var astNodes =[[0,0,0,"(root)",null,"\n",[],false],[0,0,0,null,null,null,null,false],[0,0,0,"(root)",null,"",[],false],[1,0,0,null,null,null,null,false],[1,1,0,null,null,null,null,false],[1,2,0,null,null,null,null,false],[0,0,0,"array_list.zig",null,"",[],false],[2,0,0,null,null,null,null,false],[2,1,0,null,null,null,null,false],[2,2,0,null,null,null,null,false],[2,3,0,null,null,null,null,false],[2,4,0,null,null,null,null,false],[2,5,0,null,null,null,null,false],[2,6,0,null,null,null,null,false],[2,13,0,null,null," A contiguous, growable list of items in memory.\n This is a wrapper around an array of T values. Initialize with `init`.\n\n This struct internally stores a `std.mem.Allocator` for memory management.\n To manually specify an allocator with each method call see `ArrayListUnmanaged`.",[15],false],[0,0,0,"T",null,"",null,true],[2,24,0,null,null," A contiguous, growable list of arbitrarily aligned items in memory.\n This is a wrapper around an array of T values aligned to `alignment`-byte\n addresses. If the specified alignment is `null`, then `@alignOf(T)` is used.\n Initialize with `init`.\n\n This struct internally stores a `std.mem.Allocator` for memory management.\n To manually specify an allocator with each method call see `ArrayListAlignedUnmanaged`.",[17,18],false],[0,0,0,"T",null,"",null,true],[0,0,0,"alignment",null,"",[154,155,157],true],[2,31,0,null,null,null,null,false],[2,47,0,null,null,null,null,false],[2,49,0,null,null,null,[22],false],[0,0,0,"s",null,"",null,true],[2,54,0,null,null," Deinitialize with `deinit` or use `toOwnedSlice`.",[24],false],[0,0,0,"allocator",null,"",null,false],[2,65,0,null,null," Initialize with capacity to hold `num` elements.\n The resulting capacity will equal `num` exactly.\n Deinitialize with `deinit` or use `toOwnedSlice`.",[26,27],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"num",null,"",null,false],[2,72,0,null,null," Release all allocated memory.",[29],false],[0,0,0,"self",null,"",null,false],[2,81,0,null,null," ArrayList takes ownership of the passed in slice. The slice must have been\n allocated with `allocator`.\n Deinitialize with `deinit` or use `toOwnedSlice`.",[31,32],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"slice",null,"",null,false],[2,92,0,null,null," ArrayList takes ownership of the passed in slice. The slice must have been\n allocated with `allocator`.\n Deinitialize with `deinit` or use `toOwnedSlice`.",[34,35,36],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"sentinel",null,"",null,true],[0,0,0,"slice",null,"",null,false],[2,102,0,null,null," Initializes an ArrayListUnmanaged with the `items` and `capacity` fields\n of this ArrayList. Empties this ArrayList.",[38],false],[0,0,0,"self",null,"",null,false],[2,111,0,null,null," The caller owns the returned memory. Empties this ArrayList,\n Its capacity is cleared, making deinit() safe but unnecessary to call.",[40],false],[0,0,0,"self",null,"",null,false],[2,129,0,null,null," The caller owns the returned memory. Empties this ArrayList.",[42,43],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sentinel",null,"",null,true],[2,137,0,null,null," Creates a copy of this ArrayList, using the same allocator.",[45],false],[0,0,0,"self",null,"",null,false],[2,147,0,null,null," Insert `item` at index `n`. Moves `list[n .. list.len]` to higher indices to make room.\n If `n` is equal to the length of the list this operation is equivalent to append.\n This operation is O(N).\n Invalidates pointers if additional memory is needed.",[47,48,49],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,156,0,null,null," Insert `item` at index `n`. Moves `list[n .. list.len]` to higher indices to make room.\n If `n` is equal to the length of the list this operation is equivalent to append.\n This operation is O(N).\n Asserts that there is enough capacity for the new item.",[51,52,53],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,167,0,null,null," Insert slice `items` at index `i` by moving `list[i .. list.len]` to make room.\n This operation is O(N).\n Invalidates pointers if additional memory is needed.",[55,56,57],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,179,0,null,null," Replace range of elements `list[start..][0..len]` with `new_items`.\n Grows list if `len < new_items.len`.\n Shrinks list if `len > new_items.len`.\n Invalidates pointers if this ArrayList is resized.",[59,60,61,62],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"new_items",null,"",null,false],[2,205,0,null,null," Extend the list by 1 element. Allocates more memory as necessary.\n Invalidates pointers if additional memory is needed.",[64,65],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,213,0,null,null," Extend the list by 1 element, but assert `self.capacity`\n is sufficient to hold an additional item. **Does not**\n invalidate pointers.",[67,68],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,224,0,null,null," Remove the element at index `i`, shift elements after index\n `i` forward, and return the removed element.\n Asserts the array has at least one item.\n Invalidates pointers to end of list.\n This operation is O(N).\n This preserves item order. Use `swapRemove` if order preservation is not important.",[70,71],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[2,239,0,null,null," Removes the element at the specified index and returns it.\n The empty slot is filled from the end of the list.\n This operation is O(1).\n This may not preserve item order. Use `orderedRemove` if you need to preserve order.",[73,74],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[2,250,0,null,null," Append the slice of items to the list. Allocates more\n memory as necessary.\n Invalidates pointers if additional memory is needed.",[76,77],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,257,0,null,null," Append the slice of items to the list, asserting the capacity is already\n enough to store the new items. **Does not** invalidate pointers.",[79,80],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,269,0,null,null," Append an unaligned slice of items to the list. Allocates more\n memory as necessary. Only call this function if calling\n `appendSlice` instead would be a compile error.\n Invalidates pointers if additional memory is needed.",[82,83],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,278,0,null,null," Append the slice of items to the list, asserting the capacity is already\n enough to store the new items. **Does not** invalidate pointers.\n Only call this function if calling `appendSliceAssumeCapacity` instead\n would be a compile error.",[85,86],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,286,0,null,null,null,null,false],[2,293,0,null,null," Initializes a Writer which will append to the list.",[89],false],[0,0,0,"self",null,"",null,false],[2,300,0,null,null," Same as `append` except it returns the number of bytes written, which is always the same\n as `m.len`. The purpose of this function existing is to match `std.io.Writer` API.\n Invalidates pointers if additional memory is needed.",[91,92],false],[0,0,0,"self",null,"",null,false],[0,0,0,"m",null,"",null,false],[2,310,0,null,null," Append a value to the list `n` times.\n Allocates more memory as necessary.\n Invalidates pointers if additional memory is needed.\n The function is inline so that a comptime-known `value` parameter will\n have a more optimal memset codegen in case it has a repeated byte pattern.",[94,95,96],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,320,0,null,null," Append a value to the list `n` times.\n Asserts the capacity is enough. **Does not** invalidate pointers.\n The function is inline so that a comptime-known `value` parameter will\n have a more optimal memset codegen in case it has a repeated byte pattern.",[98,99,100],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,330,0,null,null," Adjust the list's length to `new_len`.\n Does not initialize added items if any.\n Invalidates pointers if additional memory is needed.",[102,103],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[2,337,0,null,null," Reduce allocated capacity to `new_len`.\n May invalidate element pointers.",[105,106],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[2,345,0,null,null," Reduce length to `new_len`.\n Invalidates pointers for the elements `items[new_len..]`.",[108,109],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[2,351,0,null,null," Invalidates all element pointers.",[111],false],[0,0,0,"self",null,"",null,false],[2,356,0,null,null," Invalidates all element pointers.",[113],false],[0,0,0,"self",null,"",null,false],[2,364,0,null,null," Modify the array so that it can hold at least `new_capacity` items.\n Invalidates pointers if additional memory is needed.",[115,116],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[2,385,0,null,null," Modify the array so that it can hold `new_capacity` items.\n Like `ensureTotalCapacity`, but the resulting capacity is guaranteed\n to be equal to `new_capacity`.\n Invalidates pointers if additional memory is needed.",[118,119],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[2,412,0,null,null," Modify the array so that it can hold at least `additional_count` **more** items.\n Invalidates pointers if additional memory is needed.",[121,122],false],[0,0,0,"self",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[2,418,0,null,null," Increases the array's length to match the full capacity that is already allocated.\n The new elements have `undefined` values. **Does not** invalidate pointers.",[124],false],[0,0,0,"self",null,"",null,false],[2,424,0,null,null," Increase length by 1, returning pointer to the new item.\n The returned pointer becomes invalid when the list resized.",[126],false],[0,0,0,"self",null,"",null,false],[2,433,0,null,null," Increase length by 1, returning pointer to the new item.\n Asserts that there is already space for the new item without allocating more.\n The returned pointer becomes invalid when the list is resized.\n **Does not** invalidate element pointers.",[128],false],[0,0,0,"self",null,"",null,false],[2,443,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is an array pointing to the newly allocated elements.\n The returned pointer becomes invalid when the list is resized.\n Resizes list if `self.capacity` is not large enough.",[130,131],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,true],[2,454,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is an array pointing to the newly allocated elements.\n Asserts that there is already space for the new item without allocating more.\n **Does not** invalidate element pointers.\n The returned pointer becomes invalid when the list is resized.",[133,134],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,true],[2,465,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is a slice pointing to the newly allocated elements.\n The returned pointer becomes invalid when the list is resized.\n Resizes list if `self.capacity` is not large enough.",[136,137],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,476,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is a slice pointing to the newly allocated elements.\n Asserts that there is already space for the new item without allocating more.\n **Does not** invalidate element pointers.\n The returned pointer becomes invalid when the list is resized.",[139,140],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,486,0,null,null," Remove and return the last element from the list.\n Asserts the list has at least one item.\n Invalidates pointers to the removed element.",[142],false],[0,0,0,"self",null,"",null,false],[2,495,0,null,null," Remove and return the last element from the list, or\n return `null` if list is empty.\n Invalidates pointers to the removed element, if any.",[144],false],[0,0,0,"self",null,"",null,false],[2,502,0,null,null," Returns a slice of all the items plus the extra capacity, whose memory\n contents are `undefined`.",[146],false],[0,0,0,"self",null,"",null,false],[2,511,0,null,null," Returns a slice of only the extra capacity after items.\n This can be useful for writing directly into an ArrayList.\n Note that such an operation must be followed up with a direct\n modification of `self.items.len`.",[148],false],[0,0,0,"self",null,"",null,false],[2,517,0,null,null," Return the last element from the list.\n Asserts the list has at least one item.",[150],false],[0,0,0,"self",null,"",null,false],[2,524,0,null,null," Return the last element from the list, or\n return `null` if list is empty.",[152],false],[0,0,0,"self",null,"",null,false],[2,30,0,null,null,null,null,false],[0,0,0,"items",null," Contents of the list. Pointers to elements in this slice are\n **invalid after resizing operations** on the ArrayList unless the\n operation explicitly either: (1) states otherwise or (2) lists the\n invalidated pointers.\n\n The allocator used determines how element pointers are\n invalidated, so the behavior may vary between lists. To avoid\n illegal behavior, take into account the above paragraph plus the\n explicit statements given in each method.",null,false],[0,0,0,"capacity",null," How many T values this list can hold without allocating\n additional memory.",null,false],[2,30,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[2,535,0,null,null," An ArrayList, but the allocator is passed as a parameter to the relevant functions\n rather than stored in the struct itself. The same allocator **must** be used throughout\n the entire lifetime of an ArrayListUnmanaged. Initialize directly or with\n `initCapacity`, and deinitialize with `deinit` or use `toOwnedSlice`.",[159],false],[0,0,0,"T",null,"",null,true],[2,543,0,null,null," An ArrayListAligned, but the allocator is passed as a parameter to the relevant\n functions rather than stored  in the struct itself. The same allocator **must**\n be used throughout the entire lifetime of an ArrayListAlignedUnmanaged.\n Initialize directly or with `initCapacity`, and deinitialize with `deinit` or use `toOwnedSlice`.",[161,162],false],[0,0,0,"T",null,"",null,true],[0,0,0,"alignment",null,"",[321,322],true],[2,550,0,null,null,null,null,false],[2,565,0,null,null,null,null,false],[2,567,0,null,null,null,[166],false],[0,0,0,"s",null,"",null,true],[2,574,0,null,null," Initialize with capacity to hold `num` elements.\n The resulting capacity will equal `num` exactly.\n Deinitialize with `deinit` or use `toOwnedSlice`.",[168,169],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"num",null,"",null,false],[2,581,0,null,null," Release all allocated memory.",[171,172],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,588,0,null,null," Convert this list into an analogous memory-managed one.\n The returned list has ownership of the underlying memory.",[174,175],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,595,0,null,null," ArrayListUnmanaged takes ownership of the passed in slice. The slice must have been\n allocated with `allocator`.\n Deinitialize with `deinit` or use `toOwnedSlice`.",[177],false],[0,0,0,"slice",null,"",null,false],[2,605,0,null,null," ArrayListUnmanaged takes ownership of the passed in slice. The slice must have been\n allocated with `allocator`.\n Deinitialize with `deinit` or use `toOwnedSlice`.",[179,180],false],[0,0,0,"sentinel",null,"",null,true],[0,0,0,"slice",null,"",null,false],[2,614,0,null,null," The caller owns the returned memory. Empties this ArrayList.\n Its capacity is cleared, making deinit() safe but unnecessary to call.",[182,183],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,630,0,null,null," The caller owns the returned memory. ArrayList becomes empty.",[185,186,187],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"sentinel",null,"",null,true],[2,638,0,null,null," Creates a copy of this ArrayList.",[189,190],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,648,0,null,null," Insert `item` at index `n`. Moves `list[n .. list.len]` to higher indices to make room.\n If `n` is equal to the length of the list this operation is equivalent to append.\n This operation is O(N).\n Invalidates pointers if additional memory is needed.",[192,193,194,195],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,657,0,null,null," Insert `item` at index `n`. Moves `list[n .. list.len]` to higher indices to make room.\n If `n` is equal to the length of the list this operation is equivalent to append.\n This operation is O(N).\n Asserts that there is enough capacity for the new item.",[197,198,199],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,669,0,null,null," Insert slice `items` at index `i`. Moves `list[i .. list.len]` to\n higher indicices make room.\n This operation is O(N).\n Invalidates pointers if additional memory is needed.",[201,202,203,204],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,681,0,null,null," Replace range of elements `list[start..][0..len]` with `new_items`\n Grows list if `len < new_items.len`.\n Shrinks list if `len > new_items.len`\n Invalidates pointers if this ArrayList is resized.",[206,207,208,209,210],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"new_items",null,"",null,false],[2,689,0,null,null," Extend the list by 1 element. Allocates more memory as necessary.\n Invalidates pointers if additional memory is needed.",[212,213,214],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,696,0,null,null," Extend the list by 1 element, but asserting `self.capacity`\n is sufficient to hold an additional item.",[216,217],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[2,705,0,null,null," Remove the element at index `i` from the list and return its value.\n Asserts the array has at least one item. Invalidates pointers to\n last element.\n This operation is O(N).",[219,220],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[2,720,0,null,null," Removes the element at the specified index and returns it.\n The empty slot is filled from the end of the list.\n Invalidates pointers to last element.\n This operation is O(1).",[222,223],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[2,731,0,null,null," Append the slice of items to the list. Allocates more\n memory as necessary.\n Invalidates pointers if additional memory is needed.",[225,226,227],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,738,0,null,null," Append the slice of items to the list, asserting the capacity is enough\n to store the new items.",[229,230],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,750,0,null,null," Append the slice of items to the list. Allocates more\n memory as necessary. Only call this function if a call to `appendSlice` instead would\n be a compile error.\n Invalidates pointers if additional memory is needed.",[232,233,234],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,758,0,null,null," Append an unaligned slice of items to the list, asserting the capacity is enough\n to store the new items. Only call this function if a call to `appendSliceAssumeCapacity`\n instead would be a compile error.",[236,237],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[2,766,0,null,null,null,[240,242],false],[2,766,0,null,null,null,null,false],[0,0,0,"self",null,null,null,false],[2,766,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[2,771,0,null,null,null,null,false],[2,778,0,null,null," Initializes a Writer which will append to the list.",[245,246],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,785,0,null,null," Same as `append` except it returns the number of bytes written, which is always the same\n as `m.len`. The purpose of this function existing is to match `std.io.Writer` API.\n Invalidates pointers if additional memory is needed.",[248,249],false],[0,0,0,"context",null,"",null,false],[0,0,0,"m",null,"",null,false],[2,795,0,null,null," Append a value to the list `n` times.\n Allocates more memory as necessary.\n Invalidates pointers if additional memory is needed.\n The function is inline so that a comptime-known `value` parameter will\n have a more optimal memset codegen in case it has a repeated byte pattern.",[251,252,253,254],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,806,0,null,null," Append a value to the list `n` times.\n **Does not** invalidate pointers.\n Asserts the capacity is enough.\n The function is inline so that a comptime-known `value` parameter will\n have a more optimal memset codegen in case it has a repeated byte pattern.",[256,257,258],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,816,0,null,null," Adjust the list's length to `new_len`.\n Does not initialize added items, if any.\n Invalidates pointers if additional memory is needed.",[260,261,262],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[2,823,0,null,null," Reduce allocated capacity to `new_len`.\n May invalidate element pointers.",[264,265,266],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[2,855,0,null,null," Reduce length to `new_len`.\n Invalidates pointers to elements `items[new_len..]`.\n Keeps capacity the same.",[268,269],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[2,861,0,null,null," Invalidates all element pointers.",[271],false],[0,0,0,"self",null,"",null,false],[2,866,0,null,null," Invalidates all element pointers.",[273,274],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,874,0,null,null," Modify the array so that it can hold at least `new_capacity` items.\n Invalidates pointers if additional memory is needed.",[276,277,278],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[2,890,0,null,null," Modify the array so that it can hold `new_capacity` items.\n Like `ensureTotalCapacity`, but the resulting capacity is guaranteed\n to be equal to `new_capacity`.\n Invalidates pointers if additional memory is needed.",[280,281,282],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[2,917,0,null,null," Modify the array so that it can hold at least `additional_count` **more** items.\n Invalidates pointers if additional memory is needed.",[284,285,286],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[2,928,0,null,null," Increases the array's length to match the full capacity that is already allocated.\n The new elements have `undefined` values.\n **Does not** invalidate pointers.",[288],false],[0,0,0,"self",null,"",null,false],[2,934,0,null,null," Increase length by 1, returning pointer to the new item.\n The returned pointer becomes invalid when the list resized.",[290,291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[2,944,0,null,null," Increase length by 1, returning pointer to the new item.\n Asserts that there is already space for the new item without allocating more.\n **Does not** invalidate pointers.\n The returned pointer becomes invalid when the list resized.",[293],false],[0,0,0,"self",null,"",null,false],[2,954,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is an array pointing to the newly allocated elements.\n The returned pointer becomes invalid when the list is resized.",[295,296,297],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"n",null,"",null,true],[2,965,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is an array pointing to the newly allocated elements.\n Asserts that there is already space for the new item without allocating more.\n **Does not** invalidate pointers.\n The returned pointer becomes invalid when the list is resized.",[299,300],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,true],[2,976,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is a slice pointing to the newly allocated elements.\n The returned pointer becomes invalid when the list is resized.\n Resizes list if `self.capacity` is not large enough.",[302,303,304],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,987,0,null,null," Resize the array, adding `n` new elements, which have `undefined` values.\n The return value is a slice pointing to the newly allocated elements.\n Asserts that there is already space for the new item without allocating more.\n **Does not** invalidate element pointers.\n The returned pointer becomes invalid when the list is resized.",[306,307],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[2,997,0,null,null," Remove and return the last element from the list.\n Asserts the list has at least one item.\n Invalidates pointers to last element.",[309],false],[0,0,0,"self",null,"",null,false],[2,1006,0,null,null," Remove and return the last element from the list.\n If the list is empty, returns `null`.\n Invalidates pointers to last element.",[311],false],[0,0,0,"self",null,"",null,false],[2,1013,0,null,null," Returns a slice of all the items plus the extra capacity, whose memory\n contents are `undefined`.",[313],false],[0,0,0,"self",null,"",null,false],[2,1021,0,null,null," Returns a slice of only the extra capacity after items.\n This can be useful for writing directly into an ArrayList.\n Note that such an operation must be followed up with a direct\n modification of `self.items.len`.",[315],false],[0,0,0,"self",null,"",null,false],[2,1027,0,null,null," Return the last element from the list.\n Asserts the list has at least one item.",[317],false],[0,0,0,"self",null,"",null,false],[2,1034,0,null,null," Return the last element from the list, or\n return `null` if list is empty.",[319],false],[0,0,0,"self",null,"",null,false],[2,549,0,null,null,null,null,false],[0,0,0,"items",null," Contents of the list. Pointers to elements in this slice are\n **invalid after resizing operations** on the ArrayList unless the\n operation explicitly either: (1) states otherwise or (2) lists the\n invalidated pointers.\n\n The allocator used determines how element pointers are\n invalidated, so the behavior may vary between lists. To avoid\n illegal behavior, take into account the above paragraph plus the\n explicit statements given in each method.",null,false],[0,0,0,"capacity",null," How many T values this list can hold without allocating\n additional memory.",null,false],[2,1508,0,null,null,null,[324,326],false],[0,0,0,"integer",null,null,null,false],[2,1508,0,null,null,null,null,false],[0,0,0,"sub_items",null,null,null,false],[2,1513,0,null,null,null,[328,330],false],[0,0,0,"integer",null,null,null,false],[2,1513,0,null,null,null,null,false],[0,0,0,"sub_items",null,null,null,false],[1,3,0,null,null,null,null,false],[1,4,0,null,null,null,null,false],[1,5,0,null,null,null,null,false],[1,6,0,null,null,null,null,false],[1,7,0,null,null,null,null,false],[1,8,0,null,null,null,null,false],[1,9,0,null,null,null,null,false],[1,10,0,null,null,null,null,false],[0,0,0,"BitStack.zig",null," Effectively a stack of u1 values implemented using ArrayList(u8).\n",[371,372],false],[3,2,0,null,null,null,null,false],[3,4,0,null,null,null,null,false],[3,5,0,null,null,null,null,false],[3,6,0,null,null,null,null,false],[3,11,0,null,null,null,[345],false],[0,0,0,"allocator",null,"",null,false],[3,17,0,null,null,null,[347],false],[0,0,0,"self",null,"",null,false],[3,22,0,null,null,null,[349,350],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit_capcity",null,"",null,false],[3,27,0,null,null,null,[352,353],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[3,36,0,null,null,null,[355],false],[0,0,0,"self",null,"",null,false],[3,40,0,null,null,null,[357],false],[0,0,0,"self",null,"",null,false],[3,45,0,null,null," Standalone function for working with a fixed-size buffer.",[359,360,361],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"bit_len",null,"",null,false],[0,0,0,"b",null,"",null,false],[3,56,0,null,null," Standalone function for working with a fixed-size buffer.",[363,364],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"bit_len",null,"",null,false],[3,63,0,null,null," Standalone function for working with a fixed-size buffer.",[366,367],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"bit_len",null,"",null,false],[3,69,0,null,null,null,null,false],[3,70,0,"BitStack","test BitStack {\n    var stack = BitStack.init(testing.allocator);\n    defer stack.deinit();\n\n    try stack.push(1);\n    try stack.push(0);\n    try stack.push(0);\n    try stack.push(1);\n\n    try testing.expectEqual(@as(u1, 1), stack.peek());\n    try testing.expectEqual(@as(u1, 1), stack.pop());\n    try testing.expectEqual(@as(u1, 0), stack.peek());\n    try testing.expectEqual(@as(u1, 0), stack.pop());\n    try testing.expectEqual(@as(u1, 0), stack.pop());\n    try testing.expectEqual(@as(u1, 1), stack.pop());\n}",null,null,false],[3,0,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"bit_len",null,null,null,false],[1,11,0,null,null,null,null,false],[0,0,0,"bounded_array.zig",null,"",[],false],[4,0,0,null,null,null,null,false],[4,1,0,null,null,null,null,false],[4,2,0,null,null,null,null,false],[4,3,0,null,null,null,null,false],[4,17,0,null,null," A structure with an array and a length, that can be used as a slice.\n\n Useful to pass around small arrays whose exact size is only known at\n runtime, but whose maximum size is known at comptime, without requiring\n an `Allocator`.\n\n ```zig\n var actual_size = 32;\n var a = try BoundedArray(u8, 64).init(actual_size);\n var slice = a.slice(); // a slice of the 64-byte array\n var a_clone = a; // creates a copy - the structure doesn't use any internal pointers\n ```",[380,381],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer_capacity",null,"",null,true],[4,34,0,null,null," A structure with an array, length and alignment, that can be used as a\n slice.\n\n Useful to pass around small explicitly-aligned arrays whose exact size is\n only known at runtime, but whose maximum size is known at comptime, without\n requiring an `Allocator`.\n ```zig\n ```",[383,384,385],false],[0,0,0,"T",null,"",null,true],[0,0,0,"alignment",null,"",null,true],[0,0,0,"buffer_capacity",null,"",[470,472],true],[4,40,0,null,null,null,null,false],[4,41,0,null,null,null,null,false],[4,48,0,null,null," Set the actual length of the slice.\n Returns error.Overflow if it exceeds the length of the backing array.",[389],false],[0,0,0,"len",null,"",null,false],[4,54,0,null,null," View the internal array as a slice whose size was previously set.",[391],false],[0,0,0,"self",null,"",null,false],[4,63,0,null,null," View the internal array as a constant slice whose size was previously set.",[393],false],[0,0,0,"self",null,"",null,false],[4,69,0,null,null," Adjust the slice's length to `len`.\n Does not initialize added items if any.",[395,396],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,"",null,false],[4,75,0,null,null," Copy the content of an existing slice.",[398],false],[0,0,0,"m",null,"",null,false],[4,82,0,null,null," Return the element at index `i` of the slice.",[400,401],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[4,87,0,null,null," Set the value of the element at index `i` of the slice.",[403,404,405],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"item",null,"",null,false],[4,92,0,null,null," Return the maximum length of a slice.",[407],false],[0,0,0,"self",null,"",null,false],[4,97,0,null,null," Check that the slice can hold at least `additional_count` items.",[409,410],false],[0,0,0,"self",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[4,104,0,null,null," Increase length by 1, returning a pointer to the new item.",[412],false],[0,0,0,"self",null,"",null,false],[4,111,0,null,null," Increase length by 1, returning pointer to the new item.\n Asserts that there is space for the new item.",[414],false],[0,0,0,"self",null,"",null,false],[4,119,0,null,null," Resize the slice, adding `n` new elements, which have `undefined` values.\n The return value is a slice pointing to the uninitialized elements.",[416,417],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,true],[4,127,0,null,null," Remove and return the last element from the slice.\n Asserts the slice has at least one item.",[419],false],[0,0,0,"self",null,"",null,false],[4,135,0,null,null," Remove and return the last element from the slice, or\n return `null` if the slice is empty.",[421],false],[0,0,0,"self",null,"",null,false],[4,143,0,null,null," Return a slice of only the extra capacity after items.\n This can be useful for writing directly into it.\n Note that such an operation must be followed up with a\n call to `resize()`",[423],false],[0,0,0,"self",null,"",null,false],[4,149,0,null,null," Insert `item` at index `i` by moving `slice[n .. slice.len]` to make room.\n This operation is O(N).",[425,426,427],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"item",null,"",null,false],[4,165,0,null,null," Insert slice `items` at index `i` by moving `slice[i .. slice.len]` to make room.\n This operation is O(N).",[429,430,431],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"items",null,"",null,false],[4,175,0,null,null," Replace range of elements `slice[start..][0..len]` with `new_items`.\n Grows slice if `len < new_items.len`.\n Shrinks slice if `len > new_items.len`.",[433,434,435,436],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"new_items",null,"",null,false],[4,202,0,null,null," Extend the slice by 1 element.",[438,439],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[4,209,0,null,null," Extend the slice by 1 element, asserting the capacity is already\n enough to store the new item.",[441,442],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[4,218,0,null,null," Remove the element at index `i`, shift elements after index\n `i` forward, and return the removed element.\n Asserts the slice has at least one item.\n This operation is O(N).",[444,445],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[4,231,0,null,null," Remove the element at the specified index and return it.\n The empty slot is filled from the end of the slice.\n This operation is O(1).",[447,448],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[4,239,0,null,null," Append the slice of items to the slice.",[450,451],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[4,246,0,null,null," Append the slice of items to the slice, asserting the capacity is already\n enough to store the new items.",[453,454],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[4,254,0,null,null," Append a value to the slice `n` times.\n Allocates more memory as necessary.",[456,457,458],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"n",null,"",null,false],[4,262,0,null,null," Append a value to the slice `n` times.\n Asserts the capacity is enough.",[460,461,462],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"n",null,"",null,false],[4,269,0,null,null,null,null,false],[4,276,0,null,null," Initializes a writer which will write into the array.",[465],false],[0,0,0,"self",null,"",null,false],[4,282,0,null,null," Same as `appendSlice` except it returns the number of bytes written, which is always the same\n as `m.len`. The purpose of this function existing is to match `std.io.Writer` API.",[467,468],false],[0,0,0,"self",null,"",null,false],[0,0,0,"m",null,"",null,false],[4,39,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[4,39,0,null,null,null,null,false],[0,0,0,"len",null,null,null,false],[1,12,0,null,null,null,null,false],[1,13,0,null,null,null,null,false],[0,0,0,"Build.zig",null,"",[3305,3307,3309,3311,3313,3315,3316,3317,3318,3319,3321,3323,3324,3325,3327,3328,3330,3332,3334,3336,3338,3340,3342,3344,3346,3348,3350,3352,3354,3356,3358,3360,3362,3364,3366,3368,3370,3372,3374,3375,3376,3377,3378,3379,3380,3381,3382,3384,3386,3388,3390,3392,3394],false],[5,0,0,null,null,null,null,false],[5,1,0,null,null,null,null,false],[0,0,0,"builtin",null,"",[],false],[6,0,0,null,null,null,null,false],[6,3,0,null,null," Zig version. When writing code that supports multiple versions of Zig, prefer\n feature detection (i.e. with `@hasDecl` or `@hasField`) over version checks.",null,false],[6,4,0,null,null,null,null,false],[6,5,0,null,null,null,null,false],[6,7,0,null,null,null,null,false],[6,8,0,null,null,null,null,false],[6,9,0,null,null,null,null,false],[6,10,0,null,null,null,null,false],[6,11,0,null,null,null,null,false],[6,12,0,null,null,null,null,false],[6,33,0,null,null,null,null,false],[6,55,0,null,null,null,null,false],[6,61,0,null,null,null,null,false],[6,62,0,null,null,null,null,false],[6,63,0,null,null,null,null,false],[6,64,0,null,null,null,null,false],[6,65,0,null,null,null,null,false],[6,66,0,null,null,null,null,false],[6,67,0,null,null,null,null,false],[6,68,0,null,null,null,null,false],[6,69,0,null,null,null,null,false],[6,70,0,null,null,null,null,false],[6,71,0,null,null,null,null,false],[6,72,0,null,null,null,null,false],[5,2,0,null,null,null,null,false],[5,3,0,null,null,null,null,false],[5,4,0,null,null,null,null,false],[5,5,0,null,null,null,null,false],[5,6,0,null,null,null,null,false],[5,7,0,null,null,null,null,false],[5,8,0,null,null,null,null,false],[5,9,0,null,null,null,null,false],[5,10,0,null,null,null,null,false],[5,11,0,null,null,null,null,false],[5,12,0,null,null,null,null,false],[5,13,0,null,null,null,null,false],[5,14,0,null,null,null,null,false],[5,15,0,null,null,null,null,false],[5,16,0,null,null,null,null,false],[5,17,0,null,null,null,null,false],[5,18,0,null,null,null,null,false],[5,19,0,null,null,null,null,false],[5,21,0,null,null,null,null,false],[0,0,0,"Build/Cache.zig",null," Manages `zig-cache` directories.\n This is not a general-purpose cache. It is designed to be fast and simple,\n not to withstand attacks using specially-crafted input.\n",[812,814,816,817,819,821,822],false],[7,4,0,null,null,null,[541,543],false],[7,11,0,null,null,null,[525,526,527],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[7,22,0,null,null,null,[529,530,531],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[7,36,0,null,null," Whether or not the handle should be closed, or the path should be freed\n is determined by usage, however this function is provided for convenience\n if it happens to be what the caller needs.",[533,534],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[7,42,0,null,null,null,[536,537,538,539],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt_string",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[7,4,0,null,null,null,null,false],[0,0,0,"path",null," This field is redundant for operations that can act on the open directory handle\n directly, but it is needed when passing the directory to a child process.\n `null` means cwd.",null,false],[7,4,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[7,72,0,null,null,null,null,false],[0,0,0,"Cache/DepTokenizer.zig",null,"",[638,640,642],false],[8,0,0,null,null,null,null,false],[8,6,0,null,null,null,null,false],[8,7,0,null,null,null,null,false],[8,8,0,null,null,null,null,false],[8,10,0,null,null,null,[551],false],[0,0,0,"self",null,"",null,false],[8,268,0,null,null,null,[553,554,555],false],[0,0,0,"id",null,"",null,true],[0,0,0,"index",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,272,0,null,null,null,[557,558,559],false],[0,0,0,"id",null,"",null,true],[0,0,0,"index",null,"",null,false],[0,0,0,"char",null,"",null,false],[8,276,0,null,null,null,[561,562],false],[0,0,0,"must_resolve",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,280,0,null,null,null,[564,565,566,567,568,569,570,571,572,573,574,575,576],false],[0,0,0,"lhs",null,null,null,false],[0,0,0,"target",null,null,null,false],[0,0,0,"target_reverse_solidus",null,null,null,false],[0,0,0,"target_dollar_sign",null,null,null,false],[0,0,0,"target_colon",null,null,null,false],[0,0,0,"target_colon_reverse_solidus",null,null,null,false],[0,0,0,"rhs",null,null,null,false],[0,0,0,"rhs_continuation",null,null,null,false],[0,0,0,"rhs_continuation_linefeed",null,null,null,false],[0,0,0,"prereq_quote",null,null,null,false],[0,0,0,"prereq",null,null,null,false],[0,0,0,"prereq_continuation",null,null,null,false],[0,0,0,"prereq_continuation_linefeed",null,null,null,false],[8,296,0,null,null,null,[593,594,595,596,597,598,599,600,601,602],false],[8,310,0,null,null,null,[579,580],false],[0,0,0,"index",null,null,null,false],[0,0,0,"char",null,null,null,false],[8,315,0,null,null,null,[582,584],false],[0,0,0,"index",null,null,null,false],[8,315,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[8,321,0,null,null," Resolve escapes in target. Only valid with .target_must_resolve.",[586,587],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[8,359,0,null,null,null,[589,590],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[8,387,0,null,null,null,[592],false],[0,0,0,"self",null,"",null,false],[0,0,0,"target",null,null,null,false],[0,0,0,"target_must_resolve",null,null,null,false],[0,0,0,"prereq",null,null,null,false],[0,0,0,"incomplete_quoted_prerequisite",null,null,null,false],[0,0,0,"incomplete_target",null,null,null,false],[0,0,0,"invalid_target",null,null,null,false],[0,0,0,"bad_target_escape",null,null,null,false],[0,0,0,"expected_dollar_sign",null,null,null,false],[0,0,0,"continuation_eol",null,null,null,false],[0,0,0,"incomplete_escape",null,null,null,false],[8,888,0,null,null,null,[604,605],false],[0,0,0,"input",null,"",null,false],[0,0,0,"expect",null,"",null,false],[8,942,0,null,null,null,[607,608,609],false],[0,0,0,"out",null,"",null,false],[0,0,0,"label",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,950,0,null,null,null,[611,612,613],false],[0,0,0,"out",null,"",null,false],[0,0,0,"label",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,962,0,null,null,null,[615],false],[0,0,0,"out",null,"",null,false],[8,971,0,null,null,null,[617,618],false],[0,0,0,"out",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,1018,0,null,null,null,[620,621,622],false],[0,0,0,"out",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,1036,0,null,null,null,[624,625,626],false],[0,0,0,"out",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"width",null,"",null,false],[8,1042,0,null,null,null,[628,629,630],false],[0,0,0,"out",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"width",null,"",null,false],[8,1048,0,null,null,null,[632,633],false],[0,0,0,"out",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[8,1054,0,null,null,null,[635,636],false],[0,0,0,"out",null,"",null,false],[0,0,0,"char",null,"",null,false],[8,1063,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[8,0,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[8,0,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[7,74,0,null,null,null,null,false],[7,75,0,null,null,null,null,false],[7,76,0,null,null,null,null,false],[7,77,0,null,null,null,null,false],[7,78,0,null,null,null,null,false],[7,79,0,null,null,null,null,false],[7,80,0,null,null,null,null,false],[7,81,0,null,null,null,null,false],[7,82,0,null,null,null,null,false],[7,83,0,null,null,null,null,false],[7,84,0,null,null,null,null,false],[7,86,0,null,null,null,[655,656],false],[0,0,0,"cache",null,"",null,false],[0,0,0,"directory",null,"",null,false],[7,92,0,null,null," Be sure to call `Manifest.deinit` after successful initialization.",[658],false],[0,0,0,"cache",null,"",null,false],[7,102,0,null,null,null,[660],false],[0,0,0,"cache",null,"",null,false],[7,106,0,null,null,null,[662,664],false],[0,0,0,"prefix",null,null,null,false],[7,106,0,null,null,null,null,false],[0,0,0,"sub_path",null,null,null,false],[7,111,0,null,null,null,[666,667],false],[0,0,0,"cache",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[7,119,0,null,null," Takes ownership of `resolved_path` on success.",[669,670],false],[0,0,0,"cache",null,"",null,false],[0,0,0,"resolved_path",null,"",null,false],[7,143,0,null,null,null,[672,673,674],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[0,0,0,"path",null,"",null,false],[7,160,0,null,null," This is 128 bits - Even with 2^54 cache entries, the probably of a collision would be under 10^-6",null,false],[7,161,0,null,null,null,null,false],[7,162,0,null,null,null,null,false],[7,165,0,null,null," This is currently just an arbitrary non-empty string that can't match another manifest line.",null,false],[7,166,0,null,null,null,null,false],[7,171,0,null,null," The type used for hashing file contents. Currently, this is SipHash128(1, 3), because it\n provides enough collision resistance for the Manifest use cases, while being one of our\n fastest options right now.",null,false],[7,176,0,null,null," Initial state with random bytes, that can be copied.\n Refresh this with new random bytes when the manifest\n format is modified in a non-backwards-compatible way.",null,false],[7,183,0,null,null,null,[692,694,696,698,700],false],[7,190,0,null,null,null,[685,686,687],false],[7,190,0,null,null,null,null,false],[0,0,0,"inode",null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"mtime",null,null,null,false],[7,196,0,null,null,null,[689,690],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[7,183,0,null,null,null,null,false],[0,0,0,"prefixed_path",null,null,null,false],[7,183,0,null,null,null,null,false],[0,0,0,"max_file_size",null,null,null,false],[7,183,0,null,null,null,null,false],[0,0,0,"stat",null,null,null,false],[7,183,0,null,null,null,null,false],[0,0,0,"bin_digest",null,null,null,false],[7,183,0,null,null,null,null,false],[0,0,0,"contents",null,null,null,false],[7,209,0,null,null,null,[724],false],[7,213,0,null,null," Record a slice of bytes as a dependency of the process being cached.",[703,704],false],[0,0,0,"hh",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[7,218,0,null,null,null,[706,707],false],[0,0,0,"hh",null,"",null,false],[0,0,0,"optional_bytes",null,"",null,false],[7,223,0,null,null,null,[709,710],false],[0,0,0,"hh",null,"",null,false],[0,0,0,"list_of_bytes",null,"",null,false],[7,229,0,null,null," Convert the input value into bytes and record it as a dependency of the process being cached.",[712,713],false],[0,0,0,"hh",null,"",null,false],[0,0,0,"x",null,"",null,false],[7,265,0,null,null,null,[715,716],false],[0,0,0,"hh",null,"",null,false],[0,0,0,"optional",null,"",null,false],[7,271,0,null,null," Returns a hex encoded hash of the inputs, without modifying state.",[718],false],[0,0,0,"hh",null,"",null,false],[7,276,0,null,null,null,[720],false],[0,0,0,"hh",null,"",null,false],[7,284,0,null,null," Returns a hex encoded hash of the inputs, mutating the state of the hasher.",[722],false],[0,0,0,"hh",null,"",null,false],[7,209,0,null,null,null,null,false],[0,0,0,"hasher",null,null,null,false],[7,298,0,null,null,null,[729],false],[7,301,0,null,null,null,[727],false],[0,0,0,"lock",null,"",null,false],[7,298,0,null,null,null,null,false],[0,0,0,"manifest_file",null,null,null,false],[7,313,0,null,null,null,[782,784,786,787,788,789,790,792,794,796,797],false],[7,352,0,null,null," Add a file as a dependency of process being cached. When `hit` is\n called, the file's contents will be checked to ensure that it matches\n the contents from previous times.\n\n Max file size will be used to determine the amount of space the file contents\n are allowed to take up in memory. If max_file_size is null, then the contents\n will not be loaded into memory.\n\n Returns the index of the entry in the `files` array list. You can use it\n to access the contents of the file after calling `hit()` like so:\n\n ```\n var file_contents = cache_hash.files.items[file_index].contents.?;\n ```",[732,733,734],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"max_file_size",null,"",null,false],[7,374,0,null,null,null,[736,737],false],[0,0,0,"self",null,"",null,false],[0,0,0,"optional_file_path",null,"",null,false],[7,380,0,null,null,null,[739,740],false],[0,0,0,"self",null,"",null,false],[0,0,0,"list_of_files",null,"",null,false],[7,399,0,null,null," Check the cache to see if the input exists in it. If it exists, returns `true`.\n A hex encoding of its hash is available by calling `final`.\n\n This function will also acquire an exclusive lock to the manifest file. This means\n that a process holding a Manifest will block any other process attempting to\n acquire the lock. If `want_shared_lock` is `true`, a cache hit guarantees the\n manifest file to be locked in shared mode, and a cache miss guarantees the manifest\n file to be locked in exclusive mode.\n\n The lock on the manifest file is released when `deinit` is called. As another\n option, one may call `toOwnedLock` to obtain a smaller object which can represent\n the lock. `deinit` is safe to call whether or not `toOwnedLock` has been called.",[742],false],[0,0,0,"self",null,"",null,false],[7,598,0,null,null,null,[744,745,746],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bin_digest",null,"",null,false],[0,0,0,"input_file_count",null,"",null,false],[7,614,0,null,null,null,[748,749],false],[0,0,0,"man",null,"",null,false],[0,0,0,"file_time",null,"",null,false],[7,648,0,null,null,null,[751,752],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ch_file",null,"",null,false],[7,700,0,null,null," Add a file as a dependency of process being cached, after the initial hash has been\n calculated. This is useful for processes that don't know all the files that\n are depended on ahead of time. For example, a source file that can import other files\n will need to be recompiled if the imported file is changed.",[754,755,756],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"max_file_size",null,"",null,false],[7,726,0,null,null," Add a file as a dependency of process being cached, after the initial hash has been\n calculated. This is useful for processes that don't know the all the files that\n are depended on ahead of time. For example, a source file that can import other files\n will need to be recompiled if the imported file is changed.",[758,759],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[7,748,0,null,null," Like `addFilePost` but when the file contents have already been loaded from disk.\n On success, cache takes ownership of `resolved_path`.",[761,762,763,764],false],[0,0,0,"self",null,"",null,false],[0,0,0,"resolved_path",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"stat",null,"",null,false],[7,786,0,null,null,null,[766,767,768],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"dep_file_basename",null,"",null,false],[7,813,0,null,null," Returns a hex encoded hash of the inputs.",[770],false],[0,0,0,"self",null,"",null,false],[7,837,0,null,null," If `want_shared_lock` is true, this function automatically downgrades the\n lock from exclusive to shared.",[772],false],[0,0,0,"self",null,"",null,false],[7,869,0,null,null,null,[774],false],[0,0,0,"self",null,"",null,false],[7,883,0,null,null,null,[776],false],[0,0,0,"self",null,"",null,false],[7,904,0,null,null," Obtain only the data needed to maintain a lock on the manifest file.\n The `Manifest` remains safe to deinit.\n Don't forget to call `writeManifest` before this!",[778],false],[0,0,0,"self",null,"",null,false],[7,916,0,null,null," Releases the manifest file and frees any memory the Manifest was using.\n `Manifest.hit` must be called first.\n Don't forget to call `writeManifest` before this!",[780],false],[0,0,0,"self",null,"",null,false],[7,313,0,null,null,null,null,false],[0,0,0,"cache",null,null,null,false],[7,313,0,null,null,null,null,false],[0,0,0,"hash",null," Current state for incremental hashing.",null,false],[7,313,0,null,null,null,null,false],[0,0,0,"manifest_file",null,null,null,false],[0,0,0,"manifest_dirty",null,null,null,false],[0,0,0,"want_shared_lock",null," Set this flag to true before calling hit() in order to indicate that\n upon a cache hit, the code using the cache will not modify the files\n within the cache directory. This allows multiple processes to utilize\n the same cache directory at the same time.",null,false],[0,0,0,"have_exclusive_lock",null,null,null,false],[0,0,0,"want_refresh_timestamp",null,null,null,false],[7,313,0,null,null,null,null,false],[0,0,0,"files",null,null,null,false],[7,313,0,null,null,null,null,false],[0,0,0,"hex_digest",null,null,null,false],[7,313,0,null,null,null,null,false],[0,0,0,"failed_file_index",null," Populated when hit() returns an error because of one\n of the files listed in the manifest.",null,false],[0,0,0,"recent_problematic_timestamp",null," Keeps track of the last time we performed a file system write to observe\n what time the file system thinks it is, according to its own granularity.",null,false],[7,935,0,null,null," On operating systems that support symlinks, does a readlink. On other operating systems,\n uses the file contents. Windows supports symlinks but only with elevated privileges, so\n it is treated as not supporting symlinks.",[799,800,801],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[7,947,0,null,null," On operating systems that support symlinks, does a symlink. On other operating systems,\n uses the file contents. Windows supports symlinks but only with elevated privileges, so\n it is treated as not supporting symlinks.\n `data` must be a valid UTF-8 encoded file path and 255 bytes or fewer.",[803,804,805],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"data",null,"",null,false],[7,956,0,null,null,null,[807,808],false],[0,0,0,"file",null,"",null,false],[0,0,0,"bin_digest",null,"",null,false],[7,970,0,null,null,null,[810],false],[0,0,0,"dir",null,"",null,false],[7,0,0,null,null,null,null,false],[0,0,0,"gpa",null,null,null,false],[7,0,0,null,null,null,null,false],[0,0,0,"manifest_dir",null,null,null,false],[7,0,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[0,0,0,"recent_problematic_timestamp",null," This value is accessed from multiple threads, protected by mutex.",null,false],[7,0,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[7,0,0,null,null,null,null,false],[0,0,0,"prefixes_buffer",null," A set of strings such as the zig library directory or project source root, which\n are stripped from the file paths before putting into the cache. They\n are replaced with single-character indicators. This is not to save\n space but to eliminate absolute file paths. This improves portability\n and usefulness of the cache for advanced use cases.",null,false],[0,0,0,"prefixes_len",null,null,null,false],[5,24,0,null,null," deprecated: use `Step.Compile`.",null,false],[5,26,0,null,null," deprecated: use `Build`.",null,false],[5,28,0,null,null," deprecated: use `Step.InstallDir.Options`",null,false],[5,30,0,null,null,null,null,false],[0,0,0,"Build/Step.zig",null,"",[2652,2654,2656,2658,2660,2662,2664,2665,2667,2669,2670,2672,2673,2675,2677],false],[9,43,0,null,null,null,[833,834,835,836,837],false],[9,50,0,null,null,null,[830],false],[0,0,0,"tr",null,"",null,false],[9,54,0,null,null,null,[832],false],[0,0,0,"tr",null,"",null,false],[0,0,0,"fail_count",null,null,null,false],[0,0,0,"skip_count",null,null,null,false],[0,0,0,"leak_count",null,null,null,false],[0,0,0,"log_err_count",null,null,null,false],[0,0,0,"test_count",null,null,null,false],[9,59,0,null,null,null,[839,840],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[9,61,0,null,null,null,[842,843,844,845,846,847,848,849],false],[0,0,0,"precheck_unstarted",null,null,null,false],[0,0,0,"precheck_started",null,null,null,false],[0,0,0,"precheck_done",null,null,null,false],[0,0,0,"running",null,null,null,false],[0,0,0,"dependency_failure",null,null,null,false],[0,0,0,"success",null,null,null,false],[0,0,0,"failure",null,null,null,false],[0,0,0,"skipped",null," This state indicates that the step did not complete, however, it also did not fail,\n and it is safe to continue executing its dependencies.",null,false],[9,74,0,null,null,null,[853,854,855,856,857,858,859,860,861,862,863,864,865,866,867,868],false],[9,92,0,null,null,null,[852],false],[0,0,0,"id",null,"",null,true],[0,0,0,"top_level",null,null,null,false],[0,0,0,"compile",null,null,null,false],[0,0,0,"install_artifact",null,null,null,false],[0,0,0,"install_file",null,null,null,false],[0,0,0,"install_dir",null,null,null,false],[0,0,0,"remove_dir",null,null,null,false],[0,0,0,"fmt",null,null,null,false],[0,0,0,"translate_c",null,null,null,false],[0,0,0,"write_file",null,null,null,false],[0,0,0,"run",null,null,null,false],[0,0,0,"check_file",null,null,null,false],[0,0,0,"check_object",null,null,null,false],[0,0,0,"config_header",null,null,null,false],[0,0,0,"objcopy",null,null,null,false],[0,0,0,"options",null,null,null,false],[0,0,0,"custom",null,null,null,false],[9,114,0,null,null,null,null,false],[0,0,0,"Step/CheckFile.zig",null," Fail the build step if a file does not match certain checks.\n TODO: make this more flexible, supporting more kinds of checks.\n TODO: generalize the code in std.testing.expectEqualStrings and make this\n CheckFile step produce those helpful diagnostics when there is not a match.\n",[893,895,897,899,900],false],[10,4,0,null,null,null,null,false],[10,5,0,null,null,null,null,false],[10,6,0,null,null,null,null,false],[10,7,0,null,null,null,null,false],[10,8,0,null,null,null,null,false],[10,16,0,null,null,null,null,false],[10,18,0,null,null,null,[879,881],false],[10,18,0,null,null,null,null,false],[0,0,0,"expected_matches",null,null,null,false],[10,18,0,null,null,null,null,false],[0,0,0,"expected_exact",null,null,null,false],[10,23,0,null,null,null,[883,884,885],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[10,44,0,null,null,null,[887,888],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[10,48,0,null,null,null,[890,891],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[10,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[10,0,0,null,null,null,null,false],[0,0,0,"expected_matches",null,null,null,false],[10,0,0,null,null,null,null,false],[0,0,0,"expected_exact",null,null,null,false],[10,0,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[0,0,0,"max_bytes",null,null,null,false],[9,115,0,null,null,null,null,false],[0,0,0,"Step/CheckObject.zig",null,"",[1199,1201,1202,1204,1206],false],[11,0,0,null,null,null,null,false],[11,1,0,null,null,null,null,false],[11,2,0,null,null,null,null,false],[11,3,0,null,null,null,null,false],[11,4,0,null,null,null,null,false],[11,5,0,null,null,null,null,false],[11,6,0,null,null,null,null,false],[11,7,0,null,null,null,null,false],[11,9,0,null,null,null,null,false],[11,11,0,null,null,null,null,false],[11,12,0,null,null,null,null,false],[11,14,0,null,null,null,null,false],[11,22,0,null,null,null,[916,917,918],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"obj_format",null,"",null,false],[11,44,0,null,null,null,[925,927],false],[11,48,0,null,null,null,[921,922,923],false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"step",null,"",null,false],[11,44,0,null,null,null,null,false],[0,0,0,"string",null,null,null,false],[11,44,0,null,null,null,null,false],[0,0,0,"file_source",null,null,null,false],[11,65,0,null,null," There five types of actions currently supported:\n .exact - will do an exact match against the haystack\n .contains - will check for existence within the haystack\n .not_present - will check for non-existence within the haystack\n .extract - will do an exact match and extract into a variable enclosed within `{name}` braces\n .compute_cmp - will perform an operation on the extracted global variables\n using the MatchAction. It currently only supports an addition. The operation is required\n to be specified in Reverse Polish Notation to ease in operator-precedence parsing (well,\n to avoid any parsing really).\n For example, if the two extracted values were saved as `vmaddr` and `entryoff` respectively\n they could then be added with this simple program `vmaddr entryoff +`.",[961,963,965],false],[11,71,0,null,null," Returns true if the `phrase` is an exact match with the haystack and variable was successfully extracted.",[930,931,932,933,934],false],[0,0,0,"act",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"step",null,"",null,false],[0,0,0,"haystack",null,"",null,false],[0,0,0,"global_vars",null,"",null,false],[11,112,0,null,null," Returns true if the `phrase` is an exact match with the haystack.",[936,937,938,939],false],[0,0,0,"act",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"step",null,"",null,false],[0,0,0,"haystack",null,"",null,false],[11,125,0,null,null," Returns true if the `phrase` exists within the haystack.",[941,942,943,944],false],[0,0,0,"act",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"step",null,"",null,false],[0,0,0,"haystack",null,"",null,false],[11,138,0,null,null," Returns true if the `phrase` does not exist within the haystack.",[946,947,948,949],false],[0,0,0,"act",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"step",null,"",null,false],[0,0,0,"haystack",null,"",null,false],[11,155,0,null,null," Will return true if the `phrase` is correctly parsed into an RPN program and\n its reduced, computed value compares using `op` with the expected value, either\n a literal or another extracted variable.",[951,952,953,954],false],[0,0,0,"act",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"step",null,"",null,false],[0,0,0,"global_vars",null,"",null,false],[11,65,0,null,null,null,[956,957,958,959,960],false],[0,0,0,"exact",null,null,null,false],[0,0,0,"contains",null,null,null,false],[0,0,0,"not_present",null,null,null,false],[0,0,0,"extract",null,null,null,false],[0,0,0,"compute_cmp",null,null,null,false],[0,0,0,"tag",null,null,null,false],[11,65,0,null,null,null,null,false],[0,0,0,"phrase",null,null,null,false],[11,65,0,null,null,null,null,false],[0,0,0,"expected",null,null,null,false],[11,224,0,null,null,null,[973,977],false],[11,231,0,null,null,null,[968,969,970,971],false],[0,0,0,"value",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,224,0,null,null,null,null,false],[0,0,0,"op",null,null,null,false],[11,224,0,null,null,null,[975,976],false],[0,0,0,"variable",null,null,null,false],[0,0,0,"literal",null,null,null,false],[0,0,0,"value",null,null,null,false],[11,247,0,null,null,null,[998],false],[11,250,0,null,null,null,[980],false],[0,0,0,"allocator",null,"",null,false],[11,256,0,null,null,null,[982,983],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,263,0,null,null,null,[985,986],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,270,0,null,null,null,[988,989],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,277,0,null,null,null,[991,992],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,284,0,null,null,null,[994,995,996],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"expected",null,"",null,false],[11,247,0,null,null,null,null,false],[0,0,0,"actions",null,null,null,false],[11,294,0,null,null," Creates a new empty sequence of actions.",[1000],false],[0,0,0,"self",null,"",null,false],[11,300,0,null,null," Adds an exact match phrase to the latest created Check with `CheckObject.checkStart()`.",[1002,1003],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,306,0,null,null," Like `checkExact()` but takes an additional argument `LazyPath` which will be\n resolved to a full search query in `make()`.",[1005,1006,1007],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,310,0,null,null,null,[1009,1010,1011],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,317,0,null,null," Adds a fuzzy match phrase to the latest created Check with `CheckObject.checkStart()`.",[1013,1014],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,323,0,null,null," Like `checkContains()` but takes an additional argument `FileSource` which will be\n resolved to a full search query in `make()`.",[1016,1017,1018],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,327,0,null,null,null,[1020,1021,1022],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,335,0,null,null," Adds an exact match phrase with variable extractor to the latest created Check\n with `CheckObject.checkStart()`.",[1024,1025],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,341,0,null,null," Like `checkExtract()` but takes an additional argument `FileSource` which will be\n resolved to a full search query in `make()`.",[1027,1028,1029],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,345,0,null,null,null,[1031,1032,1033],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,353,0,null,null," Adds another searched phrase to the latest created Check with `CheckObject.checkStart(...)`\n however ensures there is no matching phrase in the output.",[1035,1036],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[11,359,0,null,null," Like `checkExtract()` but takes an additional argument `FileSource` which will be\n resolved to a full search query in `make()`.",[1038,1039,1040],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,363,0,null,null,null,[1042,1043,1044],false],[0,0,0,"self",null,"",null,false],[0,0,0,"phrase",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[11,371,0,null,null," Creates a new check checking specifically symbol table parsed and dumped from the object\n file.",[1046],false],[0,0,0,"self",null,"",null,false],[11,386,0,null,null," Creates a new check checking specifically dynamic symbol table parsed and dumped from the object\n file.\n This check is target-dependent and applicable to ELF only.",[1048],false],[0,0,0,"self",null,"",null,false],[11,398,0,null,null," Creates a new check checking specifically dynamic section parsed and dumped from the object\n file.\n This check is target-dependent and applicable to ELF only.",[1050],false],[0,0,0,"self",null,"",null,false],[11,410,0,null,null," Creates a new standalone, singular check which allows running simple binary operations\n on the extracted variables. It will then compare the reduced program with the value of\n the expected variable.",[1052,1053,1054],false],[0,0,0,"self",null,"",null,false],[0,0,0,"program",null,"",null,false],[0,0,0,"expected",null,"",null,false],[11,420,0,null,null,null,[1056,1057],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[11,532,0,null,null,null,[],false],[11,533,0,null,null,null,null,false],[11,534,0,null,null,null,null,false],[11,536,0,null,null,null,[1063,1065],false],[11,536,0,null,null,null,null,false],[0,0,0,"symbols",null,null,null,false],[11,536,0,null,null,null,null,false],[0,0,0,"strings",null,null,null,false],[11,541,0,null,null,null,[1067,1068],false],[0,0,0,"step",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[11,600,0,null,null,null,[1070,1071,1072],false],[0,0,0,"lc",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,826,0,null,null,null,[1074,1075,1076,1077],false],[0,0,0,"sections",null,"",null,false],[0,0,0,"imports",null,"",null,false],[0,0,0,"symtab",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,882,0,null,null,null,[],false],[11,883,0,null,null,null,null,false],[11,884,0,null,null,null,null,false],[11,885,0,null,null,null,null,false],[11,887,0,null,null,null,[1090,1092],false],[11,891,0,null,null,null,[1084,1085],false],[0,0,0,"st",null,"",null,false],[0,0,0,"index",null,"",null,false],[11,896,0,null,null,null,[1087,1088],false],[0,0,0,"st",null,"",null,false],[0,0,0,"index",null,"",null,false],[11,887,0,null,null,null,null,false],[0,0,0,"symbols",null,null,null,false],[11,887,0,null,null,null,null,false],[0,0,0,"strings",null,null,null,false],[11,902,0,null,null,null,[1095,1097,1099,1101,1103,1105,1107,1109],false],[11,902,0,null,null,null,null,false],[0,0,0,"gpa",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"hdr",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"shdrs",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"phdrs",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"shstrtab",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"symtab",null,null,null,false],[11,902,0,null,null,null,null,false],[0,0,0,"dysymtab",null,null,null,false],[11,913,0,null,null,null,[1111,1112],false],[0,0,0,"step",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[11,976,0,null,null,null,[1114,1115],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"shndx",null,"",null,false],[11,981,0,null,null,null,[1117,1118],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"shndx",null,"",null,false],[11,988,0,null,null,null,[1120,1121],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"name",null,"",null,false],[11,994,0,null,null,null,[1123,1124],false],[0,0,0,"strtab",null,"",null,false],[0,0,0,"off",null,"",null,false],[11,999,0,null,null,null,[1126,1127],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1005,0,null,null,null,[1129,1130],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1022,0,null,null,null,[1132,1133],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1161,0,null,null,null,[1135],false],[0,0,0,"sh_type",null,"",null,false],[11,1165,0,null,null,null,[1137,1138,1139,1140],false],[0,0,0,"sh_type",null,"",null,false],[0,0,0,"unused_fmt_string",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1208,0,null,null,null,[1142,1143],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1247,0,null,null,null,[1145],false],[0,0,0,"ph_type",null,"",null,false],[11,1251,0,null,null,null,[1147,1148,1149,1150],false],[0,0,0,"ph_type",null,"",null,false],[0,0,0,"unused_fmt_string",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1281,0,null,null,null,[1152,1153,1156],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"type",null,"",[1154,1155],true],[0,0,0,"symtab",null,null,null,false],[0,0,0,"dysymtab",null,null,null,false],[0,0,0,"writer",null,"",null,false],[11,1364,0,null,null,null,[],false],[11,1365,0,null,null,null,null,false],[11,1367,0,null,null,null,[1160,1161],false],[0,0,0,"step",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[11,1397,0,null,null,null,[1163,1164,1165,1166],false],[0,0,0,"step",null,"",null,false],[0,0,0,"section",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1454,0,null,null,null,[1168,1169,1170,1171,1172],false],[0,0,0,"step",null,"",null,false],[0,0,0,"section",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"entries",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1600,0,null,null,null,[1174,1175,1176,1177],false],[0,0,0,"step",null,"",null,false],[0,0,0,"WasmType",null,"",null,true],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1608,0,null,null,null,[1179,1180],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1618,0,null,null,null,[1182,1183,1184],false],[0,0,0,"step",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[11,1637,0,null,null,null,[1186,1187,1188,1189],false],[0,0,0,"step",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"data",null,"",null,false],[11,1664,0,null,null,null,[1191,1192,1193],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"data",null,"",null,false],[11,1698,0,null,null,null,[1195,1196,1197],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"data",null,"",null,false],[11,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[11,0,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[0,0,0,"max_bytes",null,null,null,false],[11,0,0,null,null,null,null,false],[0,0,0,"checks",null,null,null,false],[11,0,0,null,null,null,null,false],[0,0,0,"obj_format",null,null,null,false],[9,116,0,null,null,null,null,false],[0,0,0,"Step/ConfigHeader.zig",null,"",[1291,1293,1295,1297,1298,1300],false],[12,0,0,null,null,null,null,false],[12,1,0,null,null,null,null,false],[12,2,0,null,null,null,null,false],[12,3,0,null,null,null,null,false],[12,5,0,null,null,null,[1217,1218,1219,1220],false],[12,18,0,null,null," deprecated: use `getPath`",null,false],[12,20,0,null,null,null,[1216],false],[0,0,0,"style",null,"",null,false],[0,0,0,"autoconf",null," The configure format supported by autotools. It uses `#undef foo` to\n mark lines that can be substituted with different values.",null,false],[0,0,0,"cmake",null," The configure format supported by CMake. It uses `@@FOO@@` and\n `#cmakedefine` for template substitution.",null,false],[0,0,0,"blank",null," Instead of starting with an input file, start with nothing.",null,false],[0,0,0,"nasm",null," Start with nothing, like blank, and output a nasm .asm file.",null,false],[12,28,0,null,null,null,[1222,1223,1224,1225,1226,1227],false],[0,0,0,"undef",null,null,null,false],[0,0,0,"defined",null,null,null,false],[0,0,0,"boolean",null,null,null,false],[0,0,0,"int",null,null,null,false],[0,0,0,"ident",null,null,null,false],[0,0,0,"string",null,null,null,false],[12,45,0,null,null,null,null,false],[12,47,0,null,null,null,[1231,1232,1234,1236],false],[12,47,0,null,null,null,null,false],[0,0,0,"style",null,null,null,false],[0,0,0,"max_bytes",null,null,null,false],[12,47,0,null,null,null,null,false],[0,0,0,"include_path",null,null,null,false],[12,47,0,null,null,null,null,false],[0,0,0,"first_ret_addr",null,null,null,false],[12,54,0,null,null,null,[1238,1239],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"options",null,"",null,false],[12,99,0,null,null,null,[1241,1242],false],[0,0,0,"self",null,"",null,false],[0,0,0,"values",null,"",null,false],[12,104,0,null,null," deprecated: use `getOutput`",null,false],[12,106,0,null,null,null,[1245],false],[0,0,0,"self",null,"",null,false],[12,110,0,null,null,null,[1247,1248],false],[0,0,0,"self",null,"",null,false],[0,0,0,"values",null,"",null,false],[12,116,0,null,null,null,[1250,1251,1252,1253],false],[0,0,0,"self",null,"",null,false],[0,0,0,"field_name",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"v",null,"",null,false],[12,166,0,null,null,null,[1255,1256],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[12,247,0,null,null,null,[1258,1259,1260,1261,1262],false],[0,0,0,"step",null,"",null,false],[0,0,0,"contents",null,"",null,false],[0,0,0,"output",null,"",null,false],[0,0,0,"values",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[12,294,0,null,null,null,[1264,1265,1266,1267,1268],false],[0,0,0,"step",null,"",null,false],[0,0,0,"contents",null,"",null,false],[0,0,0,"output",null,"",null,false],[0,0,0,"values",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[12,413,0,null,null,null,[1270,1271,1272],false],[0,0,0,"output",null,"",null,false],[0,0,0,"defines",null,"",null,false],[0,0,0,"include_path",null,"",null,false],[12,443,0,null,null,null,[1274,1275],false],[0,0,0,"output",null,"",null,false],[0,0,0,"defines",null,"",null,false],[12,450,0,null,null,null,[1277,1278,1279],false],[0,0,0,"output",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[12,480,0,null,null,null,[1281,1282,1283],false],[0,0,0,"output",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[12,510,0,null,null,null,[1285,1286,1287,1288,1289],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"contents",null,"",null,false],[0,0,0,"values",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[0,0,0,"suffix",null,"",null,false],[12,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[12,0,0,null,null,null,null,false],[0,0,0,"values",null,null,null,false],[12,0,0,null,null,null,null,false],[0,0,0,"output_file",null,null,null,false],[12,0,0,null,null,null,null,false],[0,0,0,"style",null,null,null,false],[0,0,0,"max_bytes",null,null,null,false],[12,0,0,null,null,null,null,false],[0,0,0,"include_path",null,null,null,false],[9,117,0,null,null,null,null,false],[0,0,0,"Step/Fmt.zig",null," This step has two modes:\n * Modify mode: directly modify source files, formatting them in place.\n * Check mode: fail the step if a non-conforming file is found.\n",[1320,1322,1324,1325],false],[13,3,0,null,null,null,null,false],[13,4,0,null,null,null,null,false],[13,5,0,null,null,null,null,false],[13,12,0,null,null,null,null,false],[13,14,0,null,null,null,[1309,1311,1312],false],[13,14,0,null,null,null,null,false],[0,0,0,"paths",null,null,null,false],[13,14,0,null,null,null,null,false],[0,0,0,"exclude_paths",null,null,null,false],[0,0,0,"check",null," If true, fails the build step when any non-conforming files are encountered.",null,false],[13,21,0,null,null,null,[1314,1315],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"options",null,"",null,false],[13,38,0,null,null,null,[1317,1318],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[13,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[13,0,0,null,null,null,null,false],[0,0,0,"paths",null,null,null,false],[13,0,0,null,null,null,null,false],[0,0,0,"exclude_paths",null,null,null,false],[0,0,0,"check",null,null,null,false],[9,118,0,null,null,null,null,false],[0,0,0,"Step/InstallArtifact.zig",null,"",[1365,1367,1369,1371,1373,1375,1377,1379,1381,1383,1385,1387],false],[14,0,0,null,null,null,null,false],[14,1,0,null,null,null,null,false],[14,2,0,null,null,null,null,false],[14,3,0,null,null,null,null,false],[14,4,0,null,null,null,null,false],[14,5,0,null,null,null,null,false],[14,26,0,null,null,null,[1336,1338],false],[14,26,0,null,null,null,null,false],[0,0,0,"major_only_filename",null,null,null,false],[14,26,0,null,null,null,null,false],[0,0,0,"name_only_filename",null,null,null,false],[14,31,0,null,null,null,null,false],[14,33,0,null,null,null,[1346,1348,1350,1352,1354,1356],false],[14,46,0,null,null,null,[1342,1343,1344],false],[0,0,0,"disabled",null,null,null,false],[0,0,0,"default",null,null,null,false],[0,0,0,"override",null,null,null,false],[14,33,0,null,null,null,null,false],[0,0,0,"dest_dir",null," Which installation directory to put the main output file into.",null,false],[14,33,0,null,null,null,null,false],[0,0,0,"pdb_dir",null,null,null,false],[14,33,0,null,null,null,null,false],[0,0,0,"h_dir",null,null,null,false],[14,33,0,null,null,null,null,false],[0,0,0,"implib_dir",null,null,null,false],[14,33,0,null,null,null,null,false],[0,0,0,"dylib_symlinks",null," Whether to install symlinks along with dynamic libraries.",null,false],[14,33,0,null,null,null,null,false],[0,0,0,"dest_sub_path",null," If non-null, adds additional path components relative to bin dir, and\n overrides the basename of the Compile step for installation purposes.",null,false],[14,53,0,null,null,null,[1358,1359,1360],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"artifact",null,"",null,false],[0,0,0,"options",null,"",null,false],[14,121,0,null,null,null,[1362,1363],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[14,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"dest_dir",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"dest_sub_path",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"emitted_bin",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"implib_dir",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"emitted_implib",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"pdb_dir",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"emitted_pdb",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"h_dir",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"emitted_h",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"dylib_symlinks",null,null,null,false],[14,0,0,null,null,null,null,false],[0,0,0,"artifact",null,null,null,false],[9,119,0,null,null,null,null,false],[0,0,0,"Step/InstallDir.zig",null,"",[1419,1421,1423],false],[15,0,0,null,null,null,null,false],[15,1,0,null,null,null,null,false],[15,2,0,null,null,null,null,false],[15,3,0,null,null,null,null,false],[15,4,0,null,null,null,null,false],[15,5,0,null,null,null,null,false],[15,6,0,null,null,null,null,false],[15,14,0,null,null,null,null,false],[15,16,0,null,null,null,[1403,1405,1407,1409,1411],false],[15,30,0,null,null,null,[1400,1401],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[15,16,0,null,null,null,null,false],[0,0,0,"source_dir",null,null,null,false],[15,16,0,null,null,null,null,false],[0,0,0,"install_dir",null,null,null,false],[15,16,0,null,null,null,null,false],[0,0,0,"install_subdir",null,null,null,false],[15,16,0,null,null,null,null,false],[0,0,0,"exclude_extensions",null," File paths which end in any of these suffixes will be excluded\n from being installed.",null,false],[15,16,0,null,null,null,null,false],[0,0,0,"blank_extensions",null," File paths which end in any of these suffixes will result in\n empty files being installed. This is mainly intended for large\n test.zig files in order to prevent needless installation bloat.\n However if the files were not present at all, then\n `@import(\"test.zig\")` would be a compile error.",null,false],[15,41,0,null,null,null,[1413,1414],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"options",null,"",null,false],[15,58,0,null,null,null,[1416,1417],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[15,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[15,0,0,null,null,null,null,false],[0,0,0,"options",null,null,null,false],[15,0,0,null,null,null,null,false],[0,0,0,"dest_builder",null," This is used by the build system when a file being installed comes from one\n package but is being installed by another.",null,false],[9,120,0,null,null,null,null,false],[0,0,0,"Step/InstallFile.zig",null,"",[1442,1444,1446,1448,1450],false],[16,0,0,null,null,null,null,false],[16,1,0,null,null,null,null,false],[16,2,0,null,null,null,null,false],[16,3,0,null,null,null,null,false],[16,4,0,null,null,null,null,false],[16,5,0,null,null,null,null,false],[16,7,0,null,null,null,null,false],[16,17,0,null,null,null,[1434,1435,1436,1437],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[16,42,0,null,null,null,[1439,1440],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[16,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[16,0,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[16,0,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[16,0,0,null,null,null,null,false],[0,0,0,"dest_rel_path",null,null,null,false],[16,0,0,null,null,null,null,false],[0,0,0,"dest_builder",null," This is used by the build system when a file being installed comes from one\n package but is being installed by another.",null,false],[9,121,0,null,null,null,null,false],[0,0,0,"Step/ObjCopy.zig",null,"",[1500,1502,1504,1506,1508,1510,1512,1514,1516,1517],false],[17,0,0,null,null,null,null,false],[17,1,0,null,null,null,null,false],[17,3,0,null,null,null,null,false],[17,4,0,null,null,null,null,false],[17,5,0,null,null,null,null,false],[17,6,0,null,null,null,null,false],[17,7,0,null,null,null,null,false],[17,8,0,null,null,null,null,false],[17,9,0,null,null,null,null,false],[17,10,0,null,null,null,null,false],[17,11,0,null,null,null,null,false],[17,12,0,null,null,null,null,false],[17,14,0,null,null,null,null,false],[17,16,0,null,null,null,[1467,1468,1469],false],[0,0,0,"bin",null,null,null,false],[0,0,0,"hex",null,null,null,false],[0,0,0,"elf",null,null,null,false],[17,22,0,null,null,null,[1471,1472,1473],false],[0,0,0,"none",null,null,null,false],[0,0,0,"debug",null,null,null,false],[0,0,0,"debug_and_symbols",null,null,null,false],[17,40,0,null,null,null,[1476,1478,1480,1482,1483,1485,1486],false],[17,40,0,null,null,null,null,false],[0,0,0,"basename",null,null,null,false],[17,40,0,null,null,null,null,false],[0,0,0,"format",null,null,null,false],[17,40,0,null,null,null,null,false],[0,0,0,"only_section",null,null,null,false],[17,40,0,null,null,null,null,false],[0,0,0,"pad_to",null,null,null,false],[0,0,0,"compress_debug",null,null,null,false],[17,40,0,null,null,null,null,false],[0,0,0,"strip",null,null,null,false],[0,0,0,"extract_to_separate_file",null," Put the stripped out debug sections in a separate file.\n note: the `basename` is baked into the elf file to specify the link to the separate debug file.\n see https://sourceware.org/gdb/onlinedocs/gdb/Separate-Debug-Files.html",null,false],[17,55,0,null,null,null,[1488,1489,1490],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"input_file",null,"",null,false],[0,0,0,"options",null,"",null,false],[17,83,0,null,null," deprecated: use getOutput",null,false],[17,85,0,null,null,null,[1493],false],[0,0,0,"self",null,"",null,false],[17,88,0,null,null,null,[1495],false],[0,0,0,"self",null,"",null,false],[17,92,0,null,null,null,[1497,1498],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[17,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"input_file",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"basename",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"output_file",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"output_file_debug",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"format",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"only_section",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"pad_to",null,null,null,false],[17,0,0,null,null,null,null,false],[0,0,0,"strip",null,null,null,false],[0,0,0,"compress_debug",null,null,null,false],[9,122,0,null,null,null,null,false],[0,0,0,"Step/Compile.zig",null,"",[1919,1921,1923,1925,1927,1929,1931,1933,1935,1937,1939,1941,1943,1945,1947,1951,1953,1955,1957,1958,1959,1961,1963,1965,1966,1967,1968,1969,1971,1972,1973,1974,1975,1976,1978,1980,1981,1983,1985,1987,1989,1991,1993,1994,1996,1998,2000,2002,2004,2006,2008,2010,2012,2014,2016,2017,2018,2020,2022,2024,2026,2028,2030,2032,2033,2034,2035,2037,2038,2040,2041,2042,2043,2045,2047,2049,2051,2053,2055,2056,2057,2059,2061,2063,2065,2067,2069,2071,2073,2075,2077,2079,2081,2083,2085,2087,2089,2091,2093,2095,2097,2099,2101],false],[18,0,0,null,null,null,null,false],[18,1,0,null,null,null,null,false],[18,2,0,null,null,null,null,false],[18,3,0,null,null,null,null,false],[18,4,0,null,null,null,null,false],[18,5,0,null,null,null,null,false],[18,6,0,null,null,null,null,false],[18,7,0,null,null,null,null,false],[18,8,0,null,null,null,null,false],[18,9,0,null,null,null,null,false],[18,10,0,null,null,null,null,false],[18,11,0,null,null,null,null,false],[18,12,0,null,null,null,null,false],[18,13,0,null,null,null,null,false],[18,14,0,null,null,null,null,false],[18,15,0,null,null,null,null,false],[18,16,0,null,null,null,null,false],[18,17,0,null,null,null,null,false],[18,18,0,null,null,null,null,false],[18,19,0,null,null,null,null,false],[18,20,0,null,null,null,null,false],[18,21,0,null,null,null,null,false],[18,23,0,null,null,null,null,false],[18,205,0,null,null,null,[1545,1547],false],[18,205,0,null,null,null,null,false],[0,0,0,"files",null," Relative to the build root.",null,false],[18,205,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[18,211,0,null,null,null,[1553,1555],false],[18,215,0,null,null,null,[1550,1551],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[18,211,0,null,null,null,null,false],[0,0,0,"file",null,null,null,false],[18,211,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[18,223,0,null,null,null,[1557,1558,1559,1560,1561,1562],false],[0,0,0,"static_path",null,null,null,false],[0,0,0,"other_step",null,null,null,false],[0,0,0,"system_lib",null,null,null,false],[0,0,0,"assembly_file",null,null,null,false],[0,0,0,"c_source_file",null,null,null,false],[0,0,0,"c_source_files",null,null,null,false],[18,232,0,null,null,null,[1573,1574,1575,1577,1579,1581],false],[18,240,0,null,null,null,[1565,1566,1567],false],[0,0,0,"no",null," Don't use pkg-config, just pass -lfoo where foo is name.",null,false],[0,0,0,"yes",null," Try to get information on how to link the library from pkg-config.\n If that fails, fall back to passing -lfoo where foo is name.",null,false],[0,0,0,"force",null," Try to get information on how to link the library from pkg-config.\n If that fails, error out.",null,false],[18,251,0,null,null,null,[1569,1570,1571],false],[0,0,0,"paths_first",null,null,null,false],[0,0,0,"mode_first",null,null,null,false],[0,0,0,"no_fallback",null,null,null,false],[18,232,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"needed",null,null,null,false],[0,0,0,"weak",null,null,null,false],[18,232,0,null,null,null,null,false],[0,0,0,"use_pkg_config",null,null,null,false],[18,232,0,null,null,null,null,false],[0,0,0,"preferred_link_mode",null,null,null,false],[18,232,0,null,null,null,null,false],[0,0,0,"search_strategy",null,null,null,false],[18,254,0,null,null,null,[1583,1584],false],[0,0,0,"needed",null,null,null,false],[0,0,0,"weak",null,null,null,false],[18,259,0,null,null,null,[1586,1587,1588,1589,1590,1591],false],[0,0,0,"path",null,null,null,false],[0,0,0,"path_system",null,null,null,false],[0,0,0,"framework_path",null,null,null,false],[0,0,0,"framework_path_system",null,null,null,false],[0,0,0,"other_step",null,null,null,false],[0,0,0,"config_header_step",null,null,null,false],[18,268,0,null,null,null,[1594,1596,1598,1600,1602,1604,1606,1607,1609,1611,1613,1615,1617,1619,1621,1623],false],[18,268,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"root_source_file",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"linkage",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"filter",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"test_runner",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[18,268,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null,null,null,false],[18,287,0,null,null,null,[1639,1640,1641,1642,1643,1644],false],[18,295,0,null,null,null,[1626,1627],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[18,305,0,null,null,null,[1632,1633],false],[18,310,0,null,null," Result is byte values, *not* hex-encoded.",[1630],false],[0,0,0,"hs",null,"",null,false],[18,305,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"len",null,null,null,false],[18,317,0,null,null," Input is byte values, *not* hex-encoded.\n Asserts `bytes` fits inside `HexString`",[1635],false],[0,0,0,"bytes",null,"",null,false],[18,327,0,null,null," Converts UTF-8 text to a `BuildId`.",[1637],false],[0,0,0,"text",null,"",null,false],[18,347,0,"parse","test parse {\n        try std.testing.expectEqual(BuildId.md5, try parse(\"md5\"));\n        try std.testing.expectEqual(BuildId.none, try parse(\"none\"));\n        try std.testing.expectEqual(BuildId.fast, try parse(\"fast\"));\n        try std.testing.expectEqual(BuildId.uuid, try parse(\"uuid\"));\n        try std.testing.expectEqual(BuildId.sha1, try parse(\"sha1\"));\n        try std.testing.expectEqual(BuildId.sha1, try parse(\"tree\"));\n\n        try std.testing.expect(BuildId.initHexString(\"\").eql(try parse(\"0x\")));\n        try std.testing.expect(BuildId.initHexString(\"\\x12\\x34\\x56\").eql(try parse(\"0x123456\")));\n        try std.testing.expectError(error.InvalidLength, parse(\"0x12-34\"));\n        try std.testing.expectError(error.InvalidCharacter, parse(\"0xfoobbb\"));\n        try std.testing.expectError(error.InvalidBuildIdStyle, parse(\"yaddaxxx\"));\n    }",null,null,false],[0,0,0,"none",null,null,null,false],[0,0,0,"fast",null,null,null,false],[0,0,0,"uuid",null,null,null,false],[0,0,0,"sha1",null,null,null,false],[0,0,0,"md5",null,null,null,false],[0,0,0,"hexstring",null,null,null,false],[18,363,0,null,null,null,[1646,1647,1648,1649],false],[0,0,0,"exe",null,null,null,false],[0,0,0,"lib",null,null,null,false],[0,0,0,"obj",null,null,null,false],[0,0,0,"test",null,null,null,false],[18,370,0,null,null,null,[1651,1652],false],[0,0,0,"dynamic",null,null,null,false],[0,0,0,"static",null,null,null,false],[18,372,0,null,null,null,[1654,1655],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,522,0,null,null,null,[1657,1658,1659],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[18,529,0,null,null,null,[1662,1664],false],[18,529,0,null,null,null,null,false],[0,0,0,"install_dir",null,null,null,false],[18,529,0,null,null,null,null,false],[0,0,0,"dest_rel_path",null,null,null,false],[18,534,0,null,null,null,[1666,1667,1668],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"config_header",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,551,0,null,null,null,[1670,1671,1672],false],[0,0,0,"a",null,"",null,false],[0,0,0,"src_dir_path",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[18,563,0,null,null,null,[1674,1675],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,573,0,null,null,null,[1677,1678],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"l",null,"",null,false],[18,596,0,null,null,null,[1680,1681],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,611,0,null,null," This function would run in the context of the package that created the executable,\n which is undesirable when running an executable provided by a dependency package.",null,false],[18,615,0,null,null," This function would install in the context of the package that created the artifact,\n which is undesirable when installing an artifact provided by a dependency package.",null,false],[18,617,0,null,null,null,[1685],false],[0,0,0,"self",null,"",null,false],[18,622,0,null,null," deprecated: use `setLinkerScript`",null,false],[18,624,0,null,null,null,[1688,1689],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[18,630,0,null,null,null,[1691,1692],false],[0,0,0,"self",null,"",null,false],[0,0,0,"symbol_name",null,"",null,false],[18,635,0,null,null,null,[1694,1695],false],[0,0,0,"self",null,"",null,false],[0,0,0,"framework_name",null,"",null,false],[18,640,0,null,null,null,[1697,1698],false],[0,0,0,"self",null,"",null,false],[0,0,0,"framework_name",null,"",null,false],[18,647,0,null,null,null,[1700,1701],false],[0,0,0,"self",null,"",null,false],[0,0,0,"framework_name",null,"",null,false],[18,655,0,null,null," Returns whether the library, executable, or object depends on a particular system library.",[1703,1704],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,671,0,null,null,null,[1706,1707],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lib",null,"",null,false],[18,676,0,null,null,null,[1709],false],[0,0,0,"self",null,"",null,false],[18,680,0,null,null,null,[1711],false],[0,0,0,"self",null,"",null,false],[18,684,0,null,null,null,[1713],false],[0,0,0,"self",null,"",null,false],[18,693,0,null,null,null,[1715],false],[0,0,0,"self",null,"",null,false],[18,697,0,null,null,null,[1717],false],[0,0,0,"self",null,"",null,false],[18,701,0,null,null,null,[1719],false],[0,0,0,"self",null,"",null,false],[18,707,0,null,null," If the value is omitted, it is set to 1.\n `name` and `value` need not live longer than the function call.",[1721,1722,1723],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[18,714,0,null,null," name_and_value looks like [name]=[value]. If the value is omitted, it is set to 1.",[1725,1726],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name_and_value",null,"",null,false],[18,720,0,null,null," deprecated: use linkSystemLibrary2",[1728,1729],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,725,0,null,null," deprecated: use linkSystemLibrary2",[1731,1732],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,730,0,null,null," deprecated: use linkSystemLibrary2",[1734,1735],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,735,0,null,null," deprecated: use linkSystemLibrary2",[1737,1738],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lib_name",null,"",null,false],[18,740,0,null,null," deprecated: use linkSystemLibrary2",[1740,1741],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lib_name",null,"",null,false],[18,746,0,null,null," Run pkg-config for the given library name and parse the output, returning the arguments\n that should be passed to zig to link the given library.",[1743,1744],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lib_name",null,"",null,false],[18,840,0,null,null,null,[1746,1747],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,845,0,null,null," deprecated: use linkSystemLibrary2",[1749,1750],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,850,0,null,null," deprecated: use linkSystemLibrary2",[1752,1753],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[18,854,0,null,null,null,[1755,1756,1758,1760,1762],false],[0,0,0,"needed",null,null,null,false],[0,0,0,"weak",null,null,null,false],[18,854,0,null,null,null,null,false],[0,0,0,"use_pkg_config",null,null,null,false],[18,854,0,null,null,null,null,false],[0,0,0,"preferred_link_mode",null,null,null,false],[18,854,0,null,null,null,null,false],[0,0,0,"search_strategy",null,null,null,false],[18,862,0,null,null,null,[1764,1765,1766],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,890,0,null,null," Handy when you have many C/C++ source files and want them all to have the same flags.",[1768,1769,1770],false],[0,0,0,"self",null,"",null,false],[0,0,0,"files",null,"",null,false],[0,0,0,"flags",null,"",null,false],[18,904,0,null,null,null,[1772,1773],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[18,912,0,null,null,null,[1775,1776],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[18,916,0,null,null,null,[1778,1779],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[18,920,0,null,null,null,[1781,1782],false],[0,0,0,"self",null,"",null,false],[0,0,0,"libc_file",null,"",null,false],[18,925,0,null,null,null,[1784,1785],false],[0,0,0,"self",null,"",null,false],[0,0,0,"output_file",null,"",null,false],[18,937,0,null,null," deprecated: use `getEmittedBinDirectory`",null,false],[18,940,0,null,null," Returns the path to the directory that contains the emitted binary file.",[1788],false],[0,0,0,"self",null,"",null,false],[18,946,0,null,null," deprecated: use `getEmittedBin`",null,false],[18,950,0,null,null," Returns the path to the generated executable, library or object file.\n To run an executable built with zig build, use `run`, or create an install step and invoke it.",[1791],false],[0,0,0,"self",null,"",null,false],[18,955,0,null,null," deprecated: use `getEmittedImplib`",null,false],[18,959,0,null,null," Returns the path to the generated import library.\n This function can only be called for libraries.",[1794],false],[0,0,0,"self",null,"",null,false],[18,965,0,null,null," deprecated: use `getEmittedH`",null,false],[18,969,0,null,null," Returns the path to the generated header file.\n This function can only be called for libraries or objects.",[1797],false],[0,0,0,"self",null,"",null,false],[18,975,0,null,null," deprecated: use `getEmittedPdb`.",null,false],[18,980,0,null,null," Returns the generated PDB file.\n If the compilation does not produce a PDB file, this causes a FileNotFound error\n at build time.",[1800],false],[0,0,0,"self",null,"",null,false],[18,986,0,null,null," Returns the path to the generated documentation directory.",[1802],false],[0,0,0,"self",null,"",null,false],[18,991,0,null,null," Returns the path to the generated assembly code.",[1804],false],[0,0,0,"self",null,"",null,false],[18,996,0,null,null," Returns the path to the generated LLVM IR.",[1806],false],[0,0,0,"self",null,"",null,false],[18,1001,0,null,null," Returns the path to the generated LLVM BC.",[1808],false],[0,0,0,"self",null,"",null,false],[18,1005,0,null,null,null,[1810,1811],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[18,1012,0,null,null,null,[1813,1814],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[18,1018,0,null,null,null,[1816,1817],false],[0,0,0,"self",null,"",null,false],[0,0,0,"obj",null,"",null,false],[18,1023,0,null,null,null,[1819,1820],false],[0,0,0,"self",null,"",null,false],[0,0,0,"path",null,"",null,false],[18,1029,0,null,null,null,[1822,1823],false],[0,0,0,"self",null,"",null,false],[0,0,0,"path",null,"",null,false],[18,1035,0,null,null,null,[1825,1826],false],[0,0,0,"self",null,"",null,false],[0,0,0,"config_header",null,"",null,false],[18,1040,0,null,null,null,[1828,1829],false],[0,0,0,"self",null,"",null,false],[0,0,0,"directory_source",null,"",null,false],[18,1046,0,null,null,null,[1831,1832],false],[0,0,0,"self",null,"",null,false],[0,0,0,"directory_source",null,"",null,false],[18,1052,0,null,null,null,[1834,1835],false],[0,0,0,"self",null,"",null,false],[0,0,0,"directory_source",null,"",null,false],[18,1058,0,null,null,null,[1837,1838],false],[0,0,0,"self",null,"",null,false],[0,0,0,"directory_source",null,"",null,false],[18,1066,0,null,null," Adds a module to be used with `@import` and exposing it in the current\n package's module table using `name`.",[1840,1841,1842],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"module",null,"",null,false],[18,1077,0,null,null," Adds a module to be used with `@import` without exposing it in the current\n package's module table.",[1844,1845,1846],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,1083,0,null,null,null,[1848,1849,1850],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"module_name",null,"",null,false],[0,0,0,"options",null,"",null,false],[18,1087,0,null,null,null,[1852,1853,1854],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"module",null,"",null,false],[0,0,0,"done",null,"",null,false],[18,1098,0,null,null," If Vcpkg was found on the system, it will be added to include and lib\n paths for the specified target.",[1856,1857],false],[0,0,0,"self",null,"",null,false],[0,0,0,"linkage",null,"",null,false],[18,1134,0,null,null,null,[1859,1860],false],[0,0,0,"self",null,"",null,false],[0,0,0,"args",null,"",null,false],[18,1144,0,null,null,null,[1862,1863],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[18,1158,0,null,null,null,[1865,1866],false],[0,0,0,"cs",null,"",null,false],[0,0,0,"zig_args",null,"",null,false],[18,1245,0,null,null,null,[1868,1869,1870],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"mod_names",null,"",null,false],[0,0,0,"deps",null,"",null,false],[18,1268,0,null,null,null,[1872,1873,1874],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tag_name",null,"",null,true],[0,0,0,"asking_step",null,"",null,false],[18,1292,0,null,null,null,[1876,1877],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[18,2070,0,null,null,null,[1879],false],[0,0,0,"name",null,"",null,false],[18,2079,0,null,null,null,[1881],false],[0,0,0,"name",null,"",null,false],[18,2089,0,null,null," Returned slice must be freed by the caller.",[1883],false],[0,0,0,"allocator",null,"",null,false],[18,2107,0,null,null,null,[1885,1886,1887,1888],false],[0,0,0,"step",null,"",null,false],[0,0,0,"output_path",null,"",null,false],[0,0,0,"filename_major_only",null,"",null,false],[0,0,0,"filename_name_only",null,"",null,false],[18,2132,0,null,null,null,[1890,1891],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out_code",null,"",null,false],[18,2148,0,null,null,null,[1893],false],[0,0,0,"self",null,"",null,false],[18,2171,0,null,null,null,[1895,1896,1897],false],[0,0,0,"args",null,"",null,false],[0,0,0,"name",null,"",null,true],[0,0,0,"opt",null,"",null,false],[18,2181,0,null,null,null,[1907,1909,1911,1912,1913,1915],false],[18,2189,0,null,null,null,[1900,1901],false],[0,0,0,"td",null,"",null,false],[0,0,0,"link_objects",null,"",null,false],[18,2201,0,null,null,null,[1903,1904,1905],false],[0,0,0,"td",null,"",null,false],[0,0,0,"other",null,"",null,false],[0,0,0,"dyn",null,"",null,false],[18,2181,0,null,null,null,null,false],[0,0,0,"link_objects",null,null,null,false],[18,2181,0,null,null,null,null,false],[0,0,0,"seen_system_libs",null,null,null,false],[18,2181,0,null,null,null,null,false],[0,0,0,"seen_steps",null,null,null,false],[0,0,0,"is_linking_libcpp",null,null,null,false],[0,0,0,"is_linking_libc",null,null,null,false],[18,2181,0,null,null,null,null,false],[0,0,0,"frameworks",null,null,null,false],[18,2242,0,null,null,null,[1917],false],[0,0,0,"self",null,"",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"target_info",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"linker_script",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"version_script",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"out_filename",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"linkage",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"major_only_filename",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"name_only_filename",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"strip",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"unwind_tables",null,null,null,false],[18,0,0,null,null,null,[1949,1950],false],[0,0,0,"none",null,null,null,false],[0,0,0,"zlib",null,null,null,false],[0,0,0,"compress_debug_sections",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"lib_paths",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"rpaths",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"frameworks",null,null,null,false],[0,0,0,"verbose_link",null,null,null,false],[0,0,0,"verbose_cc",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"bundle_compiler_rt",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"stack_protector",null,null,null,false],[0,0,0,"disable_stack_probing",null,null,null,false],[0,0,0,"disable_sanitize_c",null,null,null,false],[0,0,0,"sanitize_thread",null,null,null,false],[0,0,0,"rdynamic",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"dwarf_format",null,null,null,false],[0,0,0,"import_memory",null,null,null,false],[0,0,0,"export_memory",null,null,null,false],[0,0,0,"import_symbols",null," For WebAssembly targets, this will allow for undefined symbols to\n be imported from the host environment.",null,false],[0,0,0,"import_table",null,null,null,false],[0,0,0,"export_table",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"initial_memory",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"max_memory",null,null,null,false],[0,0,0,"shared_memory",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"global_base",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"c_std",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null," Set via options; intended to be read-only after that.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null," Set via options; intended to be read-only after that.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"exec_cmd_args",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"filter",null,null,null,false],[0,0,0,"test_evented_io",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"test_runner",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"code_model",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"wasi_exec_model",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"export_symbol_names",null," Symbols to be exported when compiling to wasm",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"root_src",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"out_lib_filename",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"modules",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"link_objects",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"include_dirs",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"c_macros",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"installed_headers",null,null,null,false],[0,0,0,"is_linking_libc",null,null,null,false],[0,0,0,"is_linking_libcpp",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"vcpkg_bin_path",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"installed_path",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"image_base",null," Base address for an executable image.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"libc_file",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"valgrind_support",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"each_lib_rpath",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"build_id",null," On ELF targets, this will emit a link section called \".note.gnu.build-id\"\n which can be used to coordinate a stripped binary with its debug symbols.\n As an example, the bloaty project refuses to work unless its inputs have\n build ids, in order to prevent accidental mismatches.\n The default is to not include this section because it slows down linking.",null,false],[0,0,0,"link_eh_frame_hdr",null," Create a .eh_frame_hdr section and a PT_GNU_EH_FRAME segment in the ELF\n file.",null,false],[0,0,0,"link_emit_relocs",null,null,null,false],[0,0,0,"link_function_sections",null," Place every function in its own section so that unused ones may be\n safely garbage-collected during the linking phase.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"link_gc_sections",null," Remove functions and data that are unreachable by the entry point or\n exported symbols.",null,false],[0,0,0,"linker_dynamicbase",null," (Windows) Whether or not to enable ASLR. Maps to the /DYNAMICBASE[:NO] linker argument.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"linker_allow_shlib_undefined",null,null,null,false],[0,0,0,"link_z_notext",null," Permit read-only relocations in read-only segments. Disallowed by default.",null,false],[0,0,0,"link_z_relro",null," Force all relocations to be read-only after processing.",null,false],[0,0,0,"link_z_lazy",null," Allow relocations to be lazily processed after load.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"link_z_common_page_size",null," Common page size",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"link_z_max_page_size",null," Maximum page size",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"install_name",null," (Darwin) Install name for the dylib",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"entitlements",null," (Darwin) Path to entitlements file",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"pagezero_size",null," (Darwin) Size of the pagezero segment.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"headerpad_size",null," (Darwin) Set size of the padding between the end of load commands\n and start of `__TEXT,__text` section.",null,false],[0,0,0,"headerpad_max_install_names",null," (Darwin) Automatically Set size of the padding between the end of load commands\n and start of `__TEXT,__text` section to a value fitting all paths expanded to MAXPATHLEN.",null,false],[0,0,0,"dead_strip_dylibs",null," (Darwin) Remove dylibs that are unreachable by the entry point or exported symbols.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"force_pic",null," Position Independent Code",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"pie",null," Position Independent Executable",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"red_zone",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"omit_frame_pointer",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"dll_export_fns",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"subsystem",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"entry_symbol_name",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"force_undefined_symbols",null," List of symbols forced as undefined in the symbol table\n thus forcing their resolution by the linker.\n Corresponds to `-u <symbol>` for ELF/MachO and `/include:<symbol>` for COFF/PE.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"stack_size",null," Overrides the default stack size",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"want_lto",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"expect_errors",null," This is an advanced setting that can change the intent of this Compile step.\n If this slice has nonzero length, it means that this Compile step exists to\n check for compile errors and return *success* if they match, and failure\n otherwise.",null,false],[18,0,0,null,null,null,null,false],[0,0,0,"emit_directory",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_docs",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_asm",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_bin",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_pdb",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_implib",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_llvm_bc",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_llvm_ir",null,null,null,false],[18,0,0,null,null,null,null,false],[0,0,0,"generated_h",null,null,null,false],[9,123,0,null,null,null,null,false],[0,0,0,"Step/Options.zig",null,"",[2152,2154,2156,2158],false],[19,0,0,null,null,null,null,false],[19,1,0,null,null,null,null,false],[19,2,0,null,null,null,null,false],[19,3,0,null,null,null,null,false],[19,4,0,null,null,null,null,false],[19,5,0,null,null,null,null,false],[19,7,0,null,null,null,null,false],[19,9,0,null,null,null,null,false],[19,17,0,null,null,null,[2113],false],[0,0,0,"owner",null,"",null,false],[19,35,0,null,null,null,[2115,2116,2117,2118],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[19,39,0,null,null,null,[2120,2121,2122,2123],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[19,124,0,null,null,null,[2125,2126,2127],false],[0,0,0,"out",null,"",null,false],[0,0,0,"val",null,"",null,false],[0,0,0,"indent",null,"",null,false],[19,169,0,null,null," deprecated: use `addOptionPath`",null,false],[19,173,0,null,null," The value is the path in the cache dir.\n Adds a dependency automatically.",[2130,2131,2132],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"path",null,"",null,false],[19,186,0,null,null," Deprecated: use `addOptionPath(options, name, artifact.getEmittedBin())` instead.",[2134,2135,2136],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"artifact",null,"",null,false],[19,190,0,null,null,null,[2138],false],[0,0,0,"self",null,"",null,false],[19,198,0,null,null," deprecated: use `getOutput`",null,false],[19,200,0,null,null,null,[2141],false],[0,0,0,"self",null,"",null,false],[19,204,0,null,null,null,[2143,2144],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[19,290,0,null,null,null,[2147,2149],false],[19,290,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[19,290,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[19,295,0,"Options","test Options {\n    if (builtin.os.tag == .wasi) return error.SkipZigTest;\n\n    var arena = std.heap.ArenaAllocator.init(std.testing.allocator);\n    defer arena.deinit();\n\n    const host = try std.zig.system.NativeTargetInfo.detect(.{});\n\n    var cache: std.Build.Cache = .{\n        .gpa = arena.allocator(),\n        .manifest_dir = std.fs.cwd(),\n    };\n\n    var builder = try std.Build.create(\n        arena.allocator(),\n        \"test\",\n        .{ .path = \"test\", .handle = std.fs.cwd() },\n        .{ .path = \"test\", .handle = std.fs.cwd() },\n        .{ .path = \"test\", .handle = std.fs.cwd() },\n        host,\n        &cache,\n        &.{},\n    );\n    defer builder.destroy();\n\n    const options = builder.addOptions();\n\n    // TODO this regressed at some point\n    //const KeywordEnum = enum {\n    //    @\"0.8.1\",\n    //};\n\n    const nested_array = [2][2]u16{\n        [2]u16{ 300, 200 },\n        [2]u16{ 300, 200 },\n    };\n    const nested_slice: []const []const u16 = &[_][]const u16{ &nested_array[0], &nested_array[1] };\n\n    options.addOption(usize, \"option1\", 1);\n    options.addOption(?usize, \"option2\", null);\n    options.addOption(?usize, \"option3\", 3);\n    options.addOption(comptime_int, \"option4\", 4);\n    options.addOption([]const u8, \"string\", \"zigisthebest\");\n    options.addOption(?[]const u8, \"optional_string\", null);\n    options.addOption([2][2]u16, \"nested_array\", nested_array);\n    options.addOption([]const []const u16, \"nested_slice\", nested_slice);\n    //options.addOption(KeywordEnum, \"keyword_enum\", .@\"0.8.1\");\n    options.addOption(std.SemanticVersion, \"semantic_version\", try std.SemanticVersion.parse(\"0.1.2-foo+bar\"));\n\n    try std.testing.expectEqualStrings(\n        \\\\pub const option1: usize = 1;\n        \\\\pub const option2: ?usize = null;\n        \\\\pub const option3: ?usize = 3;\n        \\\\pub const option4: comptime_int = 4;\n        \\\\pub const string: []const u8 = \"zigisthebest\";\n        \\\\pub const optional_string: ?[]const u8 = null;\n        \\\\pub const nested_array: [2][2]u16 = [2][2]u16 {\n        \\\\    [2]u16 {\n        \\\\        300,\n        \\\\        200,\n        \\\\    },\n        \\\\    [2]u16 {\n        \\\\        300,\n        \\\\        200,\n        \\\\    },\n        \\\\};\n        \\\\pub const nested_slice: []const []const u16 = &[_][]const u16 {\n        \\\\    &[_]u16 {\n        \\\\        300,\n        \\\\        200,\n        \\\\    },\n        \\\\    &[_]u16 {\n        \\\\        300,\n        \\\\        200,\n        \\\\    },\n        \\\\};\n        //\\\\pub const KeywordEnum = enum {\n        //\\\\    @\"0.8.1\",\n        //\\\\};\n        //\\\\pub const keyword_enum: KeywordEnum = KeywordEnum.@\"0.8.1\";\n        \\\\pub const semantic_version: @import(\"std\").SemanticVersion = .{\n        \\\\    .major = 0,\n        \\\\    .minor = 1,\n        \\\\    .patch = 2,\n        \\\\    .pre = \"foo\",\n        \\\\    .build = \"bar\",\n        \\\\};\n        \\\\\n    , options.contents.items);\n\n    _ = try std.zig.Ast.parse(arena.allocator(), try options.contents.toOwnedSliceSentinel(0), .zig);\n}",null,null,false],[19,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[19,0,0,null,null,null,null,false],[0,0,0,"generated_file",null,null,null,false],[19,0,0,null,null,null,null,false],[0,0,0,"contents",null,null,null,false],[19,0,0,null,null,null,null,false],[0,0,0,"args",null,null,null,false],[9,124,0,null,null,null,null,false],[0,0,0,"Step/RemoveDir.zig",null,"",[2173,2175],false],[20,0,0,null,null,null,null,false],[20,1,0,null,null,null,null,false],[20,2,0,null,null,null,null,false],[20,3,0,null,null,null,null,false],[20,5,0,null,null,null,null,false],[20,10,0,null,null,null,[2167,2168],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"dir_path",null,"",null,false],[20,22,0,null,null,null,[2170,2171],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[20,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[20,0,0,null,null,null,null,false],[0,0,0,"dir_path",null,null,null,false],[9,125,0,null,null,null,null,false],[0,0,0,"Step/Run.zig",null,"",[2402,2404,2406,2408,2410,2412,2414,2415,2416,2417,2418,2420,2422,2424,2425],false],[21,0,0,null,null,null,null,false],[21,1,0,null,null,null,null,false],[21,2,0,null,null,null,null,false],[21,3,0,null,null,null,null,false],[21,4,0,null,null,null,null,false],[21,5,0,null,null,null,null,false],[21,6,0,null,null,null,null,false],[21,7,0,null,null,null,null,false],[21,8,0,null,null,null,null,false],[21,9,0,null,null,null,null,false],[21,10,0,null,null,null,null,false],[21,12,0,null,null,null,null,false],[21,14,0,null,null,null,null,false],[21,83,0,null,null,null,[2192,2193,2194],false],[0,0,0,"none",null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"lazy_path",null,null,null,false],[21,89,0,null,null,null,[2202,2203,2204,2205],false],[21,113,0,null,null,null,[2197,2198,2199,2200,2201],false],[0,0,0,"expect_stderr_exact",null,null,null,false],[0,0,0,"expect_stderr_match",null,null,null,false],[0,0,0,"expect_stdout_exact",null,null,null,false],[0,0,0,"expect_stdout_match",null,null,null,false],[0,0,0,"expect_term",null,null,null,false],[0,0,0,"infer_from_args",null," Whether the Run step has side-effects will be determined by whether or not one\n of the args is an output file (added with `addOutputFileArg`).\n If the Run step is determined to have side-effects, this is the same as `inherit`.\n The step will fail if the subprocess crashes or returns a non-zero exit code.",null,false],[0,0,0,"inherit",null," Causes the Run step to be considered to have side-effects, and therefore\n always execute when it appears in the build graph.\n It also means that this step will obtain a global lock to prevent other\n steps from running in the meantime.\n The step will fail if the subprocess crashes or returns a non-zero exit code.",null,false],[0,0,0,"check",null," Causes the Run step to be considered to *not* have side-effects. The\n process will be re-executed if any of the input dependencies are\n modified. The exit code and standard I/O streams will be checked for\n certain conditions, and the step will succeed or fail based on these\n conditions.\n Note that an explicit check for exit code 0 needs to be added to this\n list if such a check is desirable.",null,false],[0,0,0,"zig_test",null," This Run step is running a zig unit test binary and will communicate\n extra metadata over the IPC protocol.",null,false],[21,122,0,null,null,null,[2207,2208,2209,2210,2211],false],[0,0,0,"artifact",null,null,null,false],[0,0,0,"lazy_path",null,null,null,false],[0,0,0,"directory_source",null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"output",null,null,null,false],[21,130,0,null,null,null,[2214,2216],false],[21,130,0,null,null,null,null,false],[0,0,0,"prefix",null,null,null,false],[21,130,0,null,null,null,null,false],[0,0,0,"lazy_path",null,null,null,false],[21,135,0,null,null,null,[2219,2221,2223],false],[21,135,0,null,null,null,null,false],[0,0,0,"generated_file",null,null,null,false],[21,135,0,null,null,null,null,false],[0,0,0,"prefix",null,null,null,false],[21,135,0,null,null,null,null,false],[0,0,0,"basename",null,null,null,false],[21,141,0,null,null,null,[2225,2226],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"name",null,"",null,false],[21,157,0,null,null,null,[2228,2229],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[21,162,0,null,null,null,[2231],false],[0,0,0,"self",null,"",null,false],[21,167,0,null,null,null,[2233,2234],false],[0,0,0,"self",null,"",null,false],[0,0,0,"artifact",null,"",null,false],[21,176,0,null,null," This provides file path as a command line argument to the command being\n run, and returns a LazyPath which can be used as inputs to other APIs\n throughout the build system.",[2236,2237],false],[0,0,0,"self",null,"",null,false],[0,0,0,"basename",null,"",null,false],[21,180,0,null,null,null,[2239,2240,2241],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[0,0,0,"basename",null,"",null,false],[21,203,0,null,null," deprecated: use `addFileArg`",null,false],[21,205,0,null,null,null,[2244,2245],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lp",null,"",null,false],[21,210,0,null,null,null,null,false],[21,212,0,null,null,null,[2248,2249,2250],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[0,0,0,"lp",null,"",null,false],[21,224,0,null,null," deprecated: use `addDirectoryArg`",null,false],[21,226,0,null,null,null,[2253,2254],false],[0,0,0,"self",null,"",null,false],[0,0,0,"directory_source",null,"",null,false],[21,231,0,null,null,null,null,false],[21,233,0,null,null,null,[2257,2258,2259],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[0,0,0,"directory_source",null,"",null,false],[21,247,0,null,null," Add a path argument to a dep file (.d) for the child process to write its\n discovered additional dependencies.\n Only one dep file argument is allowed by instance.",[2261,2262],false],[0,0,0,"self",null,"",null,false],[0,0,0,"basename",null,"",null,false],[21,254,0,null,null," Add a prefixed path argument to a dep file (.d) for the child process to\n write its discovered additional dependencies.\n Only one dep file argument is allowed by instance.",[2264,2265,2266],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[0,0,0,"basename",null,"",null,false],[21,271,0,null,null,null,[2268,2269],false],[0,0,0,"self",null,"",null,false],[0,0,0,"arg",null,"",null,false],[21,275,0,null,null,null,[2271,2272],false],[0,0,0,"self",null,"",null,false],[0,0,0,"args",null,"",null,false],[21,281,0,null,null,null,[2274,2275],false],[0,0,0,"self",null,"",null,false],[0,0,0,"stdin",null,"",null,false],[21,289,0,null,null,null,[2277],false],[0,0,0,"self",null,"",null,false],[21,296,0,null,null,null,[2279,2280],false],[0,0,0,"self",null,"",null,false],[0,0,0,"search_path",null,"",null,false],[21,311,0,null,null,null,[2282],false],[0,0,0,"self",null,"",null,false],[21,315,0,null,null,null,[2284],false],[0,0,0,"self",null,"",null,false],[21,325,0,null,null,null,[2286,2287,2288],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[21,331,0,null,null,null,[2290,2291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[21,336,0,null,null," Adds a check for exact stderr match. Does not add any other checks.",[2293,2294],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[21,343,0,null,null," Adds a check for exact stdout match as well as a check for exit code 0, if\n there is not already an expected termination check.",[2296,2297],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[21,351,0,null,null,null,[2299,2300],false],[0,0,0,"self",null,"",null,false],[0,0,0,"code",null,"",null,false],[21,356,0,null,null,null,[2302],false],[0,0,0,"self",null,"",null,false],[21,364,0,null,null,null,[2304,2305],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_check",null,"",null,false],[21,375,0,null,null,null,[2307],false],[0,0,0,"self",null,"",null,false],[21,390,0,null,null,null,[2309],false],[0,0,0,"self",null,"",null,false],[21,406,0,null,null," Returns whether the Run step has side effects *other than* updating the output arguments.",[2311],false],[0,0,0,"self",null,"",null,false],[21,416,0,null,null,null,[2313],false],[0,0,0,"self",null,"",null,false],[21,426,0,null,null,null,[2315],false],[0,0,0,"checks",null,"",null,false],[21,440,0,null,null,null,[2317],false],[0,0,0,"checks",null,"",null,false],[21,454,0,null,null,null,[2319,2320],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[21,596,0,null,null,null,[2322,2323,2324,2325],false],[0,0,0,"term",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[21,613,0,null,null,null,[2327],false],[0,0,0,"term",null,"",null,false],[21,617,0,null,null,null,[2329,2330],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[21,641,0,null,null,null,[2332,2333,2334,2335,2336],false],[0,0,0,"self",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"has_side_effects",null,"",null,false],[0,0,0,"digest",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[21,947,0,null,null,null,[2339,2340,2341,2343],false],[21,947,0,null,null,null,null,false],[0,0,0,"term",null,null,null,false],[0,0,0,"elapsed_ns",null,null,null,false],[0,0,0,"peak_rss",null,null,null,false],[21,947,0,null,null,null,null,false],[0,0,0,"stdio",null,null,null,false],[21,955,0,null,null,null,[2345,2346,2347,2348],false],[0,0,0,"self",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"has_side_effects",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[21,1018,0,null,null,null,[2351,2353,2355,2357],false],[21,1018,0,null,null,null,null,false],[0,0,0,"stdout",null,null,null,false],[21,1018,0,null,null,null,null,false],[0,0,0,"stderr",null,null,null,false],[21,1018,0,null,null,null,null,false],[0,0,0,"test_results",null,null,null,false],[21,1018,0,null,null,null,null,false],[0,0,0,"test_metadata",null,null,null,false],[21,1025,0,null,null,null,[2359,2360,2361],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[21,1170,0,null,null,null,[2367,2369,2371,2373,2374,2376],false],[21,1178,0,null,null,null,[2364,2365],false],[0,0,0,"tm",null,"",null,false],[0,0,0,"index",null,"",null,false],[21,1170,0,null,null,null,null,false],[0,0,0,"names",null,null,null,false],[21,1170,0,null,null,null,null,false],[0,0,0,"async_frame_lens",null,null,null,false],[21,1170,0,null,null,null,null,false],[0,0,0,"expected_panic_msgs",null,null,null,false],[21,1170,0,null,null,null,null,false],[0,0,0,"string_bytes",null,null,null,false],[0,0,0,"next_index",null,null,null,false],[21,1170,0,null,null,null,null,false],[0,0,0,"prog_node",null,null,null,false],[21,1183,0,null,null,null,[2378,2379,2380],false],[0,0,0,"in",null,"",null,false],[0,0,0,"metadata",null,"",null,false],[0,0,0,"sub_prog_node",null,"",null,false],[21,1202,0,null,null,null,[2382,2383],false],[0,0,0,"file",null,"",null,false],[0,0,0,"tag",null,"",null,false],[21,1210,0,null,null,null,[2385,2386],false],[0,0,0,"file",null,"",null,false],[0,0,0,"index",null,"",null,false],[21,1219,0,null,null,null,[2388,2389],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child",null,"",null,false],[21,1291,0,null,null,null,[2391,2392],false],[0,0,0,"self",null,"",null,false],[0,0,0,"artifact",null,"",null,false],[21,1306,0,null,null,null,[2394,2395,2396,2397],false],[0,0,0,"self",null,"",null,false],[0,0,0,"suggested_flag",null,"",null,false],[0,0,0,"argv0",null,"",null,false],[0,0,0,"exe",null,"",null,false],[21,1332,0,null,null,null,[2399,2400],false],[0,0,0,"hh",null,"",null,false],[0,0,0,"stdio",null,"",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[21,0,0,null,null,null,null,false],[0,0,0,"argv",null," See also addArg and addArgs to modifying this directly",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"cwd",null," Set this to modify the current working directory\n TODO change this to a Build.Cache.Directory to better integrate with\n future child process cwd API.",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"env_map",null," Override this field to modify the environment, or use setEnvironmentVariable",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"stdio",null," Configures whether the Run step is considered to have side-effects, and also\n whether the Run step will inherit stdio streams, forwarding them to the\n parent process, in which case will require a global lock to prevent other\n steps from interfering with stdio while the subprocess associated with this\n Run step is running.\n If the Run step is determined to not have side-effects, then execution will\n be skipped if all output files are up-to-date and input files are\n unchanged.",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"stdin",null," This field must be `.none` if stdio is `inherit`.\n It should be only set using `setStdIn`.",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"extra_file_dependencies",null," Additional file paths relative to build.zig that, when modified, indicate\n that the Run step should be re-executed.\n If the Run step is determined to have side-effects, this field is ignored\n and the Run step is always executed when it appears in the build graph.",null,false],[0,0,0,"rename_step_with_output_arg",null," After adding an output argument, this step will by default rename itself\n for a better display name in the build summary.\n This can be disabled by setting this to false.",null,false],[0,0,0,"skip_foreign_checks",null," If this is true, a Run step which is configured to check the output of the\n executed binary will not fail the build if the binary cannot be executed\n due to being for a foreign binary to the host system which is running the\n build graph.\n Command-line arguments such as -fqemu and -fwasmtime may affect whether a\n binary is detected as foreign, as well as system configuration such as\n Rosetta (macOS) and binfmt_misc (Linux).\n If this Run step is considered to have side-effects, then this flag does\n nothing.",null,false],[0,0,0,"failing_to_execute_foreign_is_an_error",null," If this is true, failing to execute a foreign binary will be considered an\n error. However if this is false, the step will be skipped on failure instead.\n\n This allows for a Run step to attempt to execute a foreign binary using an\n external executor (such as qemu) but not fail if the executor is unavailable.",null,false],[0,0,0,"max_stdio_size",null," If stderr or stdout exceeds this amount, the child process is killed and\n the step fails.",null,false],[21,0,0,null,null,null,null,false],[0,0,0,"captured_stdout",null,null,null,false],[21,0,0,null,null,null,null,false],[0,0,0,"captured_stderr",null,null,null,false],[21,0,0,null,null,null,null,false],[0,0,0,"dep_output_file",null,null,null,false],[0,0,0,"has_side_effects",null,null,null,false],[9,126,0,null,null,null,null,false],[0,0,0,"Step/TranslateC.zig",null,"",[2483,2485,2487,2489,2491,2493,2495,2497],false],[22,0,0,null,null,null,null,false],[22,1,0,null,null,null,null,false],[22,2,0,null,null,null,null,false],[22,3,0,null,null,null,null,false],[22,4,0,null,null,null,null,false],[22,6,0,null,null,null,null,false],[22,8,0,null,null,null,null,false],[22,19,0,null,null,null,[2437,2439,2441],false],[22,19,0,null,null,null,null,false],[0,0,0,"source_file",null,null,null,false],[22,19,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[22,19,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[22,25,0,null,null,null,[2443,2444],false],[0,0,0,"owner",null,"",null,false],[0,0,0,"options",null,"",null,false],[22,47,0,null,null,null,[2447,2449,2451,2453,2455],false],[22,47,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[22,47,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[22,47,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[22,47,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[22,47,0,null,null,null,null,false],[0,0,0,"linkage",null,null,null,false],[22,55,0,null,null,null,[2457],false],[0,0,0,"self",null,"",null,false],[22,60,0,null,null," Creates a step to build an executable from the translated source.",[2459,2460],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,false],[22,74,0,null,null," Creates a module from the translated source and adds it to the package's\n module set making it available to other packages which depend on this one.\n `createModule` can be used instead to create a private module.",[2462,2463],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[22,83,0,null,null," Creates a private module from the translated source to be used by the\n current package, but not exposed to other packages depending on this one.\n `addModule` can be used instead to create a public module.",[2465],false],[0,0,0,"self",null,"",null,false],[22,95,0,null,null,null,[2467,2468],false],[0,0,0,"self",null,"",null,false],[0,0,0,"include_dir",null,"",null,false],[22,99,0,null,null,null,[2470,2471],false],[0,0,0,"self",null,"",null,false],[0,0,0,"expected_matches",null,"",null,false],[22,109,0,null,null," If the value is omitted, it is set to 1.\n `name` and `value` need not live longer than the function call.",[2473,2474,2475],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[22,115,0,null,null," name_and_value looks like [name]=[value]. If the value is omitted, it is set to 1.",[2477,2478],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name_and_value",null,"",null,false],[22,119,0,null,null,null,[2480,2481],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[22,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"include_dirs",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"c_macros",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"out_basename",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[22,0,0,null,null,null,null,false],[0,0,0,"output_file",null,null,null,false],[9,127,0,null,null,null,null,false],[0,0,0,"Step/WriteFile.zig",null," WriteFile is primarily used to create a directory in an appropriate\n location inside the local cache which has a set of files that have either\n been generated during the build, or are copied from the source package.\n\n However, this step has an additional capability of writing data to paths\n relative to the package root, effectively mutating the package's source\n files. Be careful with the latter functionality; it should not be used\n during the normal build process, but as a utility run by a developer with\n intention to update source files, which will then be committed to version\n control.\n",[2552,2554,2556,2558],false],[23,10,0,null,null,null,null,false],[23,11,0,null,null,null,null,false],[23,12,0,null,null,null,null,false],[23,13,0,null,null,null,null,false],[23,14,0,null,null,null,null,false],[23,23,0,null,null,null,null,false],[23,25,0,null,null,null,[2511,2513,2515],false],[23,31,0,null,null," deprecated: use `getPath`",null,false],[23,33,0,null,null,null,[2509],false],[0,0,0,"self",null,"",null,false],[23,25,0,null,null,null,null,false],[0,0,0,"generated_file",null,null,null,false],[23,25,0,null,null,null,null,false],[0,0,0,"sub_path",null,null,null,false],[23,25,0,null,null,null,null,false],[0,0,0,"contents",null,null,null,false],[23,38,0,null,null,null,[2518,2520],false],[23,38,0,null,null,null,null,false],[0,0,0,"contents",null,null,null,false],[23,38,0,null,null,null,null,false],[0,0,0,"sub_path",null,null,null,false],[23,43,0,null,null,null,[2522,2523],false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"copy",null,null,null,false],[23,48,0,null,null,null,[2525],false],[0,0,0,"owner",null,"",null,false],[23,64,0,null,null,null,[2527,2528,2529],false],[0,0,0,"wf",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[23,85,0,null,null," Place the file into the generated directory within the local cache,\n along with all the rest of the files added to this step. The parameter\n here is the destination path relative to the local cache directory\n associated with this WriteFile. It may be a basename, or it may\n include sub-directories, in which case this step will ensure the\n required sub-path exists.\n This is the option expected to be used most commonly with `addCopyFile`.",[2531,2532,2533],false],[0,0,0,"wf",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[23,106,0,null,null," A path relative to the package root.\n Be careful with this because it updates source files. This should not be\n used as part of the normal build process, but as a utility occasionally\n run by a developer with intent to modify source files and then commit\n those changes to version control.",[2535,2536,2537],false],[0,0,0,"wf",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[23,120,0,null,null," A path relative to the package root.\n Be careful with this because it updates source files. This should not be\n used as part of the normal build process, but as a utility occasionally\n run by a developer with intent to modify source files and then commit\n those changes to version control.",[2539,2540,2541],false],[0,0,0,"wf",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[23,128,0,null,null,null,null,false],[23,130,0,null,null,null,null,false],[23,134,0,null,null," Returns a `LazyPath` representing the base directory that contains all the\n files from this `WriteFile`.",[2545],false],[0,0,0,"wf",null,"",null,false],[23,138,0,null,null,null,[2547],false],[0,0,0,"wf",null,"",null,false],[23,147,0,null,null,null,[2549,2550],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[23,0,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[23,0,0,null,null,null,null,false],[0,0,0,"files",null," The elements here are pointers because we need stable pointers for the\n GeneratedFile field.",null,false],[23,0,0,null,null,null,null,false],[0,0,0,"output_source_files",null,null,null,false],[23,0,0,null,null,null,null,false],[0,0,0,"generated_directory",null,null,null,false],[9,129,0,null,null,null,[2561,2563,2565,2567,2569,2570],false],[9,129,0,null,null,null,null,false],[0,0,0,"id",null,null,null,false],[9,129,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[9,129,0,null,null,null,null,false],[0,0,0,"owner",null,null,null,false],[9,129,0,null,null,null,null,false],[0,0,0,"makeFn",null,null,null,false],[9,129,0,null,null,null,null,false],[0,0,0,"first_ret_addr",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[9,138,0,null,null,null,[2572],false],[0,0,0,"options",null,"",null,false],[9,173,0,null,null," If the Step's `make` function reports `error.MakeFailed`, it indicates they\n have already reported the error. Otherwise, we add a simple error report\n here.",[2574,2575],false],[0,0,0,"s",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[9,198,0,null,null,null,[2577,2578],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[9,202,0,null,null,null,[2580],false],[0,0,0,"s",null,"",null,false],[9,214,0,null,null,null,[2582,2583],false],[0,0,0,"step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[9,226,0,null,null,null,[2585,2586],false],[0,0,0,"step",null,"",null,false],[0,0,0,"T",null,"",null,true],[9,234,0,null,null," For debugging purposes, prints identifying information about this Step.",[2588,2589],false],[0,0,0,"step",null,"",null,false],[0,0,0,"file",null,"",null,false],[9,259,0,null,null,null,null,false],[9,260,0,null,null,null,null,false],[9,261,0,null,null,null,null,false],[9,262,0,null,null,null,null,false],[9,263,0,null,null,null,null,false],[9,264,0,null,null,null,null,false],[9,266,0,null,null,null,[2597,2598],false],[0,0,0,"s",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,284,0,null,null,null,[2600,2601,2602],false],[0,0,0,"step",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[9,289,0,null,null,null,[2604,2605,2606],false],[0,0,0,"step",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[9,297,0,null,null," Assumes that argv contains `--listen=-` and that the process being spawned\n is the zig compiler - the same version that compiled the build runner.",[2608,2609,2610],false],[0,0,0,"s",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[9,433,0,null,null,null,[2612,2613],false],[0,0,0,"file",null,"",null,false],[0,0,0,"tag",null,"",null,false],[9,441,0,null,null,null,[2615,2616,2617],false],[0,0,0,"b",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,449,0,null,null,null,[2619,2620,2621,2622],false],[0,0,0,"b",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"opt_env",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,463,0,null,null,null,[2624,2625,2626],false],[0,0,0,"s",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,476,0,null,null,null,[2628,2629,2630,2631],false],[0,0,0,"s",null,"",null,false],[0,0,0,"term",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,501,0,null,null,null,[2633,2634,2635],false],[0,0,0,"arena",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,509,0,null,null,null,[2637,2638,2639,2640],false],[0,0,0,"arena",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"opt_env",null,"",null,false],[0,0,0,"argv",null,"",null,false],[9,535,0,null,null,null,[2642,2643],false],[0,0,0,"s",null,"",null,false],[0,0,0,"man",null,"",null,false],[9,540,0,null,null,null,[2645,2646,2647],false],[0,0,0,"s",null,"",null,false],[0,0,0,"man",null,"",null,false],[0,0,0,"err",null,"",null,false],[9,547,0,null,null,null,[2649,2650],false],[0,0,0,"s",null,"",null,false],[0,0,0,"man",null,"",null,false],[9,0,0,null,null,null,null,false],[0,0,0,"id",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"owner",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"makeFn",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"dependencies",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"dependants",null," This field is empty during execution of the user's build script, and\n then populated during dependency loop checking in the build runner.",null,false],[9,0,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"max_rss",null," Set this field to declare an upper bound on the amount of bytes of memory it will\n take to run the step. Zero means no limit.\n\n The idea to annotate steps that might use a high amount of RAM with an\n upper bound. For example, perhaps a particular set of unit tests require 4\n GiB of RAM, and those tests will be run under 4 different build\n configurations at once. This would potentially require 16 GiB of memory on\n the system if all 4 steps executed simultaneously, which could easily be\n greater than what is actually available, potentially causing the system to\n crash when using `zig build` at the default concurrency level.\n\n This field causes the build runner to do two things:\n 1. ulimit child processes, so that they will fail if it would exceed this\n memory limit. This serves to enforce that this upper bound value is\n correct.\n 2. Ensure that the set of concurrent steps at any given time have a total\n max_rss value that does not exceed the `max_total_rss` value of the build\n runner. This value is configurable on the command line, and defaults to the\n total system memory available.",null,false],[9,0,0,null,null,null,null,false],[0,0,0,"result_error_msgs",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"result_error_bundle",null,null,null,false],[0,0,0,"result_cached",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"result_duration_ns",null,null,null,false],[0,0,0,"result_peak_rss",null," 0 means unavailable or not reported.",null,false],[9,0,0,null,null,null,null,false],[0,0,0,"test_results",null,null,null,false],[9,0,0,null,null,null,null,false],[0,0,0,"debug_stack_trace",null," The return address associated with creation of this step that can be useful\n to print along with debugging messages.",null,false],[5,32,0,null,null," deprecated: use `Step.CheckFile`.",null,false],[5,34,0,null,null," deprecated: use `Step.CheckObject`.",null,false],[5,36,0,null,null," deprecated: use `Step.ConfigHeader`.",null,false],[5,38,0,null,null," deprecated: use `Step.Fmt`.",null,false],[5,40,0,null,null," deprecated: use `Step.InstallArtifact`.",null,false],[5,42,0,null,null," deprecated: use `Step.InstallDir`.",null,false],[5,44,0,null,null," deprecated: use `Step.InstallFile`.",null,false],[5,46,0,null,null," deprecated: use `Step.ObjCopy`.",null,false],[5,48,0,null,null," deprecated: use `Step.Compile`.",null,false],[5,50,0,null,null," deprecated: use `Step.Options`.",null,false],[5,52,0,null,null," deprecated: use `Step.RemoveDir`.",null,false],[5,54,0,null,null," deprecated: use `Step.Run`.",null,false],[5,56,0,null,null," deprecated: use `Step.TranslateC`.",null,false],[5,58,0,null,null," deprecated: use `Step.WriteFile`.",null,false],[5,60,0,null,null," deprecated: use `LazyPath`.",null,false],[5,137,0,null,null,null,[2695,2697],false],[5,137,0,null,null,null,null,false],[0,0,0,"",null,null,null,false],[5,137,0,null,null,null,null,false],[0,0,0,"",null,null,null,false],[5,139,0,null,null,null,null,false],[5,140,0,null,null,null,[2701,2703],false],[5,140,0,null,null,null,null,false],[0,0,0,"build_root_string",null,null,null,false],[5,140,0,null,null,null,null,false],[0,0,0,"user_input_options",null,null,null,false],[5,145,0,null,null,null,[2713],false],[5,148,0,null,null,null,[2706,2707],false],[0,0,0,"self",null,"",null,false],[0,0,0,"k",null,"",null,false],[5,155,0,null,null,null,[2709,2710,2711],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[5,145,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[5,174,0,null,null,null,null,false],[5,181,0,null,null,null,null,false],[5,188,0,null,null,null,[2718,2720],false],[5,188,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,188,0,null,null,null,null,false],[0,0,0,"desc",null,null,null,false],[5,193,0,null,null,null,[2722,2723,2724],false],[0,0,0,"C89",null,null,null,false],[0,0,0,"C99",null,null,null,false],[0,0,0,"C11",null,null,null,false],[5,199,0,null,null,null,null,false],[5,200,0,null,null,null,null,false],[5,202,0,null,null,null,[2729,2731,2733,2735],false],[5,202,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,202,0,null,null,null,null,false],[0,0,0,"type_id",null,null,null,false],[5,202,0,null,null,null,null,false],[0,0,0,"description",null,null,null,false],[5,202,0,null,null,null,null,false],[0,0,0,"enum_options",null," If the `type_id` is `enum` this provides the list of enum options",null,false],[5,210,0,null,null,null,[2738,2740,2741],false],[5,210,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,210,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[0,0,0,"used",null,null,null,false],[5,216,0,null,null,null,[2743,2744,2745,2746],false],[0,0,0,"flag",null,null,null,false],[0,0,0,"scalar",null,null,null,false],[0,0,0,"list",null,null,null,false],[0,0,0,"map",null,null,null,false],[5,223,0,null,null,null,[2748,2749,2750,2751,2752,2753,2754],false],[0,0,0,"bool",null,null,null,false],[0,0,0,"int",null,null,null,false],[0,0,0,"float",null,null,null,false],[0,0,0,"enum",null,null,null,false],[0,0,0,"string",null,null,null,false],[0,0,0,"list",null,null,null,false],[0,0,0,"build_id",null,null,null,false],[5,233,0,null,null,null,[2758,2760],false],[5,234,0,null,null,null,null,false],[5,233,0,null,null,null,null,false],[0,0,0,"step",null,null,null,false],[5,233,0,null,null,null,null,false],[0,0,0,"description",null,null,null,false],[5,240,0,null,null,null,[2763,2765,2767],false],[5,240,0,null,null,null,null,false],[0,0,0,"lib_dir",null,null,null,false],[5,240,0,null,null,null,null,false],[0,0,0,"exe_dir",null,null,null,false],[5,240,0,null,null,null,null,false],[0,0,0,"include_dir",null,null,null,false],[5,246,0,null,null,null,[2769,2770,2771,2772,2773,2774,2775,2776],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"zig_exe",null,"",null,false],[0,0,0,"build_root",null,"",null,false],[0,0,0,"cache_root",null,"",null,false],[0,0,0,"global_cache_root",null,"",null,false],[0,0,0,"host",null,"",null,false],[0,0,0,"cache",null,"",null,false],[0,0,0,"available_deps",null,"",null,false],[5,323,0,null,null,null,[2778,2779,2780,2781,2782],false],[0,0,0,"parent",null,"",null,false],[0,0,0,"dep_name",null,"",null,false],[0,0,0,"build_root",null,"",null,false],[0,0,0,"pkg_deps",null,"",null,false],[0,0,0,"user_input_options",null,"",null,false],[5,335,0,null,null,null,[2784,2785,2786,2787,2788],false],[0,0,0,"parent",null,"",null,false],[0,0,0,"dep_name",null,"",null,false],[0,0,0,"build_root",null,"",null,false],[0,0,0,"pkg_deps",null,"",null,false],[0,0,0,"user_input_options",null,"",null,false],[5,410,0,null,null,null,[2790,2791],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"args",null,"",null,false],[5,470,0,null,null,null,[2811,2812,2813,2814],false],[5,476,0,null,null,null,[2799,2801],false],[5,479,0,null,null,null,[2795,2796,2797],false],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[5,476,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,476,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[5,484,0,null,null,null,[2803,2804],false],[0,0,0,"self",null,"",null,false],[0,0,0,"hasher",null,"",null,false],[5,498,0,null,null,null,[2806,2807],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"unordered",null,"",null,false],[5,512,0,null,null,null,[2809,2810],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"unordered",null,"",null,false],[0,0,0,"flag",null,null,null,false],[0,0,0,"scalar",null,null,null,false],[0,0,0,"list",null,null,null,false],[0,0,0,"map",null,null,null,false],[5,522,0,null,null,null,[2827,2829,2830],false],[5,527,0,null,null,null,[2817,2818],false],[0,0,0,"self",null,"",null,false],[0,0,0,"hasher",null,"",null,false],[5,532,0,null,null,null,[2820,2821],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"user_input_option",null,"",null,false],[5,540,0,null,null,null,[2823,2824,2825],false],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[5,522,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,522,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[0,0,0,"used",null,null,null,false],[5,547,0,null,null,null,[2832,2833,2834],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"user_input_options",null,"",null,false],[0,0,0,"hasher",null,"",null,false],[5,560,0,null,null,null,[2836],false],[0,0,0,"b",null,"",null,false],[5,578,0,null,null,null,[2838],false],[0,0,0,"b",null,"",null,false],[5,585,0,null,null," This function is intended to be called by lib/build_runner.zig, not a build.zig file.",[2840,2841,2842],false],[0,0,0,"self",null,"",null,false],[0,0,0,"install_prefix",null,"",null,false],[0,0,0,"dir_list",null,"",null,false],[5,619,0,null,null,null,[2844],false],[0,0,0,"self",null,"",null,false],[5,623,0,null,null,null,[2847,2849,2851,2853,2855,2857,2858,2860,2862,2864,2866,2868,2870],false],[5,623,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"root_source_file",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"linkage",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,623,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null,null,null,false],[5,639,0,null,null,null,[2872,2873],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,658,0,null,null,null,[2876,2878,2880,2882,2883,2885,2887,2889,2891,2893,2895],false],[5,658,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"root_source_file",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,658,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null,null,null,false],[5,672,0,null,null,null,[2897,2898],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,689,0,null,null,null,[2901,2903,2905,2907,2909,2910,2912,2914,2916,2918,2920,2922],false],[5,689,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"root_source_file",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,689,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null,null,null,false],[5,704,0,null,null,null,[2924,2925],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,723,0,null,null,null,[2928,2930,2932,2934,2936,2937,2939,2941,2943,2945,2947,2949],false],[5,723,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"root_source_file",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,723,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null,null,null,false],[5,738,0,null,null,null,[2951,2952],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,757,0,null,null,null,[2955,2957,2959,2961,2963,2964,2966,2968,2970,2972,2974,2976,2978,2980],false],[5,757,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"root_source_file",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"filter",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"test_runner",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"single_threaded",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"use_llvm",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"use_lld",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,757,0,null,null,null,null,false],[0,0,0,"main_pkg_path",null,null,null,false],[5,774,0,null,null,null,[2982,2983],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,793,0,null,null,null,[2986,2988,2990,2992,2993,2995],false],[5,793,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,793,0,null,null,null,null,false],[0,0,0,"source_file",null,null,null,false],[5,793,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[5,793,0,null,null,null,null,false],[0,0,0,"optimize",null,null,null,false],[0,0,0,"max_rss",null,null,null,false],[5,793,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,802,0,null,null,null,[2997,2998],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,819,0,null,null," This function creates a module and adds it to the package's module set, making\n it available to other packages which depend on this one.\n `createModule` can be used instead to create a private module.",[3000,3001,3002],false],[0,0,0,"b",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,825,0,null,null,null,[3005,3007],false],[5,825,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[5,825,0,null,null,null,null,false],[0,0,0,"module",null,null,null,false],[5,830,0,null,null,null,[3010,3012],false],[5,830,0,null,null,null,null,false],[0,0,0,"source_file",null,null,null,false],[5,830,0,null,null,null,null,false],[0,0,0,"dependencies",null,null,null,false],[5,838,0,null,null," This function creates a private module, to be used by the current package,\n but not exposed to other packages depending on this one.\n `addModule` can be used instead to create a public module.",[3014,3015],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,848,0,null,null,null,[3017,3018],false],[0,0,0,"arena",null,"",null,false],[0,0,0,"deps",null,"",null,false],[5,861,0,null,null," Initializes a `Step.Run` with argv, which must at least have the path to the\n executable. More command line arguments can be added with `addArg`,\n `addArgs`, and `addArtifactArg`.\n Be careful using this function, as it introduces a system dependency.\n To run an executable built with zig build, see `Step.Compile.run`.",[3020,3021],false],[0,0,0,"self",null,"",null,false],[0,0,0,"argv",null,"",null,false],[5,870,0,null,null," Creates a `Step.Run` with an executable built with `addExecutable`.\n Add command line arguments with methods of `Step.Run`.",[3023,3024],false],[0,0,0,"b",null,"",null,false],[0,0,0,"exe",null,"",null,false],[5,893,0,null,null," Using the `values` provided, produces a C header file, possibly based on a\n template input file (e.g. config.h.in).\n When an input template file is provided, this function will fail the build\n when an option not found in the input file is provided in `values`, and\n when an option found in the input file is missing from `values`.",[3026,3027,3028],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"values",null,"",null,false],[5,908,0,null,null," Allocator.dupe without the need to handle out of memory.",[3030,3031],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[5,913,0,null,null," Duplicates an array of strings without the need to handle out of memory.",[3033,3034],false],[0,0,0,"self",null,"",null,false],[0,0,0,"strings",null,"",null,false],[5,922,0,null,null," Duplicates a path and converts all slashes to the OS's canonical path separator.",[3036,3037],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[5,933,0,null,null,null,[3039,3040,3041],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"data",null,"",null,false],[5,939,0,null,null,null,[3043],false],[0,0,0,"b",null,"",null,false],[5,943,0,null,null,null,[3045,3046],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dir_path",null,"",null,false],[5,949,0,null,null,null,[3048,3049],false],[0,0,0,"b",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,953,0,null,null,null,[3051,3052],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,957,0,null,null,null,[3054],false],[0,0,0,"self",null,"",null,false],[5,961,0,null,null,null,[3056],false],[0,0,0,"self",null,"",null,false],[5,965,0,null,null,null,[3058,3059],false],[0,0,0,"uninstall_step",null,"",null,false],[0,0,0,"prog_node",null,"",null,false],[5,981,0,null,null,null,[3061,3062,3063,3064],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"name_raw",null,"",null,false],[0,0,0,"description_raw",null,"",null,false],[5,1133,0,null,null,null,[3066,3067,3068],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"description",null,"",null,false],[5,1152,0,null,null,null,[3071],false],[5,1152,0,null,null,null,null,false],[0,0,0,"preferred_optimize_mode",null,null,null,false],[5,1156,0,null,null,null,[3073,3074],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,1172,0,null,null,null,[3077,3079],false],[5,1172,0,null,null,null,null,false],[0,0,0,"whitelist",null,null,null,false],[5,1172,0,null,null,null,null,false],[0,0,0,"default_target",null,null,null,false],[5,1179,0,null,null," Exposes standard `zig build` options for choosing a target.",[3081,3082],false],[0,0,0,"self",null,"",null,false],[0,0,0,"args",null,"",null,false],[5,1310,0,null,null,null,[3084,3085,3086],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name_raw",null,"",null,false],[0,0,0,"value_raw",null,"",null,false],[5,1358,0,null,null,null,[3088,3089],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name_raw",null,"",null,false],[5,1385,0,null,null,null,[3091],false],[0,0,0,"T",null,"",null,true],[5,1402,0,null,null,null,[3093],false],[0,0,0,"self",null,"",null,false],[5,1406,0,null,null,null,[3095],false],[0,0,0,"self",null,"",null,false],[5,1419,0,null,null,null,[3097,3098,3099],false],[0,0,0,"ally",null,"",null,false],[0,0,0,"opt_cwd",null,"",null,false],[0,0,0,"argv",null,"",null,false],[5,1428,0,null,null,null,[3101,3102,3103],false],[0,0,0,"ally",null,"",null,false],[0,0,0,"cwd",null,"",null,false],[0,0,0,"argv",null,"",null,false],[5,1436,0,null,null," This creates the install step and adds it to the dependencies of the\n top-level install step, using all the default options.\n See `addInstallArtifact` for a more flexible function.",[3105,3106],false],[0,0,0,"self",null,"",null,false],[0,0,0,"artifact",null,"",null,false],[5,1442,0,null,null," This merely creates the step; it does not add it to the dependencies of the\n top-level install step.",[3108,3109,3110],false],[0,0,0,"self",null,"",null,false],[0,0,0,"artifact",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,1451,0,null,null,"`dest_rel_path` is relative to prefix path",[3112,3113,3114],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1455,0,null,null,null,[3116,3117],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,1460,0,null,null,"`dest_rel_path` is relative to bin path",[3119,3120,3121],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1465,0,null,null,"`dest_rel_path` is relative to lib path",[3123,3124,3125],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1469,0,null,null,null,[3127,3128,3129],false],[0,0,0,"b",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,1474,0,null,null,"`dest_rel_path` is relative to install prefix path",[3131,3132,3133],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1479,0,null,null,"`dest_rel_path` is relative to bin path",[3135,3136,3137],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1484,0,null,null,"`dest_rel_path` is relative to lib path",[3139,3140,3141],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1488,0,null,null,null,[3143,3144,3145],false],[0,0,0,"b",null,"",null,false],[0,0,0,"src_path",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1492,0,null,null,null,[3147,3148,3149,3150],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"install_dir",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1501,0,null,null,null,[3152,3153],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,1505,0,null,null,null,[3155,3156,3157],false],[0,0,0,"b",null,"",null,false],[0,0,0,"file_source",null,"",null,false],[0,0,0,"options",null,"",null,false],[5,1514,0,null,null," deprecated: https://github.com/ziglang/zig/issues/14943",[3159,3160,3161],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1522,0,null,null,null,[3163,3164],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[5,1539,0,null,null,null,[3166,3167],false],[0,0,0,"b",null,"",null,false],[0,0,0,"p",null,"",null,false],[5,1543,0,null,null,null,[3169,3170],false],[0,0,0,"b",null,"",null,false],[0,0,0,"p",null,"",null,false],[5,1548,0,null,null,null,[3172,3173],false],[0,0,0,"self",null,"",null,false],[0,0,0,"paths",null,"",null,false],[5,1552,0,null,null,null,[3175,3176,3177],false],[0,0,0,"self",null,"",null,false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[5,1556,0,null,null,null,[3179,3180,3181],false],[0,0,0,"self",null,"",null,false],[0,0,0,"names",null,"",null,false],[0,0,0,"paths",null,"",null,false],[5,1602,0,null,null,null,[3183,3184,3185,3186],false],[0,0,0,"self",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"out_code",null,"",null,false],[0,0,0,"stderr_behavior",null,"",null,false],[5,1646,0,null,null," This is a helper function to be called from build.zig scripts, *not* from\n inside step make() functions. If any errors occur, it fails the build with\n a helpful message.",[3188,3189],false],[0,0,0,"b",null,"",null,false],[0,0,0,"argv",null,"",null,false],[5,1664,0,null,null,null,[3191,3192],false],[0,0,0,"self",null,"",null,false],[0,0,0,"search_prefix",null,"",null,false],[5,1668,0,null,null,null,[3194,3195,3196],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"dest_rel_path",null,"",null,false],[5,1683,0,null,null,null,[3205],false],[5,1686,0,null,null,null,[3199,3200],false],[0,0,0,"d",null,"",null,false],[0,0,0,"name",null,"",null,false],[5,1704,0,null,null,null,[3202,3203],false],[0,0,0,"d",null,"",null,false],[0,0,0,"name",null,"",null,false],[5,1683,0,null,null,null,null,false],[0,0,0,"builder",null,null,null,false],[5,1711,0,null,null,null,[3207,3208,3209],false],[0,0,0,"b",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"args",null,"",null,false],[5,1733,0,null,null,null,[3211,3212,3213,3214],false],[0,0,0,"b",null,"",null,false],[0,0,0,"relative_build_root",null," The path to the directory containing the dependency's build.zig file,\n relative to the current package's build.zig.",null,false],[0,0,0,"build_zig",null," A direct `@import` of the build.zig of the dependency.\n",null,true],[0,0,0,"args",null,"",null,false],[5,1752,0,null,null,null,[3216,3217],false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[5,1799,0,null,null,null,[3219,3220,3221,3222,3223,3224],false],[0,0,0,"b",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"build_root_string",null,"",null,false],[0,0,0,"build_zig",null,"",null,true],[0,0,0,"pkg_deps",null,"",null,false],[0,0,0,"args",null,"",null,false],[5,1840,0,null,null,null,[3226,3227],false],[0,0,0,"b",null,"",null,false],[0,0,0,"build_zig",null,"",null,false],[5,1848,0,null,null,null,[3230,3232,3234],false],[5,1848,0,null,null,null,null,false],[0,0,0,"builder",null,null,null,false],[5,1848,0,null,null,null,null,false],[0,0,0,"source_file",null," This could either be a generated file, in which case the module\n contains exactly one file, or it could be a path to the root source\n file of directory of files which constitute the module.",null,false],[5,1848,0,null,null,null,null,false],[0,0,0,"dependencies",null,null,null,false],[5,1859,0,null,null," A file that is generated by a build step.\n This struct is an interface that is meant to be used with `@fieldParentPtr` to implement the actual path logic.",[3239,3241],false],[5,1867,0,null,null,null,[3237],false],[0,0,0,"self",null,"",null,false],[5,1859,0,null,null,null,null,false],[0,0,0,"step",null," The step that generates the file",null,false],[5,1859,0,null,null,null,null,false],[0,0,0,"path",null," The path to the generated file. Must be either absolute or relative to the build root.\n This value must be set in the `fn make()` of the `step` and must not be `null` afterwards.",null,false],[5,1876,0,null,null," A reference to an existing or future path.",[3260,3261,3262],false],[5,1896,0,null,null," Returns a new file source that will have a relative path to the build root guaranteed.\n Asserts the parameter is not an absolute path.",[3244],false],[0,0,0,"path",null,"",null,false],[5,1903,0,null,null," Returns a string that can be shown to represent the file source.\n Either returns the path or `\"generated\"`.",[3246],false],[0,0,0,"self",null,"",null,false],[5,1911,0,null,null," Adds dependencies this file source implies to the given step.",[3248,3249],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other_step",null,"",null,false],[5,1920,0,null,null," Returns an absolute path.\n Intended to be used during the make phase only.",[3251,3252],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src_builder",null,"",null,false],[5,1929,0,null,null," Returns an absolute path.\n Intended to be used during the make phase only.\n\n `asking_step` is only used for debugging purposes; it's the step being\n run that is asking for the path.",[3254,3255,3256],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src_builder",null,"",null,false],[0,0,0,"asking_step",null,"",null,false],[5,1943,0,null,null," Duplicates the file source for a given builder.",[3258,3259],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"path",null," A source file path relative to build root.\n This should not be an absolute path, but in an older iteration of the zig build\n system API, it was allowed to be absolute. Absolute paths should use `cwd_relative`.",null,false],[0,0,0,"generated",null," A file that is generated by an interface. Those files usually are\n not available until built by a build step.",null,false],[0,0,0,"cwd_relative",null," An absolute path or a path relative to the current working directory of\n the build runner process.\n This is uncommon but used for system environment paths such as `--zig-lib-dir` which\n ignore the file system path of build.zig and instead are relative to the directory from\n which `zig build` was invoked.\n Use of this tag indicates a dependency on the host system.",null,false],[5,1953,0,null,null," In this function the stderr mutex has already been locked.",[3264,3265,3266,3267],false],[0,0,0,"s",null,"",null,false],[0,0,0,"stderr",null,"",null,false],[0,0,0,"src_builder",null,"",null,false],[0,0,0,"asking_step",null,"",null,false],[5,1991,0,null,null," Allocates a new string for assigning a value to a named macro.\n If the value is omitted, it is set to 1.\n `name` and `value` need not live longer than the function call.",[3269,3270,3271],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[5,2004,0,null,null,null,[3273,3274,3275],false],[0,0,0,"unattempted",null,null,null,false],[0,0,0,"not_found",null,null,null,false],[0,0,0,"found",null,null,null,false],[5,2010,0,null,null,null,[3277,3278,3279],false],[0,0,0,"unattempted",null,null,null,false],[0,0,0,"not_found",null,null,null,false],[0,0,0,"found",null,null,null,false],[5,2016,0,null,null,null,[3284,3285,3286,3287,3288],false],[5,2025,0,null,null," Duplicates the install directory including the path if set to custom.",[3282,3283],false],[0,0,0,"self",null,"",null,false],[0,0,0,"builder",null,"",null,false],[0,0,0,"prefix",null,null,null,false],[0,0,0,"lib",null,null,null,false],[0,0,0,"bin",null,null,null,false],[0,0,0,"header",null,null,null,false],[0,0,0,"custom",null," A path relative to the prefix",null,false],[5,2034,0,null,null,null,[3294,3296],false],[5,2039,0,null,null," Duplicates the installed file path and directory.",[3291,3292],false],[0,0,0,"self",null,"",null,false],[0,0,0,"builder",null,"",null,false],[5,2034,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[5,2034,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[5,2047,0,null,null,null,[3298,3299],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"cpu",null,"",null,false],[5,2079,0,null,null," This function is intended to be called in the `configure` phase only.\n It returns an absolute directory path, which is potentially going to be a\n source of API breakage in the future, so keep that in mind when using this\n function.",[3301],false],[0,0,0,"b",null,"",null,false],[5,2093,0,null,null," There are a few copies of this function in miscellaneous places. Would be nice to find\n a home for them.",[3303],false],[0,0,0,"x",null,"",null,false],[5,0,0,null,null,null,null,false],[0,0,0,"install_tls",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"uninstall_tls",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"user_input_options",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"available_options_map",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"available_options_list",null,null,null,false],[0,0,0,"verbose",null,null,null,false],[0,0,0,"verbose_link",null,null,null,false],[0,0,0,"verbose_cc",null,null,null,false],[0,0,0,"verbose_air",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"verbose_llvm_ir",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"verbose_llvm_bc",null,null,null,false],[0,0,0,"verbose_cimport",null,null,null,false],[0,0,0,"verbose_llvm_cpu_features",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"reference_trace",null,null,null,false],[0,0,0,"invalid_user_input",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"zig_exe",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"default_step",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"env_map",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"top_level_steps",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"install_prefix",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"dest_dir",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"lib_dir",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"exe_dir",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"h_dir",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"install_path",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"sysroot",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"search_prefixes",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"libc_file",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"installed_files",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"build_root",null," Path to the directory containing build.zig.",null,false],[5,0,0,null,null,null,null,false],[0,0,0,"cache_root",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"global_cache_root",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"cache",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"zig_lib_dir",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"vcpkg_root",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"pkg_config_pkg_list",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"args",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"debug_log_scopes",null,null,null,false],[0,0,0,"debug_compile_errors",null,null,null,false],[0,0,0,"debug_pkg_config",null,null,null,false],[0,0,0,"debug_stack_frames_count",null," Number of stack frames captured when a `StackTrace` is recorded for debug purposes,\n in particular at `Step` creation.\n Set to 0 to disable stack collection.",null,false],[0,0,0,"enable_darling",null," Experimental. Use system Darling installation to run cross compiled macOS build artifacts.",null,false],[0,0,0,"enable_qemu",null," Use system QEMU installation to run cross compiled foreign architecture build artifacts.",null,false],[0,0,0,"enable_rosetta",null," Darwin. Use Rosetta to run x86_64 macOS build artifacts on arm64 macOS.",null,false],[0,0,0,"enable_wasmtime",null," Use system Wasmtime installation to run cross compiled wasm/wasi build artifacts.",null,false],[0,0,0,"enable_wine",null," Use system Wine installation to run cross compiled Windows build artifacts.",null,false],[5,0,0,null,null,null,null,false],[0,0,0,"glibc_runtimes_dir",null," After following the steps in https://github.com/ziglang/zig/wiki/Updating-libc#glibc,\n this will be the directory $glibc-build-dir/install/glibcs\n Given the example of the aarch64 target, this is the directory\n that contains the path `aarch64-linux-gnu/lib/ld-linux-aarch64.so.1`.",null,false],[5,0,0,null,null,null,null,false],[0,0,0,"host",null," Information about the native target. Computed before build() is invoked.",null,false],[5,0,0,null,null,null,null,false],[0,0,0,"dep_prefix",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"modules",null,null,null,false],[5,0,0,null,null,null,null,false],[0,0,0,"initialized_deps",null," A map from build root dirs to the corresponding `*Dependency`. This is shared with all child\n `Build`s.",null,false],[5,0,0,null,null,null,null,false],[0,0,0,"available_deps",null," A mapping from dependency names to package hashes.",null,false],[1,14,0,null,null,null,null,false],[0,0,0,"buf_map.zig",null,"",[],false],[24,0,0,null,null,null,null,false],[24,1,0,null,null,null,null,false],[24,2,0,null,null,null,null,false],[24,3,0,null,null,null,null,false],[24,4,0,null,null,null,null,false],[24,8,0,null,null," BufMap copies keys and values before they go into the map and\n frees them when they get removed.",[3436],false],[24,11,0,null,null,null,null,false],[24,16,0,null,null," Create a BufMap backed by a specific allocator.\n That allocator will be used for both backing allocations\n and string deduplication.",[3405],false],[0,0,0,"allocator",null,"",null,false],[24,23,0,null,null," Free the backing storage of the map, as well as all\n of the stored keys and values.",[3407],false],[0,0,0,"self",null,"",null,false],[24,36,0,null,null," Same as `put` but the key and value become owned by the BufMap rather\n than being copied.\n If `putMove` fails, the ownership of key and value does not transfer.",[3409,3410,3411],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[24,47,0,null,null," `key` and `value` are copied into the BufMap.",[3413,3414,3415],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[24,64,0,null,null," Find the address of the value associated with a key.\n The returned pointer is invalidated if the map resizes.",[3417,3418],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[24,71,0,null,null," Return the map's copy of the value associated with\n a key.  The returned string is invalidated if this\n key is removed from the map.",[3420,3421],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[24,77,0,null,null," Removes the item from the map and frees its value.\n This invalidates the value returned by get() for this key.",[3423,3424],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[24,84,0,null,null," Returns the number of KV pairs stored in the map.",[3426],false],[0,0,0,"self",null,"",null,false],[24,89,0,null,null," Returns an iterator over entries in the map.",[3428],false],[0,0,0,"self",null,"",null,false],[24,93,0,null,null,null,[3430,3431],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[24,97,0,null,null,null,[3433,3434],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[24,8,0,null,null,null,null,false],[0,0,0,"hash_map",null,null,null,false],[1,15,0,null,null,null,null,false],[0,0,0,"buf_set.zig",null,"",[],false],[25,0,0,null,null,null,null,false],[25,1,0,null,null,null,null,false],[25,2,0,null,null,null,null,false],[0,0,0,"mem.zig",null,"",[],false],[26,0,0,null,null,null,null,false],[26,1,0,null,null,null,null,false],[26,2,0,null,null,null,null,false],[26,3,0,null,null,null,null,false],[26,4,0,null,null,null,null,false],[26,5,0,null,null,null,null,false],[26,6,0,null,null,null,null,false],[26,7,0,null,null,null,null,false],[26,8,0,null,null,null,null,false],[26,9,0,null,null,null,null,false],[26,10,0,null,null,null,null,false],[26,14,0,null,null," Compile time known minimum page size.\n https://github.com/ziglang/zig/issues/4082",null,false],[26,30,0,null,null," The standard library currently thoroughly depends on byte size\n being 8 bits.  (see the use of u8 throughout allocation code as\n the \"byte\" type.)  Code which depends on this can reference this\n declaration.  If we ever try to port the standard library to a\n non-8-bit-byte platform, this will allow us to search for things\n which need to be updated.",null,false],[26,32,0,null,null,null,null,false],[0,0,0,"mem/Allocator.zig",null," The standard memory allocation interface.\n",[3594,3596],false],[27,2,0,null,null,null,null,false],[27,3,0,null,null,null,null,false],[27,4,0,null,null,null,null,false],[27,5,0,null,null,null,null,false],[27,6,0,null,null,null,null,false],[27,7,0,null,null,null,null,false],[27,9,0,null,null,null,null,false],[27,10,0,null,null,null,null,false],[27,16,0,null,null,null,[3472,3479,3485],false],[27,16,0,null,null,null,[3468,3469,3470,3471],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"alloc",null," Attempt to allocate exactly `len` bytes aligned to `1 << ptr_align`.\n\n `ret_addr` is optionally provided as the first return address of the\n allocation call stack. If the value is `0` it means no return address\n has been provided.",null,false],[27,16,0,null,null,null,[3474,3475,3476,3477,3478],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"resize",null," Attempt to expand or shrink memory in place. `buf.len` must equal the\n length requested from the most recent successful call to `alloc` or\n `resize`. `buf_align` must equal the same value that was passed as the\n `ptr_align` parameter to the original `alloc` call.\n\n A result of `true` indicates the resize was successful and the\n allocation now has the same address but a size of `new_len`. `false`\n indicates the resize could not be completed without moving the\n allocation to a different address.\n\n `new_len` must be greater than zero.\n\n `ret_addr` is optionally provided as the first return address of the\n allocation call stack. If the value is `0` it means no return address\n has been provided.",null,false],[27,16,0,null,null,null,[3481,3482,3483,3484],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buf_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"free",null," Free and invalidate a buffer.\n\n `buf.len` must equal the most recent length returned by `alloc` or\n given to a successful `resize` call.\n\n `buf_align` must equal the same value that was passed as the\n `ptr_align` parameter to the original `alloc` call.\n\n `ret_addr` is optionally provided as the first return address of the\n allocation call stack. If the value is `0` it means no return address\n has been provided.",null,false],[27,55,0,null,null,null,[3487,3488,3489,3490,3491],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[27,70,0,null,null,null,[3493,3494,3495,3496],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[27,84,0,null,null," This function is not intended to be called except from within the\n implementation of an Allocator",[3498,3499,3500,3501],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[27,90,0,null,null," This function is not intended to be called except from within the\n implementation of an Allocator",[3503,3504,3505,3506,3507],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[27,96,0,null,null," This function is not intended to be called except from within the\n implementation of an Allocator",[3509,3510,3511,3512],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[27,102,0,null,null," Returns a pointer to undefined memory.\n Call `destroy` with the result to free the memory.",[3514,3515],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[27,110,0,null,null," `ptr` should be the return value of `create`, or otherwise\n have the same address and alignment property.",[3517,3518],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ptr",null,"",null,false],[27,127,0,null,null," Allocates an array of `n` items of type `T` and sets all the\n items to `undefined`. Depending on the Allocator\n implementation, it may be required to call `free` once the\n memory is no longer needed, to avoid a resource leak. If the\n `Allocator` implementation is unknown, then correct code will\n call `free` when done.\n\n For allocating a single item, see `create`.",[3520,3521,3522],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,false],[27,131,0,null,null,null,[3524,3525,3526,3527,3528],false],[0,0,0,"self",null,"",null,false],[0,0,0,"Elem",null,"",null,true],[0,0,0,"n",null,"",null,false],[0,0,0,"optional_alignment",null," null means naturally aligned\n",null,true],[0,0,0,"optional_sentinel",null,"",null,true],[27,142,0,null,null,null,[3530,3531,3532,3533,3534,3535],false],[0,0,0,"self",null,"",null,false],[0,0,0,"Elem",null,"",null,true],[0,0,0,"n",null,"",null,false],[0,0,0,"optional_alignment",null," null means naturally aligned\n",null,true],[0,0,0,"optional_sentinel",null,"",null,true],[0,0,0,"return_address",null,"",null,false],[27,160,0,null,null,null,[3537,3538,3539],false],[0,0,0,"Elem",null,"",null,true],[0,0,0,"alignment",null,"",null,true],[0,0,0,"sentinel",null,"",null,true],[27,176,0,null,null," Allocates an array of `n + 1` items of type `T` and sets the first `n`\n items to `undefined` and the last item to `sentinel`. Depending on the\n Allocator implementation, it may be required to call `free` once the\n memory is no longer needed, to avoid a resource leak. If the\n `Allocator` implementation is unknown, then correct code will\n call `free` when done.\n\n For allocating a single item, see `create`.",[3541,3542,3543,3544],false],[0,0,0,"self",null,"",null,false],[0,0,0,"Elem",null,"",null,true],[0,0,0,"n",null,"",null,false],[0,0,0,"sentinel",null,"",null,true],[27,185,0,null,null,null,[3546,3547,3548,3549],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"alignment",null," null means naturally aligned\n",null,true],[0,0,0,"n",null,"",null,false],[27,195,0,null,null,null,[3551,3552,3553,3554,3555],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"alignment",null," null means naturally aligned\n",null,true],[0,0,0,"n",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[27,208,0,null,null,null,[3557,3558,3559,3560,3561],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,"",null,true],[0,0,0,"alignment",null,"",null,true],[0,0,0,"n",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[27,213,0,null,null,null,[3563,3564,3565,3566],false],[0,0,0,"self",null,"",null,false],[0,0,0,"alignment",null,"",null,true],[0,0,0,"byte_count",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[27,233,0,null,null," Requests to modify the size of an allocation. It is guaranteed to not move\n the pointer, however the allocator implementation may refuse the resize\n request by returning `false`.",[3568,3569,3570],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"new_n",null,"",null,false],[27,254,0,null,null," This function requests a new byte size for an existing allocation, which\n can be larger, smaller, or the same size as the old memory allocation.\n If `new_n` is 0, this is the same as `free` and it always succeeds.",[3572,3573,3574],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"new_n",null,"",null,false],[27,261,0,null,null,null,[3576,3577,3578,3579],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"new_n",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[27,305,0,null,null," Free an array allocated with `alloc`. To free a single item,\n see `destroy`.",[3581,3582],false],[0,0,0,"self",null,"",null,false],[0,0,0,"memory",null,"",null,false],[27,317,0,null,null," Copies `m` to newly allocated memory. Caller owns the memory.",[3584,3585,3586],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"m",null,"",null,false],[27,324,0,null,null," Copies `m` to newly allocated memory, with a null-terminated element. Caller owns the memory.",[3588,3589,3590],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"m",null,"",null,false],[27,333,0,null,null," TODO replace callsites with `@log2` after this proposal is implemented:\n https://github.com/ziglang/zig/issues/13642",[3592],false],[0,0,0,"x",null,"",null,false],[27,0,0,null,null,null,null,false],[0,0,0,"ptr",null,null,null,false],[27,0,0,null,null,null,null,false],[0,0,0,"vtable",null,null,null,false],[26,36,0,null,null," Detects and asserts if the std.mem.Allocator interface is violated by the caller\n or the allocator.",[3598],false],[0,0,0,"T",null,"",[3625],true],[26,38,0,null,null,null,null,false],[26,42,0,null,null,null,[3601],false],[0,0,0,"underlying_allocator",null,"",null,false],[26,48,0,null,null,null,[3603],false],[0,0,0,"self",null,"",null,false],[26,59,0,null,null,null,[3605],false],[0,0,0,"self",null,"",null,false],[26,64,0,null,null,null,[3607,3608,3609,3610],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[26,79,0,null,null,null,[3612,3613,3614,3615,3616],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[26,92,0,null,null,null,[3618,3619,3620,3621],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[26,104,0,null,null,null,[3623],false],[0,0,0,"self",null,"",null,false],[26,37,0,null,null,null,null,false],[0,0,0,"underlying_allocator",null,null,null,false],[26,110,0,null,null,null,[3627],false],[0,0,0,"allocator",null,"",null,false],[26,118,0,null,null," An allocator helper function.  Adjusts an allocation length satisfy `len_align`.\n `full_len` should be the full capacity of the allocation which may be greater\n than the `len` that was requested.  This function should only be used by allocators\n that are unaffected by `len_align`.",[3629,3630,3631],false],[0,0,0,"full_len",null,"",null,false],[0,0,0,"alloc_len",null,"",null,false],[0,0,0,"len_align",null,"",null,false],[26,129,0,null,null,null,null,false],[26,134,0,null,null,null,null,false],[26,140,0,null,null,null,[3635,3636,3637,3638],false],[0,0,0,"",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_alignment",null,"",null,false],[0,0,0,"ra",null,"",null,false],[26,196,0,null,null," Deprecated: use `@memcpy` if the arguments do not overlap, or\n `copyForwards` if they do.",null,false],[26,201,0,null,null," Copy all of source into dest at position 0.\n dest.len must be >= source.len.\n If the slices overlap, dest.ptr must be <= src.ptr.",[3641,3642,3643],false],[0,0,0,"T",null,"",null,true],[0,0,0,"dest",null,"",null,false],[0,0,0,"source",null,"",null,false],[26,208,0,null,null," Copy all of source into dest at position 0.\n dest.len must be >= source.len.\n If the slices overlap, dest.ptr must be >= src.ptr.",[3645,3646,3647],false],[0,0,0,"T",null,"",null,true],[0,0,0,"dest",null,"",null,false],[0,0,0,"source",null,"",null,false],[26,221,0,null,null,null,null,false],[26,229,0,null,null," Generally, Zig users are encouraged to explicitly initialize all fields of a struct explicitly rather than using this function.\n However, it is recognized that there are sometimes use cases for initializing all fields to a \"zero\" value. For example, when\n interfacing with a C API where this practice is more common and relied upon. If you are performing code review and see this\n function used, examine closely - it may be a code smell.\n Zero initializes the type.\n This can be used to zero-initialize any type for which it makes sense. Structs will be initialized recursively.",[3650],false],[0,0,0,"T",null,"",null,true],[26,421,0,null,null," Initializes all fields of the struct with their default value, or zero values if no default value is present.\n If the field is present in the provided initial values, it will have that value instead.\n Structs are initialized recursively.",[3652,3653],false],[0,0,0,"T",null,"",null,true],[0,0,0,"init",null,"",null,false],[26,569,0,null,null,null,[3655,3656,3657,3658],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThanFn",null,"",[3659,3660,3661],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[26,578,0,null,null,null,[3663,3664,3665,3666],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThanFn",null,"",[3667,3668,3669],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[26,589,0,null,null," TODO: currently this just calls `insertionSortContext`. The block sort implementation\n in this file needs to be adapted to use the sort context.",[3671,3672,3673],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[26,593,0,null,null,null,[3675,3676,3677],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[26,598,0,null,null," Compares two slices of numbers lexicographically. O(n).",[3679,3680,3681],false],[0,0,0,"T",null,"",null,true],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[26,611,0,null,null," Compares two many-item pointers with NUL-termination lexicographically.",[3683,3684,3685],false],[0,0,0,"T",null,"",null,true],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[26,631,0,null,null," Returns true if lhs < rhs, false otherwise",[3687,3688,3689],false],[0,0,0,"T",null,"",null,true],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[26,644,0,null,null," Compares two slices and returns whether they are equal.",[3691,3692,3693],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[26,655,0,null,null," Compares two slices and returns the index of the first inequality.\n Returns null if the slices are equal.",[3695,3696,3697],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[26,674,0,null,null," Takes a sentinel-terminated pointer and returns a slice preserving pointer attributes.\n `[*c]` pointers are assumed to be 0-terminated and assumed to not be allowzero.",[3699],false],[0,0,0,"T",null,"",null,true],[26,712,0,null,null," Takes a sentinel-terminated pointer and returns a slice, iterating over the\n memory to find the sentinel and determine the length.\n Pointer attributes such as const are preserved.\n `[*c]` pointers are assumed to be non-null and 0-terminated.",[3701],false],[0,0,0,"ptr",null,"",null,false],[26,739,0,null,null," Helper for the return type of sliceTo()",[3703,3704],false],[0,0,0,"T",null,"",null,true],[0,0,0,"end",null,"",null,true],[26,799,0,null,null," Takes an array, a pointer to an array, a sentinel-terminated pointer, or a slice and\n iterates searching for the first occurrence of `end`, returning the scanned slice.\n If `end` is not found, the full length of the array/slice/sentinel terminated pointer is returned.\n If the pointer type is sentinel terminated and `end` matches that terminator, the\n resulting slice is also sentinel terminated.\n Pointer properties such as mutability and alignment are preserved.\n C pointers are assumed to be non-null.",[3706,3707],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"end",null,"",null,true],[26,855,0,null,null," Private helper for sliceTo(). If you want the length, use sliceTo(foo, x).len",[3709,3710],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"end",null,"",null,true],[26,934,0,null,null," Takes a sentinel-terminated pointer and iterates over the memory to find the\n sentinel and determine the length.\n `[*c]` pointers are assumed to be non-null and 0-terminated.",[3712],false],[0,0,0,"value",null,"",null,false],[26,961,0,null,null,null,[3714,3715,3716],false],[0,0,0,"Elem",null,"",null,true],[0,0,0,"sentinel",null,"",null,true],[0,0,0,"ptr",null,"",null,false],[26,970,0,null,null," Returns true if all elements in a slice are equal to the scalar value provided",[3718,3719,3720],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[26,978,0,null,null," Remove a set of values from the beginning of a slice.",[3722,3723,3724],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values_to_strip",null,"",null,false],[26,985,0,null,null," Remove a set of values from the end of a slice.",[3726,3727,3728],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values_to_strip",null,"",null,false],[26,992,0,null,null," Remove a set of values from the beginning and end of a slice.",[3730,3731,3732],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values_to_strip",null,"",null,false],[26,1008,0,null,null," Linear search for the index of a scalar value inside a slice.",[3734,3735,3736],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1013,0,null,null," Linear search for the last index of a scalar value inside a slice.",[3738,3739,3740],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1022,0,null,null,null,[3742,3743,3744,3745],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1030,0,null,null,null,[3747,3748,3749],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values",null,"",null,false],[26,1034,0,null,null,null,[3751,3752,3753],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values",null,"",null,false],[26,1045,0,null,null,null,[3755,3756,3757,3758],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"values",null,"",null,false],[26,1058,0,null,null," Find the first item in `slice` which is not contained in `values`.\n\n Comparable to `strspn` in the C standard library.",[3760,3761,3762],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values",null,"",null,false],[26,1065,0,null,null," Find the last item in `slice` which is not contained in `values`.\n\n Like `strspn` in the C standard library, but searches from the end.",[3764,3765,3766],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"values",null,"",null,false],[26,1081,0,null,null," Find the first item in `slice[start_index..]` which is not contained in `values`.\n The returned index will be relative to the start of `slice`, and never less than `start_index`.\n\n Comparable to `strspn` in the C standard library.",[3768,3769,3770,3771],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"values",null,"",null,false],[26,1103,0,null,null,null,[3773,3774,3775],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1111,0,null,null," Find the index in a slice of a sub-slice, searching from the end backwards.\n To start looking at a different index, slice the haystack first.\n Consider using `lastIndexOf` instead of this, which will automatically use a\n more sophisticated algorithm on larger inputs.",[3777,3778,3779],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1121,0,null,null," Consider using `indexOfPos` instead of this, which will automatically use a\n more sophisticated algorithm on larger inputs.",[3781,3782,3783,3784],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1130,0,null,null,null,[3786,3787],false],[0,0,0,"pattern",null,"",null,false],[0,0,0,"table",null,"",null,false],[26,1143,0,null,null,null,[3789,3790],false],[0,0,0,"pattern",null,"",null,false],[0,0,0,"table",null,"",null,false],[26,1160,0,null,null," Find the index in a slice of a sub-slice, searching from the end backwards.\n To start looking at a different index, slice the haystack first.\n Uses the Reverse Boyer-Moore-Horspool algorithm on large inputs;\n `lastIndexOfLinear` on small inputs.",[3792,3793,3794],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1187,0,null,null," Uses Boyer-Moore-Horspool algorithm on large inputs; `indexOfPosLinear` on small inputs.",[3796,3797,3798,3799],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1271,0,null,null," Returns the number of needles inside the haystack\n needle.len must be > 0\n does not count overlapping needles",[3801,3802,3803],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1301,0,null,null," Returns true if the haystack contains expected_count or more needles\n needle.len must be > 0\n does not count overlapping needles",[3805,3806,3807,3808],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"expected_count",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,1335,0,null,null," Reads an integer from memory with size equal to bytes.len.\n T specifies the return type, which must be large enough to store\n the result.",[3810,3811,3812],false],[0,0,0,"ReturnType",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1361,0,null,null," Loads an integer from packed memory with provided bit_count, bit_offset, and signedness.\n Asserts that T is large enough to store the read value.\n\n Example:\n     const T = packed struct(u16){ a: u3, b: u7, c: u6 };\n     var st = T{ .a = 1, .b = 2, .c = 4 };\n     const b_field = readVarPackedInt(u64, std.mem.asBytes(&st), @bitOffsetOf(T, \"b\"), 7, builtin.cpu.arch.endian(), .unsigned);\n",[3814,3815,3816,3817,3818,3819],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[26,1428,0,null,null," Reads an integer from memory with bit count specified by T.\n The bit count of T must be evenly divisible by 8.\n This function cannot fail and cannot cause undefined behavior.\n Assumes the endianness of memory is native. This means the function can\n simply pointer cast memory.",[3821,3822],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,1436,0,null,null," Reads an integer from memory with bit count specified by T.\n The bit count of T must be evenly divisible by 8.\n This function cannot fail and cannot cause undefined behavior.\n Assumes the endianness of memory is foreign, so it must byte-swap.",[3824,3825],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,1440,0,null,null,null,null,false],[26,1445,0,null,null,null,null,false],[26,1455,0,null,null," Asserts that bytes.len >= @typeInfo(T).Int.bits / 8. Reads the integer starting from index 0\n and ignores extra bytes.\n The bit count of T must be evenly divisible by 8.\n Assumes the endianness of memory is native. This means the function can\n simply pointer cast memory.",[3829,3830],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,1465,0,null,null," Asserts that bytes.len >= @typeInfo(T).Int.bits / 8. Reads the integer starting from index 0\n and ignores extra bytes.\n The bit count of T must be evenly divisible by 8.\n Assumes the endianness of memory is foreign, so it must byte-swap.",[3832,3833],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,1469,0,null,null,null,null,false],[26,1474,0,null,null,null,null,false],[26,1482,0,null,null," Reads an integer from memory with bit count specified by T.\n The bit count of T must be evenly divisible by 8.\n This function cannot fail and cannot cause undefined behavior.",[3837,3838,3839],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1490,0,null,null,null,[3841,3842,3843],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[26,1516,0,null,null,null,[3845,3846,3847],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[26,1543,0,null,null,null,null,false],[26,1548,0,null,null,null,null,false],[26,1561,0,null,null," Loads an integer from packed memory.\n Asserts that buffer contains at least bit_offset + @bitSizeOf(T) bits.\n\n Example:\n     const T = packed struct(u16){ a: u3, b: u7, c: u6 };\n     var st = T{ .a = 1, .b = 2, .c = 4 };\n     const b_field = readPackedInt(u7, std.mem.asBytes(&st), @bitOffsetOf(T, \"b\"), builtin.cpu.arch.endian());\n",[3851,3852,3853,3854],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1571,0,null,null," Asserts that bytes.len >= @typeInfo(T).Int.bits / 8. Reads the integer starting from index 0\n and ignores extra bytes.\n The bit count of T must be evenly divisible by 8.",[3856,3857,3858],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1619,0,null,null," Writes an integer to memory, storing it in twos-complement.\n This function always succeeds, has defined behavior for all inputs, and\n accepts any integer bit width.\n This function stores in native endian, which means it is implemented as a simple\n memory store.",[3860,3861,3862],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1627,0,null,null," Writes an integer to memory, storing it in twos-complement.\n This function always succeeds, has defined behavior for all inputs, but\n the integer bit width must be divisible by 8.\n This function stores in foreign endian, which means it does a @byteSwap first.",[3864,3865,3866],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1631,0,null,null,null,null,false],[26,1636,0,null,null,null,null,false],[26,1644,0,null,null," Writes an integer to memory, storing it in twos-complement.\n This function always succeeds, has defined behavior for all inputs, but\n the integer bit width must be divisible by 8.",[3870,3871,3872,3873],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1652,0,null,null,null,[3875,3876,3877,3878],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1685,0,null,null,null,[3880,3881,3882,3883],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1720,0,null,null,null,null,false],[26,1725,0,null,null,null,null,false],[26,1739,0,null,null," Stores an integer to packed memory.\n Asserts that buffer contains at least bit_offset + @bitSizeOf(T) bits.\n\n Example:\n     const T = packed struct(u16){ a: u3, b: u7, c: u6 };\n     var st = T{ .a = 1, .b = 2, .c = 4 };\n     // st.b = 0x7f;\n     writePackedInt(u7, std.mem.asBytes(&st), @bitOffsetOf(T, \"b\"), 0x7f, builtin.cpu.arch.endian());\n",[3887,3888,3889,3890,3891],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1752,0,null,null," Writes a twos-complement little-endian integer to memory.\n Asserts that buf.len >= @typeInfo(T).Int.bits / 8.\n The bit count of T must be divisible by 8.\n Any extra bytes in buffer after writing the integer are set to zero. To\n avoid the branch to check for extra buffer bytes, use writeIntLittle\n instead.",[3893,3894,3895],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1776,0,null,null," Writes a twos-complement big-endian integer to memory.\n Asserts that buffer.len >= @typeInfo(T).Int.bits / 8.\n The bit count of T must be divisible by 8.\n Any extra bytes in buffer before writing the integer are set to zero. To\n avoid the branch to check for extra buffer bytes, use writeIntBig instead.",[3897,3898,3899],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"value",null,"",null,false],[26,1798,0,null,null,null,null,false],[26,1803,0,null,null,null,null,false],[26,1814,0,null,null," Writes a twos-complement integer to memory, with the specified endianness.\n Asserts that buf.len >= @typeInfo(T).Int.bits / 8.\n The bit count of T must be evenly divisible by 8.\n Any extra bytes in buffer not part of the integer are set to zero, with\n respect to endianness. To avoid the branch to check for extra buffer bytes,\n use writeInt instead.",[3903,3904,3905,3906],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1832,0,null,null," Stores an integer to packed memory with provided bit_count, bit_offset, and signedness.\n If negative, the written value is sign-extended.\n\n Example:\n     const T = packed struct(u16){ a: u3, b: u7, c: u6 };\n     var st = T{ .a = 1, .b = 2, .c = 4 };\n     // st.b = 0x7f;\n     var value: u64 = 0x7f;\n     writeVarPackedInt(std.mem.asBytes(&st), @bitOffsetOf(T, \"b\"), 7, value, builtin.cpu.arch.endian());\n",[3908,3909,3910,3911,3912],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"endian",null,"",null,false],[26,1925,0,null,null," Swap the byte order of all the members of the fields of a struct\n (Changing their endianness)",[3914,3915],false],[0,0,0,"S",null,"",null,true],[0,0,0,"ptr",null,"",null,false],[26,1972,0,null,null," Deprecated: use `tokenizeAny`, `tokenizeSequence`, or `tokenizeScalar`",null,false],[26,1987,0,null,null," Returns an iterator that iterates over the slices of `buffer` that are not\n any of the items in `delimiters`.\n\n `tokenizeAny(u8, \"   abc|def ||  ghi  \", \" |\")` will return slices\n for \"abc\", \"def\", \"ghi\", null, in that order.\n\n If `buffer` is empty, the iterator will return null.\n If none of `delimiters` exist in buffer,\n the iterator will return `buffer`, null, in that order.\n\n See also: `tokenizeSequence`, `tokenizeScalar`,\n           `splitSequence`,`splitAny`, `splitScalar`,\n           `splitBackwardsSequence`, `splitBackwardsAny`, and `splitBackwardsScalar`",[3918,3919,3920],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiters",null,"",null,false],[26,2009,0,null,null," Returns an iterator that iterates over the slices of `buffer` that are not\n the sequence in `delimiter`.\n\n `tokenizeSequence(u8, \"<>abc><def<><>ghi\", \"<>\")` will return slices\n for \"abc><def\", \"ghi\", null, in that order.\n\n If `buffer` is empty, the iterator will return null.\n If `delimiter` does not exist in buffer,\n the iterator will return `buffer`, null, in that order.\n The delimiter length must not be zero.\n\n See also: `tokenizeAny`, `tokenizeScalar`,\n           `splitSequence`,`splitAny`, and `splitScalar`\n           `splitBackwardsSequence`, `splitBackwardsAny`, and `splitBackwardsScalar`",[3922,3923,3924],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[26,2031,0,null,null," Returns an iterator that iterates over the slices of `buffer` that are not\n `delimiter`.\n\n `tokenizeScalar(u8, \"   abc def     ghi  \", ' ')` will return slices\n for \"abc\", \"def\", \"ghi\", null, in that order.\n\n If `buffer` is empty, the iterator will return null.\n If `delimiter` does not exist in buffer,\n the iterator will return `buffer`, null, in that order.\n\n See also: `tokenizeAny`, `tokenizeSequence`,\n           `splitSequence`,`splitAny`, and `splitScalar`\n           `splitBackwardsSequence`, `splitBackwardsAny`, and `splitBackwardsScalar`",[3926,3927,3928],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[26,2173,0,null,null," Deprecated: use `splitSequence`, `splitAny`, or `splitScalar`",null,false],[26,2188,0,null,null," Returns an iterator that iterates over the slices of `buffer` that\n are separated by the byte sequence in `delimiter`.\n\n `splitSequence(u8, \"abc||def||||ghi\", \"||\")` will return slices\n for \"abc\", \"def\", \"\", \"ghi\", null, in that order.\n\n If `delimiter` does not exist in buffer,\n the iterator will return `buffer`, null, in that order.\n The delimiter length must not be zero.\n\n See also: `splitAny`, `splitScalar`, `splitBackwardsSequence`,\n           `splitBackwardsAny`,`splitBackwardsScalar`,\n           `tokenizeAny`, `tokenizeSequence`, and `tokenizeScalar`.",[3931,3932,3933],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[26,2209,0,null,null," Returns an iterator that iterates over the slices of `buffer` that\n are separated by any item in `delimiters`.\n\n `splitAny(u8, \"abc,def||ghi\", \"|,\")` will return slices\n for \"abc\", \"def\", \"\", \"ghi\", null, in that order.\n\n If none of `delimiters` exist in buffer,\n the iterator will return `buffer`, null, in that order.\n\n See also: `splitSequence`, `splitScalar`, `splitBackwardsSequence`,\n           `splitBackwardsAny`,`splitBackwardsScalar`,\n           `tokenizeAny`, `tokenizeSequence`, and `tokenizeScalar`.",[3935,3936,3937],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiters",null,"",null,false],[26,2229,0,null,null," Returns an iterator that iterates over the slices of `buffer` that\n are separated by `delimiter`.\n\n `splitScalar(u8, \"abc|def||ghi\", '|')` will return slices\n for \"abc\", \"def\", \"\", \"ghi\", null, in that order.\n\n If `delimiter` does not exist in buffer,\n the iterator will return `buffer`, null, in that order.\n\n See also: `splitSequence`, `splitAny`, `splitBackwardsSequence`,\n           `splitBackwardsAny`,`splitBackwardsScalar`,\n           `tokenizeAny`, `tokenizeSequence`, and `tokenizeScalar`.",[3939,3940,3941],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[26,2375,0,null,null," Deprecated: use `splitBackwardsSequence`, `splitBackwardsAny`, or `splitBackwardsScalar`",null,false],[26,2390,0,null,null," Returns an iterator that iterates backwards over the slices of `buffer` that\n are separated by the sequence in `delimiter`.\n\n `splitBackwardsSequence(u8, \"abc||def||||ghi\", \"||\")` will return slices\n for \"ghi\", \"\", \"def\", \"abc\", null, in that order.\n\n If `delimiter` does not exist in buffer,\n the iterator will return `buffer`, null, in that order.\n The delimiter length must not be zero.\n\n See also: `splitBackwardsAny`, `splitBackwardsScalar`,\n           `splitSequence`, `splitAny`,`splitScalar`,\n           `tokenizeAny`, `tokenizeSequence`, and `tokenizeScalar`.",[3944,3945,3946],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[26,2411,0,null,null," Returns an iterator that iterates backwards over the slices of `buffer` that\n are separated by any item in `delimiters`.\n\n `splitBackwardsAny(u8, \"abc,def||ghi\", \"|,\")` will return slices\n for \"ghi\", \"\", \"def\", \"abc\", null, in that order.\n\n If none of `delimiters` exist in buffer,\n the iterator will return `buffer`, null, in that order.\n\n See also: `splitBackwardsSequence`, `splitBackwardsScalar`,\n           `splitSequence`, `splitAny`,`splitScalar`,\n           `tokenizeAny`, `tokenizeSequence`, and `tokenizeScalar`.",[3948,3949,3950],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiters",null,"",null,false],[26,2431,0,null,null," Returns an iterator that iterates backwards over the slices of `buffer` that\n are separated by `delimiter`.\n\n `splitBackwardsScalar(u8, \"abc|def||ghi\", '|')` will return slices\n for \"ghi\", \"\", \"def\", \"abc\", null, in that order.\n\n If `delimiter` does not exist in buffer,\n the iterator will return `buffer`, null, in that order.\n\n See also: `splitBackwardsSequence`, `splitBackwardsAny`,\n           `splitSequence`, `splitAny`,`splitScalar`,\n           `tokenizeAny`, `tokenizeSequence`, and `tokenizeScalar`.",[3952,3953,3954],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[26,2607,0,null,null," Returns an iterator with a sliding window of slices for `buffer`.\n The sliding window has length `size` and on every iteration moves\n forward by `advance`.\n\n Extract data for moving average with:\n `window(u8, \"abcdefg\", 3, 1)` will return slices\n \"abc\", \"bcd\", \"cde\", \"def\", \"efg\", null, in that order.\n\n Chunk or split every N items with:\n `window(u8, \"abcdefg\", 3, 3)` will return slices\n \"abc\", \"def\", \"g\", null, in that order.\n\n Pick every even index with:\n `window(u8, \"abcdefg\", 1, 2)` will return slices\n \"a\", \"c\", \"e\", \"g\" null, in that order.\n\n The `size` and `advance` must be not be zero.",[3956,3957,3958,3959],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"advance",null,"",null,false],[26,2701,0,null,null,null,[3961],false],[0,0,0,"T",null,"",[3970,3972,3973,3974],true],[26,2708,0,null,null,null,null,false],[26,2713,0,null,null," Returns a slice of the first window. This never fails.\n Call this only to get the first window and then use `next` to get\n all subsequent windows.",[3964],false],[0,0,0,"self",null,"",null,false],[26,2719,0,null,null," Returns a slice of the next window, or null if window is at end.",[3966],false],[0,0,0,"self",null,"",null,false],[26,2734,0,null,null," Resets the iterator to the initial window.",[3968],false],[0,0,0,"self",null,"",null,false],[26,2702,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[26,2702,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"advance",null,null,null,false],[26,2740,0,null,null,null,[3976,3977,3978],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,2749,0,null,null,null,[3980,3981,3982],false],[0,0,0,"T",null,"",null,true],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[26,2758,0,null,null,null,[3984,3985,3986],false],[0,0,0,"sequence",null,null,null,false],[0,0,0,"any",null,null,null,false],[0,0,0,"scalar",null,null,null,false],[26,2760,0,null,null,null,[3988,3989],false],[0,0,0,"T",null,"",null,true],[0,0,0,"delimiter_type",null,"",[4003,4005,4006],true],[26,2769,0,null,null,null,null,false],[26,2773,0,null,null," Returns a slice of the current token, or null if tokenization is\n complete, and advances to the next token.",[3992],false],[0,0,0,"self",null,"",null,false],[26,2781,0,null,null," Returns a slice of the current token, or null if tokenization is\n complete. Does not advance to the next token.",[3994],false],[0,0,0,"self",null,"",null,false],[26,2800,0,null,null," Returns a slice of the remaining bytes. Does not affect iterator state.",[3996],false],[0,0,0,"self",null,"",null,false],[26,2811,0,null,null," Resets the iterator to the initial token.",[3998],false],[0,0,0,"self",null,"",null,false],[26,2815,0,null,null,null,[4000,4001],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[26,2761,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[26,2761,0,null,null,null,null,false],[0,0,0,"delimiter",null,null,null,false],[0,0,0,"index",null,null,null,false],[26,2833,0,null,null,null,[4008,4009],false],[0,0,0,"T",null,"",null,true],[0,0,0,"delimiter_type",null,"",[4022,4024,4026],true],[26,2842,0,null,null,null,null,false],[26,2846,0,null,null," Returns a slice of the first field. This never fails.\n Call this only to get the first field and then use `next` to get all subsequent fields.",[4012],false],[0,0,0,"self",null,"",null,false],[26,2852,0,null,null," Returns a slice of the next field, or null if splitting is complete.",[4014],false],[0,0,0,"self",null,"",null,false],[26,2873,0,null,null," Returns a slice of the next field, or null if splitting is complete.\n This method does not alter self.index.",[4016],false],[0,0,0,"self",null,"",null,false],[26,2884,0,null,null," Returns a slice of the remaining bytes. Does not affect iterator state.",[4018],false],[0,0,0,"self",null,"",null,false],[26,2891,0,null,null," Resets the iterator to the initial slice.",[4020],false],[0,0,0,"self",null,"",null,false],[26,2834,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[26,2834,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[26,2834,0,null,null,null,null,false],[0,0,0,"delimiter",null,null,null,false],[26,2897,0,null,null,null,[4028,4029],false],[0,0,0,"T",null,"",null,true],[0,0,0,"delimiter_type",null,"",[4040,4042,4044],true],[26,2906,0,null,null,null,null,false],[26,2910,0,null,null," Returns a slice of the first field. This never fails.\n Call this only to get the first field and then use `next` to get all subsequent fields.",[4032],false],[0,0,0,"self",null,"",null,false],[26,2916,0,null,null," Returns a slice of the next field, or null if splitting is complete.",[4034],false],[0,0,0,"self",null,"",null,false],[26,2936,0,null,null," Returns a slice of the remaining bytes. Does not affect iterator state.",[4036],false],[0,0,0,"self",null,"",null,false],[26,2942,0,null,null," Resets the iterator to the initial slice.",[4038],false],[0,0,0,"self",null,"",null,false],[26,2898,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[26,2898,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[26,2898,0,null,null,null,null,false],[0,0,0,"delimiter",null,null,null,false],[26,2950,0,null,null," Naively combines a series of slices with a separator.\n Allocates memory for the result, which must be freed by the caller.",[4046,4047,4048],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"separator",null,"",null,false],[0,0,0,"slices",null,"",null,false],[26,2956,0,null,null," Naively combines a series of slices with a separator and null terminator.\n Allocates memory for the result, which must be freed by the caller.",[4050,4051,4052],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"separator",null,"",null,false],[0,0,0,"slices",null,"",null,false],[26,2961,0,null,null,null,[4054,4055,4056,4057],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"separator",null,"",null,false],[0,0,0,"slices",null,"",null,false],[0,0,0,"zero",null,"",null,false],[26,3040,0,null,null," Copies each T from slices into a new slice that exactly holds all the elements.",[4059,4060,4061],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"slices",null,"",null,false],[26,3045,0,null,null," Copies each T from slices into a new slice that exactly holds all the elements.",[4063,4064,4065,4066],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"slices",null,"",null,false],[0,0,0,"s",null,"",null,true],[26,3051,0,null,null," Copies each T from slices into a new slice that exactly holds all the elements as well as the sentinel.",[4068,4069,4070,4071],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"slices",null,"",null,false],[0,0,0,"s",null,"",null,true],[26,3132,0,null,null,null,[],false],[26,3183,0,null,null,null,[],false],[26,3321,0,null,null," Returns the smallest number in a slice. O(n).\n `slice` must not be empty.",[4075,4076],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[26,3338,0,null,null," Returns the largest number in a slice. O(n).\n `slice` must not be empty.",[4078,4079],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[26,3356,0,null,null," Finds the smallest and largest number in a slice. O(n).\n Returns an anonymous struct with the fields `min` and `max`.\n `slice` must not be empty.",[4081,4082],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",[4084,4086],false],[26,3356,0,null,null,null,null,false],[0,0,0,"min",null,null,null,false],[26,3356,0,null,null,null,null,false],[0,0,0,"max",null,null,null,false],[26,3375,0,null,null," Returns the index of the smallest number in a slice. O(n).\n `slice` must not be empty.",[4088,4089],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[26,3396,0,null,null," Returns the index of the largest number in a slice. O(n).\n `slice` must not be empty.",[4091,4092],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[26,3418,0,null,null," Finds the indices of the smallest and largest number in a slice. O(n).\n Returns an anonymous struct with the fields `index_min` and `index_max`.\n `slice` must not be empty.",[4094,4095],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",[4096,4097],false],[0,0,0,"index_min",null,null,null,false],[0,0,0,"index_max",null,null,null,false],[26,3443,0,null,null,null,[4099,4100,4101],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[26,3450,0,null,null," In-place order reversal of a slice",[4103,4104],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[26,3465,0,null,null,null,[4106],false],[0,0,0,"T",null,"",[4112,4113],true],[26,3495,0,null,null,null,[4108],false],[0,0,0,"self",null,"",null,false],[26,3500,0,null,null,null,[4110],false],[0,0,0,"self",null,"",null,false],[26,3492,0,null,null,null,null,false],[0,0,0,"ptr",null,null,null,false],[0,0,0,"index",null,null,null,false],[26,3509,0,null,null," Iterates over a slice in reverse.",[4115],false],[0,0,0,"slice",null,"",null,false],[26,3571,0,null,null," In-place rotation of the values in an array ([0 1 2 3] becomes [1 2 3 0] if we rotate by 1)\n Assumes 0 <= amount <= items.len",[4117,4118,4119],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"amount",null,"",null,false],[26,3588,0,null,null," Replace needle with replacement as many times as possible, writing to an output buffer which is assumed to be of\n appropriate size. Use replacementSize to calculate an appropriate buffer size.\n The needle must not be empty.\n Returns the number of replacements made.",[4121,4122,4123,4124,4125],false],[0,0,0,"T",null,"",null,true],[0,0,0,"input",null,"",null,false],[0,0,0,"needle",null,"",null,false],[0,0,0,"replacement",null,"",null,false],[0,0,0,"output",null,"",null,false],[26,3643,0,null,null," Replace all occurrences of `needle` with `replacement`.",[4127,4128,4129,4130],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"needle",null,"",null,false],[0,0,0,"replacement",null,"",null,false],[26,3652,0,null,null," Collapse consecutive duplicate elements into one entry.",[4132,4133,4134],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"elem",null,"",null,false],[26,3666,0,null,null," Collapse consecutive duplicate elements into one entry.",[4136,4137,4138],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[0,0,0,"elem",null,"",null,false],[26,3670,0,null,null,null,[4140,4141,4142],false],[0,0,0,"str",null,"",null,false],[0,0,0,"elem",null,"",null,false],[0,0,0,"expected",null,"",null,false],[26,3691,0,null,null," Calculate the size needed in an output buffer to perform a replacement.\n The needle must not be empty.",[4144,4145,4146,4147],false],[0,0,0,"T",null,"",null,true],[0,0,0,"input",null,"",null,false],[0,0,0,"needle",null,"",null,false],[0,0,0,"replacement",null,"",null,false],[26,3723,0,null,null," Perform a replacement on an allocated buffer of pre-determined size. Caller must free returned memory.",[4149,4150,4151,4152,4153],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"needle",null,"",null,false],[0,0,0,"replacement",null,"",null,false],[26,3742,0,null,null," Converts a little-endian integer to host endianness.",[4155,4156],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[26,3750,0,null,null," Converts a big-endian integer to host endianness.",[4158,4159],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[26,3758,0,null,null," Converts an integer from specified endianness to host endianness.",[4161,4162,4163],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"endianness_of_x",null,"",null,false],[26,3766,0,null,null," Converts an integer which has host endianness to the desired endianness.",[4165,4166,4167],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"desired_endianness",null,"",null,false],[26,3774,0,null,null," Converts an integer which has host endianness to little endian.",[4169,4170],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[26,3782,0,null,null," Converts an integer which has host endianness to big endian.",[4172,4173],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[26,3795,0,null,null," Returns the number of elements that, if added to the given pointer, align it\n to a multiple of the given quantity, or `null` if one of the following\n conditions is met:\n - The aligned pointer would not fit the address space,\n - The delta required to align the pointer is not a multiple of the pointee's\n   type.",[4175,4176],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"align_to",null,"",null,false],[26,3827,0,null,null," Aligns a given pointer value to a specified alignment factor.\n Returns an aligned pointer or null if one of the following conditions is\n met:\n - The aligned pointer would not fit the address space,\n - The delta required to align the pointer is not a multiple of the pointee's\n   type.",[4178,4179],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"align_to",null,"",null,false],[26,3852,0,null,null,null,[4181,4182,4183],false],[0,0,0,"source",null,"",null,true],[0,0,0,"size",null,"",null,true],[0,0,0,"child",null,"",null,true],[26,3872,0,null,null,null,[4185],false],[0,0,0,"P",null,"",null,true],[26,3882,0,null,null," Given a pointer to a single item, returns a slice of the underlying bytes, preserving pointer attributes.",[4187],false],[0,0,0,"ptr",null,"",null,false],[26,3942,0,null,null," Given any value, returns a copy of its bytes in an array.",[4189],false],[0,0,0,"value",null,"",null,false],[26,3960,0,null,null,null,[4191,4192],false],[0,0,0,"T",null,"",null,true],[0,0,0,"B",null,"",null,true],[26,3974,0,null,null," Given a pointer to an array of bytes, returns a pointer to a value of the specified type\n backed by those bytes, preserving pointer attributes.",[4194,4195],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,4034,0,null,null," Given a pointer to an array of bytes, returns a value of the specified type backed by a\n copy of those bytes.",[4197,4198],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,4047,0,null,null,null,[4200,4201],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytesType",null,"",null,true],[26,4061,0,null,null," Given a slice of bytes, returns a slice of the specified type\n backed by those bytes, preserving pointer attributes.",[4203,4204],false],[0,0,0,"T",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[26,4140,0,null,null,null,[4206],false],[0,0,0,"Slice",null,"",null,true],[26,4149,0,null,null," Given a slice, returns a slice of the underlying bytes, preserving pointer attributes.",[4208],false],[0,0,0,"slice",null,"",null,false],[26,4246,0,null,null," Round an address up to the next (or current) aligned address.\n The alignment must be a power of 2 and greater than 0.\n Asserts that rounding up the address does not cause integer overflow.",[4210,4211,4212],false],[0,0,0,"T",null,"",null,true],[0,0,0,"addr",null,"",null,false],[0,0,0,"alignment",null,"",null,false],[26,4251,0,null,null,null,[4214,4215],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"log2_alignment",null,"",null,false],[26,4256,0,null,null,null,null,false],[26,4262,0,null,null," Force an evaluation of the expression; this tries to prevent\n the compiler from optimizing the computation away even if the\n result eventually gets discarded.",[4218],false],[0,0,0,"val",null,"",null,false],[26,4314,0,null,null," .stage2_c doesn't support asm blocks yet, so use volatile stores instead",null,false],[26,4315,0,null,null,null,[4221],false],[0,0,0,"ptr",null,"",null,false],[26,4365,0,null,null," Round an address down to the previous (or current) aligned address.\n Unlike `alignBackward`, `alignment` can be any positive number, not just a power of 2.",[4223,4224],false],[0,0,0,"i",null,"",null,false],[0,0,0,"alignment",null,"",null,false],[26,4374,0,null,null," Round an address down to the previous (or current) aligned address.\n The alignment must be a power of 2 and greater than 0.",[4226,4227,4228],false],[0,0,0,"T",null,"",null,true],[0,0,0,"addr",null,"",null,false],[0,0,0,"alignment",null,"",null,false],[26,4382,0,null,null,null,null,false],[26,4386,0,null,null," Returns whether `alignment` is a valid alignment, meaning it is\n a positive power of 2.",[4231],false],[0,0,0,"alignment",null,"",null,false],[26,4392,0,null,null," Returns whether `alignment` is a valid alignment, meaning it is\n a positive power of 2.",[4233,4234],false],[0,0,0,"T",null,"",null,true],[0,0,0,"alignment",null,"",null,false],[26,4396,0,null,null,null,[4236,4237],false],[0,0,0,"i",null,"",null,false],[0,0,0,"alignment",null,"",null,false],[26,4403,0,null,null,null,[4239,4240],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"log2_alignment",null,"",null,false],[26,4409,0,null,null," Given an address and an alignment, return true if the address is a multiple of the alignment\n The alignment must be a power of 2 and greater than 0.",[4242,4243],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"alignment",null,"",null,false],[26,4413,0,null,null,null,[4245,4246,4247],false],[0,0,0,"T",null,"",null,true],[0,0,0,"addr",null,"",null,false],[0,0,0,"alignment",null,"",null,false],[26,4440,0,null,null," Returns a slice with the given new alignment,\n all other pointer attributes copied from `AttributeSource`.",[4249,4250],false],[0,0,0,"AttributeSource",null,"",null,true],[0,0,0,"new_alignment",null,"",null,true],[26,4458,0,null,null," Returns the largest slice in the given bytes that conforms to the new alignment,\n or `null` if the given bytes contain no conforming address.",[4252,4253],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"new_alignment",null,"",null,true],[26,4472,0,null,null," Returns the largest sub-slice within the given slice that conforms to the new alignment,\n or `null` if the given slice contains no conforming address.",[4255,4256],false],[0,0,0,"slice",null,"",null,false],[0,0,0,"new_alignment",null,"",null,true],[26,3179,0,"writeIntSlice","test writeIntSlice {\n    try testWriteIntImpl();\n    try comptime testWriteIntImpl();\n}",null,null,false],[25,3,0,null,null,null,null,false],[25,4,0,null,null,null,null,false],[25,9,0,null,null," A BufSet is a set of strings.  The BufSet duplicates\n strings internally, and never takes ownership of strings\n which are passed to it.",[4294],false],[25,12,0,null,null,null,null,false],[25,13,0,null,null,null,null,false],[25,18,0,null,null," Create a BufSet using an allocator.  The allocator will\n be used internally for both backing allocations and\n string duplication.",[4264],false],[0,0,0,"a",null,"",null,false],[25,24,0,null,null," Free a BufSet along with all stored keys.",[4266],false],[0,0,0,"self",null,"",null,false],[25,36,0,null,null," Insert an item into the BufSet.  The item will be\n copied, so the caller may delete or reuse the\n passed string immediately.",[4268,4269],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[25,47,0,null,null," Check if the set contains an item matching the passed string",[4271,4272],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[25,52,0,null,null," Remove an item from the set.",[4274,4275],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[25,58,0,null,null," Returns the number of items stored in the set",[4277],false],[0,0,0,"self",null,"",null,false],[25,64,0,null,null," Returns an iterator over the items stored in the set.\n Iteration order is arbitrary.",[4279],false],[0,0,0,"self",null,"",null,false],[25,69,0,null,null," Get the allocator used by this set",[4281],false],[0,0,0,"self",null,"",null,false],[25,74,0,null,null," Creates a copy of this BufSet, using a specified allocator.",[4283,4284],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_allocator",null,"",null,false],[25,89,0,null,null," Creates a copy of this BufSet, using the same allocator.",[4286],false],[0,0,0,"self",null,"",null,false],[25,93,0,null,null,null,[4288,4289],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[25,97,0,null,null,null,[4291,4292],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[25,9,0,null,null,null,null,false],[0,0,0,"hash_map",null,null,null,false],[1,17,0,null,null," Deprecated: use `process.Child`.",null,false],[0,0,0,"child_process.zig",null,"",[],false],[28,0,0,null,null,null,null,false],[28,1,0,null,null,null,null,false],[28,2,0,null,null,null,null,false],[28,3,0,null,null,null,null,false],[28,4,0,null,null,null,null,false],[28,5,0,null,null,null,null,false],[28,6,0,null,null,null,null,false],[28,7,0,null,null,null,null,false],[28,8,0,null,null,null,null,false],[28,9,0,null,null,null,null,false],[28,10,0,null,null,null,null,false],[28,11,0,null,null,null,null,false],[28,12,0,null,null,null,null,false],[28,13,0,null,null,null,null,false],[28,14,0,null,null,null,null,false],[28,15,0,null,null,null,null,false],[28,17,0,null,null,null,[4410,4412,4414,4416,4418,4420,4422,4424,4426,4428,4430,4432,4434,4436,4438,4440,4442,4444,4445,4446,4447,4449],false],[28,18,0,null,null,null,null,false],[28,83,0,null,null,null,[4320],false],[28,88,0,null,null," Returns the peak resident set size of the child process, in bytes,\n if available.",[4317],false],[0,0,0,"rus",null,"",null,false],[28,116,0,null,null,null,null,false],[28,83,0,null,null,null,null,false],[0,0,0,"rusage",null,null,null,false],[28,123,0,null,null,null,null,false],[28,125,0,null,null,null,null,false],[28,146,0,null,null,null,[4324,4325,4326,4327],false],[0,0,0,"Exited",null,null,null,false],[0,0,0,"Signal",null,null,null,false],[0,0,0,"Stopped",null,null,null,false],[0,0,0,"Unknown",null,null,null,false],[28,153,0,null,null,null,[4329,4330,4331,4332],false],[0,0,0,"Inherit",null,null,null,false],[0,0,0,"Ignore",null,null,null,false],[0,0,0,"Pipe",null,null,null,false],[0,0,0,"Close",null,null,null,false],[28,161,0,null,null," First argument in argv is the executable.",[4334,4335],false],[0,0,0,"argv",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[28,183,0,null,null,null,[4337,4338],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[28,191,0,null,null," On success must call `kill` or `wait`.\n After spawning the `id` is available.",[4340],false],[0,0,0,"self",null,"",null,false],[28,203,0,null,null,null,[4342],false],[0,0,0,"self",null,"",null,false],[28,209,0,null,null," Forcibly terminates child process and then cleans up all resources.",[4344],false],[0,0,0,"self",null,"",null,false],[28,217,0,null,null,null,[4346,4347],false],[0,0,0,"self",null,"",null,false],[0,0,0,"exit_code",null,"",null,false],[28,228,0,null,null,null,[4349],false],[0,0,0,"self",null,"",null,false],[28,239,0,null,null," Blocks until child process terminates and then cleans up all resources.",[4351],false],[0,0,0,"self",null,"",null,false],[28,250,0,null,null,null,[4354,4356,4358],false],[28,250,0,null,null,null,null,false],[0,0,0,"term",null,null,null,false],[28,250,0,null,null,null,null,false],[0,0,0,"stdout",null,null,null,false],[28,250,0,null,null,null,null,false],[0,0,0,"stderr",null,null,null,false],[28,256,0,null,null,null,[4360],false],[0,0,0,"fifo",null,"",null,false],[28,274,0,null,null," Collect the output from the process's stdout and stderr. Will return once all output\n has been collected. This does not mean that the process has ended. `wait` should still\n be called to wait for and clean up the process.\n\n The process must be started with stdout_behavior and stderr_behavior == .Pipe",[4362,4363,4364,4365],false],[0,0,0,"child",null,"",null,false],[0,0,0,"stdout",null,"",null,false],[0,0,0,"stderr",null,"",null,false],[0,0,0,"max_output_bytes",null,"",null,false],[28,305,0,null,null,null,null,false],[28,312,0,null,null," Spawns a child process, waits for it, collecting stdout and stderr, and then returns.\n If it succeeds, the caller owns result.stdout and result.stderr memory.",[4368],false],[0,0,0,"args",null,"",[4370,4372,4374,4376,4378,4379,4381],false],[28,312,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[28,312,0,null,null,null,null,false],[0,0,0,"argv",null,null,null,false],[28,312,0,null,null,null,null,false],[0,0,0,"cwd",null,null,null,false],[28,312,0,null,null,null,null,false],[0,0,0,"cwd_dir",null,null,null,false],[28,312,0,null,null,null,null,false],[0,0,0,"env_map",null,null,null,false],[0,0,0,"max_output_bytes",null,null,null,false],[28,312,0,null,null,null,null,false],[0,0,0,"expand_arg0",null,null,null,false],[28,347,0,null,null,null,[4383],false],[0,0,0,"self",null,"",null,false],[28,357,0,null,null,null,[4385],false],[0,0,0,"self",null,"",null,false],[28,367,0,null,null,null,[4387],false],[0,0,0,"self",null,"",null,false],[28,389,0,null,null,null,[4389],false],[0,0,0,"self",null,"",null,false],[28,410,0,null,null,null,[4391,4392],false],[0,0,0,"self",null,"",null,false],[0,0,0,"status",null,"",null,false],[28,414,0,null,null,null,[4394],false],[0,0,0,"self",null,"",null,false],[28,429,0,null,null,null,[4396,4397],false],[0,0,0,"self",null,"",null,false],[0,0,0,"status",null,"",null,false],[28,469,0,null,null,null,[4399],false],[0,0,0,"status",null,"",null,false],[28,480,0,null,null,null,[4401],false],[0,0,0,"self",null,"",null,false],[28,637,0,null,null,null,[4403],false],[0,0,0,"self",null,"",null,false],[28,904,0,null,null,null,[4405,4406,4407,4408],false],[0,0,0,"stdio",null,"",null,false],[0,0,0,"pipe_fd",null,"",null,false],[0,0,0,"std_fileno",null,"",null,false],[0,0,0,"dev_null_fd",null,"",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"id",null," Available after calling `spawn()`. This becomes `undefined` after calling `wait()`.\n On Windows this is the hProcess.\n On POSIX this is the pid.",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"thread_handle",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"stdin",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"stdout",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"stderr",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"term",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"argv",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"env_map",null," Leave as null to use the current env map using the supplied allocator.",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"stdin_behavior",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"stdout_behavior",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"stderr_behavior",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"uid",null," Set to change the user id when spawning the child process.",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"gid",null," Set to change the group id when spawning the child process.",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"cwd",null," Set to change the current working directory when spawning the child process.",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"cwd_dir",null," Set to change the current working directory when spawning the child process.\n This is not yet implemented for Windows. See https://github.com/ziglang/zig/issues/5190\n Once that is done, `cwd` will be deprecated in favor of this field.",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"err_pipe",null,null,null,false],[28,17,0,null,null,null,null,false],[0,0,0,"expand_arg0",null,null,null,false],[0,0,0,"disable_aslr",null," Darwin-only. Disable ASLR for the child process.",null,false],[0,0,0,"start_suspended",null," Darwin-only. Start child process in suspended state as if SIGSTOP was sent.",null,false],[0,0,0,"request_resource_usage_statistics",null," Set to true to obtain rusage information for the child process.\n Depending on the target platform and implementation status, the\n requested statistics may or may not be available. If they are\n available, then the `resource_usage_statistics` field will be populated\n after calling `wait`.\n On Linux and Darwin, this obtains rusage statistics from wait4().",null,false],[28,17,0,null,null,null,null,false],[0,0,0,"resource_usage_statistics",null," This is available after calling wait if\n `request_resource_usage_statistics` was set to `true` before calling\n `spawn`.",null,false],[28,918,0,null,null," Expects `app_buf` to contain exactly the app name, and `dir_buf` to contain exactly the dir path.\n After return, `app_buf` will always contain exactly the app name and `dir_buf` will always contain exactly the dir path.\n Note: `app_buf` should not contain any leading path separators.\n Note: If the dir is the cwd, dir_buf should be empty (len = 0).",[4451,4452,4453,4454,4455,4456,4457,4458,4459],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"dir_buf",null,"",null,false],[0,0,0,"app_buf",null,"",null,false],[0,0,0,"pathext",null,"",null,false],[0,0,0,"cmd_line",null,"",null,false],[0,0,0,"envp_ptr",null,"",null,false],[0,0,0,"cwd_ptr",null,"",null,false],[0,0,0,"lpStartupInfo",null,"",null,false],[0,0,0,"lpProcessInformation",null,"",null,false],[28,1119,0,null,null,null,[4461,4462,4463,4464,4465,4466],false],[0,0,0,"app_name",null,"",null,false],[0,0,0,"cmd_line",null,"",null,false],[0,0,0,"envp_ptr",null,"",null,false],[0,0,0,"cwd_ptr",null,"",null,false],[0,0,0,"lpStartupInfo",null,"",null,false],[0,0,0,"lpProcessInformation",null,"",null,false],[28,1152,0,null,null,null,[4468,4469,4470,4471],false],[0,0,0,"bat",null,null,null,false],[0,0,0,"cmd",null,null,null,false],[0,0,0,"com",null,null,null,false],[0,0,0,"exe",null,null,null,false],[28,1160,0,null,null," Case-insensitive UTF-16 lookup",[4473],false],[0,0,0,"ext",null,"",null,false],[28,1224,0,null,null," Caller must dealloc.",[4475,4476],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"argv",null,"",null,false],[28,1258,0,null,null,null,[4478,4479],false],[0,0,0,"rd",null,"",null,false],[0,0,0,"wr",null,"",null,false],[28,1263,0,null,null,null,[4481,4482,4483],false],[0,0,0,"rd",null,"",null,false],[0,0,0,"wr",null,"",null,false],[0,0,0,"sattr",null,"",null,false],[28,1273,0,null,null,null,null,false],[28,1275,0,null,null,null,[4486,4487,4488],false],[0,0,0,"rd",null,"",null,false],[0,0,0,"wr",null,"",null,false],[0,0,0,"sattr",null,"",null,false],[28,1336,0,null,null,null,[4490],false],[0,0,0,"pipe",null,"",null,false],[28,1343,0,null,null,null,[4492,4493],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"err",null,"",null,false],[28,1356,0,null,null,null,null,false],[28,1358,0,null,null,null,[4496,4497],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"value",null,"",null,false],[28,1367,0,null,null,null,[4499],false],[0,0,0,"fd",null,"",null,false],[28,1377,0,null,null," Caller must free result.",[4501,4502],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"env_map",null,"",null,false],[28,1413,0,null,null,null,[4504,4505],false],[0,0,0,"arena",null,"",null,false],[0,0,0,"env_map",null,"",null,false],[1,18,0,null,null,null,null,false],[1,19,0,null,null,null,null,false],[1,20,0,null,null,null,null,false],[0,0,0,"linked_list.zig",null,"",[],false],[29,0,0,null,null,null,null,false],[29,1,0,null,null,null,null,false],[29,2,0,null,null,null,null,false],[29,3,0,null,null,null,null,false],[29,12,0,null,null," A singly-linked list is headed by a single forward pointer. The elements\n are singly-linked for minimum space and pointer manipulation overhead at\n the expense of O(n) removal for arbitrary elements. New elements can be\n added to the list after an existing element or at the head of the list.\n A singly-linked list may only be traversed in the forward direction.\n Singly-linked lists are ideal for applications with large datasets and\n few or no removals or for implementing a LIFO queue.",[4515],false],[0,0,0,"T",null,"",[4545],true],[29,14,0,null,null,null,null,false],[29,17,0,null,null," Node inside the linked list wrapping the actual data.",[4531,4533],false],[29,21,0,null,null,null,null,false],[29,27,0,null,null," Insert a new node after the current one.\n\n Arguments:\n     new_node: Pointer to the new node to insert.",[4520,4521],false],[0,0,0,"node",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[29,38,0,null,null," Remove a node from the list.\n\n Arguments:\n     node: Pointer to the node to be removed.\n Returns:\n     node removed",[4523],false],[0,0,0,"node",null,"",null,false],[29,46,0,null,null," Iterate over the singly-linked list from this node, until the final node is found.\n This operation is O(N).",[4525],false],[0,0,0,"node",null,"",null,false],[29,55,0,null,null," Iterate over each next node, returning the count of all nodes except the starting one.\n This operation is O(N).",[4527],false],[0,0,0,"node",null,"",null,false],[29,66,0,null,null," Reverse the list starting from this node in-place.\n This operation is O(N).",[4529],false],[0,0,0,"indirect",null,"",null,false],[29,17,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[29,17,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[29,85,0,null,null," Insert a new node at the head.\n\n Arguments:\n     new_node: Pointer to the new node to insert.",[4535,4536],false],[0,0,0,"list",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[29,94,0,null,null," Remove a node from the list.\n\n Arguments:\n     node: Pointer to the node to be removed.",[4538,4539],false],[0,0,0,"list",null,"",null,false],[0,0,0,"node",null,"",null,false],[29,110,0,null,null," Remove and return the first node in the list.\n\n Returns:\n     A pointer to the first node in the list.",[4541],false],[0,0,0,"list",null,"",null,false],[29,118,0,null,null," Iterate over all nodes, returning the count.\n This operation is O(N).",[4543],false],[0,0,0,"list",null,"",null,false],[29,13,0,null,null,null,null,false],[0,0,0,"first",null,null,null,false],[29,183,0,null,null," A doubly-linked list has a pair of pointers to both the head and\n tail of the list. List elements have pointers to both the previous\n and next elements in the sequence. The list can be traversed both\n forward and backward. Some operations that take linear O(n) time\n with a singly-linked list can be done without traversal in constant\n O(1) time with a doubly-linked list:\n\n - Removing an element.\n - Inserting a new element before an existing element.\n - Pushing or popping an element from the end of the list.",[4547],false],[0,0,0,"T",null,"",[4581,4583,4584],true],[29,185,0,null,null,null,null,false],[29,188,0,null,null," Node inside the linked list wrapping the actual data.",[4551,4553,4555],false],[29,188,0,null,null,null,null,false],[0,0,0,"prev",null,null,null,false],[29,188,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[29,188,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[29,203,0,null,null," Insert a new node after an existing one.\n\n Arguments:\n     node: Pointer to a node in the list.\n     new_node: Pointer to the new node to insert.",[4557,4558,4559],false],[0,0,0,"list",null,"",null,false],[0,0,0,"node",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[29,224,0,null,null," Insert a new node before an existing one.\n\n Arguments:\n     node: Pointer to a node in the list.\n     new_node: Pointer to the new node to insert.",[4561,4562,4563],false],[0,0,0,"list",null,"",null,false],[0,0,0,"node",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[29,245,0,null,null," Concatenate list2 onto the end of list1, removing all entries from the former.\n\n Arguments:\n     list1: the list to concatenate onto\n     list2: the list to be concatenated",[4565,4566],false],[0,0,0,"list1",null,"",null,false],[0,0,0,"list2",null,"",null,false],[29,266,0,null,null," Insert a new node at the end of the list.\n\n Arguments:\n     new_node: Pointer to the new node to insert.",[4568,4569],false],[0,0,0,"list",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[29,280,0,null,null," Insert a new node at the beginning of the list.\n\n Arguments:\n     new_node: Pointer to the new node to insert.",[4571,4572],false],[0,0,0,"list",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[29,299,0,null,null," Remove a node from the list.\n\n Arguments:\n     node: Pointer to the node to be removed.",[4574,4575],false],[0,0,0,"list",null,"",null,false],[0,0,0,"node",null,"",null,false],[29,324,0,null,null," Remove and return the last node in the list.\n\n Returns:\n     A pointer to the last node in the list.",[4577],false],[0,0,0,"list",null,"",null,false],[29,334,0,null,null," Remove and return the first node in the list.\n\n Returns:\n     A pointer to the first node in the list.",[4579],false],[0,0,0,"list",null,"",null,false],[29,184,0,null,null,null,null,false],[0,0,0,"first",null,null,null,false],[29,184,0,null,null,null,null,false],[0,0,0,"last",null,null,null,false],[0,0,0,"len",null,null,null,false],[1,21,0,null,null,null,null,false],[0,0,0,"dynamic_library.zig",null,"",[],false],[30,0,0,null,null,null,null,false],[30,1,0,null,null,null,null,false],[30,2,0,null,null,null,null,false],[30,3,0,null,null,null,null,false],[30,4,0,null,null,null,null,false],[30,5,0,null,null,null,null,false],[30,6,0,null,null,null,null,false],[30,7,0,null,null,null,null,false],[30,9,0,null,null,null,null,false],[30,21,0,null,null,null,[4604,4606,4608,4610,4612],false],[30,28,0,null,null,null,[4603],false],[30,31,0,null,null,null,[4599],false],[0,0,0,"self",null,"",null,false],[30,35,0,null,null,null,[4601],false],[0,0,0,"self",null,"",null,false],[30,28,0,null,null,null,null,false],[0,0,0,"current",null,null,null,false],[0,0,0,"l_addr",null,null,null,false],[30,21,0,null,null,null,null,false],[0,0,0,"l_name",null,null,null,false],[30,21,0,null,null,null,null,false],[0,0,0,"l_ld",null,null,null,false],[30,21,0,null,null,null,null,false],[0,0,0,"l_next",null,null,null,false],[30,21,0,null,null,null,null,false],[0,0,0,"l_prev",null,null,null,false],[30,45,0,null,null,null,[4614,4616,4617,4618],false],[0,0,0,"r_version",null,null,null,false],[30,45,0,null,null,null,null,false],[0,0,0,"r_map",null,null,null,false],[0,0,0,"r_brk",null,null,null,false],[0,0,0,"r_ldbase",null,null,null,false],[30,54,0,null,null," TODO make it possible to reference this same external symbol 2x so we don't need this\n helper function.",[],false],[30,58,0,null,null,null,[4621],false],[0,0,0,"phdrs",null,"",null,false],[30,94,0,null,null,null,[4641,4643,4645,4647,4649,4651],false],[30,102,0,null,null,null,null,false],[30,113,0,null,null," Trusts the file. Malicious file will be able to execute arbitrary code.",[4625],false],[0,0,0,"path",null,"",null,false],[30,249,0,null,null," Trusts the file. Malicious file will be able to execute arbitrary code.",[4627],false],[0,0,0,"path_c",null,"",null,false],[30,254,0,null,null," Trusts the file",[4629],false],[0,0,0,"self",null,"",null,false],[30,259,0,null,null,null,[4631,4632,4633],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"name",null,"",null,false],[30,268,0,null,null," Returns the address of the symbol",[4635,4636,4637],false],[0,0,0,"self",null,"",null,false],[0,0,0,"vername",null,"",null,false],[0,0,0,"name",null,"",null,false],[30,290,0,null,null,null,[4639],false],[0,0,0,"elf_prot",null,"",null,false],[30,94,0,null,null,null,null,false],[0,0,0,"strings",null,null,null,false],[30,94,0,null,null,null,null,false],[0,0,0,"syms",null,null,null,false],[30,94,0,null,null,null,null,false],[0,0,0,"hashtab",null,null,null,false],[30,94,0,null,null,null,null,false],[0,0,0,"versym",null,null,null,false],[30,94,0,null,null,null,null,false],[0,0,0,"verdef",null,null,null,false],[30,94,0,null,null,null,null,false],[0,0,0,"memory",null,null,null,false],[30,299,0,null,null,null,[4653,4654,4655,4656],false],[0,0,0,"def_arg",null,"",null,false],[0,0,0,"vsym_arg",null,"",null,false],[0,0,0,"vername",null,"",null,false],[0,0,0,"strings",null,"",null,false],[30,313,0,null,null,null,[4672],false],[30,314,0,null,null,null,null,false],[30,318,0,null,null,null,[4660],false],[0,0,0,"path",null,"",null,false],[30,323,0,null,null,null,[4662],false],[0,0,0,"path_c",null,"",null,false],[30,328,0,null,null,null,[4664],false],[0,0,0,"path_w",null,"",null,false],[30,340,0,null,null,null,[4666],false],[0,0,0,"self",null,"",null,false],[30,345,0,null,null,null,[4668,4669,4670],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"name",null,"",null,false],[30,313,0,null,null,null,null,false],[0,0,0,"dll",null,null,null,false],[30,354,0,null,null,null,[4686],false],[30,355,0,null,null,null,null,false],[30,359,0,null,null,null,[4676],false],[0,0,0,"path",null,"",null,false],[30,364,0,null,null,null,[4678],false],[0,0,0,"path_c",null,"",null,false],[30,372,0,null,null,null,[4680],false],[0,0,0,"self",null,"",null,false],[30,377,0,null,null,null,[4682,4683,4684],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"name",null,"",null,false],[30,354,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[1,22,0,null,null,null,null,false],[1,23,0,null,null,null,null,false],[1,24,0,null,null,null,null,false],[1,25,0,null,null,null,null,false],[1,26,0,null,null,null,null,false],[1,27,0,null,null,null,null,false],[1,28,0,null,null,null,null,false],[1,29,0,null,null,null,null,false],[0,0,0,"Ini.zig",null,"",[4715],false],[31,2,0,null,null,null,[4700,4702,4704],false],[31,7,0,null,null,null,[4698],false],[0,0,0,"it",null,"",null,false],[31,2,0,null,null,null,null,false],[0,0,0,"ini",null,null,null,false],[31,2,0,null,null,null,null,false],[0,0,0,"next_index",null,null,null,false],[31,2,0,null,null,null,null,false],[0,0,0,"header",null,null,null,false],[31,23,0,null,null," Asserts that `header` includes \"\\n[\" at the beginning and \"]\\n\" at the end.\n `header` must remain valid for the lifetime of the iterator.",[4706,4707],false],[0,0,0,"ini",null,"",null,false],[0,0,0,"header",null,"",null,false],[31,38,0,null,null,null,null,false],[31,39,0,null,null,null,null,false],[31,40,0,null,null,null,null,false],[31,41,0,null,null,null,null,false],[31,42,0,null,null,null,null,false],[31,44,0,"iterateSection","test iterateSection {\n    const example =\n        \\\\[package]\n        \\\\name=libffmpeg\n        \\\\version=5.1.2\n        \\\\\n        \\\\[dependency]\n        \\\\id=libz\n        \\\\url=url1\n        \\\\\n        \\\\[dependency]\n        \\\\id=libmp3lame\n        \\\\url=url2\n    ;\n    var ini: Ini = .{ .bytes = example };\n    var it = ini.iterateSection(\"\\n[dependency]\\n\");\n    const section1 = it.next() orelse return error.TestFailed;\n    try testing.expectEqualStrings(\"id=libz\\nurl=url1\\n\", section1);\n    const section2 = it.next() orelse return error.TestFailed;\n    try testing.expectEqualStrings(\"id=libmp3lame\\nurl=url2\", section2);\n    try testing.expect(it.next() == null);\n}",null,null,false],[31,0,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[1,30,0,null,null,null,null,false],[0,0,0,"multi_array_list.zig",null,"",[],false],[32,0,0,null,null,null,null,false],[32,1,0,null,null,null,null,false],[32,2,0,null,null,null,null,false],[32,3,0,null,null,null,null,false],[32,4,0,null,null,null,null,false],[32,5,0,null,null,null,null,false],[32,6,0,null,null,null,null,false],[32,19,0,null,null," A MultiArrayList stores a list of a struct or tagged union type.\n Instead of storing a single list of items, MultiArrayList\n stores separate lists for each field of the struct or\n lists of tags and bare unions.\n This allows for memory savings if the struct or union has padding,\n and also improves cache usage if only some fields or just tags\n are needed for a computation.  The primary API for accessing fields is\n the `slice()` function, which computes the start pointers\n for the array of each field.  From the slice you can call\n `.items(.<field_name>)` to obtain a slice of field values.\n For unions you can call `.items(.tags)` or `.items(.data)`.",[4726],false],[0,0,0,"T",null,"",[4868,4869,4870],true],[32,25,0,null,null,null,null,false],[32,58,0,null,null,null,null,false],[32,64,0,null,null," A MultiArrayList.Slice contains cached start pointers for each field in the list.\n These pointers are not normally stored to reduce the size of the list in memory.\n If you are accessing multiple fields, call slice() first to compute the pointers,\n and then get the field arrays from the slice.",[4751,4752,4753],false],[32,71,0,null,null,null,[4731,4732],false],[0,0,0,"self",null,"",null,false],[0,0,0,"field",null,"",null,true],[32,84,0,null,null,null,[4734,4735,4736],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"elem",null,"",null,false],[32,95,0,null,null,null,[4738,4739],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[32,107,0,null,null,null,[4741],false],[0,0,0,"self",null,"",null,false],[32,120,0,null,null,null,[4743,4744],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[32,128,0,null,null," This function is used in the debugger pretty formatters in tools/ to fetch the\n child field order and entry type to facilitate fancy debug printing for this type.",[4746,4747,4748,4749],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child",null,"",null,false],[0,0,0,"field",null,"",null,false],[0,0,0,"entry",null,"",null,false],[32,64,0,null,null,null,null,false],[0,0,0,"ptrs",null," This array is indexed by the field index which can be obtained\n by using @intFromEnum() on the Field enum",null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"capacity",null,null,null,false],[32,136,0,null,null,null,null,false],[32,138,0,null,null,null,null,false],[32,141,0,null,null," `sizes.bytes` is an array of @sizeOf each T field. Sorted by alignment, descending.\n `sizes.fields` is an array mapping from `sizes.bytes` array index to field index.",null,false],[32,175,0,null,null," Release all allocated memory.",[4758,4759],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[32,181,0,null,null," The caller owns the returned memory. Empties this MultiArrayList.",[4761],false],[0,0,0,"self",null,"",null,false],[32,190,0,null,null," Compute pointers to the start of each field of the array.\n If you need to access multiple fields, calling this may\n be more efficient than calling `items()` multiple times.",[4763],false],[0,0,0,"self",null,"",null,false],[32,207,0,null,null," Get the slice of values for a specified field.\n If you need multiple fields, consider calling slice()\n instead.",[4765,4766],false],[0,0,0,"self",null,"",null,false],[0,0,0,"field",null,"",null,true],[32,212,0,null,null," Overwrite one array element with new data.",[4768,4769,4770],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"elem",null,"",null,false],[32,218,0,null,null," Obtain all the data for one array element.",[4772,4773],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[32,223,0,null,null," Extend the list by 1 element. Allocates more memory as necessary.",[4775,4776,4777],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"elem",null,"",null,false],[32,230,0,null,null," Extend the list by 1 element, but asserting `self.capacity`\n is sufficient to hold an additional item.",[4779,4780],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[32,239,0,null,null," Extend the list by 1 element, returning the newly reserved\n index with uninitialized data.\n Allocates more memory as necesasry.",[4782,4783],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[32,247,0,null,null," Extend the list by 1 element, asserting `self.capacity`\n is sufficient to hold an additional item.  Returns the\n newly reserved index with uninitialized data.",[4785],false],[0,0,0,"self",null,"",null,false],[32,257,0,null,null," Remove and return the last element from the list.\n Asserts the list has at least one item.\n Invalidates pointers to fields of the removed element.",[4787],false],[0,0,0,"self",null,"",null,false],[32,266,0,null,null," Remove and return the last element from the list, or\n return `null` if list is empty.\n Invalidates pointers to fields of the removed element, if any.",[4789],false],[0,0,0,"self",null,"",null,false],[32,275,0,null,null," Inserts an item into an ordered list.  Shifts all elements\n after and including the specified index back by one and\n sets the given index to the specified element.  May reallocate\n and invalidate iterators.",[4791,4792,4793,4794],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"elem",null,"",null,false],[32,284,0,null,null," Inserts an item into an ordered list which has room for it.\n Shifts all elements after and including the specified index\n back by one and sets the given index to the specified element.\n Will not reallocate the array, does not invalidate iterators.",[4796,4797,4798],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"elem",null,"",null,false],[32,307,0,null,null," Remove the specified item from the list, swapping the last\n item in the list into its position.  Fast, but does not\n retain list ordering.",[4800,4801],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[32,319,0,null,null," Remove the specified item from the list, shifting items\n after it to preserve order.",[4803,4804],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[32,334,0,null,null," Adjust the list's length to `new_len`.\n Does not initialize added items, if any.",[4806,4807,4808],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[32,342,0,null,null," Attempt to reduce allocated capacity to `new_len`.\n If `new_len` is greater than zero, this may fail to reduce the capacity,\n but the data remains intact and the length is updated to new_len.",[4810,4811,4812],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[32,391,0,null,null," Reduce length to `new_len`.\n Invalidates pointers to elements `items[new_len..]`.\n Keeps capacity the same.",[4814,4815],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[32,398,0,null,null," Modify the array so that it can hold at least `new_capacity` items.\n Implements super-linear growth to achieve amortized O(1) append operations.\n Invalidates pointers if additional memory is needed.",[4817,4818,4819],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[32,412,0,null,null," Modify the array so that it can hold at least `additional_count` **more** items.\n Invalidates pointers if additional memory is needed.",[4821,4822,4823],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[32,419,0,null,null," Modify the array so that it can hold exactly `new_capacity` items.\n Invalidates pointers if additional memory is needed.\n `new_capacity` must be greater or equal to `len`.",[4825,4826,4827],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[32,451,0,null,null," Create a copy of this list with a new backing store,\n using the specified allocator.",[4829,4830],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[32,469,0,null,null," `ctx` has the following method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[4832,4833,4834,4835,4836],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"mode",null,"",[4837,4838],true],[0,0,0,"stable",null,null,null,false],[0,0,0,"unstable",null,null,null,false],[32,503,0,null,null," This function guarantees a stable sort, i.e the relative order of equal elements is preserved during sorting.\n Read more about stable sorting here: https://en.wikipedia.org/wiki/Sorting_algorithm#Stability\n If this guarantee does not matter, `sortUnstable` might be a faster alternative.\n `ctx` has the following method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[4840,4841],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[32,513,0,null,null," Sorts only the subsection of items between indices `a` and `b` (excluding `b`)\n This function guarantees a stable sort, i.e the relative order of equal elements is preserved during sorting.\n Read more about stable sorting here: https://en.wikipedia.org/wiki/Sorting_algorithm#Stability\n If this guarantee does not matter, `sortSpanUnstable` might be a faster alternative.\n `ctx` has the following method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[4843,4844,4845,4846],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[32,522,0,null,null," This function does NOT guarantee a stable sort, i.e the relative order of equal elements may change during sorting.\n Due to the weaker guarantees of this function, this may be faster than the stable `sort` method.\n Read more about stable sorting here: https://en.wikipedia.org/wiki/Sorting_algorithm#Stability\n `ctx` has the following method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[4848,4849],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[32,532,0,null,null," Sorts only the subsection of items between indices `a` and `b` (excluding `b`)\n This function does NOT guarantee a stable sort, i.e the relative order of equal elements may change during sorting.\n Due to the weaker guarantees of this function, this may be faster than the stable `sortSpan` method.\n Read more about stable sorting here: https://en.wikipedia.org/wiki/Sorting_algorithm#Stability\n `ctx` has the following method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[4851,4852,4853,4854],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[32,536,0,null,null,null,[4856],false],[0,0,0,"capacity",null,"",null,false],[32,542,0,null,null,null,[4858],false],[0,0,0,"self",null,"",null,false],[32,546,0,null,null,null,[4860],false],[0,0,0,"field",null,"",null,true],[32,550,0,null,null,null,null,false],[32,568,0,null,null," This function is used in the debugger pretty formatters in tools/ to fetch the\n child field order and entry type to facilitate fancy debug printing for this type.",[4863,4864,4865,4866],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child",null,"",null,false],[0,0,0,"field",null,"",null,false],[0,0,0,"entry",null,"",null,false],[32,20,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"capacity",null,null,null,false],[1,31,0,null,null,null,null,false],[0,0,0,"packed_int_array.zig",null," A set of array and slice types that bit-pack integer elements. A normal [12]u3\n takes up 12 bytes of memory since u3's alignment is 1. PackedArray(u3, 12) only\n takes up 4 bytes of memory.\n",[],false],[33,4,0,null,null,null,null,false],[33,5,0,null,null,null,null,false],[33,6,0,null,null,null,null,false],[33,7,0,null,null,null,null,false],[33,8,0,null,null,null,null,false],[33,9,0,null,null,null,null,false],[33,13,0,null,null," Provides a set of functions for reading and writing packed integers from a\n slice of bytes.",[4880,4881],false],[0,0,0,"Int",null,"",null,true],[0,0,0,"endian",null,"",[],true],[33,55,0,null,null," Retrieves the integer at `index` from the packed data beginning at `bit_offset`\n within `bytes`.",[4883,4884,4885],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[33,66,0,null,null,null,[4887,4888,4889],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"Container",null,"",null,true],[0,0,0,"bit_index",null,"",null,false],[33,98,0,null,null," Sets the integer at `index` to `val` within the packed data beginning\n at `bit_offset` into `bytes`.",[4891,4892,4893,4894],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"int",null,"",null,false],[33,109,0,null,null,null,[4896,4897,4898,4899],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"Container",null,"",null,true],[0,0,0,"bit_index",null,"",null,false],[0,0,0,"int",null,"",null,false],[33,146,0,null,null," Provides a PackedIntSlice of the packed integers in `bytes` (which begins at `bit_offset`)\n from the element specified by `start` to the element specified by `end`.",[4901,4902,4903,4904],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[33,165,0,null,null," Recasts a packed slice to a version with elements of type `NewInt` and endianness `new_endian`.\n Slice will begin at `bit_offset` within `bytes` and the new length will be automatically\n calculated from `old_len` using the sizes of the current integer type and `NewInt`.",[4906,4907,4908,4909,4910],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"NewInt",null,"",null,true],[0,0,0,"new_endian",null,"",null,true],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"old_len",null,"",null,false],[33,187,0,null,null," Creates a bit-packed array of `Int`. Non-byte-multiple integers\n will take up less memory in PackedIntArray than in a normal array.\n Elements are packed using native endianness and without storing any\n meta data. PackedArray(i3, 8) will occupy exactly 3 bytes\n of memory.",[4912,4913],false],[0,0,0,"Int",null,"",null,true],[0,0,0,"int_count",null,"",null,true],[33,195,0,null,null," Creates a bit-packed array of `Int` with bit order specified by `endian`.\n Non-byte-multiple integers will take up less memory in PackedIntArrayEndian\n than in a normal array. Elements are packed without storing any meta data.\n PackedIntArrayEndian(i3, 8) will occupy exactly 3 bytes of memory.",[4915,4916,4917],false],[0,0,0,"Int",null,"",null,true],[0,0,0,"endian",null,"",null,true],[0,0,0,"int_count",null,"",[4946,4947],true],[33,203,0,null,null,null,null,false],[33,211,0,null,null," The integer type of the packed array.",null,false],[33,215,0,null,null," Initialize a packed array using an unpacked array\n or, more likely, an array literal.",[4921],false],[0,0,0,"ints",null,"",null,false],[33,222,0,null,null," Initialize all entries of a packed array to the same value.",[4923],false],[0,0,0,"int",null,"",null,false],[33,230,0,null,null," Return the integer stored at `index`.",[4925,4926],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[33,236,0,null,null,"Copy the value of `int` into the array at `index`.",[4928,4929,4930],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"int",null,"",null,false],[33,242,0,null,null," Set all entries of a packed array to the value of `int`.",[4932,4933],false],[0,0,0,"self",null,"",null,false],[0,0,0,"int",null,"",null,false],[33,250,0,null,null," Create a PackedIntSlice of the array from `start` to `end`.",[4935,4936,4937],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[33,258,0,null,null," Create a PackedIntSlice of the array using `NewInt` as the integer type.\n `NewInt`'s bit width must fit evenly within the array's `Int`'s total bits.",[4939,4940],false],[0,0,0,"self",null,"",null,false],[0,0,0,"NewInt",null,"",null,true],[33,265,0,null,null," Create a PackedIntSliceEndian of the array using `NewInt` as the integer type\n and `new_endian` as the new endianness. `NewInt`'s bit width must fit evenly\n within the array's `Int`'s total bits.",[4942,4943,4944],false],[0,0,0,"self",null,"",null,false],[0,0,0,"NewInt",null,"",null,true],[0,0,0,"new_endian",null,"",null,true],[33,202,0,null,null,null,null,false],[0,0,0,"bytes",null," The byte buffer containing the packed data.",null,false],[0,0,0,"len",null," The number of elements in the packed array.",null,false],[33,272,0,null,null," A type representing a sub range of a PackedIntArray.",[4949],false],[0,0,0,"Int",null,"",null,true],[33,277,0,null,null," A type representing a sub range of a PackedIntArrayEndian.",[4951,4952],false],[0,0,0,"Int",null,"",null,true],[0,0,0,"endian",null,"",[4979,4981,4982],true],[33,282,0,null,null,null,null,false],[33,289,0,null,null," The integer type of the packed slice.",null,false],[33,293,0,null,null," Calculates the number of bytes required to store a desired count\n of `Int`s.",[4956],false],[0,0,0,"int_count",null,"",null,false],[33,302,0,null,null," Initialize a packed slice using the memory at `bytes`, with `int_count`\n elements. `bytes` must be large enough to accommodate the requested\n count.",[4958,4959],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"int_count",null,"",null,false],[33,313,0,null,null," Return the integer stored at `index`.",[4961,4962],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[33,319,0,null,null," Copy `int` into the slice at `index`.",[4964,4965,4966],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"int",null,"",null,false],[33,325,0,null,null," Create a PackedIntSlice of this slice from `start` to `end`.",[4968,4969,4970],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[33,333,0,null,null," Create a PackedIntSlice of the sclice using `NewInt` as the integer type.\n `NewInt`'s bit width must fit evenly within the slice's `Int`'s total bits.",[4972,4973],false],[0,0,0,"self",null,"",null,false],[0,0,0,"NewInt",null,"",null,true],[33,340,0,null,null," Create a PackedIntSliceEndian of the slice using `NewInt` as the integer type\n and `new_endian` as the new endianness. `NewInt`'s bit width must fit evenly\n within the slice's `Int`'s total bits.",[4975,4976,4977],false],[0,0,0,"self",null,"",null,false],[0,0,0,"NewInt",null,"",null,true],[0,0,0,"new_endian",null,"",null,true],[33,281,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[33,281,0,null,null,null,null,false],[0,0,0,"bit_offset",null,null,null,false],[0,0,0,"len",null,null,null,false],[1,32,0,null,null,null,null,false],[1,33,0,null,null,null,null,false],[1,34,0,null,null,null,null,false],[1,35,0,null,null,null,null,false],[0,0,0,"priority_queue.zig",null,"",[],false],[34,0,0,null,null,null,null,false],[34,1,0,null,null,null,null,false],[34,2,0,null,null,null,null,false],[34,3,0,null,null,null,null,false],[34,4,0,null,null,null,null,false],[34,5,0,null,null,null,null,false],[34,6,0,null,null,null,null,false],[34,7,0,null,null,null,null,false],[34,16,0,null,null," Priority queue for storing generic data. Initialize with `init`.\n Provide `compareFn` that returns `Order.lt` when its second\n argument should get popped before its third argument,\n `Order.eq` if the arguments are of equal priority, or `Order.gt`\n if the third argument should be popped first.\n For example, to make `pop` return the smallest number, provide\n `fn lessThan(context: void, a: T, b: T) Order { _ = context; return std.math.order(a, b); }`",[4997,4998,4999],false],[0,0,0,"T",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"compareFn",null,"",[5000,5001,5002],true],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",[5067,5068,5070,5072],false],[34,18,0,null,null,null,null,false],[34,26,0,null,null," Initialize and return a priority queue.",[5005,5006],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"context",null,"",null,false],[34,36,0,null,null," Free memory used by the queue.",[5008],false],[0,0,0,"self",null,"",null,false],[34,41,0,null,null," Insert a new element, maintaining priority.",[5010,5011],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[34,46,0,null,null,null,[5013,5014],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[34,52,0,null,null,null,[5016,5017],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[34,66,0,null,null," Add each element in `items` to the queue.",[5019,5020],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[34,75,0,null,null," Look at the highest priority element in the queue. Returns\n `null` if empty.",[5022],false],[0,0,0,"self",null,"",null,false],[34,81,0,null,null," Pop the highest priority element from the queue. Returns\n `null` if empty.",[5024],false],[0,0,0,"self",null,"",null,false],[34,87,0,null,null," Remove and return the highest priority element from the\n queue.",[5026],false],[0,0,0,"self",null,"",null,false],[34,94,0,null,null," Remove and return element at index. Indices are in the\n same order as iterator, which is not necessarily priority\n order.",[5028,5029],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[34,118,0,null,null," Return the number of elements remaining in the priority\n queue.",[5031],false],[0,0,0,"self",null,"",null,false],[34,124,0,null,null," Return the number of elements that can be added to the\n queue before more memory is allocated.",[5033],false],[0,0,0,"self",null,"",null,false],[34,128,0,null,null,null,[5035,5036],false],[0,0,0,"self",null,"",null,false],[0,0,0,"target_index",null,"",null,false],[34,151,0,null,null," PriorityQueue takes ownership of the passed in slice. The slice must have been\n allocated with `allocator`.\n Deinitialize with `deinit`.",[5038,5039,5040],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[34,168,0,null,null," Ensure that the queue can fit at least `new_capacity` items.",[5042,5043],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[34,179,0,null,null," Ensure that the queue can fit at least `additional_count` **more** item.",[5045,5046],false],[0,0,0,"self",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[34,184,0,null,null," Reduce allocated capacity to `new_len`.",[5048,5049],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[34,198,0,null,null,null,[5051,5052,5053],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[0,0,0,"new_elem",null,"",null,false],[34,216,0,null,null,null,[5060,5061],false],[34,220,0,null,null,null,[5056],false],[0,0,0,"it",null,"",null,false],[34,227,0,null,null,null,[5058],false],[0,0,0,"it",null,"",null,false],[34,216,0,null,null,null,null,false],[0,0,0,"queue",null,null,null,false],[0,0,0,"count",null,null,null,false],[34,234,0,null,null," Return an iterator that walks the queue without consuming\n it. Invalidated if the heap is modified.",[5063],false],[0,0,0,"self",null,"",null,false],[34,241,0,null,null,null,[5065],false],[0,0,0,"self",null,"",null,false],[34,17,0,null,null,null,null,false],[0,0,0,"items",null,null,null,false],[0,0,0,"len",null,null,null,false],[34,17,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[34,17,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[34,260,0,null,null,null,[5074,5075,5076],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[34,265,0,null,null,null,[5078,5079,5080],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[34,269,0,null,null,null,null,false],[34,270,0,null,null,null,null,false],[34,598,0,null,null,null,[5084,5085,5086],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[34,602,0,null,null,null,null,false],[1,36,0,null,null,null,null,false],[0,0,0,"priority_dequeue.zig",null,"",[],false],[35,0,0,null,null,null,null,false],[35,1,0,null,null,null,null,false],[35,2,0,null,null,null,null,false],[35,3,0,null,null,null,null,false],[35,4,0,null,null,null,null,false],[35,5,0,null,null,null,null,false],[35,6,0,null,null,null,null,false],[35,7,0,null,null,null,null,false],[35,17,0,null,null," Priority Dequeue for storing generic data. Initialize with `init`.\n Provide `compareFn` that returns `Order.lt` when its second\n argument should get min-popped before its third argument,\n `Order.eq` if the arguments are of equal priority, or `Order.gt`\n if the third argument should be min-popped second.\n Popping the max element works in reverse. For example,\n to make `popMin` return the smallest number, provide\n `fn lessThan(context: void, a: T, b: T) Order { _ = context; return std.math.order(a, b); }`",[5099,5100,5101],false],[0,0,0,"T",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"compareFn",null,"",[5102,5103,5104],true],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",[5231,5232,5234,5236],false],[35,19,0,null,null,null,null,false],[35,27,0,null,null," Initialize and return a new priority dequeue.",[5107,5108],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"context",null,"",null,false],[35,37,0,null,null," Free memory used by the dequeue.",[5110],false],[0,0,0,"self",null,"",null,false],[35,42,0,null,null," Insert a new element, maintaining priority.",[5112,5113],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[35,48,0,null,null," Add each element in `items` to the dequeue.",[5115,5116],false],[0,0,0,"self",null,"",null,false],[0,0,0,"items",null,"",null,false],[35,55,0,null,null,null,[5118,5119],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[35,66,0,null,null,null,[5121],false],[0,0,0,"index",null,"",null,false],[35,74,0,null,null,null,[5123],false],[0,0,0,"self",null,"",null,false],[35,78,0,null,null,null,[5125,5126],false],[0,0,0,"index",null,null,null,false],[0,0,0,"min_layer",null,null,null,false],[35,83,0,null,null,null,[5128,5129,5130],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child",null,"",null,false],[0,0,0,"index",null,"",null,false],[35,106,0,null,null,null,[5132,5133],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,"",null,false],[35,114,0,null,null,null,[5135,5136,5137],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"target_order",null,"",null,false],[35,133,0,null,null," Look at the smallest element in the dequeue. Returns\n `null` if empty.",[5139],false],[0,0,0,"self",null,"",null,false],[35,139,0,null,null," Look at the largest element in the dequeue. Returns\n `null` if empty.",[5141],false],[0,0,0,"self",null,"",null,false],[35,146,0,null,null,null,[5143],false],[0,0,0,"self",null,"",null,false],[35,155,0,null,null," Pop the smallest element from the dequeue. Returns\n `null` if empty.",[5145],false],[0,0,0,"self",null,"",null,false],[35,161,0,null,null," Remove and return the smallest element from the\n dequeue.",[5147],false],[0,0,0,"self",null,"",null,false],[35,167,0,null,null," Pop the largest element from the dequeue. Returns\n `null` if empty.",[5149],false],[0,0,0,"self",null,"",null,false],[35,173,0,null,null," Remove and return the largest element from the\n dequeue.",[5151],false],[0,0,0,"self",null,"",null,false],[35,180,0,null,null," Remove and return element at index. Indices are in the\n same order as iterator, which is not necessarily priority\n order.",[5153,5154],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[35,192,0,null,null,null,[5156,5157],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[35,200,0,null,null,null,[5159,5160,5161],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"target_order",null,"",null,false],[35,257,0,null,null,null,[5163,5164,5165,5166],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child",null,"",null,false],[0,0,0,"child_index",null,"",null,false],[0,0,0,"target_order",null,"",null,false],[35,267,0,null,null,null,[5169,5170],false],[35,267,0,null,null,null,null,false],[0,0,0,"item",null,null,null,false],[0,0,0,"index",null,null,null,false],[35,272,0,null,null,null,[5172,5173],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[35,279,0,null,null,null,[5175,5176,5177,5178],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item1",null,"",null,false],[0,0,0,"item2",null,"",null,false],[0,0,0,"target_order",null,"",null,false],[35,287,0,null,null,null,[5180,5181,5182,5183],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index1",null,"",null,false],[0,0,0,"index2",null,"",null,false],[0,0,0,"target_order",null,"",null,false],[35,293,0,null,null,null,[5185,5186,5187,5188],false],[0,0,0,"self",null,"",null,false],[0,0,0,"first_child_index",null,"",null,false],[0,0,0,"first_grandchild_index",null,"",null,false],[0,0,0,"target_order",null,"",null,false],[35,325,0,null,null," Return the number of elements remaining in the dequeue",[5190],false],[0,0,0,"self",null,"",null,false],[35,331,0,null,null," Return the number of elements that can be added to the\n dequeue before more memory is allocated.",[5192],false],[0,0,0,"self",null,"",null,false],[35,338,0,null,null," Dequeue takes ownership of the passed in slice. The slice must have been\n allocated with `allocator`.\n De-initialize with `deinit`.",[5194,5195,5196],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[35,358,0,null,null," Ensure that the dequeue can fit at least `new_capacity` items.",[5198,5199],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[35,369,0,null,null," Ensure that the dequeue can fit at least `additional_count` **more** items.",[5201,5202],false],[0,0,0,"self",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[35,374,0,null,null," Reduce allocated capacity to `new_len`.",[5204,5205],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[35,388,0,null,null,null,[5207,5208,5209],false],[0,0,0,"self",null,"",null,false],[0,0,0,"elem",null,"",null,false],[0,0,0,"new_elem",null,"",null,false],[35,401,0,null,null,null,[5216,5217],false],[35,405,0,null,null,null,[5212],false],[0,0,0,"it",null,"",null,false],[35,412,0,null,null,null,[5214],false],[0,0,0,"it",null,"",null,false],[35,401,0,null,null,null,null,false],[0,0,0,"queue",null,null,null,false],[0,0,0,"count",null,null,null,false],[35,419,0,null,null," Return an iterator that walks the queue without consuming\n it. Invalidated if the queue is modified.",[5219],false],[0,0,0,"self",null,"",null,false],[35,426,0,null,null,null,[5221],false],[0,0,0,"self",null,"",null,false],[35,443,0,null,null,null,[5223],false],[0,0,0,"index",null,"",null,false],[35,447,0,null,null,null,[5225],false],[0,0,0,"index",null,"",null,false],[35,451,0,null,null,null,[5227],false],[0,0,0,"index",null,"",null,false],[35,455,0,null,null,null,[5229],false],[0,0,0,"index",null,"",null,false],[35,18,0,null,null,null,null,false],[0,0,0,"items",null,null,null,false],[0,0,0,"len",null,null,null,false],[35,18,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[35,18,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[35,461,0,null,null,null,[5238,5239,5240],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[35,466,0,null,null,null,null,false],[35,879,0,null,null,null,[5243,5244],false],[0,0,0,"rng",null,"",null,false],[0,0,0,"queue_size",null,"",null,true],[35,908,0,null,null,null,[5246,5247],false],[0,0,0,"rng",null,"",null,false],[0,0,0,"queue_size",null,"",null,false],[35,937,0,null,null,null,[5249,5250],false],[0,0,0,"rng",null,"",null,false],[0,0,0,"queue_size",null,"",null,false],[35,964,0,null,null,null,[5252,5253,5254],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"rng",null,"",null,false],[0,0,0,"size",null,"",null,false],[35,977,0,null,null,null,[5256,5257,5258],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[35,981,0,null,null,null,null,false],[35,1005,0,null,null,null,null,false],[1,37,0,null,null,null,null,false],[0,0,0,"Progress.zig",null," This API non-allocating, non-fallible, and thread-safe.\n The tradeoff is that users of this API must provide the storage\n for each `Progress.Node`.\n\n Initialize the struct directly, overriding these fields as desired:\n * `refresh_rate_ms`\n * `initial_delay_ms`\n",[5334,5335,5336,5337,5339,5341,5342,5344,5345,5346,5347,5349,5350],false],[36,8,0,null,null,null,null,false],[36,9,0,null,null,null,null,false],[36,10,0,null,null,null,null,false],[36,11,0,null,null,null,null,false],[36,12,0,null,null,null,null,false],[36,13,0,null,null,null,null,false],[36,66,0,null,null," Represents one unit of progress. Each node can have children nodes, or\n one can use integers with `update`.",[5293,5295,5297,5299,5301,5302,5303],false],[36,84,0,null,null," Create a new child progress node. Thread-safe.\n Call `Node.end` when done.\n TODO solve https://github.com/ziglang/zig/issues/2765 and then change this\n API to set `self.parent.recently_updated_child` with the return value.\n Until that is fixed you probably want to call `activate` on the return value.\n Passing 0 for `estimated_total_items` means unknown.",[5271,5272,5273],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"estimated_total_items",null,"",null,false],[36,95,0,null,null," This is the same as calling `start` and then `end` on the returned `Node`. Thread-safe.",[5275],false],[0,0,0,"self",null,"",null,false],[36,104,0,null,null," Finish a started `Node`. Thread-safe.",[5277],false],[0,0,0,"self",null,"",null,false],[36,122,0,null,null," Tell the parent node that this node is actively being worked on. Thread-safe.",[5279],false],[0,0,0,"self",null,"",null,false],[36,130,0,null,null," Thread-safe.",[5281,5282],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[36,145,0,null,null," Thread-safe.",[5284,5285],false],[0,0,0,"self",null,"",null,false],[0,0,0,"unit",null,"",null,false],[36,160,0,null,null," Thread-safe. 0 means unknown.",[5287,5288],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[36,165,0,null,null," Thread-safe.",[5290,5291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"completed_items",null,"",null,false],[36,66,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[36,66,0,null,null,null,null,false],[0,0,0,"parent",null,null,null,false],[36,66,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[36,66,0,null,null,null,null,false],[0,0,0,"unit",null,null,null,false],[36,66,0,null,null,null,null,false],[0,0,0,"recently_updated_child",null," Must be handled atomically to be thread-safe.",null,false],[0,0,0,"unprotected_estimated_total_items",null," Must be handled atomically to be thread-safe. 0 means null.",null,false],[0,0,0,"unprotected_completed_items",null," Must be handled atomically to be thread-safe.",null,false],[36,175,0,null,null," Create a new progress node.\n Call `Node.end` when done.\n TODO solve https://github.com/ziglang/zig/issues/2765 and then change this\n API to return Progress rather than accept it as a parameter.\n `estimated_total_items` value of 0 means unknown.",[5305,5306,5307],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"estimated_total_items",null,"",null,false],[36,203,0,null,null," Updates the terminal if enough time has passed since last update. Thread-safe.",[5309],false],[0,0,0,"self",null,"",null,false],[36,211,0,null,null,null,[5311,5312],false],[0,0,0,"self",null,"",null,false],[0,0,0,"timer",null,"",null,false],[36,222,0,null,null," Updates the terminal and resets `self.next_refresh_timestamp`. Thread-safe.",[5314],false],[0,0,0,"self",null,"",null,false],[36,229,0,null,null,null,[5316,5317],false],[0,0,0,"p",null,"",null,false],[0,0,0,"end_ptr",null,"",null,false],[36,298,0,null,null,null,[5319],false],[0,0,0,"self",null,"",null,false],[36,349,0,null,null,null,[5321,5322,5323],false],[0,0,0,"self",null,"",null,false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[36,364,0,null,null," Allows the caller to freely write to stderr until unlock_stderr() is called.\n During the lock, the progress information is cleared from the terminal.",[5325],false],[0,0,0,"p",null,"",null,false],[36,377,0,null,null,null,[5327],false],[0,0,0,"p",null,"",null,false],[36,382,0,null,null,null,[5329,5330,5331,5332],false],[0,0,0,"self",null,"",null,false],[0,0,0,"end",null,"",null,false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[36,0,0,null,null,null,null,false],[0,0,0,"terminal",null," `null` if the current node (and its children) should\n not print on update()",null,false],[0,0,0,"is_windows_terminal",null," Is this a windows API terminal (note: this is not the same as being run on windows\n because other terminals exist like MSYS/git-bash)",null,false],[0,0,0,"supports_ansi_escape_codes",null," Whether the terminal supports ANSI escape codes.",null,false],[0,0,0,"dont_print_on_dumb",null," If the terminal is \"dumb\", don't print output.\n This can be useful if you don't want to print all\n the stages of code generation if there are a lot.\n You should not use it if the user should see output\n for example showing the user what tests run.",null,false],[36,0,0,null,null,null,null,false],[0,0,0,"root",null,null,null,false],[36,0,0,null,null,null,null,false],[0,0,0,"timer",null," Keeps track of how much time has passed since the beginning.\n Used to compare with `initial_delay_ms` and `refresh_rate_ms`.",null,false],[0,0,0,"prev_refresh_timestamp",null," When the previous refresh was written to the terminal.\n Used to compare with `refresh_rate_ms`.",null,false],[36,0,0,null,null,null,null,false],[0,0,0,"output_buffer",null," This buffer represents the maximum number of bytes written to the terminal\n with each refresh.",null,false],[0,0,0,"refresh_rate_ns",null," How many nanoseconds between writing updates to the terminal.",null,false],[0,0,0,"initial_delay_ns",null," How many nanoseconds to keep the output hidden",null,false],[0,0,0,"done",null,null,null,false],[36,0,0,null,null,null,null,false],[0,0,0,"update_mutex",null," Protects the `refresh` function, as well as `node.recently_updated_child`.\n Without this, callsites would call `Node.end` and then free `Node` memory\n while it was still being accessed by the `refresh` function.",null,false],[0,0,0,"columns_written",null," Keeps track of how many columns in the terminal have been output, so that\n we can move the cursor back later.",null,false],[1,38,0,null,null,null,null,false],[0,0,0,"RingBuffer.zig",null," This ring buffer stores read and write indices while being able to utilise\n the full backing slice by incrementing the indices modulo twice the slice's\n length and reducing indices modulo the slice's length on slice access. This\n means that whether the ring buffer is full or empty can be distinguished by\n looking at the difference between the read and write indices without adding\n an extra boolean flag or having to reserve a slot in the buffer.\n\n This ring buffer has not been implemented with thread safety in mind, and\n therefore should not be assumed to be suitable for use cases involving\n separate reader and writer threads.\n",[5404,5405,5406],false],[37,11,0,null,null,null,null,false],[37,12,0,null,null,null,null,false],[37,14,0,null,null,null,null,false],[37,20,0,null,null,null,null,false],[37,23,0,null,null," Allocate a new `RingBuffer`; `deinit()` should be called to free the buffer.",[5358,5359],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"capacity",null,"",null,false],[37,34,0,null,null," Free the data backing a `RingBuffer`; must be passed the same `Allocator` as\n `init()`.",[5361,5362],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[37,40,0,null,null," Returns `index` modulo the length of the backing slice.",[5364,5365],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[37,45,0,null,null," Returns `index` modulo twice the length of the backing slice.",[5367,5368],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[37,51,0,null,null," Write `byte` into the ring buffer. Returns `error.Full` if the ring\n buffer is full.",[5370,5371],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[37,58,0,null,null," Write `byte` into the ring buffer. If the ring buffer is full, the\n oldest byte is overwritten.",[5373,5374],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[37,65,0,null,null," Write `bytes` into the ring buffer. Returns `error.Full` if the ring\n buffer does not have enough space, without writing any data.",[5376,5377],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[37,72,0,null,null," Write `bytes` into the ring buffer. If there is not enough space, older\n bytes will be overwritten.",[5379,5380],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[37,78,0,null,null," Consume a byte from the ring buffer and return it. Returns `null` if the\n ring buffer is empty.",[5382],false],[0,0,0,"self",null,"",null,false],[37,85,0,null,null," Consume a byte from the ring buffer and return it; asserts that the buffer\n is not empty.",[5384],false],[0,0,0,"self",null,"",null,false],[37,93,0,null,null," Returns `true` if the ring buffer is empty and `false` otherwise.",[5386],false],[0,0,0,"self",null,"",null,false],[37,98,0,null,null," Returns `true` if the ring buffer is full and `false` otherwise.",[5388],false],[0,0,0,"self",null,"",null,false],[37,103,0,null,null," Returns the length",[5390],false],[0,0,0,"self",null,"",null,false],[37,112,0,null,null," A `Slice` represents a region of a ring buffer. The region is split into two\n sections as the ring buffer data will not be contiguous if the desired\n region wraps to the start of the backing slice.",[5393,5395],false],[37,112,0,null,null,null,null,false],[0,0,0,"first",null,null,null,false],[37,112,0,null,null,null,null,false],[0,0,0,"second",null,null,null,false],[37,119,0,null,null," Returns a `Slice` for the region of the ring buffer starting at\n `self.mask(start_unmasked)` with the specified length.",[5397,5398,5399],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_unmasked",null,"",null,false],[0,0,0,"length",null,"",null,false],[37,133,0,null,null," Returns a `Slice` for the last `length` bytes written to the ring buffer.\n Does not check that any bytes have been written into the region.",[5401,5402],false],[0,0,0,"self",null,"",null,false],[0,0,0,"length",null,"",null,false],[37,0,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"read_index",null,null,null,false],[0,0,0,"write_index",null,null,null,false],[1,39,0,null,null,null,null,false],[0,0,0,"segmented_list.zig",null,"",[],false],[38,0,0,null,null,null,null,false],[38,1,0,null,null,null,null,false],[38,2,0,null,null,null,null,false],[38,3,0,null,null,null,null,false],[38,4,0,null,null,null,null,false],[38,77,0,null,null," This is a stack data structure where pointers to indexes have the same lifetime as the data structure\n itself, unlike ArrayList where append() invalidates all existing element pointers.\n The tradeoff is that elements are not guaranteed to be contiguous. For that, use ArrayList.\n Note however that most elements are contiguous, making this data structure cache-friendly.\n\n Because it never has to copy elements from an old location to a new location, it does not require\n its elements to be copyable, and it avoids wasting memory when backed by an ArenaAllocator.\n Note that the append() and pop() convenience methods perform a copy, but you can instead use\n addOne(), at(), setCapacity(), and shrinkCapacity() to avoid copying items.\n\n This data structure has O(1) append and O(1) pop.\n\n It supports preallocated elements, making it especially well suited when the expected maximum\n size is small. `prealloc_item_count` must be 0, or a power of 2.",[5415,5416],false],[0,0,0,"T",null,"",null,true],[0,0,0,"prealloc_item_count",null,"",[5516,5518,5519],true],[38,79,0,null,null,null,null,false],[38,80,0,null,null,null,null,false],[38,82,0,null,null,null,null,false],[38,98,0,null,null,null,null,false],[38,100,0,null,null,null,[5422],false],[0,0,0,"SelfType",null,"",null,true],[38,108,0,null,null,null,[5424,5425],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[38,114,0,null,null,null,[5427,5428],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[38,119,0,null,null,null,[5430],false],[0,0,0,"self",null,"",null,false],[38,123,0,null,null,null,[5432,5433,5434],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"item",null,"",null,false],[38,128,0,null,null,null,[5436,5437,5438],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"items",null,"",null,false],[38,134,0,null,null,null,[5440],false],[0,0,0,"self",null,"",null,false],[38,143,0,null,null,null,[5442,5443],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[38,153,0,null,null," Reduce length to `new_len`.\n Invalidates pointers for the elements at index new_len and beyond.",[5445,5446],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[38,159,0,null,null," Invalidates all element pointers.",[5448],false],[0,0,0,"self",null,"",null,false],[38,164,0,null,null," Invalidates all element pointers.",[5450,5451],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[38,171,0,null,null," Grows or shrinks capacity to match usage.\n TODO update this and related methods to match the conventions set by ArrayList",[5453,5454,5455],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[38,181,0,null,null," Only grows capacity, or retains current capacity.",[5457,5458,5459],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[38,206,0,null,null," Only shrinks capacity or retains current capacity.\n It may fail to reduce the capacity in which case the capacity will remain unchanged.",[5461,5462,5463],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[38,238,0,null,null,null,[5465,5466],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[38,244,0,null,null,null,[5468,5469,5470],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"start",null,"",null,false],[38,269,0,null,null,null,[5472,5473],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[38,278,0,null,null,null,[5475],false],[0,0,0,"box_count",null,"",null,false],[38,285,0,null,null,null,[5477],false],[0,0,0,"shelf_index",null,"",null,false],[38,292,0,null,null,null,[5479],false],[0,0,0,"list_index",null,"",null,false],[38,299,0,null,null,null,[5481,5482],false],[0,0,0,"list_index",null,"",null,false],[0,0,0,"shelf_index",null,"",null,false],[38,306,0,null,null,null,[5484,5485,5486,5487],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"from_count",null,"",null,false],[0,0,0,"to_count",null,"",null,false],[38,314,0,null,null,null,null,false],[38,315,0,null,null,null,null,false],[38,316,0,null,null,null,[5491,5492],false],[0,0,0,"SelfType",null,"",null,true],[0,0,0,"ElementPtr",null,"",[5503,5504,5505,5507,5508],true],[38,324,0,null,null,null,[5494],false],[0,0,0,"it",null,"",null,false],[38,348,0,null,null,null,[5496],false],[0,0,0,"it",null,"",null,false],[38,365,0,null,null,null,[5498],false],[0,0,0,"it",null,"",null,false],[38,374,0,null,null,null,[5500,5501],false],[0,0,0,"it",null,"",null,false],[0,0,0,"index",null,"",null,false],[38,317,0,null,null,null,null,false],[0,0,0,"list",null,null,null,false],[0,0,0,"index",null,null,null,false],[0,0,0,"box_index",null,null,null,false],[38,317,0,null,null,null,null,false],[0,0,0,"shelf_index",null,null,null,false],[0,0,0,"shelf_size",null,null,null,false],[38,384,0,null,null,null,[5510,5511],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[38,396,0,null,null,null,[5513,5514],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[38,78,0,null,null,null,null,false],[0,0,0,"prealloc_segment",null,null,null,false],[38,78,0,null,null,null,null,false],[0,0,0,"dynamic_segments",null,null,null,false],[0,0,0,"len",null,null,null,false],[38,419,0,null,null,null,[5521],false],[0,0,0,"prealloc",null,"",null,true],[38,524,0,null,null," TODO look into why this std.math function was changed in\n fc9430f56798a53f9393a697f4ccd6bf9981b970.",[5523,5524],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[1,40,0,null,null,null,null,false],[0,0,0,"SemanticVersion.zig",null," A software version formatted according to the Semantic Versioning 2.0.0 specification.\n\n See: https://semver.org\n",[5554,5555,5556,5558,5560],false],[39,4,0,null,null,null,null,false],[39,5,0,null,null,null,null,false],[39,13,0,null,null,null,[5537,5539],false],[39,17,0,null,null,null,[5531,5532],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[39,25,0,null,null," Checks if system is guaranteed to be at least `version` or older than `version`.\n Returns `null` if a runtime check is required.",[5534,5535],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[39,13,0,null,null,null,null,false],[0,0,0,"min",null,null,null,false],[39,13,0,null,null,null,null,false],[0,0,0,"max",null,null,null,false],[39,32,0,null,null,null,[5541,5542],false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[39,84,0,null,null,null,[5544],false],[0,0,0,"text",null,"",null,false],[39,142,0,null,null,null,[5546],false],[0,0,0,"text",null,"",null,false],[39,152,0,null,null,null,[5548,5549,5550,5551],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[39,165,0,null,null,null,null,false],[39,166,0,null,null,null,null,false],[0,0,0,"major",null,null,null,false],[0,0,0,"minor",null,null,null,false],[0,0,0,"patch",null,null,null,false],[39,0,0,null,null,null,null,false],[0,0,0,"pre",null,null,null,false],[39,0,0,null,null,null,null,false],[0,0,0,"build",null,null,null,false],[1,41,0,null,null,null,null,false],[1,42,0,null,null,null,null,false],[1,43,0,null,null,null,null,false],[1,44,0,null,null,null,null,false],[1,45,0,null,null,null,null,false],[1,46,0,null,null,null,null,false],[1,48,0,null,null," deprecated: use `DoublyLinkedList`.",null,false],[1,49,0,null,null,null,null,false],[0,0,0,"target.zig",null,"",[],false],[40,0,0,null,null,null,null,false],[40,1,0,null,null,null,null,false],[40,2,0,null,null,null,null,false],[40,3,0,null,null,null,null,false],[40,5,0,null,null,null,[8848,8850,8852,8854],false],[40,11,0,null,null,null,[5704,5706],false],[40,15,0,null,null,null,[5586,5587,5588,5589,5590,5591,5592,5593,5594,5595,5596,5597,5598,5599,5600,5601,5602,5603,5604,5605,5606,5607,5608,5609,5610,5611,5612,5613,5614,5615,5616,5617,5618,5619,5620,5621,5622,5623,5624,5625,5626,5627,5628,5629],false],[40,61,0,null,null,null,[5578],false],[0,0,0,"tag",null,"",null,false],[40,68,0,null,null,null,[5580],false],[0,0,0,"tag",null,"",null,false],[40,75,0,null,null,null,[5582],false],[0,0,0,"tag",null,"",null,false],[40,85,0,null,null,null,[5584,5585],false],[0,0,0,"tag",null,"",null,false],[0,0,0,"arch",null,"",null,false],[0,0,0,"freestanding",null,null,null,false],[0,0,0,"ananas",null,null,null,false],[0,0,0,"cloudabi",null,null,null,false],[0,0,0,"dragonfly",null,null,null,false],[0,0,0,"freebsd",null,null,null,false],[0,0,0,"fuchsia",null,null,null,false],[0,0,0,"ios",null,null,null,false],[0,0,0,"kfreebsd",null,null,null,false],[0,0,0,"linux",null,null,null,false],[0,0,0,"lv2",null,null,null,false],[0,0,0,"macos",null,null,null,false],[0,0,0,"netbsd",null,null,null,false],[0,0,0,"openbsd",null,null,null,false],[0,0,0,"solaris",null,null,null,false],[0,0,0,"windows",null,null,null,false],[0,0,0,"zos",null,null,null,false],[0,0,0,"haiku",null,null,null,false],[0,0,0,"minix",null,null,null,false],[0,0,0,"rtems",null,null,null,false],[0,0,0,"nacl",null,null,null,false],[0,0,0,"aix",null,null,null,false],[0,0,0,"cuda",null,null,null,false],[0,0,0,"nvcl",null,null,null,false],[0,0,0,"amdhsa",null,null,null,false],[0,0,0,"ps4",null,null,null,false],[0,0,0,"ps5",null,null,null,false],[0,0,0,"elfiamcu",null,null,null,false],[0,0,0,"tvos",null,null,null,false],[0,0,0,"watchos",null,null,null,false],[0,0,0,"driverkit",null,null,null,false],[0,0,0,"mesa3d",null,null,null,false],[0,0,0,"contiki",null,null,null,false],[0,0,0,"amdpal",null,null,null,false],[0,0,0,"hermit",null,null,null,false],[0,0,0,"hurd",null,null,null,false],[0,0,0,"wasi",null,null,null,false],[0,0,0,"emscripten",null,null,null,false],[0,0,0,"shadermodel",null,null,null,false],[0,0,0,"uefi",null,null,null,false],[0,0,0,"opencl",null,null,null,false],[0,0,0,"glsl450",null,null,null,false],[0,0,0,"vulkan",null,null,null,false],[0,0,0,"plan9",null,null,null,false],[0,0,0,"other",null,null,null,false],[40,95,0,null,null," Based on NTDDI version constants from\n https://docs.microsoft.com/en-us/cpp/porting/modifying-winver-and-win32-winnt",[5652,5653,5654,5655,5656,5657,5658,5659,5660,5661,5662,5663,5664,5665,5666,5667,5668,5669,5670],false],[40,118,0,null,null," Latest Windows version that the Zig Standard Library is aware of",null,false],[40,122,0,null,null," Compared against build numbers reported by the runtime to distinguish win10 versions,\n where 0x0A000000 + index corresponds to the WindowsVersion u32 value.",null,false],[40,137,0,null,null," Returns whether the first version `self` is newer (greater) than or equal to the second version `ver`.",[5634,5635],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[40,141,0,null,null,null,[5644,5646],false],[40,145,0,null,null,null,[5638,5639],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[40,151,0,null,null," Checks if system is guaranteed to be at least `version` or older than `version`.\n Returns `null` if a runtime check is required.",[5641,5642],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[40,141,0,null,null,null,null,false],[0,0,0,"min",null,null,null,false],[40,141,0,null,null,null,null,false],[0,0,0,"max",null,null,null,false],[40,160,0,null,null," This function is defined to serialize a Zig source code representation of this\n type, that, when parsed, will deserialize into the same data.",[5648,5649,5650,5651],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"nt4",null,null,null,false],[0,0,0,"win2k",null,null,null,false],[0,0,0,"xp",null,null,null,false],[0,0,0,"ws2003",null,null,null,false],[0,0,0,"vista",null,null,null,false],[0,0,0,"win7",null,null,null,false],[0,0,0,"win8",null,null,null,false],[0,0,0,"win8_1",null,null,null,false],[0,0,0,"win10",null,null,null,false],[0,0,0,"win10_th2",null,null,null,false],[0,0,0,"win10_rs1",null,null,null,false],[0,0,0,"win10_rs2",null,null,null,false],[0,0,0,"win10_rs3",null,null,null,false],[0,0,0,"win10_rs4",null,null,null,false],[0,0,0,"win10_rs5",null,null,null,false],[0,0,0,"win10_19h1",null,null,null,false],[0,0,0,"win10_vb",null,null,null,false],[0,0,0,"win10_mn",null,null,null,false],[0,0,0,"win10_fe",null,null,null,false],[40,185,0,null,null,null,[5679,5681],false],[40,189,0,null,null,null,[5673,5674],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[40,195,0,null,null," Checks if system is guaranteed to be at least `version` or older than `version`.\n Returns `null` if a runtime check is required.",[5676,5677],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ver",null,"",null,false],[40,185,0,null,null,null,null,false],[0,0,0,"range",null,null,null,false],[40,185,0,null,null,null,null,false],[0,0,0,"glibc",null,null,null,false],[40,224,0,null,null," The version ranges here represent the minimum OS version to be supported\n and the maximum OS version to be supported. The default values represent\n the range that the Zig Standard Library bases its abstractions on.\n\n The minimum version of the range is the main setting to tweak for a target.\n Usually, the maximum target OS version will remain the default, which is\n the latest released version of the OS.\n\n To test at compile time if the target is guaranteed to support a given OS feature,\n one should check that the minimum version of the range is greater than or equal to\n the version the feature was introduced in.\n\n To test at compile time if the target certainly will not support a given OS feature,\n one should check that the maximum version of the range is less than the version the\n feature was introduced in.\n\n If neither of these cases apply, a runtime check should be used to determine if the\n target supports a given OS feature.\n\n Binaries built with a given maximum version will continue to function on newer\n operating system versions. However, such a binary may not take full advantage of the\n newer operating system APIs.\n\n See `Os.isAtLeast`.",[5686,5687,5688,5689],false],[40,232,0,null,null," The default `VersionRange` represents the range that the Zig Standard Library\n bases its abstractions on.",[5684,5685],false],[0,0,0,"tag",null,"",null,false],[0,0,0,"arch",null,"",null,false],[0,0,0,"none",null,null,null,false],[0,0,0,"semver",null,null,null,false],[0,0,0,"linux",null,null,null,false],[0,0,0,"windows",null,null,null,false],[40,353,0,null,null,null,[5691,5692,5693,5694],false],[0,0,0,"none",null,null,null,false],[0,0,0,"semver",null,null,null,false],[0,0,0,"linux",null,null,null,false],[0,0,0,"windows",null,null,null,false],[40,362,0,null,null," Provides a tagged union. `Target` does not store the tag because it is\n redundant with the OS tag; this function abstracts that part away.",[5696],false],[0,0,0,"self",null,"",null,false],[40,384,0,null,null," Checks if system is guaranteed to be at least `version` or older than `version`.\n Returns `null` if a runtime check is required.",[5698,5699,5700],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tag",null,"",null,true],[0,0,0,"version",null,"",null,false],[40,397,0,null,null," On Darwin, we always link libSystem which contains libc.\n Similarly on FreeBSD and NetBSD we always link system libc\n since this is the stable syscall interface.",[5702],false],[0,0,0,"os",null,"",null,false],[40,11,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[40,11,0,null,null,null,null,false],[0,0,0,"version_range",null,null,null,false],[40,450,0,null,null,null,null,false],[0,0,0,"target/aarch64.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[41,2,0,null,null,null,null,false],[41,3,0,null,null,null,null,false],[41,4,0,null,null,null,null,false],[41,6,0,null,null,null,[5713,5714,5715,5716,5717,5718,5719,5720,5721,5722,5723,5724,5725,5726,5727,5728,5729,5730,5731,5732,5733,5734,5735,5736,5737,5738,5739,5740,5741,5742,5743,5744,5745,5746,5747,5748,5749,5750,5751,5752,5753,5754,5755,5756,5757,5758,5759,5760,5761,5762,5763,5764,5765,5766,5767,5768,5769,5770,5771,5772,5773,5774,5775,5776,5777,5778,5779,5780,5781,5782,5783,5784,5785,5786,5787,5788,5789,5790,5791,5792,5793,5794,5795,5796,5797,5798,5799,5800,5801,5802,5803,5804,5805,5806,5807,5808,5809,5810,5811,5812,5813,5814,5815,5816,5817,5818,5819,5820,5821,5822,5823,5824,5825,5826,5827,5828,5829,5830,5831,5832,5833,5834,5835,5836,5837,5838,5839,5840,5841,5842,5843,5844,5845,5846,5847,5848,5849,5850,5851,5852,5853,5854,5855,5856,5857,5858,5859,5860,5861,5862,5863,5864,5865,5866,5867,5868,5869,5870,5871,5872,5873,5874,5875,5876,5877,5878,5879,5880,5881,5882,5883,5884,5885,5886,5887,5888,5889,5890,5891,5892,5893,5894,5895,5896,5897,5898,5899,5900,5901,5902,5903,5904,5905,5906,5907,5908,5909,5910],false],[0,0,0,"a510",null,null,null,false],[0,0,0,"a65",null,null,null,false],[0,0,0,"a710",null,null,null,false],[0,0,0,"a76",null,null,null,false],[0,0,0,"a78",null,null,null,false],[0,0,0,"a78c",null,null,null,false],[0,0,0,"aes",null,null,null,false],[0,0,0,"aggressive_fma",null,null,null,false],[0,0,0,"alternate_sextload_cvt_f32_pattern",null,null,null,false],[0,0,0,"altnzcv",null,null,null,false],[0,0,0,"am",null,null,null,false],[0,0,0,"amvs",null,null,null,false],[0,0,0,"arith_bcc_fusion",null,null,null,false],[0,0,0,"arith_cbz_fusion",null,null,null,false],[0,0,0,"ascend_store_address",null,null,null,false],[0,0,0,"b16b16",null,null,null,false],[0,0,0,"balance_fp_ops",null,null,null,false],[0,0,0,"bf16",null,null,null,false],[0,0,0,"brbe",null,null,null,false],[0,0,0,"bti",null,null,null,false],[0,0,0,"call_saved_x10",null,null,null,false],[0,0,0,"call_saved_x11",null,null,null,false],[0,0,0,"call_saved_x12",null,null,null,false],[0,0,0,"call_saved_x13",null,null,null,false],[0,0,0,"call_saved_x14",null,null,null,false],[0,0,0,"call_saved_x15",null,null,null,false],[0,0,0,"call_saved_x18",null,null,null,false],[0,0,0,"call_saved_x8",null,null,null,false],[0,0,0,"call_saved_x9",null,null,null,false],[0,0,0,"ccdp",null,null,null,false],[0,0,0,"ccidx",null,null,null,false],[0,0,0,"ccpp",null,null,null,false],[0,0,0,"clrbhb",null,null,null,false],[0,0,0,"cmp_bcc_fusion",null,null,null,false],[0,0,0,"complxnum",null,null,null,false],[0,0,0,"contextidr_el2",null,null,null,false],[0,0,0,"cortex_r82",null,null,null,false],[0,0,0,"crc",null,null,null,false],[0,0,0,"crypto",null,null,null,false],[0,0,0,"cssc",null,null,null,false],[0,0,0,"custom_cheap_as_move",null,null,null,false],[0,0,0,"d128",null,null,null,false],[0,0,0,"disable_latency_sched_heuristic",null,null,null,false],[0,0,0,"dit",null,null,null,false],[0,0,0,"dotprod",null,null,null,false],[0,0,0,"ecv",null,null,null,false],[0,0,0,"el2vmsa",null,null,null,false],[0,0,0,"el3",null,null,null,false],[0,0,0,"enable_select_opt",null,null,null,false],[0,0,0,"ete",null,null,null,false],[0,0,0,"exynos_cheap_as_move",null,null,null,false],[0,0,0,"f32mm",null,null,null,false],[0,0,0,"f64mm",null,null,null,false],[0,0,0,"fgt",null,null,null,false],[0,0,0,"fix_cortex_a53_835769",null,null,null,false],[0,0,0,"flagm",null,null,null,false],[0,0,0,"fmv",null,null,null,false],[0,0,0,"force_32bit_jump_tables",null,null,null,false],[0,0,0,"fp16fml",null,null,null,false],[0,0,0,"fp_armv8",null,null,null,false],[0,0,0,"fptoint",null,null,null,false],[0,0,0,"fullfp16",null,null,null,false],[0,0,0,"fuse_address",null,null,null,false],[0,0,0,"fuse_adrp_add",null,null,null,false],[0,0,0,"fuse_aes",null,null,null,false],[0,0,0,"fuse_arith_logic",null,null,null,false],[0,0,0,"fuse_crypto_eor",null,null,null,false],[0,0,0,"fuse_csel",null,null,null,false],[0,0,0,"fuse_literals",null,null,null,false],[0,0,0,"harden_sls_blr",null,null,null,false],[0,0,0,"harden_sls_nocomdat",null,null,null,false],[0,0,0,"harden_sls_retbr",null,null,null,false],[0,0,0,"hbc",null,null,null,false],[0,0,0,"hcx",null,null,null,false],[0,0,0,"i8mm",null,null,null,false],[0,0,0,"ite",null,null,null,false],[0,0,0,"jsconv",null,null,null,false],[0,0,0,"lor",null,null,null,false],[0,0,0,"ls64",null,null,null,false],[0,0,0,"lse",null,null,null,false],[0,0,0,"lse128",null,null,null,false],[0,0,0,"lse2",null,null,null,false],[0,0,0,"lsl_fast",null,null,null,false],[0,0,0,"mec",null,null,null,false],[0,0,0,"mops",null,null,null,false],[0,0,0,"mpam",null,null,null,false],[0,0,0,"mte",null,null,null,false],[0,0,0,"neon",null,null,null,false],[0,0,0,"nmi",null,null,null,false],[0,0,0,"no_bti_at_return_twice",null,null,null,false],[0,0,0,"no_neg_immediates",null,null,null,false],[0,0,0,"no_zcz_fp",null,null,null,false],[0,0,0,"nv",null,null,null,false],[0,0,0,"outline_atomics",null,null,null,false],[0,0,0,"pan",null,null,null,false],[0,0,0,"pan_rwv",null,null,null,false],[0,0,0,"pauth",null,null,null,false],[0,0,0,"perfmon",null,null,null,false],[0,0,0,"predictable_select_expensive",null,null,null,false],[0,0,0,"predres",null,null,null,false],[0,0,0,"prfm_slc_target",null,null,null,false],[0,0,0,"rand",null,null,null,false],[0,0,0,"ras",null,null,null,false],[0,0,0,"rasv2",null,null,null,false],[0,0,0,"rcpc",null,null,null,false],[0,0,0,"rcpc3",null,null,null,false],[0,0,0,"rcpc_immo",null,null,null,false],[0,0,0,"rdm",null,null,null,false],[0,0,0,"reserve_x1",null,null,null,false],[0,0,0,"reserve_x10",null,null,null,false],[0,0,0,"reserve_x11",null,null,null,false],[0,0,0,"reserve_x12",null,null,null,false],[0,0,0,"reserve_x13",null,null,null,false],[0,0,0,"reserve_x14",null,null,null,false],[0,0,0,"reserve_x15",null,null,null,false],[0,0,0,"reserve_x18",null,null,null,false],[0,0,0,"reserve_x2",null,null,null,false],[0,0,0,"reserve_x20",null,null,null,false],[0,0,0,"reserve_x21",null,null,null,false],[0,0,0,"reserve_x22",null,null,null,false],[0,0,0,"reserve_x23",null,null,null,false],[0,0,0,"reserve_x24",null,null,null,false],[0,0,0,"reserve_x25",null,null,null,false],[0,0,0,"reserve_x26",null,null,null,false],[0,0,0,"reserve_x27",null,null,null,false],[0,0,0,"reserve_x28",null,null,null,false],[0,0,0,"reserve_x3",null,null,null,false],[0,0,0,"reserve_x30",null,null,null,false],[0,0,0,"reserve_x4",null,null,null,false],[0,0,0,"reserve_x5",null,null,null,false],[0,0,0,"reserve_x6",null,null,null,false],[0,0,0,"reserve_x7",null,null,null,false],[0,0,0,"reserve_x9",null,null,null,false],[0,0,0,"rme",null,null,null,false],[0,0,0,"sb",null,null,null,false],[0,0,0,"sel2",null,null,null,false],[0,0,0,"sha2",null,null,null,false],[0,0,0,"sha3",null,null,null,false],[0,0,0,"slow_misaligned_128store",null,null,null,false],[0,0,0,"slow_paired_128",null,null,null,false],[0,0,0,"slow_strqro_store",null,null,null,false],[0,0,0,"sm4",null,null,null,false],[0,0,0,"sme",null,null,null,false],[0,0,0,"sme2",null,null,null,false],[0,0,0,"sme2p1",null,null,null,false],[0,0,0,"sme_f16f16",null,null,null,false],[0,0,0,"sme_f64f64",null,null,null,false],[0,0,0,"sme_i16i64",null,null,null,false],[0,0,0,"spe",null,null,null,false],[0,0,0,"spe_eef",null,null,null,false],[0,0,0,"specres2",null,null,null,false],[0,0,0,"specrestrict",null,null,null,false],[0,0,0,"ssbs",null,null,null,false],[0,0,0,"strict_align",null,null,null,false],[0,0,0,"sve",null,null,null,false],[0,0,0,"sve2",null,null,null,false],[0,0,0,"sve2_aes",null,null,null,false],[0,0,0,"sve2_bitperm",null,null,null,false],[0,0,0,"sve2_sha3",null,null,null,false],[0,0,0,"sve2_sm4",null,null,null,false],[0,0,0,"sve2p1",null,null,null,false],[0,0,0,"tagged_globals",null,null,null,false],[0,0,0,"the",null,null,null,false],[0,0,0,"tlb_rmi",null,null,null,false],[0,0,0,"tme",null,null,null,false],[0,0,0,"tpidr_el1",null,null,null,false],[0,0,0,"tpidr_el2",null,null,null,false],[0,0,0,"tpidr_el3",null,null,null,false],[0,0,0,"tracev8_4",null,null,null,false],[0,0,0,"trbe",null,null,null,false],[0,0,0,"uaops",null,null,null,false],[0,0,0,"use_experimental_zeroing_pseudos",null,null,null,false],[0,0,0,"use_postra_scheduler",null,null,null,false],[0,0,0,"use_reciprocal_square_root",null,null,null,false],[0,0,0,"use_scalar_inc_vl",null,null,null,false],[0,0,0,"v8_1a",null,null,null,false],[0,0,0,"v8_2a",null,null,null,false],[0,0,0,"v8_3a",null,null,null,false],[0,0,0,"v8_4a",null,null,null,false],[0,0,0,"v8_5a",null,null,null,false],[0,0,0,"v8_6a",null,null,null,false],[0,0,0,"v8_7a",null,null,null,false],[0,0,0,"v8_8a",null,null,null,false],[0,0,0,"v8_9a",null,null,null,false],[0,0,0,"v8a",null,null,null,false],[0,0,0,"v8r",null,null,null,false],[0,0,0,"v9_1a",null,null,null,false],[0,0,0,"v9_2a",null,null,null,false],[0,0,0,"v9_3a",null,null,null,false],[0,0,0,"v9_4a",null,null,null,false],[0,0,0,"v9a",null,null,null,false],[0,0,0,"vh",null,null,null,false],[0,0,0,"wfxt",null,null,null,false],[0,0,0,"xs",null,null,null,false],[0,0,0,"zcm",null,null,null,false],[0,0,0,"zcz",null,null,null,false],[0,0,0,"zcz_fp_workaround",null,null,null,false],[0,0,0,"zcz_gp",null,null,null,false],[41,207,0,null,null,null,null,false],[41,208,0,null,null,null,null,false],[41,209,0,null,null,null,null,false],[41,210,0,null,null,null,null,false],[41,212,0,null,null,null,null,false],[41,1444,0,null,null,null,[],false],[41,1445,0,null,null,null,null,false],[41,1460,0,null,null,null,null,false],[41,1479,0,null,null,null,null,false],[41,1500,0,null,null,null,null,false],[41,1522,0,null,null,null,null,false],[41,1540,0,null,null,null,null,false],[41,1558,0,null,null,null,null,false],[41,1577,0,null,null,null,null,false],[41,1609,0,null,null,null,null,false],[41,1632,0,null,null,null,null,false],[41,1656,0,null,null,null,null,false],[41,1674,0,null,null,null,null,false],[41,1692,0,null,null,null,null,false],[41,1710,0,null,null,null,null,false],[41,1734,0,null,null,null,null,false],[41,1766,0,null,null,null,null,false],[41,1789,0,null,null,null,null,false],[41,1807,0,null,null,null,null,false],[41,1825,0,null,null,null,null,false],[41,1834,0,null,null,null,null,false],[41,1844,0,null,null,null,null,false],[41,1854,0,null,null,null,null,false],[41,1869,0,null,null,null,null,false],[41,1884,0,null,null,null,null,false],[41,1900,0,null,null,null,null,false],[41,1918,0,null,null,null,null,false],[41,1932,0,null,null,null,null,false],[41,1946,0,null,null,null,null,false],[41,1961,0,null,null,null,null,false],[41,1982,0,null,null,null,null,false],[41,1996,0,null,null,null,null,false],[41,2009,0,null,null,null,null,false],[41,2024,0,null,null,null,null,false],[41,2038,0,null,null,null,null,false],[41,2052,0,null,null,null,null,false],[41,2070,0,null,null,null,null,false],[41,2085,0,null,null,null,null,false],[41,2102,0,null,null,null,null,false],[41,2115,0,null,null,null,null,false],[41,2135,0,null,null,null,null,false],[41,2158,0,null,null,null,null,false],[41,2178,0,null,null,null,null,false],[41,2198,0,null,null,null,null,false],[41,2216,0,null,null,null,null,false],[41,2226,0,null,null,null,null,false],[41,2243,0,null,null,null,null,false],[41,2259,0,null,null,null,null,false],[41,2279,0,null,null,null,null,false],[41,2303,0,null,null,null,null,false],[41,2327,0,null,null,null,null,false],[41,2344,0,null,null,null,null,false],[41,2356,0,null,null,null,null,false],[41,2371,0,null,null,null,null,false],[41,2393,0,null,null,null,null,false],[41,2409,0,null,null,null,null,false],[41,2428,0,null,null,null,null,false],[41,2447,0,null,null,null,null,false],[41,2469,0,null,null,null,null,false],[41,2489,0,null,null,null,null,false],[41,2504,0,null,null,null,null,false],[41,2516,0,null,null,null,null,false],[41,2528,0,null,null,null,null,false],[41,2543,0,null,null,null,null,false],[41,2555,0,null,null,null,null,false],[41,2567,0,null,null,null,null,false],[41,2579,0,null,null,null,null,false],[41,2594,0,null,null,null,null,false],[40,451,0,null,null,null,null,false],[0,0,0,"target/arc.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[42,2,0,null,null,null,null,false],[42,3,0,null,null,null,null,false],[42,4,0,null,null,null,null,false],[42,6,0,null,null,null,[5990],false],[0,0,0,"norm",null,null,null,false],[42,10,0,null,null,null,null,false],[42,11,0,null,null,null,null,false],[42,12,0,null,null,null,null,false],[42,13,0,null,null,null,null,false],[42,15,0,null,null,null,null,false],[42,32,0,null,null,null,[],false],[42,33,0,null,null,null,null,false],[40,452,0,null,null,null,null,false],[0,0,0,"target/amdgpu.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[43,2,0,null,null,null,null,false],[43,3,0,null,null,null,null,false],[43,4,0,null,null,null,null,false],[43,6,0,null,null,null,[6004,6005,6006,6007,6008,6009,6010,6011,6012,6013,6014,6015,6016,6017,6018,6019,6020,6021,6022,6023,6024,6025,6026,6027,6028,6029,6030,6031,6032,6033,6034,6035,6036,6037,6038,6039,6040,6041,6042,6043,6044,6045,6046,6047,6048,6049,6050,6051,6052,6053,6054,6055,6056,6057,6058,6059,6060,6061,6062,6063,6064,6065,6066,6067,6068,6069,6070,6071,6072,6073,6074,6075,6076,6077,6078,6079,6080,6081,6082,6083,6084,6085,6086,6087,6088,6089,6090,6091,6092,6093,6094,6095,6096,6097,6098,6099,6100,6101,6102,6103,6104,6105,6106,6107,6108,6109,6110,6111,6112,6113,6114,6115,6116,6117,6118,6119,6120,6121,6122,6123,6124,6125,6126,6127,6128,6129,6130,6131,6132,6133,6134,6135,6136,6137,6138,6139,6140,6141,6142,6143,6144,6145,6146,6147,6148,6149],false],[0,0,0,"16_bit_insts",null,null,null,false],[0,0,0,"a16",null,null,null,false],[0,0,0,"add_no_carry_insts",null,null,null,false],[0,0,0,"aperture_regs",null,null,null,false],[0,0,0,"architected_flat_scratch",null,null,null,false],[0,0,0,"atomic_fadd_no_rtn_insts",null,null,null,false],[0,0,0,"atomic_fadd_rtn_insts",null,null,null,false],[0,0,0,"atomic_pk_fadd_no_rtn_insts",null,null,null,false],[0,0,0,"auto_waitcnt_before_barrier",null,null,null,false],[0,0,0,"back_off_barrier",null,null,null,false],[0,0,0,"ci_insts",null,null,null,false],[0,0,0,"cumode",null,null,null,false],[0,0,0,"dl_insts",null,null,null,false],[0,0,0,"dot1_insts",null,null,null,false],[0,0,0,"dot2_insts",null,null,null,false],[0,0,0,"dot3_insts",null,null,null,false],[0,0,0,"dot4_insts",null,null,null,false],[0,0,0,"dot5_insts",null,null,null,false],[0,0,0,"dot6_insts",null,null,null,false],[0,0,0,"dot7_insts",null,null,null,false],[0,0,0,"dot8_insts",null,null,null,false],[0,0,0,"dot9_insts",null,null,null,false],[0,0,0,"dpp",null,null,null,false],[0,0,0,"dpp8",null,null,null,false],[0,0,0,"dpp_64bit",null,null,null,false],[0,0,0,"ds128",null,null,null,false],[0,0,0,"ds_src2_insts",null,null,null,false],[0,0,0,"extended_image_insts",null,null,null,false],[0,0,0,"fast_denormal_f32",null,null,null,false],[0,0,0,"fast_fmaf",null,null,null,false],[0,0,0,"flat_address_space",null,null,null,false],[0,0,0,"flat_atomic_fadd_f32_inst",null,null,null,false],[0,0,0,"flat_for_global",null,null,null,false],[0,0,0,"flat_global_insts",null,null,null,false],[0,0,0,"flat_inst_offsets",null,null,null,false],[0,0,0,"flat_scratch",null,null,null,false],[0,0,0,"flat_scratch_insts",null,null,null,false],[0,0,0,"flat_segment_offset_bug",null,null,null,false],[0,0,0,"fma_mix_insts",null,null,null,false],[0,0,0,"fmacf64_inst",null,null,null,false],[0,0,0,"fmaf",null,null,null,false],[0,0,0,"fp64",null,null,null,false],[0,0,0,"fp8_insts",null,null,null,false],[0,0,0,"full_rate_64_ops",null,null,null,false],[0,0,0,"g16",null,null,null,false],[0,0,0,"gcn3_encoding",null,null,null,false],[0,0,0,"get_wave_id_inst",null,null,null,false],[0,0,0,"gfx10",null,null,null,false],[0,0,0,"gfx10_3_insts",null,null,null,false],[0,0,0,"gfx10_a_encoding",null,null,null,false],[0,0,0,"gfx10_b_encoding",null,null,null,false],[0,0,0,"gfx10_insts",null,null,null,false],[0,0,0,"gfx11",null,null,null,false],[0,0,0,"gfx11_full_vgprs",null,null,null,false],[0,0,0,"gfx11_insts",null,null,null,false],[0,0,0,"gfx7_gfx8_gfx9_insts",null,null,null,false],[0,0,0,"gfx8_insts",null,null,null,false],[0,0,0,"gfx9",null,null,null,false],[0,0,0,"gfx90a_insts",null,null,null,false],[0,0,0,"gfx940_insts",null,null,null,false],[0,0,0,"gfx9_insts",null,null,null,false],[0,0,0,"half_rate_64_ops",null,null,null,false],[0,0,0,"image_gather4_d16_bug",null,null,null,false],[0,0,0,"image_insts",null,null,null,false],[0,0,0,"image_store_d16_bug",null,null,null,false],[0,0,0,"inst_fwd_prefetch_bug",null,null,null,false],[0,0,0,"int_clamp_insts",null,null,null,false],[0,0,0,"inv_2pi_inline_imm",null,null,null,false],[0,0,0,"lds_branch_vmem_war_hazard",null,null,null,false],[0,0,0,"lds_misaligned_bug",null,null,null,false],[0,0,0,"ldsbankcount16",null,null,null,false],[0,0,0,"ldsbankcount32",null,null,null,false],[0,0,0,"load_store_opt",null,null,null,false],[0,0,0,"localmemorysize32768",null,null,null,false],[0,0,0,"localmemorysize65536",null,null,null,false],[0,0,0,"mad_intra_fwd_bug",null,null,null,false],[0,0,0,"mad_mac_f32_insts",null,null,null,false],[0,0,0,"mad_mix_insts",null,null,null,false],[0,0,0,"mai_insts",null,null,null,false],[0,0,0,"max_private_element_size_16",null,null,null,false],[0,0,0,"max_private_element_size_4",null,null,null,false],[0,0,0,"max_private_element_size_8",null,null,null,false],[0,0,0,"mfma_inline_literal_bug",null,null,null,false],[0,0,0,"mimg_r128",null,null,null,false],[0,0,0,"movrel",null,null,null,false],[0,0,0,"negative_scratch_offset_bug",null,null,null,false],[0,0,0,"negative_unaligned_scratch_offset_bug",null,null,null,false],[0,0,0,"no_data_dep_hazard",null,null,null,false],[0,0,0,"no_sdst_cmpx",null,null,null,false],[0,0,0,"nsa_clause_bug",null,null,null,false],[0,0,0,"nsa_encoding",null,null,null,false],[0,0,0,"nsa_max_size_13",null,null,null,false],[0,0,0,"nsa_max_size_5",null,null,null,false],[0,0,0,"nsa_to_vmem_bug",null,null,null,false],[0,0,0,"offset_3f_bug",null,null,null,false],[0,0,0,"packed_fp32_ops",null,null,null,false],[0,0,0,"packed_tid",null,null,null,false],[0,0,0,"pk_fmac_f16_inst",null,null,null,false],[0,0,0,"promote_alloca",null,null,null,false],[0,0,0,"prt_strict_null",null,null,null,false],[0,0,0,"r128_a16",null,null,null,false],[0,0,0,"s_memrealtime",null,null,null,false],[0,0,0,"s_memtime_inst",null,null,null,false],[0,0,0,"scalar_atomics",null,null,null,false],[0,0,0,"scalar_flat_scratch_insts",null,null,null,false],[0,0,0,"scalar_stores",null,null,null,false],[0,0,0,"sdwa",null,null,null,false],[0,0,0,"sdwa_mav",null,null,null,false],[0,0,0,"sdwa_omod",null,null,null,false],[0,0,0,"sdwa_out_mods_vopc",null,null,null,false],[0,0,0,"sdwa_scalar",null,null,null,false],[0,0,0,"sdwa_sdst",null,null,null,false],[0,0,0,"sea_islands",null,null,null,false],[0,0,0,"sgpr_init_bug",null,null,null,false],[0,0,0,"shader_cycles_register",null,null,null,false],[0,0,0,"si_scheduler",null,null,null,false],[0,0,0,"smem_to_vector_write_hazard",null,null,null,false],[0,0,0,"southern_islands",null,null,null,false],[0,0,0,"sramecc",null,null,null,false],[0,0,0,"sramecc_support",null,null,null,false],[0,0,0,"tgsplit",null,null,null,false],[0,0,0,"trap_handler",null,null,null,false],[0,0,0,"trig_reduced_range",null,null,null,false],[0,0,0,"true16",null,null,null,false],[0,0,0,"unaligned_access_mode",null,null,null,false],[0,0,0,"unaligned_buffer_access",null,null,null,false],[0,0,0,"unaligned_ds_access",null,null,null,false],[0,0,0,"unaligned_scratch_access",null,null,null,false],[0,0,0,"unpacked_d16_vmem",null,null,null,false],[0,0,0,"unsafe_ds_offset_folding",null,null,null,false],[0,0,0,"user_sgpr_init16_bug",null,null,null,false],[0,0,0,"valu_trans_use_hazard",null,null,null,false],[0,0,0,"vcmpx_exec_war_hazard",null,null,null,false],[0,0,0,"vcmpx_permlane_hazard",null,null,null,false],[0,0,0,"vgpr_index_mode",null,null,null,false],[0,0,0,"vmem_to_scalar_write_hazard",null,null,null,false],[0,0,0,"volcanic_islands",null,null,null,false],[0,0,0,"vop3_literal",null,null,null,false],[0,0,0,"vop3p",null,null,null,false],[0,0,0,"vopd",null,null,null,false],[0,0,0,"vscnt",null,null,null,false],[0,0,0,"wavefrontsize16",null,null,null,false],[0,0,0,"wavefrontsize32",null,null,null,false],[0,0,0,"wavefrontsize64",null,null,null,false],[0,0,0,"xnack",null,null,null,false],[0,0,0,"xnack_support",null,null,null,false],[43,155,0,null,null,null,null,false],[43,156,0,null,null,null,null,false],[43,157,0,null,null,null,null,false],[43,158,0,null,null,null,null,false],[43,160,0,null,null,null,null,false],[43,1085,0,null,null,null,[],false],[43,1086,0,null,null,null,null,false],[43,1094,0,null,null,null,null,false],[43,1106,0,null,null,null,null,false],[43,1115,0,null,null,null,null,false],[43,1122,0,null,null,null,null,false],[43,1130,0,null,null,null,null,false],[43,1162,0,null,null,null,null,false],[43,1199,0,null,null,null,null,false],[43,1236,0,null,null,null,null,false],[43,1269,0,null,null,null,null,false],[43,1291,0,null,null,null,null,false],[43,1313,0,null,null,null,null,false],[43,1335,0,null,null,null,null,false],[43,1357,0,null,null,null,null,false],[43,1379,0,null,null,null,null,false],[43,1401,0,null,null,null,null,false],[43,1423,0,null,null,null,null,false],[43,1451,0,null,null,null,null,false],[43,1478,0,null,null,null,null,false],[43,1505,0,null,null,null,null,false],[43,1531,0,null,null,null,null,false],[43,1540,0,null,null,null,null,false],[43,1547,0,null,null,null,null,false],[43,1554,0,null,null,null,null,false],[43,1562,0,null,null,null,null,false],[43,1572,0,null,null,null,null,false],[43,1581,0,null,null,null,null,false],[43,1589,0,null,null,null,null,false],[43,1597,0,null,null,null,null,false],[43,1605,0,null,null,null,null,false],[43,1617,0,null,null,null,null,false],[43,1627,0,null,null,null,null,false],[43,1636,0,null,null,null,null,false],[43,1646,0,null,null,null,null,false],[43,1657,0,null,null,null,null,false],[43,1671,0,null,null,null,null,false],[43,1685,0,null,null,null,null,false],[43,1699,0,null,null,null,null,false],[43,1719,0,null,null,null,null,false],[43,1748,0,null,null,null,null,false],[43,1762,0,null,null,null,null,false],[43,1794,0,null,null,null,null,false],[43,1808,0,null,null,null,null,false],[43,1842,0,null,null,null,null,false],[43,1849,0,null,null,null,null,false],[43,1859,0,null,null,null,null,false],[43,1869,0,null,null,null,null,false],[43,1877,0,null,null,null,null,false],[43,1885,0,null,null,null,null,false],[43,1893,0,null,null,null,null,false],[43,1900,0,null,null,null,null,false],[43,1907,0,null,null,null,null,false],[43,1916,0,null,null,null,null,false],[43,1925,0,null,null,null,null,false],[43,1936,0,null,null,null,null,false],[43,1945,0,null,null,null,null,false],[43,1955,0,null,null,null,null,false],[43,1965,0,null,null,null,null,false],[40,453,0,null,null,null,null,false],[0,0,0,"target/arm.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[44,2,0,null,null,null,null,false],[44,3,0,null,null,null,null,false],[44,4,0,null,null,null,null,false],[44,6,0,null,null,null,[6220,6221,6222,6223,6224,6225,6226,6227,6228,6229,6230,6231,6232,6233,6234,6235,6236,6237,6238,6239,6240,6241,6242,6243,6244,6245,6246,6247,6248,6249,6250,6251,6252,6253,6254,6255,6256,6257,6258,6259,6260,6261,6262,6263,6264,6265,6266,6267,6268,6269,6270,6271,6272,6273,6274,6275,6276,6277,6278,6279,6280,6281,6282,6283,6284,6285,6286,6287,6288,6289,6290,6291,6292,6293,6294,6295,6296,6297,6298,6299,6300,6301,6302,6303,6304,6305,6306,6307,6308,6309,6310,6311,6312,6313,6314,6315,6316,6317,6318,6319,6320,6321,6322,6323,6324,6325,6326,6327,6328,6329,6330,6331,6332,6333,6334,6335,6336,6337,6338,6339,6340,6341,6342,6343,6344,6345,6346,6347,6348,6349,6350,6351,6352,6353,6354,6355,6356,6357,6358,6359,6360,6361,6362,6363,6364,6365,6366,6367,6368,6369,6370,6371,6372,6373,6374,6375,6376,6377,6378,6379,6380,6381,6382,6383,6384,6385,6386,6387,6388,6389,6390,6391,6392,6393,6394,6395,6396,6397,6398,6399,6400,6401,6402,6403,6404,6405,6406,6407,6408,6409,6410,6411,6412,6413,6414,6415,6416],false],[0,0,0,"32bit",null,null,null,false],[0,0,0,"8msecext",null,null,null,false],[0,0,0,"a76",null,null,null,false],[0,0,0,"aapcs_frame_chain",null,null,null,false],[0,0,0,"aapcs_frame_chain_leaf",null,null,null,false],[0,0,0,"aclass",null,null,null,false],[0,0,0,"acquire_release",null,null,null,false],[0,0,0,"aes",null,null,null,false],[0,0,0,"atomics_32",null,null,null,false],[0,0,0,"avoid_movs_shop",null,null,null,false],[0,0,0,"avoid_partial_cpsr",null,null,null,false],[0,0,0,"bf16",null,null,null,false],[0,0,0,"big_endian_instructions",null,null,null,false],[0,0,0,"cde",null,null,null,false],[0,0,0,"cdecp0",null,null,null,false],[0,0,0,"cdecp1",null,null,null,false],[0,0,0,"cdecp2",null,null,null,false],[0,0,0,"cdecp3",null,null,null,false],[0,0,0,"cdecp4",null,null,null,false],[0,0,0,"cdecp5",null,null,null,false],[0,0,0,"cdecp6",null,null,null,false],[0,0,0,"cdecp7",null,null,null,false],[0,0,0,"cheap_predicable_cpsr",null,null,null,false],[0,0,0,"clrbhb",null,null,null,false],[0,0,0,"crc",null,null,null,false],[0,0,0,"crypto",null,null,null,false],[0,0,0,"d32",null,null,null,false],[0,0,0,"db",null,null,null,false],[0,0,0,"dfb",null,null,null,false],[0,0,0,"disable_postra_scheduler",null,null,null,false],[0,0,0,"dont_widen_vmovs",null,null,null,false],[0,0,0,"dotprod",null,null,null,false],[0,0,0,"dsp",null,null,null,false],[0,0,0,"execute_only",null,null,null,false],[0,0,0,"expand_fp_mlx",null,null,null,false],[0,0,0,"exynos",null,null,null,false],[0,0,0,"fix_cmse_cve_2021_35465",null,null,null,false],[0,0,0,"fix_cortex_a57_aes_1742098",null,null,null,false],[0,0,0,"fp16",null,null,null,false],[0,0,0,"fp16fml",null,null,null,false],[0,0,0,"fp64",null,null,null,false],[0,0,0,"fp_armv8",null,null,null,false],[0,0,0,"fp_armv8d16",null,null,null,false],[0,0,0,"fp_armv8d16sp",null,null,null,false],[0,0,0,"fp_armv8sp",null,null,null,false],[0,0,0,"fpao",null,null,null,false],[0,0,0,"fpregs",null,null,null,false],[0,0,0,"fpregs16",null,null,null,false],[0,0,0,"fpregs64",null,null,null,false],[0,0,0,"fullfp16",null,null,null,false],[0,0,0,"fuse_aes",null,null,null,false],[0,0,0,"fuse_literals",null,null,null,false],[0,0,0,"harden_sls_blr",null,null,null,false],[0,0,0,"harden_sls_nocomdat",null,null,null,false],[0,0,0,"harden_sls_retbr",null,null,null,false],[0,0,0,"has_v4t",null,null,null,false],[0,0,0,"has_v5t",null,null,null,false],[0,0,0,"has_v5te",null,null,null,false],[0,0,0,"has_v6",null,null,null,false],[0,0,0,"has_v6k",null,null,null,false],[0,0,0,"has_v6m",null,null,null,false],[0,0,0,"has_v6t2",null,null,null,false],[0,0,0,"has_v7",null,null,null,false],[0,0,0,"has_v7clrex",null,null,null,false],[0,0,0,"has_v8",null,null,null,false],[0,0,0,"has_v8_1a",null,null,null,false],[0,0,0,"has_v8_1m_main",null,null,null,false],[0,0,0,"has_v8_2a",null,null,null,false],[0,0,0,"has_v8_3a",null,null,null,false],[0,0,0,"has_v8_4a",null,null,null,false],[0,0,0,"has_v8_5a",null,null,null,false],[0,0,0,"has_v8_6a",null,null,null,false],[0,0,0,"has_v8_7a",null,null,null,false],[0,0,0,"has_v8_8a",null,null,null,false],[0,0,0,"has_v8_9a",null,null,null,false],[0,0,0,"has_v8m",null,null,null,false],[0,0,0,"has_v8m_main",null,null,null,false],[0,0,0,"has_v9_1a",null,null,null,false],[0,0,0,"has_v9_2a",null,null,null,false],[0,0,0,"has_v9_3a",null,null,null,false],[0,0,0,"has_v9_4a",null,null,null,false],[0,0,0,"has_v9a",null,null,null,false],[0,0,0,"hwdiv",null,null,null,false],[0,0,0,"hwdiv_arm",null,null,null,false],[0,0,0,"i8mm",null,null,null,false],[0,0,0,"iwmmxt",null,null,null,false],[0,0,0,"iwmmxt2",null,null,null,false],[0,0,0,"lob",null,null,null,false],[0,0,0,"long_calls",null,null,null,false],[0,0,0,"loop_align",null,null,null,false],[0,0,0,"m3",null,null,null,false],[0,0,0,"mclass",null,null,null,false],[0,0,0,"mp",null,null,null,false],[0,0,0,"muxed_units",null,null,null,false],[0,0,0,"mve",null,null,null,false],[0,0,0,"mve1beat",null,null,null,false],[0,0,0,"mve2beat",null,null,null,false],[0,0,0,"mve4beat",null,null,null,false],[0,0,0,"mve_fp",null,null,null,false],[0,0,0,"nacl_trap",null,null,null,false],[0,0,0,"neon",null,null,null,false],[0,0,0,"neon_fpmovs",null,null,null,false],[0,0,0,"neonfp",null,null,null,false],[0,0,0,"no_branch_predictor",null,null,null,false],[0,0,0,"no_bti_at_return_twice",null,null,null,false],[0,0,0,"no_movt",null,null,null,false],[0,0,0,"no_neg_immediates",null,null,null,false],[0,0,0,"noarm",null,null,null,false],[0,0,0,"nonpipelined_vfp",null,null,null,false],[0,0,0,"pacbti",null,null,null,false],[0,0,0,"perfmon",null,null,null,false],[0,0,0,"prefer_ishst",null,null,null,false],[0,0,0,"prefer_vmovsr",null,null,null,false],[0,0,0,"prof_unpr",null,null,null,false],[0,0,0,"r4",null,null,null,false],[0,0,0,"ras",null,null,null,false],[0,0,0,"rclass",null,null,null,false],[0,0,0,"read_tp_hard",null,null,null,false],[0,0,0,"reserve_r9",null,null,null,false],[0,0,0,"ret_addr_stack",null,null,null,false],[0,0,0,"sb",null,null,null,false],[0,0,0,"sha2",null,null,null,false],[0,0,0,"slow_fp_brcc",null,null,null,false],[0,0,0,"slow_load_D_subreg",null,null,null,false],[0,0,0,"slow_odd_reg",null,null,null,false],[0,0,0,"slow_vdup32",null,null,null,false],[0,0,0,"slow_vgetlni32",null,null,null,false],[0,0,0,"slowfpvfmx",null,null,null,false],[0,0,0,"slowfpvmlx",null,null,null,false],[0,0,0,"soft_float",null,null,null,false],[0,0,0,"splat_vfp_neon",null,null,null,false],[0,0,0,"strict_align",null,null,null,false],[0,0,0,"swift",null,null,null,false],[0,0,0,"thumb2",null,null,null,false],[0,0,0,"thumb_mode",null,null,null,false],[0,0,0,"trustzone",null,null,null,false],[0,0,0,"use_mipipeliner",null,null,null,false],[0,0,0,"use_misched",null,null,null,false],[0,0,0,"v2",null,null,null,false],[0,0,0,"v2a",null,null,null,false],[0,0,0,"v3",null,null,null,false],[0,0,0,"v3m",null,null,null,false],[0,0,0,"v4",null,null,null,false],[0,0,0,"v4t",null,null,null,false],[0,0,0,"v5t",null,null,null,false],[0,0,0,"v5te",null,null,null,false],[0,0,0,"v5tej",null,null,null,false],[0,0,0,"v6",null,null,null,false],[0,0,0,"v6j",null,null,null,false],[0,0,0,"v6k",null,null,null,false],[0,0,0,"v6kz",null,null,null,false],[0,0,0,"v6m",null,null,null,false],[0,0,0,"v6sm",null,null,null,false],[0,0,0,"v6t2",null,null,null,false],[0,0,0,"v7a",null,null,null,false],[0,0,0,"v7em",null,null,null,false],[0,0,0,"v7k",null,null,null,false],[0,0,0,"v7m",null,null,null,false],[0,0,0,"v7r",null,null,null,false],[0,0,0,"v7s",null,null,null,false],[0,0,0,"v7ve",null,null,null,false],[0,0,0,"v8_1a",null,null,null,false],[0,0,0,"v8_1m_main",null,null,null,false],[0,0,0,"v8_2a",null,null,null,false],[0,0,0,"v8_3a",null,null,null,false],[0,0,0,"v8_4a",null,null,null,false],[0,0,0,"v8_5a",null,null,null,false],[0,0,0,"v8_6a",null,null,null,false],[0,0,0,"v8_7a",null,null,null,false],[0,0,0,"v8_8a",null,null,null,false],[0,0,0,"v8_9a",null,null,null,false],[0,0,0,"v8a",null,null,null,false],[0,0,0,"v8m",null,null,null,false],[0,0,0,"v8m_main",null,null,null,false],[0,0,0,"v8r",null,null,null,false],[0,0,0,"v9_1a",null,null,null,false],[0,0,0,"v9_2a",null,null,null,false],[0,0,0,"v9_3a",null,null,null,false],[0,0,0,"v9_4a",null,null,null,false],[0,0,0,"v9a",null,null,null,false],[0,0,0,"vfp2",null,null,null,false],[0,0,0,"vfp2sp",null,null,null,false],[0,0,0,"vfp3",null,null,null,false],[0,0,0,"vfp3d16",null,null,null,false],[0,0,0,"vfp3d16sp",null,null,null,false],[0,0,0,"vfp3sp",null,null,null,false],[0,0,0,"vfp4",null,null,null,false],[0,0,0,"vfp4d16",null,null,null,false],[0,0,0,"vfp4d16sp",null,null,null,false],[0,0,0,"vfp4sp",null,null,null,false],[0,0,0,"virtualization",null,null,null,false],[0,0,0,"vldn_align",null,null,null,false],[0,0,0,"vmlx_forwarding",null,null,null,false],[0,0,0,"vmlx_hazards",null,null,null,false],[0,0,0,"wide_stride_vfp",null,null,null,false],[0,0,0,"xscale",null,null,null,false],[0,0,0,"zcz",null,null,null,false],[44,206,0,null,null,null,null,false],[44,207,0,null,null,null,null,false],[44,208,0,null,null,null,null,false],[44,209,0,null,null,null,null,false],[44,211,0,null,null,null,null,false],[44,1705,0,null,null,null,[],false],[44,1706,0,null,null,null,null,false],[44,1713,0,null,null,null,null,false],[44,1720,0,null,null,null,null,false],[44,1727,0,null,null,null,null,false],[44,1734,0,null,null,null,null,false],[44,1741,0,null,null,null,null,false],[44,1748,0,null,null,null,null,false],[44,1757,0,null,null,null,null,false],[44,1764,0,null,null,null,null,false],[44,1773,0,null,null,null,null,false],[44,1780,0,null,null,null,null,false],[44,1789,0,null,null,null,null,false],[44,1796,0,null,null,null,null,false],[44,1803,0,null,null,null,null,false],[44,1810,0,null,null,null,null,false],[44,1817,0,null,null,null,null,false],[44,1824,0,null,null,null,null,false],[44,1831,0,null,null,null,null,false],[44,1838,0,null,null,null,null,false],[44,1845,0,null,null,null,null,false],[44,1852,0,null,null,null,null,false],[44,1859,0,null,null,null,null,false],[44,1866,0,null,null,null,null,false],[44,1873,0,null,null,null,null,false],[44,1880,0,null,null,null,null,false],[44,1887,0,null,null,null,null,false],[44,1894,0,null,null,null,null,false],[44,1901,0,null,null,null,null,false],[44,1908,0,null,null,null,null,false],[44,1915,0,null,null,null,null,false],[44,1929,0,null,null,null,null,false],[44,1945,0,null,null,null,null,false],[44,1959,0,null,null,null,null,false],[44,1966,0,null,null,null,null,false],[44,1973,0,null,null,null,null,false],[44,1988,0,null,null,null,null,false],[44,1996,0,null,null,null,null,false],[44,2004,0,null,null,null,null,false],[44,2015,0,null,null,null,null,false],[44,2032,0,null,null,null,null,false],[44,2042,0,null,null,null,null,false],[44,2050,0,null,null,null,null,false],[44,2057,0,null,null,null,null,false],[44,2065,0,null,null,null,null,false],[44,2075,0,null,null,null,null,false],[44,2085,0,null,null,null,null,false],[44,2094,0,null,null,null,null,false],[44,2103,0,null,null,null,null,false],[44,2112,0,null,null,null,null,false],[44,2127,0,null,null,null,null,false],[44,2146,0,null,null,null,null,false],[44,2154,0,null,null,null,null,false],[44,2162,0,null,null,null,null,false],[44,2170,0,null,null,null,null,false],[44,2179,0,null,null,null,null,false],[44,2190,0,null,null,null,null,false],[44,2205,0,null,null,null,null,false],[44,2220,0,null,null,null,null,false],[44,2233,0,null,null,null,null,false],[44,2247,0,null,null,null,null,false],[44,2257,0,null,null,null,null,false],[44,2268,0,null,null,null,null,false],[44,2278,0,null,null,null,null,false],[44,2292,0,null,null,null,null,false],[44,2306,0,null,null,null,null,false],[44,2315,0,null,null,null,null,false],[44,2331,0,null,null,null,null,false],[44,2347,0,null,null,null,null,false],[44,2356,0,null,null,null,null,false],[44,2365,0,null,null,null,null,false],[44,2382,0,null,null,null,null,false],[44,2389,0,null,null,null,null,false],[44,2397,0,null,null,null,null,false],[44,2405,0,null,null,null,null,false],[44,2413,0,null,null,null,null,false],[44,2423,0,null,null,null,null,false],[44,2433,0,null,null,null,null,false],[44,2438,0,null,null,null,null,false],[44,2445,0,null,null,null,null,false],[44,2460,0,null,null,null,null,false],[44,2467,0,null,null,null,null,false],[44,2476,0,null,null,null,null,false],[44,2483,0,null,null,null,null,false],[44,2491,0,null,null,null,null,false],[44,2500,0,null,null,null,null,false],[44,2510,0,null,null,null,null,false],[44,2518,0,null,null,null,null,false],[44,2528,0,null,null,null,null,false],[44,2535,0,null,null,null,null,false],[44,2542,0,null,null,null,null,false],[44,2549,0,null,null,null,null,false],[44,2556,0,null,null,null,null,false],[44,2584,0,null,null,null,null,false],[40,454,0,null,null,null,null,false],[0,0,0,"target/avr.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[45,2,0,null,null,null,null,false],[45,3,0,null,null,null,null,false],[45,4,0,null,null,null,null,false],[45,6,0,null,null,null,[6522,6523,6524,6525,6526,6527,6528,6529,6530,6531,6532,6533,6534,6535,6536,6537,6538,6539,6540,6541,6542,6543,6544,6545,6546,6547,6548,6549,6550,6551,6552,6553,6554,6555,6556,6557],false],[0,0,0,"addsubiw",null,null,null,false],[0,0,0,"avr0",null,null,null,false],[0,0,0,"avr1",null,null,null,false],[0,0,0,"avr2",null,null,null,false],[0,0,0,"avr25",null,null,null,false],[0,0,0,"avr3",null,null,null,false],[0,0,0,"avr31",null,null,null,false],[0,0,0,"avr35",null,null,null,false],[0,0,0,"avr4",null,null,null,false],[0,0,0,"avr5",null,null,null,false],[0,0,0,"avr51",null,null,null,false],[0,0,0,"avr6",null,null,null,false],[0,0,0,"avrtiny",null,null,null,false],[0,0,0,"break",null,null,null,false],[0,0,0,"des",null,null,null,false],[0,0,0,"eijmpcall",null,null,null,false],[0,0,0,"elpm",null,null,null,false],[0,0,0,"elpmx",null,null,null,false],[0,0,0,"ijmpcall",null,null,null,false],[0,0,0,"jmpcall",null,null,null,false],[0,0,0,"lpm",null,null,null,false],[0,0,0,"lpmx",null,null,null,false],[0,0,0,"memmappedregs",null,null,null,false],[0,0,0,"movw",null,null,null,false],[0,0,0,"mul",null,null,null,false],[0,0,0,"progmem",null,null,null,false],[0,0,0,"rmw",null,null,null,false],[0,0,0,"smallstack",null,null,null,false],[0,0,0,"special",null,null,null,false],[0,0,0,"spm",null,null,null,false],[0,0,0,"spmx",null,null,null,false],[0,0,0,"sram",null,null,null,false],[0,0,0,"tinyencoding",null,null,null,false],[0,0,0,"xmega",null,null,null,false],[0,0,0,"xmega3",null,null,null,false],[0,0,0,"xmegau",null,null,null,false],[45,45,0,null,null,null,null,false],[45,46,0,null,null,null,null,false],[45,47,0,null,null,null,null,false],[45,48,0,null,null,null,null,false],[45,50,0,null,null,null,null,false],[45,348,0,null,null,null,[],false],[45,349,0,null,null,null,null,false],[45,356,0,null,null,null,null,false],[45,363,0,null,null,null,null,false],[45,370,0,null,null,null,null,false],[45,379,0,null,null,null,null,false],[45,386,0,null,null,null,null,false],[45,393,0,null,null,null,null,false],[45,400,0,null,null,null,null,false],[45,407,0,null,null,null,null,false],[45,414,0,null,null,null,null,false],[45,421,0,null,null,null,null,false],[45,428,0,null,null,null,null,false],[45,435,0,null,null,null,null,false],[45,442,0,null,null,null,null,false],[45,449,0,null,null,null,null,false],[45,456,0,null,null,null,null,false],[45,463,0,null,null,null,null,false],[45,470,0,null,null,null,null,false],[45,478,0,null,null,null,null,false],[45,486,0,null,null,null,null,false],[45,494,0,null,null,null,null,false],[45,502,0,null,null,null,null,false],[45,510,0,null,null,null,null,false],[45,518,0,null,null,null,null,false],[45,526,0,null,null,null,null,false],[45,534,0,null,null,null,null,false],[45,541,0,null,null,null,null,false],[45,548,0,null,null,null,null,false],[45,555,0,null,null,null,null,false],[45,562,0,null,null,null,null,false],[45,569,0,null,null,null,null,false],[45,576,0,null,null,null,null,false],[45,583,0,null,null,null,null,false],[45,590,0,null,null,null,null,false],[45,597,0,null,null,null,null,false],[45,607,0,null,null,null,null,false],[45,614,0,null,null,null,null,false],[45,621,0,null,null,null,null,false],[45,628,0,null,null,null,null,false],[45,635,0,null,null,null,null,false],[45,642,0,null,null,null,null,false],[45,649,0,null,null,null,null,false],[45,656,0,null,null,null,null,false],[45,663,0,null,null,null,null,false],[45,670,0,null,null,null,null,false],[45,677,0,null,null,null,null,false],[45,684,0,null,null,null,null,false],[45,691,0,null,null,null,null,false],[45,698,0,null,null,null,null,false],[45,705,0,null,null,null,null,false],[45,712,0,null,null,null,null,false],[45,719,0,null,null,null,null,false],[45,726,0,null,null,null,null,false],[45,733,0,null,null,null,null,false],[45,740,0,null,null,null,null,false],[45,747,0,null,null,null,null,false],[45,754,0,null,null,null,null,false],[45,761,0,null,null,null,null,false],[45,768,0,null,null,null,null,false],[45,775,0,null,null,null,null,false],[45,782,0,null,null,null,null,false],[45,789,0,null,null,null,null,false],[45,796,0,null,null,null,null,false],[45,803,0,null,null,null,null,false],[45,810,0,null,null,null,null,false],[45,817,0,null,null,null,null,false],[45,824,0,null,null,null,null,false],[45,831,0,null,null,null,null,false],[45,838,0,null,null,null,null,false],[45,849,0,null,null,null,null,false],[45,856,0,null,null,null,null,false],[45,867,0,null,null,null,null,false],[45,874,0,null,null,null,null,false],[45,881,0,null,null,null,null,false],[45,888,0,null,null,null,null,false],[45,895,0,null,null,null,null,false],[45,902,0,null,null,null,null,false],[45,909,0,null,null,null,null,false],[45,916,0,null,null,null,null,false],[45,923,0,null,null,null,null,false],[45,930,0,null,null,null,null,false],[45,937,0,null,null,null,null,false],[45,944,0,null,null,null,null,false],[45,951,0,null,null,null,null,false],[45,958,0,null,null,null,null,false],[45,965,0,null,null,null,null,false],[45,972,0,null,null,null,null,false],[45,979,0,null,null,null,null,false],[45,986,0,null,null,null,null,false],[45,993,0,null,null,null,null,false],[45,1000,0,null,null,null,null,false],[45,1007,0,null,null,null,null,false],[45,1014,0,null,null,null,null,false],[45,1021,0,null,null,null,null,false],[45,1028,0,null,null,null,null,false],[45,1035,0,null,null,null,null,false],[45,1042,0,null,null,null,null,false],[45,1049,0,null,null,null,null,false],[45,1056,0,null,null,null,null,false],[45,1063,0,null,null,null,null,false],[45,1070,0,null,null,null,null,false],[45,1077,0,null,null,null,null,false],[45,1084,0,null,null,null,null,false],[45,1091,0,null,null,null,null,false],[45,1098,0,null,null,null,null,false],[45,1105,0,null,null,null,null,false],[45,1112,0,null,null,null,null,false],[45,1119,0,null,null,null,null,false],[45,1126,0,null,null,null,null,false],[45,1133,0,null,null,null,null,false],[45,1140,0,null,null,null,null,false],[45,1147,0,null,null,null,null,false],[45,1154,0,null,null,null,null,false],[45,1161,0,null,null,null,null,false],[45,1168,0,null,null,null,null,false],[45,1175,0,null,null,null,null,false],[45,1182,0,null,null,null,null,false],[45,1189,0,null,null,null,null,false],[45,1196,0,null,null,null,null,false],[45,1203,0,null,null,null,null,false],[45,1210,0,null,null,null,null,false],[45,1217,0,null,null,null,null,false],[45,1224,0,null,null,null,null,false],[45,1231,0,null,null,null,null,false],[45,1238,0,null,null,null,null,false],[45,1245,0,null,null,null,null,false],[45,1252,0,null,null,null,null,false],[45,1259,0,null,null,null,null,false],[45,1266,0,null,null,null,null,false],[45,1273,0,null,null,null,null,false],[45,1280,0,null,null,null,null,false],[45,1287,0,null,null,null,null,false],[45,1294,0,null,null,null,null,false],[45,1301,0,null,null,null,null,false],[45,1308,0,null,null,null,null,false],[45,1315,0,null,null,null,null,false],[45,1322,0,null,null,null,null,false],[45,1329,0,null,null,null,null,false],[45,1336,0,null,null,null,null,false],[45,1343,0,null,null,null,null,false],[45,1350,0,null,null,null,null,false],[45,1357,0,null,null,null,null,false],[45,1364,0,null,null,null,null,false],[45,1371,0,null,null,null,null,false],[45,1378,0,null,null,null,null,false],[45,1385,0,null,null,null,null,false],[45,1392,0,null,null,null,null,false],[45,1399,0,null,null,null,null,false],[45,1406,0,null,null,null,null,false],[45,1413,0,null,null,null,null,false],[45,1420,0,null,null,null,null,false],[45,1427,0,null,null,null,null,false],[45,1434,0,null,null,null,null,false],[45,1441,0,null,null,null,null,false],[45,1448,0,null,null,null,null,false],[45,1455,0,null,null,null,null,false],[45,1462,0,null,null,null,null,false],[45,1469,0,null,null,null,null,false],[45,1476,0,null,null,null,null,false],[45,1483,0,null,null,null,null,false],[45,1490,0,null,null,null,null,false],[45,1497,0,null,null,null,null,false],[45,1504,0,null,null,null,null,false],[45,1511,0,null,null,null,null,false],[45,1518,0,null,null,null,null,false],[45,1525,0,null,null,null,null,false],[45,1532,0,null,null,null,null,false],[45,1539,0,null,null,null,null,false],[45,1550,0,null,null,null,null,false],[45,1557,0,null,null,null,null,false],[45,1564,0,null,null,null,null,false],[45,1575,0,null,null,null,null,false],[45,1586,0,null,null,null,null,false],[45,1593,0,null,null,null,null,false],[45,1600,0,null,null,null,null,false],[45,1607,0,null,null,null,null,false],[45,1614,0,null,null,null,null,false],[45,1621,0,null,null,null,null,false],[45,1632,0,null,null,null,null,false],[45,1639,0,null,null,null,null,false],[45,1646,0,null,null,null,null,false],[45,1653,0,null,null,null,null,false],[45,1660,0,null,null,null,null,false],[45,1667,0,null,null,null,null,false],[45,1675,0,null,null,null,null,false],[45,1683,0,null,null,null,null,false],[45,1691,0,null,null,null,null,false],[45,1699,0,null,null,null,null,false],[45,1707,0,null,null,null,null,false],[45,1714,0,null,null,null,null,false],[45,1721,0,null,null,null,null,false],[45,1728,0,null,null,null,null,false],[45,1735,0,null,null,null,null,false],[45,1742,0,null,null,null,null,false],[45,1749,0,null,null,null,null,false],[45,1756,0,null,null,null,null,false],[45,1763,0,null,null,null,null,false],[45,1770,0,null,null,null,null,false],[45,1777,0,null,null,null,null,false],[45,1784,0,null,null,null,null,false],[45,1791,0,null,null,null,null,false],[45,1798,0,null,null,null,null,false],[45,1805,0,null,null,null,null,false],[45,1812,0,null,null,null,null,false],[45,1819,0,null,null,null,null,false],[45,1827,0,null,null,null,null,false],[45,1835,0,null,null,null,null,false],[45,1843,0,null,null,null,null,false],[45,1851,0,null,null,null,null,false],[45,1859,0,null,null,null,null,false],[45,1867,0,null,null,null,null,false],[45,1876,0,null,null,null,null,false],[45,1884,0,null,null,null,null,false],[45,1892,0,null,null,null,null,false],[45,1900,0,null,null,null,null,false],[45,1907,0,null,null,null,null,false],[45,1914,0,null,null,null,null,false],[45,1921,0,null,null,null,null,false],[45,1928,0,null,null,null,null,false],[45,1935,0,null,null,null,null,false],[45,1942,0,null,null,null,null,false],[45,1949,0,null,null,null,null,false],[45,1956,0,null,null,null,null,false],[45,1963,0,null,null,null,null,false],[45,1970,0,null,null,null,null,false],[45,1977,0,null,null,null,null,false],[45,1984,0,null,null,null,null,false],[45,1991,0,null,null,null,null,false],[45,1998,0,null,null,null,null,false],[45,2005,0,null,null,null,null,false],[45,2012,0,null,null,null,null,false],[45,2019,0,null,null,null,null,false],[45,2026,0,null,null,null,null,false],[45,2033,0,null,null,null,null,false],[45,2040,0,null,null,null,null,false],[45,2047,0,null,null,null,null,false],[45,2054,0,null,null,null,null,false],[45,2061,0,null,null,null,null,false],[45,2068,0,null,null,null,null,false],[45,2075,0,null,null,null,null,false],[45,2082,0,null,null,null,null,false],[45,2089,0,null,null,null,null,false],[45,2096,0,null,null,null,null,false],[45,2103,0,null,null,null,null,false],[45,2110,0,null,null,null,null,false],[45,2117,0,null,null,null,null,false],[45,2124,0,null,null,null,null,false],[45,2131,0,null,null,null,null,false],[45,2138,0,null,null,null,null,false],[45,2145,0,null,null,null,null,false],[45,2152,0,null,null,null,null,false],[45,2159,0,null,null,null,null,false],[45,2166,0,null,null,null,null,false],[45,2173,0,null,null,null,null,false],[45,2180,0,null,null,null,null,false],[45,2187,0,null,null,null,null,false],[45,2194,0,null,null,null,null,false],[45,2201,0,null,null,null,null,false],[45,2208,0,null,null,null,null,false],[45,2215,0,null,null,null,null,false],[45,2222,0,null,null,null,null,false],[45,2229,0,null,null,null,null,false],[45,2236,0,null,null,null,null,false],[45,2243,0,null,null,null,null,false],[45,2250,0,null,null,null,null,false],[45,2257,0,null,null,null,null,false],[45,2264,0,null,null,null,null,false],[45,2271,0,null,null,null,null,false],[45,2278,0,null,null,null,null,false],[45,2285,0,null,null,null,null,false],[45,2292,0,null,null,null,null,false],[45,2299,0,null,null,null,null,false],[45,2306,0,null,null,null,null,false],[45,2313,0,null,null,null,null,false],[45,2320,0,null,null,null,null,false],[45,2327,0,null,null,null,null,false],[45,2334,0,null,null,null,null,false],[45,2341,0,null,null,null,null,false],[45,2348,0,null,null,null,null,false],[45,2355,0,null,null,null,null,false],[45,2362,0,null,null,null,null,false],[45,2369,0,null,null,null,null,false],[45,2376,0,null,null,null,null,false],[45,2383,0,null,null,null,null,false],[45,2390,0,null,null,null,null,false],[45,2397,0,null,null,null,null,false],[45,2404,0,null,null,null,null,false],[45,2411,0,null,null,null,null,false],[45,2418,0,null,null,null,null,false],[45,2425,0,null,null,null,null,false],[45,2432,0,null,null,null,null,false],[45,2439,0,null,null,null,null,false],[45,2446,0,null,null,null,null,false],[45,2453,0,null,null,null,null,false],[45,2460,0,null,null,null,null,false],[45,2467,0,null,null,null,null,false],[45,2474,0,null,null,null,null,false],[45,2481,0,null,null,null,null,false],[45,2488,0,null,null,null,null,false],[45,2495,0,null,null,null,null,false],[45,2502,0,null,null,null,null,false],[45,2509,0,null,null,null,null,false],[45,2516,0,null,null,null,null,false],[45,2523,0,null,null,null,null,false],[45,2530,0,null,null,null,null,false],[45,2537,0,null,null,null,null,false],[45,2544,0,null,null,null,null,false],[45,2551,0,null,null,null,null,false],[45,2558,0,null,null,null,null,false],[45,2565,0,null,null,null,null,false],[45,2572,0,null,null,null,null,false],[45,2579,0,null,null,null,null,false],[45,2586,0,null,null,null,null,false],[45,2593,0,null,null,null,null,false],[45,2600,0,null,null,null,null,false],[40,455,0,null,null,null,null,false],[0,0,0,"target/bpf.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[46,2,0,null,null,null,null,false],[46,3,0,null,null,null,null,false],[46,4,0,null,null,null,null,false],[46,6,0,null,null,null,[6885,6886,6887],false],[0,0,0,"alu32",null,null,null,false],[0,0,0,"dummy",null,null,null,false],[0,0,0,"dwarfris",null,null,null,false],[46,12,0,null,null,null,null,false],[46,13,0,null,null,null,null,false],[46,14,0,null,null,null,null,false],[46,15,0,null,null,null,null,false],[46,17,0,null,null,null,null,false],[46,44,0,null,null,null,[],false],[46,45,0,null,null,null,null,false],[46,50,0,null,null,null,null,false],[46,55,0,null,null,null,null,false],[46,60,0,null,null,null,null,false],[46,65,0,null,null,null,null,false],[40,456,0,null,null,null,null,false],[0,0,0,"target/csky.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[47,2,0,null,null,null,null,false],[47,3,0,null,null,null,null,false],[47,4,0,null,null,null,null,false],[47,6,0,null,null,null,[6905,6906,6907,6908,6909,6910,6911,6912,6913,6914,6915,6916,6917,6918,6919,6920,6921,6922,6923,6924,6925,6926,6927,6928,6929,6930,6931,6932,6933,6934,6935,6936,6937,6938,6939,6940,6941,6942,6943,6944,6945,6946,6947,6948,6949,6950,6951,6952,6953,6954,6955,6956,6957,6958,6959,6960,6961,6962,6963,6964,6965,6966,6967],false],[0,0,0,"10e60",null,null,null,false],[0,0,0,"2e3",null,null,null,false],[0,0,0,"3e3r1",null,null,null,false],[0,0,0,"3e3r2",null,null,null,false],[0,0,0,"3e3r3",null,null,null,false],[0,0,0,"3e7",null,null,null,false],[0,0,0,"7e10",null,null,null,false],[0,0,0,"btst16",null,null,null,false],[0,0,0,"cache",null,null,null,false],[0,0,0,"ccrt",null,null,null,false],[0,0,0,"ck801",null,null,null,false],[0,0,0,"ck802",null,null,null,false],[0,0,0,"ck803",null,null,null,false],[0,0,0,"ck803s",null,null,null,false],[0,0,0,"ck804",null,null,null,false],[0,0,0,"ck805",null,null,null,false],[0,0,0,"ck807",null,null,null,false],[0,0,0,"ck810",null,null,null,false],[0,0,0,"ck810v",null,null,null,false],[0,0,0,"ck860",null,null,null,false],[0,0,0,"ck860v",null,null,null,false],[0,0,0,"constpool",null,null,null,false],[0,0,0,"doloop",null,null,null,false],[0,0,0,"dsp1e2",null,null,null,false],[0,0,0,"dsp_silan",null,null,null,false],[0,0,0,"dspe60",null,null,null,false],[0,0,0,"dspv2",null,null,null,false],[0,0,0,"e1",null,null,null,false],[0,0,0,"e2",null,null,null,false],[0,0,0,"edsp",null,null,null,false],[0,0,0,"elrw",null,null,null,false],[0,0,0,"fdivdu",null,null,null,false],[0,0,0,"float1e2",null,null,null,false],[0,0,0,"float1e3",null,null,null,false],[0,0,0,"float3e4",null,null,null,false],[0,0,0,"float7e60",null,null,null,false],[0,0,0,"floate1",null,null,null,false],[0,0,0,"fpuv2_df",null,null,null,false],[0,0,0,"fpuv2_sf",null,null,null,false],[0,0,0,"fpuv3_df",null,null,null,false],[0,0,0,"fpuv3_hf",null,null,null,false],[0,0,0,"fpuv3_hi",null,null,null,false],[0,0,0,"fpuv3_sf",null,null,null,false],[0,0,0,"hard_float",null,null,null,false],[0,0,0,"hard_float_abi",null,null,null,false],[0,0,0,"hard_tp",null,null,null,false],[0,0,0,"high_registers",null,null,null,false],[0,0,0,"hwdiv",null,null,null,false],[0,0,0,"istack",null,null,null,false],[0,0,0,"java",null,null,null,false],[0,0,0,"mp",null,null,null,false],[0,0,0,"mp1e2",null,null,null,false],[0,0,0,"multiple_stld",null,null,null,false],[0,0,0,"nvic",null,null,null,false],[0,0,0,"pushpop",null,null,null,false],[0,0,0,"smart",null,null,null,false],[0,0,0,"soft_tp",null,null,null,false],[0,0,0,"stack_size",null,null,null,false],[0,0,0,"trust",null,null,null,false],[0,0,0,"vdsp2e3",null,null,null,false],[0,0,0,"vdsp2e60f",null,null,null,false],[0,0,0,"vdspv1",null,null,null,false],[0,0,0,"vdspv2",null,null,null,false],[47,72,0,null,null,null,null,false],[47,73,0,null,null,null,null,false],[47,74,0,null,null,null,null,false],[47,75,0,null,null,null,null,false],[47,77,0,null,null,null,null,false],[47,425,0,null,null,null,[],false],[47,426,0,null,null,null,null,false],[47,444,0,null,null,null,null,false],[47,469,0,null,null,null,null,false],[47,493,0,null,null,null,null,false],[47,517,0,null,null,null,null,false],[47,543,0,null,null,null,null,false],[47,569,0,null,null,null,null,false],[47,594,0,null,null,null,null,false],[47,622,0,null,null,null,null,false],[47,632,0,null,null,null,null,false],[47,642,0,null,null,null,null,false],[47,653,0,null,null,null,null,false],[47,665,0,null,null,null,null,false],[47,676,0,null,null,null,null,false],[47,688,0,null,null,null,null,false],[47,703,0,null,null,null,null,false],[47,721,0,null,null,null,null,false],[47,739,0,null,null,null,null,false],[47,760,0,null,null,null,null,false],[47,782,0,null,null,null,null,false],[47,804,0,null,null,null,null,false],[47,822,0,null,null,null,null,false],[47,843,0,null,null,null,null,false],[47,865,0,null,null,null,null,false],[47,887,0,null,null,null,null,false],[47,908,0,null,null,null,null,false],[47,930,0,null,null,null,null,false],[47,952,0,null,null,null,null,false],[47,970,0,null,null,null,null,false],[47,991,0,null,null,null,null,false],[47,1013,0,null,null,null,null,false],[47,1035,0,null,null,null,null,false],[47,1050,0,null,null,null,null,false],[47,1069,0,null,null,null,null,false],[47,1088,0,null,null,null,null,false],[47,1107,0,null,null,null,null,false],[47,1122,0,null,null,null,null,false],[47,1141,0,null,null,null,null,false],[47,1160,0,null,null,null,null,false],[47,1179,0,null,null,null,null,false],[47,1198,0,null,null,null,null,false],[47,1217,0,null,null,null,null,false],[47,1236,0,null,null,null,null,false],[47,1251,0,null,null,null,null,false],[47,1270,0,null,null,null,null,false],[47,1289,0,null,null,null,null,false],[47,1308,0,null,null,null,null,false],[47,1323,0,null,null,null,null,false],[47,1338,0,null,null,null,null,false],[47,1356,0,null,null,null,null,false],[47,1374,0,null,null,null,null,false],[47,1392,0,null,null,null,null,false],[47,1410,0,null,null,null,null,false],[47,1428,0,null,null,null,null,false],[47,1446,0,null,null,null,null,false],[47,1461,0,null,null,null,null,false],[47,1478,0,null,null,null,null,false],[47,1496,0,null,null,null,null,false],[47,1514,0,null,null,null,null,false],[47,1526,0,null,null,null,null,false],[47,1541,0,null,null,null,null,false],[47,1556,0,null,null,null,null,false],[47,1571,0,null,null,null,null,false],[47,1583,0,null,null,null,null,false],[47,1598,0,null,null,null,null,false],[47,1613,0,null,null,null,null,false],[47,1628,0,null,null,null,null,false],[47,1643,0,null,null,null,null,false],[47,1658,0,null,null,null,null,false],[47,1673,0,null,null,null,null,false],[47,1687,0,null,null,null,null,false],[47,1704,0,null,null,null,null,false],[47,1724,0,null,null,null,null,false],[47,1745,0,null,null,null,null,false],[47,1766,0,null,null,null,null,false],[47,1786,0,null,null,null,null,false],[47,1804,0,null,null,null,null,false],[47,1821,0,null,null,null,null,false],[47,1839,0,null,null,null,null,false],[47,1854,0,null,null,null,null,false],[47,1869,0,null,null,null,null,false],[47,1883,0,null,null,null,null,false],[47,1895,0,null,null,null,null,false],[47,1910,0,null,null,null,null,false],[47,1925,0,null,null,null,null,false],[47,1940,0,null,null,null,null,false],[47,1955,0,null,null,null,null,false],[47,1972,0,null,null,null,null,false],[47,1992,0,null,null,null,null,false],[47,2012,0,null,null,null,null,false],[47,2032,0,null,null,null,null,false],[47,2052,0,null,null,null,null,false],[47,2069,0,null,null,null,null,false],[47,2086,0,null,null,null,null,false],[47,2103,0,null,null,null,null,false],[47,2121,0,null,null,null,null,false],[47,2139,0,null,null,null,null,false],[47,2157,0,null,null,null,null,false],[47,2172,0,null,null,null,null,false],[47,2187,0,null,null,null,null,false],[47,2202,0,null,null,null,null,false],[47,2220,0,null,null,null,null,false],[47,2239,0,null,null,null,null,false],[47,2261,0,null,null,null,null,false],[47,2283,0,null,null,null,null,false],[47,2302,0,null,null,null,null,false],[47,2323,0,null,null,null,null,false],[47,2344,0,null,null,null,null,false],[47,2362,0,null,null,null,null,false],[47,2380,0,null,null,null,null,false],[47,2398,0,null,null,null,null,false],[47,2423,0,null,null,null,null,false],[47,2448,0,null,null,null,null,false],[47,2467,0,null,null,null,null,false],[47,2486,0,null,null,null,null,false],[47,2510,0,null,null,null,null,false],[47,2534,0,null,null,null,null,false],[47,2560,0,null,null,null,null,false],[47,2586,0,null,null,null,null,false],[47,2605,0,null,null,null,null,false],[47,2626,0,null,null,null,null,false],[47,2647,0,null,null,null,null,false],[47,2671,0,null,null,null,null,false],[47,2695,0,null,null,null,null,false],[47,2721,0,null,null,null,null,false],[47,2747,0,null,null,null,null,false],[47,2766,0,null,null,null,null,false],[47,2787,0,null,null,null,null,false],[47,2808,0,null,null,null,null,false],[47,2828,0,null,null,null,null,false],[47,2853,0,null,null,null,null,false],[47,2881,0,null,null,null,null,false],[47,2904,0,null,null,null,null,false],[47,2914,0,null,null,null,null,false],[47,2925,0,null,null,null,null,false],[47,2936,0,null,null,null,null,false],[47,2950,0,null,null,null,null,false],[47,2964,0,null,null,null,null,false],[47,2981,0,null,null,null,null,false],[47,3001,0,null,null,null,null,false],[47,3021,0,null,null,null,null,false],[47,3038,0,null,null,null,null,false],[47,3056,0,null,null,null,null,false],[47,3074,0,null,null,null,null,false],[47,3081,0,null,null,null,null,false],[47,3099,0,null,null,null,null,false],[47,3120,0,null,null,null,null,false],[47,3138,0,null,null,null,null,false],[47,3163,0,null,null,null,null,false],[47,3174,0,null,null,null,null,false],[47,3185,0,null,null,null,null,false],[47,3199,0,null,null,null,null,false],[40,457,0,null,null,null,null,false],[0,0,0,"target/hexagon.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[48,2,0,null,null,null,null,false],[48,3,0,null,null,null,null,false],[48,4,0,null,null,null,null,false],[48,6,0,null,null,null,[7132,7133,7134,7135,7136,7137,7138,7139,7140,7141,7142,7143,7144,7145,7146,7147,7148,7149,7150,7151,7152,7153,7154,7155,7156,7157,7158,7159,7160,7161,7162,7163,7164,7165,7166,7167,7168,7169,7170,7171,7172,7173],false],[0,0,0,"audio",null,null,null,false],[0,0,0,"cabac",null,null,null,false],[0,0,0,"compound",null,null,null,false],[0,0,0,"duplex",null,null,null,false],[0,0,0,"hvx",null,null,null,false],[0,0,0,"hvx_ieee_fp",null,null,null,false],[0,0,0,"hvx_length128b",null,null,null,false],[0,0,0,"hvx_length64b",null,null,null,false],[0,0,0,"hvx_qfloat",null,null,null,false],[0,0,0,"hvxv60",null,null,null,false],[0,0,0,"hvxv62",null,null,null,false],[0,0,0,"hvxv65",null,null,null,false],[0,0,0,"hvxv66",null,null,null,false],[0,0,0,"hvxv67",null,null,null,false],[0,0,0,"hvxv68",null,null,null,false],[0,0,0,"hvxv69",null,null,null,false],[0,0,0,"hvxv71",null,null,null,false],[0,0,0,"hvxv73",null,null,null,false],[0,0,0,"long_calls",null,null,null,false],[0,0,0,"mem_noshuf",null,null,null,false],[0,0,0,"memops",null,null,null,false],[0,0,0,"noreturn_stack_elim",null,null,null,false],[0,0,0,"nvj",null,null,null,false],[0,0,0,"nvs",null,null,null,false],[0,0,0,"packets",null,null,null,false],[0,0,0,"prev65",null,null,null,false],[0,0,0,"reserved_r19",null,null,null,false],[0,0,0,"small_data",null,null,null,false],[0,0,0,"tinycore",null,null,null,false],[0,0,0,"unsafe_fp",null,null,null,false],[0,0,0,"v5",null,null,null,false],[0,0,0,"v55",null,null,null,false],[0,0,0,"v60",null,null,null,false],[0,0,0,"v62",null,null,null,false],[0,0,0,"v65",null,null,null,false],[0,0,0,"v66",null,null,null,false],[0,0,0,"v67",null,null,null,false],[0,0,0,"v68",null,null,null,false],[0,0,0,"v69",null,null,null,false],[0,0,0,"v71",null,null,null,false],[0,0,0,"v73",null,null,null,false],[0,0,0,"zreg",null,null,null,false],[48,51,0,null,null,null,null,false],[48,52,0,null,null,null,null,false],[48,53,0,null,null,null,null,false],[48,54,0,null,null,null,null,false],[48,56,0,null,null,null,null,false],[48,305,0,null,null,null,[],false],[48,306,0,null,null,null,null,false],[48,323,0,null,null,null,null,false],[48,338,0,null,null,null,null,false],[48,354,0,null,null,null,null,false],[48,371,0,null,null,null,null,false],[48,389,0,null,null,null,null,false],[48,408,0,null,null,null,null,false],[48,428,0,null,null,null,null,false],[48,449,0,null,null,null,null,false],[48,469,0,null,null,null,null,false],[48,491,0,null,null,null,null,false],[48,514,0,null,null,null,null,false],[48,538,0,null,null,null,null,false],[48,561,0,null,null,null,null,false],[40,458,0,null,null,null,null,false],[0,0,0,"target/loongarch.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[49,2,0,null,null,null,null,false],[49,3,0,null,null,null,null,false],[49,4,0,null,null,null,null,false],[49,6,0,null,null,null,[7200,7201,7202,7203,7204,7205,7206,7207,7208,7209,7210],false],[0,0,0,"32bit",null,null,null,false],[0,0,0,"64bit",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"f",null,null,null,false],[0,0,0,"la_global_with_abs",null,null,null,false],[0,0,0,"la_global_with_pcrel",null,null,null,false],[0,0,0,"la_local_with_abs",null,null,null,false],[0,0,0,"lasx",null,null,null,false],[0,0,0,"lbt",null,null,null,false],[0,0,0,"lsx",null,null,null,false],[0,0,0,"lvz",null,null,null,false],[49,20,0,null,null,null,null,false],[49,21,0,null,null,null,null,false],[49,22,0,null,null,null,null,false],[49,23,0,null,null,null,null,false],[49,25,0,null,null,null,null,false],[49,98,0,null,null,null,[],false],[49,99,0,null,null,null,null,false],[49,104,0,null,null,null,null,false],[49,111,0,null,null,null,null,false],[49,118,0,null,null,null,null,false],[40,459,0,null,null,null,null,false],[0,0,0,"target/m68k.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[50,2,0,null,null,null,null,false],[50,3,0,null,null,null,null,false],[50,4,0,null,null,null,null,false],[50,6,0,null,null,null,[7227,7228,7229,7230,7231,7232,7233,7234,7235,7236,7237,7238,7239,7240,7241,7242,7243,7244,7245,7246,7247],false],[0,0,0,"isa_68000",null,null,null,false],[0,0,0,"isa_68010",null,null,null,false],[0,0,0,"isa_68020",null,null,null,false],[0,0,0,"isa_68030",null,null,null,false],[0,0,0,"isa_68040",null,null,null,false],[0,0,0,"isa_68060",null,null,null,false],[0,0,0,"reserve_a0",null,null,null,false],[0,0,0,"reserve_a1",null,null,null,false],[0,0,0,"reserve_a2",null,null,null,false],[0,0,0,"reserve_a3",null,null,null,false],[0,0,0,"reserve_a4",null,null,null,false],[0,0,0,"reserve_a5",null,null,null,false],[0,0,0,"reserve_a6",null,null,null,false],[0,0,0,"reserve_d0",null,null,null,false],[0,0,0,"reserve_d1",null,null,null,false],[0,0,0,"reserve_d2",null,null,null,false],[0,0,0,"reserve_d3",null,null,null,false],[0,0,0,"reserve_d4",null,null,null,false],[0,0,0,"reserve_d5",null,null,null,false],[0,0,0,"reserve_d6",null,null,null,false],[0,0,0,"reserve_d7",null,null,null,false],[50,30,0,null,null,null,null,false],[50,31,0,null,null,null,null,false],[50,32,0,null,null,null,null,false],[50,33,0,null,null,null,null,false],[50,35,0,null,null,null,null,false],[50,162,0,null,null,null,[],false],[50,163,0,null,null,null,null,false],[50,170,0,null,null,null,null,false],[50,177,0,null,null,null,null,false],[50,184,0,null,null,null,null,false],[50,191,0,null,null,null,null,false],[50,198,0,null,null,null,null,false],[50,205,0,null,null,null,null,false],[40,460,0,null,null,null,null,false],[0,0,0,"target/mips.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[51,2,0,null,null,null,null,false],[51,3,0,null,null,null,null,false],[51,4,0,null,null,null,null,false],[51,6,0,null,null,null,[7267,7268,7269,7270,7271,7272,7273,7274,7275,7276,7277,7278,7279,7280,7281,7282,7283,7284,7285,7286,7287,7288,7289,7290,7291,7292,7293,7294,7295,7296,7297,7298,7299,7300,7301,7302,7303,7304,7305,7306,7307,7308,7309,7310,7311,7312,7313,7314,7315,7316,7317,7318],false],[0,0,0,"abs2008",null,null,null,false],[0,0,0,"cnmips",null,null,null,false],[0,0,0,"cnmipsp",null,null,null,false],[0,0,0,"crc",null,null,null,false],[0,0,0,"dsp",null,null,null,false],[0,0,0,"dspr2",null,null,null,false],[0,0,0,"dspr3",null,null,null,false],[0,0,0,"eva",null,null,null,false],[0,0,0,"fp64",null,null,null,false],[0,0,0,"fpxx",null,null,null,false],[0,0,0,"ginv",null,null,null,false],[0,0,0,"gp64",null,null,null,false],[0,0,0,"long_calls",null,null,null,false],[0,0,0,"micromips",null,null,null,false],[0,0,0,"mips1",null,null,null,false],[0,0,0,"mips16",null,null,null,false],[0,0,0,"mips2",null,null,null,false],[0,0,0,"mips3",null,null,null,false],[0,0,0,"mips32",null,null,null,false],[0,0,0,"mips32r2",null,null,null,false],[0,0,0,"mips32r3",null,null,null,false],[0,0,0,"mips32r5",null,null,null,false],[0,0,0,"mips32r6",null,null,null,false],[0,0,0,"mips3_32",null,null,null,false],[0,0,0,"mips3_32r2",null,null,null,false],[0,0,0,"mips3d",null,null,null,false],[0,0,0,"mips4",null,null,null,false],[0,0,0,"mips4_32",null,null,null,false],[0,0,0,"mips4_32r2",null,null,null,false],[0,0,0,"mips5",null,null,null,false],[0,0,0,"mips5_32r2",null,null,null,false],[0,0,0,"mips64",null,null,null,false],[0,0,0,"mips64r2",null,null,null,false],[0,0,0,"mips64r3",null,null,null,false],[0,0,0,"mips64r5",null,null,null,false],[0,0,0,"mips64r6",null,null,null,false],[0,0,0,"msa",null,null,null,false],[0,0,0,"mt",null,null,null,false],[0,0,0,"nan2008",null,null,null,false],[0,0,0,"noabicalls",null,null,null,false],[0,0,0,"nomadd4",null,null,null,false],[0,0,0,"nooddspreg",null,null,null,false],[0,0,0,"p5600",null,null,null,false],[0,0,0,"ptr64",null,null,null,false],[0,0,0,"single_float",null,null,null,false],[0,0,0,"soft_float",null,null,null,false],[0,0,0,"sym32",null,null,null,false],[0,0,0,"use_indirect_jump_hazard",null,null,null,false],[0,0,0,"use_tcc_in_div",null,null,null,false],[0,0,0,"vfpu",null,null,null,false],[0,0,0,"virt",null,null,null,false],[0,0,0,"xgot",null,null,null,false],[51,61,0,null,null,null,null,false],[51,62,0,null,null,null,null,false],[51,63,0,null,null,null,null,false],[51,64,0,null,null,null,null,false],[51,66,0,null,null,null,null,false],[51,396,0,null,null,null,[],false],[51,397,0,null,null,null,null,false],[51,404,0,null,null,null,null,false],[51,411,0,null,null,null,null,false],[51,418,0,null,null,null,null,false],[51,425,0,null,null,null,null,false],[51,432,0,null,null,null,null,false],[51,439,0,null,null,null,null,false],[51,446,0,null,null,null,null,false],[51,453,0,null,null,null,null,false],[51,460,0,null,null,null,null,false],[51,467,0,null,null,null,null,false],[51,474,0,null,null,null,null,false],[51,481,0,null,null,null,null,false],[51,488,0,null,null,null,null,false],[51,495,0,null,null,null,null,false],[51,502,0,null,null,null,null,false],[51,509,0,null,null,null,null,false],[51,516,0,null,null,null,null,false],[51,523,0,null,null,null,null,false],[40,461,0,null,null,null,null,false],[0,0,0,"target/msp430.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[52,2,0,null,null,null,null,false],[52,3,0,null,null,null,null,false],[52,4,0,null,null,null,null,false],[52,6,0,null,null,null,[7350,7351,7352,7353],false],[0,0,0,"ext",null,null,null,false],[0,0,0,"hwmult16",null,null,null,false],[0,0,0,"hwmult32",null,null,null,false],[0,0,0,"hwmultf5",null,null,null,false],[52,13,0,null,null,null,null,false],[52,14,0,null,null,null,null,false],[52,15,0,null,null,null,null,false],[52,16,0,null,null,null,null,false],[52,18,0,null,null,null,null,false],[52,50,0,null,null,null,[],false],[52,51,0,null,null,null,null,false],[52,56,0,null,null,null,null,false],[52,61,0,null,null,null,null,false],[40,462,0,null,null,null,null,false],[0,0,0,"target/nvptx.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[53,2,0,null,null,null,null,false],[53,3,0,null,null,null,null,false],[53,4,0,null,null,null,null,false],[53,6,0,null,null,null,[7369,7370,7371,7372,7373,7374,7375,7376,7377,7378,7379,7380,7381,7382,7383,7384,7385,7386,7387,7388,7389,7390,7391,7392,7393,7394,7395,7396,7397,7398,7399,7400,7401,7402,7403,7404,7405,7406,7407,7408],false],[0,0,0,"ptx32",null,null,null,false],[0,0,0,"ptx40",null,null,null,false],[0,0,0,"ptx41",null,null,null,false],[0,0,0,"ptx42",null,null,null,false],[0,0,0,"ptx43",null,null,null,false],[0,0,0,"ptx50",null,null,null,false],[0,0,0,"ptx60",null,null,null,false],[0,0,0,"ptx61",null,null,null,false],[0,0,0,"ptx63",null,null,null,false],[0,0,0,"ptx64",null,null,null,false],[0,0,0,"ptx65",null,null,null,false],[0,0,0,"ptx70",null,null,null,false],[0,0,0,"ptx71",null,null,null,false],[0,0,0,"ptx72",null,null,null,false],[0,0,0,"ptx73",null,null,null,false],[0,0,0,"ptx74",null,null,null,false],[0,0,0,"ptx75",null,null,null,false],[0,0,0,"ptx76",null,null,null,false],[0,0,0,"ptx77",null,null,null,false],[0,0,0,"ptx78",null,null,null,false],[0,0,0,"sm_20",null,null,null,false],[0,0,0,"sm_21",null,null,null,false],[0,0,0,"sm_30",null,null,null,false],[0,0,0,"sm_32",null,null,null,false],[0,0,0,"sm_35",null,null,null,false],[0,0,0,"sm_37",null,null,null,false],[0,0,0,"sm_50",null,null,null,false],[0,0,0,"sm_52",null,null,null,false],[0,0,0,"sm_53",null,null,null,false],[0,0,0,"sm_60",null,null,null,false],[0,0,0,"sm_61",null,null,null,false],[0,0,0,"sm_62",null,null,null,false],[0,0,0,"sm_70",null,null,null,false],[0,0,0,"sm_72",null,null,null,false],[0,0,0,"sm_75",null,null,null,false],[0,0,0,"sm_80",null,null,null,false],[0,0,0,"sm_86",null,null,null,false],[0,0,0,"sm_87",null,null,null,false],[0,0,0,"sm_89",null,null,null,false],[0,0,0,"sm_90",null,null,null,false],[53,49,0,null,null,null,null,false],[53,50,0,null,null,null,null,false],[53,51,0,null,null,null,null,false],[53,52,0,null,null,null,null,false],[53,54,0,null,null,null,null,false],[53,266,0,null,null,null,[],false],[53,267,0,null,null,null,null,false],[53,275,0,null,null,null,null,false],[53,283,0,null,null,null,null,false],[53,290,0,null,null,null,null,false],[53,298,0,null,null,null,null,false],[53,306,0,null,null,null,null,false],[53,314,0,null,null,null,null,false],[53,322,0,null,null,null,null,false],[53,330,0,null,null,null,null,false],[53,338,0,null,null,null,null,false],[53,346,0,null,null,null,null,false],[53,354,0,null,null,null,null,false],[53,362,0,null,null,null,null,false],[53,370,0,null,null,null,null,false],[53,378,0,null,null,null,null,false],[53,386,0,null,null,null,null,false],[53,394,0,null,null,null,null,false],[53,402,0,null,null,null,null,false],[53,410,0,null,null,null,null,false],[53,418,0,null,null,null,null,false],[40,463,0,null,null,null,null,false],[0,0,0,"target/powerpc.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[54,2,0,null,null,null,null,false],[54,3,0,null,null,null,null,false],[54,4,0,null,null,null,null,false],[54,6,0,null,null,null,[7441,7442,7443,7444,7445,7446,7447,7448,7449,7450,7451,7452,7453,7454,7455,7456,7457,7458,7459,7460,7461,7462,7463,7464,7465,7466,7467,7468,7469,7470,7471,7472,7473,7474,7475,7476,7477,7478,7479,7480,7481,7482,7483,7484,7485,7486,7487,7488,7489,7490,7491,7492,7493,7494,7495,7496,7497,7498,7499,7500,7501,7502,7503,7504,7505,7506,7507,7508,7509,7510,7511,7512,7513,7514,7515,7516,7517,7518,7519,7520,7521],false],[0,0,0,"64bit",null,null,null,false],[0,0,0,"64bitregs",null,null,null,false],[0,0,0,"aix",null,null,null,false],[0,0,0,"allow_unaligned_fp_access",null,null,null,false],[0,0,0,"altivec",null,null,null,false],[0,0,0,"booke",null,null,null,false],[0,0,0,"bpermd",null,null,null,false],[0,0,0,"cmpb",null,null,null,false],[0,0,0,"crbits",null,null,null,false],[0,0,0,"crypto",null,null,null,false],[0,0,0,"direct_move",null,null,null,false],[0,0,0,"e500",null,null,null,false],[0,0,0,"efpu2",null,null,null,false],[0,0,0,"extdiv",null,null,null,false],[0,0,0,"fast_MFLR",null,null,null,false],[0,0,0,"fcpsgn",null,null,null,false],[0,0,0,"float128",null,null,null,false],[0,0,0,"fpcvt",null,null,null,false],[0,0,0,"fprnd",null,null,null,false],[0,0,0,"fpu",null,null,null,false],[0,0,0,"fre",null,null,null,false],[0,0,0,"fres",null,null,null,false],[0,0,0,"frsqrte",null,null,null,false],[0,0,0,"frsqrtes",null,null,null,false],[0,0,0,"fsqrt",null,null,null,false],[0,0,0,"fuse_add_logical",null,null,null,false],[0,0,0,"fuse_addi_load",null,null,null,false],[0,0,0,"fuse_addis_load",null,null,null,false],[0,0,0,"fuse_arith_add",null,null,null,false],[0,0,0,"fuse_back2back",null,null,null,false],[0,0,0,"fuse_cmp",null,null,null,false],[0,0,0,"fuse_logical",null,null,null,false],[0,0,0,"fuse_logical_add",null,null,null,false],[0,0,0,"fuse_sha3",null,null,null,false],[0,0,0,"fuse_store",null,null,null,false],[0,0,0,"fuse_wideimm",null,null,null,false],[0,0,0,"fuse_zeromove",null,null,null,false],[0,0,0,"fusion",null,null,null,false],[0,0,0,"hard_float",null,null,null,false],[0,0,0,"htm",null,null,null,false],[0,0,0,"icbt",null,null,null,false],[0,0,0,"invariant_function_descriptors",null,null,null,false],[0,0,0,"isa_future_instructions",null,null,null,false],[0,0,0,"isa_v206_instructions",null,null,null,false],[0,0,0,"isa_v207_instructions",null,null,null,false],[0,0,0,"isa_v30_instructions",null,null,null,false],[0,0,0,"isa_v31_instructions",null,null,null,false],[0,0,0,"isel",null,null,null,false],[0,0,0,"ldbrx",null,null,null,false],[0,0,0,"lfiwax",null,null,null,false],[0,0,0,"longcall",null,null,null,false],[0,0,0,"mfocrf",null,null,null,false],[0,0,0,"mma",null,null,null,false],[0,0,0,"modern_aix_as",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"paired_vector_memops",null,null,null,false],[0,0,0,"partword_atomics",null,null,null,false],[0,0,0,"pcrelative_memops",null,null,null,false],[0,0,0,"popcntd",null,null,null,false],[0,0,0,"power10_vector",null,null,null,false],[0,0,0,"power8_altivec",null,null,null,false],[0,0,0,"power8_vector",null,null,null,false],[0,0,0,"power9_altivec",null,null,null,false],[0,0,0,"power9_vector",null,null,null,false],[0,0,0,"ppc4xx",null,null,null,false],[0,0,0,"ppc6xx",null,null,null,false],[0,0,0,"ppc_postra_sched",null,null,null,false],[0,0,0,"ppc_prera_sched",null,null,null,false],[0,0,0,"predictable_select_expensive",null,null,null,false],[0,0,0,"prefix_instrs",null,null,null,false],[0,0,0,"privileged",null,null,null,false],[0,0,0,"quadword_atomics",null,null,null,false],[0,0,0,"recipprec",null,null,null,false],[0,0,0,"rop_protect",null,null,null,false],[0,0,0,"secure_plt",null,null,null,false],[0,0,0,"slow_popcntd",null,null,null,false],[0,0,0,"spe",null,null,null,false],[0,0,0,"stfiwx",null,null,null,false],[0,0,0,"two_const_nr",null,null,null,false],[0,0,0,"vectors_use_two_units",null,null,null,false],[0,0,0,"vsx",null,null,null,false],[54,90,0,null,null,null,null,false],[54,91,0,null,null,null,null,false],[54,92,0,null,null,null,null,false],[54,93,0,null,null,null,null,false],[54,95,0,null,null,null,null,false],[54,607,0,null,null,null,[],false],[54,608,0,null,null,null,null,false],[54,618,0,null,null,null,null,false],[54,628,0,null,null,null,null,false],[54,635,0,null,null,null,null,false],[54,642,0,null,null,null,null,false],[54,650,0,null,null,null,null,false],[54,658,0,null,null,null,null,false],[54,666,0,null,null,null,null,false],[54,674,0,null,null,null,null,false],[54,682,0,null,null,null,null,false],[54,690,0,null,null,null,null,false],[54,699,0,null,null,null,null,false],[54,708,0,null,null,null,null,false],[54,716,0,null,null,null,null,false],[54,729,0,null,null,null,null,false],[54,754,0,null,null,null,null,false],[54,763,0,null,null,null,null,false],[54,772,0,null,null,null,null,false],[54,783,0,null,null,null,null,false],[54,832,0,null,null,null,null,false],[54,840,0,null,null,null,null,false],[54,849,0,null,null,null,null,false],[54,858,0,null,null,null,null,false],[54,871,0,null,null,null,null,false],[54,878,0,null,null,null,null,false],[54,885,0,null,null,null,null,false],[54,898,0,null,null,null,null,false],[54,938,0,null,null,null,null,false],[54,986,0,null,null,null,null,false],[54,998,0,null,null,null,null,false],[54,1011,0,null,null,null,null,false],[54,1026,0,null,null,null,null,false],[54,1042,0,null,null,null,null,false],[54,1062,0,null,null,null,null,false],[54,1082,0,null,null,null,null,false],[54,1111,0,null,null,null,null,false],[54,1151,0,null,null,null,null,false],[40,464,0,null,null,null,null,false],[0,0,0,"target/riscv.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[55,2,0,null,null,null,null,false],[55,3,0,null,null,null,null,false],[55,4,0,null,null,null,null,false],[55,6,0,null,null,null,[7571,7572,7573,7574,7575,7576,7577,7578,7579,7580,7581,7582,7583,7584,7585,7586,7587,7588,7589,7590,7591,7592,7593,7594,7595,7596,7597,7598,7599,7600,7601,7602,7603,7604,7605,7606,7607,7608,7609,7610,7611,7612,7613,7614,7615,7616,7617,7618,7619,7620,7621,7622,7623,7624,7625,7626,7627,7628,7629,7630,7631,7632,7633,7634,7635,7636,7637,7638,7639,7640,7641,7642,7643,7644,7645,7646,7647,7648,7649,7650,7651,7652,7653,7654,7655,7656,7657,7658,7659,7660,7661,7662,7663,7664,7665,7666,7667,7668,7669,7670,7671,7672,7673,7674,7675,7676,7677,7678],false],[0,0,0,"32bit",null,null,null,false],[0,0,0,"64bit",null,null,null,false],[0,0,0,"a",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"e",null,null,null,false],[0,0,0,"experimental_zawrs",null,null,null,false],[0,0,0,"experimental_zca",null,null,null,false],[0,0,0,"experimental_zcd",null,null,null,false],[0,0,0,"experimental_zcf",null,null,null,false],[0,0,0,"experimental_zihintntl",null,null,null,false],[0,0,0,"experimental_ztso",null,null,null,false],[0,0,0,"experimental_zvfh",null,null,null,false],[0,0,0,"f",null,null,null,false],[0,0,0,"forced_atomics",null,null,null,false],[0,0,0,"h",null,null,null,false],[0,0,0,"lui_addi_fusion",null,null,null,false],[0,0,0,"m",null,null,null,false],[0,0,0,"no_default_unroll",null,null,null,false],[0,0,0,"no_optimized_zero_stride_load",null,null,null,false],[0,0,0,"no_rvc_hints",null,null,null,false],[0,0,0,"relax",null,null,null,false],[0,0,0,"reserve_x1",null,null,null,false],[0,0,0,"reserve_x10",null,null,null,false],[0,0,0,"reserve_x11",null,null,null,false],[0,0,0,"reserve_x12",null,null,null,false],[0,0,0,"reserve_x13",null,null,null,false],[0,0,0,"reserve_x14",null,null,null,false],[0,0,0,"reserve_x15",null,null,null,false],[0,0,0,"reserve_x16",null,null,null,false],[0,0,0,"reserve_x17",null,null,null,false],[0,0,0,"reserve_x18",null,null,null,false],[0,0,0,"reserve_x19",null,null,null,false],[0,0,0,"reserve_x2",null,null,null,false],[0,0,0,"reserve_x20",null,null,null,false],[0,0,0,"reserve_x21",null,null,null,false],[0,0,0,"reserve_x22",null,null,null,false],[0,0,0,"reserve_x23",null,null,null,false],[0,0,0,"reserve_x24",null,null,null,false],[0,0,0,"reserve_x25",null,null,null,false],[0,0,0,"reserve_x26",null,null,null,false],[0,0,0,"reserve_x27",null,null,null,false],[0,0,0,"reserve_x28",null,null,null,false],[0,0,0,"reserve_x29",null,null,null,false],[0,0,0,"reserve_x3",null,null,null,false],[0,0,0,"reserve_x30",null,null,null,false],[0,0,0,"reserve_x31",null,null,null,false],[0,0,0,"reserve_x4",null,null,null,false],[0,0,0,"reserve_x5",null,null,null,false],[0,0,0,"reserve_x6",null,null,null,false],[0,0,0,"reserve_x7",null,null,null,false],[0,0,0,"reserve_x8",null,null,null,false],[0,0,0,"reserve_x9",null,null,null,false],[0,0,0,"save_restore",null,null,null,false],[0,0,0,"short_forward_branch_opt",null,null,null,false],[0,0,0,"svinval",null,null,null,false],[0,0,0,"svnapot",null,null,null,false],[0,0,0,"svpbmt",null,null,null,false],[0,0,0,"tagged_globals",null,null,null,false],[0,0,0,"unaligned_scalar_mem",null,null,null,false],[0,0,0,"v",null,null,null,false],[0,0,0,"xtheadvdot",null,null,null,false],[0,0,0,"xventanacondops",null,null,null,false],[0,0,0,"zba",null,null,null,false],[0,0,0,"zbb",null,null,null,false],[0,0,0,"zbc",null,null,null,false],[0,0,0,"zbkb",null,null,null,false],[0,0,0,"zbkc",null,null,null,false],[0,0,0,"zbkx",null,null,null,false],[0,0,0,"zbs",null,null,null,false],[0,0,0,"zdinx",null,null,null,false],[0,0,0,"zfh",null,null,null,false],[0,0,0,"zfhmin",null,null,null,false],[0,0,0,"zfinx",null,null,null,false],[0,0,0,"zhinx",null,null,null,false],[0,0,0,"zhinxmin",null,null,null,false],[0,0,0,"zicbom",null,null,null,false],[0,0,0,"zicbop",null,null,null,false],[0,0,0,"zicboz",null,null,null,false],[0,0,0,"zihintpause",null,null,null,false],[0,0,0,"zk",null,null,null,false],[0,0,0,"zkn",null,null,null,false],[0,0,0,"zknd",null,null,null,false],[0,0,0,"zkne",null,null,null,false],[0,0,0,"zknh",null,null,null,false],[0,0,0,"zkr",null,null,null,false],[0,0,0,"zks",null,null,null,false],[0,0,0,"zksed",null,null,null,false],[0,0,0,"zksh",null,null,null,false],[0,0,0,"zkt",null,null,null,false],[0,0,0,"zmmul",null,null,null,false],[0,0,0,"zve32f",null,null,null,false],[0,0,0,"zve32x",null,null,null,false],[0,0,0,"zve64d",null,null,null,false],[0,0,0,"zve64f",null,null,null,false],[0,0,0,"zve64x",null,null,null,false],[0,0,0,"zvl1024b",null,null,null,false],[0,0,0,"zvl128b",null,null,null,false],[0,0,0,"zvl16384b",null,null,null,false],[0,0,0,"zvl2048b",null,null,null,false],[0,0,0,"zvl256b",null,null,null,false],[0,0,0,"zvl32768b",null,null,null,false],[0,0,0,"zvl32b",null,null,null,false],[0,0,0,"zvl4096b",null,null,null,false],[0,0,0,"zvl512b",null,null,null,false],[0,0,0,"zvl64b",null,null,null,false],[0,0,0,"zvl65536b",null,null,null,false],[0,0,0,"zvl8192b",null,null,null,false],[55,117,0,null,null,null,null,false],[55,118,0,null,null,null,null,false],[55,119,0,null,null,null,null,false],[55,120,0,null,null,null,null,false],[55,122,0,null,null,null,null,false],[55,745,0,null,null,null,[],false],[55,746,0,null,null,null,null,false],[55,757,0,null,null,null,null,false],[55,768,0,null,null,null,null,false],[55,773,0,null,null,null,null,false],[55,780,0,null,null,null,null,false],[55,787,0,null,null,null,null,false],[55,792,0,null,null,null,null,false],[55,799,0,null,null,null,null,false],[55,806,0,null,null,null,null,false],[55,814,0,null,null,null,null,false],[55,823,0,null,null,null,null,false],[55,833,0,null,null,null,null,false],[55,844,0,null,null,null,null,false],[55,854,0,null,null,null,null,false],[55,865,0,null,null,null,null,false],[55,878,0,null,null,null,null,false],[55,888,0,null,null,null,null,false],[55,898,0,null,null,null,null,false],[55,909,0,null,null,null,null,false],[55,922,0,null,null,null,null,false],[55,933,0,null,null,null,null,false],[55,946,0,null,null,null,null,false],[55,955,0,null,null,null,null,false],[40,465,0,null,null,null,null,false],[0,0,0,"target/sparc.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[56,2,0,null,null,null,null,false],[56,3,0,null,null,null,null,false],[56,4,0,null,null,null,null,false],[56,6,0,null,null,null,[7714,7715,7716,7717,7718,7719,7720,7721,7722,7723,7724,7725,7726,7727,7728,7729,7730,7731,7732],false],[0,0,0,"deprecated_v8",null,null,null,false],[0,0,0,"detectroundchange",null,null,null,false],[0,0,0,"fixallfdivsqrt",null,null,null,false],[0,0,0,"hard_quad_float",null,null,null,false],[0,0,0,"hasleoncasa",null,null,null,false],[0,0,0,"hasumacsmac",null,null,null,false],[0,0,0,"insertnopload",null,null,null,false],[0,0,0,"leon",null,null,null,false],[0,0,0,"leoncyclecounter",null,null,null,false],[0,0,0,"leonpwrpsr",null,null,null,false],[0,0,0,"no_fmuls",null,null,null,false],[0,0,0,"no_fsmuld",null,null,null,false],[0,0,0,"popc",null,null,null,false],[0,0,0,"soft_float",null,null,null,false],[0,0,0,"soft_mul_div",null,null,null,false],[0,0,0,"v9",null,null,null,false],[0,0,0,"vis",null,null,null,false],[0,0,0,"vis2",null,null,null,false],[0,0,0,"vis3",null,null,null,false],[56,28,0,null,null,null,null,false],[56,29,0,null,null,null,null,false],[56,30,0,null,null,null,null,false],[56,31,0,null,null,null,null,false],[56,33,0,null,null,null,null,false],[56,140,0,null,null,null,[],false],[56,141,0,null,null,null,null,false],[56,149,0,null,null,null,null,false],[56,157,0,null,null,null,null,false],[56,162,0,null,null,null,null,false],[56,167,0,null,null,null,null,false],[56,175,0,null,null,null,null,false],[56,186,0,null,null,null,null,false],[56,191,0,null,null,null,null,false],[56,198,0,null,null,null,null,false],[56,206,0,null,null,null,null,false],[56,215,0,null,null,null,null,false],[56,223,0,null,null,null,null,false],[56,231,0,null,null,null,null,false],[56,239,0,null,null,null,null,false],[56,247,0,null,null,null,null,false],[56,255,0,null,null,null,null,false],[56,263,0,null,null,null,null,false],[56,271,0,null,null,null,null,false],[56,279,0,null,null,null,null,false],[56,287,0,null,null,null,null,false],[56,295,0,null,null,null,null,false],[56,303,0,null,null,null,null,false],[56,311,0,null,null,null,null,false],[56,319,0,null,null,null,null,false],[56,327,0,null,null,null,null,false],[56,335,0,null,null,null,null,false],[56,345,0,null,null,null,null,false],[56,356,0,null,null,null,null,false],[56,367,0,null,null,null,null,false],[56,379,0,null,null,null,null,false],[56,384,0,null,null,null,null,false],[56,389,0,null,null,null,null,false],[56,394,0,null,null,null,null,false],[56,399,0,null,null,null,null,false],[56,404,0,null,null,null,null,false],[56,413,0,null,null,null,null,false],[56,423,0,null,null,null,null,false],[56,434,0,null,null,null,null,false],[56,442,0,null,null,null,null,false],[56,447,0,null,null,null,null,false],[40,466,0,null,null,null,null,false],[0,0,0,"target/spirv.zig",null," This file is auto-generated by tools/update_spirv_features.zig.\n TODO: Dependencies of capabilities on extensions.\n TODO: Dependencies of extensions on extensions.\n TODO: Dependencies of extensions on versions.\n",[],false],[57,5,0,null,null,null,null,false],[57,6,0,null,null,null,null,false],[57,7,0,null,null,null,null,false],[57,9,0,null,null,null,[7785,7786,7787,7788,7789,7790,7791,7792,7793,7794,7795,7796,7797,7798,7799,7800,7801,7802,7803,7804,7805,7806,7807,7808,7809,7810,7811,7812,7813,7814,7815,7816,7817,7818,7819,7820,7821,7822,7823,7824,7825,7826,7827,7828,7829,7830,7831,7832,7833,7834,7835,7836,7837,7838,7839,7840,7841,7842,7843,7844,7845,7846,7847,7848,7849,7850,7851,7852,7853,7854,7855,7856,7857,7858,7859,7860,7861,7862,7863,7864,7865,7866,7867,7868,7869,7870,7871,7872,7873,7874,7875,7876,7877,7878,7879,7880,7881,7882,7883,7884,7885,7886,7887,7888,7889,7890,7891,7892,7893,7894,7895,7896,7897,7898,7899,7900,7901,7902,7903,7904,7905,7906,7907,7908,7909,7910,7911,7912,7913,7914,7915,7916,7917,7918,7919,7920,7921,7922,7923,7924,7925,7926,7927,7928,7929,7930,7931,7932,7933,7934,7935,7936,7937,7938,7939,7940,7941,7942,7943,7944,7945,7946,7947,7948,7949,7950,7951,7952,7953,7954,7955,7956,7957,7958,7959,7960,7961,7962,7963,7964,7965,7966,7967,7968,7969,7970,7971,7972,7973,7974,7975,7976,7977,7978,7979,7980,7981,7982,7983,7984,7985,7986,7987,7988,7989,7990,7991,7992,7993,7994,7995,7996,7997,7998,7999,8000,8001,8002,8003,8004,8005,8006,8007,8008,8009,8010,8011,8012,8013,8014,8015,8016,8017,8018,8019,8020,8021,8022,8023,8024,8025,8026,8027,8028,8029,8030,8031,8032,8033,8034,8035,8036,8037,8038,8039,8040,8041,8042,8043,8044,8045,8046,8047,8048,8049,8050,8051,8052,8053,8054,8055,8056,8057,8058,8059,8060,8061,8062,8063,8064,8065,8066,8067,8068],false],[0,0,0,"v1_1",null,null,null,false],[0,0,0,"v1_2",null,null,null,false],[0,0,0,"v1_3",null,null,null,false],[0,0,0,"v1_4",null,null,null,false],[0,0,0,"v1_5",null,null,null,false],[0,0,0,"SPV_AMD_shader_fragment_mask",null,null,null,false],[0,0,0,"SPV_AMD_gpu_shader_int16",null,null,null,false],[0,0,0,"SPV_AMD_gpu_shader_half_float",null,null,null,false],[0,0,0,"SPV_AMD_texture_gather_bias_lod",null,null,null,false],[0,0,0,"SPV_AMD_shader_ballot",null,null,null,false],[0,0,0,"SPV_AMD_gcn_shader",null,null,null,false],[0,0,0,"SPV_AMD_shader_image_load_store_lod",null,null,null,false],[0,0,0,"SPV_AMD_shader_explicit_vertex_parameter",null,null,null,false],[0,0,0,"SPV_AMD_shader_trinary_minmax",null,null,null,false],[0,0,0,"SPV_AMD_gpu_shader_half_float_fetch",null,null,null,false],[0,0,0,"SPV_GOOGLE_hlsl_functionality1",null,null,null,false],[0,0,0,"SPV_GOOGLE_user_type",null,null,null,false],[0,0,0,"SPV_GOOGLE_decorate_string",null,null,null,false],[0,0,0,"SPV_EXT_demote_to_helper_invocation",null,null,null,false],[0,0,0,"SPV_EXT_descriptor_indexing",null,null,null,false],[0,0,0,"SPV_EXT_fragment_fully_covered",null,null,null,false],[0,0,0,"SPV_EXT_shader_stencil_export",null,null,null,false],[0,0,0,"SPV_EXT_physical_storage_buffer",null,null,null,false],[0,0,0,"SPV_EXT_shader_atomic_float_add",null,null,null,false],[0,0,0,"SPV_EXT_shader_atomic_float_min_max",null,null,null,false],[0,0,0,"SPV_EXT_shader_image_int64",null,null,null,false],[0,0,0,"SPV_EXT_fragment_shader_interlock",null,null,null,false],[0,0,0,"SPV_EXT_fragment_invocation_density",null,null,null,false],[0,0,0,"SPV_EXT_shader_viewport_index_layer",null,null,null,false],[0,0,0,"SPV_INTEL_loop_fuse",null,null,null,false],[0,0,0,"SPV_INTEL_fpga_dsp_control",null,null,null,false],[0,0,0,"SPV_INTEL_fpga_reg",null,null,null,false],[0,0,0,"SPV_INTEL_fpga_memory_accesses",null,null,null,false],[0,0,0,"SPV_INTEL_fpga_loop_controls",null,null,null,false],[0,0,0,"SPV_INTEL_io_pipes",null,null,null,false],[0,0,0,"SPV_INTEL_unstructured_loop_controls",null,null,null,false],[0,0,0,"SPV_INTEL_blocking_pipes",null,null,null,false],[0,0,0,"SPV_INTEL_device_side_avc_motion_estimation",null,null,null,false],[0,0,0,"SPV_INTEL_fpga_memory_attributes",null,null,null,false],[0,0,0,"SPV_INTEL_fp_fast_math_mode",null,null,null,false],[0,0,0,"SPV_INTEL_media_block_io",null,null,null,false],[0,0,0,"SPV_INTEL_shader_integer_functions2",null,null,null,false],[0,0,0,"SPV_INTEL_subgroups",null,null,null,false],[0,0,0,"SPV_INTEL_fpga_cluster_attributes",null,null,null,false],[0,0,0,"SPV_INTEL_kernel_attributes",null,null,null,false],[0,0,0,"SPV_INTEL_arbitrary_precision_integers",null,null,null,false],[0,0,0,"SPV_KHR_8bit_storage",null,null,null,false],[0,0,0,"SPV_KHR_shader_clock",null,null,null,false],[0,0,0,"SPV_KHR_device_group",null,null,null,false],[0,0,0,"SPV_KHR_16bit_storage",null,null,null,false],[0,0,0,"SPV_KHR_variable_pointers",null,null,null,false],[0,0,0,"SPV_KHR_no_integer_wrap_decoration",null,null,null,false],[0,0,0,"SPV_KHR_subgroup_vote",null,null,null,false],[0,0,0,"SPV_KHR_multiview",null,null,null,false],[0,0,0,"SPV_KHR_shader_ballot",null,null,null,false],[0,0,0,"SPV_KHR_vulkan_memory_model",null,null,null,false],[0,0,0,"SPV_KHR_physical_storage_buffer",null,null,null,false],[0,0,0,"SPV_KHR_workgroup_memory_explicit_layout",null,null,null,false],[0,0,0,"SPV_KHR_fragment_shading_rate",null,null,null,false],[0,0,0,"SPV_KHR_shader_atomic_counter_ops",null,null,null,false],[0,0,0,"SPV_KHR_shader_draw_parameters",null,null,null,false],[0,0,0,"SPV_KHR_storage_buffer_storage_class",null,null,null,false],[0,0,0,"SPV_KHR_linkonce_odr",null,null,null,false],[0,0,0,"SPV_KHR_terminate_invocation",null,null,null,false],[0,0,0,"SPV_KHR_non_semantic_info",null,null,null,false],[0,0,0,"SPV_KHR_post_depth_coverage",null,null,null,false],[0,0,0,"SPV_KHR_expect_assume",null,null,null,false],[0,0,0,"SPV_KHR_ray_tracing",null,null,null,false],[0,0,0,"SPV_KHR_ray_query",null,null,null,false],[0,0,0,"SPV_KHR_float_controls",null,null,null,false],[0,0,0,"SPV_NV_viewport_array2",null,null,null,false],[0,0,0,"SPV_NV_shader_subgroup_partitioned",null,null,null,false],[0,0,0,"SPV_NVX_multiview_per_view_attributes",null,null,null,false],[0,0,0,"SPV_NV_ray_tracing",null,null,null,false],[0,0,0,"SPV_NV_shader_image_footprint",null,null,null,false],[0,0,0,"SPV_NV_shading_rate",null,null,null,false],[0,0,0,"SPV_NV_stereo_view_rendering",null,null,null,false],[0,0,0,"SPV_NV_compute_shader_derivatives",null,null,null,false],[0,0,0,"SPV_NV_shader_sm_builtins",null,null,null,false],[0,0,0,"SPV_NV_mesh_shader",null,null,null,false],[0,0,0,"SPV_NV_geometry_shader_passthrough",null,null,null,false],[0,0,0,"SPV_NV_fragment_shader_barycentric",null,null,null,false],[0,0,0,"SPV_NV_cooperative_matrix",null,null,null,false],[0,0,0,"SPV_NV_sample_mask_override_coverage",null,null,null,false],[0,0,0,"Matrix",null,null,null,false],[0,0,0,"Shader",null,null,null,false],[0,0,0,"Geometry",null,null,null,false],[0,0,0,"Tessellation",null,null,null,false],[0,0,0,"Addresses",null,null,null,false],[0,0,0,"Linkage",null,null,null,false],[0,0,0,"Kernel",null,null,null,false],[0,0,0,"Vector16",null,null,null,false],[0,0,0,"Float16Buffer",null,null,null,false],[0,0,0,"Float16",null,null,null,false],[0,0,0,"Float64",null,null,null,false],[0,0,0,"Int64",null,null,null,false],[0,0,0,"Int64Atomics",null,null,null,false],[0,0,0,"ImageBasic",null,null,null,false],[0,0,0,"ImageReadWrite",null,null,null,false],[0,0,0,"ImageMipmap",null,null,null,false],[0,0,0,"Pipes",null,null,null,false],[0,0,0,"Groups",null,null,null,false],[0,0,0,"DeviceEnqueue",null,null,null,false],[0,0,0,"LiteralSampler",null,null,null,false],[0,0,0,"AtomicStorage",null,null,null,false],[0,0,0,"Int16",null,null,null,false],[0,0,0,"TessellationPointSize",null,null,null,false],[0,0,0,"GeometryPointSize",null,null,null,false],[0,0,0,"ImageGatherExtended",null,null,null,false],[0,0,0,"StorageImageMultisample",null,null,null,false],[0,0,0,"UniformBufferArrayDynamicIndexing",null,null,null,false],[0,0,0,"SampledImageArrayDynamicIndexing",null,null,null,false],[0,0,0,"StorageBufferArrayDynamicIndexing",null,null,null,false],[0,0,0,"StorageImageArrayDynamicIndexing",null,null,null,false],[0,0,0,"ClipDistance",null,null,null,false],[0,0,0,"CullDistance",null,null,null,false],[0,0,0,"ImageCubeArray",null,null,null,false],[0,0,0,"SampleRateShading",null,null,null,false],[0,0,0,"ImageRect",null,null,null,false],[0,0,0,"SampledRect",null,null,null,false],[0,0,0,"GenericPointer",null,null,null,false],[0,0,0,"Int8",null,null,null,false],[0,0,0,"InputAttachment",null,null,null,false],[0,0,0,"SparseResidency",null,null,null,false],[0,0,0,"MinLod",null,null,null,false],[0,0,0,"Sampled1D",null,null,null,false],[0,0,0,"Image1D",null,null,null,false],[0,0,0,"SampledCubeArray",null,null,null,false],[0,0,0,"SampledBuffer",null,null,null,false],[0,0,0,"ImageBuffer",null,null,null,false],[0,0,0,"ImageMSArray",null,null,null,false],[0,0,0,"StorageImageExtendedFormats",null,null,null,false],[0,0,0,"ImageQuery",null,null,null,false],[0,0,0,"DerivativeControl",null,null,null,false],[0,0,0,"InterpolationFunction",null,null,null,false],[0,0,0,"TransformFeedback",null,null,null,false],[0,0,0,"GeometryStreams",null,null,null,false],[0,0,0,"StorageImageReadWithoutFormat",null,null,null,false],[0,0,0,"StorageImageWriteWithoutFormat",null,null,null,false],[0,0,0,"MultiViewport",null,null,null,false],[0,0,0,"SubgroupDispatch",null,null,null,false],[0,0,0,"NamedBarrier",null,null,null,false],[0,0,0,"PipeStorage",null,null,null,false],[0,0,0,"GroupNonUniform",null,null,null,false],[0,0,0,"GroupNonUniformVote",null,null,null,false],[0,0,0,"GroupNonUniformArithmetic",null,null,null,false],[0,0,0,"GroupNonUniformBallot",null,null,null,false],[0,0,0,"GroupNonUniformShuffle",null,null,null,false],[0,0,0,"GroupNonUniformShuffleRelative",null,null,null,false],[0,0,0,"GroupNonUniformClustered",null,null,null,false],[0,0,0,"GroupNonUniformQuad",null,null,null,false],[0,0,0,"ShaderLayer",null,null,null,false],[0,0,0,"ShaderViewportIndex",null,null,null,false],[0,0,0,"FragmentShadingRateKHR",null,null,null,false],[0,0,0,"SubgroupBallotKHR",null,null,null,false],[0,0,0,"DrawParameters",null,null,null,false],[0,0,0,"WorkgroupMemoryExplicitLayoutKHR",null,null,null,false],[0,0,0,"WorkgroupMemoryExplicitLayout8BitAccessKHR",null,null,null,false],[0,0,0,"WorkgroupMemoryExplicitLayout16BitAccessKHR",null,null,null,false],[0,0,0,"SubgroupVoteKHR",null,null,null,false],[0,0,0,"StorageBuffer16BitAccess",null,null,null,false],[0,0,0,"StorageUniformBufferBlock16",null,null,null,false],[0,0,0,"UniformAndStorageBuffer16BitAccess",null,null,null,false],[0,0,0,"StorageUniform16",null,null,null,false],[0,0,0,"StoragePushConstant16",null,null,null,false],[0,0,0,"StorageInputOutput16",null,null,null,false],[0,0,0,"DeviceGroup",null,null,null,false],[0,0,0,"MultiView",null,null,null,false],[0,0,0,"VariablePointersStorageBuffer",null,null,null,false],[0,0,0,"VariablePointers",null,null,null,false],[0,0,0,"AtomicStorageOps",null,null,null,false],[0,0,0,"SampleMaskPostDepthCoverage",null,null,null,false],[0,0,0,"StorageBuffer8BitAccess",null,null,null,false],[0,0,0,"UniformAndStorageBuffer8BitAccess",null,null,null,false],[0,0,0,"StoragePushConstant8",null,null,null,false],[0,0,0,"DenormPreserve",null,null,null,false],[0,0,0,"DenormFlushToZero",null,null,null,false],[0,0,0,"SignedZeroInfNanPreserve",null,null,null,false],[0,0,0,"RoundingModeRTE",null,null,null,false],[0,0,0,"RoundingModeRTZ",null,null,null,false],[0,0,0,"RayQueryProvisionalKHR",null,null,null,false],[0,0,0,"RayQueryKHR",null,null,null,false],[0,0,0,"RayTraversalPrimitiveCullingKHR",null,null,null,false],[0,0,0,"RayTracingKHR",null,null,null,false],[0,0,0,"Float16ImageAMD",null,null,null,false],[0,0,0,"ImageGatherBiasLodAMD",null,null,null,false],[0,0,0,"FragmentMaskAMD",null,null,null,false],[0,0,0,"StencilExportEXT",null,null,null,false],[0,0,0,"ImageReadWriteLodAMD",null,null,null,false],[0,0,0,"Int64ImageEXT",null,null,null,false],[0,0,0,"ShaderClockKHR",null,null,null,false],[0,0,0,"SampleMaskOverrideCoverageNV",null,null,null,false],[0,0,0,"GeometryShaderPassthroughNV",null,null,null,false],[0,0,0,"ShaderViewportIndexLayerEXT",null,null,null,false],[0,0,0,"ShaderViewportIndexLayerNV",null,null,null,false],[0,0,0,"ShaderViewportMaskNV",null,null,null,false],[0,0,0,"ShaderStereoViewNV",null,null,null,false],[0,0,0,"PerViewAttributesNV",null,null,null,false],[0,0,0,"FragmentFullyCoveredEXT",null,null,null,false],[0,0,0,"MeshShadingNV",null,null,null,false],[0,0,0,"ImageFootprintNV",null,null,null,false],[0,0,0,"FragmentBarycentricNV",null,null,null,false],[0,0,0,"ComputeDerivativeGroupQuadsNV",null,null,null,false],[0,0,0,"FragmentDensityEXT",null,null,null,false],[0,0,0,"ShadingRateNV",null,null,null,false],[0,0,0,"GroupNonUniformPartitionedNV",null,null,null,false],[0,0,0,"ShaderNonUniform",null,null,null,false],[0,0,0,"ShaderNonUniformEXT",null,null,null,false],[0,0,0,"RuntimeDescriptorArray",null,null,null,false],[0,0,0,"RuntimeDescriptorArrayEXT",null,null,null,false],[0,0,0,"InputAttachmentArrayDynamicIndexing",null,null,null,false],[0,0,0,"InputAttachmentArrayDynamicIndexingEXT",null,null,null,false],[0,0,0,"UniformTexelBufferArrayDynamicIndexing",null,null,null,false],[0,0,0,"UniformTexelBufferArrayDynamicIndexingEXT",null,null,null,false],[0,0,0,"StorageTexelBufferArrayDynamicIndexing",null,null,null,false],[0,0,0,"StorageTexelBufferArrayDynamicIndexingEXT",null,null,null,false],[0,0,0,"UniformBufferArrayNonUniformIndexing",null,null,null,false],[0,0,0,"UniformBufferArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"SampledImageArrayNonUniformIndexing",null,null,null,false],[0,0,0,"SampledImageArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"StorageBufferArrayNonUniformIndexing",null,null,null,false],[0,0,0,"StorageBufferArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"StorageImageArrayNonUniformIndexing",null,null,null,false],[0,0,0,"StorageImageArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"InputAttachmentArrayNonUniformIndexing",null,null,null,false],[0,0,0,"InputAttachmentArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"UniformTexelBufferArrayNonUniformIndexing",null,null,null,false],[0,0,0,"UniformTexelBufferArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"StorageTexelBufferArrayNonUniformIndexing",null,null,null,false],[0,0,0,"StorageTexelBufferArrayNonUniformIndexingEXT",null,null,null,false],[0,0,0,"RayTracingNV",null,null,null,false],[0,0,0,"VulkanMemoryModel",null,null,null,false],[0,0,0,"VulkanMemoryModelKHR",null,null,null,false],[0,0,0,"VulkanMemoryModelDeviceScope",null,null,null,false],[0,0,0,"VulkanMemoryModelDeviceScopeKHR",null,null,null,false],[0,0,0,"PhysicalStorageBufferAddresses",null,null,null,false],[0,0,0,"PhysicalStorageBufferAddressesEXT",null,null,null,false],[0,0,0,"ComputeDerivativeGroupLinearNV",null,null,null,false],[0,0,0,"RayTracingProvisionalKHR",null,null,null,false],[0,0,0,"CooperativeMatrixNV",null,null,null,false],[0,0,0,"FragmentShaderSampleInterlockEXT",null,null,null,false],[0,0,0,"FragmentShaderShadingRateInterlockEXT",null,null,null,false],[0,0,0,"ShaderSMBuiltinsNV",null,null,null,false],[0,0,0,"FragmentShaderPixelInterlockEXT",null,null,null,false],[0,0,0,"DemoteToHelperInvocationEXT",null,null,null,false],[0,0,0,"SubgroupShuffleINTEL",null,null,null,false],[0,0,0,"SubgroupBufferBlockIOINTEL",null,null,null,false],[0,0,0,"SubgroupImageBlockIOINTEL",null,null,null,false],[0,0,0,"SubgroupImageMediaBlockIOINTEL",null,null,null,false],[0,0,0,"RoundToInfinityINTEL",null,null,null,false],[0,0,0,"FloatingPointModeINTEL",null,null,null,false],[0,0,0,"IntegerFunctions2INTEL",null,null,null,false],[0,0,0,"FunctionPointersINTEL",null,null,null,false],[0,0,0,"IndirectReferencesINTEL",null,null,null,false],[0,0,0,"AsmINTEL",null,null,null,false],[0,0,0,"AtomicFloat32MinMaxEXT",null,null,null,false],[0,0,0,"AtomicFloat64MinMaxEXT",null,null,null,false],[0,0,0,"AtomicFloat16MinMaxEXT",null,null,null,false],[0,0,0,"VectorComputeINTEL",null,null,null,false],[0,0,0,"VectorAnyINTEL",null,null,null,false],[0,0,0,"ExpectAssumeKHR",null,null,null,false],[0,0,0,"SubgroupAvcMotionEstimationINTEL",null,null,null,false],[0,0,0,"SubgroupAvcMotionEstimationIntraINTEL",null,null,null,false],[0,0,0,"SubgroupAvcMotionEstimationChromaINTEL",null,null,null,false],[0,0,0,"VariableLengthArrayINTEL",null,null,null,false],[0,0,0,"FunctionFloatControlINTEL",null,null,null,false],[0,0,0,"FPGAMemoryAttributesINTEL",null,null,null,false],[0,0,0,"FPFastMathModeINTEL",null,null,null,false],[0,0,0,"ArbitraryPrecisionIntegersINTEL",null,null,null,false],[0,0,0,"UnstructuredLoopControlsINTEL",null,null,null,false],[0,0,0,"FPGALoopControlsINTEL",null,null,null,false],[0,0,0,"KernelAttributesINTEL",null,null,null,false],[0,0,0,"FPGAKernelAttributesINTEL",null,null,null,false],[0,0,0,"FPGAMemoryAccessesINTEL",null,null,null,false],[0,0,0,"FPGAClusterAttributesINTEL",null,null,null,false],[0,0,0,"LoopFuseINTEL",null,null,null,false],[0,0,0,"FPGABufferLocationINTEL",null,null,null,false],[0,0,0,"USMStorageClassesINTEL",null,null,null,false],[0,0,0,"IOPipesINTEL",null,null,null,false],[0,0,0,"BlockingPipesINTEL",null,null,null,false],[0,0,0,"FPGARegINTEL",null,null,null,false],[0,0,0,"AtomicFloat32AddEXT",null,null,null,false],[0,0,0,"AtomicFloat64AddEXT",null,null,null,false],[0,0,0,"LongConstantCompositeINTEL",null,null,null,false],[57,296,0,null,null,null,null,false],[57,297,0,null,null,null,null,false],[57,298,0,null,null,null,null,false],[57,299,0,null,null,null,null,false],[57,301,0,null,null,null,null,false],[57,2084,0,null,null,null,[],false],[57,2085,0,null,null,null,null,false],[40,467,0,null,null,null,null,false],[0,0,0,"target/s390x.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[58,2,0,null,null,null,null,false],[58,3,0,null,null,null,null,false],[58,4,0,null,null,null,null,false],[58,6,0,null,null,null,[8082,8083,8084,8085,8086,8087,8088,8089,8090,8091,8092,8093,8094,8095,8096,8097,8098,8099,8100,8101,8102,8103,8104,8105,8106,8107,8108,8109,8110,8111,8112,8113,8114,8115,8116,8117,8118,8119,8120,8121,8122],false],[0,0,0,"bear_enhancement",null,null,null,false],[0,0,0,"deflate_conversion",null,null,null,false],[0,0,0,"dfp_packed_conversion",null,null,null,false],[0,0,0,"dfp_zoned_conversion",null,null,null,false],[0,0,0,"distinct_ops",null,null,null,false],[0,0,0,"enhanced_dat_2",null,null,null,false],[0,0,0,"enhanced_sort",null,null,null,false],[0,0,0,"execution_hint",null,null,null,false],[0,0,0,"fast_serialization",null,null,null,false],[0,0,0,"fp_extension",null,null,null,false],[0,0,0,"guarded_storage",null,null,null,false],[0,0,0,"high_word",null,null,null,false],[0,0,0,"insert_reference_bits_multiple",null,null,null,false],[0,0,0,"interlocked_access1",null,null,null,false],[0,0,0,"load_and_trap",null,null,null,false],[0,0,0,"load_and_zero_rightmost_byte",null,null,null,false],[0,0,0,"load_store_on_cond",null,null,null,false],[0,0,0,"load_store_on_cond_2",null,null,null,false],[0,0,0,"message_security_assist_extension3",null,null,null,false],[0,0,0,"message_security_assist_extension4",null,null,null,false],[0,0,0,"message_security_assist_extension5",null,null,null,false],[0,0,0,"message_security_assist_extension7",null,null,null,false],[0,0,0,"message_security_assist_extension8",null,null,null,false],[0,0,0,"message_security_assist_extension9",null,null,null,false],[0,0,0,"miscellaneous_extensions",null,null,null,false],[0,0,0,"miscellaneous_extensions_2",null,null,null,false],[0,0,0,"miscellaneous_extensions_3",null,null,null,false],[0,0,0,"nnp_assist",null,null,null,false],[0,0,0,"population_count",null,null,null,false],[0,0,0,"processor_activity_instrumentation",null,null,null,false],[0,0,0,"processor_assist",null,null,null,false],[0,0,0,"reset_dat_protection",null,null,null,false],[0,0,0,"reset_reference_bits_multiple",null,null,null,false],[0,0,0,"soft_float",null,null,null,false],[0,0,0,"transactional_execution",null,null,null,false],[0,0,0,"vector",null,null,null,false],[0,0,0,"vector_enhancements_1",null,null,null,false],[0,0,0,"vector_enhancements_2",null,null,null,false],[0,0,0,"vector_packed_decimal",null,null,null,false],[0,0,0,"vector_packed_decimal_enhancement",null,null,null,false],[0,0,0,"vector_packed_decimal_enhancement_2",null,null,null,false],[58,50,0,null,null,null,null,false],[58,51,0,null,null,null,null,false],[58,52,0,null,null,null,null,false],[58,53,0,null,null,null,null,false],[58,55,0,null,null,null,null,false],[58,272,0,null,null,null,[],false],[58,273,0,null,null,null,null,false],[58,296,0,null,null,null,null,false],[58,324,0,null,null,null,null,false],[58,359,0,null,null,null,null,false],[58,400,0,null,null,null,null,false],[58,446,0,null,null,null,null,false],[58,451,0,null,null,null,null,false],[58,467,0,null,null,null,null,false],[58,472,0,null,null,null,null,false],[58,477,0,null,null,null,null,false],[58,505,0,null,null,null,null,false],[58,540,0,null,null,null,null,false],[58,581,0,null,null,null,null,false],[58,627,0,null,null,null,null,false],[58,643,0,null,null,null,null,false],[40,468,0,null,null,null,null,false],[0,0,0,"target/ve.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[59,2,0,null,null,null,null,false],[59,3,0,null,null,null,null,false],[59,4,0,null,null,null,null,false],[59,6,0,null,null,null,[8150],false],[0,0,0,"vpu",null,null,null,false],[59,10,0,null,null,null,null,false],[59,11,0,null,null,null,null,false],[59,12,0,null,null,null,null,false],[59,13,0,null,null,null,null,false],[59,15,0,null,null,null,null,false],[59,32,0,null,null,null,[],false],[59,33,0,null,null,null,null,false],[40,469,0,null,null,null,null,false],[0,0,0,"target/wasm.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[60,2,0,null,null,null,null,false],[60,3,0,null,null,null,null,false],[60,4,0,null,null,null,null,false],[60,6,0,null,null,null,[8164,8165,8166,8167,8168,8169,8170,8171,8172,8173,8174,8175],false],[0,0,0,"atomics",null,null,null,false],[0,0,0,"bulk_memory",null,null,null,false],[0,0,0,"exception_handling",null,null,null,false],[0,0,0,"extended_const",null,null,null,false],[0,0,0,"multivalue",null,null,null,false],[0,0,0,"mutable_globals",null,null,null,false],[0,0,0,"nontrapping_fptoint",null,null,null,false],[0,0,0,"reference_types",null,null,null,false],[0,0,0,"relaxed_simd",null,null,null,false],[0,0,0,"sign_ext",null,null,null,false],[0,0,0,"simd128",null,null,null,false],[0,0,0,"tail_call",null,null,null,false],[60,21,0,null,null,null,null,false],[60,22,0,null,null,null,null,false],[60,23,0,null,null,null,null,false],[60,24,0,null,null,null,null,false],[60,26,0,null,null,null,null,false],[60,98,0,null,null,null,[],false],[60,99,0,null,null,null,null,false],[60,112,0,null,null,null,null,false],[60,120,0,null,null,null,null,false],[40,470,0,null,null,null,null,false],[0,0,0,"target/x86.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[61,2,0,null,null,null,null,false],[61,3,0,null,null,null,null,false],[61,4,0,null,null,null,null,false],[61,6,0,null,null,null,[8191,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8208,8209,8210,8211,8212,8213,8214,8215,8216,8217,8218,8219,8220,8221,8222,8223,8224,8225,8226,8227,8228,8229,8230,8231,8232,8233,8234,8235,8236,8237,8238,8239,8240,8241,8242,8243,8244,8245,8246,8247,8248,8249,8250,8251,8252,8253,8254,8255,8256,8257,8258,8259,8260,8261,8262,8263,8264,8265,8266,8267,8268,8269,8270,8271,8272,8273,8274,8275,8276,8277,8278,8279,8280,8281,8282,8283,8284,8285,8286,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,8304,8305,8306,8307,8308,8309,8310,8311,8312,8313,8314,8315,8316,8317,8318,8319,8320,8321,8322,8323,8324,8325,8326,8327,8328,8329,8330,8331,8332,8333,8334,8335,8336,8337,8338,8339,8340,8341,8342,8343,8344,8345,8346,8347,8348,8349,8350,8351,8352],false],[0,0,0,"16bit_mode",null,null,null,false],[0,0,0,"32bit_mode",null,null,null,false],[0,0,0,"3dnow",null,null,null,false],[0,0,0,"3dnowa",null,null,null,false],[0,0,0,"64bit",null,null,null,false],[0,0,0,"adx",null,null,null,false],[0,0,0,"aes",null,null,null,false],[0,0,0,"allow_light_256_bit",null,null,null,false],[0,0,0,"amx_bf16",null,null,null,false],[0,0,0,"amx_fp16",null,null,null,false],[0,0,0,"amx_int8",null,null,null,false],[0,0,0,"amx_tile",null,null,null,false],[0,0,0,"avx",null,null,null,false],[0,0,0,"avx2",null,null,null,false],[0,0,0,"avx512bf16",null,null,null,false],[0,0,0,"avx512bitalg",null,null,null,false],[0,0,0,"avx512bw",null,null,null,false],[0,0,0,"avx512cd",null,null,null,false],[0,0,0,"avx512dq",null,null,null,false],[0,0,0,"avx512er",null,null,null,false],[0,0,0,"avx512f",null,null,null,false],[0,0,0,"avx512fp16",null,null,null,false],[0,0,0,"avx512ifma",null,null,null,false],[0,0,0,"avx512pf",null,null,null,false],[0,0,0,"avx512vbmi",null,null,null,false],[0,0,0,"avx512vbmi2",null,null,null,false],[0,0,0,"avx512vl",null,null,null,false],[0,0,0,"avx512vnni",null,null,null,false],[0,0,0,"avx512vp2intersect",null,null,null,false],[0,0,0,"avx512vpopcntdq",null,null,null,false],[0,0,0,"avxifma",null,null,null,false],[0,0,0,"avxneconvert",null,null,null,false],[0,0,0,"avxvnni",null,null,null,false],[0,0,0,"avxvnniint8",null,null,null,false],[0,0,0,"bmi",null,null,null,false],[0,0,0,"bmi2",null,null,null,false],[0,0,0,"branchfusion",null,null,null,false],[0,0,0,"cldemote",null,null,null,false],[0,0,0,"clflushopt",null,null,null,false],[0,0,0,"clwb",null,null,null,false],[0,0,0,"clzero",null,null,null,false],[0,0,0,"cmov",null,null,null,false],[0,0,0,"cmpccxadd",null,null,null,false],[0,0,0,"crc32",null,null,null,false],[0,0,0,"cx16",null,null,null,false],[0,0,0,"cx8",null,null,null,false],[0,0,0,"enqcmd",null,null,null,false],[0,0,0,"ermsb",null,null,null,false],[0,0,0,"f16c",null,null,null,false],[0,0,0,"false_deps_getmant",null,null,null,false],[0,0,0,"false_deps_lzcnt_tzcnt",null,null,null,false],[0,0,0,"false_deps_mulc",null,null,null,false],[0,0,0,"false_deps_mullq",null,null,null,false],[0,0,0,"false_deps_perm",null,null,null,false],[0,0,0,"false_deps_popcnt",null,null,null,false],[0,0,0,"false_deps_range",null,null,null,false],[0,0,0,"fast_11bytenop",null,null,null,false],[0,0,0,"fast_15bytenop",null,null,null,false],[0,0,0,"fast_7bytenop",null,null,null,false],[0,0,0,"fast_bextr",null,null,null,false],[0,0,0,"fast_gather",null,null,null,false],[0,0,0,"fast_hops",null,null,null,false],[0,0,0,"fast_lzcnt",null,null,null,false],[0,0,0,"fast_movbe",null,null,null,false],[0,0,0,"fast_scalar_fsqrt",null,null,null,false],[0,0,0,"fast_scalar_shift_masks",null,null,null,false],[0,0,0,"fast_shld_rotate",null,null,null,false],[0,0,0,"fast_variable_crosslane_shuffle",null,null,null,false],[0,0,0,"fast_variable_perlane_shuffle",null,null,null,false],[0,0,0,"fast_vector_fsqrt",null,null,null,false],[0,0,0,"fast_vector_shift_masks",null,null,null,false],[0,0,0,"fma",null,null,null,false],[0,0,0,"fma4",null,null,null,false],[0,0,0,"fsgsbase",null,null,null,false],[0,0,0,"fsrm",null,null,null,false],[0,0,0,"fxsr",null,null,null,false],[0,0,0,"gfni",null,null,null,false],[0,0,0,"harden_sls_ijmp",null,null,null,false],[0,0,0,"harden_sls_ret",null,null,null,false],[0,0,0,"hreset",null,null,null,false],[0,0,0,"idivl_to_divb",null,null,null,false],[0,0,0,"idivq_to_divl",null,null,null,false],[0,0,0,"invpcid",null,null,null,false],[0,0,0,"kl",null,null,null,false],[0,0,0,"lea_sp",null,null,null,false],[0,0,0,"lea_uses_ag",null,null,null,false],[0,0,0,"lvi_cfi",null,null,null,false],[0,0,0,"lvi_load_hardening",null,null,null,false],[0,0,0,"lwp",null,null,null,false],[0,0,0,"lzcnt",null,null,null,false],[0,0,0,"macrofusion",null,null,null,false],[0,0,0,"mmx",null,null,null,false],[0,0,0,"movbe",null,null,null,false],[0,0,0,"movdir64b",null,null,null,false],[0,0,0,"movdiri",null,null,null,false],[0,0,0,"mwaitx",null,null,null,false],[0,0,0,"nopl",null,null,null,false],[0,0,0,"pad_short_functions",null,null,null,false],[0,0,0,"pclmul",null,null,null,false],[0,0,0,"pconfig",null,null,null,false],[0,0,0,"pku",null,null,null,false],[0,0,0,"popcnt",null,null,null,false],[0,0,0,"prefer_128_bit",null,null,null,false],[0,0,0,"prefer_256_bit",null,null,null,false],[0,0,0,"prefer_mask_registers",null,null,null,false],[0,0,0,"prefetchi",null,null,null,false],[0,0,0,"prefetchwt1",null,null,null,false],[0,0,0,"prfchw",null,null,null,false],[0,0,0,"ptwrite",null,null,null,false],[0,0,0,"raoint",null,null,null,false],[0,0,0,"rdpid",null,null,null,false],[0,0,0,"rdpru",null,null,null,false],[0,0,0,"rdrnd",null,null,null,false],[0,0,0,"rdseed",null,null,null,false],[0,0,0,"retpoline",null,null,null,false],[0,0,0,"retpoline_external_thunk",null,null,null,false],[0,0,0,"retpoline_indirect_branches",null,null,null,false],[0,0,0,"retpoline_indirect_calls",null,null,null,false],[0,0,0,"rtm",null,null,null,false],[0,0,0,"sahf",null,null,null,false],[0,0,0,"sbb_dep_breaking",null,null,null,false],[0,0,0,"serialize",null,null,null,false],[0,0,0,"seses",null,null,null,false],[0,0,0,"sgx",null,null,null,false],[0,0,0,"sha",null,null,null,false],[0,0,0,"shstk",null,null,null,false],[0,0,0,"slow_3ops_lea",null,null,null,false],[0,0,0,"slow_incdec",null,null,null,false],[0,0,0,"slow_lea",null,null,null,false],[0,0,0,"slow_pmaddwd",null,null,null,false],[0,0,0,"slow_pmulld",null,null,null,false],[0,0,0,"slow_shld",null,null,null,false],[0,0,0,"slow_two_mem_ops",null,null,null,false],[0,0,0,"slow_unaligned_mem_16",null,null,null,false],[0,0,0,"slow_unaligned_mem_32",null,null,null,false],[0,0,0,"soft_float",null,null,null,false],[0,0,0,"sse",null,null,null,false],[0,0,0,"sse2",null,null,null,false],[0,0,0,"sse3",null,null,null,false],[0,0,0,"sse4_1",null,null,null,false],[0,0,0,"sse4_2",null,null,null,false],[0,0,0,"sse4a",null,null,null,false],[0,0,0,"sse_unaligned_mem",null,null,null,false],[0,0,0,"ssse3",null,null,null,false],[0,0,0,"tagged_globals",null,null,null,false],[0,0,0,"tbm",null,null,null,false],[0,0,0,"tsxldtrk",null,null,null,false],[0,0,0,"uintr",null,null,null,false],[0,0,0,"use_glm_div_sqrt_costs",null,null,null,false],[0,0,0,"use_slm_arith_costs",null,null,null,false],[0,0,0,"vaes",null,null,null,false],[0,0,0,"vpclmulqdq",null,null,null,false],[0,0,0,"vzeroupper",null,null,null,false],[0,0,0,"waitpkg",null,null,null,false],[0,0,0,"wbnoinvd",null,null,null,false],[0,0,0,"widekl",null,null,null,false],[0,0,0,"x87",null,null,null,false],[0,0,0,"xop",null,null,null,false],[0,0,0,"xsave",null,null,null,false],[0,0,0,"xsavec",null,null,null,false],[0,0,0,"xsaveopt",null,null,null,false],[0,0,0,"xsaves",null,null,null,false],[61,171,0,null,null,null,null,false],[61,172,0,null,null,null,null,false],[61,173,0,null,null,null,null,false],[61,174,0,null,null,null,null,false],[61,176,0,null,null,null,null,false],[61,1110,0,null,null,null,[],false],[61,1111,0,null,null,null,null,false],[61,1175,0,null,null,null,null,false],[61,1197,0,null,null,null,null,false],[61,1211,0,null,null,null,null,false],[61,1230,0,null,null,null,null,false],[61,1249,0,null,null,null,null,false],[61,1265,0,null,null,null,null,false],[61,1284,0,null,null,null,null,false],[61,1300,0,null,null,null,null,false],[61,1314,0,null,null,null,null,false],[61,1330,0,null,null,null,null,false],[61,1354,0,null,null,null,null,false],[61,1376,0,null,null,null,null,false],[61,1405,0,null,null,null,null,false],[61,1440,0,null,null,null,null,false],[61,1476,0,null,null,null,null,false],[61,1517,0,null,null,null,null,false],[61,1541,0,null,null,null,null,false],[61,1585,0,null,null,null,null,false],[61,1610,0,null,null,null,null,false],[61,1644,0,null,null,null,null,false],[61,1654,0,null,null,null,null,false],[61,1668,0,null,null,null,null,false],[61,1721,0,null,null,null,null,false],[61,1775,0,null,null,null,null,false],[61,1829,0,null,null,null,null,false],[61,1847,0,null,null,null,null,false],[61,1888,0,null,null,null,null,false],[61,1918,0,null,null,null,null,false],[61,1937,0,null,null,null,null,false],[61,1965,0,null,null,null,null,false],[61,2045,0,null,null,null,null,false],[61,2060,0,null,null,null,null,false],[61,2071,0,null,null,null,null,false],[61,2107,0,null,null,null,null,false],[61,2144,0,null,null,null,null,false],[61,2205,0,null,null,null,null,false],[61,2287,0,null,null,null,null,false],[61,2328,0,null,null,null,null,false],[61,2337,0,null,null,null,null,false],[61,2346,0,null,null,null,null,false],[61,2356,0,null,null,null,null,false],[61,2367,0,null,null,null,null,false],[61,2426,0,null,null,null,null,false],[61,2488,0,null,null,null,null,false],[61,2518,0,null,null,null,null,false],[61,2529,0,null,null,null,null,false],[61,2540,0,null,null,null,null,false],[61,2551,0,null,null,null,null,false],[61,2570,0,null,null,null,null,false],[61,2589,0,null,null,null,null,false],[61,2629,0,null,null,null,null,false],[61,2670,0,null,null,null,null,false],[61,2680,0,null,null,null,null,false],[61,2744,0,null,null,null,null,false],[61,2763,0,null,null,null,null,false],[61,2779,0,null,null,null,null,false],[61,2798,0,null,null,null,null,false],[61,2817,0,null,null,null,null,false],[61,2835,0,null,null,null,null,false],[61,2845,0,null,null,null,null,false],[61,2859,0,null,null,null,null,false],[61,2874,0,null,null,null,null,false],[61,2889,0,null,null,null,null,false],[61,2904,0,null,null,null,null,false],[61,2919,0,null,null,null,null,false],[61,2934,0,null,null,null,null,false],[61,2945,0,null,null,null,null,false],[61,2957,0,null,null,null,null,false],[61,2972,0,null,null,null,null,false],[61,3036,0,null,null,null,null,false],[61,3095,0,null,null,null,null,false],[61,3123,0,null,null,null,null,false],[61,3203,0,null,null,null,null,false],[61,3263,0,null,null,null,null,false],[61,3294,0,null,null,null,null,false],[61,3347,0,null,null,null,null,false],[61,3396,0,null,null,null,null,false],[61,3449,0,null,null,null,null,false],[61,3480,0,null,null,null,null,false],[61,3544,0,null,null,null,null,false],[61,3583,0,null,null,null,null,false],[61,3603,0,null,null,null,null,false],[61,3613,0,null,null,null,null,false],[61,3623,0,null,null,null,null,false],[61,3642,0,null,null,null,null,false],[61,3668,0,null,null,null,null,false],[61,3704,0,null,null,null,null,false],[61,3743,0,null,null,null,null,false],[61,3758,0,null,null,null,null,false],[61,3809,0,null,null,null,null,false],[61,3864,0,null,null,null,null,false],[61,3923,0,null,null,null,null,false],[40,471,0,null,null,null,null,false],[0,0,0,"target/xtensa.zig",null," This file is auto-generated by tools/update_cpu_features.zig.\n",[],false],[62,2,0,null,null,null,null,false],[62,3,0,null,null,null,null,false],[62,4,0,null,null,null,null,false],[62,6,0,null,null,null,[8458],false],[0,0,0,"density",null,null,null,false],[62,10,0,null,null,null,null,false],[62,11,0,null,null,null,null,false],[62,12,0,null,null,null,null,false],[62,13,0,null,null,null,null,false],[62,15,0,null,null,null,null,false],[62,32,0,null,null,null,[],false],[62,33,0,null,null,null,null,false],[40,473,0,null,null,null,[8476,8477,8478,8479,8480,8481,8482,8483,8484,8485,8486,8487,8488,8489,8490,8491,8492,8493,8494,8495,8496,8497,8498,8499,8500,8501,8502,8503,8504,8505,8506,8507,8508,8509,8510,8511,8512,8513,8514,8515],false],[40,515,0,null,null,null,[8468,8469],false],[0,0,0,"arch",null,"",null,false],[0,0,0,"target_os",null,"",null,false],[40,571,0,null,null,null,[8471],false],[0,0,0,"abi",null,"",null,false],[40,578,0,null,null,null,[8473],false],[0,0,0,"abi",null,"",null,false],[40,585,0,null,null,null,[8475],false],[0,0,0,"abi",null,"",null,false],[0,0,0,"none",null,null,null,false],[0,0,0,"gnu",null,null,null,false],[0,0,0,"gnuabin32",null,null,null,false],[0,0,0,"gnuabi64",null,null,null,false],[0,0,0,"gnueabi",null,null,null,false],[0,0,0,"gnueabihf",null,null,null,false],[0,0,0,"gnuf32",null,null,null,false],[0,0,0,"gnuf64",null,null,null,false],[0,0,0,"gnusf",null,null,null,false],[0,0,0,"gnux32",null,null,null,false],[0,0,0,"gnuilp32",null,null,null,false],[0,0,0,"code16",null,null,null,false],[0,0,0,"eabi",null,null,null,false],[0,0,0,"eabihf",null,null,null,false],[0,0,0,"android",null,null,null,false],[0,0,0,"musl",null,null,null,false],[0,0,0,"musleabi",null,null,null,false],[0,0,0,"musleabihf",null,null,null,false],[0,0,0,"muslx32",null,null,null,false],[0,0,0,"msvc",null,null,null,false],[0,0,0,"itanium",null,null,null,false],[0,0,0,"cygnus",null,null,null,false],[0,0,0,"coreclr",null,null,null,false],[0,0,0,"simulator",null,null,null,false],[0,0,0,"macabi",null,null,null,false],[0,0,0,"pixel",null,null,null,false],[0,0,0,"vertex",null,null,null,false],[0,0,0,"geometry",null,null,null,false],[0,0,0,"hull",null,null,null,false],[0,0,0,"domain",null,null,null,false],[0,0,0,"compute",null,null,null,false],[0,0,0,"library",null,null,null,false],[0,0,0,"raygeneration",null,null,null,false],[0,0,0,"intersection",null,null,null,false],[0,0,0,"anyhit",null,null,null,false],[0,0,0,"closesthit",null,null,null,false],[0,0,0,"miss",null,null,null,false],[0,0,0,"callable",null,null,null,false],[0,0,0,"mesh",null,null,null,false],[0,0,0,"amplification",null,null,null,false],[40,596,0,null,null,null,[8523,8524,8525,8526,8527,8528,8529,8530,8531,8532,8533],false],[40,620,0,null,null,null,[8518,8519],false],[0,0,0,"of",null,"",null,false],[0,0,0,"cpu_arch",null,"",null,false],[40,634,0,null,null,null,[8521,8522],false],[0,0,0,"os_tag",null,"",null,false],[0,0,0,"cpu_arch",null,"",null,false],[0,0,0,"coff",null," Common Object File Format (Windows)",null,false],[0,0,0,"dxcontainer",null," DirectX Container",null,false],[0,0,0,"elf",null," Executable and Linking Format",null,false],[0,0,0,"macho",null," macOS relocatables",null,false],[0,0,0,"spirv",null," Standard, Portable Intermediate Representation V",null,false],[0,0,0,"wasm",null," WebAssembly",null,false],[0,0,0,"c",null," C source code",null,false],[0,0,0,"hex",null," Intel IHEX",null,false],[0,0,0,"raw",null," Machine code with no metadata.",null,false],[0,0,0,"plan9",null," Plan 9 from Bell Labs",null,false],[0,0,0,"nvptx",null," Nvidia PTX format",null,false],[40,649,0,null,null,null,[8535,8536,8537,8538,8539,8540,8541,8542],false],[0,0,0,"Console",null,null,null,false],[0,0,0,"Windows",null,null,null,false],[0,0,0,"Posix",null,null,null,false],[0,0,0,"Native",null,null,null,false],[0,0,0,"EfiApplication",null,null,null,false],[0,0,0,"EfiBootServiceDriver",null,null,null,false],[0,0,0,"EfiRom",null,null,null,false],[0,0,0,"EfiRuntimeDriver",null,null,null,false],[40,660,0,null,null,null,[8732,8734,8736],false],[40,671,0,null,null,null,[8596,8598,8600,8602,8604],false],[40,691,0,null,null," A bit set of all the features.",[8581],false],[40,694,0,null,null,null,null,false],[40,695,0,null,null,null,null,false],[40,696,0,null,null,null,null,false],[40,697,0,null,null,null,null,false],[40,698,0,null,null,null,null,false],[40,700,0,null,null,null,null,false],[40,702,0,null,null,null,[8553],false],[0,0,0,"set",null,"",null,false],[40,708,0,null,null,null,[8555,8556],false],[0,0,0,"set",null,"",null,false],[0,0,0,"arch_feature_index",null,"",null,false],[40,715,0,null,null," Adds the specified feature but not its dependencies.",[8558,8559],false],[0,0,0,"set",null,"",null,false],[0,0,0,"arch_feature_index",null,"",null,false],[40,722,0,null,null," Adds the specified feature set but not its dependencies.",[8561,8562],false],[0,0,0,"set",null,"",null,false],[0,0,0,"other_set",null,"",null,false],[40,727,0,null,null," Removes the specified feature but not its dependents.",[8564,8565],false],[0,0,0,"set",null,"",null,false],[0,0,0,"arch_feature_index",null,"",null,false],[40,734,0,null,null," Removes the specified feature but not its dependents.",[8567,8568],false],[0,0,0,"set",null,"",null,false],[0,0,0,"other_set",null,"",null,false],[40,738,0,null,null,null,[8570,8571],false],[0,0,0,"set",null,"",null,false],[0,0,0,"all_features_list",null,"",null,false],[40,755,0,null,null,null,[8573],false],[0,0,0,"set",null,"",null,false],[40,759,0,null,null,null,[8575,8576],false],[0,0,0,"set",null,"",null,false],[0,0,0,"other_set",null,"",null,false],[40,763,0,null,null,null,[8578,8579],false],[0,0,0,"set",null,"",null,false],[0,0,0,"other_set",null,"",null,false],[40,691,0,null,null,null,null,false],[0,0,0,"ints",null,null,null,false],[40,771,0,null,null,null,[8583],false],[0,0,0,"F",null,"",[],true],[40,774,0,null,null," Populates only the feature bits specified.",[8585],false],[0,0,0,"features",null,"",null,false],[40,783,0,null,null," Returns true if the specified feature is enabled.",[8587,8588],false],[0,0,0,"set",null,"",null,false],[0,0,0,"feature",null,"",null,false],[40,788,0,null,null," Returns true if any specified feature is enabled.",[8590,8591],false],[0,0,0,"set",null,"",null,false],[0,0,0,"features",null,"",null,false],[40,797,0,null,null," Returns true if every specified feature is enabled.",[8593,8594],false],[0,0,0,"set",null,"",null,false],[0,0,0,"features",null,"",null,false],[40,671,0,null,null,null,null,false],[0,0,0,"index",null," The bit index into `Set`. Has a default value of `undefined` because the canonical\n structures are populated via comptime logic.",null,false],[40,671,0,null,null,null,null,false],[0,0,0,"name",null," Has a default value of `undefined` because the canonical\n structures are populated via comptime logic.",null,false],[40,671,0,null,null,null,null,false],[0,0,0,"llvm_name",null," If this corresponds to an LLVM-recognized feature, this will be populated;\n otherwise null.",null,false],[40,671,0,null,null,null,null,false],[0,0,0,"description",null," Human-friendly UTF-8 text.",null,false],[40,671,0,null,null,null,null,false],[0,0,0,"dependencies",null," Sparse `Set` of features this depends on.",null,false],[40,808,0,null,null,null,[8654,8655,8656,8657,8658,8659,8660,8661,8662,8663,8664,8665,8666,8667,8668,8669,8670,8671,8672,8673,8674,8675,8676,8677,8678,8679,8680,8681,8682,8683,8684,8685,8686,8687,8688,8689,8690,8691,8692,8693,8694,8695,8696,8697,8698,8699,8700,8701,8702,8703,8704,8705,8706,8707,8708,8709,8710,8711,8712,8713,8714],false],[40,873,0,null,null,null,[8607],false],[0,0,0,"arch",null,"",null,false],[40,880,0,null,null,null,[8609],false],[0,0,0,"arch",null,"",null,false],[40,887,0,null,null,null,[8611],false],[0,0,0,"arch",null,"",null,false],[40,894,0,null,null,null,[8613],false],[0,0,0,"arch",null,"",null,false],[40,901,0,null,null,null,[8615],false],[0,0,0,"arch",null,"",null,false],[40,905,0,null,null,null,[8617],false],[0,0,0,"arch",null,"",null,false],[40,912,0,null,null,null,[8619],false],[0,0,0,"arch",null,"",null,false],[40,919,0,null,null,null,[8621],false],[0,0,0,"arch",null,"",null,false],[40,926,0,null,null,null,[8623],false],[0,0,0,"arch",null,"",null,false],[40,933,0,null,null,null,[8625],false],[0,0,0,"arch",null,"",null,false],[40,940,0,null,null,null,[8627],false],[0,0,0,"arch",null,"",null,false],[40,947,0,null,null,null,[8629],false],[0,0,0,"arch",null,"",null,false],[40,954,0,null,null,null,[8631],false],[0,0,0,"arch",null,"",null,false],[40,961,0,null,null,null,[8633],false],[0,0,0,"arch",null,"",null,false],[40,968,0,null,null,null,[8635,8636],false],[0,0,0,"arch",null,"",null,false],[0,0,0,"cpu_name",null,"",null,false],[40,977,0,null,null,null,[8638],false],[0,0,0,"arch",null,"",null,false],[40,1042,0,null,null,null,[8640],false],[0,0,0,"arch",null,"",null,false],[40,1107,0,null,null,null,[8642],false],[0,0,0,"arch",null,"",null,false],[40,1178,0,null,null," Returns whether this architecture supports the address space",[8644,8645],false],[0,0,0,"arch",null,"",null,false],[0,0,0,"address_space",null,"",null,false],[40,1193,0,null,null," Returns a name that matches the lib/std/target/* source file name.",[8647],false],[0,0,0,"arch",null,"",null,false],[40,1214,0,null,null," All CPU features Zig is aware of, sorted lexicographically by name.",[8649],false],[0,0,0,"arch",null,"",null,false],[40,1244,0,null,null," All processors Zig is aware of, sorted lexicographically by name.",[8651],false],[0,0,0,"arch",null,"",null,false],[40,1273,0,null,null,null,[8653],false],[0,0,0,"cpus",null,"",null,true],[0,0,0,"arm",null,null,null,false],[0,0,0,"armeb",null,null,null,false],[0,0,0,"aarch64",null,null,null,false],[0,0,0,"aarch64_be",null,null,null,false],[0,0,0,"aarch64_32",null,null,null,false],[0,0,0,"arc",null,null,null,false],[0,0,0,"avr",null,null,null,false],[0,0,0,"bpfel",null,null,null,false],[0,0,0,"bpfeb",null,null,null,false],[0,0,0,"csky",null,null,null,false],[0,0,0,"dxil",null,null,null,false],[0,0,0,"hexagon",null,null,null,false],[0,0,0,"loongarch32",null,null,null,false],[0,0,0,"loongarch64",null,null,null,false],[0,0,0,"m68k",null,null,null,false],[0,0,0,"mips",null,null,null,false],[0,0,0,"mipsel",null,null,null,false],[0,0,0,"mips64",null,null,null,false],[0,0,0,"mips64el",null,null,null,false],[0,0,0,"msp430",null,null,null,false],[0,0,0,"powerpc",null,null,null,false],[0,0,0,"powerpcle",null,null,null,false],[0,0,0,"powerpc64",null,null,null,false],[0,0,0,"powerpc64le",null,null,null,false],[0,0,0,"r600",null,null,null,false],[0,0,0,"amdgcn",null,null,null,false],[0,0,0,"riscv32",null,null,null,false],[0,0,0,"riscv64",null,null,null,false],[0,0,0,"sparc",null,null,null,false],[0,0,0,"sparc64",null,null,null,false],[0,0,0,"sparcel",null,null,null,false],[0,0,0,"s390x",null,null,null,false],[0,0,0,"tce",null,null,null,false],[0,0,0,"tcele",null,null,null,false],[0,0,0,"thumb",null,null,null,false],[0,0,0,"thumbeb",null,null,null,false],[0,0,0,"x86",null,null,null,false],[0,0,0,"x86_64",null,null,null,false],[0,0,0,"xcore",null,null,null,false],[0,0,0,"xtensa",null,null,null,false],[0,0,0,"nvptx",null,null,null,false],[0,0,0,"nvptx64",null,null,null,false],[0,0,0,"le32",null,null,null,false],[0,0,0,"le64",null,null,null,false],[0,0,0,"amdil",null,null,null,false],[0,0,0,"amdil64",null,null,null,false],[0,0,0,"hsail",null,null,null,false],[0,0,0,"hsail64",null,null,null,false],[0,0,0,"spir",null,null,null,false],[0,0,0,"spir64",null,null,null,false],[0,0,0,"spirv32",null,null,null,false],[0,0,0,"spirv64",null,null,null,false],[0,0,0,"kalimba",null,null,null,false],[0,0,0,"shave",null,null,null,false],[0,0,0,"lanai",null,null,null,false],[0,0,0,"wasm32",null,null,null,false],[0,0,0,"wasm64",null,null,null,false],[0,0,0,"renderscript32",null,null,null,false],[0,0,0,"renderscript64",null,null,null,false],[0,0,0,"ve",null,null,null,false],[0,0,0,"spu_2",null,null,null,false],[40,1283,0,null,null,null,[8724,8726,8728],false],[40,1288,0,null,null,null,[8717,8718],false],[0,0,0,"model",null,"",null,false],[0,0,0,"arch",null,"",null,false],[40,1298,0,null,null,null,[8720],false],[0,0,0,"arch",null,"",null,false],[40,1339,0,null,null,null,[8722],false],[0,0,0,"arch",null,"",null,false],[40,1283,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[40,1283,0,null,null,null,null,false],[0,0,0,"llvm_name",null,null,null,false],[40,1283,0,null,null,null,null,false],[0,0,0,"features",null,null,null,false],[40,1355,0,null,null," The \"default\" set of CPU features for cross-compiling. A conservative set\n of features that is expected to be supported on most available hardware.",[8730],false],[0,0,0,"arch",null,"",null,false],[40,660,0,null,null,null,null,false],[0,0,0,"arch",null," Architecture",null,false],[40,660,0,null,null,null,null,false],[0,0,0,"model",null," The CPU model to target. It has a set of features\n which are overridden with the `features` field.",null,false],[40,660,0,null,null,null,null,false],[0,0,0,"features",null," An explicit list of the entire CPU feature set. It may differ from the specific CPU model's features.",null,false],[40,1360,0,null,null,null,[8738,8739],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[40,1364,0,null,null,null,[8741,8742,8743,8744],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"cpu_arch",null,"",null,false],[0,0,0,"os_tag",null,"",null,false],[0,0,0,"abi",null,"",null,false],[40,1368,0,null,null,null,[8746,8747],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[40,1372,0,null,null,null,[8749,8750],false],[0,0,0,"cpu_arch",null,"",null,false],[0,0,0,"os_tag",null,"",null,false],[40,1384,0,null,null,null,[8752],false],[0,0,0,"self",null,"",null,false],[40,1388,0,null,null,null,[8754,8755],false],[0,0,0,"os_tag",null,"",null,false],[0,0,0,"abi",null,"",null,false],[40,1398,0,null,null,null,[8757],false],[0,0,0,"self",null,"",null,false],[40,1402,0,null,null,null,[8759],false],[0,0,0,"self",null,"",null,false],[40,1406,0,null,null,null,[8761,8762],false],[0,0,0,"os_tag",null,"",null,false],[0,0,0,"abi",null,"",null,false],[40,1416,0,null,null,null,[8764],false],[0,0,0,"self",null,"",null,false],[40,1420,0,null,null,null,[8766],false],[0,0,0,"self",null,"",null,false],[40,1424,0,null,null,null,[8768],false],[0,0,0,"self",null,"",null,false],[40,1428,0,null,null,null,[8770],false],[0,0,0,"self",null,"",null,false],[40,1432,0,null,null,null,[8772],false],[0,0,0,"self",null,"",null,false],[40,1436,0,null,null,null,[8774],false],[0,0,0,"self",null,"",null,false],[40,1440,0,null,null,null,[8776],false],[0,0,0,"self",null,"",null,false],[40,1444,0,null,null,null,[8778],false],[0,0,0,"self",null,"",null,false],[40,1448,0,null,null,null,[8780],false],[0,0,0,"self",null,"",null,false],[40,1452,0,null,null,null,[8782,8783],false],[0,0,0,"os_tag",null,"",null,false],[0,0,0,"abi",null,"",null,false],[40,1456,0,null,null,null,[8785],false],[0,0,0,"self",null,"",null,false],[40,1460,0,null,null,null,[8787],false],[0,0,0,"self",null,"",null,false],[40,1464,0,null,null,null,[8789],false],[0,0,0,"self",null,"",null,false],[40,1468,0,null,null,null,[8791,8792,8793],false],[0,0,0,"hard",null,null,null,false],[0,0,0,"soft",null,null,null,false],[0,0,0,"soft_fp",null,null,null,false],[40,1474,0,null,null,null,[8795],false],[0,0,0,"self",null,"",null,false],[40,1478,0,null,null,null,[8797],false],[0,0,0,"self",null,"",null,false],[40,1501,0,null,null,null,[8807,8809],false],[40,1511,0,null,null," Asserts that the length is less than or equal to 255 bytes.",[8800],false],[0,0,0,"dl_or_null",null,"",null,false],[40,1518,0,null,null," The returned memory has the same lifetime as the `DynamicLinker`.",[8802],false],[0,0,0,"self",null,"",null,false],[40,1524,0,null,null," Asserts that the length is less than or equal to 255 bytes.",[8804,8805],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dl_or_null",null,"",null,false],[40,1501,0,null,null,null,null,false],[0,0,0,"buffer",null," Contains the memory used to store the dynamic linker path. This field should\n not be used directly. See `get` and `set`. This field exists so that this API requires no allocator.",null,false],[40,1501,0,null,null,null,null,false],[0,0,0,"max_byte",null," Used to construct the dynamic linker path. This field should not be used\n directly. See `get` and `set`.",null,false],[40,1534,0,null,null,null,[8811],false],[0,0,0,"self",null,"",null,false],[40,1730,0,null,null," 0c spim    little-endian MIPS 3000 family\n 1c 68000   Motorola MC68000\n 2c 68020   Motorola MC68020\n 5c arm     little-endian ARM\n 6c amd64   AMD64 and compatibles (e.g., Intel EM64T)\n 7c arm64   ARM64 (ARMv8)\n 8c 386     Intel x86, i486, Pentium, etc.\n kc sparc   Sun SPARC\n qc power   Power PC\n vc mips    big-endian MIPS 3000 family",[8813],false],[0,0,0,"cpu_arch",null,"",null,false],[40,1744,0,null,null,null,[8815],false],[0,0,0,"target",null,"",null,false],[40,1834,0,null,null,null,[8817],false],[0,0,0,"target",null,"",null,false],[40,1911,0,null,null,null,[8819],false],[0,0,0,"target",null,"",null,false],[40,1956,0,null,null," Default signedness of `char` for the native C compiler for this target\n Note that char signedness is implementation-defined and many compilers provide\n an option to override the default signedness e.g. GCC's -funsigned-char / -fsigned-char",[8821],false],[0,0,0,"target",null,"",null,false],[40,1980,0,null,null,null,[8823,8824,8825,8826,8827,8828,8829,8830,8831,8832,8833,8834],false],[0,0,0,"char",null,null,null,false],[0,0,0,"short",null,null,null,false],[0,0,0,"ushort",null,null,null,false],[0,0,0,"int",null,null,null,false],[0,0,0,"uint",null,null,null,false],[0,0,0,"long",null,null,null,false],[0,0,0,"ulong",null,null,null,false],[0,0,0,"longlong",null,null,null,false],[0,0,0,"ulonglong",null,null,null,false],[0,0,0,"float",null,null,null,false],[0,0,0,"double",null,null,null,false],[0,0,0,"longdouble",null,null,null,false],[40,1995,0,null,null,null,[8836,8837],false],[0,0,0,"t",null,"",null,false],[0,0,0,"c_type",null,"",null,false],[40,2021,0,null,null,null,[8839,8840],false],[0,0,0,"target",null,"",null,false],[0,0,0,"c_type",null,"",null,false],[40,2335,0,null,null,null,[8842,8843],false],[0,0,0,"target",null,"",null,false],[0,0,0,"c_type",null,"",null,false],[40,2442,0,null,null,null,[8845,8846],false],[0,0,0,"target",null,"",null,false],[0,0,0,"c_type",null,"",null,false],[40,5,0,null,null,null,null,false],[0,0,0,"cpu",null,null,null,false],[40,5,0,null,null,null,null,false],[0,0,0,"os",null,null,null,false],[40,5,0,null,null,null,null,false],[0,0,0,"abi",null,null,null,false],[40,5,0,null,null,null,null,false],[0,0,0,"ofmt",null,null,null,false],[1,50,0,null,null,null,null,false],[0,0,0,"Thread.zig",null," This struct represents a kernel thread, and acts as a namespace for concurrency\n primitives that operate on kernel threads. For concurrency primitives that support\n both evented I/O and async I/O, see the respective names in the top level std namespace.\n",[9595],false],[63,4,0,null,null,null,null,false],[63,5,0,null,null,null,null,false],[63,6,0,null,null,null,null,false],[63,7,0,null,null,null,null,false],[63,8,0,null,null,null,null,false],[63,9,0,null,null,null,null,false],[63,10,0,null,null,null,null,false],[63,12,0,null,null,null,null,false],[0,0,0,"Thread/Futex.zig",null," Futex is a mechanism used to block (`wait`) and unblock (`wake`) threads using a 32bit memory address as hints.\n Blocking a thread is acknowledged only if the 32bit memory address is equal to a given value.\n This check helps avoid block/unblock deadlocks which occur if a `wake()` happens before a `wait()`.\n Using Futex, other Thread synchronization primitives can be built which efficiently wait for cross-thread events or signals.\n",[],false],[64,5,0,null,null,null,null,false],[64,6,0,null,null,null,null,false],[64,7,0,null,null,null,null,false],[64,9,0,null,null,null,null,false],[64,10,0,null,null,null,null,false],[64,11,0,null,null,null,null,false],[64,12,0,null,null,null,null,false],[64,21,0,null,null," Checks if `ptr` still contains the value `expect` and, if so, blocks the caller until either:\n - The value at `ptr` is no longer equal to `expect`.\n - The caller is unblocked by a matching `wake()`.\n - The caller is unblocked spuriously (\"at random\").\n\n The checking of `ptr` and `expect`, along with blocking the caller, is done atomically\n and totally ordered (sequentially consistent) with respect to other wait()/wake() calls on the same `ptr`.",[8874,8875],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[64,37,0,null,null," Checks if `ptr` still contains the value `expect` and, if so, blocks the caller until either:\n - The value at `ptr` is no longer equal to `expect`.\n - The caller is unblocked by a matching `wake()`.\n - The caller is unblocked spuriously (\"at random\").\n - The caller blocks for longer than the given timeout. In which case, `error.Timeout` is returned.\n\n The checking of `ptr` and `expect`, along with blocking the caller, is done atomically\n and totally ordered (sequentially consistent) with respect to other wait()/wake() calls on the same `ptr`.",[8877,8878,8879],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout_ns",null,"",null,false],[64,50,0,null,null," Unblocks at most `max_waiters` callers blocked in a `wait()` call on `ptr`.",[8881,8882],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,61,0,null,null,null,null,false],[64,84,0,null,null," We can't do @compileError() in the `Impl` switch statement above as its eagerly evaluated.\n So instead, we @compileError() on the methods themselves for platforms which don't support futex.",[],false],[64,85,0,null,null,null,[8886,8887,8888],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,89,0,null,null,null,[8890,8891],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,93,0,null,null,null,[8893],false],[0,0,0,"unused",null,"",null,false],[64,99,0,null,null,null,[],false],[64,100,0,null,null,null,[8896,8897,8898],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,115,0,null,null,null,[8900,8901],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,124,0,null,null,null,[],false],[64,125,0,null,null,null,[8904,8905,8906],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,154,0,null,null,null,[8908,8909],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,165,0,null,null,null,[],false],[64,166,0,null,null,null,[8912,8913,8914],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,222,0,null,null,null,[8916,8917],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,245,0,null,null,null,[],false],[64,246,0,null,null,null,[8920,8921,8922],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,274,0,null,null,null,[8924,8925],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,291,0,null,null,null,[],false],[64,292,0,null,null,null,[8928,8929,8930],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,328,0,null,null,null,[8932,8933],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,347,0,null,null,null,[],false],[64,348,0,null,null,null,[8936,8937,8938],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,379,0,null,null,null,[8940,8941],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,394,0,null,null,null,[],false],[64,395,0,null,null,null,[8944,8945,8946],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,437,0,null,null,null,[8948,8949],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,450,0,null,null,null,[],false],[64,451,0,null,null,null,[8952,8953,8954],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,475,0,null,null,null,[8956,8957],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,496,0,null,null," Modified version of linux's futex and Go's sema to implement userspace wait queues with pthread:\n https://code.woboq.org/linux/linux/kernel/futex.c.html\n https://go.dev/src/runtime/sema.go",[],false],[64,497,0,null,null,null,[8970,8972,8977],false],[64,502,0,null,null,null,[8961],false],[0,0,0,"self",null,"",null,false],[64,509,0,null,null,null,[8963],false],[0,0,0,"self",null,"",null,false],[64,520,0,null,null,null,[8965,8966],false],[0,0,0,"self",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,575,0,null,null,null,[8968],false],[0,0,0,"self",null,"",null,false],[64,497,0,null,null,null,null,false],[0,0,0,"cond",null,null,null,false],[64,497,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[64,497,0,null,null,null,[8974,8975,8976],false],[0,0,0,"empty",null,null,null,false],[0,0,0,"waiting",null,null,null,false],[0,0,0,"notified",null,null,null,false],[0,0,0,"state",null,null,null,false],[64,593,0,null,null,null,null,false],[64,594,0,null,null,null,[8981,8983,8985,8987,8988,8990],false],[64,594,0,null,null,null,null,false],[0,0,0,"node",null,null,null,false],[64,594,0,null,null,null,null,false],[0,0,0,"prev",null,null,null,false],[64,594,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[64,594,0,null,null,null,null,false],[0,0,0,"tail",null,null,null,false],[0,0,0,"is_queued",null,null,null,false],[64,594,0,null,null,null,null,false],[0,0,0,"event",null,null,null,false],[64,604,0,null,null,null,[8998,8999],false],[64,608,0,null,null,null,[8993,8994],false],[0,0,0,"self",null,"",null,false],[0,0,0,"waiter",null,"",null,false],[64,614,0,null,null,null,[8996],false],[0,0,0,"self",null,"",null,false],[64,604,0,null,null,null,null,false],[0,0,0,"top",null,null,null,false],[0,0,0,"len",null,null,null,false],[64,622,0,null,null,null,[],false],[64,623,0,null,null,null,[9002,9003,9004],false],[0,0,0,"treap",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"waiter",null,"",null,false],[64,648,0,null,null,null,[9006,9007,9008],false],[0,0,0,"treap",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,677,0,null,null,null,[9010,9011,9012],false],[0,0,0,"treap",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"waiter",null,"",null,false],[64,733,0,null,null,null,[9018,9020,9022],false],[64,740,0,null,null,null,null,false],[64,743,0,null,null,null,[9016],false],[0,0,0,"address",null,"",null,false],[64,733,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[64,733,0,null,null,null,null,false],[0,0,0,"pending",null,null,null,false],[64,733,0,null,null,null,null,false],[0,0,0,"treap",null,null,null,false],[64,758,0,null,null,null,[],false],[64,759,0,null,null,null,[9025],false],[0,0,0,"ptr",null,"",null,false],[64,772,0,null,null,null,[9027,9028,9029],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[64,833,0,null,null,null,[9031,9032],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"max_waiters",null,"",null,false],[64,1015,0,null,null," Deadline is used to wait efficiently for a pointer's value to change using Futex and a fixed timeout.\n\n Futex's timedWait() api uses a relative duration which suffers from over-waiting\n when used in a loop which is often required due to the possibility of spurious wakeups.\n\n Deadline instead converts the relative timeout to an absolute one so that multiple calls\n to Futex timedWait() can block for and report more accurate error.Timeouts.",[9041,9043],false],[64,1021,0,null,null," Create the deadline to expire after the given amount of time in nanoseconds passes.\n Pass in `null` to have the deadline call `Futex.wait()` and never expire.",[9035],false],[0,0,0,"expires_in_ns",null,"",null,false],[64,1038,0,null,null," Wait until either:\n - the `ptr`'s value changes from `expect`.\n - `Futex.wake()` is called on the `ptr`.\n - A spurious wake occurs.\n - The deadline expires; In which case `error.Timeout` is returned.",[9037,9038,9039],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"expect",null,"",null,false],[64,1015,0,null,null,null,null,false],[0,0,0,"timeout",null,null,null,false],[64,1015,0,null,null,null,null,false],[0,0,0,"started",null,null,null,false],[63,13,0,null,null,null,null,false],[0,0,0,"Thread/ResetEvent.zig",null," ResetEvent is a thread-safe bool which can be set to true/false (\"set\"/\"unset\").\n It can also block threads until the \"bool\" is set with cancellation via timed waits.\n ResetEvent can be statically initialized and is at most `@sizeOf(u64)` large.\n",[9096],false],[65,4,0,null,null,null,null,false],[65,5,0,null,null,null,null,false],[65,6,0,null,null,null,null,false],[65,8,0,null,null,null,null,false],[65,9,0,null,null,null,null,false],[65,10,0,null,null,null,null,false],[65,11,0,null,null,null,null,false],[65,12,0,null,null,null,null,false],[65,19,0,null,null," Returns if the ResetEvent was set().\n Once reset() is called, this returns false until the next set().\n The memory accesses before the set() can be said to happen before isSet() returns true.",[9055],false],[0,0,0,"self",null,"",null,false],[65,26,0,null,null," Block's the callers thread until the ResetEvent is set().\n This is effectively a more efficient version of `while (!isSet()) {}`.\n The memory accesses before the set() can be said to happen before wait() returns.",[9057],false],[0,0,0,"self",null,"",null,false],[65,36,0,null,null," Block's the callers thread until the ResetEvent is set(), or until the corresponding timeout expires.\n If the timeout expires before the ResetEvent is set, `error.Timeout` is returned.\n This is effectively a more efficient version of `while (!isSet()) {}`.\n The memory accesses before the set() can be said to happen before timedWait() returns without error.",[9059,9060],false],[0,0,0,"self",null,"",null,false],[0,0,0,"timeout_ns",null,"",null,false],[65,43,0,null,null," Marks the ResetEvent as \"set\" and unblocks any threads in `wait()` or `timedWait()` to observe the new state.\n The ResetEvent says \"set\" until reset() is called, making future set() calls do nothing semantically.\n The memory accesses before set() can be said to happen before isSet() returns true or wait()/timedWait() return successfully.",[9062],false],[0,0,0,"self",null,"",null,false],[65,50,0,null,null," Unmarks the ResetEvent from its \"set\" state if set() was called previously.\n It is undefined behavior is reset() is called while threads are blocked in wait() or timedWait().\n Concurrent calls to set(), isSet() and reset() are allowed.",[9064],false],[0,0,0,"self",null,"",null,false],[65,54,0,null,null,null,null,false],[65,59,0,null,null,null,[9076],false],[65,62,0,null,null,null,[9068],false],[0,0,0,"self",null,"",null,false],[65,66,0,null,null,null,[9070,9071],false],[0,0,0,"self",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[65,81,0,null,null,null,[9073],false],[0,0,0,"self",null,"",null,false],[65,85,0,null,null,null,[9075],false],[0,0,0,"self",null,"",null,false],[0,0,0,"is_set",null,null,null,false],[65,90,0,null,null,null,[9094],false],[65,93,0,null,null,null,null,false],[65,94,0,null,null,null,null,false],[65,95,0,null,null,null,null,false],[65,97,0,null,null,null,[9082],false],[0,0,0,"self",null,"",null,false],[65,102,0,null,null,null,[9084,9085],false],[0,0,0,"self",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[65,109,0,null,null,null,[9087,9088],false],[0,0,0,"self",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[65,141,0,null,null,null,[9090],false],[0,0,0,"self",null,"",null,false],[65,155,0,null,null,null,[9092],false],[0,0,0,"self",null,"",null,false],[65,90,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[65,0,0,null,null,null,null,false],[0,0,0,"impl",null,null,null,false],[63,14,0,null,null,null,null,false],[0,0,0,"Thread/Mutex.zig",null," Mutex is a synchronization primitive which enforces atomic access to a shared region of code known as the \"critical section\".\n It does this by blocking ensuring only one thread is in the critical section at any given point in time by blocking the others.\n Mutex can be statically initialized and is at most `@sizeOf(u64)` large.\n Use `lock()` or `tryLock()` to enter the critical section and `unlock()` to leave it.\n\n Example:\n ```\n var m = Mutex{};\n\n {\n     m.lock();\n     defer m.unlock();\n     // ... critical section code\n }\n\n if (m.tryLock()) {\n     defer m.unlock();\n     // ... critical section code\n }\n ```\n",[9178],false],[66,21,0,null,null,null,null,false],[66,22,0,null,null,null,null,false],[66,23,0,null,null,null,null,false],[66,25,0,null,null,null,null,false],[66,26,0,null,null,null,null,false],[66,27,0,null,null,null,null,false],[66,28,0,null,null,null,null,false],[66,29,0,null,null,null,null,false],[66,30,0,null,null,null,null,false],[66,37,0,null,null," Tries to acquire the mutex without blocking the caller's thread.\n Returns `false` if the calling thread would have to block to acquire it.\n Otherwise, returns `true` and the caller should `unlock()` the Mutex to release it.",[9109],false],[0,0,0,"self",null,"",null,false],[66,44,0,null,null," Acquires the mutex, blocking the caller's thread until it can.\n It is undefined behavior if the mutex is already held by the caller's thread.\n Once acquired, call `unlock()` on the Mutex to release it.",[9111],false],[0,0,0,"self",null,"",null,false],[66,50,0,null,null," Releases the mutex which was previously acquired with `lock()` or `tryLock()`.\n It is undefined behavior if the mutex is unlocked from a different thread that it was locked from.",[9113],false],[0,0,0,"self",null,"",null,false],[66,54,0,null,null,null,null,false],[66,59,0,null,null,null,null,false],[66,68,0,null,null,null,[9124,9126],false],[66,72,0,null,null,null,[9118],false],[0,0,0,"self",null,"",null,false],[66,80,0,null,null,null,[9120],false],[0,0,0,"self",null,"",null,false],[66,89,0,null,null,null,[9122],false],[0,0,0,"self",null,"",null,false],[66,68,0,null,null,null,null,false],[0,0,0,"locking_thread",null,null,null,false],[66,68,0,null,null,null,null,false],[0,0,0,"impl",null,null,null,false],[66,96,0,null,null,null,[9134],false],[66,99,0,null,null,null,[9129],false],[0,0,0,"self",null,"",null,false],[66,105,0,null,null,null,[9131],false],[0,0,0,"self",null,"",null,false],[66,111,0,null,null,null,[9133],false],[0,0,0,"self",null,"",null,false],[0,0,0,"is_locked",null,null,null,false],[66,119,0,null,null,null,[9143],false],[66,122,0,null,null,null,[9137],false],[0,0,0,"self",null,"",null,false],[66,126,0,null,null,null,[9139],false],[0,0,0,"self",null,"",null,false],[66,130,0,null,null,null,[9141],false],[0,0,0,"self",null,"",null,false],[66,119,0,null,null,null,null,false],[0,0,0,"srwlock",null,null,null,false],[66,136,0,null,null,null,[9152],false],[66,139,0,null,null,null,[9146],false],[0,0,0,"self",null,"",null,false],[66,143,0,null,null,null,[9148],false],[0,0,0,"self",null,"",null,false],[66,147,0,null,null,null,[9150],false],[0,0,0,"self",null,"",null,false],[66,136,0,null,null,null,null,false],[0,0,0,"oul",null,null,null,false],[66,152,0,null,null,null,[9169],false],[66,155,0,null,null,null,null,false],[66,156,0,null,null,null,null,false],[66,157,0,null,null,null,null,false],[66,159,0,null,null,null,[9158],false],[0,0,0,"self",null,"",null,false],[66,164,0,null,null,null,[9160],false],[0,0,0,"self",null,"",null,false],[66,171,0,null,null,null,[9162,9163],false],[0,0,0,"self",null,"",null,false],[0,0,0,"cas_fn_name",null,"",null,true],[66,186,0,null,null,null,[9165],false],[0,0,0,"self",null,"",null,false],[66,209,0,null,null,null,[9167],false],[0,0,0,"self",null,"",null,false],[66,152,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[66,239,0,null,null,null,[9176],false],[66,243,0,null,null,null,[9172],false],[0,0,0,"self",null,"",null,false],[66,247,0,null,null,null,[9174],false],[0,0,0,"self",null,"",null,false],[66,239,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[66,0,0,null,null,null,null,false],[0,0,0,"impl",null,null,null,false],[63,15,0,null,null,null,null,false],[0,0,0,"Thread/Semaphore.zig",null," A semaphore is an unsigned integer that blocks the kernel thread if\n the number would become negative.\n This API supports static initialization and does not require deinitialization.\n",[9192,9194,9195],false],[67,9,0,null,null,null,null,false],[67,10,0,null,null,null,null,false],[67,11,0,null,null,null,null,false],[67,12,0,null,null,null,null,false],[67,13,0,null,null,null,null,false],[67,14,0,null,null,null,null,false],[67,16,0,null,null,null,[9188],false],[0,0,0,"sem",null,"",null,false],[67,28,0,null,null,null,[9190],false],[0,0,0,"sem",null,"",null,false],[67,0,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[67,0,0,null,null,null,null,false],[0,0,0,"cond",null,null,null,false],[0,0,0,"permits",null," It is OK to initialize this field to any value.",null,false],[63,16,0,null,null,null,null,false],[0,0,0,"Thread/Condition.zig",null," Condition variables are used with a Mutex to efficiently wait for an arbitrary condition to occur.\n It does this by atomically unlocking the mutex, blocking the thread until notified, and finally re-locking the mutex.\n Condition can be statically initialized and is at most `@sizeOf(u64)` large.\n\n Example:\n ```\n var m = Mutex{};\n var c = Condition{};\n var predicate = false;\n\n fn consumer() void {\n     m.lock();\n     defer m.unlock();\n\n     while (!predicate) {\n         c.wait(&m);\n     }\n }\n\n fn producer() void {\n     {\n         m.lock();\n         defer m.unlock();\n         predicate = true;\n     }\n     c.signal();\n }\n\n const thread = try std.Thread.spawn(.{}, producer, .{});\n consumer();\n thread.join();\n ```\n\n Note that condition variables can only reliably unblock threads that are sequenced before them using the same Mutex.\n This means that the following is allowed to deadlock:\n ```\n thread-1: mutex.lock()\n thread-1: condition.wait(&mutex)\n\n thread-2: // mutex.lock() (without this, the following signal may not see the waiting thread-1)\n thread-2: // mutex.unlock() (this is optional for correctness once locked above, as signal can be called while holding the mutex)\n thread-2: condition.signal()\n ```\n",[9257],false],[68,44,0,null,null,null,null,false],[68,45,0,null,null,null,null,false],[68,46,0,null,null,null,null,false],[68,47,0,null,null,null,null,false],[68,49,0,null,null,null,null,false],[68,50,0,null,null,null,null,false],[68,51,0,null,null,null,null,false],[68,52,0,null,null,null,null,false],[68,53,0,null,null,null,null,false],[68,71,0,null,null," Atomically releases the Mutex, blocks the caller thread, then re-acquires the Mutex on return.\n \"Atomically\" here refers to accesses done on the Condition after acquiring the Mutex.\n\n The Mutex must be locked by the caller's thread when this function is called.\n A Mutex can have multiple Conditions waiting with it concurrently, but not the opposite.\n It is undefined behavior for multiple threads to wait ith different mutexes using the same Condition concurrently.\n Once threads have finished waiting with one Mutex, the Condition can be used to wait with another Mutex.\n\n A blocking call to wait() is unblocked from one of the following conditions:\n - a spurious (\"at random\") wake up occurs\n - a future call to `signal()` or `broadcast()` which has acquired the Mutex and is sequenced after this `wait()`.\n\n Given wait() can be interrupted spuriously, the blocking condition should be checked continuously\n irrespective of any notifications from `signal()` or `broadcast()`.",[9208,9209],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[68,92,0,null,null," Atomically releases the Mutex, blocks the caller thread, then re-acquires the Mutex on return.\n \"Atomically\" here refers to accesses done on the Condition after acquiring the Mutex.\n\n The Mutex must be locked by the caller's thread when this function is called.\n A Mutex can have multiple Conditions waiting with it concurrently, but not the opposite.\n It is undefined behavior for multiple threads to wait ith different mutexes using the same Condition concurrently.\n Once threads have finished waiting with one Mutex, the Condition can be used to wait with another Mutex.\n\n A blocking call to `timedWait()` is unblocked from one of the following conditions:\n - a spurious (\"at random\") wake occurs\n - the caller was blocked for around `timeout_ns` nanoseconds, in which `error.Timeout` is returned.\n - a future call to `signal()` or `broadcast()` which has acquired the Mutex and is sequenced after this `timedWait()`.\n\n Given `timedWait()` can be interrupted spuriously, the blocking condition should be checked continuously\n irrespective of any notifications from `signal()` or `broadcast()`.",[9211,9212,9213],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[0,0,0,"timeout_ns",null,"",null,false],[68,99,0,null,null," Unblocks at least one thread blocked in a call to `wait()` or `timedWait()` with a given Mutex.\n The blocked thread must be sequenced before this call with respect to acquiring the same Mutex in order to be observable for unblocking.\n `signal()` can be called with or without the relevant Mutex being acquired and have no \"effect\" if there's no observable blocked threads.",[9215],false],[0,0,0,"self",null,"",null,false],[68,106,0,null,null," Unblocks all threads currently blocked in a call to `wait()` or `timedWait()` with a given Mutex.\n The blocked threads must be sequenced before this call with respect to acquiring the same Mutex in order to be observable for unblocking.\n `broadcast()` can be called with or without the relevant Mutex being acquired and have no \"effect\" if there's no observable blocked threads.",[9217],false],[0,0,0,"self",null,"",null,false],[68,110,0,null,null,null,null,false],[68,117,0,null,null,null,[9220,9221],false],[0,0,0,"one",null,null,null,false],[0,0,0,"all",null,null,null,false],[68,122,0,null,null,null,[],false],[68,123,0,null,null,null,[9224,9225,9226],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[68,137,0,null,null,null,[9228,9229],false],[0,0,0,"self",null,"",null,false],[0,0,0,"notify",null,"",null,true],[68,144,0,null,null,null,[9239],false],[68,147,0,null,null,null,[9232,9233,9234],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[68,186,0,null,null,null,[9236,9237],false],[0,0,0,"self",null,"",null,false],[0,0,0,"notify",null,"",null,true],[68,144,0,null,null,null,null,false],[0,0,0,"condition",null,null,null,false],[68,194,0,null,null,null,[9253,9255],false],[68,198,0,null,null,null,null,false],[68,199,0,null,null,null,null,false],[68,201,0,null,null,null,null,false],[68,202,0,null,null,null,null,false],[68,204,0,null,null,null,[9246,9247,9248],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[68,256,0,null,null,null,[9250,9251],false],[0,0,0,"self",null,"",null,false],[0,0,0,"notify",null,"",null,true],[68,194,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[68,194,0,null,null,null,null,false],[0,0,0,"epoch",null,null,null,false],[68,0,0,null,null,null,null,false],[0,0,0,"impl",null,null,null,false],[63,17,0,null,null,null,null,false],[0,0,0,"Thread/RwLock.zig",null," A lock that supports one writer or many readers.\n This API is for kernel threads, not evented I/O.\n This API requires being initialized at runtime, and initialization\n can fail. Once initialized, the core operations cannot fail.\n",[9337],false],[69,7,0,null,null,null,null,false],[69,8,0,null,null,null,null,false],[69,9,0,null,null,null,null,false],[69,10,0,null,null,null,null,false],[69,11,0,null,null,null,null,false],[69,13,0,null,null,null,null,false],[69,22,0,null,null," Attempts to obtain exclusive lock ownership.\n Returns `true` if the lock is obtained, `false` otherwise.",[9267],false],[0,0,0,"rwl",null,"",null,false],[69,27,0,null,null," Blocks until exclusive lock ownership is acquired.",[9269],false],[0,0,0,"rwl",null,"",null,false],[69,33,0,null,null," Releases a held exclusive lock.\n Asserts the lock is held exclusively.",[9271],false],[0,0,0,"rwl",null,"",null,false],[69,39,0,null,null," Attempts to obtain shared lock ownership.\n Returns `true` if the lock is obtained, `false` otherwise.",[9273],false],[0,0,0,"rwl",null,"",null,false],[69,44,0,null,null," Blocks until shared lock ownership is acquired.",[9275],false],[0,0,0,"rwl",null,"",null,false],[69,49,0,null,null," Releases a held shared lock.",[9277],false],[0,0,0,"rwl",null,"",null,false],[69,55,0,null,null," Single-threaded applications use this for deadlock checks in\n debug mode, and no-ops in release modes.",[9295,9296],false],[69,61,0,null,null," Attempts to obtain exclusive lock ownership.\n Returns `true` if the lock is obtained, `false` otherwise.",[9280],false],[0,0,0,"rwl",null,"",null,false],[69,73,0,null,null," Blocks until exclusive lock ownership is acquired.",[9282],false],[0,0,0,"rwl",null,"",null,false],[69,81,0,null,null," Releases a held exclusive lock.\n Asserts the lock is held exclusively.",[9284],false],[0,0,0,"rwl",null,"",null,false],[69,89,0,null,null," Attempts to obtain shared lock ownership.\n Returns `true` if the lock is obtained, `false` otherwise.",[9286],false],[0,0,0,"rwl",null,"",null,false],[69,106,0,null,null," Blocks until shared lock ownership is acquired.",[9288],false],[0,0,0,"rwl",null,"",null,false],[69,121,0,null,null," Releases a held shared lock.",[9290],false],[0,0,0,"rwl",null,"",null,false],[69,55,0,null,null,null,[9292,9293,9294],false],[0,0,0,"unlocked",null,null,null,false],[0,0,0,"locked_exclusive",null,null,null,false],[0,0,0,"locked_shared",null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"shared_count",null,null,null,false],[69,135,0,null,null,null,[9311],false],[69,138,0,null,null,null,[9299],false],[0,0,0,"rwl",null,"",null,false],[69,142,0,null,null,null,[9301],false],[0,0,0,"rwl",null,"",null,false],[69,147,0,null,null,null,[9303],false],[0,0,0,"rwl",null,"",null,false],[69,152,0,null,null,null,[9305],false],[0,0,0,"rwl",null,"",null,false],[69,156,0,null,null,null,[9307],false],[0,0,0,"rwl",null,"",null,false],[69,161,0,null,null,null,[9309],false],[0,0,0,"rwl",null,"",null,false],[69,135,0,null,null,null,null,false],[0,0,0,"rwlock",null,null,null,false],[69,167,0,null,null,null,[9331,9333,9335],false],[69,172,0,null,null,null,null,false],[69,173,0,null,null,null,null,false],[69,174,0,null,null,null,null,false],[69,175,0,null,null,null,null,false],[69,176,0,null,null,null,null,false],[69,177,0,null,null,null,null,false],[69,179,0,null,null,null,[9320],false],[0,0,0,"rwl",null,"",null,false],[69,193,0,null,null,null,[9322],false],[0,0,0,"rwl",null,"",null,false],[69,202,0,null,null,null,[9324],false],[0,0,0,"rwl",null,"",null,false],[69,207,0,null,null,null,[9326],false],[0,0,0,"rwl",null,"",null,false],[69,229,0,null,null,null,[9328],false],[0,0,0,"rwl",null,"",null,false],[69,247,0,null,null,null,[9330],false],[0,0,0,"rwl",null,"",null,false],[0,0,0,"state",null,null,null,false],[69,167,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[69,167,0,null,null,null,null,false],[0,0,0,"semaphore",null,null,null,false],[69,0,0,null,null,null,null,false],[0,0,0,"impl",null,null,null,false],[63,18,0,null,null,null,null,false],[0,0,0,"Thread/Pool.zig",null,"",[9394,9396,9398,9399,9401,9403],false],[70,0,0,null,null,null,null,false],[70,1,0,null,null,null,null,false],[70,2,0,null,null,null,null,false],[70,3,0,null,null,null,null,false],[0,0,0,"WaitGroup.zig",null,"",[9362,9364],false],[71,0,0,null,null,null,null,false],[71,1,0,null,null,null,null,false],[71,2,0,null,null,null,null,false],[71,3,0,null,null,null,null,false],[71,5,0,null,null,null,null,false],[71,6,0,null,null,null,null,false],[71,11,0,null,null,null,[9352],false],[0,0,0,"self",null,"",null,false],[71,16,0,null,null,null,[9354],false],[0,0,0,"self",null,"",null,false],[71,26,0,null,null,null,[9356],false],[0,0,0,"self",null,"",null,false],[71,35,0,null,null,null,[9358],false],[0,0,0,"self",null,"",null,false],[71,40,0,null,null,null,[9360],false],[0,0,0,"wg",null,"",null,false],[71,0,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[71,0,0,null,null,null,null,false],[0,0,0,"event",null,null,null,false],[70,12,0,null,null,null,null,false],[70,13,0,null,null,null,[9368],false],[70,13,0,null,null,null,null,false],[0,0,0,"runFn",null,null,null,false],[70,17,0,null,null,null,[9370],false],[0,0,0,"",null,"",null,false],[70,19,0,null,null,null,[9373,9375],false],[70,19,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[70,19,0,null,null,null,null,false],[0,0,0,"n_jobs",null,null,null,false],[70,24,0,null,null,null,[9377,9378],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"options",null,"",null,false],[70,50,0,null,null,null,[9380],false],[0,0,0,"pool",null,"",null,false],[70,55,0,null,null,null,[9382,9383],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"spawned",null,"",null,false],[70,78,0,null,null,null,[9385,9386,9387],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"func",null,"",null,true],[0,0,0,"args",null,"",null,false],[70,121,0,null,null,null,[9389],false],[0,0,0,"pool",null,"",null,false],[70,144,0,null,null,null,[9391,9392],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"wait_group",null,"",null,false],[70,0,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[70,0,0,null,null,null,null,false],[0,0,0,"cond",null,null,null,false],[70,0,0,null,null,null,null,false],[0,0,0,"run_queue",null,null,null,false],[0,0,0,"is_running",null,null,null,false],[70,0,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[70,0,0,null,null,null,null,false],[0,0,0,"threads",null,null,null,false],[63,19,0,null,null,null,null,false],[63,21,0,null,null,null,null,false],[63,23,0,null,null,null,null,false],[63,24,0,null,null,null,null,false],[63,37,0,null,null,null,null,false],[63,49,0,null,null,null,null,false],[63,55,0,null,null,null,[9411,9412],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,false],[63,159,0,null,null,null,null,false],[63,171,0,null,null,null,[9415,9416],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer_ptr",null,"",null,false],[63,263,0,null,null," Represents an ID per thread guaranteed to be unique only within a process.",null,false],[63,279,0,null,null," Returns the platform ID of the callers thread.\n Attempts to use thread locals and avoid syscalls when possible.",[],false],[63,283,0,null,null,null,null,false],[63,290,0,null,null," Returns the platforms view on the number of logical CPU cores available.",[],false],[63,295,0,null,null," Configuration options for hints on how to spawn threads.",[9422,9424],false],[0,0,0,"stack_size",null," Size in bytes of the Thread's stack",null,false],[63,295,0,null,null,null,null,false],[0,0,0,"allocator",null," The allocator to be used to allocate memory for the to-be-spawned thread",null,false],[63,305,0,null,null,null,null,false],[63,339,0,null,null," Spawns a new thread which executes `function` using `args` and returns a handle to the spawned thread.\n `config` can be used as hints to the platform for now to spawn and execute the `function`.\n The caller must eventually either call `join()` to wait for the thread to finish and free its resources\n or call `detach()` to excuse the caller from calling `join()` and have the thread clean up its resources on completion.",[9427,9428,9429],false],[0,0,0,"config",null,"",null,false],[0,0,0,"function",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,350,0,null,null," Represents a kernel thread handle.\n May be an integer or a pointer depending on the platform.",null,false],[63,353,0,null,null," Returns the handle of this thread",[9432],false],[0,0,0,"self",null,"",null,false],[63,359,0,null,null," Release the obligation of the caller to call `join()` and have the thread clean up its own resources on completion.\n Once called, this consumes the Thread object and invoking any other functions on it is considered undefined behavior.",[9434],false],[0,0,0,"self",null,"",null,false],[63,365,0,null,null," Waits for the thread to complete, then deallocates any resources created on `spawn()`.\n Once called, this consumes the Thread object and invoking any other functions on it is considered undefined behavior.",[9436],false],[0,0,0,"self",null,"",null,false],[63,369,0,null,null,null,null,false],[63,375,0,null,null," Yields the current thread potentially allowing other threads to run.",[],false],[63,390,0,null,null," State to synchronize detachment of spawner thread to spawned thread",[9440,9441,9442],false],[0,0,0,"running",null,null,null,false],[0,0,0,"detached",null,null,null,false],[0,0,0,"completed",null,null,null,false],[63,397,0,null,null," Used by the Thread implementations to call the spawned function with the arguments.",[9444,9445],false],[0,0,0,"f",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,449,0,null,null," We can't compile error in the `Impl` switch statement as its eagerly evaluated.\n So instead, we compile-error on the methods themselves for platforms which don't support threads.",[],false],[63,450,0,null,null,null,null,false],[63,452,0,null,null,null,[],false],[63,456,0,null,null,null,[],false],[63,460,0,null,null,null,[9451,9452,9453],false],[0,0,0,"config",null,"",null,false],[0,0,0,"f",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,464,0,null,null,null,[9455],false],[0,0,0,"self",null,"",null,false],[63,468,0,null,null,null,[9457],false],[0,0,0,"self",null,"",null,false],[63,472,0,null,null,null,[9459],false],[0,0,0,"self",null,"",null,false],[63,476,0,null,null,null,[9461],false],[0,0,0,"unused",null,"",null,false],[63,482,0,null,null,null,[9489],false],[63,483,0,null,null,null,null,false],[63,485,0,null,null,null,null,false],[63,487,0,null,null,null,[],false],[63,491,0,null,null,null,[],false],[63,498,0,null,null,null,[9471,9473,9475,9477],false],[63,504,0,null,null,null,[9469],false],[0,0,0,"self",null,"",null,false],[63,498,0,null,null,null,null,false],[0,0,0,"completion",null,null,null,false],[63,498,0,null,null,null,null,false],[0,0,0,"heap_ptr",null,null,null,false],[63,498,0,null,null,null,null,false],[0,0,0,"heap_handle",null,null,null,false],[63,498,0,null,null,null,null,false],[0,0,0,"thread_handle",null,null,null,false],[63,510,0,null,null,null,[9479,9480,9481],false],[0,0,0,"config",null,"",null,false],[0,0,0,"f",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,565,0,null,null,null,[9483],false],[0,0,0,"self",null,"",null,false],[63,569,0,null,null,null,[9485],false],[0,0,0,"self",null,"",null,false],[63,578,0,null,null,null,[9487],false],[0,0,0,"self",null,"",null,false],[63,482,0,null,null,null,null,false],[0,0,0,"thread",null,null,null,false],[63,586,0,null,null,null,[9506],false],[63,587,0,null,null,null,null,false],[63,589,0,null,null,null,null,false],[63,591,0,null,null,null,[],false],[63,623,0,null,null,null,[],false],[63,671,0,null,null,null,[9496,9497,9498],false],[0,0,0,"config",null,"",null,false],[0,0,0,"f",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,716,0,null,null,null,[9500],false],[0,0,0,"self",null,"",null,false],[63,720,0,null,null,null,[9502],false],[0,0,0,"self",null,"",null,false],[63,729,0,null,null,null,[9504],false],[0,0,0,"self",null,"",null,false],[63,586,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[63,740,0,null,null,null,[9560],false],[63,743,0,null,null,null,null,false],[63,744,0,null,null,null,null,false],[63,746,0,null,null,null,[9512,9514,9516,9518],false],[63,746,0,null,null,null,null,false],[0,0,0,"tid",null," Thread ID",null,false],[63,746,0,null,null,null,null,false],[0,0,0,"memory",null," Contains all memory which was allocated to bootstrap this thread, including:\n - Guard page\n - Stack\n - TLS segment\n - `Instance`\n All memory is freed upon call to `join`",null,false],[63,746,0,null,null,null,null,false],[0,0,0,"allocator",null," The allocator used to allocate the thread's memory,\n which is also used during `join` to ensure clean-up.",null,false],[63,746,0,null,null,null,null,false],[0,0,0,"state",null," The current state of the thread.",null,false],[63,764,0,null,null," A meta-data structure used to bootstrap a thread",[9521,9522,9523,9524,9527,9529],false],[63,764,0,null,null,null,null,false],[0,0,0,"thread",null,null,null,false],[0,0,0,"tls_offset",null," Contains the offset to the new __tls_base.\n The offset starting from the memory's base.",null,false],[0,0,0,"stack_offset",null," Contains the offset to the stack for the newly spawned thread.\n The offset is calculated starting from the memory's base.",null,false],[0,0,0,"raw_ptr",null," Contains the raw pointer value to the wrapper which holds all arguments\n for the callback.",null,false],[63,764,0,null,null,null,[9526],false],[0,0,0,"",null,"",null,false],[0,0,0,"call_back",null," Function pointer to a wrapping function which will call the user's\n function upon thread spawn. The above mentioned pointer will be passed\n to this function pointer as its argument.",null,false],[63,764,0,null,null,null,null,false],[0,0,0,"original_stack_pointer",null," When a thread is in `detached` state, we must free all of its memory\n upon thread completion. However, as this is done while still within\n the thread, we must first jump back to the main thread's stack or else\n we end up freeing the stack that we're currently using.",null,false],[63,786,0,null,null,null,[9531,9532,9533],false],[0,0,0,"running",null,null,null,false],[0,0,0,"completed",null,null,null,false],[0,0,0,"detached",null,null,null,false],[63,788,0,null,null,null,[],false],[63,792,0,null,null,null,[9536],false],[0,0,0,"self",null,"",null,false],[63,796,0,null,null,null,[9538],false],[0,0,0,"self",null,"",null,false],[63,804,0,null,null,null,[9540],false],[0,0,0,"self",null,"",null,false],[63,844,0,null,null,null,[9542,9543,9544],false],[0,0,0,"config",null,"",null,false],[0,0,0,"f",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,920,0,null,null," Bootstrap procedure, called by the host environment after thread creation.",[9546,9547],false],[0,0,0,"tid",null,"",null,false],[0,0,0,"arg",null,"",null,false],[63,968,0,null,null," Asks the host to create a new thread for us.\n Newly created thread will call `wasi_tread_start` with the thread ID as well\n as the input `arg` that was provided to `spawnWasiThread`",null,false],[63,969,0,null,null,null,[9550],false],[0,0,0,"arg",null,"",null,false],[63,973,0,null,null," Initializes the TLS data segment starting at `memory`.\n This is a synthetic function, generated by the linker.",[9552],false],[0,0,0,"memory",null,"",null,false],[63,976,0,null,null," Returns a pointer to the base of the TLS data segment for the current thread",[],false],[63,986,0,null,null," Returns the size of the TLS segment",[],false],[63,996,0,null,null," Returns the alignment of the TLS segment",[],false],[63,1006,0,null,null," Allows for setting the stack pointer in the WebAssembly module.",[9557],false],[0,0,0,"addr",null,"",null,false],[63,1016,0,null,null," Returns the current value of the stack pointer",[],false],[63,740,0,null,null,null,null,false],[0,0,0,"thread",null,null,null,false],[63,1025,0,null,null,null,[9588],false],[63,1026,0,null,null,null,null,false],[63,1028,0,null,null,null,null,false],[63,1030,0,null,null,null,null,false],[63,1032,0,null,null,null,[],false],[63,1040,0,null,null,null,[],false],[63,1048,0,null,null,null,[9571,9573,9574,9576],false],[63,1057,0,null,null," Calls `munmap(mapped.ptr, mapped.len)` then `exit(1)` without touching the stack (which lives in `mapped.ptr`).\n Ported over from musl libc's pthread detached implementation:\n https://github.com/ifduyue/musl/search?q=__unmapself",[9569],false],[0,0,0,"self",null,"",null,false],[63,1048,0,null,null,null,null,false],[0,0,0,"completion",null,null,null,false],[63,1048,0,null,null,null,null,false],[0,0,0,"child_tid",null,null,null,false],[0,0,0,"parent_tid",null,null,null,false],[63,1048,0,null,null,null,null,false],[0,0,0,"mapped",null,null,null,false],[63,1195,0,null,null,null,[9578,9579,9580],false],[0,0,0,"config",null,"",null,false],[0,0,0,"f",null,"",null,true],[0,0,0,"args",null,"",null,false],[63,1319,0,null,null,null,[9582],false],[0,0,0,"self",null,"",null,false],[63,1323,0,null,null,null,[9584],false],[0,0,0,"self",null,"",null,false],[63,1331,0,null,null,null,[9586],false],[0,0,0,"self",null,"",null,false],[63,1025,0,null,null,null,null,false],[0,0,0,"thread",null,null,null,false],[63,1362,0,null,null,null,[9590],false],[0,0,0,"thread",null,"",null,false],[63,1445,0,null,null,null,[9592,9593],false],[0,0,0,"value",null,"",null,false],[0,0,0,"event",null,"",null,false],[63,0,0,null,null,null,null,false],[0,0,0,"impl",null,null,null,false],[1,51,0,null,null,null,null,false],[0,0,0,"treap.zig",null,"",[],false],[72,0,0,null,null,null,null,false],[72,1,0,null,null,null,null,false],[72,2,0,null,null,null,null,false],[72,3,0,null,null,null,null,false],[72,5,0,null,null,null,[9603,9604],false],[0,0,0,"Key",null,"",null,true],[0,0,0,"compareFn",null,"",[9667,9669],true],[72,7,0,null,null,null,null,false],[72,11,0,null,null,null,[9607,9608],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[72,21,0,null,null," A customized pseudo random number generator for the treap.\n This just helps reducing the memory size of the treap itself\n as std.rand.DefaultPrng requires larger state (while producing better entropy for randomness to be fair).",[9613],false],[72,24,0,null,null,null,[9611,9612],false],[0,0,0,"self",null,"",null,false],[0,0,0,"seed",null,"",null,false],[0,0,0,"xorshift",null,null,null,false],[72,48,0,null,null," A Node represents an item or point in the treap with a uniquely associated key.",[9616,9617,9619,9621],false],[72,48,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[0,0,0,"priority",null,null,null,false],[72,48,0,null,null,null,null,false],[0,0,0,"parent",null,null,null,false],[72,48,0,null,null,null,null,false],[0,0,0,"children",null,null,null,false],[72,57,0,null,null," Returns the smallest Node by key in the treap if there is one.\n Use `getEntryForExisting()` to replace/remove this Node from the treap.",[9623],false],[0,0,0,"self",null,"",null,false],[72,67,0,null,null," Returns the largest Node by key in the treap if there is one.\n Use `getEntryForExisting()` to replace/remove this Node from the treap.",[9625],false],[0,0,0,"self",null,"",null,false],[72,77,0,null,null," Lookup the Entry for the given key in the treap.\n The Entry act's as a slot in the treap to insert/replace/remove the node associated with the key.",[9627,9628],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[72,92,0,null,null," Get an entry for a Node that currently exists in the treap.\n It is undefined behavior if the Node is not currently inserted in the treap.\n The Entry act's as a slot in the treap to insert/replace/remove the node associated with the key.",[9630,9631],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[72,104,0,null,null," An Entry represents a slot in the treap associated with a given key.",[9637,9639,9641,9645],false],[72,120,0,null,null," Update's the Node at this Entry in the treap with the new node.",[9634,9635],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_node",null,"",null,false],[72,104,0,null,null,null,null,false],[0,0,0,"key",null," The associated key for this entry.",null,false],[72,104,0,null,null,null,null,false],[0,0,0,"treap",null," A reference to the treap this entry is apart of.",null,false],[72,104,0,null,null,null,null,false],[0,0,0,"node",null," The current node at this entry.",null,false],[72,104,0,null,null,null,[9643,9644],false],[0,0,0,"inserted_under",null," A find() was called for this entry and the position in the treap is known.",null,false],[0,0,0,"removed",null," The entry's node was removed from the treap and a lookup must occur again for modification.",null,false],[0,0,0,"context",null," The current state of the entry.",null,false],[72,151,0,null,null,null,[9647,9648,9649],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"parent_ref",null,"",null,false],[72,167,0,null,null,null,[9651,9652,9653,9654],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"parent",null,"",null,false],[0,0,0,"node",null,"",null,false],[72,191,0,null,null,null,[9656,9657,9658],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[72,211,0,null,null,null,[9660,9661],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[72,233,0,null,null,null,[9663,9664,9665],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[0,0,0,"right",null,"",null,false],[72,6,0,null,null,null,null,false],[0,0,0,"root",null,null,null,false],[72,6,0,null,null,null,null,false],[0,0,0,"prng",null,null,null,false],[72,264,0,null,null,null,[9671],false],[0,0,0,"T",null,"",[9681,9683,9684,9685,9686],true],[72,272,0,null,null,null,null,false],[72,274,0,null,null,null,[9674,9675],false],[0,0,0,"slice",null,"",null,false],[0,0,0,"rng",null,"",null,false],[72,294,0,null,null,null,[9677],false],[0,0,0,"self",null,"",null,false],[72,299,0,null,null,null,[9679],false],[0,0,0,"self",null,"",null,false],[72,265,0,null,null,null,null,false],[0,0,0,"rng",null,null,null,false],[72,265,0,null,null,null,null,false],[0,0,0,"slice",null,null,null,false],[0,0,0,"index",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"co_prime",null,null,null,false],[72,307,0,null,null,null,null,false],[72,308,0,null,null,null,null,false],[1,52,0,null,null,null,null,false],[1,53,0,null,null,null,null,false],[0,0,0,"Uri.zig",null," Uniform Resource Identifier (URI) parsing roughly adhering to <https://tools.ietf.org/html/rfc3986>.\n Does not do perfect grammar and character class checking, but should be robust against URIs in the wild.\n",[9786,9788,9790,9792,9794,9796,9798,9800],false],[73,3,0,null,null,null,null,false],[73,4,0,null,null,null,null,false],[73,5,0,null,null,null,null,false],[73,17,0,null,null," Applies URI encoding and replaces all reserved characters with their respective %XX code.",[9696,9697],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,21,0,null,null,null,[9699,9700],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,25,0,null,null,null,[9702,9703],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,29,0,null,null,null,[9705,9706],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,33,0,null,null,null,[9708,9709],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,37,0,null,null,null,[9711,9712],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,41,0,null,null,null,[9714,9715,9716],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"keepUnescaped",null,"",[9717],true],[0,0,0,"c",null,"",null,false],[73,66,0,null,null,null,[9719,9720,9721],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"keepUnescaped",null,"",[9722],true],[0,0,0,"c",null,"",null,false],[73,78,0,null,null," Parses a URI string and unescapes all %XX where XX is a valid hex number. Otherwise, verbatim copies\n them to the output.",[9724,9725],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"input",null,"",null,false],[73,128,0,null,null,null,null,false],[73,134,0,null,null," Parses the URI or returns an error. This function is not compliant, but is required to parse\n some forms of URIs in the wild. Such as HTTP Location headers.\n The return value will contain unescaped strings pointing into the\n original `text`. Each component that is provided, will be non-`null`.",[9728],false],[0,0,0,"text",null,"",null,false],[73,208,0,null,null,null,[9730,9731,9732,9733],false],[0,0,0,"uri",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[73,268,0,null,null," Parses the URI or returns an error.\n The return value will contain unescaped strings pointing into the\n original `text`. Each component that is provided, will be non-`null`.",[9735],false],[0,0,0,"text",null,"",null,false],[73,288,0,null,null," Resolves a URI against a base URI, conforming to RFC 3986, Section 5.\n arena owns any memory allocated by this function.",[9737,9738,9739,9740],false],[0,0,0,"Base",null,"",null,false],[0,0,0,"R",null,"",null,false],[0,0,0,"strict",null,"",null,false],[0,0,0,"arena",null,"",null,false],[73,335,0,null,null,null,[9761,9762],false],[73,336,0,null,null,null,null,false],[73,341,0,null,null,null,[9744],false],[0,0,0,"self",null,"",null,false],[73,349,0,null,null,null,[9746],false],[0,0,0,"self",null,"",null,false],[73,355,0,null,null,null,[9748,9749],false],[0,0,0,"self",null,"",null,false],[0,0,0,"predicate",null,"",[9750],true],[0,0,0,"",null,"",null,false],[73,365,0,null,null,null,[9752,9753],false],[0,0,0,"self",null,"",null,false],[0,0,0,"predicate",null,"",[9754],true],[0,0,0,"",null,"",null,false],[73,375,0,null,null,null,[9756],false],[0,0,0,"self",null,"",null,false],[73,381,0,null,null,null,[9758,9759],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[73,335,0,null,null,null,null,false],[0,0,0,"slice",null,null,null,false],[0,0,0,"offset",null,null,null,false],[73,389,0,null,null," scheme      = ALPHA *( ALPHA / DIGIT / \"+\" / \"-\" / \".\" )",[9764],false],[0,0,0,"c",null,"",null,false],[73,396,0,null,null,null,[9766],false],[0,0,0,"c",null,"",null,false],[73,404,0,null,null," reserved    = gen-delims / sub-delims",[9768],false],[0,0,0,"c",null,"",null,false],[73,409,0,null,null," gen-delims  = \":\" / \"/\" / \"?\" / \"#\" / \"[\" / \"]\" / \"@\"",[9770],false],[0,0,0,"c",null,"",null,false],[73,418,0,null,null," sub-delims  = \"!\" / \"$\" / \"&\" / \"'\" / \"(\" / \")\"\n             / \"*\" / \"+\" / \",\" / \";\" / \"=\"",[9772],false],[0,0,0,"c",null,"",null,false],[73,426,0,null,null," unreserved  = ALPHA / DIGIT / \"-\" / \".\" / \"_\" / \"~\"",[9774],false],[0,0,0,"c",null,"",null,false],[73,433,0,null,null,null,[9776],false],[0,0,0,"c",null,"",null,false],[73,440,0,null,null,null,[9778],false],[0,0,0,"c",null,"",null,false],[73,444,0,null,null,null,[9780],false],[0,0,0,"c",null,"",null,false],[73,448,0,null,null,null,[9782],false],[0,0,0,"c",null,"",null,false],[73,523,0,null,null,null,[9784],false],[0,0,0,"hostlist",null,"",null,true],[73,0,0,null,null,null,null,false],[0,0,0,"scheme",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"user",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"password",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"host",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"port",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"query",null,null,null,false],[73,0,0,null,null,null,null,false],[0,0,0,"fragment",null,null,null,false],[1,55,0,null,null,null,null,false],[0,0,0,"array_hash_map.zig",null,"",[],false],[74,0,0,null,null,null,null,false],[74,1,0,null,null,null,null,false],[74,2,0,null,null,null,null,false],[74,3,0,null,null,null,null,false],[74,4,0,null,null,null,null,false],[74,5,0,null,null,null,null,false],[74,6,0,null,null,null,null,false],[74,7,0,null,null,null,null,false],[74,8,0,null,null,null,null,false],[74,9,0,null,null,null,null,false],[74,10,0,null,null,null,null,false],[74,11,0,null,null,null,null,false],[74,15,0,null,null," An ArrayHashMap with default hash and equal functions.\n See AutoContext for a description of the hash and equal implementations.",[9816,9817],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[74,21,0,null,null," An ArrayHashMapUnmanaged with default hash and equal functions.\n See AutoContext for a description of the hash and equal implementations.",[9819,9820],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[74,26,0,null,null," Builtin hashmap for strings as keys.",[9822],false],[0,0,0,"V",null,"",null,true],[74,30,0,null,null,null,[9824],false],[0,0,0,"V",null,"",null,true],[74,34,0,null,null,null,[],false],[74,35,0,null,null,null,[9827,9828],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[74,39,0,null,null,null,[9830,9831,9832,9833],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"b_index",null,"",null,false],[74,46,0,null,null,null,[9835,9836],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[74,50,0,null,null,null,[9838],false],[0,0,0,"s",null,"",null,false],[74,73,0,null,null," Insertion order is preserved.\n Deletions perform a \"swap removal\" on the entries list.\n Modifying the hash map while iterating is allowed, however, one must understand\n the (well defined) behavior when mixing insertions and deletions with iteration.\n For a hash map that can be initialized directly that does not store an Allocator\n field, see `ArrayHashMapUnmanaged`.\n When `store_hash` is `false`, this data structure is biased towards cheap `eql`\n functions. It does not store each item's hash in the table. Setting `store_hash`\n to `true` incurs slightly more memory cost by storing each key's hash in the table\n but only has to call `eql` for hash collisions.\n If typical operations (except iteration over entries) need to be faster, prefer\n the alternative `std.HashMap`.\n Context must be a struct type with two member functions:\n   hash(self, K) u32\n   eql(self, K, K, usize) bool\n Adapted variants of many functions are provided.  These variants\n take a pseudo key instead of a key.  Their context must have the functions:\n   hash(self, PseudoKey) u32\n   eql(self, PseudoKey, K, usize) bool",[9840,9841,9842,9843],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"store_hash",null,"",[10035,10037,10039],true],[74,85,0,null,null," The ArrayHashMapUnmanaged type using the same settings as this managed map.",null,false],[74,92,0,null,null," Pointers to a key and value in the backing store of this map.\n Modifying the key is allowed only if it does not change the hash.\n Modifying the value is allowed.\n Entry pointers become invalid whenever this ArrayHashMap is modified,\n unless `ensureTotalCapacity`/`ensureUnusedCapacity` was previously used.",null,false],[74,95,0,null,null," A KV pair which has been copied out of the backing store",null,false],[74,98,0,null,null," The Data type used for the MultiArrayList backing this map",null,false],[74,100,0,null,null," The MultiArrayList type backing this map",null,false],[74,103,0,null,null," The stored hash type, either u32 or void.",null,false],[74,112,0,null,null," getOrPut variants return this structure, with pointers\n to the backing store and a flag to indicate whether an\n existing entry was found.\n Modifying the key is allowed only if it does not change the hash.\n Modifying the value is allowed.\n Entry pointers become invalid whenever this ArrayHashMap is modified,\n unless `ensureTotalCapacity`/`ensureUnusedCapacity` was previously used.",null,false],[74,115,0,null,null," An Iterator over Entry pointers.",null,false],[74,117,0,null,null,null,null,false],[74,120,0,null,null," Create an ArrayHashMap instance which will use a specified allocator.",[9854],false],[0,0,0,"allocator",null,"",null,false],[74,125,0,null,null,null,[9856,9857],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,136,0,null,null," Frees the backing allocation and leaves the map in an undefined state.\n Note that this does not free keys or values.  You must take care of that\n before calling this function, if it is needed.",[9859],false],[0,0,0,"self",null,"",null,false],[74,142,0,null,null," Clears the map but retains the backing allocation for future use.",[9861],false],[0,0,0,"self",null,"",null,false],[74,147,0,null,null," Clears the map and releases the backing allocation",[9863],false],[0,0,0,"self",null,"",null,false],[74,152,0,null,null," Returns the number of KV pairs stored in this map.",[9865],false],[0,0,0,"self",null,"",null,false],[74,160,0,null,null," Returns the backing array of keys in this map. Modifying the map may\n invalidate this array. Modifying this array in a way that changes\n key hashes or key equality puts the map into an unusable state until\n `reIndex` is called.",[9867],false],[0,0,0,"self",null,"",null,false],[74,166,0,null,null," Returns the backing array of values in this map. Modifying the map\n may invalidate this array. It is permitted to modify the values in\n this array.",[9869],false],[0,0,0,"self",null,"",null,false],[74,172,0,null,null," Returns an iterator over the pairs in this map.\n Modifying the map may invalidate this iterator.",[9871],false],[0,0,0,"self",null,"",null,false],[74,182,0,null,null," If key exists this function cannot fail.\n If there is an existing item with `key`, then the result\n `Entry` pointer points to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointer points to it. Caller should then initialize\n the value (but not the key).",[9873,9874],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,185,0,null,null,null,[9876,9877,9878],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,196,0,null,null," If there is an existing item with `key`, then the result\n `Entry` pointer points to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointer points to it. Caller should then initialize\n the value (but not the key).\n If a new entry needs to be stored, this function asserts there\n is enough capacity to store it.",[9880,9881],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,199,0,null,null,null,[9883,9884,9885],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,202,0,null,null,null,[9887,9888,9889],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,208,0,null,null," Increases capacity, guaranteeing that insertions up until the\n `expected_count` will not cause an allocation, and therefore cannot fail.",[9891,9892],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[74,215,0,null,null," Increases capacity, guaranteeing that insertions up until\n `additional_count` **more** items will not cause an allocation, and\n therefore cannot fail.",[9894,9895],false],[0,0,0,"self",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[74,221,0,null,null," Returns the number of total elements which may be present before it is\n no longer guaranteed that no allocations will be performed.",[9897],false],[0,0,0,"self",null,"",null,false],[74,227,0,null,null," Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPut`.",[9899,9900,9901],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,233,0,null,null," Inserts a key-value pair into the hash map, asserting that no previous\n entry with the same key is already present",[9903,9904,9905],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,240,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPutAssumeCapacity`.",[9907,9908,9909],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,247,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Asserts that it does not clobber any existing data.\n To detect if a put would clobber existing data, see `getOrPutAssumeCapacity`.",[9911,9912,9913],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,252,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.",[9915,9916,9917],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,258,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.\n If insertion happuns, asserts there is enough capacity without allocating.",[9919,9920,9921],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,263,0,null,null," Finds pointers to the key and value storage associated with a key.",[9923,9924],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,266,0,null,null,null,[9926,9927,9928],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,271,0,null,null," Finds the index in the `entries` array where a key is stored",[9930,9931],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,274,0,null,null,null,[9933,9934,9935],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,279,0,null,null," Find the value associated with a key",[9937,9938],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,282,0,null,null,null,[9940,9941,9942],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,287,0,null,null," Find a pointer to the value associated with a key",[9944,9945],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,290,0,null,null,null,[9947,9948,9949],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,295,0,null,null," Find the actual key associated with an adapted key",[9951,9952],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,298,0,null,null,null,[9954,9955,9956],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,303,0,null,null," Find a pointer to the actual key associated with an adapted key",[9958,9959],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,306,0,null,null,null,[9961,9962,9963],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,311,0,null,null," Check whether a key is stored in the map",[9965,9966],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,314,0,null,null,null,[9968,9969,9970],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,322,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and then returned from this function. The entry is\n removed from the underlying array by swapping it with the last\n element.",[9972,9973],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,325,0,null,null,null,[9975,9976,9977],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,333,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and then returned from this function. The entry is\n removed from the underlying array by shifting all elements forward\n thereby maintaining the current ordering.",[9979,9980],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,336,0,null,null,null,[9982,9983,9984],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,344,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map. The entry is removed from the underlying array\n by swapping it with the last element.  Returns true if an entry\n was removed, false otherwise.",[9986,9987],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,347,0,null,null,null,[9989,9990,9991],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,355,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map. The entry is removed from the underlying array\n by shifting all elements forward, thereby maintaining the\n current ordering.  Returns true if an entry was removed, false otherwise.",[9993,9994],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,358,0,null,null,null,[9996,9997,9998],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,365,0,null,null," Deletes the item at the specified index in `entries` from\n the hash map. The entry is removed from the underlying array\n by swapping it with the last element.",[10000,10001],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[74,373,0,null,null," Deletes the item at the specified index in `entries` from\n the hash map. The entry is removed from the underlying array\n by shifting all elements forward, thereby maintaining the\n current ordering.",[10003,10004],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[74,379,0,null,null," Create a copy of the hash map which can be modified separately.\n The copy uses the same context and allocator as this instance.",[10006],false],[0,0,0,"self",null,"",null,false],[74,386,0,null,null," Create a copy of the hash map which can be modified separately.\n The copy uses the same context as this instance, but the specified\n allocator.",[10008,10009],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,393,0,null,null," Create a copy of the hash map which can be modified separately.\n The copy uses the same allocator as this instance, but the\n specified context.",[10011,10012],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,399,0,null,null," Create a copy of the hash map which can be modified separately.\n The copy uses the specified allocator and context.",[10014,10015,10016],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,406,0,null,null," Set the map to an empty state, making deinitialization a no-op, and\n returning a copy of the original.",[10018],false],[0,0,0,"self",null,"",null,false],[74,422,0,null,null," Recomputes stored hashes and rebuilds the key indexes. If the\n underlying keys have been modified directly, call this method to\n recompute the denormalized metadata necessary for the operation of\n the methods of this map that lookup entries by key.\n\n One use case for this is directly calling `entries.resize()` to grow\n the underlying storage, and then setting the `keys` and `values`\n directly without going through the methods of this map.\n\n The time complexity of this operation is O(n).",[10020],false],[0,0,0,"self",null,"",null,false],[74,429,0,null,null," Sorts the entries and then rebuilds the index.\n `sort_ctx` must have this method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[10022,10023],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sort_ctx",null,"",null,false],[74,435,0,null,null," Shrinks the underlying `Entry` array to `new_len` elements and discards any associated\n index entries. Keeps capacity the same.",[10025,10026],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[74,441,0,null,null," Shrinks the underlying `Entry` array to `new_len` elements and discards any associated\n index entries. Reduces allocated capacity.",[10028,10029],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[74,446,0,null,null," Removes the last inserted `Entry` in the hash map and returns it.",[10031],false],[0,0,0,"self",null,"",null,false],[74,452,0,null,null," Removes the last inserted `Entry` in the hash map and returns it if count is nonzero.\n Otherwise returns null.",[10033],false],[0,0,0,"self",null,"",null,false],[74,79,0,null,null,null,null,false],[0,0,0,"unmanaged",null,null,null,false],[74,79,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[74,79,0,null,null,null,null,false],[0,0,0,"ctx",null,null,null,false],[74,482,0,null,null," General purpose hash table.\n Insertion order is preserved.\n Deletions perform a \"swap removal\" on the entries list.\n Modifying the hash map while iterating is allowed, however, one must understand\n the (well defined) behavior when mixing insertions and deletions with iteration.\n This type does not store an Allocator field - the Allocator must be passed in\n with each function call that requires it. See `ArrayHashMap` for a type that stores\n an Allocator field for convenience.\n Can be initialized directly using the default field values.\n This type is designed to have low overhead for small numbers of entries. When\n `store_hash` is `false` and the number of entries in the map is less than 9,\n the overhead cost of using `ArrayHashMapUnmanaged` rather than `std.ArrayList` is\n only a single pointer-sized integer.\n When `store_hash` is `false`, this data structure is biased towards cheap `eql`\n functions. It does not store each item's hash in the table. Setting `store_hash`\n to `true` incurs slightly more memory cost by storing each key's hash in the table\n but guarantees only one call to `eql` per insertion/deletion.\n Context must be a struct type with two member functions:\n   hash(self, K) u32\n   eql(self, K, K) bool\n Adapted variants of many functions are provided.  These variants\n take a pseudo key instead of a key.  Their context must have the functions:\n   hash(self, PseudoKey) u32\n   eql(self, PseudoKey, K) bool",[10041,10042,10043,10044],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"store_hash",null,"",[10574,10576],true],[74,507,0,null,null," Modifying the key is allowed only if it does not change the hash.\n Modifying the value is allowed.\n Entry pointers become invalid whenever this ArrayHashMap is modified,\n unless `ensureTotalCapacity`/`ensureUnusedCapacity` was previously used.",[10047,10049],false],[74,507,0,null,null,null,null,false],[0,0,0,"key_ptr",null,null,null,false],[74,507,0,null,null,null,null,false],[0,0,0,"value_ptr",null,null,null,false],[74,513,0,null,null," A KV pair which has been copied out of the backing store",[10052,10054],false],[74,513,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[74,513,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[74,519,0,null,null," The Data type used for the MultiArrayList backing this map",[10057,10059,10061],false],[74,519,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[74,519,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[74,519,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[74,526,0,null,null," The MultiArrayList type backing this map",null,false],[74,529,0,null,null," The stored hash type, either u32 or void.",null,false],[74,538,0,null,null," getOrPut variants return this structure, with pointers\n to the backing store and a flag to indicate whether an\n existing entry was found.\n Modifying the key is allowed only if it does not change the hash.\n Modifying the value is allowed.\n Entry pointers become invalid whenever this ArrayHashMap is modified,\n unless `ensureTotalCapacity`/`ensureUnusedCapacity` was previously used.",[10066,10068,10069,10070],false],[74,538,0,null,null,null,null,false],[0,0,0,"key_ptr",null,null,null,false],[74,538,0,null,null,null,null,false],[0,0,0,"value_ptr",null,null,null,false],[0,0,0,"found_existing",null,null,null,false],[0,0,0,"index",null,null,null,false],[74,546,0,null,null," The ArrayHashMap type using the same settings as this managed map.",null,false],[74,550,0,null,null," Some functions require a context only if hashes are not stored.\n To keep the api simple, this type is only used internally.",null,false],[74,552,0,null,null,null,null,false],[74,554,0,null,null,null,null,false],[74,556,0,null,null,null,[10076,10077],false],[0,0,0,"swap",null,null,null,false],[0,0,0,"ordered",null,null,null,false],[74,563,0,null,null," Convert from an unmanaged map to a managed map.  After calling this,\n the promoted map should no longer be used.",[10079,10080],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,568,0,null,null,null,[10082,10083,10084],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,579,0,null,null," Frees the backing allocation and leaves the map in an undefined state.\n Note that this does not free keys or values.  You must take care of that\n before calling this function, if it is needed.",[10086,10087],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,588,0,null,null," Clears the map but retains the backing allocation for future use.",[10089],false],[0,0,0,"self",null,"",null,false],[74,600,0,null,null," Clears the map and releases the backing allocation",[10091,10092],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,609,0,null,null," Returns the number of KV pairs stored in this map.",[10094],false],[0,0,0,"self",null,"",null,false],[74,617,0,null,null," Returns the backing array of keys in this map. Modifying the map may\n invalidate this array. Modifying this array in a way that changes\n key hashes or key equality puts the map into an unusable state until\n `reIndex` is called.",[10096],false],[0,0,0,"self",null,"",null,false],[74,623,0,null,null," Returns the backing array of values in this map. Modifying the map\n may invalidate this array. It is permitted to modify the values in\n this array.",[10098],false],[0,0,0,"self",null,"",null,false],[74,629,0,null,null," Returns an iterator over the pairs in this map.\n Modifying the map may invalidate this iterator.",[10100],false],[0,0,0,"self",null,"",null,false],[74,637,0,null,null,null,[10107,10109,10110,10111],false],[74,643,0,null,null,null,[10103],false],[0,0,0,"it",null,"",null,false],[74,655,0,null,null," Reset the iterator to the initial index",[10105],false],[0,0,0,"it",null,"",null,false],[74,637,0,null,null,null,null,false],[0,0,0,"keys",null,null,null,false],[74,637,0,null,null,null,null,false],[0,0,0,"values",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"index",null,null,null,false],[74,666,0,null,null," If key exists this function cannot fail.\n If there is an existing item with `key`, then the result\n `Entry` pointer points to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointer points to it. Caller should then initialize\n the value (but not the key).",[10113,10114,10115],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,671,0,null,null,null,[10117,10118,10119,10120],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,678,0,null,null,null,[10122,10123,10124,10125],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[74,683,0,null,null,null,[10127,10128,10129,10130,10131],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,706,0,null,null," If there is an existing item with `key`, then the result\n `Entry` pointer points to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointer points to it. Caller should then initialize\n the value (but not the key).\n If a new entry needs to be stored, this function asserts there\n is enough capacity to store it.",[10133,10134],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,711,0,null,null,null,[10136,10137,10138],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,725,0,null,null," If there is an existing item with `key`, then the result\n `Entry` pointers point to it, and found_existing is true.\n Otherwise, puts a new item with undefined key and value, and\n the `Entry` pointers point to it. Caller must then initialize\n both the key and the value.\n If a new entry needs to be stored, this function asserts there\n is enough capacity to store it.",[10140,10141,10142],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,764,0,null,null,null,[10144,10145,10146,10147],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,769,0,null,null,null,[10149,10150,10151,10152,10153],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,780,0,null,null," Increases capacity, guaranteeing that insertions up until the\n `expected_count` will not cause an allocation, and therefore cannot fail.",[10155,10156,10157],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[74,785,0,null,null,null,[10159,10160,10161,10162],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,810,0,null,null," Increases capacity, guaranteeing that insertions up until\n `additional_count` **more** items will not cause an allocation, and\n therefore cannot fail.",[10164,10165,10166],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"additional_capacity",null,"",null,false],[74,819,0,null,null,null,[10168,10169,10170,10171],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"additional_capacity",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,830,0,null,null," Returns the number of total elements which may be present before it is\n no longer guaranteed that no allocations will be performed.",[10173],false],[0,0,0,"self",null,"",null,false],[74,839,0,null,null," Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPut`.",[10175,10176,10177,10178],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,844,0,null,null,null,[10180,10181,10182,10183,10184],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,851,0,null,null," Inserts a key-value pair into the hash map, asserting that no previous\n entry with the same key is already present",[10186,10187,10188,10189],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,856,0,null,null,null,[10191,10192,10193,10194,10195],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,865,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPutAssumeCapacity`.",[10197,10198,10199],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,870,0,null,null,null,[10201,10202,10203,10204],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,878,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Asserts that it does not clobber any existing data.\n To detect if a put would clobber existing data, see `getOrPutAssumeCapacity`.",[10206,10207,10208],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,883,0,null,null,null,[10210,10211,10212,10213],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,890,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.",[10215,10216,10217,10218],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,895,0,null,null,null,[10220,10221,10222,10223,10224],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,910,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.\n If insertion happens, asserts there is enough capacity without allocating.",[10226,10227,10228],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[74,915,0,null,null,null,[10230,10231,10232,10233],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,929,0,null,null," Finds pointers to the key and value storage associated with a key.",[10235,10236],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,934,0,null,null,null,[10238,10239,10240],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,937,0,null,null,null,[10242,10243,10244],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,948,0,null,null," Finds the index in the `entries` array where a key is stored",[10246,10247],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,953,0,null,null,null,[10249,10250,10251],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,956,0,null,null,null,[10253,10254,10255],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,976,0,null,null,null,[10257,10258,10259,10260,10261],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[74,983,0,null,null," Find the value associated with a key",[10263,10264],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,988,0,null,null,null,[10266,10267,10268],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,991,0,null,null,null,[10270,10271,10272],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,997,0,null,null," Find a pointer to the value associated with a key",[10274,10275],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1002,0,null,null,null,[10277,10278,10279],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1005,0,null,null,null,[10281,10282,10283],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1012,0,null,null," Find the actual key associated with an adapted key",[10285,10286],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1017,0,null,null,null,[10288,10289,10290],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1020,0,null,null,null,[10292,10293,10294],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1026,0,null,null," Find a pointer to the actual key associated with an adapted key",[10296,10297],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1031,0,null,null,null,[10299,10300,10301],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1034,0,null,null,null,[10303,10304,10305],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1040,0,null,null," Check whether a key is stored in the map",[10307,10308],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1045,0,null,null,null,[10310,10311,10312],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1048,0,null,null,null,[10314,10315,10316],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1056,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and then returned from this function. The entry is\n removed from the underlying array by swapping it with the last\n element.",[10318,10319],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1061,0,null,null,null,[10321,10322,10323],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1064,0,null,null,null,[10325,10326,10327],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1069,0,null,null,null,[10329,10330,10331,10332],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1077,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and then returned from this function. The entry is\n removed from the underlying array by shifting all elements forward\n thereby maintaining the current ordering.",[10334,10335],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1082,0,null,null,null,[10337,10338,10339],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1085,0,null,null,null,[10341,10342,10343],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1090,0,null,null,null,[10345,10346,10347,10348],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1098,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map. The entry is removed from the underlying array\n by swapping it with the last element.  Returns true if an entry\n was removed, false otherwise.",[10350,10351],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1103,0,null,null,null,[10353,10354,10355],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1106,0,null,null,null,[10357,10358,10359],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1111,0,null,null,null,[10361,10362,10363,10364],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1119,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map. The entry is removed from the underlying array\n by shifting all elements forward, thereby maintaining the\n current ordering.  Returns true if an entry was removed, false otherwise.",[10366,10367],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1124,0,null,null,null,[10369,10370,10371],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1127,0,null,null,null,[10373,10374,10375],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1132,0,null,null,null,[10377,10378,10379,10380],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1139,0,null,null," Deletes the item at the specified index in `entries` from\n the hash map. The entry is removed from the underlying array\n by swapping it with the last element.",[10382,10383],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[74,1144,0,null,null,null,[10385,10386,10387],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1152,0,null,null," Deletes the item at the specified index in `entries` from\n the hash map. The entry is removed from the underlying array\n by shifting all elements forward, thereby maintaining the\n current ordering.",[10389,10390],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[74,1157,0,null,null,null,[10392,10393,10394],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1164,0,null,null," Create a copy of the hash map which can be modified separately.\n The copy uses the same context as this instance, but is allocated\n with the provided allocator.",[10396,10397],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,1169,0,null,null,null,[10399,10400,10401],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1186,0,null,null," Set the map to an empty state, making deinitialization a no-op, and\n returning a copy of the original.",[10403],false],[0,0,0,"self",null,"",null,false],[74,1202,0,null,null," Recomputes stored hashes and rebuilds the key indexes. If the\n underlying keys have been modified directly, call this method to\n recompute the denormalized metadata necessary for the operation of\n the methods of this map that lookup entries by key.\n\n One use case for this is directly calling `entries.resize()` to grow\n the underlying storage, and then setting the `keys` and `values`\n directly without going through the methods of this map.\n\n The time complexity of this operation is O(n).",[10405,10406],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,1208,0,null,null,null,[10408,10409,10410],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1231,0,null,null," Sorts the entries and then rebuilds the index.\n `sort_ctx` must have this method:\n `fn lessThan(ctx: @TypeOf(ctx), a_index: usize, b_index: usize) bool`",[10412,10413],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sort_ctx",null,"",null,false],[74,1237,0,null,null,null,[10415,10416,10417],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sort_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1246,0,null,null," Shrinks the underlying `Entry` array to `new_len` elements and discards any associated\n index entries. Keeps capacity the same.",[10419,10420],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[74,1251,0,null,null,null,[10422,10423,10424],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1265,0,null,null," Shrinks the underlying `Entry` array to `new_len` elements and discards any associated\n index entries. Reduces allocated capacity.",[10426,10427,10428],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[74,1270,0,null,null,null,[10430,10431,10432,10433],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1283,0,null,null," Removes the last inserted `Entry` in the hash map and returns it.",[10435],false],[0,0,0,"self",null,"",null,false],[74,1288,0,null,null,null,[10437,10438],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1301,0,null,null," Removes the last inserted `Entry` in the hash map and returns it if count is nonzero.\n Otherwise returns null.",[10440],false],[0,0,0,"self",null,"",null,false],[74,1306,0,null,null,null,[10442,10443],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[74,1312,0,null,null,null,[10445,10446,10447,10448,10449],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"removal_type",null,"",null,true],[74,1341,0,null,null,null,[10451,10452,10453,10454,10455,10456,10457],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"removal_type",null,"",null,true],[74,1353,0,null,null,null,[10459,10460,10461,10462,10463],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"removal_type",null,"",null,true],[74,1378,0,null,null,null,[10465,10466,10467,10468,10469,10470,10471],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"removal_type",null,"",null,true],[74,1385,0,null,null,null,[10473,10474,10475,10476],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"removal_type",null,"",null,true],[74,1400,0,null,null,null,[10478,10479,10480,10481,10482,10483],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"removal_type",null,"",null,true],[74,1406,0,null,null,null,[10485,10486,10487,10488,10489,10490,10491],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[0,0,0,"removal_type",null,"",null,true],[74,1433,0,null,null,null,[10493,10494,10495,10496,10497,10498,10499],false],[0,0,0,"self",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"old_entry_index",null,"",null,false],[0,0,0,"new_entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[74,1446,0,null,null,null,[10501,10502,10503,10504],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[74,1453,0,null,null,null,[10506,10507,10508,10509,10510,10511],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[74,1458,0,null,null,null,[10513,10514,10515,10516,10517,10518],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[74,1465,0,null,null,null,[10520,10521,10522,10523],false],[0,0,0,"removed_slot",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[74,1487,0,null,null,null,[10525,10526,10527,10528,10529,10530],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry_index",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[74,1515,0,null,null," Must `ensureTotalCapacity`/`ensureUnusedCapacity` before calling this.",[10532,10533,10534,10535,10536],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[74,1628,0,null,null,null,[10538,10539,10540,10541,10542,10543],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[0,0,0,"indexes",null,"",null,false],[74,1656,0,null,null,null,[10545,10546,10547],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[74,1663,0,null,null,null,[10549,10550,10551,10552],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[74,1701,0,null,null,null,[10554,10555],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"key",null,"",null,false],[74,1712,0,null,null,null,[10557,10558,10559,10560],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"b_index",null,"",null,false],[74,1724,0,null,null,null,[10562,10563,10564],false],[0,0,0,"self",null,"",null,false],[0,0,0,"keyFmt",null,"",null,true],[0,0,0,"valueFmt",null,"",null,true],[74,1729,0,null,null,null,[10566,10567,10568,10569],false],[0,0,0,"self",null,"",null,false],[0,0,0,"keyFmt",null,"",null,true],[0,0,0,"valueFmt",null,"",null,true],[0,0,0,"ctx",null,"",null,false],[74,1760,0,null,null,null,[10571,10572],false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[74,488,0,null,null,null,null,false],[0,0,0,"entries",null," It is permitted to access this field directly.\n After any modification to the keys, consider calling `reIndex`.",null,false],[74,488,0,null,null,null,null,false],[0,0,0,"index_header",null," When entries length is less than `linear_scan_max`, this remains `null`.\n Once entries length grows big enough, this field is allocated. There is\n an IndexHeader followed by an array of Index(I) structs, where I is defined\n by how many total indexes there are.",null,false],[74,1784,0,null,null,null,[10578,10579,10580],false],[0,0,0,"u8",null,null,null,false],[0,0,0,"u16",null,null,null,false],[0,0,0,"u32",null,null,null,false],[74,1786,0,null,null,null,[10582],false],[0,0,0,"bit_index",null,"",null,false],[74,1795,0,null,null,null,[10584],false],[0,0,0,"bit_index",null,"",null,false],[74,1809,0,null,null," @truncate fails if the target type is larger than the\n target value.  This causes problems when one of the types\n is usize, which may be larger or smaller than u32 on different\n systems.  This version of truncate is safe to use if either\n parameter has dynamic size, and will perform widening conversion\n when needed.  Both arguments must have the same signedness.",[10586,10587],false],[0,0,0,"T",null,"",null,true],[0,0,0,"val",null,"",null,false],[74,1818,0,null,null," A single entry in the lookup acceleration structure.  These structs\n are found in an array after the IndexHeader.  Hashes index into this\n array, and linear probing is used for collisions.",[10589],false],[0,0,0,"I",null,"",[10598,10600],true],[74,1820,0,null,null,null,null,false],[74,1832,0,null,null," The special entry_index value marking an empty slot.",null,false],[74,1835,0,null,null," A constant empty index",null,false],[74,1841,0,null,null," Checks if a slot is empty",[10594],false],[0,0,0,"idx",null,"",null,false],[74,1846,0,null,null," Sets a slot to empty",[10596],false],[0,0,0,"idx",null,"",null,false],[74,1819,0,null,null,null,null,false],[0,0,0,"entry_index",null," The index of this entry in the backing store.  If the index is\n empty, this is empty_sentinel.",null,false],[74,1819,0,null,null,null,null,false],[0,0,0,"distance_from_start_index",null," The distance between this slot and its ideal placement.  This is\n used to keep maximum scan length small.  This value is undefined\n if the index is empty.",null,false],[74,1856,0,null,null," the byte size of the index must fit in a usize.  This is a power of two\n length * the size of an Index(u32).  The index is 8 bytes (3 bits repr)\n and max_usize + 1 is not representable, so we need to subtract out 4 bits.",null,false],[74,1857,0,null,null,null,null,false],[74,1858,0,null,null,null,null,false],[74,1859,0,null,null,null,null,false],[74,1860,0,null,null,null,null,false],[74,1878,0,null,null," This struct is trailed by two arrays of length indexes_len\n of integers, whose integer size is determined by indexes_len.\n These arrays are indexed by constrainIndex(hash).  The\n entryIndexes array contains the index in the dense backing store\n where the entry's data can be found.  Entries which are not in\n use have their index value set to emptySentinel(I).\n The entryDistances array stores the distance between an entry\n and its ideal hash bucket.  This is used when adding elements\n to balance the maximum scan length.",[10631],false],[74,1885,0,null,null," Map from an incrementing index to an index slot in the attached arrays.",[10608,10609],false],[0,0,0,"header",null,"",null,false],[0,0,0,"i",null,"",null,false],[74,1893,0,null,null," Returns the attached array of indexes.  I must match the type\n returned by capacityIndexType.",[10611,10612],false],[0,0,0,"header",null,"",null,false],[0,0,0,"I",null,"",null,true],[74,1899,0,null,null," Returns the type used for the index arrays.",[10614],false],[0,0,0,"header",null,"",null,false],[74,1903,0,null,null,null,[10616],false],[0,0,0,"self",null,"",null,false],[74,1906,0,null,null,null,[10618],false],[0,0,0,"self",null,"",null,false],[74,1909,0,null,null,null,[10620],false],[0,0,0,"self",null,"",null,false],[74,1913,0,null,null,null,[10622],false],[0,0,0,"desired_capacity",null,"",null,false],[74,1924,0,null,null," Allocates an index header, and fills the entryIndexes array with empty.\n The distance array contents are undefined.",[10624,10625],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_bit_index",null,"",null,false],[74,1938,0,null,null," Releases the memory for a header and its associated arrays.",[10627,10628],false],[0,0,0,"header",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[74,1946,0,null,null," Puts an IndexHeader into the state that it would be in after being freshly allocated.",[10630],false],[0,0,0,"header",null,"",null,false],[0,0,0,"bit_index",null," This field tracks the total number of items in the arrays following\n this header.  It is the bit index of the power of two number of indices.\n This value is between min_bit_index and max_bit_index, inclusive.",null,false],[74,2338,0,null,null,null,[10633,10634],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",[10635,10636],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[74,2347,0,null,null,null,[10638,10639],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",[10640,10641,10642],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[74,2356,0,null,null,null,[10644],false],[0,0,0,"K",null,"",[],true],[74,2358,0,null,null,null,null,false],[74,2359,0,null,null,null,null,false],[74,2363,0,null,null,null,[10648,10649],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",[10650,10651],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[74,2378,0,null,null,null,[10653,10654],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",[10655,10656,10657,10658],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[74,2388,0,null,null,null,[10660],false],[0,0,0,"K",null,"",null,true],[74,2406,0,null,null,null,[10662,10663,10664],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"strategy",null,"",[10665,10666],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[1,58,0,null,null," Memory ordering, atomic data structures, and operations.",null,false],[0,0,0,"atomic.zig",null,"",[],false],[75,0,0,null,null,null,null,false],[75,1,0,null,null,null,null,false],[75,3,0,null,null,null,null,false],[75,5,0,null,null,null,null,false],[0,0,0,"atomic/stack.zig",null,"",[],false],[76,0,0,null,null,null,null,false],[76,1,0,null,null,null,null,false],[76,2,0,null,null,null,null,false],[76,3,0,null,null,null,null,false],[76,8,0,null,null," Many reader, many writer, non-allocating, thread-safe\n Uses a spinlock to protect push() and pop()\n When building in single threaded mode, this is a simple linked list.",[10679],false],[0,0,0,"T",null,"",[10699,10701],true],[76,13,0,null,null,null,null,false],[76,15,0,null,null,null,null,false],[76,17,0,null,null,null,[10684,10686],false],[76,17,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[76,17,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[76,22,0,null,null,null,[],false],[76,31,0,null,null," push operation, but only if you are the first item in the stack. if you did not succeed in\n being the first item in the stack, returns the other item that was there.",[10689,10690],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[76,36,0,null,null,null,[10692,10693],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[76,49,0,null,null,null,[10695],false],[0,0,0,"self",null,"",null,false],[76,64,0,null,null,null,[10697],false],[0,0,0,"self",null,"",null,false],[76,9,0,null,null,null,null,false],[0,0,0,"root",null,null,null,false],[76,9,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[76,70,0,null,null,null,[10704,10706,10707,10708,10709,10710],false],[76,70,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[76,70,0,null,null,null,null,false],[0,0,0,"stack",null,null,null,false],[0,0,0,"put_sum",null,null,null,false],[0,0,0,"get_sum",null,null,null,false],[0,0,0,"get_count",null,null,null,false],[0,0,0,"puts_done",null,null,null,false],[76,83,0,null,null,null,null,false],[76,84,0,null,null,null,null,false],[76,147,0,null,null,null,[10714],false],[0,0,0,"ctx",null,"",null,false],[76,165,0,null,null,null,[10716],false],[0,0,0,"ctx",null,"",null,false],[75,6,0,null,null,null,null,false],[0,0,0,"atomic/queue.zig",null,"",[],false],[77,0,0,null,null,null,null,false],[77,1,0,null,null,null,null,false],[77,2,0,null,null,null,null,false],[77,3,0,null,null,null,null,false],[77,9,0,null,null," Many producer, many consumer, non-allocating, thread-safe.\n Uses a mutex to protect access.\n The queue does not manage ownership and the user is responsible to\n manage the storage of the nodes.",[10724],false],[0,0,0,"T",null,"",[10747,10749,10751],true],[77,15,0,null,null,null,null,false],[77,16,0,null,null,null,null,false],[77,20,0,null,null," Initializes a new queue. The queue does not provide a `deinit()`\n function, so the user must take care of cleaning up the queue elements.",[],false],[77,30,0,null,null," Appends `node` to the queue.\n The lifetime of `node` must be longer than lifetime of queue.",[10729,10730],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[77,49,0,null,null," Gets a previously inserted node or returns `null` if there is none.\n It is safe to `get()` a node from the queue while another thread tries\n to `remove()` the same node at the same time.",[10732],false],[0,0,0,"self",null,"",null,false],[77,68,0,null,null," Prepends `node` to the front of the queue.\n The lifetime of `node` must be longer than the lifetime of the queue.",[10734,10735],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[77,87,0,null,null," Removes a node from the queue, returns whether node was actually removed.\n It is safe to `remove()` a node from the queue while another thread tries\n to `get()` the same node at the same time.",[10737,10738],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[77,113,0,null,null," Returns `true` if the queue is currently empty.\n Note that in a multi-consumer environment a return value of `false`\n does not mean that `get` will yield a non-`null` value!",[10740],false],[0,0,0,"self",null,"",null,false],[77,120,0,null,null," Dumps the contents of the queue to `stderr`.",[10742],false],[0,0,0,"self",null,"",null,false],[77,127,0,null,null," Dumps the contents of the queue to `stream`.\n Up to 4 elements from the head are dumped and the tail of the queue is\n dumped as well.",[10744,10745],false],[0,0,0,"self",null,"",null,false],[0,0,0,"stream",null,"",null,false],[77,10,0,null,null,null,null,false],[0,0,0,"head",null,null,null,false],[77,10,0,null,null,null,null,false],[0,0,0,"tail",null,null,null,false],[77,10,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[77,159,0,null,null,null,[10754,10756,10757,10758,10759,10760],false],[77,159,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[77,159,0,null,null,null,null,false],[0,0,0,"queue",null,null,null,false],[0,0,0,"put_sum",null,null,null,false],[0,0,0,"get_sum",null,null,null,false],[0,0,0,"get_count",null,null,null,false],[0,0,0,"puts_done",null,null,null,false],[77,173,0,null,null,null,null,false],[77,174,0,null,null,null,null,false],[77,244,0,null,null,null,[10764],false],[0,0,0,"ctx",null,"",null,false],[77,263,0,null,null,null,[10766],false],[0,0,0,"ctx",null,"",null,false],[75,7,0,null,null,null,null,false],[0,0,0,"atomic/Atomic.zig",null,"",[],false],[78,0,0,null,null,null,null,false],[78,1,0,null,null,null,null,false],[78,3,0,null,null,null,null,false],[78,4,0,null,null,null,null,false],[78,6,0,null,null,null,[10774],false],[0,0,0,"T",null,"",[10886],true],[78,159,0,null,null,null,[],false],[78,160,0,null,null,null,[10777,10778,10779],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,164,0,null,null,null,[10781,10782,10783],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,168,0,null,null,null,[10785,10786,10787],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,172,0,null,null,null,[10789,10790,10791],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,177,0,null,null,null,[],false],[78,178,0,null,null,null,[10794,10795,10796],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,182,0,null,null,null,[10798,10799,10800],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,186,0,null,null,null,[10802,10803,10804],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,190,0,null,null,null,[10806,10807,10808],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,194,0,null,null,null,null,false],[78,195,0,null,null,null,[10811,10812,10813],false],[0,0,0,"Set",null,null,null,false],[0,0,0,"Reset",null,null,null,false],[0,0,0,"Toggle",null,null,null,false],[78,201,0,null,null,null,[10815,10816,10817],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,205,0,null,null,null,[10819,10820,10821],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,209,0,null,null,null,[10823,10824,10825],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,213,0,null,null,null,[10827,10828,10829,10830],false],[0,0,0,"self",null,"",null,false],[0,0,0,"op",null,"",null,true],[0,0,0,"bit",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,232,0,null,null,null,[10832,10833,10834,10835],false],[0,0,0,"self",null,"",null,false],[0,0,0,"op",null,"",null,true],[0,0,0,"bit",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,10,0,null,null,null,null,false],[78,12,0,null,null,null,[10838],false],[0,0,0,"value",null,"",null,false],[78,40,0,null,null," Perform an atomic fence which uses the atomic value as a hint for the modification order.\n Use this when you want to imply a fence on an atomic variable without necessarily performing a memory access.\n\n Example:\n ```\n const RefCount = struct {\n     count: Atomic(usize),\n     dropFn: *const fn(*RefCount) void,\n\n     fn ref(self: *RefCount) void {\n         _ =  self.count.fetchAdd(1, .Monotonic); // no ordering necessary, just updating a counter\n     }\n\n     fn unref(self: *RefCount) void {\n         // Release ensures code before unref() happens-before the count is decremented as dropFn could be called by then.\n         if (self.count.fetchSub(1, .Release)) {\n             // Acquire ensures count decrement and code before previous unrefs()s happens-before we call dropFn below.\n             // NOTE: another alternative is to use .AcqRel on the fetchSub count decrement but it's extra barrier in possibly hot path.\n             self.count.fence(.Acquire);\n             (self.dropFn)(self);\n         }\n     }\n };\n ```",[10840,10841],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,65,0,null,null," Non-atomically load from the atomic value without synchronization.\n Care must be taken to avoid data-races when interacting with other atomic operations.",[10843],false],[0,0,0,"self",null,"",null,false],[78,71,0,null,null," Non-atomically store to the atomic value without synchronization.\n Care must be taken to avoid data-races when interacting with other atomic operations.",[10845,10846],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[78,75,0,null,null,null,[10848,10849],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,83,0,null,null,null,[10851,10852,10853],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,91,0,null,null,null,[10855,10856,10857],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,95,0,null,null,null,[10859,10860,10861,10862,10863],false],[0,0,0,"self",null,"",null,false],[0,0,0,"compare",null,"",null,false],[0,0,0,"exchange",null,"",null,false],[0,0,0,"success",null,"",null,true],[0,0,0,"failure",null,"",null,true],[78,105,0,null,null,null,[10865,10866,10867,10868,10869],false],[0,0,0,"self",null,"",null,false],[0,0,0,"compare",null,"",null,false],[0,0,0,"exchange",null,"",null,false],[0,0,0,"success",null,"",null,true],[0,0,0,"failure",null,"",null,true],[78,115,0,null,null,null,[10871,10872,10873,10874,10875,10876],false],[0,0,0,"self",null,"",null,false],[0,0,0,"is_strong",null,"",null,true],[0,0,0,"compare",null,"",null,false],[0,0,0,"exchange",null,"",null,false],[0,0,0,"success",null,"",null,true],[0,0,0,"failure",null,"",null,true],[78,146,0,null,null,null,[10878,10879,10880,10881],false],[0,0,0,"self",null,"",null,false],[0,0,0,"op",null,"",null,true],[0,0,0,"value",null,"",null,false],[0,0,0,"ordering",null,"",null,true],[78,155,0,null,null,null,[10883,10884],false],[0,0,0,"condition",null,"",null,true],[0,0,0,"functions",null,"",null,true],[78,7,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[78,322,0,null,null,null,[],false],[78,367,0,null,null,null,null,false],[78,399,0,null,null,null,null,false],[75,15,0,null,null,null,[10891],false],[0,0,0,"ordering",null,"",null,true],[75,26,0,null,null,null,[10893],false],[0,0,0,"ordering",null,"",null,true],[75,41,0,null,null," Signals to the processor that the caller is inside a busy-wait spin-loop.",[],false],[75,89,0,null,null," The estimated size of the CPU's cache line when atomically updating memory.\n Add this much padding or align to this boundary to avoid atomically-updated\n memory from forcing cache invalidations on near, but non-atomic, memory.\n",null,false],[1,61,0,null,null," Base64 encoding/decoding.",null,false],[0,0,0,"base64.zig",null,"",[],false],[79,0,0,null,null,null,null,false],[79,1,0,null,null,null,null,false],[79,2,0,null,null,null,null,false],[79,3,0,null,null,null,null,false],[79,5,0,null,null,null,null,false],[79,11,0,null,null,null,[10904],false],[0,0,0,"ignore",null,"",null,false],[79,14,0,null,null," Base64 codecs",[10907,10909,10911,10913,10915],false],[79,14,0,null,null,null,null,false],[0,0,0,"alphabet_chars",null,null,null,false],[79,14,0,null,null,null,null,false],[0,0,0,"pad_char",null,null,null,false],[79,14,0,null,null,null,null,false],[0,0,0,"decoderWithIgnore",null,null,null,false],[79,14,0,null,null,null,null,false],[0,0,0,"Encoder",null,null,null,false],[79,14,0,null,null,null,null,false],[0,0,0,"Decoder",null,null,null,false],[79,22,0,null,null,null,null,false],[79,23,0,null,null,null,[10918],false],[0,0,0,"ignore",null,"",null,false],[79,28,0,null,null," Standard Base64 codecs, with padding",null,false],[79,37,0,null,null," Standard Base64 codecs, without padding",null,false],[79,45,0,null,null,null,null,false],[79,46,0,null,null,null,[10923],false],[0,0,0,"ignore",null,"",null,false],[79,51,0,null,null," URL-safe Base64 codecs, with padding",null,false],[79,60,0,null,null," URL-safe Base64 codecs, without padding",null,false],[79,68,0,null,null,null,[10938,10940],false],[79,73,0,null,null," A bunch of assertions, then simply pass the data right through.",[10928,10929],false],[0,0,0,"alphabet_chars",null,"",null,false],[0,0,0,"pad_char",null,"",null,false],[79,88,0,null,null," Compute the encoded length",[10931,10932],false],[0,0,0,"encoder",null,"",null,false],[0,0,0,"source_len",null,"",null,false],[79,98,0,null,null," dest.len must at least be what you get from ::calcSize.",[10934,10935,10936],false],[0,0,0,"encoder",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"source",null,"",null,false],[79,68,0,null,null,null,null,false],[0,0,0,"alphabet_chars",null,null,null,false],[79,68,0,null,null,null,null,false],[0,0,0,"pad_char",null,null,null,false],[79,130,0,null,null,null,[10957,10959],false],[79,131,0,null,null,null,null,false],[79,138,0,null,null,null,[10944,10945],false],[0,0,0,"alphabet_chars",null,"",null,false],[0,0,0,"pad_char",null,"",null,false],[79,157,0,null,null," Return the maximum possible decoded size for a given input length - The actual length may be less if the input includes padding.\n `InvalidPadding` is returned if the input length is not valid.",[10947,10948],false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"source_len",null,"",null,false],[79,171,0,null,null," Return the exact decoded size for a slice.\n `InvalidPadding` is returned if the input length is not valid.",[10950,10951],false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"source",null,"",null,false],[79,184,0,null,null," dest.len must be what you get from ::calcSize.\n invalid characters result in error.InvalidCharacter.\n invalid padding results in error.InvalidPadding.",[10953,10954,10955],false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"source",null,"",null,false],[79,130,0,null,null,null,null,false],[0,0,0,"char_to_index",null," e.g. 'A' => 0.\n `invalid_char` for any value not in the 64 alphabet chars.",null,false],[79,130,0,null,null,null,null,false],[0,0,0,"pad_char",null,null,null,false],[79,224,0,null,null,null,[10973,10975],false],[79,228,0,null,null,null,[10962,10963,10964],false],[0,0,0,"alphabet_chars",null,"",null,false],[0,0,0,"pad_char",null,"",null,false],[0,0,0,"ignore_chars",null,"",null,false],[79,244,0,null,null," Return the maximum possible decoded size for a given input length - The actual length may be less if the input includes padding\n `InvalidPadding` is returned if the input length is not valid.",[10966,10967],false],[0,0,0,"decoder_with_ignore",null,"",null,false],[0,0,0,"source_len",null,"",null,false],[79,257,0,null,null," Invalid characters that are not ignored result in error.InvalidCharacter.\n Invalid padding results in error.InvalidPadding.\n Decoding more data than can fit in dest results in error.NoSpaceLeft. See also ::calcSizeUpperBound.\n Returns the number of bytes written to dest.",[10969,10970,10971],false],[0,0,0,"decoder_with_ignore",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"source",null,"",null,false],[79,224,0,null,null,null,null,false],[0,0,0,"decoder",null,null,null,false],[79,224,0,null,null,null,null,false],[0,0,0,"char_is_ignored",null,null,null,false],[79,330,0,null,null,null,[],false],[79,366,0,null,null,null,[],false],[79,401,0,null,null,null,[10979,10980,10981],false],[0,0,0,"codecs",null,"",null,false],[0,0,0,"expected_decoded",null,"",null,false],[0,0,0,"expected_encoded",null,"",null,false],[79,428,0,null,null,null,[10983,10984,10985],false],[0,0,0,"codecs",null,"",null,false],[0,0,0,"expected_decoded",null,"",null,false],[0,0,0,"encoded",null,"",null,false],[79,436,0,null,null,null,[10987,10988,10989],false],[0,0,0,"codecs",null,"",null,false],[0,0,0,"encoded",null,"",null,false],[0,0,0,"expected_err",null,"",null,false],[79,451,0,null,null,null,[10991,10992],false],[0,0,0,"codecs",null,"",null,false],[0,0,0,"encoded",null,"",null,false],[1,64,0,null,null," Bit manipulation data structures.",null,false],[0,0,0,"bit_set.zig",null," This file defines several variants of bit sets.  A bit set\n is a densely stored set of integers with a known maximum,\n in which each integer gets a single bit.  Bit sets have very\n fast presence checks, update operations, and union and intersection\n operations.  However, if the number of possible items is very\n large and the number of actual items in a given set is usually\n small, they may be less memory efficient than an array set.\n\n There are five variants defined here:\n\n IntegerBitSet:\n   A bit set with static size, which is backed by a single integer.\n   This set is good for sets with a small size, but may generate\n   inefficient code for larger sets, especially in debug mode.\n\n ArrayBitSet:\n   A bit set with static size, which is backed by an array of usize.\n   This set is good for sets with a larger size, but may use\n   more bytes than necessary if your set is small.\n\n StaticBitSet:\n   Picks either IntegerBitSet or ArrayBitSet depending on the requested\n   size.  The interfaces of these two types match exactly, except for fields.\n\n DynamicBitSet:\n   A bit set with runtime-known size, backed by an allocated slice\n   of usize.\n\n DynamicBitSetUnmanaged:\n   A variant of DynamicBitSet which does not store a pointer to its\n   allocator, in order to save space.\n",[],false],[80,32,0,null,null,null,null,false],[80,33,0,null,null,null,null,false],[80,34,0,null,null,null,null,false],[80,41,0,null,null," Returns the optimal static bit set type for the specified number\n of elements: either `IntegerBitSet` or `ArrayBitSet`,\n both of which fulfill the same interface.\n The returned type will perform no allocations,\n can be copied by value, and does not require deinitialization.",[10999],false],[0,0,0,"size",null,"",null,true],[80,52,0,null,null," A bit set with static size, which is backed by a single integer.\n This set is good for sets with a small size, but may generate\n inefficient code for larger sets, especially in debug mode.",[11001],false],[0,0,0,"size",null,"",[11088],true],[80,54,0,null,null,null,null,false],[80,58,0,null,null," The number of items in this bit set",null,false],[80,61,0,null,null," The integer type used to represent a mask in this bit set",null,false],[80,64,0,null,null," The integer type used to shift a mask in this bit set",null,false],[80,70,0,null,null," Creates a bit set with no elements present.",[],false],[80,75,0,null,null," Creates a bit set with all elements present.",[],false],[80,80,0,null,null," Returns the number of bits in this bit set",[11009],false],[0,0,0,"self",null,"",null,false],[80,87,0,null,null," Returns true if the bit at the specified index\n is present in the set, false otherwise.",[11011,11012],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,93,0,null,null," Returns the total number of set bits in this bit set.",[11014],false],[0,0,0,"self",null,"",null,false],[80,99,0,null,null," Changes the value of the specified bit of the bit\n set to match the passed boolean.",[11016,11017,11018],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,108,0,null,null," Adds a specific bit to the bit set",[11020,11021],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,115,0,null,null," Changes the value of all bits in the specified range to\n match the passed boolean.",[11023,11024,11025],false],[0,0,0,"self",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,139,0,null,null," Removes a specific bit from the bit set",[11027,11028],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,147,0,null,null," Flips a specific bit in the bit set",[11030,11031],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,154,0,null,null," Flips all bits in this bit set which are present\n in the toggles bit set.",[11033,11034],false],[0,0,0,"self",null,"",null,false],[0,0,0,"toggles",null,"",null,false],[80,159,0,null,null," Flips every bit in the bit set.",[11036],false],[0,0,0,"self",null,"",null,false],[80,166,0,null,null," Performs a union of two bit sets, and stores the\n result in the first one.  Bits in the result are\n set if the corresponding bits were set in either input.",[11038,11039],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,173,0,null,null," Performs an intersection of two bit sets, and stores\n the result in the first one.  Bits in the result are\n set if the corresponding bits were set in both inputs.",[11041,11042],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,179,0,null,null," Finds the index of the first set bit.\n If no bits are set, returns null.",[11044],false],[0,0,0,"self",null,"",null,false],[80,187,0,null,null," Finds the index of the first set bit, and unsets it.\n If no bits are set, returns null.",[11046],false],[0,0,0,"self",null,"",null,false],[80,197,0,null,null," Returns true iff every corresponding bit in both\n bit sets are the same.",[11048,11049],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,203,0,null,null," Returns true iff the first bit set is the subset\n of the second one.",[11051,11052],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,209,0,null,null," Returns true iff the first bit set is the superset\n of the second one.",[11054,11055],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,215,0,null,null," Returns the complement bit sets. Bits in the result\n are set if the corresponding bits were not set.",[11057],false],[0,0,0,"self",null,"",null,false],[80,224,0,null,null," Returns the union of two bit sets. Bits in the\n result are set if the corresponding bits were set\n in either input.",[11059,11060],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,233,0,null,null," Returns the intersection of two bit sets. Bits in\n the result are set if the corresponding bits were\n set in both inputs.",[11062,11063],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,242,0,null,null," Returns the xor of two bit sets. Bits in the\n result are set if the corresponding bits were\n not the same in both inputs.",[11065,11066],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,251,0,null,null," Returns the difference of two bit sets. Bits in\n the result are set if set in the first but not\n set in the second set.",[11068,11069],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,261,0,null,null," Iterates through the items in the set, according to the options.\n The default options (.{}) will iterate indices of set bits in\n ascending order.  Modifications to the underlying bit set may\n or may not be observed by the iterator.",[11071,11072],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,true],[80,270,0,null,null,null,[11074],false],[0,0,0,"options",null,"",null,true],[80,274,0,null,null,null,[11076],false],[0,0,0,"direction",null,"",[11081],true],[80,276,0,null,null,null,null,false],[80,282,0,null,null," Returns the index of the next unvisited set bit\n in the bit set, in ascending order.",[11079],false],[0,0,0,"self",null,"",null,false],[80,275,0,null,null,null,null,false],[0,0,0,"bits_remain",null,null,null,false],[80,302,0,null,null,null,[11083],false],[0,0,0,"index",null,"",null,false],[80,306,0,null,null,null,[11085,11086],false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,53,0,null,null,null,null,false],[0,0,0,"mask",null," The bit mask, as a single integer",null,false],[80,316,0,null,null," A bit set with static size, which is backed by an array of usize.\n This set is good for sets with a larger size, but may use\n more bytes than necessary if your set is small.",[11090,11091],false],[0,0,0,"MaskIntType",null,"",null,true],[0,0,0,"size",null,"",[11177],true],[80,353,0,null,null,null,null,false],[80,357,0,null,null," The number of items in this bit set",null,false],[80,360,0,null,null," The integer type used to represent a mask in this bit set",null,false],[80,363,0,null,null," The integer type used to shift a mask in this bit set",null,false],[80,366,0,null,null,null,null,false],[80,368,0,null,null,null,null,false],[80,370,0,null,null,null,null,false],[80,374,0,null,null,null,null,false],[80,381,0,null,null," Creates a bit set with no elements present.",[],false],[80,386,0,null,null," Creates a bit set with all elements present.",[],false],[80,395,0,null,null," Returns the number of bits in this bit set",[11103],false],[0,0,0,"self",null,"",null,false],[80,402,0,null,null," Returns true if the bit at the specified index\n is present in the set, false otherwise.",[11105,11106],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,409,0,null,null," Returns the total number of set bits in this bit set.",[11108],false],[0,0,0,"self",null,"",null,false],[80,419,0,null,null," Changes the value of the specified bit of the bit\n set to match the passed boolean.",[11110,11111,11112],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,429,0,null,null," Adds a specific bit to the bit set",[11114,11115],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,437,0,null,null," Changes the value of all bits in the specified range to\n match the passed boolean.",[11117,11118,11119],false],[0,0,0,"self",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,481,0,null,null," Removes a specific bit from the bit set",[11121,11122],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,488,0,null,null," Flips a specific bit in the bit set",[11124,11125],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,496,0,null,null," Flips all bits in this bit set which are present\n in the toggles bit set.",[11127,11128],false],[0,0,0,"self",null,"",null,false],[0,0,0,"toggles",null,"",null,false],[80,503,0,null,null," Flips every bit in the bit set.",[11130],false],[0,0,0,"self",null,"",null,false],[80,517,0,null,null," Performs a union of two bit sets, and stores the\n result in the first one.  Bits in the result are\n set if the corresponding bits were set in either input.",[11132,11133],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,526,0,null,null," Performs an intersection of two bit sets, and stores\n the result in the first one.  Bits in the result are\n set if the corresponding bits were set in both inputs.",[11135,11136],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,534,0,null,null," Finds the index of the first set bit.\n If no bits are set, returns null.",[11138],false],[0,0,0,"self",null,"",null,false],[80,545,0,null,null," Finds the index of the first set bit, and unsets it.\n If no bits are set, returns null.",[11140],false],[0,0,0,"self",null,"",null,false],[80,558,0,null,null," Returns true iff every corresponding bit in both\n bit sets are the same.",[11142,11143],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,569,0,null,null," Returns true iff the first bit set is the subset\n of the second one.",[11145,11146],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,575,0,null,null," Returns true iff the first bit set is the superset\n of the second one.",[11148,11149],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,581,0,null,null," Returns the complement bit sets. Bits in the result\n are set if the corresponding bits were not set.",[11151],false],[0,0,0,"self",null,"",null,false],[80,590,0,null,null," Returns the union of two bit sets. Bits in the\n result are set if the corresponding bits were set\n in either input.",[11153,11154],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,599,0,null,null," Returns the intersection of two bit sets. Bits in\n the result are set if the corresponding bits were\n set in both inputs.",[11156,11157],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,608,0,null,null," Returns the xor of two bit sets. Bits in the\n result are set if the corresponding bits were\n not the same in both inputs.",[11159,11160],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,617,0,null,null," Returns the difference of two bit sets. Bits in\n the result are set if set in the first but not\n set in the second set.",[11162,11163],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,627,0,null,null," Iterates through the items in the set, according to the options.\n The default options (.{}) will iterate indices of set bits in\n ascending order.  Modifications to the underlying bit set may\n or may not be observed by the iterator.",[11165,11166],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,true],[80,631,0,null,null,null,[11168],false],[0,0,0,"options",null,"",null,true],[80,635,0,null,null,null,[11170],false],[0,0,0,"index",null,"",null,false],[80,638,0,null,null,null,[11172],false],[0,0,0,"index",null,"",null,false],[80,641,0,null,null,null,[11174,11175],false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,352,0,null,null,null,null,false],[0,0,0,"masks",null," The bit masks, ordered with lower indices first.\n Padding bits at the end are undefined.",null,false],[80,649,0,null,null," A bit set with runtime-known size, backed by an allocated slice\n of usize.  The allocator must be tracked externally by the user.",[11263,11265],false],[80,650,0,null,null,null,null,false],[80,653,0,null,null," The integer type used to represent a mask in this bit set",null,false],[80,656,0,null,null," The integer type used to shift a mask in this bit set",null,false],[80,673,0,null,null,null,null,false],[80,674,0,null,null,null,null,false],[80,678,0,null,null," Creates a bit set with no elements present.\n If bit_length is not zero, deinit must eventually be called.",[11185,11186],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"bit_length",null,"",null,false],[80,686,0,null,null," Creates a bit set with all elements present.\n If bit_length is not zero, deinit must eventually be called.",[11188,11189],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"bit_length",null,"",null,false],[80,695,0,null,null," Resizes to a new bit_length.  If the new length is larger\n than the old length, fills any added bits with `fill`.\n If new_len is not zero, deinit must eventually be called.",[11191,11192,11193,11194],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"fill",null,"",null,false],[80,758,0,null,null," deinitializes the array and releases its memory.\n The passed allocator must be the same one used for\n init* or resize in the past.",[11196,11197],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[80,763,0,null,null," Creates a duplicate of this bit set, using the new allocator.",[11199,11200],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_allocator",null,"",null,false],[80,772,0,null,null," Returns the number of bits in this bit set",[11202],false],[0,0,0,"self",null,"",null,false],[80,778,0,null,null," Returns true if the bit at the specified index\n is present in the set, false otherwise.",[11204,11205],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,784,0,null,null," Returns the total number of set bits in this bit set.",[11207],false],[0,0,0,"self",null,"",null,false],[80,796,0,null,null," Changes the value of the specified bit of the bit\n set to match the passed boolean.",[11209,11210,11211],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,805,0,null,null," Adds a specific bit to the bit set",[11213,11214],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,812,0,null,null," Changes the value of all bits in the specified range to\n match the passed boolean.",[11216,11217,11218],false],[0,0,0,"self",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,855,0,null,null," Removes a specific bit from the bit set",[11220,11221],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,861,0,null,null," Flips a specific bit in the bit set",[11223,11224],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,869,0,null,null," Flips all bits in this bit set which are present\n in the toggles bit set.  Both sets must have the\n same bit_length.",[11226,11227],false],[0,0,0,"self",null,"",null,false],[0,0,0,"toggles",null,"",null,false],[80,878,0,null,null," Flips every bit in the bit set.",[11229],false],[0,0,0,"self",null,"",null,false],[80,897,0,null,null," Performs a union of two bit sets, and stores the\n result in the first one.  Bits in the result are\n set if the corresponding bits were set in either input.\n The two sets must both be the same bit_length.",[11231,11232],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,909,0,null,null," Performs an intersection of two bit sets, and stores\n the result in the first one.  Bits in the result are\n set if the corresponding bits were set in both inputs.\n The two sets must both be the same bit_length.",[11234,11235],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,919,0,null,null," Finds the index of the first set bit.\n If no bits are set, returns null.",[11237],false],[0,0,0,"self",null,"",null,false],[80,932,0,null,null," Finds the index of the first set bit, and unsets it.\n If no bits are set, returns null.",[11239],false],[0,0,0,"self",null,"",null,false],[80,947,0,null,null," Returns true iff every corresponding bit in both\n bit sets are the same.",[11241,11242],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,962,0,null,null," Returns true iff the first bit set is the subset\n of the second one.",[11244,11245],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,977,0,null,null," Returns true iff the first bit set is the superset\n of the second one.",[11247,11248],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,995,0,null,null," Iterates through the items in the set, according to the options.\n The default options (.{}) will iterate indices of set bits in\n ascending order.  Modifications to the underlying bit set may\n or may not be observed by the iterator.  Resizing the underlying\n bit set invalidates the iterator.",[11250,11251],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,true],[80,1002,0,null,null,null,[11253],false],[0,0,0,"options",null,"",null,true],[80,1006,0,null,null,null,[11255],false],[0,0,0,"index",null,"",null,false],[80,1009,0,null,null,null,[11257],false],[0,0,0,"index",null,"",null,false],[80,1012,0,null,null,null,[11259,11260],false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,1015,0,null,null,null,[11262],false],[0,0,0,"bit_length",null,"",null,false],[0,0,0,"bit_length",null," The number of valid items in this bit set",null,false],[80,649,0,null,null,null,null,false],[0,0,0,"masks",null," The bit masks, ordered with lower indices first.\n Padding bits at the end must be zeroed.",null,false],[80,1023,0,null,null," A bit set with runtime-known size, backed by an allocated slice\n of usize.  Thin wrapper around DynamicBitSetUnmanaged which keeps\n track of the allocator instance.",[11332,11334],false],[80,1024,0,null,null,null,null,false],[80,1027,0,null,null," The integer type used to represent a mask in this bit set",null,false],[80,1030,0,null,null," The integer type used to shift a mask in this bit set",null,false],[80,1039,0,null,null," Creates a bit set with no elements present.",[11271,11272],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"bit_length",null,"",null,false],[80,1047,0,null,null," Creates a bit set with all elements present.",[11274,11275],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"bit_length",null,"",null,false],[80,1056,0,null,null," Resizes to a new length.  If the new length is larger\n than the old length, fills any added bits with `fill`.",[11277,11278,11279],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"fill",null,"",null,false],[80,1063,0,null,null," deinitializes the array and releases its memory.\n The passed allocator must be the same one used for\n init* or resize in the past.",[11281],false],[0,0,0,"self",null,"",null,false],[80,1068,0,null,null," Creates a duplicate of this bit set, using the new allocator.",[11283,11284],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_allocator",null,"",null,false],[80,1076,0,null,null," Returns the number of bits in this bit set",[11286],false],[0,0,0,"self",null,"",null,false],[80,1082,0,null,null," Returns true if the bit at the specified index\n is present in the set, false otherwise.",[11288,11289],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,1087,0,null,null," Returns the total number of set bits in this bit set.",[11291],false],[0,0,0,"self",null,"",null,false],[80,1093,0,null,null," Changes the value of the specified bit of the bit\n set to match the passed boolean.",[11293,11294,11295],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,1098,0,null,null," Adds a specific bit to the bit set",[11297,11298],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,1104,0,null,null," Changes the value of all bits in the specified range to\n match the passed boolean.",[11300,11301,11302],false],[0,0,0,"self",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"value",null,"",null,false],[80,1109,0,null,null," Removes a specific bit from the bit set",[11304,11305],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,1114,0,null,null," Flips a specific bit in the bit set",[11307,11308],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[80,1121,0,null,null," Flips all bits in this bit set which are present\n in the toggles bit set.  Both sets must have the\n same bit_length.",[11310,11311],false],[0,0,0,"self",null,"",null,false],[0,0,0,"toggles",null,"",null,false],[80,1126,0,null,null," Flips every bit in the bit set.",[11313],false],[0,0,0,"self",null,"",null,false],[80,1134,0,null,null," Performs a union of two bit sets, and stores the\n result in the first one.  Bits in the result are\n set if the corresponding bits were set in either input.\n The two sets must both be the same bit_length.",[11315,11316],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,1142,0,null,null," Performs an intersection of two bit sets, and stores\n the result in the first one.  Bits in the result are\n set if the corresponding bits were set in both inputs.\n The two sets must both be the same bit_length.",[11318,11319],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,1148,0,null,null," Finds the index of the first set bit.\n If no bits are set, returns null.",[11321],false],[0,0,0,"self",null,"",null,false],[80,1154,0,null,null," Finds the index of the first set bit, and unsets it.\n If no bits are set, returns null.",[11323],false],[0,0,0,"self",null,"",null,false],[80,1160,0,null,null," Returns true iff every corresponding bit in both\n bit sets are the same.",[11325,11326],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[80,1169,0,null,null," Iterates through the items in the set, according to the options.\n The default options (.{}) will iterate indices of set bits in\n ascending order.  Modifications to the underlying bit set may\n or may not be observed by the iterator.  Resizing the underlying\n bit set invalidates the iterator.",[11328,11329],false],[0,0,0,"self",null,"",null,false],[0,0,0,"options",null,"",null,true],[80,1173,0,null,null,null,null,false],[80,1023,0,null,null,null,null,false],[0,0,0,"allocator",null," The allocator used by this bit set",null,false],[80,1023,0,null,null,null,null,false],[0,0,0,"unmanaged",null," The number of valid items in this bit set",null,false],[80,1177,0,null,null," Options for configuring an iterator over a bit set",[11343,11345],false],[80,1183,0,null,null,null,[11337,11338],false],[0,0,0,"set",null," visit indexes of set bits",null,false],[0,0,0,"unset",null," visit indexes of unset bits",null,false],[80,1190,0,null,null,null,[11340,11341],false],[0,0,0,"forward",null," visit indices in ascending order",null,false],[0,0,0,"reverse",null," visit indices in descending order.\n Note that this may be slightly more expensive than forward iteration.",null,false],[80,1177,0,null,null,null,null,false],[0,0,0,"kind",null," determines which bits should be visited",null,false],[80,1177,0,null,null,null,null,false],[0,0,0,"direction",null," determines the order in which bit indices should be visited",null,false],[80,1200,0,null,null,null,[11347,11348],false],[0,0,0,"MaskInt",null,"",null,true],[0,0,0,"options",null,"",[11359,11361,11362,11364],true],[80,1205,0,null,null,null,null,false],[80,1216,0,null,null,null,[11351,11352],false],[0,0,0,"masks",null,"",null,false],[0,0,0,"last_word_mask",null,"",null,false],[80,1238,0,null,null," Returns the index of the next unvisited set bit\n in the bit set, in ascending order.",[11354],false],[0,0,0,"self",null,"",null,false],[80,1268,0,null,null,null,[11356,11357],false],[0,0,0,"self",null,"",null,false],[0,0,0,"is_first_word",null,"",null,true],[80,1204,0,null,null,null,null,false],[0,0,0,"bits_remain",null,null,null,false],[80,1204,0,null,null,null,null,false],[0,0,0,"words_remain",null,null,null,false],[0,0,0,"bit_offset",null,null,null,false],[80,1204,0,null,null,null,null,false],[0,0,0,"last_word_mask",null,null,null,false],[80,1294,0,null,null," A range of indices within a bitset.",[11366,11367],false],[0,0,0,"start",null," The index of the first bit of interest.",null,false],[0,0,0,"end",null," The index immediately after the last bit of interest.",null,false],[80,1303,0,null,null,null,null,false],[80,1305,0,null,null,null,[11370,11371,11372],false],[0,0,0,"empty",null,"",null,false],[0,0,0,"full",null,"",null,false],[0,0,0,"len",null,"",null,false],[80,1320,0,null,null,null,[11374,11375,11376,11377,11378],false],[0,0,0,"empty",null,"",null,false],[0,0,0,"full",null,"",null,false],[0,0,0,"even",null,"",null,false],[0,0,0,"odd",null,"",null,false],[0,0,0,"len",null,"",null,false],[80,1340,0,null,null,null,[11380,11381,11382,11383,11384],false],[0,0,0,"empty",null,"",null,false],[0,0,0,"full",null,"",null,false],[0,0,0,"even",null,"",null,false],[0,0,0,"odd",null,"",null,false],[0,0,0,"len",null,"",null,false],[80,1360,0,null,null,null,[11386,11387,11388],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"len",null,"",null,false],[80,1558,0,null,null,null,[11390,11391],false],[0,0,0,"set",null,"",null,false],[0,0,0,"len",null,"",null,false],[80,1565,0,null,null,null,[11393,11394],false],[0,0,0,"set",null,"",null,false],[0,0,0,"len",null,"",null,false],[80,1572,0,null,null,null,[11396],false],[0,0,0,"Set",null,"",null,true],[80,1625,0,null,null,null,[11398],false],[0,0,0,"Set",null,"",null,true],[1,67,0,null,null," Comptime-available information about the build environment, such as the target and optimize mode.",null,false],[0,0,0,"builtin.zig",null,"",[],false],[81,0,0,null,null,null,null,false],[81,6,0,null,null," `explicit_subsystem` is missing when the subsystem is automatically detected,\n so Zig standard library has the subsystem detection logic here. This should generally be\n used rather than `explicit_subsystem`.\n On non-Windows targets, this is `null`.",null,false],[81,30,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11409,11411],false],[81,34,0,null,null,null,[11405,11406,11407,11408],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"index",null,null,null,false],[81,30,0,null,null,null,null,false],[0,0,0,"instruction_addresses",null,null,null,false],[81,63,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11413,11414,11415,11416],false],[0,0,0,"Internal",null,null,null,false],[0,0,0,"Strong",null,null,null,false],[0,0,0,"Weak",null,null,null,false],[0,0,0,"LinkOnce",null,null,null,false],[81,72,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11418,11419,11420],false],[0,0,0,"default",null,null,null,false],[0,0,0,"hidden",null,null,null,false],[0,0,0,"protected",null,null,null,false],[81,80,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11422,11423,11424,11425,11426,11427],false],[0,0,0,"Unordered",null,null,null,false],[0,0,0,"Monotonic",null,null,null,false],[0,0,0,"Acquire",null,null,null,false],[0,0,0,"Release",null,null,null,false],[0,0,0,"AcqRel",null,null,null,false],[0,0,0,"SeqCst",null,null,null,false],[81,91,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11429,11430,11431,11432,11433,11434,11435],false],[0,0,0,"And",null,null,null,false],[0,0,0,"Or",null,null,null,false],[0,0,0,"Xor",null,null,null,false],[0,0,0,"Min",null,null,null,false],[0,0,0,"Max",null,null,null,false],[0,0,0,"Add",null,null,null,false],[0,0,0,"Mul",null,null,null,false],[81,103,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11437,11438,11439,11440,11441,11442,11443,11444,11445],false],[0,0,0,"Xchg",null,null,null,false],[0,0,0,"Add",null,null,null,false],[0,0,0,"Sub",null,null,null,false],[0,0,0,"And",null,null,null,false],[0,0,0,"Nand",null,null,null,false],[0,0,0,"Or",null,null,null,false],[0,0,0,"Xor",null,null,null,false],[0,0,0,"Max",null,null,null,false],[0,0,0,"Min",null,null,null,false],[81,121,0,null,null," The code model puts constraints on the location of symbols and the size of code and data.\n The selection of a code model is a trade off on speed and restrictions that needs to be selected on a per application basis to meet its requirements.\n A slightly more detailed explanation can be found in (for example) the [System V Application Binary Interface (x86_64)](https://github.com/hjl-tools/x86-psABI/wiki/x86-64-psABI-1.0.pdf) 3.5.1.\n\n This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11447,11448,11449,11450,11451,11452],false],[0,0,0,"default",null,null,null,false],[0,0,0,"tiny",null,null,null,false],[0,0,0,"small",null,null,null,false],[0,0,0,"kernel",null,null,null,false],[0,0,0,"medium",null,null,null,false],[0,0,0,"large",null,null,null,false],[81,132,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11454,11455,11456,11457],false],[0,0,0,"Debug",null,null,null,false],[0,0,0,"ReleaseSafe",null,null,null,false],[0,0,0,"ReleaseFast",null,null,null,false],[0,0,0,"ReleaseSmall",null,null,null,false],[81,140,0,null,null," Deprecated; use OptimizeMode.",null,false],[81,144,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11460,11461,11462,11463,11464,11465,11466,11467,11468,11469,11470,11471,11472,11473,11474,11475,11476],false],[0,0,0,"Unspecified",null," This is the default Zig calling convention used when not using `export` on `fn`\n and no other calling convention is specified.",null,false],[0,0,0,"C",null," Matches the C ABI for the target.\n This is the default calling convention when using `export` on `fn`\n and no other calling convention is specified.",null,false],[0,0,0,"Naked",null," This makes a function not have any function prologue or epilogue,\n making the function itself uncallable in regular Zig code.\n This can be useful when integrating with assembly.",null,false],[0,0,0,"Async",null," Functions with this calling convention are called asynchronously,\n as if called as `async function()`.",null,false],[0,0,0,"Inline",null," Functions with this calling convention are inlined at all call sites.",null,false],[0,0,0,"Interrupt",null," x86-only.",null,false],[0,0,0,"Signal",null,null,null,false],[0,0,0,"Stdcall",null," x86-only.",null,false],[0,0,0,"Fastcall",null," x86-only.",null,false],[0,0,0,"Vectorcall",null," x86-only.",null,false],[0,0,0,"Thiscall",null," x86-only.",null,false],[0,0,0,"APCS",null," ARM Procedure Call Standard (obsolete)\n ARM-only.",null,false],[0,0,0,"AAPCS",null," ARM Architecture Procedure Call Standard (current standard)\n ARM-only.",null,false],[0,0,0,"AAPCSVFP",null," ARM Architecture Procedure Call Standard Vector Floating-Point\n ARM-only.",null,false],[0,0,0,"SysV",null," x86-64-only.",null,false],[0,0,0,"Win64",null," x86-64-only.",null,false],[0,0,0,"Kernel",null," AMD GPU, NVPTX, or SPIR-V kernel",null,false],[81,191,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11478,11479,11480,11481,11482,11483,11484,11485,11486,11487,11488,11489,11490,11491,11492],false],[0,0,0,"generic",null,null,null,false],[0,0,0,"gs",null,null,null,false],[0,0,0,"fs",null,null,null,false],[0,0,0,"ss",null,null,null,false],[0,0,0,"global",null,null,null,false],[0,0,0,"constant",null,null,null,false],[0,0,0,"param",null,null,null,false],[0,0,0,"shared",null,null,null,false],[0,0,0,"local",null,null,null,false],[0,0,0,"flash",null,null,null,false],[0,0,0,"flash1",null,null,null,false],[0,0,0,"flash2",null,null,null,false],[0,0,0,"flash3",null,null,null,false],[0,0,0,"flash4",null,null,null,false],[0,0,0,"flash5",null,null,null,false],[81,216,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11495,11497,11498,11499],false],[81,216,0,null,null,null,null,false],[0,0,0,"file",null,null,null,false],[81,216,0,null,null,null,null,false],[0,0,0,"fn_name",null,null,null,false],[0,0,0,"line",null,null,null,false],[0,0,0,"column",null,null,null,false],[81,223,0,null,null,null,null,false],[81,227,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11616,11617,11618,11619,11620,11621,11622,11623,11624,11625,11626,11627,11628,11629,11630,11631,11632,11633,11634,11635,11636,11637,11638,11639],false],[81,255,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11504,11505],false],[81,255,0,null,null,null,null,false],[0,0,0,"signedness",null,null,null,false],[0,0,0,"bits",null,null,null,false],[81,262,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11507],false],[0,0,0,"bits",null,null,null,false],[81,268,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11515,11516,11517,11518,11520,11521,11522,11524],false],[81,285,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11510,11511,11512,11513],false],[0,0,0,"One",null,null,null,false],[0,0,0,"Many",null,null,null,false],[0,0,0,"Slice",null,null,null,false],[0,0,0,"C",null,null,null,false],[81,268,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"is_const",null,null,null,false],[0,0,0,"is_volatile",null,null,null,false],[0,0,0,"alignment",null," TODO make this u16 instead of comptime_int",null,false],[81,268,0,null,null,null,null,false],[0,0,0,"address_space",null,null,null,false],[0,0,0,"child",null,null,null,false],[0,0,0,"is_allowzero",null,null,null,false],[81,268,0,null,null,null,null,false],[0,0,0,"sentinel",null," The type of the sentinel is the element type of the pointer, which is\n the value of the `child` field in this struct. However there is no way\n to refer to that type here, so we use pointer to `anyopaque`.",null,false],[81,295,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11526,11527,11529],false],[0,0,0,"len",null,null,null,false],[0,0,0,"child",null,null,null,false],[81,295,0,null,null,null,null,false],[0,0,0,"sentinel",null," The type of the sentinel is the element type of the array, which is\n the value of the `child` field in this struct. However there is no way\n to refer to that type here, so we use pointer to `anyopaque`.",null,false],[81,307,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11531,11532,11533],false],[0,0,0,"Auto",null,null,null,false],[0,0,0,"Extern",null,null,null,false],[0,0,0,"Packed",null,null,null,false],[81,315,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11536,11537,11539,11540,11541],false],[81,315,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"type",null,null,null,false],[81,315,0,null,null,null,null,false],[0,0,0,"default_value",null,null,null,false],[0,0,0,"is_comptime",null,null,null,false],[0,0,0,"alignment",null,null,null,false],[81,325,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11544,11546,11548,11550,11551],false],[81,325,0,null,null,null,null,false],[0,0,0,"layout",null,null,null,false],[81,325,0,null,null,null,null,false],[0,0,0,"backing_integer",null," Only valid if layout is .Packed",null,false],[81,325,0,null,null,null,null,false],[0,0,0,"fields",null,null,null,false],[81,325,0,null,null,null,null,false],[0,0,0,"decls",null,null,null,false],[0,0,0,"is_tuple",null,null,null,false],[81,336,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11553],false],[0,0,0,"child",null,null,null,false],[81,342,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11555,11556],false],[0,0,0,"error_set",null,null,null,false],[0,0,0,"payload",null,null,null,false],[81,349,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11559],false],[81,349,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[81,355,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",null,false],[81,359,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11563,11564],false],[81,359,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"value",null,null,null,false],[81,366,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11566,11568,11570,11571],false],[0,0,0,"tag_type",null,null,null,false],[81,366,0,null,null,null,null,false],[0,0,0,"fields",null,null,null,false],[81,366,0,null,null,null,null,false],[0,0,0,"decls",null,null,null,false],[0,0,0,"is_exhaustive",null,null,null,false],[81,375,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11574,11575,11576],false],[81,375,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"type",null,null,null,false],[0,0,0,"alignment",null,null,null,false],[81,383,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11579,11581,11583,11585],false],[81,383,0,null,null,null,null,false],[0,0,0,"layout",null,null,null,false],[81,383,0,null,null,null,null,false],[0,0,0,"tag_type",null,null,null,false],[81,383,0,null,null,null,null,false],[0,0,0,"fields",null,null,null,false],[81,383,0,null,null,null,null,false],[0,0,0,"decls",null,null,null,false],[81,392,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11593,11594,11595,11596,11598,11600],false],[81,403,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11588,11589,11591],false],[0,0,0,"is_generic",null,null,null,false],[0,0,0,"is_noalias",null,null,null,false],[81,403,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[81,392,0,null,null,null,null,false],[0,0,0,"calling_convention",null,null,null,false],[0,0,0,"alignment",null,null,null,false],[0,0,0,"is_generic",null,null,null,false],[0,0,0,"is_var_args",null,null,null,false],[81,392,0,null,null,null,null,false],[0,0,0,"return_type",null," TODO change the language spec to make this not optional.",null,false],[81,392,0,null,null,null,null,false],[0,0,0,"params",null,null,null,false],[81,412,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11603],false],[81,412,0,null,null,null,null,false],[0,0,0,"decls",null,null,null,false],[81,418,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11606],false],[81,418,0,null,null,null,null,false],[0,0,0,"function",null,null,null,false],[81,424,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11609],false],[81,424,0,null,null,null,null,false],[0,0,0,"child",null,null,null,false],[81,430,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11611,11612],false],[0,0,0,"len",null,null,null,false],[0,0,0,"child",null,null,null,false],[81,437,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11615],false],[81,437,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"Type",null,null,null,false],[0,0,0,"Void",null,null,null,false],[0,0,0,"Bool",null,null,null,false],[0,0,0,"NoReturn",null,null,null,false],[0,0,0,"Int",null,null,null,false],[0,0,0,"Float",null,null,null,false],[0,0,0,"Pointer",null,null,null,false],[0,0,0,"Array",null,null,null,false],[0,0,0,"Struct",null,null,null,false],[0,0,0,"ComptimeFloat",null,null,null,false],[0,0,0,"ComptimeInt",null,null,null,false],[0,0,0,"Undefined",null,null,null,false],[0,0,0,"Null",null,null,null,false],[0,0,0,"Optional",null,null,null,false],[0,0,0,"ErrorUnion",null,null,null,false],[0,0,0,"ErrorSet",null,null,null,false],[0,0,0,"Enum",null,null,null,false],[0,0,0,"Union",null,null,null,false],[0,0,0,"Fn",null,null,null,false],[0,0,0,"Opaque",null,null,null,false],[0,0,0,"Frame",null,null,null,false],[0,0,0,"AnyFrame",null,null,null,false],[0,0,0,"Vector",null,null,null,false],[0,0,0,"EnumLiteral",null,null,null,false],[81,444,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11641,11642],false],[0,0,0,"Strict",null,null,null,false],[0,0,0,"Optimized",null,null,null,false],[81,451,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11644,11645],false],[0,0,0,"Big",null,null,null,false],[0,0,0,"Little",null,null,null,false],[81,458,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11647,11648],false],[0,0,0,"signed",null,null,null,false],[0,0,0,"unsigned",null,null,null,false],[81,465,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11650,11651,11652],false],[0,0,0,"Exe",null,null,null,false],[0,0,0,"Lib",null,null,null,false],[0,0,0,"Obj",null,null,null,false],[81,473,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11654,11655],false],[0,0,0,"Static",null,null,null,false],[0,0,0,"Dynamic",null,null,null,false],[81,480,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11657,11658],false],[0,0,0,"command",null,null,null,false],[0,0,0,"reactor",null,null,null,false],[81,487,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11660,11661,11662,11663,11664,11665,11666,11667],false],[0,0,0,"auto",null," Equivalent to function call syntax.",null,false],[0,0,0,"async_kw",null," Equivalent to async keyword used with function call syntax.",null,false],[0,0,0,"never_tail",null," Prevents tail call optimization. This guarantees that the return\n address will point to the callsite, as opposed to the callsite's\n callsite. If the call is otherwise required to be tail-called\n or inlined, a compile error is emitted instead.",null,false],[0,0,0,"never_inline",null," Guarantees that the call will not be inlined. If the call is\n otherwise required to be inlined, a compile error is emitted instead.",null,false],[0,0,0,"no_async",null," Asserts that the function call will not suspend. This allows a\n non-async function to call an async function.",null,false],[0,0,0,"always_tail",null," Guarantees that the call will be generated with tail call optimization.\n If this is not possible, a compile error is emitted instead.",null,false],[0,0,0,"always_inline",null," Guarantees that the call will be inlined at the callsite.\n If this is not possible, a compile error is emitted instead.",null,false],[0,0,0,"compile_time",null," Evaluates the call at compile-time. If the call cannot be completed at\n compile-time, a compile error is emitted instead.",null,false],[81,523,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11670,11672,11674,11675,11676],false],[81,523,0,null,null,null,null,false],[0,0,0,"__stack",null,null,null,false],[81,523,0,null,null,null,null,false],[0,0,0,"__gr_top",null,null,null,false],[81,523,0,null,null,null,null,false],[0,0,0,"__vr_top",null,null,null,false],[0,0,0,"__gr_offs",null,null,null,false],[0,0,0,"__vr_offs",null,null,null,false],[81,533,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11678,11679,11681,11683],false],[0,0,0,"__gpr",null,null,null,false],[0,0,0,"__fpr",null,null,null,false],[81,533,0,null,null,null,null,false],[0,0,0,"__overflow_arg_area",null,null,null,false],[81,533,0,null,null,null,null,false],[0,0,0,"__reg_save_area",null,null,null,false],[81,542,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11685,11686,11687,11689,11691],false],[0,0,0,"gpr",null,null,null,false],[0,0,0,"fpr",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[81,542,0,null,null,null,null,false],[0,0,0,"overflow_arg_area",null,null,null,false],[81,542,0,null,null,null,null,false],[0,0,0,"reg_save_area",null,null,null,false],[81,552,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11694,11696,11698],false],[81,552,0,null,null,null,null,false],[0,0,0,"__current_saved_reg_area_pointer",null,null,null,false],[81,552,0,null,null,null,null,false],[0,0,0,"__saved_reg_area_end_pointer",null,null,null,false],[81,552,0,null,null,null,null,false],[0,0,0,"__overflow_area_pointer",null,null,null,false],[81,560,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11700,11701,11703,11705],false],[0,0,0,"gp_offset",null,null,null,false],[0,0,0,"fp_offset",null,null,null,false],[81,560,0,null,null,null,null,false],[0,0,0,"overflow_arg_area",null,null,null,false],[81,560,0,null,null,null,null,false],[0,0,0,"reg_save_area",null,null,null,false],[81,569,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",null,false],[81,604,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11715,11717,11719],false],[81,618,0,null,null,null,[11709,11710],false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[81,623,0,null,null,null,[11712,11713],false],[0,0,0,"instruction",null,null,null,false],[0,0,0,"data",null,null,null,false],[81,604,0,null,null,null,null,false],[0,0,0,"rw",null," Whether the prefetch should prepare for a read or a write.",null,false],[81,604,0,null,null,null,null,false],[0,0,0,"locality",null," The data's locality in an inclusive range from 0 to 3.\n\n 0 means no temporal locality. That is, the data can be immediately\n dropped from the cache after it is accessed.\n\n 3 means high temporal locality. That is, the data should be kept in\n the cache as it is likely to be accessed again soon.",null,false],[81,604,0,null,null,null,null,false],[0,0,0,"cache",null," The cache that the prefetch should be performed on.",null,false],[81,631,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11722,11724,11726,11728],false],[81,631,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[81,631,0,null,null,null,null,false],[0,0,0,"linkage",null,null,null,false],[81,631,0,null,null,null,null,false],[0,0,0,"section",null,null,null,false],[81,631,0,null,null,null,null,false],[0,0,0,"visibility",null,null,null,false],[81,640,0,null,null," This data structure is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11731,11733,11735,11736],false],[81,640,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[81,640,0,null,null,null,null,false],[0,0,0,"library_name",null,null,null,false],[81,640,0,null,null,null,null,false],[0,0,0,"linkage",null,null,null,false],[0,0,0,"is_thread_local",null,null,null,false],[81,664,0,null,null," This enum is set by the compiler and communicates which compiler backend is\n used to produce machine code.\n Think carefully before deciding to observe this value. Nearly all code should\n be agnostic to the backend that implements the language. The use case\n to use this value is to **work around problems with compiler implementations.**\n\n Avoid failing the compilation if the compiler backend does not match a\n whitelist of backends; rather one should detect that a known problem would\n occur in a blacklist of backends.\n\n The enum is nonexhaustive so that alternate Zig language implementations may\n choose a number as their tag (please use a random number generator rather\n than a \"cute\" number) and codebases can interact with these values even if\n this upstream enum does not have a name for the number. Of course, upstream\n is happy to accept pull requests to add Zig implementations to this enum.\n\n This data structure is part of the Zig language specification.",[11738,11739,11740,11741,11742,11743,11744,11745,11746,11747,11748,11749],false],[0,0,0,"other",null," It is allowed for a compiler implementation to not reveal its identity,\n in which case this value is appropriate. Be cool and make sure your\n code supports `other` Zig compilers!",null,false],[0,0,0,"stage1",null," The original Zig compiler created in 2015 by Andrew Kelley. Implemented\n in C++. Used LLVM. Deleted from the ZSF ziglang/zig codebase on\n December 6th, 2022.",null,false],[0,0,0,"stage2_llvm",null," The reference implementation self-hosted compiler of Zig, using the\n LLVM backend.",null,false],[0,0,0,"stage2_c",null," The reference implementation self-hosted compiler of Zig, using the\n backend that generates C source code.\n Note that one can observe whether the compilation will output C code\n directly with `object_format` value rather than the `compiler_backend` value.",null,false],[0,0,0,"stage2_wasm",null," The reference implementation self-hosted compiler of Zig, using the\n WebAssembly backend.",null,false],[0,0,0,"stage2_arm",null," The reference implementation self-hosted compiler of Zig, using the\n arm backend.",null,false],[0,0,0,"stage2_x86_64",null," The reference implementation self-hosted compiler of Zig, using the\n x86_64 backend.",null,false],[0,0,0,"stage2_aarch64",null," The reference implementation self-hosted compiler of Zig, using the\n aarch64 backend.",null,false],[0,0,0,"stage2_x86",null," The reference implementation self-hosted compiler of Zig, using the\n x86 backend.",null,false],[0,0,0,"stage2_riscv64",null," The reference implementation self-hosted compiler of Zig, using the\n riscv64 backend.",null,false],[0,0,0,"stage2_sparc64",null," The reference implementation self-hosted compiler of Zig, using the\n sparc64 backend.",null,false],[0,0,0,"stage2_spirv64",null," The reference implementation self-hosted compiler of Zig, using the\n spirv backend.",null,false],[81,711,0,null,null," This function type is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11752,11754,11756],false],[81,711,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[81,711,0,null,null,null,[],false],[0,0,0,"func",null,null,null,false],[81,711,0,null,null,null,null,false],[0,0,0,"async_frame_size",null,null,null,false],[81,719,0,null,null," This function type is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11758,11759,11760],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[81,723,0,null,null," This function is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",null,false],[81,732,0,null,null," This function is used by the Zig language code generation and\n therefore must be kept in sync with the compiler implementation.",[11763,11764,11765],false],[0,0,0,"msg",null,"",null,false],[0,0,0,"error_return_trace",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[81,817,0,null,null,null,[11767,11768],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[81,823,0,null,null,null,[11770,11771],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[81,828,0,null,null,null,[11773,11774],false],[0,0,0,"st",null,"",null,false],[0,0,0,"err",null,"",null,false],[81,833,0,null,null,null,[11776,11777],false],[0,0,0,"index",null,"",null,false],[0,0,0,"len",null,"",null,false],[81,838,0,null,null,null,[11779,11780],false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[81,843,0,null,null,null,[11782,11783],false],[0,0,0,"active",null,"",null,false],[0,0,0,"wanted",null,"",null,false],[81,848,0,null,null,null,[],false],[81,849,0,null,null,null,null,false],[81,850,0,null,null,null,null,false],[81,851,0,null,null,null,null,false],[81,852,0,null,null,null,null,false],[81,853,0,null,null,null,null,false],[81,854,0,null,null,null,null,false],[81,855,0,null,null,null,null,false],[81,856,0,null,null,null,null,false],[81,857,0,null,null,null,null,false],[81,858,0,null,null,null,null,false],[81,859,0,null,null,null,null,false],[81,860,0,null,null,null,null,false],[81,861,0,null,null,null,null,false],[81,862,0,null,null,null,null,false],[81,863,0,null,null,null,null,false],[81,864,0,null,null,null,null,false],[81,865,0,null,null,null,null,false],[81,866,0,null,null,null,null,false],[81,867,0,null,null,null,null,false],[81,868,0,null,null,null,null,false],[81,869,0,null,null,null,null,false],[81,870,0,null,null,null,null,false],[81,871,0,null,null,null,null,false],[81,872,0,null,null,null,null,false],[81,873,0,null,null,null,null,false],[81,876,0,null,null,null,[11811],false],[0,0,0,"st",null,"",null,false],[81,882,0,null,null,null,[11813,11814],false],[0,0,0,"st",null,"",null,false],[0,0,0,"addr",null,"",null,false],[81,889,0,null,null,null,null,false],[81,890,0,null,null,null,null,false],[1,69,0,null,null,null,null,false],[0,0,0,"c.zig",null,"",[],false],[82,41,0,null,null,null,null,false],[82,62,0,null,null,null,null,false],[82,97,0,null,null,null,null,false],[82,105,0,null,null,null,null,false],[82,410,0,null,null,null,null,false],[82,0,0,null,null,null,null,false],[82,1,0,null,null,null,null,false],[82,2,0,null,null,null,null,false],[82,3,0,null,null,null,null,false],[82,4,0,null,null,null,null,false],[82,5,0,null,null,null,null,false],[82,11,0,null,null,null,null,false],[0,0,0,"c/tokenizer.zig",null,"",[],false],[83,0,0,null,null,null,null,false],[83,2,0,null,null,null,[11967,11968,11969],false],[83,7,0,null,null,null,[11839,11840,11841,11842,11843,11844,11845,11846,11847,11848,11849,11850,11851,11852,11853,11854,11855,11856,11857,11858,11859,11860,11861,11862,11863,11864,11865,11866,11867,11868,11869,11870,11871,11872,11873,11874,11875,11876,11877,11878,11879,11880,11881,11882,11883,11884,11885,11886,11887,11888,11889,11890,11891,11892,11893,11894,11895,11896,11897,11898,11899,11900,11901,11902,11903,11904,11905,11906,11907,11908,11909,11910,11911,11912,11913,11914,11915,11916,11917,11918,11919,11920,11921,11922,11923,11924,11925,11926,11927,11928,11929,11930,11931,11932,11933,11934,11935,11936,11937,11938,11939,11940,11941,11942,11943,11944,11945,11946,11947],false],[83,127,0,null,null,null,[11836],false],[0,0,0,"id",null,"",null,false],[83,131,0,null,null,null,[11838],false],[0,0,0,"id",null,"",null,false],[0,0,0,"Invalid",null,null,null,false],[0,0,0,"Eof",null,null,null,false],[0,0,0,"Nl",null,null,null,false],[0,0,0,"Identifier",null,null,null,false],[0,0,0,"MacroString",null," special case for #include <...>",null,false],[0,0,0,"StringLiteral",null,null,null,false],[0,0,0,"CharLiteral",null,null,null,false],[0,0,0,"IntegerLiteral",null,null,null,false],[0,0,0,"FloatLiteral",null,null,null,false],[0,0,0,"Bang",null,null,null,false],[0,0,0,"BangEqual",null,null,null,false],[0,0,0,"Pipe",null,null,null,false],[0,0,0,"PipePipe",null,null,null,false],[0,0,0,"PipeEqual",null,null,null,false],[0,0,0,"Equal",null,null,null,false],[0,0,0,"EqualEqual",null,null,null,false],[0,0,0,"LParen",null,null,null,false],[0,0,0,"RParen",null,null,null,false],[0,0,0,"LBrace",null,null,null,false],[0,0,0,"RBrace",null,null,null,false],[0,0,0,"LBracket",null,null,null,false],[0,0,0,"RBracket",null,null,null,false],[0,0,0,"Period",null,null,null,false],[0,0,0,"Ellipsis",null,null,null,false],[0,0,0,"Caret",null,null,null,false],[0,0,0,"CaretEqual",null,null,null,false],[0,0,0,"Plus",null,null,null,false],[0,0,0,"PlusPlus",null,null,null,false],[0,0,0,"PlusEqual",null,null,null,false],[0,0,0,"Minus",null,null,null,false],[0,0,0,"MinusMinus",null,null,null,false],[0,0,0,"MinusEqual",null,null,null,false],[0,0,0,"Asterisk",null,null,null,false],[0,0,0,"AsteriskEqual",null,null,null,false],[0,0,0,"Percent",null,null,null,false],[0,0,0,"PercentEqual",null,null,null,false],[0,0,0,"Arrow",null,null,null,false],[0,0,0,"Colon",null,null,null,false],[0,0,0,"Semicolon",null,null,null,false],[0,0,0,"Slash",null,null,null,false],[0,0,0,"SlashEqual",null,null,null,false],[0,0,0,"Comma",null,null,null,false],[0,0,0,"Ampersand",null,null,null,false],[0,0,0,"AmpersandAmpersand",null,null,null,false],[0,0,0,"AmpersandEqual",null,null,null,false],[0,0,0,"QuestionMark",null,null,null,false],[0,0,0,"AngleBracketLeft",null,null,null,false],[0,0,0,"AngleBracketLeftEqual",null,null,null,false],[0,0,0,"AngleBracketAngleBracketLeft",null,null,null,false],[0,0,0,"AngleBracketAngleBracketLeftEqual",null,null,null,false],[0,0,0,"AngleBracketRight",null,null,null,false],[0,0,0,"AngleBracketRightEqual",null,null,null,false],[0,0,0,"AngleBracketAngleBracketRight",null,null,null,false],[0,0,0,"AngleBracketAngleBracketRightEqual",null,null,null,false],[0,0,0,"Tilde",null,null,null,false],[0,0,0,"LineComment",null,null,null,false],[0,0,0,"MultiLineComment",null,null,null,false],[0,0,0,"Hash",null,null,null,false],[0,0,0,"HashHash",null,null,null,false],[0,0,0,"Keyword_auto",null,null,null,false],[0,0,0,"Keyword_break",null,null,null,false],[0,0,0,"Keyword_case",null,null,null,false],[0,0,0,"Keyword_char",null,null,null,false],[0,0,0,"Keyword_const",null,null,null,false],[0,0,0,"Keyword_continue",null,null,null,false],[0,0,0,"Keyword_default",null,null,null,false],[0,0,0,"Keyword_do",null,null,null,false],[0,0,0,"Keyword_double",null,null,null,false],[0,0,0,"Keyword_else",null,null,null,false],[0,0,0,"Keyword_enum",null,null,null,false],[0,0,0,"Keyword_extern",null,null,null,false],[0,0,0,"Keyword_float",null,null,null,false],[0,0,0,"Keyword_for",null,null,null,false],[0,0,0,"Keyword_goto",null,null,null,false],[0,0,0,"Keyword_if",null,null,null,false],[0,0,0,"Keyword_int",null,null,null,false],[0,0,0,"Keyword_long",null,null,null,false],[0,0,0,"Keyword_register",null,null,null,false],[0,0,0,"Keyword_return",null,null,null,false],[0,0,0,"Keyword_short",null,null,null,false],[0,0,0,"Keyword_signed",null,null,null,false],[0,0,0,"Keyword_sizeof",null,null,null,false],[0,0,0,"Keyword_static",null,null,null,false],[0,0,0,"Keyword_struct",null,null,null,false],[0,0,0,"Keyword_switch",null,null,null,false],[0,0,0,"Keyword_typedef",null,null,null,false],[0,0,0,"Keyword_union",null,null,null,false],[0,0,0,"Keyword_unsigned",null,null,null,false],[0,0,0,"Keyword_void",null,null,null,false],[0,0,0,"Keyword_volatile",null,null,null,false],[0,0,0,"Keyword_while",null,null,null,false],[0,0,0,"Keyword_bool",null,null,null,false],[0,0,0,"Keyword_complex",null,null,null,false],[0,0,0,"Keyword_imaginary",null,null,null,false],[0,0,0,"Keyword_inline",null,null,null,false],[0,0,0,"Keyword_restrict",null,null,null,false],[0,0,0,"Keyword_alignas",null,null,null,false],[0,0,0,"Keyword_alignof",null,null,null,false],[0,0,0,"Keyword_atomic",null,null,null,false],[0,0,0,"Keyword_generic",null,null,null,false],[0,0,0,"Keyword_noreturn",null,null,null,false],[0,0,0,"Keyword_static_assert",null,null,null,false],[0,0,0,"Keyword_thread_local",null,null,null,false],[0,0,0,"Keyword_include",null,null,null,false],[0,0,0,"Keyword_define",null,null,null,false],[0,0,0,"Keyword_ifdef",null,null,null,false],[0,0,0,"Keyword_ifndef",null,null,null,false],[0,0,0,"Keyword_error",null,null,null,false],[0,0,0,"Keyword_pragma",null,null,null,false],[83,248,0,null,null,null,null,false],[83,308,0,null,null,null,[11950,11951],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"pp_directive",null,"",null,false],[83,325,0,null,null,null,[11953,11954,11955,11956,11957,11958,11959],false],[0,0,0,"none",null,null,null,false],[0,0,0,"f",null,null,null,false],[0,0,0,"l",null,null,null,false],[0,0,0,"u",null,null,null,false],[0,0,0,"lu",null,null,null,false],[0,0,0,"ll",null,null,null,false],[0,0,0,"llu",null,null,null,false],[83,335,0,null,null,null,[11961,11962,11963,11964,11965],false],[0,0,0,"none",null,null,null,false],[0,0,0,"wide",null,null,null,false],[0,0,0,"utf_8",null,null,null,false],[0,0,0,"utf_16",null,null,null,false],[0,0,0,"utf_32",null,null,null,false],[83,2,0,null,null,null,null,false],[0,0,0,"id",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[83,344,0,null,null,null,[11974,11975,11977,11978],false],[83,350,0,null,null,null,[11972],false],[0,0,0,"self",null,"",null,false],[83,344,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[0,0,0,"index",null,null,null,false],[83,344,0,null,null,null,null,false],[0,0,0,"prev_tok_id",null,null,null,false],[0,0,0,"pp_directive",null,null,null,false],[83,1572,0,null,null,null,[11980,11981],false],[0,0,0,"source",null,"",null,false],[0,0,0,"expected_tokens",null,"",null,false],[82,12,0,null,null,null,null,false],[82,13,0,null,null,null,null,false],[82,22,0,null,null," The return type is `type` to force comptime function call execution.\n TODO: https://github.com/ziglang/zig/issues/425\n If not linking libc, returns struct{pub const ok = false;}\n If linking musl libc, returns struct{pub const ok = true;}\n If linking gnu libc (glibc), the `ok` value will be true if the target\n version is greater than or equal to `glibc_version`.\n If linking a libc other than these, returns `false`.",[11985],false],[0,0,0,"glibc_version",null,"",[],true],[82,24,0,null,null,null,null,false],[82,59,0,null,null,null,null,false],[82,113,0,null,null,null,[11989],false],[0,0,0,"rc",null,"",null,false],[82,121,0,null,null,null,null,false],[82,123,0,null,null,null,[11992,11993],false],[0,0,0,"filename",null,"",null,false],[0,0,0,"modes",null,"",null,false],[82,124,0,null,null,null,[11995],false],[0,0,0,"stream",null,"",null,false],[82,125,0,null,null,null,[11997,11998,11999,12000],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"size_of_type",null,"",null,false],[0,0,0,"item_count",null,"",null,false],[0,0,0,"stream",null,"",null,false],[82,126,0,null,null,null,[12002,12003,12004,12005],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"size_of_type",null,"",null,false],[0,0,0,"item_count",null,"",null,false],[0,0,0,"stream",null,"",null,false],[82,128,0,null,null,null,[12007],false],[0,0,0,"format",null,"",null,false],[82,129,0,null,null,null,[],false],[82,130,0,null,null,null,[12010],false],[0,0,0,"code",null,"",null,false],[82,131,0,null,null,null,[12012],false],[0,0,0,"code",null,"",null,false],[82,132,0,null,null,null,[12014],false],[0,0,0,"fd",null,"",null,false],[82,133,0,null,null,null,[12016],false],[0,0,0,"fd",null,"",null,false],[82,134,0,null,null,null,[12018,12019,12020],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"whence",null,"",null,false],[82,135,0,null,null,null,[12022,12023],false],[0,0,0,"path",null,"",null,false],[0,0,0,"oflag",null,"",null,false],[82,136,0,null,null,null,[12025,12026,12027],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"oflag",null,"",null,false],[82,137,0,null,null,null,[12029,12030],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"length",null,"",null,false],[82,138,0,null,null,null,[12032],false],[0,0,0,"sig",null,"",null,false],[82,139,0,null,null,null,[12034,12035,12036],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"nbyte",null,"",null,false],[82,140,0,null,null,null,[12038,12039,12040],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"iovcnt",null,"",null,false],[82,141,0,null,null,null,[12042,12043,12044,12045],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"nbyte",null,"",null,false],[0,0,0,"offset",null,"",null,false],[82,142,0,null,null,null,[12047,12048,12049,12050],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"iovcnt",null,"",null,false],[0,0,0,"offset",null,"",null,false],[82,143,0,null,null,null,[12052,12053,12054],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"iovcnt",null,"",null,false],[82,144,0,null,null,null,[12056,12057,12058,12059],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"iovcnt",null,"",null,false],[0,0,0,"offset",null,"",null,false],[82,145,0,null,null,null,[12061,12062,12063],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"nbyte",null,"",null,false],[82,146,0,null,null,null,[12065,12066,12067,12068],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"nbyte",null,"",null,false],[0,0,0,"offset",null,"",null,false],[82,147,0,null,null,null,[12070,12071,12072,12073,12074,12075],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"prot",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[82,148,0,null,null,null,[12077,12078],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[82,149,0,null,null,null,[12080,12081,12082],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"prot",null,"",null,false],[82,150,0,null,null,null,[12084,12085,12086],false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,151,0,null,null,null,[12088,12089,12090,12091,12092],false],[0,0,0,"oldfd",null,"",null,false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newfd",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,152,0,null,null,null,[12094],false],[0,0,0,"path",null,"",null,false],[82,153,0,null,null,null,[12096,12097,12098],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,154,0,null,null,null,[12100,12101],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"size",null,"",null,false],[82,155,0,null,null,null,[12103,12104,12105],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"status",null,"",null,false],[0,0,0,"options",null,"",null,false],[82,156,0,null,null,null,[12107,12108,12109,12110],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"status",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"ru",null,"",null,false],[82,157,0,null,null,null,[],false],[82,158,0,null,null,null,[12113,12114],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,159,0,null,null,null,[12116,12117,12118,12119],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,160,0,null,null,null,[12121],false],[0,0,0,"fds",null,"",null,false],[82,161,0,null,null,null,[12123,12124],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,162,0,null,null,null,[12126,12127,12128],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,163,0,null,null,null,[12130,12131],false],[0,0,0,"existing",null,"",null,false],[0,0,0,"new",null,"",null,false],[82,164,0,null,null,null,[12133,12134,12135],false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newdirfd",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[82,165,0,null,null,null,[12137,12138],false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[82,166,0,null,null,null,[12140,12141,12142,12143],false],[0,0,0,"olddirfd",null,"",null,false],[0,0,0,"old",null,"",null,false],[0,0,0,"newdirfd",null,"",null,false],[0,0,0,"new",null,"",null,false],[82,167,0,null,null,null,[12145],false],[0,0,0,"path",null,"",null,false],[82,168,0,null,null,null,[12147],false],[0,0,0,"fd",null,"",null,false],[82,169,0,null,null,null,[12149,12150,12151],false],[0,0,0,"path",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"envp",null,"",null,false],[82,170,0,null,null,null,[12153],false],[0,0,0,"fd",null,"",null,false],[82,171,0,null,null,null,[12155,12156],false],[0,0,0,"old_fd",null,"",null,false],[0,0,0,"new_fd",null,"",null,false],[82,172,0,null,null,null,[12158,12159,12160],false],[0,0,0,"path",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"bufsize",null,"",null,false],[82,173,0,null,null,null,[12162,12163,12164,12165],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"bufsize",null,"",null,false],[82,174,0,null,null,null,[12167,12168],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,175,0,null,null,null,[12170,12171],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,176,0,null,null,null,[12173,12174,12175,12176],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,177,0,null,null,null,[12178,12179,12180],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"owner",null,"",null,false],[0,0,0,"group",null,"",null,false],[82,178,0,null,null,null,[12182],false],[0,0,0,"mode",null,"",null,false],[82,180,0,null,null,null,[12184],false],[0,0,0,"path",null,"",null,false],[82,181,0,null,null,null,[12186],false],[0,0,0,"name",null,"",null,false],[82,182,0,null,null,null,[12188,12189,12190,12191,12192,12193],false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[0,0,0,"oldp",null,"",null,false],[0,0,0,"oldlenp",null,"",null,false],[0,0,0,"newp",null,"",null,false],[0,0,0,"newlen",null,"",null,false],[82,183,0,null,null,null,[12195,12196,12197,12198,12199],false],[0,0,0,"name",null,"",null,false],[0,0,0,"oldp",null,"",null,false],[0,0,0,"oldlenp",null,"",null,false],[0,0,0,"newp",null,"",null,false],[0,0,0,"newlen",null,"",null,false],[82,184,0,null,null,null,[12201,12202,12203],false],[0,0,0,"name",null,"",null,false],[0,0,0,"mibp",null,"",null,false],[0,0,0,"sizep",null,"",null,false],[82,185,0,null,null,null,[12205,12206],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"termios_p",null,"",null,false],[82,186,0,null,null,null,[12208,12209,12210],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"optional_action",null,"",null,false],[0,0,0,"termios_p",null,"",null,false],[82,187,0,null,null,null,[12212,12213],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"cmd",null,"",null,false],[82,188,0,null,null,null,[12215,12216],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"operation",null,"",null,false],[82,189,0,null,null,null,[12218,12219],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"request",null,"",null,false],[82,190,0,null,null,null,[12221],false],[0,0,0,"buf",null,"",null,false],[82,192,0,null,null,null,[12223,12224],false],[0,0,0,"name",null,"",null,false],[0,0,0,"len",null,"",null,false],[82,193,0,null,null,null,[12226,12227],false],[0,0,0,"socket",null,"",null,false],[0,0,0,"how",null,"",null,false],[82,194,0,null,null,null,[12229,12230,12231],false],[0,0,0,"socket",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"address_len",null,"",null,false],[82,195,0,null,null,null,[12233,12234,12235,12236],false],[0,0,0,"domain",null,"",null,false],[0,0,0,"sock_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"sv",null,"",null,false],[82,196,0,null,null,null,[12238,12239],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"backlog",null,"",null,false],[82,197,0,null,null,null,[12241,12242,12243],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[82,198,0,null,null,null,[12245,12246,12247],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[82,199,0,null,null,null,[12249,12250,12251],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"sock_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[82,200,0,null,null,null,[12253,12254,12255],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[82,201,0,null,null,null,[12257,12258,12259,12260],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,202,0,null,null,null,[12262,12263,12264,12265,12266],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"optval",null,"",null,false],[0,0,0,"optlen",null,"",null,false],[82,203,0,null,null,null,[12268,12269,12270,12271,12272],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"optval",null,"",null,false],[0,0,0,"optlen",null,"",null,false],[82,204,0,null,null,null,[12274,12275,12276,12277],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,205,0,null,null,null,[12279,12280,12281,12282,12283,12284],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"dest_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[82,213,0,null,null,null,[12286,12287,12288],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,215,0,null,null,null,[12290,12291,12292,12293],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[82,221,0,null,null,null,[12295,12296,12297,12298,12299,12300],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"src_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[82,229,0,null,null,null,[12302,12303,12304],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,231,0,null,null,null,[12306,12307],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"sig",null,"",null,false],[82,232,0,null,null,null,[12309,12310,12311,12312],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf_ptr",null,"",null,false],[0,0,0,"nbytes",null,"",null,false],[0,0,0,"basep",null,"",null,false],[82,234,0,null,null,null,[12314],false],[0,0,0,"uid",null,"",null,false],[82,235,0,null,null,null,[12316],false],[0,0,0,"gid",null,"",null,false],[82,236,0,null,null,null,[12318],false],[0,0,0,"euid",null,"",null,false],[82,237,0,null,null,null,[12320],false],[0,0,0,"egid",null,"",null,false],[82,238,0,null,null,null,[12322,12323],false],[0,0,0,"ruid",null,"",null,false],[0,0,0,"euid",null,"",null,false],[82,239,0,null,null,null,[12325,12326],false],[0,0,0,"rgid",null,"",null,false],[0,0,0,"egid",null,"",null,false],[82,240,0,null,null,null,[12328,12329,12330],false],[0,0,0,"ruid",null,"",null,false],[0,0,0,"euid",null,"",null,false],[0,0,0,"suid",null,"",null,false],[82,241,0,null,null,null,[12332,12333,12334],false],[0,0,0,"rgid",null,"",null,false],[0,0,0,"egid",null,"",null,false],[0,0,0,"sgid",null,"",null,false],[82,243,0,null,null,null,[12336],false],[0,0,0,"",null,"",null,false],[82,244,0,null,null,null,[12338,12339],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[82,245,0,null,null,null,[12341],false],[0,0,0,"",null,"",null,false],[82,247,0,null,null,null,[12343,12344],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"times",null,"",null,false],[82,248,0,null,null,null,[12346,12347],false],[0,0,0,"path",null,"",null,false],[0,0,0,"times",null,"",null,false],[82,250,0,null,null,null,[12349,12350,12351,12352],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"times",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,251,0,null,null,null,[12354,12355],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"times",null,"",null,false],[82,253,0,null,null,null,[12357,12358,12359,12361],false],[0,0,0,"newthread",null,"",null,false],[0,0,0,"attr",null,"",null,false],[0,0,0,"start_routine",null,"",[12360],false],[0,0,0,"",null,"",null,false],[0,0,0,"arg",null,"",null,false],[82,259,0,null,null,null,[12363],false],[0,0,0,"attr",null,"",null,false],[82,260,0,null,null,null,[12365,12366,12367],false],[0,0,0,"attr",null,"",null,false],[0,0,0,"stackaddr",null,"",null,false],[0,0,0,"stacksize",null,"",null,false],[82,261,0,null,null,null,[12369,12370],false],[0,0,0,"attr",null,"",null,false],[0,0,0,"stacksize",null,"",null,false],[82,262,0,null,null,null,[12372,12373],false],[0,0,0,"attr",null,"",null,false],[0,0,0,"guardsize",null,"",null,false],[82,263,0,null,null,null,[12375],false],[0,0,0,"attr",null,"",null,false],[82,264,0,null,null,null,[],false],[82,265,0,null,null,null,[12378,12379],false],[0,0,0,"thread",null,"",null,false],[0,0,0,"arg_return",null,"",null,false],[82,266,0,null,null,null,[12381],false],[0,0,0,"thread",null,"",null,false],[82,267,0,null,null,null,[12383,12384,12385],false],[0,0,0,"prepare",null,"",[],false],[0,0,0,"parent",null,"",[],false],[0,0,0,"child",null,"",[],false],[82,272,0,null,null,null,[12387,12388],false],[0,0,0,"key",null,"",null,false],[0,0,0,"destructor",null,"",[12389],false],[0,0,0,"value",null,"",null,false],[82,276,0,null,null,null,[12391],false],[0,0,0,"key",null,"",null,false],[82,277,0,null,null,null,[12393],false],[0,0,0,"key",null,"",null,false],[82,278,0,null,null,null,[12395,12396],false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[82,279,0,null,null,null,[12398,12399,12400],false],[0,0,0,"how",null,"",null,false],[0,0,0,"set",null,"",null,false],[0,0,0,"oldset",null,"",null,false],[82,280,0,null,null,null,[12402,12403,12404],false],[0,0,0,"sem",null,"",null,false],[0,0,0,"pshared",null,"",null,false],[0,0,0,"value",null,"",null,false],[82,281,0,null,null,null,[12406],false],[0,0,0,"sem",null,"",null,false],[82,282,0,null,null,null,[12408,12409,12410,12411],false],[0,0,0,"name",null,"",null,false],[0,0,0,"flag",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"value",null,"",null,false],[82,283,0,null,null,null,[12413],false],[0,0,0,"sem",null,"",null,false],[82,284,0,null,null,null,[12415],false],[0,0,0,"sem",null,"",null,false],[82,285,0,null,null,null,[12417],false],[0,0,0,"sem",null,"",null,false],[82,286,0,null,null,null,[12419],false],[0,0,0,"sem",null,"",null,false],[82,287,0,null,null,null,[12421,12422],false],[0,0,0,"sem",null,"",null,false],[0,0,0,"abs_timeout",null,"",null,false],[82,288,0,null,null,null,[12424,12425],false],[0,0,0,"sem",null,"",null,false],[0,0,0,"sval",null,"",null,false],[82,290,0,null,null,null,[12427,12428,12429],false],[0,0,0,"name",null,"",null,false],[0,0,0,"flag",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,291,0,null,null,null,[12431],false],[0,0,0,"name",null,"",null,false],[82,293,0,null,null,null,[],false],[82,294,0,null,null,null,[12434,12435,12436,12437,12438,12439],false],[0,0,0,"kq",null,"",null,false],[0,0,0,"changelist",null,"",null,false],[0,0,0,"nchanges",null,"",null,false],[0,0,0,"eventlist",null,"",null,false],[0,0,0,"nevents",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[82,303,0,null,null,null,[],false],[82,304,0,null,null,null,[12442,12443,12444,12445,12446],false],[0,0,0,"port",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"object",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"user_var",null,"",null,false],[82,311,0,null,null,null,[12448,12449,12450],false],[0,0,0,"port",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"object",null,"",null,false],[82,312,0,null,null,null,[12452,12453,12454],false],[0,0,0,"port",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"user_var",null,"",null,false],[82,313,0,null,null,null,[12456,12457,12458,12459,12460],false],[0,0,0,"ports",null,"",null,false],[0,0,0,"errors",null,"",null,false],[0,0,0,"num_ports",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"user_var",null,"",null,false],[82,320,0,null,null,null,[12462,12463,12464],false],[0,0,0,"port",null,"",null,false],[0,0,0,"event",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[82,321,0,null,null,null,[12466,12467,12468,12469,12470],false],[0,0,0,"port",null,"",null,false],[0,0,0,"event_list",null,"",null,false],[0,0,0,"max_events",null,"",null,false],[0,0,0,"events_retrieved",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[82,328,0,null,null,null,[12472,12473,12474,12475],false],[0,0,0,"port",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"user_var",null,"",null,false],[82,330,0,null,null,null,[12477,12478,12479,12480],false],[0,0,0,"node",null,"",null,false],[0,0,0,"service",null,"",null,false],[0,0,0,"hints",null,"",null,false],[0,0,0,"res",null," On Linux, `res` will not be modified on error and `freeaddrinfo` will\n potentially crash if you pass it an undefined pointer\n",null,false],[82,339,0,null,null,null,[12482],false],[0,0,0,"res",null,"",null,false],[82,341,0,null,null,null,[12484,12485,12486,12487,12488,12489,12490],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[0,0,0,"host",null,"",null,false],[0,0,0,"hostlen",null,"",null,false],[0,0,0,"serv",null,"",null,false],[0,0,0,"servlen",null,"",null,false],[0,0,0,"flags",null,"",null,false],[82,351,0,null,null,null,[12492],false],[0,0,0,"errcode",null,"",null,false],[82,353,0,null,null,null,[12494,12495,12496],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"nfds",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[82,354,0,null,null,null,[12498,12499,12500,12501],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"nfds",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"sigmask",null,"",null,false],[82,356,0,null,null,null,[12503,12504,12505,12506,12507],false],[0,0,0,"msg",null,"",null,false],[0,0,0,"eomorig",null,"",null,false],[0,0,0,"comp_dn",null,"",null,false],[0,0,0,"exp_dn",null,"",null,false],[0,0,0,"length",null,"",null,false],[82,364,0,null,null,null,null,false],[82,365,0,null,null,null,[12510],false],[0,0,0,"mutex",null,"",null,false],[82,366,0,null,null,null,[12512],false],[0,0,0,"mutex",null,"",null,false],[82,367,0,null,null,null,[12514],false],[0,0,0,"mutex",null,"",null,false],[82,368,0,null,null,null,[12516],false],[0,0,0,"mutex",null,"",null,false],[82,370,0,null,null,null,null,false],[82,371,0,null,null,null,[12519,12520],false],[0,0,0,"cond",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[82,372,0,null,null,null,[12522,12523,12524],false],[0,0,0,"cond",null,"",null,false],[0,0,0,"mutex",null,"",null,false],[0,0,0,"abstime",null,"",null,false],[82,373,0,null,null,null,[12526],false],[0,0,0,"cond",null,"",null,false],[82,374,0,null,null,null,[12528],false],[0,0,0,"cond",null,"",null,false],[82,375,0,null,null,null,[12530],false],[0,0,0,"cond",null,"",null,false],[82,377,0,null,null,null,[12532],false],[0,0,0,"rwl",null,"",null,false],[82,378,0,null,null,null,[12534],false],[0,0,0,"rwl",null,"",null,false],[82,379,0,null,null,null,[12536],false],[0,0,0,"rwl",null,"",null,false],[82,380,0,null,null,null,[12538],false],[0,0,0,"rwl",null,"",null,false],[82,381,0,null,null,null,[12540],false],[0,0,0,"rwl",null,"",null,false],[82,382,0,null,null,null,[12542],false],[0,0,0,"rwl",null,"",null,false],[82,384,0,null,null,null,null,false],[82,385,0,null,null,null,null,false],[82,387,0,null,null,null,[12546,12547],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,388,0,null,null,null,[12549],false],[0,0,0,"handle",null,"",null,false],[82,389,0,null,null,null,[12551,12552],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"symbol",null,"",null,false],[82,391,0,null,null,null,[],false],[82,392,0,null,null,null,[12555],false],[0,0,0,"fd",null,"",null,false],[82,393,0,null,null,null,[12557],false],[0,0,0,"fd",null,"",null,false],[82,394,0,null,null,null,[12559],false],[0,0,0,"fd",null,"",null,false],[82,396,0,null,null,null,[12561],false],[0,0,0,"option",null,"",null,false],[82,398,0,null,null,null,[12563,12564],false],[0,0,0,"resource",null,"",null,false],[0,0,0,"rlim",null,"",null,false],[82,399,0,null,null,null,[12566,12567],false],[0,0,0,"resource",null,"",null,false],[0,0,0,"rlim",null,"",null,false],[82,401,0,null,null,null,[12569,12570,12571],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"mode",null,"",null,false],[82,403,0,null,null,null,[12573,12574],false],[0,0,0,"priority",null,"",null,false],[0,0,0,"message",null,"",null,false],[82,404,0,null,null,null,[12576,12577,12578],false],[0,0,0,"ident",null,"",null,false],[0,0,0,"logopt",null,"",null,false],[0,0,0,"facility",null,"",null,false],[82,405,0,null,null,null,[],false],[82,406,0,null,null,null,[12581],false],[0,0,0,"maskpri",null,"",null,false],[82,408,0,null,null,null,[12583],false],[0,0,0,"",null,"",null,false],[82,421,0,null,null,null,null,false],[1,72,0,null,null," COFF format.",null,false],[0,0,0,"coff.zig",null,"",[],false],[84,0,0,null,null,null,null,false],[84,1,0,null,null,null,null,false],[84,2,0,null,null,null,null,false],[84,4,0,null,null,null,[12591,12592,12593,12594,12595,12596,12597,12598,12599,12600,12601,12602,12603,12604,12605,12606],false],[0,0,0,"RELOCS_STRIPPED",null," Image only, Windows CE, and Microsoft Windows NT and later.\n This indicates that the file does not contain base relocations\n and must therefore be loaded at its preferred base address.\n If the base address is not available, the loader reports an error.\n The default behavior of the linker is to strip base relocations\n from executable (EXE) files.",null,false],[0,0,0,"EXECUTABLE_IMAGE",null," Image only. This indicates that the image file is valid and can be run.\n If this flag is not set, it indicates a linker error.",null,false],[0,0,0,"LINE_NUMS_STRIPPED",null," COFF line numbers have been removed. This flag is deprecated and should be zero.",null,false],[0,0,0,"LOCAL_SYMS_STRIPPED",null," COFF symbol table entries for local symbols have been removed.\n This flag is deprecated and should be zero.",null,false],[0,0,0,"AGGRESSIVE_WS_TRIM",null," Obsolete. Aggressively trim working set.\n This flag is deprecated for Windows 2000 and later and must be zero.",null,false],[0,0,0,"LARGE_ADDRESS_AWARE",null," Application can handle > 2-GB addresses.",null,false],[0,0,0,"RESERVED",null," This flag is reserved for future use.",null,false],[0,0,0,"BYTES_REVERSED_LO",null," Little endian: the least significant bit (LSB) precedes the\n most significant bit (MSB) in memory. This flag is deprecated and should be zero.",null,false],[0,0,0,"32BIT_MACHINE",null," Machine is based on a 32-bit-word architecture.",null,false],[0,0,0,"DEBUG_STRIPPED",null," Debugging information is removed from the image file.",null,false],[0,0,0,"REMOVABLE_RUN_FROM_SWAP",null," If the image is on removable media, fully load it and copy it to the swap file.",null,false],[0,0,0,"NET_RUN_FROM_SWAP",null," If the image is on network media, fully load it and copy it to the swap file.",null,false],[0,0,0,"SYSTEM",null," The image file is a system file, not a user program.",null,false],[0,0,0,"DLL",null," The image file is a dynamic-link library (DLL).\n Such files are considered executable files for almost all purposes,\n although they cannot be directly run.",null,false],[0,0,0,"UP_SYSTEM_ONLY",null," The file should be run only on a uniprocessor machine.",null,false],[0,0,0,"BYTES_REVERSED_HI",null," Big endian: the MSB precedes the LSB in memory. This flag is deprecated and should be zero.",null,false],[84,65,0,null,null,null,[12609,12610,12611,12612,12613,12614,12616],false],[84,65,0,null,null,null,null,false],[0,0,0,"machine",null," The number that identifies the type of target machine.",null,false],[0,0,0,"number_of_sections",null," The number of sections. This indicates the size of the section table, which immediately follows the headers.",null,false],[0,0,0,"time_date_stamp",null," The low 32 bits of the number of seconds since 00:00 January 1, 1970 (a C run-time time_t value),\n which indicates when the file was created.",null,false],[0,0,0,"pointer_to_symbol_table",null," The file offset of the COFF symbol table, or zero if no COFF symbol table is present.\n This value should be zero for an image because COFF debugging information is deprecated.",null,false],[0,0,0,"number_of_symbols",null," The number of entries in the symbol table.\n This data can be used to locate the string table, which immediately follows the symbol table.\n This value should be zero for an image because COFF debugging information is deprecated.",null,false],[0,0,0,"size_of_optional_header",null," The size of the optional header, which is required for executable files but not for object files.\n This value should be zero for an object file. For a description of the header format, see Optional Header (Image Only).",null,false],[84,65,0,null,null,null,null,false],[0,0,0,"flags",null," The flags that indicate the attributes of the file.",null,false],[84,95,0,null,null,null,null,false],[84,96,0,null,null,null,null,false],[84,98,0,null,null,null,[12621,12622,12623,12624,12625,12626,12627,12628,12629,12630,12631,12632],false],[84,98,0,null,null,null,null,false],[0,0,0,"_reserved_0",null,null,null,false],[0,0,0,"HIGH_ENTROPY_VA",null," Image can handle a high entropy 64-bit virtual address space.",null,false],[0,0,0,"DYNAMIC_BASE",null," DLL can be relocated at load time.",null,false],[0,0,0,"FORCE_INTEGRITY",null," Code Integrity checks are enforced.",null,false],[0,0,0,"NX_COMPAT",null," Image is NX compatible.",null,false],[0,0,0,"NO_ISOLATION",null," Isolation aware, but do not isolate the image.",null,false],[0,0,0,"NO_SEH",null," Does not use structured exception (SE) handling. No SE handler may be called in this image.",null,false],[0,0,0,"NO_BIND",null," Do not bind the image.",null,false],[0,0,0,"APPCONTAINER",null," Image must execute in an AppContainer.",null,false],[0,0,0,"WDM_DRIVER",null," A WDM driver.",null,false],[0,0,0,"GUARD_CF",null," Image supports Control Flow Guard.",null,false],[0,0,0,"TERMINAL_SERVER_AWARE",null," Terminal Server aware.",null,false],[84,135,0,null,null,null,[12634,12635,12636,12637,12638,12639,12640,12641,12642,12643,12644,12645,12646,12647],false],[0,0,0,"UNKNOWN",null," An unknown subsystem",null,false],[0,0,0,"NATIVE",null," Device drivers and native Windows processes",null,false],[0,0,0,"WINDOWS_GUI",null," The Windows graphical user interface (GUI) subsystem",null,false],[0,0,0,"WINDOWS_CUI",null," The Windows character subsystem",null,false],[0,0,0,"OS2_CUI",null," The OS/2 character subsystem",null,false],[0,0,0,"POSIX_CUI",null," The Posix character subsystem",null,false],[0,0,0,"NATIVE_WINDOWS",null," Native Win9x driver",null,false],[0,0,0,"WINDOWS_CE_GUI",null," Windows CE",null,false],[0,0,0,"EFI_APPLICATION",null," An Extensible Firmware Interface (EFI) application",null,false],[0,0,0,"EFI_BOOT_SERVICE_DRIVER",null," An EFI driver with boot services",null,false],[0,0,0,"EFI_RUNTIME_DRIVER",null," An EFI driver with run-time services",null,false],[0,0,0,"EFI_ROM",null," An EFI ROM image",null,false],[0,0,0,"XBOX",null," XBOX",null,false],[0,0,0,"WINDOWS_BOOT_APPLICATION",null," Windows boot application",null,false],[84,179,0,null,null,null,[12649,12650,12651,12652,12653,12654,12655,12656],false],[0,0,0,"magic",null,null,null,false],[0,0,0,"major_linker_version",null,null,null,false],[0,0,0,"minor_linker_version",null,null,null,false],[0,0,0,"size_of_code",null,null,null,false],[0,0,0,"size_of_initialized_data",null,null,null,false],[0,0,0,"size_of_uninitialized_data",null,null,null,false],[0,0,0,"address_of_entry_point",null,null,null,false],[0,0,0,"base_of_code",null,null,null,false],[84,190,0,null,null,null,[12658,12659,12660,12661,12662,12663,12664,12665,12666,12667,12668,12669,12670,12671,12672,12673,12674,12675,12676,12677,12678,12679,12681,12683,12684,12685,12686,12687,12688,12689],false],[0,0,0,"magic",null,null,null,false],[0,0,0,"major_linker_version",null,null,null,false],[0,0,0,"minor_linker_version",null,null,null,false],[0,0,0,"size_of_code",null,null,null,false],[0,0,0,"size_of_initialized_data",null,null,null,false],[0,0,0,"size_of_uninitialized_data",null,null,null,false],[0,0,0,"address_of_entry_point",null,null,null,false],[0,0,0,"base_of_code",null,null,null,false],[0,0,0,"base_of_data",null,null,null,false],[0,0,0,"image_base",null,null,null,false],[0,0,0,"section_alignment",null,null,null,false],[0,0,0,"file_alignment",null,null,null,false],[0,0,0,"major_operating_system_version",null,null,null,false],[0,0,0,"minor_operating_system_version",null,null,null,false],[0,0,0,"major_image_version",null,null,null,false],[0,0,0,"minor_image_version",null,null,null,false],[0,0,0,"major_subsystem_version",null,null,null,false],[0,0,0,"minor_subsystem_version",null,null,null,false],[0,0,0,"win32_version_value",null,null,null,false],[0,0,0,"size_of_image",null,null,null,false],[0,0,0,"size_of_headers",null,null,null,false],[0,0,0,"checksum",null,null,null,false],[84,190,0,null,null,null,null,false],[0,0,0,"subsystem",null,null,null,false],[84,190,0,null,null,null,null,false],[0,0,0,"dll_flags",null,null,null,false],[0,0,0,"size_of_stack_reserve",null,null,null,false],[0,0,0,"size_of_stack_commit",null,null,null,false],[0,0,0,"size_of_heap_reserve",null,null,null,false],[0,0,0,"size_of_heap_commit",null,null,null,false],[0,0,0,"loader_flags",null,null,null,false],[0,0,0,"number_of_rva_and_sizes",null,null,null,false],[84,223,0,null,null,null,[12691,12692,12693,12694,12695,12696,12697,12698,12699,12700,12701,12702,12703,12704,12705,12706,12707,12708,12709,12710,12711,12713,12715,12716,12717,12718,12719,12720,12721],false],[0,0,0,"magic",null,null,null,false],[0,0,0,"major_linker_version",null,null,null,false],[0,0,0,"minor_linker_version",null,null,null,false],[0,0,0,"size_of_code",null,null,null,false],[0,0,0,"size_of_initialized_data",null,null,null,false],[0,0,0,"size_of_uninitialized_data",null,null,null,false],[0,0,0,"address_of_entry_point",null,null,null,false],[0,0,0,"base_of_code",null,null,null,false],[0,0,0,"image_base",null,null,null,false],[0,0,0,"section_alignment",null,null,null,false],[0,0,0,"file_alignment",null,null,null,false],[0,0,0,"major_operating_system_version",null,null,null,false],[0,0,0,"minor_operating_system_version",null,null,null,false],[0,0,0,"major_image_version",null,null,null,false],[0,0,0,"minor_image_version",null,null,null,false],[0,0,0,"major_subsystem_version",null,null,null,false],[0,0,0,"minor_subsystem_version",null,null,null,false],[0,0,0,"win32_version_value",null,null,null,false],[0,0,0,"size_of_image",null,null,null,false],[0,0,0,"size_of_headers",null,null,null,false],[0,0,0,"checksum",null,null,null,false],[84,223,0,null,null,null,null,false],[0,0,0,"subsystem",null,null,null,false],[84,223,0,null,null,null,null,false],[0,0,0,"dll_flags",null,null,null,false],[0,0,0,"size_of_stack_reserve",null,null,null,false],[0,0,0,"size_of_stack_commit",null,null,null,false],[0,0,0,"size_of_heap_reserve",null,null,null,false],[0,0,0,"size_of_heap_commit",null,null,null,false],[0,0,0,"loader_flags",null,null,null,false],[0,0,0,"number_of_rva_and_sizes",null,null,null,false],[84,255,0,null,null,null,null,false],[84,257,0,null,null,null,[12724,12725,12726,12727,12728,12729,12730,12731,12732,12733,12734,12735,12736,12737,12738],false],[0,0,0,"EXPORT",null," Export Directory",null,false],[0,0,0,"IMPORT",null," Import Directory",null,false],[0,0,0,"RESOURCE",null," Resource Directory",null,false],[0,0,0,"EXCEPTION",null," Exception Directory",null,false],[0,0,0,"SECURITY",null," Security Directory",null,false],[0,0,0,"BASERELOC",null," Base Relocation Table",null,false],[0,0,0,"DEBUG",null," Debug Directory",null,false],[0,0,0,"ARCHITECTURE",null," Architecture Specific Data",null,false],[0,0,0,"GLOBALPTR",null," RVA of GP",null,false],[0,0,0,"TLS",null," TLS Directory",null,false],[0,0,0,"LOAD_CONFIG",null," Load Configuration Directory",null,false],[0,0,0,"BOUND_IMPORT",null," Bound Import Directory in headers",null,false],[0,0,0,"IAT",null," Import Address Table",null,false],[0,0,0,"DELAY_IMPORT",null," Delay Load Import Descriptors",null,false],[0,0,0,"COM_DESCRIPTOR",null," COM Runtime descriptor",null,false],[84,304,0,null,null,null,[12740,12741],false],[0,0,0,"virtual_address",null,null,null,false],[0,0,0,"size",null,null,null,false],[84,309,0,null,null,null,[12743,12744],false],[0,0,0,"page_rva",null," The image base plus the page RVA is added to each offset to create the VA where the base relocation must be applied.",null,false],[0,0,0,"block_size",null," The total number of bytes in the base relocation block, including the Page RVA and Block Size fields and the Type/Offset fields that follow.",null,false],[84,317,0,null,null,null,[12747,12749],false],[84,317,0,null,null,null,null,false],[0,0,0,"offset",null," Stored in the remaining 12 bits of the WORD, an offset from the starting address that was specified in the Page RVA field for the block.\n This offset specifies where the base relocation is to be applied.",null,false],[84,317,0,null,null,null,null,false],[0,0,0,"type",null," Stored in the high 4 bits of the WORD, a value that indicates the type of base relocation to be applied.",null,false],[84,326,0,null,null,null,[12751,12752,12753,12754,12755,12756,12757,12758,12759,12760,12761],false],[0,0,0,"ABSOLUTE",null," The base relocation is skipped. This type can be used to pad a block.",null,false],[0,0,0,"HIGH",null," The base relocation adds the high 16 bits of the difference to the 16-bit field at offset. The 16-bit field represents the high value of a 32-bit word.",null,false],[0,0,0,"LOW",null," The base relocation adds the low 16 bits of the difference to the 16-bit field at offset. The 16-bit field represents the low half of a 32-bit word.",null,false],[0,0,0,"HIGHLOW",null," The base relocation applies all 32 bits of the difference to the 32-bit field at offset.",null,false],[0,0,0,"HIGHADJ",null," The base relocation adds the high 16 bits of the difference to the 16-bit field at offset.\n The 16-bit field represents the high value of a 32-bit word.\n The low 16 bits of the 32-bit value are stored in the 16-bit word that follows this base relocation.\n This means that this base relocation occupies two slots.",null,false],[0,0,0,"MIPS_JMPADDR",null," When the machine type is MIPS, the base relocation applies to a MIPS jump instruction.",null,false],[0,0,0,"RESERVED",null," This relocation is meaningful only when the machine type is ARM or Thumb.\n The base relocation applies the 32-bit address of a symbol across a consecutive MOVW/MOVT instruction pair.\n This relocation is only meaningful when the machine type is RISC-V.\n The base relocation applies to the high 20 bits of a 32-bit absolute address.\n Reserved, must be zero.",null,false],[0,0,0,"THUMB_MOV32",null," This relocation is meaningful only when the machine type is Thumb.\n The base relocation applies the 32-bit address of a symbol to a consecutive MOVW/MOVT instruction pair.",null,false],[0,0,0,"RISCV_LOW12S",null," This relocation is only meaningful when the machine type is RISC-V.\n The base relocation applies to the low 12 bits of a 32-bit absolute address formed in RISC-V I-type instruction format.\n This relocation is only meaningful when the machine type is RISC-V.\n The base relocation applies to the low 12 bits of a 32-bit absolute address formed in RISC-V S-type instruction format.",null,false],[0,0,0,"MIPS_JMPADDR16",null," This relocation is only meaningful when the machine type is LoongArch 32-bit.\n The base relocation applies to a 32-bit absolute address formed in two consecutive instructions.\n This relocation is only meaningful when the machine type is LoongArch 64-bit.\n The base relocation applies to a 64-bit absolute address formed in four consecutive instructions.\n The relocation is only meaningful when the machine type is MIPS.\n The base relocation applies to a MIPS16 jump instruction.",null,false],[0,0,0,"DIR64",null," The base relocation applies the difference to the 64-bit field at offset.",null,false],[84,387,0,null,null,null,[12763,12764,12765,12766,12768,12769,12770,12771],false],[0,0,0,"characteristics",null,null,null,false],[0,0,0,"time_date_stamp",null,null,null,false],[0,0,0,"major_version",null,null,null,false],[0,0,0,"minor_version",null,null,null,false],[84,387,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[0,0,0,"size_of_data",null,null,null,false],[0,0,0,"address_of_raw_data",null,null,null,false],[0,0,0,"pointer_to_raw_data",null,null,null,false],[84,398,0,null,null,null,[12773,12774,12775,12776,12777,12778,12779,12780,12781,12782,12783,12784,12785,12786,12787,12788,12789],false],[0,0,0,"UNKNOWN",null,null,null,false],[0,0,0,"COFF",null,null,null,false],[0,0,0,"CODEVIEW",null,null,null,false],[0,0,0,"FPO",null,null,null,false],[0,0,0,"MISC",null,null,null,false],[0,0,0,"EXCEPTION",null,null,null,false],[0,0,0,"FIXUP",null,null,null,false],[0,0,0,"OMAP_TO_SRC",null,null,null,false],[0,0,0,"OMAP_FROM_SRC",null,null,null,false],[0,0,0,"BORLAND",null,null,null,false],[0,0,0,"RESERVED10",null,null,null,false],[0,0,0,"VC_FEATURE",null,null,null,false],[0,0,0,"POGO",null,null,null,false],[0,0,0,"ILTCG",null,null,null,false],[0,0,0,"MPX",null,null,null,false],[0,0,0,"REPRO",null,null,null,false],[0,0,0,"EX_DLLCHARACTERISTICS",null,null,null,false],[84,418,0,null,null,null,[12791,12792,12793,12794,12795],false],[0,0,0,"import_lookup_table_rva",null," The RVA of the import lookup table.\n This table contains a name or ordinal for each import.\n (The name \"Characteristics\" is used in Winnt.h, but no longer describes this field.)",null,false],[0,0,0,"time_date_stamp",null," The stamp that is set to zero until the image is bound.\n After the image is bound, this field is set to the time/data stamp of the DLL.",null,false],[0,0,0,"forwarder_chain",null," The index of the first forwarder reference.",null,false],[0,0,0,"name_rva",null," The address of an ASCII string that contains the name of the DLL.\n This address is relative to the image base.",null,false],[0,0,0,"import_address_table_rva",null," The RVA of the import address table.\n The contents of this table are identical to the contents of the import lookup table until the image is bound.",null,false],[84,440,0,null,null,null,[],false],[84,441,0,null,null,null,[12799,12800],false],[84,441,0,null,null,null,null,false],[0,0,0,"name_table_rva",null,null,null,false],[0,0,0,"flag",null,null,null,false],[84,446,0,null,null,null,[12802,12804,12805],false],[0,0,0,"ordinal_number",null,null,null,false],[84,446,0,null,null,null,null,false],[0,0,0,"unused",null,null,null,false],[0,0,0,"flag",null,null,null,false],[84,452,0,null,null,null,null,false],[84,454,0,null,null,null,[12808],false],[0,0,0,"raw",null,"",null,false],[84,459,0,null,null,null,[12810],false],[0,0,0,"raw",null,"",null,false],[84,465,0,null,null,null,[],false],[84,466,0,null,null,null,[12814,12815,12816],false],[84,466,0,null,null,null,null,false],[0,0,0,"name_table_rva",null,null,null,false],[0,0,0,"unused",null,null,null,false],[0,0,0,"flag",null,null,null,false],[84,472,0,null,null,null,[12818,12820,12821],false],[0,0,0,"ordinal_number",null,null,null,false],[84,472,0,null,null,null,null,false],[0,0,0,"unused",null,null,null,false],[0,0,0,"flag",null,null,null,false],[84,478,0,null,null,null,null,false],[84,480,0,null,null,null,[12824],false],[0,0,0,"raw",null,"",null,false],[84,485,0,null,null,null,[12826],false],[0,0,0,"raw",null,"",null,false],[84,493,0,null,null," Every name ends with a NULL byte. IF the NULL byte does not fall on\n 2byte boundary, the entry structure is padded to ensure 2byte alignment.",[12828,12830],false],[0,0,0,"hint",null," An index into the export name pointer table.\n A match is attempted first with this value. If it fails, a binary search is performed on the DLL's export name pointer table.",null,false],[84,493,0,null,null,null,null,false],[0,0,0,"name",null," Pointer to NULL terminated ASCII name.\n Variable length...",null,false],[84,503,0,null,null,null,[12846,12847,12848,12849,12850,12851,12852,12853,12854,12856],false],[84,515,0,null,null,null,[12833],false],[0,0,0,"self",null,"",null,false],[84,521,0,null,null,null,[12835],false],[0,0,0,"self",null,"",null,false],[84,529,0,null,null," Applicable only to section headers in COFF objects.",[12837],false],[0,0,0,"self",null,"",null,false],[84,534,0,null,null,null,[12839,12840],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_alignment",null,"",null,false],[84,539,0,null,null,null,[12842],false],[0,0,0,"self",null,"",null,false],[84,543,0,null,null,null,[12844],false],[0,0,0,"self",null,"",null,false],[84,503,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"virtual_size",null,null,null,false],[0,0,0,"virtual_address",null,null,null,false],[0,0,0,"size_of_raw_data",null,null,null,false],[0,0,0,"pointer_to_raw_data",null,null,null,false],[0,0,0,"pointer_to_relocations",null,null,null,false],[0,0,0,"pointer_to_linenumbers",null,null,null,false],[0,0,0,"number_of_relocations",null,null,null,false],[0,0,0,"number_of_linenumbers",null,null,null,false],[84,503,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[84,548,0,null,null,null,[12859,12860,12861,12862,12863,12864,12865,12866,12867,12868,12869,12871,12872,12873,12874,12875,12876,12878,12879,12880,12881,12882,12883,12884,12885,12886],false],[84,548,0,null,null,null,null,false],[0,0,0,"_reserved_0",null,null,null,false],[0,0,0,"TYPE_NO_PAD",null," The section should not be padded to the next boundary.\n This flag is obsolete and is replaced by IMAGE_SCN_ALIGN_1BYTES.\n This is valid only for object files.",null,false],[0,0,0,"_reserved_1",null,null,null,false],[0,0,0,"CNT_CODE",null," The section contains executable code.",null,false],[0,0,0,"CNT_INITIALIZED_DATA",null," The section contains initialized data.",null,false],[0,0,0,"CNT_UNINITIALIZED_DATA",null," The section contains uninitialized data.",null,false],[0,0,0,"LNK_OTHER",null," Reserved for future use.",null,false],[0,0,0,"LNK_INFO",null," The section contains comments or other information.\n The .drectve section has this type.\n This is valid for object files only.",null,false],[0,0,0,"_reserverd_2",null,null,null,false],[0,0,0,"LNK_REMOVE",null," The section will not become part of the image.\n This is valid only for object files.",null,false],[0,0,0,"LNK_COMDAT",null," The section contains COMDAT data.\n For more information, see COMDAT Sections (Object Only).\n This is valid only for object files.",null,false],[84,548,0,null,null,null,null,false],[0,0,0,"_reserved_3",null,null,null,false],[0,0,0,"GPREL",null," The section contains data referenced through the global pointer (GP).",null,false],[0,0,0,"MEM_PURGEABLE",null," Reserved for future use.",null,false],[0,0,0,"MEM_16BIT",null," Reserved for future use.",null,false],[0,0,0,"MEM_LOCKED",null," Reserved for future use.",null,false],[0,0,0,"MEM_PRELOAD",null," Reserved for future use.",null,false],[84,548,0,null,null,null,null,false],[0,0,0,"ALIGN",null," Takes on multiple values according to flags:\n pub const IMAGE_SCN_ALIGN_1BYTES: u32 = 0x100000;\n pub const IMAGE_SCN_ALIGN_2BYTES: u32 = 0x200000;\n pub const IMAGE_SCN_ALIGN_4BYTES: u32 = 0x300000;\n pub const IMAGE_SCN_ALIGN_8BYTES: u32 = 0x400000;\n pub const IMAGE_SCN_ALIGN_16BYTES: u32 = 0x500000;\n pub const IMAGE_SCN_ALIGN_32BYTES: u32 = 0x600000;\n pub const IMAGE_SCN_ALIGN_64BYTES: u32 = 0x700000;\n pub const IMAGE_SCN_ALIGN_128BYTES: u32 = 0x800000;\n pub const IMAGE_SCN_ALIGN_256BYTES: u32 = 0x900000;\n pub const IMAGE_SCN_ALIGN_512BYTES: u32 = 0xA00000;\n pub const IMAGE_SCN_ALIGN_1024BYTES: u32 = 0xB00000;\n pub const IMAGE_SCN_ALIGN_2048BYTES: u32 = 0xC00000;\n pub const IMAGE_SCN_ALIGN_4096BYTES: u32 = 0xD00000;\n pub const IMAGE_SCN_ALIGN_8192BYTES: u32 = 0xE00000;",null,false],[0,0,0,"LNK_NRELOC_OVFL",null," The section contains extended relocations.",null,false],[0,0,0,"MEM_DISCARDABLE",null," The section can be discarded as needed.",null,false],[0,0,0,"MEM_NOT_CACHED",null," The section cannot be cached.",null,false],[0,0,0,"MEM_NOT_PAGED",null," The section is not pageable.",null,false],[0,0,0,"MEM_SHARED",null," The section can be shared in memory.",null,false],[0,0,0,"MEM_EXECUTE",null," The section can be executed as code.",null,false],[0,0,0,"MEM_READ",null," The section can be read.",null,false],[0,0,0,"MEM_WRITE",null," The section can be written to.",null,false],[84,645,0,null,null,null,[12894,12895,12897,12899,12901,12902],false],[84,653,0,null,null,null,[],false],[84,657,0,null,null,null,[12890],false],[0,0,0,"self",null,"",null,false],[84,663,0,null,null,null,[12892],false],[0,0,0,"self",null,"",null,false],[84,645,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"value",null,null,null,false],[84,645,0,null,null,null,null,false],[0,0,0,"section_number",null,null,null,false],[84,645,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[84,645,0,null,null,null,null,false],[0,0,0,"storage_class",null,null,null,false],[0,0,0,"number_of_aux_symbols",null,null,null,false],[84,670,0,null,null,null,[12904,12905,12906],false],[0,0,0,"UNDEFINED",null," The symbol record is not yet assigned a section.\n A value of zero indicates that a reference to an external symbol is defined elsewhere.\n A value of non-zero is a common symbol with a size that is specified by the value.",null,false],[0,0,0,"ABSOLUTE",null," The symbol has an absolute (non-relocatable) value and is not an address.",null,false],[0,0,0,"DEBUG",null," The symbol provides general type or debugging information but does not correspond to a section.\n Microsoft tools use this setting along with .file records (storage class FILE).",null,false],[84,685,0,null,null,null,[12909,12911],false],[84,685,0,null,null,null,null,false],[0,0,0,"complex_type",null,null,null,false],[84,685,0,null,null,null,null,false],[0,0,0,"base_type",null,null,null,false],[84,690,0,null,null,null,[12913,12914,12915,12916,12917,12918,12919,12920,12921,12922,12923,12924,12925,12926,12927,12928],false],[0,0,0,"NULL",null," No type information or unknown base type. Microsoft tools use this setting",null,false],[0,0,0,"VOID",null," No valid type; used with void pointers and functions",null,false],[0,0,0,"CHAR",null," A character (signed byte)",null,false],[0,0,0,"SHORT",null," A 2-byte signed integer",null,false],[0,0,0,"INT",null," A natural integer type (normally 4 bytes in Windows)",null,false],[0,0,0,"LONG",null," A 4-byte signed integer",null,false],[0,0,0,"FLOAT",null," A 4-byte floating-point number",null,false],[0,0,0,"DOUBLE",null," An 8-byte floating-point number",null,false],[0,0,0,"STRUCT",null," A structure",null,false],[0,0,0,"UNION",null," A union",null,false],[0,0,0,"ENUM",null," An enumerated type",null,false],[0,0,0,"MOE",null," A member of enumeration (a specified value)",null,false],[0,0,0,"BYTE",null," A byte; unsigned 1-byte integer",null,false],[0,0,0,"WORD",null," A word; unsigned 2-byte integer",null,false],[0,0,0,"UINT",null," An unsigned integer of natural size (normally, 4 bytes)",null,false],[0,0,0,"DWORD",null," An unsigned 4-byte integer",null,false],[84,740,0,null,null,null,[12930,12931,12932,12933],false],[0,0,0,"NULL",null," No derived type; the symbol is a simple scalar variable.",null,false],[0,0,0,"POINTER",null," The symbol is a pointer to base type.",null,false],[0,0,0,"FUNCTION",null," The symbol is a function that returns a base type.",null,false],[0,0,0,"ARRAY",null," The symbol is an array of base type.",null,false],[84,754,0,null,null,null,[12935,12936,12937,12938,12939,12940,12941,12942,12943,12944,12945,12946,12947,12948,12949,12950,12951,12952,12953,12954,12955,12956,12957,12958,12959,12960,12961],false],[0,0,0,"END_OF_FUNCTION",null," A special symbol that represents the end of function, for debugging purposes.",null,false],[0,0,0,"NULL",null," No assigned storage class.",null,false],[0,0,0,"AUTOMATIC",null," The automatic (stack) variable. The Value field specifies the stack frame offset.",null,false],[0,0,0,"EXTERNAL",null," A value that Microsoft tools use for external symbols.\n The Value field indicates the size if the section number is IMAGE_SYM_UNDEFINED (0).\n If the section number is not zero, then the Value field specifies the offset within the section.",null,false],[0,0,0,"STATIC",null," The offset of the symbol within the section.\n If the Value field is zero, then the symbol represents a section name.",null,false],[0,0,0,"REGISTER",null," A register variable.\n The Value field specifies the register number.",null,false],[0,0,0,"EXTERNAL_DEF",null," A symbol that is defined externally.",null,false],[0,0,0,"LABEL",null," A code label that is defined within the module.\n The Value field specifies the offset of the symbol within the section.",null,false],[0,0,0,"UNDEFINED_LABEL",null," A reference to a code label that is not defined.",null,false],[0,0,0,"MEMBER_OF_STRUCT",null," The structure member. The Value field specifies the n th member.",null,false],[0,0,0,"ARGUMENT",null," A formal argument (parameter) of a function. The Value field specifies the n th argument.",null,false],[0,0,0,"STRUCT_TAG",null," The structure tag-name entry.",null,false],[0,0,0,"MEMBER_OF_UNION",null," A union member. The Value field specifies the n th member.",null,false],[0,0,0,"UNION_TAG",null," The Union tag-name entry.",null,false],[0,0,0,"TYPE_DEFINITION",null," A Typedef entry.",null,false],[0,0,0,"UNDEFINED_STATIC",null," A static data declaration.",null,false],[0,0,0,"ENUM_TAG",null," An enumerated type tagname entry.",null,false],[0,0,0,"MEMBER_OF_ENUM",null," A member of an enumeration. The Value field specifies the n th member.",null,false],[0,0,0,"REGISTER_PARAM",null," A register parameter.",null,false],[0,0,0,"BIT_FIELD",null," A bit-field reference. The Value field specifies the n th bit in the bit field.",null,false],[0,0,0,"BLOCK",null," A .bb (beginning of block) or .eb (end of block) record.\n The Value field is the relocatable address of the code location.",null,false],[0,0,0,"FUNCTION",null," A value that Microsoft tools use for symbol records that define the extent of a function: begin function (.bf ), end function ( .ef ), and lines in function ( .lf ).\n For .lf records, the Value field gives the number of source lines in the function.\n For .ef records, the Value field gives the size of the function code.",null,false],[0,0,0,"END_OF_STRUCT",null," An end-of-structure entry.",null,false],[0,0,0,"FILE",null," A value that Microsoft tools, as well as traditional COFF format, use for the source-file symbol record.\n The symbol is followed by auxiliary records that name the file.",null,false],[0,0,0,"SECTION",null," A definition of a section (Microsoft tools use STATIC storage class instead).",null,false],[0,0,0,"WEAK_EXTERNAL",null," A weak external. For more information, see Auxiliary Format 3: Weak Externals.",null,false],[0,0,0,"CLR_TOKEN",null," A CLR token symbol. The name is an ASCII string that consists of the hexadecimal value of the token.\n For more information, see CLR Token Definition (Object Only).",null,false],[84,847,0,null,null,null,[12963,12964,12965,12966,12968],false],[0,0,0,"tag_index",null," The symbol-table index of the corresponding .bf (begin function) symbol record.",null,false],[0,0,0,"total_size",null," The size of the executable code for the function itself.\n If the function is in its own section, the SizeOfRawData in the section header is greater or equal to this field,\n depending on alignment considerations.",null,false],[0,0,0,"pointer_to_linenumber",null," The file offset of the first COFF line-number entry for the function, or zero if none exists.",null,false],[0,0,0,"pointer_to_next_function",null," The symbol-table index of the record for the next function.\n If the function is the last in the symbol table, this field is set to zero.",null,false],[84,847,0,null,null,null,null,false],[0,0,0,"unused",null,null,null,false],[84,866,0,null,null,null,[12970,12971,12972,12973,12974,12976,12978],false],[0,0,0,"length",null," The size of section data; the same as SizeOfRawData in the section header.",null,false],[0,0,0,"number_of_relocations",null," The number of relocation entries for the section.",null,false],[0,0,0,"number_of_linenumbers",null," The number of line-number entries for the section.",null,false],[0,0,0,"checksum",null," The checksum for communal data. It is applicable if the IMAGE_SCN_LNK_COMDAT flag is set in the section header.",null,false],[0,0,0,"number",null," One-based index into the section table for the associated section. This is used when the COMDAT selection setting is 5.",null,false],[84,866,0,null,null,null,null,false],[0,0,0,"selection",null," The COMDAT selection number. This is applicable if the section is a COMDAT section.",null,false],[84,866,0,null,null,null,null,false],[0,0,0,"unused",null,null,null,false],[84,888,0,null,null,null,[12983],false],[84,893,0,null,null,null,[12981],false],[0,0,0,"self",null,"",null,false],[84,888,0,null,null,null,null,false],[0,0,0,"file_name",null," An ANSI string that gives the name of the source file.\n This is padded with nulls if it is less than the maximum length.",null,false],[84,899,0,null,null,null,[12985,12987,12989],false],[0,0,0,"tag_index",null," The symbol-table index of sym2, the symbol to be linked if sym1 is not found.",null,false],[84,899,0,null,null,null,null,false],[0,0,0,"flag",null," A value of IMAGE_WEAK_EXTERN_SEARCH_NOLIBRARY indicates that no library search for sym1 should be performed.\n A value of IMAGE_WEAK_EXTERN_SEARCH_LIBRARY indicates that a library search for sym1 should be performed.\n A value of IMAGE_WEAK_EXTERN_SEARCH_ALIAS indicates that sym1 is an alias for sym2.",null,false],[84,899,0,null,null,null,null,false],[0,0,0,"unused",null,null,null,false],[84,912,0,null,null,null,[12991,12992,12993,12994],false],[0,0,0,"SEARCH_NOLIBRARY",null,null,null,false],[0,0,0,"SEARCH_LIBRARY",null,null,null,false],[0,0,0,"SEARCH_ALIAS",null,null,null,false],[0,0,0,"ANTI_DEPENDENCY",null,null,null,false],[84,919,0,null,null,null,[12996,12997,12998,12999,13000,13001,13002],false],[0,0,0,"NONE",null," Not a COMDAT section.",null,false],[0,0,0,"NODUPLICATES",null," If this symbol is already defined, the linker issues a \"multiply defined symbol\" error.",null,false],[0,0,0,"ANY",null," Any section that defines the same COMDAT symbol can be linked; the rest are removed.",null,false],[0,0,0,"SAME_SIZE",null," The linker chooses an arbitrary section among the definitions for this symbol.\n If all definitions are not the same size, a \"multiply defined symbol\" error is issued.",null,false],[0,0,0,"EXACT_MATCH",null," The linker chooses an arbitrary section among the definitions for this symbol.\n If all definitions do not match exactly, a \"multiply defined symbol\" error is issued.",null,false],[0,0,0,"ASSOCIATIVE",null," The section is linked if a certain other COMDAT section is linked.\n This other section is indicated by the Number field of the auxiliary symbol record for the section definition.\n This setting is useful for definitions that have components in multiple sections\n (for example, code in one and data in another), but where all must be linked or discarded as a set.\n The other section this section is associated with must be a COMDAT section, which can be another\n associative COMDAT section. An associative COMDAT section's section association chain can't form a loop.\n The section association chain must eventually come to a COMDAT section that doesn't have IMAGE_COMDAT_SELECT_ASSOCIATIVE set.",null,false],[0,0,0,"LARGEST",null," The linker chooses the largest definition from among all of the definitions for this symbol.\n If multiple definitions have this size, the choice between them is arbitrary.",null,false],[84,951,0,null,null,null,[13005,13006,13008,13009,13011],false],[84,951,0,null,null,null,null,false],[0,0,0,"unused_1",null,null,null,false],[0,0,0,"linenumber",null," The actual ordinal line number (1, 2, 3, and so on) within the source file, corresponding to the .bf or .ef record.",null,false],[84,951,0,null,null,null,null,false],[0,0,0,"unused_2",null,null,null,false],[0,0,0,"pointer_to_next_function",null," The symbol-table index of the next .bf symbol record.\n If the function is the last in the symbol table, this field is set to zero.\n It is not used for .ef records.",null,false],[84,951,0,null,null,null,null,false],[0,0,0,"unused_3",null,null,null,false],[84,967,0,null,null,null,[13017,13018,13019,13020,13021,13022,13023,13024,13025,13026,13027,13028,13029,13030,13031,13032,13033,13034,13035,13036,13037,13038,13039,13040,13041],false],[84,1018,0,null,null,null,[13014],false],[0,0,0,"arch",null,"",null,false],[84,1033,0,null,null,null,[13016],false],[0,0,0,"machine_type",null,"",null,false],[0,0,0,"Unknown",null,null,null,false],[0,0,0,"AM33",null," Matsushita AM33",null,false],[0,0,0,"X64",null," x64",null,false],[0,0,0,"ARM",null," ARM little endian",null,false],[0,0,0,"ARM64",null," ARM64 little endian",null,false],[0,0,0,"ARMNT",null," ARM Thumb-2 little endian",null,false],[0,0,0,"EBC",null," EFI byte code",null,false],[0,0,0,"I386",null," Intel 386 or later processors and compatible processors",null,false],[0,0,0,"IA64",null," Intel Itanium processor family",null,false],[0,0,0,"M32R",null," Mitsubishi M32R little endian",null,false],[0,0,0,"MIPS16",null," MIPS16",null,false],[0,0,0,"MIPSFPU",null," MIPS with FPU",null,false],[0,0,0,"MIPSFPU16",null," MIPS16 with FPU",null,false],[0,0,0,"POWERPC",null," Power PC little endian",null,false],[0,0,0,"POWERPCFP",null," Power PC with floating point support",null,false],[0,0,0,"R4000",null," MIPS little endian",null,false],[0,0,0,"RISCV32",null," RISC-V 32-bit address space",null,false],[0,0,0,"RISCV64",null," RISC-V 64-bit address space",null,false],[0,0,0,"RISCV128",null," RISC-V 128-bit address space",null,false],[0,0,0,"SH3",null," Hitachi SH3",null,false],[0,0,0,"SH3DSP",null," Hitachi SH3 DSP",null,false],[0,0,0,"SH4",null," Hitachi SH4",null,false],[0,0,0,"SH5",null," Hitachi SH5",null,false],[0,0,0,"Thumb",null," Thumb",null,false],[0,0,0,"WCEMIPSV2",null," MIPS little-endian WCE v2",null,false],[84,1049,0,null,null,null,null,false],[84,1059,0,null,null,null,[13089,13090,13091,13092,13094,13095],false],[84,1070,0,null,null,null,[13045,13046],false],[0,0,0,"data",null,"",null,false],[0,0,0,"is_loaded",null,"",null,false],[84,1103,0,null,null,null,[13048,13049],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[84,1160,0,null,null,null,[13051],false],[0,0,0,"self",null,"",null,false],[84,1164,0,null,null,null,[13053],false],[0,0,0,"self",null,"",null,false],[84,1170,0,null,null,null,[13055],false],[0,0,0,"self",null,"",null,false],[84,1176,0,null,null,null,[13057],false],[0,0,0,"self",null,"",null,false],[84,1182,0,null,null,null,[13059],false],[0,0,0,"self",null,"",null,false],[84,1191,0,null,null,null,[13061],false],[0,0,0,"self",null,"",null,false],[84,1200,0,null,null,null,[13063],false],[0,0,0,"self",null,"",null,false],[84,1211,0,null,null,null,[13065],false],[0,0,0,"self",null,"",null,false],[84,1220,0,null,null,null,[13067],false],[0,0,0,"self",null,"",null,false],[84,1231,0,null,null,null,[13069],false],[0,0,0,"self",null,"",null,false],[84,1236,0,null,null,null,[13071],false],[0,0,0,"self",null,"",null,false],[84,1242,0,null,null,null,[13073,13074],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[84,1252,0,null,null,null,[13076,13077],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sect_hdr",null,"",null,false],[84,1261,0,null,null,null,[13079,13080],false],[0,0,0,"self",null,"",null,false],[0,0,0,"name",null,"",null,true],[84,1273,0,null,null,null,[13082,13083],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sec",null,"",null,false],[84,1278,0,null,null,null,[13085,13086,13087],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sec",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[84,1059,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"is_loaded",null,null,null,false],[0,0,0,"is_image",null,null,null,false],[0,0,0,"coff_header_offset",null,null,null,false],[84,1059,0,null,null,null,null,false],[0,0,0,"guid",null,null,null,false],[0,0,0,"age",null,null,null,false],[84,1284,0,null,null,null,[13141],false],[84,1287,0,null,null,null,[13098],false],[0,0,0,"self",null,"",null,false],[84,1291,0,null,null,null,[13100,13101,13102,13103,13104,13105],false],[0,0,0,"symbol",null,null,null,false],[0,0,0,"debug_info",null,null,null,false],[0,0,0,"func_def",null,null,null,false],[0,0,0,"weak_ext",null,null,null,false],[0,0,0,"file_def",null,null,null,false],[0,0,0,"sect_def",null,null,null,false],[84,1300,0,null,null,null,[13107,13108,13109,13110,13111,13112],false],[0,0,0,"symbol",null,null,null,false],[0,0,0,"debug_info",null,null,null,false],[0,0,0,"func_def",null,null,null,false],[0,0,0,"weak_ext",null,null,null,false],[0,0,0,"file_def",null,null,null,false],[0,0,0,"sect_def",null,null,null,false],[84,1310,0,null,null," Lives as long as Symtab instance.",[13114,13115,13116],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"tag",null,"",null,false],[84,1323,0,null,null,null,[13118],false],[0,0,0,"raw",null,"",null,false],[84,1334,0,null,null,null,[13120],false],[0,0,0,"raw",null,"",null,false],[84,1344,0,null,null,null,[13122],false],[0,0,0,"raw",null,"",null,false],[84,1354,0,null,null,null,[13124],false],[0,0,0,"raw",null,"",null,false],[84,1362,0,null,null,null,[13126],false],[0,0,0,"raw",null,"",null,false],[84,1368,0,null,null,null,[13128],false],[0,0,0,"raw",null,"",null,false],[84,1380,0,null,null,null,[13133,13134,13135],false],[84,1386,0,null,null," Lives as long as Symtab instance.",[13131],false],[0,0,0,"self",null,"",null,false],[84,1380,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[0,0,0,"num",null,null,null,false],[0,0,0,"count",null,null,null,false],[84,1395,0,null,null,null,[13137,13138,13139],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[84,1284,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[84,1403,0,null,null,null,[13147],false],[84,1406,0,null,null,null,[13144,13145],false],[0,0,0,"self",null,"",null,false],[0,0,0,"off",null,"",null,false],[84,1403,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[1,75,0,null,null," Compression algorithms such as zlib, zstd, etc.",null,false],[0,0,0,"compress.zig",null,"",[],false],[85,0,0,null,null,null,null,false],[85,2,0,null,null,null,null,false],[0,0,0,"compress/deflate.zig",null," The deflate package is a translation of the Go code of the compress/flate package from\n https://go.googlesource.com/go/+/refs/tags/go1.17/src/compress/flate/\n",[],false],[86,3,0,null,null,null,null,false],[0,0,0,"deflate/compressor.zig",null,"",[],false],[87,0,0,null,null,null,null,false],[87,1,0,null,null,null,null,false],[87,2,0,null,null,null,null,false],[87,3,0,null,null,null,null,false],[87,4,0,null,null,null,null,false],[87,5,0,null,null,null,null,false],[87,7,0,null,null,null,null,false],[87,9,0,null,null,null,null,false],[0,0,0,"deflate_const.zig",null,"",[],false],[88,3,0,null,null,null,null,false],[88,5,0,null,null,null,null,false],[88,10,0,null,null,null,null,false],[88,12,0,null,null,null,null,false],[88,14,0,null,null,null,null,false],[88,16,0,null,null,null,null,false],[88,21,0,null,null,null,null,false],[88,25,0,null,null,null,null,false],[88,27,0,null,null,null,null,false],[87,10,0,null,null,null,null,false],[0,0,0,"deflate_fast.zig",null,"",[],false],[89,3,0,null,null,null,null,false],[89,4,0,null,null,null,null,false],[89,5,0,null,null,null,null,false],[89,7,0,null,null,null,null,false],[89,9,0,null,null,null,null,false],[89,10,0,null,null,null,null,false],[89,11,0,null,null,null,null,false],[0,0,0,"token.zig",null,"",[],false],[90,3,0,null,null,null,null,false],[90,4,0,null,null,null,null,false],[90,5,0,null,null,null,null,false],[90,6,0,null,null,null,null,false],[90,10,0,null,null,null,null,false],[90,39,0,null,null,null,null,false],[90,58,0,null,null,null,null,false],[90,61,0,null,null,null,[13191],false],[0,0,0,"lit",null,"",null,false],[90,66,0,null,null,null,[13193,13194],false],[0,0,0,"xlength",null,"",null,false],[0,0,0,"xoffset",null,"",null,false],[90,71,0,null,null,null,[13196],false],[0,0,0,"t",null,"",null,false],[90,76,0,null,null,null,[13198],false],[0,0,0,"t",null,"",null,false],[90,80,0,null,null,null,[13200],false],[0,0,0,"t",null,"",null,false],[90,84,0,null,null,null,[13202],false],[0,0,0,"len",null,"",null,false],[90,89,0,null,null,null,[13204],false],[0,0,0,"off",null,"",null,false],[89,13,0,null,null,null,null,false],[89,14,0,null,null,null,null,false],[89,15,0,null,null,null,null,false],[89,16,0,null,null,null,null,false],[89,17,0,null,null,null,null,false],[89,19,0,null,null,null,null,false],[89,20,0,null,null,null,null,false],[89,21,0,null,null,null,null,false],[89,22,0,null,null,null,null,false],[89,29,0,null,null,null,null,false],[89,31,0,null,null,null,[13216,13217],false],[0,0,0,"b",null,"",null,false],[0,0,0,"i",null,"",null,false],[89,39,0,null,null,null,[13219,13220],false],[0,0,0,"b",null,"",null,false],[0,0,0,"i",null,"",null,false],[89,51,0,null,null,null,[13222],false],[0,0,0,"u",null,"",null,false],[89,59,0,null,null,null,null,false],[89,60,0,null,null,null,null,false],[89,62,0,null,null,null,[13226,13227],false],[0,0,0,"val",null,null,null,false],[0,0,0,"offset",null,null,null,false],[89,67,0,null,null,null,[],false],[89,79,0,null,null,null,[13255,13257,13258,13259,13261],false],[89,86,0,null,null,null,null,false],[89,88,0,null,null,null,[13232,13233],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[89,94,0,null,null,null,[13235],false],[0,0,0,"self",null,"",null,false],[89,100,0,null,null,null,[13237,13238,13239,13240],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"tokens_count",null,"",null,false],[0,0,0,"src",null,"",null,false],[89,243,0,null,null,null,[13242,13243,13244],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"tokens_count",null,"",null,false],[0,0,0,"lit",null,"",null,false],[89,254,0,null,null,null,[13246,13247,13248,13249],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"t",null,"",null,false],[0,0,0,"src",null,"",null,false],[89,313,0,null,null,null,[13251],false],[0,0,0,"self",null,"",null,false],[89,329,0,null,null,null,[13253],false],[0,0,0,"self",null,"",null,false],[89,79,0,null,null,null,null,false],[0,0,0,"table",null,null,null,false],[89,79,0,null,null,null,null,false],[0,0,0,"prev",null,null,null,false],[0,0,0,"prev_len",null,null,null,false],[0,0,0,"cur",null,null,null,false],[89,79,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[87,11,0,null,null,null,null,false],[0,0,0,"huffman_bit_writer.zig",null,"",[],false],[91,0,0,null,null,null,null,false],[91,1,0,null,null,null,null,false],[91,2,0,null,null,null,null,false],[91,4,0,null,null,null,null,false],[91,6,0,null,null,null,null,false],[91,7,0,null,null,null,null,false],[0,0,0,"huffman_code.zig",null,"",[],false],[92,0,0,null,null,null,null,false],[92,1,0,null,null,null,null,false],[92,2,0,null,null,null,null,false],[92,3,0,null,null,null,null,false],[92,4,0,null,null,null,null,false],[92,5,0,null,null,null,null,false],[92,7,0,null,null,null,null,false],[92,9,0,null,null,null,null,false],[0,0,0,"bits_utils.zig",null,"",[],false],[93,0,0,null,null,null,null,false],[93,3,0,null,null,null,[13282,13283,13284],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[0,0,0,"N",null,"",null,false],[92,10,0,null,null,null,null,false],[92,12,0,null,null,null,null,false],[92,14,0,null,null,null,[13288,13289],false],[0,0,0,"literal",null,null,null,false],[0,0,0,"freq",null,null,null,false],[92,20,0,null,null,null,[13291,13292,13293,13294,13295],false],[0,0,0,"level",null,null,null,false],[0,0,0,"last_freq",null,null,null,false],[0,0,0,"next_char_freq",null,null,null,false],[0,0,0,"next_pair_freq",null,null,null,false],[0,0,0,"needed",null,null,null,false],[92,40,0,null,null,null,[13301,13302],false],[92,45,0,null,null,null,[13298,13299,13300],false],[0,0,0,"self",null,"",null,false],[0,0,0,"code",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"code",null,null,null,false],[0,0,0,"len",null,null,null,false],[92,51,0,null,null,null,[13322,13324,13326,13328,13330,13332],false],[92,59,0,null,null,null,[13305],false],[0,0,0,"self",null,"",null,false],[92,68,0,null,null,null,[13307,13308,13309],false],[0,0,0,"self",null,"",null,false],[0,0,0,"freq",null,"",null,false],[0,0,0,"max_bits",null,"",null,false],[92,103,0,null,null,null,[13311,13312],false],[0,0,0,"self",null,"",null,false],[0,0,0,"freq",null,"",null,false],[92,128,0,null,null,null,[13314,13315,13316],false],[0,0,0,"self",null,"",null,false],[0,0,0,"list",null,"",null,false],[0,0,0,"max_bits_to_use",null,"",null,false],[92,256,0,null,null,null,[13318,13319,13320],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"list_arg",null,"",null,false],[92,51,0,null,null,null,null,false],[0,0,0,"codes",null,null,null,false],[92,51,0,null,null,null,null,false],[0,0,0,"freq_cache",null,null,null,false],[92,51,0,null,null,null,null,false],[0,0,0,"bit_count",null,null,null,false],[92,51,0,null,null,null,null,false],[0,0,0,"lns",null,null,null,false],[92,51,0,null,null,null,null,false],[0,0,0,"lfs",null,null,null,false],[92,51,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[92,286,0,null,null,null,[],false],[92,293,0,null,null,null,[13335,13336],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"size",null,"",null,false],[92,304,0,null,null,null,[13338],false],[0,0,0,"allocator",null,"",null,false],[92,339,0,null,null,null,[13340],false],[0,0,0,"allocator",null,"",null,false],[92,348,0,null,null,null,[13342,13343,13344],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[92,353,0,null,null,null,[13346,13347,13348],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[91,8,0,null,null,null,null,false],[91,11,0,null,null,null,null,false],[91,14,0,null,null,null,null,false],[91,15,0,null,null,null,null,false],[91,21,0,null,null,null,null,false],[91,26,0,null,null,null,null,false],[91,29,0,null,null,null,null,false],[91,37,0,null,null,null,null,false],[91,44,0,null,null,null,null,false],[91,50,0,null,null,null,null,false],[91,60,0,null,null,null,null,false],[91,62,0,null,null,null,[13361],false],[0,0,0,"WriterType",null,"",[13439,13440,13441,13442,13444,13446,13447,13449,13451,13453,13455,13457,13459,13460,13462,13464,13466,13468],true],[91,64,0,null,null,null,null,false],[91,65,0,null,null,null,null,false],[91,93,0,null,null,null,[13365,13366],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_writer",null,"",null,false],[91,102,0,null,null,null,[13368],false],[0,0,0,"self",null,"",null,false],[91,123,0,null,null,null,[13370,13371],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[91,130,0,null,null,null,[13373,13374,13375],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"nb",null,"",null,false],[91,157,0,null,null,null,[13377,13378],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[91,192,0,null,null,null,[13380,13381,13382,13383,13384],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_literals",null,"",null,false],[0,0,0,"num_offsets",null,"",null,false],[0,0,0,"lit_enc",null,"",null,false],[0,0,0,"off_enc",null,"",null,false],[91,288,0,null,null,null,[13386,13387,13388,13389],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lit_enc",null,"",null,false],[0,0,0,"off_enc",null,"",null,false],[0,0,0,"extra_bits",null,"",null,false],[91,315,0,null,null,null,[13391,13392],false],[0,0,0,"self",null,"",null,false],[0,0,0,"extra_bits",null,"",null,false],[91,325,0,null,null,null,[13394],false],[0,0,0,"in",null,"",null,false],[91,335,0,null,null,null,[13396,13397],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c",null,"",null,false],[91,368,0,null,null,null,[13399,13400,13401,13402,13403],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_literals",null,"",null,false],[0,0,0,"num_offsets",null,"",null,false],[0,0,0,"num_codegens",null,"",null,false],[0,0,0,"is_eof",null,"",null,false],[91,420,0,null,null,null,[13405,13406,13407],false],[0,0,0,"self",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"is_eof",null,"",null,false],[91,434,0,null,null,null,[13409,13410],false],[0,0,0,"self",null,"",null,false],[0,0,0,"is_eof",null,"",null,false],[91,451,0,null,null,null,[13412,13413,13414,13415],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tokens",null,"",null,false],[0,0,0,"eof",null,"",null,false],[0,0,0,"input",null,"",null,false],[91,544,0,null,null,null,[13417,13418,13419,13420],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tokens",null,"",null,false],[0,0,0,"eof",null,"",null,false],[0,0,0,"input",null,"",null,false],[91,589,0,null,null,null,[13422,13423],false],[0,0,0,"num_literals",null,null,null,false],[0,0,0,"num_offsets",null,null,null,false],[91,598,0,null,null,null,[13425,13426],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tokens",null,"",null,false],[91,648,0,null,null,null,[13428,13429,13430,13431],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tokens",null,"",null,false],[0,0,0,"le_codes",null,"",null,false],[0,0,0,"oe_codes",null,"",null,false],[91,687,0,null,null,null,[13433,13434,13435],false],[0,0,0,"self",null,"",null,false],[0,0,0,"eof",null,"",null,false],[0,0,0,"input",null,"",null,false],[91,774,0,null,null,null,[13437],false],[0,0,0,"self",null,"",null,false],[91,63,0,null,null,null,null,false],[0,0,0,"inner_writer",null,null,null,false],[0,0,0,"bytes_written",null,null,null,false],[0,0,0,"bits",null,null,null,false],[0,0,0,"nbits",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"codegen_freq",null,null,null,false],[0,0,0,"nbytes",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"literal_freq",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"offset_freq",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"codegen",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"literal_encoding",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"offset_encoding",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"codegen_encoding",null,null,null,false],[0,0,0,"err",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"fixed_literal_encoding",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"fixed_offset_encoding",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[91,63,0,null,null,null,null,false],[0,0,0,"huff_offset",null,null,null,false],[91,788,0,null,null,null,[13470,13471],false],[0,0,0,"size",null,null,null,false],[0,0,0,"num_codegens",null,null,null,false],[91,793,0,null,null,null,[13473,13474],false],[0,0,0,"size",null,null,null,false],[0,0,0,"storable",null,null,null,false],[91,798,0,null,null,null,[13476,13477],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"writer",null,"",null,false],[91,830,0,null,null,null,[13479,13480],false],[0,0,0,"b",null,"",null,false],[0,0,0,"h",null,"",null,false],[91,838,0,null,null,null,null,false],[91,839,0,null,null,null,null,false],[91,840,0,null,null,null,null,false],[91,841,0,null,null,null,null,false],[91,842,0,null,null,null,null,false],[91,844,0,null,null,null,null,false],[91,888,0,null,null,null,[13488,13489],false],[0,0,0,"in_name",null,"",null,true],[0,0,0,"want_name",null,"",null,true],[91,916,0,null,null,null,[13492,13494,13496,13498],false],[91,916,0,null,null,null,null,false],[0,0,0,"tokens",null,null,null,false],[91,916,0,null,null,null,null,false],[0,0,0,"input",null,null,null,false],[91,916,0,null,null,null,null,false],[0,0,0,"want",null,null,null,false],[91,916,0,null,null,null,null,false],[0,0,0,"want_no_input",null,null,null,false],[91,923,0,null,null,null,null,false],[91,925,0,null,null,null,null,false],[91,1556,0,null,null,null,[13504,13505,13506],false],[91,1561,0,null,null,null,[13503],false],[0,0,0,"self",null,"",null,false],[0,0,0,"write_block",null,null,null,false],[0,0,0,"write_dyn_block",null,null,null,false],[0,0,0,"write_huffman_block",null,null,null,false],[91,1602,0,null,null,null,[13508,13509],false],[0,0,0,"ht",null,"",null,true],[0,0,0,"ttype",null,"",null,true],[91,1658,0,null,null,null,[13511,13512,13513,13514],false],[0,0,0,"ttype",null,"",null,false],[0,0,0,"bw",null,"",null,false],[0,0,0,"tok",null,"",null,false],[0,0,0,"input",null,"",null,false],[91,1668,0,null,null,null,[13516,13517,13518],false],[0,0,0,"ttype",null,"",null,false],[0,0,0,"ht_tokens",null,"",null,false],[0,0,0,"input",null,"",null,false],[87,12,0,null,null,null,null,false],[87,14,0,null,null,null,[13521,13522,13523,13524,13525,13526,13527,13528,13529,13530,13531,13532],false],[0,0,0,"huffman_only",null," huffman_only disables Lempel-Ziv match searching and only performs Huffman\n entropy encoding. This mode is useful in compressing data that has\n already been compressed with an LZ style algorithm (e.g. Snappy or LZ4)\n that lacks an entropy encoder. Compression gains are achieved when\n certain bytes in the input stream occur more frequently than others.\n\n Note that huffman_only produces a compressed output that is\n RFC 1951 compliant. That is, any valid DEFLATE decompressor will\n continue to be able to decompress this output.",null,false],[0,0,0,"default_compression",null," Same as level_6",null,false],[0,0,0,"no_compression",null," Does not attempt any compression; only adds the necessary DEFLATE framing.",null,false],[0,0,0,"best_speed",null," Prioritizes speed over output size, based on Snappy's LZ77-style encoder",null,false],[0,0,0,"level_2",null,null,null,false],[0,0,0,"level_3",null,null,null,false],[0,0,0,"level_4",null,null,null,false],[0,0,0,"level_5",null,null,null,false],[0,0,0,"level_6",null,null,null,false],[0,0,0,"level_7",null,null,null,false],[0,0,0,"level_8",null,null,null,false],[0,0,0,"best_compression",null," Prioritizes smaller output size over speed",null,false],[87,42,0,null,null,null,null,false],[87,43,0,null,null,null,null,false],[87,44,0,null,null,null,null,false],[87,52,0,null,null,null,null,false],[87,53,0,null,null,null,null,false],[87,54,0,null,null,null,null,false],[87,55,0,null,null,null,null,false],[87,56,0,null,null,null,null,false],[87,60,0,null,null,null,null,false],[87,61,0,null,null,null,null,false],[87,62,0,null,null,null,null,false],[87,63,0,null,null,null,null,false],[87,64,0,null,null,null,null,false],[87,65,0,null,null,null,null,false],[87,67,0,null,null,null,null,false],[87,69,0,null,null,null,[13549,13550,13551,13552,13553],false],[0,0,0,"good",null,null,null,false],[0,0,0,"lazy",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"chain",null,null,null,false],[0,0,0,"fast_skip_hashshing",null,null,null,false],[87,77,0,null,null,null,[13555],false],[0,0,0,"compression",null,"",null,false],[87,157,0,null,null,null,[13557,13558,13559],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"max",null,"",null,false],[87,168,0,null,null,null,null,false],[87,173,0,null,null,null,[13562],false],[0,0,0,"b",null,"",null,false],[87,182,0,null,null,null,[13564,13565],false],[0,0,0,"b",null,"",null,false],[0,0,0,"dst",null,"",null,false],[87,203,0,null,null,null,[13568,13570],false],[87,203,0,null,null,null,null,false],[0,0,0,"level",null,null,null,false],[87,203,0,null,null,null,null,false],[0,0,0,"dictionary",null,null,null,false],[87,224,0,null,null," Returns a new Compressor compressing data at the given level.\n Following zlib, levels range from 1 (best_speed) to 9 (best_compression);\n higher levels typically run slower but compress more. Level 0\n (no_compression) does not attempt any compression; it only adds the\n necessary DEFLATE framing.\n Level -1 (default_compression) uses the default compression level.\n Level -2 (huffman_only) will use Huffman compression only, giving\n a very fast compression for all types of input, but sacrificing considerable\n compression efficiency.\n\n `dictionary` is optional and initializes the new `Compressor` with a preset dictionary.\n The returned Compressor behaves as if the dictionary had been written to it without producing\n any compressed output. The compressed data written to hm_bw can only be decompressed by a\n Decompressor initialized with the same dictionary.\n\n The compressed data will be passed to the provided `writer`, see `writer()` and `write()`.",[13572,13573,13574],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"options",null,"",null,false],[87,232,0,null,null,null,[13576],false],[0,0,0,"WriterType",null,"",[13642,13644,13646,13648,13652,13653,13655,13656,13658,13660,13661,13662,13664,13665,13666,13667,13669,13670,13671,13672,13673,13674,13675,13677,13679],true],[87,234,0,null,null,null,null,false],[87,238,0,null,null," A Writer takes data written to it and writes the compressed\n form of that data to an underlying writer.",null,false],[87,242,0,null,null," Returns a Writer that takes data written to it and writes the compressed\n form of that data to an underlying writer.",[13580],false],[0,0,0,"self",null,"",null,false],[87,246,0,null,null,null,null,false],[87,294,0,null,null,null,[13583,13584],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[87,334,0,null,null,null,[13586,13587,13588],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tokens",null,"",null,false],[0,0,0,"index",null,"",null,false],[87,351,0,null,null,null,[13590,13591],false],[0,0,0,"self",null,"",null,false],[0,0,0,"in_b",null,"",null,false],[87,409,0,null,null,null,[13593,13594,13595],false],[0,0,0,"length",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"ok",null,null,null,false],[87,417,0,null,null,null,[13597,13598,13599,13600,13601],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pos",null,"",null,false],[0,0,0,"prev_head",null,"",null,false],[0,0,0,"prev_length",null,"",null,false],[0,0,0,"lookahead",null,"",null,false],[87,486,0,null,null,null,[13603,13604],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[87,493,0,null,null,null,[13606],false],[0,0,0,"self",null,"",null,false],[87,539,0,null,null,null,[13608],false],[0,0,0,"self",null,"",null,false],[87,554,0,null,null,null,[13610],false],[0,0,0,"self",null,"",null,false],[87,706,0,null,null,null,[13612,13613],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[87,712,0,null,null,null,[13615],false],[0,0,0,"self",null,"",null,false],[87,721,0,null,null,null,[13617],false],[0,0,0,"self",null,"",null,false],[87,730,0,null,null,null,[13619],false],[0,0,0,"self",null,"",null,false],[87,735,0,null,null," Writes the compressed form of `input` to the underlying writer.",[13621,13622],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[87,758,0,null,null," Flushes any pending data to the underlying writer.\n It is useful mainly in compressed network protocols, to ensure that\n a remote reader has enough data to reconstruct a packet.\n Flush does not return until the data has been written.\n Calling `flush()` when there is no pending data still causes the Writer\n to emit a sync marker of at least 4 bytes.\n If the underlying writer returns an error, `flush()` returns that error.\n\n In the terminology of the zlib library, Flush is equivalent to Z_SYNC_FLUSH.",[13624],false],[0,0,0,"self",null,"",null,false],[87,767,0,null,null,null,[13626],false],[0,0,0,"self",null,"",null,false],[87,785,0,null,null,null,[13628,13629],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[87,803,0,null,null,null,[13631,13632,13633],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_writer",null,"",null,false],[0,0,0,"options",null,"",null,false],[87,897,0,null,null," Release all allocated memory.",[13635],false],[0,0,0,"self",null,"",null,false],[87,912,0,null,null," Reset discards the inner writer's state and replace the inner writer with new_writer.\n new_writer must be of the same type as the previous writer.",[13637,13638],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_writer",null,"",null,false],[87,958,0,null,null," Writes any pending data to the underlying writer.",[13640],false],[0,0,0,"self",null,"",null,false],[87,233,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"compression",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"compression_level",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"hm_bw",null,null,null,false],[87,233,0,null,null,null,[13650,13651],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"bulk_hasher",null,null,null,false],[0,0,0,"sync",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"best_speed_enc",null,null,null,false],[0,0,0,"chain_head",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"hash_head",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"hash_prev",null,null,null,false],[0,0,0,"hash_offset",null,null,null,false],[0,0,0,"index",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"window",null,null,null,false],[0,0,0,"window_end",null,null,null,false],[0,0,0,"block_start",null,null,null,false],[0,0,0,"byte_available",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"tokens",null,null,null,false],[0,0,0,"tokens_count",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"hash",null,null,null,false],[0,0,0,"max_insert_index",null,null,null,false],[0,0,0,"err",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"hash_match",null,null,null,false],[87,233,0,null,null,null,null,false],[0,0,0,"dictionary",null,null,null,false],[87,970,0,null,null,null,null,false],[87,971,0,null,null,null,null,false],[87,973,0,null,null,null,null,false],[87,975,0,null,null,null,[13685,13687,13689],false],[87,975,0,null,null,null,null,false],[0,0,0,"in",null,null,null,false],[87,975,0,null,null,null,null,false],[0,0,0,"level",null,null,null,false],[87,975,0,null,null,null,null,false],[0,0,0,"out",null,null,null,false],[87,981,0,null,null,null,null,false],[86,4,0,null,null,null,null,false],[0,0,0,"deflate/decompressor.zig",null,"",[],false],[94,0,0,null,null,null,null,false],[94,1,0,null,null,null,null,false],[94,2,0,null,null,null,null,false],[94,3,0,null,null,null,null,false],[94,5,0,null,null,null,null,false],[94,6,0,null,null,null,null,false],[94,8,0,null,null,null,null,false],[94,9,0,null,null,null,null,false],[0,0,0,"dict_decoder.zig",null,"",[],false],[95,0,0,null,null,null,null,false],[95,1,0,null,null,null,null,false],[95,2,0,null,null,null,null,false],[95,4,0,null,null,null,null,false],[95,26,0,null,null,null,[13743,13745,13746,13747,13748],false],[95,27,0,null,null,null,null,false],[95,41,0,null,null,null,[13709,13710,13711,13712],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"dict",null,"",null,false],[95,61,0,null,null,null,[13714],false],[0,0,0,"self",null,"",null,false],[95,66,0,null,null,null,[13716],false],[0,0,0,"self",null,"",null,false],[95,74,0,null,null,null,[13718],false],[0,0,0,"self",null,"",null,false],[95,79,0,null,null,null,[13720],false],[0,0,0,"self",null,"",null,false],[95,86,0,null,null,null,[13722],false],[0,0,0,"self",null,"",null,false],[95,93,0,null,null,null,[13724,13725],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[95,101,0,null,null,null,[13727,13728],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[95,109,0,null,null," TODO: eliminate this function because the callsites should care about whether\n or not their arguments alias and then they should directly call `@memcpy` or\n `mem.copyForwards`.",[13730,13731],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[95,123,0,null,null,null,[13733,13734,13735],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dist",null,"",null,false],[0,0,0,"length",null,"",null,false],[95,175,0,null,null,null,[13737,13738,13739],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dist",null,"",null,false],[0,0,0,"length",null,"",null,false],[95,196,0,null,null,null,[13741],false],[0,0,0,"self",null,"",null,false],[95,26,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[95,26,0,null,null,null,null,false],[0,0,0,"hist",null,null,null,false],[0,0,0,"wr_pos",null,null,null,false],[0,0,0,"rd_pos",null,null,null,false],[0,0,0,"full",null,null,null,false],[94,10,0,null,null,null,null,false],[94,12,0,null,null,null,null,false],[94,13,0,null,null,null,null,false],[94,15,0,null,null,null,null,false],[94,19,0,null,null,null,null,false],[94,20,0,null,null,null,null,false],[94,21,0,null,null,null,null,false],[94,23,0,null,null,null,null,false],[94,25,0,null,null,null,null,false],[94,53,0,null,null,null,null,false],[94,54,0,null,null,null,null,false],[94,55,0,null,null,null,null,false],[94,56,0,null,null,null,null,false],[94,58,0,null,null,null,[13771,13772,13774,13776,13777,13778,13780],false],[94,59,0,null,null,null,null,false],[94,75,0,null,null,null,[13765,13766,13767],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"lengths",null,"",null,false],[94,242,0,null,null," Release all allocated memory.",[13769],false],[0,0,0,"self",null,"",null,false],[94,58,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[0,0,0,"min",null,null,null,false],[94,58,0,null,null,null,null,false],[0,0,0,"chunks",null,null,null,false],[94,58,0,null,null,null,null,false],[0,0,0,"links",null,null,null,false],[0,0,0,"link_mask",null,null,null,false],[0,0,0,"initialized",null,null,null,false],[94,58,0,null,null,null,null,false],[0,0,0,"sub_chunks",null,null,null,false],[94,254,0,null,null,null,null,false],[94,256,0,null,null,null,[13783],false],[0,0,0,"allocator",null,"",null,false],[94,282,0,null,null,null,[13785,13786],false],[0,0,0,"init",null,null,null,false],[0,0,0,"dict",null,null,null,false],[94,294,0,null,null," Returns a new Decompressor that can be used to read the uncompressed version of `reader`.\n `dictionary` is optional and initializes the Decompressor with a preset dictionary.\n The returned Decompressor behaves as if the uncompressed data stream started with the given\n dictionary, which has already been read. Use the same `dictionary` as the compressor used to\n compress the data.\n This decompressor may use at most 300 KiB of heap memory from the provided allocator.\n The uncompressed data will be written into the provided buffer, see `reader()` and `read()`.",[13788,13789,13790],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"dictionary",null,"",null,false],[94,298,0,null,null,null,[13792],false],[0,0,0,"ReaderType",null,"",[13832,13834,13835,13836,13837,13839,13841,13843,13845,13847,13849,13852,13854,13855,13857,13859,13861,13863,13864,13865],true],[94,300,0,null,null,null,null,false],[94,302,0,null,null,null,null,false],[94,307,0,null,null,null,null,false],[94,349,0,null,null," Returns a Reader that reads compressed data from an underlying reader and outputs\n uncompressed data.",[13797],false],[0,0,0,"self",null,"",null,false],[94,353,0,null,null,null,[13799,13800,13801],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_reader",null,"",null,false],[0,0,0,"dict",null,"",null,false],[94,401,0,null,null," Release all allocated memory.",[13803],false],[0,0,0,"self",null,"",null,false],[94,409,0,null,null,null,[13805],false],[0,0,0,"self",null,"",null,false],[94,449,0,null,null," Reads compressed data from the underlying reader and outputs uncompressed data into\n `output`.",[13807,13808],false],[0,0,0,"self",null,"",null,false],[0,0,0,"output",null,"",null,false],[94,479,0,null,null,null,[13810],false],[0,0,0,"self",null,"",null,false],[94,489,0,null,null,null,null,false],[94,491,0,null,null,null,[13813],false],[0,0,0,"self",null,"",null,false],[94,615,0,null,null,null,[13815],false],[0,0,0,"self",null,"",null,false],[94,752,0,null,null,null,[13817],false],[0,0,0,"self",null,"",null,false],[94,785,0,null,null,null,[13819],false],[0,0,0,"self",null,"",null,false],[94,810,0,null,null,null,[13821],false],[0,0,0,"self",null,"",null,false],[94,820,0,null,null,null,[13823],false],[0,0,0,"self",null,"",null,false],[94,834,0,null,null,null,[13825,13826],false],[0,0,0,"self",null,"",null,false],[0,0,0,"h",null,"",null,false],[94,882,0,null,null," Replaces the inner reader and dictionary with new_reader and new_dict.\n new_reader must be of the same type as the reader being replaced.",[13828,13829,13830],false],[0,0,0,"s",null,"",null,false],[0,0,0,"new_reader",null,"",null,false],[0,0,0,"new_dict",null,"",null,false],[94,299,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"inner_reader",null,null,null,false],[0,0,0,"roffset",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"nb",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"hd1",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"hd2",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"bits",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"codebits",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"dict",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[94,299,0,null,null,null,[13851],false],[0,0,0,"",null,"",null,false],[0,0,0,"step",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"step_state",null,null,null,false],[0,0,0,"final",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"err",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"to_read",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"hl",null,null,null,false],[94,299,0,null,null,null,null,false],[0,0,0,"hd",null,null,null,false],[0,0,0,"copy_len",null,null,null,false],[0,0,0,"copy_dist",null,null,null,false],[94,896,0,null,null,null,null,false],[94,897,0,null,null,null,null,false],[94,898,0,null,null,null,null,false],[94,1083,0,null,null,null,[13870],false],[0,0,0,"input",null,"",null,false],[86,6,0,null,null,null,null,false],[86,7,0,null,null,null,null,false],[86,8,0,null,null,null,null,false],[86,9,0,null,null,null,null,false],[86,11,0,null,null,null,null,false],[86,12,0,null,null,null,null,false],[86,18,0,null,null," Copies elements from a source `src` slice into a destination `dst` slice.\n The copy never returns an error but might not be complete if the destination is too small.\n Returns the number of elements copied, which will be the minimum of `src.len` and `dst.len`.\n TODO: remove this smelly function",[13878,13879],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[85,3,0,null,null,null,null,false],[0,0,0,"compress/gzip.zig",null,"",[],false],[96,3,0,null,null,null,null,false],[96,4,0,null,null,null,null,false],[96,5,0,null,null,null,null,false],[96,6,0,null,null,null,null,false],[96,7,0,null,null,null,null,false],[96,8,0,null,null,null,null,false],[96,11,0,null,null,null,null,false],[96,12,0,null,null,null,null,false],[96,13,0,null,null,null,null,false],[96,14,0,null,null,null,null,false],[96,15,0,null,null,null,null,false],[96,17,0,null,null,null,null,false],[96,19,0,null,null,null,[13895],false],[0,0,0,"ReaderType",null,"",[13910,13912,13914,13916,13917,13927],true],[96,21,0,null,null,null,null,false],[96,23,0,null,null,null,null,false],[96,26,0,null,null,null,null,false],[96,42,0,null,null,null,[13900,13901],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[96,111,0,null,null,null,[13903],false],[0,0,0,"self",null,"",null,false],[96,122,0,null,null,null,[13905,13906],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[96,147,0,null,null,null,[13908],false],[0,0,0,"self",null,"",null,false],[96,20,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[96,20,0,null,null,null,null,false],[0,0,0,"inflater",null,null,null,false],[96,20,0,null,null,null,null,false],[0,0,0,"in_reader",null,null,null,false],[96,20,0,null,null,null,null,false],[0,0,0,"hasher",null,null,null,false],[0,0,0,"read_amt",null,null,null,false],[96,20,0,null,null,null,[13920,13922,13924,13925,13926],false],[96,34,0,null,null,null,null,false],[0,0,0,"extra",null,null,null,false],[96,34,0,null,null,null,null,false],[0,0,0,"filename",null,null,null,false],[96,34,0,null,null,null,null,false],[0,0,0,"comment",null,null,null,false],[0,0,0,"modification_time",null,null,null,false],[0,0,0,"operating_system",null,null,null,false],[0,0,0,"info",null,null,null,false],[96,153,0,null,null,null,[13929,13930],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[96,157,0,null,null,null,[13932,13933],false],[0,0,0,"data",null,"",null,false],[0,0,0,"expected",null,"",null,true],[85,4,0,null,null,null,null,false],[0,0,0,"compress/lzma.zig",null,"",[],false],[97,0,0,null,null,null,null,false],[97,1,0,null,null,null,null,false],[97,2,0,null,null,null,null,false],[97,3,0,null,null,null,null,false],[97,5,0,null,null,null,null,false],[0,0,0,"lzma/decode.zig",null,"",[],false],[98,0,0,null,null,null,null,false],[98,1,0,null,null,null,null,false],[98,2,0,null,null,null,null,false],[98,3,0,null,null,null,null,false],[98,5,0,null,null,null,null,false],[0,0,0,"decode/lzbuffer.zig",null,"",[],false],[99,0,0,null,null,null,null,false],[99,1,0,null,null,null,null,false],[99,2,0,null,null,null,null,false],[99,3,0,null,null,null,null,false],[99,4,0,null,null,null,null,false],[99,7,0,null,null," An accumulating buffer for LZ sequences",[13988,13989,13990],false],[99,17,0,null,null,null,null,false],[99,19,0,null,null,null,[13956],false],[0,0,0,"memlimit",null,"",null,false],[99,27,0,null,null,null,[13958,13959,13960],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"byte",null,"",null,false],[99,33,0,null,null," Reset the internal dictionary",[13962,13963],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,40,0,null,null," Retrieve the last byte or return a default",[13965,13966],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lit",null,"",null,false],[99,49,0,null,null," Retrieve the n-th last byte",[13968,13969],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dist",null,"",null,false],[99,59,0,null,null," Append a literal",[13971,13972,13973,13974],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"lit",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,74,0,null,null," Fetch an LZ sequence (length, distance) from inside the buffer",[13976,13977,13978,13979,13980],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"dist",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,98,0,null,null,null,[13982,13983],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,103,0,null,null,null,[13985,13986],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[99,7,0,null,null,null,null,false],[0,0,0,"buf",null," Buffer",null,false],[0,0,0,"memlimit",null," Buffer memory limit",null,false],[0,0,0,"len",null," Total number of bytes sent through the buffer",null,false],[99,110,0,null,null," A circular buffer for LZ sequences",[14028,14029,14030,14031,14032],false],[99,126,0,null,null,null,null,false],[99,128,0,null,null,null,[13994,13995],false],[0,0,0,"dict_size",null,"",null,false],[0,0,0,"memlimit",null,"",null,false],[99,138,0,null,null,null,[13997,13998],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[99,145,0,null,null,null,[14000,14001,14002,14003],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"value",null,"",null,false],[99,157,0,null,null," Retrieve the last byte or return a default",[14005,14006],false],[0,0,0,"self",null,"",null,false],[0,0,0,"lit",null,"",null,false],[99,165,0,null,null," Retrieve the n-th last byte",[14008,14009],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dist",null,"",null,false],[99,175,0,null,null," Append a literal",[14011,14012,14013,14014],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"lit",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,193,0,null,null," Fetch an LZ sequence (length, distance) from inside the buffer",[14016,14017,14018,14019,14020],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"dist",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,216,0,null,null,null,[14022,14023],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[99,223,0,null,null,null,[14025,14026],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[99,110,0,null,null,null,null,false],[0,0,0,"buf",null," Circular buffer",null,false],[0,0,0,"dict_size",null," Length of the buffer",null,false],[0,0,0,"memlimit",null," Buffer memory limit",null,false],[0,0,0,"cursor",null," Current position",null,false],[0,0,0,"len",null," Total number of bytes sent through the buffer",null,false],[98,6,0,null,null,null,null,false],[0,0,0,"decode/rangecoder.zig",null,"",[],false],[100,0,0,null,null,null,null,false],[100,1,0,null,null,null,null,false],[100,3,0,null,null,null,[14077,14078],false],[100,7,0,null,null,null,[14039],false],[0,0,0,"reader",null,"",null,false],[100,18,0,null,null,null,[14041,14042],false],[0,0,0,"range",null,"",null,false],[0,0,0,"code",null,"",null,false],[100,28,0,null,null,null,[14044,14045,14046],false],[0,0,0,"self",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"code",null,"",null,false],[100,33,0,null,null,null,[14048],false],[0,0,0,"self",null,"",null,false],[100,37,0,null,null,null,[14050,14051],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[100,44,0,null,null,null,[14053,14054],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[100,55,0,null,null,null,[14056,14057,14058],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"count",null,"",null,false],[100,63,0,null,null,null,[14060,14061,14062,14063],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"prob",null,"",null,false],[0,0,0,"update",null,"",null,false],[100,84,0,null,null,null,[14065,14066,14067,14068,14069],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"num_bits",null,"",null,false],[0,0,0,"probs",null,"",null,false],[0,0,0,"update",null,"",null,false],[100,100,0,null,null,null,[14071,14072,14073,14074,14075,14076],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"num_bits",null,"",null,false],[0,0,0,"probs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"update",null,"",null,false],[0,0,0,"range",null,null,null,false],[0,0,0,"code",null,null,null,false],[100,120,0,null,null,null,[14080],false],[0,0,0,"num_bits",null,"",[14095],true],[100,124,0,null,null,null,null,false],[100,126,0,null,null,null,[14083,14084,14085,14086],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"update",null,"",null,false],[100,135,0,null,null,null,[14088,14089,14090,14091],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"update",null,"",null,false],[100,144,0,null,null,null,[14093],false],[0,0,0,"self",null,"",null,false],[100,121,0,null,null,null,null,false],[0,0,0,"probs",null,null,null,false],[100,150,0,null,null,null,[14105,14106,14108,14110,14112],false],[100,157,0,null,null,null,[14098,14099,14100,14101,14102],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"pos_state",null,"",null,false],[0,0,0,"update",null,"",null,false],[100,173,0,null,null,null,[14104],false],[0,0,0,"self",null,"",null,false],[0,0,0,"choice",null,null,null,false],[0,0,0,"choice2",null,null,null,false],[100,150,0,null,null,null,null,false],[0,0,0,"low_coder",null,null,null,false],[100,150,0,null,null,null,null,false],[0,0,0,"mid_coder",null,null,null,false],[100,150,0,null,null,null,null,false],[0,0,0,"high_coder",null,null,null,false],[98,8,0,null,null,null,null,false],[98,9,0,null,null,null,null,false],[98,10,0,null,null,null,null,false],[98,11,0,null,null,null,null,false],[98,12,0,null,null,null,null,false],[0,0,0,"vec2d.zig",null,"",[],false],[101,0,0,null,null,null,null,false],[101,1,0,null,null,null,null,false],[101,2,0,null,null,null,null,false],[101,3,0,null,null,null,null,false],[101,5,0,null,null,null,[14124],false],[0,0,0,"T",null,"",[14148,14149],true],[101,10,0,null,null,null,null,false],[101,12,0,null,null,null,[14127,14128,14129],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",[14130,14131],false],[0,0,0,"",null,null,null,false],[0,0,0,"",null,null,null,false],[101,22,0,null,null,null,[14133,14134],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[101,27,0,null,null,null,[14136,14137],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[101,31,0,null,null,null,[14139,14140],false],[0,0,0,"self",null,"",null,false],[0,0,0,"row",null,"",null,false],[101,37,0,null,null,null,[14142,14143],false],[0,0,0,"self",null,"",null,false],[0,0,0,"row",null,"",null,false],[101,41,0,null,null,null,[14145,14146],false],[0,0,0,"self",null,"",null,false],[0,0,0,"row",null,"",null,false],[101,6,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"cols",null,null,null,false],[101,47,0,null,null,null,null,false],[101,48,0,null,null,null,null,false],[101,49,0,null,null,null,null,false],[98,14,0,null,null,null,[14155,14157,14158],false],[98,14,0,null,null,null,null,false],[0,0,0,"unpacked_size",null,null,null,false],[98,14,0,null,null,null,null,false],[0,0,0,"memlimit",null,null,null,false],[0,0,0,"allow_incomplete",null,null,null,false],[98,20,0,null,null,null,[14160,14161,14162],false],[0,0,0,"read_from_header",null,null,null,false],[0,0,0,"read_header_but_use_provided",null,null,null,false],[0,0,0,"use_provided",null,null,null,false],[98,26,0,null,null,null,[14164,14165],false],[0,0,0,"continue_",null,null,null,false],[0,0,0,"finished",null,null,null,false],[98,31,0,null,null,null,[14170,14172,14174],false],[98,36,0,null,null,null,[14168],false],[0,0,0,"self",null,"",null,false],[98,31,0,null,null,null,null,false],[0,0,0,"lc",null,null,null,false],[98,31,0,null,null,null,null,false],[0,0,0,"lp",null,null,null,false],[98,31,0,null,null,null,null,false],[0,0,0,"pb",null,null,null,false],[98,43,0,null,null,null,[14180,14181,14183],false],[98,48,0,null,null,null,[14177,14178],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"options",null,"",null,false],[98,43,0,null,null,null,null,false],[0,0,0,"properties",null,null,null,false],[0,0,0,"dict_size",null,null,null,false],[98,43,0,null,null,null,null,false],[0,0,0,"unpacked_size",null,null,null,false],[98,87,0,null,null,null,[14231,14233,14235,14237,14239,14241,14243,14245,14247,14249,14251,14253,14254,14256,14258,14260],false],[98,105,0,null,null,null,[14186,14187,14188],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"lzma_props",null,"",null,false],[0,0,0,"unpacked_size",null,"",null,false],[98,130,0,null,null,null,[14190,14191],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[98,135,0,null,null,null,[14193,14194,14195],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_props",null,"",null,false],[98,160,0,null,null,null,[14197,14198,14199,14200,14201,14202,14203],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"update",null,"",null,false],[98,264,0,null,null,null,[14205,14206,14207,14208,14209,14210],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[98,275,0,null,null,null,[14212,14213,14214,14215,14216,14217],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[98,307,0,null,null,null,[14219,14220,14221,14222,14223],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"update",null,"",null,false],[98,347,0,null,null,null,[14225,14226,14227,14228,14229],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"decoder",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"update",null,"",null,false],[98,87,0,null,null,null,null,false],[0,0,0,"lzma_props",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"unpacked_size",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"literal_probs",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"pos_slot_decoder",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"align_decoder",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"pos_decoders",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"is_match",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"is_rep",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"is_rep_g0",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"is_rep_g1",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"is_rep_g2",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"is_rep_0long",null,null,null,false],[0,0,0,"state",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"rep",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"len_decoder",null,null,null,false],[98,87,0,null,null,null,null,false],[0,0,0,"rep_len_decoder",null,null,null,false],[97,7,0,null,null,null,[14262,14263],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[97,14,0,null,null,null,[14265,14266,14267],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"options",null,"",null,false],[97,23,0,null,null,null,[14269],false],[0,0,0,"ReaderType",null,"",[14286,14288,14290,14292,14294,14296],true],[97,25,0,null,null,null,null,false],[97,27,0,null,null,null,null,false],[97,32,0,null,null,null,null,false],[97,42,0,null,null,null,[14274,14275,14276,14277],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"memlimit",null,"",null,false],[97,54,0,null,null,null,[14279],false],[0,0,0,"self",null,"",null,false],[97,58,0,null,null,null,[14281],false],[0,0,0,"self",null,"",null,false],[97,65,0,null,null,null,[14283,14284],false],[0,0,0,"self",null,"",null,false],[0,0,0,"output",null,"",null,false],[97,24,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[97,24,0,null,null,null,null,false],[0,0,0,"in_reader",null,null,null,false],[97,24,0,null,null,null,null,false],[0,0,0,"to_read",null,null,null,false],[97,24,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[97,24,0,null,null,null,null,false],[0,0,0,"decoder",null,null,null,false],[97,24,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[85,5,0,null,null,null,null,false],[0,0,0,"compress/lzma2.zig",null,"",[],false],[102,0,0,null,null,null,null,false],[102,1,0,null,null,null,null,false],[102,3,0,null,null,null,null,false],[0,0,0,"lzma2/decode.zig",null,"",[],false],[103,0,0,null,null,null,null,false],[103,1,0,null,null,null,null,false],[103,3,0,null,null,null,null,false],[103,4,0,null,null,null,null,false],[103,5,0,null,null,null,null,false],[103,6,0,null,null,null,null,false],[103,7,0,null,null,null,null,false],[103,9,0,null,null,null,[14335],false],[103,12,0,null,null,null,[14312],false],[0,0,0,"allocator",null,"",null,false],[103,26,0,null,null,null,[14314,14315],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[103,31,0,null,null,null,[14317,14318,14319,14320],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[103,54,0,null,null,null,[14322,14323,14324,14325,14326,14327],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"accum",null,"",null,false],[0,0,0,"status",null,"",null,false],[103,150,0,null,null,null,[14329,14330,14331,14332,14333],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"accum",null,"",null,false],[0,0,0,"reset_dict",null,"",null,false],[103,9,0,null,null,null,null,false],[0,0,0,"lzma_state",null,null,null,false],[102,5,0,null,null,null,[14337,14338,14339],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"writer",null,"",null,false],[85,6,0,null,null,null,null,false],[0,0,0,"compress/xz.zig",null,"",[],false],[104,0,0,null,null,null,null,false],[104,1,0,null,null,null,null,false],[0,0,0,"xz/block.zig",null,"",[],false],[105,0,0,null,null,null,null,false],[105,1,0,null,null,null,null,false],[105,2,0,null,null,null,null,false],[105,3,0,null,null,null,null,false],[105,4,0,null,null,null,null,false],[105,5,0,null,null,null,null,false],[105,6,0,null,null,null,null,false],[105,7,0,null,null,null,null,false],[105,9,0,null,null,null,null,false],[105,18,0,null,null,null,[14355,14356,14357],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"check",null,"",null,false],[105,22,0,null,null,null,[14359],false],[0,0,0,"ReaderType",null,"",[14377,14379,14381,14383,14385,14386],true],[105,24,0,null,null,null,null,false],[105,25,0,null,null,null,null,false],[105,29,0,null,null,null,null,false],[105,38,0,null,null,null,[14364,14365,14366],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_reader",null,"",null,false],[0,0,0,"check",null,"",null,false],[105,49,0,null,null,null,[14368],false],[0,0,0,"self",null,"",null,false],[105,53,0,null,null,null,[14370],false],[0,0,0,"self",null,"",null,false],[105,57,0,null,null,null,[14372,14373],false],[0,0,0,"self",null,"",null,false],[0,0,0,"output",null,"",null,false],[105,85,0,null,null,null,[14375],false],[0,0,0,"self",null,"",null,false],[105,23,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[105,23,0,null,null,null,null,false],[0,0,0,"inner_reader",null,null,null,false],[105,23,0,null,null,null,null,false],[0,0,0,"check",null,null,null,false],[105,23,0,null,null,null,null,false],[0,0,0,"err",null,null,null,false],[105,23,0,null,null,null,null,false],[0,0,0,"to_read",null,null,null,false],[0,0,0,"block_count",null,null,null,false],[104,2,0,null,null,null,null,false],[104,3,0,null,null,null,null,false],[104,5,0,null,null,null,[14390,14391,14392,14393],false],[0,0,0,"none",null,null,null,false],[0,0,0,"crc32",null,null,null,false],[0,0,0,"crc64",null,null,null,false],[0,0,0,"sha256",null,null,null,false],[104,13,0,null,null,null,[14395,14396],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"check",null,"",null,false],[104,27,0,null,null,null,[14398,14399],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[104,31,0,null,null,null,[14401],false],[0,0,0,"ReaderType",null,"",[14416,14418,14420],true],[104,33,0,null,null,null,null,false],[104,35,0,null,null,null,null,false],[104,36,0,null,null,null,null,false],[104,42,0,null,null,null,[14406,14407],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[104,65,0,null,null,null,[14409],false],[0,0,0,"self",null,"",null,false],[104,69,0,null,null,null,[14411],false],[0,0,0,"self",null,"",null,false],[104,73,0,null,null,null,[14413,14414],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[104,32,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[104,32,0,null,null,null,null,false],[0,0,0,"block_decoder",null,null,null,false],[104,32,0,null,null,null,null,false],[0,0,0,"in_reader",null,null,null,false],[85,7,0,null,null,null,null,false],[0,0,0,"compress/zlib.zig",null,"",[],false],[106,3,0,null,null,null,null,false],[106,4,0,null,null,null,null,false],[106,5,0,null,null,null,null,false],[106,6,0,null,null,null,null,false],[106,7,0,null,null,null,null,false],[106,8,0,null,null,null,null,false],[106,11,0,null,null,null,[14433,14434,14436,14438,14440],false],[106,18,0,null,null,null,null,false],[106,19,0,null,null,null,null,false],[106,11,0,null,null,null,null,false],[0,0,0,"checksum",null,null,null,false],[0,0,0,"preset_dict",null,null,null,false],[106,11,0,null,null,null,null,false],[0,0,0,"compression_level",null,null,null,false],[106,11,0,null,null,null,null,false],[0,0,0,"compression_method",null,null,null,false],[106,11,0,null,null,null,null,false],[0,0,0,"compression_info",null,null,null,false],[106,22,0,null,null,null,[14442],false],[0,0,0,"ReaderType",null,"",[14457,14459,14461,14463],true],[106,24,0,null,null,null,null,false],[106,26,0,null,null,null,null,false],[106,29,0,null,null,null,null,false],[106,36,0,null,null,null,[14447,14448],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[106,66,0,null,null,null,[14450],false],[0,0,0,"self",null,"",null,false],[106,71,0,null,null,null,[14452,14453],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[106,90,0,null,null,null,[14455],false],[0,0,0,"self",null,"",null,false],[106,23,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[106,23,0,null,null,null,null,false],[0,0,0,"inflater",null,null,null,false],[106,23,0,null,null,null,null,false],[0,0,0,"in_reader",null,null,null,false],[106,23,0,null,null,null,null,false],[0,0,0,"hasher",null,null,null,false],[106,96,0,null,null,null,[14465,14466],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[106,100,0,null,null,null,[14468,14469,14470,14471],false],[0,0,0,"no_compression",null,null,null,false],[0,0,0,"fastest",null,null,null,false],[0,0,0,"default",null,null,null,false],[0,0,0,"maximum",null,null,null,false],[106,107,0,null,null,null,[14474],false],[106,107,0,null,null,null,null,false],[0,0,0,"level",null,null,null,false],[106,111,0,null,null,null,[14476],false],[0,0,0,"WriterType",null,"",[14494,14496,14498,14500],true],[106,113,0,null,null,null,null,false],[106,115,0,null,null,null,null,false],[106,117,0,null,null,null,null,false],[106,124,0,null,null,null,[14481,14482,14483],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"options",null,"",null,false],[106,151,0,null,null,null,[14485,14486],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[106,162,0,null,null,null,[14488],false],[0,0,0,"self",null,"",null,false],[106,166,0,null,null,null,[14490],false],[0,0,0,"self",null,"",null,false],[106,170,0,null,null,null,[14492],false],[0,0,0,"self",null,"",null,false],[106,112,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[106,112,0,null,null,null,null,false],[0,0,0,"deflator",null,null,null,false],[106,112,0,null,null,null,null,false],[0,0,0,"in_writer",null,null,null,false],[106,112,0,null,null,null,null,false],[0,0,0,"hasher",null,null,null,false],[106,178,0,null,null,null,[14502,14503,14504],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"options",null,"",null,false],[106,182,0,null,null,null,[14506,14507],false],[0,0,0,"data",null,"",null,false],[0,0,0,"expected",null,"",null,false],[85,8,0,null,null,null,null,false],[0,0,0,"compress/zstandard.zig",null,"",[],false],[107,0,0,null,null,null,null,false],[107,1,0,null,null,null,null,false],[107,2,0,null,null,null,null,false],[107,4,0,null,null,null,null,false],[0,0,0,"zstandard/types.zig",null,"",[],false],[108,0,0,null,null,null,[],false],[108,1,0,null,null,null,[14517,14518],false],[0,0,0,"zstandard",null,null,null,false],[0,0,0,"skippable",null,null,null,false],[108,3,0,null,null,null,[14552,14554,14556],false],[108,4,0,null,null,null,null,false],[108,10,0,null,null,null,[14532,14534,14536,14538],false],[108,16,0,null,null,null,[14524,14525,14526,14527,14528,14530],false],[108,16,0,null,null,null,null,false],[0,0,0,"dictionary_id_flag",null,null,null,false],[0,0,0,"content_checksum_flag",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"unused",null,null,null,false],[0,0,0,"single_segment_flag",null,null,null,false],[108,16,0,null,null,null,null,false],[0,0,0,"content_size_flag",null,null,null,false],[108,10,0,null,null,null,null,false],[0,0,0,"descriptor",null,null,null,false],[108,10,0,null,null,null,null,false],[0,0,0,"window_descriptor",null,null,null,false],[108,10,0,null,null,null,null,false],[0,0,0,"dictionary_id",null,null,null,false],[108,10,0,null,null,null,null,false],[0,0,0,"content_size",null,null,null,false],[108,26,0,null,null,null,[],false],[108,27,0,null,null,null,[14541,14543,14545],false],[0,0,0,"last_block",null,null,null,false],[108,27,0,null,null,null,null,false],[0,0,0,"block_type",null,null,null,false],[108,27,0,null,null,null,null,false],[0,0,0,"block_size",null,null,null,false],[108,33,0,null,null,null,[14547,14548,14549,14550],false],[0,0,0,"raw",null,null,null,false],[0,0,0,"rle",null,null,null,false],[0,0,0,"compressed",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[108,3,0,null,null,null,null,false],[0,0,0,"header",null,null,null,false],[108,3,0,null,null,null,null,false],[0,0,0,"data_blocks",null,null,null,false],[108,3,0,null,null,null,null,false],[0,0,0,"checksum",null,null,null,false],[108,42,0,null,null,null,[],false],[108,43,0,null,null,null,null,false],[108,44,0,null,null,null,null,false],[108,46,0,null,null,null,[14561,14562],false],[0,0,0,"magic_number",null,null,null,false],[0,0,0,"frame_size",null,null,null,false],[108,53,0,null,null,null,[],false],[108,54,0,null,null,null,[14610,14612,14614],false],[108,59,0,null,null,null,[14566,14567],false],[0,0,0,"one",null,null,null,false],[0,0,0,"four",null,null,null,false],[108,64,0,null,null,null,[14570,14572,14574,14576],false],[108,64,0,null,null,null,null,false],[0,0,0,"block_type",null,null,null,false],[108,64,0,null,null,null,null,false],[0,0,0,"size_format",null,null,null,false],[108,64,0,null,null,null,null,false],[0,0,0,"regenerated_size",null,null,null,false],[108,64,0,null,null,null,null,false],[0,0,0,"compressed_size",null,null,null,false],[108,71,0,null,null,null,[14578,14579,14580,14581],false],[0,0,0,"raw",null,null,null,false],[0,0,0,"rle",null,null,null,false],[0,0,0,"compressed",null,null,null,false],[0,0,0,"treeless",null,null,null,false],[108,78,0,null,null,null,[14599,14600,14602],false],[108,83,0,null,null,null,[14584,14585,14587],false],[0,0,0,"symbol",null,null,null,false],[0,0,0,"prefix",null,null,null,false],[108,83,0,null,null,null,null,false],[0,0,0,"weight",null,null,null,false],[108,89,0,null,null,null,[14589,14590],false],[0,0,0,"symbol",null,null,null,false],[0,0,0,"index",null,null,null,false],[108,94,0,null,null,null,[14592,14593,14594],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[108,107,0,null,null,null,[14596,14597],false],[0,0,0,"weight",null,"",null,false],[0,0,0,"max_bit_count",null,"",null,false],[108,78,0,null,null,null,null,false],[0,0,0,"max_bit_count",null,null,null,false],[0,0,0,"symbol_count_minus_one",null,null,null,false],[108,78,0,null,null,null,null,false],[0,0,0,"nodes",null,null,null,false],[108,112,0,null,null,null,[14604,14605],false],[0,0,0,"one",null,null,null,false],[0,0,0,"four",null,null,null,false],[108,113,0,null,null,null,[14607,14608],false],[0,0,0,"size_format",null,"",null,false],[0,0,0,"block_type",null,"",null,false],[108,54,0,null,null,null,null,false],[0,0,0,"header",null,null,null,false],[108,54,0,null,null,null,null,false],[0,0,0,"huffman_tree",null,null,null,false],[108,54,0,null,null,null,null,false],[0,0,0,"streams",null,null,null,false],[108,121,0,null,null,null,[14631,14633,14635,14637],false],[108,127,0,null,null,null,[14623,14625,14627,14629],false],[108,133,0,null,null,null,[14618,14619,14620,14621],false],[0,0,0,"predefined",null,null,null,false],[0,0,0,"rle",null,null,null,false],[0,0,0,"fse",null,null,null,false],[0,0,0,"repeat",null,null,null,false],[108,127,0,null,null,null,null,false],[0,0,0,"sequence_count",null,null,null,false],[108,127,0,null,null,null,null,false],[0,0,0,"match_lengths",null,null,null,false],[108,127,0,null,null,null,null,false],[0,0,0,"offsets",null,null,null,false],[108,127,0,null,null,null,null,false],[0,0,0,"literal_lengths",null,null,null,false],[108,121,0,null,null,null,null,false],[0,0,0,"header",null,null,null,false],[108,121,0,null,null,null,null,false],[0,0,0,"literals_length_table",null,null,null,false],[108,121,0,null,null,null,null,false],[0,0,0,"offset_table",null,null,null,false],[108,121,0,null,null,null,null,false],[0,0,0,"match_length_table",null,null,null,false],[108,142,0,null,null,null,[14643,14644],false],[108,146,0,null,null,null,[14640,14641,14642],false],[0,0,0,"symbol",null,null,null,false],[0,0,0,"baseline",null,null,null,false],[0,0,0,"bits",null,null,null,false],[0,0,0,"fse",null,null,null,false],[0,0,0,"rle",null,null,null,false],[108,153,0,null,null,null,[14646,14648],false],[0,0,0,"",null,null,null,false],[108,153,0,null,null,null,null,false],[0,0,0,"",null,null,null,false],[108,165,0,null,null,null,[14650,14652],false],[0,0,0,"",null,null,null,false],[108,165,0,null,null,null,null,false],[0,0,0,"",null,null,null,false],[108,177,0,null,null,null,null,false],[108,183,0,null,null,null,null,false],[108,190,0,null,null,null,null,false],[108,195,0,null,null,null,null,false],[108,264,0,null,null,null,null,false],[108,333,0,null,null,null,null,false],[108,369,0,null,null,null,null,false],[108,370,0,null,null,null,null,false],[108,371,0,null,null,null,null,false],[108,373,0,null,null,null,[],false],[108,374,0,null,null,null,null,false],[108,375,0,null,null,null,null,false],[108,376,0,null,null,null,null,false],[108,379,0,null,null,null,[],false],[108,380,0,null,null,null,null,false],[108,381,0,null,null,null,null,false],[108,382,0,null,null,null,null,false],[108,385,0,null,null,null,[],false],[108,386,0,null,null,null,null,false],[108,387,0,null,null,null,null,false],[108,388,0,null,null,null,null,false],[108,390,0,null,null,null,[],false],[108,391,0,null,null,null,null,false],[108,392,0,null,null,null,null,false],[108,393,0,null,null,null,null,false],[107,5,0,null,null,null,null,false],[107,6,0,null,null,null,null,false],[107,8,0,null,null,null,null,false],[0,0,0,"zstandard/decompress.zig",null,"",[],false],[109,0,0,null,null,null,null,false],[109,1,0,null,null,null,null,false],[109,2,0,null,null,null,null,false],[109,3,0,null,null,null,null,false],[109,5,0,null,null,null,null,false],[109,6,0,null,null,null,null,false],[109,7,0,null,null,null,null,false],[109,8,0,null,null,null,null,false],[109,9,0,null,null,null,null,false],[109,10,0,null,null,null,null,false],[109,11,0,null,null,null,null,false],[109,13,0,null,null,null,null,false],[0,0,0,"decode/block.zig",null,"",[],false],[110,0,0,null,null,null,null,false],[110,1,0,null,null,null,null,false],[110,2,0,null,null,null,null,false],[110,4,0,null,null,null,null,false],[110,5,0,null,null,null,null,false],[110,6,0,null,null,null,null,false],[110,7,0,null,null,null,null,false],[110,8,0,null,null,null,null,false],[110,10,0,null,null,null,null,false],[0,0,0,"huffman.zig",null,"",[],false],[111,0,0,null,null,null,null,false],[111,2,0,null,null,null,null,false],[111,3,0,null,null,null,null,false],[111,4,0,null,null,null,null,false],[111,6,0,null,null,null,null,false],[0,0,0,"../readers.zig",null,"",[],false],[112,0,0,null,null,null,null,false],[112,2,0,null,null,null,[14721,14723],false],[112,6,0,null,null,null,null,false],[112,8,0,null,null,null,[14715],false],[0,0,0,"bytes",null,"",null,false],[112,15,0,null,null,null,[14717],false],[0,0,0,"self",null,"",null,false],[112,19,0,null,null,null,[14719,14720],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"remaining_bytes",null,null,null,false],[112,2,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[112,31,0,null,null," A bit reader for reading the reversed bit streams used to encode\n FSE compressed data.",[14742,14744],false],[112,35,0,null,null,null,[14726,14727],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[112,44,0,null,null,null,[14729,14730,14731],false],[0,0,0,"self",null,"",null,false],[0,0,0,"U",null,"",null,true],[0,0,0,"num_bits",null,"",null,false],[112,48,0,null,null,null,[14733,14734,14735,14736],false],[0,0,0,"self",null,"",null,false],[0,0,0,"U",null,"",null,true],[0,0,0,"num_bits",null,"",null,false],[0,0,0,"out_bits",null,"",null,false],[112,52,0,null,null,null,[14738],false],[0,0,0,"self",null,"",null,false],[112,56,0,null,null,null,[14740],false],[0,0,0,"self",null,"",null,false],[112,31,0,null,null,null,null,false],[0,0,0,"byte_reader",null,null,null,false],[112,31,0,null,null,null,null,false],[0,0,0,"bit_reader",null,null,null,false],[112,61,0,null,null,null,[14746],false],[0,0,0,"Reader",null,"",[14759],true],[112,65,0,null,null,null,[14748,14749,14750],false],[0,0,0,"self",null,"",null,false],[0,0,0,"U",null,"",null,true],[0,0,0,"num_bits",null,"",null,false],[112,69,0,null,null,null,[14752,14753,14754,14755],false],[0,0,0,"self",null,"",null,false],[0,0,0,"U",null,"",null,true],[0,0,0,"num_bits",null,"",null,false],[0,0,0,"out_bits",null,"",null,false],[112,73,0,null,null,null,[14757],false],[0,0,0,"self",null,"",null,false],[112,62,0,null,null,null,null,false],[0,0,0,"underlying",null,null,null,false],[112,79,0,null,null,null,[14761],false],[0,0,0,"reader",null,"",null,false],[111,8,0,null,null,null,null,false],[0,0,0,"fse.zig",null,"",[],false],[113,0,0,null,null,null,null,false],[113,1,0,null,null,null,null,false],[113,3,0,null,null,null,null,false],[113,4,0,null,null,null,null,false],[113,6,0,null,null,null,[14769,14770,14771,14772],false],[0,0,0,"bit_reader",null,"",null,false],[0,0,0,"expected_symbol_count",null,"",null,false],[0,0,0,"max_accuracy_log",null,"",null,false],[0,0,0,"entries",null,"",null,false],[113,70,0,null,null,null,[14774,14775],false],[0,0,0,"values",null,"",null,false],[0,0,0,"entries",null,"",null,false],[113,124,0,"buildFseTable","test buildFseTable {\n    const literals_length_default_values = [36]u16{\n        5, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2,\n        3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 3, 2, 2, 2, 2, 2,\n        0, 0, 0, 0,\n    };\n\n    const match_lengths_default_values = [53]u16{\n        2, 5, 4, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2,\n        2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,\n        2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0,\n        0, 0, 0, 0, 0,\n    };\n\n    const offset_codes_default_values = [29]u16{\n        2, 2, 2, 2, 2, 2, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2,\n        2, 2, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0,\n    };\n\n    var entries: [64]Table.Fse = undefined;\n    try buildFseTable(&literals_length_default_values, &entries);\n    try std.testing.expectEqualSlices(Table.Fse, types.compressed_block.predefined_literal_fse_table.fse, &entries);\n\n    try buildFseTable(&match_lengths_default_values, &entries);\n    try std.testing.expectEqualSlices(Table.Fse, types.compressed_block.predefined_match_fse_table.fse, &entries);\n\n    try buildFseTable(&offset_codes_default_values, entries[0..32]);\n    try std.testing.expectEqualSlices(Table.Fse, types.compressed_block.predefined_offset_fse_table.fse, entries[0..32]);\n}",null,null,false],[111,10,0,null,null,null,null,false],[111,17,0,null,null,null,[14779,14780,14781,14782],false],[0,0,0,"source",null,"",null,false],[0,0,0,"compressed_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"weights",null,"",null,false],[111,41,0,null,null,null,[14784,14785,14786],false],[0,0,0,"src",null,"",null,false],[0,0,0,"compressed_size",null,"",null,false],[0,0,0,"weights",null,"",null,false],[111,63,0,null,null,null,[14788,14789,14790,14791],false],[0,0,0,"huff_bits",null,"",null,false],[0,0,0,"accuracy_log",null,"",null,false],[0,0,0,"entries",null,"",null,false],[0,0,0,"weights",null,"",null,false],[111,107,0,null,null,null,[14793,14794,14795],false],[0,0,0,"source",null,"",null,false],[0,0,0,"encoded_symbol_count",null,"",null,false],[0,0,0,"weights",null,"",null,false],[111,117,0,null,null,null,[14797,14798],false],[0,0,0,"weight_sorted_prefixed_symbols",null,"",null,false],[0,0,0,"weights",null,"",null,false],[111,163,0,null,null,null,[14800,14801],false],[0,0,0,"weights",null,"",null,false],[0,0,0,"symbol_count",null,"",null,false],[111,187,0,null,null,null,[14803,14804],false],[0,0,0,"source",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[111,202,0,null,null,null,[14806,14807],false],[0,0,0,"src",null,"",null,false],[0,0,0,"consumed_count",null,"",null,false],[111,224,0,null,null,null,[14809,14810,14811],false],[0,0,0,"weights",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[110,11,0,null,null,null,null,false],[110,13,0,null,null,null,null,false],[110,15,0,null,null,null,null,false],[110,17,0,null,null,null,null,false],[110,25,0,null,null,null,[14911,14913,14915,14917,14919,14921,14923,14924,14926,14927,14929,14931,14933,14934,14935],false],[110,47,0,null,null,null,[14818],false],[0,0,0,"max_accuracy_log",null,"",[14821,14823,14824],true],[110,53,0,null,null,null,null,false],[110,48,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[110,48,0,null,null,null,null,false],[0,0,0,"table",null,null,null,false],[0,0,0,"accuracy_log",null,null,null,false],[110,57,0,null,null,null,[14826,14827,14828],false],[0,0,0,"literal_fse_buffer",null,"",null,false],[0,0,0,"match_fse_buffer",null,"",null,false],[0,0,0,"offset_fse_buffer",null,"",null,false],[110,105,0,null,null," Prepare the decoder to decode a compressed block. Loads the literals\n stream and Huffman tree from `literals` and reads the FSE tables from\n `source`.\n\n Errors returned:\n   - `error.BitStreamHasNoStartBit` if the (reversed) literal bitstream's\n     first byte does not have any bits set\n   - `error.TreelessLiteralsFirst` `literals` is a treeless literals\n     section and the decode state does not have a Huffman tree from a\n     previous block\n   - `error.RepeatModeFirst` on the first call if one of the sequence FSE\n     tables is set to repeat mode\n   - `error.MalformedAccuracyLog` if an FSE table has an invalid accuracy\n   - `error.MalformedFseTable` if there are errors decoding an FSE table\n   - `error.EndOfStream` if `source` ends before all FSE tables are read",[14830,14831,14832,14833],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"literals",null,"",null,false],[0,0,0,"sequences_header",null,"",null,false],[110,144,0,null,null," Read initial FSE states for sequence decoding.\n\n Errors returned:\n   - `error.EndOfStream` if `bit_reader` does not contain enough bits.",[14835,14836],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit_reader",null,"",null,false],[110,150,0,null,null,null,[14838,14839],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[110,156,0,null,null,null,[14841,14842],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[110,166,0,null,null,null,[14844,14845,14846],false],[0,0,0,"offset",null,null,null,false],[0,0,0,"match",null,null,null,false],[0,0,0,"literal",null,null,null,false],[110,168,0,null,null,null,[14848,14849,14850],false],[0,0,0,"self",null,"",null,false],[0,0,0,"choice",null,"",null,true],[0,0,0,"bit_reader",null,"",null,false],[110,188,0,null,null,null,null,false],[110,195,0,null,null,null,[14853,14854,14855,14856],false],[0,0,0,"self",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"choice",null,"",null,true],[0,0,0,"mode",null,"",null,false],[110,232,0,null,null,null,[14858,14859,14860],false],[0,0,0,"literal_length",null,null,null,false],[0,0,0,"match_length",null,null,null,false],[0,0,0,"offset",null,null,null,false],[110,238,0,null,null,null,[14862,14863],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit_reader",null,"",null,false],[110,285,0,null,null,null,[14865,14866,14867,14868],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"write_pos",null,"",null,false],[0,0,0,"sequence",null,"",null,false],[110,302,0,null,null,null,[14870,14871,14872],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"sequence",null,"",null,false],[110,318,0,null,null,null,null,false],[110,341,0,null,null," Decode one sequence from `bit_reader` into `dest`, written starting at\n `write_pos` and update FSE states if `last_sequence` is `false`.\n `prepare()` must be called for the block before attempting to decode\n sequences.\n\n Errors returned:\n   - `error.MalformedSequence` if the decompressed sequence would be\n     longer than `sequence_size_limit` or the sequence's offset is too\n     large\n   - `error.UnexpectedEndOfLiteralStream` if the decoder state's literal\n     streams do not contain enough literals for the sequence (this may\n     mean the literal stream or the sequence is malformed).\n   - `error.InvalidBitStream` if the FSE sequence bitstream is malformed\n   - `error.EndOfStream` if `bit_reader` does not contain enough bits\n   - `error.DestTooSmall` if `dest` is not large enough to holde the\n     decompressed sequence",[14875,14876,14877,14878,14879,14880],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"write_pos",null,"",null,false],[0,0,0,"bit_reader",null,"",null,false],[0,0,0,"sequence_size_limit",null,"",null,false],[0,0,0,"last_sequence",null,"",null,false],[110,365,0,null,null," Decode one sequence from `bit_reader` into `dest`; see\n `decodeSequenceSlice`.",[14882,14883,14884,14885,14886],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"bit_reader",null,"",null,false],[0,0,0,"sequence_size_limit",null,"",null,false],[0,0,0,"last_sequence",null,"",null,false],[110,385,0,null,null,null,[14888],false],[0,0,0,"self",null,"",null,false],[110,392,0,null,null,null,[14890,14891],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[110,396,0,null,null,null,[14893],false],[0,0,0,"self",null,"",null,false],[110,403,0,null,null,null,null,false],[110,407,0,null,null,null,[14896,14897],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit_count_to_read",null,"",null,false],[110,422,0,null,null,null,null,false],[110,435,0,null,null," Decode `len` bytes of literals into `dest`.\n\n Errors returned:\n   - `error.MalformedLiteralsLength` if the number of literal bytes\n     decoded by `self` plus `len` is greater than the regenerated size of\n     `literals`\n   - `error.UnexpectedEndOfLiteralStream` and `error.NotFound` if there\n     are problems decoding Huffman compressed literals",[14900,14901,14902],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"len",null,"",null,false],[110,507,0,null,null," Decode literals into `dest`; see `decodeLiteralsSlice()`.",[14904,14905,14906],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"len",null,"",null,false],[110,575,0,null,null,null,[14908,14909],false],[0,0,0,"self",null,"",null,false],[0,0,0,"choice",null,"",null,true],[110,25,0,null,null,null,null,false],[0,0,0,"repeat_offsets",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"offset",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"match",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"literal",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"offset_fse_buffer",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"match_fse_buffer",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"literal_fse_buffer",null,null,null,false],[0,0,0,"fse_tables_undefined",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"literal_stream_reader",null,null,null,false],[0,0,0,"literal_stream_index",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"literal_streams",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"literal_header",null,null,null,false],[110,25,0,null,null,null,null,false],[0,0,0,"huffman_tree",null,null,null,false],[0,0,0,"literal_written_count",null,null,null,false],[0,0,0,"written_count",null,null,null,false],[110,600,0,null,null," Decode a single block from `src` into `dest`. The beginning of `src` must be\n the start of the block content (i.e. directly after the block header).\n Increments `consumed_count` by the number of bytes read from `src` to decode\n the block and returns the decompressed size of the block.\n\n Errors returned:\n\n   - `error.BlockSizeOverMaximum` if block's size is larger than 1 << 17 or\n     `dest[written_count..].len`\n   - `error.MalformedBlockSize` if `src.len` is smaller than the block size\n     and the block is a raw or compressed block\n   - `error.ReservedBlock` if the block is a reserved block\n   - `error.MalformedRleBlock` if the block is an RLE block and `src.len < 1`\n   - `error.MalformedCompressedBlock` if there are errors decoding a\n     compressed block\n   - `error.DestTooSmall` is `dest` is not large enough to hold the\n     decompressed block",[14937,14938,14939,14940,14941,14942,14943],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"block_header",null,"",null,false],[0,0,0,"decode_state",null,"",null,false],[0,0,0,"consumed_count",null,"",null,false],[0,0,0,"block_size_max",null,"",null,false],[0,0,0,"written_count",null,"",null,false],[110,704,0,null,null," Decode a single block from `src` into `dest`; see `decodeBlock()`. Returns\n the size of the decompressed block, which can be used with `dest.sliceLast()`\n to get the decompressed bytes. `error.BlockSizeOverMaximum` is returned if\n the block's compressed or decompressed size is larger than `block_size_max`.",[14945,14946,14947,14948,14949,14950],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"block_header",null,"",null,false],[0,0,0,"decode_state",null,"",null,false],[0,0,0,"consumed_count",null,"",null,false],[0,0,0,"block_size_max",null,"",null,false],[110,805,0,null,null," Decode a single block from `source` into `dest`. Literal and sequence data\n from the block is copied into `literals_buffer` and `sequence_buffer`, which\n must be large enough or `error.LiteralsBufferTooSmall` and\n `error.SequenceBufferTooSmall` are returned (the maximum block size is an\n upper bound for the size of both buffers). See `decodeBlock`\n and `decodeBlockRingBuffer` for function that can decode a block without\n these extra copies. `error.EndOfStream` is returned if `source` does not\n contain enough bytes.",[14952,14953,14954,14955,14956,14957,14958],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"block_header",null,"",null,false],[0,0,0,"decode_state",null,"",null,false],[0,0,0,"block_size_max",null,"",null,false],[0,0,0,"literals_buffer",null,"",null,false],[0,0,0,"sequence_buffer",null,"",null,false],[110,894,0,null,null," Decode the header of a block.",[14960],false],[0,0,0,"src",null,"",null,false],[110,909,0,null,null," Decode the header of a block.\n\n Errors returned:\n   - `error.EndOfStream` if `src.len < 3`",[14962],false],[0,0,0,"src",null,"",null,false],[110,925,0,null,null," Decode a `LiteralsSection` from `src`, incrementing `consumed_count` by the\n number of bytes the section uses.\n\n Errors returned:\n   - `error.MalformedLiteralsHeader` if the header is invalid\n   - `error.MalformedLiteralsSection` if there are decoding errors\n   - `error.MalformedAccuracyLog` if compressed literals have invalid\n     accuracy\n   - `error.MalformedFseTable` if compressed literals have invalid FSE table\n   - `error.MalformedHuffmanTree` if there are errors decoding a Huffamn tree\n   - `error.EndOfStream` if there are not enough bytes in `src`",[14964,14965],false],[0,0,0,"src",null,"",null,false],[0,0,0,"consumed_count",null,"",null,false],[110,982,0,null,null," Decode a `LiteralsSection` from `src`, incrementing `consumed_count` by the\n number of bytes the section uses. See `decodeLiterasSectionSlice()`.",[14967,14968],false],[0,0,0,"source",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[110,1028,0,null,null,null,[14970,14971],false],[0,0,0,"size_format",null,"",null,false],[0,0,0,"stream_data",null,"",null,false],[110,1058,0,null,null," Decode a literals section header.\n\n Errors returned:\n   - `error.EndOfStream` if there are not enough bytes in `source`",[14973],false],[0,0,0,"source",null,"",null,false],[110,1111,0,null,null," Decode a sequences section header.\n\n Errors returned:\n   - `error.ReservedBitSet` if the reserved bit is set\n   - `error.EndOfStream` if there are not enough bytes in `source`",[14975],false],[0,0,0,"source",null,"",null,false],[109,15,0,null,null,null,null,false],[109,17,0,null,null,null,null,false],[109,18,0,null,null,null,null,false],[109,21,0,null,null," Returns `true` is `magic` is a valid magic number for a skippable frame",[14980],false],[0,0,0,"magic",null,"",null,false],[109,32,0,null,null," Returns the kind of frame at the beginning of `source`.\n\n Errors returned:\n   - `error.BadMagic` if `source` begins with bytes not equal to the\n     Zstandard frame magic number, or outside the range of magic numbers for\n     skippable frames.\n   - `error.EndOfStream` if `source` contains fewer than 4 bytes",[14982],false],[0,0,0,"source",null,"",null,false],[109,41,0,null,null," Returns the kind of frame associated to `magic`.\n\n Errors returned:\n   - `error.BadMagic` if `magic` is not a valid magic number.",[14984],false],[0,0,0,"magic",null,"",null,false],[109,50,0,null,null,null,[14986,14987],false],[0,0,0,"zstandard",null,null,null,false],[0,0,0,"skippable",null,null,null,false],[109,55,0,null,null,null,null,false],[109,66,0,null,null," Returns the header of the frame at the beginning of `source`.\n\n Errors returned:\n   - `error.BadMagic` if `source` begins with bytes not equal to the\n     Zstandard frame magic number, or outside the range of magic numbers for\n     skippable frames.\n   - `error.EndOfStream` if `source` contains fewer than 4 bytes\n   - `error.ReservedBitSet` if the frame is a Zstandard frame and any of the\n     reserved bits are set",[14990],false],[0,0,0,"source",null,"",null,false],[109,80,0,null,null,null,[14992,14993],false],[0,0,0,"read_count",null,null,null,false],[0,0,0,"write_count",null,null,null,false],[109,96,0,null,null," Decodes frames from `src` into `dest`; returns the length of the result.\n The stream should not have extra trailing bytes - either all bytes in `src`\n will be decoded, or an error will be returned. An error will be returned if\n a Zstandard frame in `src` does not declare its content size.\n\n Errors returned:\n   - `error.DictionaryIdFlagUnsupported` if a `src` contains a frame that\n     uses a dictionary\n   - `error.MalformedFrame` if a frame in `src` is invalid\n   - `error.UnknownContentSizeUnsupported` if a frame in `src` does not\n     declare its content size",[14995,14996,14997],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[109,126,0,null,null," Decodes a stream of frames from `src`; returns the decoded bytes. The stream\n should not have extra trailing bytes - either all bytes in `src` will be\n decoded, or an error will be returned.\n\n Errors returned:\n   - `error.DictionaryIdFlagUnsupported` if a `src` contains a frame that\n     uses a dictionary\n   - `error.MalformedFrame` if a frame in `src` is invalid\n   - `error.OutOfMemory` if `allocator` cannot allocate enough memory",[14999,15000,15001,15002],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[0,0,0,"window_size_max",null,"",null,false],[109,178,0,null,null," Decodes the frame at the start of `src` into `dest`. Returns the number of\n bytes read from `src` and written to `dest`. This function can only decode\n frames that declare the decompressed content size.\n\n Errors returned:\n   - `error.BadMagic` if the first 4 bytes of `src` is not a valid magic\n     number for a Zstandard or skippable frame\n   - `error.UnknownContentSizeUnsupported` if the frame does not declare the\n     uncompressed content size\n   - `error.WindowSizeUnknown` if the frame does not have a valid window size\n   - `error.ContentTooLarge` if `dest` is smaller than the uncompressed data\n     size declared by the frame header\n   - `error.ContentSizeTooLarge` if the frame header indicates a content size\n     that is larger than `std.math.maxInt(usize)`\n   - `error.DictionaryIdFlagUnsupported` if the frame uses a dictionary\n   - `error.ChecksumFailure` if `verify_checksum` is true and the frame\n     contains a checksum that does not match the checksum of the decompressed\n     data\n   - `error.ReservedBitSet` if any of the reserved bits of the frame header\n     are set\n   - `error.EndOfStream` if `src` does not contain a complete frame\n   - `error.BadContentSize` if the content size declared by the frame does\n     not equal the actual size of decompressed data\n   - an error in `block.Error` if there are errors decoding a block\n   - `error.SkippableSizeTooLarge` if the frame is skippable and reports a\n     size greater than `src.len`",[15004,15005,15006],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[109,231,0,null,null," Decodes the frame at the start of `src` into `dest`. Returns the number of\n bytes read from `src`.\n\n Errors returned:\n   - `error.BadMagic` if the first 4 bytes of `src` is not a valid magic\n     number for a Zstandard or skippable frame\n   - `error.WindowSizeUnknown` if the frame does not have a valid window size\n   - `error.WindowTooLarge` if the window size is larger than\n     `window_size_max`\n   - `error.ContentSizeTooLarge` if the frame header indicates a content size\n     that is larger than `std.math.maxInt(usize)`\n   - `error.DictionaryIdFlagUnsupported` if the frame uses a dictionary\n   - `error.ChecksumFailure` if `verify_checksum` is true and the frame\n     contains a checksum that does not match the checksum of the decompressed\n     data\n   - `error.ReservedBitSet` if any of the reserved bits of the frame header\n     are set\n   - `error.EndOfStream` if `src` does not contain a complete frame\n   - `error.BadContentSize` if the content size declared by the frame does\n     not equal the actual size of decompressed data\n   - `error.OutOfMemory` if `allocator` cannot allocate enough memory\n   - an error in `block.Error` if there are errors decoding a block\n   - `error.SkippableSizeTooLarge` if the frame is skippable and reports a\n     size greater than `src.len`",[15008,15009,15010,15011,15012],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[0,0,0,"window_size_max",null,"",null,false],[109,260,0,null,null," Returns the frame checksum corresponding to the data fed into `hasher`",[15014],false],[0,0,0,"hasher",null,"",null,false],[109,265,0,null,null,null,null,false],[109,293,0,null,null," Decode a Zstandard frame from `src` into `dest`, returning the number of\n bytes read from `src` and written to `dest`. The first four bytes of `src`\n must be the magic number for a Zstandard frame.\n\n Error returned:\n   - `error.UnknownContentSizeUnsupported` if the frame does not declare the\n     uncompressed content size\n   - `error.ContentTooLarge` if `dest` is smaller than the uncompressed data\n     size declared by the frame header\n   - `error.WindowSizeUnknown` if the frame does not have a valid window size\n   - `error.DictionaryIdFlagUnsupported` if the frame uses a dictionary\n   - `error.ContentSizeTooLarge` if the frame header indicates a content size\n     that is larger than `std.math.maxInt(usize)`\n   - `error.ChecksumFailure` if `verify_checksum` is true and the frame\n     contains a checksum that does not match the checksum of the decompressed\n     data\n   - `error.ReservedBitSet` if the reserved bit of the frame header is set\n   - `error.EndOfStream` if `src` does not contain a complete frame\n   - an error in `block.Error` if there are errors decoding a block\n   - `error.BadContentSize` if the content size declared by the frame does\n     not equal the actual size of decompressed data",[15017,15018,15019],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[109,332,0,null,null,null,[15021,15022,15023],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"frame_context",null,"",null,false],[109,365,0,null,null,null,[15031,15032,15033,15034,15036],false],[109,372,0,null,null,null,null,false],[109,388,0,null,null," Validates `frame_header` and returns the associated `FrameContext`.\n\n Errors returned:\n   - `error.DictionaryIdFlagUnsupported` if the frame uses a dictionary\n   - `error.WindowSizeUnknown` if the frame does not have a valid window\n     size\n   - `error.WindowTooLarge` if the window size is larger than\n     `window_size_max`\n   - `error.ContentSizeTooLarge` if the frame header indicates a content\n     size larger than `std.math.maxInt(usize)`",[15027,15028,15029],false],[0,0,0,"frame_header",null,"",null,false],[0,0,0,"window_size_max",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[109,365,0,null,null,null,null,false],[0,0,0,"hasher_opt",null,null,null,false],[0,0,0,"window_size",null,null,null,false],[0,0,0,"has_checksum",null,null,null,false],[0,0,0,"block_size_max",null,null,null,false],[109,365,0,null,null,null,null,false],[0,0,0,"content_size",null,null,null,false],[109,440,0,null,null," Decode a Zstandard from from `src` and return number of bytes read; see\n `decodeZstandardFrame()`. The first four bytes of `src` must be the magic\n number for a Zstandard frame.\n\n Errors returned:\n   - `error.WindowSizeUnknown` if the frame does not have a valid window size\n   - `error.WindowTooLarge` if the window size is larger than\n     `window_size_max`\n   - `error.DictionaryIdFlagUnsupported` if the frame uses a dictionary\n   - `error.ContentSizeTooLarge` if the frame header indicates a content size\n     that is larger than `std.math.maxInt(usize)`\n   - `error.ChecksumFailure` if `verify_checksum` is true and the frame\n     contains a checksum that does not match the checksum of the decompressed\n     data\n   - `error.ReservedBitSet` if the reserved bit of the frame header is set\n   - `error.EndOfStream` if `src` does not contain a complete frame\n   - `error.OutOfMemory` if `allocator` cannot allocate enough memory\n   - an error in `block.Error` if there are errors decoding a block\n   - `error.BadContentSize` if the content size declared by the frame does\n     not equal the size of decompressed data",[15038,15039,15040,15041,15042],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"verify_checksum",null,"",null,false],[0,0,0,"window_size_max",null,"",null,false],[109,467,0,null,null,null,[15044,15045,15046,15047],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"frame_context",null,"",null,false],[109,531,0,null,null,null,[15049,15050,15051,15052,15053],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"consumed_count",null,"",null,false],[0,0,0,"hash",null,"",null,false],[0,0,0,"block_size_max",null,"",null,false],[109,570,0,null,null," Decode the header of a skippable frame. The first four bytes of `src` must\n be a valid magic number for a skippable frame.",[15055],false],[0,0,0,"src",null,"",null,false],[109,582,0,null,null," Returns the window size required to decompress a frame, or `null` if it\n cannot be determined (which indicates a malformed frame header).",[15057],false],[0,0,0,"header",null,"",null,false],[109,598,0,null,null," Decode the header of a Zstandard frame.\n\n Errors returned:\n   - `error.ReservedBitSet` if any of the reserved bits of the header are set\n   - `error.EndOfStream` if `source` does not contain a complete header",[15059],false],[0,0,0,"source",null,"",null,false],[107,10,0,null,null,null,[15061,15062],false],[0,0,0,"verify_checksum",null,null,null,false],[0,0,0,"window_size_max",null,null,null,false],[107,15,0,null,null,null,[15064,15065],false],[0,0,0,"ReaderType",null,"",null,true],[0,0,0,"options",null,"",[15085,15087,15092,15094,15096,15098,15100,15102,15104,15106,15108,15110,15111],true],[107,20,0,null,null,null,null,false],[107,36,0,null,null,null,null,false],[107,44,0,null,null,null,null,false],[107,46,0,null,null,null,[15070,15071],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[107,64,0,null,null,null,[15073],false],[0,0,0,"self",null,"",null,false],[107,130,0,null,null,null,[15075],false],[0,0,0,"self",null,"",null,false],[107,140,0,null,null,null,[15077],false],[0,0,0,"self",null,"",null,false],[107,144,0,null,null,null,[15079,15080],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[107,166,0,null,null,null,[15082,15083],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[107,19,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[107,19,0,null,null,null,[15089,15090,15091],false],[0,0,0,"NewFrame",null,null,null,false],[0,0,0,"InFrame",null,null,null,false],[0,0,0,"LastBlock",null,null,null,false],[0,0,0,"state",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"decode_state",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"frame_context",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"literal_fse_buffer",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"match_fse_buffer",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"offset_fse_buffer",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"literals_buffer",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"sequence_buffer",null,null,null,false],[107,19,0,null,null,null,null,false],[0,0,0,"checksum",null,null,null,false],[0,0,0,"current_frame_decompressed_size",null,null,null,false],[107,238,0,null,null,null,[15113,15114,15115],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"options",null,"",null,true],[107,246,0,null,null,null,[15117,15118],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[107,253,0,null,null,null,[15120],false],[0,0,0,"data",null,"",null,false],[107,261,0,null,null,null,[15122,15123],false],[0,0,0,"data",null,"",null,false],[0,0,0,"expected",null,"",null,true],[85,10,0,null,null,null,[15125,15126],false],[0,0,0,"ReaderType",null,"",null,true],[0,0,0,"HasherType",null,"",[15135,15137],true],[85,18,0,null,null,null,null,false],[85,19,0,null,null,null,null,false],[85,21,0,null,null,null,[15130,15131],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[85,27,0,null,null,null,[15133],false],[0,0,0,"self",null,"",null,false],[85,14,0,null,null,null,null,false],[0,0,0,"child_reader",null,null,null,false],[85,14,0,null,null,null,null,false],[0,0,0,"hasher",null,null,null,false],[85,33,0,null,null,null,[15139,15140],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"hasher",null,"",null,false],[1,77,0,null,null,null,null,false],[0,0,0,"comptime_string_map.zig",null,"",[],false],[114,0,0,null,null,null,null,false],[114,1,0,null,null,null,null,false],[114,9,0,null,null," Comptime string map optimized for small sets of disparate string keys.\n Works by separating the keys by length at comptime and only checking strings of\n equal length at runtime.\n\n `kvs_list` expects a list of `struct { []const u8, V }` (key-value pair) tuples.\n You can pass `struct { []const u8 }` (only keys) tuples if `V` is `void`.",[15146,15147],false],[0,0,0,"V",null,"",null,true],[0,0,0,"kvs_list",null,"",null,true],[114,18,0,null,null," Like `std.mem.eql`, but takes advantage of the fact that the lengths\n of `a` and `b` are known to be equal.",[15149,15150],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[114,28,0,null,null," Like `std.ascii.eqlIgnoreCase` but takes advantage of the fact that\n the lengths of `a` and `b` are known to be equal.",[15152,15153],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[114,40,0,null,null," ComptimeStringMap, but accepts an equality function (`eql`).\n The `eql` function is only called to determine the equality\n of equal length strings. Any strings that are not equal length\n are never compared using the `eql` function.",[15155,15156,15157],false],[0,0,0,"V",null,"",null,true],[0,0,0,"kvs_list",null,"",null,true],[0,0,0,"eql",null,"",[15158,15159],true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",[],false],[114,96,0,null,null," Array of `struct { key: []const u8, value: V }` where `value` is `void{}` if `V` is `void`.\n Sorted by `key` length.",null,false],[114,99,0,null,null," Checks if the map has a value for the key.",[15162],false],[0,0,0,"str",null,"",null,false],[114,104,0,null,null," Returns the value for the key if any, else null.",[15164],false],[0,0,0,"str",null,"",null,false],[114,123,0,null,null,null,[15166,15167,15168,15169,15170],false],[0,0,0,"A",null,null,null,false],[0,0,0,"B",null,null,null,false],[0,0,0,"C",null,null,null,false],[0,0,0,"D",null,null,null,false],[0,0,0,"E",null,null,null,false],[114,170,0,null,null,null,[15172],false],[0,0,0,"map",null,"",null,true],[114,207,0,null,null,null,[15174],false],[0,0,0,"map",null,"",null,true],[1,80,0,null,null," Cryptography.",null,false],[0,0,0,"crypto.zig",null,"",[],false],[115,0,0,null,null,null,null,false],[115,3,0,null,null," Authenticated Encryption with Associated Data",[],false],[115,4,0,null,null,null,[],false],[115,5,0,null,null,null,null,false],[0,0,0,"crypto/aegis.zig",null," AEGIS is a very fast authenticated encryption system built on top of the core AES function.\n\n The AEGIS-128L variant has a 128 bit key, a 128 bit nonce, and processes 256 bit message blocks.\n The AEGIS-256  variant has a 256 bit key, a 256 bit nonce, and processes 128 bit message blocks.\n\n The AEGIS cipher family offers performance that significantly exceeds that of AES-GCM with\n hardware support for parallelizable AES block encryption.\n\n Unlike with AES-GCM, nonces can be safely chosen at random with no practical limit when using AEGIS-256.\n AEGIS-128L also allows for more messages to be safely encrypted when using random nonces.\n\n AEGIS is believed to be key-committing, making it a safer choice than most other AEADs\n when the key has low entropy, or can be controlled by an attacker.\n\n Finally, leaking the state does not leak the key.\n\n https://datatracker.ietf.org/doc/draft-irtf-cfrg-aegis-aead/\n",[],false],[116,18,0,null,null,null,null,false],[116,19,0,null,null,null,null,false],[116,20,0,null,null,null,null,false],[116,21,0,null,null,null,null,false],[116,22,0,null,null,null,null,false],[116,23,0,null,null,null,null,false],[116,26,0,null,null," AEGIS-128L with a 128-bit authentication tag.",null,false],[116,29,0,null,null," AEGIS-128L with a 256-bit authentication tag.",null,false],[116,32,0,null,null," AEGIS-256 with a 128-bit authentication tag.",null,false],[116,35,0,null,null," AEGIS-256 with a 256-bit authentication tag.",null,false],[116,37,0,null,null,null,[15217],false],[116,40,0,null,null,null,[15194,15195],false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[116,63,0,null,null,null,[15197,15198,15199],false],[0,0,0,"state",null,"",null,false],[0,0,0,"d1",null,"",null,false],[0,0,0,"d2",null,"",null,false],[116,75,0,null,null,null,[15201,15202],false],[0,0,0,"state",null,"",null,false],[0,0,0,"src",null,"",null,false],[116,81,0,null,null,null,[15204,15205,15206],false],[0,0,0,"state",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[116,94,0,null,null,null,[15208,15209,15210],false],[0,0,0,"state",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[116,105,0,null,null,null,[15212,15213,15214,15215],false],[0,0,0,"state",null,"",null,false],[0,0,0,"tag_bits",null,"",null,true],[0,0,0,"adlen",null,"",null,false],[0,0,0,"mlen",null,"",null,false],[116,37,0,null,null,null,null,false],[0,0,0,"blocks",null,null,null,false],[116,128,0,null,null,null,[15219],false],[0,0,0,"tag_bits",null,"",[],true],[116,132,0,null,null,null,null,false],[116,133,0,null,null,null,null,false],[116,134,0,null,null,null,null,false],[116,135,0,null,null,null,null,false],[116,137,0,null,null,null,null,false],[116,145,0,null,null," c: ciphertext: output buffer should be of size m.len\n tag: authentication tag: output MAC\n m: message\n ad: Associated Data\n npub: public nonce\n k: private key",[15226,15227,15228,15229,15230,15231],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[116,181,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15233,15234,15235,15236,15237,15238],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[116,220,0,null,null,null,[15263],false],[116,223,0,null,null,null,[15241,15242],false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[116,251,0,null,null,null,[15244,15245],false],[0,0,0,"state",null,"",null,false],[0,0,0,"d",null,"",null,false],[116,261,0,null,null,null,[15247,15248],false],[0,0,0,"state",null,"",null,false],[0,0,0,"src",null,"",null,false],[116,266,0,null,null,null,[15250,15251,15252],false],[0,0,0,"state",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[116,275,0,null,null,null,[15254,15255,15256],false],[0,0,0,"state",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[116,283,0,null,null,null,[15258,15259,15260,15261],false],[0,0,0,"state",null,"",null,false],[0,0,0,"tag_bits",null,"",null,true],[0,0,0,"adlen",null,"",null,false],[0,0,0,"mlen",null,"",null,false],[116,220,0,null,null,null,null,false],[0,0,0,"blocks",null,null,null,false],[116,311,0,null,null," AEGIS is a very fast authenticated encryption system built on top of the core AES function.\n\n The 256 bit variant of AEGIS has a 256 bit key, a 256 bit nonce, and processes 128 bit message blocks.\n\n https://datatracker.ietf.org/doc/draft-irtf-cfrg-aegis-aead/",[15265],false],[0,0,0,"tag_bits",null,"",[],true],[116,315,0,null,null,null,null,false],[116,316,0,null,null,null,null,false],[116,317,0,null,null,null,null,false],[116,318,0,null,null,null,null,false],[116,320,0,null,null,null,null,false],[116,328,0,null,null," c: ciphertext: output buffer should be of size m.len\n tag: authentication tag: output MAC\n m: message\n ad: Associated Data\n npub: public nonce\n k: private key",[15272,15273,15274,15275,15276,15277],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[116,364,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15279,15280,15281,15282,15283,15284],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[116,409,0,null,null," The `Aegis128LMac` message authentication function outputs 256 bit tags.\n In addition to being extremely fast, its large state, non-linearity\n and non-invertibility provides the following properties:\n - 128 bit security, stronger than GHash/Polyval/Poly1305.\n - Recovering the secret key from the state would require ~2^128 attempts,\n   which is infeasible for any practical adversary.\n - It has a large security margin against internal collisions.",null,false],[116,420,0,null,null," The `Aegis256Mac` message authentication function has a 256-bit key size,\n and outputs 256 bit tags. Unless theoretical multi-target attacks are a\n concern, the AEGIS-128L variant should be preferred.\n AEGIS' large state, non-linearity and non-invertibility provides the\n following properties:\n - More than 128 bit security against forgery.\n - Recovering the secret key from the state would require ~2^256 attempts,\n   which is infeasible for any practical adversary.\n - It has a large security margin against internal collisions.",null,false],[116,427,0,null,null," Aegis128L MAC with a 128-bit output.\n A MAC with a 128-bit output is not safe unless the number of messages\n authenticated with the same key remains small.\n After 2^48 messages, the probability of a collision is already ~ 2^-33.\n If unsure, use the  Aegis128LMac type, that has a 256 bit output.",null,false],[116,434,0,null,null," Aegis256 MAC with a 128-bit output.\n A MAC with a 128-bit output is not safe unless the number of messages\n authenticated with the same key remains small.\n After 2^48 messages, the probability of a collision is already ~ 2^-33.\n If unsure, use the  Aegis256Mac type, that has a 256 bit output.",null,false],[116,436,0,null,null,null,[15290],false],[0,0,0,"T",null,"",[15315,15317,15318,15319],true],[116,438,0,null,null,null,null,false],[116,440,0,null,null,null,null,false],[116,441,0,null,null,null,null,false],[116,442,0,null,null,null,null,false],[116,450,0,null,null," Initialize a state for the MAC function",[15296],false],[0,0,0,"key",null,"",null,false],[116,458,0,null,null," Add data to the state",[15298,15299],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[116,481,0,null,null," Return an authentication tag for the current state",[15301,15302],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[116,491,0,null,null," Return an authentication tag for a message and a key",[15304,15305,15306],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[116,497,0,null,null,null,null,false],[116,498,0,null,null,null,null,false],[116,500,0,null,null,null,[15310,15311],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[116,505,0,null,null,null,[15313],false],[0,0,0,"self",null,"",null,false],[116,437,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[116,437,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"off",null,null,null,false],[0,0,0,"msg_len",null,null,null,false],[116,511,0,null,null,null,null,false],[0,0,0,"test.zig",null,"",[],false],[116,512,0,null,null,null,null,false],[115,6,0,null,null,null,null,false],[115,7,0,null,null,null,null,false],[115,8,0,null,null,null,null,false],[115,11,0,null,null,null,[],false],[115,12,0,null,null,null,null,false],[0,0,0,"crypto/aes_gcm.zig",null,"",[],false],[118,0,0,null,null,null,null,false],[118,1,0,null,null,null,null,false],[118,2,0,null,null,null,null,false],[118,3,0,null,null,null,null,false],[118,4,0,null,null,null,null,false],[118,5,0,null,null,null,null,false],[118,6,0,null,null,null,null,false],[118,7,0,null,null,null,null,false],[118,8,0,null,null,null,null,false],[118,10,0,null,null,null,null,false],[118,11,0,null,null,null,null,false],[118,13,0,null,null,null,[15341],false],[0,0,0,"Aes",null,"",[],true],[118,17,0,null,null,null,null,false],[118,18,0,null,null,null,null,false],[118,19,0,null,null,null,null,false],[118,21,0,null,null,null,null,false],[118,23,0,null,null,null,[15347,15348,15349,15350,15351,15352],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[118,66,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15354,15355,15356,15357,15358,15359],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[118,110,0,null,null,null,null,false],[118,111,0,null,null,null,null,false],[115,13,0,null,null,null,null,false],[115,16,0,null,null,null,[],false],[115,17,0,null,null,null,null,false],[0,0,0,"crypto/aes_ocb.zig",null,"",[],false],[119,0,0,null,null,null,null,false],[119,1,0,null,null,null,null,false],[119,2,0,null,null,null,null,false],[119,3,0,null,null,null,null,false],[119,4,0,null,null,null,null,false],[119,5,0,null,null,null,null,false],[119,6,0,null,null,null,null,false],[119,7,0,null,null,null,null,false],[119,9,0,null,null,null,null,false],[119,10,0,null,null,null,null,false],[119,12,0,null,null,null,null,false],[119,15,0,null,null," AES-OCB (RFC 7253 - https://competitions.cr.yp.to/round3/ocbv11.pdf)",[15378],false],[0,0,0,"Aes",null,"",[],true],[119,20,0,null,null,null,null,false],[119,21,0,null,null,null,null,false],[119,22,0,null,null,null,null,false],[119,24,0,null,null,null,[15391,15393,15395,15396],false],[119,30,0,null,null,null,[15384],false],[0,0,0,"l",null,"",null,false],[119,38,0,null,null,null,[15386,15387],false],[0,0,0,"lx",null,"",null,false],[0,0,0,"upto",null,"",null,false],[119,49,0,null,null,null,[15389],false],[0,0,0,"aes_enc_ctx",null,"",null,false],[119,24,0,null,null,null,null,false],[0,0,0,"star",null,null,null,false],[119,24,0,null,null,null,null,false],[0,0,0,"dol",null,null,null,false],[119,24,0,null,null,null,null,false],[0,0,0,"table",null,null,null,false],[0,0,0,"upto",null,null,null,false],[119,60,0,null,null,null,[15398,15399,15400],false],[0,0,0,"aes_enc_ctx",null,"",null,false],[0,0,0,"lx",null,"",null,false],[0,0,0,"a",null,"",null,false],[119,86,0,null,null,null,[15402,15403],false],[0,0,0,"aes_enc_ctx",null,"",null,false],[0,0,0,"npub",null,"",null,false],[119,103,0,null,null,null,null,false],[119,104,0,null,null,null,null,false],[119,105,0,null,null,null,null,false],[119,113,0,null,null," c: ciphertext: output buffer should be of size m.len\n tag: authentication tag: output MAC\n m: message\n ad: Associated Data\n npub: public nonce\n k: secret key",[15408,15409,15410,15411,15412,15413],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[119,179,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15415,15416,15417,15418,15419,15420],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[119,246,0,null,null,null,[15422,15423],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[119,254,0,null,null,null,[15425,15426],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[119,260,0,null,null,null,null,false],[115,18,0,null,null,null,null,false],[115,21,0,null,null,null,[],false],[115,22,0,null,null,null,null,false],[0,0,0,"crypto/chacha20.zig",null,"",[],false],[120,2,0,null,null,null,null,false],[120,3,0,null,null,null,null,false],[120,4,0,null,null,null,null,false],[120,5,0,null,null,null,null,false],[120,6,0,null,null,null,null,false],[120,7,0,null,null,null,null,false],[120,8,0,null,null,null,null,false],[120,9,0,null,null,null,null,false],[120,10,0,null,null,null,null,false],[120,11,0,null,null,null,null,false],[120,14,0,null,null," IETF-variant of the ChaCha20 stream cipher, as designed for TLS.",null,false],[120,19,0,null,null," IETF-variant of the ChaCha20 stream cipher, reduced to 12 rounds.\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,24,0,null,null," IETF-variant of the ChaCha20 stream cipher, reduced to 8 rounds.\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,27,0,null,null," Original ChaCha20 stream cipher.",null,false],[120,32,0,null,null," Original ChaCha20 stream cipher, reduced to 12 rounds.\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,37,0,null,null," Original ChaCha20 stream cipher, reduced to 8 rounds.\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,40,0,null,null," XChaCha20 (nonce-extended version of the IETF ChaCha20 variant) stream cipher",null,false],[120,45,0,null,null," XChaCha20 (nonce-extended version of the IETF ChaCha20 variant) stream cipher, reduced to 12 rounds\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,50,0,null,null," XChaCha20 (nonce-extended version of the IETF ChaCha20 variant) stream cipher, reduced to 8 rounds\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,53,0,null,null," ChaCha20-Poly1305 authenticated cipher, as designed for TLS",null,false],[120,58,0,null,null," ChaCha20-Poly1305 authenticated cipher, reduced to 12 rounds\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,63,0,null,null," ChaCha20-Poly1305 authenticated cipher, reduced to 8 rounds\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,66,0,null,null," XChaCha20-Poly1305 authenticated cipher",null,false],[120,71,0,null,null," XChaCha20-Poly1305 authenticated cipher\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,76,0,null,null," XChaCha20-Poly1305 authenticated cipher\n Reduced-rounds versions are faster than the full-round version, but have a lower security margin.\n However, ChaCha is still believed to have a comfortable security even with only 8 rounds.",null,false],[120,79,0,null,null,null,[15458,15459],false],[0,0,0,"rounds_nb",null,"",null,true],[0,0,0,"degree",null,"",[],true],[120,81,0,null,null,null,null,false],[120,82,0,null,null,null,null,false],[120,84,0,null,null,null,[15463,15464],false],[0,0,0,"key",null,"",null,false],[0,0,0,"d",null,"",null,false],[120,153,0,null,null,null,[15466,15467],false],[0,0,0,"x",null,"",null,false],[0,0,0,"input",null,"",null,false],[120,217,0,null,null,null,[15469,15470,15471],false],[0,0,0,"dm",null,"",null,true],[0,0,0,"out",null,"",null,false],[0,0,0,"x",null,"",null,false],[120,228,0,null,null,null,[15473,15474],false],[0,0,0,"x",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[120,235,0,null,null,null,[15476,15477,15478,15479,15480],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce_and_counter",null,"",null,false],[0,0,0,"count64",null,"",null,true],[120,278,0,null,null,null,[15482,15483,15484,15485],false],[0,0,0,"out",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce_and_counter",null,"",null,false],[0,0,0,"count64",null,"",null,true],[120,308,0,null,null,null,[15487,15488],false],[0,0,0,"input",null,"",null,false],[0,0,0,"key",null,"",null,false],[120,331,0,null,null,null,[15490],false],[0,0,0,"rounds_nb",null,"",[],true],[120,333,0,null,null,null,null,false],[120,335,0,null,null,null,[15493,15494],false],[0,0,0,"key",null,"",null,false],[0,0,0,"d",null,"",null,false],[120,351,0,null,null,null,[15496,15497,15498,15499],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[120,358,0,null,null,null,[15501,15502,15503,15504],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[120,367,0,null,null,null,[15506,15507],false],[0,0,0,"x",null,"",null,false],[0,0,0,"input",null,"",null,false],[120,396,0,null,null,null,[15509,15510],false],[0,0,0,"out",null,"",null,false],[0,0,0,"x",null,"",null,false],[120,405,0,null,null,null,[15512,15513],false],[0,0,0,"x",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[120,411,0,null,null,null,[15515,15516,15517,15518,15519],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce_and_counter",null,"",null,false],[0,0,0,"count64",null,"",null,true],[120,450,0,null,null,null,[15521,15522,15523,15524],false],[0,0,0,"out",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce_and_counter",null,"",null,false],[0,0,0,"count64",null,"",null,true],[120,476,0,null,null,null,[15526,15527],false],[0,0,0,"input",null,"",null,false],[0,0,0,"key",null,"",null,false],[120,498,0,null,null,null,[15529],false],[0,0,0,"rounds_nb",null,"",null,true],[120,516,0,null,null,null,[15531],false],[0,0,0,"key",null,"",null,false],[120,524,0,null,null,null,[15533,15534,15535],false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[0,0,0,"rounds_nb",null,"",[15537,15539],true],[120,524,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[120,524,0,null,null,null,null,false],[0,0,0,"nonce",null,null,null,false],[120,534,0,null,null,null,[15541],false],[0,0,0,"rounds_nb",null,"",[],true],[120,537,0,null,null," Nonce length in bytes.",null,false],[120,539,0,null,null," Key length in bytes.",null,false],[120,541,0,null,null," Block length in bytes.",null,false],[120,546,0,null,null," Add the output of the ChaCha20 stream cipher to `in` and stores the result into `out`.\n WARNING: This function doesn't provide authenticated encryption.\n Using the AEAD or one of the `box` versions is usually preferred.",[15546,15547,15548,15549,15550],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[120,559,0,null,null," Write the output of the ChaCha20 stream cipher into `out`.",[15552,15553,15554,15555],false],[0,0,0,"out",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[120,572,0,null,null,null,[15557],false],[0,0,0,"rounds_nb",null,"",[],true],[120,575,0,null,null," Nonce length in bytes.",null,false],[120,577,0,null,null," Key length in bytes.",null,false],[120,579,0,null,null," Block length in bytes.",null,false],[120,584,0,null,null," Add the output of the ChaCha20 stream cipher to `in` and stores the result into `out`.\n WARNING: This function doesn't provide authenticated encryption.\n Using the AEAD or one of the `box` versions is usually preferred.",[15562,15563,15564,15565,15566],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[120,598,0,null,null," Write the output of the ChaCha20 stream cipher into `out`.",[15568,15569,15570,15571],false],[0,0,0,"out",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[120,612,0,null,null,null,[15573],false],[0,0,0,"rounds_nb",null,"",[],true],[120,615,0,null,null," Nonce length in bytes.",null,false],[120,617,0,null,null," Key length in bytes.",null,false],[120,619,0,null,null," Block length in bytes.",null,false],[120,624,0,null,null," Add the output of the XChaCha20 stream cipher to `in` and stores the result into `out`.\n WARNING: This function doesn't provide authenticated encryption.\n Using the AEAD or one of the `box` versions is usually preferred.",[15578,15579,15580,15581,15582],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[120,630,0,null,null," Write the output of the XChaCha20 stream cipher into `out`.",[15584,15585,15586,15587],false],[0,0,0,"out",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[120,637,0,null,null,null,[15589],false],[0,0,0,"rounds_nb",null,"",[],true],[120,639,0,null,null,null,null,false],[120,640,0,null,null,null,null,false],[120,641,0,null,null,null,null,false],[120,649,0,null,null," c: ciphertext: output buffer should be of size m.len\n tag: authentication tag: output MAC\n m: message\n ad: Associated Data\n npub: public nonce\n k: private key",[15594,15595,15596,15597,15598,15599],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[120,687,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15601,15602,15603,15604,15605,15606],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[120,725,0,null,null,null,[15608],false],[0,0,0,"rounds_nb",null,"",[],true],[120,727,0,null,null,null,null,false],[120,728,0,null,null,null,null,false],[120,729,0,null,null,null,null,false],[120,737,0,null,null," c: ciphertext: output buffer should be of size m.len\n tag: authentication tag: output MAC\n m: message\n ad: Associated Data\n npub: public nonce\n k: private key",[15613,15614,15615,15616,15617,15618],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[120,751,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15620,15621,15622,15623,15624,15625],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[115,23,0,null,null,null,null,false],[115,24,0,null,null,null,null,false],[115,25,0,null,null,null,null,false],[115,26,0,null,null,null,null,false],[115,27,0,null,null,null,null,false],[115,30,0,null,null,null,null,false],[0,0,0,"crypto/isap.zig",null,"",[],false],[121,0,0,null,null,null,null,false],[121,1,0,null,null,null,null,false],[121,2,0,null,null,null,null,false],[121,3,0,null,null,null,null,false],[121,4,0,null,null,null,null,false],[121,5,0,null,null,null,null,false],[121,6,0,null,null,null,null,false],[121,7,0,null,null,null,null,false],[121,20,0,null,null," ISAPv2 is an authenticated encryption system hardened against side channels and fault attacks.\n https://csrc.nist.gov/CSRC/media/Projects/lightweight-cryptography/documents/round-2/spec-doc-rnd2/isap-spec-round2.pdf\n\n Note that ISAP is not suitable for high-performance applications.\n\n However:\n - if allowing physical access to the device is part of your threat model,\n - or if you need resistance against microcode/hardware-level side channel attacks,\n - or if software-induced fault attacks such as rowhammer are a concern,\n\n then you may consider ISAP for highly sensitive data.",[15681],false],[121,21,0,null,null,null,null,false],[121,22,0,null,null,null,null,false],[121,23,0,null,null,null,null,false],[121,25,0,null,null,null,null,false],[121,26,0,null,null,null,null,false],[121,27,0,null,null,null,null,false],[121,31,0,null,null,null,[15649,15650],false],[0,0,0,"isap",null,"",null,false],[0,0,0,"m",null,"",null,false],[121,54,0,null,null,null,[15652,15653,15654,15655],false],[0,0,0,"k",null,"",null,false],[0,0,0,"iv",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"out_len",null,"",null,true],[121,84,0,null,null,null,[15657,15658,15659,15660],false],[0,0,0,"c",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[121,112,0,null,null,null,[15662,15663,15664,15665],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[121,144,0,null,null,null,[15667,15668,15669,15670,15671,15672],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[121,158,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15674,15675,15676,15677,15678,15679],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"key",null,"",null,false],[121,20,0,null,null,null,null,false],[0,0,0,"st",null,null,null,false],[115,32,0,null,null,null,[],false],[115,33,0,null,null,null,null,false],[0,0,0,"crypto/salsa20.zig",null,"",[],false],[122,0,0,null,null,null,null,false],[122,1,0,null,null,null,null,false],[122,2,0,null,null,null,null,false],[122,3,0,null,null,null,null,false],[122,4,0,null,null,null,null,false],[122,5,0,null,null,null,null,false],[122,6,0,null,null,null,null,false],[122,8,0,null,null,null,null,false],[122,9,0,null,null,null,null,false],[122,10,0,null,null,null,null,false],[122,12,0,null,null,null,null,false],[122,13,0,null,null,null,null,false],[122,14,0,null,null,null,null,false],[122,17,0,null,null," The Salsa cipher with 20 rounds.",null,false],[122,20,0,null,null," The XSalsa cipher with 20 rounds.",null,false],[122,22,0,null,null,null,[15701],false],[0,0,0,"rounds",null,"",[],true],[122,24,0,null,null,null,null,false],[122,25,0,null,null,null,null,false],[122,26,0,null,null,null,null,false],[122,28,0,null,null,null,[15706,15707],false],[0,0,0,"key",null,"",null,false],[0,0,0,"d",null,"",null,false],[122,44,0,null,null,null,[15709,15710,15711],false],[0,0,0,"x",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"feedback",null,"",null,true],[122,111,0,null,null,null,[15713,15714],false],[0,0,0,"out",null,"",null,false],[0,0,0,"x",null,"",null,false],[122,121,0,null,null,null,[15716,15717,15718,15719],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"d",null,"",null,false],[122,157,0,null,null,null,[15721,15722],false],[0,0,0,"input",null,"",null,false],[0,0,0,"key",null,"",null,false],[122,179,0,null,null,null,[15724],false],[0,0,0,"rounds",null,"",[],true],[122,181,0,null,null,null,null,false],[122,183,0,null,null,null,[15727,15728],false],[0,0,0,"key",null,"",null,false],[0,0,0,"d",null,"",null,false],[122,199,0,null,null,null,[15730,15731,15732,15734],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[122,199,0,null,null,null,null,false],[0,0,0,"d",null,null,null,false],[122,206,0,null,null,null,[15736,15737,15738,15739],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[122,215,0,null,null,null,[15741,15742,15743],false],[0,0,0,"x",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"feedback",null,"",null,true],[122,241,0,null,null,null,[15745,15746],false],[0,0,0,"out",null,"",null,false],[0,0,0,"x",null,"",null,false],[122,247,0,null,null,null,[15748,15749,15750,15751],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"d",null,"",null,false],[122,282,0,null,null,null,[15753,15754],false],[0,0,0,"input",null,"",null,false],[0,0,0,"key",null,"",null,false],[122,304,0,null,null,null,null,false],[122,306,0,null,null,null,[15757],false],[0,0,0,"key",null,"",null,false],[122,315,0,null,null,null,[15759,15760,15761],false],[0,0,0,"rounds",null,"",null,true],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",[15763,15765],false],[122,315,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[122,315,0,null,null,null,null,false],[0,0,0,"nonce",null,null,null,false],[122,323,0,null,null," The Salsa stream cipher.",[15767],false],[0,0,0,"rounds",null,"",[],true],[122,326,0,null,null," Nonce length in bytes.",null,false],[122,328,0,null,null," Key length in bytes.",null,false],[122,333,0,null,null," Add the output of the Salsa stream cipher to `in` and stores the result into `out`.\n WARNING: This function doesn't provide authenticated encryption.\n Using the AEAD or one of the `box` versions is usually preferred.",[15771,15772,15773,15774,15775],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[122,347,0,null,null," The XSalsa stream cipher.",[15777],false],[0,0,0,"rounds",null,"",[],true],[122,350,0,null,null," Nonce length in bytes.",null,false],[122,352,0,null,null," Key length in bytes.",null,false],[122,357,0,null,null," Add the output of the XSalsa stream cipher to `in` and stores the result into `out`.\n WARNING: This function doesn't provide authenticated encryption.\n Using the AEAD or one of the `box` versions is usually preferred.",[15781,15782,15783,15784,15785],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[122,365,0,null,null," The XSalsa stream cipher, combined with the Poly1305 MAC",[],false],[122,367,0,null,null," Authentication tag length in bytes.",null,false],[122,369,0,null,null," Nonce length in bytes.",null,false],[122,371,0,null,null," Key length in bytes.",null,false],[122,373,0,null,null,null,null,false],[122,381,0,null,null," c: ciphertext: output buffer should be of size m.len\n tag: authentication tag: output MAC\n m: message\n ad: Associated Data\n npub: public nonce\n k: private key",[15792,15793,15794,15795,15796,15797],false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[122,405,0,null,null," `m`: Message\n `c`: Ciphertext\n `tag`: Authentication tag\n `ad`: Associated data\n `npub`: Public nonce\n `k`: Private key\n Asserts `c.len == m.len`.\n\n Contents of `m` are undefined if an error is returned.",[15799,15800,15801,15802,15803,15804],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"ad",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[122,435,0,null,null," NaCl-compatible secretbox API.\n\n A secretbox contains both an encrypted message and an authentication tag to verify that it hasn't been tampered with.\n A secret key shared by all the recipients must be already known in order to use this API.\n\n Nonces are 192-bit large and can safely be chosen with a random number generator.",[],false],[122,437,0,null,null," Key length in bytes.",null,false],[122,439,0,null,null," Nonce length in bytes.",null,false],[122,441,0,null,null," Authentication tag length in bytes.",null,false],[122,445,0,null,null," Encrypt and authenticate `m` using a nonce `npub` and a key `k`.\n `c` must be exactly `tag_length` longer than `m`, as it will store both the ciphertext and the authentication tag.",[15810,15811,15812,15813],false],[0,0,0,"c",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[122,452,0,null,null," Verify and decrypt `c` using a nonce `npub` and a key `k`.\n `m` must be exactly `tag_length` smaller than `c`, as `c` includes an authentication tag in addition to the encrypted message.",[15815,15816,15817,15818],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"k",null,"",null,false],[122,469,0,null,null," NaCl-compatible box API.\n\n A secretbox contains both an encrypted message and an authentication tag to verify that it hasn't been tampered with.\n This construction uses public-key cryptography. A shared secret doesn't have to be known in advance by both parties.\n Instead, a message is encrypted using a sender's secret key and a recipient's public key,\n and is decrypted using the recipient's secret key and the sender's public key.\n\n Nonces are 192-bit large and can safely be chosen with a random number generator.",[],false],[122,471,0,null,null," Public key length in bytes.",null,false],[122,473,0,null,null," Secret key length in bytes.",null,false],[122,475,0,null,null," Shared key length in bytes.",null,false],[122,477,0,null,null," Seed (for key pair creation) length in bytes.",null,false],[122,479,0,null,null," Nonce length in bytes.",null,false],[122,481,0,null,null," Authentication tag length in bytes.",null,false],[122,484,0,null,null," A key pair.",null,false],[122,487,0,null,null," Compute a secret suitable for `secretbox` given a recipent's public key and a sender's secret key.",[15828,15829],false],[0,0,0,"public_key",null,"",null,false],[0,0,0,"secret_key",null,"",null,false],[122,494,0,null,null," Encrypt and authenticate a message using a recipient's public key `public_key` and a sender's `secret_key`.",[15831,15832,15833,15834,15835],false],[0,0,0,"c",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[0,0,0,"secret_key",null,"",null,false],[122,500,0,null,null," Verify and decrypt a message using a recipient's secret key `public_key` and a sender's `public_key`.",[15837,15838,15839,15840,15841],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"npub",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[0,0,0,"secret_key",null,"",null,false],[122,513,0,null,null," libsodium-compatible sealed boxes\n\n Sealed boxes are designed to anonymously send messages to a recipient given their public key.\n Only the recipient can decrypt these messages, using their private key.\n While the recipient can verify the integrity of the message, it cannot verify the identity of the sender.\n\n A message is encrypted using an ephemeral key pair, whose secret part is destroyed right after the encryption process.",[],false],[122,514,0,null,null,null,null,false],[122,515,0,null,null,null,null,false],[122,516,0,null,null,null,null,false],[122,517,0,null,null,null,null,false],[122,520,0,null,null," A key pair.",null,false],[122,522,0,null,null,null,[15849,15850],false],[0,0,0,"pk1",null,"",null,false],[0,0,0,"pk2",null,"",null,false],[122,533,0,null,null," Encrypt a message `m` for a recipient whose public key is `public_key`.\n `c` must be `seal_length` bytes larger than `m`, so that the required metadata can be added.",[15852,15853,15854],false],[0,0,0,"c",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[122,544,0,null,null," Decrypt a message using a key pair.\n `m` must be exactly `seal_length` bytes smaller than `c`, as `c` also includes metadata.",[15856,15857,15858],false],[0,0,0,"m",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"keypair",null,"",null,false],[122,554,0,null,null,null,null,false],[115,38,0,null,null," Authentication (MAC) functions.",[],false],[115,39,0,null,null,null,null,false],[0,0,0,"crypto/hmac.zig",null,"",[],false],[123,0,0,null,null,null,null,false],[123,1,0,null,null,null,null,false],[123,2,0,null,null,null,null,false],[123,3,0,null,null,null,null,false],[123,5,0,null,null,null,null,false],[123,6,0,null,null,null,null,false],[123,8,0,null,null,null,[],false],[123,9,0,null,null,null,null,false],[123,10,0,null,null,null,null,false],[123,11,0,null,null,null,null,false],[123,12,0,null,null,null,null,false],[123,15,0,null,null,null,[15875],false],[0,0,0,"Hash",null,"",[15893,15895],true],[123,17,0,null,null,null,null,false],[123,18,0,null,null,null,null,false],[123,19,0,null,null,null,null,false],[123,20,0,null,null,null,null,false],[123,26,0,null,null,null,[15881,15882,15883],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[123,32,0,null,null,null,[15885],false],[0,0,0,"key",null,"",null,false],[123,61,0,null,null,null,[15887,15888],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"msg",null,"",null,false],[123,65,0,null,null,null,[15890,15891],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"out",null,"",null,false],[123,16,0,null,null,null,null,false],[0,0,0,"o_key_pad",null,null,null,false],[123,16,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[123,76,0,null,null,null,null,false],[115,40,0,null,null,null,null,false],[0,0,0,"crypto/siphash.zig",null,"",[],false],[124,8,0,null,null,null,null,false],[124,9,0,null,null,null,null,false],[124,10,0,null,null,null,null,false],[124,11,0,null,null,null,null,false],[124,12,0,null,null,null,null,false],[124,24,0,null,null," SipHash function with 64-bit output.\n\n Recommended parameters are:\n - (c_rounds=4, d_rounds=8) for conservative security; regular hash functions such as BLAKE2 or BLAKE3 are usually a better alternative.\n - (c_rounds=2, d_rounds=4) standard parameters.\n - (c_rounds=1, d_rounds=3) reduced-round function. Faster, no known implications on its practical security level.\n - (c_rounds=1, d_rounds=2) fastest option, but the output may be distinguishable from random data with related keys or non-uniform input - not suitable as a PRF.\n\n SipHash is not a traditional hash function. If the input includes untrusted content, a secret key is absolutely necessary.\n And due to its small output size, collisions in SipHash64 can be found with an exhaustive search.",[15905,15906],false],[0,0,0,"c_rounds",null,"",null,true],[0,0,0,"d_rounds",null,"",null,true],[124,38,0,null,null," SipHash function with 128-bit output.\n\n Recommended parameters are:\n - (c_rounds=4, d_rounds=8) for conservative security; regular hash functions such as BLAKE2 or BLAKE3 are usually a better alternative.\n - (c_rounds=2, d_rounds=4) standard parameters.\n - (c_rounds=1, d_rounds=4) reduced-round function. Recommended to hash very short, similar strings, when a 128-bit PRF output is still required.\n - (c_rounds=1, d_rounds=3) reduced-round function. Faster, no known implications on its practical security level.\n - (c_rounds=1, d_rounds=2) fastest option, but the output may be distinguishable from random data with related keys or non-uniform input - not suitable as a PRF.\n\n SipHash is not a traditional hash function. If the input includes untrusted content, a secret key is absolutely necessary.",[15908,15909],false],[0,0,0,"c_rounds",null,"",null,true],[0,0,0,"d_rounds",null,"",null,true],[124,42,0,null,null,null,[15911,15912,15913],false],[0,0,0,"T",null,"",null,true],[0,0,0,"c_rounds",null,"",null,true],[0,0,0,"d_rounds",null,"",[15933,15934,15935,15936,15937],true],[124,47,0,null,null,null,null,false],[124,48,0,null,null,null,null,false],[124,49,0,null,null,null,null,false],[124,57,0,null,null,null,[15918],false],[0,0,0,"key",null,"",null,false],[124,76,0,null,null,null,[15920,15921],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[124,88,0,null,null,null,[15923,15924],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[124,125,0,null,null,null,[15926,15927],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[124,137,0,null,null,null,[15929],false],[0,0,0,"d",null,"",null,false],[124,154,0,null,null,null,[15931,15932],false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"v0",null,null,null,false],[0,0,0,"v1",null,null,null,false],[0,0,0,"v2",null,null,null,false],[0,0,0,"v3",null,null,null,false],[0,0,0,"msg_len",null,null,null,false],[124,163,0,null,null,null,[15939,15940,15941],false],[0,0,0,"T",null,"",null,true],[0,0,0,"c_rounds",null,"",null,true],[0,0,0,"d_rounds",null,"",[15976,15978,15979],true],[124,168,0,null,null,null,null,false],[124,169,0,null,null,null,null,false],[124,170,0,null,null,null,null,false],[124,171,0,null,null,null,null,false],[124,172,0,null,null,null,null,false],[124,179,0,null,null," Initialize a state for a SipHash function",[15948],false],[0,0,0,"key",null,"",null,false],[124,188,0,null,null," Add data to the state",[15950,15951],false],[0,0,0,"self",null,"",null,false],[0,0,0,"b",null,"",null,false],[124,207,0,null,null,null,[15953],false],[0,0,0,"self",null,"",null,false],[124,214,0,null,null," Return an authentication tag for the current state\n Assumes `out` is less than or equal to `mac_length`.",[15955,15956],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[124,218,0,null,null,null,[15958],false],[0,0,0,"self",null,"",null,false],[124,225,0,null,null," Return an authentication tag for a message and a key",[15960,15961,15962],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[124,232,0,null,null," Return an authentication tag for the current state, as an integer",[15964],false],[0,0,0,"self",null,"",null,false],[124,237,0,null,null," Return an authentication tag for a message and a key, as an integer",[15966,15967],false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[124,241,0,null,null,null,null,false],[124,242,0,null,null,null,null,false],[124,244,0,null,null,null,[15971,15972],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[124,249,0,null,null,null,[15974],false],[0,0,0,"self",null,"",null,false],[124,167,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[124,167,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[124,257,0,null,null,null,null,false],[115,41,0,null,null,null,[],false],[115,42,0,null,null,null,null,false],[115,43,0,null,null,null,null,false],[115,44,0,null,null,null,null,false],[115,45,0,null,null,null,null,false],[115,47,0,null,null,null,null,false],[0,0,0,"crypto/cmac.zig",null,"",[],false],[125,0,0,null,null,null,null,false],[125,1,0,null,null,null,null,false],[125,2,0,null,null,null,null,false],[125,5,0,null,null," CMAC with AES-128 - RFC 4493 https://www.rfc-editor.org/rfc/rfc4493",null,false],[125,9,0,null,null," NIST Special Publication 800-38B - The CMAC Mode for Authentication\n https://nvlpubs.nist.gov/nistpubs/SpecialPublications/NIST.SP.800-38b.pdf",[15993],false],[0,0,0,"BlockCipher",null,"",[16013,16015,16017,16019,16020],true],[125,14,0,null,null,null,null,false],[125,15,0,null,null,null,null,false],[125,16,0,null,null,null,null,false],[125,17,0,null,null,null,null,false],[125,25,0,null,null,null,[15999,16000,16001],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[125,31,0,null,null,null,[16003],false],[0,0,0,"key",null,"",null,false],[125,44,0,null,null,null,[16005,16006],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[125,65,0,null,null,null,[16008,16009],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[125,75,0,null,null,null,[16011],false],[0,0,0,"l",null,"",null,false],[125,13,0,null,null,null,null,false],[0,0,0,"cipher_ctx",null,null,null,false],[125,13,0,null,null,null,null,false],[0,0,0,"k1",null,null,null,false],[125,13,0,null,null,null,null,false],[0,0,0,"k2",null,null,null,false],[125,13,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"pos",null,null,null,false],[125,92,0,null,null,null,null,false],[115,51,0,null,null," Core functions, that should rarely be used directly by applications.",[],false],[115,52,0,null,null,null,null,false],[0,0,0,"crypto/aes.zig",null,"",[],false],[126,0,0,null,null,null,null,false],[126,1,0,null,null,null,null,false],[126,2,0,null,null,null,null,false],[126,4,0,null,null,null,null,false],[126,5,0,null,null,null,null,false],[126,6,0,null,null,null,null,false],[126,8,0,null,null,null,null,false],[126,19,0,null,null," `true` if AES is backed by hardware (AES-NI on x86_64, ARM Crypto Extensions on AArch64).\n Software implementations are much slower, and should be avoided if possible.",null,false],[126,23,0,null,null,null,null,false],[126,24,0,null,null,null,null,false],[126,25,0,null,null,null,null,false],[126,26,0,null,null,null,null,false],[126,27,0,null,null,null,null,false],[115,53,0,null,null,null,null,false],[0,0,0,"crypto/keccak_p.zig",null,"",[],false],[127,0,0,null,null,null,null,false],[127,1,0,null,null,null,null,false],[127,2,0,null,null,null,null,false],[127,3,0,null,null,null,null,false],[127,6,0,null,null," The Keccak-f permutation.",[16045],false],[0,0,0,"f",null,"",[16088],true],[127,16,0,null,null,null,null,false],[127,19,0,null,null," Number of bytes in the state.",null,false],[127,22,0,null,null," Maximum number of rounds for the given f parameter.",null,false],[127,25,0,null,null,null,null,false],[127,42,0,null,null," Initialize the state from a slice of bytes.",[16051],false],[0,0,0,"bytes",null,"",null,false],[127,51,0,null,null," A representation of the state as bytes. The byte order is architecture-dependent.",[16053],false],[0,0,0,"self",null,"",null,false],[127,56,0,null,null," Byte-swap the entire state if the architecture doesn't match the required endianness.",[16055],false],[0,0,0,"self",null,"",null,false],[127,63,0,null,null," Set bytes starting at the beginning of the state.",[16057,16058],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[127,76,0,null,null," XOR a byte into the state at a given offset.",[16060,16061,16062],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[0,0,0,"offset",null,"",null,false],[127,82,0,null,null," XOR bytes into the beginning of the state.",[16064,16065],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[127,95,0,null,null," Extract the first bytes of the state.",[16067,16068],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[127,108,0,null,null," XOR the first bytes of the state into a slice of bytes.",[16070,16071,16072],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[127,126,0,null,null," Set the words storing the bytes of a given range to zero.",[16074,16075,16076],false],[0,0,0,"self",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[127,131,0,null,null," Clear the entire state, disabling compiler optimizations.",[16078],false],[0,0,0,"self",null,"",null,false],[127,135,0,null,null,null,[16080,16081],false],[0,0,0,"self",null,"",null,false],[0,0,0,"rc",null,"",null,false],[127,175,0,null,null," Apply a (possibly) reduced-round permutation to the state.",[16083,16084],false],[0,0,0,"self",null,"",null,false],[0,0,0,"rounds",null,"",null,true],[127,188,0,null,null," Apply a full-round permutation to the state.",[16086],false],[0,0,0,"self",null,"",null,false],[127,15,0,null,null,null,null,false],[0,0,0,"st",null,null,null,false],[127,195,0,null,null," A generic Keccak-P state.",[16090,16091,16092,16093],false],[0,0,0,"f",null,"",null,true],[0,0,0,"capacity",null,"",null,true],[0,0,0,"delim",null,"",null,true],[0,0,0,"rounds",null,"",[16105,16107,16109],true],[127,200,0,null,null,null,null,false],[127,203,0,null,null," The block length, or rate, in bytes.",null,false],[127,205,0,null,null," Keccak does not have any options.",[],false],[127,213,0,null,null," Absorb a slice of bytes into the sponge.",[16098,16099],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes_",null,"",null,false],[127,239,0,null,null," Mark the end of the input.",[16101],false],[0,0,0,"self",null,"",null,false],[127,248,0,null,null," Squeeze a slice of bytes from the sponge.",[16103,16104],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"offset",null,null,null,false],[127,199,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[127,199,0,null,null,null,null,false],[0,0,0,"st",null,null,null,false],[115,55,0,null,null,null,null,false],[0,0,0,"crypto/ascon.zig",null," Ascon is a 320-bit permutation, selected as new standard for lightweight cryptography\n in the NIST Lightweight Cryptography competition (2019–2023).\n https://csrc.nist.gov/News/2023/lightweight-cryptography-nist-selects-ascon\n\n The permutation is compact, and optimized for timing and side channel resistance,\n making it a good choice for embedded applications.\n\n It is not meant to be used directly, but as a building block for symmetric cryptography.\n",[],false],[128,9,0,null,null,null,null,false],[128,10,0,null,null,null,null,false],[128,11,0,null,null,null,null,false],[128,12,0,null,null,null,null,false],[128,13,0,null,null,null,null,false],[128,14,0,null,null,null,null,false],[128,22,0,null,null," An Ascon state.\n\n The state is represented as 5 64-bit words.\n\n The NIST submission (v1.2) serializes these words as big-endian,\n but software implementations are free to use native endianness.",[16119],false],[0,0,0,"endian",null,"",[16169],true],[128,24,0,null,null,null,null,false],[128,27,0,null,null," Number of bytes in the state.",null,false],[128,29,0,null,null,null,null,false],[128,34,0,null,null," Initialize the state from a slice of bytes.",[16124],false],[0,0,0,"initial_state",null,"",null,false],[128,42,0,null,null," Initialize the state from u64 words in native endianness.",[16126],false],[0,0,0,"initial_state",null,"",null,false],[128,48,0,null,null," Initialize the state for Ascon XOF",[],false],[128,59,0,null,null," Initialize the state for Ascon XOFa",[],false],[128,70,0,null,null," A representation of the state as bytes. The byte order is architecture-dependent.",[16130],false],[0,0,0,"self",null,"",null,false],[128,75,0,null,null," Byte-swap the entire state if the architecture doesn't match the required endianness.",[16132],false],[0,0,0,"self",null,"",null,false],[128,82,0,null,null," Set bytes starting at the beginning of the state.",[16134,16135],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[128,95,0,null,null," XOR a byte into the state at a given offset.",[16137,16138,16139],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[0,0,0,"offset",null,"",null,false],[128,104,0,null,null," XOR bytes into the beginning of the state.",[16141,16142],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[128,117,0,null,null," Extract the first bytes of the state.",[16144,16145],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[128,130,0,null,null," XOR the first bytes of the state into a slice of bytes.",[16147,16148,16149],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[128,148,0,null,null," Set the words storing the bytes of a given range to zero.",[16151,16152,16153],false],[0,0,0,"self",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[128,153,0,null,null," Clear the entire state, disabling compiler optimizations.",[16155],false],[0,0,0,"self",null,"",null,false],[128,158,0,null,null," Apply a reduced-round permutation to the state.",[16157,16158],false],[0,0,0,"state",null,"",null,false],[0,0,0,"rounds",null,"",null,true],[128,166,0,null,null," Apply a full-round permutation to the state.",[16160],false],[0,0,0,"state",null,"",null,false],[128,172,0,null,null," Apply a permutation to the state and prevent backtracking.\n The rate is expressed in bytes and must be a multiple of the word size (8).",[16162,16163,16164],false],[0,0,0,"state",null,"",null,false],[0,0,0,"rounds",null,"",null,true],[0,0,0,"rate",null,"",null,true],[128,182,0,null,null,null,[16166,16167],false],[0,0,0,"state",null,"",null,false],[0,0,0,"rk",null,"",null,false],[128,23,0,null,null,null,null,false],[0,0,0,"st",null,null,null,false],[115,62,0,null,null," Modes are generic compositions to construct encryption/decryption functions from block ciphers and permutations.\n\n These modes are designed to be building blocks for higher-level constructions, and should generally not be used directly by applications, as they may not provide the expected properties and security guarantees.\n\n Most applications may want to use AEADs instead.",null,false],[0,0,0,"crypto/modes.zig",null,"",[],false],[129,2,0,null,null,null,null,false],[129,3,0,null,null,null,null,false],[129,4,0,null,null,null,null,false],[129,12,0,null,null," Counter mode.\n\n This mode creates a key stream by encrypting an incrementing counter using a block cipher, and adding it to the source material.\n\n Important: the counter mode doesn't provide authenticated encryption: the ciphertext can be trivially modified without this being detected.\n As a result, applications should generally never use it directly, but only in a construction that includes a MAC.",[16176,16177,16178,16179,16180,16181],false],[0,0,0,"BlockCipher",null,"",null,true],[0,0,0,"block_cipher",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"iv",null,"",null,false],[0,0,0,"endian",null,"",null,false],[115,66,0,null,null," Diffie-Hellman key exchange functions.",[],false],[115,67,0,null,null,null,null,false],[0,0,0,"crypto/25519/x25519.zig",null,"",[],false],[130,0,0,null,null,null,null,false],[130,1,0,null,null,null,null,false],[130,2,0,null,null,null,null,false],[130,3,0,null,null,null,null,false],[130,5,0,null,null,null,null,false],[130,7,0,null,null,null,null,false],[130,8,0,null,null,null,null,false],[130,9,0,null,null,null,null,false],[130,12,0,null,null," X25519 DH function.",[],false],[130,14,0,null,null," The underlying elliptic curve.",null,false],[0,0,0,"curve25519.zig",null,"",[],false],[131,0,0,null,null,null,null,false],[131,1,0,null,null,null,null,false],[131,3,0,null,null,null,null,false],[131,4,0,null,null,null,null,false],[131,5,0,null,null,null,null,false],[131,8,0,null,null," Group operations over Curve25519.",[16398],false],[131,10,0,null,null," The underlying prime field.",null,false],[0,0,0,"field.zig",null,"",[],false],[132,0,0,null,null,null,null,false],[132,1,0,null,null,null,null,false],[132,2,0,null,null,null,null,false],[132,3,0,null,null,null,null,false],[132,4,0,null,null,null,null,false],[132,6,0,null,null,null,null,false],[132,7,0,null,null,null,null,false],[132,10,0,null,null,null,null,false],[132,15,0,null,null,null,[16294],false],[132,18,0,null,null,null,null,false],[132,21,0,null,null," 0",null,false],[132,24,0,null,null," 1",null,false],[132,27,0,null,null," sqrt(-1)",null,false],[132,30,0,null,null," The Curve25519 base point",null,false],[132,33,0,null,null," Edwards25519 d = 37095705934669439343138083508754565189542113879843219016388785533085940283555",null,false],[132,36,0,null,null," Edwards25519 2d",null,false],[132,39,0,null,null," Edwards25519 1/sqrt(a-d)",null,false],[132,42,0,null,null," Edwards25519 1-d^2",null,false],[132,45,0,null,null," Edwards25519 (d-1)^2",null,false],[132,48,0,null,null," Edwards25519 sqrt(ad-1) with a = -1 (mod p)",null,false],[132,51,0,null,null," Edwards25519 A, as a single limb",null,false],[132,54,0,null,null," Edwards25519 A",null,false],[132,57,0,null,null," Edwards25519 sqrt(A-2)",null,false],[132,60,0,null,null," Return true if the field element is zero",[16228],false],[0,0,0,"fe",null,"",null,false],[132,68,0,null,null," Return true if both field elements are equivalent",[16230,16231],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[132,73,0,null,null," Unpack a field element",[16233],false],[0,0,0,"s",null,"",null,false],[132,85,0,null,null," Pack a field element",[16235],false],[0,0,0,"fe",null,"",null,false],[132,98,0,null,null," Map a 64 bytes big endian string into a field element",[16237],false],[0,0,0,"s",null,"",null,false],[132,120,0,null,null," Reject non-canonical encodings of an element, possibly ignoring the top bit",[16239,16240],false],[0,0,0,"s",null,"",null,false],[0,0,0,"ignore_extra_bit",null,"",null,true],[132,135,0,null,null," Reduce a field element mod 2^255-19",[16242],false],[0,0,0,"fe",null,"",null,false],[132,172,0,null,null," Add a field element",[16244,16245],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[132,182,0,null,null," Subtract a field element",[16247,16248],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[132,201,0,null,null," Negate a field element",[16250],false],[0,0,0,"a",null,"",null,false],[132,206,0,null,null," Return true if a field element is negative",[16252],false],[0,0,0,"a",null,"",null,false],[132,211,0,null,null," Conditonally replace a field element with `a` if `c` is positive",[16254,16255,16256],false],[0,0,0,"fe",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[132,229,0,null,null," Conditionally swap two pairs of field elements if `c` is positive",[16258,16259,16260,16261,16262],false],[0,0,0,"a0",null,"",null,false],[0,0,0,"b0",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"b1",null,"",null,false],[0,0,0,"c",null,"",null,false],[132,252,0,null,null,null,[16264],false],[0,0,0,"r",null,"",null,false],[132,273,0,null,null," Multiply two field elements",[16266,16267],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[132,296,0,null,null,null,[16269,16270],false],[0,0,0,"a",null,"",null,false],[0,0,0,"double",null,"",null,true],[132,325,0,null,null," Square a field element",[16272],false],[0,0,0,"a",null,"",null,false],[132,330,0,null,null," Square and double a field element",[16274],false],[0,0,0,"a",null,"",null,false],[132,335,0,null,null," Multiply a field element with a small (32-bit) integer",[16276,16277],false],[0,0,0,"a",null,"",null,false],[0,0,0,"n",null,"",null,true],[132,350,0,null,null," Square a field element `n` times",[16279,16280],false],[0,0,0,"a",null,"",null,false],[0,0,0,"n",null,"",null,false],[132,360,0,null,null," Return the inverse of a field element, or 0 if a=0.",[16282],false],[0,0,0,"a",null,"",null,false],[132,375,0,null,null," Return a^((p-5)/8) = a^(2^252-3)\n Used to compute square roots since we have p=5 (mod 8); see Cohen and Frey.",[16284],false],[0,0,0,"a",null,"",null,false],[132,387,0,null,null," Return the absolute value of a field element",[16286],false],[0,0,0,"a",null,"",null,false],[132,394,0,null,null," Return true if the field element is a square",[16288],false],[0,0,0,"a",null,"",null,false],[132,407,0,null,null,null,[16290],false],[0,0,0,"x2",null,"",null,false],[132,419,0,null,null," Compute the square root of `x2`, returning `error.NotSquare` if `x2` was not a square",[16292],false],[0,0,0,"x2",null,"",null,false],[132,15,0,null,null,null,null,false],[0,0,0,"limbs",null,null,null,false],[131,12,0,null,null," Field arithmetic mod the order of the main subgroup.",null,false],[0,0,0,"scalar.zig",null,"",[],false],[133,0,0,null,null,null,null,false],[133,1,0,null,null,null,null,false],[133,2,0,null,null,null,null,false],[133,4,0,null,null,null,null,false],[133,7,0,null,null," The scalar field order.",null,false],[133,10,0,null,null," A compressed scalar",null,false],[133,13,0,null,null," Zero",null,false],[133,15,0,null,null,null,null,false],[133,22,0,null,null," Reject a scalar whose encoding is not canonical.",[16306],false],[0,0,0,"s",null,"",null,false],[133,39,0,null,null," Reduce a scalar to the field size.",[16308],false],[0,0,0,"s",null,"",null,false],[133,45,0,null,null," Reduce a 64-bytes scalar to the field size.",[16310],false],[0,0,0,"s",null,"",null,false],[133,52,0,null,null," Perform the X25519 \"clamping\" operation.\n The scalar is then guaranteed to be a multiple of the cofactor.",[16312],false],[0,0,0,"s",null,"",null,false],[133,58,0,null,null," Return a*b (mod L)",[16314,16315],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[133,63,0,null,null," Return a*b+c (mod L)",[16317,16318,16319],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[133,68,0,null,null," Return a*8 (mod L)",[16321],false],[0,0,0,"s",null,"",null,false],[133,77,0,null,null," Return a+b (mod L)",[16323,16324],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[133,82,0,null,null," Return -s (mod L)",[16326],false],[0,0,0,"s",null,"",null,false],[133,98,0,null,null," Return (a-b) (mod L)",[16328,16329],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[133,103,0,null,null," Return a random scalar < L",[],false],[133,108,0,null,null," A scalar in unpacked representation",[16360],false],[133,109,0,null,null,null,null,false],[133,113,0,null,null," Unpack a 32-byte representation of a scalar",[16334],false],[0,0,0,"bytes",null,"",null,false],[133,119,0,null,null," Unpack a 64-byte representation of a scalar",[16336],false],[0,0,0,"bytes",null,"",null,false],[133,125,0,null,null," Pack a scalar into bytes",[16338],false],[0,0,0,"expanded",null,"",null,false],[133,136,0,null,null," Return true if the scalar is zero",[16340],false],[0,0,0,"n",null,"",null,false],[133,142,0,null,null," Return x+y (mod L)",[16342,16343],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[133,199,0,null,null," Return x*r (mod L)",[16345,16346],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[133,511,0,null,null," Return x^2 (mod L)",[16348],false],[0,0,0,"x",null,"",null,false],[133,516,0,null,null," Square a scalar `n` times",[16350,16351],false],[0,0,0,"x",null,"",null,false],[0,0,0,"n",null,"",null,true],[133,526,0,null,null," Square and multiply",[16353,16354,16355],false],[0,0,0,"x",null,"",null,false],[0,0,0,"n",null,"",null,true],[0,0,0,"y",null,"",null,false],[133,531,0,null,null," Return the inverse of a scalar (mod L), or 0 if x=0.",[16357],false],[0,0,0,"x",null,"",null,false],[133,562,0,null,null," Return a random scalar < L.",[],false],[133,108,0,null,null,null,null,false],[0,0,0,"limbs",null,null,null,false],[133,574,0,null,null,null,[16373],false],[133,575,0,null,null,null,null,false],[133,578,0,null,null,null,[16364],false],[0,0,0,"bytes",null,"",null,false],[133,588,0,null,null,null,[16366],false],[0,0,0,"bytes",null,"",null,false],[133,599,0,null,null,null,[16368],false],[0,0,0,"expanded_double",null,"",null,false],[133,604,0,null,null," Barrett reduction",[16370,16371],false],[0,0,0,"expanded",null,"",null,false],[0,0,0,"limbs_count",null,"",null,true],[133,574,0,null,null,null,null,false],[0,0,0,"limbs",null,null,null,false],[131,17,0,null,null," Decode a Curve25519 point from its compressed (X) coordinates.",[16375],false],[0,0,0,"s",null,"",null,false],[131,22,0,null,null," Encode a Curve25519 point.",[16377],false],[0,0,0,"p",null,"",null,false],[131,27,0,null,null," The Curve25519 base point.",null,false],[131,30,0,null,null," Check that the encoding of a Curve25519 point is canonical.",[16380],false],[0,0,0,"s",null,"",null,false],[131,35,0,null,null," Reject the neutral element.",[16382],false],[0,0,0,"p",null,"",null,false],[131,42,0,null,null," Multiply a point by the cofactor, returning WeakPublicKey if the element is in a small-order group.",[16384],false],[0,0,0,"p",null,"",null,false],[131,47,0,null,null,null,[16386,16387,16388],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"bits",null,"",null,true],[131,88,0,null,null," Multiply a Curve25519 point by a scalar after \"clamping\" it.\n Clamping forces the scalar to be a multiple of the cofactor in\n order to prevent small subgroups attacks. This is the standard\n way to use Curve25519 for a DH operation.\n Return error.IdentityElement if the resulting point is\n the identity element.",[16390,16391],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[131,98,0,null,null," Multiply a Curve25519 point by a scalar without clamping it.\n Return error.IdentityElement if the resulting point is\n the identity element or error.WeakPublicKey if the public\n key is a low-order point.",[16393,16394],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[131,104,0,null,null," Compute the Curve25519 equivalent to an Edwards25519 point.",[16396],false],[0,0,0,"p",null,"",null,false],[131,8,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[130,16,0,null,null," Length (in bytes) of a secret key.",null,false],[130,18,0,null,null," Length (in bytes) of a public key.",null,false],[130,20,0,null,null," Length (in bytes) of the output of the DH function.",null,false],[130,22,0,null,null," Seed (for key pair creation) length in bytes.",null,false],[130,25,0,null,null," An X25519 key pair.",[16409,16411],false],[130,32,0,null,null," Create a new key pair using an optional seed.",[16405],false],[0,0,0,"seed",null,"",null,false],[130,45,0,null,null," Create a key pair from an Ed25519 key pair",[16407],false],[0,0,0,"ed25519_key_pair",null,"",null,false],[130,25,0,null,null,null,null,false],[0,0,0,"public_key",null," Public part.",null,false],[130,25,0,null,null,null,null,false],[0,0,0,"secret_key",null," Secret part.",null,false],[130,60,0,null,null," Compute the public key for a given private key.",[16413],false],[0,0,0,"secret_key",null,"",null,false],[130,66,0,null,null," Compute the X25519 equivalent to an Ed25519 public eky.",[16415],false],[0,0,0,"ed25519_public_key",null,"",null,false],[130,75,0,null,null," Compute the scalar product of a public key and a secret scalar.\n Note that the output should not be used as a shared secret without\n hashing it first.",[16417,16418],false],[0,0,0,"secret_key",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[130,81,0,null,null,null,null,false],[115,71,0,null,null," Key Encapsulation Mechanisms.",[],false],[115,72,0,null,null,null,null,false],[0,0,0,"crypto/kyber_d00.zig",null," Implementation of the IND-CCA2 post-quantum secure key encapsulation\n mechanism (KEM) CRYSTALS-Kyber, as submitted to the third round of the NIST\n Post-Quantum Cryptography (v3.02/\"draft00\"), and selected for standardisation.\n\n Kyber will likely change before final standardisation.\n\n The namespace suffix (currently `_d00`) refers to the version currently\n implemented, in accordance with the draft. It may not be updated if new\n versions of the draft only include editorial changes.\n\n The suffix will eventually be removed once Kyber is finalized.\n\n Quoting from the CFRG I-D:\n\n Kyber is not a Diffie-Hellman (DH) style non-interactive key\n agreement, but instead, Kyber is a Key Encapsulation Method (KEM).\n In essence, a KEM is a Public-Key Encryption (PKE) scheme where the\n plaintext cannot be specified, but is generated as a random key as\n part of the encryption. A KEM can be transformed into an unrestricted\n PKE using HPKE (RFC9180). On its own, a KEM can be used as a key\n agreement method in TLS.\n\n Kyber is an IND-CCA2 secure KEM. It is constructed by applying a\n Fujisaki--Okamato style transformation on InnerPKE, which is the\n underlying IND-CPA secure Public Key Encryption scheme. We cannot\n use InnerPKE directly, as its ciphertexts are malleable.\n\n ```\n                     F.O. transform\n     InnerPKE   ---------------------->   Kyber\n     IND-CPA                              IND-CCA2\n ```\n\n Kyber is a lattice-based scheme.  More precisely, its security is\n based on the learning-with-errors-and-rounding problem in module\n lattices (MLWER).  The underlying polynomial ring R (defined in\n Section 5) is chosen such that multiplication is very fast using the\n number theoretic transform (NTT, see Section 5.1.3).\n\n An InnerPKE private key is a vector _s_ over R of length k which is\n _small_ in a particular way.  Here k is a security parameter akin to\n the size of a prime modulus.  For Kyber512, which targets AES-128's\n security level, the value of k is 2.\n\n The public key consists of two values:\n\n * _A_ a uniformly sampled k by k matrix over R _and_\n\n * _t = A s + e_, where e is a suitably small masking vector.\n\n Distinguishing between such A s + e and a uniformly sampled t is the\n module learning-with-errors (MLWE) problem.  If that is hard, then it\n is also hard to recover the private key from the public key as that\n would allow you to distinguish between those two.\n\n To save space in the public key, A is recomputed deterministically\n from a seed _rho_.\n\n A ciphertext for a message m under this public key is a pair (c_1,\n c_2) computed roughly as follows:\n\n c_1 = Compress(A^T r + e_1, d_u)\n c_2 = Compress(t^T r + e_2 + Decompress(m, 1), d_v)\n\n where\n\n * e_1, e_2 and r are small blinds;\n\n * Compress(-, d) removes some information, leaving d bits per\n   coefficient and Decompress is such that Compress after Decompress\n   does nothing and\n\n * d_u, d_v are scheme parameters.\n\n Distinguishing such a ciphertext and uniformly sampled (c_1, c_2) is\n an example of the full MLWER problem, see section 4.4 of [KyberV302].\n\n To decrypt the ciphertext, one computes\n\n m = Compress(Decompress(c_2, d_v) - s^T Decompress(c_1, d_u), 1).\n\n It it not straight-forward to see that this formula is correct.  In\n fact, there is negligible but non-zero probability that a ciphertext\n does not decrypt correctly given by the DFP column in Table 4.  This\n failure probability can be computed by a careful automated analysis\n of the probabilities involved, see kyber_failure.py of [SecEst].\n\n [KyberV302](https://pq-crystals.org/kyber/data/kyber-specification-round3-20210804.pdf)\n [I-D](https://github.com/bwesterb/draft-schwabe-cfrg-kyber)\n [SecEst](https://github.com/pq-crystals/security-estimates)\n",[],false],[134,104,0,null,null,null,null,false],[134,105,0,null,null,null,null,false],[134,107,0,null,null,null,null,false],[134,108,0,null,null,null,null,false],[134,109,0,null,null,null,null,false],[134,110,0,null,null,null,null,false],[134,111,0,null,null,null,null,false],[134,112,0,null,null,null,null,false],[134,113,0,null,null,null,null,false],[134,116,0,null,null,null,null,false],[134,119,0,null,null,null,null,false],[134,122,0,null,null,null,null,false],[134,125,0,null,null,null,null,false],[134,127,0,null,null,null,[16438,16439,16440,16441,16442],false],[134,127,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[0,0,0,"k",null,null,null,false],[0,0,0,"eta1",null,null,null,false],[0,0,0,"du",null,null,null,false],[0,0,0,"dv",null,null,null,false],[134,145,0,null,null,null,null,false],[134,153,0,null,null,null,null,false],[134,161,0,null,null,null,null,false],[134,169,0,null,null,null,null,false],[134,170,0,null,null,null,null,false],[134,171,0,null,null,null,null,false],[134,172,0,null,null,null,null,false],[134,173,0,null,null,null,null,false],[134,175,0,null,null,null,[16452],false],[0,0,0,"p",null,"",[],true],[134,178,0,null,null,null,null,false],[134,180,0,null,null,null,null,false],[134,181,0,null,null,null,null,false],[134,182,0,null,null,null,null,false],[134,185,0,null,null," Length (in bytes) of a shared secret.",null,false],[134,187,0,null,null," Length (in bytes) of a seed for deterministic encapsulation.",null,false],[134,189,0,null,null," Length (in bytes) of a seed for key generation.",null,false],[134,191,0,null,null," Algorithm name.",null,false],[134,194,0,null,null," A shared secret, and an encapsulated (encrypted) representation of it.",[16463,16465],false],[134,194,0,null,null,null,null,false],[0,0,0,"shared_secret",null,null,null,false],[134,194,0,null,null,null,null,false],[0,0,0,"ciphertext",null,null,null,false],[134,200,0,null,null," A Kyber public key.",[16476,16478],false],[134,207,0,null,null," Size of a serialized representation of the key, in bytes.",null,false],[134,212,0,null,null," Generates a shared secret, and encapsulates it for the public key.\n If `seed` is `null`, a random seed is used. This is recommended.\n If `seed` is set, encapsulation is deterministic.",[16469,16470],false],[0,0,0,"pk",null,"",null,false],[0,0,0,"seed_",null,"",null,false],[134,254,0,null,null," Serializes the key into a byte array.",[16472],false],[0,0,0,"pk",null,"",null,false],[134,259,0,null,null," Deserializes the key from a byte array.",[16474],false],[0,0,0,"buf",null,"",null,false],[134,200,0,null,null,null,null,false],[0,0,0,"pk",null,null,null,false],[134,200,0,null,null,null,null,false],[0,0,0,"hpk",null,null,null,false],[134,271,0,null,null," A Kyber secret key.",[16489,16491,16493,16495],false],[134,278,0,null,null," Size of a serialized representation of the key, in bytes.",null,false],[134,282,0,null,null," Decapsulates the shared secret within ct using the private key.",[16482,16483],false],[0,0,0,"sk",null,"",null,false],[0,0,0,"ct",null,"",null,false],[134,313,0,null,null," Serializes the key into a byte array.",[16485],false],[0,0,0,"sk",null,"",null,false],[134,318,0,null,null," Deserializes the key from a byte array.",[16487],false],[0,0,0,"buf",null,"",null,false],[134,271,0,null,null,null,null,false],[0,0,0,"sk",null,null,null,false],[134,271,0,null,null,null,null,false],[0,0,0,"pk",null,null,null,false],[134,271,0,null,null,null,null,false],[0,0,0,"hpk",null,null,null,false],[134,271,0,null,null,null,null,false],[0,0,0,"z",null,null,null,false],[134,333,0,null,null," A Kyber key pair.",[16500,16502],false],[134,340,0,null,null," Create a new key pair.\n If seed is null, a random seed will be generated.\n If a seed is provided, the key pair will be determinsitic.",[16498],false],[0,0,0,"seed_",null,"",null,false],[134,333,0,null,null,null,null,false],[0,0,0,"secret_key",null,null,null,false],[134,333,0,null,null,null,null,false],[0,0,0,"public_key",null,null,null,false],[134,371,0,null,null,null,null,false],[134,373,0,null,null,null,[16515,16517,16519],false],[134,380,0,null,null,null,null,false],[134,382,0,null,null,null,[16507,16508,16509],false],[0,0,0,"pk",null,"",null,false],[0,0,0,"pt",null,"",null,false],[0,0,0,"seed",null,"",null,false],[134,413,0,null,null,null,[16511],false],[0,0,0,"pk",null,"",null,false],[134,417,0,null,null,null,[16513],false],[0,0,0,"buf",null,"",null,false],[134,373,0,null,null,null,null,false],[0,0,0,"rho",null,null,null,false],[134,373,0,null,null,null,null,false],[0,0,0,"th",null,null,null,false],[134,373,0,null,null,null,null,false],[0,0,0,"aT",null,null,null,false],[134,427,0,null,null,null,[16530],false],[134,429,0,null,null,null,null,false],[134,431,0,null,null,null,[16523,16524],false],[0,0,0,"sk",null,"",null,false],[0,0,0,"ct",null,"",null,false],[134,443,0,null,null,null,[16526],false],[0,0,0,"sk",null,"",null,false],[134,447,0,null,null,null,[16528],false],[0,0,0,"buf",null,"",null,false],[134,427,0,null,null,null,null,false],[0,0,0,"sh",null,null,null,false],[134,455,0,null,null,null,[16532,16533,16534],false],[0,0,0,"seed",null,"",null,false],[0,0,0,"pk",null,"",null,false],[0,0,0,"sk",null,"",null,false],[134,490,0,null,null,null,null,false],[134,493,0,null,null,null,null,false],[134,496,0,null,null,null,null,false],[134,499,0,null,null,null,null,false],[134,507,0,null,null,null,null,false],[134,518,0,null,null,null,null,false],[134,590,0,null,null,null,[16542,16543],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,598,0,null,null,null,[16545],false],[0,0,0,"T",null,"",[16547,16549,16551],true],[134,599,0,null,null,null,null,false],[0,0,0,"gcd",null,null,null,false],[134,599,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[134,599,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[134,603,0,null,null,null,[16553,16554],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,609,0,null,null,null,[16556,16557],false],[0,0,0,"a",null,"",null,false],[0,0,0,"p",null,"",null,false],[134,616,0,null,null,null,[16559],false],[0,0,0,"x",null,"",null,false],[134,625,0,null,null,null,[16561],false],[0,0,0,"x",null,"",null,false],[134,669,0,null,null,null,[16563],false],[0,0,0,"x",null,"",null,false],[134,687,0,null,null,null,[16565],false],[0,0,0,"x",null,"",null,false],[134,721,0,null,null,null,[16567],false],[0,0,0,"x",null,"",null,false],[134,741,0,null,null,null,[16569,16570,16571],false],[0,0,0,"a",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"p",null,"",null,false],[134,760,0,null,null,null,[],false],[134,777,0,null,null,null,[16620],false],[134,780,0,null,null,null,null,false],[134,781,0,null,null,null,null,false],[134,783,0,null,null,null,[16577,16578],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,791,0,null,null,null,[16580,16581],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,801,0,null,null,null,[16583],false],[0,0,0,"rnd",null,"",null,false],[134,810,0,null,null,null,[16585],false],[0,0,0,"rnd",null,"",null,false],[134,824,0,null,null,null,[16587],false],[0,0,0,"a",null,"",null,false],[134,907,0,null,null,null,[16589],false],[0,0,0,"a",null,"",null,false],[134,964,0,null,null,null,[16591],false],[0,0,0,"a",null,"",null,false],[134,973,0,null,null,null,[16593],false],[0,0,0,"a",null,"",null,false],[134,984,0,null,null,null,[16595],false],[0,0,0,"a",null,"",null,false],[134,992,0,null,null,null,[16597],false],[0,0,0,"d",null,"",null,true],[134,999,0,null,null,null,[16599,16600],false],[0,0,0,"p",null,"",null,false],[0,0,0,"d",null,"",null,true],[134,1055,0,null,null,null,[16602,16603],false],[0,0,0,"d",null,"",null,true],[0,0,0,"in",null,"",null,false],[134,1112,0,null,null,null,[16605,16606],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,1155,0,null,null,null,[16608,16609,16610],false],[0,0,0,"eta",null,"",null,true],[0,0,0,"nonce",null,"",null,false],[0,0,0,"seed",null,"",null,false],[134,1221,0,null,null,null,[16612,16613,16614],false],[0,0,0,"seed",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[134,1265,0,null,null,null,[16616],false],[0,0,0,"p",null,"",null,false],[134,1280,0,null,null,null,[16618],false],[0,0,0,"buf",null,"",null,false],[134,777,0,null,null,null,null,false],[0,0,0,"cs",null,null,null,false],[134,1294,0,null,null,null,[16622],false],[0,0,0,"K",null,"",[16659],true],[134,1298,0,null,null,null,null,false],[134,1299,0,null,null,null,null,false],[134,1301,0,null,null,null,[16626],false],[0,0,0,"d",null,"",null,true],[134,1305,0,null,null,null,[16628],false],[0,0,0,"a",null,"",null,false],[134,1313,0,null,null,null,[16630],false],[0,0,0,"a",null,"",null,false],[134,1321,0,null,null,null,[16632],false],[0,0,0,"a",null,"",null,false],[134,1329,0,null,null,null,[16634],false],[0,0,0,"a",null,"",null,false],[134,1337,0,null,null,null,[16636,16637],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,1345,0,null,null,null,[16639,16640],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,1355,0,null,null,null,[16642,16643,16644],false],[0,0,0,"eta",null,"",null,true],[0,0,0,"nonce",null,"",null,false],[0,0,0,"seed",null,"",null,false],[134,1371,0,null,null,null,[16646,16647],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,1379,0,null,null,null,[16649,16650],false],[0,0,0,"v",null,"",null,false],[0,0,0,"d",null,"",null,true],[134,1388,0,null,null,null,[16652,16653],false],[0,0,0,"d",null,"",null,true],[0,0,0,"buf",null,"",null,false],[134,1398,0,null,null," Serializes the key into a byte array.",[16655],false],[0,0,0,"v",null,"",null,false],[134,1407,0,null,null," Deserializes the key from a byte array.",[16657],false],[0,0,0,"buf",null,"",null,false],[134,1295,0,null,null,null,null,false],[0,0,0,"ps",null,null,null,false],[134,1420,0,null,null,null,[16661],false],[0,0,0,"K",null,"",[16669],true],[134,1422,0,null,null,null,null,false],[134,1425,0,null,null,null,[16664,16665],false],[0,0,0,"seed",null,"",null,false],[0,0,0,"transposed",null,"",null,true],[134,1442,0,null,null,null,[16667],false],[0,0,0,"m",null,"",null,false],[134,1421,0,null,null,null,null,false],[0,0,0,"vs",null,null,null,false],[134,1455,0,null,null,null,[16671,16672,16673],false],[0,0,0,"len",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,1460,0,null,null,null,[16675,16676,16677,16678],false],[0,0,0,"len",null,"",null,true],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"b",null,"",null,false],[134,1666,0,null,null,null,null,false],[134,1715,0,null,null,null,[16692,16694],false],[134,1719,0,null,null,null,[16682],false],[0,0,0,"g",null,"",null,false],[134,1732,0,null,null,null,[16684,16685],false],[0,0,0,"g",null,"",null,false],[0,0,0,"pd",null,"",null,false],[134,1752,0,null,null,null,[16687,16688],false],[0,0,0,"g",null,"",null,false],[0,0,0,"out",null,"",null,false],[134,1770,0,null,null,null,[16690],false],[0,0,0,"seed",null,"",null,false],[134,1715,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[134,1715,0,null,null,null,null,false],[0,0,0,"v",null,null,null,false],[115,76,0,null,null," Elliptic-curve arithmetic.",[],false],[115,77,0,null,null,null,null,false],[115,78,0,null,null,null,null,false],[0,0,0,"crypto/25519/edwards25519.zig",null,"",[],false],[135,0,0,null,null,null,null,false],[135,1,0,null,null,null,null,false],[135,2,0,null,null,null,null,false],[135,3,0,null,null,null,null,false],[135,4,0,null,null,null,null,false],[135,6,0,null,null,null,null,false],[135,7,0,null,null,null,null,false],[135,8,0,null,null,null,null,false],[135,9,0,null,null,null,null,false],[135,10,0,null,null,null,null,false],[135,13,0,null,null," Group operations over Edwards25519.",[16802,16804,16806,16808,16809],false],[135,15,0,null,null," The underlying prime field.",null,false],[135,17,0,null,null," Field arithmetic mod the order of the main subgroup.",null,false],[135,19,0,null,null," Length in bytes of a compressed representation of a point.",null,false],[135,29,0,null,null," Decode an Edwards25519 point from its compressed (Y+sign) coordinates.",[16714],false],[0,0,0,"s",null,"",null,false],[135,50,0,null,null," Encode an Edwards25519 point.",[16716],false],[0,0,0,"p",null,"",null,false],[135,58,0,null,null," Check that the encoding of a point is canonical.",[16718],false],[0,0,0,"s",null,"",null,false],[135,63,0,null,null," The edwards25519 base point.",null,false],[135,71,0,null,null,null,null,false],[135,74,0,null,null," Reject the neutral element.",[16722],false],[0,0,0,"p",null,"",null,false],[135,81,0,null,null," Multiply a point by the cofactor",[16724],false],[0,0,0,"p",null,"",null,false],[135,87,0,null,null," Check that the point does not generate a low-order group.\n Return a `WeakPublicKey` error if it does.",[16726],false],[0,0,0,"p",null,"",null,false],[135,99,0,null,null," Flip the sign of the X coordinate.",[16728],false],[0,0,0,"p",null,"",null,false],[135,104,0,null,null," Double an Edwards25519 point.",[16730],false],[0,0,0,"p",null,"",null,false],[135,121,0,null,null," Add two Edwards25519 points.",[16732,16733],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[135,140,0,null,null," Subtract two Edwards25519 points.",[16735,16736],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[135,144,0,null,null,null,[16738,16739,16740],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[135,151,0,null,null,null,[16742,16743,16744],false],[0,0,0,"n",null,"",null,true],[0,0,0,"pc",null,"",null,false],[0,0,0,"b",null,"",null,false],[135,160,0,null,null,null,[16746],false],[0,0,0,"s",null,"",null,false],[135,184,0,null,null,null,[16748,16749,16750],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[135,204,0,null,null,null,[16752,16753,16754],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[135,223,0,null,null,null,[16756,16757],false],[0,0,0,"p",null,"",null,false],[0,0,0,"count",null,"",null,true],[135,234,0,null,null,null,null,false],[135,242,0,null,null," Multiply an Edwards25519 point by a scalar without clamping it.\n Return error.WeakPublicKey if the base generates a small-order group,\n and error.IdentityElement if the result is the identity element.",[16760,16761],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[135,253,0,null,null," Multiply an Edwards25519 point by a *PUBLIC* scalar *IN VARIABLE TIME*\n This can be used for signature verification.",[16763,16764],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[135,265,0,null,null," Double-base multiplication of public parameters - Compute (p1*s1)+(p2*s2) *IN VARIABLE TIME*\n This can be used for signature verification.",[16766,16767,16768,16769],false],[0,0,0,"p1",null,"",null,false],[0,0,0,"s1",null,"",null,false],[0,0,0,"p2",null,"",null,false],[0,0,0,"s2",null,"",null,false],[135,304,0,null,null," Multiscalar multiplication *IN VARIABLE TIME* for public data\n Computes ps0*ss0 + ps1*ss1 + ps2*ss2... faster than doing many of these operations individually",[16771,16772,16773],false],[0,0,0,"count",null,"",null,true],[0,0,0,"ps",null,"",null,false],[0,0,0,"ss",null,"",null,false],[135,346,0,null,null," Multiply an Edwards25519 point by a scalar after \"clamping\" it.\n Clamping forces the scalar to be a multiple of the cofactor in\n order to prevent small subgroups attacks.\n This is strongly recommended for DH operations.\n Return error.WeakPublicKey if the resulting point is\n the identity element.",[16775,16776],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[135,353,0,null,null,null,[16778],false],[0,0,0,"x",null,"",null,false],[135,361,0,null,null,null,[16780,16781],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[135,382,0,null,null," Elligator2 map - Returns Montgomery affine coordinates",[16783],false],[0,0,0,"r",null,"",[16785,16787,16788],false],[135,382,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[135,382,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[0,0,0,"not_square",null,null,null,false],[135,404,0,null,null," Map a 64-bit hash into an Edwards25519 point",[16790],false],[0,0,0,"h",null,"",null,false],[135,414,0,null,null,null,[16792,16793,16794],false],[0,0,0,"n",null,"",null,true],[0,0,0,"ctx",null,"",null,false],[0,0,0,"s",null,"",null,false],[135,471,0,null,null," Hash a context `ctx` and a string `s` into an Edwards25519 point\n\n This function implements the edwards25519_XMD:SHA-512_ELL2_RO_ and edwards25519_XMD:SHA-512_ELL2_NU_\n methods from the \"Hashing to Elliptic Curves\" standard document.\n\n Although not strictly required by the standard, it is recommended to avoid NUL characters in\n the context in order to be compatible with other implementations.",[16796,16797,16798],false],[0,0,0,"random_oracle",null,"",null,true],[0,0,0,"ctx",null,"",null,false],[0,0,0,"s",null,"",null,false],[135,481,0,null,null," Map a 32 bit uniform bit string into an edwards25519 point",[16800],false],[0,0,0,"r",null,"",null,false],[135,13,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[135,13,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[135,13,0,null,null,null,null,false],[0,0,0,"z",null,null,null,false],[135,13,0,null,null,null,null,false],[0,0,0,"t",null,null,null,false],[0,0,0,"is_base",null,null,null,false],[135,493,0,null,null,null,null,false],[115,79,0,null,null,null,null,false],[0,0,0,"crypto/pcurves/p256.zig",null,"",[],false],[136,0,0,null,null,null,null,false],[136,1,0,null,null,null,null,false],[136,2,0,null,null,null,null,false],[136,3,0,null,null,null,null,false],[136,5,0,null,null,null,null,false],[136,6,0,null,null,null,null,false],[136,7,0,null,null,null,null,false],[136,8,0,null,null,null,null,false],[136,11,0,null,null," Group operations over P256.",[17263,17265,17267,17268],false],[136,13,0,null,null," The underlying prime field.",null,false],[0,0,0,"p256/field.zig",null,"",[],false],[137,0,0,null,null,null,null,false],[137,1,0,null,null,null,null,false],[0,0,0,"../common.zig",null,"",[],false],[138,0,0,null,null,null,null,false],[138,1,0,null,null,null,null,false],[138,2,0,null,null,null,null,false],[138,3,0,null,null,null,null,false],[138,4,0,null,null,null,null,false],[138,6,0,null,null,null,null,false],[138,7,0,null,null,null,null,false],[138,10,0,null,null," Parameters to create a finite field type.",[16835,16836,16837,16838,16839],false],[0,0,0,"fiat",null,null,null,false],[0,0,0,"field_order",null,null,null,false],[0,0,0,"field_bits",null,null,null,false],[0,0,0,"saturated_bits",null,null,null,false],[0,0,0,"encoded_length",null,null,null,false],[138,19,0,null,null," A field element, internally stored in Montgomery domain.",[16841],false],[0,0,0,"params",null,"",[16907],true],[138,25,0,null,null,null,null,false],[138,30,0,null,null," Field size.",null,false],[138,33,0,null,null," Number of bits to represent the set of all elements.",null,false],[138,36,0,null,null," Number of bits that can be saturated without overflowing.",null,false],[138,39,0,null,null," Number of bytes required to encode an element.",null,false],[138,42,0,null,null," Zero.",null,false],[138,45,0,null,null," One.",null,false],[138,52,0,null,null," Reject non-canonical encodings of an element.",[16850,16851],false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[138,65,0,null,null," Swap the endianness of an encoded element.",[16853],false],[0,0,0,"s",null,"",null,false],[138,72,0,null,null," Unpack a field element.",[16855,16856],false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[138,83,0,null,null," Pack a field element.",[16858,16859],false],[0,0,0,"fe",null,"",null,false],[0,0,0,"endian",null,"",null,false],[138,92,0,null,null," Element as an integer.",null,false],[138,95,0,null,null," Create a field element from an integer.",[16862],false],[0,0,0,"x",null,"",null,true],[138,102,0,null,null," Return the field element as an integer.",[16864],false],[0,0,0,"fe",null,"",null,false],[138,108,0,null,null," Return true if the field element is zero.",[16866],false],[0,0,0,"fe",null,"",null,false],[138,115,0,null,null," Return true if both field elements are equivalent.",[16868,16869],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[138,120,0,null,null," Return true if the element is odd.",[16871],false],[0,0,0,"fe",null,"",null,false],[138,126,0,null,null," Conditonally replace a field element with `a` if `c` is positive.",[16873,16874,16875],false],[0,0,0,"fe",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[138,131,0,null,null," Add field elements.",[16877,16878],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[138,138,0,null,null," Subtract field elements.",[16880,16881],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[138,145,0,null,null," Double a field element.",[16883],false],[0,0,0,"a",null,"",null,false],[138,152,0,null,null," Multiply field elements.",[16885,16886],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[138,159,0,null,null," Square a field element.",[16888],false],[0,0,0,"a",null,"",null,false],[138,166,0,null,null," Square a field element n times.",[16890,16891],false],[0,0,0,"a",null,"",null,false],[0,0,0,"n",null,"",null,true],[138,176,0,null,null," Compute a^n.",[16893,16894,16895],false],[0,0,0,"a",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,true],[138,190,0,null,null," Negate a field element.",[16897],false],[0,0,0,"a",null,"",null,false],[138,198,0,null,null," Return the inverse of a field element, or 0 if a=0.",[16899],false],[0,0,0,"a",null,"",null,false],[138,248,0,null,null," Return true if the field element is a square.",[16901],false],[0,0,0,"x2",null,"",null,false],[138,278,0,null,null,null,[16903],false],[0,0,0,"x2",null,"",null,false],[138,314,0,null,null," Compute the square root of `x2`, returning `error.NotSquare` if `x2` was not a square.",[16905],false],[0,0,0,"x2",null,"",null,false],[138,24,0,null,null,null,null,false],[0,0,0,"limbs",null,null,null,false],[137,3,0,null,null,null,null,false],[137,5,0,null,null,null,null,false],[0,0,0,"p256_64.zig",null,"",[],false],[139,50,0,null,null,null,null,false],[139,51,0,null,null,null,null,false],[139,55,0,null,null,null,null,false],[139,59,0,null,null,null,null,false],[139,74,0,null,null," The function addcarryxU64 is an addition with carry.\n\n Postconditions:\n   out1 = (arg1 + arg2 + arg3) mod 2^64\n   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[16916,16917,16918,16919,16920],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[139,96,0,null,null," The function subborrowxU64 is a subtraction with borrow.\n\n Postconditions:\n   out1 = (-arg1 + arg2 + -arg3) mod 2^64\n   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[16922,16923,16924,16925,16926],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[139,117,0,null,null," The function mulxU64 is a multiplication, returning the full double-width result.\n\n Postconditions:\n   out1 = (arg1 * arg2) mod 2^64\n   out2 = ⌊arg1 * arg2 / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0xffffffffffffffff]",[16928,16929,16930,16931],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[139,136,0,null,null," The function cmovznzU64 is a single-word conditional move.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[16933,16934,16935,16936],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[139,152,0,null,null," The function mul multiplies two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[16938,16939,16940],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[139,444,0,null,null," The function square squares a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m\n   0 ≤ eval out1 < m\n",[16942,16943],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,737,0,null,null," The function add adds two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[16945,16946,16947],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[139,790,0,null,null," The function sub subtracts two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[16949,16950,16951],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[139,833,0,null,null," The function opp negates a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m\n   0 ≤ eval out1 < m\n",[16953,16954],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,876,0,null,null," The function fromMontgomery translates a field element out of the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^4) mod m\n   0 ≤ eval out1 < m\n",[16956,16957],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,1029,0,null,null," The function toMontgomery translates a field element into the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = eval arg1 mod m\n   0 ≤ eval out1 < m\n",[16959,16960],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,1304,0,null,null," The function nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[16962,16963],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,1322,0,null,null," The function selectznz is a multi-limb conditional select.\n\n Postconditions:\n   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[16965,16966,16967,16968],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[139,1350,0,null,null," The function toBytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]",[16970,16971],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,1459,0,null,null," The function fromBytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.\n\n Preconditions:\n   0 ≤ bytes_eval arg1 < m\n Postconditions:\n   eval out1 mod m = bytes_eval arg1 mod m\n   0 ≤ eval out1 < m\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[16973,16974],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[139,1534,0,null,null," The function setOne returns the field element one in the Montgomery domain.\n\n Postconditions:\n   eval (from_montgomery out1) mod m = 1 mod m\n   0 ≤ eval out1 < m\n",[16976],false],[0,0,0,"out1",null,"",null,false],[139,1551,0,null,null," The function msat returns the saturated representation of the prime modulus.\n\n Postconditions:\n   twos_complement_eval out1 = m\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[16978],false],[0,0,0,"out1",null,"",null,false],[139,1589,0,null,null," The function divstep computes a divstep.\n\n Preconditions:\n   0 ≤ eval arg4 < m\n   0 ≤ eval arg5 < m\n Postconditions:\n   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)\n   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)\n   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)\n   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)\n   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)\n   0 ≤ eval out5 < m\n   0 ≤ eval out5 < m\n   0 ≤ eval out2 < m\n   0 ≤ eval out3 < m\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[16980,16981,16982,16983,16984,16985,16986,16987,16988,16989],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"out3",null,"",null,false],[0,0,0,"out4",null,"",null,false],[0,0,0,"out5",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[139,1823,0,null,null," The function divstepPrecomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).\n\n Postconditions:\n   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[16991],false],[0,0,0,"out1",null,"",null,false],[136,15,0,null,null," Field arithmetic mod the order of the main subgroup.",null,false],[0,0,0,"p256/scalar.zig",null,"",[],false],[140,0,0,null,null,null,null,false],[140,1,0,null,null,null,null,false],[140,2,0,null,null,null,null,false],[140,3,0,null,null,null,null,false],[140,4,0,null,null,null,null,false],[140,5,0,null,null,null,null,false],[140,7,0,null,null,null,null,false],[140,9,0,null,null,null,null,false],[140,10,0,null,null,null,null,false],[140,13,0,null,null," Number of bytes required to encode a scalar.",null,false],[140,16,0,null,null," A compressed scalar, in canonical form.",null,false],[140,18,0,null,null,null,null,false],[0,0,0,"p256_scalar_64.zig",null,"",[],false],[141,50,0,null,null,null,null,false],[141,51,0,null,null,null,null,false],[141,55,0,null,null,null,null,false],[141,59,0,null,null,null,null,false],[141,74,0,null,null," The function addcarryxU64 is an addition with carry.\n\n Postconditions:\n   out1 = (arg1 + arg2 + arg3) mod 2^64\n   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17012,17013,17014,17015,17016],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[141,96,0,null,null," The function subborrowxU64 is a subtraction with borrow.\n\n Postconditions:\n   out1 = (-arg1 + arg2 + -arg3) mod 2^64\n   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17018,17019,17020,17021,17022],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[141,117,0,null,null," The function mulxU64 is a multiplication, returning the full double-width result.\n\n Postconditions:\n   out1 = (arg1 * arg2) mod 2^64\n   out2 = ⌊arg1 * arg2 / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0xffffffffffffffff]",[17024,17025,17026,17027],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[141,136,0,null,null," The function cmovznzU64 is a single-word conditional move.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17029,17030,17031,17032],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[141,152,0,null,null," The function mul multiplies two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17034,17035,17036],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[141,492,0,null,null," The function square squares a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m\n   0 ≤ eval out1 < m\n",[17038,17039],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,833,0,null,null," The function add adds two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17041,17042,17043],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[141,886,0,null,null," The function sub subtracts two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17045,17046,17047],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[141,929,0,null,null," The function opp negates a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m\n   0 ≤ eval out1 < m\n",[17049,17050],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,972,0,null,null," The function fromMontgomery translates a field element out of the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^4) mod m\n   0 ≤ eval out1 < m\n",[17052,17053],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,1185,0,null,null," The function toMontgomery translates a field element into the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = eval arg1 mod m\n   0 ≤ eval out1 < m\n",[17055,17056],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,1508,0,null,null," The function nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17058,17059],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,1526,0,null,null," The function selectznz is a multi-limb conditional select.\n\n Postconditions:\n   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17061,17062,17063,17064],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[141,1554,0,null,null," The function toBytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]",[17066,17067],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,1663,0,null,null," The function fromBytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.\n\n Preconditions:\n   0 ≤ bytes_eval arg1 < m\n Postconditions:\n   eval out1 mod m = bytes_eval arg1 mod m\n   0 ≤ eval out1 < m\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17069,17070],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[141,1738,0,null,null," The function setOne returns the field element one in the Montgomery domain.\n\n Postconditions:\n   eval (from_montgomery out1) mod m = 1 mod m\n   0 ≤ eval out1 < m\n",[17072],false],[0,0,0,"out1",null,"",null,false],[141,1755,0,null,null," The function msat returns the saturated representation of the prime modulus.\n\n Postconditions:\n   twos_complement_eval out1 = m\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17074],false],[0,0,0,"out1",null,"",null,false],[141,1793,0,null,null," The function divstep computes a divstep.\n\n Preconditions:\n   0 ≤ eval arg4 < m\n   0 ≤ eval arg5 < m\n Postconditions:\n   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)\n   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)\n   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)\n   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)\n   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)\n   0 ≤ eval out5 < m\n   0 ≤ eval out5 < m\n   0 ≤ eval out2 < m\n   0 ≤ eval out3 < m\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17076,17077,17078,17079,17080,17081,17082,17083,17084,17085],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"out3",null,"",null,false],[0,0,0,"out4",null,"",null,false],[0,0,0,"out5",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[141,2027,0,null,null," The function divstepPrecomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).\n\n Postconditions:\n   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17087],false],[0,0,0,"out1",null,"",null,false],[140,27,0,null,null," The scalar field order.",null,false],[140,30,0,null,null," Reject a scalar whose encoding is not canonical.",[17090,17091],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,35,0,null,null," Reduce a 48-bytes scalar to the field size.",[17093,17094],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,40,0,null,null," Reduce a 64-bytes scalar to the field size.",[17096,17097],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,45,0,null,null," Return a*b (mod L)",[17099,17100,17101],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,50,0,null,null," Return a*b+c (mod L)",[17103,17104,17105,17106],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,55,0,null,null," Return a+b (mod L)",[17108,17109,17110],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,60,0,null,null," Return -s (mod L)",[17112,17113],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,65,0,null,null," Return (a-b) (mod L)",[17115,17116,17117],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,70,0,null,null," Return a random scalar",[17119],false],[0,0,0,"endian",null,"",null,false],[140,75,0,null,null," A scalar in unpacked representation.",[17169],false],[140,79,0,null,null," Zero.",null,false],[140,82,0,null,null," One.",null,false],[140,85,0,null,null," Unpack a serialized representation of a scalar.",[17124,17125],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,90,0,null,null," Reduce a 384 bit input to the field size.",[17127,17128],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,96,0,null,null," Reduce a 512 bit input to the field size.",[17130,17131],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,102,0,null,null," Pack a scalar into bytes.",[17133,17134],false],[0,0,0,"n",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,107,0,null,null," Return true if the scalar is zero..",[17136],false],[0,0,0,"n",null,"",null,false],[140,112,0,null,null," Return true if the scalar is odd.",[17138],false],[0,0,0,"n",null,"",null,false],[140,117,0,null,null," Return true if a and b are equivalent.",[17140,17141],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[140,122,0,null,null," Compute x+y (mod L)",[17143,17144],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[140,127,0,null,null," Compute x-y (mod L)",[17146,17147],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[140,132,0,null,null," Compute 2n (mod L)",[17149],false],[0,0,0,"n",null,"",null,false],[140,137,0,null,null," Compute x*y (mod L)",[17151,17152],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[140,142,0,null,null," Compute x^2 (mod L)",[17154],false],[0,0,0,"n",null,"",null,false],[140,147,0,null,null," Compute x^n (mod L)",[17156,17157,17158],false],[0,0,0,"a",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,true],[140,152,0,null,null," Compute -x (mod L)",[17160],false],[0,0,0,"n",null,"",null,false],[140,157,0,null,null," Compute x^-1 (mod L)",[17162],false],[0,0,0,"n",null,"",null,false],[140,162,0,null,null," Return true if n is a quadratic residue mod L.",[17164],false],[0,0,0,"n",null,"",null,false],[140,167,0,null,null," Return the square root of L, or NotSquare if there isn't any solutions.",[17166],false],[0,0,0,"n",null,"",null,false],[140,172,0,null,null," Return a random scalar < L.",[],false],[140,75,0,null,null,null,null,false],[0,0,0,"fe",null,null,null,false],[140,184,0,null,null,null,[17179,17181,17183],false],[140,189,0,null,null,null,[17172,17173,17174],false],[0,0,0,"bits",null,"",null,true],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[140,218,0,null,null,null,[17176,17177],false],[0,0,0,"expanded",null,"",null,false],[0,0,0,"bits",null,"",null,true],[140,184,0,null,null,null,null,false],[0,0,0,"x1",null,null,null,false],[140,184,0,null,null,null,null,false],[0,0,0,"x2",null,null,null,false],[140,184,0,null,null,null,null,false],[0,0,0,"x3",null,null,null,false],[136,24,0,null,null," The P256 base point.",null,false],[136,32,0,null,null," The P256 neutral element.",null,false],[136,34,0,null,null,null,null,false],[136,37,0,null,null," Reject the neutral element.",[17188],false],[0,0,0,"p",null,"",null,false],[136,46,0,null,null," Create a point from affine coordinates after checking that they match the curve equation.",[17190],false],[0,0,0,"p",null,"",null,false],[136,62,0,null,null," Create a point from serialized affine coordinates.",[17192,17193,17194],false],[0,0,0,"xs",null,"",null,false],[0,0,0,"ys",null,"",null,false],[0,0,0,"endian",null,"",null,false],[136,69,0,null,null," Recover the Y coordinate from the X coordinate.",[17196,17197],false],[0,0,0,"x",null,"",null,false],[0,0,0,"is_odd",null,"",null,false],[136,78,0,null,null," Deserialize a SEC1-encoded point.",[17199],false],[0,0,0,"s",null,"",null,false],[136,105,0,null,null," Serialize a point using the compressed SEC-1 format.",[17201],false],[0,0,0,"p",null,"",null,false],[136,114,0,null,null," Serialize a point using the uncompressed SEC-1 format.",[17203],false],[0,0,0,"p",null,"",null,false],[136,124,0,null,null," Return a random point.",[],false],[136,130,0,null,null," Flip the sign of the X coordinate.",[17206],false],[0,0,0,"p",null,"",null,false],[136,136,0,null,null," Double a P256 point.",[17208],false],[0,0,0,"p",null,"",null,false],[136,179,0,null,null," Add P256 points, the second being specified using affine coordinates.",[17210,17211],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[136,227,0,null,null," Add P256 points.",[17213,17214],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[136,279,0,null,null," Subtract P256 points.",[17216,17217],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[136,284,0,null,null," Subtract P256 points, the second being specified using affine coordinates.",[17219,17220],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[136,289,0,null,null," Return affine coordinates.",[17222],false],[0,0,0,"p",null,"",null,false],[136,302,0,null,null," Return true if both coordinate sets represent the same point.",[17224,17225],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[136,310,0,null,null,null,[17227,17228,17229],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[136,316,0,null,null,null,[17231,17232,17233],false],[0,0,0,"n",null,"",null,true],[0,0,0,"pc",null,"",null,false],[0,0,0,"b",null,"",null,false],[136,325,0,null,null,null,[17235],false],[0,0,0,"s",null,"",null,false],[136,345,0,null,null,null,[17237,17238,17239],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[136,364,0,null,null,null,[17241,17242,17243],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[136,383,0,null,null,null,[17245,17246],false],[0,0,0,"p",null,"",null,false],[0,0,0,"count",null,"",null,true],[136,394,0,null,null,null,null,false],[136,401,0,null,null," Multiply an elliptic curve point by a scalar.\n Return error.IdentityElement if the result is the identity element.",[17249,17250,17251],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[136,413,0,null,null," Multiply an elliptic curve point by a *PUBLIC* scalar *IN VARIABLE TIME*\n This can be used for signature verification.",[17253,17254,17255],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[136,425,0,null,null," Double-base multiplication of public parameters - Compute (p1*s1)+(p2*s2) *IN VARIABLE TIME*\n This can be used for signature verification.",[17257,17258,17259,17260,17261],false],[0,0,0,"p1",null,"",null,false],[0,0,0,"s1_",null,"",null,false],[0,0,0,"p2",null,"",null,false],[0,0,0,"s2_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[136,11,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[136,11,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[136,11,0,null,null,null,null,false],[0,0,0,"z",null,null,null,false],[0,0,0,"is_base",null,null,null,false],[136,466,0,null,null," A point in affine coordinates.",[17276,17278],false],[136,471,0,null,null," Identity element in affine coordinates.",null,false],[136,473,0,null,null,null,[17272,17273,17274],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[136,466,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[136,466,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[115,80,0,null,null,null,null,false],[0,0,0,"crypto/pcurves/p384.zig",null,"",[],false],[142,0,0,null,null,null,null,false],[142,1,0,null,null,null,null,false],[142,2,0,null,null,null,null,false],[142,3,0,null,null,null,null,false],[142,5,0,null,null,null,null,false],[142,6,0,null,null,null,null,false],[142,7,0,null,null,null,null,false],[142,8,0,null,null,null,null,false],[142,11,0,null,null," Group operations over P384.",[17641,17643,17645,17646],false],[142,13,0,null,null," The underlying prime field.",null,false],[0,0,0,"p384/field.zig",null,"",[],false],[143,0,0,null,null,null,null,false],[143,1,0,null,null,null,null,false],[143,3,0,null,null,null,null,false],[143,5,0,null,null,null,null,false],[0,0,0,"p384_64.zig",null,"",[],false],[144,19,0,null,null,null,null,false],[144,20,0,null,null,null,null,false],[144,24,0,null,null,null,null,false],[144,28,0,null,null,null,null,false],[144,43,0,null,null," The function addcarryxU64 is an addition with carry.\n\n Postconditions:\n   out1 = (arg1 + arg2 + arg3) mod 2^64\n   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17302,17303,17304,17305,17306],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[144,65,0,null,null," The function subborrowxU64 is a subtraction with borrow.\n\n Postconditions:\n   out1 = (-arg1 + arg2 + -arg3) mod 2^64\n   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17308,17309,17310,17311,17312],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[144,86,0,null,null," The function mulxU64 is a multiplication, returning the full double-width result.\n\n Postconditions:\n   out1 = (arg1 * arg2) mod 2^64\n   out2 = ⌊arg1 * arg2 / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0xffffffffffffffff]",[17314,17315,17316,17317],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[144,105,0,null,null," The function cmovznzU64 is a single-word conditional move.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17319,17320,17321,17322],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[144,121,0,null,null," The function mul multiplies two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17324,17325,17326],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[144,841,0,null,null," The function square squares a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m\n   0 ≤ eval out1 < m\n",[17328,17329],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,1562,0,null,null," The function add adds two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17331,17332,17333],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[144,1633,0,null,null," The function sub subtracts two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17335,17336,17337],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[144,1690,0,null,null," The function opp negates a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m\n   0 ≤ eval out1 < m\n",[17339,17340],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,1747,0,null,null," The function fromMontgomery translates a field element out of the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^6) mod m\n   0 ≤ eval out1 < m\n",[17342,17343],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,2232,0,null,null," The function toMontgomery translates a field element into the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = eval arg1 mod m\n   0 ≤ eval out1 < m\n",[17345,17346],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,2869,0,null,null," The function nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17348,17349],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,2887,0,null,null," The function selectznz is a multi-limb conditional select.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17351,17352,17353,17354],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[144,2921,0,null,null," The function toBytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..47]\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]",[17356,17357],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,3076,0,null,null," The function fromBytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.\n\n Preconditions:\n   0 ≤ bytes_eval arg1 < m\n Postconditions:\n   eval out1 mod m = bytes_eval arg1 mod m\n   0 ≤ eval out1 < m\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17359,17360],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[144,3183,0,null,null," The function setOne returns the field element one in the Montgomery domain.\n\n Postconditions:\n   eval (from_montgomery out1) mod m = 1 mod m\n   0 ≤ eval out1 < m\n",[17362],false],[0,0,0,"out1",null,"",null,false],[144,3202,0,null,null," The function msat returns the saturated representation of the prime modulus.\n\n Postconditions:\n   twos_complement_eval out1 = m\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17364],false],[0,0,0,"out1",null,"",null,false],[144,3242,0,null,null," The function divstep computes a divstep.\n\n Preconditions:\n   0 ≤ eval arg4 < m\n   0 ≤ eval arg5 < m\n Postconditions:\n   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)\n   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)\n   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)\n   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)\n   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)\n   0 ≤ eval out5 < m\n   0 ≤ eval out5 < m\n   0 ≤ eval out2 < m\n   0 ≤ eval out3 < m\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17366,17367,17368,17369,17370,17371,17372,17373,17374,17375],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"out3",null,"",null,false],[0,0,0,"out4",null,"",null,false],[0,0,0,"out5",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[144,3568,0,null,null," The function divstepPrecomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).\n\n Postconditions:\n   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17377],false],[0,0,0,"out1",null,"",null,false],[142,15,0,null,null," Field arithmetic mod the order of the main subgroup.",null,false],[0,0,0,"p384/scalar.zig",null,"",[],false],[145,0,0,null,null,null,null,false],[145,1,0,null,null,null,null,false],[145,2,0,null,null,null,null,false],[145,3,0,null,null,null,null,false],[145,4,0,null,null,null,null,false],[145,5,0,null,null,null,null,false],[145,7,0,null,null,null,null,false],[145,9,0,null,null,null,null,false],[145,10,0,null,null,null,null,false],[145,13,0,null,null," Number of bytes required to encode a scalar.",null,false],[145,16,0,null,null," A compressed scalar, in canonical form.",null,false],[145,18,0,null,null,null,null,false],[0,0,0,"p384_scalar_64.zig",null,"",[],false],[146,19,0,null,null,null,null,false],[146,20,0,null,null,null,null,false],[146,24,0,null,null,null,null,false],[146,28,0,null,null,null,null,false],[146,43,0,null,null," The function addcarryxU64 is an addition with carry.\n\n Postconditions:\n   out1 = (arg1 + arg2 + arg3) mod 2^64\n   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17398,17399,17400,17401,17402],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[146,65,0,null,null," The function subborrowxU64 is a subtraction with borrow.\n\n Postconditions:\n   out1 = (-arg1 + arg2 + -arg3) mod 2^64\n   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17404,17405,17406,17407,17408],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[146,86,0,null,null," The function mulxU64 is a multiplication, returning the full double-width result.\n\n Postconditions:\n   out1 = (arg1 * arg2) mod 2^64\n   out2 = ⌊arg1 * arg2 / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0xffffffffffffffff]",[17410,17411,17412,17413],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[146,105,0,null,null," The function cmovznzU64 is a single-word conditional move.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17415,17416,17417,17418],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[146,121,0,null,null," The function mul multiplies two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17420,17421,17422],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[146,841,0,null,null," The function square squares a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m\n   0 ≤ eval out1 < m\n",[17424,17425],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,1562,0,null,null," The function add adds two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17427,17428,17429],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[146,1633,0,null,null," The function sub subtracts two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17431,17432,17433],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[146,1690,0,null,null," The function opp negates a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m\n   0 ≤ eval out1 < m\n",[17435,17436],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,1747,0,null,null," The function fromMontgomery translates a field element out of the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^6) mod m\n   0 ≤ eval out1 < m\n",[17438,17439],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,2232,0,null,null," The function toMontgomery translates a field element into the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = eval arg1 mod m\n   0 ≤ eval out1 < m\n",[17441,17442],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,2923,0,null,null," The function nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17444,17445],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,2941,0,null,null," The function selectznz is a multi-limb conditional select.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17447,17448,17449,17450],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[146,2975,0,null,null," The function toBytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..47]\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]",[17452,17453],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,3130,0,null,null," The function fromBytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.\n\n Preconditions:\n   0 ≤ bytes_eval arg1 < m\n Postconditions:\n   eval out1 mod m = bytes_eval arg1 mod m\n   0 ≤ eval out1 < m\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17455,17456],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[146,3237,0,null,null," The function setOne returns the field element one in the Montgomery domain.\n\n Postconditions:\n   eval (from_montgomery out1) mod m = 1 mod m\n   0 ≤ eval out1 < m\n",[17458],false],[0,0,0,"out1",null,"",null,false],[146,3256,0,null,null," The function msat returns the saturated representation of the prime modulus.\n\n Postconditions:\n   twos_complement_eval out1 = m\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17460],false],[0,0,0,"out1",null,"",null,false],[146,3296,0,null,null," The function divstep computes a divstep.\n\n Preconditions:\n   0 ≤ eval arg4 < m\n   0 ≤ eval arg5 < m\n Postconditions:\n   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)\n   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)\n   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)\n   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)\n   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)\n   0 ≤ eval out5 < m\n   0 ≤ eval out5 < m\n   0 ≤ eval out2 < m\n   0 ≤ eval out3 < m\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17462,17463,17464,17465,17466,17467,17468,17469,17470,17471],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"out3",null,"",null,false],[0,0,0,"out4",null,"",null,false],[0,0,0,"out5",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[146,3622,0,null,null," The function divstepPrecomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).\n\n Postconditions:\n   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17473],false],[0,0,0,"out1",null,"",null,false],[145,27,0,null,null," The scalar field order.",null,false],[145,30,0,null,null," Reject a scalar whose encoding is not canonical.",[17476,17477],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,35,0,null,null," Reduce a 64-bytes scalar to the field size.",[17479,17480],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,40,0,null,null," Return a*b (mod L)",[17482,17483,17484],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,45,0,null,null," Return a*b+c (mod L)",[17486,17487,17488,17489],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,50,0,null,null," Return a+b (mod L)",[17491,17492,17493],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,55,0,null,null," Return -s (mod L)",[17495,17496],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,60,0,null,null," Return (a-b) (mod L)",[17498,17499,17500],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,65,0,null,null," Return a random scalar",[17502],false],[0,0,0,"endian",null,"",null,false],[145,70,0,null,null," A scalar in unpacked representation.",[17549],false],[145,74,0,null,null," Zero.",null,false],[145,77,0,null,null," One.",null,false],[145,80,0,null,null," Unpack a serialized representation of a scalar.",[17507,17508],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,85,0,null,null," Reduce a 512 bit input to the field size.",[17510,17511],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,91,0,null,null," Pack a scalar into bytes.",[17513,17514],false],[0,0,0,"n",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,96,0,null,null," Return true if the scalar is zero..",[17516],false],[0,0,0,"n",null,"",null,false],[145,101,0,null,null," Return true if the scalar is odd.",[17518],false],[0,0,0,"n",null,"",null,false],[145,106,0,null,null," Return true if a and b are equivalent.",[17520,17521],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[145,111,0,null,null," Compute x+y (mod L)",[17523,17524],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[145,116,0,null,null," Compute x-y (mod L)",[17526,17527],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[145,121,0,null,null," Compute 2n (mod L)",[17529],false],[0,0,0,"n",null,"",null,false],[145,126,0,null,null," Compute x*y (mod L)",[17531,17532],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[145,131,0,null,null," Compute x^2 (mod L)",[17534],false],[0,0,0,"n",null,"",null,false],[145,136,0,null,null," Compute x^n (mod L)",[17536,17537,17538],false],[0,0,0,"a",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,true],[145,141,0,null,null," Compute -x (mod L)",[17540],false],[0,0,0,"n",null,"",null,false],[145,146,0,null,null," Compute x^-1 (mod L)",[17542],false],[0,0,0,"n",null,"",null,false],[145,151,0,null,null," Return true if n is a quadratic residue mod L.",[17544],false],[0,0,0,"n",null,"",null,false],[145,156,0,null,null," Return the square root of L, or NotSquare if there isn't any solutions.",[17546],false],[0,0,0,"n",null,"",null,false],[145,161,0,null,null," Return a random scalar < L.",[],false],[145,70,0,null,null,null,null,false],[0,0,0,"fe",null,null,null,false],[145,173,0,null,null,null,[17559,17561],false],[145,177,0,null,null,null,[17552,17553,17554],false],[0,0,0,"bits",null,"",null,true],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[145,200,0,null,null,null,[17556,17557],false],[0,0,0,"expanded",null,"",null,false],[0,0,0,"bits",null,"",null,true],[145,173,0,null,null,null,null,false],[0,0,0,"x1",null,null,null,false],[145,173,0,null,null,null,null,false],[0,0,0,"x2",null,null,null,false],[142,24,0,null,null," The P384 base point.",null,false],[142,32,0,null,null," The P384 neutral element.",null,false],[142,34,0,null,null,null,null,false],[142,37,0,null,null," Reject the neutral element.",[17566],false],[0,0,0,"p",null,"",null,false],[142,46,0,null,null," Create a point from affine coordinates after checking that they match the curve equation.",[17568],false],[0,0,0,"p",null,"",null,false],[142,62,0,null,null," Create a point from serialized affine coordinates.",[17570,17571,17572],false],[0,0,0,"xs",null,"",null,false],[0,0,0,"ys",null,"",null,false],[0,0,0,"endian",null,"",null,false],[142,69,0,null,null," Recover the Y coordinate from the X coordinate.",[17574,17575],false],[0,0,0,"x",null,"",null,false],[0,0,0,"is_odd",null,"",null,false],[142,78,0,null,null," Deserialize a SEC1-encoded point.",[17577],false],[0,0,0,"s",null,"",null,false],[142,105,0,null,null," Serialize a point using the compressed SEC-1 format.",[17579],false],[0,0,0,"p",null,"",null,false],[142,114,0,null,null," Serialize a point using the uncompressed SEC-1 format.",[17581],false],[0,0,0,"p",null,"",null,false],[142,124,0,null,null," Return a random point.",[],false],[142,130,0,null,null," Flip the sign of the X coordinate.",[17584],false],[0,0,0,"p",null,"",null,false],[142,136,0,null,null," Double a P384 point.",[17586],false],[0,0,0,"p",null,"",null,false],[142,179,0,null,null," Add P384 points, the second being specified using affine coordinates.",[17588,17589],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[142,227,0,null,null," Add P384 points.",[17591,17592],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[142,279,0,null,null," Subtract P384 points.",[17594,17595],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[142,284,0,null,null," Subtract P384 points, the second being specified using affine coordinates.",[17597,17598],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[142,289,0,null,null," Return affine coordinates.",[17600],false],[0,0,0,"p",null,"",null,false],[142,302,0,null,null," Return true if both coordinate sets represent the same point.",[17602,17603],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[142,310,0,null,null,null,[17605,17606,17607],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[142,316,0,null,null,null,[17609,17610,17611],false],[0,0,0,"n",null,"",null,true],[0,0,0,"pc",null,"",null,false],[0,0,0,"b",null,"",null,false],[142,325,0,null,null,null,[17613],false],[0,0,0,"s",null,"",null,false],[142,345,0,null,null,null,[17615,17616,17617],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[142,364,0,null,null,null,[17619,17620,17621],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[142,383,0,null,null,null,[17623,17624],false],[0,0,0,"p",null,"",null,false],[0,0,0,"count",null,"",null,true],[142,394,0,null,null,null,null,false],[142,401,0,null,null," Multiply an elliptic curve point by a scalar.\n Return error.IdentityElement if the result is the identity element.",[17627,17628,17629],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[142,413,0,null,null," Multiply an elliptic curve point by a *PUBLIC* scalar *IN VARIABLE TIME*\n This can be used for signature verification.",[17631,17632,17633],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[142,425,0,null,null," Double-base multiplication of public parameters - Compute (p1*s1)+(p2*s2) *IN VARIABLE TIME*\n This can be used for signature verification.",[17635,17636,17637,17638,17639],false],[0,0,0,"p1",null,"",null,false],[0,0,0,"s1_",null,"",null,false],[0,0,0,"p2",null,"",null,false],[0,0,0,"s2_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[142,11,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[142,11,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[142,11,0,null,null,null,null,false],[0,0,0,"z",null,null,null,false],[0,0,0,"is_base",null,null,null,false],[142,466,0,null,null," A point in affine coordinates.",[17654,17656],false],[142,471,0,null,null," Identity element in affine coordinates.",null,false],[142,473,0,null,null,null,[17650,17651,17652],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[142,466,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[142,466,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[115,81,0,null,null,null,null,false],[0,0,0,"crypto/25519/ristretto255.zig",null,"",[],false],[147,0,0,null,null,null,null,false],[147,1,0,null,null,null,null,false],[147,3,0,null,null,null,null,false],[147,4,0,null,null,null,null,false],[147,5,0,null,null,null,null,false],[147,6,0,null,null,null,null,false],[147,9,0,null,null," Group operations over Edwards25519.",[17701],false],[147,11,0,null,null," The underlying elliptic curve.",null,false],[147,13,0,null,null," The underlying prime field.",null,false],[147,15,0,null,null," Field arithmetic mod the order of the main subgroup.",null,false],[147,17,0,null,null," Length in byte of an encoded element.",null,false],[147,21,0,null,null,null,[17671,17672],false],[0,0,0,"u",null,"",null,false],[0,0,0,"v",null,"",[17673,17675],false],[0,0,0,"ratio_is_square",null,null,null,false],[147,21,0,null,null,null,null,false],[0,0,0,"root",null,null,null,false],[147,36,0,null,null,null,[17677],false],[0,0,0,"s",null,"",null,false],[147,44,0,null,null," Reject the neutral element.",[17679],false],[0,0,0,"p",null,"",null,false],[147,49,0,null,null," The base point (Ristretto is a curve in desguise).",null,false],[147,52,0,null,null," Decode a Ristretto255 representative.",[17682],false],[0,0,0,"s",null,"",null,false],[147,82,0,null,null," Encode to a Ristretto255 representative.",[17684],false],[0,0,0,"e",null,"",null,false],[147,113,0,null,null,null,[17686],false],[0,0,0,"t",null,"",null,false],[147,136,0,null,null," Map a 64-bit string into a Ristretto255 group element",[17688],false],[0,0,0,"h",null,"",null,false],[147,143,0,null,null," Double a Ristretto255 element.",[17690],false],[0,0,0,"p",null,"",null,false],[147,148,0,null,null," Add two Ristretto255 elements.",[17692,17693],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[147,155,0,null,null," Multiply a Ristretto255 element with a scalar.\n Return error.WeakPublicKey if the resulting element is\n the identity element.",[17695,17696],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[147,160,0,null,null," Return true if two Ristretto255 elements are equivalent",[17698,17699],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[147,9,0,null,null,null,null,false],[0,0,0,"p",null,null,null,false],[115,82,0,null,null,null,null,false],[0,0,0,"crypto/pcurves/secp256k1.zig",null,"",[],false],[148,0,0,null,null,null,null,false],[148,1,0,null,null,null,null,false],[148,2,0,null,null,null,null,false],[148,3,0,null,null,null,null,false],[148,4,0,null,null,null,null,false],[148,6,0,null,null,null,null,false],[148,7,0,null,null,null,null,false],[148,8,0,null,null,null,null,false],[148,9,0,null,null,null,null,false],[148,12,0,null,null," Group operations over secp256k1.",[18090,18092,18094,18095],false],[148,14,0,null,null," The underlying prime field.",null,false],[0,0,0,"secp256k1/field.zig",null,"",[],false],[149,0,0,null,null,null,null,false],[149,1,0,null,null,null,null,false],[149,3,0,null,null,null,null,false],[149,5,0,null,null,null,null,false],[0,0,0,"secp256k1_64.zig",null,"",[],false],[150,19,0,null,null,null,null,false],[150,20,0,null,null,null,null,false],[150,24,0,null,null,null,null,false],[150,28,0,null,null,null,null,false],[150,43,0,null,null," The function addcarryxU64 is an addition with carry.\n\n Postconditions:\n   out1 = (arg1 + arg2 + arg3) mod 2^64\n   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17726,17727,17728,17729,17730],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[150,65,0,null,null," The function subborrowxU64 is a subtraction with borrow.\n\n Postconditions:\n   out1 = (-arg1 + arg2 + -arg3) mod 2^64\n   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17732,17733,17734,17735,17736],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[150,86,0,null,null," The function mulxU64 is a multiplication, returning the full double-width result.\n\n Postconditions:\n   out1 = (arg1 * arg2) mod 2^64\n   out2 = ⌊arg1 * arg2 / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0xffffffffffffffff]",[17738,17739,17740,17741],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[150,105,0,null,null," The function cmovznzU64 is a single-word conditional move.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17743,17744,17745,17746],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[150,121,0,null,null," The function mul multiplies two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17748,17749,17750],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[150,461,0,null,null," The function square squares a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m\n   0 ≤ eval out1 < m\n",[17752,17753],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,802,0,null,null," The function add adds two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17755,17756,17757],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[150,855,0,null,null," The function sub subtracts two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17759,17760,17761],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[150,898,0,null,null," The function opp negates a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m\n   0 ≤ eval out1 < m\n",[17763,17764],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,941,0,null,null," The function fromMontgomery translates a field element out of the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^4) mod m\n   0 ≤ eval out1 < m\n",[17766,17767],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,1174,0,null,null," The function toMontgomery translates a field element into the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = eval arg1 mod m\n   0 ≤ eval out1 < m\n",[17769,17770],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,1437,0,null,null," The function nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17772,17773],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,1455,0,null,null," The function selectznz is a multi-limb conditional select.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17775,17776,17777,17778],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[150,1483,0,null,null," The function toBytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]",[17780,17781],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,1592,0,null,null," The function fromBytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.\n\n Preconditions:\n   0 ≤ bytes_eval arg1 < m\n Postconditions:\n   eval out1 mod m = bytes_eval arg1 mod m\n   0 ≤ eval out1 < m\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17783,17784],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[150,1667,0,null,null," The function setOne returns the field element one in the Montgomery domain.\n\n Postconditions:\n   eval (from_montgomery out1) mod m = 1 mod m\n   0 ≤ eval out1 < m\n",[17786],false],[0,0,0,"out1",null,"",null,false],[150,1684,0,null,null," The function msat returns the saturated representation of the prime modulus.\n\n Postconditions:\n   twos_complement_eval out1 = m\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17788],false],[0,0,0,"out1",null,"",null,false],[150,1722,0,null,null," The function divstep computes a divstep.\n\n Preconditions:\n   0 ≤ eval arg4 < m\n   0 ≤ eval arg5 < m\n Postconditions:\n   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)\n   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)\n   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)\n   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)\n   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)\n   0 ≤ eval out5 < m\n   0 ≤ eval out5 < m\n   0 ≤ eval out2 < m\n   0 ≤ eval out3 < m\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17790,17791,17792,17793,17794,17795,17796,17797,17798,17799],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"out3",null,"",null,false],[0,0,0,"out4",null,"",null,false],[0,0,0,"out5",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[150,1956,0,null,null," The function divstepPrecomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).\n\n Postconditions:\n   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17801],false],[0,0,0,"out1",null,"",null,false],[148,16,0,null,null," Field arithmetic mod the order of the main subgroup.",null,false],[0,0,0,"secp256k1/scalar.zig",null,"",[],false],[151,0,0,null,null,null,null,false],[151,1,0,null,null,null,null,false],[151,2,0,null,null,null,null,false],[151,3,0,null,null,null,null,false],[151,4,0,null,null,null,null,false],[151,5,0,null,null,null,null,false],[151,7,0,null,null,null,null,false],[151,9,0,null,null,null,null,false],[151,10,0,null,null,null,null,false],[151,13,0,null,null," Number of bytes required to encode a scalar.",null,false],[151,16,0,null,null," A compressed scalar, in canonical form.",null,false],[151,18,0,null,null,null,null,false],[0,0,0,"secp256k1_scalar_64.zig",null,"",[],false],[152,19,0,null,null,null,null,false],[152,20,0,null,null,null,null,false],[152,24,0,null,null,null,null,false],[152,28,0,null,null,null,null,false],[152,43,0,null,null," The function addcarryxU64 is an addition with carry.\n\n Postconditions:\n   out1 = (arg1 + arg2 + arg3) mod 2^64\n   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17822,17823,17824,17825,17826],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[152,65,0,null,null," The function subborrowxU64 is a subtraction with borrow.\n\n Postconditions:\n   out1 = (-arg1 + arg2 + -arg3) mod 2^64\n   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0x1]",[17828,17829,17830,17831,17832],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[152,86,0,null,null," The function mulxU64 is a multiplication, returning the full double-width result.\n\n Postconditions:\n   out1 = (arg1 * arg2) mod 2^64\n   out2 = ⌊arg1 * arg2 / 2^64⌋\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [0x0 ~> 0xffffffffffffffff]",[17834,17835,17836,17837],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[152,105,0,null,null," The function cmovznzU64 is a single-word conditional move.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [0x0 ~> 0xffffffffffffffff]\n   arg3: [0x0 ~> 0xffffffffffffffff]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17839,17840,17841,17842],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[152,121,0,null,null," The function mul multiplies two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17844,17845,17846],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[152,461,0,null,null," The function square squares a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m\n   0 ≤ eval out1 < m\n",[17848,17849],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,802,0,null,null," The function add adds two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17851,17852,17853],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[152,855,0,null,null," The function sub subtracts two field elements in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n   0 ≤ eval arg2 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m\n   0 ≤ eval out1 < m\n",[17855,17856,17857],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[152,898,0,null,null," The function opp negates a field element in the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m\n   0 ≤ eval out1 < m\n",[17859,17860],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,941,0,null,null," The function fromMontgomery translates a field element out of the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^4) mod m\n   0 ≤ eval out1 < m\n",[17862,17863],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,1174,0,null,null," The function toMontgomery translates a field element into the Montgomery domain.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   eval (from_montgomery out1) mod m = eval arg1 mod m\n   0 ≤ eval out1 < m\n",[17865,17866],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,1497,0,null,null," The function nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]",[17868,17869],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,1515,0,null,null," The function selectznz is a multi-limb conditional select.\n\n Postconditions:\n   out1 = (if arg1 = 0 then arg2 else arg3)\n\n Input Bounds:\n   arg1: [0x0 ~> 0x1]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17871,17872,17873,17874],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[152,1543,0,null,null," The function toBytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.\n\n Preconditions:\n   0 ≤ eval arg1 < m\n Postconditions:\n   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]",[17876,17877],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,1652,0,null,null," The function fromBytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.\n\n Preconditions:\n   0 ≤ bytes_eval arg1 < m\n Postconditions:\n   eval out1 mod m = bytes_eval arg1 mod m\n   0 ≤ eval out1 < m\n\n Input Bounds:\n   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17879,17880],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[152,1727,0,null,null," The function setOne returns the field element one in the Montgomery domain.\n\n Postconditions:\n   eval (from_montgomery out1) mod m = 1 mod m\n   0 ≤ eval out1 < m\n",[17882],false],[0,0,0,"out1",null,"",null,false],[152,1744,0,null,null," The function msat returns the saturated representation of the prime modulus.\n\n Postconditions:\n   twos_complement_eval out1 = m\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17884],false],[0,0,0,"out1",null,"",null,false],[152,1782,0,null,null," The function divstep computes a divstep.\n\n Preconditions:\n   0 ≤ eval arg4 < m\n   0 ≤ eval arg5 < m\n Postconditions:\n   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)\n   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)\n   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)\n   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)\n   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)\n   0 ≤ eval out5 < m\n   0 ≤ eval out5 < m\n   0 ≤ eval out2 < m\n   0 ≤ eval out3 < m\n\n Input Bounds:\n   arg1: [0x0 ~> 0xffffffffffffffff]\n   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n Output Bounds:\n   out1: [0x0 ~> 0xffffffffffffffff]\n   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]\n   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17886,17887,17888,17889,17890,17891,17892,17893,17894,17895],false],[0,0,0,"out1",null,"",null,false],[0,0,0,"out2",null,"",null,false],[0,0,0,"out3",null,"",null,false],[0,0,0,"out4",null,"",null,false],[0,0,0,"out5",null,"",null,false],[0,0,0,"arg1",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[152,2016,0,null,null," The function divstepPrecomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).\n\n Postconditions:\n   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)\n   0 ≤ eval out1 < m\n\n Output Bounds:\n   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]",[17897],false],[0,0,0,"out1",null,"",null,false],[151,27,0,null,null," The scalar field order.",null,false],[151,30,0,null,null," Reject a scalar whose encoding is not canonical.",[17900,17901],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,35,0,null,null," Reduce a 48-bytes scalar to the field size.",[17903,17904],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,40,0,null,null," Reduce a 64-bytes scalar to the field size.",[17906,17907],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,45,0,null,null," Return a*b (mod L)",[17909,17910,17911],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,50,0,null,null," Return a*b+c (mod L)",[17913,17914,17915,17916],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,55,0,null,null," Return a+b (mod L)",[17918,17919,17920],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,60,0,null,null," Return -s (mod L)",[17922,17923],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,65,0,null,null," Return (a-b) (mod L)",[17925,17926,17927],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,70,0,null,null," Return a random scalar",[17929],false],[0,0,0,"endian",null,"",null,false],[151,75,0,null,null," A scalar in unpacked representation.",[17979],false],[151,79,0,null,null," Zero.",null,false],[151,82,0,null,null," One.",null,false],[151,85,0,null,null," Unpack a serialized representation of a scalar.",[17934,17935],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,90,0,null,null," Reduce a 384 bit input to the field size.",[17937,17938],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,96,0,null,null," Reduce a 512 bit input to the field size.",[17940,17941],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,102,0,null,null," Pack a scalar into bytes.",[17943,17944],false],[0,0,0,"n",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,107,0,null,null," Return true if the scalar is zero..",[17946],false],[0,0,0,"n",null,"",null,false],[151,112,0,null,null," Return true if the scalar is odd.",[17948],false],[0,0,0,"n",null,"",null,false],[151,117,0,null,null," Return true if a and b are equivalent.",[17950,17951],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[151,122,0,null,null," Compute x+y (mod L)",[17953,17954],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[151,127,0,null,null," Compute x-y (mod L)",[17956,17957],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[151,132,0,null,null," Compute 2n (mod L)",[17959],false],[0,0,0,"n",null,"",null,false],[151,137,0,null,null," Compute x*y (mod L)",[17961,17962],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[151,142,0,null,null," Compute x^2 (mod L)",[17964],false],[0,0,0,"n",null,"",null,false],[151,147,0,null,null," Compute x^n (mod L)",[17966,17967,17968],false],[0,0,0,"a",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,true],[151,152,0,null,null," Compute -x (mod L)",[17970],false],[0,0,0,"n",null,"",null,false],[151,157,0,null,null," Compute x^-1 (mod L)",[17972],false],[0,0,0,"n",null,"",null,false],[151,162,0,null,null," Return true if n is a quadratic residue mod L.",[17974],false],[0,0,0,"n",null,"",null,false],[151,167,0,null,null," Return the square root of L, or NotSquare if there isn't any solutions.",[17976],false],[0,0,0,"n",null,"",null,false],[151,172,0,null,null," Return a random scalar < L.",[],false],[151,75,0,null,null,null,null,false],[0,0,0,"fe",null,null,null,false],[151,184,0,null,null,null,[17989,17991,17993],false],[151,189,0,null,null,null,[17982,17983,17984],false],[0,0,0,"bits",null,"",null,true],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[151,218,0,null,null,null,[17986,17987],false],[0,0,0,"expanded",null,"",null,false],[0,0,0,"bits",null,"",null,true],[151,184,0,null,null,null,null,false],[0,0,0,"x1",null,null,null,false],[151,184,0,null,null,null,null,false],[0,0,0,"x2",null,null,null,false],[151,184,0,null,null,null,null,false],[0,0,0,"x3",null,null,null,false],[148,25,0,null,null," The secp256k1 base point.",null,false],[148,33,0,null,null," The secp256k1 neutral element.",null,false],[148,35,0,null,null,null,null,false],[148,37,0,null,null,null,[],false],[148,38,0,null,null,null,null,false],[148,39,0,null,null,null,null,false],[148,41,0,null,null,null,null,false],[148,47,0,null,null,null,[18003,18005],false],[148,47,0,null,null,null,null,false],[0,0,0,"r1",null,null,null,false],[148,47,0,null,null,null,null,false],[0,0,0,"r2",null,null,null,false],[148,53,0,null,null," Compute r1 and r2 so that k = r1 + r2*lambda (mod L).",[18007,18008],false],[0,0,0,"s",null,"",null,false],[0,0,0,"endian",null,"",null,false],[148,90,0,null,null," Reject the neutral element.",[18010],false],[0,0,0,"p",null,"",null,false],[148,99,0,null,null," Create a point from affine coordinates after checking that they match the curve equation.",[18012],false],[0,0,0,"p",null,"",null,false],[148,115,0,null,null," Create a point from serialized affine coordinates.",[18014,18015,18016],false],[0,0,0,"xs",null,"",null,false],[0,0,0,"ys",null,"",null,false],[0,0,0,"endian",null,"",null,false],[148,122,0,null,null," Recover the Y coordinate from the X coordinate.",[18018,18019],false],[0,0,0,"x",null,"",null,false],[0,0,0,"is_odd",null,"",null,false],[148,131,0,null,null," Deserialize a SEC1-encoded point.",[18021],false],[0,0,0,"s",null,"",null,false],[148,158,0,null,null," Serialize a point using the compressed SEC-1 format.",[18023],false],[0,0,0,"p",null,"",null,false],[148,167,0,null,null," Serialize a point using the uncompressed SEC-1 format.",[18025],false],[0,0,0,"p",null,"",null,false],[148,177,0,null,null," Return a random point.",[],false],[148,183,0,null,null," Flip the sign of the X coordinate.",[18028],false],[0,0,0,"p",null,"",null,false],[148,189,0,null,null," Double a secp256k1 point.",[18030],false],[0,0,0,"p",null,"",null,false],[148,219,0,null,null," Add secp256k1 points, the second being specified using affine coordinates.",[18032,18033],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[148,261,0,null,null," Add secp256k1 points.",[18035,18036],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[148,307,0,null,null," Subtract secp256k1 points.",[18038,18039],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[148,312,0,null,null," Subtract secp256k1 points, the second being specified using affine coordinates.",[18041,18042],false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[148,317,0,null,null," Return affine coordinates.",[18044],false],[0,0,0,"p",null,"",null,false],[148,330,0,null,null," Return true if both coordinate sets represent the same point.",[18046,18047],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[148,338,0,null,null,null,[18049,18050,18051],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[148,344,0,null,null,null,[18053,18054,18055],false],[0,0,0,"n",null,"",null,true],[0,0,0,"pc",null,"",null,false],[0,0,0,"b",null,"",null,false],[148,353,0,null,null,null,[18057],false],[0,0,0,"s",null,"",null,false],[148,373,0,null,null,null,[18059,18060,18061],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[148,392,0,null,null,null,[18063,18064,18065],false],[0,0,0,"pc",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"vartime",null,"",null,true],[148,411,0,null,null,null,[18067,18068],false],[0,0,0,"p",null,"",null,false],[0,0,0,"count",null,"",null,true],[148,422,0,null,null,null,null,false],[148,429,0,null,null," Multiply an elliptic curve point by a scalar.\n Return error.IdentityElement if the result is the identity element.",[18071,18072,18073],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[148,441,0,null,null," Multiply an elliptic curve point by a *PUBLIC* scalar *IN VARIABLE TIME*\n This can be used for signature verification.",[18075,18076,18077],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[148,468,0,null,null,null,[18079,18080,18081,18082],false],[0,0,0,"p1",null,"",null,false],[0,0,0,"s1",null,"",null,false],[0,0,0,"p2",null,"",null,false],[0,0,0,"s2",null,"",null,false],[148,503,0,null,null," Double-base multiplication of public parameters - Compute (p1*s1)+(p2*s2) *IN VARIABLE TIME*\n This can be used for signature verification.",[18084,18085,18086,18087,18088],false],[0,0,0,"p1",null,"",null,false],[0,0,0,"s1_",null,"",null,false],[0,0,0,"p2",null,"",null,false],[0,0,0,"s2_",null,"",null,false],[0,0,0,"endian",null,"",null,false],[148,12,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[148,12,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[148,12,0,null,null,null,null,false],[0,0,0,"z",null,null,null,false],[0,0,0,"is_base",null,null,null,false],[148,544,0,null,null," A point in affine coordinates.",[18103,18105],false],[148,549,0,null,null," Identity element in affine coordinates.",null,false],[148,551,0,null,null,null,[18099,18100,18101],false],[0,0,0,"p",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"c",null,"",null,false],[148,544,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[148,544,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[115,86,0,null,null," Hash functions.",[],false],[115,87,0,null,null,null,null,false],[0,0,0,"crypto/blake2.zig",null,"",[],false],[153,0,0,null,null,null,null,false],[153,1,0,null,null,null,null,false],[153,2,0,null,null,null,null,false],[153,3,0,null,null,null,null,false],[153,4,0,null,null,null,null,false],[153,6,0,null,null,null,[18115,18116,18117,18118,18119,18120],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"x",null,null,null,false],[0,0,0,"y",null,null,null,false],[153,15,0,null,null,null,[18122,18123,18124,18125,18126,18127],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[153,29,0,null,null,null,null,false],[153,30,0,null,null,null,null,false],[153,31,0,null,null,null,null,false],[153,32,0,null,null,null,null,false],[153,34,0,null,null,null,[18133],false],[0,0,0,"out_bits",null,"",[18174,18175,18177,18178],true],[153,36,0,null,null,null,null,false],[153,37,0,null,null,null,null,false],[153,38,0,null,null,null,null,false],[153,39,0,null,null,null,null,false],[153,40,0,null,null,null,null,false],[153,41,0,null,null,null,null,false],[153,42,0,null,null,null,[18142,18144,18146,18147],false],[153,42,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[153,42,0,null,null,null,null,false],[0,0,0,"salt",null,null,null,false],[153,42,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[0,0,0,"expected_out_bits",null,null,null,false],[153,44,0,null,null,null,null,false],[153,55,0,null,null,null,null,false],[153,74,0,null,null,null,[18151],false],[0,0,0,"options",null,"",null,false],[153,102,0,null,null,null,[18153,18154,18155],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[153,108,0,null,null,null,[18157,18158],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[153,132,0,null,null,null,[18160,18161],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[153,140,0,null,null,null,[18163,18164,18165],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"last",null,"",null,false],[153,188,0,null,null,null,null,false],[153,189,0,null,null,null,null,false],[153,191,0,null,null,null,[18169,18170],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[153,196,0,null,null,null,[18172],false],[0,0,0,"self",null,"",null,false],[153,35,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[0,0,0,"t",null,null,null,false],[153,35,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[153,462,0,null,null,null,null,false],[153,463,0,null,null,null,null,false],[153,464,0,null,null,null,null,false],[153,465,0,null,null,null,null,false],[153,466,0,null,null,null,null,false],[153,468,0,null,null,null,[18185],false],[0,0,0,"out_bits",null,"",[18219,18220,18222,18223],true],[153,470,0,null,null,null,null,false],[153,471,0,null,null,null,null,false],[153,472,0,null,null,null,null,false],[153,473,0,null,null,null,null,false],[153,474,0,null,null,null,null,false],[153,475,0,null,null,null,null,false],[153,476,0,null,null,null,[18194,18196,18198,18199],false],[153,476,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[153,476,0,null,null,null,null,false],[0,0,0,"salt",null,null,null,false],[153,476,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[0,0,0,"expected_out_bits",null,null,null,false],[153,478,0,null,null,null,null,false],[153,489,0,null,null,null,null,false],[153,510,0,null,null,null,[18203],false],[0,0,0,"options",null,"",null,false],[153,538,0,null,null,null,[18205,18206,18207],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[153,544,0,null,null,null,[18209,18210],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[153,568,0,null,null,null,[18212,18213],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[153,576,0,null,null,null,[18215,18216,18217],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"last",null,"",null,false],[153,469,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[0,0,0,"t",null,null,null,false],[153,469,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[115,88,0,null,null,null,null,false],[0,0,0,"crypto/blake3.zig",null,"",[],false],[154,3,0,null,null,null,null,false],[154,4,0,null,null,null,null,false],[154,5,0,null,null,null,null,false],[154,6,0,null,null,null,null,false],[154,7,0,null,null,null,null,false],[154,8,0,null,null,null,null,false],[154,10,0,null,null,null,[18239,18240],false],[154,14,0,null,null,null,[18234,18235],false],[0,0,0,"slice",null,"",null,false],[0,0,0,"chunk_len",null,"",null,false],[154,21,0,null,null,null,[18237],false],[0,0,0,"self",null,"",null,false],[154,10,0,null,null,null,null,false],[0,0,0,"slice",null,null,null,false],[0,0,0,"chunk_len",null,null,null,false],[154,28,0,null,null,null,null,false],[154,29,0,null,null,null,null,false],[154,30,0,null,null,null,null,false],[154,31,0,null,null,null,null,false],[154,33,0,null,null,null,null,false],[154,37,0,null,null,null,null,false],[154,51,0,null,null,null,null,false],[154,52,0,null,null,null,null,false],[154,53,0,null,null,null,null,false],[154,54,0,null,null,null,null,false],[154,55,0,null,null,null,null,false],[154,56,0,null,null,null,null,false],[154,57,0,null,null,null,null,false],[154,59,0,null,null,null,[],false],[154,60,0,null,null,null,null,false],[154,61,0,null,null,null,null,false],[154,63,0,null,null,null,[18258,18259,18260],false],[0,0,0,"even",null,"",null,true],[0,0,0,"rows",null,"",null,false],[0,0,0,"m",null,"",null,false],[154,72,0,null,null,null,[18262],false],[0,0,0,"rows",null,"",null,false],[154,78,0,null,null,null,[18264],false],[0,0,0,"rows",null,"",null,false],[154,84,0,null,null,null,[18266,18267,18268,18269,18270],false],[0,0,0,"chaining_value",null,"",null,false],[0,0,0,"block_words",null,"",null,false],[0,0,0,"block_len",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"flags",null,"",null,false],[154,140,0,null,null,null,[],false],[154,141,0,null,null,null,[18273,18274,18275,18276,18277,18278,18279],false],[0,0,0,"state",null,"",null,false],[0,0,0,"a",null,"",null,true],[0,0,0,"b",null,"",null,true],[0,0,0,"c",null,"",null,true],[0,0,0,"d",null,"",null,true],[0,0,0,"mx",null,"",null,false],[0,0,0,"my",null,"",null,false],[154,152,0,null,null,null,[18281,18282,18283],false],[0,0,0,"state",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"schedule",null,"",null,false],[154,166,0,null,null,null,[18285,18286,18287,18288,18289],false],[0,0,0,"chaining_value",null,"",null,false],[0,0,0,"block_words",null,"",null,false],[0,0,0,"block_len",null,"",null,false],[0,0,0,"counter",null,"",null,false],[0,0,0,"flags",null,"",null,false],[154,202,0,null,null,null,null,false],[154,207,0,null,null,null,[18292],false],[0,0,0,"words",null,"",null,false],[154,211,0,null,null,null,[18294,18295],false],[0,0,0,"count",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[154,222,0,null,null,null,[18303,18305,18306,18307,18308],false],[154,229,0,null,null,null,[18298],false],[0,0,0,"self",null,"",null,false],[154,239,0,null,null,null,[18300,18301],false],[0,0,0,"self",null,"",null,false],[0,0,0,"output",null,"",null,false],[154,222,0,null,null,null,null,false],[0,0,0,"input_chaining_value",null,null,null,false],[154,222,0,null,null,null,null,false],[0,0,0,"block_words",null,null,null,false],[0,0,0,"block_len",null,null,null,false],[0,0,0,"counter",null,null,null,false],[0,0,0,"flags",null,null,null,false],[154,263,0,null,null,null,[18327,18328,18330,18331,18332,18333],false],[154,271,0,null,null,null,[18311,18312,18313],false],[0,0,0,"key",null,"",null,false],[0,0,0,"chunk_counter",null,"",null,false],[0,0,0,"flags",null,"",null,false],[154,279,0,null,null,null,[18315],false],[0,0,0,"self",null,"",null,false],[154,283,0,null,null,null,[18317,18318],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[154,291,0,null,null,null,[18320],false],[0,0,0,"self",null,"",null,false],[154,295,0,null,null,null,[18322,18323],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input_slice",null,"",null,false],[154,319,0,null,null,null,[18325],false],[0,0,0,"self",null,"",null,false],[154,263,0,null,null,null,null,false],[0,0,0,"chaining_value",null,null,null,false],[0,0,0,"chunk_counter",null,null,null,false],[154,263,0,null,null,null,null,false],[0,0,0,"block",null,null,null,false],[0,0,0,"block_len",null,null,null,false],[0,0,0,"blocks_compressed",null,null,null,false],[0,0,0,"flags",null,null,null,false],[154,331,0,null,null,null,[18335,18336,18337,18338],false],[0,0,0,"left_child_cv",null,"",null,false],[0,0,0,"right_child_cv",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"flags",null,"",null,false],[154,349,0,null,null,null,[18340,18341,18342,18343],false],[0,0,0,"left_child_cv",null,"",null,false],[0,0,0,"right_child_cv",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"flags",null,"",null,false],[154,359,0,null,null," An incremental hasher that can accept any number of writes.",[18387,18389,18391,18392,18393],false],[154,360,0,null,null,null,[18347],false],[154,360,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[154,361,0,null,null,null,[],false],[154,369,0,null,null,null,null,false],[154,370,0,null,null,null,null,false],[154,371,0,null,null,null,null,false],[154,373,0,null,null,null,[18353,18354],false],[0,0,0,"key",null,"",null,false],[0,0,0,"flags",null,"",null,false],[154,382,0,null,null," Construct a new `Blake3` for the hash function, with an optional key",[18356],false],[0,0,0,"options",null,"",null,false],[154,393,0,null,null," Construct a new `Blake3` for the key derivation function. The context\n string should be hardcoded, globally unique, and application-specific.",[18358,18359],false],[0,0,0,"context",null,"",null,false],[0,0,0,"options",null,"",null,false],[154,403,0,null,null,null,[18361,18362,18363],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[154,409,0,null,null,null,[18365,18366],false],[0,0,0,"self",null,"",null,false],[0,0,0,"cv",null,"",null,false],[154,414,0,null,null,null,[18368],false],[0,0,0,"self",null,"",null,false],[154,420,0,null,null,null,[18370,18371,18372],false],[0,0,0,"self",null,"",null,false],[0,0,0,"first_cv",null,"",null,false],[0,0,0,"total_chunks",null,"",null,false],[154,438,0,null,null," Add input to the hash state. This can be called any number of times.",[18374,18375],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input_slice",null,"",null,false],[154,459,0,null,null," Finalize the hash and write any number of output bytes.",[18377,18378],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out_slice",null,"",null,false],[154,477,0,null,null,null,null,false],[154,478,0,null,null,null,null,false],[154,480,0,null,null,null,[18382,18383],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[154,485,0,null,null,null,[18385],false],[0,0,0,"self",null,"",null,false],[154,359,0,null,null,null,null,false],[0,0,0,"chunk_state",null,null,null,false],[154,359,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[154,359,0,null,null,null,null,false],[0,0,0,"cv_stack",null,null,null,false],[0,0,0,"cv_stack_len",null,null,null,false],[0,0,0,"flags",null,null,null,false],[154,491,0,null,null,null,[18396,18398,18400],false],[154,491,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[154,491,0,null,null,null,null,false],[0,0,0,"context_string",null,null,null,false],[154,491,0,null,null,null,null,false],[0,0,0,"cases",null,null,null,false],[154,497,0,null,null,null,[18402,18404,18406,18408],false],[0,0,0,"input_len",null,null,null,false],[154,497,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[154,497,0,null,null,null,null,false],[0,0,0,"keyed_hash",null,null,null,false],[154,497,0,null,null,null,null,false],[0,0,0,"derive_key",null,null,null,false],[154,515,0,null,null,null,null,false],[154,654,0,null,null,null,[18411,18412,18413],false],[0,0,0,"hasher",null,"",null,false],[0,0,0,"input_len",null,"",null,false],[0,0,0,"expected_hex",null,"",null,false],[115,89,0,null,null,null,null,false],[0,0,0,"crypto/md5.zig",null,"",[],false],[155,0,0,null,null,null,null,false],[155,1,0,null,null,null,null,false],[155,2,0,null,null,null,null,false],[155,4,0,null,null,null,[18420,18421,18422,18423,18424,18425,18426],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"k",null,null,null,false],[0,0,0,"s",null,null,null,false],[0,0,0,"t",null,null,null,false],[155,14,0,null,null,null,[18428,18429,18430,18431,18432,18433,18434],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[0,0,0,"k",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"t",null,"",null,false],[155,29,0,null,null," The MD5 function is now considered cryptographically broken.\n Namely, it is trivial to find multiple inputs producing the same hash.\n For a fast-performing, cryptographically secure hash function, see SHA512/256, BLAKE2 or BLAKE3.",[18456,18458,18459,18460],false],[155,30,0,null,null,null,null,false],[155,31,0,null,null,null,null,false],[155,32,0,null,null,null,null,false],[155,33,0,null,null,null,[],false],[155,41,0,null,null,null,[18441],false],[0,0,0,"options",null,"",null,false],[155,56,0,null,null,null,[18443,18444,18445],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[155,62,0,null,null,null,[18447,18448],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[155,88,0,null,null,null,[18450,18451],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[155,118,0,null,null,null,[18453,18454],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[155,29,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[155,29,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[0,0,0,"total_len",null,null,null,false],[155,232,0,null,null,null,null,false],[115,90,0,null,null,null,null,false],[0,0,0,"crypto/sha1.zig",null,"",[],false],[156,0,0,null,null,null,null,false],[156,1,0,null,null,null,null,false],[156,2,0,null,null,null,null,false],[156,4,0,null,null,null,[18468,18469,18470,18471,18472,18473],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"e",null,null,null,false],[0,0,0,"i",null,null,null,false],[156,13,0,null,null,null,[18475,18476,18477,18478,18479,18480],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[0,0,0,"e",null,"",null,false],[0,0,0,"i",null,"",null,false],[156,27,0,null,null," The SHA-1 function is now considered cryptographically broken.\n Namely, it is feasible to find multiple inputs producing the same hash.\n For a fast-performing, cryptographically secure hash function, see SHA512/256, BLAKE2 or BLAKE3.",[18513,18515,18516,18517],false],[156,28,0,null,null,null,null,false],[156,29,0,null,null,null,null,false],[156,30,0,null,null,null,null,false],[156,31,0,null,null,null,[],false],[156,39,0,null,null,null,[18487],false],[0,0,0,"options",null,"",null,false],[156,52,0,null,null,null,[18489,18490,18491],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[156,58,0,null,null,null,[18493,18494],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[156,82,0,null,null,null,[18496],false],[0,0,0,"d",null,"",null,false],[156,87,0,null,null,null,[18498,18499],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[156,117,0,null,null,null,[18501],false],[0,0,0,"d",null,"",null,false],[156,123,0,null,null,null,[18503,18504],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[156,270,0,null,null,null,null,false],[156,271,0,null,null,null,null,false],[156,273,0,null,null,null,[18508,18509],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[156,278,0,null,null,null,[18511],false],[0,0,0,"self",null,"",null,false],[156,27,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[156,27,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[0,0,0,"total_len",null,null,null,false],[156,283,0,null,null,null,null,false],[115,91,0,null,null,null,null,false],[0,0,0,"crypto/sha2.zig",null,"",[],false],[157,0,0,null,null,null,null,false],[157,1,0,null,null,null,null,false],[157,2,0,null,null,null,null,false],[157,3,0,null,null,null,null,false],[157,4,0,null,null,null,null,false],[157,9,0,null,null,null,[18527,18528,18529,18530,18531,18532,18533,18534,18535],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"e",null,null,null,false],[0,0,0,"f",null,null,null,false],[0,0,0,"g",null,null,null,false],[0,0,0,"h",null,null,null,false],[0,0,0,"i",null,null,null,false],[157,21,0,null,null,null,[18537,18538,18539,18540,18541,18542,18543,18544,18545],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[0,0,0,"e",null,"",null,false],[0,0,0,"f",null,"",null,false],[0,0,0,"g",null,"",null,false],[0,0,0,"h",null,"",null,false],[0,0,0,"i",null,"",null,false],[157,35,0,null,null,null,[18547,18548,18549,18550,18551,18552,18553,18554,18555],false],[0,0,0,"iv0",null,null,null,false],[0,0,0,"iv1",null,null,null,false],[0,0,0,"iv2",null,null,null,false],[0,0,0,"iv3",null,null,null,false],[0,0,0,"iv4",null,null,null,false],[0,0,0,"iv5",null,null,null,false],[0,0,0,"iv6",null,null,null,false],[0,0,0,"iv7",null,null,null,false],[0,0,0,"digest_bits",null,null,null,false],[157,47,0,null,null,null,null,false],[157,59,0,null,null,null,null,false],[157,71,0,null,null,null,null,false],[157,74,0,null,null," SHA-224",null,false],[157,77,0,null,null," SHA-256",null,false],[157,79,0,null,null,null,[18562],false],[0,0,0,"params",null,"",[18595,18597,18598,18599],true],[157,81,0,null,null,null,null,false],[157,82,0,null,null,null,null,false],[157,83,0,null,null,null,null,false],[157,84,0,null,null,null,[],false],[157,92,0,null,null,null,[18568],false],[0,0,0,"options",null,"",null,false],[157,108,0,null,null,null,[18570,18571,18572],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[157,114,0,null,null,null,[18574,18575],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[157,139,0,null,null,null,[18577],false],[0,0,0,"d",null,"",null,false],[157,144,0,null,null,null,[18579,18580],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[157,177,0,null,null,null,[18582],false],[0,0,0,"d",null,"",null,false],[157,183,0,null,null,null,null,false],[157,194,0,null,null,null,[18585,18586],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[157,393,0,null,null,null,null,false],[157,394,0,null,null,null,null,false],[157,396,0,null,null,null,[18590,18591],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[157,401,0,null,null,null,[18593],false],[0,0,0,"self",null,"",null,false],[157,80,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[157,80,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[0,0,0,"total_len",null,null,null,false],[157,471,0,null,null,null,[18601,18602,18603,18604,18605,18606,18607,18608,18609,18610],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[0,0,0,"e",null,null,null,false],[0,0,0,"f",null,null,null,false],[0,0,0,"g",null,null,null,false],[0,0,0,"h",null,null,null,false],[0,0,0,"i",null,null,null,false],[0,0,0,"k",null,null,null,false],[157,484,0,null,null,null,[18612,18613,18614,18615,18616,18617,18618,18619,18620,18621],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[0,0,0,"e",null,"",null,false],[0,0,0,"f",null,"",null,false],[0,0,0,"g",null,"",null,false],[0,0,0,"h",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"k",null,"",null,false],[157,499,0,null,null,null,[18623,18624,18625,18626,18627,18628,18629,18630,18631],false],[0,0,0,"iv0",null,null,null,false],[0,0,0,"iv1",null,null,null,false],[0,0,0,"iv2",null,null,null,false],[0,0,0,"iv3",null,null,null,false],[0,0,0,"iv4",null,null,null,false],[0,0,0,"iv5",null,null,null,false],[0,0,0,"iv6",null,null,null,false],[0,0,0,"iv7",null,null,null,false],[0,0,0,"digest_bits",null,null,null,false],[157,511,0,null,null,null,null,false],[157,523,0,null,null,null,null,false],[157,535,0,null,null,null,null,false],[157,547,0,null,null,null,null,false],[157,560,0,null,null," SHA-384",null,false],[157,563,0,null,null," SHA-512",null,false],[157,566,0,null,null," SHA-512/256",null,false],[157,569,0,null,null," Truncated SHA-512",null,false],[157,571,0,null,null,null,[18641],false],[0,0,0,"params",null,"",[18666,18668,18669,18670],true],[157,573,0,null,null,null,null,false],[157,574,0,null,null,null,null,false],[157,575,0,null,null,null,null,false],[157,576,0,null,null,null,[],false],[157,584,0,null,null,null,[18647],false],[0,0,0,"options",null,"",null,false],[157,600,0,null,null,null,[18649,18650,18651],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[157,606,0,null,null,null,[18653,18654],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[157,631,0,null,null,null,[18656],false],[0,0,0,"d",null,"",null,false],[157,636,0,null,null,null,[18658,18659],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[157,669,0,null,null,null,[18661],false],[0,0,0,"d",null,"",null,false],[157,675,0,null,null,null,[18663,18664],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[157,572,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[157,572,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[0,0,0,"total_len",null,null,null,false],[115,92,0,null,null,null,null,false],[0,0,0,"crypto/sha3.zig",null,"",[],false],[158,0,0,null,null,null,null,false],[158,1,0,null,null,null,null,false],[158,2,0,null,null,null,null,false],[158,3,0,null,null,null,null,false],[158,5,0,null,null,null,null,false],[158,7,0,null,null,null,null,false],[158,8,0,null,null,null,null,false],[158,9,0,null,null,null,null,false],[158,10,0,null,null,null,null,false],[158,12,0,null,null,null,null,false],[158,13,0,null,null,null,null,false],[158,14,0,null,null,null,null,false],[158,15,0,null,null,null,null,false],[158,17,0,null,null,null,null,false],[158,18,0,null,null,null,null,false],[158,24,0,null,null," TurboSHAKE128 is a XOF (a secure hash function with a variable output length), with a 128 bit security level.\n It is based on the same permutation as SHA3 and SHAKE128, but which much higher performance.\n The delimiter is 0x1f by default, but can be changed for context-separation.\n For a protocol that uses both KangarooTwelve and TurboSHAKE128, it is recommended to avoid using 0x06, 0x07 or 0x0b for the delimiter.",[18689],false],[0,0,0,"delim",null,"",null,true],[158,31,0,null,null," TurboSHAKE256 is a XOF (a secure hash function with a variable output length), with a 256 bit security level.\n It is based on the same permutation as SHA3 and SHAKE256, but which much higher performance.\n The delimiter is 0x1f by default, but can be changed for context-separation.",[18691],false],[0,0,0,"delim",null,"",null,true],[158,36,0,null,null," A generic Keccak hash function.",[18693,18694,18695,18696],false],[0,0,0,"f",null,"",null,true],[0,0,0,"output_bits",null,"",null,true],[0,0,0,"delim",null,"",null,true],[0,0,0,"rounds",null,"",[18721],true],[158,42,0,null,null,null,null,false],[158,47,0,null,null," The output length, in bytes.",null,false],[158,49,0,null,null," The block length, or rate, in bytes.",null,false],[158,51,0,null,null," Keccak does not have any options.",[],false],[158,54,0,null,null," Initialize a Keccak hash function.",[18702],false],[0,0,0,"options",null,"",null,false],[158,60,0,null,null," Hash a slice of bytes.",[18704,18705,18706],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[158,67,0,null,null," Absorb a slice of bytes into the state.",[18708,18709],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[158,72,0,null,null," Return the hash of the absorbed bytes.",[18711,18712],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[158,77,0,null,null,null,null,false],[158,78,0,null,null,null,null,false],[158,80,0,null,null,null,[18716,18717],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[158,85,0,null,null,null,[18719],false],[0,0,0,"self",null,"",null,false],[158,41,0,null,null,null,null,false],[0,0,0,"st",null,null,null,false],[158,92,0,null,null," The SHAKE extendable output hash function.",[18723],false],[0,0,0,"security_level",null,"",null,true],[158,100,0,null,null," The TurboSHAKE extendable output hash function.\n It is based on the same permutation as SHA3 and SHAKE, but which much higher performance.\n The delimiter is 0x1f by default, but can be changed for context-separation.\n https://eprint.iacr.org/2023/342",[18725,18726],false],[0,0,0,"security_level",null,"",null,true],[0,0,0,"delim",null,"",null,true],[158,107,0,null,null,null,[18728,18729,18730],false],[0,0,0,"security_level",null,"",null,true],[0,0,0,"delim",null,"",null,true],[0,0,0,"rounds",null,"",[18758,18760,18761,18762],true],[158,112,0,null,null,null,null,false],[158,120,0,null,null," The recommended output length, in bytes.",null,false],[158,122,0,null,null," The block length, or rate, in bytes.",null,false],[158,124,0,null,null," Keccak does not have any options.",[],false],[158,127,0,null,null," Initialize a SHAKE extensible hash function.",[18736],false],[0,0,0,"options",null,"",null,false],[158,134,0,null,null," Hash a slice of bytes.\n `out` can be any length.",[18738,18739,18740],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[158,141,0,null,null," Absorb a slice of bytes into the state.",[18742,18743],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[158,147,0,null,null," Squeeze a slice of bytes from the state.\n `out` can be any length, and the function can be called multiple times.",[18745,18746],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out_",null,"",null,false],[158,179,0,null,null," Return the hash of the absorbed bytes.\n `out` can be of any length, but the function must not be called multiple times (use `squeeze` for that purpose instead).",[18748,18749],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[158,184,0,null,null,null,null,false],[158,185,0,null,null,null,null,false],[158,187,0,null,null,null,[18753,18754],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[158,192,0,null,null,null,[18756],false],[0,0,0,"self",null,"",null,false],[158,111,0,null,null,null,null,false],[0,0,0,"st",null,null,null,false],[158,111,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"padded",null,null,null,false],[158,198,0,null,null,null,null,false],[115,93,0,null,null,null,null,false],[0,0,0,"crypto/hash_composition.zig",null,"",[],false],[159,0,0,null,null,null,null,false],[159,1,0,null,null,null,null,false],[159,12,0,null,null," The composition of two hash functions: H1 o H2, with the same API as regular hash functions.\n\n The security level of a hash cascade doesn't exceed the security level of the weakest function.\n\n However, Merkle–Damgård constructions such as SHA-256 are vulnerable to length-extension attacks,\n where under some conditions, `H(x||e)` can be efficiently computed without knowing `x`.\n The composition of two hash functions is a common defense against such attacks.\n\n This is not necessary with modern hash functions, such as SHA-3, BLAKE2 and BLAKE3.",[18769,18770],false],[0,0,0,"H1",null,"",null,true],[0,0,0,"H2",null,"",[18792,18794],true],[159,14,0,null,null,null,null,false],[159,20,0,null,null," The length of the hash output, in bytes.",null,false],[159,22,0,null,null," The block length, in bytes.",null,false],[159,25,0,null,null," Options for both hashes.",[18776,18778],false],[159,25,0,null,null,null,null,false],[0,0,0,"H1",null," Options for H1.",null,false],[159,25,0,null,null,null,null,false],[0,0,0,"H2",null," Options for H2.",null,false],[159,33,0,null,null," Initialize the hash composition with the given options.",[18780],false],[0,0,0,"options",null,"",null,false],[159,38,0,null,null," Compute H1(H2(b)).",[18782,18783,18784],false],[0,0,0,"b",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"options",null,"",null,false],[159,45,0,null,null," Add content to the hash.",[18786,18787],false],[0,0,0,"d",null,"",null,false],[0,0,0,"b",null,"",null,false],[159,50,0,null,null," Compute the final hash for the accumulated content: H1(H2(b)).",[18789,18790],false],[0,0,0,"d",null,"",null,false],[0,0,0,"out",null,"",null,false],[159,13,0,null,null,null,null,false],[0,0,0,"H1",null,null,null,false],[159,13,0,null,null,null,null,false],[0,0,0,"H2",null,null,null,false],[159,60,0,null,null," SHA-256(SHA-256())",null,false],[159,62,0,null,null," SHA-384(SHA-384())",null,false],[159,64,0,null,null," SHA-512(SHA-512())",null,false],[115,97,0,null,null," Key derivation functions.",[],false],[115,98,0,null,null,null,null,false],[0,0,0,"crypto/hkdf.zig",null,"",[],false],[160,0,0,null,null,null,null,false],[160,1,0,null,null,null,null,false],[160,2,0,null,null,null,null,false],[160,3,0,null,null,null,null,false],[160,6,0,null,null," HKDF-SHA256",null,false],[160,9,0,null,null," HKDF-SHA512",null,false],[160,13,0,null,null," The Hkdf construction takes some source of initial keying material and\n derives one or more uniform keys from it.",[18808],false],[0,0,0,"Hmac",null,"",[],true],[160,16,0,null,null," Length of a master key, in bytes.",null,false],[160,19,0,null,null," Return a master key from a salt and initial keying material.",[18811,18812],false],[0,0,0,"salt",null,"",null,false],[0,0,0,"ikm",null,"",null,false],[160,35,0,null,null," Initialize the creation of a master key from a salt\n and keying material that can be added later, possibly in chunks.\n Example:\n ```\n var prk: [hkdf.prk_length]u8 = undefined;\n var hkdf = HkdfSha256.extractInit(salt);\n hkdf.update(ikm1);\n hkdf.update(ikm2);\n hkdf.final(&prk);\n ```",[18814],false],[0,0,0,"salt",null,"",null,false],[160,40,0,null,null," Derive a subkey from a master key `prk` and a subkey description `ctx`.",[18816,18817,18818],false],[0,0,0,"out",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"prk",null,"",null,false],[160,71,0,null,null,null,null,false],[115,102,0,null,null," MAC functions requiring single-use secret keys.",[],false],[115,103,0,null,null,null,null,false],[0,0,0,"crypto/ghash_polyval.zig",null,"",[],false],[161,0,0,null,null,null,null,false],[161,1,0,null,null,null,null,false],[161,2,0,null,null,null,null,false],[161,3,0,null,null,null,null,false],[161,4,0,null,null,null,null,false],[161,5,0,null,null,null,null,false],[161,7,0,null,null,null,null,false],[161,15,0,null,null," GHASH is a universal hash function that uses multiplication by a fixed\n parameter within a Galois field.\n\n It is not a general purpose hash function - The key must be secret, unpredictable and never reused.\n\n GHASH is typically used to compute the authentication tag in the AES-GCM construction.",null,false],[161,23,0,null,null," POLYVAL is a universal hash function that uses multiplication by a fixed\n parameter within a Galois field.\n\n It is not a general purpose hash function - The key must be secret, unpredictable and never reused.\n\n POLYVAL is typically used to compute the authentication tag in the AES-GCM-SIV construction.",null,false],[161,25,0,null,null,null,[18833,18834],false],[0,0,0,"endian",null,"",null,true],[0,0,0,"shift_key",null,"",[18907,18908,18909,18911],true],[161,27,0,null,null,null,null,false],[161,29,0,null,null,null,null,false],[161,30,0,null,null,null,null,false],[161,31,0,null,null,null,null,false],[161,33,0,null,null,null,null,false],[161,34,0,null,null,null,null,false],[161,35,0,null,null,null,null,false],[161,36,0,null,null,null,null,false],[161,44,0,null,null,null,null,false],[161,53,0,null,null," Initialize the GHASH state with a key, and a minimum number of block count.",[18845,18846],false],[0,0,0,"key",null,"",null,false],[0,0,0,"block_count",null,"",null,false],[161,85,0,null,null," Initialize the GHASH state with a key.",[18848],false],[0,0,0,"key",null,"",null,false],[161,89,0,null,null,null,[18850,18851,18852],false],[0,0,0,"lo",null,null,null,false],[0,0,0,"hi",null,null,null,false],[0,0,0,"hi_lo",null,null,null,false],[161,92,0,null,null,null,[18854,18855,18856],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"half",null,"",null,true],[161,125,0,null,null,null,[18858,18859,18860],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"half",null,"",null,true],[161,158,0,null,null," clmulSoft128_64 is faster on platforms with no native 128-bit registers.",null,false],[161,168,0,null,null,null,[18863,18864,18865],false],[0,0,0,"x_",null,"",null,false],[0,0,0,"y_",null,"",null,false],[0,0,0,"half",null,"",null,true],[161,199,0,null,null,null,[18867,18868],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[161,217,0,null,null,null,[18870,18871,18872],false],[0,0,0,"x_",null,"",null,false],[0,0,0,"y_",null,"",null,false],[0,0,0,"half",null,"",null,true],[161,232,0,null,null,null,[18874,18875,18876],false],[0,0,0,"hi",null,null,null,false],[0,0,0,"lo",null,null,null,false],[0,0,0,"mid",null,null,null,false],[161,238,0,null,null,null,[18878,18879],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[161,247,0,null,null,null,[18881],false],[0,0,0,"x",null,"",null,false],[161,256,0,null,null,null,[18883,18884],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[161,280,0,null,null,null,[18886],false],[0,0,0,"x",null,"",null,false],[161,291,0,null,null,null,null,false],[161,292,0,null,null,null,null,false],[161,293,0,null,null,null,null,false],[161,295,0,null,null,null,null,false],[161,304,0,null,null,null,[18892,18893],false],[0,0,0,"st",null,"",null,false],[0,0,0,"msg",null,"",null,false],[161,361,0,null,null," Absorb a message into the GHASH state.",[18895,18896],false],[0,0,0,"st",null,"",null,false],[0,0,0,"m",null,"",null,false],[161,392,0,null,null," Zero-pad to align the next input to the first byte of a block",[18898],false],[0,0,0,"st",null,"",null,false],[161,405,0,null,null," Compute the GHASH of the entire input.",[18900,18901],false],[0,0,0,"st",null,"",null,false],[0,0,0,"out",null,"",null,false],[161,413,0,null,null," Compute the GHASH of a message.",[18903,18904,18905],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[161,26,0,null,null,null,null,false],[0,0,0,"hx",null,null,null,false],[0,0,0,"acc",null,null,null,false],[0,0,0,"leftover",null,null,null,false],[161,26,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[161,421,0,null,null,null,null,false],[115,104,0,null,null,null,null,false],[115,105,0,null,null,null,null,false],[0,0,0,"crypto/poly1305.zig",null,"",[],false],[162,0,0,null,null,null,null,false],[162,1,0,null,null,null,null,false],[162,2,0,null,null,null,null,false],[162,3,0,null,null,null,null,false],[162,5,0,null,null,null,[18955,18957,18959,18960,18962],false],[162,6,0,null,null,null,null,false],[162,7,0,null,null,null,null,false],[162,8,0,null,null,null,null,false],[162,21,0,null,null,null,[18925],false],[0,0,0,"key",null,"",null,false],[162,34,0,null,null,null,[18927,18928,18929],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",[18930,18931],false],[0,0,0,"",null,null,null,false],[0,0,0,"",null,null,null,false],[162,40,0,null,null,null,[18933,18934,18935],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",[18936,18937],false],[0,0,0,"",null,null,null,false],[0,0,0,"",null,null,null,false],[162,46,0,null,null,null,[18939,18940,18941],false],[0,0,0,"st",null,"",null,false],[0,0,0,"m",null,"",null,false],[0,0,0,"last",null,"",null,true],[162,109,0,null,null,null,[18943,18944],false],[0,0,0,"st",null,"",null,false],[0,0,0,"m",null,"",null,false],[162,145,0,null,null," Zero-pad to align the next input to the first byte of a block",[18946],false],[0,0,0,"st",null,"",null,false],[162,154,0,null,null,null,[18948,18949],false],[0,0,0,"st",null,"",null,false],[0,0,0,"out",null,"",null,false],[162,190,0,null,null,null,[18951,18952,18953],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[162,5,0,null,null,null,null,false],[0,0,0,"r",null,null,null,false],[162,5,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[162,5,0,null,null,null,null,false],[0,0,0,"pad",null,null,null,false],[0,0,0,"leftover",null,null,null,false],[162,5,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[115,124,0,null,null," A password hashing function derives a uniform key from low-entropy input material such as passwords.\n It is intentionally slow or expensive.\n\n With the standard definition of a key derivation function, if a key space is small, an exhaustive search may be practical.\n Password hashing functions make exhaustive searches way slower or way more expensive, even when implemented on GPUs and ASICs, by using different, optionally combined strategies:\n\n - Requiring a lot of computation cycles to complete\n - Requiring a lot of memory to complete\n - Requiring multiple CPU cores to complete\n - Requiring cache-local data to complete in reasonable time\n - Requiring large static tables\n - Avoiding precomputations and time/memory tradeoffs\n - Requiring multi-party computations\n - Combining the input material with random per-entry data (salts), application-specific contexts and keys\n\n Password hashing functions must be used whenever sensitive data has to be directly derived from a password.",[],false],[115,125,0,null,null,null,[18965,18966],false],[0,0,0,"phc",null,null,null,false],[0,0,0,"crypt",null,null,null,false],[115,130,0,null,null,null,null,false],[115,131,0,null,null,null,null,false],[115,132,0,null,null,null,null,false],[115,134,0,null,null,null,null,false],[0,0,0,"crypto/argon2.zig",null,"",[],false],[163,4,0,null,null,null,null,false],[163,5,0,null,null,null,null,false],[163,7,0,null,null,null,null,false],[163,8,0,null,null,null,null,false],[163,9,0,null,null,null,null,false],[163,10,0,null,null,null,null,false],[163,11,0,null,null,null,null,false],[163,12,0,null,null,null,null,false],[163,14,0,null,null,null,null,false],[163,15,0,null,null,null,null,false],[163,16,0,null,null,null,null,false],[163,17,0,null,null,null,null,false],[163,19,0,null,null,null,null,false],[163,20,0,null,null,null,null,false],[163,21,0,null,null,null,null,false],[163,22,0,null,null,null,null,false],[163,24,0,null,null,null,null,false],[163,25,0,null,null,null,null,false],[163,26,0,null,null,null,null,false],[163,27,0,null,null,null,null,false],[163,29,0,null,null,null,null,false],[163,30,0,null,null,null,null,false],[163,31,0,null,null,null,null,false],[163,32,0,null,null,null,null,false],[163,35,0,null,null," Argon2 type",[18997,18998,18999],false],[0,0,0,"argon2d",null," Argon2d is faster and uses data-depending memory access, which makes it highly resistant\n against GPU cracking attacks and suitable for applications with no threats from side-channel\n timing attacks (eg. cryptocurrencies).",null,false],[0,0,0,"argon2i",null," Argon2i instead uses data-independent memory access, which is preferred for password\n hashing and password-based key derivation, but it is slower as it makes more passes over\n the memory to protect from tradeoff attacks.",null,false],[0,0,0,"argon2id",null," Argon2id is a hybrid of Argon2i and Argon2d, using a combination of data-depending and\n data-independent memory accesses, which gives some of Argon2i's resistance to side-channel\n cache timing attacks and much of Argon2d's resistance to GPU cracking attacks.",null,false],[163,53,0,null,null," Argon2 parameters",[19011,19012,19014,19016,19018],false],[163,54,0,null,null,null,null,false],[163,80,0,null,null," Baseline parameters for interactive logins using argon2i type",null,false],[163,82,0,null,null," Baseline parameters for normal usage using argon2i type",null,false],[163,84,0,null,null," Baseline parameters for offline usage using argon2i type",null,false],[163,87,0,null,null," Baseline parameters for interactive logins using argon2id type",null,false],[163,89,0,null,null," Baseline parameters for normal usage using argon2id type",null,false],[163,91,0,null,null," Baseline parameters for offline usage using argon2id type",null,false],[163,94,0,null,null," Create parameters from ops and mem limits, where mem_limit given in bytes",[19009,19010],false],[0,0,0,"ops_limit",null,"",null,false],[0,0,0,"mem_limit",null,"",null,false],[0,0,0,"t",null," A [t]ime cost, which defines the amount of computation realized and therefore the execution\n time, given in number of iterations.",null,false],[0,0,0,"m",null," A [m]emory cost, which defines the memory usage, given in kibibytes.",null,false],[163,53,0,null,null,null,null,false],[0,0,0,"p",null," A [p]arallelism degree, which defines the number of parallel threads.",null,false],[163,53,0,null,null,null,null,false],[0,0,0,"secret",null," The [secret] parameter, which is used for keyed hashing. This allows a secret key to be input\n at hashing time (from some external location) and be folded into the value of the hash. This\n means that even if your salts and hashes are compromised, an attacker cannot brute-force to\n find the password without the key.",null,false],[163,53,0,null,null,null,null,false],[0,0,0,"ad",null," The [ad] parameter, which is used to fold any additional data into the hash value. Functionally,\n this behaves almost exactly like the secret or salt parameters; the ad parameter is folding\n into the value of the hash. However, this parameter is used for different data. The salt\n should be a random string stored alongside your password. The secret should be a random key\n only usable at hashing time. The ad is for any other data.",null,false],[163,101,0,null,null,null,[19020,19021,19022,19023,19024],false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"dk_len",null,"",null,false],[0,0,0,"mode",null,"",null,false],[163,139,0,null,null,null,[19026,19027],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in",null,"",null,false],[163,175,0,null,null,null,[19029,19030,19031,19032],false],[0,0,0,"blocks",null,"",null,false],[0,0,0,"h0",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"threads",null,"",null,false],[163,201,0,null,null,null,[19034,19035,19036,19037,19038,19039],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"blocks",null,"",null,false],[0,0,0,"time",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"threads",null,"",null,false],[0,0,0,"mode",null,"",null,false],[163,219,0,null,null,null,[19041,19042,19043,19044,19045,19046,19047],false],[0,0,0,"blocks",null,"",null,false],[0,0,0,"time",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"threads",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"lanes",null,"",null,false],[0,0,0,"segments",null,"",null,false],[163,240,0,null,null,null,[19049,19050,19051,19052,19053,19054,19055,19056],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"blocks",null,"",null,false],[0,0,0,"time",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"threads",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"lanes",null,"",null,false],[0,0,0,"segments",null,"",null,false],[163,273,0,null,null,null,[19058,19059,19060,19061,19062,19063,19064,19065,19066,19067],false],[0,0,0,"blocks",null,"",null,false],[0,0,0,"passes",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"threads",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"lanes",null,"",null,false],[0,0,0,"segments",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"slice",null,"",null,false],[0,0,0,"lane",null,"",null,false],[163,330,0,null,null,null,[19069,19070,19071],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in1",null,"",null,false],[0,0,0,"in2",null,"",null,false],[163,338,0,null,null,null,[19073,19074,19075],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in1",null,"",null,false],[0,0,0,"in2",null,"",null,false],[163,346,0,null,null,null,[19077,19078,19079,19080],false],[0,0,0,"out",null,"",null,false],[0,0,0,"in1",null,"",null,false],[0,0,0,"in2",null,"",null,false],[0,0,0,"xor",null,"",null,true],[163,386,0,null,null,null,[19082,19083,19084,19085],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"d",null,null,null,false],[163,388,0,null,null,null,[19087,19088,19089,19090],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[163,392,0,null,null,null,[19092,19093],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[163,397,0,null,null,null,[19095],false],[0,0,0,"x",null,"",null,false],[163,420,0,null,null,null,[19097,19098,19099,19100],false],[0,0,0,"blocks",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"threads",null,"",null,false],[0,0,0,"out",null,"",null,false],[163,440,0,null,null,null,[19102,19103,19104,19105,19106,19107,19108,19109],false],[0,0,0,"rand",null,"",null,false],[0,0,0,"lanes",null,"",null,false],[0,0,0,"segments",null,"",null,false],[0,0,0,"threads",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"slice",null,"",null,false],[0,0,0,"lane",null,"",null,false],[0,0,0,"index",null,"",null,false],[163,480,0,null,null," Derives a key from the password, salt, and argon2 parameters.\n\n Derived key has to be at least 4 bytes length.\n\n Salt has to be at least 8 bytes length.",[19111,19112,19113,19114,19115,19116],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"derived_key",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"mode",null,"",null,false],[163,511,0,null,null,null,[],false],[163,512,0,null,null,null,null,false],[163,514,0,null,null,null,[19121,19123,19124,19125,19127,19129,19131],false],[163,514,0,null,null,null,null,false],[0,0,0,"alg_id",null,null,null,false],[163,514,0,null,null,null,null,false],[0,0,0,"alg_version",null,null,null,false],[0,0,0,"m",null,null,null,false],[0,0,0,"t",null,null,null,false],[163,514,0,null,null,null,null,false],[0,0,0,"p",null,null,null,false],[163,514,0,null,null,null,null,false],[0,0,0,"salt",null,null,null,false],[163,514,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[163,524,0,null,null,null,[19133,19134,19135,19136,19137],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"buf",null,"",null,false],[163,550,0,null,null,null,[19139,19140,19141],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[163,579,0,null,null," Options for hashing a password.\n\n Allocator is required for argon2.\n\n Only phc encoding is supported.",[19144,19146,19148,19150],false],[163,579,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[163,579,0,null,null,null,null,false],[0,0,0,"params",null,null,null,false],[163,579,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[163,579,0,null,null,null,null,false],[0,0,0,"encoding",null,null,null,false],[163,588,0,null,null," Compute a hash of a password using the argon2 key derivation function.\n The function returns a string that includes all the parameters required for verification.",[19152,19153,19154],false],[0,0,0,"password",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"out",null,"",null,false],[163,609,0,null,null," Options for hash verification.\n\n Allocator is required for argon2.",[19157],false],[163,609,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[163,614,0,null,null," Verify that a previously computed hash is valid for a given password.",[19159,19160,19161],false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"options",null,"",null,false],[115,135,0,null,null,null,null,false],[0,0,0,"crypto/bcrypt.zig",null,"",[],false],[164,0,0,null,null,null,null,false],[164,1,0,null,null,null,null,false],[164,2,0,null,null,null,null,false],[164,3,0,null,null,null,null,false],[164,4,0,null,null,null,null,false],[164,5,0,null,null,null,null,false],[164,6,0,null,null,null,null,false],[164,7,0,null,null,null,null,false],[164,8,0,null,null,null,null,false],[164,9,0,null,null,null,null,false],[164,10,0,null,null,null,null,false],[164,11,0,null,null,null,null,false],[164,13,0,null,null,null,null,false],[0,0,0,"phc_encoding.zig",null,"",[],false],[165,2,0,null,null,null,null,false],[165,3,0,null,null,null,null,false],[165,4,0,null,null,null,null,false],[165,5,0,null,null,null,null,false],[165,6,0,null,null,null,null,false],[165,8,0,null,null,null,null,false],[165,9,0,null,null,null,null,false],[165,10,0,null,null,null,null,false],[165,11,0,null,null,null,null,false],[165,12,0,null,null,null,null,false],[165,13,0,null,null,null,null,false],[165,14,0,null,null,null,null,false],[165,16,0,null,null,null,null,false],[165,18,0,null,null,null,null,false],[165,19,0,null,null,null,null,false],[165,27,0,null,null," A wrapped binary value whose maximum size is `max_len`.\n\n This type must be used whenever a binary value is encoded in a PHC-formatted string.\n This includes `salt`, `hash`, and any other binary parameters such as keys.\n\n Once initialized, the actual value can be read with the `constSlice()` function.",[19194],false],[0,0,0,"max_len",null,"",[19209,19210],true],[165,29,0,null,null,null,null,false],[165,30,0,null,null,null,null,false],[165,31,0,null,null,null,null,false],[165,37,0,null,null," Wrap an existing byte slice",[19199],false],[0,0,0,"slice",null,"",null,false],[165,46,0,null,null," Return the slice containing the actual value.",[19201],false],[0,0,0,"self",null,"",null,false],[165,50,0,null,null,null,[19203,19204],false],[0,0,0,"self",null,"",null,false],[0,0,0,"str",null,"",null,false],[165,57,0,null,null,null,[19206,19207],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[165,28,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"len",null,null,null,false],[165,76,0,null,null," Deserialize a PHC-formatted string into a structure `HashResult`.\n\n Required field in the `HashResult` structure:\n   - `alg_id`: algorithm identifier\n Optional, special fields:\n   - `alg_version`: algorithm version (unsigned integer)\n   - `salt`: salt\n   - `hash`: output of the hash function\n\n Other fields will also be deserialized from the function parameters section.",[19212,19213],false],[0,0,0,"HashResult",null,"",null,true],[0,0,0,"str",null,"",null,false],[165,185,0,null,null," Serialize parameters into a PHC string.\n\n Required field for `params`:\n   - `alg_id`: algorithm identifier\n Optional, special fields:\n   - `alg_version`: algorithm version (unsigned integer)\n   - `salt`: salt\n   - `hash`: output of the hash function\n\n `params` can also include any additional parameters.",[19215,19216],false],[0,0,0,"params",null,"",null,false],[0,0,0,"str",null,"",null,false],[165,192,0,null,null," Compute the number of bytes required to serialize `params`",[19218],false],[0,0,0,"params",null,"",null,false],[165,198,0,null,null,null,[19220,19221],false],[0,0,0,"params",null,"",null,false],[0,0,0,"out",null,"",null,false],[165,256,0,null,null,null,[19223],false],[0,0,0,"str",null,"",[19225,19227],false],[165,256,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[165,256,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[164,15,0,null,null,null,null,false],[164,16,0,null,null,null,null,false],[164,17,0,null,null,null,null,false],[164,18,0,null,null,null,null,false],[164,20,0,null,null,null,null,false],[164,21,0,null,null,null,null,false],[164,22,0,null,null,null,null,false],[164,23,0,null,null,null,null,false],[164,24,0,null,null,null,null,false],[164,27,0,null,null," Length (in bytes) of a password hash in crypt encoding",null,false],[164,29,0,null,null,null,[19264,19266],false],[164,305,0,null,null,null,[19240,19241],false],[0,0,0,"data",null,"",null,false],[0,0,0,"current",null,"",null,false],[164,318,0,null,null,null,[19243,19244],false],[0,0,0,"state",null,"",null,false],[0,0,0,"key",null,"",null,false],[164,344,0,null,null,null,[19246,19247,19248],false],[0,0,0,"state",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"key",null,"",null,false],[164,375,0,null,null,null,[19250,19251],false],[0,0,0,"l",null,null,null,false],[0,0,0,"r",null,null,null,false],[164,377,0,null,null,null,[19253,19254,19255,19256],false],[0,0,0,"state",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"j",null,"",null,false],[0,0,0,"n",null,"",null,false],[164,385,0,null,null,null,[19258,19259],false],[0,0,0,"state",null,"",null,false],[0,0,0,"halves",null,"",null,false],[164,396,0,null,null,null,[19261,19262],false],[0,0,0,"state",null,"",null,false],[0,0,0,"data",null,"",null,false],[164,29,0,null,null,null,null,false],[0,0,0,"sboxes",null,null,null,false],[164,29,0,null,null,null,null,false],[0,0,0,"subkeys",null,null,null,false],[164,409,0,null,null," bcrypt parameters",[19269],false],[164,409,0,null,null,null,null,false],[0,0,0,"rounds_log",null," log2 of the number of rounds",null,false],[164,423,0,null,null," Compute a hash of a password using 2^rounds_log rounds of the bcrypt key stretching function.\n bcrypt is a computationally expensive and cache-hard function, explicitly designed to slow down exhaustive searches.\n\n The function returns the hash as a `dk_length` byte array, that doesn't include anything besides the hash output.\n\n For a generic key-derivation function, use `bcrypt.pbkdf()` instead.\n\n IMPORTANT: by design, bcrypt silently truncates passwords to 72 bytes.\n If this is an issue for your application, use `bcryptWithoutTruncation` instead.",[19271,19272,19273],false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"params",null,"",null,false],[164,466,0,null,null," Compute a hash of a password using 2^rounds_log rounds of the bcrypt key stretching function.\n bcrypt is a computationally expensive and cache-hard function, explicitly designed to slow down exhaustive searches.\n\n The function returns the hash as a `dk_length` byte array, that doesn't include anything besides the hash output.\n\n For a generic key-derivation function, use `bcrypt.pbkdf()` instead.\n\n This function is identical to `bcrypt`, except that it doesn't silently truncate passwords.\n Instead, passwords longer than 72 bytes are pre-hashed using HMAC-SHA512 before being passed to bcrypt.",[19275,19276,19277],false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"params",null,"",null,false],[164,485,0,null,null,null,[19297,19299],false],[164,486,0,null,null,null,null,false],[164,487,0,null,null,null,null,false],[164,492,0,null,null,null,[19282,19283,19284],false],[0,0,0,"out",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"key",null,"",null,false],[164,498,0,null,null,null,[19286],false],[0,0,0,"key",null,"",null,false],[164,505,0,null,null,null,[19288,19289],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[164,509,0,null,null,null,[19291,19292],false],[0,0,0,"self",null,"",null,false],[0,0,0,"out",null,"",null,false],[164,517,0,null,null," Matches OpenBSD function\n https://github.com/openbsd/src/blob/6df1256b7792691e66c2ed9d86a8c103069f9e34/lib/libutil/bcrypt_pbkdf.c#L98",[19294,19295],false],[0,0,0,"sha2pass",null,"",null,false],[0,0,0,"sha2salt",null,"",null,false],[164,485,0,null,null,null,null,false],[0,0,0,"hasher",null,null,null,false],[164,485,0,null,null,null,null,false],[0,0,0,"sha2pass",null,null,null,false],[164,565,0,null,null," bcrypt-pbkdf is a key derivation function based on bcrypt.\n This is the function used in OpenSSH to derive encryption keys from passphrases.\n\n This implementation is compatible with the OpenBSD implementation (https://github.com/openbsd/src/blob/master/lib/libutil/bcrypt_pbkdf.c).\n\n Unlike the password hashing function `bcrypt`, this function doesn't silently truncate passwords longer than 72 bytes.",[19301,19302,19303,19304],false],[0,0,0,"pass",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"rounds",null,"",null,false],[164,569,0,null,null,null,[],false],[164,571,0,null,null," String prefix for bcrypt",null,false],[164,574,0,null,null,null,null,false],[164,575,0,null,null,null,[19310,19312],false],[164,844,0,null,null,null,null,false],[0,0,0,"Encoder",null,null,null,false],[164,844,0,null,null,null,null,false],[0,0,0,"Decoder",null,null,[19314,19316],false],[164,575,0,null,null,null,null,false],[0,0,0,"Encoder",null,null,null,false],[164,575,0,null,null,null,null,false],[0,0,0,"Decoder",null,null,[19318,19320],false],[164,575,0,null,null,null,null,false],[0,0,0,"Encoder",null,null,null,false],[164,575,0,null,null,null,null,false],[0,0,0,"Decoder",null,null,null,false],[164,580,0,null,null,null,[19322,19323,19324,19325],false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"silently_truncate_password",null,"",null,false],[164,606,0,null,null," Hash and verify passwords using the PHC format.",[],false],[164,607,0,null,null,null,null,false],[164,608,0,null,null,null,null,false],[164,610,0,null,null,null,[19331,19333,19335,19337],false],[164,610,0,null,null,null,null,false],[0,0,0,"alg_id",null,null,null,false],[164,610,0,null,null,null,null,false],[0,0,0,"r",null,null,null,false],[164,610,0,null,null,null,null,false],[0,0,0,"salt",null,null,null,false],[164,610,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[164,618,0,null,null," Return a non-deterministic hash of the password encoded as a PHC-format string",[19339,19340,19341,19342],false],[0,0,0,"password",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"silently_truncate_password",null,"",null,false],[0,0,0,"buf",null,"",null,false],[164,638,0,null,null," Verify a password against a PHC-format encoded string",[19344,19345,19346],false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"silently_truncate_password",null,"",null,false],[164,658,0,null,null," Hash and verify passwords using the modular crypt format.",[],false],[164,660,0,null,null," Length of a string returned by the create() function",null,false],[164,663,0,null,null," Return a non-deterministic hash of the password encoded into the modular crypt format",[19350,19351,19352,19353],false],[0,0,0,"password",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"silently_truncate_password",null,"",null,false],[0,0,0,"buf",null,"",null,false],[164,681,0,null,null," Verify a password against a string in modular crypt format",[19355,19356,19357],false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"silently_truncate_password",null,"",null,false],[164,703,0,null,null," Options for hashing a password.",[19360,19362,19364,19365],false],[164,703,0,null,null,null,null,false],[0,0,0,"allocator",null," For `bcrypt`, that can be left to `null`.",null,false],[164,703,0,null,null,null,null,false],[0,0,0,"params",null," Internal bcrypt parameters.",null,false],[164,703,0,null,null,null,null,false],[0,0,0,"encoding",null," Encoding to use for the output of the hash function.",null,false],[0,0,0,"silently_truncate_password",null," Whether to silently truncate the password to 72 bytes, or pre-hash the password when it is longer.\n The default is `true`, for compatibility with the original bcrypt implementation.",null,false],[164,722,0,null,null," Compute a hash of a password using 2^rounds_log rounds of the bcrypt key stretching function.\n bcrypt is a computationally expensive and cache-hard function, explicitly designed to slow down exhaustive searches.\n\n The function returns a string that includes all the parameters required for verification.\n\n IMPORTANT: by design, bcrypt silently truncates passwords to 72 bytes.\n If this is an issue for your application, set the `silently_truncate_password` option to `false`.",[19367,19368,19369],false],[0,0,0,"password",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"out",null,"",null,false],[164,734,0,null,null," Options for hash verification.",[19372,19373],false],[164,734,0,null,null,null,null,false],[0,0,0,"allocator",null," For `bcrypt`, that can be left to `null`.",null,false],[0,0,0,"silently_truncate_password",null," Whether to silently truncate the password to 72 bytes, or pre-hash the password when it is longer.",null,false],[164,742,0,null,null," Verify that a previously computed hash is valid for a given password.",[19375,19376,19377],false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"options",null,"",null,false],[115,136,0,null,null,null,null,false],[0,0,0,"crypto/scrypt.zig",null,"",[],false],[166,4,0,null,null,null,null,false],[166,5,0,null,null,null,null,false],[166,6,0,null,null,null,null,false],[166,7,0,null,null,null,null,false],[166,8,0,null,null,null,null,false],[166,9,0,null,null,null,null,false],[166,10,0,null,null,null,null,false],[166,11,0,null,null,null,null,false],[166,13,0,null,null,null,null,false],[166,15,0,null,null,null,null,false],[166,16,0,null,null,null,null,false],[166,17,0,null,null,null,null,false],[166,18,0,null,null,null,null,false],[166,19,0,null,null,null,null,false],[166,21,0,null,null,null,null,false],[166,22,0,null,null,null,null,false],[166,23,0,null,null,null,null,false],[166,24,0,null,null,null,null,false],[166,25,0,null,null,null,null,false],[166,26,0,null,null,null,null,false],[166,28,0,null,null,null,[19401,19402,19403],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"n",null,"",null,false],[166,32,0,null,null,null,[19405,19406,19407],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"n",null,"",null,false],[166,38,0,null,null,null,[19409,19410,19411,19413],false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[166,38,0,null,null,null,null,false],[0,0,0,"d",null,null,null,false],[166,40,0,null,null,null,[19415,19416,19417,19418],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"d",null,"",null,false],[166,44,0,null,null,null,[19420],false],[0,0,0,"b",null,"",null,false],[166,68,0,null,null,null,[19422,19423,19424],false],[0,0,0,"tmp",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"out",null,"",null,false],[166,74,0,null,null,null,[19426,19427,19428,19429],false],[0,0,0,"tmp",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"r",null,"",null,false],[166,83,0,null,null,null,[19431,19432],false],[0,0,0,"b",null,"",null,false],[0,0,0,"r",null,"",null,false],[166,88,0,null,null,null,[19434,19435,19436,19437,19438],false],[0,0,0,"b",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"v",null,"",null,false],[0,0,0,"xy",null,"",null,false],[166,123,0,null,null," Scrypt parameters",[19447,19449,19451],false],[166,124,0,null,null,null,null,false],[166,138,0,null,null," Baseline parameters for interactive logins",null,false],[166,141,0,null,null," Baseline parameters for offline usage",null,false],[166,144,0,null,null," Create parameters from ops and mem limits, where mem_limit given in bytes",[19444,19445],false],[0,0,0,"ops_limit",null,"",null,false],[0,0,0,"mem_limit",null,"",null,false],[166,123,0,null,null,null,null,false],[0,0,0,"ln",null," The CPU/Memory cost parameter [ln] is log2(N).",null,false],[166,123,0,null,null,null,null,false],[0,0,0,"r",null," The [r]esource usage parameter specifies the block size.",null,false],[166,123,0,null,null,null,null,false],[0,0,0,"p",null," The [p]arallelization parameter.\n A large value of [p] can be used to increase the computational cost of scrypt without\n increasing the memory usage.",null,false],[166,174,0,null,null," Apply scrypt to generate a key from a password.\n\n scrypt is defined in RFC 7914.\n\n allocator: mem.Allocator.\n\n derived_key: Slice of appropriate size for generated key. Generally 16 or 32 bytes in length.\n              May be uninitialized. All bytes will be overwritten.\n              Maximum size is `derived_key.len / 32 == 0xffff_ffff`.\n\n password: Arbitrary sequence of bytes of any length.\n\n salt: Arbitrary sequence of bytes of any length.\n\n params: Params.",[19453,19454,19455,19456,19457],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"derived_key",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"params",null,"",null,false],[166,208,0,null,null,null,[],false],[166,210,0,null,null," String prefix for scrypt",null,false],[166,213,0,null,null," Standard type for a set of scrypt parameters, with the salt and hash.",[19461],false],[0,0,0,"crypt_max_hash_len",null,"",[19463,19465,19467,19469,19471],true],[166,214,0,null,null,null,null,false],[0,0,0,"ln",null,null,null,false],[166,214,0,null,null,null,null,false],[0,0,0,"r",null,null,null,false],[166,214,0,null,null,null,null,false],[0,0,0,"p",null,null,null,false],[166,214,0,null,null,null,null,false],[0,0,0,"salt",null,null,null,false],[166,214,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[166,223,0,null,null,null,null,false],[166,231,0,null,null," A wrapped binary value whose maximum size is `max_len`.\n\n This type must be used whenever a binary value is encoded in a PHC-formatted string.\n This includes `salt`, `hash`, and any other binary parameters such as keys.\n\n Once initialized, the actual value can be read with the `constSlice()` function.",[19474],false],[0,0,0,"max_len",null,"",[19489,19490],true],[166,233,0,null,null,null,null,false],[166,234,0,null,null,null,null,false],[166,235,0,null,null,null,null,false],[166,241,0,null,null," Wrap an existing byte slice",[19479],false],[0,0,0,"slice",null,"",null,false],[166,250,0,null,null," Return the slice containing the actual value.",[19481],false],[0,0,0,"self",null,"",null,false],[166,254,0,null,null,null,[19483,19484],false],[0,0,0,"self",null,"",null,false],[0,0,0,"str",null,"",null,false],[166,261,0,null,null,null,[19486,19487],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[166,232,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"len",null,null,null,false],[166,273,0,null,null," Expand binary data into a salt for the modular crypt format.",[19492,19493],false],[0,0,0,"len",null,"",null,true],[0,0,0,"salt",null,"",null,false],[166,280,0,null,null," Deserialize a string into a structure `T` (matching `HashResult`).",[19495,19496],false],[0,0,0,"T",null,"",null,true],[0,0,0,"str",null,"",null,false],[166,301,0,null,null," Serialize parameters into a string in modular crypt format.",[19498,19499],false],[0,0,0,"params",null,"",null,false],[0,0,0,"str",null,"",null,false],[166,308,0,null,null," Compute the number of bytes required to serialize `params`",[19501],false],[0,0,0,"params",null,"",null,false],[166,314,0,null,null,null,[19503,19504],false],[0,0,0,"params",null,"",null,false],[0,0,0,"out",null,"",null,false],[166,330,0,null,null," Custom codec that maps 6 bits into 8 like regular Base64, but uses its own alphabet,\n encodes bits in little-endian, and can also encode integers.",[19506],false],[0,0,0,"map",null,"",[],true],[166,332,0,null,null,null,null,false],[166,334,0,null,null,null,[19509],false],[0,0,0,"len",null,"",null,false],[166,338,0,null,null,null,[19511],false],[0,0,0,"len",null,"",null,false],[166,342,0,null,null,null,[19513,19514],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[166,350,0,null,null,null,[19516,19517],false],[0,0,0,"T",null,"",null,true],[0,0,0,"src",null,"",null,false],[166,359,0,null,null,null,[19519,19520],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[166,375,0,null,null,null,[19522,19523],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[166,393,0,null,null," Hash and verify passwords using the PHC format.",[],false],[166,394,0,null,null,null,null,false],[166,395,0,null,null,null,null,false],[166,397,0,null,null,null,[19529,19531,19533,19535,19537,19539],false],[166,397,0,null,null,null,null,false],[0,0,0,"alg_id",null,null,null,false],[166,397,0,null,null,null,null,false],[0,0,0,"ln",null,null,null,false],[166,397,0,null,null,null,null,false],[0,0,0,"r",null,null,null,false],[166,397,0,null,null,null,null,false],[0,0,0,"p",null,null,null,false],[166,397,0,null,null,null,null,false],[0,0,0,"salt",null,null,null,false],[166,397,0,null,null,null,null,false],[0,0,0,"hash",null,null,null,false],[166,407,0,null,null," Return a non-deterministic hash of the password encoded as a PHC-format string",[19541,19542,19543,19544],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"buf",null,"",null,false],[166,430,0,null,null," Verify a password against a PHC-format encoded string",[19546,19547,19548],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[166,448,0,null,null," Hash and verify passwords using the modular crypt format.",[],false],[166,449,0,null,null,null,null,false],[166,450,0,null,null,null,null,false],[166,453,0,null,null," Length of a string returned by the create() function",null,false],[166,456,0,null,null," Return a non-deterministic hash of the password encoded into the modular crypt format",[19554,19555,19556,19557],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"params",null,"",null,false],[0,0,0,"buf",null,"",null,false],[166,479,0,null,null," Verify a password against a string in modular crypt format",[19559,19560,19561],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[166,498,0,null,null," Options for hashing a password.\n\n Allocator is required for scrypt.",[19564,19566,19568],false],[166,498,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[166,498,0,null,null,null,null,false],[0,0,0,"params",null,null,null,false],[166,498,0,null,null,null,null,false],[0,0,0,"encoding",null,null,null,false],[166,506,0,null,null," Compute a hash of a password using the scrypt key derivation function.\n The function returns a string that includes all the parameters required for verification.",[19570,19571,19572],false],[0,0,0,"password",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"out",null,"",null,false],[166,521,0,null,null," Options for hash verification.\n\n Allocator is required for scrypt.",[19575],false],[166,521,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[166,526,0,null,null," Verify that a previously computed hash is valid for a given password.",[19577,19578,19579],false],[0,0,0,"str",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"options",null,"",null,false],[166,540,0,null,null,null,null,false],[115,137,0,null,null,null,null,false],[0,0,0,"crypto/pbkdf2.zig",null,"",[],false],[167,0,0,null,null,null,null,false],[167,1,0,null,null,null,null,false],[167,2,0,null,null,null,null,false],[167,3,0,null,null,null,null,false],[167,4,0,null,null,null,null,false],[167,52,0,null,null," Apply PBKDF2 to generate a key from a password.\n\n PBKDF2 is defined in RFC 2898, and is a recommendation of NIST SP 800-132.\n\n dk: Slice of appropriate size for generated key. Generally 16 or 32 bytes in length.\n             May be uninitialized. All bytes will be overwritten.\n             Maximum size is `maxInt(u32) * Hash.digest_length`\n             It is a programming error to pass buffer longer than the maximum size.\n\n password: Arbitrary sequence of bytes of any length, including empty.\n\n salt: Arbitrary sequence of bytes of any length, including empty. A common length is 8 bytes.\n\n rounds: Iteration count. Must be greater than 0. Common values range from 1,000 to 100,000.\n         Larger iteration counts improve security by increasing the time required to compute\n         the dk. It is common to tune this parameter to achieve approximately 100ms.\n\n Prf: Pseudo-random function to use. A common choice is `std.crypto.auth.hmac.sha2.HmacSha256`.",[19589,19590,19591,19592,19593],false],[0,0,0,"dk",null,"",null,false],[0,0,0,"password",null,"",null,false],[0,0,0,"salt",null,"",null,false],[0,0,0,"rounds",null,"",null,false],[0,0,0,"Prf",null,"",null,true],[167,147,0,null,null,null,null,false],[167,148,0,null,null,null,null,false],[115,139,0,null,null,null,null,false],[115,143,0,null,null," Digital signature functions.",[],false],[115,144,0,null,null,null,null,false],[0,0,0,"crypto/25519/ed25519.zig",null,"",[],false],[168,0,0,null,null,null,null,false],[168,1,0,null,null,null,null,false],[168,2,0,null,null,null,null,false],[168,3,0,null,null,null,null,false],[168,4,0,null,null,null,null,false],[168,5,0,null,null,null,null,false],[168,7,0,null,null,null,null,false],[168,9,0,null,null,null,null,false],[168,10,0,null,null,null,null,false],[168,11,0,null,null,null,null,false],[168,12,0,null,null,null,null,false],[168,13,0,null,null,null,null,false],[168,14,0,null,null,null,null,false],[168,17,0,null,null," Ed25519 (EdDSA) signatures.",[],false],[168,19,0,null,null," The underlying elliptic curve.",null,false],[168,22,0,null,null," Length (in bytes) of optional random bytes, for non-deterministic signatures.",null,false],[168,24,0,null,null,null,null,false],[168,25,0,null,null,null,null,false],[168,28,0,null,null," An Ed25519 secret key.",[19635],false],[168,30,0,null,null," Length (in bytes) of a raw secret key.",null,false],[168,35,0,null,null," Return the seed used to generate this secret key.",[19621],false],[0,0,0,"self",null,"",null,false],[168,40,0,null,null," Return the raw public key bytes corresponding to this secret key.",[19623],false],[0,0,0,"self",null,"",null,false],[168,45,0,null,null," Create a secret key from raw bytes.",[19625],false],[0,0,0,"bytes",null,"",null,false],[168,50,0,null,null," Return the secret key as raw bytes.",[19627],false],[0,0,0,"sk",null,"",null,false],[168,55,0,null,null,null,[19629],false],[0,0,0,"self",null,"",[19631,19633],false],[168,55,0,null,null,null,null,false],[0,0,0,"scalar",null,null,null,false],[168,55,0,null,null,null,null,false],[0,0,0,"prefix",null,null,null,false],[168,28,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[168,70,0,null,null," A Signer is used to incrementally compute a signature.\n It can be obtained from a `KeyPair`, using the `signer()` function.",[19647,19649,19651,19653],false],[168,76,0,null,null,null,[19638,19639,19640],false],[0,0,0,"scalar",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[168,90,0,null,null," Add new data to the message being signed.",[19642,19643],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data",null,"",null,false],[168,95,0,null,null," Compute a signature over the entire message.",[19645],false],[0,0,0,"self",null,"",null,false],[168,70,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[168,70,0,null,null,null,null,false],[0,0,0,"scalar",null,null,null,false],[168,70,0,null,null,null,null,false],[0,0,0,"nonce",null,null,null,false],[168,70,0,null,null,null,null,false],[0,0,0,"r_bytes",null,null,null,false],[168,107,0,null,null," An Ed25519 public key.",[19672],false],[168,109,0,null,null," Length (in bytes) of a raw public key.",null,false],[168,114,0,null,null," Create a public key from raw bytes.",[19657],false],[0,0,0,"bytes",null,"",null,false],[168,120,0,null,null," Convert a public key to raw bytes.",[19659],false],[0,0,0,"pk",null,"",null,false],[168,124,0,null,null,null,[19661,19662,19663,19664],false],[0,0,0,"public_key",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[0,0,0,"nonce",null,"",null,false],[168,130,0,null,null,null,[19666,19667,19668,19669,19670],false],[0,0,0,"public_key",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"noise",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[168,107,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[168,148,0,null,null," A Verifier is used to incrementally verify a signature.\n It can be obtained from a `Signature`, using the `verifier()` function.",[19683,19685,19687,19689],false],[168,154,0,null,null,null,[19675,19676],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[168,172,0,null,null," Add new content to the message to be verified.",[19678,19679],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[168,177,0,null,null," Verify that the signature is valid for the entire message.",[19681],false],[0,0,0,"self",null,"",null,false],[168,148,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[168,148,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[168,148,0,null,null,null,null,false],[0,0,0,"a",null,null,null,false],[168,148,0,null,null,null,null,false],[0,0,0,"expected_r",null,null,null,false],[168,190,0,null,null," An Ed25519 signature.",[19704,19706],false],[168,192,0,null,null," Length (in bytes) of a raw signature.",null,false],[168,200,0,null,null," Return the raw signature (r, s) in little-endian format.",[19693],false],[0,0,0,"self",null,"",null,false],[168,209,0,null,null," Create a signature from a raw encoding of (r, s).\n EdDSA always assumes little-endian.",[19695],false],[0,0,0,"bytes",null,"",null,false],[168,217,0,null,null," Create a Verifier for incremental verification of a signature.",[19697,19698],false],[0,0,0,"self",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[168,224,0,null,null," Verify the signature against a message and public key.\n Return IdentityElement or NonCanonical if the public key or signature are not in the expected range,\n or SignatureVerificationError if the signature is invalid for the given message and key.",[19700,19701,19702],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[168,190,0,null,null,null,null,false],[0,0,0,"r",null," The R component of an EdDSA signature.",null,false],[168,190,0,null,null,null,null,false],[0,0,0,"s",null," The S component of an EdDSA signature.",null,false],[168,232,0,null,null," An Ed25519 key pair.",[19721,19723],false],[168,234,0,null,null," Length (in bytes) of a seed required to create a key pair.",null,false],[168,249,0,null,null," Derive a key pair from an optional secret seed.\n\n As in RFC 8032, an Ed25519 public key is generated by hashing\n the secret key using the SHA-512 function, and interpreting the\n bit-swapped, clamped lower-half of the output as the secret scalar.\n\n For this reason, an EdDSA secret key is commonly called a seed,\n from which the actual secret is derived.",[19710],false],[0,0,0,"seed",null,"",null,false],[168,275,0,null,null," Create a KeyPair from a secret key.\n Note that with EdDSA, storing the seed, and recovering the key pair\n from it is recommended over storing the entire secret key.\n The seed of an exiting key pair can be obtained with\n `key_pair.secret_key.seed()`.",[19712],false],[0,0,0,"secret_key",null,"",null,false],[168,294,0,null,null," Sign a message using the key pair.\n The noise can be null in order to create deterministic signatures.\n If deterministic signatures are not required, the noise should be randomly generated instead.\n This helps defend against fault attacks.",[19714,19715,19716],false],[0,0,0,"key_pair",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"noise",null,"",null,false],[168,311,0,null,null," Create a Signer, that can be used for incremental signing.\n Note that the signature is not deterministic.\n The noise parameter, if set, should be something unique for each message,\n such as a random nonce, or a counter.",[19718,19719],false],[0,0,0,"key_pair",null,"",null,false],[0,0,0,"noise",null,"",null,false],[168,232,0,null,null,null,null,false],[0,0,0,"public_key",null," Public part.",null,false],[168,232,0,null,null,null,null,false],[0,0,0,"secret_key",null," Secret scalar.",null,false],[168,333,0,null,null," A (signature, message, public_key) tuple for batch verification",[19726,19728,19730],false],[168,333,0,null,null,null,null,false],[0,0,0,"sig",null,null,null,false],[168,333,0,null,null,null,null,false],[0,0,0,"msg",null,null,null,false],[168,333,0,null,null,null,null,false],[0,0,0,"public_key",null,null,null,false],[168,340,0,null,null," Verify several signatures in a single operation, much faster than verifying signatures one-by-one",[19732,19733],false],[0,0,0,"count",null,"",null,true],[0,0,0,"signature_batch",null,"",null,false],[168,400,0,null,null," Ed25519 signatures with key blinding.",[],false],[168,402,0,null,null," Length (in bytes) of a blinding seed.",null,false],[168,405,0,null,null," A blind secret key.",[19738,19740,19742],false],[168,405,0,null,null,null,null,false],[0,0,0,"prefix",null,null,null,false],[168,405,0,null,null,null,null,false],[0,0,0,"blind_scalar",null,null,null,false],[168,405,0,null,null,null,null,false],[0,0,0,"blind_public_key",null,null,null,false],[168,412,0,null,null," A blind public key.",[19749],false],[168,417,0,null,null," Recover a public key from a blind version of it.",[19745,19746,19747],false],[0,0,0,"blind_public_key",null,"",null,false],[0,0,0,"blind_seed",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[168,412,0,null,null,null,null,false],[0,0,0,"key",null," Public key equivalent, that can used for signature verification.",null,false],[168,426,0,null,null," A blind key pair.",[19760,19762],false],[168,431,0,null,null," Create an blind key pair from an existing key pair, a blinding seed and a context.",[19752,19753,19754],false],[0,0,0,"key_pair",null,"",null,false],[0,0,0,"blind_seed",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[168,463,0,null,null," Sign a message using a blind key pair, and optional random noise.\n Having noise creates non-standard, non-deterministic signatures,\n but has been proven to increase resilience against fault attacks.",[19756,19757,19758],false],[0,0,0,"key_pair",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"noise",null,"",null,false],[168,426,0,null,null,null,null,false],[0,0,0,"blind_public_key",null,null,null,false],[168,426,0,null,null,null,null,false],[0,0,0,"blind_secret_key",null,null,null,false],[168,473,0,null,null," Compute a blind context from a blinding seed and a context.",[19764,19765],false],[0,0,0,"blind_seed",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[115,145,0,null,null,null,null,false],[0,0,0,"crypto/ecdsa.zig",null,"",[],false],[169,0,0,null,null,null,null,false],[169,1,0,null,null,null,null,false],[169,2,0,null,null,null,null,false],[169,3,0,null,null,null,null,false],[169,4,0,null,null,null,null,false],[169,5,0,null,null,null,null,false],[169,6,0,null,null,null,null,false],[169,8,0,null,null,null,null,false],[169,9,0,null,null,null,null,false],[169,10,0,null,null,null,null,false],[169,11,0,null,null,null,null,false],[169,14,0,null,null," ECDSA over P-256 with SHA-256.",null,false],[169,16,0,null,null," ECDSA over P-256 with SHA3-256.",null,false],[169,18,0,null,null," ECDSA over P-384 with SHA-384.",null,false],[169,20,0,null,null," ECDSA over P-384 with SHA3-384.",null,false],[169,22,0,null,null," ECDSA over Secp256k1 with SHA-256.",null,false],[169,24,0,null,null," ECDSA over Secp256k1 with SHA-256(SHA-256()) -- The Bitcoin signature system.",null,false],[169,27,0,null,null," Elliptic Curve Digital Signature Algorithm (ECDSA).",[19786,19787],false],[0,0,0,"Curve",null,"",null,true],[0,0,0,"Hash",null,"",[],true],[169,32,0,null,null," Length (in bytes) of optional random bytes, for non-deterministic signatures.",null,false],[169,35,0,null,null," An ECDSA secret key.",[19796],false],[169,37,0,null,null," Length (in bytes) of a raw secret key.",null,false],[169,41,0,null,null,null,[19792],false],[0,0,0,"bytes",null,"",null,false],[169,45,0,null,null,null,[19794],false],[0,0,0,"sk",null,"",null,false],[169,35,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[169,51,0,null,null," An ECDSA public key.",[19807],false],[169,53,0,null,null," Length (in bytes) of a compressed sec1-encoded key.",null,false],[169,55,0,null,null," Length (in bytes) of a compressed sec1-encoded key.",null,false],[169,60,0,null,null," Create a public key from a SEC-1 representation.",[19801],false],[0,0,0,"sec1",null,"",null,false],[169,65,0,null,null," Encode the public key using the compressed SEC-1 format.",[19803],false],[0,0,0,"pk",null,"",null,false],[169,70,0,null,null," Encoding the public key using the uncompressed SEC-1 format.",[19805],false],[0,0,0,"pk",null,"",null,false],[169,51,0,null,null,null,null,false],[0,0,0,"p",null,null,null,false],[169,76,0,null,null," An ECDSA signature.",[19831,19833],false],[169,78,0,null,null," Length (in bytes) of a raw signature.",null,false],[169,80,0,null,null," Maximum length (in bytes) of a DER-encoded signature.",null,false],[169,88,0,null,null," Create a Verifier for incremental verification of a signature.",[19812,19813],false],[0,0,0,"self",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[169,95,0,null,null," Verify the signature against a message and public key.\n Return IdentityElement or NonCanonical if the public key or signature are not in the expected range,\n or SignatureVerificationError if the signature is invalid for the given message and key.",[19815,19816,19817],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[169,102,0,null,null," Return the raw signature (r, s) in big-endian format.",[19819],false],[0,0,0,"self",null,"",null,false],[169,111,0,null,null," Create a signature from a raw encoding of (r, s).\n ECDSA always assumes big-endian.",[19821],false],[0,0,0,"bytes",null,"",null,false],[169,121,0,null,null," Encode the signature using the DER format.\n The maximum length of the DER encoding is der_encoded_max_length.\n The function returns a slice, that can be shorter than der_encoded_max_length.",[19823,19824],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[169,142,0,null,null,null,[19826,19827],false],[0,0,0,"out",null,"",null,false],[0,0,0,"reader",null,"",null,false],[169,161,0,null,null," Create a signature from a DER representation.\n Returns InvalidEncoding if the DER encoding is invalid.",[19829],false],[0,0,0,"der",null,"",null,false],[169,76,0,null,null,null,null,false],[0,0,0,"r",null," The R component of an ECDSA signature.",null,false],[169,76,0,null,null,null,null,false],[0,0,0,"s",null," The S component of an ECDSA signature.",null,false],[169,180,0,null,null," A Signer is used to incrementally compute a signature.\n It can be obtained from a `KeyPair`, using the `signer()` function.",[19844,19846,19848],false],[169,185,0,null,null,null,[19836,19837],false],[0,0,0,"secret_key",null,"",null,false],[0,0,0,"noise",null,"",null,false],[169,194,0,null,null," Add new data to the message being signed.",[19839,19840],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data",null,"",null,false],[169,199,0,null,null," Compute a signature over the entire message.",[19842],false],[0,0,0,"self",null,"",null,false],[169,180,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[169,180,0,null,null,null,null,false],[0,0,0,"secret_key",null,null,null,false],[169,180,0,null,null,null,null,false],[0,0,0,"noise",null,null,null,false],[169,227,0,null,null," A Verifier is used to incrementally verify a signature.\n It can be obtained from a `Signature`, using the `verifier()` function.",[19859,19861,19863,19865],false],[169,233,0,null,null,null,[19851,19852],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[169,247,0,null,null," Add new content to the message to be verified.",[19854,19855],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data",null,"",null,false],[169,252,0,null,null," Verify that the signature is valid for the entire message.",[19857],false],[0,0,0,"self",null,"",null,false],[169,227,0,null,null,null,null,false],[0,0,0,"h",null,null,null,false],[169,227,0,null,null,null,null,false],[0,0,0,"r",null,null,null,false],[169,227,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[169,227,0,null,null,null,null,false],[0,0,0,"public_key",null,null,null,false],[169,277,0,null,null," An ECDSA key pair.",[19880,19882],false],[169,279,0,null,null," Length (in bytes) of a seed required to create a key pair.",null,false],[169,288,0,null,null," Create a new key pair. The seed must be secret and indistinguishable from random.\n The seed can also be left to null in order to generate a random key pair.",[19869],false],[0,0,0,"seed",null,"",null,false],[169,302,0,null,null," Return the public key corresponding to the secret key.",[19871],false],[0,0,0,"secret_key",null,"",null,false],[169,311,0,null,null," Sign a message using the key pair.\n The noise can be null in order to create deterministic signatures.\n If deterministic signatures are not required, the noise should be randomly generated instead.\n This helps defend against fault attacks.",[19873,19874,19875],false],[0,0,0,"key_pair",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"noise",null,"",null,false],[169,318,0,null,null," Create a Signer, that can be used for incremental signature verification.",[19877,19878],false],[0,0,0,"key_pair",null,"",null,false],[0,0,0,"noise",null,"",null,false],[169,277,0,null,null,null,null,false],[0,0,0,"public_key",null," Public part.",null,false],[169,277,0,null,null,null,null,false],[0,0,0,"secret_key",null," Secret scalar.",null,false],[169,324,0,null,null,null,[19884,19885],false],[0,0,0,"unreduced_len",null,"",null,true],[0,0,0,"s",null,"",null,false],[169,337,0,null,null,null,[19887,19888,19889],false],[0,0,0,"h",null,"",null,false],[0,0,0,"secret_key",null,"",null,false],[0,0,0,"noise",null,"",null,false],[169,458,0,null,null,null,[19892,19894,19896,19901],false],[169,458,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[169,458,0,null,null,null,null,false],[0,0,0,"msg",null,null,null,false],[169,458,0,null,null,null,null,false],[0,0,0,"sig",null,null,null,false],[169,458,0,null,null,null,[19898,19899,19900],false],[0,0,0,"valid",null,null,null,false],[0,0,0,"invalid",null,null,null,false],[0,0,0,"acceptable",null,null,null,false],[0,0,0,"result",null,null,null,false],[169,866,0,null,null,null,[19903],false],[0,0,0,"vector",null,"",null,false],[115,150,0,null,null," Stream ciphers. These do not provide any kind of authentication.\n Most applications should be using AEAD constructions instead of stream ciphers directly.",[],false],[115,151,0,null,null,null,[],false],[115,152,0,null,null,null,null,false],[115,153,0,null,null,null,null,false],[115,154,0,null,null,null,null,false],[115,155,0,null,null,null,null,false],[115,156,0,null,null,null,null,false],[115,157,0,null,null,null,null,false],[115,158,0,null,null,null,null,false],[115,159,0,null,null,null,null,false],[115,160,0,null,null,null,null,false],[115,163,0,null,null,null,[],false],[115,164,0,null,null,null,null,false],[115,165,0,null,null,null,null,false],[115,166,0,null,null,null,null,false],[115,167,0,null,null,null,null,false],[115,171,0,null,null,null,[],false],[115,172,0,null,null,null,null,false],[115,174,0,null,null,null,null,false],[115,175,0,null,null,null,null,false],[115,176,0,null,null,null,null,false],[115,179,0,null,null,null,null,false],[0,0,0,"crypto/utils.zig",null,"",[],false],[170,0,0,null,null,null,null,false],[170,1,0,null,null,null,null,false],[170,2,0,null,null,null,null,false],[170,3,0,null,null,null,null,false],[170,4,0,null,null,null,null,false],[170,6,0,null,null,null,null,false],[170,7,0,null,null,null,null,false],[170,12,0,null,null," Compares two arrays in constant time (for a given length) and returns whether they are equal.\n This function was designed to compare short cryptographic secrets (MACs, signatures).\n For all other applications, use mem.eql() instead.",[19935,19936,19937],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[170,47,0,null,null," Compare two integers serialized as arrays of the same size, in constant time.\n Returns .lt if a<b, .gt if a>b and .eq if a=b",[19939,19940,19941,19942],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"endian",null,"",null,false],[170,82,0,null,null," Add two integers serialized as arrays of the same size, in constant time.\n The result is stored into `result`, and `true` is returned if an overflow occurred.",[19944,19945,19946,19947,19948],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"result",null,"",null,false],[0,0,0,"endian",null,"",null,false],[170,109,0,null,null," Subtract two integers serialized as arrays of the same size, in constant time.\n The result is stored into `result`, and `true` is returned if an underflow occurred.",[19950,19951,19952,19953,19954],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"result",null,"",null,false],[0,0,0,"endian",null,"",null,false],[170,136,0,null,null," Sets a slice to zeroes.\n Prevents the store from being optimized out.",[19956,19957],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[115,182,0,null,null," Finite-field arithmetic.",null,false],[0,0,0,"crypto/ff.zig",null," Allocation-free, (best-effort) constant-time, finite field arithmetic for large integers.\n\n Unlike `std.math.big`, these integers have a fixed maximum length and are only designed to be used for modular arithmetic.\n Arithmetic operations are meant to run in constant-time for a given modulus, making them suitable for cryptography.\n\n Parts of that code was ported from the BSD-licensed crypto/internal/bigmod/nat.go file in the Go language, itself inspired from BearSSL.\n",[],false],[171,7,0,null,null,null,null,false],[171,8,0,null,null,null,null,false],[171,9,0,null,null,null,null,false],[171,10,0,null,null,null,null,false],[171,11,0,null,null,null,null,false],[171,12,0,null,null,null,null,false],[171,13,0,null,null,null,null,false],[171,14,0,null,null,null,null,false],[171,15,0,null,null,null,null,false],[171,18,0,null,null,null,null,false],[171,21,0,null,null,null,null,false],[171,24,0,null,null,null,null,false],[171,27,0,null,null,null,null,false],[171,29,0,null,null,null,null,false],[171,32,0,null,null,null,[19976,19978],false],[171,32,0,null,null,null,null,false],[0,0,0,"hi",null,null,null,false],[171,32,0,null,null,null,null,false],[0,0,0,"lo",null,null,null,false],[171,38,0,null,null," Value is too large for the destination.",null,false],[171,41,0,null,null," Invalid modulus. Modulus must be odd.",null,false],[171,46,0,null,null," Exponentation with a null exponent.\n Exponentiation in cryptographic protocols is almost always a sign of a bug which can lead to trivial attacks.\n Therefore, this module returns an error when a null exponent is encountered, encouraging applications to handle this case explicitly.",null,false],[171,49,0,null,null," Invalid field element for the given modulus.",null,false],[171,52,0,null,null," Invalid representation (Montgomery vs non-Montgomery domain.)",null,false],[171,55,0,null,null," The set of all possible errors `std.crypto.ff` functions can return.",null,false],[171,59,0,null,null," An unsigned big integer with a fixed maximum size (`max_bits`), suitable for cryptographic operations.\n Unless side-channels mitigations are explicitly disabled, operations are designed to be constant-time.",[19986],false],[0,0,0,"max_bits",null,"",[20038],true],[171,63,0,null,null,null,null,false],[171,65,0,null,null,null,null,false],[171,66,0,null,null,null,null,false],[171,70,0,null,null," Number of bytes required to serialize an integer.",null,false],[171,73,0,null,null,null,[19992],false],[0,0,0,"self",null,"",null,false],[171,78,0,null,null,null,[19994],false],[0,0,0,"self",null,"",null,false],[171,90,0,null,null," The zero integer.",null,false],[171,98,0,null,null," Creates a new big integer from a primitive type.\n This function may not run in constant time.",[19997,19998],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x_",null,"",null,false],[171,114,0,null,null," Converts a big integer to a primitive type.\n This function may not run in constant time.",[20000,20001],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[171,130,0,null,null," Encodes a big integer into a byte array.",[20003,20004,20005],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,true],[171,177,0,null,null," Creates a new big integer from a byte array.",[20007,20008],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,true],[171,218,0,null,null," Returns `true` if both integers are equal.",[20010,20011],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,223,0,null,null," Compares two integers.",[20013,20014],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,233,0,null,null," Returns `true` if the integer is zero.",[20016],false],[0,0,0,"x",null,"",null,false],[171,243,0,null,null," Returns `true` if the integer is odd.",[20018],false],[0,0,0,"x",null,"",null,false],[171,248,0,null,null," Adds `y` to `x`, and returns `true` if the operation overflowed.",[20020,20021],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,253,0,null,null," Subtracts `y` from `x`, and returns `true` if the operation overflowed.",[20023,20024],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,258,0,null,null,null,[20026,20027,20028],false],[0,0,0,"x",null,"",null,false],[0,0,0,"on",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,267,0,null,null,null,[20030,20031,20032],false],[0,0,0,"x",null,"",null,false],[0,0,0,"on",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,282,0,null,null,null,[20034,20035,20036],false],[0,0,0,"x",null,"",null,false],[0,0,0,"on",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,62,0,null,null,null,null,false],[0,0,0,"limbs",null,null,null,false],[171,299,0,null,null," A field element.",[20040],false],[0,0,0,"bits",null,"",[20072,20073],true],[171,301,0,null,null,null,null,false],[171,303,0,null,null,null,null,false],[171,312,0,null,null," The maximum number of bytes required to encode a field element.",null,false],[171,315,0,null,null,null,[20045],false],[0,0,0,"self",null,"",null,false],[171,321,0,null,null," Creates a field element from a primitive.\n This function may not run in constant time.",[20047,20048,20049],false],[0,0,0,"T",null,"",null,true],[0,0,0,"m",null,"",null,false],[0,0,0,"x",null,"",null,false],[171,332,0,null,null," Converts the field element to a primitive.\n This function may not run in constant time.",[20051,20052],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[171,337,0,null,null," Creates a field element from a byte string.",[20054,20055,20056],false],[0,0,0,"m",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,true],[171,346,0,null,null," Converts the field element to a byte string.",[20058,20059,20060],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,true],[171,351,0,null,null," Returns `true` if the field elements are equal, in constant time.",[20062,20063],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,356,0,null,null," Compares two field elements in constant time.",[20065,20066],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,361,0,null,null," Returns `true` if the element is zero.",[20068],false],[0,0,0,"self",null,"",null,false],[171,366,0,null,null," Returns `true` is the element is odd.",[20070],false],[0,0,0,"self",null,"",null,false],[171,300,0,null,null,null,null,false],[0,0,0,"v",null," The element value as a `Uint`.",null,false],[0,0,0,"montgomery",null," `true` is the element is in Montgomery form.",null,false],[171,375,0,null,null," A modulus, defining a finite field.\n All operations within the field are performed modulo this modulus, without heap allocations.\n `max_bits` represents the number of bits in the maximum value the modulus can be set to.",[20075],false],[0,0,0,"max_bits",null,"",[20159,20161,20163,20165,20166],true],[171,377,0,null,null,null,null,false],[171,380,0,null,null," A field element, representing a value within the field defined by this modulus.",null,false],[171,382,0,null,null,null,null,false],[171,398,0,null,null,null,[20080],false],[0,0,0,"self",null,"",null,false],[171,403,0,null,null," Actual size of the modulus, in bits.",[20082],false],[0,0,0,"self",null,"",null,false],[171,408,0,null,null," Returns the element `1`.",[20084],false],[0,0,0,"self",null,"",null,false],[171,416,0,null,null," Creates a new modulus from a `Uint` value.\n The modulus must be odd and larger than 2.",[20086],false],[0,0,0,"v_",null,"",null,false],[171,453,0,null,null," Creates a new modulus from a primitive value.\n The modulus must be odd and larger than 2.",[20088,20089],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[171,460,0,null,null," Creates a new modulus from a byte string.",[20091,20092],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,true],[171,466,0,null,null," Serializes the modulus to a byte string.",[20094,20095,20096],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"endian",null,"",null,true],[171,471,0,null,null," Rejects field elements that are not in the canonical form.",[20098,20099],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fe",null,"",null,false],[171,478,0,null,null,null,[20101,20102],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fe",null,"",null,false],[171,490,0,null,null,null,[20104],false],[0,0,0,"self",null,"",null,false],[171,501,0,null,null," Computes x << t_bits + y (mod m)",[20106,20107,20108],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,530,0,null,null," Adds two field elements (mod m).",[20110,20111,20112],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,540,0,null,null," Subtracts two field elements (mod m).",[20114,20115,20116],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,548,0,null,null," Converts a field element to the Montgomery form.",[20118,20119],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[171,558,0,null,null," Takes a field element out of the Montgomery form.",[20121,20122],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[171,568,0,null,null," Reduces an arbitrary `Uint`, converting it to a field element.",[20124,20125],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[171,587,0,null,null,null,[20127,20128,20129,20130],false],[0,0,0,"self",null,"",null,false],[0,0,0,"d",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,634,0,null,null,null,[20132,20133,20134],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,647,0,null,null,null,[20136,20137],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[171,659,0,null,null," Multiplies two field elements.",[20139,20140,20141],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,673,0,null,null," Squares a field element.",[20143,20144],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[171,685,0,null,null," Returns x^e (mod m) in constant time.",[20146,20147,20148],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"e",null,"",null,false],[171,693,0,null,null," Returns x^e (mod m), assuming that the exponent is public.\n The function remains constant time with respect to `x`.",[20150,20151,20152],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"e",null,"",null,false],[171,706,0,null,null," Returns x^e (mod m), assuming that the exponent is public, and provided as a byte string.\n Exponents are usually small, so this function is faster than `powPublic` as a field element\n doesn't have to be created if a serialized representation is already available.",[20154,20155,20156,20157],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"e",null,"",null,false],[0,0,0,"endian",null,"",null,false],[171,376,0,null,null,null,null,false],[0,0,0,"zero",null," The neutral element.",null,false],[171,376,0,null,null,null,null,false],[0,0,0,"v",null," The modulus value.",null,false],[171,376,0,null,null,null,null,false],[0,0,0,"rr",null," R^2 for the Montgomery representation.",null,false],[171,376,0,null,null,null,null,false],[0,0,0,"m0inv",null," Inverse of the first limb",null,false],[0,0,0,"leading",null," Number of leading zero bits in the modulus.",null,false],[171,760,0,null,null,null,null,false],[171,762,0,null,null,null,[],false],[171,764,0,null,null,null,[20170,20171,20172],false],[0,0,0,"on",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,770,0,null,null,null,[20174,20175],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,777,0,null,null,null,[20177,20178],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,790,0,null,null,null,[20180,20181],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,795,0,null,null,null,[20183,20184],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,813,0,null,null,null,[],false],[171,815,0,null,null,null,[20187,20188,20189],false],[0,0,0,"on",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,820,0,null,null,null,[20191,20192],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,825,0,null,null,null,[20194,20195],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,841,0,null,null,null,[20197,20198],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[171,846,0,null,null,null,[20200,20201],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[115,185,0,null,null," This is a thread-local, cryptographically secure pseudo random number generator.",null,false],[0,0,0,"crypto/tlcsprng.zig",null," Thread-local cryptographically secure pseudo-random number generator.\n This file has public declarations that are intended to be used internally\n by the standard library; this namespace is not intended to be exposed\n directly to standard library users.\n",[],false],[172,5,0,null,null,null,null,false],[172,6,0,null,null,null,null,false],[172,7,0,null,null,null,null,false],[172,8,0,null,null,null,null,false],[172,12,0,null,null," We use this as a layer of indirection because global const pointers cannot\n point to thread-local variables.",null,false],[172,17,0,null,null,null,null,false],[172,34,0,null,null,null,null,false],[172,35,0,null,null,null,null,false],[172,37,0,null,null,null,null,false],[172,42,0,null,null,null,null,false],[172,44,0,null,null,null,null,false],[172,46,0,null,null,null,[20220,20222],false],[172,46,0,null,null,null,[20217,20218,20219],false],[0,0,0,"uninitialized",null,null,null,false],[0,0,0,"initialized",null,null,null,false],[0,0,0,"failed",null,null,null,false],[0,0,0,"init_state",null,null,null,false],[172,46,0,null,null,null,null,false],[0,0,0,"rng",null,null,null,false],[172,51,0,null,null,null,null,false],[172,61,0,null,null,null,null,false],[172,63,0,null,null,null,[20226,20227],false],[0,0,0,"",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[172,147,0,null,null,null,[20229],false],[0,0,0,"buffer",null,"",null,false],[172,152,0,null,null,null,[],false],[172,159,0,null,null,null,[20232],false],[0,0,0,"buffer",null,"",null,false],[172,164,0,null,null,null,[20234],false],[0,0,0,"buffer",null,"",null,false],[172,168,0,null,null,null,[20236],false],[0,0,0,"buffer",null,"",null,false],[115,187,0,null,null,null,null,false],[115,189,0,null,null,null,null,false],[0,0,0,"crypto/errors.zig",null,"",[],false],[173,1,0,null,null," MAC verification failed - The tag doesn't verify for the given ciphertext and secret key",null,false],[173,4,0,null,null," The requested output length is too long for the chosen algorithm",null,false],[173,7,0,null,null," Finite field operation returned the identity element",null,false],[173,10,0,null,null," Encoded input cannot be decoded",null,false],[173,13,0,null,null," The signature doesn't verify for the given message and public key",null,false],[173,16,0,null,null," Both a public and secret key have been provided, but they are incompatible",null,false],[173,19,0,null,null," Encoded input is not in canonical form",null,false],[173,22,0,null,null," Square root has no solutions",null,false],[173,25,0,null,null," Verification string doesn't match the provided password and parameters",null,false],[173,28,0,null,null," Parameters would be insecure to use",null,false],[173,31,0,null,null," Public key would be insecure to use",null,false],[173,34,0,null,null," Any error related to cryptography operations",null,false],[115,191,0,null,null,null,null,false],[0,0,0,"crypto/tls.zig",null," Plaintext:\n * type: ContentType\n * legacy_record_version: u16 = 0x0303,\n * length: u16,\n   - The length (in bytes) of the following TLSPlaintext.fragment.  The\n     length MUST NOT exceed 2^14 bytes.\n * fragment: opaque\n   - the data being transmitted\n\n Ciphertext\n * ContentType opaque_type = application_data; /* 23 */\n * ProtocolVersion legacy_record_version = 0x0303; /* TLS v1.2 */\n * uint16 length;\n * opaque encrypted_record[TLSCiphertext.length];\n\n Handshake:\n * type: HandshakeType\n * length: u24\n * data: opaque\n\n ServerHello:\n * ProtocolVersion legacy_version = 0x0303;\n * Random random;\n * opaque legacy_session_id_echo<0..32>;\n * CipherSuite cipher_suite;\n * uint8 legacy_compression_method = 0;\n * Extension extensions<6..2^16-1>;\n\n Extension:\n * ExtensionType extension_type;\n * opaque extension_data<0..2^16-1>;\n",[],false],[174,32,0,null,null,null,null,false],[174,33,0,null,null,null,null,false],[174,34,0,null,null,null,null,false],[174,35,0,null,null,null,null,false],[174,36,0,null,null,null,null,false],[174,37,0,null,null,null,null,false],[174,39,0,null,null,null,null,false],[0,0,0,"tls/Client.zig",null,"",[20394,20395,20397,20399,20401,20402,20403,20405,20407],false],[175,0,0,null,null,null,null,false],[175,1,0,null,null,null,null,false],[175,2,0,null,null,null,null,false],[175,3,0,null,null,null,null,false],[175,4,0,null,null,null,null,false],[175,5,0,null,null,null,null,false],[175,6,0,null,null,null,null,false],[175,7,0,null,null,null,null,false],[175,9,0,null,null,null,null,false],[175,10,0,null,null,null,null,false],[175,11,0,null,null,null,null,false],[175,12,0,null,null,null,null,false],[175,13,0,null,null,null,null,false],[175,14,0,null,null,null,null,false],[175,54,0,null,null," This is an example of the type that is needed by the read and write\n functions. It can have any fields but it must at least have these\n functions.\n\n Note that `std.net.Stream` conforms to this interface.\n\n This declaration serves as documentation only.",[],false],[175,56,0,null,null," Can be any error set.",null,false],[175,64,0,null,null," Returns the number of bytes read. The number read may be less than the\n buffer space provided. End-of-stream is indicated by a return value of 0.\n\n The `iovecs` parameter is mutable because so that function may to\n mutate the fields in order to handle partial reads from the underlying\n stream layer.",[20279,20280],false],[0,0,0,"this",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[175,70,0,null,null," Can be any error set.",null,false],[175,74,0,null,null," Returns the number of bytes read, which may be less than the buffer\n space provided. A short read does not indicate end-of-stream.",[20283,20284],false],[0,0,0,"this",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[175,83,0,null,null," Returns the number of bytes read, which may be less than the buffer\n space provided, indicating end-of-stream.\n The `iovecs` parameter is mutable in case this function needs to mutate\n the fields in order to handle partial writes from the underlying layer.",[20286,20287],false],[0,0,0,"this",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[175,90,0,null,null,null,[20289],false],[0,0,0,"Stream",null,"",null,true],[175,141,0,null,null," Initiates a TLS handshake and establishes a TLSv1.3 session with `stream`, which\n must conform to `StreamInterface`.\n\n `host` is only borrowed during this function call.",[20291,20292,20293],false],[0,0,0,"stream",null,"",null,false],[0,0,0,"ca_bundle",null,"",null,false],[0,0,0,"host",null,"",null,false],[175,708,0,null,null," Sends TLS-encrypted data to `stream`, which must conform to `StreamInterface`.\n Returns the number of plaintext bytes sent, which may be fewer than `bytes.len`.",[20295,20296,20297],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[175,713,0,null,null," Sends TLS-encrypted data to `stream`, which must conform to `StreamInterface`.",[20299,20300,20301],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[175,724,0,null,null," Sends TLS-encrypted data to `stream`, which must conform to `StreamInterface`.\n If `end` is true, then this function additionally sends a `close_notify` alert,\n which is necessary for the server to distinguish between a properly finished\n TLS session, or a truncation attack.",[20303,20304,20305,20306],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"end",null,"",null,false],[175,736,0,null,null," Sends TLS-encrypted data to `stream`, which must conform to `StreamInterface`.\n Returns the number of plaintext bytes sent, which may be fewer than `bytes.len`.\n If `end` is true, then this function additionally sends a `close_notify` alert,\n which is necessary for the server to distinguish between a properly finished\n TLS session, or a truncation attack.",[20308,20309,20310,20311],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"end",null,"",null,false],[175,777,0,null,null,null,[20313,20314,20315,20316,20317],false],[0,0,0,"c",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"ciphertext_buf",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"inner_content_type",null,"",[20318,20319,20320],false],[0,0,0,"iovec_end",null,null,null,false],[0,0,0,"ciphertext_end",null,null,null,false],[0,0,0,"overhead_len",null," How many bytes are taken up by overhead per record.",null,false],[175,847,0,null,null,null,[20322],false],[0,0,0,"c",null,"",null,false],[175,858,0,null,null," Receives TLS-encrypted data from `stream`, which must conform to `StreamInterface`.\n Returns the number of bytes read, calling the underlying read function the\n minimal number of times until the buffer has at least `len` bytes filled.\n If the number read is less than `len` it means the stream reached the end.\n Reaching the end of the stream is not an error condition.",[20324,20325,20326,20327],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[175,864,0,null,null," Receives TLS-encrypted data from `stream`, which must conform to `StreamInterface`.",[20329,20330,20331],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[175,872,0,null,null," Receives TLS-encrypted data from `stream`, which must conform to `StreamInterface`.\n Returns the number of bytes read. If the number read is smaller than\n `buffer.len`, it means the stream reached the end. Reaching the end of the\n stream is not an error condition.",[20333,20334,20335],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[175,882,0,null,null," Receives TLS-encrypted data from `stream`, which must conform to `StreamInterface`.\n Returns the number of bytes read. If the number read is less than the space\n provided it means the stream reached the end. Reaching the end of the\n stream is not an error condition.\n The `iovecs` parameter is mutable because this function needs to mutate the fields in\n order to handle partial reads from the underlying stream layer.",[20337,20338,20339],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[175,893,0,null,null," Receives TLS-encrypted data from `stream`, which must conform to `StreamInterface`.\n Returns the number of bytes read, calling the underlying read function the\n minimal number of times until the iovecs have at least `len` bytes filled.\n If the number read is less than `len` it means the stream reached the end.\n Reaching the end of the stream is not an error condition.\n The `iovecs` parameter is mutable because this function needs to mutate the fields in\n order to handle partial reads from the underlying stream layer.",[20341,20342,20343,20344],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"len",null,"",null,false],[175,919,0,null,null," Receives TLS-encrypted data from `stream`, which must conform to `StreamInterface`.\n Returns number of bytes that have been read, populated inside `iovecs`. A\n return value of zero bytes does not mean end of stream. Instead, check the `eof()`\n for the end of stream. The `eof()` may be true after any call to\n `read`, including when greater than zero bytes are returned, and this\n function asserts that `eof()` is `false`.\n See `readv` for a higher level function that has the same, familiar API as\n other read functions, such as `std.fs.File.read`.",[20346,20347,20348],false],[0,0,0,"c",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[175,1228,0,null,null,null,[20350,20351,20352,20353],false],[0,0,0,"c",null,"",null,false],[0,0,0,"frag",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"out",null,"",null,false],[175,1244,0,null,null," Note that `first` usually overlaps with `c.partially_read_buffer`.",[20355,20356,20357,20358],false],[0,0,0,"c",null,"",null,false],[0,0,0,"first",null,"",null,false],[0,0,0,"frag1",null,"",null,false],[0,0,0,"out",null,"",null,false],[175,1262,0,null,null,null,[20360,20361],false],[0,0,0,"frag",null,"",null,false],[0,0,0,"in",null,"",null,false],[175,1273,0,null,null,null,[20363,20364,20365],false],[0,0,0,"s1",null,"",null,false],[0,0,0,"s2",null,"",null,false],[0,0,0,"index",null,"",null,false],[175,1281,0,null,null,null,null,false],[175,1282,0,null,null,null,null,false],[175,1284,0,null,null,null,[20369],false],[0,0,0,"x",null,"",null,false],[175,1291,0,null,null,null,[20371],false],[0,0,0,"scheme",null,"",null,true],[175,1300,0,null,null,null,[20373],false],[0,0,0,"scheme",null,"",null,true],[175,1310,0,null,null," Abstraction for sending multiple byte buffers to a slice of iovecs.",[20386,20387,20388,20389],false],[175,1318,0,null,null," Returns the amount actually put which is always equal to bytes.len\n unless the vectors ran out of space.",[20376,20377],false],[0,0,0,"vp",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[175,1344,0,null,null," Returns the next buffer that consecutive bytes can go into.",[20379],false],[0,0,0,"vp",null,"",null,false],[175,1352,0,null,null,null,[20381,20382],false],[0,0,0,"vp",null,"",null,false],[0,0,0,"len",null,"",null,false],[175,1361,0,null,null,null,[20384],false],[0,0,0,"vp",null,"",null,false],[175,1310,0,null,null,null,null,false],[0,0,0,"iovecs",null,null,null,false],[0,0,0,"idx",null,null,null,false],[0,0,0,"off",null,null,null,false],[0,0,0,"total",null,null,null,false],[175,1372,0,null,null," Limit iovecs to a specific byte size.",[20391,20392],false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"len",null,"",null,false],[175,1405,0,null,null," The priority order here is chosen based on what crypto algorithms Zig has\n available in the standard library as well as what is faster. Following are\n a few data points on the relative performance of these algorithms.\n\n Measurement taken with 0.11.0-dev.810+c2f5848fe\n on x86_64-linux Intel(R) Core(TM) i9-9980HK CPU @ 2.40GHz:\n zig run .lib/std/crypto/benchmark.zig -OReleaseFast\n       aegis-128l:      15382 MiB/s\n        aegis-256:       9553 MiB/s\n       aes128-gcm:       3721 MiB/s\n       aes256-gcm:       3010 MiB/s\n chacha20Poly1305:        597 MiB/s\n\n Measurement taken with 0.11.0-dev.810+c2f5848fe\n on x86_64-linux Intel(R) Core(TM) i9-9980HK CPU @ 2.40GHz:\n zig run .lib/std/crypto/benchmark.zig -OReleaseFast -mcpu=baseline\n       aegis-128l:        629 MiB/s\n chacha20Poly1305:        529 MiB/s\n        aegis-256:        461 MiB/s\n       aes128-gcm:        138 MiB/s\n       aes256-gcm:        120 MiB/s",null,false],[0,0,0,"read_seq",null,null,null,false],[0,0,0,"write_seq",null,null,null,false],[175,0,0,null,null,null,null,false],[0,0,0,"partial_cleartext_idx",null," The starting index of cleartext bytes inside `partially_read_buffer`.",null,false],[175,0,0,null,null,null,null,false],[0,0,0,"partial_ciphertext_idx",null," The ending index of cleartext bytes inside `partially_read_buffer` as well\n as the starting index of ciphertext bytes.",null,false],[175,0,0,null,null,null,null,false],[0,0,0,"partial_ciphertext_end",null," The ending index of ciphertext bytes inside `partially_read_buffer`.",null,false],[0,0,0,"received_close_notify",null," When this is true, the stream may still not be at the end because there\n may be data in `partially_read_buffer`.",null,false],[0,0,0,"allow_truncation_attacks",null," By default, reaching the end-of-stream when reading from the server will\n cause `error.TlsConnectionTruncated` to be returned, unless a close_notify\n message has been received. By setting this flag to `true`, instead, the\n end-of-stream will be forwarded to the application layer above TLS.\n This makes the application vulnerable to truncation attacks unless the\n application layer itself verifies that the amount of data received equals\n the amount of data expected, such as HTTP with the Content-Length header.",null,false],[175,0,0,null,null,null,null,false],[0,0,0,"application_cipher",null,null,null,false],[175,0,0,null,null,null,null,false],[0,0,0,"partially_read_buffer",null," The size is enough to contain exactly one TLSCiphertext record.\n This buffer is segmented into four parts:\n 0. unused\n 1. cleartext\n 2. ciphertext\n 3. unused\n The fields `partial_cleartext_idx`, `partial_ciphertext_idx`, and\n `partial_ciphertext_end` describe the span of the segments.",null,false],[174,41,0,null,null,null,null,false],[174,42,0,null,null,null,null,false],[174,43,0,null,null,null,null,false],[174,44,0,null,null,null,null,false],[174,49,0,null,null,null,null,false],[174,54,0,null,null,null,[20414,20415],false],[0,0,0,"tls_1_2",null,null,null,false],[0,0,0,"tls_1_3",null,null,null,false],[174,60,0,null,null,null,[20417,20418,20419,20420,20421],false],[0,0,0,"invalid",null,null,null,false],[0,0,0,"change_cipher_spec",null,null,null,false],[0,0,0,"alert",null,null,null,false],[0,0,0,"handshake",null,null,null,false],[0,0,0,"application_data",null,null,null,false],[174,69,0,null,null,null,[20423,20424,20425,20426,20427,20428,20429,20430,20431,20432,20433],false],[0,0,0,"client_hello",null,null,null,false],[0,0,0,"server_hello",null,null,null,false],[0,0,0,"new_session_ticket",null,null,null,false],[0,0,0,"end_of_early_data",null,null,null,false],[0,0,0,"encrypted_extensions",null,null,null,false],[0,0,0,"certificate",null,null,null,false],[0,0,0,"certificate_request",null,null,null,false],[0,0,0,"certificate_verify",null,null,null,false],[0,0,0,"finished",null,null,null,false],[0,0,0,"key_update",null,null,null,false],[0,0,0,"message_hash",null,null,null,false],[174,84,0,null,null,null,[20435,20436,20437,20438,20439,20440,20441,20442,20443,20444,20445,20446,20447,20448,20449,20450,20451,20452,20453,20454,20455,20456],false],[0,0,0,"server_name",null," RFC 6066",null,false],[0,0,0,"max_fragment_length",null," RFC 6066",null,false],[0,0,0,"status_request",null," RFC 6066",null,false],[0,0,0,"supported_groups",null," RFC 8422, 7919",null,false],[0,0,0,"signature_algorithms",null," RFC 8446",null,false],[0,0,0,"use_srtp",null," RFC 5764",null,false],[0,0,0,"heartbeat",null," RFC 6520",null,false],[0,0,0,"application_layer_protocol_negotiation",null," RFC 7301",null,false],[0,0,0,"signed_certificate_timestamp",null," RFC 6962",null,false],[0,0,0,"client_certificate_type",null," RFC 7250",null,false],[0,0,0,"server_certificate_type",null," RFC 7250",null,false],[0,0,0,"padding",null," RFC 7685",null,false],[0,0,0,"pre_shared_key",null," RFC 8446",null,false],[0,0,0,"early_data",null," RFC 8446",null,false],[0,0,0,"supported_versions",null," RFC 8446",null,false],[0,0,0,"cookie",null," RFC 8446",null,false],[0,0,0,"psk_key_exchange_modes",null," RFC 8446",null,false],[0,0,0,"certificate_authorities",null," RFC 8446",null,false],[0,0,0,"oid_filters",null," RFC 8446",null,false],[0,0,0,"post_handshake_auth",null," RFC 8446",null,false],[0,0,0,"signature_algorithms_cert",null," RFC 8446",null,false],[0,0,0,"key_share",null," RFC 8446",null,false],[174,133,0,null,null,null,[20458,20459],false],[0,0,0,"warning",null,null,null,false],[0,0,0,"fatal",null,null,null,false],[174,139,0,null,null,null,[20464,20465,20466,20467,20468,20469,20470,20471,20472,20473,20474,20475,20476,20477,20478,20479,20480,20481,20482,20483,20484,20485,20486,20487,20488,20489,20490],false],[174,140,0,null,null,null,null,false],[174,198,0,null,null,null,[20463],false],[0,0,0,"alert",null,"",null,false],[0,0,0,"close_notify",null,null,null,false],[0,0,0,"unexpected_message",null,null,null,false],[0,0,0,"bad_record_mac",null,null,null,false],[0,0,0,"record_overflow",null,null,null,false],[0,0,0,"handshake_failure",null,null,null,false],[0,0,0,"bad_certificate",null,null,null,false],[0,0,0,"unsupported_certificate",null,null,null,false],[0,0,0,"certificate_revoked",null,null,null,false],[0,0,0,"certificate_expired",null,null,null,false],[0,0,0,"certificate_unknown",null,null,null,false],[0,0,0,"illegal_parameter",null,null,null,false],[0,0,0,"unknown_ca",null,null,null,false],[0,0,0,"access_denied",null,null,null,false],[0,0,0,"decode_error",null,null,null,false],[0,0,0,"decrypt_error",null,null,null,false],[0,0,0,"protocol_version",null,null,null,false],[0,0,0,"insufficient_security",null,null,null,false],[0,0,0,"internal_error",null,null,null,false],[0,0,0,"inappropriate_fallback",null,null,null,false],[0,0,0,"user_canceled",null,null,null,false],[0,0,0,"missing_extension",null,null,null,false],[0,0,0,"unsupported_extension",null,null,null,false],[0,0,0,"unrecognized_name",null,null,null,false],[0,0,0,"bad_certificate_status_response",null,null,null,false],[0,0,0,"unknown_psk_identity",null,null,null,false],[0,0,0,"certificate_required",null,null,null,false],[0,0,0,"no_application_protocol",null,null,null,false],[174,232,0,null,null,null,[20492,20493,20494,20495,20496,20497,20498,20499,20500,20501,20502,20503,20504,20505,20506,20507],false],[0,0,0,"rsa_pkcs1_sha256",null,null,null,false],[0,0,0,"rsa_pkcs1_sha384",null,null,null,false],[0,0,0,"rsa_pkcs1_sha512",null,null,null,false],[0,0,0,"ecdsa_secp256r1_sha256",null,null,null,false],[0,0,0,"ecdsa_secp384r1_sha384",null,null,null,false],[0,0,0,"ecdsa_secp521r1_sha512",null,null,null,false],[0,0,0,"rsa_pss_rsae_sha256",null,null,null,false],[0,0,0,"rsa_pss_rsae_sha384",null,null,null,false],[0,0,0,"rsa_pss_rsae_sha512",null,null,null,false],[0,0,0,"ed25519",null,null,null,false],[0,0,0,"ed448",null,null,null,false],[0,0,0,"rsa_pss_pss_sha256",null,null,null,false],[0,0,0,"rsa_pss_pss_sha384",null,null,null,false],[0,0,0,"rsa_pss_pss_sha512",null,null,null,false],[0,0,0,"rsa_pkcs1_sha1",null,null,null,false],[0,0,0,"ecdsa_sha1",null,null,null,false],[174,264,0,null,null,null,[20509,20510,20511,20512,20513,20514,20515,20516,20517,20518,20519,20520],false],[0,0,0,"secp256r1",null,null,null,false],[0,0,0,"secp384r1",null,null,null,false],[0,0,0,"secp521r1",null,null,null,false],[0,0,0,"x25519",null,null,null,false],[0,0,0,"x448",null,null,null,false],[0,0,0,"ffdhe2048",null,null,null,false],[0,0,0,"ffdhe3072",null,null,null,false],[0,0,0,"ffdhe4096",null,null,null,false],[0,0,0,"ffdhe6144",null,null,null,false],[0,0,0,"ffdhe8192",null,null,null,false],[0,0,0,"x25519_kyber512d00",null,null,null,false],[0,0,0,"x25519_kyber768d00",null,null,null,false],[174,286,0,null,null,null,[20522,20523,20524,20525,20526,20527,20528],false],[0,0,0,"AES_128_GCM_SHA256",null,null,null,false],[0,0,0,"AES_256_GCM_SHA384",null,null,null,false],[0,0,0,"CHACHA20_POLY1305_SHA256",null,null,null,false],[0,0,0,"AES_128_CCM_SHA256",null,null,null,false],[0,0,0,"AES_128_CCM_8_SHA256",null,null,null,false],[0,0,0,"AEGIS_256_SHA384",null,null,null,false],[0,0,0,"AEGIS_128L_SHA256",null,null,null,false],[174,297,0,null,null,null,[20530,20531],false],[0,0,0,"X509",null,null,null,false],[0,0,0,"RawPublicKey",null,null,null,false],[174,303,0,null,null,null,[20533,20534],false],[0,0,0,"update_not_requested",null,null,null,false],[0,0,0,"update_requested",null,null,null,false],[174,309,0,null,null,null,[20536,20537],false],[0,0,0,"AeadType",null,"",null,true],[0,0,0,"HashType",null,"",[20543,20545,20547,20549,20551,20553,20555,20557,20559],true],[174,311,0,null,null,null,null,false],[174,312,0,null,null,null,null,false],[174,313,0,null,null,null,null,false],[174,314,0,null,null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"handshake_secret",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"master_secret",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"client_handshake_key",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"server_handshake_key",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"client_finished_key",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"server_finished_key",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"client_handshake_iv",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"server_handshake_iv",null,null,null,false],[174,310,0,null,null,null,null,false],[0,0,0,"transcript_hash",null,null,null,false],[174,328,0,null,null,null,[20561,20562,20563,20564,20565],false],[0,0,0,"AES_128_GCM_SHA256",null,null,null,false],[0,0,0,"AES_256_GCM_SHA384",null,null,null,false],[0,0,0,"CHACHA20_POLY1305_SHA256",null,null,null,false],[0,0,0,"AEGIS_256_SHA384",null,null,null,false],[0,0,0,"AEGIS_128L_SHA256",null,null,null,false],[174,336,0,null,null,null,[20567,20568],false],[0,0,0,"AeadType",null,"",null,true],[0,0,0,"HashType",null,"",[20574,20576,20578,20580,20582,20584],true],[174,338,0,null,null,null,null,false],[174,339,0,null,null,null,null,false],[174,340,0,null,null,null,null,false],[174,341,0,null,null,null,null,false],[174,337,0,null,null,null,null,false],[0,0,0,"client_secret",null,null,null,false],[174,337,0,null,null,null,null,false],[0,0,0,"server_secret",null,null,null,false],[174,337,0,null,null,null,null,false],[0,0,0,"client_key",null,null,null,false],[174,337,0,null,null,null,null,false],[0,0,0,"server_key",null,null,null,false],[174,337,0,null,null,null,null,false],[0,0,0,"client_iv",null,null,null,false],[174,337,0,null,null,null,null,false],[0,0,0,"server_iv",null,null,null,false],[174,353,0,null,null," Encryption parameters for application traffic.",[20586,20587,20588,20589,20590],false],[0,0,0,"AES_128_GCM_SHA256",null,null,null,false],[0,0,0,"AES_256_GCM_SHA384",null,null,null,false],[0,0,0,"CHACHA20_POLY1305_SHA256",null,null,null,false],[0,0,0,"AEGIS_256_SHA384",null,null,null,false],[0,0,0,"AEGIS_128L_SHA256",null,null,null,false],[174,361,0,null,null,null,[20592,20593,20594,20595,20596],false],[0,0,0,"Hkdf",null,"",null,true],[0,0,0,"key",null,"",null,false],[0,0,0,"label",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"len",null,"",null,true],[174,388,0,null,null,null,[20598],false],[0,0,0,"Hash",null,"",null,true],[174,394,0,null,null,null,[20600,20601,20602],false],[0,0,0,"Hmac",null,"",null,true],[0,0,0,"message",null,"",null,false],[0,0,0,"key",null,"",null,false],[174,400,0,null,null,null,[20604,20605],false],[0,0,0,"et",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[174,404,0,null,null,null,[20607,20608],false],[0,0,0,"elem_size",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[174,409,0,null,null,null,[20610,20611],false],[0,0,0,"E",null,"",null,true],[0,0,0,"tags",null,"",null,true],[174,419,0,null,null,null,[20613],false],[0,0,0,"x",null,"",null,false],[174,426,0,null,null,null,[20615],false],[0,0,0,"x",null,"",null,false],[174,436,0,null,null," An abstraction to ensure that protocol-parsing code does not perform an\n out-of-bounds read.",[20650,20651,20652,20653,20654,20655],false],[174,451,0,null,null,null,[20618],false],[0,0,0,"buf",null,"",null,false],[174,461,0,null,null," Use this function to increase `their_end`.",[20620,20621,20622],false],[0,0,0,"d",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"their_amt",null,"",null,false],[174,476,0,null,null," Same as `readAtLeast` but also increases `our_end` by exactly `our_amt`.\n Use when `our_amt` is calculated by us, not by them.",[20624,20625,20626],false],[0,0,0,"d",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"our_amt",null,"",null,false],[174,484,0,null,null," Use this function to increase `our_end`.\n This should always be called with an amount provided by us, not them.",[20628,20629],false],[0,0,0,"d",null,"",null,false],[0,0,0,"amt",null,"",null,false],[174,490,0,null,null," Use this function to increase `idx`.",[20631,20632],false],[0,0,0,"d",null,"",null,false],[0,0,0,"T",null,"",null,true],[174,522,0,null,null," Use this function to increase `idx`.",[20634,20635],false],[0,0,0,"d",null,"",null,false],[0,0,0,"len",null,"",null,true],[174,528,0,null,null," Use this function to increase `idx`.",[20637,20638],false],[0,0,0,"d",null,"",null,false],[0,0,0,"len",null,"",null,false],[174,534,0,null,null," Use this function to increase `idx`.",[20640,20641],false],[0,0,0,"d",null,"",null,false],[0,0,0,"amt",null,"",null,false],[174,539,0,null,null,null,[20643],false],[0,0,0,"d",null,"",null,false],[174,547,0,null,null," Provide the length they claim, and receive a sub-decoder specific to that slice.\n The parent decoder is advanced to the end.",[20645,20646],false],[0,0,0,"d",null,"",null,false],[0,0,0,"their_len",null,"",null,false],[174,556,0,null,null,null,[20648],false],[0,0,0,"d",null,"",null,false],[174,436,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"idx",null," Points to the next byte in buffer that will be decoded.",null,false],[0,0,0,"our_end",null," Up to this point in `buf` we have already checked that `cap` is greater than it.",null,false],[0,0,0,"their_end",null," Beyond this point in `buf` is extra tag-along bytes beyond the amount we\n requested with `readAtLeast`.",null,false],[0,0,0,"cap",null," Points to the end within buffer that has been filled. Beyond this point\n in buf is undefined bytes.",null,false],[0,0,0,"disable_reads",null," Debug helper to prevent illegal calls to read functions.",null,false],[115,192,0,null,null,null,null,false],[0,0,0,"crypto/Certificate.zig",null,"",[21094,21095],false],[176,3,0,null,null,null,null,false],[0,0,0,"Certificate/Bundle.zig",null," A set of certificates. Typically pre-installed on every operating system,\n these are \"Certificate Authorities\" used to validate SSL certificates.\n This data structure stores certificates in DER-encoded form, all of them\n concatenated together in the `bytes` array. The `map` field contains an\n index from the DER-encoded subject name to the index of the containing\n certificate within `bytes`.\n",[20793,20795],false],[177,11,0,null,null,null,null,false],[177,15,0,null,null,null,[20662,20663,20664],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"subject",null,"",null,false],[0,0,0,"now_sec",null,"",null,false],[177,29,0,null,null," The returned bytes become invalid after calling any of the rescan functions\n or add functions.",[20666,20667],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"subject_name",null,"",null,false],[177,46,0,null,null,null,[20669,20670],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[177,52,0,null,null,null,null,false],[177,58,0,null,null," Clears the set of certificates and then scans the host operating system\n file system standard locations for certificates.\n For operating systems that do not have standard CA installations to be\n found, this function clears the set of certificates.",[20673,20674],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[177,70,0,null,null,null,null,false],[0,0,0,"Bundle/macos.zig",null,"",[],false],[178,0,0,null,null,null,null,false],[178,1,0,null,null,null,null,false],[178,2,0,null,null,null,null,false],[178,3,0,null,null,null,null,false],[178,4,0,null,null,null,null,false],[178,5,0,null,null,null,null,false],[178,7,0,null,null,null,null,false],[178,9,0,null,null,null,[20685,20686],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[178,74,0,null,null,null,[20689,20690,20691,20692,20693],false],[178,74,0,null,null,null,null,false],[0,0,0,"signature",null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"header_size",null,null,null,false],[0,0,0,"schema_offset",null,null,null,false],[0,0,0,"auth_offset",null,null,null,false],[178,82,0,null,null,null,[20695,20696],false],[0,0,0,"schema_size",null,null,null,false],[0,0,0,"table_count",null,null,null,false],[178,87,0,null,null,null,[20698,20699,20700,20701,20702,20703,20704],false],[0,0,0,"table_size",null,null,null,false],[0,0,0,"table_id",null,null,null,false],[0,0,0,"record_count",null,null,null,false],[0,0,0,"records",null,null,null,false],[0,0,0,"indexes_offset",null,null,null,false],[0,0,0,"free_list_head",null,null,null,false],[0,0,0,"record_numbers_count",null,null,null,false],[178,97,0,null,null,null,[20706,20707,20708,20709,20710,20711,20712,20713,20714,20715,20716,20717,20718,20719,20720],false],[0,0,0,"record_size",null,null,null,false],[0,0,0,"record_number",null,null,null,false],[0,0,0,"unknown1",null,null,null,false],[0,0,0,"unknown2",null,null,null,false],[0,0,0,"cert_size",null,null,null,false],[0,0,0,"unknown3",null,null,null,false],[0,0,0,"cert_type",null,null,null,false],[0,0,0,"cert_encoding",null,null,null,false],[0,0,0,"print_name",null,null,null,false],[0,0,0,"alias",null,null,null,false],[0,0,0,"subject",null,null,null,false],[0,0,0,"issuer",null,null,null,false],[0,0,0,"serial_number",null,null,null,false],[0,0,0,"subject_key_identifier",null,null,null,false],[0,0,0,"public_key_hash",null,null,null,false],[177,71,0,null,null,null,null,false],[177,73,0,null,null,null,null,false],[177,75,0,null,null,null,[20724,20725],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[177,117,0,null,null,null,null,false],[177,119,0,null,null,null,[20728,20729,20730],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"cert_file_path",null,"",null,false],[177,126,0,null,null,null,null,false],[177,128,0,null,null,null,[20733,20734],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[177,153,0,null,null,null,null,false],[177,155,0,null,null,null,[20737,20738,20739,20740],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"sub_dir_path",null,"",null,false],[177,166,0,null,null,null,[20742,20743,20744],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"abs_dir_path",null,"",null,false],[177,177,0,null,null,null,null,false],[177,179,0,null,null,null,[20747,20748,20749],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"iterable_dir",null,"",null,false],[177,191,0,null,null,null,null,false],[177,193,0,null,null,null,[20752,20753,20754],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"abs_file_path",null,"",null,false],[177,204,0,null,null,null,[20756,20757,20758,20759],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"sub_file_path",null,"",null,false],[177,215,0,null,null,null,null,false],[177,217,0,null,null,null,[20762,20763,20764],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"file",null,"",null,false],[177,251,0,null,null,null,null,false],[177,253,0,null,null,null,[20767,20768,20769,20770],false],[0,0,0,"cb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"decoded_start",null,"",null,false],[0,0,0,"now_sec",null,"",null,false],[177,281,0,null,null,null,null,false],[177,282,0,null,null,null,null,false],[177,283,0,null,null,null,null,false],[177,284,0,null,null,null,null,false],[177,285,0,null,null,null,null,false],[177,286,0,null,null,null,null,false],[177,287,0,null,null,null,null,false],[177,288,0,null,null,null,null,false],[177,289,0,null,null,null,null,false],[177,290,0,null,null,null,null,false],[177,292,0,null,null,null,null,false],[177,294,0,null,null,null,[20791],false],[177,297,0,null,null,null,[20784,20785],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"k",null,"",null,false],[177,301,0,null,null,null,[20787,20788,20789],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[177,294,0,null,null,null,null,false],[0,0,0,"cb",null,null,null,false],[177,0,0,null,null,null,null,false],[0,0,0,"map",null," The key is the contents slice of the subject.",null,false],[177,0,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[176,5,0,null,null,null,[20797,20798,20799],false],[0,0,0,"v1",null,null,null,false],[0,0,0,"v2",null,null,null,false],[0,0,0,"v3",null,null,null,false],[176,7,0,null,null,null,[20804,20805,20806,20807,20808,20809,20810,20811,20812,20813,20814],false],[176,20,0,null,null,null,null,false],[176,34,0,null,null,null,[20803],false],[0,0,0,"algorithm",null,"",null,true],[0,0,0,"sha1WithRSAEncryption",null,null,null,false],[0,0,0,"sha224WithRSAEncryption",null,null,null,false],[0,0,0,"sha256WithRSAEncryption",null,null,null,false],[0,0,0,"sha384WithRSAEncryption",null,null,null,false],[0,0,0,"sha512WithRSAEncryption",null,null,null,false],[0,0,0,"ecdsa_with_SHA224",null,null,null,false],[0,0,0,"ecdsa_with_SHA256",null,null,null,false],[0,0,0,"ecdsa_with_SHA384",null,null,null,false],[0,0,0,"ecdsa_with_SHA512",null,null,null,false],[0,0,0,"md2WithRSAEncryption",null,null,null,false],[0,0,0,"md5WithRSAEncryption",null,null,null,false],[176,47,0,null,null,null,[20817,20818],false],[176,51,0,null,null,null,null,false],[0,0,0,"rsaEncryption",null,null,null,false],[0,0,0,"X9_62_id_ecPublicKey",null,null,null,false],[176,57,0,null,null,null,[20821,20822,20823,20824,20825,20826,20827,20828,20829,20830,20831,20832],false],[176,71,0,null,null,null,null,false],[0,0,0,"commonName",null,null,null,false],[0,0,0,"serialNumber",null,null,null,false],[0,0,0,"countryName",null,null,null,false],[0,0,0,"localityName",null,null,null,false],[0,0,0,"stateOrProvinceName",null,null,null,false],[0,0,0,"streetAddress",null,null,null,false],[0,0,0,"organizationName",null,null,null,false],[0,0,0,"organizationalUnitName",null,null,null,false],[0,0,0,"postalCode",null,null,null,false],[0,0,0,"organizationIdentifier",null,null,null,false],[0,0,0,"pkcs9_emailAddress",null,null,null,false],[0,0,0,"domainComponent",null,null,null,false],[176,87,0,null,null,null,[20837,20838,20839],false],[176,92,0,null,null,null,null,false],[176,98,0,null,null,null,[20836],false],[0,0,0,"curve",null,"",null,true],[0,0,0,"secp384r1",null,null,null,false],[0,0,0,"secp521r1",null,null,null,false],[0,0,0,"X9_62_prime256v1",null,null,null,false],[176,107,0,null,null,null,[20842,20843,20844,20845,20846,20847,20848,20849,20850,20851,20852,20853,20854,20855,20856,20857,20858,20859,20860],false],[176,128,0,null,null,null,null,false],[0,0,0,"subject_key_identifier",null,null,null,false],[0,0,0,"key_usage",null,null,null,false],[0,0,0,"private_key_usage_period",null,null,null,false],[0,0,0,"subject_alt_name",null,null,null,false],[0,0,0,"issuer_alt_name",null,null,null,false],[0,0,0,"basic_constraints",null,null,null,false],[0,0,0,"crl_number",null,null,null,false],[0,0,0,"certificate_policies",null,null,null,false],[0,0,0,"authority_key_identifier",null,null,null,false],[0,0,0,"msCertsrvCAVersion",null,null,null,false],[0,0,0,"commonName",null,null,null,false],[0,0,0,"ext_key_usage",null,null,null,false],[0,0,0,"crl_distribution_points",null,null,null,false],[0,0,0,"info_access",null,null,null,false],[0,0,0,"entrustVersInfo",null,null,null,false],[0,0,0,"enroll_certtype",null,null,null,false],[0,0,0,"pe_logotype",null,null,null,false],[0,0,0,"netscape_cert_type",null,null,null,false],[0,0,0,"netscape_comment",null,null,null,false],[176,154,0,null,null,null,[20862,20863,20864,20865,20866,20867,20868,20869,20870],false],[0,0,0,"otherName",null,null,null,false],[0,0,0,"rfc822Name",null,null,null,false],[0,0,0,"dNSName",null,null,null,false],[0,0,0,"x400Address",null,null,null,false],[0,0,0,"directoryName",null,null,null,false],[0,0,0,"ediPartyName",null,null,null,false],[0,0,0,"uniformResourceIdentifier",null,null,null,false],[0,0,0,"iPAddress",null,null,null,false],[0,0,0,"registeredID",null,null,null,false],[176,167,0,null,null,null,[20911,20913,20915,20917,20919,20921,20923,20925,20927,20929,20931,20933],false],[176,181,0,null,null,null,[20873,20874],false],[0,0,0,"rsaEncryption",null,null,null,false],[0,0,0,"X9_62_id_ecPublicKey",null,null,null,false],[176,186,0,null,null,null,[20876,20877],false],[0,0,0,"not_before",null,null,null,false],[0,0,0,"not_after",null,null,null,false],[176,191,0,null,null,null,null,false],[176,193,0,null,null,null,[20880,20881],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[176,197,0,null,null,null,[20883],false],[0,0,0,"p",null,"",null,false],[176,201,0,null,null,null,[20885],false],[0,0,0,"p",null,"",null,false],[176,205,0,null,null,null,[20887],false],[0,0,0,"p",null,"",null,false],[176,209,0,null,null,null,[20889],false],[0,0,0,"p",null,"",null,false],[176,213,0,null,null,null,[20891],false],[0,0,0,"p",null,"",null,false],[176,217,0,null,null,null,[20893],false],[0,0,0,"p",null,"",null,false],[176,221,0,null,null,null,[20895],false],[0,0,0,"p",null,"",null,false],[176,225,0,null,null,null,[20897],false],[0,0,0,"p",null,"",null,false],[176,229,0,null,null,null,null,false],[176,248,0,null,null," This function verifies:\n  * That the subject's issuer is indeed the provided issuer.\n  * The time validity of the subject.\n  * The signature.",[20900,20901,20902],false],[0,0,0,"parsed_subject",null,"",null,false],[0,0,0,"parsed_issuer",null,"",null,false],[0,0,0,"now_sec",null,"",null,false],[176,292,0,null,null,null,null,false],[176,297,0,null,null,null,[20905,20906],false],[0,0,0,"parsed_subject",null,"",null,false],[0,0,0,"host_name",null,"",null,false],[176,334,0,null,null,null,[20908,20909],false],[0,0,0,"host_name",null,"",null,false],[0,0,0,"dns_name",null,"",null,false],[176,167,0,null,null,null,null,false],[0,0,0,"certificate",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"issuer_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"subject_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"common_name_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"signature_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"signature_algorithm",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"pub_key_algo",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"pub_key_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"message_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"subject_alt_name_slice",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"validity",null,null,null,false],[176,167,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[176,373,0,null,null,null,null,false],[176,375,0,null,null,null,[20936],false],[0,0,0,"cert",null,"",null,false],[176,508,0,null,null,null,[20938,20939,20940],false],[0,0,0,"subject",null,"",null,false],[0,0,0,"issuer",null,"",null,false],[0,0,0,"now_sec",null,"",null,false],[176,514,0,null,null,null,[20942,20943],false],[0,0,0,"cert",null,"",null,false],[0,0,0,"elem",null,"",null,false],[176,518,0,null,null,null,null,false],[176,520,0,null,null,null,[20946,20947],false],[0,0,0,"cert",null,"",null,false],[0,0,0,"elem",null,"",null,false],[176,526,0,null,null,null,null,false],[176,529,0,null,null," Returns number of seconds since epoch.",[20950,20951],false],[0,0,0,"cert",null,"",null,false],[0,0,0,"elem",null,"",null,false],[176,568,0,null,null,null,[20955,20956,20957,20958,20959,20960],false],[176,583,0,null,null," Convert to number of seconds since epoch.",[20954],false],[0,0,0,"date",null,"",null,false],[0,0,0,"year",null," example: 1999",null,false],[0,0,0,"month",null," range: 1 to 12",null,false],[0,0,0,"day",null," range: 1 to 31",null,false],[0,0,0,"hour",null," range: 0 to 59",null,false],[0,0,0,"minute",null," range: 0 to 59",null,false],[0,0,0,"second",null," range: 0 to 59",null,false],[176,615,0,null,null,null,[20962,20963,20964],false],[0,0,0,"text",null,"",null,false],[0,0,0,"min",null,"",null,false],[0,0,0,"max",null,"",null,false],[176,637,0,null,null,null,[20966],false],[0,0,0,"text",null,"",null,false],[176,658,0,null,null,null,[20968,20969],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"element",null,"",null,false],[176,662,0,null,null,null,[20971,20972],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"element",null,"",null,false],[176,666,0,null,null,null,[20974,20975],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"element",null,"",null,false],[176,670,0,null,null,null,[20977,20978],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"element",null,"",null,false],[176,674,0,null,null,null,[20980,20981],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"element",null,"",null,false],[176,678,0,null,null,null,null,false],[176,680,0,null,null,null,[20984,20985,20986],false],[0,0,0,"E",null,"",null,true],[0,0,0,"bytes",null,"",null,false],[0,0,0,"element",null,"",null,false],[176,687,0,null,null,null,null,false],[176,689,0,null,null,null,[20989,20990],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"version_elem",null,"",null,false],[176,709,0,null,null,null,[20992,20993,20994,20995,20996],false],[0,0,0,"Hash",null,"",null,true],[0,0,0,"message",null,"",null,false],[0,0,0,"sig",null,"",null,false],[0,0,0,"pub_key_algo",null,"",null,false],[0,0,0,"pub_key",null,"",null,false],[176,779,0,null,null,null,[20998,20999,21000,21001,21002],false],[0,0,0,"Hash",null,"",null,true],[0,0,0,"message",null,"",null,false],[0,0,0,"encoded_sig",null,"",null,false],[0,0,0,"pub_key_algo",null,"",null,false],[0,0,0,"sec1_pub_key",null,"",null,false],[176,816,0,null,null,null,null,false],[176,817,0,null,null,null,null,false],[176,818,0,null,null,null,null,false],[176,819,0,null,null,null,null,false],[176,821,0,null,null,null,[],false],[176,822,0,null,null,null,[21009,21010,21011,21012],false],[0,0,0,"universal",null,null,null,false],[0,0,0,"application",null,null,null,false],[0,0,0,"context_specific",null,null,null,false],[0,0,0,"private",null,null,null,false],[176,829,0,null,null,null,[21014,21015],false],[0,0,0,"primitive",null,null,null,false],[0,0,0,"constructed",null,null,null,false],[176,834,0,null,null,null,[21018,21020,21022],false],[176,834,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[176,834,0,null,null,null,null,false],[0,0,0,"pc",null,null,null,false],[176,834,0,null,null,null,null,false],[0,0,0,"class",null,null,null,false],[176,840,0,null,null,null,[21024,21025,21026,21027,21028,21029,21030,21031,21032,21033],false],[0,0,0,"boolean",null,null,null,false],[0,0,0,"integer",null,null,null,false],[0,0,0,"bitstring",null,null,null,false],[0,0,0,"octetstring",null,null,null,false],[0,0,0,"null",null,null,null,false],[0,0,0,"object_identifier",null,null,null,false],[0,0,0,"sequence",null,null,null,false],[0,0,0,"sequence_of",null,null,null,false],[0,0,0,"utc_time",null,null,null,false],[0,0,0,"generalized_time",null,null,null,false],[176,854,0,null,null,null,[21044,21046],false],[176,858,0,null,null,null,[21037,21038],false],[176,862,0,null,null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[176,865,0,null,null,null,null,false],[176,867,0,null,null,null,[21041,21042],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"index",null,"",null,false],[176,854,0,null,null,null,null,false],[0,0,0,"identifier",null,null,null,false],[176,854,0,null,null,null,null,false],[0,0,0,"slice",null,null,null,false],[176,909,0,null,null,null,[],false],[176,910,0,null,null,null,null,false],[176,911,0,null,null,null,null,false],[176,912,0,null,null,null,null,false],[176,913,0,null,null,null,null,false],[176,915,0,null,null,null,[],false],[176,916,0,null,null,null,[21054,21055],false],[0,0,0,"modulus_len",null,"",null,true],[0,0,0,"msg",null,"",null,false],[176,922,0,null,null,null,[21057,21058,21059,21060,21061],false],[0,0,0,"modulus_len",null,"",null,true],[0,0,0,"sig",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[0,0,0,"Hash",null,"",null,true],[176,929,0,null,null,null,[21063,21064,21065,21066,21067],false],[0,0,0,"msg",null,"",null,false],[0,0,0,"em",null,"",null,false],[0,0,0,"emBit",null,"",null,false],[0,0,0,"sLen",null,"",null,false],[0,0,0,"Hash",null,"",null,true],[176,1038,0,null,null,null,[21069,21070,21071,21072],false],[0,0,0,"Hash",null,"",null,true],[0,0,0,"out",null,"",null,false],[0,0,0,"seed",null,"",null,false],[0,0,0,"len",null,"",null,false],[176,1065,0,null,null,null,[21084,21086],false],[176,1069,0,null,null,null,[21075,21076],false],[0,0,0,"pub_bytes",null,"",null,false],[0,0,0,"modulus_bytes",null,"",null,false],[176,1094,0,null,null,null,[21078],false],[0,0,0,"pub_key",null,"",[21080,21082],false],[176,1094,0,null,null,null,null,false],[0,0,0,"modulus",null,null,null,false],[176,1094,0,null,null,null,null,false],[0,0,0,"exponent",null,null,null,false],[176,1065,0,null,null,null,null,false],[0,0,0,"n",null,null,null,false],[176,1065,0,null,null,null,null,false],[0,0,0,"e",null,null,null,false],[176,1113,0,null,null,null,[21088,21089,21090],false],[0,0,0,"modulus_len",null,"",null,true],[0,0,0,"msg",null,"",null,false],[0,0,0,"public_key",null,"",null,false],[176,625,0,"parseTimeDigits","test parseTimeDigits {\n    const expectEqual = std.testing.expectEqual;\n    try expectEqual(@as(u8, 0), try parseTimeDigits(\"00\", 0, 99));\n    try expectEqual(@as(u8, 99), try parseTimeDigits(\"99\", 0, 99));\n    try expectEqual(@as(u8, 42), try parseTimeDigits(\"42\", 0, 99));\n\n    const expectError = std.testing.expectError;\n    try expectError(error.CertificateTimeInvalid, parseTimeDigits(\"13\", 1, 12));\n    try expectError(error.CertificateTimeInvalid, parseTimeDigits(\"00\", 1, 12));\n    try expectError(error.CertificateTimeInvalid, parseTimeDigits(\"Di\", 0, 99));\n}",null,null,false],[176,646,0,"parseYear4","test parseYear4 {\n    const expectEqual = std.testing.expectEqual;\n    try expectEqual(@as(u16, 0), try parseYear4(\"0000\"));\n    try expectEqual(@as(u16, 9999), try parseYear4(\"9999\"));\n    try expectEqual(@as(u16, 1988), try parseYear4(\"1988\"));\n\n    const expectError = std.testing.expectError;\n    try expectError(error.CertificateTimeInvalid, parseYear4(\"999b\"));\n    try expectError(error.CertificateTimeInvalid, parseYear4(\"crap\"));\n    try expectError(error.CertificateTimeInvalid, parseYear4(\"r:bQ\"));\n}",null,null,false],[176,0,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[0,0,0,"index",null,null,null,false],[115,195,0,null,null," Side-channels mitigations.",[21097,21098,21099,21100],false],[0,0,0,"none",null," No additional side-channel mitigations are applied.\n This is the fastest mode.",null,false],[0,0,0,"basic",null," The `basic` mode protects against most practical attacks, provided that the\n application or implements proper defenses against brute-force attacks.\n It offers a good balance between performance and security.",null,false],[0,0,0,"medium",null," The `medium` mode offers increased resilience against side-channel attacks,\n making most attacks unpractical even on shared/low latency environements.\n This is the default mode.",null,false],[0,0,0,"full",null," The `full` mode offers the highest level of protection against side-channel attacks.\n Note that this doesn't cover all possible attacks (especially power analysis or\n thread-local attacks such as cachebleed), and that the performance impact is significant.",null,false],[115,213,0,null,null,null,null,false],[1,82,0,null,null,null,null,false],[0,0,0,"cstr.zig",null,"",[],false],[179,0,0,null,null,null,null,false],[179,1,0,null,null,null,null,false],[179,2,0,null,null,null,null,false],[1,85,0,null,null," Debug printing, allocation and other debug helpers.",null,false],[0,0,0,"debug.zig",null,"",[],false],[180,0,0,null,null,null,null,false],[180,1,0,null,null,null,null,false],[180,2,0,null,null,null,null,false],[180,3,0,null,null,null,null,false],[180,4,0,null,null,null,null,false],[180,5,0,null,null,null,null,false],[180,6,0,null,null,null,null,false],[180,7,0,null,null,null,null,false],[180,8,0,null,null,null,null,false],[180,9,0,null,null,null,null,false],[180,10,0,null,null,null,null,false],[180,11,0,null,null,null,null,false],[180,12,0,null,null,null,null,false],[180,13,0,null,null,null,null,false],[180,14,0,null,null,null,null,false],[180,15,0,null,null,null,null,false],[180,16,0,null,null,null,null,false],[180,17,0,null,null,null,null,false],[180,18,0,null,null,null,null,false],[180,20,0,null,null,null,null,false],[180,25,0,null,null,null,null,false],[180,46,0,null,null,null,[21134,21135,21137],false],[180,51,0,null,null,null,[21132,21133],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"line",null,null,null,false],[0,0,0,"column",null,null,null,false],[180,46,0,null,null,null,null,false],[0,0,0,"file_name",null,null,null,false],[180,56,0,null,null,null,[21143,21145,21147],false],[180,61,0,null,null,null,[21140,21141],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[180,56,0,null,null,null,null,false],[0,0,0,"symbol_name",null,null,null,false],[180,56,0,null,null,null,null,false],[0,0,0,"compile_unit_name",null,null,null,false],[180,56,0,null,null,null,null,false],[0,0,0,"line_info",null,null,null,false],[180,67,0,null,null,null,[21152,21153],false],[180,71,0,null,null,null,[21150,21151],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"pdb",null,null,null,false],[0,0,0,"dwarf",null,null,null,false],[180,79,0,null,null,null,null,false],[180,83,0,null,null," Print to stderr, unbuffered, and silently returning on failure. Intended\n for use in \"printf debugging.\" Use `std.log` functions for proper logging.",[21156,21157],false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[180,90,0,null,null,null,[],false],[180,95,0,null,null," TODO multithreaded awareness",null,false],[180,97,0,null,null,null,[],false],[180,108,0,null,null," Tries to print the current stack trace to stderr, unbuffered, and ignores any error returned.\n TODO multithreaded awareness",[21162],false],[0,0,0,"start_addr",null,"",null,false],[180,133,0,null,null,null,null,false],[180,142,0,null,null," Platform-specific thread state. This contains register state, and on some platforms\n information about the stack. This is not safe to trivially copy, because some platforms\n use internal pointers within this structure. To make a copy, use `copyContext`.",null,false],[180,153,0,null,null," Copies one context to another, updating any internal pointers",[21166,21167],false],[0,0,0,"source",null,"",null,false],[0,0,0,"dest",null,"",null,false],[180,160,0,null,null," Updates any internal pointers in the context to reflect its current location",[21169],false],[0,0,0,"context",null,"",null,false],[180,169,0,null,null,null,null,false],[180,183,0,null,null," Capture the current context. The register values in the context will reflect the\n state after the platform `getcontext` function returns.\n\n It is valid to call this if the platform doesn't have context capturing support,\n in that case false will be returned.",[21172],false],[0,0,0,"context",null,"",null,false],[180,207,0,null,null," Tries to print the stack trace starting from the supplied base pointer to stderr,\n unbuffered, and ignores any error returned.\n TODO multithreaded awareness",[21174],false],[0,0,0,"context",null,"",null,false],[180,262,0,null,null," Returns a slice with the same pointer as addresses, with a potentially smaller len.\n On Windows, when first_address is not null, we ask for at least 32 stack frames,\n and then try to find the first address. If addresses.len is more than 32, we\n capture that many stack frames exactly, and then look for the first address,\n chopping off the irrelevant frames and shifting so that the returned addresses pointer\n equals the passed in addresses pointer.",[21176,21177],false],[0,0,0,"first_address",null,"",null,false],[0,0,0,"stack_trace",null,"",null,false],[180,305,0,null,null," Tries to print a stack trace to stderr, unbuffered, and ignores any error returned.\n TODO multithreaded awareness",[21179],false],[0,0,0,"stack_trace",null,"",null,false],[180,340,0,null,null," This function invokes undefined behavior when `ok` is `false`.\n In Debug and ReleaseSafe modes, calls to this function are always\n generated, and the `unreachable` statement triggers a panic.\n In ReleaseFast and ReleaseSmall modes, calls to this function are\n optimized away, and in fact the optimizer is able to use the assertion\n in its heuristics.\n Inside a test block, it is best to use the `std.testing` module rather\n than this function, because this function may not detect a test failure\n in ReleaseFast and ReleaseSmall mode. Outside of a test block, this assert\n function is the correct function to use.",[21181],false],[0,0,0,"ok",null,"",null,false],[180,344,0,null,null,null,[21183,21184],false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[180,352,0,null,null," `panicExtra` is useful when you want to print out an `@errorReturnTrace`\n and also print out some values.",[21186,21187,21188,21189],false],[0,0,0,"trace",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[180,377,0,null,null," Non-zero whenever the program triggered a panic.\n The counter is incremented/decremented atomically.",null,false],[180,380,0,null,null,null,null,false],[180,384,0,null,null," Counts how many times the panic handler is invoked by this thread.\n This is used to catch and handle panics triggered by the panic handler.",null,false],[180,388,0,null,null,null,[21194,21195,21196],false],[0,0,0,"trace",null,"",null,false],[0,0,0,"first_trace_addr",null,"",null,false],[0,0,0,"msg",null,"",null,false],[180,443,0,null,null," Must be called only after adding 1 to `panicking`. There are three callsites.",[],false],[180,456,0,null,null,null,[21199,21200,21201,21202,21203],false],[0,0,0,"stack_trace",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[180,485,0,null,null,null,null,false],[180,490,0,null,null,null,[21232,21233,21235],false],[180,506,0,null,null,null,[21207,21208],false],[0,0,0,"first_address",null,"",null,false],[0,0,0,"fp",null,"",null,false],[180,520,0,null,null,null,[21210,21211,21212],false],[0,0,0,"first_address",null,"",null,false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"context",null,"",null,false],[180,536,0,null,null,null,[21214],false],[0,0,0,"self",null,"",null,false],[180,540,0,null,null,null,[21216],false],[0,0,0,"self",null,"",[21218,21219],false],[180,540,0,null,null,null,null,false],[0,0,0,"err",null,null,null,false],[0,0,0,"address",null,null,null,false],[180,559,0,null,null,null,null,false],[180,570,0,null,null,null,null,false],[180,577,0,null,null,null,null,false],[180,582,0,null,null,null,[21224],false],[0,0,0,"self",null,"",null,false],[180,595,0,null,null,null,[21226],false],[0,0,0,"address",null,"",null,false],[180,640,0,null,null,null,[21228],false],[0,0,0,"self",null,"",null,false],[180,663,0,null,null,null,[21230],false],[0,0,0,"self",null,"",null,false],[180,490,0,null,null,null,null,false],[0,0,0,"first_address",null,null,null,false],[0,0,0,"fp",null,null,null,false],[180,490,0,null,null,null,null,false],[0,0,0,"unwind_state",null,null,null,false],[180,713,0,null,null,null,[21237,21238,21239,21240],false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[0,0,0,"start_addr",null,"",null,false],[180,743,0,null,null,null,[21242,21243],false],[0,0,0,"addresses",null,"",null,false],[0,0,0,"existing_context",null,"",null,false],[180,799,0,null,null,null,[21245,21246,21247,21248,21249],false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"start_addr",null,"",null,false],[180,820,0,null,null,null,[21251,21252],false],[0,0,0,"symbols",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,865,0,null,null,null,[21254,21255,21256,21257],false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[180,878,0,null,null,null,[21259,21260,21261,21262],false],[0,0,0,"it",null,"",null,false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[180,885,0,null,null,null,[21264,21265,21266,21267,21268],false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"err",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[180,896,0,null,null,null,[21270,21271,21272,21273],false],[0,0,0,"debug_info",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[180,919,0,null,null,null,[21275,21276,21277,21278,21279,21280,21281],false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"line_info",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"symbol_name",null,"",null,false],[0,0,0,"compile_unit_name",null,"",null,false],[0,0,0,"tty_config",null,"",null,false],[0,0,0,"printLineFromFile",null,"",null,true],[180,967,0,null,null,null,null,false],[180,972,0,null,null,null,[21284],false],[0,0,0,"allocator",null,"",null,false],[180,994,0,null,null,null,[21286,21287],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"coff_obj",null,"",null,false],[180,1055,0,null,null,null,[21289,21290,21291],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"size",null,"",null,false],[180,1065,0,null,null," Reads debug info from an ELF file, or the current binary if none in specified.\n If the required sections aren't present but a reference to external debug info is,\n then this this function will recurse to attempt to load the debug sections from\n an external file.",[21293,21294,21295,21296,21297,21298],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"elf_filename",null,"",null,false],[0,0,0,"build_id",null,"",null,false],[0,0,0,"expected_crc",null,"",null,false],[0,0,0,"parent_sections",null,"",null,false],[0,0,0,"parent_mapped_mem",null,"",null,false],[180,1264,0,null,null," This takes ownership of macho_file: users of this function should not close\n it themselves, even on error.\n TODO it's weird to take ownership even on error, rework this code.",[21300,21301],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"macho_file",null,"",null,false],[180,1388,0,null,null,null,[21303,21304],false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"line_info",null,"",null,false],[180,1424,0,null,null,null,[21312,21313,21314,21315],false],[180,1431,0,null,null," Returns the address from the macho file",[21307],false],[0,0,0,"self",null,"",null,false],[180,1435,0,null,null,null,[21309,21310,21311],false],[0,0,0,"context",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[0,0,0,"strx",null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"ofile",null,null,null,false],[180,1444,0,null,null," `file` is expected to have been opened with .intended_io_mode == .blocking.\n Takes ownership of file, even on error.\n TODO it's weird to take ownership even on error, rework this code.",[21317],false],[0,0,0,"file",null,"",null,false],[180,1463,0,null,null,null,[21319,21320,21322,21324,21334],false],[0,0,0,"base_address",null,null,null,false],[0,0,0,"size",null,null,null,false],[180,1463,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[180,1463,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[180,1463,0,null,null,null,[21329,21331,21333],false],[180,1475,0,null,null,null,[21327],false],[0,0,0,"self",null,"",null,false],[180,1470,0,null,null,null,null,false],[0,0,0,"file",null,null,null,false],[180,1470,0,null,null,null,null,false],[0,0,0,"section_handle",null,null,null,false],[180,1470,0,null,null,null,null,false],[0,0,0,"section_view",null,null,null,false],[0,0,0,"mapped_file",null,null,null,false],[180,1484,0,null,null,null,[21371,21373,21375],false],[180,1489,0,null,null,null,[21337],false],[0,0,0,"allocator",null,"",null,false],[180,1533,0,null,null,null,[21339],false],[0,0,0,"self",null,"",null,false],[180,1550,0,null,null,null,[21341,21342],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1567,0,null,null,null,[21344,21345],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1581,0,null,null,null,[21347,21348],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1649,0,null,null,null,[21350,21351],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1687,0,null,null,null,[21353,21354],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1777,0,null,null,null,[21356,21357],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1786,0,null,null,null,[21359,21360],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1824,0,null,null,null,[21362,21363],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1918,0,null,null,null,[21365,21366],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1924,0,null,null,null,[21368,21369],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[180,1484,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[180,1484,0,null,null,null,null,false],[0,0,0,"address_map",null,null,null,false],[180,1484,0,null,null,null,null,false],[0,0,0,"modules",null,null,null,false],[180,1931,0,null,null,null,null,false],[180,2272,0,null,null,null,[21378,21379,21380],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"di",null,"",null,false],[180,2293,0,null,null," TODO multithreaded awareness",null,false],[180,2294,0,null,null,null,null,false],[180,2295,0,null,null,null,[],false],[180,2305,0,null,null," Whether or not the current target can print useful debug information when a segfault occurs.",null,false],[180,2317,0,null,null,null,null,false],[180,2318,0,null,null,null,null,false],[180,2320,0,null,null,null,[],false],[180,2326,0,null,null,null,null,false],[180,2328,0,null,null,null,[21390],false],[0,0,0,"act",null,"",null,false],[180,2336,0,null,null," Attaches a global SIGSEGV handler which calls @panic(\"segmentation fault\");",[],false],[180,2355,0,null,null,null,[],false],[180,2372,0,null,null,null,[21394,21395,21396],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"info",null,"",null,false],[0,0,0,"ctx_ptr",null,"",null,false],[180,2413,0,null,null,null,[21398,21399,21400],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"ctx_ptr",null,"",null,false],[180,2436,0,null,null,null,[21402],false],[0,0,0,"info",null,"",null,false],[180,2446,0,null,null,null,[21404,21405,21406],false],[0,0,0,"info",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"label",null,"",null,false],[180,2488,0,null,null,null,[21408,21409,21410],false],[0,0,0,"info",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"label",null,"",null,false],[180,2500,0,null,null,null,[21412],false],[0,0,0,"prefix",null,"",null,false],[180,2521,0,null,null,null,[],false],[180,2532,0,null,null," This API helps you track where a value originated and where it was mutated,\n or any other points of interest.\n In debug mode, it adds a small size penalty (104 bytes on 64-bit architectures)\n to the aggregate that you add it to.\n In release mode, it is size 0 and all methods are no-ops.\n This is a pre-made type with default settings.\n For more advanced usage, see `ConfigurableTrace`.",null,false],[180,2534,0,null,null,null,[21416,21417,21418],false],[0,0,0,"size",null,"",null,true],[0,0,0,"stack_frame_count",null,"",null,true],[0,0,0,"is_enabled",null,"",[21441,21443,21445],true],[180,2540,0,null,null,null,null,false],[180,2541,0,null,null,null,null,false],[180,2543,0,null,null,null,null,false],[180,2545,0,null,null,null,null,false],[180,2547,0,null,null,null,[21424,21425],false],[0,0,0,"t",null,"",null,false],[0,0,0,"note",null,"",null,false],[180,2552,0,null,null,null,[21427,21428],false],[0,0,0,"t",null,"",null,false],[0,0,0,"note",null,"",null,false],[180,2558,0,null,null,null,[21430,21431,21432],false],[0,0,0,"t",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"note",null,"",null,false],[180,2575,0,null,null,null,[21434],false],[0,0,0,"t",null,"",null,false],[180,2605,0,null,null,null,[21436,21437,21438,21439],false],[0,0,0,"t",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[180,2535,0,null,null,null,null,false],[0,0,0,"addrs",null,null,null,false],[180,2535,0,null,null,null,null,false],[0,0,0,"notes",null,null,null,false],[180,2535,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[1,88,0,null,null," DWARF debugging data format.",null,false],[0,0,0,"dwarf.zig",null,"",[],false],[181,0,0,null,null,null,null,false],[181,1,0,null,null,null,null,false],[181,2,0,null,null,null,null,false],[181,3,0,null,null,null,null,false],[181,4,0,null,null,null,null,false],[181,5,0,null,null,null,null,false],[181,6,0,null,null,null,null,false],[181,7,0,null,null,null,null,false],[0,0,0,"leb128.zig",null,"",[],false],[182,0,0,null,null,null,null,false],[182,1,0,null,null,null,null,false],[182,2,0,null,null,null,null,false],[182,6,0,null,null," Read a single unsigned LEB128 value from the given reader as type T,\n or error.Overflow if the value cannot fit.",[21461,21462],false],[0,0,0,"T",null,"",null,true],[0,0,0,"reader",null,"",null,false],[182,36,0,null,null," Write a single unsigned integer as unsigned LEB128 to the given writer.",[21464,21465],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"uint_value",null,"",null,false],[182,55,0,null,null," Read a single signed LEB128 value from the given reader as type T,\n or error.Overflow if the value cannot fit.",[21467,21468],false],[0,0,0,"T",null,"",null,true],[0,0,0,"reader",null,"",null,false],[182,112,0,null,null," Write a single signed integer as signed LEB128 to the given writer.",[21470,21471],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"int_value",null,"",null,false],[182,140,0,null,null," This is an \"advanced\" function. It allows one to use a fixed amount of memory to store a\n ULEB128. This defeats the entire purpose of using this data encoding; it will no longer use\n fewer bytes to store smaller numbers. The advantage of using a fixed width is that it makes\n fields have a predictable size and so depending on the use case this tradeoff can be worthwhile.\n An example use case of this is in emitting DWARF info where one wants to make a ULEB128 field\n \"relocatable\", meaning that it becomes possible to later go back and patch the number to be a\n different value without shifting all the following code.",[21473,21474,21475],false],[0,0,0,"l",null,"",null,true],[0,0,0,"ptr",null,"",null,false],[0,0,0,"int",null,"",null,false],[182,178,0,null,null,null,[21477,21478],false],[0,0,0,"T",null,"",null,true],[0,0,0,"encoded",null,"",null,false],[182,183,0,null,null,null,[21480,21481],false],[0,0,0,"T",null,"",null,true],[0,0,0,"encoded",null,"",null,false],[182,188,0,null,null,null,[21483,21484],false],[0,0,0,"T",null,"",null,true],[0,0,0,"encoded",null,"",null,false],[182,194,0,null,null,null,[21486,21487],false],[0,0,0,"T",null,"",null,true],[0,0,0,"encoded",null,"",null,false],[182,200,0,null,null,null,[21489,21490,21491],false],[0,0,0,"T",null,"",null,true],[0,0,0,"N",null,"",null,true],[0,0,0,"encoded",null,"",null,false],[182,208,0,null,null,null,[21493,21494,21495],false],[0,0,0,"T",null,"",null,true],[0,0,0,"N",null,"",null,true],[0,0,0,"encoded",null,"",null,false],[182,303,0,null,null,null,[21497],false],[0,0,0,"value",null,"",null,false],[181,8,0,null,null,null,null,false],[181,10,0,null,null,null,null,false],[0,0,0,"dwarf/TAG.zig",null,"",[],false],[183,0,0,null,null,null,null,false],[183,1,0,null,null,null,null,false],[183,2,0,null,null,null,null,false],[183,3,0,null,null,null,null,false],[183,4,0,null,null,null,null,false],[183,5,0,null,null,null,null,false],[183,6,0,null,null,null,null,false],[183,7,0,null,null,null,null,false],[183,8,0,null,null,null,null,false],[183,9,0,null,null,null,null,false],[183,10,0,null,null,null,null,false],[183,11,0,null,null,null,null,false],[183,12,0,null,null,null,null,false],[183,13,0,null,null,null,null,false],[183,14,0,null,null,null,null,false],[183,15,0,null,null,null,null,false],[183,16,0,null,null,null,null,false],[183,17,0,null,null,null,null,false],[183,18,0,null,null,null,null,false],[183,19,0,null,null,null,null,false],[183,20,0,null,null,null,null,false],[183,21,0,null,null,null,null,false],[183,22,0,null,null,null,null,false],[183,23,0,null,null,null,null,false],[183,24,0,null,null,null,null,false],[183,25,0,null,null,null,null,false],[183,26,0,null,null,null,null,false],[183,27,0,null,null,null,null,false],[183,28,0,null,null,null,null,false],[183,29,0,null,null,null,null,false],[183,30,0,null,null,null,null,false],[183,31,0,null,null,null,null,false],[183,32,0,null,null,null,null,false],[183,33,0,null,null,null,null,false],[183,34,0,null,null,null,null,false],[183,35,0,null,null,null,null,false],[183,36,0,null,null,null,null,false],[183,37,0,null,null,null,null,false],[183,38,0,null,null,null,null,false],[183,39,0,null,null,null,null,false],[183,40,0,null,null,null,null,false],[183,41,0,null,null,null,null,false],[183,42,0,null,null,null,null,false],[183,43,0,null,null,null,null,false],[183,44,0,null,null,null,null,false],[183,45,0,null,null,null,null,false],[183,46,0,null,null,null,null,false],[183,47,0,null,null,null,null,false],[183,48,0,null,null,null,null,false],[183,51,0,null,null,null,null,false],[183,52,0,null,null,null,null,false],[183,53,0,null,null,null,null,false],[183,54,0,null,null,null,null,false],[183,55,0,null,null,null,null,false],[183,56,0,null,null,null,null,false],[183,57,0,null,null,null,null,false],[183,58,0,null,null,null,null,false],[183,59,0,null,null,null,null,false],[183,60,0,null,null,null,null,false],[183,63,0,null,null,null,null,false],[183,64,0,null,null,null,null,false],[183,65,0,null,null,null,null,false],[183,68,0,null,null,null,null,false],[183,69,0,null,null,null,null,false],[183,70,0,null,null,null,null,false],[183,71,0,null,null,null,null,false],[183,72,0,null,null,null,null,false],[183,73,0,null,null,null,null,false],[183,74,0,null,null,null,null,false],[183,75,0,null,null,null,null,false],[183,77,0,null,null,null,null,false],[183,78,0,null,null,null,null,false],[183,81,0,null,null,null,null,false],[183,84,0,null,null,null,null,false],[183,85,0,null,null,null,null,false],[183,86,0,null,null,null,null,false],[183,89,0,null,null,null,null,false],[183,90,0,null,null,null,null,false],[183,91,0,null,null,null,null,false],[183,92,0,null,null,null,null,false],[183,93,0,null,null,null,null,false],[183,97,0,null,null,null,null,false],[183,103,0,null,null,null,null,false],[183,104,0,null,null,null,null,false],[183,109,0,null,null,null,null,false],[183,110,0,null,null,null,null,false],[183,112,0,null,null,null,null,false],[183,113,0,null,null,null,null,false],[183,114,0,null,null,null,null,false],[183,116,0,null,null,null,null,false],[183,117,0,null,null,null,null,false],[181,11,0,null,null,null,null,false],[0,0,0,"dwarf/AT.zig",null,"",[],false],[184,0,0,null,null,null,null,false],[184,1,0,null,null,null,null,false],[184,2,0,null,null,null,null,false],[184,3,0,null,null,null,null,false],[184,4,0,null,null,null,null,false],[184,5,0,null,null,null,null,false],[184,6,0,null,null,null,null,false],[184,7,0,null,null,null,null,false],[184,8,0,null,null,null,null,false],[184,9,0,null,null,null,null,false],[184,10,0,null,null,null,null,false],[184,11,0,null,null,null,null,false],[184,12,0,null,null,null,null,false],[184,13,0,null,null,null,null,false],[184,14,0,null,null,null,null,false],[184,15,0,null,null,null,null,false],[184,16,0,null,null,null,null,false],[184,17,0,null,null,null,null,false],[184,18,0,null,null,null,null,false],[184,19,0,null,null,null,null,false],[184,20,0,null,null,null,null,false],[184,21,0,null,null,null,null,false],[184,22,0,null,null,null,null,false],[184,23,0,null,null,null,null,false],[184,24,0,null,null,null,null,false],[184,25,0,null,null,null,null,false],[184,26,0,null,null,null,null,false],[184,27,0,null,null,null,null,false],[184,28,0,null,null,null,null,false],[184,29,0,null,null,null,null,false],[184,30,0,null,null,null,null,false],[184,31,0,null,null,null,null,false],[184,32,0,null,null,null,null,false],[184,33,0,null,null,null,null,false],[184,34,0,null,null,null,null,false],[184,35,0,null,null,null,null,false],[184,36,0,null,null,null,null,false],[184,37,0,null,null,null,null,false],[184,38,0,null,null,null,null,false],[184,39,0,null,null,null,null,false],[184,40,0,null,null,null,null,false],[184,41,0,null,null,null,null,false],[184,42,0,null,null,null,null,false],[184,43,0,null,null,null,null,false],[184,44,0,null,null,null,null,false],[184,45,0,null,null,null,null,false],[184,46,0,null,null,null,null,false],[184,47,0,null,null,null,null,false],[184,48,0,null,null,null,null,false],[184,49,0,null,null,null,null,false],[184,50,0,null,null,null,null,false],[184,51,0,null,null,null,null,false],[184,52,0,null,null,null,null,false],[184,53,0,null,null,null,null,false],[184,54,0,null,null,null,null,false],[184,55,0,null,null,null,null,false],[184,56,0,null,null,null,null,false],[184,57,0,null,null,null,null,false],[184,58,0,null,null,null,null,false],[184,59,0,null,null,null,null,false],[184,60,0,null,null,null,null,false],[184,61,0,null,null,null,null,false],[184,64,0,null,null,null,null,false],[184,65,0,null,null,null,null,false],[184,66,0,null,null,null,null,false],[184,67,0,null,null,null,null,false],[184,68,0,null,null,null,null,false],[184,69,0,null,null,null,null,false],[184,70,0,null,null,null,null,false],[184,71,0,null,null,null,null,false],[184,72,0,null,null,null,null,false],[184,73,0,null,null,null,null,false],[184,74,0,null,null,null,null,false],[184,75,0,null,null,null,null,false],[184,76,0,null,null,null,null,false],[184,77,0,null,null,null,null,false],[184,78,0,null,null,null,null,false],[184,79,0,null,null,null,null,false],[184,80,0,null,null,null,null,false],[184,81,0,null,null,null,null,false],[184,82,0,null,null,null,null,false],[184,83,0,null,null,null,null,false],[184,84,0,null,null,null,null,false],[184,85,0,null,null,null,null,false],[184,86,0,null,null,null,null,false],[184,87,0,null,null,null,null,false],[184,88,0,null,null,null,null,false],[184,89,0,null,null,null,null,false],[184,90,0,null,null,null,null,false],[184,93,0,null,null,null,null,false],[184,94,0,null,null,null,null,false],[184,95,0,null,null,null,null,false],[184,96,0,null,null,null,null,false],[184,97,0,null,null,null,null,false],[184,98,0,null,null,null,null,false],[184,101,0,null,null,null,null,false],[184,102,0,null,null,null,null,false],[184,103,0,null,null,null,null,false],[184,104,0,null,null,null,null,false],[184,105,0,null,null,null,null,false],[184,106,0,null,null,null,null,false],[184,107,0,null,null,null,null,false],[184,108,0,null,null,null,null,false],[184,109,0,null,null,null,null,false],[184,110,0,null,null,null,null,false],[184,111,0,null,null,null,null,false],[184,112,0,null,null,null,null,false],[184,113,0,null,null,null,null,false],[184,114,0,null,null,null,null,false],[184,115,0,null,null,null,null,false],[184,116,0,null,null,null,null,false],[184,117,0,null,null,null,null,false],[184,118,0,null,null,null,null,false],[184,119,0,null,null,null,null,false],[184,120,0,null,null,null,null,false],[184,121,0,null,null,null,null,false],[184,122,0,null,null,null,null,false],[184,123,0,null,null,null,null,false],[184,124,0,null,null,null,null,false],[184,125,0,null,null,null,null,false],[184,126,0,null,null,null,null,false],[184,127,0,null,null,null,null,false],[184,128,0,null,null,null,null,false],[184,129,0,null,null,null,null,false],[184,131,0,null,null,null,null,false],[184,132,0,null,null,null,null,false],[184,135,0,null,null,null,null,false],[184,136,0,null,null,null,null,false],[184,137,0,null,null,null,null,false],[184,138,0,null,null,null,null,false],[184,139,0,null,null,null,null,false],[184,140,0,null,null,null,null,false],[184,141,0,null,null,null,null,false],[184,142,0,null,null,null,null,false],[184,143,0,null,null,null,null,false],[184,144,0,null,null,null,null,false],[184,145,0,null,null,null,null,false],[184,148,0,null,null,null,null,false],[184,149,0,null,null,null,null,false],[184,150,0,null,null,null,null,false],[184,151,0,null,null,null,null,false],[184,152,0,null,null,null,null,false],[184,153,0,null,null,null,null,false],[184,154,0,null,null,null,null,false],[184,155,0,null,null,null,null,false],[184,156,0,null,null,null,null,false],[184,157,0,null,null,null,null,false],[184,158,0,null,null,null,null,false],[184,159,0,null,null,null,null,false],[184,160,0,null,null,null,null,false],[184,161,0,null,null,null,null,false],[184,162,0,null,null,null,null,false],[184,163,0,null,null,null,null,false],[184,164,0,null,null,null,null,false],[184,165,0,null,null,null,null,false],[184,166,0,null,null,null,null,false],[184,167,0,null,null,null,null,false],[184,168,0,null,null,null,null,false],[184,169,0,null,null,null,null,false],[184,172,0,null,null,null,null,false],[184,173,0,null,null,null,null,false],[184,174,0,null,null,null,null,false],[184,175,0,null,null,null,null,false],[184,176,0,null,null,null,null,false],[184,177,0,null,null,null,null,false],[184,178,0,null,null,null,null,false],[184,181,0,null,null,null,null,false],[184,182,0,null,null,null,null,false],[184,183,0,null,null,null,null,false],[184,184,0,null,null,null,null,false],[184,185,0,null,null,null,null,false],[184,186,0,null,null,null,null,false],[184,187,0,null,null,null,null,false],[184,190,0,null,null,null,null,false],[184,193,0,null,null,null,null,false],[184,196,0,null,null,null,null,false],[184,197,0,null,null,null,null,false],[184,198,0,null,null,null,null,false],[184,199,0,null,null,null,null,false],[184,200,0,null,null,null,null,false],[184,201,0,null,null,null,null,false],[184,202,0,null,null,null,null,false],[184,203,0,null,null,null,null,false],[184,205,0,null,null,null,null,false],[184,207,0,null,null,null,null,false],[184,208,0,null,null,null,null,false],[184,209,0,null,null,null,null,false],[184,210,0,null,null,null,null,false],[184,211,0,null,null,null,null,false],[184,212,0,null,null,null,null,false],[184,214,0,null,null,null,null,false],[184,218,0,null,null,null,null,false],[184,219,0,null,null,null,null,false],[184,221,0,null,null,null,null,false],[184,223,0,null,null,null,null,false],[184,224,0,null,null,null,null,false],[184,225,0,null,null,null,null,false],[181,12,0,null,null,null,null,false],[0,0,0,"dwarf/OP.zig",null,"",[],false],[185,0,0,null,null,null,null,false],[185,1,0,null,null,null,null,false],[185,2,0,null,null,null,null,false],[185,3,0,null,null,null,null,false],[185,4,0,null,null,null,null,false],[185,5,0,null,null,null,null,false],[185,6,0,null,null,null,null,false],[185,7,0,null,null,null,null,false],[185,8,0,null,null,null,null,false],[185,9,0,null,null,null,null,false],[185,10,0,null,null,null,null,false],[185,11,0,null,null,null,null,false],[185,12,0,null,null,null,null,false],[185,13,0,null,null,null,null,false],[185,14,0,null,null,null,null,false],[185,15,0,null,null,null,null,false],[185,16,0,null,null,null,null,false],[185,17,0,null,null,null,null,false],[185,18,0,null,null,null,null,false],[185,19,0,null,null,null,null,false],[185,20,0,null,null,null,null,false],[185,21,0,null,null,null,null,false],[185,22,0,null,null,null,null,false],[185,23,0,null,null,null,null,false],[185,24,0,null,null,null,null,false],[185,25,0,null,null,null,null,false],[185,26,0,null,null,null,null,false],[185,27,0,null,null,null,null,false],[185,28,0,null,null,null,null,false],[185,29,0,null,null,null,null,false],[185,30,0,null,null,null,null,false],[185,31,0,null,null,null,null,false],[185,32,0,null,null,null,null,false],[185,33,0,null,null,null,null,false],[185,34,0,null,null,null,null,false],[185,35,0,null,null,null,null,false],[185,36,0,null,null,null,null,false],[185,37,0,null,null,null,null,false],[185,38,0,null,null,null,null,false],[185,39,0,null,null,null,null,false],[185,40,0,null,null,null,null,false],[185,41,0,null,null,null,null,false],[185,42,0,null,null,null,null,false],[185,43,0,null,null,null,null,false],[185,44,0,null,null,null,null,false],[185,45,0,null,null,null,null,false],[185,46,0,null,null,null,null,false],[185,47,0,null,null,null,null,false],[185,48,0,null,null,null,null,false],[185,49,0,null,null,null,null,false],[185,50,0,null,null,null,null,false],[185,51,0,null,null,null,null,false],[185,52,0,null,null,null,null,false],[185,53,0,null,null,null,null,false],[185,54,0,null,null,null,null,false],[185,55,0,null,null,null,null,false],[185,56,0,null,null,null,null,false],[185,57,0,null,null,null,null,false],[185,58,0,null,null,null,null,false],[185,59,0,null,null,null,null,false],[185,60,0,null,null,null,null,false],[185,61,0,null,null,null,null,false],[185,62,0,null,null,null,null,false],[185,63,0,null,null,null,null,false],[185,64,0,null,null,null,null,false],[185,65,0,null,null,null,null,false],[185,66,0,null,null,null,null,false],[185,67,0,null,null,null,null,false],[185,68,0,null,null,null,null,false],[185,69,0,null,null,null,null,false],[185,70,0,null,null,null,null,false],[185,71,0,null,null,null,null,false],[185,72,0,null,null,null,null,false],[185,73,0,null,null,null,null,false],[185,74,0,null,null,null,null,false],[185,75,0,null,null,null,null,false],[185,76,0,null,null,null,null,false],[185,77,0,null,null,null,null,false],[185,78,0,null,null,null,null,false],[185,79,0,null,null,null,null,false],[185,80,0,null,null,null,null,false],[185,81,0,null,null,null,null,false],[185,82,0,null,null,null,null,false],[185,83,0,null,null,null,null,false],[185,84,0,null,null,null,null,false],[185,85,0,null,null,null,null,false],[185,86,0,null,null,null,null,false],[185,87,0,null,null,null,null,false],[185,88,0,null,null,null,null,false],[185,89,0,null,null,null,null,false],[185,90,0,null,null,null,null,false],[185,91,0,null,null,null,null,false],[185,92,0,null,null,null,null,false],[185,93,0,null,null,null,null,false],[185,94,0,null,null,null,null,false],[185,95,0,null,null,null,null,false],[185,96,0,null,null,null,null,false],[185,97,0,null,null,null,null,false],[185,98,0,null,null,null,null,false],[185,99,0,null,null,null,null,false],[185,100,0,null,null,null,null,false],[185,101,0,null,null,null,null,false],[185,102,0,null,null,null,null,false],[185,103,0,null,null,null,null,false],[185,104,0,null,null,null,null,false],[185,105,0,null,null,null,null,false],[185,106,0,null,null,null,null,false],[185,107,0,null,null,null,null,false],[185,108,0,null,null,null,null,false],[185,109,0,null,null,null,null,false],[185,110,0,null,null,null,null,false],[185,111,0,null,null,null,null,false],[185,112,0,null,null,null,null,false],[185,113,0,null,null,null,null,false],[185,114,0,null,null,null,null,false],[185,115,0,null,null,null,null,false],[185,116,0,null,null,null,null,false],[185,117,0,null,null,null,null,false],[185,118,0,null,null,null,null,false],[185,119,0,null,null,null,null,false],[185,120,0,null,null,null,null,false],[185,121,0,null,null,null,null,false],[185,122,0,null,null,null,null,false],[185,123,0,null,null,null,null,false],[185,124,0,null,null,null,null,false],[185,125,0,null,null,null,null,false],[185,126,0,null,null,null,null,false],[185,127,0,null,null,null,null,false],[185,128,0,null,null,null,null,false],[185,129,0,null,null,null,null,false],[185,130,0,null,null,null,null,false],[185,131,0,null,null,null,null,false],[185,132,0,null,null,null,null,false],[185,133,0,null,null,null,null,false],[185,134,0,null,null,null,null,false],[185,135,0,null,null,null,null,false],[185,136,0,null,null,null,null,false],[185,137,0,null,null,null,null,false],[185,138,0,null,null,null,null,false],[185,139,0,null,null,null,null,false],[185,140,0,null,null,null,null,false],[185,141,0,null,null,null,null,false],[185,142,0,null,null,null,null,false],[185,143,0,null,null,null,null,false],[185,144,0,null,null,null,null,false],[185,147,0,null,null,null,null,false],[185,148,0,null,null,null,null,false],[185,149,0,null,null,null,null,false],[185,150,0,null,null,null,null,false],[185,151,0,null,null,null,null,false],[185,152,0,null,null,null,null,false],[185,153,0,null,null,null,null,false],[185,156,0,null,null,null,null,false],[185,157,0,null,null,null,null,false],[185,160,0,null,null,null,null,false],[185,161,0,null,null,null,null,false],[185,162,0,null,null,null,null,false],[185,163,0,null,null,null,null,false],[185,164,0,null,null,null,null,false],[185,165,0,null,null,null,null,false],[185,166,0,null,null,null,null,false],[185,167,0,null,null,null,null,false],[185,168,0,null,null,null,null,false],[185,169,0,null,null,null,null,false],[185,171,0,null,null,null,null,false],[185,172,0,null,null,null,null,false],[185,175,0,null,null,null,null,false],[185,177,0,null,null,null,null,false],[185,178,0,null,null,null,null,false],[185,181,0,null,null,null,null,false],[185,184,0,null,null,null,null,false],[185,187,0,null,null,null,null,false],[185,188,0,null,null,null,null,false],[185,189,0,null,null,null,null,false],[185,190,0,null,null,null,null,false],[185,191,0,null,null,null,null,false],[185,193,0,null,null,null,null,false],[185,195,0,null,null,null,null,false],[185,196,0,null,null,null,null,false],[185,198,0,null,null,null,null,false],[185,199,0,null,null,null,null,false],[185,200,0,null,null,null,null,false],[185,201,0,null,null,null,null,false],[185,202,0,null,null,null,null,false],[185,203,0,null,null,null,null,false],[185,204,0,null,null,null,null,false],[185,206,0,null,null,null,null,false],[185,208,0,null,null,null,null,false],[185,209,0,null,null,null,null,false],[185,210,0,null,null,null,null,false],[185,211,0,null,null,null,null,false],[185,212,0,null,null,null,null,false],[181,13,0,null,null,null,null,false],[0,0,0,"dwarf/LANG.zig",null,"",[],false],[186,0,0,null,null,null,null,false],[186,1,0,null,null,null,null,false],[186,2,0,null,null,null,null,false],[186,3,0,null,null,null,null,false],[186,4,0,null,null,null,null,false],[186,5,0,null,null,null,null,false],[186,6,0,null,null,null,null,false],[186,7,0,null,null,null,null,false],[186,8,0,null,null,null,null,false],[186,9,0,null,null,null,null,false],[186,10,0,null,null,null,null,false],[186,11,0,null,null,null,null,false],[186,12,0,null,null,null,null,false],[186,13,0,null,null,null,null,false],[186,14,0,null,null,null,null,false],[186,15,0,null,null,null,null,false],[186,16,0,null,null,null,null,false],[186,17,0,null,null,null,null,false],[186,18,0,null,null,null,null,false],[186,19,0,null,null,null,null,false],[186,20,0,null,null,null,null,false],[186,21,0,null,null,null,null,false],[186,22,0,null,null,null,null,false],[186,23,0,null,null,null,null,false],[186,24,0,null,null,null,null,false],[186,25,0,null,null,null,null,false],[186,26,0,null,null,null,null,false],[186,27,0,null,null,null,null,false],[186,28,0,null,null,null,null,false],[186,29,0,null,null,null,null,false],[186,30,0,null,null,null,null,false],[186,31,0,null,null,null,null,false],[186,32,0,null,null,null,null,false],[186,33,0,null,null,null,null,false],[186,34,0,null,null,null,null,false],[186,35,0,null,null,null,null,false],[186,36,0,null,null,null,null,false],[186,38,0,null,null,null,null,false],[186,39,0,null,null,null,null,false],[186,41,0,null,null,null,null,false],[186,42,0,null,null,null,null,false],[186,43,0,null,null,null,null,false],[186,44,0,null,null,null,null,false],[186,45,0,null,null,null,null,false],[186,46,0,null,null,null,null,false],[186,47,0,null,null,null,null,false],[181,14,0,null,null,null,null,false],[0,0,0,"dwarf/FORM.zig",null,"",[],false],[187,0,0,null,null,null,null,false],[187,1,0,null,null,null,null,false],[187,2,0,null,null,null,null,false],[187,3,0,null,null,null,null,false],[187,4,0,null,null,null,null,false],[187,5,0,null,null,null,null,false],[187,6,0,null,null,null,null,false],[187,7,0,null,null,null,null,false],[187,8,0,null,null,null,null,false],[187,9,0,null,null,null,null,false],[187,10,0,null,null,null,null,false],[187,11,0,null,null,null,null,false],[187,12,0,null,null,null,null,false],[187,13,0,null,null,null,null,false],[187,14,0,null,null,null,null,false],[187,15,0,null,null,null,null,false],[187,16,0,null,null,null,null,false],[187,17,0,null,null,null,null,false],[187,18,0,null,null,null,null,false],[187,19,0,null,null,null,null,false],[187,20,0,null,null,null,null,false],[187,21,0,null,null,null,null,false],[187,22,0,null,null,null,null,false],[187,23,0,null,null,null,null,false],[187,24,0,null,null,null,null,false],[187,25,0,null,null,null,null,false],[187,26,0,null,null,null,null,false],[187,27,0,null,null,null,null,false],[187,28,0,null,null,null,null,false],[187,29,0,null,null,null,null,false],[187,30,0,null,null,null,null,false],[187,31,0,null,null,null,null,false],[187,32,0,null,null,null,null,false],[187,33,0,null,null,null,null,false],[187,34,0,null,null,null,null,false],[187,35,0,null,null,null,null,false],[187,36,0,null,null,null,null,false],[187,37,0,null,null,null,null,false],[187,38,0,null,null,null,null,false],[187,39,0,null,null,null,null,false],[187,40,0,null,null,null,null,false],[187,41,0,null,null,null,null,false],[187,42,0,null,null,null,null,false],[187,45,0,null,null,null,null,false],[187,46,0,null,null,null,null,false],[187,50,0,null,null,null,null,false],[187,51,0,null,null,null,null,false],[181,15,0,null,null,null,null,false],[0,0,0,"dwarf/ATE.zig",null,"",[],false],[188,0,0,null,null,null,null,false],[188,1,0,null,null,null,null,false],[188,2,0,null,null,null,null,false],[188,3,0,null,null,null,null,false],[188,4,0,null,null,null,null,false],[188,5,0,null,null,null,null,false],[188,6,0,null,null,null,null,false],[188,7,0,null,null,null,null,false],[188,8,0,null,null,null,null,false],[188,11,0,null,null,null,null,false],[188,12,0,null,null,null,null,false],[188,13,0,null,null,null,null,false],[188,14,0,null,null,null,null,false],[188,15,0,null,null,null,null,false],[188,16,0,null,null,null,null,false],[188,17,0,null,null,null,null,false],[188,20,0,null,null,null,null,false],[188,23,0,null,null,null,null,false],[188,24,0,null,null,null,null,false],[188,26,0,null,null,null,null,false],[188,27,0,null,null,null,null,false],[188,30,0,null,null,null,null,false],[188,31,0,null,null,null,null,false],[188,32,0,null,null,null,null,false],[188,33,0,null,null,null,null,false],[188,34,0,null,null,null,null,false],[188,35,0,null,null,null,null,false],[188,36,0,null,null,null,null,false],[188,37,0,null,null,null,null,false],[188,38,0,null,null,null,null,false],[188,39,0,null,null,null,null,false],[188,40,0,null,null,null,null,false],[188,41,0,null,null,null,null,false],[188,42,0,null,null,null,null,false],[188,43,0,null,null,null,null,false],[188,44,0,null,null,null,null,false],[188,45,0,null,null,null,null,false],[181,16,0,null,null,null,null,false],[0,0,0,"dwarf/EH.zig",null,"",[],false],[189,0,0,null,null,null,[],false],[189,1,0,null,null,null,null,false],[189,3,0,null,null,null,null,false],[189,4,0,null,null,null,null,false],[189,5,0,null,null,null,null,false],[189,7,0,null,null,null,null,false],[189,8,0,null,null,null,null,false],[189,9,0,null,null,null,null,false],[189,10,0,null,null,null,null,false],[189,11,0,null,null,null,null,false],[189,12,0,null,null,null,null,false],[189,13,0,null,null,null,null,false],[189,14,0,null,null,null,null,false],[189,16,0,null,null,null,null,false],[189,17,0,null,null,null,null,false],[189,18,0,null,null,null,null,false],[189,19,0,null,null,null,null,false],[189,20,0,null,null,null,null,false],[189,21,0,null,null,null,null,false],[189,23,0,null,null,null,null,false],[189,25,0,null,null,null,null,false],[181,17,0,null,null,null,null,false],[0,0,0,"dwarf/abi.zig",null,"",[],false],[190,0,0,null,null,null,null,false],[190,1,0,null,null,null,null,false],[190,2,0,null,null,null,null,false],[190,3,0,null,null,null,null,false],[190,5,0,null,null,null,[22151],false],[0,0,0,"target",null,"",null,false],[190,27,0,null,null,null,[],false],[190,37,0,null,null,null,[22154],false],[0,0,0,"reg_context",null,"",null,false],[190,48,0,null,null,null,[22156],false],[0,0,0,"reg_context",null,"",null,false],[190,60,0,null,null," Some platforms use pointer authentication - the upper bits of instruction pointers contain a signature.\n This function clears these signature bits to make the pointer usable.",[22158],false],[0,0,0,"ptr",null,"",null,false],[190,79,0,null,null,null,[22160,22161],false],[0,0,0,"eh_frame",null,null,null,false],[0,0,0,"is_macho",null,null,null,false],[190,84,0,null,null,null,null,false],[190,92,0,null,null,null,[22164,22165],false],[0,0,0,"ContextPtrType",null,"",null,true],[0,0,0,"T",null,"",null,true],[190,110,0,null,null," Returns a pointer to a register stored in a ThreadContext, preserving the pointer attributes of the context.",[22167,22168,22169,22170],false],[0,0,0,"T",null,"",null,true],[0,0,0,"thread_context_ptr",null,"",null,false],[0,0,0,"reg_number",null,"",null,false],[0,0,0,"reg_context",null,"",null,false],[190,121,0,null,null,null,[22172],false],[0,0,0,"ContextPtrType",null,"",null,true],[190,135,0,null,null," Returns a slice containing the backing storage for `reg_number`.\n\n `reg_context` describes in what context the register number is used, as it can have different\n meanings depending on the DWARF container. It is only required when getting the stack or\n frame pointer register on some architectures.",[22174,22175,22176],false],[0,0,0,"thread_context_ptr",null,"",null,false],[0,0,0,"reg_number",null,"",null,false],[0,0,0,"reg_context",null,"",null,false],[190,382,0,null,null," Returns the ABI-defined default value this register has in the unwinding table\n before running any of the CIE instructions. The DWARF spec defines these as having\n the .undefined rule by default, but allows ABI authors to override that.",[22178,22179,22180],false],[0,0,0,"reg_number",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"out",null,"",null,false],[181,18,0,null,null,null,null,false],[0,0,0,"dwarf/call_frame.zig",null,"",[],false],[191,0,0,null,null,null,null,false],[191,1,0,null,null,null,null,false],[191,2,0,null,null,null,null,false],[191,3,0,null,null,null,null,false],[191,4,0,null,null,null,null,false],[191,5,0,null,null,null,null,false],[191,6,0,null,null,null,null,false],[191,7,0,null,null,null,null,false],[191,8,0,null,null,null,null,false],[191,10,0,null,null,null,[22199,22200,22201,22202,22203,22204,22205,22206,22207,22208,22209,22210,22211,22212,22213,22214,22215,22216,22217,22218,22219,22220,22221,22222,22223,22224],false],[191,40,0,null,null,null,null,false],[191,41,0,null,null,null,null,false],[191,44,0,null,null,null,null,false],[191,45,0,null,null,null,null,false],[191,48,0,null,null,null,null,false],[191,49,0,null,null,null,null,false],[0,0,0,"advance_loc",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"restore",null,null,null,false],[0,0,0,"nop",null,null,null,false],[0,0,0,"set_loc",null,null,null,false],[0,0,0,"advance_loc1",null,null,null,false],[0,0,0,"advance_loc2",null,null,null,false],[0,0,0,"advance_loc4",null,null,null,false],[0,0,0,"offset_extended",null,null,null,false],[0,0,0,"restore_extended",null,null,null,false],[0,0,0,"undefined",null,null,null,false],[0,0,0,"same_value",null,null,null,false],[0,0,0,"register",null,null,null,false],[0,0,0,"remember_state",null,null,null,false],[0,0,0,"restore_state",null,null,null,false],[0,0,0,"def_cfa",null,null,null,false],[0,0,0,"def_cfa_register",null,null,null,false],[0,0,0,"def_cfa_offset",null,null,null,false],[0,0,0,"def_cfa_expression",null,null,null,false],[0,0,0,"expression",null,null,null,false],[0,0,0,"offset_extended_sf",null,null,null,false],[0,0,0,"def_cfa_sf",null,null,null,false],[0,0,0,"def_cfa_offset_sf",null,null,null,false],[0,0,0,"val_offset",null,null,null,false],[0,0,0,"val_offset_sf",null,null,null,false],[0,0,0,"val_expression",null,null,null,false],[191,52,0,null,null,null,[22226],false],[0,0,0,"stream",null,"",null,false],[191,63,0,null,null,null,[22233,22236,22238,22239,22241,22243,22245,22247,22250,22252,22254,22256,22259,22260,22261,22264,22266,22268,22271,22275,22278,22281,22283,22286,22289,22293],false],[191,147,0,null,null,null,[22229,22230,22231],false],[0,0,0,"stream",null,"",null,false],[0,0,0,"addr_size_bytes",null,"",null,false],[0,0,0,"endian",null,"",[22232],false],[0,0,0,"delta",null,null,null,false],[0,0,0,"advance_loc",null,null,[22234,22235],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"offset",null,null,[22237],false],[0,0,0,"register",null,null,null,false],[0,0,0,"restore",null,null,null,false],[0,0,0,"nop",null,null,[22240],false],[0,0,0,"address",null,null,null,false],[0,0,0,"set_loc",null,null,[22242],false],[0,0,0,"delta",null,null,null,false],[0,0,0,"advance_loc1",null,null,[22244],false],[0,0,0,"delta",null,null,null,false],[0,0,0,"advance_loc2",null,null,[22246],false],[0,0,0,"delta",null,null,null,false],[0,0,0,"advance_loc4",null,null,[22248,22249],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"offset_extended",null,null,[22251],false],[0,0,0,"register",null,null,null,false],[0,0,0,"restore_extended",null,null,[22253],false],[0,0,0,"register",null,null,null,false],[0,0,0,"undefined",null,null,[22255],false],[0,0,0,"register",null,null,null,false],[0,0,0,"same_value",null,null,[22257,22258],false],[0,0,0,"register",null,null,null,false],[0,0,0,"target_register",null,null,null,false],[0,0,0,"register",null,null,null,false],[0,0,0,"remember_state",null,null,null,false],[0,0,0,"restore_state",null,null,[22262,22263],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"def_cfa",null,null,[22265],false],[0,0,0,"register",null,null,null,false],[0,0,0,"def_cfa_register",null,null,[22267],false],[0,0,0,"offset",null,null,null,false],[0,0,0,"def_cfa_offset",null,null,[22270],false],[191,116,0,null,null,null,null,false],[0,0,0,"block",null,null,null,false],[0,0,0,"def_cfa_expression",null,null,[22272,22274],false],[0,0,0,"register",null,null,null,false],[191,119,0,null,null,null,null,false],[0,0,0,"block",null,null,null,false],[0,0,0,"expression",null,null,[22276,22277],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"offset_extended_sf",null,null,[22279,22280],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"def_cfa_sf",null,null,[22282],false],[0,0,0,"offset",null,null,null,false],[0,0,0,"def_cfa_offset_sf",null,null,[22284,22285],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"val_offset",null,null,[22287,22288],false],[0,0,0,"register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"val_offset_sf",null,null,[22290,22292],false],[0,0,0,"register",null,null,null,false],[191,142,0,null,null,null,null,false],[0,0,0,"block",null,null,null,false],[0,0,0,"val_expression",null,null,null,false],[191,302,0,null,null," Since register rules are applied (usually) during a panic,\n checked addition / subtraction is used so that we can return\n an error and fall back to FP-based unwinding.",[22295,22296],false],[0,0,0,"base",null,"",null,false],[0,0,0,"offset",null,"",null,false],[191,310,0,null,null," This is a virtual machine that runs DWARF call frame instructions.",[22364,22366,22368,22370],false],[191,312,0,null,null," See section 6.4.1 of the DWARF5 specification for details on each",[22299,22300,22301,22302,22303,22304,22305,22306,22307],false],[0,0,0,"default",null,null,null,false],[0,0,0,"undefined",null,null,null,false],[0,0,0,"same_value",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"val_offset",null,null,null,false],[0,0,0,"register",null,null,null,false],[0,0,0,"expression",null,null,null,false],[0,0,0,"val_expression",null,null,null,false],[0,0,0,"architectural",null,null,null,false],[191,341,0,null,null," Each row contains unwinding rules for a set of registers.",[22309,22311,22313,22314],false],[0,0,0,"offset",null," Offset from `FrameDescriptionEntry.pc_begin`",null,false],[191,341,0,null,null,null,null,false],[0,0,0,"cfa",null," Special-case column that defines the CFA (Canonical Frame Address) rule.\n The register field of this column defines the register that CFA is derived from.",null,false],[191,341,0,null,null,null,null,false],[0,0,0,"columns",null," The register fields in these columns define the register the rule applies to.",null,false],[0,0,0,"copy_on_write",null," Indicates that the next write to any column in this row needs to copy\n the backing column storage first, as it may be referenced by previous rows.",null,false],[191,357,0,null,null,null,[22322,22324],false],[191,362,0,null,null," Resolves the register rule and places the result into `out` (see dwarf.abi.regBytes)",[22317,22318,22319,22320],false],[0,0,0,"self",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"expression_context",null,"",null,false],[0,0,0,"out",null,"",null,false],[191,357,0,null,null,null,null,false],[0,0,0,"register",null,null,null,false],[191,357,0,null,null,null,null,false],[0,0,0,"rule",null,null,null,false],[191,426,0,null,null,null,[22326,22327],false],[0,0,0,"start",null," Index into `columns` of the first column in this row.",null,false],[0,0,0,"len",null,null,null,false],[191,439,0,null,null,null,[22329,22330],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[191,445,0,null,null,null,[22332],false],[0,0,0,"self",null,"",null,false],[191,453,0,null,null," Return a slice backed by the row's non-CFA columns",[22334,22335],false],[0,0,0,"self",null,"",null,false],[0,0,0,"row",null,"",null,false],[191,459,0,null,null," Either retrieves or adds a column for `register` (non-CFA) in the current row.",[22337,22338,22339],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"register",null,"",null,false],[191,479,0,null,null," Runs the CIE instructions, then the FDE instructions. Execution halts\n once the row that corresponds to `pc` is known, and the row is returned.",[22341,22342,22343,22344,22345,22346,22347],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"pc",null,"",null,false],[0,0,0,"cie",null,"",null,false],[0,0,0,"fde",null,"",null,false],[0,0,0,"addr_size_bytes",null,"",null,false],[0,0,0,"endian",null,"",null,false],[191,511,0,null,null,null,[22349,22350,22351,22352,22353],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"pc",null,"",null,false],[0,0,0,"cie",null,"",null,false],[0,0,0,"fde",null,"",null,false],[191,521,0,null,null,null,[22355,22356],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[191,535,0,null,null," Executes a single instruction.\n If this instruction is from the CIE, `is_initial` should be set.\n Returns the value of `current_row` before executing this instruction.",[22358,22359,22360,22361,22362],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"cie",null,"",null,false],[0,0,0,"is_initial",null,"",null,false],[0,0,0,"instruction",null,"",null,false],[191,310,0,null,null,null,null,false],[0,0,0,"columns",null,null,null,false],[191,310,0,null,null,null,null,false],[0,0,0,"stack",null,null,null,false],[191,310,0,null,null,null,null,false],[0,0,0,"current_row",null,null,null,false],[191,310,0,null,null,null,null,false],[0,0,0,"cie_row",null," The result of executing the CIE's initial_instructions",null,false],[181,19,0,null,null,null,null,false],[0,0,0,"dwarf/expressions.zig",null,"",[],false],[192,0,0,null,null,null,null,false],[192,1,0,null,null,null,null,false],[192,2,0,null,null,null,null,false],[192,3,0,null,null,null,null,false],[192,4,0,null,null,null,null,false],[192,5,0,null,null,null,null,false],[192,6,0,null,null,null,null,false],[192,7,0,null,null,null,null,false],[192,12,0,null,null," Expressions can be evaluated in different contexts, each requiring its own set of inputs.\n Callers should specify all the fields relevant to their context. If a field is required\n by the expression and it isn't in the context, error.IncompleteExpressionContext is returned.",[22382,22385,22387,22389,22391,22393,22395,22397,22398],false],[0,0,0,"is_64",null," This expression is from a DWARF64 section",null,false],[192,12,0,null,null,null,[22384],false],[0,0,0,"address",null,"",null,false],[0,0,0,"isValidMemory",null," If specified, any addresses will pass through this function before being acccessed",null,false],[192,12,0,null,null,null,null,false],[0,0,0,"compile_unit",null," The compilation unit this expression relates to, if any",null,false],[192,12,0,null,null,null,null,false],[0,0,0,"object_address",null," When evaluating a user-presented expression, this is the address of the object being evaluated",null,false],[192,12,0,null,null,null,null,false],[0,0,0,"debug_addr",null," .debug_addr section",null,false],[192,12,0,null,null,null,null,false],[0,0,0,"thread_context",null," Thread context",null,false],[192,12,0,null,null,null,null,false],[0,0,0,"reg_context",null,null,null,false],[192,12,0,null,null,null,null,false],[0,0,0,"cfa",null," Call frame address, if in a CFI context",null,false],[0,0,0,"entry_value_context",null," This expression is a sub-expression from an OP.entry_value instruction",null,false],[192,39,0,null,null,null,[22400,22402,22403],false],[0,0,0,"addr_size",null," The address size of the target architecture",null,false],[192,39,0,null,null,null,null,false],[0,0,0,"endian",null," Endianess of the target architecture",null,false],[0,0,0,"call_frame_context",null," Restrict the stack machine to a subset of opcodes used in call frame instructions",null,false],[192,51,0,null,null,null,null,false],[192,76,0,null,null," A stack machine that can decode and run DWARF expressions.\n Expressions can be decoded for non-native address size and endianness,\n but can only be executed if the current target matches the configuration.",[22406],false],[0,0,0,"options",null,"",[22471],true],[192,92,0,null,null,null,null,false],[192,94,0,null,null,null,[22409,22410,22411,22412,22415,22418,22419,22423,22428,22432],false],[0,0,0,"generic",null,null,null,false],[0,0,0,"register",null,null,null,false],[0,0,0,"type_size",null,null,null,false],[0,0,0,"branch_offset",null,null,[22413,22414],false],[0,0,0,"base_register",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"base_register",null,null,[22416,22417],false],[0,0,0,"size",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"composite_location",null,null,null,false],[0,0,0,"block",null,null,[22420,22422],false],[0,0,0,"register",null,null,null,false],[192,108,0,null,null,null,null,false],[0,0,0,"type_offset",null,null,null,false],[0,0,0,"register_type",null,null,[22425,22427],false],[192,112,0,null,null,null,null,false],[0,0,0,"type_offset",null,null,null,false],[192,112,0,null,null,null,null,false],[0,0,0,"value_bytes",null,null,null,false],[0,0,0,"const_type",null,null,[22429,22431],false],[0,0,0,"size",null,null,null,false],[192,116,0,null,null,null,null,false],[0,0,0,"type_offset",null,null,null,false],[0,0,0,"deref_type",null,null,null,false],[192,122,0,null,null,null,[22436,22442,22447],false],[192,141,0,null,null,null,[22435],false],[0,0,0,"self",null,"",null,false],[0,0,0,"generic",null,null,[22438,22439,22441],false],[192,126,0,null,null,null,null,false],[0,0,0,"type_offset",null,null,null,false],[0,0,0,"type_size",null,null,null,false],[192,126,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[0,0,0,"regval_type",null,null,[22444,22446],false],[192,134,0,null,null,null,null,false],[0,0,0,"type_offset",null,null,null,false],[192,134,0,null,null,null,null,false],[0,0,0,"value_bytes",null,null,null,false],[0,0,0,"const_type",null,null,null,false],[192,164,0,null,null,null,[22449],false],[0,0,0,"self",null,"",null,false],[192,168,0,null,null,null,[22451,22452],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[192,172,0,null,null,null,[22454],false],[0,0,0,"value",null,"",null,false],[192,187,0,null,null,null,[22456,22457,22458],false],[0,0,0,"stream",null,"",null,false],[0,0,0,"opcode",null,"",null,false],[0,0,0,"context",null,"",null,false],[192,294,0,null,null,null,[22460,22461,22462,22463,22464],false],[0,0,0,"self",null,"",null,false],[0,0,0,"expression",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"initial_value",null,"",null,false],[192,309,0,null,null," Reads an opcode and its operands from `stream`, then executes it",[22466,22467,22468,22469],false],[0,0,0,"self",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"context",null,"",null,false],[192,91,0,null,null,null,null,false],[0,0,0,"stack",null,null,null,false],[192,784,0,null,null,null,[22473],false],[0,0,0,"options",null,"",[],true],[192,794,0,null,null," Zero-operand instructions",[22475,22476],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"opcode",null,"",null,true],[192,835,0,null,null,null,[22478,22479],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"literal",null,"",null,false],[192,842,0,null,null,null,[22481,22482,22483],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[192,874,0,null,null,null,[22485,22486],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"debug_addr_offset",null,"",null,false],[192,879,0,null,null,null,[22488,22489,22490],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"die_offset",null,"",null,false],[0,0,0,"value_bytes",null,"",null,false],[192,888,0,null,null,null,[22492,22493],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"value",null,"",null,false],[192,893,0,null,null,null,[22495,22496],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"debug_addr_offset",null,"",null,false],[192,900,0,null,null,null,[22498,22499],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[192,905,0,null,null,null,[22501,22502,22503],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"register",null,"",null,false],[0,0,0,"offset",null,"",null,false],[192,911,0,null,null,null,[22505,22506,22507],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"register",null,"",null,false],[0,0,0,"offset",null,"",null,false],[192,917,0,null,null,null,[22509,22510,22511],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"register",null,"",null,false],[0,0,0,"offset",null,"",null,false],[192,925,0,null,null,null,[22513,22514],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"index",null,"",null,false],[192,930,0,null,null,null,[22516,22517],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"size",null,"",null,false],[192,935,0,null,null,null,[22519,22520],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"size",null,"",null,false],[192,940,0,null,null,null,[22522,22523,22524],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"die_offset",null,"",null,false],[192,947,0,null,null,null,[22526,22527,22528],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"die_offset",null,"",null,false],[192,955,0,null,null,null,[22530,22531],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"uint_value",null,"",null,false],[192,962,0,null,null,null,[22533,22534],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[192,967,0,null,null,null,[22536,22537],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[192,972,0,null,null,null,[22539,22540,22541],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"offset",null,"",null,false],[192,983,0,null,null,null,[22543,22544,22545],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"is_64",null,"",null,true],[0,0,0,"value",null,"",null,false],[192,989,0,null,null,null,[22547,22548],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"die_offset",null,"",null,false],[192,995,0,null,null,null,[22550,22551],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"die_offset",null,"",null,false],[192,1003,0,null,null,null,[22553,22554],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"expression",null,"",null,false],[192,1010,0,null,null,null,[22556,22557],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"register",null,"",null,false],[192,1014,0,null,null,null,[22559,22560],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"register",null,"",null,false],[192,1019,0,null,null,null,[22562,22563],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"value_bytes",null,"",null,false],[192,1028,0,null,null,null,[22565],false],[0,0,0,"opcode",null,"",null,false],[192,1047,0,null,null,null,[22567],false],[0,0,0,"opcode",null,"",null,false],[192,1054,0,null,null,null,null,false],[181,21,0,null,null,null,[],false],[181,22,0,null,null,null,null,false],[181,23,0,null,null,null,null,false],[181,24,0,null,null,null,null,false],[181,25,0,null,null,null,null,false],[181,26,0,null,null,null,null,false],[181,27,0,null,null,null,null,false],[181,28,0,null,null,null,null,false],[181,29,0,null,null,null,null,false],[181,30,0,null,null,null,null,false],[181,33,0,null,null,null,[],false],[181,34,0,null,null,null,null,false],[181,35,0,null,null,null,null,false],[181,36,0,null,null,null,null,false],[181,37,0,null,null,null,null,false],[181,38,0,null,null,null,null,false],[181,39,0,null,null,null,null,false],[181,40,0,null,null,null,null,false],[181,41,0,null,null,null,null,false],[181,42,0,null,null,null,null,false],[181,43,0,null,null,null,null,false],[181,44,0,null,null,null,null,false],[181,45,0,null,null,null,null,false],[181,46,0,null,null,null,null,false],[181,47,0,null,null,null,null,false],[181,48,0,null,null,null,null,false],[181,49,0,null,null,null,null,false],[181,50,0,null,null,null,null,false],[181,51,0,null,null,null,null,false],[181,54,0,null,null,null,null,false],[181,55,0,null,null,null,null,false],[181,56,0,null,null,null,null,false],[181,57,0,null,null,null,null,false],[181,58,0,null,null,null,null,false],[181,59,0,null,null,null,null,false],[181,60,0,null,null,null,null,false],[181,61,0,null,null,null,null,false],[181,63,0,null,null,null,null,false],[181,64,0,null,null,null,null,false],[181,67,0,null,null,null,null,false],[181,70,0,null,null,null,null,false],[181,71,0,null,null,null,null,false],[181,72,0,null,null,null,null,false],[181,75,0,null,null,null,[],false],[181,76,0,null,null,null,null,false],[181,77,0,null,null,null,null,false],[181,80,0,null,null,null,[],false],[181,81,0,null,null,null,null,false],[181,82,0,null,null,null,null,false],[181,83,0,null,null,null,null,false],[181,84,0,null,null,null,null,false],[181,85,0,null,null,null,null,false],[181,86,0,null,null,null,null,false],[181,87,0,null,null,null,null,false],[181,88,0,null,null,null,null,false],[181,89,0,null,null,null,null,false],[181,90,0,null,null,null,null,false],[181,91,0,null,null,null,null,false],[181,92,0,null,null,null,null,false],[181,93,0,null,null,null,null,false],[181,96,0,null,null,null,[],false],[181,97,0,null,null,null,null,false],[181,98,0,null,null,null,null,false],[181,99,0,null,null,null,null,false],[181,100,0,null,null,null,null,false],[181,101,0,null,null,null,null,false],[181,102,0,null,null,null,null,false],[181,105,0,null,null,null,[],false],[181,106,0,null,null,null,null,false],[181,107,0,null,null,null,null,false],[181,108,0,null,null,null,null,false],[181,109,0,null,null,null,null,false],[181,110,0,null,null,null,null,false],[181,111,0,null,null,null,null,false],[181,113,0,null,null,null,null,false],[181,114,0,null,null,null,null,false],[181,117,0,null,null,null,[],false],[181,118,0,null,null,null,null,false],[181,119,0,null,null,null,null,false],[181,120,0,null,null,null,null,false],[181,121,0,null,null,null,null,false],[181,122,0,null,null,null,null,false],[181,124,0,null,null,null,null,false],[181,125,0,null,null,null,null,false],[181,128,0,null,null,null,[],false],[181,129,0,null,null,null,null,false],[181,130,0,null,null,null,null,false],[181,131,0,null,null,null,null,false],[181,132,0,null,null,null,null,false],[181,133,0,null,null,null,null,false],[181,134,0,null,null,null,null,false],[181,135,0,null,null,null,null,false],[181,136,0,null,null,null,null,false],[181,139,0,null,null,null,[22665,22666,22667,22668,22669,22670,22671],false],[181,150,0,null,null,null,null,false],[181,151,0,null,null,null,null,false],[0,0,0,"normal",null,null,null,false],[0,0,0,"program",null,null,null,false],[0,0,0,"nocall",null,null,null,false],[0,0,0,"pass_by_reference",null,null,null,false],[0,0,0,"pass_by_value",null,null,null,false],[0,0,0,"GNU_renesas_sh",null,null,null,false],[0,0,0,"GNU_borland_fastcall_i386",null,null,null,false],[181,154,0,null,null,null,[22673,22674],false],[0,0,0,"32",null,null,null,false],[0,0,0,"64",null,null,null,false],[181,156,0,null,null,null,[22676,22677],false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[181,161,0,null,null,null,[22680,22682],false],[181,161,0,null,null,null,null,false],[0,0,0,"pc_range",null,null,null,false],[181,161,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[181,166,0,null,null,null,[22684,22685,22687,22689,22690,22691,22692,22693,22695],false],[0,0,0,"version",null,null,null,false],[0,0,0,"is_64",null,null,null,false],[181,166,0,null,null,null,null,false],[0,0,0,"die",null,null,null,false],[181,166,0,null,null,null,null,false],[0,0,0,"pc_range",null,null,null,false],[0,0,0,"str_offsets_base",null,null,null,false],[0,0,0,"addr_base",null,null,null,false],[0,0,0,"rnglists_base",null,null,null,false],[0,0,0,"loclists_base",null,null,null,false],[181,166,0,null,null,null,null,false],[0,0,0,"frame_base",null,null,null,false],[181,179,0,null,null,null,null,false],[181,181,0,null,null,null,[22700,22702],false],[181,186,0,null,null,null,[22699],false],[0,0,0,"header",null,"",null,false],[0,0,0,"offset",null,null,null,false],[181,181,0,null,null,null,null,false],[0,0,0,"table",null,null,null,false],[181,194,0,null,null,null,[22706,22707,22708,22710],false],[181,200,0,null,null,null,[22705],false],[0,0,0,"entry",null,"",null,false],[0,0,0,"has_children",null,null,null,false],[0,0,0,"abbrev_code",null,null,null,false],[0,0,0,"tag_id",null,null,null,false],[181,194,0,null,null,null,null,false],[0,0,0,"attrs",null,null,null,false],[181,205,0,null,null,null,[22712,22713,22714],false],[0,0,0,"attr_id",null,null,null,false],[0,0,0,"form_id",null,null,null,false],[0,0,0,"payload",null," Only valid if form_id is .implicit_const",null,false],[181,212,0,null,null,null,[22724,22725,22726,22727,22728,22729,22730,22731,22732,22733,22734,22735,22736,22737,22738,22739],false],[181,230,0,null,null,null,[22717,22718],false],[0,0,0,"fv",null,"",null,false],[0,0,0,"di",null,"",null,false],[181,239,0,null,null,null,[22720,22721],false],[0,0,0,"fv",null,"",null,false],[0,0,0,"U",null,"",null,true],[181,250,0,null,null,null,[22723],false],[0,0,0,"fv",null,"",null,false],[0,0,0,"Address",null,null,null,false],[0,0,0,"AddrOffset",null,null,null,false],[0,0,0,"Block",null,null,null,false],[0,0,0,"Const",null,null,null,false],[0,0,0,"ExprLoc",null,null,null,false],[0,0,0,"Flag",null,null,null,false],[0,0,0,"SecOffset",null,null,null,false],[0,0,0,"Ref",null,null,null,false],[0,0,0,"RefAddr",null,null,null,false],[0,0,0,"String",null,null,null,false],[0,0,0,"StrPtr",null,null,null,false],[0,0,0,"StrOffset",null,null,null,false],[0,0,0,"LineStrPtr",null,null,null,false],[0,0,0,"LocListOffset",null,null,null,false],[0,0,0,"RangeListOffset",null,null,null,false],[0,0,0,"data16",null,null,null,false],[181,258,0,null,null,null,[22743,22744],false],[181,262,0,null,null,null,[22742],false],[0,0,0,"self",null,"",null,false],[0,0,0,"payload",null,null,null,false],[0,0,0,"signed",null,null,null,false],[181,268,0,null,null,null,[22777,22778,22779,22781],false],[181,275,0,null,null,null,[22747,22749],false],[0,0,0,"id",null,null,null,false],[181,275,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[181,280,0,null,null,null,[22751,22752],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[181,285,0,null,null,null,[22754,22755],false],[0,0,0,"self",null,"",null,false],[0,0,0,"id",null,"",null,false],[181,292,0,null,null,null,[22757,22758,22759,22760],false],[0,0,0,"self",null,"",null,false],[0,0,0,"di",null,"",null,false],[0,0,0,"id",null,"",null,false],[0,0,0,"compile_unit",null,"",null,false],[181,306,0,null,null,null,[22762,22763],false],[0,0,0,"self",null,"",null,false],[0,0,0,"id",null,"",null,false],[181,311,0,null,null,null,[22765,22766],false],[0,0,0,"self",null,"",null,false],[0,0,0,"id",null,"",null,false],[181,319,0,null,null,null,[22768,22769],false],[0,0,0,"self",null,"",null,false],[0,0,0,"id",null,"",null,false],[181,327,0,null,null,null,[22771,22772,22773,22774,22775],false],[0,0,0,"self",null,"",null,false],[0,0,0,"di",null,"",null,false],[0,0,0,"id",null,"",null,false],[0,0,0,"opt_str",null,"",null,false],[0,0,0,"compile_unit",null,"",null,false],[181,268,0,null,null,null,null,false],[0,0,0,"arena",null,null,null,false],[0,0,0,"tag_id",null,null,null,false],[0,0,0,"has_children",null,null,null,false],[181,268,0,null,null,null,null,false],[0,0,0,"attrs",null,null,null,false],[181,359,0,null,null,null,[22784,22785,22786,22787,22789],false],[181,359,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[0,0,0,"dir_index",null,null,null,false],[0,0,0,"mtime",null,null,null,false],[0,0,0,"size",null,null,null,false],[181,359,0,null,null,null,null,false],[0,0,0,"md5",null,null,null,false],[181,367,0,null,null,null,[22802,22803,22804,22805,22806,22807,22808,22809,22810,22811,22813,22814,22815,22816,22817,22818,22819,22820,22821],false],[181,391,0,null,null,null,[22792],false],[0,0,0,"self",null,"",null,false],[181,410,0,null,null,null,[22794,22795,22796,22797],false],[0,0,0,"is_stmt",null,"",null,false],[0,0,0,"include_dirs",null,"",null,false],[0,0,0,"target_address",null,"",null,false],[0,0,0,"version",null,"",null,false],[181,439,0,null,null,null,[22799,22800,22801],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"file_entries",null,"",null,false],[0,0,0,"address",null,null,null,false],[0,0,0,"file",null,null,null,false],[0,0,0,"line",null,null,null,false],[0,0,0,"column",null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"is_stmt",null,null,null,false],[0,0,0,"basic_block",null,null,null,false],[0,0,0,"end_sequence",null,null,null,false],[0,0,0,"default_is_stmt",null,null,null,false],[0,0,0,"target_address",null,null,null,false],[181,367,0,null,null,null,null,false],[0,0,0,"include_dirs",null,null,null,false],[0,0,0,"prev_valid",null,null,null,false],[0,0,0,"prev_address",null,null,null,false],[0,0,0,"prev_file",null,null,null,false],[0,0,0,"prev_line",null,null,null,false],[0,0,0,"prev_column",null,null,null,false],[0,0,0,"prev_is_stmt",null,null,null,false],[0,0,0,"prev_basic_block",null,null,null,false],[0,0,0,"prev_end_sequence",null,null,null,false],[181,482,0,null,null,null,[22823,22824,22825],false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"is_64",null,"",null,false],[181,495,0,null,null,null,[22827,22828,22829],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"size",null,"",null,false],[181,503,0,null,null,null,[22831,22832,22833],false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"is_64",null,"",null,false],[181,510,0,null,null,null,[22835,22836,22837],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"size",null,"",null,false],[181,516,0,null,null,null,[22839,22840,22841,22842],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"size",null,"",null,false],[181,521,0,null,null,null,[22844,22845,22846,22847],false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"signed",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"size",null,"",null,true],[181,548,0,null,null,null,[22849,22850,22851],false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"size",null,"",null,false],[181,562,0,null,null,null,[22853,22854,22855,22856,22857],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"form_id",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"is_64",null,"",null,false],[181,637,0,null,null,null,[22859,22860],false],[0,0,0,"abbrev_table",null,"",null,false],[0,0,0,"abbrev_code",null,"",null,false],[181,644,0,null,null,null,[22862,22863,22864,22865,22866,22867,22868,22869,22870,22871,22872,22873,22874,22875],false],[0,0,0,"debug_info",null,null,null,false],[0,0,0,"debug_abbrev",null,null,null,false],[0,0,0,"debug_str",null,null,null,false],[0,0,0,"debug_str_offsets",null,null,null,false],[0,0,0,"debug_line",null,null,null,false],[0,0,0,"debug_line_str",null,null,null,false],[0,0,0,"debug_ranges",null,null,null,false],[0,0,0,"debug_loclists",null,null,null,false],[0,0,0,"debug_rnglists",null,null,null,false],[0,0,0,"debug_addr",null,null,null,false],[0,0,0,"debug_names",null,null,null,false],[0,0,0,"debug_frame",null,null,null,false],[0,0,0,"eh_frame",null,null,null,false],[0,0,0,"eh_frame_hdr",null,null,null,false],[181,661,0,null,null,null,[22967,22969,22970,22972,22974,22976,22978,22980,22982],false],[181,662,0,null,null,null,[22882,22884,22885],false],[181,673,0,null,null,null,[22879,22880],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base_address",null,"",null,false],[181,662,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[181,662,0,null,null,null,null,false],[0,0,0,"virtual_address",null,null,null,false],[0,0,0,"owned",null,null,null,false],[181,682,0,null,null,null,null,false],[181,683,0,null,null,null,null,false],[181,684,0,null,null,null,null,false],[181,701,0,null,null,null,[22890,22891],false],[0,0,0,"di",null,"",null,false],[0,0,0,"dwarf_section",null,"",null,false],[181,705,0,null,null,null,[22893,22894,22895],false],[0,0,0,"di",null,"",null,false],[0,0,0,"dwarf_section",null,"",null,false],[0,0,0,"base_address",null,"",null,false],[181,709,0,null,null,null,[22897,22898],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[181,727,0,null,null,null,[22900,22901],false],[0,0,0,"di",null,"",null,false],[0,0,0,"address",null,"",null,false],[181,739,0,null,null,null,[22903,22904],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[181,908,0,null,null,null,[22906,22907],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[181,998,0,null,null,null,[22917,22919,22921,22923,22925],false],[181,1005,0,null,null,null,[22910,22911,22912],false],[0,0,0,"ranges_value",null,"",null,false],[0,0,0,"di",null,"",null,false],[0,0,0,"compile_unit",null,"",null,false],[181,1050,0,null,null,null,[22914],false],[0,0,0,"self",null,"",[22915,22916],false],[0,0,0,"start_addr",null,null,null,false],[0,0,0,"end_addr",null,null,null,false],[0,0,0,"base_address",null,null,null,false],[181,998,0,null,null,null,null,false],[0,0,0,"section_type",null,null,null,false],[181,998,0,null,null,null,null,false],[0,0,0,"di",null,null,null,false],[181,998,0,null,null,null,null,false],[0,0,0,"compile_unit",null,null,null,false],[181,998,0,null,null,null,null,false],[0,0,0,"stream",null,null,null,false],[181,1143,0,null,null,null,[22927,22928],false],[0,0,0,"di",null,"",null,false],[0,0,0,"target_address",null,"",null,false],[181,1161,0,null,null," Gets an already existing AbbrevTable given the abbrev_offset, or if not found,\n seeks in the stream and parses it.",[22930,22931,22932],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"abbrev_offset",null,"",null,false],[181,1174,0,null,null,null,[22934,22935,22936],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"offset",null,"",null,false],[181,1214,0,null,null,null,[22938,22939,22940,22941,22942],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in_stream",null,"",null,false],[0,0,0,"abbrev_table",null,"",null,false],[0,0,0,"is_64",null,"",null,false],[181,1250,0,null,null,null,[22944,22945,22946,22947],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"compile_unit",null,"",null,false],[0,0,0,"target_address",null,"",null,false],[181,1525,0,null,null,null,[22949,22950],false],[0,0,0,"di",null,"",null,false],[0,0,0,"offset",null,"",null,false],[181,1529,0,null,null,null,[22952,22953],false],[0,0,0,"di",null,"",null,false],[0,0,0,"offset",null,"",null,false],[181,1533,0,null,null,null,[22955,22956,22957],false],[0,0,0,"di",null,"",null,false],[0,0,0,"compile_unit",null,"",null,false],[0,0,0,"index",null,"",null,false],[181,1563,0,null,null," If .eh_frame_hdr is present, then only the header needs to be parsed.\n\n Otherwise, .eh_frame and .debug_frame are scanned and a sorted list\n of FDEs is built for binary searching during unwinding.",[22959,22960,22961],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"base_address",null,"",null,false],[181,1656,0,null,null," Unwind a stack frame using DWARF unwinding info, updating the register context.\n\n If `.eh_frame_hdr` is available, it will be used to binary search for the FDE.\n Otherwise, a linear scan of `.eh_frame` and `.debug_frame` is done to find the FDE.\n\n `explicit_fde_offset` is for cases where the FDE offset is known, such as when __unwind_info\n defers unwinding to DWARF. This is an offset into the `.eh_frame` section.",[22963,22964,22965],false],[0,0,0,"di",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"explicit_fde_offset",null,"",null,false],[181,661,0,null,null,null,null,false],[0,0,0,"endian",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"sections",null,null,null,false],[0,0,0,"is_macho",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"abbrev_table_list",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"compile_unit_list",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"func_list",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"eh_frame_hdr",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"cie_map",null,null,null,false],[181,661,0,null,null,null,null,false],[0,0,0,"fde_list",null,null,null,false],[181,1843,0,null,null," Returns the DWARF register number for an x86_64 register number found in compact unwind info",[22984],false],[0,0,0,"unwind_reg_number",null,"",null,false],[181,1855,0,null,null,null,null,false],[181,1860,0,null,null," Unwind a frame using MachO compact unwind info (from __unwind_info).\n If the compact encoding can't encode a way to unwind a frame, it will\n defer unwinding to DWARF, in which case `.eh_frame` will be used if available.",[22987,22988,22989,22990],false],[0,0,0,"context",null,"",null,false],[0,0,0,"unwind_info",null,"",null,false],[0,0,0,"eh_frame",null,"",null,false],[0,0,0,"module_base_address",null,"",null,false],[181,2186,0,null,null,null,[22992,22993,22994],false],[0,0,0,"context",null,"",null,false],[0,0,0,"eh_frame",null,"",null,false],[0,0,0,"fde_offset",null,"",null,false],[181,2201,0,null,null,null,[23006,23008,23009,23011,23013,23016,23018,23020],false],[181,2211,0,null,null,null,[22997,22998,22999],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"thread_context",null,"",null,false],[0,0,0,"isValidMemory",null,"",[23000],false],[0,0,0,"address",null,"",null,false],[181,2227,0,null,null,null,[23002],false],[0,0,0,"self",null,"",null,false],[181,2233,0,null,null,null,[23004],false],[0,0,0,"self",null,"",null,false],[181,2201,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[181,2201,0,null,null,null,null,false],[0,0,0,"cfa",null,null,null,false],[0,0,0,"pc",null,null,null,false],[181,2201,0,null,null,null,null,false],[0,0,0,"thread_context",null,null,null,false],[181,2201,0,null,null,null,null,false],[0,0,0,"reg_context",null,null,null,false],[181,2201,0,null,null,null,[23015],false],[0,0,0,"address",null,"",null,false],[0,0,0,"isValidMemory",null,null,null,false],[181,2201,0,null,null,null,null,false],[0,0,0,"vm",null,null,null,false],[181,2201,0,null,null,null,null,false],[0,0,0,"stack_machine",null,null,null,false],[181,2241,0,null,null," Initialize DWARF info. The caller has the responsibility to initialize most\n the DwarfInfo fields before calling. `binary_mem` is the raw bytes of the\n main binary file (not the secondary debug info file).",[23022,23023],false],[0,0,0,"di",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[181,2248,0,null,null," This function is to make it handy to comment out the return and make it\n into a crash when working on this file.",[],false],[181,2253,0,null,null,null,[],false],[181,2258,0,null,null,null,[23027,23028],false],[0,0,0,"opt_str",null,"",null,false],[0,0,0,"offset",null,"",null,false],[181,2267,0,null,null,null,[23030,23031,23033,23035,23037],false],[0,0,0,"pc_rel_base",null,null,null,false],[0,0,0,"follow_indirect",null,null,null,false],[181,2267,0,null,null,null,null,false],[0,0,0,"data_rel_base",null,null,null,false],[181,2267,0,null,null,null,null,false],[0,0,0,"text_rel_base",null,null,null,false],[181,2267,0,null,null,null,null,false],[0,0,0,"function_rel_base",null,null,null,false],[181,2283,0,null,null,null,[23039,23040,23041,23042,23043],false],[0,0,0,"reader",null,"",null,false],[0,0,0,"enc",null,"",null,false],[0,0,0,"addr_size_bytes",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"endian",null,"",null,false],[181,2343,0,null,null," This represents the decoded .eh_frame_hdr header",[23062,23063,23064,23066],false],[181,2349,0,null,null,null,[23046],false],[0,0,0,"table_enc",null,"",null,false],[181,2365,0,null,null,null,[23048,23049,23050,23052],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"isValidMemory",null,"",[23051],false],[0,0,0,"address",null,"",null,false],[0,0,0,"eh_frame_len",null,"",null,false],[181,2383,0,null,null," Find an entry by binary searching the eh_frame_hdr section.\n\n Since the length of the eh_frame section (`eh_frame_len`) may not be known by the caller,\n `isValidMemory` will be called before accessing any memory referenced by\n the header entries. If `eh_frame_len` is provided, then these checks can be skipped.",[23054,23055,23057,23058,23059,23060,23061],false],[0,0,0,"self",null,"",null,false],[0,0,0,"isValidMemory",null,"",[23056],false],[0,0,0,"address",null,"",null,false],[0,0,0,"eh_frame_len",null,"",null,false],[0,0,0,"eh_frame_hdr_ptr",null,"",null,false],[0,0,0,"pc",null,"",null,false],[0,0,0,"cie",null,"",null,false],[0,0,0,"fde",null,"",null,false],[0,0,0,"eh_frame_ptr",null,null,null,false],[0,0,0,"table_enc",null,null,null,false],[0,0,0,"fde_count",null,null,null,false],[181,2343,0,null,null,null,null,false],[0,0,0,"entries",null,null,null,false],[181,2482,0,null,null,null,[23074,23075,23080,23082],false],[181,2497,0,null,null," Reads a header for either an FDE or a CIE, then advances the stream to the position after the trailing structure.\n `stream` must be a stream backed by either the .eh_frame or .debug_frame sections.",[23069,23070,23071],false],[0,0,0,"stream",null,"",null,false],[0,0,0,"dwarf_section",null,"",null,false],[0,0,0,"endian",null,"",null,false],[181,2539,0,null,null," The length of the entry including the ID field, but not the length field itself",[23073],false],[0,0,0,"self",null,"",null,false],[0,0,0,"length_offset",null," Offset of the length field in the backing buffer",null,false],[0,0,0,"is_64",null,null,null,false],[181,2482,0,null,null,null,[23077,23078,23079],false],[0,0,0,"cie",null,null,null,false],[0,0,0,"fde",null," Value is the offset of the corresponding CIE",null,false],[0,0,0,"terminator",null,null,null,false],[0,0,0,"type",null,null,null,false],[181,2482,0,null,null,null,null,false],[0,0,0,"entry_bytes",null," The entry's contents, not including the ID field",null,false],[181,2544,0,null,null,null,[23102,23103,23104,23105,23107,23108,23109,23110,23112,23114,23115,23117,23119,23120,23122],false],[181,2546,0,null,null,null,null,false],[181,2549,0,null,null,null,null,false],[181,2552,0,null,null,null,null,false],[181,2576,0,null,null,null,[23088],false],[0,0,0,"self",null,"",null,false],[181,2581,0,null,null,null,[23090],false],[0,0,0,"self",null,"",null,false],[181,2586,0,null,null,null,[23092],false],[0,0,0,"self",null,"",null,false],[181,2599,0,null,null," This function expects to read the CIE starting with the version field.\n The returned struct references memory backed by cie_bytes.\n\n See the FrameDescriptionEntry.parse documentation for the description\n of `pc_rel_offset` and `is_runtime`.\n\n `length_offset` specifies the offset of this CIE's length field in the\n .eh_frame / .debug_frame section.",[23094,23095,23096,23097,23098,23099,23100,23101],false],[0,0,0,"cie_bytes",null,"",null,false],[0,0,0,"pc_rel_offset",null,"",null,false],[0,0,0,"is_runtime",null,"",null,false],[0,0,0,"is_64",null,"",null,false],[0,0,0,"dwarf_section",null,"",null,false],[0,0,0,"length_offset",null,"",null,false],[0,0,0,"addr_size_bytes",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"length_offset",null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"address_size",null,null,null,false],[0,0,0,"is_64",null,null,null,false],[181,2544,0,null,null,null,null,false],[0,0,0,"segment_selector_size",null,null,null,false],[0,0,0,"code_alignment_factor",null,null,null,false],[0,0,0,"data_alignment_factor",null,null,null,false],[0,0,0,"return_address_register",null,null,null,false],[181,2544,0,null,null,null,null,false],[0,0,0,"aug_str",null,null,null,false],[181,2544,0,null,null,null,null,false],[0,0,0,"aug_data",null,null,null,false],[0,0,0,"lsda_pointer_enc",null,null,null,false],[181,2544,0,null,null,null,null,false],[0,0,0,"personality_enc",null,null,null,false],[181,2544,0,null,null,null,null,false],[0,0,0,"personality_routine_pointer",null,null,null,false],[0,0,0,"fde_pointer_enc",null,null,null,false],[181,2544,0,null,null,null,null,false],[0,0,0,"initial_instructions",null,null,null,false],[181,2720,0,null,null,null,[23131,23132,23133,23135,23137,23139],false],[181,2742,0,null,null," This function expects to read the FDE starting at the PC Begin field.\n The returned struct references memory backed by `fde_bytes`.\n\n `pc_rel_offset` specifies an offset to be applied to pc_rel_base values\n used when decoding pointers. This should be set to zero if fde_bytes is\n backed by the memory of a .eh_frame / .debug_frame section in the running executable.\n Otherwise, it should be the relative offset to translate addresses from\n where the section is currently stored in memory, to where it *would* be\n stored at runtime: section base addr - backing data base ptr.\n\n Similarly, `is_runtime` specifies this function is being called on a runtime\n section, and so indirect pointers can be followed.",[23125,23126,23127,23128,23129,23130],false],[0,0,0,"fde_bytes",null,"",null,false],[0,0,0,"pc_rel_offset",null,"",null,false],[0,0,0,"is_runtime",null,"",null,false],[0,0,0,"cie",null,"",null,false],[0,0,0,"addr_size_bytes",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"cie_length_offset",null,null,null,false],[0,0,0,"pc_begin",null,null,null,false],[0,0,0,"pc_range",null,null,null,false],[181,2720,0,null,null,null,null,false],[0,0,0,"lsda_pointer",null,null,null,false],[181,2720,0,null,null,null,null,false],[0,0,0,"aug_data",null,null,null,false],[181,2720,0,null,null,null,null,false],[0,0,0,"instructions",null,null,null,false],[181,2813,0,null,null,null,[23141,23142],false],[0,0,0,"field_ptr",null,"",null,false],[0,0,0,"pc_rel_offset",null,"",null,false],[1,91,0,null,null," ELF format.",null,false],[0,0,0,"elf.zig",null,"",[],false],[193,0,0,null,null,null,null,false],[193,1,0,null,null,null,null,false],[193,2,0,null,null,null,null,false],[193,3,0,null,null,null,null,false],[193,4,0,null,null,null,null,false],[193,6,0,null,null,null,null,false],[193,7,0,null,null,null,null,false],[193,8,0,null,null,null,null,false],[193,9,0,null,null,null,null,false],[193,10,0,null,null,null,null,false],[193,11,0,null,null,null,null,false],[193,12,0,null,null,null,null,false],[193,13,0,null,null,null,null,false],[193,14,0,null,null,null,null,false],[193,15,0,null,null,null,null,false],[193,16,0,null,null,null,null,false],[193,17,0,null,null,null,null,false],[193,18,0,null,null,null,null,false],[193,19,0,null,null,null,null,false],[193,20,0,null,null,null,null,false],[193,21,0,null,null,null,null,false],[193,22,0,null,null,null,null,false],[193,23,0,null,null,null,null,false],[193,24,0,null,null,null,null,false],[193,25,0,null,null,null,null,false],[193,26,0,null,null,null,null,false],[193,27,0,null,null,null,null,false],[193,28,0,null,null,null,null,false],[193,29,0,null,null,null,null,false],[193,30,0,null,null,null,null,false],[193,31,0,null,null,null,null,false],[193,32,0,null,null,null,null,false],[193,33,0,null,null,null,null,false],[193,34,0,null,null,null,null,false],[193,35,0,null,null,null,null,false],[193,36,0,null,null,null,null,false],[193,37,0,null,null,null,null,false],[193,38,0,null,null,null,null,false],[193,39,0,null,null,null,null,false],[193,40,0,null,null,null,null,false],[193,41,0,null,null,null,null,false],[193,42,0,null,null,null,null,false],[193,43,0,null,null,null,null,false],[193,44,0,null,null,null,null,false],[193,45,0,null,null,null,null,false],[193,46,0,null,null,null,null,false],[193,47,0,null,null,null,null,false],[193,49,0,null,null,null,null,false],[193,50,0,null,null,null,null,false],[193,51,0,null,null,null,null,false],[193,52,0,null,null,null,null,false],[193,53,0,null,null,null,null,false],[193,54,0,null,null,null,null,false],[193,55,0,null,null,null,null,false],[193,56,0,null,null,null,null,false],[193,57,0,null,null,null,null,false],[193,58,0,null,null,null,null,false],[193,59,0,null,null,null,null,false],[193,60,0,null,null,null,null,false],[193,61,0,null,null,null,null,false],[193,62,0,null,null,null,null,false],[193,63,0,null,null,null,null,false],[193,64,0,null,null,null,null,false],[193,65,0,null,null,null,null,false],[193,66,0,null,null,null,null,false],[193,67,0,null,null,null,null,false],[193,68,0,null,null,null,null,false],[193,69,0,null,null,null,null,false],[193,70,0,null,null,null,null,false],[193,71,0,null,null,null,null,false],[193,72,0,null,null,null,null,false],[193,73,0,null,null,null,null,false],[193,74,0,null,null,null,null,false],[193,75,0,null,null,null,null,false],[193,76,0,null,null,null,null,false],[193,77,0,null,null,null,null,false],[193,78,0,null,null,null,null,false],[193,79,0,null,null,null,null,false],[193,80,0,null,null,null,null,false],[193,81,0,null,null,null,null,false],[193,82,0,null,null,null,null,false],[193,83,0,null,null,null,null,false],[193,84,0,null,null,null,null,false],[193,85,0,null,null,null,null,false],[193,86,0,null,null,null,null,false],[193,87,0,null,null,null,null,false],[193,88,0,null,null,null,null,false],[193,89,0,null,null,null,null,false],[193,91,0,null,null,null,null,false],[193,92,0,null,null,null,null,false],[193,93,0,null,null,null,null,false],[193,94,0,null,null,null,null,false],[193,95,0,null,null,null,null,false],[193,96,0,null,null,null,null,false],[193,97,0,null,null,null,null,false],[193,98,0,null,null,null,null,false],[193,99,0,null,null,null,null,false],[193,100,0,null,null,null,null,false],[193,102,0,null,null,null,null,false],[193,103,0,null,null,null,null,false],[193,104,0,null,null,null,null,false],[193,105,0,null,null,null,null,false],[193,107,0,null,null,null,null,false],[193,108,0,null,null,null,null,false],[193,109,0,null,null,null,null,false],[193,110,0,null,null,null,null,false],[193,111,0,null,null,null,null,false],[193,112,0,null,null,null,null,false],[193,113,0,null,null,null,null,false],[193,114,0,null,null,null,null,false],[193,115,0,null,null,null,null,false],[193,116,0,null,null,null,null,false],[193,117,0,null,null,null,null,false],[193,118,0,null,null,null,null,false],[193,119,0,null,null,null,null,false],[193,120,0,null,null,null,null,false],[193,122,0,null,null,null,null,false],[193,124,0,null,null,null,null,false],[193,125,0,null,null,null,null,false],[193,127,0,null,null,null,null,false],[193,128,0,null,null,null,null,false],[193,130,0,null,null,null,null,false],[193,131,0,null,null,null,null,false],[193,133,0,null,null,null,null,false],[193,134,0,null,null,null,null,false],[193,136,0,null,null,null,null,false],[193,137,0,null,null,null,null,false],[193,138,0,null,null,null,null,false],[193,140,0,null,null,null,null,false],[193,141,0,null,null,null,null,false],[193,143,0,null,null,null,null,false],[193,144,0,null,null,null,null,false],[193,145,0,null,null,null,null,false],[193,146,0,null,null,null,null,false],[193,147,0,null,null,null,null,false],[193,148,0,null,null,null,null,false],[193,149,0,null,null,null,null,false],[193,150,0,null,null,null,null,false],[193,151,0,null,null,null,null,false],[193,152,0,null,null,null,null,false],[193,153,0,null,null,null,null,false],[193,154,0,null,null,null,null,false],[193,155,0,null,null,null,null,false],[193,156,0,null,null,null,null,false],[193,157,0,null,null,null,null,false],[193,158,0,null,null,null,null,false],[193,159,0,null,null,null,null,false],[193,160,0,null,null,null,null,false],[193,161,0,null,null,null,null,false],[193,163,0,null,null,null,null,false],[193,164,0,null,null,null,null,false],[193,166,0,null,null,null,null,false],[193,167,0,null,null,null,null,false],[193,169,0,null,null,null,null,false],[193,171,0,null,null,null,null,false],[193,173,0,null,null,null,null,false],[193,175,0,null,null,null,null,false],[193,177,0,null,null,null,null,false],[193,178,0,null,null,null,null,false],[193,179,0,null,null,null,null,false],[193,180,0,null,null,null,null,false],[193,181,0,null,null,null,null,false],[193,182,0,null,null,null,null,false],[193,183,0,null,null,null,null,false],[193,184,0,null,null,null,null,false],[193,185,0,null,null,null,null,false],[193,186,0,null,null,null,null,false],[193,187,0,null,null,null,null,false],[193,188,0,null,null,null,null,false],[193,190,0,null,null,null,null,false],[193,192,0,null,null,null,null,false],[193,193,0,null,null,null,null,false],[193,194,0,null,null,null,null,false],[193,196,0,null,null,null,null,false],[193,198,0,null,null,null,null,false],[193,199,0,null,null,null,null,false],[193,200,0,null,null,null,null,false],[193,202,0,null,null,null,null,false],[193,203,0,null,null,null,null,false],[193,205,0,null,null,null,null,false],[193,206,0,null,null,null,null,false],[193,207,0,null,null,null,null,false],[193,209,0,null,null,null,null,false],[193,210,0,null,null,null,null,false],[193,211,0,null,null,null,null,false],[193,212,0,null,null,null,null,false],[193,213,0,null,null,null,null,false],[193,215,0,null,null,null,null,false],[193,216,0,null,null,null,null,false],[193,218,0,null,null,null,null,false],[193,220,0,null,null,null,null,false],[193,221,0,null,null,null,null,false],[193,222,0,null,null,null,null,false],[193,223,0,null,null,null,null,false],[193,224,0,null,null,null,null,false],[193,226,0,null,null,null,null,false],[193,227,0,null,null,null,null,false],[193,228,0,null,null,null,null,false],[193,229,0,null,null,null,null,false],[193,230,0,null,null,null,null,false],[193,231,0,null,null,null,null,false],[193,232,0,null,null,null,null,false],[193,233,0,null,null,null,null,false],[193,234,0,null,null,null,null,false],[193,235,0,null,null,null,null,false],[193,236,0,null,null,null,null,false],[193,237,0,null,null,null,null,false],[193,238,0,null,null,null,null,false],[193,239,0,null,null,null,null,false],[193,240,0,null,null,null,null,false],[193,241,0,null,null,null,null,false],[193,242,0,null,null,null,null,false],[193,243,0,null,null,null,null,false],[193,244,0,null,null,null,null,false],[193,245,0,null,null,null,null,false],[193,246,0,null,null,null,null,false],[193,247,0,null,null,null,null,false],[193,248,0,null,null,null,null,false],[193,249,0,null,null,null,null,false],[193,250,0,null,null,null,null,false],[193,251,0,null,null,null,null,false],[193,252,0,null,null,null,null,false],[193,253,0,null,null,null,null,false],[193,255,0,null,null,null,null,false],[193,256,0,null,null,null,null,false],[193,259,0,null,null," Symbol is local",null,false],[193,261,0,null,null," Symbol is global",null,false],[193,263,0,null,null," Beginning of reserved entries",null,false],[193,265,0,null,null," Symbol is to be eliminated",null,false],[193,268,0,null,null," Version definition of the file itself",null,false],[193,270,0,null,null," Weak version identifier",null,false],[193,273,0,null,null," Program header table entry unused",null,false],[193,275,0,null,null," Loadable program segment",null,false],[193,277,0,null,null," Dynamic linking information",null,false],[193,279,0,null,null," Program interpreter",null,false],[193,281,0,null,null," Auxiliary information",null,false],[193,283,0,null,null," Reserved",null,false],[193,285,0,null,null," Entry for header table itself",null,false],[193,287,0,null,null," Thread-local storage segment",null,false],[193,289,0,null,null," Number of defined types",null,false],[193,291,0,null,null," Start of OS-specific",null,false],[193,293,0,null,null," GCC .eh_frame_hdr segment",null,false],[193,295,0,null,null," Indicates stack executability",null,false],[193,297,0,null,null," Read-only after relocation",null,false],[193,298,0,null,null,null,null,false],[193,300,0,null,null," Sun specific segment",null,false],[193,302,0,null,null," Stack segment",null,false],[193,303,0,null,null,null,null,false],[193,305,0,null,null," End of OS-specific",null,false],[193,307,0,null,null," Start of processor-specific",null,false],[193,309,0,null,null," End of processor-specific",null,false],[193,312,0,null,null," Section header table entry unused",null,false],[193,314,0,null,null," Program data",null,false],[193,316,0,null,null," Symbol table",null,false],[193,318,0,null,null," String table",null,false],[193,320,0,null,null," Relocation entries with addends",null,false],[193,322,0,null,null," Symbol hash table",null,false],[193,324,0,null,null," Dynamic linking information",null,false],[193,326,0,null,null," Notes",null,false],[193,328,0,null,null," Program space with no data (bss)",null,false],[193,330,0,null,null," Relocation entries, no addends",null,false],[193,332,0,null,null," Reserved",null,false],[193,334,0,null,null," Dynamic linker symbol table",null,false],[193,336,0,null,null," Array of constructors",null,false],[193,338,0,null,null," Array of destructors",null,false],[193,340,0,null,null," Array of pre-constructors",null,false],[193,342,0,null,null," Section group",null,false],[193,344,0,null,null," Extended section indices",null,false],[193,346,0,null,null," Start of OS-specific",null,false],[193,348,0,null,null," LLVM address-significance table",null,false],[193,350,0,null,null," GNU hash table",null,false],[193,352,0,null,null," GNU version definition table",null,false],[193,354,0,null,null," GNU needed versions table",null,false],[193,356,0,null,null," GNU symbol version table",null,false],[193,358,0,null,null," End of OS-specific",null,false],[193,360,0,null,null," Start of processor-specific",null,false],[193,362,0,null,null," Unwind information",null,false],[193,364,0,null,null," End of processor-specific",null,false],[193,366,0,null,null," Start of application-specific",null,false],[193,368,0,null,null," End of application-specific",null,false],[193,371,0,null,null,null,null,false],[193,374,0,null,null," Local symbol",null,false],[193,376,0,null,null," Global symbol",null,false],[193,378,0,null,null," Weak symbol",null,false],[193,380,0,null,null," Number of defined types",null,false],[193,382,0,null,null," Start of OS-specific",null,false],[193,384,0,null,null," Unique symbol",null,false],[193,386,0,null,null," End of OS-specific",null,false],[193,388,0,null,null," Start of processor-specific",null,false],[193,390,0,null,null," End of processor-specific",null,false],[193,392,0,null,null,null,null,false],[193,395,0,null,null," Symbol type is unspecified",null,false],[193,397,0,null,null," Symbol is a data object",null,false],[193,399,0,null,null," Symbol is a code object",null,false],[193,401,0,null,null," Symbol associated with a section",null,false],[193,403,0,null,null," Symbol's name is file name",null,false],[193,405,0,null,null," Symbol is a common data object",null,false],[193,407,0,null,null," Symbol is thread-local data object",null,false],[193,409,0,null,null," Number of defined types",null,false],[193,411,0,null,null," Start of OS-specific",null,false],[193,413,0,null,null," Symbol is indirect code object",null,false],[193,415,0,null,null," End of OS-specific",null,false],[193,417,0,null,null," Start of processor-specific",null,false],[193,419,0,null,null," End of processor-specific",null,false],[193,421,0,null,null,null,null,false],[193,423,0,null,null,null,null,false],[193,425,0,null,null,null,null,false],[193,426,0,null,null,null,null,false],[193,428,0,null,null,null,null,false],[193,429,0,null,null,null,null,false],[193,431,0,null,null,null,null,false],[193,434,0,null,null," File types",[23459,23460,23461,23462,23463],false],[193,451,0,null,null," Beginning of processor-specific codes",null,false],[193,454,0,null,null," Processor-specific",null,false],[0,0,0,"NONE",null," No file type",null,false],[0,0,0,"REL",null," Relocatable file",null,false],[0,0,0,"EXEC",null," Executable file",null,false],[0,0,0,"DYN",null," Shared object file",null,false],[0,0,0,"CORE",null," Core file",null,false],[193,458,0,null,null," All integers are native endian.",[23476,23478,23479,23480,23481,23482,23483,23484,23485,23486,23487],false],[193,471,0,null,null,null,[23466,23467],false],[0,0,0,"self",null,"",null,false],[0,0,0,"parse_source",null,"",null,false],[193,478,0,null,null,null,[23469,23470],false],[0,0,0,"self",null,"",null,false],[0,0,0,"parse_source",null,"",null,false],[193,485,0,null,null,null,[23472],false],[0,0,0,"parse_source",null,"",null,false],[193,492,0,null,null,null,[23474],false],[0,0,0,"hdr_buf",null,"",null,false],[193,458,0,null,null,null,null,false],[0,0,0,"endian",null,null,null,false],[193,458,0,null,null,null,null,false],[0,0,0,"machine",null,null,null,false],[0,0,0,"is_64",null,null,null,false],[0,0,0,"entry",null,null,null,false],[0,0,0,"phoff",null,null,null,false],[0,0,0,"shoff",null,null,null,false],[0,0,0,"phentsize",null,null,null,false],[0,0,0,"phnum",null,null,null,false],[0,0,0,"shentsize",null,null,null,false],[0,0,0,"shnum",null,null,null,false],[0,0,0,"shstrndx",null,null,null,false],[193,532,0,null,null,null,[23489],false],[0,0,0,"ParseSource",null,"",[23493,23495,23496],true],[193,538,0,null,null,null,[23491],false],[0,0,0,"self",null,"",null,false],[193,533,0,null,null,null,null,false],[0,0,0,"elf_header",null,null,null,false],[193,533,0,null,null,null,null,false],[0,0,0,"parse_source",null,null,null,false],[0,0,0,"index",null,null,null,false],[193,582,0,null,null,null,[23498],false],[0,0,0,"ParseSource",null,"",[23502,23504,23505],true],[193,588,0,null,null,null,[23500],false],[0,0,0,"self",null,"",null,false],[193,583,0,null,null,null,null,false],[0,0,0,"elf_header",null,null,null,false],[193,583,0,null,null,null,null,false],[0,0,0,"parse_source",null,null,null,false],[0,0,0,"index",null,null,null,false],[193,634,0,null,null,null,[23507,23508,23509,23510],false],[0,0,0,"is_64",null,"",null,false],[0,0,0,"need_bswap",null,"",null,false],[0,0,0,"int_32",null,"",null,false],[0,0,0,"int_64",null,"",null,false],[193,646,0,null,null,null,[23512,23513,23514],false],[0,0,0,"need_bswap",null,"",null,false],[0,0,0,"int_32",null,"",null,false],[0,0,0,"Int64",null,"",null,true],[193,654,0,null,null,null,null,false],[193,656,0,null,null,null,null,false],[193,657,0,null,null,null,null,false],[193,658,0,null,null,null,null,false],[193,659,0,null,null,null,null,false],[193,660,0,null,null,null,null,false],[193,662,0,null,null,null,null,false],[193,663,0,null,null,null,null,false],[193,664,0,null,null,null,null,false],[193,665,0,null,null,null,null,false],[193,666,0,null,null,null,null,false],[193,668,0,null,null,null,null,false],[193,670,0,null,null,null,null,false],[193,671,0,null,null,null,null,false],[193,672,0,null,null,null,null,false],[193,673,0,null,null,null,null,false],[193,674,0,null,null,null,null,false],[193,675,0,null,null,null,null,false],[193,676,0,null,null,null,null,false],[193,677,0,null,null,null,null,false],[193,678,0,null,null,null,null,false],[193,679,0,null,null,null,null,false],[193,680,0,null,null,null,null,false],[193,681,0,null,null,null,null,false],[193,682,0,null,null,null,null,false],[193,683,0,null,null,null,null,false],[193,684,0,null,null,null,null,false],[193,685,0,null,null,null,null,false],[193,686,0,null,null,null,null,false],[193,687,0,null,null,null,null,false],[193,688,0,null,null,null,[23547,23549,23551,23553,23555,23557,23559,23561,23563,23565,23567,23569,23571,23573],false],[193,688,0,null,null,null,null,false],[0,0,0,"e_ident",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_type",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_machine",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_version",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_entry",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_phoff",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_shoff",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_flags",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_ehsize",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_phentsize",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_phnum",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_shentsize",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_shnum",null,null,null,false],[193,688,0,null,null,null,null,false],[0,0,0,"e_shstrndx",null,null,null,false],[193,704,0,null,null,null,[23576,23578,23580,23582,23584,23586,23588,23590,23592,23594,23596,23598,23600,23602],false],[193,704,0,null,null,null,null,false],[0,0,0,"e_ident",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_type",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_machine",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_version",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_entry",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_phoff",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_shoff",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_flags",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_ehsize",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_phentsize",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_phnum",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_shentsize",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_shnum",null,null,null,false],[193,704,0,null,null,null,null,false],[0,0,0,"e_shstrndx",null,null,null,false],[193,720,0,null,null,null,[23605,23607,23609,23611,23613,23615,23617,23619],false],[193,720,0,null,null,null,null,false],[0,0,0,"p_type",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_offset",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_vaddr",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_paddr",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_filesz",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_memsz",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_flags",null,null,null,false],[193,720,0,null,null,null,null,false],[0,0,0,"p_align",null,null,null,false],[193,730,0,null,null,null,[23622,23624,23626,23628,23630,23632,23634,23636],false],[193,730,0,null,null,null,null,false],[0,0,0,"p_type",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_flags",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_offset",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_vaddr",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_paddr",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_filesz",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_memsz",null,null,null,false],[193,730,0,null,null,null,null,false],[0,0,0,"p_align",null,null,null,false],[193,740,0,null,null,null,[23639,23641,23643,23645,23647,23649,23651,23653,23655,23657],false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_name",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_type",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_flags",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_addr",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_offset",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_size",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_link",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_info",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_addralign",null,null,null,false],[193,740,0,null,null,null,null,false],[0,0,0,"sh_entsize",null,null,null,false],[193,752,0,null,null,null,[23660,23662,23664,23666,23668,23670,23672,23674,23676,23678],false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_name",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_type",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_flags",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_addr",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_offset",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_size",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_link",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_info",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_addralign",null,null,null,false],[193,752,0,null,null,null,null,false],[0,0,0,"sh_entsize",null,null,null,false],[193,764,0,null,null,null,[23681,23683,23685],false],[193,764,0,null,null,null,null,false],[0,0,0,"ch_type",null,null,null,false],[193,764,0,null,null,null,null,false],[0,0,0,"ch_size",null,null,null,false],[193,764,0,null,null,null,null,false],[0,0,0,"ch_addralign",null,null,null,false],[193,769,0,null,null,null,[23688,23690,23692,23694],false],[193,769,0,null,null,null,null,false],[0,0,0,"ch_type",null,null,null,false],[193,769,0,null,null,null,null,false],[0,0,0,"ch_reserved",null,null,null,false],[193,769,0,null,null,null,null,false],[0,0,0,"ch_size",null,null,null,false],[193,769,0,null,null,null,null,false],[0,0,0,"ch_addralign",null,null,null,false],[193,775,0,null,null,null,[23701,23703,23705,23706,23707,23709],false],[193,783,0,null,null,null,[23697],false],[0,0,0,"self",null,"",null,false],[193,786,0,null,null,null,[23699],false],[0,0,0,"self",null,"",null,false],[193,775,0,null,null,null,null,false],[0,0,0,"st_name",null,null,null,false],[193,775,0,null,null,null,null,false],[0,0,0,"st_value",null,null,null,false],[193,775,0,null,null,null,null,false],[0,0,0,"st_size",null,null,null,false],[0,0,0,"st_info",null,null,null,false],[0,0,0,"st_other",null,null,null,false],[193,775,0,null,null,null,null,false],[0,0,0,"st_shndx",null,null,null,false],[193,790,0,null,null,null,[23716,23717,23718,23720,23722,23724],false],[193,798,0,null,null,null,[23712],false],[0,0,0,"self",null,"",null,false],[193,801,0,null,null,null,[23714],false],[0,0,0,"self",null,"",null,false],[193,790,0,null,null,null,null,false],[0,0,0,"st_name",null,null,null,false],[0,0,0,"st_info",null,null,null,false],[0,0,0,"st_other",null,null,null,false],[193,790,0,null,null,null,null,false],[0,0,0,"st_shndx",null,null,null,false],[193,790,0,null,null,null,null,false],[0,0,0,"st_value",null,null,null,false],[193,790,0,null,null,null,null,false],[0,0,0,"st_size",null,null,null,false],[193,805,0,null,null,null,[23727,23729],false],[193,805,0,null,null,null,null,false],[0,0,0,"si_boundto",null,null,null,false],[193,805,0,null,null,null,null,false],[0,0,0,"si_flags",null,null,null,false],[193,809,0,null,null,null,[23732,23734],false],[193,809,0,null,null,null,null,false],[0,0,0,"si_boundto",null,null,null,false],[193,809,0,null,null,null,null,false],[0,0,0,"si_flags",null,null,null,false],[193,813,0,null,null,null,[23741,23743],false],[193,817,0,null,null,null,[23737],false],[0,0,0,"self",null,"",null,false],[193,820,0,null,null,null,[23739],false],[0,0,0,"self",null,"",null,false],[193,813,0,null,null,null,null,false],[0,0,0,"r_offset",null,null,null,false],[193,813,0,null,null,null,null,false],[0,0,0,"r_info",null,null,null,false],[193,824,0,null,null,null,[23750,23752],false],[193,828,0,null,null,null,[23746],false],[0,0,0,"self",null,"",null,false],[193,831,0,null,null,null,[23748],false],[0,0,0,"self",null,"",null,false],[193,824,0,null,null,null,null,false],[0,0,0,"r_offset",null,null,null,false],[193,824,0,null,null,null,null,false],[0,0,0,"r_info",null,null,null,false],[193,835,0,null,null,null,[23759,23761,23763],false],[193,840,0,null,null,null,[23755],false],[0,0,0,"self",null,"",null,false],[193,843,0,null,null,null,[23757],false],[0,0,0,"self",null,"",null,false],[193,835,0,null,null,null,null,false],[0,0,0,"r_offset",null,null,null,false],[193,835,0,null,null,null,null,false],[0,0,0,"r_info",null,null,null,false],[193,835,0,null,null,null,null,false],[0,0,0,"r_addend",null,null,null,false],[193,847,0,null,null,null,[23770,23772,23774],false],[193,852,0,null,null,null,[23766],false],[0,0,0,"self",null,"",null,false],[193,855,0,null,null,null,[23768],false],[0,0,0,"self",null,"",null,false],[193,847,0,null,null,null,null,false],[0,0,0,"r_offset",null,null,null,false],[193,847,0,null,null,null,null,false],[0,0,0,"r_info",null,null,null,false],[193,847,0,null,null,null,null,false],[0,0,0,"r_addend",null,null,null,false],[193,859,0,null,null,null,[23777,23779],false],[193,859,0,null,null,null,null,false],[0,0,0,"d_tag",null,null,null,false],[193,859,0,null,null,null,null,false],[0,0,0,"d_val",null,null,null,false],[193,863,0,null,null,null,[23782,23784],false],[193,863,0,null,null,null,null,false],[0,0,0,"d_tag",null,null,null,false],[193,863,0,null,null,null,null,false],[0,0,0,"d_val",null,null,null,false],[193,867,0,null,null,null,[23787,23789,23791,23793,23795,23797,23799],false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_version",null,null,null,false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_flags",null,null,null,false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_ndx",null,null,null,false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_cnt",null,null,null,false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_hash",null,null,null,false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_aux",null,null,null,false],[193,867,0,null,null,null,null,false],[0,0,0,"vd_next",null,null,null,false],[193,876,0,null,null,null,[23802,23804,23806,23808,23810,23812,23814],false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_version",null,null,null,false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_flags",null,null,null,false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_ndx",null,null,null,false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_cnt",null,null,null,false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_hash",null,null,null,false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_aux",null,null,null,false],[193,876,0,null,null,null,null,false],[0,0,0,"vd_next",null,null,null,false],[193,885,0,null,null,null,[23817,23819],false],[193,885,0,null,null,null,null,false],[0,0,0,"vda_name",null,null,null,false],[193,885,0,null,null,null,null,false],[0,0,0,"vda_next",null,null,null,false],[193,889,0,null,null,null,[23822,23824],false],[193,889,0,null,null,null,null,false],[0,0,0,"vda_name",null,null,null,false],[193,889,0,null,null,null,null,false],[0,0,0,"vda_next",null,null,null,false],[193,893,0,null,null,null,[23827,23829,23831,23833,23835],false],[193,893,0,null,null,null,null,false],[0,0,0,"vn_version",null,null,null,false],[193,893,0,null,null,null,null,false],[0,0,0,"vn_cnt",null,null,null,false],[193,893,0,null,null,null,null,false],[0,0,0,"vn_file",null,null,null,false],[193,893,0,null,null,null,null,false],[0,0,0,"vn_aux",null,null,null,false],[193,893,0,null,null,null,null,false],[0,0,0,"vn_next",null,null,null,false],[193,900,0,null,null,null,[23838,23840,23842,23844,23846],false],[193,900,0,null,null,null,null,false],[0,0,0,"vn_version",null,null,null,false],[193,900,0,null,null,null,null,false],[0,0,0,"vn_cnt",null,null,null,false],[193,900,0,null,null,null,null,false],[0,0,0,"vn_file",null,null,null,false],[193,900,0,null,null,null,null,false],[0,0,0,"vn_aux",null,null,null,false],[193,900,0,null,null,null,null,false],[0,0,0,"vn_next",null,null,null,false],[193,907,0,null,null,null,[23849,23851,23853,23855,23857],false],[193,907,0,null,null,null,null,false],[0,0,0,"vna_hash",null,null,null,false],[193,907,0,null,null,null,null,false],[0,0,0,"vna_flags",null,null,null,false],[193,907,0,null,null,null,null,false],[0,0,0,"vna_other",null,null,null,false],[193,907,0,null,null,null,null,false],[0,0,0,"vna_name",null,null,null,false],[193,907,0,null,null,null,null,false],[0,0,0,"vna_next",null,null,null,false],[193,914,0,null,null,null,[23860,23862,23864,23866,23868],false],[193,914,0,null,null,null,null,false],[0,0,0,"vna_hash",null,null,null,false],[193,914,0,null,null,null,null,false],[0,0,0,"vna_flags",null,null,null,false],[193,914,0,null,null,null,null,false],[0,0,0,"vna_other",null,null,null,false],[193,914,0,null,null,null,null,false],[0,0,0,"vna_name",null,null,null,false],[193,914,0,null,null,null,null,false],[0,0,0,"vna_next",null,null,null,false],[193,921,0,null,null,null,[23870,23873],false],[0,0,0,"a_type",null,null,null,false],[193,921,0,null,null,null,[23872],false],[0,0,0,"a_val",null,null,null,false],[0,0,0,"a_un",null,null,null,false],[193,927,0,null,null,null,[23875,23878],false],[0,0,0,"a_type",null,null,null,false],[193,927,0,null,null,null,[23877],false],[0,0,0,"a_val",null,null,null,false],[0,0,0,"a_un",null,null,null,false],[193,933,0,null,null,null,[23881,23883,23885],false],[193,933,0,null,null,null,null,false],[0,0,0,"n_namesz",null,null,null,false],[193,933,0,null,null,null,null,false],[0,0,0,"n_descsz",null,null,null,false],[193,933,0,null,null,null,null,false],[0,0,0,"n_type",null,null,null,false],[193,938,0,null,null,null,[23888,23890,23892],false],[193,938,0,null,null,null,null,false],[0,0,0,"n_namesz",null,null,null,false],[193,938,0,null,null,null,null,false],[0,0,0,"n_descsz",null,null,null,false],[193,938,0,null,null,null,null,false],[0,0,0,"n_type",null,null,null,false],[193,943,0,null,null,null,[23895,23897,23899,23901,23903],false],[193,943,0,null,null,null,null,false],[0,0,0,"m_value",null,null,null,false],[193,943,0,null,null,null,null,false],[0,0,0,"m_info",null,null,null,false],[193,943,0,null,null,null,null,false],[0,0,0,"m_poffset",null,null,null,false],[193,943,0,null,null,null,null,false],[0,0,0,"m_repeat",null,null,null,false],[193,943,0,null,null,null,null,false],[0,0,0,"m_stride",null,null,null,false],[193,950,0,null,null,null,[23906,23908,23910,23912,23914],false],[193,950,0,null,null,null,null,false],[0,0,0,"m_value",null,null,null,false],[193,950,0,null,null,null,null,false],[0,0,0,"m_info",null,null,null,false],[193,950,0,null,null,null,null,false],[0,0,0,"m_poffset",null,null,null,false],[193,950,0,null,null,null,null,false],[0,0,0,"m_repeat",null,null,null,false],[193,950,0,null,null,null,null,false],[0,0,0,"m_stride",null,null,null,false],[193,957,0,null,null,null,[23920,23925],false],[193,958,0,null,null,null,null,false],[0,0,0,"gt_current_g_value",null,null,null,false],[193,958,0,null,null,null,null,false],[0,0,0,"gt_unused",null,null,null,false],[0,0,0,"gt_header",null,null,[23922,23924],false],[193,962,0,null,null,null,null,false],[0,0,0,"gt_g_value",null,null,null,false],[193,962,0,null,null,null,null,false],[0,0,0,"gt_bytes",null,null,null,false],[0,0,0,"gt_entry",null,null,null,false],[193,967,0,null,null,null,[23928,23930,23932],false],[193,967,0,null,null,null,null,false],[0,0,0,"ri_gprmask",null,null,null,false],[193,967,0,null,null,null,null,false],[0,0,0,"ri_cprmask",null,null,null,false],[193,967,0,null,null,null,null,false],[0,0,0,"ri_gp_value",null,null,null,false],[193,972,0,null,null,null,[23934,23935,23937,23939],false],[0,0,0,"kind",null,null,null,false],[0,0,0,"size",null,null,null,false],[193,972,0,null,null,null,null,false],[0,0,0,"section",null,null,null,false],[193,972,0,null,null,null,null,false],[0,0,0,"info",null,null,null,false],[193,978,0,null,null,null,[23942,23944],false],[193,978,0,null,null,null,null,false],[0,0,0,"hwp_flags1",null,null,null,false],[193,978,0,null,null,null,null,false],[0,0,0,"hwp_flags2",null,null,null,false],[193,982,0,null,null,null,[23947,23949,23951,23953,23955],false],[193,982,0,null,null,null,null,false],[0,0,0,"l_name",null,null,null,false],[193,982,0,null,null,null,null,false],[0,0,0,"l_time_stamp",null,null,null,false],[193,982,0,null,null,null,null,false],[0,0,0,"l_checksum",null,null,null,false],[193,982,0,null,null,null,null,false],[0,0,0,"l_version",null,null,null,false],[193,982,0,null,null,null,null,false],[0,0,0,"l_flags",null,null,null,false],[193,989,0,null,null,null,[23958,23960,23962,23964,23966],false],[193,989,0,null,null,null,null,false],[0,0,0,"l_name",null,null,null,false],[193,989,0,null,null,null,null,false],[0,0,0,"l_time_stamp",null,null,null,false],[193,989,0,null,null,null,null,false],[0,0,0,"l_checksum",null,null,null,false],[193,989,0,null,null,null,null,false],[0,0,0,"l_version",null,null,null,false],[193,989,0,null,null,null,null,false],[0,0,0,"l_flags",null,null,null,false],[193,996,0,null,null,null,null,false],[193,997,0,null,null,null,[23970,23971,23972,23973,23974,23975,23976,23978,23980,23982,23984],false],[193,997,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"isa_level",null,null,null,false],[0,0,0,"isa_rev",null,null,null,false],[0,0,0,"gpr_size",null,null,null,false],[0,0,0,"cpr1_size",null,null,null,false],[0,0,0,"cpr2_size",null,null,null,false],[0,0,0,"fp_abi",null,null,null,false],[193,997,0,null,null,null,null,false],[0,0,0,"isa_ext",null,null,null,false],[193,997,0,null,null,null,null,false],[0,0,0,"ases",null,null,null,false],[193,997,0,null,null,null,null,false],[0,0,0,"flags1",null,null,null,false],[193,997,0,null,null,null,null,false],[0,0,0,"flags2",null,null,null,false],[193,1022,0,null,null,null,null,false],[193,1027,0,null,null,null,null,false],[193,1032,0,null,null,null,null,false],[193,1037,0,null,null,null,null,false],[193,1042,0,null,null,null,null,false],[193,1047,0,null,null,null,null,false],[193,1052,0,null,null,null,null,false],[193,1057,0,null,null,null,null,false],[193,1062,0,null,null,null,null,false],[193,1067,0,null,null,null,null,false],[193,1072,0,null,null,null,null,false],[193,1077,0,null,null,null,null,false],[193,1082,0,null,null,null,null,false],[193,1092,0,null,null," Machine architectures.\n\n See current registered ELF machine architectures at:\n http://www.sco.com/developers/gabi/latest/ch4.eheader.html",[24001,24002,24003,24004,24005,24006,24007,24008,24009,24010,24011,24012,24013,24014,24015,24016,24017,24018,24019,24020,24021,24022,24023,24024,24025,24026,24027,24028,24029,24030,24031,24032,24033,24034,24035,24036,24037,24038,24039,24040,24041,24042,24043,24044,24045,24046,24047,24048,24049,24050,24051,24052,24053,24054,24055,24056,24057,24058,24059,24060,24061,24062,24063,24064,24065,24066,24067,24068,24069,24070,24071,24072,24073,24074,24075,24076,24077,24078,24079,24080,24081,24082,24083,24084,24085,24086,24087,24088,24089,24090,24091,24092,24093,24094,24095,24096,24097,24098,24099,24100,24101,24102,24103,24104,24105,24106,24107,24108,24109,24110,24111,24112,24113,24114,24115,24116,24117,24118,24119,24120,24121,24122,24123,24124,24125,24126,24127,24128,24129,24130,24131,24132,24133,24134,24135,24136,24137,24138,24139,24140,24141,24142,24143,24144,24145,24146,24147,24148,24149,24150,24151,24152,24153,24154,24155,24156,24157,24158,24159,24160,24161,24162,24163,24164,24165,24166,24167,24168,24169,24170,24171,24172,24173,24174,24175,24176,24177,24178,24179,24180],false],[193,1635,0,null,null,null,[24000],false],[0,0,0,"em",null,"",null,false],[0,0,0,"NONE",null," No machine",null,false],[0,0,0,"M32",null," AT&T WE 32100",null,false],[0,0,0,"SPARC",null," SPARC",null,false],[0,0,0,"386",null," Intel 386",null,false],[0,0,0,"68K",null," Motorola 68000",null,false],[0,0,0,"88K",null," Motorola 88000",null,false],[0,0,0,"IAMCU",null," Intel MCU",null,false],[0,0,0,"860",null," Intel 80860",null,false],[0,0,0,"MIPS",null," MIPS R3000",null,false],[0,0,0,"S370",null," IBM System/370",null,false],[0,0,0,"MIPS_RS3_LE",null," MIPS RS3000 Little-endian",null,false],[0,0,0,"SPU_2",null," SPU Mark II",null,false],[0,0,0,"PARISC",null," Hewlett-Packard PA-RISC",null,false],[0,0,0,"VPP500",null," Fujitsu VPP500",null,false],[0,0,0,"SPARC32PLUS",null," Enhanced instruction set SPARC",null,false],[0,0,0,"960",null," Intel 80960",null,false],[0,0,0,"PPC",null," PowerPC",null,false],[0,0,0,"PPC64",null," PowerPC64",null,false],[0,0,0,"S390",null," IBM System/390",null,false],[0,0,0,"SPU",null," IBM SPU/SPC",null,false],[0,0,0,"V800",null," NEC V800",null,false],[0,0,0,"FR20",null," Fujitsu FR20",null,false],[0,0,0,"RH32",null," TRW RH-32",null,false],[0,0,0,"RCE",null," Motorola RCE",null,false],[0,0,0,"ARM",null," ARM",null,false],[0,0,0,"ALPHA",null," DEC Alpha",null,false],[0,0,0,"SH",null," Hitachi SH",null,false],[0,0,0,"SPARCV9",null," SPARC V9",null,false],[0,0,0,"TRICORE",null," Siemens TriCore",null,false],[0,0,0,"ARC",null," Argonaut RISC Core",null,false],[0,0,0,"H8_300",null," Hitachi H8/300",null,false],[0,0,0,"H8_300H",null," Hitachi H8/300H",null,false],[0,0,0,"H8S",null," Hitachi H8S",null,false],[0,0,0,"H8_500",null," Hitachi H8/500",null,false],[0,0,0,"IA_64",null," Intel IA-64 processor architecture",null,false],[0,0,0,"MIPS_X",null," Stanford MIPS-X",null,false],[0,0,0,"COLDFIRE",null," Motorola ColdFire",null,false],[0,0,0,"68HC12",null," Motorola M68HC12",null,false],[0,0,0,"MMA",null," Fujitsu MMA Multimedia Accelerator",null,false],[0,0,0,"PCP",null," Siemens PCP",null,false],[0,0,0,"NCPU",null," Sony nCPU embedded RISC processor",null,false],[0,0,0,"NDR1",null," Denso NDR1 microprocessor",null,false],[0,0,0,"STARCORE",null," Motorola Star*Core processor",null,false],[0,0,0,"ME16",null," Toyota ME16 processor",null,false],[0,0,0,"ST100",null," STMicroelectronics ST100 processor",null,false],[0,0,0,"TINYJ",null," Advanced Logic Corp. TinyJ embedded processor family",null,false],[0,0,0,"X86_64",null," AMD x86-64 architecture",null,false],[0,0,0,"PDSP",null," Sony DSP Processor",null,false],[0,0,0,"PDP10",null," Digital Equipment Corp. PDP-10",null,false],[0,0,0,"PDP11",null," Digital Equipment Corp. PDP-11",null,false],[0,0,0,"FX66",null," Siemens FX66 microcontroller",null,false],[0,0,0,"ST9PLUS",null," STMicroelectronics ST9+ 8/16 bit microcontroller",null,false],[0,0,0,"ST7",null," STMicroelectronics ST7 8-bit microcontroller",null,false],[0,0,0,"68HC16",null," Motorola MC68HC16 Microcontroller",null,false],[0,0,0,"68HC11",null," Motorola MC68HC11 Microcontroller",null,false],[0,0,0,"68HC08",null," Motorola MC68HC08 Microcontroller",null,false],[0,0,0,"68HC05",null," Motorola MC68HC05 Microcontroller",null,false],[0,0,0,"SVX",null," Silicon Graphics SVx",null,false],[0,0,0,"ST19",null," STMicroelectronics ST19 8-bit microcontroller",null,false],[0,0,0,"VAX",null," Digital VAX",null,false],[0,0,0,"CRIS",null," Axis Communications 32-bit embedded processor",null,false],[0,0,0,"JAVELIN",null," Infineon Technologies 32-bit embedded processor",null,false],[0,0,0,"FIREPATH",null," Element 14 64-bit DSP Processor",null,false],[0,0,0,"ZSP",null," LSI Logic 16-bit DSP Processor",null,false],[0,0,0,"MMIX",null," Donald Knuth's educational 64-bit processor",null,false],[0,0,0,"HUANY",null," Harvard University machine-independent object files",null,false],[0,0,0,"PRISM",null," SiTera Prism",null,false],[0,0,0,"AVR",null," Atmel AVR 8-bit microcontroller",null,false],[0,0,0,"FR30",null," Fujitsu FR30",null,false],[0,0,0,"D10V",null," Mitsubishi D10V",null,false],[0,0,0,"D30V",null," Mitsubishi D30V",null,false],[0,0,0,"V850",null," NEC v850",null,false],[0,0,0,"M32R",null," Mitsubishi M32R",null,false],[0,0,0,"MN10300",null," Matsushita MN10300",null,false],[0,0,0,"MN10200",null," Matsushita MN10200",null,false],[0,0,0,"PJ",null," picoJava",null,false],[0,0,0,"OPENRISC",null," OpenRISC 32-bit embedded processor",null,false],[0,0,0,"ARC_COMPACT",null," ARC International ARCompact processor (old spelling/synonym: EM_ARC_A5)",null,false],[0,0,0,"XTENSA",null," Tensilica Xtensa Architecture",null,false],[0,0,0,"VIDEOCORE",null," Alphamosaic VideoCore processor",null,false],[0,0,0,"TMM_GPP",null," Thompson Multimedia General Purpose Processor",null,false],[0,0,0,"NS32K",null," National Semiconductor 32000 series",null,false],[0,0,0,"TPC",null," Tenor Network TPC processor",null,false],[0,0,0,"SNP1K",null," Trebia SNP 1000 processor",null,false],[0,0,0,"ST200",null," STMicroelectronics (www.st.com) ST200",null,false],[0,0,0,"IP2K",null," Ubicom IP2xxx microcontroller family",null,false],[0,0,0,"MAX",null," MAX Processor",null,false],[0,0,0,"CR",null," National Semiconductor CompactRISC microprocessor",null,false],[0,0,0,"F2MC16",null," Fujitsu F2MC16",null,false],[0,0,0,"MSP430",null," Texas Instruments embedded microcontroller msp430",null,false],[0,0,0,"BLACKFIN",null," Analog Devices Blackfin (DSP) processor",null,false],[0,0,0,"SE_C33",null," S1C33 Family of Seiko Epson processors",null,false],[0,0,0,"SEP",null," Sharp embedded microprocessor",null,false],[0,0,0,"ARCA",null," Arca RISC Microprocessor",null,false],[0,0,0,"UNICORE",null," Microprocessor series from PKU-Unity Ltd. and MPRC of Peking University",null,false],[0,0,0,"EXCESS",null," eXcess: 16/32/64-bit configurable embedded CPU",null,false],[0,0,0,"DXP",null," Icera Semiconductor Inc. Deep Execution Processor",null,false],[0,0,0,"ALTERA_NIOS2",null," Altera Nios II soft-core processor",null,false],[0,0,0,"CRX",null," National Semiconductor CompactRISC CRX",null,false],[0,0,0,"XGATE",null," Motorola XGATE embedded processor",null,false],[0,0,0,"C166",null," Infineon C16x/XC16x processor",null,false],[0,0,0,"M16C",null," Renesas M16C series microprocessors",null,false],[0,0,0,"DSPIC30F",null," Microchip Technology dsPIC30F Digital Signal Controller",null,false],[0,0,0,"CE",null," Freescale Communication Engine RISC core",null,false],[0,0,0,"M32C",null," Renesas M32C series microprocessors",null,false],[0,0,0,"TSK3000",null," Altium TSK3000 core",null,false],[0,0,0,"RS08",null," Freescale RS08 embedded processor",null,false],[0,0,0,"SHARC",null," Analog Devices SHARC family of 32-bit DSP processors",null,false],[0,0,0,"ECOG2",null," Cyan Technology eCOG2 microprocessor",null,false],[0,0,0,"SCORE7",null," Sunplus S+core7 RISC processor",null,false],[0,0,0,"DSP24",null," New Japan Radio (NJR) 24-bit DSP Processor",null,false],[0,0,0,"VIDEOCORE3",null," Broadcom VideoCore III processor",null,false],[0,0,0,"LATTICEMICO32",null," RISC processor for Lattice FPGA architecture",null,false],[0,0,0,"SE_C17",null," Seiko Epson C17 family",null,false],[0,0,0,"TI_C6000",null," The Texas Instruments TMS320C6000 DSP family",null,false],[0,0,0,"TI_C2000",null," The Texas Instruments TMS320C2000 DSP family",null,false],[0,0,0,"TI_C5500",null," The Texas Instruments TMS320C55x DSP family",null,false],[0,0,0,"MMDSP_PLUS",null," STMicroelectronics 64bit VLIW Data Signal Processor",null,false],[0,0,0,"CYPRESS_M8C",null," Cypress M8C microprocessor",null,false],[0,0,0,"R32C",null," Renesas R32C series microprocessors",null,false],[0,0,0,"TRIMEDIA",null," NXP Semiconductors TriMedia architecture family",null,false],[0,0,0,"HEXAGON",null," Qualcomm Hexagon processor",null,false],[0,0,0,"8051",null," Intel 8051 and variants",null,false],[0,0,0,"STXP7X",null," STMicroelectronics STxP7x family of configurable and extensible RISC processors",null,false],[0,0,0,"NDS32",null," Andes Technology compact code size embedded RISC processor family",null,false],[0,0,0,"ECOG1X",null," Cyan Technology eCOG1X family",null,false],[0,0,0,"MAXQ30",null," Dallas Semiconductor MAXQ30 Core Micro-controllers",null,false],[0,0,0,"XIMO16",null," New Japan Radio (NJR) 16-bit DSP Processor",null,false],[0,0,0,"MANIK",null," M2000 Reconfigurable RISC Microprocessor",null,false],[0,0,0,"CRAYNV2",null," Cray Inc. NV2 vector architecture",null,false],[0,0,0,"RX",null," Renesas RX family",null,false],[0,0,0,"METAG",null," Imagination Technologies META processor architecture",null,false],[0,0,0,"MCST_ELBRUS",null," MCST Elbrus general purpose hardware architecture",null,false],[0,0,0,"ECOG16",null," Cyan Technology eCOG16 family",null,false],[0,0,0,"CR16",null," National Semiconductor CompactRISC CR16 16-bit microprocessor",null,false],[0,0,0,"ETPU",null," Freescale Extended Time Processing Unit",null,false],[0,0,0,"SLE9X",null," Infineon Technologies SLE9X core",null,false],[0,0,0,"L10M",null," Intel L10M",null,false],[0,0,0,"K10M",null," Intel K10M",null,false],[0,0,0,"AARCH64",null," ARM AArch64",null,false],[0,0,0,"AVR32",null," Atmel Corporation 32-bit microprocessor family",null,false],[0,0,0,"STM8",null," STMicroeletronics STM8 8-bit microcontroller",null,false],[0,0,0,"TILE64",null," Tilera TILE64 multicore architecture family",null,false],[0,0,0,"TILEPRO",null," Tilera TILEPro multicore architecture family",null,false],[0,0,0,"CUDA",null," NVIDIA CUDA architecture",null,false],[0,0,0,"TILEGX",null," Tilera TILE-Gx multicore architecture family",null,false],[0,0,0,"CLOUDSHIELD",null," CloudShield architecture family",null,false],[0,0,0,"COREA_1ST",null," KIPO-KAIST Core-A 1st generation processor family",null,false],[0,0,0,"COREA_2ND",null," KIPO-KAIST Core-A 2nd generation processor family",null,false],[0,0,0,"ARC_COMPACT2",null," Synopsys ARCompact V2",null,false],[0,0,0,"OPEN8",null," Open8 8-bit RISC soft processor core",null,false],[0,0,0,"RL78",null," Renesas RL78 family",null,false],[0,0,0,"VIDEOCORE5",null," Broadcom VideoCore V processor",null,false],[0,0,0,"78KOR",null," Renesas 78KOR family",null,false],[0,0,0,"56800EX",null," Freescale 56800EX Digital Signal Controller (DSC)",null,false],[0,0,0,"BA1",null," Beyond BA1 CPU architecture",null,false],[0,0,0,"BA2",null," Beyond BA2 CPU architecture",null,false],[0,0,0,"XCORE",null," XMOS xCORE processor family",null,false],[0,0,0,"MCHP_PIC",null," Microchip 8-bit PIC(r) family",null,false],[0,0,0,"INTEL205",null," Reserved by Intel",null,false],[0,0,0,"INTEL206",null," Reserved by Intel",null,false],[0,0,0,"INTEL207",null," Reserved by Intel",null,false],[0,0,0,"INTEL208",null," Reserved by Intel",null,false],[0,0,0,"INTEL209",null," Reserved by Intel",null,false],[0,0,0,"KM32",null," KM211 KM32 32-bit processor",null,false],[0,0,0,"KMX32",null," KM211 KMX32 32-bit processor",null,false],[0,0,0,"KMX16",null," KM211 KMX16 16-bit processor",null,false],[0,0,0,"KMX8",null," KM211 KMX8 8-bit processor",null,false],[0,0,0,"KVARC",null," KM211 KVARC processor",null,false],[0,0,0,"CDP",null," Paneve CDP architecture family",null,false],[0,0,0,"COGE",null," Cognitive Smart Memory Processor",null,false],[0,0,0,"COOL",null," iCelero CoolEngine",null,false],[0,0,0,"NORC",null," Nanoradio Optimized RISC",null,false],[0,0,0,"CSR_KALIMBA",null," CSR Kalimba architecture family",null,false],[0,0,0,"AMDGPU",null," AMD GPU architecture",null,false],[0,0,0,"RISCV",null," RISC-V",null,false],[0,0,0,"LANAI",null," Lanai 32-bit processor",null,false],[0,0,0,"BPF",null," Linux kernel bpf virtual machine",null,false],[0,0,0,"CSKY",null," C-SKY",null,false],[0,0,0,"FRV",null," Fujitsu FR-V",null,false],[193,1667,0,null,null," Section data should be writable during execution.",null,false],[193,1670,0,null,null," Section occupies memory during program execution.",null,false],[193,1673,0,null,null," Section contains executable machine instructions.",null,false],[193,1676,0,null,null," The data in this section may be merged.",null,false],[193,1679,0,null,null," The data in this section is null-terminated strings.",null,false],[193,1682,0,null,null," A field in this section holds a section header table index.",null,false],[193,1685,0,null,null," Adds special ordering requirements for link editors.",null,false],[193,1689,0,null,null," This section requires special OS-specific processing to avoid incorrect\n behavior.",null,false],[193,1692,0,null,null," This section is a member of a section group.",null,false],[193,1695,0,null,null," This section holds Thread-Local Storage.",null,false],[193,1698,0,null,null," Identifies a section containing compressed data.",null,false],[193,1701,0,null,null," Not to be GCed by the linker",null,false],[193,1704,0,null,null," This section is excluded from the final executable or shared library.",null,false],[193,1707,0,null,null," Start of target-specific flags.",null,false],[193,1710,0,null,null," Bits indicating processor-specific flags.",null,false],[193,1715,0,null,null," All sections with the \"d\" flag are grouped together by the linker to form\n the data section and the dp register is set to the start of the section by\n the boot code.",null,false],[193,1720,0,null,null," All sections with the \"c\" flag are grouped together by the linker to form\n the constant pool and the cp register is set to the start of the constant\n pool by the boot code.",null,false],[193,1729,0,null,null," If an object file section does not have this flag set, then it may not hold\n more than 2GB and can be freely referred to in objects using smaller code\n models. Otherwise, only objects using larger code models can refer to them.\n For example, a medium code model object can refer to data in a section that\n sets this flag besides being able to refer to data in a section that does\n not set it; likewise, a small code model object can refer only to code in a\n section that does not set this flag.",null,false],[193,1733,0,null,null," All sections with the GPREL flag are grouped into a global data area\n for faster accesses",null,false],[193,1737,0,null,null," Section contains text/data which may be replicated in other sections.\n Linker must retain only one copy.",null,false],[193,1740,0,null,null," Linker must generate implicit hidden weak names.",null,false],[193,1743,0,null,null," Section data local to process.",null,false],[193,1746,0,null,null," Do not strip this section.",null,false],[193,1749,0,null,null," Section must be part of global data area.",null,false],[193,1752,0,null,null," This section should be merged.",null,false],[193,1755,0,null,null," Address size to be inferred from section entry size.",null,false],[193,1758,0,null,null," Section data is string data by default.",null,false],[193,1761,0,null,null," Make code section unreadable when in execute-only mode",null,false],[193,1764,0,null,null," Execute",null,false],[193,1767,0,null,null," Write",null,false],[193,1770,0,null,null," Read",null,false],[193,1773,0,null,null," Bits for operating system-specific semantics.",null,false],[193,1776,0,null,null," Bits for processor-specific semantics.",null,false],[193,1779,0,null,null," Undefined section",null,false],[193,1781,0,null,null," Start of reserved indices",null,false],[193,1783,0,null,null," Start of processor-specific",null,false],[193,1785,0,null,null," End of processor-specific",null,false],[193,1786,0,null,null,null,null,false],[193,1788,0,null,null," Associated symbol is absolute",null,false],[193,1790,0,null,null," Associated symbol is common",null,false],[193,1792,0,null,null," End of reserved indices",null,false],[193,1795,0,null,null,null,[24223,24224,24225,24226,24227,24228],false],[0,0,0,"ZLIB",null,null,null,false],[0,0,0,"ZSTD",null,null,null,false],[0,0,0,"LOOS",null,null,null,false],[0,0,0,"HIOS",null,null,null,false],[0,0,0,"LOPROC",null,null,null,false],[0,0,0,"HIPROC",null,null,null,false],[193,1807,0,null,null," AMD x86-64 relocations.\n No reloc",null,false],[193,1809,0,null,null," Direct 64 bit",null,false],[193,1811,0,null,null," PC relative 32 bit signed",null,false],[193,1813,0,null,null," 32 bit GOT entry",null,false],[193,1815,0,null,null," 32 bit PLT address",null,false],[193,1817,0,null,null," Copy symbol at runtime",null,false],[193,1819,0,null,null," Create GOT entry",null,false],[193,1821,0,null,null," Create PLT entry",null,false],[193,1823,0,null,null," Adjust by program base",null,false],[193,1825,0,null,null," 32 bit signed PC relative offset to GOT",null,false],[193,1827,0,null,null," Direct 32 bit zero extended",null,false],[193,1829,0,null,null," Direct 32 bit sign extended",null,false],[193,1831,0,null,null," Direct 16 bit zero extended",null,false],[193,1833,0,null,null," 16 bit sign extended pc relative",null,false],[193,1835,0,null,null," Direct 8 bit sign extended",null,false],[193,1837,0,null,null," 8 bit sign extended pc relative",null,false],[193,1839,0,null,null," ID of module containing symbol",null,false],[193,1841,0,null,null," Offset in module's TLS block",null,false],[193,1843,0,null,null," Offset in initial TLS block",null,false],[193,1845,0,null,null," 32 bit signed PC relative offset to two GOT entries for GD symbol",null,false],[193,1847,0,null,null," 32 bit signed PC relative offset to two GOT entries for LD symbol",null,false],[193,1849,0,null,null," Offset in TLS block",null,false],[193,1851,0,null,null," 32 bit signed PC relative offset to GOT entry for IE symbol",null,false],[193,1853,0,null,null," Offset in initial TLS block",null,false],[193,1855,0,null,null," PC relative 64 bit",null,false],[193,1857,0,null,null," 64 bit offset to GOT",null,false],[193,1859,0,null,null," 32 bit signed pc relative offset to GOT",null,false],[193,1861,0,null,null," 64 bit GOT entry offset",null,false],[193,1863,0,null,null," 64 bit PC relative offset to GOT entry",null,false],[193,1865,0,null,null," 64 bit PC relative offset to GOT",null,false],[193,1867,0,null,null," Like GOT64, says PLT entry needed",null,false],[193,1869,0,null,null," 64-bit GOT relative offset to PLT entry",null,false],[193,1871,0,null,null," Size of symbol plus 32-bit addend",null,false],[193,1873,0,null,null," Size of symbol plus 64-bit addend",null,false],[193,1875,0,null,null," GOT offset for TLS descriptor",null,false],[193,1877,0,null,null," Marker for call through TLS descriptor",null,false],[193,1879,0,null,null," TLS descriptor",null,false],[193,1881,0,null,null," Adjust indirectly by program base",null,false],[193,1883,0,null,null," 64-bit adjust by program base",null,false],[193,1887,0,null,null," 39 Reserved was R_X86_64_PC32_BND\n 40 Reserved was R_X86_64_PLT32_BND\n Load from 32 bit signed pc relative offset to GOT entry without REX prefix, relaxable",null,false],[193,1889,0,null,null," Load from 32 bit signed PC relative offset to GOT entry with REX prefix, relaxable",null,false],[193,1890,0,null,null,null,null,false],[193,1892,0,null,null,null,[24272,24273,24274,24275],false],[0,0,0,"DEFAULT",null,null,null,false],[0,0,0,"INTERNAL",null,null,null,false],[0,0,0,"HIDDEN",null,null,null,false],[0,0,0,"PROTECTED",null,null,null,false],[1,94,0,null,null," Enum-related metaprogramming helpers.",null,false],[0,0,0,"enums.zig",null," This module contains utilities and data structures for working with enums.\n",[],false],[194,2,0,null,null,null,null,false],[194,3,0,null,null,null,null,false],[194,4,0,null,null,null,null,false],[194,5,0,null,null,null,null,false],[194,11,0,null,null," Returns a struct with a field matching each unique named enum element.\n If the enum is extern and has multiple names for the same value, only\n the first name is used.  Each field is of type Data and has the provided\n default, which may be undefined.",[24283,24284,24285],false],[0,0,0,"E",null,"",null,true],[0,0,0,"Data",null,"",null,true],[0,0,0,"field_default",null,"",null,true],[194,34,0,null,null," Looks up the supplied fields in the given enum type.\n Uses only the field names, field values are ignored.\n The result array is in the same order as the input.",[24287,24288],false],[0,0,0,"E",null,"",null,true],[0,0,0,"fields",null,"",null,true],[194,46,0,null,null," Returns the set of all named values in the given enum, in\n declaration order.",[24290],false],[0,0,0,"E",null,"",null,true],[194,53,0,null,null," A safe alternative to @tagName() for non-exhaustive enums that doesn't\n panic when `e` has no tagged value.\n Returns the tag name for `e` or null if no tag exists.",[24292,24293],false],[0,0,0,"E",null,"",null,true],[0,0,0,"e",null,"",null,false],[194,75,0,null,null," Determines the length of a direct-mapped enum array, indexed by\n @intCast(usize, @intFromEnum(enum_value)).\n If the enum is non-exhaustive, the resulting length will only be enough\n to hold all explicit fields.\n If the enum contains any fields with values that cannot be represented\n by usize, a compile error is issued.  The max_unused_slots parameter limits\n the total number of items which have no matching enum key (holes in the enum\n numbering).  So for example, if an enum has values 1, 2, 5, and 6, max_unused_slots\n must be at least 3, to allow unused slots 0, 3, and 4.",[24295,24296],false],[0,0,0,"E",null,"",null,true],[0,0,0,"max_unused_slots",null,"",null,true],[194,113,0,null,null," Initializes an array of Data which can be indexed by\n @intCast(usize, @intFromEnum(enum_value)).\n If the enum is non-exhaustive, the resulting array will only be large enough\n to hold all explicit fields.\n If the enum contains any fields with values that cannot be represented\n by usize, a compile error is issued.  The max_unused_slots parameter limits\n the total number of items which have no matching enum key (holes in the enum\n numbering).  So for example, if an enum has values 1, 2, 5, and 6, max_unused_slots\n must be at least 3, to allow unused slots 0, 3, and 4.\n The init_values parameter must be a struct with field names that match the enum values.\n If the enum has multiple fields with the same value, the name of the first one must\n be used.",[24298,24299,24300,24301],false],[0,0,0,"E",null,"",null,true],[0,0,0,"Data",null,"",null,true],[0,0,0,"max_unused_slots",null,"",null,true],[0,0,0,"init_values",null,"",null,false],[194,147,0,null,null," Initializes an array of Data which can be indexed by\n @intCast(usize, @intFromEnum(enum_value)).  The enum must be exhaustive.\n If the enum contains any fields with values that cannot be represented\n by usize, a compile error is issued.  The max_unused_slots parameter limits\n the total number of items which have no matching enum key (holes in the enum\n numbering).  So for example, if an enum has values 1, 2, 5, and 6, max_unused_slots\n must be at least 3, to allow unused slots 0, 3, and 4.\n The init_values parameter must be a struct with field names that match the enum values.\n If the enum has multiple fields with the same value, the name of the first one must\n be used.",[24303,24304,24305,24306,24307],false],[0,0,0,"E",null,"",null,true],[0,0,0,"Data",null,"",null,true],[0,0,0,"default",null,"",null,true],[0,0,0,"max_unused_slots",null,"",null,true],[0,0,0,"init_values",null,"",null,false],[194,194,0,null,null," Cast an enum literal, value, or string to the enum value of type E\n with the same name.",[24309,24310],false],[0,0,0,"E",null,"",null,true],[0,0,0,"value",null,"",null,true],[194,239,0,null,null," A set of enum elements, backed by a bitfield.  If the enum\n is not dense, a mapping will be constructed from enum values\n to dense indices.  This type does no dynamic allocation and\n can be copied by value.",[24312],false],[0,0,0,"E",null,"",[],true],[194,241,0,null,null,null,[24314],false],[0,0,0,"Self",null,"",[],true],[194,245,0,null,null," Initializes the set using a struct of bools",[24316],false],[0,0,0,"init_values",null,"",null,false],[194,267,0,null,null," A map keyed by an enum, backed by a bitfield and a dense array.\n If the enum is not dense, a mapping will be constructed from\n enum values to dense indices.  This type does no dynamic\n allocation and can be copied by value.",[24318,24319],false],[0,0,0,"E",null,"",null,true],[0,0,0,"V",null,"",[],true],[194,269,0,null,null,null,[24321],false],[0,0,0,"Self",null,"",[],true],[194,273,0,null,null," Initializes the map using a sparse struct of optionals",[24323],false],[0,0,0,"init_values",null,"",null,false],[194,288,0,null,null," Initializes a full mapping with all keys set to value.\n Consider using EnumArray instead if the map will remain full.",[24325],false],[0,0,0,"value",null,"",null,false],[194,298,0,null,null," Initializes a full mapping with supplied values.\n Consider using EnumArray instead if the map will remain full.",[24327],false],[0,0,0,"init_values",null,"",null,false],[194,303,0,null,null," Initializes a full mapping with a provided default.\n Consider using EnumArray instead if the map will remain full.",[24329,24330],false],[0,0,0,"default",null,"",null,true],[0,0,0,"init_values",null,"",null,false],[194,325,0,null,null," A multiset of enum elements up to a count of usize. Backed\n by an EnumArray. This type does no dynamic allocation and can\n be copied by value.",[24332],false],[0,0,0,"E",null,"",null,true],[194,332,0,null,null," A multiset of enum elements up to CountSize. Backed by an\n EnumArray. This type does no dynamic allocation and can be\n copied by value.",[24334,24335],false],[0,0,0,"E",null,"",null,true],[0,0,0,"CountSize",null,"",[24401],true],[194,334,0,null,null,null,null,false],[194,339,0,null,null," Initializes the multiset using a struct of counts.",[24338],false],[0,0,0,"init_counts",null,"",null,false],[194,350,0,null,null," Initializes the multiset with a count of zero.",[],false],[194,356,0,null,null," Initializes the multiset with all keys at the\n same count.",[24341],false],[0,0,0,"c",null,"",null,true],[194,363,0,null,null," Returns the total number of key counts in the multiset.",[24343],false],[0,0,0,"self",null,"",null,false],[194,372,0,null,null," Checks if at least one key in multiset.",[24345,24346],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,378,0,null,null," Removes all instance of a key from multiset. Same as\n setCount(key, 0).",[24348,24349],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,384,0,null,null," Increases the key count by given amount. Caller asserts\n operation will not overflow.",[24351,24352,24353],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"c",null,"",null,false],[194,389,0,null,null," Increases the key count by given amount.",[24355,24356,24357],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"c",null,"",null,false],[194,396,0,null,null," Decreases the key count by given amount. If amount is\n greater than the number of keys in multset, then key count\n will be set to zero.",[24359,24360,24361],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"c",null,"",null,false],[194,401,0,null,null," Returns the count for a key.",[24363,24364],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,406,0,null,null," Set the count for a key.",[24366,24367,24368],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"c",null,"",null,false],[194,412,0,null,null," Increases the all key counts by given multiset. Caller\n asserts operation will not overflow any key.",[24370,24371],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,420,0,null,null," Increases the all key counts by given multiset.",[24373,24374],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,430,0,null,null," Deccreases the all key counts by given multiset. If\n the given multiset has more key counts than this,\n then that key will have a key count of zero.",[24376,24377],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,439,0,null,null," Returns true iff all key counts are the same as\n given multiset.",[24379,24380],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,451,0,null,null," Returns true iff all key counts less than or\n equal to the given multiset.",[24382,24383],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,463,0,null,null," Returns true iff all key counts greater than or\n equal to the given multiset.",[24385,24386],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,476,0,null,null," Returns a multiset with the total key count of this\n multiset and the other multiset. Caller asserts\n operation will not overflow any key.",[24388,24389],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,484,0,null,null," Returns a multiset with the total key count of this\n multiset and the other multiset.",[24391,24392],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,495,0,null,null," Returns a multiset with the key count of this\n multiset minus the corresponding key count in the\n other multiset. If the other multiset contains\n more key count than this set, that key will have\n a count of zero.",[24394,24395],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,501,0,null,null,null,null,false],[194,502,0,null,null,null,null,false],[194,508,0,null,null," Returns an iterator over this multiset. Keys with zero\n counts are included. Modifications to the set during\n iteration may or may not be observed by the iterator,\n but will not invalidate it.",[24399],false],[0,0,0,"self",null,"",null,false],[194,333,0,null,null,null,null,false],[0,0,0,"counts",null,null,null,false],[194,722,0,null,null," An array keyed by an enum, backed by a dense array.\n If the enum is not dense, a mapping will be constructed from\n enum values to dense indices.  This type does no dynamic\n allocation and can be copied by value.",[24403,24404],false],[0,0,0,"E",null,"",null,true],[0,0,0,"V",null,"",[],true],[194,724,0,null,null,null,[24406],false],[0,0,0,"Self",null,"",[],true],[194,728,0,null,null," Initializes all values in the enum array",[24408],false],[0,0,0,"init_values",null,"",null,false],[194,733,0,null,null," Initializes values in the enum array, with the specified default.",[24410,24411],false],[0,0,0,"default",null,"",null,true],[0,0,0,"init_values",null,"",null,false],[194,749,0,null,null,null,[24413],false],[0,0,0,"Self",null,"",null,true],[194,753,0,null,null,null,[],false],[194,758,0,null,null," A set type with an Indexer mapping from keys to indices.\n Presence or absence is stored as a dense bitfield.  This\n type does no allocation and can be copied by value.",[24416,24417],false],[0,0,0,"I",null,"",null,true],[0,0,0,"Ext",null,"",[24418],true],[0,0,0,"",null,"",[24491],false],[194,763,0,null,null,null,null,false],[194,761,0,null,null,null,null,false],[194,766,0,null,null," The indexing rules for converting between keys and indices.",null,false],[194,768,0,null,null," The element type for this set.",null,false],[194,770,0,null,null,null,null,false],[194,773,0,null,null," The maximum number of items in this set.",null,false],[194,778,0,null,null," Returns a set containing no keys.",[],false],[194,783,0,null,null," Returns a set containing all possible keys.",[],false],[194,788,0,null,null," Returns a set containing multiple keys.",[24428],false],[0,0,0,"keys",null,"",null,false],[194,795,0,null,null," Returns a set containing a single key.",[24430],false],[0,0,0,"key",null,"",null,false],[194,800,0,null,null," Returns the number of keys in the set.",[24432],false],[0,0,0,"self",null,"",null,false],[194,805,0,null,null," Checks if a key is in the set.",[24434,24435],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,810,0,null,null," Puts a key in the set.",[24437,24438],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,815,0,null,null," Removes a key from the set.",[24440,24441],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,820,0,null,null," Changes the presence of a key in the set to match the passed bool.",[24443,24444,24445],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"present",null,"",null,false],[194,826,0,null,null," Toggles the presence of a key in the set.  If the key is in\n the set, removes it.  Otherwise adds it.",[24447,24448],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,831,0,null,null," Toggles the presence of all keys in the passed set.",[24450,24451],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,836,0,null,null," Toggles all possible keys in the set.",[24453],false],[0,0,0,"self",null,"",null,false],[194,841,0,null,null," Adds all keys in the passed set to this set.",[24455,24456],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,846,0,null,null," Removes all keys which are not in the passed set.",[24458,24459],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,851,0,null,null," Returns true iff both sets have the same keys.",[24461,24462],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,858,0,null,null," Returns true iff all the keys in this set are\n in the other set. The other set may have keys\n not found in this set.",[24464,24465],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,865,0,null,null," Returns true iff this set contains all the keys\n in the other set. This set may have keys not\n found in the other set.",[24467,24468],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,870,0,null,null," Returns a set with all the keys not in this set.",[24470],false],[0,0,0,"self",null,"",null,false],[194,876,0,null,null," Returns a set with keys that are in either this\n set or the other set.",[24472,24473],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,882,0,null,null," Returns a set with keys that are in both this\n set and the other set.",[24475,24476],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,888,0,null,null," Returns a set with keys that are in either this\n set or the other set, but not both.",[24478,24479],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,894,0,null,null," Returns a set with keys that are in this set\n except for keys in the other set.",[24481,24482],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[194,902,0,null,null," Returns an iterator over this set, which iterates in\n index order.  Modifications to the set during iteration\n may or may not be observed by the iterator, but will\n not invalidate it.",[24484],false],[0,0,0,"self",null,"",null,false],[194,906,0,null,null,null,[24489],false],[194,909,0,null,null,null,[24487],false],[0,0,0,"self",null,"",null,false],[194,906,0,null,null,null,null,false],[0,0,0,"inner",null,null,null,false],[194,760,0,null,null,null,null,false],[0,0,0,"bits",null,null,null,false],[194,1003,0,null,null," A map from keys to values, using an index lookup.  Uses a\n bitfield to track presence and a dense array of values.\n This type does no allocation and can be copied by value.",[24493,24494,24495],false],[0,0,0,"I",null,"",null,true],[0,0,0,"V",null,"",null,true],[0,0,0,"Ext",null,"",[24496],true],[0,0,0,"",null,"",[24556,24558],false],[194,1008,0,null,null,null,null,false],[194,1006,0,null,null,null,null,false],[194,1011,0,null,null," The index mapping for this map",null,false],[194,1013,0,null,null," The key type used to index this map",null,false],[194,1015,0,null,null," The value type stored in this map",null,false],[194,1017,0,null,null," The number of possible keys in the map",null,false],[194,1019,0,null,null,null,null,false],[194,1028,0,null,null," The number of items in the map.",[24505],false],[0,0,0,"self",null,"",null,false],[194,1033,0,null,null," Checks if the map contains an item.",[24507,24508],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1039,0,null,null," Gets the value associated with a key.\n If the key is not in the map, returns null.",[24510,24511],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1046,0,null,null," Gets the value associated with a key, which must\n exist in the map.",[24513,24514],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1054,0,null,null," Gets the address of the value associated with a key.\n If the key is not in the map, returns null.",[24516,24517],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1061,0,null,null," Gets the address of the const value associated with a key.\n If the key is not in the map, returns null.",[24519,24520],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1068,0,null,null," Gets the address of the value associated with a key.\n The key must be present in the map.",[24522,24523],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1076,0,null,null," Adds the key to the map with the supplied value.\n If the key is already in the map, overwrites the value.",[24525,24526,24527],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[194,1086,0,null,null," Adds the key to the map with an undefined value.\n If the key is already in the map, the value becomes undefined.\n A pointer to the value is returned, which should be\n used to initialize the value.",[24529,24530],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1096,0,null,null," Sets the value associated with the key in the map,\n and returns the old value.  If the key was not in\n the map, returns null.",[24532,24533,24534],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[194,1106,0,null,null," Removes a key from the map.  If the key was not in the map,\n does nothing.",[24536,24537],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1114,0,null,null," Removes a key from the map, and returns the old value.\n If the key was not in the map, returns null.",[24539,24540],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1125,0,null,null," Returns an iterator over the map, which visits items in index order.\n Modifications to the underlying map may or may not be observed by\n the iterator, but will not invalidate it.",[24542],false],[0,0,0,"self",null,"",null,false],[194,1133,0,null,null," An entry in the map.",[24545,24547],false],[194,1133,0,null,null,null,null,false],[0,0,0,"key",null," The key associated with this entry.\n Modifying this key will not change the map.",null,false],[194,1133,0,null,null,null,null,false],[0,0,0,"value",null," A pointer to the value in the map associated\n with this key.  Modifications through this\n pointer will modify the underlying data.",null,false],[194,1144,0,null,null,null,[24552,24554],false],[194,1148,0,null,null,null,[24550],false],[0,0,0,"self",null,"",null,false],[194,1144,0,null,null,null,null,false],[0,0,0,"inner",null,null,null,false],[194,1144,0,null,null,null,null,false],[0,0,0,"values",null,null,null,false],[194,1005,0,null,null,null,null,false],[0,0,0,"bits",null," Bits determining whether items are in the map",null,false],[194,1005,0,null,null,null,null,false],[0,0,0,"values",null," Values of items in the map.  If the associated\n bit is zero, the value is undefined.",null,false],[194,1163,0,null,null," A dense array of values, using an indexed lookup.\n This type does no allocation and can be copied by value.",[24560,24561,24562],false],[0,0,0,"I",null,"",null,true],[0,0,0,"V",null,"",null,true],[0,0,0,"Ext",null,"",[24563],true],[0,0,0,"",null,"",[24600],false],[194,1168,0,null,null,null,null,false],[194,1166,0,null,null,null,null,false],[194,1171,0,null,null," The index mapping for this map",null,false],[194,1173,0,null,null," The key type used to index this map",null,false],[194,1175,0,null,null," The value type stored in this map",null,false],[194,1177,0,null,null," The number of possible keys in the map",null,false],[194,1181,0,null,null,null,[],false],[194,1185,0,null,null,null,[24572],false],[0,0,0,"v",null,"",null,false],[194,1192,0,null,null," Returns the value in the array associated with a key.",[24574,24575],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1197,0,null,null," Returns a pointer to the slot in the array associated with a key.",[24577,24578],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1202,0,null,null," Returns a const pointer to the slot in the array associated with a key.",[24580,24581],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[194,1207,0,null,null," Sets the value in the slot associated with a key.",[24583,24584,24585],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[194,1212,0,null,null," Iterates over the items in the array, in index order.",[24587],false],[0,0,0,"self",null,"",null,false],[194,1219,0,null,null," An entry in the array.",[24590,24592],false],[194,1219,0,null,null,null,null,false],[0,0,0,"key",null," The key associated with this entry.\n Modifying this key will not change the array.",null,false],[194,1219,0,null,null,null,null,false],[0,0,0,"value",null," A pointer to the value in the array associated\n with this key.  Modifications through this\n pointer will modify the underlying data.",null,false],[194,1230,0,null,null,null,[24596,24598],false],[194,1234,0,null,null,null,[24595],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,null,null,false],[194,1230,0,null,null,null,null,false],[0,0,0,"values",null,null,null,false],[194,1165,0,null,null,null,null,false],[0,0,0,"values",null,null,null,false],[194,1265,0,null,null," Verifies that a type is a valid Indexer, providing a helpful\n compile error if not.  An Indexer maps a comptime-known set\n of keys to a dense set of zero-based indices.\n The indexer interface must look like this:\n ```\n struct {\n     /// The key type which this indexer converts to indices\n     pub const Key: type,\n     /// The number of indexes in the dense mapping\n     pub const count: usize,\n     /// Converts from a key to an index\n     pub fn indexOf(Key) usize;\n     /// Converts from an index to a key\n     pub fn keyForIndex(usize) Key;\n }\n ```",[24602],false],[0,0,0,"T",null,"",null,true],[194,1291,0,null,null,null,[24604],false],[0,0,0,"E",null,"",[],true],[194,1349,0,null,null,null,null,false],[194,1350,0,null,null,null,null,false],[194,1351,0,null,null,null,[24608],false],[0,0,0,"e",null,"",null,false],[194,1357,0,null,null,null,[24610],false],[0,0,0,"i",null,"",null,false],[194,59,0,"tagName","test tagName {\n    const E = enum(u8) { a, b, _ };\n    try testing.expect(tagName(E, .a) != null);\n    try testing.expectEqualStrings(\"a\", tagName(E, .a).?);\n    try testing.expect(tagName(E, @as(E, @enumFromInt(42))) == null);\n}",null,null,false],[1,97,0,null,null," Evented I/O data structures.",null,false],[0,0,0,"event.zig",null,"",[],false],[195,0,0,null,null,null,null,false],[0,0,0,"event/channel.zig",null,"",[],false],[196,0,0,null,null,null,null,false],[196,1,0,null,null,null,null,false],[196,2,0,null,null,null,null,false],[196,3,0,null,null,null,null,false],[196,4,0,null,null,null,null,false],[196,9,0,null,null," Many producer, many consumer, thread-safe, runtime configurable buffer size.\n When buffer is empty, consumers suspend and are resumed by producers.\n When buffer is full, producers suspend and are resumed by consumers.",[24622],false],[0,0,0,"T",null,"",[24661,24663,24665,24666,24667,24668,24669,24671,24672,24673],true],[196,24,0,null,null,null,null,false],[196,25,0,null,null,null,[24637,24639],false],[196,29,0,null,null,null,[24626,24627],false],[0,0,0,"Normal",null,null,null,false],[0,0,0,"OrNull",null,null,null,false],[196,34,0,null,null,null,[24630],false],[196,34,0,null,null,null,null,false],[0,0,0,"ptr",null,null,null,false],[196,38,0,null,null,null,[24633,24635],false],[196,38,0,null,null,null,null,false],[0,0,0,"ptr",null,null,null,false],[196,38,0,null,null,null,null,false],[0,0,0,"or_null",null,null,null,false],[196,25,0,null,null,null,null,false],[0,0,0,"tick_node",null,null,null,false],[196,25,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[196,43,0,null,null,null,[24642,24644],false],[196,43,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[196,43,0,null,null,null,null,false],[0,0,0,"tick_node",null,null,null,false],[196,48,0,null,null,null,null,false],[196,55,0,null,null," Call `deinit` to free resources when done.\n `buffer` must live until `deinit` is called.\n For a zero length buffer, use `[0]T{}`.\n TODO https://github.com/ziglang/zig/issues/2765",[24647,24648],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[196,77,0,null,null," Must be called when all calls to put and get have suspended and no more calls occur.\n This can be omitted if caller can guarantee that the suspended putters and getters\n do not need to be run to completion. Note that this may leave awaiters hanging.",[24650],false],[0,0,0,"self",null,"",null,false],[196,90,0,null,null," puts a data item in the channel. The function returns when the value has been added to the\n buffer, or in the case of a zero size buffer, when the item has been retrieved by a getter.\n Or when the channel is destroyed.",[24652,24653],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data",null,"",null,false],[196,109,0,null,null," await this function to get an item from the channel. If the buffer is empty, the frame will\n complete when the next item is put in the channel.",[24655],false],[0,0,0,"self",null,"",null,false],[196,142,0,null,null," Get an item from the channel. If the buffer is empty and there are no\n puts waiting, this returns `null`.",[24657],false],[0,0,0,"self",null,"",null,false],[196,171,0,null,null,null,[24659],false],[0,0,0,"self",null,"",null,false],[196,10,0,null,null,null,null,false],[0,0,0,"getters",null,null,null,false],[196,10,0,null,null,null,null,false],[0,0,0,"or_null_queue",null,null,null,false],[196,10,0,null,null,null,null,false],[0,0,0,"putters",null,null,null,false],[0,0,0,"get_count",null,null,null,false],[0,0,0,"put_count",null,null,null,false],[0,0,0,"dispatch_lock",null,null,null,false],[0,0,0,"need_dispatch",null,null,null,false],[196,10,0,null,null,null,null,false],[0,0,0,"buffer_nodes",null,null,null,false],[0,0,0,"buffer_index",null,null,null,false],[0,0,0,"buffer_len",null,null,null,false],[196,312,0,null,null,null,[24675],false],[0,0,0,"channel",null,"",null,false],[196,327,0,null,null,null,[24677],false],[0,0,0,"channel",null,"",null,false],[196,331,0,null,null,null,[24679,24680],false],[0,0,0,"channel",null,"",null,false],[0,0,0,"value",null,"",null,false],[195,1,0,null,null,null,null,false],[0,0,0,"event/future.zig",null,"",[],false],[197,0,0,null,null,null,null,false],[197,1,0,null,null,null,null,false],[197,2,0,null,null,null,null,false],[197,3,0,null,null,null,null,false],[197,4,0,null,null,null,null,false],[197,10,0,null,null," This is a value that starts out unavailable, until resolve() is called\n While it is unavailable, functions suspend when they try to get() it,\n and then are resumed when resolve() is called.\n At this point the value remains forever available, and another resolve() is not allowed.",[24689],false],[0,0,0,"T",null,"",[24706,24708,24710],true],[197,16,0,null,null,null,[24691,24692,24693],false],[0,0,0,"NotStarted",null,null,null,false],[0,0,0,"Started",null,null,null,false],[0,0,0,"Finished",null,null,null,false],[197,22,0,null,null,null,null,false],[197,23,0,null,null,null,null,false],[197,25,0,null,null,null,[],false],[197,36,0,null,null," Obtain the value. If it's not available, wait until it becomes\n available.\n Thread-safe.",[24698],false],[0,0,0,"self",null,"",null,false],[197,48,0,null,null," Gets the data without waiting for it. If it's available, a pointer is\n returned. Otherwise, null is returned.",[24700],false],[0,0,0,"self",null,"",null,false],[197,61,0,null,null," If someone else has started working on the data, wait for them to complete\n and return a pointer to the data. Otherwise, return null, and the caller\n should start working on the data.\n It's not required to call start() before resolve() but it can be useful since\n this method is thread-safe.",[24702],false],[0,0,0,"self",null,"",null,false],[197,76,0,null,null," Make the data become available. May be called only once.\n Before calling this, modify the `data` property.",[24704],false],[0,0,0,"self",null,"",null,false],[197,11,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[197,11,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[197,11,0,null,null,null,null,false],[0,0,0,"available",null,null,null,false],[197,95,0,null,null,null,[],false],[197,107,0,null,null,null,[24713],false],[0,0,0,"future",null,"",null,false],[197,111,0,null,null,null,[24715],false],[0,0,0,"future",null,"",null,false],[195,2,0,null,null,null,null,false],[0,0,0,"event/group.zig",null,"",[],false],[198,0,0,null,null,null,null,false],[198,1,0,null,null,null,null,false],[198,2,0,null,null,null,null,false],[198,3,0,null,null,null,null,false],[198,4,0,null,null,null,null,false],[198,12,0,null,null," ReturnType must be `void` or `E!void`\n TODO This API was created back with the old design of async/await, when calling any\n async function required an allocator. There is an ongoing experiment to transition\n all uses of this API to the simpler and more resource-aware `std.event.Batch` API.\n If the transition goes well, all usages of `Group` will be gone, and this API\n will be deleted.",[24724],false],[0,0,0,"ReturnType",null,"",[24749,24751,24753,24755],true],[198,19,0,null,null,null,null,false],[198,21,0,null,null,null,null,false],[198,25,0,null,null,null,null,false],[198,26,0,null,null,null,null,false],[198,28,0,null,null,null,[24731,24733],false],[198,28,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[198,28,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[198,33,0,null,null,null,[24735],false],[0,0,0,"allocator",null,"",null,false],[198,43,0,null,null," Add a frame to the group. Thread-safe.",[24737,24738],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[198,59,0,null,null," Add a node to the group. Thread-safe. Cannot fail.\n `node.data` should be the frame handle to add to the group.\n The node's memory should be in the function frame of\n the handle that is in the node, or somewhere guaranteed to live\n at least as long.",[24740,24741],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[198,67,0,null,null," This is equivalent to adding a frame to the group but the memory of its frame is\n allocated by the group and freed by `wait`.\n `func` must be async and have return type `ReturnType`.\n Thread-safe.",[24743,24744,24745],false],[0,0,0,"self",null,"",null,false],[0,0,0,"func",null,"",null,true],[0,0,0,"args",null,"",null,false],[198,86,0,null,null," Wait for all the calls and promises of the group to complete.\n Thread-safe.\n Safe to call any number of times.",[24747],false],[0,0,0,"self",null,"",null,false],[198,13,0,null,null,null,null,false],[0,0,0,"frame_stack",null,null,null,false],[198,13,0,null,null,null,null,false],[0,0,0,"alloc_stack",null,null,null,false],[198,13,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[198,13,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[198,129,0,null,null,null,[24757],false],[0,0,0,"allocator",null,"",null,false],[198,146,0,null,null,null,[24759],false],[0,0,0,"count",null,"",null,false],[198,150,0,null,null,null,[24761],false],[0,0,0,"count",null,"",null,false],[198,156,0,null,null,null,[],false],[198,157,0,null,null,null,[],false],[195,3,0,null,null,null,null,false],[0,0,0,"event/batch.zig",null,"",[],false],[199,0,0,null,null,null,null,false],[199,1,0,null,null,null,null,false],[199,8,0,null,null," Performs multiple async functions in parallel, without heap allocation.\n Async function frames are managed externally to this abstraction, and\n passed in via the `add` function. Once all the jobs are added, call `wait`.\n This API is *not* thread-safe. The object must be accessed from one thread at\n a time, however, it need not be the same thread.",[24769,24770,24771],false],[0,0,0,"Result",null," The return value for each job.\n If a job slot was re-used due to maxed out concurrency, then its result\n value will be overwritten. The values can be accessed with the `results` field.\n",null,true],[0,0,0,"max_jobs",null," How many jobs to run in parallel.\n",null,true],[0,0,0,"async_behavior",null," Controls whether the `add` and `wait` functions will be async functions.\n",[24772,24773,24774],true],[0,0,0,"auto_async",null," Observe the value of `std.io.is_async` to decide whether `add`\n and `wait` will be async functions. Asserts that the jobs do not suspend when\n `std.options.io_mode == .blocking`. This is a generally safe assumption, and the\n usual recommended option for this parameter.",null,false],[0,0,0,"never_async",null," Always uses the `nosuspend` keyword when using `await` on the jobs,\n making `add` and `wait` non-async functions. Asserts that the jobs do not suspend.",null,false],[0,0,0,"always_async",null," `add` and `wait` use regular `await` keyword, making them async functions.",[24790,24791,24793],false],[199,36,0,null,null,null,[24777,24779],false],[199,36,0,null,null,null,null,false],[0,0,0,"frame",null,null,null,false],[199,36,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[199,41,0,null,null,null,null,false],[199,43,0,null,null,null,null,false],[199,48,0,null,null,null,null,false],[199,54,0,null,null,null,[],false],[199,73,0,null,null," Add a frame to the Batch. If all jobs are in-flight, then this function\n waits until one completes.\n This function is *not* thread-safe. It must be called from one thread at\n a time, however, it need not be the same thread.\n TODO: \"select\" language feature to use the next available slot, rather than\n awaiting the next index.",[24785,24786],false],[0,0,0,"self",null,"",null,false],[0,0,0,"frame",null,"",null,false],[199,94,0,null,null," Wait for all the jobs to complete.\n Safe to call any number of times.\n If `Result` is an error union, this function returns the last error that occurred, if any.\n Unlike the `results` field, the return value of `wait` will report any error that occurred;\n hitting max parallelism will not compromise the result.\n This function is *not* thread-safe. It must be called from one thread at\n a time, however, it need not be the same thread.",[24788],false],[0,0,0,"self",null,"",null,false],[199,31,0,null,null,null,null,false],[0,0,0,"jobs",null,null,null,false],[0,0,0,"next_job_index",null,null,null,false],[199,31,0,null,null,null,null,false],[0,0,0,"collected_result",null,null,null,false],[199,125,0,null,null,null,[24795],false],[0,0,0,"count",null,"",null,false],[199,130,0,null,null,null,[24797],false],[0,0,0,"count",null,"",null,false],[199,137,0,null,null,null,[],false],[199,138,0,null,null,null,[],false],[195,4,0,null,null,null,null,false],[0,0,0,"event/lock.zig",null,"",[],false],[200,0,0,null,null,null,null,false],[200,1,0,null,null,null,null,false],[200,2,0,null,null,null,null,false],[200,3,0,null,null,null,null,false],[200,4,0,null,null,null,null,false],[200,5,0,null,null,null,null,false],[200,12,0,null,null," Thread-safe async/await lock.\n Functions which are waiting for the lock are suspended, and\n are resumed when the lock is released, in order.\n Allows only one actor to hold the lock.\n TODO: make this API also work in blocking I/O mode.",[24828,24829],false],[200,16,0,null,null,null,null,false],[200,17,0,null,null,null,null,false],[200,19,0,null,null,null,null,false],[200,22,0,null,null,null,[24814,24816,24818],false],[200,22,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[200,22,0,null,null,null,null,false],[0,0,0,"tail",null,null,null,false],[200,22,0,null,null,null,null,false],[0,0,0,"node",null,null,null,false],[200,29,0,null,null,null,[],false],[200,33,0,null,null,null,[24821],false],[0,0,0,"self",null,"",null,false],[200,79,0,null,null,null,[24826],false],[200,82,0,null,null,null,[24824],false],[0,0,0,"self",null,"",null,false],[200,79,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[200,12,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[0,0,0,"head",null,null,null,false],[200,135,0,null,null,null,[24831],false],[0,0,0,"lock",null,"",null,false],[200,145,0,null,null,null,null,false],[200,146,0,null,null,null,null,false],[200,148,0,null,null,null,[24835],false],[0,0,0,"lock",null,"",null,false],[195,5,0,null,null,null,null,false],[0,0,0,"event/locked.zig",null,"",[],false],[201,0,0,null,null,null,null,false],[201,1,0,null,null,null,null,false],[201,6,0,null,null," Thread-safe async/await lock that protects one piece of data.\n Functions which are waiting for the lock are suspended, and\n are resumed when the lock is released, in order.",[24841],false],[0,0,0,"T",null,"",[24857,24859],true],[201,11,0,null,null,null,null,false],[201,13,0,null,null,null,[24847,24849],false],[201,17,0,null,null,null,[24845],false],[0,0,0,"self",null,"",null,false],[201,13,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[201,13,0,null,null,null,null,false],[0,0,0,"held",null,null,null,false],[201,22,0,null,null,null,[24851],false],[0,0,0,"data",null,"",null,false],[201,29,0,null,null,null,[24853],false],[0,0,0,"self",null,"",null,false],[201,33,0,null,null,null,[24855],false],[0,0,0,"self",null,"",null,false],[201,7,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[201,7,0,null,null,null,null,false],[0,0,0,"private_data",null,null,null,false],[195,6,0,null,null,null,null,false],[0,0,0,"event/rwlock.zig",null,"",[],false],[202,0,0,null,null,null,null,false],[202,1,0,null,null,null,null,false],[202,2,0,null,null,null,null,false],[202,3,0,null,null,null,null,false],[202,4,0,null,null,null,null,false],[202,5,0,null,null,null,null,false],[202,6,0,null,null,null,null,false],[202,15,0,null,null," Thread-safe async/await lock.\n Functions which are waiting for the lock are suspended, and\n are resumed when the lock is released, in order.\n Many readers can hold the lock at the same time; however locking for writing is exclusive.\n When a read lock is held, it will not be released until the reader queue is empty.\n When a write lock is held, it will not be released until the writer queue is empty.\n TODO: make this API also work in blocking I/O mode",[24896,24898,24900,24901,24902,24903],false],[202,23,0,null,null,null,[24871,24872,24873],false],[0,0,0,"Unlocked",null,null,null,false],[0,0,0,"WriteLock",null,null,null,false],[0,0,0,"ReadLock",null,null,null,false],[202,29,0,null,null,null,null,false],[202,31,0,null,null,null,null,false],[202,34,0,null,null,null,[24880],false],[202,37,0,null,null,null,[24878],false],[0,0,0,"self",null,"",null,false],[202,34,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[202,53,0,null,null,null,[24885],false],[202,56,0,null,null,null,[24883],false],[0,0,0,"self",null,"",null,false],[202,53,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[202,81,0,null,null,null,[],false],[202,94,0,null,null," Must be called when not locked. Not thread safe.\n All calls to acquire() and release() must complete before calling deinit().",[24888],false],[0,0,0,"self",null,"",null,false],[202,100,0,null,null,null,[24890],false],[0,0,0,"self",null,"",null,false],[202,133,0,null,null,null,[24892],false],[0,0,0,"self",null,"",null,false],[202,161,0,null,null,null,[24894],false],[0,0,0,"self",null,"",null,false],[202,15,0,null,null,null,null,false],[0,0,0,"shared_state",null,null,null,false],[202,15,0,null,null,null,null,false],[0,0,0,"writer_queue",null,null,null,false],[202,15,0,null,null,null,null,false],[0,0,0,"reader_queue",null,null,null,false],[0,0,0,"writer_queue_empty",null,null,null,false],[0,0,0,"reader_queue_empty",null,null,null,false],[0,0,0,"reader_lock_count",null,null,null,false],[202,228,0,null,null,null,[24905,24906],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"lock",null,"",null,false],[202,257,0,null,null,null,null,false],[202,258,0,null,null,null,null,false],[202,259,0,null,null,null,null,false],[202,260,0,null,null,null,null,false],[202,261,0,null,null,null,[24912],false],[0,0,0,"lock",null,"",null,false],[202,278,0,null,null,null,[24914],false],[0,0,0,"lock",null,"",null,false],[195,7,0,null,null,null,null,false],[0,0,0,"event/rwlocked.zig",null,"",[],false],[203,0,0,null,null,null,null,false],[203,1,0,null,null,null,null,false],[203,6,0,null,null," Thread-safe async/await RW lock that protects one piece of data.\n Functions which are waiting for the lock are suspended, and\n are resumed when the lock is released, in order.",[24920],false],[0,0,0,"T",null,"",[24945,24947],true],[203,11,0,null,null,null,null,false],[203,13,0,null,null,null,[24926,24928],false],[203,17,0,null,null,null,[24924],false],[0,0,0,"self",null,"",null,false],[203,13,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[203,13,0,null,null,null,null,false],[0,0,0,"held",null,null,null,false],[203,22,0,null,null,null,[24933,24935],false],[203,26,0,null,null,null,[24931],false],[0,0,0,"self",null,"",null,false],[203,22,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[203,22,0,null,null,null,null,false],[0,0,0,"held",null,null,null,false],[203,31,0,null,null,null,[24937],false],[0,0,0,"data",null,"",null,false],[203,38,0,null,null,null,[24939],false],[0,0,0,"self",null,"",null,false],[203,42,0,null,null,null,[24941],false],[0,0,0,"self",null,"",null,false],[203,49,0,null,null,null,[24943],false],[0,0,0,"self",null,"",null,false],[203,7,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[203,7,0,null,null,null,null,false],[0,0,0,"locked_data",null,null,null,false],[195,8,0,null,null,null,null,false],[0,0,0,"event/loop.zig",null,"",[],false],[204,0,0,null,null,null,null,false],[204,1,0,null,null,null,null,false],[204,2,0,null,null,null,null,false],[204,3,0,null,null,null,null,false],[204,4,0,null,null,null,null,false],[204,5,0,null,null,null,null,false],[204,6,0,null,null,null,null,false],[204,7,0,null,null,null,null,false],[204,8,0,null,null,null,null,false],[204,9,0,null,null,null,null,false],[204,11,0,null,null,null,null,false],[204,13,0,null,null,null,[25353,25355,25357,25358,25360,25362,25364,25366,25368,25370,25372,25374,25376],false],[204,40,0,null,null,null,null,false],[204,42,0,null,null,null,[24983,24985,24987],false],[204,47,0,null,null,null,null,false],[204,61,0,null,null,null,null,false],[204,63,0,null,null,null,[24967,24968,24969],false],[0,0,0,"basic",null,null,null,false],[0,0,0,"stop",null,null,null,false],[0,0,0,"event_fd",null,null,null,false],[204,69,0,null,null,null,null,false],[204,83,0,null,null,null,[24973,24975],false],[204,83,0,null,null,null,null,false],[0,0,0,"base",null,null,null,false],[204,83,0,null,null,null,null,false],[0,0,0,"kevent",null,null,null,false],[204,88,0,null,null,null,null,false],[204,99,0,null,null,null,[24979,24981],false],[204,99,0,null,null,null,null,false],[0,0,0,"base",null,null,null,false],[204,99,0,null,null,null,null,false],[0,0,0,"kev",null,null,null,false],[204,42,0,null,null,null,null,false],[0,0,0,"id",null,null,null,false],[204,42,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[204,42,0,null,null,null,null,false],[0,0,0,"overlapped",null,null,null,false],[204,105,0,null,null,null,null,false],[204,109,0,null,null,null,null,false],[204,111,0,null,null,null,null,false],[204,112,0,null,null,null,null,false],[204,117,0,null,null,null,[24993,24994],false],[0,0,0,"single_threaded",null,null,null,false],[0,0,0,"multi_threaded",null,null,null,false],[204,121,0,null,null,null,null,false],[204,126,0,null,null," TODO copy elision / named return values so that the threads referencing *Loop\n have the correct pointer value.\n https://github.com/ziglang/zig/issues/2761 and https://github.com/ziglang/zig/issues/2765",[24997],false],[0,0,0,"self",null,"",null,false],[204,138,0,null,null," After initialization, call run().\n TODO copy elision / named return values so that the threads referencing *Loop\n have the correct pointer value.\n https://github.com/ziglang/zig/issues/2761 and https://github.com/ziglang/zig/issues/2765",[24999],false],[0,0,0,"self",null,"",null,false],[204,148,0,null,null," After initialization, call run().\n This is the same as `initThreadPool` using `Thread.getCpuCount` to determine the thread\n pool size.\n TODO copy elision / named return values so that the threads referencing *Loop\n have the correct pointer value.\n https://github.com/ziglang/zig/issues/2761 and https://github.com/ziglang/zig/issues/2765",[25001],false],[0,0,0,"self",null,"",null,false],[204,157,0,null,null," Thread count is the total thread count. The thread pool size will be\n max(thread_count - 1, 0)",[25003,25004],false],[0,0,0,"self",null,"",null,false],[0,0,0,"thread_count",null,"",null,false],[204,204,0,null,null,null,[25006],false],[0,0,0,"self",null,"",null,false],[204,210,0,null,null,null,null,false],[204,214,0,null,null,null,null,false],[204,216,0,null,null,null,[25010,25011],false],[0,0,0,"self",null,"",null,false],[0,0,0,"extra_thread_count",null,"",null,false],[204,455,0,null,null,null,[25013],false],[0,0,0,"self",null,"",null,false],[204,474,0,null,null," resume_node must live longer than the anyframe that it holds a reference to.\n flags must contain EPOLLET",[25015,25016,25017,25018],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"resume_node",null,"",null,false],[0,0,0,"flags",null,"",null,false],[204,486,0,null,null,null,[25020,25021,25022,25023,25024],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"resume_node",null,"",null,false],[204,495,0,null,null,null,[25026,25027],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[204,500,0,null,null,null,[25029,25030,25031],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[204,552,0,null,null,null,[25033,25034],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[204,564,0,null,null,null,[25036,25037],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[204,576,0,null,null,null,[25039,25040],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[204,589,0,null,null,null,[25042,25043,25044,25045],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ident",null,"",null,false],[0,0,0,"filter",null,"",null,false],[0,0,0,"flags",null,"",null,false],[204,612,0,null,null," resume_node must live longer than the anyframe that it holds a reference to.",[25047,25048,25049,25050,25051],false],[0,0,0,"self",null,"",null,false],[0,0,0,"resume_node",null,"",null,false],[0,0,0,"ident",null,"",null,false],[0,0,0,"filter",null,"",null,false],[0,0,0,"flags",null,"",null,false],[204,627,0,null,null,null,[25053,25054,25055],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ident",null,"",null,false],[0,0,0,"filter",null,"",null,false],[204,641,0,null,null,null,[25057],false],[0,0,0,"self",null,"",null,false],[204,692,0,null,null," Bring your own linked list node. This means it can't fail.",[25059,25060],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[204,698,0,null,null,null,[25062,25063],false],[0,0,0,"self",null,"",null,false],[0,0,0,"node",null,"",null,false],[204,704,0,null,null,null,[25065],false],[0,0,0,"self",null,"",null,false],[204,736,0,null,null," Runs the provided function asynchronously. The function's frame is allocated\n with `allocator` and freed when the function returns.\n `func` must return void and it can be an async function.\n Yields to the event loop, running the function on the next tick.",[25067,25068,25069,25070],false],[0,0,0,"self",null,"",null,false],[0,0,0,"alloc",null,"",null,false],[0,0,0,"func",null,"",null,true],[0,0,0,"args",null,"",null,false],[204,764,0,null,null," Yielding lets the event loop run, starting any unstarted async operations.\n Note that async operations automatically start when a function yields for any other reason,\n for example, when async I/O is performed. This function is intended to be used only when\n CPU bound tasks would be waiting in the event loop but never get started because no async I/O\n is performed.",[25072],false],[0,0,0,"self",null,"",null,false],[204,777,0,null,null," If the build is multi-threaded and there is an event loop, then it calls `yield`. Otherwise,\n does nothing.",[],false],[204,786,0,null,null," call finishOneEvent when done",[25075],false],[0,0,0,"self",null,"",null,false],[204,790,0,null,null,null,[25077],false],[0,0,0,"self",null,"",null,false],[204,833,0,null,null,null,[25079,25080],false],[0,0,0,"self",null,"",null,false],[0,0,0,"nanoseconds",null,"",null,false],[204,851,0,null,null,null,[25110,25112,25114,25116,25118],false],[204,860,0,null,null," Initialize the delay queue by spawning the timer thread\n and starting any timer resources.",[25083],false],[0,0,0,"self",null,"",null,false],[204,875,0,null,null,null,[25085],false],[0,0,0,"self",null,"",null,false],[204,883,0,null,null," Entry point for the timer thread\n which waits for timer entries to expire and reschedules them.",[25087],false],[0,0,0,"self",null,"",null,false],[204,907,0,null,null,null,[25108],false],[204,910,0,null,null,null,[25095,25096],false],[204,914,0,null,null,null,[25091,25092,25093],false],[0,0,0,"self",null,"",null,false],[0,0,0,"frame",null,"",null,false],[0,0,0,"expires",null,"",null,false],[204,910,0,null,null,null,null,false],[0,0,0,"node",null,null,null,false],[0,0,0,"expires",null,null,null,false],[204,921,0,null,null," Registers the entry into the queue of waiting frames",[25098,25099],false],[0,0,0,"self",null,"",null,false],[0,0,0,"entry",null,"",null,false],[204,926,0,null,null," Dequeues one expired event relative to `now`",[25101,25102],false],[0,0,0,"self",null,"",null,false],[0,0,0,"now",null,"",null,false],[204,937,0,null,null," Returns an estimate for the amount of time\n to wait until the next waiting entry expires.",[25104],false],[0,0,0,"self",null,"",null,false],[204,942,0,null,null,null,[25106],false],[0,0,0,"self",null,"",null,false],[204,907,0,null,null,null,null,false],[0,0,0,"entries",null,null,null,false],[204,851,0,null,null,null,null,false],[0,0,0,"timer",null,null,null,false],[204,851,0,null,null,null,null,false],[0,0,0,"waiters",null,null,null,false],[204,851,0,null,null,null,null,false],[0,0,0,"thread",null,null,null,false],[204,851,0,null,null,null,null,false],[0,0,0,"event",null,null,null,false],[204,851,0,null,null,null,null,false],[0,0,0,"is_running",null,null,null,false],[204,966,0,null,null," ------- I/0 APIs -------",[25120,25121,25122,25123,25124],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sockfd",null," This argument is a socket that has been created with `socket`, bound to a local address\n with `bind`, and is listening for connections after a `listen`.",null,false],[0,0,0,"addr",null," This argument is a pointer to a sockaddr structure.  This structure is filled in with  the\n address  of  the  peer  socket, as known to the communications layer.  The exact format of the\n address returned addr is determined by the socket's address  family  (see  `socket`  and  the\n respective  protocol  man  pages).",null,false],[0,0,0,"addr_size",null," This argument is a value-result argument: the caller must initialize it to contain  the\n size (in bytes) of the structure pointed to by addr; on return it will contain the actual size\n of the peer address.\n\n The returned address is truncated if the buffer provided is too small; in this  case,  `addr_size`\n will return a value greater than was supplied to the call.",null,false],[0,0,0,"flags",null," The following values can be bitwise ORed in flags to obtain different behavior:\n * `SOCK.CLOEXEC`  - Set the close-on-exec (`FD_CLOEXEC`) flag on the new file descriptor.   See  the\n   description  of the `O.CLOEXEC` flag in `open` for reasons why this may be useful.",null,false],[204,999,0,null,null,null,[25126,25127,25128,25129],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"sock_addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[204,1010,0,null,null," Performs an async `os.open` using a separate thread.",[25131,25132,25133,25134],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[204,1031,0,null,null," Performs an async `os.opent` using a separate thread.",[25136,25137,25138,25139,25140],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[204,1053,0,null,null," Performs an async `os.close` using a separate thread.",[25142,25143],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[204,1067,0,null,null," Performs an async `os.read` using a separate thread.\n `fd` must block and not return EAGAIN.",[25145,25146,25147,25148],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1100,0,null,null," Performs an async `os.readv` using a separate thread.\n `fd` must block and not return EAGAIN.",[25150,25151,25152,25153],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1133,0,null,null," Performs an async `os.pread` using a separate thread.\n `fd` must block and not return EAGAIN.",[25155,25156,25157,25158,25159],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1167,0,null,null," Performs an async `os.preadv` using a separate thread.\n `fd` must block and not return EAGAIN.",[25161,25162,25163,25164,25165],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1201,0,null,null," Performs an async `os.write` using a separate thread.\n `fd` must block and not return EAGAIN.",[25167,25168,25169,25170],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1234,0,null,null," Performs an async `os.writev` using a separate thread.\n `fd` must block and not return EAGAIN.",[25172,25173,25174,25175],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1267,0,null,null," Performs an async `os.pwrite` using a separate thread.\n `fd` must block and not return EAGAIN.",[25177,25178,25179,25180,25181],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1301,0,null,null," Performs an async `os.pwritev` using a separate thread.\n `fd` must block and not return EAGAIN.",[25183,25184,25185,25186,25187],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"simulate_evented",null,"",null,false],[204,1333,0,null,null,null,[25189,25190,25191,25192,25193,25194],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sockfd",null," The file descriptor of the sending socket.",null,false],[0,0,0,"buf",null," Message to send.",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"dest_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[204,1354,0,null,null,null,[25196,25197,25198,25199,25200,25201],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"src_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[204,1375,0,null,null," Performs an async `os.faccessatZ` using a separate thread.\n `fd` must block and not return EAGAIN.",[25203,25204,25205,25206,25207],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path_z",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[204,1402,0,null,null,null,[25209],false],[0,0,0,"self",null,"",null,false],[204,1495,0,null,null,null,[25211,25212],false],[0,0,0,"self",null,"",null,false],[0,0,0,"request_node",null,"",null,false],[204,1501,0,null,null,null,[25214,25215],false],[0,0,0,"self",null,"",null,false],[0,0,0,"request_node",null,"",null,false],[204,1507,0,null,null,null,[25217],false],[0,0,0,"self",null,"",null,false],[204,1560,0,null,null,null,null,false],[204,1570,0,null,null,null,[25220,25222],false],[0,0,0,"kqfd",null,null,null,false],[204,1570,0,null,null,null,null,false],[0,0,0,"final_kevent",null,null,null,false],[204,1575,0,null,null,null,[25224,25225,25227],false],[0,0,0,"epollfd",null,null,null,false],[0,0,0,"final_eventfd",null,null,null,false],[204,1575,0,null,null,null,null,false],[0,0,0,"final_eventfd_event",null,null,null,false],[204,1581,0,null,null,null,[25349,25351],false],[204,1585,0,null,null,null,null,false],[204,1587,0,null,null,null,[25231,25232],false],[0,0,0,"tick_node",null,null,null,false],[0,0,0,"no_action",null,null,null,false],[204,1592,0,null,null,null,[25335,25336,25337,25338,25339,25340,25341,25342,25343,25344,25345,25346,25347],false],[204,1609,0,null,null,null,[25237,25239,25241],false],[204,1614,0,null,null,null,null,false],[204,1609,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1609,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[204,1609,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1617,0,null,null,null,[25245,25247,25249],false],[204,1622,0,null,null,null,null,false],[204,1617,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1617,0,null,null,null,null,false],[0,0,0,"iov",null,null,null,false],[204,1617,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1625,0,null,null,null,[25253,25255,25257],false],[204,1630,0,null,null,null,null,false],[204,1625,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1625,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[204,1625,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1633,0,null,null,null,[25261,25263,25265],false],[204,1638,0,null,null,null,null,false],[204,1633,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1633,0,null,null,null,null,false],[0,0,0,"iov",null,null,null,false],[204,1633,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1641,0,null,null,null,[25269,25271,25272,25274],false],[204,1647,0,null,null,null,null,false],[204,1641,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1641,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"offset",null,null,null,false],[204,1641,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1650,0,null,null,null,[25278,25280,25281,25283],false],[204,1656,0,null,null,null,null,false],[204,1650,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1650,0,null,null,null,null,false],[0,0,0,"iov",null,null,null,false],[0,0,0,"offset",null,null,null,false],[204,1650,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1659,0,null,null,null,[25287,25289,25290,25292],false],[204,1665,0,null,null,null,null,false],[204,1659,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1659,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"offset",null,null,null,false],[204,1659,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1668,0,null,null,null,[25296,25298,25299,25301],false],[204,1674,0,null,null,null,null,false],[204,1668,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1668,0,null,null,null,null,false],[0,0,0,"iov",null,null,null,false],[0,0,0,"offset",null,null,null,false],[204,1668,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1677,0,null,null,null,[25305,25306,25308,25310],false],[204,1683,0,null,null,null,null,false],[204,1677,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[0,0,0,"flags",null,null,null,false],[204,1677,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[204,1677,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1686,0,null,null,null,[25314,25316,25317,25319,25321],false],[204,1693,0,null,null,null,null,false],[204,1686,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1686,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[0,0,0,"flags",null,null,null,false],[204,1686,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[204,1686,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[204,1696,0,null,null,null,[25324],false],[204,1696,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[204,1700,0,null,null,null,[25328,25330,25331,25332,25334],false],[204,1707,0,null,null,null,null,false],[204,1700,0,null,null,null,null,false],[0,0,0,"dirfd",null,null,null,false],[204,1700,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[0,0,0,"mode",null,null,null,false],[0,0,0,"flags",null,null,null,false],[204,1700,0,null,null,null,null,false],[0,0,0,"result",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"pwrite",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"pread",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"end",null," special - means the fs thread should exit",null,false],[204,1581,0,null,null,null,null,false],[0,0,0,"msg",null,null,null,false],[204,1581,0,null,null,null,null,false],[0,0,0,"finish",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"next_tick_queue",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"os_data",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"final_resume_node",null,null,null,false],[0,0,0,"pending_event_count",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"extra_threads",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"fs_thread",null," TODO change this to a pool of configurable number of threads\n and rename it to be not file-system-specific. it will become\n a thread pool for turning non-CPU-bound blocking things into\n async things. A fallback for any missing OS-specific API.",null,false],[204,13,0,null,null,null,null,false],[0,0,0,"fs_queue",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"fs_end_request",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"fs_thread_wakeup",null,null,null,false],[204,13,0,null,null,null,null,false],[0,0,0,"arena",null," For resources that have the same lifetime as the `Loop`.\n This is only used by `Loop` for the thread pool and associated resources.",null,false],[204,13,0,null,null,null,null,false],[0,0,0,"delay_queue",null," State which manages frames that are sleeping on timers",null,false],[204,13,0,null,null,null,null,false],[0,0,0,"available_eventfd_resume_nodes",null," Pre-allocated eventfds. All permanently active.\n This is how `Loop` sends promises to be resumed on other threads.",null,false],[204,13,0,null,null,null,null,false],[0,0,0,"eventfd_resume_nodes",null,null,null,false],[204,1729,0,null,null,null,[],false],[204,1733,0,null,null,null,[25379,25380],false],[0,0,0,"h",null,"",null,false],[0,0,0,"did_it",null,"",null,false],[204,1739,0,null,null,null,null,false],[204,1765,0,null,null,null,[],false],[204,1788,0,null,null,null,[25384,25385],false],[0,0,0,"wait_ns",null,"",null,false],[0,0,0,"sleep_count",null,"",null,false],[195,9,0,null,null,null,null,false],[0,0,0,"event/wait_group.zig",null,"",[],false],[205,0,0,null,null,null,null,false],[205,1,0,null,null,null,null,false],[205,2,0,null,null,null,null,false],[205,16,0,null,null," A WaitGroup keeps track and waits for a group of async tasks to finish.\n Call `begin` when creating new tasks, and have tasks call `finish` when done.\n You can provide a count for both operations to perform them in bulk.\n Call `wait` to suspend until all tasks are completed.\n Multiple waiters are supported.\n\n WaitGroup is an instance of WaitGroupGeneric, which takes in a bitsize\n for the internal counter. WaitGroup defaults to a `usize` counter.\n It's also possible to define a max value for the counter so that\n `begin` will return error.Overflow when the limit is reached, even\n if the integer type has not has not overflowed.\n By default `max_value` is set to std.math.maxInt(CounterType).",null,false],[205,18,0,null,null,null,[25393],false],[0,0,0,"counter_size",null,"",[25411,25413,25415,25417],true],[205,29,0,null,null,null,[25396,25398,25400],false],[205,29,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[205,29,0,null,null,null,null,false],[0,0,0,"tail",null,null,null,false],[205,29,0,null,null,null,null,false],[0,0,0,"node",null,null,null,false],[205,35,0,null,null,null,null,false],[205,36,0,null,null,null,[25403,25404],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[205,45,0,null,null,null,[25406,25407],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[205,66,0,null,null,null,[25409],false],[0,0,0,"self",null,"",null,false],[205,24,0,null,null,null,null,false],[0,0,0,"counter",null,null,null,false],[205,24,0,null,null,null,null,false],[0,0,0,"max_counter",null,null,null,false],[205,24,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[205,24,0,null,null,null,null,false],[0,0,0,"waiters",null,null,null,false],[205,111,0,null,null,null,[25419,25420],false],[0,0,0,"wg_i",null,"",null,false],[0,0,0,"wg_f",null,"",null,false],[1,100,0,null,null," First in, first out data structures.",null,false],[0,0,0,"fifo.zig",null,"",[],false],[206,3,0,null,null,null,null,false],[206,4,0,null,null,null,null,false],[206,5,0,null,null,null,null,false],[206,6,0,null,null,null,null,false],[206,7,0,null,null,null,null,false],[206,8,0,null,null,null,null,false],[206,10,0,null,null,null,[25430,25431,25432],false],[0,0,0,"Static",null," The buffer is internal to the fifo; it is of the specified size.",null,false],[0,0,0,"Slice",null," The buffer is passed as a slice to the initialiser.",null,false],[0,0,0,"Dynamic",null," The buffer is managed dynamically using a `mem.Allocator`.",null,false],[206,21,0,null,null,null,[25434,25435],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buffer_type",null,"",[25522,25524,25525,25526],true],[206,48,0,null,null,null,null,false],[206,39,0,null,null,null,null,false],[206,40,0,null,null,null,null,false],[206,41,0,null,null,null,null,false],[206,46,0,null,null,null,null,false],[206,81,0,null,null,null,[25442],false],[0,0,0,"self",null,"",null,false],[206,85,0,null,null,null,[25444],false],[0,0,0,"self",null,"",null,false],[206,108,0,null,null," Reduce allocated capacity to `size`.",[25446,25447],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,"",null,false],[206,119,0,null,null," Ensure that the buffer can fit at least `size` items",[25449,25450],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,"",null,false],[206,131,0,null,null," Makes sure at least `size` items are unused",[25452,25453],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,"",null,false],[206,138,0,null,null," Returns number of items currently in fifo",[25455],false],[0,0,0,"self",null,"",null,false],[206,143,0,null,null," Returns a writable slice from the 'read' end of the fifo",[25457,25458],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[206,157,0,null,null," Returns a readable slice from `offset`",[25460,25461],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[206,161,0,null,null,null,[25463,25464],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,"",null,false],[206,173,0,null,null," Discard first `count` items in the fifo",[25466,25467],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[206,205,0,null,null," Read the next item from the fifo",[25469],false],[0,0,0,"self",null,"",null,false],[206,214,0,null,null," Read data from the fifo into `dst`, returns number of items copied.",[25471,25472],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dst",null,"",null,false],[206,231,0,null,null," Same as `read` except it returns an error union\n The purpose of this function existing is to match `std.io.Reader` API.",[25474,25475],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[206,235,0,null,null,null,[25477],false],[0,0,0,"self",null,"",null,false],[206,240,0,null,null," Returns number of items available in fifo",[25479],false],[0,0,0,"self",null,"",null,false],[206,246,0,null,null," Returns the first section of writable buffer\n Note that this may be of length 0",[25481,25482],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[206,259,0,null,null," Returns a writable buffer of at least `size` items, allocating memory as needed.\n Use `fifo.update` once you've written data to it.",[25484,25485],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,"",null,false],[206,272,0,null,null," Update the tail location of the buffer (usually follows use of writable/writableWithSize)",[25487,25488],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[206,279,0,null,null," Appends the data in `src` to the fifo.\n You must have ensured there is enough space.",[25490,25491],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src",null,"",null,false],[206,294,0,null,null," Write a single item to the fifo",[25493,25494],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[206,299,0,null,null,null,[25496,25497],false],[0,0,0,"self",null,"",null,false],[0,0,0,"item",null,"",null,false],[206,312,0,null,null," Appends the data in `src` to the fifo.\n Allocates more memory as necessary",[25499,25500],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src",null,"",null,false],[206,320,0,null,null," Same as `write` except it returns the number of bytes written, which is always the same\n as `bytes.len`. The purpose of this function existing is to match `std.io.Writer` API.",[25502,25503],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[206,325,0,null,null,null,[25505],false],[0,0,0,"self",null,"",null,false],[206,330,0,null,null," Make `count` items available before the current read location",[25507,25508],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[206,344,0,null,null," Place data back into the read stream",[25510,25511],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src",null,"",null,false],[206,361,0,null,null," Returns the item at `offset`.\n Asserts offset is within bounds.",[25513,25514],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[206,376,0,null,null," Pump data from a reader into a writer\n stops when reader returns 0 bytes (EOF)\n Buffer size must be set before calling; a buffer length of 0 is invalid.",[25516,25517,25518],false],[0,0,0,"self",null,"",null,false],[0,0,0,"src_reader",null,"",null,false],[0,0,0,"dest_writer",null,"",null,false],[206,392,0,null,null,null,[25520],false],[0,0,0,"self",null,"",null,false],[206,33,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[206,33,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"head",null,null,null,false],[0,0,0,"count",null,null,null,false],[1,103,0,null,null," String formatting and parsing (e.g. parsing numbers out of strings).",null,false],[0,0,0,"fmt.zig",null,"",[],false],[207,0,0,null,null,null,null,false],[207,1,0,null,null,null,null,false],[207,3,0,null,null,null,null,false],[207,4,0,null,null,null,null,false],[207,5,0,null,null,null,null,false],[207,6,0,null,null,null,null,false],[207,7,0,null,null,null,null,false],[207,8,0,null,null,null,null,false],[207,9,0,null,null,null,null,false],[0,0,0,"fmt/errol.zig",null,"",[],false],[208,0,0,null,null,null,null,false],[208,1,0,null,null,null,null,false],[0,0,0,"errol/enum3.zig",null,"",[],false],[209,0,0,null,null,null,null,false],[209,435,0,null,null,null,[25545,25546],false],[209,435,0,null,null,null,null,false],[0,0,0,"str",null,null,null,false],[0,0,0,"exp",null,null,null,false],[209,440,0,null,null,null,[25548,25549],false],[0,0,0,"str",null,"",null,false],[0,0,0,"exp",null,"",null,false],[209,447,0,null,null,null,null,false],[208,2,0,null,null,null,null,false],[208,3,0,null,null,null,null,false],[0,0,0,"errol/lookup.zig",null,"",[],false],[210,0,0,null,null,null,[25555,25556],false],[0,0,0,"val",null,null,null,false],[0,0,0,"off",null,null,null,false],[210,4,0,null,null,null,null,false],[208,4,0,null,null,null,null,false],[208,5,0,null,null,null,null,false],[208,6,0,null,null,null,null,false],[208,7,0,null,null,null,null,false],[208,9,0,null,null,null,[25564,25565],false],[208,9,0,null,null,null,null,false],[0,0,0,"digits",null,null,null,false],[0,0,0,"exp",null,null,null,false],[208,14,0,null,null,null,[25567,25568],false],[0,0,0,"Decimal",null,null,null,false],[0,0,0,"Scientific",null,null,null,false],[208,23,0,null,null," Round a FloatDecimal as returned by errol3 to the specified fractional precision.\n All digits after the specified precision should be considered invalid.",[25570,25571,25572],false],[0,0,0,"float_decimal",null,"",null,false],[0,0,0,"precision",null,"",null,false],[0,0,0,"mode",null,"",null,false],[208,81,0,null,null," Corrected Errol3 double to ASCII conversion.",[25574,25575],false],[0,0,0,"value",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[208,101,0,null,null," Uncorrected Errol3 double to ASCII conversion.",[25577,25578],false],[0,0,0,"val",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[208,111,0,null,null,null,[25580,25581],false],[0,0,0,"val",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[208,202,0,null,null,null,[25583],false],[0,0,0,"k",null,"",null,false],[208,222,0,null,null," Compute the product of an HP number and a double.\n   @in: The HP number.\n   @val: The double.\n   &returns: The HP number.",[25585,25586],false],[0,0,0,"in",null,"",null,false],[0,0,0,"val",null,"",null,false],[208,244,0,null,null," Split a double into two halves.\n   @val: The double.\n   @hi: The high bits.\n   @lo: The low bits.",[25588,25589,25590],false],[0,0,0,"val",null,"",null,false],[0,0,0,"hi",null,"",null,false],[0,0,0,"lo",null,"",null,false],[208,249,0,null,null,null,[25592],false],[0,0,0,"in",null,"",null,false],[208,257,0,null,null," Normalize the number by factoring in the error.\n   @hp: The float pair.",[25594],false],[0,0,0,"hp",null,"",null,false],[208,265,0,null,null," Divide the high-precision number by ten.\n   @hp: The high-precision number",[25596],false],[0,0,0,"hp",null,"",null,false],[208,281,0,null,null," Multiply the high-precision number by ten.\n   @hp: The high-precision number",[25598],false],[0,0,0,"hp",null,"",null,false],[208,300,0,null,null," Integer conversion algorithm, guaranteed correct, optimal, and best.\n  @val: The val.\n  @buf: The output buffer.\n  &return: The exponent.",[25600,25601],false],[0,0,0,"val",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[208,359,0,null,null," Fixed point conversion algorithm, guaranteed correct, optimal, and best.\n  @val: The val.\n  @buf: The output buffer.\n  &return: The exponent.",[25603,25604],false],[0,0,0,"val",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[208,414,0,null,null,null,[25606],false],[0,0,0,"val",null,"",null,false],[208,418,0,null,null,null,[25608],false],[0,0,0,"val",null,"",null,false],[208,422,0,null,null,null,null,false],[208,440,0,null,null,null,[25611,25612],false],[0,0,0,"value_param",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[208,673,0,null,null,null,[25614],false],[0,0,0,"from",null,"",null,false],[208,687,0,null,null," Given two different integers with the same length in terms of the number\n of decimal digits, index the digits from the right-most position starting\n from zero, find the first index where the digits in the two integers\n divergent starting from the highest index.\n   @a: Integer a.\n   @b: Integer b.\n   &returns: An index within [0, 19).",[25616,25617],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[207,10,0,null,null,null,null,false],[207,11,0,null,null,null,null,false],[207,13,0,null,null,null,null,false],[207,15,0,null,null,null,[25622,25623,25624],false],[0,0,0,"left",null,null,null,false],[0,0,0,"center",null,null,null,false],[0,0,0,"right",null,null,null,false],[207,21,0,null,null,null,[25627,25629,25631,25632],false],[207,21,0,null,null,null,null,false],[0,0,0,"precision",null,null,null,false],[207,21,0,null,null,null,null,false],[0,0,0,"width",null,null,null,false],[207,21,0,null,null,null,null,false],[0,0,0,"alignment",null,null,null,false],[0,0,0,"fill",null,null,null,false],[207,78,0,null,null," Renders fmt string with args, calling `writer` with slices of bytes.\n If `writer` returns an error, the error is returned from `format` and\n `writer` is not called again.\n\n The format string must be comptime-known and may contain placeholders following\n this format:\n `{[argument][specifier]:[fill][alignment][width].[precision]}`\n\n Above, each word including its surrounding [ and ] is a parameter which you have to replace with something:\n\n - *argument* is either the numeric index or the field name of the argument that should be inserted\n   - when using a field name, you are required to enclose the field name (an identifier) in square\n     brackets, e.g. {[score]...} as opposed to the numeric index form which can be written e.g. {2...}\n - *specifier* is a type-dependent formatting option that determines how a type should formatted (see below)\n - *fill* is a single character which is used to pad the formatted text\n - *alignment* is one of the three characters `<`, `^`, or `>` to make the text left-, center-, or right-aligned, respectively\n - *width* is the total width of the field in characters\n - *precision* specifies how many decimals a formatted number should have\n\n Note that most of the parameters are optional and may be omitted. Also you can leave out separators like `:` and `.` when\n all parameters after the separator are omitted.\n Only exception is the *fill* parameter. If *fill* is required, one has to specify *alignment* as well, as otherwise\n the digits after `:` is interpreted as *width*, not *fill*.\n\n The *specifier* has several options for types:\n - `x` and `X`: output numeric value in hexadecimal notation\n - `s`:\n   - for pointer-to-many and C pointers of u8, print as a C-string using zero-termination\n   - for slices of u8, print the entire slice as a string without zero-termination\n - `e`: output floating point value in scientific notation\n - `d`: output numeric value in decimal notation\n - `b`: output integer value in binary notation\n - `o`: output integer value in octal notation\n - `c`: output integer as an ASCII character. Integer type must have 8 bits at max.\n - `u`: output integer as an UTF-8 sequence. Integer type must have 21 bits at max.\n - `?`: output optional value as either the unwrapped value, or `null`; may be followed by a format specifier for the underlying value.\n - `!`: output error union value as either the unwrapped value, or the formatted error value; may be followed by a format specifier for the underlying value.\n - `*`: output the address of the value instead of the value itself.\n - `any`: output a value of any type using its default format.\n\n If a formatted user type contains a function of the type\n ```\n pub fn format(value: ?, comptime fmt: []const u8, options: std.fmt.FormatOptions, writer: anytype) !void\n ```\n with `?` being the type formatted, this function will be called instead of the default implementation.\n This allows user types to be formatted in a logical manner instead of dumping all fields of the type.\n\n A user type may be a `struct`, `vector`, `union` or `enum` type.\n\n To print literal curly braces, escape them by writing them twice, e.g. `{{` or `}}`.",[25634,25635,25636],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,207,0,null,null,null,[25638],false],[0,0,0,"str",null,"",null,false],[207,211,0,null,null,null,[25643,25644,25646,25648,25650,25652],false],[207,219,0,null,null,null,[25641],false],[0,0,0,"str",null,"",null,true],[207,211,0,null,null,null,null,false],[0,0,0,"specifier_arg",null,null,null,false],[0,0,0,"fill",null,null,null,false],[207,211,0,null,null,null,null,false],[0,0,0,"alignment",null,null,null,false],[207,211,0,null,null,null,null,false],[0,0,0,"arg",null,null,null,false],[207,211,0,null,null,null,null,false],[0,0,0,"width",null,null,null,false],[207,211,0,null,null,null,null,false],[0,0,0,"precision",null,null,null,false],[207,290,0,null,null,null,[25654,25655,25656],false],[0,0,0,"none",null,null,null,false],[0,0,0,"number",null,null,null,false],[0,0,0,"named",null,null,null,false],[207,296,0,null,null,null,[25674,25675],false],[207,302,0,null,null,null,[25659],false],[0,0,0,"self",null,"",null,false],[207,321,0,null,null,null,[25661,25662],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ch",null,"",null,false],[207,334,0,null,null,null,[25664],false],[0,0,0,"self",null,"",null,false],[207,343,0,null,null,null,[25666,25667],false],[0,0,0,"self",null,"",null,false],[0,0,0,"val",null,"",null,false],[207,353,0,null,null,null,[25669],false],[0,0,0,"self",null,"",null,false],[207,369,0,null,null,null,[25671,25672],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[207,296,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"pos",null,null,null,false],[207,374,0,null,null,null,null,false],[207,375,0,null,null,null,null,false],[207,377,0,null,null,null,[25684,25686,25687],false],[207,382,0,null,null,null,[25680],false],[0,0,0,"self",null,"",null,false],[207,386,0,null,null,null,[25682,25683],false],[0,0,0,"self",null,"",null,false],[0,0,0,"arg_index",null,"",null,false],[0,0,0,"next_arg",null,null,null,false],[207,377,0,null,null,null,null,false],[0,0,0,"used_args",null,null,null,false],[0,0,0,"args_len",null,null,null,false],[207,403,0,null,null,null,[25689,25690,25691],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,430,0,null,null,null,null,false],[207,432,0,null,null,null,[25694],false],[0,0,0,"T",null,"",null,true],[207,450,0,null,null,null,[25696],false],[0,0,0,"fmt",null,"",null,true],[207,457,0,null,null,null,[25698,25699],false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"value",null,"",null,false],[207,461,0,null,null,null,[25701,25702,25703,25704,25705],false],[0,0,0,"value",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"max_depth",null,"",null,false],[207,723,0,null,null,null,[25707,25708,25709,25710],false],[0,0,0,"value",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,738,0,null,null,null,[25712,25713,25714,25715],false],[0,0,0,"value",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,786,0,null,null,null,[25717,25718,25719,25720],false],[0,0,0,"value",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,815,0,null,null,null,[25722,25723],false],[0,0,0,"lower",null,null,null,false],[0,0,0,"upper",null,null,null,false],[207,817,0,null,null,null,[25725],false],[0,0,0,"case",null,"",[],true],[207,821,0,null,null,null,[25727,25728,25729,25730],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,840,0,null,null,null,null,false],[207,841,0,null,null,null,null,false],[207,845,0,null,null," Return a Formatter for a []const u8 where every byte is formatted as a pair\n of lowercase hexadecimal digits.",[25734],false],[0,0,0,"bytes",null,"",null,false],[207,851,0,null,null," Return a Formatter for a []const u8 where every byte is formatted as pair\n of uppercase hexadecimal digits.",[25736],false],[0,0,0,"bytes",null,"",null,false],[207,855,0,null,null,null,[25738],false],[0,0,0,"case",null,"",[],true],[207,859,0,null,null,null,[25740,25741,25742,25743],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,885,0,null,null,null,null,false],[207,886,0,null,null,null,null,false],[207,891,0,null,null," Return a Formatter for a []const u8 where every non-printable ASCII\n character is escaped as \\xNN, where NN is the character in lowercase\n hexadecimal notation.",[25747],false],[0,0,0,"bytes",null,"",null,false],[207,898,0,null,null," Return a Formatter for a []const u8 where every non-printable ASCII\n character is escaped as \\xNN, where NN is the character in uppercase\n hexadecimal notation.",[25749],false],[0,0,0,"bytes",null,"",null,false],[207,902,0,null,null,null,[25751],false],[0,0,0,"base",null,"",[],true],[207,904,0,null,null,null,[25753,25754,25755,25756],false],[0,0,0,"value",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,952,0,null,null,null,null,false],[207,953,0,null,null,null,null,false],[207,958,0,null,null," Return a Formatter for a u64 value representing a file size.\n This formatter represents the number as multiple of 1000 and uses the SI\n measurement units (kB, MB, GB, ...).",[25760],false],[0,0,0,"value",null,"",null,false],[207,965,0,null,null," Return a Formatter for a u64 value representing a file size.\n This formatter represents the number as multiple of 1024 and uses the IEC\n measurement units (KiB, MiB, GiB, ...).",[25762],false],[0,0,0,"value",null,"",null,false],[207,969,0,null,null,null,[25764],false],[0,0,0,"fmt",null,"",null,true],[207,981,0,null,null,null,[25766,25767,25768,25769],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,991,0,null,null,null,[25771,25772,25773],false],[0,0,0,"c",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,999,0,null,null,null,[25775,25776,25777],false],[0,0,0,"c",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1014,0,null,null,null,[25779,25780,25781],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1053,0,null,null," Print a float in scientific notation to the specified precision. Null uses full precision.\n It should be the case that every full precision, printed value can be re-parsed back to the\n same type unambiguously.",[25783,25784,25785],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1144,0,null,null,null,[25787,25788,25789],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1255,0,null,null," Print a float of the format x.yyyyy where the number of y is specified by the precision argument.\n By default floats are printed at full precision (no rounding).",[25791,25792,25793],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1394,0,null,null,null,[25795,25796,25797,25798,25799],false],[0,0,0,"value",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"case",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1462,0,null,null,null,[25801,25802,25803,25804,25805],false],[0,0,0,"out_buf",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"case",null,"",null,false],[0,0,0,"options",null,"",null,false],[207,1469,0,null,null,null,[25807],false],[0,0,0,"value",null,"",null,false],[207,1477,0,null,null,null,[25809,25810],false],[0,0,0,"ns",null,null,null,false],[0,0,0,"negative",null,null,null,false],[207,1482,0,null,null,null,[25812,25813,25814,25815],false],[0,0,0,"data",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1542,0,null,null," Return a Formatter for number of nanoseconds according to its magnitude:\n [#y][#w][#d][#h][#m]#[.###][n|u|m]s",[25817],false],[0,0,0,"ns",null,"",null,false],[207,1595,0,null,null,null,[25819,25820,25821,25822],false],[0,0,0,"ns",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1607,0,null,null," Return a Formatter for number of nanoseconds according to its signed magnitude:\n [#y][#w][#d][#h][#m]#[.###][n|u|m]s",[25824],false],[0,0,0,"ns",null,"",null,false],[207,1689,0,null,null,null,null,false],[207,1708,0,null,null," Creates a Formatter type from a format function. Wrapping data in Formatter(func) causes\n the data to be formatted using the given function `func`.  `func` must be of the following\n form:\n\n     fn formatExample(\n         data: T,\n         comptime fmt: []const u8,\n         options: std.fmt.FormatOptions,\n         writer: anytype,\n     ) !void;\n",[25827],false],[0,0,0,"format_fn",null,"",[25834],true],[207,1712,0,null,null,null,[25829,25830,25831,25832],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[207,1710,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[207,1734,0,null,null," Parses the string `buf` as signed or unsigned representation in the\n specified base of an integral value of type `T`.\n\n When `base` is zero the string prefix is examined to detect the true base:\n  * A prefix of \"0b\" implies base=2,\n  * A prefix of \"0o\" implies base=8,\n  * A prefix of \"0x\" implies base=16,\n  * Otherwise base=10 is assumed.\n\n Ignores '_' character in `buf`.\n See also `parseUnsigned`.",[25836,25837,25838],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[0,0,0,"base",null,"",null,false],[207,1796,0,null,null,null,[25840,25841,25842,25843],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"sign",null,"",[25844,25845],true],[0,0,0,"pos",null,null,null,false],[0,0,0,"neg",null,null,null,false],[207,1868,0,null,null," Parses the string `buf` as unsigned representation in the specified base\n of an integral value of type `T`.\n\n When `base` is zero the string prefix is examined to detect the true base:\n  * A prefix of \"0b\" implies base=2,\n  * A prefix of \"0o\" implies base=8,\n  * A prefix of \"0x\" implies base=16,\n  * Otherwise base=10 is assumed.\n\n Ignores '_' character in `buf`.\n See also `parseInt`.",[25847,25848,25849],false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[0,0,0,"base",null,"",null,false],[207,1909,0,null,null," Parses a number like '2G', '2Gi', or '2GiB'.",[25851,25852],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"digit_base",null,"",null,false],[207,1958,0,null,null,null,null,false],[0,0,0,"fmt/parse_float.zig",null,"",[],false],[211,0,0,null,null,null,null,false],[0,0,0,"parse_float/parse_float.zig",null,"",[],false],[212,0,0,null,null,null,null,false],[212,1,0,null,null,null,null,false],[0,0,0,"parse.zig",null,"",[],false],[213,0,0,null,null,null,null,false],[213,1,0,null,null,null,null,false],[0,0,0,"common.zig",null,"",[],false],[214,0,0,null,null,null,null,false],[214,5,0,null,null," A custom N-bit floating point type, representing `f * 2^e`.\n e is biased, so it be directly shifted into the exponent bits.\n Negative exponent indicates an invalid result.",[25865],false],[0,0,0,"T",null,"",[25880,25881],true],[214,9,0,null,null,null,null,false],[214,16,0,null,null,null,[],false],[214,20,0,null,null,null,[25869],false],[0,0,0,"e",null,"",null,false],[214,24,0,null,null,null,[25871],false],[0,0,0,"FloatT",null,"",null,true],[214,28,0,null,null,null,[25873,25874],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[214,32,0,null,null,null,[25876,25877,25878],false],[0,0,0,"self",null,"",null,false],[0,0,0,"FloatT",null,"",null,true],[0,0,0,"negative",null,"",null,false],[214,8,0,null,null,null,null,false],[0,0,0,"f",null," The significant digits.",null,false],[0,0,0,"e",null," The biased, binary exponent.",null,false],[214,42,0,null,null,null,[25883,25884,25885],false],[0,0,0,"T",null,"",null,true],[0,0,0,"MantissaT",null,"",null,true],[0,0,0,"v",null,"",null,false],[214,53,0,null,null," Represents a parsed floating point value as its components.",[25887],false],[0,0,0,"T",null,"",[25888,25890,25891,25892,25893],true],[0,0,0,"exponent",null,null,null,false],[214,54,0,null,null,null,null,false],[0,0,0,"mantissa",null,null,null,false],[0,0,0,"negative",null,null,null,false],[0,0,0,"many_digits",null," More than max_mantissa digits were found during parse",null,false],[0,0,0,"hex",null," The number was a hex-float (e.g. 0x1.234p567)",null,false],[214,67,0,null,null," Determine if 8 bytes are all decimal digits.\n This does not care about the order in which the bytes were loaded.",[25895],false],[0,0,0,"v",null,"",null,false],[214,73,0,null,null,null,[25897,25898],false],[0,0,0,"c",null,"",null,false],[0,0,0,"base",null,"",null,true],[214,84,0,null,null," Returns the underlying storage type used for the mantissa of floating-point type.\n The output unsigned type must have at least as many bits as the input floating-point type.",[25900],false],[0,0,0,"T",null,"",null,true],[213,2,0,null,null,null,null,false],[0,0,0,"FloatStream.zig",null," A wrapper over a byte-slice, providing useful methods for parsing string floating point values.\n",[25962,25963,25964],false],[215,2,0,null,null,null,null,false],[215,3,0,null,null,null,null,false],[215,4,0,null,null,null,null,false],[215,10,0,null,null,null,[25907],false],[0,0,0,"s",null,"",null,false],[215,15,0,null,null,null,[25909],false],[0,0,0,"self",null,"",null,false],[215,19,0,null,null,null,[25911],false],[0,0,0,"self",null,"",null,false],[215,24,0,null,null,null,[25913],false],[0,0,0,"self",null,"",null,false],[215,31,0,null,null,null,[25915,25916],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[215,35,0,null,null,null,[25918],false],[0,0,0,"self",null,"",null,false],[215,39,0,null,null,null,[25920],false],[0,0,0,"self",null,"",null,false],[215,46,0,null,null,null,[25922],false],[0,0,0,"self",null,"",null,false],[215,50,0,null,null,null,[25924,25925],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c",null,"",null,false],[215,57,0,null,null,null,[25927,25928],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c",null,"",null,false],[215,64,0,null,null,null,[25930,25931,25932],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c1",null,"",null,false],[0,0,0,"c2",null,"",null,false],[215,71,0,null,null,null,[25934,25935,25936,25937],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c1",null,"",null,false],[0,0,0,"c2",null,"",null,false],[0,0,0,"c3",null,"",null,false],[215,78,0,null,null,null,[25939,25940],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base",null,"",null,true],[215,87,0,null,null,null,[25942,25943],false],[0,0,0,"self",null,"",null,false],[0,0,0,"n",null,"",null,false],[215,91,0,null,null,null,[25945,25946],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c",null,"",null,false],[215,95,0,null,null,null,[25948,25949,25950],false],[0,0,0,"self",null,"",null,false],[0,0,0,"c1",null,"",null,false],[0,0,0,"c2",null,"",null,false],[215,99,0,null,null,null,[25952],false],[0,0,0,"self",null,"",null,false],[215,103,0,null,null,null,[25954],false],[0,0,0,"self",null,"",null,false],[215,110,0,null,null,null,[25956,25957],false],[0,0,0,"self",null,"",null,false],[0,0,0,"i",null,"",null,false],[215,114,0,null,null,null,[25959,25960],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base",null,"",null,true],[215,0,0,null,null,null,null,false],[0,0,0,"slice",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"underscore_count",null,null,null,false],[213,3,0,null,null,null,null,false],[213,4,0,null,null,null,null,false],[213,14,0,null,null," Parse 8 digits, loaded as bytes in little-endian order.\n\n This uses the trick where every digit is in [0x030, 0x39],\n and therefore can be parsed in 3 multiplications, much\n faster than the normal 8.\n\n This is based off the algorithm described in \"Fast numeric string to\n int\", available here: <https://johnnylee-sde.github.io/Fast-numeric-string-to-int/>.",[25968],false],[0,0,0,"v_",null,"",null,false],[213,27,0,null,null," Parse digits until a non-digit character is found.",[25970,25971,25972,25973],false],[0,0,0,"T",null,"",null,true],[0,0,0,"stream",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"base",null,"",null,true],[213,48,0,null,null,null,[25975,25976],false],[0,0,0,"T",null,"",null,true],[0,0,0,"digit_count",null,"",null,false],[213,56,0,null,null," Parse up to N digits",[25978,25979,25980,25981,25982],false],[0,0,0,"T",null,"",null,true],[0,0,0,"stream",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"base",null,"",null,true],[0,0,0,"n",null,"",null,true],[213,68,0,null,null," Parse the scientific notation component of a float.",[25984],false],[0,0,0,"stream",null,"",null,false],[213,92,0,null,null,null,[25986,25987,25988],false],[0,0,0,"base",null,null,null,false],[0,0,0,"max_mantissa_digits",null,null,null,false],[0,0,0,"exp_char_lower",null,null,null,false],[213,101,0,null,null,null,[25990,25991,25992,25993,25994],false],[0,0,0,"T",null,"",null,true],[0,0,0,"stream",null,"",null,false],[0,0,0,"negative",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"info",null,"",null,true],[213,212,0,null,null," Parse a partial, non-special floating point number.\n\n This creates a representation of the float as the\n significant digits and the decimal exponent.",[25996,25997,25998,25999],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[0,0,0,"negative",null,"",null,false],[0,0,0,"n",null,"",null,false],[213,233,0,null,null,null,[26001,26002,26003],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[0,0,0,"negative",null,"",null,false],[213,244,0,null,null,null,[26005,26006,26007,26008],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[0,0,0,"negative",null,"",null,false],[0,0,0,"n",null,"",null,false],[213,263,0,null,null,null,[26010,26011,26012],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[0,0,0,"negative",null,"",null,false],[213,273,0,null,null,null,[26014,26015],false],[0,0,0,"s",null,"",null,false],[0,0,0,"base",null,"",null,true],[212,2,0,null,null,null,null,false],[0,0,0,"convert_fast.zig",null," Representation of a float as the significant digits and exponent.\n The fast path algorithm using machine-sized integers and floats.\n\n This only works if both the mantissa and the exponent can be exactly\n represented as a machine float, since IEE-754 guarantees no rounding\n will occur.\n\n There is an exception: disguised fast-path cases, where we can shift\n powers-of-10 from the exponent to the significant digits.\n",[],false],[216,10,0,null,null,null,null,false],[216,11,0,null,null,null,null,false],[216,12,0,null,null,null,null,false],[216,13,0,null,null,null,null,false],[0,0,0,"FloatInfo.zig",null,"",[26027,26028,26029,26030,26031,26032,26033,26034,26035,26036,26037],false],[217,0,0,null,null,null,null,false],[217,1,0,null,null,null,null,false],[217,53,0,null,null,null,[26026],false],[0,0,0,"T",null,"",null,true],[0,0,0,"min_exponent_fast_path",null,null,null,false],[0,0,0,"max_exponent_fast_path",null,null,null,false],[0,0,0,"max_exponent_fast_path_disguised",null,null,null,false],[0,0,0,"max_mantissa_fast_path",null,null,null,false],[0,0,0,"smallest_power_of_ten",null,null,null,false],[0,0,0,"largest_power_of_ten",null,null,null,false],[0,0,0,"mantissa_explicit_bits",null,null,null,false],[0,0,0,"minimum_exponent",null,null,null,false],[0,0,0,"min_exponent_round_to_even",null,null,null,false],[0,0,0,"max_exponent_round_to_even",null,null,null,false],[0,0,0,"infinite_power",null,null,null,false],[216,14,0,null,null,null,null,false],[216,15,0,null,null,null,null,false],[216,17,0,null,null,null,[26041,26042],false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,false],[216,30,0,null,null,null,[26044,26045],false],[0,0,0,"T",null,"",null,true],[0,0,0,"i",null,"",null,false],[216,63,0,null,null,null,[26047,26048],false],[0,0,0,"T",null,"",null,true],[0,0,0,"i",null,"",null,false],[216,97,0,null,null,null,[26050,26051],false],[0,0,0,"T",null,"",null,true],[0,0,0,"n",null,"",null,false],[212,3,0,null,null,null,null,false],[0,0,0,"convert_eisel_lemire.zig",null,"",[],false],[218,0,0,null,null,null,null,false],[218,1,0,null,null,null,null,false],[218,2,0,null,null,null,null,false],[218,3,0,null,null,null,null,false],[218,4,0,null,null,null,null,false],[218,5,0,null,null,null,null,false],[218,25,0,null,null," Compute a float using an extended-precision representation.\n\n Fast conversion of a the significant digits and decimal exponent\n a float to an extended representation with a binary float. This\n algorithm will accurately parse the vast majority of cases,\n and uses a 128-bit representation (with a fallback 192-bit\n representation).\n\n This algorithm scales the exponent by the decimal exponent\n using pre-computed powers-of-5, and calculates if the\n representation can be unambiguously rounded to the nearest\n machine float. Near-halfway cases are not handled here,\n and are represented by a negative, biased binary exponent.\n\n The algorithm is described in detail in \"Daniel Lemire, Number Parsing\n at a Gigabyte per Second\" in section 5, \"Fast Algorithm\", and\n section 6, \"Exact Numbers And Ties\", available online:\n <https://arxiv.org/abs/2101.11408.pdf>.",[26061,26062,26063],false],[0,0,0,"T",null,"",null,true],[0,0,0,"q",null,"",null,false],[0,0,0,"w_",null,"",null,false],[218,126,0,null,null," Calculate a base 2 exponent from a decimal exponent.\n This uses a pre-computed integer approximation for\n log2(10), where 217706 / 2^16 is accurate for the\n entire range of non-finite decimal exponents.",[26065],false],[0,0,0,"q",null,"",null,false],[218,130,0,null,null,null,[26073,26074],false],[218,134,0,null,null,null,[26068,26069],false],[0,0,0,"lo",null,"",null,false],[0,0,0,"hi",null,"",null,false],[218,138,0,null,null,null,[26071,26072],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"lo",null,null,null,false],[0,0,0,"hi",null,null,null,false],[218,150,0,null,null,null,[26076,26077,26078],false],[0,0,0,"q",null,"",null,false],[0,0,0,"w",null,"",null,false],[0,0,0,"precision",null,"",null,true],[218,188,0,null,null,null,null,false],[218,189,0,null,null,null,null,false],[218,190,0,null,null,null,null,false],[212,4,0,null,null,null,null,false],[0,0,0,"convert_slow.zig",null,"",[],false],[219,0,0,null,null,null,null,false],[219,1,0,null,null,null,null,false],[219,2,0,null,null,null,null,false],[219,3,0,null,null,null,null,false],[219,4,0,null,null,null,null,false],[0,0,0,"decimal.zig",null,"",[],false],[220,0,0,null,null,null,null,false],[220,1,0,null,null,null,null,false],[220,2,0,null,null,null,null,false],[220,3,0,null,null,null,null,false],[220,4,0,null,null,null,null,false],[220,5,0,null,null,null,null,false],[220,24,0,null,null,null,[26097],false],[0,0,0,"T",null,"",[26124,26125,26126,26128],true],[220,29,0,null,null,null,null,false],[220,60,0,null,null," The maximum number of digits required to unambiguously round a float.\n\n For a double-precision IEEE-754 float, this required 767 digits,\n so we store the max digits + 1.\n\n We can exactly represent a float in base `b` from base 2 if\n `b` is divisible by 2. This function calculates the exact number of\n digits required to exactly represent that float.\n\n According to the \"Handbook of Floating Point Arithmetic\",\n for IEEE754, with emin being the min exponent, p2 being the\n precision, and b being the base, the number of digits follows as:\n\n `−emin + p2 + ⌊(emin + 1) log(2, b) − log(1 − 2^(−p2), b)⌋`\n\n For f32, this follows as:\n     emin = -126\n     p2 = 24\n\n For f64, this follows as:\n     emin = -1022\n     p2 = 53\n\n For f128, this follows as:\n     emin = -16383\n     p2 = 112\n\n In Python:\n     `-emin + p2 + math.floor((emin+ 1)*math.log(2, b)-math.log(1-2**(-p2), b))`",null,false],[220,62,0,null,null," The max digits that can be exactly represented in a 64-bit integer.",null,false],[220,63,0,null,null,null,null,false],[220,64,0,null,null,null,null,false],[220,65,0,null,null,null,null,false],[220,66,0,null,null,null,null,false],[220,77,0,null,null,null,[],false],[220,87,0,null,null," Append a digit to the buffer",[26107,26108],false],[0,0,0,"self",null,"",null,false],[0,0,0,"digit",null,"",null,false],[220,95,0,null,null," Trim trailing zeroes from the buffer",[26110],false],[0,0,0,"self",null,"",null,false],[220,109,0,null,null,null,[26112],false],[0,0,0,"self",null,"",null,false],[220,141,0,null,null," Computes decimal * 2^shift.",[26114,26115],false],[0,0,0,"self",null,"",null,false],[0,0,0,"shift",null,"",null,false],[220,185,0,null,null," Computes decimal * 2^-shift.",[26117,26118],false],[0,0,0,"self",null,"",null,false],[0,0,0,"shift",null,"",null,false],[220,239,0,null,null," Parse a bit integer representation of the float as a decimal.",[26120],false],[0,0,0,"s",null,"",null,false],[220,326,0,null,null,null,[26122,26123],false],[0,0,0,"self",null,"",null,false],[0,0,0,"shift",null,"",null,false],[0,0,0,"num_digits",null," The number of significant digits in the decimal.",null,false],[0,0,0,"decimal_point",null," The offset of the decimal point in the significant digits.",null,false],[0,0,0,"truncated",null," If the number of significant digits stored in the decimal is truncated.",null,false],[220,28,0,null,null,null,null,false],[0,0,0,"digits",null," buffer of the raw digits, in the range [0, 9].",null,false],[219,5,0,null,null,null,null,false],[219,7,0,null,null,null,null,false],[219,8,0,null,null,null,null,false],[219,9,0,null,null,null,null,false],[219,11,0,null,null,null,[26134],false],[0,0,0,"n",null,"",null,false],[219,37,0,null,null," Parse the significant digits and biased, binary exponent of a float.\n\n This is a fallback algorithm that uses a big-integer representation\n of the float, and therefore is considerably slower than faster\n approximations. However, it will always determine how to round\n the significant digits to the nearest machine float, allowing\n use to handle near half-way cases.\n\n Near half-way cases are halfway between two consecutive machine floats.\n For example, the float `16777217.0` has a bitwise representation of\n `100000000000000000000000 1`. Rounding to a single-precision float,\n the trailing `1` is truncated. Using round-nearest, tie-even, any\n value above `16777217.0` must be rounded up to `16777218.0`, while\n any value before or equal to `16777217.0` must be rounded down\n to `16777216.0`. These near-halfway conversions therefore may require\n a large number of digits to unambiguously determine how to round.\n\n The algorithms described here are based on \"Processing Long Numbers Quickly\",\n available here: <https://arxiv.org/pdf/2101.11408.pdf#section.11>.\n\n Note that this function needs a lot of stack space and is marked\n cold to hint against inlining into the caller.",[26136,26137],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[212,5,0,null,null,null,null,false],[0,0,0,"convert_hex.zig",null," Conversion of hex-float representation into an accurate value.\n",[],false],[221,4,0,null,null,null,null,false],[221,5,0,null,null,null,null,false],[221,6,0,null,null,null,null,false],[221,7,0,null,null,null,null,false],[221,8,0,null,null,null,null,false],[221,16,0,null,null,null,[26146,26147],false],[0,0,0,"T",null,"",null,true],[0,0,0,"n_",null,"",null,false],[212,7,0,null,null,null,null,false],[212,9,0,null,null,null,null,false],[212,13,0,null,null,null,[26151,26152],false],[0,0,0,"T",null,"",null,true],[0,0,0,"s",null,"",null,false],[211,1,0,null,null,null,null,false],[211,3,0,null,null,null,null,false],[211,4,0,null,null,null,null,false],[211,5,0,null,null,null,null,false],[211,6,0,null,null,null,null,false],[211,7,0,null,null,null,null,false],[211,8,0,null,null,null,null,false],[211,9,0,null,null,null,null,false],[211,10,0,null,null,null,null,false],[211,11,0,null,null,null,null,false],[207,1959,0,null,null,null,null,false],[207,1965,0,null,null,null,[26165,26166],false],[0,0,0,"c",null,"",null,false],[0,0,0,"base",null,"",null,false],[207,1978,0,null,null,null,[26168,26169],false],[0,0,0,"digit",null,"",null,false],[0,0,0,"case",null,"",null,false],[207,1986,0,null,null,null,null,false],[207,1993,0,null,null," print a Formatter string into `buf`. Actually just a thin wrapper around `format` and `fixedBufferStream`.\n returns a slice of the bytes printed to.",[26172,26173,26174],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,1999,0,null,null,null,[26176,26177,26178],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,2005,0,null,null," Count the characters needed for format. Useful for preallocating memory",[26180,26181],false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,2011,0,null,null,null,null,false],[207,2013,0,null,null,null,[26184,26185,26186],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,2021,0,null,null,null,[26188,26189,26190],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,2047,0,null,null,null,[26192,26193,26194,26195,26196],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"case",null,"",null,false],[0,0,0,"options",null,"",null,false],[207,2051,0,null,null,null,[26198,26199],false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[207,2599,0,null,null," Encodes a sequence of bytes as hexadecimal digits.\n Returns an array containing the encoded bytes.",[26201,26202],false],[0,0,0,"input",null,"",null,false],[0,0,0,"case",null,"",null,false],[207,2615,0,null,null," Decodes the sequence of bytes represented by the specified string of\n hexadecimal characters.\n Returns a slice of the output buffer containing the decoded bytes.",[26204,26205],false],[0,0,0,"out",null,"",null,false],[0,0,0,"input",null,"",null,false],[1,106,0,null,null," File system-related functionality.",null,false],[0,0,0,"fs.zig",null,"",[],false],[222,0,0,null,null,null,null,false],[222,1,0,null,null,null,null,false],[222,2,0,null,null,null,null,false],[222,3,0,null,null,null,null,false],[222,4,0,null,null,null,null,false],[222,5,0,null,null,null,null,false],[222,6,0,null,null,null,null,false],[222,7,0,null,null,null,null,false],[222,8,0,null,null,null,null,false],[222,9,0,null,null,null,null,false],[222,11,0,null,null,null,null,false],[222,13,0,null,null,null,null,false],[222,18,0,null,null,null,null,false],[0,0,0,"fs/path.zig",null,"",[],false],[223,0,0,null,null,null,null,false],[223,1,0,null,null,null,null,false],[223,2,0,null,null,null,null,false],[223,3,0,null,null,null,null,false],[223,4,0,null,null,null,null,false],[223,5,0,null,null,null,null,false],[223,6,0,null,null,null,null,false],[223,7,0,null,null,null,null,false],[223,8,0,null,null,null,null,false],[223,9,0,null,null,null,null,false],[223,10,0,null,null,null,null,false],[223,11,0,null,null,null,null,false],[223,12,0,null,null,null,null,false],[223,13,0,null,null,null,null,false],[223,14,0,null,null,null,null,false],[223,16,0,null,null,null,null,false],[223,17,0,null,null,null,null,false],[223,18,0,null,null,null,null,false],[223,23,0,null,null,null,null,false],[223,24,0,null,null,null,null,false],[223,25,0,null,null,null,null,false],[223,30,0,null,null,null,null,false],[223,31,0,null,null,null,null,false],[223,32,0,null,null,null,null,false],[223,35,0,null,null," Returns if the given byte is a valid path separator",[26247],false],[0,0,0,"byte",null,"",null,false],[223,43,0,null,null,null,[26253,26254,26255],false],[223,49,0,null,null," Returns true if `c` is a valid path separator for the `path_type`.",[26250,26251,26252],false],[0,0,0,"path_type",null,"",null,true],[0,0,0,"T",null,"",null,true],[0,0,0,"c",null,"",null,false],[0,0,0,"windows",null,null,null,false],[0,0,0,"uefi",null,null,null,false],[0,0,0,"posix",null,null,null,false],[223,60,0,null,null," This is different from mem.join in that the separator will not be repeated if\n it is found at the end or beginning of a pair of consecutive paths.",[26257,26258,26259,26261,26262],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"separator",null,"",null,false],[0,0,0,"sepPredicate",null,"",[26260],true],[0,0,0,"",null,"",null,false],[0,0,0,"paths",null,"",null,false],[0,0,0,"zero",null,"",null,false],[223,124,0,null,null," Naively combines a series of paths with the native path separator.\n Allocates memory for the result, which must be freed by the caller.",[26264,26265],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[223,130,0,null,null," Naively combines a series of paths with the native path separator and null terminator.\n Allocates memory for the result, which must be freed by the caller.",[26267,26268],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[223,135,0,null,null,null,[26270,26271,26272],false],[0,0,0,"paths",null,"",null,false],[0,0,0,"expected",null,"",null,false],[0,0,0,"zero",null,"",null,false],[223,146,0,null,null,null,[26274,26275,26276],false],[0,0,0,"paths",null,"",null,false],[0,0,0,"expected",null,"",null,false],[0,0,0,"zero",null,"",null,false],[223,157,0,null,null,null,[26278,26279,26280],false],[0,0,0,"paths",null,"",null,false],[0,0,0,"expected",null,"",null,false],[0,0,0,"zero",null,"",null,false],[223,228,0,null,null,null,[26282],false],[0,0,0,"path_c",null,"",null,false],[223,236,0,null,null,null,[26284],false],[0,0,0,"path",null,"",null,false],[223,244,0,null,null,null,[26286,26287],false],[0,0,0,"T",null,"",null,true],[0,0,0,"path",null,"",null,false],[223,267,0,null,null,null,[26289],false],[0,0,0,"path",null,"",null,false],[223,271,0,null,null,null,[26291],false],[0,0,0,"path_w",null,"",null,false],[223,275,0,null,null,null,[26293],false],[0,0,0,"path",null,"",null,false],[223,279,0,null,null,null,[26295],false],[0,0,0,"path_c",null,"",null,false],[223,283,0,null,null,null,[26297],false],[0,0,0,"path",null,"",null,false],[223,287,0,null,null,null,[26299],false],[0,0,0,"path_c",null,"",null,false],[223,322,0,null,null,null,[26301,26302],false],[0,0,0,"path",null,"",null,false],[0,0,0,"expected_result",null,"",null,false],[223,326,0,null,null,null,[26304,26305],false],[0,0,0,"path",null,"",null,false],[0,0,0,"expected_result",null,"",null,false],[223,330,0,null,null,null,[26311,26313,26315],false],[223,335,0,null,null,null,[26308,26309,26310],false],[0,0,0,"None",null,null,null,false],[0,0,0,"Drive",null,null,null,false],[0,0,0,"NetworkShare",null,null,null,false],[0,0,0,"is_abs",null,null,null,false],[223,330,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[223,330,0,null,null,null,null,false],[0,0,0,"disk_designator",null,null,null,false],[223,342,0,null,null,null,[26317],false],[0,0,0,"path",null,"",null,false],[223,421,0,null,null,null,[26319],false],[0,0,0,"path",null,"",null,false],[223,429,0,null,null,null,[26321],false],[0,0,0,"path",null,"",null,false],[223,433,0,null,null,null,[26323,26324],false],[0,0,0,"ns1",null,"",null,false],[0,0,0,"ns2",null,"",null,false],[223,443,0,null,null,null,[26326,26327,26328],false],[0,0,0,"kind",null,"",null,false],[0,0,0,"p1",null,"",null,false],[0,0,0,"p2",null,"",null,false],[223,466,0,null,null," On Windows, this calls `resolveWindows` and on POSIX it calls `resolvePosix`.",[26330,26331],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[223,482,0,null,null," This function is like a series of `cd` statements executed one after another.\n It resolves \".\" and \"..\", but will not convert relative path to absolute path, use std.fs.Dir.realpath instead.\n The result does not have a trailing path separator.\n Each drive has its own current working directory.\n Path separators are canonicalized to '\\\\' and drives are canonicalized to capital letters.\n Note: all usage of this function should be audited due to the existence of symlinks.\n Without performing actual syscalls, resolving `..` could be incorrect.\n This API may break in the future: https://github.com/ziglang/zig/issues/13613",[26333,26334],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[223,657,0,null,null," This function is like a series of `cd` statements executed one after another.\n It resolves \".\" and \"..\", but will not convert relative path to absolute path, use std.fs.Dir.realpath instead.\n The result does not have a trailing path separator.\n This function does not perform any syscalls. Executing this series of path\n lookups on the actual filesystem may produce different results due to\n symlinks.",[26336,26337],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"paths",null,"",null,false],[223,784,0,null,null,null,[26339,26340],false],[0,0,0,"paths",null,"",null,false],[0,0,0,"expected",null,"",null,false],[223,790,0,null,null,null,[26342,26343],false],[0,0,0,"paths",null,"",null,false],[0,0,0,"expected",null,"",null,false],[223,802,0,null,null," Strip the last component from a file path.\n\n If the path is a file in the current directory (no directory component)\n then returns null.\n\n If the path is the root directory, returns null.",[26345],false],[0,0,0,"path",null,"",null,false],[223,810,0,null,null,null,[26347],false],[0,0,0,"path",null,"",null,false],[223,844,0,null,null,null,[26349],false],[0,0,0,"path",null,"",null,false],[223,920,0,null,null,null,[26351,26352],false],[0,0,0,"input",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,928,0,null,null,null,[26354,26355],false],[0,0,0,"input",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,936,0,null,null,null,[26357],false],[0,0,0,"path",null,"",null,false],[223,944,0,null,null,null,[26359],false],[0,0,0,"path",null,"",null,false],[223,965,0,null,null,null,[26361],false],[0,0,0,"path",null,"",null,false],[223,1036,0,null,null,null,[26363,26364],false],[0,0,0,"input",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,1040,0,null,null,null,[26366,26367],false],[0,0,0,"input",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,1044,0,null,null,null,[26369,26370],false],[0,0,0,"input",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,1052,0,null,null," Returns the relative path from `from` to `to`. If `from` and `to` each\n resolve to the same path (after calling `resolve` on each), a zero-length\n string is returned.\n On Windows this canonicalizes the drive to a capital letter and paths to `\\\\`.",[26372,26373,26374],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[223,1060,0,null,null,null,[26376,26377,26378],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[223,1130,0,null,null,null,[26380,26381,26382],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[223,1220,0,null,null,null,[26384,26385,26386],false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,1226,0,null,null,null,[26388,26389,26390],false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[0,0,0,"expected_output",null,"",null,false],[223,1246,0,null,null," Searches for a file extension separated by a `.` and returns the string after that `.`.\n Files that end or start with `.` and have no other `.` in their name\n are considered to have no extension, in which case this returns \"\".\n Examples:\n - `\"main.zig\"`      ⇒ `\".zig\"`\n - `\"src/main.zig\"`  ⇒ `\".zig\"`\n - `\".gitignore\"`    ⇒ `\"\"`\n - `\".image.png\"`    ⇒ `\".png\"`\n - `\"keep.\"`         ⇒ `\".\"`\n - `\"src.keep.me\"`   ⇒ `\".me\"`\n - `\"/src/keep.me\"`  ⇒ `\".me\"`\n - `\"/src/keep.me/\"` ⇒ `\".me\"`\n The returned slice is guaranteed to have its pointer within the start and end\n pointer address range of `path`, even if it is length zero.",[26392],false],[0,0,0,"path",null,"",null,false],[223,1253,0,null,null,null,[26394,26395],false],[0,0,0,"path",null,"",null,false],[0,0,0,"expected",null,"",null,false],[223,1303,0,null,null," Returns the last component of this path without its extension (if any):\n - \"hello/world/lib.tar.gz\" ⇒ \"lib.tar\"\n - \"hello/world/lib.tar\"    ⇒ \"lib\"\n - \"hello/world/lib\"        ⇒ \"lib\"",[26397],false],[0,0,0,"path",null,"",null,false],[223,1310,0,null,null,null,[26399,26400],false],[0,0,0,"path",null,"",null,false],[0,0,0,"expected",null,"",null,false],[223,1344,0,null,null," A path component iterator that can move forwards and backwards.\n The 'root' of the path (`/` for POSIX, things like `C:\\`, `\\\\server\\share\\`, etc\n for Windows) is treated specially and will never be returned by any of the\n `first`, `last`, `next`, or `previous` functions.\n Multiple consecutive path separators are skipped (treated as a single separator)\n when iterating.\n All returned component names/paths are slices of the original path.\n There is no normalization of paths performed while iterating.",[26402,26403],false],[0,0,0,"path_type",null,"",null,true],[0,0,0,"T",null,"",[26424,26425,26426,26427],true],[223,1351,0,null,null,null,null,false],[223,1353,0,null,null,null,[26407,26409],false],[223,1353,0,null,null,null,null,false],[0,0,0,"name",null," The current component's path name, e.g. 'b'.\n This will never contain path separators.",null,false],[223,1353,0,null,null,null,null,false],[0,0,0,"path",null," The full path up to and including the current component, e.g. '/a/b'\n This will never contain trailing path separators.",null,false],[223,1362,0,null,null,null,null,false],[223,1374,0,null,null," After `init`, `next` will return the first component after the root\n (there is no need to call `first` after `init`).\n To iterate backwards (from the end of the path to the beginning), call `last`\n after `init` and then iterate via `previous` calls.\n For Windows paths, `error.BadPathName` is returned if the `path` has an explicit\n namespace prefix (`\\\\.\\`, `\\\\?\\`, or `\\??\\`) or if it is a UNC path with more\n than two path separators at the beginning.",[26412],false],[0,0,0,"path",null,"",null,false],[223,1453,0,null,null," Returns the root of the path if it is an absolute path, or null otherwise.\n For POSIX paths, this will be `/`.\n For Windows paths, this will be something like `C:\\`, `\\\\server\\share\\`, etc.\n For UEFI paths, this will be `\\`.",[26414],false],[0,0,0,"self",null,"",null,false],[223,1462,0,null,null," Returns the first component (from the beginning of the path).\n For example, if the path is `/a/b/c` then this will return the `a` component.\n After calling `first`, `previous` will always return `null`, and `next` will return\n the component to the right of the one returned by `first`, if any exist.",[26416],false],[0,0,0,"self",null,"",null,false],[223,1479,0,null,null," Returns the last component (from the end of the path).\n For example, if the path is `/a/b/c` then this will return the `c` component.\n After calling `last`, `next` will always return `null`, and `previous` will return\n the component to the left of the one returned by `last`, if any exist.",[26418],false],[0,0,0,"self",null,"",null,false],[223,1506,0,null,null," Returns the next component (the component to the right of the most recently\n returned component), or null if no such component exists.\n For example, if the path is `/a/b/c` and the most recently returned component\n is `b`, then this will return the `c` component.",[26420],false],[0,0,0,"self",null,"",null,false],[223,1528,0,null,null," Returns the previous component (the component to the left of the most recently\n returned component), or null if no such component exists.\n For example, if the path is `/a/b/c` and the most recently returned component\n is `b`, then this will return the `a` component.",[26422],false],[0,0,0,"self",null,"",null,false],[223,1345,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[0,0,0,"root_end_index",null,null,null,false],[0,0,0,"start_index",null,null,null,false],[0,0,0,"end_index",null,null,null,false],[223,1552,0,null,null,null,null,false],[223,1558,0,null,null,null,[26430],false],[0,0,0,"path",null,"",null,false],[222,19,0,null,null,null,null,false],[0,0,0,"fs/file.zig",null,"",[],false],[224,0,0,null,null,null,null,false],[224,1,0,null,null,null,null,false],[224,2,0,null,null,null,null,false],[224,3,0,null,null,null,null,false],[224,4,0,null,null,null,null,false],[224,5,0,null,null,null,null,false],[224,6,0,null,null,null,null,false],[224,7,0,null,null,null,null,false],[224,8,0,null,null,null,null,false],[224,9,0,null,null,null,null,false],[224,10,0,null,null,null,null,false],[224,12,0,null,null,null,[26812,26814,26816],false],[224,30,0,null,null,null,null,false],[224,31,0,null,null,null,null,false],[224,32,0,null,null,null,null,false],[224,33,0,null,null,null,null,false],[224,34,0,null,null,null,null,false],[224,36,0,null,null,null,[26451,26452,26453,26454,26455,26456,26457,26458,26459,26460,26461],false],[0,0,0,"block_device",null,null,null,false],[0,0,0,"character_device",null,null,null,false],[0,0,0,"directory",null,null,null,false],[0,0,0,"named_pipe",null,null,null,false],[0,0,0,"sym_link",null,null,null,false],[0,0,0,"file",null,null,null,false],[0,0,0,"unix_domain_socket",null,null,null,false],[0,0,0,"whiteout",null,null,null,false],[0,0,0,"door",null,null,null,false],[0,0,0,"event_port",null,null,null,false],[0,0,0,"unknown",null,null,null,false],[224,56,0,null,null," This is the default mode given to POSIX operating systems for creating\n files. `0o666` is \"-rw-rw-rw-\" which is counter-intuitive at first,\n since most people would expect \"-rw-r--r--\", for example, when using\n the `touch` command, which would correspond to `0o644`. However, POSIX\n libc implementations use `0o666` inside `fopen` and then rely on the\n process-scoped \"umask\" setting to adjust this number for file creation.",null,false],[224,62,0,null,null,null,null,false],[224,79,0,null,null,null,[26465,26466,26467],false],[0,0,0,"read_only",null,null,null,false],[0,0,0,"write_only",null,null,null,false],[0,0,0,"read_write",null,null,null,false],[224,85,0,null,null,null,[26469,26470,26471],false],[0,0,0,"none",null,null,null,false],[0,0,0,"shared",null,null,null,false],[0,0,0,"exclusive",null,null,null,false],[224,91,0,null,null,null,[26478,26480,26481,26483,26484],false],[224,137,0,null,null,null,[26474],false],[0,0,0,"self",null,"",null,false],[224,141,0,null,null,null,[26476],false],[0,0,0,"self",null,"",null,false],[224,91,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[224,91,0,null,null,null,null,false],[0,0,0,"lock",null," Open the file with an advisory lock to coordinate with other processes\n accessing it at the same time. An exclusive lock will prevent other\n processes from acquiring a lock. A shared lock will prevent other\n processes from acquiring a exclusive lock, but does not prevent\n other process from getting their own shared locks.\n\n The lock is advisory, except on Linux in very specific circumstances[1].\n This means that a process that does not respect the locking API can still get access\n to the file, despite the lock.\n\n On these operating systems, the lock is acquired atomically with\n opening the file:\n * Darwin\n * DragonFlyBSD\n * FreeBSD\n * Haiku\n * NetBSD\n * OpenBSD\n On these operating systems, the lock is acquired via a separate syscall\n after opening the file:\n * Linux\n * Windows\n\n [1]: https://www.kernel.org/doc/Documentation/filesystems/mandatory-locking.txt",null,false],[0,0,0,"lock_nonblocking",null," Sets whether or not to wait until the file is locked to return. If set to true,\n `error.WouldBlock` will be returned. Otherwise, the file will wait until the file\n is available to proceed.\n In async I/O mode, non-blocking at the OS level is\n determined by `intended_io_mode`, and `true` means `error.WouldBlock` is returned,\n and `false` means `error.WouldBlock` is handled by the event loop.",null,false],[224,91,0,null,null,null,null,false],[0,0,0,"intended_io_mode",null," Setting this to `.blocking` prevents `O.NONBLOCK` from being passed even\n if `std.io.is_async`. It allows the use of `nosuspend` when calling functions\n related to opening the file, reading, writing, and locking.",null,false],[0,0,0,"allow_ctty",null," Set this to allow the opened file to automatically become the\n controlling TTY for the current process.",null,false],[224,146,0,null,null,null,[26486,26487,26488,26490,26491,26493,26495],false],[0,0,0,"read",null," Whether the file will be created with read access.",null,false],[0,0,0,"truncate",null," If the file already exists, and is a regular file, and the access\n mode allows writing, it will be truncated to length 0.",null,false],[0,0,0,"exclusive",null," Ensures that this open call creates the file, otherwise causes\n `error.PathAlreadyExists` to be returned.",null,false],[224,146,0,null,null,null,null,false],[0,0,0,"lock",null," Open the file with an advisory lock to coordinate with other processes\n accessing it at the same time. An exclusive lock will prevent other\n processes from acquiring a lock. A shared lock will prevent other\n processes from acquiring a exclusive lock, but does not prevent\n other process from getting their own shared locks.\n\n The lock is advisory, except on Linux in very specific circumstances[1].\n This means that a process that does not respect the locking API can still get access\n to the file, despite the lock.\n\n On these operating systems, the lock is acquired atomically with\n opening the file:\n * Darwin\n * DragonFlyBSD\n * FreeBSD\n * Haiku\n * NetBSD\n * OpenBSD\n On these operating systems, the lock is acquired via a separate syscall\n after opening the file:\n * Linux\n * Windows\n\n [1]: https://www.kernel.org/doc/Documentation/filesystems/mandatory-locking.txt",null,false],[0,0,0,"lock_nonblocking",null," Sets whether or not to wait until the file is locked to return. If set to true,\n `error.WouldBlock` will be returned. Otherwise, the file will wait until the file\n is available to proceed.\n In async I/O mode, non-blocking at the OS level is\n determined by `intended_io_mode`, and `true` means `error.WouldBlock` is returned,\n and `false` means `error.WouldBlock` is handled by the event loop.",null,false],[224,146,0,null,null,null,null,false],[0,0,0,"mode",null," For POSIX systems this is the file system mode the file will\n be created with. On other systems this is always 0.",null,false],[224,146,0,null,null,null,null,false],[0,0,0,"intended_io_mode",null," Setting this to `.blocking` prevents `O.NONBLOCK` from being passed even\n if `std.io.is_async`. It allows the use of `nosuspend` when calling functions\n related to opening the file, reading, writing, and locking.",null,false],[224,204,0,null,null," Upon success, the stream is in an uninitialized state. To continue using it,\n you must use the open() function.",[26497],false],[0,0,0,"self",null,"",null,false],[224,214,0,null,null,null,null,false],[224,221,0,null,null," Blocks until all pending file contents and metadata modifications\n for the file have been synchronized with the underlying filesystem.\n\n Note that this does not ensure that metadata for the\n directory containing the file has also reached disk.",[26500],false],[0,0,0,"self",null,"",null,false],[224,227,0,null,null," Test whether the file refers to a terminal.\n See also `supportsAnsiEscapeCodes`.",[26502],false],[0,0,0,"self",null,"",null,false],[224,232,0,null,null," Test whether ANSI escape codes will be treated as such.",[26504],false],[0,0,0,"self",null,"",null,false],[224,259,0,null,null,null,null,false],[224,263,0,null,null," Shrinks or expands the file.\n The file offset after this call is left unchanged.",[26507,26508],false],[0,0,0,"self",null,"",null,false],[0,0,0,"length",null,"",null,false],[224,267,0,null,null,null,null,false],[224,271,0,null,null," Repositions read/write file offset relative to the current offset.\n TODO: integrate with async I/O",[26511,26512],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,277,0,null,null," Repositions read/write file offset relative to the end.\n TODO: integrate with async I/O",[26514,26515],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,283,0,null,null," Repositions read/write file offset relative to the beginning.\n TODO: integrate with async I/O",[26517,26518],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,287,0,null,null,null,null,false],[224,290,0,null,null," TODO: integrate with async I/O",[26521],false],[0,0,0,"self",null,"",null,false],[224,295,0,null,null," TODO: integrate with async I/O",[26523],false],[0,0,0,"self",null,"",null,false],[224,302,0,null,null,null,null,false],[224,305,0,null,null," TODO: integrate with async I/O",[26526],false],[0,0,0,"self",null,"",null,false],[224,312,0,null,null,null,[26531,26532,26534,26536,26537,26538,26539],false],[224,337,0,null,null,null,[26529],false],[0,0,0,"st",null,"",null,false],[224,312,0,null,null,null,null,false],[0,0,0,"inode",null," A number that the system uses to point to the file metadata. This\n number is not guaranteed to be unique across time, as some file\n systems may reuse an inode after its file has been deleted. Some\n systems may change the inode of a file over time.\n\n On Linux, the inode is a structure that stores the metadata, and\n the inode _number_ is what you see here: the index number of the\n inode.\n\n The FileIndex on Windows is similar. It is a number for a file that\n is unique to each filesystem.",null,false],[0,0,0,"size",null,null,null,false],[224,312,0,null,null,null,null,false],[0,0,0,"mode",null," This is available on POSIX systems and is always 0 otherwise.",null,false],[224,312,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[0,0,0,"atime",null," Access time in nanoseconds, relative to UTC 1970-01-01.",null,false],[0,0,0,"mtime",null," Last modification time in nanoseconds, relative to UTC 1970-01-01.",null,false],[0,0,0,"ctime",null," Creation time in nanoseconds, relative to UTC 1970-01-01.",null,false],[224,382,0,null,null,null,null,false],[224,385,0,null,null," TODO: integrate with async I/O",[26542],false],[0,0,0,"self",null,"",null,false],[224,415,0,null,null,null,null,false],[224,421,0,null,null," Changes the mode of the file.\n The process must have the correct privileges in order to do this\n successfully, or must have the effective user ID matching the owner\n of the file.",[26545,26546],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_mode",null,"",null,false],[224,425,0,null,null,null,null,false],[224,432,0,null,null," Changes the owner and group of the file.\n The process must have the correct privileges in order to do this\n successfully. The group may be changed by the owner of the file to\n any group of which the owner is a member. If the owner or group is\n specified as `null`, the ID is not changed.",[26549,26550,26551],false],[0,0,0,"self",null,"",null,false],[0,0,0,"owner",null,"",null,false],[0,0,0,"group",null,"",null,false],[224,439,0,null,null," Cross-platform representation of permissions on a file.\n The `readonly` and `setReadonly` are the only methods available across all platforms.\n Platform-specific functionality is available through the `inner` field.",[26560],false],[224,446,0,null,null,null,null,false],[224,450,0,null,null," Returns `true` if permissions represent an unwritable file.\n On Unix, `true` is returned only if no class has write permissions.",[26555],false],[0,0,0,"self",null,"",null,false],[224,457,0,null,null," Sets whether write permissions are provided.\n On Unix, this affects *all* classes. If this is undesired, use `unixSet`\n This method *DOES NOT* set permissions on the filesystem: use `File.setPermissions(permissions)`",[26557,26558],false],[0,0,0,"self",null,"",null,false],[0,0,0,"read_only",null,"",null,false],[224,439,0,null,null,null,null,false],[0,0,0,"inner",null," You may use the `inner` field to use platform-specific functionality",null,false],[224,462,0,null,null,null,[26569],false],[224,465,0,null,null,null,null,false],[224,468,0,null,null," Returns `true` if permissions represent an unwritable file.",[26564],false],[0,0,0,"self",null,"",null,false],[224,474,0,null,null," Sets whether write permissions are provided.\n This method *DOES NOT* set permissions on the filesystem: use `File.setPermissions(permissions)`",[26566,26567],false],[0,0,0,"self",null,"",null,false],[0,0,0,"read_only",null,"",null,false],[224,462,0,null,null,null,null,false],[0,0,0,"attributes",null,null,null,false],[224,483,0,null,null,null,[26602],false],[224,486,0,null,null,null,null,false],[224,490,0,null,null," Returns `true` if permissions represent an unwritable file.\n `true` is returned only if no class has write permissions.",[26573],false],[0,0,0,"self",null,"",null,false],[224,497,0,null,null," Sets whether write permissions are provided.\n This affects *all* classes. If this is undesired, use `unixSet`\n This method *DOES NOT* set permissions on the filesystem: use `File.setPermissions(permissions)`",[26575,26576],false],[0,0,0,"self",null,"",null,false],[0,0,0,"read_only",null,"",null,false],[224,505,0,null,null,null,[26578,26579,26580],false],[0,0,0,"user",null,null,null,false],[0,0,0,"group",null,null,null,false],[0,0,0,"other",null,null,null,false],[224,511,0,null,null,null,[26582,26583,26584],false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"execute",null,null,null,false],[224,519,0,null,null," Returns `true` if the chosen class has the selected permission.\n This method is only available on Unix platforms.",[26586,26587,26588],false],[0,0,0,"self",null,"",null,false],[0,0,0,"class",null,"",null,false],[0,0,0,"permission",null,"",null,false],[224,526,0,null,null," Sets the permissions for the chosen class. Any permissions set to `null` are left unchanged.\n This method *DOES NOT* set permissions on the filesystem: use `File.setPermissions(permissions)`",[26590,26591,26592],false],[0,0,0,"self",null,"",null,false],[0,0,0,"class",null,"",null,false],[0,0,0,"permissions",null,"",[26594,26596,26598],false],[224,526,0,null,null,null,null,false],[0,0,0,"read",null,null,null,false],[224,526,0,null,null,null,null,false],[0,0,0,"write",null,null,null,false],[224,526,0,null,null,null,null,false],[0,0,0,"execute",null,null,null,false],[224,556,0,null,null," Returns a `Permissions` struct representing the permissions from the passed mode.",[26600],false],[0,0,0,"new_mode",null,"",null,false],[224,483,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[224,563,0,null,null,null,null,false],[224,567,0,null,null," Sets permissions according to the provided `Permissions` struct.\n This method is *NOT* available on WASI",[26605,26606],false],[0,0,0,"self",null,"",null,false],[0,0,0,"permissions",null,"",null,false],[224,601,0,null,null," Cross-platform representation of file metadata.\n Platform-specific functionality is available through the `inner` field.",[26622],false],[224,609,0,null,null,null,null,false],[224,612,0,null,null," Returns the size of the file",[26610],false],[0,0,0,"self",null,"",null,false],[224,617,0,null,null," Returns a `Permissions` struct, representing the permissions on the file",[26612],false],[0,0,0,"self",null,"",null,false],[224,623,0,null,null," Returns the `Kind` of file.\n On Windows, can only return: `.file`, `.directory`, `.sym_link` or `.unknown`",[26614],false],[0,0,0,"self",null,"",null,false],[224,628,0,null,null," Returns the last time the file was accessed in nanoseconds since UTC 1970-01-01",[26616],false],[0,0,0,"self",null,"",null,false],[224,633,0,null,null," Returns the time the file was modified in nanoseconds since UTC 1970-01-01",[26618],false],[0,0,0,"self",null,"",null,false],[224,642,0,null,null," Returns the time the file was created in nanoseconds since UTC 1970-01-01\n On Windows, this cannot return null\n On Linux, this returns null if the filesystem does not support creation times, or if the kernel is older than 4.11\n On Unices, this returns null if the filesystem or OS does not support creation times\n On MacOS, this returns the ctime if the filesystem does not support creation times; this is insanity, and yet another reason to hate on Apple",[26620],false],[0,0,0,"self",null,"",null,false],[224,601,0,null,null,null,null,false],[0,0,0,"inner",null," You may use the `inner` field to use platform-specific functionality",null,false],[224,647,0,null,null,null,[26638],false],[224,650,0,null,null,null,null,false],[224,653,0,null,null," Returns the size of the file",[26626],false],[0,0,0,"self",null,"",null,false],[224,658,0,null,null," Returns a `Permissions` struct, representing the permissions on the file",[26628],false],[0,0,0,"self",null,"",null,false],[224,663,0,null,null," Returns the `Kind` of the file",[26630],false],[0,0,0,"self",null,"",null,false],[224,697,0,null,null," Returns the last time the file was accessed in nanoseconds since UTC 1970-01-01",[26632],false],[0,0,0,"self",null,"",null,false],[224,703,0,null,null," Returns the last time the file was modified in nanoseconds since UTC 1970-01-01",[26634],false],[0,0,0,"self",null,"",null,false],[224,710,0,null,null," Returns the time the file was created in nanoseconds since UTC 1970-01-01\n Returns null if this is not supported by the OS or filesystem",[26636],false],[0,0,0,"self",null,"",null,false],[224,647,0,null,null,null,null,false],[0,0,0,"stat",null,null,null,false],[224,731,0,null,null," `MetadataUnix`, but using Linux's `statx` syscall.\n On Linux versions below 4.11, `statx` will be filled with data from stat.",[26654],false],[224,734,0,null,null,null,null,false],[224,737,0,null,null," Returns the size of the file",[26642],false],[0,0,0,"self",null,"",null,false],[224,742,0,null,null," Returns a `Permissions` struct, representing the permissions on the file",[26644],false],[0,0,0,"self",null,"",null,false],[224,747,0,null,null," Returns the `Kind` of the file",[26646],false],[0,0,0,"self",null,"",null,false],[224,765,0,null,null," Returns the last time the file was accessed in nanoseconds since UTC 1970-01-01",[26648],false],[0,0,0,"self",null,"",null,false],[224,770,0,null,null," Returns the last time the file was modified in nanoseconds since UTC 1970-01-01",[26650],false],[0,0,0,"self",null,"",null,false],[224,776,0,null,null," Returns the time the file was created in nanoseconds since UTC 1970-01-01\n Returns null if this is not supported by the filesystem, or on kernels before than version 4.11",[26652],false],[0,0,0,"self",null,"",null,false],[224,731,0,null,null,null,null,false],[0,0,0,"statx",null,null,null,false],[224,782,0,null,null,null,[26670,26672,26673,26674,26675,26676],false],[224,790,0,null,null,null,null,false],[224,793,0,null,null," Returns the size of the file",[26658],false],[0,0,0,"self",null,"",null,false],[224,798,0,null,null," Returns a `Permissions` struct, representing the permissions on the file",[26660],false],[0,0,0,"self",null,"",null,false],[224,804,0,null,null," Returns the `Kind` of the file.\n Can only return: `.file`, `.directory`, `.sym_link` or `.unknown`",[26662],false],[0,0,0,"self",null,"",null,false],[224,818,0,null,null," Returns the last time the file was accessed in nanoseconds since UTC 1970-01-01",[26664],false],[0,0,0,"self",null,"",null,false],[224,823,0,null,null," Returns the time the file was modified in nanoseconds since UTC 1970-01-01",[26666],false],[0,0,0,"self",null,"",null,false],[224,829,0,null,null," Returns the time the file was created in nanoseconds since UTC 1970-01-01\n This never returns null, only returning an optional for compatibility with other OSes",[26668],false],[0,0,0,"self",null,"",null,false],[224,782,0,null,null,null,null,false],[0,0,0,"attributes",null,null,null,false],[224,782,0,null,null,null,null,false],[0,0,0,"reparse_tag",null,null,null,false],[0,0,0,"_size",null,null,null,false],[0,0,0,"access_time",null,null,null,false],[0,0,0,"modified_time",null,null,null,false],[0,0,0,"creation_time",null,null,null,false],[224,834,0,null,null,null,null,false],[224,836,0,null,null,null,[26679],false],[0,0,0,"self",null,"",null,false],[224,918,0,null,null,null,null,false],[224,925,0,null,null," The underlying file system may have a different granularity than nanoseconds,\n and therefore this function cannot guarantee any precision will be stored.\n Further, the maximum value is limited by the system ABI. When a value is provided\n that exceeds this range, the value is clamped to the maximum.\n TODO: integrate with async I/O",[26682,26683,26684],false],[0,0,0,"self",null,"",null,false],[0,0,0,"atime",null," access timestamp in nanoseconds",null,false],[0,0,0,"mtime",null," last modification timestamp in nanoseconds",null,false],[224,953,0,null,null," Reads all the bytes from the current position to the end of the file.\n On success, caller owns returned buffer.\n If the file is larger than `max_bytes`, returns `error.FileTooBig`.",[26686,26687,26688],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"max_bytes",null,"",null,false],[224,963,0,null,null," Reads all the bytes from the current position to the end of the file.\n On success, caller owns returned buffer.\n If the file is larger than `max_bytes`, returns `error.FileTooBig`.\n If `size_hint` is specified the initial buffer size is calculated using\n that value, otherwise an arbitrary value is used instead.\n Allows specifying alignment and a sentinel value.",[26690,26691,26692,26693,26694,26695],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"max_bytes",null,"",null,false],[0,0,0,"size_hint",null,"",null,false],[0,0,0,"alignment",null,"",null,true],[0,0,0,"optional_sentinel",null,"",null,true],[224,993,0,null,null,null,null,false],[224,994,0,null,null,null,null,false],[224,996,0,null,null,null,[26699,26700],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[224,1010,0,null,null," Returns the number of bytes read. If the number read is smaller than `buffer.len`, it\n means the file reached the end. Reaching the end of a file is not an error condition.",[26702,26703],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[224,1022,0,null,null," On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26705,26706,26707],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1038,0,null,null," Returns the number of bytes read. If the number read is smaller than `buffer.len`, it\n means the file reached the end. Reaching the end of a file is not an error condition.\n On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26709,26710,26711],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1049,0,null,null," See https://github.com/ziglang/zig/issues/7699",[26713,26714],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[224,1077,0,null,null," Returns the number of bytes read. If the number read is smaller than the total bytes\n from all the buffers, it means the file reached the end. Reaching the end of a file\n is not an error condition.\n\n The `iovecs` parameter is mutable because:\n * This function needs to mutate the fields in order to handle partial\n   reads from the underlying OS layer.\n * The OS layer expects pointer addresses to be inside the application's address space\n   even if the length is zero. Meanwhile, in Zig, slices may have undefined pointer\n   addresses when the length is zero. So this function modifies the iov_base fields\n   when the length is zero.\n\n Related open issue: https://github.com/ziglang/zig/issues/7699",[26716,26717],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[224,1109,0,null,null," See https://github.com/ziglang/zig/issues/7699\n On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26719,26720,26721],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1132,0,null,null," Returns the number of bytes read. If the number read is smaller than the total bytes\n from all the buffers, it means the file reached the end. Reaching the end of a file\n is not an error condition.\n The `iovecs` parameter is mutable because this function needs to mutate the fields in\n order to handle partial reads from the underlying OS layer.\n See https://github.com/ziglang/zig/issues/7699\n On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26723,26724,26725],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1153,0,null,null,null,null,false],[224,1154,0,null,null,null,null,false],[224,1156,0,null,null,null,[26729,26730],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[224,1168,0,null,null,null,[26732,26733],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[224,1177,0,null,null," On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26735,26736,26737],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1191,0,null,null," On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26739,26740,26741],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1200,0,null,null," See https://github.com/ziglang/zig/issues/7699\n See equivalent function: `std.net.Stream.writev`.",[26743,26744],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[224,1224,0,null,null," The `iovecs` parameter is mutable because:\n * This function needs to mutate the fields in order to handle partial\n   writes from the underlying OS layer.\n * The OS layer expects pointer addresses to be inside the application's address space\n   even if the length is zero. Meanwhile, in Zig, slices may have undefined pointer\n   addresses when the length is zero. So this function modifies the iov_base fields\n   when the length is zero.\n See https://github.com/ziglang/zig/issues/7699\n See equivalent function: `std.net.Stream.writevAll`.",[26746,26747],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[224,1251,0,null,null," See https://github.com/ziglang/zig/issues/7699\n On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26749,26750,26751],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1271,0,null,null," The `iovecs` parameter is mutable because this function needs to mutate the fields in\n order to handle partial writes from the underlying OS layer.\n See https://github.com/ziglang/zig/issues/7699\n On Windows, this function currently does alter the file pointer.\n https://github.com/ziglang/zig/issues/12783",[26753,26754,26755],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[224,1289,0,null,null,null,null,false],[224,1291,0,null,null,null,[26758,26759,26760,26761,26762],false],[0,0,0,"in",null,"",null,false],[0,0,0,"in_offset",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"out_offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[224,1299,0,null,null," Returns the number of bytes copied. If the number read is smaller than `buffer.len`, it\n means the in file reached the end. Reaching the end of a file is not an error condition.",[26764,26765,26766,26767,26768],false],[0,0,0,"in",null,"",null,false],[0,0,0,"in_offset",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"out_offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[224,1313,0,null,null,null,[26770,26772,26774,26775],false],[0,0,0,"in_offset",null,null,null,false],[224,1313,0,null,null,null,null,false],[0,0,0,"in_len",null," `null` means the entire file. `0` means no bytes from the file.\n When this is `null`, trailers must be sent in a separate writev() call\n due to a flaw in the BSD sendfile API. Other operating systems, such as\n Linux, already do this anyway due to API limitations.\n If the size of the source file is known, passing the size here will save one syscall.",null,false],[224,1313,0,null,null,null,null,false],[0,0,0,"headers_and_trailers",null,null,null,false],[0,0,0,"header_count",null," The trailer count is inferred from `headers_and_trailers.len - header_count`",null,false],[224,1329,0,null,null,null,null,false],[224,1331,0,null,null,null,[26778,26779,26780],false],[0,0,0,"self",null,"",null,false],[0,0,0,"in_file",null,"",null,false],[0,0,0,"args",null,"",null,false],[224,1347,0,null,null," Does not try seeking in either of the File parameters.\n See `writeFileAll` as an alternative to calling this.",[26782,26783,26784],false],[0,0,0,"self",null,"",null,false],[0,0,0,"in_file",null,"",null,false],[0,0,0,"args",null,"",null,false],[224,1369,0,null,null," Low level function which can fail for OS-specific reasons.\n See `writeFileAll` as an alternative to calling this.\n TODO integrate with async I/O",[26786,26787,26788],false],[0,0,0,"self",null,"",null,false],[0,0,0,"in_file",null,"",null,false],[0,0,0,"args",null,"",null,false],[224,1433,0,null,null,null,null,false],[224,1435,0,null,null,null,[26791],false],[0,0,0,"file",null,"",null,false],[224,1439,0,null,null,null,null,false],[224,1441,0,null,null,null,[26794],false],[0,0,0,"file",null,"",null,false],[224,1445,0,null,null,null,null,false],[224,1455,0,null,null,null,[26797],false],[0,0,0,"file",null,"",null,false],[224,1459,0,null,null,null,null,false],[224,1460,0,null,null,null,null,false],[224,1462,0,null,null,null,null,false],[224,1474,0,null,null," Blocks when an incompatible lock is held by another process.\n A process may hold only one type of lock (shared or exclusive) on\n a file. When a process terminates in any way, the lock is released.\n\n Assumes the file is unlocked.\n\n TODO: integrate with async I/O",[26802,26803],false],[0,0,0,"file",null,"",null,false],[0,0,0,"l",null,"",null,false],[224,1510,0,null,null," Assumes the file is locked.",[26805],false],[0,0,0,"file",null,"",null,false],[224,1541,0,null,null," Attempts to obtain a lock, returning `true` if the lock is\n obtained, and `false` if there was an existing incompatible lock held.\n A process may hold only one type of lock (shared or exclusive) on\n a file. When a process terminates in any way, the lock is released.\n\n Assumes the file is unlocked.\n\n TODO: integrate with async I/O",[26807,26808],false],[0,0,0,"file",null,"",null,false],[0,0,0,"l",null,"",null,false],[224,1581,0,null,null," Assumes the file is already locked in exclusive mode.\n Atomically modifies the lock to be in shared mode, without releasing it.\n\n TODO: integrate with async I/O",[26810],false],[0,0,0,"file",null,"",null,false],[224,12,0,null,null,null,null,false],[0,0,0,"handle",null," The OS-specific file descriptor or file handle.",null,false],[224,12,0,null,null,null,null,false],[0,0,0,"capable_io_mode",null," On some systems, such as Linux, file system file descriptors are incapable\n of non-blocking I/O. This forces us to perform asynchronous I/O on a dedicated thread,\n to achieve non-blocking file-system I/O. To do this, `File` must be aware of whether\n it is a file system file descriptor, or, more specifically, whether the I/O is always\n blocking.",null,false],[224,12,0,null,null,null,null,false],[0,0,0,"intended_io_mode",null," Furthermore, even when `std.options.io_mode` is async, it is still sometimes desirable\n to perform blocking I/O, although not by default. For example, when printing a\n stack trace to stderr. This field tracks both by acting as an overriding I/O mode.\n When not building in async I/O mode, the type only has the `.blocking` tag, making\n it a zero-bit type.",null,false],[222,20,0,null,null,null,null,false],[0,0,0,"fs/wasi.zig",null,"",[],false],[225,0,0,null,null,null,null,false],[225,1,0,null,null,null,null,false],[225,2,0,null,null,null,null,false],[225,3,0,null,null,null,null,false],[225,4,0,null,null,null,null,false],[225,5,0,null,null,null,null,false],[225,6,0,null,null,null,null,false],[225,7,0,null,null,null,null,false],[225,8,0,null,null,null,null,false],[225,9,0,null,null,null,null,false],[225,10,0,null,null,null,null,false],[225,12,0,null,null,null,[26835],false],[225,16,0,null,null,null,[26832,26833],false],[0,0,0,"p",null,"",null,false],[0,0,0,"name",null,"",null,false],[225,12,0,null,null,null,null,false],[0,0,0,"names",null,null,null,false],[225,26,0,null,null,null,[26837],false],[0,0,0,"gpa",null,"",null,false],[222,24,0,null,null,null,null,false],[222,25,0,null,null,null,null,false],[222,26,0,null,null,null,null,false],[222,28,0,null,null,null,null,false],[0,0,0,"fs/get_app_data_dir.zig",null,"",[],false],[226,0,0,null,null,null,null,false],[226,1,0,null,null,null,null,false],[226,2,0,null,null,null,null,false],[226,3,0,null,null,null,null,false],[226,4,0,null,null,null,null,false],[226,5,0,null,null,null,null,false],[226,7,0,null,null,null,null,false],[226,14,0,null,null," Caller owns returned memory.\n TODO determine if we can remove the allocator requirement",[26851,26852],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"appname",null,"",null,false],[222,29,0,null,null,null,null,false],[222,31,0,null,null,null,null,false],[0,0,0,"fs/watch.zig",null,"",[],false],[227,0,0,null,null,null,null,false],[227,1,0,null,null,null,null,false],[227,2,0,null,null,null,null,false],[227,3,0,null,null,null,null,false],[227,4,0,null,null,null,null,false],[227,5,0,null,null,null,null,false],[227,6,0,null,null,null,null,false],[227,7,0,null,null,null,null,false],[227,8,0,null,null,null,null,false],[227,9,0,null,null,null,null,false],[227,10,0,null,null,null,null,false],[227,11,0,null,null,null,null,false],[227,13,0,null,null,null,null,false],[227,16,0,null,null,null,[26870,26871],false],[0,0,0,"CloseWrite",null,null,null,false],[0,0,0,"Delete",null,null,null,false],[227,21,0,null,null,null,null,false],[227,28,0,null,null,null,[26874],false],[0,0,0,"V",null,"",[26967,26969,26971],true],[227,34,0,null,null,null,null,false],[227,43,0,null,null,null,[26885,26887],false],[227,47,0,null,null,null,null,false],[227,48,0,null,null,null,[26880,26881,26883],false],[227,48,0,null,null,null,null,false],[0,0,0,"putter_frame",null,null,null,false],[0,0,0,"cancelled",null,null,null,false],[227,48,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[227,43,0,null,null,null,null,false],[0,0,0,"table_lock",null,null,null,false],[227,43,0,null,null,null,null,false],[0,0,0,"file_table",null,null,null,false],[227,55,0,null,null,null,[26899,26901,26902],false],[227,60,0,null,null,null,null,false],[227,61,0,null,null,null,null,false],[227,63,0,null,null,null,[26893,26895,26897],false],[227,63,0,null,null,null,null,false],[0,0,0,"putter_frame",null,null,null,false],[227,63,0,null,null,null,null,false],[0,0,0,"file_table",null,null,null,false],[227,63,0,null,null,null,null,false],[0,0,0,"dir_handle",null,null,null,false],[227,55,0,null,null,null,null,false],[0,0,0,"table_lock",null,null,null,false],[227,55,0,null,null,null,null,false],[0,0,0,"dir_table",null,null,null,false],[0,0,0,"cancelled",null,null,null,false],[227,70,0,null,null,null,[26912,26913,26915,26917,26918],false],[227,77,0,null,null,null,null,false],[227,78,0,null,null,null,null,false],[227,80,0,null,null,null,[26908,26910],false],[227,80,0,null,null,null,null,false],[0,0,0,"dirname",null,null,null,false],[227,80,0,null,null,null,null,false],[0,0,0,"file_table",null,null,null,false],[227,70,0,null,null,null,null,false],[0,0,0,"putter_frame",null,null,null,false],[0,0,0,"inotify_fd",null,null,null,false],[227,70,0,null,null,null,null,false],[0,0,0,"wd_table",null,null,null,false],[227,70,0,null,null,null,null,false],[0,0,0,"table_lock",null,null,null,false],[0,0,0,"cancelled",null,null,null,false],[227,86,0,null,null,null,null,false],[227,88,0,null,null,null,[26924,26926,26928,26930],false],[227,94,0,null,null,null,null,false],[227,95,0,null,null,null,null,false],[227,88,0,null,null,null,null,false],[0,0,0,"id",null,null,null,false],[227,88,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[227,88,0,null,null,null,null,false],[0,0,0,"dirname",null,null,null,false],[227,88,0,null,null,null,null,false],[0,0,0,"basename",null,null,null,false],[227,98,0,null,null,null,[26932,26933],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"event_buf_count",null,"",null,false],[227,157,0,null,null,null,[26935],false],[0,0,0,"self",null,"",null,false],[227,218,0,null,null,null,[26937,26938,26939],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"value",null,"",null,false],[227,227,0,null,null,null,[26941,26942,26943],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"value",null,"",null,false],[227,258,0,null,null,null,[26945,26946,26947,26948],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"put",null,"",null,false],[227,329,0,null,null,null,[26950,26951,26952],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"value",null,"",null,false],[227,366,0,null,null,null,[26954,26955,26956],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"value",null,"",null,false],[227,425,0,null,null,null,[26958,26959,26960],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"dirname",null,"",null,false],[227,518,0,null,null,null,[26962,26963],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[227,568,0,null,null,null,[26965],false],[0,0,0,"self",null,"",null,false],[227,29,0,null,null,null,null,false],[0,0,0,"channel",null,null,null,false],[227,29,0,null,null,null,null,false],[0,0,0,"os_data",null,null,null,false],[227,29,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[227,637,0,null,null,null,null,false],[227,650,0,null,null,null,[26974],false],[0,0,0,"allocator",null,"",null,false],[222,40,0,null,null," This represents the maximum size of a UTF-8 encoded file path that the\n operating system will accept. Paths, including those returned from file\n system operations, may be longer than this length, but such paths cannot\n be successfully passed back in other file system operations. However,\n all path components returned by file system operations are assumed to\n fit into a UTF-8 encoded array of this length.\n The byte count includes room for a null sentinel byte.",null,false],[222,60,0,null,null," This represents the maximum size of a UTF-8 encoded file name component that\n the platform's common file systems support. File name components returned by file system\n operations are likely to fit into a UTF-8 encoded array of this length, but\n (depending on the platform) this assumption may not hold for every configuration.\n The byte count does not include a null sentinel byte.",null,false],[222,79,0,null,null,null,null,false],[222,82,0,null,null," Base64 encoder, replacing the standard `+/` with `-_` so that it can be used in a file name on any filesystem.",null,false],[222,85,0,null,null," Base64 decoder, replacing the standard `+/` with `-_` so that it can be used in a file name on any filesystem.",null,false],[222,89,0,null,null," Whether or not async file system syscalls need a dedicated thread because the operating\n system does not support non-blocking I/O on the file system.",null,false],[222,95,0,null,null," TODO remove the allocator requirement from this API",[26982,26983,26984],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"existing_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[222,123,0,null,null,null,[26986,26987],false],[0,0,0,"stale",null,null,null,false],[0,0,0,"fresh",null,null,null,false],[222,128,0,null,null,null,[26990],false],[222,128,0,null,null,null,null,false],[0,0,0,"override_mode",null," When this is `null` the mode is copied from the source file.",null,false],[222,136,0,null,null," Same as `Dir.updateFile`, except asserts that both `source_path` and `dest_path`\n are absolute. See `Dir.updateFile` for a function that operates on both\n absolute and relative paths.",[26992,26993,26994],false],[0,0,0,"source_path",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[0,0,0,"args",null,"",null,false],[222,150,0,null,null," Same as `Dir.copyFile`, except asserts that both `source_path` and `dest_path`\n are absolute. See `Dir.copyFile` for a function that operates on both\n absolute and relative paths.",[26996,26997,26998],false],[0,0,0,"source_path",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[0,0,0,"args",null,"",null,false],[222,157,0,null,null,null,[27014,27016,27018,27019,27020,27021,27023],false],[222,167,0,null,null,null,null,false],[222,169,0,null,null,null,null,false],[222,170,0,null,null,null,null,false],[222,173,0,null,null," Note that the `Dir.atomicFile` API may be more handy than this lower-level function.",[27004,27005,27006,27007],false],[0,0,0,"dest_basename",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"close_dir_on_deinit",null,"",null,false],[222,208,0,null,null," always call deinit, even after successful finish()",[27009],false],[0,0,0,"self",null,"",null,false],[222,223,0,null,null,null,null,false],[222,225,0,null,null,null,[27012],false],[0,0,0,"self",null,"",null,false],[222,157,0,null,null,null,null,false],[0,0,0,"file",null,null,null,false],[222,157,0,null,null,null,null,false],[0,0,0,"tmp_path_buf",null,null,null,false],[222,157,0,null,null,null,null,false],[0,0,0,"dest_basename",null,null,null,false],[0,0,0,"file_open",null,null,null,false],[0,0,0,"file_exists",null,null,null,false],[0,0,0,"close_dir_on_deinit",null,null,null,false],[222,157,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[222,236,0,null,null,null,null,false],[222,241,0,null,null," Create a new directory, based on an absolute path.\n Asserts that the path is absolute. See `Dir.makeDir` for a function that operates\n on both absolute and relative paths.",[27026],false],[0,0,0,"absolute_path",null,"",null,false],[222,247,0,null,null," Same as `makeDirAbsolute` except the parameter is a null-terminated UTF-8-encoded string.",[27028],false],[0,0,0,"absolute_path_z",null,"",null,false],[222,253,0,null,null," Same as `makeDirAbsolute` except the parameter is a null-terminated WTF-16-encoded string.",[27030],false],[0,0,0,"absolute_path_w",null,"",null,false],[222,259,0,null,null," Same as `Dir.deleteDir` except the path is absolute.",[27032],false],[0,0,0,"dir_path",null,"",null,false],[222,265,0,null,null," Same as `deleteDirAbsolute` except the path parameter is null-terminated.",[27034],false],[0,0,0,"dir_path",null,"",null,false],[222,271,0,null,null," Same as `deleteDirAbsolute` except the path parameter is WTF-16 and target OS is assumed Windows.",[27036],false],[0,0,0,"dir_path",null,"",null,false],[222,277,0,null,null," Same as `Dir.rename` except the paths are absolute.",[27038,27039],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[222,284,0,null,null," Same as `renameAbsolute` except the path parameters are null-terminated.",[27041,27042],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[222,291,0,null,null," Same as `renameAbsolute` except the path parameters are WTF-16 and target OS is assumed Windows.",[27044,27045],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[222,298,0,null,null," Same as `Dir.rename`, except `new_sub_path` is relative to `new_dir`",[27047,27048,27049,27050],false],[0,0,0,"old_dir",null,"",null,false],[0,0,0,"old_sub_path",null,"",null,false],[0,0,0,"new_dir",null,"",null,false],[0,0,0,"new_sub_path",null,"",null,false],[222,303,0,null,null," Same as `rename` except the parameters are null-terminated.",[27052,27053,27054,27055],false],[0,0,0,"old_dir",null,"",null,false],[0,0,0,"old_sub_path_z",null,"",null,false],[0,0,0,"new_dir",null,"",null,false],[0,0,0,"new_sub_path_z",null,"",null,false],[222,309,0,null,null," Same as `rename` except the parameters are UTF16LE, NT prefixed.\n This function is Windows-only.",[27057,27058,27059,27060],false],[0,0,0,"old_dir",null,"",null,false],[0,0,0,"old_sub_path_w",null,"",null,false],[0,0,0,"new_dir",null,"",null,false],[0,0,0,"new_sub_path_w",null,"",null,false],[222,315,0,null,null," A directory that can be iterated. It is *NOT* legal to initialize this with a regular `Dir`\n that has been opened without iteration permission.",[27114],false],[222,318,0,null,null,null,[27065,27067],false],[222,322,0,null,null,null,null,false],[222,318,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[222,318,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[222,325,0,null,null,null,null,false],[222,327,0,null,null,null,null,false],[222,880,0,null,null,null,[27071],false],[0,0,0,"self",null,"",null,false],[222,887,0,null,null," Like `iterate`, but will not reset the directory cursor before the first\n iteration. This should only be used in cases where it is known that the\n `IterableDir` has not had its cursor modified yet (e.g. it was just opened).",[27073],false],[0,0,0,"self",null,"",null,false],[222,891,0,null,null,null,[27075,27076],false],[0,0,0,"self",null,"",null,false],[0,0,0,"first_iter_start_value",null,"",null,false],[222,934,0,null,null,null,[27096,27098],false],[222,938,0,null,null,null,[27080,27082,27084,27086],false],[222,938,0,null,null,null,null,false],[0,0,0,"dir",null," The containing directory. This can be used to operate directly on `basename`\n rather than `path`, avoiding `error.NameTooLong` for deeply nested paths.\n The directory remains open until `next` or `deinit` is called.",null,false],[222,938,0,null,null,null,null,false],[0,0,0,"basename",null,null,null,false],[222,938,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[222,938,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[222,948,0,null,null,null,[27089,27090],false],[222,948,0,null,null,null,null,false],[0,0,0,"iter",null,null,null,false],[0,0,0,"dirname_len",null,null,null,false],[222,956,0,null,null," After each call to this function, and on deinit(), the memory returned\n from this function becomes invalid. A copy must be made in order to keep\n a reference to the path.",[27092],false],[0,0,0,"self",null,"",null,false],[222,1010,0,null,null,null,[27094],false],[0,0,0,"self",null,"",null,false],[222,934,0,null,null,null,null,false],[0,0,0,"stack",null,null,null,false],[222,934,0,null,null,null,null,false],[0,0,0,"name_buffer",null,null,null,false],[222,1026,0,null,null," Recursively iterates over a directory.\n Must call `Walker.deinit` when done.\n The order of returned file system entries is undefined.\n `self` will not be closed after walking it.",[27100,27101],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[222,1044,0,null,null,null,[27103],false],[0,0,0,"self",null,"",null,false],[222,1049,0,null,null,null,null,false],[222,1055,0,null,null," Changes the mode of the directory.\n The process must have the correct privileges in order to do this\n successfully, or must have the effective user ID matching the owner\n of the directory.",[27106,27107],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_mode",null,"",null,false],[222,1068,0,null,null," Changes the owner and group of the directory.\n The process must have the correct privileges in order to do this\n successfully. The group may be changed by the owner of the directory to\n any group of which the owner is a member. If the\n owner or group is specified as `null`, the ID is not changed.",[27109,27110,27111],false],[0,0,0,"self",null,"",null,false],[0,0,0,"owner",null,"",null,false],[0,0,0,"group",null,"",null,false],[222,1076,0,null,null,null,null,false],[222,315,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[222,1079,0,null,null,null,[27383],false],[222,1082,0,null,null,null,null,false],[222,1083,0,null,null,null,null,false],[222,1084,0,null,null,null,null,false],[222,1085,0,null,null,null,null,false],[222,1087,0,null,null,null,null,false],[222,1105,0,null,null,null,[27122],false],[0,0,0,"self",null,"",null,false],[222,1118,0,null,null," Opens a file for reading or writing, without attempting to create a new file.\n To create a new file, see `createFile`.\n Call `File.close` to release the resource.\n Asserts that the path parameter has no null bytes.",[27124,27125,27126],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1131,0,null,null," Same as `openFile` but WASI only.",[27128,27129,27130],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1156,0,null,null," Same as `openFile` but the path parameter is null-terminated.",[27132,27133,27134],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1241,0,null,null," Same as `openFile` but Windows-only and the path parameter is\n [WTF-16](https://simonsapin.github.io/wtf-8/#potentially-ill-formed-utf-16) encoded.",[27136,27137,27138],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1282,0,null,null," Creates, opens, or overwrites a file with write access.\n Call `File.close` on the result when done.\n Asserts that the path parameter has no null bytes.",[27140,27141,27142],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1295,0,null,null," Same as `createFile` but WASI only.",[27144,27145,27146],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1323,0,null,null," Same as `createFile` but the path parameter is null-terminated.",[27148,27149,27150],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1398,0,null,null," Same as `createFile` but Windows-only and the path parameter is\n [WTF-16](https://simonsapin.github.io/wtf-8/#potentially-ill-formed-utf-16) encoded.",[27152,27153,27154],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1443,0,null,null," Creates a single directory with a relative or absolute path.\n To create multiple directories to make an entire path, see `makePath`.\n To operate on only absolute paths, see `makeDirAbsolute`.",[27156,27157],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,1450,0,null,null," Creates a single directory with a relative or absolute null-terminated UTF-8-encoded path.\n To create multiple directories to make an entire path, see `makePath`.\n To operate on only absolute paths, see `makeDirAbsoluteZ`.",[27159,27160],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,1457,0,null,null," Creates a single directory with a relative or absolute null-terminated WTF-16-encoded path.\n To create multiple directories to make an entire path, see `makePath`.\n To operate on only absolute paths, see `makeDirAbsoluteW`.",[27162,27163],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,1465,0,null,null," Calls makeDir recursively to make an entire path. Returns success if the path\n already exists and is a directory.\n This function is not atomic, and if it returns an error, the file system may\n have been modified regardless.",[27165,27166],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,1488,0,null,null," This function performs `makePath`, followed by `openDir`.\n If supported by the OS, this operation is atomic. It is not atomic on\n all operating systems.",[27168,27169,27170],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"open_dir_options",null,"",null,false],[222,1497,0,null,null," This function performs `makePath`, followed by `openIterableDir`.\n If supported by the OS, this operation is atomic. It is not atomic on\n all operating systems.",[27172,27173,27174],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"open_dir_options",null,"",null,false],[222,1510,0,null,null,"  This function returns the canonicalized absolute pathname of\n `pathname` relative to this `Dir`. If `pathname` is absolute, ignores this\n `Dir` handle and returns the canonicalized absolute pathname of `pathname`\n argument.\n This function is not universally supported by all platforms.\n Currently supported hosts are: Linux, macOS, and Windows.\n See also `Dir.realpathZ`, `Dir.realpathW`, and `Dir.realpathAlloc`.",[27176,27177,27178],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[222,1524,0,null,null," Same as `Dir.realpath` except `pathname` is null-terminated.\n See also `Dir.realpath`, `realpathZ`.",[27180,27181,27182],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[222,1557,0,null,null," Windows-only. Same as `Dir.realpath` except `pathname` is WTF16 encoded.\n See also `Dir.realpath`, `realpathW`.",[27184,27185,27186],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[222,1599,0,null,null," Same as `Dir.realpath` except caller must free the returned memory.\n See also `Dir.realpath`.",[27188,27189,27190],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[222,1617,0,null,null," Changes the current working directory to the open directory handle.\n This modifies global state and can have surprising effects in multi-\n threaded applications. Most applications and especially libraries should\n not call this function as a general rule, however it can have use cases\n in, for example, implementing a shell, or child process execution.\n Not all targets support this. For example, WASI does not have the concept\n of a current working directory.",[27192],false],[0,0,0,"self",null,"",null,false],[222,1632,0,null,null,null,[27194,27195],false],[0,0,0,"access_sub_paths",null," `true` means the opened directory can be used as the `Dir` parameter\n for functions which operate based on an open directory handle. When `false`,\n such operations are Illegal Behavior.",null,false],[0,0,0,"no_follow",null," `true` means it won't dereference the symlinks.",null,false],[222,1646,0,null,null," Opens a directory at the given path. The directory is a system resource that remains\n open until `close` is called on the result.\n\n Asserts that the path parameter has no null bytes.",[27197,27198,27199],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"args",null,"",null,false],[222,1662,0,null,null," Opens an iterable directory at the given path. The directory is a system resource that remains\n open until `close` is called on the result.\n\n Asserts that the path parameter has no null bytes.",[27201,27202,27203],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"args",null,"",null,false],[222,1675,0,null,null," Same as `openDir` except only WASI.",[27205,27206,27207],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"args",null,"",null,false],[222,1722,0,null,null," Same as `openDir` except the parameter is null-terminated.",[27209,27210,27211,27212],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_c",null,"",null,false],[0,0,0,"args",null,"",null,false],[0,0,0,"iterable",null,"",null,false],[222,1738,0,null,null," Same as `openDir` except the path parameter is WTF-16 encoded, NT-prefixed.\n This function asserts the target OS is Windows.",[27214,27215,27216,27217],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"args",null,"",null,false],[0,0,0,"iterable",null,"",null,false],[222,1749,0,null,null," `flags` must contain `os.O.DIRECTORY`.",[27219,27220,27221],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1767,0,null,null,null,[27223,27224,27225,27226],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"access_mask",null,"",null,false],[0,0,0,"no_follow",null,"",null,false],[222,1817,0,null,null,null,null,false],[222,1821,0,null,null," Delete a file name and possibly the file it refers to, based on an open directory handle.\n Asserts that the path parameter has no null bytes.",[27229,27230],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,1837,0,null,null," Same as `deleteFile` except the parameter is null-terminated.",[27232,27233],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_c",null,"",null,false],[222,1856,0,null,null," Same as `deleteFile` except the parameter is WTF-16 encoded.",[27235,27236],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[222,1863,0,null,null,null,null,false],[222,1884,0,null,null," Returns `error.DirNotEmpty` if the directory is not empty.\n To delete a directory recursively, see `deleteTree`.\n Asserts that the path parameter has no null bytes.",[27239,27240],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,1900,0,null,null," Same as `deleteDir` except the parameter is null-terminated.",[27242,27243],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_c",null,"",null,false],[222,1909,0,null,null," Same as `deleteDir` except the parameter is UTF16LE, NT prefixed.\n This function is Windows-only.",[27245,27246],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[222,1916,0,null,null,null,null,false],[222,1922,0,null,null," Change the name or location of a file or directory.\n If new_sub_path already exists, it will be replaced.\n Renaming a file over an existing directory or a directory\n over an existing file will fail with `error.IsDir` or `error.NotDir`",[27249,27250,27251],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_sub_path",null,"",null,false],[0,0,0,"new_sub_path",null,"",null,false],[222,1927,0,null,null," Same as `rename` except the parameters are null-terminated.",[27253,27254,27255],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_sub_path_z",null,"",null,false],[0,0,0,"new_sub_path_z",null,"",null,false],[222,1933,0,null,null," Same as `rename` except the parameters are UTF16LE, NT prefixed.\n This function is Windows-only.",[27257,27258,27259],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_sub_path_w",null,"",null,false],[0,0,0,"new_sub_path_w",null,"",null,false],[222,1941,0,null,null," Creates a symbolic link named `sym_link_path` which contains the string `target_path`.\n A symbolic link (also known as a soft link) may point to an existing file or to a nonexistent\n one; the latter case is known as a dangling link.\n If `sym_link_path` exists, it will not be overwritten.",[27261,27262,27263,27264],false],[0,0,0,"self",null,"",null,false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1967,0,null,null," WASI-only. Same as `symLink` except targeting WASI.",[27266,27267,27268,27269],false],[0,0,0,"self",null,"",null,false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[0,0,0,"",null,"",null,false],[222,1977,0,null,null," Same as `symLink`, except the pathname parameters are null-terminated.",[27271,27272,27273,27274],false],[0,0,0,"self",null,"",null,false],[0,0,0,"target_path_c",null,"",null,false],[0,0,0,"sym_link_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,1993,0,null,null," Windows-only. Same as `symLink` except the pathname parameters\n are null-terminated, WTF16 encoded.",[27276,27277,27278,27279],false],[0,0,0,"self",null,"",null,false],[0,0,0,"target_path_w",null," WTF-16, does not need to be NT-prefixed. The NT-prefixing\n of this path is handled by CreateSymbolicLink.",null,false],[0,0,0,"sym_link_path_w",null," WTF-16, must be NT-prefixed or relative",null,false],[0,0,0,"flags",null,"",null,false],[222,2008,0,null,null," Read value of a symbolic link.\n The return value is a slice of `buffer`, from index `0`.\n Asserts that the path parameter has no null bytes.",[27281,27282,27283],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2021,0,null,null," WASI-only. Same as `readLink` except targeting WASI.",[27285,27286,27287],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2026,0,null,null," Same as `readLink`, except the `pathname` parameter is null-terminated.",[27289,27290,27291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_c",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2036,0,null,null," Windows-only. Same as `readLink` except the pathname parameter\n is null-terminated, WTF16 encoded.",[27293,27294,27295],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2045,0,null,null," Read all of file contents using a preallocated buffer.\n The returned slice has the same pointer as `buffer`. If the length matches `buffer.len`\n the situation is ambiguous. It could either mean that the entire file was read, and\n it exactly fits the buffer, or it could mean the buffer was not big enough for the\n entire file.",[27297,27298,27299],false],[0,0,0,"self",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2055,0,null,null," On success, caller owns returned buffer.\n If the file is larger than `max_bytes`, returns `error.FileTooBig`.",[27301,27302,27303,27304],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"max_bytes",null,"",null,false],[222,2064,0,null,null," On success, caller owns returned buffer.\n If the file is larger than `max_bytes`, returns `error.FileTooBig`.\n If `size_hint` is specified the initial buffer size is calculated using\n that value, otherwise the effective file size is used instead.\n Allows specifying alignment and a sentinel value.",[27306,27307,27308,27309,27310,27311,27312],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"max_bytes",null,"",null,false],[0,0,0,"size_hint",null,"",null,false],[0,0,0,"alignment",null,"",null,true],[0,0,0,"optional_sentinel",null,"",null,true],[222,2084,0,null,null,null,null,false],[222,2118,0,null,null," Whether `full_path` describes a symlink, file, or directory, this function\n removes it. If it cannot be removed because it is a non-empty directory,\n this function recursively removes its entries and then tries again.\n This operation is not atomic on most file systems.",[27315,27316],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,2307,0,null,null," Like `deleteTree`, but only keeps one `Iterator` active at a time to minimize the function's stack size.\n This is slower than `deleteTree` but uses less stack space.",[27318,27319],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,2311,0,null,null,null,[27321,27322,27323],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"kind_hint",null,"",null,false],[222,2423,0,null,null," On successful delete, returns null.",[27325,27326,27327],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"kind_hint",null,"",null,false],[222,2487,0,null,null," Writes content to the file system, creating a new file if it does not exist, truncating\n if it already exists.",[27329,27330,27331],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"data",null,"",null,false],[222,2493,0,null,null,null,null,false],[222,2500,0,null,null," Test accessing `path`.\n `path` is UTF-8-encoded.\n Be careful of Time-Of-Check-Time-Of-Use race conditions when using this function.\n For example, instead of testing if a file exists and then opening it, just\n open it and handle the error for file not found.",[27334,27335,27336],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2513,0,null,null," Same as `access` except the path parameter is null-terminated.",[27338,27339,27340],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2538,0,null,null," Same as `access` except asserts the target OS is Windows and the path parameter is\n * WTF-16 encoded\n * null-terminated\n * NtDll prefixed\n TODO currently this ignores `flags`.",[27342,27343,27344],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2548,0,null,null," Check the file size, mtime, and mode of `source_path` and `dest_path`. If they are equal, does nothing.\n Otherwise, atomically copies `source_path` to `dest_path`. The destination file gains the mtime,\n atime, and mode of the source file so that the next call to `updateFile` will not need a copy.\n Returns the previous status of the file before updating.\n If any of the directories do not exist for dest_path, they are created.",[27346,27347,27348,27349,27350],false],[0,0,0,"source_dir",null,"",null,false],[0,0,0,"source_path",null,"",null,false],[0,0,0,"dest_dir",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[0,0,0,"options",null,"",null,false],[222,2592,0,null,null,null,null,false],[222,2598,0,null,null," Guaranteed to be atomic.\n On Linux, until https://patchwork.kernel.org/patch/9636735/ is merged and readily available,\n there is a possibility of power loss or application termination leaving temporary files present\n in the same directory as dest_path.",[27353,27354,27355,27356,27357],false],[0,0,0,"source_dir",null,"",null,false],[0,0,0,"source_path",null,"",null,false],[0,0,0,"dest_dir",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[0,0,0,"options",null,"",null,false],[222,2616,0,null,null,null,[27360],false],[222,2616,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[222,2624,0,null,null," Directly access the `.file` field, and then call `AtomicFile.finish`\n to atomically replace `dest_path` with contents.\n Always call `AtomicFile.deinit` to clean up, regardless of whether `AtomicFile.finish` succeeded.\n `dest_path` must remain valid until `AtomicFile.deinit` is called.",[27362,27363,27364],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[0,0,0,"options",null,"",null,false],[222,2633,0,null,null,null,null,false],[222,2634,0,null,null,null,null,false],[222,2636,0,null,null,null,[27368],false],[0,0,0,"self",null,"",null,false],[222,2644,0,null,null,null,null,false],[222,2654,0,null,null," Returns metadata for a file inside the directory.\n\n On Windows, this requires three syscalls. On other operating systems, it\n only takes one.\n\n Symlinks are followed.\n\n `sub_path` may be absolute, in which case `self` is ignored.",[27371,27372],false],[0,0,0,"self",null,"",null,false],[0,0,0,"sub_path",null,"",null,false],[222,2668,0,null,null,null,null,false],[222,2669,0,null,null,null,null,false],[222,2673,0,null,null," Sets permissions according to the provided `Permissions` struct.\n This method is *NOT* available on WASI",[27376,27377],false],[0,0,0,"self",null,"",null,false],[0,0,0,"permissions",null,"",null,false],[222,2681,0,null,null,null,null,false],[222,2682,0,null,null,null,null,false],[222,2685,0,null,null," Returns a `Metadata` struct, representing the permissions on the directory",[27381],false],[0,0,0,"self",null,"",null,false],[222,1079,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[222,2697,0,null,null," Returns a handle to the current working directory. It is not opened with iteration capability.\n Closing the returned `Dir` is checked illegal behavior. Iterating over the result is illegal behavior.\n On POSIX targets, this function is comptime-callable.",[],false],[222,2707,0,null,null,null,[],false],[222,2717,0,null,null," Opens a directory at the given path. The directory is a system resource that remains\n open until `close` is called on the result.\n See `openDirAbsoluteZ` for a function that accepts a null-terminated path.\n\n Asserts that the path parameter has no null bytes.",[27387,27388],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2723,0,null,null," Same as `openDirAbsolute` but the path parameter is null-terminated.",[27390,27391],false],[0,0,0,"absolute_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2728,0,null,null," Same as `openDirAbsolute` but the path parameter is null-terminated.",[27393,27394],false],[0,0,0,"absolute_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2738,0,null,null," Opens a directory at the given path. The directory is a system resource that remains\n open until `close` is called on the result.\n See `openIterableDirAbsoluteZ` for a function that accepts a null-terminated path.\n\n Asserts that the path parameter has no null bytes.",[27396,27397],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2744,0,null,null," Same as `openIterableDirAbsolute` but the path parameter is null-terminated.",[27399,27400],false],[0,0,0,"absolute_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2749,0,null,null," Same as `openIterableDirAbsolute` but the path parameter is null-terminated.",[27402,27403],false],[0,0,0,"absolute_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2760,0,null,null," Opens a file for reading or writing, without attempting to create a new file, based on an absolute path.\n Call `File.close` to release the resource.\n Asserts that the path is absolute. See `Dir.openFile` for a function that\n operates on both absolute and relative paths.\n Asserts that the path parameter has no null bytes. See `openFileAbsoluteZ` for a function\n that accepts a null-terminated path.",[27405,27406],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2766,0,null,null," Same as `openFileAbsolute` but the path parameter is null-terminated.",[27408,27409],false],[0,0,0,"absolute_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2772,0,null,null," Same as `openFileAbsolute` but the path parameter is WTF-16-encoded.",[27411,27412],false],[0,0,0,"absolute_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2783,0,null,null," Test accessing `path`.\n `path` is UTF-8-encoded.\n Be careful of Time-Of-Check-Time-Of-Use race conditions when using this function.\n For example, instead of testing if a file exists and then opening it, just\n open it and handle the error for file not found.\n See `accessAbsoluteZ` for a function that accepts a null-terminated path.",[27414,27415],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2788,0,null,null," Same as `accessAbsolute` but the path parameter is null-terminated.",[27417,27418],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2793,0,null,null," Same as `accessAbsolute` but the path parameter is WTF-16 encoded.",[27420,27421],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2804,0,null,null," Creates, opens, or overwrites a file with write access, based on an absolute path.\n Call `File.close` to release the resource.\n Asserts that the path is absolute. See `Dir.createFile` for a function that\n operates on both absolute and relative paths.\n Asserts that the path parameter has no null bytes. See `createFileAbsoluteC` for a function\n that accepts a null-terminated path.",[27423,27424],false],[0,0,0,"absolute_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2810,0,null,null," Same as `createFileAbsolute` but the path parameter is null-terminated.",[27426,27427],false],[0,0,0,"absolute_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2816,0,null,null," Same as `createFileAbsolute` but the path parameter is WTF-16 encoded.",[27429,27430],false],[0,0,0,"absolute_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2825,0,null,null," Delete a file name and possibly the file it refers to, based on an absolute path.\n Asserts that the path is absolute. See `Dir.deleteFile` for a function that\n operates on both absolute and relative paths.\n Asserts that the path parameter has no null bytes.",[27432],false],[0,0,0,"absolute_path",null,"",null,false],[222,2831,0,null,null," Same as `deleteFileAbsolute` except the parameter is null-terminated.",[27434],false],[0,0,0,"absolute_path_c",null,"",null,false],[222,2837,0,null,null," Same as `deleteFileAbsolute` except the parameter is WTF-16 encoded.",[27436],false],[0,0,0,"absolute_path_w",null,"",null,false],[222,2847,0,null,null," Removes a symlink, file, or directory.\n This is equivalent to `Dir.deleteTree` with the base directory.\n Asserts that the path is absolute. See `Dir.deleteTree` for a function that\n operates on both absolute and relative paths.\n Asserts that the path parameter has no null bytes.",[27438],false],[0,0,0,"absolute_path",null,"",null,false],[222,2862,0,null,null," Same as `Dir.readLink`, except it asserts the path is absolute.",[27440,27441],false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2869,0,null,null," Windows-only. Same as `readlinkW`, except the path parameter is null-terminated, WTF16\n encoded.",[27443,27444],false],[0,0,0,"pathname_w",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2875,0,null,null," Same as `readLink`, except the path parameter is null-terminated.",[27446,27447],false],[0,0,0,"pathname_c",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[222,2884,0,null,null," Use with `Dir.symLink` and `symLinkAbsolute` to specify whether the symlink\n will point to a file or a directory. This value is ignored on all hosts\n except Windows where creating symlinks to different resource types, requires\n different flags. By default, `symLinkAbsolute` is assumed to point to a file.",[27449],false],[0,0,0,"is_directory",null,null,null,false],[222,2893,0,null,null," Creates a symbolic link named `sym_link_path` which contains the string `target_path`.\n A symbolic link (also known as a soft link) may point to an existing file or to a nonexistent\n one; the latter case is known as a dangling link.\n If `sym_link_path` exists, it will not be overwritten.\n See also `symLinkAbsoluteZ` and `symLinkAbsoluteW`.",[27451,27452,27453],false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2908,0,null,null," Windows-only. Same as `symLinkAbsolute` except the parameters are null-terminated, WTF16 encoded.\n Note that this function will by default try creating a symbolic link to a file. If you would\n like to create a symbolic link to a directory, specify this with `SymLinkFlags{ .is_directory = true }`.\n See also `symLinkAbsolute`, `symLinkAbsoluteZ`.",[27455,27456,27457],false],[0,0,0,"target_path_w",null,"",null,false],[0,0,0,"sym_link_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2916,0,null,null," Same as `symLinkAbsolute` except the parameters are null-terminated pointers.\n See also `symLinkAbsolute`.",[27459,27460,27461],false],[0,0,0,"target_path_c",null,"",null,false],[0,0,0,"sym_link_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[222,2927,0,null,null,null,null,false],[222,2942,0,null,null,null,[27464],false],[0,0,0,"flags",null,"",null,false],[222,2963,0,null,null,null,null,false],[222,2967,0,null,null," `selfExePath` except allocates the result on the heap.\n Caller owns returned memory.",[27467],false],[0,0,0,"allocator",null,"",null,false],[222,2989,0,null,null," Get the path to the current executable. Follows symlinks.\n If you only need the directory, use selfExeDirPath.\n If you only want an open file handle, use openSelfExe.\n This function may return an error if the current executable\n was deleted after spawning.\n Returned value is a slice of out_buffer.\n\n On Linux, depends on procfs being mounted. If the currently executing binary has\n been deleted, the file path looks something like `/a/b/c/exe (deleted)`.\n TODO make the return type of this a null terminated pointer",[27469],false],[0,0,0,"out_buffer",null,"",null,false],[222,3075,0,null,null,null,null,false],[222,3079,0,null,null," `selfExeDirPath` except allocates the result on the heap.\n Caller owns returned memory.",[27472],false],[0,0,0,"allocator",null,"",null,false],[222,3093,0,null,null," Get the directory path that contains the current executable.\n Returned value is a slice of out_buffer.",[27474],false],[0,0,0,"out_buffer",null,"",null,false],[222,3102,0,null,null," `realpath`, except caller must free the returned memory.\n See also `Dir.realpath`.",[27476,27477],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[222,3113,0,null,null,null,null,false],[222,3118,0,null,null,null,[27480,27481,27482],false],[0,0,0,"fd_in",null,"",null,false],[0,0,0,"fd_out",null,"",null,false],[0,0,0,"maybe_size",null,"",null,false],[1,109,0,null,null," Fast hashing functions (i.e. not cryptographically secure).",null,false],[0,0,0,"hash.zig",null,"",[],false],[228,0,0,null,null,null,null,false],[0,0,0,"hash/adler.zig",null,"",[],false],[229,5,0,null,null,null,null,false],[229,6,0,null,null,null,null,false],[229,8,0,null,null,null,[27500],false],[229,9,0,null,null,null,null,false],[229,10,0,null,null,null,null,false],[229,14,0,null,null,null,[],false],[229,20,0,null,null,null,[27494,27495],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[229,84,0,null,null,null,[27497],false],[0,0,0,"self",null,"",null,false],[229,88,0,null,null,null,[27499],false],[0,0,0,"input",null,"",null,false],[0,0,0,"adler",null,null,null,false],[229,129,0,null,null,null,null,false],[0,0,0,"verify.zig",null,"",[],false],[230,0,0,null,null,null,null,false],[230,2,0,null,null,null,[27505,27506,27507],false],[0,0,0,"hash_fn",null,"",null,true],[0,0,0,"seed",null,"",null,false],[0,0,0,"buf",null,"",null,false],[230,15,0,null,null,null,[27509,27510],false],[0,0,0,"Hash",null,"",null,true],[0,0,0,"seed",null,"",null,false],[230,28,0,null,null,null,[27512],false],[0,0,0,"hash_fn",null,"",null,true],[230,45,0,null,null,null,[27514],false],[0,0,0,"Hash",null,"",null,true],[228,1,0,null,null,null,null,false],[228,3,0,null,null,null,null,false],[0,0,0,"hash/auto_hash.zig",null,"",[],false],[231,0,0,null,null,null,null,false],[231,1,0,null,null,null,null,false],[231,2,0,null,null,null,null,false],[231,3,0,null,null,null,null,false],[231,6,0,null,null," Describes how pointer types should be hashed.",[27523,27524,27525],false],[0,0,0,"Shallow",null," Do not follow pointers, only hash their value.",null,false],[0,0,0,"Deep",null," Follow pointers, hash the pointee content.\n Only dereferences one level, ie. it is changed into .Shallow when a\n pointer type is encountered.",null,false],[0,0,0,"DeepRecursive",null," Follow pointers, hash the pointee content.\n Dereferences all pointers encountered.\n Assumes no cycle.",null,false],[231,22,0,null,null," Helper function to hash a pointer and mutate the strategy if needed.",[27527,27528,27529],false],[0,0,0,"hasher",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"strat",null,"",null,true],[231,56,0,null,null," Helper function to hash a set of contiguous objects, from an array or slice.",[27531,27532,27533],false],[0,0,0,"hasher",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"strat",null,"",null,true],[231,64,0,null,null," Provides generic hashing for any eligible type.\n Strategy is provided to determine if pointers should be followed or not.",[27535,27536,27537],false],[0,0,0,"hasher",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"strat",null,"",null,true],[231,168,0,null,null,null,[27539],false],[0,0,0,"K",null,"",null,true],[231,195,0,null,null," Provides generic hashing for any eligible type.\n Only hashes `key` itself, pointers are not followed.\n Slices as well as unions and structs containing slices are rejected to avoid\n ambiguity on the user's intention.",[27541,27542],false],[0,0,0,"hasher",null,"",null,false],[0,0,0,"key",null,"",null,false],[231,205,0,null,null,null,null,false],[231,206,0,null,null,null,null,false],[231,208,0,null,null,null,[27546],false],[0,0,0,"key",null,"",null,false],[231,215,0,null,null,null,[27548],false],[0,0,0,"key",null,"",null,false],[231,222,0,null,null,null,[27550],false],[0,0,0,"key",null,"",null,false],[231,229,0,null,null,null,[27552],false],[0,0,0,"key",null,"",null,false],[228,4,0,null,null,null,null,false],[228,5,0,null,null,null,null,false],[228,6,0,null,null,null,null,false],[228,9,0,null,null,null,null,false],[0,0,0,"hash/crc.zig",null,"",[],false],[232,12,0,null,null,null,null,false],[0,0,0,"crc/catalog.zig",null," This file is auto-generated by tools/update_crc_catalog.zig.\n",[],false],[233,2,0,null,null,null,null,false],[233,8,0,null,null,null,null,false],[233,16,0,null,null,null,null,false],[233,24,0,null,null,null,null,false],[233,32,0,null,null,null,null,false],[233,40,0,null,null,null,null,false],[233,48,0,null,null,null,null,false],[233,56,0,null,null,null,null,false],[233,64,0,null,null,null,null,false],[233,72,0,null,null,null,null,false],[233,80,0,null,null,null,null,false],[233,88,0,null,null,null,null,false],[233,96,0,null,null,null,null,false],[233,104,0,null,null,null,null,false],[233,112,0,null,null,null,null,false],[233,120,0,null,null,null,null,false],[233,128,0,null,null,null,null,false],[233,136,0,null,null,null,null,false],[233,144,0,null,null,null,null,false],[233,152,0,null,null,null,null,false],[233,160,0,null,null,null,null,false],[233,168,0,null,null,null,null,false],[233,176,0,null,null,null,null,false],[233,184,0,null,null,null,null,false],[233,192,0,null,null,null,null,false],[233,200,0,null,null,null,null,false],[233,208,0,null,null,null,null,false],[233,216,0,null,null,null,null,false],[233,224,0,null,null,null,null,false],[233,232,0,null,null,null,null,false],[233,240,0,null,null,null,null,false],[233,248,0,null,null,null,null,false],[233,256,0,null,null,null,null,false],[233,264,0,null,null,null,null,false],[233,272,0,null,null,null,null,false],[233,280,0,null,null,null,null,false],[233,288,0,null,null,null,null,false],[233,296,0,null,null,null,null,false],[233,304,0,null,null,null,null,false],[233,312,0,null,null,null,null,false],[233,320,0,null,null,null,null,false],[233,328,0,null,null,null,null,false],[233,336,0,null,null,null,null,false],[233,344,0,null,null,null,null,false],[233,352,0,null,null,null,null,false],[233,360,0,null,null,null,null,false],[233,368,0,null,null,null,null,false],[233,376,0,null,null,null,null,false],[233,384,0,null,null,null,null,false],[233,392,0,null,null,null,null,false],[233,400,0,null,null,null,null,false],[233,408,0,null,null,null,null,false],[233,416,0,null,null,null,null,false],[233,424,0,null,null,null,null,false],[233,432,0,null,null,null,null,false],[233,440,0,null,null,null,null,false],[233,448,0,null,null,null,null,false],[233,456,0,null,null,null,null,false],[233,464,0,null,null,null,null,false],[233,472,0,null,null,null,null,false],[233,480,0,null,null,null,null,false],[233,488,0,null,null,null,null,false],[233,496,0,null,null,null,null,false],[233,504,0,null,null,null,null,false],[233,512,0,null,null,null,null,false],[233,520,0,null,null,null,null,false],[233,528,0,null,null,null,null,false],[233,536,0,null,null,null,null,false],[233,544,0,null,null,null,null,false],[233,552,0,null,null,null,null,false],[233,560,0,null,null,null,null,false],[233,568,0,null,null,null,null,false],[233,576,0,null,null,null,null,false],[233,584,0,null,null,null,null,false],[233,592,0,null,null,null,null,false],[233,600,0,null,null,null,null,false],[233,608,0,null,null,null,null,false],[233,616,0,null,null,null,null,false],[233,624,0,null,null,null,null,false],[233,632,0,null,null,null,null,false],[233,640,0,null,null,null,null,false],[233,648,0,null,null,null,null,false],[233,656,0,null,null,null,null,false],[233,664,0,null,null,null,null,false],[233,672,0,null,null,null,null,false],[233,680,0,null,null,null,null,false],[233,688,0,null,null,null,null,false],[233,696,0,null,null,null,null,false],[233,704,0,null,null,null,null,false],[233,712,0,null,null,null,null,false],[233,720,0,null,null,null,null,false],[233,728,0,null,null,null,null,false],[233,736,0,null,null,null,null,false],[233,744,0,null,null,null,null,false],[233,752,0,null,null,null,null,false],[233,760,0,null,null,null,null,false],[233,768,0,null,null,null,null,false],[233,776,0,null,null,null,null,false],[233,784,0,null,null,null,null,false],[233,792,0,null,null,null,null,false],[233,800,0,null,null,null,null,false],[233,808,0,null,null,null,null,false],[233,816,0,null,null,null,null,false],[233,824,0,null,null,null,null,false],[233,832,0,null,null,null,null,false],[233,840,0,null,null,null,null,false],[233,848,0,null,null,null,null,false],[233,856,0,null,null,null,null,false],[233,864,0,null,null,null,null,false],[233,872,0,null,null,null,null,false],[233,880,0,null,null,null,null,false],[233,888,0,null,null,null,null,false],[233,896,0,null,null,null,null,false],[232,7,0,null,null,null,null,false],[232,8,0,null,null,null,null,false],[232,9,0,null,null,null,null,false],[232,10,0,null,null,null,null,false],[232,14,0,null,null,null,[27678],false],[0,0,0,"W",null,"",[27680,27682,27683,27684,27686],true],[232,15,0,null,null,null,null,false],[0,0,0,"polynomial",null,null,null,false],[232,15,0,null,null,null,null,false],[0,0,0,"initial",null,null,null,false],[0,0,0,"reflect_input",null,null,null,false],[0,0,0,"reflect_output",null,null,null,false],[232,15,0,null,null,null,null,false],[0,0,0,"xor_output",null,null,null,false],[232,24,0,null,null,null,[27688,27689],false],[0,0,0,"W",null,"",null,true],[0,0,0,"algorithm",null,"",[27704],true],[232,26,0,null,null,null,null,false],[232,27,0,null,null,null,null,false],[232,28,0,null,null,null,null,false],[232,58,0,null,null,null,[],false],[232,66,0,null,null,null,[27695],false],[0,0,0,"index",null,"",null,false],[232,70,0,null,null,null,[27697,27698],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[232,89,0,null,null,null,[27700],false],[0,0,0,"self",null,"",null,false],[232,100,0,null,null,null,[27702],false],[0,0,0,"bytes",null,"",null,false],[232,25,0,null,null,null,null,false],[0,0,0,"crc",null,null,null,false],[232,108,0,null,null,null,[27706,27707,27708],false],[0,0,0,"IEEE",null,null,null,false],[0,0,0,"Castagnoli",null,null,null,false],[0,0,0,"Koopman",null,null,null,false],[232,116,0,null,null,null,null,false],[232,119,0,null,null,null,[27711],false],[0,0,0,"poly",null,"",[27722],true],[232,121,0,null,null,null,null,false],[232,122,0,null,null,null,null,false],[232,155,0,null,null,null,[],false],[232,159,0,null,null,null,[27716,27717],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[232,184,0,null,null,null,[27719],false],[0,0,0,"self",null,"",null,false],[232,188,0,null,null,null,[27721],false],[0,0,0,"input",null,"",null,false],[0,0,0,"crc",null,null,null,false],[232,196,0,null,null,null,null,false],[232,219,0,null,null,null,[27725],false],[0,0,0,"poly",null,"",[27736],true],[232,221,0,null,null,null,null,false],[232,222,0,null,null,null,null,false],[232,243,0,null,null,null,[],false],[232,247,0,null,null,null,[27730,27731],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[232,254,0,null,null,null,[27733],false],[0,0,0,"self",null,"",null,false],[232,258,0,null,null,null,[27735],false],[0,0,0,"input",null,"",null,false],[0,0,0,"crc",null,null,null,false],[228,10,0,null,null,null,null,false],[228,12,0,null,null,null,null,false],[0,0,0,"hash/fnv.zig",null,"",[],false],[234,6,0,null,null,null,null,false],[234,7,0,null,null,null,null,false],[234,9,0,null,null,null,null,false],[234,10,0,null,null,null,null,false],[234,11,0,null,null,null,null,false],[234,13,0,null,null,null,[27746,27747,27748],false],[0,0,0,"T",null,"",null,true],[0,0,0,"prime",null,"",null,true],[0,0,0,"offset",null,"",[27759],true],[234,15,0,null,null,null,null,false],[234,19,0,null,null,null,[],false],[234,23,0,null,null,null,[27752,27753],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[234,30,0,null,null,null,[27755],false],[0,0,0,"self",null,"",null,false],[234,34,0,null,null,null,[27757],false],[0,0,0,"input",null,"",null,false],[234,14,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[234,42,0,null,null,null,null,false],[228,13,0,null,null,null,null,false],[228,14,0,null,null,null,null,false],[228,15,0,null,null,null,null,false],[228,17,0,null,null,null,null,false],[228,18,0,null,null,null,null,false],[228,19,0,null,null,null,null,false],[228,21,0,null,null,null,null,false],[0,0,0,"hash/murmur.zig",null,"",[],false],[235,0,0,null,null,null,null,false],[235,1,0,null,null,null,null,false],[235,2,0,null,null,null,null,false],[235,3,0,null,null,null,null,false],[235,5,0,null,null,null,null,false],[235,7,0,null,null,null,[],false],[235,8,0,null,null,null,null,false],[235,10,0,null,null,null,[27777],false],[0,0,0,"str",null,"",null,false],[235,14,0,null,null,null,[27779,27780],false],[0,0,0,"str",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,46,0,null,null,null,[27782],false],[0,0,0,"v",null,"",null,false],[235,50,0,null,null,null,[27784,27785],false],[0,0,0,"v",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,66,0,null,null,null,[27787],false],[0,0,0,"v",null,"",null,false],[235,70,0,null,null,null,[27789,27790],false],[0,0,0,"v",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,92,0,null,null,null,[],false],[235,93,0,null,null,null,null,false],[235,95,0,null,null,null,[27794],false],[0,0,0,"str",null,"",null,false],[235,99,0,null,null,null,[27796,27797],false],[0,0,0,"str",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,128,0,null,null,null,[27799],false],[0,0,0,"v",null,"",null,false],[235,132,0,null,null,null,[27801,27802],false],[0,0,0,"v",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,145,0,null,null,null,[27804],false],[0,0,0,"v",null,"",null,false],[235,149,0,null,null,null,[27806,27807],false],[0,0,0,"v",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,166,0,null,null,null,[],false],[235,167,0,null,null,null,null,false],[235,169,0,null,null,null,[27811,27812],false],[0,0,0,"x",null,"",null,false],[0,0,0,"r",null,"",null,true],[235,173,0,null,null,null,[27814],false],[0,0,0,"str",null,"",null,false],[235,177,0,null,null,null,[27816,27817],false],[0,0,0,"str",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,221,0,null,null,null,[27819],false],[0,0,0,"v",null,"",null,false],[235,225,0,null,null,null,[27821,27822],false],[0,0,0,"v",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,247,0,null,null,null,[27824],false],[0,0,0,"v",null,"",null,false],[235,251,0,null,null,null,[27826,27827],false],[0,0,0,"v",null,"",null,false],[0,0,0,"seed",null,"",null,false],[235,281,0,null,null,null,null,false],[228,22,0,null,null,null,null,false],[228,24,0,null,null,null,null,false],[228,25,0,null,null,null,null,false],[228,27,0,null,null,null,null,false],[0,0,0,"hash/cityhash.zig",null,"",[],false],[236,0,0,null,null,null,null,false],[236,2,0,null,null,null,[27836,27837],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"offset",null,"",null,false],[236,7,0,null,null,null,[27839,27840],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"offset",null,"",null,false],[236,11,0,null,null,null,[27842,27843],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"offset",null,"",null,false],[236,15,0,null,null,null,[],false],[236,16,0,null,null,null,null,false],[236,19,0,null,null,null,null,false],[236,20,0,null,null,null,null,false],[236,23,0,null,null,null,[27849],false],[0,0,0,"h",null,"",null,false],[236,34,0,null,null,null,[27851,27852],false],[0,0,0,"x",null,"",null,false],[0,0,0,"r",null,"",null,true],[236,39,0,null,null,null,[27854,27855],false],[0,0,0,"a",null,"",null,false],[0,0,0,"h",null,"",null,false],[236,50,0,null,null,null,[27857],false],[0,0,0,"str",null,"",null,false],[236,61,0,null,null,null,[27859],false],[0,0,0,"str",null,"",null,false],[236,74,0,null,null,null,[27861],false],[0,0,0,"str",null,"",null,false],[236,86,0,null,null,null,[27863],false],[0,0,0,"str",null,"",null,false],[236,169,0,null,null,null,[],false],[236,170,0,null,null,null,null,false],[236,173,0,null,null,null,null,false],[236,174,0,null,null,null,null,false],[236,175,0,null,null,null,null,false],[236,178,0,null,null,null,[27870,27871],false],[0,0,0,"x",null,"",null,false],[0,0,0,"r",null,"",null,true],[236,182,0,null,null,null,[27873],false],[0,0,0,"v",null,"",null,false],[236,186,0,null,null,null,[27875,27876],false],[0,0,0,"u",null,"",null,false],[0,0,0,"v",null,"",null,false],[236,190,0,null,null,null,[27878,27879,27880],false],[0,0,0,"low",null,"",null,false],[0,0,0,"high",null,"",null,false],[0,0,0,"mul",null,"",null,false],[236,199,0,null,null,null,[27882,27883],false],[0,0,0,"low",null,"",null,false],[0,0,0,"high",null,"",null,false],[236,203,0,null,null,null,[27885],false],[0,0,0,"str",null,"",null,false],[236,229,0,null,null,null,[27887],false],[0,0,0,"str",null,"",null,false],[236,240,0,null,null,null,[27889],false],[0,0,0,"str",null,"",null,false],[236,263,0,null,null,null,[27891,27892],false],[0,0,0,"first",null,null,null,false],[0,0,0,"second",null,null,null,false],[236,268,0,null,null,null,[27894,27895,27896,27897,27898,27899],false],[0,0,0,"w",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"z",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[236,280,0,null,null,null,[27901,27902,27903],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[236,291,0,null,null,null,[27905],false],[0,0,0,"str",null,"",null,false],[236,335,0,null,null,null,[27907,27908],false],[0,0,0,"str",null,"",null,false],[0,0,0,"seed",null,"",null,false],[236,339,0,null,null,null,[27910,27911,27912],false],[0,0,0,"str",null,"",null,false],[0,0,0,"seed0",null,"",null,false],[0,0,0,"seed1",null,"",null,false],[236,344,0,null,null,null,[27914,27915],false],[0,0,0,"str",null,"",null,false],[0,0,0,"seed",null,"",null,false],[236,349,0,null,null,null,null,false],[228,28,0,null,null,null,null,false],[228,29,0,null,null,null,null,false],[228,31,0,null,null,null,null,false],[0,0,0,"hash/wyhash.zig",null,"",[],false],[237,0,0,null,null,null,null,false],[237,2,0,null,null,null,[27959,27960,27962,27963,27965,27966],false],[237,3,0,null,null,null,null,false],[237,18,0,null,null,null,[27925],false],[0,0,0,"seed",null,"",null,false],[237,36,0,null,null,null,[27927,27928],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[237,67,0,null,null,null,[27930],false],[0,0,0,"self",null,"",null,false],[237,94,0,null,null,null,[27932],false],[0,0,0,"self",null,"",null,false],[237,105,0,null,null,null,[27934,27935],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[237,122,0,null,null,null,[27937,27938],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[237,130,0,null,null,null,[27940,27941],false],[0,0,0,"bytes",null,"",null,true],[0,0,0,"data",null,"",null,false],[237,136,0,null,null,null,[27943,27944],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[237,142,0,null,null,null,[27946,27947],false],[0,0,0,"a_",null,"",null,false],[0,0,0,"b_",null,"",null,false],[237,149,0,null,null,null,[27949],false],[0,0,0,"self",null,"",null,false],[237,156,0,null,null,null,[27951,27952,27953],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input_lb",null,"",null,false],[0,0,0,"start_pos",null,"",null,false],[237,170,0,null,null,null,[27955],false],[0,0,0,"self",null,"",null,false],[237,177,0,null,null,null,[27957,27958],false],[0,0,0,"seed",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[237,2,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"total_len",null,null,null,false],[237,2,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[237,198,0,null,null,null,null,false],[237,199,0,null,null,null,null,false],[237,201,0,null,null,null,[27970,27971,27973],false],[0,0,0,"expected",null,null,null,false],[0,0,0,"seed",null,null,null,false],[237,201,0,null,null,null,null,false],[0,0,0,"input",null,null,null,false],[237,208,0,null,null,null,null,false],[228,32,0,null,null,null,null,false],[228,34,0,null,null,null,null,false],[0,0,0,"hash/xxhash.zig",null,"",[],false],[238,0,0,null,null,null,null,false],[238,1,0,null,null,null,null,false],[238,2,0,null,null,null,null,false],[238,4,0,null,null,null,null,false],[238,6,0,null,null,null,[28040,28041,28043,28044,28045],false],[238,13,0,null,null,null,null,false],[238,14,0,null,null,null,null,false],[238,15,0,null,null,null,null,false],[238,16,0,null,null,null,null,false],[238,17,0,null,null,null,null,false],[238,19,0,null,null,null,[28003,28004,28005,28006],false],[238,25,0,null,null,null,[27990],false],[0,0,0,"seed",null,"",null,false],[238,34,0,null,null,null,[27992,27993,27994],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"unroll_count",null,"",null,true],[238,53,0,null,null,null,[27996,27997],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[238,60,0,null,null,null,[27999],false],[0,0,0,"self",null,"",null,false],[238,70,0,null,null,null,[28001,28002],false],[0,0,0,"acc",null,"",null,false],[0,0,0,"other",null,"",null,false],[0,0,0,"acc1",null,null,null,false],[0,0,0,"acc2",null,null,null,false],[0,0,0,"acc3",null,null,null,false],[0,0,0,"acc4",null,null,null,false],[238,77,0,null,null,null,[28008,28009,28010],false],[0,0,0,"unfinished",null,"",null,false],[0,0,0,"byte_count",null,"",null,false],[0,0,0,"partial",null,"",null,false],[238,138,0,null,null,null,[28012,28013],false],[0,0,0,"v",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[238,147,0,null,null,null,[28015,28016],false],[0,0,0,"v",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[238,156,0,null,null,null,[28018,28019],false],[0,0,0,"v",null,"",null,false],[0,0,0,"byte",null,"",null,false],[238,164,0,null,null,null,[28021],false],[0,0,0,"value",null,"",null,false],[238,174,0,null,null,null,[28023],false],[0,0,0,"seed",null,"",null,false],[238,184,0,null,null,null,[28025,28026],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[238,210,0,null,null,null,[28028,28029],false],[0,0,0,"acc",null,"",null,false],[0,0,0,"lane",null,"",null,false],[238,216,0,null,null,null,[28031],false],[0,0,0,"self",null,"",null,false],[238,225,0,null,null,null,[28033,28034,28035],false],[0,0,0,"small",null,null,null,false],[0,0,0,"large",null,null,null,false],[0,0,0,"unknown",null,null,null,false],[238,231,0,null,null,null,[28037,28038],false],[0,0,0,"seed",null,"",null,false],[0,0,0,"input",null,"",null,false],[238,6,0,null,null,null,null,false],[0,0,0,"accumulator",null,null,null,false],[0,0,0,"seed",null,null,null,false],[238,6,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[0,0,0,"byte_count",null,null,null,false],[238,244,0,null,null,null,[28094,28095,28097,28098,28099],false],[238,251,0,null,null,null,null,false],[238,252,0,null,null,null,null,false],[238,253,0,null,null,null,null,false],[238,254,0,null,null,null,null,false],[238,255,0,null,null,null,null,false],[238,257,0,null,null,null,[28064,28065,28066,28067],false],[238,263,0,null,null,null,[28054],false],[0,0,0,"seed",null,"",null,false],[238,272,0,null,null,null,[28056,28057,28058],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"unroll_count",null,"",null,true],[238,291,0,null,null,null,[28060,28061],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[238,298,0,null,null,null,[28063],false],[0,0,0,"self",null,"",null,false],[0,0,0,"acc1",null,null,null,false],[0,0,0,"acc2",null,null,null,false],[0,0,0,"acc3",null,null,null,false],[0,0,0,"acc4",null,null,null,false],[238,304,0,null,null,null,[28069],false],[0,0,0,"seed",null,"",null,false],[238,314,0,null,null,null,[28071,28072],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[238,341,0,null,null,null,[28074,28075],false],[0,0,0,"acc",null,"",null,false],[0,0,0,"lane",null,"",null,false],[238,347,0,null,null,null,[28077],false],[0,0,0,"self",null,"",null,false],[238,356,0,null,null,null,[28079,28080,28081],false],[0,0,0,"unfinished",null,"",null,false],[0,0,0,"byte_count",null,"",null,false],[0,0,0,"partial",null,"",null,false],[238,389,0,null,null,null,[28083,28084],false],[0,0,0,"v",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[238,397,0,null,null,null,[28086,28087],false],[0,0,0,"v",null,"",null,false],[0,0,0,"byte",null,"",null,false],[238,405,0,null,null,null,[28089],false],[0,0,0,"value",null,"",null,false],[238,415,0,null,null,null,[28091,28092],false],[0,0,0,"seed",null,"",null,false],[0,0,0,"input",null,"",null,false],[238,244,0,null,null,null,null,false],[0,0,0,"accumulator",null,null,null,false],[0,0,0,"seed",null,null,null,false],[238,244,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"buf_len",null,null,null,false],[0,0,0,"byte_count",null,null,null,false],[238,428,0,null,null,null,[28101],false],[0,0,0,"T",null,"",null,true],[238,440,0,null,null,null,null,false],[238,442,0,null,null,null,[28104,28105,28106,28107],false],[0,0,0,"H",null,"",null,true],[0,0,0,"seed",null,"",null,false],[0,0,0,"input",null,"",null,false],[0,0,0,"expected",null,"",null,false],[228,35,0,null,null,null,null,false],[228,36,0,null,null,null,null,false],[228,42,0,null,null," This is handy if you have a u32 and want a u32 and don't want to take a\n detour through many layers of abstraction elsewhere in the std.hash\n namespace.\n Copied from https://nullprogram.com/blog/2018/07/31/",[28111],false],[0,0,0,"input",null,"",null,false],[1,110,0,null,null,null,null,false],[0,0,0,"hash_map.zig",null,"",[],false],[239,0,0,null,null,null,null,false],[239,1,0,null,null,null,null,false],[239,2,0,null,null,null,null,false],[239,3,0,null,null,null,null,false],[239,4,0,null,null,null,null,false],[239,5,0,null,null,null,null,false],[239,6,0,null,null,null,null,false],[239,7,0,null,null,null,null,false],[239,8,0,null,null,null,null,false],[239,9,0,null,null,null,null,false],[239,11,0,null,null,null,[28125,28126],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",[28127,28128],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[239,37,0,null,null,null,[28130,28131],false],[0,0,0,"K",null,"",null,true],[0,0,0,"Context",null,"",[28132,28133,28134],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[239,46,0,null,null,null,[28136,28137],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[239,50,0,null,null,null,[28139,28140],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[239,54,0,null,null,null,[28142],false],[0,0,0,"K",null,"",[],true],[239,56,0,null,null,null,null,false],[239,57,0,null,null,null,null,false],[239,64,0,null,null," Builtin hashmap for strings as keys.\n Key memory is managed by the caller.  Keys and values\n will not automatically be freed.",[28146],false],[0,0,0,"V",null,"",null,true],[239,70,0,null,null," Key memory is managed by the caller.  Keys and values\n will not automatically be freed.",[28148],false],[0,0,0,"V",null,"",null,true],[239,74,0,null,null,null,[],false],[239,75,0,null,null,null,[28151,28152],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[239,79,0,null,null,null,[28154,28155,28156],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[239,85,0,null,null,null,[28158,28159],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[239,89,0,null,null,null,[28161],false],[0,0,0,"s",null,"",null,false],[239,93,0,null,null,null,[28171],false],[239,96,0,null,null,null,[28164,28165,28166],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[239,101,0,null,null,null,[28168,28169],false],[0,0,0,"self",null,"",null,false],[0,0,0,"x",null,"",null,false],[239,93,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[239,107,0,null,null,null,[28181],false],[239,110,0,null,null,null,[28174,28175,28176],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a_slice",null,"",null,false],[0,0,0,"b",null,"",null,false],[239,115,0,null,null,null,[28178,28179],false],[0,0,0,"self",null,"",null,false],[0,0,0,"adapted_key",null,"",null,false],[239,107,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[239,121,0,null,null,null,null,false],[239,131,0,null,null," This function issues a compile error with a helpful message if there\n is a problem with the provided context type.  A context must have the following\n member functions:\n   - hash(self, PseudoKey) Hash\n   - eql(self, PseudoKey, Key) bool\n If you are passing a context to a *Adapted function, PseudoKey is the type\n of the key parameter.  Otherwise, when creating a HashMap or HashMapUnmanaged\n type, PseudoKey = Key = K.",[28184,28185,28186,28187,28188],false],[0,0,0,"RawContext",null,"",null,true],[0,0,0,"PseudoKey",null,"",null,true],[0,0,0,"Key",null,"",null,true],[0,0,0,"Hash",null,"",null,true],[0,0,0,"is_array",null,"",null,true],[239,363,0,null,null," General purpose hash table.\n No order is guaranteed and any modification invalidates live iterators.\n It provides fast operations (lookup, insertion, deletion) with quite high\n load factors (up to 80% by default) for low memory usage.\n For a hash map that can be initialized directly that does not store an Allocator\n field, see `HashMapUnmanaged`.\n If iterating over the table entries is a strong usecase and needs to be fast,\n prefer the alternative `std.ArrayHashMap`.\n Context must be a struct type with two member functions:\n   hash(self, K) u64\n   eql(self, K, K) bool\n Adapted variants of many functions are provided.  These variants\n take a pseudo key instead of a key.  Their context must have the functions:\n   hash(self, PseudoKey) u64\n   eql(self, PseudoKey, K) bool",[28190,28191,28192,28193],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"max_load_percentage",null,"",[28347,28349,28351],true],[239,379,0,null,null," The type of the unmanaged hash map underlying this wrapper",null,false],[239,381,0,null,null," An entry, containing pointers to a key and value stored in the map",null,false],[239,383,0,null,null," A copy of a key and value which are no longer in the map",null,false],[239,385,0,null,null," The integer type that is the result of hashing",null,false],[239,387,0,null,null," The iterator type returned by iterator()",null,false],[239,389,0,null,null,null,null,false],[239,390,0,null,null,null,null,false],[239,393,0,null,null," The integer type used to store the size of the map",null,false],[239,395,0,null,null," The type returned from getOrPut and variants",null,false],[239,397,0,null,null,null,null,false],[239,402,0,null,null," Create a managed hash map with an empty context.\n If the context is not zero-sized, you must use\n initContext(allocator, ctx) instead.",[28205],false],[0,0,0,"allocator",null,"",null,false],[239,414,0,null,null," Create a managed hash map with a context",[28207,28208],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,426,0,null,null," Release the backing array and invalidate this map.\n This does *not* deinit keys, values, or the context!\n If your keys or values need to be released, ensure\n that that is done before calling this function.",[28210],false],[0,0,0,"self",null,"",null,false],[239,435,0,null,null," Empty the map, but keep the backing allocation for future use.\n This does *not* free keys or values! Be sure to\n release them if they need deinitialization before\n calling this function.",[28212],false],[0,0,0,"self",null,"",null,false],[239,443,0,null,null," Empty the map and release the backing allocation.\n This does *not* free keys or values! Be sure to\n release them if they need deinitialization before\n calling this function.",[28214],false],[0,0,0,"self",null,"",null,false],[239,448,0,null,null," Return the number of items in the map.",[28216],false],[0,0,0,"self",null,"",null,false],[239,454,0,null,null," Create an iterator over the entries in the map.\n The iterator is invalidated if the map is modified.",[28218],false],[0,0,0,"self",null,"",null,false],[239,460,0,null,null," Create an iterator over the keys in the map.\n The iterator is invalidated if the map is modified.",[28220],false],[0,0,0,"self",null,"",null,false],[239,466,0,null,null," Create an iterator over the values in the map.\n The iterator is invalidated if the map is modified.",[28222],false],[0,0,0,"self",null,"",null,false],[239,476,0,null,null," If key exists this function cannot fail.\n If there is an existing item with `key`, then the result\n `Entry` pointers point to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointers point to it. Caller should then initialize\n the value (but not the key).",[28224,28225],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,486,0,null,null," If key exists this function cannot fail.\n If there is an existing item with `key`, then the result\n `Entry` pointers point to it, and found_existing is true.\n Otherwise, puts a new item with undefined key and value, and\n the `Entry` pointers point to it. Caller must then initialize\n the key and value.",[28227,28228,28229],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,497,0,null,null," If there is an existing item with `key`, then the result\n `Entry` pointers point to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointers point to it. Caller should then initialize\n the value (but not the key).\n If a new entry needs to be stored, this function asserts there\n is enough capacity to store it.",[28231,28232],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,508,0,null,null," If there is an existing item with `key`, then the result\n `Entry` pointers point to it, and found_existing is true.\n Otherwise, puts a new item with undefined value, and\n the `Entry` pointers point to it. Caller must then initialize\n the key and value.\n If a new entry needs to be stored, this function asserts there\n is enough capacity to store it.",[28234,28235,28236],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,512,0,null,null,null,[28238,28239,28240],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,518,0,null,null," Increases capacity, guaranteeing that insertions up until the\n `expected_count` will not cause an allocation, and therefore cannot fail.",[28242,28243],false],[0,0,0,"self",null,"",null,false],[0,0,0,"expected_count",null,"",null,false],[239,525,0,null,null," Increases capacity, guaranteeing that insertions up until\n `additional_count` **more** items will not cause an allocation, and\n therefore cannot fail.",[28245,28246],false],[0,0,0,"self",null,"",null,false],[0,0,0,"additional_count",null,"",null,false],[239,531,0,null,null," Returns the number of total elements which may be present before it is\n no longer guaranteed that no allocations will be performed.",[28248],false],[0,0,0,"self",null,"",null,false],[239,537,0,null,null," Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPut`.",[28250,28251,28252],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,543,0,null,null," Inserts a key-value pair into the hash map, asserting that no previous\n entry with the same key is already present",[28254,28255,28256],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,550,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPutAssumeCapacity`.",[28258,28259,28260],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,557,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Asserts that it does not clobber any existing data.\n To detect if a put would clobber existing data, see `getOrPutAssumeCapacity`.",[28262,28263,28264],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,562,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.",[28266,28267,28268],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,568,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.\n If insertion happuns, asserts there is enough capacity without allocating.",[28270,28271,28272],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,573,0,null,null," Removes a value from the map and returns the removed kv pair.",[28274,28275],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,577,0,null,null,null,[28277,28278,28279],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,582,0,null,null," Finds the value associated with a key in the map",[28281,28282],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,585,0,null,null,null,[28284,28285,28286],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,589,0,null,null,null,[28288,28289],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,592,0,null,null,null,[28291,28292,28293],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,597,0,null,null," Finds the actual key associated with an adapted key in the map",[28295,28296],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,600,0,null,null,null,[28298,28299,28300],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,604,0,null,null,null,[28302,28303],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,607,0,null,null,null,[28305,28306,28307],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,612,0,null,null," Finds the key and value associated with a key in the map",[28309,28310],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,616,0,null,null,null,[28312,28313,28314],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,621,0,null,null," Check if the map contains a key",[28316,28317],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,625,0,null,null,null,[28319,28320,28321],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,632,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and this function returns true.  Otherwise this\n function returns false.",[28323,28324],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,636,0,null,null,null,[28326,28327,28328],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,643,0,null,null," Delete the entry with key pointed to by key_ptr from the hash map.\n key_ptr is assumed to be a valid pointer to a key that is present\n in the hash map.",[28330,28331],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key_ptr",null,"",null,false],[239,648,0,null,null," Creates a copy of this map, using the same allocator",[28333],false],[0,0,0,"self",null,"",null,false],[239,654,0,null,null," Creates a copy of this map, using a specified allocator",[28335,28336],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_allocator",null,"",null,false],[239,660,0,null,null," Creates a copy of this map, using a specified context",[28338,28339],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_ctx",null,"",null,false],[239,666,0,null,null," Creates a copy of this map, using a specified allocator and context.",[28341,28342,28343],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_allocator",null,"",null,false],[0,0,0,"new_ctx",null,"",null,false],[239,677,0,null,null," Set the map to an empty state, making deinitialization a no-op, and\n returning a copy of the original.",[28345],false],[0,0,0,"self",null,"",null,false],[239,369,0,null,null,null,null,false],[0,0,0,"unmanaged",null,null,null,false],[239,369,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[239,369,0,null,null,null,null,false],[0,0,0,"ctx",null,null,null,false],[239,694,0,null,null," A HashMap based on open addressing and linear probing.\n A lookup or modification typically occurs only 2 cache misses.\n No order is guaranteed and any modification invalidates live iterators.\n It achieves good performance with quite high load factors (by default,\n grow is triggered at 80% full) and only one byte of overhead per element.\n The struct itself is only 16 bytes for a small footprint. This comes at\n the price of handling size with u32, which should be reasonable enough\n for almost all uses.\n Deletions are achieved with tombstones.",[28353,28354,28355,28356],false],[0,0,0,"K",null,"",null,true],[0,0,0,"V",null,"",null,true],[0,0,0,"Context",null,"",null,true],[0,0,0,"max_load_percentage",null,"",[28714,28716,28718],true],[239,703,0,null,null,null,null,false],[239,730,0,null,null," Capacity of the first grow when bootstrapping the hashmap.",null,false],[239,733,0,null,null,null,null,false],[239,737,0,null,null,null,null,false],[239,739,0,null,null,null,[28363,28365],false],[239,739,0,null,null,null,null,false],[0,0,0,"key_ptr",null,null,null,false],[239,739,0,null,null,null,null,false],[0,0,0,"value_ptr",null,null,null,false],[239,744,0,null,null,null,[28368,28370],false],[239,744,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[239,744,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[239,749,0,null,null,null,[28373,28375,28377],false],[239,749,0,null,null,null,null,false],[0,0,0,"values",null,null,null,false],[239,749,0,null,null,null,null,false],[0,0,0,"keys",null,null,null,false],[239,749,0,null,null,null,null,false],[0,0,0,"capacity",null,null,null,false],[239,769,0,null,null," Metadata for a slot. It can be in three states: empty, used or\n tombstone. Tombstones indicate that an entry was previously used,\n they are a simple way to handle removal.\n To this state, we add 7 bits from the slot's key hash. These are\n used as a fast way to disambiguate between entries without\n having to use the equality function. If two fingerprints are\n different, we know that we don't have to compare the keys at all.\n The 7 bits are the highest ones from a 64 bit hash. This way, not\n only we use the `log2(capacity)` lowest bits from the hash to determine\n a slot index, but we use 7 more bits to quickly resolve collisions\n when multiple elements with different hashes end up wanting to be in the same slot.\n Not using the equality function means we don't have to read into\n the entries array, likely avoiding a cache miss and a potentially\n costly function call.",[28398,28399],false],[239,770,0,null,null,null,null,false],[239,772,0,null,null,null,null,false],[239,773,0,null,null,null,null,false],[239,778,0,null,null,null,null,false],[239,779,0,null,null,null,null,false],[239,781,0,null,null,null,[28385],false],[0,0,0,"self",null,"",null,false],[239,785,0,null,null,null,[28387],false],[0,0,0,"self",null,"",null,false],[239,789,0,null,null,null,[28389],false],[0,0,0,"self",null,"",null,false],[239,793,0,null,null,null,[28391],false],[0,0,0,"hash",null,"",null,false],[239,799,0,null,null,null,[28393,28394],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fp",null,"",null,false],[239,804,0,null,null,null,[28396],false],[0,0,0,"self",null,"",null,false],[239,769,0,null,null,null,null,false],[0,0,0,"fingerprint",null,null,null,false],[0,0,0,"used",null,null,null,false],[239,815,0,null,null,null,[28404,28406],false],[239,819,0,null,null,null,[28402],false],[0,0,0,"it",null,"",null,false],[239,815,0,null,null,null,null,false],[0,0,0,"hm",null,null,null,false],[239,815,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[239,843,0,null,null,null,null,false],[239,844,0,null,null,null,null,false],[239,846,0,null,null,null,[28410],false],[0,0,0,"T",null,"",[28413,28415,28417],true],[239,852,0,null,null,null,[28412],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,null,null,false],[239,847,0,null,null,null,null,false],[0,0,0,"metadata",null,null,null,false],[239,847,0,null,null,null,null,false],[0,0,0,"items",null,null,null,false],[239,868,0,null,null,null,[28420,28422,28423],false],[239,868,0,null,null,null,null,false],[0,0,0,"key_ptr",null,null,null,false],[239,868,0,null,null,null,null,false],[0,0,0,"value_ptr",null,null,null,false],[0,0,0,"found_existing",null,null,null,false],[239,874,0,null,null,null,null,false],[239,876,0,null,null,null,[28426,28427],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[239,882,0,null,null,null,[28429,28430,28431],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,890,0,null,null,null,[28433,28434],false],[0,0,0,"size",null,"",null,false],[0,0,0,"cap",null,"",null,false],[239,894,0,null,null,null,[28436,28437],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[239,899,0,null,null,null,[28439],false],[0,0,0,"size",null,"",null,false],[239,905,0,null,null,null,[28441,28442,28443],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_size",null,"",null,false],[239,910,0,null,null,null,[28445,28446,28447,28448],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_size",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,915,0,null,null,null,[28450,28451,28452],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"additional_size",null,"",null,false],[239,920,0,null,null,null,[28454,28455,28456,28457],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"additional_size",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,924,0,null,null,null,[28459],false],[0,0,0,"self",null,"",null,false],[239,932,0,null,null,null,[28461,28462],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[239,938,0,null,null,null,[28464],false],[0,0,0,"self",null,"",null,false],[239,942,0,null,null,null,[28466],false],[0,0,0,"self",null,"",null,false],[239,946,0,null,null,null,[28468],false],[0,0,0,"self",null,"",null,false],[239,950,0,null,null,null,[28470],false],[0,0,0,"self",null,"",null,false],[239,954,0,null,null,null,[28472],false],[0,0,0,"self",null,"",null,false],[239,960,0,null,null,null,[28474],false],[0,0,0,"self",null,"",null,false],[239,964,0,null,null,null,[28476],false],[0,0,0,"self",null,"",null,false],[239,980,0,null,null,null,[28478],false],[0,0,0,"self",null,"",null,false],[239,997,0,null,null," Insert an entry in the map. Assumes it is not already present.",[28480,28481,28482,28483],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1002,0,null,null,null,[28485,28486,28487,28488,28489],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1012,0,null,null," Asserts there is enough capacity to store the new key-value pair.\n Clobbers any existing data. To detect if a put would clobber\n existing data, see `getOrPutAssumeCapacity`.",[28491,28492,28493],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1017,0,null,null,null,[28495,28496,28497,28498],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1024,0,null,null," Insert an entry in the map. Assumes it is not already present,\n and that no allocation is needed.",[28500,28501,28502],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1029,0,null,null,null,[28504,28505,28506,28507],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1054,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.",[28509,28510,28511,28512],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1059,0,null,null,null,[28514,28515,28516,28517,28518],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1074,0,null,null," Inserts a new `Entry` into the hash map, returning the previous one, if any.\n If insertion happens, asserts there is enough capacity without allocating.",[28520,28521,28522],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1079,0,null,null,null,[28524,28525,28526,28527],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1094,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and then returned from this function.",[28529,28530],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1099,0,null,null,null,[28532,28533,28534],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1102,0,null,null,null,[28536,28537,28538],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1129,0,null,null," Find the index containing the data for the given key.\n Whether this function returns null is almost always\n branched on after this function returns, and this function\n returns null/not null from separate code paths.  We\n want the optimizer to remove that branch and instead directly\n fuse the basic blocks after the branch to the basic blocks\n from this function.  To encourage that, this function is\n marked as inline.",[28540,28541,28542],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1175,0,null,null,null,[28544,28545],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1180,0,null,null,null,[28547,28548,28549],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1183,0,null,null,null,[28551,28552,28553],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1194,0,null,null," Insert an entry if the associated key is not already present, otherwise update preexisting value.",[28555,28556,28557,28558],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1199,0,null,null,null,[28560,28561,28562,28563,28564],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1205,0,null,null," Get an optional pointer to the actual key associated with adapted key, if present.",[28566,28567],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1210,0,null,null,null,[28569,28570,28571],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1213,0,null,null,null,[28573,28574,28575],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1221,0,null,null," Get a copy of the actual key associated with adapted key, if present.",[28577,28578],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1226,0,null,null,null,[28580,28581,28582],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1229,0,null,null,null,[28584,28585,28586],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1237,0,null,null," Get an optional pointer to the value associated with key, if present.",[28588,28589],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1242,0,null,null,null,[28591,28592,28593],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1245,0,null,null,null,[28595,28596,28597],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1253,0,null,null," Get a copy of the value associated with key, if present.",[28599,28600],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1258,0,null,null,null,[28602,28603,28604],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1261,0,null,null,null,[28606,28607,28608],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1268,0,null,null,null,[28610,28611,28612],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1273,0,null,null,null,[28614,28615,28616,28617],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1280,0,null,null,null,[28619,28620,28621,28622],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[239,1285,0,null,null,null,[28624,28625,28626,28627,28628],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"key_ctx",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1300,0,null,null,null,[28630,28631],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1305,0,null,null,null,[28633,28634,28635],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1312,0,null,null,null,[28637,28638,28639],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1379,0,null,null,null,[28641,28642,28643,28644],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[239,1384,0,null,null,null,[28646,28647,28648,28649,28650],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1394,0,null,null," Return true if there is a value associated with key in the map.",[28652,28653],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1399,0,null,null,null,[28655,28656,28657],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1402,0,null,null,null,[28659,28660,28661],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1406,0,null,null,null,[28663,28664],false],[0,0,0,"self",null,"",null,false],[0,0,0,"idx",null,"",null,false],[239,1417,0,null,null," If there is an `Entry` with a matching key, it is deleted from\n the hash map, and this function returns true.  Otherwise this\n function returns false.",[28666,28667],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[239,1422,0,null,null,null,[28669,28670,28671],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1425,0,null,null,null,[28673,28674,28675],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1437,0,null,null," Delete the entry with key pointed to by key_ptr from the hash map.\n key_ptr is assumed to be a valid pointer to a key that is present\n in the hash map.",[28677,28678],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key_ptr",null,"",null,false],[239,1450,0,null,null,null,[28680],false],[0,0,0,"self",null,"",null,false],[239,1456,0,null,null,null,[28682],false],[0,0,0,"self",null,"",null,false],[239,1462,0,null,null,null,[28684,28685,28686,28687],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_count",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1468,0,null,null,null,[28689,28690],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[239,1473,0,null,null,null,[28692,28693,28694],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_ctx",null,"",null,false],[239,1500,0,null,null," Set the map to an empty state, making deinitialization a no-op, and\n returning a copy of the original.",[28696],false],[0,0,0,"self",null,"",null,false],[239,1506,0,null,null,null,[28698,28699,28700,28701],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[239,1537,0,null,null,null,[28703,28704,28705],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"new_capacity",null,"",null,false],[239,1570,0,null,null,null,[28707,28708],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[239,1599,0,null,null," This function is used in the debugger pretty formatters in tools/ to fetch the\n header type to facilitate fancy debug printing for this type.",[28710,28711,28712],false],[0,0,0,"self",null,"",null,false],[0,0,0,"hdr",null,"",null,false],[0,0,0,"entry",null,"",null,false],[239,702,0,null,null,null,null,false],[0,0,0,"metadata",null," Pointer to the metadata.",null,false],[239,702,0,null,null,null,null,false],[0,0,0,"size",null," Current number of elements in the hashmap.",null,false],[239,702,0,null,null,null,null,false],[0,0,0,"available",null," Number of available slots before a grow is needed to satisfy the\n `max_load_percentage`.",null,false],[239,1613,0,null,null,null,null,false],[239,1614,0,null,null,null,null,false],[239,1615,0,null,null,null,null,false],[1,113,0,null,null," Allocator implementations.",null,false],[0,0,0,"heap.zig",null,"",[],false],[240,0,0,null,null,null,null,false],[240,1,0,null,null,null,null,false],[240,2,0,null,null,null,null,false],[240,3,0,null,null,null,null,false],[240,4,0,null,null,null,null,false],[240,5,0,null,null,null,null,false],[240,6,0,null,null,null,null,false],[240,7,0,null,null,null,null,false],[240,8,0,null,null,null,null,false],[240,10,0,null,null,null,null,false],[0,0,0,"heap/logging_allocator.zig",null,"",[],false],[241,0,0,null,null,null,null,false],[241,1,0,null,null,null,null,false],[241,6,0,null,null," This allocator is used in front of another allocator and logs to `std.log`\n on every call to the allocator.\n For logging to a `std.io.Writer` see `std.heap.LogToWriterAllocator`",[28738,28739],false],[0,0,0,"success_log_level",null,"",null,true],[0,0,0,"failure_log_level",null,"",null,true],[241,16,0,null,null," This allocator is used in front of another allocator and logs to `std.log`\n with the given scope on every call to the allocator.\n For logging to a `std.io.Writer` see `std.heap.LogToWriterAllocator`",[28741,28742,28743],false],[0,0,0,"scope",null,"",null,true],[0,0,0,"success_log_level",null,"",null,true],[0,0,0,"failure_log_level",null,"",[28770],true],[241,26,0,null,null,null,null,false],[241,28,0,null,null,null,[28746],false],[0,0,0,"parent_allocator",null,"",null,false],[241,34,0,null,null,null,[28748],false],[0,0,0,"self",null,"",null,false],[241,46,0,null,null,null,[28750,28751,28752],false],[0,0,0,"log_level",null,"",null,true],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[241,55,0,null,null,null,[28754,28755,28756,28757],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[241,79,0,null,null,null,[28759,28760,28761,28762,28763],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ra",null,"",null,false],[241,114,0,null,null,null,[28765,28766,28767,28768],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[241,23,0,null,null,null,null,false],[0,0,0,"parent_allocator",null,null,null,false],[241,130,0,null,null," This allocator is used in front of another allocator and logs to `std.log`\n on every call to the allocator.\n For logging to a `std.io.Writer` see `std.heap.LogToWriterAllocator`",[28772],false],[0,0,0,"parent_allocator",null,"",null,false],[240,11,0,null,null,null,null,false],[240,12,0,null,null,null,null,false],[240,13,0,null,null,null,null,false],[0,0,0,"heap/log_to_writer_allocator.zig",null,"",[],false],[242,0,0,null,null,null,null,false],[242,1,0,null,null,null,null,false],[242,5,0,null,null," This allocator is used in front of another allocator and logs to the provided writer\n on every call to the allocator. Writer errors are ignored.",[28780],false],[0,0,0,"Writer",null,"",[28804,28806],true],[242,10,0,null,null,null,null,false],[242,12,0,null,null,null,[28783,28784],false],[0,0,0,"parent_allocator",null,"",null,false],[0,0,0,"writer",null,"",null,false],[242,19,0,null,null,null,[28786],false],[0,0,0,"self",null,"",null,false],[242,30,0,null,null,null,[28788,28789,28790,28791],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[242,47,0,null,null,null,[28793,28794,28795,28796,28797],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ra",null,"",null,false],[242,73,0,null,null,null,[28799,28800,28801,28802],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[242,6,0,null,null,null,null,false],[0,0,0,"parent_allocator",null,null,null,false],[242,6,0,null,null,null,null,false],[0,0,0,"writer",null,null,null,false],[242,88,0,null,null," This allocator is used in front of another allocator and logs to the provided writer\n on every call to the allocator. Writer errors are ignored.",[28808,28809],false],[0,0,0,"parent_allocator",null,"",null,false],[0,0,0,"writer",null,"",null,false],[240,14,0,null,null,null,null,false],[240,15,0,null,null,null,null,false],[0,0,0,"heap/arena_allocator.zig",null,"",[],false],[243,0,0,null,null,null,null,false],[243,1,0,null,null,null,null,false],[243,2,0,null,null,null,null,false],[243,3,0,null,null,null,null,false],[243,7,0,null,null," This allocator takes an existing allocator, wraps it, and provides an interface\n where you can allocate without freeing, and then free it all together.",[28862,28864],false],[243,13,0,null,null," Inner state of ArenaAllocator. Can be stored rather than the entire ArenaAllocator\n as a memory-saving optimization.",[28823,28824],false],[243,17,0,null,null,null,[28820,28821],false],[0,0,0,"self",null,"",null,false],[0,0,0,"child_allocator",null,"",null,false],[243,13,0,null,null,null,null,false],[0,0,0,"buffer_list",null,null,null,false],[0,0,0,"end_index",null,null,null,false],[243,25,0,null,null,null,[28826],false],[0,0,0,"self",null,"",null,false],[243,36,0,null,null,null,null,false],[243,38,0,null,null,null,[28829],false],[0,0,0,"child_allocator",null,"",null,false],[243,42,0,null,null,null,[28831],false],[0,0,0,"self",null,"",null,false],[243,56,0,null,null,null,[28833,28834,28835],false],[0,0,0,"free_all",null," Releases all allocated memory in the arena.",null,false],[0,0,0,"retain_capacity",null," This will pre-heat the arena for future allocations by allocating a\n large enough buffer for all previously done allocations.\n Preheating will speed up the allocation process by invoking the backing allocator\n less often than before. If `reset()` is used in a loop, this means that after the\n biggest operation, no memory allocations are performed anymore.",null,false],[0,0,0,"retain_with_limit",null," This is the same as `retain_capacity`, but the memory will be shrunk to\n this value if it exceeds the limit.",null,false],[243,71,0,null,null," Queries the current memory use of this arena.\n This will **not** include the storage required for internal keeping.",[28837],false],[0,0,0,"self",null,"",null,false],[243,92,0,null,null," Resets the arena allocator and frees all allocated memory.\n\n `mode` defines how the currently allocated memory is handled.\n See the variant documentation for `ResetMode` for the effects of each mode.\n\n The function will return whether the reset operation was successful or not.\n If the reallocation  failed `false` is returned. The arena will still be fully\n functional in that case, all memory is released. Future allocations just might\n be slower.\n\n NOTE: If `mode` is `free_mode`, the function will always return `true`.",[28839,28840],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mode",null,"",null,false],[243,161,0,null,null,null,[28842,28843,28844],false],[0,0,0,"self",null,"",null,false],[0,0,0,"prev_len",null,"",null,false],[0,0,0,"minimum_size",null,"",null,false],[243,175,0,null,null,null,[28846,28847,28848,28849],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[243,209,0,null,null,null,[28851,28852,28853,28854,28855],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[243,233,0,null,null,null,[28857,28858,28859,28860],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[243,7,0,null,null,null,null,false],[0,0,0,"child_allocator",null,null,null,false],[243,7,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[240,16,0,null,null,null,null,false],[0,0,0,"heap/general_purpose_allocator.zig",null," # General Purpose Allocator\n\n ## Design Priorities\n\n ### `OptimizationMode.debug` and `OptimizationMode.release_safe`:\n\n  * Detect double free, and emit stack trace of:\n    - Where it was first allocated\n    - Where it was freed the first time\n    - Where it was freed the second time\n\n  * Detect leaks and emit stack trace of:\n    - Where it was allocated\n\n  * When a page of memory is no longer needed, give it back to resident memory\n    as soon as possible, so that it causes page faults when used.\n\n  * Do not re-use memory slots, so that memory safety is upheld. For small\n    allocations, this is handled here; for larger ones it is handled in the\n    backing allocator (by default `std.heap.page_allocator`).\n\n  * Make pointer math errors unlikely to harm memory from\n    unrelated allocations.\n\n  * It's OK for these mechanisms to cost some extra overhead bytes.\n\n  * It's OK for performance cost for these mechanisms.\n\n  * Rogue memory writes should not harm the allocator's state.\n\n  * Cross platform. Operates based on a backing allocator which makes it work\n    everywhere, even freestanding.\n\n  * Compile-time configuration.\n\n ### `OptimizationMode.release_fast` (note: not much work has gone into this use case yet):\n\n  * Low fragmentation is primary concern\n  * Performance of worst-case latency is secondary concern\n  * Performance of average-case latency is next\n  * Finally, having freed memory unmapped, and pointer math errors unlikely to\n    harm memory from unrelated allocations are nice-to-haves.\n\n ### `OptimizationMode.release_small` (note: not much work has gone into this use case yet):\n\n  * Small binary code size of the executable is the primary concern.\n  * Next, defer to the `.release_fast` priority list.\n\n ## Basic Design:\n\n Small allocations are divided into buckets:\n\n ```\n index obj_size\n 0     1\n 1     2\n 2     4\n 3     8\n 4     16\n 5     32\n 6     64\n 7     128\n 8     256\n 9     512\n 10    1024\n 11    2048\n ```\n\n The main allocator state has an array of all the \"current\" buckets for each\n size class. Each slot in the array can be null, meaning the bucket for that\n size class is not allocated. When the first object is allocated for a given\n size class, it allocates 1 page of memory from the OS. This page is\n divided into \"slots\" - one per allocated object. Along with the page of memory\n for object slots, as many pages as necessary are allocated to store the\n BucketHeader, followed by \"used bits\", and two stack traces for each slot\n (allocation trace and free trace).\n\n The \"used bits\" are 1 bit per slot representing whether the slot is used.\n Allocations use the data to iterate to find a free slot. Frees assert that the\n corresponding bit is 1 and set it to 0.\n\n Buckets have prev and next pointers. When there is only one bucket for a given\n size class, both prev and next point to itself. When all slots of a bucket are\n used, a new bucket is allocated, and enters the doubly linked list. The main\n allocator state tracks the \"current\" bucket for each size class. Leak detection\n currently only checks the current bucket.\n\n Resizing detects if the size class is unchanged or smaller, in which case the same\n pointer is returned unmodified. If a larger size class is required,\n `error.OutOfMemory` is returned.\n\n Large objects are allocated directly using the backing allocator and their metadata is stored\n in a `std.HashMap` using the backing allocator.\n",[],false],[244,94,0,null,null,null,null,false],[244,95,0,null,null,null,null,false],[244,96,0,null,null,null,null,false],[244,97,0,null,null,null,null,false],[244,98,0,null,null,null,null,false],[244,99,0,null,null,null,null,false],[244,100,0,null,null,null,null,false],[244,101,0,null,null,null,null,false],[244,102,0,null,null,null,null,false],[244,105,0,null,null," Integer type for pointing to slots in a small allocation",null,false],[244,107,0,null,null,null,null,false],[244,108,0,null,null,null,null,false],[244,109,0,null,null,null,null,false],[244,114,0,null,null,null,[28881,28882,28883,28884,28886,28887,28888,28889],false],[0,0,0,"stack_trace_frames",null," Number of stack frames to capture.",null,false],[0,0,0,"enable_memory_limit",null," If true, the allocator will have two fields:\n  * `total_requested_bytes` which tracks the total allocated bytes of memory requested.\n  * `requested_memory_limit` which causes allocations to return `error.OutOfMemory`\n    when the `total_requested_bytes` exceeds this limit.\n If false, these fields will be `void`.",null,false],[0,0,0,"safety",null," Whether to enable safety checks.",null,false],[0,0,0,"thread_safe",null," Whether the allocator may be used simultaneously from multiple threads.",null,false],[244,114,0,null,null,null,null,false],[0,0,0,"MutexType",null," What type of mutex you'd like to use, for thread safety.\n when specified, the mutex type must have the same shape as `std.Thread.Mutex` and\n `DummyMutex`, and have no required fields. Specifying this field causes\n the `thread_safe` field to be ignored.\n\n when null (default):\n * the mutex type defaults to `std.Thread.Mutex` when thread_safe is enabled.\n * the mutex type defaults to `DummyMutex` otherwise.",null,false],[0,0,0,"never_unmap",null," This is a temporary debugging trick you can use to turn segfaults into more helpful\n logged error messages with stack trace details. The downside is that every allocation\n will be leaked, unless used with retain_metadata!",null,false],[0,0,0,"retain_metadata",null," This is a temporary debugging aid that retains metadata about allocations indefinitely.\n This allows a greater range of double frees to be reported. All metadata is freed when\n deinit is called. When used with never_unmap, deliberately leaked memory is also freed\n during deinit. Currently should be used with never_unmap to avoid segfaults.\n TODO https://github.com/ziglang/zig/issues/4298 will allow use without never_unmap",null,false],[0,0,0,"verbose_log",null," Enables emitting info messages with the size and address of every allocation.",null,false],[244,157,0,null,null,null,[28891,28892],false],[0,0,0,"ok",null,null,null,false],[0,0,0,"leak",null,null,null,false],[244,159,0,null,null,null,[28894],false],[0,0,0,"config",null,"",[29047,29049,29051,29053,29055,29057,29059,29061],true],[244,422,0,null,null,null,null,false],[244,173,0,null,null,null,null,false],[244,175,0,null,null,null,null,false],[244,176,0,null,null,null,null,false],[244,178,0,null,null,null,null,false],[244,185,0,null,null,null,[],false],[244,186,0,null,null,null,[28902],false],[0,0,0,"",null,"",null,false],[244,187,0,null,null,null,[28904],false],[0,0,0,"",null,"",null,false],[244,190,0,null,null,null,null,false],[244,191,0,null,null,null,null,false],[244,192,0,null,null,null,null,false],[244,194,0,null,null,null,null,false],[244,196,0,null,null,null,null,false],[244,197,0,null,null,null,null,false],[244,199,0,null,null,null,[28912,28913],false],[0,0,0,"requested_size",null,null,null,false],[0,0,0,"log2_ptr_align",null,null,null,false],[244,204,0,null,null,null,[28927,28929,28931,28933,28935],false],[244,211,0,null,null,null,null,false],[244,213,0,null,null,null,[28917,28918],false],[0,0,0,"self",null,"",null,false],[0,0,0,"trace_kind",null,"",null,false],[244,217,0,null,null,null,[28920,28921],false],[0,0,0,"self",null,"",null,false],[0,0,0,"trace_kind",null,"",null,false],[244,230,0,null,null,null,[28923,28924,28925],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"trace_kind",null,"",null,false],[244,204,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[244,204,0,null,null,null,null,false],[0,0,0,"requested_size",null,null,null,false],[244,204,0,null,null,null,null,false],[0,0,0,"stack_addresses",null,null,null,false],[244,204,0,null,null,null,null,false],[0,0,0,"freed",null,null,null,false],[244,204,0,null,null,null,null,false],[0,0,0,"log2_ptr_align",null,null,null,false],[244,236,0,null,null,null,null,false],[244,237,0,null,null,null,null,false],[244,244,0,null,null,null,[28954,28956,28958,28960,28962],false],[244,251,0,null,null,null,[28940,28941],false],[0,0,0,"bucket",null,"",null,false],[0,0,0,"index",null,"",null,false],[244,255,0,null,null,null,[28943,28944,28945,28946],false],[0,0,0,"bucket",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[0,0,0,"slot_index",null,"",null,false],[0,0,0,"trace_kind",null,"",null,false],[244,267,0,null,null,null,[28948,28949,28950,28951,28952],false],[0,0,0,"bucket",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[0,0,0,"slot_index",null,"",null,false],[0,0,0,"trace_kind",null,"",null,false],[244,244,0,null,null,null,null,false],[0,0,0,"prev",null,null,null,false],[244,244,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[244,244,0,null,null,null,null,false],[0,0,0,"page",null,null,null,false],[244,244,0,null,null,null,null,false],[0,0,0,"alloc_cursor",null,null,null,false],[244,244,0,null,null,null,null,false],[0,0,0,"used_count",null,null,null,false],[244,281,0,null,null,null,[28964],false],[0,0,0,"self",null,"",null,false],[244,292,0,null,null,null,[28966,28967,28968,28969],false],[0,0,0,"bucket",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[0,0,0,"slot_index",null,"",null,false],[0,0,0,"trace_kind",null,"",null,false],[244,309,0,null,null,null,[28971],false],[0,0,0,"size_class",null,"",null,false],[244,317,0,null,null,null,[28973],false],[0,0,0,"size_class",null,"",null,false],[244,322,0,null,null,null,[28975],false],[0,0,0,"size_class",null,"",null,false],[244,328,0,null,null,null,[28977,28978,28979],false],[0,0,0,"bucket",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[0,0,0,"used_bits_count",null,"",null,false],[244,359,0,null,null," Emits log messages for leaks and then returns whether there were any leaks.",[28981],false],[0,0,0,"self",null,"",null,false],[244,385,0,null,null,null,[28983,28984,28985],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bucket",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[244,391,0,null,null,null,[28987],false],[0,0,0,"self",null,"",null,false],[244,436,0,null,null," Returns `Check.leak` if there were leaks; `Check.ok` otherwise.",[28989],false],[0,0,0,"self",null,"",null,false],[244,449,0,null,null,null,[28991,28992],false],[0,0,0,"first_trace_addr",null,"",null,false],[0,0,0,"addresses",null,"",null,false],[244,459,0,null,null,null,[28994,28995,28996],false],[0,0,0,"ret_addr",null,"",null,false],[0,0,0,"alloc_stack_trace",null,"",null,false],[0,0,0,"free_stack_trace",null,"",null,false],[244,471,0,null,null,null,[28998,28999,29000],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[0,0,0,"trace_addr",null,"",null,false],[244,505,0,null,null,null,[29002,29003],false],[0,0,0,"bucket_list",null,"",null,false],[0,0,0,"addr",null,"",null,false],[244,524,0,null,null," This function assumes the object is in the large object storage regardless\n of the parameters.",[29005,29006,29007,29008,29009],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"log2_old_align",null,"",null,false],[0,0,0,"new_size",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[244,600,0,null,null," This function assumes the object is in the large object storage regardless\n of the parameters.",[29011,29012,29013,29014],false],[0,0,0,"self",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"log2_old_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[244,658,0,null,null,null,[29016,29017],false],[0,0,0,"self",null,"",null,false],[0,0,0,"limit",null,"",null,false],[244,662,0,null,null,null,[29019,29020,29021,29022,29023],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"log2_old_align_u8",null,"",null,false],[0,0,0,"new_size",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[244,782,0,null,null,null,[29025,29026,29027,29028],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"log2_old_align_u8",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[244,926,0,null,null,null,[29030,29031],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,"",null,false],[244,937,0,null,null,null,[29033,29034,29035,29036],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[244,945,0,null,null,null,[29038,29039,29040,29041],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[244,998,0,null,null,null,[29043,29044,29045],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size_class",null,"",null,false],[0,0,0,"bucket_index",null,"",null,false],[244,160,0,null,null,null,null,false],[0,0,0,"backing_allocator",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"buckets",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"large_allocations",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"small_allocations",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"empty_buckets",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"total_requested_bytes",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"requested_memory_limit",null,null,null,false],[244,160,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[244,1020,0,null,null,null,[29063,29064],false],[0,0,0,"alloc",null,null,null,false],[0,0,0,"free",null,null,null,false],[244,1025,0,null,null,null,null,false],[240,17,0,null,null,null,null,false],[240,18,0,null,null,null,null,false],[0,0,0,"heap/WasmAllocator.zig",null," This is intended to be merged into GeneralPurposeAllocator at some point.\n",[],false],[245,2,0,null,null,null,null,false],[245,3,0,null,null,null,null,false],[245,4,0,null,null,null,null,false],[245,5,0,null,null,null,null,false],[245,6,0,null,null,null,null,false],[245,7,0,null,null,null,null,false],[245,8,0,null,null,null,null,false],[245,16,0,null,null,null,null,false],[245,22,0,null,null,null,null,false],[245,24,0,null,null,null,null,false],[245,25,0,null,null,null,null,false],[245,26,0,null,null,null,null,false],[245,27,0,null,null,null,null,false],[245,28,0,null,null,null,null,false],[245,31,0,null,null," Because of storing free list pointers, the minimum size class is 3.",null,false],[245,32,0,null,null,null,null,false],[245,37,0,null,null," 0 - 1 bigpage\n 1 - 2 bigpages\n 2 - 4 bigpages\n etc.",null,false],[245,39,0,null,null,null,null,false],[245,41,0,null,null," For each size class, points to the freed pointer.",null,false],[245,43,0,null,null," For each big size class, points to the freed pointer.",null,false],[245,45,0,null,null,null,[29090,29091,29092,29093],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[245,83,0,null,null,null,[29095,29096,29097,29098,29099],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[245,111,0,null,null,null,[29101,29102,29103,29104],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[245,139,0,null,null,null,[29106],false],[0,0,0,"byte_count",null,"",null,false],[245,143,0,null,null,null,[29108],false],[0,0,0,"n",null,"",null,false],[245,161,0,null,null,null,null,false],[240,19,0,null,null,null,null,false],[0,0,0,"heap/WasmPageAllocator.zig",null,"",[],false],[246,0,0,null,null,null,null,false],[246,1,0,null,null,null,null,false],[246,2,0,null,null,null,null,false],[246,3,0,null,null,null,null,false],[246,4,0,null,null,null,null,false],[246,5,0,null,null,null,null,false],[246,6,0,null,null,null,null,false],[246,14,0,null,null,null,null,false],[246,20,0,null,null,null,[29122,29123],false],[246,24,0,null,null,null,null,false],[0,0,0,"used",null,null,null,false],[0,0,0,"free",null,null,null,false],[246,27,0,null,null,null,[29148],false],[246,30,0,null,null,null,null,false],[246,32,0,null,null,null,[29127],false],[0,0,0,"self",null,"",null,false],[246,36,0,null,null,null,[29129],false],[0,0,0,"self",null,"",null,false],[246,40,0,null,null,null,[29131,29132],false],[0,0,0,"self",null,"",null,false],[0,0,0,"idx",null,"",null,false],[246,45,0,null,null,null,[29134,29135,29136,29137],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_idx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"val",null,"",null,false],[246,60,0,null,null,null,null,false],[246,62,0,null,null,null,[29140,29141,29142],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_pages",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[246,87,0,null,null,null,[29144,29145,29146],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_idx",null,"",null,false],[0,0,0,"len",null,"",null,false],[246,27,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[246,92,0,null,null,null,null,false],[246,94,0,null,null,null,null,false],[246,95,0,null,null,null,null,false],[246,97,0,null,null,null,[],false],[246,101,0,null,null,null,[29154],false],[0,0,0,"memsize",null,"",null,false],[246,105,0,null,null,null,[29156,29157,29158,29159],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[246,114,0,null,null,null,[29161,29162],false],[0,0,0,"page_count",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[246,142,0,null,null,null,[29164,29165],false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[246,162,0,null,null,null,[29167,29168,29169,29170,29171],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[246,183,0,null,null,null,[29173,29174,29175,29176],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,20,0,null,null,null,null,false],[0,0,0,"heap/PageAllocator.zig",null,"",[],false],[247,0,0,null,null,null,null,false],[247,1,0,null,null,null,null,false],[247,2,0,null,null,null,null,false],[247,3,0,null,null,null,null,false],[247,4,0,null,null,null,null,false],[247,5,0,null,null,null,null,false],[247,6,0,null,null,null,null,false],[247,8,0,null,null,null,null,false],[247,14,0,null,null,null,[29188,29189,29190,29191],false],[0,0,0,"",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[247,47,0,null,null,null,[29193,29194,29195,29196,29197],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf_unaligned",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_size",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[247,98,0,null,null,null,[29199,29200,29201,29202],false],[0,0,0,"",null,"",null,false],[0,0,0,"slice",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,21,0,null,null,null,null,false],[0,0,0,"heap/ThreadSafeAllocator.zig",null," Wraps a non-thread-safe allocator and makes it thread-safe.\n",[29227,29229],false],[248,5,0,null,null,null,[29206],false],[0,0,0,"self",null,"",null,false],[248,16,0,null,null,null,[29208,29209,29210,29211],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[248,24,0,null,null,null,[29213,29214,29215,29216,29217],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[248,33,0,null,null,null,[29219,29220,29221,29222],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[248,42,0,null,null,null,null,false],[248,43,0,null,null,null,null,false],[248,44,0,null,null,null,null,false],[248,0,0,null,null,null,null,false],[0,0,0,"child_allocator",null,null,null,false],[248,0,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[240,22,0,null,null,null,null,false],[0,0,0,"heap/sbrk_allocator.zig",null,"",[],false],[249,0,0,null,null,null,null,false],[249,1,0,null,null,null,null,false],[249,2,0,null,null,null,null,false],[249,3,0,null,null,null,null,false],[249,4,0,null,null,null,null,false],[249,5,0,null,null,null,null,false],[249,7,0,null,null,null,[29239],false],[0,0,0,"sbrk",null,"",[29240],true],[0,0,0,"n",null,"",[29276],false],[249,9,0,null,null,null,null,false],[249,15,0,null,null,null,null,false],[249,19,0,null,null,null,null,false],[249,20,0,null,null,null,null,false],[249,21,0,null,null,null,null,false],[249,22,0,null,null,null,null,false],[249,23,0,null,null,null,null,false],[249,26,0,null,null," Because of storing free list pointers, the minimum size class is 3.",null,false],[249,27,0,null,null,null,null,false],[249,32,0,null,null," 0 - 1 bigpage\n 1 - 2 bigpages\n 2 - 4 bigpages\n etc.",null,false],[249,34,0,null,null,null,null,false],[249,36,0,null,null," For each size class, points to the freed pointer.",null,false],[249,38,0,null,null," For each big size class, points to the freed pointer.",null,false],[249,41,0,null,null,null,null,false],[249,42,0,null,null,null,[29256,29257,29258,29259],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[249,82,0,null,null,null,[29261,29262,29263,29264,29265],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[249,112,0,null,null,null,[29267,29268,29269,29270],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[249,142,0,null,null,null,[29272],false],[0,0,0,"byte_count",null,"",null,false],[249,146,0,null,null,null,[29274],false],[0,0,0,"n",null,"",null,false],[249,8,0,null,null,null,null,false],[0,0,0,"lock",null,null,null,false],[240,24,0,null,null,null,null,false],[0,0,0,"heap/memory_pool.zig",null,"",[],false],[250,0,0,null,null,null,null,false],[250,2,0,null,null,null,null,false],[250,4,0,null,null,null,null,false],[250,9,0,null,null," A memory pool that can allocate objects of a single type very quickly.\n Use this when you need to allocate a lot of objects of the same type,\n because It outperforms general purpose allocators.",[29283],false],[0,0,0,"Item",null,"",null,true],[250,16,0,null,null," A memory pool that can allocate objects of a single type very quickly.\n Use this when you need to allocate a lot of objects of the same type,\n because It outperforms general purpose allocators.",[29285,29286],false],[0,0,0,"Item",null,"",null,true],[0,0,0,"alignment",null,"",null,true],[250,24,0,null,null,null,[29289,29290],false],[250,24,0,null,null,null,null,false],[0,0,0,"alignment",null," The alignment of the memory pool items. Use `null` for natural alignment.",null,false],[0,0,0,"growable",null," If `true`, the memory pool can allocate additional items after a initial setup.\n If `false`, the memory pool will not allocate further after a call to `initPreheated`.",null,false],[250,36,0,null,null," A memory pool that can allocate objects of a single type very quickly.\n Use this when you need to allocate a lot of objects of the same type,\n because It outperforms general purpose allocators.",[29292,29293],false],[0,0,0,"Item",null,"",null,true],[0,0,0,"pool_options",null,"",[29319,29321],true],[250,38,0,null,null,null,null,false],[250,42,0,null,null," Size of the memory pool items. This is not necessarily the same\n as `@sizeOf(Item)` as the pool also uses the items for internal means.",null,false],[250,46,0,null,null," Alignment of the memory pool items. This is not necessarily the same\n as `@alignOf(Item)` as the pool also uses the items for internal means.",null,false],[250,48,0,null,null,null,[29299],false],[250,48,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[250,51,0,null,null,null,null,false],[250,52,0,null,null,null,null,false],[250,58,0,null,null," Creates a new memory pool.",[29303],false],[0,0,0,"allocator",null,"",null,false],[250,65,0,null,null," Creates a new memory pool and pre-allocates `initial_size` items.\n This allows the up to `initial_size` active allocations before a\n `OutOfMemory` error happens when calling `create()`.",[29305,29306],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"initial_size",null,"",null,false],[250,83,0,null,null," Destroys the memory pool and frees all allocated memory.",[29308],false],[0,0,0,"pool",null,"",null,false],[250,90,0,null,null," Resets the memory pool and destroys all allocated items.\n This can be used to batch-destroy all objects without invalidating the memory pool.",[29310],false],[0,0,0,"pool",null,"",null,false],[250,103,0,null,null," Creates a new item and adds it to the memory pool.",[29312],false],[0,0,0,"pool",null,"",null,false],[250,119,0,null,null," Destroys a previously created item.\n Only pass items to `ptr` that were previously created with `create()` of the same memory pool!",[29314,29315],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"ptr",null,"",null,false],[250,129,0,null,null,null,[29317],false],[0,0,0,"pool",null,"",null,false],[250,37,0,null,null,null,null,false],[0,0,0,"arena",null,null,null,false],[250,37,0,null,null,null,null,false],[0,0,0,"free_list",null,null,null,false],[240,25,0,null,null,null,null,false],[240,26,0,null,null,null,null,false],[240,27,0,null,null,null,null,false],[240,28,0,null,null,null,null,false],[240,31,0,null,null," TODO Utilize this on Windows.",null,false],[240,33,0,null,null,null,[],false],[240,40,0,null,null,null,null,false],[240,60,0,null,null,null,null,false],[240,62,0,null,null,null,[29331],false],[0,0,0,"ptr",null,"",null,false],[240,66,0,null,null,null,[29333,29334],false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[240,92,0,null,null,null,[29336],false],[0,0,0,"ptr",null,"",null,false],[240,101,0,null,null,null,[29338],false],[0,0,0,"ptr",null,"",null,false],[240,111,0,null,null,null,[29340,29341,29342,29343],false],[0,0,0,"",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,122,0,null,null,null,[29345,29346,29347,29348,29349],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,143,0,null,null,null,[29351,29352,29353,29354],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,158,0,null,null," Supports the full Allocator interface, including alignment, and exploiting\n `malloc_usable_size` if available. For an allocator that directly calls\n `malloc`/`free`, see `raw_c_allocator`.",null,false],[240,162,0,null,null,null,null,false],[240,173,0,null,null," Asserts allocations are within `@alignOf(std.c.max_align_t)` and directly calls\n `malloc`/`free`. Does not attempt to utilize `malloc_usable_size`.\n This allocator is safe to use as the backing allocator with\n `ArenaAllocator` for example and is more optimal in such a case\n than `c_allocator`.",null,false],[240,177,0,null,null,null,null,false],[240,183,0,null,null,null,[29360,29361,29362,29363],false],[0,0,0,"",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[240,200,0,null,null,null,[29365,29366,29367,29368,29369],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_old_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[240,212,0,null,null,null,[29371,29372,29373,29374],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_old_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[240,225,0,null,null," This allocator makes a syscall directly for every allocation and free.\n Thread-safe and lock-free.",null,false],[240,248,0,null,null," This allocator is fast, small, and specific to WebAssembly. In the future,\n this will be the implementation automatically selected by\n `GeneralPurposeAllocator` when compiling in `ReleaseSmall` mode for wasm32\n and wasm64 architectures.\n Until then, it is available here to play with.",null,false],[240,254,0,null,null," Verifies that the adjusted length will still map to the full length",[29378,29379],false],[0,0,0,"full_len",null,"",null,false],[0,0,0,"len",null,"",null,false],[240,260,0,null,null,null,null,false],[240,360,0,null,null,null,[29382,29383],false],[0,0,0,"container",null,"",null,false],[0,0,0,"ptr",null,"",null,false],[240,365,0,null,null,null,[29385,29386],false],[0,0,0,"container",null,"",null,false],[0,0,0,"slice",null,"",null,false],[240,370,0,null,null,null,[29426,29428],false],[240,374,0,null,null,null,[29389],false],[0,0,0,"buffer",null,"",null,false],[240,382,0,null,null," *WARNING* using this at the same time as the interface returned by `threadSafeAllocator` is not thread safe",[29391],false],[0,0,0,"self",null,"",null,false],[240,395,0,null,null," Provides a lock free thread safe `Allocator` interface to the underlying `FixedBufferAllocator`\n *WARNING* using this at the same time as the interface returned by `allocator` is not thread safe",[29393],false],[0,0,0,"self",null,"",null,false],[240,406,0,null,null,null,[29395,29396],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ptr",null,"",null,false],[240,410,0,null,null,null,[29398,29399],false],[0,0,0,"self",null,"",null,false],[0,0,0,"slice",null,"",null,false],[240,417,0,null,null," NOTE: this will not work in all cases, if the last allocation had an adjusted_index\n       then we won't be able to determine what the last allocation was.  This is because\n       the alignForward operation done in alloc is not reversible.",[29401,29402],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[240,421,0,null,null,null,[29404,29405,29406,29407],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[240,433,0,null,null,null,[29409,29410,29411,29412,29413],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_size",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,463,0,null,null,null,[29415,29416,29417,29418],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[240,479,0,null,null,null,[29420,29421,29422,29423],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[240,494,0,null,null,null,[29425],false],[0,0,0,"self",null,"",null,false],[0,0,0,"end_index",null,null,null,false],[240,370,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[240,499,0,null,null,null,null,false],[240,504,0,null,null," Returns a `StackFallbackAllocator` allocating using either a\n `FixedBufferAllocator` on an array of size `size` and falling back to\n `fallback_allocator` if that fails.",[29431,29432],false],[0,0,0,"size",null,"",null,true],[0,0,0,"fallback_allocator",null,"",null,false],[240,516,0,null,null," An allocator that attempts to allocate using a\n `FixedBufferAllocator` using an array of size `size`. If the\n allocation fails, it will fall back to using\n `fallback_allocator`. Easily created with `stackFallback`.",[29434],false],[0,0,0,"size",null,"",[29455,29457,29459],true],[240,518,0,null,null,null,null,false],[240,526,0,null,null," This function both fetches a `Allocator` interface to this\n allocator *and* resets the internal buffer allocator.",[29437],false],[0,0,0,"self",null,"",null,false],[240,538,0,null,null,null,[29439,29440,29441,29442],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[240,549,0,null,null,null,[29444,29445,29446,29447,29448],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ra",null,"",null,false],[240,564,0,null,null,null,[29450,29451,29452,29453],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_buf_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[240,517,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[240,517,0,null,null,null,null,false],[0,0,0,"fallback_allocator",null,null,null,false],[240,517,0,null,null,null,null,false],[0,0,0,"fixed_buffer_allocator",null,null,null,false],[240,644,0,null,null,null,null,false],[240,727,0,null,null," This one should not try alignments that exceed what C malloc can handle.",[29462],false],[0,0,0,"base_allocator",null,"",null,false],[240,774,0,null,null,null,[29464],false],[0,0,0,"base_allocator",null,"",null,false],[240,801,0,null,null,null,[29466],false],[0,0,0,"base_allocator",null,"",null,false],[240,830,0,null,null,null,[29468],false],[0,0,0,"base_allocator",null,"",null,false],[1,116,0,null,null," HTTP client and server.",null,false],[0,0,0,"http.zig",null,"",[],false],[251,0,0,null,null,null,null,false],[251,2,0,null,null,null,null,false],[0,0,0,"http/Client.zig",null," Connecting and opening requests are threadsafe. Individual requests are not.\n",[29876,29878,29880,29881,29883,29885],false],[252,2,0,null,null,null,null,false],[252,3,0,null,null,null,null,false],[252,4,0,null,null,null,null,false],[252,5,0,null,null,null,null,false],[252,6,0,null,null,null,null,false],[252,7,0,null,null,null,null,false],[252,8,0,null,null,null,null,false],[252,9,0,null,null,null,null,false],[252,11,0,null,null,null,null,false],[252,12,0,null,null,null,null,false],[0,0,0,"protocol.zig",null,"",[],false],[253,0,0,null,null,null,null,false],[253,1,0,null,null,null,null,false],[253,2,0,null,null,null,null,false],[253,4,0,null,null,null,null,false],[253,6,0,null,null,null,[29492,29493,29494,29495,29496,29497,29498,29499,29500,29501,29502,29503,29504],false],[253,24,0,null,null," Returns true if the parser is in a content state (ie. not waiting for more headers).",[29491],false],[0,0,0,"self",null,"",null,false],[0,0,0,"invalid",null," Begin header parsing states.",null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"seen_n",null,null,null,false],[0,0,0,"seen_r",null,null,null,false],[0,0,0,"seen_rn",null,null,null,false],[0,0,0,"seen_rnr",null,null,null,false],[0,0,0,"finished",null,null,null,false],[0,0,0,"chunk_head_size",null," Begin transfer-encoding: chunked parsing states.",null,false],[0,0,0,"chunk_head_ext",null,null,null,false],[0,0,0,"chunk_head_r",null,null,null,false],[0,0,0,"chunk_data",null,null,null,false],[0,0,0,"chunk_data_suffix",null,null,null,false],[0,0,0,"chunk_data_suffix_r",null,null,null,false],[253,32,0,null,null,null,[29532,29533,29535,29536,29537,29538],false],[253,47,0,null,null," Initializes the parser with a dynamically growing header buffer of up to `max` bytes.",[29507],false],[0,0,0,"max",null,"",null,false],[253,56,0,null,null," Initializes the parser with a provided buffer `buf`.",[29509],false],[0,0,0,"buf",null,"",null,false],[253,66,0,null,null," Completely resets the parser to it's initial state.\n This must be called after a message is complete.",[29511],false],[0,0,0,"r",null,"",null,false],[253,83,0,null,null," Returns the number of bytes consumed by headers. This is always less than or equal to `bytes.len`.\n You should check `r.state.isContent()` after this to check if the headers are done.\n\n If the amount returned is less than `bytes.len`, you may assume that the parser is in a content state and the\n first byte of content is located at `bytes[result]`.",[29513,29514],false],[0,0,0,"r",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[253,406,0,null,null," Returns the number of bytes consumed by the chunk size. This is always less than or equal to `bytes.len`.\n You should check `r.state == .chunk_data` after this to check if the chunk size has been fully parsed.\n\n If the amount returned is less than `bytes.len`, you may assume that the parser is in the `chunk_data` state\n and that the first byte of the chunk is at `bytes[result]`.",[29516,29517],false],[0,0,0,"r",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[253,481,0,null,null," Returns whether or not the parser has finished parsing a complete message. A message is only complete after the\n entire body has been read and any trailing headers have been parsed.",[29519],false],[0,0,0,"r",null,"",null,false],[253,485,0,null,null,null,null,false],[253,491,0,null,null," Pushes `in` into the parser. Returns the number of bytes consumed by the header. Any header bytes are appended\n to the `header_bytes` buffer.\n\n This function only uses `allocator` if `r.header_bytes_owned` is true, and may be undefined otherwise.",[29522,29523,29524],false],[0,0,0,"r",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"in",null,"",null,false],[253,507,0,null,null,null,null,false],[253,516,0,null,null," Reads the body of the message into `buffer`. Returns the number of bytes placed in the buffer.\n\n If `skip` is true, the buffer will be unused and the body will be skipped.\n\n See `std.http.Client.BufferedConnection for an example of `conn`.",[29527,29528,29529,29530],false],[0,0,0,"r",null,"",null,false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"skip",null,"",null,false],[253,32,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"header_bytes_owned",null," Whether or not `header_bytes` is allocated or was provided as a fixed buffer.",null,false],[253,32,0,null,null,null,null,false],[0,0,0,"header_bytes",null," Either a fixed buffer of len `max_header_bytes` or a dynamic buffer that can grow up to `max_header_bytes`.\n Pointers into this buffer are not stable until after a message is complete.",null,false],[0,0,0,"max_header_bytes",null," The maximum allowed size of `header_bytes`.",null,false],[0,0,0,"next_chunk_length",null,null,null,false],[0,0,0,"done",null," Whether this parser is done parsing a complete message.\n A message is only done when the entire payload has been read.",null,false],[253,605,0,null,null,null,[29540],false],[0,0,0,"array",null,"",null,false],[253,609,0,null,null,null,[29542],false],[0,0,0,"array",null,"",null,false],[253,613,0,null,null,null,[29544],false],[0,0,0,"array",null,"",null,false],[253,617,0,null,null,null,[29546,29547],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[253,625,0,null,null," A buffered (and peekable) Connection.",[29579,29581,29582,29583],false],[253,626,0,null,null,null,null,false],[253,633,0,null,null,null,[29551],false],[0,0,0,"conn",null,"",null,false],[253,642,0,null,null,null,[29553],false],[0,0,0,"conn",null,"",null,false],[253,646,0,null,null,null,[29555,29556],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"num",null,"",null,false],[253,650,0,null,null,null,[29558,29559,29560],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[253,677,0,null,null,null,[29562,29563],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[253,681,0,null,null,null,null,false],[253,682,0,null,null,null,null,false],[253,684,0,null,null,null,[29567],false],[0,0,0,"conn",null,"",null,false],[253,688,0,null,null,null,[29569,29570],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[253,692,0,null,null,null,[29572,29573],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[253,696,0,null,null,null,null,false],[253,697,0,null,null,null,null,false],[253,699,0,null,null,null,[29577],false],[0,0,0,"conn",null,"",null,false],[253,625,0,null,null,null,null,false],[0,0,0,"conn",null,null,null,false],[253,625,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[252,14,0,null,null,null,null,false],[252,15,0,null,null,null,null,false],[252,30,0,null,null," A set of linked lists of connections that can be reused.",[29614,29616,29618,29619,29620],false],[252,32,0,null,null," The criteria for a connection to be considered a match.",[29589,29590,29591],false],[252,32,0,null,null,null,null,false],[0,0,0,"host",null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"is_tls",null,null,null,false],[252,38,0,null,null,null,null,false],[252,39,0,null,null,null,null,false],[252,51,0,null,null," Finds and acquires a connection from the connection pool matching the criteria. This function is threadsafe.\n If no connection is found, null is returned.",[29595,29596],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"criteria",null,"",null,false],[252,69,0,null,null," Acquires an existing connection from the connection pool. This function is not threadsafe.",[29598,29599],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"node",null,"",null,false],[252,77,0,null,null," Acquires an existing connection from the connection pool. This function is threadsafe.",[29601,29602],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"node",null,"",null,false],[252,86,0,null,null," Tries to release a connection back to the connection pool. This function is threadsafe.\n If the connection is marked as closing, it will be closed instead.",[29604,29605,29606],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"client",null,"",null,false],[0,0,0,"node",null,"",null,false],[252,115,0,null,null," Adds a newly created node to the pool of used connections. This function is threadsafe.",[29608,29609],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"node",null,"",null,false],[252,122,0,null,null,null,[29611,29612],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"client",null,"",null,false],[252,30,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[252,30,0,null,null,null,null,false],[0,0,0,"used",null," Open connections that are currently in use.",null,false],[252,30,0,null,null,null,null,false],[0,0,0,"free",null," Open connections that are not currently in use.",null,false],[0,0,0,"free_len",null,null,null,false],[0,0,0,"free_size",null,null,null,false],[252,146,0,null,null," An interface to either a plain or TLS connection.",[29665,29667,29669,29671,29672,29673,29674,29675,29676,29678],false],[252,147,0,null,null,null,null,false],[252,148,0,null,null,null,[29624,29625],false],[0,0,0,"plain",null,null,null,false],[0,0,0,"tls",null,null,null,false],[252,165,0,null,null,null,[29627,29628,29629],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[252,182,0,null,null,null,[29631],false],[0,0,0,"conn",null,"",null,false],[252,191,0,null,null,null,[29633],false],[0,0,0,"conn",null,"",null,false],[252,195,0,null,null,null,[29635,29636],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"num",null,"",null,false],[252,199,0,null,null,null,[29638,29639,29640],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[252,235,0,null,null,null,[29642,29643],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[252,239,0,null,null,null,null,false],[252,248,0,null,null,null,null,false],[252,250,0,null,null,null,[29647],false],[0,0,0,"conn",null,"",null,false],[252,254,0,null,null,null,[29649,29650],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[252,264,0,null,null,null,[29652,29653],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[252,274,0,null,null,null,null,false],[252,279,0,null,null,null,null,false],[252,281,0,null,null,null,[29657],false],[0,0,0,"conn",null,"",null,false],[252,285,0,null,null,null,[29659,29660],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"client",null,"",null,false],[252,295,0,null,null,null,[29662,29663],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"client",null,"",null,false],[252,146,0,null,null,null,null,false],[0,0,0,"stream",null,null,null,false],[252,146,0,null,null,null,null,false],[0,0,0,"tls_client",null," undefined unless protocol is tls.",null,false],[252,146,0,null,null,null,null,false],[0,0,0,"protocol",null,null,null,false],[252,146,0,null,null,null,null,false],[0,0,0,"host",null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"proxied",null,null,null,false],[0,0,0,"closing",null,null,null,false],[0,0,0,"read_start",null,null,null,false],[0,0,0,"read_end",null,null,null,false],[252,146,0,null,null,null,null,false],[0,0,0,"read_buf",null,null,null,false],[252,302,0,null,null," The mode of transport for requests.",[29680,29681,29682],false],[0,0,0,"content_length",null,null,null,false],[0,0,0,"chunked",null,null,null,false],[0,0,0,"none",null,null,null,false],[252,309,0,null,null," The decompressor for response messages.",[29687,29688,29689,29690],false],[252,310,0,null,null,null,null,false],[252,311,0,null,null,null,null,false],[252,312,0,null,null,null,null,false],[0,0,0,"deflate",null,null,null,false],[0,0,0,"gzip",null,null,null,false],[0,0,0,"zstd",null,null,null,false],[0,0,0,"none",null,null,null,false],[252,321,0,null,null," A HTTP response originating from a server.",[29703,29705,29707,29709,29711,29713,29715,29717,29719,29720],false],[252,322,0,null,null,null,null,false],[252,331,0,null,null,null,[29694,29695,29696],false],[0,0,0,"res",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"trailing",null,"",null,false],[252,418,0,null,null,null,[29698],false],[0,0,0,"array",null,"",null,false],[252,422,0,null,null,null,[29700],false],[0,0,0,"nnn",null,"",null,false],[252,428,0,"parseInt3","test parseInt3 {\n        const expectEqual = testing.expectEqual;\n        try expectEqual(@as(u10, 0), parseInt3(\"000\".*));\n        try expectEqual(@as(u10, 418), parseInt3(\"418\".*));\n        try expectEqual(@as(u10, 999), parseInt3(\"999\".*));\n    }",null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"status",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"reason",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"content_length",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"transfer_encoding",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"transfer_compression",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"headers",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"parser",null,null,null,false],[252,321,0,null,null,null,null,false],[0,0,0,"compression",null,null,null,false],[0,0,0,"skip",null,null,null,false],[252,452,0,null,null," A HTTP request that has been sent.\n\n Order of operations: request -> start[ -> write -> finish] -> wait -> read",[29764,29766,29768,29770,29772,29774,29776,29777,29778,29780,29782],false],[252,472,0,null,null," Frees all resources associated with the request.",[29723],false],[0,0,0,"req",null,"",null,false],[252,501,0,null,null,null,[29725,29726],false],[0,0,0,"req",null,"",null,false],[0,0,0,"uri",null,"",null,false],[252,538,0,null,null,null,null,false],[252,541,0,null,null," Send the request to the server.",[29729],false],[0,0,0,"req",null,"",null,false],[252,629,0,null,null,null,null,false],[252,631,0,null,null,null,null,false],[252,633,0,null,null,null,[29733],false],[0,0,0,"req",null,"",null,false],[252,637,0,null,null,null,[29735,29736],false],[0,0,0,"req",null,"",null,false],[0,0,0,"buf",null,"",null,false],[252,650,0,null,null,null,null,false],[252,657,0,null,null," Waits for a response from the server and parses any headers that are sent.\n This function will block until the final response is received.\n\n If `handle_redirects` is true and the request has no payload, then this function will automatically follow\n redirects. If a request payload is present, then this function will error with error.RedirectRequiresResend.",[29739],false],[0,0,0,"req",null,"",null,false],[252,782,0,null,null,null,null,false],[252,784,0,null,null,null,null,false],[252,786,0,null,null,null,[29743],false],[0,0,0,"req",null,"",null,false],[252,791,0,null,null," Reads data from the response body. Must be called after `do`.",[29745,29746],false],[0,0,0,"req",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[252,822,0,null,null," Reads data from the response body. Must be called after `do`.",[29748,29749],false],[0,0,0,"req",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[252,832,0,null,null,null,null,false],[252,834,0,null,null,null,null,false],[252,836,0,null,null,null,[29753],false],[0,0,0,"req",null,"",null,false],[252,841,0,null,null," Write `bytes` to the server. The `transfer_encoding` request header determines how data will be sent.",[29755,29756],false],[0,0,0,"req",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[252,861,0,null,null,null,[29758,29759],false],[0,0,0,"req",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[252,868,0,null,null,null,null,false],[252,871,0,null,null," Finish the body of a request. This notifies the server that you have no more data to send.",[29762],false],[0,0,0,"req",null,"",null,false],[252,452,0,null,null,null,null,false],[0,0,0,"uri",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"client",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"connection",null," is null when this connection is released",null,false],[252,452,0,null,null,null,null,false],[0,0,0,"method",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"headers",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"transfer_encoding",null,null,null,false],[0,0,0,"redirects_left",null,null,null,false],[0,0,0,"handle_redirects",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"response",null,null,null,false],[252,452,0,null,null,null,null,false],[0,0,0,"arena",null," Used as a allocator for resolving redirects locations.",null,false],[252,880,0,null,null,null,[29788,29790,29792,29794],false],[252,881,0,null,null,null,[29785,29786],false],[0,0,0,"basic",null,null,null,false],[0,0,0,"custom",null,null,null,false],[252,880,0,null,null,null,null,false],[0,0,0,"protocol",null,null,null,false],[252,880,0,null,null,null,null,false],[0,0,0,"host",null,null,null,false],[252,880,0,null,null,null,null,false],[0,0,0,"port",null,null,null,false],[252,880,0,null,null,null,null,false],[0,0,0,"auth",null," The value for the Proxy-Authorization header.",null,false],[252,896,0,null,null," Release all associated resources with the client.\n TODO: currently leaks all request allocated data",[29796],false],[0,0,0,"client",null,"",null,false],[252,903,0,null,null,null,null,false],[252,907,0,null,null," Connect to `host:port` using the specified protocol. This will reuse a connection if one is already open.\n This function is threadsafe.",[29799,29800,29801,29802],false],[0,0,0,"client",null,"",null,false],[0,0,0,"host",null,"",null,false],[0,0,0,"port",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[252,960,0,null,null,null,null,false],[252,962,0,null,null,null,[29805,29806],false],[0,0,0,"client",null,"",null,false],[0,0,0,"path",null,"",null,false],[252,995,0,null,null,null,null,false],[252,996,0,null,null,null,null,false],[252,998,0,null,null,null,[29810,29811,29812,29813],false],[0,0,0,"client",null,"",null,false],[0,0,0,"host",null,"",null,false],[0,0,0,"port",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[252,1021,0,null,null,null,null,false],[252,1029,0,null,null,null,[29820,29821,29822,29824,29826],false],[252,1039,0,null,null,null,[29817,29818],false],[0,0,0,"dynamic",null," In this case, the client's Allocator will be used to store the\n entire HTTP header. This value is the maximum total size of\n HTTP headers allowed, otherwise\n error.HttpHeadersExceededSizeLimit is returned from read().",null,false],[0,0,0,"static",null," This is used to store the entire HTTP header. If the HTTP\n header is too big to fit, `error.HttpHeadersExceededSizeLimit`\n is returned from read(). When this is used, `error.OutOfMemory`\n cannot be returned from `read()`.",null,false],[252,1029,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"handle_redirects",null,null,null,false],[0,0,0,"max_redirects",null,null,null,false],[252,1029,0,null,null,null,null,false],[0,0,0,"header_strategy",null,null,null,false],[252,1029,0,null,null,null,null,false],[0,0,0,"connection",null," Must be an already acquired connection.",null,false],[252,1053,0,null,null,null,null,false],[252,1066,0,null,null," Form and send a http request to a server.\n\n `uri` must remain alive during the entire request.\n `headers` is cloned and may be freed after this function returns.\n\n This function is threadsafe.",[29829,29830,29831,29832,29833],false],[0,0,0,"client",null,"",null,false],[0,0,0,"method",null,"",null,false],[0,0,0,"uri",null,"",null,false],[0,0,0,"headers",null,"",null,false],[0,0,0,"options",null,"",null,false],[252,1116,0,null,null,null,[29847,29849,29851,29853,29855,29857],false],[252,1117,0,null,null,null,[29836,29837],false],[0,0,0,"url",null,null,null,false],[0,0,0,"uri",null,null,null,false],[252,1122,0,null,null,null,[29839,29840,29841],false],[0,0,0,"string",null,null,null,false],[0,0,0,"file",null,null,null,false],[0,0,0,"none",null,null,null,false],[252,1128,0,null,null,null,[29843,29844,29845],false],[0,0,0,"storage",null,null,null,false],[0,0,0,"file",null,null,null,false],[0,0,0,"none",null,null,null,false],[252,1116,0,null,null,null,null,false],[0,0,0,"header_strategy",null,null,null,false],[252,1116,0,null,null,null,null,false],[0,0,0,"response_strategy",null,null,null,false],[252,1116,0,null,null,null,null,false],[0,0,0,"location",null,null,null,false],[252,1116,0,null,null,null,null,false],[0,0,0,"method",null,null,null,false],[252,1116,0,null,null,null,null,false],[0,0,0,"headers",null,null,null,false],[252,1116,0,null,null,null,null,false],[0,0,0,"payload",null,null,null,false],[252,1143,0,null,null,null,[29862,29864,29866,29868,29870],false],[252,1151,0,null,null,null,[29860],false],[0,0,0,"res",null,"",null,false],[252,1143,0,null,null,null,null,false],[0,0,0,"status",null,null,null,false],[252,1143,0,null,null,null,null,false],[0,0,0,"body",null,null,null,false],[252,1143,0,null,null,null,null,false],[0,0,0,"headers",null,null,null,false],[252,1143,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[252,1143,0,null,null,null,null,false],[0,0,0,"options",null,null,null,false],[252,1160,0,null,null,null,[29872,29873,29874],false],[0,0,0,"client",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"options",null,"",null,false],[252,0,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[252,0,0,null,null,null,null,false],[0,0,0,"ca_bundle",null,null,null,false],[252,0,0,null,null,null,null,false],[0,0,0,"ca_bundle_mutex",null,null,null,false],[0,0,0,"next_https_rescan_certs",null," When this is `true`, the next time this client performs an HTTPS request,\n it will first rescan the system for root certificates.",null,false],[252,0,0,null,null,null,null,false],[0,0,0,"connection_pool",null," The pool of connections that can be reused (and currently in use).",null,false],[252,0,0,null,null,null,null,false],[0,0,0,"proxy",null,null,null,false],[251,3,0,null,null,null,null,false],[0,0,0,"http/Server.zig",null,"",[30074,30076],false],[254,0,0,null,null,null,null,false],[254,1,0,null,null,null,null,false],[254,2,0,null,null,null,null,false],[254,3,0,null,null,null,null,false],[254,4,0,null,null,null,null,false],[254,5,0,null,null,null,null,false],[254,6,0,null,null,null,null,false],[254,7,0,null,null,null,null,false],[254,9,0,null,null,null,null,false],[254,10,0,null,null,null,null,false],[254,17,0,null,null," An interface to either a plain or TLS connection.",[29937,29939,29940,29942,29943,29944],false],[254,18,0,null,null,null,null,false],[254,19,0,null,null,null,[29901],false],[0,0,0,"plain",null,null,null,false],[254,30,0,null,null,null,[29903,29904,29905],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[254,42,0,null,null,null,[29907],false],[0,0,0,"conn",null,"",null,false],[254,51,0,null,null,null,[29909],false],[0,0,0,"conn",null,"",null,false],[254,55,0,null,null,null,[29911,29912],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"num",null,"",null,false],[254,59,0,null,null,null,[29914,29915,29916],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[254,95,0,null,null,null,[29918,29919],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[254,99,0,null,null,null,null,false],[254,106,0,null,null,null,null,false],[254,108,0,null,null,null,[29923],false],[0,0,0,"conn",null,"",null,false],[254,112,0,null,null,null,[29925,29926],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[254,122,0,null,null,null,[29928,29929],false],[0,0,0,"conn",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[254,132,0,null,null,null,null,false],[254,137,0,null,null,null,null,false],[254,139,0,null,null,null,[29933],false],[0,0,0,"conn",null,"",null,false],[254,143,0,null,null,null,[29935],false],[0,0,0,"conn",null,"",null,false],[254,17,0,null,null,null,null,false],[0,0,0,"stream",null,null,null,false],[254,17,0,null,null,null,null,false],[0,0,0,"protocol",null,null,null,false],[0,0,0,"closing",null,null,null,false],[254,17,0,null,null,null,null,false],[0,0,0,"read_buf",null,null,null,false],[0,0,0,"read_start",null,null,null,false],[0,0,0,"read_end",null,null,null,false],[254,149,0,null,null," The mode of transport for responses.",[29946,29947,29948],false],[0,0,0,"content_length",null,null,null,false],[0,0,0,"chunked",null,null,null,false],[0,0,0,"none",null,null,null,false],[254,156,0,null,null," The decompressor for request messages.",[29953,29954,29955,29956],false],[254,157,0,null,null,null,null,false],[254,158,0,null,null,null,null,false],[254,159,0,null,null,null,null,false],[0,0,0,"deflate",null,null,null,false],[0,0,0,"gzip",null,null,null,false],[0,0,0,"zstd",null,null,null,false],[0,0,0,"none",null,null,null,false],[254,168,0,null,null," A HTTP request originating from a client.",[29965,29967,29969,29971,29973,29975,29977,29979,29981],false],[254,169,0,null,null,null,null,false],[254,179,0,null,null,null,[29960,29961],false],[0,0,0,"req",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[254,271,0,null,null,null,[29963],false],[0,0,0,"array",null,"",null,false],[254,168,0,null,null,null,null,false],[0,0,0,"method",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"content_length",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"transfer_encoding",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"transfer_compression",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"headers",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"parser",null,null,null,false],[254,168,0,null,null,null,null,false],[0,0,0,"compression",null,null,null,false],[254,293,0,null,null," A HTTP response waiting to be sent.\n\n                                  [/ <----------------------------------- \\]\n Order of operations: accept -> wait -> do  [ -> write -> finish][ -> reset /]\n                                   \\ -> read /",[30033,30035,30037,30039,30041,30043,30045,30047,30049,30051],false],[254,309,0,null,null,null,[29984,29985,29986,29987,29988],false],[0,0,0,"first",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"waited",null,null,null,false],[0,0,0,"responded",null,null,null,false],[0,0,0,"finished",null,null,null,false],[254,317,0,null,null,null,[29990],false],[0,0,0,"res",null,"",null,false],[254,328,0,null,null,null,[29992,29993],false],[0,0,0,"reset",null,null,null,false],[0,0,0,"closing",null,null,null,false],[254,331,0,null,null," Reset this response to its initial state. This must be called before handling a second request on the same connection.",[29995],false],[0,0,0,"res",null,"",null,false],[254,392,0,null,null,null,null,false],[254,395,0,null,null," Send the response headers.",[29998],false],[0,0,0,"res",null,"",null,false],[254,471,0,null,null,null,null,false],[254,473,0,null,null,null,null,false],[254,475,0,null,null,null,[30002],false],[0,0,0,"res",null,"",null,false],[254,479,0,null,null,null,[30004,30005],false],[0,0,0,"res",null,"",null,false],[0,0,0,"buf",null,"",null,false],[254,492,0,null,null,null,null,false],[254,495,0,null,null," Wait for the client to send a complete request head.",[30008],false],[0,0,0,"res",null,"",null,false],[254,544,0,null,null,null,null,false],[254,546,0,null,null,null,null,false],[254,548,0,null,null,null,[30012],false],[0,0,0,"res",null,"",null,false],[254,552,0,null,null,null,[30014,30015],false],[0,0,0,"res",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[254,587,0,null,null,null,[30017,30018],false],[0,0,0,"res",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[254,597,0,null,null,null,null,false],[254,599,0,null,null,null,null,false],[254,601,0,null,null,null,[30022],false],[0,0,0,"res",null,"",null,false],[254,606,0,null,null," Write `bytes` to the server. The `transfer_encoding` request header determines how data will be sent.",[30024,30025],false],[0,0,0,"res",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[254,631,0,null,null,null,[30027,30028],false],[0,0,0,"req",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[254,638,0,null,null,null,null,false],[254,641,0,null,null," Finish the body of a request. This notifies the server that you have no more data to send.",[30031],false],[0,0,0,"res",null,"",null,false],[254,293,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"status",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"reason",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"transfer_encoding",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"address",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"connection",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"headers",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"request",null,null,null,false],[254,293,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[254,655,0,null,null,null,[30053,30054],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"options",null,"",null,false],[254,662,0,null,null,null,[30056],false],[0,0,0,"server",null,"",null,false],[254,666,0,null,null,null,null,false],[254,669,0,null,null," Start the HTTP server listening on the given address.",[30059,30060],false],[0,0,0,"server",null,"",null,false],[0,0,0,"address",null,"",null,false],[254,673,0,null,null,null,null,false],[254,675,0,null,null,null,[30063,30064],false],[0,0,0,"dynamic",null," In this case, the client's Allocator will be used to store the\n entire HTTP header. This value is the maximum total size of\n HTTP headers allowed, otherwise\n error.HttpHeadersExceededSizeLimit is returned from read().",null,false],[0,0,0,"static",null," This is used to store the entire HTTP header. If the HTTP\n header is too big to fit, `error.HttpHeadersExceededSizeLimit`\n is returned from read(). When this is used, `error.OutOfMemory`\n cannot be returned from `read()`.",null,false],[254,688,0,null,null,null,[30067,30069],false],[254,688,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[254,688,0,null,null,null,null,false],[0,0,0,"header_strategy",null,null,null,false],[254,694,0,null,null," Accept a new connection.",[30071,30072],false],[0,0,0,"server",null,"",null,false],[0,0,0,"options",null,"",null,false],[254,0,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[254,0,0,null,null,null,null,false],[0,0,0,"socket",null,null,null,false],[251,4,0,null,null,null,null,false],[251,5,0,null,null,null,null,false],[0,0,0,"http/Headers.zig",null,"",[],false],[255,0,0,null,null,null,null,false],[255,2,0,null,null,null,null,false],[255,4,0,null,null,null,null,false],[255,5,0,null,null,null,null,false],[255,6,0,null,null,null,null,false],[255,8,0,null,null,null,null,false],[255,9,0,null,null,null,null,false],[255,10,0,null,null,null,null,false],[255,12,0,null,null,null,[],false],[255,13,0,null,null,null,[30090,30091],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[255,28,0,null,null,null,[30093,30094,30095],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[255,34,0,null,null,null,[30102,30104],false],[255,38,0,null,null,null,[30098,30099,30100],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[255,34,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[255,34,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[255,46,0,null,null,null,[30166,30168,30170,30171],false],[255,55,0,null,null,null,[30107],false],[0,0,0,"allocator",null,"",null,false],[255,59,0,null,null,null,[30109,30110],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"list",null,"",null,false],[255,71,0,null,null,null,[30112],false],[0,0,0,"headers",null,"",null,false],[255,80,0,null,null," Appends a header to the list. Both name and value are copied.",[30114,30115,30116],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[255,107,0,null,null,null,[30118,30119],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,112,0,null,null," Removes all headers with the given name.",[30121,30122],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,138,0,null,null," Returns the index of the first occurrence of a header with the given name.",[30124,30125],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,145,0,null,null," Returns a list of indices containing headers with the given name.",[30127,30128],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,152,0,null,null," Returns the entry of the first occurrence of a header with the given name.",[30130,30131],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,160,0,null,null," Returns a slice containing each header with the given name.\n The caller owns the returned slice, but NOT the values in the slice.",[30133,30134,30135],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,172,0,null,null," Returns the value in the entry of the first occurrence of a header with the given name.",[30137,30138],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,180,0,null,null," Returns a slice containing the value of each header with the given name.\n The caller owns the returned slice, but NOT the values in the slice.",[30140,30141,30142],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"name",null,"",null,false],[255,191,0,null,null,null,[30144],false],[0,0,0,"headers",null,"",null,false],[255,205,0,null,null," Sorts the headers in lexicographical order.",[30146],false],[0,0,0,"headers",null,"",null,false],[255,211,0,null,null," Writes the headers to the given stream.",[30148,30149,30150,30151],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[255,233,0,null,null," Writes all of the headers with the given name to the given stream, separated by commas.\n\n This is useful for headers like `Set-Cookie` which can have multiple values. RFC 9110, Section 5.2",[30153,30154,30155],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[255,253,0,null,null," Frees all `HeaderIndexList`s within `index`\n Frees names and values of all fields if they are owned.",[30157],false],[0,0,0,"headers",null,"",null,false],[255,270,0,null,null," Clears and frees the underlying data structures.\n Frees names and values if they are owned.",[30159],false],[0,0,0,"headers",null,"",null,false],[255,278,0,null,null," Clears the underlying data structures while retaining their capacities.\n Frees names and values if they are owned.",[30161],false],[0,0,0,"headers",null,"",null,false],[255,284,0,null,null,null,[30163,30164],false],[0,0,0,"headers",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[255,46,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[255,46,0,null,null,null,null,false],[0,0,0,"list",null,null,null,false],[255,46,0,null,null,null,null,false],[0,0,0,"index",null,null,null,false],[0,0,0,"owned",null," When this is false, names and values will not be duplicated.\n Use with caution.",null,false],[251,7,0,null,null,null,null,false],[251,8,0,null,null,null,null,false],[251,10,0,null,null,null,[30175,30176],false],[0,0,0,"HTTP/1.0",null,null,null,false],[0,0,0,"HTTP/1.1",null,null,null,false],[251,18,0,null,null," https://developer.mozilla.org/en-US/docs/Web/HTTP/Methods\n https://datatracker.ietf.org/doc/html/rfc7231#section-4 Initial definition\n https://datatracker.ietf.org/doc/html/rfc5789#section-2 PATCH",[30198,30199,30200,30201,30202,30203,30204,30205,30206],false],[251,33,0,null,null," Converts `s` into a type that may be used as a `Method` field.\n Asserts that `s` is 24 or fewer bytes.",[30179],false],[0,0,0,"s",null,"",null,false],[251,39,0,null,null,null,[30181,30182],false],[0,0,0,"self",null,"",null,false],[0,0,0,"w",null,"",null,false],[251,45,0,null,null,null,[30184,30185,30186,30187],false],[0,0,0,"value",null,"",null,false],[0,0,0,"",null,"",null,true],[0,0,0,"",null,"",null,false],[0,0,0,"writer",null,"",null,false],[251,51,0,null,null," Returns true if a request of this method is allowed to have a body\n Actual behavior from servers may vary and should still be checked",[30189],false],[0,0,0,"self",null,"",null,false],[251,61,0,null,null," Returns true if a response to this method is allowed to have a body\n Actual behavior from clients may vary and should still be checked",[30191],false],[0,0,0,"self",null,"",null,false],[251,72,0,null,null," An HTTP method is safe if it doesn't alter the state of the server.\n https://developer.mozilla.org/en-US/docs/Glossary/Safe/HTTP\n https://datatracker.ietf.org/doc/html/rfc7231#section-4.2.1",[30193],false],[0,0,0,"self",null,"",null,false],[251,83,0,null,null," An HTTP method is idempotent if an identical request can be made once or several times in a row with the same effect while leaving the server in the same state.\n https://developer.mozilla.org/en-US/docs/Glossary/Idempotent\n https://datatracker.ietf.org/doc/html/rfc7231#section-4.2.2",[30195],false],[0,0,0,"self",null,"",null,false],[251,94,0,null,null," A cacheable response is an HTTP response that can be cached, that is stored to be retrieved and used later, saving a new request to the server.\n https://developer.mozilla.org/en-US/docs/Glossary/cacheable\n https://datatracker.ietf.org/doc/html/rfc7231#section-4.2.3",[30197],false],[0,0,0,"self",null,"",null,false],[0,0,0,"GET",null,null,null,false],[0,0,0,"HEAD",null,null,null,false],[0,0,0,"POST",null,null,null,false],[0,0,0,"PUT",null,null,null,false],[0,0,0,"DELETE",null,null,null,false],[0,0,0,"CONNECT",null,null,null,false],[0,0,0,"OPTIONS",null,null,null,false],[0,0,0,"TRACE",null,null,null,false],[0,0,0,"PATCH",null,null,null,false],[251,104,0,null,null," https://developer.mozilla.org/en-US/docs/Web/HTTP/Status",[30218,30219,30220,30221,30222,30223,30224,30225,30226,30227,30228,30229,30230,30231,30232,30233,30234,30235,30236,30237,30238,30239,30240,30241,30242,30243,30244,30245,30246,30247,30248,30249,30250,30251,30252,30253,30254,30255,30256,30257,30258,30259,30260,30261,30262,30263,30264,30265,30266,30267,30268,30269,30270,30271,30272,30273,30274,30275,30276,30277,30278,30279],false],[251,174,0,null,null,null,[30209],false],[0,0,0,"self",null,"",null,false],[251,252,0,null,null,null,[30211,30212,30213,30214,30215],false],[0,0,0,"informational",null,null,null,false],[0,0,0,"success",null,null,null,false],[0,0,0,"redirect",null,null,null,false],[0,0,0,"client_error",null,null,null,false],[0,0,0,"server_error",null,null,null,false],[251,260,0,null,null,null,[30217],false],[0,0,0,"self",null,"",null,false],[0,0,0,"continue",null,null,null,false],[0,0,0,"switching_protocols",null,null,null,false],[0,0,0,"processing",null,null,null,false],[0,0,0,"early_hints",null,null,null,false],[0,0,0,"ok",null,null,null,false],[0,0,0,"created",null,null,null,false],[0,0,0,"accepted",null,null,null,false],[0,0,0,"non_authoritative_info",null,null,null,false],[0,0,0,"no_content",null,null,null,false],[0,0,0,"reset_content",null,null,null,false],[0,0,0,"partial_content",null,null,null,false],[0,0,0,"multi_status",null,null,null,false],[0,0,0,"already_reported",null,null,null,false],[0,0,0,"im_used",null,null,null,false],[0,0,0,"multiple_choice",null,null,null,false],[0,0,0,"moved_permanently",null,null,null,false],[0,0,0,"found",null,null,null,false],[0,0,0,"see_other",null,null,null,false],[0,0,0,"not_modified",null,null,null,false],[0,0,0,"use_proxy",null,null,null,false],[0,0,0,"temporary_redirect",null,null,null,false],[0,0,0,"permanent_redirect",null,null,null,false],[0,0,0,"bad_request",null,null,null,false],[0,0,0,"unauthorized",null,null,null,false],[0,0,0,"payment_required",null,null,null,false],[0,0,0,"forbidden",null,null,null,false],[0,0,0,"not_found",null,null,null,false],[0,0,0,"method_not_allowed",null,null,null,false],[0,0,0,"not_acceptable",null,null,null,false],[0,0,0,"proxy_auth_required",null,null,null,false],[0,0,0,"request_timeout",null,null,null,false],[0,0,0,"conflict",null,null,null,false],[0,0,0,"gone",null,null,null,false],[0,0,0,"length_required",null,null,null,false],[0,0,0,"precondition_failed",null,null,null,false],[0,0,0,"payload_too_large",null,null,null,false],[0,0,0,"uri_too_long",null,null,null,false],[0,0,0,"unsupported_media_type",null,null,null,false],[0,0,0,"range_not_satisfiable",null,null,null,false],[0,0,0,"expectation_failed",null,null,null,false],[0,0,0,"teapot",null,null,null,false],[0,0,0,"misdirected_request",null,null,null,false],[0,0,0,"unprocessable_entity",null,null,null,false],[0,0,0,"locked",null,null,null,false],[0,0,0,"failed_dependency",null,null,null,false],[0,0,0,"too_early",null,null,null,false],[0,0,0,"upgrade_required",null,null,null,false],[0,0,0,"precondition_required",null,null,null,false],[0,0,0,"too_many_requests",null,null,null,false],[0,0,0,"request_header_fields_too_large",null,null,null,false],[0,0,0,"unavailable_for_legal_reasons",null,null,null,false],[0,0,0,"internal_server_error",null,null,null,false],[0,0,0,"not_implemented",null,null,null,false],[0,0,0,"bad_gateway",null,null,null,false],[0,0,0,"service_unavailable",null,null,null,false],[0,0,0,"gateway_timeout",null,null,null,false],[0,0,0,"http_version_not_supported",null,null,null,false],[0,0,0,"variant_also_negotiates",null,null,null,false],[0,0,0,"insufficient_storage",null,null,null,false],[0,0,0,"loop_detected",null,null,null,false],[0,0,0,"not_extended",null,null,null,false],[0,0,0,"network_authentication_required",null,null,null,false],[251,281,0,null,null,null,[30281],false],[0,0,0,"chunked",null,null,null,false],[251,286,0,null,null,null,[30283,30284,30285,30286],false],[0,0,0,"compress",null,null,null,false],[0,0,0,"deflate",null,null,null,false],[0,0,0,"gzip",null,null,null,false],[0,0,0,"zstd",null,null,null,false],[251,293,0,null,null,null,[30288,30289],false],[0,0,0,"keep_alive",null,null,null,false],[0,0,0,"close",null,null,null,false],[1,119,0,null,null," I/O streams, reader/writer interfaces and common helpers.",null,false],[0,0,0,"io.zig",null,"",[],false],[256,0,0,null,null,null,null,false],[256,1,0,null,null,null,null,false],[256,2,0,null,null,null,null,false],[256,3,0,null,null,null,null,false],[256,5,0,null,null,null,null,false],[256,6,0,null,null,null,null,false],[256,7,0,null,null,null,null,false],[256,8,0,null,null,null,null,false],[256,9,0,null,null,null,null,false],[256,10,0,null,null,null,null,false],[256,11,0,null,null,null,null,false],[256,13,0,null,null,null,[30304,30305],false],[0,0,0,"blocking",null," I/O operates normally, waiting for the operating system syscalls to complete.",null,false],[0,0,0,"evented",null," I/O functions are generated async and rely on a global event loop. Event-based I/O.",null,false],[256,21,0,null,null,null,null,false],[256,22,0,null,null,null,null,false],[256,26,0,null,null," This is an enum value to use for I/O mode at runtime, since it takes up zero bytes at runtime,\n and makes expressions comptime-known when `is_async` is `false`.",null,false],[256,27,0,null,null,null,null,false],[256,29,0,null,null,null,[],false],[256,47,0,null,null," TODO: async stdout on windows without a dedicated thread.\n https://github.com/ziglang/zig/pull/4816#issuecomment-604521023",[],false],[256,55,0,null,null,null,[],false],[256,73,0,null,null," This returns a `File` that is configured to block with every write, in order\n to facilitate better debugging. This can be changed by modifying the `intended_io_mode` field.",[],false],[256,81,0,null,null,null,[],false],[256,99,0,null,null," TODO: async stdin on windows without a dedicated thread.\n https://github.com/ziglang/zig/pull/4816#issuecomment-604521023",[],false],[256,107,0,null,null,null,null,false],[0,0,0,"io/reader.zig",null,"",[],false],[257,0,0,null,null,null,null,false],[257,1,0,null,null,null,null,false],[257,2,0,null,null,null,null,false],[257,3,0,null,null,null,null,false],[257,4,0,null,null,null,null,false],[257,5,0,null,null,null,null,false],[257,7,0,null,null,null,[30325,30326,30327],false],[0,0,0,"Context",null,"",null,true],[0,0,0,"ReadError",null,"",null,true],[0,0,0,"readFn",null," Returns the number of bytes read. It may be less than buffer.len.\n If the number of bytes read is 0, it means end of stream.\n End of stream is not an error condition.\n",[30328,30329],true],[0,0,0,"context",null,"",null,false],[0,0,0,"buffer",null,"",[30444],false],[257,16,0,null,null,null,null,false],[257,20,0,null,null,null,null,false],[257,25,0,null,null," Returns the number of bytes read. It may be less than buffer.len.\n If the number of bytes read is 0, it means end of stream.\n End of stream is not an error condition.",[30333,30334],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[257,32,0,null,null," Returns the number of bytes read. If the number read is smaller than `buffer.len`, it\n means the stream reached the end. Reaching the end of a stream is not an error\n condition.",[30336,30337],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[257,41,0,null,null," Returns the number of bytes read, calling the underlying read\n function the minimal number of times until the buffer has at least\n `len` bytes filled. If the number read is less than `len` it means\n the stream reached the end. Reaching the end of the stream is not\n an error condition.",[30339,30340,30341],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[257,53,0,null,null," If the number read would be smaller than `buf.len`, `error.EndOfStream` is returned instead.",[30343,30344],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[257,63,0,null,null," Appends to the `std.ArrayList` contents by reading from the stream\n until end of stream is found.\n If the number of bytes appended would exceed `max_append_size`,\n `error.StreamTooLong` is returned\n and the `std.ArrayList` has exactly `max_append_size` bytes appended.",[30346,30347,30348],false],[0,0,0,"self",null,"",null,false],[0,0,0,"array_list",null,"",null,false],[0,0,0,"max_append_size",null,"",null,false],[257,67,0,null,null,null,[30350,30351,30352,30353],false],[0,0,0,"self",null,"",null,false],[0,0,0,"alignment",null,"",null,true],[0,0,0,"array_list",null,"",null,false],[0,0,0,"max_append_size",null,"",null,false],[257,101,0,null,null," Allocates enough memory to hold all the contents of the stream. If the allocated\n memory would be greater than `max_size`, returns `error.StreamTooLong`.\n Caller owns returned memory.\n If this function returns an error, the contents from the stream read so far are lost.",[30355,30356,30357],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"max_size",null,"",null,false],[257,113,0,null,null," Deprecated: use `streamUntilDelimiter` with ArrayList's writer instead.\n Replaces the `std.ArrayList` contents by reading from the stream until `delimiter` is found.\n Does not include the delimiter in the result.\n If the `std.ArrayList` length would exceed `max_size`, `error.StreamTooLong` is returned and the\n `std.ArrayList` is populated with `max_size` bytes from the stream.",[30359,30360,30361,30362],false],[0,0,0,"self",null,"",null,false],[0,0,0,"array_list",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[0,0,0,"max_size",null,"",null,false],[257,128,0,null,null," Deprecated: use `streamUntilDelimiter` with ArrayList's writer instead.\n Allocates enough memory to read until `delimiter`. If the allocated\n memory would be greater than `max_size`, returns `error.StreamTooLong`.\n Caller owns returned memory.\n If this function returns an error, the contents from the stream read so far are lost.",[30364,30365,30366,30367],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[0,0,0,"max_size",null,"",null,false],[257,147,0,null,null," Deprecated: use `streamUntilDelimiter` with FixedBufferStream's writer instead.\n Reads from the stream until specified byte is found. If the buffer is not\n large enough to hold the entire contents, `error.StreamTooLong` is returned.\n If end-of-stream is found, `error.EndOfStream` is returned.\n Returns a slice of the stream data, with ptr equal to `buf.ptr`. The\n delimiter byte is written to the output buffer but is not included\n in the returned slice.",[30369,30370,30371],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[257,163,0,null,null," Deprecated: use `streamUntilDelimiter` with ArrayList's (or any other's) writer instead.\n Allocates enough memory to read until `delimiter` or end-of-stream.\n If the allocated memory would be greater than `max_size`, returns\n `error.StreamTooLong`. If end-of-stream is found, returns the rest\n of the stream. If this function is called again after that, returns\n null.\n Caller owns returned memory.\n If this function returns an error, the contents from the stream read so far are lost.",[30373,30374,30375,30376],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[0,0,0,"max_size",null,"",null,false],[257,188,0,null,null," Deprecated: use `streamUntilDelimiter` with FixedBufferStream's writer instead.\n Reads from the stream until specified byte is found. If the buffer is not\n large enough to hold the entire contents, `error.StreamTooLong` is returned.\n If end-of-stream is found, returns the rest of the stream. If this\n function is called again after that, returns null.\n Returns a slice of the stream data, with ptr equal to `buf.ptr`. The\n delimiter byte is written to the output buffer but is not included\n in the returned slice.",[30378,30379,30380],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[257,207,0,null,null," Appends to the `writer` contents by reading from the stream until `delimiter` is found.\n Does not write the delimiter itself.\n If `optional_max_size` is not null and amount of written bytes exceeds `optional_max_size`,\n returns `error.StreamTooLong` and finishes appending.\n If `optional_max_size` is null, appending is unbounded.",[30382,30383,30384,30385],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[0,0,0,"optional_max_size",null,"",null,false],[257,228,0,null,null," Reads from the stream until specified byte is found, discarding all data,\n including the delimiter.\n If end-of-stream is found, this function succeeds.",[30387,30388],false],[0,0,0,"self",null,"",null,false],[0,0,0,"delimiter",null,"",null,false],[257,239,0,null,null," Reads 1 byte from the stream or returns `error.EndOfStream`.",[30390],false],[0,0,0,"self",null,"",null,false],[257,247,0,null,null," Same as `readByte` except the returned byte is signed.",[30392],false],[0,0,0,"self",null,"",null,false],[257,253,0,null,null," Reads exactly `num_bytes` bytes and returns as an array.\n `num_bytes` must be comptime-known",[30394,30395],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_bytes",null,"",null,true],[257,263,0,null,null," Reads bytes until `bounded.len` is equal to `num_bytes`,\n or the stream ends.\n\n * it is assumed that `num_bytes` will not exceed `bounded.capacity()`",[30397,30398,30399],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_bytes",null,"",null,true],[0,0,0,"bounded",null,"",null,false],[257,280,0,null,null," Reads at most `num_bytes` and returns as a bounded array.",[30401,30402],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_bytes",null,"",null,true],[257,287,0,null,null," Reads a native-endian integer",[30404,30405],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[257,293,0,null,null," Reads a foreign-endian integer",[30407,30408],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[257,298,0,null,null,null,[30410,30411],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[257,303,0,null,null,null,[30413,30414],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[257,308,0,null,null,null,[30416,30417,30418],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"endian",null,"",null,false],[257,313,0,null,null,null,[30420,30421,30422,30423],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ReturnType",null,"",null,true],[0,0,0,"endian",null,"",null,false],[0,0,0,"size",null,"",null,false],[257,322,0,null,null," Optional parameters for `skipBytes`",[30425],false],[0,0,0,"buf_size",null,null,null,false],[257,328,0,null,null," Reads `num_bytes` bytes from the stream and discards them",[30427,30428,30429],false],[0,0,0,"self",null,"",null,false],[0,0,0,"num_bytes",null,"",null,false],[0,0,0,"options",null,"",null,true],[257,340,0,null,null," Reads `slice.len` bytes from the stream and returns if they are the same as the passed slice",[30431,30432],false],[0,0,0,"self",null,"",null,false],[0,0,0,"slice",null,"",null,false],[257,351,0,null,null,null,[30434,30435],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[257,359,0,null,null,null,[30437,30438],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[257,370,0,null,null," Reads an integer with the same size as the given enum's tag type. If the integer matches\n an enum tag, casts the integer to the enum tag and returns it. Otherwise, returns an `error.InvalidValue`.\n TODO optimization taking advantage of most fields being in order",[30440,30441,30442],false],[0,0,0,"self",null,"",null,false],[0,0,0,"Enum",null,"",null,true],[0,0,0,"endian",null,"",null,false],[257,15,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[256,108,0,null,null,null,null,false],[0,0,0,"io/writer.zig",null,"",[],false],[258,0,0,null,null,null,null,false],[258,1,0,null,null,null,null,false],[258,2,0,null,null,null,null,false],[258,4,0,null,null,null,[30451,30452,30453],false],[0,0,0,"Context",null,"",null,true],[0,0,0,"WriteError",null,"",null,true],[0,0,0,"writeFn",null,"",[30454,30455],true],[0,0,0,"context",null,"",null,false],[0,0,0,"bytes",null,"",[30500],false],[258,12,0,null,null,null,null,false],[258,13,0,null,null,null,null,false],[258,15,0,null,null,null,[30459,30460],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[258,19,0,null,null,null,[30462,30463],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[258,26,0,null,null,null,[30465,30466,30467],false],[0,0,0,"self",null,"",null,false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[258,30,0,null,null,null,[30469,30470],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[258,35,0,null,null,null,[30472,30473,30474],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[0,0,0,"n",null,"",null,false],[258,48,0,null,null," Write a native-endian integer.",[30476,30477,30478],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[258,55,0,null,null," Write a foreign-endian integer.",[30480,30481,30482],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[258,61,0,null,null,null,[30484,30485,30486],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[258,67,0,null,null,null,[30488,30489,30490],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[258,73,0,null,null,null,[30492,30493,30494,30495],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[0,0,0,"endian",null,"",null,false],[258,79,0,null,null,null,[30497,30498],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[258,9,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[256,109,0,null,null,null,null,false],[0,0,0,"io/seekable_stream.zig",null,"",[],false],[259,0,0,null,null,null,null,false],[259,2,0,null,null,null,[30505,30506,30507,30508,30511,30514,30516],false],[0,0,0,"Context",null,"",null,true],[0,0,0,"SeekErrorType",null,"",null,true],[0,0,0,"GetSeekPosErrorType",null,"",null,true],[0,0,0,"seekToFn",null,"",[30509,30510],true],[0,0,0,"context",null,"",null,false],[0,0,0,"pos",null,"",null,false],[0,0,0,"seekByFn",null,"",[30512,30513],true],[0,0,0,"context",null,"",null,false],[0,0,0,"pos",null,"",null,false],[0,0,0,"getPosFn",null,"",[30515],true],[0,0,0,"context",null,"",null,false],[0,0,0,"getEndPosFn",null,"",[30517],true],[0,0,0,"context",null,"",[30532],false],[259,14,0,null,null,null,null,false],[259,15,0,null,null,null,null,false],[259,16,0,null,null,null,null,false],[259,18,0,null,null,null,[30522,30523],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pos",null,"",null,false],[259,22,0,null,null,null,[30525,30526],false],[0,0,0,"self",null,"",null,false],[0,0,0,"amt",null,"",null,false],[259,26,0,null,null,null,[30528],false],[0,0,0,"self",null,"",null,false],[259,30,0,null,null,null,[30530],false],[0,0,0,"self",null,"",null,false],[259,11,0,null,null,null,null,false],[0,0,0,"context",null,null,null,false],[256,111,0,null,null,null,null,false],[0,0,0,"io/buffered_writer.zig",null,"",[],false],[260,0,0,null,null,null,null,false],[260,2,0,null,null,null,null,false],[260,3,0,null,null,null,null,false],[260,5,0,null,null,null,[30539,30540],false],[0,0,0,"buffer_size",null,"",null,true],[0,0,0,"WriterType",null,"",[30552,30554,30555],true],[260,11,0,null,null,null,null,false],[260,12,0,null,null,null,null,false],[260,14,0,null,null,null,null,false],[260,16,0,null,null,null,[30545],false],[0,0,0,"self",null,"",null,false],[260,21,0,null,null,null,[30547],false],[0,0,0,"self",null,"",null,false],[260,25,0,null,null,null,[30549,30550],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[260,6,0,null,null,null,null,false],[0,0,0,"unbuffered_writer",null,null,null,false],[260,6,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"end",null,null,null,false],[260,40,0,null,null,null,[30557],false],[0,0,0,"underlying_stream",null,"",null,false],[256,112,0,null,null,null,null,false],[256,114,0,null,null,null,null,false],[0,0,0,"io/buffered_reader.zig",null,"",[],false],[261,0,0,null,null,null,null,false],[261,1,0,null,null,null,null,false],[261,2,0,null,null,null,null,false],[261,3,0,null,null,null,null,false],[261,4,0,null,null,null,null,false],[261,6,0,null,null,null,[30567,30568],false],[0,0,0,"buffer_size",null,"",null,true],[0,0,0,"ReaderType",null,"",[30578,30580,30581,30582],true],[261,13,0,null,null,null,null,false],[261,14,0,null,null,null,null,false],[261,16,0,null,null,null,null,false],[261,18,0,null,null,null,[30573,30574],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[261,41,0,null,null,null,[30576],false],[0,0,0,"self",null,"",null,false],[261,7,0,null,null,null,null,false],[0,0,0,"unbuffered_reader",null,null,null,false],[261,7,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[261,47,0,null,null,null,[30584],false],[0,0,0,"reader",null,"",null,false],[261,51,0,null,null,null,[30586,30587],false],[0,0,0,"size",null,"",null,true],[0,0,0,"reader",null,"",null,false],[261,95,0,null,null,null,[30589],false],[0,0,0,"underlying_stream",null,"",null,false],[256,115,0,null,null,null,null,false],[256,116,0,null,null,null,null,false],[256,118,0,null,null,null,null,false],[0,0,0,"io/peek_stream.zig",null,"",[],false],[262,0,0,null,null,null,null,false],[262,1,0,null,null,null,null,false],[262,2,0,null,null,null,null,false],[262,3,0,null,null,null,null,false],[262,8,0,null,null," Creates a stream which supports 'un-reading' data, so that it can be read again.\n This makes look-ahead style parsing much easier.\n TODO merge this with `std.io.BufferedReader`: https://github.com/ziglang/zig/issues/4501",[30599,30600],false],[0,0,0,"buffer_type",null,"",null,true],[0,0,0,"ReaderType",null,"",[30618,30620],true],[262,22,0,null,null,null,null,false],[262,16,0,null,null,null,null,false],[262,17,0,null,null,null,null,false],[262,19,0,null,null,null,null,false],[262,20,0,null,null,null,null,false],[262,49,0,null,null,null,[30607,30608],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte",null,"",null,false],[262,53,0,null,null,null,[30610,30611],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[262,57,0,null,null,null,[30613,30614],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[262,67,0,null,null,null,[30616],false],[0,0,0,"self",null,"",null,false],[262,12,0,null,null,null,null,false],[0,0,0,"unbuffered_reader",null,null,null,false],[262,12,0,null,null,null,null,false],[0,0,0,"fifo",null,null,null,false],[262,73,0,null,null,null,[30622,30623],false],[0,0,0,"lookahead",null,"",null,true],[0,0,0,"underlying_stream",null,"",null,false],[256,119,0,null,null,null,null,false],[256,121,0,null,null,null,null,false],[0,0,0,"io/fixed_buffer_stream.zig",null,"",[],false],[263,0,0,null,null,null,null,false],[263,1,0,null,null,null,null,false],[263,2,0,null,null,null,null,false],[263,3,0,null,null,null,null,false],[263,4,0,null,null,null,null,false],[263,8,0,null,null," This turns a byte buffer into an `io.Writer`, `io.Reader`, or `io.SeekableStream`.\n If the supplied byte buffer is const, then `io.Writer` is not available.",[30633],false],[0,0,0,"Buffer",null,"",[30669,30670],true],[263,14,0,null,null,null,null,false],[263,15,0,null,null,null,null,false],[263,16,0,null,null,null,null,false],[263,17,0,null,null,null,null,false],[263,19,0,null,null,null,null,false],[263,20,0,null,null,null,null,false],[263,22,0,null,null,null,null,false],[263,32,0,null,null,null,null,false],[263,34,0,null,null,null,[30643],false],[0,0,0,"self",null,"",null,false],[263,38,0,null,null,null,[30645],false],[0,0,0,"self",null,"",null,false],[263,42,0,null,null,null,[30647],false],[0,0,0,"self",null,"",null,false],[263,46,0,null,null,null,[30649,30650],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[263,60,0,null,null," If the returned number of bytes written is less than requested, the\n buffer is full. Returns `error.NoSpaceLeft` when no bytes would be written.\n Note: `error.NoSpaceLeft` matches the corresponding error from\n `std.fs.File.WriteError`.",[30652,30653],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[263,77,0,null,null,null,[30655,30656],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pos",null,"",null,false],[263,81,0,null,null,null,[30658,30659],false],[0,0,0,"self",null,"",null,false],[0,0,0,"amt",null,"",null,false],[263,97,0,null,null,null,[30661],false],[0,0,0,"self",null,"",null,false],[263,101,0,null,null,null,[30663],false],[0,0,0,"self",null,"",null,false],[263,105,0,null,null,null,[30665],false],[0,0,0,"self",null,"",null,false],[263,109,0,null,null,null,[30667],false],[0,0,0,"self",null,"",null,false],[263,9,0,null,null,null,null,false],[0,0,0,"buffer",null," `Buffer` is either a `[]u8` or `[]const u8`.",null,false],[0,0,0,"pos",null,null,null,false],[263,115,0,null,null,null,[30672],false],[0,0,0,"buffer",null,"",null,false],[263,119,0,null,null,null,[30674],false],[0,0,0,"T",null,"",null,true],[256,122,0,null,null,null,null,false],[256,124,0,null,null,null,null,false],[0,0,0,"io/c_writer.zig",null,"",[],false],[264,0,0,null,null,null,null,false],[264,1,0,null,null,null,null,false],[264,2,0,null,null,null,null,false],[264,3,0,null,null,null,null,false],[264,4,0,null,null,null,null,false],[264,6,0,null,null,null,null,false],[264,8,0,null,null,null,[30685],false],[0,0,0,"c_file",null,"",null,false],[264,12,0,null,null,null,[30687,30688],false],[0,0,0,"c_file",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[256,125,0,null,null,null,null,false],[256,127,0,null,null,null,null,false],[0,0,0,"io/limited_reader.zig",null,"",[],false],[265,0,0,null,null,null,null,false],[265,1,0,null,null,null,null,false],[265,2,0,null,null,null,null,false],[265,3,0,null,null,null,null,false],[265,5,0,null,null,null,[30697],false],[0,0,0,"ReaderType",null,"",[30707,30708],true],[265,10,0,null,null,null,null,false],[265,11,0,null,null,null,null,false],[265,13,0,null,null,null,null,false],[265,15,0,null,null,null,[30702,30703],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[265,22,0,null,null,null,[30705],false],[0,0,0,"self",null,"",null,false],[265,6,0,null,null,null,null,false],[0,0,0,"inner_reader",null,null,null,false],[0,0,0,"bytes_left",null,null,null,false],[265,30,0,null,null," Returns an initialised `LimitedReader`\n `bytes_left` is a `u64` to be able to take 64 bit file offsets",[30710,30711],false],[0,0,0,"inner_reader",null,"",null,false],[0,0,0,"bytes_left",null,"",null,false],[256,128,0,null,null,null,null,false],[256,130,0,null,null,null,null,false],[0,0,0,"io/counting_writer.zig",null,"",[],false],[266,0,0,null,null,null,null,false],[266,1,0,null,null,null,null,false],[266,2,0,null,null,null,null,false],[266,5,0,null,null," A Writer that counts how many bytes has been written to it.",[30719],false],[0,0,0,"WriterType",null,"",[30728,30730],true],[266,10,0,null,null,null,null,false],[266,11,0,null,null,null,null,false],[266,13,0,null,null,null,null,false],[266,15,0,null,null,null,[30724,30725],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[266,21,0,null,null,null,[30727],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes_written",null,null,null,false],[266,6,0,null,null,null,null,false],[0,0,0,"child_stream",null,null,null,false],[266,27,0,null,null,null,[30732],false],[0,0,0,"child_stream",null,"",null,false],[256,131,0,null,null,null,null,false],[256,132,0,null,null,null,null,false],[0,0,0,"io/counting_reader.zig",null,"",[],false],[267,0,0,null,null,null,null,false],[267,1,0,null,null,null,null,false],[267,2,0,null,null,null,null,false],[267,5,0,null,null," A Reader that counts how many bytes has been read from it.",[30740],false],[0,0,0,"ReaderType",null,"",[30749,30750],true],[267,10,0,null,null,null,null,false],[267,11,0,null,null,null,null,false],[267,13,0,null,null,null,[30744,30745],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[267,19,0,null,null,null,[30747],false],[0,0,0,"self",null,"",null,false],[267,6,0,null,null,null,null,false],[0,0,0,"child_reader",null,null,null,false],[0,0,0,"bytes_read",null,null,null,false],[267,25,0,null,null,null,[30752],false],[0,0,0,"reader",null,"",null,false],[256,133,0,null,null,null,null,false],[256,135,0,null,null,null,null,false],[0,0,0,"io/multi_writer.zig",null,"",[],false],[268,0,0,null,null,null,null,false],[268,1,0,null,null,null,null,false],[268,4,0,null,null," Takes a tuple of streams, and constructs a new stream that writes to all of them",[30759],false],[0,0,0,"Writers",null,"",[30769],true],[268,12,0,null,null,null,null,false],[268,16,0,null,null,null,null,false],[268,17,0,null,null,null,null,false],[268,19,0,null,null,null,[30764],false],[0,0,0,"self",null,"",null,false],[268,23,0,null,null,null,[30766,30767],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[268,11,0,null,null,null,null,false],[0,0,0,"streams",null,null,null,false],[268,31,0,null,null,null,[30771],false],[0,0,0,"streams",null,"",null,false],[268,35,0,null,null,null,null,false],[256,136,0,null,null,null,null,false],[256,138,0,null,null,null,null,false],[0,0,0,"io/bit_reader.zig",null,"",[],false],[269,0,0,null,null,null,null,false],[269,1,0,null,null,null,null,false],[269,2,0,null,null,null,null,false],[269,3,0,null,null,null,null,false],[269,4,0,null,null,null,null,false],[269,5,0,null,null,null,null,false],[269,6,0,null,null,null,null,false],[269,9,0,null,null," Creates a stream which allows for reading bit fields from another stream",[30784,30785],false],[0,0,0,"endian",null,"",null,true],[0,0,0,"ReaderType",null,"",[30811,30813,30815],true],[269,15,0,null,null,null,null,false],[269,16,0,null,null,null,null,false],[269,18,0,null,null,null,null,false],[269,19,0,null,null,null,null,false],[269,20,0,null,null,null,null,false],[269,21,0,null,null,null,null,false],[269,23,0,null,null,null,[30793],false],[0,0,0,"forward_reader",null,"",null,false],[269,34,0,null,null," Reads `bits` bits from the stream and returns a specified unsigned int type\n  containing them in the least significant end, returning an error if the\n  specified number of bits could not be read.",[30795,30796,30797],false],[0,0,0,"self",null,"",null,false],[0,0,0,"U",null,"",null,true],[0,0,0,"bits",null,"",null,false],[269,44,0,null,null," Reads `bits` bits from the stream and returns a specified unsigned int type\n  containing them in the least significant end. The number of bits successfully\n  read is placed in `out_bits`, as reaching the end of the stream is not an error.",[30799,30800,30801,30802],false],[0,0,0,"self",null,"",null,false],[0,0,0,"U",null,"",null,true],[0,0,0,"bits",null,"",null,false],[0,0,0,"out_bits",null,"",null,false],[269,131,0,null,null,null,[30804],false],[0,0,0,"self",null,"",null,false],[269,136,0,null,null,null,[30806,30807],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[269,152,0,null,null,null,[30809],false],[0,0,0,"self",null,"",null,false],[269,10,0,null,null,null,null,false],[0,0,0,"forward_reader",null,null,null,false],[269,10,0,null,null,null,null,false],[0,0,0,"bit_buffer",null,null,null,false],[269,10,0,null,null,null,null,false],[0,0,0,"bit_count",null,null,null,false],[269,158,0,null,null,null,[30817,30818],false],[0,0,0,"endian",null,"",null,true],[0,0,0,"underlying_stream",null,"",null,false],[256,139,0,null,null,null,null,false],[256,141,0,null,null,null,null,false],[0,0,0,"io/bit_writer.zig",null,"",[],false],[270,0,0,null,null,null,null,false],[270,1,0,null,null,null,null,false],[270,2,0,null,null,null,null,false],[270,3,0,null,null,null,null,false],[270,4,0,null,null,null,null,false],[270,5,0,null,null,null,null,false],[270,6,0,null,null,null,null,false],[270,9,0,null,null," Creates a stream which allows for writing bit fields to another stream",[30830,30831],false],[0,0,0,"endian",null,"",null,true],[0,0,0,"WriterType",null,"",[30851,30852,30854],true],[270,15,0,null,null,null,null,false],[270,16,0,null,null,null,null,false],[270,18,0,null,null,null,null,false],[270,19,0,null,null,null,null,false],[270,20,0,null,null,null,null,false],[270,22,0,null,null,null,[30838],false],[0,0,0,"forward_writer",null,"",null,false],[270,33,0,null,null," Write the specified number of bits to the stream from the least significant bits of\n  the specified unsigned int value. Bits will only be written to the stream when there\n  are enough to fill a byte.",[30840,30841,30842],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"bits",null,"",null,false],[270,114,0,null,null," Flush any remaining bits to the stream.",[30844],false],[0,0,0,"self",null,"",null,false],[270,121,0,null,null,null,[30846,30847],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[270,132,0,null,null,null,[30849],false],[0,0,0,"self",null,"",null,false],[270,10,0,null,null,null,null,false],[0,0,0,"forward_writer",null,null,null,false],[0,0,0,"bit_buffer",null,null,null,false],[270,10,0,null,null,null,null,false],[0,0,0,"bit_count",null,null,null,false],[270,138,0,null,null,null,[30856,30857],false],[0,0,0,"endian",null,"",null,true],[0,0,0,"underlying_stream",null,"",null,false],[256,142,0,null,null,null,null,false],[256,144,0,null,null,null,null,false],[0,0,0,"io/change_detection_stream.zig",null,"",[],false],[271,0,0,null,null,null,null,false],[271,1,0,null,null,null,null,false],[271,2,0,null,null,null,null,false],[271,3,0,null,null,null,null,false],[271,6,0,null,null," Used to detect if the data written to a stream differs from a source buffer",[30866],false],[0,0,0,"WriterType",null,"",[30877,30879,30880,30882],true],[271,8,0,null,null,null,null,false],[271,9,0,null,null,null,null,false],[271,10,0,null,null,null,null,false],[271,17,0,null,null,null,[30871],false],[0,0,0,"self",null,"",null,false],[271,21,0,null,null,null,[30873,30874],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[271,38,0,null,null,null,[30876],false],[0,0,0,"self",null,"",null,false],[0,0,0,"anything_changed",null,null,null,false],[271,7,0,null,null,null,null,false],[0,0,0,"underlying_writer",null,null,null,false],[0,0,0,"source_index",null,null,null,false],[271,7,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[271,44,0,null,null,null,[30884,30885],false],[0,0,0,"source",null,"",null,false],[0,0,0,"underlying_writer",null,"",null,false],[256,145,0,null,null,null,null,false],[256,147,0,null,null,null,null,false],[0,0,0,"io/find_byte_writer.zig",null,"",[],false],[272,0,0,null,null,null,null,false],[272,1,0,null,null,null,null,false],[272,2,0,null,null,null,null,false],[272,6,0,null,null," A Writer that returns whether the given character has been written to it.\n The contents are not written to anything.",[30893],false],[0,0,0,"UnderlyingWriter",null,"",[30903,30904,30905],true],[272,8,0,null,null,null,null,false],[272,9,0,null,null,null,null,false],[272,10,0,null,null,null,null,false],[272,16,0,null,null,null,[30898],false],[0,0,0,"self",null,"",null,false],[272,20,0,null,null,null,[30900,30901],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[272,7,0,null,null,null,null,false],[0,0,0,"underlying_writer",null,null,null,false],[0,0,0,"byte_found",null,null,null,false],[0,0,0,"byte",null,null,null,false],[272,33,0,null,null,null,[30907,30908],false],[0,0,0,"byte",null,"",null,false],[0,0,0,"underlying_writer",null,"",null,false],[256,148,0,null,null,null,null,false],[256,150,0,null,null,null,null,false],[0,0,0,"io/buffered_atomic_file.zig",null,"",[],false],[273,0,0,null,null,null,null,false],[273,1,0,null,null,null,null,false],[273,2,0,null,null,null,null,false],[273,3,0,null,null,null,null,false],[273,5,0,null,null,null,[30932,30934,30936,30938],false],[273,11,0,null,null,null,null,false],[273,12,0,null,null,null,null,false],[273,13,0,null,null,null,null,false],[273,17,0,null,null," TODO when https://github.com/ziglang/zig/issues/2761 is solved\n this API will not need an allocator",[30921,30922,30923,30924],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"dest_path",null,"",null,false],[0,0,0,"atomic_file_options",null,"",null,false],[273,41,0,null,null," always call destroy, even after successful finish()",[30926],false],[0,0,0,"self",null,"",null,false],[273,46,0,null,null,null,[30928],false],[0,0,0,"self",null,"",null,false],[273,51,0,null,null,null,[30930],false],[0,0,0,"self",null,"",null,false],[273,5,0,null,null,null,null,false],[0,0,0,"atomic_file",null,null,null,false],[273,5,0,null,null,null,null,false],[0,0,0,"file_writer",null,null,null,false],[273,5,0,null,null,null,null,false],[0,0,0,"buffered_writer",null,null,null,false],[273,5,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[256,152,0,null,null,null,null,false],[0,0,0,"io/stream_source.zig",null,"",[],false],[274,0,0,null,null,null,null,false],[274,1,0,null,null,null,null,false],[274,2,0,null,null,null,null,false],[274,8,0,null,null," Provides `io.Reader`, `io.Writer`, and `io.SeekableStream` for in-memory buffers as\n well as files.\n For memory sources, if the supplied byte buffer is const, then `io.Writer` is not available.\n The error set of the stream functions is the error set of the corresponding file functions.",[30975,30976,30977],false],[274,10,0,null,null,null,null,false],[274,23,0,null,null,null,null,false],[274,24,0,null,null,null,null,false],[274,25,0,null,null,null,null,false],[274,26,0,null,null,null,null,false],[274,28,0,null,null,null,null,false],[274,29,0,null,null,null,null,false],[274,30,0,null,null,null,null,false],[274,40,0,null,null,null,[30954,30955],false],[0,0,0,"self",null,"",null,false],[0,0,0,"dest",null,"",null,false],[274,48,0,null,null,null,[30957,30958],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[274,56,0,null,null,null,[30960,30961],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pos",null,"",null,false],[274,64,0,null,null,null,[30963,30964],false],[0,0,0,"self",null,"",null,false],[0,0,0,"amt",null,"",null,false],[274,72,0,null,null,null,[30966],false],[0,0,0,"self",null,"",null,false],[274,80,0,null,null,null,[30968],false],[0,0,0,"self",null,"",null,false],[274,88,0,null,null,null,[30970],false],[0,0,0,"self",null,"",null,false],[274,92,0,null,null,null,[30972],false],[0,0,0,"self",null,"",null,false],[274,96,0,null,null,null,[30974],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null," The stream access is redirected to this buffer.",null,false],[0,0,0,"const_buffer",null," The stream access is redirected to this buffer.\n Writing to the source will always yield `error.AccessDenied`.",null,false],[0,0,0,"file",null," The stream access is redirected to this file.\n On freestanding, this must never be initialized!",null,false],[256,154,0,null,null,null,null,false],[0,0,0,"io/tty.zig",null,"",[],false],[275,0,0,null,null,null,null,false],[275,1,0,null,null,null,null,false],[275,2,0,null,null,null,null,false],[275,3,0,null,null,null,null,false],[275,4,0,null,null,null,null,false],[275,5,0,null,null,null,null,false],[275,10,0,null,null," Detect suitable TTY configuration options for the given file (commonly stdout/stderr).\n This includes feature checks for ANSI escape codes and the Windows console API, as well as\n respecting the `NO_COLOR` and `YES_COLOR` environment variables to override the default.",[30987],false],[0,0,0,"file",null,"",null,false],[275,38,0,null,null,null,[30989,30990,30991,30992,30993,30994,30995,30996,30997,30998,30999,31000,31001,31002,31003,31004,31005,31006,31007],false],[0,0,0,"black",null,null,null,false],[0,0,0,"red",null,null,null,false],[0,0,0,"green",null,null,null,false],[0,0,0,"yellow",null,null,null,false],[0,0,0,"blue",null,null,null,false],[0,0,0,"magenta",null,null,null,false],[0,0,0,"cyan",null,null,null,false],[0,0,0,"white",null,null,null,false],[0,0,0,"bright_black",null,null,null,false],[0,0,0,"bright_red",null,null,null,false],[0,0,0,"bright_green",null,null,null,false],[0,0,0,"bright_yellow",null,null,null,false],[0,0,0,"bright_blue",null,null,null,false],[0,0,0,"bright_magenta",null,null,null,false],[0,0,0,"bright_cyan",null,null,null,false],[0,0,0,"bright_white",null,null,null,false],[0,0,0,"dim",null,null,null,false],[0,0,0,"bold",null,null,null,false],[0,0,0,"reset",null,null,null,false],[275,62,0,null,null," Provides simple functionality for manipulating the terminal in some way,\n such as coloring text, etc.",[31017,31018,31019],false],[275,67,0,null,null,null,[31011,31012],false],[275,67,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[0,0,0,"reset_attributes",null,null,null,false],[275,72,0,null,null,null,[31014,31015,31016],false],[0,0,0,"conf",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"color",null,"",null,false],[0,0,0,"no_color",null,null,null,false],[0,0,0,"escape_codes",null,null,null,false],[0,0,0,"windows_api",null,null,null,false],[256,157,0,null,null," A Writer that doesn't write to anything.",null,false],[256,159,0,null,null,null,null,false],[256,160,0,null,null,null,[31023,31024],false],[0,0,0,"context",null,"",null,false],[0,0,0,"data",null,"",null,false],[256,169,0,null,null,null,[31026,31027,31028],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"StreamEnum",null,"",null,true],[0,0,0,"files",null,"",null,false],[256,209,0,null,null,null,null,false],[256,211,0,null,null,null,[31031],false],[0,0,0,"StreamEnum",null,"",[31047,31049,31051],true],[256,213,0,null,null,null,null,false],[256,214,0,null,null,null,null,false],[256,237,0,null,null,null,null,false],[256,239,0,null,null,null,[31036],false],[0,0,0,"self",null,"",null,false],[256,250,0,null,null,null,[31038],false],[0,0,0,"self",null,"",null,false],[256,258,0,null,null,null,[31040,31041],false],[0,0,0,"self",null,"",null,false],[0,0,0,"which",null,"",null,true],[256,262,0,null,null,null,[31043],false],[0,0,0,"self",null,"",null,false],[256,334,0,null,null,null,[31045],false],[0,0,0,"self",null,"",null,false],[256,212,0,null,null,null,null,false],[0,0,0,"fifos",null,null,null,false],[256,212,0,null,null,null,null,false],[0,0,0,"poll_fds",null,null,null,false],[256,212,0,null,null,null,null,false],[0,0,0,"windows",null,null,null,false],[256,378,0,null,null,null,[31053,31054,31055,31056],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"overlapped",null,"",null,false],[0,0,0,"fifo",null,"",null,false],[0,0,0,"bump_amt",null,"",[31057,31058],false],[0,0,0,"pending",null,null,null,false],[0,0,0,"closed",null,null,null,false],[256,399,0,null,null," Given an enum, returns a struct with fields of that enum, each field\n representing an I/O stream for polling.",[31060],false],[0,0,0,"StreamEnum",null,"",null,true],[1,122,0,null,null," JSON parsing and serialization.",null,false],[0,0,0,"json.zig",null," JSON parsing and stringification conforming to RFC 8259. https://datatracker.ietf.org/doc/html/rfc8259\n\n The low-level `Scanner` API produces `Token`s from an input slice or successive slices of inputs,\n The `Reader` API connects a `std.io.Reader` to a `Scanner`.\n\n The high-level `parseFromSlice` and `parseFromTokenSource` deserialize a JSON document into a Zig type.\n Parse into a dynamically-typed `Value` to load any JSON value for runtime inspection.\n\n The low-level `writeStream` emits syntax-conformant JSON tokens to a `std.io.Writer`.\n The high-level `stringify` serializes a Zig or `Value` type into JSON.\n",[],false],[276,11,0,null,null,null,null,false],[276,12,0,null,null,null,null,false],[276,68,0,null,null,null,null,false],[0,0,0,"json/dynamic.zig",null,"",[],false],[277,0,0,null,null,null,null,false],[277,1,0,null,null,null,null,false],[277,2,0,null,null,null,null,false],[277,3,0,null,null,null,null,false],[277,4,0,null,null,null,null,false],[277,5,0,null,null,null,null,false],[277,7,0,null,null,null,null,false],[0,0,0,"./stringify.zig",null,"",[],false],[278,0,0,null,null,null,null,false],[278,1,0,null,null,null,null,false],[278,2,0,null,null,null,null,false],[278,3,0,null,null,null,null,false],[278,4,0,null,null,null,null,false],[278,6,0,null,null,null,null,false],[278,7,0,null,null,null,null,false],[278,9,0,null,null,null,[31091,31092,31093,31094,31095],false],[278,9,0,null,null,null,[31084,31085,31086,31087,31088,31089,31090],false],[0,0,0,"minified",null,null,null,false],[0,0,0,"indent_1",null,null,null,false],[0,0,0,"indent_2",null,null,null,false],[0,0,0,"indent_3",null,null,null,false],[0,0,0,"indent_4",null,null,null,false],[0,0,0,"indent_8",null,null,null,false],[0,0,0,"indent_tab",null,null,null,false],[0,0,0,"whitespace",null," Controls the whitespace emitted.\n The default `.minified` is a compact encoding with no whitespace between tokens.\n Any setting other than `.minified` will use newlines, indentation, and a space after each ':'.\n `.indent_1` means 1 space for each indentation level, `.indent_2` means 2 spaces, etc.\n `.indent_tab` uses a tab for each indentation level.",null,false],[0,0,0,"emit_null_optional_fields",null," Should optional fields with null value be written?",null,false],[0,0,0,"emit_strings_as_arrays",null," Arrays/slices of u8 are typically encoded as JSON strings.\n This option emits them as arrays of numbers instead.\n Does not affect calls to `objectField()`.",null,false],[0,0,0,"escape_unicode",null," Should unicode characters be escaped in strings?",null,false],[0,0,0,"emit_nonportable_numbers_as_strings",null," When true, renders numbers outside the range `+-1<<53` (the precise integer range of f64) as JSON strings in base 10.",null,false],[278,44,0,null,null," Writes the given value to the `std.io.Writer` stream.\n See `WriteStream` for how the given value is serialized into JSON.\n The maximum nesting depth of the output JSON document is 256.\n See also `stringifyMaxDepth` and `stringifyArbitraryDepth`.",[31097,31098,31099],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[278,58,0,null,null," Like `stringify` with configurable nesting depth.\n `max_depth` is rounded up to the nearest multiple of 8.\n Give `null` for `max_depth` to disable some safety checks and allow arbitrary nesting depth.\n See `writeStreamMaxDepth` for more info.",[31101,31102,31103,31104],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"max_depth",null,"",null,true],[278,71,0,null,null," Like `stringify` but takes an allocator to facilitate safety checks while allowing arbitrary nesting depth.\n These safety checks can be helpful when debugging custom `jsonStringify` implementations;\n See `WriteStream`.",[31106,31107,31108,31109],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[278,86,0,null,null," Calls `stringifyArbitraryDepth` and stores the result in dynamically allocated memory\n instead of taking a `std.io.Writer`.\n\n Caller owns returned memory.",[31111,31112,31113],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[278,101,0,null,null," See `WriteStream` for documentation.\n Equivalent to calling `writeStreamMaxDepth` with a depth of `256`.\n\n The caller does *not* need to call `deinit()` on the returned object.",[31115,31116],false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"options",null,"",null,false],[278,118,0,null,null," See `WriteStream` for documentation.\n The returned object includes 1 bit of size per `max_depth` to enable safety checks on the order of method calls;\n see the grammar in the `WriteStream` documentation.\n `max_depth` is rounded up to the nearest multiple of 8.\n If the nesting depth exceeds `max_depth`, it is detectable illegal behavior.\n Give `null` for `max_depth` to disable safety checks for the grammar and allow arbitrary nesting depth.\n In `ReleaseFast` and `ReleaseSmall`, `max_depth` is ignored, effectively equivalent to passing `null`.\n Alternatively, see `writeStreamArbitraryDepth` to do safety checks to arbitrary depth.\n\n The caller does *not* need to call `deinit()` on the returned object.",[31118,31119,31120],false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"max_depth",null,"",null,true],[278,139,0,null,null," See `WriteStream` for documentation.\n This version of the write stream enables safety checks to arbitrarily deep nesting levels\n by using the given allocator.\n The caller should call `deinit()` on the returned object to free allocated memory.\n\n In `ReleaseFast` and `ReleaseSmall` mode, this function is effectively equivalent to calling `writeStreamMaxDepth(..., null)`;\n in those build modes, the allocator is *not used*.",[31122,31123,31124],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[0,0,0,"options",null,"",null,false],[278,188,0,null,null," Writes JSON ([RFC8259](https://tools.ietf.org/html/rfc8259)) formatted data\n to a stream.\n\n The seqeunce of method calls to write JSON content must follow this grammar:\n ```\n  <once> = <value>\n  <value> =\n    | <object>\n    | <array>\n    | write\n    | print\n  <object> = beginObject ( objectField <value> )* endObject\n  <array> = beginArray ( <value> )* endArray\n ```\n\n Supported types:\n  * Zig `bool` -> JSON `true` or `false`.\n  * Zig `?T` -> `null` or the rendering of `T`.\n  * Zig `i32`, `u64`, etc. -> JSON number or string.\n      * When option `emit_nonportable_numbers_as_strings` is true, if the value is outside the range `+-1<<53` (the precise integer range of f64), it is rendered as a JSON string in base 10. Otherwise, it is rendered as JSON number.\n  * Zig floats -> JSON number or string.\n      * If the value cannot be precisely represented by an f64, it is rendered as a JSON string. Otherwise, it is rendered as JSON number.\n      * TODO: Float rendering will likely change in the future, e.g. to remove the unnecessary \"e+00\".\n  * Zig `[]const u8`, `[]u8`, `*[N]u8`, `@Vector(N, u8)`, and similar -> JSON string.\n      * See `StringifyOptions.emit_strings_as_arrays`.\n      * If the content is not valid UTF-8, rendered as an array of numbers instead.\n  * Zig `[]T`, `[N]T`, `*[N]T`, `@Vector(N, T)`, and similar -> JSON array of the rendering of each item.\n  * Zig tuple -> JSON array of the rendering of each item.\n  * Zig `struct` -> JSON object with each field in declaration order.\n      * If the struct declares a method `pub fn jsonStringify(self: *@This(), jw: anytype) !void`, it is called to do the serialization instead of the default behavior. The given `jw` is a pointer to this `WriteStream`. See `std.json.Value` for an example.\n      * See `StringifyOptions.emit_null_optional_fields`.\n  * Zig `union(enum)` -> JSON object with one field named for the active tag and a value representing the payload.\n      * If the payload is `void`, then the emitted value is `{}`.\n      * If the union declares a method `pub fn jsonStringify(self: *@This(), jw: anytype) !void`, it is called to do the serialization instead of the default behavior. The given `jw` is a pointer to this `WriteStream`.\n  * Zig `enum` -> JSON string naming the active tag.\n      * If the enum declares a method `pub fn jsonStringify(self: *@This(), jw: anytype) !void`, it is called to do the serialization instead of the default behavior. The given `jw` is a pointer to this `WriteStream`.\n  * Zig untyped enum literal -> JSON string naming the active tag.\n  * Zig error -> JSON string naming the error.\n  * Zig `*T` -> the rendering of `T`. Note there is no guard against circular-reference infinite recursion.\n\n In `ReleaseFast` and `ReleaseSmall` mode, the given `safety_checks_hint` is ignored and is always treated as `.assumed_correct`.",[31126,31127],false],[0,0,0,"OutStream",null,"",null,true],[0,0,0,"safety_checks_hint",null,"",[31128,31129,31130],true],[0,0,0,"checked_to_arbitrary_depth",null,null,null,false],[0,0,0,"checked_to_fixed_depth",null,null,null,false],[0,0,0,"assumed_correct",null,null,[31190,31192,31193,31199,31201],false],[278,197,0,null,null,null,null,false],[278,198,0,null,null,null,null,false],[278,203,0,null,null,null,null,false],[278,204,0,null,null,null,null,false],[278,226,0,null,null,null,[31136,31137,31138],false],[0,0,0,"safety_allocator",null,"",null,false],[0,0,0,"stream",null,"",null,false],[0,0,0,"options",null,"",null,false],[278,238,0,null,null,null,[31140],false],[0,0,0,"self",null,"",null,false],[278,246,0,null,null,null,[31142],false],[0,0,0,"self",null,"",null,false],[278,253,0,null,null,null,[31144],false],[0,0,0,"self",null,"",null,false],[278,260,0,null,null,null,[31146],false],[0,0,0,"self",null,"",null,false],[278,273,0,null,null,null,[31148],false],[0,0,0,"self",null,"",null,false],[278,286,0,null,null,null,[31150,31151],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mode",null,"",null,false],[278,300,0,null,null,null,[31153,31154],false],[0,0,0,"self",null,"",null,false],[0,0,0,"assert_its_this_one",null,"",null,false],[278,315,0,null,null,null,[31156],false],[0,0,0,"self",null,"",null,false],[278,333,0,null,null,null,[31158],false],[0,0,0,"self",null,"",null,false],[278,337,0,null,null,null,[31160],false],[0,0,0,"self",null,"",null,false],[278,341,0,null,null,null,[31162],false],[0,0,0,"self",null,"",null,false],[278,364,0,null,null,null,[31164],false],[0,0,0,"self",null,"",null,false],[278,369,0,null,null,null,[31166],false],[0,0,0,"self",null,"",null,false],[278,380,0,null,null,null,[31168],false],[0,0,0,"self",null,"",null,false],[278,389,0,null,null," An alternative to calling `write` that formats a value with `std.fmt`.\n This function does the usual punctuation and indentation formatting\n assuming the resulting formatted string represents a single complete value;\n e.g. `\"1\"`, `\"[]\"`, `\"[1,2]\"`, not `\"1,2\"`.\n This function may be useful for doing your own number formatting.",[31170,31171,31172],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[278,395,0,null,null,null,[31174,31175],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[278,402,0,null,null," See `WriteStream`.",[31177,31178],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[278,573,0,null,null,null,[31180,31181],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[278,579,0,null,null,null,null,false],[278,580,0,null,null,null,null,false],[278,581,0,null,null,null,null,false],[278,582,0,null,null,null,null,false],[278,583,0,null,null,null,null,false],[278,584,0,null,null,null,null,false],[278,585,0,null,null,null,null,false],[278,196,0,null,null,null,null,false],[0,0,0,"options",null,null,null,false],[278,196,0,null,null,null,null,false],[0,0,0,"stream",null,null,null,false],[0,0,0,"indent_level",null,null,null,false],[278,196,0,null,null,null,[31195,31196,31197,31198],false],[0,0,0,"the_beginning",null,null,null,false],[0,0,0,"none",null,null,null,false],[0,0,0,"comma",null,null,null,false],[0,0,0,"colon",null,null,null,false],[0,0,0,"next_punctuation",null,null,null,false],[278,196,0,null,null,null,null,false],[0,0,0,"nesting_stack",null,null,null,false],[278,589,0,null,null,null,[31203,31204],false],[0,0,0,"codepoint",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[278,609,0,null,null,null,[31206,31207],false],[0,0,0,"c",null,"",null,false],[0,0,0,"writer",null,"",null,false],[278,623,0,null,null," Write `string` to `writer` as a JSON encoded string.",[31209,31210,31211],false],[0,0,0,"string",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[278,630,0,null,null," Write `chars` to `writer` as JSON encoded string characters.",[31213,31214,31215],false],[0,0,0,"chars",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[277,8,0,null,null,null,null,false],[277,10,0,null,null,null,null,false],[0,0,0,"./static.zig",null,"",[],false],[279,0,0,null,null,null,null,false],[279,1,0,null,null,null,null,false],[279,2,0,null,null,null,null,false],[279,3,0,null,null,null,null,false],[279,4,0,null,null,null,null,false],[279,6,0,null,null,null,null,false],[0,0,0,"./scanner.zig",null,"",[],false],[280,30,0,null,null,null,null,false],[280,32,0,null,null,null,null,false],[280,33,0,null,null,null,null,false],[280,34,0,null,null,null,null,false],[280,35,0,null,null,null,null,false],[280,41,0,null,null," Scan the input and check for malformed JSON.\n On `SyntaxError` or `UnexpectedEndOfInput`, returns `false`.\n Returns any errors from the allocator as-is, which is unlikely,\n but can be caused by extreme nesting depth in the input.",[31232,31233],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"s",null,"",null,false],[280,63,0,null,null," The parsing errors are divided into two categories:\n  * `SyntaxError` is for clearly malformed JSON documents,\n    such as giving an input document that isn't JSON at all.\n  * `UnexpectedEndOfInput` is for signaling that everything's been\n    valid so far, but the input appears to be truncated for some reason.\n Note that a completely empty (or whitespace-only) input will give `UnexpectedEndOfInput`.",null,false],[280,66,0,null,null," Calls `std.json.Reader` with `std.json.default_buffer_size`.",[31236,31237],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"io_reader",null,"",null,false],[280,70,0,null,null," Used by `json.reader`.",null,false],[280,151,0,null,null," The tokens emitted by `std.json.Scanner` and `std.json.Reader` `.next*()` functions follow this grammar:\n ```\n  <document> = <value> .end_of_document\n  <value> =\n    | <object>\n    | <array>\n    | <number>\n    | <string>\n    | .true\n    | .false\n    | .null\n  <object> = .object_begin ( <string> <value> )* .object_end\n  <array> = .array_begin ( <value> )* .array_end\n  <number> = <It depends. See below.>\n  <string> = <It depends. See below.>\n ```\n\n What you get for `<number>` and `<string>` values depends on which `next*()` method you call:\n\n ```\n next():\n  <number> = ( .partial_number )* .number\n  <string> = ( <partial_string> )* .string\n  <partial_string> =\n    | .partial_string\n    | .partial_string_escaped_1\n    | .partial_string_escaped_2\n    | .partial_string_escaped_3\n    | .partial_string_escaped_4\n\n nextAlloc*(..., .alloc_always):\n  <number> = .allocated_number\n  <string> = .allocated_string\n\n nextAlloc*(..., .alloc_if_needed):\n  <number> =\n    | .number\n    | .allocated_number\n  <string> =\n    | .string\n    | .allocated_string\n ```\n\n For all tokens with a `[]const u8`, `[]u8`, or `[n]u8` payload, the payload represents the content of the value.\n For number values, this is the representation of the number exactly as it appears in the input.\n For strings, this is the content of the string after resolving escape sequences.\n\n For `.allocated_number` and `.allocated_string`, the `[]u8` payloads are allocations made with the given allocator.\n You are responsible for managing that memory. `json.Reader.deinit()` does *not* free those allocations.\n\n The `.partial_*` tokens indicate that a value spans multiple input buffers or that a string contains escape sequences.\n To get a complete value in memory, you need to concatenate the values yourself.\n Calling `nextAlloc*()` does this for you, and returns an `.allocated_*` token with the result.\n\n For tokens with a `[]const u8` payload, the payload is a slice into the current input buffer.\n The memory may become undefined during the next call to `json.Scanner.feedInput()`\n or any `json.Reader` method whose return error set includes `json.Error`.\n To keep the value persistently, it recommended to make a copy or to use `.alloc_always`,\n which makes a copy for you.\n\n Note that `.number` and `.string` tokens that follow `.partial_*` tokens may have `0` length to indicate that\n the previously partial value is completed with no additional bytes.\n (This can happen when the break between input buffers happens to land on the exact end of a value. E.g. `\"[1234\"`, `\"]\"`.)\n `.partial_*` tokens never have `0` length.\n\n The recommended strategy for using the different `next*()` methods is something like this:\n\n When you're expecting an object key, use `.alloc_if_needed`.\n You often don't need a copy of the key string to persist; you might just check which field it is.\n In the case that the key happens to require an allocation, free it immediately after checking it.\n\n When you're expecting a meaningful string value (such as on the right of a `:`),\n use `.alloc_always` in order to keep the value valid throughout parsing the rest of the document.\n\n When you're expecting a number value, use `.alloc_if_needed`.\n You're probably going to be parsing the string representation of the number into a numeric representation,\n so you need the complete string representation only temporarily.\n\n When you're skipping an unrecognized value, use `skipValue()`.",[31240,31241,31242,31243,31244,31245,31246,31247,31248,31249,31250,31251,31252,31253,31254,31255,31256,31257],false],[0,0,0,"object_begin",null,null,null,false],[0,0,0,"object_end",null,null,null,false],[0,0,0,"array_begin",null,null,null,false],[0,0,0,"array_end",null,null,null,false],[0,0,0,"true",null,null,null,false],[0,0,0,"false",null,null,null,false],[0,0,0,"null",null,null,null,false],[0,0,0,"number",null,null,null,false],[0,0,0,"partial_number",null,null,null,false],[0,0,0,"allocated_number",null,null,null,false],[0,0,0,"string",null,null,null,false],[0,0,0,"partial_string",null,null,null,false],[0,0,0,"partial_string_escaped_1",null,null,null,false],[0,0,0,"partial_string_escaped_2",null,null,null,false],[0,0,0,"partial_string_escaped_3",null,null,null,false],[0,0,0,"partial_string_escaped_4",null,null,null,false],[0,0,0,"allocated_string",null,null,null,false],[0,0,0,"end_of_document",null,null,null,false],[280,177,0,null,null," This is only used in `peekNextTokenType()` and gives a categorization based on the first byte of the next token that will be emitted from a `next*()` call.",[31259,31260,31261,31262,31263,31264,31265,31266,31267,31268],false],[0,0,0,"object_begin",null,null,null,false],[0,0,0,"object_end",null,null,null,false],[0,0,0,"array_begin",null,null,null,false],[0,0,0,"array_end",null,null,null,false],[0,0,0,"true",null,null,null,false],[0,0,0,"false",null,null,null,false],[0,0,0,"null",null,null,null,false],[0,0,0,"number",null,null,null,false],[0,0,0,"string",null,null,null,false],[0,0,0,"end_of_document",null,null,null,false],[280,194,0,null,null," To enable diagnostics, declare `var diagnostics = Diagnostics{};` then call `source.enableDiagnostics(&diagnostics);`\n where `source` is either a `std.json.Reader` or a `std.json.Scanner` that has just been initialized.\n At any time, notably just after an error, call `getLine()`, `getColumn()`, and/or `getByteOffset()`\n to get meaningful information from this.",[31276,31277,31278,31280],false],[280,201,0,null,null," Starts at 1.",[31271],false],[0,0,0,"self",null,"",null,false],[280,205,0,null,null," Starts at 1.",[31273],false],[0,0,0,"self",null,"",null,false],[280,209,0,null,null," Starts at 0. Measures the byte offset since the start of the input.",[31275],false],[0,0,0,"self",null,"",null,false],[0,0,0,"line_number",null,null,null,false],[0,0,0,"line_start_cursor",null,null,null,false],[0,0,0,"total_bytes_before_current_input",null,null,null,false],[280,194,0,null,null,null,null,false],[0,0,0,"cursor_pointer",null,null,null,false],[280,215,0,null,null," See the documentation for `std.json.Token`.",[31282,31283],false],[0,0,0,"alloc_if_needed",null,null,null,false],[0,0,0,"alloc_always",null,null,null,false],[280,219,0,null,null," For security, the maximum size allocated to store a single string or number value is limited to 4MiB by default.\n This limit can be specified by calling `nextAllocMax()` instead of `nextAlloc()`.",null,false],[280,223,0,null,null," Connects a `std.io.Reader` to a `std.json.Scanner`.\n All `next*()` methods here handle `error.BufferUnderrun` from `std.json.Scanner`, and then read from the reader.",[31286,31287],false],[0,0,0,"buffer_size",null,"",null,true],[0,0,0,"ReaderType",null,"",[31335,31337,31339],true],[280,231,0,null,null," The allocator is only used to track `[]` and `{}` nesting levels.",[31289,31290],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"io_reader",null,"",null,false],[280,237,0,null,null,null,[31292],false],[0,0,0,"self",null,"",null,false],[280,243,0,null,null," Calls `std.json.Scanner.enableDiagnostics`.",[31294,31295],false],[0,0,0,"self",null,"",null,false],[0,0,0,"diagnostics",null,"",null,false],[280,247,0,null,null,null,null,false],[280,248,0,null,null,null,null,false],[280,249,0,null,null,null,null,false],[280,250,0,null,null,null,null,false],[280,254,0,null,null," Equivalent to `nextAllocMax(allocator, when, default_max_value_len);`\n See also `std.json.Token` for documentation of `nextAlloc*()` function behavior.",[31301,31302,31303],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"when",null,"",null,false],[280,258,0,null,null," See also `std.json.Token` for documentation of `nextAlloc*()` function behavior.",[31305,31306,31307,31308],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"when",null,"",null,false],[0,0,0,"max_value_len",null,"",null,false],[280,293,0,null,null," Equivalent to `allocNextIntoArrayListMax(value_list, when, default_max_value_len);`",[31310,31311,31312],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value_list",null,"",null,false],[0,0,0,"when",null,"",null,false],[280,297,0,null,null," Calls `std.json.Scanner.allocNextIntoArrayListMax` and handles `error.BufferUnderrun`.",[31314,31315,31316,31317],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value_list",null,"",null,false],[0,0,0,"when",null,"",null,false],[0,0,0,"max_value_len",null,"",null,false],[280,310,0,null,null," Like `std.json.Scanner.skipValue`, but handles `error.BufferUnderrun`.",[31319],false],[0,0,0,"self",null,"",null,false],[280,340,0,null,null," Like `std.json.Scanner.skipUntilStackHeight()` but handles `error.BufferUnderrun`.",[31321,31322],false],[0,0,0,"self",null,"",null,false],[0,0,0,"terminal_stack_height",null,"",null,false],[280,353,0,null,null," Calls `std.json.Scanner.stackHeight`.",[31324],false],[0,0,0,"self",null,"",null,false],[280,357,0,null,null," Calls `std.json.Scanner.ensureTotalStackCapacity`.",[31326,31327],false],[0,0,0,"self",null,"",null,false],[0,0,0,"height",null,"",null,false],[280,362,0,null,null," See `std.json.Token` for documentation of this function.",[31329],false],[0,0,0,"self",null,"",null,false],[280,375,0,null,null," See `std.json.Scanner.peekNextTokenType()`.",[31331],false],[0,0,0,"self",null,"",null,false],[280,387,0,null,null,null,[31333],false],[0,0,0,"self",null,"",null,false],[280,224,0,null,null,null,null,false],[0,0,0,"scanner",null,null,null,false],[280,224,0,null,null,null,null,false],[0,0,0,"reader",null,null,null,false],[280,224,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[280,411,0,null,null," The lowest level parsing API in this package;\n supports streaming input with a low memory footprint.\n The memory requirement is `O(d)` where d is the nesting depth of `[]` or `{}` containers in the input.\n Specifically `d/8` bytes are required for this purpose,\n with some extra buffer according to the implementation of `std.ArrayList`.\n\n This scanner can emit partial tokens; see `std.json.Token`.\n The input to this class is a sequence of input buffers that you must supply one at a time.\n Call `feedInput()` with the first buffer, then call `next()` repeatedly until `error.BufferUnderrun` is returned.\n Then call `feedInput()` again and so forth.\n Call `endInput()` when the last input buffer has been given to `feedInput()`, either immediately after calling `feedInput()`,\n or when `error.BufferUnderrun` requests more data and there is no more.\n Be sure to call `next()` after calling `endInput()` until `Token.end_of_document` has been returned.",[31452,31453,31455,31456,31458,31460,31461,31462,31464],false],[280,424,0,null,null," The allocator is only used to track `[]` and `{}` nesting levels.",[31342],false],[0,0,0,"allocator",null,"",null,false],[280,436,0,null,null," Use this if your input is a single slice.\n This is effectively equivalent to:\n ```\n initStreaming(allocator);\n feedInput(complete_input);\n endInput();\n ```",[31344,31345],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"complete_input",null,"",null,false],[280,443,0,null,null,null,[31347],false],[0,0,0,"self",null,"",null,false],[280,448,0,null,null,null,[31349,31350],false],[0,0,0,"self",null,"",null,false],[0,0,0,"diagnostics",null,"",null,false],[280,455,0,null,null," Call this whenever you get `error.BufferUnderrun` from `next()`.\n When there is no more input to provide, call `endInput()`.",[31352,31353],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input",null,"",null,false],[280,471,0,null,null," Call this when you will no longer call `feedInput()` anymore.\n This can be called either immediately after the last `feedInput()`,\n or at any time afterward, such as when getting `error.BufferUnderrun` from `next()`.\n Don't forget to call `next*()` after `endInput()` until you get `.end_of_document`.",[31355],false],[0,0,0,"self",null,"",null,false],[280,475,0,null,null,null,null,false],[280,476,0,null,null,null,null,false],[280,477,0,null,null,null,null,false],[280,478,0,null,null,null,null,false],[280,479,0,null,null,null,null,false],[280,484,0,null,null," Equivalent to `nextAllocMax(allocator, when, default_max_value_len);`\n This function is only available after `endInput()` (or `initCompleteInput()`) has been called.\n See also `std.json.Token` for documentation of `nextAlloc*()` function behavior.",[31362,31363,31364],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"when",null,"",null,false],[280,490,0,null,null," This function is only available after `endInput()` (or `initCompleteInput()`) has been called.\n See also `std.json.Token` for documentation of `nextAlloc*()` function behavior.",[31366,31367,31368,31369],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"when",null,"",null,false],[0,0,0,"max_value_len",null,"",null,false],[280,535,0,null,null," Equivalent to `allocNextIntoArrayListMax(value_list, when, default_max_value_len);`",[31371,31372,31373],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value_list",null,"",null,false],[0,0,0,"when",null,"",null,false],[280,548,0,null,null," The next token type must be either `.number` or `.string`. See `peekNextTokenType()`.\n When allocation is not necessary with `.alloc_if_needed`,\n this method returns the content slice from the input buffer, and `value_list` is not touched.\n When allocation is necessary or with `.alloc_always`, this method concatenates partial tokens into the given `value_list`,\n and returns `null` once the final `.number` or `.string` token has been written into it.\n In case of an `error.BufferUnderrun`, partial values will be left in the given value_list.\n The given `value_list` is never reset by this method, so an `error.BufferUnderrun` situation\n can be resumed by passing the same array list in again.\n This method does not indicate whether the token content being returned is for a `.number` or `.string` token type;\n the caller of this method is expected to know which type of token is being processed.",[31375,31376,31377,31378],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value_list",null,"",null,false],[0,0,0,"when",null,"",null,false],[0,0,0,"max_value_len",null,"",null,false],[280,612,0,null,null," This function is only available after `endInput()` (or `initCompleteInput()`) has been called.\n If the next token type is `.object_begin` or `.array_begin`,\n this function calls `next()` repeatedly until the corresponding `.object_end` or `.array_end` is found.\n If the next token type is `.number` or `.string`,\n this function calls `next()` repeatedly until the (non `.partial_*`) `.number` or `.string` token is found.\n If the next token type is `.true`, `.false`, or `.null`, this function calls `next()` once.\n The next token type must not be `.object_end`, `.array_end`, or `.end_of_document`;\n see `peekNextTokenType()`.",[31380],false],[0,0,0,"self",null,"",null,false],[280,657,0,null,null," Skip tokens until an `.object_end` or `.array_end` token results in a `stackHeight()` equal the given stack height.\n Unlike `skipValue()`, this function is available in streaming mode.",[31382,31383],false],[0,0,0,"self",null,"",null,false],[0,0,0,"terminal_stack_height",null,"",null,false],[280,670,0,null,null," The depth of `{}` or `[]` nesting levels at the current position.",[31385],false],[0,0,0,"self",null,"",null,false],[280,676,0,null,null," Pre allocate memory to hold the given number of nesting levels.\n `stackHeight()` up to the given number will not cause allocations.",[31387,31388],false],[0,0,0,"self",null,"",null,false],[0,0,0,"height",null,"",null,false],[280,681,0,null,null," See `std.json.Token` for documentation of this function.",[31390],false],[0,0,0,"self",null,"",null,false],[280,1434,0,null,null," Seeks ahead in the input until the first byte of the next token (or the end of the input)\n determines which type of token will be returned from the next `next*()` call.\n This function is idempotent, only advancing past commas, colons, and inter-token whitespace.",[31392],false],[0,0,0,"self",null,"",null,false],[280,1560,0,null,null,null,[31394,31395,31396,31397,31398,31399,31400,31401,31402,31403,31404,31405,31406,31407,31408,31409,31410,31411,31412,31413,31414,31415,31416,31417,31418,31419,31420,31421,31422,31423,31424,31425,31426,31427,31428,31429,31430,31431,31432,31433,31434,31435],false],[0,0,0,"value",null,null,null,false],[0,0,0,"post_value",null,null,null,false],[0,0,0,"object_start",null,null,null,false],[0,0,0,"object_post_comma",null,null,null,false],[0,0,0,"array_start",null,null,null,false],[0,0,0,"number_minus",null,null,null,false],[0,0,0,"number_leading_zero",null,null,null,false],[0,0,0,"number_int",null,null,null,false],[0,0,0,"number_post_dot",null,null,null,false],[0,0,0,"number_frac",null,null,null,false],[0,0,0,"number_post_e",null,null,null,false],[0,0,0,"number_post_e_sign",null,null,null,false],[0,0,0,"number_exp",null,null,null,false],[0,0,0,"string",null,null,null,false],[0,0,0,"string_backslash",null,null,null,false],[0,0,0,"string_backslash_u",null,null,null,false],[0,0,0,"string_backslash_u_1",null,null,null,false],[0,0,0,"string_backslash_u_2",null,null,null,false],[0,0,0,"string_backslash_u_3",null,null,null,false],[0,0,0,"string_surrogate_half",null,null,null,false],[0,0,0,"string_surrogate_half_backslash",null,null,null,false],[0,0,0,"string_surrogate_half_backslash_u",null,null,null,false],[0,0,0,"string_surrogate_half_backslash_u_1",null,null,null,false],[0,0,0,"string_surrogate_half_backslash_u_2",null,null,null,false],[0,0,0,"string_surrogate_half_backslash_u_3",null,null,null,false],[0,0,0,"string_utf8_last_byte",null,null,null,false],[0,0,0,"string_utf8_second_to_last_byte",null,null,null,false],[0,0,0,"string_utf8_second_to_last_byte_guard_against_overlong",null,null,null,false],[0,0,0,"string_utf8_second_to_last_byte_guard_against_surrogate_half",null,null,null,false],[0,0,0,"string_utf8_third_to_last_byte",null,null,null,false],[0,0,0,"string_utf8_third_to_last_byte_guard_against_overlong",null,null,null,false],[0,0,0,"string_utf8_third_to_last_byte_guard_against_too_large",null,null,null,false],[0,0,0,"literal_t",null,null,null,false],[0,0,0,"literal_tr",null,null,null,false],[0,0,0,"literal_tru",null,null,null,false],[0,0,0,"literal_f",null,null,null,false],[0,0,0,"literal_fa",null,null,null,false],[0,0,0,"literal_fal",null,null,null,false],[0,0,0,"literal_fals",null,null,null,false],[0,0,0,"literal_n",null,null,null,false],[0,0,0,"literal_nu",null,null,null,false],[0,0,0,"literal_nul",null,null,null,false],[280,1612,0,null,null,null,[31437],false],[0,0,0,"self",null,"",null,false],[280,1621,0,null,null,null,[31439],false],[0,0,0,"self",null,"",null,false],[280,1640,0,null,null,null,[31441],false],[0,0,0,"self",null,"",null,false],[280,1645,0,null,null,null,[31443],false],[0,0,0,"self",null,"",null,false],[280,1663,0,null,null,null,[31445],false],[0,0,0,"self",null,"",null,false],[280,1669,0,null,null,null,[31447,31448],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allow_end",null,"",null,false],[280,1680,0,null,null,null,[31450],false],[0,0,0,"code_point",null,"",null,false],[280,411,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"string_is_object_key",null,null,null,false],[280,411,0,null,null,null,null,false],[0,0,0,"stack",null,null,null,false],[0,0,0,"value_start",null,null,null,false],[280,411,0,null,null,null,null,false],[0,0,0,"utf16_code_units",null,null,null,false],[280,411,0,null,null,null,null,false],[0,0,0,"input",null,null,null,false],[0,0,0,"cursor",null,null,null,false],[0,0,0,"is_end_of_input",null,null,null,false],[280,411,0,null,null,null,null,false],[0,0,0,"diagnostics",null,null,null,false],[280,1692,0,null,null,null,null,false],[280,1693,0,null,null,null,null,false],[280,1695,0,null,null,null,[31468,31469,31470],false],[0,0,0,"list",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"max_value_len",null,"",null,false],[280,1706,0,null,null," For the slice you get from a `Token.number` or `Token.allocated_number`,\n this function returns true if the number doesn't contain any fraction or exponent components.\n Note, the numeric value encoded by the value may still be an integer, such as `1.0`.\n This function is meant to give a hint about whether integer parsing or float parsing should be used on the value.\n This function will not give meaningful results on non-numeric input.",[31472],false],[0,0,0,"value",null,"",null,false],[279,7,0,null,null,null,null,false],[279,8,0,null,null,null,null,false],[279,9,0,null,null,null,null,false],[279,10,0,null,null,null,null,false],[279,12,0,null,null,null,null,false],[279,13,0,null,null,null,null,false],[279,18,0,null,null," Controls how to deal with various inconsistencies between the JSON document and the Zig struct type passed in.\n For duplicate fields or unknown fields, set options in this struct.\n For missing fields, give the Zig struct fields default values.",[31484,31485,31487,31489],false],[279,18,0,null,null,null,[31481,31482,31483],false],[0,0,0,"use_first",null,null,null,false],[0,0,0,"error",null,null,null,false],[0,0,0,"use_last",null,null,null,false],[0,0,0,"duplicate_field_behavior",null," Behaviour when a duplicate field is encountered.\n The default is to return `error.DuplicateField`.",null,false],[0,0,0,"ignore_unknown_fields",null," If false, finding an unknown field returns `error.UnknownField`.",null,false],[279,18,0,null,null,null,null,false],[0,0,0,"max_value_len",null," Passed to `std.json.Scanner.nextAllocMax` or `std.json.Reader.nextAllocMax`.\n The default for `parseFromSlice` or `parseFromTokenSource` with a `*std.json.Scanner` input\n is the length of the input slice, which means `error.ValueTooLong` will never be returned.\n The default for `parseFromTokenSource` with a `*std.json.Reader` is `std.json.default_max_value_len`.\n Ignored for `parseFromValue` and `parseFromValueLeaky`.",null,false],[279,18,0,null,null,null,null,false],[0,0,0,"allocate",null," This determines whether strings should always be copied,\n or if a reference to the given buffer should be preferred if possible.\n The default for `parseFromSlice` or `parseFromTokenSource` with a `*std.json.Scanner` input\n is `.alloc_if_needed`.\n The default with a `*std.json.Reader` input is `.alloc_always`.\n Ignored for `parseFromValue` and `parseFromValueLeaky`.",null,false],[279,46,0,null,null,null,[31491],false],[0,0,0,"T",null,"",[31495,31497],true],[279,51,0,null,null,null,[31493],false],[0,0,0,"self",null,"",null,false],[279,47,0,null,null,null,null,false],[0,0,0,"arena",null,null,null,false],[279,47,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[279,63,0,null,null," Parses the json document from `s` and returns the result packaged in a `std.json.Parsed`.\n You must call `deinit()` of the returned object to clean up allocated resources.\n If you are using a `std.heap.ArenaAllocator` or similar, consider calling `parseFromSliceLeaky` instead.\n Note that `error.BufferUnderrun` is not actually possible to return from this function.",[31499,31500,31501,31502],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,78,0,null,null," Parses the json document from `s` and returns the result.\n Allocations made during this operation are not carefully tracked and may not be possible to individually clean up.\n It is recommended to use a `std.heap.ArenaAllocator` or similar.",[31504,31505,31506,31507],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,92,0,null,null," `scanner_or_reader` must be either a `*std.json.Scanner` with complete input or a `*std.json.Reader`.\n Note that `error.BufferUnderrun` is not actually possible to return from this function.",[31509,31510,31511,31512],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"scanner_or_reader",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,114,0,null,null," `scanner_or_reader` must be either a `*std.json.Scanner` with complete input or a `*std.json.Reader`.\n Allocations made during this operation are not carefully tracked and may not be possible to individually clean up.\n It is recommended to use a `std.heap.ArenaAllocator` or similar.",[31514,31515,31516,31517],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"scanner_or_reader",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,148,0,null,null," Like `parseFromSlice`, but the input is an already-parsed `std.json.Value` object.\n Only `options.ignore_unknown_fields` is used from `options`.",[31519,31520,31521,31522],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,167,0,null,null,null,[31524,31525,31526,31527],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,181,0,null,null," The error set that will be returned when parsing from `*Source`.\n Note that this may contain `error.BufferUnderrun`, but that error will never actually be returned.",[31529],false],[0,0,0,"Source",null,"",null,true],[279,187,0,null,null,null,null,false],[279,205,0,null,null," This is an internal function called recursively\n during the implementation of `parseFromTokenSourceLeaky` and similar.\n It is exposed primarily to enable custom `jsonParse()` methods to call back into the `parseFrom*` system,\n such as if you're implementing a custom container of type `T`;\n you can call `innerParse(T, ...)` for each of the container's items.\n Note that `null` fields are not allowed on the `options` when calling this function.\n (The `options` you get in your `jsonParse` method has no `null` fields.)",[31532,31533,31534,31535],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,510,0,null,null,null,[31537,31538,31539,31540,31541,31542],false],[0,0,0,"T",null,"",null,true],[0,0,0,"Child",null,"",null,true],[0,0,0,"len",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,536,0,null,null," This is an internal function called recursively\n during the implementation of `parseFromValueLeaky`.\n It is exposed primarily to enable custom `jsonParseFromValue()` methods to call back into the `parseFromValue*` system,\n such as if you're implementing a custom container of type `T`;\n you can call `innerParseFromValue(T, ...)` for each of the container's items.",[31544,31545,31546,31547],false],[0,0,0,"T",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,740,0,null,null,null,[31549,31550,31551,31552,31553,31554],false],[0,0,0,"T",null,"",null,true],[0,0,0,"Child",null,"",null,true],[0,0,0,"len",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"array",null,"",null,false],[0,0,0,"options",null,"",null,false],[279,758,0,null,null,null,[31556,31557],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[279,768,0,null,null,null,[31559,31560],false],[0,0,0,"T",null,"",null,true],[0,0,0,"slice",null,"",null,false],[279,777,0,null,null,null,[31562,31563,31564],false],[0,0,0,"T",null,"",null,true],[0,0,0,"r",null,"",null,false],[0,0,0,"fields_seen",null,"",null,false],[279,790,0,null,null,null,[31566,31567],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"token",null,"",null,false],[277,11,0,null,null,null,null,false],[277,13,0,null,null,null,null,false],[277,14,0,null,null,null,null,false],[277,15,0,null,null,null,null,false],[277,16,0,null,null,null,null,false],[277,18,0,null,null,null,null,false],[277,19,0,null,null,null,null,false],[277,24,0,null,null," Represents any JSON value, potentially containing other JSON values.\n A .float value may be an approximation of the original value.\n Arbitrary precision numbers can be represented by .number_string values.",[31591,31592,31593,31594,31595,31596,31597,31598],false],[277,34,0,null,null,null,[31577],false],[0,0,0,"s",null,"",null,false],[277,53,0,null,null,null,[31579],false],[0,0,0,"self",null,"",null,false],[277,61,0,null,null,null,[31581,31582],false],[0,0,0,"value",null,"",null,false],[0,0,0,"jws",null,"",null,false],[277,82,0,null,null,null,[31584,31585,31586],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[277,128,0,null,null,null,[31588,31589,31590],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"null",null,null,null,false],[0,0,0,"bool",null,null,null,false],[0,0,0,"integer",null,null,null,false],[0,0,0,"float",null,null,null,false],[0,0,0,"number_string",null,null,null,false],[0,0,0,"string",null,null,null,false],[0,0,0,"array",null,null,null,false],[0,0,0,"object",null,null,null,false],[277,135,0,null,null,null,[31600,31601,31602,31603,31604],false],[0,0,0,"stack",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"value_",null,"",null,false],[0,0,0,"options",null,"",null,false],[276,69,0,null,null,null,null,false],[276,70,0,null,null,null,null,false],[276,72,0,null,null,null,null,false],[0,0,0,"json/hashmap.zig",null,"",[],false],[281,0,0,null,null,null,null,false],[281,1,0,null,null,null,null,false],[281,3,0,null,null,null,null,false],[281,4,0,null,null,null,null,false],[281,5,0,null,null,null,null,false],[281,6,0,null,null,null,null,false],[281,12,0,null,null," A thin wrapper around `std.StringArrayHashMapUnmanaged` that implements\n `jsonParse`, `jsonParseFromValue`, and `jsonStringify`.\n This is useful when your JSON schema has an object with arbitrary data keys\n instead of comptime-known struct field names.",[31616],false],[0,0,0,"T",null,"",[31632],true],[281,16,0,null,null,null,[31618,31619],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[281,20,0,null,null,null,[31621,31622,31623],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[281,51,0,null,null,null,[31625,31626,31627],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"options",null,"",null,false],[281,64,0,null,null,null,[31629,31630],false],[0,0,0,"self",null,"",null,false],[0,0,0,"jws",null,"",null,false],[281,13,0,null,null,null,null,false],[0,0,0,"map",null,null,null,false],[276,74,0,null,null,null,null,false],[276,75,0,null,null,null,null,false],[276,76,0,null,null,null,null,false],[276,77,0,null,null,null,null,false],[276,78,0,null,null,null,null,false],[276,79,0,null,null,null,null,false],[276,80,0,null,null,null,null,false],[276,81,0,null,null,null,null,false],[276,82,0,null,null,null,null,false],[276,83,0,null,null,null,null,false],[276,84,0,null,null,null,null,false],[276,85,0,null,null,null,null,false],[276,87,0,null,null,null,null,false],[276,88,0,null,null,null,null,false],[276,89,0,null,null,null,null,false],[276,90,0,null,null,null,null,false],[276,91,0,null,null,null,null,false],[276,92,0,null,null,null,null,false],[276,93,0,null,null,null,null,false],[276,94,0,null,null,null,null,false],[276,95,0,null,null,null,null,false],[276,96,0,null,null,null,null,false],[276,97,0,null,null,null,null,false],[276,98,0,null,null,null,null,false],[276,100,0,null,null,null,null,false],[276,101,0,null,null,null,null,false],[276,102,0,null,null,null,null,false],[276,103,0,null,null,null,null,false],[276,104,0,null,null,null,null,false],[276,105,0,null,null,null,null,false],[276,106,0,null,null,null,null,false],[276,107,0,null,null,null,null,false],[276,108,0,null,null,null,null,false],[276,109,0,null,null,null,null,false],[276,110,0,null,null,null,null,false],[276,112,0,null,null,null,null,false],[0,0,0,"json/fmt.zig",null,"",[],false],[282,0,0,null,null,null,null,false],[282,2,0,null,null,null,null,false],[282,3,0,null,null,null,null,false],[282,6,0,null,null," Returns a formatter that formats the given value using stringify.",[31674,31675],false],[0,0,0,"value",null,"",null,false],[0,0,0,"options",null,"",null,false],[282,11,0,null,null," Formats the given value using stringify.",[31677],false],[0,0,0,"T",null,"",[31684,31686],true],[282,16,0,null,null,null,[31679,31680,31681,31682],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt_spec",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[282,12,0,null,null,null,null,false],[0,0,0,"value",null,null,null,false],[282,12,0,null,null,null,null,false],[0,0,0,"options",null,null,null,false],[282,29,0,"fmt","test fmt {\n    const expectFmt = std.testing.expectFmt;\n    try expectFmt(\"123\", \"{}\", .{fmt(@as(u32, 123), .{})});\n    try expectFmt(\n        \\\\{\"num\":927,\"msg\":\"hello\",\"sub\":{\"mybool\":true}}\n    , \"{}\", .{fmt(struct {\n        num: u32,\n        msg: []const u8,\n        sub: struct {\n            mybool: bool,\n        },\n    }{\n        .num = 927,\n        .msg = \"hello\",\n        .sub = .{ .mybool = true },\n    }, .{})});\n}",null,null,false],[276,113,0,null,null,null,null,false],[276,116,0,null,null,null,null,false],[276,117,0,null,null,null,null,false],[276,118,0,null,null,null,null,false],[276,119,0,null,null,null,null,false],[276,120,0,null,null,null,null,false],[276,121,0,null,null,null,null,false],[276,14,0,"Scanner","test Scanner {\n    var scanner = Scanner.initCompleteInput(testing.allocator, \"{\\\"foo\\\": 123}\\n\");\n    defer scanner.deinit();\n    try testing.expectEqual(Token.object_begin, try scanner.next());\n    try testing.expectEqualSlices(u8, \"foo\", (try scanner.next()).string);\n    try testing.expectEqualSlices(u8, \"123\", (try scanner.next()).number);\n    try testing.expectEqual(Token.object_end, try scanner.next());\n    try testing.expectEqual(Token.end_of_document, try scanner.next());\n}",null,null,false],[276,24,0,"parseFromSlice","test parseFromSlice {\n    var parsed_str = try parseFromSlice([]const u8, testing.allocator, \"\\\"a\\\\u0020b\\\"\", .{});\n    defer parsed_str.deinit();\n    try testing.expectEqualSlices(u8, \"a b\", parsed_str.value);\n\n    const T = struct { a: i32 = -1, b: [2]u8 };\n    var parsed_struct = try parseFromSlice(T, testing.allocator, \"{\\\"b\\\":\\\"xy\\\"}\", .{});\n    defer parsed_struct.deinit();\n    try testing.expectEqual(@as(i32, -1), parsed_struct.value.a); // default value\n    try testing.expectEqualSlices(u8, \"xy\", parsed_struct.value.b[0..]);\n}",null,null,false],[276,36,0,"Value","test Value {\n    var parsed = try parseFromSlice(Value, testing.allocator, \"{\\\"anything\\\": \\\"goes\\\"}\", .{});\n    defer parsed.deinit();\n    try testing.expectEqualSlices(u8, \"goes\", parsed.value.object.get(\"anything\").?.string);\n}",null,null,false],[276,42,0,"writeStream","test writeStream {\n    var out = ArrayList(u8).init(testing.allocator);\n    defer out.deinit();\n    var write_stream = writeStream(out.writer(), .{ .whitespace = .indent_2 });\n    defer write_stream.deinit();\n    try write_stream.beginObject();\n    try write_stream.objectField(\"foo\");\n    try write_stream.write(123);\n    try write_stream.endObject();\n    const expected =\n        \\\\{\n        \\\\  \"foo\": 123\n        \\\\}\n    ;\n    try testing.expectEqualSlices(u8, expected, out.items);\n}",null,null,false],[276,59,0,"stringify","test stringify {\n    var out = ArrayList(u8).init(testing.allocator);\n    defer out.deinit();\n\n    const T = struct { a: i32, b: []const u8 };\n    try stringify(T{ .a = 123, .b = \"xy\" }, .{}, out.writer());\n    try testing.expectEqualSlices(u8, \"{\\\"a\\\":123,\\\"b\\\":\\\"xy\\\"}\", out.items);\n}",null,null,false],[1,125,0,null,null," LEB128 encoding.",null,false],[1,128,0,null,null," A standardized interface for logging.",null,false],[0,0,0,"log.zig",null," std.log is a standardized interface for logging which allows for the logging\n of programs and libraries using this interface to be formatted and filtered\n by the implementer of the `std.options.logFn` function.\n\n Each log message has an associated scope enum, which can be used to give\n context to the logging. The logging functions in std.log implicitly use a\n scope of .default.\n\n A logging namespace using a custom scope can be created using the\n std.log.scoped function, passing the scope as an argument; the logging\n functions in the resulting struct use the provided scope parameter.\n For example, a library called 'libfoo' might use\n `const log = std.log.scoped(.libfoo);` to use .libfoo as the scope of its\n log messages.\n\n An example `logFn` might look something like this:\n\n ```\n const std = @import(\"std\");\n\n pub const std_options = struct {\n     // Set the log level to info\n     pub const log_level = .info;\n\n     // Define logFn to override the std implementation\n     pub const logFn = myLogFn;\n };\n\n pub fn myLogFn(\n     comptime level: std.log.Level,\n     comptime scope: @TypeOf(.EnumLiteral),\n     comptime format: []const u8,\n     args: anytype,\n ) void {\n     // Ignore all non-error logging from sources other than\n     // .my_project, .nice_library and the default\n     const scope_prefix = \"(\" ++ switch (scope) {\n         .my_project, .nice_library, std.log.default_log_scope => @tagName(scope),\n         else => if (@intFromEnum(level) <= @intFromEnum(std.log.Level.err))\n             @tagName(scope)\n         else\n             return,\n     } ++ \"): \";\n\n     const prefix = \"[\" ++ comptime level.asText() ++ \"] \" ++ scope_prefix;\n\n     // Print the message to stderr, silently ignoring any errors\n     std.debug.getStderrMutex().lock();\n     defer std.debug.getStderrMutex().unlock();\n     const stderr = std.io.getStdErr().writer();\n     nosuspend stderr.print(prefix ++ format ++ \"\\n\", args) catch return;\n }\n\n pub fn main() void {\n     // Using the default scope:\n     std.log.debug(\"A borderline useless debug log message\", .{}); // Won't be printed as log_level is .info\n     std.log.info(\"Flux capacitor is starting to overheat\", .{});\n\n     // Using scoped logging:\n     const my_project_log = std.log.scoped(.my_project);\n     const nice_library_log = std.log.scoped(.nice_library);\n     const verbose_lib_log = std.log.scoped(.verbose_lib);\n\n     my_project_log.debug(\"Starting up\", .{}); // Won't be printed as log_level is .info\n     nice_library_log.warn(\"Something went very wrong, sorry\", .{});\n     verbose_lib_log.warn(\"Added 1 + 1: {}\", .{1 + 1}); // Won't be printed as it gets filtered out by our log function\n }\n ```\n Which produces the following output:\n ```\n [info] (default): Flux capacitor is starting to overheat\n [warning] (nice_library): Something went very wrong, sorry\n ```\n",[],false],[283,74,0,null,null,null,null,false],[283,75,0,null,null,null,null,false],[283,77,0,null,null,null,[31708,31709,31710,31711],false],[283,90,0,null,null," Returns a string literal of the given level in full text form.",[31707],false],[0,0,0,"self",null,"",null,true],[0,0,0,"err",null," Error: something has gone wrong. This might be recoverable or might\n be followed by the program exiting.",null,false],[0,0,0,"warn",null," Warning: it is uncertain if something has gone wrong or not, but the\n circumstances would be worth investigating.",null,false],[0,0,0,"info",null," Info: general messages about the state of the program.",null,false],[0,0,0,"debug",null," Debug: messages only useful for debugging.",null,false],[283,101,0,null,null," The default log level is based on build mode.",null,false],[283,107,0,null,null,null,null,false],[283,109,0,null,null,null,[31716,31718],false],[283,109,0,null,null,null,null,false],[0,0,0,"scope",null,null,null,false],[283,109,0,null,null,null,null,false],[0,0,0,"level",null,null,null,false],[283,114,0,null,null,null,null,false],[283,116,0,null,null,null,[31721,31722,31723,31724],false],[0,0,0,"message_level",null,"",null,true],[0,0,0,"scope",null,"",null,true],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[283,128,0,null,null," Determine if a specific log message level and scope combination are enabled for logging.",[31726,31727],false],[0,0,0,"message_level",null,"",null,true],[0,0,0,"scope",null,"",null,true],[283,136,0,null,null," Determine if a specific log message level using the default log scope is enabled for logging.",[31729],false],[0,0,0,"message_level",null,"",null,true],[283,142,0,null,null," The default implementation for the log function, custom log functions may\n forward log messages to this function.",[31731,31732,31733,31734],false],[0,0,0,"message_level",null,"",null,true],[0,0,0,"scope",null,"",null,true],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[283,158,0,null,null," Returns a scoped logging namespace that logs all messages using the scope\n provided here.",[31736],false],[0,0,0,"scope",null,"",[],true],[283,163,0,null,null," Log an error message. This log level is intended to be used\n when something has gone wrong. This might be recoverable or might\n be followed by the program exiting.",[31738,31739],false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[283,174,0,null,null," Log a warning message. This log level is intended to be used if\n it is uncertain whether something has gone wrong or not, but the\n circumstances would be worth investigating.",[31741,31742],false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[283,183,0,null,null," Log an info message. This log level is intended to be used for\n general messages about the state of the program.",[31744,31745],false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[283,192,0,null,null," Log a debug message. This log level is intended to be used for\n messages which are only useful for debugging.",[31747,31748],false],[0,0,0,"format",null,"",null,true],[0,0,0,"args",null,"",null,false],[283,201,0,null,null,null,null,false],[283,204,0,null,null," The default scoped logging namespace.",null,false],[283,209,0,null,null," Log an error message using the default scope. This log level is intended to\n be used when something has gone wrong. This might be recoverable or might\n be followed by the program exiting.",null,false],[283,214,0,null,null," Log a warning message using the default scope. This log level is intended\n to be used if it is uncertain whether something has gone wrong or not, but\n the circumstances would be worth investigating.",null,false],[283,218,0,null,null," Log an info message using the default scope. This log level is intended to\n be used for general messages about the state of the program.",null,false],[283,222,0,null,null," Log a debug message using the default scope. This log level is intended to\n be used for messages which are only useful for debugging.",null,false],[1,131,0,null,null," Mach-O format.",null,false],[0,0,0,"macho.zig",null,"",[],false],[284,0,0,null,null,null,null,false],[284,1,0,null,null,null,null,false],[284,2,0,null,null,null,null,false],[284,3,0,null,null,null,null,false],[284,4,0,null,null,null,null,false],[284,5,0,null,null,null,null,false],[284,6,0,null,null,null,null,false],[284,8,0,null,null,null,null,false],[284,10,0,null,null,null,null,false],[284,11,0,null,null,null,null,false],[284,12,0,null,null,null,null,false],[284,14,0,null,null,null,[31769,31771,31773,31774,31775,31776,31777],false],[0,0,0,"magic",null,null,null,false],[284,14,0,null,null,null,null,false],[0,0,0,"cputype",null,null,null,false],[284,14,0,null,null,null,null,false],[0,0,0,"cpusubtype",null,null,null,false],[0,0,0,"filetype",null,null,null,false],[0,0,0,"ncmds",null,null,null,false],[0,0,0,"sizeofcmds",null,null,null,false],[0,0,0,"flags",null,null,null,false],[284,24,0,null,null,null,[31779,31781,31783,31784,31785,31786,31787,31788],false],[0,0,0,"magic",null,null,null,false],[284,24,0,null,null,null,null,false],[0,0,0,"cputype",null,null,null,false],[284,24,0,null,null,null,null,false],[0,0,0,"cpusubtype",null,null,null,false],[0,0,0,"filetype",null,null,null,false],[0,0,0,"ncmds",null,null,null,false],[0,0,0,"sizeofcmds",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[284,35,0,null,null,null,[31790,31791],false],[0,0,0,"magic",null,null,null,false],[0,0,0,"nfat_arch",null,null,null,false],[284,40,0,null,null,null,[31794,31796,31797,31798,31799],false],[284,40,0,null,null,null,null,false],[0,0,0,"cputype",null,null,null,false],[284,40,0,null,null,null,null,false],[0,0,0,"cpusubtype",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"align",null,null,null,false],[284,48,0,null,null,null,[31802,31803],false],[284,48,0,null,null,null,null,false],[0,0,0,"cmd",null,null,null,false],[0,0,0,"cmdsize",null,null,null,false],[284,55,0,null,null," The uuid load command contains a single 128-bit unique random number that\n identifies an object produced by the static link editor.",[31806,31807,31809],false],[284,55,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_UUID",null,false],[0,0,0,"cmdsize",null," sizeof(struct uuid_command)",null,false],[284,55,0,null,null,null,null,false],[0,0,0,"uuid",null," the 128-bit uuid",null,false],[284,68,0,null,null," The version_min_command contains the min OS version on which this\n binary was built to run.",[31812,31813,31814,31815],false],[284,68,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_VERSION_MIN_MACOSX or LC_VERSION_MIN_IPHONEOS or LC_VERSION_MIN_WATCHOS or LC_VERSION_MIN_TVOS",null,false],[0,0,0,"cmdsize",null," sizeof(struct version_min_command)",null,false],[0,0,0,"version",null," X.Y.Z is encoded in nibbles xxxx.yy.zz",null,false],[0,0,0,"sdk",null," X.Y.Z is encoded in nibbles xxxx.yy.zz",null,false],[284,84,0,null,null," The source_version_command is an optional load command containing\n the version of the sources used to build the binary.",[31818,31819,31820],false],[284,84,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_SOURCE_VERSION",null,false],[0,0,0,"cmdsize",null," sizeof(source_version_command)",null,false],[0,0,0,"version",null," A.B.C.D.E packed as a24.b10.c10.d10.e10",null,false],[284,98,0,null,null," The build_version_command contains the min OS version on which this\n binary was built to run for its platform. The list of known platforms and\n tool values following it.",[31823,31824,31826,31827,31828,31829],false],[284,98,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_BUILD_VERSION",null,false],[0,0,0,"cmdsize",null," sizeof(struct build_version_command) plus\n ntools * sizeof(struct build_version_command)",null,false],[284,98,0,null,null,null,null,false],[0,0,0,"platform",null," platform",null,false],[0,0,0,"minos",null," X.Y.Z is encoded in nibbles xxxx.yy.zz",null,false],[0,0,0,"sdk",null," X.Y.Z is encoded in nibbles xxxx.yy.zz",null,false],[0,0,0,"ntools",null," number of tool entries following this",null,false],[284,119,0,null,null,null,[31832,31833],false],[284,119,0,null,null,null,null,false],[0,0,0,"tool",null," enum for the tool",null,false],[0,0,0,"version",null," version number of the tool",null,false],[284,127,0,null,null,null,[31835,31836,31837,31838,31839,31840,31841,31842,31843,31844],false],[0,0,0,"MACOS",null,null,null,false],[0,0,0,"IOS",null,null,null,false],[0,0,0,"TVOS",null,null,null,false],[0,0,0,"WATCHOS",null,null,null,false],[0,0,0,"BRIDGEOS",null,null,null,false],[0,0,0,"MACCATALYST",null,null,null,false],[0,0,0,"IOSSIMULATOR",null,null,null,false],[0,0,0,"TVOSSIMULATOR",null,null,null,false],[0,0,0,"WATCHOSSIMULATOR",null,null,null,false],[0,0,0,"DRIVERKIT",null,null,null,false],[284,141,0,null,null,null,[31846,31847,31848,31849,31850],false],[0,0,0,"CLANG",null,null,null,false],[0,0,0,"SWIFT",null,null,null,false],[0,0,0,"LD",null,null,null,false],[0,0,0,"LLD",null,null,null,false],[0,0,0,"ZIG",null,null,null,false],[284,154,0,null,null," The entry_point_command is a replacement for thread_command.\n It is used for main executables to specify the location (file offset)\n of main(). If -stack_size was used at link time, the stacksize\n field will contain the stack size needed for the main thread.",[31853,31854,31855,31856],false],[284,154,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_MAIN only used in MH_EXECUTE filetypes",null,false],[0,0,0,"cmdsize",null," sizeof(struct entry_point_command)",null,false],[0,0,0,"entryoff",null," file (__TEXT) offset of main()",null,false],[0,0,0,"stacksize",null," if not zero, initial stack size",null,false],[284,171,0,null,null," The symtab_command contains the offsets and sizes of the link-edit 4.3BSD\n \"stab\" style symbol table information as described in the header files\n <nlist.h> and <stab.h>.",[31859,31860,31861,31862,31863,31864],false],[284,171,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_SYMTAB",null,false],[0,0,0,"cmdsize",null," sizeof(struct symtab_command)",null,false],[0,0,0,"symoff",null," symbol table offset",null,false],[0,0,0,"nsyms",null," number of symbol table entries",null,false],[0,0,0,"stroff",null," string table offset",null,false],[0,0,0,"strsize",null," string table size in bytes",null,false],[284,229,0,null,null," This is the second set of the symbolic information which is used to support\n the data structures for the dynamically link editor.\n\n The original set of symbolic information in the symtab_command which contains\n the symbol and string tables must also be present when this load command is\n present.  When this load command is present the symbol table is organized\n into three groups of symbols:\n  local symbols (static and debugging symbols) - grouped by module\n  defined external symbols - grouped by module (sorted by name if not lib)\n  undefined external symbols (sorted by name if MH_BINDATLOAD is not set,\n       \t\t\t    and in order the were seen by the static\n  \t\t\t    linker if MH_BINDATLOAD is set)\n In this load command there are offsets and counts to each of the three groups\n of symbols.\n\n This load command contains a the offsets and sizes of the following new\n symbolic information tables:\n  table of contents\n  module table\n  reference symbol table\n  indirect symbol table\n The first three tables above (the table of contents, module table and\n reference symbol table) are only present if the file is a dynamically linked\n shared library.  For executable and object modules, which are files\n containing only one module, the information that would be in these three\n tables is determined as follows:\n \ttable of contents - the defined external symbols are sorted by name\n  module table - the file contains only one module so everything in the\n  \t       file is part of the module.\n  reference symbol table - is the defined and undefined external symbols\n\n For dynamically linked shared library files this load command also contains\n offsets and sizes to the pool of relocation entries for all sections\n separated into two groups:\n  external relocation entries\n  local relocation entries\n For executable and object modules the relocation entries continue to hang\n off the section structures.",[31867,31868,31869,31870,31871,31872,31873,31874,31875,31876,31877,31878,31879,31880,31881,31882,31883,31884,31885,31886],false],[284,229,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_DYSYMTAB",null,false],[0,0,0,"cmdsize",null," sizeof(struct dysymtab_command)",null,false],[0,0,0,"ilocalsym",null," index of local symbols",null,false],[0,0,0,"nlocalsym",null," number of local symbols",null,false],[0,0,0,"iextdefsym",null," index to externally defined symbols",null,false],[0,0,0,"nextdefsym",null," number of externally defined symbols",null,false],[0,0,0,"iundefsym",null," index to undefined symbols",null,false],[0,0,0,"nundefsym",null," number of undefined symbols",null,false],[0,0,0,"tocoff",null," file offset to table of contents",null,false],[0,0,0,"ntoc",null," number of entries in table of contents",null,false],[0,0,0,"modtaboff",null," file offset to module table",null,false],[0,0,0,"nmodtab",null," number of module table entries",null,false],[0,0,0,"extrefsymoff",null," offset to referenced symbol table",null,false],[0,0,0,"nextrefsyms",null," number of referenced symbol table entries",null,false],[0,0,0,"indirectsymoff",null," file offset to the indirect symbol table",null,false],[0,0,0,"nindirectsyms",null," number of indirect symbol table entries",null,false],[0,0,0,"extreloff",null," offset to external relocation entries",null,false],[0,0,0,"nextrel",null," number of external relocation entries",null,false],[0,0,0,"locreloff",null," offset to local relocation entries",null,false],[0,0,0,"nlocrel",null," number of local relocation entries",null,false],[284,369,0,null,null," The linkedit_data_command contains the offsets and sizes of a blob\n of data in the __LINKEDIT segment.",[31889,31890,31891,31892],false],[284,369,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_CODE_SIGNATURE, LC_SEGMENT_SPLIT_INFO, LC_FUNCTION_STARTS, LC_DATA_IN_CODE, LC_DYLIB_CODE_SIGN_DRS or LC_LINKER_OPTIMIZATION_HINT.",null,false],[0,0,0,"cmdsize",null," sizeof(struct linkedit_data_command)",null,false],[0,0,0,"dataoff",null," file offset of data in __LINKEDIT segment",null,false],[0,0,0,"datasize",null," file size of data in __LINKEDIT segment",null,false],[284,389,0,null,null," The dyld_info_command contains the file offsets and sizes of\n the new compressed form of the information dyld needs to\n load the image.  This information is used by dyld on Mac OS X\n 10.6 and later.  All information pointed to by this command\n is encoded using byte streams, so no endian swapping is needed\n to interpret it.",[31895,31896,31897,31898,31899,31900,31901,31902,31903,31904,31905,31906],false],[284,389,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_DYLD_INFO or LC_DYLD_INFO_ONLY",null,false],[0,0,0,"cmdsize",null," sizeof(struct dyld_info_command)",null,false],[0,0,0,"rebase_off",null," file offset to rebase info",null,false],[0,0,0,"rebase_size",null," size of rebase info",null,false],[0,0,0,"bind_off",null," file offset to binding info",null,false],[0,0,0,"bind_size",null," size of binding info",null,false],[0,0,0,"weak_bind_off",null," file offset to weak binding info",null,false],[0,0,0,"weak_bind_size",null," size of weak binding info",null,false],[0,0,0,"lazy_bind_off",null," file offset to lazy binding info",null,false],[0,0,0,"lazy_bind_size",null," size of lazy binding info",null,false],[0,0,0,"export_off",null," file offset to lazy binding info",null,false],[0,0,0,"export_size",null," size of lazy binding info",null,false],[284,510,0,null,null," A program that uses a dynamic linker contains a dylinker_command to identify\n the name of the dynamic linker (LC_LOAD_DYLINKER). And a dynamic linker\n contains a dylinker_command to identify the dynamic linker (LC_ID_DYLINKER).\n A file can have at most one of these.\n This struct is also used for the LC_DYLD_ENVIRONMENT load command and contains\n string for dyld to treat like an environment variable.",[31909,31910,31911],false],[284,510,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_ID_DYLINKER, LC_LOAD_DYLINKER, or LC_DYLD_ENVIRONMENT",null,false],[0,0,0,"cmdsize",null," includes pathname string",null,false],[0,0,0,"name",null," A variable length string in a load command is represented by an lc_str\n union.  The strings are stored just after the load command structure and\n the offset is from the start of the load command structure.  The size\n of the string is reflected in the cmdsize field of the load command.\n Once again any padded bytes to bring the cmdsize field to a multiple\n of 4 bytes must be zero.",null,false],[284,531,0,null,null," A dynamically linked shared library (filetype == MH_DYLIB in the mach header)\n contains a dylib_command (cmd == LC_ID_DYLIB) to identify the library.\n An object that uses a dynamically linked shared library also contains a\n dylib_command (cmd == LC_LOAD_DYLIB, LC_LOAD_WEAK_DYLIB, or\n LC_REEXPORT_DYLIB) for each library it uses.",[31914,31915,31917],false],[284,531,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_ID_DYLIB, LC_LOAD_WEAK_DYLIB, LC_LOAD_DYLIB, LC_REEXPORT_DYLIB",null,false],[0,0,0,"cmdsize",null," includes pathname string",null,false],[284,531,0,null,null,null,null,false],[0,0,0,"dylib",null," the library identification",null,false],[284,549,0,null,null," Dynamically linked shared libraries are identified by two things.  The\n pathname (the name of the library as found for execution), and the\n compatibility version number.  The pathname must match and the compatibility\n number in the user of the library must be greater than or equal to the\n library being used.  The time stamp is used to record the time a library was\n built and copied into user so it can be use to determined if the library used\n at runtime is exactly the same as used to build the program.",[31919,31920,31921,31922],false],[0,0,0,"name",null," library's pathname (offset pointing at the end of dylib_command)",null,false],[0,0,0,"timestamp",null," library's build timestamp",null,false],[0,0,0,"current_version",null," library's current version number",null,false],[0,0,0,"compatibility_version",null," library's compatibility version number",null,false],[284,565,0,null,null," The rpath_command contains a path which at runtime should be added to the current\n run path used to find @rpath prefixed dylibs.",[31925,31926,31927],false],[284,565,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_RPATH",null,false],[0,0,0,"cmdsize",null," includes string",null,false],[0,0,0,"path",null," path to add to run path",null,false],[284,586,0,null,null," The segment load command indicates that a part of this file is to be\n mapped into the task's address space.  The size of this segment in memory,\n vmsize, maybe equal to or larger than the amount to map from this file,\n filesize.  The file is mapped starting at fileoff to the beginning of\n the segment in memory, vmaddr.  The rest of the memory of the segment,\n if any, is allocated zero fill on demand.  The segment's maximum virtual\n memory protection and initial virtual memory protection are specified\n by the maxprot and initprot fields.  If the segment has sections then the\n section structures directly follow the segment command and their size is\n reflected in cmdsize.",[31930,31931,31933,31934,31935,31936,31937,31939,31941,31942,31943],false],[284,586,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_SEGMENT",null,false],[0,0,0,"cmdsize",null," includes sizeof section structs",null,false],[284,586,0,null,null,null,null,false],[0,0,0,"segname",null," segment name",null,false],[0,0,0,"vmaddr",null," memory address of this segment",null,false],[0,0,0,"vmsize",null," memory size of this segment",null,false],[0,0,0,"fileoff",null," file offset of this segment",null,false],[0,0,0,"filesize",null," amount to map from the file",null,false],[284,586,0,null,null,null,null,false],[0,0,0,"maxprot",null," maximum VM protection",null,false],[284,586,0,null,null,null,null,false],[0,0,0,"initprot",null," initial VM protection",null,false],[0,0,0,"nsects",null," number of sections in segment",null,false],[0,0,0,"flags",null,null,null,false],[284,623,0,null,null," The 64-bit segment load command indicates that a part of this file is to be\n mapped into a 64-bit task's address space.  If the 64-bit segment has\n sections then section_64 structures directly follow the 64-bit segment\n command and their size is reflected in cmdsize.",[31950,31951,31953,31954,31955,31956,31957,31959,31961,31962,31963],false],[284,657,0,null,null,null,[31946],false],[0,0,0,"seg",null,"",null,false],[284,661,0,null,null,null,[31948],false],[0,0,0,"seg",null,"",null,false],[284,623,0,null,null,null,null,false],[0,0,0,"cmd",null," LC_SEGMENT_64",null,false],[0,0,0,"cmdsize",null," includes sizeof section_64 structs",null,false],[284,623,0,null,null,null,null,false],[0,0,0,"segname",null," segment name",null,false],[0,0,0,"vmaddr",null," memory address of this segment",null,false],[0,0,0,"vmsize",null," memory size of this segment",null,false],[0,0,0,"fileoff",null," file offset of this segment",null,false],[0,0,0,"filesize",null," amount to map from the file",null,false],[284,623,0,null,null,null,null,false],[0,0,0,"maxprot",null," maximum VM protection",null,false],[284,623,0,null,null,null,null,false],[0,0,0,"initprot",null," initial VM protection",null,false],[0,0,0,"nsects",null," number of sections in segment",null,false],[0,0,0,"flags",null,null,null,false],[284,666,0,null,null,null,[],false],[284,668,0,null,null," [MC2] no permissions",null,false],[284,670,0,null,null," [MC2] pages can be read",null,false],[284,672,0,null,null," [MC2] pages can be written",null,false],[284,674,0,null,null," [MC2] pages can be executed",null,false],[284,680,0,null,null," When a caller finds that they cannot obtain write permission on a\n mapped entry, the following flag can be used. The entry will be\n made \"needs copy\" effectively copying the object (using COW),\n and write permission will be added to the maximum protections for\n the associated entry.",null,false],[284,708,0,null,null," A segment is made up of zero or more sections.  Non-MH_OBJECT files have\n all of their segments with the proper sections in each, and padded to the\n specified segment alignment when produced by the link editor.  The first\n segment of a MH_EXECUTE and MH_FVMLIB format file contains the mach_header\n and load commands of the object file before its first section.  The zero\n fill sections are always last in their segment (in all formats).  This\n allows the zeroed segment padding to be mapped into memory where zero fill\n sections might be. The gigabyte zero fill sections, those with the section\n type S_GB_ZEROFILL, can only be in a segment with sections of this type.\n These segments are then placed after all other segments.\n\n The MH_OBJECT format has all of its sections in one segment for\n compactness.  There is no padding to a specified segment boundary and the\n mach_header and load commands are not part of the segment.\n\n Sections with the same section name, sectname, going into the same segment,\n segname, are combined by the link editor.  The resulting section is aligned\n to the maximum alignment of the combined sections and is the new section's\n alignment.  The combined sections are aligned to their original alignment in\n the combined section.  Any padded bytes to get the specified alignment are\n zeroed.\n\n The format of the relocation entries referenced by the reloff and nreloc\n fields of the section structure for mach object files is described in the\n header file <reloc.h>.",[31972,31974,31975,31976,31977,31978,31979,31980,31981,31982,31983],false],[284,708,0,null,null,null,null,false],[0,0,0,"sectname",null," name of this section",null,false],[284,708,0,null,null,null,null,false],[0,0,0,"segname",null," segment this section goes in",null,false],[0,0,0,"addr",null," memory address of this section",null,false],[0,0,0,"size",null," size in bytes of this section",null,false],[0,0,0,"offset",null," file offset of this section",null,false],[0,0,0,"align",null," section alignment (power of 2)",null,false],[0,0,0,"reloff",null," file offset of relocation entries",null,false],[0,0,0,"nreloc",null," number of relocation entries",null,false],[0,0,0,"flags",null," flags (section type and attributes",null,false],[0,0,0,"reserved1",null," reserved (for offset or index)",null,false],[0,0,0,"reserved2",null," reserved (for count or sizeof)",null,false],[284,743,0,null,null,null,[32006,32008,32009,32010,32011,32012,32013,32014,32015,32016,32017,32018],false],[284,780,0,null,null,null,[31986],false],[0,0,0,"sect",null,"",null,false],[284,784,0,null,null,null,[31988],false],[0,0,0,"sect",null,"",null,false],[284,788,0,null,null,null,[31990],false],[0,0,0,"sect",null,"",null,false],[284,792,0,null,null,null,[31992],false],[0,0,0,"sect",null,"",null,false],[284,796,0,null,null,null,[31994],false],[0,0,0,"sect",null,"",null,false],[284,801,0,null,null,null,[31996],false],[0,0,0,"sect",null,"",null,false],[284,806,0,null,null,null,[31998],false],[0,0,0,"sect",null,"",null,false],[284,811,0,null,null,null,[32000],false],[0,0,0,"sect",null,"",null,false],[284,815,0,null,null,null,[32002],false],[0,0,0,"sect",null,"",null,false],[284,819,0,null,null,null,[32004],false],[0,0,0,"sect",null,"",null,false],[284,743,0,null,null,null,null,false],[0,0,0,"sectname",null," name of this section",null,false],[284,743,0,null,null,null,null,false],[0,0,0,"segname",null," segment this section goes in",null,false],[0,0,0,"addr",null," memory address of this section",null,false],[0,0,0,"size",null," size in bytes of this section",null,false],[0,0,0,"offset",null," file offset of this section",null,false],[0,0,0,"align",null," section alignment (power of 2)",null,false],[0,0,0,"reloff",null," file offset of relocation entries",null,false],[0,0,0,"nreloc",null," number of relocation entries",null,false],[0,0,0,"flags",null," flags (section type and attributes",null,false],[0,0,0,"reserved1",null," reserved (for offset or index)",null,false],[0,0,0,"reserved2",null," reserved (for count or sizeof)",null,false],[0,0,0,"reserved3",null," reserved",null,false],[284,824,0,null,null,null,[32020],false],[0,0,0,"name",null,"",null,false],[284,829,0,null,null,null,[32022,32023,32024,32025,32026],false],[0,0,0,"n_strx",null,null,null,false],[0,0,0,"n_type",null,null,null,false],[0,0,0,"n_sect",null,null,null,false],[0,0,0,"n_desc",null,null,null,false],[0,0,0,"n_value",null,null,null,false],[284,837,0,null,null,null,[32050,32051,32052,32053,32054],false],[284,844,0,null,null,null,[32029],false],[0,0,0,"sym",null,"",null,false],[284,848,0,null,null,null,[32031],false],[0,0,0,"sym",null,"",null,false],[284,852,0,null,null,null,[32033],false],[0,0,0,"sym",null,"",null,false],[284,856,0,null,null,null,[32035],false],[0,0,0,"sym",null,"",null,false],[284,861,0,null,null,null,[32037],false],[0,0,0,"sym",null,"",null,false],[284,866,0,null,null,null,[32039],false],[0,0,0,"sym",null,"",null,false],[284,871,0,null,null,null,[32041],false],[0,0,0,"sym",null,"",null,false],[284,876,0,null,null,null,[32043],false],[0,0,0,"sym",null,"",null,false],[284,880,0,null,null,null,[32045],false],[0,0,0,"sym",null,"",null,false],[284,884,0,null,null,null,[32047],false],[0,0,0,"sym",null,"",null,false],[284,888,0,null,null,null,[32049],false],[0,0,0,"sym",null,"",null,false],[0,0,0,"n_strx",null,null,null,false],[0,0,0,"n_type",null,null,null,false],[0,0,0,"n_sect",null,null,null,false],[0,0,0,"n_desc",null,null,null,false],[0,0,0,"n_value",null,null,null,false],[284,900,0,null,null," Format of a relocation entry of a Mach-O file.  Modified from the 4.3BSD\n format.  The modifications from the original format were changing the value\n of the r_symbolnum field for \"local\" (r_extern == 0) relocation entries.\n This modification is required to support symbols in an arbitrary number of\n sections not just the three sections (text, data and bss) in a 4.3BSD file.\n Also the last 4 bits have had the r_type tag added to them.",[32056,32058,32059,32061,32062,32064],false],[0,0,0,"r_address",null," offset in the section to what is being relocated",null,false],[284,900,0,null,null,null,null,false],[0,0,0,"r_symbolnum",null," symbol index if r_extern == 1 or section ordinal if r_extern == 0",null,false],[0,0,0,"r_pcrel",null," was relocated pc relative already",null,false],[284,900,0,null,null,null,null,false],[0,0,0,"r_length",null," 0=byte, 1=word, 2=long, 3=quad",null,false],[0,0,0,"r_extern",null," does not include value of sym referenced",null,false],[284,900,0,null,null,null,null,false],[0,0,0,"r_type",null," if not 0, machine specific relocation type",null,false],[284,927,0,null,null," After MacOS X 10.1 when a new load command is added that is required to be\n understood by the dynamic linker for the image to execute properly the\n LC_REQ_DYLD bit will be or'ed into the load command constant.  If the dynamic\n linker sees such a load command it it does not understand will issue a\n \"unknown load command required for execution\" error and refuse to use the\n image.  Other load commands without this bit that are not understood will\n simply be ignored.",null,false],[284,929,0,null,null,null,[32067,32068,32069,32070,32071,32072,32073,32074,32075,32076,32077,32078,32079,32080,32081,32082,32083,32084,32085,32086,32087,32088,32089,32090,32091,32092,32093,32094,32095,32096,32097,32098,32099,32100,32101,32102,32103,32104,32105,32106,32107,32108,32109,32110,32111,32112,32113,32114,32115,32116,32117,32118],false],[0,0,0,"NONE",null," No load command - invalid",null,false],[0,0,0,"SEGMENT",null," segment of this file to be mapped",null,false],[0,0,0,"SYMTAB",null," link-edit stab symbol table info",null,false],[0,0,0,"SYMSEG",null," link-edit gdb symbol table info (obsolete)",null,false],[0,0,0,"THREAD",null," thread",null,false],[0,0,0,"UNIXTHREAD",null," unix thread (includes a stack)",null,false],[0,0,0,"LOADFVMLIB",null," load a specified fixed VM shared library",null,false],[0,0,0,"IDFVMLIB",null," fixed VM shared library identification",null,false],[0,0,0,"IDENT",null," object identification info (obsolete)",null,false],[0,0,0,"FVMFILE",null," fixed VM file inclusion (internal use)",null,false],[0,0,0,"PREPAGE",null," prepage command (internal use)",null,false],[0,0,0,"DYSYMTAB",null," dynamic link-edit symbol table info",null,false],[0,0,0,"LOAD_DYLIB",null," load a dynamically linked shared library",null,false],[0,0,0,"ID_DYLIB",null," dynamically linked shared lib ident",null,false],[0,0,0,"LOAD_DYLINKER",null," load a dynamic linker",null,false],[0,0,0,"ID_DYLINKER",null," dynamic linker identification",null,false],[0,0,0,"PREBOUND_DYLIB",null," modules prebound for a dynamically",null,false],[0,0,0,"ROUTINES",null," image routines",null,false],[0,0,0,"SUB_FRAMEWORK",null," sub framework",null,false],[0,0,0,"SUB_UMBRELLA",null," sub umbrella",null,false],[0,0,0,"SUB_CLIENT",null," sub client",null,false],[0,0,0,"SUB_LIBRARY",null," sub library",null,false],[0,0,0,"TWOLEVEL_HINTS",null," two-level namespace lookup hints",null,false],[0,0,0,"PREBIND_CKSUM",null," prebind checksum",null,false],[0,0,0,"LOAD_WEAK_DYLIB",null," load a dynamically linked shared library that is allowed to be missing\n (all symbols are weak imported).",null,false],[0,0,0,"SEGMENT_64",null," 64-bit segment of this file to be mapped",null,false],[0,0,0,"ROUTINES_64",null," 64-bit image routines",null,false],[0,0,0,"UUID",null," the uuid",null,false],[0,0,0,"RPATH",null," runpath additions",null,false],[0,0,0,"CODE_SIGNATURE",null," local of code signature",null,false],[0,0,0,"SEGMENT_SPLIT_INFO",null," local of info to split segments",null,false],[0,0,0,"REEXPORT_DYLIB",null," load and re-export dylib",null,false],[0,0,0,"LAZY_LOAD_DYLIB",null," delay load of dylib until first use",null,false],[0,0,0,"ENCRYPTION_INFO",null," encrypted segment information",null,false],[0,0,0,"DYLD_INFO",null," compressed dyld information",null,false],[0,0,0,"DYLD_INFO_ONLY",null," compressed dyld information only",null,false],[0,0,0,"LOAD_UPWARD_DYLIB",null," load upward dylib",null,false],[0,0,0,"VERSION_MIN_MACOSX",null," build for MacOSX min OS version",null,false],[0,0,0,"VERSION_MIN_IPHONEOS",null," build for iPhoneOS min OS version",null,false],[0,0,0,"FUNCTION_STARTS",null," compressed table of function start addresses",null,false],[0,0,0,"DYLD_ENVIRONMENT",null," string for dyld to treat like environment variable",null,false],[0,0,0,"MAIN",null," replacement for LC_UNIXTHREAD",null,false],[0,0,0,"DATA_IN_CODE",null," table of non-instructions in __text",null,false],[0,0,0,"SOURCE_VERSION",null," source version used to build binary",null,false],[0,0,0,"DYLIB_CODE_SIGN_DRS",null," Code signing DRs copied from linked dylibs",null,false],[0,0,0,"ENCRYPTION_INFO_64",null," 64-bit encrypted segment information",null,false],[0,0,0,"LINKER_OPTION",null," linker options in MH_OBJECT files",null,false],[0,0,0,"LINKER_OPTIMIZATION_HINT",null," optimization hints in MH_OBJECT files",null,false],[0,0,0,"VERSION_MIN_TVOS",null," build for AppleTV min OS version",null,false],[0,0,0,"VERSION_MIN_WATCHOS",null," build for Watch min OS version",null,false],[0,0,0,"NOTE",null," arbitrary data included within a Mach-O file",null,false],[0,0,0,"BUILD_VERSION",null," build for platform min OS version",null,false],[284,1091,0,null,null," the mach magic number",null,false],[284,1094,0,null,null," NXSwapInt(MH_MAGIC)",null,false],[284,1097,0,null,null," the 64-bit mach magic number",null,false],[284,1100,0,null,null," NXSwapInt(MH_MAGIC_64)",null,false],[284,1103,0,null,null," relocatable object file",null,false],[284,1106,0,null,null," demand paged executable file",null,false],[284,1109,0,null,null," fixed VM shared library file",null,false],[284,1112,0,null,null," core file",null,false],[284,1115,0,null,null," preloaded executable file",null,false],[284,1118,0,null,null," dynamically bound shared library",null,false],[284,1121,0,null,null," dynamic link editor",null,false],[284,1124,0,null,null," dynamically bound bundle file",null,false],[284,1127,0,null,null," shared library stub for static linking only, no section contents",null,false],[284,1130,0,null,null," companion file with only debug sections",null,false],[284,1133,0,null,null," x86_64 kexts",null,false],[284,1138,0,null,null," the object file has no undefined references",null,false],[284,1141,0,null,null," the object file is the output of an incremental link against a base file and can't be link edited again",null,false],[284,1144,0,null,null," the object file is input for the dynamic linker and can't be statically link edited again",null,false],[284,1147,0,null,null," the object file's undefined references are bound by the dynamic linker when loaded.",null,false],[284,1150,0,null,null," the file has its dynamic undefined references prebound.",null,false],[284,1153,0,null,null," the file has its read-only and read-write segments split",null,false],[284,1156,0,null,null," the shared library init routine is to be run lazily via catching memory faults to its writeable segments (obsolete)",null,false],[284,1159,0,null,null," the image is using two-level name space bindings",null,false],[284,1162,0,null,null," the executable is forcing all images to use flat name space bindings",null,false],[284,1165,0,null,null," this umbrella guarantees no multiple definitions of symbols in its sub-images so the two-level namespace hints can always be used.",null,false],[284,1168,0,null,null," do not have dyld notify the prebinding agent about this executable",null,false],[284,1171,0,null,null," the binary is not prebound but can have its prebinding redone. only used when MH_PREBOUND is not set.",null,false],[284,1174,0,null,null," indicates that this binary binds to all two-level namespace modules of its dependent libraries. only used when MH_PREBINDABLE and MH_TWOLEVEL are both set.",null,false],[284,1177,0,null,null," safe to divide up the sections into sub-sections via symbols for dead code stripping",null,false],[284,1180,0,null,null," the binary has been canonicalized via the unprebind operation",null,false],[284,1183,0,null,null," the final linked image contains external weak symbols",null,false],[284,1186,0,null,null," the final linked image uses weak symbols",null,false],[284,1189,0,null,null," When this bit is set, all stacks in the task will be given stack execution privilege.  Only used in MH_EXECUTE filetypes.",null,false],[284,1192,0,null,null," When this bit is set, the binary declares it is safe for use in processes with uid zero",null,false],[284,1195,0,null,null," When this bit is set, the binary declares it is safe for use in processes when issetugid() is true",null,false],[284,1198,0,null,null," When this bit is set on a dylib, the static linker does not need to examine dependent dylibs to see if any are re-exported",null,false],[284,1201,0,null,null," When this bit is set, the OS will load the main executable at a random address.  Only used in MH_EXECUTE filetypes.",null,false],[284,1204,0,null,null," Only for use on dylibs.  When linking against a dylib that has this bit set, the static linker will automatically not create a LC_LOAD_DYLIB load command to the dylib if no symbols are being referenced from the dylib.",null,false],[284,1207,0,null,null," Contains a section of type S_THREAD_LOCAL_VARIABLES",null,false],[284,1210,0,null,null," When this bit is set, the OS will run the main executable with a non-executable heap even on platforms (e.g. x86) that don't require it. Only used in MH_EXECUTE filetypes.",null,false],[284,1213,0,null,null," The code was linked for use in an application extension.",null,false],[284,1216,0,null,null," The external symbols listed in the nlist symbol table do not include all the symbols listed in the dyld info.",null,false],[284,1221,0,null,null," the fat magic number",null,false],[284,1224,0,null,null," NXSwapLong(FAT_MAGIC)",null,false],[284,1227,0,null,null," the 64-bit fat magic number",null,false],[284,1230,0,null,null," NXSwapLong(FAT_MAGIC_64)",null,false],[284,1237,0,null,null," The flags field of a section structure is separated into two parts a section\n type and section attributes.  The section types are mutually exclusive (it\n can only have one type) but the section attributes are not (it may have more\n than one attribute).\n 256 section types",null,false],[284,1240,0,null,null,"  24 section attributes",null,false],[284,1243,0,null,null," regular section",null,false],[284,1246,0,null,null," zero fill on demand section",null,false],[284,1249,0,null,null," section with only literal C string",null,false],[284,1252,0,null,null," section with only 4 byte literals",null,false],[284,1255,0,null,null," section with only 8 byte literals",null,false],[284,1258,0,null,null," section with only pointers to",null,false],[284,1261,0,null,null," if any of these bits set, a symbolic debugging entry",null,false],[284,1264,0,null,null," private external symbol bit",null,false],[284,1267,0,null,null," mask for the type bits",null,false],[284,1270,0,null,null," external symbol bit, set for external symbols",null,false],[284,1273,0,null,null," symbol is undefined",null,false],[284,1276,0,null,null," symbol is absolute",null,false],[284,1279,0,null,null," symbol is defined in the section number given in n_sect",null,false],[284,1283,0,null,null," symbol is undefined  and the image is using a prebound\n value  for the symbol",null,false],[284,1288,0,null,null," symbol is defined to be the same as another symbol; the n_value\n field is an index into the string table specifying the name of the\n other symbol",null,false],[284,1291,0,null,null," global symbol: name,,NO_SECT,type,0",null,false],[284,1294,0,null,null," procedure name (f77 kludge): name,,NO_SECT,0,0",null,false],[284,1297,0,null,null," procedure: name,,n_sect,linenumber,address",null,false],[284,1300,0,null,null," static symbol: name,,n_sect,type,address",null,false],[284,1303,0,null,null," .lcomm symbol: name,,n_sect,type,address",null,false],[284,1306,0,null,null," begin nsect sym: 0,,n_sect,0,address",null,false],[284,1309,0,null,null," AST file path: name,,NO_SECT,0,0",null,false],[284,1312,0,null,null," emitted with gcc2_compiled and in gcc source",null,false],[284,1315,0,null,null," register sym: name,,NO_SECT,type,register",null,false],[284,1318,0,null,null," src line: 0,,n_sect,linenumber,address",null,false],[284,1321,0,null,null," end nsect sym: 0,,n_sect,0,address",null,false],[284,1324,0,null,null," structure elt: name,,NO_SECT,type,struct_offset",null,false],[284,1327,0,null,null," source file name: name,,n_sect,0,address",null,false],[284,1330,0,null,null," object file name: name,,0,0,st_mtime",null,false],[284,1333,0,null,null," local sym: name,,NO_SECT,type,offset",null,false],[284,1336,0,null,null," include file beginning: name,,NO_SECT,0,sum",null,false],[284,1339,0,null,null," #included file name: name,,n_sect,0,address",null,false],[284,1342,0,null,null," compiler parameters: name,,NO_SECT,0,0",null,false],[284,1345,0,null,null," compiler version: name,,NO_SECT,0,0",null,false],[284,1348,0,null,null," compiler -O level: name,,NO_SECT,0,0",null,false],[284,1351,0,null,null," parameter: name,,NO_SECT,type,offset",null,false],[284,1354,0,null,null," include file end: name,,NO_SECT,0,0",null,false],[284,1357,0,null,null," alternate entry: name,,n_sect,linenumber,address",null,false],[284,1360,0,null,null," left bracket: 0,,NO_SECT,nesting level,address",null,false],[284,1363,0,null,null," deleted include file: name,,NO_SECT,0,sum",null,false],[284,1366,0,null,null," right bracket: 0,,NO_SECT,nesting level,address",null,false],[284,1369,0,null,null," begin common: name,,NO_SECT,0,0",null,false],[284,1372,0,null,null," end common: name,,n_sect,0,0",null,false],[284,1375,0,null,null," end common (local name): 0,,n_sect,0,address",null,false],[284,1378,0,null,null," second stab entry with length information",null,false],[284,1392,0,null,null," section with only non-lazy symbol pointers",null,false],[284,1395,0,null,null," section with only lazy symbol pointers",null,false],[284,1398,0,null,null," section with only symbol stubs, byte size of stub in the reserved2 field",null,false],[284,1401,0,null,null," section with only function pointers for initialization",null,false],[284,1404,0,null,null," section with only function pointers for termination",null,false],[284,1407,0,null,null," section contains symbols that are to be coalesced",null,false],[284,1410,0,null,null," zero fill on demand section (that can be larger than 4 gigabytes)",null,false],[284,1413,0,null,null," section with only pairs of function pointers for interposing",null,false],[284,1416,0,null,null," section with only 16 byte literals",null,false],[284,1419,0,null,null," section contains DTrace Object Format",null,false],[284,1422,0,null,null," section with only lazy symbol pointers to lazy loaded dylibs",null,false],[284,1433,0,null,null," a debug section",null,false],[284,1436,0,null,null," section contains only true machine instructions",null,false],[284,1440,0,null,null," section contains coalesced symbols that are not to be in a ranlib\n table of contents",null,false],[284,1444,0,null,null," ok to strip static symbols in this section in files with the\n MH_DYLDLINK flag",null,false],[284,1447,0,null,null," no dead stripping",null,false],[284,1450,0,null,null," blocks are live if they reference live blocks",null,false],[284,1453,0,null,null," used with x86 code stubs written on by dyld",null,false],[284,1456,0,null,null," section contains some machine instructions",null,false],[284,1459,0,null,null," section has external relocation entries",null,false],[284,1462,0,null,null," section has local relocation entries",null,false],[284,1465,0,null,null," template of initial values for TLVs",null,false],[284,1468,0,null,null," template of initial values for TLVs",null,false],[284,1471,0,null,null," TLV descriptors",null,false],[284,1474,0,null,null," pointers to TLV descriptors",null,false],[284,1477,0,null,null," functions to call to initialize TLV values",null,false],[284,1480,0,null,null," 32-bit offsets to initializers",null,false],[284,1483,0,null,null," CPU type targeting 64-bit Intel-based Macs",null,false],[284,1486,0,null,null," CPU type targeting 64-bit ARM-based Macs",null,false],[284,1489,0,null,null," All Intel-based Macs",null,false],[284,1492,0,null,null," All ARM-based Macs",null,false],[284,1495,0,null,null,null,null,false],[284,1496,0,null,null,null,null,false],[284,1497,0,null,null,null,null,false],[284,1499,0,null,null,null,null,false],[284,1500,0,null,null,null,null,false],[284,1501,0,null,null,null,null,false],[284,1502,0,null,null,null,null,false],[284,1503,0,null,null,null,null,false],[284,1504,0,null,null,null,null,false],[284,1505,0,null,null,null,null,false],[284,1506,0,null,null,null,null,false],[284,1507,0,null,null,null,null,false],[284,1508,0,null,null,null,null,false],[284,1509,0,null,null,null,null,false],[284,1512,0,null,null,null,null,false],[284,1513,0,null,null,null,null,false],[284,1514,0,null,null,null,null,false],[284,1516,0,null,null,null,null,false],[284,1517,0,null,null,null,null,false],[284,1518,0,null,null,null,null,false],[284,1520,0,null,null,null,null,false],[284,1521,0,null,null,null,null,false],[284,1523,0,null,null,null,null,false],[284,1524,0,null,null,null,null,false],[284,1525,0,null,null,null,null,false],[284,1526,0,null,null,null,null,false],[284,1527,0,null,null,null,null,false],[284,1528,0,null,null,null,null,false],[284,1529,0,null,null,null,null,false],[284,1530,0,null,null,null,null,false],[284,1531,0,null,null,null,null,false],[284,1532,0,null,null,null,null,false],[284,1533,0,null,null,null,null,false],[284,1534,0,null,null,null,null,false],[284,1535,0,null,null,null,null,false],[284,1536,0,null,null,null,null,false],[284,1537,0,null,null,null,null,false],[284,1539,0,null,null,null,[32281,32282,32283,32284,32285,32286,32287,32288,32289,32290],false],[0,0,0,"X86_64_RELOC_UNSIGNED",null," for absolute addresses",null,false],[0,0,0,"X86_64_RELOC_SIGNED",null," for signed 32-bit displacement",null,false],[0,0,0,"X86_64_RELOC_BRANCH",null," a CALL/JMP instruction with 32-bit displacement",null,false],[0,0,0,"X86_64_RELOC_GOT_LOAD",null," a MOVQ load of a GOT entry",null,false],[0,0,0,"X86_64_RELOC_GOT",null," other GOT references",null,false],[0,0,0,"X86_64_RELOC_SUBTRACTOR",null," must be followed by a X86_64_RELOC_UNSIGNED",null,false],[0,0,0,"X86_64_RELOC_SIGNED_1",null," for signed 32-bit displacement with a -1 addend",null,false],[0,0,0,"X86_64_RELOC_SIGNED_2",null," for signed 32-bit displacement with a -2 addend",null,false],[0,0,0,"X86_64_RELOC_SIGNED_4",null," for signed 32-bit displacement with a -4 addend",null,false],[0,0,0,"X86_64_RELOC_TLV",null," for thread local variables",null,false],[284,1571,0,null,null,null,[32292,32293,32294,32295,32296,32297,32298,32299,32300,32301,32302],false],[0,0,0,"ARM64_RELOC_UNSIGNED",null," For pointers.",null,false],[0,0,0,"ARM64_RELOC_SUBTRACTOR",null," Must be followed by a ARM64_RELOC_UNSIGNED.",null,false],[0,0,0,"ARM64_RELOC_BRANCH26",null," A B/BL instruction with 26-bit displacement.",null,false],[0,0,0,"ARM64_RELOC_PAGE21",null," Pc-rel distance to page of target.",null,false],[0,0,0,"ARM64_RELOC_PAGEOFF12",null," Offset within page, scaled by r_length.",null,false],[0,0,0,"ARM64_RELOC_GOT_LOAD_PAGE21",null," Pc-rel distance to page of GOT slot.",null,false],[0,0,0,"ARM64_RELOC_GOT_LOAD_PAGEOFF12",null," Offset within page of GOT slot, scaled by r_length.",null,false],[0,0,0,"ARM64_RELOC_POINTER_TO_GOT",null," For pointers to GOT slots.",null,false],[0,0,0,"ARM64_RELOC_TLVP_LOAD_PAGE21",null," Pc-rel distance to page of TLVP slot.",null,false],[0,0,0,"ARM64_RELOC_TLVP_LOAD_PAGEOFF12",null," Offset within page of TLVP slot, scaled by r_length.",null,false],[0,0,0,"ARM64_RELOC_ADDEND",null," Must be followed by PAGE21 or PAGEOFF12.",null,false],[284,1607,0,null,null," This symbol is a reference to an external non-lazy (data) symbol.",null,false],[284,1610,0,null,null," This symbol is a reference to an external lazy symbol—that is, to a function call.",null,false],[284,1613,0,null,null," This symbol is defined in this module.",null,false],[284,1616,0,null,null," This symbol is defined in this module and is visible only to modules within this shared library.",null,false],[284,1620,0,null,null," This symbol is defined in another module in this file, is a non-lazy (data) symbol, and is visible\n only to modules within this shared library.",null,false],[284,1624,0,null,null," This symbol is defined in another module in this file, is a lazy (function) symbol, and is visible\n only to modules within this shared library.",null,false],[284,1629,0,null,null," Must be set for any defined symbol that is referenced by dynamic-loader APIs (such as dlsym and\n NSLookupSymbolInImage) and not ordinary undefined symbol references. The strip tool uses this bit\n to avoid removing symbols that must exist: If the symbol has this bit set, strip does not strip it.",null,false],[284,1632,0,null,null," Used by the dynamic linker at runtime. Do not set this bit.",null,false],[284,1637,0,null,null," Indicates that this symbol is a weak reference. If the dynamic linker cannot find a definition\n for this symbol, it sets the address of this symbol to 0. The static linker sets this symbol given\n the appropriate weak-linking flags.",null,false],[284,1642,0,null,null," Indicates that this symbol is a weak definition. If the static linker or the dynamic linker finds\n another (non-weak) definition for this symbol, the weak definition is ignored. Only symbols in a\n coalesced section (page 23) can be marked as a weak definition.",null,false],[284,1648,0,null,null," The N_SYMBOL_RESOLVER bit of the n_desc field indicates that the\n that the function is actually a resolver function and should\n be called to get the address of the real function to use.\n This bit is only available in .o files (MH_OBJECT filetype)",null,false],[284,1651,0,null,null,null,null,false],[284,1652,0,null,null,null,null,false],[284,1653,0,null,null,null,null,false],[284,1654,0,null,null,null,null,false],[284,1655,0,null,null,null,null,false],[284,1656,0,null,null,null,null,false],[284,1657,0,null,null,null,null,false],[284,1664,0,null,null,null,null,false],[284,1665,0,null,null,null,null,false],[284,1671,0,null,null," Single Requirement blob",null,false],[284,1673,0,null,null," Requirements vector (internal requirements)",null,false],[284,1675,0,null,null," CodeDirectory blob",null,false],[284,1677,0,null,null," embedded form of signature data",null,false],[284,1679,0,null,null," XXX",null,false],[284,1681,0,null,null," Embedded entitlements",null,false],[284,1683,0,null,null," Embedded DER encoded entitlements",null,false],[284,1685,0,null,null," Multi-arch collection of embedded signatures",null,false],[284,1687,0,null,null," CMS Signature, among other things",null,false],[284,1689,0,null,null,null,null,false],[284,1690,0,null,null,null,null,false],[284,1691,0,null,null,null,null,false],[284,1692,0,null,null,null,null,false],[284,1695,0,null,null," Slot index for CodeDirectory",null,false],[284,1696,0,null,null,null,null,false],[284,1697,0,null,null,null,null,false],[284,1698,0,null,null,null,null,false],[284,1699,0,null,null,null,null,false],[284,1700,0,null,null,null,null,false],[284,1701,0,null,null,null,null,false],[284,1704,0,null,null," first alternate CodeDirectory, if any",null,false],[284,1706,0,null,null," Max number of alternate CD slots",null,false],[284,1708,0,null,null," One past the last",null,false],[284,1711,0,null,null," CMS Signature",null,false],[284,1712,0,null,null,null,null,false],[284,1713,0,null,null,null,null,false],[284,1716,0,null,null," Compat with amfi",null,false],[284,1718,0,null,null," Compat with amfi",null,false],[284,1720,0,null,null,null,null,false],[284,1721,0,null,null,null,null,false],[284,1722,0,null,null,null,null,false],[284,1723,0,null,null,null,null,false],[284,1725,0,null,null,null,null,false],[284,1726,0,null,null,null,null,false],[284,1727,0,null,null,null,null,false],[284,1730,0,null,null," Always - larger hashes are truncated",null,false],[284,1732,0,null,null," Max size of the hash we'll support",null,false],[284,1734,0,null,null,null,null,false],[284,1735,0,null,null,null,null,false],[284,1736,0,null,null,null,null,false],[284,1738,0,null,null,null,null,false],[284,1739,0,null,null,null,null,false],[284,1741,0,null,null,null,null,false],[284,1744,0,null,null," This CodeDirectory is tailored specifically at version 0x20400.",[32367,32368,32369,32370,32371,32372,32373,32374,32375,32376,32377,32378,32379,32380,32381,32382,32383,32384,32385,32386,32387],false],[0,0,0,"magic",null," Magic number (CSMAGIC_CODEDIRECTORY)",null,false],[0,0,0,"length",null," Total length of CodeDirectory blob",null,false],[0,0,0,"version",null," Compatibility version",null,false],[0,0,0,"flags",null," Setup and mode flags",null,false],[0,0,0,"hashOffset",null," Offset of hash slot element at index zero",null,false],[0,0,0,"identOffset",null," Offset of identifier string",null,false],[0,0,0,"nSpecialSlots",null," Number of special hash slots",null,false],[0,0,0,"nCodeSlots",null," Number of ordinary (code) hash slots",null,false],[0,0,0,"codeLimit",null," Limit to main image signature range",null,false],[0,0,0,"hashSize",null," Size of each hash in bytes",null,false],[0,0,0,"hashType",null," Type of hash (cdHashType* constants)",null,false],[0,0,0,"platform",null," Platform identifier; zero if not platform binary",null,false],[0,0,0,"pageSize",null," log2(page size in bytes); 0 => infinite",null,false],[0,0,0,"spare2",null," Unused (must be zero)",null,false],[0,0,0,"scatterOffset",null,"",null,false],[0,0,0,"teamOffset",null,"",null,false],[0,0,0,"spare3",null,"",null,false],[0,0,0,"codeLimit64",null,"",null,false],[0,0,0,"execSegBase",null," Offset of executable segment",null,false],[0,0,0,"execSegLimit",null," Limit of executable segment",null,false],[0,0,0,"execSegFlags",null," Executable segment flags",null,false],[284,1810,0,null,null," Structure of an embedded-signature SuperBlob",[32389,32390],false],[0,0,0,"type",null," Type of entry",null,false],[0,0,0,"offset",null," Offset of entry",null,false],[284,1820,0,null,null," This structure is followed by GenericBlobs in no particular\n order as indicated by offsets in index",[32392,32393,32394],false],[0,0,0,"magic",null," Magic number",null,false],[0,0,0,"length",null," Total length of SuperBlob",null,false],[0,0,0,"count",null," Number of index BlobIndex entries following this struct",null,false],[284,1831,0,null,null,null,[32396,32397],false],[0,0,0,"magic",null," Magic number",null,false],[0,0,0,"length",null," Total length of blob",null,false],[284,1842,0,null,null," The LC_DATA_IN_CODE load commands uses a linkedit_data_command\n to point to an array of data_in_code_entry entries. Each entry\n describes a range of data in a code section.",[32399,32400,32401],false],[0,0,0,"offset",null," From mach_header to start of data range.",null,false],[0,0,0,"length",null," Number of bytes in data range.",null,false],[0,0,0,"kind",null," A DICE_KIND value.",null,false],[284,1853,0,null,null,null,[32425,32427,32428],false],[284,1858,0,null,null,null,[32420,32422],false],[284,1862,0,null,null,null,[32405],false],[0,0,0,"lc",null,"",null,false],[284,1866,0,null,null,null,[32407],false],[0,0,0,"lc",null,"",null,false],[284,1870,0,null,null,null,[32409,32410],false],[0,0,0,"lc",null,"",null,false],[0,0,0,"Cmd",null,"",null,true],[284,1876,0,null,null," Asserts LoadCommand is of type segment_command_64.",[32412],false],[0,0,0,"lc",null,"",null,false],[284,1888,0,null,null," Asserts LoadCommand is of type dylib_command.",[32414],false],[0,0,0,"lc",null,"",null,false],[284,1895,0,null,null," Asserts LoadCommand is of type rpath_command.",[32416],false],[0,0,0,"lc",null,"",null,false],[284,1902,0,null,null," Asserts LoadCommand is of type build_version_command.",[32418],false],[0,0,0,"lc",null,"",null,false],[284,1858,0,null,null,null,null,false],[0,0,0,"hdr",null,null,null,false],[284,1858,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[284,1912,0,null,null,null,[32424],false],[0,0,0,"it",null,"",null,false],[0,0,0,"ncmds",null,null,null,false],[284,1853,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[0,0,0,"index",null,null,null,false],[284,1931,0,null,null,null,null,false],[284,1935,0,null,null,null,[32431,32432,32433,32434,32435],false],[0,0,0,"rangeStart",null,null,null,false],[0,0,0,"rangeLength",null,null,null,false],[0,0,0,"compactUnwindEncoding",null,null,null,false],[0,0,0,"personalityFunction",null,null,null,false],[0,0,0,"lsda",null,null,null,false],[284,1948,0,null,null,null,null,false],[284,1950,0,null,null,null,[32438,32439,32440,32441,32442,32443,32444],false],[0,0,0,"version",null," UNWIND_SECTION_VERSION",null,false],[0,0,0,"commonEncodingsArraySectionOffset",null,null,null,false],[0,0,0,"commonEncodingsArrayCount",null,null,null,false],[0,0,0,"personalityArraySectionOffset",null,null,null,false],[0,0,0,"personalityArrayCount",null,null,null,false],[0,0,0,"indexSectionOffset",null,null,null,false],[0,0,0,"indexCount",null,null,null,false],[284,1965,0,null,null,null,[32446,32447,32448],false],[0,0,0,"functionOffset",null,null,null,false],[0,0,0,"secondLevelPagesSectionOffset",null," section offset to start of regular or compress page",null,false],[0,0,0,"lsdaIndexArraySectionOffset",null," section offset to start of lsda_index array for this range",null,false],[284,1975,0,null,null,null,[32450,32451],false],[0,0,0,"functionOffset",null,null,null,false],[0,0,0,"lsdaOffset",null,null,null,false],[284,1985,0,null,null,null,[32453,32455],false],[0,0,0,"functionOffset",null,null,null,false],[284,1985,0,null,null,null,null,false],[0,0,0,"encoding",null,null,null,false],[284,1990,0,null,null,null,[32457,32458],false],[0,0,0,"REGULAR",null,null,null,false],[0,0,0,"COMPRESSED",null,null,null,false],[284,1996,0,null,null,null,[32461,32462,32463],false],[284,1996,0,null,null,null,null,false],[0,0,0,"kind",null," UNWIND_SECOND_LEVEL_REGULAR",null,false],[0,0,0,"entryPageOffset",null,null,null,false],[0,0,0,"entryCount",null,null,null,false],[284,2005,0,null,null,null,[32466,32467,32468,32469,32470],false],[284,2005,0,null,null,null,null,false],[0,0,0,"kind",null," UNWIND_SECOND_LEVEL_COMPRESSED",null,false],[0,0,0,"entryPageOffset",null,null,null,false],[0,0,0,"entryCount",null,null,null,false],[0,0,0,"encodingsPageOffset",null,null,null,false],[0,0,0,"encodingsCount",null,null,null,false],[284,2017,0,null,null,null,[32473,32474],false],[284,2017,0,null,null,null,null,false],[0,0,0,"funcOffset",null,null,null,false],[0,0,0,"encodingIndex",null,null,null,false],[284,2022,0,null,null,null,null,false],[284,2023,0,null,null,null,null,false],[284,2024,0,null,null,null,null,false],[284,2027,0,null,null,null,null,false],[284,2028,0,null,null,null,[32480,32481,32482,32483,32484],false],[0,0,0,"OLD",null,null,null,false],[0,0,0,"RBP_FRAME",null,null,null,false],[0,0,0,"STACK_IMMD",null,null,null,false],[0,0,0,"STACK_IND",null,null,null,false],[0,0,0,"DWARF",null,null,null,false],[284,2035,0,null,null,null,null,false],[284,2036,0,null,null,null,null,false],[284,2038,0,null,null,null,null,false],[284,2039,0,null,null,null,null,false],[284,2040,0,null,null,null,null,false],[284,2041,0,null,null,null,null,false],[284,2043,0,null,null,null,null,false],[284,2045,0,null,null,null,[32493,32494,32495,32496,32497,32498,32499],false],[0,0,0,"NONE",null,null,null,false],[0,0,0,"RBX",null,null,null,false],[0,0,0,"R12",null,null,null,false],[0,0,0,"R13",null,null,null,false],[0,0,0,"R14",null,null,null,false],[0,0,0,"R15",null,null,null,false],[0,0,0,"RBP",null,null,null,false],[284,2056,0,null,null,null,null,false],[284,2057,0,null,null,null,[32502,32503,32504,32505],false],[0,0,0,"OLD",null,null,null,false],[0,0,0,"FRAMELESS",null,null,null,false],[0,0,0,"DWARF",null,null,null,false],[0,0,0,"FRAME",null,null,null,false],[284,2064,0,null,null,null,null,false],[284,2065,0,null,null,null,null,false],[284,2066,0,null,null,null,null,false],[284,2067,0,null,null,null,null,false],[284,2068,0,null,null,null,null,false],[284,2069,0,null,null,null,null,false],[284,2070,0,null,null,null,null,false],[284,2071,0,null,null,null,null,false],[284,2072,0,null,null,null,null,false],[284,2074,0,null,null,null,null,false],[284,2075,0,null,null,null,null,false],[284,2077,0,null,null,null,[32572,32576,32578,32579,32580],false],[284,2077,0,null,null,null,[32548,32571],false],[284,2080,0,null,null,null,null,false],[0,0,0,"reg4",null,null,null,false],[284,2080,0,null,null,null,null,false],[0,0,0,"reg3",null,null,null,false],[284,2080,0,null,null,null,null,false],[0,0,0,"reg2",null,null,null,false],[284,2080,0,null,null,null,null,false],[0,0,0,"reg1",null,null,null,false],[284,2080,0,null,null,null,null,false],[0,0,0,"reg0",null,null,null,false],[0,0,0,"unused",null,null,null,false],[0,0,0,"frame_offset",null,null,null,false],[0,0,0,"frame",null,null,[32533,32535,32545],false],[284,2089,0,null,null,null,null,false],[0,0,0,"stack_reg_permutation",null,null,null,false],[284,2089,0,null,null,null,null,false],[0,0,0,"stack_reg_count",null,null,null,false],[284,2089,0,null,null,null,[32540,32544],false],[284,2093,0,null,null,null,null,false],[0,0,0,"_",null,null,null,false],[0,0,0,"stack_size",null,null,null,false],[0,0,0,"direct",null,null,[32542,32543],false],[284,2097,0,null,null,null,null,false],[0,0,0,"stack_adjust",null,null,null,false],[0,0,0,"sub_offset",null,null,null,false],[0,0,0,"indirect",null,null,null,false],[0,0,0,"stack",null,null,null,false],[0,0,0,"frameless",null,null,null,false],[0,0,0,"dwarf",null,null,null,false],[0,0,0,"x86_64",null,null,[32564,32569,32570],false],[284,2106,0,null,null,null,[32550,32551,32552,32553,32554],false],[0,0,0,"x19_x20",null,null,null,false],[0,0,0,"x21_x22",null,null,null,false],[0,0,0,"x23_x24",null,null,null,false],[0,0,0,"x25_x26",null,null,null,false],[0,0,0,"x27_x28",null,null,null,false],[0,0,0,"x_reg_pairs",null,null,null,false],[284,2106,0,null,null,null,[32557,32558,32559,32560],false],[0,0,0,"d8_d9",null,null,null,false],[0,0,0,"d10_d11",null,null,null,false],[0,0,0,"d12_d13",null,null,null,false],[0,0,0,"d14_d15",null,null,null,false],[0,0,0,"d_reg_pairs",null,null,null,false],[284,2106,0,null,null,null,null,false],[0,0,0,"_",null,null,null,false],[0,0,0,"frame",null,null,[32566,32568],false],[284,2122,0,null,null,null,null,false],[0,0,0,"_",null,null,null,false],[284,2122,0,null,null,null,null,false],[0,0,0,"stack_size",null,null,null,false],[0,0,0,"frameless",null,null,null,false],[0,0,0,"dwarf",null,null,null,false],[0,0,0,"arm64",null,null,null,false],[0,0,0,"value",null,null,null,false],[284,2077,0,null,null,null,[32574,32575],false],[0,0,0,"x86_64",null,null,null,false],[0,0,0,"arm64",null,null,null,false],[0,0,0,"mode",null,null,null,false],[284,2077,0,null,null,null,null,false],[0,0,0,"personality_index",null,null,null,false],[0,0,0,"has_lsda",null,null,null,false],[0,0,0,"start",null,null,null,false],[1,134,0,null,null," Mathematical constants and operations.",null,false],[0,0,0,"math.zig",null,"",[],false],[285,0,0,null,null,null,null,false],[285,1,0,null,null,null,null,false],[285,2,0,null,null,null,null,false],[285,3,0,null,null,null,null,false],[285,4,0,null,null,null,null,false],[285,7,0,null,null," Euler's number (e)",null,false],[285,10,0,null,null," Archimedes' constant (π)",null,false],[285,13,0,null,null," Phi or Golden ratio constant (Φ) = (1 + sqrt(5))/2",null,false],[285,16,0,null,null," Circle constant (τ)",null,false],[285,19,0,null,null," log2(e)",null,false],[285,22,0,null,null," log10(e)",null,false],[285,25,0,null,null," ln(2)",null,false],[285,28,0,null,null," ln(10)",null,false],[285,31,0,null,null," 2/sqrt(π)",null,false],[285,34,0,null,null," sqrt(2)",null,false],[285,37,0,null,null," 1/sqrt(2)",null,false],[285,39,0,null,null,null,null,false],[0,0,0,"math/float.zig",null,"",[],false],[286,0,0,null,null,null,null,false],[286,1,0,null,null,null,null,false],[286,2,0,null,null,null,null,false],[286,3,0,null,null,null,null,false],[286,4,0,null,null,null,null,false],[286,7,0,null,null," Creates a raw \"1.0\" mantissa for floating point type T. Used to dedupe f80 logic.",[32607],false],[0,0,0,"T",null,"",null,true],[286,12,0,null,null," Creates floating point type T from an unbiased exponent and raw mantissa.",[32609,32610,32611],false],[0,0,0,"T",null,"",null,true],[0,0,0,"exponent",null,"",null,true],[0,0,0,"mantissa",null,"",null,true],[286,19,0,null,null," Returns the number of bits in the exponent of floating point type T.",[32613],false],[0,0,0,"T",null,"",null,true],[286,33,0,null,null," Returns the number of bits in the mantissa of floating point type T.",[32615],false],[0,0,0,"T",null,"",null,true],[286,47,0,null,null," Returns the number of fractional bits in the mantissa of floating point type T.",[32617],false],[0,0,0,"T",null,"",null,true],[286,65,0,null,null," Returns the minimum exponent that can represent\n a normalised value in floating point type T.",[32619],false],[0,0,0,"T",null,"",null,true],[286,71,0,null,null," Returns the maximum exponent that can represent\n a normalised value in floating point type T.",[32621],false],[0,0,0,"T",null,"",null,true],[286,76,0,null,null," Returns the smallest subnormal number representable in floating point type T.",[32623],false],[0,0,0,"T",null,"",null,true],[286,81,0,null,null," Returns the smallest normal number representable in floating point type T.",[32625],false],[0,0,0,"T",null,"",null,true],[286,86,0,null,null," Returns the largest normal number representable in floating point type T.",[32627],false],[0,0,0,"T",null,"",null,true],[286,92,0,null,null," Returns the machine epsilon of floating point type T.",[32629],false],[0,0,0,"T",null,"",null,true],[286,97,0,null,null," Returns the value inf for floating point type T.",[32631],false],[0,0,0,"T",null,"",null,true],[286,102,0,null,null," Returns the canonical quiet NaN representation for floating point type T.",[32633],false],[0,0,0,"T",null,"",null,true],[286,114,0,null,null," Returns a signalling NaN representation for floating point type T.\n\n TODO: LLVM is known to miscompile on some architectures to quiet NaN -\n       this is tracked by https://github.com/ziglang/zig/issues/14366",[32635],false],[0,0,0,"T",null,"",null,true],[285,40,0,null,null,null,null,false],[285,41,0,null,null,null,null,false],[285,42,0,null,null,null,null,false],[285,43,0,null,null,null,null,false],[285,44,0,null,null,null,null,false],[285,45,0,null,null,null,null,false],[285,46,0,null,null,null,null,false],[285,47,0,null,null,null,null,false],[285,48,0,null,null,null,null,false],[285,49,0,null,null,null,null,false],[285,50,0,null,null,null,null,false],[285,52,0,null,null,null,null,false],[285,53,0,null,null,null,null,false],[285,54,0,null,null,null,null,false],[285,55,0,null,null,null,null,false],[285,56,0,null,null,null,null,false],[285,57,0,null,null,null,null,false],[285,58,0,null,null,null,null,false],[285,59,0,null,null,null,null,false],[285,60,0,null,null,null,null,false],[285,61,0,null,null,null,null,false],[285,62,0,null,null,null,null,false],[285,63,0,null,null,null,null,false],[285,64,0,null,null,null,null,false],[285,65,0,null,null,null,null,false],[285,66,0,null,null,null,null,false],[285,67,0,null,null,null,null,false],[285,68,0,null,null,null,null,false],[285,69,0,null,null,null,null,false],[285,70,0,null,null,null,null,false],[285,71,0,null,null,null,null,false],[285,72,0,null,null,null,null,false],[285,73,0,null,null,null,null,false],[285,74,0,null,null,null,null,false],[285,75,0,null,null,null,null,false],[285,76,0,null,null,null,null,false],[285,77,0,null,null,null,null,false],[285,78,0,null,null,null,null,false],[285,79,0,null,null,null,null,false],[285,80,0,null,null,null,null,false],[285,81,0,null,null,null,null,false],[285,82,0,null,null,null,null,false],[285,83,0,null,null,null,null,false],[285,84,0,null,null,null,null,false],[285,85,0,null,null,null,null,false],[285,86,0,null,null,null,null,false],[285,87,0,null,null,null,null,false],[285,88,0,null,null,null,null,false],[285,89,0,null,null,null,null,false],[285,90,0,null,null,null,null,false],[285,91,0,null,null,null,null,false],[285,92,0,null,null,null,null,false],[285,93,0,null,null,null,null,false],[285,94,0,null,null,null,null,false],[285,95,0,null,null,null,null,false],[285,96,0,null,null,null,null,false],[285,97,0,null,null,null,null,false],[285,98,0,null,null,null,null,false],[285,99,0,null,null,null,null,false],[285,100,0,null,null,null,null,false],[285,101,0,null,null,null,null,false],[285,102,0,null,null,null,null,false],[285,103,0,null,null,null,null,false],[285,104,0,null,null,null,null,false],[285,105,0,null,null,null,null,false],[285,106,0,null,null,null,null,false],[285,107,0,null,null,null,null,false],[285,121,0,null,null," Performs an approximate comparison of two floating point values `x` and `y`.\n Returns true if the absolute difference between them is less or equal than\n the specified tolerance.\n\n The `tolerance` parameter is the absolute tolerance used when determining if\n the two numbers are close enough; a good value for this parameter is a small\n multiple of `floatEps(T)`.\n\n Note that this function is recommended for comparing small numbers\n around zero; using `approxEqRel` is suggested otherwise.\n\n NaN values are never considered equal to any value.",[32704,32705,32706,32707],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"tolerance",null,"",null,false],[285,149,0,null,null," Performs an approximate comparison of two floating point values `x` and `y`.\n Returns true if the absolute difference between them is less or equal than\n `max(|x|, |y|) * tolerance`, where `tolerance` is a positive number greater\n than zero.\n\n The `tolerance` parameter is the relative tolerance used when determining if\n the two numbers are close enough; a good value for this parameter is usually\n `sqrt(floatEps(T))`, meaning that the two numbers are considered equal if at\n least half of the digits are equal.\n\n Note that for comparisons of small numbers around zero this function won't\n give meaningful results, use `approxEqAbs` instead.\n\n NaN values are never considered equal to any value.",[32709,32710,32711,32712],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"tolerance",null,"",null,false],[285,188,0,null,null,null,[32714],false],[0,0,0,"val",null,"",null,false],[285,192,0,null,null,null,[],false],[285,196,0,null,null,null,[],false],[285,200,0,null,null,null,[],false],[285,204,0,null,null,null,[],false],[285,208,0,null,null,null,[],false],[285,212,0,null,null,null,null,false],[0,0,0,"math/isnan.zig",null,"",[],false],[287,0,0,null,null,null,null,false],[287,1,0,null,null,null,null,false],[287,2,0,null,null,null,null,false],[287,3,0,null,null,null,null,false],[287,4,0,null,null,null,null,false],[287,6,0,null,null,null,[32728],false],[0,0,0,"x",null,"",null,false],[287,12,0,null,null," TODO: LLVM is known to miscompile on some architectures to quiet NaN -\n       this is tracked by https://github.com/ziglang/zig/issues/14366",[32730],false],[0,0,0,"x",null,"",null,false],[285,213,0,null,null,null,null,false],[285,214,0,null,null,null,null,false],[0,0,0,"math/frexp.zig",null,"",[],false],[288,7,0,null,null,null,null,false],[288,8,0,null,null,null,null,false],[288,9,0,null,null,null,null,false],[288,11,0,null,null,null,[32738],false],[0,0,0,"T",null,"",[32740,32741],true],[288,12,0,null,null,null,null,false],[0,0,0,"significand",null,null,null,false],[0,0,0,"exponent",null,null,null,false],[288,25,0,null,null," Breaks x into a normalized fraction and an integral power of two.\n f == frac * 2^exp, with |frac| in the interval [0.5, 1).\n\n Special Cases:\n  - frexp(+-0)   = +-0, 0\n  - frexp(+-inf) = +-inf, 0\n  - frexp(nan)   = nan, undefined",[32743],false],[0,0,0,"x",null,"",null,false],[288,37,0,null,null,null,[32745],false],[0,0,0,"x",null,"",null,false],[288,74,0,null,null,null,[32747],false],[0,0,0,"x",null,"",null,false],[288,111,0,null,null,null,[32749],false],[0,0,0,"x",null,"",null,false],[285,215,0,null,null,null,null,false],[285,216,0,null,null,null,null,false],[0,0,0,"math/modf.zig",null,"",[],false],[289,6,0,null,null,null,null,false],[289,7,0,null,null,null,null,false],[289,8,0,null,null,null,null,false],[289,9,0,null,null,null,null,false],[289,10,0,null,null,null,null,false],[289,12,0,null,null,null,[32759],false],[0,0,0,"T",null,"",[32761,32763],true],[289,13,0,null,null,null,null,false],[0,0,0,"fpart",null,null,null,false],[289,13,0,null,null,null,null,false],[0,0,0,"ipart",null,null,null,false],[289,18,0,null,null,null,null,false],[289,19,0,null,null,null,null,false],[289,27,0,null,null," Returns the integer and fractional floating-point numbers that sum to x. The sign of each\n result is the same as the sign of x.\n\n Special Cases:\n  - modf(+-inf) = +-inf, nan\n  - modf(nan)   = nan, nan",[32767],false],[0,0,0,"x",null,"",null,false],[289,36,0,null,null,null,[32769],false],[0,0,0,"x",null,"",null,false],[289,81,0,null,null,null,[32771],false],[0,0,0,"x",null,"",null,false],[285,217,0,null,null,null,null,false],[285,218,0,null,null,null,null,false],[285,219,0,null,null,null,null,false],[0,0,0,"math/copysign.zig",null,"",[],false],[290,0,0,null,null,null,null,false],[290,1,0,null,null,null,null,false],[290,2,0,null,null,null,null,false],[290,5,0,null,null," Returns a value with the magnitude of `magnitude` and the sign of `sign`.",[32780,32781],false],[0,0,0,"magnitude",null,"",null,false],[0,0,0,"sign",null,"",null,false],[285,220,0,null,null,null,null,false],[0,0,0,"math/isfinite.zig",null,"",[],false],[291,0,0,null,null,null,null,false],[291,1,0,null,null,null,null,false],[291,2,0,null,null,null,null,false],[291,5,0,null,null," Returns whether x is a finite value.",[32788],false],[0,0,0,"x",null,"",null,false],[285,221,0,null,null,null,null,false],[0,0,0,"math/isinf.zig",null,"",[],false],[292,0,0,null,null,null,null,false],[292,1,0,null,null,null,null,false],[292,2,0,null,null,null,null,false],[292,5,0,null,null," Returns whether x is an infinity, ignoring sign.",[32795],false],[0,0,0,"x",null,"",null,false],[292,13,0,null,null," Returns whether x is an infinity with a positive sign.",[32797],false],[0,0,0,"x",null,"",null,false],[292,18,0,null,null," Returns whether x is an infinity with a negative sign.",[32799],false],[0,0,0,"x",null,"",null,false],[285,222,0,null,null,null,null,false],[285,223,0,null,null,null,null,false],[285,224,0,null,null,null,null,false],[0,0,0,"math/isnormal.zig",null,"",[],false],[293,0,0,null,null,null,null,false],[293,1,0,null,null,null,null,false],[293,2,0,null,null,null,null,false],[293,5,0,null,null," Returns whether x is neither zero, subnormal, infinity, or NaN.",[32808],false],[0,0,0,"x",null,"",null,false],[285,225,0,null,null,null,null,false],[0,0,0,"math/signbit.zig",null,"",[],false],[294,0,0,null,null,null,null,false],[294,1,0,null,null,null,null,false],[294,2,0,null,null,null,null,false],[294,5,0,null,null," Returns whether x is negative or negative 0.",[32815],false],[0,0,0,"x",null,"",null,false],[285,226,0,null,null,null,null,false],[0,0,0,"math/scalbn.zig",null,"",[],false],[295,0,0,null,null,null,null,false],[295,1,0,null,null,null,null,false],[295,6,0,null,null," Returns a * FLT_RADIX ^ exp.\n\n Zig only supports binary base IEEE-754 floats. Hence FLT_RADIX=2, and this is an alias for ldexp.",null,false],[0,0,0,"ldexp.zig",null,"",[],false],[296,0,0,null,null,null,null,false],[296,1,0,null,null,null,null,false],[296,2,0,null,null,null,null,false],[296,3,0,null,null,null,null,false],[296,4,0,null,null,null,null,false],[296,7,0,null,null," Returns x * 2^n.",[32828,32829],false],[0,0,0,"x",null,"",null,false],[0,0,0,"n",null,"",null,false],[285,227,0,null,null,null,null,false],[285,228,0,null,null,null,null,false],[0,0,0,"math/pow.zig",null,"",[],false],[297,5,0,null,null,null,null,false],[297,6,0,null,null,null,null,false],[297,7,0,null,null,null,null,false],[297,32,0,null,null," Returns x raised to the power of y (x^y).\n\n Special Cases:\n  - pow(x, +-0)    = 1 for any x\n  - pow(1, y)      = 1 for any y\n  - pow(x, 1)      = x for any x\n  - pow(nan, y)    = nan\n  - pow(x, nan)    = nan\n  - pow(+-0, y)    = +-inf for y an odd integer < 0\n  - pow(+-0, -inf) = +inf\n  - pow(+-0, +inf) = +0\n  - pow(+-0, y)    = +inf for finite y < 0 and not an odd integer\n  - pow(+-0, y)    = +-0 for y an odd integer > 0\n  - pow(+-0, y)    = +0 for finite y > 0 and not an odd integer\n  - pow(-1, +-inf) = 1\n  - pow(x, +inf)   = +inf for |x| > 1\n  - pow(x, -inf)   = +0 for |x| > 1\n  - pow(x, +inf)   = +0 for |x| < 1\n  - pow(x, -inf)   = +inf for |x| < 1\n  - pow(+inf, y)   = +inf for y > 0\n  - pow(+inf, y)   = +0 for y < 0\n  - pow(-inf, y)   = pow(-0, -y)\n  - pow(x, y)      = nan for finite x < 0 and finite non-integer y",[32837,32838,32839],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[297,179,0,null,null,null,[32841],false],[0,0,0,"x",null,"",null,false],[285,229,0,null,null,null,null,false],[0,0,0,"math/powi.zig",null,"",[],false],[298,5,0,null,null,null,null,false],[298,6,0,null,null,null,null,false],[298,7,0,null,null,null,null,false],[298,8,0,null,null,null,null,false],[298,25,0,null,null," Returns the power of x raised by the integer y (x^y).\n\n Errors:\n  - Overflow: Integer overflow or Infinity\n  - Underflow: Absolute value of result smaller than 1\n Edge case rules ordered by precedence:\n  - powi(T, x, 0)   = 1 unless T is i1, i0, u0\n  - powi(T, 0, x)   = 0 when x > 0\n  - powi(T, 0, x)   = Overflow\n  - powi(T, 1, y)   = 1\n  - powi(T, -1, y)  = -1 for y an odd integer\n  - powi(T, -1, y)  = 1 unless T is i1, i0, u0\n  - powi(T, -1, y)  = Overflow\n  - powi(T, x, y)   = Overflow when y >= @bitSizeOf(x)\n  - powi(T, x, y)   = Underflow when y < 0",[32849,32850,32851],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[285,230,0,null,null,null,null,false],[0,0,0,"math/sqrt.zig",null,"",[],false],[299,0,0,null,null,null,null,false],[299,1,0,null,null,null,null,false],[299,2,0,null,null,null,null,false],[299,3,0,null,null,null,null,false],[299,4,0,null,null,null,null,false],[299,14,0,null,null," Returns the square root of x.\n\n Special Cases:\n  - sqrt(+inf)  = +inf\n  - sqrt(+-0)   = +-0\n  - sqrt(x)     = nan if x < 0\n  - sqrt(nan)   = nan\n TODO Decide if all this logic should be implemented directly in the @sqrt builtin function.",[32860],false],[0,0,0,"x",null,"",null,false],[299,35,0,null,null,null,[32862,32863],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[299,80,0,null,null," Returns the return type `sqrt` will return given an operand of type `T`.",[32865],false],[0,0,0,"T",null,"",null,true],[285,231,0,null,null,null,null,false],[0,0,0,"math/cbrt.zig",null,"",[],false],[300,6,0,null,null,null,null,false],[300,7,0,null,null,null,null,false],[300,8,0,null,null,null,null,false],[300,16,0,null,null," Returns the cube root of x.\n\n Special Cases:\n  - cbrt(+-0)   = +-0\n  - cbrt(+-inf) = +-inf\n  - cbrt(nan)   = nan",[32872],false],[0,0,0,"x",null,"",null,false],[300,25,0,null,null,null,[32874],false],[0,0,0,"x",null,"",null,false],[300,65,0,null,null,null,[32876],false],[0,0,0,"x",null,"",null,false],[285,232,0,null,null,null,null,false],[0,0,0,"math/acos.zig",null,"",[],false],[301,6,0,null,null,null,null,false],[301,7,0,null,null,null,null,false],[301,8,0,null,null,null,null,false],[301,14,0,null,null," Returns the arc-cosine of x.\n\n Special cases:\n  - acos(x)   = nan if x < -1 or x > 1",[32883],false],[0,0,0,"x",null,"",null,false],[301,23,0,null,null,null,[32885],false],[0,0,0,"z",null,"",null,false],[301,34,0,null,null,null,[32887],false],[0,0,0,"x",null,"",null,false],[301,81,0,null,null,null,[32889],false],[0,0,0,"z",null,"",null,false],[301,98,0,null,null,null,[32891],false],[0,0,0,"x",null,"",null,false],[285,233,0,null,null,null,null,false],[0,0,0,"math/asin.zig",null,"",[],false],[302,6,0,null,null,null,null,false],[302,7,0,null,null,null,null,false],[302,8,0,null,null,null,null,false],[302,15,0,null,null," Returns the arc-sin of x.\n\n Special Cases:\n  - asin(+-0) = +-0\n  - asin(x)   = nan if x < -1 or x > 1",[32898],false],[0,0,0,"x",null,"",null,false],[302,24,0,null,null,null,[32900],false],[0,0,0,"z",null,"",null,false],[302,35,0,null,null,null,[32902],false],[0,0,0,"x",null,"",null,false],[302,73,0,null,null,null,[32904],false],[0,0,0,"z",null,"",null,false],[302,90,0,null,null,null,[32906],false],[0,0,0,"x",null,"",null,false],[285,234,0,null,null,null,null,false],[0,0,0,"math/atan.zig",null,"",[],false],[303,6,0,null,null,null,null,false],[303,7,0,null,null,null,null,false],[303,8,0,null,null,null,null,false],[303,15,0,null,null," Returns the arc-tangent of x.\n\n Special Cases:\n  - atan(+-0)   = +-0\n  - atan(+-inf) = +-pi/2",[32913],false],[0,0,0,"x",null,"",null,false],[303,24,0,null,null,null,[32915],false],[0,0,0,"x_",null,"",null,false],[303,115,0,null,null,null,[32917],false],[0,0,0,"x_",null,"",null,false],[285,235,0,null,null,null,null,false],[0,0,0,"math/atan2.zig",null,"",[],false],[304,6,0,null,null,null,null,false],[304,7,0,null,null,null,null,false],[304,8,0,null,null,null,null,false],[304,30,0,null,null," Returns the arc-tangent of y/x.\n\n Special Cases:\n  - atan2(y, nan)     = nan\n  - atan2(nan, x)     = nan\n  - atan2(+0, x>=0)   = +0\n  - atan2(-0, x>=0)   = -0\n  - atan2(+0, x<=-0)  = +pi\n  - atan2(-0, x<=-0)  = -pi\n  - atan2(y>0, 0)     = +pi/2\n  - atan2(y<0, 0)     = -pi/2\n  - atan2(+inf, +inf) = +pi/4\n  - atan2(-inf, +inf) = -pi/4\n  - atan2(+inf, -inf) = 3pi/4\n  - atan2(-inf, -inf) = -3pi/4\n  - atan2(y, +inf)    = 0\n  - atan2(y>0, -inf)  = +pi\n  - atan2(y<0, -inf)  = -pi\n  - atan2(+inf, x)    = +pi/2\n  - atan2(-inf, x)    = -pi/2",[32924,32925,32926],false],[0,0,0,"T",null,"",null,true],[0,0,0,"y",null,"",null,false],[0,0,0,"x",null,"",null,false],[304,38,0,null,null,null,[32928,32929],false],[0,0,0,"y",null,"",null,false],[0,0,0,"x",null,"",null,false],[304,123,0,null,null,null,[32931,32932],false],[0,0,0,"y",null,"",null,false],[0,0,0,"x",null,"",null,false],[285,236,0,null,null,null,null,false],[0,0,0,"math/hypot.zig",null,"",[],false],[305,6,0,null,null,null,null,false],[305,7,0,null,null,null,null,false],[305,8,0,null,null,null,null,false],[305,9,0,null,null,null,null,false],[305,18,0,null,null," Returns sqrt(x * x + y * y), avoiding unnecessary overflow and underflow.\n\n Special Cases:\n  - hypot(+-inf, y)  = +inf\n  - hypot(x, +-inf)  = +inf\n  - hypot(nan, y)    = nan\n  - hypot(x, nan)    = nan",[32940,32941,32942],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[305,26,0,null,null,null,[32944,32945],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[305,61,0,null,null,null,[32947,32948,32949],false],[0,0,0,"hi",null,"",null,false],[0,0,0,"lo",null,"",null,false],[0,0,0,"x",null,"",null,false],[305,70,0,null,null,null,[32951,32952],false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[285,237,0,null,null,null,null,false],[0,0,0,"math/expm1.zig",null,"",[],false],[306,8,0,null,null,null,null,false],[306,9,0,null,null,null,null,false],[306,10,0,null,null,null,null,false],[306,19,0,null,null," Returns e raised to the power of x, minus 1 (e^x - 1). This is more accurate than exp(e, x) - 1\n when x is near 0.\n\n Special Cases:\n  - expm1(+inf) = +inf\n  - expm1(-inf) = -1\n  - expm1(nan)  = nan",[32959],false],[0,0,0,"x",null,"",null,false],[306,28,0,null,null,null,[32961],false],[0,0,0,"x_",null,"",null,false],[306,156,0,null,null,null,[32963],false],[0,0,0,"x_",null,"",null,false],[285,238,0,null,null,null,null,false],[0,0,0,"math/ilogb.zig",null,"",[],false],[307,7,0,null,null,null,null,false],[307,8,0,null,null,null,null,false],[307,9,0,null,null,null,null,false],[307,10,0,null,null,null,null,false],[307,11,0,null,null,null,null,false],[307,19,0,null,null," Returns the binary exponent of x as an integer.\n\n Special Cases:\n  - ilogb(+-inf) = maxInt(i32)\n  - ilogb(+-0)   = minInt(i32)\n  - ilogb(nan)   = minInt(i32)",[32972],false],[0,0,0,"x",null,"",null,false],[307,24,0,null,null,null,null,false],[307,25,0,null,null,null,null,false],[307,27,0,null,null,null,[32976,32977],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[285,239,0,null,null,null,null,false],[0,0,0,"math/log.zig",null,"",[],false],[308,6,0,null,null,null,null,false],[308,7,0,null,null,null,null,false],[308,8,0,null,null,null,null,false],[308,11,0,null,null," Returns the logarithm of x for the provided base.",[32984,32985,32986],false],[0,0,0,"T",null,"",null,true],[0,0,0,"base",null,"",null,false],[0,0,0,"x",null,"",null,false],[285,240,0,null,null,null,null,false],[0,0,0,"math/log2.zig",null,"",[],false],[309,0,0,null,null,null,null,false],[309,1,0,null,null,null,null,false],[309,2,0,null,null,null,null,false],[309,3,0,null,null,null,null,false],[309,12,0,null,null," Returns the base-2 logarithm of x.\n\n Special Cases:\n  - log2(+inf)  = +inf\n  - log2(0)     = -inf\n  - log2(x)     = nan if x < 0\n  - log2(nan)   = nan",[32994],false],[0,0,0,"x",null,"",null,false],[285,241,0,null,null,null,null,false],[0,0,0,"math/log10.zig",null,"",[],false],[310,0,0,null,null,null,null,false],[310,1,0,null,null,null,null,false],[310,2,0,null,null,null,null,false],[310,3,0,null,null,null,null,false],[310,4,0,null,null,null,null,false],[310,5,0,null,null,null,null,false],[310,6,0,null,null,null,null,false],[310,15,0,null,null," Returns the base-10 logarithm of x.\n\n Special Cases:\n  - log10(+inf)  = +inf\n  - log10(0)     = -inf\n  - log10(x)     = nan if x < 0\n  - log10(nan)   = nan",[33005],false],[0,0,0,"x",null,"",null,false],[310,40,0,null,null," Return the log base 10 of integer value x, rounding down to the\n nearest integer.",[33007],false],[0,0,0,"x",null,"",null,false],[310,76,0,null,null,null,[33009],false],[0,0,0,"y",null,"",null,true],[310,99,0,null,null,null,[33011],false],[0,0,0,"x",null,"",null,false],[310,116,0,null,null,null,[33013],false],[0,0,0,"x",null,"",null,false],[310,135,0,null,null,null,[33015],false],[0,0,0,"x",null,"",null,false],[285,242,0,null,null,null,null,false],[285,243,0,null,null,null,null,false],[0,0,0,"math/log_int.zig",null,"",[],false],[311,0,0,null,null,null,null,false],[311,1,0,null,null,null,null,false],[311,2,0,null,null,null,null,false],[311,3,0,null,null,null,null,false],[311,4,0,null,null,null,null,false],[311,8,0,null,null," Returns the logarithm of `x` for the provided `base`, rounding down to the nearest integer.\n Asserts that `base > 1` and `x > 0`.",[33025,33026,33027],false],[0,0,0,"T",null,"",null,true],[0,0,0,"base",null,"",null,false],[0,0,0,"x",null,"",null,false],[285,244,0,null,null,null,null,false],[0,0,0,"math/log1p.zig",null,"",[],false],[312,6,0,null,null,null,null,false],[312,7,0,null,null,null,null,false],[312,8,0,null,null,null,null,false],[312,18,0,null,null," Returns the natural logarithm of 1 + x with greater accuracy when x is near zero.\n\n Special Cases:\n  - log1p(+inf)  = +inf\n  - log1p(+-0)   = +-0\n  - log1p(-1)    = -inf\n  - log1p(x)     = nan if x < -1\n  - log1p(nan)   = nan",[33034],false],[0,0,0,"x",null,"",null,false],[312,27,0,null,null,null,[33036],false],[0,0,0,"x",null,"",null,false],[312,103,0,null,null,null,[33038],false],[0,0,0,"x",null,"",null,false],[285,245,0,null,null,null,null,false],[0,0,0,"math/asinh.zig",null,"",[],false],[313,6,0,null,null,null,null,false],[313,7,0,null,null,null,null,false],[313,8,0,null,null,null,null,false],[313,9,0,null,null,null,null,false],[313,17,0,null,null," Returns the hyperbolic arc-sin of x.\n\n Special Cases:\n  - asinh(+-0)   = +-0\n  - asinh(+-inf) = +-inf\n  - asinh(nan)   = nan",[33046],false],[0,0,0,"x",null,"",null,false],[313,27,0,null,null,null,[33048],false],[0,0,0,"x",null,"",null,false],[313,54,0,null,null,null,[33050],false],[0,0,0,"x",null,"",null,false],[285,246,0,null,null,null,null,false],[0,0,0,"math/acosh.zig",null,"",[],false],[314,6,0,null,null,null,null,false],[314,7,0,null,null,null,null,false],[314,8,0,null,null,null,null,false],[314,15,0,null,null," Returns the hyperbolic arc-cosine of x.\n\n Special cases:\n  - acosh(x)   = nan if x < 1\n  - acosh(nan) = nan",[33057],false],[0,0,0,"x",null,"",null,false],[314,25,0,null,null,null,[33059],false],[0,0,0,"x",null,"",null,false],[314,43,0,null,null,null,[33061],false],[0,0,0,"x",null,"",null,false],[285,247,0,null,null,null,null,false],[0,0,0,"math/atanh.zig",null,"",[],false],[315,6,0,null,null,null,null,false],[315,7,0,null,null,null,null,false],[315,8,0,null,null,null,null,false],[315,9,0,null,null,null,null,false],[315,17,0,null,null," Returns the hyperbolic arc-tangent of x.\n\n Special Cases:\n  - atanh(+-1) = +-inf with signal\n  - atanh(x)   = nan if |x| > 1 with signal\n  - atanh(nan) = nan",[33069],false],[0,0,0,"x",null,"",null,false],[315,27,0,null,null,null,[33071],false],[0,0,0,"x",null,"",null,false],[315,56,0,null,null,null,[33073],false],[0,0,0,"x",null,"",null,false],[285,248,0,null,null,null,null,false],[0,0,0,"math/sinh.zig",null,"",[],false],[316,6,0,null,null,null,null,false],[316,7,0,null,null,null,null,false],[316,8,0,null,null,null,null,false],[316,9,0,null,null,null,null,false],[0,0,0,"expo2.zig",null,"",[],false],[317,6,0,null,null,null,null,false],[317,9,0,null,null," Returns exp(x) / 2 for x >= log(maxFloat(T)).",[33083],false],[0,0,0,"x",null,"",null,false],[317,18,0,null,null,null,[33085],false],[0,0,0,"x",null,"",null,false],[317,27,0,null,null,null,[33087],false],[0,0,0,"x",null,"",null,false],[316,10,0,null,null,null,null,false],[316,18,0,null,null," Returns the hyperbolic sine of x.\n\n Special Cases:\n  - sinh(+-0)   = +-0\n  - sinh(+-inf) = +-inf\n  - sinh(nan)   = nan",[33090],false],[0,0,0,"x",null,"",null,false],[316,30,0,null,null,null,[33092],false],[0,0,0,"x",null,"",null,false],[316,61,0,null,null,null,[33094],false],[0,0,0,"x",null,"",null,false],[285,249,0,null,null,null,null,false],[0,0,0,"math/cosh.zig",null,"",[],false],[318,6,0,null,null,null,null,false],[318,7,0,null,null,null,null,false],[318,8,0,null,null,null,null,false],[318,9,0,null,null,null,null,false],[318,10,0,null,null,null,null,false],[318,18,0,null,null," Returns the hyperbolic cosine of x.\n\n Special Cases:\n  - cosh(+-0)   = 1\n  - cosh(+-inf) = +inf\n  - cosh(nan)   = nan",[33103],false],[0,0,0,"x",null,"",null,false],[318,30,0,null,null,null,[33105],false],[0,0,0,"x",null,"",null,false],[318,55,0,null,null,null,[33107],false],[0,0,0,"x",null,"",null,false],[285,250,0,null,null,null,null,false],[0,0,0,"math/tanh.zig",null,"",[],false],[319,6,0,null,null,null,null,false],[319,7,0,null,null,null,null,false],[319,8,0,null,null,null,null,false],[319,9,0,null,null,null,null,false],[319,10,0,null,null,null,null,false],[319,18,0,null,null," Returns the hyperbolic tangent of x.\n\n Special Cases:\n  - sinh(+-0)   = +-0\n  - sinh(+-inf) = +-1\n  - sinh(nan)   = nan",[33116],false],[0,0,0,"x",null,"",null,false],[319,30,0,null,null,null,[33118],false],[0,0,0,"x",null,"",null,false],[319,67,0,null,null,null,[33120],false],[0,0,0,"x",null,"",null,false],[285,251,0,null,null,null,null,false],[0,0,0,"math/gcd.zig",null," Greatest common divisor (https://mathworld.wolfram.com/GreatestCommonDivisor.html)\n",[],false],[320,1,0,null,null,null,null,false],[320,2,0,null,null,null,null,false],[320,6,0,null,null," Returns the greatest common divisor (GCD) of two unsigned integers (a and b) which are not both zero.\n For example, the GCD of 8 and 12 is 4, that is, gcd(8, 12) == 4.",[33126,33127],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,256,0,null,null," Sine trigonometric function on a floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @sin",[33129],false],[0,0,0,"value",null,"",null,false],[285,263,0,null,null," Cosine trigonometric function on a floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @cos",[33131],false],[0,0,0,"value",null,"",null,false],[285,270,0,null,null," Tangent trigonometric function on a floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @tan",[33133],false],[0,0,0,"value",null,"",null,false],[285,275,0,null,null," Converts an angle in radians to degrees. T must be a float type.",[33135,33136],false],[0,0,0,"T",null,"",null,true],[0,0,0,"angle_in_radians",null,"",null,false],[285,290,0,null,null," Converts an angle in degrees to radians. T must be a float type.",[33138,33139],false],[0,0,0,"T",null,"",null,true],[0,0,0,"angle_in_degrees",null,"",null,false],[285,305,0,null,null," Base-e exponential function on a floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @exp",[33141],false],[0,0,0,"value",null,"",null,false],[285,312,0,null,null," Base-2 exponential function on a floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @exp2",[33143],false],[0,0,0,"value",null,"",null,false],[285,316,0,null,null,null,null,false],[0,0,0,"math/complex.zig",null,"",[],false],[321,0,0,null,null,null,null,false],[321,1,0,null,null,null,null,false],[321,2,0,null,null,null,null,false],[321,4,0,null,null,null,null,false],[0,0,0,"complex/abs.zig",null,"",[],false],[322,0,0,null,null,null,null,false],[322,1,0,null,null,null,null,false],[322,2,0,null,null,null,null,false],[322,3,0,null,null,null,null,false],[322,4,0,null,null,null,null,false],[322,7,0,null,null," Returns the absolute value (modulus) of z.",[33157],false],[0,0,0,"z",null,"",null,false],[322,12,0,null,null,null,null,false],[321,5,0,null,null,null,null,false],[0,0,0,"complex/acosh.zig",null,"",[],false],[323,0,0,null,null,null,null,false],[323,1,0,null,null,null,null,false],[323,2,0,null,null,null,null,false],[323,3,0,null,null,null,null,false],[323,4,0,null,null,null,null,false],[323,7,0,null,null," Returns the hyperbolic arc-cosine of z.",[33167],false],[0,0,0,"z",null,"",null,false],[323,13,0,null,null,null,null,false],[321,6,0,null,null,null,null,false],[0,0,0,"complex/acos.zig",null,"",[],false],[324,0,0,null,null,null,null,false],[324,1,0,null,null,null,null,false],[324,2,0,null,null,null,null,false],[324,3,0,null,null,null,null,false],[324,4,0,null,null,null,null,false],[324,7,0,null,null," Returns the arc-cosine of z.",[33177],false],[0,0,0,"z",null,"",null,false],[324,13,0,null,null,null,null,false],[321,7,0,null,null,null,null,false],[0,0,0,"complex/arg.zig",null,"",[],false],[325,0,0,null,null,null,null,false],[325,1,0,null,null,null,null,false],[325,2,0,null,null,null,null,false],[325,3,0,null,null,null,null,false],[325,4,0,null,null,null,null,false],[325,7,0,null,null," Returns the angular component (in radians) of z.",[33187],false],[0,0,0,"z",null,"",null,false],[325,12,0,null,null,null,null,false],[321,8,0,null,null,null,null,false],[0,0,0,"complex/asinh.zig",null,"",[],false],[326,0,0,null,null,null,null,false],[326,1,0,null,null,null,null,false],[326,2,0,null,null,null,null,false],[326,3,0,null,null,null,null,false],[326,4,0,null,null,null,null,false],[326,7,0,null,null," Returns the hyperbolic arc-sine of z.",[33197],false],[0,0,0,"z",null,"",null,false],[326,14,0,null,null,null,null,false],[321,9,0,null,null,null,null,false],[0,0,0,"complex/asin.zig",null,"",[],false],[327,0,0,null,null,null,null,false],[327,1,0,null,null,null,null,false],[327,2,0,null,null,null,null,false],[327,3,0,null,null,null,null,false],[327,4,0,null,null,null,null,false],[327,7,0,null,null,null,[33207],false],[0,0,0,"z",null,"",null,false],[327,19,0,null,null,null,null,false],[321,10,0,null,null,null,null,false],[0,0,0,"complex/atanh.zig",null,"",[],false],[328,0,0,null,null,null,null,false],[328,1,0,null,null,null,null,false],[328,2,0,null,null,null,null,false],[328,3,0,null,null,null,null,false],[328,4,0,null,null,null,null,false],[328,7,0,null,null," Returns the hyperbolic arc-tangent of z.",[33217],false],[0,0,0,"z",null,"",null,false],[328,14,0,null,null,null,null,false],[321,11,0,null,null,null,null,false],[0,0,0,"complex/atan.zig",null,"",[],false],[329,6,0,null,null,null,null,false],[329,7,0,null,null,null,null,false],[329,8,0,null,null,null,null,false],[329,9,0,null,null,null,null,false],[329,10,0,null,null,null,null,false],[329,13,0,null,null," Returns the arc-tangent of z.",[33227],false],[0,0,0,"z",null,"",null,false],[329,22,0,null,null,null,[33229],false],[0,0,0,"x",null,"",null,false],[329,38,0,null,null,null,[33231],false],[0,0,0,"z",null,"",null,false],[329,71,0,null,null,null,[33233],false],[0,0,0,"x",null,"",null,false],[329,87,0,null,null,null,[33235],false],[0,0,0,"z",null,"",null,false],[329,120,0,null,null,null,null,false],[321,12,0,null,null,null,null,false],[0,0,0,"complex/conj.zig",null,"",[],false],[330,0,0,null,null,null,null,false],[330,1,0,null,null,null,null,false],[330,2,0,null,null,null,null,false],[330,3,0,null,null,null,null,false],[330,4,0,null,null,null,null,false],[330,7,0,null,null," Returns the complex conjugate of z.",[33245],false],[0,0,0,"z",null,"",null,false],[321,13,0,null,null,null,null,false],[0,0,0,"complex/cosh.zig",null,"",[],false],[331,6,0,null,null,null,null,false],[331,7,0,null,null,null,null,false],[331,8,0,null,null,null,null,false],[331,9,0,null,null,null,null,false],[331,10,0,null,null,null,null,false],[331,12,0,null,null,null,null,false],[0,0,0,"ldexp.zig",null,"",[],false],[332,6,0,null,null,null,null,false],[332,7,0,null,null,null,null,false],[332,8,0,null,null,null,null,false],[332,9,0,null,null,null,null,false],[332,10,0,null,null,null,null,false],[332,11,0,null,null,null,null,false],[332,14,0,null,null," Returns exp(z) scaled to avoid overflow.",[33262,33263],false],[0,0,0,"z",null,"",null,false],[0,0,0,"expt",null,"",null,false],[332,24,0,null,null,null,[33265,33266],false],[0,0,0,"x",null,"",null,false],[0,0,0,"expt",null,"",null,false],[332,35,0,null,null,null,[33268,33269],false],[0,0,0,"z",null,"",null,false],[0,0,0,"expt",null,"",null,false],[332,52,0,null,null,null,[33271,33272],false],[0,0,0,"x",null,"",null,false],[0,0,0,"expt",null,"",null,false],[332,68,0,null,null,null,[33274,33275],false],[0,0,0,"z",null,"",null,false],[0,0,0,"expt",null,"",null,false],[331,15,0,null,null," Returns the hyperbolic arc-cosine of z.",[33277],false],[0,0,0,"z",null,"",null,false],[331,24,0,null,null,null,[33279],false],[0,0,0,"z",null,"",null,false],[331,87,0,null,null,null,[33281],false],[0,0,0,"z",null,"",null,false],[331,155,0,null,null,null,null,false],[321,14,0,null,null,null,null,false],[0,0,0,"complex/cos.zig",null,"",[],false],[333,0,0,null,null,null,null,false],[333,1,0,null,null,null,null,false],[333,2,0,null,null,null,null,false],[333,3,0,null,null,null,null,false],[333,4,0,null,null,null,null,false],[333,7,0,null,null," Returns the cosine of z.",[33291],false],[0,0,0,"z",null,"",null,false],[333,13,0,null,null,null,null,false],[321,15,0,null,null,null,null,false],[0,0,0,"complex/exp.zig",null,"",[],false],[334,6,0,null,null,null,null,false],[334,7,0,null,null,null,null,false],[334,8,0,null,null,null,null,false],[334,9,0,null,null,null,null,false],[334,10,0,null,null,null,null,false],[334,12,0,null,null,null,null,false],[334,15,0,null,null," Returns e raised to the power of z (e^z).",[33302],false],[0,0,0,"z",null,"",null,false],[334,25,0,null,null,null,[33304],false],[0,0,0,"z",null,"",null,false],[334,70,0,null,null,null,[33306],false],[0,0,0,"z",null,"",null,false],[321,16,0,null,null,null,null,false],[0,0,0,"complex/log.zig",null,"",[],false],[335,0,0,null,null,null,null,false],[335,1,0,null,null,null,null,false],[335,2,0,null,null,null,null,false],[335,3,0,null,null,null,null,false],[335,4,0,null,null,null,null,false],[335,7,0,null,null," Returns the natural logarithm of z.",[33315],false],[0,0,0,"z",null,"",null,false],[335,15,0,null,null,null,null,false],[321,17,0,null,null,null,null,false],[0,0,0,"complex/pow.zig",null,"",[],false],[336,0,0,null,null,null,null,false],[336,1,0,null,null,null,null,false],[336,2,0,null,null,null,null,false],[336,3,0,null,null,null,null,false],[336,4,0,null,null,null,null,false],[336,7,0,null,null," Returns z raised to the complex power of c.",[33325,33326,33327],false],[0,0,0,"T",null,"",null,true],[0,0,0,"z",null,"",null,false],[0,0,0,"c",null,"",null,false],[336,13,0,null,null,null,null,false],[321,18,0,null,null,null,null,false],[0,0,0,"complex/proj.zig",null,"",[],false],[337,0,0,null,null,null,null,false],[337,1,0,null,null,null,null,false],[337,2,0,null,null,null,null,false],[337,3,0,null,null,null,null,false],[337,4,0,null,null,null,null,false],[337,7,0,null,null," Returns the projection of z onto the riemann sphere.",[33337],false],[0,0,0,"z",null,"",null,false],[337,17,0,null,null,null,null,false],[321,19,0,null,null,null,null,false],[0,0,0,"complex/sinh.zig",null,"",[],false],[338,6,0,null,null,null,null,false],[338,7,0,null,null,null,null,false],[338,8,0,null,null,null,null,false],[338,9,0,null,null,null,null,false],[338,10,0,null,null,null,null,false],[338,12,0,null,null,null,null,false],[338,15,0,null,null," Returns the hyperbolic sine of z.",[33348],false],[0,0,0,"z",null,"",null,false],[338,24,0,null,null,null,[33350],false],[0,0,0,"z",null,"",null,false],[338,87,0,null,null,null,[33352],false],[0,0,0,"z",null,"",null,false],[338,154,0,null,null,null,null,false],[321,20,0,null,null,null,null,false],[0,0,0,"complex/sin.zig",null,"",[],false],[339,0,0,null,null,null,null,false],[339,1,0,null,null,null,null,false],[339,2,0,null,null,null,null,false],[339,3,0,null,null,null,null,false],[339,4,0,null,null,null,null,false],[339,7,0,null,null," Returns the sine of z.",[33362],false],[0,0,0,"z",null,"",null,false],[339,14,0,null,null,null,null,false],[321,21,0,null,null,null,null,false],[0,0,0,"complex/sqrt.zig",null,"",[],false],[340,6,0,null,null,null,null,false],[340,7,0,null,null,null,null,false],[340,8,0,null,null,null,null,false],[340,9,0,null,null,null,null,false],[340,10,0,null,null,null,null,false],[340,14,0,null,null," Returns the square root of z. The real and imaginary parts of the result have the same sign\n as the imaginary part of z.",[33372],false],[0,0,0,"z",null,"",null,false],[340,24,0,null,null,null,[33374],false],[0,0,0,"z",null,"",null,false],[340,72,0,null,null,null,[33376],false],[0,0,0,"z",null,"",null,false],[340,129,0,null,null,null,null,false],[321,22,0,null,null,null,null,false],[0,0,0,"complex/tanh.zig",null,"",[],false],[341,6,0,null,null,null,null,false],[341,7,0,null,null,null,null,false],[341,8,0,null,null,null,null,false],[341,9,0,null,null,null,null,false],[341,10,0,null,null,null,null,false],[341,13,0,null,null," Returns the hyperbolic tangent of z.",[33386],false],[0,0,0,"z",null,"",null,false],[341,22,0,null,null,null,[33388],false],[0,0,0,"z",null,"",null,false],[341,60,0,null,null,null,[33390],false],[0,0,0,"z",null,"",null,false],[341,103,0,null,null,null,null,false],[321,23,0,null,null,null,null,false],[0,0,0,"complex/tan.zig",null,"",[],false],[342,0,0,null,null,null,null,false],[342,1,0,null,null,null,null,false],[342,2,0,null,null,null,null,false],[342,3,0,null,null,null,null,false],[342,4,0,null,null,null,null,false],[342,7,0,null,null," Returns the tangent of z.",[33400],false],[0,0,0,"z",null,"",null,false],[342,14,0,null,null,null,null,false],[321,26,0,null,null," A complex number consisting of a real an imaginary part. T must be a floating-point value.",[33403],false],[0,0,0,"T",null,"",[33431,33433],true],[321,28,0,null,null,null,null,false],[321,37,0,null,null," Create a new Complex number from the given real and imaginary parts.",[33406,33407],false],[0,0,0,"re",null,"",null,false],[0,0,0,"im",null,"",null,false],[321,45,0,null,null," Returns the sum of two complex numbers.",[33409,33410],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[321,53,0,null,null," Returns the subtraction of two complex numbers.",[33412,33413],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[321,61,0,null,null," Returns the product of two complex numbers.",[33415,33416],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[321,69,0,null,null," Returns the quotient of two complex numbers.",[33418,33419],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[321,81,0,null,null," Returns the complex conjugate of a number.",[33421],false],[0,0,0,"self",null,"",null,false],[321,89,0,null,null," Returns the negation of a complex number.",[33423],false],[0,0,0,"self",null,"",null,false],[321,97,0,null,null," Returns the product of complex number and i=sqrt(-1)",[33425],false],[0,0,0,"self",null,"",null,false],[321,105,0,null,null," Returns the reciprocal of a complex number.",[33427],false],[0,0,0,"self",null,"",null,false],[321,114,0,null,null," Returns the magnitude of a complex number.",[33429],false],[0,0,0,"self",null,"",null,false],[321,27,0,null,null,null,null,false],[0,0,0,"re",null," Real part.",null,false],[321,27,0,null,null,null,null,false],[0,0,0,"im",null," Imaginary part.",null,false],[321,120,0,null,null,null,null,false],[285,317,0,null,null,null,null,false],[285,319,0,null,null,null,null,false],[0,0,0,"math/big.zig",null,"",[],false],[343,0,0,null,null,null,null,false],[343,1,0,null,null,null,null,false],[343,3,0,null,null,null,null,false],[0,0,0,"big/rational.zig",null,"",[],false],[344,0,0,null,null,null,null,false],[344,1,0,null,null,null,null,false],[344,2,0,null,null,null,null,false],[344,3,0,null,null,null,null,false],[344,4,0,null,null,null,null,false],[344,5,0,null,null,null,null,false],[344,7,0,null,null,null,null,false],[344,8,0,null,null,null,null,false],[344,9,0,null,null,null,null,false],[344,10,0,null,null,null,null,false],[344,22,0,null,null," An arbitrary-precision rational number.\n\n Memory is allocated as needed for operations to ensure full precision is kept. The precision\n of a Rational is only bounded by memory.\n\n Rational's are always normalized. That is, for a Rational r = p/q where p and q are integers,\n gcd(p, q) = 1 always.\n\n TODO rework this to store its own allocator and use a non-managed big int, to avoid double\n allocator storage.",[33519,33521],false],[344,31,0,null,null," Create a new Rational. A small amount of memory will be allocated on initialization.\n This will be 2 * Int.default_capacity.",[33454],false],[0,0,0,"a",null,"",null,false],[344,41,0,null,null," Frees all memory associated with a Rational.",[33456],false],[0,0,0,"self",null,"",null,false],[344,47,0,null,null," Set a Rational from a primitive integer type.",[33458,33459],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[344,53,0,null,null," Set a Rational from a string of the form `A/B` where A and B are base-10 integers.",[33461,33462],false],[0,0,0,"self",null,"",null,false],[0,0,0,"str",null,"",null,false],[344,134,0,null,null," Set a Rational from a floating-point value. The rational will have enough precision to\n completely represent the provided float.",[33464,33465,33466],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"f",null,"",null,false],[344,191,0,null,null," Return a floating-point value that is the closest value to a Rational.\n\n The result may not be exact if the Rational is too precise or too large for the\n target type.",[33468,33469],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[344,287,0,null,null," Set a rational from an integer ratio.",[33471,33472,33473],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"q",null,"",null,false],[344,302,0,null,null," Set a Rational directly from an Int.",[33475,33476],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[344,308,0,null,null," Set a Rational directly from a ratio of two Int's.",[33478,33479,33480],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,319,0,null,null," Make a Rational positive.",[33482],false],[0,0,0,"r",null,"",null,false],[344,324,0,null,null," Negate the sign of a Rational.",[33484],false],[0,0,0,"r",null,"",null,false],[344,330,0,null,null," Efficiently swap a Rational with another. This swaps the limb pointers and a full copy is not\n performed. The address of the limbs field will not be the same after this function.",[33486,33487],false],[0,0,0,"r",null,"",null,false],[0,0,0,"other",null,"",null,false],[344,337,0,null,null," Returns math.Order.lt, math.Order.eq, math.Order.gt if a < b, a == b or a\n > b respectively.",[33489,33490],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,343,0,null,null," Returns math.Order.lt, math.Order.eq, math.Order.gt if |a| < |b|, |a| ==\n |b| or |a| > |b| respectively.",[33492,33493],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,348,0,null,null,null,[33495,33496,33497],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"is_abs",null,"",null,false],[344,368,0,null,null," rma = a + b.\n\n rma, a and b may be aliases. However, it is more efficient if rma does not alias a or b.\n\n Returns an error if memory could not be allocated.",[33499,33500,33501],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,396,0,null,null," rma = a - b.\n\n rma, a and b may be aliases. However, it is more efficient if rma does not alias a or b.\n\n Returns an error if memory could not be allocated.",[33503,33504,33505],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,424,0,null,null," rma = a * b.\n\n rma, a and b may be aliases. However, it is more efficient if rma does not alias a or b.\n\n Returns an error if memory could not be allocated.",[33507,33508,33509],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,435,0,null,null," rma = a / b.\n\n rma, a and b may be aliases. However, it is more efficient if rma does not alias a or b.\n\n Returns an error if memory could not be allocated.",[33511,33512,33513],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[344,446,0,null,null," Invert the numerator and denominator fields of a Rational. p/q => q/p.",[33515],false],[0,0,0,"r",null,"",null,false],[344,451,0,null,null,null,[33517],false],[0,0,0,"r",null,"",null,false],[344,22,0,null,null,null,null,false],[0,0,0,"p",null," Numerator. Determines the sign of the Rational.",null,false],[344,22,0,null,null,null,null,false],[0,0,0,"q",null," Denominator. Sign is ignored.",null,false],[344,473,0,null,null,null,[33523,33524],false],[0,0,0,"a",null,"",null,false],[0,0,0,"T",null,"",null,true],[343,4,0,null,null,null,null,false],[0,0,0,"big/int.zig",null,"",[],false],[345,0,0,null,null,null,null,false],[345,1,0,null,null,null,null,false],[345,2,0,null,null,null,null,false],[345,3,0,null,null,null,null,false],[345,4,0,null,null,null,null,false],[345,5,0,null,null,null,null,false],[345,6,0,null,null,null,null,false],[345,7,0,null,null,null,null,false],[345,8,0,null,null,null,null,false],[345,9,0,null,null,null,null,false],[345,10,0,null,null,null,null,false],[345,11,0,null,null,null,null,false],[345,12,0,null,null,null,null,false],[345,13,0,null,null,null,null,false],[345,14,0,null,null,null,null,false],[345,15,0,null,null,null,null,false],[345,16,0,null,null,null,null,false],[345,17,0,null,null,null,null,false],[345,19,0,null,null,null,null,false],[345,26,0,null,null," Returns the number of limbs needed to store `scalar`, which must be a\n primitive integer value.\n Note: A comptime-known upper bound of this value that may be used\n instead if `scalar` is not already comptime-known is\n `calcTwosCompLimbCount(@typeInfo(@TypeOf(scalar)).Int.bits)`",[33547],false],[0,0,0,"scalar",null,"",null,false],[345,35,0,null,null,null,[33549,33550],false],[0,0,0,"a_len",null,"",null,false],[0,0,0,"base",null,"",null,false],[345,41,0,null,null,null,[33552,33553],false],[0,0,0,"a_len",null,"",null,false],[0,0,0,"b_len",null,"",null,false],[345,45,0,null,null,null,[33555,33556,33557],false],[0,0,0,"a_len",null,"",null,false],[0,0,0,"b_len",null,"",null,false],[0,0,0,"aliases",null,"",null,false],[345,49,0,null,null,null,[33559,33560,33561,33562],false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"a_len",null,"",null,false],[0,0,0,"b_len",null,"",null,false],[0,0,0,"aliases",null,"",null,false],[345,54,0,null,null,null,[33564,33565],false],[0,0,0,"base",null,"",null,false],[0,0,0,"string_len",null,"",null,false],[345,59,0,null,null,null,[33567,33568],false],[0,0,0,"base",null,"",null,false],[0,0,0,"string_len",null,"",null,false],[345,63,0,null,null,null,[33570,33571],false],[0,0,0,"a_bit_count",null,"",null,false],[0,0,0,"y",null,"",null,false],[345,68,0,null,null,null,[33573],false],[0,0,0,"a_bit_count",null,"",null,false],[345,76,0,null,null,null,[33575],false],[0,0,0,"bit_count",null,"",null,false],[345,81,0,null,null," a + b * c + *carry, sets carry to the overflow bits",[33577,33578,33579,33580],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"carry",null,"",null,false],[345,103,0,null,null," a - b * c - *carry, sets carry to the overflow bits",[33582,33583,33584,33585],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"carry",null,"",null,false],[345,120,0,null,null," Used to indicate either limit of a 2s-complement integer.",[33587,33588],false],[0,0,0,"min",null,null,null,false],[0,0,0,"max",null,null,null,false],[345,129,0,null,null," A arbitrary-precision big integer, with a fixed set of mutable limbs.",[33827,33828,33829],false],[345,142,0,null,null,null,[33591],false],[0,0,0,"self",null,"",null,false],[345,150,0,null,null,null,null,false],[345,153,0,null,null," Returns true if `a == 0`.",[33594],false],[0,0,0,"self",null,"",null,false],[345,159,0,null,null," Asserts that the allocator owns the limbs memory. If this is not the case,\n use `toConst().toManaged()`.",[33596,33597],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,173,0,null,null," `value` is a primitive integer type.\n Asserts the value fits within the provided `limbs_buffer`.\n Note: `calcLimbLen` can be used to figure out how big an array to allocate for `limbs_buffer`.",[33599,33600],false],[0,0,0,"limbs_buffer",null,"",null,false],[0,0,0,"value",null,"",null,false],[345,186,0,null,null," Copies the value of a Const to an existing Mutable so that they both have the same value.\n Asserts the value fits in the limbs buffer.",[33602,33603],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[345,196,0,null,null," Efficiently swap an Mutable with another. This swaps the limb pointers and a full copy is not\n performed. The address of the limbs field will not be the same after this function.",[33605,33606],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[345,200,0,null,null,null,[33608],false],[0,0,0,"self",null,"",null,false],[345,210,0,null,null," Clones an Mutable and returns a new Mutable with the same value. The new Mutable is a deep copy and\n can be modified separately from the original.\n Asserts that limbs is big enough to store the value.",[33610,33611],false],[0,0,0,"other",null,"",null,false],[0,0,0,"limbs",null,"",null,false],[345,219,0,null,null,null,[33613],false],[0,0,0,"self",null,"",null,false],[345,224,0,null,null," Modify to become the absolute value",[33615],false],[0,0,0,"self",null,"",null,false],[345,232,0,null,null," Sets the Mutable to value. Value must be an primitive integer type.\n Asserts the value fits within the limbs buffer.\n Note: `calcLimbLen` can be used to figure out how big the limbs buffer\n needs to be to store a specific value.",[33617,33618],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[345,294,0,null,null," Set self from the string representation `value`.\n\n `value` must contain only digits <= `base` and is case insensitive.  Base prefixes are\n not allowed (e.g. 0x43 should simply be 43).  Underscores in the input string are\n ignored and can be used as digit separators.\n\n Asserts there is enough memory for the value in `self.limbs`. An upper bound on number of limbs can\n be determined with `calcSetStringLimbCount`.\n Asserts the base is in the range [2, 16].\n\n Returns an error if the value has invalid digits for the requested base.\n\n `limbs_buffer` is used for temporary storage. The size required can be found with\n `calcSetStringLimbsBufferLen`.\n\n If `allocator` is provided, it will be used for temporary storage to improve\n multiplication performance. `error.OutOfMemory` is handled with a fallback algorithm.",[33620,33621,33622,33623,33624],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,332,0,null,null," Set self to either bound of a 2s-complement integer.\n Note: The result is still sign-magnitude, not twos complement! In order to convert the\n result to twos complement, it is sufficient to take the absolute value.\n\n Asserts the result fits in `r`. An upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33626,33627,33628,33629],false],[0,0,0,"r",null,"",null,false],[0,0,0,"limit",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,402,0,null,null," r = a + scalar\n\n r and a may be aliases.\n scalar is a primitive integer type.\n\n Asserts the result fits in `r`. An upper bound on the number of limbs needed by\n r is `@max(a.limbs.len, calcLimbLen(scalar)) + 1`.",[33631,33632,33633],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[345,424,0,null,null," Base implementation for addition. Adds `@max(a.limbs.len, b.limbs.len)` elements from a and b,\n and returns whether any overflow occurred.\n r, a and b may be aliases.\n\n Asserts r has enough elements to hold the result. The upper bound is `@max(a.limbs.len, b.limbs.len)`.",[33635,33636,33637],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,458,0,null,null," r = a + b\n r, a and b may be aliases.\n\n Asserts the result fits in `r`. An upper bound on the number of limbs needed by\n r is `@max(a.limbs.len, b.limbs.len) + 1`.",[33639,33640,33641],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,475,0,null,null," r = a + b with 2s-complement wrapping semantics. Returns whether overflow occurred.\n r, a and b may be aliases\n\n Asserts the result fits in `r`. An upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33643,33644,33645,33646,33647],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,520,0,null,null," r = a + b with 2s-complement saturating semantics.\n r, a and b may be aliases.\n\n Assets the result fits in `r`. Upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33649,33650,33651,33652,33653],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,560,0,null,null," Base implementation for subtraction. Subtracts `@max(a.limbs.len, b.limbs.len)` elements from a and b,\n and returns whether any overflow occurred.\n r, a and b may be aliases.\n\n Asserts r has enough elements to hold the result. The upper bound is `@max(a.limbs.len, b.limbs.len)`.",[33655,33656,33657],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,613,0,null,null," r = a - b\n\n r, a and b may be aliases.\n\n Asserts the result fits in `r`. An upper bound on the number of limbs needed by\n r is `@max(a.limbs.len, b.limbs.len) + 1`. The +1 is not needed if both operands are positive.",[33659,33660,33661],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,622,0,null,null," r = a - b with 2s-complement wrapping semantics. Returns whether any overflow occurred.\n\n r, a and b may be aliases\n Asserts the result fits in `r`. An upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33663,33664,33665,33666,33667],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,631,0,null,null," r = a - b with 2s-complement saturating semantics.\n r, a and b may be aliases.\n\n Assets the result fits in `r`. Upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33669,33670,33671,33672,33673],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,644,0,null,null," rma = a * b\n\n `rma` may alias with `a` or `b`.\n `a` and `b` may alias with each other.\n\n Asserts the result fits in `rma`. An upper bound on the number of limbs needed by\n rma is given by `a.limbs.len + b.limbs.len`.\n\n `limbs_buffer` is used for temporary storage. The amount required is given by `calcMulLimbsBufferLen`.",[33675,33676,33677,33678,33679],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,674,0,null,null," rma = a * b\n\n `rma` may not alias with `a` or `b`.\n `a` and `b` may alias with each other.\n\n Asserts the result fits in `rma`. An upper bound on the number of limbs needed by\n rma is given by `a.limbs.len + b.limbs.len`.\n\n If `allocator` is provided, it will be used for temporary storage to improve\n multiplication performance. `error.OutOfMemory` is handled with a fallback algorithm.",[33681,33682,33683,33684],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,705,0,null,null," rma = a * b with 2s-complement wrapping semantics.\n\n `rma` may alias with `a` or `b`.\n `a` and `b` may alias with each other.\n\n Asserts the result fits in `rma`. An upper bound on the number of limbs needed by\n rma is given by `a.limbs.len + b.limbs.len`.\n\n `limbs_buffer` is used for temporary storage. The amount required is given by `calcMulWrapLimbsBufferLen`.",[33686,33687,33688,33689,33690,33691,33692],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,746,0,null,null," rma = a * b with 2s-complement wrapping semantics.\n\n `rma` may not alias with `a` or `b`.\n `a` and `b` may alias with each other.\n\n Asserts the result fits in `rma`. An upper bound on the number of limbs needed by\n rma is given by `a.limbs.len + b.limbs.len`.\n\n If `allocator` is provided, it will be used for temporary storage to improve\n multiplication performance. `error.OutOfMemory` is handled with a fallback algorithm.",[33694,33695,33696,33697,33698,33699],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,776,0,null,null," r = @bitReverse(a) with 2s-complement semantics.\n r and a may be aliases.\n\n Asserts the result fits in `r`. Upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33701,33702,33703,33704],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,839,0,null,null," r = @byteSwap(a) with 2s-complement semantics.\n r and a may be aliases.\n\n Asserts the result fits in `r`. Upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(8*byte_count)`.",[33706,33707,33708,33709],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"byte_count",null,"",null,false],[345,902,0,null,null," r = @popCount(a) with 2s-complement semantics.\n r and a may be aliases.\n\n Assets the result fits in `r`. Upper bound on the number of limbs needed by\n r is `calcTwosCompLimbCount(bit_count)`.",[33711,33712,33713],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,927,0,null,null," rma = a * a\n\n `rma` may not alias with `a`.\n\n Asserts the result fits in `rma`. An upper bound on the number of limbs needed by\n rma is given by `2 * a.limbs.len + 1`.\n\n If `allocator` is provided, it will be used for temporary storage to improve\n multiplication performance. `error.OutOfMemory` is handled with a fallback algorithm.",[33715,33716,33717],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"opt_allocator",null,"",null,false],[345,949,0,null,null," q = a / b (rem r)\n\n a / b are floored (rounded towards 0).\n q may alias with a or b.\n\n Asserts there is enough memory to store q and r.\n The upper bound for r limb count is `b.limbs.len`.\n The upper bound for q limb count is given by `a.limbs`.\n\n `limbs_buffer` is used for temporary storage. The amount required is given by `calcDivLimbsBufferLen`.",[33719,33720,33721,33722,33723],false],[0,0,0,"q",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1076,0,null,null," q = a / b (rem r)\n\n a / b are truncated (rounded towards -inf).\n q may alias with a or b.\n\n Asserts there is enough memory to store q and r.\n The upper bound for r limb count is `b.limbs.len`.\n The upper bound for q limb count is given by `a.limbs.len`.\n\n `limbs_buffer` is used for temporary storage. The amount required is given by `calcDivLimbsBufferLen`.",[33725,33726,33727,33728,33729],false],[0,0,0,"q",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1096,0,null,null," r = a << shift, in other words, r = a * 2^shift\n\n r and a may alias.\n\n Asserts there is enough memory to fit the result. The upper bound Limb count is\n `a.limbs.len + (shift / (@sizeOf(Limb) * 8))`.",[33731,33732,33733],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[345,1108,0,null,null," r = a <<| shift with 2s-complement saturating semantics.\n\n r and a may alias.\n\n Asserts there is enough memory to fit the result. The upper bound Limb count is\n r is `calcTwosCompLimbCount(bit_count)`.",[33735,33736,33737,33738,33739],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,1176,0,null,null," r = a >> shift\n r and a may alias.\n\n Asserts there is enough memory to fit the result. The upper bound Limb count is\n `a.limbs.len - (shift / (@sizeOf(Limb) * 8))`.",[33741,33742,33743],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[345,1205,0,null,null," r = ~a under 2s complement wrapping semantics.\n r may alias with a.\n\n Assets that r has enough limbs to store the result. The upper bound Limb count is\n r is `calcTwosCompLimbCount(bit_count)`.",[33745,33746,33747,33748],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,1217,0,null,null," r = a | b under 2s complement semantics.\n r may alias with a or b.\n\n a and b are zero-extended to the longer of a or b.\n\n Asserts that r has enough limbs to store the result. Upper bound is `@max(a.limbs.len, b.limbs.len)`.",[33750,33751,33752],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,1242,0,null,null," r = a & b under 2s complement semantics.\n r may alias with a or b.\n\n Asserts that r has enough limbs to store the result.\n If a or b is positive, the upper bound is `@min(a.limbs.len, b.limbs.len)`.\n If a and b are negative, the upper bound is `@max(a.limbs.len, b.limbs.len) + 1`.",[33754,33755,33756],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,1267,0,null,null," r = a ^ b under 2s complement semantics.\n r may alias with a or b.\n\n Asserts that r has enough limbs to store the result. If a and b share the same signedness, the\n upper bound is `@max(a.limbs.len, b.limbs.len)`. Otherwise, if either a or b is negative\n but not both, the upper bound is `@max(a.limbs.len, b.limbs.len) + 1`.",[33758,33759,33760],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,1293,0,null,null," rma may alias x or y.\n x and y may alias each other.\n Asserts that `rma` has enough limbs to store the result. Upper bound is\n `@min(x.limbs.len, y.limbs.len)`.\n\n `limbs_buffer` is used for temporary storage during the operation. When this function returns,\n it will have the same length as it had when the function was called.",[33762,33763,33764,33765],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1319,0,null,null," q = a ^ b\n\n r may not alias a.\n\n Asserts that `r` has enough limbs to store the result. Upper bound is\n `calcPowLimbsBufferLen(a.bitCountAbs(), b)`.\n\n `limbs_buffer` is used for temporary storage.\n The amount required is given by `calcPowLimbsBufferLen`.",[33767,33768,33769,33770],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1365,0,null,null," r = ⌊√a⌋\n\n r may alias a.\n\n Asserts that `r` has enough limbs to store the result. Upper bound is\n `(a.limbs.len - 1) / 2 + 1`.\n\n `limbs_buffer` is used for temporary storage.\n The amount required is given by `calcSqrtLimbsBufferLen`.",[33772,33773,33774],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1419,0,null,null," rma may not alias x or y.\n x and y may alias each other.\n Asserts that `rma` has enough limbs to store the result. Upper bound is given by `calcGcdNoAliasLimbLen`.\n\n `limbs_buffer` is used for temporary storage during the operation.",[33776,33777,33778,33779],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1425,0,null,null,null,[33781,33782,33783,33784],false],[0,0,0,"result",null,"",null,false],[0,0,0,"xa",null,"",null,false],[0,0,0,"ya",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,1521,0,null,null,null,[33786,33787,33788,33789],false],[0,0,0,"q",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[345,1601,0,null,null," Handbook of Applied Cryptography, 14.20\n\n x = qy + r where 0 <= r < y\n y is modified but returned intact.",[33791,33792,33793,33794],false],[0,0,0,"q",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[345,1743,0,null,null," If a is positive, this passes through to truncate.\n If a is negative, then r is set to positive with the bit pattern ~(a - 1).\n r may alias a.\n\n Asserts `r` has enough storage to store the result.\n The upper bound is `calcTwosCompLimbCount(a.len)`.",[33796,33797,33798,33799],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,1777,0,null,null," Truncate an integer to a number of bits, following 2s-complement semantics.\n r may alias a.\n\n Asserts `r` has enough storage to store the result.\n The upper bound is `calcTwosCompLimbCount(a.len)`.",[33801,33802,33803,33804],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,1865,0,null,null," Saturate an integer to a number of bits, following 2s-complement semantics.\n r may alias a.\n\n Asserts `r` has enough storage to store the result.\n The upper bound is `calcTwosCompLimbCount(a.len)`.",[33806,33807,33808,33809],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,1877,0,null,null," Read the value of `x` from `buffer`\n Asserts that `buffer` is large enough to contain a value of bit-size `bit_count`.\n\n The contents of `buffer` are interpreted as if they were the contents of\n @ptrCast(*[buffer.len]const u8, &x). Byte ordering is determined by `endian`\n and any required padding bits are expected on the MSB end.",[33811,33812,33813,33814,33815],false],[0,0,0,"x",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[345,1893,0,null,null," Read the value of `x` from a packed memory `buffer`.\n Asserts that `buffer` is large enough to contain a value of bit-size `bit_count`\n at offset `bit_offset`.\n\n This is equivalent to loading the value of an integer with `bit_count` bits as\n if it were a field in packed memory at the provided bit offset.",[33817,33818,33819,33820,33821,33822],false],[0,0,0,"x",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"endian",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[345,1972,0,null,null," Normalize a possible sequence of leading zeros.\n\n [1, 2, 3, 4, 0] -> [1, 2, 3, 4]\n [1, 2, 0, 0, 0] -> [1, 2]\n [0, 0, 0, 0, 0] -> [0]",[33824,33825],false],[0,0,0,"r",null,"",null,false],[0,0,0,"length",null,"",null,false],[345,129,0,null,null,null,null,false],[0,0,0,"limbs",null," Raw digits. These are:\n\n * Little-endian ordered\n * limbs.len >= 1\n * Zero is represented as limbs.len == 1 with limbs[0] == 0.\n\n Accessing limbs directly should be avoided.\n These are allocated limbs; the `len` field tells the valid range.",null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"positive",null,null,null,false],[345,1978,0,null,null," A arbitrary-precision big integer, with a fixed set of immutable limbs.",[33921,33922],false],[345,1990,0,null,null," The result is an independent resource which is managed by the caller.",[33832,33833],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,2004,0,null,null," Asserts `limbs` is big enough to store the value.",[33835,33836],false],[0,0,0,"self",null,"",null,false],[0,0,0,"limbs",null,"",null,false],[345,2013,0,null,null,null,[33838],false],[0,0,0,"self",null,"",null,false],[345,2020,0,null,null,null,[33840],false],[0,0,0,"self",null,"",null,false],[345,2027,0,null,null,null,[33842],false],[0,0,0,"self",null,"",null,false],[345,2034,0,null,null,null,[33844],false],[0,0,0,"self",null,"",null,false],[345,2038,0,null,null,null,[33846],false],[0,0,0,"self",null,"",null,false],[345,2043,0,null,null," Returns the number of bits required to represent the absolute value of an integer.",[33848],false],[0,0,0,"self",null,"",null,false],[345,2055,0,null,null," Returns the number of bits required to represent the integer in twos-complement form.\n\n If the integer is negative the value returned is the number of bits needed by a signed\n integer to represent the value. If positive the value is the number of bits for an\n unsigned integer. Any unsigned integer will fit in the signed integer with bitcount\n one greater than the returned value.\n\n e.g. -127 returns 8 as it will fit in an i8. 127 returns 7 since it fits in a u7.",[33850],false],[0,0,0,"self",null,"",null,false],[345,2087,0,null,null," @popCount with two's complement semantics.\n\n This returns the number of 1 bits set when the value would be represented in\n two's complement with the given integer width (bit_count).\n This includes the leading sign bit, which will be set for negative values.\n\n Asserts that bit_count is enough to represent value in two's compliment\n and that the final result fits in a usize.\n Asserts that there are no trailing empty limbs on the most significant end,\n i.e. that limb count matches `calcLimbLen()` and zero is not negative.",[33852,33853],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2125,0,null,null,null,[33855,33856,33857],false],[0,0,0,"self",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2138,0,null,null," Returns whether self can fit into an integer of the requested type.",[33859,33860],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[345,2147,0,null,null," Returns the approximate size of the integer in the given base. Negative values accommodate for\n the minus sign. This is used for determining the number of characters needed to print the\n value. It is inexact and may exceed the given value by ~1-2 bytes.\n TODO See if we can make this exact.",[33862,33863],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base",null,"",null,false],[345,2152,0,null,null,null,null,false],[345,2160,0,null,null," Convert self to type T.\n\n Returns an error if self cannot be narrowed into the requested type without truncation.",[33866,33867],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[345,2207,0,null,null," To allow `std.fmt.format` to work with this type.\n If the integer is larger than `pow(2, 64 * @sizeOf(usize) * 8), this function will fail\n to print the string, printing \"(BigInt)\" instead of a number.\n This is because the rendering algorithm requires reversing a string, which requires O(N) memory.\n See `toString` and `toStringAlloc` for a way to print big integers without failure.",[33869,33870,33871,33872],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[345,2254,0,null,null," Converts self to a string in the requested base.\n Caller owns returned memory.\n Asserts that `base` is in the range [2, 16].\n See also `toString`, a lower level function than this.",[33874,33875,33876,33877],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"case",null,"",null,false],[345,2279,0,null,null," Converts self to a string in the requested base.\n Asserts that `base` is in the range [2, 16].\n `string` is a caller-provided slice of at least `sizeInBaseUpperBound` bytes,\n where the result is written to.\n Returns the length of the string.\n `limbs_buffer` is caller-provided memory for `toString` to use as a working area. It must have\n length of at least `calcToStringLimbsBufferLen`.\n In the case of power-of-two base, `limbs_buffer` is ignored.\n See also `toStringAlloc`, a higher level function than this.",[33879,33880,33881,33882,33883],false],[0,0,0,"self",null,"",null,false],[0,0,0,"string",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"case",null,"",null,false],[0,0,0,"limbs_buffer",null,"",null,false],[345,2381,0,null,null," Write the value of `x` into `buffer`\n Asserts that `buffer` is large enough to store the value.\n\n `buffer` is filled so that its contents match what would be observed via\n @ptrCast(*[buffer.len]const u8, &x). Byte ordering is determined by `endian`,\n and any required padding bits are added on the MSB end.",[33885,33886,33887],false],[0,0,0,"x",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"endian",null,"",null,false],[345,2391,0,null,null," Write the value of `x` to a packed memory `buffer`.\n Asserts that `buffer` is large enough to contain a value of bit-size `bit_count`\n at offset `bit_offset`.\n\n This is equivalent to storing the value of an integer with `bit_count` bits as\n if it were a field in packed memory at the provided bit offset.",[33889,33890,33891,33892,33893],false],[0,0,0,"x",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"bit_offset",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[0,0,0,"endian",null,"",null,false],[345,2427,0,null,null," Returns `math.Order.lt`, `math.Order.eq`, `math.Order.gt` if\n `|a| < |b|`, `|a| == |b|`, or `|a| > |b|` respectively.",[33895,33896],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2452,0,null,null," Returns `math.Order.lt`, `math.Order.eq`, `math.Order.gt` if `a < b`, `a == b` or `a > b` respectively.",[33898,33899],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2466,0,null,null," Same as `order` but the right-hand operand is a primitive integer.",[33901,33902],false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[345,2484,0,null,null,null,null,false],[345,2485,0,null,null,null,null,false],[345,2486,0,null,null,null,null,false],[345,2489,0,null,null," Returns true if `a == 0`.",[33907],false],[0,0,0,"a",null,"",null,false],[345,2496,0,null,null," Returns true if `|a| == |b|`.",[33909,33910],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2501,0,null,null," Returns true if `a == b`.",[33912,33913],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2505,0,null,null,null,[33915,33916],false],[0,0,0,"a",null,"",null,false],[0,0,0,"bits",null,"",null,false],[345,2522,0,null,null,null,[33918,33919],false],[0,0,0,"a",null,"",null,false],[0,0,0,"bits",null,"",null,false],[345,1978,0,null,null,null,null,false],[0,0,0,"limbs",null," Raw digits. These are:\n\n * Little-endian ordered\n * limbs.len >= 1\n * Zero is represented as limbs.len == 1 with limbs[0] == 0.\n\n Accessing limbs directly should be avoided.",null,false],[0,0,0,"positive",null,null,null,false],[345,2538,0,null,null," An arbitrary-precision big integer along with an allocator which manages the memory.\n\n Memory is allocated as needed to ensure operations never overflow. The range\n is bounded only by available memory.",[34169,34171,34172],false],[345,2539,0,null,null,null,null,false],[345,2542,0,null,null," Default number of limbs to allocate on creation of a `Managed`.",null,false],[345,2562,0,null,null," Creates a new `Managed`. `default_capacity` limbs will be allocated immediately.\n The integer value after initializing is `0`.",[33927],false],[0,0,0,"allocator",null,"",null,false],[345,2566,0,null,null,null,[33929],false],[0,0,0,"self",null,"",null,false],[345,2574,0,null,null,null,[33931],false],[0,0,0,"self",null,"",null,false],[345,2584,0,null,null," Creates a new `Managed` with value `value`.\n\n This is identical to an `init`, followed by a `set`.",[33933,33934],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"value",null,"",null,false],[345,2594,0,null,null," Creates a new Managed with a specific capacity. If capacity < default_capacity then the\n default capacity will be used instead.\n The integer value after initializing is `0`.",[33936,33937],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"capacity",null,"",null,false],[345,2607,0,null,null," Returns the number of limbs currently in use.",[33939],false],[0,0,0,"self",null,"",null,false],[345,2612,0,null,null," Returns whether an Managed is positive.",[33941],false],[0,0,0,"self",null,"",null,false],[345,2617,0,null,null," Sets the sign of an Managed.",[33943,33944],false],[0,0,0,"self",null,"",null,false],[0,0,0,"positive",null,"",null,false],[345,2628,0,null,null," Sets the length of an Managed.\n\n If setLen is used, then the Managed must be normalized to suit.",[33946,33947],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[345,2633,0,null,null,null,[33949,33950,33951],false],[0,0,0,"self",null,"",null,false],[0,0,0,"positive",null,"",null,false],[0,0,0,"length",null,"",null,false],[345,2640,0,null,null," Ensures an Managed has enough space allocated for capacity limbs. If the Managed does not have\n sufficient capacity, the exact amount will be allocated. This occurs even if the requested\n capacity is only greater than the current capacity by one limb.",[33953,33954],false],[0,0,0,"self",null,"",null,false],[0,0,0,"capacity",null,"",null,false],[345,2648,0,null,null," Frees all associated memory.",[33956],false],[0,0,0,"self",null,"",null,false],[345,2656,0,null,null," Returns a `Managed` with the same value. The returned `Managed` is a deep copy and\n can be modified separately from the original, and its resources are managed\n separately from the original.",[33958],false],[0,0,0,"other",null,"",null,false],[345,2660,0,null,null,null,[33960,33961],false],[0,0,0,"other",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[345,2674,0,null,null," Copies the value of the integer to an existing `Managed` so that they both have the same value.\n Extra memory will be allocated if the receiver does not have enough capacity.",[33963,33964],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[345,2684,0,null,null," Efficiently swap a `Managed` with another. This swaps the limb pointers and a full copy is not\n performed. The address of the limbs field will not be the same after this function.",[33966,33967],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[345,2689,0,null,null," Debugging tool: prints the state to stderr.",[33969],false],[0,0,0,"self",null,"",null,false],[345,2697,0,null,null," Negate the sign.",[33971],false],[0,0,0,"self",null,"",null,false],[345,2702,0,null,null," Make positive.",[33973],false],[0,0,0,"self",null,"",null,false],[345,2706,0,null,null,null,[33975],false],[0,0,0,"self",null,"",null,false],[345,2710,0,null,null,null,[33977],false],[0,0,0,"self",null,"",null,false],[345,2715,0,null,null," Returns the number of bits required to represent the absolute value of an integer.",[33979],false],[0,0,0,"self",null,"",null,false],[345,2727,0,null,null," Returns the number of bits required to represent the integer in twos-complement form.\n\n If the integer is negative the value returned is the number of bits needed by a signed\n integer to represent the value. If positive the value is the number of bits for an\n unsigned integer. Any unsigned integer will fit in the signed integer with bitcount\n one greater than the returned value.\n\n e.g. -127 returns 8 as it will fit in an i8. 127 returns 7 since it fits in a u7.",[33981],false],[0,0,0,"self",null,"",null,false],[345,2731,0,null,null,null,[33983,33984,33985],false],[0,0,0,"self",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2736,0,null,null," Returns whether self can fit into an integer of the requested type.",[33987,33988],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[345,2743,0,null,null," Returns the approximate size of the integer in the given base. Negative values accommodate for\n the minus sign. This is used for determining the number of characters needed to print the\n value. It is inexact and may exceed the given value by ~1-2 bytes.",[33990,33991],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base",null,"",null,false],[345,2748,0,null,null," Sets an Managed to value. Value must be an primitive integer type.",[33993,33994],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[345,2755,0,null,null,null,null,false],[345,2760,0,null,null," Convert self to type T.\n\n Returns an error if self cannot be narrowed into the requested type without truncation.",[33997,33998],false],[0,0,0,"self",null,"",null,false],[0,0,0,"T",null,"",null,true],[345,2774,0,null,null," Set self from the string representation `value`.\n\n `value` must contain only digits <= `base` and is case insensitive.  Base prefixes are\n not allowed (e.g. 0x43 should simply be 43).  Underscores in the input string are\n ignored and can be used as digit separators.\n\n Returns an error if memory could not be allocated or `value` has invalid digits for the\n requested base.\n\n self's allocator is used for temporary storage to boost multiplication performance.",[34000,34001,34002],false],[0,0,0,"self",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"value",null,"",null,false],[345,2787,0,null,null," Set self to either bound of a 2s-complement integer.\n Note: The result is still sign-magnitude, not twos complement! In order to convert the\n result to twos complement, it is sufficient to take the absolute value.",[34004,34005,34006,34007],false],[0,0,0,"r",null,"",null,false],[0,0,0,"limit",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2801,0,null,null," Converts self to a string in the requested base. Memory is allocated from the provided\n allocator and not the one present in self.",[34009,34010,34011,34012],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"case",null,"",null,false],[345,2811,0,null,null," To allow `std.fmt.format` to work with `Managed`.\n If the integer is larger than `pow(2, 64 * @sizeOf(usize) * 8), this function will fail\n to print the string, printing \"(BigInt)\" instead of a number.\n This is because the rendering algorithm requires reversing a string, which requires O(N) memory.\n See `toString` and `toStringAlloc` for a way to print big integers without failure.",[34014,34015,34016,34017],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[345,2822,0,null,null," Returns math.Order.lt, math.Order.eq, math.Order.gt if |a| < |b|, |a| ==\n |b| or |a| > |b| respectively.",[34019,34020],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2828,0,null,null," Returns math.Order.lt, math.Order.eq, math.Order.gt if a < b, a == b or a\n > b respectively.",[34022,34023],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2833,0,null,null,null,null,false],[345,2834,0,null,null,null,null,false],[345,2835,0,null,null,null,null,false],[345,2838,0,null,null," Returns true if a == 0.",[34028],false],[0,0,0,"a",null,"",null,false],[345,2843,0,null,null," Returns true if |a| == |b|.",[34030,34031],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2848,0,null,null," Returns true if a == b.",[34033,34034],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2857,0,null,null," Normalize a possible sequence of leading zeros.\n\n [1, 2, 3, 4, 0] -> [1, 2, 3, 4]\n [1, 2, 0, 0, 0] -> [1, 2]\n [0, 0, 0, 0, 0] -> [0]",[34036,34037],false],[0,0,0,"r",null,"",null,false],[0,0,0,"length",null,"",null,false],[345,2877,0,null,null," r = a + scalar\n\n r and a may be aliases.\n\n Returns an error if memory could not be allocated.",[34039,34040,34041],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[345,2889,0,null,null," r = a + b\n\n r, a and b may be aliases.\n\n Returns an error if memory could not be allocated.",[34043,34044,34045],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2901,0,null,null," r = a + b with 2s-complement wrapping semantics. Returns whether any overflow occurred.\n\n r, a and b may be aliases.\n\n Returns an error if memory could not be allocated.",[34047,34048,34049,34050,34051],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2920,0,null,null," r = a + b with 2s-complement saturating semantics.\n\n r, a and b may be aliases.\n\n Returns an error if memory could not be allocated.",[34053,34054,34055,34056,34057],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2932,0,null,null," r = a - b\n\n r, a and b may be aliases.\n\n Returns an error if memory could not be allocated.",[34059,34060,34061],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,2944,0,null,null," r = a - b with 2s-complement wrapping semantics. Returns whether any overflow occurred.\n\n r, a and b may be aliases.\n\n Returns an error if memory could not be allocated.",[34063,34064,34065,34066,34067],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2963,0,null,null," r = a - b with 2s-complement saturating semantics.\n\n r, a and b may be aliases.\n\n Returns an error if memory could not be allocated.",[34069,34070,34071,34072,34073],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2983,0,null,null," rma = a * b\n\n rma, a and b may be aliases. However, it is more efficient if rma does not alias a or b.\n\n Returns an error if memory could not be allocated.\n\n rma's allocator is used for temporary storage to speed up the multiplication.",[34075,34076,34077],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3009,0,null,null," rma = a * b with 2s-complement wrapping semantics.\n\n rma, a and b may be aliases. However, it is more efficient if rma does not alias a or b.\n\n Returns an error if memory could not be allocated.\n\n rma's allocator is used for temporary storage to speed up the multiplication.",[34079,34080,34081,34082,34083],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,3035,0,null,null,null,[34085,34086],false],[0,0,0,"r",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,3039,0,null,null,null,[34088,34089,34090],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"scalar",null,"",null,false],[345,3043,0,null,null,null,[34092,34093,34094],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3047,0,null,null,null,[34096,34097,34098],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3056,0,null,null," q = a / b (rem r)\n\n a / b are floored (rounded towards 0).\n\n Returns an error if memory could not be allocated.",[34100,34101,34102,34103],false],[0,0,0,"q",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3073,0,null,null," q = a / b (rem r)\n\n a / b are truncated (rounded towards -inf).\n\n Returns an error if memory could not be allocated.",[34105,34106,34107,34108],false],[0,0,0,"q",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3087,0,null,null," r = a << shift, in other words, r = a * 2^shift\n r and a may alias.",[34110,34111,34112],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[345,3096,0,null,null," r = a <<| shift with 2s-complement saturating semantics.\n r and a may alias.",[34114,34115,34116,34117,34118],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,3105,0,null,null," r = a >> shift\n r and a may alias.",[34120,34121,34122],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[345,3127,0,null,null," r = ~a under 2s-complement wrapping semantics.\n r and a may alias.",[34124,34125,34126,34127],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,3137,0,null,null," r = a | b\n\n a and b are zero-extended to the longer of a or b.",[34129,34130,34131],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3145,0,null,null," r = a & b",[34133,34134,34135],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3157,0,null,null," r = a ^ b",[34137,34138,34139],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3170,0,null,null," rma may alias x or y.\n x and y may alias each other.\n\n rma's allocator is used for temporary storage to boost multiplication performance.",[34141,34142,34143],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[345,3180,0,null,null," r = a * a",[34145,34146],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[345,3200,0,null,null,null,[34148,34149,34150],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3224,0,null,null," r = ⌊√a⌋",[34152,34153],false],[0,0,0,"rma",null,"",null,false],[0,0,0,"a",null,"",null,false],[345,3237,0,null,null," r = truncate(Int(signedness, bit_count), a)",[34155,34156,34157,34158],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,3245,0,null,null," r = saturate(Int(signedness, bit_count), a)",[34160,34161,34162,34163],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"signedness",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,3254,0,null,null," r = @popCount(a) with 2s-complement semantics.\n r and a may be aliases.",[34165,34166,34167],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"bit_count",null,"",null,false],[345,2538,0,null,null,null,null,false],[0,0,0,"allocator",null," Allocator used by the Managed when requesting memory.",null,false],[345,2538,0,null,null,null,null,false],[0,0,0,"limbs",null," Raw digits. These are:\n\n * Little-endian ordered\n * limbs.len >= 1\n * Zero is represent as Managed.len() == 1 with limbs[0] == 0.\n\n Accessing limbs directly should be avoided.",null,false],[0,0,0,"metadata",null," High bit is the sign bit. If set, Managed is negative, else Managed is positive.\n The remaining bits represent the number of limbs used by Managed.",null,false],[345,3265,0,null,null," Different operators which can be used in accumulation style functions\n (llmulacc, llmulaccKaratsuba, llmulaccLong, llmulLimb). In all these functions,\n a computed value is accumulated with an existing result.",[34174,34175],false],[0,0,0,"add",null," The computed value is added to the result.",null,false],[0,0,0,"sub",null," The computed value is subtracted from the result.",null,false],[345,3279,0,null,null," Knuth 4.3.1, Algorithm M.\n\n r = r (op) a * b\n r MUST NOT alias any of a or b.\n\n The result is computed modulo `r.len`. When `r.len >= a.len + b.len`, no overflow occurs.",[34177,34178,34179,34180,34181],false],[0,0,0,"op",null,"",null,true],[0,0,0,"opt_allocator",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3312,0,null,null," Knuth 4.3.1, Algorithm M.\n\n r = r (op) a * b\n r MUST NOT alias any of a or b.\n\n The result is computed modulo `r.len`. When `r.len >= a.len + b.len`, no overflow occurs.",[34183,34184,34185,34186,34187],false],[0,0,0,"op",null,"",null,true],[0,0,0,"allocator",null,"",null,false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3481,0,null,null," r = r (op) a.\n The result is computed modulo `r.len`.",[34189,34190,34191],false],[0,0,0,"op",null,"",null,true],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[345,3510,0,null,null," Returns -1, 0, 1 if |a| < |b|, |a| == |b| or |a| > |b| respectively for limbs.",[34193,34194],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3539,0,null,null," r = r (op) y * xi\n The result is computed modulo `r.len`. When `r.len >= a.len + b.len`, no overflow occurs.",[34196,34197,34198,34199],false],[0,0,0,"op",null,"",null,true],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3553,0,null,null," r = r (op) y * xi\n The result is computed modulo `r.len`.\n Returns whether the operation overflowed.",[34201,34202,34203,34204],false],[0,0,0,"op",null,"",null,true],[0,0,0,"acc",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"xi",null,"",null,false],[345,3600,0,null,null," returns the min length the limb could be.",[34206],false],[0,0,0,"a",null,"",null,false],[345,3614,0,null,null," Knuth 4.3.1, Algorithm S.",[34208,34209,34210],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3640,0,null,null,null,[34212,34213,34214],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3647,0,null,null," Knuth 4.3.1, Algorithm A.",[34216,34217,34218],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3673,0,null,null,null,[34220,34221,34222],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3680,0,null,null," Knuth 4.3.1, Exercise 16.",[34224,34225,34226,34227],false],[0,0,0,"quo",null,"",null,false],[0,0,0,"rem",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3706,0,null,null,null,[34229,34230,34231,34232],false],[0,0,0,"quo",null,"",null,false],[0,0,0,"rem",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[345,3730,0,null,null,null,[34234,34235,34236],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[345,3765,0,null,null,null,[34238,34239,34240],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"shift",null,"",null,false],[345,3790,0,null,null,null,[34242],false],[0,0,0,"r",null,"",null,false],[345,3804,0,null,null,null,[34244,34245,34246,34247,34248],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"a_positive",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"b_positive",null,"",null,false],[345,3933,0,null,null,null,[34250,34251,34252,34253,34254],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"a_positive",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"b_positive",null,"",null,false],[345,4040,0,null,null,null,[34256,34257,34258,34259,34260],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"a_positive",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"b_positive",null,"",null,false],[345,4099,0,null,null," r MUST NOT alias x.",[34262,34263],false],[0,0,0,"r",null,"",null,false],[0,0,0,"x",null,"",null,false],[345,4137,0,null,null," Knuth 4.6.3",[34265,34266,34267,34268],false],[0,0,0,"r",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"tmp_limbs",null,"",null,false],[345,4185,0,null,null,null,[34270,34271],false],[0,0,0,"A",null,"",null,false],[0,0,0,"storage",null,"",null,false],[343,5,0,null,null,null,null,false],[343,6,0,null,null,null,null,false],[343,7,0,null,null,null,null,false],[343,8,0,null,null,null,null,false],[343,9,0,null,null,null,null,false],[343,10,0,null,null,null,null,false],[343,11,0,null,null,null,null,false],[285,383,0,null,null," Given two types, returns the smallest one which is capable of holding the\n full range of the minimum value.",[34280,34281],false],[0,0,0,"A",null,"",null,true],[0,0,0,"B",null,"",null,true],[285,400,0,null,null,null,null,false],[285,401,0,null,null,null,null,false],[285,402,0,null,null,null,null,false],[285,403,0,null,null,null,null,false],[285,404,0,null,null,null,null,false],[285,407,0,null,null," Limit val to the inclusive range [lower, upper].",[34288,34289,34290],false],[0,0,0,"val",null,"",null,false],[0,0,0,"lower",null,"",null,false],[0,0,0,"upper",null,"",null,false],[285,429,0,null,null," Returns the product of a and b. Returns an error on overflow.",[34292,34293,34294],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,437,0,null,null," Returns the sum of a and b. Returns an error on overflow.",[34296,34297,34298],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,445,0,null,null," Returns a - b, or an error on overflow.",[34300,34301,34302],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,452,0,null,null,null,[34304],false],[0,0,0,"x",null,"",null,false],[285,458,0,null,null," Shifts a left by shift_amt. Returns an error on overflow. shift_amt\n is unsigned.",[34306,34307,34308],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"shift_amt",null,"",null,false],[285,467,0,null,null," Shifts left. Overflowed bits are truncated.\n A negative shift amount results in a right shift.",[34310,34311,34312],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"shift_amt",null,"",null,false],[285,511,0,null,null," Shifts right. Overflowed bits are truncated.\n A negative shift amount results in a left shift.",[34314,34315,34316],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"shift_amt",null,"",null,false],[285,555,0,null,null," Rotates right. Only unsigned values can be rotated.  Negative shift\n values result in shift modulo the bit count.",[34318,34319,34320],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"r",null,"",null,false],[285,599,0,null,null," Rotates left. Only unsigned values can be rotated.  Negative shift\n values result in shift modulo the bit count.",[34322,34323,34324],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[0,0,0,"r",null,"",null,false],[285,643,0,null,null," Returns an unsigned int type that can hold the number of bits in T\n - 1. Suitable for 0-based bit indices of T.",[34326],false],[0,0,0,"T",null,"",null,true],[285,655,0,null,null," Returns an unsigned int type that can hold the number of bits in T.",[34328],false],[0,0,0,"T",null,"",null,true],[285,667,0,null,null," Returns the smallest integer type that can hold both from and to.",[34330,34331],false],[0,0,0,"from",null,"",null,true],[0,0,0,"to",null,"",null,true],[285,735,0,null,null,null,[],false],[285,746,0,null,null," Returns the absolute value of x, where x is a value of a signed integer type.\n Does not convert and returns a value of a signed integer type.\n Use `absCast` if you want to convert the result and get an unsigned type.\n Use `@fabs` if you need the absolute value of a floating point value.",[34334],false],[0,0,0,"x",null,"",null,false],[285,779,0,null,null,null,[],false],[285,790,0,null,null," Divide numerator by denominator, rounding toward zero. Returns an\n error on overflow or when denominator is zero.",[34337,34338,34339],false],[0,0,0,"T",null,"",null,true],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[285,801,0,null,null,null,[],false],[285,814,0,null,null," Divide numerator by denominator, rounding toward negative\n infinity. Returns an error on overflow or when denominator is\n zero.",[34342,34343,34344],false],[0,0,0,"T",null,"",null,true],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[285,825,0,null,null,null,[],false],[285,838,0,null,null," Divide numerator by denominator, rounding toward positive\n infinity. Returns an error on overflow or when denominator is\n zero.",[34347,34348,34349],false],[0,0,0,"T",null,"",null,true],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[285,862,0,null,null,null,[],false],[285,893,0,null,null," Divide numerator by denominator. Return an error if quotient is\n not an integer, denominator is zero, or on overflow.",[34352,34353,34354],false],[0,0,0,"T",null,"",null,true],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[285,906,0,null,null,null,[],false],[285,921,0,null,null," Returns numerator modulo denominator, or an error if denominator is\n zero or negative. Negative numerators never result in negative\n return values.",[34357,34358,34359],false],[0,0,0,"T",null,"",null,true],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[285,932,0,null,null,null,[],false],[285,947,0,null,null," Returns the remainder when numerator is divided by denominator, or\n an error if denominator is zero or negative. Negative numerators\n can give negative results.",[34362,34363,34364],false],[0,0,0,"T",null,"",null,true],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[285,958,0,null,null,null,[],false],[285,973,0,null,null," Returns the absolute value of a floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @fabs",[34367],false],[0,0,0,"value",null,"",null,false],[285,980,0,null,null," Returns the absolute value of the integer parameter.\n Converts result type to unsigned if needed and returns a value of an unsigned integer type.\n Use `absInt` if you want to keep your integer type signed.",[34369],false],[0,0,0,"x",null,"",null,false],[285,1016,0,null,null," Returns the negation of the integer parameter.\n Result is a signed integer.",[34371],false],[0,0,0,"x",null,"",null,false],[285,1039,0,null,null," Cast an integer to a different integer type. If the value doesn't fit,\n return null.",[34373,34374],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[285,1068,0,null,null,null,null,false],[285,1070,0,null,null,null,[34377,34378],false],[0,0,0,"alignment",null,"",null,true],[0,0,0,"Ptr",null,"",null,true],[285,1077,0,null,null," Align cast a pointer but return an error if it's the wrong alignment",[34380,34381],false],[0,0,0,"alignment",null,"",null,true],[0,0,0,"ptr",null,"",null,false],[285,1086,0,null,null," Asserts `int > 0`.",[34383],false],[0,0,0,"int",null,"",null,false],[285,1104,0,null,null," Aligns the given integer type bit width to a width divisible by 8.",[34385],false],[0,0,0,"T",null,"",null,true],[285,1123,0,null,null," Rounds the given floating point number to an integer, away from zero.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @round",[34387],false],[0,0,0,"value",null,"",null,false],[285,1130,0,null,null," Rounds the given floating point number to an integer, towards zero.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @trunc",[34389],false],[0,0,0,"value",null,"",null,false],[285,1137,0,null,null," Returns the largest integral value not greater than the given floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @floor",[34391],false],[0,0,0,"value",null,"",null,false],[285,1143,0,null,null," Returns the nearest power of two less than or equal to value, or\n zero if value is less than or equal to zero.",[34393,34394],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[285,1154,0,null,null,null,[],false],[285,1172,0,null,null," Returns the smallest integral value not less than the given floating point number.\n Uses a dedicated hardware instruction when available.\n This is the same as calling the builtin @ceil",[34397],false],[0,0,0,"value",null,"",null,false],[285,1179,0,null,null," Returns the next power of two (if the value is not already a power of two).\n Only unsigned integers can be used. Zero is not an allowed input.\n Result is a type with 1 more bit than the input type.",[34399,34400],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[285,1191,0,null,null," Returns the next power of two (if the value is not already a power of two).\n Only unsigned integers can be used. Zero is not an allowed input.\n If the value doesn't fit, returns an error.",[34402,34403],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[285,1207,0,null,null," Returns the next power of two (if the value is not already a power\n of two). Only unsigned integers can be used. Zero is not an\n allowed input. Asserts that the value fits.",[34405,34406],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[285,1216,0,null,null,null,[],false],[285,1233,0,null,null,null,[],false],[285,1247,0,null,null," Return the log base 2 of integer value x, rounding down to the\n nearest integer.",[34410,34411],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[285,1256,0,null,null," Return the log base 2 of integer value x, rounding up to the\n nearest integer.",[34413,34414],false],[0,0,0,"T",null,"",null,true],[0,0,0,"x",null,"",null,false],[285,1281,0,null,null," Cast a value to a different type. If the value doesn't fit in, or\n can't be perfectly represented by, the new type, it will be\n converted to the closest possible representation.",[34416,34417],false],[0,0,0,"T",null,"",null,true],[0,0,0,"value",null,"",null,false],[285,1331,0,null,null," Performs linear interpolation between *a* and *b* based on *t*.\n *t* must be in range 0.0 to 1.0. Supports floats and vectors of floats.\n\n This does not guarantee returning *b* if *t* is 1 due to floating-point errors.\n This is monotonic.",[34419,34420,34421],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"t",null,"",null,false],[285,1381,0,null,null," Returns the maximum value of integer type T.",[34423],false],[0,0,0,"T",null,"",null,true],[285,1389,0,null,null," Returns the minimum value of integer type T.",[34425],false],[0,0,0,"T",null,"",null,true],[285,1441,0,null,null," Multiply a and b. Return type is wide enough to guarantee no\n overflow.",[34427,34428,34429],false],[0,0,0,"T",null,"",null,true],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,1459,0,null,null," See also `CompareOperator`.",[34436,34437,34438],false],[285,1469,0,null,null,null,[34432],false],[0,0,0,"self",null,"",null,false],[285,1477,0,null,null,null,[34434,34435],false],[0,0,0,"self",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"gt",null," Greater than (`>`)",null,false],[0,0,0,"lt",null," Less than (`<`)",null,false],[0,0,0,"eq",null," Equal (`==`)",null,false],[285,1508,0,null,null," Given two numbers, this function returns the order they are with respect to each other.",[34440,34441],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,1521,0,null,null," See also `Order`.",[34445,34446,34447,34448,34449,34450],false],[285,1537,0,null,null," Reverse the direction of the comparison.\n Use when swapping the left and right hand operands.",[34444],false],[0,0,0,"op",null,"",null,false],[0,0,0,"lt",null," Less than (`<`)",null,false],[0,0,0,"lte",null," Less than or equal (`<=`)",null,false],[0,0,0,"eq",null," Equal (`==`)",null,false],[0,0,0,"gte",null," Greater than or equal (`>=`)",null,false],[0,0,0,"gt",null," Greater than (`>`)",null,false],[0,0,0,"neq",null," Not equal (`!=`)",null,false],[285,1552,0,null,null," This function does the same thing as comparison operators, however the\n operator is a runtime-known enum value. Works on any operands that\n support comparison operators.",[34452,34453,34454],false],[0,0,0,"a",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"b",null,"",null,false],[285,1618,0,null,null," Returns a mask of all ones if value is true,\n and a mask of all zeroes if value is false.\n Compiles to one instruction for register sized integers.",[34456,34457],false],[0,0,0,"MaskInt",null,"",null,true],[0,0,0,"value",null,"",null,false],[285,1663,0,null,null," Return the mod of `num` with the smallest integer type",[34459,34460],false],[0,0,0,"num",null,"",null,false],[0,0,0,"denom",null,"",null,true],[285,1667,0,null,null,null,[34462,34463],false],[0,0,0,"fraction",null,null,null,false],[0,0,0,"exp",null,null,null,false],[285,1672,0,null,null,null,[34465],false],[0,0,0,"repr",null,"",null,false],[285,1677,0,null,null,null,[34467],false],[0,0,0,"x",null,"",null,false],[285,1689,0,null,null," Returns -1, 0, or 1.\n Supports integer and float types and vectors of integer and float types.\n Unsigned integer types will always return 0 or 1.\n Branchless.",[34469],false],[0,0,0,"i",null,"",null,false],[285,1708,0,null,null,null,[],false],[285,1091,0,"isPowerOfTwo","test isPowerOfTwo {\n    try testing.expect(isPowerOfTwo(@as(u8, 1)));\n    try testing.expect(isPowerOfTwo(2));\n    try testing.expect(!isPowerOfTwo(@as(i16, 3)));\n    try testing.expect(isPowerOfTwo(4));\n    try testing.expect(!isPowerOfTwo(@as(u32, 31)));\n    try testing.expect(isPowerOfTwo(32));\n    try testing.expect(!isPowerOfTwo(@as(i64, 63)));\n    try testing.expect(isPowerOfTwo(128));\n    try testing.expect(isPowerOfTwo(@as(u128, 256)));\n}",null,null,false],[1,137,0,null,null," Functions for comparing, searching, and manipulating memory.",null,false],[1,140,0,null,null," Metaprogramming helpers.",null,false],[0,0,0,"meta.zig",null,"",[],false],[346,0,0,null,null,null,null,false],[346,1,0,null,null,null,null,false],[346,2,0,null,null,null,null,false],[346,3,0,null,null,null,null,false],[346,4,0,null,null,null,null,false],[346,5,0,null,null,null,null,false],[346,7,0,null,null,null,null,false],[0,0,0,"meta/trait.zig",null,"",[],false],[347,0,0,null,null,null,null,false],[347,1,0,null,null,null,null,false],[347,2,0,null,null,null,null,false],[347,3,0,null,null,null,null,false],[347,5,0,null,null,null,null,false],[347,7,0,null,null,null,[34489],false],[0,0,0,"",null,"",null,false],[347,9,0,null,null,null,[34491],false],[0,0,0,"traits",null,"",null,true],[347,44,0,null,null,null,[34493],false],[0,0,0,"name",null,"",null,true],[347,66,0,null,null,null,[34495],false],[0,0,0,"name",null,"",null,true],[347,98,0,null,null,null,[34497],false],[0,0,0,"id",null,"",null,true],[347,115,0,null,null,null,[34499],false],[0,0,0,"id",null,"",null,true],[347,131,0,null,null,null,[34501],false],[0,0,0,"id",null,"",null,true],[347,152,0,null,null,null,[34503],false],[0,0,0,"T",null,"",null,true],[347,169,0,null,null,null,[34505],false],[0,0,0,"T",null,"",null,true],[347,186,0,null,null,null,[34507],false],[0,0,0,"T",null,"",null,true],[347,200,0,null,null,null,[34509],false],[0,0,0,"T",null,"",null,true],[347,215,0,null,null,null,[34511],false],[0,0,0,"T",null,"",null,true],[347,230,0,null,null,null,[34513],false],[0,0,0,"T",null,"",null,true],[347,245,0,null,null,null,[34515],false],[0,0,0,"T",null,"",null,true],[347,260,0,null,null,null,[34517],false],[0,0,0,"T",null,"",null,true],[347,284,0,null,null,null,[34519],false],[0,0,0,"T",null,"",null,true],[347,305,0,null,null,null,[34521],false],[0,0,0,"T",null,"",null,true],[347,321,0,null,null,null,[34523],false],[0,0,0,"T",null,"",null,true],[347,337,0,null,null,null,[34525],false],[0,0,0,"T",null,"",null,true],[347,351,0,null,null,null,[34527],false],[0,0,0,"T",null,"",null,true],[347,376,0,null,null,null,[34529],false],[0,0,0,"T",null,"",null,true],[347,401,0,null,null," Returns true if the passed type will coerce to []const u8.\n Any of the following are considered strings:\n ```\n []const u8, [:S]const u8, *const [N]u8, *const [N:S]u8,\n []u8, [:S]u8, *[:S]u8, *[N:S]u8.\n ```\n These types are not considered strings:\n ```\n u8, [N]u8, [*]const u8, [*:0]const u8,\n [*]const [N]u8, []const u16, []const i8,\n *const u8, ?[]const u8, ?*const [N]u8.\n ```",[34531],false],[0,0,0,"T",null,"",null,true],[347,467,0,null,null,null,[34533,34534],false],[0,0,0,"T",null,"",null,true],[0,0,0,"names",null,"",null,true],[347,493,0,null,null,null,[34536,34537],false],[0,0,0,"T",null,"",null,true],[0,0,0,"names",null,"",null,true],[347,519,0,null,null,null,[34539,34540],false],[0,0,0,"T",null,"",null,true],[0,0,0,"names",null,"",null,true],[347,544,0,null,null," True if every value of the type `T` has a unique bit pattern representing it.\n In other words, `T` has no unused bits and no padding.",[34542],false],[0,0,0,"T",null,"",null,true],[346,8,0,null,null,null,null,false],[0,0,0,"meta/trailer_flags.zig",null,"",[],false],[348,0,0,null,null,null,null,false],[348,1,0,null,null,null,null,false],[348,2,0,null,null,null,null,false],[348,3,0,null,null,null,null,false],[348,4,0,null,null,null,null,false],[348,5,0,null,null,null,null,false],[348,11,0,null,null," This is useful for saving memory when allocating an object that has many\n optional components. The optional objects are allocated sequentially in\n memory, and a single integer is used to represent each optional object\n and whether it is present based on each corresponding bit.",[34552],false],[0,0,0,"Fields",null,"",[34596],true],[348,15,0,null,null,null,null,false],[348,16,0,null,null,null,null,false],[348,18,0,null,null,null,null,false],[348,20,0,null,null,null,null,false],[348,21,0,null,null,null,null,false],[348,42,0,null,null,null,null,false],[348,44,0,null,null,null,[34560,34561],false],[0,0,0,"self",null,"",null,false],[0,0,0,"field",null,"",null,true],[348,49,0,null,null,null,[34563,34564,34565],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"field",null,"",null,true],[348,55,0,null,null,null,[34567,34568],false],[0,0,0,"self",null,"",null,false],[0,0,0,"field",null,"",null,true],[348,61,0,null,null," `fields` is a boolean struct where each active field is set to `true`",[34570],false],[0,0,0,"fields",null,"",null,false],[348,71,0,null,null," `fields` is a struct with each field set to an optional value",[34572,34573,34574],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"fields",null,"",null,false],[348,78,0,null,null,null,[34576,34577,34578,34579],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"field",null,"",null,true],[0,0,0,"value",null,"",null,false],[348,87,0,null,null,null,[34581,34582,34583],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"field",null,"",null,true],[348,94,0,null,null,null,[34585,34586,34587],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"field",null,"",null,true],[348,101,0,null,null,null,[34589,34590],false],[0,0,0,"self",null,"",null,false],[0,0,0,"field",null,"",null,true],[348,115,0,null,null,null,[34592],false],[0,0,0,"field",null,"",null,true],[348,119,0,null,null,null,[34594],false],[0,0,0,"self",null,"",null,false],[348,12,0,null,null,null,null,false],[0,0,0,"bits",null,null,null,false],[346,10,0,null,null,null,null,false],[346,16,0,null,null,null,null,false],[346,18,0,null,null,null,null,false],[346,21,0,null,null," Returns the variant of an enum type, `T`, which is named `str`, or `null` if no such variant exists.",[34601,34602],false],[0,0,0,"T",null,"",null,true],[0,0,0,"str",null,"",null,false],[346,64,0,null,null," Returns the alignment of type T.\n Note that if T is a pointer or function type the result is different than\n the one returned by @alignOf(T).\n If T is a pointer type the alignment of the type it points to is returned.\n If T is a function type the alignment a target-dependent value is returned.",[34604],false],[0,0,0,"T",null,"",null,true],[346,87,0,null,null," Given a parameterized type (array, vector, pointer, optional), returns the \"child type\".",[34606],false],[0,0,0,"T",null,"",null,true],[346,106,0,null,null," Given a \"memory span\" type (array, slice, vector, or pointer to such), returns the \"element type\".",[34608],false],[0,0,0,"T",null,"",null,true],[346,137,0,null,null," Given a type which can have a sentinel e.g. `[:0]u8`, returns the sentinel value,\n or `null` if there is not one.\n Types which cannot possibly have a sentinel will be a compile error.",[34610],false],[0,0,0,"T",null,"",null,true],[346,169,0,null,null,null,[],false],[346,182,0,null,null," Given a \"memory span\" type, returns the same type except with the given sentinel value.",[34613,34614],false],[0,0,0,"T",null,"",null,true],[0,0,0,"sentinel_val",null,"",null,true],[346,247,0,null,null,null,null,false],[346,249,0,null,null,null,[34617],false],[0,0,0,"T",null,"",null,true],[346,281,0,null,null," Instead of this function, prefer to use e.g. `@typeInfo(foo).Struct.decls`\n directly when you know what kind of type it is.",[34619],false],[0,0,0,"T",null,"",null,true],[346,322,0,null,null,null,[34621,34622],false],[0,0,0,"T",null,"",null,true],[0,0,0,"decl_name",null,"",null,true],[346,356,0,null,null,null,[34624],false],[0,0,0,"T",null,"",null,true],[346,401,0,null,null,null,[34626,34627],false],[0,0,0,"T",null,"",null,true],[0,0,0,"field",null,"",null,true],[346,436,0,null,null,null,[34629,34630],false],[0,0,0,"T",null,"",null,true],[0,0,0,"field",null,"",null,true],[346,462,0,null,null,null,[34632],false],[0,0,0,"T",null,"",null,true],[346,503,0,null,null," Given an enum or error set type, returns a pointer to an array containing all tags for that\n enum or error set.",[34634],false],[0,0,0,"T",null,"",null,true],[346,529,0,null,null," Returns an enum with a variant named after each field of `T`.",[34636],false],[0,0,0,"T",null,"",null,true],[346,572,0,null,null,null,[34638,34639],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[346,625,0,null,null,null,[34641],false],[0,0,0,"T",null,"",null,true],[346,665,0,null,null,null,[34643],false],[0,0,0,"T",null,"",null,true],[346,688,0,null,null,"Returns the active tag of a tagged union",[34645],false],[0,0,0,"u",null,"",null,false],[346,711,0,null,null,null,null,false],[346,713,0,null,null,null,[34648,34649],false],[0,0,0,"U",null,"",null,true],[0,0,0,"tag_name",null,"",null,true],[346,728,0,null,null," Given a tagged union type, and an enum, return the type of the union field\n corresponding to the enum tag.",[34651,34652],false],[0,0,0,"U",null,"",null,true],[0,0,0,"tag",null,"",null,true],[346,746,0,null,null," Compares two of any type for equality. Containers are compared on a field-by-field basis,\n where possible. Pointers are not followed.",[34654,34655],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[346,891,0,null,null,null,null,false],[346,893,0,null,null,null,[34658,34659],false],[0,0,0,"EnumTag",null,"",null,true],[0,0,0,"tag_int",null,"",null,false],[346,914,0,null,null," Given a type and a name, return the field index according to source order.\n Returns `null` if the field is not found.",[34661,34662],false],[0,0,0,"T",null,"",null,true],[0,0,0,"name",null,"",null,true],[346,922,0,null,null,null,null,false],[346,925,0,null,null," Returns a slice of pointers to public declarations of a namespace.",[34665,34666],false],[0,0,0,"Namespace",null,"",null,true],[0,0,0,"Decl",null,"",null,true],[346,943,0,null,null,null,null,false],[346,945,0,null,null,null,[34669,34670],false],[0,0,0,"signedness",null,"",null,true],[0,0,0,"bit_count",null,"",null,true],[346,954,0,null,null,null,[34672],false],[0,0,0,"bit_count",null,"",null,true],[346,974,0,null,null," For a given function type, returns a tuple type which fields will\n correspond to the argument types.\n\n Examples:\n - `ArgsTuple(fn() void)` ⇒ `tuple { }`\n - `ArgsTuple(fn(a: u32) u32)` ⇒ `tuple { u32 }`\n - `ArgsTuple(fn(a: u32, b: f16) noreturn)` ⇒ `tuple { u32, f16 }`",[34674],false],[0,0,0,"Function",null,"",null,true],[346,999,0,null,null," For a given anonymous list of types, returns a new tuple type\n with those types as fields.\n\n Examples:\n - `Tuple(&[_]type {})` ⇒ `tuple { }`\n - `Tuple(&[_]type {f32})` ⇒ `tuple { f32 }`\n - `Tuple(&[_]type {f32,u32})` ⇒ `tuple { f32, u32 }`",[34676],false],[0,0,0,"types",null,"",null,true],[346,1003,0,null,null,null,[34678,34679],false],[0,0,0,"N",null,"",null,true],[0,0,0,"types",null,"",null,true],[346,1027,0,null,null,null,[],false],[346,1028,0,null,null,null,[34682,34683],false],[0,0,0,"Expected",null,"",null,true],[0,0,0,"Actual",null,"",null,true],[346,1033,0,null,null,null,[34685,34686],false],[0,0,0,"expected",null,"",null,true],[0,0,0,"Actual",null,"",null,true],[346,1094,0,null,null," TODO: https://github.com/ziglang/zig/issues/425",[34688,34689],false],[0,0,0,"name",null,"",null,true],[0,0,0,"T",null,"",null,true],[346,1101,0,null,null," Returns whether `error_union` contains an error.",[34691],false],[0,0,0,"error_union",null,"",null,false],[1,143,0,null,null," Networking.",null,false],[0,0,0,"net.zig",null,"",[],false],[349,0,0,null,null,null,null,false],[349,1,0,null,null,null,null,false],[349,2,0,null,null,null,null,false],[349,3,0,null,null,null,null,false],[349,4,0,null,null,null,null,false],[349,5,0,null,null,null,null,false],[349,6,0,null,null,null,null,false],[349,7,0,null,null,null,null,false],[349,8,0,null,null,null,null,false],[349,12,0,null,null,null,null,false],[349,16,0,null,null,null,[34751,34752,34753,34754],false],[349,25,0,null,null," Parse the given IP address string into an Address value.\n It is recommended to use `resolveIp` instead, to handle\n IPv6 link-local unix addresses.",[34706,34707],false],[0,0,0,"name",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,47,0,null,null,null,[34709,34710],false],[0,0,0,"name",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,70,0,null,null,null,[34712,34713,34714],false],[0,0,0,"name",null,"",null,false],[0,0,0,"family",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,79,0,null,null,null,[34716,34717],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,83,0,null,null,null,[34719,34720],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,87,0,null,null,null,[34722,34723],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,91,0,null,null,null,[34725,34726],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,95,0,null,null,null,[34728,34729,34730,34731],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"port",null,"",null,false],[0,0,0,"flowinfo",null,"",null,false],[0,0,0,"scope_id",null,"",null,false],[349,99,0,null,null,null,[34733],false],[0,0,0,"path",null,"",null,false],[349,116,0,null,null," Returns the port in native endian.\n Asserts that the address is ip4 or ip6.",[34735],false],[0,0,0,"self",null,"",null,false],[349,126,0,null,null," `port` is native-endian.\n Asserts that the address is ip4 or ip6.",[34737,34738],false],[0,0,0,"self",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,137,0,null,null," Asserts that `addr` is an IP address.\n This function will read past the end of the pointer, with a size depending\n on the address family.",[34740],false],[0,0,0,"addr",null,"",null,false],[349,145,0,null,null,null,[34742,34743,34744,34745],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[349,166,0,null,null,null,[34747,34748],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[349,172,0,null,null,null,[34750],false],[0,0,0,"self",null,"",null,false],[0,0,0,"any",null,null,null,false],[0,0,0,"in",null,null,null,false],[0,0,0,"in6",null,null,null,false],[0,0,0,"un",null,null,null,false],[349,197,0,null,null,null,[34778],false],[349,200,0,null,null,null,[34757,34758],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,247,0,null,null,null,[34760,34761],false],[0,0,0,"name",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,258,0,null,null,null,[34763,34764],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,269,0,null,null," Returns the port in native endian.\n Asserts that the address is ip4 or ip6.",[34766],false],[0,0,0,"self",null,"",null,false],[349,275,0,null,null," `port` is native-endian.\n Asserts that the address is ip4 or ip6.",[34768,34769],false],[0,0,0,"self",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,279,0,null,null,null,[34771,34772,34773,34774],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[349,297,0,null,null,null,[34776],false],[0,0,0,"self",null,"",null,false],[349,197,0,null,null,null,null,false],[0,0,0,"sa",null,null,null,false],[349,303,0,null,null,null,[34804],false],[349,309,0,null,null," Parse a given IPv6 address string into an Address.\n Assumes the Scope ID of the address is fully numeric.\n For non-numeric addresses, see `resolveIp6`.",[34781,34782],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,426,0,null,null,null,[34784,34785],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,560,0,null,null,null,[34787,34788,34789,34790],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"port",null,"",null,false],[0,0,0,"flowinfo",null,"",null,false],[0,0,0,"scope_id",null,"",null,false],[349,573,0,null,null," Returns the port in native endian.\n Asserts that the address is ip4 or ip6.",[34792],false],[0,0,0,"self",null,"",null,false],[349,579,0,null,null," `port` is native-endian.\n Asserts that the address is ip4 or ip6.",[34794,34795],false],[0,0,0,"self",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,583,0,null,null,null,[34797,34798,34799,34800],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"out_stream",null,"",null,false],[349,632,0,null,null,null,[34802],false],[0,0,0,"self",null,"",null,false],[349,303,0,null,null,null,null,false],[0,0,0,"sa",null,null,null,false],[349,638,0,null,null,null,[34806],false],[0,0,0,"path",null,"",null,false],[349,661,0,null,null,null,[34808],false],[0,0,0,"name",null,"",null,false],[349,693,0,null,null,null,[34813,34815,34817],false],[349,698,0,null,null,null,[34811],false],[0,0,0,"self",null,"",null,false],[349,693,0,null,null,null,null,false],[0,0,0,"arena",null,null,null,false],[349,693,0,null,null,null,null,false],[0,0,0,"addrs",null,null,null,false],[349,693,0,null,null,null,null,false],[0,0,0,"canon_name",null,null,null,false],[349,707,0,null,null,null,null,false],[349,710,0,null,null," All memory allocated with `allocator` will be freed before this function returns.",[34820,34821,34822],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,727,0,null,null,null,null,false],[349,729,0,null,null,null,[34825],false],[0,0,0,"address",null,"",null,false],[349,746,0,null,null,null,null,false],[349,771,0,null,null," Call `AddressList.deinit` on the result.",[34828,34829,34830],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,952,0,null,null,null,[34833,34834],false],[349,952,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"sortkey",null,null,null,false],[349,957,0,null,null,null,null,false],[349,958,0,null,null,null,null,false],[349,959,0,null,null,null,null,false],[349,960,0,null,null,null,null,false],[349,961,0,null,null,null,null,false],[349,962,0,null,null,null,null,false],[349,963,0,null,null,null,null,false],[349,965,0,null,null,null,[34843,34844,34845,34846,34847,34848],false],[0,0,0,"addrs",null,"",null,false],[0,0,0,"canon",null,"",null,false],[0,0,0,"opt_name",null,"",null,false],[0,0,0,"family",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,1090,0,null,null,null,[34851,34852,34853,34854,34855],false],[349,1090,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"mask",null,null,null,false],[0,0,0,"prec",null,null,null,false],[0,0,0,"label",null,null,null,false],[349,1098,0,null,null,null,null,false],[349,1150,0,null,null,null,[34858],false],[0,0,0,"a",null,"",null,false],[349,1159,0,null,null,null,[34860],false],[0,0,0,"a",null,"",null,false],[349,1167,0,null,null,null,[34862,34863],false],[0,0,0,"s",null,"",null,false],[0,0,0,"d",null,"",null,false],[349,1180,0,null,null,null,[34865],false],[0,0,0,"a",null,"",null,false],[349,1184,0,null,null,null,[34867],false],[0,0,0,"a",null,"",null,false],[349,1188,0,null,null,null,[34869],false],[0,0,0,"a",null,"",null,false],[349,1192,0,null,null,null,[34871],false],[0,0,0,"a",null,"",null,false],[349,1199,0,null,null,null,[34873],false],[0,0,0,"a",null,"",null,false],[349,1204,0,null,null,null,[34875,34876,34877],false],[0,0,0,"context",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"a",null,"",null,false],[349,1209,0,null,null,null,[34879,34880,34881,34882],false],[0,0,0,"addrs",null,"",null,false],[0,0,0,"family",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,1240,0,null,null,null,[34884,34885,34886,34887,34888],false],[0,0,0,"addrs",null,"",null,false],[0,0,0,"canon",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"family",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,1302,0,null,null,null,[34890],false],[0,0,0,"hostname",null,"",null,false],[349,1314,0,null,null,null,[34892,34893,34894,34895,34896],false],[0,0,0,"addrs",null,"",null,false],[0,0,0,"canon",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"family",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,1363,0,null,null,null,[34899,34901,34902],false],[349,1363,0,null,null,null,null,false],[0,0,0,"addrs",null,null,null,false],[349,1363,0,null,null,null,null,false],[0,0,0,"canon",null,null,null,false],[0,0,0,"port",null,null,null,false],[349,1369,0,null,null,null,[34904,34905,34906,34907,34908,34909],false],[0,0,0,"addrs",null,"",null,false],[0,0,0,"canon",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"family",null,"",null,false],[0,0,0,"rc",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,1422,0,null,null,null,[34913,34914,34915,34917,34919],false],[349,1429,0,null,null,null,[34912],false],[0,0,0,"rc",null,"",null,false],[0,0,0,"attempts",null,null,null,false],[0,0,0,"ndots",null,null,null,false],[0,0,0,"timeout",null,null,null,false],[349,1422,0,null,null,null,null,false],[0,0,0,"search",null,null,null,false],[349,1422,0,null,null,null,null,false],[0,0,0,"ns",null,null,null,false],[349,1438,0,null,null," Ignores lines longer than 512 bytes.\n TODO: https://github.com/ziglang/zig/issues/2765 and https://github.com/ziglang/zig/issues/2761",[34921,34922],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"rc",null,"",null,false],[349,1508,0,null,null,null,[34924,34925,34926],false],[0,0,0,"addrs",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"port",null,"",null,false],[349,1517,0,null,null,null,[34928,34929,34930,34931],false],[0,0,0,"queries",null,"",null,false],[0,0,0,"answers",null,"",null,false],[0,0,0,"answer_bufs",null,"",null,false],[0,0,0,"rc",null,"",null,false],[349,1678,0,null,null,null,[34933,34934,34935],false],[0,0,0,"r",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"callback",null,"",null,true],[349,1711,0,null,null,null,[34937,34938,34939,34940],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"rr",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"packet",null,"",null,false],[349,1741,0,null,null,null,[34978],false],[349,1747,0,null,null,null,[34943],false],[0,0,0,"self",null,"",null,false],[349,1751,0,null,null,null,null,false],[349,1752,0,null,null,null,null,false],[349,1754,0,null,null,null,null,false],[349,1755,0,null,null,null,null,false],[349,1757,0,null,null,null,[34949],false],[0,0,0,"self",null,"",null,false],[349,1761,0,null,null,null,[34951],false],[0,0,0,"self",null,"",null,false],[349,1765,0,null,null,null,[34953,34954],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[349,1777,0,null,null,null,[34956,34957],false],[0,0,0,"s",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[349,1791,0,null,null," Returns the number of bytes read. If the number read is smaller than\n `buffer.len`, it means the stream reached the end. Reaching the end of\n a stream is not an error condition.",[34959,34960],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[349,1800,0,null,null," Returns the number of bytes read, calling the underlying read function\n the minimal number of times until the buffer has at least `len` bytes\n filled. If the number read is less than `len` it means the stream\n reached the end. Reaching the end of the stream is not an error\n condition.",[34962,34963,34964],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"len",null,"",null,false],[349,1814,0,null,null," TODO in evented I/O mode, this implementation incorrectly uses the event loop's\n file system thread instead of non-blocking. It needs to be reworked to properly\n use non-blocking I/O.",[34966,34967],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[349,1826,0,null,null,null,[34969,34970],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[349,1835,0,null,null," See https://github.com/ziglang/zig/issues/7699\n See equivalent function: `std.fs.File.writev`.",[34972,34973],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[349,1851,0,null,null," The `iovecs` parameter is mutable because this function needs to mutate the fields in\n order to handle partial writes from the underlying OS layer.\n See https://github.com/ziglang/zig/issues/7699\n See equivalent function: `std.fs.File.writevAll`.",[34975,34976],false],[0,0,0,"self",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[349,1741,0,null,null,null,null,false],[0,0,0,"handle",null,null,null,false],[349,1868,0,null,null,null,[35003,35004,35005,35007,35009],false],[349,1879,0,null,null,null,[34982,34983,34984],false],[349,1879,0,null,null,null,null,false],[0,0,0,"kernel_backlog",null," How many connections the kernel will accept on the application's behalf.\n If more than this many connections pool in the kernel, clients will start\n seeing \"Connection refused\".",null,false],[0,0,0,"reuse_address",null," Enable SO.REUSEADDR on the socket.",null,false],[0,0,0,"reuse_port",null," Enable SO.REUSEPORT on the socket.",null,false],[349,1894,0,null,null," After this call succeeds, resources have been acquired and must\n be released with `deinit`.",[34986],false],[0,0,0,"options",null,"",null,false],[349,1905,0,null,null," Release all resources. The `StreamServer` memory becomes `undefined`.",[34988],false],[0,0,0,"self",null,"",null,false],[349,1910,0,null,null,null,[34990,34991],false],[0,0,0,"self",null,"",null,false],[0,0,0,"address",null,"",null,false],[349,1948,0,null,null," Stop listening. It is still necessary to call `deinit` after stopping listening.\n Calling `deinit` will automatically call `close`. It is safe to call `close` when\n not listening.",[34993],false],[0,0,0,"self",null,"",null,false],[349,1956,0,null,null,null,null,false],[349,1986,0,null,null,null,[34997,34999],false],[349,1986,0,null,null,null,null,false],[0,0,0,"stream",null,null,null,false],[349,1986,0,null,null,null,null,false],[0,0,0,"address",null,null,null,false],[349,1992,0,null,null," If this function succeeds, the returned `Connection` is a caller-managed resource.",[35001],false],[0,0,0,"self",null,"",null,false],[349,1868,0,null,null,null,null,false],[0,0,0,"kernel_backlog",null," Copied from `Options` on `init`.",null,false],[0,0,0,"reuse_address",null,null,null,false],[0,0,0,"reuse_port",null,null,null,false],[349,1868,0,null,null,null,null,false],[0,0,0,"listen_address",null," `undefined` until `listen` returns successfully.",null,false],[349,1868,0,null,null,null,null,false],[0,0,0,"sockfd",null,null,null,false],[1,146,0,null,null," Wrappers around OS-specific APIs.",null,false],[0,0,0,"os.zig",null," This file contains thin wrappers around OS-specific APIs, with these\n specific goals in mind:\n * Convert \"errno\"-style error codes into Zig errors.\n * When null-terminated byte buffers are required, provide APIs which accept\n   slices as well as APIs which accept null-terminated byte buffers. Same goes\n   for UTF-16LE encoding.\n * Where operating systems share APIs, e.g. POSIX, these thin wrappers provide\n   cross platform abstracting.\n * When there exists a corresponding libc function and linking libc, the libc\n   implementation is used. Exceptions are made for known buggy areas of libc.\n   On Linux libc can be side-stepped by using `std.os.linux` directly.\n * For Windows, this file represents the API that libc would provide for\n   Windows. For thin wrappers around Windows-specific APIs, see `std.os.windows`.\n Note: The Zig standard library does not support POSIX thread cancellation, and\n in general EINTR is handled by trying again.\n",[],false],[350,16,0,null,null,null,null,false],[350,17,0,null,null,null,null,false],[350,18,0,null,null,null,null,false],[350,19,0,null,null,null,null,false],[350,20,0,null,null,null,null,false],[350,21,0,null,null,null,null,false],[350,22,0,null,null,null,null,false],[350,23,0,null,null,null,null,false],[350,24,0,null,null,null,null,false],[350,25,0,null,null,null,null,false],[350,26,0,null,null,null,null,false],[350,28,0,null,null,null,null,false],[350,29,0,null,null,null,null,false],[350,30,0,null,null,null,null,false],[350,31,0,null,null,null,null,false],[350,32,0,null,null,null,null,false],[350,33,0,null,null,null,null,false],[350,34,0,null,null,null,null,false],[350,35,0,null,null,null,null,false],[0,0,0,"os/linux.zig",null," This file provides the system interface functions for Linux matching those\n that are provided by libc, whether or not libc is linked. The following\n abstractions are made:\n * Work around kernel bugs and limitations. For example, see sendmmsg.\n * Implement all the syscalls in the same way that libc functions will\n   provide `rename` when only the `renameat` syscall exists.\n * Does not support POSIX thread cancellation.\n",[],false],[351,151,0,null,null,null,null,false],[0,0,0,"linux/io_uring.zig",null,"",[],false],[352,0,0,null,null,null,null,false],[352,1,0,null,null,null,null,false],[352,2,0,null,null,null,null,false],[352,3,0,null,null,null,null,false],[352,4,0,null,null,null,null,false],[352,5,0,null,null,null,null,false],[352,6,0,null,null,null,null,false],[352,7,0,null,null,null,null,false],[352,9,0,null,null,null,[35325,35327,35329,35330,35331],false],[352,21,0,null,null," A friendly way to setup an io_uring, with default linux.io_uring_params.\n `entries` must be a power of two between 1 and 4096, although the kernel will make the final\n call on how many entries the submission and completion queues will ultimately have,\n see https://github.com/torvalds/linux/blob/v5.8/fs/io_uring.c#L8027-L8050.\n Matches the interface of io_uring_queue_init() in liburing.",[35044,35045],false],[0,0,0,"entries",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,33,0,null,null," A powerful way to setup an io_uring, if you want to tweak linux.io_uring_params such as submission\n queue thread cpu affinity or thread idle timeout (the kernel and our default is 1 second).\n `params` is passed by reference because the kernel needs to modify the parameters.\n Matches the interface of io_uring_queue_init_params() in liburing.",[35047,35048],false],[0,0,0,"entries",null,"",null,false],[0,0,0,"p",null,"",null,false],[352,117,0,null,null,null,[35050],false],[0,0,0,"self",null,"",null,false],[352,133,0,null,null," Returns a pointer to a vacant SQE, or an error if the submission queue is full.\n We follow the implementation (and atomics) of liburing's `io_uring_get_sqe()` exactly.\n However, instead of a null we return an error to force safe handling.\n Any situation where the submission queue is full tends more towards a control flow error,\n and the null return in liburing is more a C idiom than anything else, for lack of a better\n alternative. In Zig, we have first-class error handling... so let's use it.\n Matches the implementation of io_uring_get_sqe() in liburing.",[35052],false],[0,0,0,"self",null,"",null,false],[352,148,0,null,null," Submits the SQEs acquired via get_sqe() to the kernel. You can call this once after you have\n called get_sqe() multiple times to setup multiple I/O requests.\n Returns the number of SQEs submitted.\n Matches the implementation of io_uring_submit() in liburing.",[35054],false],[0,0,0,"self",null,"",null,false],[352,155,0,null,null," Like submit(), but allows waiting for events as well.\n Returns the number of SQEs submitted.\n Matches the implementation of io_uring_submit_and_wait() in liburing.",[35056,35057],false],[0,0,0,"self",null,"",null,false],[0,0,0,"wait_nr",null,"",null,false],[352,169,0,null,null," Tell the kernel we have submitted SQEs and/or want to wait for CQEs.\n Returns the number of SQEs submitted.",[35059,35060,35061,35062],false],[0,0,0,"self",null,"",null,false],[0,0,0,"to_submit",null,"",null,false],[0,0,0,"min_complete",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,208,0,null,null," Sync internal state with kernel ring state on the SQ side.\n Returns the number of all pending events in the SQ ring, for the shared ring.\n This return value includes previously flushed SQEs, as per liburing.\n The rationale is to suggest that an io_uring_enter() call is needed rather than not.\n Matches the implementation of __io_uring_flush_sq() in liburing.",[35064],false],[0,0,0,"self",null,"",null,false],[352,229,0,null,null," Returns true if we are not using an SQ thread (thus nobody submits but us),\n or if IORING_SQ_NEED_WAKEUP is set and the SQ thread must be explicitly awakened.\n For the latter case, we set the SQ thread wakeup flag.\n Matches the implementation of sq_ring_needs_enter() in liburing.",[35066,35067],false],[0,0,0,"self",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,243,0,null,null," Returns the number of flushed and unflushed SQEs pending in the submission queue.\n In other words, this is the number of SQEs in the submission queue, i.e. its length.\n These are SQEs that the kernel is yet to consume.\n Matches the implementation of io_uring_sq_ready in liburing.",[35069],false],[0,0,0,"self",null,"",null,false],[352,252,0,null,null," Returns the number of CQEs in the completion queue, i.e. its length.\n These are CQEs that the application is yet to consume.\n Matches the implementation of io_uring_cq_ready in liburing.",[35071],false],[0,0,0,"self",null,"",null,false],[352,266,0,null,null," Copies as many CQEs as are ready, and that can fit into the destination `cqes` slice.\n If none are available, enters into the kernel to wait for at most `wait_nr` CQEs.\n Returns the number of CQEs copied, advancing the CQ ring.\n Provides all the wait/peek methods found in liburing, but with batching and a single method.\n The rationale for copying CQEs rather than copying pointers is that pointers are 8 bytes\n whereas CQEs are not much more at only 16 bytes, and this provides a safer faster interface.\n Safer, because you no longer need to call cqe_seen(), avoiding idempotency bugs.\n Faster, because we can now amortize the atomic store release to `cq.head` across the batch.\n See https://github.com/axboe/liburing/issues/103#issuecomment-686665007.\n Matches the implementation of io_uring_peek_batch_cqe() in liburing, but supports waiting.",[35073,35074,35075],false],[0,0,0,"self",null,"",null,false],[0,0,0,"cqes",null,"",null,false],[0,0,0,"wait_nr",null,"",null,false],[352,276,0,null,null,null,[35077,35078,35079],false],[0,0,0,"self",null,"",null,false],[0,0,0,"cqes",null,"",null,false],[0,0,0,"wait_nr",null,"",null,false],[352,296,0,null,null," Returns a copy of an I/O completion, waiting for it if necessary, and advancing the CQ ring.\n A convenience method for `copy_cqes()` for when you don't need to batch or peek.",[35081],false],[0,0,0,"ring",null,"",null,false],[352,305,0,null,null," Matches the implementation of cq_ring_needs_flush() in liburing.",[35083],false],[0,0,0,"self",null,"",null,false],[352,314,0,null,null," For advanced use cases only that implement custom completion queue methods.\n If you use copy_cqes() or copy_cqe() you must not call cqe_seen() or cq_advance().\n Must be called exactly once after a zero-copy CQE has been processed by your application.\n Not idempotent, calling more than once will result in other CQEs being lost.\n Matches the implementation of cqe_seen() in liburing.",[35085,35086],false],[0,0,0,"self",null,"",null,false],[0,0,0,"cqe",null,"",null,false],[352,321,0,null,null," For advanced use cases only that implement custom completion queue methods.\n Matches the implementation of cq_advance() in liburing.",[35088,35089],false],[0,0,0,"self",null,"",null,false],[0,0,0,"count",null,"",null,false],[352,337,0,null,null," Queues (but does not submit) an SQE to perform an `fsync(2)`.\n Returns a pointer to the SQE so that you can further modify the SQE for advanced use cases.\n For example, for `fdatasync()` you can set `IORING_FSYNC_DATASYNC` in the SQE's `rw_flags`.\n N.B. While SQEs are initiated in the order in which they appear in the submission queue,\n operations execute in parallel and completions are unordered. Therefore, an application that\n submits a write followed by an fsync in the submission queue cannot expect the fsync to\n apply to the write, since the fsync may complete before the write is issued to the disk.\n You should preferably use `link_with_next_sqe()` on a write's SQE to link it with an fsync,\n or else insert a full write barrier using `drain_previous_sqes()` when queueing an fsync.",[35091,35092,35093,35094],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,349,0,null,null," Queues (but does not submit) an SQE to perform a no-op.\n Returns a pointer to the SQE so that you can further modify the SQE for advanced use cases.\n A no-op is more useful than may appear at first glance.\n For example, you could call `drain_previous_sqes()` on the returned SQE, to use the no-op to\n know when the ring is idle before acting on a kill signal.",[35096,35097],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[352,357,0,null,null," Used to select how the read should be handled.",[35099,35100,35103],false],[0,0,0,"buffer",null," io_uring will read directly into this buffer",null,false],[0,0,0,"iovecs",null," io_uring will read directly into these buffers using readv.",[35101,35102],false],[0,0,0,"group_id",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"buffer_selection",null," io_uring will select a buffer that has previously been provided with `provide_buffers`.\n The buffer group reference by `group_id` must contain at least one buffer for the read to work.\n `len` controls the number of bytes to read into the selected buffer.",null,false],[352,379,0,null,null," Queues (but does not submit) an SQE to perform a `read(2)` or `preadv(2)` depending on the buffer type.\n * Reading into a `ReadBuffer.buffer` uses `read(2)`\n * Reading into a `ReadBuffer.iovecs` uses `preadv(2)`\n   If you want to do a `preadv2(2)` then set `rw_flags` on the returned SQE. See https://man7.org/linux/man-pages/man2/preadv2.2.html\n\n Returns a pointer to the SQE.",[35105,35106,35107,35108,35109],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,402,0,null,null," Queues (but does not submit) an SQE to perform a `write(2)`.\n Returns a pointer to the SQE.",[35111,35112,35113,35114,35115],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,420,0,null,null," Queues (but does not submit) an SQE to perform a IORING_OP_READ_FIXED.\n The `buffer` provided must be registered with the kernel by calling `register_buffers` first.\n The `buffer_index` must be the same as its index in the array provided to `register_buffers`.\n\n Returns a pointer to the SQE so that you can further modify the SQE for advanced use cases.",[35117,35118,35119,35120,35121,35122],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"buffer_index",null,"",null,false],[352,438,0,null,null," Queues (but does not submit) an SQE to perform a `pwritev()`.\n Returns a pointer to the SQE so that you can further modify the SQE for advanced use cases.\n For example, if you want to do a `pwritev2()` then set `rw_flags` on the returned SQE.\n See https://linux.die.net/man/2/pwritev.",[35124,35125,35126,35127,35128],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,456,0,null,null," Queues (but does not submit) an SQE to perform a IORING_OP_WRITE_FIXED.\n The `buffer` provided must be registered with the kernel by calling `register_buffers` first.\n The `buffer_index` must be the same as its index in the array provided to `register_buffers`.\n\n Returns a pointer to the SQE so that you can further modify the SQE for advanced use cases.",[35130,35131,35132,35133,35134,35135],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"buffer_index",null,"",null,false],[352,472,0,null,null," Queues (but does not submit) an SQE to perform an `accept4(2)` on a socket.\n Returns a pointer to the SQE.",[35137,35138,35139,35140,35141,35142],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,488,0,null,null," Queue (but does not submit) an SQE to perform a `connect(2)` on a socket.\n Returns a pointer to the SQE.",[35144,35145,35146,35147,35148],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[352,503,0,null,null," Queues (but does not submit) an SQE to perform a `epoll_ctl(2)`.\n Returns a pointer to the SQE.",[35150,35151,35152,35153,35154,35155],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"epfd",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"ev",null,"",null,false],[352,518,0,null,null," Used to select how the recv call should be handled.",[35157,35160],false],[0,0,0,"buffer",null," io_uring will recv directly into this buffer",[35158,35159],false],[0,0,0,"group_id",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"buffer_selection",null," io_uring will select a buffer that has previously been provided with `provide_buffers`.\n The buffer group referenced by `group_id` must contain at least one buffer for the recv call to work.\n `len` controls the number of bytes to read into the selected buffer.",null,false],[352,533,0,null,null," Queues (but does not submit) an SQE to perform a `recv(2)`.\n Returns a pointer to the SQE.",[35162,35163,35164,35165,35166],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,556,0,null,null," Queues (but does not submit) an SQE to perform a `send(2)`.\n Returns a pointer to the SQE.",[35168,35169,35170,35171,35172],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,571,0,null,null," Queues (but does not submit) an SQE to perform a `recvmsg(2)`.\n Returns a pointer to the SQE.",[35174,35175,35176,35177,35178],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,586,0,null,null," Queues (but does not submit) an SQE to perform a `sendmsg(2)`.\n Returns a pointer to the SQE.",[35180,35181,35182,35183,35184],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,601,0,null,null," Queues (but does not submit) an SQE to perform an `openat(2)`.\n Returns a pointer to the SQE.",[35186,35187,35188,35189,35190,35191],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[352,617,0,null,null," Queues (but does not submit) an SQE to perform a `close(2)`.\n Returns a pointer to the SQE.",[35193,35194,35195],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[352,637,0,null,null," Queues (but does not submit) an SQE to register a timeout operation.\n Returns a pointer to the SQE.\n\n The timeout will complete when either the timeout expires, or after the specified number of\n events complete (if `count` is greater than `0`).\n\n `flags` may be `0` for a relative timeout, or `IORING_TIMEOUT_ABS` for an absolute timeout.\n\n The completion event result will be `-ETIME` if the timeout completed through expiration,\n `0` if the timeout completed after the specified number of events, or `-ECANCELED` if the\n timeout was removed before it expired.\n\n io_uring timeouts use the `CLOCK.MONOTONIC` clock source.",[35197,35198,35199,35200,35201],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"ts",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,658,0,null,null," Queues (but does not submit) an SQE to remove an existing timeout operation.\n Returns a pointer to the SQE.\n\n The timeout is identified by its `user_data`.\n\n The completion event result will be `0` if the timeout was found and cancelled successfully,\n `-EBUSY` if the timeout was found but expiration was already in progress, or\n `-ENOENT` if the timeout was not found.",[35203,35204,35205,35206],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"timeout_user_data",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,686,0,null,null," Queues (but does not submit) an SQE to add a link timeout operation.\n Returns a pointer to the SQE.\n\n You need to set linux.IOSQE_IO_LINK to flags of the target operation\n and then call this method right after the target operation.\n See https://lwn.net/Articles/803932/ for detail.\n\n If the dependent request finishes before the linked timeout, the timeout\n is canceled. If the timeout finishes before the dependent request, the\n dependent request will be canceled.\n\n The completion event result of the link_timeout will be\n `-ETIME` if the timeout finishes before the dependent request\n (in this case, the completion event result of the dependent request will\n be `-ECANCELED`), or\n `-EALREADY` if the dependent request finishes before the linked timeout.",[35208,35209,35210,35211],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"ts",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,700,0,null,null," Queues (but does not submit) an SQE to perform a `poll(2)`.\n Returns a pointer to the SQE.",[35213,35214,35215,35216],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"poll_mask",null,"",null,false],[352,714,0,null,null," Queues (but does not submit) an SQE to remove an existing poll operation.\n Returns a pointer to the SQE.",[35218,35219,35220],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"target_user_data",null,"",null,false],[352,727,0,null,null," Queues (but does not submit) an SQE to update the user data of an existing poll\n operation. Returns a pointer to the SQE.",[35222,35223,35224,35225,35226,35227],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"old_user_data",null,"",null,false],[0,0,0,"new_user_data",null,"",null,false],[0,0,0,"poll_mask",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,743,0,null,null," Queues (but does not submit) an SQE to perform an `fallocate(2)`.\n Returns a pointer to the SQE.",[35229,35230,35231,35232,35233,35234],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[352,759,0,null,null," Queues (but does not submit) an SQE to perform an `statx(2)`.\n Returns a pointer to the SQE.",[35236,35237,35238,35239,35240,35241,35242],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mask",null,"",null,false],[0,0,0,"buf",null,"",null,false],[352,782,0,null,null," Queues (but does not submit) an SQE to remove an existing operation.\n Returns a pointer to the SQE.\n\n The operation is identified by its `user_data`.\n\n The completion event result will be `0` if the operation was found and cancelled successfully,\n `-EALREADY` if the operation was found but was already in progress, or\n `-ENOENT` if the operation was not found.",[35244,35245,35246,35247],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"cancel_user_data",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,798,0,null,null," Queues (but does not submit) an SQE to perform a `shutdown(2)`.\n Returns a pointer to the SQE.\n\n The operation is identified by its `user_data`.",[35249,35250,35251,35252],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"how",null,"",null,false],[352,812,0,null,null," Queues (but does not submit) an SQE to perform a `renameat2(2)`.\n Returns a pointer to the SQE.",[35254,35255,35256,35257,35258,35259,35260],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,829,0,null,null," Queues (but does not submit) an SQE to perform a `unlinkat(2)`.\n Returns a pointer to the SQE.",[35262,35263,35264,35265,35266],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,844,0,null,null," Queues (but does not submit) an SQE to perform a `mkdirat(2)`.\n Returns a pointer to the SQE.",[35268,35269,35270,35271,35272],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[352,859,0,null,null," Queues (but does not submit) an SQE to perform a `symlinkat(2)`.\n Returns a pointer to the SQE.",[35274,35275,35276,35277,35278],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"target",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"link_path",null,"",null,false],[352,874,0,null,null," Queues (but does not submit) an SQE to perform a `linkat(2)`.\n Returns a pointer to the SQE.",[35280,35281,35282,35283,35284,35285,35286],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,895,0,null,null," Queues (but does not submit) an SQE to provide a group of buffers used for commands that read/receive data.\n Returns a pointer to the SQE.\n\n Provided buffers can be used in `read`, `recv` or `recvmsg` commands via .buffer_selection.\n\n The kernel expects a contiguous block of memory of size (buffers_count * buffer_size).",[35288,35289,35290,35291,35292,35293,35294],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"buffers",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffers_count",null,"",null,false],[0,0,0,"group_id",null,"",null,false],[0,0,0,"buffer_id",null,"",null,false],[352,912,0,null,null," Queues (but does not submit) an SQE to remove a group of provided buffers.\n Returns a pointer to the SQE.",[35296,35297,35298,35299],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null,"",null,false],[0,0,0,"buffers_count",null,"",null,false],[0,0,0,"group_id",null,"",null,false],[352,934,0,null,null," Registers an array of file descriptors.\n Every time a file descriptor is put in an SQE and submitted to the kernel, the kernel must\n retrieve a reference to the file, and once I/O has completed the file reference must be\n dropped. The atomic nature of this file reference can be a slowdown for high IOPS workloads.\n This slowdown can be avoided by pre-registering file descriptors.\n To refer to a registered file descriptor, IOSQE_FIXED_FILE must be set in the SQE's flags,\n and the SQE's fd must be set to the index of the file descriptor in the registered array.\n Registering file descriptors will wait for the ring to idle.\n Files are automatically unregistered by the kernel when the ring is torn down.\n An application need unregister only if it wants to register a new array of file descriptors.",[35301,35302],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fds",null,"",null,false],[352,953,0,null,null," Updates registered file descriptors.\n\n Updates are applied starting at the provided offset in the original file descriptors slice.\n There are three kind of updates:\n * turning a sparse entry (where the fd is -1) into a real one\n * removing an existing entry (set the fd to -1)\n * replacing an existing entry with a new fd\n Adding new file descriptors must be done with `register_files`.",[35304,35305,35306],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"fds",null,"",null,false],[352,979,0,null,null," Registers the file descriptor for an eventfd that will be notified of completion events on\n  an io_uring instance.\n Only a single a eventfd can be registered at any given point in time.",[35308,35309],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[352,994,0,null,null," Registers the file descriptor for an eventfd that will be notified of completion events on\n an io_uring instance. Notifications are only posted for events that complete in an async manner.\n This means that events that complete inline while being submitted do not trigger a notification event.\n Only a single eventfd can be registered at any given point in time.",[35311,35312],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fd",null,"",null,false],[352,1006,0,null,null," Unregister the registered eventfd file descriptor.",[35314],false],[0,0,0,"self",null,"",null,false],[352,1018,0,null,null," Registers an array of buffers for use with `read_fixed` and `write_fixed`.",[35316,35317],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffers",null,"",null,false],[352,1030,0,null,null," Unregister the registered buffers.",[35319],false],[0,0,0,"self",null,"",null,false],[352,1040,0,null,null,null,[35321],false],[0,0,0,"res",null,"",null,false],[352,1063,0,null,null," Unregisters all registered file descriptors previously associated with the ring.",[35323],false],[0,0,0,"self",null,"",null,false],[352,9,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[352,9,0,null,null,null,null,false],[0,0,0,"sq",null,null,null,false],[352,9,0,null,null,null,null,false],[0,0,0,"cq",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"features",null,null,null,false],[352,1074,0,null,null,null,[35339,35341,35342,35344,35346,35348,35350,35352,35354,35355,35356],false],[352,1092,0,null,null,null,[35334,35335],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"p",null,"",null,false],[352,1142,0,null,null,null,[35337],false],[0,0,0,"self",null,"",null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"head",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"tail",null,null,null,false],[0,0,0,"mask",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"dropped",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"array",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"sqes",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"mmap",null,null,null,false],[352,1074,0,null,null,null,null,false],[0,0,0,"mmap_sqes",null,null,null,false],[0,0,0,"sqe_head",null,null,null,false],[0,0,0,"sqe_tail",null,null,null,false],[352,1148,0,null,null,null,[35365,35367,35368,35370,35372],false],[352,1155,0,null,null,null,[35359,35360,35361],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"sq",null,"",null,false],[352,1170,0,null,null,null,[35363],false],[0,0,0,"self",null,"",null,false],[352,1148,0,null,null,null,null,false],[0,0,0,"head",null,null,null,false],[352,1148,0,null,null,null,null,false],[0,0,0,"tail",null,null,null,false],[0,0,0,"mask",null,null,null,false],[352,1148,0,null,null,null,null,false],[0,0,0,"overflow",null,null,null,false],[352,1148,0,null,null,null,null,false],[0,0,0,"cqes",null,null,null,false],[352,1177,0,null,null,null,[35374],false],[0,0,0,"sqe",null,"",null,false],[352,1195,0,null,null,null,[35376,35377,35378],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1213,0,null,null,null,[35380,35381,35382,35383,35384,35385],false],[0,0,0,"op",null,"",null,false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,1238,0,null,null,null,[35387,35388,35389,35390],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,1242,0,null,null,null,[35392,35393,35394,35395],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,1246,0,null,null,null,[35397,35398,35399,35400],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,1255,0,null,null,null,[35402,35403,35404,35405],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovecs",null,"",null,false],[0,0,0,"offset",null,"",null,false],[352,1264,0,null,null,null,[35407,35408,35409,35410,35411],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"buffer_index",null,"",null,false],[352,1269,0,null,null,null,[35413,35414,35415,35416,35417],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"buffer_index",null,"",null,false],[352,1280,0,null,null," Poll masks previously used to comprise of 16 bits in the flags union of\n a SQE, but were then extended to comprise of 32 bits in order to make\n room for additional option flags. To ensure that the correct bits of\n poll masks are consistently and properly read across multiple kernel\n versions, poll masks are enforced to be little-endian.\n https://www.spinics.net/lists/io-uring/msg02848.html",[35419],false],[0,0,0,"poll_mask",null,"",null,false],[352,1284,0,null,null,null,[35421,35422,35423,35424,35425],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1297,0,null,null,null,[35427,35428,35429,35430],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[352,1307,0,null,null,null,[35432,35433,35434,35435,35436],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"epfd",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"ev",null,"",null,false],[352,1317,0,null,null,null,[35438,35439,35440,35441],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1322,0,null,null,null,[35443,35444,35445,35446],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1327,0,null,null,null,[35448,35449,35450,35451],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1337,0,null,null,null,[35453,35454,35455,35456],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1347,0,null,null,null,[35458,35459,35460,35461,35462],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[352,1358,0,null,null,null,[35464,35465],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[352,1376,0,null,null,null,[35467,35468,35469,35470],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"ts",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1386,0,null,null,null,[35472,35473,35474],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"timeout_user_data",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1404,0,null,null,null,[35476,35477,35478],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"ts",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1413,0,null,null,null,[35480,35481,35482],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"poll_mask",null,"",null,false],[352,1422,0,null,null,null,[35484,35485],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"target_user_data",null,"",null,false],[352,1429,0,null,null,null,[35487,35488,35489,35490,35491],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"old_user_data",null,"",null,false],[0,0,0,"new_user_data",null,"",null,false],[0,0,0,"poll_mask",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1440,0,null,null,null,[35493,35494,35495,35496,35497],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[352,1464,0,null,null,null,[35499,35500,35501,35502,35503,35504],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mask",null,"",null,false],[0,0,0,"buf",null,"",null,false],[352,1476,0,null,null,null,[35506,35507,35508],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"cancel_user_data",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1485,0,null,null,null,[35510,35511,35512],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"how",null,"",null,false],[352,1493,0,null,null,null,[35514,35515,35516,35517,35518,35519],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1513,0,null,null,null,[35521,35522,35523,35524],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1523,0,null,null,null,[35526,35527,35528,35529],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[352,1532,0,null,null,null,[35531,35532,35533,35534],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"target",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"link_path",null,"",null,false],[352,1548,0,null,null,null,[35536,35537,35538,35539,35540,35541],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[352,1568,0,null,null,null,[35543,35544,35545,35546,35547,35548],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"buffers",null,"",null,false],[0,0,0,"buffer_len",null,"",null,false],[0,0,0,"num",null,"",null,false],[0,0,0,"group_id",null,"",null,false],[0,0,0,"buffer_id",null,"",null,false],[352,1581,0,null,null,null,[35550,35551,35552],false],[0,0,0,"sqe",null,"",null,false],[0,0,0,"num",null,"",null,false],[0,0,0,"group_id",null,"",null,false],[352,3236,0,null,null," Used for testing server/client interactions.",[35557,35559,35561],false],[352,3241,0,null,null,null,[35555],false],[0,0,0,"self",null,"",null,false],[352,3236,0,null,null,null,null,false],[0,0,0,"listener",null,null,null,false],[352,3236,0,null,null,null,null,false],[0,0,0,"server",null,null,null,false],[352,3236,0,null,null,null,null,false],[0,0,0,"client",null,null,null,false],[352,3247,0,null,null,null,[35563],false],[0,0,0,"ring",null,"",null,false],[351,156,0,null,null,null,null,false],[351,7,0,null,null,null,null,false],[351,8,0,null,null,null,null,false],[351,9,0,null,null,null,null,false],[351,10,0,null,null,null,null,false],[351,11,0,null,null,null,null,false],[351,12,0,null,null,null,null,false],[0,0,0,"linux/vdso.zig",null,"",[],false],[353,0,0,null,null,null,null,false],[353,1,0,null,null,null,null,false],[353,2,0,null,null,null,null,false],[353,3,0,null,null,null,null,false],[353,4,0,null,null,null,null,false],[353,6,0,null,null,null,[35578,35579],false],[0,0,0,"vername",null,"",null,false],[0,0,0,"name",null,"",null,false],[353,82,0,null,null,null,[35581,35582,35583,35584],false],[0,0,0,"def_arg",null,"",null,false],[0,0,0,"vsym_arg",null,"",null,false],[0,0,0,"vername",null,"",null,false],[0,0,0,"strings",null,"",null,false],[351,13,0,null,null,null,null,false],[351,14,0,null,null,null,null,false],[351,15,0,null,null,null,null,false],[351,16,0,null,null,null,null,false],[351,17,0,null,null,null,null,false],[351,18,0,null,null,null,null,false],[351,19,0,null,null,null,null,false],[351,20,0,null,null,null,null,false],[351,21,0,null,null,null,null,false],[351,29,0,null,null,null,null,false],[351,34,0,null,null,null,null,false],[351,47,0,null,null,null,null,false],[351,48,0,null,null,null,null,false],[351,49,0,null,null,null,null,false],[351,50,0,null,null,null,null,false],[351,51,0,null,null,null,null,false],[351,52,0,null,null,null,null,false],[351,53,0,null,null,null,null,false],[351,54,0,null,null,null,null,false],[351,55,0,null,null,null,null,false],[351,56,0,null,null,null,null,false],[351,57,0,null,null,null,null,false],[351,58,0,null,null,null,null,false],[351,59,0,null,null,null,null,false],[351,61,0,null,null,null,null,false],[351,62,0,null,null,null,null,false],[351,63,0,null,null,null,null,false],[351,64,0,null,null,null,null,false],[351,65,0,null,null,null,null,false],[351,66,0,null,null,null,null,false],[351,67,0,null,null,null,null,false],[351,68,0,null,null,null,null,false],[351,69,0,null,null,null,null,false],[351,70,0,null,null,null,null,false],[351,71,0,null,null,null,null,false],[351,72,0,null,null,null,null,false],[351,73,0,null,null,null,null,false],[351,74,0,null,null,null,null,false],[351,75,0,null,null,null,null,false],[351,76,0,null,null,null,null,false],[351,77,0,null,null,null,null,false],[351,78,0,null,null,null,null,false],[351,79,0,null,null,null,null,false],[351,80,0,null,null,null,null,false],[351,81,0,null,null,null,null,false],[351,82,0,null,null,null,null,false],[351,83,0,null,null,null,null,false],[351,84,0,null,null,null,null,false],[351,85,0,null,null,null,null,false],[351,86,0,null,null,null,null,false],[351,87,0,null,null,null,null,false],[351,88,0,null,null,null,null,false],[351,90,0,null,null,null,null,false],[0,0,0,"linux/tls.zig",null,"",[],false],[354,0,0,null,null,null,null,false],[354,1,0,null,null,null,null,false],[354,2,0,null,null,null,null,false],[354,3,0,null,null,null,null,false],[354,4,0,null,null,null,null,false],[354,5,0,null,null,null,null,false],[354,6,0,null,null,null,null,false],[354,44,0,null,null,null,[35647,35648],false],[0,0,0,"VariantI",null,null,null,false],[0,0,0,"VariantII",null,null,null,false],[354,49,0,null,null,null,null,false],[354,56,0,null,null,null,null,false],[354,65,0,null,null,null,null,false],[354,73,0,null,null,null,null,false],[354,78,0,null,null,null,null,false],[354,85,0,null,null,null,[35655],false],[0,0,0,"dummy",null,null,null,false],[354,90,0,null,null,null,[35657,35659],false],[0,0,0,"entries",null,null,null,false],[354,90,0,null,null,null,null,false],[0,0,0,"tls_block",null,null,null,false],[354,96,0,null,null,null,[35662,35663,35664,35665,35666,35667,35668,35669],false],[354,96,0,null,null,null,null,false],[0,0,0,"init_data",null,null,null,false],[0,0,0,"alloc_size",null,null,null,false],[0,0,0,"alloc_align",null,null,null,false],[0,0,0,"tcb_offset",null,null,null,false],[0,0,0,"dtv_offset",null,null,null,false],[0,0,0,"data_offset",null,null,null,false],[0,0,0,"data_size",null,null,null,false],[0,0,0,"gdt_entry_number",null,null,null,false],[354,108,0,null,null,null,null,false],[354,110,0,null,null,null,[35672],false],[0,0,0,"addr",null,"",null,false],[354,189,0,null,null,null,[35674],false],[0,0,0,"phdrs",null,"",null,false],[354,271,0,null,null,null,[35676,35677],false],[0,0,0,"T",null,"",null,true],[0,0,0,"ptr",null,"",null,false],[354,277,0,null,null," Initializes all the fields of the static TLS area and returns the computed\n architecture-specific value of the thread-pointer register",[35679],false],[0,0,0,"area",null,"",null,false],[354,308,0,null,null,null,null,false],[354,310,0,null,null,null,[35682],false],[0,0,0,"phdrs",null,"",null,false],[351,91,0,null,null,null,null,false],[0,0,0,"linux/start_pie.zig",null,"",[],false],[355,0,0,null,null,null,null,false],[355,1,0,null,null,null,null,false],[355,2,0,null,null,null,null,false],[355,3,0,null,null,null,null,false],[355,5,0,null,null,null,null,false],[355,6,0,null,null,null,null,false],[355,7,0,null,null,null,null,false],[355,8,0,null,null,null,null,false],[355,9,0,null,null,null,null,false],[355,10,0,null,null,null,null,false],[355,12,0,null,null,null,null,false],[355,24,0,null,null,null,[],false],[355,71,0,null,null,null,[35698],false],[0,0,0,"phdrs",null,"",null,false],[351,92,0,null,null,null,null,false],[0,0,0,"linux/bpf.zig",null,"",[],false],[356,0,0,null,null,null,null,false],[356,1,0,null,null,null,null,false],[356,2,0,null,null,null,null,false],[356,3,0,null,null,null,null,false],[356,4,0,null,null,null,null,false],[356,5,0,null,null,null,null,false],[356,7,0,null,null,null,null,false],[356,8,0,null,null,null,null,false],[356,9,0,null,null,null,null,false],[356,10,0,null,null,null,null,false],[356,12,0,null,null,null,null,false],[0,0,0,"bpf/btf.zig",null,"",[],false],[357,0,0,null,null,null,null,false],[357,2,0,null,null,null,null,false],[357,3,0,null,null,null,null,false],[357,5,0,null,null,null,null,false],[0,0,0,"btf_ext.zig",null,"",[],false],[358,0,0,null,null,null,[35719,35720,35721,35722,35723,35724,35725,35726],false],[0,0,0,"magic",null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"hdr_len",null,null,null,false],[0,0,0,"func_info_off",null," All offsets are in bytes relative to the end of this header",null,false],[0,0,0,"func_info_len",null,null,null,false],[0,0,0,"line_info_off",null,null,null,false],[0,0,0,"line_info_len",null,null,null,false],[358,13,0,null,null,null,[35728,35729],false],[0,0,0,"sec_name_off",null,null,null,false],[0,0,0,"num_info",null,null,null,false],[357,8,0,null,null," All offsets are in bytes relative to the end of this header",[35731,35732,35733,35734,35735,35736,35737,35738],false],[0,0,0,"magic",null,null,null,false],[0,0,0,"version",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"hdr_len",null,null,null,false],[0,0,0,"type_off",null," offset of type section",null,false],[0,0,0,"type_len",null," length of type section",null,false],[0,0,0,"str_off",null," offset of string section",null,false],[0,0,0,"str_len",null," length of string section",null,false],[357,28,0,null,null," Max number of type identifiers",null,false],[357,31,0,null,null," Max offset into string section",null,false],[357,34,0,null,null," Max number of struct/union/enum member of func args",null,false],[357,36,0,null,null,null,[35743,35752,35756],false],[0,0,0,"name_off",null,null,null,false],[357,36,0,null,null,null,[35745,35746,35748,35750,35751],false],[0,0,0,"vlen",null," number of struct's members",null,false],[0,0,0,"unused_1",null,null,null,false],[357,38,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[357,38,0,null,null,null,null,false],[0,0,0,"unused_2",null,null,null,false],[0,0,0,"kind_flag",null," used by Struct, Union, and Fwd",null,false],[0,0,0,"info",null,null,null,false],[357,36,0,null,null,null,[35754,35755],false],[0,0,0,"size",null,null,null,false],[0,0,0,"typ",null,null,null,false],[0,0,0,"size_type",null," size is used by Int, Enum, Struct, Union, and DataSec, it tells the size\n of the type it is describing\n\n type is used by Ptr, Typedef, Volatile, Const, Restrict, Func,\n FuncProto, and Var. It is a type_id referring to another type",null,false],[357,59,0,null,null," For some kinds, Type is immediately followed by extra data",[35758,35759,35760,35761,35762,35763,35764,35765,35766,35767,35768,35769,35770,35771,35772,35773,35774,35775,35776,35777],false],[0,0,0,"unknown",null,null,null,false],[0,0,0,"int",null,null,null,false],[0,0,0,"ptr",null,null,null,false],[0,0,0,"array",null,null,null,false],[0,0,0,"struct",null,null,null,false],[0,0,0,"union",null,null,null,false],[0,0,0,"enum",null,null,null,false],[0,0,0,"fwd",null,null,null,false],[0,0,0,"typedef",null,null,null,false],[0,0,0,"volatile",null,null,null,false],[0,0,0,"const",null,null,null,false],[0,0,0,"restrict",null,null,null,false],[0,0,0,"func",null,null,null,false],[0,0,0,"func_proto",null,null,null,false],[0,0,0,"var",null,null,null,false],[0,0,0,"datasec",null,null,null,false],[0,0,0,"float",null,null,null,false],[0,0,0,"decl_tag",null,null,null,false],[0,0,0,"type_tag",null,null,null,false],[0,0,0,"enum64",null,null,null,false],[357,83,0,null,null," int kind is followed by this struct",[35779,35780,35781,35786],false],[0,0,0,"bits",null,null,null,false],[0,0,0,"unused",null,null,null,false],[0,0,0,"offset",null,null,null,false],[357,83,0,null,null,null,[35783,35784,35785],false],[0,0,0,"signed",null,null,null,false],[0,0,0,"char",null,null,null,false],[0,0,0,"boolean",null,null,null,false],[0,0,0,"encoding",null,null,null,false],[357,99,0,null,null," enum kind is followed by this struct",[35788,35789],false],[0,0,0,"name_off",null,null,null,false],[0,0,0,"val",null,null,null,false],[357,105,0,null,null," enum64 kind is followed by this struct",[35791,35792,35793],false],[0,0,0,"name_off",null,null,null,false],[0,0,0,"val_lo32",null,null,null,false],[0,0,0,"val_hi32",null,null,null,false],[357,112,0,null,null," array kind is followed by this struct",[35795,35796,35797],false],[0,0,0,"typ",null,null,null,false],[0,0,0,"index_type",null,null,null,false],[0,0,0,"nelems",null,null,null,false],[357,120,0,null,null," struct and union kinds are followed by multiple Member structs. The exact\n number is stored in vlen",[35799,35800,35805],false],[0,0,0,"name_off",null,null,null,false],[0,0,0,"typ",null,null,null,false],[357,120,0,null,null,null,[35803,35804],false],[357,127,0,null,null,null,null,false],[0,0,0,"bit",null,null,null,false],[0,0,0,"bitfield_size",null,null,null,false],[0,0,0,"offset",null," if the kind_flag is set, offset contains both member bitfield size and\n bit offset, the bitfield size is set for bitfield members. If the type\n info kind_flag is not set, the offset contains only bit offset",null,false],[357,134,0,null,null," func_proto is followed by multiple Params, the exact number is stored in vlen",[35807,35808],false],[0,0,0,"name_off",null,null,null,false],[0,0,0,"typ",null,null,null,false],[357,139,0,null,null,null,[35810,35811,35812],false],[0,0,0,"static",null,null,null,false],[0,0,0,"global_allocated",null,null,null,false],[0,0,0,"global_extern",null,null,null,false],[357,145,0,null,null,null,[35814,35815,35816],false],[0,0,0,"static",null,null,null,false],[0,0,0,"global",null,null,null,false],[0,0,0,"external",null,null,null,false],[357,153,0,null,null," var kind is followed by a single Var struct to describe additional\n information related to the variable such as its linkage",[35818],false],[0,0,0,"linkage",null,null,null,false],[357,159,0,null,null," datasec kind is followed by multiple VarSecInfo to describe all Var kind\n types it contains along with it's in-section offset as well as size.",[35820,35821,35822],false],[0,0,0,"typ",null,null,null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"size",null,null,null,false],[357,171,0,null,null,null,[35824],false],[0,0,0,"component_idx",null,null,null,false],[356,13,0,null,null,null,null,false],[0,0,0,"bpf/kern.zig",null,"",[],false],[359,0,0,null,null,null,null,false],[359,1,0,null,null,null,null,false],[359,3,0,null,null,null,null,false],[359,8,0,null,null,null,null,false],[359,10,0,null,null,null,null,false],[359,11,0,null,null,null,null,false],[359,12,0,null,null,null,null,false],[359,13,0,null,null,null,null,false],[359,14,0,null,null,null,null,false],[359,15,0,null,null,null,null,false],[359,16,0,null,null,null,null,false],[359,17,0,null,null,null,null,false],[359,18,0,null,null,null,null,false],[359,19,0,null,null,null,null,false],[359,20,0,null,null,null,null,false],[359,21,0,null,null,null,null,false],[359,22,0,null,null,null,null,false],[359,23,0,null,null,null,null,false],[359,24,0,null,null,null,null,false],[359,25,0,null,null,null,null,false],[359,26,0,null,null,null,null,false],[359,27,0,null,null,null,null,false],[359,28,0,null,null,null,null,false],[359,29,0,null,null,null,null,false],[359,30,0,null,null,null,null,false],[359,31,0,null,null,null,null,false],[359,32,0,null,null,null,null,false],[359,33,0,null,null,null,null,false],[359,34,0,null,null,null,null,false],[356,16,0,null,null,null,null,false],[356,17,0,null,null,null,null,false],[356,18,0,null,null,null,null,false],[356,19,0,null,null,null,null,false],[356,20,0,null,null,null,null,false],[356,21,0,null,null,null,null,false],[356,22,0,null,null,null,null,false],[356,23,0,null,null,null,null,false],[356,26,0,null,null," 32-bit",null,false],[356,28,0,null,null," 16-bit",null,false],[356,30,0,null,null," 8-bit",null,false],[356,32,0,null,null," 64-bit",null,false],[356,34,0,null,null,null,null,false],[356,35,0,null,null,null,null,false],[356,36,0,null,null,null,null,false],[356,37,0,null,null,null,null,false],[356,38,0,null,null,null,null,false],[356,39,0,null,null,null,null,false],[356,42,0,null,null,null,null,false],[356,43,0,null,null,null,null,false],[356,44,0,null,null,null,null,false],[356,45,0,null,null,null,null,false],[356,46,0,null,null,null,null,false],[356,47,0,null,null,null,null,false],[356,48,0,null,null,null,null,false],[356,49,0,null,null,null,null,false],[356,50,0,null,null,null,null,false],[356,51,0,null,null,null,null,false],[356,52,0,null,null,null,null,false],[356,55,0,null,null,null,null,false],[356,56,0,null,null,null,null,false],[356,57,0,null,null,null,null,false],[356,58,0,null,null,null,null,false],[356,59,0,null,null,null,null,false],[356,62,0,null,null,null,null,false],[356,63,0,null,null,null,null,false],[356,65,0,null,null,null,null,false],[356,69,0,null,null," jmp mode in word width",null,false],[356,72,0,null,null," alu mode in double word width",null,false],[356,76,0,null,null," exclusive add",null,false],[356,80,0,null,null," mov reg to reg",null,false],[356,83,0,null,null," sign extending arithmetic shift right */",null,false],[356,87,0,null,null," flags for endianness conversion:",null,false],[356,90,0,null,null," convert to little-endian */",null,false],[356,93,0,null,null," convert to big-endian",null,false],[356,94,0,null,null,null,null,false],[356,95,0,null,null,null,null,false],[356,99,0,null,null," jump != *",null,false],[356,102,0,null,null," LT is unsigned, '<'",null,false],[356,105,0,null,null," LE is unsigned, '<=' *",null,false],[356,108,0,null,null," SGT is signed '>', GT in x86",null,false],[356,111,0,null,null," SGE is signed '>=', GE in x86",null,false],[356,114,0,null,null," SLT is signed, '<'",null,false],[356,117,0,null,null," SLE is signed, '<='",null,false],[356,120,0,null,null," function call",null,false],[356,123,0,null,null," function return",null,false],[356,127,0,null,null," Flag for prog_attach command. If a sub-cgroup installs some bpf program, the\n program in this cgroup yields to sub-cgroup program.",null,false],[356,131,0,null,null," Flag for prog_attach command. If a sub-cgroup installs some bpf program,\n that cgroup program gets run in addition to the program in this cgroup.",null,false],[356,134,0,null,null," Flag for prog_attach command.",null,false],[356,139,0,null,null," If BPF_F_STRICT_ALIGNMENT is used in BPF_PROG_LOAD command, the verifier\n will perform strict alignment checking as if the kernel has been built with\n CONFIG_EFFICIENT_UNALIGNED_ACCESS not set, and NET_IP_ALIGN defined to 2.",null,false],[356,150,0,null,null," If BPF_F_ANY_ALIGNMENT is used in BPF_PROF_LOAD command, the verifier will\n allow any alignment whatsoever.  On platforms with strict alignment\n requirements for loads ands stores (such as sparc and mips) the verifier\n validates that all loads and stores provably follow this requirement.  This\n flag turns that checking and enforcement off.\n\n It is mostly used for testing when we want to validate the context and\n memory access aspects of the verifier, but because of an unaligned access\n the alignment check would trigger before the one we are interested in.",null,false],[356,167,0,null,null," BPF_F_TEST_RND_HI32 is used in BPF_PROG_LOAD command for testing purpose.\n Verifier does sub-register def/use analysis and identifies instructions\n whose def only matters for low 32-bit, high 32-bit is never referenced later\n through implicit zero extension. Therefore verifier notifies JIT back-ends\n that it is safe to ignore clearing high 32-bit for these instructions. This\n saves some back-ends a lot of code-gen. However such optimization is not\n necessary on some arches, for example x86_64, arm64 etc, whose JIT back-ends\n hence hasn't used verifier's analysis result. But, we really want to have a\n way to be able to verify the correctness of the described optimization on\n x86_64 on which testsuites are frequently exercised.\n\n So, this flag is introduced. Once it is set, verifier will randomize high\n 32-bit for those instructions who has been identified as safe to ignore\n them.  Then, if verifier is not doing correct analysis, such randomization\n will regress tests to expose bugs.",null,false],[356,174,0,null,null," If BPF_F_SLEEPABLE is used in BPF_PROG_LOAD command, the verifier will\n restrict map and helper usage for such programs. Sleepable BPF programs can\n only be attached to hooks where kernel execution context allows sleeping.\n Such programs are allowed to use helpers that may sleep like\n bpf_copy_from_user().",null,false],[356,184,0,null,null," When BPF ldimm64's insn[0].src_reg != 0 then this can have two extensions:\n insn[0].src_reg:  BPF_PSEUDO_MAP_FD   BPF_PSEUDO_MAP_VALUE\n insn[0].imm:      map fd              map fd\n insn[1].imm:      0                   offset into value\n insn[0].off:      0                   0\n insn[1].off:      0                   0\n ldimm64 rewrite:  address of map      address of map[0]+offset\n verifier type:    CONST_PTR_TO_MAP    PTR_TO_MAP_VALUE",null,false],[356,185,0,null,null,null,null,false],[356,189,0,null,null," when bpf_call->src_reg == BPF_PSEUDO_CALL, bpf_call->imm == pc-relative\n offset to another bpf function",null,false],[356,192,0,null,null," flag for BPF_MAP_UPDATE_ELEM command. create new element or update existing",null,false],[356,195,0,null,null," flag for BPF_MAP_UPDATE_ELEM command. create new element if it didn't exist",null,false],[356,198,0,null,null," flag for BPF_MAP_UPDATE_ELEM command. update existing element",null,false],[356,201,0,null,null," flag for BPF_MAP_UPDATE_ELEM command. spin_lock-ed map_lookup/map_update",null,false],[356,204,0,null,null," flag for BPF_MAP_CREATE command */",null,false],[356,210,0,null,null," flag for BPF_MAP_CREATE command. Instead of having one common LRU list in\n the BPF_MAP_TYPE_LRU_[PERCPU_]HASH map, use a percpu LRU list which can\n scale and perform better.  Note, the LRU nodes (including free nodes) cannot\n be moved across different LRU lists.",null,false],[356,213,0,null,null," flag for BPF_MAP_CREATE command. Specify numa node during map creation",null,false],[356,217,0,null,null," flag for BPF_MAP_CREATE command. Flags for BPF object read access from\n syscall side",null,false],[356,221,0,null,null," flag for BPF_MAP_CREATE command. Flags for BPF object write access from\n syscall side",null,false],[356,225,0,null,null," flag for BPF_MAP_CREATE command. Flag for stack_map, store build_id+offset\n instead of pointer",null,false],[356,229,0,null,null," flag for BPF_MAP_CREATE command. Zero-initialize hash function seed. This\n should only be used for testing.",null,false],[356,233,0,null,null," flag for BPF_MAP_CREATE command Flags for accessing BPF object from program\n side.",null,false],[356,237,0,null,null," flag for BPF_MAP_CREATE command. Flags for accessing BPF object from program\n side.",null,false],[356,241,0,null,null," flag for BPF_MAP_CREATE command. Clone map from listener for newly accepted\n socket",null,false],[356,244,0,null,null," flag for BPF_MAP_CREATE command. Enable memory-mapping BPF map",null,false],[356,248,0,null,null," These values correspond to \"syscalls\" within the BPF program's environment,\n each one is documented in std.os.linux.BPF.kern",[35938,35939,35940,35941,35942,35943,35944,35945,35946,35947,35948,35949,35950,35951,35952,35953,35954,35955,35956,35957,35958,35959,35960,35961,35962,35963,35964,35965,35966,35967,35968,35969,35970,35971,35972,35973,35974,35975,35976,35977,35978,35979,35980,35981,35982,35983,35984,35985,35986,35987,35988,35989,35990,35991,35992,35993,35994,35995,35996,35997,35998,35999,36000,36001,36002,36003,36004,36005,36006,36007,36008,36009,36010,36011,36012,36013,36014,36015,36016,36017,36018,36019,36020,36021,36022,36023,36024,36025,36026,36027,36028,36029,36030,36031,36032,36033,36034,36035,36036,36037,36038,36039,36040,36041,36042,36043,36044,36045,36046,36047,36048,36049,36050,36051,36052,36053,36054,36055,36056,36057,36058,36059,36060,36061,36062,36063,36064,36065,36066,36067,36068,36069,36070,36071,36072,36073,36074,36075,36076,36077,36078,36079],false],[0,0,0,"unspec",null,null,null,false],[0,0,0,"map_lookup_elem",null,null,null,false],[0,0,0,"map_update_elem",null,null,null,false],[0,0,0,"map_delete_elem",null,null,null,false],[0,0,0,"probe_read",null,null,null,false],[0,0,0,"ktime_get_ns",null,null,null,false],[0,0,0,"trace_printk",null,null,null,false],[0,0,0,"get_prandom_u32",null,null,null,false],[0,0,0,"get_smp_processor_id",null,null,null,false],[0,0,0,"skb_store_bytes",null,null,null,false],[0,0,0,"l3_csum_replace",null,null,null,false],[0,0,0,"l4_csum_replace",null,null,null,false],[0,0,0,"tail_call",null,null,null,false],[0,0,0,"clone_redirect",null,null,null,false],[0,0,0,"get_current_pid_tgid",null,null,null,false],[0,0,0,"get_current_uid_gid",null,null,null,false],[0,0,0,"get_current_comm",null,null,null,false],[0,0,0,"get_cgroup_classid",null,null,null,false],[0,0,0,"skb_vlan_push",null,null,null,false],[0,0,0,"skb_vlan_pop",null,null,null,false],[0,0,0,"skb_get_tunnel_key",null,null,null,false],[0,0,0,"skb_set_tunnel_key",null,null,null,false],[0,0,0,"perf_event_read",null,null,null,false],[0,0,0,"redirect",null,null,null,false],[0,0,0,"get_route_realm",null,null,null,false],[0,0,0,"perf_event_output",null,null,null,false],[0,0,0,"skb_load_bytes",null,null,null,false],[0,0,0,"get_stackid",null,null,null,false],[0,0,0,"csum_diff",null,null,null,false],[0,0,0,"skb_get_tunnel_opt",null,null,null,false],[0,0,0,"skb_set_tunnel_opt",null,null,null,false],[0,0,0,"skb_change_proto",null,null,null,false],[0,0,0,"skb_change_type",null,null,null,false],[0,0,0,"skb_under_cgroup",null,null,null,false],[0,0,0,"get_hash_recalc",null,null,null,false],[0,0,0,"get_current_task",null,null,null,false],[0,0,0,"probe_write_user",null,null,null,false],[0,0,0,"current_task_under_cgroup",null,null,null,false],[0,0,0,"skb_change_tail",null,null,null,false],[0,0,0,"skb_pull_data",null,null,null,false],[0,0,0,"csum_update",null,null,null,false],[0,0,0,"set_hash_invalid",null,null,null,false],[0,0,0,"get_numa_node_id",null,null,null,false],[0,0,0,"skb_change_head",null,null,null,false],[0,0,0,"xdp_adjust_head",null,null,null,false],[0,0,0,"probe_read_str",null,null,null,false],[0,0,0,"get_socket_cookie",null,null,null,false],[0,0,0,"get_socket_uid",null,null,null,false],[0,0,0,"set_hash",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"skb_adjust_room",null,null,null,false],[0,0,0,"redirect_map",null,null,null,false],[0,0,0,"sk_redirect_map",null,null,null,false],[0,0,0,"sock_map_update",null,null,null,false],[0,0,0,"xdp_adjust_meta",null,null,null,false],[0,0,0,"perf_event_read_value",null,null,null,false],[0,0,0,"perf_prog_read_value",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"override_return",null,null,null,false],[0,0,0,"sock_ops_cb_flags_set",null,null,null,false],[0,0,0,"msg_redirect_map",null,null,null,false],[0,0,0,"msg_apply_bytes",null,null,null,false],[0,0,0,"msg_cork_bytes",null,null,null,false],[0,0,0,"msg_pull_data",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"xdp_adjust_tail",null,null,null,false],[0,0,0,"skb_get_xfrm_state",null,null,null,false],[0,0,0,"get_stack",null,null,null,false],[0,0,0,"skb_load_bytes_relative",null,null,null,false],[0,0,0,"fib_lookup",null,null,null,false],[0,0,0,"sock_hash_update",null,null,null,false],[0,0,0,"msg_redirect_hash",null,null,null,false],[0,0,0,"sk_redirect_hash",null,null,null,false],[0,0,0,"lwt_push_encap",null,null,null,false],[0,0,0,"lwt_seg6_store_bytes",null,null,null,false],[0,0,0,"lwt_seg6_adjust_srh",null,null,null,false],[0,0,0,"lwt_seg6_action",null,null,null,false],[0,0,0,"rc_repeat",null,null,null,false],[0,0,0,"rc_keydown",null,null,null,false],[0,0,0,"skb_cgroup_id",null,null,null,false],[0,0,0,"get_current_cgroup_id",null,null,null,false],[0,0,0,"get_local_storage",null,null,null,false],[0,0,0,"sk_select_reuseport",null,null,null,false],[0,0,0,"skb_ancestor_cgroup_id",null,null,null,false],[0,0,0,"sk_lookup_tcp",null,null,null,false],[0,0,0,"sk_lookup_udp",null,null,null,false],[0,0,0,"sk_release",null,null,null,false],[0,0,0,"map_push_elem",null,null,null,false],[0,0,0,"map_pop_elem",null,null,null,false],[0,0,0,"map_peek_elem",null,null,null,false],[0,0,0,"msg_push_data",null,null,null,false],[0,0,0,"msg_pop_data",null,null,null,false],[0,0,0,"rc_pointer_rel",null,null,null,false],[0,0,0,"spin_lock",null,null,null,false],[0,0,0,"spin_unlock",null,null,null,false],[0,0,0,"sk_fullsock",null,null,null,false],[0,0,0,"tcp_sock",null,null,null,false],[0,0,0,"skb_ecn_set_ce",null,null,null,false],[0,0,0,"get_listener_sock",null,null,null,false],[0,0,0,"skc_lookup_tcp",null,null,null,false],[0,0,0,"tcp_check_syncookie",null,null,null,false],[0,0,0,"sysctl_get_name",null,null,null,false],[0,0,0,"sysctl_get_current_value",null,null,null,false],[0,0,0,"sysctl_get_new_value",null,null,null,false],[0,0,0,"sysctl_set_new_value",null,null,null,false],[0,0,0,"strtol",null,null,null,false],[0,0,0,"strtoul",null,null,null,false],[0,0,0,"sk_storage_get",null,null,null,false],[0,0,0,"sk_storage_delete",null,null,null,false],[0,0,0,"send_signal",null,null,null,false],[0,0,0,"tcp_gen_syncookie",null,null,null,false],[0,0,0,"skb_output",null,null,null,false],[0,0,0,"probe_read_user",null,null,null,false],[0,0,0,"probe_read_kernel",null,null,null,false],[0,0,0,"probe_read_user_str",null,null,null,false],[0,0,0,"probe_read_kernel_str",null,null,null,false],[0,0,0,"tcp_send_ack",null,null,null,false],[0,0,0,"send_signal_thread",null,null,null,false],[0,0,0,"jiffies64",null,null,null,false],[0,0,0,"read_branch_records",null,null,null,false],[0,0,0,"get_ns_current_pid_tgid",null,null,null,false],[0,0,0,"xdp_output",null,null,null,false],[0,0,0,"get_netns_cookie",null,null,null,false],[0,0,0,"get_current_ancestor_cgroup_id",null,null,null,false],[0,0,0,"sk_assign",null,null,null,false],[0,0,0,"ktime_get_boot_ns",null,null,null,false],[0,0,0,"seq_printf",null,null,null,false],[0,0,0,"seq_write",null,null,null,false],[0,0,0,"sk_cgroup_id",null,null,null,false],[0,0,0,"sk_ancestor_cgroup_id",null,null,null,false],[0,0,0,"ringbuf_output",null,null,null,false],[0,0,0,"ringbuf_reserve",null,null,null,false],[0,0,0,"ringbuf_submit",null,null,null,false],[0,0,0,"ringbuf_discard",null,null,null,false],[0,0,0,"ringbuf_query",null,null,null,false],[0,0,0,"csum_level",null,null,null,false],[0,0,0,"skc_to_tcp6_sock",null,null,null,false],[0,0,0,"skc_to_tcp_sock",null,null,null,false],[0,0,0,"skc_to_tcp_timewait_sock",null,null,null,false],[0,0,0,"skc_to_tcp_request_sock",null,null,null,false],[0,0,0,"skc_to_udp6_sock",null,null,null,false],[0,0,0,"get_task_stack",null,null,null,false],[356,397,0,null,null," a single BPF instruction",[36300,36302,36304,36305,36306],false],[356,406,0,null,null," r0 - r9 are general purpose 64-bit registers, r10 points to the stack\n frame",[36082,36083,36084,36085,36086,36087,36088,36089,36090,36091,36092],false],[0,0,0,"r0",null,null,null,false],[0,0,0,"r1",null,null,null,false],[0,0,0,"r2",null,null,null,false],[0,0,0,"r3",null,null,null,false],[0,0,0,"r4",null,null,null,false],[0,0,0,"r5",null,null,null,false],[0,0,0,"r6",null,null,null,false],[0,0,0,"r7",null,null,null,false],[0,0,0,"r8",null,null,null,false],[0,0,0,"r9",null,null,null,false],[0,0,0,"r10",null,null,null,false],[356,407,0,null,null,null,[36094,36095],false],[0,0,0,"reg",null,null,null,false],[0,0,0,"imm",null,null,null,false],[356,409,0,null,null,null,[36097,36098,36099,36100,36101,36102],false],[0,0,0,"imm",null,null,null,false],[0,0,0,"abs",null,null,null,false],[0,0,0,"ind",null,null,null,false],[0,0,0,"mem",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"msh",null,null,null,false],[356,418,0,null,null,null,[36104,36105,36106,36107,36108,36109,36110,36111,36112,36113,36114,36115,36116],false],[0,0,0,"add",null,null,null,false],[0,0,0,"sub",null,null,null,false],[0,0,0,"mul",null,null,null,false],[0,0,0,"div",null,null,null,false],[0,0,0,"alu_or",null,null,null,false],[0,0,0,"alu_and",null,null,null,false],[0,0,0,"lsh",null,null,null,false],[0,0,0,"rsh",null,null,null,false],[0,0,0,"neg",null,null,null,false],[0,0,0,"mod",null,null,null,false],[0,0,0,"xor",null,null,null,false],[0,0,0,"mov",null,null,null,false],[0,0,0,"arsh",null,null,null,false],[356,434,0,null,null,null,[36118,36119,36120,36121],false],[0,0,0,"byte",null,null,null,false],[0,0,0,"half_word",null,null,null,false],[0,0,0,"word",null,null,null,false],[0,0,0,"double_word",null,null,null,false],[356,441,0,null,null,null,[36123,36124,36125,36126,36127,36128,36129,36130,36131,36132,36133,36134],false],[0,0,0,"ja",null,null,null,false],[0,0,0,"jeq",null,null,null,false],[0,0,0,"jgt",null,null,null,false],[0,0,0,"jge",null,null,null,false],[0,0,0,"jset",null,null,null,false],[0,0,0,"jlt",null,null,null,false],[0,0,0,"jle",null,null,null,false],[0,0,0,"jne",null,null,null,false],[0,0,0,"jsgt",null,null,null,false],[0,0,0,"jsge",null,null,null,false],[0,0,0,"jslt",null,null,null,false],[0,0,0,"jsle",null,null,null,false],[356,456,0,null,null,null,[36136,36137],false],[0,0,0,"reg",null,null,null,false],[0,0,0,"imm",null,null,null,false],[356,461,0,null,null,null,[36139,36140,36141,36142],false],[0,0,0,"code",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,487,0,null,null,null,[36144,36145,36146,36147],false],[0,0,0,"width",null,"",null,true],[0,0,0,"op",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,497,0,null,null,null,[36149,36150],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,501,0,null,null,null,[36152,36153],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,505,0,null,null,null,[36155,36156],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,509,0,null,null,null,[36158,36159],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,513,0,null,null,null,[36161,36162],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,517,0,null,null,null,[36164,36165],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,521,0,null,null,null,[36167,36168],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,525,0,null,null,null,[36170,36171],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,529,0,null,null,null,[36173,36174],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,533,0,null,null,null,[36176],false],[0,0,0,"dst",null,"",null,false],[356,537,0,null,null,null,[36178,36179],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,541,0,null,null,null,[36181,36182],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,545,0,null,null,null,[36184,36185],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,549,0,null,null,null,[36187,36188,36189,36190],false],[0,0,0,"op",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,553,0,null,null,null,[36192],false],[0,0,0,"off",null,"",null,false],[356,557,0,null,null,null,[36194,36195,36196],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,561,0,null,null,null,[36198,36199,36200],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,565,0,null,null,null,[36202,36203,36204],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,569,0,null,null,null,[36206,36207,36208],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,573,0,null,null,null,[36210,36211,36212],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,577,0,null,null,null,[36214,36215,36216],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,581,0,null,null,null,[36218,36219,36220],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,585,0,null,null,null,[36222,36223,36224],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,589,0,null,null,null,[36226,36227,36228],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,593,0,null,null,null,[36230,36231,36232],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,597,0,null,null,null,[36234,36235,36236],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,601,0,null,null,null,[36238,36239],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,611,0,null,null,null,[36241,36242,36243,36244,36245],false],[0,0,0,"mode",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"imm",null,"",null,false],[356,621,0,null,null,null,[36247,36248,36249,36250],false],[0,0,0,"size",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"imm",null,"",null,false],[356,625,0,null,null,null,[36252,36253,36254,36255],false],[0,0,0,"size",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"imm",null,"",null,false],[356,629,0,null,null,null,[36257,36258,36259,36260],false],[0,0,0,"size",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"off",null,"",null,false],[356,639,0,null,null,null,[36262,36263,36264],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"imm",null,"",null,false],[356,649,0,null,null,null,[36266],false],[0,0,0,"imm",null,"",null,false],[356,659,0,null,null,null,[36268,36269],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"imm",null,"",null,false],[356,663,0,null,null,null,[36271],false],[0,0,0,"imm",null,"",null,false],[356,667,0,null,null,null,[36273,36274],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"map_fd",null,"",null,false],[356,671,0,null,null,null,[36276],false],[0,0,0,"map_fd",null,"",null,false],[356,675,0,null,null,null,[36278,36279,36280,36281],false],[0,0,0,"size",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"off",null,"",null,false],[0,0,0,"imm",null,"",null,false],[356,685,0,null,null,null,[36283,36284,36285,36286],false],[0,0,0,"size",null,"",null,false],[0,0,0,"dst",null,"",null,false],[0,0,0,"off",null,"",null,false],[0,0,0,"src",null,"",null,false],[356,695,0,null,null,null,[36288,36289,36290],false],[0,0,0,"endian",null,"",null,false],[0,0,0,"size",null,"",null,true],[0,0,0,"dst",null,"",null,false],[356,713,0,null,null,null,[36292,36293],false],[0,0,0,"size",null,"",null,true],[0,0,0,"dst",null,"",null,false],[356,717,0,null,null,null,[36295,36296],false],[0,0,0,"size",null,"",null,true],[0,0,0,"dst",null,"",null,false],[356,721,0,null,null,null,[36298],false],[0,0,0,"helper",null,"",null,false],[356,732,0,null,null," exit BPF program",[],false],[0,0,0,"code",null,null,null,false],[356,397,0,null,null,null,null,false],[0,0,0,"dst",null,null,null,false],[356,397,0,null,null,null,null,false],[0,0,0,"src",null,null,null,false],[0,0,0,"off",null,null,null,false],[0,0,0,"imm",null,null,null,false],[356,747,0,null,null,null,[36308,36309],false],[0,0,0,"code",null,"",null,false],[0,0,0,"insn",null,"",null,false],[356,861,0,null,null,null,[36311,36312,36313,36314,36315,36316,36317,36318,36319,36320,36321,36322,36323,36324,36325,36326,36327,36328,36329,36330,36331,36332,36333,36334,36335,36336,36337,36338,36339,36340,36341,36342,36343,36344,36345],false],[0,0,0,"map_create",null," Create  a map and return a file descriptor that refers to the map.  The\n close-on-exec file descriptor flag is automatically enabled for the new\n file descriptor.\n\n uses MapCreateAttr",null,false],[0,0,0,"map_lookup_elem",null," Look up an element by key in a specified map and return its value.\n\n uses MapElemAttr",null,false],[0,0,0,"map_update_elem",null," Create or update an element (key/value pair) in a specified map.\n\n uses MapElemAttr",null,false],[0,0,0,"map_delete_elem",null," Look up and delete an element by key in a specified map.\n\n uses MapElemAttr",null,false],[0,0,0,"map_get_next_key",null," Look up an element by key in a specified map and return the key of the\n next element.",null,false],[0,0,0,"prog_load",null," Verify and load an eBPF program, returning a new file descriptor\n associated with  the  program.   The close-on-exec file descriptor flag\n is automatically enabled for the new file descriptor.\n\n uses ProgLoadAttr",null,false],[0,0,0,"obj_pin",null," Pin a map or eBPF program to a path within the minimal BPF filesystem\n\n uses ObjAttr",null,false],[0,0,0,"obj_get",null," Get the file descriptor of a BPF object pinned to a certain path\n\n uses ObjAttr",null,false],[0,0,0,"prog_attach",null," uses ProgAttachAttr",null,false],[0,0,0,"prog_detach",null," uses ProgAttachAttr",null,false],[0,0,0,"prog_test_run",null," uses TestRunAttr",null,false],[0,0,0,"prog_get_next_id",null," uses GetIdAttr",null,false],[0,0,0,"map_get_next_id",null," uses GetIdAttr",null,false],[0,0,0,"prog_get_fd_by_id",null," uses GetIdAttr",null,false],[0,0,0,"map_get_fd_by_id",null," uses GetIdAttr",null,false],[0,0,0,"obj_get_info_by_fd",null," uses InfoAttr",null,false],[0,0,0,"prog_query",null," uses QueryAttr",null,false],[0,0,0,"raw_tracepoint_open",null," uses RawTracepointAttr",null,false],[0,0,0,"btf_load",null," uses BtfLoadAttr",null,false],[0,0,0,"btf_get_fd_by_id",null," uses GetIdAttr",null,false],[0,0,0,"task_fd_query",null," uses TaskFdQueryAttr",null,false],[0,0,0,"map_lookup_and_delete_elem",null," uses MapElemAttr",null,false],[0,0,0,"map_freeze",null,null,null,false],[0,0,0,"btf_get_next_id",null," uses GetIdAttr",null,false],[0,0,0,"map_lookup_batch",null," uses MapBatchAttr",null,false],[0,0,0,"map_lookup_and_delete_batch",null," uses MapBatchAttr",null,false],[0,0,0,"map_update_batch",null," uses MapBatchAttr",null,false],[0,0,0,"map_delete_batch",null," uses MapBatchAttr",null,false],[0,0,0,"link_create",null," uses LinkCreateAttr",null,false],[0,0,0,"link_update",null," uses LinkUpdateAttr",null,false],[0,0,0,"link_get_fd_by_id",null," uses GetIdAttr",null,false],[0,0,0,"link_get_next_id",null," uses GetIdAttr",null,false],[0,0,0,"enable_stats",null," uses EnableStatsAttr",null,false],[0,0,0,"iter_create",null," uses IterCreateAttr",null,false],[0,0,0,"link_detach",null,null,null,false],[356,984,0,null,null,null,[36347,36348,36349,36350,36351,36352,36353,36354,36355,36356,36357,36358,36359,36360,36361,36362,36363,36364,36365,36366,36367,36368,36369,36370,36371,36372,36373,36374],false],[0,0,0,"unspec",null,null,null,false],[0,0,0,"hash",null,null,null,false],[0,0,0,"array",null,null,null,false],[0,0,0,"prog_array",null,null,null,false],[0,0,0,"perf_event_array",null,null,null,false],[0,0,0,"percpu_hash",null,null,null,false],[0,0,0,"percpu_array",null,null,null,false],[0,0,0,"stack_trace",null,null,null,false],[0,0,0,"cgroup_array",null,null,null,false],[0,0,0,"lru_hash",null,null,null,false],[0,0,0,"lru_percpu_hash",null,null,null,false],[0,0,0,"lpm_trie",null,null,null,false],[0,0,0,"array_of_maps",null,null,null,false],[0,0,0,"hash_of_maps",null,null,null,false],[0,0,0,"devmap",null,null,null,false],[0,0,0,"sockmap",null,null,null,false],[0,0,0,"cpumap",null,null,null,false],[0,0,0,"xskmap",null,null,null,false],[0,0,0,"sockhash",null,null,null,false],[0,0,0,"cgroup_storage",null,null,null,false],[0,0,0,"reuseport_sockarray",null,null,null,false],[0,0,0,"percpu_cgroup_storage",null,null,null,false],[0,0,0,"queue",null,null,null,false],[0,0,0,"stack",null,null,null,false],[0,0,0,"sk_storage",null,null,null,false],[0,0,0,"devmap_hash",null,null,null,false],[0,0,0,"struct_ops",null,null,null,false],[0,0,0,"ringbuf",null," An ordered and shared CPU version of perf_event_array. They have\n similar semantics:\n     - variable length records\n     - no blocking: when full, reservation fails\n     - memory mappable for ease and speed\n     - epoll notifications for new data, but can busy poll\n\n Ringbufs give BPF programs two sets of APIs:\n     - ringbuf_output() allows copy data from one place to a ring\n     buffer, similar to bpf_perf_event_output()\n     - ringbuf_reserve()/ringbuf_commit()/ringbuf_discard() split the\n     process into two steps. First a fixed amount of space is reserved,\n     if that is successful then the program gets a pointer to a chunk of\n     memory and can be submitted with commit() or discarded with\n     discard()\n\n ringbuf_output() will incurr an extra memory copy, but allows to submit\n records of the length that's not known beforehand, and is an easy\n replacement for perf_event_outptu().\n\n ringbuf_reserve() avoids the extra memory copy but requires a known size\n of memory beforehand.\n\n ringbuf_query() allows to query properties of the map, 4 are currently\n supported:\n     - BPF_RB_AVAIL_DATA: amount of unconsumed data in ringbuf\n     - BPF_RB_RING_SIZE: returns size of ringbuf\n     - BPF_RB_CONS_POS/BPF_RB_PROD_POS returns current logical position\n     of consumer and producer respectively\n\n key size: 0\n value size: 0\n max entries: size of ringbuf, must be power of 2",null,false],[356,1051,0,null,null,null,[36376,36377,36378,36379,36380,36381,36382,36383,36384,36385,36386,36387,36388,36389,36390,36391,36392,36393,36394,36395,36396,36397,36398,36399,36400,36401,36402,36403,36404,36405,36406,36407],false],[0,0,0,"unspec",null,null,null,false],[0,0,0,"socket_filter",null," context type: __sk_buff",null,false],[0,0,0,"kprobe",null," context type: bpf_user_pt_regs_t",null,false],[0,0,0,"sched_cls",null," context type: __sk_buff",null,false],[0,0,0,"sched_act",null," context type: __sk_buff",null,false],[0,0,0,"tracepoint",null," context type: u64",null,false],[0,0,0,"xdp",null," context type: xdp_md",null,false],[0,0,0,"perf_event",null," context type: bpf_perf_event_data",null,false],[0,0,0,"cgroup_skb",null," context type: __sk_buff",null,false],[0,0,0,"cgroup_sock",null," context type: bpf_sock",null,false],[0,0,0,"lwt_in",null," context type: __sk_buff",null,false],[0,0,0,"lwt_out",null," context type: __sk_buff",null,false],[0,0,0,"lwt_xmit",null," context type: __sk_buff",null,false],[0,0,0,"sock_ops",null," context type: bpf_sock_ops",null,false],[0,0,0,"sk_skb",null," context type: __sk_buff",null,false],[0,0,0,"cgroup_device",null," context type: bpf_cgroup_dev_ctx",null,false],[0,0,0,"sk_msg",null," context type: sk_msg_md",null,false],[0,0,0,"raw_tracepoint",null," context type: bpf_raw_tracepoint_args",null,false],[0,0,0,"cgroup_sock_addr",null," context type: bpf_sock_addr",null,false],[0,0,0,"lwt_seg6local",null," context type: __sk_buff",null,false],[0,0,0,"lirc_mode2",null," context type: u32",null,false],[0,0,0,"sk_reuseport",null," context type: sk_reuseport_md",null,false],[0,0,0,"flow_dissector",null," context type: __sk_buff",null,false],[0,0,0,"cgroup_sysctl",null," context type: bpf_sysctl",null,false],[0,0,0,"raw_tracepoint_writable",null," context type: bpf_raw_tracepoint_args",null,false],[0,0,0,"cgroup_sockopt",null," context type: bpf_sockopt",null,false],[0,0,0,"tracing",null," context type: void *",null,false],[0,0,0,"struct_ops",null," context type: void *",null,false],[0,0,0,"ext",null," context type: void *",null,false],[0,0,0,"lsm",null," context type: void *",null,false],[0,0,0,"sk_lookup",null," context type: bpf_sk_lookup",null,false],[0,0,0,"syscall",null," context type: void *",null,false],[356,1150,0,null,null,null,[36409,36410,36411,36412,36413,36414,36415,36416,36417,36418,36419,36420,36421,36422,36423,36424,36425,36426,36427,36428,36429,36430,36431,36432,36433,36434,36435,36436,36437,36438,36439,36440,36441,36442,36443,36444,36445,36446],false],[0,0,0,"cgroup_inet_ingress",null,null,null,false],[0,0,0,"cgroup_inet_egress",null,null,null,false],[0,0,0,"cgroup_inet_sock_create",null,null,null,false],[0,0,0,"cgroup_sock_ops",null,null,null,false],[0,0,0,"sk_skb_stream_parser",null,null,null,false],[0,0,0,"sk_skb_stream_verdict",null,null,null,false],[0,0,0,"cgroup_device",null,null,null,false],[0,0,0,"sk_msg_verdict",null,null,null,false],[0,0,0,"cgroup_inet4_bind",null,null,null,false],[0,0,0,"cgroup_inet6_bind",null,null,null,false],[0,0,0,"cgroup_inet4_connect",null,null,null,false],[0,0,0,"cgroup_inet6_connect",null,null,null,false],[0,0,0,"cgroup_inet4_post_bind",null,null,null,false],[0,0,0,"cgroup_inet6_post_bind",null,null,null,false],[0,0,0,"cgroup_udp4_sendmsg",null,null,null,false],[0,0,0,"cgroup_udp6_sendmsg",null,null,null,false],[0,0,0,"lirc_mode2",null,null,null,false],[0,0,0,"flow_dissector",null,null,null,false],[0,0,0,"cgroup_sysctl",null,null,null,false],[0,0,0,"cgroup_udp4_recvmsg",null,null,null,false],[0,0,0,"cgroup_udp6_recvmsg",null,null,null,false],[0,0,0,"cgroup_getsockopt",null,null,null,false],[0,0,0,"cgroup_setsockopt",null,null,null,false],[0,0,0,"trace_raw_tp",null,null,null,false],[0,0,0,"trace_fentry",null,null,null,false],[0,0,0,"trace_fexit",null,null,null,false],[0,0,0,"modify_return",null,null,null,false],[0,0,0,"lsm_mac",null,null,null,false],[0,0,0,"trace_iter",null,null,null,false],[0,0,0,"cgroup_inet4_getpeername",null,null,null,false],[0,0,0,"cgroup_inet6_getpeername",null,null,null,false],[0,0,0,"cgroup_inet4_getsockname",null,null,null,false],[0,0,0,"cgroup_inet6_getsockname",null,null,null,false],[0,0,0,"xdp_devmap",null,null,null,false],[0,0,0,"cgroup_inet_sock_release",null,null,null,false],[0,0,0,"xdp_cpumap",null,null,null,false],[0,0,0,"sk_lookup",null,null,null,false],[0,0,0,"xdp",null,null,null,false],[356,1192,0,null,null,null,null,false],[356,1194,0,null,null," struct used by Cmd.map_create command",[36449,36450,36451,36452,36453,36455,36456,36458,36459,36461,36462,36463,36464],false],[0,0,0,"map_type",null," one of MapType",null,false],[0,0,0,"key_size",null," size of key in bytes",null,false],[0,0,0,"value_size",null," size of value in bytes",null,false],[0,0,0,"max_entries",null," max number of entries in a map",null,false],[0,0,0,"map_flags",null," .map_create related flags",null,false],[356,1194,0,null,null,null,null,false],[0,0,0,"inner_map_fd",null," fd pointing to the inner map",null,false],[0,0,0,"numa_node",null," numa node (effective only if MapCreateFlags.numa_node is set)",null,false],[356,1194,0,null,null,null,null,false],[0,0,0,"map_name",null,null,null,false],[0,0,0,"map_ifindex",null," ifindex of netdev to create on",null,false],[356,1194,0,null,null,null,null,false],[0,0,0,"btf_fd",null," fd pointing to a BTF type data",null,false],[0,0,0,"btf_key_type_id",null," BTF type_id of the key",null,false],[0,0,0,"bpf_value_type_id",null," BTF type_id of the value",null,false],[0,0,0,"btf_vmlinux_value_type_id",null," BTF type_id of a kernel struct stored as the map value",null,false],[356,1234,0,null,null," struct used by Cmd.map_*_elem commands",[36467,36468,36472,36473],false],[356,1234,0,null,null,null,null,false],[0,0,0,"map_fd",null,null,null,false],[0,0,0,"key",null,null,null,false],[356,1234,0,null,null,null,[36470,36471],false],[0,0,0,"value",null,null,null,false],[0,0,0,"next_key",null,null,null,false],[0,0,0,"result",null,null,null,false],[0,0,0,"flags",null,null,null,false],[356,1245,0,null,null," struct used by Cmd.map_*_batch commands",[36475,36476,36477,36478,36479,36481,36482,36483],false],[0,0,0,"in_batch",null," start batch, NULL to start from beginning",null,false],[0,0,0,"out_batch",null," output: next start batch",null,false],[0,0,0,"keys",null,null,null,false],[0,0,0,"values",null,null,null,false],[0,0,0,"count",null," input/output:\n input: # of key/value elements\n output: # of filled elements",null,false],[356,1245,0,null,null,null,null,false],[0,0,0,"map_fd",null,null,null,false],[0,0,0,"elem_flags",null,null,null,false],[0,0,0,"flags",null,null,null,false],[356,1264,0,null,null," struct used by Cmd.prog_load command",[36485,36486,36487,36488,36489,36490,36491,36492,36493,36495,36496,36497,36499,36500,36501,36502,36503,36504,36505,36506,36507],false],[0,0,0,"prog_type",null," one of ProgType",null,false],[0,0,0,"insn_cnt",null,null,null,false],[0,0,0,"insns",null,null,null,false],[0,0,0,"license",null,null,null,false],[0,0,0,"log_level",null," verbosity level of verifier",null,false],[0,0,0,"log_size",null," size of user buffer",null,false],[0,0,0,"log_buf",null," user supplied buffer",null,false],[0,0,0,"kern_version",null," not used",null,false],[0,0,0,"prog_flags",null,null,null,false],[356,1264,0,null,null,null,null,false],[0,0,0,"prog_name",null,null,null,false],[0,0,0,"prog_ifindex",null," ifindex of netdev to prep for.",null,false],[0,0,0,"expected_attach_type",null," For some prog types expected attach type must be known at load time to\n verify attach type specific parts of prog (context accesses, allowed\n helpers, etc).",null,false],[356,1264,0,null,null,null,null,false],[0,0,0,"prog_btf_fd",null," fd pointing to BTF type data",null,false],[0,0,0,"func_info_rec_size",null," userspace bpf_func_info size",null,false],[0,0,0,"func_info",null,null,null,false],[0,0,0,"func_info_cnt",null," number of bpf_func_info records",null,false],[0,0,0,"line_info_rec_size",null," userspace bpf_line_info size",null,false],[0,0,0,"line_info",null,null,null,false],[0,0,0,"line_info_cnt",null," number of bpf_line_info records",null,false],[0,0,0,"attact_btf_id",null," in-kernel BTF type id to attach to",null,false],[0,0,0,"attach_prog_id",null," 0 to attach to vmlinux",null,false],[356,1318,0,null,null," struct used by Cmd.obj_* commands",[36509,36511,36512],false],[0,0,0,"pathname",null,null,null,false],[356,1318,0,null,null,null,null,false],[0,0,0,"bpf_fd",null,null,null,false],[0,0,0,"file_flags",null,null,null,false],[356,1325,0,null,null," struct used by Cmd.prog_attach/detach commands",[36515,36517,36518,36519,36521],false],[356,1325,0,null,null,null,null,false],[0,0,0,"target_fd",null," container object to attach to",null,false],[356,1325,0,null,null,null,null,false],[0,0,0,"attach_bpf_fd",null," eBPF program to attach",null,false],[0,0,0,"attach_type",null,null,null,false],[0,0,0,"attach_flags",null,null,null,false],[356,1325,0,null,null,null,null,false],[0,0,0,"replace_bpf_fd",null," previously attached eBPF program to replace if .replace is used",null,false],[356,1341,0,null,null," struct used by Cmd.prog_test_run command",[36524,36525,36526,36527,36528,36529,36530,36531,36532,36533,36534,36535],false],[356,1341,0,null,null,null,null,false],[0,0,0,"prog_fd",null,null,null,false],[0,0,0,"retval",null,null,null,false],[0,0,0,"data_size_in",null," input: len of data_in",null,false],[0,0,0,"data_size_out",null," input/output: len of data_out. returns ENOSPC if data_out is too small.",null,false],[0,0,0,"data_in",null,null,null,false],[0,0,0,"data_out",null,null,null,false],[0,0,0,"repeat",null,null,null,false],[0,0,0,"duration",null,null,null,false],[0,0,0,"ctx_size_in",null," input: len of ctx_in",null,false],[0,0,0,"ctx_size_out",null," input/output: len of ctx_out. returns ENOSPC if ctx_out is too small.",null,false],[0,0,0,"ctx_in",null,null,null,false],[0,0,0,"ctx_out",null,null,null,false],[356,1365,0,null,null," struct used by Cmd.*_get_*_id commands",[36543,36544,36545],false],[356,1365,0,null,null,null,[36538,36539,36540,36541,36542],false],[0,0,0,"start_id",null,null,null,false],[0,0,0,"prog_id",null,null,null,false],[0,0,0,"map_id",null,null,null,false],[0,0,0,"btf_id",null,null,null,false],[0,0,0,"link_id",null,null,null,false],[0,0,0,"id",null,null,null,false],[0,0,0,"next_id",null,null,null,false],[0,0,0,"open_flags",null,null,null,false],[356,1378,0,null,null," struct used by Cmd.obj_get_info_by_fd command",[36548,36549,36550],false],[356,1378,0,null,null,null,null,false],[0,0,0,"bpf_fd",null,null,null,false],[0,0,0,"info_len",null,null,null,false],[0,0,0,"info",null,null,null,false],[356,1385,0,null,null," struct used by Cmd.prog_query command",[36553,36554,36555,36556,36557,36558],false],[356,1385,0,null,null,null,null,false],[0,0,0,"target_fd",null," container object to query",null,false],[0,0,0,"attach_type",null,null,null,false],[0,0,0,"query_flags",null,null,null,false],[0,0,0,"attach_flags",null,null,null,false],[0,0,0,"prog_ids",null,null,null,false],[0,0,0,"prog_cnt",null,null,null,false],[356,1396,0,null,null," struct used by Cmd.raw_tracepoint_open command",[36560,36562],false],[0,0,0,"name",null,null,null,false],[356,1396,0,null,null,null,null,false],[0,0,0,"prog_fd",null,null,null,false],[356,1402,0,null,null," struct used by Cmd.btf_load command",[36564,36565,36566,36567,36568],false],[0,0,0,"btf",null,null,null,false],[0,0,0,"btf_log_buf",null,null,null,false],[0,0,0,"btf_size",null,null,null,false],[0,0,0,"btf_log_size",null,null,null,false],[0,0,0,"btf_log_level",null,null,null,false],[356,1411,0,null,null," struct used by Cmd.task_fd_query",[36571,36573,36574,36575,36576,36577,36578,36579,36580],false],[356,1411,0,null,null,null,null,false],[0,0,0,"pid",null," input: pid",null,false],[356,1411,0,null,null,null,null,false],[0,0,0,"fd",null," input: fd",null,false],[0,0,0,"flags",null," input: flags",null,false],[0,0,0,"buf_len",null," input/output: buf len",null,false],[0,0,0,"buf",null," input/output:\n     tp_name for tracepoint\n     symbol for kprobe\n     filename for uprobe",null,false],[0,0,0,"prog_id",null," output: prod_id",null,false],[0,0,0,"fd_type",null," output: BPF_FD_TYPE",null,false],[0,0,0,"probe_offset",null," output: probe_offset",null,false],[0,0,0,"probe_addr",null," output: probe_addr",null,false],[356,1444,0,null,null," struct used by Cmd.link_create command",[36583,36585,36586,36587],false],[356,1444,0,null,null,null,null,false],[0,0,0,"prog_fd",null," eBPF program to attach",null,false],[356,1444,0,null,null,null,null,false],[0,0,0,"target_fd",null," object to attach to",null,false],[0,0,0,"attach_type",null,null,null,false],[0,0,0,"flags",null," extra flags",null,false],[356,1457,0,null,null," struct used by Cmd.link_update command",[36590,36592,36593,36595],false],[356,1457,0,null,null,null,null,false],[0,0,0,"link_fd",null,null,null,false],[356,1457,0,null,null,null,null,false],[0,0,0,"new_prog_fd",null," new program to update link with",null,false],[0,0,0,"flags",null," extra flags",null,false],[356,1457,0,null,null,null,null,false],[0,0,0,"old_prog_fd",null," expected link's program fd, it is specified only if BPF_F_REPLACE is\n set in flags",null,false],[356,1472,0,null,null," struct used by Cmd.enable_stats command",[36597],false],[0,0,0,"type",null,null,null,false],[356,1477,0,null,null," struct used by Cmd.iter_create command",[36600,36601],false],[356,1477,0,null,null,null,null,false],[0,0,0,"link_fd",null,null,null,false],[0,0,0,"flags",null,null,null,false],[356,1483,0,null,null," Mega struct that is passed to the bpf() syscall",[36603,36604,36605,36606,36607,36608,36609,36610,36611,36612,36613,36614,36615,36616,36617,36618,36619],false],[0,0,0,"map_create",null,null,null,false],[0,0,0,"map_elem",null,null,null,false],[0,0,0,"map_batch",null,null,null,false],[0,0,0,"prog_load",null,null,null,false],[0,0,0,"obj",null,null,null,false],[0,0,0,"prog_attach",null,null,null,false],[0,0,0,"test_run",null,null,null,false],[0,0,0,"get_id",null,null,null,false],[0,0,0,"info",null,null,null,false],[0,0,0,"query",null,null,null,false],[0,0,0,"raw_tracepoint",null,null,null,false],[0,0,0,"btf_load",null,null,null,false],[0,0,0,"task_fd_query",null,null,null,false],[0,0,0,"link_create",null,null,null,false],[0,0,0,"link_update",null,null,null,false],[0,0,0,"enable_stats",null,null,null,false],[0,0,0,"iter_create",null,null,null,false],[356,1503,0,null,null,null,[36621,36623],false],[0,0,0,"level",null,null,null,false],[356,1503,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[356,1508,0,null,null,null,[36625,36626,36627,36628],false],[0,0,0,"map_type",null,"",null,false],[0,0,0,"key_size",null,"",null,false],[0,0,0,"value_size",null,"",null,false],[0,0,0,"max_entries",null,"",null,false],[356,1533,0,null,null,null,[36630,36631,36632],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[356,1554,0,null,null,null,[36634,36635,36636,36637],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"flags",null,"",null,false],[356,1577,0,null,null,null,[36639,36640],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"key",null,"",null,false],[356,1597,0,null,null,null,[36642,36643,36644],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"next_key",null,"",null,false],[356,1656,0,null,null,null,[36646,36647,36648,36649,36650,36651],false],[0,0,0,"prog_type",null,"",null,false],[0,0,0,"insns",null,"",null,false],[0,0,0,"log",null,"",null,false],[0,0,0,"license",null,"",null,false],[0,0,0,"kern_version",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,93,0,null,null,null,null,false],[0,0,0,"linux/ioctl.zig",null,"",[],false],[360,0,0,null,null,null,null,false],[360,2,0,null,null,null,null,false],[360,18,0,null,null,null,null,false],[360,20,0,null,null,null,[36658,36659,36661,36663],false],[0,0,0,"nr",null,null,null,false],[0,0,0,"io_type",null,null,null,false],[360,20,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[360,20,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[360,27,0,null,null,null,[36665,36666,36667,36668],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"io_type",null,"",null,false],[0,0,0,"nr",null,"",null,false],[0,0,0,"T",null,"",null,true],[360,37,0,null,null,null,[36670,36671],false],[0,0,0,"io_type",null,"",null,false],[0,0,0,"nr",null,"",null,false],[360,41,0,null,null,null,[36673,36674,36675],false],[0,0,0,"io_type",null,"",null,false],[0,0,0,"nr",null,"",null,false],[0,0,0,"T",null,"",null,true],[360,45,0,null,null,null,[36677,36678,36679],false],[0,0,0,"io_type",null,"",null,false],[0,0,0,"nr",null,"",null,false],[0,0,0,"T",null,"",null,true],[360,49,0,null,null,null,[36681,36682,36683],false],[0,0,0,"io_type",null,"",null,false],[0,0,0,"nr",null,"",null,false],[0,0,0,"T",null,"",null,true],[351,94,0,null,null,null,null,false],[0,0,0,"linux/seccomp.zig",null," API bits for the Secure Computing facility in the Linux kernel, which allows\n processes to restrict access to the system call API.\n\n Seccomp started life with a single \"strict\" mode, which only allowed calls\n to read(2), write(2), _exit(2) and sigreturn(2). It turns out that this\n isn't that useful for general-purpose applications, and so a mode that\n utilizes user-supplied filters mode was added.\n\n Seccomp filters are classic BPF programs. Conceptually, a seccomp program\n is attached to the kernel and is executed on each syscall. The \"packet\"\n being validated is the `data` structure, and the verdict is an action that\n the kernel performs on the calling process. The actions are variations on a\n \"pass\" or \"fail\" result, where a pass allows the syscall to continue and a\n fail blocks the syscall and returns some sort of error value. See the full\n list of actions under ::RET for more information. Finally, only word-sized,\n absolute loads (`ld [k]`) are supported to read from the `data` structure.\n\n There are some issues with the filter API that have traditionally made\n writing them a pain:\n\n 1. Each CPU architecture supported by Linux has its own unique ABI and\n    syscall API. It is not guaranteed that the syscall numbers and arguments\n    are the same across architectures, or that they're even implemented. Thus,\n    filters cannot be assumed to be portable without consulting documentation\n    like syscalls(2) and testing on target hardware. This also requires\n    checking the value of `data.arch` to make sure that a filter was compiled\n    for the correct architecture.\n 2. Many syscalls take an `unsigned long` or `size_t` argument, the size of\n    which is dependant on the ABI. Since BPF programs execute in a 32-bit\n    machine, validation of 64-bit arguments necessitates two load-and-compare\n    instructions for the upper and lower words.\n 3. A further wrinkle to the above is endianness. Unlike network packets,\n    syscall data shares the endianness of the target machine. A filter\n    compiled on a little-endian machine will not work on a big-endian one,\n    and vice-versa. For example: Checking the upper 32-bits of `data.arg1`\n    requires a load at `@offsetOf(data, \"arg1\") + 4` on big-endian systems\n    and `@offsetOf(data, \"arg1\")` on little-endian systems. Endian-portable\n    filters require adjusting these offsets at compile time, similar to how\n    e.g. OpenSSH does[1].\n 4. Syscalls with userspace implementations via the vDSO cannot be traced or\n    filtered. The vDSO can be disabled or just ignored, which must be taken\n    into account when writing filters.\n 5. Software libraries -  especially dynamically loaded ones - tend to use\n    more of the syscall API over time, thus filters must evolve with them.\n    Static filters can result in reduced or even broken functionality when\n    calling newer code from these libraries. This is known to happen with\n    critical libraries like glibc[2].\n\n Some of these issues can be mitigated with help from Zig and the standard\n library. Since the target CPU is known at compile time, the proper syscall\n numbers are mixed into the `os` namespace under `std.os.SYS (see the code\n for `arch_bits` in `os/linux.zig`). Referencing an unimplemented syscall\n would be a compile error. Endian offsets can also be defined in a similar\n manner to the OpenSSH example:\n\n ```zig\n const offset = if (native_endian == .Little) struct {\n     pub const low = 0;\n     pub const high = @sizeOf(u32);\n } else struct {\n     pub const low = @sizeOf(u32);\n     pub const high = 0;\n };\n ```\n\n Unfortunately, there is no easy solution for issue 5. The most reliable\n strategy is to keep testing; test newer Zig versions, different libcs,\n different distros, and design your filter to accommodate all of them.\n Alternatively, you could inject a filter at runtime. Since filters are\n preserved across execve(2), a filter could be setup before executing your\n program, without your program having any knowledge of this happening. This\n is the method used by systemd[3] and Cloudflare's sandbox library[4].\n\n [1]: https://github.com/openssh/openssh-portable/blob/master/sandbox-seccomp-filter.c#L81\n [2]: https://sourceware.org/legacy-ml/libc-alpha/2017-11/msg00246.html\n [3]: https://www.freedesktop.org/software/systemd/man/systemd.exec.html#SystemCallFilter=\n [4]: https://github.com/cloudflare/sandbox\n\n See Also\n - seccomp(2), seccomp_unotify(2)\n - https://www.kernel.org/doc/html/latest/userspace-api/seccomp_filter.html\n",[],false],[361,81,0,null,null,null,null,false],[361,84,0,null,null,null,[],false],[361,86,0,null,null," Seccomp not in use.",null,false],[361,88,0,null,null," Uses a hard-coded filter.",null,false],[361,90,0,null,null," Uses a user-supplied filter.",null,false],[361,94,0,null,null,null,null,false],[361,95,0,null,null,null,null,false],[361,96,0,null,null,null,null,false],[361,97,0,null,null,null,null,false],[361,100,0,null,null," Bitflags for the SET_MODE_FILTER operation.",[],false],[361,101,0,null,null,null,null,false],[361,102,0,null,null,null,null,false],[361,103,0,null,null,null,null,false],[361,104,0,null,null,null,null,false],[361,105,0,null,null,null,null,false],[361,111,0,null,null," Action values for seccomp BPF programs.\n The lower 16-bits are for optional return data.\n The upper 16-bits are ordered from least permissive values to most.",[],false],[361,113,0,null,null," Kill the process.",null,false],[361,115,0,null,null," Kill the thread.",null,false],[361,116,0,null,null,null,null,false],[361,118,0,null,null," Disallow and force a SIGSYS.",null,false],[361,120,0,null,null," Return an errno.",null,false],[361,122,0,null,null," Forward the syscall to a userspace supervisor to make a decision.",null,false],[361,124,0,null,null," Pass to a tracer or disallow.",null,false],[361,126,0,null,null," Allow after logging.",null,false],[361,128,0,null,null," Allow.",null,false],[361,131,0,null,null,null,null,false],[361,132,0,null,null,null,null,false],[361,133,0,null,null,null,null,false],[361,136,0,null,null,null,[],false],[361,137,0,null,null,null,null,false],[361,138,0,null,null,null,null,false],[361,139,0,null,null,null,null,false],[361,140,0,null,null,null,null,false],[361,144,0,null,null," Tells the kernel that the supervisor allows the syscall to continue.",null,false],[361,147,0,null,null," See seccomp_unotify(2).",[],false],[361,148,0,null,null,null,null,false],[361,149,0,null,null,null,null,false],[361,152,0,null,null,null,[36724,36725,36726,36727,36728,36729,36730,36731,36732],false],[0,0,0,"nr",null," The system call number.",null,false],[0,0,0,"arch",null," The CPU architecture/system call convention.\n One of the values defined in `std.os.linux.AUDIT`.",null,false],[0,0,0,"instruction_pointer",null,null,null,false],[0,0,0,"arg0",null,null,null,false],[0,0,0,"arg1",null,null,null,false],[0,0,0,"arg2",null,null,null,false],[0,0,0,"arg3",null,null,null,false],[0,0,0,"arg4",null,null,null,false],[0,0,0,"arg5",null,null,null,false],[361,169,0,null,null," Used with the ::GET_NOTIF_SIZES command to check if the kernel structures\n have changed.",[36734,36735,36736],false],[0,0,0,"notif",null," Size of ::notif.",null,false],[0,0,0,"notif_resp",null," Size of ::resp.",null,false],[0,0,0,"data",null," Size of ::data.",null,false],[361,178,0,null,null,null,[36738,36739,36740,36742],false],[0,0,0,"id",null," Unique notification cookie for each filter.",null,false],[0,0,0,"pid",null," ID of the thread that triggered the notification.",null,false],[0,0,0,"flags",null," Bitmask for event information. Currently set to zero.",null,false],[361,178,0,null,null,null,null,false],[0,0,0,"data",null," The current system call data.",null,false],[361,190,0,null,null," The decision payload the supervisor process sends to the kernel.",[36744,36745,36746,36747],false],[0,0,0,"id",null," The filter cookie.",null,false],[0,0,0,"val",null," The return value for a spoofed syscall.",null,false],[0,0,0,"error",null," Set to zero for a spoofed success or a negative error number for a\n failure.",null,false],[0,0,0,"flags",null," Bitmask containing the decision. Either USER_NOTIF_FLAG_CONTINUE to\n allow the syscall or zero to spoof the return values.",null,false],[361,203,0,null,null,null,[36749,36750,36751,36752,36753],false],[0,0,0,"id",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"srcfd",null,null,null,false],[0,0,0,"newfd",null,null,null,false],[0,0,0,"newfd_flags",null,null,null,false],[351,96,0,null,null,null,null,false],[0,0,0,"linux/syscalls.zig",null,"",[],false],[362,3,0,null,null,null,[36757,36758,36759,36760,36761,36762,36763,36764,36765,36766,36767,36768,36769,36770,36771,36772,36773,36774,36775,36776,36777,36778,36779,36780,36781,36782,36783,36784,36785,36786,36787,36788,36789,36790,36791,36792,36793,36794,36795,36796,36797,36798,36799,36800,36801,36802,36803,36804,36805,36806,36807,36808,36809,36810,36811,36812,36813,36814,36815,36816,36817,36818,36819,36820,36821,36822,36823,36824,36825,36826,36827,36828,36829,36830,36831,36832,36833,36834,36835,36836,36837,36838,36839,36840,36841,36842,36843,36844,36845,36846,36847,36848,36849,36850,36851,36852,36853,36854,36855,36856,36857,36858,36859,36860,36861,36862,36863,36864,36865,36866,36867,36868,36869,36870,36871,36872,36873,36874,36875,36876,36877,36878,36879,36880,36881,36882,36883,36884,36885,36886,36887,36888,36889,36890,36891,36892,36893,36894,36895,36896,36897,36898,36899,36900,36901,36902,36903,36904,36905,36906,36907,36908,36909,36910,36911,36912,36913,36914,36915,36916,36917,36918,36919,36920,36921,36922,36923,36924,36925,36926,36927,36928,36929,36930,36931,36932,36933,36934,36935,36936,36937,36938,36939,36940,36941,36942,36943,36944,36945,36946,36947,36948,36949,36950,36951,36952,36953,36954,36955,36956,36957,36958,36959,36960,36961,36962,36963,36964,36965,36966,36967,36968,36969,36970,36971,36972,36973,36974,36975,36976,36977,36978,36979,36980,36981,36982,36983,36984,36985,36986,36987,36988,36989,36990,36991,36992,36993,36994,36995,36996,36997,36998,36999,37000,37001,37002,37003,37004,37005,37006,37007,37008,37009,37010,37011,37012,37013,37014,37015,37016,37017,37018,37019,37020,37021,37022,37023,37024,37025,37026,37027,37028,37029,37030,37031,37032,37033,37034,37035,37036,37037,37038,37039,37040,37041,37042,37043,37044,37045,37046,37047,37048,37049,37050,37051,37052,37053,37054,37055,37056,37057,37058,37059,37060,37061,37062,37063,37064,37065,37066,37067,37068,37069,37070,37071,37072,37073,37074,37075,37076,37077,37078,37079,37080,37081,37082,37083,37084,37085,37086,37087,37088,37089,37090,37091,37092,37093,37094,37095,37096,37097,37098,37099,37100,37101,37102,37103,37104,37105,37106,37107,37108,37109,37110,37111,37112,37113,37114,37115,37116,37117,37118,37119,37120,37121,37122,37123,37124,37125,37126,37127,37128,37129,37130,37131,37132,37133,37134,37135,37136,37137,37138,37139,37140,37141,37142,37143,37144,37145,37146,37147,37148,37149,37150,37151,37152,37153,37154,37155,37156,37157,37158,37159,37160,37161,37162,37163,37164,37165,37166,37167,37168,37169,37170,37171,37172,37173,37174,37175,37176,37177,37178,37179,37180,37181,37182,37183,37184,37185,37186,37187,37188,37189,37190,37191,37192,37193,37194,37195,37196],false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"waitpid",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"time",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"break",null,null,null,false],[0,0,0,"oldstat",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"umount",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"oldfstat",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"stty",null,null,null,false],[0,0,0,"gtty",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"ftime",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"prof",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"signal",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"lock",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"mpx",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"ulimit",null,null,null,false],[0,0,0,"oldolduname",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"sgetmask",null,null,null,false],[0,0,0,"ssetmask",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"sigsuspend",null,null,null,false],[0,0,0,"sigpending",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"select",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"oldlstat",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"readdir",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"profil",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"ioperm",null,null,null,false],[0,0,0,"socketcall",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"olduname",null,null,null,false],[0,0,0,"iopl",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"idle",null,null,null,false],[0,0,0,"vm86old",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"ipc",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"sigreturn",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"modify_ldt",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"sigprocmask",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"bdflush",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"_llseek",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"vm86",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"getpmsg",null,null,null,false],[0,0,0,"putpmsg",null,null,null,false],[0,0,0,"vfork",null,null,null,false],[0,0,0,"ugetrlimit",null,null,null,false],[0,0,0,"mmap2",null,null,null,false],[0,0,0,"truncate64",null,null,null,false],[0,0,0,"ftruncate64",null,null,null,false],[0,0,0,"stat64",null,null,null,false],[0,0,0,"lstat64",null,null,null,false],[0,0,0,"fstat64",null,null,null,false],[0,0,0,"lchown32",null,null,null,false],[0,0,0,"getuid32",null,null,null,false],[0,0,0,"getgid32",null,null,null,false],[0,0,0,"geteuid32",null,null,null,false],[0,0,0,"getegid32",null,null,null,false],[0,0,0,"setreuid32",null,null,null,false],[0,0,0,"setregid32",null,null,null,false],[0,0,0,"getgroups32",null,null,null,false],[0,0,0,"setgroups32",null,null,null,false],[0,0,0,"fchown32",null,null,null,false],[0,0,0,"setresuid32",null,null,null,false],[0,0,0,"getresuid32",null,null,null,false],[0,0,0,"setresgid32",null,null,null,false],[0,0,0,"getresgid32",null,null,null,false],[0,0,0,"chown32",null,null,null,false],[0,0,0,"setuid32",null,null,null,false],[0,0,0,"setgid32",null,null,null,false],[0,0,0,"setfsuid32",null,null,null,false],[0,0,0,"setfsgid32",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"fcntl64",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"sendfile64",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"set_thread_area",null,null,null,false],[0,0,0,"get_thread_area",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"statfs64",null,null,null,false],[0,0,0,"fstatfs64",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"fadvise64_64",null,null,null,false],[0,0,0,"vserver",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"arch_prctl",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"clock_gettime64",null,null,null,false],[0,0,0,"clock_settime64",null,null,null,false],[0,0,0,"clock_adjtime64",null,null,null,false],[0,0,0,"clock_getres_time64",null,null,null,false],[0,0,0,"clock_nanosleep_time64",null,null,null,false],[0,0,0,"timer_gettime64",null,null,null,false],[0,0,0,"timer_settime64",null,null,null,false],[0,0,0,"timerfd_gettime64",null,null,null,false],[0,0,0,"timerfd_settime64",null,null,null,false],[0,0,0,"utimensat_time64",null,null,null,false],[0,0,0,"pselect6_time64",null,null,null,false],[0,0,0,"ppoll_time64",null,null,null,false],[0,0,0,"io_pgetevents_time64",null,null,null,false],[0,0,0,"recvmmsg_time64",null,null,null,false],[0,0,0,"mq_timedsend_time64",null,null,null,false],[0,0,0,"mq_timedreceive_time64",null,null,null,false],[0,0,0,"semtimedop_time64",null,null,null,false],[0,0,0,"rt_sigtimedwait_time64",null,null,null,false],[0,0,0,"futex_time64",null,null,null,false],[0,0,0,"sched_rr_get_interval_time64",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"memfd_secret",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,446,0,null,null,null,[37198,37199,37200,37201,37202,37203,37204,37205,37206,37207,37208,37209,37210,37211,37212,37213,37214,37215,37216,37217,37218,37219,37220,37221,37222,37223,37224,37225,37226,37227,37228,37229,37230,37231,37232,37233,37234,37235,37236,37237,37238,37239,37240,37241,37242,37243,37244,37245,37246,37247,37248,37249,37250,37251,37252,37253,37254,37255,37256,37257,37258,37259,37260,37261,37262,37263,37264,37265,37266,37267,37268,37269,37270,37271,37272,37273,37274,37275,37276,37277,37278,37279,37280,37281,37282,37283,37284,37285,37286,37287,37288,37289,37290,37291,37292,37293,37294,37295,37296,37297,37298,37299,37300,37301,37302,37303,37304,37305,37306,37307,37308,37309,37310,37311,37312,37313,37314,37315,37316,37317,37318,37319,37320,37321,37322,37323,37324,37325,37326,37327,37328,37329,37330,37331,37332,37333,37334,37335,37336,37337,37338,37339,37340,37341,37342,37343,37344,37345,37346,37347,37348,37349,37350,37351,37352,37353,37354,37355,37356,37357,37358,37359,37360,37361,37362,37363,37364,37365,37366,37367,37368,37369,37370,37371,37372,37373,37374,37375,37376,37377,37378,37379,37380,37381,37382,37383,37384,37385,37386,37387,37388,37389,37390,37391,37392,37393,37394,37395,37396,37397,37398,37399,37400,37401,37402,37403,37404,37405,37406,37407,37408,37409,37410,37411,37412,37413,37414,37415,37416,37417,37418,37419,37420,37421,37422,37423,37424,37425,37426,37427,37428,37429,37430,37431,37432,37433,37434,37435,37436,37437,37438,37439,37440,37441,37442,37443,37444,37445,37446,37447,37448,37449,37450,37451,37452,37453,37454,37455,37456,37457,37458,37459,37460,37461,37462,37463,37464,37465,37466,37467,37468,37469,37470,37471,37472,37473,37474,37475,37476,37477,37478,37479,37480,37481,37482,37483,37484,37485,37486,37487,37488,37489,37490,37491,37492,37493,37494,37495,37496,37497,37498,37499,37500,37501,37502,37503,37504,37505,37506,37507,37508,37509,37510,37511,37512,37513,37514,37515,37516,37517,37518,37519,37520,37521,37522,37523,37524,37525,37526,37527,37528,37529,37530,37531,37532,37533,37534,37535,37536,37537,37538,37539,37540,37541,37542,37543,37544,37545,37546,37547,37548,37549,37550,37551,37552,37553,37554,37555,37556,37557,37558,37559],false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"select",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"vfork",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semop",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"modify_ldt",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"arch_prctl",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"iopl",null,null,null,false],[0,0,0,"ioperm",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"getpmsg",null,null,null,false],[0,0,0,"putpmsg",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"tuxcall",null,null,null,false],[0,0,0,"security",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"time",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"set_thread_area",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"get_thread_area",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl_old",null,null,null,false],[0,0,0,"epoll_wait_old",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"vserver",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"kexec_file_load",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"memfd_secret",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,811,0,null,null,null,[37562,37563,37564,37565,37566,37567,37568,37569,37570,37571,37572,37573,37574,37575,37576,37577,37578,37579,37580,37581,37582,37583,37584,37585,37586,37587,37588,37589,37590,37591,37592,37593,37594,37595,37596,37597,37598,37599,37600,37601,37602,37603,37604,37605,37606,37607,37608,37609,37610,37611,37612,37613,37614,37615,37616,37617,37618,37619,37620,37621,37622,37623,37624,37625,37626,37627,37628,37629,37630,37631,37632,37633,37634,37635,37636,37637,37638,37639,37640,37641,37642,37643,37644,37645,37646,37647,37648,37649,37650,37651,37652,37653,37654,37655,37656,37657,37658,37659,37660,37661,37662,37663,37664,37665,37666,37667,37668,37669,37670,37671,37672,37673,37674,37675,37676,37677,37678,37679,37680,37681,37682,37683,37684,37685,37686,37687,37688,37689,37690,37691,37692,37693,37694,37695,37696,37697,37698,37699,37700,37701,37702,37703,37704,37705,37706,37707,37708,37709,37710,37711,37712,37713,37714,37715,37716,37717,37718,37719,37720,37721,37722,37723,37724,37725,37726,37727,37728,37729,37730,37731,37732,37733,37734,37735,37736,37737,37738,37739,37740,37741,37742,37743,37744,37745,37746,37747,37748,37749,37750,37751,37752,37753,37754,37755,37756,37757,37758,37759,37760,37761,37762,37763,37764,37765,37766,37767,37768,37769,37770,37771,37772,37773,37774,37775,37776,37777,37778,37779,37780,37781,37782,37783,37784,37785,37786,37787,37788,37789,37790,37791,37792,37793,37794,37795,37796,37797,37798,37799,37800,37801,37802,37803,37804,37805,37806,37807,37808,37809,37810,37811,37812,37813,37814,37815,37816,37817,37818,37819,37820,37821,37822,37823,37824,37825,37826,37827,37828,37829,37830,37831,37832,37833,37834,37835,37836,37837,37838,37839,37840,37841,37842,37843,37844,37845,37846,37847,37848,37849,37850,37851,37852,37853,37854,37855,37856,37857,37858,37859,37860,37861,37862,37863,37864,37865,37866,37867,37868,37869,37870,37871,37872,37873,37874,37875,37876,37877,37878,37879,37880,37881,37882,37883,37884,37885,37886,37887,37888,37889,37890,37891,37892,37893,37894,37895,37896,37897,37898,37899,37900,37901,37902,37903,37904,37905,37906,37907,37908,37909,37910,37911,37912,37913,37914,37915,37916,37917,37918,37919,37920,37921,37922,37923,37924,37925,37926,37927,37928,37929,37930,37931,37932,37933,37934,37935,37936,37937,37938,37939,37940,37941,37942,37943,37944,37945,37946,37947,37948,37949,37950,37951,37952,37953,37954,37955,37956,37957,37958,37959,37960,37961,37962,37963,37964,37965,37966,37967,37968,37969,37970],false],[362,812,0,null,null,null,null,false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"sigsuspend",null,null,null,false],[0,0,0,"sigpending",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"sigreturn",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"sigprocmask",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"bdflush",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"_llseek",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"vfork",null,null,null,false],[0,0,0,"ugetrlimit",null,null,null,false],[0,0,0,"mmap2",null,null,null,false],[0,0,0,"truncate64",null,null,null,false],[0,0,0,"ftruncate64",null,null,null,false],[0,0,0,"stat64",null,null,null,false],[0,0,0,"lstat64",null,null,null,false],[0,0,0,"fstat64",null,null,null,false],[0,0,0,"lchown32",null,null,null,false],[0,0,0,"getuid32",null,null,null,false],[0,0,0,"getgid32",null,null,null,false],[0,0,0,"geteuid32",null,null,null,false],[0,0,0,"getegid32",null,null,null,false],[0,0,0,"setreuid32",null,null,null,false],[0,0,0,"setregid32",null,null,null,false],[0,0,0,"getgroups32",null,null,null,false],[0,0,0,"setgroups32",null,null,null,false],[0,0,0,"fchown32",null,null,null,false],[0,0,0,"setresuid32",null,null,null,false],[0,0,0,"getresuid32",null,null,null,false],[0,0,0,"setresgid32",null,null,null,false],[0,0,0,"getresgid32",null,null,null,false],[0,0,0,"chown32",null,null,null,false],[0,0,0,"setuid32",null,null,null,false],[0,0,0,"setgid32",null,null,null,false],[0,0,0,"setfsuid32",null,null,null,false],[0,0,0,"setfsgid32",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"fcntl64",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"sendfile64",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"statfs64",null,null,null,false],[0,0,0,"fstatfs64",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"fadvise64_64",null,null,null,false],[0,0,0,"pciconfig_iobase",null,null,null,false],[0,0,0,"pciconfig_read",null,null,null,false],[0,0,0,"pciconfig_write",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"send",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recv",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"semop",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"vserver",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"kexec_file_load",null,null,null,false],[0,0,0,"clock_gettime64",null,null,null,false],[0,0,0,"clock_settime64",null,null,null,false],[0,0,0,"clock_adjtime64",null,null,null,false],[0,0,0,"clock_getres_time64",null,null,null,false],[0,0,0,"clock_nanosleep_time64",null,null,null,false],[0,0,0,"timer_gettime64",null,null,null,false],[0,0,0,"timer_settime64",null,null,null,false],[0,0,0,"timerfd_gettime64",null,null,null,false],[0,0,0,"timerfd_settime64",null,null,null,false],[0,0,0,"utimensat_time64",null,null,null,false],[0,0,0,"pselect6_time64",null,null,null,false],[0,0,0,"ppoll_time64",null,null,null,false],[0,0,0,"io_pgetevents_time64",null,null,null,false],[0,0,0,"recvmmsg_time64",null,null,null,false],[0,0,0,"mq_timedsend_time64",null,null,null,false],[0,0,0,"mq_timedreceive_time64",null,null,null,false],[0,0,0,"semtimedop_time64",null,null,null,false],[0,0,0,"rt_sigtimedwait_time64",null,null,null,false],[0,0,0,"futex_time64",null,null,null,false],[0,0,0,"sched_rr_get_interval_time64",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[0,0,0,"breakpoint",null,null,null,false],[0,0,0,"cacheflush",null,null,null,false],[0,0,0,"usr26",null,null,null,false],[0,0,0,"usr32",null,null,null,false],[0,0,0,"set_tls",null,null,null,false],[0,0,0,"get_tls",null,null,null,false],[362,1226,0,null,null,null,[37972,37973,37974,37975,37976,37977,37978,37979,37980,37981,37982,37983,37984,37985,37986,37987,37988,37989,37990,37991,37992,37993,37994,37995,37996,37997,37998,37999,38000,38001,38002,38003,38004,38005,38006,38007,38008,38009,38010,38011,38012,38013,38014,38015,38016,38017,38018,38019,38020,38021,38022,38023,38024,38025,38026,38027,38028,38029,38030,38031,38032,38033,38034,38035,38036,38037,38038,38039,38040,38041,38042,38043,38044,38045,38046,38047,38048,38049,38050,38051,38052,38053,38054,38055,38056,38057,38058,38059,38060,38061,38062,38063,38064,38065,38066,38067,38068,38069,38070,38071,38072,38073,38074,38075,38076,38077,38078,38079,38080,38081,38082,38083,38084,38085,38086,38087,38088,38089,38090,38091,38092,38093,38094,38095,38096,38097,38098,38099,38100,38101,38102,38103,38104,38105,38106,38107,38108,38109,38110,38111,38112,38113,38114,38115,38116,38117,38118,38119,38120,38121,38122,38123,38124,38125,38126,38127,38128,38129,38130,38131,38132,38133,38134,38135,38136,38137,38138,38139,38140,38141,38142,38143,38144,38145,38146,38147,38148,38149,38150,38151,38152,38153,38154,38155,38156,38157,38158,38159,38160,38161,38162,38163,38164,38165,38166,38167,38168,38169,38170,38171,38172,38173,38174,38175,38176,38177,38178,38179,38180,38181,38182,38183,38184,38185,38186,38187,38188,38189,38190,38191,38192,38193,38194,38195,38196,38197,38198,38199,38200,38201,38202,38203,38204,38205,38206,38207,38208,38209,38210,38211,38212,38213,38214,38215,38216,38217,38218,38219,38220,38221,38222,38223,38224,38225,38226,38227,38228,38229,38230,38231,38232,38233,38234,38235,38236,38237,38238,38239,38240,38241,38242,38243,38244,38245,38246,38247,38248,38249,38250,38251,38252,38253,38254,38255,38256,38257,38258,38259,38260,38261,38262,38263,38264,38265,38266,38267,38268,38269,38270,38271,38272,38273,38274,38275,38276,38277,38278,38279,38280,38281,38282,38283,38284,38285,38286,38287,38288,38289,38290,38291,38292,38293,38294,38295,38296,38297,38298,38299,38300,38301,38302,38303,38304,38305,38306,38307,38308,38309,38310,38311,38312,38313,38314,38315,38316,38317,38318,38319,38320,38321,38322,38323,38324,38325,38326,38327,38328,38329,38330,38331,38332,38333,38334,38335,38336,38337,38338,38339,38340,38341,38342,38343,38344,38345,38346,38347,38348,38349,38350,38351,38352,38353],false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"execv",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"perfctr",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"signal",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"memory_ordering",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"fstat64",null,null,null,false],[0,0,0,"getpagesize",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"vfork",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"select",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"lstat64",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"stat64",null,null,null,false],[0,0,0,"sendfile64",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"pciconfig_read",null,null,null,false],[0,0,0,"pciconfig_write",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"umount",null,null,null,false],[0,0,0,"sched_set_affinity",null,null,null,false],[0,0,0,"sched_get_affinity",null,null,null,false],[0,0,0,"getdomainname",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"utrap_install",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"sigpending",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"sgetmask",null,null,null,false],[0,0,0,"ssetmask",null,null,null,false],[0,0,0,"sigsuspend",null,null,null,false],[0,0,0,"oldlstat",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"readdir",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"socketcall",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"fadvise64_64",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"waitpid",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"ipc",null,null,null,false],[0,0,0,"sigreturn",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"sigprocmask",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"bdflush",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"statfs64",null,null,null,false],[0,0,0,"fstatfs64",null,null,null,false],[0,0,0,"_llseek",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"vserver",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kern_features",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,1611,0,null,null,null,[38356,38357,38358,38359,38360,38361,38362,38363,38364,38365,38366,38367,38368,38369,38370,38371,38372,38373,38374,38375,38376,38377,38378,38379,38380,38381,38382,38383,38384,38385,38386,38387,38388,38389,38390,38391,38392,38393,38394,38395,38396,38397,38398,38399,38400,38401,38402,38403,38404,38405,38406,38407,38408,38409,38410,38411,38412,38413,38414,38415,38416,38417,38418,38419,38420,38421,38422,38423,38424,38425,38426,38427,38428,38429,38430,38431,38432,38433,38434,38435,38436,38437,38438,38439,38440,38441,38442,38443,38444,38445,38446,38447,38448,38449,38450,38451,38452,38453,38454,38455,38456,38457,38458,38459,38460,38461,38462,38463,38464,38465,38466,38467,38468,38469,38470,38471,38472,38473,38474,38475,38476,38477,38478,38479,38480,38481,38482,38483,38484,38485,38486,38487,38488,38489,38490,38491,38492,38493,38494,38495,38496,38497,38498,38499,38500,38501,38502,38503,38504,38505,38506,38507,38508,38509,38510,38511,38512,38513,38514,38515,38516,38517,38518,38519,38520,38521,38522,38523,38524,38525,38526,38527,38528,38529,38530,38531,38532,38533,38534,38535,38536,38537,38538,38539,38540,38541,38542,38543,38544,38545,38546,38547,38548,38549,38550,38551,38552,38553,38554,38555,38556,38557,38558,38559,38560,38561,38562,38563,38564,38565,38566,38567,38568,38569,38570,38571,38572,38573,38574,38575,38576,38577,38578,38579,38580,38581,38582,38583,38584,38585,38586,38587,38588,38589,38590,38591,38592,38593,38594,38595,38596,38597,38598,38599,38600,38601,38602,38603,38604,38605,38606,38607,38608,38609,38610,38611,38612,38613,38614,38615,38616,38617,38618,38619,38620,38621,38622,38623,38624,38625,38626,38627,38628,38629,38630,38631,38632,38633,38634,38635,38636,38637,38638,38639,38640,38641,38642,38643,38644,38645,38646,38647,38648,38649,38650,38651,38652,38653,38654,38655,38656,38657,38658,38659,38660,38661,38662,38663,38664,38665,38666,38667,38668,38669,38670,38671,38672,38673,38674,38675,38676,38677,38678,38679,38680,38681,38682,38683,38684,38685,38686,38687,38688,38689,38690,38691,38692,38693,38694,38695,38696,38697,38698,38699,38700,38701,38702,38703,38704,38705,38706,38707,38708,38709,38710,38711,38712,38713,38714,38715,38716,38717,38718,38719,38720,38721,38722,38723,38724,38725,38726,38727,38728,38729,38730,38731,38732,38733,38734,38735,38736,38737,38738,38739,38740,38741,38742,38743,38744,38745,38746,38747,38748,38749,38750,38751,38752,38753,38754,38755,38756,38757,38758,38759,38760,38761,38762,38763,38764,38765,38766,38767,38768,38769,38770,38771,38772,38773],false],[362,1612,0,null,null,null,null,false],[0,0,0,"syscall",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"waitpid",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"time",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"break",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"umount",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"stty",null,null,null,false],[0,0,0,"gtty",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"ftime",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"prof",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"signal",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"lock",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"mpx",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"ulimit",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"sgetmask",null,null,null,false],[0,0,0,"ssetmask",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"sigsuspend",null,null,null,false],[0,0,0,"sigpending",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"reserved82",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"readdir",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"profil",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"ioperm",null,null,null,false],[0,0,0,"socketcall",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"iopl",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"idle",null,null,null,false],[0,0,0,"vm86",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"ipc",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"sigreturn",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"modify_ldt",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"sigprocmask",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"bdflush",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"_llseek",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"cacheflush",null,null,null,false],[0,0,0,"cachectl",null,null,null,false],[0,0,0,"sysmips",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"recv",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"send",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"getpmsg",null,null,null,false],[0,0,0,"putpmsg",null,null,null,false],[0,0,0,"mmap2",null,null,null,false],[0,0,0,"truncate64",null,null,null,false],[0,0,0,"ftruncate64",null,null,null,false],[0,0,0,"stat64",null,null,null,false],[0,0,0,"lstat64",null,null,null,false],[0,0,0,"fstat64",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"fcntl64",null,null,null,false],[0,0,0,"reserved221",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"sendfile64",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"statfs64",null,null,null,false],[0,0,0,"fstatfs64",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"vserver",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"set_thread_area",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"clock_gettime64",null,null,null,false],[0,0,0,"clock_settime64",null,null,null,false],[0,0,0,"clock_adjtime64",null,null,null,false],[0,0,0,"clock_getres_time64",null,null,null,false],[0,0,0,"clock_nanosleep_time64",null,null,null,false],[0,0,0,"timer_gettime64",null,null,null,false],[0,0,0,"timer_settime64",null,null,null,false],[0,0,0,"timerfd_gettime64",null,null,null,false],[0,0,0,"timerfd_settime64",null,null,null,false],[0,0,0,"utimensat_time64",null,null,null,false],[0,0,0,"pselect6_time64",null,null,null,false],[0,0,0,"ppoll_time64",null,null,null,false],[0,0,0,"io_pgetevents_time64",null,null,null,false],[0,0,0,"recvmmsg_time64",null,null,null,false],[0,0,0,"mq_timedsend_time64",null,null,null,false],[0,0,0,"mq_timedreceive_time64",null,null,null,false],[0,0,0,"semtimedop_time64",null,null,null,false],[0,0,0,"rt_sigtimedwait_time64",null,null,null,false],[0,0,0,"futex_time64",null,null,null,false],[0,0,0,"sched_rr_get_interval_time64",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,2034,0,null,null,null,[38776,38777,38778,38779,38780,38781,38782,38783,38784,38785,38786,38787,38788,38789,38790,38791,38792,38793,38794,38795,38796,38797,38798,38799,38800,38801,38802,38803,38804,38805,38806,38807,38808,38809,38810,38811,38812,38813,38814,38815,38816,38817,38818,38819,38820,38821,38822,38823,38824,38825,38826,38827,38828,38829,38830,38831,38832,38833,38834,38835,38836,38837,38838,38839,38840,38841,38842,38843,38844,38845,38846,38847,38848,38849,38850,38851,38852,38853,38854,38855,38856,38857,38858,38859,38860,38861,38862,38863,38864,38865,38866,38867,38868,38869,38870,38871,38872,38873,38874,38875,38876,38877,38878,38879,38880,38881,38882,38883,38884,38885,38886,38887,38888,38889,38890,38891,38892,38893,38894,38895,38896,38897,38898,38899,38900,38901,38902,38903,38904,38905,38906,38907,38908,38909,38910,38911,38912,38913,38914,38915,38916,38917,38918,38919,38920,38921,38922,38923,38924,38925,38926,38927,38928,38929,38930,38931,38932,38933,38934,38935,38936,38937,38938,38939,38940,38941,38942,38943,38944,38945,38946,38947,38948,38949,38950,38951,38952,38953,38954,38955,38956,38957,38958,38959,38960,38961,38962,38963,38964,38965,38966,38967,38968,38969,38970,38971,38972,38973,38974,38975,38976,38977,38978,38979,38980,38981,38982,38983,38984,38985,38986,38987,38988,38989,38990,38991,38992,38993,38994,38995,38996,38997,38998,38999,39000,39001,39002,39003,39004,39005,39006,39007,39008,39009,39010,39011,39012,39013,39014,39015,39016,39017,39018,39019,39020,39021,39022,39023,39024,39025,39026,39027,39028,39029,39030,39031,39032,39033,39034,39035,39036,39037,39038,39039,39040,39041,39042,39043,39044,39045,39046,39047,39048,39049,39050,39051,39052,39053,39054,39055,39056,39057,39058,39059,39060,39061,39062,39063,39064,39065,39066,39067,39068,39069,39070,39071,39072,39073,39074,39075,39076,39077,39078,39079,39080,39081,39082,39083,39084,39085,39086,39087,39088,39089,39090,39091,39092,39093,39094,39095,39096,39097,39098,39099,39100,39101,39102,39103,39104,39105,39106,39107,39108,39109,39110,39111,39112,39113,39114,39115,39116,39117,39118,39119,39120,39121,39122,39123,39124,39125,39126,39127,39128,39129],false],[362,2035,0,null,null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semop",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"getpmsg",null,null,null,false],[0,0,0,"putpmsg",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"reserved177",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"reserved193",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"cacheflush",null,null,null,false],[0,0,0,"cachectl",null,null,null,false],[0,0,0,"sysmips",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"vserver",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"set_thread_area",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,2393,0,null,null,null,[39131,39132,39133,39134,39135,39136,39137,39138,39139,39140,39141,39142,39143,39144,39145,39146,39147,39148,39149,39150,39151,39152,39153,39154,39155,39156,39157,39158,39159,39160,39161,39162,39163,39164,39165,39166,39167,39168,39169,39170,39171,39172,39173,39174,39175,39176,39177,39178,39179,39180,39181,39182,39183,39184,39185,39186,39187,39188,39189,39190,39191,39192,39193,39194,39195,39196,39197,39198,39199,39200,39201,39202,39203,39204,39205,39206,39207,39208,39209,39210,39211,39212,39213,39214,39215,39216,39217,39218,39219,39220,39221,39222,39223,39224,39225,39226,39227,39228,39229,39230,39231,39232,39233,39234,39235,39236,39237,39238,39239,39240,39241,39242,39243,39244,39245,39246,39247,39248,39249,39250,39251,39252,39253,39254,39255,39256,39257,39258,39259,39260,39261,39262,39263,39264,39265,39266,39267,39268,39269,39270,39271,39272,39273,39274,39275,39276,39277,39278,39279,39280,39281,39282,39283,39284,39285,39286,39287,39288,39289,39290,39291,39292,39293,39294,39295,39296,39297,39298,39299,39300,39301,39302,39303,39304,39305,39306,39307,39308,39309,39310,39311,39312,39313,39314,39315,39316,39317,39318,39319,39320,39321,39322,39323,39324,39325,39326,39327,39328,39329,39330,39331,39332,39333,39334,39335,39336,39337,39338,39339,39340,39341,39342,39343,39344,39345,39346,39347,39348,39349,39350,39351,39352,39353,39354,39355,39356,39357,39358,39359,39360,39361,39362,39363,39364,39365,39366,39367,39368,39369,39370,39371,39372,39373,39374,39375,39376,39377,39378,39379,39380,39381,39382,39383,39384,39385,39386,39387,39388,39389,39390,39391,39392,39393,39394,39395,39396,39397,39398,39399,39400,39401,39402,39403,39404,39405,39406,39407,39408,39409,39410,39411,39412,39413,39414,39415,39416,39417,39418,39419,39420,39421,39422,39423,39424,39425,39426,39427,39428,39429,39430,39431,39432,39433,39434,39435,39436,39437,39438,39439,39440,39441,39442,39443,39444,39445,39446,39447,39448,39449,39450,39451,39452,39453,39454,39455,39456,39457,39458,39459,39460,39461,39462,39463,39464,39465,39466,39467,39468,39469,39470,39471,39472,39473,39474,39475,39476,39477,39478,39479,39480,39481,39482,39483,39484,39485,39486,39487,39488,39489,39490,39491,39492,39493,39494,39495,39496,39497,39498,39499,39500,39501,39502,39503,39504,39505,39506,39507,39508,39509,39510,39511,39512,39513,39514,39515,39516,39517,39518,39519,39520,39521,39522,39523,39524,39525,39526,39527,39528,39529,39530,39531,39532,39533,39534,39535,39536,39537,39538,39539,39540,39541,39542,39543,39544,39545,39546,39547,39548,39549,39550,39551,39552,39553,39554,39555,39556,39557,39558,39559,39560,39561],false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"waitpid",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"time",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"break",null,null,null,false],[0,0,0,"oldstat",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"umount",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"oldfstat",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"stty",null,null,null,false],[0,0,0,"gtty",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"ftime",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"prof",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"signal",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"lock",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"mpx",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"ulimit",null,null,null,false],[0,0,0,"oldolduname",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"sgetmask",null,null,null,false],[0,0,0,"ssetmask",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"sigsuspend",null,null,null,false],[0,0,0,"sigpending",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"select",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"oldlstat",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"readdir",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"profil",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"ioperm",null,null,null,false],[0,0,0,"socketcall",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"olduname",null,null,null,false],[0,0,0,"iopl",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"idle",null,null,null,false],[0,0,0,"vm86",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"ipc",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"sigreturn",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"modify_ldt",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"sigprocmask",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"bdflush",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"_llseek",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"getpmsg",null,null,null,false],[0,0,0,"putpmsg",null,null,null,false],[0,0,0,"vfork",null,null,null,false],[0,0,0,"ugetrlimit",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"mmap2",null,null,null,false],[0,0,0,"truncate64",null,null,null,false],[0,0,0,"ftruncate64",null,null,null,false],[0,0,0,"stat64",null,null,null,false],[0,0,0,"lstat64",null,null,null,false],[0,0,0,"fstat64",null,null,null,false],[0,0,0,"pciconfig_read",null,null,null,false],[0,0,0,"pciconfig_write",null,null,null,false],[0,0,0,"pciconfig_iobase",null,null,null,false],[0,0,0,"multiplexer",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"fcntl64",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"tuxcall",null,null,null,false],[0,0,0,"sendfile64",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"swapcontext",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"statfs64",null,null,null,false],[0,0,0,"fstatfs64",null,null,null,false],[0,0,0,"fadvise64_64",null,null,null,false],[0,0,0,"rtas",null,null,null,false],[0,0,0,"sys_debug_setcontext",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"spu_run",null,null,null,false],[0,0,0,"spu_create",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"subpage_prot",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"send",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recv",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"switch_endian",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"kexec_file_load",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"clock_gettime64",null,null,null,false],[0,0,0,"clock_settime64",null,null,null,false],[0,0,0,"clock_adjtime64",null,null,null,false],[0,0,0,"clock_getres_time64",null,null,null,false],[0,0,0,"clock_nanosleep_time64",null,null,null,false],[0,0,0,"timer_gettime64",null,null,null,false],[0,0,0,"timer_settime64",null,null,null,false],[0,0,0,"timerfd_gettime64",null,null,null,false],[0,0,0,"timerfd_settime64",null,null,null,false],[0,0,0,"utimensat_time64",null,null,null,false],[0,0,0,"pselect6_time64",null,null,null,false],[0,0,0,"ppoll_time64",null,null,null,false],[0,0,0,"io_pgetevents_time64",null,null,null,false],[0,0,0,"recvmmsg_time64",null,null,null,false],[0,0,0,"mq_timedsend_time64",null,null,null,false],[0,0,0,"mq_timedreceive_time64",null,null,null,false],[0,0,0,"semtimedop_time64",null,null,null,false],[0,0,0,"rt_sigtimedwait_time64",null,null,null,false],[0,0,0,"futex_time64",null,null,null,false],[0,0,0,"sched_rr_get_interval_time64",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,2827,0,null,null,null,[39563,39564,39565,39566,39567,39568,39569,39570,39571,39572,39573,39574,39575,39576,39577,39578,39579,39580,39581,39582,39583,39584,39585,39586,39587,39588,39589,39590,39591,39592,39593,39594,39595,39596,39597,39598,39599,39600,39601,39602,39603,39604,39605,39606,39607,39608,39609,39610,39611,39612,39613,39614,39615,39616,39617,39618,39619,39620,39621,39622,39623,39624,39625,39626,39627,39628,39629,39630,39631,39632,39633,39634,39635,39636,39637,39638,39639,39640,39641,39642,39643,39644,39645,39646,39647,39648,39649,39650,39651,39652,39653,39654,39655,39656,39657,39658,39659,39660,39661,39662,39663,39664,39665,39666,39667,39668,39669,39670,39671,39672,39673,39674,39675,39676,39677,39678,39679,39680,39681,39682,39683,39684,39685,39686,39687,39688,39689,39690,39691,39692,39693,39694,39695,39696,39697,39698,39699,39700,39701,39702,39703,39704,39705,39706,39707,39708,39709,39710,39711,39712,39713,39714,39715,39716,39717,39718,39719,39720,39721,39722,39723,39724,39725,39726,39727,39728,39729,39730,39731,39732,39733,39734,39735,39736,39737,39738,39739,39740,39741,39742,39743,39744,39745,39746,39747,39748,39749,39750,39751,39752,39753,39754,39755,39756,39757,39758,39759,39760,39761,39762,39763,39764,39765,39766,39767,39768,39769,39770,39771,39772,39773,39774,39775,39776,39777,39778,39779,39780,39781,39782,39783,39784,39785,39786,39787,39788,39789,39790,39791,39792,39793,39794,39795,39796,39797,39798,39799,39800,39801,39802,39803,39804,39805,39806,39807,39808,39809,39810,39811,39812,39813,39814,39815,39816,39817,39818,39819,39820,39821,39822,39823,39824,39825,39826,39827,39828,39829,39830,39831,39832,39833,39834,39835,39836,39837,39838,39839,39840,39841,39842,39843,39844,39845,39846,39847,39848,39849,39850,39851,39852,39853,39854,39855,39856,39857,39858,39859,39860,39861,39862,39863,39864,39865,39866,39867,39868,39869,39870,39871,39872,39873,39874,39875,39876,39877,39878,39879,39880,39881,39882,39883,39884,39885,39886,39887,39888,39889,39890,39891,39892,39893,39894,39895,39896,39897,39898,39899,39900,39901,39902,39903,39904,39905,39906,39907,39908,39909,39910,39911,39912,39913,39914,39915,39916,39917,39918,39919,39920,39921,39922,39923,39924,39925,39926,39927,39928,39929,39930,39931,39932,39933,39934,39935,39936,39937,39938,39939,39940,39941,39942,39943,39944,39945,39946,39947,39948,39949,39950,39951,39952,39953,39954,39955,39956,39957,39958,39959,39960,39961,39962,39963,39964,39965],false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"fork",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"open",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"waitpid",null,null,null,false],[0,0,0,"creat",null,null,null,false],[0,0,0,"link",null,null,null,false],[0,0,0,"unlink",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"time",null,null,null,false],[0,0,0,"mknod",null,null,null,false],[0,0,0,"chmod",null,null,null,false],[0,0,0,"lchown",null,null,null,false],[0,0,0,"break",null,null,null,false],[0,0,0,"oldstat",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"umount",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"alarm",null,null,null,false],[0,0,0,"oldfstat",null,null,null,false],[0,0,0,"pause",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"stty",null,null,null,false],[0,0,0,"gtty",null,null,null,false],[0,0,0,"access",null,null,null,false],[0,0,0,"nice",null,null,null,false],[0,0,0,"ftime",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"rename",null,null,null,false],[0,0,0,"mkdir",null,null,null,false],[0,0,0,"rmdir",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"prof",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"signal",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"lock",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"mpx",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"ulimit",null,null,null,false],[0,0,0,"oldolduname",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"ustat",null,null,null,false],[0,0,0,"dup2",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getpgrp",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"sgetmask",null,null,null,false],[0,0,0,"ssetmask",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"sigsuspend",null,null,null,false],[0,0,0,"sigpending",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"select",null,null,null,false],[0,0,0,"symlink",null,null,null,false],[0,0,0,"oldlstat",null,null,null,false],[0,0,0,"readlink",null,null,null,false],[0,0,0,"uselib",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"readdir",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"profil",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"ioperm",null,null,null,false],[0,0,0,"socketcall",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"stat",null,null,null,false],[0,0,0,"lstat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"olduname",null,null,null,false],[0,0,0,"iopl",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"idle",null,null,null,false],[0,0,0,"vm86",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"ipc",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"sigreturn",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"modify_ldt",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"sigprocmask",null,null,null,false],[0,0,0,"create_module",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"get_kernel_syms",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"bdflush",null,null,null,false],[0,0,0,"sysfs",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"afs_syscall",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"_llseek",null,null,null,false],[0,0,0,"getdents",null,null,null,false],[0,0,0,"_newselect",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"_sysctl",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"query_module",null,null,null,false],[0,0,0,"poll",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"chown",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"getpmsg",null,null,null,false],[0,0,0,"putpmsg",null,null,null,false],[0,0,0,"vfork",null,null,null,false],[0,0,0,"ugetrlimit",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"pciconfig_read",null,null,null,false],[0,0,0,"pciconfig_write",null,null,null,false],[0,0,0,"pciconfig_iobase",null,null,null,false],[0,0,0,"multiplexer",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"tuxcall",null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"epoll_create",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_wait",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"swapcontext",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"utimes",null,null,null,false],[0,0,0,"statfs64",null,null,null,false],[0,0,0,"fstatfs64",null,null,null,false],[0,0,0,"rtas",null,null,null,false],[0,0,0,"sys_debug_setcontext",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"inotify_init",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"spu_run",null,null,null,false],[0,0,0,"spu_create",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"futimesat",null,null,null,false],[0,0,0,"fstatat64",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"signalfd",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"eventfd",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"subpage_prot",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"send",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recv",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"switch_endian",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"kexec_file_load",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,3233,0,null,null,null,[39967,39968,39969,39970,39971,39972,39973,39974,39975,39976,39977,39978,39979,39980,39981,39982,39983,39984,39985,39986,39987,39988,39989,39990,39991,39992,39993,39994,39995,39996,39997,39998,39999,40000,40001,40002,40003,40004,40005,40006,40007,40008,40009,40010,40011,40012,40013,40014,40015,40016,40017,40018,40019,40020,40021,40022,40023,40024,40025,40026,40027,40028,40029,40030,40031,40032,40033,40034,40035,40036,40037,40038,40039,40040,40041,40042,40043,40044,40045,40046,40047,40048,40049,40050,40051,40052,40053,40054,40055,40056,40057,40058,40059,40060,40061,40062,40063,40064,40065,40066,40067,40068,40069,40070,40071,40072,40073,40074,40075,40076,40077,40078,40079,40080,40081,40082,40083,40084,40085,40086,40087,40088,40089,40090,40091,40092,40093,40094,40095,40096,40097,40098,40099,40100,40101,40102,40103,40104,40105,40106,40107,40108,40109,40110,40111,40112,40113,40114,40115,40116,40117,40118,40119,40120,40121,40122,40123,40124,40125,40126,40127,40128,40129,40130,40131,40132,40133,40134,40135,40136,40137,40138,40139,40140,40141,40142,40143,40144,40145,40146,40147,40148,40149,40150,40151,40152,40153,40154,40155,40156,40157,40158,40159,40160,40161,40162,40163,40164,40165,40166,40167,40168,40169,40170,40171,40172,40173,40174,40175,40176,40177,40178,40179,40180,40181,40182,40183,40184,40185,40186,40187,40188,40189,40190,40191,40192,40193,40194,40195,40196,40197,40198,40199,40200,40201,40202,40203,40204,40205,40206,40207,40208,40209,40210,40211,40212,40213,40214,40215,40216,40217,40218,40219,40220,40221,40222,40223,40224,40225,40226,40227,40228,40229,40230,40231,40232,40233,40234,40235,40236,40237,40238,40239,40240,40241,40242,40243,40244,40245,40246,40247,40248,40249,40250,40251,40252,40253,40254,40255,40256,40257,40258,40259,40260,40261,40262,40263,40264,40265,40266,40267,40268,40269,40270,40271,40272],false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"renameat",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fstatat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"semop",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"kexec_file_load",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"memfd_secret",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[362,3542,0,null,null,null,[40275,40276,40277,40278,40279,40280,40281,40282,40283,40284,40285,40286,40287,40288,40289,40290,40291,40292,40293,40294,40295,40296,40297,40298,40299,40300,40301,40302,40303,40304,40305,40306,40307,40308,40309,40310,40311,40312,40313,40314,40315,40316,40317,40318,40319,40320,40321,40322,40323,40324,40325,40326,40327,40328,40329,40330,40331,40332,40333,40334,40335,40336,40337,40338,40339,40340,40341,40342,40343,40344,40345,40346,40347,40348,40349,40350,40351,40352,40353,40354,40355,40356,40357,40358,40359,40360,40361,40362,40363,40364,40365,40366,40367,40368,40369,40370,40371,40372,40373,40374,40375,40376,40377,40378,40379,40380,40381,40382,40383,40384,40385,40386,40387,40388,40389,40390,40391,40392,40393,40394,40395,40396,40397,40398,40399,40400,40401,40402,40403,40404,40405,40406,40407,40408,40409,40410,40411,40412,40413,40414,40415,40416,40417,40418,40419,40420,40421,40422,40423,40424,40425,40426,40427,40428,40429,40430,40431,40432,40433,40434,40435,40436,40437,40438,40439,40440,40441,40442,40443,40444,40445,40446,40447,40448,40449,40450,40451,40452,40453,40454,40455,40456,40457,40458,40459,40460,40461,40462,40463,40464,40465,40466,40467,40468,40469,40470,40471,40472,40473,40474,40475,40476,40477,40478,40479,40480,40481,40482,40483,40484,40485,40486,40487,40488,40489,40490,40491,40492,40493,40494,40495,40496,40497,40498,40499,40500,40501,40502,40503,40504,40505,40506,40507,40508,40509,40510,40511,40512,40513,40514,40515,40516,40517,40518,40519,40520,40521,40522,40523,40524,40525,40526,40527,40528,40529,40530,40531,40532,40533,40534,40535,40536,40537,40538,40539,40540,40541,40542,40543,40544,40545,40546,40547,40548,40549,40550,40551,40552,40553,40554,40555,40556,40557,40558,40559,40560,40561,40562,40563,40564,40565,40566,40567,40568,40569,40570,40571,40572,40573,40574,40575,40576,40577,40578,40579,40580],false],[362,3543,0,null,null,null,null,false],[0,0,0,"io_setup",null,null,null,false],[0,0,0,"io_destroy",null,null,null,false],[0,0,0,"io_submit",null,null,null,false],[0,0,0,"io_cancel",null,null,null,false],[0,0,0,"io_getevents",null,null,null,false],[0,0,0,"setxattr",null,null,null,false],[0,0,0,"lsetxattr",null,null,null,false],[0,0,0,"fsetxattr",null,null,null,false],[0,0,0,"getxattr",null,null,null,false],[0,0,0,"lgetxattr",null,null,null,false],[0,0,0,"fgetxattr",null,null,null,false],[0,0,0,"listxattr",null,null,null,false],[0,0,0,"llistxattr",null,null,null,false],[0,0,0,"flistxattr",null,null,null,false],[0,0,0,"removexattr",null,null,null,false],[0,0,0,"lremovexattr",null,null,null,false],[0,0,0,"fremovexattr",null,null,null,false],[0,0,0,"getcwd",null,null,null,false],[0,0,0,"lookup_dcookie",null,null,null,false],[0,0,0,"eventfd2",null,null,null,false],[0,0,0,"epoll_create1",null,null,null,false],[0,0,0,"epoll_ctl",null,null,null,false],[0,0,0,"epoll_pwait",null,null,null,false],[0,0,0,"dup",null,null,null,false],[0,0,0,"dup3",null,null,null,false],[0,0,0,"fcntl",null,null,null,false],[0,0,0,"inotify_init1",null,null,null,false],[0,0,0,"inotify_add_watch",null,null,null,false],[0,0,0,"inotify_rm_watch",null,null,null,false],[0,0,0,"ioctl",null,null,null,false],[0,0,0,"ioprio_set",null,null,null,false],[0,0,0,"ioprio_get",null,null,null,false],[0,0,0,"flock",null,null,null,false],[0,0,0,"mknodat",null,null,null,false],[0,0,0,"mkdirat",null,null,null,false],[0,0,0,"unlinkat",null,null,null,false],[0,0,0,"symlinkat",null,null,null,false],[0,0,0,"linkat",null,null,null,false],[0,0,0,"umount2",null,null,null,false],[0,0,0,"mount",null,null,null,false],[0,0,0,"pivot_root",null,null,null,false],[0,0,0,"nfsservctl",null,null,null,false],[0,0,0,"statfs",null,null,null,false],[0,0,0,"fstatfs",null,null,null,false],[0,0,0,"truncate",null,null,null,false],[0,0,0,"ftruncate",null,null,null,false],[0,0,0,"fallocate",null,null,null,false],[0,0,0,"faccessat",null,null,null,false],[0,0,0,"chdir",null,null,null,false],[0,0,0,"fchdir",null,null,null,false],[0,0,0,"chroot",null,null,null,false],[0,0,0,"fchmod",null,null,null,false],[0,0,0,"fchmodat",null,null,null,false],[0,0,0,"fchownat",null,null,null,false],[0,0,0,"fchown",null,null,null,false],[0,0,0,"openat",null,null,null,false],[0,0,0,"close",null,null,null,false],[0,0,0,"vhangup",null,null,null,false],[0,0,0,"pipe2",null,null,null,false],[0,0,0,"quotactl",null,null,null,false],[0,0,0,"getdents64",null,null,null,false],[0,0,0,"lseek",null,null,null,false],[0,0,0,"read",null,null,null,false],[0,0,0,"write",null,null,null,false],[0,0,0,"readv",null,null,null,false],[0,0,0,"writev",null,null,null,false],[0,0,0,"pread64",null,null,null,false],[0,0,0,"pwrite64",null,null,null,false],[0,0,0,"preadv",null,null,null,false],[0,0,0,"pwritev",null,null,null,false],[0,0,0,"sendfile",null,null,null,false],[0,0,0,"pselect6",null,null,null,false],[0,0,0,"ppoll",null,null,null,false],[0,0,0,"signalfd4",null,null,null,false],[0,0,0,"vmsplice",null,null,null,false],[0,0,0,"splice",null,null,null,false],[0,0,0,"tee",null,null,null,false],[0,0,0,"readlinkat",null,null,null,false],[0,0,0,"fstatat",null,null,null,false],[0,0,0,"fstat",null,null,null,false],[0,0,0,"sync",null,null,null,false],[0,0,0,"fsync",null,null,null,false],[0,0,0,"fdatasync",null,null,null,false],[0,0,0,"sync_file_range",null,null,null,false],[0,0,0,"timerfd_create",null,null,null,false],[0,0,0,"timerfd_settime",null,null,null,false],[0,0,0,"timerfd_gettime",null,null,null,false],[0,0,0,"utimensat",null,null,null,false],[0,0,0,"acct",null,null,null,false],[0,0,0,"capget",null,null,null,false],[0,0,0,"capset",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"exit",null,null,null,false],[0,0,0,"exit_group",null,null,null,false],[0,0,0,"waitid",null,null,null,false],[0,0,0,"set_tid_address",null,null,null,false],[0,0,0,"unshare",null,null,null,false],[0,0,0,"futex",null,null,null,false],[0,0,0,"set_robust_list",null,null,null,false],[0,0,0,"get_robust_list",null,null,null,false],[0,0,0,"nanosleep",null,null,null,false],[0,0,0,"getitimer",null,null,null,false],[0,0,0,"setitimer",null,null,null,false],[0,0,0,"kexec_load",null,null,null,false],[0,0,0,"init_module",null,null,null,false],[0,0,0,"delete_module",null,null,null,false],[0,0,0,"timer_create",null,null,null,false],[0,0,0,"timer_gettime",null,null,null,false],[0,0,0,"timer_getoverrun",null,null,null,false],[0,0,0,"timer_settime",null,null,null,false],[0,0,0,"timer_delete",null,null,null,false],[0,0,0,"clock_settime",null,null,null,false],[0,0,0,"clock_gettime",null,null,null,false],[0,0,0,"clock_getres",null,null,null,false],[0,0,0,"clock_nanosleep",null,null,null,false],[0,0,0,"syslog",null,null,null,false],[0,0,0,"ptrace",null,null,null,false],[0,0,0,"sched_setparam",null,null,null,false],[0,0,0,"sched_setscheduler",null,null,null,false],[0,0,0,"sched_getscheduler",null,null,null,false],[0,0,0,"sched_getparam",null,null,null,false],[0,0,0,"sched_setaffinity",null,null,null,false],[0,0,0,"sched_getaffinity",null,null,null,false],[0,0,0,"sched_yield",null,null,null,false],[0,0,0,"sched_get_priority_max",null,null,null,false],[0,0,0,"sched_get_priority_min",null,null,null,false],[0,0,0,"sched_rr_get_interval",null,null,null,false],[0,0,0,"restart_syscall",null,null,null,false],[0,0,0,"kill",null,null,null,false],[0,0,0,"tkill",null,null,null,false],[0,0,0,"tgkill",null,null,null,false],[0,0,0,"sigaltstack",null,null,null,false],[0,0,0,"rt_sigsuspend",null,null,null,false],[0,0,0,"rt_sigaction",null,null,null,false],[0,0,0,"rt_sigprocmask",null,null,null,false],[0,0,0,"rt_sigpending",null,null,null,false],[0,0,0,"rt_sigtimedwait",null,null,null,false],[0,0,0,"rt_sigqueueinfo",null,null,null,false],[0,0,0,"rt_sigreturn",null,null,null,false],[0,0,0,"setpriority",null,null,null,false],[0,0,0,"getpriority",null,null,null,false],[0,0,0,"reboot",null,null,null,false],[0,0,0,"setregid",null,null,null,false],[0,0,0,"setgid",null,null,null,false],[0,0,0,"setreuid",null,null,null,false],[0,0,0,"setuid",null,null,null,false],[0,0,0,"setresuid",null,null,null,false],[0,0,0,"getresuid",null,null,null,false],[0,0,0,"setresgid",null,null,null,false],[0,0,0,"getresgid",null,null,null,false],[0,0,0,"setfsuid",null,null,null,false],[0,0,0,"setfsgid",null,null,null,false],[0,0,0,"times",null,null,null,false],[0,0,0,"setpgid",null,null,null,false],[0,0,0,"getpgid",null,null,null,false],[0,0,0,"getsid",null,null,null,false],[0,0,0,"setsid",null,null,null,false],[0,0,0,"getgroups",null,null,null,false],[0,0,0,"setgroups",null,null,null,false],[0,0,0,"uname",null,null,null,false],[0,0,0,"sethostname",null,null,null,false],[0,0,0,"setdomainname",null,null,null,false],[0,0,0,"getrlimit",null,null,null,false],[0,0,0,"setrlimit",null,null,null,false],[0,0,0,"getrusage",null,null,null,false],[0,0,0,"umask",null,null,null,false],[0,0,0,"prctl",null,null,null,false],[0,0,0,"getcpu",null,null,null,false],[0,0,0,"gettimeofday",null,null,null,false],[0,0,0,"settimeofday",null,null,null,false],[0,0,0,"adjtimex",null,null,null,false],[0,0,0,"getpid",null,null,null,false],[0,0,0,"getppid",null,null,null,false],[0,0,0,"getuid",null,null,null,false],[0,0,0,"geteuid",null,null,null,false],[0,0,0,"getgid",null,null,null,false],[0,0,0,"getegid",null,null,null,false],[0,0,0,"gettid",null,null,null,false],[0,0,0,"sysinfo",null,null,null,false],[0,0,0,"mq_open",null,null,null,false],[0,0,0,"mq_unlink",null,null,null,false],[0,0,0,"mq_timedsend",null,null,null,false],[0,0,0,"mq_timedreceive",null,null,null,false],[0,0,0,"mq_notify",null,null,null,false],[0,0,0,"mq_getsetattr",null,null,null,false],[0,0,0,"msgget",null,null,null,false],[0,0,0,"msgctl",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"semget",null,null,null,false],[0,0,0,"semctl",null,null,null,false],[0,0,0,"semtimedop",null,null,null,false],[0,0,0,"semop",null,null,null,false],[0,0,0,"shmget",null,null,null,false],[0,0,0,"shmctl",null,null,null,false],[0,0,0,"shmat",null,null,null,false],[0,0,0,"shmdt",null,null,null,false],[0,0,0,"socket",null,null,null,false],[0,0,0,"socketpair",null,null,null,false],[0,0,0,"bind",null,null,null,false],[0,0,0,"listen",null,null,null,false],[0,0,0,"accept",null,null,null,false],[0,0,0,"connect",null,null,null,false],[0,0,0,"getsockname",null,null,null,false],[0,0,0,"getpeername",null,null,null,false],[0,0,0,"sendto",null,null,null,false],[0,0,0,"recvfrom",null,null,null,false],[0,0,0,"setsockopt",null,null,null,false],[0,0,0,"getsockopt",null,null,null,false],[0,0,0,"shutdown",null,null,null,false],[0,0,0,"sendmsg",null,null,null,false],[0,0,0,"recvmsg",null,null,null,false],[0,0,0,"readahead",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"munmap",null,null,null,false],[0,0,0,"mremap",null,null,null,false],[0,0,0,"add_key",null,null,null,false],[0,0,0,"request_key",null,null,null,false],[0,0,0,"keyctl",null,null,null,false],[0,0,0,"clone",null,null,null,false],[0,0,0,"execve",null,null,null,false],[0,0,0,"mmap",null,null,null,false],[0,0,0,"fadvise64",null,null,null,false],[0,0,0,"swapon",null,null,null,false],[0,0,0,"swapoff",null,null,null,false],[0,0,0,"mprotect",null,null,null,false],[0,0,0,"msync",null,null,null,false],[0,0,0,"mlock",null,null,null,false],[0,0,0,"munlock",null,null,null,false],[0,0,0,"mlockall",null,null,null,false],[0,0,0,"munlockall",null,null,null,false],[0,0,0,"mincore",null,null,null,false],[0,0,0,"madvise",null,null,null,false],[0,0,0,"remap_file_pages",null,null,null,false],[0,0,0,"mbind",null,null,null,false],[0,0,0,"get_mempolicy",null,null,null,false],[0,0,0,"set_mempolicy",null,null,null,false],[0,0,0,"migrate_pages",null,null,null,false],[0,0,0,"move_pages",null,null,null,false],[0,0,0,"rt_tgsigqueueinfo",null,null,null,false],[0,0,0,"perf_event_open",null,null,null,false],[0,0,0,"accept4",null,null,null,false],[0,0,0,"recvmmsg",null,null,null,false],[0,0,0,"wait4",null,null,null,false],[0,0,0,"prlimit64",null,null,null,false],[0,0,0,"fanotify_init",null,null,null,false],[0,0,0,"fanotify_mark",null,null,null,false],[0,0,0,"name_to_handle_at",null,null,null,false],[0,0,0,"open_by_handle_at",null,null,null,false],[0,0,0,"clock_adjtime",null,null,null,false],[0,0,0,"syncfs",null,null,null,false],[0,0,0,"setns",null,null,null,false],[0,0,0,"sendmmsg",null,null,null,false],[0,0,0,"process_vm_readv",null,null,null,false],[0,0,0,"process_vm_writev",null,null,null,false],[0,0,0,"kcmp",null,null,null,false],[0,0,0,"finit_module",null,null,null,false],[0,0,0,"sched_setattr",null,null,null,false],[0,0,0,"sched_getattr",null,null,null,false],[0,0,0,"renameat2",null,null,null,false],[0,0,0,"seccomp",null,null,null,false],[0,0,0,"getrandom",null,null,null,false],[0,0,0,"memfd_create",null,null,null,false],[0,0,0,"bpf",null,null,null,false],[0,0,0,"execveat",null,null,null,false],[0,0,0,"userfaultfd",null,null,null,false],[0,0,0,"membarrier",null,null,null,false],[0,0,0,"mlock2",null,null,null,false],[0,0,0,"copy_file_range",null,null,null,false],[0,0,0,"preadv2",null,null,null,false],[0,0,0,"pwritev2",null,null,null,false],[0,0,0,"pkey_mprotect",null,null,null,false],[0,0,0,"pkey_alloc",null,null,null,false],[0,0,0,"pkey_free",null,null,null,false],[0,0,0,"statx",null,null,null,false],[0,0,0,"io_pgetevents",null,null,null,false],[0,0,0,"rseq",null,null,null,false],[0,0,0,"kexec_file_load",null,null,null,false],[0,0,0,"pidfd_send_signal",null,null,null,false],[0,0,0,"io_uring_setup",null,null,null,false],[0,0,0,"io_uring_enter",null,null,null,false],[0,0,0,"io_uring_register",null,null,null,false],[0,0,0,"open_tree",null,null,null,false],[0,0,0,"move_mount",null,null,null,false],[0,0,0,"fsopen",null,null,null,false],[0,0,0,"fsconfig",null,null,null,false],[0,0,0,"fsmount",null,null,null,false],[0,0,0,"fspick",null,null,null,false],[0,0,0,"pidfd_open",null,null,null,false],[0,0,0,"clone3",null,null,null,false],[0,0,0,"close_range",null,null,null,false],[0,0,0,"openat2",null,null,null,false],[0,0,0,"pidfd_getfd",null,null,null,false],[0,0,0,"faccessat2",null,null,null,false],[0,0,0,"process_madvise",null,null,null,false],[0,0,0,"epoll_pwait2",null,null,null,false],[0,0,0,"mount_setattr",null,null,null,false],[0,0,0,"quotactl_fd",null,null,null,false],[0,0,0,"landlock_create_ruleset",null,null,null,false],[0,0,0,"landlock_add_rule",null,null,null,false],[0,0,0,"landlock_restrict_self",null,null,null,false],[0,0,0,"memfd_secret",null,null,null,false],[0,0,0,"process_mrelease",null,null,null,false],[0,0,0,"futex_waitv",null,null,null,false],[0,0,0,"set_mempolicy_home_node",null,null,null,false],[0,0,0,"riscv_flush_icache",null,null,null,false],[351,97,0,null,null,null,null,false],[351,111,0,null,null,null,[],false],[351,112,0,null,null,null,null,false],[351,115,0,null,null," Share changes",null,false],[351,117,0,null,null," Changes are private",null,false],[351,119,0,null,null," share + validate extension flags",null,false],[351,121,0,null,null," Mask for type of mapping",null,false],[351,123,0,null,null," Interpret addr exactly",null,false],[351,125,0,null,null," don't use a file",null,false],[351,128,0,null,null," populate (prefault) pagetables",null,false],[351,130,0,null,null," do not block on IO",null,false],[351,132,0,null,null," give out an address that is best suited for process/thread stacks",null,false],[351,134,0,null,null," create a huge page mapping",null,false],[351,136,0,null,null," perform synchronous page faults for the mapping",null,false],[351,138,0,null,null," MAP_FIXED which doesn't unmap underlying mapping",null,false],[351,140,0,null,null," For anonymous mmap, memory could be uninitialized",null,false],[351,143,0,null,null,null,[],false],[351,144,0,null,null,null,null,false],[351,146,0,null,null,null,null,false],[351,147,0,null,null,null,null,false],[351,148,0,null,null,null,null,false],[351,154,0,null,null," Set by startup code, used by `getauxval`.",null,false],[351,171,0,null,null,null,[40604],false],[0,0,0,"index",null,"",null,false],[351,183,0,null,null,null,null,false],[351,191,0,null,null,null,[40607],false],[0,0,0,"val",null,"",null,false],[351,198,0,null,null,null,[40609],false],[0,0,0,"val",null,"",null,false],[351,205,0,null,null,null,[40611],false],[0,0,0,"val",null,"",null,false],[351,220,0,null,null," Get the errno from a syscall return value, or 0 for no error.",[40613],false],[0,0,0,"r",null,"",null,false],[351,226,0,null,null,null,[40615],false],[0,0,0,"old",null,"",null,false],[351,230,0,null,null,null,[40617,40618],false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[351,246,0,null,null,null,[40620,40621,40622],false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,250,0,null,null,null,[40624],false],[0,0,0,"path",null,"",null,false],[351,254,0,null,null,null,[40626],false],[0,0,0,"fd",null,"",null,false],[351,258,0,null,null,null,[40628],false],[0,0,0,"path",null,"",null,false],[351,262,0,null,null,null,[40630,40631,40632],false],[0,0,0,"path",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"envp",null,"",null,false],[351,266,0,null,null,null,[],false],[351,281,0,null,null," This must be inline, and inline call the syscall function, because if the\n child does a return it will clobber the parent's stack.\n It is advised to avoid this function and use clone instead, because\n the compiler is not aware of how vfork affects control flow and you may\n see different results in optimized builds.",[],false],[351,285,0,null,null,null,[40636,40637],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"times",null,"",null,false],[351,289,0,null,null,null,[40639,40640,40641,40642],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"times",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,293,0,null,null,null,[40644,40645,40646,40647],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"length",null,"",null,false],[351,317,0,null,null,null,[40649,40650,40651,40652],false],[0,0,0,"uaddr",null,"",null,false],[0,0,0,"futex_op",null,"",null,false],[0,0,0,"val",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[351,321,0,null,null,null,[40654,40655,40656],false],[0,0,0,"uaddr",null,"",null,false],[0,0,0,"futex_op",null,"",null,false],[0,0,0,"val",null,"",null,false],[351,325,0,null,null,null,[40658,40659],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,329,0,null,null,null,[40661,40662,40663],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"dirp",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,338,0,null,null,null,[40665,40666,40667],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"dirp",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,347,0,null,null,null,[40669],false],[0,0,0,"flags",null,"",null,false],[351,351,0,null,null,null,[40671,40672,40673],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"mask",null,"",null,false],[351,355,0,null,null,null,[40675,40676],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"wd",null,"",null,false],[351,359,0,null,null,null,[40678,40679,40680],false],[0,0,0,"path",null,"",null,false],[0,0,0,"buf_ptr",null,"",null,false],[0,0,0,"buf_len",null,"",null,false],[351,367,0,null,null,null,[40682,40683,40684,40685],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"buf_ptr",null,"",null,false],[0,0,0,"buf_len",null,"",null,false],[351,371,0,null,null,null,[40687,40688],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[351,379,0,null,null,null,[40690,40691,40692],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[351,383,0,null,null,null,[40694,40695,40696],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"dev",null,"",null,false],[351,391,0,null,null,null,[40698,40699,40700,40701],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"dev",null,"",null,false],[351,395,0,null,null,null,[40703,40704,40705,40706,40707],false],[0,0,0,"special",null,"",null,false],[0,0,0,"dir",null,"",null,false],[0,0,0,"fstype",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"data",null,"",null,false],[351,399,0,null,null,null,[40709],false],[0,0,0,"special",null,"",null,false],[351,403,0,null,null,null,[40711,40712],false],[0,0,0,"special",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,407,0,null,null,null,[40714,40715,40716,40717,40718,40719],false],[0,0,0,"address",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"prot",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[351,435,0,null,null,null,[40721,40722,40723],false],[0,0,0,"address",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"protection",null,"",null,false],[351,439,0,null,null,null,[],false],[351,440,0,null,null,null,null,false],[351,441,0,null,null,null,null,false],[351,442,0,null,null,null,null,false],[351,445,0,null,null,null,[40729,40730,40731],false],[0,0,0,"address",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,449,0,null,null,null,[40733,40734],false],[0,0,0,"address",null,"",null,false],[0,0,0,"length",null,"",null,false],[351,453,0,null,null,null,[40736,40737,40738],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[351,474,0,null,null,null,[40740,40741,40742,40743],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"sigmask",null,"",null,false],[351,478,0,null,null,null,[40745,40746,40747],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[351,482,0,null,null,null,[40749,40750,40751,40752],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[351,497,0,null,null,null,[40754,40755,40756,40757,40758],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,511,0,null,null,null,[40760,40761,40762],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"count",null,"",null,false],[351,515,0,null,null,null,[40764,40765,40766],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"count",null,"",null,false],[351,519,0,null,null,null,[40768,40769,40770,40771],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[351,532,0,null,null,null,[40773,40774,40775,40776,40777],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,546,0,null,null,null,[40779],false],[0,0,0,"path",null,"",null,false],[351,554,0,null,null,null,[40781,40782],false],[0,0,0,"existing",null,"",null,false],[0,0,0,"new",null,"",null,false],[351,562,0,null,null,null,[40784,40785,40786],false],[0,0,0,"existing",null,"",null,false],[0,0,0,"newfd",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[351,566,0,null,null,null,[40788,40789,40790,40791],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[351,605,0,null,null,null,[40793,40794],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[351,613,0,null,null,null,[40796,40797,40798,40799],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,617,0,null,null,null,[40801],false],[0,0,0,"fd",null,"",null,false],[351,627,0,null,null,null,[40803,40804],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,631,0,null,null,null,[40806,40807,40808],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[351,635,0,null,null,null,[40810,40811],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"length",null,"",null,false],[351,663,0,null,null,null,[40813,40814,40815,40816],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[351,703,0,null,null,null,[40818,40819],false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[351,713,0,null,null,null,[40821,40822,40823,40824],false],[0,0,0,"oldfd",null,"",null,false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newfd",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[351,734,0,null,null,null,[40826,40827,40828,40829,40830],false],[0,0,0,"oldfd",null,"",null,false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newfd",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,745,0,null,null,null,[40832,40833,40834],false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"perm",null,"",null,false],[351,759,0,null,null,null,[40836,40837],false],[0,0,0,"path",null,"",null,false],[0,0,0,"perm",null,"",null,false],[351,763,0,null,null,null,[40839,40840,40841,40842],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[351,769,0,null,null," See also `clone` (from the arch-specific include)",[40844,40845,40846,40847,40848],false],[0,0,0,"flags",null,"",null,false],[0,0,0,"child_stack_ptr",null,"",null,false],[0,0,0,"parent_tid",null,"",null,false],[0,0,0,"child_tid",null,"",null,false],[0,0,0,"newtls",null,"",null,false],[351,774,0,null,null," See also `clone` (from the arch-specific include)",[40850,40851],false],[0,0,0,"flags",null,"",null,false],[0,0,0,"child_stack_ptr",null,"",null,false],[351,778,0,null,null,null,[40853],false],[0,0,0,"fd",null,"",null,false],[351,782,0,null,null,null,[40855,40856],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mode",null,"",null,false],[351,786,0,null,null,null,[40858,40859],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[351,800,0,null,null,null,[40861,40862,40863],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"owner",null,"",null,false],[0,0,0,"group",null,"",null,false],[351,808,0,null,null,null,[40865,40866,40867,40868],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,813,0,null,null," Can only be called on 32 bit systems. For 64 bit see `lseek`.",[40870,40871,40872,40873],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"result",null,"",null,false],[0,0,0,"whence",null,"",null,false],[351,827,0,null,null," Can only be called on 64 bit systems. For 32 bit see `llseek`.",[40875,40876,40877],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"whence",null,"",null,false],[351,831,0,null,null,null,[40879],false],[0,0,0,"status",null,"",null,false],[351,836,0,null,null,null,[40881],false],[0,0,0,"status",null,"",null,false],[351,842,0,null,null," flags for the `reboot' system call.",[],false],[351,844,0,null,null," First magic value required to use _reboot() system call.",[40884],false],[0,0,0,"MAGIC1",null,null,null,false],[351,850,0,null,null," Second magic value required to use _reboot() system call.",[40886,40887,40888,40889],false],[0,0,0,"MAGIC2",null,null,null,false],[0,0,0,"MAGIC2A",null,null,null,false],[0,0,0,"MAGIC2B",null,null,null,false],[0,0,0,"MAGIC2C",null,null,null,false],[351,859,0,null,null," Commands accepted by the _reboot() system call.",[40891,40892,40893,40894,40895,40896,40897,40898],false],[0,0,0,"RESTART",null," Restart system using default command and mode.",null,false],[0,0,0,"HALT",null," Stop OS and give system control to ROM monitor, if any.",null,false],[0,0,0,"CAD_ON",null," Ctrl-Alt-Del sequence causes RESTART command.",null,false],[0,0,0,"CAD_OFF",null," Ctrl-Alt-Del sequence sends SIGINT to init task.",null,false],[0,0,0,"POWER_OFF",null," Stop OS and remove all power from system, if possible.",null,false],[0,0,0,"RESTART2",null," Restart system using given command string.",null,false],[0,0,0,"SW_SUSPEND",null," Suspend system using software suspend if compiled in.",null,false],[0,0,0,"KEXEC",null," Restart system using a previously loaded Linux kernel",null,false],[351,888,0,null,null,null,[40900,40901,40902,40903],false],[0,0,0,"magic",null,"",null,false],[0,0,0,"magic2",null,"",null,false],[0,0,0,"cmd",null,"",null,false],[0,0,0,"arg",null,"",null,false],[351,898,0,null,null,null,[40905,40906,40907],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,902,0,null,null,null,[40909,40910],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"sig",null,"",null,false],[351,906,0,null,null,null,[40912,40913],false],[0,0,0,"tid",null,"",null,false],[0,0,0,"sig",null,"",null,false],[351,910,0,null,null,null,[40915,40916,40917],false],[0,0,0,"tgid",null,"",null,false],[0,0,0,"tid",null,"",null,false],[0,0,0,"sig",null,"",null,false],[351,914,0,null,null,null,[40919,40920,40921],false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,934,0,null,null,null,[40923,40924,40925,40926,40927],false],[0,0,0,"oldfd",null,"",null,false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newfd",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,945,0,null,null,null,[40929],false],[0,0,0,"path",null,"",null,false],[351,953,0,null,null,null,[40931,40932,40933],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,957,0,null,null,null,[40935,40936,40937],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"status",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,961,0,null,null,null,[40939,40940,40941,40942],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"status",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"usage",null,"",null,false],[351,971,0,null,null,null,[40944,40945,40946,40947],false],[0,0,0,"id_type",null,"",null,false],[0,0,0,"id",null,"",null,false],[0,0,0,"infop",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,975,0,null,null,null,[40949,40950,40951],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"cmd",null,"",null,false],[0,0,0,"arg",null,"",null,false],[351,979,0,null,null,null,[40953,40954],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"operation",null,"",null,false],[351,983,0,null,null,null,null,false],[351,986,0,null,null,null,[40957,40958],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[351,988,0,null,null,null,[40960,40961],false],[0,0,0,"clk_id",null,"",null,false],[0,0,0,"tp",null,"",null,false],[351,1003,0,null,null,null,[40963,40964],false],[0,0,0,"clk",null,"",null,false],[0,0,0,"ts",null,"",null,false],[351,1016,0,null,null,null,[40966,40967],false],[0,0,0,"clk_id",null,"",null,false],[0,0,0,"tp",null,"",null,false],[351,1020,0,null,null,null,[40969,40970],false],[0,0,0,"clk_id",null,"",null,false],[0,0,0,"tp",null,"",null,false],[351,1024,0,null,null,null,[40972,40973],false],[0,0,0,"tv",null,"",null,false],[0,0,0,"tz",null,"",null,false],[351,1028,0,null,null,null,[40975,40976],false],[0,0,0,"tv",null,"",null,false],[0,0,0,"tz",null,"",null,false],[351,1032,0,null,null,null,[40978,40979],false],[0,0,0,"req",null,"",null,false],[0,0,0,"rem",null,"",null,false],[351,1036,0,null,null,null,[40981],false],[0,0,0,"uid",null,"",null,false],[351,1044,0,null,null,null,[40983],false],[0,0,0,"gid",null,"",null,false],[351,1052,0,null,null,null,[40985,40986],false],[0,0,0,"ruid",null,"",null,false],[0,0,0,"euid",null,"",null,false],[351,1060,0,null,null,null,[40988,40989],false],[0,0,0,"rgid",null,"",null,false],[0,0,0,"egid",null,"",null,false],[351,1068,0,null,null,null,[],false],[351,1076,0,null,null,null,[],false],[351,1084,0,null,null,null,[],false],[351,1092,0,null,null,null,[],false],[351,1100,0,null,null,null,[40995],false],[0,0,0,"euid",null,"",null,false],[351,1111,0,null,null,null,[40997],false],[0,0,0,"egid",null,"",null,false],[351,1122,0,null,null,null,[40999,41000,41001],false],[0,0,0,"ruid",null,"",null,false],[0,0,0,"euid",null,"",null,false],[0,0,0,"suid",null,"",null,false],[351,1130,0,null,null,null,[41003,41004,41005],false],[0,0,0,"rgid",null,"",null,false],[0,0,0,"egid",null,"",null,false],[0,0,0,"sgid",null,"",null,false],[351,1138,0,null,null,null,[41007,41008,41009],false],[0,0,0,"ruid",null,"",null,false],[0,0,0,"euid",null,"",null,false],[0,0,0,"suid",null,"",null,false],[351,1146,0,null,null,null,[41011,41012,41013],false],[0,0,0,"rgid",null,"",null,false],[0,0,0,"egid",null,"",null,false],[0,0,0,"sgid",null,"",null,false],[351,1154,0,null,null,null,[41015,41016],false],[0,0,0,"size",null,"",null,false],[0,0,0,"list",null,"",null,false],[351,1162,0,null,null,null,[41018,41019],false],[0,0,0,"size",null,"",null,false],[0,0,0,"list",null,"",null,false],[351,1170,0,null,null,null,[],false],[351,1174,0,null,null,null,[],false],[351,1178,0,null,null,null,[],false],[351,1182,0,null,null,null,[41024,41025,41026],false],[0,0,0,"flags",null,"",null,false],[0,0,0,"set",null,"",null,false],[0,0,0,"oldset",null,"",null,false],[351,1186,0,null,null,null,[41028,41029,41030],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"act",null,"",null,false],[0,0,0,"oact",null,"",null,false],[351,1225,0,null,null,null,null,false],[351,1227,0,null,null,null,[41033,41034],false],[0,0,0,"set",null,"",null,false],[0,0,0,"sig",null,"",null,false],[351,1235,0,null,null,null,[41036,41037],false],[0,0,0,"set",null,"",null,false],[0,0,0,"sig",null,"",null,false],[351,1240,0,null,null,null,[41039,41040,41041],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,1247,0,null,null,null,[41043,41044,41045],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,1254,0,null,null,null,[41047,41048,41049],false],[0,0,0,"domain",null,"",null,false],[0,0,0,"socket_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[351,1261,0,null,null,null,[41051,41052,41053,41054,41055],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"optval",null,"",null,false],[0,0,0,"optlen",null,"",null,false],[351,1268,0,null,null,null,[41057,41058,41059,41060,41061],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"optval",null,"",null,false],[0,0,0,"optlen",null,"",null,false],[351,1275,0,null,null,null,[41063,41064,41065],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1285,0,null,null,null,[41067,41068,41069,41070],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msgvec",null,"",null,false],[0,0,0,"vlen",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1325,0,null,null,null,[41072,41073,41074],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,1335,0,null,null,null,[41076,41077,41078],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1345,0,null,null,null,[41080,41081,41082,41083,41084,41085],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"alen",null,"",null,false],[351,1364,0,null,null,null,[41087,41088],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"how",null,"",null,false],[351,1371,0,null,null,null,[41090,41091,41092],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,1378,0,null,null,null,[41094,41095],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"backlog",null,"",null,false],[351,1385,0,null,null,null,[41097,41098,41099,41100,41101,41102],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"alen",null,"",null,false],[351,1392,0,null,null,null,[41104,41105,41106,41107],false],[0,0,0,"outfd",null,"",null,false],[0,0,0,"infd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"count",null,"",null,false],[351,1412,0,null,null,null,[41109,41110,41111,41112],false],[0,0,0,"domain",null,"",null,false],[0,0,0,"socket_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"fd",null,"",null,false],[351,1419,0,null,null,null,[41114,41115,41116],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[351,1426,0,null,null,null,[41118,41119,41120,41121],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1433,0,null,null,null,[41123,41124],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"stat_buf",null,"",null,false],[351,1441,0,null,null,null,[41126,41127],false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"statbuf",null,"",null,false],[351,1449,0,null,null,null,[41129,41130],false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"statbuf",null,"",null,false],[351,1457,0,null,null,null,[41132,41133,41134,41135],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"stat_buf",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1465,0,null,null,null,[41137,41138,41139,41140,41141],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mask",null,"",null,false],[0,0,0,"statx_buf",null,"",null,false],[351,1479,0,null,null,null,[41143,41144,41145],false],[0,0,0,"path",null,"",null,false],[0,0,0,"list",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1483,0,null,null,null,[41147,41148,41149],false],[0,0,0,"path",null,"",null,false],[0,0,0,"list",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1487,0,null,null,null,[41151,41152,41153],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"list",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1491,0,null,null,null,[41155,41156,41157,41158],false],[0,0,0,"path",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1495,0,null,null,null,[41160,41161,41162,41163],false],[0,0,0,"path",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1499,0,null,null,null,[41165,41166,41167,41168],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1503,0,null,null,null,[41170,41171,41172,41173,41174],false],[0,0,0,"path",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1507,0,null,null,null,[41176,41177,41178,41179,41180],false],[0,0,0,"path",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1511,0,null,null,null,[41182,41183,41184,41185,41186],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1515,0,null,null,null,[41188,41189],false],[0,0,0,"path",null,"",null,false],[0,0,0,"name",null,"",null,false],[351,1519,0,null,null,null,[41191,41192],false],[0,0,0,"path",null,"",null,false],[0,0,0,"name",null,"",null,false],[351,1523,0,null,null,null,[41194,41195],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"name",null,"",null,false],[351,1527,0,null,null,null,[],false],[351,1531,0,null,null,null,[41198,41199,41200],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"set",null,"",null,false],[351,1538,0,null,null,null,[],false],[351,1542,0,null,null,null,[41203],false],[0,0,0,"flags",null,"",null,false],[351,1546,0,null,null,null,[41205,41206,41207,41208],false],[0,0,0,"epoll_fd",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"ev",null,"",null,false],[351,1550,0,null,null,null,[41210,41211,41212,41213],false],[0,0,0,"epoll_fd",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"maxevents",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[351,1554,0,null,null,null,[41215,41216,41217,41218,41219],false],[0,0,0,"epoll_fd",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"maxevents",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"sigmask",null,"",null,false],[351,1566,0,null,null,null,[41221,41222],false],[0,0,0,"count",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1570,0,null,null,null,[41224,41225],false],[0,0,0,"clockid",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1574,0,null,null,null,[41228,41230],false],[351,1574,0,null,null,null,null,false],[0,0,0,"it_interval",null,null,null,false],[351,1574,0,null,null,null,null,false],[0,0,0,"it_value",null,null,null,false],[351,1579,0,null,null,null,[41232,41233],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"curr_value",null,"",null,false],[351,1583,0,null,null,null,[41235,41236,41237,41238],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"new_value",null,"",null,false],[0,0,0,"old_value",null,"",null,false],[351,1588,0,null,null,null,[41240,41241,41242],false],[0,0,0,"REAL",null,null,null,false],[0,0,0,"VIRTUAL",null,null,null,false],[0,0,0,"PROF",null,null,null,false],[351,1594,0,null,null,null,[41244,41245],false],[0,0,0,"which",null,"",null,false],[0,0,0,"curr_value",null,"",null,false],[351,1598,0,null,null,null,[41247,41248,41249],false],[0,0,0,"which",null,"",null,false],[0,0,0,"new_value",null,"",null,false],[0,0,0,"old_value",null,"",null,false],[351,1602,0,null,null,null,[41251],false],[0,0,0,"flags",null,"",null,false],[351,1606,0,null,null,null,[41253,41254],false],[0,0,0,"hdrp",null,"",null,false],[0,0,0,"datap",null,"",null,false],[351,1610,0,null,null,null,[41256,41257],false],[0,0,0,"hdrp",null,"",null,false],[0,0,0,"datap",null,"",null,false],[351,1614,0,null,null,null,[41259,41260],false],[0,0,0,"ss",null,"",null,false],[0,0,0,"old_ss",null,"",null,false],[351,1618,0,null,null,null,[41262],false],[0,0,0,"uts",null,"",null,false],[351,1622,0,null,null,null,[41264,41265],false],[0,0,0,"entries",null,"",null,false],[0,0,0,"p",null,"",null,false],[351,1626,0,null,null,null,[41267,41268,41269,41270,41271],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"to_submit",null,"",null,false],[0,0,0,"min_complete",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"sig",null,"",null,false],[351,1630,0,null,null,null,[41273,41274,41275,41276],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"opcode",null,"",null,false],[0,0,0,"arg",null,"",null,false],[0,0,0,"nr_args",null,"",null,false],[351,1634,0,null,null,null,[41278,41279],false],[0,0,0,"name",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1638,0,null,null,null,[41281,41282],false],[0,0,0,"who",null,"",null,false],[0,0,0,"usage",null,"",null,false],[351,1642,0,null,null,null,[41284,41285],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"termios_p",null,"",null,false],[351,1646,0,null,null,null,[41287,41288,41289],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"optional_action",null,"",null,false],[0,0,0,"termios_p",null,"",null,false],[351,1650,0,null,null,null,[41291,41292],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"pgrp",null,"",null,false],[351,1654,0,null,null,null,[41294,41295],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"pgrp",null,"",null,false],[351,1658,0,null,null,null,[41297],false],[0,0,0,"fd",null,"",null,false],[351,1662,0,null,null,null,[41299,41300,41301],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"request",null,"",null,false],[0,0,0,"arg",null,"",null,false],[351,1666,0,null,null,null,[41303,41304,41305],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mask",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1670,0,null,null,null,[41307,41308,41309,41310,41311,41312],false],[0,0,0,"fd_in",null,"",null,false],[0,0,0,"off_in",null,"",null,false],[0,0,0,"fd_out",null,"",null,false],[0,0,0,"off_out",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1682,0,null,null,null,[41314,41315,41316],false],[0,0,0,"cmd",null,"",null,false],[0,0,0,"attr",null,"",null,false],[0,0,0,"size",null,"",null,false],[351,1686,0,null,null,null,[],false],[351,1690,0,null,null,null,[41319],false],[0,0,0,"fd",null,"",null,false],[351,1694,0,null,null,null,[41321],false],[0,0,0,"fd",null,"",null,false],[351,1698,0,null,null,null,[41323],false],[0,0,0,"fd",null,"",null,false],[351,1702,0,null,null,null,[41325,41326,41327,41328,41329],false],[0,0,0,"option",null,"",null,false],[0,0,0,"arg2",null,"",null,false],[0,0,0,"arg3",null,"",null,false],[0,0,0,"arg4",null,"",null,false],[0,0,0,"arg5",null,"",null,false],[351,1706,0,null,null,null,[41331,41332],false],[0,0,0,"resource",null,"",null,false],[0,0,0,"rlim",null,"",null,false],[351,1711,0,null,null,null,[41334,41335],false],[0,0,0,"resource",null,"",null,false],[0,0,0,"rlim",null,"",null,false],[351,1716,0,null,null,null,[41337,41338,41339,41340],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"resource",null,"",null,false],[0,0,0,"new_limit",null,"",null,false],[0,0,0,"old_limit",null,"",null,false],[351,1726,0,null,null,null,[41342,41343,41344],false],[0,0,0,"address",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"vec",null,"",null,false],[351,1730,0,null,null,null,[41346,41347,41348],false],[0,0,0,"address",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"advice",null,"",null,false],[351,1734,0,null,null,null,[41350,41351],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1738,0,null,null,null,[41353,41354,41355],false],[0,0,0,"pidfd",null,"",null,false],[0,0,0,"targetfd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1747,0,null,null,null,[41357,41358,41359,41360],false],[0,0,0,"pidfd",null,"",null,false],[0,0,0,"sig",null,"",null,false],[0,0,0,"info",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1757,0,null,null,null,[41362,41363,41364,41365],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"local",null,"",null,false],[0,0,0,"remote",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1769,0,null,null,null,[41367,41368,41369,41370],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"local",null,"",null,false],[0,0,0,"remote",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1781,0,null,null,null,[41372,41373,41374,41375],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"advice",null,"",null,false],[351,1840,0,null,null,null,[41377,41378,41379,41380,41381],false],[0,0,0,"attr",null,"",null,false],[0,0,0,"pid",null,"",null,false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"group_fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[351,1857,0,null,null,null,[41383,41384,41385],false],[0,0,0,"operation",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"args",null,"",null,false],[351,1861,0,null,null,null,[41387,41388,41389,41390,41391],false],[0,0,0,"req",null,"",null,false],[0,0,0,"pid",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"addr2",null,"",null,false],[351,1878,0,null,null,null,null,false],[351,1884,0,null,null,null,null,false],[351,1885,0,null,null,null,null,false],[351,1886,0,null,null,null,null,false],[351,1887,0,null,null,null,null,false],[351,1888,0,null,null,null,null,false],[351,1890,0,null,null,null,null,false],[351,1891,0,null,null,null,null,false],[351,1892,0,null,null,null,null,false],[351,1896,0,null,null," Largest hardware address length\n e.g. a mac address is a type of hardware address",null,false],[351,1898,0,null,null,null,null,false],[351,1899,0,null,null,null,null,false],[351,1900,0,null,null,null,null,false],[351,1902,0,null,null,null,[],false],[351,1904,0,null,null," Special value used to indicate openat should use the current working directory",null,false],[351,1907,0,null,null," Do not follow symbolic links",null,false],[351,1910,0,null,null," Remove directory instead of unlinking file",null,false],[351,1913,0,null,null," Follow symbolic links.",null,false],[351,1916,0,null,null," Suppress terminal automount traversal",null,false],[351,1919,0,null,null," Allow empty relative pathname",null,false],[351,1922,0,null,null," Type of synchronisation required from statx()",null,false],[351,1925,0,null,null," - Do whatever stat() does",null,false],[351,1928,0,null,null," - Force the attributes to be sync'd with the server",null,false],[351,1931,0,null,null," - Don't sync attributes with the server",null,false],[351,1934,0,null,null," Apply to the entire subtree",null,false],[351,1937,0,null,null,null,[],false],[351,1939,0,null,null," Default is extend size",null,false],[351,1942,0,null,null," De-allocates range",null,false],[351,1945,0,null,null," Reserved codepoint",null,false],[351,1948,0,null,null," Removes a range of a file without leaving a hole in the file",null,false],[351,1951,0,null,null," Converts a range of file to zeros preferably without issuing data IO",null,false],[351,1954,0,null,null," Inserts space within the file size without overwriting any existing data",null,false],[351,1957,0,null,null," Unshares shared blocks within the file size without overwriting any existing data",null,false],[351,1960,0,null,null,null,[],false],[351,1961,0,null,null,null,null,false],[351,1962,0,null,null,null,null,false],[351,1963,0,null,null,null,null,false],[351,1964,0,null,null,null,null,false],[351,1965,0,null,null,null,null,false],[351,1966,0,null,null,null,null,false],[351,1967,0,null,null,null,null,false],[351,1968,0,null,null,null,null,false],[351,1969,0,null,null,null,null,false],[351,1970,0,null,null,null,null,false],[351,1971,0,null,null,null,null,false],[351,1972,0,null,null,null,null,false],[351,1973,0,null,null,null,null,false],[351,1975,0,null,null,null,null,false],[351,1977,0,null,null,null,null,false],[351,1980,0,null,null,null,[],false],[351,1982,0,null,null," page can not be accessed",null,false],[351,1984,0,null,null," page can be read",null,false],[351,1986,0,null,null," page can be written",null,false],[351,1988,0,null,null," page can be executed",null,false],[351,1990,0,null,null," page may be used for atomic ops",null,false],[351,1996,0,null,null," mprotect flag: extend change to start of growsdown vma",null,false],[351,1998,0,null,null," mprotect flag: extend change to end of growsup vma",null,false],[351,2001,0,null,null,null,null,false],[351,2003,0,null,null,null,null,false],[351,2004,0,null,null,null,null,false],[351,2005,0,null,null,null,null,false],[351,2006,0,null,null,null,null,false],[351,2008,0,null,null,null,[],false],[351,2009,0,null,null,null,null,false],[351,2010,0,null,null,null,null,false],[351,2011,0,null,null,null,null,false],[351,2012,0,null,null,null,null,false],[351,2013,0,null,null,null,null,false],[351,2014,0,null,null,null,null,false],[351,2016,0,null,null,null,[41462],false],[0,0,0,"s",null,"",null,false],[351,2019,0,null,null,null,[41464],false],[0,0,0,"s",null,"",null,false],[351,2022,0,null,null,null,[41466],false],[0,0,0,"s",null,"",null,false],[351,2025,0,null,null,null,[41468],false],[0,0,0,"s",null,"",null,false],[351,2028,0,null,null,null,[41470],false],[0,0,0,"s",null,"",null,false],[351,2031,0,null,null,null,[41472],false],[0,0,0,"s",null,"",null,false],[351,2037,0,null,null,null,[41474,41475,41476,41477],false],[0,0,0,"ALL",null,null,null,false],[0,0,0,"PID",null,null,null,false],[0,0,0,"PGID",null,null,null,false],[0,0,0,"PIDFD",null,null,null,false],[351,2045,0,null,null,null,null,false],[351,2074,0,null,null,null,null,false],[351,2206,0,null,null,null,null,false],[351,2208,0,null,null,null,[],false],[351,2210,0,null,null," high priority request, poll if possible",null,false],[351,2213,0,null,null," per-IO O.DSYNC",null,false],[351,2216,0,null,null," per-IO O.SYNC",null,false],[351,2219,0,null,null," per-IO, return -EAGAIN if operation would block",null,false],[351,2222,0,null,null," per-IO O.APPEND",null,false],[351,2225,0,null,null,null,[],false],[351,2226,0,null,null,null,null,false],[351,2227,0,null,null,null,null,false],[351,2228,0,null,null,null,null,false],[351,2231,0,null,null,null,[],false],[351,2232,0,null,null,null,null,false],[351,2233,0,null,null,null,null,false],[351,2234,0,null,null,null,null,false],[351,2237,0,null,null,null,[],false],[351,2238,0,null,null,null,null,false],[351,2239,0,null,null,null,null,false],[351,2240,0,null,null,null,null,false],[351,2241,0,null,null,null,null,false],[351,2242,0,null,null,null,null,false],[351,2243,0,null,null,null,null,false],[351,2244,0,null,null,null,null,false],[351,2245,0,null,null,null,null,false],[351,2246,0,null,null,null,null,false],[351,2249,0,null,null,null,[],false],[351,2251,0,null,null," Turn off Nagle's algorithm",null,false],[351,2253,0,null,null," Limit MSS",null,false],[351,2255,0,null,null," Never send partially complete segments.",null,false],[351,2257,0,null,null," Start keeplives after this period, in seconds",null,false],[351,2259,0,null,null," Interval between keepalives",null,false],[351,2261,0,null,null," Number of keepalives before death",null,false],[351,2263,0,null,null," Number of SYN retransmits",null,false],[351,2265,0,null,null," Life time of orphaned FIN-WAIT-2 state",null,false],[351,2267,0,null,null," Wake up listener only when data arrive",null,false],[351,2269,0,null,null," Bound advertised window",null,false],[351,2271,0,null,null," Information about this connection.",null,false],[351,2273,0,null,null," Block/reenable quick acks",null,false],[351,2275,0,null,null," Congestion control algorithm",null,false],[351,2277,0,null,null," TCP MD5 Signature (RFC2385)",null,false],[351,2279,0,null,null," Use linear timeouts for thin streams",null,false],[351,2281,0,null,null," Fast retrans. after 1 dupack",null,false],[351,2283,0,null,null," How long for loss retry before timeout",null,false],[351,2285,0,null,null," TCP sock is under repair right now",null,false],[351,2286,0,null,null,null,null,false],[351,2287,0,null,null,null,null,false],[351,2288,0,null,null,null,null,false],[351,2290,0,null,null," Enable FastOpen on listeners",null,false],[351,2291,0,null,null,null,null,false],[351,2293,0,null,null," limit number of unsent bytes in write queue",null,false],[351,2295,0,null,null," Get Congestion Control (optional) info",null,false],[351,2297,0,null,null," Record SYN headers for new connections",null,false],[351,2299,0,null,null," Get SYN headers recorded for connection",null,false],[351,2301,0,null,null," Get/set window parameters",null,false],[351,2303,0,null,null," Attempt FastOpen with connect",null,false],[351,2305,0,null,null," Attach a ULP to a TCP connection",null,false],[351,2307,0,null,null," TCP MD5 Signature with extensions",null,false],[351,2309,0,null,null," Set the key for Fast Open (cookie)",null,false],[351,2311,0,null,null," Enable TFO without a TFO cookie",null,false],[351,2312,0,null,null,null,null,false],[351,2314,0,null,null," Notify bytes available to read as a cmsg on read",null,false],[351,2315,0,null,null,null,null,false],[351,2317,0,null,null," delay outgoing packets by XX usec",null,false],[351,2319,0,null,null,null,null,false],[351,2320,0,null,null,null,null,false],[351,2322,0,null,null," Turn off without window probes",null,false],[351,2325,0,null,null,null,[],false],[351,2326,0,null,null,null,null,false],[351,2327,0,null,null,null,null,false],[351,2328,0,null,null,null,null,false],[351,2329,0,null,null,null,null,false],[351,2330,0,null,null,null,null,false],[351,2331,0,null,null,null,null,false],[351,2332,0,null,null,null,null,false],[351,2333,0,null,null,null,null,false],[351,2334,0,null,null,null,null,false],[351,2335,0,null,null,null,null,false],[351,2336,0,null,null,null,null,false],[351,2337,0,null,null,null,null,false],[351,2338,0,null,null,null,null,false],[351,2339,0,null,null,null,null,false],[351,2340,0,null,null,null,null,false],[351,2341,0,null,null,null,null,false],[351,2342,0,null,null,null,null,false],[351,2343,0,null,null,null,null,false],[351,2344,0,null,null,null,null,false],[351,2345,0,null,null,null,null,false],[351,2346,0,null,null,null,null,false],[351,2347,0,null,null,null,null,false],[351,2348,0,null,null,null,null,false],[351,2349,0,null,null,null,null,false],[351,2350,0,null,null,null,null,false],[351,2351,0,null,null,null,null,false],[351,2352,0,null,null,null,null,false],[351,2353,0,null,null,null,null,false],[351,2354,0,null,null,null,null,false],[351,2355,0,null,null,null,null,false],[351,2356,0,null,null,null,null,false],[351,2357,0,null,null,null,null,false],[351,2358,0,null,null,null,null,false],[351,2359,0,null,null,null,null,false],[351,2360,0,null,null,null,null,false],[351,2361,0,null,null,null,null,false],[351,2362,0,null,null,null,null,false],[351,2363,0,null,null,null,null,false],[351,2364,0,null,null,null,null,false],[351,2365,0,null,null,null,null,false],[351,2366,0,null,null,null,null,false],[351,2367,0,null,null,null,null,false],[351,2368,0,null,null,null,null,false],[351,2369,0,null,null,null,null,false],[351,2370,0,null,null,null,null,false],[351,2371,0,null,null,null,null,false],[351,2372,0,null,null,null,null,false],[351,2373,0,null,null,null,null,false],[351,2374,0,null,null,null,null,false],[351,2377,0,null,null,null,[],false],[351,2378,0,null,null,null,null,false],[351,2379,0,null,null,null,null,false],[351,2380,0,null,null,null,null,false],[351,2381,0,null,null,null,null,false],[351,2382,0,null,null,null,null,false],[351,2383,0,null,null,null,null,false],[351,2384,0,null,null,null,null,false],[351,2385,0,null,null,null,null,false],[351,2386,0,null,null,null,null,false],[351,2387,0,null,null,null,null,false],[351,2388,0,null,null,null,null,false],[351,2389,0,null,null,null,null,false],[351,2390,0,null,null,null,null,false],[351,2391,0,null,null,null,null,false],[351,2392,0,null,null,null,null,false],[351,2393,0,null,null,null,null,false],[351,2394,0,null,null,null,null,false],[351,2395,0,null,null,null,null,false],[351,2396,0,null,null,null,null,false],[351,2397,0,null,null,null,null,false],[351,2398,0,null,null,null,null,false],[351,2399,0,null,null,null,null,false],[351,2400,0,null,null,null,null,false],[351,2401,0,null,null,null,null,false],[351,2402,0,null,null,null,null,false],[351,2403,0,null,null,null,null,false],[351,2404,0,null,null,null,null,false],[351,2405,0,null,null,null,null,false],[351,2406,0,null,null,null,null,false],[351,2407,0,null,null,null,null,false],[351,2408,0,null,null,null,null,false],[351,2409,0,null,null,null,null,false],[351,2410,0,null,null,null,null,false],[351,2411,0,null,null,null,null,false],[351,2412,0,null,null,null,null,false],[351,2413,0,null,null,null,null,false],[351,2414,0,null,null,null,null,false],[351,2415,0,null,null,null,null,false],[351,2416,0,null,null,null,null,false],[351,2417,0,null,null,null,null,false],[351,2418,0,null,null,null,null,false],[351,2419,0,null,null,null,null,false],[351,2420,0,null,null,null,null,false],[351,2421,0,null,null,null,null,false],[351,2422,0,null,null,null,null,false],[351,2423,0,null,null,null,null,false],[351,2424,0,null,null,null,null,false],[351,2425,0,null,null,null,null,false],[351,2426,0,null,null,null,null,false],[351,2429,0,null,null,null,[],false],[351,2430,0,null,null,null,null,false],[351,2709,0,null,null,null,[],false],[351,2710,0,null,null,null,null,false],[351,2711,0,null,null,null,null,false],[351,2712,0,null,null,null,null,false],[351,2713,0,null,null,null,null,false],[351,2716,0,null,null,null,[],false],[351,2717,0,null,null,null,null,false],[351,2719,0,null,null,null,null,false],[351,2720,0,null,null,null,null,false],[351,2721,0,null,null,null,null,false],[351,2723,0,null,null,null,null,false],[351,2724,0,null,null,null,null,false],[351,2725,0,null,null,null,null,false],[351,2726,0,null,null,null,null,false],[351,2727,0,null,null,null,null,false],[351,2728,0,null,null,null,null,false],[351,2729,0,null,null,null,null,false],[351,2730,0,null,null,null,null,false],[351,2731,0,null,null,null,null,false],[351,2732,0,null,null,null,null,false],[351,2733,0,null,null,null,null,false],[351,2734,0,null,null,null,null,false],[351,2735,0,null,null,null,null,false],[351,2736,0,null,null,null,null,false],[351,2737,0,null,null,null,null,false],[351,2738,0,null,null,null,null,false],[351,2739,0,null,null,null,null,false],[351,2740,0,null,null,null,null,false],[351,2741,0,null,null,null,null,false],[351,2742,0,null,null,null,null,false],[351,2743,0,null,null,null,null,false],[351,2744,0,null,null,null,null,false],[351,2745,0,null,null,null,null,false],[351,2746,0,null,null,null,null,false],[351,2749,0,null,null,null,null,false],[351,2751,0,null,null,null,[],false],[351,2752,0,null,null,null,null,false],[351,2753,0,null,null,null,null,false],[351,2754,0,null,null,null,null,false],[351,2755,0,null,null,null,null,false],[351,2756,0,null,null,null,null,false],[351,2757,0,null,null,null,null,false],[351,2758,0,null,null,null,null,false],[351,2759,0,null,null,null,null,false],[351,2760,0,null,null,null,null,false],[351,2761,0,null,null,null,null,false],[351,2762,0,null,null,null,null,false],[351,2763,0,null,null,null,null,false],[351,2764,0,null,null,null,null,false],[351,2765,0,null,null,null,null,false],[351,2766,0,null,null,null,null,false],[351,2767,0,null,null,null,null,false],[351,2768,0,null,null,null,null,false],[351,2769,0,null,null,null,null,false],[351,2770,0,null,null,null,null,false],[351,2771,0,null,null,null,null,false],[351,2772,0,null,null,null,null,false],[351,2773,0,null,null,null,null,false],[351,2774,0,null,null,null,null,false],[351,2775,0,null,null,null,null,false],[351,2776,0,null,null,null,null,false],[351,2777,0,null,null,null,null,false],[351,2778,0,null,null,null,null,false],[351,2779,0,null,null,null,null,false],[351,2780,0,null,null,null,null,false],[351,2781,0,null,null,null,null,false],[351,2782,0,null,null,null,null,false],[351,2783,0,null,null,null,null,false],[351,2784,0,null,null,null,null,false],[351,2785,0,null,null,null,null,false],[351,2786,0,null,null,null,null,false],[351,2787,0,null,null,null,null,false],[351,2788,0,null,null,null,null,false],[351,2789,0,null,null,null,null,false],[351,2790,0,null,null,null,null,false],[351,2792,0,null,null,null,null,false],[351,2794,0,null,null,null,null,false],[351,2795,0,null,null,null,null,false],[351,2796,0,null,null,null,null,false],[351,2797,0,null,null,null,null,false],[351,2798,0,null,null,null,null,false],[351,2799,0,null,null,null,null,false],[351,2801,0,null,null,null,null,false],[351,2802,0,null,null,null,null,false],[351,2803,0,null,null,null,null,false],[351,2807,0,null,null," IPv6 socket options",[],false],[351,2808,0,null,null,null,null,false],[351,2809,0,null,null,null,null,false],[351,2810,0,null,null,null,null,false],[351,2811,0,null,null,null,null,false],[351,2812,0,null,null,null,null,false],[351,2813,0,null,null,null,null,false],[351,2814,0,null,null,null,null,false],[351,2815,0,null,null,null,null,false],[351,2816,0,null,null,null,null,false],[351,2817,0,null,null,null,null,false],[351,2818,0,null,null,null,null,false],[351,2820,0,null,null,null,null,false],[351,2821,0,null,null,null,null,false],[351,2822,0,null,null,null,null,false],[351,2823,0,null,null,null,null,false],[351,2824,0,null,null,null,null,false],[351,2825,0,null,null,null,null,false],[351,2826,0,null,null,null,null,false],[351,2827,0,null,null,null,null,false],[351,2828,0,null,null,null,null,false],[351,2829,0,null,null,null,null,false],[351,2830,0,null,null,null,null,false],[351,2831,0,null,null,null,null,false],[351,2832,0,null,null,null,null,false],[351,2835,0,null,null,null,null,false],[351,2836,0,null,null,null,null,false],[351,2837,0,null,null,null,null,false],[351,2838,0,null,null,null,null,false],[351,2839,0,null,null,null,null,false],[351,2840,0,null,null,null,null,false],[351,2843,0,null,null,null,null,false],[351,2844,0,null,null,null,null,false],[351,2845,0,null,null,null,null,false],[351,2846,0,null,null,null,null,false],[351,2847,0,null,null,null,null,false],[351,2850,0,null,null,null,null,false],[351,2851,0,null,null,null,null,false],[351,2852,0,null,null,null,null,false],[351,2853,0,null,null,null,null,false],[351,2854,0,null,null,null,null,false],[351,2855,0,null,null,null,null,false],[351,2856,0,null,null,null,null,false],[351,2857,0,null,null,null,null,false],[351,2858,0,null,null,null,null,false],[351,2859,0,null,null,null,null,false],[351,2860,0,null,null,null,null,false],[351,2861,0,null,null,null,null,false],[351,2862,0,null,null,null,null,false],[351,2863,0,null,null,null,null,false],[351,2866,0,null,null,null,null,false],[351,2867,0,null,null,null,null,false],[351,2869,0,null,null,null,null,false],[351,2872,0,null,null,null,null,false],[351,2874,0,null,null,null,null,false],[351,2875,0,null,null,null,null,false],[351,2876,0,null,null,null,null,false],[351,2877,0,null,null,null,null,false],[351,2878,0,null,null,null,null,false],[351,2879,0,null,null,null,null,false],[351,2880,0,null,null,null,null,false],[351,2883,0,null,null,null,null,false],[351,2885,0,null,null,null,null,false],[351,2886,0,null,null,null,null,false],[351,2887,0,null,null,null,null,false],[351,2888,0,null,null,null,null,false],[351,2889,0,null,null,null,null,false],[351,2890,0,null,null,null,null,false],[351,2893,0,null,null,null,[],false],[351,2894,0,null,null,null,null,false],[351,2895,0,null,null,null,null,false],[351,2896,0,null,null,null,null,false],[351,2897,0,null,null,null,null,false],[351,2898,0,null,null,null,null,false],[351,2899,0,null,null,null,null,false],[351,2900,0,null,null,null,null,false],[351,2901,0,null,null,null,null,false],[351,2902,0,null,null,null,null,false],[351,2903,0,null,null,null,null,false],[351,2904,0,null,null,null,null,false],[351,2905,0,null,null,null,null,false],[351,2906,0,null,null,null,null,false],[351,2907,0,null,null,null,null,false],[351,2908,0,null,null,null,null,false],[351,2909,0,null,null,null,null,false],[351,2910,0,null,null,null,null,false],[351,2911,0,null,null,null,null,false],[351,2912,0,null,null,null,null,false],[351,2913,0,null,null,null,null,false],[351,2914,0,null,null,null,null,false],[351,2917,0,null,null,null,[],false],[351,2918,0,null,null,null,null,false],[351,2919,0,null,null,null,null,false],[351,2920,0,null,null,null,null,false],[351,2921,0,null,null,null,null,false],[351,2922,0,null,null,null,null,false],[351,2923,0,null,null,null,null,false],[351,2924,0,null,null,null,null,false],[351,2925,0,null,null,null,null,false],[351,2926,0,null,null,null,null,false],[351,2929,0,null,null,null,[],false],[351,2930,0,null,null,null,null,false],[351,2931,0,null,null,null,null,false],[351,2932,0,null,null,null,null,false],[351,2933,0,null,null,null,null,false],[351,2934,0,null,null,null,null,false],[351,2935,0,null,null,null,null,false],[351,2936,0,null,null,null,null,false],[351,2937,0,null,null,null,null,false],[351,2938,0,null,null,null,null,false],[351,2939,0,null,null,null,null,false],[351,2940,0,null,null,null,null,false],[351,2941,0,null,null,null,null,false],[351,2942,0,null,null,null,null,false],[351,2943,0,null,null,null,null,false],[351,2944,0,null,null,null,null,false],[351,2945,0,null,null,null,null,false],[351,2946,0,null,null,null,null,false],[351,2947,0,null,null,null,null,false],[351,2948,0,null,null,null,null,false],[351,2949,0,null,null,null,null,false],[351,2950,0,null,null,null,null,false],[351,2951,0,null,null,null,null,false],[351,2952,0,null,null,null,null,false],[351,2953,0,null,null,null,null,false],[351,2954,0,null,null,null,null,false],[351,2955,0,null,null,null,null,false],[351,2956,0,null,null,null,null,false],[351,2957,0,null,null,null,null,false],[351,2958,0,null,null,null,null,false],[351,2959,0,null,null,null,null,false],[351,2960,0,null,null,null,null,false],[351,2961,0,null,null,null,null,false],[351,2962,0,null,null,null,null,false],[351,2963,0,null,null,null,null,false],[351,2964,0,null,null,null,null,false],[351,2965,0,null,null,null,null,false],[351,2966,0,null,null,null,null,false],[351,2967,0,null,null,null,null,false],[351,2968,0,null,null,null,null,false],[351,2969,0,null,null,null,null,false],[351,2970,0,null,null,null,null,false],[351,2971,0,null,null,null,null,false],[351,2972,0,null,null,null,null,false],[351,2973,0,null,null,null,null,false],[351,2974,0,null,null,null,null,false],[351,2975,0,null,null,null,null,false],[351,2976,0,null,null,null,null,false],[351,2977,0,null,null,null,null,false],[351,2978,0,null,null,null,null,false],[351,2979,0,null,null,null,null,false],[351,2980,0,null,null,null,null,false],[351,2981,0,null,null,null,null,false],[351,2982,0,null,null,null,null,false],[351,2983,0,null,null,null,null,false],[351,2984,0,null,null,null,null,false],[351,2987,0,null,null,null,[],false],[351,2988,0,null,null,null,null,false],[351,2990,0,null,null,null,null,false],[351,2991,0,null,null,null,null,false],[351,2992,0,null,null,null,null,false],[351,2994,0,null,null,null,null,false],[351,2995,0,null,null,null,null,false],[351,2996,0,null,null,null,null,false],[351,2997,0,null,null,null,null,false],[351,2998,0,null,null,null,null,false],[351,2999,0,null,null,null,null,false],[351,3000,0,null,null,null,null,false],[351,3001,0,null,null,null,null,false],[351,3002,0,null,null,null,null,false],[351,3003,0,null,null,null,null,false],[351,3004,0,null,null,null,null,false],[351,3005,0,null,null,null,null,false],[351,3006,0,null,null,null,null,false],[351,3007,0,null,null,null,null,false],[351,3008,0,null,null,null,null,false],[351,3011,0,null,null,null,[],false],[351,3012,0,null,null,null,null,false],[351,3013,0,null,null,null,null,false],[351,3014,0,null,null,null,null,false],[351,3015,0,null,null,null,null,false],[351,3016,0,null,null,null,null,false],[351,3017,0,null,null,null,null,false],[351,3018,0,null,null,null,null,false],[351,3019,0,null,null,null,null,false],[351,3020,0,null,null,null,null,false],[351,3021,0,null,null,null,null,false],[351,3022,0,null,null,null,null,false],[351,3023,0,null,null,null,null,false],[351,3026,0,null,null,null,null,false],[351,3028,0,null,null,null,[],false],[351,3029,0,null,null,null,null,false],[351,3030,0,null,null,null,null,false],[351,3031,0,null,null,null,null,false],[351,3032,0,null,null,null,null,false],[351,3033,0,null,null,null,null,false],[351,3034,0,null,null,null,null,false],[351,3035,0,null,null,null,null,false],[351,3036,0,null,null,null,null,false],[351,3037,0,null,null,null,null,false],[351,3038,0,null,null,null,null,false],[351,3039,0,null,null,null,null,false],[351,3040,0,null,null,null,null,false],[351,3041,0,null,null,null,null,false],[351,3042,0,null,null,null,null,false],[351,3043,0,null,null,null,null,false],[351,3044,0,null,null,null,null,false],[351,3045,0,null,null,null,null,false],[351,3046,0,null,null,null,null,false],[351,3047,0,null,null,null,null,false],[351,3048,0,null,null,null,null,false],[351,3049,0,null,null,null,null,false],[351,3050,0,null,null,null,null,false],[351,3051,0,null,null,null,null,false],[351,3052,0,null,null,null,null,false],[351,3057,0,null,null," Clear any signal handler and reset to SIG_DFL.",null,false],[351,3059,0,null,null," Clone into a specific cgroup given the right permissions.",null,false],[351,3064,0,null,null," New time namespace",null,false],[351,3067,0,null,null,null,[],false],[351,3068,0,null,null,null,null,false],[351,3069,0,null,null,null,null,false],[351,3070,0,null,null,null,null,false],[351,3073,0,null,null,null,[],false],[351,3074,0,null,null,null,null,false],[351,3075,0,null,null,null,null,false],[351,3076,0,null,null,null,null,false],[351,3077,0,null,null,null,null,false],[351,3078,0,null,null,null,null,false],[351,3079,0,null,null,null,null,false],[351,3080,0,null,null,null,null,false],[351,3081,0,null,null,null,null,false],[351,3082,0,null,null,null,null,false],[351,3083,0,null,null,null,null,false],[351,3084,0,null,null,null,null,false],[351,3085,0,null,null,null,null,false],[351,3086,0,null,null,null,null,false],[351,3087,0,null,null,null,null,false],[351,3088,0,null,null,null,null,false],[351,3089,0,null,null,null,null,false],[351,3090,0,null,null,null,null,false],[351,3091,0,null,null,null,null,false],[351,3092,0,null,null,null,null,false],[351,3093,0,null,null,null,null,false],[351,3094,0,null,null,null,null,false],[351,3095,0,null,null,null,null,false],[351,3096,0,null,null,null,null,false],[351,3097,0,null,null,null,null,false],[351,3098,0,null,null,null,null,false],[351,3099,0,null,null,null,null,false],[351,3100,0,null,null,null,null,false],[351,3101,0,null,null,null,null,false],[351,3102,0,null,null,null,null,false],[351,3104,0,null,null,null,null,false],[351,3106,0,null,null,null,null,false],[351,3107,0,null,null,null,null,false],[351,3110,0,null,null,null,[],false],[351,3111,0,null,null,null,null,false],[351,3112,0,null,null,null,null,false],[351,3113,0,null,null,null,null,false],[351,3116,0,null,null,null,null,false],[351,3118,0,null,null,null,[],false],[351,3119,0,null,null,null,null,false],[351,3120,0,null,null,null,null,false],[351,3122,0,null,null,null,null,false],[351,3123,0,null,null,null,null,false],[351,3124,0,null,null,null,null,false],[351,3125,0,null,null,null,null,false],[351,3126,0,null,null,null,null,false],[351,3127,0,null,null,null,null,false],[351,3128,0,null,null,null,null,false],[351,3129,0,null,null,null,null,false],[351,3130,0,null,null,null,null,false],[351,3131,0,null,null,null,null,false],[351,3132,0,null,null,null,null,false],[351,3133,0,null,null,null,null,false],[351,3134,0,null,null,null,null,false],[351,3135,0,null,null,null,null,false],[351,3136,0,null,null,null,null,false],[351,3138,0,null,null,null,null,false],[351,3139,0,null,null,null,null,false],[351,3140,0,null,null,null,null,false],[351,3142,0,null,null,null,null,false],[351,3143,0,null,null,null,null,false],[351,3144,0,null,null,null,null,false],[351,3145,0,null,null,null,null,false],[351,3146,0,null,null,null,null,false],[351,3148,0,null,null,null,null,false],[351,3149,0,null,null,null,null,false],[351,3152,0,null,null,null,[],false],[351,3153,0,null,null,null,null,false],[351,3155,0,null,null,null,null,false],[351,3156,0,null,null,null,null,false],[351,3157,0,null,null,null,null,false],[351,3158,0,null,null,null,null,false],[351,3159,0,null,null,null,null,false],[351,3160,0,null,null,null,null,false],[351,3161,0,null,null,null,null,false],[351,3163,0,null,null,null,null,false],[351,3164,0,null,null,null,null,false],[351,3165,0,null,null,null,null,false],[351,3166,0,null,null,null,null,false],[351,3167,0,null,null,null,null,false],[351,3168,0,null,null,null,null,false],[351,3169,0,null,null,null,null,false],[351,3170,0,null,null,null,null,false],[351,3171,0,null,null,null,null,false],[351,3172,0,null,null,null,null,false],[351,3173,0,null,null,null,null,false],[351,3174,0,null,null,null,null,false],[351,3175,0,null,null,null,null,false],[351,3176,0,null,null,null,null,false],[351,3177,0,null,null,null,null,false],[351,3179,0,null,null,null,[42046],false],[0,0,0,"m",null,"",null,false],[351,3183,0,null,null,null,[42048],false],[0,0,0,"m",null,"",null,false],[351,3187,0,null,null,null,[42050],false],[0,0,0,"m",null,"",null,false],[351,3191,0,null,null,null,[42052],false],[0,0,0,"m",null,"",null,false],[351,3195,0,null,null,null,[42054],false],[0,0,0,"m",null,"",null,false],[351,3199,0,null,null,null,[42056],false],[0,0,0,"m",null,"",null,false],[351,3203,0,null,null,null,[42058],false],[0,0,0,"m",null,"",null,false],[351,3208,0,null,null,null,[],false],[351,3209,0,null,null,null,null,false],[351,3210,0,null,null,null,null,false],[351,3213,0,null,null,null,[],false],[351,3214,0,null,null,null,null,false],[351,3215,0,null,null,null,null,false],[351,3217,0,null,null,null,null,false],[351,3218,0,null,null,null,null,false],[351,3221,0,null,null,null,[42068,42069,42070,42071],false],[0,0,0,"ws_row",null,null,null,false],[0,0,0,"ws_col",null,null,null,false],[0,0,0,"ws_xpixel",null,null,null,false],[0,0,0,"ws_ypixel",null,null,null,false],[351,3230,0,null,null," NSIG is the total number of signals defined.\n As signal numbers are sequential, NSIG is one greater than the largest defined signal number.",null,false],[351,3232,0,null,null,null,null,false],[351,3234,0,null,null,null,null,false],[351,3235,0,null,null,null,null,false],[351,3237,0,null,null,null,[],false],[351,3238,0,null,null,null,[42078],false],[0,0,0,"",null,"",null,false],[351,3239,0,null,null,null,[],false],[351,3242,0,null,null,null,null,false],[351,3264,0,null,null," Renamed from `sigaction` to `Sigaction` to avoid conflict with the syscall.",[42091,42093,42094,42096],false],[351,3265,0,null,null,null,[42083],false],[0,0,0,"",null,"",null,false],[351,3266,0,null,null,null,[42085,42086,42087],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[351,3264,0,null,null,null,[42089,42090],false],[0,0,0,"handler",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"handler",null,null,null,false],[351,3264,0,null,null,null,null,false],[0,0,0,"mask",null,null,null,false],[0,0,0,"flags",null,null,null,false],[351,3264,0,null,null,null,[],false],[0,0,0,"restorer",null,null,null,false],[351,3277,0,null,null,null,null,false],[351,3279,0,null,null,null,[],false],[351,3280,0,null,null,null,null,false],[351,3281,0,null,null,null,null,false],[351,3284,0,null,null,null,[42102,42103,42104,42105,42107,42108,42109,42110,42111,42112,42113,42114,42115,42116,42117,42118,42119,42120,42121,42122,42123,42125],false],[0,0,0,"signo",null,null,null,false],[0,0,0,"errno",null,null,null,false],[0,0,0,"code",null,null,null,false],[0,0,0,"pid",null,null,null,false],[351,3284,0,null,null,null,null,false],[0,0,0,"uid",null,null,null,false],[0,0,0,"fd",null,null,null,false],[0,0,0,"tid",null,null,null,false],[0,0,0,"band",null,null,null,false],[0,0,0,"overrun",null,null,null,false],[0,0,0,"trapno",null,null,null,false],[0,0,0,"status",null,null,null,false],[0,0,0,"int",null,null,null,false],[0,0,0,"ptr",null,null,null,false],[0,0,0,"utime",null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"addr_lsb",null,null,null,false],[0,0,0,"__pad2",null,null,null,false],[0,0,0,"syscall",null,null,null,false],[0,0,0,"call_addr",null,null,null,false],[0,0,0,"native_arch",null,null,null,false],[351,3284,0,null,null,null,null,false],[0,0,0,"__pad",null,null,null,false],[351,3309,0,null,null,null,null,false],[351,3310,0,null,null,null,null,false],[351,3311,0,null,null,null,null,false],[351,3313,0,null,null,null,[42190,42192],false],[351,3317,0,null,null,null,null,false],[351,3318,0,null,null,null,[42133,42135],false],[351,3318,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[351,3318,0,null,null,null,null,false],[0,0,0,"padding",null,null,null,false],[351,3329,0,null,null," IPv4 socket address",[42138,42140,42141,42143],false],[351,3329,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[351,3329,0,null,null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"addr",null,null,null,false],[351,3329,0,null,null,null,null,false],[0,0,0,"zero",null,null,null,false],[351,3337,0,null,null," IPv6 socket address",[42146,42148,42149,42151,42152],false],[351,3337,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[351,3337,0,null,null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"flowinfo",null,null,null,false],[351,3337,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"scope_id",null,null,null,false],[351,3346,0,null,null," UNIX domain socket address",[42155,42157],false],[351,3346,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[351,3346,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[351,3352,0,null,null," Packet socket address",[42160,42161,42162,42163,42164,42165,42167],false],[351,3352,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[0,0,0,"protocol",null,null,null,false],[0,0,0,"ifindex",null,null,null,false],[0,0,0,"hatype",null,null,null,false],[0,0,0,"pkttype",null,null,null,false],[0,0,0,"halen",null,null,null,false],[351,3352,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[351,3363,0,null,null," Netlink socket address",[42170,42171,42172,42173],false],[351,3363,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[0,0,0,"__pad1",null,null,null,false],[0,0,0,"pid",null," port ID",null,false],[0,0,0,"groups",null," multicast groups mask",null,false],[351,3374,0,null,null,null,[42175,42176,42177,42178,42179],false],[0,0,0,"family",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"ifindex",null,null,null,false],[0,0,0,"queue_id",null,null,null,false],[0,0,0,"shared_umem_fd",null,null,null,false],[351,3383,0,null,null," Address structure for vSockets",[42182,42183,42184,42185,42186,42188],false],[351,3383,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[0,0,0,"reserved1",null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"cid",null,null,null,false],[0,0,0,"flags",null,null,null,false],[351,3383,0,null,null,null,null,false],[0,0,0,"zero",null," The total size of this structure should be exactly the same as that of struct sockaddr.",null,false],[351,3313,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[351,3313,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[351,3398,0,null,null,null,[42195,42196],false],[351,3398,0,null,null,null,null,false],[0,0,0,"msg_hdr",null,null,null,false],[0,0,0,"msg_len",null,null,null,false],[351,3403,0,null,null,null,[42199,42200],false],[351,3403,0,null,null,null,null,false],[0,0,0,"msg_hdr",null,null,null,false],[0,0,0,"msg_len",null,null,null,false],[351,3408,0,null,null,null,[42202,42203,42204,42205],false],[0,0,0,"ptr",null,null,null,false],[0,0,0,"fd",null,null,null,false],[0,0,0,"u32",null,null,null,false],[0,0,0,"u64",null,null,null,false],[351,3415,0,null,null,null,[42207,42209],false],[0,0,0,"events",null,null,null,false],[351,3415,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[351,3423,0,null,null,null,null,false],[351,3424,0,null,null,null,null,false],[351,3425,0,null,null,null,null,false],[351,3426,0,null,null,null,null,false],[351,3428,0,null,null,null,null,false],[351,3429,0,null,null,null,null,false],[351,3430,0,null,null,null,null,false],[351,3432,0,null,null,null,null,false],[351,3433,0,null,null,null,null,false],[351,3434,0,null,null,null,null,false],[351,3436,0,null,null,null,null,false],[351,3437,0,null,null,null,null,false],[351,3438,0,null,null,null,null,false],[351,3440,0,null,null,null,[42227,42229],false],[351,3443,0,null,null,null,[42225,42226],false],[0,0,0,"permitted",null,null,null,false],[0,0,0,"inheritable",null,null,null,false],[0,0,0,"magic_etc",null,null,null,false],[351,3440,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[351,3452,0,null,null,null,[],false],[351,3453,0,null,null,null,null,false],[351,3454,0,null,null,null,null,false],[351,3455,0,null,null,null,null,false],[351,3456,0,null,null,null,null,false],[351,3457,0,null,null,null,null,false],[351,3458,0,null,null,null,null,false],[351,3459,0,null,null,null,null,false],[351,3460,0,null,null,null,null,false],[351,3461,0,null,null,null,null,false],[351,3462,0,null,null,null,null,false],[351,3463,0,null,null,null,null,false],[351,3464,0,null,null,null,null,false],[351,3465,0,null,null,null,null,false],[351,3466,0,null,null,null,null,false],[351,3467,0,null,null,null,null,false],[351,3468,0,null,null,null,null,false],[351,3469,0,null,null,null,null,false],[351,3470,0,null,null,null,null,false],[351,3471,0,null,null,null,null,false],[351,3472,0,null,null,null,null,false],[351,3473,0,null,null,null,null,false],[351,3474,0,null,null,null,null,false],[351,3475,0,null,null,null,null,false],[351,3476,0,null,null,null,null,false],[351,3477,0,null,null,null,null,false],[351,3478,0,null,null,null,null,false],[351,3479,0,null,null,null,null,false],[351,3480,0,null,null,null,null,false],[351,3481,0,null,null,null,null,false],[351,3482,0,null,null,null,null,false],[351,3483,0,null,null,null,null,false],[351,3484,0,null,null,null,null,false],[351,3485,0,null,null,null,null,false],[351,3486,0,null,null,null,null,false],[351,3487,0,null,null,null,null,false],[351,3488,0,null,null,null,null,false],[351,3489,0,null,null,null,null,false],[351,3490,0,null,null,null,null,false],[351,3491,0,null,null,null,null,false],[351,3492,0,null,null,null,null,false],[351,3493,0,null,null,null,null,false],[351,3494,0,null,null,null,null,false],[351,3496,0,null,null,null,[42274],false],[0,0,0,"x",null,"",null,false],[351,3500,0,null,null,null,[42276],false],[0,0,0,"cap",null,"",null,false],[351,3504,0,null,null,null,[42278],false],[0,0,0,"cap",null,"",null,false],[351,3509,0,null,null,null,[42281,42283],false],[351,3509,0,null,null,null,null,false],[0,0,0,"hdrp",null,null,null,false],[351,3509,0,null,null,null,null,false],[0,0,0,"datap",null,null,null,false],[351,3514,0,null,null,null,[42285,42286],false],[0,0,0,"version",null,null,null,false],[0,0,0,"pid",null,null,null,false],[351,3519,0,null,null,null,[42288,42289,42290],false],[0,0,0,"effective",null,null,null,false],[0,0,0,"permitted",null,null,null,false],[0,0,0,"inheritable",null,null,null,false],[351,3525,0,null,null,null,[42292,42293,42294,42295],false],[0,0,0,"wd",null,null,null,false],[0,0,0,"mask",null,null,null,false],[0,0,0,"cookie",null,null,null,false],[0,0,0,"len",null,null,null,false],[351,3533,0,null,null,null,[42299,42300,42301,42302,42303],false],[351,3540,0,null,null,null,[42298],false],[0,0,0,"self",null,"",null,false],[0,0,0,"d_ino",null,null,null,false],[0,0,0,"d_off",null,null,null,false],[0,0,0,"d_reclen",null,null,null,false],[0,0,0,"d_type",null,null,null,false],[0,0,0,"d_name",null,null,null,false],[351,3545,0,null,null,null,[42305,42307,42309,42310],false],[0,0,0,"dlpi_addr",null,null,null,false],[351,3545,0,null,null,null,null,false],[0,0,0,"dlpi_name",null,null,null,false],[351,3545,0,null,null,null,null,false],[0,0,0,"dlpi_phdr",null,null,null,false],[0,0,0,"dlpi_phnum",null,null,null,false],[351,3552,0,null,null,null,null,false],[351,3553,0,null,null,null,null,false],[351,3554,0,null,null,null,null,false],[351,3556,0,null,null,null,[42315],false],[0,0,0,"set",null,"",null,false],[351,3564,0,null,null,null,null,false],[351,3569,0,null,null,null,null,false],[351,3575,0,null,null,null,null,false],[351,3576,0,null,null,null,null,false],[351,3577,0,null,null,null,null,false],[351,3579,0,null,null,null,null,false],[351,3593,0,null,null,null,[42323,42324],false],[0,0,0,"int",null,null,null,false],[0,0,0,"ptr",null,null,null,false],[351,3598,0,null,null,null,[42326,42346,42358,42361,42366],false],[0,0,0,"pad",null,null,[42336,42345],false],[351,3600,0,null,null,null,[42332,42335],false],[351,3602,0,null,null,null,null,false],[0,0,0,"pid",null,null,null,false],[351,3602,0,null,null,null,null,false],[0,0,0,"uid",null,null,null,false],[0,0,0,"piduid",null,null,[42333,42334],false],[0,0,0,"timerid",null,null,null,false],[0,0,0,"overrun",null,null,null,false],[0,0,0,"timer",null,null,null,false],[0,0,0,"first",null,null,null,false],[351,3600,0,null,null,null,[42338,42344],false],[0,0,0,"value",null,null,[42339,42341,42343],false],[0,0,0,"status",null,null,null,false],[351,3613,0,null,null,null,null,false],[0,0,0,"utime",null,null,null,false],[351,3613,0,null,null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"sigchld",null,null,null,false],[0,0,0,"second",null,null,null,false],[0,0,0,"common",null,null,[42348,42349,42357],false],[351,3620,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"addr_lsb",null,null,null,false],[351,3620,0,null,null,null,[42355,42356],false],[351,3624,0,null,null,null,null,false],[0,0,0,"lower",null,null,null,false],[351,3624,0,null,null,null,null,false],[0,0,0,"upper",null,null,null,false],[0,0,0,"addr_bnd",null,null,null,false],[0,0,0,"pkey",null,null,null,false],[0,0,0,"first",null,null,null,false],[0,0,0,"sigfault",null,null,[42359,42360],false],[0,0,0,"band",null,null,null,false],[0,0,0,"fd",null,null,null,false],[0,0,0,"sigpoll",null,null,[42363,42364,42365],false],[351,3635,0,null,null,null,null,false],[0,0,0,"call_addr",null,null,null,false],[0,0,0,"syscall",null,null,null,false],[0,0,0,"native_arch",null,null,null,false],[0,0,0,"sigsys",null,null,null,false],[351,3642,0,null,null,null,null,false],[351,3657,0,null,null,null,[42369,42370,42371,42372,42373,42374,42375,42377,42379,42381],false],[0,0,0,"sq_entries",null,null,null,false],[0,0,0,"cq_entries",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"sq_thread_cpu",null,null,null,false],[0,0,0,"sq_thread_idle",null,null,null,false],[0,0,0,"features",null,null,null,false],[0,0,0,"wq_fd",null,null,null,false],[351,3657,0,null,null,null,null,false],[0,0,0,"resv",null,null,null,false],[351,3657,0,null,null,null,null,false],[0,0,0,"sq_off",null,null,null,false],[351,3657,0,null,null,null,null,false],[0,0,0,"cq_off",null,null,null,false],[351,3672,0,null,null,null,null,false],[351,3673,0,null,null,null,null,false],[351,3674,0,null,null,null,null,false],[351,3675,0,null,null,null,null,false],[351,3676,0,null,null,null,null,false],[351,3677,0,null,null,null,null,false],[351,3678,0,null,null,null,null,false],[351,3679,0,null,null,null,null,false],[351,3680,0,null,null,null,null,false],[351,3681,0,null,null,null,null,false],[351,3682,0,null,null,null,null,false],[351,3683,0,null,null,null,null,false],[351,3684,0,null,null,null,null,false],[351,3689,0,null,null," io_context is polled",null,false],[351,3692,0,null,null," SQ poll thread",null,false],[351,3695,0,null,null," sq_thread_cpu is valid",null,false],[351,3698,0,null,null," app defines CQ size",null,false],[351,3701,0,null,null," clamp SQ/CQ ring sizes",null,false],[351,3704,0,null,null," attach to existing wq",null,false],[351,3707,0,null,null," start with ring disabled",null,false],[351,3710,0,null,null," continue submit on error",null,false],[351,3717,0,null,null," Cooperative task running. When requests complete, they often require\n forcing the submitter to transition to the kernel to complete. If this\n flag is set, work will be done when the task transitions anyway, rather\n than force an inter-processor interrupt reschedule. This avoids interrupting\n a task running in userspace, and saves an IPI.",null,false],[351,3722,0,null,null," If COOP_TASKRUN is set, get notified if task work is available for\n running and a kernel transition would be needed to run it. This sets\n IORING_SQ_TASKRUN in the sq ring flags. Not valid with COOP_TASKRUN.",null,false],[351,3725,0,null,null," SQEs are 128 byte",null,false],[351,3727,0,null,null," CQEs are 32 byte",null,false],[351,3729,0,null,null,null,[42408,42409,42410,42411,42412,42413,42414,42415,42416],false],[0,0,0,"head",null," offset of ring head",null,false],[0,0,0,"tail",null," offset of ring tail",null,false],[0,0,0,"ring_mask",null," ring mask value",null,false],[0,0,0,"ring_entries",null," entries in ring",null,false],[0,0,0,"flags",null," ring flags",null,false],[0,0,0,"dropped",null," number of sqes not submitted",null,false],[0,0,0,"array",null," sqe index array",null,false],[0,0,0,"resv1",null,null,null,false],[0,0,0,"resv2",null,null,null,false],[351,3758,0,null,null," needs io_uring_enter wakeup",null,false],[351,3760,0,null,null," kernel has cqes waiting beyond the cq ring",null,false],[351,3762,0,null,null," task should enter the kernel",null,false],[351,3764,0,null,null,null,[42421,42422,42423,42424,42425,42426,42428],false],[0,0,0,"head",null,null,null,false],[0,0,0,"tail",null,null,null,false],[0,0,0,"ring_mask",null,null,null,false],[0,0,0,"ring_entries",null,null,null,false],[0,0,0,"overflow",null,null,null,false],[0,0,0,"cqes",null,null,null,false],[351,3764,0,null,null,null,null,false],[0,0,0,"resv",null,null,null,false],[351,3774,0,null,null,null,[42431,42432,42433,42434,42435,42436,42437,42438,42439,42440,42441,42442,42444],false],[351,3774,0,null,null,null,null,false],[0,0,0,"opcode",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"ioprio",null,null,null,false],[0,0,0,"fd",null,null,null,false],[0,0,0,"off",null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"rw_flags",null,null,null,false],[0,0,0,"user_data",null,null,null,false],[0,0,0,"buf_index",null,null,null,false],[0,0,0,"personality",null,null,null,false],[0,0,0,"splice_fd_in",null,null,null,false],[351,3774,0,null,null,null,null,false],[0,0,0,"__pad2",null,null,null,false],[351,3790,0,null,null,null,[42446,42447,42448,42449,42450,42451,42452],false],[0,0,0,"FIXED_FILE",null,null,null,false],[0,0,0,"IO_DRAIN",null,null,null,false],[0,0,0,"IO_LINK",null,null,null,false],[0,0,0,"IO_HARDLINK",null,null,null,false],[0,0,0,"ASYNC",null,null,null,false],[0,0,0,"BUFFER_SELECT",null,null,null,false],[0,0,0,"CQE_SKIP_SUCCESS",null,null,null,false],[351,3805,0,null,null," use fixed fileset",null,false],[351,3808,0,null,null," issue after inflight IO",null,false],[351,3811,0,null,null," links next sqe",null,false],[351,3814,0,null,null," like LINK, but stronger",null,false],[351,3817,0,null,null," always go async",null,false],[351,3820,0,null,null," select buffer from buf_group",null,false],[351,3824,0,null,null," don't post CQE if request succeeded\n Available since Linux 5.17",null,false],[351,3826,0,null,null,null,[42461,42462,42463,42464,42465,42466,42467,42468,42469,42470,42471,42472,42473,42474,42475,42476,42477,42478,42479,42480,42481,42482,42483,42484,42485,42486,42487,42488,42489,42490,42491,42492,42493,42494,42495,42496,42497,42498,42499,42500],false],[0,0,0,"NOP",null,null,null,false],[0,0,0,"READV",null,null,null,false],[0,0,0,"WRITEV",null,null,null,false],[0,0,0,"FSYNC",null,null,null,false],[0,0,0,"READ_FIXED",null,null,null,false],[0,0,0,"WRITE_FIXED",null,null,null,false],[0,0,0,"POLL_ADD",null,null,null,false],[0,0,0,"POLL_REMOVE",null,null,null,false],[0,0,0,"SYNC_FILE_RANGE",null,null,null,false],[0,0,0,"SENDMSG",null,null,null,false],[0,0,0,"RECVMSG",null,null,null,false],[0,0,0,"TIMEOUT",null,null,null,false],[0,0,0,"TIMEOUT_REMOVE",null,null,null,false],[0,0,0,"ACCEPT",null,null,null,false],[0,0,0,"ASYNC_CANCEL",null,null,null,false],[0,0,0,"LINK_TIMEOUT",null,null,null,false],[0,0,0,"CONNECT",null,null,null,false],[0,0,0,"FALLOCATE",null,null,null,false],[0,0,0,"OPENAT",null,null,null,false],[0,0,0,"CLOSE",null,null,null,false],[0,0,0,"FILES_UPDATE",null,null,null,false],[0,0,0,"STATX",null,null,null,false],[0,0,0,"READ",null,null,null,false],[0,0,0,"WRITE",null,null,null,false],[0,0,0,"FADVISE",null,null,null,false],[0,0,0,"MADVISE",null,null,null,false],[0,0,0,"SEND",null,null,null,false],[0,0,0,"RECV",null,null,null,false],[0,0,0,"OPENAT2",null,null,null,false],[0,0,0,"EPOLL_CTL",null,null,null,false],[0,0,0,"SPLICE",null,null,null,false],[0,0,0,"PROVIDE_BUFFERS",null,null,null,false],[0,0,0,"REMOVE_BUFFERS",null,null,null,false],[0,0,0,"TEE",null,null,null,false],[0,0,0,"SHUTDOWN",null,null,null,false],[0,0,0,"RENAMEAT",null,null,null,false],[0,0,0,"UNLINKAT",null,null,null,false],[0,0,0,"MKDIRAT",null,null,null,false],[0,0,0,"SYMLINKAT",null,null,null,false],[0,0,0,"LINKAT",null,null,null,false],[351,3872,0,null,null,null,null,false],[351,3875,0,null,null,null,null,false],[351,3876,0,null,null,null,null,false],[351,3877,0,null,null,null,null,false],[351,3878,0,null,null,null,null,false],[351,3879,0,null,null,null,null,false],[351,3880,0,null,null,null,null,false],[351,3881,0,null,null,null,null,false],[351,3882,0,null,null,null,null,false],[351,3886,0,null,null,null,null,false],[351,3892,0,null,null," Multishot poll. Sets IORING_CQE_F_MORE if the poll handler will continue to report CQEs on behalf of the same SQE.",null,false],[351,3894,0,null,null," Update existing poll request, matching sqe->addr as the old user_data field.",null,false],[351,3895,0,null,null,null,null,false],[351,3900,0,null,null," Cancel all requests that match the given key",null,false],[351,3902,0,null,null," Key off 'fd' for cancelation rather than the request 'user_data'.",null,false],[351,3904,0,null,null," Match any request",null,false],[351,3910,0,null,null," If set, instead of first attempting to send or receive and arm poll if that yields an -EAGAIN result,\n arm poll upfront and skip the initial transfer attempt.",null,false],[351,3912,0,null,null," Multishot recv. Sets IORING_CQE_F_MORE if the handler will continue to report CQEs on behalf of the same SQE.",null,false],[351,3915,0,null,null," accept flags stored in sqe->ioprio",null,false],[351,3918,0,null,null,null,[42523,42524,42525],false],[351,3926,0,null,null,null,[42522],false],[0,0,0,"self",null,"",null,false],[0,0,0,"user_data",null," io_uring_sqe.data submission passed back",null,false],[0,0,0,"res",null," result code for this event",null,false],[0,0,0,"flags",null,null,null,false],[351,3937,0,null,null," If set, the upper 16 bits are the buffer ID",null,false],[351,3940,0,null,null," If set, parent SQE will generate more CQE entries.\n Available since Linux 5.13.",null,false],[351,3942,0,null,null," If set, more data to read after socket recv",null,false],[351,3944,0,null,null," Set for notification CQEs. Can be used to distinct them from sends.",null,false],[351,3947,0,null,null," Magic offsets for the application to mmap the data it needs",null,false],[351,3948,0,null,null,null,null,false],[351,3949,0,null,null,null,null,false],[351,3952,0,null,null,null,null,false],[351,3953,0,null,null,null,null,false],[351,3954,0,null,null,null,null,false],[351,3955,0,null,null,null,null,false],[351,3956,0,null,null,null,null,false],[351,3959,0,null,null,null,[42539,42540,42541,42542,42543,42544,42545,42546,42547,42548,42549,42550,42551,42552,42553,42554,42555,42556,42557,42558,42559,42560,42561,42562,42563,42564],false],[0,0,0,"REGISTER_BUFFERS",null,null,null,false],[0,0,0,"UNREGISTER_BUFFERS",null,null,null,false],[0,0,0,"REGISTER_FILES",null,null,null,false],[0,0,0,"UNREGISTER_FILES",null,null,null,false],[0,0,0,"REGISTER_EVENTFD",null,null,null,false],[0,0,0,"UNREGISTER_EVENTFD",null,null,null,false],[0,0,0,"REGISTER_FILES_UPDATE",null,null,null,false],[0,0,0,"REGISTER_EVENTFD_ASYNC",null,null,null,false],[0,0,0,"REGISTER_PROBE",null,null,null,false],[0,0,0,"REGISTER_PERSONALITY",null,null,null,false],[0,0,0,"UNREGISTER_PERSONALITY",null,null,null,false],[0,0,0,"REGISTER_RESTRICTIONS",null,null,null,false],[0,0,0,"REGISTER_ENABLE_RINGS",null,null,null,false],[0,0,0,"IORING_REGISTER_FILES2",null,null,null,false],[0,0,0,"IORING_REGISTER_FILES_UPDATE2",null,null,null,false],[0,0,0,"IORING_REGISTER_BUFFERS2",null,null,null,false],[0,0,0,"IORING_REGISTER_BUFFERS_UPDATE",null,null,null,false],[0,0,0,"IORING_REGISTER_IOWQ_AFF",null,null,null,false],[0,0,0,"IORING_UNREGISTER_IOWQ_AFF",null,null,null,false],[0,0,0,"IORING_REGISTER_IOWQ_MAX_WORKERS",null,null,null,false],[0,0,0,"IORING_REGISTER_RING_FDS",null,null,null,false],[0,0,0,"IORING_UNREGISTER_RING_FDS",null,null,null,false],[0,0,0,"IORING_REGISTER_PBUF_RING",null,null,null,false],[0,0,0,"IORING_UNREGISTER_PBUF_RING",null,null,null,false],[0,0,0,"IORING_REGISTER_SYNC_CANCEL",null,null,null,false],[0,0,0,"IORING_REGISTER_FILE_ALLOC_RANGE",null,null,null,false],[351,4004,0,null,null,null,[42566,42567,42568],false],[0,0,0,"offset",null,null,null,false],[0,0,0,"resv",null,null,null,false],[0,0,0,"fds",null,null,null,false],[351,4010,0,null,null,null,null,false],[351,4012,0,null,null,null,[42572,42573,42574,42575],false],[351,4012,0,null,null,null,null,false],[0,0,0,"op",null,null,null,false],[0,0,0,"resv",null,null,null,false],[0,0,0,"flags",null," IO_URING_OP_* flags",null,false],[0,0,0,"resv2",null,null,null,false],[351,4023,0,null,null,null,[42578,42579,42580,42582],false],[351,4023,0,null,null,null,null,false],[0,0,0,"last_op",null," last opcode supported",null,false],[0,0,0,"ops_len",null," Number of io_uring_probe_op following",null,false],[0,0,0,"resv",null,null,null,false],[351,4023,0,null,null,null,null,false],[0,0,0,"resv2",null,null,null,false],[351,4036,0,null,null,null,[42584,42589,42590,42592],false],[0,0,0,"opcode",null,null,null,false],[351,4036,0,null,null,null,[42586,42587,42588],false],[0,0,0,"register_op",null," IORING_RESTRICTION_REGISTER_OP",null,false],[0,0,0,"sqe_op",null," IORING_RESTRICTION_SQE_OP",null,false],[0,0,0,"sqe_flags",null," IORING_RESTRICTION_SQE_FLAGS_*",null,false],[0,0,0,"arg",null,null,null,false],[0,0,0,"resv",null,null,null,false],[351,4036,0,null,null,null,null,false],[0,0,0,"resv2",null,null,null,false],[351,4053,0,null,null," io_uring_restriction->opcode values",[42594,42595,42596,42597],false],[0,0,0,"REGISTER_OP",null," Allow an io_uring_register(2) opcode",null,false],[0,0,0,"SQE_OP",null," Allow an sqe opcode",null,false],[0,0,0,"SQE_FLAGS_ALLOWED",null," Allow sqe flags",null,false],[0,0,0,"SQE_FLAGS_REQUIRED",null," Require sqe flags (these flags must be set on each submission)",null,false],[351,4069,0,null,null,null,[42600,42602,42604,42606,42608,42610],false],[351,4069,0,null,null,null,null,false],[0,0,0,"sysname",null,null,null,false],[351,4069,0,null,null,null,null,false],[0,0,0,"nodename",null,null,null,false],[351,4069,0,null,null,null,null,false],[0,0,0,"release",null,null,null,false],[351,4069,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[351,4069,0,null,null,null,null,false],[0,0,0,"machine",null,null,null,false],[351,4069,0,null,null,null,null,false],[0,0,0,"domainname",null,null,null,false],[351,4077,0,null,null,null,null,false],[351,4079,0,null,null,null,null,false],[351,4080,0,null,null,null,null,false],[351,4081,0,null,null,null,null,false],[351,4082,0,null,null,null,null,false],[351,4083,0,null,null,null,null,false],[351,4084,0,null,null,null,null,false],[351,4085,0,null,null,null,null,false],[351,4086,0,null,null,null,null,false],[351,4087,0,null,null,null,null,false],[351,4088,0,null,null,null,null,false],[351,4089,0,null,null,null,null,false],[351,4090,0,null,null,null,null,false],[351,4092,0,null,null,null,null,false],[351,4094,0,null,null,null,null,false],[351,4095,0,null,null,null,null,false],[351,4096,0,null,null,null,null,false],[351,4097,0,null,null,null,null,false],[351,4098,0,null,null,null,null,false],[351,4099,0,null,null,null,null,false],[351,4101,0,null,null,null,[42632,42633,42634],false],[0,0,0,"tv_sec",null,null,null,false],[0,0,0,"tv_nsec",null,null,null,false],[0,0,0,"__pad1",null,null,null,false],[351,4108,0,null,null," Renamed to `Statx` to not conflict with the `statx` function.",[42636,42637,42638,42639,42641,42643,42644,42645,42646,42647,42648,42649,42651,42653,42655,42657,42658,42659,42660,42661,42663],false],[0,0,0,"mask",null," Mask of bits indicating filled fields",null,false],[0,0,0,"blksize",null," Block size for filesystem I/O",null,false],[0,0,0,"attributes",null," Extra file attribute indicators",null,false],[0,0,0,"nlink",null," Number of hard links",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"uid",null," User ID of owner",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"gid",null," Group ID of owner",null,false],[0,0,0,"mode",null," File type and mode",null,false],[0,0,0,"__pad1",null,null,null,false],[0,0,0,"ino",null," Inode number",null,false],[0,0,0,"size",null," Total size in bytes",null,false],[0,0,0,"blocks",null," Number of 512B blocks allocated",null,false],[0,0,0,"attributes_mask",null," Mask to show what's supported in `attributes`.",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"atime",null," Last access file timestamp",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"btime",null," Creation file timestamp",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"ctime",null," Last status change file timestamp",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"mtime",null," Last modification file timestamp",null,false],[0,0,0,"rdev_major",null," Major ID, if this file represents a device.",null,false],[0,0,0,"rdev_minor",null," Minor ID, if this file represents a device.",null,false],[0,0,0,"dev_major",null," Major ID of the device containing the filesystem where this file resides.",null,false],[0,0,0,"dev_minor",null," Minor ID of the device containing the filesystem where this file resides.",null,false],[351,4108,0,null,null,null,null,false],[0,0,0,"__pad2",null,null,null,false],[351,4170,0,null,null,null,[42665,42666,42667,42668,42670,42672,42674,42676],false],[0,0,0,"flags",null,null,null,false],[0,0,0,"family",null,null,null,false],[0,0,0,"socktype",null,null,null,false],[0,0,0,"protocol",null,null,null,false],[351,4170,0,null,null,null,null,false],[0,0,0,"addrlen",null,null,null,false],[351,4170,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[351,4170,0,null,null,null,null,false],[0,0,0,"canonname",null,null,null,false],[351,4170,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[351,4181,0,null,null,null,null,false],[351,4183,0,null,null,null,[],false],[351,4184,0,null,null,null,null,false],[351,4185,0,null,null,null,null,false],[351,4186,0,null,null,null,null,false],[351,4187,0,null,null,null,null,false],[351,4188,0,null,null,null,null,false],[351,4189,0,null,null,null,null,false],[351,4190,0,null,null,null,null,false],[351,4191,0,null,null,null,null,false],[351,4192,0,null,null,null,null,false],[351,4193,0,null,null,null,null,false],[351,4194,0,null,null,null,null,false],[351,4195,0,null,null,null,null,false],[351,4196,0,null,null,null,null,false],[351,4197,0,null,null,null,null,false],[351,4198,0,null,null,null,null,false],[351,4199,0,null,null,null,null,false],[351,4200,0,null,null,null,null,false],[351,4201,0,null,null,null,null,false],[351,4202,0,null,null,null,null,false],[351,4203,0,null,null,null,null,false],[351,4204,0,null,null,null,null,false],[351,4205,0,null,null,null,null,false],[351,4206,0,null,null,null,null,false],[351,4207,0,null,null,null,null,false],[351,4208,0,null,null,null,null,false],[351,4209,0,null,null,null,null,false],[351,4210,0,null,null,null,null,false],[351,4211,0,null,null,null,null,false],[351,4212,0,null,null,null,null,false],[351,4213,0,null,null,null,null,false],[351,4214,0,null,null,null,null,false],[351,4215,0,null,null,null,null,false],[351,4216,0,null,null,null,null,false],[351,4219,0,null,null,null,[],false],[351,4220,0,null,null,null,null,false],[351,4221,0,null,null,null,null,false],[351,4222,0,null,null,null,null,false],[351,4225,0,null,null,null,[42717,42718],false],[0,0,0,"opt_code",null,null,null,false],[0,0,0,"opt_val",null,null,null,false],[351,4230,0,null,null,null,[42720,42721,42722,42723,42724],false],[0,0,0,"snd_wl1",null,null,null,false],[0,0,0,"snd_wnd",null,null,null,false],[0,0,0,"max_window",null,null,null,false],[0,0,0,"rcv_wnd",null,null,null,false],[0,0,0,"rcv_wup",null,null,null,false],[351,4238,0,null,null,null,[42726,42727,42728,42729],false],[0,0,0,"TCP_NO_QUEUE",null,null,null,false],[0,0,0,"TCP_RECV_QUEUE",null,null,null,false],[0,0,0,"TCP_SEND_QUEUE",null,null,null,false],[0,0,0,"TCP_QUEUES_NR",null,null,null,false],[351,4246,0,null,null," why fastopen failed from client perspective",[42731,42732,42733,42734],false],[0,0,0,"TFO_STATUS_UNSPEC",null," catch-all",null,false],[0,0,0,"TFO_COOKIE_UNAVAILABLE",null," if not in TFO_CLIENT_NO_COOKIE mode",null,false],[0,0,0,"TFO_DATA_NOT_ACKED",null," SYN-ACK did not ack SYN data",null,false],[0,0,0,"TFO_SYN_RETRANSMITTED",null," SYN-ACK did not ack SYN data after timeout",null,false],[351,4258,0,null,null," for TCP_INFO socket option",null,false],[351,4259,0,null,null,null,null,false],[351,4260,0,null,null,null,null,false],[351,4262,0,null,null," ECN was negotiated at TCP session init",null,false],[351,4264,0,null,null," we received at least one packet with ECT",null,false],[351,4266,0,null,null," SYN-ACK acked data in SYN sent or rcvd",null,false],[351,4268,0,null,null,null,null,false],[351,4269,0,null,null,null,[42744,42745,42746],false],[351,4269,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[0,0,0,"events",null,null,null,false],[0,0,0,"revents",null,null,null,false],[351,4275,0,null,null,null,[],false],[351,4276,0,null,null,null,null,false],[351,4277,0,null,null,null,null,false],[351,4278,0,null,null,null,null,false],[351,4279,0,null,null,null,null,false],[351,4280,0,null,null,null,null,false],[351,4281,0,null,null,null,null,false],[351,4282,0,null,null,null,null,false],[351,4283,0,null,null,null,null,false],[351,4286,0,null,null,null,null,false],[351,4287,0,null,null,null,null,false],[351,4288,0,null,null,null,null,false],[351,4289,0,null,null,null,null,false],[351,4290,0,null,null,null,null,false],[351,4291,0,null,null,null,null,false],[351,4292,0,null,null,null,null,false],[351,4293,0,null,null,null,null,false],[351,4294,0,null,null,null,null,false],[351,4295,0,null,null,null,null,false],[351,4296,0,null,null,null,null,false],[351,4297,0,null,null,null,null,false],[351,4298,0,null,null,null,null,false],[351,4299,0,null,null,null,null,false],[351,4301,0,null,null,null,[],false],[351,4302,0,null,null,null,null,false],[351,4303,0,null,null,null,null,false],[351,4304,0,null,null,null,null,false],[351,4305,0,null,null,null,null,false],[351,4307,0,null,null,null,null,false],[351,4308,0,null,null,null,null,false],[351,4309,0,null,null,null,null,false],[351,4310,0,null,null,null,null,false],[351,4311,0,null,null,null,null,false],[351,4312,0,null,null,null,null,false],[351,4313,0,null,null,null,null,false],[351,4314,0,null,null,null,null,false],[351,4315,0,null,null,null,null,false],[351,4316,0,null,null,null,null,false],[351,4317,0,null,null,null,null,false],[351,4318,0,null,null,null,null,false],[351,4319,0,null,null,null,null,false],[351,4320,0,null,null,null,null,false],[351,4323,0,null,null,null,[42794,42796,42797,42798,42799,42800,42801,42802,42803,42804,42805,42806,42807,42808,42809,42810,42812],false],[351,4342,0,null,null,null,null,false],[351,4343,0,null,null,null,null,false],[351,4344,0,null,null,null,null,false],[351,4323,0,null,null,null,null,false],[0,0,0,"utime",null,null,null,false],[351,4323,0,null,null,null,null,false],[0,0,0,"stime",null,null,null,false],[0,0,0,"maxrss",null,null,null,false],[0,0,0,"ixrss",null,null,null,false],[0,0,0,"idrss",null,null,null,false],[0,0,0,"isrss",null,null,null,false],[0,0,0,"minflt",null,null,null,false],[0,0,0,"majflt",null,null,null,false],[0,0,0,"nswap",null,null,null,false],[0,0,0,"inblock",null,null,null,false],[0,0,0,"oublock",null,null,null,false],[0,0,0,"msgsnd",null,null,null,false],[0,0,0,"msgrcv",null,null,null,false],[0,0,0,"nsignals",null,null,null,false],[0,0,0,"nvcsw",null,null,null,false],[0,0,0,"nivcsw",null,null,null,false],[351,4323,0,null,null,null,null,false],[0,0,0,"__reserved",null,null,null,false],[351,4347,0,null,null,null,null,false],[351,4348,0,null,null,null,null,false],[351,4349,0,null,null,null,null,false],[351,4351,0,null,null,null,null,false],[351,4353,0,null,null,null,null,false],[351,4354,0,null,null,null,null,false],[351,4355,0,null,null,null,null,false],[351,4356,0,null,null,null,null,false],[351,4357,0,null,null,null,null,false],[351,4358,0,null,null,null,null,false],[351,4359,0,null,null,null,null,false],[351,4360,0,null,null,null,null,false],[351,4361,0,null,null,null,null,false],[351,4362,0,null,null,null,null,false],[351,4363,0,null,null,null,null,false],[351,4364,0,null,null,null,null,false],[351,4365,0,null,null,null,null,false],[351,4366,0,null,null,null,null,false],[351,4367,0,null,null,null,null,false],[351,4368,0,null,null,null,null,false],[351,4369,0,null,null,null,null,false],[351,4370,0,null,null,null,null,false],[351,4371,0,null,null,null,null,false],[351,4372,0,null,null,null,null,false],[351,4373,0,null,null,null,null,false],[351,4374,0,null,null,null,null,false],[351,4375,0,null,null,null,null,false],[351,4376,0,null,null,null,null,false],[351,4377,0,null,null,null,null,false],[351,4378,0,null,null,null,null,false],[351,4379,0,null,null,null,null,false],[351,4380,0,null,null,null,null,false],[351,4381,0,null,null,null,null,false],[351,4382,0,null,null,null,null,false],[351,4383,0,null,null,null,null,false],[351,4384,0,null,null,null,null,false],[351,4386,0,null,null,null,null,false],[351,4467,0,null,null,null,null,false],[351,4468,0,null,null,null,null,false],[351,4469,0,null,null,null,null,false],[351,4470,0,null,null,null,null,false],[351,4471,0,null,null,null,null,false],[351,4472,0,null,null,null,null,false],[351,4473,0,null,null,null,null,false],[351,4474,0,null,null,null,null,false],[351,4475,0,null,null,null,null,false],[351,4476,0,null,null,null,null,false],[351,4477,0,null,null,null,null,false],[351,4478,0,null,null,null,null,false],[351,4479,0,null,null,null,null,false],[351,4480,0,null,null,null,null,false],[351,4481,0,null,null,null,null,false],[351,4483,0,null,null,null,null,false],[351,4484,0,null,null,null,null,false],[351,4485,0,null,null,null,null,false],[351,4486,0,null,null,null,null,false],[351,4487,0,null,null,null,null,false],[351,4488,0,null,null,null,null,false],[351,4489,0,null,null,null,null,false],[351,4490,0,null,null,null,null,false],[351,4491,0,null,null,null,null,false],[351,4492,0,null,null,null,null,false],[351,4493,0,null,null,null,null,false],[351,4495,0,null,null,null,null,false],[351,4496,0,null,null,null,null,false],[351,4497,0,null,null,null,null,false],[351,4498,0,null,null,null,null,false],[351,4499,0,null,null,null,null,false],[351,4500,0,null,null,null,null,false],[351,4501,0,null,null,null,null,false],[351,4502,0,null,null,null,null,false],[351,4503,0,null,null,null,null,false],[351,4504,0,null,null,null,null,false],[351,4505,0,null,null,null,null,false],[351,4507,0,null,null,null,null,false],[351,4508,0,null,null,null,null,false],[351,4509,0,null,null,null,null,false],[351,4510,0,null,null,null,null,false],[351,4511,0,null,null,null,null,false],[351,4512,0,null,null,null,null,false],[351,4513,0,null,null,null,null,false],[351,4514,0,null,null,null,null,false],[351,4515,0,null,null,null,null,false],[351,4517,0,null,null,null,[42897,42898,42899],false],[0,0,0,"NOW",null,null,null,false],[0,0,0,"DRAIN",null,null,null,false],[0,0,0,"FLUSH",null,null,null,false],[351,4524,0,null,null,null,[42902,42904,42906,42908,42910,42912,42914,42916],false],[351,4524,0,null,null,null,null,false],[0,0,0,"iflag",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"oflag",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"cflag",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"lflag",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"line",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"cc",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"ispeed",null,null,null,false],[351,4524,0,null,null,null,null,false],[0,0,0,"ospeed",null,null,null,false],[351,4535,0,null,null,null,null,false],[351,4536,0,null,null,null,null,false],[351,4538,0,null,null,null,[42920,42921,42922,42923,42924,42925],false],[0,0,0,"mem_start",null,null,null,false],[0,0,0,"mem_end",null,null,null,false],[0,0,0,"base_addr",null,null,null,false],[0,0,0,"irq",null,null,null,false],[0,0,0,"dma",null,null,null,false],[0,0,0,"port",null,null,null,false],[351,4547,0,null,null,null,[42929,42943],false],[351,4547,0,null,null,null,[42928],false],[0,0,0,"name",null,null,null,false],[0,0,0,"ifrn",null,null,null,false],[351,4547,0,null,null,null,[42931,42932,42933,42934,42935,42936,42937,42938,42939,42940,42941,42942],false],[0,0,0,"addr",null,null,null,false],[0,0,0,"dstaddr",null,null,null,false],[0,0,0,"broadaddr",null,null,null,false],[0,0,0,"netmask",null,null,null,false],[0,0,0,"hwaddr",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"ivalue",null,null,null,false],[0,0,0,"mtu",null,null,null,false],[0,0,0,"map",null,null,null,false],[0,0,0,"slave",null,null,null,false],[0,0,0,"newname",null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"ifru",null,null,null,false],[351,4568,0,null,null,null,null,false],[351,4631,0,null,null,null,null,false],[351,4633,0,null,null,null,[],false],[351,4635,0,null,null," No limit",null,false],[351,4637,0,null,null,null,null,false],[351,4638,0,null,null,null,null,false],[351,4641,0,null,null,null,[42952,42954],false],[351,4641,0,null,null,null,null,false],[0,0,0,"cur",null," Soft limit",null,false],[351,4641,0,null,null,null,null,false],[0,0,0,"max",null," Hard limit",null,false],[351,4648,0,null,null,null,[],false],[351,4649,0,null,null,null,null,false],[351,4650,0,null,null,null,null,false],[351,4651,0,null,null,null,null,false],[351,4652,0,null,null,null,null,false],[351,4653,0,null,null,null,null,false],[351,4654,0,null,null,null,null,false],[351,4655,0,null,null,null,null,false],[351,4656,0,null,null,null,null,false],[351,4657,0,null,null,null,null,false],[351,4658,0,null,null,null,null,false],[351,4659,0,null,null,null,null,false],[351,4660,0,null,null,null,null,false],[351,4661,0,null,null,null,null,false],[351,4662,0,null,null,null,null,false],[351,4663,0,null,null,null,null,false],[351,4664,0,null,null,null,null,false],[351,4665,0,null,null,null,null,false],[351,4666,0,null,null,null,null,false],[351,4667,0,null,null,null,null,false],[351,4668,0,null,null,null,null,false],[351,4669,0,null,null,null,null,false],[351,4672,0,null,null,null,null,false],[351,4699,0,null,null," The timespec struct used by the kernel.",null,false],[351,4704,0,null,null,null,[42980,42981],false],[0,0,0,"tv_sec",null,null,null,false],[0,0,0,"tv_nsec",null,null,null,false],[351,4709,0,null,null,null,[],false],[351,4710,0,null,null,null,null,false],[351,4711,0,null,null,null,null,false],[351,4712,0,null,null,null,null,false],[351,4713,0,null,null,null,null,false],[351,4714,0,null,null,null,null,false],[351,4716,0,null,null,null,null,false],[351,4717,0,null,null,null,null,false],[351,4718,0,null,null,null,null,false],[351,4719,0,null,null,null,null,false],[351,4720,0,null,null,null,null,false],[351,4721,0,null,null,null,null,false],[351,4722,0,null,null,null,null,false],[351,4723,0,null,null,null,null,false],[351,4725,0,null,null,null,null,false],[351,4727,0,null,null,null,null,false],[351,4728,0,null,null,null,null,false],[351,4729,0,null,null,null,null,false],[351,4730,0,null,null,null,null,false],[351,4733,0,null,null,null,[43002,43003,43004,43005],false],[0,0,0,"producer",null,null,null,false],[0,0,0,"consumer",null,null,null,false],[0,0,0,"desc",null,null,null,false],[0,0,0,"flags",null,null,null,false],[351,4740,0,null,null,null,[43008,43010,43012,43014],false],[351,4740,0,null,null,null,null,false],[0,0,0,"rx",null,null,null,false],[351,4740,0,null,null,null,null,false],[0,0,0,"tx",null,null,null,false],[351,4740,0,null,null,null,null,false],[0,0,0,"fr",null,null,null,false],[351,4740,0,null,null,null,null,false],[0,0,0,"cr",null,null,null,false],[351,4747,0,null,null,null,[43016,43017,43018,43019,43020],false],[0,0,0,"addr",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"chunk_size",null,null,null,false],[0,0,0,"headroom",null,null,null,false],[0,0,0,"flags",null,null,null,false],[351,4755,0,null,null,null,[43022,43023,43024,43025,43026,43027],false],[0,0,0,"rx_dropped",null,null,null,false],[0,0,0,"rx_invalid_descs",null,null,null,false],[0,0,0,"tx_invalid_descs",null,null,null,false],[0,0,0,"rx_ring_full",null,null,null,false],[0,0,0,"rx_fill_ring_empty_descs",null,null,null,false],[0,0,0,"tx_ring_empty_descs",null,null,null,false],[351,4764,0,null,null,null,[43029],false],[0,0,0,"flags",null,null,null,false],[351,4768,0,null,null,null,null,false],[351,4769,0,null,null,null,null,false],[351,4771,0,null,null,null,[43033,43034,43035],false],[0,0,0,"addr",null,null,null,false],[0,0,0,"len",null,null,null,false],[0,0,0,"options",null,null,null,false],[351,4777,0,null,null,null,[43037],false],[0,0,0,"x",null,"",null,true],[351,4781,0,null,null,null,null,false],[351,4783,0,null,null,null,null,false],[351,4784,0,null,null,null,null,false],[351,4786,0,null,null,null,null,false],[351,4787,0,null,null,null,null,false],[351,4789,0,null,null,null,null,false],[351,4790,0,null,null,null,null,false],[351,4792,0,null,null,null,null,false],[351,4793,0,null,null,null,null,false],[351,4795,0,null,null,null,null,false],[351,4796,0,null,null,null,null,false],[351,4798,0,null,null,null,null,false],[351,4799,0,null,null,null,null,false],[351,4801,0,null,null,null,null,false],[351,4802,0,null,null,null,null,false],[351,4804,0,null,null,null,null,false],[351,4805,0,null,null,null,null,false],[351,4807,0,null,null,null,null,false],[351,4811,0,null,null,null,null,false],[351,4813,0,null,null,null,[43115,43116,43117,43118,43119,43120,43121,43122,43123,43124,43125,43126,43127,43128,43129,43130,43131,43132,43133,43134,43135,43136,43137,43138,43139,43140,43141,43142,43143,43144,43145,43146,43147,43148,43149,43150,43151,43152,43153,43154,43155,43156,43157,43158,43159,43160,43161,43162,43163,43164],false],[351,4894,0,null,null,null,null,false],[351,4895,0,null,null,null,null,false],[351,4897,0,null,null,null,null,false],[351,4898,0,null,null,null,null,false],[351,4900,0,null,null,null,null,false],[351,4901,0,null,null,null,null,false],[351,4902,0,null,null,null,null,false],[351,4903,0,null,null,null,null,false],[351,4904,0,null,null,null,null,false],[351,4905,0,null,null,null,null,false],[351,4906,0,null,null,null,null,false],[351,4907,0,null,null,null,null,false],[351,4908,0,null,null,null,null,false],[351,4909,0,null,null,null,null,false],[351,4911,0,null,null,null,null,false],[351,4912,0,null,null,null,null,false],[351,4914,0,null,null,null,null,false],[351,4915,0,null,null,null,null,false],[351,4916,0,null,null,null,null,false],[351,4918,0,null,null,null,null,false],[351,4919,0,null,null,null,null,false],[351,4921,0,null,null,null,null,false],[351,4922,0,null,null,null,null,false],[351,4924,0,null,null,null,null,false],[351,4925,0,null,null,null,null,false],[351,4926,0,null,null,null,null,false],[351,4928,0,null,null,null,null,false],[351,4929,0,null,null,null,null,false],[351,4930,0,null,null,null,null,false],[351,4931,0,null,null,null,null,false],[351,4932,0,null,null,null,null,false],[351,4933,0,null,null,null,null,false],[351,4934,0,null,null,null,null,false],[351,4935,0,null,null,null,null,false],[351,4936,0,null,null,null,null,false],[351,4937,0,null,null,null,null,false],[351,4938,0,null,null,null,null,false],[351,4939,0,null,null,null,null,false],[351,4940,0,null,null,null,null,false],[351,4941,0,null,null,null,null,false],[351,4942,0,null,null,null,null,false],[351,4944,0,null,null,null,null,false],[351,4946,0,null,null,null,null,false],[351,4947,0,null,null,null,null,false],[351,4949,0,null,null,null,null,false],[351,4950,0,null,null,null,null,false],[351,4951,0,null,null,null,null,false],[351,4952,0,null,null,null,null,false],[351,4954,0,null,null,null,null,false],[351,4955,0,null,null,null,null,false],[351,4956,0,null,null,null,null,false],[351,4958,0,null,null,null,null,false],[351,4959,0,null,null,null,null,false],[351,4960,0,null,null,null,null,false],[351,4961,0,null,null,null,null,false],[351,4962,0,null,null,null,null,false],[351,4963,0,null,null,null,null,false],[0,0,0,"SET_PDEATHSIG",null,null,null,false],[0,0,0,"GET_PDEATHSIG",null,null,null,false],[0,0,0,"GET_DUMPABLE",null,null,null,false],[0,0,0,"SET_DUMPABLE",null,null,null,false],[0,0,0,"GET_UNALIGN",null,null,null,false],[0,0,0,"SET_UNALIGN",null,null,null,false],[0,0,0,"GET_KEEPCAPS",null,null,null,false],[0,0,0,"SET_KEEPCAPS",null,null,null,false],[0,0,0,"GET_FPEMU",null,null,null,false],[0,0,0,"SET_FPEMU",null,null,null,false],[0,0,0,"GET_FPEXC",null,null,null,false],[0,0,0,"SET_FPEXC",null,null,null,false],[0,0,0,"GET_TIMING",null,null,null,false],[0,0,0,"SET_TIMING",null,null,null,false],[0,0,0,"SET_NAME",null,null,null,false],[0,0,0,"GET_NAME",null,null,null,false],[0,0,0,"GET_ENDIAN",null,null,null,false],[0,0,0,"SET_ENDIAN",null,null,null,false],[0,0,0,"GET_SECCOMP",null,null,null,false],[0,0,0,"SET_SECCOMP",null,null,null,false],[0,0,0,"CAPBSET_READ",null,null,null,false],[0,0,0,"CAPBSET_DROP",null,null,null,false],[0,0,0,"GET_TSC",null,null,null,false],[0,0,0,"SET_TSC",null,null,null,false],[0,0,0,"GET_SECUREBITS",null,null,null,false],[0,0,0,"SET_SECUREBITS",null,null,null,false],[0,0,0,"SET_TIMERSLACK",null,null,null,false],[0,0,0,"GET_TIMERSLACK",null,null,null,false],[0,0,0,"TASK_PERF_EVENTS_DISABLE",null,null,null,false],[0,0,0,"TASK_PERF_EVENTS_ENABLE",null,null,null,false],[0,0,0,"MCE_KILL",null,null,null,false],[0,0,0,"MCE_KILL_GET",null,null,null,false],[0,0,0,"SET_MM",null,null,null,false],[0,0,0,"SET_PTRACER",null,null,null,false],[0,0,0,"SET_CHILD_SUBREAPER",null,null,null,false],[0,0,0,"GET_CHILD_SUBREAPER",null,null,null,false],[0,0,0,"SET_NO_NEW_PRIVS",null,null,null,false],[0,0,0,"GET_NO_NEW_PRIVS",null,null,null,false],[0,0,0,"GET_TID_ADDRESS",null,null,null,false],[0,0,0,"SET_THP_DISABLE",null,null,null,false],[0,0,0,"GET_THP_DISABLE",null,null,null,false],[0,0,0,"MPX_ENABLE_MANAGEMENT",null,null,null,false],[0,0,0,"MPX_DISABLE_MANAGEMENT",null,null,null,false],[0,0,0,"SET_FP_MODE",null,null,null,false],[0,0,0,"GET_FP_MODE",null,null,null,false],[0,0,0,"CAP_AMBIENT",null,null,null,false],[0,0,0,"SVE_SET_VL",null,null,null,false],[0,0,0,"SVE_GET_VL",null,null,null,false],[0,0,0,"GET_SPECULATION_CTRL",null,null,null,false],[0,0,0,"SET_SPECULATION_CTRL",null,null,null,false],[351,4966,0,null,null,null,[43166,43167,43168,43169,43170,43171,43172,43173,43174,43175,43176,43178,43179,43180],false],[0,0,0,"start_code",null,null,null,false],[0,0,0,"end_code",null,null,null,false],[0,0,0,"start_data",null,null,null,false],[0,0,0,"end_data",null,null,null,false],[0,0,0,"start_brk",null,null,null,false],[0,0,0,"brk",null,null,null,false],[0,0,0,"start_stack",null,null,null,false],[0,0,0,"arg_start",null,null,null,false],[0,0,0,"arg_end",null,null,null,false],[0,0,0,"env_start",null,null,null,false],[0,0,0,"env_end",null,null,null,false],[351,4966,0,null,null,null,null,false],[0,0,0,"auxv",null,null,null,false],[0,0,0,"auxv_size",null,null,null,false],[0,0,0,"exe_fd",null,null,null,false],[351,4983,0,null,null,null,[],false],[351,4985,0,null,null," Routing/device hook",null,false],[351,4988,0,null,null," Unused number",null,false],[351,4991,0,null,null," Reserved for user mode socket protocols",null,false],[351,4994,0,null,null," Unused number, formerly ip_queue",null,false],[351,4997,0,null,null," socket monitoring",null,false],[351,5000,0,null,null," netfilter/iptables ULOG",null,false],[351,5003,0,null,null," ipsec",null,false],[351,5006,0,null,null," SELinux event notifications",null,false],[351,5009,0,null,null," Open-iSCSI",null,false],[351,5012,0,null,null," auditing",null,false],[351,5014,0,null,null,null,null,false],[351,5016,0,null,null,null,null,false],[351,5019,0,null,null," netfilter subsystem",null,false],[351,5021,0,null,null,null,null,false],[351,5024,0,null,null," DECnet routing messages",null,false],[351,5027,0,null,null," Kernel messages to userspace",null,false],[351,5029,0,null,null,null,null,false],[351,5034,0,null,null," SCSI Transports",null,false],[351,5036,0,null,null,null,null,false],[351,5038,0,null,null,null,null,false],[351,5041,0,null,null," Crypto layer",null,false],[351,5044,0,null,null," SMC monitoring",null,false],[351,5050,0,null,null," It is request message.",null,false],[351,5053,0,null,null," Multipart message, terminated by NLMSG_DONE",null,false],[351,5056,0,null,null," Reply with ack, with zero or error code",null,false],[351,5059,0,null,null," Echo this request",null,false],[351,5062,0,null,null," Dump was inconsistent due to sequence change",null,false],[351,5065,0,null,null," Dump was filtered as requested",null,false],[351,5070,0,null,null," specify tree root",null,false],[351,5073,0,null,null," return all matching",null,false],[351,5076,0,null,null," atomic GET",null,false],[351,5077,0,null,null,null,null,false],[351,5082,0,null,null," Override existing",null,false],[351,5085,0,null,null," Do not touch, if it exists",null,false],[351,5088,0,null,null," Create, if it does not exist",null,false],[351,5091,0,null,null," Add to end of list",null,false],[351,5096,0,null,null," Do not delete recursively",null,false],[351,5101,0,null,null," request was capped",null,false],[351,5104,0,null,null," extended ACK TVLs were included",null,false],[351,5106,0,null,null,null,[43223,43224,43225,43226,43227,43228,43229,43230,43231,43232,43233,43234,43235,43236,43237,43238,43239,43240,43241,43242,43243,43244,43245,43246,43247,43248,43249,43250,43251,43252,43253,43254,43255,43256,43257,43258,43259,43260,43261,43262,43263,43264,43265,43266,43267,43268,43269,43270,43271,43272,43273,43274,43275,43276,43277,43278,43279,43280,43281,43282,43283,43284],false],[351,5108,0,null,null," < 0x10: reserved control messages",null,false],[0,0,0,"NOOP",null," Nothing.",null,false],[0,0,0,"ERROR",null," Error",null,false],[0,0,0,"DONE",null," End of a dump",null,false],[0,0,0,"OVERRUN",null," Data lost",null,false],[0,0,0,"RTM_NEWLINK",null,null,null,false],[0,0,0,"RTM_DELLINK",null,null,null,false],[0,0,0,"RTM_GETLINK",null,null,null,false],[0,0,0,"RTM_SETLINK",null,null,null,false],[0,0,0,"RTM_NEWADDR",null,null,null,false],[0,0,0,"RTM_DELADDR",null,null,null,false],[0,0,0,"RTM_GETADDR",null,null,null,false],[0,0,0,"RTM_NEWROUTE",null,null,null,false],[0,0,0,"RTM_DELROUTE",null,null,null,false],[0,0,0,"RTM_GETROUTE",null,null,null,false],[0,0,0,"RTM_NEWNEIGH",null,null,null,false],[0,0,0,"RTM_DELNEIGH",null,null,null,false],[0,0,0,"RTM_GETNEIGH",null,null,null,false],[0,0,0,"RTM_NEWRULE",null,null,null,false],[0,0,0,"RTM_DELRULE",null,null,null,false],[0,0,0,"RTM_GETRULE",null,null,null,false],[0,0,0,"RTM_NEWQDISC",null,null,null,false],[0,0,0,"RTM_DELQDISC",null,null,null,false],[0,0,0,"RTM_GETQDISC",null,null,null,false],[0,0,0,"RTM_NEWTCLASS",null,null,null,false],[0,0,0,"RTM_DELTCLASS",null,null,null,false],[0,0,0,"RTM_GETTCLASS",null,null,null,false],[0,0,0,"RTM_NEWTFILTER",null,null,null,false],[0,0,0,"RTM_DELTFILTER",null,null,null,false],[0,0,0,"RTM_GETTFILTER",null,null,null,false],[0,0,0,"RTM_NEWACTION",null,null,null,false],[0,0,0,"RTM_DELACTION",null,null,null,false],[0,0,0,"RTM_GETACTION",null,null,null,false],[0,0,0,"RTM_NEWPREFIX",null,null,null,false],[0,0,0,"RTM_GETMULTICAST",null,null,null,false],[0,0,0,"RTM_GETANYCAST",null,null,null,false],[0,0,0,"RTM_NEWNEIGHTBL",null,null,null,false],[0,0,0,"RTM_GETNEIGHTBL",null,null,null,false],[0,0,0,"RTM_SETNEIGHTBL",null,null,null,false],[0,0,0,"RTM_NEWNDUSEROPT",null,null,null,false],[0,0,0,"RTM_NEWADDRLABEL",null,null,null,false],[0,0,0,"RTM_DELADDRLABEL",null,null,null,false],[0,0,0,"RTM_GETADDRLABEL",null,null,null,false],[0,0,0,"RTM_GETDCB",null,null,null,false],[0,0,0,"RTM_SETDCB",null,null,null,false],[0,0,0,"RTM_NEWNETCONF",null,null,null,false],[0,0,0,"RTM_DELNETCONF",null,null,null,false],[0,0,0,"RTM_GETNETCONF",null,null,null,false],[0,0,0,"RTM_NEWMDB",null,null,null,false],[0,0,0,"RTM_DELMDB",null,null,null,false],[0,0,0,"RTM_GETMDB",null,null,null,false],[0,0,0,"RTM_NEWNSID",null,null,null,false],[0,0,0,"RTM_DELNSID",null,null,null,false],[0,0,0,"RTM_GETNSID",null,null,null,false],[0,0,0,"RTM_NEWSTATS",null,null,null,false],[0,0,0,"RTM_GETSTATS",null,null,null,false],[0,0,0,"RTM_NEWCACHEREPORT",null,null,null,false],[0,0,0,"RTM_NEWCHAIN",null,null,null,false],[0,0,0,"RTM_DELCHAIN",null,null,null,false],[0,0,0,"RTM_GETCHAIN",null,null,null,false],[0,0,0,"RTM_NEWNEXTHOP",null,null,null,false],[0,0,0,"RTM_DELNEXTHOP",null,null,null,false],[0,0,0,"RTM_GETNEXTHOP",null,null,null,false],[351,5210,0,null,null," Netlink message header\n Specified in RFC 3549 Section 2.3.2",[43286,43288,43289,43290,43291],false],[0,0,0,"len",null," Length of message including header",null,false],[351,5210,0,null,null,null,null,false],[0,0,0,"type",null," Message content",null,false],[0,0,0,"flags",null," Additional flags",null,false],[0,0,0,"seq",null," Sequence number",null,false],[0,0,0,"pid",null," Sending process port ID",null,false],[351,5227,0,null,null,null,[43293,43294,43295,43296,43297,43298],false],[0,0,0,"family",null,null,null,false],[0,0,0,"__pad1",null,null,null,false],[0,0,0,"type",null," ARPHRD_*",null,false],[0,0,0,"index",null," Link index",null,false],[0,0,0,"flags",null," IFF_* flags",null,false],[0,0,0,"change",null," IFF_* change mask",null,false],[351,5244,0,null,null,null,[43301,43303],false],[351,5251,0,null,null,null,null,false],[0,0,0,"len",null," Length of option",null,false],[351,5244,0,null,null,null,null,false],[0,0,0,"type",null," Type of option",null,false],[351,5254,0,null,null,null,[43306,43307,43308,43309,43310,43311,43312,43313,43314,43315,43316,43317,43318,43319,43320,43321,43322,43323,43324,43325,43326,43327,43328,43329,43330,43331,43332,43333,43334,43335,43336,43337,43338,43339,43340,43341,43342,43343,43344,43345,43346,43347,43348,43349,43350,43351,43352,43353,43354,43355,43356,43357],false],[351,5328,0,null,null,null,null,false],[0,0,0,"UNSPEC",null,null,null,false],[0,0,0,"ADDRESS",null,null,null,false],[0,0,0,"BROADCAST",null,null,null,false],[0,0,0,"IFNAME",null,null,null,false],[0,0,0,"MTU",null,null,null,false],[0,0,0,"LINK",null,null,null,false],[0,0,0,"QDISC",null,null,null,false],[0,0,0,"STATS",null,null,null,false],[0,0,0,"COST",null,null,null,false],[0,0,0,"PRIORITY",null,null,null,false],[0,0,0,"MASTER",null,null,null,false],[0,0,0,"WIRELESS",null," Wireless Extension event",null,false],[0,0,0,"PROTINFO",null," Protocol specific information for a link",null,false],[0,0,0,"TXQLEN",null,null,null,false],[0,0,0,"MAP",null,null,null,false],[0,0,0,"WEIGHT",null,null,null,false],[0,0,0,"OPERSTATE",null,null,null,false],[0,0,0,"LINKMODE",null,null,null,false],[0,0,0,"LINKINFO",null,null,null,false],[0,0,0,"NET_NS_PID",null,null,null,false],[0,0,0,"IFALIAS",null,null,null,false],[0,0,0,"NUM_VF",null," Number of VFs if device is SR-IOV PF",null,false],[0,0,0,"VFINFO_LIST",null,null,null,false],[0,0,0,"STATS64",null,null,null,false],[0,0,0,"VF_PORTS",null,null,null,false],[0,0,0,"PORT_SELF",null,null,null,false],[0,0,0,"AF_SPEC",null,null,null,false],[0,0,0,"GROUP",null," Group the device belongs to",null,false],[0,0,0,"NET_NS_FD",null,null,null,false],[0,0,0,"EXT_MASK",null," Extended info mask, VFs, etc",null,false],[0,0,0,"PROMISCUITY",null," Promiscuity count: > 0 means acts PROMISC",null,false],[0,0,0,"NUM_TX_QUEUES",null,null,null,false],[0,0,0,"NUM_RX_QUEUES",null,null,null,false],[0,0,0,"CARRIER",null,null,null,false],[0,0,0,"PHYS_PORT_ID",null,null,null,false],[0,0,0,"CARRIER_CHANGES",null,null,null,false],[0,0,0,"PHYS_SWITCH_ID",null,null,null,false],[0,0,0,"LINK_NETNSID",null,null,null,false],[0,0,0,"PHYS_PORT_NAME",null,null,null,false],[0,0,0,"PROTO_DOWN",null,null,null,false],[0,0,0,"GSO_MAX_SEGS",null,null,null,false],[0,0,0,"GSO_MAX_SIZE",null,null,null,false],[0,0,0,"PAD",null,null,null,false],[0,0,0,"XDP",null,null,null,false],[0,0,0,"EVENT",null,null,null,false],[0,0,0,"NEW_NETNSID",null,null,null,false],[0,0,0,"IF_NETNSID",null,null,null,false],[0,0,0,"CARRIER_UP_COUNT",null,null,null,false],[0,0,0,"CARRIER_DOWN_COUNT",null,null,null,false],[0,0,0,"NEW_IFINDEX",null,null,null,false],[0,0,0,"MIN_MTU",null,null,null,false],[0,0,0,"MAX_MTU",null,null,null,false],[351,5331,0,null,null,null,[43359,43360,43361,43362,43363,43364],false],[0,0,0,"mem_start",null,null,null,false],[0,0,0,"mem_end",null,null,null,false],[0,0,0,"base_addr",null,null,null,false],[0,0,0,"irq",null,null,null,false],[0,0,0,"dma",null,null,null,false],[0,0,0,"port",null,null,null,false],[351,5340,0,null,null,null,[43366,43367,43368,43369,43370,43371,43372,43373,43374,43375,43376,43377,43378,43379,43380,43381,43382,43383,43384,43385,43386,43387,43388,43389],false],[0,0,0,"rx_packets",null," total packets received",null,false],[0,0,0,"tx_packets",null," total packets transmitted",null,false],[0,0,0,"rx_bytes",null," total bytes received",null,false],[0,0,0,"tx_bytes",null," total bytes transmitted",null,false],[0,0,0,"rx_errors",null," bad packets received",null,false],[0,0,0,"tx_errors",null," packet transmit problems",null,false],[0,0,0,"rx_dropped",null," no space in linux buffers",null,false],[0,0,0,"tx_dropped",null," no space available in linux",null,false],[0,0,0,"multicast",null," multicast packets received",null,false],[0,0,0,"collisions",null,null,null,false],[0,0,0,"rx_length_errors",null,null,null,false],[0,0,0,"rx_over_errors",null," receiver ring buff overflow",null,false],[0,0,0,"rx_crc_errors",null," recved pkt with crc error",null,false],[0,0,0,"rx_frame_errors",null," recv'd frame alignment error",null,false],[0,0,0,"rx_fifo_errors",null," recv'r fifo overrun",null,false],[0,0,0,"rx_missed_errors",null," receiver missed packet",null,false],[0,0,0,"tx_aborted_errors",null,null,null,false],[0,0,0,"tx_carrier_errors",null,null,null,false],[0,0,0,"tx_fifo_errors",null,null,null,false],[0,0,0,"tx_heartbeat_errors",null,null,null,false],[0,0,0,"tx_window_errors",null,null,null,false],[0,0,0,"rx_compressed",null,null,null,false],[0,0,0,"tx_compressed",null,null,null,false],[0,0,0,"rx_nohandler",null," dropped, no handler found",null,false],[351,5405,0,null,null,null,[43391,43392,43393,43394,43395,43396,43397,43398,43399,43400,43401,43402,43403,43404,43405,43406,43407,43408,43409,43410,43411,43412,43413,43414],false],[0,0,0,"rx_packets",null," total packets received",null,false],[0,0,0,"tx_packets",null," total packets transmitted",null,false],[0,0,0,"rx_bytes",null," total bytes received",null,false],[0,0,0,"tx_bytes",null," total bytes transmitted",null,false],[0,0,0,"rx_errors",null," bad packets received",null,false],[0,0,0,"tx_errors",null," packet transmit problems",null,false],[0,0,0,"rx_dropped",null," no space in linux buffers",null,false],[0,0,0,"tx_dropped",null," no space available in linux",null,false],[0,0,0,"multicast",null," multicast packets received",null,false],[0,0,0,"collisions",null,null,null,false],[0,0,0,"rx_length_errors",null,null,null,false],[0,0,0,"rx_over_errors",null," receiver ring buff overflow",null,false],[0,0,0,"rx_crc_errors",null," recved pkt with crc error",null,false],[0,0,0,"rx_frame_errors",null," recv'd frame alignment error",null,false],[0,0,0,"rx_fifo_errors",null," recv'r fifo overrun",null,false],[0,0,0,"rx_missed_errors",null," receiver missed packet",null,false],[0,0,0,"tx_aborted_errors",null,null,null,false],[0,0,0,"tx_carrier_errors",null,null,null,false],[0,0,0,"tx_fifo_errors",null,null,null,false],[0,0,0,"tx_heartbeat_errors",null,null,null,false],[0,0,0,"tx_window_errors",null,null,null,false],[0,0,0,"rx_compressed",null,null,null,false],[0,0,0,"tx_compressed",null,null,null,false],[0,0,0,"rx_nohandler",null," dropped, no handler found",null,false],[351,5470,0,null,null,null,[43417,43418,43419,43420,43421,43422,43455,43456,43457,43458,43459,43460,43461,43462,43463,43464,43465,43466,43467],false],[351,5470,0,null,null,null,null,false],[0,0,0,"type",null," Major type: hardware/software/tracepoint/etc.",null,false],[0,0,0,"size",null," Size of the attr structure, for fwd/bwd compat.",null,false],[0,0,0,"config",null," Type specific configuration information.",null,false],[0,0,0,"sample_period_or_freq",null,null,null,false],[0,0,0,"sample_type",null,null,null,false],[0,0,0,"read_format",null,null,null,false],[351,5470,0,null,null,null,[43424,43425,43426,43427,43428,43429,43430,43431,43432,43433,43434,43435,43436,43437,43438,43440,43441,43442,43443,43444,43445,43446,43447,43448,43449,43450,43451,43452,43454],false],[0,0,0,"disabled",null," off by default",null,false],[0,0,0,"inherit",null," children inherit it",null,false],[0,0,0,"pinned",null," must always be on PMU",null,false],[0,0,0,"exclusive",null," only group on PMU",null,false],[0,0,0,"exclude_user",null," don't count user",null,false],[0,0,0,"exclude_kernel",null," ditto kernel",null,false],[0,0,0,"exclude_hv",null," ditto hypervisor",null,false],[0,0,0,"exclude_idle",null," don't count when idle",null,false],[0,0,0,"mmap",null," include mmap data",null,false],[0,0,0,"comm",null," include comm data",null,false],[0,0,0,"freq",null," use freq, not period",null,false],[0,0,0,"inherit_stat",null," per task counts",null,false],[0,0,0,"enable_on_exec",null," next exec enables",null,false],[0,0,0,"task",null," trace fork/exit",null,false],[0,0,0,"watermark",null," wakeup_watermark",null,false],[351,5482,0,null,null,null,null,false],[0,0,0,"precise_ip",null," precise_ip:\n\n  0 - SAMPLE_IP can have arbitrary skid\n  1 - SAMPLE_IP must have constant skid\n  2 - SAMPLE_IP requested to have 0 skid\n  3 - SAMPLE_IP must have 0 skid\n\n  See also PERF_RECORD_MISC_EXACT_IP\n skid constraint",null,false],[0,0,0,"mmap_data",null," non-exec mmap data",null,false],[0,0,0,"sample_id_all",null," sample_type all events",null,false],[0,0,0,"exclude_host",null," don't count in host",null,false],[0,0,0,"exclude_guest",null," don't count in guest",null,false],[0,0,0,"exclude_callchain_kernel",null," exclude kernel callchains",null,false],[0,0,0,"exclude_callchain_user",null," exclude user callchains",null,false],[0,0,0,"mmap2",null," include mmap with inode data",null,false],[0,0,0,"comm_exec",null," flag comm events that are due to an exec",null,false],[0,0,0,"use_clockid",null," use @clockid for time fields",null,false],[0,0,0,"context_switch",null," context switch data",null,false],[0,0,0,"write_backward",null," Write ring buffer from end to beginning",null,false],[0,0,0,"namespaces",null," include namespaces data",null,false],[351,5482,0,null,null,null,null,false],[0,0,0,"__reserved_1",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"wakeup_events_or_watermark",null," wakeup every n events, or\n bytes before wakeup",null,false],[0,0,0,"bp_type",null,null,null,false],[0,0,0,"config1",null," This field is also used for:\n bp_addr\n kprobe_func for perf_kprobe\n uprobe_path for perf_uprobe",null,false],[0,0,0,"config2",null," This field is also used for:\n bp_len\n kprobe_addr when kprobe_func == null\n probe_offset for perf_[k,u]probe",null,false],[0,0,0,"branch_sample_type",null," enum perf_branch_sample_type",null,false],[0,0,0,"sample_regs_user",null," Defines set of user regs to dump on samples.\n See asm/perf_regs.h for details.",null,false],[0,0,0,"sample_stack_user",null," Defines size of the user stack to dump on samples.",null,false],[0,0,0,"clockid",null,null,null,false],[0,0,0,"sample_regs_intr",null," Defines set of regs to dump for each sample\n state captured on:\n  - precise = 0: PMU interrupt\n  - precise > 0: sampled instruction\n\n See asm/perf_regs.h for details.",null,false],[0,0,0,"aux_watermark",null," Wakeup watermark for AUX area",null,false],[0,0,0,"sample_max_stack",null,null,null,false],[0,0,0,"__reserved_2",null," Align to u64",null,false],[351,5595,0,null,null,null,[],false],[351,5596,0,null,null,null,[43470,43471,43472,43473,43474,43475,43476],false],[0,0,0,"HARDWARE",null,null,null,false],[0,0,0,"SOFTWARE",null,null,null,false],[0,0,0,"TRACEPOINT",null,null,null,false],[0,0,0,"HW_CACHE",null,null,null,false],[0,0,0,"RAW",null,null,null,false],[0,0,0,"BREAKPOINT",null,null,null,false],[0,0,0,"MAX",null,null,null,false],[351,5607,0,null,null,null,[],false],[351,5608,0,null,null,null,[43497,43498,43499,43500,43501,43502,43503,43504,43505,43506,43507],false],[351,5621,0,null,null,null,[43489,43490,43491,43492,43493,43494,43495,43496],false],[351,5631,0,null,null,null,[43481,43482,43483,43484],false],[0,0,0,"READ",null,null,null,false],[0,0,0,"WRITE",null,null,null,false],[0,0,0,"PREFETCH",null,null,null,false],[0,0,0,"MAX",null,null,null,false],[351,5638,0,null,null,null,[43486,43487,43488],false],[0,0,0,"ACCESS",null,null,null,false],[0,0,0,"MISS",null,null,null,false],[0,0,0,"MAX",null,null,null,false],[0,0,0,"L1D",null,null,null,false],[0,0,0,"L1I",null,null,null,false],[0,0,0,"LL",null,null,null,false],[0,0,0,"DTLB",null,null,null,false],[0,0,0,"ITLB",null,null,null,false],[0,0,0,"BPU",null,null,null,false],[0,0,0,"NODE",null,null,null,false],[0,0,0,"MAX",null,null,null,false],[0,0,0,"CPU_CYCLES",null,null,null,false],[0,0,0,"INSTRUCTIONS",null,null,null,false],[0,0,0,"CACHE_REFERENCES",null,null,null,false],[0,0,0,"CACHE_MISSES",null,null,null,false],[0,0,0,"BRANCH_INSTRUCTIONS",null,null,null,false],[0,0,0,"BRANCH_MISSES",null,null,null,false],[0,0,0,"BUS_CYCLES",null,null,null,false],[0,0,0,"STALLED_CYCLES_FRONTEND",null,null,null,false],[0,0,0,"STALLED_CYCLES_BACKEND",null,null,null,false],[0,0,0,"REF_CPU_CYCLES",null,null,null,false],[0,0,0,"MAX",null,null,null,false],[351,5646,0,null,null,null,[43509,43510,43511,43512,43513,43514,43515,43516,43517,43518,43519,43520],false],[0,0,0,"CPU_CLOCK",null,null,null,false],[0,0,0,"TASK_CLOCK",null,null,null,false],[0,0,0,"PAGE_FAULTS",null,null,null,false],[0,0,0,"CONTEXT_SWITCHES",null,null,null,false],[0,0,0,"CPU_MIGRATIONS",null,null,null,false],[0,0,0,"PAGE_FAULTS_MIN",null,null,null,false],[0,0,0,"PAGE_FAULTS_MAJ",null,null,null,false],[0,0,0,"ALIGNMENT_FAULTS",null,null,null,false],[0,0,0,"EMULATION_FAULTS",null,null,null,false],[0,0,0,"DUMMY",null,null,null,false],[0,0,0,"BPF_OUTPUT",null,null,null,false],[0,0,0,"MAX",null,null,null,false],[351,5662,0,null,null,null,[],false],[351,5663,0,null,null,null,null,false],[351,5664,0,null,null,null,null,false],[351,5665,0,null,null,null,null,false],[351,5666,0,null,null,null,null,false],[351,5667,0,null,null,null,null,false],[351,5668,0,null,null,null,null,false],[351,5669,0,null,null,null,null,false],[351,5670,0,null,null,null,null,false],[351,5671,0,null,null,null,null,false],[351,5672,0,null,null,null,null,false],[351,5673,0,null,null,null,null,false],[351,5674,0,null,null,null,null,false],[351,5675,0,null,null,null,null,false],[351,5676,0,null,null,null,null,false],[351,5677,0,null,null,null,null,false],[351,5678,0,null,null,null,null,false],[351,5679,0,null,null,null,null,false],[351,5680,0,null,null,null,null,false],[351,5681,0,null,null,null,null,false],[351,5682,0,null,null,null,null,false],[351,5683,0,null,null,null,null,false],[351,5685,0,null,null,null,[],false],[351,5686,0,null,null,null,null,false],[351,5687,0,null,null,null,null,false],[351,5688,0,null,null,null,null,false],[351,5689,0,null,null,null,null,false],[351,5690,0,null,null,null,null,false],[351,5691,0,null,null,null,null,false],[351,5692,0,null,null,null,null,false],[351,5693,0,null,null,null,null,false],[351,5694,0,null,null,null,null,false],[351,5695,0,null,null,null,null,false],[351,5696,0,null,null,null,null,false],[351,5697,0,null,null,null,null,false],[351,5698,0,null,null,null,null,false],[351,5699,0,null,null,null,null,false],[351,5700,0,null,null,null,null,false],[351,5701,0,null,null,null,null,false],[351,5702,0,null,null,null,null,false],[351,5703,0,null,null,null,null,false],[351,5707,0,null,null,null,[],false],[351,5708,0,null,null,null,null,false],[351,5709,0,null,null,null,null,false],[351,5710,0,null,null,null,null,false],[351,5711,0,null,null,null,null,false],[351,5714,0,null,null,null,[],false],[351,5715,0,null,null,null,null,false],[351,5716,0,null,null,null,null,false],[351,5717,0,null,null,null,null,false],[351,5718,0,null,null,null,null,false],[351,5719,0,null,null,null,null,false],[351,5720,0,null,null,null,null,false],[351,5721,0,null,null,null,null,false],[351,5722,0,null,null,null,null,false],[351,5723,0,null,null,null,null,false],[351,5724,0,null,null,null,null,false],[351,5725,0,null,null,null,null,false],[351,5728,0,null,null,null,null,false],[351,5732,0,null,null,null,[],false],[351,5733,0,null,null,null,[43587,43588,43589,43590,43591,43592,43593,43594,43595,43596,43597,43598,43599,43600,43601,43602,43603,43604,43605,43606],false],[351,5734,0,null,null,null,null,false],[351,5735,0,null,null,null,null,false],[351,5737,0,null,null,null,null,false],[351,5773,0,null,null,null,[43586],false],[0,0,0,"arch",null,"",null,false],[0,0,0,"AARCH64",null,null,null,false],[0,0,0,"ARM",null,null,null,false],[0,0,0,"ARMEB",null,null,null,false],[0,0,0,"CSKY",null,null,null,false],[0,0,0,"HEXAGON",null,null,null,false],[0,0,0,"X86",null,null,null,false],[0,0,0,"M68K",null,null,null,false],[0,0,0,"MIPS",null,null,null,false],[0,0,0,"MIPSEL",null,null,null,false],[0,0,0,"MIPS64",null,null,null,false],[0,0,0,"MIPSEL64",null,null,null,false],[0,0,0,"PPC",null,null,null,false],[0,0,0,"PPC64",null,null,null,false],[0,0,0,"PPC64LE",null,null,null,false],[0,0,0,"RISCV32",null,null,null,false],[0,0,0,"RISCV64",null,null,null,false],[0,0,0,"S390X",null,null,null,false],[0,0,0,"SPARC",null,null,null,false],[0,0,0,"SPARC64",null,null,null,false],[0,0,0,"X86_64",null,null,null,false],[351,5793,0,null,null,null,[],false],[351,5794,0,null,null,null,null,false],[351,5795,0,null,null,null,null,false],[351,5796,0,null,null,null,null,false],[351,5797,0,null,null,null,null,false],[351,5798,0,null,null,null,null,false],[351,5799,0,null,null,null,null,false],[351,5800,0,null,null,null,null,false],[351,5801,0,null,null,null,null,false],[351,5802,0,null,null,null,null,false],[351,5803,0,null,null,null,null,false],[351,5804,0,null,null,null,null,false],[351,5805,0,null,null,null,null,false],[351,5806,0,null,null,null,null,false],[351,5807,0,null,null,null,null,false],[351,5808,0,null,null,null,null,false],[351,5809,0,null,null,null,null,false],[351,5810,0,null,null,null,null,false],[351,5811,0,null,null,null,null,false],[351,5812,0,null,null,null,null,false],[351,5813,0,null,null,null,null,false],[351,5814,0,null,null,null,null,false],[351,5815,0,null,null,null,null,false],[351,5816,0,null,null,null,null,false],[351,5817,0,null,null,null,null,false],[351,5818,0,null,null,null,null,false],[351,5819,0,null,null,null,null,false],[351,5820,0,null,null,null,null,false],[351,5821,0,null,null,null,null,false],[351,5822,0,null,null,null,null,false],[351,5823,0,null,null,null,null,false],[351,5824,0,null,null,null,null,false],[351,5825,0,null,null,null,null,false],[351,5826,0,null,null,null,null,false],[351,5827,0,null,null,null,null,false],[350,36,0,null,null,null,null,false],[0,0,0,"os/plan9.zig",null,"",[],false],[363,0,0,null,null,null,null,false],[363,1,0,null,null,null,null,false],[363,3,0,null,null,null,null,false],[363,5,0,null,null,null,null,false],[363,6,0,null,null,null,null,false],[363,7,0,null,null,null,null,false],[363,8,0,null,null,null,null,false],[363,9,0,null,null,null,null,false],[363,13,0,null,null,null,null,false],[0,0,0,"plan9/errno.zig",null," Ported from /sys/include/ape/errno.h\n",[],false],[364,1,0,null,null,null,[43655,43656,43657,43658,43659,43660,43661,43662,43663,43664,43665,43666,43667,43668,43669,43670,43671,43672,43673,43674,43675,43676,43677,43678,43679,43680,43681,43682,43683,43684,43685,43686,43687,43688,43689,43690,43691,43692,43693,43694,43695,43696,43697,43698,43699,43700,43701,43702,43703,43704,43705,43706,43707,43708,43709,43710,43711,43712,43713,43714,43715,43716,43717,43718,43719,43720,43721,43722,43723,43724,43725],false],[0,0,0,"SUCCESS",null,null,null,false],[0,0,0,"DOM",null,null,null,false],[0,0,0,"RANGE",null,null,null,false],[0,0,0,"PLAN9",null,null,null,false],[0,0,0,"2BIG",null,null,null,false],[0,0,0,"ACCES",null,null,null,false],[0,0,0,"AGAIN",null,null,null,false],[0,0,0,"BADF",null,null,null,false],[0,0,0,"BUSY",null,null,null,false],[0,0,0,"CHILD",null,null,null,false],[0,0,0,"DEADLK",null,null,null,false],[0,0,0,"EXIST",null,null,null,false],[0,0,0,"FAULT",null,null,null,false],[0,0,0,"FBIG",null,null,null,false],[0,0,0,"INTR",null,null,null,false],[0,0,0,"INVAL",null,null,null,false],[0,0,0,"IO",null,null,null,false],[0,0,0,"ISDIR",null,null,null,false],[0,0,0,"MFILE",null,null,null,false],[0,0,0,"MLINK",null,null,null,false],[0,0,0,"NAMETOOLONG",null,null,null,false],[0,0,0,"NFILE",null,null,null,false],[0,0,0,"NODEV",null,null,null,false],[0,0,0,"NOENT",null,null,null,false],[0,0,0,"NOEXEC",null,null,null,false],[0,0,0,"NOLCK",null,null,null,false],[0,0,0,"NOMEM",null,null,null,false],[0,0,0,"NOSPC",null,null,null,false],[0,0,0,"NOSYS",null,null,null,false],[0,0,0,"NOTDIR",null,null,null,false],[0,0,0,"NOTEMPTY",null,null,null,false],[0,0,0,"NOTTY",null,null,null,false],[0,0,0,"NXIO",null,null,null,false],[0,0,0,"PERM",null,null,null,false],[0,0,0,"PIPE",null,null,null,false],[0,0,0,"ROFS",null,null,null,false],[0,0,0,"SPIPE",null,null,null,false],[0,0,0,"SRCH",null,null,null,false],[0,0,0,"XDEV",null,null,null,false],[0,0,0,"NOTSOCK",null,null,null,false],[0,0,0,"PROTONOSUPPORT",null,null,null,false],[0,0,0,"CONNREFUSED",null,null,null,false],[0,0,0,"AFNOSUPPORT",null,null,null,false],[0,0,0,"NOBUFS",null,null,null,false],[0,0,0,"OPNOTSUPP",null,null,null,false],[0,0,0,"ADDRINUSE",null,null,null,false],[0,0,0,"DESTADDRREQ",null,null,null,false],[0,0,0,"MSGSIZE",null,null,null,false],[0,0,0,"NOPROTOOPT",null,null,null,false],[0,0,0,"SOCKTNOSUPPORT",null,null,null,false],[0,0,0,"PFNOSUPPORT",null,null,null,false],[0,0,0,"ADDRNOTAVAIL",null,null,null,false],[0,0,0,"NETDOWN",null,null,null,false],[0,0,0,"NETUNREACH",null,null,null,false],[0,0,0,"NETRESET",null,null,null,false],[0,0,0,"CONNABORTED",null,null,null,false],[0,0,0,"ISCONN",null,null,null,false],[0,0,0,"NOTCONN",null,null,null,false],[0,0,0,"SHUTDOWN",null,null,null,false],[0,0,0,"TOOMANYREFS",null,null,null,false],[0,0,0,"TIMEDOUT",null,null,null,false],[0,0,0,"HOSTDOWN",null,null,null,false],[0,0,0,"HOSTUNREACH",null,null,null,false],[0,0,0,"GREG",null,null,null,false],[0,0,0,"CANCELED",null,null,null,false],[0,0,0,"INPROGRESS",null,null,null,false],[0,0,0,"DQUOT",null,null,null,false],[0,0,0,"CONNRESET",null,null,null,false],[0,0,0,"OVERFLOW",null,null,null,false],[0,0,0,"LOOP",null,null,null,false],[0,0,0,"TXTBSY",null,null,null,false],[363,15,0,null,null," Get the errno from a syscall return value, or 0 for no error.",[43727],false],[0,0,0,"r",null,"",null,false],[363,21,0,null,null,null,null,false],[363,22,0,null,null,null,null,false],[363,24,0,null,null," Gets whatever the last errstr was",[],false],[363,28,0,null,null,null,null,false],[363,29,0,null,null,null,[43744,43745,43746,43747,43748,43749],false],[363,29,0,null,null,null,[43735,43737,43739,43741,43742,43743],false],[363,31,0,null,null,null,null,false],[0,0,0,"pp",null," known to be 0(ptr)",null,false],[363,31,0,null,null,null,null,false],[0,0,0,"next",null," known to be 4(ptr)",null,false],[363,31,0,null,null,null,null,false],[0,0,0,"last",null,null,null,false],[363,31,0,null,null,null,null,false],[0,0,0,"first",null,null,null,false],[0,0,0,"pid",null,null,null,false],[0,0,0,"what",null,null,null,false],[0,0,0,"prof",null," Per process profiling",null,false],[0,0,0,"cyclefreq",null," cycle clock frequency if there is one, 0 otherwise",null,false],[0,0,0,"kcycles",null," cycles spent in kernel",null,false],[0,0,0,"pcycles",null," cycles spent in process (kernel + user)",null,false],[0,0,0,"pid",null," might as well put the pid here",null,false],[0,0,0,"clock",null,null,null,false],[363,53,0,null,null,null,null,false],[363,54,0,null,null,null,[],false],[363,57,0,null,null,null,[],false],[363,59,0,null,null," hangup",null,false],[363,61,0,null,null," interrupt",null,false],[363,63,0,null,null," quit",null,false],[363,65,0,null,null," illegal instruction (not reset when caught)",null,false],[363,67,0,null,null," used by abort",null,false],[363,69,0,null,null," floating point exception",null,false],[363,71,0,null,null," kill (cannot be caught or ignored)",null,false],[363,73,0,null,null," segmentation violation",null,false],[363,75,0,null,null," write on a pipe with no one to read it",null,false],[363,77,0,null,null," alarm clock",null,false],[363,79,0,null,null," software termination signal from kill",null,false],[363,81,0,null,null," user defined signal 1",null,false],[363,83,0,null,null," user defined signal 2",null,false],[363,85,0,null,null," bus error",null,false],[363,88,0,null,null," child process terminated or stopped",null,false],[363,90,0,null,null," continue if stopped",null,false],[363,92,0,null,null," stop",null,false],[363,94,0,null,null," interactive stop",null,false],[363,96,0,null,null," read from ctl tty by member of background",null,false],[363,98,0,null,null," write to ctl tty by member of background",null,false],[363,100,0,null,null,null,null,false],[363,101,0,null,null,null,null,false],[363,102,0,null,null,null,null,false],[363,104,0,null,null,null,[43786,43788,43789],false],[363,105,0,null,null,null,[43778],false],[0,0,0,"",null,"",null,false],[363,106,0,null,null,null,[43780,43781,43782],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[363,104,0,null,null,null,[43784,43785],false],[0,0,0,"handler",null,null,null,false],[0,0,0,"sigaction",null,null,null,false],[0,0,0,"handler",null,null,null,false],[363,104,0,null,null,null,null,false],[0,0,0,"mask",null,null,null,false],[0,0,0,"flags",null,null,null,false],[363,115,0,null,null,null,[],false],[363,116,0,null,null,null,null,false],[363,120,0,null,null,null,[43793,43794,43795],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"act",null,"",null,false],[0,0,0,"oact",null,"",null,false],[363,126,0,null,null,null,[43797,43798,43799,43800,43801,43802,43803,43804,43805,43806,43807,43808,43809,43810,43811,43812,43813,43814,43815,43816,43817,43818,43819,43820,43821,43822,43823,43824,43825,43826,43827,43828,43829,43830,43831,43832,43833,43834,43835,43836,43837,43838,43839,43840,43841,43842,43843,43844,43845,43846,43847,43848],false],[0,0,0,"SYSR1",null,null,null,false],[0,0,0,"_ERRSTR",null,null,null,false],[0,0,0,"BIND",null,null,null,false],[0,0,0,"CHDIR",null,null,null,false],[0,0,0,"CLOSE",null,null,null,false],[0,0,0,"DUP",null,null,null,false],[0,0,0,"ALARM",null,null,null,false],[0,0,0,"EXEC",null,null,null,false],[0,0,0,"EXITS",null,null,null,false],[0,0,0,"_FSESSION",null,null,null,false],[0,0,0,"FAUTH",null,null,null,false],[0,0,0,"_FSTAT",null,null,null,false],[0,0,0,"SEGBRK",null,null,null,false],[0,0,0,"_MOUNT",null,null,null,false],[0,0,0,"OPEN",null,null,null,false],[0,0,0,"_READ",null,null,null,false],[0,0,0,"OSEEK",null,null,null,false],[0,0,0,"SLEEP",null,null,null,false],[0,0,0,"_STAT",null,null,null,false],[0,0,0,"RFORK",null,null,null,false],[0,0,0,"_WRITE",null,null,null,false],[0,0,0,"PIPE",null,null,null,false],[0,0,0,"CREATE",null,null,null,false],[0,0,0,"FD2PATH",null,null,null,false],[0,0,0,"BRK_",null,null,null,false],[0,0,0,"REMOVE",null,null,null,false],[0,0,0,"_WSTAT",null,null,null,false],[0,0,0,"_FWSTAT",null,null,null,false],[0,0,0,"NOTIFY",null,null,null,false],[0,0,0,"NOTED",null,null,null,false],[0,0,0,"SEGATTACH",null,null,null,false],[0,0,0,"SEGDETACH",null,null,null,false],[0,0,0,"SEGFREE",null,null,null,false],[0,0,0,"SEGFLUSH",null,null,null,false],[0,0,0,"RENDEZVOUS",null,null,null,false],[0,0,0,"UNMOUNT",null,null,null,false],[0,0,0,"_WAIT",null,null,null,false],[0,0,0,"SEMACQUIRE",null,null,null,false],[0,0,0,"SEMRELEASE",null,null,null,false],[0,0,0,"SEEK",null,null,null,false],[0,0,0,"FVERSION",null,null,null,false],[0,0,0,"ERRSTR",null,null,null,false],[0,0,0,"STAT",null,null,null,false],[0,0,0,"FSTAT",null,null,null,false],[0,0,0,"WSTAT",null,null,null,false],[0,0,0,"FWSTAT",null,null,null,false],[0,0,0,"MOUNT",null,null,null,false],[0,0,0,"AWAIT",null,null,null,false],[0,0,0,"PREAD",null,null,null,false],[0,0,0,"PWRITE",null,null,null,false],[0,0,0,"TSEMACQUIRE",null,null,null,false],[0,0,0,"_NSEC",null,null,null,false],[363,181,0,null,null,null,[43850,43851,43852],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[363,184,0,null,null,null,[43854,43855,43856,43857],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[363,188,0,null,null,null,[43859,43860,43861],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[363,191,0,null,null,null,[43863,43864,43865,43866],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"count",null,"",null,false],[0,0,0,"offset",null,"",null,false],[363,195,0,null,null,null,[43868,43869],false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[363,199,0,null,null,null,[43871,43872,43873,43874],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"",null,"",null,false],[363,217,0,null,null,null,[43876,43877,43878],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"nbuf",null,"",null,false],[363,221,0,null,null,null,[43880,43881,43882],false],[0,0,0,"path",null,"",null,false],[0,0,0,"omode",null,"",null,false],[0,0,0,"perms",null,"",null,false],[363,225,0,null,null,null,[43884],false],[0,0,0,"status",null,"",null,false],[363,235,0,null,null,null,[43886],false],[0,0,0,"status",null,"",null,false],[363,240,0,null,null,null,[43888],false],[0,0,0,"fd",null,"",null,false],[363,243,0,null,null,null,null,false],[363,244,0,null,null,null,[],false],[363,245,0,null,null,null,null,false],[363,246,0,null,null,null,null,false],[363,247,0,null,null,null,null,false],[363,248,0,null,null,null,null,false],[363,249,0,null,null,null,null,false],[363,250,0,null,null,null,null,false],[363,251,0,null,null,null,null,false],[363,252,0,null,null,null,null,false],[363,253,0,null,null,null,null,false],[363,254,0,null,null,null,null,false],[363,257,0,null,null,null,[],false],[363,258,0,null,null,null,null,false],[363,259,0,null,null,null,null,false],[363,260,0,null,null,null,null,false],[363,268,0,null,null," Brk sets the system's idea of the lowest bss location not\n used by the program (called the break) to addr rounded up to\n the next multiple of 8 bytes.  Locations not less than addr\n and below the stack pointer may cause a memory violation if\n accessed. -9front brk(2)",[43906],false],[0,0,0,"addr",null,"",null,false],[363,271,0,null,null,null,null,false],[363,272,0,null,null,null,null,false],[363,274,0,null,null,null,[43910],false],[0,0,0,"n",null,"",null,false],[350,37,0,null,null,null,null,false],[0,0,0,"os/uefi.zig",null,"",[],false],[365,0,0,null,null,null,null,false],[365,3,0,null,null," A protocol is an interface identified by a GUID.",null,false],[0,0,0,"uefi/protocol.zig",null,"",[],false],[366,0,0,null,null,null,null,false],[0,0,0,"protocol/loaded_image.zig",null,"",[],false],[367,0,0,null,null,null,null,false],[367,1,0,null,null,null,null,false],[367,2,0,null,null,null,null,false],[367,3,0,null,null,null,null,false],[367,4,0,null,null,null,null,false],[367,5,0,null,null,null,null,false],[367,6,0,null,null,null,null,false],[367,7,0,null,null,null,null,false],[367,8,0,null,null,null,null,false],[367,10,0,null,null,null,[43933,43935,43937,43939,43941,43943,43944,43946,43948,43949,43951,43953,43957],false],[367,26,0,null,null," Unloads an image from memory.",[43929,43930],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[367,30,0,null,null,null,null,false],[367,39,0,null,null,null,null,false],[0,0,0,"revision",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"parent_handle",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"system_table",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"device_handle",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"file_path",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"load_options_size",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"load_options",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"image_base",null,null,null,false],[0,0,0,"image_size",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"image_code_type",null,null,null,false],[367,10,0,null,null,null,null,false],[0,0,0,"image_data_type",null,null,null,false],[367,10,0,null,null,null,[43955,43956],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_unload",null,null,null,false],[366,1,0,null,null,null,null,false],[0,0,0,"protocol/device_path.zig",null,"",[],false],[368,0,0,null,null,null,null,false],[368,1,0,null,null,null,null,false],[368,2,0,null,null,null,null,false],[368,3,0,null,null,null,null,false],[368,4,0,null,null,null,null,false],[368,5,0,null,null,null,null,false],[368,10,0,null,null,null,[43982,43983,43984],false],[368,15,0,null,null,null,null,false],[368,25,0,null,null," Returns the next DevicePath node in the sequence, if any.",[43969],false],[0,0,0,"self",null,"",null,false],[368,33,0,null,null," Calculates the total length of the device path structure in bytes, including the end of device path node.",[43971],false],[0,0,0,"self",null,"",null,false],[368,44,0,null,null," Creates a file device path from the existing device path and a file path.",[43973,43974,43975],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"path",null,"",null,false],[368,77,0,null,null,null,[43977],false],[0,0,0,"self",null,"",null,false],[368,96,0,null,null,null,[43979,43980],false],[0,0,0,"self",null,"",null,false],[0,0,0,"TUnion",null,"",null,true],[368,10,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[366,2,0,null,null,null,null,false],[0,0,0,"protocol/rng.zig",null,"",[],false],[369,0,0,null,null,null,null,false],[369,1,0,null,null,null,null,false],[369,2,0,null,null,null,null,false],[369,3,0,null,null,null,null,false],[369,4,0,null,null,null,null,false],[369,7,0,null,null," Random Number Generator protocol",[44013,44019],false],[369,12,0,null,null," Returns information about the random number generation implementation.",[43994,43995,43996],false],[0,0,0,"self",null,"",null,false],[0,0,0,"list_size",null,"",null,false],[0,0,0,"list",null,"",null,false],[369,17,0,null,null," Produces and returns an RNG value using either the default or specified RNG algorithm.",[43998,43999,44000,44001],false],[0,0,0,"self",null,"",null,false],[0,0,0,"algo",null,"",null,false],[0,0,0,"value_length",null,"",null,false],[0,0,0,"value",null,"",null,false],[369,21,0,null,null,null,null,false],[369,29,0,null,null,null,null,false],[369,37,0,null,null,null,null,false],[369,45,0,null,null,null,null,false],[369,53,0,null,null,null,null,false],[369,61,0,null,null,null,null,false],[369,69,0,null,null,null,null,false],[369,7,0,null,null,null,[44010,44011,44012],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_info",null,null,null,false],[369,7,0,null,null,null,[44015,44016,44017,44018],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_rng",null,null,null,false],[366,3,0,null,null,null,null,false],[0,0,0,"protocol/shell_parameters.zig",null,"",[],false],[370,0,0,null,null,null,null,false],[370,1,0,null,null,null,null,false],[370,2,0,null,null,null,null,false],[370,4,0,null,null,null,[44028,44029,44031,44033,44035],false],[370,11,0,null,null,null,null,false],[370,4,0,null,null,null,null,false],[0,0,0,"argv",null,null,null,false],[0,0,0,"argc",null,null,null,false],[370,4,0,null,null,null,null,false],[0,0,0,"stdin",null,null,null,false],[370,4,0,null,null,null,null,false],[0,0,0,"stdout",null,null,null,false],[370,4,0,null,null,null,null,false],[0,0,0,"stderr",null,null,null,false],[366,5,0,null,null,null,null,false],[0,0,0,"protocol/simple_file_system.zig",null,"",[],false],[371,0,0,null,null,null,null,false],[371,1,0,null,null,null,null,false],[371,2,0,null,null,null,null,false],[371,3,0,null,null,null,null,false],[371,4,0,null,null,null,null,false],[371,5,0,null,null,null,null,false],[371,7,0,null,null,null,[44049,44053],false],[371,11,0,null,null,null,[44046,44047],false],[0,0,0,"self",null,"",null,false],[0,0,0,"root",null,"",null,false],[371,15,0,null,null,null,null,false],[0,0,0,"revision",null,null,null,false],[371,7,0,null,null,null,[44051,44052],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_open_volume",null,null,null,false],[366,6,0,null,null,null,null,false],[0,0,0,"protocol/file.zig",null,"",[],false],[372,0,0,null,null,null,null,false],[372,1,0,null,null,null,null,false],[372,2,0,null,null,null,null,false],[372,3,0,null,null,null,null,false],[372,4,0,null,null,null,null,false],[372,5,0,null,null,null,null,false],[372,6,0,null,null,null,null,false],[372,8,0,null,null,null,[44140,44147,44150,44153,44158,44163,44167,44171,44177,44183,44186],false],[372,21,0,null,null,null,null,false],[372,22,0,null,null,null,null,false],[372,23,0,null,null,null,null,false],[372,24,0,null,null,null,null,false],[372,26,0,null,null,null,null,false],[372,27,0,null,null,null,null,false],[372,28,0,null,null,null,null,false],[372,30,0,null,null,null,[44072],false],[0,0,0,"self",null,"",null,false],[372,34,0,null,null,null,[44074],false],[0,0,0,"self",null,"",null,false],[372,38,0,null,null,null,[44076],false],[0,0,0,"self",null,"",null,false],[372,42,0,null,null,null,[44078,44079,44080,44081,44082],false],[0,0,0,"self",null,"",null,false],[0,0,0,"new_handle",null,"",null,false],[0,0,0,"file_name",null,"",null,false],[0,0,0,"open_mode",null,"",null,false],[0,0,0,"attributes",null,"",null,false],[372,46,0,null,null,null,[44084],false],[0,0,0,"self",null,"",null,false],[372,50,0,null,null,null,[44086],false],[0,0,0,"self",null,"",null,false],[372,54,0,null,null,null,[44088,44089,44090],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[372,58,0,null,null,null,[44092,44093],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[372,64,0,null,null,null,[44095,44096,44097],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[372,68,0,null,null,null,[44099,44100],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[372,74,0,null,null,null,[44102,44103],false],[0,0,0,"self",null,"",null,false],[0,0,0,"position",null,"",null,false],[372,78,0,null,null,null,[44105],false],[0,0,0,"self",null,"",null,false],[372,84,0,null,null,null,[44107],false],[0,0,0,"self",null,"",null,false],[372,96,0,null,null,null,[44109,44110],false],[0,0,0,"self",null,"",null,false],[0,0,0,"position",null,"",null,false],[372,100,0,null,null,null,[44112,44113],false],[0,0,0,"self",null,"",null,false],[0,0,0,"pos",null,"",null,false],[372,104,0,null,null,null,[44115,44116],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,"",null,false],[372,118,0,null,null,null,[44118,44119,44120,44121],false],[0,0,0,"self",null,"",null,false],[0,0,0,"information_type",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[372,122,0,null,null,null,[44123,44124,44125,44126],false],[0,0,0,"self",null,"",null,false],[0,0,0,"information_type",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[372,126,0,null,null,null,[44128],false],[0,0,0,"self",null,"",null,false],[372,130,0,null,null,null,null,false],[372,131,0,null,null,null,null,false],[372,132,0,null,null,null,null,false],[372,134,0,null,null,null,null,false],[372,135,0,null,null,null,null,false],[372,136,0,null,null,null,null,false],[372,137,0,null,null,null,null,false],[372,138,0,null,null,null,null,false],[372,139,0,null,null,null,null,false],[372,140,0,null,null,null,null,false],[372,142,0,null,null,null,null,false],[0,0,0,"revision",null,null,null,false],[372,8,0,null,null,null,[44142,44143,44144,44145,44146],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_open",null,null,null,false],[372,8,0,null,null,null,[44149],false],[0,0,0,"",null,"",null,false],[0,0,0,"_close",null,null,null,false],[372,8,0,null,null,null,[44152],false],[0,0,0,"",null,"",null,false],[0,0,0,"_delete",null,null,null,false],[372,8,0,null,null,null,[44155,44156,44157],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_read",null,null,null,false],[372,8,0,null,null,null,[44160,44161,44162],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_write",null,null,null,false],[372,8,0,null,null,null,[44165,44166],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_position",null,null,null,false],[372,8,0,null,null,null,[44169,44170],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_position",null,null,null,false],[372,8,0,null,null,null,[44173,44174,44175,44176],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_info",null,null,null,false],[372,8,0,null,null,null,[44179,44180,44181,44182],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_info",null,null,null,false],[372,8,0,null,null,null,[44185],false],[0,0,0,"",null,"",null,false],[0,0,0,"_flush",null,null,null,false],[366,7,0,null,null,null,null,false],[0,0,0,"protocol/block_io.zig",null,"",[],false],[373,0,0,null,null,null,null,false],[373,1,0,null,null,null,null,false],[373,2,0,null,null,null,null,false],[373,3,0,null,null,null,null,false],[373,5,0,null,null,null,[44226,44228,44232,44239,44246,44249],false],[373,6,0,null,null,null,null,false],[373,17,0,null,null," Resets the block device hardware.",[44196,44197],false],[0,0,0,"self",null,"",null,false],[0,0,0,"extended_verification",null,"",null,false],[373,22,0,null,null," Reads the number of requested blocks from the device.",[44199,44200,44201,44202,44203],false],[0,0,0,"self",null,"",null,false],[0,0,0,"media_id",null,"",null,false],[0,0,0,"lba",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buf",null,"",null,false],[373,27,0,null,null," Writes a specified number of blocks to the device.",[44205,44206,44207,44208,44209],false],[0,0,0,"self",null,"",null,false],[0,0,0,"media_id",null,"",null,false],[0,0,0,"lba",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buf",null,"",null,false],[373,32,0,null,null," Flushes all modified data to a physical block device.",[44211],false],[0,0,0,"self",null,"",null,false],[373,36,0,null,null,null,null,false],[373,45,0,null,null,null,[44214,44215,44216,44217,44218,44219,44220,44221,44222,44223,44224,44225],false],[0,0,0,"media_id",null," The current media ID. If the media changes, this value is changed.",null,false],[0,0,0,"removable_media",null," `true` if the media is removable; otherwise, `false`.",null,false],[0,0,0,"media_present",null," `true` if there is a media currently present in the device",null,false],[0,0,0,"logical_partition",null," `true` if the `BlockIo` was produced to abstract\n partition structures on the disk. `false` if the `BlockIo` was\n produced to abstract the logical blocks on a hardware device.",null,false],[0,0,0,"read_only",null," `true` if the media is marked read-only otherwise, `false`. This field\n shows the read-only status as of the most recent `WriteBlocks()`",null,false],[0,0,0,"write_caching",null," `true` if the WriteBlocks() function caches write data.",null,false],[0,0,0,"block_size",null," The intrinsic block size of the device. If the media changes, then this",null,false],[0,0,0,"io_align",null," Supplies the alignment requirement for any buffer used in a data\n transfer. IoAlign values of 0 and 1 mean that the buffer can be\n placed anywhere in memory. Otherwise, IoAlign must be a power of\n 2, and the requirement is that the start address of a buffer must be\n evenly divisible by IoAlign with no remainder.",null,false],[0,0,0,"last_block",null," The last LBA on the device. If the media changes, then this field is updated.",null,false],[0,0,0,"lowest_aligned_lba",null,null,null,false],[0,0,0,"logical_blocks_per_physical_block",null,null,null,false],[0,0,0,"optimal_transfer_length_granularity",null,null,null,false],[0,0,0,"revision",null,null,null,false],[373,5,0,null,null,null,null,false],[0,0,0,"media",null,null,null,false],[373,5,0,null,null,null,[44230,44231],false],[0,0,0,"",null,"",null,false],[0,0,0,"extended_verification",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[373,5,0,null,null,null,[44234,44235,44236,44237,44238],false],[0,0,0,"",null,"",null,false],[0,0,0,"media_id",null,"",null,false],[0,0,0,"lba",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"_read_blocks",null,null,null,false],[373,5,0,null,null,null,[44241,44242,44243,44244,44245],false],[0,0,0,"",null,"",null,false],[0,0,0,"media_id",null,"",null,false],[0,0,0,"lba",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"_write_blocks",null,null,null,false],[373,5,0,null,null,null,[44248],false],[0,0,0,"",null,"",null,false],[0,0,0,"_flush_blocks",null,null,null,false],[366,9,0,null,null,null,null,false],[0,0,0,"protocol/simple_text_input.zig",null,"",[],false],[374,0,0,null,null,null,null,false],[374,1,0,null,null,null,null,false],[374,2,0,null,null,null,null,false],[374,3,0,null,null,null,null,false],[374,4,0,null,null,null,null,false],[374,5,0,null,null,null,null,false],[374,8,0,null,null," Character input devices, e.g. Keyboard",[44270,44274,44276],false],[374,14,0,null,null," Resets the input device hardware.",[44260,44261],false],[0,0,0,"self",null,"",null,false],[0,0,0,"verify",null,"",null,false],[374,19,0,null,null," Reads the next keystroke from the input device.",[44263,44264],false],[0,0,0,"self",null,"",null,false],[0,0,0,"input_key",null,"",null,false],[374,23,0,null,null,null,null,false],[374,32,0,null,null,null,null,false],[374,8,0,null,null,null,[44268,44269],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[374,8,0,null,null,null,[44272,44273],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_read_key_stroke",null,null,null,false],[374,8,0,null,null,null,null,false],[0,0,0,"wait_for_key",null,null,null,false],[366,10,0,null,null,null,null,false],[0,0,0,"protocol/simple_text_input_ex.zig",null,"",[],false],[375,0,0,null,null,null,null,false],[375,1,0,null,null,null,null,false],[375,2,0,null,null,null,null,false],[375,3,0,null,null,null,null,false],[375,4,0,null,null,null,null,false],[375,5,0,null,null,null,null,false],[375,8,0,null,null," Character input devices, e.g. Keyboard",[44343,44347,44349,44353,44360,44364],false],[375,17,0,null,null," Resets the input device hardware.",[44287,44288],false],[0,0,0,"self",null,"",null,false],[0,0,0,"verify",null,"",null,false],[375,22,0,null,null," Reads the next keystroke from the input device.",[44290,44291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key_data",null,"",null,false],[375,27,0,null,null," Set certain state for the input device.",[44293,44294],false],[0,0,0,"self",null,"",null,false],[0,0,0,"state",null,"",null,false],[375,32,0,null,null," Register a notification function for a particular keystroke for the input device.",[44296,44297,44298,44300],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key_data",null,"",null,false],[0,0,0,"notify",null,"",[44299],false],[0,0,0,"",null,"",null,false],[0,0,0,"handle",null,"",null,false],[375,37,0,null,null," Remove the notification that was previously registered.",[44302,44303],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[375,41,0,null,null,null,null,false],[375,50,0,null,null,null,[44337,44339],false],[375,54,0,null,null,null,[44330,44332],false],[375,58,0,null,null,null,[44308,44309,44310,44311,44312,44313,44314,44315,44316,44317,44319,44320],false],[0,0,0,"right_shift_pressed",null,null,null,false],[0,0,0,"left_shift_pressed",null,null,null,false],[0,0,0,"right_control_pressed",null,null,null,false],[0,0,0,"left_control_pressed",null,null,null,false],[0,0,0,"right_alt_pressed",null,null,null,false],[0,0,0,"left_alt_pressed",null,null,null,false],[0,0,0,"right_logo_pressed",null,null,null,false],[0,0,0,"left_logo_pressed",null,null,null,false],[0,0,0,"menu_key_pressed",null,null,null,false],[0,0,0,"sys_req_pressed",null,null,null,false],[375,58,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[0,0,0,"shift_state_valid",null,null,null,false],[375,73,0,null,null,null,[44322,44323,44324,44326,44327,44328],false],[0,0,0,"scroll_lock_active",null,null,null,false],[0,0,0,"num_lock_active",null,null,null,false],[0,0,0,"caps_lock_active",null,null,null,false],[375,73,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[0,0,0,"key_state_exposed",null,null,null,false],[0,0,0,"toggle_state_valid",null,null,null,false],[375,54,0,null,null,null,null,false],[0,0,0,"shift",null,null,null,false],[375,54,0,null,null,null,null,false],[0,0,0,"toggle",null,null,null,false],[375,83,0,null,null,null,[44334,44335],false],[0,0,0,"scan_code",null,null,null,false],[0,0,0,"unicode_char",null,null,null,false],[375,50,0,null,null,null,null,false],[0,0,0,"input",null,null,null,false],[375,50,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[375,8,0,null,null,null,[44341,44342],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[375,8,0,null,null,null,[44345,44346],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_read_key_stroke_ex",null,null,null,false],[375,8,0,null,null,null,null,false],[0,0,0,"wait_for_key_ex",null,null,null,false],[375,8,0,null,null,null,[44351,44352],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_state",null,null,null,false],[375,8,0,null,null,null,[44355,44356,44357,44359],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",[44358],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_register_key_notify",null,null,null,false],[375,8,0,null,null,null,[44362,44363],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_unregister_key_notify",null,null,null,false],[366,11,0,null,null,null,null,false],[0,0,0,"protocol/simple_text_output.zig",null,"",[],false],[376,0,0,null,null,null,null,false],[376,1,0,null,null,null,null,false],[376,2,0,null,null,null,null,false],[376,3,0,null,null,null,null,false],[376,4,0,null,null,null,null,false],[376,7,0,null,null," Character output devices",[44486,44490,44494,44500,44504,44508,44511,44516,44520,44522],false],[376,20,0,null,null," Resets the text output device hardware.",[44374,44375],false],[0,0,0,"self",null,"",null,false],[0,0,0,"verify",null,"",null,false],[376,25,0,null,null," Writes a string to the output device.",[44377,44378],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[376,30,0,null,null," Verifies that all characters in a string can be output to the target device.",[44380,44381],false],[0,0,0,"self",null,"",null,false],[0,0,0,"msg",null,"",null,false],[376,35,0,null,null," Returns information for an available text mode that the output device(s) supports.",[44383,44384,44385,44386],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mode_number",null,"",null,false],[0,0,0,"columns",null,"",null,false],[0,0,0,"rows",null,"",null,false],[376,40,0,null,null," Sets the output device(s) to a specified mode.",[44388,44389],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mode_number",null,"",null,false],[376,45,0,null,null," Sets the background and foreground colors for the outputString() and clearScreen() functions.",[44391,44392],false],[0,0,0,"self",null,"",null,false],[0,0,0,"attribute",null,"",null,false],[376,50,0,null,null," Clears the output device(s) display to the currently selected background color.",[44394],false],[0,0,0,"self",null,"",null,false],[376,55,0,null,null," Sets the current coordinates of the cursor position.",[44396,44397,44398],false],[0,0,0,"self",null,"",null,false],[0,0,0,"column",null,"",null,false],[0,0,0,"row",null,"",null,false],[376,60,0,null,null," Makes the cursor visible or invisible.",[44400,44401],false],[0,0,0,"self",null,"",null,false],[0,0,0,"visible",null,"",null,false],[376,64,0,null,null,null,null,false],[376,72,0,null,null,null,null,false],[376,73,0,null,null,null,null,false],[376,74,0,null,null,null,null,false],[376,75,0,null,null,null,null,false],[376,76,0,null,null,null,null,false],[376,77,0,null,null,null,null,false],[376,78,0,null,null,null,null,false],[376,79,0,null,null,null,null,false],[376,80,0,null,null,null,null,false],[376,81,0,null,null,null,null,false],[376,82,0,null,null,null,null,false],[376,83,0,null,null,null,null,false],[376,84,0,null,null,null,null,false],[376,85,0,null,null,null,null,false],[376,86,0,null,null,null,null,false],[376,87,0,null,null,null,null,false],[376,88,0,null,null,null,null,false],[376,89,0,null,null,null,null,false],[376,90,0,null,null,null,null,false],[376,91,0,null,null,null,null,false],[376,92,0,null,null,null,null,false],[376,93,0,null,null,null,null,false],[376,94,0,null,null,null,null,false],[376,95,0,null,null,null,null,false],[376,96,0,null,null,null,null,false],[376,97,0,null,null,null,null,false],[376,98,0,null,null,null,null,false],[376,99,0,null,null,null,null,false],[376,100,0,null,null,null,null,false],[376,101,0,null,null,null,null,false],[376,102,0,null,null,null,null,false],[376,103,0,null,null,null,null,false],[376,104,0,null,null,null,null,false],[376,105,0,null,null,null,null,false],[376,106,0,null,null,null,null,false],[376,107,0,null,null,null,null,false],[376,108,0,null,null,null,null,false],[376,109,0,null,null,null,null,false],[376,110,0,null,null,null,null,false],[376,111,0,null,null,null,null,false],[376,112,0,null,null,null,null,false],[376,113,0,null,null,null,null,false],[376,114,0,null,null,null,null,false],[376,115,0,null,null,null,null,false],[376,116,0,null,null,null,null,false],[376,117,0,null,null,null,null,false],[376,118,0,null,null,null,null,false],[376,119,0,null,null,null,null,false],[376,120,0,null,null,null,null,false],[376,121,0,null,null,null,null,false],[376,122,0,null,null,null,null,false],[376,123,0,null,null,null,null,false],[376,124,0,null,null,null,null,false],[376,125,0,null,null,null,null,false],[376,126,0,null,null,null,null,false],[376,127,0,null,null,null,null,false],[376,128,0,null,null,null,null,false],[376,129,0,null,null,null,null,false],[376,130,0,null,null,null,null,false],[376,131,0,null,null,null,null,false],[376,132,0,null,null,null,null,false],[376,133,0,null,null,null,null,false],[376,134,0,null,null,null,null,false],[376,135,0,null,null,null,null,false],[376,136,0,null,null,null,null,false],[376,137,0,null,null,null,null,false],[376,138,0,null,null,null,null,false],[376,139,0,null,null,null,null,false],[376,140,0,null,null,null,null,false],[376,141,0,null,null,null,null,false],[376,142,0,null,null,null,null,false],[376,143,0,null,null,null,null,false],[376,144,0,null,null,null,null,false],[376,146,0,null,null,null,[44477,44478,44479,44480,44481,44482],false],[0,0,0,"max_mode",null,null,null,false],[0,0,0,"mode",null,null,null,false],[0,0,0,"attribute",null,null,null,false],[0,0,0,"cursor_column",null,null,null,false],[0,0,0,"cursor_row",null,null,null,false],[0,0,0,"cursor_visible",null,null,null,false],[376,7,0,null,null,null,[44484,44485],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[376,7,0,null,null,null,[44488,44489],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_output_string",null,null,null,false],[376,7,0,null,null,null,[44492,44493],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_test_string",null,null,null,false],[376,7,0,null,null,null,[44496,44497,44498,44499],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_query_mode",null,null,null,false],[376,7,0,null,null,null,[44502,44503],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_mode",null,null,null,false],[376,7,0,null,null,null,[44506,44507],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_attribute",null,null,null,false],[376,7,0,null,null,null,[44510],false],[0,0,0,"",null,"",null,false],[0,0,0,"_clear_screen",null,null,null,false],[376,7,0,null,null,null,[44513,44514,44515],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_cursor_position",null,null,null,false],[376,7,0,null,null,null,[44518,44519],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_enable_cursor",null,null,null,false],[376,7,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[366,13,0,null,null,null,null,false],[0,0,0,"protocol/simple_pointer.zig",null,"",[],false],[377,0,0,null,null,null,null,false],[377,1,0,null,null,null,null,false],[377,2,0,null,null,null,null,false],[377,3,0,null,null,null,null,false],[377,4,0,null,null,null,null,false],[377,5,0,null,null,null,null,false],[377,8,0,null,null," Protocol for mice.",[44554,44558,44560,44562],false],[377,15,0,null,null," Resets the pointer device hardware.",[44533,44534],false],[0,0,0,"self",null,"",null,false],[0,0,0,"verify",null,"",null,false],[377,20,0,null,null," Retrieves the current state of a pointer device.",[44536,44537],false],[0,0,0,"self",null,"",null,false],[0,0,0,"state",null,"",null,false],[377,24,0,null,null,null,null,false],[377,33,0,null,null,null,[44540,44541,44542,44543,44544],false],[0,0,0,"resolution_x",null,null,null,false],[0,0,0,"resolution_y",null,null,null,false],[0,0,0,"resolution_z",null,null,null,false],[0,0,0,"left_button",null,null,null,false],[0,0,0,"right_button",null,null,null,false],[377,41,0,null,null,null,[44546,44547,44548,44549,44550],false],[0,0,0,"relative_movement_x",null,null,null,false],[0,0,0,"relative_movement_y",null,null,null,false],[0,0,0,"relative_movement_z",null,null,null,false],[0,0,0,"left_button",null,null,null,false],[0,0,0,"right_button",null,null,null,false],[377,8,0,null,null,null,[44552,44553],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[377,8,0,null,null,null,[44556,44557],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_state",null,null,null,false],[377,8,0,null,null,null,null,false],[0,0,0,"wait_for_input",null,null,null,false],[377,8,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[366,14,0,null,null,null,null,false],[0,0,0,"protocol/absolute_pointer.zig",null,"",[],false],[378,0,0,null,null,null,null,false],[378,1,0,null,null,null,null,false],[378,2,0,null,null,null,null,false],[378,3,0,null,null,null,null,false],[378,4,0,null,null,null,null,false],[378,5,0,null,null,null,null,false],[378,8,0,null,null," Protocol for touchscreens.",[44607,44611,44613,44615],false],[378,15,0,null,null," Resets the pointer device hardware.",[44573,44574],false],[0,0,0,"self",null,"",null,false],[0,0,0,"verify",null,"",null,false],[378,20,0,null,null," Retrieves the current state of a pointer device.",[44576,44577],false],[0,0,0,"self",null,"",null,false],[0,0,0,"state",null,"",null,false],[378,24,0,null,null,null,null,false],[378,33,0,null,null,null,[44585,44586,44587,44588,44589,44590,44592],false],[378,42,0,null,null,null,[44581,44582,44584],false],[0,0,0,"supports_alt_active",null,null,null,false],[0,0,0,"supports_pressure_as_z",null,null,null,false],[378,42,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[0,0,0,"absolute_min_x",null,null,null,false],[0,0,0,"absolute_min_y",null,null,null,false],[0,0,0,"absolute_min_z",null,null,null,false],[0,0,0,"absolute_max_x",null,null,null,false],[0,0,0,"absolute_max_y",null,null,null,false],[0,0,0,"absolute_max_z",null,null,null,false],[378,33,0,null,null,null,null,false],[0,0,0,"attributes",null,null,null,false],[378,49,0,null,null,null,[44599,44600,44601,44603],false],[378,55,0,null,null,null,[44595,44596,44598],false],[0,0,0,"touch_active",null,null,null,false],[0,0,0,"alt_active",null,null,null,false],[378,55,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[0,0,0,"current_x",null,null,null,false],[0,0,0,"current_y",null,null,null,false],[0,0,0,"current_z",null,null,null,false],[378,49,0,null,null,null,null,false],[0,0,0,"active_buttons",null,null,null,false],[378,8,0,null,null,null,[44605,44606],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[378,8,0,null,null,null,[44609,44610],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_state",null,null,null,false],[378,8,0,null,null,null,null,false],[0,0,0,"wait_for_input",null,null,null,false],[378,8,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[366,16,0,null,null,null,null,false],[0,0,0,"protocol/graphics_output.zig",null,"",[],false],[379,0,0,null,null,null,null,false],[379,1,0,null,null,null,null,false],[379,2,0,null,null,null,null,false],[379,3,0,null,null,null,null,false],[379,4,0,null,null,null,null,false],[379,6,0,null,null,null,[44687,44691,44703,44705],false],[379,13,0,null,null," Returns information for an available graphics mode that the graphics device and the set of active video output devices supports.",[44625,44626,44627,44628],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"size_of_info",null,"",null,false],[0,0,0,"info",null,"",null,false],[379,18,0,null,null," Set the video device into the specified mode and clears the visible portions of the output display to black.",[44630,44631],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mode",null,"",null,false],[379,23,0,null,null," Blt a rectangle of pixels on the graphics screen. Blt stands for BLock Transfer.",[44633,44634,44635,44636,44637,44638,44639,44640,44641,44642],false],[0,0,0,"self",null,"",null,false],[0,0,0,"blt_buffer",null,"",null,false],[0,0,0,"blt_operation",null,"",null,false],[0,0,0,"source_x",null,"",null,false],[0,0,0,"source_y",null,"",null,false],[0,0,0,"destination_x",null,"",null,false],[0,0,0,"destination_y",null,"",null,false],[0,0,0,"width",null,"",null,false],[0,0,0,"height",null,"",null,false],[0,0,0,"delta",null,"",null,false],[379,27,0,null,null,null,null,false],[379,36,0,null,null,null,[44654,44655,44657,44658,44659,44660],false],[379,44,0,null,null,null,[44646,44647,44648,44650,44652,44653],false],[0,0,0,"version",null,null,null,false],[0,0,0,"horizontal_resolution",null,null,null,false],[0,0,0,"vertical_resolution",null,null,null,false],[379,44,0,null,null,null,null,false],[0,0,0,"pixel_format",null,null,null,false],[379,44,0,null,null,null,null,false],[0,0,0,"pixel_information",null,null,null,false],[0,0,0,"pixels_per_scan_line",null,null,null,false],[0,0,0,"max_mode",null,null,null,false],[0,0,0,"mode",null,null,null,false],[379,36,0,null,null,null,null,false],[0,0,0,"info",null,null,null,false],[0,0,0,"size_of_info",null,null,null,false],[0,0,0,"frame_buffer_base",null,null,null,false],[0,0,0,"frame_buffer_size",null,null,null,false],[379,54,0,null,null,null,[44662,44663,44664,44665],false],[0,0,0,"RedGreenBlueReserved8BitPerColor",null,null,null,false],[0,0,0,"BlueGreenRedReserved8BitPerColor",null,null,null,false],[0,0,0,"BitMask",null,null,null,false],[0,0,0,"BltOnly",null,null,null,false],[379,61,0,null,null,null,[44667,44668,44669,44670],false],[0,0,0,"red_mask",null,null,null,false],[0,0,0,"green_mask",null,null,null,false],[0,0,0,"blue_mask",null,null,null,false],[0,0,0,"reserved_mask",null,null,null,false],[379,68,0,null,null,null,[44672,44673,44674,44675],false],[0,0,0,"blue",null,null,null,false],[0,0,0,"green",null,null,null,false],[0,0,0,"red",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[379,75,0,null,null,null,[44677,44678,44679,44680,44681],false],[0,0,0,"BltVideoFill",null,null,null,false],[0,0,0,"BltVideoToBltBuffer",null,null,null,false],[0,0,0,"BltBufferToVideo",null,null,null,false],[0,0,0,"BltVideoToVideo",null,null,null,false],[0,0,0,"GraphicsOutputBltOperationMax",null,null,null,false],[379,6,0,null,null,null,[44683,44684,44685,44686],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_query_mode",null,null,null,false],[379,6,0,null,null,null,[44689,44690],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_mode",null,null,null,false],[379,6,0,null,null,null,[44693,44694,44695,44696,44697,44698,44699,44700,44701,44702],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_blt",null,null,null,false],[379,6,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[366,18,0,null,null,null,null,false],[0,0,0,"protocol/edid.zig",null,"",[],false],[380,0,0,null,null,null,null,false],[380,1,0,null,null,null,null,false],[380,2,0,null,null,null,null,false],[380,3,0,null,null,null,null,false],[380,4,0,null,null,null,null,false],[380,5,0,null,null,null,null,false],[380,8,0,null,null," EDID information for an active video output device",[44716,44718],false],[380,12,0,null,null,null,null,false],[0,0,0,"size_of_edid",null,null,null,false],[380,8,0,null,null,null,null,false],[0,0,0,"edid",null,null,null,false],[380,23,0,null,null," EDID information for a video output device",[44721,44723],false],[380,27,0,null,null,null,null,false],[0,0,0,"size_of_edid",null,null,null,false],[380,23,0,null,null,null,null,false],[0,0,0,"edid",null,null,null,false],[380,38,0,null,null," Override EDID information",[44743],false],[380,42,0,null,null," Returns policy information and potentially a replacement EDID for the specified video output device.",[44726,44727,44728,44729,44730],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"edid_size",null,"",null,false],[0,0,0,"edid",null,"",null,false],[380,52,0,null,null,null,null,false],[380,61,0,null,null,null,[44733,44734,44736],false],[0,0,0,"dont_override",null,null,null,false],[0,0,0,"enable_hot_plug",null,null,null,false],[380,61,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[380,38,0,null,null,null,[44738,44739,44740,44741,44742],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_edid",null,null,null,false],[366,20,0,null,null,null,null,false],[0,0,0,"protocol/simple_network.zig",null,"",[],false],[381,0,0,null,null,null,null,false],[381,1,0,null,null,null,null,false],[381,2,0,null,null,null,null,false],[381,3,0,null,null,null,null,false],[381,4,0,null,null,null,null,false],[381,5,0,null,null,null,null,false],[381,7,0,null,null,null,[44888,44891,44894,44899,44903,44906,44914,44919,44925,44931,44938,44943,44952,44961,44963,44965],false],[381,26,0,null,null," Changes the state of a network interface from \"stopped\" to \"started\".",[44754],false],[0,0,0,"self",null,"",null,false],[381,31,0,null,null," Changes the state of a network interface from \"started\" to \"stopped\".",[44756],false],[0,0,0,"self",null,"",null,false],[381,36,0,null,null," Resets a network adapter and allocates the transmit and receive buffers required by the network interface.",[44758,44759,44760],false],[0,0,0,"self",null,"",null,false],[0,0,0,"extra_rx_buffer_size",null,"",null,false],[0,0,0,"extra_tx_buffer_size",null,"",null,false],[381,41,0,null,null," Resets a network adapter and reinitializes it with the parameters that were provided in the previous call to initialize().",[44762,44763],false],[0,0,0,"self",null,"",null,false],[0,0,0,"extended_verification",null,"",null,false],[381,46,0,null,null," Resets a network adapter and leaves it in a state that is safe for another driver to initialize.",[44765],false],[0,0,0,"self",null,"",null,false],[381,51,0,null,null," Manages the multicast receive filters of a network interface.",[44767,44768,44769,44770,44771,44772],false],[0,0,0,"self",null,"",null,false],[0,0,0,"enable",null,"",null,false],[0,0,0,"disable",null,"",null,false],[0,0,0,"reset_mcast_filter",null,"",null,false],[0,0,0,"mcast_filter_cnt",null,"",null,false],[0,0,0,"mcast_filter",null,"",null,false],[381,56,0,null,null," Modifies or resets the current station address, if supported.",[44774,44775,44776],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reset_flag",null,"",null,false],[0,0,0,"new",null,"",null,false],[381,61,0,null,null," Resets or collects the statistics on a network interface.",[44778,44779,44780,44781],false],[0,0,0,"self",null,"",null,false],[0,0,0,"reset_flag",null,"",null,false],[0,0,0,"statistics_size",null,"",null,false],[0,0,0,"statistics_table",null,"",null,false],[381,66,0,null,null," Converts a multicast IP address to a multicast HW MAC address.",[44783,44784,44785,44786],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ipv6",null,"",null,false],[0,0,0,"ip",null,"",null,false],[0,0,0,"mac",null,"",null,false],[381,71,0,null,null," Performs read and write operations on the NVRAM device attached to a network interface.",[44788,44789,44790,44791,44792],false],[0,0,0,"self",null,"",null,false],[0,0,0,"read_write",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[381,76,0,null,null," Reads the current interrupt status and recycled transmit buffer status from a network interface.",[44794,44795,44796],false],[0,0,0,"self",null,"",null,false],[0,0,0,"interrupt_status",null,"",null,false],[0,0,0,"tx_buf",null,"",null,false],[381,81,0,null,null," Places a packet in the transmit queue of a network interface.",[44798,44799,44800,44801,44802,44803,44804],false],[0,0,0,"self",null,"",null,false],[0,0,0,"header_size",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"src_addr",null,"",null,false],[0,0,0,"dest_addr",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[381,86,0,null,null," Receives a packet from a network interface.",[44806,44807,44808,44809,44810,44811,44812],false],[0,0,0,"self",null,"",null,false],[0,0,0,"header_size",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"src_addr",null,"",null,false],[0,0,0,"dest_addr",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[381,90,0,null,null,null,null,false],[381,99,0,null,null,null,null,false],[381,101,0,null,null,null,[44817,44818,44819,44820,44821,44822,44824,44826,44827,44828,44830,44832,44834,44836,44837,44838,44839,44840,44841],false],[381,101,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"hw_address_size",null,null,null,false],[0,0,0,"media_header_size",null,null,null,false],[0,0,0,"max_packet_size",null,null,null,false],[0,0,0,"nvram_size",null,null,null,false],[0,0,0,"nvram_access_size",null,null,null,false],[381,101,0,null,null,null,null,false],[0,0,0,"receive_filter_mask",null,null,null,false],[381,101,0,null,null,null,null,false],[0,0,0,"receive_filter_setting",null,null,null,false],[0,0,0,"max_mcast_filter_count",null,null,null,false],[0,0,0,"mcast_filter_count",null,null,null,false],[381,101,0,null,null,null,null,false],[0,0,0,"mcast_filter",null,null,null,false],[381,101,0,null,null,null,null,false],[0,0,0,"current_address",null,null,null,false],[381,101,0,null,null,null,null,false],[0,0,0,"broadcast_address",null,null,null,false],[381,101,0,null,null,null,null,false],[0,0,0,"permanent_address",null,null,null,false],[0,0,0,"if_type",null,null,null,false],[0,0,0,"mac_address_changeable",null,null,null,false],[0,0,0,"multiple_tx_supported",null,null,null,false],[0,0,0,"media_present_supported",null,null,null,false],[0,0,0,"media_present",null,null,null,false],[381,123,0,null,null,null,[44843,44844,44845,44846,44847,44849],false],[0,0,0,"receive_unicast",null,null,null,false],[0,0,0,"receive_multicast",null,null,null,false],[0,0,0,"receive_broadcast",null,null,null,false],[0,0,0,"receive_promiscuous",null,null,null,false],[0,0,0,"receive_promiscuous_multicast",null,null,null,false],[381,123,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[381,132,0,null,null,null,[44851,44852,44853],false],[0,0,0,"Stopped",null,null,null,false],[0,0,0,"Started",null,null,null,false],[0,0,0,"Initialized",null,null,null,false],[381,138,0,null,null,null,[44855,44856,44857,44858,44859,44860,44861,44862,44863,44864,44865,44866,44867,44868,44869,44870,44871,44872,44873,44874,44875,44876,44877,44878,44879,44880],false],[0,0,0,"rx_total_frames",null,null,null,false],[0,0,0,"rx_good_frames",null,null,null,false],[0,0,0,"rx_undersize_frames",null,null,null,false],[0,0,0,"rx_oversize_frames",null,null,null,false],[0,0,0,"rx_dropped_frames",null,null,null,false],[0,0,0,"rx_unicast_frames",null,null,null,false],[0,0,0,"rx_broadcast_frames",null,null,null,false],[0,0,0,"rx_multicast_frames",null,null,null,false],[0,0,0,"rx_crc_error_frames",null,null,null,false],[0,0,0,"rx_total_bytes",null,null,null,false],[0,0,0,"tx_total_frames",null,null,null,false],[0,0,0,"tx_good_frames",null,null,null,false],[0,0,0,"tx_undersize_frames",null,null,null,false],[0,0,0,"tx_oversize_frames",null,null,null,false],[0,0,0,"tx_dropped_frames",null,null,null,false],[0,0,0,"tx_unicast_frames",null,null,null,false],[0,0,0,"tx_broadcast_frames",null,null,null,false],[0,0,0,"tx_multicast_frames",null,null,null,false],[0,0,0,"tx_crc_error_frames",null,null,null,false],[0,0,0,"tx_total_bytes",null,null,null,false],[0,0,0,"collisions",null,null,null,false],[0,0,0,"unsupported_protocol",null,null,null,false],[0,0,0,"rx_duplicated_frames",null,null,null,false],[0,0,0,"rx_decryptError_frames",null,null,null,false],[0,0,0,"tx_error_frames",null,null,null,false],[0,0,0,"tx_retry_frames",null,null,null,false],[381,167,0,null,null,null,[44882,44883,44884,44885,44887],false],[0,0,0,"receive_interrupt",null,null,null,false],[0,0,0,"transmit_interrupt",null,null,null,false],[0,0,0,"command_interrupt",null,null,null,false],[0,0,0,"software_interrupt",null,null,null,false],[381,167,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[0,0,0,"revision",null,null,null,false],[381,7,0,null,null,null,[44890],false],[0,0,0,"",null,"",null,false],[0,0,0,"_start",null,null,null,false],[381,7,0,null,null,null,[44893],false],[0,0,0,"",null,"",null,false],[0,0,0,"_stop",null,null,null,false],[381,7,0,null,null,null,[44896,44897,44898],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_initialize",null,null,null,false],[381,7,0,null,null,null,[44901,44902],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_reset",null,null,null,false],[381,7,0,null,null,null,[44905],false],[0,0,0,"",null,"",null,false],[0,0,0,"_shutdown",null,null,null,false],[381,7,0,null,null,null,[44908,44909,44910,44911,44912,44913],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_receive_filters",null,null,null,false],[381,7,0,null,null,null,[44916,44917,44918],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_station_address",null,null,null,false],[381,7,0,null,null,null,[44921,44922,44923,44924],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_statistics",null,null,null,false],[381,7,0,null,null,null,[44927,44928,44929,44930],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_mcast_ip_to_mac",null,null,null,false],[381,7,0,null,null,null,[44933,44934,44935,44936,44937],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_nvdata",null,null,null,false],[381,7,0,null,null,null,[44940,44941,44942],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_status",null,null,null,false],[381,7,0,null,null,null,[44945,44946,44947,44948,44949,44950,44951],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_transmit",null,null,null,false],[381,7,0,null,null,null,[44954,44955,44956,44957,44958,44959,44960],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_receive",null,null,null,false],[381,7,0,null,null,null,null,false],[0,0,0,"wait_for_packet",null,null,null,false],[381,7,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[366,21,0,null,null,null,null,false],[0,0,0,"protocol/managed_network.zig",null,"",[],false],[382,0,0,null,null,null,null,false],[382,1,0,null,null,null,null,false],[382,2,0,null,null,null,null,false],[382,3,0,null,null,null,null,false],[382,4,0,null,null,null,null,false],[382,5,0,null,null,null,null,false],[382,6,0,null,null,null,null,false],[382,7,0,null,null,null,null,false],[382,8,0,null,null,null,null,false],[382,9,0,null,null,null,null,false],[382,11,0,null,null,null,[45083,45087,45093,45098,45102,45106,45110,45113],false],[382,23,0,null,null," Returns the operational parameters for the current MNP child driver.\n May also support returning the underlying SNP driver mode data.",[44980,44981,44982],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mnp_config_data",null,"",null,false],[0,0,0,"snp_mode_data",null,"",null,false],[382,28,0,null,null," Sets or clears the operational parameters for the MNP child driver.",[44984,44985],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mnp_config_data",null,"",null,false],[382,34,0,null,null," Translates an IP multicast address to a hardware (MAC) multicast address.\n This function may be unsupported in some MNP implementations.",[44987,44988,44989,44990],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ipv6flag",null,"",null,false],[0,0,0,"ipaddress",null,"",null,false],[0,0,0,"mac_address",null,"",null,false],[382,40,0,null,null," Enables and disables receive filters for multicast address.\n This function may be unsupported in some MNP implementations.",[44992,44993,44994],false],[0,0,0,"self",null,"",null,false],[0,0,0,"join_flag",null,"",null,false],[0,0,0,"mac_address",null,"",null,false],[382,45,0,null,null," Places asynchronous outgoing data packets into the transmit queue.",[44996,44997],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[382,50,0,null,null," Places an asynchronous receiving request into the receiving queue.",[44999,45000],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[382,55,0,null,null," Aborts an asynchronous transmit or receive request.",[45002,45003],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[382,60,0,null,null," Polls for incoming data packets and processes outgoing data packets.",[45005],false],[0,0,0,"self",null,"",null,false],[382,64,0,null,null,null,null,false],[382,73,0,null,null,null,[45018,45022],false],[382,77,0,null,null,null,[45009,45010],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[382,81,0,null,null,null,[45012,45013],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[382,85,0,null,null,null,null,false],[382,73,0,null,null,null,[45016,45017],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_create_child",null,null,null,false],[382,73,0,null,null,null,[45020,45021],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_destroy_child",null,null,null,false],[382,95,0,null,null,null,[45024,45025,45026,45027,45028,45029,45030,45031,45032,45033],false],[0,0,0,"received_queue_timeout_value",null,null,null,false],[0,0,0,"transmit_queue_timeout_value",null,null,null,false],[0,0,0,"protocol_type_filter",null,null,null,false],[0,0,0,"enable_unicast_receive",null,null,null,false],[0,0,0,"enable_multicast_receive",null,null,null,false],[0,0,0,"enable_broadcast_receive",null,null,null,false],[0,0,0,"enable_promiscuous_receive",null,null,null,false],[0,0,0,"flush_queues_on_reset",null,null,null,false],[0,0,0,"enable_receive_timestamps",null,null,null,false],[0,0,0,"disable_background_polling",null,null,null,false],[382,108,0,null,null,null,[45036,45038,45042],false],[382,108,0,null,null,null,null,false],[0,0,0,"event",null,null,null,false],[382,108,0,null,null,null,null,false],[0,0,0,"status",null,null,null,false],[382,108,0,null,null,null,[45040,45041],false],[0,0,0,"RxData",null,null,null,false],[0,0,0,"TxData",null,null,null,false],[0,0,0,"packet",null,null,null,false],[382,117,0,null,null,null,[45045,45047,45048,45049,45050,45051,45052,45053,45054,45055,45057,45059,45061,45063],false],[382,117,0,null,null,null,null,false],[0,0,0,"timestamp",null,null,null,false],[382,117,0,null,null,null,null,false],[0,0,0,"recycle_event",null,null,null,false],[0,0,0,"packet_length",null,null,null,false],[0,0,0,"header_length",null,null,null,false],[0,0,0,"address_length",null,null,null,false],[0,0,0,"data_length",null,null,null,false],[0,0,0,"broadcast_flag",null,null,null,false],[0,0,0,"multicast_flag",null,null,null,false],[0,0,0,"promiscuous_flag",null,null,null,false],[0,0,0,"protocol_type",null,null,null,false],[382,117,0,null,null,null,null,false],[0,0,0,"destination_address",null,null,null,false],[382,117,0,null,null,null,null,false],[0,0,0,"source_address",null,null,null,false],[382,117,0,null,null,null,null,false],[0,0,0,"media_header",null,null,null,false],[382,117,0,null,null,null,null,false],[0,0,0,"packet_data",null,null,null,false],[382,134,0,null,null,null,[45068,45070,45071,45072,45073,45074],false],[382,142,0,null,null,null,[45066],false],[0,0,0,"self",null,"",null,false],[382,134,0,null,null,null,null,false],[0,0,0,"destination_address",null,null,null,false],[382,134,0,null,null,null,null,false],[0,0,0,"source_address",null,null,null,false],[0,0,0,"protocol_type",null,null,null,false],[0,0,0,"data_length",null,null,null,false],[0,0,0,"header_length",null,null,null,false],[0,0,0,"fragment_count",null,null,null,false],[382,147,0,null,null,null,[45076,45078],false],[0,0,0,"fragment_length",null,null,null,false],[382,147,0,null,null,null,null,false],[0,0,0,"fragment_buffer",null,null,null,false],[382,11,0,null,null,null,[45080,45081,45082],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_mode_data",null,null,null,false],[382,11,0,null,null,null,[45085,45086],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_configure",null,null,null,false],[382,11,0,null,null,null,[45089,45090,45091,45092],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_mcast_ip_to_mac",null,null,null,false],[382,11,0,null,null,null,[45095,45096,45097],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_groups",null,null,null,false],[382,11,0,null,null,null,[45100,45101],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_transmit",null,null,null,false],[382,11,0,null,null,null,[45104,45105],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_receive",null,null,null,false],[382,11,0,null,null,null,[45108,45109],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_cancel",null,null,null,false],[382,11,0,null,null,null,[45112],false],[0,0,0,"",null,"",null,false],[0,0,0,"_poll",null,null,null,false],[366,23,0,null,null,null,null,false],[0,0,0,"protocol/ip6_service_binding.zig",null,"",[],false],[383,0,0,null,null,null,null,false],[383,1,0,null,null,null,null,false],[383,2,0,null,null,null,null,false],[383,3,0,null,null,null,null,false],[383,4,0,null,null,null,null,false],[383,5,0,null,null,null,null,false],[383,7,0,null,null,null,[45133,45137],false],[383,11,0,null,null,null,[45124,45125],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[383,15,0,null,null,null,[45127,45128],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[383,19,0,null,null,null,null,false],[383,7,0,null,null,null,[45131,45132],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_create_child",null,null,null,false],[383,7,0,null,null,null,[45135,45136],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_destroy_child",null,null,null,false],[366,24,0,null,null,null,null,false],[0,0,0,"protocol/ip6.zig",null,"",[],false],[384,0,0,null,null,null,null,false],[384,1,0,null,null,null,null,false],[384,2,0,null,null,null,null,false],[384,3,0,null,null,null,null,false],[384,4,0,null,null,null,null,false],[384,5,0,null,null,null,null,false],[384,6,0,null,null,null,null,false],[384,7,0,null,null,null,null,false],[384,8,0,null,null,null,null,false],[384,10,0,null,null,null,[45264,45268,45273,45280,45288,45292,45296,45300,45303],false],[384,22,0,null,null," Gets the current operational settings for this instance of the EFI IPv6 Protocol driver.",[45151,45152,45153,45154],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ip6_mode_data",null,"",null,false],[0,0,0,"mnp_config_data",null,"",null,false],[0,0,0,"snp_mode_data",null,"",null,false],[384,27,0,null,null," Assign IPv6 address and other configuration parameter to this EFI IPv6 Protocol driver instance.",[45156,45157],false],[0,0,0,"self",null,"",null,false],[0,0,0,"ip6_config_data",null,"",null,false],[384,32,0,null,null," Joins and leaves multicast groups.",[45159,45160,45161],false],[0,0,0,"self",null,"",null,false],[0,0,0,"join_flag",null,"",null,false],[0,0,0,"group_address",null,"",null,false],[384,37,0,null,null," Adds and deletes routing table entries.",[45163,45164,45165,45166,45167],false],[0,0,0,"self",null,"",null,false],[0,0,0,"delete_route",null,"",null,false],[0,0,0,"destination",null,"",null,false],[0,0,0,"prefix_length",null,"",null,false],[0,0,0,"gateway_address",null,"",null,false],[384,42,0,null,null," Add or delete Neighbor cache entries.",[45169,45170,45171,45172,45173,45174],false],[0,0,0,"self",null,"",null,false],[0,0,0,"delete_flag",null,"",null,false],[0,0,0,"target_ip6_address",null,"",null,false],[0,0,0,"target_link_address",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"override",null,"",null,false],[384,47,0,null,null," Places outgoing data packets into the transmit queue.",[45176,45177],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[384,52,0,null,null," Places a receiving request into the receiving queue.",[45179,45180],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[384,57,0,null,null," Abort an asynchronous transmits or receive request.",[45182,45183],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[384,62,0,null,null," Polls for incoming data packets and processes outgoing data packets.",[45185],false],[0,0,0,"self",null,"",null,false],[384,66,0,null,null,null,null,false],[384,75,0,null,null,null,[45188,45189,45191,45192,45193,45195,45196,45198,45199,45201,45202,45204,45205,45207,45208,45210],false],[0,0,0,"is_started",null,null,null,false],[0,0,0,"max_packet_size",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"config_data",null,null,null,false],[0,0,0,"is_configured",null,null,null,false],[0,0,0,"address_count",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"address_list",null,null,null,false],[0,0,0,"group_count",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"group_table",null,null,null,false],[0,0,0,"route_count",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"route_table",null,null,null,false],[0,0,0,"neighbor_count",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"neighbor_cache",null,null,null,false],[0,0,0,"prefix_count",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"prefix_table",null,null,null,false],[0,0,0,"icmp_type_count",null,null,null,false],[384,75,0,null,null,null,null,false],[0,0,0,"icmp_type_list",null,null,null,false],[384,94,0,null,null,null,[45212,45213,45214,45215,45217,45219,45220,45221,45222,45223,45224],false],[0,0,0,"default_protocol",null,null,null,false],[0,0,0,"accept_any_protocol",null,null,null,false],[0,0,0,"accept_icmp_errors",null,null,null,false],[0,0,0,"accept_promiscuous",null,null,null,false],[384,94,0,null,null,null,null,false],[0,0,0,"destination_address",null,null,null,false],[384,94,0,null,null,null,null,false],[0,0,0,"station_address",null,null,null,false],[0,0,0,"traffic_class",null,null,null,false],[0,0,0,"hop_limit",null,null,null,false],[0,0,0,"flow_label",null,null,null,false],[0,0,0,"receive_timeout",null,null,null,false],[0,0,0,"transmit_timeout",null,null,null,false],[384,108,0,null,null,null,null,false],[384,110,0,null,null,null,[45228,45229],false],[384,110,0,null,null,null,null,false],[0,0,0,"address",null,null,null,false],[0,0,0,"prefix_length",null,null,null,false],[384,115,0,null,null,null,[45232,45234,45235],false],[384,115,0,null,null,null,null,false],[0,0,0,"gateway",null,null,null,false],[384,115,0,null,null,null,null,false],[0,0,0,"destination",null,null,null,false],[0,0,0,"prefix_length",null,null,null,false],[384,121,0,null,null,null,[45237,45238,45239,45240,45241],false],[0,0,0,"Incomplete",null,null,null,false],[0,0,0,"Reachable",null,null,null,false],[0,0,0,"Stale",null,null,null,false],[0,0,0,"Delay",null,null,null,false],[0,0,0,"Probe",null,null,null,false],[384,129,0,null,null,null,[45244,45246,45248],false],[384,129,0,null,null,null,null,false],[0,0,0,"neighbor",null,null,null,false],[384,129,0,null,null,null,null,false],[0,0,0,"link_address",null,null,null,false],[384,129,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[384,135,0,null,null,null,[45250,45251],false],[0,0,0,"type",null,null,null,false],[0,0,0,"code",null,null,null,false],[384,140,0,null,null,null,[45254,45256,45258],false],[384,140,0,null,null,null,null,false],[0,0,0,"event",null,null,null,false],[384,140,0,null,null,null,null,false],[0,0,0,"status",null,null,null,false],[384,140,0,null,null,null,null,false],[0,0,0,"packet",null,null,null,false],[384,10,0,null,null,null,[45260,45261,45262,45263],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_mode_data",null,null,null,false],[384,10,0,null,null,null,[45266,45267],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_configure",null,null,null,false],[384,10,0,null,null,null,[45270,45271,45272],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_groups",null,null,null,false],[384,10,0,null,null,null,[45275,45276,45277,45278,45279],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_routes",null,null,null,false],[384,10,0,null,null,null,[45282,45283,45284,45285,45286,45287],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_neighbors",null,null,null,false],[384,10,0,null,null,null,[45290,45291],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_transmit",null,null,null,false],[384,10,0,null,null,null,[45294,45295],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_receive",null,null,null,false],[384,10,0,null,null,null,[45298,45299],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_cancel",null,null,null,false],[384,10,0,null,null,null,[45302],false],[0,0,0,"",null,"",null,false],[0,0,0,"_poll",null,null,null,false],[366,25,0,null,null,null,null,false],[0,0,0,"protocol/ip6_config.zig",null,"",[],false],[385,0,0,null,null,null,null,false],[385,1,0,null,null,null,null,false],[385,2,0,null,null,null,null,false],[385,3,0,null,null,null,null,false],[385,4,0,null,null,null,null,false],[385,5,0,null,null,null,null,false],[385,7,0,null,null,null,[45345,45351,45356,45361],false],[385,13,0,null,null,null,[45314,45315,45316,45317],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data_type",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"data",null,"",null,false],[385,17,0,null,null,null,[45319,45320,45321,45322],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data_type",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"data",null,"",null,false],[385,21,0,null,null,null,[45324,45325,45326],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data_type",null,"",null,false],[0,0,0,"event",null,"",null,false],[385,25,0,null,null,null,[45328,45329,45330],false],[0,0,0,"self",null,"",null,false],[0,0,0,"data_type",null,"",null,false],[0,0,0,"event",null,"",null,false],[385,29,0,null,null,null,null,false],[385,38,0,null,null,null,[45333,45334,45335,45336,45337,45338,45339],false],[0,0,0,"InterfaceInfo",null,null,null,false],[0,0,0,"AltInterfaceId",null,null,null,false],[0,0,0,"Policy",null,null,null,false],[0,0,0,"DupAddrDetectTransmits",null,null,null,false],[0,0,0,"ManualAddress",null,null,null,false],[0,0,0,"Gateway",null,null,null,false],[0,0,0,"DnsServer",null,null,null,false],[385,7,0,null,null,null,[45341,45342,45343,45344],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_set_data",null,null,null,false],[385,7,0,null,null,null,[45347,45348,45349,45350],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_data",null,null,null,false],[385,7,0,null,null,null,[45353,45354,45355],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_register_data_notify",null,null,null,false],[385,7,0,null,null,null,[45358,45359,45360],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_unregister_data_notify",null,null,null,false],[366,27,0,null,null,null,null,false],[0,0,0,"protocol/udp6_service_binding.zig",null,"",[],false],[386,0,0,null,null,null,null,false],[386,1,0,null,null,null,null,false],[386,2,0,null,null,null,null,false],[386,3,0,null,null,null,null,false],[386,4,0,null,null,null,null,false],[386,5,0,null,null,null,null,false],[386,7,0,null,null,null,[45381,45385],false],[386,11,0,null,null,null,[45372,45373],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[386,15,0,null,null,null,[45375,45376],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[386,19,0,null,null,null,null,false],[386,7,0,null,null,null,[45379,45380],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_create_child",null,null,null,false],[386,7,0,null,null,null,[45383,45384],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_destroy_child",null,null,null,false],[366,28,0,null,null,null,null,false],[0,0,0,"protocol/udp6.zig",null,"",[],false],[387,0,0,null,null,null,null,false],[387,1,0,null,null,null,null,false],[387,2,0,null,null,null,null,false],[387,3,0,null,null,null,null,false],[387,4,0,null,null,null,null,false],[387,5,0,null,null,null,null,false],[387,6,0,null,null,null,null,false],[387,7,0,null,null,null,null,false],[387,8,0,null,null,null,null,false],[387,9,0,null,null,null,null,false],[387,11,0,null,null,null,[45481,45485,45490,45494,45498,45502,45505],false],[387,20,0,null,null,null,[45400,45401,45402,45403,45404],false],[0,0,0,"self",null,"",null,false],[0,0,0,"udp6_config_data",null,"",null,false],[0,0,0,"ip6_mode_data",null,"",null,false],[0,0,0,"mnp_config_data",null,"",null,false],[0,0,0,"snp_mode_data",null,"",null,false],[387,24,0,null,null,null,[45406,45407],false],[0,0,0,"self",null,"",null,false],[0,0,0,"udp6_config_data",null,"",null,false],[387,28,0,null,null,null,[45409,45410,45411],false],[0,0,0,"self",null,"",null,false],[0,0,0,"join_flag",null,"",null,false],[0,0,0,"multicast_address",null,"",null,false],[387,32,0,null,null,null,[45413,45414],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[387,36,0,null,null,null,[45416,45417],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[387,40,0,null,null,null,[45419,45420],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[387,44,0,null,null,null,[45422],false],[0,0,0,"self",null,"",null,false],[387,48,0,null,null,null,null,false],[387,57,0,null,null,null,[45425,45426,45427,45428,45429,45430,45431,45433,45434,45436,45437],false],[0,0,0,"accept_promiscuous",null,null,null,false],[0,0,0,"accept_any_port",null,null,null,false],[0,0,0,"allow_duplicate_port",null,null,null,false],[0,0,0,"traffic_class",null,null,null,false],[0,0,0,"hop_limit",null,null,null,false],[0,0,0,"receive_timeout",null,null,null,false],[0,0,0,"transmit_timeout",null,null,null,false],[387,57,0,null,null,null,null,false],[0,0,0,"station_address",null,null,null,false],[0,0,0,"station_port",null,null,null,false],[387,57,0,null,null,null,null,false],[0,0,0,"remote_address",null,null,null,false],[0,0,0,"remote_port",null,null,null,false],[387,71,0,null,null,null,[45440,45441,45445],false],[387,71,0,null,null,null,null,false],[0,0,0,"event",null,null,null,false],[0,0,0,"Status",null,null,null,false],[387,71,0,null,null,null,[45443,45444],false],[0,0,0,"RxData",null,null,null,false],[0,0,0,"TxData",null,null,null,false],[0,0,0,"packet",null,null,null,false],[387,80,0,null,null,null,[45450,45452,45454,45455,45456],false],[387,87,0,null,null,null,[45448],false],[0,0,0,"self",null,"",null,false],[387,80,0,null,null,null,null,false],[0,0,0,"timestamp",null,null,null,false],[387,80,0,null,null,null,null,false],[0,0,0,"recycle_signal",null,null,null,false],[387,80,0,null,null,null,null,false],[0,0,0,"udp6_session",null,null,null,false],[0,0,0,"data_length",null,null,null,false],[0,0,0,"fragment_count",null,null,null,false],[387,92,0,null,null,null,[45461,45462,45463],false],[387,97,0,null,null,null,[45459],false],[0,0,0,"self",null,"",null,false],[387,92,0,null,null,null,null,false],[0,0,0,"udp6_session_data",null,null,null,false],[0,0,0,"data_length",null,null,null,false],[0,0,0,"fragment_count",null,null,null,false],[387,102,0,null,null,null,[45466,45467,45469,45470],false],[387,102,0,null,null,null,null,false],[0,0,0,"source_address",null,null,null,false],[0,0,0,"source_port",null,null,null,false],[387,102,0,null,null,null,null,false],[0,0,0,"destination_address",null,null,null,false],[0,0,0,"destination_port",null,null,null,false],[387,109,0,null,null,null,[45472,45474],false],[0,0,0,"fragment_length",null,null,null,false],[387,109,0,null,null,null,null,false],[0,0,0,"fragment_buffer",null,null,null,false],[387,11,0,null,null,null,[45476,45477,45478,45479,45480],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_get_mode_data",null,null,null,false],[387,11,0,null,null,null,[45483,45484],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_configure",null,null,null,false],[387,11,0,null,null,null,[45487,45488,45489],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_groups",null,null,null,false],[387,11,0,null,null,null,[45492,45493],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_transmit",null,null,null,false],[387,11,0,null,null,null,[45496,45497],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_receive",null,null,null,false],[387,11,0,null,null,null,[45500,45501],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_cancel",null,null,null,false],[387,11,0,null,null,null,[45504],false],[0,0,0,"",null,"",null,false],[0,0,0,"_poll",null,null,null,false],[366,30,0,null,null,null,null,false],[0,0,0,"protocol/hii_database.zig",null,"",[],false],[388,0,0,null,null,null,null,false],[388,1,0,null,null,null,null,false],[388,2,0,null,null,null,null,false],[388,3,0,null,null,null,null,false],[388,4,0,null,null,null,null,false],[388,5,0,null,null,null,null,false],[388,8,0,null,null," Database manager for HII-related data structures.",[45535,45539,45544,45551,45557,45559,45561,45563,45565,45567,45569],false],[388,22,0,null,null," Removes a package list from the HII database.",[45516,45517],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[388,27,0,null,null," Update a package list in the HII database.",[45519,45520,45521],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[388,32,0,null,null," Determines the handles that are currently active in the database.",[45523,45524,45525,45526,45527],false],[0,0,0,"self",null,"",null,false],[0,0,0,"package_type",null,"",null,false],[0,0,0,"package_guid",null,"",null,false],[0,0,0,"buffer_length",null,"",null,false],[0,0,0,"handles",null,"",null,false],[388,37,0,null,null," Exports the contents of one or all package lists in the HII database into a buffer.",[45529,45530,45531,45532],false],[0,0,0,"self",null,"",null,false],[0,0,0,"handle",null,"",null,false],[0,0,0,"buffer_size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[388,41,0,null,null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_new_package_list",null,null,null,false],[388,8,0,null,null,null,[45537,45538],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_remove_package_list",null,null,null,false],[388,8,0,null,null,null,[45541,45542,45543],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_update_package_list",null,null,null,false],[388,8,0,null,null,null,[45546,45547,45548,45549,45550],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_list_package_lists",null,null,null,false],[388,8,0,null,null,null,[45553,45554,45555,45556],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_export_package_lists",null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_register_package_notify",null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_unregister_package_notify",null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_find_keyboard_layouts",null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_get_keyboard_layout",null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_set_keyboard_layout",null,null,null,false],[388,8,0,null,null,null,null,false],[0,0,0,"_get_package_list_handle",null,null,null,false],[366,31,0,null,null,null,null,false],[0,0,0,"protocol/hii_popup.zig",null,"",[],false],[389,0,0,null,null,null,null,false],[389,1,0,null,null,null,null,false],[389,2,0,null,null,null,null,false],[389,3,0,null,null,null,null,false],[389,4,0,null,null,null,null,false],[389,5,0,null,null,null,null,false],[389,8,0,null,null," Display a popup window",[45601,45609],false],[389,13,0,null,null," Displays a popup window.",[45580,45581,45582,45583,45584,45585],false],[0,0,0,"self",null,"",null,false],[0,0,0,"style",null,"",null,false],[0,0,0,"popup_type",null,"",null,false],[0,0,0,"handle",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"user_selection",null,"",null,false],[389,17,0,null,null,null,null,false],[389,26,0,null,null,null,[45588,45589,45590],false],[0,0,0,"Info",null,null,null,false],[0,0,0,"Warning",null,null,null,false],[0,0,0,"Error",null,null,null,false],[389,32,0,null,null,null,[45592,45593,45594,45595],false],[0,0,0,"Ok",null,null,null,false],[0,0,0,"Cancel",null,null,null,false],[0,0,0,"YesNo",null,null,null,false],[0,0,0,"YesNoCancel",null,null,null,false],[389,39,0,null,null,null,[45597,45598,45599,45600],false],[0,0,0,"Ok",null,null,null,false],[0,0,0,"Cancel",null,null,null,false],[0,0,0,"Yes",null,null,null,false],[0,0,0,"No",null,null,null,false],[0,0,0,"revision",null,null,null,false],[389,8,0,null,null,null,[45603,45604,45605,45606,45607,45608],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"_create_popup",null,null,null,false],[365,4,0,null,null,null,null,false],[0,0,0,"uefi/device_path.zig",null,"",[],false],[390,0,0,null,null,null,null,false],[390,1,0,null,null,null,null,false],[390,2,0,null,null,null,null,false],[390,3,0,null,null,null,null,false],[390,5,0,null,null,null,[46120,46121,46122,46123,46124,46125],false],[390,13,0,null,null,null,[45618,45619,45620,45621,45622,45623],false],[0,0,0,"Hardware",null,null,null,false],[0,0,0,"Acpi",null,null,null,false],[0,0,0,"Messaging",null,null,null,false],[0,0,0,"Media",null,null,null,false],[0,0,0,"BiosBootSpecification",null,null,null,false],[0,0,0,"End",null,null,null,false],[390,23,0,null,null,null,[45679,45680,45681,45682,45683,45684],false],[390,31,0,null,null,null,[45626,45627,45628,45629,45630,45631],false],[0,0,0,"Pci",null,null,null,false],[0,0,0,"PcCard",null,null,null,false],[0,0,0,"MemoryMapped",null,null,null,false],[0,0,0,"Vendor",null,null,null,false],[0,0,0,"Controller",null,null,null,false],[0,0,0,"Bmc",null,null,null,false],[390,41,0,null,null,null,[45634,45636,45637,45638,45639],false],[390,41,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,41,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"function",null,null,null,false],[0,0,0,"device",null,null,null,false],[390,60,0,null,null,null,[45642,45644,45645,45646],false],[390,60,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,60,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"function_number",null,null,null,false],[390,77,0,null,null,null,[45649,45651,45652,45653,45654,45655],false],[390,77,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,77,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"memory_type",null,null,null,false],[0,0,0,"start_address",null,null,null,false],[0,0,0,"end_address",null,null,null,false],[390,98,0,null,null,null,[45658,45660,45661,45663],false],[390,98,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,98,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,98,0,null,null,null,null,false],[0,0,0,"vendor_guid",null,null,null,false],[390,115,0,null,null,null,[45666,45668,45669,45670],false],[390,115,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,115,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"controller_number",null,null,null,false],[390,132,0,null,null,null,[45673,45675,45676,45677,45678],false],[390,132,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,132,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"interface_type",null,null,null,false],[0,0,0,"base_address",null,null,null,false],[0,0,0,"Pci",null,null,null,false],[0,0,0,"PcCard",null,null,null,false],[0,0,0,"MemoryMapped",null,null,null,false],[0,0,0,"Vendor",null,null,null,false],[0,0,0,"Controller",null,null,null,false],[0,0,0,"Bmc",null,null,null,false],[390,152,0,null,null,null,[45716,45717,45718],false],[390,157,0,null,null,null,[45687,45688,45689],false],[0,0,0,"Acpi",null,null,null,false],[0,0,0,"ExpandedAcpi",null,null,null,false],[0,0,0,"Adr",null,null,null,false],[390,164,0,null,null,null,[45692,45694,45695,45696,45697],false],[390,164,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,164,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"hid",null,null,null,false],[0,0,0,"uid",null,null,null,false],[390,183,0,null,null,null,[45700,45702,45703,45704,45705,45706],false],[390,183,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,183,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"hid",null,null,null,false],[0,0,0,"uid",null,null,null,false],[0,0,0,"cid",null,null,null,false],[390,206,0,null,null,null,[45711,45713,45714,45715],false],[390,213,0,null,null,null,[45709],false],[0,0,0,"self",null,"",null,false],[390,206,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,206,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"adr",null,null,null,false],[0,0,0,"Acpi",null,null,null,false],[0,0,0,"ExpandedAcpi",null,null,null,false],[0,0,0,"Adr",null,null,null,false],[390,231,0,null,null,null,[45959,45960,45961,45962,45963,45964,45965,45966,45967,45968,45969,45970,45971,45972,45973,45974,45975,45976],false],[390,251,0,null,null,null,[45721,45722,45723,45724,45725,45726,45727,45728,45729,45730,45731,45732,45733,45734,45735,45736,45737,45738],false],[0,0,0,"Atapi",null,null,null,false],[0,0,0,"Scsi",null,null,null,false],[0,0,0,"FibreChannel",null,null,null,false],[0,0,0,"FibreChannelEx",null,null,null,false],[0,0,0,"1394",null,null,null,false],[0,0,0,"Usb",null,null,null,false],[0,0,0,"Sata",null,null,null,false],[0,0,0,"UsbWwid",null,null,null,false],[0,0,0,"Lun",null,null,null,false],[0,0,0,"UsbClass",null,null,null,false],[0,0,0,"I2o",null,null,null,false],[0,0,0,"MacAddress",null,null,null,false],[0,0,0,"Ipv4",null,null,null,false],[0,0,0,"Ipv6",null,null,null,false],[0,0,0,"Vlan",null,null,null,false],[0,0,0,"InfiniBand",null,null,null,false],[0,0,0,"Uart",null,null,null,false],[0,0,0,"Vendor",null,null,null,false],[390,273,0,null,null,null,[45747,45749,45750,45752,45754,45755],false],[390,274,0,null,null,null,[45741,45742],false],[0,0,0,"Master",null,null,null,false],[0,0,0,"Slave",null,null,null,false],[390,279,0,null,null,null,[45744,45745],false],[0,0,0,"Primary",null,null,null,false],[0,0,0,"Secondary",null,null,null,false],[390,273,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,273,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,273,0,null,null,null,null,false],[0,0,0,"primary_secondary",null,null,null,false],[390,273,0,null,null,null,null,false],[0,0,0,"slave_master",null,null,null,false],[0,0,0,"logical_unit_number",null,null,null,false],[390,304,0,null,null,null,[45758,45760,45761,45762,45763],false],[390,304,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,304,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"target_id",null,null,null,false],[0,0,0,"logical_unit_number",null,null,null,false],[390,323,0,null,null,null,[45766,45768,45769,45770,45771,45772],false],[390,323,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,323,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"world_wide_name",null,null,null,false],[0,0,0,"logical_unit_number",null,null,null,false],[390,344,0,null,null,null,[45775,45777,45778,45779,45780,45781],false],[390,344,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,344,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"world_wide_name",null,null,null,false],[0,0,0,"logical_unit_number",null,null,null,false],[390,365,0,null,null,null,[45784,45786,45787,45788,45789],false],[390,365,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,365,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"guid",null,null,null,false],[390,384,0,null,null,null,[45792,45794,45795,45796,45797],false],[390,384,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,384,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"parent_port_number",null,null,null,false],[0,0,0,"interface_number",null,null,null,false],[390,403,0,null,null,null,[45800,45802,45803,45804,45805,45806],false],[390,403,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,403,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"hba_port_number",null,null,null,false],[0,0,0,"port_multiplier_port_number",null,null,null,false],[0,0,0,"logical_unit_number",null,null,null,false],[390,424,0,null,null,null,[45811,45813,45814,45815,45816,45817],false],[390,432,0,null,null,null,[45809],false],[0,0,0,"self",null,"",null,false],[390,424,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,424,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"interface_number",null,null,null,false],[0,0,0,"device_vendor_id",null,null,null,false],[0,0,0,"device_product_id",null,null,null,false],[390,450,0,null,null,null,[45820,45822,45823,45824],false],[390,450,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,450,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"lun",null,null,null,false],[390,467,0,null,null,null,[45827,45829,45830,45831,45832,45833,45834,45835],false],[390,467,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,467,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"vendor_id",null,null,null,false],[0,0,0,"product_id",null,null,null,false],[0,0,0,"device_class",null,null,null,false],[0,0,0,"device_subclass",null,null,null,false],[0,0,0,"device_protocol",null,null,null,false],[390,492,0,null,null,null,[45838,45840,45841,45842],false],[390,492,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,492,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"tid",null,null,null,false],[390,509,0,null,null,null,[45845,45847,45848,45850,45851],false],[390,509,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,509,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,509,0,null,null,null,null,false],[0,0,0,"mac_address",null,null,null,false],[0,0,0,"if_type",null,null,null,false],[390,528,0,null,null,null,[45857,45859,45860,45862,45864,45865,45866,45867,45869,45870,45871],false],[390,529,0,null,null,null,[45854,45855],false],[0,0,0,"Dhcp",null,null,null,false],[0,0,0,"Static",null,null,null,false],[390,528,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,528,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,528,0,null,null,null,null,false],[0,0,0,"local_ip_address",null,null,null,false],[390,528,0,null,null,null,null,false],[0,0,0,"remote_ip_address",null,null,null,false],[0,0,0,"local_port",null,null,null,false],[0,0,0,"remote_port",null,null,null,false],[0,0,0,"network_protocol",null,null,null,false],[390,528,0,null,null,null,null,false],[0,0,0,"static_ip_address",null,null,null,false],[0,0,0,"gateway_ip_address",null,null,null,false],[0,0,0,"subnet_mask",null,null,null,false],[390,564,0,null,null,null,[45878,45880,45881,45883,45885,45886,45887,45888,45890,45891,45893],false],[390,565,0,null,null,null,[45874,45875,45876],false],[0,0,0,"Manual",null,null,null,false],[0,0,0,"AssignedStateless",null,null,null,false],[0,0,0,"AssignedStateful",null,null,null,false],[390,564,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,564,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,564,0,null,null,null,null,false],[0,0,0,"local_ip_address",null,null,null,false],[390,564,0,null,null,null,null,false],[0,0,0,"remote_ip_address",null,null,null,false],[0,0,0,"local_port",null,null,null,false],[0,0,0,"remote_port",null,null,null,false],[0,0,0,"protocol",null,null,null,false],[390,564,0,null,null,null,null,false],[0,0,0,"ip_address_origin",null,null,null,false],[0,0,0,"prefix_length",null,null,null,false],[390,564,0,null,null,null,null,false],[0,0,0,"gateway_ip_address",null,null,null,false],[390,601,0,null,null,null,[45896,45898,45899,45900],false],[390,601,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,601,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"vlan_id",null,null,null,false],[390,618,0,null,null,null,[45915,45917,45918,45920,45922,45923,45924,45925],false],[390,619,0,null,null,null,[45907,45908,45909,45910,45911,45913],false],[390,620,0,null,null,null,[45904,45905],false],[0,0,0,"Ioc",null,null,null,false],[0,0,0,"Service",null,null,null,false],[390,619,0,null,null,null,null,false],[0,0,0,"ioc_or_service",null,null,null,false],[0,0,0,"extend_boot_environment",null,null,null,false],[0,0,0,"console_protocol",null,null,null,false],[0,0,0,"storage_protocol",null,null,null,false],[0,0,0,"network_protocol",null,null,null,false],[390,619,0,null,null,null,null,false],[0,0,0,"reserved",null,null,null,false],[390,618,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,618,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,618,0,null,null,null,null,false],[0,0,0,"resource_flags",null,null,null,false],[390,618,0,null,null,null,null,false],[0,0,0,"port_gid",null,null,null,false],[0,0,0,"service_id",null,null,null,false],[0,0,0,"target_port_id",null,null,null,false],[0,0,0,"device_id",null,null,null,false],[390,659,0,null,null,null,[45940,45942,45943,45944,45945,45946,45948,45950],false],[390,660,0,null,null,null,[45928,45929,45930,45931,45932,45933],false],[0,0,0,"Default",null,null,null,false],[0,0,0,"None",null,null,null,false],[0,0,0,"Even",null,null,null,false],[0,0,0,"Odd",null,null,null,false],[0,0,0,"Mark",null,null,null,false],[0,0,0,"Space",null,null,null,false],[390,670,0,null,null,null,[45935,45936,45937,45938],false],[0,0,0,"Default",null,null,null,false],[0,0,0,"One",null,null,null,false],[0,0,0,"OneAndAHalf",null,null,null,false],[0,0,0,"Two",null,null,null,false],[390,659,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,659,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"baud_rate",null,null,null,false],[0,0,0,"data_bits",null,null,null,false],[390,659,0,null,null,null,null,false],[0,0,0,"parity",null,null,null,false],[390,659,0,null,null,null,null,false],[0,0,0,"stop_bits",null,null,null,false],[390,702,0,null,null,null,[45953,45955,45956,45958],false],[390,702,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,702,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,702,0,null,null,null,null,false],[0,0,0,"vendor_guid",null,null,null,false],[0,0,0,"Atapi",null,null,null,false],[0,0,0,"Scsi",null,null,null,false],[0,0,0,"FibreChannel",null,null,null,false],[0,0,0,"FibreChannelEx",null,null,null,false],[0,0,0,"1394",null,null,null,false],[0,0,0,"Usb",null,null,null,false],[0,0,0,"Sata",null,null,null,false],[0,0,0,"UsbWwid",null,null,null,false],[0,0,0,"Lun",null,null,null,false],[0,0,0,"UsbClass",null,null,null,false],[0,0,0,"I2o",null,null,null,false],[0,0,0,"MacAddress",null,null,null,false],[0,0,0,"Ipv4",null,null,null,false],[0,0,0,"Ipv6",null,null,null,false],[0,0,0,"Vlan",null,null,null,false],[0,0,0,"InfiniBand",null,null,null,false],[0,0,0,"Uart",null,null,null,false],[0,0,0,"Vendor",null,null,null,false],[390,720,0,null,null,null,[46079,46080,46081,46082,46083,46084,46085,46086,46087],false],[390,731,0,null,null,null,[45979,45980,45981,45982,45983,45984,45985,45986,45987],false],[0,0,0,"HardDrive",null,null,null,false],[0,0,0,"Cdrom",null,null,null,false],[0,0,0,"Vendor",null,null,null,false],[0,0,0,"FilePath",null,null,null,false],[0,0,0,"MediaProtocol",null,null,null,false],[0,0,0,"PiwgFirmwareFile",null,null,null,false],[0,0,0,"PiwgFirmwareVolume",null,null,null,false],[0,0,0,"RelativeOffsetRange",null,null,null,false],[0,0,0,"RamDisk",null,null,null,false],[390,744,0,null,null,null,[45997,45999,46000,46001,46002,46003,46005,46007,46009],false],[390,745,0,null,null,null,[45990,45991],false],[0,0,0,"LegacyMbr",null,null,null,false],[0,0,0,"GuidPartitionTable",null,null,null,false],[390,750,0,null,null,null,[45993,45994,45995],false],[0,0,0,"NoSignature",null,null,null,false],[0,0,0,"MbrSignature",null," \"32-bit signature from address 0x1b8 of the type 0x01 MBR\"",null,false],[0,0,0,"GuidSignature",null,null,null,false],[390,744,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,744,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"partition_number",null,null,null,false],[0,0,0,"partition_start",null,null,null,false],[0,0,0,"partition_size",null,null,null,false],[390,744,0,null,null,null,null,false],[0,0,0,"partition_signature",null,null,null,false],[390,744,0,null,null,null,null,false],[0,0,0,"partition_format",null,null,null,false],[390,744,0,null,null,null,null,false],[0,0,0,"signature_type",null,null,null,false],[390,783,0,null,null,null,[46012,46014,46015,46016,46017,46018],false],[390,783,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,783,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"boot_entry",null,null,null,false],[0,0,0,"partition_start",null,null,null,false],[0,0,0,"partition_size",null,null,null,false],[390,804,0,null,null,null,[46021,46023,46024,46026],false],[390,804,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,804,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,804,0,null,null,null,null,false],[0,0,0,"guid",null,null,null,false],[390,821,0,null,null,null,[46031,46033,46034],false],[390,826,0,null,null,null,[46029],false],[0,0,0,"self",null,"",null,false],[390,821,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,821,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,840,0,null,null,null,[46037,46039,46040,46042],false],[390,840,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,840,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,840,0,null,null,null,null,false],[0,0,0,"guid",null,null,null,false],[390,857,0,null,null,null,[46045,46047,46048,46050],false],[390,857,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,857,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,857,0,null,null,null,null,false],[0,0,0,"fv_filename",null,null,null,false],[390,874,0,null,null,null,[46053,46055,46056,46058],false],[390,874,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,874,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,874,0,null,null,null,null,false],[0,0,0,"fv_name",null,null,null,false],[390,891,0,null,null,null,[46061,46063,46064,46065,46066,46067],false],[390,891,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,891,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[390,912,0,null,null,null,[46070,46072,46073,46074,46075,46077,46078],false],[390,912,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,912,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[390,912,0,null,null,null,null,false],[0,0,0,"disk_type",null,null,null,false],[0,0,0,"instance",null,null,null,false],[0,0,0,"HardDrive",null,null,null,false],[0,0,0,"Cdrom",null,null,null,false],[0,0,0,"Vendor",null,null,null,false],[0,0,0,"FilePath",null,null,null,false],[0,0,0,"MediaProtocol",null,null,null,false],[0,0,0,"PiwgFirmwareFile",null,null,null,false],[0,0,0,"PiwgFirmwareVolume",null,null,null,false],[0,0,0,"RelativeOffsetRange",null,null,null,false],[0,0,0,"RamDisk",null,null,null,false],[390,936,0,null,null,null,[46101],false],[390,939,0,null,null,null,[46090],false],[0,0,0,"BBS101",null,null,null,false],[390,944,0,null,null,null,[46095,46097,46098,46099,46100],false],[390,951,0,null,null,null,[46093],false],[0,0,0,"self",null,"",null,false],[390,944,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,944,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"device_type",null,null,null,false],[0,0,0,"status_flag",null,null,null,false],[0,0,0,"BBS101",null,null,null,false],[390,968,0,null,null,null,[46118,46119],false],[390,972,0,null,null,null,[46104,46105],false],[0,0,0,"EndEntire",null,null,null,false],[0,0,0,"EndThisInstance",null,null,null,false],[390,978,0,null,null,null,[46108,46110,46111],false],[390,978,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,978,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[390,993,0,null,null,null,[46114,46116,46117],false],[390,993,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[390,993,0,null,null,null,null,false],[0,0,0,"subtype",null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"EndEntire",null,null,null,false],[0,0,0,"EndThisInstance",null,null,null,false],[0,0,0,"Hardware",null,null,null,false],[0,0,0,"Acpi",null,null,null,false],[0,0,0,"Messaging",null,null,null,false],[0,0,0,"Media",null,null,null,false],[0,0,0,"BiosBootSpecification",null,null,null,false],[0,0,0,"End",null,null,null,false],[365,5,0,null,null,null,null,false],[0,0,0,"uefi/hii.zig",null,"",[],false],[391,0,0,null,null,null,null,false],[391,1,0,null,null,null,null,false],[391,3,0,null,null,null,null,false],[391,6,0,null,null," The header found at the start of each package.",[46146,46147],false],[391,10,0,null,null,null,null,false],[391,11,0,null,null,null,null,false],[391,12,0,null,null,null,null,false],[391,13,0,null,null,null,null,false],[391,14,0,null,null,null,null,false],[391,15,0,null,null,null,null,false],[391,16,0,null,null,null,null,false],[391,17,0,null,null,null,null,false],[391,18,0,null,null,null,null,false],[391,19,0,null,null,null,null,false],[391,20,0,null,null,null,null,false],[391,21,0,null,null,null,null,false],[391,22,0,null,null,null,null,false],[391,6,0,null,null,null,null,false],[0,0,0,"length",null,null,null,false],[0,0,0,"type",null,null,null,false],[391,26,0,null,null," The header found at the start of each package list.",[46150,46151],false],[391,26,0,null,null,null,null,false],[0,0,0,"package_list_guid",null,null,null,false],[0,0,0,"package_list_length",null," The size of the package list (in bytes), including the header.",null,false],[391,35,0,null,null,null,[46156,46157,46158],false],[391,40,0,null,null,null,[46154],false],[0,0,0,"self",null,"",null,false],[391,35,0,null,null,null,null,false],[0,0,0,"header",null,null,null,false],[0,0,0,"number_of_narrow_glyphs",null,null,null,false],[0,0,0,"number_of_wide_glyphs",null,null,null,false],[391,45,0,null,null,null,[46160,46161,46163],false],[0,0,0,"non_spacing",null,null,null,false],[0,0,0,"wide",null,null,null,false],[391,45,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[391,51,0,null,null,null,[46165,46167,46169],false],[0,0,0,"unicode_weight",null,null,null,false],[391,51,0,null,null,null,null,false],[0,0,0,"attributes",null,null,null,false],[391,51,0,null,null,null,null,false],[0,0,0,"glyph_col_1",null,null,null,false],[391,57,0,null,null,null,[46171,46172,46174],false],[0,0,0,"non_spacing",null,null,null,false],[0,0,0,"wide",null,null,null,false],[391,57,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[391,63,0,null,null,null,[46176,46178,46180,46182,46184],false],[0,0,0,"unicode_weight",null,null,null,false],[391,63,0,null,null,null,null,false],[0,0,0,"attributes",null,null,null,false],[391,63,0,null,null,null,null,false],[0,0,0,"glyph_col_1",null,null,null,false],[391,63,0,null,null,null,null,false],[0,0,0,"glyph_col_2",null,null,null,false],[391,63,0,null,null,null,null,false],[0,0,0,"_pad",null,null,null,false],[391,71,0,null,null,null,[46187,46188,46189,46191,46192,46194],false],[391,71,0,null,null,null,null,false],[0,0,0,"header",null,null,null,false],[0,0,0,"hdr_size",null,null,null,false],[0,0,0,"string_info_offset",null,null,null,false],[391,71,0,null,null,null,null,false],[0,0,0,"language_window",null,null,null,false],[0,0,0,"language_name",null,null,null,false],[391,71,0,null,null,null,null,false],[0,0,0,"language",null,null,null,false],[365,8,0,null,null," Status codes returned by EFI interfaces",null,false],[0,0,0,"uefi/status.zig",null,"",[],false],[392,0,0,null,null,null,null,false],[392,2,0,null,null,null,null,false],[392,4,0,null,null,null,[46203,46204,46205,46206,46207,46208,46209,46210,46211,46212,46213,46214,46215,46216,46217,46218,46219,46220,46221,46222,46223,46224,46225,46226,46227,46228,46229,46230,46231,46232,46233,46234,46235,46236,46237,46238,46239,46240,46241,46242,46243,46244,46245,46246,46247,46248,46249,46250],false],[392,144,0,null,null,null,null,false],[392,187,0,null,null,null,[46202],false],[0,0,0,"self",null,"",null,false],[0,0,0,"Success",null," The operation completed successfully.",null,false],[0,0,0,"LoadError",null," The image failed to load.",null,false],[0,0,0,"InvalidParameter",null," A parameter was incorrect.",null,false],[0,0,0,"Unsupported",null," The operation is not supported.",null,false],[0,0,0,"BadBufferSize",null," The buffer was not the proper size for the request.",null,false],[0,0,0,"BufferTooSmall",null," The buffer is not large enough to hold the requested data. The required buffer size is returned in the appropriate parameter when this error occurs.",null,false],[0,0,0,"NotReady",null," There is no data pending upon return.",null,false],[0,0,0,"DeviceError",null," The physical device reported an error while attempting the operation.",null,false],[0,0,0,"WriteProtected",null," The device cannot be written to.",null,false],[0,0,0,"OutOfResources",null," A resource has run out.",null,false],[0,0,0,"VolumeCorrupted",null," An inconstancy was detected on the file system causing the operating to fail.",null,false],[0,0,0,"VolumeFull",null," There is no more space on the file system.",null,false],[0,0,0,"NoMedia",null," The device does not contain any medium to perform the operation.",null,false],[0,0,0,"MediaChanged",null," The medium in the device has changed since the last access.",null,false],[0,0,0,"NotFound",null," The item was not found.",null,false],[0,0,0,"AccessDenied",null," Access was denied.",null,false],[0,0,0,"NoResponse",null," The server was not found or did not respond to the request.",null,false],[0,0,0,"NoMapping",null," A mapping to a device does not exist.",null,false],[0,0,0,"Timeout",null," The timeout time expired.",null,false],[0,0,0,"NotStarted",null," The protocol has not been started.",null,false],[0,0,0,"AlreadyStarted",null," The protocol has already been started.",null,false],[0,0,0,"Aborted",null," The operation was aborted.",null,false],[0,0,0,"IcmpError",null," An ICMP error occurred during the network operation.",null,false],[0,0,0,"TftpError",null," A TFTP error occurred during the network operation.",null,false],[0,0,0,"ProtocolError",null," A protocol error occurred during the network operation.",null,false],[0,0,0,"IncompatibleVersion",null," The function encountered an internal version that was incompatible with a version requested by the caller.",null,false],[0,0,0,"SecurityViolation",null," The function was not performed due to a security violation.",null,false],[0,0,0,"CrcError",null," A CRC error was detected.",null,false],[0,0,0,"EndOfMedia",null," Beginning or end of media was reached",null,false],[0,0,0,"EndOfFile",null," The end of the file was reached.",null,false],[0,0,0,"InvalidLanguage",null," The language specified was invalid.",null,false],[0,0,0,"CompromisedData",null," The security status of the data is unknown or compromised and the data must be updated or replaced to restore a valid security status.",null,false],[0,0,0,"IpAddressConflict",null," There is an address conflict address allocation",null,false],[0,0,0,"HttpError",null," A HTTP error occurred during the network operation.",null,false],[0,0,0,"NetworkUnreachable",null,null,null,false],[0,0,0,"HostUnreachable",null,null,null,false],[0,0,0,"ProtocolUnreachable",null,null,null,false],[0,0,0,"PortUnreachable",null,null,null,false],[0,0,0,"ConnectionFin",null,null,null,false],[0,0,0,"ConnectionReset",null,null,null,false],[0,0,0,"ConnectionRefused",null,null,null,false],[0,0,0,"WarnUnknownGlyph",null," The string contained one or more characters that the device could not render and were skipped.",null,false],[0,0,0,"WarnDeleteFailure",null," The handle was closed, but the file was not deleted.",null,false],[0,0,0,"WarnWriteFailure",null," The handle was closed, but the data to the file was not flushed properly.",null,false],[0,0,0,"WarnBufferTooSmall",null," The resulting buffer was too small, and the data was truncated to the buffer size.",null,false],[0,0,0,"WarnStaleData",null," The data has not been updated within the timeframe set by localpolicy for this type of data.",null,false],[0,0,0,"WarnFileSystem",null," The resulting buffer contains UEFI-compliant file system.",null,false],[0,0,0,"WarnResetRequired",null," The operation will be processed across a system reset.",null,false],[365,9,0,null,null,null,null,false],[0,0,0,"uefi/tables.zig",null,"",[],false],[393,0,0,null,null,null,null,false],[0,0,0,"tables/boot_services.zig",null,"",[],false],[394,0,0,null,null,null,null,false],[394,1,0,null,null,null,null,false],[394,2,0,null,null,null,null,false],[394,3,0,null,null,null,null,false],[394,4,0,null,null,null,null,false],[394,5,0,null,null,null,null,false],[394,6,0,null,null,null,null,false],[394,7,0,null,null,null,null,false],[394,8,0,null,null,null,null,false],[394,21,0,null,null," Boot services are services provided by the system's firmware until the operating system takes\n over control over the hardware by calling exitBootServices.\n\n Boot Services must not be used after exitBootServices has been called. The only exception is\n getMemoryMap, which may be used after the first unsuccessful call to exitBootServices.\n After successfully calling exitBootServices, system_table.console_in_handle, system_table.con_in,\n system_table.console_out_handle, system_table.con_out, system_table.standard_error_handle,\n system_table.std_err, and system_table.boot_services should be set to null. After setting these\n attributes to null, system_table.hdr.crc32 must be recomputed.\n\n As the boot_services table may grow with new UEFI versions, it is important to check hdr.header_size.",[46281,46284,46287,46293,46297,46304,46309,46312,46321,46326,46331,46334,46337,46340,46346,46352,46357,46362,46364,46369,46376,46381,46385,46393,46398,46404,46407,46411,46414,46417,46423,46429,46434,46442,46448,46454,46459,46466,46471,46474,46477,46482,46487,46492,46500],false],[394,161,0,null,null," Opens a protocol with a structure as the loaded image for a UEFI application",[46266,46267,46268],false],[0,0,0,"self",null,"",null,false],[0,0,0,"protocol",null,"",null,true],[0,0,0,"handle",null,"",null,false],[394,181,0,null,null,null,null,false],[394,183,0,null,null,null,null,false],[394,184,0,null,null,null,null,false],[394,185,0,null,null,null,null,false],[394,186,0,null,null,null,null,false],[394,187,0,null,null,null,null,false],[394,188,0,null,null,null,null,false],[394,190,0,null,null,null,null,false],[394,191,0,null,null,null,null,false],[394,192,0,null,null,null,null,false],[394,193,0,null,null,null,null,false],[394,21,0,null,null,null,null,false],[0,0,0,"hdr",null,null,null,false],[394,21,0,null,null,null,[46283],false],[0,0,0,"new_tpl",null,"",null,false],[0,0,0,"raiseTpl",null," Raises a task's priority level and returns its previous level.",null,false],[394,21,0,null,null,null,[46286],false],[0,0,0,"old_tpl",null,"",null,false],[0,0,0,"restoreTpl",null," Restores a task's priority level to its previous value.",null,false],[394,21,0,null,null,null,[46289,46290,46291,46292],false],[0,0,0,"alloc_type",null,"",null,false],[0,0,0,"mem_type",null,"",null,false],[0,0,0,"pages",null,"",null,false],[0,0,0,"memory",null,"",null,false],[0,0,0,"allocatePages",null," Allocates memory pages from the system.",null,false],[394,21,0,null,null,null,[46295,46296],false],[0,0,0,"memory",null,"",null,false],[0,0,0,"pages",null,"",null,false],[0,0,0,"freePages",null," Frees memory pages.",null,false],[394,21,0,null,null,null,[46299,46300,46301,46302,46303],false],[0,0,0,"mmap_size",null,"",null,false],[0,0,0,"mmap",null,"",null,false],[0,0,0,"mapKey",null,"",null,false],[0,0,0,"descriptor_size",null,"",null,false],[0,0,0,"descriptor_version",null,"",null,false],[0,0,0,"getMemoryMap",null," Returns the current memory map.",null,false],[394,21,0,null,null,null,[46306,46307,46308],false],[0,0,0,"pool_type",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"allocatePool",null," Allocates pool memory.",null,false],[394,21,0,null,null,null,[46311],false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"freePool",null," Returns pool memory to the system.",null,false],[394,21,0,null,null,null,[46314,46315,46316,46319,46320],false],[0,0,0,"type",null,"",null,false],[0,0,0,"notify_tpl",null,"",null,false],[0,0,0,"notify_func",null,"",[46317,46318],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"notifyCtx",null,"",null,false],[0,0,0,"event",null,"",null,false],[0,0,0,"createEvent",null," Creates an event.",null,false],[394,21,0,null,null,null,[46323,46324,46325],false],[0,0,0,"event",null,"",null,false],[0,0,0,"type",null,"",null,false],[0,0,0,"triggerTime",null,"",null,false],[0,0,0,"setTimer",null," Sets the type of timer and the trigger time for a timer event.",null,false],[394,21,0,null,null,null,[46328,46329,46330],false],[0,0,0,"event_len",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"waitForEvent",null," Stops execution until an event is signaled.",null,false],[394,21,0,null,null,null,[46333],false],[0,0,0,"event",null,"",null,false],[0,0,0,"signalEvent",null," Signals an event.",null,false],[394,21,0,null,null,null,[46336],false],[0,0,0,"event",null,"",null,false],[0,0,0,"closeEvent",null," Closes an event.",null,false],[394,21,0,null,null,null,[46339],false],[0,0,0,"event",null,"",null,false],[0,0,0,"checkEvent",null," Checks whether an event is in the signaled state.",null,false],[394,21,0,null,null,null,[46342,46343,46344,46345],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"interface_type",null,"",null,false],[0,0,0,"interface",null,"",null,false],[0,0,0,"installProtocolInterface",null," Installs a protocol interface on a device handle. If the handle does not exist, it is created\n and added to the list of handles in the system. installMultipleProtocolInterfaces()\n performs more error checking than installProtocolInterface(), so its use is recommended over this.",null,false],[394,21,0,null,null,null,[46348,46349,46350,46351],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"old_interface",null,"",null,false],[0,0,0,"new_interface",null,"",null,false],[0,0,0,"reinstallProtocolInterface",null," Reinstalls a protocol interface on a device handle",null,false],[394,21,0,null,null,null,[46354,46355,46356],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"interface",null,"",null,false],[0,0,0,"uninstallProtocolInterface",null," Removes a protocol interface from a device handle. Usage of\n uninstallMultipleProtocolInterfaces is recommended over this.",null,false],[394,21,0,null,null,null,[46359,46360,46361],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"interface",null,"",null,false],[0,0,0,"handleProtocol",null," Queries a handle to determine if it supports a specified protocol.",null,false],[394,21,0,null,null,null,null,false],[0,0,0,"reserved",null,null,null,false],[394,21,0,null,null,null,[46366,46367,46368],false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"event",null,"",null,false],[0,0,0,"registration",null,"",null,false],[0,0,0,"registerProtocolNotify",null," Creates an event that is to be signaled whenever an interface is installed for a specified protocol.",null,false],[394,21,0,null,null,null,[46371,46372,46373,46374,46375],false],[0,0,0,"search_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"search_key",null,"",null,false],[0,0,0,"bufferSize",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"locateHandle",null," Returns an array of handles that support a specified protocol.",null,false],[394,21,0,null,null,null,[46378,46379,46380],false],[0,0,0,"protocols",null,"",null,false],[0,0,0,"device_path",null,"",null,false],[0,0,0,"device",null,"",null,false],[0,0,0,"locateDevicePath",null," Locates the handle to a device on the device path that supports the specified protocol",null,false],[394,21,0,null,null,null,[46383,46384],false],[0,0,0,"guid",null,"",null,false],[0,0,0,"table",null,"",null,false],[0,0,0,"installConfigurationTable",null," Adds, updates, or removes a configuration table entry from the EFI System Table.",null,false],[394,21,0,null,null,null,[46387,46388,46389,46390,46391,46392],false],[0,0,0,"boot_policy",null,"",null,false],[0,0,0,"parent_image_handle",null,"",null,false],[0,0,0,"device_path",null,"",null,false],[0,0,0,"source_buffer",null,"",null,false],[0,0,0,"source_size",null,"",null,false],[0,0,0,"imageHandle",null,"",null,false],[0,0,0,"loadImage",null," Loads an EFI image into memory.",null,false],[394,21,0,null,null,null,[46395,46396,46397],false],[0,0,0,"image_handle",null,"",null,false],[0,0,0,"exit_data_size",null,"",null,false],[0,0,0,"exit_data",null,"",null,false],[0,0,0,"startImage",null," Transfers control to a loaded image's entry point.",null,false],[394,21,0,null,null,null,[46400,46401,46402,46403],false],[0,0,0,"image_handle",null,"",null,false],[0,0,0,"exit_status",null,"",null,false],[0,0,0,"exit_data_size",null,"",null,false],[0,0,0,"exit_data",null,"",null,false],[0,0,0,"exit",null," Terminates a loaded EFI image and returns control to boot services.",null,false],[394,21,0,null,null,null,[46406],false],[0,0,0,"image_handle",null,"",null,false],[0,0,0,"unloadImage",null," Unloads an image.",null,false],[394,21,0,null,null,null,[46409,46410],false],[0,0,0,"image_handle",null,"",null,false],[0,0,0,"map_key",null,"",null,false],[0,0,0,"exitBootServices",null," Terminates all boot services.",null,false],[394,21,0,null,null,null,[46413],false],[0,0,0,"count",null,"",null,false],[0,0,0,"getNextMonotonicCount",null," Returns a monotonically increasing count for the platform.",null,false],[394,21,0,null,null,null,[46416],false],[0,0,0,"microseconds",null,"",null,false],[0,0,0,"stall",null," Induces a fine-grained stall.",null,false],[394,21,0,null,null,null,[46419,46420,46421,46422],false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"watchdogCode",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"watchdog_data",null,"",null,false],[0,0,0,"setWatchdogTimer",null," Sets the system's watchdog timer.",null,false],[394,21,0,null,null,null,[46425,46426,46427,46428],false],[0,0,0,"controller_handle",null,"",null,false],[0,0,0,"driver_image_handle",null,"",null,false],[0,0,0,"remaining_device_path",null,"",null,false],[0,0,0,"recursive",null,"",null,false],[0,0,0,"connectController",null," Connects one or more drives to a controller.",null,false],[394,21,0,null,null,null,[46431,46432,46433],false],[0,0,0,"controller_handle",null,"",null,false],[0,0,0,"driver_image_handle",null,"",null,false],[0,0,0,"child_handle",null,"",null,false],[0,0,0,"disconnectController",null,null,null,false],[394,21,0,null,null,null,[46436,46437,46438,46439,46440,46441],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"interface",null,"",null,false],[0,0,0,"agent_handle",null,"",null,false],[0,0,0,"controller_handle",null,"",null,false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"openProtocol",null," Queries a handle to determine if it supports a specified protocol.",null,false],[394,21,0,null,null,null,[46444,46445,46446,46447],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"agentHandle",null,"",null,false],[0,0,0,"controller_handle",null,"",null,false],[0,0,0,"closeProtocol",null," Closes a protocol on a handle that was opened using openProtocol().",null,false],[394,21,0,null,null,null,[46450,46451,46452,46453],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"entry_buffer",null,"",null,false],[0,0,0,"entry_count",null,"",null,false],[0,0,0,"openProtocolInformation",null," Retrieves the list of agents that currently have a protocol interface opened.",null,false],[394,21,0,null,null,null,[46456,46457,46458],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"protocol_buffer",null,"",null,false],[0,0,0,"protocol_buffer_count",null,"",null,false],[0,0,0,"protocolsPerHandle",null," Retrieves the list of protocol interface GUIDs that are installed on a handle in a buffer allocated from pool.",null,false],[394,21,0,null,null,null,[46461,46462,46463,46464,46465],false],[0,0,0,"search_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"search_key",null,"",null,false],[0,0,0,"num_handles",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"locateHandleBuffer",null," Returns an array of handles that support the requested protocol in a buffer allocated from pool.",null,false],[394,21,0,null,null,null,[46468,46469,46470],false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"registration",null,"",null,false],[0,0,0,"interface",null,"",null,false],[0,0,0,"locateProtocol",null," Returns the first protocol instance that matches the given protocol.",null,false],[394,21,0,null,null,null,[46473],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"installMultipleProtocolInterfaces",null," Installs one or more protocol interfaces into the boot services environment",null,false],[394,21,0,null,null,null,[46476],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"uninstallMultipleProtocolInterfaces",null," Removes one or more protocol interfaces into the boot services environment",null,false],[394,21,0,null,null,null,[46479,46480,46481],false],[0,0,0,"data",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"calculateCrc32",null," Computes and returns a 32-bit CRC for a data buffer.",null,false],[394,21,0,null,null,null,[46484,46485,46486],false],[0,0,0,"dest",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"copyMem",null," Copies the contents of one buffer to another buffer",null,false],[394,21,0,null,null,null,[46489,46490,46491],false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"setMem",null," Fills a buffer with a specified value",null,false],[394,21,0,null,null,null,[46494,46495,46496,46497,46498,46499],false],[0,0,0,"type",null,"",null,false],[0,0,0,"notify_tpl",null,"",null,false],[0,0,0,"notify_func",null,"",null,false],[0,0,0,"notify_ctx",null,"",null,false],[0,0,0,"event_group",null,"",null,false],[0,0,0,"event",null,"",null,false],[0,0,0,"createEventEx",null," Creates an event in a group.",null,false],[394,196,0,null,null,null,[46502,46503],false],[0,0,0,"event",null,"",null,false],[0,0,0,"ctx",null,"",null,false],[394,198,0,null,null,null,[46505,46506,46507],false],[0,0,0,"TimerCancel",null,null,null,false],[0,0,0,"TimerPeriodic",null,null,null,false],[0,0,0,"TimerRelative",null,null,null,false],[394,204,0,null,null,null,[46509,46510,46511,46512,46513,46514,46515,46516,46517,46518,46519,46520,46521,46522,46523,46524],false],[0,0,0,"ReservedMemoryType",null,null,null,false],[0,0,0,"LoaderCode",null,null,null,false],[0,0,0,"LoaderData",null,null,null,false],[0,0,0,"BootServicesCode",null,null,null,false],[0,0,0,"BootServicesData",null,null,null,false],[0,0,0,"RuntimeServicesCode",null,null,null,false],[0,0,0,"RuntimeServicesData",null,null,null,false],[0,0,0,"ConventionalMemory",null,null,null,false],[0,0,0,"UnusableMemory",null,null,null,false],[0,0,0,"ACPIReclaimMemory",null,null,null,false],[0,0,0,"ACPIMemoryNVS",null,null,null,false],[0,0,0,"MemoryMappedIO",null,null,null,false],[0,0,0,"MemoryMappedIOPortSpace",null,null,null,false],[0,0,0,"PalCode",null,null,null,false],[0,0,0,"PersistentMemory",null,null,null,false],[0,0,0,"MaxMemoryType",null,null,null,false],[394,224,0,null,null,null,[46526,46527,46528,46529,46530,46532,46533,46534,46535,46536,46537,46538,46539,46540,46542,46543],false],[0,0,0,"uc",null,null,null,false],[0,0,0,"wc",null,null,null,false],[0,0,0,"wt",null,null,null,false],[0,0,0,"wb",null,null,null,false],[0,0,0,"uce",null,null,null,false],[394,224,0,null,null,null,null,false],[0,0,0,"_pad1",null,null,null,false],[0,0,0,"wp",null,null,null,false],[0,0,0,"rp",null,null,null,false],[0,0,0,"xp",null,null,null,false],[0,0,0,"nv",null,null,null,false],[0,0,0,"more_reliable",null,null,null,false],[0,0,0,"ro",null,null,null,false],[0,0,0,"sp",null,null,null,false],[0,0,0,"cpu_crypto",null,null,null,false],[394,224,0,null,null,null,null,false],[0,0,0,"_pad2",null,null,null,false],[0,0,0,"memory_runtime",null,null,null,false],[394,243,0,null,null,null,[46546,46547,46548,46549,46551],false],[394,243,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[0,0,0,"physical_start",null,null,null,false],[0,0,0,"virtual_start",null,null,null,false],[0,0,0,"number_of_pages",null,null,null,false],[394,243,0,null,null,null,null,false],[0,0,0,"attribute",null,null,null,false],[394,251,0,null,null,null,[46553,46554,46555],false],[0,0,0,"AllHandles",null,null,null,false],[0,0,0,"ByRegisterNotify",null,null,null,false],[0,0,0,"ByProtocol",null,null,null,false],[394,257,0,null,null,null,[46557,46558,46559,46560,46561,46562,46564],false],[0,0,0,"by_handle_protocol",null,null,null,false],[0,0,0,"get_protocol",null,null,null,false],[0,0,0,"test_protocol",null,null,null,false],[0,0,0,"by_child_controller",null,null,null,false],[0,0,0,"by_driver",null,null,null,false],[0,0,0,"exclusive",null,null,null,false],[394,257,0,null,null,null,null,false],[0,0,0,"reserved",null,null,null,false],[394,267,0,null,null,null,[46567,46569,46571,46572],false],[394,267,0,null,null,null,null,false],[0,0,0,"agent_handle",null,null,null,false],[394,267,0,null,null,null,null,false],[0,0,0,"controller_handle",null,null,null,false],[394,267,0,null,null,null,null,false],[0,0,0,"attributes",null,null,null,false],[0,0,0,"open_count",null,null,null,false],[394,274,0,null,null,null,[46574],false],[0,0,0,"EfiNativeInterface",null,null,null,false],[394,278,0,null,null,null,[46576,46577,46578],false],[0,0,0,"AllocateAnyPages",null,null,null,false],[0,0,0,"AllocateMaxAddress",null,null,null,false],[0,0,0,"AllocateAddress",null,null,null,false],[393,1,0,null,null,null,null,false],[0,0,0,"tables/runtime_services.zig",null,"",[],false],[395,0,0,null,null,null,null,false],[395,1,0,null,null,null,null,false],[395,2,0,null,null,null,null,false],[395,3,0,null,null,null,null,false],[395,4,0,null,null,null,null,false],[395,5,0,null,null,null,null,false],[395,6,0,null,null,null,null,false],[395,7,0,null,null,null,null,false],[395,8,0,null,null,null,null,false],[395,18,0,null,null," Runtime services are provided by the firmware before and after exitBootServices has been called.\n\n As the runtime_services table may grow with new UEFI versions, it is important to check hdr.header_size.\n\n Some functions may not be supported. Check the RuntimeServicesSupported variable using getVariable.\n getVariable is one of the functions that may not be supported.\n\n Some functions may not be called while other functions are running.",[46593,46597,46600,46605,46609,46615,46619,46626,46631,46638,46641,46647,46652,46658,46664],false],[395,67,0,null,null,null,null,false],[395,18,0,null,null,null,null,false],[0,0,0,"hdr",null,null,null,false],[395,18,0,null,null,null,[46595,46596],false],[0,0,0,"time",null,"",null,false],[0,0,0,"capabilities",null,"",null,false],[0,0,0,"getTime",null," Returns the current time and date information, and the time-keeping capabilities of the hardware platform.",null,false],[395,18,0,null,null,null,[46599],false],[0,0,0,"time",null,"",null,false],[0,0,0,"setTime",null," Sets the current local time and date information",null,false],[395,18,0,null,null,null,[46602,46603,46604],false],[0,0,0,"enabled",null,"",null,false],[0,0,0,"pending",null,"",null,false],[0,0,0,"time",null,"",null,false],[0,0,0,"getWakeupTime",null," Returns the current wakeup alarm clock setting",null,false],[395,18,0,null,null,null,[46607,46608],false],[0,0,0,"enable",null,"",null,false],[0,0,0,"time",null,"",null,false],[0,0,0,"setWakeupTime",null," Sets the system wakeup alarm clock time",null,false],[395,18,0,null,null,null,[46611,46612,46613,46614],false],[0,0,0,"mmap_size",null,"",null,false],[0,0,0,"descriptor_size",null,"",null,false],[0,0,0,"descriptor_version",null,"",null,false],[0,0,0,"virtual_map",null,"",null,false],[0,0,0,"setVirtualAddressMap",null," Changes the runtime addressing mode of EFI firmware from physical to virtual.",null,false],[395,18,0,null,null,null,[46617,46618],false],[0,0,0,"debug_disposition",null,"",null,false],[0,0,0,"address",null,"",null,false],[0,0,0,"convertPointer",null," Determines the new virtual address that is to be used on subsequent memory accesses.",null,false],[395,18,0,null,null,null,[46621,46622,46623,46624,46625],false],[0,0,0,"var_name",null,"",null,false],[0,0,0,"vendor_guid",null,"",null,false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"getVariable",null," Returns the value of a variable.",null,false],[395,18,0,null,null,null,[46628,46629,46630],false],[0,0,0,"var_name_size",null,"",null,false],[0,0,0,"var_name",null,"",null,false],[0,0,0,"vendor_guid",null,"",null,false],[0,0,0,"getNextVariableName",null," Enumerates the current variable names.",null,false],[395,18,0,null,null,null,[46633,46634,46635,46636,46637],false],[0,0,0,"var_name",null,"",null,false],[0,0,0,"vendor_guid",null,"",null,false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"setVariable",null," Sets the value of a variable.",null,false],[395,18,0,null,null,null,[46640],false],[0,0,0,"high_count",null,"",null,false],[0,0,0,"getNextHighMonotonicCount",null," Return the next high 32 bits of the platform's monotonic counter",null,false],[395,18,0,null,null,null,[46643,46644,46645,46646],false],[0,0,0,"reset_type",null,"",null,false],[0,0,0,"reset_status",null,"",null,false],[0,0,0,"data_size",null,"",null,false],[0,0,0,"reset_data",null,"",null,false],[0,0,0,"resetSystem",null," Resets the entire platform.",null,false],[395,18,0,null,null,null,[46649,46650,46651],false],[0,0,0,"capsule_header_array",null,"",null,false],[0,0,0,"capsule_count",null,"",null,false],[0,0,0,"scatter_gather_list",null,"",null,false],[0,0,0,"updateCapsule",null," Passes capsules to the firmware with both virtual and physical mapping.\n Depending on the intended consumption, the firmware may process the capsule immediately.\n If the payload should persist across a system reset, the reset value returned from\n `queryCapsuleCapabilities` must be passed into resetSystem and will cause the capsule\n to be processed by the firmware as part of the reset process.",null,false],[395,18,0,null,null,null,[46654,46655,46656,46657],false],[0,0,0,"capsule_header_array",null,"",null,false],[0,0,0,"capsule_count",null,"",null,false],[0,0,0,"maximum_capsule_size",null,"",null,false],[0,0,0,"resetType",null,"",null,false],[0,0,0,"queryCapsuleCapabilities",null," Returns if the capsule can be supported via `updateCapsule`",null,false],[395,18,0,null,null,null,[46660,46661,46662,46663],false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"maximum_variable_storage_size",null,"",null,false],[0,0,0,"remaining_variable_storage_size",null,"",null,false],[0,0,0,"maximum_variable_size",null,"",null,false],[0,0,0,"queryVariableInfo",null," Returns information about the EFI variables",null,false],[395,70,0,null,null,null,null,false],[395,72,0,null,null,null,[46668,46669,46670,46671],false],[395,72,0,null,null,null,null,false],[0,0,0,"capsuleGuid",null,null,null,false],[0,0,0,"headerSize",null,null,null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"capsuleImageSize",null,null,null,false],[395,79,0,null,null,null,[46673,46677],false],[0,0,0,"length",null,null,null,false],[395,79,0,null,null,null,[46675,46676],false],[0,0,0,"dataBlock",null,null,null,false],[0,0,0,"continuationPointer",null,null,null,false],[0,0,0,"address",null,null,null,false],[395,87,0,null,null,null,[46679,46680,46681,46682],false],[0,0,0,"ResetCold",null,null,null,false],[0,0,0,"ResetWarm",null,null,null,false],[0,0,0,"ResetShutdown",null,null,null,false],[0,0,0,"ResetPlatformSpecific",null,null,null,false],[395,94,0,null,null,null,null,false],[393,2,0,null,null,null,null,false],[0,0,0,"tables/configuration_table.zig",null,"",[],false],[396,0,0,null,null,null,null,false],[396,1,0,null,null,null,null,false],[396,3,0,null,null,null,[46699,46701],false],[396,7,0,null,null,null,null,false],[396,15,0,null,null,null,null,false],[396,23,0,null,null,null,null,false],[396,31,0,null,null,null,null,false],[396,39,0,null,null,null,null,false],[396,47,0,null,null,null,null,false],[396,55,0,null,null,null,null,false],[396,63,0,null,null,null,null,false],[396,71,0,null,null,null,null,false],[396,3,0,null,null,null,null,false],[0,0,0,"vendor_guid",null,null,null,false],[396,3,0,null,null,null,null,false],[0,0,0,"vendor_table",null,null,null,false],[393,3,0,null,null,null,null,false],[0,0,0,"tables/system_table.zig",null,"",[],false],[397,0,0,null,null,null,null,false],[397,1,0,null,null,null,null,false],[397,2,0,null,null,null,null,false],[397,3,0,null,null,null,null,false],[397,4,0,null,null,null,null,false],[397,5,0,null,null,null,null,false],[397,6,0,null,null,null,null,false],[397,7,0,null,null,null,null,false],[397,17,0,null,null," The EFI System Table contains pointers to the runtime and boot services tables.\n\n As the system_table may grow with new UEFI versions, it is important to check hdr.header_size.\n\n After successfully calling boot_services.exitBootServices, console_in_handle,\n con_in, console_out_handle, con_out, standard_error_handle, std_err, and\n boot_services should be set to null. After setting these attributes to null,\n hdr.crc32 must be recomputed.",[46727,46729,46730,46732,46734,46736,46738,46740,46742,46744,46746,46747,46749],false],[397,34,0,null,null,null,null,false],[397,35,0,null,null,null,null,false],[397,36,0,null,null,null,null,false],[397,37,0,null,null,null,null,false],[397,38,0,null,null,null,null,false],[397,39,0,null,null,null,null,false],[397,40,0,null,null,null,null,false],[397,41,0,null,null,null,null,false],[397,42,0,null,null,null,null,false],[397,43,0,null,null,null,null,false],[397,44,0,null,null,null,null,false],[397,45,0,null,null,null,null,false],[397,46,0,null,null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"hdr",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"firmware_vendor",null," A null-terminated string that identifies the vendor that produces the system firmware of the platform.",null,false],[0,0,0,"firmware_revision",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"console_in_handle",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"con_in",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"console_out_handle",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"con_out",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"standard_error_handle",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"std_err",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"runtime_services",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"boot_services",null,null,null,false],[0,0,0,"number_of_table_entries",null,null,null,false],[397,17,0,null,null,null,null,false],[0,0,0,"configuration_table",null,null,null,false],[393,4,0,null,null,null,null,false],[0,0,0,"tables/table_header.zig",null,"",[],false],[398,0,0,null,null,null,[46753,46754,46755,46756,46757],false],[0,0,0,"signature",null,null,null,false],[0,0,0,"revision",null,null,null,false],[0,0,0,"header_size",null," The size, in bytes, of the entire table including the TableHeader",null,false],[0,0,0,"crc32",null,null,null,false],[0,0,0,"reserved",null,null,null,false],[365,14,0,null,null," The memory type to allocate when using the pool\n Defaults to .LoaderData, the default data allocation type\n used by UEFI applications to allocate pool memory.",null,false],[365,15,0,null,null,null,null,false],[0,0,0,"uefi/pool_allocator.zig",null,"",[],false],[399,0,0,null,null,null,null,false],[399,2,0,null,null,null,null,false],[399,3,0,null,null,null,null,false],[399,5,0,null,null,null,null,false],[399,7,0,null,null,null,null,false],[399,9,0,null,null,null,[],false],[399,10,0,null,null,null,[46768],false],[0,0,0,"ptr",null,"",null,false],[399,14,0,null,null,null,[46770,46771,46772,46773],false],[0,0,0,"",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[399,42,0,null,null,null,[46775,46776,46777,46778,46779],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_old_ptr_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[399,58,0,null,null,null,[46781,46782,46783,46784],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_old_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[399,72,0,null,null," Supports the full Allocator interface, including alignment.\n For a direct call of `allocatePool`, see `raw_pool_allocator`.",null,false],[399,77,0,null,null,null,null,false],[399,84,0,null,null," Asserts allocations are 8 byte aligned and calls `boot_services.allocatePool`.",null,false],[399,89,0,null,null,null,null,false],[399,95,0,null,null,null,[46790,46791,46792,46793],false],[0,0,0,"",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[399,111,0,null,null,null,[46795,46796,46797,46798,46799],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_old_ptr_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[399,129,0,null,null,null,[46801,46802,46803,46804],false],[0,0,0,"",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"log2_old_ptr_align",null,"",null,false],[0,0,0,"ret_addr",null,"",null,false],[365,16,0,null,null,null,null,false],[365,19,0,null,null," The EFI image's handle that is passed to its entry point.",null,false],[365,22,0,null,null," A pointer to the EFI System Table that is passed to the EFI image's entry point.",null,false],[365,25,0,null,null," A handle to an event structure.",null,false],[365,28,0,null,null," The calling convention used for all external functions part of the UEFI API.",null,false],[365,33,0,null,null,null,[46812],false],[365,33,0,null,null,null,null,false],[0,0,0,"address",null,null,null,false],[365,37,0,null,null,null,[46815],false],[365,37,0,null,null,null,null,false],[0,0,0,"address",null,null,null,false],[365,41,0,null,null,null,[46818],false],[365,41,0,null,null,null,null,false],[0,0,0,"address",null,null,null,false],[365,46,0,null,null," GUIDs are align(8) unless otherwise specified.",[46828,46829,46830,46831,46832,46834],false],[365,55,0,null,null," Format GUID into hexadecimal lowercase xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx format",[46821,46822,46823,46824],false],[0,0,0,"self",null,"",null,false],[0,0,0,"f",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[365,82,0,null,null,null,[46826,46827],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"time_low",null,null,null,false],[0,0,0,"time_mid",null,null,null,false],[0,0,0,"time_high_and_version",null,null,null,false],[0,0,0,"clock_seq_high_and_reserved",null,null,null,false],[0,0,0,"clock_seq_low",null,null,null,false],[365,46,0,null,null,null,null,false],[0,0,0,"node",null,null,null,false],[365,93,0,null,null," An EFI Handle represents a collection of related interfaces.",null,false],[365,96,0,null,null," This structure represents time information.",[46838,46839,46840,46841,46842,46843,46844,46845,46851],false],[365,132,0,null,null," Time is to be interpreted as local time",null,false],[0,0,0,"year",null," 1900 - 9999",null,false],[0,0,0,"month",null," 1 - 12",null,false],[0,0,0,"day",null," 1 - 31",null,false],[0,0,0,"hour",null," 0 - 23",null,false],[0,0,0,"minute",null," 0 - 59",null,false],[0,0,0,"second",null," 0 - 59",null,false],[0,0,0,"nanosecond",null," 0 - 999999999",null,false],[0,0,0,"timezone",null," The time's offset in minutes from UTC.\n Allowed values are -1440 to 1440 or unspecified_timezone",null,false],[365,96,0,null,null,null,[46848,46849,46850],false],[365,121,0,null,null,null,null,false],[0,0,0,"_pad1",null,null,null,false],[0,0,0,"in_daylight",null," If true, the time has been adjusted for daylight savings time.",null,false],[0,0,0,"adjust_daylight",null," If true, the time is affected by daylight savings time.",null,false],[0,0,0,"daylight",null,null,null,false],[365,136,0,null,null," Capabilities of the clock device",[46853,46854,46855],false],[0,0,0,"resolution",null," Resolution in Hz",null,false],[0,0,0,"accuracy",null," Accuracy in an error rate of 1e-6 parts per million.",null,false],[0,0,0,"sets_to_zero",null," If true, a time set operation clears the device's time below the resolution level.",null,false],[365,148,0,null,null," File Handle as specified in the EFI Shell Spec",null,false],[365,161,0,null,null,null,[46868,46869,46870,46872,46874,46876,46877],false],[365,170,0,null,null,null,[46859],false],[0,0,0,"self",null,"",null,false],[365,174,0,null,null,null,null,false],[365,175,0,null,null,null,null,false],[365,176,0,null,null,null,null,false],[365,177,0,null,null,null,null,false],[365,178,0,null,null,null,null,false],[365,179,0,null,null,null,null,false],[365,180,0,null,null,null,null,false],[365,182,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"file_size",null,null,null,false],[0,0,0,"physical_size",null,null,null,false],[365,161,0,null,null,null,null,false],[0,0,0,"create_time",null,null,null,false],[365,161,0,null,null,null,null,false],[0,0,0,"last_access_time",null,null,null,false],[365,161,0,null,null,null,null,false],[0,0,0,"modification_time",null,null,null,false],[0,0,0,"attribute",null,null,null,false],[365,192,0,null,null,null,[46882,46883,46884,46885,46886,46887],false],[365,200,0,null,null,null,[46880],false],[0,0,0,"self",null,"",null,false],[365,204,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"read_only",null,null,null,false],[0,0,0,"volume_size",null,null,null,false],[0,0,0,"free_space",null,null,null,false],[0,0,0,"block_size",null,null,null,false],[0,0,0,"_volume_label",null,null,null,false],[350,38,0,null,null,null,null,false],[0,0,0,"os/wasi.zig",null,"",[],false],[400,3,0,null,null,null,null,false],[400,4,0,null,null,null,null,false],[400,5,0,null,null,null,null,false],[400,18,0,null,null,null,null,false],[400,19,0,null,null,null,null,false],[400,20,0,null,null,null,null,false],[400,21,0,null,null,null,null,false],[400,23,0,null,null,null,null,false],[400,24,0,null,null,null,null,false],[400,26,0,null,null,null,[46900,46901],false],[0,0,0,"argv",null,"",null,false],[0,0,0,"argv_buf",null,"",null,false],[400,27,0,null,null,null,[46903,46904],false],[0,0,0,"argc",null,"",null,false],[0,0,0,"argv_buf_size",null,"",null,false],[400,29,0,null,null,null,[46906,46907],false],[0,0,0,"clock_id",null,"",null,false],[0,0,0,"resolution",null,"",null,false],[400,30,0,null,null,null,[46909,46910,46911],false],[0,0,0,"clock_id",null,"",null,false],[0,0,0,"precision",null,"",null,false],[0,0,0,"timestamp",null,"",null,false],[400,32,0,null,null,null,[46913,46914],false],[0,0,0,"environ",null,"",null,false],[0,0,0,"environ_buf",null,"",null,false],[400,33,0,null,null,null,[46916,46917],false],[0,0,0,"environ_count",null,"",null,false],[0,0,0,"environ_buf_size",null,"",null,false],[400,35,0,null,null,null,[46919,46920,46921,46922],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"advice",null,"",null,false],[400,36,0,null,null,null,[46924,46925,46926],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"len",null,"",null,false],[400,37,0,null,null,null,[46928],false],[0,0,0,"fd",null,"",null,false],[400,38,0,null,null,null,[46930],false],[0,0,0,"fd",null,"",null,false],[400,39,0,null,null,null,[46932,46933,46934,46935,46936],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovs",null,"",null,false],[0,0,0,"iovs_len",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"nread",null,"",null,false],[400,40,0,null,null,null,[46938,46939,46940,46941,46942],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovs",null,"",null,false],[0,0,0,"iovs_len",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"nwritten",null,"",null,false],[400,41,0,null,null,null,[46944,46945,46946,46947],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovs",null,"",null,false],[0,0,0,"iovs_len",null,"",null,false],[0,0,0,"nread",null,"",null,false],[400,42,0,null,null,null,[46949,46950,46951,46952,46953],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buf_len",null,"",null,false],[0,0,0,"cookie",null,"",null,false],[0,0,0,"bufused",null,"",null,false],[400,43,0,null,null,null,[46955,46956],false],[0,0,0,"from",null,"",null,false],[0,0,0,"to",null,"",null,false],[400,44,0,null,null,null,[46958,46959,46960,46961],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"whence",null,"",null,false],[0,0,0,"newoffset",null,"",null,false],[400,45,0,null,null,null,[46963],false],[0,0,0,"fd",null,"",null,false],[400,46,0,null,null,null,[46965,46966],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"newoffset",null,"",null,false],[400,47,0,null,null,null,[46968,46969,46970,46971],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iovs",null,"",null,false],[0,0,0,"iovs_len",null,"",null,false],[0,0,0,"nwritten",null,"",null,false],[400,49,0,null,null,null,[46973,46974],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[400,50,0,null,null,null,[46976,46977],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[400,51,0,null,null,null,[46979,46980,46981],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"fs_rights_base",null,"",null,false],[0,0,0,"fs_rights_inheriting",null,"",null,false],[400,53,0,null,null,null,[46983,46984],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[400,54,0,null,null,null,[46986,46987],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"st_size",null,"",null,false],[400,55,0,null,null,null,[46989,46990,46991,46992],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"st_atim",null,"",null,false],[0,0,0,"st_mtim",null,"",null,false],[0,0,0,"fstflags",null,"",null,false],[400,57,0,null,null,null,[46994,46995],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[400,58,0,null,null,null,[46997,46998,46999],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[400,60,0,null,null,null,[47001,47002,47003],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[400,61,0,null,null,null,[47005,47006,47007,47008,47009],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[0,0,0,"buf",null,"",null,false],[400,62,0,null,null,null,[47011,47012,47013,47014,47015,47016,47017],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[0,0,0,"st_atim",null,"",null,false],[0,0,0,"st_mtim",null,"",null,false],[0,0,0,"fstflags",null,"",null,false],[400,63,0,null,null,null,[47019,47020,47021,47022,47023,47024,47025],false],[0,0,0,"old_fd",null,"",null,false],[0,0,0,"old_flags",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"old_path_len",null,"",null,false],[0,0,0,"new_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"new_path_len",null,"",null,false],[400,64,0,null,null,null,[47027,47028,47029,47030,47031,47032,47033,47034,47035],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"dirflags",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[0,0,0,"oflags",null,"",null,false],[0,0,0,"fs_rights_base",null,"",null,false],[0,0,0,"fs_rights_inheriting",null,"",null,false],[0,0,0,"fs_flags",null,"",null,false],[0,0,0,"fd",null,"",null,false],[400,65,0,null,null,null,[47037,47038,47039,47040,47041,47042],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buf_len",null,"",null,false],[0,0,0,"bufused",null,"",null,false],[400,66,0,null,null,null,[47044,47045,47046],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[400,67,0,null,null,null,[47048,47049,47050,47051,47052,47053],false],[0,0,0,"old_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"old_path_len",null,"",null,false],[0,0,0,"new_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"new_path_len",null,"",null,false],[400,68,0,null,null,null,[47055,47056,47057,47058,47059],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"old_path_len",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"new_path_len",null,"",null,false],[400,69,0,null,null,null,[47061,47062,47063],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"path_len",null,"",null,false],[400,71,0,null,null,null,[47065,47066,47067,47068],false],[0,0,0,"in",null,"",null,false],[0,0,0,"out",null,"",null,false],[0,0,0,"nsubscriptions",null,"",null,false],[0,0,0,"nevents",null,"",null,false],[400,73,0,null,null,null,[47070],false],[0,0,0,"rval",null,"",null,false],[400,75,0,null,null,null,[47072,47073],false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buf_len",null,"",null,false],[400,77,0,null,null,null,[],false],[400,79,0,null,null,null,[47076,47077,47078],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"result_fd",null,"",null,false],[400,80,0,null,null,null,[47080,47081,47082,47083,47084,47085],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"ri_data",null,"",null,false],[0,0,0,"ri_data_len",null,"",null,false],[0,0,0,"ri_flags",null,"",null,false],[0,0,0,"ro_datalen",null,"",null,false],[0,0,0,"ro_flags",null,"",null,false],[400,81,0,null,null,null,[47087,47088,47089,47090,47091],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"si_data",null,"",null,false],[0,0,0,"si_data_len",null,"",null,false],[0,0,0,"si_flags",null,"",null,false],[0,0,0,"so_datalen",null,"",null,false],[400,82,0,null,null,null,[47093,47094],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"how",null,"",null,false],[400,85,0,null,null," Get the errno from a syscall return value, or 0 for no error.",[47096],false],[0,0,0,"r",null,"",null,false],[400,89,0,null,null,null,null,false],[400,90,0,null,null,null,null,false],[400,91,0,null,null,null,null,false],[400,93,0,null,null,null,null,false],[400,95,0,null,null,null,null,false],[400,97,0,null,null,null,[47108,47109],false],[400,101,0,null,null,null,[47104],false],[0,0,0,"tm",null,"",null,false],[400,110,0,null,null,null,[47106],false],[0,0,0,"ts",null,"",null,false],[400,97,0,null,null,null,null,false],[0,0,0,"tv_sec",null,null,null,false],[0,0,0,"tv_nsec",null,null,null,false],[400,116,0,null,null,null,[47121,47123,47125,47127,47129,47131,47133,47135,47137],false],[400,127,0,null,null,null,null,false],[400,129,0,null,null,null,[47113],false],[0,0,0,"stat",null,"",null,false],[400,143,0,null,null,null,[47115],false],[0,0,0,"self",null,"",null,false],[400,147,0,null,null,null,[47117],false],[0,0,0,"self",null,"",null,false],[400,151,0,null,null,null,[47119],false],[0,0,0,"self",null,"",null,false],[400,116,0,null,null,null,null,false],[0,0,0,"dev",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"ino",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"mode",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"filetype",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"nlink",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"atim",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"mtim",null,null,null,false],[400,116,0,null,null,null,null,false],[0,0,0,"ctim",null,null,null,false],[400,156,0,null,null,null,null,false],[400,158,0,null,null,null,[],false],[400,159,0,null,null,null,null,false],[400,165,0,null,null," When linking libc, we follow their convention and use -2 for current working directory.\n However, without libc, Zig does a different convention: it assumes the\n current working directory is the first preopen. This behavior can be\n overridden with a public function called `wasi_cwd` in the root source\n file.",null,false],[400,170,0,null,null,null,null,false],[400,171,0,null,null,null,null,false],[400,172,0,null,null,null,null,false],[400,173,0,null,null,null,null,false],[400,174,0,null,null,null,null,false],[400,175,0,null,null,null,null,false],[400,176,0,null,null,null,null,false],[400,178,0,null,null,null,null,false],[400,179,0,null,null,null,[],false],[400,180,0,null,null,null,null,false],[400,181,0,null,null,null,null,false],[400,182,0,null,null,null,null,false],[400,183,0,null,null,null,null,false],[400,186,0,null,null,null,null,false],[400,188,0,null,null,null,null,false],[400,189,0,null,null,null,null,false],[400,191,0,null,null,null,null,false],[400,193,0,null,null,null,[47161,47163,47165,47167],false],[400,193,0,null,null,null,null,false],[0,0,0,"d_next",null,null,null,false],[400,193,0,null,null,null,null,false],[0,0,0,"d_ino",null,null,null,false],[400,193,0,null,null,null,null,false],[0,0,0,"d_namlen",null,null,null,false],[400,193,0,null,null,null,null,false],[0,0,0,"d_type",null,null,null,false],[400,200,0,null,null,null,[47169,47170,47171,47172,47173,47174,47175,47176,47177,47178,47179,47180,47181,47182,47183,47184,47185,47186,47187,47188,47189,47190,47191,47192,47193,47194,47195,47196,47197,47198,47199,47200,47201,47202,47203,47204,47205,47206,47207,47208,47209,47210,47211,47212,47213,47214,47215,47216,47217,47218,47219,47220,47221,47222,47223,47224,47225,47226,47227,47228,47229,47230,47231,47232,47233,47234,47235,47236,47237,47238,47239,47240,47241,47242,47243,47244,47245],false],[0,0,0,"SUCCESS",null,null,null,false],[0,0,0,"2BIG",null,null,null,false],[0,0,0,"ACCES",null,null,null,false],[0,0,0,"ADDRINUSE",null,null,null,false],[0,0,0,"ADDRNOTAVAIL",null,null,null,false],[0,0,0,"AFNOSUPPORT",null,null,null,false],[0,0,0,"AGAIN",null," This is also the error code used for `WOULDBLOCK`.",null,false],[0,0,0,"ALREADY",null,null,null,false],[0,0,0,"BADF",null,null,null,false],[0,0,0,"BADMSG",null,null,null,false],[0,0,0,"BUSY",null,null,null,false],[0,0,0,"CANCELED",null,null,null,false],[0,0,0,"CHILD",null,null,null,false],[0,0,0,"CONNABORTED",null,null,null,false],[0,0,0,"CONNREFUSED",null,null,null,false],[0,0,0,"CONNRESET",null,null,null,false],[0,0,0,"DEADLK",null,null,null,false],[0,0,0,"DESTADDRREQ",null,null,null,false],[0,0,0,"DOM",null,null,null,false],[0,0,0,"DQUOT",null,null,null,false],[0,0,0,"EXIST",null,null,null,false],[0,0,0,"FAULT",null,null,null,false],[0,0,0,"FBIG",null,null,null,false],[0,0,0,"HOSTUNREACH",null,null,null,false],[0,0,0,"IDRM",null,null,null,false],[0,0,0,"ILSEQ",null,null,null,false],[0,0,0,"INPROGRESS",null,null,null,false],[0,0,0,"INTR",null,null,null,false],[0,0,0,"INVAL",null,null,null,false],[0,0,0,"IO",null,null,null,false],[0,0,0,"ISCONN",null,null,null,false],[0,0,0,"ISDIR",null,null,null,false],[0,0,0,"LOOP",null,null,null,false],[0,0,0,"MFILE",null,null,null,false],[0,0,0,"MLINK",null,null,null,false],[0,0,0,"MSGSIZE",null,null,null,false],[0,0,0,"MULTIHOP",null,null,null,false],[0,0,0,"NAMETOOLONG",null,null,null,false],[0,0,0,"NETDOWN",null,null,null,false],[0,0,0,"NETRESET",null,null,null,false],[0,0,0,"NETUNREACH",null,null,null,false],[0,0,0,"NFILE",null,null,null,false],[0,0,0,"NOBUFS",null,null,null,false],[0,0,0,"NODEV",null,null,null,false],[0,0,0,"NOENT",null,null,null,false],[0,0,0,"NOEXEC",null,null,null,false],[0,0,0,"NOLCK",null,null,null,false],[0,0,0,"NOLINK",null,null,null,false],[0,0,0,"NOMEM",null,null,null,false],[0,0,0,"NOMSG",null,null,null,false],[0,0,0,"NOPROTOOPT",null,null,null,false],[0,0,0,"NOSPC",null,null,null,false],[0,0,0,"NOSYS",null,null,null,false],[0,0,0,"NOTCONN",null,null,null,false],[0,0,0,"NOTDIR",null,null,null,false],[0,0,0,"NOTEMPTY",null,null,null,false],[0,0,0,"NOTRECOVERABLE",null,null,null,false],[0,0,0,"NOTSOCK",null,null,null,false],[0,0,0,"OPNOTSUPP",null," This is also the code used for `NOTSUP`.",null,false],[0,0,0,"NOTTY",null,null,null,false],[0,0,0,"NXIO",null,null,null,false],[0,0,0,"OVERFLOW",null,null,null,false],[0,0,0,"OWNERDEAD",null,null,null,false],[0,0,0,"PERM",null,null,null,false],[0,0,0,"PIPE",null,null,null,false],[0,0,0,"PROTO",null,null,null,false],[0,0,0,"PROTONOSUPPORT",null,null,null,false],[0,0,0,"PROTOTYPE",null,null,null,false],[0,0,0,"RANGE",null,null,null,false],[0,0,0,"ROFS",null,null,null,false],[0,0,0,"SPIPE",null,null,null,false],[0,0,0,"SRCH",null,null,null,false],[0,0,0,"STALE",null,null,null,false],[0,0,0,"TIMEDOUT",null,null,null,false],[0,0,0,"TXTBSY",null,null,null,false],[0,0,0,"XDEV",null,null,null,false],[0,0,0,"NOTCAPABLE",null,null,null,false],[400,282,0,null,null,null,null,false],[400,284,0,null,null,null,[47249,47251,47253,47255],false],[400,284,0,null,null,null,null,false],[0,0,0,"userdata",null,null,null,false],[400,284,0,null,null,null,null,false],[0,0,0,"error",null,null,null,false],[400,284,0,null,null,null,null,false],[0,0,0,"type",null,null,null,false],[400,284,0,null,null,null,null,false],[0,0,0,"fd_readwrite",null,null,null,false],[400,291,0,null,null,null,[47258,47260],false],[400,291,0,null,null,null,null,false],[0,0,0,"nbytes",null,null,null,false],[400,291,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[400,296,0,null,null,null,null,false],[400,297,0,null,null,null,null,false],[400,299,0,null,null,null,null,false],[400,300,0,null,null,null,null,false],[400,301,0,null,null,null,null,false],[400,302,0,null,null,null,null,false],[400,304,0,null,null,null,null,false],[400,306,0,null,null,null,null,false],[400,308,0,null,null,null,null,false],[400,309,0,null,null,null,[],false],[400,310,0,null,null,null,null,false],[400,311,0,null,null,null,null,false],[400,312,0,null,null,null,null,false],[400,313,0,null,null,null,null,false],[400,314,0,null,null,null,null,false],[400,317,0,null,null,null,[47278,47280,47282,47284],false],[400,317,0,null,null,null,null,false],[0,0,0,"fs_filetype",null,null,null,false],[400,317,0,null,null,null,null,false],[0,0,0,"fs_flags",null,null,null,false],[400,317,0,null,null,null,null,false],[0,0,0,"fs_rights_base",null,null,null,false],[400,317,0,null,null,null,null,false],[0,0,0,"fs_rights_inheriting",null,null,null,false],[400,324,0,null,null,null,null,false],[400,326,0,null,null,null,null,false],[400,328,0,null,null,null,[47295,47297,47299,47301,47303,47305,47307,47309],false],[400,338,0,null,null,null,[47289],false],[0,0,0,"self",null,"",null,false],[400,342,0,null,null,null,[47291],false],[0,0,0,"self",null,"",null,false],[400,346,0,null,null,null,[47293],false],[0,0,0,"self",null,"",null,false],[400,328,0,null,null,null,null,false],[0,0,0,"dev",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"ino",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"filetype",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"nlink",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"atim",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"mtim",null,null,null,false],[400,328,0,null,null,null,null,false],[0,0,0,"ctim",null,null,null,false],[400,352,0,null,null," Also known as `FILETYPE`.",[47311,47312,47313,47314,47315,47316,47317,47318],false],[0,0,0,"UNKNOWN",null,null,null,false],[0,0,0,"BLOCK_DEVICE",null,null,null,false],[0,0,0,"CHARACTER_DEVICE",null,null,null,false],[0,0,0,"DIRECTORY",null,null,null,false],[0,0,0,"REGULAR_FILE",null,null,null,false],[0,0,0,"SOCKET_DGRAM",null,null,null,false],[0,0,0,"SOCKET_STREAM",null,null,null,false],[0,0,0,"SYMBOLIC_LINK",null,null,null,false],[400,364,0,null,null,null,null,false],[400,365,0,null,null,null,null,false],[400,366,0,null,null,null,null,false],[400,367,0,null,null,null,null,false],[400,368,0,null,null,null,null,false],[400,370,0,null,null,null,null,false],[400,371,0,null,null,null,null,false],[400,373,0,null,null,null,null,false],[400,375,0,null,null,null,null,false],[400,376,0,null,null,null,null,false],[400,378,0,null,null,null,null,false],[400,379,0,null,null,null,[],false],[400,380,0,null,null,null,null,false],[400,381,0,null,null,null,null,false],[400,382,0,null,null,null,null,false],[400,383,0,null,null,null,null,false],[400,386,0,null,null,null,null,false],[400,387,0,null,null,null,null,false],[400,389,0,null,null,null,[47339,47341],false],[400,389,0,null,null,null,null,false],[0,0,0,"pr_type",null,null,null,false],[400,389,0,null,null,null,null,false],[0,0,0,"u",null,null,null,false],[400,394,0,null,null,null,[47343],false],[0,0,0,"pr_name_len",null,null,null,false],[400,398,0,null,null,null,[47345],false],[0,0,0,"dir",null,null,null,false],[400,402,0,null,null,null,null,false],[400,403,0,null,null,null,null,false],[400,405,0,null,null,null,[],false],[400,406,0,null,null,null,null,false],[400,407,0,null,null,null,null,false],[400,409,0,null,null,null,null,false],[400,412,0,null,null,null,null,false],[400,413,0,null,null,null,[],false],[400,414,0,null,null,null,null,false],[400,415,0,null,null,null,null,false],[400,416,0,null,null,null,null,false],[400,417,0,null,null,null,null,false],[400,418,0,null,null,null,null,false],[400,419,0,null,null,null,null,false],[400,420,0,null,null,null,null,false],[400,421,0,null,null,null,null,false],[400,422,0,null,null,null,null,false],[400,423,0,null,null,null,null,false],[400,424,0,null,null,null,null,false],[400,425,0,null,null,null,null,false],[400,426,0,null,null,null,null,false],[400,427,0,null,null,null,null,false],[400,428,0,null,null,null,null,false],[400,429,0,null,null,null,null,false],[400,430,0,null,null,null,null,false],[400,431,0,null,null,null,null,false],[400,432,0,null,null,null,null,false],[400,433,0,null,null,null,null,false],[400,434,0,null,null,null,null,false],[400,435,0,null,null,null,null,false],[400,436,0,null,null,null,null,false],[400,437,0,null,null,null,null,false],[400,438,0,null,null,null,null,false],[400,439,0,null,null,null,null,false],[400,440,0,null,null,null,null,false],[400,441,0,null,null,null,null,false],[400,442,0,null,null,null,null,false],[400,443,0,null,null,null,null,false],[400,444,0,null,null,null,null,false],[400,476,0,null,null,null,null,false],[400,477,0,null,null,null,[],false],[400,478,0,null,null,null,null,false],[400,479,0,null,null,null,null,false],[400,482,0,null,null,null,null,false],[400,484,0,null,null,null,null,false],[400,485,0,null,null,null,null,false],[400,486,0,null,null,null,null,false],[400,487,0,null,null,null,null,false],[400,488,0,null,null,null,null,false],[400,489,0,null,null,null,null,false],[400,490,0,null,null,null,null,false],[400,491,0,null,null,null,null,false],[400,492,0,null,null,null,null,false],[400,493,0,null,null,null,null,false],[400,494,0,null,null,null,null,false],[400,495,0,null,null,null,null,false],[400,496,0,null,null,null,null,false],[400,497,0,null,null,null,null,false],[400,498,0,null,null,null,null,false],[400,499,0,null,null,null,null,false],[400,500,0,null,null,null,null,false],[400,501,0,null,null,null,null,false],[400,502,0,null,null,null,null,false],[400,503,0,null,null,null,null,false],[400,504,0,null,null,null,null,false],[400,505,0,null,null,null,null,false],[400,506,0,null,null,null,null,false],[400,507,0,null,null,null,null,false],[400,508,0,null,null,null,null,false],[400,509,0,null,null,null,null,false],[400,510,0,null,null,null,null,false],[400,511,0,null,null,null,null,false],[400,512,0,null,null,null,null,false],[400,513,0,null,null,null,null,false],[400,514,0,null,null,null,null,false],[400,515,0,null,null,null,null,false],[400,517,0,null,null,null,null,false],[400,518,0,null,null,null,null,false],[400,520,0,null,null,null,[47426,47428],false],[400,520,0,null,null,null,null,false],[0,0,0,"userdata",null,null,null,false],[400,520,0,null,null,null,null,false],[0,0,0,"u",null,null,null,false],[400,525,0,null,null,null,[47431,47433,47435,47437],false],[400,525,0,null,null,null,null,false],[0,0,0,"id",null,null,null,false],[400,525,0,null,null,null,null,false],[0,0,0,"timeout",null,null,null,false],[400,525,0,null,null,null,null,false],[0,0,0,"precision",null,null,null,false],[400,525,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[400,532,0,null,null,null,[47440],false],[400,532,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[400,536,0,null,null,null,[47443,47445],false],[400,536,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[400,536,0,null,null,null,null,false],[0,0,0,"u",null,null,null,false],[400,541,0,null,null,null,[47447,47448,47449],false],[0,0,0,"clock",null,null,null,false],[0,0,0,"fd_read",null,null,null,false],[0,0,0,"fd_write",null,null,null,false],[400,547,0,null,null,null,null,false],[400,549,0,null,null,null,null,false],[400,552,0,null,null," Also known as `WHENCE`.",[47453,47454,47455],false],[0,0,0,"SET",null,null,null,false],[0,0,0,"CUR",null,null,null,false],[0,0,0,"END",null,null,null,false],[400,554,0,null,null,null,[],false],[400,555,0,null,null,null,null,false],[400,556,0,null,null,null,null,false],[400,557,0,null,null,null,null,false],[400,558,0,null,null,null,null,false],[400,559,0,null,null,null,null,false],[400,560,0,null,null,null,null,false],[400,561,0,null,null,null,null,false],[400,562,0,null,null,null,null,false],[400,564,0,null,null,null,null,false],[400,567,0,null,null,null,[],false],[400,568,0,null,null,null,null,false],[400,569,0,null,null,null,null,false],[400,570,0,null,null,null,null,false],[400,571,0,null,null,null,null,false],[350,39,0,null,null,null,null,false],[0,0,0,"os/windows.zig",null," This file contains thin wrappers around Windows-specific APIs, with these\n specific goals in mind:\n * Convert \"errno\"-style error codes into Zig errors.\n * When null-terminated or UTF16LE byte buffers are required, provide APIs which accept\n   slices as well as APIs which accept null-terminated UTF16LE byte buffers.\n",[],false],[401,3802,0,null,null,null,null,false],[401,6,0,null,null,null,null,false],[401,7,0,null,null,null,null,false],[401,8,0,null,null,null,null,false],[401,9,0,null,null,null,null,false],[401,10,0,null,null,null,null,false],[401,11,0,null,null,null,null,false],[401,12,0,null,null,null,null,false],[401,20,0,null,null,null,null,false],[0,0,0,"windows/advapi32.zig",null,"",[],false],[402,0,0,null,null,null,null,false],[402,1,0,null,null,null,null,false],[402,2,0,null,null,null,null,false],[402,3,0,null,null,null,null,false],[402,4,0,null,null,null,null,false],[402,5,0,null,null,null,null,false],[402,6,0,null,null,null,null,false],[402,7,0,null,null,null,null,false],[402,8,0,null,null,null,null,false],[402,9,0,null,null,null,null,false],[402,10,0,null,null,null,null,false],[402,12,0,null,null,null,[47495,47496,47497,47498,47499],false],[0,0,0,"hKey",null,"",null,false],[0,0,0,"lpSubKey",null,"",null,false],[0,0,0,"ulOptions",null,"",null,false],[0,0,0,"samDesired",null,"",null,false],[0,0,0,"phkResult",null,"",null,false],[402,20,0,null,null,null,[47501,47502,47503,47504,47505,47506],false],[0,0,0,"hKey",null,"",null,false],[0,0,0,"lpValueName",null,"",null,false],[0,0,0,"lpReserved",null,"",null,false],[0,0,0,"lpType",null,"",null,false],[0,0,0,"lpData",null,"",null,false],[0,0,0,"lpcbData",null,"",null,false],[402,29,0,null,null,null,[47508],false],[0,0,0,"hKey",null,"",null,false],[402,33,0,null,null,null,[47510,47511],false],[0,0,0,"output",null,"",null,false],[0,0,0,"length",null,"",null,false],[402,34,0,null,null,null,null,false],[402,36,0,null,null,null,[],false],[402,37,0,null,null,null,null,false],[402,39,0,null,null,null,null,false],[402,40,0,null,null,null,null,false],[402,42,0,null,null,null,null,false],[402,43,0,null,null,null,null,false],[402,44,0,null,null,null,null,false],[402,45,0,null,null,null,null,false],[402,46,0,null,null,null,null,false],[402,47,0,null,null,null,null,false],[402,48,0,null,null,null,null,false],[402,50,0,null,null,null,null,false],[402,51,0,null,null,null,null,false],[402,52,0,null,null,null,null,false],[402,53,0,null,null,null,null,false],[402,56,0,null,null,null,[47529,47530,47531,47532,47533,47534,47535],false],[0,0,0,"hkey",null,"",null,false],[0,0,0,"lpSubKey",null,"",null,false],[0,0,0,"lpValue",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"pdwType",null,"",null,false],[0,0,0,"pvData",null,"",null,false],[0,0,0,"pcbData",null,"",null,false],[402,66,0,null,null,null,[47537,47538,47539,47540,47541],false],[0,0,0,"lpFile",null,"",null,false],[0,0,0,"phkResult",null,"",null,false],[0,0,0,"samDesired",null,"",null,false],[0,0,0,"dwOptions",null,"",null,false],[0,0,0,"reserved",null,"",null,false],[401,21,0,null,null,null,null,false],[0,0,0,"windows/kernel32.zig",null,"",[],false],[403,0,0,null,null,null,null,false],[403,1,0,null,null,null,null,false],[403,3,0,null,null,null,null,false],[403,4,0,null,null,null,null,false],[403,5,0,null,null,null,null,false],[403,6,0,null,null,null,null,false],[403,7,0,null,null,null,null,false],[403,8,0,null,null,null,null,false],[403,9,0,null,null,null,null,false],[403,10,0,null,null,null,null,false],[403,11,0,null,null,null,null,false],[403,12,0,null,null,null,null,false],[403,13,0,null,null,null,null,false],[403,14,0,null,null,null,null,false],[403,15,0,null,null,null,null,false],[403,16,0,null,null,null,null,false],[403,17,0,null,null,null,null,false],[403,18,0,null,null,null,null,false],[403,19,0,null,null,null,null,false],[403,20,0,null,null,null,null,false],[403,21,0,null,null,null,null,false],[403,22,0,null,null,null,null,false],[403,23,0,null,null,null,null,false],[403,24,0,null,null,null,null,false],[403,25,0,null,null,null,null,false],[403,26,0,null,null,null,null,false],[403,27,0,null,null,null,null,false],[403,28,0,null,null,null,null,false],[403,29,0,null,null,null,null,false],[403,30,0,null,null,null,null,false],[403,31,0,null,null,null,null,false],[403,32,0,null,null,null,null,false],[403,33,0,null,null,null,null,false],[403,34,0,null,null,null,null,false],[403,35,0,null,null,null,null,false],[403,36,0,null,null,null,null,false],[403,37,0,null,null,null,null,false],[403,38,0,null,null,null,null,false],[403,39,0,null,null,null,null,false],[403,40,0,null,null,null,null,false],[403,41,0,null,null,null,null,false],[403,42,0,null,null,null,null,false],[403,43,0,null,null,null,null,false],[403,44,0,null,null,null,null,false],[403,45,0,null,null,null,null,false],[403,46,0,null,null,null,null,false],[403,47,0,null,null,null,null,false],[403,48,0,null,null,null,null,false],[403,49,0,null,null,null,null,false],[403,50,0,null,null,null,null,false],[403,51,0,null,null,null,null,false],[403,52,0,null,null,null,null,false],[403,53,0,null,null,null,null,false],[403,54,0,null,null,null,null,false],[403,55,0,null,null,null,null,false],[403,56,0,null,null,null,null,false],[403,57,0,null,null,null,null,false],[403,58,0,null,null,null,null,false],[403,59,0,null,null,null,null,false],[403,60,0,null,null,null,null,false],[403,61,0,null,null,null,null,false],[403,62,0,null,null,null,null,false],[403,63,0,null,null,null,null,false],[403,64,0,null,null,null,null,false],[403,65,0,null,null,null,null,false],[403,66,0,null,null,null,null,false],[403,67,0,null,null,null,null,false],[403,68,0,null,null,null,null,false],[403,69,0,null,null,null,null,false],[403,71,0,null,null,null,[47614,47615],false],[0,0,0,"First",null,"",null,false],[0,0,0,"Handler",null,"",null,false],[403,72,0,null,null,null,[47617],false],[0,0,0,"Handle",null,"",null,false],[403,74,0,null,null,null,[47619],false],[0,0,0,"hFile",null,"",null,false],[403,75,0,null,null,null,[47621,47622],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[403,77,0,null,null,null,[47624],false],[0,0,0,"hObject",null,"",null,false],[403,79,0,null,null,null,[47626,47627],false],[0,0,0,"lpPathName",null,"",null,false],[0,0,0,"lpSecurityAttributes",null,"",null,false],[403,80,0,null,null,null,[47629],false],[0,0,0,"hFile",null,"",null,false],[403,82,0,null,null,null,[47631,47632,47633,47634],false],[0,0,0,"lpEventAttributes",null,"",null,false],[0,0,0,"lpName",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"dwDesiredAccess",null,"",null,false],[403,89,0,null,null,null,[47636,47637,47638,47639,47640,47641,47642],false],[0,0,0,"lpFileName",null,"",null,false],[0,0,0,"dwDesiredAccess",null,"",null,false],[0,0,0,"dwShareMode",null,"",null,false],[0,0,0,"lpSecurityAttributes",null,"",null,false],[0,0,0,"dwCreationDisposition",null,"",null,false],[0,0,0,"dwFlagsAndAttributes",null,"",null,false],[0,0,0,"hTemplateFile",null,"",null,false],[403,99,0,null,null,null,[47644,47645,47646,47647],false],[0,0,0,"hReadPipe",null,"",null,false],[0,0,0,"hWritePipe",null,"",null,false],[0,0,0,"lpPipeAttributes",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,106,0,null,null,null,[47649,47650,47651,47652,47653,47654,47655,47656],false],[0,0,0,"lpName",null,"",null,false],[0,0,0,"dwOpenMode",null,"",null,false],[0,0,0,"dwPipeMode",null,"",null,false],[0,0,0,"nMaxInstances",null,"",null,false],[0,0,0,"nOutBufferSize",null,"",null,false],[0,0,0,"nInBufferSize",null,"",null,false],[0,0,0,"nDefaultTimeOut",null,"",null,false],[0,0,0,"lpSecurityAttributes",null,"",null,false],[403,117,0,null,null,null,[47658,47659,47660,47661,47662,47663,47664,47665,47666,47667],false],[0,0,0,"lpApplicationName",null,"",null,false],[0,0,0,"lpCommandLine",null,"",null,false],[0,0,0,"lpProcessAttributes",null,"",null,false],[0,0,0,"lpThreadAttributes",null,"",null,false],[0,0,0,"bInheritHandles",null,"",null,false],[0,0,0,"dwCreationFlags",null,"",null,false],[0,0,0,"lpEnvironment",null,"",null,false],[0,0,0,"lpCurrentDirectory",null,"",null,false],[0,0,0,"lpStartupInfo",null,"",null,false],[0,0,0,"lpProcessInformation",null,"",null,false],[403,130,0,null,null,null,[47669,47670,47671],false],[0,0,0,"lpSymlinkFileName",null,"",null,false],[0,0,0,"lpTargetFileName",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[403,132,0,null,null,null,[47673,47674,47675,47676],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"ExistingCompletionPort",null,"",null,false],[0,0,0,"CompletionKey",null,"",null,false],[0,0,0,"NumberOfConcurrentThreads",null,"",null,false],[403,134,0,null,null,null,[47678,47679,47680,47681,47682,47683],false],[0,0,0,"lpThreadAttributes",null,"",null,false],[0,0,0,"dwStackSize",null,"",null,false],[0,0,0,"lpStartAddress",null,"",null,false],[0,0,0,"lpParameter",null,"",null,false],[0,0,0,"dwCreationFlags",null,"",null,false],[0,0,0,"lpThreadId",null,"",null,false],[403,136,0,null,null,null,[47685,47686],false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"th32ProcessID",null,"",null,false],[403,138,0,null,null,null,[47688,47689,47690,47691,47692,47693,47694,47695],false],[0,0,0,"h",null,"",null,false],[0,0,0,"dwIoControlCode",null,"",null,false],[0,0,0,"lpInBuffer",null,"",null,false],[0,0,0,"nInBufferSize",null,"",null,false],[0,0,0,"lpOutBuffer",null,"",null,false],[0,0,0,"nOutBufferSize",null,"",null,false],[0,0,0,"lpBytesReturned",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[403,149,0,null,null,null,[47697],false],[0,0,0,"lpFileName",null,"",null,false],[403,151,0,null,null,null,[47699,47700,47701,47702,47703,47704,47705],false],[0,0,0,"hSourceProcessHandle",null,"",null,false],[0,0,0,"hSourceHandle",null,"",null,false],[0,0,0,"hTargetProcessHandle",null,"",null,false],[0,0,0,"lpTargetHandle",null,"",null,false],[0,0,0,"dwDesiredAccess",null,"",null,false],[0,0,0,"bInheritHandle",null,"",null,false],[0,0,0,"dwOptions",null,"",null,false],[403,153,0,null,null,null,[47707],false],[0,0,0,"exit_code",null,"",null,false],[403,155,0,null,null,null,[47709,47710],false],[0,0,0,"lpFileName",null,"",null,false],[0,0,0,"lpFindFileData",null,"",null,false],[403,156,0,null,null,null,[47712],false],[0,0,0,"hFindFile",null,"",null,false],[403,157,0,null,null,null,[47714,47715],false],[0,0,0,"hFindFile",null,"",null,false],[0,0,0,"lpFindFileData",null,"",null,false],[403,159,0,null,null,null,[47717,47718,47719,47720,47721,47722,47723],false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpSource",null,"",null,false],[0,0,0,"dwMessageId",null,"",null,false],[0,0,0,"dwLanguageId",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[0,0,0,"Arguments",null,"",null,false],[403,161,0,null,null,null,[47725],false],[0,0,0,"penv",null,"",null,false],[403,163,0,null,null,null,[],false],[403,164,0,null,null,null,[],false],[403,166,0,null,null,null,[47729,47730],false],[0,0,0,"in_hConsoleHandle",null,"",null,false],[0,0,0,"out_lpMode",null,"",null,false],[403,168,0,null,null,null,[],false],[403,170,0,null,null,null,[47733,47734],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"lpConsoleScreenBufferInfo",null,"",null,false],[403,171,0,null,null,null,[47736,47737,47738,47739,47740],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"cCharacter",null,"",null,false],[0,0,0,"nLength",null,"",null,false],[0,0,0,"dwWriteCoord",null,"",null,false],[0,0,0,"lpNumberOfCharsWritten",null,"",null,false],[403,172,0,null,null,null,[47742,47743,47744,47745,47746],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"cCharacter",null,"",null,false],[0,0,0,"nLength",null,"",null,false],[0,0,0,"dwWriteCoord",null,"",null,false],[0,0,0,"lpNumberOfCharsWritten",null,"",null,false],[403,173,0,null,null,null,[47748,47749,47750,47751,47752],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"wAttribute",null,"",null,false],[0,0,0,"nLength",null,"",null,false],[0,0,0,"dwWriteCoord",null,"",null,false],[0,0,0,"lpNumberOfAttrsWritten",null,"",null,false],[403,174,0,null,null,null,[47754,47755],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"dwCursorPosition",null,"",null,false],[403,176,0,null,null,null,[47757,47758],false],[0,0,0,"nBufferLength",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[403,178,0,null,null,null,[],false],[403,179,0,null,null,null,[],false],[403,181,0,null,null,null,[],false],[403,183,0,null,null,null,[],false],[403,185,0,null,null,null,[],false],[403,187,0,null,null,null,[47765,47766,47767],false],[0,0,0,"lpName",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,189,0,null,null,null,[47769,47770],false],[0,0,0,"lpName",null,"",null,false],[0,0,0,"lpValue",null,"",null,false],[403,191,0,null,null,null,[47772,47773],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpExitCode",null,"",null,false],[403,193,0,null,null,null,[47775,47776],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpFileSize",null,"",null,false],[403,195,0,null,null,null,[47778],false],[0,0,0,"lpFileName",null,"",null,false],[403,197,0,null,null,null,[47780,47781,47782],false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,199,0,null,null,null,[47784],false],[0,0,0,"lpModuleName",null,"",null,false],[403,201,0,null,null,null,[],false],[403,202,0,null,null,null,[47787],false],[0,0,0,"dwErrCode",null,"",null,false],[403,204,0,null,null,null,[47789,47790,47791,47792],false],[0,0,0,"in_hFile",null,"",null,false],[0,0,0,"in_FileInformationClass",null,"",null,false],[0,0,0,"out_lpFileInformation",null,"",null,false],[0,0,0,"in_dwBufferSize",null,"",null,false],[403,211,0,null,null,null,[47794,47795,47796,47797],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpszFilePath",null,"",null,false],[0,0,0,"cchFilePath",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[403,218,0,null,null,null,[47799,47800,47801,47802],false],[0,0,0,"lpFileName",null,"",null,false],[0,0,0,"nBufferLength",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"lpFilePart",null,"",null,false],[403,225,0,null,null,null,[47804,47805,47806,47807],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpNumberOfBytesTransferred",null,"",null,false],[0,0,0,"bWait",null,"",null,false],[403,227,0,null,null,null,[],false],[403,229,0,null,null,null,[47810,47811,47812,47813,47814],false],[0,0,0,"in_hProcess",null,"",null,false],[0,0,0,"out_lpCreationTime",null,"",null,false],[0,0,0,"out_lpExitTime",null,"",null,false],[0,0,0,"out_lpKernelTime",null,"",null,false],[0,0,0,"out_lpUserTime",null,"",null,false],[403,231,0,null,null,null,[47816,47817,47818,47819,47820],false],[0,0,0,"CompletionPort",null,"",null,false],[0,0,0,"lpNumberOfBytesTransferred",null,"",null,false],[0,0,0,"lpCompletionKey",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[403,232,0,null,null,null,[47822,47823,47824,47825,47826,47827],false],[0,0,0,"CompletionPort",null,"",null,false],[0,0,0,"lpCompletionPortEntries",null,"",null,false],[0,0,0,"ulCount",null,"",null,false],[0,0,0,"ulNumEntriesRemoved",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[0,0,0,"fAlertable",null,"",null,false],[403,241,0,null,null,null,[47829],false],[0,0,0,"lpSystemInfo",null,"",null,false],[403,242,0,null,null,null,[47831],false],[0,0,0,"",null,"",null,false],[403,243,0,null,null,null,[47833],false],[0,0,0,"ProcessorFeature",null,"",null,false],[403,245,0,null,null,null,[47835,47836,47837],false],[0,0,0,"flOptions",null,"",null,false],[0,0,0,"dwInitialSize",null,"",null,false],[0,0,0,"dwMaximumSize",null,"",null,false],[403,246,0,null,null,null,[47839],false],[0,0,0,"hHeap",null,"",null,false],[403,247,0,null,null,null,[47841,47842,47843,47844],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpMem",null,"",null,false],[0,0,0,"dwBytes",null,"",null,false],[403,248,0,null,null,null,[47846,47847,47848],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpMem",null,"",null,false],[403,249,0,null,null,null,[47850,47851],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[403,250,0,null,null,null,[47853,47854,47855],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpSummary",null,"",null,false],[403,252,0,null,null,null,[47857],false],[0,0,0,"in_nStdHandle",null,"",null,false],[403,254,0,null,null,null,[47859,47860,47861],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"dwBytes",null,"",null,false],[403,256,0,null,null,null,[47863,47864,47865],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpMem",null,"",null,false],[403,258,0,null,null,null,[47867,47868,47869],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpMem",null,"",null,false],[403,260,0,null,null,null,[47871,47872,47873,47874],false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"dwSize",null,"",null,false],[0,0,0,"flAllocationType",null,"",null,false],[0,0,0,"flProtect",null,"",null,false],[403,261,0,null,null,null,[47876,47877,47878],false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"dwSize",null,"",null,false],[0,0,0,"dwFreeType",null,"",null,false],[403,262,0,null,null,null,[47880,47881,47882],false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"dwLength",null,"",null,false],[403,264,0,null,null,null,[47884],false],[0,0,0,"hMem",null,"",null,false],[403,266,0,null,null,null,[47886,47887],false],[0,0,0,"hSnapshot",null,"",null,false],[0,0,0,"lpme",null,"",null,false],[403,268,0,null,null,null,[47889,47890],false],[0,0,0,"hSnapshot",null,"",null,false],[0,0,0,"lpme",null,"",null,false],[403,270,0,null,null,null,[47892,47893,47894],false],[0,0,0,"lpExistingFileName",null,"",null,false],[0,0,0,"lpNewFileName",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[403,276,0,null,null,null,[47896,47897,47898,47899],false],[0,0,0,"CompletionPort",null,"",null,false],[0,0,0,"dwNumberOfBytesTransferred",null,"",null,false],[0,0,0,"dwCompletionKey",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[403,278,0,null,null,null,[47901],false],[0,0,0,"lpPerformanceCount",null,"",null,false],[403,280,0,null,null,null,[47903],false],[0,0,0,"lpFrequency",null,"",null,false],[403,282,0,null,null,null,[47905,47906,47907,47908,47909,47910,47911,47912],false],[0,0,0,"hDirectory",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"nBufferLength",null,"",null,false],[0,0,0,"bWatchSubtree",null,"",null,false],[0,0,0,"dwNotifyFilter",null,"",null,false],[0,0,0,"lpBytesReturned",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[403,293,0,null,null,null,[47914,47915,47916,47917,47918],false],[0,0,0,"in_hFile",null,"",null,false],[0,0,0,"out_lpBuffer",null,"",null,false],[0,0,0,"in_nNumberOfBytesToRead",null,"",null,false],[0,0,0,"out_lpNumberOfBytesRead",null,"",null,false],[0,0,0,"in_out_lpOverlapped",null,"",null,false],[403,301,0,null,null,null,[47920],false],[0,0,0,"lpPathName",null,"",null,false],[403,303,0,null,null,null,[47922],false],[0,0,0,"ContextRecord",null,"",null,false],[403,305,0,null,null,null,[47924,47925,47926],false],[0,0,0,"ControlPc",null,"",null,false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"HistoryTable",null,"",null,false],[403,311,0,null,null,null,[47928,47929,47930,47931,47932,47933,47934,47935],false],[0,0,0,"HandlerType",null,"",null,false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"ControlPc",null,"",null,false],[0,0,0,"FunctionEntry",null,"",null,false],[0,0,0,"ContextRecord",null,"",null,false],[0,0,0,"HandlerData",null,"",null,false],[0,0,0,"EstablisherFrame",null,"",null,false],[0,0,0,"ContextPointers",null,"",null,false],[403,322,0,null,null,null,[47937,47938],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"wAttributes",null,"",null,false],[403,324,0,null,null,null,[47940,47941],false],[0,0,0,"HandlerRoutine",null,"",null,false],[0,0,0,"Add",null,"",null,false],[403,329,0,null,null,null,[47943],false],[0,0,0,"wCodePageID",null,"",null,false],[403,331,0,null,null,null,[47945,47946],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"Flags",null,"",null,false],[403,336,0,null,null,null,[47948,47949,47950,47951],false],[0,0,0,"in_fFile",null,"",null,false],[0,0,0,"in_liDistanceToMove",null,"",null,false],[0,0,0,"out_opt_ldNewFilePointer",null,"",null,false],[0,0,0,"in_dwMoveMethod",null,"",null,false],[403,343,0,null,null,null,[47953,47954,47955,47956],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpCreationTime",null,"",null,false],[0,0,0,"lpLastAccessTime",null,"",null,false],[0,0,0,"lpLastWriteTime",null,"",null,false],[403,350,0,null,null,null,[47958,47959,47960],false],[0,0,0,"hObject",null,"",null,false],[0,0,0,"dwMask",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[403,352,0,null,null,null,[47962],false],[0,0,0,"dwMilliseconds",null,"",null,false],[403,354,0,null,null,null,[],false],[403,356,0,null,null,null,[47965,47966],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"uExitCode",null,"",null,false],[403,358,0,null,null,null,[],false],[403,360,0,null,null,null,[47969],false],[0,0,0,"dwTlsIndex",null,"",null,false],[403,362,0,null,null,null,[47971,47972],false],[0,0,0,"hHandle",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[403,364,0,null,null,null,[47974,47975,47976],false],[0,0,0,"hHandle",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[0,0,0,"bAlertable",null,"",null,false],[403,366,0,null,null,null,[47978,47979,47980,47981],false],[0,0,0,"nCount",null,"",null,false],[0,0,0,"lpHandle",null,"",null,false],[0,0,0,"bWaitAll",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[403,368,0,null,null,null,[47983,47984,47985,47986,47987],false],[0,0,0,"nCount",null,"",null,false],[0,0,0,"lpHandle",null,"",null,false],[0,0,0,"bWaitAll",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[0,0,0,"bAlertable",null,"",null,false],[403,376,0,null,null,null,[47989,47990,47991,47992,47993],false],[0,0,0,"in_hFile",null,"",null,false],[0,0,0,"in_lpBuffer",null,"",null,false],[0,0,0,"in_nNumberOfBytesToWrite",null,"",null,false],[0,0,0,"out_lpNumberOfBytesWritten",null,"",null,false],[0,0,0,"in_out_lpOverlapped",null,"",null,false],[403,384,0,null,null,null,[47995,47996,47997,47998,47999],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"nNumberOfBytesToWrite",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[403,392,0,null,null,null,[48001],false],[0,0,0,"lpLibFileName",null,"",null,false],[403,394,0,null,null,null,[48003,48004],false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpProcName",null,"",null,false],[403,396,0,null,null,null,[48006],false],[0,0,0,"hModule",null,"",null,false],[403,398,0,null,null,null,[48008],false],[0,0,0,"lpCriticalSection",null,"",null,false],[403,399,0,null,null,null,[48010],false],[0,0,0,"lpCriticalSection",null,"",null,false],[403,400,0,null,null,null,[48012],false],[0,0,0,"lpCriticalSection",null,"",null,false],[403,401,0,null,null,null,[48014],false],[0,0,0,"lpCriticalSection",null,"",null,false],[403,403,0,null,null,null,[48016,48017,48018,48019],false],[0,0,0,"InitOnce",null,"",null,false],[0,0,0,"InitFn",null,"",null,false],[0,0,0,"Parameter",null,"",null,false],[0,0,0,"Context",null,"",null,false],[403,405,0,null,null,null,[48021],false],[0,0,0,"hProcess",null,"",null,false],[403,406,0,null,null,null,[48023,48024,48025],false],[0,0,0,"lpImageBase",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"lpcbNeeded",null,"",null,false],[403,407,0,null,null,null,[48027,48028],false],[0,0,0,"pCallBackRoutine",null,"",null,false],[0,0,0,"pContext",null,"",null,false],[403,408,0,null,null,null,[48030,48031],false],[0,0,0,"pCallBackRoutine",null,"",null,false],[0,0,0,"pContext",null,"",null,false],[403,409,0,null,null,null,[48033,48034,48035,48036],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lphModule",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"lpcbNeeded",null,"",null,false],[403,410,0,null,null,null,[48038,48039,48040,48041,48042],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lphModule",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"lpcbNeeded",null,"",null,false],[0,0,0,"dwFilterFlag",null,"",null,false],[403,411,0,null,null,null,[48044,48045,48046],false],[0,0,0,"lpidProcess",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"cbNeeded",null,"",null,false],[403,412,0,null,null,null,[48048,48049,48050],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,413,0,null,null,null,[48052,48053,48054],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,414,0,null,null,null,[48056,48057,48058],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,415,0,null,null,null,[48060,48061,48062],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,416,0,null,null,null,[48064,48065,48066,48067],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpv",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,417,0,null,null,null,[48069,48070,48071,48072],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpv",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,418,0,null,null,null,[48074,48075,48076,48077],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,419,0,null,null,null,[48079,48080,48081,48082],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,420,0,null,null,null,[48084,48085,48086,48087],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,421,0,null,null,null,[48089,48090,48091,48092],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,422,0,null,null,null,[48094,48095,48096,48097],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpmodinfo",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,423,0,null,null,null,[48099,48100],false],[0,0,0,"pPerformanceInformation",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,424,0,null,null,null,[48102,48103,48104],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpImageFileName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,425,0,null,null,null,[48106,48107,48108],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpImageFileName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[403,426,0,null,null,null,[48110,48111,48112],false],[0,0,0,"Process",null,"",null,false],[0,0,0,"ppsmemCounters",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,427,0,null,null,null,[48114,48115,48116],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpWatchInfo",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,428,0,null,null,null,[48118,48119,48120],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpWatchInfoEx",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,429,0,null,null,null,[48122],false],[0,0,0,"hProcess",null,"",null,false],[403,430,0,null,null,null,[48124,48125,48126],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"pv",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,431,0,null,null,null,[48128,48129,48130],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"pv",null,"",null,false],[0,0,0,"cb",null,"",null,false],[403,433,0,null,null,null,[48132],false],[0,0,0,"hFile",null,"",null,false],[403,435,0,null,null,null,[48134],false],[0,0,0,"c",null,"",null,false],[403,436,0,null,null,null,[48136],false],[0,0,0,"c",null,"",null,false],[403,437,0,null,null,null,[48138,48139,48140,48141],false],[0,0,0,"c",null,"",null,false],[0,0,0,"s",null,"",null,false],[0,0,0,"t",null,"",null,false],[0,0,0,"f",null,"",null,false],[403,444,0,null,null,null,[48143],false],[0,0,0,"s",null,"",null,false],[403,445,0,null,null,null,[48145],false],[0,0,0,"s",null,"",null,false],[403,446,0,null,null,null,[48147],false],[0,0,0,"s",null,"",null,false],[403,448,0,null,null,null,[48149,48150,48151,48152,48153],false],[0,0,0,"hkey",null,"",null,false],[0,0,0,"lpSubKey",null,"",null,false],[0,0,0,"ulOptions",null,"",null,false],[0,0,0,"samDesired",null,"",null,false],[0,0,0,"phkResult",null,"",null,false],[403,456,0,null,null,null,[48155],false],[0,0,0,"TotalMemoryInKilobytes",null,"",null,false],[401,22,0,null,null,null,null,false],[0,0,0,"windows/ntdll.zig",null,"",[],false],[404,0,0,null,null,null,null,false],[404,1,0,null,null,null,null,false],[404,3,0,null,null,null,null,false],[404,4,0,null,null,null,null,false],[404,5,0,null,null,null,null,false],[404,6,0,null,null,null,null,false],[404,7,0,null,null,null,null,false],[404,8,0,null,null,null,null,false],[404,9,0,null,null,null,null,false],[404,10,0,null,null,null,null,false],[404,11,0,null,null,null,null,false],[404,12,0,null,null,null,null,false],[404,13,0,null,null,null,null,false],[404,14,0,null,null,null,null,false],[404,15,0,null,null,null,null,false],[404,16,0,null,null,null,null,false],[404,17,0,null,null,null,null,false],[404,18,0,null,null,null,null,false],[404,19,0,null,null,null,null,false],[404,20,0,null,null,null,null,false],[404,21,0,null,null,null,null,false],[404,22,0,null,null,null,null,false],[404,23,0,null,null,null,null,false],[404,24,0,null,null,null,null,false],[404,25,0,null,null,null,null,false],[404,26,0,null,null,null,null,false],[404,27,0,null,null,null,null,false],[404,28,0,null,null,null,null,false],[404,29,0,null,null,null,null,false],[404,30,0,null,null,null,null,false],[404,31,0,null,null,null,null,false],[404,32,0,null,null,null,null,false],[404,33,0,null,null,null,null,false],[404,34,0,null,null,null,null,false],[404,35,0,null,null,null,null,false],[404,36,0,null,null,null,null,false],[404,37,0,null,null,null,null,false],[404,38,0,null,null,null,null,false],[404,40,0,null,null,null,[48197,48198,48199,48200,48201],false],[0,0,0,"ProcessHandle",null,"",null,false],[0,0,0,"ProcessInformationClass",null,"",null,false],[0,0,0,"ProcessInformation",null,"",null,false],[0,0,0,"ProcessInformationLength",null,"",null,false],[0,0,0,"ReturnLength",null,"",null,false],[404,48,0,null,null,null,[48203,48204,48205,48206,48207],false],[0,0,0,"ThreadHandle",null,"",null,false],[0,0,0,"ThreadInformationClass",null,"",null,false],[0,0,0,"ThreadInformation",null,"",null,false],[0,0,0,"ThreadInformationLength",null,"",null,false],[0,0,0,"ReturnLength",null,"",null,false],[404,56,0,null,null,null,[48209,48210,48211,48212],false],[0,0,0,"SystemInformationClass",null,"",null,false],[0,0,0,"SystemInformation",null,"",null,false],[0,0,0,"SystemInformationLength",null,"",null,false],[0,0,0,"ReturnLength",null,"",null,false],[404,63,0,null,null,null,[48214,48215,48216,48217],false],[0,0,0,"ThreadHandle",null,"",null,false],[0,0,0,"ThreadInformationClass",null,"",null,false],[0,0,0,"ThreadInformation",null,"",null,false],[0,0,0,"ThreadInformationLength",null,"",null,false],[404,70,0,null,null,null,[48219],false],[0,0,0,"lpVersionInformation",null,"",null,false],[404,73,0,null,null,null,[48221,48222,48223,48224],false],[0,0,0,"FramesToSkip",null,"",null,false],[0,0,0,"FramesToCapture",null,"",null,false],[0,0,0,"BackTrace",null,"",null,false],[0,0,0,"BackTraceHash",null,"",null,false],[404,79,0,null,null,null,[48226],false],[0,0,0,"ContextRecord",null,"",null,false],[404,80,0,null,null,null,[48228,48229,48230],false],[0,0,0,"ControlPc",null,"",null,false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"HistoryTable",null,"",null,false],[404,85,0,null,null,null,[48232,48233,48234,48235,48236,48237,48238,48239],false],[0,0,0,"HandlerType",null,"",null,false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"ControlPc",null,"",null,false],[0,0,0,"FunctionEntry",null,"",null,false],[0,0,0,"ContextRecord",null,"",null,false],[0,0,0,"HandlerData",null,"",null,false],[0,0,0,"EstablisherFrame",null,"",null,false],[0,0,0,"ContextPointers",null,"",null,false],[404,95,0,null,null,null,[48241,48242,48243,48244,48245],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"FileInformation",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"FileInformationClass",null,"",null,false],[404,102,0,null,null,null,[48247,48248,48249,48250,48251],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"FileInformation",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"FileInformationClass",null,"",null,false],[404,110,0,null,null,null,[48253,48254],false],[0,0,0,"ObjectAttributes",null,"",null,false],[0,0,0,"FileAttributes",null,"",null,false],[404,115,0,null,null,null,[48256,48257,48258,48259,48260,48261,48262,48263,48264,48265,48266],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"DesiredAccess",null,"",null,false],[0,0,0,"ObjectAttributes",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"AllocationSize",null,"",null,false],[0,0,0,"FileAttributes",null,"",null,false],[0,0,0,"ShareAccess",null,"",null,false],[0,0,0,"CreateDisposition",null,"",null,false],[0,0,0,"CreateOptions",null,"",null,false],[0,0,0,"EaBuffer",null,"",null,false],[0,0,0,"EaLength",null,"",null,false],[404,128,0,null,null,null,[48268,48269,48270,48271,48272,48273,48274],false],[0,0,0,"SectionHandle",null,"",null,false],[0,0,0,"DesiredAccess",null,"",null,false],[0,0,0,"ObjectAttributes",null,"",null,false],[0,0,0,"MaximumSize",null,"",null,false],[0,0,0,"SectionPageProtection",null,"",null,false],[0,0,0,"AllocationAttributes",null,"",null,false],[0,0,0,"FileHandle",null,"",null,false],[404,137,0,null,null,null,[48276,48277,48278,48279,48280,48281,48282,48283,48284,48285],false],[0,0,0,"SectionHandle",null,"",null,false],[0,0,0,"ProcessHandle",null,"",null,false],[0,0,0,"BaseAddress",null,"",null,false],[0,0,0,"ZeroBits",null,"",null,false],[0,0,0,"CommitSize",null,"",null,false],[0,0,0,"SectionOffset",null,"",null,false],[0,0,0,"ViewSize",null,"",null,false],[0,0,0,"InheritDispostion",null,"",null,false],[0,0,0,"AllocationType",null,"",null,false],[0,0,0,"Win32Protect",null,"",null,false],[404,149,0,null,null,null,[48287,48288],false],[0,0,0,"ProcessHandle",null,"",null,false],[0,0,0,"BaseAddress",null,"",null,false],[404,153,0,null,null,null,[48290,48291,48292,48293,48294,48295,48296,48297,48298,48299],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"Event",null,"",null,false],[0,0,0,"ApcRoutine",null,"",null,false],[0,0,0,"ApcContext",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"IoControlCode",null,"",null,false],[0,0,0,"InputBuffer",null,"",null,false],[0,0,0,"InputBufferLength",null,"",null,false],[0,0,0,"OutputBuffer",null,"",null,false],[0,0,0,"OutputBufferLength",null,"",null,false],[404,165,0,null,null,null,[48301,48302,48303,48304,48305,48306,48307,48308,48309,48310],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"Event",null,"",null,false],[0,0,0,"ApcRoutine",null,"",null,false],[0,0,0,"ApcContext",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"FsControlCode",null,"",null,false],[0,0,0,"InputBuffer",null,"",null,false],[0,0,0,"InputBufferLength",null,"",null,false],[0,0,0,"OutputBuffer",null,"",null,false],[0,0,0,"OutputBufferLength",null,"",null,false],[404,177,0,null,null,null,[48312],false],[0,0,0,"Handle",null,"",null,false],[404,178,0,null,null,null,[48314,48315,48316,48317],false],[0,0,0,"DosPathName",null,"",null,false],[0,0,0,"NtPathName",null,"",null,false],[0,0,0,"NtFileNamePart",null,"",null,false],[0,0,0,"DirectoryInfo",null,"",null,false],[404,184,0,null,null,null,[48319],false],[0,0,0,"UnicodeString",null,"",null,false],[404,189,0,null,null," Returns the number of bytes written to `Buffer`.\n If the returned count is larger than `BufferByteLength`, the buffer was too small.\n If the returned count is zero, an error occurred.",[48321,48322,48323,48324],false],[0,0,0,"FileName",null,"",null,false],[0,0,0,"BufferByteLength",null,"",null,false],[0,0,0,"Buffer",null,"",null,false],[0,0,0,"ShortName",null,"",null,false],[404,196,0,null,null,null,[48326,48327,48328,48329,48330,48331,48332,48333,48334,48335,48336],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"Event",null,"",null,false],[0,0,0,"ApcRoutine",null,"",null,false],[0,0,0,"ApcContext",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"FileInformation",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"FileInformationClass",null,"",null,false],[0,0,0,"ReturnSingleEntry",null,"",null,false],[0,0,0,"FileName",null,"",null,false],[0,0,0,"RestartScan",null,"",null,false],[404,210,0,null,null,null,[48338,48339,48340,48341],false],[0,0,0,"KeyedEventHandle",null,"",null,false],[0,0,0,"DesiredAccess",null,"",null,false],[0,0,0,"ObjectAttributes",null,"",null,false],[0,0,0,"Flags",null,"",null,false],[404,217,0,null,null,null,[48343,48344,48345,48346],false],[0,0,0,"EventHandle",null,"",null,false],[0,0,0,"Key",null,"",null,false],[0,0,0,"Alertable",null,"",null,false],[0,0,0,"Timeout",null,"",null,false],[404,224,0,null,null,null,[48348,48349,48350,48351],false],[0,0,0,"EventHandle",null,"",null,false],[0,0,0,"Key",null,"",null,false],[0,0,0,"Alertable",null,"",null,false],[0,0,0,"Timeout",null,"",null,false],[404,231,0,null,null,null,[48353],false],[0,0,0,"PathName",null,"",null,false],[404,233,0,null,null,null,[48355,48356,48357,48358,48359],false],[0,0,0,"Handle",null,"",null,false],[0,0,0,"ObjectInformationClass",null,"",null,false],[0,0,0,"ObjectInformation",null,"",null,false],[0,0,0,"ObjectInformationLength",null,"",null,false],[0,0,0,"ReturnLength",null,"",null,false],[404,241,0,null,null,null,[48361,48362,48363,48364,48365],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"FsInformation",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"FsInformationClass",null,"",null,false],[404,249,0,null,null,null,[48367],false],[0,0,0,"Address",null,"",null,false],[404,253,0,null,null,null,[48369],false],[0,0,0,"Address",null,"",null,false],[404,257,0,null,null,null,[48371,48372,48373,48374],false],[0,0,0,"Address",null,"",null,false],[0,0,0,"CompareAddress",null,"",null,false],[0,0,0,"AddressSize",null,"",null,false],[0,0,0,"Timeout",null,"",null,false],[404,264,0,null,null,null,[48376,48377,48378],false],[0,0,0,"String1",null,"",null,false],[0,0,0,"String2",null,"",null,false],[0,0,0,"CaseInSensitive",null,"",null,false],[404,270,0,null,null,null,[48380],false],[0,0,0,"SourceCharacter",null,"",null,false],[404,274,0,null,null,null,[48382,48383,48384,48385,48386,48387,48388,48389,48390,48391],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"Event",null,"",null,false],[0,0,0,"ApcRoutine",null,"",null,false],[0,0,0,"ApcContext",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"ByteOffset",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"Key",null,"",null,false],[0,0,0,"FailImmediately",null,"",null,false],[0,0,0,"ExclusiveLock",null,"",null,false],[404,287,0,null,null,null,[48393,48394,48395,48396,48397],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"ByteOffset",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"Key",null,"",null,false],[404,295,0,null,null,null,[48399,48400,48401],false],[0,0,0,"KeyHandle",null,"",null,false],[0,0,0,"DesiredAccess",null,"",null,false],[0,0,0,"ObjectAttributes",null,"",null,false],[404,301,0,null,null,null,[48403,48404,48405,48406,48407],false],[0,0,0,"RelativeTo",null,"",null,false],[0,0,0,"Path",null,"",null,false],[0,0,0,"QueryTable",null,"",null,false],[0,0,0,"Context",null,"",null,false],[0,0,0,"Environment",null,"",null,false],[404,309,0,null,null,null,[48409,48410,48411,48412,48413],false],[0,0,0,"ProcessHandle",null,"",null,false],[0,0,0,"BaseAddress",null,"",null,false],[0,0,0,"Buffer",null,"",null,false],[0,0,0,"NumberOfBytesToRead",null,"",null,false],[0,0,0,"NumberOfBytesRead",null,"",null,false],[404,317,0,null,null,null,[48415,48416,48417,48418,48419],false],[0,0,0,"ProcessHandle",null,"",null,false],[0,0,0,"BaseAddress",null,"",null,false],[0,0,0,"Buffer",null,"",null,false],[0,0,0,"NumberOfBytesToWrite",null,"",null,false],[0,0,0,"NumberOfBytesWritten",null,"",null,false],[404,325,0,null,null,null,[48421,48422,48423,48424,48425],false],[0,0,0,"ProcessHandle",null,"",null,false],[0,0,0,"BaseAddress",null,"",null,false],[0,0,0,"NumberOfBytesToProtect",null,"",null,false],[0,0,0,"NewAccessProtection",null,"",null,false],[0,0,0,"OldAccessProtection",null,"",null,false],[401,23,0,null,null,null,null,false],[0,0,0,"windows/ole32.zig",null,"",[],false],[405,0,0,null,null,null,null,false],[405,1,0,null,null,null,null,false],[405,2,0,null,null,null,null,false],[405,3,0,null,null,null,null,false],[405,4,0,null,null,null,null,false],[405,5,0,null,null,null,null,false],[405,7,0,null,null,null,[48435],false],[0,0,0,"pv",null,"",null,false],[405,8,0,null,null,null,[],false],[405,9,0,null,null,null,[],false],[405,10,0,null,null,null,[48439],false],[0,0,0,"pvReserved",null,"",null,false],[405,11,0,null,null,null,[48441,48442],false],[0,0,0,"pvReserved",null,"",null,false],[0,0,0,"dwCoInit",null,"",null,false],[401,24,0,null,null,null,null,false],[0,0,0,"windows/psapi.zig",null,"",[],false],[406,0,0,null,null,null,null,false],[406,1,0,null,null,null,null,false],[406,2,0,null,null,null,null,false],[406,3,0,null,null,null,null,false],[406,4,0,null,null,null,null,false],[406,5,0,null,null,null,null,false],[406,6,0,null,null,null,null,false],[406,7,0,null,null,null,null,false],[406,8,0,null,null,null,null,false],[406,9,0,null,null,null,null,false],[406,10,0,null,null,null,null,false],[406,11,0,null,null,null,null,false],[406,12,0,null,null,null,null,false],[406,13,0,null,null,null,null,false],[406,14,0,null,null,null,null,false],[406,15,0,null,null,null,null,false],[406,16,0,null,null,null,null,false],[406,17,0,null,null,null,null,false],[406,18,0,null,null,null,null,false],[406,19,0,null,null,null,null,false],[406,20,0,null,null,null,null,false],[406,21,0,null,null,null,null,false],[406,22,0,null,null,null,null,false],[406,23,0,null,null,null,null,false],[406,24,0,null,null,null,null,false],[406,25,0,null,null,null,null,false],[406,26,0,null,null,null,null,false],[406,27,0,null,null,null,null,false],[406,28,0,null,null,null,null,false],[406,29,0,null,null,null,null,false],[406,30,0,null,null,null,null,false],[406,31,0,null,null,null,null,false],[406,32,0,null,null,null,null,false],[406,33,0,null,null,null,null,false],[406,34,0,null,null,null,null,false],[406,35,0,null,null,null,null,false],[406,36,0,null,null,null,null,false],[406,37,0,null,null,null,null,false],[406,38,0,null,null,null,null,false],[406,39,0,null,null,null,null,false],[406,40,0,null,null,null,null,false],[406,41,0,null,null,null,null,false],[406,42,0,null,null,null,null,false],[406,43,0,null,null,null,null,false],[406,44,0,null,null,null,null,false],[406,45,0,null,null,null,null,false],[406,46,0,null,null,null,null,false],[406,48,0,null,null,null,[48493],false],[0,0,0,"hProcess",null,"",null,false],[406,49,0,null,null,null,[48495,48496,48497],false],[0,0,0,"lpImageBase",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"lpcbNeeded",null,"",null,false],[406,50,0,null,null,null,[48499,48500],false],[0,0,0,"pCallBackRoutine",null,"",null,false],[0,0,0,"pContext",null,"",null,false],[406,51,0,null,null,null,[48502,48503],false],[0,0,0,"pCallBackRoutine",null,"",null,false],[0,0,0,"pContext",null,"",null,false],[406,52,0,null,null,null,[48505,48506,48507,48508],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lphModule",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"lpcbNeeded",null,"",null,false],[406,53,0,null,null,null,[48510,48511,48512,48513,48514],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lphModule",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"lpcbNeeded",null,"",null,false],[0,0,0,"dwFilterFlag",null,"",null,false],[406,54,0,null,null,null,[48516,48517,48518],false],[0,0,0,"lpidProcess",null,"",null,false],[0,0,0,"cb",null,"",null,false],[0,0,0,"cbNeeded",null,"",null,false],[406,55,0,null,null,null,[48520,48521,48522],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,56,0,null,null,null,[48524,48525,48526],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,57,0,null,null,null,[48528,48529,48530],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,58,0,null,null,null,[48532,48533,48534],false],[0,0,0,"ImageBase",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,59,0,null,null,null,[48536,48537,48538,48539],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpv",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,60,0,null,null,null,[48541,48542,48543,48544],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpv",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,61,0,null,null,null,[48546,48547,48548,48549],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,62,0,null,null,null,[48551,48552,48553,48554],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpBaseName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,63,0,null,null,null,[48556,48557,48558,48559],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,64,0,null,null,null,[48561,48562,48563,48564],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpFilename",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,65,0,null,null,null,[48566,48567,48568,48569],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"lpmodinfo",null,"",null,false],[0,0,0,"cb",null,"",null,false],[406,66,0,null,null,null,[48571,48572],false],[0,0,0,"pPerformanceInformation",null,"",null,false],[0,0,0,"cb",null,"",null,false],[406,67,0,null,null,null,[48574,48575,48576],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpImageFileName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,68,0,null,null,null,[48578,48579,48580],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpImageFileName",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[406,69,0,null,null,null,[48582,48583,48584],false],[0,0,0,"Process",null,"",null,false],[0,0,0,"ppsmemCounters",null,"",null,false],[0,0,0,"cb",null,"",null,false],[406,70,0,null,null,null,[48586,48587,48588],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpWatchInfo",null,"",null,false],[0,0,0,"cb",null,"",null,false],[406,71,0,null,null,null,[48590,48591,48592],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"lpWatchInfoEx",null,"",null,false],[0,0,0,"cb",null,"",null,false],[406,72,0,null,null,null,[48594],false],[0,0,0,"hProcess",null,"",null,false],[406,73,0,null,null,null,[48596,48597,48598],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"pv",null,"",null,false],[0,0,0,"cb",null,"",null,false],[406,74,0,null,null,null,[48600,48601,48602],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"pv",null,"",null,false],[0,0,0,"cb",null,"",null,false],[401,25,0,null,null,null,null,false],[0,0,0,"windows/shell32.zig",null,"",[],false],[407,0,0,null,null,null,null,false],[407,1,0,null,null,null,null,false],[407,2,0,null,null,null,null,false],[407,3,0,null,null,null,null,false],[407,4,0,null,null,null,null,false],[407,5,0,null,null,null,null,false],[407,6,0,null,null,null,null,false],[407,7,0,null,null,null,null,false],[407,9,0,null,null,null,[48614,48615,48616,48617],false],[0,0,0,"rfid",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"hToken",null,"",null,false],[0,0,0,"ppszPath",null,"",null,false],[401,26,0,null,null,null,null,false],[0,0,0,"windows/user32.zig",null,"",[],false],[408,0,0,null,null,null,null,false],[408,1,0,null,null,null,null,false],[408,2,0,null,null,null,null,false],[408,4,0,null,null,null,null,false],[408,5,0,null,null,null,null,false],[408,6,0,null,null,null,null,false],[408,7,0,null,null,null,null,false],[408,8,0,null,null,null,null,false],[408,9,0,null,null,null,null,false],[408,10,0,null,null,null,null,false],[408,11,0,null,null,null,null,false],[408,12,0,null,null,null,null,false],[408,13,0,null,null,null,null,false],[408,14,0,null,null,null,null,false],[408,15,0,null,null,null,null,false],[408,16,0,null,null,null,null,false],[408,17,0,null,null,null,null,false],[408,18,0,null,null,null,null,false],[408,19,0,null,null,null,null,false],[408,20,0,null,null,null,null,false],[408,21,0,null,null,null,null,false],[408,22,0,null,null,null,null,false],[408,23,0,null,null,null,null,false],[408,24,0,null,null,null,null,false],[408,25,0,null,null,null,null,false],[408,26,0,null,null,null,null,false],[408,27,0,null,null,null,null,false],[408,28,0,null,null,null,null,false],[408,30,0,null,null,null,[48649,48650,48651],false],[0,0,0,"function_static",null,"",null,true],[0,0,0,"function_dynamic",null,"",null,false],[0,0,0,"os",null,"",null,true],[408,39,0,null,null,null,[48653,48654,48655,48656],false],[0,0,0,"hwnd",null,"",null,false],[0,0,0,"uMsg",null,"",null,false],[0,0,0,"wParam",null,"",null,false],[0,0,0,"lParam",null,"",null,false],[408,41,0,null,null,null,[48659,48661,48663,48665,48667,48669,48671],false],[408,41,0,null,null,null,null,false],[0,0,0,"hWnd",null,null,null,false],[408,41,0,null,null,null,null,false],[0,0,0,"message",null,null,null,false],[408,41,0,null,null,null,null,false],[0,0,0,"wParam",null,null,null,false],[408,41,0,null,null,null,null,false],[0,0,0,"lParam",null,null,null,false],[408,41,0,null,null,null,null,false],[0,0,0,"time",null,null,null,false],[408,41,0,null,null,null,null,false],[0,0,0,"pt",null,null,null,false],[408,41,0,null,null,null,null,false],[0,0,0,"lPrivate",null,null,null,false],[408,52,0,null,null,null,null,false],[408,53,0,null,null,null,null,false],[408,54,0,null,null,null,null,false],[408,55,0,null,null,null,null,false],[408,56,0,null,null,null,null,false],[408,57,0,null,null,null,null,false],[408,58,0,null,null,null,null,false],[408,59,0,null,null,null,null,false],[408,60,0,null,null,null,null,false],[408,61,0,null,null,null,null,false],[408,62,0,null,null,null,null,false],[408,63,0,null,null,null,null,false],[408,64,0,null,null,null,null,false],[408,65,0,null,null,null,null,false],[408,66,0,null,null,null,null,false],[408,67,0,null,null,null,null,false],[408,68,0,null,null,null,null,false],[408,69,0,null,null,null,null,false],[408,70,0,null,null,null,null,false],[408,71,0,null,null,null,null,false],[408,72,0,null,null,null,null,false],[408,73,0,null,null,null,null,false],[408,74,0,null,null,null,null,false],[408,75,0,null,null,null,null,false],[408,76,0,null,null,null,null,false],[408,77,0,null,null,null,null,false],[408,78,0,null,null,null,null,false],[408,79,0,null,null,null,null,false],[408,80,0,null,null,null,null,false],[408,81,0,null,null,null,null,false],[408,82,0,null,null,null,null,false],[408,83,0,null,null,null,null,false],[408,84,0,null,null,null,null,false],[408,85,0,null,null,null,null,false],[408,86,0,null,null,null,null,false],[408,87,0,null,null,null,null,false],[408,88,0,null,null,null,null,false],[408,89,0,null,null,null,null,false],[408,90,0,null,null,null,null,false],[408,91,0,null,null,null,null,false],[408,92,0,null,null,null,null,false],[408,93,0,null,null,null,null,false],[408,94,0,null,null,null,null,false],[408,95,0,null,null,null,null,false],[408,96,0,null,null,null,null,false],[408,97,0,null,null,null,null,false],[408,98,0,null,null,null,null,false],[408,99,0,null,null,null,null,false],[408,100,0,null,null,null,null,false],[408,101,0,null,null,null,null,false],[408,102,0,null,null,null,null,false],[408,103,0,null,null,null,null,false],[408,104,0,null,null,null,null,false],[408,105,0,null,null,null,null,false],[408,106,0,null,null,null,null,false],[408,107,0,null,null,null,null,false],[408,108,0,null,null,null,null,false],[408,109,0,null,null,null,null,false],[408,110,0,null,null,null,null,false],[408,111,0,null,null,null,null,false],[408,112,0,null,null,null,null,false],[408,113,0,null,null,null,null,false],[408,114,0,null,null,null,null,false],[408,115,0,null,null,null,null,false],[408,116,0,null,null,null,null,false],[408,117,0,null,null,null,null,false],[408,118,0,null,null,null,null,false],[408,119,0,null,null,null,null,false],[408,120,0,null,null,null,null,false],[408,121,0,null,null,null,null,false],[408,122,0,null,null,null,null,false],[408,123,0,null,null,null,null,false],[408,124,0,null,null,null,null,false],[408,125,0,null,null,null,null,false],[408,126,0,null,null,null,null,false],[408,127,0,null,null,null,null,false],[408,128,0,null,null,null,null,false],[408,129,0,null,null,null,null,false],[408,130,0,null,null,null,null,false],[408,131,0,null,null,null,null,false],[408,132,0,null,null,null,null,false],[408,133,0,null,null,null,null,false],[408,134,0,null,null,null,null,false],[408,135,0,null,null,null,null,false],[408,136,0,null,null,null,null,false],[408,137,0,null,null,null,null,false],[408,138,0,null,null,null,null,false],[408,139,0,null,null,null,null,false],[408,140,0,null,null,null,null,false],[408,141,0,null,null,null,null,false],[408,142,0,null,null,null,null,false],[408,143,0,null,null,null,null,false],[408,144,0,null,null,null,null,false],[408,145,0,null,null,null,null,false],[408,146,0,null,null,null,null,false],[408,147,0,null,null,null,null,false],[408,148,0,null,null,null,null,false],[408,149,0,null,null,null,null,false],[408,150,0,null,null,null,null,false],[408,151,0,null,null,null,null,false],[408,152,0,null,null,null,null,false],[408,153,0,null,null,null,null,false],[408,154,0,null,null,null,null,false],[408,155,0,null,null,null,null,false],[408,156,0,null,null,null,null,false],[408,157,0,null,null,null,null,false],[408,158,0,null,null,null,null,false],[408,159,0,null,null,null,null,false],[408,160,0,null,null,null,null,false],[408,161,0,null,null,null,null,false],[408,162,0,null,null,null,null,false],[408,163,0,null,null,null,null,false],[408,164,0,null,null,null,null,false],[408,165,0,null,null,null,null,false],[408,166,0,null,null,null,null,false],[408,167,0,null,null,null,null,false],[408,168,0,null,null,null,null,false],[408,169,0,null,null,null,null,false],[408,170,0,null,null,null,null,false],[408,171,0,null,null,null,null,false],[408,172,0,null,null,null,null,false],[408,173,0,null,null,null,null,false],[408,174,0,null,null,null,null,false],[408,175,0,null,null,null,null,false],[408,176,0,null,null,null,null,false],[408,177,0,null,null,null,null,false],[408,178,0,null,null,null,null,false],[408,179,0,null,null,null,null,false],[408,180,0,null,null,null,null,false],[408,181,0,null,null,null,null,false],[408,182,0,null,null,null,null,false],[408,183,0,null,null,null,null,false],[408,184,0,null,null,null,null,false],[408,185,0,null,null,null,null,false],[408,186,0,null,null,null,null,false],[408,187,0,null,null,null,null,false],[408,188,0,null,null,null,null,false],[408,189,0,null,null,null,null,false],[408,190,0,null,null,null,null,false],[408,191,0,null,null,null,null,false],[408,192,0,null,null,null,null,false],[408,193,0,null,null,null,null,false],[408,194,0,null,null,null,null,false],[408,195,0,null,null,null,null,false],[408,196,0,null,null,null,null,false],[408,197,0,null,null,null,null,false],[408,198,0,null,null,null,null,false],[408,199,0,null,null,null,null,false],[408,200,0,null,null,null,null,false],[408,201,0,null,null,null,null,false],[408,202,0,null,null,null,null,false],[408,203,0,null,null,null,null,false],[408,204,0,null,null,null,null,false],[408,205,0,null,null,null,null,false],[408,206,0,null,null,null,null,false],[408,207,0,null,null,null,null,false],[408,208,0,null,null,null,null,false],[408,209,0,null,null,null,null,false],[408,210,0,null,null,null,null,false],[408,211,0,null,null,null,null,false],[408,212,0,null,null,null,null,false],[408,213,0,null,null,null,null,false],[408,214,0,null,null,null,null,false],[408,215,0,null,null,null,null,false],[408,216,0,null,null,null,null,false],[408,217,0,null,null,null,null,false],[408,218,0,null,null,null,null,false],[408,219,0,null,null,null,null,false],[408,220,0,null,null,null,null,false],[408,221,0,null,null,null,null,false],[408,222,0,null,null,null,null,false],[408,223,0,null,null,null,null,false],[408,224,0,null,null,null,null,false],[408,225,0,null,null,null,null,false],[408,226,0,null,null,null,null,false],[408,227,0,null,null,null,null,false],[408,228,0,null,null,null,null,false],[408,229,0,null,null,null,null,false],[408,230,0,null,null,null,null,false],[408,231,0,null,null,null,null,false],[408,232,0,null,null,null,null,false],[408,233,0,null,null,null,null,false],[408,234,0,null,null,null,null,false],[408,235,0,null,null,null,null,false],[408,236,0,null,null,null,null,false],[408,237,0,null,null,null,null,false],[408,238,0,null,null,null,null,false],[408,239,0,null,null,null,null,false],[408,240,0,null,null,null,null,false],[408,241,0,null,null,null,null,false],[408,242,0,null,null,null,null,false],[408,243,0,null,null,null,null,false],[408,244,0,null,null,null,null,false],[408,245,0,null,null,null,null,false],[408,246,0,null,null,null,null,false],[408,247,0,null,null,null,null,false],[408,248,0,null,null,null,null,false],[408,249,0,null,null,null,null,false],[408,250,0,null,null,null,null,false],[408,251,0,null,null,null,null,false],[408,252,0,null,null,null,null,false],[408,253,0,null,null,null,null,false],[408,254,0,null,null,null,null,false],[408,255,0,null,null,null,null,false],[408,256,0,null,null,null,null,false],[408,257,0,null,null,null,null,false],[408,258,0,null,null,null,null,false],[408,259,0,null,null,null,null,false],[408,260,0,null,null,null,null,false],[408,261,0,null,null,null,null,false],[408,262,0,null,null,null,null,false],[408,263,0,null,null,null,null,false],[408,264,0,null,null,null,null,false],[408,265,0,null,null,null,null,false],[408,266,0,null,null,null,null,false],[408,267,0,null,null,null,null,false],[408,268,0,null,null,null,null,false],[408,269,0,null,null,null,null,false],[408,270,0,null,null,null,null,false],[408,271,0,null,null,null,null,false],[408,272,0,null,null,null,null,false],[408,273,0,null,null,null,null,false],[408,274,0,null,null,null,null,false],[408,275,0,null,null,null,null,false],[408,276,0,null,null,null,null,false],[408,277,0,null,null,null,null,false],[408,278,0,null,null,null,null,false],[408,279,0,null,null,null,null,false],[408,280,0,null,null,null,null,false],[408,281,0,null,null,null,null,false],[408,282,0,null,null,null,null,false],[408,283,0,null,null,null,null,false],[408,284,0,null,null,null,null,false],[408,285,0,null,null,null,null,false],[408,286,0,null,null,null,null,false],[408,287,0,null,null,null,null,false],[408,288,0,null,null,null,null,false],[408,289,0,null,null,null,null,false],[408,290,0,null,null,null,null,false],[408,291,0,null,null,null,null,false],[408,292,0,null,null,null,null,false],[408,293,0,null,null,null,null,false],[408,294,0,null,null,null,null,false],[408,295,0,null,null,null,null,false],[408,296,0,null,null,null,null,false],[408,297,0,null,null,null,null,false],[408,298,0,null,null,null,null,false],[408,299,0,null,null,null,null,false],[408,300,0,null,null,null,null,false],[408,301,0,null,null,null,null,false],[408,302,0,null,null,null,null,false],[408,303,0,null,null,null,null,false],[408,304,0,null,null,null,null,false],[408,305,0,null,null,null,null,false],[408,306,0,null,null,null,null,false],[408,307,0,null,null,null,null,false],[408,308,0,null,null,null,null,false],[408,309,0,null,null,null,null,false],[408,310,0,null,null,null,null,false],[408,311,0,null,null,null,null,false],[408,312,0,null,null,null,null,false],[408,313,0,null,null,null,null,false],[408,314,0,null,null,null,null,false],[408,315,0,null,null,null,null,false],[408,316,0,null,null,null,null,false],[408,317,0,null,null,null,null,false],[408,318,0,null,null,null,null,false],[408,319,0,null,null,null,null,false],[408,320,0,null,null,null,null,false],[408,321,0,null,null,null,null,false],[408,322,0,null,null,null,null,false],[408,323,0,null,null,null,null,false],[408,324,0,null,null,null,null,false],[408,325,0,null,null,null,null,false],[408,326,0,null,null,null,null,false],[408,327,0,null,null,null,null,false],[408,328,0,null,null,null,null,false],[408,329,0,null,null,null,null,false],[408,330,0,null,null,null,null,false],[408,331,0,null,null,null,null,false],[408,332,0,null,null,null,null,false],[408,333,0,null,null,null,null,false],[408,334,0,null,null,null,null,false],[408,335,0,null,null,null,null,false],[408,336,0,null,null,null,null,false],[408,337,0,null,null,null,null,false],[408,338,0,null,null,null,null,false],[408,339,0,null,null,null,null,false],[408,340,0,null,null,null,null,false],[408,341,0,null,null,null,null,false],[408,342,0,null,null,null,null,false],[408,343,0,null,null,null,null,false],[408,344,0,null,null,null,null,false],[408,345,0,null,null,null,null,false],[408,346,0,null,null,null,null,false],[408,347,0,null,null,null,null,false],[408,348,0,null,null,null,null,false],[408,349,0,null,null,null,null,false],[408,350,0,null,null,null,null,false],[408,351,0,null,null,null,null,false],[408,352,0,null,null,null,null,false],[408,353,0,null,null,null,null,false],[408,354,0,null,null,null,null,false],[408,355,0,null,null,null,null,false],[408,356,0,null,null,null,null,false],[408,357,0,null,null,null,null,false],[408,358,0,null,null,null,null,false],[408,359,0,null,null,null,null,false],[408,360,0,null,null,null,null,false],[408,361,0,null,null,null,null,false],[408,362,0,null,null,null,null,false],[408,363,0,null,null,null,null,false],[408,364,0,null,null,null,null,false],[408,365,0,null,null,null,null,false],[408,366,0,null,null,null,null,false],[408,367,0,null,null,null,null,false],[408,368,0,null,null,null,null,false],[408,369,0,null,null,null,null,false],[408,370,0,null,null,null,null,false],[408,371,0,null,null,null,null,false],[408,372,0,null,null,null,null,false],[408,373,0,null,null,null,null,false],[408,374,0,null,null,null,null,false],[408,375,0,null,null,null,null,false],[408,376,0,null,null,null,null,false],[408,377,0,null,null,null,null,false],[408,378,0,null,null,null,null,false],[408,379,0,null,null,null,null,false],[408,380,0,null,null,null,null,false],[408,381,0,null,null,null,null,false],[408,382,0,null,null,null,null,false],[408,383,0,null,null,null,null,false],[408,384,0,null,null,null,null,false],[408,385,0,null,null,null,null,false],[408,386,0,null,null,null,null,false],[408,387,0,null,null,null,null,false],[408,388,0,null,null,null,null,false],[408,389,0,null,null,null,null,false],[408,390,0,null,null,null,null,false],[408,391,0,null,null,null,null,false],[408,392,0,null,null,null,null,false],[408,393,0,null,null,null,null,false],[408,394,0,null,null,null,null,false],[408,395,0,null,null,null,null,false],[408,396,0,null,null,null,null,false],[408,397,0,null,null,null,null,false],[408,398,0,null,null,null,null,false],[408,399,0,null,null,null,null,false],[408,400,0,null,null,null,null,false],[408,401,0,null,null,null,null,false],[408,402,0,null,null,null,null,false],[408,403,0,null,null,null,null,false],[408,404,0,null,null,null,null,false],[408,405,0,null,null,null,null,false],[408,406,0,null,null,null,null,false],[408,407,0,null,null,null,null,false],[408,408,0,null,null,null,null,false],[408,409,0,null,null,null,null,false],[408,410,0,null,null,null,null,false],[408,411,0,null,null,null,null,false],[408,412,0,null,null,null,null,false],[408,413,0,null,null,null,null,false],[408,414,0,null,null,null,null,false],[408,415,0,null,null,null,null,false],[408,416,0,null,null,null,null,false],[408,417,0,null,null,null,null,false],[408,418,0,null,null,null,null,false],[408,419,0,null,null,null,null,false],[408,420,0,null,null,null,null,false],[408,421,0,null,null,null,null,false],[408,422,0,null,null,null,null,false],[408,423,0,null,null,null,null,false],[408,424,0,null,null,null,null,false],[408,425,0,null,null,null,null,false],[408,426,0,null,null,null,null,false],[408,427,0,null,null,null,null,false],[408,428,0,null,null,null,null,false],[408,429,0,null,null,null,null,false],[408,430,0,null,null,null,null,false],[408,431,0,null,null,null,null,false],[408,432,0,null,null,null,null,false],[408,433,0,null,null,null,null,false],[408,434,0,null,null,null,null,false],[408,435,0,null,null,null,null,false],[408,436,0,null,null,null,null,false],[408,437,0,null,null,null,null,false],[408,438,0,null,null,null,null,false],[408,439,0,null,null,null,null,false],[408,440,0,null,null,null,null,false],[408,441,0,null,null,null,null,false],[408,442,0,null,null,null,null,false],[408,443,0,null,null,null,null,false],[408,444,0,null,null,null,null,false],[408,445,0,null,null,null,null,false],[408,446,0,null,null,null,null,false],[408,447,0,null,null,null,null,false],[408,448,0,null,null,null,null,false],[408,449,0,null,null,null,null,false],[408,450,0,null,null,null,null,false],[408,451,0,null,null,null,null,false],[408,452,0,null,null,null,null,false],[408,453,0,null,null,null,null,false],[408,454,0,null,null,null,null,false],[408,455,0,null,null,null,null,false],[408,456,0,null,null,null,null,false],[408,457,0,null,null,null,null,false],[408,458,0,null,null,null,null,false],[408,459,0,null,null,null,null,false],[408,460,0,null,null,null,null,false],[408,461,0,null,null,null,null,false],[408,462,0,null,null,null,null,false],[408,463,0,null,null,null,null,false],[408,464,0,null,null,null,null,false],[408,465,0,null,null,null,null,false],[408,466,0,null,null,null,null,false],[408,467,0,null,null,null,null,false],[408,468,0,null,null,null,null,false],[408,469,0,null,null,null,null,false],[408,470,0,null,null,null,null,false],[408,471,0,null,null,null,null,false],[408,472,0,null,null,null,null,false],[408,473,0,null,null,null,null,false],[408,474,0,null,null,null,null,false],[408,475,0,null,null,null,null,false],[408,476,0,null,null,null,null,false],[408,477,0,null,null,null,null,false],[408,478,0,null,null,null,null,false],[408,479,0,null,null,null,null,false],[408,480,0,null,null,null,null,false],[408,481,0,null,null,null,null,false],[408,482,0,null,null,null,null,false],[408,483,0,null,null,null,null,false],[408,484,0,null,null,null,null,false],[408,485,0,null,null,null,null,false],[408,486,0,null,null,null,null,false],[408,487,0,null,null,null,null,false],[408,488,0,null,null,null,null,false],[408,489,0,null,null,null,null,false],[408,490,0,null,null,null,null,false],[408,491,0,null,null,null,null,false],[408,492,0,null,null,null,null,false],[408,493,0,null,null,null,null,false],[408,494,0,null,null,null,null,false],[408,495,0,null,null,null,null,false],[408,496,0,null,null,null,null,false],[408,497,0,null,null,null,null,false],[408,498,0,null,null,null,null,false],[408,499,0,null,null,null,null,false],[408,500,0,null,null,null,null,false],[408,501,0,null,null,null,null,false],[408,502,0,null,null,null,null,false],[408,503,0,null,null,null,null,false],[408,504,0,null,null,null,null,false],[408,505,0,null,null,null,null,false],[408,506,0,null,null,null,null,false],[408,507,0,null,null,null,null,false],[408,508,0,null,null,null,null,false],[408,509,0,null,null,null,null,false],[408,510,0,null,null,null,null,false],[408,511,0,null,null,null,null,false],[408,512,0,null,null,null,null,false],[408,513,0,null,null,null,null,false],[408,514,0,null,null,null,null,false],[408,515,0,null,null,null,null,false],[408,516,0,null,null,null,null,false],[408,517,0,null,null,null,null,false],[408,518,0,null,null,null,null,false],[408,519,0,null,null,null,null,false],[408,520,0,null,null,null,null,false],[408,521,0,null,null,null,null,false],[408,522,0,null,null,null,null,false],[408,523,0,null,null,null,null,false],[408,524,0,null,null,null,null,false],[408,525,0,null,null,null,null,false],[408,526,0,null,null,null,null,false],[408,527,0,null,null,null,null,false],[408,528,0,null,null,null,null,false],[408,529,0,null,null,null,null,false],[408,530,0,null,null,null,null,false],[408,531,0,null,null,null,null,false],[408,532,0,null,null,null,null,false],[408,533,0,null,null,null,null,false],[408,534,0,null,null,null,null,false],[408,535,0,null,null,null,null,false],[408,536,0,null,null,null,null,false],[408,537,0,null,null,null,null,false],[408,538,0,null,null,null,null,false],[408,539,0,null,null,null,null,false],[408,540,0,null,null,null,null,false],[408,541,0,null,null,null,null,false],[408,542,0,null,null,null,null,false],[408,543,0,null,null,null,null,false],[408,544,0,null,null,null,null,false],[408,545,0,null,null,null,null,false],[408,546,0,null,null,null,null,false],[408,547,0,null,null,null,null,false],[408,548,0,null,null,null,null,false],[408,549,0,null,null,null,null,false],[408,550,0,null,null,null,null,false],[408,551,0,null,null,null,null,false],[408,552,0,null,null,null,null,false],[408,553,0,null,null,null,null,false],[408,554,0,null,null,null,null,false],[408,555,0,null,null,null,null,false],[408,556,0,null,null,null,null,false],[408,557,0,null,null,null,null,false],[408,558,0,null,null,null,null,false],[408,559,0,null,null,null,null,false],[408,560,0,null,null,null,null,false],[408,561,0,null,null,null,null,false],[408,562,0,null,null,null,null,false],[408,563,0,null,null,null,null,false],[408,564,0,null,null,null,null,false],[408,565,0,null,null,null,null,false],[408,566,0,null,null,null,null,false],[408,567,0,null,null,null,null,false],[408,568,0,null,null,null,null,false],[408,569,0,null,null,null,null,false],[408,570,0,null,null,null,null,false],[408,571,0,null,null,null,null,false],[408,572,0,null,null,null,null,false],[408,573,0,null,null,null,null,false],[408,574,0,null,null,null,null,false],[408,575,0,null,null,null,null,false],[408,576,0,null,null,null,null,false],[408,577,0,null,null,null,null,false],[408,578,0,null,null,null,null,false],[408,579,0,null,null,null,null,false],[408,580,0,null,null,null,null,false],[408,581,0,null,null,null,null,false],[408,582,0,null,null,null,null,false],[408,583,0,null,null,null,null,false],[408,584,0,null,null,null,null,false],[408,585,0,null,null,null,null,false],[408,586,0,null,null,null,null,false],[408,587,0,null,null,null,null,false],[408,588,0,null,null,null,null,false],[408,589,0,null,null,null,null,false],[408,590,0,null,null,null,null,false],[408,591,0,null,null,null,null,false],[408,592,0,null,null,null,null,false],[408,593,0,null,null,null,null,false],[408,594,0,null,null,null,null,false],[408,595,0,null,null,null,null,false],[408,596,0,null,null,null,null,false],[408,597,0,null,null,null,null,false],[408,598,0,null,null,null,null,false],[408,599,0,null,null,null,null,false],[408,600,0,null,null,null,null,false],[408,601,0,null,null,null,null,false],[408,602,0,null,null,null,null,false],[408,603,0,null,null,null,null,false],[408,604,0,null,null,null,null,false],[408,605,0,null,null,null,null,false],[408,606,0,null,null,null,null,false],[408,607,0,null,null,null,null,false],[408,608,0,null,null,null,null,false],[408,609,0,null,null,null,null,false],[408,610,0,null,null,null,null,false],[408,611,0,null,null,null,null,false],[408,612,0,null,null,null,null,false],[408,613,0,null,null,null,null,false],[408,614,0,null,null,null,null,false],[408,615,0,null,null,null,null,false],[408,616,0,null,null,null,null,false],[408,617,0,null,null,null,null,false],[408,618,0,null,null,null,null,false],[408,619,0,null,null,null,null,false],[408,620,0,null,null,null,null,false],[408,621,0,null,null,null,null,false],[408,622,0,null,null,null,null,false],[408,623,0,null,null,null,null,false],[408,624,0,null,null,null,null,false],[408,625,0,null,null,null,null,false],[408,626,0,null,null,null,null,false],[408,627,0,null,null,null,null,false],[408,628,0,null,null,null,null,false],[408,629,0,null,null,null,null,false],[408,630,0,null,null,null,null,false],[408,631,0,null,null,null,null,false],[408,632,0,null,null,null,null,false],[408,633,0,null,null,null,null,false],[408,634,0,null,null,null,null,false],[408,635,0,null,null,null,null,false],[408,636,0,null,null,null,null,false],[408,637,0,null,null,null,null,false],[408,638,0,null,null,null,null,false],[408,639,0,null,null,null,null,false],[408,640,0,null,null,null,null,false],[408,641,0,null,null,null,null,false],[408,642,0,null,null,null,null,false],[408,643,0,null,null,null,null,false],[408,644,0,null,null,null,null,false],[408,645,0,null,null,null,null,false],[408,646,0,null,null,null,null,false],[408,647,0,null,null,null,null,false],[408,648,0,null,null,null,null,false],[408,649,0,null,null,null,null,false],[408,650,0,null,null,null,null,false],[408,651,0,null,null,null,null,false],[408,652,0,null,null,null,null,false],[408,653,0,null,null,null,null,false],[408,654,0,null,null,null,null,false],[408,655,0,null,null,null,null,false],[408,656,0,null,null,null,null,false],[408,657,0,null,null,null,null,false],[408,658,0,null,null,null,null,false],[408,659,0,null,null,null,null,false],[408,660,0,null,null,null,null,false],[408,661,0,null,null,null,null,false],[408,662,0,null,null,null,null,false],[408,663,0,null,null,null,null,false],[408,664,0,null,null,null,null,false],[408,665,0,null,null,null,null,false],[408,666,0,null,null,null,null,false],[408,667,0,null,null,null,null,false],[408,668,0,null,null,null,null,false],[408,669,0,null,null,null,null,false],[408,670,0,null,null,null,null,false],[408,671,0,null,null,null,null,false],[408,672,0,null,null,null,null,false],[408,673,0,null,null,null,null,false],[408,674,0,null,null,null,null,false],[408,675,0,null,null,null,null,false],[408,676,0,null,null,null,null,false],[408,677,0,null,null,null,null,false],[408,678,0,null,null,null,null,false],[408,679,0,null,null,null,null,false],[408,680,0,null,null,null,null,false],[408,681,0,null,null,null,null,false],[408,682,0,null,null,null,null,false],[408,683,0,null,null,null,null,false],[408,684,0,null,null,null,null,false],[408,685,0,null,null,null,null,false],[408,686,0,null,null,null,null,false],[408,687,0,null,null,null,null,false],[408,688,0,null,null,null,null,false],[408,689,0,null,null,null,null,false],[408,690,0,null,null,null,null,false],[408,691,0,null,null,null,null,false],[408,692,0,null,null,null,null,false],[408,693,0,null,null,null,null,false],[408,694,0,null,null,null,null,false],[408,695,0,null,null,null,null,false],[408,696,0,null,null,null,null,false],[408,697,0,null,null,null,null,false],[408,698,0,null,null,null,null,false],[408,699,0,null,null,null,null,false],[408,700,0,null,null,null,null,false],[408,701,0,null,null,null,null,false],[408,702,0,null,null,null,null,false],[408,703,0,null,null,null,null,false],[408,704,0,null,null,null,null,false],[408,705,0,null,null,null,null,false],[408,706,0,null,null,null,null,false],[408,707,0,null,null,null,null,false],[408,708,0,null,null,null,null,false],[408,709,0,null,null,null,null,false],[408,710,0,null,null,null,null,false],[408,711,0,null,null,null,null,false],[408,712,0,null,null,null,null,false],[408,713,0,null,null,null,null,false],[408,714,0,null,null,null,null,false],[408,715,0,null,null,null,null,false],[408,716,0,null,null,null,null,false],[408,717,0,null,null,null,null,false],[408,718,0,null,null,null,null,false],[408,719,0,null,null,null,null,false],[408,720,0,null,null,null,null,false],[408,721,0,null,null,null,null,false],[408,722,0,null,null,null,null,false],[408,723,0,null,null,null,null,false],[408,724,0,null,null,null,null,false],[408,725,0,null,null,null,null,false],[408,726,0,null,null,null,null,false],[408,727,0,null,null,null,null,false],[408,728,0,null,null,null,null,false],[408,729,0,null,null,null,null,false],[408,730,0,null,null,null,null,false],[408,731,0,null,null,null,null,false],[408,732,0,null,null,null,null,false],[408,733,0,null,null,null,null,false],[408,734,0,null,null,null,null,false],[408,735,0,null,null,null,null,false],[408,736,0,null,null,null,null,false],[408,737,0,null,null,null,null,false],[408,738,0,null,null,null,null,false],[408,739,0,null,null,null,null,false],[408,740,0,null,null,null,null,false],[408,741,0,null,null,null,null,false],[408,742,0,null,null,null,null,false],[408,743,0,null,null,null,null,false],[408,744,0,null,null,null,null,false],[408,745,0,null,null,null,null,false],[408,746,0,null,null,null,null,false],[408,747,0,null,null,null,null,false],[408,748,0,null,null,null,null,false],[408,749,0,null,null,null,null,false],[408,750,0,null,null,null,null,false],[408,751,0,null,null,null,null,false],[408,752,0,null,null,null,null,false],[408,753,0,null,null,null,null,false],[408,754,0,null,null,null,null,false],[408,755,0,null,null,null,null,false],[408,756,0,null,null,null,null,false],[408,757,0,null,null,null,null,false],[408,758,0,null,null,null,null,false],[408,759,0,null,null,null,null,false],[408,760,0,null,null,null,null,false],[408,761,0,null,null,null,null,false],[408,762,0,null,null,null,null,false],[408,763,0,null,null,null,null,false],[408,764,0,null,null,null,null,false],[408,765,0,null,null,null,null,false],[408,766,0,null,null,null,null,false],[408,767,0,null,null,null,null,false],[408,768,0,null,null,null,null,false],[408,769,0,null,null,null,null,false],[408,770,0,null,null,null,null,false],[408,771,0,null,null,null,null,false],[408,772,0,null,null,null,null,false],[408,773,0,null,null,null,null,false],[408,774,0,null,null,null,null,false],[408,775,0,null,null,null,null,false],[408,776,0,null,null,null,null,false],[408,777,0,null,null,null,null,false],[408,778,0,null,null,null,null,false],[408,779,0,null,null,null,null,false],[408,780,0,null,null,null,null,false],[408,781,0,null,null,null,null,false],[408,782,0,null,null,null,null,false],[408,783,0,null,null,null,null,false],[408,784,0,null,null,null,null,false],[408,785,0,null,null,null,null,false],[408,786,0,null,null,null,null,false],[408,787,0,null,null,null,null,false],[408,788,0,null,null,null,null,false],[408,789,0,null,null,null,null,false],[408,790,0,null,null,null,null,false],[408,791,0,null,null,null,null,false],[408,792,0,null,null,null,null,false],[408,793,0,null,null,null,null,false],[408,794,0,null,null,null,null,false],[408,795,0,null,null,null,null,false],[408,796,0,null,null,null,null,false],[408,797,0,null,null,null,null,false],[408,798,0,null,null,null,null,false],[408,799,0,null,null,null,null,false],[408,800,0,null,null,null,null,false],[408,801,0,null,null,null,null,false],[408,802,0,null,null,null,null,false],[408,803,0,null,null,null,null,false],[408,804,0,null,null,null,null,false],[408,805,0,null,null,null,null,false],[408,806,0,null,null,null,null,false],[408,807,0,null,null,null,null,false],[408,808,0,null,null,null,null,false],[408,809,0,null,null,null,null,false],[408,810,0,null,null,null,null,false],[408,811,0,null,null,null,null,false],[408,812,0,null,null,null,null,false],[408,813,0,null,null,null,null,false],[408,814,0,null,null,null,null,false],[408,815,0,null,null,null,null,false],[408,816,0,null,null,null,null,false],[408,817,0,null,null,null,null,false],[408,818,0,null,null,null,null,false],[408,819,0,null,null,null,null,false],[408,820,0,null,null,null,null,false],[408,821,0,null,null,null,null,false],[408,822,0,null,null,null,null,false],[408,823,0,null,null,null,null,false],[408,824,0,null,null,null,null,false],[408,825,0,null,null,null,null,false],[408,826,0,null,null,null,null,false],[408,827,0,null,null,null,null,false],[408,828,0,null,null,null,null,false],[408,829,0,null,null,null,null,false],[408,830,0,null,null,null,null,false],[408,831,0,null,null,null,null,false],[408,832,0,null,null,null,null,false],[408,833,0,null,null,null,null,false],[408,834,0,null,null,null,null,false],[408,835,0,null,null,null,null,false],[408,836,0,null,null,null,null,false],[408,837,0,null,null,null,null,false],[408,838,0,null,null,null,null,false],[408,839,0,null,null,null,null,false],[408,840,0,null,null,null,null,false],[408,841,0,null,null,null,null,false],[408,842,0,null,null,null,null,false],[408,843,0,null,null,null,null,false],[408,844,0,null,null,null,null,false],[408,845,0,null,null,null,null,false],[408,846,0,null,null,null,null,false],[408,847,0,null,null,null,null,false],[408,848,0,null,null,null,null,false],[408,849,0,null,null,null,null,false],[408,850,0,null,null,null,null,false],[408,851,0,null,null,null,null,false],[408,852,0,null,null,null,null,false],[408,853,0,null,null,null,null,false],[408,854,0,null,null,null,null,false],[408,855,0,null,null,null,null,false],[408,856,0,null,null,null,null,false],[408,857,0,null,null,null,null,false],[408,858,0,null,null,null,null,false],[408,859,0,null,null,null,null,false],[408,860,0,null,null,null,null,false],[408,861,0,null,null,null,null,false],[408,862,0,null,null,null,null,false],[408,863,0,null,null,null,null,false],[408,864,0,null,null,null,null,false],[408,865,0,null,null,null,null,false],[408,866,0,null,null,null,null,false],[408,867,0,null,null,null,null,false],[408,868,0,null,null,null,null,false],[408,869,0,null,null,null,null,false],[408,870,0,null,null,null,null,false],[408,871,0,null,null,null,null,false],[408,872,0,null,null,null,null,false],[408,873,0,null,null,null,null,false],[408,874,0,null,null,null,null,false],[408,875,0,null,null,null,null,false],[408,876,0,null,null,null,null,false],[408,877,0,null,null,null,null,false],[408,878,0,null,null,null,null,false],[408,879,0,null,null,null,null,false],[408,880,0,null,null,null,null,false],[408,881,0,null,null,null,null,false],[408,882,0,null,null,null,null,false],[408,883,0,null,null,null,null,false],[408,884,0,null,null,null,null,false],[408,885,0,null,null,null,null,false],[408,886,0,null,null,null,null,false],[408,887,0,null,null,null,null,false],[408,888,0,null,null,null,null,false],[408,889,0,null,null,null,null,false],[408,890,0,null,null,null,null,false],[408,891,0,null,null,null,null,false],[408,892,0,null,null,null,null,false],[408,893,0,null,null,null,null,false],[408,894,0,null,null,null,null,false],[408,895,0,null,null,null,null,false],[408,896,0,null,null,null,null,false],[408,897,0,null,null,null,null,false],[408,898,0,null,null,null,null,false],[408,899,0,null,null,null,null,false],[408,900,0,null,null,null,null,false],[408,901,0,null,null,null,null,false],[408,902,0,null,null,null,null,false],[408,903,0,null,null,null,null,false],[408,904,0,null,null,null,null,false],[408,905,0,null,null,null,null,false],[408,906,0,null,null,null,null,false],[408,907,0,null,null,null,null,false],[408,908,0,null,null,null,null,false],[408,909,0,null,null,null,null,false],[408,910,0,null,null,null,null,false],[408,911,0,null,null,null,null,false],[408,912,0,null,null,null,null,false],[408,913,0,null,null,null,null,false],[408,914,0,null,null,null,null,false],[408,915,0,null,null,null,null,false],[408,916,0,null,null,null,null,false],[408,917,0,null,null,null,null,false],[408,918,0,null,null,null,null,false],[408,919,0,null,null,null,null,false],[408,920,0,null,null,null,null,false],[408,921,0,null,null,null,null,false],[408,922,0,null,null,null,null,false],[408,923,0,null,null,null,null,false],[408,924,0,null,null,null,null,false],[408,925,0,null,null,null,null,false],[408,926,0,null,null,null,null,false],[408,927,0,null,null,null,null,false],[408,928,0,null,null,null,null,false],[408,929,0,null,null,null,null,false],[408,930,0,null,null,null,null,false],[408,931,0,null,null,null,null,false],[408,932,0,null,null,null,null,false],[408,933,0,null,null,null,null,false],[408,934,0,null,null,null,null,false],[408,935,0,null,null,null,null,false],[408,936,0,null,null,null,null,false],[408,937,0,null,null,null,null,false],[408,938,0,null,null,null,null,false],[408,939,0,null,null,null,null,false],[408,940,0,null,null,null,null,false],[408,941,0,null,null,null,null,false],[408,942,0,null,null,null,null,false],[408,943,0,null,null,null,null,false],[408,944,0,null,null,null,null,false],[408,945,0,null,null,null,null,false],[408,946,0,null,null,null,null,false],[408,947,0,null,null,null,null,false],[408,948,0,null,null,null,null,false],[408,949,0,null,null,null,null,false],[408,950,0,null,null,null,null,false],[408,951,0,null,null,null,null,false],[408,952,0,null,null,null,null,false],[408,953,0,null,null,null,null,false],[408,954,0,null,null,null,null,false],[408,955,0,null,null,null,null,false],[408,956,0,null,null,null,null,false],[408,957,0,null,null,null,null,false],[408,958,0,null,null,null,null,false],[408,959,0,null,null,null,null,false],[408,960,0,null,null,null,null,false],[408,961,0,null,null,null,null,false],[408,962,0,null,null,null,null,false],[408,963,0,null,null,null,null,false],[408,964,0,null,null,null,null,false],[408,965,0,null,null,null,null,false],[408,966,0,null,null,null,null,false],[408,967,0,null,null,null,null,false],[408,968,0,null,null,null,null,false],[408,969,0,null,null,null,null,false],[408,970,0,null,null,null,null,false],[408,971,0,null,null,null,null,false],[408,972,0,null,null,null,null,false],[408,973,0,null,null,null,null,false],[408,974,0,null,null,null,null,false],[408,975,0,null,null,null,null,false],[408,976,0,null,null,null,null,false],[408,977,0,null,null,null,null,false],[408,978,0,null,null,null,null,false],[408,979,0,null,null,null,null,false],[408,980,0,null,null,null,null,false],[408,981,0,null,null,null,null,false],[408,982,0,null,null,null,null,false],[408,983,0,null,null,null,null,false],[408,984,0,null,null,null,null,false],[408,985,0,null,null,null,null,false],[408,986,0,null,null,null,null,false],[408,987,0,null,null,null,null,false],[408,988,0,null,null,null,null,false],[408,989,0,null,null,null,null,false],[408,990,0,null,null,null,null,false],[408,991,0,null,null,null,null,false],[408,992,0,null,null,null,null,false],[408,993,0,null,null,null,null,false],[408,994,0,null,null,null,null,false],[408,995,0,null,null,null,null,false],[408,996,0,null,null,null,null,false],[408,997,0,null,null,null,null,false],[408,998,0,null,null,null,null,false],[408,999,0,null,null,null,null,false],[408,1000,0,null,null,null,null,false],[408,1001,0,null,null,null,null,false],[408,1002,0,null,null,null,null,false],[408,1003,0,null,null,null,null,false],[408,1004,0,null,null,null,null,false],[408,1005,0,null,null,null,null,false],[408,1006,0,null,null,null,null,false],[408,1007,0,null,null,null,null,false],[408,1008,0,null,null,null,null,false],[408,1009,0,null,null,null,null,false],[408,1010,0,null,null,null,null,false],[408,1011,0,null,null,null,null,false],[408,1012,0,null,null,null,null,false],[408,1013,0,null,null,null,null,false],[408,1014,0,null,null,null,null,false],[408,1015,0,null,null,null,null,false],[408,1016,0,null,null,null,null,false],[408,1017,0,null,null,null,null,false],[408,1018,0,null,null,null,null,false],[408,1019,0,null,null,null,null,false],[408,1020,0,null,null,null,null,false],[408,1021,0,null,null,null,null,false],[408,1022,0,null,null,null,null,false],[408,1023,0,null,null,null,null,false],[408,1024,0,null,null,null,null,false],[408,1025,0,null,null,null,null,false],[408,1026,0,null,null,null,null,false],[408,1027,0,null,null,null,null,false],[408,1028,0,null,null,null,null,false],[408,1029,0,null,null,null,null,false],[408,1030,0,null,null,null,null,false],[408,1031,0,null,null,null,null,false],[408,1032,0,null,null,null,null,false],[408,1033,0,null,null,null,null,false],[408,1034,0,null,null,null,null,false],[408,1035,0,null,null,null,null,false],[408,1036,0,null,null,null,null,false],[408,1037,0,null,null,null,null,false],[408,1038,0,null,null,null,null,false],[408,1039,0,null,null,null,null,false],[408,1040,0,null,null,null,null,false],[408,1041,0,null,null,null,null,false],[408,1043,0,null,null,null,[49663,49664,49665,49666],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[408,1044,0,null,null,null,[49668,49669,49670,49671],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[408,1055,0,null,null,null,[49673,49674,49675,49676],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[408,1056,0,null,null,null,null,false],[408,1057,0,null,null,null,[49679,49680,49681,49682],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[408,1070,0,null,null,null,null,false],[408,1071,0,null,null,null,null,false],[408,1072,0,null,null,null,null,false],[408,1074,0,null,null,null,[49687,49688,49689,49690,49691],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[0,0,0,"wRemoveMsg",null,"",null,false],[408,1075,0,null,null,null,[49693,49694,49695,49696,49697],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[0,0,0,"wRemoveMsg",null,"",null,false],[408,1086,0,null,null,null,[49699,49700,49701,49702,49703],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[0,0,0,"wRemoveMsg",null,"",null,false],[408,1087,0,null,null,null,null,false],[408,1088,0,null,null,null,[49706,49707,49708,49709,49710],false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsgFilterMin",null,"",null,false],[0,0,0,"wMsgFilterMax",null,"",null,false],[0,0,0,"wRemoveMsg",null,"",null,false],[408,1101,0,null,null,null,[49712],false],[0,0,0,"lpMsg",null,"",null,false],[408,1102,0,null,null,null,[49714],false],[0,0,0,"lpMsg",null,"",null,false],[408,1106,0,null,null,null,[49716],false],[0,0,0,"lpMsg",null,"",null,false],[408,1107,0,null,null,null,[49718],false],[0,0,0,"lpMsg",null,"",null,false],[408,1111,0,null,null,null,[49720],false],[0,0,0,"lpMsg",null,"",null,false],[408,1112,0,null,null,null,null,false],[408,1113,0,null,null,null,[49723],false],[0,0,0,"lpMsg",null,"",null,false],[408,1118,0,null,null,null,[49725],false],[0,0,0,"nExitCode",null,"",null,false],[408,1119,0,null,null,null,[49727],false],[0,0,0,"nExitCode",null,"",null,false],[408,1123,0,null,null,null,[49729,49730,49731,49732],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"Msg",null,"",null,false],[0,0,0,"wParam",null,"",null,false],[0,0,0,"lParam",null,"",null,false],[408,1124,0,null,null,null,[49734,49735,49736,49737],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"Msg",null,"",null,false],[0,0,0,"wParam",null,"",null,false],[0,0,0,"lParam",null,"",null,false],[408,1128,0,null,null,null,[49739,49740,49741,49742],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"Msg",null,"",null,false],[0,0,0,"wParam",null,"",null,false],[0,0,0,"lParam",null,"",null,false],[408,1129,0,null,null,null,null,false],[408,1130,0,null,null,null,[49745,49746,49747,49748],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"Msg",null,"",null,false],[0,0,0,"wParam",null,"",null,false],[0,0,0,"lParam",null,"",null,false],[408,1137,0,null,null,null,null,false],[408,1138,0,null,null,null,null,false],[408,1139,0,null,null,null,null,false],[408,1140,0,null,null,null,null,false],[408,1141,0,null,null,null,null,false],[408,1142,0,null,null,null,null,false],[408,1143,0,null,null,null,null,false],[408,1144,0,null,null,null,null,false],[408,1145,0,null,null,null,null,false],[408,1146,0,null,null,null,null,false],[408,1147,0,null,null,null,null,false],[408,1149,0,null,null,null,[49762,49764,49766,49767,49768,49770,49772,49774,49776,49778,49780,49782],false],[408,1149,0,null,null,null,null,false],[0,0,0,"cbSize",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"style",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"lpfnWndProc",null,null,null,false],[0,0,0,"cbClsExtra",null,null,null,false],[0,0,0,"cbWndExtra",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"hInstance",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"hIcon",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"hCursor",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"hbrBackground",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"lpszMenuName",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"lpszClassName",null,null,null,false],[408,1149,0,null,null,null,null,false],[0,0,0,"hIconSm",null,null,null,false],[408,1164,0,null,null,null,[49785,49787,49789,49790,49791,49793,49795,49797,49799,49801,49803,49805],false],[408,1164,0,null,null,null,null,false],[0,0,0,"cbSize",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"style",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"lpfnWndProc",null,null,null,false],[0,0,0,"cbClsExtra",null,null,null,false],[0,0,0,"cbWndExtra",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"hInstance",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"hIcon",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"hCursor",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"hbrBackground",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"lpszMenuName",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"lpszClassName",null,null,null,false],[408,1164,0,null,null,null,null,false],[0,0,0,"hIconSm",null,null,null,false],[408,1179,0,null,null,null,[49807],false],[0,0,0,"",null,"",null,false],[408,1180,0,null,null,null,[49809],false],[0,0,0,"window_class",null,"",null,false],[408,1190,0,null,null,null,[49811],false],[0,0,0,"",null,"",null,false],[408,1191,0,null,null,null,null,false],[408,1192,0,null,null,null,[49814],false],[0,0,0,"window_class",null,"",null,false],[408,1204,0,null,null,null,[49816,49817],false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[408,1205,0,null,null,null,[49819,49820],false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[408,1214,0,null,null,null,[49822,49823],false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[408,1215,0,null,null,null,null,false],[408,1216,0,null,null,null,[49826,49827],false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[408,1226,0,null,null,null,null,false],[408,1227,0,null,null,null,null,false],[408,1228,0,null,null,null,null,false],[408,1229,0,null,null,null,null,false],[408,1230,0,null,null,null,null,false],[408,1231,0,null,null,null,null,false],[408,1232,0,null,null,null,null,false],[408,1233,0,null,null,null,null,false],[408,1234,0,null,null,null,null,false],[408,1235,0,null,null,null,null,false],[408,1236,0,null,null,null,null,false],[408,1237,0,null,null,null,null,false],[408,1238,0,null,null,null,null,false],[408,1239,0,null,null,null,null,false],[408,1240,0,null,null,null,null,false],[408,1241,0,null,null,null,null,false],[408,1242,0,null,null,null,null,false],[408,1243,0,null,null,null,null,false],[408,1244,0,null,null,null,null,false],[408,1245,0,null,null,null,null,false],[408,1246,0,null,null,null,null,false],[408,1247,0,null,null,null,null,false],[408,1248,0,null,null,null,null,false],[408,1249,0,null,null,null,null,false],[408,1250,0,null,null,null,null,false],[408,1251,0,null,null,null,null,false],[408,1252,0,null,null,null,null,false],[408,1254,0,null,null,null,null,false],[408,1255,0,null,null,null,null,false],[408,1256,0,null,null,null,null,false],[408,1257,0,null,null,null,null,false],[408,1258,0,null,null,null,null,false],[408,1259,0,null,null,null,null,false],[408,1260,0,null,null,null,null,false],[408,1261,0,null,null,null,null,false],[408,1262,0,null,null,null,null,false],[408,1263,0,null,null,null,null,false],[408,1264,0,null,null,null,null,false],[408,1265,0,null,null,null,null,false],[408,1266,0,null,null,null,null,false],[408,1267,0,null,null,null,null,false],[408,1268,0,null,null,null,null,false],[408,1269,0,null,null,null,null,false],[408,1270,0,null,null,null,null,false],[408,1271,0,null,null,null,null,false],[408,1272,0,null,null,null,null,false],[408,1273,0,null,null,null,null,false],[408,1274,0,null,null,null,null,false],[408,1275,0,null,null,null,null,false],[408,1277,0,null,null,null,null,false],[408,1279,0,null,null,null,[49879,49880,49881,49882,49883,49884,49885,49886,49887,49888,49889,49890],false],[0,0,0,"dwExStyle",null,"",null,false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"lpWindowName",null,"",null,false],[0,0,0,"dwStyle",null,"",null,false],[0,0,0,"X",null,"",null,false],[0,0,0,"Y",null,"",null,false],[0,0,0,"nWidth",null,"",null,false],[0,0,0,"nHeight",null,"",null,false],[0,0,0,"hWindParent",null,"",null,false],[0,0,0,"hMenu",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[0,0,0,"lpParam",null,"",null,false],[408,1280,0,null,null,null,[49892,49893,49894,49895,49896,49897,49898,49899,49900,49901,49902,49903],false],[0,0,0,"dwExStyle",null,"",null,false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"lpWindowName",null,"",null,false],[0,0,0,"dwStyle",null,"",null,false],[0,0,0,"X",null,"",null,false],[0,0,0,"Y",null,"",null,false],[0,0,0,"nWidth",null,"",null,false],[0,0,0,"nHeight",null,"",null,false],[0,0,0,"hWindParent",null,"",null,false],[0,0,0,"hMenu",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[0,0,0,"lpParam",null,"",null,false],[408,1291,0,null,null,null,[49905,49906,49907,49908,49909,49910,49911,49912,49913,49914,49915,49916],false],[0,0,0,"dwExStyle",null,"",null,false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"lpWindowName",null,"",null,false],[0,0,0,"dwStyle",null,"",null,false],[0,0,0,"X",null,"",null,false],[0,0,0,"Y",null,"",null,false],[0,0,0,"nWidth",null,"",null,false],[0,0,0,"nHeight",null,"",null,false],[0,0,0,"hWindParent",null,"",null,false],[0,0,0,"hMenu",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[0,0,0,"lpParam",null,"",null,false],[408,1292,0,null,null,null,null,false],[408,1293,0,null,null,null,[49919,49920,49921,49922,49923,49924,49925,49926,49927,49928,49929,49930],false],[0,0,0,"dwExStyle",null,"",null,false],[0,0,0,"lpClassName",null,"",null,false],[0,0,0,"lpWindowName",null,"",null,false],[0,0,0,"dwStyle",null,"",null,false],[0,0,0,"X",null,"",null,false],[0,0,0,"Y",null,"",null,false],[0,0,0,"nWidth",null,"",null,false],[0,0,0,"nHeight",null,"",null,false],[0,0,0,"hWindParent",null,"",null,false],[0,0,0,"hMenu",null,"",null,false],[0,0,0,"hInstance",null,"",null,false],[0,0,0,"lpParam",null,"",null,false],[408,1305,0,null,null,null,[49932],false],[0,0,0,"hWnd",null,"",null,false],[408,1306,0,null,null,null,[49934],false],[0,0,0,"hWnd",null,"",null,false],[408,1316,0,null,null,null,null,false],[408,1317,0,null,null,null,null,false],[408,1318,0,null,null,null,null,false],[408,1319,0,null,null,null,null,false],[408,1320,0,null,null,null,null,false],[408,1321,0,null,null,null,null,false],[408,1322,0,null,null,null,null,false],[408,1323,0,null,null,null,null,false],[408,1324,0,null,null,null,null,false],[408,1325,0,null,null,null,null,false],[408,1326,0,null,null,null,null,false],[408,1327,0,null,null,null,null,false],[408,1328,0,null,null,null,null,false],[408,1329,0,null,null,null,null,false],[408,1330,0,null,null,null,null,false],[408,1332,0,null,null,null,[49951,49952],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nCmdShow",null,"",null,false],[408,1333,0,null,null,null,[49954,49955],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nCmdShow",null,"",null,false],[408,1337,0,null,null,null,[49957],false],[0,0,0,"hWnd",null,"",null,false],[408,1338,0,null,null,null,[49959],false],[0,0,0,"hWnd",null,"",null,false],[408,1348,0,null,null,null,[49961,49962,49963,49964],false],[0,0,0,"lpRect",null,"",null,false],[0,0,0,"dwStyle",null,"",null,false],[0,0,0,"bMenu",null,"",null,false],[0,0,0,"dwExStyle",null,"",null,false],[408,1349,0,null,null,null,[49966,49967,49968,49969],false],[0,0,0,"lpRect",null,"",null,false],[0,0,0,"dwStyle",null,"",null,false],[0,0,0,"bMenu",null,"",null,false],[0,0,0,"dwExStyle",null,"",null,false],[408,1360,0,null,null,null,null,false],[408,1361,0,null,null,null,null,false],[408,1362,0,null,null,null,null,false],[408,1363,0,null,null,null,null,false],[408,1364,0,null,null,null,null,false],[408,1365,0,null,null,null,null,false],[408,1366,0,null,null,null,null,false],[408,1368,0,null,null,null,[49978,49979],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1369,0,null,null,null,[49981,49982],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1381,0,null,null,null,[49984,49985],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1382,0,null,null,null,null,false],[408,1383,0,null,null,null,[49988,49989],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1397,0,null,null,null,[49991,49992],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1398,0,null,null,null,[49994,49995],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1414,0,null,null,null,[49997,49998],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1415,0,null,null,null,null,false],[408,1416,0,null,null,null,[50001,50002],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[408,1431,0,null,null,null,[50004,50005,50006],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1432,0,null,null,null,[50008,50009,50010],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1448,0,null,null,null,[50012,50013,50014],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1449,0,null,null,null,null,false],[408,1450,0,null,null,null,[50017,50018,50019],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1465,0,null,null,null,[50021,50022,50023],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1466,0,null,null,null,[50025,50026,50027],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1483,0,null,null,null,[50029,50030,50031],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1484,0,null,null,null,null,false],[408,1485,0,null,null,null,[50034,50035,50036],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"nIndex",null,"",null,false],[0,0,0,"dwNewLong",null,"",null,false],[408,1501,0,null,null,null,[50038],false],[0,0,0,"hWnd",null,"",null,false],[408,1502,0,null,null,null,[50040],false],[0,0,0,"hWnd",null,"",null,false],[408,1513,0,null,null,null,[50042,50043],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"hDC",null,"",null,false],[408,1514,0,null,null,null,[50045,50046],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"hDC",null,"",null,false],[408,1520,0,null,null,null,null,false],[408,1521,0,null,null,null,null,false],[408,1522,0,null,null,null,null,false],[408,1523,0,null,null,null,null,false],[408,1524,0,null,null,null,null,false],[408,1525,0,null,null,null,null,false],[408,1526,0,null,null,null,null,false],[408,1527,0,null,null,null,null,false],[408,1528,0,null,null,null,null,false],[408,1529,0,null,null,null,null,false],[408,1530,0,null,null,null,null,false],[408,1531,0,null,null,null,null,false],[408,1532,0,null,null,null,null,false],[408,1533,0,null,null,null,null,false],[408,1534,0,null,null,null,null,false],[408,1535,0,null,null,null,null,false],[408,1536,0,null,null,null,null,false],[408,1537,0,null,null,null,null,false],[408,1538,0,null,null,null,null,false],[408,1539,0,null,null,null,null,false],[408,1540,0,null,null,null,null,false],[408,1541,0,null,null,null,null,false],[408,1542,0,null,null,null,null,false],[408,1543,0,null,null,null,null,false],[408,1544,0,null,null,null,null,false],[408,1545,0,null,null,null,null,false],[408,1546,0,null,null,null,null,false],[408,1547,0,null,null,null,null,false],[408,1548,0,null,null,null,null,false],[408,1549,0,null,null,null,null,false],[408,1550,0,null,null,null,null,false],[408,1551,0,null,null,null,null,false],[408,1552,0,null,null,null,null,false],[408,1553,0,null,null,null,null,false],[408,1554,0,null,null,null,null,false],[408,1556,0,null,null,null,null,false],[408,1557,0,null,null,null,null,false],[408,1558,0,null,null,null,null,false],[408,1559,0,null,null,null,null,false],[408,1560,0,null,null,null,null,false],[408,1561,0,null,null,null,null,false],[408,1562,0,null,null,null,null,false],[408,1563,0,null,null,null,null,false],[408,1564,0,null,null,null,null,false],[408,1565,0,null,null,null,null,false],[408,1566,0,null,null,null,null,false],[408,1568,0,null,null,null,[50094,50095,50096,50097],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"lpText",null,"",null,false],[0,0,0,"lpCaption",null,"",null,false],[0,0,0,"uType",null,"",null,false],[408,1569,0,null,null,null,[50099,50100,50101,50102],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"lpText",null,"",null,false],[0,0,0,"lpCaption",null,"",null,false],[0,0,0,"uType",null,"",null,false],[408,1579,0,null,null,null,[50104,50105,50106,50107],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"lpText",null,"",null,false],[0,0,0,"lpCaption",null,"",null,false],[0,0,0,"uType",null,"",null,false],[408,1580,0,null,null,null,null,false],[408,1581,0,null,null,null,[50110,50111,50112,50113],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"lpText",null,"",null,false],[0,0,0,"lpCaption",null,"",null,false],[0,0,0,"uType",null,"",null,false],[401,27,0,null,null,null,null,false],[0,0,0,"windows/ws2_32.zig",null,"",[],false],[409,0,0,null,null,null,null,false],[409,1,0,null,null,null,null,false],[409,2,0,null,null,null,null,false],[409,4,0,null,null,null,null,false],[409,5,0,null,null,null,null,false],[409,6,0,null,null,null,null,false],[409,7,0,null,null,null,null,false],[409,8,0,null,null,null,null,false],[409,9,0,null,null,null,null,false],[409,10,0,null,null,null,null,false],[409,11,0,null,null,null,null,false],[409,12,0,null,null,null,null,false],[409,13,0,null,null,null,null,false],[409,14,0,null,null,null,null,false],[409,15,0,null,null,null,null,false],[409,16,0,null,null,null,null,false],[409,17,0,null,null,null,null,false],[409,18,0,null,null,null,null,false],[409,19,0,null,null,null,null,false],[409,20,0,null,null,null,null,false],[409,22,0,null,null,null,null,false],[409,23,0,null,null,null,null,false],[409,25,0,null,null,null,null,false],[409,26,0,null,null,null,null,false],[409,27,0,null,null,null,null,false],[409,30,0,null,null,null,null,false],[409,32,0,null,null,null,null,false],[409,33,0,null,null,null,null,false],[409,34,0,null,null,null,null,false],[409,35,0,null,null,null,null,false],[409,36,0,null,null,null,null,false],[409,37,0,null,null,null,null,false],[409,38,0,null,null,null,null,false],[409,39,0,null,null,null,null,false],[409,40,0,null,null,null,null,false],[409,41,0,null,null,null,null,false],[409,42,0,null,null,null,null,false],[409,43,0,null,null,null,null,false],[409,44,0,null,null,null,null,false],[409,45,0,null,null,null,null,false],[409,46,0,null,null,null,null,false],[409,47,0,null,null,null,null,false],[409,48,0,null,null,null,null,false],[409,49,0,null,null,null,null,false],[409,50,0,null,null,null,null,false],[409,51,0,null,null,null,null,false],[409,52,0,null,null,null,null,false],[409,53,0,null,null,null,null,false],[409,54,0,null,null,null,null,false],[409,55,0,null,null,null,null,false],[409,56,0,null,null,null,null,false],[409,57,0,null,null,null,null,false],[409,58,0,null,null,null,null,false],[409,59,0,null,null,null,null,false],[409,60,0,null,null,null,null,false],[409,61,0,null,null,null,null,false],[409,62,0,null,null,null,null,false],[409,63,0,null,null,null,null,false],[409,64,0,null,null,null,null,false],[409,65,0,null,null,null,null,false],[409,66,0,null,null,null,null,false],[409,67,0,null,null,null,null,false],[409,68,0,null,null,null,null,false],[409,69,0,null,null,null,null,false],[409,70,0,null,null,null,null,false],[409,71,0,null,null,null,null,false],[409,72,0,null,null,null,null,false],[409,73,0,null,null,null,null,false],[409,74,0,null,null,null,null,false],[409,75,0,null,null,null,null,false],[409,76,0,null,null,null,null,false],[409,77,0,null,null,null,null,false],[409,78,0,null,null,null,null,false],[409,79,0,null,null,null,null,false],[409,80,0,null,null,null,null,false],[409,81,0,null,null,null,null,false],[409,82,0,null,null,null,null,false],[409,83,0,null,null,null,null,false],[409,84,0,null,null,null,null,false],[409,85,0,null,null,null,null,false],[409,86,0,null,null,null,null,false],[409,87,0,null,null,null,null,false],[409,88,0,null,null,null,null,false],[409,89,0,null,null,null,null,false],[409,90,0,null,null,null,null,false],[409,91,0,null,null,null,null,false],[409,92,0,null,null,null,null,false],[409,93,0,null,null,null,null,false],[409,94,0,null,null,null,null,false],[409,95,0,null,null,null,null,false],[409,96,0,null,null,null,null,false],[409,97,0,null,null,null,null,false],[409,98,0,null,null,null,null,false],[409,99,0,null,null,null,null,false],[409,100,0,null,null,null,null,false],[409,101,0,null,null,null,null,false],[409,102,0,null,null,null,null,false],[409,103,0,null,null,null,null,false],[409,104,0,null,null,null,null,false],[409,105,0,null,null,null,null,false],[409,106,0,null,null,null,null,false],[409,107,0,null,null,null,null,false],[409,108,0,null,null,null,null,false],[409,109,0,null,null,null,null,false],[409,110,0,null,null,null,null,false],[409,111,0,null,null,null,null,false],[409,112,0,null,null,null,null,false],[409,113,0,null,null,null,null,false],[409,114,0,null,null,null,null,false],[409,115,0,null,null,null,null,false],[409,116,0,null,null,null,null,false],[409,117,0,null,null,null,null,false],[409,118,0,null,null,null,null,false],[409,119,0,null,null,null,null,false],[409,120,0,null,null,null,null,false],[409,121,0,null,null,null,null,false],[409,122,0,null,null,null,null,false],[409,123,0,null,null,null,null,false],[409,124,0,null,null,null,null,false],[409,125,0,null,null,null,null,false],[409,126,0,null,null,null,null,false],[409,127,0,null,null,null,null,false],[409,128,0,null,null,null,null,false],[409,129,0,null,null,null,null,false],[409,130,0,null,null,null,null,false],[409,131,0,null,null,null,null,false],[409,132,0,null,null,null,null,false],[409,133,0,null,null,null,null,false],[409,134,0,null,null,null,null,false],[409,135,0,null,null,null,null,false],[409,136,0,null,null,null,null,false],[409,137,0,null,null,null,null,false],[409,138,0,null,null,null,null,false],[409,139,0,null,null,null,null,false],[409,140,0,null,null,null,null,false],[409,141,0,null,null,null,null,false],[409,142,0,null,null,null,null,false],[409,143,0,null,null,null,null,false],[409,144,0,null,null,null,null,false],[409,145,0,null,null,null,null,false],[409,146,0,null,null,null,null,false],[409,147,0,null,null,null,null,false],[409,148,0,null,null,null,null,false],[409,149,0,null,null,null,null,false],[409,150,0,null,null,null,null,false],[409,151,0,null,null,null,null,false],[409,152,0,null,null,null,null,false],[409,153,0,null,null,null,null,false],[409,154,0,null,null,null,null,false],[409,155,0,null,null,null,null,false],[409,156,0,null,null,null,null,false],[409,157,0,null,null,null,null,false],[409,158,0,null,null,null,null,false],[409,159,0,null,null,null,null,false],[409,160,0,null,null,null,null,false],[409,161,0,null,null,null,null,false],[409,162,0,null,null,null,null,false],[409,163,0,null,null,null,null,false],[409,164,0,null,null,null,null,false],[409,165,0,null,null,null,null,false],[409,166,0,null,null,null,null,false],[409,167,0,null,null,null,null,false],[409,168,0,null,null,null,null,false],[409,169,0,null,null,null,null,false],[409,170,0,null,null,null,null,false],[409,171,0,null,null,null,null,false],[409,172,0,null,null,null,null,false],[409,173,0,null,null,null,null,false],[409,174,0,null,null,null,null,false],[409,175,0,null,null,null,null,false],[409,176,0,null,null,null,null,false],[409,177,0,null,null,null,null,false],[409,178,0,null,null,null,null,false],[409,179,0,null,null,null,null,false],[409,180,0,null,null,null,null,false],[409,181,0,null,null,null,null,false],[409,182,0,null,null,null,null,false],[409,183,0,null,null,null,null,false],[409,184,0,null,null,null,null,false],[409,185,0,null,null,null,null,false],[409,186,0,null,null,null,null,false],[409,187,0,null,null,null,null,false],[409,188,0,null,null,null,null,false],[409,189,0,null,null,null,null,false],[409,190,0,null,null,null,null,false],[409,191,0,null,null,null,null,false],[409,192,0,null,null,null,null,false],[409,193,0,null,null,null,null,false],[409,194,0,null,null,null,null,false],[409,195,0,null,null,null,null,false],[409,196,0,null,null,null,null,false],[409,197,0,null,null,null,null,false],[409,198,0,null,null,null,null,false],[409,199,0,null,null,null,null,false],[409,200,0,null,null,null,null,false],[409,201,0,null,null,null,null,false],[409,202,0,null,null,null,null,false],[409,203,0,null,null,null,null,false],[409,204,0,null,null,null,null,false],[409,205,0,null,null,null,null,false],[409,206,0,null,null,null,null,false],[409,207,0,null,null,null,null,false],[409,208,0,null,null,null,null,false],[409,209,0,null,null,null,null,false],[409,210,0,null,null,null,null,false],[409,211,0,null,null,null,null,false],[409,212,0,null,null,null,null,false],[409,213,0,null,null,null,null,false],[409,214,0,null,null,null,null,false],[409,215,0,null,null,null,null,false],[409,216,0,null,null,null,null,false],[409,217,0,null,null,null,null,false],[409,218,0,null,null,null,null,false],[409,219,0,null,null,null,null,false],[409,220,0,null,null,null,null,false],[409,221,0,null,null,null,null,false],[409,222,0,null,null,null,null,false],[409,223,0,null,null,null,null,false],[409,224,0,null,null,null,null,false],[409,225,0,null,null,null,null,false],[409,226,0,null,null,null,null,false],[409,227,0,null,null,null,null,false],[409,228,0,null,null,null,null,false],[409,229,0,null,null,null,null,false],[409,230,0,null,null,null,null,false],[409,231,0,null,null,null,null,false],[409,232,0,null,null,null,null,false],[409,233,0,null,null,null,null,false],[409,234,0,null,null,null,null,false],[409,235,0,null,null,null,null,false],[409,236,0,null,null,null,null,false],[409,237,0,null,null,null,null,false],[409,238,0,null,null,null,null,false],[409,239,0,null,null,null,null,false],[409,240,0,null,null,null,null,false],[409,241,0,null,null,null,null,false],[409,242,0,null,null,null,null,false],[409,243,0,null,null,null,null,false],[409,244,0,null,null,null,null,false],[409,245,0,null,null,null,null,false],[409,246,0,null,null,null,null,false],[409,247,0,null,null,null,null,false],[409,248,0,null,null,null,null,false],[409,249,0,null,null,null,null,false],[409,250,0,null,null,null,null,false],[409,251,0,null,null,null,null,false],[409,252,0,null,null,null,null,false],[409,253,0,null,null,null,null,false],[409,254,0,null,null,null,null,false],[409,255,0,null,null,null,null,false],[409,256,0,null,null,null,null,false],[409,257,0,null,null,null,null,false],[409,258,0,null,null,null,null,false],[409,259,0,null,null,null,null,false],[409,260,0,null,null,null,null,false],[409,261,0,null,null,null,null,false],[409,262,0,null,null,null,null,false],[409,263,0,null,null,null,null,false],[409,264,0,null,null,null,null,false],[409,265,0,null,null,null,null,false],[409,266,0,null,null,null,null,false],[409,267,0,null,null,null,null,false],[409,268,0,null,null,null,null,false],[409,269,0,null,null,null,null,false],[409,270,0,null,null,null,null,false],[409,271,0,null,null,null,null,false],[409,272,0,null,null,null,null,false],[409,273,0,null,null,null,null,false],[409,274,0,null,null,null,null,false],[409,275,0,null,null,null,null,false],[409,276,0,null,null,null,null,false],[409,277,0,null,null,null,null,false],[409,278,0,null,null,null,null,false],[409,279,0,null,null,null,null,false],[409,280,0,null,null,null,null,false],[409,282,0,null,null,null,null,false],[409,283,0,null,null,null,null,false],[409,284,0,null,null,null,null,false],[409,285,0,null,null,null,null,false],[409,287,0,null,null,null,null,false],[409,294,0,null,null,null,null,false],[409,301,0,null,null,null,null,false],[409,308,0,null,null,null,null,false],[409,315,0,null,null,null,null,false],[409,322,0,null,null,null,null,false],[409,329,0,null,null,null,null,false],[409,330,0,null,null,null,null,false],[409,331,0,null,null,null,null,false],[409,332,0,null,null,null,null,false],[409,333,0,null,null,null,null,false],[409,334,0,null,null,null,null,false],[409,335,0,null,null,null,null,false],[409,336,0,null,null,null,null,false],[409,337,0,null,null,null,null,false],[409,338,0,null,null,null,null,false],[409,339,0,null,null,null,null,false],[409,340,0,null,null,null,null,false],[409,341,0,null,null,null,null,false],[409,342,0,null,null,null,null,false],[409,343,0,null,null,null,null,false],[409,344,0,null,null,null,null,false],[409,345,0,null,null,null,null,false],[409,346,0,null,null,null,null,false],[409,347,0,null,null,null,null,false],[409,348,0,null,null,null,null,false],[409,349,0,null,null,null,null,false],[409,350,0,null,null,null,null,false],[409,351,0,null,null,null,null,false],[409,352,0,null,null,null,null,false],[409,353,0,null,null,null,null,false],[409,354,0,null,null,null,null,false],[409,355,0,null,null,null,null,false],[409,356,0,null,null,null,null,false],[409,357,0,null,null,null,null,false],[409,358,0,null,null,null,null,false],[409,359,0,null,null,null,null,false],[409,360,0,null,null,null,null,false],[409,361,0,null,null,null,null,false],[409,362,0,null,null,null,null,false],[409,363,0,null,null,null,null,false],[409,364,0,null,null,null,null,false],[409,365,0,null,null,null,null,false],[409,366,0,null,null,null,null,false],[409,367,0,null,null,null,null,false],[409,368,0,null,null,null,null,false],[409,369,0,null,null,null,null,false],[409,370,0,null,null,null,null,false],[409,371,0,null,null,null,null,false],[409,372,0,null,null,null,null,false],[409,373,0,null,null,null,null,false],[409,374,0,null,null,null,null,false],[409,375,0,null,null,null,null,false],[409,376,0,null,null,null,null,false],[409,377,0,null,null,null,null,false],[409,378,0,null,null,null,null,false],[409,379,0,null,null,null,null,false],[409,380,0,null,null,null,null,false],[409,381,0,null,null,null,null,false],[409,382,0,null,null,null,null,false],[409,383,0,null,null,null,null,false],[409,384,0,null,null,null,null,false],[409,385,0,null,null,null,null,false],[409,386,0,null,null,null,null,false],[409,387,0,null,null,null,null,false],[409,388,0,null,null,null,null,false],[409,389,0,null,null,null,null,false],[409,390,0,null,null,null,null,false],[409,391,0,null,null,null,null,false],[409,392,0,null,null,null,null,false],[409,393,0,null,null,null,null,false],[409,394,0,null,null,null,null,false],[409,395,0,null,null,null,null,false],[409,396,0,null,null,null,null,false],[409,397,0,null,null,null,null,false],[409,398,0,null,null,null,null,false],[409,399,0,null,null,null,null,false],[409,400,0,null,null,null,null,false],[409,401,0,null,null,null,null,false],[409,402,0,null,null,null,null,false],[409,403,0,null,null,null,null,false],[409,404,0,null,null,null,null,false],[409,405,0,null,null,null,null,false],[409,406,0,null,null,null,null,false],[409,407,0,null,null,null,null,false],[409,408,0,null,null,null,null,false],[409,409,0,null,null,null,null,false],[409,410,0,null,null,null,null,false],[409,411,0,null,null,null,null,false],[409,412,0,null,null,null,null,false],[409,413,0,null,null,null,null,false],[409,414,0,null,null,null,null,false],[409,415,0,null,null,null,null,false],[409,416,0,null,null,null,null,false],[409,417,0,null,null,null,null,false],[409,418,0,null,null,null,null,false],[409,419,0,null,null,null,null,false],[409,420,0,null,null,null,null,false],[409,421,0,null,null,null,null,false],[409,422,0,null,null,null,null,false],[409,423,0,null,null,null,null,false],[409,424,0,null,null,null,null,false],[409,425,0,null,null,null,null,false],[409,426,0,null,null,null,null,false],[409,427,0,null,null,null,null,false],[409,428,0,null,null,null,null,false],[409,429,0,null,null,null,null,false],[409,430,0,null,null,null,null,false],[409,431,0,null,null,null,null,false],[409,432,0,null,null,null,null,false],[409,433,0,null,null,null,null,false],[409,434,0,null,null,null,null,false],[409,435,0,null,null,null,null,false],[409,436,0,null,null,null,null,false],[409,437,0,null,null,null,null,false],[409,438,0,null,null,null,null,false],[409,439,0,null,null,null,null,false],[409,440,0,null,null,null,null,false],[409,441,0,null,null,null,null,false],[409,442,0,null,null,null,null,false],[409,443,0,null,null,null,null,false],[409,444,0,null,null,null,null,false],[409,446,0,null,null,null,[],false],[409,447,0,null,null,null,null,false],[409,448,0,null,null,null,null,false],[409,449,0,null,null,null,null,false],[409,450,0,null,null,null,null,false],[409,451,0,null,null,null,null,false],[409,452,0,null,null,null,null,false],[409,453,0,null,null,null,null,false],[409,454,0,null,null,null,null,false],[409,455,0,null,null,null,null,false],[409,456,0,null,null,null,null,false],[409,457,0,null,null,null,null,false],[409,458,0,null,null,null,null,false],[409,459,0,null,null,null,null,false],[409,460,0,null,null,null,null,false],[409,461,0,null,null,null,null,false],[409,462,0,null,null,null,null,false],[409,463,0,null,null,null,null,false],[409,464,0,null,null,null,null,false],[409,465,0,null,null,null,null,false],[409,466,0,null,null,null,null,false],[409,467,0,null,null,null,null,false],[409,468,0,null,null,null,null,false],[409,469,0,null,null,null,null,false],[409,472,0,null,null,null,null,false],[409,473,0,null,null,null,null,false],[409,474,0,null,null,null,null,false],[409,476,0,null,null,null,[],false],[409,477,0,null,null,null,null,false],[409,478,0,null,null,null,null,false],[409,479,0,null,null,null,null,false],[409,480,0,null,null,null,null,false],[409,481,0,null,null,null,null,false],[409,482,0,null,null,null,null,false],[409,483,0,null,null,null,null,false],[409,484,0,null,null,null,null,false],[409,485,0,null,null,null,null,false],[409,486,0,null,null,null,null,false],[409,487,0,null,null,null,null,false],[409,488,0,null,null,null,null,false],[409,489,0,null,null,null,null,false],[409,490,0,null,null,null,null,false],[409,491,0,null,null,null,null,false],[409,492,0,null,null,null,null,false],[409,493,0,null,null,null,null,false],[409,494,0,null,null,null,null,false],[409,495,0,null,null,null,null,false],[409,496,0,null,null,null,null,false],[409,497,0,null,null,null,null,false],[409,498,0,null,null,null,null,false],[409,499,0,null,null,null,null,false],[409,500,0,null,null,null,null,false],[409,501,0,null,null,null,null,false],[409,502,0,null,null,null,null,false],[409,503,0,null,null,null,null,false],[409,504,0,null,null,null,null,false],[409,505,0,null,null,null,null,false],[409,506,0,null,null,null,null,false],[409,507,0,null,null,null,null,false],[409,508,0,null,null,null,null,false],[409,509,0,null,null,null,null,false],[409,510,0,null,null,null,null,false],[409,511,0,null,null,null,null,false],[409,514,0,null,null,null,[],false],[409,515,0,null,null,null,null,false],[409,516,0,null,null,null,null,false],[409,517,0,null,null,null,null,false],[409,518,0,null,null,null,null,false],[409,519,0,null,null,null,null,false],[409,524,0,null,null," WARNING: this flag is not supported by windows socket functions directly,\n          it is only supported by std.os.socket. Be sure that this value does\n          not share any bits with any of the `SOCK` values.",null,false],[409,528,0,null,null," WARNING: this flag is not supported by windows socket functions directly,\n          it is only supported by std.os.socket. Be sure that this value does\n          not share any bits with any of the `SOCK` values.",null,false],[409,531,0,null,null,null,[],false],[409,532,0,null,null,null,null,false],[409,533,0,null,null,null,null,false],[409,536,0,null,null,null,[],false],[409,537,0,null,null,null,null,false],[409,538,0,null,null,null,null,false],[409,539,0,null,null,null,null,false],[409,540,0,null,null,null,null,false],[409,541,0,null,null,null,null,false],[409,542,0,null,null,null,null,false],[409,543,0,null,null,null,null,false],[409,544,0,null,null,null,null,false],[409,545,0,null,null,null,null,false],[409,546,0,null,null,null,null,false],[409,547,0,null,null,null,null,false],[409,548,0,null,null,null,null,false],[409,549,0,null,null,null,null,false],[409,550,0,null,null,null,null,false],[409,551,0,null,null,null,null,false],[409,552,0,null,null,null,null,false],[409,553,0,null,null,null,null,false],[409,554,0,null,null,null,null,false],[409,555,0,null,null,null,null,false],[409,556,0,null,null,null,null,false],[409,557,0,null,null,null,null,false],[409,558,0,null,null,null,null,false],[409,559,0,null,null,null,null,false],[409,560,0,null,null,null,null,false],[409,561,0,null,null,null,null,false],[409,562,0,null,null,null,null,false],[409,563,0,null,null,null,null,false],[409,564,0,null,null,null,null,false],[409,565,0,null,null,null,null,false],[409,566,0,null,null,null,null,false],[409,567,0,null,null,null,null,false],[409,568,0,null,null,null,null,false],[409,569,0,null,null,null,null,false],[409,570,0,null,null,null,null,false],[409,571,0,null,null,null,null,false],[409,572,0,null,null,null,null,false],[409,573,0,null,null,null,null,false],[409,574,0,null,null,null,null,false],[409,575,0,null,null,null,null,false],[409,576,0,null,null,null,null,false],[409,577,0,null,null,null,null,false],[409,578,0,null,null,null,null,false],[409,579,0,null,null,null,null,false],[409,580,0,null,null,null,null,false],[409,581,0,null,null,null,null,false],[409,582,0,null,null,null,null,false],[409,583,0,null,null,null,null,false],[409,586,0,null,null,null,null,false],[409,587,0,null,null,null,null,false],[409,588,0,null,null,null,null,false],[409,589,0,null,null,null,null,false],[409,590,0,null,null,null,null,false],[409,591,0,null,null,null,null,false],[409,592,0,null,null,null,null,false],[409,593,0,null,null,null,null,false],[409,594,0,null,null,null,null,false],[409,595,0,null,null,null,null,false],[409,596,0,null,null,null,null,false],[409,597,0,null,null,null,null,false],[409,598,0,null,null,null,null,false],[409,599,0,null,null,null,null,false],[409,600,0,null,null,null,null,false],[409,601,0,null,null,null,null,false],[409,602,0,null,null,null,null,false],[409,603,0,null,null,null,null,false],[409,604,0,null,null,null,null,false],[409,605,0,null,null,null,null,false],[409,606,0,null,null,null,null,false],[409,607,0,null,null,null,null,false],[409,608,0,null,null,null,null,false],[409,609,0,null,null,null,null,false],[409,610,0,null,null,null,null,false],[409,611,0,null,null,null,null,false],[409,612,0,null,null,null,null,false],[409,613,0,null,null,null,null,false],[409,614,0,null,null,null,null,false],[409,615,0,null,null,null,null,false],[409,616,0,null,null,null,null,false],[409,617,0,null,null,null,null,false],[409,618,0,null,null,null,null,false],[409,619,0,null,null,null,null,false],[409,620,0,null,null,null,null,false],[409,621,0,null,null,null,null,false],[409,622,0,null,null,null,null,false],[409,623,0,null,null,null,null,false],[409,624,0,null,null,null,null,false],[409,625,0,null,null,null,null,false],[409,626,0,null,null,null,null,false],[409,627,0,null,null,null,null,false],[409,628,0,null,null,null,null,false],[409,629,0,null,null,null,null,false],[409,630,0,null,null,null,null,false],[409,631,0,null,null,null,null,false],[409,632,0,null,null,null,null,false],[409,633,0,null,null,null,null,false],[409,634,0,null,null,null,null,false],[409,635,0,null,null,null,null,false],[409,636,0,null,null,null,null,false],[409,637,0,null,null,null,null,false],[409,638,0,null,null,null,null,false],[409,639,0,null,null,null,null,false],[409,640,0,null,null,null,null,false],[409,641,0,null,null,null,null,false],[409,642,0,null,null,null,null,false],[409,643,0,null,null,null,null,false],[409,644,0,null,null,null,null,false],[409,645,0,null,null,null,null,false],[409,646,0,null,null,null,null,false],[409,647,0,null,null,null,null,false],[409,648,0,null,null,null,null,false],[409,649,0,null,null,null,null,false],[409,650,0,null,null,null,null,false],[409,651,0,null,null,null,null,false],[409,652,0,null,null,null,null,false],[409,653,0,null,null,null,null,false],[409,654,0,null,null,null,null,false],[409,655,0,null,null,null,null,false],[409,656,0,null,null,null,null,false],[409,657,0,null,null,null,null,false],[409,658,0,null,null,null,null,false],[409,659,0,null,null,null,null,false],[409,660,0,null,null,null,null,false],[409,661,0,null,null,null,null,false],[409,663,0,null,null,null,[],false],[409,664,0,null,null,null,null,false],[409,665,0,null,null,null,null,false],[409,666,0,null,null,null,null,false],[409,667,0,null,null,null,null,false],[409,668,0,null,null,null,null,false],[409,670,0,null,null,null,null,false],[409,671,0,null,null,null,null,false],[409,672,0,null,null,null,null,false],[409,673,0,null,null,null,null,false],[409,674,0,null,null,null,null,false],[409,675,0,null,null,null,null,false],[409,678,0,null,null,null,[],false],[409,679,0,null,null,null,null,false],[409,680,0,null,null,null,null,false],[409,681,0,null,null,null,null,false],[409,682,0,null,null,null,null,false],[409,683,0,null,null,null,null,false],[409,684,0,null,null,null,null,false],[409,685,0,null,null,null,null,false],[409,686,0,null,null,null,null,false],[409,687,0,null,null,null,null,false],[409,688,0,null,null,null,null,false],[409,689,0,null,null,null,null,false],[409,690,0,null,null,null,null,false],[409,691,0,null,null,null,null,false],[409,692,0,null,null,null,null,false],[409,693,0,null,null,null,null,false],[409,694,0,null,null,null,null,false],[409,697,0,null,null,null,null,false],[409,698,0,null,null,null,null,false],[409,699,0,null,null,null,null,false],[409,700,0,null,null,null,null,false],[409,701,0,null,null,null,null,false],[409,702,0,null,null,null,null,false],[409,703,0,null,null,null,null,false],[409,704,0,null,null,null,null,false],[409,705,0,null,null,null,null,false],[409,706,0,null,null,null,null,false],[409,707,0,null,null,null,null,false],[409,708,0,null,null,null,null,false],[409,709,0,null,null,null,null,false],[409,710,0,null,null,null,null,false],[409,711,0,null,null,null,null,false],[409,712,0,null,null,null,null,false],[409,713,0,null,null,null,null,false],[409,714,0,null,null,null,null,false],[409,715,0,null,null,null,null,false],[409,716,0,null,null,null,null,false],[409,717,0,null,null,null,null,false],[409,718,0,null,null,null,null,false],[409,719,0,null,null,null,null,false],[409,720,0,null,null,null,null,false],[409,721,0,null,null,null,null,false],[409,722,0,null,null,null,null,false],[409,723,0,null,null,null,null,false],[409,724,0,null,null,null,null,false],[409,725,0,null,null,null,null,false],[409,726,0,null,null,null,null,false],[409,727,0,null,null,null,null,false],[409,728,0,null,null,null,null,false],[409,729,0,null,null,null,null,false],[409,730,0,null,null,null,null,false],[409,731,0,null,null,null,null,false],[409,732,0,null,null,null,null,false],[409,733,0,null,null,null,null,false],[409,734,0,null,null,null,null,false],[409,735,0,null,null,null,null,false],[409,736,0,null,null,null,null,false],[409,737,0,null,null,null,null,false],[409,738,0,null,null,null,null,false],[409,739,0,null,null,null,null,false],[409,740,0,null,null,null,null,false],[409,741,0,null,null,null,null,false],[409,742,0,null,null,null,null,false],[409,743,0,null,null,null,null,false],[409,744,0,null,null,null,null,false],[409,745,0,null,null,null,null,false],[409,746,0,null,null,null,null,false],[409,747,0,null,null,null,null,false],[409,748,0,null,null,null,null,false],[409,749,0,null,null,null,null,false],[409,750,0,null,null,null,null,false],[409,751,0,null,null,null,null,false],[409,752,0,null,null,null,null,false],[409,753,0,null,null,null,null,false],[409,754,0,null,null,null,null,false],[409,755,0,null,null,null,null,false],[409,756,0,null,null,null,null,false],[409,757,0,null,null,null,null,false],[409,758,0,null,null,null,null,false],[409,759,0,null,null,null,null,false],[409,760,0,null,null,null,null,false],[409,761,0,null,null,null,null,false],[409,762,0,null,null,null,null,false],[409,763,0,null,null,null,null,false],[409,764,0,null,null,null,null,false],[409,765,0,null,null,null,null,false],[409,766,0,null,null,null,null,false],[409,767,0,null,null,null,null,false],[409,768,0,null,null,null,null,false],[409,769,0,null,null,null,null,false],[409,770,0,null,null,null,null,false],[409,771,0,null,null,null,null,false],[409,772,0,null,null,null,null,false],[409,773,0,null,null,null,null,false],[409,774,0,null,null,null,null,false],[409,775,0,null,null,null,null,false],[409,776,0,null,null,null,null,false],[409,777,0,null,null,null,null,false],[409,778,0,null,null,null,null,false],[409,779,0,null,null,null,null,false],[409,780,0,null,null,null,null,false],[409,781,0,null,null,null,null,false],[409,782,0,null,null,null,null,false],[409,783,0,null,null,null,null,false],[409,784,0,null,null,null,null,false],[409,785,0,null,null,null,null,false],[409,786,0,null,null,null,null,false],[409,787,0,null,null,null,null,false],[409,788,0,null,null,null,null,false],[409,789,0,null,null,null,null,false],[409,790,0,null,null,null,null,false],[409,791,0,null,null,null,null,false],[409,792,0,null,null,null,null,false],[409,793,0,null,null,null,null,false],[409,794,0,null,null,null,null,false],[409,795,0,null,null,null,null,false],[409,796,0,null,null,null,null,false],[409,797,0,null,null,null,null,false],[409,798,0,null,null,null,null,false],[409,799,0,null,null,null,null,false],[409,800,0,null,null,null,null,false],[409,801,0,null,null,null,null,false],[409,802,0,null,null,null,null,false],[409,803,0,null,null,null,null,false],[409,804,0,null,null,null,null,false],[409,805,0,null,null,null,null,false],[409,806,0,null,null,null,null,false],[409,807,0,null,null,null,null,false],[409,808,0,null,null,null,null,false],[409,809,0,null,null,null,null,false],[409,810,0,null,null,null,null,false],[409,811,0,null,null,null,null,false],[409,812,0,null,null,null,null,false],[409,813,0,null,null,null,null,false],[409,814,0,null,null,null,null,false],[409,815,0,null,null,null,null,false],[409,816,0,null,null,null,null,false],[409,817,0,null,null,null,null,false],[409,818,0,null,null,null,null,false],[409,819,0,null,null,null,null,false],[409,820,0,null,null,null,null,false],[409,821,0,null,null,null,null,false],[409,822,0,null,null,null,null,false],[409,823,0,null,null,null,null,false],[409,824,0,null,null,null,null,false],[409,825,0,null,null,null,null,false],[409,826,0,null,null,null,null,false],[409,827,0,null,null,null,null,false],[409,828,0,null,null,null,null,false],[409,829,0,null,null,null,null,false],[409,830,0,null,null,null,null,false],[409,831,0,null,null,null,null,false],[409,832,0,null,null,null,null,false],[409,833,0,null,null,null,null,false],[409,834,0,null,null,null,null,false],[409,835,0,null,null,null,null,false],[409,836,0,null,null,null,null,false],[409,837,0,null,null,null,null,false],[409,838,0,null,null,null,null,false],[409,839,0,null,null,null,null,false],[409,840,0,null,null,null,null,false],[409,841,0,null,null,null,null,false],[409,843,0,null,null,null,[],false],[409,844,0,null,null,null,null,false],[409,845,0,null,null,null,null,false],[409,846,0,null,null,null,null,false],[409,847,0,null,null,null,null,false],[409,848,0,null,null,null,null,false],[409,849,0,null,null,null,null,false],[409,850,0,null,null,null,null,false],[409,851,0,null,null,null,null,false],[409,854,0,null,null,null,null,false],[409,855,0,null,null,null,null,false],[409,856,0,null,null,null,null,false],[409,857,0,null,null,null,null,false],[409,858,0,null,null,null,null,false],[409,859,0,null,null,null,null,false],[409,860,0,null,null,null,null,false],[409,861,0,null,null,null,null,false],[409,862,0,null,null,null,null,false],[409,863,0,null,null,null,null,false],[409,864,0,null,null,null,null,false],[409,865,0,null,null,null,null,false],[409,866,0,null,null,null,null,false],[409,867,0,null,null,null,null,false],[409,868,0,null,null,null,null,false],[409,869,0,null,null,null,null,false],[409,870,0,null,null,null,null,false],[409,871,0,null,null,null,null,false],[409,872,0,null,null,null,null,false],[409,873,0,null,null,null,null,false],[409,874,0,null,null,null,null,false],[409,875,0,null,null,null,null,false],[409,877,0,null,null,null,[],false],[409,878,0,null,null,null,null,false],[409,879,0,null,null,null,null,false],[409,880,0,null,null,null,null,false],[409,881,0,null,null,null,null,false],[409,882,0,null,null,null,null,false],[409,883,0,null,null,null,null,false],[409,884,0,null,null,null,null,false],[409,885,0,null,null,null,null,false],[409,886,0,null,null,null,null,false],[409,887,0,null,null,null,null,false],[409,888,0,null,null,null,null,false],[409,889,0,null,null,null,null,false],[409,892,0,null,null,null,null,false],[409,893,0,null,null,null,null,false],[409,894,0,null,null,null,null,false],[409,895,0,null,null,null,null,false],[409,896,0,null,null,null,null,false],[409,897,0,null,null,null,null,false],[409,898,0,null,null,null,null,false],[409,899,0,null,null,null,null,false],[409,900,0,null,null,null,null,false],[409,901,0,null,null,null,null,false],[409,902,0,null,null,null,null,false],[409,903,0,null,null,null,null,false],[409,904,0,null,null,null,null,false],[409,905,0,null,null,null,null,false],[409,906,0,null,null,null,null,false],[409,907,0,null,null,null,null,false],[409,908,0,null,null,null,null,false],[409,909,0,null,null,null,null,false],[409,910,0,null,null,null,null,false],[409,911,0,null,null,null,null,false],[409,912,0,null,null,null,null,false],[409,913,0,null,null,null,null,false],[409,914,0,null,null,null,null,false],[409,915,0,null,null,null,null,false],[409,916,0,null,null,null,null,false],[409,917,0,null,null,null,null,false],[409,918,0,null,null,null,null,false],[409,919,0,null,null,null,null,false],[409,920,0,null,null,null,null,false],[409,921,0,null,null,null,null,false],[409,922,0,null,null,null,null,false],[409,923,0,null,null,null,null,false],[409,924,0,null,null,null,null,false],[409,925,0,null,null,null,null,false],[409,926,0,null,null,null,null,false],[409,927,0,null,null,null,null,false],[409,928,0,null,null,null,null,false],[409,929,0,null,null,null,null,false],[409,930,0,null,null,null,null,false],[409,931,0,null,null,null,null,false],[409,932,0,null,null,null,null,false],[409,933,0,null,null,null,null,false],[409,934,0,null,null,null,null,false],[409,935,0,null,null,null,null,false],[409,936,0,null,null,null,null,false],[409,937,0,null,null,null,null,false],[409,938,0,null,null,null,null,false],[409,939,0,null,null,null,null,false],[409,940,0,null,null,null,null,false],[409,941,0,null,null,null,null,false],[409,942,0,null,null,null,null,false],[409,943,0,null,null,null,null,false],[409,945,0,null,null,null,[50986,50987,50988,50989,50990,50991,50992,50993],false],[0,0,0,"lpCallerId",null,"",null,false],[0,0,0,"lpCallerData",null,"",null,false],[0,0,0,"lpSQOS",null,"",null,false],[0,0,0,"lpGQOS",null,"",null,false],[0,0,0,"lpCalleeId",null,"",null,false],[0,0,0,"lpCalleeData",null,"",null,false],[0,0,0,"g",null,"",null,false],[0,0,0,"dwCallbackData",null,"",null,false],[409,956,0,null,null,null,[50995,50996,50997,50998],false],[0,0,0,"dwError",null,"",null,false],[0,0,0,"cbTransferred",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[409,963,0,null,null,null,[51000,51001,51002,51003,51004,51005,51006,51007],false],[0,0,0,"TokenRate",null,null,null,false],[0,0,0,"TokenBucketSize",null,null,null,false],[0,0,0,"PeakBandwidth",null,null,null,false],[0,0,0,"Latency",null,null,null,false],[0,0,0,"DelayVariation",null,null,null,false],[0,0,0,"ServiceType",null,null,null,false],[0,0,0,"MaxSduSize",null,null,null,false],[0,0,0,"MinimumPolicedSize",null,null,null,false],[409,974,0,null,null,null,[51010,51012,51014],false],[409,974,0,null,null,null,null,false],[0,0,0,"SendingFlowspec",null,null,null,false],[409,974,0,null,null,null,null,false],[0,0,0,"ReceivingFlowspec",null,null,null,false],[409,974,0,null,null,null,null,false],[0,0,0,"ProviderSpecific",null,null,null,false],[409,980,0,null,null,null,[51017,51018],false],[409,980,0,null,null,null,null,false],[0,0,0,"lpSockaddr",null,null,null,false],[0,0,0,"iSockaddrLength",null,null,null,false],[409,985,0,null,null,null,[51020,51022],false],[0,0,0,"iAddressCount",null,null,null,false],[409,985,0,null,null,null,null,false],[0,0,0,"Address",null,null,null,false],[409,990,0,null,null,null,null,false],[409,1011,0,null,null,null,[51025,51027],false],[0,0,0,"ChainLen",null,null,null,false],[409,1011,0,null,null,null,null,false],[0,0,0,"ChainEntries",null,null,null,false],[409,1016,0,null,null,null,[51030,51032,51034,51036,51038,51040,51042,51044,51045,51046,51047,51048,51049,51050,51051,51052,51053,51055,51057,51059],false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwServiceFlags1",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwServiceFlags2",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwServiceFlags3",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwServiceFlags4",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwProviderFlags",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"ProviderId",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwCatalogEntryId",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"ProtocolChain",null,null,null,false],[0,0,0,"iVersion",null,null,null,false],[0,0,0,"iAddressFamily",null,null,null,false],[0,0,0,"iMaxSockAddr",null,null,null,false],[0,0,0,"iMinSockAddr",null,null,null,false],[0,0,0,"iSocketType",null,null,null,false],[0,0,0,"iProtocol",null,null,null,false],[0,0,0,"iProtocolMaxOffset",null,null,null,false],[0,0,0,"iNetworkByteOrder",null,null,null,false],[0,0,0,"iSecurityScheme",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwMessageSize",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"dwProviderReserved",null,null,null,false],[409,1016,0,null,null,null,null,false],[0,0,0,"szProtocol",null,null,null,false],[409,1039,0,null,null,null,[51062,51064,51066,51068,51070,51072,51074,51076,51077,51078,51079,51080,51081,51082,51083,51084,51085,51087,51089,51091],false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwServiceFlags1",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwServiceFlags2",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwServiceFlags3",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwServiceFlags4",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwProviderFlags",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"ProviderId",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwCatalogEntryId",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"ProtocolChain",null,null,null,false],[0,0,0,"iVersion",null,null,null,false],[0,0,0,"iAddressFamily",null,null,null,false],[0,0,0,"iMaxSockAddr",null,null,null,false],[0,0,0,"iMinSockAddr",null,null,null,false],[0,0,0,"iSocketType",null,null,null,false],[0,0,0,"iProtocol",null,null,null,false],[0,0,0,"iProtocolMaxOffset",null,null,null,false],[0,0,0,"iNetworkByteOrder",null,null,null,false],[0,0,0,"iSecurityScheme",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwMessageSize",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"dwProviderReserved",null,null,null,false],[409,1039,0,null,null,null,null,false],[0,0,0,"szProtocol",null,null,null,false],[409,1062,0,null,null,null,[51093,51094],false],[0,0,0,"sp_family",null,null,null,false],[0,0,0,"sp_protocol",null,null,null,false],[409,1067,0,null,null,null,[51096,51097],false],[0,0,0,"l_onoff",null,null,null,false],[0,0,0,"l_linger",null,null,null,false],[409,1072,0,null,null,null,[51099,51101],false],[0,0,0,"lNetworkEvents",null,null,null,false],[409,1072,0,null,null,null,null,false],[0,0,0,"iErrorCode",null,null,null,false],[409,1077,0,null,null,null,null,false],[409,1079,0,null,null,null,[51104,51105,51106,51107,51108,51110,51112,51114],false],[0,0,0,"flags",null,null,null,false],[0,0,0,"family",null,null,null,false],[0,0,0,"socktype",null,null,null,false],[0,0,0,"protocol",null,null,null,false],[0,0,0,"addrlen",null,null,null,false],[409,1079,0,null,null,null,null,false],[0,0,0,"canonname",null,null,null,false],[409,1079,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[409,1079,0,null,null,null,null,false],[0,0,0,"next",null,null,null,false],[409,1090,0,null,null,null,[51116,51117,51118,51119,51120,51122,51124,51126,51127,51129,51131],false],[0,0,0,"ai_flags",null,null,null,false],[0,0,0,"ai_family",null,null,null,false],[0,0,0,"ai_socktype",null,null,null,false],[0,0,0,"ai_protocol",null,null,null,false],[0,0,0,"ai_addrlen",null,null,null,false],[409,1090,0,null,null,null,null,false],[0,0,0,"ai_canonname",null,null,null,false],[409,1090,0,null,null,null,null,false],[0,0,0,"ai_addr",null,null,null,false],[409,1090,0,null,null,null,null,false],[0,0,0,"ai_blob",null,null,null,false],[0,0,0,"ai_bloblen",null,null,null,false],[409,1090,0,null,null,null,null,false],[0,0,0,"ai_provider",null,null,null,false],[409,1090,0,null,null,null,null,false],[0,0,0,"ai_next",null,null,null,false],[409,1104,0,null,null,null,[51162,51164],false],[409,1108,0,null,null,null,null,false],[409,1109,0,null,null,null,[51136,51138],false],[409,1109,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[409,1109,0,null,null,null,null,false],[0,0,0,"padding",null,null,null,false],[409,1120,0,null,null," IPv4 socket address",[51141,51143,51144,51146],false],[409,1120,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[409,1120,0,null,null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"addr",null,null,null,false],[409,1120,0,null,null,null,null,false],[0,0,0,"zero",null,null,null,false],[409,1128,0,null,null," IPv6 socket address",[51149,51151,51152,51154,51155],false],[409,1128,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[409,1128,0,null,null,null,null,false],[0,0,0,"port",null,null,null,false],[0,0,0,"flowinfo",null,null,null,false],[409,1128,0,null,null,null,null,false],[0,0,0,"addr",null,null,null,false],[0,0,0,"scope_id",null,null,null,false],[409,1137,0,null,null," UNIX domain socket address",[51158,51160],false],[409,1137,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[409,1137,0,null,null,null,null,false],[0,0,0,"path",null,null,null,false],[409,1104,0,null,null,null,null,false],[0,0,0,"family",null,null,null,false],[409,1104,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[409,1143,0,null,null,null,[51167,51169],false],[409,1143,0,null,null,null,null,false],[0,0,0,"len",null,null,null,false],[409,1143,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[409,1148,0,null,null,null,null,false],[409,1149,0,null,null,null,null,false],[409,1151,0,null,null,null,[51174,51176,51178,51180,51182,51184],false],[409,1151,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[409,1151,0,null,null,null,null,false],[0,0,0,"namelen",null,null,null,false],[409,1151,0,null,null,null,null,false],[0,0,0,"lpBuffers",null,null,null,false],[409,1151,0,null,null,null,null,false],[0,0,0,"dwBufferCount",null,null,null,false],[409,1151,0,null,null,null,null,false],[0,0,0,"Control",null,null,null,false],[409,1151,0,null,null,null,null,false],[0,0,0,"dwFlags",null,null,null,false],[409,1160,0,null,null,null,[51187,51189,51191,51193,51195,51197],false],[409,1160,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[409,1160,0,null,null,null,null,false],[0,0,0,"namelen",null,null,null,false],[409,1160,0,null,null,null,null,false],[0,0,0,"lpBuffers",null,null,null,false],[409,1160,0,null,null,null,null,false],[0,0,0,"dwBufferCount",null,null,null,false],[409,1160,0,null,null,null,null,false],[0,0,0,"Control",null,null,null,false],[409,1160,0,null,null,null,null,false],[0,0,0,"dwFlags",null,null,null,false],[409,1169,0,null,null,null,null,false],[409,1171,0,null,null,null,[51201,51203,51205],false],[409,1171,0,null,null,null,null,false],[0,0,0,"fd",null,null,null,false],[409,1171,0,null,null,null,null,false],[0,0,0,"events",null,null,null,false],[409,1171,0,null,null,null,null,false],[0,0,0,"revents",null,null,null,false],[409,1177,0,null,null,null,[51208,51209,51211,51212],false],[409,1177,0,null,null,null,null,false],[0,0,0,"Head",null,null,null,false],[0,0,0,"HeadLength",null,null,null,false],[409,1177,0,null,null,null,null,false],[0,0,0,"Tail",null,null,null,false],[0,0,0,"TailLength",null,null,null,false],[409,1184,0,null,null,null,[51214,51215,51216,51217,51218,51219,51220],false],[0,0,0,"hSocket",null,"",null,false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"nNumberOfBytesToWrite",null,"",null,false],[0,0,0,"nNumberOfBytesPerSend",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpTransmitBuffers",null,"",null,false],[0,0,0,"dwReserved",null,"",null,false],[409,1194,0,null,null,null,[51222,51223,51224,51225,51226,51227,51228,51229],false],[0,0,0,"sListenSocket",null,"",null,false],[0,0,0,"sAcceptSocket",null,"",null,false],[0,0,0,"lpOutputBuffer",null,"",null,false],[0,0,0,"dwReceiveDataLength",null,"",null,false],[0,0,0,"dwLocalAddressLength",null,"",null,false],[0,0,0,"dwRemoteAddressLength",null,"",null,false],[0,0,0,"lpdwBytesReceived",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[409,1205,0,null,null,null,[51231,51232,51233,51234,51235,51236,51237,51238],false],[0,0,0,"lpOutputBuffer",null,"",null,false],[0,0,0,"dwReceiveDataLength",null,"",null,false],[0,0,0,"dwLocalAddressLength",null,"",null,false],[0,0,0,"dwRemoteAddressLength",null,"",null,false],[0,0,0,"LocalSockaddr",null,"",null,false],[0,0,0,"LocalSockaddrLength",null,"",null,false],[0,0,0,"RemoteSockaddr",null,"",null,false],[0,0,0,"RemoteSockaddrLength",null,"",null,false],[409,1216,0,null,null,null,[51240,51241,51242,51243,51244,51245],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpNumberOfBytesSent",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,1225,0,null,null,null,[51247,51248,51249,51250,51251],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"lpdwNumberOfBytesRecv",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,1233,0,null,null,null,[51253,51254],false],[0,0,0,"lParam",null,"",null,false],[0,0,0,"hAsyncTaskHandle",null,"",null,false],[409,1238,0,null,null,null,[51257,51259,51261],false],[409,1238,0,null,null,null,null,false],[0,0,0,"lpServiceCallbackProc",null,null,null,false],[409,1238,0,null,null,null,null,false],[0,0,0,"lParam",null,null,null,false],[409,1238,0,null,null,null,null,false],[0,0,0,"hAsyncTaskHandle",null,null,null,false],[409,1244,0,null,null,null,[51263,51264,51265],false],[0,0,0,"dwError",null,"",null,false],[0,0,0,"dwBytes",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[409,1250,0,null,null,null,[51267,51269],false],[0,0,0,"fd_count",null,null,null,false],[409,1250,0,null,null,null,null,false],[0,0,0,"fd_array",null,null,null,false],[409,1255,0,null,null,null,[51272,51274,51275,51276,51278],false],[409,1255,0,null,null,null,null,false],[0,0,0,"h_name",null,null,null,false],[409,1255,0,null,null,null,null,false],[0,0,0,"h_aliases",null,null,null,false],[0,0,0,"h_addrtype",null,null,null,false],[0,0,0,"h_length",null,null,null,false],[409,1255,0,null,null,null,null,false],[0,0,0,"h_addr_list",null,null,null,false],[409,1264,0,null,null,null,[51280,51281,51282,51283,51284,51285,51286,51287,51288,51289,51290,51291,51292,51293,51294,51295,51296,51297,51298,51299,51300,51301,51302,51303,51304,51305,51306,51307,51308,51309,51310,51311,51312,51313,51314,51315,51316,51317,51318,51319,51320,51321,51322,51323,51324,51325,51326,51327,51328,51329,51330,51331,51332,51333,51334,51335,51336,51337,51338,51339,51340,51341,51342,51343,51344,51345,51346,51347,51348,51349,51350,51351,51352,51353,51354,51355,51356,51357,51358,51359,51360,51361,51362,51363,51364,51365,51366,51367,51368,51369,51370,51371,51372,51373,51374],false],[0,0,0,"WSA_INVALID_HANDLE",null," Specified event object handle is invalid.\n An application attempts to use an event object, but the specified handle is not valid.",null,false],[0,0,0,"WSA_NOT_ENOUGH_MEMORY",null," Insufficient memory available.\n An application used a Windows Sockets function that directly maps to a Windows function.\n The Windows function is indicating a lack of required memory resources.",null,false],[0,0,0,"WSA_INVALID_PARAMETER",null," One or more parameters are invalid.\n An application used a Windows Sockets function which directly maps to a Windows function.\n The Windows function is indicating a problem with one or more parameters.",null,false],[0,0,0,"WSA_OPERATION_ABORTED",null," Overlapped operation aborted.\n An overlapped operation was canceled due to the closure of the socket, or the execution of the SIO_FLUSH command in WSAIoctl.",null,false],[0,0,0,"WSA_IO_INCOMPLETE",null," Overlapped I/O event object not in signaled state.\n The application has tried to determine the status of an overlapped operation which is not yet completed.\n Applications that use WSAGetOverlappedResult (with the fWait flag set to FALSE) in a polling mode to determine when an overlapped operation has completed, get this error code until the operation is complete.",null,false],[0,0,0,"WSA_IO_PENDING",null," The application has initiated an overlapped operation that cannot be completed immediately.\n A completion indication will be given later when the operation has been completed.",null,false],[0,0,0,"WSAEINTR",null," Interrupted function call.\n A blocking operation was interrupted by a call to WSACancelBlockingCall.",null,false],[0,0,0,"WSAEBADF",null," File handle is not valid.\n The file handle supplied is not valid.",null,false],[0,0,0,"WSAEACCES",null," Permission denied.\n An attempt was made to access a socket in a way forbidden by its access permissions.\n An example is using a broadcast address for sendto without broadcast permission being set using setsockopt(SO.BROADCAST).\n Another possible reason for the WSAEACCES error is that when the bind function is called (on Windows NT 4.0 with SP4 and later), another application, service, or kernel mode driver is bound to the same address with exclusive access.\n Such exclusive access is a new feature of Windows NT 4.0 with SP4 and later, and is implemented by using the SO.EXCLUSIVEADDRUSE option.",null,false],[0,0,0,"WSAEFAULT",null," Bad address.\n The system detected an invalid pointer address in attempting to use a pointer argument of a call.\n This error occurs if an application passes an invalid pointer value, or if the length of the buffer is too small.\n For instance, if the length of an argument, which is a sockaddr structure, is smaller than the sizeof(sockaddr).",null,false],[0,0,0,"WSAEINVAL",null," Invalid argument.\n Some invalid argument was supplied (for example, specifying an invalid level to the setsockopt function).\n In some instances, it also refers to the current state of the socket—for instance, calling accept on a socket that is not listening.",null,false],[0,0,0,"WSAEMFILE",null," Too many open files.\n Too many open sockets. Each implementation may have a maximum number of socket handles available, either globally, per process, or per thread.",null,false],[0,0,0,"WSAEWOULDBLOCK",null," Resource temporarily unavailable.\n This error is returned from operations on nonblocking sockets that cannot be completed immediately, for example recv when no data is queued to be read from the socket.\n It is a nonfatal error, and the operation should be retried later.\n It is normal for WSAEWOULDBLOCK to be reported as the result from calling connect on a nonblocking SOCK.STREAM socket, since some time must elapse for the connection to be established.",null,false],[0,0,0,"WSAEINPROGRESS",null," Operation now in progress.\n A blocking operation is currently executing.\n Windows Sockets only allows a single blocking operation—per- task or thread—to be outstanding, and if any other function call is made (whether or not it references that or any other socket) the function fails with the WSAEINPROGRESS error.",null,false],[0,0,0,"WSAEALREADY",null," Operation already in progress.\n An operation was attempted on a nonblocking socket with an operation already in progress—that is, calling connect a second time on a nonblocking socket that is already connecting, or canceling an asynchronous request (WSAAsyncGetXbyY) that has already been canceled or completed.",null,false],[0,0,0,"WSAENOTSOCK",null," Socket operation on nonsocket.\n An operation was attempted on something that is not a socket.\n Either the socket handle parameter did not reference a valid socket, or for select, a member of an fd_set was not valid.",null,false],[0,0,0,"WSAEDESTADDRREQ",null," Destination address required.\n A required address was omitted from an operation on a socket.\n For example, this error is returned if sendto is called with the remote address of ADDR_ANY.",null,false],[0,0,0,"WSAEMSGSIZE",null," Message too long.\n A message sent on a datagram socket was larger than the internal message buffer or some other network limit, or the buffer used to receive a datagram was smaller than the datagram itself.",null,false],[0,0,0,"WSAEPROTOTYPE",null," Protocol wrong type for socket.\n A protocol was specified in the socket function call that does not support the semantics of the socket type requested.\n For example, the ARPA Internet UDP protocol cannot be specified with a socket type of SOCK.STREAM.",null,false],[0,0,0,"WSAENOPROTOOPT",null," Bad protocol option.\n An unknown, invalid or unsupported option or level was specified in a getsockopt or setsockopt call.",null,false],[0,0,0,"WSAEPROTONOSUPPORT",null," Protocol not supported.\n The requested protocol has not been configured into the system, or no implementation for it exists.\n For example, a socket call requests a SOCK.DGRAM socket, but specifies a stream protocol.",null,false],[0,0,0,"WSAESOCKTNOSUPPORT",null," Socket type not supported.\n The support for the specified socket type does not exist in this address family.\n For example, the optional type SOCK.RAW might be selected in a socket call, and the implementation does not support SOCK.RAW sockets at all.",null,false],[0,0,0,"WSAEOPNOTSUPP",null," Operation not supported.\n The attempted operation is not supported for the type of object referenced.\n Usually this occurs when a socket descriptor to a socket that cannot support this operation is trying to accept a connection on a datagram socket.",null,false],[0,0,0,"WSAEPFNOSUPPORT",null," Protocol family not supported.\n The protocol family has not been configured into the system or no implementation for it exists.\n This message has a slightly different meaning from WSAEAFNOSUPPORT.\n However, it is interchangeable in most cases, and all Windows Sockets functions that return one of these messages also specify WSAEAFNOSUPPORT.",null,false],[0,0,0,"WSAEAFNOSUPPORT",null," Address family not supported by protocol family.\n An address incompatible with the requested protocol was used.\n All sockets are created with an associated address family (that is, AF.INET for Internet Protocols) and a generic protocol type (that is, SOCK.STREAM).\n This error is returned if an incorrect protocol is explicitly requested in the socket call, or if an address of the wrong family is used for a socket, for example, in sendto.",null,false],[0,0,0,"WSAEADDRINUSE",null," Address already in use.\n Typically, only one usage of each socket address (protocol/IP address/port) is permitted.\n This error occurs if an application attempts to bind a socket to an IP address/port that has already been used for an existing socket, or a socket that was not closed properly, or one that is still in the process of closing.\n For server applications that need to bind multiple sockets to the same port number, consider using setsockopt (SO.REUSEADDR).\n Client applications usually need not call bind at all—connect chooses an unused port automatically.\n When bind is called with a wildcard address (involving ADDR_ANY), a WSAEADDRINUSE error could be delayed until the specific address is committed.\n This could happen with a call to another function later, including connect, listen, WSAConnect, or WSAJoinLeaf.",null,false],[0,0,0,"WSAEADDRNOTAVAIL",null," Cannot assign requested address.\n The requested address is not valid in its context.\n This normally results from an attempt to bind to an address that is not valid for the local computer.\n This can also result from connect, sendto, WSAConnect, WSAJoinLeaf, or WSASendTo when the remote address or port is not valid for a remote computer (for example, address or port 0).",null,false],[0,0,0,"WSAENETDOWN",null," Network is down.\n A socket operation encountered a dead network.\n This could indicate a serious failure of the network system (that is, the protocol stack that the Windows Sockets DLL runs over), the network interface, or the local network itself.",null,false],[0,0,0,"WSAENETUNREACH",null," Network is unreachable.\n A socket operation was attempted to an unreachable network.\n This usually means the local software knows no route to reach the remote host.",null,false],[0,0,0,"WSAENETRESET",null," Network dropped connection on reset.\n The connection has been broken due to keep-alive activity detecting a failure while the operation was in progress.\n It can also be returned by setsockopt if an attempt is made to set SO.KEEPALIVE on a connection that has already failed.",null,false],[0,0,0,"WSAECONNABORTED",null," Software caused connection abort.\n An established connection was aborted by the software in your host computer, possibly due to a data transmission time-out or protocol error.",null,false],[0,0,0,"WSAECONNRESET",null," Connection reset by peer.\n An existing connection was forcibly closed by the remote host.\n This normally results if the peer application on the remote host is suddenly stopped, the host is rebooted, the host or remote network interface is disabled, or the remote host uses a hard close (see setsockopt for more information on the SO.LINGER option on the remote socket).\n This error may also result if a connection was broken due to keep-alive activity detecting a failure while one or more operations are in progress.\n Operations that were in progress fail with WSAENETRESET. Subsequent operations fail with WSAECONNRESET.",null,false],[0,0,0,"WSAENOBUFS",null," No buffer space available.\n An operation on a socket could not be performed because the system lacked sufficient buffer space or because a queue was full.",null,false],[0,0,0,"WSAEISCONN",null," Socket is already connected.\n A connect request was made on an already-connected socket.\n Some implementations also return this error if sendto is called on a connected SOCK.DGRAM socket (for SOCK.STREAM sockets, the to parameter in sendto is ignored) although other implementations treat this as a legal occurrence.",null,false],[0,0,0,"WSAENOTCONN",null," Socket is not connected.\n A request to send or receive data was disallowed because the socket is not connected and (when sending on a datagram socket using sendto) no address was supplied.\n Any other type of operation might also return this error—for example, setsockopt setting SO.KEEPALIVE if the connection has been reset.",null,false],[0,0,0,"WSAESHUTDOWN",null," Cannot send after socket shutdown.\n A request to send or receive data was disallowed because the socket had already been shut down in that direction with a previous shutdown call.\n By calling shutdown a partial close of a socket is requested, which is a signal that sending or receiving, or both have been discontinued.",null,false],[0,0,0,"WSAETOOMANYREFS",null," Too many references.\n Too many references to some kernel object.",null,false],[0,0,0,"WSAETIMEDOUT",null," Connection timed out.\n A connection attempt failed because the connected party did not properly respond after a period of time, or the established connection failed because the connected host has failed to respond.",null,false],[0,0,0,"WSAECONNREFUSED",null," Connection refused.\n No connection could be made because the target computer actively refused it.\n This usually results from trying to connect to a service that is inactive on the foreign host—that is, one with no server application running.",null,false],[0,0,0,"WSAELOOP",null," Cannot translate name.\n Cannot translate a name.",null,false],[0,0,0,"WSAENAMETOOLONG",null," Name too long.\n A name component or a name was too long.",null,false],[0,0,0,"WSAEHOSTDOWN",null," Host is down.\n A socket operation failed because the destination host is down. A socket operation encountered a dead host.\n Networking activity on the local host has not been initiated.\n These conditions are more likely to be indicated by the error WSAETIMEDOUT.",null,false],[0,0,0,"WSAEHOSTUNREACH",null," No route to host.\n A socket operation was attempted to an unreachable host. See WSAENETUNREACH.",null,false],[0,0,0,"WSAENOTEMPTY",null," Directory not empty.\n Cannot remove a directory that is not empty.",null,false],[0,0,0,"WSAEPROCLIM",null," Too many processes.\n A Windows Sockets implementation may have a limit on the number of applications that can use it simultaneously.\n WSAStartup may fail with this error if the limit has been reached.",null,false],[0,0,0,"WSAEUSERS",null," User quota exceeded.\n Ran out of user quota.",null,false],[0,0,0,"WSAEDQUOT",null," Disk quota exceeded.\n Ran out of disk quota.",null,false],[0,0,0,"WSAESTALE",null," Stale file handle reference.\n The file handle reference is no longer available.",null,false],[0,0,0,"WSAEREMOTE",null," Item is remote.\n The item is not available locally.",null,false],[0,0,0,"WSASYSNOTREADY",null," Network subsystem is unavailable.\n This error is returned by WSAStartup if the Windows Sockets implementation cannot function at this time because the underlying system it uses to provide network services is currently unavailable.\n Users should check:\n   - That the appropriate Windows Sockets DLL file is in the current path.\n   - That they are not trying to use more than one Windows Sockets implementation simultaneously.\n   - If there is more than one Winsock DLL on your system, be sure the first one in the path is appropriate for the network subsystem currently loaded.\n   - The Windows Sockets implementation documentation to be sure all necessary components are currently installed and configured correctly.",null,false],[0,0,0,"WSAVERNOTSUPPORTED",null," Winsock.dll version out of range.\n The current Windows Sockets implementation does not support the Windows Sockets specification version requested by the application.\n Check that no old Windows Sockets DLL files are being accessed.",null,false],[0,0,0,"WSANOTINITIALISED",null," Successful WSAStartup not yet performed.\n Either the application has not called WSAStartup or WSAStartup failed.\n The application may be accessing a socket that the current active task does not own (that is, trying to share a socket between tasks), or WSACleanup has been called too many times.",null,false],[0,0,0,"WSAEDISCON",null," Graceful shutdown in progress.\n Returned by WSARecv and WSARecvFrom to indicate that the remote party has initiated a graceful shutdown sequence.",null,false],[0,0,0,"WSAENOMORE",null," No more results.\n No more results can be returned by the WSALookupServiceNext function.",null,false],[0,0,0,"WSAECANCELLED",null," Call has been canceled.\n A call to the WSALookupServiceEnd function was made while this call was still processing. The call has been canceled.",null,false],[0,0,0,"WSAEINVALIDPROCTABLE",null," Procedure call table is invalid.\n The service provider procedure call table is invalid.\n A service provider returned a bogus procedure table to Ws2_32.dll.\n This is usually caused by one or more of the function pointers being NULL.",null,false],[0,0,0,"WSAEINVALIDPROVIDER",null," Service provider is invalid.\n The requested service provider is invalid.\n This error is returned by the WSCGetProviderInfo and WSCGetProviderInfo32 functions if the protocol entry specified could not be found.\n This error is also returned if the service provider returned a version number other than 2.0.",null,false],[0,0,0,"WSAEPROVIDERFAILEDINIT",null," Service provider failed to initialize.\n The requested service provider could not be loaded or initialized.\n This error is returned if either a service provider's DLL could not be loaded (LoadLibrary failed) or the provider's WSPStartup or NSPStartup function failed.",null,false],[0,0,0,"WSASYSCALLFAILURE",null," System call failure.\n A system call that should never fail has failed.\n This is a generic error code, returned under various conditions.\n Returned when a system call that should never fail does fail.\n For example, if a call to WaitForMultipleEvents fails or one of the registry functions fails trying to manipulate the protocol/namespace catalogs.\n Returned when a provider does not return SUCCESS and does not provide an extended error code.\n Can indicate a service provider implementation error.",null,false],[0,0,0,"WSASERVICE_NOT_FOUND",null," Service not found.\n No such service is known. The service cannot be found in the specified name space.",null,false],[0,0,0,"WSATYPE_NOT_FOUND",null," Class type not found.\n The specified class was not found.",null,false],[0,0,0,"WSA_E_NO_MORE",null," No more results.\n No more results can be returned by the WSALookupServiceNext function.",null,false],[0,0,0,"WSA_E_CANCELLED",null," Call was canceled.\n A call to the WSALookupServiceEnd function was made while this call was still processing. The call has been canceled.",null,false],[0,0,0,"WSAEREFUSED",null," Database query was refused.\n A database query failed because it was actively refused.",null,false],[0,0,0,"WSAHOST_NOT_FOUND",null," Host not found.\n No such host is known. The name is not an official host name or alias, or it cannot be found in the database(s) being queried.\n This error may also be returned for protocol and service queries, and means that the specified name could not be found in the relevant database.",null,false],[0,0,0,"WSATRY_AGAIN",null," Nonauthoritative host not found.\n This is usually a temporary error during host name resolution and means that the local server did not receive a response from an authoritative server. A retry at some time later may be successful.",null,false],[0,0,0,"WSANO_RECOVERY",null," This is a nonrecoverable error.\n This indicates that some sort of nonrecoverable error occurred during a database lookup.\n This may be because the database files (for example, BSD-compatible HOSTS, SERVICES, or PROTOCOLS files) could not be found, or a DNS request was returned by the server with a severe error.",null,false],[0,0,0,"WSANO_DATA",null," Valid name, no data record of requested type.\n The requested name is valid and was found in the database, but it does not have the correct associated data being resolved for.\n The usual example for this is a host name-to-address translation attempt (using gethostbyname or WSAAsyncGetHostByName) which uses the DNS (Domain Name Server).\n An MX record is returned but no A record—indicating the host itself exists, but is not directly reachable.",null,false],[0,0,0,"WSA_QOS_RECEIVERS",null," QoS receivers.\n At least one QoS reserve has arrived.",null,false],[0,0,0,"WSA_QOS_SENDERS",null," QoS senders.\n At least one QoS send path has arrived.",null,false],[0,0,0,"WSA_QOS_NO_SENDERS",null," No QoS senders.\n There are no QoS senders.",null,false],[0,0,0,"WSA_QOS_NO_RECEIVERS",null," QoS no receivers.\n There are no QoS receivers.",null,false],[0,0,0,"WSA_QOS_REQUEST_CONFIRMED",null," QoS request confirmed.\n The QoS reserve request has been confirmed.",null,false],[0,0,0,"WSA_QOS_ADMISSION_FAILURE",null," QoS admission error.\n A QoS error occurred due to lack of resources.",null,false],[0,0,0,"WSA_QOS_POLICY_FAILURE",null," QoS policy failure.\n The QoS request was rejected because the policy system couldn't allocate the requested resource within the existing policy.",null,false],[0,0,0,"WSA_QOS_BAD_STYLE",null," QoS bad style.\n An unknown or conflicting QoS style was encountered.",null,false],[0,0,0,"WSA_QOS_BAD_OBJECT",null," QoS bad object.\n A problem was encountered with some part of the filterspec or the provider-specific buffer in general.",null,false],[0,0,0,"WSA_QOS_TRAFFIC_CTRL_ERROR",null," QoS traffic control error.\n An error with the underlying traffic control (TC) API as the generic QoS request was converted for local enforcement by the TC API.\n This could be due to an out of memory error or to an internal QoS provider error.",null,false],[0,0,0,"WSA_QOS_GENERIC_ERROR",null," QoS generic error.\n A general QoS error.",null,false],[0,0,0,"WSA_QOS_ESERVICETYPE",null," QoS service type error.\n An invalid or unrecognized service type was found in the QoS flowspec.",null,false],[0,0,0,"WSA_QOS_EFLOWSPEC",null," QoS flowspec error.\n An invalid or inconsistent flowspec was found in the QOS structure.",null,false],[0,0,0,"WSA_QOS_EPROVSPECBUF",null," Invalid QoS provider buffer.\n An invalid QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_EFILTERSTYLE",null," Invalid QoS filter style.\n An invalid QoS filter style was used.",null,false],[0,0,0,"WSA_QOS_EFILTERTYPE",null," Invalid QoS filter type.\n An invalid QoS filter type was used.",null,false],[0,0,0,"WSA_QOS_EFILTERCOUNT",null," Incorrect QoS filter count.\n An incorrect number of QoS FILTERSPECs were specified in the FLOWDESCRIPTOR.",null,false],[0,0,0,"WSA_QOS_EOBJLENGTH",null," Invalid QoS object length.\n An object with an invalid ObjectLength field was specified in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_EFLOWCOUNT",null," Incorrect QoS flow count.\n An incorrect number of flow descriptors was specified in the QoS structure.",null,false],[0,0,0,"WSA_QOS_EUNKOWNPSOBJ",null," Unrecognized QoS object.\n An unrecognized object was found in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_EPOLICYOBJ",null," Invalid QoS policy object.\n An invalid policy object was found in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_EFLOWDESC",null," Invalid QoS flow descriptor.\n An invalid QoS flow descriptor was found in the flow descriptor list.",null,false],[0,0,0,"WSA_QOS_EPSFLOWSPEC",null," Invalid QoS provider-specific flowspec.\n An invalid or inconsistent flowspec was found in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_EPSFILTERSPEC",null," Invalid QoS provider-specific filterspec.\n An invalid FILTERSPEC was found in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_ESDMODEOBJ",null," Invalid QoS shape discard mode object.\n An invalid shape discard mode object was found in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_ESHAPERATEOBJ",null," Invalid QoS shaping rate object.\n An invalid shaping rate object was found in the QoS provider-specific buffer.",null,false],[0,0,0,"WSA_QOS_RESERVED_PETYPE",null," Reserved policy QoS element type.\n A reserved policy element was found in the QoS provider-specific buffer.",null,false],[409,1712,0,null,null,null,[51376,51377,51378],false],[0,0,0,"s",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[409,1718,0,null,null,null,[51380,51381,51382],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[409,1724,0,null,null,null,[51384],false],[0,0,0,"s",null,"",null,false],[409,1728,0,null,null,null,[51386,51387,51388],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[409,1734,0,null,null,null,[51390,51391,51392],false],[0,0,0,"s",null,"",null,false],[0,0,0,"cmd",null,"",null,false],[0,0,0,"argp",null,"",null,false],[409,1740,0,null,null,null,[51394,51395,51396],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[409,1746,0,null,null,null,[51398,51399,51400],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[409,1752,0,null,null,null,[51402,51403,51404,51405,51406],false],[0,0,0,"s",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"optval",null,"",null,false],[0,0,0,"optlen",null,"",null,false],[409,1760,0,null,null,null,[51408],false],[0,0,0,"hostlong",null,"",null,false],[409,1764,0,null,null,null,[51410],false],[0,0,0,"hostshort",null,"",null,false],[409,1768,0,null,null,null,[51412],false],[0,0,0,"cp",null,"",null,false],[409,1772,0,null,null,null,[51414,51415],false],[0,0,0,"s",null,"",null,false],[0,0,0,"backlog",null,"",null,false],[409,1777,0,null,null,null,[51417],false],[0,0,0,"netlong",null,"",null,false],[409,1781,0,null,null,null,[51419],false],[0,0,0,"netshort",null,"",null,false],[409,1785,0,null,null,null,[51421,51422,51423,51424],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[409,1792,0,null,null,null,[51426,51427,51428,51429,51430,51431],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"fromlen",null,"",null,false],[409,1801,0,null,null,null,[51433,51434,51435,51436,51437],false],[0,0,0,"nfds",null,"",null,false],[0,0,0,"readfds",null,"",null,false],[0,0,0,"writefds",null,"",null,false],[0,0,0,"exceptfds",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[409,1809,0,null,null,null,[51439,51440,51441,51442],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[409,1816,0,null,null,null,[51444,51445,51446,51447,51448,51449],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"to",null,"",null,false],[0,0,0,"tolen",null,"",null,false],[409,1825,0,null,null,null,[51451,51452,51453,51454,51455],false],[0,0,0,"s",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"optval",null,"",null,false],[0,0,0,"optlen",null,"",null,false],[409,1833,0,null,null,null,[51457,51458],false],[0,0,0,"s",null,"",null,false],[0,0,0,"how",null,"",null,false],[409,1838,0,null,null,null,[51460,51461,51462],false],[0,0,0,"af",null,"",null,false],[0,0,0,"type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[409,1844,0,null,null,null,[51464,51465],false],[0,0,0,"wVersionRequired",null,"",null,false],[0,0,0,"lpWSAData",null,"",null,false],[409,1849,0,null,null,null,[],false],[409,1851,0,null,null,null,[51468],false],[0,0,0,"iError",null,"",null,false],[409,1853,0,null,null,null,[],false],[409,1855,0,null,null,null,[],false],[409,1857,0,null,null,null,[],false],[409,1859,0,null,null,null,[51473],false],[0,0,0,"lpBlockFunc",null,"",null,false],[409,1861,0,null,null,null,[],false],[409,1863,0,null,null,null,[51476,51477,51478,51479,51480,51481],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsg",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"proto",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buflen",null,"",null,false],[409,1872,0,null,null,null,[51483,51484,51485,51486,51487,51488],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsg",null,"",null,false],[0,0,0,"port",null,"",null,false],[0,0,0,"proto",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buflen",null,"",null,false],[409,1881,0,null,null,null,[51490,51491,51492,51493,51494],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsg",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buflen",null,"",null,false],[409,1889,0,null,null,null,[51496,51497,51498,51499,51500],false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsg",null,"",null,false],[0,0,0,"number",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"buflen",null,"",null,false],[409,1897,0,null,null,null,[51502],false],[0,0,0,"hAsyncTaskHandle",null,"",null,false],[409,1899,0,null,null,null,[51504,51505,51506,51507],false],[0,0,0,"s",null,"",null,false],[0,0,0,"hWnd",null,"",null,false],[0,0,0,"wMsg",null,"",null,false],[0,0,0,"lEvent",null,"",null,false],[409,1906,0,null,null,null,[51509,51510,51511,51512,51513],false],[0,0,0,"s",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[0,0,0,"lpfnCondition",null,"",null,false],[0,0,0,"dwCallbackData",null,"",null,false],[409,1914,0,null,null,null,[51515],false],[0,0,0,"hEvent",null,"",null,false],[409,1916,0,null,null,null,[51517,51518,51519,51520,51521,51522,51523],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[0,0,0,"lpCallerData",null,"",null,false],[0,0,0,"lpCalleeData",null,"",null,false],[0,0,0,"lpSQOS",null,"",null,false],[0,0,0,"lpGQOS",null,"",null,false],[409,1926,0,null,null,null,[51525,51526,51527,51528,51529,51530,51531,51532,51533],false],[0,0,0,"s",null,"",null,false],[0,0,0,"nodename",null,"",null,false],[0,0,0,"servicename",null,"",null,false],[0,0,0,"LocalAddressLength",null,"",null,false],[0,0,0,"LocalAddress",null,"",null,false],[0,0,0,"RemoteAddressLength",null,"",null,false],[0,0,0,"RemoteAddress",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"Reserved",null,"",null,false],[409,1938,0,null,null,null,[51535,51536,51537,51538,51539,51540,51541,51542,51543],false],[0,0,0,"s",null,"",null,false],[0,0,0,"nodename",null,"",null,false],[0,0,0,"servicename",null,"",null,false],[0,0,0,"LocalAddressLength",null,"",null,false],[0,0,0,"LocalAddress",null,"",null,false],[0,0,0,"RemoteAddressLength",null,"",null,false],[0,0,0,"RemoteAddress",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"Reserved",null,"",null,false],[409,1950,0,null,null,null,[51545,51546,51547,51548,51549,51550,51551,51552],false],[0,0,0,"s",null,"",null,false],[0,0,0,"SocketAddress",null,"",null,false],[0,0,0,"LocalAddressLength",null,"",null,false],[0,0,0,"LocalAddress",null,"",null,false],[0,0,0,"RemoteAddressLength",null,"",null,false],[0,0,0,"RemoteAddress",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"Reserved",null,"",null,false],[409,1961,0,null,null,null,[],false],[409,1963,0,null,null,null,[51555,51556,51557],false],[0,0,0,"s",null,"",null,false],[0,0,0,"dwProcessId",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[409,1969,0,null,null,null,[51559,51560,51561],false],[0,0,0,"s",null,"",null,false],[0,0,0,"dwProcessId",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[409,1975,0,null,null,null,[51563,51564,51565],false],[0,0,0,"s",null,"",null,false],[0,0,0,"hEventObject",null,"",null,false],[0,0,0,"lpNetworkEvents",null,"",null,false],[409,1981,0,null,null,null,[51567,51568,51569],false],[0,0,0,"lpiProtocols",null,"",null,false],[0,0,0,"lpProtocolBuffer",null,"",null,false],[0,0,0,"lpdwBufferLength",null,"",null,false],[409,1987,0,null,null,null,[51571,51572,51573],false],[0,0,0,"lpiProtocols",null,"",null,false],[0,0,0,"lpProtocolBuffer",null,"",null,false],[0,0,0,"lpdwBufferLength",null,"",null,false],[409,1993,0,null,null,null,[51575,51576,51577],false],[0,0,0,"s",null,"",null,false],[0,0,0,"hEventObject",null,"",null,false],[0,0,0,"lNetworkEvents",null,"",null,false],[409,1999,0,null,null,null,[51579,51580,51581,51582,51583],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpcbTransfer",null,"",null,false],[0,0,0,"fWait",null,"",null,false],[0,0,0,"lpdwFlags",null,"",null,false],[409,2007,0,null,null,null,[51585,51586,51587],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpQOSName",null,"",null,false],[0,0,0,"lpQOS",null,"",null,false],[409,2013,0,null,null,null,[51589,51590,51591],false],[0,0,0,"s",null,"",null,false],[0,0,0,"hostlong",null,"",null,false],[0,0,0,"lpnetlong",null,"",null,false],[409,2019,0,null,null,null,[51593,51594,51595],false],[0,0,0,"s",null,"",null,false],[0,0,0,"hostshort",null,"",null,false],[0,0,0,"lpnetshort",null,"",null,false],[409,2025,0,null,null,null,[51597,51598,51599,51600,51601,51602,51603,51604,51605],false],[0,0,0,"s",null,"",null,false],[0,0,0,"dwIoControlCode",null,"",null,false],[0,0,0,"lpvInBuffer",null,"",null,false],[0,0,0,"cbInBuffer",null,"",null,false],[0,0,0,"lpvOutbuffer",null,"",null,false],[0,0,0,"cbOutbuffer",null,"",null,false],[0,0,0,"lpcbBytesReturned",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2037,0,null,null,null,[51607,51608,51609,51610,51611,51612,51613,51614],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[0,0,0,"lpCallerdata",null,"",null,false],[0,0,0,"lpCalleeData",null,"",null,false],[0,0,0,"lpSQOS",null,"",null,false],[0,0,0,"lpGQOS",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[409,2048,0,null,null,null,[51616,51617,51618],false],[0,0,0,"s",null,"",null,false],[0,0,0,"netlong",null,"",null,false],[0,0,0,"lphostlong",null,"",null,false],[409,2054,0,null,null,null,[51620,51621,51622],false],[0,0,0,"s",null,"",null,false],[0,0,0,"netshort",null,"",null,false],[0,0,0,"lphostshort",null,"",null,false],[409,2060,0,null,null,null,[51624,51625,51626,51627,51628,51629,51630],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpBuffers",null,"",null,false],[0,0,0,"dwBufferCouynt",null,"",null,false],[0,0,0,"lpNumberOfBytesRecv",null,"",null,false],[0,0,0,"lpFlags",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2070,0,null,null,null,[51632,51633],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpInboundDisconnectData",null,"",null,false],[409,2075,0,null,null,null,[51635,51636,51637,51638,51639,51640,51641,51642,51643],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpBuffers",null,"",null,false],[0,0,0,"dwBuffercount",null,"",null,false],[0,0,0,"lpNumberOfBytesRecvd",null,"",null,false],[0,0,0,"lpFlags",null,"",null,false],[0,0,0,"lpFrom",null,"",null,false],[0,0,0,"lpFromlen",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2087,0,null,null,null,[51645],false],[0,0,0,"hEvent",null,"",null,false],[409,2089,0,null,null,null,[51647,51648,51649,51650,51651,51652,51653],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpBuffers",null,"",null,false],[0,0,0,"dwBufferCount",null,"",null,false],[0,0,0,"lpNumberOfBytesSent",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2099,0,null,null,null,[51655,51656,51657,51658,51659,51660],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpNumberOfBytesSent",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2108,0,null,null,null,[51662,51663,51664,51665,51666],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpMsg",null,"",null,false],[0,0,0,"lpdwNumberOfBytesRecv",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2116,0,null,null,null,[51668,51669],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpOutboundDisconnectData",null,"",null,false],[409,2121,0,null,null,null,[51671,51672,51673,51674,51675,51676,51677,51678,51679],false],[0,0,0,"s",null,"",null,false],[0,0,0,"lpBuffers",null,"",null,false],[0,0,0,"dwBufferCount",null,"",null,false],[0,0,0,"lpNumberOfBytesSent",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpTo",null,"",null,false],[0,0,0,"iToLen",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRounte",null,"",null,false],[409,2133,0,null,null,null,[51681],false],[0,0,0,"hEvent",null,"",null,false],[409,2137,0,null,null,null,[51683,51684,51685,51686,51687,51688],false],[0,0,0,"af",null,"",null,false],[0,0,0,"type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[0,0,0,"g",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[409,2146,0,null,null,null,[51690,51691,51692,51693,51694,51695],false],[0,0,0,"af",null,"",null,false],[0,0,0,"type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[0,0,0,"g",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[409,2155,0,null,null,null,[51697,51698,51699,51700,51701],false],[0,0,0,"cEvents",null,"",null,false],[0,0,0,"lphEvents",null,"",null,false],[0,0,0,"fWaitAll",null,"",null,false],[0,0,0,"dwTimeout",null,"",null,false],[0,0,0,"fAlertable",null,"",null,false],[409,2163,0,null,null,null,[51703,51704,51705,51706,51707],false],[0,0,0,"lpsaAddress",null,"",null,false],[0,0,0,"dwAddressLength",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[0,0,0,"lpszAddressString",null,"",null,false],[0,0,0,"lpdwAddressStringLength",null,"",null,false],[409,2171,0,null,null,null,[51709,51710,51711,51712,51713],false],[0,0,0,"lpsaAddress",null,"",null,false],[0,0,0,"dwAddressLength",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[0,0,0,"lpszAddressString",null,"",null,false],[0,0,0,"lpdwAddressStringLength",null,"",null,false],[409,2179,0,null,null,null,[51715,51716,51717,51718,51719],false],[0,0,0,"AddressString",null,"",null,false],[0,0,0,"AddressFamily",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"lpAddressLength",null,"",null,false],[409,2187,0,null,null,null,[51721,51722,51723,51724,51725],false],[0,0,0,"AddressString",null,"",null,false],[0,0,0,"AddressFamily",null,"",null,false],[0,0,0,"lpProtocolInfo",null,"",null,false],[0,0,0,"lpAddrses",null,"",null,false],[0,0,0,"lpAddressLength",null,"",null,false],[409,2195,0,null,null,null,[51727,51728,51729],false],[0,0,0,"lpNotificationHandle",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2201,0,null,null,null,[51731,51732,51733],false],[0,0,0,"fdArray",null,"",null,false],[0,0,0,"fds",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[409,2207,0,null,null,null,[51735,51736,51737,51738],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[409,2214,0,null,null,null,[51740,51741,51742,51743,51744,51745,51746],false],[0,0,0,"hSocket",null,"",null,false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"nNumberOfBytesToWrite",null,"",null,false],[0,0,0,"nNumberOfBytesPerSend",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpTransmitBuffers",null,"",null,false],[0,0,0,"dwReserved",null,"",null,false],[409,2224,0,null,null,null,[51748,51749,51750,51751,51752,51753,51754,51755],false],[0,0,0,"sListenSocket",null,"",null,false],[0,0,0,"sAcceptSocket",null,"",null,false],[0,0,0,"lpOutputBuffer",null,"",null,false],[0,0,0,"dwReceiveDataLength",null,"",null,false],[0,0,0,"dwLocalAddressLength",null,"",null,false],[0,0,0,"dwRemoteAddressLength",null,"",null,false],[0,0,0,"lpdwBytesReceived",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[409,2235,0,null,null,null,[51757,51758,51759,51760,51761,51762,51763,51764],false],[0,0,0,"lpOutputBuffer",null,"",null,false],[0,0,0,"dwReceiveDataLength",null,"",null,false],[0,0,0,"dwLocalAddressLength",null,"",null,false],[0,0,0,"dwRemoteAddressLength",null,"",null,false],[0,0,0,"LocalSockaddr",null,"",null,false],[0,0,0,"LocalSockaddrLength",null,"",null,false],[0,0,0,"RemoteSockaddr",null,"",null,false],[0,0,0,"RemoteSockaddrLength",null,"",null,false],[409,2246,0,null,null,null,[51766,51767],false],[0,0,0,"hAsyncCall",null,"",null,false],[0,0,0,"iRetCode",null,"",null,false],[409,2251,0,null,null,null,[51769,51770,51771],false],[0,0,0,"lpiProtocols",null,"",null,false],[0,0,0,"lpProtocolBuffer",null,"",null,false],[0,0,0,"lpdwBufferLength",null,"",null,false],[409,2257,0,null,null,null,[51773,51774,51775],false],[0,0,0,"lpiProtocols",null,"",null,false],[0,0,0,"lpProtocolBuffer",null,"",null,false],[0,0,0,"lpdwBufferLength",null,"",null,false],[409,2263,0,null,null,null,[51777,51778,51779,51780,51781,51782,51783,51784,51785],false],[0,0,0,"dwNameSpace",null,"",null,false],[0,0,0,"lpServiceType",null,"",null,false],[0,0,0,"lpServiceName",null,"",null,false],[0,0,0,"lpiProtocols",null,"",null,false],[0,0,0,"dwResolution",null,"",null,false],[0,0,0,"lpServiceAsyncInfo",null,"",null,false],[0,0,0,"lpCsaddrBuffer",null,"",null,false],[0,0,0,"lpAliasBuffer",null,"",null,false],[0,0,0,"lpdwAliasBufferLength",null,"",null,false],[409,2275,0,null,null,null,[51787,51788,51789,51790,51791,51792,51793,51794,51795,51796],false],[0,0,0,"dwNameSpace",null,"",null,false],[0,0,0,"lpServiceType",null,"",null,false],[0,0,0,"lpServiceName",null,"",null,false],[0,0,0,"lpiProtocols",null,"",null,false],[0,0,0,"dwResolution",null,"",null,false],[0,0,0,"lpServiceAsyncInfo",null,"",null,false],[0,0,0,"lpCsaddrBuffer",null,"",null,false],[0,0,0,"ldwBufferLEngth",null,"",null,false],[0,0,0,"lpAliasBuffer",null,"",null,false],[0,0,0,"lpdwAliasBufferLength",null,"",null,false],[409,2288,0,null,null,null,[51798,51799],false],[0,0,0,"lpServiceName",null,"",null,false],[0,0,0,"lpServiceType",null,"",null,false],[409,2293,0,null,null,null,[51801,51802],false],[0,0,0,"lpServiceName",null,"",null,false],[0,0,0,"lpServiceType",null,"",null,false],[409,2298,0,null,null,null,[51804,51805,51806],false],[0,0,0,"lpServiceType",null,"",null,false],[0,0,0,"lpServiceName",null,"",null,false],[0,0,0,"dwNameLength",null,"",null,false],[409,2304,0,null,null,null,[51808,51809,51810],false],[0,0,0,"lpServiceType",null,"",null,false],[0,0,0,"lpServiceName",null,"",null,false],[0,0,0,"dwNameLength",null,"",null,false],[409,2310,0,null,null,null,[51812,51813,51814,51815],false],[0,0,0,"pNodeName",null,"",null,false],[0,0,0,"pServiceName",null,"",null,false],[0,0,0,"pHints",null,"",null,false],[0,0,0,"ppResult",null,"",null,false],[409,2317,0,null,null,null,[51817,51818,51819,51820,51821,51822,51823,51824,51825],false],[0,0,0,"pName",null,"",null,false],[0,0,0,"pServiceName",null,"",null,false],[0,0,0,"dwNameSapce",null,"",null,false],[0,0,0,"lpNspId",null,"",null,false],[0,0,0,"hints",null,"",null,false],[0,0,0,"ppResult",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"lpCompletionRoutine",null,"",null,false],[409,2329,0,null,null,null,[51827],false],[0,0,0,"lpHandle",null,"",null,false],[409,2333,0,null,null,null,[51829],false],[0,0,0,"lpOverlapped",null,"",null,false],[409,2337,0,null,null,null,[51831],false],[0,0,0,"pAddrInfo",null,"",null,false],[409,2341,0,null,null,null,[51833],false],[0,0,0,"pAddrInfoEx",null,"",null,false],[409,2345,0,null,null,null,[51835,51836,51837,51838,51839,51840,51841],false],[0,0,0,"pSockaddr",null,"",null,false],[0,0,0,"SockaddrLength",null,"",null,false],[0,0,0,"pNodeBuffer",null,"",null,false],[0,0,0,"NodeBufferSize",null,"",null,false],[0,0,0,"pServiceBuffer",null,"",null,false],[0,0,0,"ServiceBufferName",null,"",null,false],[0,0,0,"Flags",null,"",null,false],[409,2355,0,null,null,null,[51843],false],[0,0,0,"InterfaceName",null,"",null,false],[401,28,0,null,null,null,null,false],[0,0,0,"windows/gdi32.zig",null,"",[],false],[410,0,0,null,null,null,null,false],[410,1,0,null,null,null,null,false],[410,2,0,null,null,null,null,false],[410,3,0,null,null,null,null,false],[410,4,0,null,null,null,null,false],[410,5,0,null,null,null,null,false],[410,6,0,null,null,null,null,false],[410,7,0,null,null,null,null,false],[410,8,0,null,null,null,null,false],[410,10,0,null,null,null,[51857,51859,51861,51863,51865,51867,51869,51871,51873,51875,51877,51879,51881,51883,51885,51887,51889,51891,51893,51895,51897,51899,51901,51903,51905,51907],false],[410,10,0,null,null,null,null,false],[0,0,0,"nSize",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"nVersion",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"dwFlags",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"iPixelType",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cColorBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cRedBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cRedShift",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cGreenBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cGreenShift",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cBlueBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cBlueShift",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAlphaBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAlphaShift",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAccumBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAccumRedBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAccumGreenBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAccumBlueBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAccumAlphaBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cDepthBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cStencilBits",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"cAuxBuffers",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"iLayerType",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"bReserved",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"dwLayerMask",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"dwVisibleMask",null,null,null,false],[410,10,0,null,null,null,null,false],[0,0,0,"dwDamageMask",null,null,null,false],[410,39,0,null,null,null,[51909,51910,51911],false],[0,0,0,"hdc",null,"",null,false],[0,0,0,"format",null,"",null,false],[0,0,0,"ppfd",null,"",null,false],[410,45,0,null,null,null,[51913,51914],false],[0,0,0,"hdc",null,"",null,false],[0,0,0,"ppfd",null,"",null,false],[410,50,0,null,null,null,[51916],false],[0,0,0,"hdc",null,"",null,false],[410,51,0,null,null,null,[51918],false],[0,0,0,"hdc",null,"",null,false],[410,52,0,null,null,null,[51920,51921],false],[0,0,0,"hdc",null,"",null,false],[0,0,0,"hglrc",null,"",null,false],[401,29,0,null,null,null,null,false],[0,0,0,"windows/winmm.zig",null,"",[],false],[411,0,0,null,null,null,null,false],[411,1,0,null,null,null,null,false],[411,2,0,null,null,null,null,false],[411,3,0,null,null,null,null,false],[411,4,0,null,null,null,null,false],[411,5,0,null,null,null,null,false],[411,7,0,null,null,null,null,false],[411,8,0,null,null,null,null,false],[411,9,0,null,null,null,null,false],[411,10,0,null,null,null,null,false],[411,11,0,null,null,null,null,false],[411,12,0,null,null,null,null,false],[411,13,0,null,null,null,null,false],[411,14,0,null,null,null,null,false],[411,15,0,null,null,null,null,false],[411,16,0,null,null,null,null,false],[411,17,0,null,null,null,null,false],[411,18,0,null,null,null,null,false],[411,19,0,null,null,null,null,false],[411,20,0,null,null,null,null,false],[411,21,0,null,null,null,null,false],[411,22,0,null,null,null,null,false],[411,23,0,null,null,null,null,false],[411,24,0,null,null,null,null,false],[411,25,0,null,null,null,null,false],[411,26,0,null,null,null,null,false],[411,27,0,null,null,null,null,false],[411,28,0,null,null,null,null,false],[411,29,0,null,null,null,null,false],[411,30,0,null,null,null,null,false],[411,31,0,null,null,null,null,false],[411,33,0,null,null,null,[51957,51981],false],[411,33,0,null,null,null,null,false],[0,0,0,"wType",null,null,null,false],[411,33,0,null,null,null,[51959,51960,51961,51962,51977,51980],false],[0,0,0,"ms",null,null,null,false],[0,0,0,"sample",null,null,null,false],[0,0,0,"cb",null,null,null,false],[0,0,0,"ticks",null,null,[51964,51966,51968,51970,51972,51974,51976],false],[411,40,0,null,null,null,null,false],[0,0,0,"hour",null,null,null,false],[411,40,0,null,null,null,null,false],[0,0,0,"min",null,null,null,false],[411,40,0,null,null,null,null,false],[0,0,0,"sec",null,null,null,false],[411,40,0,null,null,null,null,false],[0,0,0,"frame",null,null,null,false],[411,40,0,null,null,null,null,false],[0,0,0,"fps",null,null,null,false],[411,40,0,null,null,null,null,false],[0,0,0,"dummy",null,null,null,false],[411,40,0,null,null,null,null,false],[0,0,0,"pad",null,null,null,false],[0,0,0,"smpte",null,null,[51979],false],[411,49,0,null,null,null,null,false],[0,0,0,"songptrpos",null,null,null,false],[0,0,0,"midi",null,null,null,false],[0,0,0,"u",null,null,null,false],[411,54,0,null,null,null,null,false],[411,55,0,null,null,null,null,false],[411,56,0,null,null,null,null,false],[411,57,0,null,null,null,null,false],[411,58,0,null,null,null,null,false],[411,59,0,null,null,null,null,false],[411,60,0,null,null,null,null,false],[411,63,0,null,null,null,[51991,51993],false],[411,63,0,null,null,null,null,false],[0,0,0,"wPeriodMin",null,null,null,false],[411,63,0,null,null,null,null,false],[0,0,0,"wPeriodMax",null,null,null,false],[411,64,0,null,null,null,null,false],[411,65,0,null,null,null,null,false],[411,66,0,null,null,null,null,false],[411,67,0,null,null,null,null,false],[411,68,0,null,null,null,[51999],false],[0,0,0,"uPeriod",null,"",null,false],[411,69,0,null,null,null,[52001],false],[0,0,0,"uPeriod",null,"",null,false],[411,70,0,null,null,null,[52003,52004],false],[0,0,0,"ptc",null,"",null,false],[0,0,0,"cbtc",null,"",null,false],[411,71,0,null,null,null,[52006,52007],false],[0,0,0,"pmmt",null,"",null,false],[0,0,0,"cbmmt",null,"",null,false],[411,72,0,null,null,null,[],false],[401,30,0,null,null,null,null,false],[0,0,0,"windows/crypt32.zig",null,"",[],false],[412,0,0,null,null,null,null,false],[412,1,0,null,null,null,null,false],[412,2,0,null,null,null,null,false],[412,3,0,null,null,null,null,false],[412,4,0,null,null,null,null,false],[412,5,0,null,null,null,null,false],[412,6,0,null,null,null,null,false],[412,8,0,null,null,null,null,false],[412,9,0,null,null,null,null,false],[412,10,0,null,null,null,[52022,52024,52026,52028,52030],false],[412,10,0,null,null,null,null,false],[0,0,0,"dwCertEncodingType",null,null,null,false],[412,10,0,null,null,null,null,false],[0,0,0,"pbCertEncoded",null,null,null,false],[412,10,0,null,null,null,null,false],[0,0,0,"cbCertEncoded",null,null,null,false],[412,10,0,null,null,null,null,false],[0,0,0,"pCertInfo",null,null,null,false],[412,10,0,null,null,null,null,false],[0,0,0,"hCertStore",null,null,null,false],[412,18,0,null,null,null,[52032,52033],false],[0,0,0,"",null,"",null,false],[0,0,0,"szSubsystemProtocol",null,"",null,false],[412,23,0,null,null,null,[52035,52036],false],[0,0,0,"hCertStore",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[412,28,0,null,null,null,[52038,52039],false],[0,0,0,"hCertStore",null,"",null,false],[0,0,0,"pPrevCertContext",null,"",null,false],[401,31,0,null,null,null,null,false],[0,0,0,"windows/nls.zig",null," Implementations of functionality related to National Language Support\n on Windows.\n",[],false],[413,3,0,null,null,null,null,false],[413,4,0,null,null,null,null,false],[413,14,0,null,null," This corresponds to the uppercase table within the locale-independent\n l_intl.nls data (found at system32\\l_intl.nls).\n - In l_intl.nls, this data starts at offset 0x04.\n - In the PEB, this data starts at index [2] of peb.UnicodeCaseTableData when\n   it is casted to `[*]u16`.\n\n Note: This data has not changed since Windows 8.1, and has become out-of-sync with\n       the Unicode standard.",null,false],[413,132,0,null,null," Cross-platform implementation of `ntdll.RtlUpcaseUnicodeChar`.\n Transforms the UTF-16 code unit in `c` to its uppercased version\n if there is one. Otherwise, returns `c` unmodified.\n\n Note: When this function is referenced, it will need to include\n       `uppercase_table.len * 2` bytes of data in the resulting binary\n       since it depends on the `uppercase_table` data. When\n       targeting Windows, `ntdll.RtlUpcaseUnicodeChar` can be\n       used instead to avoid having to include a copy of this data.",[52046],false],[0,0,0,"c",null,"",null,false],[401,33,0,null,null,null,null,false],[401,35,0,null,null,null,null,false],[401,37,0,null,null,null,null,false],[401,51,0,null,null,null,[52056,52058,52060,52062,52064,52066,52068,52069],false],[401,65,0,null,null,null,[52052,52053,52054],false],[0,0,0,"file_only",null," Causes `OpenFile` to return `error.IsDir` if the opened handle would be a directory.",null,false],[0,0,0,"dir_only",null," Causes `OpenFile` to return `error.NotDir` if the opened handle would be a file.",null,false],[0,0,0,"any",null," `OpenFile` does not discriminate between opening files and directories.",null,false],[401,51,0,null,null,null,null,false],[0,0,0,"access_mask",null,null,null,false],[401,51,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[401,51,0,null,null,null,null,false],[0,0,0,"sa",null,null,null,false],[401,51,0,null,null,null,null,false],[0,0,0,"share_access",null,null,null,false],[401,51,0,null,null,null,null,false],[0,0,0,"creation",null,null,null,false],[401,51,0,null,null,null,null,false],[0,0,0,"io_mode",null,null,null,false],[401,51,0,null,null,null,null,false],[0,0,0,"filter",null," If true, tries to open path as a directory.\n Defaults to false.",null,false],[0,0,0,"follow_symlinks",null," If false, tries to open path as a reparse point without dereferencing it.\n Defaults to true.",null,false],[401,75,0,null,null,null,[52071,52072],false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"options",null,"",null,false],[401,161,0,null,null,null,null,false],[401,163,0,null,null,null,[52075,52076,52077],false],[0,0,0,"rd",null,"",null,false],[0,0,0,"wr",null,"",null,false],[0,0,0,"sattr",null,"",null,false],[401,171,0,null,null,null,[52079,52080,52081,52082],false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"desired_access",null,"",null,false],[401,176,0,null,null,null,[52084,52085,52086,52087],false],[0,0,0,"attributes",null,"",null,false],[0,0,0,"nameW",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"desired_access",null,"",null,false],[401,187,0,null,null,null,null,false],[401,193,0,null,null," A Zig wrapper around `NtDeviceIoControlFile` and `NtFsControlFile` syscalls.\n It implements similar behavior to `DeviceIoControl` and is meant to serve\n as a direct substitute for that call.\n TODO work out if we need to expose other arguments to the underlying syscalls.",[52090,52091,52092,52093],false],[0,0,0,"h",null,"",null,false],[0,0,0,"ioControlCode",null,"",null,false],[0,0,0,"in",null,"",null,false],[0,0,0,"out",null,"",null,false],[401,247,0,null,null,null,[52095,52096,52097],false],[0,0,0,"h",null,"",null,false],[0,0,0,"overlapped",null,"",null,false],[0,0,0,"wait",null,"",null,false],[401,258,0,null,null,null,null,false],[401,260,0,null,null,null,[52100,52101,52102],false],[0,0,0,"h",null,"",null,false],[0,0,0,"mask",null,"",null,false],[0,0,0,"flags",null,"",null,false],[401,268,0,null,null,null,null,false],[401,273,0,null,null," Call RtlGenRandom() instead of CryptGetRandom() on Windows\n https://github.com/rust-lang-nursery/rand/issues/111\n https://bugzilla.mozilla.org/show_bug.cgi?id=504270",[52105],false],[0,0,0,"output",null,"",null,false],[401,290,0,null,null,null,null,false],[401,296,0,null,null,null,[52108,52109],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"milliseconds",null,"",null,false],[401,300,0,null,null,null,[52111,52112,52113],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"milliseconds",null,"",null,false],[0,0,0,"alertable",null,"",null,false],[401,312,0,null,null,null,[52115,52116,52117,52118],false],[0,0,0,"handles",null,"",null,false],[0,0,0,"waitAll",null,"",null,false],[0,0,0,"milliseconds",null,"",null,false],[0,0,0,"alertable",null,"",null,false],[401,340,0,null,null,null,null,false],[401,342,0,null,null,null,[52121,52122,52123,52124],false],[0,0,0,"file_handle",null,"",null,false],[0,0,0,"existing_completion_port",null,"",null,false],[0,0,0,"completion_key",null,"",null,false],[0,0,0,"concurrent_thread_count",null,"",null,false],[401,357,0,null,null,null,null,false],[401,359,0,null,null,null,[52127,52128,52129,52130],false],[0,0,0,"completion_port",null,"",null,false],[0,0,0,"bytes_transferred_count",null,"",null,false],[0,0,0,"completion_key",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[401,372,0,null,null,null,[52132,52133,52134,52135],false],[0,0,0,"Normal",null,null,null,false],[0,0,0,"Aborted",null,null,null,false],[0,0,0,"Cancelled",null,null,null,false],[0,0,0,"EOF",null,null,null,false],[401,379,0,null,null,null,[52137,52138,52139,52140,52141],false],[0,0,0,"completion_port",null,"",null,false],[0,0,0,"bytes_transferred_count",null,"",null,false],[0,0,0,"lpCompletionKey",null,"",null,false],[0,0,0,"lpOverlapped",null,"",null,false],[0,0,0,"dwMilliseconds",null,"",null,false],[401,408,0,null,null,null,null,false],[401,415,0,null,null,null,[52144,52145,52146,52147],false],[0,0,0,"completion_port",null,"",null,false],[0,0,0,"completion_port_entries",null,"",null,false],[0,0,0,"timeout_ms",null,"",null,false],[0,0,0,"alertable",null,"",null,false],[401,445,0,null,null,null,[52149],false],[0,0,0,"hObject",null,"",null,false],[401,449,0,null,null,null,[52151],false],[0,0,0,"hFindFile",null,"",null,false],[401,453,0,null,null,null,null,false],[401,462,0,null,null," If buffer's length exceeds what a Windows DWORD integer can hold, it will be broken into\n multiple non-atomic reads.",[52154,52155,52156,52157],false],[0,0,0,"in_hFile",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"io_mode",null,"",null,false],[401,540,0,null,null,null,null,false],[401,551,0,null,null,null,[52160,52161,52162,52163],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"io_mode",null,"",null,false],[401,636,0,null,null,null,null,false],[401,647,0,null,null,null,[52166],false],[0,0,0,"path_name",null,"",null,false],[401,671,0,null,null,null,null,false],[401,677,0,null,null," The result is a slice of `buffer`, indexed from 0.",[52169],false],[0,0,0,"buffer",null,"",null,false],[401,699,0,null,null,null,null,false],[401,716,0,null,null," Needs either:\n - `SeCreateSymbolicLinkPrivilege` privilege\n or\n - Developer mode on Windows 10\n otherwise fails with `error.AccessDenied`. In which case `sym_link_path` may still\n be created on the file system but will lack reparse processing data applied to it.",[52172,52173,52174,52175],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"is_directory",null,"",null,false],[401,803,0,null,null,null,null,false],[401,812,0,null,null,null,[52178,52179,52180],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[401,896,0,null,null,null,[52182,52183,52184],false],[0,0,0,"path",null,"",null,false],[0,0,0,"is_relative",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[401,909,0,null,null,null,null,false],[401,922,0,null,null,null,[52188,52189],false],[401,922,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[0,0,0,"remove_dir",null,null,null,false],[401,927,0,null,null,null,[52191,52192],false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"options",null,"",null,false],[401,1045,0,null,null,null,null,false],[401,1047,0,null,null,null,[52195,52196,52197],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[401,1053,0,null,null,null,[52199,52200,52201],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[401,1063,0,null,null,null,null,false],[401,1068,0,null,null,null,[52204],false],[0,0,0,"handle_id",null,"",null,false],[401,1078,0,null,null,null,null,false],[401,1081,0,null,null," The SetFilePointerEx function with the `dwMoveMethod` parameter set to `FILE_BEGIN`.",[52207,52208],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"offset",null,"",null,false],[401,1096,0,null,null," The SetFilePointerEx function with the `dwMoveMethod` parameter set to `FILE_CURRENT`.",[52210,52211],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"offset",null,"",null,false],[401,1107,0,null,null," The SetFilePointerEx function with the `dwMoveMethod` parameter set to `FILE_END`.",[52213,52214],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"offset",null,"",null,false],[401,1118,0,null,null," The SetFilePointerEx function with parameters to get the current offset.",[52216],false],[0,0,0,"handle",null,"",null,false],[401,1132,0,null,null,null,[52218,52219],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[401,1178,0,null,null,null,null,false],[401,1188,0,null,null," Specifies how to format volume path in the result of `GetFinalPathNameByHandle`.\n Defaults to DOS volume names.",[52225],false],[401,1188,0,null,null,null,[52223,52224],false],[0,0,0,"Dos",null," Format as DOS volume name",null,false],[0,0,0,"Nt",null," Format as NT volume name",null,false],[0,0,0,"volume_name",null,null,null,false],[401,1202,0,null,null," Returns canonical (normalized) path of handle.\n Use `GetFinalPathNameByHandleFormat` to specify whether the path is meant to include\n NT or DOS volume name (e.g., `\\Device\\HarddiskVolume0\\foo.txt` versus `C:\\foo.txt`).\n If DOS volume name format is selected, note that this function does *not* prepend\n `\\\\?\\` prefix to the resultant path.",[52227,52228,52229],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"fmt",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[401,1349,0,null,null,null,null,false],[401,1351,0,null,null,null,[52232],false],[0,0,0,"hFile",null,"",null,false],[401,1361,0,null,null,null,null,false],[401,1367,0,null,null,null,[52235],false],[0,0,0,"filename",null,"",null,false],[401,1372,0,null,null,null,[52237],false],[0,0,0,"lpFileName",null,"",null,false],[401,1385,0,null,null,null,[52239,52240],false],[0,0,0,"majorVersion",null,"",null,false],[0,0,0,"minorVersion",null,"",null,false],[401,1399,0,null,null,null,[],false],[401,1412,0,null,null,null,null,false],[401,1414,0,null,null,null,[],false],[401,1453,0,null,null," Microsoft requires WSAStartup to be called to initialize, or else\n WSASocketW will return WSANOTINITIALISED.\n Since this is a standard library, we do not have the luxury of\n putting initialization code anywhere, because we would not want\n to pay the cost of calling WSAStartup if there ended up being no\n networking. Also, if Zig code is used as a library, Zig is not in\n charge of the start code, and we couldn't put in any initialization\n code even if we wanted to.\n The documentation for WSAStartup mentions that there must be a\n matching WSACleanup call. It is not possible for the Zig Standard\n Library to honor this for the same reason - there is nowhere to put\n deinitialization code.\n So, API users of the zig std lib have two options:\n  * (recommended) The simple, cross-platform way: just call `WSASocketW`\n    and don't worry about it. Zig will call WSAStartup() in a thread-safe\n    manner and never deinitialize networking. This is ideal for an\n    application which has the capability to do networking.\n  * The getting-your-hands-dirty way: call `WSAStartup()` before doing\n    networking, so that the error handling code for WSANOTINITIALISED never\n    gets run, which then allows the application or library to call `WSACleanup()`.\n    This could make sense for a library, which has init and deinit\n    functions for the whole library's lifetime.",[52245,52246,52247,52248,52249,52250],false],[0,0,0,"af",null,"",null,false],[0,0,0,"socket_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[0,0,0,"protocolInfo",null,"",null,false],[0,0,0,"g",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[401,1483,0,null,null,null,[52252,52253,52254],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[401,1487,0,null,null,null,[52256,52257],false],[0,0,0,"s",null,"",null,false],[0,0,0,"backlog",null,"",null,false],[401,1491,0,null,null,null,[52259],false],[0,0,0,"s",null,"",null,false],[401,1501,0,null,null,null,[52261,52262,52263],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[401,1506,0,null,null,null,[52265,52266,52267],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[401,1510,0,null,null,null,[52269,52270,52271],false],[0,0,0,"s",null,"",null,false],[0,0,0,"name",null,"",null,false],[0,0,0,"namelen",null,"",null,false],[401,1514,0,null,null,null,[52273,52274,52275],false],[0,0,0,"s",null,"",null,false],[0,0,0,"msg",null,"",null,false],[0,0,0,"flags",null,"",null,false],[401,1527,0,null,null,null,[52277,52278,52279,52280,52281,52282],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"to",null,"",null,false],[0,0,0,"to_len",null,"",null,false],[401,1537,0,null,null,null,[52284,52285,52286,52287,52288,52289],false],[0,0,0,"s",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"from",null,"",null,false],[0,0,0,"from_len",null,"",null,false],[401,1548,0,null,null,null,[52291,52292,52293],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"n",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[401,1552,0,null,null,null,[52295,52296,52297,52298,52299,52300],false],[0,0,0,"s",null,"",null,false],[0,0,0,"dwIoControlCode",null,"",null,false],[0,0,0,"inBuffer",null,"",null,false],[0,0,0,"outBuffer",null,"",null,false],[0,0,0,"overlapped",null,"",null,false],[0,0,0,"completionRoutine",null,"",null,false],[401,1581,0,null,null,null,null,false],[401,1583,0,null,null,null,[52303,52304,52305],false],[0,0,0,"hModule",null,"",null,false],[0,0,0,"buf_ptr",null,"",null,false],[0,0,0,"buf_len",null,"",null,false],[401,1593,0,null,null,null,null,false],[401,1595,0,null,null,null,[52308,52309],false],[0,0,0,"hProcess",null,"",null,false],[0,0,0,"uExitCode",null,"",null,false],[401,1603,0,null,null,null,null,false],[401,1605,0,null,null,null,[52312,52313,52314,52315],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"alloc_type",null,"",null,false],[0,0,0,"flProtect",null,"",null,false],[401,1613,0,null,null,null,[52317,52318,52319],false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"dwSize",null,"",null,false],[0,0,0,"dwFreeType",null,"",null,false],[401,1617,0,null,null,null,null,false],[401,1622,0,null,null,null,[52322,52323,52324,52325],false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"dwSize",null,"",null,false],[0,0,0,"flNewProtect",null,"",null,false],[0,0,0,"lpflOldProtect",null,"",null,false],[401,1633,0,null,null,null,[52327,52328,52329,52330],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"new_prot",null,"",null,false],[401,1651,0,null,null,null,null,false],[401,1653,0,null,null,null,[52333,52334,52335],false],[0,0,0,"lpAddress",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"dwLength",null,"",null,false],[401,1664,0,null,null,null,null,false],[401,1666,0,null,null,null,[52338,52339],false],[0,0,0,"hConsoleOutput",null,"",null,false],[0,0,0,"wAttributes",null,"",null,false],[401,1674,0,null,null,null,[52341,52342],false],[0,0,0,"handler_routine",null,"",null,false],[0,0,0,"add",null,"",null,false],[401,1687,0,null,null,null,[52344,52345],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"flags",null,"",null,false],[401,1696,0,null,null,null,null,false],[401,1698,0,null,null,null,[],false],[401,1702,0,null,null,null,[52349],false],[0,0,0,"penv",null,"",null,false],[401,1706,0,null,null,null,null,false],[401,1711,0,null,null,null,[52352,52353,52354],false],[0,0,0,"lpName",null,"",null,false],[0,0,0,"lpBuffer",null,"",null,false],[0,0,0,"nSize",null,"",null,false],[401,1722,0,null,null,null,null,false],[401,1731,0,null,null,null,[52357,52358,52359,52360,52361,52362,52363,52364,52365,52366],false],[0,0,0,"lpApplicationName",null,"",null,false],[0,0,0,"lpCommandLine",null,"",null,false],[0,0,0,"lpProcessAttributes",null,"",null,false],[0,0,0,"lpThreadAttributes",null,"",null,false],[0,0,0,"bInheritHandles",null,"",null,false],[0,0,0,"dwCreationFlags",null,"",null,false],[0,0,0,"lpEnvironment",null,"",null,false],[0,0,0,"lpCurrentDirectory",null,"",null,false],[0,0,0,"lpStartupInfo",null,"",null,false],[0,0,0,"lpProcessInformation",null,"",null,false],[401,1791,0,null,null,null,null,false],[401,1796,0,null,null,null,[52369],false],[0,0,0,"lpLibFileName",null,"",null,false],[401,1807,0,null,null,null,[52371],false],[0,0,0,"hModule",null,"",null,false],[401,1811,0,null,null,null,[],false],[401,1820,0,null,null,null,[],false],[401,1829,0,null,null,null,[52375,52376,52377,52378],false],[0,0,0,"InitOnce",null,"",null,false],[0,0,0,"InitFn",null,"",null,false],[0,0,0,"Parameter",null,"",null,false],[0,0,0,"Context",null,"",null,false],[401,1833,0,null,null,null,[52380,52381,52382],false],[0,0,0,"hHeap",null,"",null,false],[0,0,0,"dwFlags",null,"",null,false],[0,0,0,"lpMem",null,"",null,false],[401,1837,0,null,null,null,[52384],false],[0,0,0,"hHeap",null,"",null,false],[401,1841,0,null,null,null,[52386],false],[0,0,0,"hMem",null,"",null,false],[401,1845,0,null,null,null,null,false],[401,1847,0,null,null,null,[52389,52390,52391,52392],false],[0,0,0,"hFile",null,"",null,false],[0,0,0,"lpCreationTime",null,"",null,false],[0,0,0,"lpLastAccessTime",null,"",null,false],[0,0,0,"lpLastWriteTime",null,"",null,false],[401,1861,0,null,null,null,null,false],[401,1866,0,null,null,null,[52395,52396,52397,52398,52399,52400,52401,52402,52403,52404],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"Event",null,"",null,false],[0,0,0,"ApcRoutine",null,"",null,false],[0,0,0,"ApcContext",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"ByteOffset",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"Key",null,"",null,false],[0,0,0,"FailImmediately",null,"",null,false],[0,0,0,"ExclusiveLock",null,"",null,false],[401,1899,0,null,null,null,null,false],[401,1903,0,null,null,null,[52407,52408,52409,52410,52411],false],[0,0,0,"FileHandle",null,"",null,false],[0,0,0,"IoStatusBlock",null,"",null,false],[0,0,0,"ByteOffset",null,"",null,false],[0,0,0,"Length",null,"",null,false],[0,0,0,"Key",null,"",null,false],[401,1921,0,null,null," This is a workaround for the C backend until zig has the ability to put\n C code in inline assembly.",[],false],[401,1922,0,null,null,null,[],false],[401,1924,0,null,null,null,[],false],[401,1954,0,null,null,null,[],false],[401,1963,0,null,null," A file time is a 64-bit value that represents the number of 100-nanosecond\n intervals that have elapsed since 12:00 A.M. January 1, 1601 Coordinated\n Universal Time (UTC).\n This function returns the number of nanoseconds since the canonical epoch,\n which is the POSIX one (Jan 01, 1970 AD).",[52417],false],[0,0,0,"hns",null,"",null,false],[401,1968,0,null,null,null,[52419],false],[0,0,0,"ns",null,"",null,false],[401,1973,0,null,null,null,[52421],false],[0,0,0,"ft",null,"",null,false],[401,1979,0,null,null," Converts a number of nanoseconds since the POSIX epoch to a Windows FILETIME.",[52423],false],[0,0,0,"ns",null,"",null,false],[401,1990,0,null,null," Compares two WTF16 strings using the equivalent functionality of\n `RtlEqualUnicodeString` (with case insensitive comparison enabled).\n This function can be called on any target.",[52425,52426],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[401,2031,0,null,null," Compares two UTF-8 strings using the equivalent functionality of\n `RtlEqualUnicodeString` (with case insensitive comparison enabled).\n This function can be called on any target.\n Assumes `a` and `b` are valid UTF-8.",[52428,52429],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[401,2065,0,null,null,null,[52431,52432,52433],false],[0,0,0,"expect_eql",null,"",null,true],[0,0,0,"a",null,"",null,true],[0,0,0,"b",null,"",null,true],[401,2085,0,null,null,null,[52438,52439],false],[401,2089,0,null,null,null,[52436],false],[0,0,0,"self",null,"",null,false],[401,2085,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"len",null,null,null,false],[401,2095,0,null,null," The error type for `removeDotDirsSanitized`",null,false],[401,2102,0,null,null," Removes '.' and '..' path components from a \"sanitized relative path\".\n A \"sanitized path\" is one where:\n    1) all forward slashes have been replaced with back slashes\n    2) all repeating back slashes have been collapsed\n    3) the path is a relative one (does not start with a back slash)",[52442,52443],false],[0,0,0,"T",null,"",null,true],[0,0,0,"path",null,"",null,false],[401,2155,0,null,null," Normalizes a Windows path with the following steps:\n     1) convert all forward slashes to back slashes\n     2) collapse duplicate back slashes\n     3) remove '.' and '..' directory parts\n Returns the length of the new path.",[52445,52446],false],[0,0,0,"T",null,"",null,true],[0,0,0,"path",null,"",null,false],[401,2171,0,null,null," Same as `sliceToPrefixedFileW` but accepts a pointer\n to a null-terminated path.",[52448,52449],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"s",null,"",null,false],[401,2176,0,null,null," Same as `wToPrefixedFileW` but accepts a UTF-8 encoded path.",[52451,52452],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"path",null,"",null,false],[401,2194,0,null,null," Converts the `path` to WTF16, null-terminated. If the path contains any\n namespace prefix, or is anything but a relative path (rooted, drive relative,\n etc) the result will have the NT-style prefix `\\??\\`.\n\n Similar to RtlDosPathNameToNtPathName_U with a few differences:\n - Does not allocate on the heap.\n - Relative paths are kept as relative unless they contain too many ..\n   components, in which case they are resolved against the `dir` if it\n   is non-null, or the CWD if it is null.\n - Special case device names like COM1, NUL, etc are not handled specially (TODO)\n - . and space are not stripped from the end of relative paths (potential TODO)",[52454,52455],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"path",null,"",null,false],[401,2329,0,null,null,null,[52457,52458,52459,52460,52461],false],[0,0,0,"none",null,null,null,false],[0,0,0,"local_device",null," `\\\\.\\` (path separators can be `\\` or `/`)",null,false],[0,0,0,"verbatim",null," `\\\\?\\`\n When converted to an NT path, everything past the prefix is left\n untouched and `\\\\?\\` is replaced by `\\??\\`.",null,false],[0,0,0,"fake_verbatim",null," `\\\\?\\` without all path separators being `\\`.\n This seems to be recognized as a prefix, but the 'verbatim' aspect\n is not respected (i.e. if `//?/C:/foo` is converted to an NT path,\n it will become `\\??\\C:\\foo` [it will be canonicalized and the //?/ won't\n be treated as part of the final path])",null,false],[0,0,0,"nt",null," `\\??\\`",null,false],[401,2348,0,null,null," If `T` is `u16`, then `path` should be encoded as UTF-16LE.",[52463,52464],false],[0,0,0,"T",null,"",null,true],[0,0,0,"path",null,"",null,false],[401,2390,0,null,null,null,[52466,52467,52468,52469,52470,52471],false],[0,0,0,"unc_absolute",null,null,null,false],[0,0,0,"drive_absolute",null,null,null,false],[0,0,0,"drive_relative",null,null,null,false],[0,0,0,"rooted",null,null,null,false],[0,0,0,"relative",null,null,null,false],[0,0,0,"root_local_device",null,null,null,false],[401,2402,0,null,null," Get the path type of a path that is known to not have any namespace prefixes\n (`\\\\?\\`, `\\\\.\\`, `\\??\\`).\n If `T` is `u16`, then `path` should be encoded as UTF-16LE.",[52473,52474],false],[0,0,0,"T",null,"",null,true],[0,0,0,"path",null,"",null,false],[401,2456,0,null,null," Similar to `RtlNtPathNameToDosPathName` but does not do any heap allocation.\n The possible transformations are:\n   \\??\\C:\\Some\\Path -> C:\\Some\\Path\n   \\??\\UNC\\server\\share\\foo -> \\\\server\\share\\foo\n If the path does not have the NT namespace prefix, then `error.NotNtPath` is returned.\n\n Functionality is based on the ReactOS test cases found here:\n https://github.com/reactos/reactos/blob/master/modules/rostests/apitests/ntdll/RtlNtPathNameToDosPathName.c\n\n `path` should be encoded as UTF-16LE.",[52476],false],[0,0,0,"path",null,"",null,false],[401,2508,0,null,null,null,[52478,52479],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"path",null,"",null,false],[401,2513,0,null,null,null,[52481,52482],false],[0,0,0,"path",null,"",null,false],[0,0,0,"out",null,"",null,false],[401,2523,0,null,null,null,[52484,52485],false],[0,0,0,"p",null,"",null,false],[0,0,0,"s",null,"",null,false],[401,2528,0,null,null," Loads a Winsock extension function in runtime specified by a GUID.",[52487,52488,52489],false],[0,0,0,"T",null,"",null,true],[0,0,0,"sock",null,"",null,false],[0,0,0,"guid",null,"",null,false],[401,2561,0,null,null," Call this when you made a windows DLL call or something that does SetLastError\n and you get an unexpected error.",[52491],false],[0,0,0,"err",null,"",null,false],[401,2582,0,null,null,null,[52493],false],[0,0,0,"err",null,"",null,false],[401,2588,0,null,null," Call this when you made a windows NtDll call\n and you get an unexpected status.",[52495],false],[0,0,0,"status",null,"",null,false],[401,2596,0,null,null,null,null,false],[0,0,0,"windows/win32error.zig",null,"",[],false],[414,1,0,null,null," Codes are from https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-erref/18d8fbe8-a967-4f1c-ae50-99ca8e491d2d",[52499,52500,52501,52502,52503,52504,52505,52506,52507,52508,52509,52510,52511,52512,52513,52514,52515,52516,52517,52518,52519,52520,52521,52522,52523,52524,52525,52526,52527,52528,52529,52530,52531,52532,52533,52534,52535,52536,52537,52538,52539,52540,52541,52542,52543,52544,52545,52546,52547,52548,52549,52550,52551,52552,52553,52554,52555,52556,52557,52558,52559,52560,52561,52562,52563,52564,52565,52566,52567,52568,52569,52570,52571,52572,52573,52574,52575,52576,52577,52578,52579,52580,52581,52582,52583,52584,52585,52586,52587,52588,52589,52590,52591,52592,52593,52594,52595,52596,52597,52598,52599,52600,52601,52602,52603,52604,52605,52606,52607,52608,52609,52610,52611,52612,52613,52614,52615,52616,52617,52618,52619,52620,52621,52622,52623,52624,52625,52626,52627,52628,52629,52630,52631,52632,52633,52634,52635,52636,52637,52638,52639,52640,52641,52642,52643,52644,52645,52646,52647,52648,52649,52650,52651,52652,52653,52654,52655,52656,52657,52658,52659,52660,52661,52662,52663,52664,52665,52666,52667,52668,52669,52670,52671,52672,52673,52674,52675,52676,52677,52678,52679,52680,52681,52682,52683,52684,52685,52686,52687,52688,52689,52690,52691,52692,52693,52694,52695,52696,52697,52698,52699,52700,52701,52702,52703,52704,52705,52706,52707,52708,52709,52710,52711,52712,52713,52714,52715,52716,52717,52718,52719,52720,52721,52722,52723,52724,52725,52726,52727,52728,52729,52730,52731,52732,52733,52734,52735,52736,52737,52738,52739,52740,52741,52742,52743,52744,52745,52746,52747,52748,52749,52750,52751,52752,52753,52754,52755,52756,52757,52758,52759,52760,52761,52762,52763,52764,52765,52766,52767,52768,52769,52770,52771,52772,52773,52774,52775,52776,52777,52778,52779,52780,52781,52782,52783,52784,52785,52786,52787,52788,52789,52790,52791,52792,52793,52794,52795,52796,52797,52798,52799,52800,52801,52802,52803,52804,52805,52806,52807,52808,52809,52810,52811,52812,52813,52814,52815,52816,52817,52818,52819,52820,52821,52822,52823,52824,52825,52826,52827,52828,52829,52830,52831,52832,52833,52834,52835,52836,52837,52838,52839,52840,52841,52842,52843,52844,52845,52846,52847,52848,52849,52850,52851,52852,52853,52854,52855,52856,52857,52858,52859,52860,52861,52862,52863,52864,52865,52866,52867,52868,52869,52870,52871,52872,52873,52874,52875,52876,52877,52878,52879,52880,52881,52882,52883,52884,52885,52886,52887,52888,52889,52890,52891,52892,52893,52894,52895,52896,52897,52898,52899,52900,52901,52902,52903,52904,52905,52906,52907,52908,52909,52910,52911,52912,52913,52914,52915,52916,52917,52918,52919,52920,52921,52922,52923,52924,52925,52926,52927,52928,52929,52930,52931,52932,52933,52934,52935,52936,52937,52938,52939,52940,52941,52942,52943,52944,52945,52946,52947,52948,52949,52950,52951,52952,52953,52954,52955,52956,52957,52958,52959,52960,52961,52962,52963,52964,52965,52966,52967,52968,52969,52970,52971,52972,52973,52974,52975,52976,52977,52978,52979,52980,52981,52982,52983,52984,52985,52986,52987,52988,52989,52990,52991,52992,52993,52994,52995,52996,52997,52998,52999,53000,53001,53002,53003,53004,53005,53006,53007,53008,53009,53010,53011,53012,53013,53014,53015,53016,53017,53018,53019,53020,53021,53022,53023,53024,53025,53026,53027,53028,53029,53030,53031,53032,53033,53034,53035,53036,53037,53038,53039,53040,53041,53042,53043,53044,53045,53046,53047,53048,53049,53050,53051,53052,53053,53054,53055,53056,53057,53058,53059,53060,53061,53062,53063,53064,53065,53066,53067,53068,53069,53070,53071,53072,53073,53074,53075,53076,53077,53078,53079,53080,53081,53082,53083,53084,53085,53086,53087,53088,53089,53090,53091,53092,53093,53094,53095,53096,53097,53098,53099,53100,53101,53102,53103,53104,53105,53106,53107,53108,53109,53110,53111,53112,53113,53114,53115,53116,53117,53118,53119,53120,53121,53122,53123,53124,53125,53126,53127,53128,53129,53130,53131,53132,53133,53134,53135,53136,53137,53138,53139,53140,53141,53142,53143,53144,53145,53146,53147,53148,53149,53150,53151,53152,53153,53154,53155,53156,53157,53158,53159,53160,53161,53162,53163,53164,53165,53166,53167,53168,53169,53170,53171,53172,53173,53174,53175,53176,53177,53178,53179,53180,53181,53182,53183,53184,53185,53186,53187,53188,53189,53190,53191,53192,53193,53194,53195,53196,53197,53198,53199,53200,53201,53202,53203,53204,53205,53206,53207,53208,53209,53210,53211,53212,53213,53214,53215,53216,53217,53218,53219,53220,53221,53222,53223,53224,53225,53226,53227,53228,53229,53230,53231,53232,53233,53234,53235,53236,53237,53238,53239,53240,53241,53242,53243,53244,53245,53246,53247,53248,53249,53250,53251,53252,53253,53254,53255,53256,53257,53258,53259,53260,53261,53262,53263,53264,53265,53266,53267,53268,53269,53270,53271,53272,53273,53274,53275,53276,53277,53278,53279,53280,53281,53282,53283,53284,53285,53286,53287,53288,53289,53290,53291,53292,53293,53294,53295,53296,53297,53298,53299,53300,53301,53302,53303,53304,53305,53306,53307,53308,53309,53310,53311,53312,53313,53314,53315,53316,53317,53318,53319,53320,53321,53322,53323,53324,53325,53326,53327,53328,53329,53330,53331,53332,53333,53334,53335,53336,53337,53338,53339,53340,53341,53342,53343,53344,53345,53346,53347,53348,53349,53350,53351,53352,53353,53354,53355,53356,53357,53358,53359,53360,53361,53362,53363,53364,53365,53366,53367,53368,53369,53370,53371,53372,53373,53374,53375,53376,53377,53378,53379,53380,53381,53382,53383,53384,53385,53386,53387,53388,53389,53390,53391,53392,53393,53394,53395,53396,53397,53398,53399,53400,53401,53402,53403,53404,53405,53406,53407,53408,53409,53410,53411,53412,53413,53414,53415,53416,53417,53418,53419,53420,53421,53422,53423,53424,53425,53426,53427,53428,53429,53430,53431,53432,53433,53434,53435,53436,53437,53438,53439,53440,53441,53442,53443,53444,53445,53446,53447,53448,53449,53450,53451,53452,53453,53454,53455,53456,53457,53458,53459,53460,53461,53462,53463,53464,53465,53466,53467,53468,53469,53470,53471,53472,53473,53474,53475,53476,53477,53478,53479,53480,53481,53482,53483,53484,53485,53486,53487,53488,53489,53490,53491,53492,53493,53494,53495,53496,53497,53498,53499,53500,53501,53502,53503,53504,53505,53506,53507,53508,53509,53510,53511,53512,53513,53514,53515,53516,53517,53518,53519,53520,53521,53522,53523,53524,53525,53526,53527,53528,53529,53530,53531,53532,53533,53534,53535,53536,53537,53538,53539,53540,53541,53542,53543,53544,53545,53546,53547,53548,53549,53550,53551,53552,53553,53554,53555,53556,53557,53558,53559,53560,53561,53562,53563,53564,53565,53566,53567,53568,53569,53570,53571,53572,53573,53574,53575,53576,53577,53578,53579,53580,53581,53582,53583,53584,53585,53586,53587,53588,53589,53590,53591,53592,53593,53594,53595,53596,53597,53598,53599,53600,53601,53602,53603,53604,53605,53606,53607,53608,53609,53610,53611,53612,53613,53614,53615,53616,53617,53618,53619,53620,53621,53622,53623,53624,53625,53626,53627,53628,53629,53630,53631,53632,53633,53634,53635,53636,53637,53638,53639,53640,53641,53642,53643,53644,53645,53646,53647,53648,53649,53650,53651,53652,53653,53654,53655,53656,53657,53658,53659,53660,53661,53662,53663,53664,53665,53666,53667,53668,53669,53670,53671,53672,53673,53674,53675,53676,53677,53678,53679,53680,53681,53682,53683,53684,53685,53686,53687],false],[0,0,0,"SUCCESS",null," The operation completed successfully.",null,false],[0,0,0,"INVALID_FUNCTION",null," Incorrect function.",null,false],[0,0,0,"FILE_NOT_FOUND",null," The system cannot find the file specified.",null,false],[0,0,0,"PATH_NOT_FOUND",null," The system cannot find the path specified.",null,false],[0,0,0,"TOO_MANY_OPEN_FILES",null," The system cannot open the file.",null,false],[0,0,0,"ACCESS_DENIED",null," Access is denied.",null,false],[0,0,0,"INVALID_HANDLE",null," The handle is invalid.",null,false],[0,0,0,"ARENA_TRASHED",null," The storage control blocks were destroyed.",null,false],[0,0,0,"NOT_ENOUGH_MEMORY",null," Not enough storage is available to process this command.",null,false],[0,0,0,"INVALID_BLOCK",null," The storage control block address is invalid.",null,false],[0,0,0,"BAD_ENVIRONMENT",null," The environment is incorrect.",null,false],[0,0,0,"BAD_FORMAT",null," An attempt was made to load a program with an incorrect format.",null,false],[0,0,0,"INVALID_ACCESS",null," The access code is invalid.",null,false],[0,0,0,"INVALID_DATA",null," The data is invalid.",null,false],[0,0,0,"OUTOFMEMORY",null," Not enough storage is available to complete this operation.",null,false],[0,0,0,"INVALID_DRIVE",null," The system cannot find the drive specified.",null,false],[0,0,0,"CURRENT_DIRECTORY",null," The directory cannot be removed.",null,false],[0,0,0,"NOT_SAME_DEVICE",null," The system cannot move the file to a different disk drive.",null,false],[0,0,0,"NO_MORE_FILES",null," There are no more files.",null,false],[0,0,0,"WRITE_PROTECT",null," The media is write protected.",null,false],[0,0,0,"BAD_UNIT",null," The system cannot find the device specified.",null,false],[0,0,0,"NOT_READY",null," The device is not ready.",null,false],[0,0,0,"BAD_COMMAND",null," The device does not recognize the command.",null,false],[0,0,0,"CRC",null," Data error (cyclic redundancy check).",null,false],[0,0,0,"BAD_LENGTH",null," The program issued a command but the command length is incorrect.",null,false],[0,0,0,"SEEK",null," The drive cannot locate a specific area or track on the disk.",null,false],[0,0,0,"NOT_DOS_DISK",null," The specified disk or diskette cannot be accessed.",null,false],[0,0,0,"SECTOR_NOT_FOUND",null," The drive cannot find the sector requested.",null,false],[0,0,0,"OUT_OF_PAPER",null," The printer is out of paper.",null,false],[0,0,0,"WRITE_FAULT",null," The system cannot write to the specified device.",null,false],[0,0,0,"READ_FAULT",null," The system cannot read from the specified device.",null,false],[0,0,0,"GEN_FAILURE",null," A device attached to the system is not functioning.",null,false],[0,0,0,"SHARING_VIOLATION",null," The process cannot access the file because it is being used by another process.",null,false],[0,0,0,"LOCK_VIOLATION",null," The process cannot access the file because another process has locked a portion of the file.",null,false],[0,0,0,"WRONG_DISK",null," The wrong diskette is in the drive.\n Insert %2 (Volume Serial Number: %3) into drive %1.",null,false],[0,0,0,"SHARING_BUFFER_EXCEEDED",null," Too many files opened for sharing.",null,false],[0,0,0,"HANDLE_EOF",null," Reached the end of the file.",null,false],[0,0,0,"HANDLE_DISK_FULL",null," The disk is full.",null,false],[0,0,0,"NOT_SUPPORTED",null," The request is not supported.",null,false],[0,0,0,"REM_NOT_LIST",null," Windows cannot find the network path.\n Verify that the network path is correct and the destination computer is not busy or turned off.\n If Windows still cannot find the network path, contact your network administrator.",null,false],[0,0,0,"DUP_NAME",null," You were not connected because a duplicate name exists on the network.\n If joining a domain, go to System in Control Panel to change the computer name and try again.\n If joining a workgroup, choose another workgroup name.",null,false],[0,0,0,"BAD_NETPATH",null," The network path was not found.",null,false],[0,0,0,"NETWORK_BUSY",null," The network is busy.",null,false],[0,0,0,"DEV_NOT_EXIST",null," The specified network resource or device is no longer available.",null,false],[0,0,0,"TOO_MANY_CMDS",null," The network BIOS command limit has been reached.",null,false],[0,0,0,"ADAP_HDW_ERR",null," A network adapter hardware error occurred.",null,false],[0,0,0,"BAD_NET_RESP",null," The specified server cannot perform the requested operation.",null,false],[0,0,0,"UNEXP_NET_ERR",null," An unexpected network error occurred.",null,false],[0,0,0,"BAD_REM_ADAP",null," The remote adapter is not compatible.",null,false],[0,0,0,"PRINTQ_FULL",null," The printer queue is full.",null,false],[0,0,0,"NO_SPOOL_SPACE",null," Space to store the file waiting to be printed is not available on the server.",null,false],[0,0,0,"PRINT_CANCELLED",null," Your file waiting to be printed was deleted.",null,false],[0,0,0,"NETNAME_DELETED",null," The specified network name is no longer available.",null,false],[0,0,0,"NETWORK_ACCESS_DENIED",null," Network access is denied.",null,false],[0,0,0,"BAD_DEV_TYPE",null," The network resource type is not correct.",null,false],[0,0,0,"BAD_NET_NAME",null," The network name cannot be found.",null,false],[0,0,0,"TOO_MANY_NAMES",null," The name limit for the local computer network adapter card was exceeded.",null,false],[0,0,0,"TOO_MANY_SESS",null," The network BIOS session limit was exceeded.",null,false],[0,0,0,"SHARING_PAUSED",null," The remote server has been paused or is in the process of being started.",null,false],[0,0,0,"REQ_NOT_ACCEP",null," No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept.",null,false],[0,0,0,"REDIR_PAUSED",null," The specified printer or disk device has been paused.",null,false],[0,0,0,"FILE_EXISTS",null," The file exists.",null,false],[0,0,0,"CANNOT_MAKE",null," The directory or file cannot be created.",null,false],[0,0,0,"FAIL_I24",null," Fail on INT 24.",null,false],[0,0,0,"OUT_OF_STRUCTURES",null," Storage to process this request is not available.",null,false],[0,0,0,"ALREADY_ASSIGNED",null," The local device name is already in use.",null,false],[0,0,0,"INVALID_PASSWORD",null," The specified network password is not correct.",null,false],[0,0,0,"INVALID_PARAMETER",null," The parameter is incorrect.",null,false],[0,0,0,"NET_WRITE_FAULT",null," A write fault occurred on the network.",null,false],[0,0,0,"NO_PROC_SLOTS",null," The system cannot start another process at this time.",null,false],[0,0,0,"TOO_MANY_SEMAPHORES",null," Cannot create another system semaphore.",null,false],[0,0,0,"EXCL_SEM_ALREADY_OWNED",null," The exclusive semaphore is owned by another process.",null,false],[0,0,0,"SEM_IS_SET",null," The semaphore is set and cannot be closed.",null,false],[0,0,0,"TOO_MANY_SEM_REQUESTS",null," The semaphore cannot be set again.",null,false],[0,0,0,"INVALID_AT_INTERRUPT_TIME",null," Cannot request exclusive semaphores at interrupt time.",null,false],[0,0,0,"SEM_OWNER_DIED",null," The previous ownership of this semaphore has ended.",null,false],[0,0,0,"SEM_USER_LIMIT",null," Insert the diskette for drive %1.",null,false],[0,0,0,"DISK_CHANGE",null," The program stopped because an alternate diskette was not inserted.",null,false],[0,0,0,"DRIVE_LOCKED",null," The disk is in use or locked by another process.",null,false],[0,0,0,"BROKEN_PIPE",null," The pipe has been ended.",null,false],[0,0,0,"OPEN_FAILED",null," The system cannot open the device or file specified.",null,false],[0,0,0,"BUFFER_OVERFLOW",null," The file name is too long.",null,false],[0,0,0,"DISK_FULL",null," There is not enough space on the disk.",null,false],[0,0,0,"NO_MORE_SEARCH_HANDLES",null," No more internal file identifiers available.",null,false],[0,0,0,"INVALID_TARGET_HANDLE",null," The target internal file identifier is incorrect.",null,false],[0,0,0,"INVALID_CATEGORY",null," The IOCTL call made by the application program is not correct.",null,false],[0,0,0,"INVALID_VERIFY_SWITCH",null," The verify-on-write switch parameter value is not correct.",null,false],[0,0,0,"BAD_DRIVER_LEVEL",null," The system does not support the command requested.",null,false],[0,0,0,"CALL_NOT_IMPLEMENTED",null," This function is not supported on this system.",null,false],[0,0,0,"SEM_TIMEOUT",null," The semaphore timeout period has expired.",null,false],[0,0,0,"INSUFFICIENT_BUFFER",null," The data area passed to a system call is too small.",null,false],[0,0,0,"INVALID_NAME",null," The filename, directory name, or volume label syntax is incorrect.",null,false],[0,0,0,"INVALID_LEVEL",null," The system call level is not correct.",null,false],[0,0,0,"NO_VOLUME_LABEL",null," The disk has no volume label.",null,false],[0,0,0,"MOD_NOT_FOUND",null," The specified module could not be found.",null,false],[0,0,0,"PROC_NOT_FOUND",null," The specified procedure could not be found.",null,false],[0,0,0,"WAIT_NO_CHILDREN",null," There are no child processes to wait for.",null,false],[0,0,0,"CHILD_NOT_COMPLETE",null," The %1 application cannot be run in Win32 mode.",null,false],[0,0,0,"DIRECT_ACCESS_HANDLE",null," Attempt to use a file handle to an open disk partition for an operation other than raw disk I/O.",null,false],[0,0,0,"NEGATIVE_SEEK",null," An attempt was made to move the file pointer before the beginning of the file.",null,false],[0,0,0,"SEEK_ON_DEVICE",null," The file pointer cannot be set on the specified device or file.",null,false],[0,0,0,"IS_JOIN_TARGET",null," A JOIN or SUBST command cannot be used for a drive that contains previously joined drives.",null,false],[0,0,0,"IS_JOINED",null," An attempt was made to use a JOIN or SUBST command on a drive that has already been joined.",null,false],[0,0,0,"IS_SUBSTED",null," An attempt was made to use a JOIN or SUBST command on a drive that has already been substituted.",null,false],[0,0,0,"NOT_JOINED",null," The system tried to delete the JOIN of a drive that is not joined.",null,false],[0,0,0,"NOT_SUBSTED",null," The system tried to delete the substitution of a drive that is not substituted.",null,false],[0,0,0,"JOIN_TO_JOIN",null," The system tried to join a drive to a directory on a joined drive.",null,false],[0,0,0,"SUBST_TO_SUBST",null," The system tried to substitute a drive to a directory on a substituted drive.",null,false],[0,0,0,"JOIN_TO_SUBST",null," The system tried to join a drive to a directory on a substituted drive.",null,false],[0,0,0,"SUBST_TO_JOIN",null," The system tried to SUBST a drive to a directory on a joined drive.",null,false],[0,0,0,"BUSY_DRIVE",null," The system cannot perform a JOIN or SUBST at this time.",null,false],[0,0,0,"SAME_DRIVE",null," The system cannot join or substitute a drive to or for a directory on the same drive.",null,false],[0,0,0,"DIR_NOT_ROOT",null," The directory is not a subdirectory of the root directory.",null,false],[0,0,0,"DIR_NOT_EMPTY",null," The directory is not empty.",null,false],[0,0,0,"IS_SUBST_PATH",null," The path specified is being used in a substitute.",null,false],[0,0,0,"IS_JOIN_PATH",null," Not enough resources are available to process this command.",null,false],[0,0,0,"PATH_BUSY",null," The path specified cannot be used at this time.",null,false],[0,0,0,"IS_SUBST_TARGET",null," An attempt was made to join or substitute a drive for which a directory on the drive is the target of a previous substitute.",null,false],[0,0,0,"SYSTEM_TRACE",null," System trace information was not specified in your CONFIG.SYS file, or tracing is disallowed.",null,false],[0,0,0,"INVALID_EVENT_COUNT",null," The number of specified semaphore events for DosMuxSemWait is not correct.",null,false],[0,0,0,"TOO_MANY_MUXWAITERS",null," DosMuxSemWait did not execute; too many semaphores are already set.",null,false],[0,0,0,"INVALID_LIST_FORMAT",null," The DosMuxSemWait list is not correct.",null,false],[0,0,0,"LABEL_TOO_LONG",null," The volume label you entered exceeds the label character limit of the target file system.",null,false],[0,0,0,"TOO_MANY_TCBS",null," Cannot create another thread.",null,false],[0,0,0,"SIGNAL_REFUSED",null," The recipient process has refused the signal.",null,false],[0,0,0,"DISCARDED",null," The segment is already discarded and cannot be locked.",null,false],[0,0,0,"NOT_LOCKED",null," The segment is already unlocked.",null,false],[0,0,0,"BAD_THREADID_ADDR",null," The address for the thread ID is not correct.",null,false],[0,0,0,"BAD_ARGUMENTS",null," One or more arguments are not correct.",null,false],[0,0,0,"BAD_PATHNAME",null," The specified path is invalid.",null,false],[0,0,0,"SIGNAL_PENDING",null," A signal is already pending.",null,false],[0,0,0,"MAX_THRDS_REACHED",null," No more threads can be created in the system.",null,false],[0,0,0,"LOCK_FAILED",null," Unable to lock a region of a file.",null,false],[0,0,0,"BUSY",null," The requested resource is in use.",null,false],[0,0,0,"DEVICE_SUPPORT_IN_PROGRESS",null," Device's command support detection is in progress.",null,false],[0,0,0,"CANCEL_VIOLATION",null," A lock request was not outstanding for the supplied cancel region.",null,false],[0,0,0,"ATOMIC_LOCKS_NOT_SUPPORTED",null," The file system does not support atomic changes to the lock type.",null,false],[0,0,0,"INVALID_SEGMENT_NUMBER",null," The system detected a segment number that was not correct.",null,false],[0,0,0,"INVALID_ORDINAL",null," The operating system cannot run %1.",null,false],[0,0,0,"ALREADY_EXISTS",null," Cannot create a file when that file already exists.",null,false],[0,0,0,"INVALID_FLAG_NUMBER",null," The flag passed is not correct.",null,false],[0,0,0,"SEM_NOT_FOUND",null," The specified system semaphore name was not found.",null,false],[0,0,0,"INVALID_STARTING_CODESEG",null," The operating system cannot run %1.",null,false],[0,0,0,"INVALID_STACKSEG",null," The operating system cannot run %1.",null,false],[0,0,0,"INVALID_MODULETYPE",null," The operating system cannot run %1.",null,false],[0,0,0,"INVALID_EXE_SIGNATURE",null," Cannot run %1 in Win32 mode.",null,false],[0,0,0,"EXE_MARKED_INVALID",null," The operating system cannot run %1.",null,false],[0,0,0,"BAD_EXE_FORMAT",null," %1 is not a valid Win32 application.",null,false],[0,0,0,"ITERATED_DATA_EXCEEDS_64k",null," The operating system cannot run %1.",null,false],[0,0,0,"INVALID_MINALLOCSIZE",null," The operating system cannot run %1.",null,false],[0,0,0,"DYNLINK_FROM_INVALID_RING",null," The operating system cannot run this application program.",null,false],[0,0,0,"IOPL_NOT_ENABLED",null," The operating system is not presently configured to run this application.",null,false],[0,0,0,"INVALID_SEGDPL",null," The operating system cannot run %1.",null,false],[0,0,0,"AUTODATASEG_EXCEEDS_64k",null," The operating system cannot run this application program.",null,false],[0,0,0,"RING2SEG_MUST_BE_MOVABLE",null," The code segment cannot be greater than or equal to 64K.",null,false],[0,0,0,"RELOC_CHAIN_XEEDS_SEGLIM",null," The operating system cannot run %1.",null,false],[0,0,0,"INFLOOP_IN_RELOC_CHAIN",null," The operating system cannot run %1.",null,false],[0,0,0,"ENVVAR_NOT_FOUND",null," The system could not find the environment option that was entered.",null,false],[0,0,0,"NO_SIGNAL_SENT",null," No process in the command subtree has a signal handler.",null,false],[0,0,0,"FILENAME_EXCED_RANGE",null," The filename or extension is too long.",null,false],[0,0,0,"RING2_STACK_IN_USE",null," The ring 2 stack is in use.",null,false],[0,0,0,"META_EXPANSION_TOO_LONG",null," The global filename characters, * or ?, are entered incorrectly or too many global filename characters are specified.",null,false],[0,0,0,"INVALID_SIGNAL_NUMBER",null," The signal being posted is not correct.",null,false],[0,0,0,"THREAD_1_INACTIVE",null," The signal handler cannot be set.",null,false],[0,0,0,"LOCKED",null," The segment is locked and cannot be reallocated.",null,false],[0,0,0,"TOO_MANY_MODULES",null," Too many dynamic-link modules are attached to this program or dynamic-link module.",null,false],[0,0,0,"NESTING_NOT_ALLOWED",null," Cannot nest calls to LoadModule.",null,false],[0,0,0,"EXE_MACHINE_TYPE_MISMATCH",null," This version of %1 is not compatible with the version of Windows you're running.\n Check your computer's system information and then contact the software publisher.",null,false],[0,0,0,"EXE_CANNOT_MODIFY_SIGNED_BINARY",null," The image file %1 is signed, unable to modify.",null,false],[0,0,0,"EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY",null," The image file %1 is strong signed, unable to modify.",null,false],[0,0,0,"FILE_CHECKED_OUT",null," This file is checked out or locked for editing by another user.",null,false],[0,0,0,"CHECKOUT_REQUIRED",null," The file must be checked out before saving changes.",null,false],[0,0,0,"BAD_FILE_TYPE",null," The file type being saved or retrieved has been blocked.",null,false],[0,0,0,"FILE_TOO_LARGE",null," The file size exceeds the limit allowed and cannot be saved.",null,false],[0,0,0,"FORMS_AUTH_REQUIRED",null," Access Denied. Before opening files in this location, you must first add the web site to your trusted sites list, browse to the web site, and select the option to login automatically.",null,false],[0,0,0,"VIRUS_INFECTED",null," Operation did not complete successfully because the file contains a virus or potentially unwanted software.",null,false],[0,0,0,"VIRUS_DELETED",null," This file contains a virus or potentially unwanted software and cannot be opened.\n Due to the nature of this virus or potentially unwanted software, the file has been removed from this location.",null,false],[0,0,0,"PIPE_LOCAL",null," The pipe is local.",null,false],[0,0,0,"BAD_PIPE",null," The pipe state is invalid.",null,false],[0,0,0,"PIPE_BUSY",null," All pipe instances are busy.",null,false],[0,0,0,"NO_DATA",null," The pipe is being closed.",null,false],[0,0,0,"PIPE_NOT_CONNECTED",null," No process is on the other end of the pipe.",null,false],[0,0,0,"MORE_DATA",null," More data is available.",null,false],[0,0,0,"VC_DISCONNECTED",null," The session was canceled.",null,false],[0,0,0,"INVALID_EA_NAME",null," The specified extended attribute name was invalid.",null,false],[0,0,0,"EA_LIST_INCONSISTENT",null," The extended attributes are inconsistent.",null,false],[0,0,0,"IMEOUT",null," The wait operation timed out.",null,false],[0,0,0,"NO_MORE_ITEMS",null," No more data is available.",null,false],[0,0,0,"CANNOT_COPY",null," The copy functions cannot be used.",null,false],[0,0,0,"DIRECTORY",null," The directory name is invalid.",null,false],[0,0,0,"EAS_DIDNT_FIT",null," The extended attributes did not fit in the buffer.",null,false],[0,0,0,"EA_FILE_CORRUPT",null," The extended attribute file on the mounted file system is corrupt.",null,false],[0,0,0,"EA_TABLE_FULL",null," The extended attribute table file is full.",null,false],[0,0,0,"INVALID_EA_HANDLE",null," The specified extended attribute handle is invalid.",null,false],[0,0,0,"EAS_NOT_SUPPORTED",null," The mounted file system does not support extended attributes.",null,false],[0,0,0,"NOT_OWNER",null," Attempt to release mutex not owned by caller.",null,false],[0,0,0,"TOO_MANY_POSTS",null," Too many posts were made to a semaphore.",null,false],[0,0,0,"PARTIAL_COPY",null," Only part of a ReadProcessMemory or WriteProcessMemory request was completed.",null,false],[0,0,0,"OPLOCK_NOT_GRANTED",null," The oplock request is denied.",null,false],[0,0,0,"INVALID_OPLOCK_PROTOCOL",null," An invalid oplock acknowledgment was received by the system.",null,false],[0,0,0,"DISK_TOO_FRAGMENTED",null," The volume is too fragmented to complete this operation.",null,false],[0,0,0,"DELETE_PENDING",null," The file cannot be opened because it is in the process of being deleted.",null,false],[0,0,0,"INCOMPATIBLE_WITH_GLOBAL_SHORT_NAME_REGISTRY_SETTING",null," Short name settings may not be changed on this volume due to the global registry setting.",null,false],[0,0,0,"SHORT_NAMES_NOT_ENABLED_ON_VOLUME",null," Short names are not enabled on this volume.",null,false],[0,0,0,"SECURITY_STREAM_IS_INCONSISTENT",null," The security stream for the given volume is in an inconsistent state. Please run CHKDSK on the volume.",null,false],[0,0,0,"INVALID_LOCK_RANGE",null," A requested file lock operation cannot be processed due to an invalid byte range.",null,false],[0,0,0,"IMAGE_SUBSYSTEM_NOT_PRESENT",null," The subsystem needed to support the image type is not present.",null,false],[0,0,0,"NOTIFICATION_GUID_ALREADY_DEFINED",null," The specified file already has a notification GUID associated with it.",null,false],[0,0,0,"INVALID_EXCEPTION_HANDLER",null," An invalid exception handler routine has been detected.",null,false],[0,0,0,"DUPLICATE_PRIVILEGES",null," Duplicate privileges were specified for the token.",null,false],[0,0,0,"NO_RANGES_PROCESSED",null," No ranges for the specified operation were able to be processed.",null,false],[0,0,0,"NOT_ALLOWED_ON_SYSTEM_FILE",null," Operation is not allowed on a file system internal file.",null,false],[0,0,0,"DISK_RESOURCES_EXHAUSTED",null," The physical resources of this disk have been exhausted.",null,false],[0,0,0,"INVALID_TOKEN",null," The token representing the data is invalid.",null,false],[0,0,0,"DEVICE_FEATURE_NOT_SUPPORTED",null," The device does not support the command feature.",null,false],[0,0,0,"MR_MID_NOT_FOUND",null," The system cannot find message text for message number 0x%1 in the message file for %2.",null,false],[0,0,0,"SCOPE_NOT_FOUND",null," The scope specified was not found.",null,false],[0,0,0,"UNDEFINED_SCOPE",null," The Central Access Policy specified is not defined on the target machine.",null,false],[0,0,0,"INVALID_CAP",null," The Central Access Policy obtained from Active Directory is invalid.",null,false],[0,0,0,"DEVICE_UNREACHABLE",null," The device is unreachable.",null,false],[0,0,0,"DEVICE_NO_RESOURCES",null," The target device has insufficient resources to complete the operation.",null,false],[0,0,0,"DATA_CHECKSUM_ERROR",null," A data integrity checksum error occurred. Data in the file stream is corrupt.",null,false],[0,0,0,"INTERMIXED_KERNEL_EA_OPERATION",null," An attempt was made to modify both a KERNEL and normal Extended Attribute (EA) in the same operation.",null,false],[0,0,0,"FILE_LEVEL_TRIM_NOT_SUPPORTED",null," Device does not support file-level TRIM.",null,false],[0,0,0,"OFFSET_ALIGNMENT_VIOLATION",null," The command specified a data offset that does not align to the device's granularity/alignment.",null,false],[0,0,0,"INVALID_FIELD_IN_PARAMETER_LIST",null," The command specified an invalid field in its parameter list.",null,false],[0,0,0,"OPERATION_IN_PROGRESS",null," An operation is currently in progress with the device.",null,false],[0,0,0,"BAD_DEVICE_PATH",null," An attempt was made to send down the command via an invalid path to the target device.",null,false],[0,0,0,"TOO_MANY_DESCRIPTORS",null," The command specified a number of descriptors that exceeded the maximum supported by the device.",null,false],[0,0,0,"SCRUB_DATA_DISABLED",null," Scrub is disabled on the specified file.",null,false],[0,0,0,"NOT_REDUNDANT_STORAGE",null," The storage device does not provide redundancy.",null,false],[0,0,0,"RESIDENT_FILE_NOT_SUPPORTED",null," An operation is not supported on a resident file.",null,false],[0,0,0,"COMPRESSED_FILE_NOT_SUPPORTED",null," An operation is not supported on a compressed file.",null,false],[0,0,0,"DIRECTORY_NOT_SUPPORTED",null," An operation is not supported on a directory.",null,false],[0,0,0,"NOT_READ_FROM_COPY",null," The specified copy of the requested data could not be read.",null,false],[0,0,0,"FAIL_NOACTION_REBOOT",null," No action was taken as a system reboot is required.",null,false],[0,0,0,"FAIL_SHUTDOWN",null," The shutdown operation failed.",null,false],[0,0,0,"FAIL_RESTART",null," The restart operation failed.",null,false],[0,0,0,"MAX_SESSIONS_REACHED",null," The maximum number of sessions has been reached.",null,false],[0,0,0,"THREAD_MODE_ALREADY_BACKGROUND",null," The thread is already in background processing mode.",null,false],[0,0,0,"THREAD_MODE_NOT_BACKGROUND",null," The thread is not in background processing mode.",null,false],[0,0,0,"PROCESS_MODE_ALREADY_BACKGROUND",null," The process is already in background processing mode.",null,false],[0,0,0,"PROCESS_MODE_NOT_BACKGROUND",null," The process is not in background processing mode.",null,false],[0,0,0,"INVALID_ADDRESS",null," Attempt to access invalid address.",null,false],[0,0,0,"USER_PROFILE_LOAD",null," User profile cannot be loaded.",null,false],[0,0,0,"ARITHMETIC_OVERFLOW",null," Arithmetic result exceeded 32 bits.",null,false],[0,0,0,"PIPE_CONNECTED",null," There is a process on other end of the pipe.",null,false],[0,0,0,"PIPE_LISTENING",null," Waiting for a process to open the other end of the pipe.",null,false],[0,0,0,"VERIFIER_STOP",null," Application verifier has found an error in the current process.",null,false],[0,0,0,"ABIOS_ERROR",null," An error occurred in the ABIOS subsystem.",null,false],[0,0,0,"WX86_WARNING",null," A warning occurred in the WX86 subsystem.",null,false],[0,0,0,"WX86_ERROR",null," An error occurred in the WX86 subsystem.",null,false],[0,0,0,"TIMER_NOT_CANCELED",null," An attempt was made to cancel or set a timer that has an associated APC and the subject thread is not the thread that originally set the timer with an associated APC routine.",null,false],[0,0,0,"UNWIND",null," Unwind exception code.",null,false],[0,0,0,"BAD_STACK",null," An invalid or unaligned stack was encountered during an unwind operation.",null,false],[0,0,0,"INVALID_UNWIND_TARGET",null," An invalid unwind target was encountered during an unwind operation.",null,false],[0,0,0,"INVALID_PORT_ATTRIBUTES",null," Invalid Object Attributes specified to NtCreatePort or invalid Port Attributes specified to NtConnectPort",null,false],[0,0,0,"PORT_MESSAGE_TOO_LONG",null," Length of message passed to NtRequestPort or NtRequestWaitReplyPort was longer than the maximum message allowed by the port.",null,false],[0,0,0,"INVALID_QUOTA_LOWER",null," An attempt was made to lower a quota limit below the current usage.",null,false],[0,0,0,"DEVICE_ALREADY_ATTACHED",null," An attempt was made to attach to a device that was already attached to another device.",null,false],[0,0,0,"INSTRUCTION_MISALIGNMENT",null," An attempt was made to execute an instruction at an unaligned address and the host system does not support unaligned instruction references.",null,false],[0,0,0,"PROFILING_NOT_STARTED",null," Profiling not started.",null,false],[0,0,0,"PROFILING_NOT_STOPPED",null," Profiling not stopped.",null,false],[0,0,0,"COULD_NOT_INTERPRET",null," The passed ACL did not contain the minimum required information.",null,false],[0,0,0,"PROFILING_AT_LIMIT",null," The number of active profiling objects is at the maximum and no more may be started.",null,false],[0,0,0,"CANT_WAIT",null," Used to indicate that an operation cannot continue without blocking for I/O.",null,false],[0,0,0,"CANT_TERMINATE_SELF",null," Indicates that a thread attempted to terminate itself by default (called NtTerminateThread with NULL) and it was the last thread in the current process.",null,false],[0,0,0,"UNEXPECTED_MM_CREATE_ERR",null," If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter.\n In this case information is lost, however, the filter correctly handles the exception.",null,false],[0,0,0,"UNEXPECTED_MM_MAP_ERROR",null," If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter.\n In this case information is lost, however, the filter correctly handles the exception.",null,false],[0,0,0,"UNEXPECTED_MM_EXTEND_ERR",null," If an MM error is returned which is not defined in the standard FsRtl filter, it is converted to one of the following errors which is guaranteed to be in the filter.\n In this case information is lost, however, the filter correctly handles the exception.",null,false],[0,0,0,"BAD_FUNCTION_TABLE",null," A malformed function table was encountered during an unwind operation.",null,false],[0,0,0,"NO_GUID_TRANSLATION",null," Indicates that an attempt was made to assign protection to a file system file or directory and one of the SIDs in the security descriptor could not be translated into a GUID that could be stored by the file system.\n This causes the protection attempt to fail, which may cause a file creation attempt to fail.",null,false],[0,0,0,"INVALID_LDT_SIZE",null," Indicates that an attempt was made to grow an LDT by setting its size, or that the size was not an even number of selectors.",null,false],[0,0,0,"INVALID_LDT_OFFSET",null," Indicates that the starting value for the LDT information was not an integral multiple of the selector size.",null,false],[0,0,0,"INVALID_LDT_DESCRIPTOR",null," Indicates that the user supplied an invalid descriptor when trying to set up Ldt descriptors.",null,false],[0,0,0,"TOO_MANY_THREADS",null," Indicates a process has too many threads to perform the requested action.\n For example, assignment of a primary token may only be performed when a process has zero or one threads.",null,false],[0,0,0,"THREAD_NOT_IN_PROCESS",null," An attempt was made to operate on a thread within a specific process, but the thread specified is not in the process specified.",null,false],[0,0,0,"PAGEFILE_QUOTA_EXCEEDED",null," Page file quota was exceeded.",null,false],[0,0,0,"LOGON_SERVER_CONFLICT",null," The Netlogon service cannot start because another Netlogon service running in the domain conflicts with the specified role.",null,false],[0,0,0,"SYNCHRONIZATION_REQUIRED",null," The SAM database on a Windows Server is significantly out of synchronization with the copy on the Domain Controller. A complete synchronization is required.",null,false],[0,0,0,"NET_OPEN_FAILED",null," The NtCreateFile API failed. This error should never be returned to an application, it is a place holder for the Windows Lan Manager Redirector to use in its internal error mapping routines.",null,false],[0,0,0,"IO_PRIVILEGE_FAILED",null," {Privilege Failed} The I/O permissions for the process could not be changed.",null,false],[0,0,0,"CONTROL_C_EXIT",null," {Application Exit by CTRL+C} The application terminated as a result of a CTRL+C.",null,false],[0,0,0,"MISSING_SYSTEMFILE",null," {Missing System File} The required system file %hs is bad or missing.",null,false],[0,0,0,"UNHANDLED_EXCEPTION",null," {Application Error} The exception %s (0x%08lx) occurred in the application at location 0x%08lx.",null,false],[0,0,0,"APP_INIT_FAILURE",null," {Application Error} The application was unable to start correctly (0x%lx). Click OK to close the application.",null,false],[0,0,0,"PAGEFILE_CREATE_FAILED",null," {Unable to Create Paging File} The creation of the paging file %hs failed (%lx). The requested size was %ld.",null,false],[0,0,0,"INVALID_IMAGE_HASH",null," Windows cannot verify the digital signature for this file.\n A recent hardware or software change might have installed a file that is signed incorrectly or damaged, or that might be malicious software from an unknown source.",null,false],[0,0,0,"NO_PAGEFILE",null," {No Paging File Specified} No paging file was specified in the system configuration.",null,false],[0,0,0,"ILLEGAL_FLOAT_CONTEXT",null," {EXCEPTION} A real-mode application issued a floating-point instruction and floating-point hardware is not present.",null,false],[0,0,0,"NO_EVENT_PAIR",null," An event pair synchronization operation was performed using the thread specific client/server event pair object, but no event pair object was associated with the thread.",null,false],[0,0,0,"DOMAIN_CTRLR_CONFIG_ERROR",null," A Windows Server has an incorrect configuration.",null,false],[0,0,0,"ILLEGAL_CHARACTER",null," An illegal character was encountered.\n For a multi-byte character set this includes a lead byte without a succeeding trail byte.\n For the Unicode character set this includes the characters 0xFFFF and 0xFFFE.",null,false],[0,0,0,"UNDEFINED_CHARACTER",null," The Unicode character is not defined in the Unicode character set installed on the system.",null,false],[0,0,0,"FLOPPY_VOLUME",null," The paging file cannot be created on a floppy diskette.",null,false],[0,0,0,"BIOS_FAILED_TO_CONNECT_INTERRUPT",null," The system BIOS failed to connect a system interrupt to the device or bus for which the device is connected.",null,false],[0,0,0,"BACKUP_CONTROLLER",null," This operation is only allowed for the Primary Domain Controller of the domain.",null,false],[0,0,0,"MUTANT_LIMIT_EXCEEDED",null," An attempt was made to acquire a mutant such that its maximum count would have been exceeded.",null,false],[0,0,0,"FS_DRIVER_REQUIRED",null," A volume has been accessed for which a file system driver is required that has not yet been loaded.",null,false],[0,0,0,"CANNOT_LOAD_REGISTRY_FILE",null," {Registry File Failure} The registry cannot load the hive (file): %hs or its log or alternate. It is corrupt, absent, or not writable.",null,false],[0,0,0,"DEBUG_ATTACH_FAILED",null," {Unexpected Failure in DebugActiveProcess} An unexpected failure occurred while processing a DebugActiveProcess API request.\n You may choose OK to terminate the process, or Cancel to ignore the error.",null,false],[0,0,0,"SYSTEM_PROCESS_TERMINATED",null," {Fatal System Error} The %hs system process terminated unexpectedly with a status of 0x%08x (0x%08x 0x%08x). The system has been shut down.",null,false],[0,0,0,"DATA_NOT_ACCEPTED",null," {Data Not Accepted} The TDI client could not handle the data received during an indication.",null,false],[0,0,0,"VDM_HARD_ERROR",null," NTVDM encountered a hard error.",null,false],[0,0,0,"DRIVER_CANCEL_TIMEOUT",null," {Cancel Timeout} The driver %hs failed to complete a cancelled I/O request in the allotted time.",null,false],[0,0,0,"REPLY_MESSAGE_MISMATCH",null," {Reply Message Mismatch} An attempt was made to reply to an LPC message, but the thread specified by the client ID in the message was not waiting on that message.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs. The data has been lost.\n This error may be caused by a failure of your computer hardware or network connection. Please try to save this file elsewhere.",null,false],[0,0,0,"CLIENT_SERVER_PARAMETERS_INVALID",null," The parameter(s) passed to the server in the client/server shared memory window were invalid.\n Too much data may have been put in the shared memory window.",null,false],[0,0,0,"NOT_TINY_STREAM",null," The stream is not a tiny stream.",null,false],[0,0,0,"STACK_OVERFLOW_READ",null," The request must be handled by the stack overflow code.",null,false],[0,0,0,"CONVERT_TO_LARGE",null," Internal OFS status codes indicating how an allocation operation is handled.\n Either it is retried after the containing onode is moved or the extent stream is converted to a large stream.",null,false],[0,0,0,"FOUND_OUT_OF_SCOPE",null," The attempt to find the object found an object matching by ID on the volume but it is out of the scope of the handle used for the operation.",null,false],[0,0,0,"ALLOCATE_BUCKET",null," The bucket array must be grown. Retry transaction after doing so.",null,false],[0,0,0,"MARSHALL_OVERFLOW",null," The user/kernel marshalling buffer has overflowed.",null,false],[0,0,0,"INVALID_VARIANT",null," The supplied variant structure contains invalid data.",null,false],[0,0,0,"BAD_COMPRESSION_BUFFER",null," The specified buffer contains ill-formed data.",null,false],[0,0,0,"AUDIT_FAILED",null," {Audit Failed} An attempt to generate a security audit failed.",null,false],[0,0,0,"TIMER_RESOLUTION_NOT_SET",null," The timer resolution was not previously set by the current process.",null,false],[0,0,0,"INSUFFICIENT_LOGON_INFO",null," There is insufficient account information to log you on.",null,false],[0,0,0,"BAD_DLL_ENTRYPOINT",null," {Invalid DLL Entrypoint} The dynamic link library %hs is not written correctly.\n The stack pointer has been left in an inconsistent state.\n The entrypoint should be declared as WINAPI or STDCALL.\n Select YES to fail the DLL load. Select NO to continue execution.\n Selecting NO may cause the application to operate incorrectly.",null,false],[0,0,0,"BAD_SERVICE_ENTRYPOINT",null," {Invalid Service Callback Entrypoint} The %hs service is not written correctly.\n The stack pointer has been left in an inconsistent state.\n The callback entrypoint should be declared as WINAPI or STDCALL.\n Selecting OK will cause the service to continue operation.\n However, the service process may operate incorrectly.",null,false],[0,0,0,"IP_ADDRESS_CONFLICT1",null," There is an IP address conflict with another system on the network.",null,false],[0,0,0,"IP_ADDRESS_CONFLICT2",null," There is an IP address conflict with another system on the network.",null,false],[0,0,0,"REGISTRY_QUOTA_LIMIT",null," {Low On Registry Space} The system has reached the maximum size allowed for the system part of the registry. Additional storage requests will be ignored.",null,false],[0,0,0,"NO_CALLBACK_ACTIVE",null," A callback return system service cannot be executed when no callback is active.",null,false],[0,0,0,"PWD_TOO_SHORT",null," The password provided is too short to meet the policy of your user account. Please choose a longer password.",null,false],[0,0,0,"PWD_TOO_RECENT",null," The policy of your user account does not allow you to change passwords too frequently.\n This is done to prevent users from changing back to a familiar, but potentially discovered, password.\n If you feel your password has been compromised then please contact your administrator immediately to have a new one assigned.",null,false],[0,0,0,"PWD_HISTORY_CONFLICT",null," You have attempted to change your password to one that you have used in the past.\n The policy of your user account does not allow this.\n Please select a password that you have not previously used.",null,false],[0,0,0,"UNSUPPORTED_COMPRESSION",null," The specified compression format is unsupported.",null,false],[0,0,0,"INVALID_HW_PROFILE",null," The specified hardware profile configuration is invalid.",null,false],[0,0,0,"INVALID_PLUGPLAY_DEVICE_PATH",null," The specified Plug and Play registry device path is invalid.",null,false],[0,0,0,"QUOTA_LIST_INCONSISTENT",null," The specified quota list is internally inconsistent with its descriptor.",null,false],[0,0,0,"EVALUATION_EXPIRATION",null," {Windows Evaluation Notification} The evaluation period for this installation of Windows has expired. This system will shutdown in 1 hour.\n To restore access to this installation of Windows, please upgrade this installation using a licensed distribution of this product.",null,false],[0,0,0,"ILLEGAL_DLL_RELOCATION",null," {Illegal System DLL Relocation} The system DLL %hs was relocated in memory. The application will not run properly.\n The relocation occurred because the DLL %hs occupied an address range reserved for Windows system DLLs.\n The vendor supplying the DLL should be contacted for a new DLL.",null,false],[0,0,0,"DLL_INIT_FAILED_LOGOFF",null," {DLL Initialization Failed} The application failed to initialize because the window station is shutting down.",null,false],[0,0,0,"VALIDATE_CONTINUE",null," The validation process needs to continue on to the next step.",null,false],[0,0,0,"NO_MORE_MATCHES",null," There are no more matches for the current index enumeration.",null,false],[0,0,0,"RANGE_LIST_CONFLICT",null," The range could not be added to the range list because of a conflict.",null,false],[0,0,0,"SERVER_SID_MISMATCH",null," The server process is running under a SID different than that required by client.",null,false],[0,0,0,"CANT_ENABLE_DENY_ONLY",null," A group marked use for deny only cannot be enabled.",null,false],[0,0,0,"FLOAT_MULTIPLE_FAULTS",null," {EXCEPTION} Multiple floating point faults.",null,false],[0,0,0,"FLOAT_MULTIPLE_TRAPS",null," {EXCEPTION} Multiple floating point traps.",null,false],[0,0,0,"NOINTERFACE",null," The requested interface is not supported.",null,false],[0,0,0,"DRIVER_FAILED_SLEEP",null," {System Standby Failed} The driver %hs does not support standby mode.\n Updating this driver may allow the system to go to standby mode.",null,false],[0,0,0,"CORRUPT_SYSTEM_FILE",null," The system file %1 has become corrupt and has been replaced.",null,false],[0,0,0,"COMMITMENT_MINIMUM",null," {Virtual Memory Minimum Too Low} Your system is low on virtual memory.\n Windows is increasing the size of your virtual memory paging file.\n During this process, memory requests for some applications may be denied. For more information, see Help.",null,false],[0,0,0,"PNP_RESTART_ENUMERATION",null," A device was removed so enumeration must be restarted.",null,false],[0,0,0,"SYSTEM_IMAGE_BAD_SIGNATURE",null," {Fatal System Error} The system image %s is not properly signed.\n The file has been replaced with the signed file. The system has been shut down.",null,false],[0,0,0,"PNP_REBOOT_REQUIRED",null," Device will not start without a reboot.",null,false],[0,0,0,"INSUFFICIENT_POWER",null," There is not enough power to complete the requested operation.",null,false],[0,0,0,"MULTIPLE_FAULT_VIOLATION",null," ERROR_MULTIPLE_FAULT_VIOLATION",null,false],[0,0,0,"SYSTEM_SHUTDOWN",null," The system is in the process of shutting down.",null,false],[0,0,0,"PORT_NOT_SET",null," An attempt to remove a processes DebugPort was made, but a port was not already associated with the process.",null,false],[0,0,0,"DS_VERSION_CHECK_FAILURE",null," This version of Windows is not compatible with the behavior version of directory forest, domain or domain controller.",null,false],[0,0,0,"RANGE_NOT_FOUND",null," The specified range could not be found in the range list.",null,false],[0,0,0,"NOT_SAFE_MODE_DRIVER",null," The driver was not loaded because the system is booting into safe mode.",null,false],[0,0,0,"FAILED_DRIVER_ENTRY",null," The driver was not loaded because it failed its initialization call.",null,false],[0,0,0,"DEVICE_ENUMERATION_ERROR",null," The \"%hs\" encountered an error while applying power or reading the device configuration.\n This may be caused by a failure of your hardware or by a poor connection.",null,false],[0,0,0,"MOUNT_POINT_NOT_RESOLVED",null," The create operation failed because the name contained at least one mount point which resolves to a volume to which the specified device object is not attached.",null,false],[0,0,0,"INVALID_DEVICE_OBJECT_PARAMETER",null," The device object parameter is either not a valid device object or is not attached to the volume specified by the file name.",null,false],[0,0,0,"MCA_OCCURED",null," A Machine Check Error has occurred.\n Please check the system eventlog for additional information.",null,false],[0,0,0,"DRIVER_DATABASE_ERROR",null," There was error [%2] processing the driver database.",null,false],[0,0,0,"SYSTEM_HIVE_TOO_LARGE",null," System hive size has exceeded its limit.",null,false],[0,0,0,"DRIVER_FAILED_PRIOR_UNLOAD",null," The driver could not be loaded because a previous version of the driver is still in memory.",null,false],[0,0,0,"VOLSNAP_PREPARE_HIBERNATE",null," {Volume Shadow Copy Service} Please wait while the Volume Shadow Copy Service prepares volume %hs for hibernation.",null,false],[0,0,0,"HIBERNATION_FAILURE",null," The system has failed to hibernate (The error code is %hs).\n Hibernation will be disabled until the system is restarted.",null,false],[0,0,0,"PWD_TOO_LONG",null," The password provided is too long to meet the policy of your user account. Please choose a shorter password.",null,false],[0,0,0,"FILE_SYSTEM_LIMITATION",null," The requested operation could not be completed due to a file system limitation.",null,false],[0,0,0,"ASSERTION_FAILURE",null," An assertion failure has occurred.",null,false],[0,0,0,"ACPI_ERROR",null," An error occurred in the ACPI subsystem.",null,false],[0,0,0,"WOW_ASSERTION",null," WOW Assertion Error.",null,false],[0,0,0,"PNP_BAD_MPS_TABLE",null," A device is missing in the system BIOS MPS table. This device will not be used.\n Please contact your system vendor for system BIOS update.",null,false],[0,0,0,"PNP_TRANSLATION_FAILED",null," A translator failed to translate resources.",null,false],[0,0,0,"PNP_IRQ_TRANSLATION_FAILED",null," A IRQ translator failed to translate resources.",null,false],[0,0,0,"PNP_INVALID_ID",null," Driver %2 returned invalid ID for a child device (%3).",null,false],[0,0,0,"WAKE_SYSTEM_DEBUGGER",null," {Kernel Debugger Awakened} the system debugger was awakened by an interrupt.",null,false],[0,0,0,"HANDLES_CLOSED",null," {Handles Closed} Handles to objects have been automatically closed as a result of the requested operation.",null,false],[0,0,0,"EXTRANEOUS_INFORMATION",null," {Too Much Information} The specified access control list (ACL) contained more information than was expected.",null,false],[0,0,0,"RXACT_COMMIT_NECESSARY",null," This warning level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted.\n The commit has NOT been completed, but has not been rolled back either (so it may still be committed if desired).",null,false],[0,0,0,"MEDIA_CHECK",null," {Media Changed} The media may have changed.",null,false],[0,0,0,"GUID_SUBSTITUTION_MADE",null," {GUID Substitution} During the translation of a global identifier (GUID) to a Windows security ID (SID), no administratively-defined GUID prefix was found.\n A substitute prefix was used, which will not compromise system security.\n However, this may provide a more restrictive access than intended.",null,false],[0,0,0,"STOPPED_ON_SYMLINK",null," The create operation stopped after reaching a symbolic link.",null,false],[0,0,0,"LONGJUMP",null," A long jump has been executed.",null,false],[0,0,0,"PLUGPLAY_QUERY_VETOED",null," The Plug and Play query operation was not successful.",null,false],[0,0,0,"UNWIND_CONSOLIDATE",null," A frame consolidation has been executed.",null,false],[0,0,0,"REGISTRY_HIVE_RECOVERED",null," {Registry Hive Recovered} Registry hive (file): %hs was corrupted and it has been recovered. Some data might have been lost.",null,false],[0,0,0,"DLL_MIGHT_BE_INSECURE",null," The application is attempting to run executable code from the module %hs. This may be insecure.\n An alternative, %hs, is available. Should the application use the secure module %hs?",null,false],[0,0,0,"DLL_MIGHT_BE_INCOMPATIBLE",null," The application is loading executable code from the module %hs.\n This is secure, but may be incompatible with previous releases of the operating system.\n An alternative, %hs, is available. Should the application use the secure module %hs?",null,false],[0,0,0,"DBG_EXCEPTION_NOT_HANDLED",null," Debugger did not handle the exception.",null,false],[0,0,0,"DBG_REPLY_LATER",null," Debugger will reply later.",null,false],[0,0,0,"DBG_UNABLE_TO_PROVIDE_HANDLE",null," Debugger cannot provide handle.",null,false],[0,0,0,"DBG_TERMINATE_THREAD",null," Debugger terminated thread.",null,false],[0,0,0,"DBG_TERMINATE_PROCESS",null," Debugger terminated process.",null,false],[0,0,0,"DBG_CONTROL_C",null," Debugger got control C.",null,false],[0,0,0,"DBG_PRINTEXCEPTION_C",null," Debugger printed exception on control C.",null,false],[0,0,0,"DBG_RIPEXCEPTION",null," Debugger received RIP exception.",null,false],[0,0,0,"DBG_CONTROL_BREAK",null," Debugger received control break.",null,false],[0,0,0,"DBG_COMMAND_EXCEPTION",null," Debugger command communication exception.",null,false],[0,0,0,"OBJECT_NAME_EXISTS",null," {Object Exists} An attempt was made to create an object and the object name already existed.",null,false],[0,0,0,"THREAD_WAS_SUSPENDED",null," {Thread Suspended} A thread termination occurred while the thread was suspended.\n The thread was resumed, and termination proceeded.",null,false],[0,0,0,"IMAGE_NOT_AT_BASE",null," {Image Relocated} An image file could not be mapped at the address specified in the image file. Local fixups must be performed on this image.",null,false],[0,0,0,"RXACT_STATE_CREATED",null," This informational level status indicates that a specified registry sub-tree transaction state did not yet exist and had to be created.",null,false],[0,0,0,"SEGMENT_NOTIFICATION",null," {Segment Load} A virtual DOS machine (VDM) is loading, unloading, or moving an MS-DOS or Win16 program segment image.\n An exception is raised so a debugger can load, unload or track symbols and breakpoints within these 16-bit segments.",null,false],[0,0,0,"BAD_CURRENT_DIRECTORY",null," {Invalid Current Directory} The process cannot switch to the startup current directory %hs.\n Select OK to set current directory to %hs, or select CANCEL to exit.",null,false],[0,0,0,"FT_READ_RECOVERY_FROM_BACKUP",null," {Redundant Read} To satisfy a read request, the NT fault-tolerant file system successfully read the requested data from a redundant copy.\n This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was unable to reassign the failing area of the device.",null,false],[0,0,0,"FT_WRITE_RECOVERY",null," {Redundant Write} To satisfy a write request, the NT fault-tolerant file system successfully wrote a redundant copy of the information.\n This was done because the file system encountered a failure on a member of the fault-tolerant volume, but was not able to reassign the failing area of the device.",null,false],[0,0,0,"IMAGE_MACHINE_TYPE_MISMATCH",null," {Machine Type Mismatch} The image file %hs is valid, but is for a machine type other than the current machine.\n Select OK to continue, or CANCEL to fail the DLL load.",null,false],[0,0,0,"RECEIVE_PARTIAL",null," {Partial Data Received} The network transport returned partial data to its client. The remaining data will be sent later.",null,false],[0,0,0,"RECEIVE_EXPEDITED",null," {Expedited Data Received} The network transport returned data to its client that was marked as expedited by the remote system.",null,false],[0,0,0,"RECEIVE_PARTIAL_EXPEDITED",null," {Partial Expedited Data Received} The network transport returned partial data to its client and this data was marked as expedited by the remote system. The remaining data will be sent later.",null,false],[0,0,0,"EVENT_DONE",null," {TDI Event Done} The TDI indication has completed successfully.",null,false],[0,0,0,"EVENT_PENDING",null," {TDI Event Pending} The TDI indication has entered the pending state.",null,false],[0,0,0,"CHECKING_FILE_SYSTEM",null," Checking file system on %wZ.",null,false],[0,0,0,"FATAL_APP_EXIT",null," {Fatal Application Exit} %hs.",null,false],[0,0,0,"PREDEFINED_HANDLE",null," The specified registry key is referenced by a predefined handle.",null,false],[0,0,0,"WAS_UNLOCKED",null," {Page Unlocked} The page protection of a locked page was changed to 'No Access' and the page was unlocked from memory and from the process.",null,false],[0,0,0,"SERVICE_NOTIFICATION",null," %hs",null,false],[0,0,0,"WAS_LOCKED",null," {Page Locked} One of the pages to lock was already locked.",null,false],[0,0,0,"LOG_HARD_ERROR",null," Application popup: %1 : %2",null,false],[0,0,0,"ALREADY_WIN32",null," ERROR_ALREADY_WIN32",null,false],[0,0,0,"IMAGE_MACHINE_TYPE_MISMATCH_EXE",null," {Machine Type Mismatch} The image file %hs is valid, but is for a machine type other than the current machine.",null,false],[0,0,0,"NO_YIELD_PERFORMED",null," A yield execution was performed and no thread was available to run.",null,false],[0,0,0,"TIMER_RESUME_IGNORED",null," The resumable flag to a timer API was ignored.",null,false],[0,0,0,"ARBITRATION_UNHANDLED",null," The arbiter has deferred arbitration of these resources to its parent.",null,false],[0,0,0,"CARDBUS_NOT_SUPPORTED",null," The inserted CardBus device cannot be started because of a configuration error on \"%hs\".",null,false],[0,0,0,"MP_PROCESSOR_MISMATCH",null," The CPUs in this multiprocessor system are not all the same revision level.\n To use all processors the operating system restricts itself to the features of the least capable processor in the system.\n Should problems occur with this system, contact the CPU manufacturer to see if this mix of processors is supported.",null,false],[0,0,0,"HIBERNATED",null," The system was put into hibernation.",null,false],[0,0,0,"RESUME_HIBERNATION",null," The system was resumed from hibernation.",null,false],[0,0,0,"FIRMWARE_UPDATED",null," Windows has detected that the system firmware (BIOS) was updated [previous firmware date = %2, current firmware date %3].",null,false],[0,0,0,"DRIVERS_LEAKING_LOCKED_PAGES",null," A device driver is leaking locked I/O pages causing system degradation.\n The system has automatically enabled tracking code in order to try and catch the culprit.",null,false],[0,0,0,"WAKE_SYSTEM",null," The system has awoken.",null,false],[0,0,0,"WAIT_1",null," ERROR_WAIT_1",null,false],[0,0,0,"WAIT_2",null," ERROR_WAIT_2",null,false],[0,0,0,"WAIT_3",null," ERROR_WAIT_3",null,false],[0,0,0,"WAIT_63",null," ERROR_WAIT_63",null,false],[0,0,0,"ABANDONED_WAIT_0",null," ERROR_ABANDONED_WAIT_0",null,false],[0,0,0,"ABANDONED_WAIT_63",null," ERROR_ABANDONED_WAIT_63",null,false],[0,0,0,"USER_APC",null," ERROR_USER_APC",null,false],[0,0,0,"KERNEL_APC",null," ERROR_KERNEL_APC",null,false],[0,0,0,"ALERTED",null," ERROR_ALERTED",null,false],[0,0,0,"ELEVATION_REQUIRED",null," The requested operation requires elevation.",null,false],[0,0,0,"REPARSE",null," A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link.",null,false],[0,0,0,"OPLOCK_BREAK_IN_PROGRESS",null," An open/create operation completed while an oplock break is underway.",null,false],[0,0,0,"VOLUME_MOUNTED",null," A new volume has been mounted by a file system.",null,false],[0,0,0,"RXACT_COMMITTED",null," This success level status indicates that the transaction state already exists for the registry sub-tree, but that a transaction commit was previously aborted. The commit has now been completed.",null,false],[0,0,0,"NOTIFY_CLEANUP",null," This indicates that a notify change request has been completed due to closing the handle which made the notify change request.",null,false],[0,0,0,"PRIMARY_TRANSPORT_CONNECT_FAILED",null," {Connect Failure on Primary Transport} An attempt was made to connect to the remote server %hs on the primary transport, but the connection failed.\n The computer WAS able to connect on a secondary transport.",null,false],[0,0,0,"PAGE_FAULT_TRANSITION",null," Page fault was a transition fault.",null,false],[0,0,0,"PAGE_FAULT_DEMAND_ZERO",null," Page fault was a demand zero fault.",null,false],[0,0,0,"PAGE_FAULT_COPY_ON_WRITE",null," Page fault was a demand zero fault.",null,false],[0,0,0,"PAGE_FAULT_GUARD_PAGE",null," Page fault was a demand zero fault.",null,false],[0,0,0,"PAGE_FAULT_PAGING_FILE",null," Page fault was satisfied by reading from a secondary storage device.",null,false],[0,0,0,"CACHE_PAGE_LOCKED",null," Cached page was locked during operation.",null,false],[0,0,0,"CRASH_DUMP",null," Crash dump exists in paging file.",null,false],[0,0,0,"BUFFER_ALL_ZEROS",null," Specified buffer contains all zeros.",null,false],[0,0,0,"REPARSE_OBJECT",null," A reparse should be performed by the Object Manager since the name of the file resulted in a symbolic link.",null,false],[0,0,0,"RESOURCE_REQUIREMENTS_CHANGED",null," The device has succeeded a query-stop and its resource requirements have changed.",null,false],[0,0,0,"TRANSLATION_COMPLETE",null," The translator has translated these resources into the global space and no further translations should be performed.",null,false],[0,0,0,"NOTHING_TO_TERMINATE",null," A process being terminated has no threads to terminate.",null,false],[0,0,0,"PROCESS_NOT_IN_JOB",null," The specified process is not part of a job.",null,false],[0,0,0,"PROCESS_IN_JOB",null," The specified process is part of a job.",null,false],[0,0,0,"VOLSNAP_HIBERNATE_READY",null," {Volume Shadow Copy Service} The system is now ready for hibernation.",null,false],[0,0,0,"FSFILTER_OP_COMPLETED_SUCCESSFULLY",null," A file system or file system filter driver has successfully completed an FsFilter operation.",null,false],[0,0,0,"INTERRUPT_VECTOR_ALREADY_CONNECTED",null," The specified interrupt vector was already connected.",null,false],[0,0,0,"INTERRUPT_STILL_CONNECTED",null," The specified interrupt vector is still connected.",null,false],[0,0,0,"WAIT_FOR_OPLOCK",null," An operation is blocked waiting for an oplock.",null,false],[0,0,0,"DBG_EXCEPTION_HANDLED",null," Debugger handled exception.",null,false],[0,0,0,"DBG_CONTINUE",null," Debugger continued.",null,false],[0,0,0,"CALLBACK_POP_STACK",null," An exception occurred in a user mode callback and the kernel callback frame should be removed.",null,false],[0,0,0,"COMPRESSION_DISABLED",null," Compression is disabled for this volume.",null,false],[0,0,0,"CANTFETCHBACKWARDS",null," The data provider cannot fetch backwards through a result set.",null,false],[0,0,0,"CANTSCROLLBACKWARDS",null," The data provider cannot scroll backwards through a result set.",null,false],[0,0,0,"ROWSNOTRELEASED",null," The data provider requires that previously fetched data is released before asking for more data.",null,false],[0,0,0,"BAD_ACCESSOR_FLAGS",null," The data provider was not able to interpret the flags set for a column binding in an accessor.",null,false],[0,0,0,"ERRORS_ENCOUNTERED",null," One or more errors occurred while processing the request.",null,false],[0,0,0,"NOT_CAPABLE",null," The implementation is not capable of performing the request.",null,false],[0,0,0,"REQUEST_OUT_OF_SEQUENCE",null," The client of a component requested an operation which is not valid given the state of the component instance.",null,false],[0,0,0,"VERSION_PARSE_ERROR",null," A version number could not be parsed.",null,false],[0,0,0,"BADSTARTPOSITION",null," The iterator's start position is invalid.",null,false],[0,0,0,"MEMORY_HARDWARE",null," The hardware has reported an uncorrectable memory error.",null,false],[0,0,0,"DISK_REPAIR_DISABLED",null," The attempted operation required self healing to be enabled.",null,false],[0,0,0,"INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE",null," The Desktop heap encountered an error while allocating session memory.\n There is more information in the system event log.",null,false],[0,0,0,"SYSTEM_POWERSTATE_TRANSITION",null," The system power state is transitioning from %2 to %3.",null,false],[0,0,0,"SYSTEM_POWERSTATE_COMPLEX_TRANSITION",null," The system power state is transitioning from %2 to %3 but could enter %4.",null,false],[0,0,0,"MCA_EXCEPTION",null," A thread is getting dispatched with MCA EXCEPTION because of MCA.",null,false],[0,0,0,"ACCESS_AUDIT_BY_POLICY",null," Access to %1 is monitored by policy rule %2.",null,false],[0,0,0,"ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY",null," Access to %1 has been restricted by your Administrator by policy rule %2.",null,false],[0,0,0,"ABANDON_HIBERFILE",null," A valid hibernation file has been invalidated and should be abandoned.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost.\n This error may be caused by network connectivity issues. Please try to save this file elsewhere.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost.\n This error was returned by the server on which the file exists. Please try to save this file elsewhere.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost.\n This error may be caused if the device has been removed or the media is write-protected.",null,false],[0,0,0,"BAD_MCFG_TABLE",null," The resources required for this device conflict with the MCFG table.",null,false],[0,0,0,"DISK_REPAIR_REDIRECTED",null," The volume repair could not be performed while it is online.\n Please schedule to take the volume offline so that it can be repaired.",null,false],[0,0,0,"DISK_REPAIR_UNSUCCESSFUL",null," The volume repair was not successful.",null,false],[0,0,0,"CORRUPT_LOG_OVERFULL",null," One of the volume corruption logs is full.\n Further corruptions that may be detected won't be logged.",null,false],[0,0,0,"CORRUPT_LOG_CORRUPTED",null," One of the volume corruption logs is internally corrupted and needs to be recreated.\n The volume may contain undetected corruptions and must be scanned.",null,false],[0,0,0,"CORRUPT_LOG_UNAVAILABLE",null," One of the volume corruption logs is unavailable for being operated on.",null,false],[0,0,0,"CORRUPT_LOG_DELETED_FULL",null," One of the volume corruption logs was deleted while still having corruption records in them.\n The volume contains detected corruptions and must be scanned.",null,false],[0,0,0,"CORRUPT_LOG_CLEARED",null," One of the volume corruption logs was cleared by chkdsk and no longer contains real corruptions.",null,false],[0,0,0,"ORPHAN_NAME_EXHAUSTED",null," Orphaned files exist on the volume but could not be recovered because no more new names could be created in the recovery directory. Files must be moved from the recovery directory.",null,false],[0,0,0,"OPLOCK_SWITCHED_TO_NEW_HANDLE",null," The oplock that was associated with this handle is now associated with a different handle.",null,false],[0,0,0,"CANNOT_GRANT_REQUESTED_OPLOCK",null," An oplock of the requested level cannot be granted. An oplock of a lower level may be available.",null,false],[0,0,0,"CANNOT_BREAK_OPLOCK",null," The operation did not complete successfully because it would cause an oplock to be broken.\n The caller has requested that existing oplocks not be broken.",null,false],[0,0,0,"OPLOCK_HANDLE_CLOSED",null," The handle with which this oplock was associated has been closed. The oplock is now broken.",null,false],[0,0,0,"NO_ACE_CONDITION",null," The specified access control entry (ACE) does not contain a condition.",null,false],[0,0,0,"INVALID_ACE_CONDITION",null," The specified access control entry (ACE) contains an invalid condition.",null,false],[0,0,0,"FILE_HANDLE_REVOKED",null," Access to the specified file handle has been revoked.",null,false],[0,0,0,"IMAGE_AT_DIFFERENT_BASE",null," An image file was mapped at a different address from the one specified in the image file but fixups will still be automatically performed on the image.",null,false],[0,0,0,"EA_ACCESS_DENIED",null," Access to the extended attribute was denied.",null,false],[0,0,0,"OPERATION_ABORTED",null," The I/O operation has been aborted because of either a thread exit or an application request.",null,false],[0,0,0,"IO_INCOMPLETE",null," Overlapped I/O event is not in a signaled state.",null,false],[0,0,0,"IO_PENDING",null," Overlapped I/O operation is in progress.",null,false],[0,0,0,"NOACCESS",null," Invalid access to memory location.",null,false],[0,0,0,"SWAPERROR",null," Error performing inpage operation.",null,false],[0,0,0,"STACK_OVERFLOW",null," Recursion too deep; the stack overflowed.",null,false],[0,0,0,"INVALID_MESSAGE",null," The window cannot act on the sent message.",null,false],[0,0,0,"CAN_NOT_COMPLETE",null," Cannot complete this function.",null,false],[0,0,0,"INVALID_FLAGS",null," Invalid flags.",null,false],[0,0,0,"UNRECOGNIZED_VOLUME",null," The volume does not contain a recognized file system.\n Please make sure that all required file system drivers are loaded and that the volume is not corrupted.",null,false],[0,0,0,"FILE_INVALID",null," The volume for a file has been externally altered so that the opened file is no longer valid.",null,false],[0,0,0,"FULLSCREEN_MODE",null," The requested operation cannot be performed in full-screen mode.",null,false],[0,0,0,"NO_TOKEN",null," An attempt was made to reference a token that does not exist.",null,false],[0,0,0,"BADDB",null," The configuration registry database is corrupt.",null,false],[0,0,0,"BADKEY",null," The configuration registry key is invalid.",null,false],[0,0,0,"CANTOPEN",null," The configuration registry key could not be opened.",null,false],[0,0,0,"CANTREAD",null," The configuration registry key could not be read.",null,false],[0,0,0,"CANTWRITE",null," The configuration registry key could not be written.",null,false],[0,0,0,"REGISTRY_RECOVERED",null," One of the files in the registry database had to be recovered by use of a log or alternate copy. The recovery was successful.",null,false],[0,0,0,"REGISTRY_CORRUPT",null," The registry is corrupted. The structure of one of the files containing registry data is corrupted, or the system's memory image of the file is corrupted, or the file could not be recovered because the alternate copy or log was absent or corrupted.",null,false],[0,0,0,"REGISTRY_IO_FAILED",null," An I/O operation initiated by the registry failed unrecoverably.\n The registry could not read in, or write out, or flush, one of the files that contain the system's image of the registry.",null,false],[0,0,0,"NOT_REGISTRY_FILE",null," The system has attempted to load or restore a file into the registry, but the specified file is not in a registry file format.",null,false],[0,0,0,"KEY_DELETED",null," Illegal operation attempted on a registry key that has been marked for deletion.",null,false],[0,0,0,"NO_LOG_SPACE",null," System could not allocate the required space in a registry log.",null,false],[0,0,0,"KEY_HAS_CHILDREN",null," Cannot create a symbolic link in a registry key that already has subkeys or values.",null,false],[0,0,0,"CHILD_MUST_BE_VOLATILE",null," Cannot create a stable subkey under a volatile parent key.",null,false],[0,0,0,"NOTIFY_ENUM_DIR",null," A notify change request is being completed and the information is not being returned in the caller's buffer.\n The caller now needs to enumerate the files to find the changes.",null,false],[0,0,0,"DEPENDENT_SERVICES_RUNNING",null," A stop control has been sent to a service that other running services are dependent on.",null,false],[0,0,0,"INVALID_SERVICE_CONTROL",null," The requested control is not valid for this service.",null,false],[0,0,0,"SERVICE_REQUEST_TIMEOUT",null," The service did not respond to the start or control request in a timely fashion.",null,false],[0,0,0,"SERVICE_NO_THREAD",null," A thread could not be created for the service.",null,false],[0,0,0,"SERVICE_DATABASE_LOCKED",null," The service database is locked.",null,false],[0,0,0,"SERVICE_ALREADY_RUNNING",null," An instance of the service is already running.",null,false],[0,0,0,"INVALID_SERVICE_ACCOUNT",null," The account name is invalid or does not exist, or the password is invalid for the account name specified.",null,false],[0,0,0,"SERVICE_DISABLED",null," The service cannot be started, either because it is disabled or because it has no enabled devices associated with it.",null,false],[0,0,0,"CIRCULAR_DEPENDENCY",null," Circular service dependency was specified.",null,false],[0,0,0,"SERVICE_DOES_NOT_EXIST",null," The specified service does not exist as an installed service.",null,false],[0,0,0,"SERVICE_CANNOT_ACCEPT_CTRL",null," The service cannot accept control messages at this time.",null,false],[0,0,0,"SERVICE_NOT_ACTIVE",null," The service has not been started.",null,false],[0,0,0,"FAILED_SERVICE_CONTROLLER_CONNECT",null," The service process could not connect to the service controller.",null,false],[0,0,0,"EXCEPTION_IN_SERVICE",null," An exception occurred in the service when handling the control request.",null,false],[0,0,0,"DATABASE_DOES_NOT_EXIST",null," The database specified does not exist.",null,false],[0,0,0,"SERVICE_SPECIFIC_ERROR",null," The service has returned a service-specific error code.",null,false],[0,0,0,"PROCESS_ABORTED",null," The process terminated unexpectedly.",null,false],[0,0,0,"SERVICE_DEPENDENCY_FAIL",null," The dependency service or group failed to start.",null,false],[0,0,0,"SERVICE_LOGON_FAILED",null," The service did not start due to a logon failure.",null,false],[0,0,0,"SERVICE_START_HANG",null," After starting, the service hung in a start-pending state.",null,false],[0,0,0,"INVALID_SERVICE_LOCK",null," The specified service database lock is invalid.",null,false],[0,0,0,"SERVICE_MARKED_FOR_DELETE",null," The specified service has been marked for deletion.",null,false],[0,0,0,"SERVICE_EXISTS",null," The specified service already exists.",null,false],[0,0,0,"ALREADY_RUNNING_LKG",null," The system is currently running with the last-known-good configuration.",null,false],[0,0,0,"SERVICE_DEPENDENCY_DELETED",null," The dependency service does not exist or has been marked for deletion.",null,false],[0,0,0,"BOOT_ALREADY_ACCEPTED",null," The current boot has already been accepted for use as the last-known-good control set.",null,false],[0,0,0,"SERVICE_NEVER_STARTED",null," No attempts to start the service have been made since the last boot.",null,false],[0,0,0,"DUPLICATE_SERVICE_NAME",null," The name is already in use as either a service name or a service display name.",null,false],[0,0,0,"DIFFERENT_SERVICE_ACCOUNT",null," The account specified for this service is different from the account specified for other services running in the same process.",null,false],[0,0,0,"CANNOT_DETECT_DRIVER_FAILURE",null," Failure actions can only be set for Win32 services, not for drivers.",null,false],[0,0,0,"CANNOT_DETECT_PROCESS_ABORT",null," This service runs in the same process as the service control manager.\n Therefore, the service control manager cannot take action if this service's process terminates unexpectedly.",null,false],[0,0,0,"NO_RECOVERY_PROGRAM",null," No recovery program has been configured for this service.",null,false],[0,0,0,"SERVICE_NOT_IN_EXE",null," The executable program that this service is configured to run in does not implement the service.",null,false],[0,0,0,"NOT_SAFEBOOT_SERVICE",null," This service cannot be started in Safe Mode.",null,false],[0,0,0,"END_OF_MEDIA",null," The physical end of the tape has been reached.",null,false],[0,0,0,"FILEMARK_DETECTED",null," A tape access reached a filemark.",null,false],[0,0,0,"BEGINNING_OF_MEDIA",null," The beginning of the tape or a partition was encountered.",null,false],[0,0,0,"SETMARK_DETECTED",null," A tape access reached the end of a set of files.",null,false],[0,0,0,"NO_DATA_DETECTED",null," No more data is on the tape.",null,false],[0,0,0,"PARTITION_FAILURE",null," Tape could not be partitioned.",null,false],[0,0,0,"INVALID_BLOCK_LENGTH",null," When accessing a new tape of a multivolume partition, the current block size is incorrect.",null,false],[0,0,0,"DEVICE_NOT_PARTITIONED",null," Tape partition information could not be found when loading a tape.",null,false],[0,0,0,"UNABLE_TO_LOCK_MEDIA",null," Unable to lock the media eject mechanism.",null,false],[0,0,0,"UNABLE_TO_UNLOAD_MEDIA",null," Unable to unload the media.",null,false],[0,0,0,"MEDIA_CHANGED",null," The media in the drive may have changed.",null,false],[0,0,0,"BUS_RESET",null," The I/O bus was reset.",null,false],[0,0,0,"NO_MEDIA_IN_DRIVE",null," No media in drive.",null,false],[0,0,0,"NO_UNICODE_TRANSLATION",null," No mapping for the Unicode character exists in the target multi-byte code page.",null,false],[0,0,0,"DLL_INIT_FAILED",null," A dynamic link library (DLL) initialization routine failed.",null,false],[0,0,0,"SHUTDOWN_IN_PROGRESS",null," A system shutdown is in progress.",null,false],[0,0,0,"NO_SHUTDOWN_IN_PROGRESS",null," Unable to abort the system shutdown because no shutdown was in progress.",null,false],[0,0,0,"IO_DEVICE",null," The request could not be performed because of an I/O device error.",null,false],[0,0,0,"SERIAL_NO_DEVICE",null," No serial device was successfully initialized. The serial driver will unload.",null,false],[0,0,0,"IRQ_BUSY",null," Unable to open a device that was sharing an interrupt request (IRQ) with other devices.\n At least one other device that uses that IRQ was already opened.",null,false],[0,0,0,"MORE_WRITES",null," A serial I/O operation was completed by another write to the serial port. The IOCTL_SERIAL_XOFF_COUNTER reached zero.)",null,false],[0,0,0,"COUNTER_TIMEOUT",null," A serial I/O operation completed because the timeout period expired.\n The IOCTL_SERIAL_XOFF_COUNTER did not reach zero.)",null,false],[0,0,0,"FLOPPY_ID_MARK_NOT_FOUND",null," No ID address mark was found on the floppy disk.",null,false],[0,0,0,"FLOPPY_WRONG_CYLINDER",null," Mismatch between the floppy disk sector ID field and the floppy disk controller track address.",null,false],[0,0,0,"FLOPPY_UNKNOWN_ERROR",null," The floppy disk controller reported an error that is not recognized by the floppy disk driver.",null,false],[0,0,0,"FLOPPY_BAD_REGISTERS",null," The floppy disk controller returned inconsistent results in its registers.",null,false],[0,0,0,"DISK_RECALIBRATE_FAILED",null," While accessing the hard disk, a recalibrate operation failed, even after retries.",null,false],[0,0,0,"DISK_OPERATION_FAILED",null," While accessing the hard disk, a disk operation failed even after retries.",null,false],[0,0,0,"DISK_RESET_FAILED",null," While accessing the hard disk, a disk controller reset was needed, but even that failed.",null,false],[0,0,0,"EOM_OVERFLOW",null," Physical end of tape encountered.",null,false],[0,0,0,"NOT_ENOUGH_SERVER_MEMORY",null," Not enough server storage is available to process this command.",null,false],[0,0,0,"POSSIBLE_DEADLOCK",null," A potential deadlock condition has been detected.",null,false],[0,0,0,"MAPPED_ALIGNMENT",null," The base address or the file offset specified does not have the proper alignment.",null,false],[0,0,0,"SET_POWER_STATE_VETOED",null," An attempt to change the system power state was vetoed by another application or driver.",null,false],[0,0,0,"SET_POWER_STATE_FAILED",null," The system BIOS failed an attempt to change the system power state.",null,false],[0,0,0,"TOO_MANY_LINKS",null," An attempt was made to create more links on a file than the file system supports.",null,false],[0,0,0,"OLD_WIN_VERSION",null," The specified program requires a newer version of Windows.",null,false],[0,0,0,"APP_WRONG_OS",null," The specified program is not a Windows or MS-DOS program.",null,false],[0,0,0,"SINGLE_INSTANCE_APP",null," Cannot start more than one instance of the specified program.",null,false],[0,0,0,"RMODE_APP",null," The specified program was written for an earlier version of Windows.",null,false],[0,0,0,"INVALID_DLL",null," One of the library files needed to run this application is damaged.",null,false],[0,0,0,"NO_ASSOCIATION",null," No application is associated with the specified file for this operation.",null,false],[0,0,0,"DDE_FAIL",null," An error occurred in sending the command to the application.",null,false],[0,0,0,"DLL_NOT_FOUND",null," One of the library files needed to run this application cannot be found.",null,false],[0,0,0,"NO_MORE_USER_HANDLES",null," The current process has used all of its system allowance of handles for Window Manager objects.",null,false],[0,0,0,"MESSAGE_SYNC_ONLY",null," The message can be used only with synchronous operations.",null,false],[0,0,0,"SOURCE_ELEMENT_EMPTY",null," The indicated source element has no media.",null,false],[0,0,0,"DESTINATION_ELEMENT_FULL",null," The indicated destination element already contains media.",null,false],[0,0,0,"ILLEGAL_ELEMENT_ADDRESS",null," The indicated element does not exist.",null,false],[0,0,0,"MAGAZINE_NOT_PRESENT",null," The indicated element is part of a magazine that is not present.",null,false],[0,0,0,"DEVICE_REINITIALIZATION_NEEDED",null," The indicated device requires reinitialization due to hardware errors.",null,false],[0,0,0,"DEVICE_REQUIRES_CLEANING",null," The device has indicated that cleaning is required before further operations are attempted.",null,false],[0,0,0,"DEVICE_DOOR_OPEN",null," The device has indicated that its door is open.",null,false],[0,0,0,"DEVICE_NOT_CONNECTED",null," The device is not connected.",null,false],[0,0,0,"NOT_FOUND",null," Element not found.",null,false],[0,0,0,"NO_MATCH",null," There was no match for the specified key in the index.",null,false],[0,0,0,"SET_NOT_FOUND",null," The property set specified does not exist on the object.",null,false],[0,0,0,"POINT_NOT_FOUND",null," The point passed to GetMouseMovePoints is not in the buffer.",null,false],[0,0,0,"NO_TRACKING_SERVICE",null," The tracking (workstation) service is not running.",null,false],[0,0,0,"NO_VOLUME_ID",null," The Volume ID could not be found.",null,false],[0,0,0,"UNABLE_TO_REMOVE_REPLACED",null," Unable to remove the file to be replaced.",null,false],[0,0,0,"UNABLE_TO_MOVE_REPLACEMENT",null," Unable to move the replacement file to the file to be replaced.\n The file to be replaced has retained its original name.",null,false],[0,0,0,"UNABLE_TO_MOVE_REPLACEMENT_2",null," Unable to move the replacement file to the file to be replaced.\n The file to be replaced has been renamed using the backup name.",null,false],[0,0,0,"JOURNAL_DELETE_IN_PROGRESS",null," The volume change journal is being deleted.",null,false],[0,0,0,"JOURNAL_NOT_ACTIVE",null," The volume change journal is not active.",null,false],[0,0,0,"POTENTIAL_FILE_FOUND",null," A file was found, but it may not be the correct file.",null,false],[0,0,0,"JOURNAL_ENTRY_DELETED",null," The journal entry has been deleted from the journal.",null,false],[0,0,0,"SHUTDOWN_IS_SCHEDULED",null," A system shutdown has already been scheduled.",null,false],[0,0,0,"SHUTDOWN_USERS_LOGGED_ON",null," The system shutdown cannot be initiated because there are other users logged on to the computer.",null,false],[0,0,0,"BAD_DEVICE",null," The specified device name is invalid.",null,false],[0,0,0,"CONNECTION_UNAVAIL",null," The device is not currently connected but it is a remembered connection.",null,false],[0,0,0,"DEVICE_ALREADY_REMEMBERED",null," The local device name has a remembered connection to another network resource.",null,false],[0,0,0,"NO_NET_OR_BAD_PATH",null," The network path was either typed incorrectly, does not exist, or the network provider is not currently available.\n Please try retyping the path or contact your network administrator.",null,false],[0,0,0,"BAD_PROVIDER",null," The specified network provider name is invalid.",null,false],[0,0,0,"CANNOT_OPEN_PROFILE",null," Unable to open the network connection profile.",null,false],[0,0,0,"BAD_PROFILE",null," The network connection profile is corrupted.",null,false],[0,0,0,"NOT_CONTAINER",null," Cannot enumerate a noncontainer.",null,false],[0,0,0,"EXTENDED_ERROR",null," An extended error has occurred.",null,false],[0,0,0,"INVALID_GROUPNAME",null," The format of the specified group name is invalid.",null,false],[0,0,0,"INVALID_COMPUTERNAME",null," The format of the specified computer name is invalid.",null,false],[0,0,0,"INVALID_EVENTNAME",null," The format of the specified event name is invalid.",null,false],[0,0,0,"INVALID_DOMAINNAME",null," The format of the specified domain name is invalid.",null,false],[0,0,0,"INVALID_SERVICENAME",null," The format of the specified service name is invalid.",null,false],[0,0,0,"INVALID_NETNAME",null," The format of the specified network name is invalid.",null,false],[0,0,0,"INVALID_SHARENAME",null," The format of the specified share name is invalid.",null,false],[0,0,0,"INVALID_PASSWORDNAME",null," The format of the specified password is invalid.",null,false],[0,0,0,"INVALID_MESSAGENAME",null," The format of the specified message name is invalid.",null,false],[0,0,0,"INVALID_MESSAGEDEST",null," The format of the specified message destination is invalid.",null,false],[0,0,0,"SESSION_CREDENTIAL_CONFLICT",null," Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed.\n Disconnect all previous connections to the server or shared resource and try again.",null,false],[0,0,0,"REMOTE_SESSION_LIMIT_EXCEEDED",null," An attempt was made to establish a session to a network server, but there are already too many sessions established to that server.",null,false],[0,0,0,"DUP_DOMAINNAME",null," The workgroup or domain name is already in use by another computer on the network.",null,false],[0,0,0,"NO_NETWORK",null," The network is not present or not started.",null,false],[0,0,0,"CANCELLED",null," The operation was canceled by the user.",null,false],[0,0,0,"USER_MAPPED_FILE",null," The requested operation cannot be performed on a file with a user-mapped section open.",null,false],[0,0,0,"CONNECTION_REFUSED",null," The remote computer refused the network connection.",null,false],[0,0,0,"GRACEFUL_DISCONNECT",null," The network connection was gracefully closed.",null,false],[0,0,0,"ADDRESS_ALREADY_ASSOCIATED",null," The network transport endpoint already has an address associated with it.",null,false],[0,0,0,"ADDRESS_NOT_ASSOCIATED",null," An address has not yet been associated with the network endpoint.",null,false],[0,0,0,"CONNECTION_INVALID",null," An operation was attempted on a nonexistent network connection.",null,false],[0,0,0,"CONNECTION_ACTIVE",null," An invalid operation was attempted on an active network connection.",null,false],[0,0,0,"NETWORK_UNREACHABLE",null," The network location cannot be reached.\n For information about network troubleshooting, see Windows Help.",null,false],[0,0,0,"HOST_UNREACHABLE",null," The network location cannot be reached.\n For information about network troubleshooting, see Windows Help.",null,false],[0,0,0,"PROTOCOL_UNREACHABLE",null," The network location cannot be reached.\n For information about network troubleshooting, see Windows Help.",null,false],[0,0,0,"PORT_UNREACHABLE",null," No service is operating at the destination network endpoint on the remote system.",null,false],[0,0,0,"REQUEST_ABORTED",null," The request was aborted.",null,false],[0,0,0,"CONNECTION_ABORTED",null," The network connection was aborted by the local system.",null,false],[0,0,0,"RETRY",null," The operation could not be completed. A retry should be performed.",null,false],[0,0,0,"CONNECTION_COUNT_LIMIT",null," A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached.",null,false],[0,0,0,"LOGIN_TIME_RESTRICTION",null," Attempting to log in during an unauthorized time of day for this account.",null,false],[0,0,0,"LOGIN_WKSTA_RESTRICTION",null," The account is not authorized to log in from this station.",null,false],[0,0,0,"INCORRECT_ADDRESS",null," The network address could not be used for the operation requested.",null,false],[0,0,0,"ALREADY_REGISTERED",null," The service is already registered.",null,false],[0,0,0,"SERVICE_NOT_FOUND",null," The specified service does not exist.",null,false],[0,0,0,"NOT_AUTHENTICATED",null," The operation being requested was not performed because the user has not been authenticated.",null,false],[0,0,0,"NOT_LOGGED_ON",null," The operation being requested was not performed because the user has not logged on to the network. The specified service does not exist.",null,false],[0,0,0,"CONTINUE",null," Continue with work in progress.",null,false],[0,0,0,"ALREADY_INITIALIZED",null," An attempt was made to perform an initialization operation when initialization has already been completed.",null,false],[0,0,0,"NO_MORE_DEVICES",null," No more local devices.",null,false],[0,0,0,"NO_SUCH_SITE",null," The specified site does not exist.",null,false],[0,0,0,"DOMAIN_CONTROLLER_EXISTS",null," A domain controller with the specified name already exists.",null,false],[0,0,0,"ONLY_IF_CONNECTED",null," This operation is supported only when you are connected to the server.",null,false],[0,0,0,"OVERRIDE_NOCHANGES",null," The group policy framework should call the extension even if there are no changes.",null,false],[0,0,0,"BAD_USER_PROFILE",null," The specified user does not have a valid profile.",null,false],[0,0,0,"NOT_SUPPORTED_ON_SBS",null," This operation is not supported on a computer running Windows Server 2003 for Small Business Server.",null,false],[0,0,0,"SERVER_SHUTDOWN_IN_PROGRESS",null," The server machine is shutting down.",null,false],[0,0,0,"HOST_DOWN",null," The remote system is not available.\n For information about network troubleshooting, see Windows Help.",null,false],[0,0,0,"NON_ACCOUNT_SID",null," The security identifier provided is not from an account domain.",null,false],[0,0,0,"NON_DOMAIN_SID",null," The security identifier provided does not have a domain component.",null,false],[0,0,0,"APPHELP_BLOCK",null," AppHelp dialog canceled thus preventing the application from starting.",null,false],[0,0,0,"ACCESS_DISABLED_BY_POLICY",null," This program is blocked by group policy.\n For more information, contact your system administrator.",null,false],[0,0,0,"REG_NAT_CONSUMPTION",null," A program attempt to use an invalid register value.\n Normally caused by an uninitialized register. This error is Itanium specific.",null,false],[0,0,0,"CSCSHARE_OFFLINE",null," The share is currently offline or does not exist.",null,false],[0,0,0,"PKINIT_FAILURE",null," The Kerberos protocol encountered an error while validating the KDC certificate during smartcard logon.\n There is more information in the system event log.",null,false],[0,0,0,"SMARTCARD_SUBSYSTEM_FAILURE",null," The Kerberos protocol encountered an error while attempting to utilize the smartcard subsystem.",null,false],[0,0,0,"DOWNGRADE_DETECTED",null," The system cannot contact a domain controller to service the authentication request. Please try again later.",null,false],[0,0,0,"MACHINE_LOCKED",null," The machine is locked and cannot be shut down without the force option.",null,false],[0,0,0,"CALLBACK_SUPPLIED_INVALID_DATA",null," An application-defined callback gave invalid data when called.",null,false],[0,0,0,"SYNC_FOREGROUND_REFRESH_REQUIRED",null," The group policy framework should call the extension in the synchronous foreground policy refresh.",null,false],[0,0,0,"DRIVER_BLOCKED",null," This driver has been blocked from loading.",null,false],[0,0,0,"INVALID_IMPORT_OF_NON_DLL",null," A dynamic link library (DLL) referenced a module that was neither a DLL nor the process's executable image.",null,false],[0,0,0,"ACCESS_DISABLED_WEBBLADE",null," Windows cannot open this program since it has been disabled.",null,false],[0,0,0,"ACCESS_DISABLED_WEBBLADE_TAMPER",null," Windows cannot open this program because the license enforcement system has been tampered with or become corrupted.",null,false],[0,0,0,"RECOVERY_FAILURE",null," A transaction recover failed.",null,false],[0,0,0,"ALREADY_FIBER",null," The current thread has already been converted to a fiber.",null,false],[0,0,0,"ALREADY_THREAD",null," The current thread has already been converted from a fiber.",null,false],[0,0,0,"STACK_BUFFER_OVERRUN",null," The system detected an overrun of a stack-based buffer in this application.\n This overrun could potentially allow a malicious user to gain control of this application.",null,false],[0,0,0,"PARAMETER_QUOTA_EXCEEDED",null," Data present in one of the parameters is more than the function can operate on.",null,false],[0,0,0,"DEBUGGER_INACTIVE",null," An attempt to do an operation on a debug object failed because the object is in the process of being deleted.",null,false],[0,0,0,"DELAY_LOAD_FAILED",null," An attempt to delay-load a .dll or get a function address in a delay-loaded .dll failed.",null,false],[0,0,0,"VDM_DISALLOWED",null," %1 is a 16-bit application. You do not have permissions to execute 16-bit applications.\n Check your permissions with your system administrator.",null,false],[0,0,0,"UNIDENTIFIED_ERROR",null," Insufficient information exists to identify the cause of failure.",null,false],[0,0,0,"INVALID_CRUNTIME_PARAMETER",null," The parameter passed to a C runtime function is incorrect.",null,false],[0,0,0,"BEYOND_VDL",null," The operation occurred beyond the valid data length of the file.",null,false],[0,0,0,"INCOMPATIBLE_SERVICE_SID_TYPE",null," The service start failed since one or more services in the same process have an incompatible service SID type setting.\n A service with restricted service SID type can only coexist in the same process with other services with a restricted SID type.\n If the service SID type for this service was just configured, the hosting process must be restarted in order to start this service.\n On Windows Server 2003 and Windows XP, an unrestricted service cannot coexist in the same process with other services.\n The service with the unrestricted service SID type must be moved to an owned process in order to start this service.",null,false],[0,0,0,"DRIVER_PROCESS_TERMINATED",null," The process hosting the driver for this device has been terminated.",null,false],[0,0,0,"IMPLEMENTATION_LIMIT",null," An operation attempted to exceed an implementation-defined limit.",null,false],[0,0,0,"PROCESS_IS_PROTECTED",null," Either the target process, or the target thread's containing process, is a protected process.",null,false],[0,0,0,"SERVICE_NOTIFY_CLIENT_LAGGING",null," The service notification client is lagging too far behind the current state of services in the machine.",null,false],[0,0,0,"DISK_QUOTA_EXCEEDED",null," The requested file operation failed because the storage quota was exceeded.\n To free up disk space, move files to a different location or delete unnecessary files.\n For more information, contact your system administrator.",null,false],[0,0,0,"CONTENT_BLOCKED",null," The requested file operation failed because the storage policy blocks that type of file.\n For more information, contact your system administrator.",null,false],[0,0,0,"INCOMPATIBLE_SERVICE_PRIVILEGE",null," A privilege that the service requires to function properly does not exist in the service account configuration.\n You may use the Services Microsoft Management Console (MMC) snap-in (services.msc) and the Local Security Settings MMC snap-in (secpol.msc) to view the service configuration and the account configuration.",null,false],[0,0,0,"APP_HANG",null," A thread involved in this operation appears to be unresponsive.",null,false],[0,0,0,"INVALID_LABEL",null," Indicates a particular Security ID may not be assigned as the label of an object.",null,false],[0,0,0,"NOT_ALL_ASSIGNED",null," Not all privileges or groups referenced are assigned to the caller.",null,false],[0,0,0,"SOME_NOT_MAPPED",null," Some mapping between account names and security IDs was not done.",null,false],[0,0,0,"NO_QUOTAS_FOR_ACCOUNT",null," No system quota limits are specifically set for this account.",null,false],[0,0,0,"LOCAL_USER_SESSION_KEY",null," No encryption key is available. A well-known encryption key was returned.",null,false],[0,0,0,"NULL_LM_PASSWORD",null," The password is too complex to be converted to a LAN Manager password.\n The LAN Manager password returned is a NULL string.",null,false],[0,0,0,"UNKNOWN_REVISION",null," The revision level is unknown.",null,false],[0,0,0,"REVISION_MISMATCH",null," Indicates two revision levels are incompatible.",null,false],[0,0,0,"INVALID_OWNER",null," This security ID may not be assigned as the owner of this object.",null,false],[0,0,0,"INVALID_PRIMARY_GROUP",null," This security ID may not be assigned as the primary group of an object.",null,false],[0,0,0,"NO_IMPERSONATION_TOKEN",null," An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client.",null,false],[0,0,0,"CANT_DISABLE_MANDATORY",null," The group may not be disabled.",null,false],[0,0,0,"NO_LOGON_SERVERS",null," There are currently no logon servers available to service the logon request.",null,false],[0,0,0,"NO_SUCH_LOGON_SESSION",null," A specified logon session does not exist. It may already have been terminated.",null,false],[0,0,0,"NO_SUCH_PRIVILEGE",null," A specified privilege does not exist.",null,false],[0,0,0,"PRIVILEGE_NOT_HELD",null," A required privilege is not held by the client.",null,false],[0,0,0,"INVALID_ACCOUNT_NAME",null," The name provided is not a properly formed account name.",null,false],[0,0,0,"USER_EXISTS",null," The specified account already exists.",null,false],[0,0,0,"NO_SUCH_USER",null," The specified account does not exist.",null,false],[0,0,0,"GROUP_EXISTS",null," The specified group already exists.",null,false],[0,0,0,"NO_SUCH_GROUP",null," The specified group does not exist.",null,false],[0,0,0,"MEMBER_IN_GROUP",null," Either the specified user account is already a member of the specified group, or the specified group cannot be deleted because it contains a member.",null,false],[0,0,0,"MEMBER_NOT_IN_GROUP",null," The specified user account is not a member of the specified group account.",null,false],[0,0,0,"LAST_ADMIN",null," This operation is disallowed as it could result in an administration account being disabled, deleted or unable to log on.",null,false],[0,0,0,"WRONG_PASSWORD",null," Unable to update the password. The value provided as the current password is incorrect.",null,false],[0,0,0,"ILL_FORMED_PASSWORD",null," Unable to update the password. The value provided for the new password contains values that are not allowed in passwords.",null,false],[0,0,0,"PASSWORD_RESTRICTION",null," Unable to update the password. The value provided for the new password does not meet the length, complexity, or history requirements of the domain.",null,false],[0,0,0,"LOGON_FAILURE",null," The user name or password is incorrect.",null,false],[0,0,0,"ACCOUNT_RESTRICTION",null," Account restrictions are preventing this user from signing in.\n For example: blank passwords aren't allowed, sign-in times are limited, or a policy restriction has been enforced.",null,false],[0,0,0,"INVALID_LOGON_HOURS",null," Your account has time restrictions that keep you from signing in right now.",null,false],[0,0,0,"INVALID_WORKSTATION",null," This user isn't allowed to sign in to this computer.",null,false],[0,0,0,"PASSWORD_EXPIRED",null," The password for this account has expired.",null,false],[0,0,0,"ACCOUNT_DISABLED",null," This user can't sign in because this account is currently disabled.",null,false],[0,0,0,"NONE_MAPPED",null," No mapping between account names and security IDs was done.",null,false],[0,0,0,"TOO_MANY_LUIDS_REQUESTED",null," Too many local user identifiers (LUIDs) were requested at one time.",null,false],[0,0,0,"LUIDS_EXHAUSTED",null," No more local user identifiers (LUIDs) are available.",null,false],[0,0,0,"INVALID_SUB_AUTHORITY",null," The subauthority part of a security ID is invalid for this particular use.",null,false],[0,0,0,"INVALID_ACL",null," The access control list (ACL) structure is invalid.",null,false],[0,0,0,"INVALID_SID",null," The security ID structure is invalid.",null,false],[0,0,0,"INVALID_SECURITY_DESCR",null," The security descriptor structure is invalid.",null,false],[0,0,0,"BAD_INHERITANCE_ACL",null," The inherited access control list (ACL) or access control entry (ACE) could not be built.",null,false],[0,0,0,"SERVER_DISABLED",null," The server is currently disabled.",null,false],[0,0,0,"SERVER_NOT_DISABLED",null," The server is currently enabled.",null,false],[0,0,0,"INVALID_ID_AUTHORITY",null," The value provided was an invalid value for an identifier authority.",null,false],[0,0,0,"ALLOTTED_SPACE_EXCEEDED",null," No more memory is available for security information updates.",null,false],[0,0,0,"INVALID_GROUP_ATTRIBUTES",null," The specified attributes are invalid, or incompatible with the attributes for the group as a whole.",null,false],[0,0,0,"BAD_IMPERSONATION_LEVEL",null," Either a required impersonation level was not provided, or the provided impersonation level is invalid.",null,false],[0,0,0,"CANT_OPEN_ANONYMOUS",null," Cannot open an anonymous level security token.",null,false],[0,0,0,"BAD_VALIDATION_CLASS",null," The validation information class requested was invalid.",null,false],[0,0,0,"BAD_TOKEN_TYPE",null," The type of the token is inappropriate for its attempted use.",null,false],[0,0,0,"NO_SECURITY_ON_OBJECT",null," Unable to perform a security operation on an object that has no associated security.",null,false],[0,0,0,"CANT_ACCESS_DOMAIN_INFO",null," Configuration information could not be read from the domain controller, either because the machine is unavailable, or access has been denied.",null,false],[0,0,0,"INVALID_SERVER_STATE",null," The security account manager (SAM) or local security authority (LSA) server was in the wrong state to perform the security operation.",null,false],[0,0,0,"INVALID_DOMAIN_STATE",null," The domain was in the wrong state to perform the security operation.",null,false],[0,0,0,"INVALID_DOMAIN_ROLE",null," This operation is only allowed for the Primary Domain Controller of the domain.",null,false],[0,0,0,"NO_SUCH_DOMAIN",null," The specified domain either does not exist or could not be contacted.",null,false],[0,0,0,"DOMAIN_EXISTS",null," The specified domain already exists.",null,false],[0,0,0,"DOMAIN_LIMIT_EXCEEDED",null," An attempt was made to exceed the limit on the number of domains per server.",null,false],[0,0,0,"INTERNAL_DB_CORRUPTION",null," Unable to complete the requested operation because of either a catastrophic media failure or a data structure corruption on the disk.",null,false],[0,0,0,"INTERNAL_ERROR",null," An internal error occurred.",null,false],[0,0,0,"GENERIC_NOT_MAPPED",null," Generic access types were contained in an access mask which should already be mapped to nongeneric types.",null,false],[0,0,0,"BAD_DESCRIPTOR_FORMAT",null," A security descriptor is not in the right format (absolute or self-relative).",null,false],[0,0,0,"NOT_LOGON_PROCESS",null," The requested action is restricted for use by logon processes only.\n The calling process has not registered as a logon process.",null,false],[0,0,0,"LOGON_SESSION_EXISTS",null," Cannot start a new logon session with an ID that is already in use.",null,false],[0,0,0,"NO_SUCH_PACKAGE",null," A specified authentication package is unknown.",null,false],[0,0,0,"BAD_LOGON_SESSION_STATE",null," The logon session is not in a state that is consistent with the requested operation.",null,false],[0,0,0,"LOGON_SESSION_COLLISION",null," The logon session ID is already in use.",null,false],[0,0,0,"INVALID_LOGON_TYPE",null," A logon request contained an invalid logon type value.",null,false],[0,0,0,"CANNOT_IMPERSONATE",null," Unable to impersonate using a named pipe until data has been read from that pipe.",null,false],[0,0,0,"RXACT_INVALID_STATE",null," The transaction state of a registry subtree is incompatible with the requested operation.",null,false],[0,0,0,"RXACT_COMMIT_FAILURE",null," An internal security database corruption has been encountered.",null,false],[0,0,0,"SPECIAL_ACCOUNT",null," Cannot perform this operation on built-in accounts.",null,false],[0,0,0,"SPECIAL_GROUP",null," Cannot perform this operation on this built-in special group.",null,false],[0,0,0,"SPECIAL_USER",null," Cannot perform this operation on this built-in special user.",null,false],[0,0,0,"MEMBERS_PRIMARY_GROUP",null," The user cannot be removed from a group because the group is currently the user's primary group.",null,false],[0,0,0,"TOKEN_ALREADY_IN_USE",null," The token is already in use as a primary token.",null,false],[0,0,0,"NO_SUCH_ALIAS",null," The specified local group does not exist.",null,false],[0,0,0,"MEMBER_NOT_IN_ALIAS",null," The specified account name is not a member of the group.",null,false],[0,0,0,"MEMBER_IN_ALIAS",null," The specified account name is already a member of the group.",null,false],[0,0,0,"ALIAS_EXISTS",null," The specified local group already exists.",null,false],[0,0,0,"LOGON_NOT_GRANTED",null," Logon failure: the user has not been granted the requested logon type at this computer.",null,false],[0,0,0,"TOO_MANY_SECRETS",null," The maximum number of secrets that may be stored in a single system has been exceeded.",null,false],[0,0,0,"SECRET_TOO_LONG",null," The length of a secret exceeds the maximum length allowed.",null,false],[0,0,0,"INTERNAL_DB_ERROR",null," The local security authority database contains an internal inconsistency.",null,false],[0,0,0,"TOO_MANY_CONTEXT_IDS",null," During a logon attempt, the user's security context accumulated too many security IDs.",null,false],[0,0,0,"LOGON_TYPE_NOT_GRANTED",null," Logon failure: the user has not been granted the requested logon type at this computer.",null,false],[0,0,0,"NT_CROSS_ENCRYPTION_REQUIRED",null," A cross-encrypted password is necessary to change a user password.",null,false],[0,0,0,"NO_SUCH_MEMBER",null," A member could not be added to or removed from the local group because the member does not exist.",null,false],[0,0,0,"INVALID_MEMBER",null," A new member could not be added to a local group because the member has the wrong account type.",null,false],[0,0,0,"TOO_MANY_SIDS",null," Too many security IDs have been specified.",null,false],[0,0,0,"LM_CROSS_ENCRYPTION_REQUIRED",null," A cross-encrypted password is necessary to change this user password.",null,false],[0,0,0,"NO_INHERITANCE",null," Indicates an ACL contains no inheritable components.",null,false],[0,0,0,"FILE_CORRUPT",null," The file or directory is corrupted and unreadable.",null,false],[0,0,0,"DISK_CORRUPT",null," The disk structure is corrupted and unreadable.",null,false],[0,0,0,"NO_USER_SESSION_KEY",null," There is no user session key for the specified logon session.",null,false],[0,0,0,"LICENSE_QUOTA_EXCEEDED",null," The service being accessed is licensed for a particular number of connections.\n No more connections can be made to the service at this time because there are already as many connections as the service can accept.",null,false],[0,0,0,"WRONG_TARGET_NAME",null," The target account name is incorrect.",null,false],[0,0,0,"MUTUAL_AUTH_FAILED",null," Mutual Authentication failed. The server's password is out of date at the domain controller.",null,false],[0,0,0,"TIME_SKEW",null," There is a time and/or date difference between the client and server.",null,false],[0,0,0,"CURRENT_DOMAIN_NOT_ALLOWED",null," This operation cannot be performed on the current domain.",null,false],[0,0,0,"INVALID_WINDOW_HANDLE",null," Invalid window handle.",null,false],[0,0,0,"INVALID_MENU_HANDLE",null," Invalid menu handle.",null,false],[0,0,0,"INVALID_CURSOR_HANDLE",null," Invalid cursor handle.",null,false],[0,0,0,"INVALID_ACCEL_HANDLE",null," Invalid accelerator table handle.",null,false],[0,0,0,"INVALID_HOOK_HANDLE",null," Invalid hook handle.",null,false],[0,0,0,"INVALID_DWP_HANDLE",null," Invalid handle to a multiple-window position structure.",null,false],[0,0,0,"TLW_WITH_WSCHILD",null," Cannot create a top-level child window.",null,false],[0,0,0,"CANNOT_FIND_WND_CLASS",null," Cannot find window class.",null,false],[0,0,0,"WINDOW_OF_OTHER_THREAD",null," Invalid window; it belongs to other thread.",null,false],[0,0,0,"HOTKEY_ALREADY_REGISTERED",null," Hot key is already registered.",null,false],[0,0,0,"CLASS_ALREADY_EXISTS",null," Class already exists.",null,false],[0,0,0,"CLASS_DOES_NOT_EXIST",null," Class does not exist.",null,false],[0,0,0,"CLASS_HAS_WINDOWS",null," Class still has open windows.",null,false],[0,0,0,"INVALID_INDEX",null," Invalid index.",null,false],[0,0,0,"INVALID_ICON_HANDLE",null," Invalid icon handle.",null,false],[0,0,0,"PRIVATE_DIALOG_INDEX",null," Using private DIALOG window words.",null,false],[0,0,0,"LISTBOX_ID_NOT_FOUND",null," The list box identifier was not found.",null,false],[0,0,0,"NO_WILDCARD_CHARACTERS",null," No wildcards were found.",null,false],[0,0,0,"CLIPBOARD_NOT_OPEN",null," Thread does not have a clipboard open.",null,false],[0,0,0,"HOTKEY_NOT_REGISTERED",null," Hot key is not registered.",null,false],[0,0,0,"WINDOW_NOT_DIALOG",null," The window is not a valid dialog window.",null,false],[0,0,0,"CONTROL_ID_NOT_FOUND",null," Control ID not found.",null,false],[0,0,0,"INVALID_COMBOBOX_MESSAGE",null," Invalid message for a combo box because it does not have an edit control.",null,false],[0,0,0,"WINDOW_NOT_COMBOBOX",null," The window is not a combo box.",null,false],[0,0,0,"INVALID_EDIT_HEIGHT",null," Height must be less than 256.",null,false],[0,0,0,"DC_NOT_FOUND",null," Invalid device context (DC) handle.",null,false],[0,0,0,"INVALID_HOOK_FILTER",null," Invalid hook procedure type.",null,false],[0,0,0,"INVALID_FILTER_PROC",null," Invalid hook procedure.",null,false],[0,0,0,"HOOK_NEEDS_HMOD",null," Cannot set nonlocal hook without a module handle.",null,false],[0,0,0,"GLOBAL_ONLY_HOOK",null," This hook procedure can only be set globally.",null,false],[0,0,0,"JOURNAL_HOOK_SET",null," The journal hook procedure is already installed.",null,false],[0,0,0,"HOOK_NOT_INSTALLED",null," The hook procedure is not installed.",null,false],[0,0,0,"INVALID_LB_MESSAGE",null," Invalid message for single-selection list box.",null,false],[0,0,0,"SETCOUNT_ON_BAD_LB",null," LB_SETCOUNT sent to non-lazy list box.",null,false],[0,0,0,"LB_WITHOUT_TABSTOPS",null," This list box does not support tab stops.",null,false],[0,0,0,"DESTROY_OBJECT_OF_OTHER_THREAD",null," Cannot destroy object created by another thread.",null,false],[0,0,0,"CHILD_WINDOW_MENU",null," Child windows cannot have menus.",null,false],[0,0,0,"NO_SYSTEM_MENU",null," The window does not have a system menu.",null,false],[0,0,0,"INVALID_MSGBOX_STYLE",null," Invalid message box style.",null,false],[0,0,0,"INVALID_SPI_VALUE",null," Invalid system-wide (SPI_*) parameter.",null,false],[0,0,0,"SCREEN_ALREADY_LOCKED",null," Screen already locked.",null,false],[0,0,0,"HWNDS_HAVE_DIFF_PARENT",null," All handles to windows in a multiple-window position structure must have the same parent.",null,false],[0,0,0,"NOT_CHILD_WINDOW",null," The window is not a child window.",null,false],[0,0,0,"INVALID_GW_COMMAND",null," Invalid GW_* command.",null,false],[0,0,0,"INVALID_THREAD_ID",null," Invalid thread identifier.",null,false],[0,0,0,"NON_MDICHILD_WINDOW",null," Cannot process a message from a window that is not a multiple document interface (MDI) window.",null,false],[0,0,0,"POPUP_ALREADY_ACTIVE",null," Popup menu already active.",null,false],[0,0,0,"NO_SCROLLBARS",null," The window does not have scroll bars.",null,false],[0,0,0,"INVALID_SCROLLBAR_RANGE",null," Scroll bar range cannot be greater than MAXLONG.",null,false],[0,0,0,"INVALID_SHOWWIN_COMMAND",null," Cannot show or remove the window in the way specified.",null,false],[0,0,0,"NO_SYSTEM_RESOURCES",null," Insufficient system resources exist to complete the requested service.",null,false],[0,0,0,"NONPAGED_SYSTEM_RESOURCES",null," Insufficient system resources exist to complete the requested service.",null,false],[0,0,0,"PAGED_SYSTEM_RESOURCES",null," Insufficient system resources exist to complete the requested service.",null,false],[0,0,0,"WORKING_SET_QUOTA",null," Insufficient quota to complete the requested service.",null,false],[0,0,0,"PAGEFILE_QUOTA",null," Insufficient quota to complete the requested service.",null,false],[0,0,0,"COMMITMENT_LIMIT",null," The paging file is too small for this operation to complete.",null,false],[0,0,0,"MENU_ITEM_NOT_FOUND",null," A menu item was not found.",null,false],[0,0,0,"INVALID_KEYBOARD_HANDLE",null," Invalid keyboard layout handle.",null,false],[0,0,0,"HOOK_TYPE_NOT_ALLOWED",null," Hook type not allowed.",null,false],[0,0,0,"REQUIRES_INTERACTIVE_WINDOWSTATION",null," This operation requires an interactive window station.",null,false],[0,0,0,"TIMEOUT",null," This operation returned because the timeout period expired.",null,false],[0,0,0,"INVALID_MONITOR_HANDLE",null," Invalid monitor handle.",null,false],[0,0,0,"INCORRECT_SIZE",null," Incorrect size argument.",null,false],[0,0,0,"SYMLINK_CLASS_DISABLED",null," The symbolic link cannot be followed because its type is disabled.",null,false],[0,0,0,"SYMLINK_NOT_SUPPORTED",null," This application does not support the current operation on symbolic links.",null,false],[0,0,0,"XML_PARSE_ERROR",null," Windows was unable to parse the requested XML data.",null,false],[0,0,0,"XMLDSIG_ERROR",null," An error was encountered while processing an XML digital signature.",null,false],[0,0,0,"RESTART_APPLICATION",null," This application must be restarted.",null,false],[0,0,0,"WRONG_COMPARTMENT",null," The caller made the connection request in the wrong routing compartment.",null,false],[0,0,0,"AUTHIP_FAILURE",null," There was an AuthIP failure when attempting to connect to the remote host.",null,false],[0,0,0,"NO_NVRAM_RESOURCES",null," Insufficient NVRAM resources exist to complete the requested service. A reboot might be required.",null,false],[0,0,0,"NOT_GUI_PROCESS",null," Unable to finish the requested operation because the specified process is not a GUI process.",null,false],[0,0,0,"EVENTLOG_FILE_CORRUPT",null," The event log file is corrupted.",null,false],[0,0,0,"EVENTLOG_CANT_START",null," No event log file could be opened, so the event logging service did not start.",null,false],[0,0,0,"LOG_FILE_FULL",null," The event log file is full.",null,false],[0,0,0,"EVENTLOG_FILE_CHANGED",null," The event log file has changed between read operations.",null,false],[0,0,0,"INVALID_TASK_NAME",null," The specified task name is invalid.",null,false],[0,0,0,"INVALID_TASK_INDEX",null," The specified task index is invalid.",null,false],[0,0,0,"THREAD_ALREADY_IN_TASK",null," The specified thread is already joining a task.",null,false],[0,0,0,"INSTALL_SERVICE_FAILURE",null," The Windows Installer Service could not be accessed.\n This can occur if the Windows Installer is not correctly installed. Contact your support personnel for assistance.",null,false],[0,0,0,"INSTALL_USEREXIT",null," User cancelled installation.",null,false],[0,0,0,"INSTALL_FAILURE",null," Fatal error during installation.",null,false],[0,0,0,"INSTALL_SUSPEND",null," Installation suspended, incomplete.",null,false],[0,0,0,"UNKNOWN_PRODUCT",null," This action is only valid for products that are currently installed.",null,false],[0,0,0,"UNKNOWN_FEATURE",null," Feature ID not registered.",null,false],[0,0,0,"UNKNOWN_COMPONENT",null," Component ID not registered.",null,false],[0,0,0,"UNKNOWN_PROPERTY",null," Unknown property.",null,false],[0,0,0,"INVALID_HANDLE_STATE",null," Handle is in an invalid state.",null,false],[0,0,0,"BAD_CONFIGURATION",null," The configuration data for this product is corrupt. Contact your support personnel.",null,false],[0,0,0,"INDEX_ABSENT",null," Component qualifier not present.",null,false],[0,0,0,"INSTALL_SOURCE_ABSENT",null," The installation source for this product is not available.\n Verify that the source exists and that you can access it.",null,false],[0,0,0,"INSTALL_PACKAGE_VERSION",null," This installation package cannot be installed by the Windows Installer service.\n You must install a Windows service pack that contains a newer version of the Windows Installer service.",null,false],[0,0,0,"PRODUCT_UNINSTALLED",null," Product is uninstalled.",null,false],[0,0,0,"BAD_QUERY_SYNTAX",null," SQL query syntax invalid or unsupported.",null,false],[0,0,0,"INVALID_FIELD",null," Record field does not exist.",null,false],[0,0,0,"DEVICE_REMOVED",null," The device has been removed.",null,false],[0,0,0,"INSTALL_ALREADY_RUNNING",null," Another installation is already in progress.\n Complete that installation before proceeding with this install.",null,false],[0,0,0,"INSTALL_PACKAGE_OPEN_FAILED",null," This installation package could not be opened.\n Verify that the package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer package.",null,false],[0,0,0,"INSTALL_PACKAGE_INVALID",null," This installation package could not be opened.\n Contact the application vendor to verify that this is a valid Windows Installer package.",null,false],[0,0,0,"INSTALL_UI_FAILURE",null," There was an error starting the Windows Installer service user interface. Contact your support personnel.",null,false],[0,0,0,"INSTALL_LOG_FAILURE",null," Error opening installation log file.\n Verify that the specified log file location exists and that you can write to it.",null,false],[0,0,0,"INSTALL_LANGUAGE_UNSUPPORTED",null," The language of this installation package is not supported by your system.",null,false],[0,0,0,"INSTALL_TRANSFORM_FAILURE",null," Error applying transforms. Verify that the specified transform paths are valid.",null,false],[0,0,0,"INSTALL_PACKAGE_REJECTED",null," This installation is forbidden by system policy. Contact your system administrator.",null,false],[0,0,0,"FUNCTION_NOT_CALLED",null," Function could not be executed.",null,false],[0,0,0,"FUNCTION_FAILED",null," Function failed during execution.",null,false],[0,0,0,"INVALID_TABLE",null," Invalid or unknown table specified.",null,false],[0,0,0,"DATATYPE_MISMATCH",null," Data supplied is of wrong type.",null,false],[0,0,0,"UNSUPPORTED_TYPE",null," Data of this type is not supported.",null,false],[0,0,0,"CREATE_FAILED",null," The Windows Installer service failed to start. Contact your support personnel.",null,false],[0,0,0,"INSTALL_TEMP_UNWRITABLE",null," The Temp folder is on a drive that is full or is inaccessible.\n Free up space on the drive or verify that you have write permission on the Temp folder.",null,false],[0,0,0,"INSTALL_PLATFORM_UNSUPPORTED",null," This installation package is not supported by this processor type. Contact your product vendor.",null,false],[0,0,0,"INSTALL_NOTUSED",null," Component not used on this computer.",null,false],[0,0,0,"PATCH_PACKAGE_OPEN_FAILED",null," This update package could not be opened.\n Verify that the update package exists and that you can access it, or contact the application vendor to verify that this is a valid Windows Installer update package.",null,false],[0,0,0,"PATCH_PACKAGE_INVALID",null," This update package could not be opened.\n Contact the application vendor to verify that this is a valid Windows Installer update package.",null,false],[0,0,0,"PATCH_PACKAGE_UNSUPPORTED",null," This update package cannot be processed by the Windows Installer service.\n You must install a Windows service pack that contains a newer version of the Windows Installer service.",null,false],[0,0,0,"PRODUCT_VERSION",null," Another version of this product is already installed. Installation of this version cannot continue.\n To configure or remove the existing version of this product, use Add/Remove Programs on the Control Panel.",null,false],[0,0,0,"INVALID_COMMAND_LINE",null," Invalid command line argument. Consult the Windows Installer SDK for detailed command line help.",null,false],[0,0,0,"INSTALL_REMOTE_DISALLOWED",null," Only administrators have permission to add, remove, or configure server software during a Terminal services remote session.\n If you want to install or configure software on the server, contact your network administrator.",null,false],[0,0,0,"SUCCESS_REBOOT_INITIATED",null," The requested operation completed successfully.\n The system will be restarted so the changes can take effect.",null,false],[0,0,0,"PATCH_TARGET_NOT_FOUND",null," The upgrade cannot be installed by the Windows Installer service because the program to be upgraded may be missing, or the upgrade may update a different version of the program.\n Verify that the program to be upgraded exists on your computer and that you have the correct upgrade.",null,false],[0,0,0,"PATCH_PACKAGE_REJECTED",null," The update package is not permitted by software restriction policy.",null,false],[0,0,0,"INSTALL_TRANSFORM_REJECTED",null," One or more customizations are not permitted by software restriction policy.",null,false],[0,0,0,"INSTALL_REMOTE_PROHIBITED",null," The Windows Installer does not permit installation from a Remote Desktop Connection.",null,false],[0,0,0,"PATCH_REMOVAL_UNSUPPORTED",null," Uninstallation of the update package is not supported.",null,false],[0,0,0,"UNKNOWN_PATCH",null," The update is not applied to this product.",null,false],[0,0,0,"PATCH_NO_SEQUENCE",null," No valid sequence could be found for the set of updates.",null,false],[0,0,0,"PATCH_REMOVAL_DISALLOWED",null," Update removal was disallowed by policy.",null,false],[0,0,0,"INVALID_PATCH_XML",null," The XML update data is invalid.",null,false],[0,0,0,"PATCH_MANAGED_ADVERTISED_PRODUCT",null," Windows Installer does not permit updating of managed advertised products.\n At least one feature of the product must be installed before applying the update.",null,false],[0,0,0,"INSTALL_SERVICE_SAFEBOOT",null," The Windows Installer service is not accessible in Safe Mode.\n Please try again when your computer is not in Safe Mode or you can use System Restore to return your machine to a previous good state.",null,false],[0,0,0,"FAIL_FAST_EXCEPTION",null," A fail fast exception occurred.\n Exception handlers will not be invoked and the process will be terminated immediately.",null,false],[0,0,0,"INSTALL_REJECTED",null," The app that you are trying to run is not supported on this version of Windows.",null,false],[0,0,0,"RPC_S_INVALID_STRING_BINDING",null," The string binding is invalid.",null,false],[0,0,0,"RPC_S_WRONG_KIND_OF_BINDING",null," The binding handle is not the correct type.",null,false],[0,0,0,"RPC_S_INVALID_BINDING",null," The binding handle is invalid.",null,false],[0,0,0,"RPC_S_PROTSEQ_NOT_SUPPORTED",null," The RPC protocol sequence is not supported.",null,false],[0,0,0,"RPC_S_INVALID_RPC_PROTSEQ",null," The RPC protocol sequence is invalid.",null,false],[0,0,0,"RPC_S_INVALID_STRING_UUID",null," The string universal unique identifier (UUID) is invalid.",null,false],[0,0,0,"RPC_S_INVALID_ENDPOINT_FORMAT",null," The endpoint format is invalid.",null,false],[0,0,0,"RPC_S_INVALID_NET_ADDR",null," The network address is invalid.",null,false],[0,0,0,"RPC_S_NO_ENDPOINT_FOUND",null," No endpoint was found.",null,false],[0,0,0,"RPC_S_INVALID_TIMEOUT",null," The timeout value is invalid.",null,false],[0,0,0,"RPC_S_OBJECT_NOT_FOUND",null," The object universal unique identifier (UUID) was not found.",null,false],[0,0,0,"RPC_S_ALREADY_REGISTERED",null," The object universal unique identifier (UUID) has already been registered.",null,false],[0,0,0,"RPC_S_TYPE_ALREADY_REGISTERED",null," The type universal unique identifier (UUID) has already been registered.",null,false],[0,0,0,"RPC_S_ALREADY_LISTENING",null," The RPC server is already listening.",null,false],[0,0,0,"RPC_S_NO_PROTSEQS_REGISTERED",null," No protocol sequences have been registered.",null,false],[0,0,0,"RPC_S_NOT_LISTENING",null," The RPC server is not listening.",null,false],[0,0,0,"RPC_S_UNKNOWN_MGR_TYPE",null," The manager type is unknown.",null,false],[0,0,0,"RPC_S_UNKNOWN_IF",null," The interface is unknown.",null,false],[0,0,0,"RPC_S_NO_BINDINGS",null," There are no bindings.",null,false],[0,0,0,"RPC_S_NO_PROTSEQS",null," There are no protocol sequences.",null,false],[0,0,0,"RPC_S_CANT_CREATE_ENDPOINT",null," The endpoint cannot be created.",null,false],[0,0,0,"RPC_S_OUT_OF_RESOURCES",null," Not enough resources are available to complete this operation.",null,false],[0,0,0,"RPC_S_SERVER_UNAVAILABLE",null," The RPC server is unavailable.",null,false],[0,0,0,"RPC_S_SERVER_TOO_BUSY",null," The RPC server is too busy to complete this operation.",null,false],[0,0,0,"RPC_S_INVALID_NETWORK_OPTIONS",null," The network options are invalid.",null,false],[0,0,0,"RPC_S_NO_CALL_ACTIVE",null," There are no remote procedure calls active on this thread.",null,false],[0,0,0,"RPC_S_CALL_FAILED",null," The remote procedure call failed.",null,false],[0,0,0,"RPC_S_CALL_FAILED_DNE",null," The remote procedure call failed and did not execute.",null,false],[0,0,0,"RPC_S_PROTOCOL_ERROR",null," A remote procedure call (RPC) protocol error occurred.",null,false],[0,0,0,"RPC_S_PROXY_ACCESS_DENIED",null," Access to the HTTP proxy is denied.",null,false],[0,0,0,"RPC_S_UNSUPPORTED_TRANS_SYN",null," The transfer syntax is not supported by the RPC server.",null,false],[0,0,0,"RPC_S_UNSUPPORTED_TYPE",null," The universal unique identifier (UUID) type is not supported.",null,false],[0,0,0,"RPC_S_INVALID_TAG",null," The tag is invalid.",null,false],[0,0,0,"RPC_S_INVALID_BOUND",null," The array bounds are invalid.",null,false],[0,0,0,"RPC_S_NO_ENTRY_NAME",null," The binding does not contain an entry name.",null,false],[0,0,0,"RPC_S_INVALID_NAME_SYNTAX",null," The name syntax is invalid.",null,false],[0,0,0,"RPC_S_UNSUPPORTED_NAME_SYNTAX",null," The name syntax is not supported.",null,false],[0,0,0,"RPC_S_UUID_NO_ADDRESS",null," No network address is available to use to construct a universal unique identifier (UUID).",null,false],[0,0,0,"RPC_S_DUPLICATE_ENDPOINT",null," The endpoint is a duplicate.",null,false],[0,0,0,"RPC_S_UNKNOWN_AUTHN_TYPE",null," The authentication type is unknown.",null,false],[0,0,0,"RPC_S_MAX_CALLS_TOO_SMALL",null," The maximum number of calls is too small.",null,false],[0,0,0,"RPC_S_STRING_TOO_LONG",null," The string is too long.",null,false],[0,0,0,"RPC_S_PROTSEQ_NOT_FOUND",null," The RPC protocol sequence was not found.",null,false],[0,0,0,"RPC_S_PROCNUM_OUT_OF_RANGE",null," The procedure number is out of range.",null,false],[0,0,0,"RPC_S_BINDING_HAS_NO_AUTH",null," The binding does not contain any authentication information.",null,false],[0,0,0,"RPC_S_UNKNOWN_AUTHN_SERVICE",null," The authentication service is unknown.",null,false],[0,0,0,"RPC_S_UNKNOWN_AUTHN_LEVEL",null," The authentication level is unknown.",null,false],[0,0,0,"RPC_S_INVALID_AUTH_IDENTITY",null," The security context is invalid.",null,false],[0,0,0,"RPC_S_UNKNOWN_AUTHZ_SERVICE",null," The authorization service is unknown.",null,false],[0,0,0,"EPT_S_INVALID_ENTRY",null," The entry is invalid.",null,false],[0,0,0,"EPT_S_CANT_PERFORM_OP",null," The server endpoint cannot perform the operation.",null,false],[0,0,0,"EPT_S_NOT_REGISTERED",null," There are no more endpoints available from the endpoint mapper.",null,false],[0,0,0,"RPC_S_NOTHING_TO_EXPORT",null," No interfaces have been exported.",null,false],[0,0,0,"RPC_S_INCOMPLETE_NAME",null," The entry name is incomplete.",null,false],[0,0,0,"RPC_S_INVALID_VERS_OPTION",null," The version option is invalid.",null,false],[0,0,0,"RPC_S_NO_MORE_MEMBERS",null," There are no more members.",null,false],[0,0,0,"RPC_S_NOT_ALL_OBJS_UNEXPORTED",null," There is nothing to unexport.",null,false],[0,0,0,"RPC_S_INTERFACE_NOT_FOUND",null," The interface was not found.",null,false],[0,0,0,"RPC_S_ENTRY_ALREADY_EXISTS",null," The entry already exists.",null,false],[0,0,0,"RPC_S_ENTRY_NOT_FOUND",null," The entry is not found.",null,false],[0,0,0,"RPC_S_NAME_SERVICE_UNAVAILABLE",null," The name service is unavailable.",null,false],[0,0,0,"RPC_S_INVALID_NAF_ID",null," The network address family is invalid.",null,false],[0,0,0,"RPC_S_CANNOT_SUPPORT",null," The requested operation is not supported.",null,false],[0,0,0,"RPC_S_NO_CONTEXT_AVAILABLE",null," No security context is available to allow impersonation.",null,false],[0,0,0,"RPC_S_INTERNAL_ERROR",null," An internal error occurred in a remote procedure call (RPC).",null,false],[0,0,0,"RPC_S_ZERO_DIVIDE",null," The RPC server attempted an integer division by zero.",null,false],[0,0,0,"RPC_S_ADDRESS_ERROR",null," An addressing error occurred in the RPC server.",null,false],[0,0,0,"RPC_S_FP_DIV_ZERO",null," A floating-point operation at the RPC server caused a division by zero.",null,false],[0,0,0,"RPC_S_FP_UNDERFLOW",null," A floating-point underflow occurred at the RPC server.",null,false],[0,0,0,"RPC_S_FP_OVERFLOW",null," A floating-point overflow occurred at the RPC server.",null,false],[0,0,0,"RPC_X_NO_MORE_ENTRIES",null," The list of RPC servers available for the binding of auto handles has been exhausted.",null,false],[0,0,0,"RPC_X_SS_CHAR_TRANS_OPEN_FAIL",null," Unable to open the character translation table file.",null,false],[0,0,0,"RPC_X_SS_CHAR_TRANS_SHORT_FILE",null," The file containing the character translation table has fewer than 512 bytes.",null,false],[0,0,0,"RPC_X_SS_IN_NULL_CONTEXT",null," A null context handle was passed from the client to the host during a remote procedure call.",null,false],[0,0,0,"RPC_X_SS_CONTEXT_DAMAGED",null," The context handle changed during a remote procedure call.",null,false],[0,0,0,"RPC_X_SS_HANDLES_MISMATCH",null," The binding handles passed to a remote procedure call do not match.",null,false],[0,0,0,"RPC_X_SS_CANNOT_GET_CALL_HANDLE",null," The stub is unable to get the remote procedure call handle.",null,false],[0,0,0,"RPC_X_NULL_REF_POINTER",null," A null reference pointer was passed to the stub.",null,false],[0,0,0,"RPC_X_ENUM_VALUE_OUT_OF_RANGE",null," The enumeration value is out of range.",null,false],[0,0,0,"RPC_X_BYTE_COUNT_TOO_SMALL",null," The byte count is too small.",null,false],[0,0,0,"RPC_X_BAD_STUB_DATA",null," The stub received bad data.",null,false],[0,0,0,"INVALID_USER_BUFFER",null," The supplied user buffer is not valid for the requested operation.",null,false],[0,0,0,"UNRECOGNIZED_MEDIA",null," The disk media is not recognized. It may not be formatted.",null,false],[0,0,0,"NO_TRUST_LSA_SECRET",null," The workstation does not have a trust secret.",null,false],[0,0,0,"NO_TRUST_SAM_ACCOUNT",null," The security database on the server does not have a computer account for this workstation trust relationship.",null,false],[0,0,0,"TRUSTED_DOMAIN_FAILURE",null," The trust relationship between the primary domain and the trusted domain failed.",null,false],[0,0,0,"TRUSTED_RELATIONSHIP_FAILURE",null," The trust relationship between this workstation and the primary domain failed.",null,false],[0,0,0,"TRUST_FAILURE",null," The network logon failed.",null,false],[0,0,0,"RPC_S_CALL_IN_PROGRESS",null," A remote procedure call is already in progress for this thread.",null,false],[0,0,0,"NETLOGON_NOT_STARTED",null," An attempt was made to logon, but the network logon service was not started.",null,false],[0,0,0,"ACCOUNT_EXPIRED",null," The user's account has expired.",null,false],[0,0,0,"REDIRECTOR_HAS_OPEN_HANDLES",null," The redirector is in use and cannot be unloaded.",null,false],[0,0,0,"PRINTER_DRIVER_ALREADY_INSTALLED",null," The specified printer driver is already installed.",null,false],[0,0,0,"UNKNOWN_PORT",null," The specified port is unknown.",null,false],[0,0,0,"UNKNOWN_PRINTER_DRIVER",null," The printer driver is unknown.",null,false],[0,0,0,"UNKNOWN_PRINTPROCESSOR",null," The print processor is unknown.",null,false],[0,0,0,"INVALID_SEPARATOR_FILE",null," The specified separator file is invalid.",null,false],[0,0,0,"INVALID_PRIORITY",null," The specified priority is invalid.",null,false],[0,0,0,"INVALID_PRINTER_NAME",null," The printer name is invalid.",null,false],[0,0,0,"PRINTER_ALREADY_EXISTS",null," The printer already exists.",null,false],[0,0,0,"INVALID_PRINTER_COMMAND",null," The printer command is invalid.",null,false],[0,0,0,"INVALID_DATATYPE",null," The specified datatype is invalid.",null,false],[0,0,0,"INVALID_ENVIRONMENT",null," The environment specified is invalid.",null,false],[0,0,0,"RPC_S_NO_MORE_BINDINGS",null," There are no more bindings.",null,false],[0,0,0,"NOLOGON_INTERDOMAIN_TRUST_ACCOUNT",null," The account used is an interdomain trust account.\n Use your global user account or local user account to access this server.",null,false],[0,0,0,"NOLOGON_WORKSTATION_TRUST_ACCOUNT",null," The account used is a computer account.\n Use your global user account or local user account to access this server.",null,false],[0,0,0,"NOLOGON_SERVER_TRUST_ACCOUNT",null," The account used is a server trust account.\n Use your global user account or local user account to access this server.",null,false],[0,0,0,"DOMAIN_TRUST_INCONSISTENT",null," The name or security ID (SID) of the domain specified is inconsistent with the trust information for that domain.",null,false],[0,0,0,"SERVER_HAS_OPEN_HANDLES",null," The server is in use and cannot be unloaded.",null,false],[0,0,0,"RESOURCE_DATA_NOT_FOUND",null," The specified image file did not contain a resource section.",null,false],[0,0,0,"RESOURCE_TYPE_NOT_FOUND",null," The specified resource type cannot be found in the image file.",null,false],[0,0,0,"RESOURCE_NAME_NOT_FOUND",null," The specified resource name cannot be found in the image file.",null,false],[0,0,0,"RESOURCE_LANG_NOT_FOUND",null," The specified resource language ID cannot be found in the image file.",null,false],[0,0,0,"NOT_ENOUGH_QUOTA",null," Not enough quota is available to process this command.",null,false],[0,0,0,"RPC_S_NO_INTERFACES",null," No interfaces have been registered.",null,false],[0,0,0,"RPC_S_CALL_CANCELLED",null," The remote procedure call was cancelled.",null,false],[0,0,0,"RPC_S_BINDING_INCOMPLETE",null," The binding handle does not contain all required information.",null,false],[0,0,0,"RPC_S_COMM_FAILURE",null," A communications failure occurred during a remote procedure call.",null,false],[0,0,0,"RPC_S_UNSUPPORTED_AUTHN_LEVEL",null," The requested authentication level is not supported.",null,false],[0,0,0,"RPC_S_NO_PRINC_NAME",null," No principal name registered.",null,false],[0,0,0,"RPC_S_NOT_RPC_ERROR",null," The error specified is not a valid Windows RPC error code.",null,false],[0,0,0,"RPC_S_UUID_LOCAL_ONLY",null," A UUID that is valid only on this computer has been allocated.",null,false],[0,0,0,"RPC_S_SEC_PKG_ERROR",null," A security package specific error occurred.",null,false],[0,0,0,"RPC_S_NOT_CANCELLED",null," Thread is not canceled.",null,false],[0,0,0,"RPC_X_INVALID_ES_ACTION",null," Invalid operation on the encoding/decoding handle.",null,false],[0,0,0,"RPC_X_WRONG_ES_VERSION",null," Incompatible version of the serializing package.",null,false],[0,0,0,"RPC_X_WRONG_STUB_VERSION",null," Incompatible version of the RPC stub.",null,false],[0,0,0,"RPC_X_INVALID_PIPE_OBJECT",null," The RPC pipe object is invalid or corrupted.",null,false],[0,0,0,"RPC_X_WRONG_PIPE_ORDER",null," An invalid operation was attempted on an RPC pipe object.",null,false],[0,0,0,"RPC_X_WRONG_PIPE_VERSION",null," Unsupported RPC pipe version.",null,false],[0,0,0,"RPC_S_COOKIE_AUTH_FAILED",null," HTTP proxy server rejected the connection because the cookie authentication failed.",null,false],[0,0,0,"RPC_S_GROUP_MEMBER_NOT_FOUND",null," The group member was not found.",null,false],[0,0,0,"EPT_S_CANT_CREATE",null," The endpoint mapper database entry could not be created.",null,false],[0,0,0,"RPC_S_INVALID_OBJECT",null," The object universal unique identifier (UUID) is the nil UUID.",null,false],[0,0,0,"INVALID_TIME",null," The specified time is invalid.",null,false],[0,0,0,"INVALID_FORM_NAME",null," The specified form name is invalid.",null,false],[0,0,0,"INVALID_FORM_SIZE",null," The specified form size is invalid.",null,false],[0,0,0,"ALREADY_WAITING",null," The specified printer handle is already being waited on.",null,false],[0,0,0,"PRINTER_DELETED",null," The specified printer has been deleted.",null,false],[0,0,0,"INVALID_PRINTER_STATE",null," The state of the printer is invalid.",null,false],[0,0,0,"PASSWORD_MUST_CHANGE",null," The user's password must be changed before signing in.",null,false],[0,0,0,"DOMAIN_CONTROLLER_NOT_FOUND",null," Could not find the domain controller for this domain.",null,false],[0,0,0,"ACCOUNT_LOCKED_OUT",null," The referenced account is currently locked out and may not be logged on to.",null,false],[0,0,0,"OR_INVALID_OXID",null," The object exporter specified was not found.",null,false],[0,0,0,"OR_INVALID_OID",null," The object specified was not found.",null,false],[0,0,0,"OR_INVALID_SET",null," The object resolver set specified was not found.",null,false],[0,0,0,"RPC_S_SEND_INCOMPLETE",null," Some data remains to be sent in the request buffer.",null,false],[0,0,0,"RPC_S_INVALID_ASYNC_HANDLE",null," Invalid asynchronous remote procedure call handle.",null,false],[0,0,0,"RPC_S_INVALID_ASYNC_CALL",null," Invalid asynchronous RPC call handle for this operation.",null,false],[0,0,0,"RPC_X_PIPE_CLOSED",null," The RPC pipe object has already been closed.",null,false],[0,0,0,"RPC_X_PIPE_DISCIPLINE_ERROR",null," The RPC call completed before all pipes were processed.",null,false],[0,0,0,"RPC_X_PIPE_EMPTY",null," No more data is available from the RPC pipe.",null,false],[0,0,0,"NO_SITENAME",null," No site name is available for this machine.",null,false],[0,0,0,"CANT_ACCESS_FILE",null," The file cannot be accessed by the system.",null,false],[0,0,0,"CANT_RESOLVE_FILENAME",null," The name of the file cannot be resolved by the system.",null,false],[0,0,0,"RPC_S_ENTRY_TYPE_MISMATCH",null," The entry is not of the expected type.",null,false],[0,0,0,"RPC_S_NOT_ALL_OBJS_EXPORTED",null," Not all object UUIDs could be exported to the specified entry.",null,false],[0,0,0,"RPC_S_INTERFACE_NOT_EXPORTED",null," Interface could not be exported to the specified entry.",null,false],[0,0,0,"RPC_S_PROFILE_NOT_ADDED",null," The specified profile entry could not be added.",null,false],[0,0,0,"RPC_S_PRF_ELT_NOT_ADDED",null," The specified profile element could not be added.",null,false],[0,0,0,"RPC_S_PRF_ELT_NOT_REMOVED",null," The specified profile element could not be removed.",null,false],[0,0,0,"RPC_S_GRP_ELT_NOT_ADDED",null," The group element could not be added.",null,false],[0,0,0,"RPC_S_GRP_ELT_NOT_REMOVED",null," The group element could not be removed.",null,false],[0,0,0,"KM_DRIVER_BLOCKED",null," The printer driver is not compatible with a policy enabled on your computer that blocks NT 4.0 drivers.",null,false],[0,0,0,"CONTEXT_EXPIRED",null," The context has expired and can no longer be used.",null,false],[0,0,0,"PER_USER_TRUST_QUOTA_EXCEEDED",null," The current user's delegated trust creation quota has been exceeded.",null,false],[0,0,0,"ALL_USER_TRUST_QUOTA_EXCEEDED",null," The total delegated trust creation quota has been exceeded.",null,false],[0,0,0,"USER_DELETE_TRUST_QUOTA_EXCEEDED",null," The current user's delegated trust deletion quota has been exceeded.",null,false],[0,0,0,"AUTHENTICATION_FIREWALL_FAILED",null," The computer you are signing into is protected by an authentication firewall.\n The specified account is not allowed to authenticate to the computer.",null,false],[0,0,0,"REMOTE_PRINT_CONNECTIONS_BLOCKED",null," Remote connections to the Print Spooler are blocked by a policy set on your machine.",null,false],[0,0,0,"NTLM_BLOCKED",null," Authentication failed because NTLM authentication has been disabled.",null,false],[0,0,0,"PASSWORD_CHANGE_REQUIRED",null," Logon Failure: EAS policy requires that the user change their password before this operation can be performed.",null,false],[0,0,0,"INVALID_PIXEL_FORMAT",null," The pixel format is invalid.",null,false],[0,0,0,"BAD_DRIVER",null," The specified driver is invalid.",null,false],[0,0,0,"INVALID_WINDOW_STYLE",null," The window style or class attribute is invalid for this operation.",null,false],[0,0,0,"METAFILE_NOT_SUPPORTED",null," The requested metafile operation is not supported.",null,false],[0,0,0,"TRANSFORM_NOT_SUPPORTED",null," The requested transformation operation is not supported.",null,false],[0,0,0,"CLIPPING_NOT_SUPPORTED",null," The requested clipping operation is not supported.",null,false],[0,0,0,"INVALID_CMM",null," The specified color management module is invalid.",null,false],[0,0,0,"INVALID_PROFILE",null," The specified color profile is invalid.",null,false],[0,0,0,"TAG_NOT_FOUND",null," The specified tag was not found.",null,false],[0,0,0,"TAG_NOT_PRESENT",null," A required tag is not present.",null,false],[0,0,0,"DUPLICATE_TAG",null," The specified tag is already present.",null,false],[0,0,0,"PROFILE_NOT_ASSOCIATED_WITH_DEVICE",null," The specified color profile is not associated with the specified device.",null,false],[0,0,0,"PROFILE_NOT_FOUND",null," The specified color profile was not found.",null,false],[0,0,0,"INVALID_COLORSPACE",null," The specified color space is invalid.",null,false],[0,0,0,"ICM_NOT_ENABLED",null," Image Color Management is not enabled.",null,false],[0,0,0,"DELETING_ICM_XFORM",null," There was an error while deleting the color transform.",null,false],[0,0,0,"INVALID_TRANSFORM",null," The specified color transform is invalid.",null,false],[0,0,0,"COLORSPACE_MISMATCH",null," The specified transform does not match the bitmap's color space.",null,false],[0,0,0,"INVALID_COLORINDEX",null," The specified named color index is not present in the profile.",null,false],[0,0,0,"PROFILE_DOES_NOT_MATCH_DEVICE",null," The specified profile is intended for a device of a different type than the specified device.",null,false],[0,0,0,"CONNECTED_OTHER_PASSWORD",null," The network connection was made successfully, but the user had to be prompted for a password other than the one originally specified.",null,false],[0,0,0,"CONNECTED_OTHER_PASSWORD_DEFAULT",null," The network connection was made successfully using default credentials.",null,false],[0,0,0,"BAD_USERNAME",null," The specified username is invalid.",null,false],[0,0,0,"NOT_CONNECTED",null," This network connection does not exist.",null,false],[0,0,0,"OPEN_FILES",null," This network connection has files open or requests pending.",null,false],[0,0,0,"ACTIVE_CONNECTIONS",null," Active connections still exist.",null,false],[0,0,0,"DEVICE_IN_USE",null," The device is in use by an active process and cannot be disconnected.",null,false],[0,0,0,"UNKNOWN_PRINT_MONITOR",null," The specified print monitor is unknown.",null,false],[0,0,0,"PRINTER_DRIVER_IN_USE",null," The specified printer driver is currently in use.",null,false],[0,0,0,"SPOOL_FILE_NOT_FOUND",null," The spool file was not found.",null,false],[0,0,0,"SPL_NO_STARTDOC",null," A StartDocPrinter call was not issued.",null,false],[0,0,0,"SPL_NO_ADDJOB",null," An AddJob call was not issued.",null,false],[0,0,0,"PRINT_PROCESSOR_ALREADY_INSTALLED",null," The specified print processor has already been installed.",null,false],[0,0,0,"PRINT_MONITOR_ALREADY_INSTALLED",null," The specified print monitor has already been installed.",null,false],[0,0,0,"INVALID_PRINT_MONITOR",null," The specified print monitor does not have the required functions.",null,false],[0,0,0,"PRINT_MONITOR_IN_USE",null," The specified print monitor is currently in use.",null,false],[0,0,0,"PRINTER_HAS_JOBS_QUEUED",null," The requested operation is not allowed when there are jobs queued to the printer.",null,false],[0,0,0,"SUCCESS_REBOOT_REQUIRED",null," The requested operation is successful.\n Changes will not be effective until the system is rebooted.",null,false],[0,0,0,"SUCCESS_RESTART_REQUIRED",null," The requested operation is successful.\n Changes will not be effective until the service is restarted.",null,false],[0,0,0,"PRINTER_NOT_FOUND",null," No printers were found.",null,false],[0,0,0,"PRINTER_DRIVER_WARNED",null," The printer driver is known to be unreliable.",null,false],[0,0,0,"PRINTER_DRIVER_BLOCKED",null," The printer driver is known to harm the system.",null,false],[0,0,0,"PRINTER_DRIVER_PACKAGE_IN_USE",null," The specified printer driver package is currently in use.",null,false],[0,0,0,"CORE_DRIVER_PACKAGE_NOT_FOUND",null," Unable to find a core driver package that is required by the printer driver package.",null,false],[0,0,0,"FAIL_REBOOT_REQUIRED",null," The requested operation failed.\n A system reboot is required to roll back changes made.",null,false],[0,0,0,"FAIL_REBOOT_INITIATED",null," The requested operation failed.\n A system reboot has been initiated to roll back changes made.",null,false],[0,0,0,"PRINTER_DRIVER_DOWNLOAD_NEEDED",null," The specified printer driver was not found on the system and needs to be downloaded.",null,false],[0,0,0,"PRINT_JOB_RESTART_REQUIRED",null," The requested print job has failed to print.\n A print system update requires the job to be resubmitted.",null,false],[0,0,0,"INVALID_PRINTER_DRIVER_MANIFEST",null," The printer driver does not contain a valid manifest, or contains too many manifests.",null,false],[0,0,0,"PRINTER_NOT_SHAREABLE",null," The specified printer cannot be shared.",null,false],[0,0,0,"REQUEST_PAUSED",null," The operation was paused.",null,false],[0,0,0,"IO_REISSUE_AS_CACHED",null," Reissue the given operation as a cached IO operation.",null,false],[401,2597,0,null,null,null,null,false],[0,0,0,"windows/ntstatus.zig",null,"",[],false],[415,1,0,null,null," NTSTATUS codes from https://docs.microsoft.com/en-us/openspecs/windows_protocols/ms-erref/596a1078-e883-4972-9bbc-49e60bebca55?",[53694,53695,53696,53697,53698,53699,53700,53701,53702,53703,53704,53705,53706,53707,53708,53709,53710,53711,53712,53713,53714,53715,53716,53717,53718,53719,53720,53721,53722,53723,53724,53725,53726,53727,53728,53729,53730,53731,53732,53733,53734,53735,53736,53737,53738,53739,53740,53741,53742,53743,53744,53745,53746,53747,53748,53749,53750,53751,53752,53753,53754,53755,53756,53757,53758,53759,53760,53761,53762,53763,53764,53765,53766,53767,53768,53769,53770,53771,53772,53773,53774,53775,53776,53777,53778,53779,53780,53781,53782,53783,53784,53785,53786,53787,53788,53789,53790,53791,53792,53793,53794,53795,53796,53797,53798,53799,53800,53801,53802,53803,53804,53805,53806,53807,53808,53809,53810,53811,53812,53813,53814,53815,53816,53817,53818,53819,53820,53821,53822,53823,53824,53825,53826,53827,53828,53829,53830,53831,53832,53833,53834,53835,53836,53837,53838,53839,53840,53841,53842,53843,53844,53845,53846,53847,53848,53849,53850,53851,53852,53853,53854,53855,53856,53857,53858,53859,53860,53861,53862,53863,53864,53865,53866,53867,53868,53869,53870,53871,53872,53873,53874,53875,53876,53877,53878,53879,53880,53881,53882,53883,53884,53885,53886,53887,53888,53889,53890,53891,53892,53893,53894,53895,53896,53897,53898,53899,53900,53901,53902,53903,53904,53905,53906,53907,53908,53909,53910,53911,53912,53913,53914,53915,53916,53917,53918,53919,53920,53921,53922,53923,53924,53925,53926,53927,53928,53929,53930,53931,53932,53933,53934,53935,53936,53937,53938,53939,53940,53941,53942,53943,53944,53945,53946,53947,53948,53949,53950,53951,53952,53953,53954,53955,53956,53957,53958,53959,53960,53961,53962,53963,53964,53965,53966,53967,53968,53969,53970,53971,53972,53973,53974,53975,53976,53977,53978,53979,53980,53981,53982,53983,53984,53985,53986,53987,53988,53989,53990,53991,53992,53993,53994,53995,53996,53997,53998,53999,54000,54001,54002,54003,54004,54005,54006,54007,54008,54009,54010,54011,54012,54013,54014,54015,54016,54017,54018,54019,54020,54021,54022,54023,54024,54025,54026,54027,54028,54029,54030,54031,54032,54033,54034,54035,54036,54037,54038,54039,54040,54041,54042,54043,54044,54045,54046,54047,54048,54049,54050,54051,54052,54053,54054,54055,54056,54057,54058,54059,54060,54061,54062,54063,54064,54065,54066,54067,54068,54069,54070,54071,54072,54073,54074,54075,54076,54077,54078,54079,54080,54081,54082,54083,54084,54085,54086,54087,54088,54089,54090,54091,54092,54093,54094,54095,54096,54097,54098,54099,54100,54101,54102,54103,54104,54105,54106,54107,54108,54109,54110,54111,54112,54113,54114,54115,54116,54117,54118,54119,54120,54121,54122,54123,54124,54125,54126,54127,54128,54129,54130,54131,54132,54133,54134,54135,54136,54137,54138,54139,54140,54141,54142,54143,54144,54145,54146,54147,54148,54149,54150,54151,54152,54153,54154,54155,54156,54157,54158,54159,54160,54161,54162,54163,54164,54165,54166,54167,54168,54169,54170,54171,54172,54173,54174,54175,54176,54177,54178,54179,54180,54181,54182,54183,54184,54185,54186,54187,54188,54189,54190,54191,54192,54193,54194,54195,54196,54197,54198,54199,54200,54201,54202,54203,54204,54205,54206,54207,54208,54209,54210,54211,54212,54213,54214,54215,54216,54217,54218,54219,54220,54221,54222,54223,54224,54225,54226,54227,54228,54229,54230,54231,54232,54233,54234,54235,54236,54237,54238,54239,54240,54241,54242,54243,54244,54245,54246,54247,54248,54249,54250,54251,54252,54253,54254,54255,54256,54257,54258,54259,54260,54261,54262,54263,54264,54265,54266,54267,54268,54269,54270,54271,54272,54273,54274,54275,54276,54277,54278,54279,54280,54281,54282,54283,54284,54285,54286,54287,54288,54289,54290,54291,54292,54293,54294,54295,54296,54297,54298,54299,54300,54301,54302,54303,54304,54305,54306,54307,54308,54309,54310,54311,54312,54313,54314,54315,54316,54317,54318,54319,54320,54321,54322,54323,54324,54325,54326,54327,54328,54329,54330,54331,54332,54333,54334,54335,54336,54337,54338,54339,54340,54341,54342,54343,54344,54345,54346,54347,54348,54349,54350,54351,54352,54353,54354,54355,54356,54357,54358,54359,54360,54361,54362,54363,54364,54365,54366,54367,54368,54369,54370,54371,54372,54373,54374,54375,54376,54377,54378,54379,54380,54381,54382,54383,54384,54385,54386,54387,54388,54389,54390,54391,54392,54393,54394,54395,54396,54397,54398,54399,54400,54401,54402,54403,54404,54405,54406,54407,54408,54409,54410,54411,54412,54413,54414,54415,54416,54417,54418,54419,54420,54421,54422,54423,54424,54425,54426,54427,54428,54429,54430,54431,54432,54433,54434,54435,54436,54437,54438,54439,54440,54441,54442,54443,54444,54445,54446,54447,54448,54449,54450,54451,54452,54453,54454,54455,54456,54457,54458,54459,54460,54461,54462,54463,54464,54465,54466,54467,54468,54469,54470,54471,54472,54473,54474,54475,54476,54477,54478,54479,54480,54481,54482,54483,54484,54485,54486,54487,54488,54489,54490,54491,54492,54493,54494,54495,54496,54497,54498,54499,54500,54501,54502,54503,54504,54505,54506,54507,54508,54509,54510,54511,54512,54513,54514,54515,54516,54517,54518,54519,54520,54521,54522,54523,54524,54525,54526,54527,54528,54529,54530,54531,54532,54533,54534,54535,54536,54537,54538,54539,54540,54541,54542,54543,54544,54545,54546,54547,54548,54549,54550,54551,54552,54553,54554,54555,54556,54557,54558,54559,54560,54561,54562,54563,54564,54565,54566,54567,54568,54569,54570,54571,54572,54573,54574,54575,54576,54577,54578,54579,54580,54581,54582,54583,54584,54585,54586,54587,54588,54589,54590,54591,54592,54593,54594,54595,54596,54597,54598,54599,54600,54601,54602,54603,54604,54605,54606,54607,54608,54609,54610,54611,54612,54613,54614,54615,54616,54617,54618,54619,54620,54621,54622,54623,54624,54625,54626,54627,54628,54629,54630,54631,54632,54633,54634,54635,54636,54637,54638,54639,54640,54641,54642,54643,54644,54645,54646,54647,54648,54649,54650,54651,54652,54653,54654,54655,54656,54657,54658,54659,54660,54661,54662,54663,54664,54665,54666,54667,54668,54669,54670,54671,54672,54673,54674,54675,54676,54677,54678,54679,54680,54681,54682,54683,54684,54685,54686,54687,54688,54689,54690,54691,54692,54693,54694,54695,54696,54697,54698,54699,54700,54701,54702,54703,54704,54705,54706,54707,54708,54709,54710,54711,54712,54713,54714,54715,54716,54717,54718,54719,54720,54721,54722,54723,54724,54725,54726,54727,54728,54729,54730,54731,54732,54733,54734,54735,54736,54737,54738,54739,54740,54741,54742,54743,54744,54745,54746,54747,54748,54749,54750,54751,54752,54753,54754,54755,54756,54757,54758,54759,54760,54761,54762,54763,54764,54765,54766,54767,54768,54769,54770,54771,54772,54773,54774,54775,54776,54777,54778,54779,54780,54781,54782,54783,54784,54785,54786,54787,54788,54789,54790,54791,54792,54793,54794,54795,54796,54797,54798,54799,54800,54801,54802,54803,54804,54805,54806,54807,54808,54809,54810,54811,54812,54813,54814,54815,54816,54817,54818,54819,54820,54821,54822,54823,54824,54825,54826,54827,54828,54829,54830,54831,54832,54833,54834,54835,54836,54837,54838,54839,54840,54841,54842,54843,54844,54845,54846,54847,54848,54849,54850,54851,54852,54853,54854,54855,54856,54857,54858,54859,54860,54861,54862,54863,54864,54865,54866,54867,54868,54869,54870,54871,54872,54873,54874,54875,54876,54877,54878,54879,54880,54881,54882,54883,54884,54885,54886,54887,54888,54889,54890,54891,54892,54893,54894,54895,54896,54897,54898,54899,54900,54901,54902,54903,54904,54905,54906,54907,54908,54909,54910,54911,54912,54913,54914,54915,54916,54917,54918,54919,54920,54921,54922,54923,54924,54925,54926,54927,54928,54929,54930,54931,54932,54933,54934,54935,54936,54937,54938,54939,54940,54941,54942,54943,54944,54945,54946,54947,54948,54949,54950,54951,54952,54953,54954,54955,54956,54957,54958,54959,54960,54961,54962,54963,54964,54965,54966,54967,54968,54969,54970,54971,54972,54973,54974,54975,54976,54977,54978,54979,54980,54981,54982,54983,54984,54985,54986,54987,54988,54989,54990,54991,54992,54993,54994,54995,54996,54997,54998,54999,55000,55001,55002,55003,55004,55005,55006,55007,55008,55009,55010,55011,55012,55013,55014,55015,55016,55017,55018,55019,55020,55021,55022,55023,55024,55025,55026,55027,55028,55029,55030,55031,55032,55033,55034,55035,55036,55037,55038,55039,55040,55041,55042,55043,55044,55045,55046,55047,55048,55049,55050,55051,55052,55053,55054,55055,55056,55057,55058,55059,55060,55061,55062,55063,55064,55065,55066,55067,55068,55069,55070,55071,55072,55073,55074,55075,55076,55077,55078,55079,55080,55081,55082,55083,55084,55085,55086,55087,55088,55089,55090,55091,55092,55093,55094,55095,55096,55097,55098,55099,55100,55101,55102,55103,55104,55105,55106,55107,55108,55109,55110,55111,55112,55113,55114,55115,55116,55117,55118,55119,55120,55121,55122,55123,55124,55125,55126,55127,55128,55129,55130,55131,55132,55133,55134,55135,55136,55137,55138,55139,55140,55141,55142,55143,55144,55145,55146,55147,55148,55149,55150,55151,55152,55153,55154,55155,55156,55157,55158,55159,55160,55161,55162,55163,55164,55165,55166,55167,55168,55169,55170,55171,55172,55173,55174,55175,55176,55177,55178,55179,55180,55181,55182,55183,55184,55185,55186,55187,55188,55189,55190,55191,55192,55193,55194,55195,55196,55197,55198,55199,55200,55201,55202,55203,55204,55205,55206,55207,55208,55209,55210,55211,55212,55213,55214,55215,55216,55217,55218,55219,55220,55221,55222,55223,55224,55225,55226,55227,55228,55229,55230,55231,55232,55233,55234,55235,55236,55237,55238,55239,55240,55241,55242,55243,55244,55245,55246,55247,55248,55249,55250,55251,55252,55253,55254,55255,55256,55257,55258,55259,55260,55261,55262,55263,55264,55265,55266,55267,55268,55269,55270,55271,55272,55273,55274,55275,55276,55277,55278,55279,55280,55281,55282,55283,55284,55285,55286,55287,55288,55289,55290,55291,55292,55293,55294,55295,55296,55297,55298,55299,55300,55301,55302,55303,55304,55305,55306,55307,55308,55309,55310,55311,55312,55313,55314,55315,55316,55317,55318,55319,55320,55321,55322,55323,55324,55325,55326,55327,55328,55329,55330,55331,55332,55333,55334,55335,55336,55337,55338,55339,55340,55341,55342,55343,55344,55345,55346,55347,55348,55349,55350,55351,55352,55353,55354,55355,55356,55357,55358,55359,55360,55361,55362,55363,55364,55365,55366,55367,55368,55369,55370,55371,55372,55373,55374,55375,55376,55377,55378,55379,55380,55381,55382,55383,55384,55385,55386,55387,55388,55389,55390,55391,55392,55393,55394,55395,55396,55397,55398,55399,55400,55401,55402,55403,55404,55405,55406,55407,55408,55409,55410,55411,55412,55413,55414,55415,55416,55417,55418,55419,55420,55421,55422,55423,55424,55425,55426,55427,55428,55429,55430,55431,55432,55433,55434,55435,55436,55437,55438,55439,55440,55441,55442,55443,55444,55445,55446,55447,55448,55449,55450,55451,55452,55453,55454,55455,55456,55457,55458,55459,55460,55461,55462,55463,55464,55465,55466,55467,55468,55469,55470,55471,55472,55473,55474,55475,55476,55477,55478,55479,55480,55481,55482,55483,55484,55485],false],[415,4,0,null,null," The caller specified WaitAny for WaitType and one of the dispatcher\n objects in the Object array has been set to the signaled state.",null,false],[415,6,0,null,null," The caller attempted to wait for a mutex that has been abandoned.",null,false],[415,8,0,null,null," The maximum number of boot-time filters has been reached.",null,false],[0,0,0,"SUCCESS",null," The operation completed successfully.",null,false],[0,0,0,"WAIT_1",null," The caller specified WaitAny for WaitType and one of the dispatcher objects in the Object array has been set to the signaled state.",null,false],[0,0,0,"WAIT_2",null," The caller specified WaitAny for WaitType and one of the dispatcher objects in the Object array has been set to the signaled state.",null,false],[0,0,0,"WAIT_3",null," The caller specified WaitAny for WaitType and one of the dispatcher objects in the Object array has been set to the signaled state.",null,false],[0,0,0,"WAIT_63",null," The caller specified WaitAny for WaitType and one of the dispatcher objects in the Object array has been set to the signaled state.",null,false],[0,0,0,"ABANDONED",null," The caller attempted to wait for a mutex that has been abandoned.",null,false],[0,0,0,"ABANDONED_WAIT_63",null," The caller attempted to wait for a mutex that has been abandoned.",null,false],[0,0,0,"USER_APC",null," A user-mode APC was delivered before the given Interval expired.",null,false],[0,0,0,"ALERTED",null," The delay completed because the thread was alerted.",null,false],[0,0,0,"TIMEOUT",null," The given Timeout interval expired.",null,false],[0,0,0,"PENDING",null," The operation that was requested is pending completion.",null,false],[0,0,0,"REPARSE",null," A reparse should be performed by the Object Manager because the name of the file resulted in a symbolic link.",null,false],[0,0,0,"MORE_ENTRIES",null," Returned by enumeration APIs to indicate more information is available to successive calls.",null,false],[0,0,0,"NOT_ALL_ASSIGNED",null," Indicates not all privileges or groups that are referenced are assigned to the caller.\n This allows, for example, all privileges to be disabled without having to know exactly which privileges are assigned.",null,false],[0,0,0,"SOME_NOT_MAPPED",null," Some of the information to be translated has not been translated.",null,false],[0,0,0,"OPLOCK_BREAK_IN_PROGRESS",null," An open/create operation completed while an opportunistic lock (oplock) break is underway.",null,false],[0,0,0,"VOLUME_MOUNTED",null," A new volume has been mounted by a file system.",null,false],[0,0,0,"RXACT_COMMITTED",null," This success level status indicates that the transaction state already exists for the registry subtree but that a transaction commit was previously aborted. The commit has now been completed.",null,false],[0,0,0,"NOTIFY_CLEANUP",null," Indicates that a notify change request has been completed due to closing the handle that made the notify change request.",null,false],[0,0,0,"NOTIFY_ENUM_DIR",null," Indicates that a notify change request is being completed and that the information is not being returned in the caller's buffer.\n The caller now needs to enumerate the files to find the changes.",null,false],[0,0,0,"NO_QUOTAS_FOR_ACCOUNT",null," {No Quotas} No system quota limits are specifically set for this account.",null,false],[0,0,0,"PRIMARY_TRANSPORT_CONNECT_FAILED",null," {Connect Failure on Primary Transport} An attempt was made to connect to the remote server %hs on the primary transport, but the connection failed.\n The computer WAS able to connect on a secondary transport.",null,false],[0,0,0,"PAGE_FAULT_TRANSITION",null," The page fault was a transition fault.",null,false],[0,0,0,"PAGE_FAULT_DEMAND_ZERO",null," The page fault was a demand zero fault.",null,false],[0,0,0,"PAGE_FAULT_COPY_ON_WRITE",null," The page fault was a demand zero fault.",null,false],[0,0,0,"PAGE_FAULT_GUARD_PAGE",null," The page fault was a demand zero fault.",null,false],[0,0,0,"PAGE_FAULT_PAGING_FILE",null," The page fault was satisfied by reading from a secondary storage device.",null,false],[0,0,0,"CACHE_PAGE_LOCKED",null," The cached page was locked during operation.",null,false],[0,0,0,"CRASH_DUMP",null," The crash dump exists in a paging file.",null,false],[0,0,0,"BUFFER_ALL_ZEROS",null," The specified buffer contains all zeros.",null,false],[0,0,0,"REPARSE_OBJECT",null," A reparse should be performed by the Object Manager because the name of the file resulted in a symbolic link.",null,false],[0,0,0,"RESOURCE_REQUIREMENTS_CHANGED",null," The device has succeeded a query-stop and its resource requirements have changed.",null,false],[0,0,0,"TRANSLATION_COMPLETE",null," The translator has translated these resources into the global space and no additional translations should be performed.",null,false],[0,0,0,"DS_MEMBERSHIP_EVALUATED_LOCALLY",null," The directory service evaluated group memberships locally, because it was unable to contact a global catalog server.",null,false],[0,0,0,"NOTHING_TO_TERMINATE",null," A process being terminated has no threads to terminate.",null,false],[0,0,0,"PROCESS_NOT_IN_JOB",null," The specified process is not part of a job.",null,false],[0,0,0,"PROCESS_IN_JOB",null," The specified process is part of a job.",null,false],[0,0,0,"VOLSNAP_HIBERNATE_READY",null," {Volume Shadow Copy Service} The system is now ready for hibernation.",null,false],[0,0,0,"FSFILTER_OP_COMPLETED_SUCCESSFULLY",null," A file system or file system filter driver has successfully completed an FsFilter operation.",null,false],[0,0,0,"INTERRUPT_VECTOR_ALREADY_CONNECTED",null," The specified interrupt vector was already connected.",null,false],[0,0,0,"INTERRUPT_STILL_CONNECTED",null," The specified interrupt vector is still connected.",null,false],[0,0,0,"PROCESS_CLONED",null," The current process is a cloned process.",null,false],[0,0,0,"FILE_LOCKED_WITH_ONLY_READERS",null," The file was locked and all users of the file can only read.",null,false],[0,0,0,"FILE_LOCKED_WITH_WRITERS",null," The file was locked and at least one user of the file can write.",null,false],[0,0,0,"RESOURCEMANAGER_READ_ONLY",null," The specified ResourceManager made no changes or updates to the resource under this transaction.",null,false],[0,0,0,"WAIT_FOR_OPLOCK",null," An operation is blocked and waiting for an oplock.",null,false],[0,0,0,"DBG_EXCEPTION_HANDLED",null," Debugger handled the exception.",null,false],[0,0,0,"DBG_CONTINUE",null," The debugger continued.",null,false],[0,0,0,"FLT_IO_COMPLETE",null," The IO was completed by a filter.",null,false],[0,0,0,"FILE_NOT_AVAILABLE",null," The file is temporarily unavailable.",null,false],[0,0,0,"SHARE_UNAVAILABLE",null," The share is temporarily unavailable.",null,false],[0,0,0,"CALLBACK_RETURNED_THREAD_AFFINITY",null," A threadpool worker thread entered a callback at thread affinity %p and exited at affinity %p.\n This is unexpected, indicating that the callback missed restoring the priority.",null,false],[0,0,0,"OBJECT_NAME_EXISTS",null," {Object Exists} An attempt was made to create an object but the object name already exists.",null,false],[0,0,0,"THREAD_WAS_SUSPENDED",null," {Thread Suspended} A thread termination occurred while the thread was suspended. The thread resumed, and termination proceeded.",null,false],[0,0,0,"WORKING_SET_LIMIT_RANGE",null," {Working Set Range Error} An attempt was made to set the working set minimum or maximum to values that are outside the allowable range.",null,false],[0,0,0,"IMAGE_NOT_AT_BASE",null," {Image Relocated} An image file could not be mapped at the address that is specified in the image file. Local fixes must be performed on this image.",null,false],[0,0,0,"RXACT_STATE_CREATED",null," This informational level status indicates that a specified registry subtree transaction state did not yet exist and had to be created.",null,false],[0,0,0,"SEGMENT_NOTIFICATION",null," {Segment Load} A virtual DOS machine (VDM) is loading, unloading, or moving an MS-DOS or Win16 program segment image.\n An exception is raised so that a debugger can load, unload, or track symbols and breakpoints within these 16-bit segments.",null,false],[0,0,0,"LOCAL_USER_SESSION_KEY",null," {Local Session Key} A user session key was requested for a local remote procedure call (RPC) connection.\n The session key that is returned is a constant value and not unique to this connection.",null,false],[0,0,0,"BAD_CURRENT_DIRECTORY",null," {Invalid Current Directory} The process cannot switch to the startup current directory %hs.\n Select OK to set the current directory to %hs, or select CANCEL to exit.",null,false],[0,0,0,"SERIAL_MORE_WRITES",null," {Serial IOCTL Complete} A serial I/O operation was completed by another write to a serial port. (The IOCTL_SERIAL_XOFF_COUNTER reached zero.)",null,false],[0,0,0,"REGISTRY_RECOVERED",null," {Registry Recovery} One of the files that contains the system registry data had to be recovered by using a log or alternate copy. The recovery was successful.",null,false],[0,0,0,"FT_READ_RECOVERY_FROM_BACKUP",null," {Redundant Read} To satisfy a read request, the Windows NT operating system fault-tolerant file system successfully read the requested data from a redundant copy.\n This was done because the file system encountered a failure on a member of the fault-tolerant volume but was unable to reassign the failing area of the device.",null,false],[0,0,0,"FT_WRITE_RECOVERY",null," {Redundant Write} To satisfy a write request, the Windows NT fault-tolerant file system successfully wrote a redundant copy of the information.\n This was done because the file system encountered a failure on a member of the fault-tolerant volume but was unable to reassign the failing area of the device.",null,false],[0,0,0,"SERIAL_COUNTER_TIMEOUT",null," {Serial IOCTL Timeout} A serial I/O operation completed because the time-out period expired.\n (The IOCTL_SERIAL_XOFF_COUNTER had not reached zero.)",null,false],[0,0,0,"NULL_LM_PASSWORD",null," {Password Too Complex} The Windows password is too complex to be converted to a LAN Manager password.\n The LAN Manager password that returned is a NULL string.",null,false],[0,0,0,"IMAGE_MACHINE_TYPE_MISMATCH",null," {Machine Type Mismatch} The image file %hs is valid but is for a machine type other than the current machine.\n Select OK to continue, or CANCEL to fail the DLL load.",null,false],[0,0,0,"RECEIVE_PARTIAL",null," {Partial Data Received} The network transport returned partial data to its client. The remaining data will be sent later.",null,false],[0,0,0,"RECEIVE_EXPEDITED",null," {Expedited Data Received} The network transport returned data to its client that was marked as expedited by the remote system.",null,false],[0,0,0,"RECEIVE_PARTIAL_EXPEDITED",null," {Partial Expedited Data Received} The network transport returned partial data to its client and this data was marked as expedited by the remote system. The remaining data will be sent later.",null,false],[0,0,0,"EVENT_DONE",null," {TDI Event Done} The TDI indication has completed successfully.",null,false],[0,0,0,"EVENT_PENDING",null," {TDI Event Pending} The TDI indication has entered the pending state.",null,false],[0,0,0,"CHECKING_FILE_SYSTEM",null," Checking file system on %wZ.",null,false],[0,0,0,"FATAL_APP_EXIT",null," {Fatal Application Exit} %hs",null,false],[0,0,0,"PREDEFINED_HANDLE",null," The specified registry key is referenced by a predefined handle.",null,false],[0,0,0,"WAS_UNLOCKED",null," {Page Unlocked} The page protection of a locked page was changed to 'No Access' and the page was unlocked from memory and from the process.",null,false],[0,0,0,"SERVICE_NOTIFICATION",null," %hs",null,false],[0,0,0,"WAS_LOCKED",null," {Page Locked} One of the pages to lock was already locked.",null,false],[0,0,0,"LOG_HARD_ERROR",null," Application popup: %1 : %2",null,false],[0,0,0,"ALREADY_WIN32",null," A Win32 process already exists.",null,false],[0,0,0,"WX86_UNSIMULATE",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_CONTINUE",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_SINGLE_STEP",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_BREAKPOINT",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_EXCEPTION_CONTINUE",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_EXCEPTION_LASTCHANCE",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_EXCEPTION_CHAIN",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"IMAGE_MACHINE_TYPE_MISMATCH_EXE",null," {Machine Type Mismatch} The image file %hs is valid but is for a machine type other than the current machine.",null,false],[0,0,0,"NO_YIELD_PERFORMED",null," A yield execution was performed and no thread was available to run.",null,false],[0,0,0,"TIMER_RESUME_IGNORED",null," The resume flag to a timer API was ignored.",null,false],[0,0,0,"ARBITRATION_UNHANDLED",null," The arbiter has deferred arbitration of these resources to its parent.",null,false],[0,0,0,"CARDBUS_NOT_SUPPORTED",null," The device has detected a CardBus card in its slot.",null,false],[0,0,0,"WX86_CREATEWX86TIB",null," An exception status code that is used by the Win32 x86 emulation subsystem.",null,false],[0,0,0,"MP_PROCESSOR_MISMATCH",null," The CPUs in this multiprocessor system are not all the same revision level.\n To use all processors, the operating system restricts itself to the features of the least capable processor in the system.\n If problems occur with this system, contact the CPU manufacturer to see if this mix of processors is supported.",null,false],[0,0,0,"HIBERNATED",null," The system was put into hibernation.",null,false],[0,0,0,"RESUME_HIBERNATION",null," The system was resumed from hibernation.",null,false],[0,0,0,"FIRMWARE_UPDATED",null," Windows has detected that the system firmware (BIOS) was updated [previous firmware date = %2, current firmware date %3].",null,false],[0,0,0,"DRIVERS_LEAKING_LOCKED_PAGES",null," A device driver is leaking locked I/O pages and is causing system degradation.\n The system has automatically enabled the tracking code to try and catch the culprit.",null,false],[0,0,0,"MESSAGE_RETRIEVED",null," The ALPC message being canceled has already been retrieved from the queue on the other side.",null,false],[0,0,0,"SYSTEM_POWERSTATE_TRANSITION",null," The system power state is transitioning from %2 to %3.",null,false],[0,0,0,"ALPC_CHECK_COMPLETION_LIST",null," The receive operation was successful.\n Check the ALPC completion list for the received message.",null,false],[0,0,0,"SYSTEM_POWERSTATE_COMPLEX_TRANSITION",null," The system power state is transitioning from %2 to %3 but could enter %4.",null,false],[0,0,0,"ACCESS_AUDIT_BY_POLICY",null," Access to %1 is monitored by policy rule %2.",null,false],[0,0,0,"ABANDON_HIBERFILE",null," A valid hibernation file has been invalidated and should be abandoned.",null,false],[0,0,0,"BIZRULES_NOT_ENABLED",null," Business rule scripts are disabled for the calling application.",null,false],[0,0,0,"WAKE_SYSTEM",null," The system has awoken.",null,false],[0,0,0,"DS_SHUTTING_DOWN",null," The directory service is shutting down.",null,false],[0,0,0,"DBG_REPLY_LATER",null," Debugger will reply later.",null,false],[0,0,0,"DBG_UNABLE_TO_PROVIDE_HANDLE",null," Debugger cannot provide a handle.",null,false],[0,0,0,"DBG_TERMINATE_THREAD",null," Debugger terminated the thread.",null,false],[0,0,0,"DBG_TERMINATE_PROCESS",null," Debugger terminated the process.",null,false],[0,0,0,"DBG_CONTROL_C",null," Debugger obtained control of C.",null,false],[0,0,0,"DBG_PRINTEXCEPTION_C",null," Debugger printed an exception on control C.",null,false],[0,0,0,"DBG_RIPEXCEPTION",null," Debugger received a RIP exception.",null,false],[0,0,0,"DBG_CONTROL_BREAK",null," Debugger received a control break.",null,false],[0,0,0,"DBG_COMMAND_EXCEPTION",null," Debugger command communication exception.",null,false],[0,0,0,"RPC_NT_UUID_LOCAL_ONLY",null," A UUID that is valid only on this computer has been allocated.",null,false],[0,0,0,"RPC_NT_SEND_INCOMPLETE",null," Some data remains to be sent in the request buffer.",null,false],[0,0,0,"CTX_CDM_CONNECT",null," The Client Drive Mapping Service has connected on Terminal Connection.",null,false],[0,0,0,"CTX_CDM_DISCONNECT",null," The Client Drive Mapping Service has disconnected on Terminal Connection.",null,false],[0,0,0,"SXS_RELEASE_ACTIVATION_CONTEXT",null," A kernel mode component is releasing a reference on an activation context.",null,false],[0,0,0,"RECOVERY_NOT_NEEDED",null," The transactional resource manager is already consistent. Recovery is not needed.",null,false],[0,0,0,"RM_ALREADY_STARTED",null," The transactional resource manager has already been started.",null,false],[0,0,0,"LOG_NO_RESTART",null," The log service encountered a log stream with no restart area.",null,false],[0,0,0,"VIDEO_DRIVER_DEBUG_REPORT_REQUEST",null," {Display Driver Recovered From Failure} The %hs display driver has detected a failure and recovered from it. Some graphical operations might have failed.\n The next time you restart the machine, a dialog box appears, giving you an opportunity to upload data about this failure to Microsoft.",null,false],[0,0,0,"GRAPHICS_PARTIAL_DATA_POPULATED",null," The specified buffer is not big enough to contain the entire requested dataset.\n Partial data is populated up to the size of the buffer.\n The caller needs to provide a buffer of the size as specified in the partially populated buffer's content (interface specific).",null,false],[0,0,0,"GRAPHICS_DRIVER_MISMATCH",null," The kernel driver detected a version mismatch between it and the user mode driver.",null,false],[0,0,0,"GRAPHICS_MODE_NOT_PINNED",null," No mode is pinned on the specified VidPN source/target.",null,false],[0,0,0,"GRAPHICS_NO_PREFERRED_MODE",null," The specified mode set does not specify a preference for one of its modes.",null,false],[0,0,0,"GRAPHICS_DATASET_IS_EMPTY",null," The specified dataset (for example, mode set, frequency range set, descriptor set, or topology) is empty.",null,false],[0,0,0,"GRAPHICS_NO_MORE_ELEMENTS_IN_DATASET",null," The specified dataset (for example, mode set, frequency range set, descriptor set, or topology) does not contain any more elements.",null,false],[0,0,0,"GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_PINNED",null," The specified content transformation is not pinned on the specified VidPN present path.",null,false],[0,0,0,"GRAPHICS_UNKNOWN_CHILD_STATUS",null," The child device presence was not reliably detected.",null,false],[0,0,0,"GRAPHICS_LEADLINK_START_DEFERRED",null," Starting the lead adapter in a linked configuration has been temporarily deferred.",null,false],[0,0,0,"GRAPHICS_POLLING_TOO_FREQUENTLY",null," The display adapter is being polled for children too frequently at the same polling level.",null,false],[0,0,0,"GRAPHICS_START_DEFERRED",null," Starting the adapter has been temporarily deferred.",null,false],[0,0,0,"NDIS_INDICATION_REQUIRED",null," The request will be completed later by an NDIS status indication.",null,false],[0,0,0,"GUARD_PAGE_VIOLATION",null," {EXCEPTION} Guard Page Exception A page of memory that marks the end of a data structure, such as a stack or an array, has been accessed.",null,false],[0,0,0,"DATATYPE_MISALIGNMENT",null," {EXCEPTION} Alignment Fault A data type misalignment was detected in a load or store instruction.",null,false],[0,0,0,"BREAKPOINT",null," {EXCEPTION} Breakpoint A breakpoint has been reached.",null,false],[0,0,0,"SINGLE_STEP",null," {EXCEPTION} Single Step A single step or trace operation has just been completed.",null,false],[0,0,0,"BUFFER_OVERFLOW",null," {Buffer Overflow} The data was too large to fit into the specified buffer.",null,false],[0,0,0,"NO_MORE_FILES",null," {No More Files} No more files were found which match the file specification.",null,false],[0,0,0,"WAKE_SYSTEM_DEBUGGER",null," {Kernel Debugger Awakened} The system debugger was awakened by an interrupt.",null,false],[0,0,0,"HANDLES_CLOSED",null," {Handles Closed} Handles to objects have been automatically closed because of the requested operation.",null,false],[0,0,0,"NO_INHERITANCE",null," {Non-Inheritable ACL} An access control list (ACL) contains no components that can be inherited.",null,false],[0,0,0,"GUID_SUBSTITUTION_MADE",null," {GUID Substitution} During the translation of a globally unique identifier (GUID) to a Windows security ID (SID), no administratively defined GUID prefix was found.\n A substitute prefix was used, which will not compromise system security.\n However, this might provide a more restrictive access than intended.",null,false],[0,0,0,"PARTIAL_COPY",null," Because of protection conflicts, not all the requested bytes could be copied.",null,false],[0,0,0,"DEVICE_PAPER_EMPTY",null," {Out of Paper} The printer is out of paper.",null,false],[0,0,0,"DEVICE_POWERED_OFF",null," {Device Power Is Off} The printer power has been turned off.",null,false],[0,0,0,"DEVICE_OFF_LINE",null," {Device Offline} The printer has been taken offline.",null,false],[0,0,0,"DEVICE_BUSY",null," {Device Busy} The device is currently busy.",null,false],[0,0,0,"NO_MORE_EAS",null," {No More EAs} No more extended attributes (EAs) were found for the file.",null,false],[0,0,0,"INVALID_EA_NAME",null," {Illegal EA} The specified extended attribute (EA) name contains at least one illegal character.",null,false],[0,0,0,"EA_LIST_INCONSISTENT",null," {Inconsistent EA List} The extended attribute (EA) list is inconsistent.",null,false],[0,0,0,"INVALID_EA_FLAG",null," {Invalid EA Flag} An invalid extended attribute (EA) flag was set.",null,false],[0,0,0,"VERIFY_REQUIRED",null," {Verifying Disk} The media has changed and a verify operation is in progress; therefore, no reads or writes can be performed to the device, except those that are used in the verify operation.",null,false],[0,0,0,"EXTRANEOUS_INFORMATION",null," {Too Much Information} The specified access control list (ACL) contained more information than was expected.",null,false],[0,0,0,"RXACT_COMMIT_NECESSARY",null," This warning level status indicates that the transaction state already exists for the registry subtree, but that a transaction commit was previously aborted.\n The commit has NOT been completed but has not been rolled back either; therefore, it can still be committed, if needed.",null,false],[0,0,0,"NO_MORE_ENTRIES",null," {No More Entries} No more entries are available from an enumeration operation.",null,false],[0,0,0,"FILEMARK_DETECTED",null," {Filemark Found} A filemark was detected.",null,false],[0,0,0,"MEDIA_CHANGED",null," {Media Changed} The media has changed.",null,false],[0,0,0,"BUS_RESET",null," {I/O Bus Reset} An I/O bus reset was detected.",null,false],[0,0,0,"END_OF_MEDIA",null," {End of Media} The end of the media was encountered.",null,false],[0,0,0,"BEGINNING_OF_MEDIA",null," The beginning of a tape or partition has been detected.",null,false],[0,0,0,"MEDIA_CHECK",null," {Media Changed} The media might have changed.",null,false],[0,0,0,"SETMARK_DETECTED",null," A tape access reached a set mark.",null,false],[0,0,0,"NO_DATA_DETECTED",null," During a tape access, the end of the data written is reached.",null,false],[0,0,0,"REDIRECTOR_HAS_OPEN_HANDLES",null," The redirector is in use and cannot be unloaded.",null,false],[0,0,0,"SERVER_HAS_OPEN_HANDLES",null," The server is in use and cannot be unloaded.",null,false],[0,0,0,"ALREADY_DISCONNECTED",null," The specified connection has already been disconnected.",null,false],[0,0,0,"LONGJUMP",null," A long jump has been executed.",null,false],[0,0,0,"CLEANER_CARTRIDGE_INSTALLED",null," A cleaner cartridge is present in the tape library.",null,false],[0,0,0,"PLUGPLAY_QUERY_VETOED",null," The Plug and Play query operation was not successful.",null,false],[0,0,0,"UNWIND_CONSOLIDATE",null," A frame consolidation has been executed.",null,false],[0,0,0,"REGISTRY_HIVE_RECOVERED",null," {Registry Hive Recovered} The registry hive (file): %hs was corrupted and it has been recovered. Some data might have been lost.",null,false],[0,0,0,"DLL_MIGHT_BE_INSECURE",null," The application is attempting to run executable code from the module %hs. This might be insecure.\n An alternative, %hs, is available. Should the application use the secure module %hs?",null,false],[0,0,0,"DLL_MIGHT_BE_INCOMPATIBLE",null," The application is loading executable code from the module %hs.\n This is secure but might be incompatible with previous releases of the operating system.\n An alternative, %hs, is available. Should the application use the secure module %hs?",null,false],[0,0,0,"STOPPED_ON_SYMLINK",null," The create operation stopped after reaching a symbolic link.",null,false],[0,0,0,"DEVICE_REQUIRES_CLEANING",null," The device has indicated that cleaning is necessary.",null,false],[0,0,0,"DEVICE_DOOR_OPEN",null," The device has indicated that its door is open. Further operations require it closed and secured.",null,false],[0,0,0,"DATA_LOST_REPAIR",null," Windows discovered a corruption in the file %hs. This file has now been repaired.\n Check if any data in the file was lost because of the corruption.",null,false],[0,0,0,"DBG_EXCEPTION_NOT_HANDLED",null," Debugger did not handle the exception.",null,false],[0,0,0,"CLUSTER_NODE_ALREADY_UP",null," The cluster node is already up.",null,false],[0,0,0,"CLUSTER_NODE_ALREADY_DOWN",null," The cluster node is already down.",null,false],[0,0,0,"CLUSTER_NETWORK_ALREADY_ONLINE",null," The cluster network is already online.",null,false],[0,0,0,"CLUSTER_NETWORK_ALREADY_OFFLINE",null," The cluster network is already offline.",null,false],[0,0,0,"CLUSTER_NODE_ALREADY_MEMBER",null," The cluster node is already a member of the cluster.",null,false],[0,0,0,"COULD_NOT_RESIZE_LOG",null," The log could not be set to the requested size.",null,false],[0,0,0,"NO_TXF_METADATA",null," There is no transaction metadata on the file.",null,false],[0,0,0,"CANT_RECOVER_WITH_HANDLE_OPEN",null," The file cannot be recovered because there is a handle still open on it.",null,false],[0,0,0,"TXF_METADATA_ALREADY_PRESENT",null," Transaction metadata is already present on this file and cannot be superseded.",null,false],[0,0,0,"TRANSACTION_SCOPE_CALLBACKS_NOT_SET",null," A transaction scope could not be entered because the scope handler has not been initialized.",null,false],[0,0,0,"VIDEO_HUNG_DISPLAY_DRIVER_THREAD_RECOVERED",null," {Display Driver Stopped Responding and recovered} The %hs display driver has stopped working normally. The recovery had been performed.",null,false],[0,0,0,"FLT_BUFFER_TOO_SMALL",null," {Buffer too small} The buffer is too small to contain the entry. No information has been written to the buffer.",null,false],[0,0,0,"FVE_PARTIAL_METADATA",null," Volume metadata read or write is incomplete.",null,false],[0,0,0,"FVE_TRANSIENT_STATE",null," BitLocker encryption keys were ignored because the volume was in a transient state.",null,false],[0,0,0,"UNSUCCESSFUL",null," {Operation Failed} The requested operation was unsuccessful.",null,false],[0,0,0,"NOT_IMPLEMENTED",null," {Not Implemented} The requested operation is not implemented.",null,false],[0,0,0,"INVALID_INFO_CLASS",null," {Invalid Parameter} The specified information class is not a valid information class for the specified object.",null,false],[0,0,0,"INFO_LENGTH_MISMATCH",null," The specified information record length does not match the length that is required for the specified information class.",null,false],[0,0,0,"ACCESS_VIOLATION",null," The instruction at 0x%08lx referenced memory at 0x%08lx. The memory could not be %s.",null,false],[0,0,0,"IN_PAGE_ERROR",null," The instruction at 0x%08lx referenced memory at 0x%08lx.\n The required data was not placed into memory because of an I/O error status of 0x%08lx.",null,false],[0,0,0,"PAGEFILE_QUOTA",null," The page file quota for the process has been exhausted.",null,false],[0,0,0,"INVALID_HANDLE",null," An invalid HANDLE was specified.",null,false],[0,0,0,"BAD_INITIAL_STACK",null," An invalid initial stack was specified in a call to NtCreateThread.",null,false],[0,0,0,"BAD_INITIAL_PC",null," An invalid initial start address was specified in a call to NtCreateThread.",null,false],[0,0,0,"INVALID_CID",null," An invalid client ID was specified.",null,false],[0,0,0,"TIMER_NOT_CANCELED",null," An attempt was made to cancel or set a timer that has an associated APC and the specified thread is not the thread that originally set the timer with an associated APC routine.",null,false],[0,0,0,"INVALID_PARAMETER",null," An invalid parameter was passed to a service or function.",null,false],[0,0,0,"NO_SUCH_DEVICE",null," A device that does not exist was specified.",null,false],[0,0,0,"NO_SUCH_FILE",null," {File Not Found} The file %hs does not exist.",null,false],[0,0,0,"INVALID_DEVICE_REQUEST",null," The specified request is not a valid operation for the target device.",null,false],[0,0,0,"END_OF_FILE",null," The end-of-file marker has been reached.\n There is no valid data in the file beyond this marker.",null,false],[0,0,0,"WRONG_VOLUME",null," {Wrong Volume} The wrong volume is in the drive. Insert volume %hs into drive %hs.",null,false],[0,0,0,"NO_MEDIA_IN_DEVICE",null," {No Disk} There is no disk in the drive. Insert a disk into drive %hs.",null,false],[0,0,0,"UNRECOGNIZED_MEDIA",null," {Unknown Disk Format} The disk in drive %hs is not formatted properly.\n Check the disk, and reformat it, if needed.",null,false],[0,0,0,"NONEXISTENT_SECTOR",null," {Sector Not Found} The specified sector does not exist.",null,false],[0,0,0,"MORE_PROCESSING_REQUIRED",null," {Still Busy} The specified I/O request packet (IRP) cannot be disposed of because the I/O operation is not complete.",null,false],[0,0,0,"NO_MEMORY",null," {Not Enough Quota} Not enough virtual memory or paging file quota is available to complete the specified operation.",null,false],[0,0,0,"CONFLICTING_ADDRESSES",null," {Conflicting Address Range} The specified address range conflicts with the address space.",null,false],[0,0,0,"NOT_MAPPED_VIEW",null," The address range to unmap is not a mapped view.",null,false],[0,0,0,"UNABLE_TO_FREE_VM",null," The virtual memory cannot be freed.",null,false],[0,0,0,"UNABLE_TO_DELETE_SECTION",null," The specified section cannot be deleted.",null,false],[0,0,0,"INVALID_SYSTEM_SERVICE",null," An invalid system service was specified in a system service call.",null,false],[0,0,0,"ILLEGAL_INSTRUCTION",null," {EXCEPTION} Illegal Instruction An attempt was made to execute an illegal instruction.",null,false],[0,0,0,"INVALID_LOCK_SEQUENCE",null," {Invalid Lock Sequence} An attempt was made to execute an invalid lock sequence.",null,false],[0,0,0,"INVALID_VIEW_SIZE",null," {Invalid Mapping} An attempt was made to create a view for a section that is bigger than the section.",null,false],[0,0,0,"INVALID_FILE_FOR_SECTION",null," {Bad File} The attributes of the specified mapping file for a section of memory cannot be read.",null,false],[0,0,0,"ALREADY_COMMITTED",null," {Already Committed} The specified address range is already committed.",null,false],[0,0,0,"ACCESS_DENIED",null," {Access Denied} A process has requested access to an object but has not been granted those access rights.",null,false],[0,0,0,"BUFFER_TOO_SMALL",null," {Buffer Too Small} The buffer is too small to contain the entry. No information has been written to the buffer.",null,false],[0,0,0,"OBJECT_TYPE_MISMATCH",null," {Wrong Type} There is a mismatch between the type of object that is required by the requested operation and the type of object that is specified in the request.",null,false],[0,0,0,"NONCONTINUABLE_EXCEPTION",null," {EXCEPTION} Cannot Continue Windows cannot continue from this exception.",null,false],[0,0,0,"INVALID_DISPOSITION",null," An invalid exception disposition was returned by an exception handler.",null,false],[0,0,0,"UNWIND",null," Unwind exception code.",null,false],[0,0,0,"BAD_STACK",null," An invalid or unaligned stack was encountered during an unwind operation.",null,false],[0,0,0,"INVALID_UNWIND_TARGET",null," An invalid unwind target was encountered during an unwind operation.",null,false],[0,0,0,"NOT_LOCKED",null," An attempt was made to unlock a page of memory that was not locked.",null,false],[0,0,0,"PARITY_ERROR",null," A device parity error on an I/O operation.",null,false],[0,0,0,"UNABLE_TO_DECOMMIT_VM",null," An attempt was made to decommit uncommitted virtual memory.",null,false],[0,0,0,"NOT_COMMITTED",null," An attempt was made to change the attributes on memory that has not been committed.",null,false],[0,0,0,"INVALID_PORT_ATTRIBUTES",null," Invalid object attributes specified to NtCreatePort or invalid port attributes specified to NtConnectPort.",null,false],[0,0,0,"PORT_MESSAGE_TOO_LONG",null," The length of the message that was passed to NtRequestPort or NtRequestWaitReplyPort is longer than the maximum message that is allowed by the port.",null,false],[0,0,0,"INVALID_PARAMETER_MIX",null," An invalid combination of parameters was specified.",null,false],[0,0,0,"INVALID_QUOTA_LOWER",null," An attempt was made to lower a quota limit below the current usage.",null,false],[0,0,0,"DISK_CORRUPT_ERROR",null," {Corrupt Disk} The file system structure on the disk is corrupt and unusable. Run the Chkdsk utility on the volume %hs.",null,false],[0,0,0,"OBJECT_NAME_INVALID",null," The object name is invalid.",null,false],[0,0,0,"OBJECT_NAME_NOT_FOUND",null," The object name is not found.",null,false],[0,0,0,"OBJECT_NAME_COLLISION",null," The object name already exists.",null,false],[0,0,0,"PORT_DISCONNECTED",null," An attempt was made to send a message to a disconnected communication port.",null,false],[0,0,0,"DEVICE_ALREADY_ATTACHED",null," An attempt was made to attach to a device that was already attached to another device.",null,false],[0,0,0,"OBJECT_PATH_INVALID",null," The object path component was not a directory object.",null,false],[0,0,0,"OBJECT_PATH_NOT_FOUND",null," {Path Not Found} The path %hs does not exist.",null,false],[0,0,0,"OBJECT_PATH_SYNTAX_BAD",null," The object path component was not a directory object.",null,false],[0,0,0,"DATA_OVERRUN",null," {Data Overrun} A data overrun error occurred.",null,false],[0,0,0,"DATA_LATE_ERROR",null," {Data Late} A data late error occurred.",null,false],[0,0,0,"DATA_ERROR",null," {Data Error} An error occurred in reading or writing data.",null,false],[0,0,0,"CRC_ERROR",null," {Bad CRC} A cyclic redundancy check (CRC) checksum error occurred.",null,false],[0,0,0,"SECTION_TOO_BIG",null," {Section Too Large} The specified section is too big to map the file.",null,false],[0,0,0,"PORT_CONNECTION_REFUSED",null," The NtConnectPort request is refused.",null,false],[0,0,0,"INVALID_PORT_HANDLE",null," The type of port handle is invalid for the operation that is requested.",null,false],[0,0,0,"SHARING_VIOLATION",null," A file cannot be opened because the share access flags are incompatible.",null,false],[0,0,0,"QUOTA_EXCEEDED",null," Insufficient quota exists to complete the operation.",null,false],[0,0,0,"INVALID_PAGE_PROTECTION",null," The specified page protection was not valid.",null,false],[0,0,0,"MUTANT_NOT_OWNED",null," An attempt to release a mutant object was made by a thread that was not the owner of the mutant object.",null,false],[0,0,0,"SEMAPHORE_LIMIT_EXCEEDED",null," An attempt was made to release a semaphore such that its maximum count would have been exceeded.",null,false],[0,0,0,"PORT_ALREADY_SET",null," An attempt was made to set the DebugPort or ExceptionPort of a process, but a port already exists in the process, or an attempt was made to set the CompletionPort of a file but a port was already set in the file, or an attempt was made to set the associated completion port of an ALPC port but it is already set.",null,false],[0,0,0,"SECTION_NOT_IMAGE",null," An attempt was made to query image information on a section that does not map an image.",null,false],[0,0,0,"SUSPEND_COUNT_EXCEEDED",null," An attempt was made to suspend a thread whose suspend count was at its maximum.",null,false],[0,0,0,"THREAD_IS_TERMINATING",null," An attempt was made to suspend a thread that has begun termination.",null,false],[0,0,0,"BAD_WORKING_SET_LIMIT",null," An attempt was made to set the working set limit to an invalid value (for example, the minimum greater than maximum).",null,false],[0,0,0,"INCOMPATIBLE_FILE_MAP",null," A section was created to map a file that is not compatible with an already existing section that maps the same file.",null,false],[0,0,0,"SECTION_PROTECTION",null," A view to a section specifies a protection that is incompatible with the protection of the initial view.",null,false],[0,0,0,"EAS_NOT_SUPPORTED",null," An operation involving EAs failed because the file system does not support EAs.",null,false],[0,0,0,"EA_TOO_LARGE",null," An EA operation failed because the EA set is too large.",null,false],[0,0,0,"NONEXISTENT_EA_ENTRY",null," An EA operation failed because the name or EA index is invalid.",null,false],[0,0,0,"NO_EAS_ON_FILE",null," The file for which EAs were requested has no EAs.",null,false],[0,0,0,"EA_CORRUPT_ERROR",null," The EA is corrupt and cannot be read.",null,false],[0,0,0,"FILE_LOCK_CONFLICT",null," A requested read/write cannot be granted due to a conflicting file lock.",null,false],[0,0,0,"LOCK_NOT_GRANTED",null," A requested file lock cannot be granted due to other existing locks.",null,false],[0,0,0,"DELETE_PENDING",null," A non-close operation has been requested of a file object that has a delete pending.",null,false],[0,0,0,"CTL_FILE_NOT_SUPPORTED",null," An attempt was made to set the control attribute on a file.\n This attribute is not supported in the destination file system.",null,false],[0,0,0,"UNKNOWN_REVISION",null," Indicates a revision number that was encountered or specified is not one that is known by the service.\n It might be a more recent revision than the service is aware of.",null,false],[0,0,0,"REVISION_MISMATCH",null," Indicates that two revision levels are incompatible.",null,false],[0,0,0,"INVALID_OWNER",null," Indicates a particular security ID cannot be assigned as the owner of an object.",null,false],[0,0,0,"INVALID_PRIMARY_GROUP",null," Indicates a particular security ID cannot be assigned as the primary group of an object.",null,false],[0,0,0,"NO_IMPERSONATION_TOKEN",null," An attempt has been made to operate on an impersonation token by a thread that is not currently impersonating a client.",null,false],[0,0,0,"CANT_DISABLE_MANDATORY",null," A mandatory group cannot be disabled.",null,false],[0,0,0,"NO_LOGON_SERVERS",null," No logon servers are currently available to service the logon request.",null,false],[0,0,0,"NO_SUCH_LOGON_SESSION",null," A specified logon session does not exist. It might already have been terminated.",null,false],[0,0,0,"NO_SUCH_PRIVILEGE",null," A specified privilege does not exist.",null,false],[0,0,0,"PRIVILEGE_NOT_HELD",null," A required privilege is not held by the client.",null,false],[0,0,0,"INVALID_ACCOUNT_NAME",null," The name provided is not a properly formed account name.",null,false],[0,0,0,"USER_EXISTS",null," The specified account already exists.",null,false],[0,0,0,"NO_SUCH_USER",null," The specified account does not exist.",null,false],[0,0,0,"GROUP_EXISTS",null," The specified group already exists.",null,false],[0,0,0,"NO_SUCH_GROUP",null," The specified group does not exist.",null,false],[0,0,0,"MEMBER_IN_GROUP",null," The specified user account is already in the specified group account.\n Also used to indicate a group cannot be deleted because it contains a member.",null,false],[0,0,0,"MEMBER_NOT_IN_GROUP",null," The specified user account is not a member of the specified group account.",null,false],[0,0,0,"LAST_ADMIN",null," Indicates the requested operation would disable or delete the last remaining administration account.\n This is not allowed to prevent creating a situation in which the system cannot be administrated.",null,false],[0,0,0,"WRONG_PASSWORD",null," When trying to update a password, this return status indicates that the value provided as the current password is not correct.",null,false],[0,0,0,"ILL_FORMED_PASSWORD",null," When trying to update a password, this return status indicates that the value provided for the new password contains values that are not allowed in passwords.",null,false],[0,0,0,"PASSWORD_RESTRICTION",null," When trying to update a password, this status indicates that some password update rule has been violated.\n For example, the password might not meet length criteria.",null,false],[0,0,0,"LOGON_FAILURE",null," The attempted logon is invalid.\n This is either due to a bad username or authentication information.",null,false],[0,0,0,"ACCOUNT_RESTRICTION",null," Indicates a referenced user name and authentication information are valid, but some user account restriction has prevented successful authentication (such as time-of-day restrictions).",null,false],[0,0,0,"INVALID_LOGON_HOURS",null," The user account has time restrictions and cannot be logged onto at this time.",null,false],[0,0,0,"INVALID_WORKSTATION",null," The user account is restricted so that it cannot be used to log on from the source workstation.",null,false],[0,0,0,"PASSWORD_EXPIRED",null," The user account password has expired.",null,false],[0,0,0,"ACCOUNT_DISABLED",null," The referenced account is currently disabled and cannot be logged on to.",null,false],[0,0,0,"NONE_MAPPED",null," None of the information to be translated has been translated.",null,false],[0,0,0,"TOO_MANY_LUIDS_REQUESTED",null," The number of LUIDs requested cannot be allocated with a single allocation.",null,false],[0,0,0,"LUIDS_EXHAUSTED",null," Indicates there are no more LUIDs to allocate.",null,false],[0,0,0,"INVALID_SUB_AUTHORITY",null," Indicates the sub-authority value is invalid for the particular use.",null,false],[0,0,0,"INVALID_ACL",null," Indicates the ACL structure is not valid.",null,false],[0,0,0,"INVALID_SID",null," Indicates the SID structure is not valid.",null,false],[0,0,0,"INVALID_SECURITY_DESCR",null," Indicates the SECURITY_DESCRIPTOR structure is not valid.",null,false],[0,0,0,"PROCEDURE_NOT_FOUND",null," Indicates the specified procedure address cannot be found in the DLL.",null,false],[0,0,0,"INVALID_IMAGE_FORMAT",null," {Bad Image} %hs is either not designed to run on Windows or it contains an error.\n Try installing the program again using the original installation media or contact your system administrator or the software vendor for support.",null,false],[0,0,0,"NO_TOKEN",null," An attempt was made to reference a token that does not exist.\n This is typically done by referencing the token that is associated with a thread when the thread is not impersonating a client.",null,false],[0,0,0,"BAD_INHERITANCE_ACL",null," Indicates that an attempt to build either an inherited ACL or ACE was not successful. This can be caused by a number of things.\n One of the more probable causes is the replacement of a CreatorId with a SID that did not fit into the ACE or ACL.",null,false],[0,0,0,"RANGE_NOT_LOCKED",null," The range specified in NtUnlockFile was not locked.",null,false],[0,0,0,"DISK_FULL",null," An operation failed because the disk was full.",null,false],[0,0,0,"SERVER_DISABLED",null," The GUID allocation server is disabled at the moment.",null,false],[0,0,0,"SERVER_NOT_DISABLED",null," The GUID allocation server is enabled at the moment.",null,false],[0,0,0,"TOO_MANY_GUIDS_REQUESTED",null," Too many GUIDs were requested from the allocation server at once.",null,false],[0,0,0,"GUIDS_EXHAUSTED",null," The GUIDs could not be allocated because the Authority Agent was exhausted.",null,false],[0,0,0,"INVALID_ID_AUTHORITY",null," The value provided was an invalid value for an identifier authority.",null,false],[0,0,0,"AGENTS_EXHAUSTED",null," No more authority agent values are available for the particular identifier authority value.",null,false],[0,0,0,"INVALID_VOLUME_LABEL",null," An invalid volume label has been specified.",null,false],[0,0,0,"SECTION_NOT_EXTENDED",null," A mapped section could not be extended.",null,false],[0,0,0,"NOT_MAPPED_DATA",null," Specified section to flush does not map a data file.",null,false],[0,0,0,"RESOURCE_DATA_NOT_FOUND",null," Indicates the specified image file did not contain a resource section.",null,false],[0,0,0,"RESOURCE_TYPE_NOT_FOUND",null," Indicates the specified resource type cannot be found in the image file.",null,false],[0,0,0,"RESOURCE_NAME_NOT_FOUND",null," Indicates the specified resource name cannot be found in the image file.",null,false],[0,0,0,"ARRAY_BOUNDS_EXCEEDED",null," {EXCEPTION} Array bounds exceeded.",null,false],[0,0,0,"FLOAT_DENORMAL_OPERAND",null," {EXCEPTION} Floating-point denormal operand.",null,false],[0,0,0,"FLOAT_DIVIDE_BY_ZERO",null," {EXCEPTION} Floating-point division by zero.",null,false],[0,0,0,"FLOAT_INEXACT_RESULT",null," {EXCEPTION} Floating-point inexact result.",null,false],[0,0,0,"FLOAT_INVALID_OPERATION",null," {EXCEPTION} Floating-point invalid operation.",null,false],[0,0,0,"FLOAT_OVERFLOW",null," {EXCEPTION} Floating-point overflow.",null,false],[0,0,0,"FLOAT_STACK_CHECK",null," {EXCEPTION} Floating-point stack check.",null,false],[0,0,0,"FLOAT_UNDERFLOW",null," {EXCEPTION} Floating-point underflow.",null,false],[0,0,0,"INTEGER_DIVIDE_BY_ZERO",null," {EXCEPTION} Integer division by zero.",null,false],[0,0,0,"INTEGER_OVERFLOW",null," {EXCEPTION} Integer overflow.",null,false],[0,0,0,"PRIVILEGED_INSTRUCTION",null," {EXCEPTION} Privileged instruction.",null,false],[0,0,0,"TOO_MANY_PAGING_FILES",null," An attempt was made to install more paging files than the system supports.",null,false],[0,0,0,"FILE_INVALID",null," The volume for a file has been externally altered such that the opened file is no longer valid.",null,false],[0,0,0,"ALLOTTED_SPACE_EXCEEDED",null," When a block of memory is allotted for future updates, such as the memory allocated to hold discretionary access control and primary group information, successive updates might exceed the amount of memory originally allotted.\n Because a quota might already have been charged to several processes that have handles to the object, it is not reasonable to alter the size of the allocated memory.\n Instead, a request that requires more memory than has been allotted must fail and the STATUS_ALLOTTED_SPACE_EXCEEDED error returned.",null,false],[0,0,0,"INSUFFICIENT_RESOURCES",null," Insufficient system resources exist to complete the API.",null,false],[0,0,0,"DFS_EXIT_PATH_FOUND",null," An attempt has been made to open a DFS exit path control file.",null,false],[0,0,0,"DEVICE_DATA_ERROR",null," There are bad blocks (sectors) on the hard disk.",null,false],[0,0,0,"DEVICE_NOT_CONNECTED",null," There is bad cabling, non-termination, or the controller is not able to obtain access to the hard disk.",null,false],[0,0,0,"FREE_VM_NOT_AT_BASE",null," Virtual memory cannot be freed because the base address is not the base of the region and a region size of zero was specified.",null,false],[0,0,0,"MEMORY_NOT_ALLOCATED",null," An attempt was made to free virtual memory that is not allocated.",null,false],[0,0,0,"WORKING_SET_QUOTA",null," The working set is not big enough to allow the requested pages to be locked.",null,false],[0,0,0,"MEDIA_WRITE_PROTECTED",null," {Write Protect Error} The disk cannot be written to because it is write-protected.\n Remove the write protection from the volume %hs in drive %hs.",null,false],[0,0,0,"DEVICE_NOT_READY",null," {Drive Not Ready} The drive is not ready for use; its door might be open.\n Check drive %hs and make sure that a disk is inserted and that the drive door is closed.",null,false],[0,0,0,"INVALID_GROUP_ATTRIBUTES",null," The specified attributes are invalid or are incompatible with the attributes for the group as a whole.",null,false],[0,0,0,"BAD_IMPERSONATION_LEVEL",null," A specified impersonation level is invalid.\n Also used to indicate that a required impersonation level was not provided.",null,false],[0,0,0,"CANT_OPEN_ANONYMOUS",null," An attempt was made to open an anonymous-level token. Anonymous tokens cannot be opened.",null,false],[0,0,0,"BAD_VALIDATION_CLASS",null," The validation information class requested was invalid.",null,false],[0,0,0,"BAD_TOKEN_TYPE",null," The type of a token object is inappropriate for its attempted use.",null,false],[0,0,0,"BAD_MASTER_BOOT_RECORD",null," The type of a token object is inappropriate for its attempted use.",null,false],[0,0,0,"INSTRUCTION_MISALIGNMENT",null," An attempt was made to execute an instruction at an unaligned address and the host system does not support unaligned instruction references.",null,false],[0,0,0,"INSTANCE_NOT_AVAILABLE",null," The maximum named pipe instance count has been reached.",null,false],[0,0,0,"PIPE_NOT_AVAILABLE",null," An instance of a named pipe cannot be found in the listening state.",null,false],[0,0,0,"INVALID_PIPE_STATE",null," The named pipe is not in the connected or closing state.",null,false],[0,0,0,"PIPE_BUSY",null," The specified pipe is set to complete operations and there are current I/O operations queued so that it cannot be changed to queue operations.",null,false],[0,0,0,"ILLEGAL_FUNCTION",null," The specified handle is not open to the server end of the named pipe.",null,false],[0,0,0,"PIPE_DISCONNECTED",null," The specified named pipe is in the disconnected state.",null,false],[0,0,0,"PIPE_CLOSING",null," The specified named pipe is in the closing state.",null,false],[0,0,0,"PIPE_CONNECTED",null," The specified named pipe is in the connected state.",null,false],[0,0,0,"PIPE_LISTENING",null," The specified named pipe is in the listening state.",null,false],[0,0,0,"INVALID_READ_MODE",null," The specified named pipe is not in message mode.",null,false],[0,0,0,"IO_TIMEOUT",null," {Device Timeout} The specified I/O operation on %hs was not completed before the time-out period expired.",null,false],[0,0,0,"FILE_FORCED_CLOSED",null," The specified file has been closed by another process.",null,false],[0,0,0,"PROFILING_NOT_STARTED",null," Profiling is not started.",null,false],[0,0,0,"PROFILING_NOT_STOPPED",null," Profiling is not stopped.",null,false],[0,0,0,"COULD_NOT_INTERPRET",null," The passed ACL did not contain the minimum required information.",null,false],[0,0,0,"FILE_IS_A_DIRECTORY",null," The file that was specified as a target is a directory, and the caller specified that it could be anything but a directory.",null,false],[0,0,0,"NOT_SUPPORTED",null," The request is not supported.",null,false],[0,0,0,"REMOTE_NOT_LISTENING",null," This remote computer is not listening.",null,false],[0,0,0,"DUPLICATE_NAME",null," A duplicate name exists on the network.",null,false],[0,0,0,"BAD_NETWORK_PATH",null," The network path cannot be located.",null,false],[0,0,0,"NETWORK_BUSY",null," The network is busy.",null,false],[0,0,0,"DEVICE_DOES_NOT_EXIST",null," This device does not exist.",null,false],[0,0,0,"TOO_MANY_COMMANDS",null," The network BIOS command limit has been reached.",null,false],[0,0,0,"ADAPTER_HARDWARE_ERROR",null," An I/O adapter hardware error has occurred.",null,false],[0,0,0,"INVALID_NETWORK_RESPONSE",null," The network responded incorrectly.",null,false],[0,0,0,"UNEXPECTED_NETWORK_ERROR",null," An unexpected network error occurred.",null,false],[0,0,0,"BAD_REMOTE_ADAPTER",null," The remote adapter is not compatible.",null,false],[0,0,0,"PRINT_QUEUE_FULL",null," The print queue is full.",null,false],[0,0,0,"NO_SPOOL_SPACE",null," Space to store the file that is waiting to be printed is not available on the server.",null,false],[0,0,0,"PRINT_CANCELLED",null," The requested print file has been canceled.",null,false],[0,0,0,"NETWORK_NAME_DELETED",null," The network name was deleted.",null,false],[0,0,0,"NETWORK_ACCESS_DENIED",null," Network access is denied.",null,false],[0,0,0,"BAD_DEVICE_TYPE",null," {Incorrect Network Resource Type} The specified device type (LPT, for example) conflicts with the actual device type on the remote resource.",null,false],[0,0,0,"BAD_NETWORK_NAME",null," {Network Name Not Found} The specified share name cannot be found on the remote server.",null,false],[0,0,0,"TOO_MANY_NAMES",null," The name limit for the network adapter card of the local computer was exceeded.",null,false],[0,0,0,"TOO_MANY_SESSIONS",null," The network BIOS session limit was exceeded.",null,false],[0,0,0,"SHARING_PAUSED",null," File sharing has been temporarily paused.",null,false],[0,0,0,"REQUEST_NOT_ACCEPTED",null," No more connections can be made to this remote computer at this time because the computer has already accepted the maximum number of connections.",null,false],[0,0,0,"REDIRECTOR_PAUSED",null," Print or disk redirection is temporarily paused.",null,false],[0,0,0,"NET_WRITE_FAULT",null," A network data fault occurred.",null,false],[0,0,0,"PROFILING_AT_LIMIT",null," The number of active profiling objects is at the maximum and no more can be started.",null,false],[0,0,0,"NOT_SAME_DEVICE",null," {Incorrect Volume} The destination file of a rename request is located on a different device than the source of the rename request.",null,false],[0,0,0,"FILE_RENAMED",null," The specified file has been renamed and thus cannot be modified.",null,false],[0,0,0,"VIRTUAL_CIRCUIT_CLOSED",null," {Network Request Timeout} The session with a remote server has been disconnected because the time-out interval for a request has expired.",null,false],[0,0,0,"NO_SECURITY_ON_OBJECT",null," Indicates an attempt was made to operate on the security of an object that does not have security associated with it.",null,false],[0,0,0,"CANT_WAIT",null," Used to indicate that an operation cannot continue without blocking for I/O.",null,false],[0,0,0,"PIPE_EMPTY",null," Used to indicate that a read operation was done on an empty pipe.",null,false],[0,0,0,"CANT_ACCESS_DOMAIN_INFO",null," Configuration information could not be read from the domain controller, either because the machine is unavailable or access has been denied.",null,false],[0,0,0,"CANT_TERMINATE_SELF",null," Indicates that a thread attempted to terminate itself by default (called NtTerminateThread with NULL) and it was the last thread in the current process.",null,false],[0,0,0,"INVALID_SERVER_STATE",null," Indicates the Sam Server was in the wrong state to perform the desired operation.",null,false],[0,0,0,"INVALID_DOMAIN_STATE",null," Indicates the domain was in the wrong state to perform the desired operation.",null,false],[0,0,0,"INVALID_DOMAIN_ROLE",null," This operation is only allowed for the primary domain controller of the domain.",null,false],[0,0,0,"NO_SUCH_DOMAIN",null," The specified domain did not exist.",null,false],[0,0,0,"DOMAIN_EXISTS",null," The specified domain already exists.",null,false],[0,0,0,"DOMAIN_LIMIT_EXCEEDED",null," An attempt was made to exceed the limit on the number of domains per server for this release.",null,false],[0,0,0,"OPLOCK_NOT_GRANTED",null," An error status returned when the opportunistic lock (oplock) request is denied.",null,false],[0,0,0,"INVALID_OPLOCK_PROTOCOL",null," An error status returned when an invalid opportunistic lock (oplock) acknowledgment is received by a file system.",null,false],[0,0,0,"INTERNAL_DB_CORRUPTION",null," This error indicates that the requested operation cannot be completed due to a catastrophic media failure or an on-disk data structure corruption.",null,false],[0,0,0,"INTERNAL_ERROR",null," An internal error occurred.",null,false],[0,0,0,"GENERIC_NOT_MAPPED",null," Indicates generic access types were contained in an access mask which should already be mapped to non-generic access types.",null,false],[0,0,0,"BAD_DESCRIPTOR_FORMAT",null," Indicates a security descriptor is not in the necessary format (absolute or self-relative).",null,false],[0,0,0,"INVALID_USER_BUFFER",null," An access to a user buffer failed at an expected point in time.\n This code is defined because the caller does not want to accept STATUS_ACCESS_VIOLATION in its filter.",null,false],[0,0,0,"UNEXPECTED_IO_ERROR",null," If an I/O error that is not defined in the standard FsRtl filter is returned, it is converted to the following error, which is guaranteed to be in the filter.\n In this case, information is lost; however, the filter correctly handles the exception.",null,false],[0,0,0,"UNEXPECTED_MM_CREATE_ERR",null," If an MM error that is not defined in the standard FsRtl filter is returned, it is converted to one of the following errors, which are guaranteed to be in the filter.\n In this case, information is lost; however, the filter correctly handles the exception.",null,false],[0,0,0,"UNEXPECTED_MM_MAP_ERROR",null," If an MM error that is not defined in the standard FsRtl filter is returned, it is converted to one of the following errors, which are guaranteed to be in the filter.\n In this case, information is lost; however, the filter correctly handles the exception.",null,false],[0,0,0,"UNEXPECTED_MM_EXTEND_ERR",null," If an MM error that is not defined in the standard FsRtl filter is returned, it is converted to one of the following errors, which are guaranteed to be in the filter.\n In this case, information is lost; however, the filter correctly handles the exception.",null,false],[0,0,0,"NOT_LOGON_PROCESS",null," The requested action is restricted for use by logon processes only.\n The calling process has not registered as a logon process.",null,false],[0,0,0,"LOGON_SESSION_EXISTS",null," An attempt has been made to start a new session manager or LSA logon session by using an ID that is already in use.",null,false],[0,0,0,"INVALID_PARAMETER_1",null," An invalid parameter was passed to a service or function as the first argument.",null,false],[0,0,0,"INVALID_PARAMETER_2",null," An invalid parameter was passed to a service or function as the second argument.",null,false],[0,0,0,"INVALID_PARAMETER_3",null," An invalid parameter was passed to a service or function as the third argument.",null,false],[0,0,0,"INVALID_PARAMETER_4",null," An invalid parameter was passed to a service or function as the fourth argument.",null,false],[0,0,0,"INVALID_PARAMETER_5",null," An invalid parameter was passed to a service or function as the fifth argument.",null,false],[0,0,0,"INVALID_PARAMETER_6",null," An invalid parameter was passed to a service or function as the sixth argument.",null,false],[0,0,0,"INVALID_PARAMETER_7",null," An invalid parameter was passed to a service or function as the seventh argument.",null,false],[0,0,0,"INVALID_PARAMETER_8",null," An invalid parameter was passed to a service or function as the eighth argument.",null,false],[0,0,0,"INVALID_PARAMETER_9",null," An invalid parameter was passed to a service or function as the ninth argument.",null,false],[0,0,0,"INVALID_PARAMETER_10",null," An invalid parameter was passed to a service or function as the tenth argument.",null,false],[0,0,0,"INVALID_PARAMETER_11",null," An invalid parameter was passed to a service or function as the eleventh argument.",null,false],[0,0,0,"INVALID_PARAMETER_12",null," An invalid parameter was passed to a service or function as the twelfth argument.",null,false],[0,0,0,"REDIRECTOR_NOT_STARTED",null," An attempt was made to access a network file, but the network software was not yet started.",null,false],[0,0,0,"REDIRECTOR_STARTED",null," An attempt was made to start the redirector, but the redirector has already been started.",null,false],[0,0,0,"STACK_OVERFLOW",null," A new guard page for the stack cannot be created.",null,false],[0,0,0,"NO_SUCH_PACKAGE",null," A specified authentication package is unknown.",null,false],[0,0,0,"BAD_FUNCTION_TABLE",null," A malformed function table was encountered during an unwind operation.",null,false],[0,0,0,"VARIABLE_NOT_FOUND",null," Indicates the specified environment variable name was not found in the specified environment block.",null,false],[0,0,0,"DIRECTORY_NOT_EMPTY",null," Indicates that the directory trying to be deleted is not empty.",null,false],[0,0,0,"FILE_CORRUPT_ERROR",null," {Corrupt File} The file or directory %hs is corrupt and unreadable. Run the Chkdsk utility.",null,false],[0,0,0,"NOT_A_DIRECTORY",null," A requested opened file is not a directory.",null,false],[0,0,0,"BAD_LOGON_SESSION_STATE",null," The logon session is not in a state that is consistent with the requested operation.",null,false],[0,0,0,"LOGON_SESSION_COLLISION",null," An internal LSA error has occurred.\n An authentication package has requested the creation of a logon session but the ID of an already existing logon session has been specified.",null,false],[0,0,0,"NAME_TOO_LONG",null," A specified name string is too long for its intended use.",null,false],[0,0,0,"FILES_OPEN",null," The user attempted to force close the files on a redirected drive, but there were opened files on the drive, and the user did not specify a sufficient level of force.",null,false],[0,0,0,"CONNECTION_IN_USE",null," The user attempted to force close the files on a redirected drive, but there were opened directories on the drive, and the user did not specify a sufficient level of force.",null,false],[0,0,0,"MESSAGE_NOT_FOUND",null," RtlFindMessage could not locate the requested message ID in the message table resource.",null,false],[0,0,0,"PROCESS_IS_TERMINATING",null," An attempt was made to duplicate an object handle into or out of an exiting process.",null,false],[0,0,0,"INVALID_LOGON_TYPE",null," Indicates an invalid value has been provided for the LogonType requested.",null,false],[0,0,0,"NO_GUID_TRANSLATION",null," Indicates that an attempt was made to assign protection to a file system file or directory and one of the SIDs in the security descriptor could not be translated into a GUID that could be stored by the file system.\n This causes the protection attempt to fail, which might cause a file creation attempt to fail.",null,false],[0,0,0,"CANNOT_IMPERSONATE",null," Indicates that an attempt has been made to impersonate via a named pipe that has not yet been read from.",null,false],[0,0,0,"IMAGE_ALREADY_LOADED",null," Indicates that the specified image is already loaded.",null,false],[0,0,0,"NO_LDT",null," Indicates that an attempt was made to change the size of the LDT for a process that has no LDT.",null,false],[0,0,0,"INVALID_LDT_SIZE",null," Indicates that an attempt was made to grow an LDT by setting its size, or that the size was not an even number of selectors.",null,false],[0,0,0,"INVALID_LDT_OFFSET",null," Indicates that the starting value for the LDT information was not an integral multiple of the selector size.",null,false],[0,0,0,"INVALID_LDT_DESCRIPTOR",null," Indicates that the user supplied an invalid descriptor when trying to set up LDT descriptors.",null,false],[0,0,0,"INVALID_IMAGE_NE_FORMAT",null," The specified image file did not have the correct format. It appears to be NE format.",null,false],[0,0,0,"RXACT_INVALID_STATE",null," Indicates that the transaction state of a registry subtree is incompatible with the requested operation.\n For example, a request has been made to start a new transaction with one already in progress, or a request has been made to apply a transaction when one is not currently in progress.",null,false],[0,0,0,"RXACT_COMMIT_FAILURE",null," Indicates an error has occurred during a registry transaction commit.\n The database has been left in an unknown, but probably inconsistent, state.\n The state of the registry transaction is left as COMMITTING.",null,false],[0,0,0,"MAPPED_FILE_SIZE_ZERO",null," An attempt was made to map a file of size zero with the maximum size specified as zero.",null,false],[0,0,0,"TOO_MANY_OPENED_FILES",null," Too many files are opened on a remote server.\n This error should only be returned by the Windows redirector on a remote drive.",null,false],[0,0,0,"CANCELLED",null," The I/O request was canceled.",null,false],[0,0,0,"CANNOT_DELETE",null," An attempt has been made to remove a file or directory that cannot be deleted.",null,false],[0,0,0,"INVALID_COMPUTER_NAME",null," Indicates a name that was specified as a remote computer name is syntactically invalid.",null,false],[0,0,0,"FILE_DELETED",null," An I/O request other than close was performed on a file after it was deleted, which can only happen to a request that did not complete before the last handle was closed via NtClose.",null,false],[0,0,0,"SPECIAL_ACCOUNT",null," Indicates an operation that is incompatible with built-in accounts has been attempted on a built-in (special) SAM account. For example, built-in accounts cannot be deleted.",null,false],[0,0,0,"SPECIAL_GROUP",null," The operation requested cannot be performed on the specified group because it is a built-in special group.",null,false],[0,0,0,"SPECIAL_USER",null," The operation requested cannot be performed on the specified user because it is a built-in special user.",null,false],[0,0,0,"MEMBERS_PRIMARY_GROUP",null," Indicates a member cannot be removed from a group because the group is currently the member's primary group.",null,false],[0,0,0,"FILE_CLOSED",null," An I/O request other than close and several other special case operations was attempted using a file object that had already been closed.",null,false],[0,0,0,"TOO_MANY_THREADS",null," Indicates a process has too many threads to perform the requested action.\n For example, assignment of a primary token can be performed only when a process has zero or one threads.",null,false],[0,0,0,"THREAD_NOT_IN_PROCESS",null," An attempt was made to operate on a thread within a specific process, but the specified thread is not in the specified process.",null,false],[0,0,0,"TOKEN_ALREADY_IN_USE",null," An attempt was made to establish a token for use as a primary token but the token is already in use.\n A token can only be the primary token of one process at a time.",null,false],[0,0,0,"PAGEFILE_QUOTA_EXCEEDED",null," The page file quota was exceeded.",null,false],[0,0,0,"COMMITMENT_LIMIT",null," {Out of Virtual Memory} Your system is low on virtual memory.\n To ensure that Windows runs correctly, increase the size of your virtual memory paging file. For more information, see Help.",null,false],[0,0,0,"INVALID_IMAGE_LE_FORMAT",null," The specified image file did not have the correct format: it appears to be LE format.",null,false],[0,0,0,"INVALID_IMAGE_NOT_MZ",null," The specified image file did not have the correct format: it did not have an initial MZ.",null,false],[0,0,0,"INVALID_IMAGE_PROTECT",null," The specified image file did not have the correct format: it did not have a proper e_lfarlc in the MZ header.",null,false],[0,0,0,"INVALID_IMAGE_WIN_16",null," The specified image file did not have the correct format: it appears to be a 16-bit Windows image.",null,false],[0,0,0,"LOGON_SERVER_CONFLICT",null," The Netlogon service cannot start because another Netlogon service running in the domain conflicts with the specified role.",null,false],[0,0,0,"TIME_DIFFERENCE_AT_DC",null," The time at the primary domain controller is different from the time at the backup domain controller or member server by too large an amount.",null,false],[0,0,0,"SYNCHRONIZATION_REQUIRED",null," On applicable Windows Server releases, the SAM database is significantly out of synchronization with the copy on the domain controller. A complete synchronization is required.",null,false],[0,0,0,"DLL_NOT_FOUND",null," {Unable To Locate Component} This application has failed to start because %hs was not found.\n Reinstalling the application might fix this problem.",null,false],[0,0,0,"OPEN_FAILED",null," The NtCreateFile API failed. This error should never be returned to an application; it is a place holder for the Windows LAN Manager Redirector to use in its internal error-mapping routines.",null,false],[0,0,0,"IO_PRIVILEGE_FAILED",null," {Privilege Failed} The I/O permissions for the process could not be changed.",null,false],[0,0,0,"ORDINAL_NOT_FOUND",null," {Ordinal Not Found} The ordinal %ld could not be located in the dynamic link library %hs.",null,false],[0,0,0,"ENTRYPOINT_NOT_FOUND",null," {Entry Point Not Found} The procedure entry point %hs could not be located in the dynamic link library %hs.",null,false],[0,0,0,"CONTROL_C_EXIT",null," {Application Exit by CTRL+C} The application terminated as a result of a CTRL+C.",null,false],[0,0,0,"LOCAL_DISCONNECT",null," {Virtual Circuit Closed} The network transport on your computer has closed a network connection.\n There might or might not be I/O requests outstanding.",null,false],[0,0,0,"REMOTE_DISCONNECT",null," {Virtual Circuit Closed} The network transport on a remote computer has closed a network connection.\n There might or might not be I/O requests outstanding.",null,false],[0,0,0,"REMOTE_RESOURCES",null," {Insufficient Resources on Remote Computer} The remote computer has insufficient resources to complete the network request.\n For example, the remote computer might not have enough available memory to carry out the request at this time.",null,false],[0,0,0,"LINK_FAILED",null," {Virtual Circuit Closed} An existing connection (virtual circuit) has been broken at the remote computer.\n There is probably something wrong with the network software protocol or the network hardware on the remote computer.",null,false],[0,0,0,"LINK_TIMEOUT",null," {Virtual Circuit Closed} The network transport on your computer has closed a network connection because it had to wait too long for a response from the remote computer.",null,false],[0,0,0,"INVALID_CONNECTION",null," The connection handle that was given to the transport was invalid.",null,false],[0,0,0,"INVALID_ADDRESS",null," The address handle that was given to the transport was invalid.",null,false],[0,0,0,"DLL_INIT_FAILED",null," {DLL Initialization Failed} Initialization of the dynamic link library %hs failed. The process is terminating abnormally.",null,false],[0,0,0,"MISSING_SYSTEMFILE",null," {Missing System File} The required system file %hs is bad or missing.",null,false],[0,0,0,"UNHANDLED_EXCEPTION",null," {Application Error} The exception %s (0x%08lx) occurred in the application at location 0x%08lx.",null,false],[0,0,0,"APP_INIT_FAILURE",null," {Application Error} The application failed to initialize properly (0x%lx). Click OK to terminate the application.",null,false],[0,0,0,"PAGEFILE_CREATE_FAILED",null," {Unable to Create Paging File} The creation of the paging file %hs failed (%lx). The requested size was %ld.",null,false],[0,0,0,"NO_PAGEFILE",null," {No Paging File Specified} No paging file was specified in the system configuration.",null,false],[0,0,0,"INVALID_LEVEL",null," {Incorrect System Call Level} An invalid level was passed into the specified system call.",null,false],[0,0,0,"WRONG_PASSWORD_CORE",null," {Incorrect Password to LAN Manager Server} You specified an incorrect password to a LAN Manager 2.x or MS-NET server.",null,false],[0,0,0,"ILLEGAL_FLOAT_CONTEXT",null," {EXCEPTION} A real-mode application issued a floating-point instruction and floating-point hardware is not present.",null,false],[0,0,0,"PIPE_BROKEN",null," The pipe operation has failed because the other end of the pipe has been closed.",null,false],[0,0,0,"REGISTRY_CORRUPT",null," {The Registry Is Corrupt} The structure of one of the files that contains registry data is corrupt; the image of the file in memory is corrupt; or the file could not be recovered because the alternate copy or log was absent or corrupt.",null,false],[0,0,0,"REGISTRY_IO_FAILED",null," An I/O operation initiated by the Registry failed and cannot be recovered.\n The registry could not read in, write out, or flush one of the files that contain the system's image of the registry.",null,false],[0,0,0,"NO_EVENT_PAIR",null," An event pair synchronization operation was performed using the thread-specific client/server event pair object, but no event pair object was associated with the thread.",null,false],[0,0,0,"UNRECOGNIZED_VOLUME",null," The volume does not contain a recognized file system.\n Be sure that all required file system drivers are loaded and that the volume is not corrupt.",null,false],[0,0,0,"SERIAL_NO_DEVICE_INITED",null," No serial device was successfully initialized. The serial driver will unload.",null,false],[0,0,0,"NO_SUCH_ALIAS",null," The specified local group does not exist.",null,false],[0,0,0,"MEMBER_NOT_IN_ALIAS",null," The specified account name is not a member of the group.",null,false],[0,0,0,"MEMBER_IN_ALIAS",null," The specified account name is already a member of the group.",null,false],[0,0,0,"ALIAS_EXISTS",null," The specified local group already exists.",null,false],[0,0,0,"LOGON_NOT_GRANTED",null," A requested type of logon (for example, interactive, network, and service) is not granted by the local security policy of the target system.\n Ask the system administrator to grant the necessary form of logon.",null,false],[0,0,0,"TOO_MANY_SECRETS",null," The maximum number of secrets that can be stored in a single system was exceeded.\n The length and number of secrets is limited to satisfy U.S. State Department export restrictions.",null,false],[0,0,0,"SECRET_TOO_LONG",null," The length of a secret exceeds the maximum allowable length.\n The length and number of secrets is limited to satisfy U.S. State Department export restrictions.",null,false],[0,0,0,"INTERNAL_DB_ERROR",null," The local security authority (LSA) database contains an internal inconsistency.",null,false],[0,0,0,"FULLSCREEN_MODE",null," The requested operation cannot be performed in full-screen mode.",null,false],[0,0,0,"TOO_MANY_CONTEXT_IDS",null," During a logon attempt, the user's security context accumulated too many security IDs. This is a very unusual situation.\n Remove the user from some global or local groups to reduce the number of security IDs to incorporate into the security context.",null,false],[0,0,0,"LOGON_TYPE_NOT_GRANTED",null," A user has requested a type of logon (for example, interactive or network) that has not been granted.\n An administrator has control over who can logon interactively and through the network.",null,false],[0,0,0,"NOT_REGISTRY_FILE",null," The system has attempted to load or restore a file into the registry, and the specified file is not in the format of a registry file.",null,false],[0,0,0,"NT_CROSS_ENCRYPTION_REQUIRED",null," An attempt was made to change a user password in the security account manager without providing the necessary Windows cross-encrypted password.",null,false],[0,0,0,"DOMAIN_CTRLR_CONFIG_ERROR",null," A domain server has an incorrect configuration.",null,false],[0,0,0,"FT_MISSING_MEMBER",null," An attempt was made to explicitly access the secondary copy of information via a device control to the fault tolerance driver and the secondary copy is not present in the system.",null,false],[0,0,0,"ILL_FORMED_SERVICE_ENTRY",null," A configuration registry node that represents a driver service entry was ill-formed and did not contain the required value entries.",null,false],[0,0,0,"ILLEGAL_CHARACTER",null," An illegal character was encountered.\n For a multibyte character set, this includes a lead byte without a succeeding trail byte.\n For the Unicode character set this includes the characters 0xFFFF and 0xFFFE.",null,false],[0,0,0,"UNMAPPABLE_CHARACTER",null," No mapping for the Unicode character exists in the target multibyte code page.",null,false],[0,0,0,"UNDEFINED_CHARACTER",null," The Unicode character is not defined in the Unicode character set that is installed on the system.",null,false],[0,0,0,"FLOPPY_VOLUME",null," The paging file cannot be created on a floppy disk.",null,false],[0,0,0,"FLOPPY_ID_MARK_NOT_FOUND",null," {Floppy Disk Error} While accessing a floppy disk, an ID address mark was not found.",null,false],[0,0,0,"FLOPPY_WRONG_CYLINDER",null," {Floppy Disk Error} While accessing a floppy disk, the track address from the sector ID field was found to be different from the track address that is maintained by the controller.",null,false],[0,0,0,"FLOPPY_UNKNOWN_ERROR",null," {Floppy Disk Error} The floppy disk controller reported an error that is not recognized by the floppy disk driver.",null,false],[0,0,0,"FLOPPY_BAD_REGISTERS",null," {Floppy Disk Error} While accessing a floppy-disk, the controller returned inconsistent results via its registers.",null,false],[0,0,0,"DISK_RECALIBRATE_FAILED",null," {Hard Disk Error} While accessing the hard disk, a recalibrate operation failed, even after retries.",null,false],[0,0,0,"DISK_OPERATION_FAILED",null," {Hard Disk Error} While accessing the hard disk, a disk operation failed even after retries.",null,false],[0,0,0,"DISK_RESET_FAILED",null," {Hard Disk Error} While accessing the hard disk, a disk controller reset was needed, but even that failed.",null,false],[0,0,0,"SHARED_IRQ_BUSY",null," An attempt was made to open a device that was sharing an interrupt request (IRQ) with other devices.\n At least one other device that uses that IRQ was already opened.\n Two concurrent opens of devices that share an IRQ and only work via interrupts is not supported for the particular bus type that the devices use.",null,false],[0,0,0,"FT_ORPHANING",null," {FT Orphaning} A disk that is part of a fault-tolerant volume can no longer be accessed.",null,false],[0,0,0,"BIOS_FAILED_TO_CONNECT_INTERRUPT",null," The basic input/output system (BIOS) failed to connect a system interrupt to the device or bus for which the device is connected.",null,false],[0,0,0,"PARTITION_FAILURE",null," The tape could not be partitioned.",null,false],[0,0,0,"INVALID_BLOCK_LENGTH",null," When accessing a new tape of a multi-volume partition, the current blocksize is incorrect.",null,false],[0,0,0,"DEVICE_NOT_PARTITIONED",null," The tape partition information could not be found when loading a tape.",null,false],[0,0,0,"UNABLE_TO_LOCK_MEDIA",null," An attempt to lock the eject media mechanism failed.",null,false],[0,0,0,"UNABLE_TO_UNLOAD_MEDIA",null," An attempt to unload media failed.",null,false],[0,0,0,"EOM_OVERFLOW",null," The physical end of tape was detected.",null,false],[0,0,0,"NO_MEDIA",null," {No Media} There is no media in the drive. Insert media into drive %hs.",null,false],[0,0,0,"NO_SUCH_MEMBER",null," A member could not be added to or removed from the local group because the member does not exist.",null,false],[0,0,0,"INVALID_MEMBER",null," A new member could not be added to a local group because the member has the wrong account type.",null,false],[0,0,0,"KEY_DELETED",null," An illegal operation was attempted on a registry key that has been marked for deletion.",null,false],[0,0,0,"NO_LOG_SPACE",null," The system could not allocate the required space in a registry log.",null,false],[0,0,0,"TOO_MANY_SIDS",null," Too many SIDs have been specified.",null,false],[0,0,0,"LM_CROSS_ENCRYPTION_REQUIRED",null," An attempt was made to change a user password in the security account manager without providing the necessary LM cross-encrypted password.",null,false],[0,0,0,"KEY_HAS_CHILDREN",null," An attempt was made to create a symbolic link in a registry key that already has subkeys or values.",null,false],[0,0,0,"CHILD_MUST_BE_VOLATILE",null," An attempt was made to create a stable subkey under a volatile parent key.",null,false],[0,0,0,"DEVICE_CONFIGURATION_ERROR",null," The I/O device is configured incorrectly or the configuration parameters to the driver are incorrect.",null,false],[0,0,0,"DRIVER_INTERNAL_ERROR",null," An error was detected between two drivers or within an I/O driver.",null,false],[0,0,0,"INVALID_DEVICE_STATE",null," The device is not in a valid state to perform this request.",null,false],[0,0,0,"IO_DEVICE_ERROR",null," The I/O device reported an I/O error.",null,false],[0,0,0,"DEVICE_PROTOCOL_ERROR",null," A protocol error was detected between the driver and the device.",null,false],[0,0,0,"BACKUP_CONTROLLER",null," This operation is only allowed for the primary domain controller of the domain.",null,false],[0,0,0,"LOG_FILE_FULL",null," The log file space is insufficient to support this operation.",null,false],[0,0,0,"TOO_LATE",null," A write operation was attempted to a volume after it was dismounted.",null,false],[0,0,0,"NO_TRUST_LSA_SECRET",null," The workstation does not have a trust secret for the primary domain in the local LSA database.",null,false],[0,0,0,"NO_TRUST_SAM_ACCOUNT",null," On applicable Windows Server releases, the SAM database does not have a computer account for this workstation trust relationship.",null,false],[0,0,0,"TRUSTED_DOMAIN_FAILURE",null," The logon request failed because the trust relationship between the primary domain and the trusted domain failed.",null,false],[0,0,0,"TRUSTED_RELATIONSHIP_FAILURE",null," The logon request failed because the trust relationship between this workstation and the primary domain failed.",null,false],[0,0,0,"EVENTLOG_FILE_CORRUPT",null," The Eventlog log file is corrupt.",null,false],[0,0,0,"EVENTLOG_CANT_START",null," No Eventlog log file could be opened. The Eventlog service did not start.",null,false],[0,0,0,"TRUST_FAILURE",null," The network logon failed. This might be because the validation authority cannot be reached.",null,false],[0,0,0,"MUTANT_LIMIT_EXCEEDED",null," An attempt was made to acquire a mutant such that its maximum count would have been exceeded.",null,false],[0,0,0,"NETLOGON_NOT_STARTED",null," An attempt was made to logon, but the NetLogon service was not started.",null,false],[0,0,0,"ACCOUNT_EXPIRED",null," The user account has expired.",null,false],[0,0,0,"POSSIBLE_DEADLOCK",null," {EXCEPTION} Possible deadlock condition.",null,false],[0,0,0,"NETWORK_CREDENTIAL_CONFLICT",null," Multiple connections to a server or shared resource by the same user, using more than one user name, are not allowed.\n Disconnect all previous connections to the server or shared resource and try again.",null,false],[0,0,0,"REMOTE_SESSION_LIMIT",null," An attempt was made to establish a session to a network server, but there are already too many sessions established to that server.",null,false],[0,0,0,"EVENTLOG_FILE_CHANGED",null," The log file has changed between reads.",null,false],[0,0,0,"NOLOGON_INTERDOMAIN_TRUST_ACCOUNT",null," The account used is an interdomain trust account.\n Use your global user account or local user account to access this server.",null,false],[0,0,0,"NOLOGON_WORKSTATION_TRUST_ACCOUNT",null," The account used is a computer account.\n Use your global user account or local user account to access this server.",null,false],[0,0,0,"NOLOGON_SERVER_TRUST_ACCOUNT",null," The account used is a server trust account.\n Use your global user account or local user account to access this server.",null,false],[0,0,0,"DOMAIN_TRUST_INCONSISTENT",null," The name or SID of the specified domain is inconsistent with the trust information for that domain.",null,false],[0,0,0,"FS_DRIVER_REQUIRED",null," A volume has been accessed for which a file system driver is required that has not yet been loaded.",null,false],[0,0,0,"IMAGE_ALREADY_LOADED_AS_DLL",null," Indicates that the specified image is already loaded as a DLL.",null,false],[0,0,0,"INCOMPATIBLE_WITH_GLOBAL_SHORT_NAME_REGISTRY_SETTING",null," Short name settings cannot be changed on this volume due to the global registry setting.",null,false],[0,0,0,"SHORT_NAMES_NOT_ENABLED_ON_VOLUME",null," Short names are not enabled on this volume.",null,false],[0,0,0,"SECURITY_STREAM_IS_INCONSISTENT",null," The security stream for the given volume is in an inconsistent state. Please run CHKDSK on the volume.",null,false],[0,0,0,"INVALID_LOCK_RANGE",null," A requested file lock operation cannot be processed due to an invalid byte range.",null,false],[0,0,0,"INVALID_ACE_CONDITION",null," The specified access control entry (ACE) contains an invalid condition.",null,false],[0,0,0,"IMAGE_SUBSYSTEM_NOT_PRESENT",null," The subsystem needed to support the image type is not present.",null,false],[0,0,0,"NOTIFICATION_GUID_ALREADY_DEFINED",null," The specified file already has a notification GUID associated with it.",null,false],[0,0,0,"NETWORK_OPEN_RESTRICTION",null," A remote open failed because the network open restrictions were not satisfied.",null,false],[0,0,0,"NO_USER_SESSION_KEY",null," There is no user session key for the specified logon session.",null,false],[0,0,0,"USER_SESSION_DELETED",null," The remote user session has been deleted.",null,false],[0,0,0,"RESOURCE_LANG_NOT_FOUND",null," Indicates the specified resource language ID cannot be found in the image file.",null,false],[0,0,0,"INSUFF_SERVER_RESOURCES",null," Insufficient server resources exist to complete the request.",null,false],[0,0,0,"INVALID_BUFFER_SIZE",null," The size of the buffer is invalid for the specified operation.",null,false],[0,0,0,"INVALID_ADDRESS_COMPONENT",null," The transport rejected the specified network address as invalid.",null,false],[0,0,0,"INVALID_ADDRESS_WILDCARD",null," The transport rejected the specified network address due to invalid use of a wildcard.",null,false],[0,0,0,"TOO_MANY_ADDRESSES",null," The transport address could not be opened because all the available addresses are in use.",null,false],[0,0,0,"ADDRESS_ALREADY_EXISTS",null," The transport address could not be opened because it already exists.",null,false],[0,0,0,"ADDRESS_CLOSED",null," The transport address is now closed.",null,false],[0,0,0,"CONNECTION_DISCONNECTED",null," The transport connection is now disconnected.",null,false],[0,0,0,"CONNECTION_RESET",null," The transport connection has been reset.",null,false],[0,0,0,"TOO_MANY_NODES",null," The transport cannot dynamically acquire any more nodes.",null,false],[0,0,0,"TRANSACTION_ABORTED",null," The transport aborted a pending transaction.",null,false],[0,0,0,"TRANSACTION_TIMED_OUT",null," The transport timed out a request that is waiting for a response.",null,false],[0,0,0,"TRANSACTION_NO_RELEASE",null," The transport did not receive a release for a pending response.",null,false],[0,0,0,"TRANSACTION_NO_MATCH",null," The transport did not find a transaction that matches the specific token.",null,false],[0,0,0,"TRANSACTION_RESPONDED",null," The transport had previously responded to a transaction request.",null,false],[0,0,0,"TRANSACTION_INVALID_ID",null," The transport does not recognize the specified transaction request ID.",null,false],[0,0,0,"TRANSACTION_INVALID_TYPE",null," The transport does not recognize the specified transaction request type.",null,false],[0,0,0,"NOT_SERVER_SESSION",null," The transport can only process the specified request on the server side of a session.",null,false],[0,0,0,"NOT_CLIENT_SESSION",null," The transport can only process the specified request on the client side of a session.",null,false],[0,0,0,"CANNOT_LOAD_REGISTRY_FILE",null," {Registry File Failure} The registry cannot load the hive (file): %hs or its log or alternate. It is corrupt, absent, or not writable.",null,false],[0,0,0,"DEBUG_ATTACH_FAILED",null," {Unexpected Failure in DebugActiveProcess} An unexpected failure occurred while processing a DebugActiveProcess API request.\n Choosing OK will terminate the process, and choosing Cancel will ignore the error.",null,false],[0,0,0,"SYSTEM_PROCESS_TERMINATED",null," {Fatal System Error} The %hs system process terminated unexpectedly with a status of 0x%08x (0x%08x 0x%08x). The system has been shut down.",null,false],[0,0,0,"DATA_NOT_ACCEPTED",null," {Data Not Accepted} The TDI client could not handle the data received during an indication.",null,false],[0,0,0,"NO_BROWSER_SERVERS_FOUND",null," {Unable to Retrieve Browser Server List} The list of servers for this workgroup is not currently available.",null,false],[0,0,0,"VDM_HARD_ERROR",null," NTVDM encountered a hard error.",null,false],[0,0,0,"DRIVER_CANCEL_TIMEOUT",null," {Cancel Timeout} The driver %hs failed to complete a canceled I/O request in the allotted time.",null,false],[0,0,0,"REPLY_MESSAGE_MISMATCH",null," {Reply Message Mismatch} An attempt was made to reply to an LPC message, but the thread specified by the client ID in the message was not waiting on that message.",null,false],[0,0,0,"MAPPED_ALIGNMENT",null," {Mapped View Alignment Incorrect} An attempt was made to map a view of a file, but either the specified base address or the offset into the file were not aligned on the proper allocation granularity.",null,false],[0,0,0,"IMAGE_CHECKSUM_MISMATCH",null," {Bad Image Checksum} The image %hs is possibly corrupt.\n The header checksum does not match the computed checksum.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs. The data has been lost.\n This error might be caused by a failure of your computer hardware or network connection. Try to save this file elsewhere.",null,false],[0,0,0,"CLIENT_SERVER_PARAMETERS_INVALID",null," The parameters passed to the server in the client/server shared memory window were invalid.\n Too much data might have been put in the shared memory window.",null,false],[0,0,0,"PASSWORD_MUST_CHANGE",null," The user password must be changed before logging on the first time.",null,false],[0,0,0,"NOT_FOUND",null," The object was not found.",null,false],[0,0,0,"NOT_TINY_STREAM",null," The stream is not a tiny stream.",null,false],[0,0,0,"RECOVERY_FAILURE",null," A transaction recovery failed.",null,false],[0,0,0,"STACK_OVERFLOW_READ",null," The request must be handled by the stack overflow code.",null,false],[0,0,0,"FAIL_CHECK",null," A consistency check failed.",null,false],[0,0,0,"DUPLICATE_OBJECTID",null," The attempt to insert the ID in the index failed because the ID is already in the index.",null,false],[0,0,0,"OBJECTID_EXISTS",null," The attempt to set the object ID failed because the object already has an ID.",null,false],[0,0,0,"CONVERT_TO_LARGE",null," Internal OFS status codes indicating how an allocation operation is handled.\n Either it is retried after the containing oNode is moved or the extent stream is converted to a large stream.",null,false],[0,0,0,"RETRY",null," The request needs to be retried.",null,false],[0,0,0,"FOUND_OUT_OF_SCOPE",null," The attempt to find the object found an object on the volume that matches by ID; however, it is out of the scope of the handle that is used for the operation.",null,false],[0,0,0,"ALLOCATE_BUCKET",null," The bucket array must be grown. Retry the transaction after doing so.",null,false],[0,0,0,"PROPSET_NOT_FOUND",null," The specified property set does not exist on the object.",null,false],[0,0,0,"MARSHALL_OVERFLOW",null," The user/kernel marshaling buffer has overflowed.",null,false],[0,0,0,"INVALID_VARIANT",null," The supplied variant structure contains invalid data.",null,false],[0,0,0,"DOMAIN_CONTROLLER_NOT_FOUND",null," A domain controller for this domain was not found.",null,false],[0,0,0,"ACCOUNT_LOCKED_OUT",null," The user account has been automatically locked because too many invalid logon attempts or password change attempts have been requested.",null,false],[0,0,0,"HANDLE_NOT_CLOSABLE",null," NtClose was called on a handle that was protected from close via NtSetInformationObject.",null,false],[0,0,0,"CONNECTION_REFUSED",null," The transport-connection attempt was refused by the remote system.",null,false],[0,0,0,"GRACEFUL_DISCONNECT",null," The transport connection was gracefully closed.",null,false],[0,0,0,"ADDRESS_ALREADY_ASSOCIATED",null," The transport endpoint already has an address associated with it.",null,false],[0,0,0,"ADDRESS_NOT_ASSOCIATED",null," An address has not yet been associated with the transport endpoint.",null,false],[0,0,0,"CONNECTION_INVALID",null," An operation was attempted on a nonexistent transport connection.",null,false],[0,0,0,"CONNECTION_ACTIVE",null," An invalid operation was attempted on an active transport connection.",null,false],[0,0,0,"NETWORK_UNREACHABLE",null," The remote network is not reachable by the transport.",null,false],[0,0,0,"HOST_UNREACHABLE",null," The remote system is not reachable by the transport.",null,false],[0,0,0,"PROTOCOL_UNREACHABLE",null," The remote system does not support the transport protocol.",null,false],[0,0,0,"PORT_UNREACHABLE",null," No service is operating at the destination port of the transport on the remote system.",null,false],[0,0,0,"REQUEST_ABORTED",null," The request was aborted.",null,false],[0,0,0,"CONNECTION_ABORTED",null," The transport connection was aborted by the local system.",null,false],[0,0,0,"BAD_COMPRESSION_BUFFER",null," The specified buffer contains ill-formed data.",null,false],[0,0,0,"USER_MAPPED_FILE",null," The requested operation cannot be performed on a file with a user mapped section open.",null,false],[0,0,0,"AUDIT_FAILED",null," {Audit Failed} An attempt to generate a security audit failed.",null,false],[0,0,0,"TIMER_RESOLUTION_NOT_SET",null," The timer resolution was not previously set by the current process.",null,false],[0,0,0,"CONNECTION_COUNT_LIMIT",null," A connection to the server could not be made because the limit on the number of concurrent connections for this account has been reached.",null,false],[0,0,0,"LOGIN_TIME_RESTRICTION",null," Attempting to log on during an unauthorized time of day for this account.",null,false],[0,0,0,"LOGIN_WKSTA_RESTRICTION",null," The account is not authorized to log on from this station.",null,false],[0,0,0,"IMAGE_MP_UP_MISMATCH",null," {UP/MP Image Mismatch} The image %hs has been modified for use on a uniprocessor system, but you are running it on a multiprocessor machine. Reinstall the image file.",null,false],[0,0,0,"INSUFFICIENT_LOGON_INFO",null," There is insufficient account information to log you on.",null,false],[0,0,0,"BAD_DLL_ENTRYPOINT",null," {Invalid DLL Entrypoint} The dynamic link library %hs is not written correctly.\n The stack pointer has been left in an inconsistent state.\n The entry point should be declared as WINAPI or STDCALL.\n Select YES to fail the DLL load. Select NO to continue execution.\n Selecting NO might cause the application to operate incorrectly.",null,false],[0,0,0,"BAD_SERVICE_ENTRYPOINT",null," {Invalid Service Callback Entrypoint} The %hs service is not written correctly.\n The stack pointer has been left in an inconsistent state.\n The callback entry point should be declared as WINAPI or STDCALL.\n Selecting OK will cause the service to continue operation.\n However, the service process might operate incorrectly.",null,false],[0,0,0,"LPC_REPLY_LOST",null," The server received the messages but did not send a reply.",null,false],[0,0,0,"IP_ADDRESS_CONFLICT1",null," There is an IP address conflict with another system on the network.",null,false],[0,0,0,"IP_ADDRESS_CONFLICT2",null," There is an IP address conflict with another system on the network.",null,false],[0,0,0,"REGISTRY_QUOTA_LIMIT",null," {Low On Registry Space} The system has reached the maximum size that is allowed for the system part of the registry. Additional storage requests will be ignored.",null,false],[0,0,0,"PATH_NOT_COVERED",null," The contacted server does not support the indicated part of the DFS namespace.",null,false],[0,0,0,"NO_CALLBACK_ACTIVE",null," A callback return system service cannot be executed when no callback is active.",null,false],[0,0,0,"LICENSE_QUOTA_EXCEEDED",null," The service being accessed is licensed for a particular number of connections.\n No more connections can be made to the service at this time because the service has already accepted the maximum number of connections.",null,false],[0,0,0,"PWD_TOO_SHORT",null," The password provided is too short to meet the policy of your user account. Choose a longer password.",null,false],[0,0,0,"PWD_TOO_RECENT",null," The policy of your user account does not allow you to change passwords too frequently.\n This is done to prevent users from changing back to a familiar, but potentially discovered, password.\n If you feel your password has been compromised, contact your administrator immediately to have a new one assigned.",null,false],[0,0,0,"PWD_HISTORY_CONFLICT",null," You have attempted to change your password to one that you have used in the past.\n The policy of your user account does not allow this.\n Select a password that you have not previously used.",null,false],[0,0,0,"PLUGPLAY_NO_DEVICE",null," You have attempted to load a legacy device driver while its device instance had been disabled.",null,false],[0,0,0,"UNSUPPORTED_COMPRESSION",null," The specified compression format is unsupported.",null,false],[0,0,0,"INVALID_HW_PROFILE",null," The specified hardware profile configuration is invalid.",null,false],[0,0,0,"INVALID_PLUGPLAY_DEVICE_PATH",null," The specified Plug and Play registry device path is invalid.",null,false],[0,0,0,"DRIVER_ORDINAL_NOT_FOUND",null," {Driver Entry Point Not Found} The %hs device driver could not locate the ordinal %ld in driver %hs.",null,false],[0,0,0,"DRIVER_ENTRYPOINT_NOT_FOUND",null," {Driver Entry Point Not Found} The %hs device driver could not locate the entry point %hs in driver %hs.",null,false],[0,0,0,"RESOURCE_NOT_OWNED",null," {Application Error} The application attempted to release a resource it did not own. Click OK to terminate the application.",null,false],[0,0,0,"TOO_MANY_LINKS",null," An attempt was made to create more links on a file than the file system supports.",null,false],[0,0,0,"QUOTA_LIST_INCONSISTENT",null," The specified quota list is internally inconsistent with its descriptor.",null,false],[0,0,0,"FILE_IS_OFFLINE",null," The specified file has been relocated to offline storage.",null,false],[0,0,0,"EVALUATION_EXPIRATION",null," {Windows Evaluation Notification} The evaluation period for this installation of Windows has expired. This system will shutdown in 1 hour.\n To restore access to this installation of Windows, upgrade this installation by using a licensed distribution of this product.",null,false],[0,0,0,"ILLEGAL_DLL_RELOCATION",null," {Illegal System DLL Relocation} The system DLL %hs was relocated in memory. The application will not run properly.\n The relocation occurred because the DLL %hs occupied an address range that is reserved for Windows system DLLs.\n The vendor supplying the DLL should be contacted for a new DLL.",null,false],[0,0,0,"LICENSE_VIOLATION",null," {License Violation} The system has detected tampering with your registered product type.\n This is a violation of your software license. Tampering with the product type is not permitted.",null,false],[0,0,0,"DLL_INIT_FAILED_LOGOFF",null," {DLL Initialization Failed} The application failed to initialize because the window station is shutting down.",null,false],[0,0,0,"DRIVER_UNABLE_TO_LOAD",null," {Unable to Load Device Driver} %hs device driver could not be loaded. Error Status was 0x%x.",null,false],[0,0,0,"DFS_UNAVAILABLE",null," DFS is unavailable on the contacted server.",null,false],[0,0,0,"VOLUME_DISMOUNTED",null," An operation was attempted to a volume after it was dismounted.",null,false],[0,0,0,"WX86_INTERNAL_ERROR",null," An internal error occurred in the Win32 x86 emulation subsystem.",null,false],[0,0,0,"WX86_FLOAT_STACK_CHECK",null," Win32 x86 emulation subsystem floating-point stack check.",null,false],[0,0,0,"VALIDATE_CONTINUE",null," The validation process needs to continue on to the next step.",null,false],[0,0,0,"NO_MATCH",null," There was no match for the specified key in the index.",null,false],[0,0,0,"NO_MORE_MATCHES",null," There are no more matches for the current index enumeration.",null,false],[0,0,0,"NOT_A_REPARSE_POINT",null," The NTFS file or directory is not a reparse point.",null,false],[0,0,0,"IO_REPARSE_TAG_INVALID",null," The Windows I/O reparse tag passed for the NTFS reparse point is invalid.",null,false],[0,0,0,"IO_REPARSE_TAG_MISMATCH",null," The Windows I/O reparse tag does not match the one that is in the NTFS reparse point.",null,false],[0,0,0,"IO_REPARSE_DATA_INVALID",null," The user data passed for the NTFS reparse point is invalid.",null,false],[0,0,0,"IO_REPARSE_TAG_NOT_HANDLED",null," The layered file system driver for this I/O tag did not handle it when needed.",null,false],[0,0,0,"REPARSE_POINT_NOT_RESOLVED",null," The NTFS symbolic link could not be resolved even though the initial file name is valid.",null,false],[0,0,0,"DIRECTORY_IS_A_REPARSE_POINT",null," The NTFS directory is a reparse point.",null,false],[0,0,0,"RANGE_LIST_CONFLICT",null," The range could not be added to the range list because of a conflict.",null,false],[0,0,0,"SOURCE_ELEMENT_EMPTY",null," The specified medium changer source element contains no media.",null,false],[0,0,0,"DESTINATION_ELEMENT_FULL",null," The specified medium changer destination element already contains media.",null,false],[0,0,0,"ILLEGAL_ELEMENT_ADDRESS",null," The specified medium changer element does not exist.",null,false],[0,0,0,"MAGAZINE_NOT_PRESENT",null," The specified element is contained in a magazine that is no longer present.",null,false],[0,0,0,"REINITIALIZATION_NEEDED",null," The device requires re-initialization due to hardware errors.",null,false],[0,0,0,"ENCRYPTION_FAILED",null," The file encryption attempt failed.",null,false],[0,0,0,"DECRYPTION_FAILED",null," The file decryption attempt failed.",null,false],[0,0,0,"RANGE_NOT_FOUND",null," The specified range could not be found in the range list.",null,false],[0,0,0,"NO_RECOVERY_POLICY",null," There is no encryption recovery policy configured for this system.",null,false],[0,0,0,"NO_EFS",null," The required encryption driver is not loaded for this system.",null,false],[0,0,0,"WRONG_EFS",null," The file was encrypted with a different encryption driver than is currently loaded.",null,false],[0,0,0,"NO_USER_KEYS",null," There are no EFS keys defined for the user.",null,false],[0,0,0,"FILE_NOT_ENCRYPTED",null," The specified file is not encrypted.",null,false],[0,0,0,"NOT_EXPORT_FORMAT",null," The specified file is not in the defined EFS export format.",null,false],[0,0,0,"FILE_ENCRYPTED",null," The specified file is encrypted and the user does not have the ability to decrypt it.",null,false],[0,0,0,"WMI_GUID_NOT_FOUND",null," The GUID passed was not recognized as valid by a WMI data provider.",null,false],[0,0,0,"WMI_INSTANCE_NOT_FOUND",null," The instance name passed was not recognized as valid by a WMI data provider.",null,false],[0,0,0,"WMI_ITEMID_NOT_FOUND",null," The data item ID passed was not recognized as valid by a WMI data provider.",null,false],[0,0,0,"WMI_TRY_AGAIN",null," The WMI request could not be completed and should be retried.",null,false],[0,0,0,"SHARED_POLICY",null," The policy object is shared and can only be modified at the root.",null,false],[0,0,0,"POLICY_OBJECT_NOT_FOUND",null," The policy object does not exist when it should.",null,false],[0,0,0,"POLICY_ONLY_IN_DS",null," The requested policy information only lives in the Ds.",null,false],[0,0,0,"VOLUME_NOT_UPGRADED",null," The volume must be upgraded to enable this feature.",null,false],[0,0,0,"REMOTE_STORAGE_NOT_ACTIVE",null," The remote storage service is not operational at this time.",null,false],[0,0,0,"REMOTE_STORAGE_MEDIA_ERROR",null," The remote storage service encountered a media error.",null,false],[0,0,0,"NO_TRACKING_SERVICE",null," The tracking (workstation) service is not running.",null,false],[0,0,0,"SERVER_SID_MISMATCH",null," The server process is running under a SID that is different from the SID that is required by client.",null,false],[0,0,0,"DS_NO_ATTRIBUTE_OR_VALUE",null," The specified directory service attribute or value does not exist.",null,false],[0,0,0,"DS_INVALID_ATTRIBUTE_SYNTAX",null," The attribute syntax specified to the directory service is invalid.",null,false],[0,0,0,"DS_ATTRIBUTE_TYPE_UNDEFINED",null," The attribute type specified to the directory service is not defined.",null,false],[0,0,0,"DS_ATTRIBUTE_OR_VALUE_EXISTS",null," The specified directory service attribute or value already exists.",null,false],[0,0,0,"DS_BUSY",null," The directory service is busy.",null,false],[0,0,0,"DS_UNAVAILABLE",null," The directory service is unavailable.",null,false],[0,0,0,"DS_NO_RIDS_ALLOCATED",null," The directory service was unable to allocate a relative identifier.",null,false],[0,0,0,"DS_NO_MORE_RIDS",null," The directory service has exhausted the pool of relative identifiers.",null,false],[0,0,0,"DS_INCORRECT_ROLE_OWNER",null," The requested operation could not be performed because the directory service is not the master for that type of operation.",null,false],[0,0,0,"DS_RIDMGR_INIT_ERROR",null," The directory service was unable to initialize the subsystem that allocates relative identifiers.",null,false],[0,0,0,"DS_OBJ_CLASS_VIOLATION",null," The requested operation did not satisfy one or more constraints that are associated with the class of the object.",null,false],[0,0,0,"DS_CANT_ON_NON_LEAF",null," The directory service can perform the requested operation only on a leaf object.",null,false],[0,0,0,"DS_CANT_ON_RDN",null," The directory service cannot perform the requested operation on the Relatively Defined Name (RDN) attribute of an object.",null,false],[0,0,0,"DS_CANT_MOD_OBJ_CLASS",null," The directory service detected an attempt to modify the object class of an object.",null,false],[0,0,0,"DS_CROSS_DOM_MOVE_FAILED",null," An error occurred while performing a cross domain move operation.",null,false],[0,0,0,"DS_GC_NOT_AVAILABLE",null," Unable to contact the global catalog server.",null,false],[0,0,0,"DIRECTORY_SERVICE_REQUIRED",null," The requested operation requires a directory service, and none was available.",null,false],[0,0,0,"REPARSE_ATTRIBUTE_CONFLICT",null," The reparse attribute cannot be set because it is incompatible with an existing attribute.",null,false],[0,0,0,"CANT_ENABLE_DENY_ONLY",null," A group marked \"use for deny only\" cannot be enabled.",null,false],[0,0,0,"FLOAT_MULTIPLE_FAULTS",null," {EXCEPTION} Multiple floating-point faults.",null,false],[0,0,0,"FLOAT_MULTIPLE_TRAPS",null," {EXCEPTION} Multiple floating-point traps.",null,false],[0,0,0,"DEVICE_REMOVED",null," The device has been removed.",null,false],[0,0,0,"JOURNAL_DELETE_IN_PROGRESS",null," The volume change journal is being deleted.",null,false],[0,0,0,"JOURNAL_NOT_ACTIVE",null," The volume change journal is not active.",null,false],[0,0,0,"NOINTERFACE",null," The requested interface is not supported.",null,false],[0,0,0,"DS_ADMIN_LIMIT_EXCEEDED",null," A directory service resource limit has been exceeded.",null,false],[0,0,0,"DRIVER_FAILED_SLEEP",null," {System Standby Failed} The driver %hs does not support standby mode.\n Updating this driver allows the system to go to standby mode.",null,false],[0,0,0,"MUTUAL_AUTHENTICATION_FAILED",null," Mutual Authentication failed. The server password is out of date at the domain controller.",null,false],[0,0,0,"CORRUPT_SYSTEM_FILE",null," The system file %1 has become corrupt and has been replaced.",null,false],[0,0,0,"DATATYPE_MISALIGNMENT_ERROR",null," {EXCEPTION} Alignment Error A data type misalignment error was detected in a load or store instruction.",null,false],[0,0,0,"WMI_READ_ONLY",null," The WMI data item or data block is read-only.",null,false],[0,0,0,"WMI_SET_FAILURE",null," The WMI data item or data block could not be changed.",null,false],[0,0,0,"COMMITMENT_MINIMUM",null," {Virtual Memory Minimum Too Low} Your system is low on virtual memory.\n Windows is increasing the size of your virtual memory paging file.\n During this process, memory requests for some applications might be denied. For more information, see Help.",null,false],[0,0,0,"REG_NAT_CONSUMPTION",null," {EXCEPTION} Register NaT consumption faults.\n A NaT value is consumed on a non-speculative instruction.",null,false],[0,0,0,"TRANSPORT_FULL",null," The transport element of the medium changer contains media, which is causing the operation to fail.",null,false],[0,0,0,"DS_SAM_INIT_FAILURE",null," Security Accounts Manager initialization failed because of the following error: %hs Error Status: 0x%x.\n Click OK to shut down this system and restart in Directory Services Restore Mode.\n Check the event log for more detailed information.",null,false],[0,0,0,"ONLY_IF_CONNECTED",null," This operation is supported only when you are connected to the server.",null,false],[0,0,0,"DS_SENSITIVE_GROUP_VIOLATION",null," Only an administrator can modify the membership list of an administrative group.",null,false],[0,0,0,"PNP_RESTART_ENUMERATION",null," A device was removed so enumeration must be restarted.",null,false],[0,0,0,"JOURNAL_ENTRY_DELETED",null," The journal entry has been deleted from the journal.",null,false],[0,0,0,"DS_CANT_MOD_PRIMARYGROUPID",null," Cannot change the primary group ID of a domain controller account.",null,false],[0,0,0,"SYSTEM_IMAGE_BAD_SIGNATURE",null," {Fatal System Error} The system image %s is not properly signed.\n The file has been replaced with the signed file. The system has been shut down.",null,false],[0,0,0,"PNP_REBOOT_REQUIRED",null," The device will not start without a reboot.",null,false],[0,0,0,"POWER_STATE_INVALID",null," The power state of the current device cannot support this request.",null,false],[0,0,0,"DS_INVALID_GROUP_TYPE",null," The specified group type is invalid.",null,false],[0,0,0,"DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN",null," In a mixed domain, no nesting of a global group if the group is security enabled.",null,false],[0,0,0,"DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN",null," In a mixed domain, cannot nest local groups with other local groups, if the group is security enabled.",null,false],[0,0,0,"DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER",null," A global group cannot have a local group as a member.",null,false],[0,0,0,"DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER",null," A global group cannot have a universal group as a member.",null,false],[0,0,0,"DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER",null," A universal group cannot have a local group as a member.",null,false],[0,0,0,"DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER",null," A global group cannot have a cross-domain member.",null,false],[0,0,0,"DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER",null," A local group cannot have another cross-domain local group as a member.",null,false],[0,0,0,"DS_HAVE_PRIMARY_MEMBERS",null," Cannot change to a security-disabled group because primary members are in this group.",null,false],[0,0,0,"WMI_NOT_SUPPORTED",null," The WMI operation is not supported by the data block or method.",null,false],[0,0,0,"INSUFFICIENT_POWER",null," There is not enough power to complete the requested operation.",null,false],[0,0,0,"SAM_NEED_BOOTKEY_PASSWORD",null," The Security Accounts Manager needs to get the boot password.",null,false],[0,0,0,"SAM_NEED_BOOTKEY_FLOPPY",null," The Security Accounts Manager needs to get the boot key from the floppy disk.",null,false],[0,0,0,"DS_CANT_START",null," The directory service cannot start.",null,false],[0,0,0,"DS_INIT_FAILURE",null," The directory service could not start because of the following error: %hs Error Status: 0x%x.\n Click OK to shut down this system and restart in Directory Services Restore Mode.\n Check the event log for more detailed information.",null,false],[0,0,0,"SAM_INIT_FAILURE",null," The Security Accounts Manager initialization failed because of the following error: %hs Error Status: 0x%x.\n Click OK to shut down this system and restart in Safe Mode.\n Check the event log for more detailed information.",null,false],[0,0,0,"DS_GC_REQUIRED",null," The requested operation can be performed only on a global catalog server.",null,false],[0,0,0,"DS_LOCAL_MEMBER_OF_LOCAL_ONLY",null," A local group can only be a member of other local groups in the same domain.",null,false],[0,0,0,"DS_NO_FPO_IN_UNIVERSAL_GROUPS",null," Foreign security principals cannot be members of universal groups.",null,false],[0,0,0,"DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED",null," Your computer could not be joined to the domain.\n You have exceeded the maximum number of computer accounts you are allowed to create in this domain.\n Contact your system administrator to have this limit reset or increased.",null,false],[0,0,0,"CURRENT_DOMAIN_NOT_ALLOWED",null," This operation cannot be performed on the current domain.",null,false],[0,0,0,"CANNOT_MAKE",null," The directory or file cannot be created.",null,false],[0,0,0,"SYSTEM_SHUTDOWN",null," The system is in the process of shutting down.",null,false],[0,0,0,"DS_INIT_FAILURE_CONSOLE",null," Directory Services could not start because of the following error: %hs Error Status: 0x%x. Click OK to shut down the system.\n You can use the recovery console to diagnose the system further.",null,false],[0,0,0,"DS_SAM_INIT_FAILURE_CONSOLE",null," Security Accounts Manager initialization failed because of the following error: %hs Error Status: 0x%x. Click OK to shut down the system.\n You can use the recovery console to diagnose the system further.",null,false],[0,0,0,"UNFINISHED_CONTEXT_DELETED",null," A security context was deleted before the context was completed. This is considered a logon failure.",null,false],[0,0,0,"NO_TGT_REPLY",null," The client is trying to negotiate a context and the server requires user-to-user but did not send a TGT reply.",null,false],[0,0,0,"OBJECTID_NOT_FOUND",null," An object ID was not found in the file.",null,false],[0,0,0,"NO_IP_ADDRESSES",null," Unable to accomplish the requested task because the local machine does not have any IP addresses.",null,false],[0,0,0,"WRONG_CREDENTIAL_HANDLE",null," The supplied credential handle does not match the credential that is associated with the security context.",null,false],[0,0,0,"CRYPTO_SYSTEM_INVALID",null," The crypto system or checksum function is invalid because a required function is unavailable.",null,false],[0,0,0,"MAX_REFERRALS_EXCEEDED",null," The number of maximum ticket referrals has been exceeded.",null,false],[0,0,0,"MUST_BE_KDC",null," The local machine must be a Kerberos KDC (domain controller) and it is not.",null,false],[0,0,0,"STRONG_CRYPTO_NOT_SUPPORTED",null," The other end of the security negotiation requires strong crypto but it is not supported on the local machine.",null,false],[0,0,0,"TOO_MANY_PRINCIPALS",null," The KDC reply contained more than one principal name.",null,false],[0,0,0,"NO_PA_DATA",null," Expected to find PA data for a hint of what etype to use, but it was not found.",null,false],[0,0,0,"PKINIT_NAME_MISMATCH",null," The client certificate does not contain a valid UPN, or does not match the client name in the logon request. Contact your administrator.",null,false],[0,0,0,"SMARTCARD_LOGON_REQUIRED",null," Smart card logon is required and was not used.",null,false],[0,0,0,"KDC_INVALID_REQUEST",null," An invalid request was sent to the KDC.",null,false],[0,0,0,"KDC_UNABLE_TO_REFER",null," The KDC was unable to generate a referral for the service requested.",null,false],[0,0,0,"KDC_UNKNOWN_ETYPE",null," The encryption type requested is not supported by the KDC.",null,false],[0,0,0,"SHUTDOWN_IN_PROGRESS",null," A system shutdown is in progress.",null,false],[0,0,0,"SERVER_SHUTDOWN_IN_PROGRESS",null," The server machine is shutting down.",null,false],[0,0,0,"NOT_SUPPORTED_ON_SBS",null," This operation is not supported on a computer running Windows Server 2003 operating system for Small Business Server.",null,false],[0,0,0,"WMI_GUID_DISCONNECTED",null," The WMI GUID is no longer available.",null,false],[0,0,0,"WMI_ALREADY_DISABLED",null," Collection or events for the WMI GUID is already disabled.",null,false],[0,0,0,"WMI_ALREADY_ENABLED",null," Collection or events for the WMI GUID is already enabled.",null,false],[0,0,0,"MFT_TOO_FRAGMENTED",null," The master file table on the volume is too fragmented to complete this operation.",null,false],[0,0,0,"COPY_PROTECTION_FAILURE",null," Copy protection failure.",null,false],[0,0,0,"CSS_AUTHENTICATION_FAILURE",null," Copy protection error—DVD CSS Authentication failed.",null,false],[0,0,0,"CSS_KEY_NOT_PRESENT",null," Copy protection error—The specified sector does not contain a valid key.",null,false],[0,0,0,"CSS_KEY_NOT_ESTABLISHED",null," Copy protection error—DVD session key not established.",null,false],[0,0,0,"CSS_SCRAMBLED_SECTOR",null," Copy protection error—The read failed because the sector is encrypted.",null,false],[0,0,0,"CSS_REGION_MISMATCH",null," Copy protection error—The region of the specified DVD does not correspond to the region setting of the drive.",null,false],[0,0,0,"CSS_RESETS_EXHAUSTED",null," Copy protection error—The region setting of the drive might be permanent.",null,false],[0,0,0,"PKINIT_FAILURE",null," The Kerberos protocol encountered an error while validating the KDC certificate during smart card logon.\n There is more information in the system event log.",null,false],[0,0,0,"SMARTCARD_SUBSYSTEM_FAILURE",null," The Kerberos protocol encountered an error while attempting to use the smart card subsystem.",null,false],[0,0,0,"NO_KERB_KEY",null," The target server does not have acceptable Kerberos credentials.",null,false],[0,0,0,"HOST_DOWN",null," The transport determined that the remote system is down.",null,false],[0,0,0,"UNSUPPORTED_PREAUTH",null," An unsupported pre-authentication mechanism was presented to the Kerberos package.",null,false],[0,0,0,"EFS_ALG_BLOB_TOO_BIG",null," The encryption algorithm that is used on the source file needs a bigger key buffer than the one that is used on the destination file.",null,false],[0,0,0,"PORT_NOT_SET",null," An attempt to remove a processes DebugPort was made, but a port was not already associated with the process.",null,false],[0,0,0,"DEBUGGER_INACTIVE",null," An attempt to do an operation on a debug port failed because the port is in the process of being deleted.",null,false],[0,0,0,"DS_VERSION_CHECK_FAILURE",null," This version of Windows is not compatible with the behavior version of the directory forest, domain, or domain controller.",null,false],[0,0,0,"AUDITING_DISABLED",null," The specified event is currently not being audited.",null,false],[0,0,0,"PRENT4_MACHINE_ACCOUNT",null," The machine account was created prior to Windows NT 4.0 operating system. The account needs to be recreated.",null,false],[0,0,0,"DS_AG_CANT_HAVE_UNIVERSAL_MEMBER",null," An account group cannot have a universal group as a member.",null,false],[0,0,0,"INVALID_IMAGE_WIN_32",null," The specified image file did not have the correct format; it appears to be a 32-bit Windows image.",null,false],[0,0,0,"INVALID_IMAGE_WIN_64",null," The specified image file did not have the correct format; it appears to be a 64-bit Windows image.",null,false],[0,0,0,"BAD_BINDINGS",null," The client's supplied SSPI channel bindings were incorrect.",null,false],[0,0,0,"NETWORK_SESSION_EXPIRED",null," The client session has expired; so the client must re-authenticate to continue accessing the remote resources.",null,false],[0,0,0,"APPHELP_BLOCK",null," The AppHelp dialog box canceled; thus preventing the application from starting.",null,false],[0,0,0,"ALL_SIDS_FILTERED",null," The SID filtering operation removed all SIDs.",null,false],[0,0,0,"NOT_SAFE_MODE_DRIVER",null," The driver was not loaded because the system is starting in safe mode.",null,false],[0,0,0,"ACCESS_DISABLED_BY_POLICY_DEFAULT",null," Access to %1 has been restricted by your Administrator by the default software restriction policy level.",null,false],[0,0,0,"ACCESS_DISABLED_BY_POLICY_PATH",null," Access to %1 has been restricted by your Administrator by location with policy rule %2 placed on path %3.",null,false],[0,0,0,"ACCESS_DISABLED_BY_POLICY_PUBLISHER",null," Access to %1 has been restricted by your Administrator by software publisher policy.",null,false],[0,0,0,"ACCESS_DISABLED_BY_POLICY_OTHER",null," Access to %1 has been restricted by your Administrator by policy rule %2.",null,false],[0,0,0,"FAILED_DRIVER_ENTRY",null," The driver was not loaded because it failed its initialization call.",null,false],[0,0,0,"DEVICE_ENUMERATION_ERROR",null," The device encountered an error while applying power or reading the device configuration.\n This might be caused by a failure of your hardware or by a poor connection.",null,false],[0,0,0,"MOUNT_POINT_NOT_RESOLVED",null," The create operation failed because the name contained at least one mount point that resolves to a volume to which the specified device object is not attached.",null,false],[0,0,0,"INVALID_DEVICE_OBJECT_PARAMETER",null," The device object parameter is either not a valid device object or is not attached to the volume that is specified by the file name.",null,false],[0,0,0,"MCA_OCCURED",null," A machine check error has occurred.\n Check the system event log for additional information.",null,false],[0,0,0,"DRIVER_BLOCKED_CRITICAL",null," Driver %2 has been blocked from loading.",null,false],[0,0,0,"DRIVER_BLOCKED",null," Driver %2 has been blocked from loading.",null,false],[0,0,0,"DRIVER_DATABASE_ERROR",null," There was error [%2] processing the driver database.",null,false],[0,0,0,"SYSTEM_HIVE_TOO_LARGE",null," System hive size has exceeded its limit.",null,false],[0,0,0,"INVALID_IMPORT_OF_NON_DLL",null," A dynamic link library (DLL) referenced a module that was neither a DLL nor the process's executable image.",null,false],[0,0,0,"NO_SECRETS",null," The local account store does not contain secret material for the specified account.",null,false],[0,0,0,"ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY",null," Access to %1 has been restricted by your Administrator by policy rule %2.",null,false],[0,0,0,"FAILED_STACK_SWITCH",null," The system was not able to allocate enough memory to perform a stack switch.",null,false],[0,0,0,"HEAP_CORRUPTION",null," A heap has been corrupted.",null,false],[0,0,0,"SMARTCARD_WRONG_PIN",null," An incorrect PIN was presented to the smart card.",null,false],[0,0,0,"SMARTCARD_CARD_BLOCKED",null," The smart card is blocked.",null,false],[0,0,0,"SMARTCARD_CARD_NOT_AUTHENTICATED",null," No PIN was presented to the smart card.",null,false],[0,0,0,"SMARTCARD_NO_CARD",null," No smart card is available.",null,false],[0,0,0,"SMARTCARD_NO_KEY_CONTAINER",null," The requested key container does not exist on the smart card.",null,false],[0,0,0,"SMARTCARD_NO_CERTIFICATE",null," The requested certificate does not exist on the smart card.",null,false],[0,0,0,"SMARTCARD_NO_KEYSET",null," The requested keyset does not exist.",null,false],[0,0,0,"SMARTCARD_IO_ERROR",null," A communication error with the smart card has been detected.",null,false],[0,0,0,"DOWNGRADE_DETECTED",null," The system detected a possible attempt to compromise security.\n Ensure that you can contact the server that authenticated you.",null,false],[0,0,0,"SMARTCARD_CERT_REVOKED",null," The smart card certificate used for authentication has been revoked. Contact your system administrator.\n There might be additional information in the event log.",null,false],[0,0,0,"ISSUING_CA_UNTRUSTED",null," An untrusted certificate authority was detected while processing the smart card certificate that is used for authentication. Contact your system administrator.",null,false],[0,0,0,"REVOCATION_OFFLINE_C",null," The revocation status of the smart card certificate that is used for authentication could not be determined. Contact your system administrator.",null,false],[0,0,0,"PKINIT_CLIENT_FAILURE",null," The smart card certificate used for authentication was not trusted. Contact your system administrator.",null,false],[0,0,0,"SMARTCARD_CERT_EXPIRED",null," The smart card certificate used for authentication has expired. Contact your system administrator.",null,false],[0,0,0,"DRIVER_FAILED_PRIOR_UNLOAD",null," The driver could not be loaded because a previous version of the driver is still in memory.",null,false],[0,0,0,"SMARTCARD_SILENT_CONTEXT",null," The smart card provider could not perform the action because the context was acquired as silent.",null,false],[0,0,0,"PER_USER_TRUST_QUOTA_EXCEEDED",null," The delegated trust creation quota of the current user has been exceeded.",null,false],[0,0,0,"ALL_USER_TRUST_QUOTA_EXCEEDED",null," The total delegated trust creation quota has been exceeded.",null,false],[0,0,0,"USER_DELETE_TRUST_QUOTA_EXCEEDED",null," The delegated trust deletion quota of the current user has been exceeded.",null,false],[0,0,0,"DS_NAME_NOT_UNIQUE",null," The requested name already exists as a unique identifier.",null,false],[0,0,0,"DS_DUPLICATE_ID_FOUND",null," The requested object has a non-unique identifier and cannot be retrieved.",null,false],[0,0,0,"DS_GROUP_CONVERSION_ERROR",null," The group cannot be converted due to attribute restrictions on the requested group type.",null,false],[0,0,0,"VOLSNAP_PREPARE_HIBERNATE",null," {Volume Shadow Copy Service} Wait while the Volume Shadow Copy Service prepares volume %hs for hibernation.",null,false],[0,0,0,"USER2USER_REQUIRED",null," Kerberos sub-protocol User2User is required.",null,false],[0,0,0,"STACK_BUFFER_OVERRUN",null," The system detected an overrun of a stack-based buffer in this application.\n This overrun could potentially allow a malicious user to gain control of this application.",null,false],[0,0,0,"NO_S4U_PROT_SUPPORT",null," The Kerberos subsystem encountered an error.\n A service for user protocol request was made against a domain controller which does not support service for user.",null,false],[0,0,0,"CROSSREALM_DELEGATION_FAILURE",null," An attempt was made by this server to make a Kerberos constrained delegation request for a target that is outside the server realm.\n This action is not supported and the resulting error indicates a misconfiguration on the allowed-to-delegate-to list for this server. Contact your administrator.",null,false],[0,0,0,"REVOCATION_OFFLINE_KDC",null," The revocation status of the domain controller certificate used for smart card authentication could not be determined.\n There is additional information in the system event log. Contact your system administrator.",null,false],[0,0,0,"ISSUING_CA_UNTRUSTED_KDC",null," An untrusted certificate authority was detected while processing the domain controller certificate used for authentication.\n There is additional information in the system event log. Contact your system administrator.",null,false],[0,0,0,"KDC_CERT_EXPIRED",null," The domain controller certificate used for smart card logon has expired.\n Contact your system administrator with the contents of your system event log.",null,false],[0,0,0,"KDC_CERT_REVOKED",null," The domain controller certificate used for smart card logon has been revoked.\n Contact your system administrator with the contents of your system event log.",null,false],[0,0,0,"PARAMETER_QUOTA_EXCEEDED",null," Data present in one of the parameters is more than the function can operate on.",null,false],[0,0,0,"HIBERNATION_FAILURE",null," The system has failed to hibernate (The error code is %hs).\n Hibernation will be disabled until the system is restarted.",null,false],[0,0,0,"DELAY_LOAD_FAILED",null," An attempt to delay-load a .dll or get a function address in a delay-loaded .dll failed.",null,false],[0,0,0,"AUTHENTICATION_FIREWALL_FAILED",null," Logon Failure: The machine you are logging onto is protected by an authentication firewall.\n The specified account is not allowed to authenticate to the machine.",null,false],[0,0,0,"VDM_DISALLOWED",null," %hs is a 16-bit application. You do not have permissions to execute 16-bit applications.\n Check your permissions with your system administrator.",null,false],[0,0,0,"HUNG_DISPLAY_DRIVER_THREAD",null," {Display Driver Stopped Responding} The %hs display driver has stopped working normally.\n Save your work and reboot the system to restore full display functionality.\n The next time you reboot the machine a dialog will be displayed giving you a chance to report this failure to Microsoft.",null,false],[0,0,0,"INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE",null," The Desktop heap encountered an error while allocating session memory.\n There is more information in the system event log.",null,false],[0,0,0,"INVALID_CRUNTIME_PARAMETER",null," An invalid parameter was passed to a C runtime function.",null,false],[0,0,0,"NTLM_BLOCKED",null," The authentication failed because NTLM was blocked.",null,false],[0,0,0,"DS_SRC_SID_EXISTS_IN_FOREST",null," The source object's SID already exists in destination forest.",null,false],[0,0,0,"DS_DOMAIN_NAME_EXISTS_IN_FOREST",null," The domain name of the trusted domain already exists in the forest.",null,false],[0,0,0,"DS_FLAT_NAME_EXISTS_IN_FOREST",null," The flat name of the trusted domain already exists in the forest.",null,false],[0,0,0,"INVALID_USER_PRINCIPAL_NAME",null," The User Principal Name (UPN) is invalid.",null,false],[0,0,0,"ASSERTION_FAILURE",null," There has been an assertion failure.",null,false],[0,0,0,"VERIFIER_STOP",null," Application verifier has found an error in the current process.",null,false],[0,0,0,"CALLBACK_POP_STACK",null," A user mode unwind is in progress.",null,false],[0,0,0,"INCOMPATIBLE_DRIVER_BLOCKED",null," %2 has been blocked from loading due to incompatibility with this system.\n Contact your software vendor for a compatible version of the driver.",null,false],[0,0,0,"HIVE_UNLOADED",null," Illegal operation attempted on a registry key which has already been unloaded.",null,false],[0,0,0,"COMPRESSION_DISABLED",null," Compression is disabled for this volume.",null,false],[0,0,0,"FILE_SYSTEM_LIMITATION",null," The requested operation could not be completed due to a file system limitation.",null,false],[0,0,0,"INVALID_IMAGE_HASH",null," The hash for image %hs cannot be found in the system catalogs.\n The image is likely corrupt or the victim of tampering.",null,false],[0,0,0,"NOT_CAPABLE",null," The implementation is not capable of performing the request.",null,false],[0,0,0,"REQUEST_OUT_OF_SEQUENCE",null," The requested operation is out of order with respect to other operations.",null,false],[0,0,0,"IMPLEMENTATION_LIMIT",null," An operation attempted to exceed an implementation-defined limit.",null,false],[0,0,0,"ELEVATION_REQUIRED",null," The requested operation requires elevation.",null,false],[0,0,0,"NO_SECURITY_CONTEXT",null," The required security context does not exist.",null,false],[0,0,0,"PKU2U_CERT_FAILURE",null," The PKU2U protocol encountered an error while attempting to utilize the associated certificates.",null,false],[0,0,0,"BEYOND_VDL",null," The operation was attempted beyond the valid data length of the file.",null,false],[0,0,0,"ENCOUNTERED_WRITE_IN_PROGRESS",null," The attempted write operation encountered a write already in progress for some portion of the range.",null,false],[0,0,0,"PTE_CHANGED",null," The page fault mappings changed in the middle of processing a fault so the operation must be retried.",null,false],[0,0,0,"PURGE_FAILED",null," The attempt to purge this file from memory failed to purge some or all the data from memory.",null,false],[0,0,0,"CRED_REQUIRES_CONFIRMATION",null," The requested credential requires confirmation.",null,false],[0,0,0,"CS_ENCRYPTION_INVALID_SERVER_RESPONSE",null," The remote server sent an invalid response for a file being opened with Client Side Encryption.",null,false],[0,0,0,"CS_ENCRYPTION_UNSUPPORTED_SERVER",null," Client Side Encryption is not supported by the remote server even though it claims to support it.",null,false],[0,0,0,"CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE",null," File is encrypted and should be opened in Client Side Encryption mode.",null,false],[0,0,0,"CS_ENCRYPTION_NEW_ENCRYPTED_FILE",null," A new encrypted file is being created and a $EFS needs to be provided.",null,false],[0,0,0,"CS_ENCRYPTION_FILE_NOT_CSE",null," The SMB client requested a CSE FSCTL on a non-CSE file.",null,false],[0,0,0,"INVALID_LABEL",null," Indicates a particular Security ID cannot be assigned as the label of an object.",null,false],[0,0,0,"DRIVER_PROCESS_TERMINATED",null," The process hosting the driver for this device has terminated.",null,false],[0,0,0,"AMBIGUOUS_SYSTEM_DEVICE",null," The requested system device cannot be identified due to multiple indistinguishable devices potentially matching the identification criteria.",null,false],[0,0,0,"SYSTEM_DEVICE_NOT_FOUND",null," The requested system device cannot be found.",null,false],[0,0,0,"RESTART_BOOT_APPLICATION",null," This boot application must be restarted.",null,false],[0,0,0,"INSUFFICIENT_NVRAM_RESOURCES",null," Insufficient NVRAM resources exist to complete the API.  A reboot might be required.",null,false],[0,0,0,"NO_RANGES_PROCESSED",null," No ranges for the specified operation were able to be processed.",null,false],[0,0,0,"DEVICE_FEATURE_NOT_SUPPORTED",null," The storage device does not support Offload Write.",null,false],[0,0,0,"DEVICE_UNREACHABLE",null," Data cannot be moved because the source device cannot communicate with the destination device.",null,false],[0,0,0,"INVALID_TOKEN",null," The token representing the data is invalid or expired.",null,false],[0,0,0,"SERVER_UNAVAILABLE",null," The file server is temporarily unavailable.",null,false],[0,0,0,"INVALID_TASK_NAME",null," The specified task name is invalid.",null,false],[0,0,0,"INVALID_TASK_INDEX",null," The specified task index is invalid.",null,false],[0,0,0,"THREAD_ALREADY_IN_TASK",null," The specified thread is already joining a task.",null,false],[0,0,0,"CALLBACK_BYPASS",null," A callback has requested to bypass native code.",null,false],[0,0,0,"FAIL_FAST_EXCEPTION",null," A fail fast exception occurred.\n Exception handlers will not be invoked and the process will be terminated immediately.",null,false],[0,0,0,"IMAGE_CERT_REVOKED",null," Windows cannot verify the digital signature for this file.\n The signing certificate for this file has been revoked.",null,false],[0,0,0,"PORT_CLOSED",null," The ALPC port is closed.",null,false],[0,0,0,"MESSAGE_LOST",null," The ALPC message requested is no longer available.",null,false],[0,0,0,"INVALID_MESSAGE",null," The ALPC message supplied is invalid.",null,false],[0,0,0,"REQUEST_CANCELED",null," The ALPC message has been canceled.",null,false],[0,0,0,"RECURSIVE_DISPATCH",null," Invalid recursive dispatch attempt.",null,false],[0,0,0,"LPC_RECEIVE_BUFFER_EXPECTED",null," No receive buffer has been supplied in a synchronous request.",null,false],[0,0,0,"LPC_INVALID_CONNECTION_USAGE",null," The connection port is used in an invalid context.",null,false],[0,0,0,"LPC_REQUESTS_NOT_ALLOWED",null," The ALPC port does not accept new request messages.",null,false],[0,0,0,"RESOURCE_IN_USE",null," The resource requested is already in use.",null,false],[0,0,0,"HARDWARE_MEMORY_ERROR",null," The hardware has reported an uncorrectable memory error.",null,false],[0,0,0,"THREADPOOL_HANDLE_EXCEPTION",null," Status 0x%08x was returned, waiting on handle 0x%x for wait 0x%p, in waiter 0x%p.",null,false],[0,0,0,"THREADPOOL_SET_EVENT_ON_COMPLETION_FAILED",null," After a callback to 0x%p(0x%p), a completion call to Set event(0x%p) failed with status 0x%08x.",null,false],[0,0,0,"THREADPOOL_RELEASE_SEMAPHORE_ON_COMPLETION_FAILED",null," After a callback to 0x%p(0x%p), a completion call to ReleaseSemaphore(0x%p, %d) failed with status 0x%08x.",null,false],[0,0,0,"THREADPOOL_RELEASE_MUTEX_ON_COMPLETION_FAILED",null," After a callback to 0x%p(0x%p), a completion call to ReleaseMutex(%p) failed with status 0x%08x.",null,false],[0,0,0,"THREADPOOL_FREE_LIBRARY_ON_COMPLETION_FAILED",null," After a callback to 0x%p(0x%p), a completion call to FreeLibrary(%p) failed with status 0x%08x.",null,false],[0,0,0,"THREADPOOL_RELEASED_DURING_OPERATION",null," The thread pool 0x%p was released while a thread was posting a callback to 0x%p(0x%p) to it.",null,false],[0,0,0,"CALLBACK_RETURNED_WHILE_IMPERSONATING",null," A thread pool worker thread is impersonating a client, after a callback to 0x%p(0x%p).\n This is unexpected, indicating that the callback is missing a call to revert the impersonation.",null,false],[0,0,0,"APC_RETURNED_WHILE_IMPERSONATING",null," A thread pool worker thread is impersonating a client, after executing an APC.\n This is unexpected, indicating that the APC is missing a call to revert the impersonation.",null,false],[0,0,0,"PROCESS_IS_PROTECTED",null," Either the target process, or the target thread's containing process, is a protected process.",null,false],[0,0,0,"MCA_EXCEPTION",null," A thread is getting dispatched with MCA EXCEPTION because of MCA.",null,false],[0,0,0,"CERTIFICATE_MAPPING_NOT_UNIQUE",null," The client certificate account mapping is not unique.",null,false],[0,0,0,"SYMLINK_CLASS_DISABLED",null," The symbolic link cannot be followed because its type is disabled.",null,false],[0,0,0,"INVALID_IDN_NORMALIZATION",null," Indicates that the specified string is not valid for IDN normalization.",null,false],[0,0,0,"NO_UNICODE_TRANSLATION",null," No mapping for the Unicode character exists in the target multi-byte code page.",null,false],[0,0,0,"ALREADY_REGISTERED",null," The provided callback is already registered.",null,false],[0,0,0,"CONTEXT_MISMATCH",null," The provided context did not match the target.",null,false],[0,0,0,"PORT_ALREADY_HAS_COMPLETION_LIST",null," The specified port already has a completion list.",null,false],[0,0,0,"CALLBACK_RETURNED_THREAD_PRIORITY",null," A threadpool worker thread entered a callback at thread base priority 0x%x and exited at priority 0x%x.\n This is unexpected, indicating that the callback missed restoring the priority.",null,false],[0,0,0,"INVALID_THREAD",null," An invalid thread, handle %p, is specified for this operation.\n Possibly, a threadpool worker thread was specified.",null,false],[0,0,0,"CALLBACK_RETURNED_TRANSACTION",null," A threadpool worker thread entered a callback, which left transaction state.\n This is unexpected, indicating that the callback missed clearing the transaction.",null,false],[0,0,0,"CALLBACK_RETURNED_LDR_LOCK",null," A threadpool worker thread entered a callback, which left the loader lock held.\n This is unexpected, indicating that the callback missed releasing the lock.",null,false],[0,0,0,"CALLBACK_RETURNED_LANG",null," A threadpool worker thread entered a callback, which left with preferred languages set.\n This is unexpected, indicating that the callback missed clearing them.",null,false],[0,0,0,"CALLBACK_RETURNED_PRI_BACK",null," A threadpool worker thread entered a callback, which left with background priorities set.\n This is unexpected, indicating that the callback missed restoring the original priorities.",null,false],[0,0,0,"DISK_REPAIR_DISABLED",null," The attempted operation required self healing to be enabled.",null,false],[0,0,0,"DS_DOMAIN_RENAME_IN_PROGRESS",null," The directory service cannot perform the requested operation because a domain rename operation is in progress.",null,false],[0,0,0,"DISK_QUOTA_EXCEEDED",null," An operation failed because the storage quota was exceeded.",null,false],[0,0,0,"CONTENT_BLOCKED",null," An operation failed because the content was blocked.",null,false],[0,0,0,"BAD_CLUSTERS",null," The operation could not be completed due to bad clusters on disk.",null,false],[0,0,0,"VOLUME_DIRTY",null," The operation could not be completed because the volume is dirty. Please run the Chkdsk utility and try again.",null,false],[0,0,0,"FILE_CHECKED_OUT",null," This file is checked out or locked for editing by another user.",null,false],[0,0,0,"CHECKOUT_REQUIRED",null," The file must be checked out before saving changes.",null,false],[0,0,0,"BAD_FILE_TYPE",null," The file type being saved or retrieved has been blocked.",null,false],[0,0,0,"FILE_TOO_LARGE",null," The file size exceeds the limit allowed and cannot be saved.",null,false],[0,0,0,"FORMS_AUTH_REQUIRED",null," Access Denied. Before opening files in this location, you must first browse to the e.g.\n site and select the option to log on automatically.",null,false],[0,0,0,"VIRUS_INFECTED",null," The operation did not complete successfully because the file contains a virus.",null,false],[0,0,0,"VIRUS_DELETED",null," This file contains a virus and cannot be opened.\n Due to the nature of this virus, the file has been removed from this location.",null,false],[0,0,0,"BAD_MCFG_TABLE",null," The resources required for this device conflict with the MCFG table.",null,false],[0,0,0,"CANNOT_BREAK_OPLOCK",null," The operation did not complete successfully because it would cause an oplock to be broken.\n The caller has requested that existing oplocks not be broken.",null,false],[0,0,0,"WOW_ASSERTION",null," WOW Assertion Error.",null,false],[0,0,0,"INVALID_SIGNATURE",null," The cryptographic signature is invalid.",null,false],[0,0,0,"HMAC_NOT_SUPPORTED",null," The cryptographic provider does not support HMAC.",null,false],[0,0,0,"IPSEC_QUEUE_OVERFLOW",null," The IPsec queue overflowed.",null,false],[0,0,0,"ND_QUEUE_OVERFLOW",null," The neighbor discovery queue overflowed.",null,false],[0,0,0,"HOPLIMIT_EXCEEDED",null," An Internet Control Message Protocol (ICMP) hop limit exceeded error was received.",null,false],[0,0,0,"PROTOCOL_NOT_SUPPORTED",null," The protocol is not installed on the local machine.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost.\n This error might be caused by network connectivity issues. Try to save this file elsewhere.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost.\n This error was returned by the server on which the file exists. Try to save this file elsewhere.",null,false],[0,0,0,"LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR",null," {Delayed Write Failed} Windows was unable to save all the data for the file %hs; the data has been lost.\n This error might be caused if the device has been removed or the media is write-protected.",null,false],[0,0,0,"XML_PARSE_ERROR",null," Windows was unable to parse the requested XML data.",null,false],[0,0,0,"XMLDSIG_ERROR",null," An error was encountered while processing an XML digital signature.",null,false],[0,0,0,"WRONG_COMPARTMENT",null," This indicates that the caller made the connection request in the wrong routing compartment.",null,false],[0,0,0,"AUTHIP_FAILURE",null," This indicates that there was an AuthIP failure when attempting to connect to the remote host.",null,false],[0,0,0,"DS_OID_MAPPED_GROUP_CANT_HAVE_MEMBERS",null," OID mapped groups cannot have members.",null,false],[0,0,0,"DS_OID_NOT_FOUND",null," The specified OID cannot be found.",null,false],[0,0,0,"HASH_NOT_SUPPORTED",null," Hash generation for the specified version and hash type is not enabled on server.",null,false],[0,0,0,"HASH_NOT_PRESENT",null," The hash requests is not present or not up to date with the current file contents.",null,false],[0,0,0,"OFFLOAD_READ_FLT_NOT_SUPPORTED",null," A file system filter on the server has not opted in for Offload Read support.",null,false],[0,0,0,"OFFLOAD_WRITE_FLT_NOT_SUPPORTED",null," A file system filter on the server has not opted in for Offload Write support.",null,false],[0,0,0,"OFFLOAD_READ_FILE_NOT_SUPPORTED",null," Offload read operations cannot be performed on:\n   - Compressed files\n   - Sparse files\n   - Encrypted files\n   - File system metadata files",null,false],[0,0,0,"OFFLOAD_WRITE_FILE_NOT_SUPPORTED",null," Offload write operations cannot be performed on:\n  - Compressed files\n  - Sparse files\n  - Encrypted files\n  - File system metadata files",null,false],[0,0,0,"DBG_NO_STATE_CHANGE",null," The debugger did not perform a state change.",null,false],[0,0,0,"DBG_APP_NOT_IDLE",null," The debugger found that the application is not idle.",null,false],[0,0,0,"RPC_NT_INVALID_STRING_BINDING",null," The string binding is invalid.",null,false],[0,0,0,"RPC_NT_WRONG_KIND_OF_BINDING",null," The binding handle is not the correct type.",null,false],[0,0,0,"RPC_NT_INVALID_BINDING",null," The binding handle is invalid.",null,false],[0,0,0,"RPC_NT_PROTSEQ_NOT_SUPPORTED",null," The RPC protocol sequence is not supported.",null,false],[0,0,0,"RPC_NT_INVALID_RPC_PROTSEQ",null," The RPC protocol sequence is invalid.",null,false],[0,0,0,"RPC_NT_INVALID_STRING_UUID",null," The string UUID is invalid.",null,false],[0,0,0,"RPC_NT_INVALID_ENDPOINT_FORMAT",null," The endpoint format is invalid.",null,false],[0,0,0,"RPC_NT_INVALID_NET_ADDR",null," The network address is invalid.",null,false],[0,0,0,"RPC_NT_NO_ENDPOINT_FOUND",null," No endpoint was found.",null,false],[0,0,0,"RPC_NT_INVALID_TIMEOUT",null," The time-out value is invalid.",null,false],[0,0,0,"RPC_NT_OBJECT_NOT_FOUND",null," The object UUID was not found.",null,false],[0,0,0,"RPC_NT_ALREADY_REGISTERED",null," The object UUID has already been registered.",null,false],[0,0,0,"RPC_NT_TYPE_ALREADY_REGISTERED",null," The type UUID has already been registered.",null,false],[0,0,0,"RPC_NT_ALREADY_LISTENING",null," The RPC server is already listening.",null,false],[0,0,0,"RPC_NT_NO_PROTSEQS_REGISTERED",null," No protocol sequences have been registered.",null,false],[0,0,0,"RPC_NT_NOT_LISTENING",null," The RPC server is not listening.",null,false],[0,0,0,"RPC_NT_UNKNOWN_MGR_TYPE",null," The manager type is unknown.",null,false],[0,0,0,"RPC_NT_UNKNOWN_IF",null," The interface is unknown.",null,false],[0,0,0,"RPC_NT_NO_BINDINGS",null," There are no bindings.",null,false],[0,0,0,"RPC_NT_NO_PROTSEQS",null," There are no protocol sequences.",null,false],[0,0,0,"RPC_NT_CANT_CREATE_ENDPOINT",null," The endpoint cannot be created.",null,false],[0,0,0,"RPC_NT_OUT_OF_RESOURCES",null," Insufficient resources are available to complete this operation.",null,false],[0,0,0,"RPC_NT_SERVER_UNAVAILABLE",null," The RPC server is unavailable.",null,false],[0,0,0,"RPC_NT_SERVER_TOO_BUSY",null," The RPC server is too busy to complete this operation.",null,false],[0,0,0,"RPC_NT_INVALID_NETWORK_OPTIONS",null," The network options are invalid.",null,false],[0,0,0,"RPC_NT_NO_CALL_ACTIVE",null," No RPCs are active on this thread.",null,false],[0,0,0,"RPC_NT_CALL_FAILED",null," The RPC failed.",null,false],[0,0,0,"RPC_NT_CALL_FAILED_DNE",null," The RPC failed and did not execute.",null,false],[0,0,0,"RPC_NT_PROTOCOL_ERROR",null," An RPC protocol error occurred.",null,false],[0,0,0,"RPC_NT_UNSUPPORTED_TRANS_SYN",null," The RPC server does not support the transfer syntax.",null,false],[0,0,0,"RPC_NT_UNSUPPORTED_TYPE",null," The type UUID is not supported.",null,false],[0,0,0,"RPC_NT_INVALID_TAG",null," The tag is invalid.",null,false],[0,0,0,"RPC_NT_INVALID_BOUND",null," The array bounds are invalid.",null,false],[0,0,0,"RPC_NT_NO_ENTRY_NAME",null," The binding does not contain an entry name.",null,false],[0,0,0,"RPC_NT_INVALID_NAME_SYNTAX",null," The name syntax is invalid.",null,false],[0,0,0,"RPC_NT_UNSUPPORTED_NAME_SYNTAX",null," The name syntax is not supported.",null,false],[0,0,0,"RPC_NT_UUID_NO_ADDRESS",null," No network address is available to construct a UUID.",null,false],[0,0,0,"RPC_NT_DUPLICATE_ENDPOINT",null," The endpoint is a duplicate.",null,false],[0,0,0,"RPC_NT_UNKNOWN_AUTHN_TYPE",null," The authentication type is unknown.",null,false],[0,0,0,"RPC_NT_MAX_CALLS_TOO_SMALL",null," The maximum number of calls is too small.",null,false],[0,0,0,"RPC_NT_STRING_TOO_LONG",null," The string is too long.",null,false],[0,0,0,"RPC_NT_PROTSEQ_NOT_FOUND",null," The RPC protocol sequence was not found.",null,false],[0,0,0,"RPC_NT_PROCNUM_OUT_OF_RANGE",null," The procedure number is out of range.",null,false],[0,0,0,"RPC_NT_BINDING_HAS_NO_AUTH",null," The binding does not contain any authentication information.",null,false],[0,0,0,"RPC_NT_UNKNOWN_AUTHN_SERVICE",null," The authentication service is unknown.",null,false],[0,0,0,"RPC_NT_UNKNOWN_AUTHN_LEVEL",null," The authentication level is unknown.",null,false],[0,0,0,"RPC_NT_INVALID_AUTH_IDENTITY",null," The security context is invalid.",null,false],[0,0,0,"RPC_NT_UNKNOWN_AUTHZ_SERVICE",null," The authorization service is unknown.",null,false],[0,0,0,"EPT_NT_INVALID_ENTRY",null," The entry is invalid.",null,false],[0,0,0,"EPT_NT_CANT_PERFORM_OP",null," The operation cannot be performed.",null,false],[0,0,0,"EPT_NT_NOT_REGISTERED",null," No more endpoints are available from the endpoint mapper.",null,false],[0,0,0,"RPC_NT_NOTHING_TO_EXPORT",null," No interfaces have been exported.",null,false],[0,0,0,"RPC_NT_INCOMPLETE_NAME",null," The entry name is incomplete.",null,false],[0,0,0,"RPC_NT_INVALID_VERS_OPTION",null," The version option is invalid.",null,false],[0,0,0,"RPC_NT_NO_MORE_MEMBERS",null," There are no more members.",null,false],[0,0,0,"RPC_NT_NOT_ALL_OBJS_UNEXPORTED",null," There is nothing to unexport.",null,false],[0,0,0,"RPC_NT_INTERFACE_NOT_FOUND",null," The interface was not found.",null,false],[0,0,0,"RPC_NT_ENTRY_ALREADY_EXISTS",null," The entry already exists.",null,false],[0,0,0,"RPC_NT_ENTRY_NOT_FOUND",null," The entry was not found.",null,false],[0,0,0,"RPC_NT_NAME_SERVICE_UNAVAILABLE",null," The name service is unavailable.",null,false],[0,0,0,"RPC_NT_INVALID_NAF_ID",null," The network address family is invalid.",null,false],[0,0,0,"RPC_NT_CANNOT_SUPPORT",null," The requested operation is not supported.",null,false],[0,0,0,"RPC_NT_NO_CONTEXT_AVAILABLE",null," No security context is available to allow impersonation.",null,false],[0,0,0,"RPC_NT_INTERNAL_ERROR",null," An internal error occurred in the RPC.",null,false],[0,0,0,"RPC_NT_ZERO_DIVIDE",null," The RPC server attempted to divide an integer by zero.",null,false],[0,0,0,"RPC_NT_ADDRESS_ERROR",null," An addressing error occurred in the RPC server.",null,false],[0,0,0,"RPC_NT_FP_DIV_ZERO",null," A floating point operation at the RPC server caused a divide by zero.",null,false],[0,0,0,"RPC_NT_FP_UNDERFLOW",null," A floating point underflow occurred at the RPC server.",null,false],[0,0,0,"RPC_NT_FP_OVERFLOW",null," A floating point overflow occurred at the RPC server.",null,false],[0,0,0,"RPC_NT_CALL_IN_PROGRESS",null," An RPC is already in progress for this thread.",null,false],[0,0,0,"RPC_NT_NO_MORE_BINDINGS",null," There are no more bindings.",null,false],[0,0,0,"RPC_NT_GROUP_MEMBER_NOT_FOUND",null," The group member was not found.",null,false],[0,0,0,"EPT_NT_CANT_CREATE",null," The endpoint mapper database entry could not be created.",null,false],[0,0,0,"RPC_NT_INVALID_OBJECT",null," The object UUID is the nil UUID.",null,false],[0,0,0,"RPC_NT_NO_INTERFACES",null," No interfaces have been registered.",null,false],[0,0,0,"RPC_NT_CALL_CANCELLED",null," The RPC was canceled.",null,false],[0,0,0,"RPC_NT_BINDING_INCOMPLETE",null," The binding handle does not contain all the required information.",null,false],[0,0,0,"RPC_NT_COMM_FAILURE",null," A communications failure occurred during an RPC.",null,false],[0,0,0,"RPC_NT_UNSUPPORTED_AUTHN_LEVEL",null," The requested authentication level is not supported.",null,false],[0,0,0,"RPC_NT_NO_PRINC_NAME",null," No principal name was registered.",null,false],[0,0,0,"RPC_NT_NOT_RPC_ERROR",null," The error specified is not a valid Windows RPC error code.",null,false],[0,0,0,"RPC_NT_SEC_PKG_ERROR",null," A security package-specific error occurred.",null,false],[0,0,0,"RPC_NT_NOT_CANCELLED",null," The thread was not canceled.",null,false],[0,0,0,"RPC_NT_INVALID_ASYNC_HANDLE",null," Invalid asynchronous RPC handle.",null,false],[0,0,0,"RPC_NT_INVALID_ASYNC_CALL",null," Invalid asynchronous RPC call handle for this operation.",null,false],[0,0,0,"RPC_NT_PROXY_ACCESS_DENIED",null," Access to the HTTP proxy is denied.",null,false],[0,0,0,"RPC_NT_NO_MORE_ENTRIES",null," The list of RPC servers available for auto-handle binding has been exhausted.",null,false],[0,0,0,"RPC_NT_SS_CHAR_TRANS_OPEN_FAIL",null," The file designated by DCERPCCHARTRANS cannot be opened.",null,false],[0,0,0,"RPC_NT_SS_CHAR_TRANS_SHORT_FILE",null," The file containing the character translation table has fewer than 512 bytes.",null,false],[0,0,0,"RPC_NT_SS_IN_NULL_CONTEXT",null," A null context handle is passed as an [in] parameter.",null,false],[0,0,0,"RPC_NT_SS_CONTEXT_MISMATCH",null," The context handle does not match any known context handles.",null,false],[0,0,0,"RPC_NT_SS_CONTEXT_DAMAGED",null," The context handle changed during a call.",null,false],[0,0,0,"RPC_NT_SS_HANDLES_MISMATCH",null," The binding handles passed to an RPC do not match.",null,false],[0,0,0,"RPC_NT_SS_CANNOT_GET_CALL_HANDLE",null," The stub is unable to get the call handle.",null,false],[0,0,0,"RPC_NT_NULL_REF_POINTER",null," A null reference pointer was passed to the stub.",null,false],[0,0,0,"RPC_NT_ENUM_VALUE_OUT_OF_RANGE",null," The enumeration value is out of range.",null,false],[0,0,0,"RPC_NT_BYTE_COUNT_TOO_SMALL",null," The byte count is too small.",null,false],[0,0,0,"RPC_NT_BAD_STUB_DATA",null," The stub received bad data.",null,false],[0,0,0,"RPC_NT_INVALID_ES_ACTION",null," Invalid operation on the encoding/decoding handle.",null,false],[0,0,0,"RPC_NT_WRONG_ES_VERSION",null," Incompatible version of the serializing package.",null,false],[0,0,0,"RPC_NT_WRONG_STUB_VERSION",null," Incompatible version of the RPC stub.",null,false],[0,0,0,"RPC_NT_INVALID_PIPE_OBJECT",null," The RPC pipe object is invalid or corrupt.",null,false],[0,0,0,"RPC_NT_INVALID_PIPE_OPERATION",null," An invalid operation was attempted on an RPC pipe object.",null,false],[0,0,0,"RPC_NT_WRONG_PIPE_VERSION",null," Unsupported RPC pipe version.",null,false],[0,0,0,"RPC_NT_PIPE_CLOSED",null," The RPC pipe object has already been closed.",null,false],[0,0,0,"RPC_NT_PIPE_DISCIPLINE_ERROR",null," The RPC call completed before all pipes were processed.",null,false],[0,0,0,"RPC_NT_PIPE_EMPTY",null," No more data is available from the RPC pipe.",null,false],[0,0,0,"PNP_BAD_MPS_TABLE",null," A device is missing in the system BIOS MPS table. This device will not be used.\n Contact your system vendor for a system BIOS update.",null,false],[0,0,0,"PNP_TRANSLATION_FAILED",null," A translator failed to translate resources.",null,false],[0,0,0,"PNP_IRQ_TRANSLATION_FAILED",null," An IRQ translator failed to translate resources.",null,false],[0,0,0,"PNP_INVALID_ID",null," Driver %2 returned an invalid ID for a child device (%3).",null,false],[0,0,0,"IO_REISSUE_AS_CACHED",null," Reissue the given operation as a cached I/O operation",null,false],[0,0,0,"CTX_WINSTATION_NAME_INVALID",null," Session name %1 is invalid.",null,false],[0,0,0,"CTX_INVALID_PD",null," The protocol driver %1 is invalid.",null,false],[0,0,0,"CTX_PD_NOT_FOUND",null," The protocol driver %1 was not found in the system path.",null,false],[0,0,0,"CTX_CLOSE_PENDING",null," A close operation is pending on the terminal connection.",null,false],[0,0,0,"CTX_NO_OUTBUF",null," No free output buffers are available.",null,false],[0,0,0,"CTX_MODEM_INF_NOT_FOUND",null," The MODEM.INF file was not found.",null,false],[0,0,0,"CTX_INVALID_MODEMNAME",null," The modem (%1) was not found in the MODEM.INF file.",null,false],[0,0,0,"CTX_RESPONSE_ERROR",null," The modem did not accept the command sent to it.\n Verify that the configured modem name matches the attached modem.",null,false],[0,0,0,"CTX_MODEM_RESPONSE_TIMEOUT",null," The modem did not respond to the command sent to it.\n Verify that the modem cable is properly attached and the modem is turned on.",null,false],[0,0,0,"CTX_MODEM_RESPONSE_NO_CARRIER",null," Carrier detection has failed or the carrier has been dropped due to disconnection.",null,false],[0,0,0,"CTX_MODEM_RESPONSE_NO_DIALTONE",null," A dial tone was not detected within the required time.\n Verify that the phone cable is properly attached and functional.",null,false],[0,0,0,"CTX_MODEM_RESPONSE_BUSY",null," A busy signal was detected at a remote site on callback.",null,false],[0,0,0,"CTX_MODEM_RESPONSE_VOICE",null," A voice was detected at a remote site on callback.",null,false],[0,0,0,"CTX_TD_ERROR",null," Transport driver error.",null,false],[0,0,0,"CTX_LICENSE_CLIENT_INVALID",null," The client you are using is not licensed to use this system. Your logon request is denied.",null,false],[0,0,0,"CTX_LICENSE_NOT_AVAILABLE",null," The system has reached its licensed logon limit. Try again later.",null,false],[0,0,0,"CTX_LICENSE_EXPIRED",null," The system license has expired. Your logon request is denied.",null,false],[0,0,0,"CTX_WINSTATION_NOT_FOUND",null," The specified session cannot be found.",null,false],[0,0,0,"CTX_WINSTATION_NAME_COLLISION",null," The specified session name is already in use.",null,false],[0,0,0,"CTX_WINSTATION_BUSY",null," The requested operation cannot be completed because the terminal connection is currently processing a connect, disconnect, reset, or delete operation.",null,false],[0,0,0,"CTX_BAD_VIDEO_MODE",null," An attempt has been made to connect to a session whose video mode is not supported by the current client.",null,false],[0,0,0,"CTX_GRAPHICS_INVALID",null," The application attempted to enable DOS graphics mode. DOS graphics mode is not supported.",null,false],[0,0,0,"CTX_NOT_CONSOLE",null," The requested operation can be performed only on the system console.\n This is most often the result of a driver or system DLL requiring direct console access.",null,false],[0,0,0,"CTX_CLIENT_QUERY_TIMEOUT",null," The client failed to respond to the server connect message.",null,false],[0,0,0,"CTX_CONSOLE_DISCONNECT",null," Disconnecting the console session is not supported.",null,false],[0,0,0,"CTX_CONSOLE_CONNECT",null," Reconnecting a disconnected session to the console is not supported.",null,false],[0,0,0,"CTX_SHADOW_DENIED",null," The request to control another session remotely was denied.",null,false],[0,0,0,"CTX_WINSTATION_ACCESS_DENIED",null," A process has requested access to a session, but has not been granted those access rights.",null,false],[0,0,0,"CTX_INVALID_WD",null," The terminal connection driver %1 is invalid.",null,false],[0,0,0,"CTX_WD_NOT_FOUND",null," The terminal connection driver %1 was not found in the system path.",null,false],[0,0,0,"CTX_SHADOW_INVALID",null," The requested session cannot be controlled remotely.\n You cannot control your own session, a session that is trying to control your session, a session that has no user logged on, or other sessions from the console.",null,false],[0,0,0,"CTX_SHADOW_DISABLED",null," The requested session is not configured to allow remote control.",null,false],[0,0,0,"RDP_PROTOCOL_ERROR",null," The RDP protocol component %2 detected an error in the protocol stream and has disconnected the client.",null,false],[0,0,0,"CTX_CLIENT_LICENSE_NOT_SET",null," Your request to connect to this terminal server has been rejected.\n Your terminal server client license number has not been entered for this copy of the terminal client.\n Contact your system administrator for help in entering a valid, unique license number for this terminal server client. Click OK to continue.",null,false],[0,0,0,"CTX_CLIENT_LICENSE_IN_USE",null," Your request to connect to this terminal server has been rejected.\n Your terminal server client license number is currently being used by another user.\n Contact your system administrator to obtain a new copy of the terminal server client with a valid, unique license number. Click OK to continue.",null,false],[0,0,0,"CTX_SHADOW_ENDED_BY_MODE_CHANGE",null," The remote control of the console was terminated because the display mode was changed.\n Changing the display mode in a remote control session is not supported.",null,false],[0,0,0,"CTX_SHADOW_NOT_RUNNING",null," Remote control could not be terminated because the specified session is not currently being remotely controlled.",null,false],[0,0,0,"CTX_LOGON_DISABLED",null," Your interactive logon privilege has been disabled. Contact your system administrator.",null,false],[0,0,0,"CTX_SECURITY_LAYER_ERROR",null," The terminal server security layer detected an error in the protocol stream and has disconnected the client.",null,false],[0,0,0,"TS_INCOMPATIBLE_SESSIONS",null," The target session is incompatible with the current session.",null,false],[0,0,0,"MUI_FILE_NOT_FOUND",null," The resource loader failed to find an MUI file.",null,false],[0,0,0,"MUI_INVALID_FILE",null," The resource loader failed to load an MUI file because the file failed to pass validation.",null,false],[0,0,0,"MUI_INVALID_RC_CONFIG",null," The RC manifest is corrupted with garbage data, is an unsupported version, or is missing a required item.",null,false],[0,0,0,"MUI_INVALID_LOCALE_NAME",null," The RC manifest has an invalid culture name.",null,false],[0,0,0,"MUI_INVALID_ULTIMATEFALLBACK_NAME",null," The RC manifest has and invalid ultimate fallback name.",null,false],[0,0,0,"MUI_FILE_NOT_LOADED",null," The resource loader cache does not have a loaded MUI entry.",null,false],[0,0,0,"RESOURCE_ENUM_USER_STOP",null," The user stopped resource enumeration.",null,false],[0,0,0,"CLUSTER_INVALID_NODE",null," The cluster node is not valid.",null,false],[0,0,0,"CLUSTER_NODE_EXISTS",null," The cluster node already exists.",null,false],[0,0,0,"CLUSTER_JOIN_IN_PROGRESS",null," A node is in the process of joining the cluster.",null,false],[0,0,0,"CLUSTER_NODE_NOT_FOUND",null," The cluster node was not found.",null,false],[0,0,0,"CLUSTER_LOCAL_NODE_NOT_FOUND",null," The cluster local node information was not found.",null,false],[0,0,0,"CLUSTER_NETWORK_EXISTS",null," The cluster network already exists.",null,false],[0,0,0,"CLUSTER_NETWORK_NOT_FOUND",null," The cluster network was not found.",null,false],[0,0,0,"CLUSTER_NETINTERFACE_EXISTS",null," The cluster network interface already exists.",null,false],[0,0,0,"CLUSTER_NETINTERFACE_NOT_FOUND",null," The cluster network interface was not found.",null,false],[0,0,0,"CLUSTER_INVALID_REQUEST",null," The cluster request is not valid for this object.",null,false],[0,0,0,"CLUSTER_INVALID_NETWORK_PROVIDER",null," The cluster network provider is not valid.",null,false],[0,0,0,"CLUSTER_NODE_DOWN",null," The cluster node is down.",null,false],[0,0,0,"CLUSTER_NODE_UNREACHABLE",null," The cluster node is not reachable.",null,false],[0,0,0,"CLUSTER_NODE_NOT_MEMBER",null," The cluster node is not a member of the cluster.",null,false],[0,0,0,"CLUSTER_JOIN_NOT_IN_PROGRESS",null," A cluster join operation is not in progress.",null,false],[0,0,0,"CLUSTER_INVALID_NETWORK",null," The cluster network is not valid.",null,false],[0,0,0,"CLUSTER_NO_NET_ADAPTERS",null," No network adapters are available.",null,false],[0,0,0,"CLUSTER_NODE_UP",null," The cluster node is up.",null,false],[0,0,0,"CLUSTER_NODE_PAUSED",null," The cluster node is paused.",null,false],[0,0,0,"CLUSTER_NODE_NOT_PAUSED",null," The cluster node is not paused.",null,false],[0,0,0,"CLUSTER_NO_SECURITY_CONTEXT",null," No cluster security context is available.",null,false],[0,0,0,"CLUSTER_NETWORK_NOT_INTERNAL",null," The cluster network is not configured for internal cluster communication.",null,false],[0,0,0,"CLUSTER_POISONED",null," The cluster node has been poisoned.",null,false],[0,0,0,"ACPI_INVALID_OPCODE",null," An attempt was made to run an invalid AML opcode.",null,false],[0,0,0,"ACPI_STACK_OVERFLOW",null," The AML interpreter stack has overflowed.",null,false],[0,0,0,"ACPI_ASSERT_FAILED",null," An inconsistent state has occurred.",null,false],[0,0,0,"ACPI_INVALID_INDEX",null," An attempt was made to access an array outside its bounds.",null,false],[0,0,0,"ACPI_INVALID_ARGUMENT",null," A required argument was not specified.",null,false],[0,0,0,"ACPI_FATAL",null," A fatal error has occurred.",null,false],[0,0,0,"ACPI_INVALID_SUPERNAME",null," An invalid SuperName was specified.",null,false],[0,0,0,"ACPI_INVALID_ARGTYPE",null," An argument with an incorrect type was specified.",null,false],[0,0,0,"ACPI_INVALID_OBJTYPE",null," An object with an incorrect type was specified.",null,false],[0,0,0,"ACPI_INVALID_TARGETTYPE",null," A target with an incorrect type was specified.",null,false],[0,0,0,"ACPI_INCORRECT_ARGUMENT_COUNT",null," An incorrect number of arguments was specified.",null,false],[0,0,0,"ACPI_ADDRESS_NOT_MAPPED",null," An address failed to translate.",null,false],[0,0,0,"ACPI_INVALID_EVENTTYPE",null," An incorrect event type was specified.",null,false],[0,0,0,"ACPI_HANDLER_COLLISION",null," A handler for the target already exists.",null,false],[0,0,0,"ACPI_INVALID_DATA",null," Invalid data for the target was specified.",null,false],[0,0,0,"ACPI_INVALID_REGION",null," An invalid region for the target was specified.",null,false],[0,0,0,"ACPI_INVALID_ACCESS_SIZE",null," An attempt was made to access a field outside the defined range.",null,false],[0,0,0,"ACPI_ACQUIRE_GLOBAL_LOCK",null," The global system lock could not be acquired.",null,false],[0,0,0,"ACPI_ALREADY_INITIALIZED",null," An attempt was made to reinitialize the ACPI subsystem.",null,false],[0,0,0,"ACPI_NOT_INITIALIZED",null," The ACPI subsystem has not been initialized.",null,false],[0,0,0,"ACPI_INVALID_MUTEX_LEVEL",null," An incorrect mutex was specified.",null,false],[0,0,0,"ACPI_MUTEX_NOT_OWNED",null," The mutex is not currently owned.",null,false],[0,0,0,"ACPI_MUTEX_NOT_OWNER",null," An attempt was made to access the mutex by a process that was not the owner.",null,false],[0,0,0,"ACPI_RS_ACCESS",null," An error occurred during an access to region space.",null,false],[0,0,0,"ACPI_INVALID_TABLE",null," An attempt was made to use an incorrect table.",null,false],[0,0,0,"ACPI_REG_HANDLER_FAILED",null," The registration of an ACPI event failed.",null,false],[0,0,0,"ACPI_POWER_REQUEST_FAILED",null," An ACPI power object failed to transition state.",null,false],[0,0,0,"SXS_SECTION_NOT_FOUND",null," The requested section is not present in the activation context.",null,false],[0,0,0,"SXS_CANT_GEN_ACTCTX",null," Windows was unble to process the application binding information.\n Refer to the system event log for further information.",null,false],[0,0,0,"SXS_INVALID_ACTCTXDATA_FORMAT",null," The application binding data format is invalid.",null,false],[0,0,0,"SXS_ASSEMBLY_NOT_FOUND",null," The referenced assembly is not installed on the system.",null,false],[0,0,0,"SXS_MANIFEST_FORMAT_ERROR",null," The manifest file does not begin with the required tag and format information.",null,false],[0,0,0,"SXS_MANIFEST_PARSE_ERROR",null," The manifest file contains one or more syntax errors.",null,false],[0,0,0,"SXS_ACTIVATION_CONTEXT_DISABLED",null," The application attempted to activate a disabled activation context.",null,false],[0,0,0,"SXS_KEY_NOT_FOUND",null," The requested lookup key was not found in any active activation context.",null,false],[0,0,0,"SXS_VERSION_CONFLICT",null," A component version required by the application conflicts with another component version that is already active.",null,false],[0,0,0,"SXS_WRONG_SECTION_TYPE",null," The type requested activation context section does not match the query API used.",null,false],[0,0,0,"SXS_THREAD_QUERIES_DISABLED",null," Lack of system resources has required isolated activation to be disabled for the current thread of execution.",null,false],[0,0,0,"SXS_ASSEMBLY_MISSING",null," The referenced assembly could not be found.",null,false],[0,0,0,"SXS_PROCESS_DEFAULT_ALREADY_SET",null," An attempt to set the process default activation context failed because the process default activation context was already set.",null,false],[0,0,0,"SXS_EARLY_DEACTIVATION",null," The activation context being deactivated is not the most recently activated one.",null,false],[0,0,0,"SXS_INVALID_DEACTIVATION",null," The activation context being deactivated is not active for the current thread of execution.",null,false],[0,0,0,"SXS_MULTIPLE_DEACTIVATION",null," The activation context being deactivated has already been deactivated.",null,false],[0,0,0,"SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY",null," The activation context of the system default assembly could not be generated.",null,false],[0,0,0,"SXS_PROCESS_TERMINATION_REQUESTED",null," A component used by the isolation facility has requested that the process be terminated.",null,false],[0,0,0,"SXS_CORRUPT_ACTIVATION_STACK",null," The activation context activation stack for the running thread of execution is corrupt.",null,false],[0,0,0,"SXS_CORRUPTION",null," The application isolation metadata for this process or thread has become corrupt.",null,false],[0,0,0,"SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE",null," The value of an attribute in an identity is not within the legal range.",null,false],[0,0,0,"SXS_INVALID_IDENTITY_ATTRIBUTE_NAME",null," The name of an attribute in an identity is not within the legal range.",null,false],[0,0,0,"SXS_IDENTITY_DUPLICATE_ATTRIBUTE",null," An identity contains two definitions for the same attribute.",null,false],[0,0,0,"SXS_IDENTITY_PARSE_ERROR",null," The identity string is malformed.\n This might be due to a trailing comma, more than two unnamed attributes, a missing attribute name, or a missing attribute value.",null,false],[0,0,0,"SXS_COMPONENT_STORE_CORRUPT",null," The component store has become corrupted.",null,false],[0,0,0,"SXS_FILE_HASH_MISMATCH",null," A component's file does not match the verification information present in the component manifest.",null,false],[0,0,0,"SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT",null," The identities of the manifests are identical, but their contents are different.",null,false],[0,0,0,"SXS_IDENTITIES_DIFFERENT",null," The component identities are different.",null,false],[0,0,0,"SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT",null," The assembly is not a deployment.",null,false],[0,0,0,"SXS_FILE_NOT_PART_OF_ASSEMBLY",null," The file is not a part of the assembly.",null,false],[0,0,0,"ADVANCED_INSTALLER_FAILED",null," An advanced installer failed during setup or servicing.",null,false],[0,0,0,"XML_ENCODING_MISMATCH",null," The character encoding in the XML declaration did not match the encoding used in the document.",null,false],[0,0,0,"SXS_MANIFEST_TOO_BIG",null," The size of the manifest exceeds the maximum allowed.",null,false],[0,0,0,"SXS_SETTING_NOT_REGISTERED",null," The setting is not registered.",null,false],[0,0,0,"SXS_TRANSACTION_CLOSURE_INCOMPLETE",null," One or more required transaction members are not present.",null,false],[0,0,0,"SMI_PRIMITIVE_INSTALLER_FAILED",null," The SMI primitive installer failed during setup or servicing.",null,false],[0,0,0,"GENERIC_COMMAND_FAILED",null," A generic command executable returned a result that indicates failure.",null,false],[0,0,0,"SXS_FILE_HASH_MISSING",null," A component is missing file verification information in its manifest.",null,false],[0,0,0,"TRANSACTIONAL_CONFLICT",null," The function attempted to use a name that is reserved for use by another transaction.",null,false],[0,0,0,"INVALID_TRANSACTION",null," The transaction handle associated with this operation is invalid.",null,false],[0,0,0,"TRANSACTION_NOT_ACTIVE",null," The requested operation was made in the context of a transaction that is no longer active.",null,false],[0,0,0,"TM_INITIALIZATION_FAILED",null," The transaction manager was unable to be successfully initialized. Transacted operations are not supported.",null,false],[0,0,0,"RM_NOT_ACTIVE",null," Transaction support within the specified file system resource manager was not started or was shut down due to an error.",null,false],[0,0,0,"RM_METADATA_CORRUPT",null," The metadata of the resource manager has been corrupted. The resource manager will not function.",null,false],[0,0,0,"TRANSACTION_NOT_JOINED",null," The resource manager attempted to prepare a transaction that it has not successfully joined.",null,false],[0,0,0,"DIRECTORY_NOT_RM",null," The specified directory does not contain a file system resource manager.",null,false],[0,0,0,"TRANSACTIONS_UNSUPPORTED_REMOTE",null," The remote server or share does not support transacted file operations.",null,false],[0,0,0,"LOG_RESIZE_INVALID_SIZE",null," The requested log size for the file system resource manager is invalid.",null,false],[0,0,0,"REMOTE_FILE_VERSION_MISMATCH",null," The remote server sent mismatching version number or Fid for a file opened with transactions.",null,false],[0,0,0,"CRM_PROTOCOL_ALREADY_EXISTS",null," The resource manager tried to register a protocol that already exists.",null,false],[0,0,0,"TRANSACTION_PROPAGATION_FAILED",null," The attempt to propagate the transaction failed.",null,false],[0,0,0,"CRM_PROTOCOL_NOT_FOUND",null," The requested propagation protocol was not registered as a CRM.",null,false],[0,0,0,"TRANSACTION_SUPERIOR_EXISTS",null," The transaction object already has a superior enlistment, and the caller attempted an operation that would have created a new superior. Only a single superior enlistment is allowed.",null,false],[0,0,0,"TRANSACTION_REQUEST_NOT_VALID",null," The requested operation is not valid on the transaction object in its current state.",null,false],[0,0,0,"TRANSACTION_NOT_REQUESTED",null," The caller has called a response API, but the response is not expected because the transaction manager did not issue the corresponding request to the caller.",null,false],[0,0,0,"TRANSACTION_ALREADY_ABORTED",null," It is too late to perform the requested operation, because the transaction has already been aborted.",null,false],[0,0,0,"TRANSACTION_ALREADY_COMMITTED",null," It is too late to perform the requested operation, because the transaction has already been committed.",null,false],[0,0,0,"TRANSACTION_INVALID_MARSHALL_BUFFER",null," The buffer passed in to NtPushTransaction or NtPullTransaction is not in a valid format.",null,false],[0,0,0,"CURRENT_TRANSACTION_NOT_VALID",null," The current transaction context associated with the thread is not a valid handle to a transaction object.",null,false],[0,0,0,"LOG_GROWTH_FAILED",null," An attempt to create space in the transactional resource manager's log failed.\n The failure status has been recorded in the event log.",null,false],[0,0,0,"OBJECT_NO_LONGER_EXISTS",null," The object (file, stream, or link) that corresponds to the handle has been deleted by a transaction savepoint rollback.",null,false],[0,0,0,"STREAM_MINIVERSION_NOT_FOUND",null," The specified file miniversion was not found for this transacted file open.",null,false],[0,0,0,"STREAM_MINIVERSION_NOT_VALID",null," The specified file miniversion was found but has been invalidated.\n The most likely cause is a transaction savepoint rollback.",null,false],[0,0,0,"MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION",null," A miniversion can be opened only in the context of the transaction that created it.",null,false],[0,0,0,"CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT",null," It is not possible to open a miniversion with modify access.",null,false],[0,0,0,"CANT_CREATE_MORE_STREAM_MINIVERSIONS",null," It is not possible to create any more miniversions for this stream.",null,false],[0,0,0,"HANDLE_NO_LONGER_VALID",null," The handle has been invalidated by a transaction.\n The most likely cause is the presence of memory mapping on a file or an open handle when the transaction ended or rolled back to savepoint.",null,false],[0,0,0,"LOG_CORRUPTION_DETECTED",null," The log data is corrupt.",null,false],[0,0,0,"RM_DISCONNECTED",null," The transaction outcome is unavailable because the resource manager responsible for it is disconnected.",null,false],[0,0,0,"ENLISTMENT_NOT_SUPERIOR",null," The request was rejected because the enlistment in question is not a superior enlistment.",null,false],[0,0,0,"FILE_IDENTITY_NOT_PERSISTENT",null," The file cannot be opened in a transaction because its identity depends on the outcome of an unresolved transaction.",null,false],[0,0,0,"CANT_BREAK_TRANSACTIONAL_DEPENDENCY",null," The operation cannot be performed because another transaction is depending on this property not changing.",null,false],[0,0,0,"CANT_CROSS_RM_BOUNDARY",null," The operation would involve a single file with two transactional resource managers and is, therefore, not allowed.",null,false],[0,0,0,"TXF_DIR_NOT_EMPTY",null," The $Txf directory must be empty for this operation to succeed.",null,false],[0,0,0,"INDOUBT_TRANSACTIONS_EXIST",null," The operation would leave a transactional resource manager in an inconsistent state and is therefore not allowed.",null,false],[0,0,0,"TM_VOLATILE",null," The operation could not be completed because the transaction manager does not have a log.",null,false],[0,0,0,"ROLLBACK_TIMER_EXPIRED",null," A rollback could not be scheduled because a previously scheduled rollback has already executed or been queued for execution.",null,false],[0,0,0,"TXF_ATTRIBUTE_CORRUPT",null," The transactional metadata attribute on the file or directory %hs is corrupt and unreadable.",null,false],[0,0,0,"EFS_NOT_ALLOWED_IN_TRANSACTION",null," The encryption operation could not be completed because a transaction is active.",null,false],[0,0,0,"TRANSACTIONAL_OPEN_NOT_ALLOWED",null," This object is not allowed to be opened in a transaction.",null,false],[0,0,0,"TRANSACTED_MAPPING_UNSUPPORTED_REMOTE",null," Memory mapping (creating a mapped section) a remote file under a transaction is not supported.",null,false],[0,0,0,"TRANSACTION_REQUIRED_PROMOTION",null," Promotion was required to allow the resource manager to enlist, but the transaction was set to disallow it.",null,false],[0,0,0,"CANNOT_EXECUTE_FILE_IN_TRANSACTION",null," This file is open for modification in an unresolved transaction and can be opened for execute only by a transacted reader.",null,false],[0,0,0,"TRANSACTIONS_NOT_FROZEN",null," The request to thaw frozen transactions was ignored because transactions were not previously frozen.",null,false],[0,0,0,"TRANSACTION_FREEZE_IN_PROGRESS",null," Transactions cannot be frozen because a freeze is already in progress.",null,false],[0,0,0,"NOT_SNAPSHOT_VOLUME",null," The target volume is not a snapshot volume.\n This operation is valid only on a volume mounted as a snapshot.",null,false],[0,0,0,"NO_SAVEPOINT_WITH_OPEN_FILES",null," The savepoint operation failed because files are open on the transaction, which is not permitted.",null,false],[0,0,0,"SPARSE_NOT_ALLOWED_IN_TRANSACTION",null," The sparse operation could not be completed because a transaction is active on the file.",null,false],[0,0,0,"TM_IDENTITY_MISMATCH",null," The call to create a transaction manager object failed because the Tm Identity that is stored in the log file does not match the Tm Identity that was passed in as an argument.",null,false],[0,0,0,"FLOATED_SECTION",null," I/O was attempted on a section object that has been floated as a result of a transaction ending. There is no valid data.",null,false],[0,0,0,"CANNOT_ACCEPT_TRANSACTED_WORK",null," The transactional resource manager cannot currently accept transacted work due to a transient condition, such as low resources.",null,false],[0,0,0,"CANNOT_ABORT_TRANSACTIONS",null," The transactional resource manager had too many transactions outstanding that could not be aborted.\n The transactional resource manager has been shut down.",null,false],[0,0,0,"TRANSACTION_NOT_FOUND",null," The specified transaction was unable to be opened because it was not found.",null,false],[0,0,0,"RESOURCEMANAGER_NOT_FOUND",null," The specified resource manager was unable to be opened because it was not found.",null,false],[0,0,0,"ENLISTMENT_NOT_FOUND",null," The specified enlistment was unable to be opened because it was not found.",null,false],[0,0,0,"TRANSACTIONMANAGER_NOT_FOUND",null," The specified transaction manager was unable to be opened because it was not found.",null,false],[0,0,0,"TRANSACTIONMANAGER_NOT_ONLINE",null," The specified resource manager was unable to create an enlistment because its associated transaction manager is not online.",null,false],[0,0,0,"TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION",null," The specified transaction manager was unable to create the objects contained in its log file in the Ob namespace.\n Therefore, the transaction manager was unable to recover.",null,false],[0,0,0,"TRANSACTION_NOT_ROOT",null," The call to create a superior enlistment on this transaction object could not be completed because the transaction object specified for the enlistment is a subordinate branch of the transaction.\n Only the root of the transaction can be enlisted as a superior.",null,false],[0,0,0,"TRANSACTION_OBJECT_EXPIRED",null," Because the associated transaction manager or resource manager has been closed, the handle is no longer valid.",null,false],[0,0,0,"COMPRESSION_NOT_ALLOWED_IN_TRANSACTION",null," The compression operation could not be completed because a transaction is active on the file.",null,false],[0,0,0,"TRANSACTION_RESPONSE_NOT_ENLISTED",null," The specified operation could not be performed on this superior enlistment because the enlistment was not created with the corresponding completion response in the NotificationMask.",null,false],[0,0,0,"TRANSACTION_RECORD_TOO_LONG",null," The specified operation could not be performed because the record to be logged was too long.\n This can occur because either there are too many enlistments on this transaction or the combined RecoveryInformation being logged on behalf of those enlistments is too long.",null,false],[0,0,0,"NO_LINK_TRACKING_IN_TRANSACTION",null," The link-tracking operation could not be completed because a transaction is active.",null,false],[0,0,0,"OPERATION_NOT_SUPPORTED_IN_TRANSACTION",null," This operation cannot be performed in a transaction.",null,false],[0,0,0,"TRANSACTION_INTEGRITY_VIOLATED",null," The kernel transaction manager had to abort or forget the transaction because it blocked forward progress.",null,false],[0,0,0,"EXPIRED_HANDLE",null," The handle is no longer properly associated with its transaction.\n  It might have been opened in a transactional resource manager that was subsequently forced to restart.  Please close the handle and open a new one.",null,false],[0,0,0,"TRANSACTION_NOT_ENLISTED",null," The specified operation could not be performed because the resource manager is not enlisted in the transaction.",null,false],[0,0,0,"LOG_SECTOR_INVALID",null," The log service found an invalid log sector.",null,false],[0,0,0,"LOG_SECTOR_PARITY_INVALID",null," The log service encountered a log sector with invalid block parity.",null,false],[0,0,0,"LOG_SECTOR_REMAPPED",null," The log service encountered a remapped log sector.",null,false],[0,0,0,"LOG_BLOCK_INCOMPLETE",null," The log service encountered a partial or incomplete log block.",null,false],[0,0,0,"LOG_INVALID_RANGE",null," The log service encountered an attempt to access data outside the active log range.",null,false],[0,0,0,"LOG_BLOCKS_EXHAUSTED",null," The log service user-log marshaling buffers are exhausted.",null,false],[0,0,0,"LOG_READ_CONTEXT_INVALID",null," The log service encountered an attempt to read from a marshaling area with an invalid read context.",null,false],[0,0,0,"LOG_RESTART_INVALID",null," The log service encountered an invalid log restart area.",null,false],[0,0,0,"LOG_BLOCK_VERSION",null," The log service encountered an invalid log block version.",null,false],[0,0,0,"LOG_BLOCK_INVALID",null," The log service encountered an invalid log block.",null,false],[0,0,0,"LOG_READ_MODE_INVALID",null," The log service encountered an attempt to read the log with an invalid read mode.",null,false],[0,0,0,"LOG_METADATA_CORRUPT",null," The log service encountered a corrupted metadata file.",null,false],[0,0,0,"LOG_METADATA_INVALID",null," The log service encountered a metadata file that could not be created by the log file system.",null,false],[0,0,0,"LOG_METADATA_INCONSISTENT",null," The log service encountered a metadata file with inconsistent data.",null,false],[0,0,0,"LOG_RESERVATION_INVALID",null," The log service encountered an attempt to erroneously allocate or dispose reservation space.",null,false],[0,0,0,"LOG_CANT_DELETE",null," The log service cannot delete the log file or the file system container.",null,false],[0,0,0,"LOG_CONTAINER_LIMIT_EXCEEDED",null," The log service has reached the maximum allowable containers allocated to a log file.",null,false],[0,0,0,"LOG_START_OF_LOG",null," The log service has attempted to read or write backward past the start of the log.",null,false],[0,0,0,"LOG_POLICY_ALREADY_INSTALLED",null," The log policy could not be installed because a policy of the same type is already present.",null,false],[0,0,0,"LOG_POLICY_NOT_INSTALLED",null," The log policy in question was not installed at the time of the request.",null,false],[0,0,0,"LOG_POLICY_INVALID",null," The installed set of policies on the log is invalid.",null,false],[0,0,0,"LOG_POLICY_CONFLICT",null," A policy on the log in question prevented the operation from completing.",null,false],[0,0,0,"LOG_PINNED_ARCHIVE_TAIL",null," The log space cannot be reclaimed because the log is pinned by the archive tail.",null,false],[0,0,0,"LOG_RECORD_NONEXISTENT",null," The log record is not a record in the log file.",null,false],[0,0,0,"LOG_RECORDS_RESERVED_INVALID",null," The number of reserved log records or the adjustment of the number of reserved log records is invalid.",null,false],[0,0,0,"LOG_SPACE_RESERVED_INVALID",null," The reserved log space or the adjustment of the log space is invalid.",null,false],[0,0,0,"LOG_TAIL_INVALID",null," A new or existing archive tail or the base of the active log is invalid.",null,false],[0,0,0,"LOG_FULL",null," The log space is exhausted.",null,false],[0,0,0,"LOG_MULTIPLEXED",null," The log is multiplexed; no direct writes to the physical log are allowed.",null,false],[0,0,0,"LOG_DEDICATED",null," The operation failed because the log is dedicated.",null,false],[0,0,0,"LOG_ARCHIVE_NOT_IN_PROGRESS",null," The operation requires an archive context.",null,false],[0,0,0,"LOG_ARCHIVE_IN_PROGRESS",null," Log archival is in progress.",null,false],[0,0,0,"LOG_EPHEMERAL",null," The operation requires a nonephemeral log, but the log is ephemeral.",null,false],[0,0,0,"LOG_NOT_ENOUGH_CONTAINERS",null," The log must have at least two containers before it can be read from or written to.",null,false],[0,0,0,"LOG_CLIENT_ALREADY_REGISTERED",null," A log client has already registered on the stream.",null,false],[0,0,0,"LOG_CLIENT_NOT_REGISTERED",null," A log client has not been registered on the stream.",null,false],[0,0,0,"LOG_FULL_HANDLER_IN_PROGRESS",null," A request has already been made to handle the log full condition.",null,false],[0,0,0,"LOG_CONTAINER_READ_FAILED",null," The log service encountered an error when attempting to read from a log container.",null,false],[0,0,0,"LOG_CONTAINER_WRITE_FAILED",null," The log service encountered an error when attempting to write to a log container.",null,false],[0,0,0,"LOG_CONTAINER_OPEN_FAILED",null," The log service encountered an error when attempting to open a log container.",null,false],[0,0,0,"LOG_CONTAINER_STATE_INVALID",null," The log service encountered an invalid container state when attempting a requested action.",null,false],[0,0,0,"LOG_STATE_INVALID",null," The log service is not in the correct state to perform a requested action.",null,false],[0,0,0,"LOG_PINNED",null," The log space cannot be reclaimed because the log is pinned.",null,false],[0,0,0,"LOG_METADATA_FLUSH_FAILED",null," The log metadata flush failed.",null,false],[0,0,0,"LOG_INCONSISTENT_SECURITY",null," Security on the log and its containers is inconsistent.",null,false],[0,0,0,"LOG_APPENDED_FLUSH_FAILED",null," Records were appended to the log or reservation changes were made, but the log could not be flushed.",null,false],[0,0,0,"LOG_PINNED_RESERVATION",null," The log is pinned due to reservation consuming most of the log space.\n Free some reserved records to make space available.",null,false],[0,0,0,"VIDEO_HUNG_DISPLAY_DRIVER_THREAD",null," {Display Driver Stopped Responding} The %hs display driver has stopped working normally.\n Save your work and reboot the system to restore full display functionality.\n The next time you reboot the computer, a dialog box will allow you to upload data about this failure to Microsoft.",null,false],[0,0,0,"FLT_NO_HANDLER_DEFINED",null," A handler was not defined by the filter for this operation.",null,false],[0,0,0,"FLT_CONTEXT_ALREADY_DEFINED",null," A context is already defined for this object.",null,false],[0,0,0,"FLT_INVALID_ASYNCHRONOUS_REQUEST",null," Asynchronous requests are not valid for this operation.",null,false],[0,0,0,"FLT_DISALLOW_FAST_IO",null," This is an internal error code used by the filter manager to determine if a fast I/O operation should be forced down the input/output request packet (IRP) path. Minifilters should never return this value.",null,false],[0,0,0,"FLT_INVALID_NAME_REQUEST",null," An invalid name request was made.\n The name requested cannot be retrieved at this time.",null,false],[0,0,0,"FLT_NOT_SAFE_TO_POST_OPERATION",null," Posting this operation to a worker thread for further processing is not safe at this time because it could lead to a system deadlock.",null,false],[0,0,0,"FLT_NOT_INITIALIZED",null," The Filter Manager was not initialized when a filter tried to register.\n Make sure that the Filter Manager is loaded as a driver.",null,false],[0,0,0,"FLT_FILTER_NOT_READY",null," The filter is not ready for attachment to volumes because it has not finished initializing (FltStartFiltering has not been called).",null,false],[0,0,0,"FLT_POST_OPERATION_CLEANUP",null," The filter must clean up any operation-specific context at this time because it is being removed from the system before the operation is completed by the lower drivers.",null,false],[0,0,0,"FLT_INTERNAL_ERROR",null," The Filter Manager had an internal error from which it cannot recover; therefore, the operation has failed.\n This is usually the result of a filter returning an invalid value from a pre-operation callback.",null,false],[0,0,0,"FLT_DELETING_OBJECT",null," The object specified for this action is in the process of being deleted; therefore, the action requested cannot be completed at this time.",null,false],[0,0,0,"FLT_MUST_BE_NONPAGED_POOL",null," A nonpaged pool must be used for this type of context.",null,false],[0,0,0,"FLT_DUPLICATE_ENTRY",null," A duplicate handler definition has been provided for an operation.",null,false],[0,0,0,"FLT_CBDQ_DISABLED",null," The callback data queue has been disabled.",null,false],[0,0,0,"FLT_DO_NOT_ATTACH",null," Do not attach the filter to the volume at this time.",null,false],[0,0,0,"FLT_DO_NOT_DETACH",null," Do not detach the filter from the volume at this time.",null,false],[0,0,0,"FLT_INSTANCE_ALTITUDE_COLLISION",null," An instance already exists at this altitude on the volume specified.",null,false],[0,0,0,"FLT_INSTANCE_NAME_COLLISION",null," An instance already exists with this name on the volume specified.",null,false],[0,0,0,"FLT_FILTER_NOT_FOUND",null," The system could not find the filter specified.",null,false],[0,0,0,"FLT_VOLUME_NOT_FOUND",null," The system could not find the volume specified.",null,false],[0,0,0,"FLT_INSTANCE_NOT_FOUND",null," The system could not find the instance specified.",null,false],[0,0,0,"FLT_CONTEXT_ALLOCATION_NOT_FOUND",null," No registered context allocation definition was found for the given request.",null,false],[0,0,0,"FLT_INVALID_CONTEXT_REGISTRATION",null," An invalid parameter was specified during context registration.",null,false],[0,0,0,"FLT_NAME_CACHE_MISS",null," The name requested was not found in the Filter Manager name cache and could not be retrieved from the file system.",null,false],[0,0,0,"FLT_NO_DEVICE_OBJECT",null," The requested device object does not exist for the given volume.",null,false],[0,0,0,"FLT_VOLUME_ALREADY_MOUNTED",null," The specified volume is already mounted.",null,false],[0,0,0,"FLT_ALREADY_ENLISTED",null," The specified transaction context is already enlisted in a transaction.",null,false],[0,0,0,"FLT_CONTEXT_ALREADY_LINKED",null," The specified context is already attached to another object.",null,false],[0,0,0,"FLT_NO_WAITER_FOR_REPLY",null," No waiter is present for the filter's reply to this message.",null,false],[0,0,0,"MONITOR_NO_DESCRIPTOR",null," A monitor descriptor could not be obtained.",null,false],[0,0,0,"MONITOR_UNKNOWN_DESCRIPTOR_FORMAT",null," This release does not support the format of the obtained monitor descriptor.",null,false],[0,0,0,"MONITOR_INVALID_DESCRIPTOR_CHECKSUM",null," The checksum of the obtained monitor descriptor is invalid.",null,false],[0,0,0,"MONITOR_INVALID_STANDARD_TIMING_BLOCK",null," The monitor descriptor contains an invalid standard timing block.",null,false],[0,0,0,"MONITOR_WMI_DATABLOCK_REGISTRATION_FAILED",null," WMI data-block registration failed for one of the MSMonitorClass WMI subclasses.",null,false],[0,0,0,"MONITOR_INVALID_SERIAL_NUMBER_MONDSC_BLOCK",null," The provided monitor descriptor block is either corrupted or does not contain the monitor's detailed serial number.",null,false],[0,0,0,"MONITOR_INVALID_USER_FRIENDLY_MONDSC_BLOCK",null," The provided monitor descriptor block is either corrupted or does not contain the monitor's user-friendly name.",null,false],[0,0,0,"MONITOR_NO_MORE_DESCRIPTOR_DATA",null," There is no monitor descriptor data at the specified (offset or size) region.",null,false],[0,0,0,"MONITOR_INVALID_DETAILED_TIMING_BLOCK",null," The monitor descriptor contains an invalid detailed timing block.",null,false],[0,0,0,"MONITOR_INVALID_MANUFACTURE_DATE",null," Monitor descriptor contains invalid manufacture date.",null,false],[0,0,0,"GRAPHICS_NOT_EXCLUSIVE_MODE_OWNER",null," Exclusive mode ownership is needed to create an unmanaged primary allocation.",null,false],[0,0,0,"GRAPHICS_INSUFFICIENT_DMA_BUFFER",null," The driver needs more DMA buffer space to complete the requested operation.",null,false],[0,0,0,"GRAPHICS_INVALID_DISPLAY_ADAPTER",null," The specified display adapter handle is invalid.",null,false],[0,0,0,"GRAPHICS_ADAPTER_WAS_RESET",null," The specified display adapter and all of its state have been reset.",null,false],[0,0,0,"GRAPHICS_INVALID_DRIVER_MODEL",null," The driver stack does not match the expected driver model.",null,false],[0,0,0,"GRAPHICS_PRESENT_MODE_CHANGED",null," Present happened but ended up into the changed desktop mode.",null,false],[0,0,0,"GRAPHICS_PRESENT_OCCLUDED",null," Nothing to present due to desktop occlusion.",null,false],[0,0,0,"GRAPHICS_PRESENT_DENIED",null," Not able to present due to denial of desktop access.",null,false],[0,0,0,"GRAPHICS_CANNOTCOLORCONVERT",null," Not able to present with color conversion.",null,false],[0,0,0,"GRAPHICS_PRESENT_REDIRECTION_DISABLED",null," Present redirection is disabled (desktop windowing management subsystem is off).",null,false],[0,0,0,"GRAPHICS_PRESENT_UNOCCLUDED",null," Previous exclusive VidPn source owner has released its ownership",null,false],[0,0,0,"GRAPHICS_NO_VIDEO_MEMORY",null," Not enough video memory is available to complete the operation.",null,false],[0,0,0,"GRAPHICS_CANT_LOCK_MEMORY",null," Could not probe and lock the underlying memory of an allocation.",null,false],[0,0,0,"GRAPHICS_ALLOCATION_BUSY",null," The allocation is currently busy.",null,false],[0,0,0,"GRAPHICS_TOO_MANY_REFERENCES",null," An object being referenced has already reached the maximum reference count and cannot be referenced further.",null,false],[0,0,0,"GRAPHICS_TRY_AGAIN_LATER",null," A problem could not be solved due to an existing condition. Try again later.",null,false],[0,0,0,"GRAPHICS_TRY_AGAIN_NOW",null," A problem could not be solved due to an existing condition. Try again now.",null,false],[0,0,0,"GRAPHICS_ALLOCATION_INVALID",null," The allocation is invalid.",null,false],[0,0,0,"GRAPHICS_UNSWIZZLING_APERTURE_UNAVAILABLE",null," No more unswizzling apertures are currently available.",null,false],[0,0,0,"GRAPHICS_UNSWIZZLING_APERTURE_UNSUPPORTED",null," The current allocation cannot be unswizzled by an aperture.",null,false],[0,0,0,"GRAPHICS_CANT_EVICT_PINNED_ALLOCATION",null," The request failed because a pinned allocation cannot be evicted.",null,false],[0,0,0,"GRAPHICS_INVALID_ALLOCATION_USAGE",null," The allocation cannot be used from its current segment location for the specified operation.",null,false],[0,0,0,"GRAPHICS_CANT_RENDER_LOCKED_ALLOCATION",null," A locked allocation cannot be used in the current command buffer.",null,false],[0,0,0,"GRAPHICS_ALLOCATION_CLOSED",null," The allocation being referenced has been closed permanently.",null,false],[0,0,0,"GRAPHICS_INVALID_ALLOCATION_INSTANCE",null," An invalid allocation instance is being referenced.",null,false],[0,0,0,"GRAPHICS_INVALID_ALLOCATION_HANDLE",null," An invalid allocation handle is being referenced.",null,false],[0,0,0,"GRAPHICS_WRONG_ALLOCATION_DEVICE",null," The allocation being referenced does not belong to the current device.",null,false],[0,0,0,"GRAPHICS_ALLOCATION_CONTENT_LOST",null," The specified allocation lost its content.",null,false],[0,0,0,"GRAPHICS_GPU_EXCEPTION_ON_DEVICE",null," A GPU exception was detected on the given device. The device cannot be scheduled.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN_TOPOLOGY",null," The specified VidPN topology is invalid.",null,false],[0,0,0,"GRAPHICS_VIDPN_TOPOLOGY_NOT_SUPPORTED",null," The specified VidPN topology is valid but is not supported by this model of the display adapter.",null,false],[0,0,0,"GRAPHICS_VIDPN_TOPOLOGY_CURRENTLY_NOT_SUPPORTED",null," The specified VidPN topology is valid but is not currently supported by the display adapter due to allocation of its resources.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN",null," The specified VidPN handle is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE",null," The specified video present source is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDEO_PRESENT_TARGET",null," The specified video present target is invalid.",null,false],[0,0,0,"GRAPHICS_VIDPN_MODALITY_NOT_SUPPORTED",null," The specified VidPN modality is not supported (for example, at least two of the pinned modes are not co-functional).",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN_SOURCEMODESET",null," The specified VidPN source mode set is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN_TARGETMODESET",null," The specified VidPN target mode set is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_FREQUENCY",null," The specified video signal frequency is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_ACTIVE_REGION",null," The specified video signal active region is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_TOTAL_REGION",null," The specified video signal total region is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDEO_PRESENT_SOURCE_MODE",null," The specified video present source mode is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDEO_PRESENT_TARGET_MODE",null," The specified video present target mode is invalid.",null,false],[0,0,0,"GRAPHICS_PINNED_MODE_MUST_REMAIN_IN_SET",null," The pinned mode must remain in the set on the VidPN's co-functional modality enumeration.",null,false],[0,0,0,"GRAPHICS_PATH_ALREADY_IN_TOPOLOGY",null," The specified video present path is already in the VidPN's topology.",null,false],[0,0,0,"GRAPHICS_MODE_ALREADY_IN_MODESET",null," The specified mode is already in the mode set.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDEOPRESENTSOURCESET",null," The specified video present source set is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDEOPRESENTTARGETSET",null," The specified video present target set is invalid.",null,false],[0,0,0,"GRAPHICS_SOURCE_ALREADY_IN_SET",null," The specified video present source is already in the video present source set.",null,false],[0,0,0,"GRAPHICS_TARGET_ALREADY_IN_SET",null," The specified video present target is already in the video present target set.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN_PRESENT_PATH",null," The specified VidPN present path is invalid.",null,false],[0,0,0,"GRAPHICS_NO_RECOMMENDED_VIDPN_TOPOLOGY",null," The miniport has no recommendation for augmenting the specified VidPN's topology.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITOR_FREQUENCYRANGESET",null," The specified monitor frequency range set is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE",null," The specified monitor frequency range is invalid.",null,false],[0,0,0,"GRAPHICS_FREQUENCYRANGE_NOT_IN_SET",null," The specified frequency range is not in the specified monitor frequency range set.",null,false],[0,0,0,"GRAPHICS_FREQUENCYRANGE_ALREADY_IN_SET",null," The specified frequency range is already in the specified monitor frequency range set.",null,false],[0,0,0,"GRAPHICS_STALE_MODESET",null," The specified mode set is stale. Reacquire the new mode set.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITOR_SOURCEMODESET",null," The specified monitor source mode set is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITOR_SOURCE_MODE",null," The specified monitor source mode is invalid.",null,false],[0,0,0,"GRAPHICS_NO_RECOMMENDED_FUNCTIONAL_VIDPN",null," The miniport does not have a recommendation regarding the request to provide a functional VidPN given the current display adapter configuration.",null,false],[0,0,0,"GRAPHICS_MODE_ID_MUST_BE_UNIQUE",null," The ID of the specified mode is being used by another mode in the set.",null,false],[0,0,0,"GRAPHICS_EMPTY_ADAPTER_MONITOR_MODE_SUPPORT_INTERSECTION",null," The system failed to determine a mode that is supported by both the display adapter and the monitor connected to it.",null,false],[0,0,0,"GRAPHICS_VIDEO_PRESENT_TARGETS_LESS_THAN_SOURCES",null," The number of video present targets must be greater than or equal to the number of video present sources.",null,false],[0,0,0,"GRAPHICS_PATH_NOT_IN_TOPOLOGY",null," The specified present path is not in the VidPN's topology.",null,false],[0,0,0,"GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_SOURCE",null," The display adapter must have at least one video present source.",null,false],[0,0,0,"GRAPHICS_ADAPTER_MUST_HAVE_AT_LEAST_ONE_TARGET",null," The display adapter must have at least one video present target.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITORDESCRIPTORSET",null," The specified monitor descriptor set is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITORDESCRIPTOR",null," The specified monitor descriptor is invalid.",null,false],[0,0,0,"GRAPHICS_MONITORDESCRIPTOR_NOT_IN_SET",null," The specified descriptor is not in the specified monitor descriptor set.",null,false],[0,0,0,"GRAPHICS_MONITORDESCRIPTOR_ALREADY_IN_SET",null," The specified descriptor is already in the specified monitor descriptor set.",null,false],[0,0,0,"GRAPHICS_MONITORDESCRIPTOR_ID_MUST_BE_UNIQUE",null," The ID of the specified monitor descriptor is being used by another descriptor in the set.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN_TARGET_SUBSET_TYPE",null," The specified video present target subset type is invalid.",null,false],[0,0,0,"GRAPHICS_RESOURCES_NOT_RELATED",null," Two or more of the specified resources are not related to each other, as defined by the interface semantics.",null,false],[0,0,0,"GRAPHICS_SOURCE_ID_MUST_BE_UNIQUE",null," The ID of the specified video present source is being used by another source in the set.",null,false],[0,0,0,"GRAPHICS_TARGET_ID_MUST_BE_UNIQUE",null," The ID of the specified video present target is being used by another target in the set.",null,false],[0,0,0,"GRAPHICS_NO_AVAILABLE_VIDPN_TARGET",null," The specified VidPN source cannot be used because there is no available VidPN target to connect it to.",null,false],[0,0,0,"GRAPHICS_MONITOR_COULD_NOT_BE_ASSOCIATED_WITH_ADAPTER",null," The newly arrived monitor could not be associated with a display adapter.",null,false],[0,0,0,"GRAPHICS_NO_VIDPNMGR",null," The particular display adapter does not have an associated VidPN manager.",null,false],[0,0,0,"GRAPHICS_NO_ACTIVE_VIDPN",null," The VidPN manager of the particular display adapter does not have an active VidPN.",null,false],[0,0,0,"GRAPHICS_STALE_VIDPN_TOPOLOGY",null," The specified VidPN topology is stale; obtain the new topology.",null,false],[0,0,0,"GRAPHICS_MONITOR_NOT_CONNECTED",null," No monitor is connected on the specified video present target.",null,false],[0,0,0,"GRAPHICS_SOURCE_NOT_IN_TOPOLOGY",null," The specified source is not part of the specified VidPN's topology.",null,false],[0,0,0,"GRAPHICS_INVALID_PRIMARYSURFACE_SIZE",null," The specified primary surface size is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_VISIBLEREGION_SIZE",null," The specified visible region size is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_STRIDE",null," The specified stride is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_PIXELFORMAT",null," The specified pixel format is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_COLORBASIS",null," The specified color basis is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_PIXELVALUEACCESSMODE",null," The specified pixel value access mode is invalid.",null,false],[0,0,0,"GRAPHICS_TARGET_NOT_IN_TOPOLOGY",null," The specified target is not part of the specified VidPN's topology.",null,false],[0,0,0,"GRAPHICS_NO_DISPLAY_MODE_MANAGEMENT_SUPPORT",null," Failed to acquire the display mode management interface.",null,false],[0,0,0,"GRAPHICS_VIDPN_SOURCE_IN_USE",null," The specified VidPN source is already owned by a DMM client and cannot be used until that client releases it.",null,false],[0,0,0,"GRAPHICS_CANT_ACCESS_ACTIVE_VIDPN",null," The specified VidPN is active and cannot be accessed.",null,false],[0,0,0,"GRAPHICS_INVALID_PATH_IMPORTANCE_ORDINAL",null," The specified VidPN's present path importance ordinal is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_PATH_CONTENT_GEOMETRY_TRANSFORMATION",null," The specified VidPN's present path content geometry transformation is invalid.",null,false],[0,0,0,"GRAPHICS_PATH_CONTENT_GEOMETRY_TRANSFORMATION_NOT_SUPPORTED",null," The specified content geometry transformation is not supported on the respective VidPN present path.",null,false],[0,0,0,"GRAPHICS_INVALID_GAMMA_RAMP",null," The specified gamma ramp is invalid.",null,false],[0,0,0,"GRAPHICS_GAMMA_RAMP_NOT_SUPPORTED",null," The specified gamma ramp is not supported on the respective VidPN present path.",null,false],[0,0,0,"GRAPHICS_MULTISAMPLING_NOT_SUPPORTED",null," Multisampling is not supported on the respective VidPN present path.",null,false],[0,0,0,"GRAPHICS_MODE_NOT_IN_MODESET",null," The specified mode is not in the specified mode set.",null,false],[0,0,0,"GRAPHICS_INVALID_VIDPN_TOPOLOGY_RECOMMENDATION_REASON",null," The specified VidPN topology recommendation reason is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_PATH_CONTENT_TYPE",null," The specified VidPN present path content type is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_COPYPROTECTION_TYPE",null," The specified VidPN present path copy protection type is invalid.",null,false],[0,0,0,"GRAPHICS_UNASSIGNED_MODESET_ALREADY_EXISTS",null," Only one unassigned mode set can exist at any one time for a particular VidPN source or target.",null,false],[0,0,0,"GRAPHICS_INVALID_SCANLINE_ORDERING",null," The specified scan line ordering type is invalid.",null,false],[0,0,0,"GRAPHICS_TOPOLOGY_CHANGES_NOT_ALLOWED",null," The topology changes are not allowed for the specified VidPN.",null,false],[0,0,0,"GRAPHICS_NO_AVAILABLE_IMPORTANCE_ORDINALS",null," All available importance ordinals are being used in the specified topology.",null,false],[0,0,0,"GRAPHICS_INCOMPATIBLE_PRIVATE_FORMAT",null," The specified primary surface has a different private-format attribute than the current primary surface.",null,false],[0,0,0,"GRAPHICS_INVALID_MODE_PRUNING_ALGORITHM",null," The specified mode-pruning algorithm is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITOR_CAPABILITY_ORIGIN",null," The specified monitor-capability origin is invalid.",null,false],[0,0,0,"GRAPHICS_INVALID_MONITOR_FREQUENCYRANGE_CONSTRAINT",null," The specified monitor-frequency range constraint is invalid.",null,false],[0,0,0,"GRAPHICS_MAX_NUM_PATHS_REACHED",null," The maximum supported number of present paths has been reached.",null,false],[0,0,0,"GRAPHICS_CANCEL_VIDPN_TOPOLOGY_AUGMENTATION",null," The miniport requested that augmentation be canceled for the specified source of the specified VidPN's topology.",null,false],[0,0,0,"GRAPHICS_INVALID_CLIENT_TYPE",null," The specified client type was not recognized.",null,false],[0,0,0,"GRAPHICS_CLIENTVIDPN_NOT_SET",null," The client VidPN is not set on this adapter (for example, no user mode-initiated mode changes have taken place on this adapter).",null,false],[0,0,0,"GRAPHICS_SPECIFIED_CHILD_ALREADY_CONNECTED",null," The specified display adapter child device already has an external device connected to it.",null,false],[0,0,0,"GRAPHICS_CHILD_DESCRIPTOR_NOT_SUPPORTED",null," The display adapter child device does not support reporting a descriptor.",null,false],[0,0,0,"GRAPHICS_NOT_A_LINKED_ADAPTER",null," The display adapter is not linked to any other adapters.",null,false],[0,0,0,"GRAPHICS_LEADLINK_NOT_ENUMERATED",null," The lead adapter in a linked configuration was not enumerated yet.",null,false],[0,0,0,"GRAPHICS_CHAINLINKS_NOT_ENUMERATED",null," Some chain adapters in a linked configuration have not yet been enumerated.",null,false],[0,0,0,"GRAPHICS_ADAPTER_CHAIN_NOT_READY",null," The chain of linked adapters is not ready to start because of an unknown failure.",null,false],[0,0,0,"GRAPHICS_CHAINLINKS_NOT_STARTED",null," An attempt was made to start a lead link display adapter when the chain links had not yet started.",null,false],[0,0,0,"GRAPHICS_CHAINLINKS_NOT_POWERED_ON",null," An attempt was made to turn on a lead link display adapter when the chain links were turned off.",null,false],[0,0,0,"GRAPHICS_INCONSISTENT_DEVICE_LINK_STATE",null," The adapter link was found in an inconsistent state.\n Not all adapters are in an expected PNP/power state.",null,false],[0,0,0,"GRAPHICS_NOT_POST_DEVICE_DRIVER",null," The driver trying to start is not the same as the driver for the posted display adapter.",null,false],[0,0,0,"GRAPHICS_ADAPTER_ACCESS_NOT_EXCLUDED",null," An operation is being attempted that requires the display adapter to be in a quiescent state.",null,false],[0,0,0,"GRAPHICS_OPM_NOT_SUPPORTED",null," The driver does not support OPM.",null,false],[0,0,0,"GRAPHICS_COPP_NOT_SUPPORTED",null," The driver does not support COPP.",null,false],[0,0,0,"GRAPHICS_UAB_NOT_SUPPORTED",null," The driver does not support UAB.",null,false],[0,0,0,"GRAPHICS_OPM_INVALID_ENCRYPTED_PARAMETERS",null," The specified encrypted parameters are invalid.",null,false],[0,0,0,"GRAPHICS_OPM_PARAMETER_ARRAY_TOO_SMALL",null," An array passed to a function cannot hold all of the data that the function wants to put in it.",null,false],[0,0,0,"GRAPHICS_OPM_NO_PROTECTED_OUTPUTS_EXIST",null," The GDI display device passed to this function does not have any active protected outputs.",null,false],[0,0,0,"GRAPHICS_PVP_NO_DISPLAY_DEVICE_CORRESPONDS_TO_NAME",null," The PVP cannot find an actual GDI display device that corresponds to the passed-in GDI display device name.",null,false],[0,0,0,"GRAPHICS_PVP_DISPLAY_DEVICE_NOT_ATTACHED_TO_DESKTOP",null," This function failed because the GDI display device passed to it was not attached to the Windows desktop.",null,false],[0,0,0,"GRAPHICS_PVP_MIRRORING_DEVICES_NOT_SUPPORTED",null," The PVP does not support mirroring display devices because they do not have any protected outputs.",null,false],[0,0,0,"GRAPHICS_OPM_INVALID_POINTER",null," The function failed because an invalid pointer parameter was passed to it.\n A pointer parameter is invalid if it is null, is not correctly aligned, or it points to an invalid address or a kernel mode address.",null,false],[0,0,0,"GRAPHICS_OPM_INTERNAL_ERROR",null," An internal error caused an operation to fail.",null,false],[0,0,0,"GRAPHICS_OPM_INVALID_HANDLE",null," The function failed because the caller passed in an invalid OPM user-mode handle.",null,false],[0,0,0,"GRAPHICS_PVP_NO_MONITORS_CORRESPOND_TO_DISPLAY_DEVICE",null," This function failed because the GDI device passed to it did not have any monitors associated with it.",null,false],[0,0,0,"GRAPHICS_PVP_INVALID_CERTIFICATE_LENGTH",null," A certificate could not be returned because the certificate buffer passed to the function was too small.",null,false],[0,0,0,"GRAPHICS_OPM_SPANNING_MODE_ENABLED",null," DxgkDdiOpmCreateProtectedOutput() could not create a protected output because the video present yarget is in spanning mode.",null,false],[0,0,0,"GRAPHICS_OPM_THEATER_MODE_ENABLED",null," DxgkDdiOpmCreateProtectedOutput() could not create a protected output because the video present target is in theater mode.",null,false],[0,0,0,"GRAPHICS_PVP_HFS_FAILED",null," The function call failed because the display adapter's hardware functionality scan (HFS) failed to validate the graphics hardware.",null,false],[0,0,0,"GRAPHICS_OPM_INVALID_SRM",null," The HDCP SRM passed to this function did not comply with section 5 of the HDCP 1.1 specification.",null,false],[0,0,0,"GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_HDCP",null," The protected output cannot enable the HDCP system because it does not support it.",null,false],[0,0,0,"GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_ACP",null," The protected output cannot enable analog copy protection because it does not support it.",null,false],[0,0,0,"GRAPHICS_OPM_OUTPUT_DOES_NOT_SUPPORT_CGMSA",null," The protected output cannot enable the CGMS-A protection technology because it does not support it.",null,false],[0,0,0,"GRAPHICS_OPM_HDCP_SRM_NEVER_SET",null," DxgkDdiOPMGetInformation() cannot return the version of the SRM being used because the application never successfully passed an SRM to the protected output.",null,false],[0,0,0,"GRAPHICS_OPM_RESOLUTION_TOO_HIGH",null," DxgkDdiOPMConfigureProtectedOutput() cannot enable the specified output protection technology because the output's screen resolution is too high.",null,false],[0,0,0,"GRAPHICS_OPM_ALL_HDCP_HARDWARE_ALREADY_IN_USE",null," DxgkDdiOPMConfigureProtectedOutput() cannot enable HDCP because other physical outputs are using the display adapter's HDCP hardware.",null,false],[0,0,0,"GRAPHICS_OPM_PROTECTED_OUTPUT_NO_LONGER_EXISTS",null," The operating system asynchronously destroyed this OPM-protected output because the operating system state changed.\n This error typically occurs because the monitor PDO associated with this protected output was removed or stopped, the protected output's session became a nonconsole session, or the protected output's desktop became inactive.",null,false],[0,0,0,"GRAPHICS_OPM_SESSION_TYPE_CHANGE_IN_PROGRESS",null," OPM functions cannot be called when a session is changing its type.\n Three types of sessions currently exist: console, disconnected, and remote (RDP or ICA).",null,false],[0,0,0,"GRAPHICS_OPM_PROTECTED_OUTPUT_DOES_NOT_HAVE_COPP_SEMANTICS",null," The DxgkDdiOPMGetCOPPCompatibleInformation, DxgkDdiOPMGetInformation, or DxgkDdiOPMConfigureProtectedOutput function failed.\n This error is returned only if a protected output has OPM semantics.\n DxgkDdiOPMGetCOPPCompatibleInformation always returns this error if a protected output has OPM semantics.\n DxgkDdiOPMGetInformation returns this error code if the caller requested COPP-specific information.\n DxgkDdiOPMConfigureProtectedOutput returns this error when the caller tries to use a COPP-specific command.",null,false],[0,0,0,"GRAPHICS_OPM_INVALID_INFORMATION_REQUEST",null," The DxgkDdiOPMGetInformation and DxgkDdiOPMGetCOPPCompatibleInformation functions return this error code if the passed-in sequence number is not the expected sequence number or the passed-in OMAC value is invalid.",null,false],[0,0,0,"GRAPHICS_OPM_DRIVER_INTERNAL_ERROR",null," The function failed because an unexpected error occurred inside a display driver.",null,false],[0,0,0,"GRAPHICS_OPM_PROTECTED_OUTPUT_DOES_NOT_HAVE_OPM_SEMANTICS",null," The DxgkDdiOPMGetCOPPCompatibleInformation, DxgkDdiOPMGetInformation, or DxgkDdiOPMConfigureProtectedOutput function failed.\n This error is returned only if a protected output has COPP semantics.\n DxgkDdiOPMGetCOPPCompatibleInformation returns this error code if the caller requested OPM-specific information.\n DxgkDdiOPMGetInformation always returns this error if a protected output has COPP semantics.\n DxgkDdiOPMConfigureProtectedOutput returns this error when the caller tries to use an OPM-specific command.",null,false],[0,0,0,"GRAPHICS_OPM_SIGNALING_NOT_SUPPORTED",null," The DxgkDdiOPMGetCOPPCompatibleInformation and DxgkDdiOPMConfigureProtectedOutput functions return this error if the display driver does not support the DXGKMDT_OPM_GET_ACP_AND_CGMSA_SIGNALING and DXGKMDT_OPM_SET_ACP_AND_CGMSA_SIGNALING GUIDs.",null,false],[0,0,0,"GRAPHICS_OPM_INVALID_CONFIGURATION_REQUEST",null," The DxgkDdiOPMConfigureProtectedOutput function returns this error code if the passed-in sequence number is not the expected sequence number or the passed-in OMAC value is invalid.",null,false],[0,0,0,"GRAPHICS_I2C_NOT_SUPPORTED",null," The monitor connected to the specified video output does not have an I2C bus.",null,false],[0,0,0,"GRAPHICS_I2C_DEVICE_DOES_NOT_EXIST",null," No device on the I2C bus has the specified address.",null,false],[0,0,0,"GRAPHICS_I2C_ERROR_TRANSMITTING_DATA",null," An error occurred while transmitting data to the device on the I2C bus.",null,false],[0,0,0,"GRAPHICS_I2C_ERROR_RECEIVING_DATA",null," An error occurred while receiving data from the device on the I2C bus.",null,false],[0,0,0,"GRAPHICS_DDCCI_VCP_NOT_SUPPORTED",null," The monitor does not support the specified VCP code.",null,false],[0,0,0,"GRAPHICS_DDCCI_INVALID_DATA",null," The data received from the monitor is invalid.",null,false],[0,0,0,"GRAPHICS_DDCCI_MONITOR_RETURNED_INVALID_TIMING_STATUS_BYTE",null," A function call failed because a monitor returned an invalid timing status byte when the operating system used the DDC/CI get timing report and timing message command to get a timing report from a monitor.",null,false],[0,0,0,"GRAPHICS_DDCCI_INVALID_CAPABILITIES_STRING",null," A monitor returned a DDC/CI capabilities string that did not comply with the ACCESS.bus 3.0, DDC/CI 1.1, or MCCS 2 Revision 1 specification.",null,false],[0,0,0,"GRAPHICS_MCA_INTERNAL_ERROR",null," An internal error caused an operation to fail.",null,false],[0,0,0,"GRAPHICS_DDCCI_INVALID_MESSAGE_COMMAND",null," An operation failed because a DDC/CI message had an invalid value in its command field.",null,false],[0,0,0,"GRAPHICS_DDCCI_INVALID_MESSAGE_LENGTH",null," This error occurred because a DDC/CI message had an invalid value in its length field.",null,false],[0,0,0,"GRAPHICS_DDCCI_INVALID_MESSAGE_CHECKSUM",null," This error occurred because the value in a DDC/CI message's checksum field did not match the message's computed checksum value.\n This error implies that the data was corrupted while it was being transmitted from a monitor to a computer.",null,false],[0,0,0,"GRAPHICS_INVALID_PHYSICAL_MONITOR_HANDLE",null," This function failed because an invalid monitor handle was passed to it.",null,false],[0,0,0,"GRAPHICS_MONITOR_NO_LONGER_EXISTS",null," The operating system asynchronously destroyed the monitor that corresponds to this handle because the operating system's state changed.\n This error typically occurs because the monitor PDO associated with this handle was removed or stopped, or a display mode change occurred.\n A display mode change occurs when Windows sends a WM_DISPLAYCHANGE message to applications.",null,false],[0,0,0,"GRAPHICS_ONLY_CONSOLE_SESSION_SUPPORTED",null," This function can be used only if a program is running in the local console session.\n It cannot be used if a program is running on a remote desktop session or on a terminal server session.",null,false],[0,0,0,"GRAPHICS_NO_DISPLAY_DEVICE_CORRESPONDS_TO_NAME",null," This function cannot find an actual GDI display device that corresponds to the specified GDI display device name.",null,false],[0,0,0,"GRAPHICS_DISPLAY_DEVICE_NOT_ATTACHED_TO_DESKTOP",null," The function failed because the specified GDI display device was not attached to the Windows desktop.",null,false],[0,0,0,"GRAPHICS_MIRRORING_DEVICES_NOT_SUPPORTED",null," This function does not support GDI mirroring display devices because GDI mirroring display devices do not have any physical monitors associated with them.",null,false],[0,0,0,"GRAPHICS_INVALID_POINTER",null," The function failed because an invalid pointer parameter was passed to it.\n A pointer parameter is invalid if it is null, is not correctly aligned, or points to an invalid address or to a kernel mode address.",null,false],[0,0,0,"GRAPHICS_NO_MONITORS_CORRESPOND_TO_DISPLAY_DEVICE",null," This function failed because the GDI device passed to it did not have a monitor associated with it.",null,false],[0,0,0,"GRAPHICS_PARAMETER_ARRAY_TOO_SMALL",null," An array passed to the function cannot hold all of the data that the function must copy into the array.",null,false],[0,0,0,"GRAPHICS_INTERNAL_ERROR",null," An internal error caused an operation to fail.",null,false],[0,0,0,"GRAPHICS_SESSION_TYPE_CHANGE_IN_PROGRESS",null," The function failed because the current session is changing its type.\n This function cannot be called when the current session is changing its type.\n Three types of sessions currently exist: console, disconnected, and remote (RDP or ICA).",null,false],[0,0,0,"FVE_LOCKED_VOLUME",null," The volume must be unlocked before it can be used.",null,false],[0,0,0,"FVE_NOT_ENCRYPTED",null," The volume is fully decrypted and no key is available.",null,false],[0,0,0,"FVE_BAD_INFORMATION",null," The control block for the encrypted volume is not valid.",null,false],[0,0,0,"FVE_TOO_SMALL",null," Not enough free space remains on the volume to allow encryption.",null,false],[0,0,0,"FVE_FAILED_WRONG_FS",null," The partition cannot be encrypted because the file system is not supported.",null,false],[0,0,0,"FVE_FAILED_BAD_FS",null," The file system is inconsistent. Run the Check Disk utility.",null,false],[0,0,0,"FVE_FS_NOT_EXTENDED",null," The file system does not extend to the end of the volume.",null,false],[0,0,0,"FVE_FS_MOUNTED",null," This operation cannot be performed while a file system is mounted on the volume.",null,false],[0,0,0,"FVE_NO_LICENSE",null," BitLocker Drive Encryption is not included with this version of Windows.",null,false],[0,0,0,"FVE_ACTION_NOT_ALLOWED",null," The requested action was denied by the FVE control engine.",null,false],[0,0,0,"FVE_BAD_DATA",null," The data supplied is malformed.",null,false],[0,0,0,"FVE_VOLUME_NOT_BOUND",null," The volume is not bound to the system.",null,false],[0,0,0,"FVE_NOT_DATA_VOLUME",null," The volume specified is not a data volume.",null,false],[0,0,0,"FVE_CONV_READ_ERROR",null," A read operation failed while converting the volume.",null,false],[0,0,0,"FVE_CONV_WRITE_ERROR",null," A write operation failed while converting the volume.",null,false],[0,0,0,"FVE_OVERLAPPED_UPDATE",null," The control block for the encrypted volume was updated by another thread. Try again.",null,false],[0,0,0,"FVE_FAILED_SECTOR_SIZE",null," The volume encryption algorithm cannot be used on this sector size.",null,false],[0,0,0,"FVE_FAILED_AUTHENTICATION",null," BitLocker recovery authentication failed.",null,false],[0,0,0,"FVE_NOT_OS_VOLUME",null," The volume specified is not the boot operating system volume.",null,false],[0,0,0,"FVE_KEYFILE_NOT_FOUND",null," The BitLocker startup key or recovery password could not be read from external media.",null,false],[0,0,0,"FVE_KEYFILE_INVALID",null," The BitLocker startup key or recovery password file is corrupt or invalid.",null,false],[0,0,0,"FVE_KEYFILE_NO_VMK",null," The BitLocker encryption key could not be obtained from the startup key or the recovery password.",null,false],[0,0,0,"FVE_TPM_DISABLED",null," The TPM is disabled.",null,false],[0,0,0,"FVE_TPM_SRK_AUTH_NOT_ZERO",null," The authorization data for the SRK of the TPM is not zero.",null,false],[0,0,0,"FVE_TPM_INVALID_PCR",null," The system boot information changed or the TPM locked out access to BitLocker encryption keys until the computer is restarted.",null,false],[0,0,0,"FVE_TPM_NO_VMK",null," The BitLocker encryption key could not be obtained from the TPM.",null,false],[0,0,0,"FVE_PIN_INVALID",null," The BitLocker encryption key could not be obtained from the TPM and PIN.",null,false],[0,0,0,"FVE_AUTH_INVALID_APPLICATION",null," A boot application hash does not match the hash computed when BitLocker was turned on.",null,false],[0,0,0,"FVE_AUTH_INVALID_CONFIG",null," The Boot Configuration Data (BCD) settings are not supported or have changed because BitLocker was enabled.",null,false],[0,0,0,"FVE_DEBUGGER_ENABLED",null," Boot debugging is enabled. Run Windows Boot Configuration Data Store Editor (bcdedit.exe) to turn it off.",null,false],[0,0,0,"FVE_DRY_RUN_FAILED",null," The BitLocker encryption key could not be obtained.",null,false],[0,0,0,"FVE_BAD_METADATA_POINTER",null," The metadata disk region pointer is incorrect.",null,false],[0,0,0,"FVE_OLD_METADATA_COPY",null," The backup copy of the metadata is out of date.",null,false],[0,0,0,"FVE_REBOOT_REQUIRED",null," No action was taken because a system restart is required.",null,false],[0,0,0,"FVE_RAW_ACCESS",null," No action was taken because BitLocker Drive Encryption is in RAW access mode.",null,false],[0,0,0,"FVE_RAW_BLOCKED",null," BitLocker Drive Encryption cannot enter RAW access mode for this volume.",null,false],[0,0,0,"FVE_NO_FEATURE_LICENSE",null," This feature of BitLocker Drive Encryption is not included with this version of Windows.",null,false],[0,0,0,"FVE_POLICY_USER_DISABLE_RDV_NOT_ALLOWED",null," Group policy does not permit turning off BitLocker Drive Encryption on roaming data volumes.",null,false],[0,0,0,"FVE_CONV_RECOVERY_FAILED",null," Bitlocker Drive Encryption failed to recover from aborted conversion.\n This could be due to either all conversion logs being corrupted or the media being write-protected.",null,false],[0,0,0,"FVE_VIRTUALIZED_SPACE_TOO_BIG",null," The requested virtualization size is too big.",null,false],[0,0,0,"FVE_VOLUME_TOO_SMALL",null," The drive is too small to be protected using BitLocker Drive Encryption.",null,false],[0,0,0,"FWP_CALLOUT_NOT_FOUND",null," The callout does not exist.",null,false],[0,0,0,"FWP_CONDITION_NOT_FOUND",null," The filter condition does not exist.",null,false],[0,0,0,"FWP_FILTER_NOT_FOUND",null," The filter does not exist.",null,false],[0,0,0,"FWP_LAYER_NOT_FOUND",null," The layer does not exist.",null,false],[0,0,0,"FWP_PROVIDER_NOT_FOUND",null," The provider does not exist.",null,false],[0,0,0,"FWP_PROVIDER_CONTEXT_NOT_FOUND",null," The provider context does not exist.",null,false],[0,0,0,"FWP_SUBLAYER_NOT_FOUND",null," The sublayer does not exist.",null,false],[0,0,0,"FWP_NOT_FOUND",null," The object does not exist.",null,false],[0,0,0,"FWP_ALREADY_EXISTS",null," An object with that GUID or LUID already exists.",null,false],[0,0,0,"FWP_IN_USE",null," The object is referenced by other objects and cannot be deleted.",null,false],[0,0,0,"FWP_DYNAMIC_SESSION_IN_PROGRESS",null," The call is not allowed from within a dynamic session.",null,false],[0,0,0,"FWP_WRONG_SESSION",null," The call was made from the wrong session and cannot be completed.",null,false],[0,0,0,"FWP_NO_TXN_IN_PROGRESS",null," The call must be made from within an explicit transaction.",null,false],[0,0,0,"FWP_TXN_IN_PROGRESS",null," The call is not allowed from within an explicit transaction.",null,false],[0,0,0,"FWP_TXN_ABORTED",null," The explicit transaction has been forcibly canceled.",null,false],[0,0,0,"FWP_SESSION_ABORTED",null," The session has been canceled.",null,false],[0,0,0,"FWP_INCOMPATIBLE_TXN",null," The call is not allowed from within a read-only transaction.",null,false],[0,0,0,"FWP_TIMEOUT",null," The call timed out while waiting to acquire the transaction lock.",null,false],[0,0,0,"FWP_NET_EVENTS_DISABLED",null," The collection of network diagnostic events is disabled.",null,false],[0,0,0,"FWP_INCOMPATIBLE_LAYER",null," The operation is not supported by the specified layer.",null,false],[0,0,0,"FWP_KM_CLIENTS_ONLY",null," The call is allowed for kernel-mode callers only.",null,false],[0,0,0,"FWP_LIFETIME_MISMATCH",null," The call tried to associate two objects with incompatible lifetimes.",null,false],[0,0,0,"FWP_BUILTIN_OBJECT",null," The object is built-in and cannot be deleted.",null,false],[0,0,0,"FWP_TOO_MANY_CALLOUTS",null," The maximum number of callouts has been reached.",null,false],[0,0,0,"FWP_NOTIFICATION_DROPPED",null," A notification could not be delivered because a message queue has reached maximum capacity.",null,false],[0,0,0,"FWP_TRAFFIC_MISMATCH",null," The traffic parameters do not match those for the security association context.",null,false],[0,0,0,"FWP_INCOMPATIBLE_SA_STATE",null," The call is not allowed for the current security association state.",null,false],[0,0,0,"FWP_NULL_POINTER",null," A required pointer is null.",null,false],[0,0,0,"FWP_INVALID_ENUMERATOR",null," An enumerator is not valid.",null,false],[0,0,0,"FWP_INVALID_FLAGS",null," The flags field contains an invalid value.",null,false],[0,0,0,"FWP_INVALID_NET_MASK",null," A network mask is not valid.",null,false],[0,0,0,"FWP_INVALID_RANGE",null," An FWP_RANGE is not valid.",null,false],[0,0,0,"FWP_INVALID_INTERVAL",null," The time interval is not valid.",null,false],[0,0,0,"FWP_ZERO_LENGTH_ARRAY",null," An array that must contain at least one element has a zero length.",null,false],[0,0,0,"FWP_NULL_DISPLAY_NAME",null," The displayData.name field cannot be null.",null,false],[0,0,0,"FWP_INVALID_ACTION_TYPE",null," The action type is not one of the allowed action types for a filter.",null,false],[0,0,0,"FWP_INVALID_WEIGHT",null," The filter weight is not valid.",null,false],[0,0,0,"FWP_MATCH_TYPE_MISMATCH",null," A filter condition contains a match type that is not compatible with the operands.",null,false],[0,0,0,"FWP_TYPE_MISMATCH",null," An FWP_VALUE or FWPM_CONDITION_VALUE is of the wrong type.",null,false],[0,0,0,"FWP_OUT_OF_BOUNDS",null," An integer value is outside the allowed range.",null,false],[0,0,0,"FWP_RESERVED",null," A reserved field is nonzero.",null,false],[0,0,0,"FWP_DUPLICATE_CONDITION",null," A filter cannot contain multiple conditions operating on a single field.",null,false],[0,0,0,"FWP_DUPLICATE_KEYMOD",null," A policy cannot contain the same keying module more than once.",null,false],[0,0,0,"FWP_ACTION_INCOMPATIBLE_WITH_LAYER",null," The action type is not compatible with the layer.",null,false],[0,0,0,"FWP_ACTION_INCOMPATIBLE_WITH_SUBLAYER",null," The action type is not compatible with the sublayer.",null,false],[0,0,0,"FWP_CONTEXT_INCOMPATIBLE_WITH_LAYER",null," The raw context or the provider context is not compatible with the layer.",null,false],[0,0,0,"FWP_CONTEXT_INCOMPATIBLE_WITH_CALLOUT",null," The raw context or the provider context is not compatible with the callout.",null,false],[0,0,0,"FWP_INCOMPATIBLE_AUTH_METHOD",null," The authentication method is not compatible with the policy type.",null,false],[0,0,0,"FWP_INCOMPATIBLE_DH_GROUP",null," The Diffie-Hellman group is not compatible with the policy type.",null,false],[0,0,0,"FWP_EM_NOT_SUPPORTED",null," An IKE policy cannot contain an Extended Mode policy.",null,false],[0,0,0,"FWP_NEVER_MATCH",null," The enumeration template or subscription will never match any objects.",null,false],[0,0,0,"FWP_PROVIDER_CONTEXT_MISMATCH",null," The provider context is of the wrong type.",null,false],[0,0,0,"FWP_INVALID_PARAMETER",null," The parameter is incorrect.",null,false],[0,0,0,"FWP_TOO_MANY_SUBLAYERS",null," The maximum number of sublayers has been reached.",null,false],[0,0,0,"FWP_CALLOUT_NOTIFICATION_FAILED",null," The notification function for a callout returned an error.",null,false],[0,0,0,"FWP_INCOMPATIBLE_AUTH_CONFIG",null," The IPsec authentication configuration is not compatible with the authentication type.",null,false],[0,0,0,"FWP_INCOMPATIBLE_CIPHER_CONFIG",null," The IPsec cipher configuration is not compatible with the cipher type.",null,false],[0,0,0,"FWP_DUPLICATE_AUTH_METHOD",null," A policy cannot contain the same auth method more than once.",null,false],[0,0,0,"FWP_TCPIP_NOT_READY",null," The TCP/IP stack is not ready.",null,false],[0,0,0,"FWP_INJECT_HANDLE_CLOSING",null," The injection handle is being closed by another thread.",null,false],[0,0,0,"FWP_INJECT_HANDLE_STALE",null," The injection handle is stale.",null,false],[0,0,0,"FWP_CANNOT_PEND",null," The classify cannot be pended.",null,false],[0,0,0,"NDIS_CLOSING",null," The binding to the network interface is being closed.",null,false],[0,0,0,"NDIS_BAD_VERSION",null," An invalid version was specified.",null,false],[0,0,0,"NDIS_BAD_CHARACTERISTICS",null," An invalid characteristics table was used.",null,false],[0,0,0,"NDIS_ADAPTER_NOT_FOUND",null," Failed to find the network interface or the network interface is not ready.",null,false],[0,0,0,"NDIS_OPEN_FAILED",null," Failed to open the network interface.",null,false],[0,0,0,"NDIS_DEVICE_FAILED",null," The network interface has encountered an internal unrecoverable failure.",null,false],[0,0,0,"NDIS_MULTICAST_FULL",null," The multicast list on the network interface is full.",null,false],[0,0,0,"NDIS_MULTICAST_EXISTS",null," An attempt was made to add a duplicate multicast address to the list.",null,false],[0,0,0,"NDIS_MULTICAST_NOT_FOUND",null," At attempt was made to remove a multicast address that was never added.",null,false],[0,0,0,"NDIS_REQUEST_ABORTED",null," The network interface aborted the request.",null,false],[0,0,0,"NDIS_RESET_IN_PROGRESS",null," The network interface cannot process the request because it is being reset.",null,false],[0,0,0,"NDIS_INVALID_PACKET",null," An attempt was made to send an invalid packet on a network interface.",null,false],[0,0,0,"NDIS_INVALID_DEVICE_REQUEST",null," The specified request is not a valid operation for the target device.",null,false],[0,0,0,"NDIS_ADAPTER_NOT_READY",null," The network interface is not ready to complete this operation.",null,false],[0,0,0,"NDIS_INVALID_LENGTH",null," The length of the buffer submitted for this operation is not valid.",null,false],[0,0,0,"NDIS_INVALID_DATA",null," The data used for this operation is not valid.",null,false],[0,0,0,"NDIS_BUFFER_TOO_SHORT",null," The length of the submitted buffer for this operation is too small.",null,false],[0,0,0,"NDIS_INVALID_OID",null," The network interface does not support this object identifier.",null,false],[0,0,0,"NDIS_ADAPTER_REMOVED",null," The network interface has been removed.",null,false],[0,0,0,"NDIS_UNSUPPORTED_MEDIA",null," The network interface does not support this media type.",null,false],[0,0,0,"NDIS_GROUP_ADDRESS_IN_USE",null," An attempt was made to remove a token ring group address that is in use by other components.",null,false],[0,0,0,"NDIS_FILE_NOT_FOUND",null," An attempt was made to map a file that cannot be found.",null,false],[0,0,0,"NDIS_ERROR_READING_FILE",null," An error occurred while NDIS tried to map the file.",null,false],[0,0,0,"NDIS_ALREADY_MAPPED",null," An attempt was made to map a file that is already mapped.",null,false],[0,0,0,"NDIS_RESOURCE_CONFLICT",null," An attempt to allocate a hardware resource failed because the resource is used by another component.",null,false],[0,0,0,"NDIS_MEDIA_DISCONNECTED",null," The I/O operation failed because the network media is disconnected or the wireless access point is out of range.",null,false],[0,0,0,"NDIS_INVALID_ADDRESS",null," The network address used in the request is invalid.",null,false],[0,0,0,"NDIS_PAUSED",null," The offload operation on the network interface has been paused.",null,false],[0,0,0,"NDIS_INTERFACE_NOT_FOUND",null," The network interface was not found.",null,false],[0,0,0,"NDIS_UNSUPPORTED_REVISION",null," The revision number specified in the structure is not supported.",null,false],[0,0,0,"NDIS_INVALID_PORT",null," The specified port does not exist on this network interface.",null,false],[0,0,0,"NDIS_INVALID_PORT_STATE",null," The current state of the specified port on this network interface does not support the requested operation.",null,false],[0,0,0,"NDIS_LOW_POWER_STATE",null," The miniport adapter is in a lower power state.",null,false],[0,0,0,"NDIS_NOT_SUPPORTED",null," The network interface does not support this request.",null,false],[0,0,0,"NDIS_OFFLOAD_POLICY",null," The TCP connection is not offloadable because of a local policy setting.",null,false],[0,0,0,"NDIS_OFFLOAD_CONNECTION_REJECTED",null," The TCP connection is not offloadable by the Chimney offload target.",null,false],[0,0,0,"NDIS_OFFLOAD_PATH_REJECTED",null," The IP Path object is not in an offloadable state.",null,false],[0,0,0,"NDIS_DOT11_AUTO_CONFIG_ENABLED",null," The wireless LAN interface is in auto-configuration mode and does not support the requested parameter change operation.",null,false],[0,0,0,"NDIS_DOT11_MEDIA_IN_USE",null," The wireless LAN interface is busy and cannot perform the requested operation.",null,false],[0,0,0,"NDIS_DOT11_POWER_STATE_INVALID",null," The wireless LAN interface is power down and does not support the requested operation.",null,false],[0,0,0,"NDIS_PM_WOL_PATTERN_LIST_FULL",null," The list of wake on LAN patterns is full.",null,false],[0,0,0,"NDIS_PM_PROTOCOL_OFFLOAD_LIST_FULL",null," The list of low power protocol offloads is full.",null,false],[0,0,0,"IPSEC_BAD_SPI",null," The SPI in the packet does not match a valid IPsec SA.",null,false],[0,0,0,"IPSEC_SA_LIFETIME_EXPIRED",null," The packet was received on an IPsec SA whose lifetime has expired.",null,false],[0,0,0,"IPSEC_WRONG_SA",null," The packet was received on an IPsec SA that does not match the packet characteristics.",null,false],[0,0,0,"IPSEC_REPLAY_CHECK_FAILED",null," The packet sequence number replay check failed.",null,false],[0,0,0,"IPSEC_INVALID_PACKET",null," The IPsec header and/or trailer in the packet is invalid.",null,false],[0,0,0,"IPSEC_INTEGRITY_CHECK_FAILED",null," The IPsec integrity check failed.",null,false],[0,0,0,"IPSEC_CLEAR_TEXT_DROP",null," IPsec dropped a clear text packet.",null,false],[0,0,0,"IPSEC_AUTH_FIREWALL_DROP",null," IPsec dropped an incoming ESP packet in authenticated firewall mode.  This drop is benign.",null,false],[0,0,0,"IPSEC_THROTTLE_DROP",null," IPsec dropped a packet due to DOS throttle.",null,false],[0,0,0,"IPSEC_DOSP_BLOCK",null," IPsec Dos Protection matched an explicit block rule.",null,false],[0,0,0,"IPSEC_DOSP_RECEIVED_MULTICAST",null," IPsec Dos Protection received an IPsec specific multicast packet which is not allowed.",null,false],[0,0,0,"IPSEC_DOSP_INVALID_PACKET",null," IPsec Dos Protection received an incorrectly formatted packet.",null,false],[0,0,0,"IPSEC_DOSP_STATE_LOOKUP_FAILED",null," IPsec Dos Protection failed to lookup state.",null,false],[0,0,0,"IPSEC_DOSP_MAX_ENTRIES",null," IPsec Dos Protection failed to create state because there are already maximum number of entries allowed by policy.",null,false],[0,0,0,"IPSEC_DOSP_KEYMOD_NOT_ALLOWED",null," IPsec Dos Protection received an IPsec negotiation packet for a keying module which is not allowed by policy.",null,false],[0,0,0,"IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES",null," IPsec Dos Protection failed to create per internal IP ratelimit queue because there is already maximum number of queues allowed by policy.",null,false],[0,0,0,"VOLMGR_MIRROR_NOT_SUPPORTED",null," The system does not support mirrored volumes.",null,false],[0,0,0,"VOLMGR_RAID5_NOT_SUPPORTED",null," The system does not support RAID-5 volumes.",null,false],[0,0,0,"VIRTDISK_PROVIDER_NOT_FOUND",null," A virtual disk support provider for the specified file was not found.",null,false],[0,0,0,"VIRTDISK_NOT_VIRTUAL_DISK",null," The specified disk is not a virtual disk.",null,false],[0,0,0,"VHD_PARENT_VHD_ACCESS_DENIED",null," The chain of virtual hard disks is inaccessible.\n The process has not been granted access rights to the parent virtual hard disk for the differencing disk.",null,false],[0,0,0,"VHD_CHILD_PARENT_SIZE_MISMATCH",null," The chain of virtual hard disks is corrupted.\n There is a mismatch in the virtual sizes of the parent virtual hard disk and differencing disk.",null,false],[0,0,0,"VHD_DIFFERENCING_CHAIN_CYCLE_DETECTED",null," The chain of virtual hard disks is corrupted.\n A differencing disk is indicated in its own parent chain.",null,false],[0,0,0,"VHD_DIFFERENCING_CHAIN_ERROR_IN_PARENT",null," The chain of virtual hard disks is inaccessible.\n There was an error opening a virtual hard disk further up the chain.",null,false],[401,2598,0,null,null,null,null,false],[0,0,0,"windows/lang.zig",null,"",[],false],[416,0,0,null,null,null,null,false],[416,1,0,null,null,null,null,false],[416,2,0,null,null,null,null,false],[416,3,0,null,null,null,null,false],[416,4,0,null,null,null,null,false],[416,5,0,null,null,null,null,false],[416,6,0,null,null,null,null,false],[416,7,0,null,null,null,null,false],[416,8,0,null,null,null,null,false],[416,9,0,null,null,null,null,false],[416,10,0,null,null,null,null,false],[416,11,0,null,null,null,null,false],[416,12,0,null,null,null,null,false],[416,13,0,null,null,null,null,false],[416,14,0,null,null,null,null,false],[416,15,0,null,null,null,null,false],[416,16,0,null,null,null,null,false],[416,17,0,null,null,null,null,false],[416,18,0,null,null,null,null,false],[416,19,0,null,null,null,null,false],[416,20,0,null,null,null,null,false],[416,21,0,null,null,null,null,false],[416,22,0,null,null,null,null,false],[416,23,0,null,null,null,null,false],[416,24,0,null,null,null,null,false],[416,25,0,null,null,null,null,false],[416,26,0,null,null,null,null,false],[416,27,0,null,null,null,null,false],[416,28,0,null,null,null,null,false],[416,29,0,null,null,null,null,false],[416,30,0,null,null,null,null,false],[416,31,0,null,null,null,null,false],[416,32,0,null,null,null,null,false],[416,33,0,null,null,null,null,false],[416,34,0,null,null,null,null,false],[416,35,0,null,null,null,null,false],[416,36,0,null,null,null,null,false],[416,37,0,null,null,null,null,false],[416,38,0,null,null,null,null,false],[416,39,0,null,null,null,null,false],[416,40,0,null,null,null,null,false],[416,41,0,null,null,null,null,false],[416,42,0,null,null,null,null,false],[416,43,0,null,null,null,null,false],[416,44,0,null,null,null,null,false],[416,45,0,null,null,null,null,false],[416,46,0,null,null,null,null,false],[416,47,0,null,null,null,null,false],[416,48,0,null,null,null,null,false],[416,49,0,null,null,null,null,false],[416,50,0,null,null,null,null,false],[416,51,0,null,null,null,null,false],[416,52,0,null,null,null,null,false],[416,53,0,null,null,null,null,false],[416,54,0,null,null,null,null,false],[416,55,0,null,null,null,null,false],[416,56,0,null,null,null,null,false],[416,57,0,null,null,null,null,false],[416,58,0,null,null,null,null,false],[416,59,0,null,null,null,null,false],[416,60,0,null,null,null,null,false],[416,61,0,null,null,null,null,false],[416,62,0,null,null,null,null,false],[416,63,0,null,null,null,null,false],[416,64,0,null,null,null,null,false],[416,65,0,null,null,null,null,false],[416,66,0,null,null,null,null,false],[416,67,0,null,null,null,null,false],[416,68,0,null,null,null,null,false],[416,69,0,null,null,null,null,false],[416,70,0,null,null,null,null,false],[416,71,0,null,null,null,null,false],[416,72,0,null,null,null,null,false],[416,73,0,null,null,null,null,false],[416,74,0,null,null,null,null,false],[416,75,0,null,null,null,null,false],[416,76,0,null,null,null,null,false],[416,77,0,null,null,null,null,false],[416,78,0,null,null,null,null,false],[416,79,0,null,null,null,null,false],[416,80,0,null,null,null,null,false],[416,81,0,null,null,null,null,false],[416,82,0,null,null,null,null,false],[416,83,0,null,null,null,null,false],[416,84,0,null,null,null,null,false],[416,85,0,null,null,null,null,false],[416,86,0,null,null,null,null,false],[416,87,0,null,null,null,null,false],[416,88,0,null,null,null,null,false],[416,89,0,null,null,null,null,false],[416,90,0,null,null,null,null,false],[416,91,0,null,null,null,null,false],[416,92,0,null,null,null,null,false],[416,93,0,null,null,null,null,false],[416,94,0,null,null,null,null,false],[416,95,0,null,null,null,null,false],[416,96,0,null,null,null,null,false],[416,97,0,null,null,null,null,false],[416,98,0,null,null,null,null,false],[416,99,0,null,null,null,null,false],[416,100,0,null,null,null,null,false],[416,101,0,null,null,null,null,false],[416,102,0,null,null,null,null,false],[416,103,0,null,null,null,null,false],[416,104,0,null,null,null,null,false],[416,105,0,null,null,null,null,false],[416,106,0,null,null,null,null,false],[416,107,0,null,null,null,null,false],[416,108,0,null,null,null,null,false],[416,109,0,null,null,null,null,false],[416,110,0,null,null,null,null,false],[416,111,0,null,null,null,null,false],[416,112,0,null,null,null,null,false],[416,113,0,null,null,null,null,false],[416,114,0,null,null,null,null,false],[416,115,0,null,null,null,null,false],[416,116,0,null,null,null,null,false],[416,117,0,null,null,null,null,false],[416,118,0,null,null,null,null,false],[416,119,0,null,null,null,null,false],[416,120,0,null,null,null,null,false],[416,121,0,null,null,null,null,false],[416,122,0,null,null,null,null,false],[416,123,0,null,null,null,null,false],[416,124,0,null,null,null,null,false],[416,125,0,null,null,null,null,false],[416,126,0,null,null,null,null,false],[416,127,0,null,null,null,null,false],[416,128,0,null,null,null,null,false],[416,129,0,null,null,null,null,false],[416,130,0,null,null,null,null,false],[416,131,0,null,null,null,null,false],[416,132,0,null,null,null,null,false],[416,133,0,null,null,null,null,false],[416,134,0,null,null,null,null,false],[416,135,0,null,null,null,null,false],[416,136,0,null,null,null,null,false],[416,137,0,null,null,null,null,false],[416,138,0,null,null,null,null,false],[416,139,0,null,null,null,null,false],[401,2599,0,null,null,null,null,false],[0,0,0,"windows/sublang.zig",null,"",[],false],[417,0,0,null,null,null,null,false],[417,1,0,null,null,null,null,false],[417,2,0,null,null,null,null,false],[417,3,0,null,null,null,null,false],[417,4,0,null,null,null,null,false],[417,5,0,null,null,null,null,false],[417,6,0,null,null,null,null,false],[417,7,0,null,null,null,null,false],[417,8,0,null,null,null,null,false],[417,9,0,null,null,null,null,false],[417,10,0,null,null,null,null,false],[417,11,0,null,null,null,null,false],[417,12,0,null,null,null,null,false],[417,13,0,null,null,null,null,false],[417,14,0,null,null,null,null,false],[417,15,0,null,null,null,null,false],[417,16,0,null,null,null,null,false],[417,17,0,null,null,null,null,false],[417,18,0,null,null,null,null,false],[417,19,0,null,null,null,null,false],[417,20,0,null,null,null,null,false],[417,21,0,null,null,null,null,false],[417,22,0,null,null,null,null,false],[417,23,0,null,null,null,null,false],[417,24,0,null,null,null,null,false],[417,25,0,null,null,null,null,false],[417,26,0,null,null,null,null,false],[417,27,0,null,null,null,null,false],[417,28,0,null,null,null,null,false],[417,29,0,null,null,null,null,false],[417,30,0,null,null,null,null,false],[417,31,0,null,null,null,null,false],[417,32,0,null,null,null,null,false],[417,33,0,null,null,null,null,false],[417,34,0,null,null,null,null,false],[417,35,0,null,null,null,null,false],[417,36,0,null,null,null,null,false],[417,37,0,null,null,null,null,false],[417,38,0,null,null,null,null,false],[417,39,0,null,null,null,null,false],[417,40,0,null,null,null,null,false],[417,41,0,null,null,null,null,false],[417,42,0,null,null,null,null,false],[417,43,0,null,null,null,null,false],[417,44,0,null,null,null,null,false],[417,45,0,null,null,null,null,false],[417,46,0,null,null,null,null,false],[417,47,0,null,null,null,null,false],[417,48,0,null,null,null,null,false],[417,49,0,null,null,null,null,false],[417,50,0,null,null,null,null,false],[417,51,0,null,null,null,null,false],[417,52,0,null,null,null,null,false],[417,53,0,null,null,null,null,false],[417,54,0,null,null,null,null,false],[417,55,0,null,null,null,null,false],[417,56,0,null,null,null,null,false],[417,57,0,null,null,null,null,false],[417,58,0,null,null,null,null,false],[417,59,0,null,null,null,null,false],[417,60,0,null,null,null,null,false],[417,61,0,null,null,null,null,false],[417,62,0,null,null,null,null,false],[417,63,0,null,null,null,null,false],[417,64,0,null,null,null,null,false],[417,65,0,null,null,null,null,false],[417,66,0,null,null,null,null,false],[417,67,0,null,null,null,null,false],[417,68,0,null,null,null,null,false],[417,69,0,null,null,null,null,false],[417,70,0,null,null,null,null,false],[417,71,0,null,null,null,null,false],[417,72,0,null,null,null,null,false],[417,73,0,null,null,null,null,false],[417,74,0,null,null,null,null,false],[417,75,0,null,null,null,null,false],[417,76,0,null,null,null,null,false],[417,77,0,null,null,null,null,false],[417,78,0,null,null,null,null,false],[417,79,0,null,null,null,null,false],[417,80,0,null,null,null,null,false],[417,81,0,null,null,null,null,false],[417,82,0,null,null,null,null,false],[417,83,0,null,null,null,null,false],[417,84,0,null,null,null,null,false],[417,85,0,null,null,null,null,false],[417,86,0,null,null,null,null,false],[417,87,0,null,null,null,null,false],[417,88,0,null,null,null,null,false],[417,89,0,null,null,null,null,false],[417,90,0,null,null,null,null,false],[417,91,0,null,null,null,null,false],[417,92,0,null,null,null,null,false],[417,93,0,null,null,null,null,false],[417,94,0,null,null,null,null,false],[417,95,0,null,null,null,null,false],[417,96,0,null,null,null,null,false],[417,97,0,null,null,null,null,false],[417,98,0,null,null,null,null,false],[417,99,0,null,null,null,null,false],[417,100,0,null,null,null,null,false],[417,101,0,null,null,null,null,false],[417,102,0,null,null,null,null,false],[417,103,0,null,null,null,null,false],[417,104,0,null,null,null,null,false],[417,105,0,null,null,null,null,false],[417,106,0,null,null,null,null,false],[417,107,0,null,null,null,null,false],[417,108,0,null,null,null,null,false],[417,109,0,null,null,null,null,false],[417,110,0,null,null,null,null,false],[417,111,0,null,null,null,null,false],[417,112,0,null,null,null,null,false],[417,113,0,null,null,null,null,false],[417,114,0,null,null,null,null,false],[417,115,0,null,null,null,null,false],[417,116,0,null,null,null,null,false],[417,117,0,null,null,null,null,false],[417,118,0,null,null,null,null,false],[417,119,0,null,null,null,null,false],[417,120,0,null,null,null,null,false],[417,121,0,null,null,null,null,false],[417,122,0,null,null,null,null,false],[417,123,0,null,null,null,null,false],[417,124,0,null,null,null,null,false],[417,125,0,null,null,null,null,false],[417,126,0,null,null,null,null,false],[417,127,0,null,null,null,null,false],[417,128,0,null,null,null,null,false],[417,129,0,null,null,null,null,false],[417,130,0,null,null,null,null,false],[417,131,0,null,null,null,null,false],[417,132,0,null,null,null,null,false],[417,133,0,null,null,null,null,false],[417,134,0,null,null,null,null,false],[417,135,0,null,null,null,null,false],[417,136,0,null,null,null,null,false],[417,137,0,null,null,null,null,false],[417,138,0,null,null,null,null,false],[417,139,0,null,null,null,null,false],[417,140,0,null,null,null,null,false],[417,141,0,null,null,null,null,false],[417,142,0,null,null,null,null,false],[417,143,0,null,null,null,null,false],[417,144,0,null,null,null,null,false],[417,145,0,null,null,null,null,false],[417,146,0,null,null,null,null,false],[417,147,0,null,null,null,null,false],[417,148,0,null,null,null,null,false],[417,149,0,null,null,null,null,false],[417,150,0,null,null,null,null,false],[417,151,0,null,null,null,null,false],[417,152,0,null,null,null,null,false],[417,153,0,null,null,null,null,false],[417,154,0,null,null,null,null,false],[417,155,0,null,null,null,null,false],[417,156,0,null,null,null,null,false],[417,157,0,null,null,null,null,false],[417,158,0,null,null,null,null,false],[417,159,0,null,null,null,null,false],[417,160,0,null,null,null,null,false],[417,161,0,null,null,null,null,false],[417,162,0,null,null,null,null,false],[417,163,0,null,null,null,null,false],[417,164,0,null,null,null,null,false],[417,165,0,null,null,null,null,false],[417,166,0,null,null,null,null,false],[417,167,0,null,null,null,null,false],[417,168,0,null,null,null,null,false],[417,169,0,null,null,null,null,false],[417,170,0,null,null,null,null,false],[417,171,0,null,null,null,null,false],[417,172,0,null,null,null,null,false],[417,173,0,null,null,null,null,false],[417,174,0,null,null,null,null,false],[417,175,0,null,null,null,null,false],[417,176,0,null,null,null,null,false],[417,177,0,null,null,null,null,false],[417,178,0,null,null,null,null,false],[417,179,0,null,null,null,null,false],[417,180,0,null,null,null,null,false],[417,181,0,null,null,null,null,false],[417,182,0,null,null,null,null,false],[417,183,0,null,null,null,null,false],[417,184,0,null,null,null,null,false],[417,185,0,null,null,null,null,false],[417,186,0,null,null,null,null,false],[417,187,0,null,null,null,null,false],[417,188,0,null,null,null,null,false],[417,189,0,null,null,null,null,false],[417,190,0,null,null,null,null,false],[417,191,0,null,null,null,null,false],[417,192,0,null,null,null,null,false],[417,193,0,null,null,null,null,false],[417,194,0,null,null,null,null,false],[417,195,0,null,null,null,null,false],[417,196,0,null,null,null,null,false],[417,197,0,null,null,null,null,false],[417,198,0,null,null,null,null,false],[417,199,0,null,null,null,null,false],[417,200,0,null,null,null,null,false],[417,201,0,null,null,null,null,false],[417,202,0,null,null,null,null,false],[417,203,0,null,null,null,null,false],[417,204,0,null,null,null,null,false],[417,205,0,null,null,null,null,false],[417,206,0,null,null,null,null,false],[417,207,0,null,null,null,null,false],[417,208,0,null,null,null,null,false],[417,209,0,null,null,null,null,false],[417,210,0,null,null,null,null,false],[417,211,0,null,null,null,null,false],[417,212,0,null,null,null,null,false],[417,213,0,null,null,null,null,false],[417,214,0,null,null,null,null,false],[417,215,0,null,null,null,null,false],[417,216,0,null,null,null,null,false],[417,217,0,null,null,null,null,false],[417,218,0,null,null,null,null,false],[417,219,0,null,null,null,null,false],[417,220,0,null,null,null,null,false],[417,221,0,null,null,null,null,false],[417,222,0,null,null,null,null,false],[417,223,0,null,null,null,null,false],[417,224,0,null,null,null,null,false],[417,225,0,null,null,null,null,false],[417,226,0,null,null,null,null,false],[417,227,0,null,null,null,null,false],[417,228,0,null,null,null,null,false],[417,229,0,null,null,null,null,false],[417,230,0,null,null,null,null,false],[417,231,0,null,null,null,null,false],[417,232,0,null,null,null,null,false],[417,233,0,null,null,null,null,false],[417,234,0,null,null,null,null,false],[417,235,0,null,null,null,null,false],[417,236,0,null,null,null,null,false],[417,237,0,null,null,null,null,false],[417,238,0,null,null,null,null,false],[417,239,0,null,null,null,null,false],[417,240,0,null,null,null,null,false],[417,241,0,null,null,null,null,false],[417,242,0,null,null,null,null,false],[417,243,0,null,null,null,null,false],[401,2602,0,null,null," The standard input device. Initially, this is the console input buffer, CONIN$.",null,false],[401,2605,0,null,null," The standard output device. Initially, this is the active console screen buffer, CONOUT$.",null,false],[401,2608,0,null,null," The standard error device. Initially, this is the active console screen buffer, CONOUT$.",null,false],[401,2610,0,null,null,null,null,false],[401,2615,0,null,null,null,null,false],[401,2616,0,null,null,null,null,false],[401,2617,0,null,null,null,null,false],[401,2618,0,null,null,null,null,false],[401,2619,0,null,null,null,null,false],[401,2620,0,null,null,null,null,false],[401,2621,0,null,null,null,null,false],[401,2622,0,null,null,null,null,false],[401,2623,0,null,null,null,null,false],[401,2624,0,null,null,null,null,false],[401,2625,0,null,null,null,null,false],[401,2626,0,null,null,null,null,false],[401,2627,0,null,null,null,null,false],[401,2628,0,null,null,null,null,false],[401,2629,0,null,null,null,null,false],[401,2630,0,null,null,null,null,false],[401,2631,0,null,null,null,null,false],[401,2632,0,null,null,null,null,false],[401,2633,0,null,null,null,null,false],[401,2634,0,null,null,null,null,false],[401,2635,0,null,null,null,null,false],[401,2636,0,null,null,null,null,false],[401,2637,0,null,null,null,null,false],[401,2638,0,null,null,null,null,false],[401,2639,0,null,null,null,null,false],[401,2640,0,null,null,null,null,false],[401,2641,0,null,null,null,null,false],[401,2642,0,null,null,null,null,false],[401,2643,0,null,null,null,null,false],[401,2645,0,null,null," Allocated by SysAllocString, freed by SysFreeString",null,false],[401,2646,0,null,null,null,null,false],[401,2647,0,null,null,null,null,false],[401,2648,0,null,null,null,null,false],[401,2649,0,null,null,null,null,false],[401,2650,0,null,null,null,null,false],[401,2651,0,null,null,null,null,false],[401,2652,0,null,null,null,null,false],[401,2653,0,null,null,null,null,false],[401,2654,0,null,null,null,null,false],[401,2655,0,null,null,null,null,false],[401,2656,0,null,null,null,null,false],[401,2657,0,null,null,null,null,false],[401,2658,0,null,null,null,null,false],[401,2659,0,null,null,null,null,false],[401,2660,0,null,null,null,null,false],[401,2661,0,null,null,null,null,false],[401,2662,0,null,null,null,null,false],[401,2663,0,null,null,null,null,false],[401,2664,0,null,null,null,null,false],[401,2665,0,null,null,null,null,false],[401,2667,0,null,null,null,null,false],[401,2668,0,null,null,null,null,false],[401,2669,0,null,null,null,null,false],[401,2671,0,null,null,null,null,false],[401,2673,0,null,null,null,null,false],[401,2674,0,null,null,null,null,false],[401,2676,0,null,null,null,null,false],[401,2677,0,null,null,null,null,false],[401,2678,0,null,null,null,null,false],[401,2679,0,null,null,null,null,false],[401,2680,0,null,null,null,null,false],[401,2681,0,null,null,null,null,false],[401,2682,0,null,null,null,null,false],[401,2683,0,null,null,null,null,false],[401,2684,0,null,null,null,null,false],[401,2685,0,null,null,null,null,false],[401,2686,0,null,null,null,null,false],[401,2687,0,null,null,null,null,false],[401,2688,0,null,null,null,null,false],[401,2689,0,null,null,null,null,false],[401,2690,0,null,null,null,null,false],[401,2691,0,null,null,null,null,false],[401,2692,0,null,null,null,null,false],[401,2693,0,null,null,null,null,false],[401,2694,0,null,null,null,null,false],[401,2695,0,null,null,null,null,false],[401,2696,0,null,null,null,null,false],[401,2697,0,null,null,null,null,false],[401,2698,0,null,null,null,null,false],[401,2699,0,null,null,null,null,false],[401,2700,0,null,null,null,null,false],[401,2701,0,null,null,null,null,false],[401,2702,0,null,null,null,null,false],[401,2703,0,null,null,null,null,false],[401,2704,0,null,null,null,null,false],[401,2705,0,null,null,null,null,false],[401,2706,0,null,null,null,null,false],[401,2707,0,null,null,null,null,false],[401,2708,0,null,null,null,null,false],[401,2709,0,null,null,null,null,false],[401,2710,0,null,null,null,null,false],[401,2711,0,null,null,null,null,false],[401,2712,0,null,null,null,null,false],[401,2713,0,null,null,null,null,false],[401,2714,0,null,null,null,null,false],[401,2715,0,null,null,null,null,false],[401,2716,0,null,null,null,null,false],[401,2717,0,null,null,null,null,false],[401,2718,0,null,null,null,null,false],[401,2719,0,null,null,null,null,false],[401,2720,0,null,null,null,null,false],[401,2721,0,null,null,null,null,false],[401,2722,0,null,null,null,null,false],[401,2723,0,null,null,null,null,false],[401,2724,0,null,null,null,null,false],[401,2725,0,null,null,null,null,false],[401,2726,0,null,null,null,null,false],[401,2727,0,null,null,null,null,false],[401,2728,0,null,null,null,null,false],[401,2729,0,null,null,null,null,false],[401,2730,0,null,null,null,null,false],[401,2731,0,null,null,null,null,false],[401,2732,0,null,null,null,null,false],[401,2733,0,null,null,null,null,false],[401,2734,0,null,null,null,null,false],[401,2735,0,null,null,null,null,false],[401,2737,0,null,null,null,null,false],[401,2738,0,null,null,null,null,false],[401,2739,0,null,null,null,null,false],[401,2740,0,null,null,null,null,false],[401,2741,0,null,null,null,null,false],[401,2742,0,null,null,null,null,false],[401,2743,0,null,null,null,null,false],[401,2744,0,null,null,null,null,false],[401,2745,0,null,null,null,null,false],[401,2746,0,null,null,null,null,false],[401,2747,0,null,null,null,null,false],[401,2748,0,null,null,null,null,false],[401,2749,0,null,null,null,null,false],[401,2750,0,null,null,null,null,false],[401,2751,0,null,null,null,null,false],[401,2752,0,null,null,null,null,false],[401,2753,0,null,null,null,null,false],[401,2754,0,null,null,null,null,false],[401,2755,0,null,null,null,null,false],[401,2756,0,null,null,null,null,false],[401,2757,0,null,null,null,null,false],[401,2758,0,null,null,null,null,false],[401,2759,0,null,null,null,null,false],[401,2760,0,null,null,null,null,false],[401,2761,0,null,null,null,null,false],[401,2764,0,null,null," https://docs.microsoft.com/en-us/windows-hardware/drivers/kernel/buffer-descriptions-for-i-o-control-codes",[56020,56021,56022,56023],false],[0,0,0,"METHOD_BUFFERED",null,null,null,false],[0,0,0,"METHOD_IN_DIRECT",null,null,null,false],[0,0,0,"METHOD_OUT_DIRECT",null,null,null,false],[0,0,0,"METHOD_NEITHER",null,null,null,false],[401,2771,0,null,null,null,null,false],[401,2772,0,null,null,null,null,false],[401,2773,0,null,null,null,null,false],[401,2776,0,null,null," https://docs.microsoft.com/en-us/windows-hardware/drivers/kernel/defining-i-o-control-codes",[56028,56029,56030,56031],false],[0,0,0,"deviceType",null,"",null,false],[0,0,0,"function",null,"",null,false],[0,0,0,"method",null,"",null,false],[0,0,0,"access",null,"",null,false],[401,2783,0,null,null,null,null,false],[401,2785,0,null,null,null,null,false],[401,2787,0,null,null,null,[56036,56038,56040,56042,56044,56046,56048,56050,56052],false],[401,2787,0,null,null,null,null,false],[0,0,0,"BasicInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"StandardInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"InternalInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"EaInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"AccessInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"PositionInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"ModeInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"AlignmentInformation",null,null,null,false],[401,2787,0,null,null,null,null,false],[0,0,0,"NameInformation",null,null,null,false],[401,2799,0,null,null,null,[56055,56057,56059,56061,56063],false],[401,2799,0,null,null,null,null,false],[0,0,0,"CreationTime",null,null,null,false],[401,2799,0,null,null,null,null,false],[0,0,0,"LastAccessTime",null,null,null,false],[401,2799,0,null,null,null,null,false],[0,0,0,"LastWriteTime",null,null,null,false],[401,2799,0,null,null,null,null,false],[0,0,0,"ChangeTime",null,null,null,false],[401,2799,0,null,null,null,null,false],[0,0,0,"FileAttributes",null,null,null,false],[401,2807,0,null,null,null,[56066,56068,56070,56072,56074],false],[401,2807,0,null,null,null,null,false],[0,0,0,"AllocationSize",null,null,null,false],[401,2807,0,null,null,null,null,false],[0,0,0,"EndOfFile",null,null,null,false],[401,2807,0,null,null,null,null,false],[0,0,0,"NumberOfLinks",null,null,null,false],[401,2807,0,null,null,null,null,false],[0,0,0,"DeletePending",null,null,null,false],[401,2807,0,null,null,null,null,false],[0,0,0,"Directory",null,null,null,false],[401,2815,0,null,null,null,[56077],false],[401,2815,0,null,null,null,null,false],[0,0,0,"IndexNumber",null,null,null,false],[401,2819,0,null,null,null,[56080],false],[401,2819,0,null,null,null,null,false],[0,0,0,"EaSize",null,null,null,false],[401,2823,0,null,null,null,[56083],false],[401,2823,0,null,null,null,null,false],[0,0,0,"AccessFlags",null,null,null,false],[401,2827,0,null,null,null,[56086],false],[401,2827,0,null,null,null,null,false],[0,0,0,"CurrentByteOffset",null,null,null,false],[401,2831,0,null,null,null,[56089],false],[401,2831,0,null,null,null,null,false],[0,0,0,"EndOfFile",null,null,null,false],[401,2835,0,null,null,null,[56092],false],[401,2835,0,null,null,null,null,false],[0,0,0,"Mode",null,null,null,false],[401,2839,0,null,null,null,[56095],false],[401,2839,0,null,null,null,null,false],[0,0,0,"AlignmentRequirement",null,null,null,false],[401,2843,0,null,null,null,[56098,56100],false],[401,2843,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,2843,0,null,null,null,null,false],[0,0,0,"FileName",null,null,null,false],[401,2848,0,null,null,null,[56103],false],[401,2848,0,null,null,null,null,false],[0,0,0,"Flags",null," combination of FILE_DISPOSITION_* flags",null,false],[401,2853,0,null,null,null,null,false],[401,2854,0,null,null,null,null,false],[401,2855,0,null,null,null,null,false],[401,2856,0,null,null,null,null,false],[401,2857,0,null,null,null,null,false],[401,2858,0,null,null,null,null,false],[401,2861,0,null,null,null,null,false],[401,2862,0,null,null,null,null,false],[401,2863,0,null,null,null,null,false],[401,2864,0,null,null,null,null,false],[401,2865,0,null,null,null,null,false],[401,2866,0,null,null,null,null,false],[401,2867,0,null,null,null,null,false],[401,2868,0,null,null,null,null,false],[401,2869,0,null,null,null,null,false],[401,2870,0,null,null,null,null,false],[401,2871,0,null,null,null,null,false],[401,2873,0,null,null,null,[56123,56125,56127,56129],false],[401,2873,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,2873,0,null,null,null,null,false],[0,0,0,"RootDirectory",null,null,null,false],[401,2873,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,2873,0,null,null,null,null,false],[0,0,0,"FileName",null,null,null,false],[401,2881,0,null,null,null,[56132,56134,56136,56138],false],[401,2881,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,2881,0,null,null,null,null,false],[0,0,0,"RootDirectory",null,null,null,false],[401,2881,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,2881,0,null,null,null,null,false],[0,0,0,"FileName",null,null,null,false],[401,2888,0,null,null,null,[56143,56145],false],[401,2888,0,null,null,null,[56141,56142],false],[0,0,0,"Status",null,null,null,false],[0,0,0,"Pointer",null,null,null,false],[0,0,0,"u",null,null,null,false],[401,2888,0,null,null,null,null,false],[0,0,0,"Information",null,null,null,false],[401,2897,0,null,null,null,[56147,56148,56149,56150,56151,56152,56153,56154,56155,56156,56157,56158,56159,56160,56161,56162,56163,56164,56165,56166,56167,56168,56169,56170,56171,56172,56173,56174,56175,56176,56177,56178,56179,56180,56181,56182,56183,56184,56185,56186,56187,56188,56189,56190,56191,56192,56193,56194,56195,56196,56197,56198,56199,56200,56201,56202,56203,56204,56205,56206,56207,56208,56209,56210,56211,56212,56213,56214,56215,56216,56217,56218,56219,56220,56221,56222],false],[0,0,0,"FileDirectoryInformation",null,null,null,false],[0,0,0,"FileFullDirectoryInformation",null,null,null,false],[0,0,0,"FileBothDirectoryInformation",null,null,null,false],[0,0,0,"FileBasicInformation",null,null,null,false],[0,0,0,"FileStandardInformation",null,null,null,false],[0,0,0,"FileInternalInformation",null,null,null,false],[0,0,0,"FileEaInformation",null,null,null,false],[0,0,0,"FileAccessInformation",null,null,null,false],[0,0,0,"FileNameInformation",null,null,null,false],[0,0,0,"FileRenameInformation",null,null,null,false],[0,0,0,"FileLinkInformation",null,null,null,false],[0,0,0,"FileNamesInformation",null,null,null,false],[0,0,0,"FileDispositionInformation",null,null,null,false],[0,0,0,"FilePositionInformation",null,null,null,false],[0,0,0,"FileFullEaInformation",null,null,null,false],[0,0,0,"FileModeInformation",null,null,null,false],[0,0,0,"FileAlignmentInformation",null,null,null,false],[0,0,0,"FileAllInformation",null,null,null,false],[0,0,0,"FileAllocationInformation",null,null,null,false],[0,0,0,"FileEndOfFileInformation",null,null,null,false],[0,0,0,"FileAlternateNameInformation",null,null,null,false],[0,0,0,"FileStreamInformation",null,null,null,false],[0,0,0,"FilePipeInformation",null,null,null,false],[0,0,0,"FilePipeLocalInformation",null,null,null,false],[0,0,0,"FilePipeRemoteInformation",null,null,null,false],[0,0,0,"FileMailslotQueryInformation",null,null,null,false],[0,0,0,"FileMailslotSetInformation",null,null,null,false],[0,0,0,"FileCompressionInformation",null,null,null,false],[0,0,0,"FileObjectIdInformation",null,null,null,false],[0,0,0,"FileCompletionInformation",null,null,null,false],[0,0,0,"FileMoveClusterInformation",null,null,null,false],[0,0,0,"FileQuotaInformation",null,null,null,false],[0,0,0,"FileReparsePointInformation",null,null,null,false],[0,0,0,"FileNetworkOpenInformation",null,null,null,false],[0,0,0,"FileAttributeTagInformation",null,null,null,false],[0,0,0,"FileTrackingInformation",null,null,null,false],[0,0,0,"FileIdBothDirectoryInformation",null,null,null,false],[0,0,0,"FileIdFullDirectoryInformation",null,null,null,false],[0,0,0,"FileValidDataLengthInformation",null,null,null,false],[0,0,0,"FileShortNameInformation",null,null,null,false],[0,0,0,"FileIoCompletionNotificationInformation",null,null,null,false],[0,0,0,"FileIoStatusBlockRangeInformation",null,null,null,false],[0,0,0,"FileIoPriorityHintInformation",null,null,null,false],[0,0,0,"FileSfioReserveInformation",null,null,null,false],[0,0,0,"FileSfioVolumeInformation",null,null,null,false],[0,0,0,"FileHardLinkInformation",null,null,null,false],[0,0,0,"FileProcessIdsUsingFileInformation",null,null,null,false],[0,0,0,"FileNormalizedNameInformation",null,null,null,false],[0,0,0,"FileNetworkPhysicalNameInformation",null,null,null,false],[0,0,0,"FileIdGlobalTxDirectoryInformation",null,null,null,false],[0,0,0,"FileIsRemoteDeviceInformation",null,null,null,false],[0,0,0,"FileUnusedInformation",null,null,null,false],[0,0,0,"FileNumaNodeInformation",null,null,null,false],[0,0,0,"FileStandardLinkInformation",null,null,null,false],[0,0,0,"FileRemoteProtocolInformation",null,null,null,false],[0,0,0,"FileRenameInformationBypassAccessCheck",null,null,null,false],[0,0,0,"FileLinkInformationBypassAccessCheck",null,null,null,false],[0,0,0,"FileVolumeNameInformation",null,null,null,false],[0,0,0,"FileIdInformation",null,null,null,false],[0,0,0,"FileIdExtdDirectoryInformation",null,null,null,false],[0,0,0,"FileReplaceCompletionInformation",null,null,null,false],[0,0,0,"FileHardLinkFullIdInformation",null,null,null,false],[0,0,0,"FileIdExtdBothDirectoryInformation",null,null,null,false],[0,0,0,"FileDispositionInformationEx",null,null,null,false],[0,0,0,"FileRenameInformationEx",null,null,null,false],[0,0,0,"FileRenameInformationExBypassAccessCheck",null,null,null,false],[0,0,0,"FileDesiredStorageClassInformation",null,null,null,false],[0,0,0,"FileStatInformation",null,null,null,false],[0,0,0,"FileMemoryPartitionInformation",null,null,null,false],[0,0,0,"FileStatLxInformation",null,null,null,false],[0,0,0,"FileCaseSensitiveInformation",null,null,null,false],[0,0,0,"FileLinkInformationEx",null,null,null,false],[0,0,0,"FileLinkInformationExBypassAccessCheck",null,null,null,false],[0,0,0,"FileStorageReserveIdInformation",null,null,null,false],[0,0,0,"FileCaseSensitiveInformationForceAccessCheck",null,null,null,false],[0,0,0,"FileMaximumInformation",null,null,null,false],[401,2976,0,null,null,null,[56225],false],[401,2976,0,null,null,null,null,false],[0,0,0,"DeleteFile",null,null,null,false],[401,2980,0,null,null,null,[56228,56230],false],[401,2980,0,null,null,null,null,false],[0,0,0,"DeviceType",null,null,null,false],[401,2980,0,null,null,null,null,false],[0,0,0,"Characteristics",null,null,null,false],[401,2985,0,null,null,null,[56232,56233,56234,56235,56236,56237,56238,56239,56240,56241,56242,56243,56244,56245,56246],false],[0,0,0,"FileFsVolumeInformation",null,null,null,false],[0,0,0,"FileFsLabelInformation",null,null,null,false],[0,0,0,"FileFsSizeInformation",null,null,null,false],[0,0,0,"FileFsDeviceInformation",null,null,null,false],[0,0,0,"FileFsAttributeInformation",null,null,null,false],[0,0,0,"FileFsControlInformation",null,null,null,false],[0,0,0,"FileFsFullSizeInformation",null,null,null,false],[0,0,0,"FileFsObjectIdInformation",null,null,null,false],[0,0,0,"FileFsDriverPathInformation",null,null,null,false],[0,0,0,"FileFsVolumeFlagsInformation",null,null,null,false],[0,0,0,"FileFsSectorSizeInformation",null,null,null,false],[0,0,0,"FileFsDataCopyInformation",null,null,null,false],[0,0,0,"FileFsMetadataSizeInformation",null,null,null,false],[0,0,0,"FileFsFullSizeInformationEx",null,null,null,false],[0,0,0,"FileFsMaximumInformation",null,null,null,false],[401,3003,0,null,null,null,[56249,56251,56259,56261],false],[401,3003,0,null,null,null,null,false],[0,0,0,"Internal",null,null,null,false],[401,3003,0,null,null,null,null,false],[0,0,0,"InternalHigh",null,null,null,false],[401,3003,0,null,null,null,[56257,56258],false],[401,3007,0,null,null,null,null,false],[0,0,0,"Offset",null,null,null,false],[401,3007,0,null,null,null,null,false],[0,0,0,"OffsetHigh",null,null,null,false],[0,0,0,"DUMMYSTRUCTNAME",null,null,null,false],[0,0,0,"Pointer",null,null,null,false],[0,0,0,"DUMMYUNIONNAME",null,null,null,false],[401,3003,0,null,null,null,null,false],[0,0,0,"hEvent",null,null,null,false],[401,3016,0,null,null,null,[56264,56266,56268,56270],false],[401,3016,0,null,null,null,null,false],[0,0,0,"lpCompletionKey",null,null,null,false],[401,3016,0,null,null,null,null,false],[0,0,0,"lpOverlapped",null,null,null,false],[401,3016,0,null,null,null,null,false],[0,0,0,"Internal",null,null,null,false],[401,3016,0,null,null,null,null,false],[0,0,0,"dwNumberOfBytesTransferred",null,null,null,false],[401,3023,0,null,null,null,null,false],[401,3026,0,null,null,null,null,false],[401,3027,0,null,null,null,null,false],[401,3028,0,null,null,null,null,false],[401,3029,0,null,null,null,null,false],[401,3030,0,null,null,null,null,false],[401,3031,0,null,null,null,null,false],[401,3032,0,null,null,null,null,false],[401,3033,0,null,null,null,null,false],[401,3034,0,null,null,null,null,false],[401,3035,0,null,null,null,null,false],[401,3036,0,null,null,null,null,false],[401,3037,0,null,null,null,null,false],[401,3038,0,null,null,null,null,false],[401,3039,0,null,null,null,null,false],[401,3040,0,null,null,null,null,false],[401,3041,0,null,null,null,null,false],[401,3042,0,null,null,null,null,false],[401,3043,0,null,null,null,null,false],[401,3044,0,null,null,null,null,false],[401,3045,0,null,null,null,null,false],[401,3046,0,null,null,null,null,false],[401,3047,0,null,null,null,null,false],[401,3049,0,null,null,null,[56296,56298,56300,56302,56304,56306,56308,56310,56312,56314],false],[401,3049,0,null,null,null,null,false],[0,0,0,"dwFileAttributes",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"ftCreationTime",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"ftLastAccessTime",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"ftLastWriteTime",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"dwVolumeSerialNumber",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"nFileSizeHigh",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"nFileSizeLow",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"nNumberOfLinks",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"nFileIndexHigh",null,null,null,false],[401,3049,0,null,null,null,null,false],[0,0,0,"nFileIndexLow",null,null,null,false],[401,3062,0,null,null,null,[56317,56319],false],[401,3062,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,3062,0,null,null,null,null,false],[0,0,0,"FileName",null,null,null,false],[401,3068,0,null,null," Return the normalized drive name. This is the default.",null,false],[401,3071,0,null,null," Return the opened file name (not normalized).",null,false],[401,3074,0,null,null," Return the path with the drive letter. This is the default.",null,false],[401,3077,0,null,null," Return the path with a volume GUID path instead of the drive name.",null,false],[401,3080,0,null,null," Return the path with no drive information.",null,false],[401,3083,0,null,null," Return the path with the volume device path.",null,false],[401,3085,0,null,null,null,[56328,56330,56332],false],[401,3085,0,null,null,null,null,false],[0,0,0,"nLength",null,null,null,false],[401,3085,0,null,null,null,null,false],[0,0,0,"lpSecurityDescriptor",null,null,null,false],[401,3085,0,null,null,null,null,false],[0,0,0,"bInheritHandle",null,null,null,false],[401,3091,0,null,null,null,null,false],[401,3092,0,null,null,null,null,false],[401,3093,0,null,null,null,null,false],[401,3095,0,null,null,null,null,false],[401,3096,0,null,null,null,null,false],[401,3098,0,null,null,null,null,false],[401,3099,0,null,null,null,null,false],[401,3101,0,null,null,null,null,false],[401,3102,0,null,null,null,null,false],[401,3104,0,null,null,null,null,false],[401,3105,0,null,null,null,null,false],[401,3106,0,null,null,null,null,false],[401,3107,0,null,null,null,null,false],[401,3109,0,null,null,null,null,false],[401,3110,0,null,null,null,null,false],[401,3111,0,null,null,null,null,false],[401,3113,0,null,null,null,null,false],[401,3114,0,null,null,null,null,false],[401,3115,0,null,null,null,null,false],[401,3116,0,null,null,null,null,false],[401,3117,0,null,null,null,null,false],[401,3118,0,null,null,null,null,false],[401,3119,0,null,null,null,null,false],[401,3120,0,null,null,null,null,false],[401,3121,0,null,null,null,null,false],[401,3122,0,null,null,null,null,false],[401,3125,0,null,null,null,null,false],[401,3126,0,null,null,null,null,false],[401,3127,0,null,null,null,null,false],[401,3128,0,null,null,null,null,false],[401,3129,0,null,null,null,null,false],[401,3130,0,null,null,null,null,false],[401,3131,0,null,null,null,null,false],[401,3134,0,null,null,null,null,false],[401,3135,0,null,null,null,null,false],[401,3136,0,null,null,null,null,false],[401,3137,0,null,null,null,null,false],[401,3138,0,null,null,null,null,false],[401,3139,0,null,null,null,null,false],[401,3140,0,null,null,null,null,false],[401,3141,0,null,null,null,null,false],[401,3142,0,null,null,null,null,false],[401,3143,0,null,null,null,null,false],[401,3144,0,null,null,null,null,false],[401,3145,0,null,null,null,null,false],[401,3146,0,null,null,null,null,false],[401,3147,0,null,null,null,null,false],[401,3149,0,null,null,null,null,false],[401,3150,0,null,null,null,null,false],[401,3151,0,null,null,null,null,false],[401,3152,0,null,null,null,null,false],[401,3153,0,null,null,null,null,false],[401,3154,0,null,null,null,null,false],[401,3155,0,null,null,null,null,false],[401,3156,0,null,null,null,null,false],[401,3157,0,null,null,null,null,false],[401,3158,0,null,null,null,null,false],[401,3159,0,null,null,null,null,false],[401,3160,0,null,null,null,null,false],[401,3161,0,null,null,null,null,false],[401,3162,0,null,null,null,null,false],[401,3163,0,null,null,null,null,false],[401,3164,0,null,null,null,null,false],[401,3165,0,null,null,null,null,false],[401,3166,0,null,null,null,null,false],[401,3167,0,null,null,null,null,false],[401,3168,0,null,null,null,null,false],[401,3170,0,null,null,null,null,false],[401,3171,0,null,null,null,null,false],[401,3172,0,null,null,null,null,false],[401,3173,0,null,null,null,null,false],[401,3174,0,null,null,null,null,false],[401,3176,0,null,null,null,null,false],[401,3177,0,null,null,null,null,false],[401,3178,0,null,null,null,null,false],[401,3179,0,null,null,null,null,false],[401,3180,0,null,null,null,null,false],[401,3181,0,null,null,null,null,false],[401,3182,0,null,null,null,null,false],[401,3183,0,null,null,null,null,false],[401,3184,0,null,null,null,null,false],[401,3185,0,null,null,null,null,false],[401,3186,0,null,null,null,null,false],[401,3187,0,null,null,null,null,false],[401,3188,0,null,null,null,null,false],[401,3189,0,null,null,null,null,false],[401,3190,0,null,null,null,null,false],[401,3191,0,null,null,null,null,false],[401,3192,0,null,null,null,null,false],[401,3193,0,null,null,null,null,false],[401,3194,0,null,null,null,null,false],[401,3197,0,null,null,null,null,false],[401,3198,0,null,null,null,null,false],[401,3200,0,null,null,null,null,false],[401,3201,0,null,null,null,null,false],[401,3204,0,null,null,null,null,false],[401,3205,0,null,null,null,null,false],[401,3206,0,null,null,null,null,false],[401,3208,0,null,null,null,[56433,56435,56437,56439],false],[401,3208,0,null,null,null,null,false],[0,0,0,"hProcess",null,null,null,false],[401,3208,0,null,null,null,null,false],[0,0,0,"hThread",null,null,null,false],[401,3208,0,null,null,null,null,false],[0,0,0,"dwProcessId",null,null,null,false],[401,3208,0,null,null,null,null,false],[0,0,0,"dwThreadId",null,null,null,false],[401,3215,0,null,null,null,[56442,56444,56446,56448,56450,56452,56454,56456,56458,56460,56462,56464,56466,56468,56470,56472,56474,56476],false],[401,3215,0,null,null,null,null,false],[0,0,0,"cb",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"lpReserved",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"lpDesktop",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"lpTitle",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwX",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwY",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwXSize",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwYSize",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwXCountChars",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwYCountChars",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwFillAttribute",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"dwFlags",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"wShowWindow",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"cbReserved2",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"lpReserved2",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"hStdInput",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"hStdOutput",null,null,null,false],[401,3215,0,null,null,null,null,false],[0,0,0,"hStdError",null,null,null,false],[401,3236,0,null,null,null,null,false],[401,3237,0,null,null,null,null,false],[401,3238,0,null,null,null,null,false],[401,3239,0,null,null,null,null,false],[401,3240,0,null,null,null,null,false],[401,3241,0,null,null,null,null,false],[401,3242,0,null,null,null,null,false],[401,3243,0,null,null,null,null,false],[401,3244,0,null,null,null,null,false],[401,3245,0,null,null,null,null,false],[401,3246,0,null,null,null,null,false],[401,3247,0,null,null,null,null,false],[401,3248,0,null,null,null,null,false],[401,3249,0,null,null,null,null,false],[401,3251,0,null,null,null,null,false],[401,3253,0,null,null,null,null,false],[401,3255,0,null,null,null,null,false],[401,3256,0,null,null,null,null,false],[401,3257,0,null,null,null,null,false],[401,3258,0,null,null,null,null,false],[401,3259,0,null,null,null,null,false],[401,3261,0,null,null,null,null,false],[401,3262,0,null,null,null,null,false],[401,3264,0,null,null,null,null,false],[401,3265,0,null,null,null,null,false],[401,3266,0,null,null,null,null,false],[401,3267,0,null,null,null,null,false],[401,3268,0,null,null,null,null,false],[401,3269,0,null,null,null,null,false],[401,3271,0,null,null,null,null,false],[401,3272,0,null,null,null,null,false],[401,3273,0,null,null,null,null,false],[401,3275,0,null,null,null,null,false],[401,3276,0,null,null,null,null,false],[401,3277,0,null,null,null,null,false],[401,3278,0,null,null,null,null,false],[401,3281,0,null,null,null,null,false],[401,3282,0,null,null,null,null,false],[401,3283,0,null,null,null,null,false],[401,3284,0,null,null,null,null,false],[401,3285,0,null,null,null,null,false],[401,3286,0,null,null,null,null,false],[401,3287,0,null,null,null,null,false],[401,3288,0,null,null,null,null,false],[401,3289,0,null,null,null,null,false],[401,3292,0,null,null,null,null,false],[401,3293,0,null,null,null,null,false],[401,3294,0,null,null,null,null,false],[401,3295,0,null,null,null,null,false],[401,3296,0,null,null,null,null,false],[401,3297,0,null,null,null,null,false],[401,3298,0,null,null,null,null,false],[401,3299,0,null,null,null,null,false],[401,3300,0,null,null,null,null,false],[401,3301,0,null,null,null,null,false],[401,3302,0,null,null,null,null,false],[401,3303,0,null,null,null,null,false],[401,3304,0,null,null,null,null,false],[401,3307,0,null,null,null,null,false],[401,3308,0,null,null,null,null,false],[401,3309,0,null,null,null,null,false],[401,3310,0,null,null,null,null,false],[401,3312,0,null,null,null,[56540],false],[0,0,0,"",null,"",null,false],[401,3313,0,null,null,null,null,false],[401,3315,0,null,null,null,[56544,56546,56548,56550,56552,56554,56556,56558,56560,56562],false],[401,3315,0,null,null,null,null,false],[0,0,0,"dwFileAttributes",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"ftCreationTime",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"ftLastAccessTime",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"ftLastWriteTime",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"nFileSizeHigh",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"nFileSizeLow",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"dwReserved0",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"dwReserved1",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"cFileName",null,null,null,false],[401,3315,0,null,null,null,null,false],[0,0,0,"cAlternateFileName",null,null,null,false],[401,3328,0,null,null,null,[56565,56567],false],[401,3328,0,null,null,null,null,false],[0,0,0,"dwLowDateTime",null,null,null,false],[401,3328,0,null,null,null,null,false],[0,0,0,"dwHighDateTime",null,null,null,false],[401,3333,0,null,null,null,[56576,56578,56580,56582,56584,56586,56588,56590,56592,56594],false],[401,3333,0,null,null,null,[56570,56575],false],[0,0,0,"dwOemId",null,null,[56572,56574],false],[401,3336,0,null,null,null,null,false],[0,0,0,"wProcessorArchitecture",null,null,null,false],[401,3336,0,null,null,null,null,false],[0,0,0,"wReserved",null,null,null,false],[0,0,0,"anon2",null,null,null,false],[0,0,0,"anon1",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"dwPageSize",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"lpMinimumApplicationAddress",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"lpMaximumApplicationAddress",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"dwActiveProcessorMask",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"dwNumberOfProcessors",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"dwProcessorType",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"dwAllocationGranularity",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"wProcessorLevel",null,null,null,false],[401,3333,0,null,null,null,null,false],[0,0,0,"wProcessorRevision",null,null,null,false],[401,3352,0,null,null,null,null,false],[401,3354,0,null,null,null,null,false],[401,3355,0,null,null,null,[56603,56604,56605,56607],false],[401,3361,0,null,null,null,null,false],[401,3376,0,null,null,null,[56600],false],[0,0,0,"s",null,"",null,false],[401,3382,0,null,null,null,[56602],false],[0,0,0,"s",null,"",null,false],[0,0,0,"Data1",null,null,null,false],[0,0,0,"Data2",null,null,null,false],[0,0,0,"Data3",null,null,null,false],[401,3355,0,null,null,null,null,false],[0,0,0,"Data4",null,null,null,false],[401,3409,0,null,null,null,null,false],[401,3411,0,null,null,null,null,false],[401,3412,0,null,null,null,null,false],[401,3413,0,null,null,null,null,false],[401,3414,0,null,null,null,null,false],[401,3415,0,null,null,null,null,false],[401,3416,0,null,null,null,null,false],[401,3417,0,null,null,null,null,false],[401,3418,0,null,null,null,null,false],[401,3419,0,null,null,null,null,false],[401,3420,0,null,null,null,null,false],[401,3421,0,null,null,null,null,false],[401,3423,0,null,null,null,null,false],[401,3424,0,null,null,null,null,false],[401,3425,0,null,null,null,null,false],[401,3426,0,null,null,null,null,false],[401,3427,0,null,null,null,null,false],[401,3428,0,null,null,null,null,false],[401,3429,0,null,null,null,null,false],[401,3430,0,null,null,null,null,false],[401,3431,0,null,null,null,null,false],[401,3432,0,null,null,null,null,false],[401,3433,0,null,null,null,null,false],[401,3434,0,null,null,null,null,false],[401,3436,0,null,null,null,null,false],[401,3437,0,null,null,null,null,false],[401,3438,0,null,null,null,null,false],[401,3439,0,null,null,null,null,false],[401,3440,0,null,null,null,null,false],[401,3441,0,null,null,null,null,false],[401,3442,0,null,null,null,null,false],[401,3443,0,null,null,null,null,false],[401,3444,0,null,null,null,null,false],[401,3445,0,null,null,null,null,false],[401,3446,0,null,null,null,null,false],[401,3448,0,null,null,null,[56645,56647,56649,56651],false],[401,3448,0,null,null,null,null,false],[0,0,0,"left",null,null,null,false],[401,3448,0,null,null,null,null,false],[0,0,0,"top",null,null,null,false],[401,3448,0,null,null,null,null,false],[0,0,0,"right",null,null,null,false],[401,3448,0,null,null,null,null,false],[0,0,0,"bottom",null,null,null,false],[401,3455,0,null,null,null,[56654,56656,56658,56660],false],[401,3455,0,null,null,null,null,false],[0,0,0,"Left",null,null,null,false],[401,3455,0,null,null,null,null,false],[0,0,0,"Top",null,null,null,false],[401,3455,0,null,null,null,null,false],[0,0,0,"Right",null,null,null,false],[401,3455,0,null,null,null,null,false],[0,0,0,"Bottom",null,null,null,false],[401,3462,0,null,null,null,[56663,56665],false],[401,3462,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[401,3462,0,null,null,null,null,false],[0,0,0,"y",null,null,null,false],[401,3467,0,null,null,null,[56668,56670],false],[401,3467,0,null,null,null,null,false],[0,0,0,"X",null,null,null,false],[401,3467,0,null,null,null,null,false],[0,0,0,"Y",null,null,null,false],[401,3472,0,null,null,null,null,false],[401,3474,0,null,null,null,null,false],[401,3475,0,null,null,null,[56674,56675,56676,56677,56678,56679],false],[0,0,0,"StartAddressOfRawData",null,null,null,false],[0,0,0,"EndAddressOfRawData",null,null,null,false],[0,0,0,"AddressOfIndex",null,null,null,false],[0,0,0,"AddressOfCallBacks",null,null,null,false],[0,0,0,"SizeOfZeroFill",null,null,null,false],[0,0,0,"Characteristics",null,null,null,false],[401,3483,0,null,null,null,null,false],[401,3484,0,null,null,null,null,false],[401,3486,0,null,null,null,[56683,56684,56685],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[401,3488,0,null,null,null,null,false],[401,3490,0,null,null,null,null,false],[401,3491,0,null,null,null,null,false],[401,3492,0,null,null,null,null,false],[401,3494,0,null,null,null,[56691,56692],false],[0,0,0,"ViewShare",null,null,null,false],[0,0,0,"ViewUnmap",null,null,null,false],[401,3499,0,null,null,null,null,false],[401,3500,0,null,null,null,null,false],[401,3501,0,null,null,null,null,false],[401,3502,0,null,null,null,null,false],[401,3503,0,null,null,null,null,false],[401,3504,0,null,null,null,null,false],[401,3512,0,null,null,null,null,false],[401,3513,0,null,null,null,null,false],[401,3514,0,null,null,null,null,false],[401,3515,0,null,null,null,null,false],[401,3516,0,null,null,null,null,false],[401,3517,0,null,null,null,null,false],[401,3518,0,null,null,null,null,false],[401,3519,0,null,null,null,null,false],[401,3520,0,null,null,null,null,false],[401,3521,0,null,null,null,null,false],[401,3523,0,null,null,null,null,false],[401,3525,0,null,null,null,null,false],[401,3529,0,null,null," Combines the STANDARD_RIGHTS_REQUIRED, KEY_QUERY_VALUE, KEY_SET_VALUE, KEY_CREATE_SUB_KEY,\n KEY_ENUMERATE_SUB_KEYS, KEY_NOTIFY, and KEY_CREATE_LINK access rights.",null,false],[401,3531,0,null,null," Reserved for system use.",null,false],[401,3533,0,null,null," Required to create a subkey of a registry key.",null,false],[401,3535,0,null,null," Required to enumerate the subkeys of a registry key.",null,false],[401,3537,0,null,null," Equivalent to KEY_READ.",null,false],[401,3539,0,null,null," Required to request change notifications for a registry key or for subkeys of a registry key.",null,false],[401,3541,0,null,null," Required to query the values of a registry key.",null,false],[401,3543,0,null,null," Combines the STANDARD_RIGHTS_READ, KEY_QUERY_VALUE, KEY_ENUMERATE_SUB_KEYS, and KEY_NOTIFY values.",null,false],[401,3545,0,null,null," Required to create, delete, or set a registry value.",null,false],[401,3548,0,null,null," Indicates that an application on 64-bit Windows should operate on the 32-bit registry view.\n This flag is ignored by 32-bit Windows.",null,false],[401,3551,0,null,null," Indicates that an application on 64-bit Windows should operate on the 64-bit registry view.\n This flag is ignored by 32-bit Windows.",null,false],[401,3553,0,null,null," Combines the STANDARD_RIGHTS_WRITE, KEY_SET_VALUE, and KEY_CREATE_SUB_KEY access rights.",null,false],[401,3556,0,null,null," Open symbolic link.",null,false],[401,3558,0,null,null,null,[56726,56728,56730,56732,56734,56736,56738],false],[401,3558,0,null,null,null,null,false],[0,0,0,"QueryRoutine",null,null,null,false],[401,3558,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,3558,0,null,null,null,null,false],[0,0,0,"Name",null,null,null,false],[401,3558,0,null,null,null,null,false],[0,0,0,"EntryContext",null,null,null,false],[401,3558,0,null,null,null,null,false],[0,0,0,"DefaultType",null,null,null,false],[401,3558,0,null,null,null,null,false],[0,0,0,"DefaultData",null,null,null,false],[401,3558,0,null,null,null,null,false],[0,0,0,"DefaultLength",null,null,null,false],[401,3568,0,null,null,null,[56740,56741,56742,56743,56744,56745],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[401,3578,0,null,null," Path is a full path",null,false],[401,3580,0,null,null," \\Registry\\Machine\\System\\CurrentControlSet\\Services",null,false],[401,3582,0,null,null," \\Registry\\Machine\\System\\CurrentControlSet\\Control",null,false],[401,3584,0,null,null," \\Registry\\Machine\\Software\\Microsoft\\Windows NT\\CurrentVersion",null,false],[401,3586,0,null,null," \\Registry\\Machine\\Hardware\\DeviceMap",null,false],[401,3588,0,null,null," \\Registry\\User\\CurrentUser",null,false],[401,3589,0,null,null,null,null,false],[401,3592,0,null,null," Low order bits are registry handle",null,false],[401,3594,0,null,null," Indicates the key node is optional",null,false],[401,3598,0,null,null," Name is a subkey and remainder of table or until next subkey are value\n names for that subkey to look at.",null,false],[401,3601,0,null,null," Reset current key to original key for this and all following table entries.",null,false],[401,3604,0,null,null," Fail if no match found for this table entry.",null,false],[401,3608,0,null,null," Used to mark a table entry that has no value name, just wants a call out, not\n an enumeration of all values.",null,false],[401,3612,0,null,null," Used to suppress the expansion of REG_MULTI_SZ into multiple callouts or\n to prevent the expansion of environment variable values in REG_EXPAND_SZ.",null,false],[401,3618,0,null,null," QueryRoutine field ignored.  EntryContext field points to location to store value.\n For null terminated strings, EntryContext points to UNICODE_STRING structure that\n that describes maximum size of buffer. If .Buffer field is NULL then a buffer is\n allocated.",null,false],[401,3621,0,null,null," Used to delete value keys after they are queried.",null,false],[401,3626,0,null,null," Use this flag with the RTL_QUERY_REGISTRY_DIRECT flag to verify that the REG_XXX type\n of the stored registry value matches the type expected by the caller.\n If the types do not match, the call fails.",null,false],[401,3628,0,null,null,null,[],false],[401,3630,0,null,null," No value type",null,false],[401,3632,0,null,null," Unicode nul terminated string",null,false],[401,3634,0,null,null," Unicode nul terminated string (with environment variable references)",null,false],[401,3636,0,null,null," Free form binary",null,false],[401,3638,0,null,null," 32-bit number",null,false],[401,3640,0,null,null," 32-bit number (same as REG_DWORD)",null,false],[401,3642,0,null,null," 32-bit number",null,false],[401,3644,0,null,null," Symbolic Link (unicode)",null,false],[401,3646,0,null,null," Multiple Unicode strings",null,false],[401,3648,0,null,null," Resource list in the resource map",null,false],[401,3650,0,null,null," Resource list in the hardware description",null,false],[401,3651,0,null,null,null,null,false],[401,3653,0,null,null," 64-bit number",null,false],[401,3655,0,null,null," 64-bit number (same as REG_QWORD)",null,false],[401,3658,0,null,null,null,[56780,56782,56784],false],[401,3658,0,null,null,null,null,false],[0,0,0,"NextEntryOffset",null,null,null,false],[401,3658,0,null,null,null,null,false],[0,0,0,"Action",null,null,null,false],[401,3658,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,3666,0,null,null,null,null,false],[401,3667,0,null,null,null,null,false],[401,3668,0,null,null,null,null,false],[401,3669,0,null,null,null,null,false],[401,3670,0,null,null,null,null,false],[401,3672,0,null,null,null,[56791,56792,56793],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[401,3674,0,null,null,null,null,false],[401,3675,0,null,null,null,null,false],[401,3676,0,null,null,null,null,false],[401,3677,0,null,null,null,null,false],[401,3678,0,null,null,null,null,false],[401,3679,0,null,null,null,null,false],[401,3680,0,null,null,null,null,false],[401,3681,0,null,null,null,null,false],[401,3683,0,null,null,null,[56804,56806,56808,56810,56812],false],[401,3683,0,null,null,null,null,false],[0,0,0,"dwSize",null,null,null,false],[401,3683,0,null,null,null,null,false],[0,0,0,"dwCursorPosition",null,null,null,false],[401,3683,0,null,null,null,null,false],[0,0,0,"wAttributes",null,null,null,false],[401,3683,0,null,null,null,null,false],[0,0,0,"srWindow",null,null,null,false],[401,3683,0,null,null,null,null,false],[0,0,0,"dwMaximumWindowSize",null,null,null,false],[401,3691,0,null,null,null,null,false],[401,3693,0,null,null,null,null,false],[401,3694,0,null,null,null,null,false],[401,3695,0,null,null,null,null,false],[401,3696,0,null,null,null,null,false],[401,3698,0,null,null,null,[56820,56822],false],[401,3698,0,null,null,null,null,false],[0,0,0,"Flink",null,null,null,false],[401,3698,0,null,null,null,null,false],[0,0,0,"Blink",null,null,null,false],[401,3703,0,null,null,null,[56825,56827,56829,56831,56833,56835,56837,56839,56841],false],[401,3703,0,null,null,null,null,false],[0,0,0,"Type",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"CreatorBackTraceIndex",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"CriticalSection",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"ProcessLocksList",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"EntryCount",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"ContentionCount",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"CreatorBackTraceIndexHigh",null,null,null,false],[401,3703,0,null,null,null,null,false],[0,0,0,"SpareWORD",null,null,null,false],[401,3715,0,null,null,null,[56844,56846,56848,56850,56852,56854],false],[401,3715,0,null,null,null,null,false],[0,0,0,"DebugInfo",null,null,null,false],[401,3715,0,null,null,null,null,false],[0,0,0,"LockCount",null,null,null,false],[401,3715,0,null,null,null,null,false],[0,0,0,"RecursionCount",null,null,null,false],[401,3715,0,null,null,null,null,false],[0,0,0,"OwningThread",null,null,null,false],[401,3715,0,null,null,null,null,false],[0,0,0,"LockSemaphore",null,null,null,false],[401,3715,0,null,null,null,null,false],[0,0,0,"SpinCount",null,null,null,false],[401,3724,0,null,null,null,null,false],[401,3725,0,null,null,null,null,false],[401,3726,0,null,null,null,null,false],[401,3727,0,null,null,null,[56859,56860,56861],false],[0,0,0,"InitOnce",null,"",null,false],[0,0,0,"Parameter",null,"",null,false],[0,0,0,"Context",null,"",null,false],[401,3729,0,null,null,null,[56864],false],[401,3729,0,null,null,null,null,false],[0,0,0,"Ptr",null,null,null,false],[401,3733,0,null,null,null,null,false],[401,3735,0,null,null,null,[],false],[401,3736,0,null,null,null,null,false],[401,3737,0,null,null,null,null,false],[401,3738,0,null,null,null,null,false],[401,3739,0,null,null,null,null,false],[401,3742,0,null,null,null,[56873,56875,56877,56879,56881,56883,56885,56887],false],[401,3742,0,null,null,null,null,false],[0,0,0,"BaseAddress",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"AllocationBase",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"AllocationProtect",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"PartitionId",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"RegionSize",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"State",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"Protect",null,null,null,false],[401,3742,0,null,null,null,null,false],[0,0,0,"Type",null,null,null,false],[401,3753,0,null,null,null,null,false],[401,3759,0,null,null," > The maximum path of 32,767 characters is approximate, because the \"\\\\?\\\"\n > prefix may be expanded to a longer string by the system at run time, and\n > this expansion applies to the total length.\n from https://docs.microsoft.com/en-us/windows/desktop/FileIO/naming-a-file#maximum-path-length-limitation",null,false],[401,3777,0,null,null," > [Each file name component can be] up to the value returned in the\n > lpMaximumComponentLength parameter of the GetVolumeInformation function\n > (this value is commonly 255 characters)\n from https://learn.microsoft.com/en-us/windows/win32/fileio/maximum-file-path-limitation\n\n > The value that is stored in the variable that *lpMaximumComponentLength points to is\n > used to indicate that a specified file system supports long names. For example, for\n > a FAT file system that supports long names, the function stores the value 255, rather\n > than the previous 8.3 indicator. Long names can also be supported on systems that use\n > the NTFS file system.\n from https://learn.microsoft.com/en-us/windows/win32/api/fileapi/nf-fileapi-getvolumeinformationw\n\n The assumption being made here is that while lpMaximumComponentLength may vary, it will never\n be larger than 255.\n\n TODO: More verification of this assumption.",null,false],[401,3779,0,null,null,null,null,false],[401,3780,0,null,null,null,null,false],[401,3781,0,null,null,null,null,false],[401,3782,0,null,null,null,null,false],[401,3783,0,null,null,null,null,false],[401,3784,0,null,null,null,null,false],[401,3785,0,null,null,null,null,false],[401,3787,0,null,null,null,null,false],[401,3788,0,null,null,null,null,false],[401,3789,0,null,null,null,null,false],[401,3790,0,null,null,null,null,false],[401,3791,0,null,null,null,null,false],[401,3793,0,null,null,null,[56904,56905,56907,56909,56910,56912],false],[0,0,0,"ExceptionCode",null,null,null,false],[0,0,0,"ExceptionFlags",null,null,null,false],[401,3793,0,null,null,null,null,false],[0,0,0,"ExceptionRecord",null,null,null,false],[401,3793,0,null,null,null,null,false],[0,0,0,"ExceptionAddress",null,null,null,false],[0,0,0,"NumberParameters",null,null,null,false],[401,3793,0,null,null,null,null,false],[0,0,0,"ExceptionInformation",null,null,null,false],[401,4088,0,null,null,null,[56915,56917],false],[401,4088,0,null,null,null,null,false],[0,0,0,"ExceptionRecord",null,null,null,false],[401,4088,0,null,null,null,null,false],[0,0,0,"ContextRecord",null,null,null,false],[401,4093,0,null,null,null,[56919],false],[0,0,0,"ExceptionInfo",null,"",null,false],[401,4095,0,null,null,null,null,false],[401,4096,0,null,null,null,[56922,56923,56924,56925],false],[0,0,0,"ExceptionRecord",null,"",null,false],[0,0,0,"EstablisherFrame",null,"",null,false],[0,0,0,"ContextRecord",null,"",null,false],[0,0,0,"DispatcherContext",null,"",null,false],[401,4103,0,null,null,null,null,false],[401,4104,0,null,null,null,[56929,56931],false],[401,4104,0,null,null,null,null,false],[0,0,0,"ImageBase",null,null,null,false],[401,4104,0,null,null,null,null,false],[0,0,0,"FunctionEntry",null,null,null,false],[401,4109,0,null,null,null,[56934,56936,56938,56940,56942,56944,56946,56948],false],[401,4109,0,null,null,null,null,false],[0,0,0,"Count",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"LocalHint",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"GlobalHint",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"Search",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"Once",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"LowAddress",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"HighAddress",null,null,null,false],[401,4109,0,null,null,null,null,false],[0,0,0,"Entry",null,null,null,false],[401,4120,0,null,null,null,null,false],[401,4121,0,null,null,null,null,false],[401,4122,0,null,null,null,null,false],[401,4123,0,null,null,null,null,false],[401,4125,0,null,null,null,[56955,56957,56959,56961,56963,56965],false],[401,4125,0,null,null,null,null,false],[0,0,0,"Length",null,null,null,false],[401,4125,0,null,null,null,null,false],[0,0,0,"RootDirectory",null,null,null,false],[401,4125,0,null,null,null,null,false],[0,0,0,"ObjectName",null,null,null,false],[401,4125,0,null,null,null,null,false],[0,0,0,"Attributes",null,null,null,false],[401,4125,0,null,null,null,null,false],[0,0,0,"SecurityDescriptor",null,null,null,false],[401,4125,0,null,null,null,null,false],[0,0,0,"SecurityQualityOfService",null,null,null,false],[401,4134,0,null,null,null,null,false],[401,4135,0,null,null,null,null,false],[401,4136,0,null,null,null,null,false],[401,4137,0,null,null,null,null,false],[401,4138,0,null,null,null,null,false],[401,4139,0,null,null,null,null,false],[401,4140,0,null,null,null,null,false],[401,4141,0,null,null,null,null,false],[401,4143,0,null,null,null,[56975,56976,56978],false],[0,0,0,"Length",null,null,null,false],[0,0,0,"MaximumLength",null,null,null,false],[401,4143,0,null,null,null,null,false],[0,0,0,"Buffer",null,null,null,false],[401,4149,0,null,null,null,null,false],[401,4150,0,null,null,null,null,false],[401,4151,0,null,null,null,null,false],[401,4152,0,null,null,null,null,false],[401,4153,0,null,null,null,null,false],[401,4154,0,null,null,null,null,false],[401,4156,0,null,null,null,[56987,56989],false],[401,4156,0,null,null,null,null,false],[0,0,0,"UniqueProcess",null,null,null,false],[401,4156,0,null,null,null,null,false],[0,0,0,"UniqueThread",null,null,null,false],[401,4161,0,null,null,null,[56992,56994,56996,56998,57000,57002],false],[401,4161,0,null,null,null,null,false],[0,0,0,"ExitStatus",null,null,null,false],[401,4161,0,null,null,null,null,false],[0,0,0,"TebBaseAddress",null,null,null,false],[401,4161,0,null,null,null,null,false],[0,0,0,"ClientId",null,null,null,false],[401,4161,0,null,null,null,null,false],[0,0,0,"AffinityMask",null,null,null,false],[401,4161,0,null,null,null,null,false],[0,0,0,"Priority",null,null,null,false],[401,4161,0,null,null,null,null,false],[0,0,0,"BasePriority",null,null,null,false],[401,4170,0,null,null,null,[57005,57007,57009,57011,57013,57015,57017,57019,57021,57023],false],[401,4170,0,null,null,null,null,false],[0,0,0,"Reserved1",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"ProcessEnvironmentBlock",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"Reserved2",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"Reserved3",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"TlsSlots",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"Reserved4",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"Reserved5",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"ReservedForOle",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"Reserved6",null,null,null,false],[401,4170,0,null,null,null,null,false],[0,0,0,"TlsExpansionSlots",null,null,null,false],[401,4183,0,null,null,null,[57026,57028],false],[401,4183,0,null,null,null,null,false],[0,0,0,"Next",null,null,null,false],[401,4183,0,null,null,null,null,false],[0,0,0,"Handler",null,null,null,false],[401,4188,0,null,null,null,[57031,57033,57035,57037,57041,57043,57045],false],[401,4188,0,null,null,null,null,false],[0,0,0,"ExceptionList",null,null,null,false],[401,4188,0,null,null,null,null,false],[0,0,0,"StackBase",null,null,null,false],[401,4188,0,null,null,null,null,false],[0,0,0,"StackLimit",null,null,null,false],[401,4188,0,null,null,null,null,false],[0,0,0,"SubSystemTib",null,null,null,false],[401,4188,0,null,null,null,[57039,57040],false],[0,0,0,"FiberData",null,null,null,false],[0,0,0,"Version",null,null,null,false],[0,0,0,"DUMMYUNIONNAME",null,null,null,false],[401,4188,0,null,null,null,null,false],[0,0,0,"ArbitraryUserPointer",null,null,null,false],[401,4188,0,null,null,null,null,false],[0,0,0,"Self",null,null,null,false],[401,4202,0,null,null," Process Environment Block\n Microsoft documentation of this is incomplete, the fields here are taken from various resources including:\n  - https://github.com/wine-mirror/wine/blob/1aff1e6a370ee8c0213a0fd4b220d121da8527aa/include/winternl.h#L269\n  - https://www.geoffchappell.com/studies/windows/win32/ntdll/structs/peb/index.htm",[57048,57050,57052,57054,57056,57058,57060,57062,57064,57066,57068,57070,57072,57074,57078,57080,57082,57084,57086,57088,57090,57092,57094,57096,57098,57100,57102,57104,57106,57108,57110,57112,57114,57116,57118,57120,57122,57124,57126,57128,57130,57132,57134,57136,57138,57140,57142,57144,57146,57148,57150,57152,57154,57156,57158,57160,57162,57164,57166,57168,57170,57172,57174,57176,57178,57180,57182,57184,57186,57188,57190,57192,57194,57196,57198,57200,57202,57204,57206,57208,57210],false],[401,4202,0,null,null,null,null,false],[0,0,0,"InheritedAddressSpace",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ReadImageFileExecOptions",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"BeingDebugged",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"BitField",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"Mutant",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ImageBaseAddress",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"Ldr",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ProcessParameters",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"SubSystemData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ProcessHeap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"FastPebLock",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"AtlThunkSListPtr",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"IFEOKey",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"CrossProcessFlags",null," https://www.geoffchappell.com/studies/windows/win32/ntdll/structs/peb/crossprocessflags.htm",null,false],[401,4202,0,null,null,null,[57076,57077],false],[0,0,0,"KernelCallbackTable",null,null,null,false],[0,0,0,"UserSharedInfoPtr",null,null,null,false],[0,0,0,"union1",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"SystemReserved",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"AtlThunkSListPtr32",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ApiSetMap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TlsExpansionCounter",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TlsBitmap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TlsBitmapBits",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ReadOnlySharedMemoryBase",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"SharedData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ReadOnlyStaticServerData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"AnsiCodePageData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"OemCodePageData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"UnicodeCaseTableData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"NumberOfProcessors",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"NtGlobalFlag",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"CriticalSectionTimeout",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"HeapSegmentReserve",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"HeapSegmentCommit",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"HeapDeCommitTotalFreeThreshold",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"HeapDeCommitFreeBlockThreshold",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"NumberOfHeaps",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"MaximumNumberOfHeaps",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ProcessHeaps",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"GdiSharedHandleTable",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ProcessStarterHelper",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"GdiDCAttributeList",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"LoaderLock",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"OSMajorVersion",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"OSMinorVersion",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"OSBuildNumber",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"OSCSDVersion",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"OSPlatformId",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ImageSubSystem",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ImageSubSystemMajorVersion",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ImageSubSystemMinorVersion",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ActiveProcessAffinityMask",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"GdiHandleBuffer",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"PostProcessInitRoutine",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TlsExpansionBitmap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TlsExpansionBitmapBits",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"SessionId",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"AppCompatFlags",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"AppCompatFlagsUser",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ShimData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"AppCompatInfo",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"CSDVersion",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ActivationContextData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"ProcessAssemblyStorageMap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"SystemDefaultActivationData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"SystemAssemblyStorageMap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"MinimumStackCommit",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"FlsCallback",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"FlsListHead",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"FlsBitmap",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"FlsBitmapBits",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"FlsHighIndex",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"WerRegistrationData",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"WerShipAssertPtr",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"pUnused",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"pImageHeaderHash",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TracingFlags",null," TODO: https://www.geoffchappell.com/studies/windows/win32/ntdll/structs/peb/tracingflags.htm",null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"CsrServerReadOnlySharedMemoryBase",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TppWorkerpListLock",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TppWorkerpList",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"WaitOnAddressHashTable",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"TelemetryCoverageHeader",null,null,null,false],[401,4202,0,null,null,null,null,false],[0,0,0,"CloudFileFlags",null,null,null,false],[401,4363,0,null,null," The `PEB_LDR_DATA` structure is the main record of what modules are loaded in a process.\n It is essentially the head of three double-linked lists of `LDR_DATA_TABLE_ENTRY` structures which each represent one loaded module.\n\n Microsoft documentation of this is incomplete, the fields here are taken from various resources including:\n  - https://www.geoffchappell.com/studies/windows/win32/ntdll/structs/peb_ldr_data.htm",[57213,57215,57217,57219,57221,57223,57225,57227,57229],false],[401,4363,0,null,null,null,null,false],[0,0,0,"Length",null," The size in bytes of the structure",null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"Initialized",null," TRUE if the structure is prepared.",null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"SsHandle",null,null,null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"InLoadOrderModuleList",null,null,null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"InMemoryOrderModuleList",null,null,null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"InInitializationOrderModuleList",null,null,null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"EntryInProgress",null," No known use of this field is known in Windows 8 and higher.",null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"ShutdownInProgress",null,null,null,false],[401,4363,0,null,null,null,null,false],[0,0,0,"ShutdownThreadId",null," Though ShutdownThreadId is declared as a HANDLE,\n it is indeed the thread ID as suggested by its name.\n It is picked up from the UniqueThread member of the CLIENT_ID in the\n TEB of the thread that asks to terminate the process.",null,false],[401,4394,0,null,null," Microsoft documentation of this is incomplete, the fields here are taken from various resources including:\n  - https://docs.microsoft.com/en-us/windows/win32/api/winternl/ns-winternl-peb_ldr_data\n  - https://www.geoffchappell.com/studies/windows/km/ntoskrnl/inc/api/ntldr/ldr_data_table_entry.htm",[57232,57234,57236,57238,57240,57242,57244,57246,57248,57252,57254],false],[401,4394,0,null,null,null,null,false],[0,0,0,"Reserved1",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"InMemoryOrderLinks",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"Reserved2",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"DllBase",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"EntryPoint",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"SizeOfImage",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"FullDllName",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"Reserved4",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"Reserved5",null,null,null,false],[401,4394,0,null,null,null,[57250,57251],false],[0,0,0,"CheckSum",null,null,null,false],[0,0,0,"Reserved6",null,null,null,false],[0,0,0,"DUMMYUNIONNAME",null,null,null,false],[401,4394,0,null,null,null,null,false],[0,0,0,"TimeDateStamp",null,null,null,false],[401,4411,0,null,null,null,[57257,57259,57261,57263,57265,57267,57269,57271,57273,57275,57277,57279,57281,57283,57285,57287,57289,57291,57293,57295,57297,57299,57301,57303,57305,57307,57309,57311],false],[401,4411,0,null,null,null,null,false],[0,0,0,"AllocationSize",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"Size",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"DebugFlags",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"ConsoleHandle",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"ConsoleFlags",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"hStdInput",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"hStdOutput",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"hStdError",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"CurrentDirectory",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"DllPath",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"ImagePathName",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"CommandLine",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"Environment",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwX",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwY",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwXSize",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwYSize",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwXCountChars",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwYCountChars",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwFillAttribute",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwFlags",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"dwShowWindow",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"WindowTitle",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"Desktop",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"ShellInfo",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"RuntimeInfo",null,null,null,false],[401,4411,0,null,null,null,null,false],[0,0,0,"DLCurrentDirectory",null,null,null,false],[401,4442,0,null,null,null,[57313,57314,57316,57318],false],[0,0,0,"Flags",null,null,null,false],[0,0,0,"Length",null,null,null,false],[401,4442,0,null,null,null,null,false],[0,0,0,"TimeStamp",null,null,null,false],[401,4442,0,null,null,null,null,false],[0,0,0,"DosPath",null,null,null,false],[401,4449,0,null,null,null,[],false],[401,4451,0,null,null,null,[57322,57324,57326,57328,57330,57332,57334,57336,57338,57340,57342],false],[401,4451,0,null,null,null,null,false],[0,0,0,"NextEntryOffset",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"FileIndex",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"CreationTime",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"LastAccessTime",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"LastWriteTime",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"ChangeTime",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"EndOfFile",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"AllocationSize",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"FileAttributes",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,4451,0,null,null,null,null,false],[0,0,0,"FileName",null,null,null,false],[401,4465,0,null,null,null,[57345,57347,57349,57351,57353,57355,57357,57359,57361,57363,57365,57367,57369,57371],false],[401,4465,0,null,null,null,null,false],[0,0,0,"NextEntryOffset",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"FileIndex",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"CreationTime",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"LastAccessTime",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"LastWriteTime",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"ChangeTime",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"EndOfFile",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"AllocationSize",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"FileAttributes",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"FileNameLength",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"EaSize",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"ShortNameLength",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"ShortName",null,null,null,false],[401,4465,0,null,null,null,null,false],[0,0,0,"FileName",null,null,null,false],[401,4481,0,null,null,null,null,false],[401,4485,0,null,null," Helper for iterating a byte buffer of FILE_*_INFORMATION structures (from\n things like NtQueryDirectoryFile calls).",[57374],false],[0,0,0,"FileInformationType",null,"",[57377,57379],true],[401,4490,0,null,null,null,[57376],false],[0,0,0,"self",null,"",null,false],[0,0,0,"byte_offset",null,null,null,false],[401,4486,0,null,null,null,null,false],[0,0,0,"buf",null,null,null,false],[401,4503,0,null,null,null,[57381,57382,57383],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[401,4505,0,null,null,null,[57386,57388],false],[401,4505,0,null,null,null,null,false],[0,0,0,"DosPath",null,null,null,false],[401,4505,0,null,null,null,null,false],[0,0,0,"Handle",null,null,null,false],[401,4510,0,null,null,null,null,false],[401,4512,0,null,null,null,[57392,57394,57396],false],[401,4512,0,null,null,null,null,false],[0,0,0,"lpBaseOfDll",null,null,null,false],[401,4512,0,null,null,null,null,false],[0,0,0,"SizeOfImage",null,null,null,false],[401,4512,0,null,null,null,null,false],[0,0,0,"EntryPoint",null,null,null,false],[401,4518,0,null,null,null,[57399,57401],false],[401,4518,0,null,null,null,null,false],[0,0,0,"FaultingPc",null,null,null,false],[401,4518,0,null,null,null,null,false],[0,0,0,"FaultingVa",null,null,null,false],[401,4523,0,null,null,null,[57404,57406,57408,57410,57412,57414,57416,57418,57420,57422,57424],false],[401,4523,0,null,null,null,null,false],[0,0,0,"PeakVirtualSize",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"VirtualSize",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"PageFaultCount",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"PeakWorkingSetSize",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"WorkingSetSize",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"QuotaPeakPagedPoolUsage",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"QuotaPagedPoolUsage",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"QuotaPeakNonPagedPoolUsage",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"QuotaNonPagedPoolUsage",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"PagefileUsage",null,null,null,false],[401,4523,0,null,null,null,null,false],[0,0,0,"PeakPagefileUsage",null,null,null,false],[401,4537,0,null,null,null,[57427,57429,57431,57433,57435,57437,57439,57441,57443,57445],false],[401,4537,0,null,null,null,null,false],[0,0,0,"cb",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"PageFaultCount",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"PeakWorkingSetSize",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"WorkingSetSize",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"QuotaPeakPagedPoolUsage",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"QuotaPagedPoolUsage",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"QuotaPeakNonPagedPoolUsage",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"QuotaNonPagedPoolUsage",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"PagefileUsage",null,null,null,false],[401,4537,0,null,null,null,null,false],[0,0,0,"PeakPagefileUsage",null,null,null,false],[401,4550,0,null,null,null,[57448,57450,57452,57454,57456,57458,57460,57462,57464,57466,57468],false],[401,4550,0,null,null,null,null,false],[0,0,0,"cb",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"PageFaultCount",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"PeakWorkingSetSize",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"WorkingSetSize",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"QuotaPeakPagedPoolUsage",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"QuotaPagedPoolUsage",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"QuotaPeakNonPagedPoolUsage",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"QuotaNonPagedPoolUsage",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"PagefileUsage",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"PeakPagefileUsage",null,null,null,false],[401,4550,0,null,null,null,null,false],[0,0,0,"PrivateUsage",null,null,null,false],[401,4564,0,null,null,null,null,false],[401,4570,0,null,null,null,[57471],false],[0,0,0,"hProcess",null,"",null,false],[401,4582,0,null,null,null,[57474,57476,57478,57480,57482,57484,57486,57488,57490,57492,57494,57496,57498,57500],false],[401,4582,0,null,null,null,null,false],[0,0,0,"cb",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"CommitTotal",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"CommitLimit",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"CommitPeak",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"PhysicalTotal",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"PhysicalAvailable",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"SystemCache",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"KernelTotal",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"KernelPaged",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"KernelNonpaged",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"PageSize",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"HandleCount",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"ProcessCount",null,null,null,false],[401,4582,0,null,null,null,null,false],[0,0,0,"ThreadCount",null,null,null,false],[401,4599,0,null,null,null,[57503,57505,57507,57509,57511],false],[401,4599,0,null,null,null,null,false],[0,0,0,"cb",null,null,null,false],[401,4599,0,null,null,null,null,false],[0,0,0,"Reserved",null,null,null,false],[401,4599,0,null,null,null,null,false],[0,0,0,"TotalSize",null,null,null,false],[401,4599,0,null,null,null,null,false],[0,0,0,"TotalInUse",null,null,null,false],[401,4599,0,null,null,null,null,false],[0,0,0,"PeakUsage",null,null,null,false],[401,4607,0,null,null,null,[57513,57514,57515],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[401,4608,0,null,null,null,[57517,57518,57519],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[401,4610,0,null,null,null,[57522,57524,57526],false],[401,4610,0,null,null,null,null,false],[0,0,0,"BasicInfo",null,null,null,false],[401,4610,0,null,null,null,null,false],[0,0,0,"FaultingThreadId",null,null,null,false],[401,4610,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,4616,0,null,null,null,[57529,57531,57533,57535,57537,57539],false],[401,4616,0,null,null,null,null,false],[0,0,0,"dwOSVersionInfoSize",null,null,null,false],[401,4616,0,null,null,null,null,false],[0,0,0,"dwMajorVersion",null,null,null,false],[401,4616,0,null,null,null,null,false],[0,0,0,"dwMinorVersion",null,null,null,false],[401,4616,0,null,null,null,null,false],[0,0,0,"dwBuildNumber",null,null,null,false],[401,4616,0,null,null,null,null,false],[0,0,0,"dwPlatformId",null,null,null,false],[401,4616,0,null,null,null,null,false],[0,0,0,"szCSDVersion",null,null,null,false],[401,4624,0,null,null,null,null,false],[401,4626,0,null,null,null,[57543,57545,57547,57549],false],[401,4626,0,null,null,null,null,false],[0,0,0,"ReparseTag",null,null,null,false],[401,4626,0,null,null,null,null,false],[0,0,0,"ReparseDataLength",null,null,null,false],[401,4626,0,null,null,null,null,false],[0,0,0,"Reserved",null,null,null,false],[401,4626,0,null,null,null,null,false],[0,0,0,"DataBuffer",null,null,null,false],[401,4632,0,null,null,null,[57552,57554,57556,57558,57560,57562],false],[401,4632,0,null,null,null,null,false],[0,0,0,"SubstituteNameOffset",null,null,null,false],[401,4632,0,null,null,null,null,false],[0,0,0,"SubstituteNameLength",null,null,null,false],[401,4632,0,null,null,null,null,false],[0,0,0,"PrintNameOffset",null,null,null,false],[401,4632,0,null,null,null,null,false],[0,0,0,"PrintNameLength",null,null,null,false],[401,4632,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[401,4632,0,null,null,null,null,false],[0,0,0,"PathBuffer",null,null,null,false],[401,4640,0,null,null,null,[57565,57567,57569,57571,57573],false],[401,4640,0,null,null,null,null,false],[0,0,0,"SubstituteNameOffset",null,null,null,false],[401,4640,0,null,null,null,null,false],[0,0,0,"SubstituteNameLength",null,null,null,false],[401,4640,0,null,null,null,null,false],[0,0,0,"PrintNameOffset",null,null,null,false],[401,4640,0,null,null,null,null,false],[0,0,0,"PrintNameLength",null,null,null,false],[401,4640,0,null,null,null,null,false],[0,0,0,"PathBuffer",null,null,null,false],[401,4647,0,null,null,null,null,false],[401,4648,0,null,null,null,null,false],[401,4649,0,null,null,null,null,false],[401,4650,0,null,null,null,null,false],[401,4651,0,null,null,null,null,false],[401,4652,0,null,null,null,null,false],[401,4654,0,null,null,null,null,false],[401,4655,0,null,null,null,null,false],[401,4657,0,null,null,null,[57584,57586,57588,57590,57592,57594,57596,57598,57600],false],[401,4657,0,null,null,null,null,false],[0,0,0,"SymbolicLinkNameOffset",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"SymbolicLinkNameLength",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"Reserved1",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"UniqueIdOffset",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"UniqueIdLength",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"Reserved2",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"DeviceNameOffset",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"DeviceNameLength",null,null,null,false],[401,4657,0,null,null,null,null,false],[0,0,0,"Reserved3",null,null,null,false],[401,4668,0,null,null,null,[57603,57605,57607],false],[401,4668,0,null,null,null,null,false],[0,0,0,"Size",null,null,null,false],[401,4668,0,null,null,null,null,false],[0,0,0,"NumberOfMountPoints",null,null,null,false],[401,4668,0,null,null,null,null,false],[0,0,0,"MountPoints",null,null,null,false],[401,4673,0,null,null,null,null,false],[401,4675,0,null,null,null,[57610,57611,57612,57613,57614,57615,57616],false],[0,0,0,"ObjectBasicInformation",null,null,null,false],[0,0,0,"ObjectNameInformation",null,null,null,false],[0,0,0,"ObjectTypeInformation",null,null,null,false],[0,0,0,"ObjectTypesInformation",null,null,null,false],[0,0,0,"ObjectHandleFlagInformation",null,null,null,false],[0,0,0,"ObjectSessionInformation",null,null,null,false],[0,0,0,"MaxObjectInfoClass",null,null,null,false],[401,4685,0,null,null,null,[57619],false],[401,4685,0,null,null,null,null,false],[0,0,0,"Name",null,null,null,false],[401,4689,0,null,null,null,null,false],[401,4690,0,null,null,null,[57623],false],[401,4690,0,null,null,null,null,false],[0,0,0,"Ptr",null,null,null,false],[401,4694,0,null,null,null,null,false],[401,4695,0,null,null,null,[57627],false],[401,4695,0,null,null,null,null,false],[0,0,0,"Ptr",null,null,null,false],[401,4699,0,null,null,null,null,false],[401,4700,0,null,null,null,null,false],[401,4702,0,null,null,null,null,false],[401,4703,0,null,null,null,null,false],[401,4704,0,null,null,null,null,false],[401,4705,0,null,null,null,null,false],[401,4706,0,null,null,null,null,false],[401,4708,0,null,null,null,[57636],false],[0,0,0,"dwCtrlType",null,"",null,false],[401,4711,0,null,null," Processor feature enumeration.",[57638,57639,57640,57641,57642,57643,57644,57645,57646,57647,57648,57649,57650,57651,57652,57653,57654,57655,57656,57657,57658,57659,57660,57661,57662,57663,57664,57665,57666,57667,57668,57669,57670,57671,57672,57673,57674,57675,57676,57677,57678,57679,57680,57681,57682],false],[0,0,0,"FLOATING_POINT_PRECISION_ERRATA",null," On a Pentium, a floating-point precision error can occur in rare circumstances.",null,false],[0,0,0,"FLOATING_POINT_EMULATED",null," Floating-point operations are emulated using software emulator.\n This function returns a nonzero value if floating-point operations are emulated; otherwise, it returns zero.",null,false],[0,0,0,"COMPARE_EXCHANGE_DOUBLE",null," The atomic compare and exchange operation (cmpxchg) is available.",null,false],[0,0,0,"MMX_INSTRUCTIONS_AVAILABLE",null," The MMX instruction set is available.",null,false],[0,0,0,"PPC_MOVEMEM_64BIT_OK",null,null,null,false],[0,0,0,"ALPHA_BYTE_INSTRUCTIONS",null,null,null,false],[0,0,0,"XMMI_INSTRUCTIONS_AVAILABLE",null," The SSE instruction set is available.",null,false],[0,0,0,"3DNOW_INSTRUCTIONS_AVAILABLE",null," The 3D-Now instruction is available.",null,false],[0,0,0,"RDTSC_INSTRUCTION_AVAILABLE",null," The RDTSC instruction is available.",null,false],[0,0,0,"PAE_ENABLED",null," The processor is PAE-enabled.",null,false],[0,0,0,"XMMI64_INSTRUCTIONS_AVAILABLE",null," The SSE2 instruction set is available.",null,false],[0,0,0,"SSE_DAZ_MODE_AVAILABLE",null,null,null,false],[0,0,0,"NX_ENABLED",null," Data execution prevention is enabled.",null,false],[0,0,0,"SSE3_INSTRUCTIONS_AVAILABLE",null," The SSE3 instruction set is available.",null,false],[0,0,0,"COMPARE_EXCHANGE128",null," The atomic compare and exchange 128-bit operation (cmpxchg16b) is available.",null,false],[0,0,0,"COMPARE64_EXCHANGE128",null," The atomic compare 64 and exchange 128-bit operation (cmp8xchg16) is available.",null,false],[0,0,0,"CHANNELS_ENABLED",null," The processor channels are enabled.",null,false],[0,0,0,"XSAVE_ENABLED",null," The processor implements the XSAVI and XRSTOR instructions.",null,false],[0,0,0,"ARM_VFP_32_REGISTERS_AVAILABLE",null," The VFP/Neon: 32 x 64bit register bank is present.\n This flag has the same meaning as PF_ARM_VFP_EXTENDED_REGISTERS.",null,false],[0,0,0,"ARM_NEON_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8 NEON instruction set.",null,false],[0,0,0,"SECOND_LEVEL_ADDRESS_TRANSLATION",null," Second Level Address Translation is supported by the hardware.",null,false],[0,0,0,"VIRT_FIRMWARE_ENABLED",null," Virtualization is enabled in the firmware and made available by the operating system.",null,false],[0,0,0,"RDWRFSGBASE_AVAILABLE",null," RDFSBASE, RDGSBASE, WRFSBASE, and WRGSBASE instructions are available.",null,false],[0,0,0,"FASTFAIL_AVAILABLE",null," _fastfail() is available.",null,false],[0,0,0,"ARM_DIVIDE_INSTRUCTION_AVAILABLE",null," The divide instruction_available.",null,false],[0,0,0,"ARM_64BIT_LOADSTORE_ATOMIC",null," The 64-bit load/store atomic instructions are available.",null,false],[0,0,0,"ARM_EXTERNAL_CACHE_AVAILABLE",null," The external cache is available.",null,false],[0,0,0,"ARM_FMAC_INSTRUCTIONS_AVAILABLE",null," The floating-point multiply-accumulate instruction is available.",null,false],[0,0,0,"RDRAND_INSTRUCTION_AVAILABLE",null,null,null,false],[0,0,0,"ARM_V8_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8 instructions set.",null,false],[0,0,0,"ARM_V8_CRYPTO_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8 extra cryptographic instructions (i.e., AES, SHA1 and SHA2).",null,false],[0,0,0,"ARM_V8_CRC32_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8 extra CRC32 instructions.",null,false],[0,0,0,"RDTSCP_INSTRUCTION_AVAILABLE",null,null,null,false],[0,0,0,"RDPID_INSTRUCTION_AVAILABLE",null,null,null,false],[0,0,0,"ARM_V81_ATOMIC_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8.1 atomic instructions (e.g., CAS, SWP).",null,false],[0,0,0,"MONITORX_INSTRUCTION_AVAILABLE",null,null,null,false],[0,0,0,"SSSE3_INSTRUCTIONS_AVAILABLE",null," The SSSE3 instruction set is available.",null,false],[0,0,0,"SSE4_1_INSTRUCTIONS_AVAILABLE",null," The SSE4_1 instruction set is available.",null,false],[0,0,0,"SSE4_2_INSTRUCTIONS_AVAILABLE",null," The SSE4_2 instruction set is available.",null,false],[0,0,0,"AVX_INSTRUCTIONS_AVAILABLE",null," The AVX instruction set is available.",null,false],[0,0,0,"AVX2_INSTRUCTIONS_AVAILABLE",null," The AVX2 instruction set is available.",null,false],[0,0,0,"AVX512F_INSTRUCTIONS_AVAILABLE",null," The AVX512F instruction set is available.",null,false],[0,0,0,"ERMS_AVAILABLE",null,null,null,false],[0,0,0,"ARM_V82_DP_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8.2 Dot Product (DP) instructions.",null,false],[0,0,0,"ARM_V83_JSCVT_INSTRUCTIONS_AVAILABLE",null," This ARM processor implements the ARM v8.3 JavaScript conversion (JSCVT) instructions.",null,false],[401,4840,0,null,null,null,null,false],[401,4841,0,null,null,null,null,false],[401,4842,0,null,null,null,null,false],[401,4844,0,null,null,null,[57688,57690,57692],false],[401,4844,0,null,null,null,null,false],[0,0,0,"LowPart",null,null,null,false],[401,4844,0,null,null,null,null,false],[0,0,0,"High1Time",null,null,null,false],[401,4844,0,null,null,null,null,false],[0,0,0,"High2Time",null,null,null,false],[401,4850,0,null,null,null,[57694,57695,57696],false],[0,0,0,"NtProductWinNt",null,null,null,false],[0,0,0,"NtProductLanManNt",null,null,null,false],[0,0,0,"NtProductServer",null,null,null,false],[401,4856,0,null,null,null,[57698,57699,57700],false],[0,0,0,"StandardDesign",null,null,null,false],[0,0,0,"NEC98x86",null,null,null,false],[0,0,0,"EndAlternatives",null,null,null,false],[401,4862,0,null,null,null,[57703,57705],false],[401,4862,0,null,null,null,null,false],[0,0,0,"Offset",null,null,null,false],[401,4862,0,null,null,null,null,false],[0,0,0,"Size",null,null,null,false],[401,4867,0,null,null,null,[57708,57710,57712,57714],false],[401,4867,0,null,null,null,null,false],[0,0,0,"EnabledFeatures",null,null,null,false],[401,4867,0,null,null,null,null,false],[0,0,0,"Size",null,null,null,false],[401,4867,0,null,null,null,null,false],[0,0,0,"OptimizedSave",null,null,null,false],[401,4867,0,null,null,null,null,false],[0,0,0,"Features",null,null,null,false],[401,4875,0,null,null," Shared Kernel User Data",[57717,57719,57721,57723,57725,57727,57729,57731,57733,57735,57737,57739,57741,57743,57745,57747,57749,57751,57753,57755,57757,57759,57761,57763,57765,57767,57769,57771,57773,57775,57777,57779,57781,57793,57795,57797,57799,57801,57803,57805,57807,57815,57817,57834,57836,57838,57840,57842,57844,57846,57855,57857,57859,57861,57863,57865,57867,57869,57871,57873,57875,57877,57879,57881,57883,57885,57887,57889,57891,57893,57895,57897,57899,57907,57909,57911,57913,57915,57917,57919],false],[401,4875,0,null,null,null,null,false],[0,0,0,"TickCountLowDeprecated",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TickCountMultiplier",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"InterruptTime",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"SystemTime",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeZoneBias",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ImageNumberLow",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ImageNumberHigh",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NtSystemRoot",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"MaxStackTraceDepth",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"CryptoExponent",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeZoneId",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"LargePageMinimum",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"AitSamplingValue",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"AppCompatFlag",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"RNGSeedVersion",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"GlobalValidationRunlevel",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeZoneBiasStamp",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NtBuildNumber",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NtProductType",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ProductTypeIsValid",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved0",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NativeProcessorArchitecture",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NtMajorVersion",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NtMinorVersion",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ProcessorFeatures",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved1",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved3",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeSlip",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"AlternativeArchitecture",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"BootId",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"SystemExpirationDate",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"SuiteMaskY",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"KdDebuggerEnabled",null,null,null,false],[401,4875,0,null,null,null,[57783,57792],false],[0,0,0,"MitigationPolicies",null,null,[57785,57787,57789,57791],false],[401,4911,0,null,null,null,null,false],[0,0,0,"NXSupportPolicy",null,null,null,false],[401,4911,0,null,null,null,null,false],[0,0,0,"SEHValidationPolicy",null,null,null,false],[401,4911,0,null,null,null,null,false],[0,0,0,"CurDirDevicesSkippedForDlls",null,null,null,false],[401,4911,0,null,null,null,null,false],[0,0,0,"Reserved",null,null,null,false],[0,0,0,"Alt",null,null,null,false],[0,0,0,"DummyUnion1",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"CyclesPerYield",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ActiveConsoleId",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"DismountCount",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ComPlusPackage",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"LastSystemRITEventTickCount",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"NumberOfPhysicalPages",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"SafeBootMode",null,null,null,false],[401,4875,0,null,null,null,[57809,57814],false],[0,0,0,"VirtualizationFlags",null,null,[57810,57811,57813],false],[0,0,0,"ArchStartedInEl2",null,null,null,false],[0,0,0,"QcSlIsSupported",null,null,null,false],[401,4927,0,null,null,null,null,false],[0,0,0,"SpareBits",null,null,null,false],[0,0,0,"Alt",null,null,null,false],[0,0,0,"DummyUnion2",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved12",null,null,null,false],[401,4875,0,null,null,null,[57819,57833],false],[0,0,0,"SharedDataFlags",null,null,[57820,57821,57822,57823,57824,57825,57826,57827,57828,57829,57830,57832],false],[0,0,0,"DbgErrorPortPresent",null,null,null,false],[0,0,0,"DbgElevationEnabled",null,null,null,false],[0,0,0,"DbgVirtEnabled",null,null,null,false],[0,0,0,"DbgInstallerDetectEnabled",null,null,null,false],[0,0,0,"DbgLkgEnabled",null,null,null,false],[0,0,0,"DbgDynProcessorEnabled",null,null,null,false],[0,0,0,"DbgConsoleBrokerEnabled",null,null,null,false],[0,0,0,"DbgSecureBootEnabled",null,null,null,false],[0,0,0,"DbgMultiSessionSku",null,null,null,false],[0,0,0,"DbgMultiUsersInSessionSku",null,null,null,false],[0,0,0,"DbgStateSeparationEnabled",null,null,null,false],[401,4936,0,null,null,null,null,false],[0,0,0,"SpareBits",null,null,null,false],[0,0,0,"Alt",null,null,null,false],[0,0,0,"DummyUnion3",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"DataFlagsPad",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TestRetInstruction",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"QpcFrequency",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"SystemCall",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved2",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"SystemCallPad",null,null,null,false],[401,4875,0,null,null,null,[57848,57849,57854],false],[0,0,0,"TickCount",null,null,null,false],[0,0,0,"TickCountQuad",null,null,[57851,57853],false],[401,4960,0,null,null,null,null,false],[0,0,0,"ReservedTickCountOverlay",null,null,null,false],[401,4960,0,null,null,null,null,false],[0,0,0,"TickCountPad",null,null,null,false],[0,0,0,"Alt",null,null,null,false],[0,0,0,"DummyUnion4",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Cookie",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"CookiePad",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ConsoleSessionForegroundProcessId",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeUpdateLock",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"BaselineSystemTimeQpc",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"BaselineInterruptTimeQpc",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"QpcSystemTimeIncrement",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"QpcInterruptTimeIncrement",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"QpcSystemTimeIncrementShift",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"QpcInterruptTimeIncrementShift",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"UnparkedProcessorCount",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"EnclaveFeatureMask",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TelemetryCoverageRound",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"UserModeGlobalLogger",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ImageFileExecutionOptions",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"LangGenerationCount",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved4",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"InterruptTimeBias",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"QpcBias",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ActiveProcessorCount",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"ActiveGroupCount",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Reserved9",null,null,null,false],[401,4875,0,null,null,null,[57901,57906],false],[0,0,0,"QpcData",null,null,[57903,57905],false],[401,4989,0,null,null,null,null,false],[0,0,0,"QpcBypassEnabled",null,null,null,false],[401,4989,0,null,null,null,null,false],[0,0,0,"QpcShift",null,null,null,false],[0,0,0,"Alt",null,null,null,false],[0,0,0,"DummyUnion5",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeZoneBiasEffectiveStart",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"TimeZoneBiasEffectiveEnd",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"XState",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"FeatureConfigurationChangeStamp",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"Spare",null,null,null,false],[401,4875,0,null,null,null,null,false],[0,0,0,"UserPointerAuthMask",null,null,null,false],[401,5005,0,null,null," Read-only user-mode address for the shared data.\n https://www.geoffchappell.com/studies/windows/km/ntoskrnl/inc/api/ntexapi_x/kuser_shared_data/index.htm\n https://msrc-blog.microsoft.com/2022/04/05/randomizing-the-kuser_shared_data-structure-on-windows/",null,false],[401,5007,0,null,null,null,[57922],false],[0,0,0,"feature",null,"",null,false],[401,5012,0,null,null,null,null,false],[401,5013,0,null,null,null,null,false],[401,5014,0,null,null,null,null,false],[401,5015,0,null,null,null,null,false],[401,5016,0,null,null,null,null,false],[401,5017,0,null,null,null,null,false],[401,5018,0,null,null,null,null,false],[401,5020,0,null,null,null,null,false],[401,5021,0,null,null,null,[57933,57935,57937,57939,57941,57943,57945,57947,57949,57951],false],[401,5021,0,null,null,null,null,false],[0,0,0,"dwSize",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"th32ModuleID",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"th32ProcessID",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"GlblcntUsage",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"ProccntUsage",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"modBaseAddr",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"modBaseSize",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"hModule",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"szModule",null,null,null,false],[401,5021,0,null,null,null,null,false],[0,0,0,"szExePath",null,null,null,false],[401,5034,0,null,null,null,[57953,57954,57955,57956,57957,57958,57959,57960,57961,57962,57963],false],[0,0,0,"SystemBasicInformation",null,null,null,false],[0,0,0,"SystemPerformanceInformation",null,null,null,false],[0,0,0,"SystemTimeOfDayInformation",null,null,null,false],[0,0,0,"SystemProcessInformation",null,null,null,false],[0,0,0,"SystemProcessorPerformanceInformation",null,null,null,false],[0,0,0,"SystemInterruptInformation",null,null,null,false],[0,0,0,"SystemExceptionInformation",null,null,null,false],[0,0,0,"SystemRegistryQuotaInformation",null,null,null,false],[0,0,0,"SystemLookasideInformation",null,null,null,false],[0,0,0,"SystemCodeIntegrityInformation",null,null,null,false],[0,0,0,"SystemPolicyInformation",null,null,null,false],[401,5048,0,null,null,null,[57966,57968,57970,57972,57974,57976,57978,57980,57982,57984,57986],false],[401,5048,0,null,null,null,null,false],[0,0,0,"Reserved",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"TimerResolution",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"PageSize",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"NumberOfPhysicalPages",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"LowestPhysicalPageNumber",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"HighestPhysicalPageNumber",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"AllocationGranularity",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"MinimumUserModeAddress",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"MaximumUserModeAddress",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"ActiveProcessorsAffinityMask",null,null,null,false],[401,5048,0,null,null,null,null,false],[0,0,0,"NumberOfProcessors",null,null,null,false],[401,5062,0,null,null,null,[57988,57989,57990,57991,57992,57993,57994,57995,57996,57997,57998,57999,58000,58001,58002,58003,58004,58005,58006,58007,58008,58009,58010,58011,58012,58013,58014,58015,58016,58017,58018,58019,58020,58021,58022,58023,58024,58025,58026,58027,58028,58029],false],[0,0,0,"ThreadBasicInformation",null,null,null,false],[0,0,0,"ThreadTimes",null,null,null,false],[0,0,0,"ThreadPriority",null,null,null,false],[0,0,0,"ThreadBasePriority",null,null,null,false],[0,0,0,"ThreadAffinityMask",null,null,null,false],[0,0,0,"ThreadImpersonationToken",null,null,null,false],[0,0,0,"ThreadDescriptorTableEntry",null,null,null,false],[0,0,0,"ThreadEnableAlignmentFaultFixup",null,null,null,false],[0,0,0,"ThreadEventPair_Reusable",null,null,null,false],[0,0,0,"ThreadQuerySetWin32StartAddress",null,null,null,false],[0,0,0,"ThreadZeroTlsCell",null,null,null,false],[0,0,0,"ThreadPerformanceCount",null,null,null,false],[0,0,0,"ThreadAmILastThread",null,null,null,false],[0,0,0,"ThreadIdealProcessor",null,null,null,false],[0,0,0,"ThreadPriorityBoost",null,null,null,false],[0,0,0,"ThreadSetTlsArrayAddress",null,null,null,false],[0,0,0,"ThreadIsIoPending",null,null,null,false],[0,0,0,"ThreadHideFromDebugger",null,null,null,false],[0,0,0,"ThreadBreakOnTermination",null,null,null,false],[0,0,0,"ThreadSwitchLegacyState",null,null,null,false],[0,0,0,"ThreadIsTerminated",null,null,null,false],[0,0,0,"ThreadLastSystemCall",null,null,null,false],[0,0,0,"ThreadIoPriority",null,null,null,false],[0,0,0,"ThreadCycleTime",null,null,null,false],[0,0,0,"ThreadPagePriority",null,null,null,false],[0,0,0,"ThreadActualBasePriority",null,null,null,false],[0,0,0,"ThreadTebInformation",null,null,null,false],[0,0,0,"ThreadCSwitchMon",null,null,null,false],[0,0,0,"ThreadCSwitchPmu",null,null,null,false],[0,0,0,"ThreadWow64Context",null,null,null,false],[0,0,0,"ThreadGroupInformation",null,null,null,false],[0,0,0,"ThreadUmsInformation",null,null,null,false],[0,0,0,"ThreadCounterProfiling",null,null,null,false],[0,0,0,"ThreadIdealProcessorEx",null,null,null,false],[0,0,0,"ThreadCpuAccountingInformation",null,null,null,false],[0,0,0,"ThreadSuspendCount",null,null,null,false],[0,0,0,"ThreadHeterogeneousCpuPolicy",null,null,null,false],[0,0,0,"ThreadContainerId",null,null,null,false],[0,0,0,"ThreadNameInformation",null,null,null,false],[0,0,0,"ThreadSelectedCpuSets",null,null,null,false],[0,0,0,"ThreadSystemThreadInformation",null,null,null,false],[0,0,0,"ThreadActualGroupAffinity",null,null,null,false],[401,5114,0,null,null,null,[58031,58032,58033,58034,58035,58036,58037,58038,58039,58040,58041,58042,58043,58044,58045,58046,58047,58048,58049,58050,58051,58052,58053,58054,58055,58056,58057,58058,58059,58060,58061,58062,58063,58064,58065,58066,58067,58068,58069,58070,58071,58072,58073,58074,58075,58076,58077,58078,58079,58080,58081,58082],false],[0,0,0,"ProcessBasicInformation",null,null,null,false],[0,0,0,"ProcessQuotaLimits",null,null,null,false],[0,0,0,"ProcessIoCounters",null,null,null,false],[0,0,0,"ProcessVmCounters",null,null,null,false],[0,0,0,"ProcessTimes",null,null,null,false],[0,0,0,"ProcessBasePriority",null,null,null,false],[0,0,0,"ProcessRaisePriority",null,null,null,false],[0,0,0,"ProcessDebugPort",null,null,null,false],[0,0,0,"ProcessExceptionPort",null,null,null,false],[0,0,0,"ProcessAccessToken",null,null,null,false],[0,0,0,"ProcessLdtInformation",null,null,null,false],[0,0,0,"ProcessLdtSize",null,null,null,false],[0,0,0,"ProcessDefaultHardErrorMode",null,null,null,false],[0,0,0,"ProcessIoPortHandlers",null,null,null,false],[0,0,0,"ProcessPooledUsageAndLimits",null,null,null,false],[0,0,0,"ProcessWorkingSetWatch",null,null,null,false],[0,0,0,"ProcessUserModeIOPL",null,null,null,false],[0,0,0,"ProcessEnableAlignmentFaultFixup",null,null,null,false],[0,0,0,"ProcessPriorityClass",null,null,null,false],[0,0,0,"ProcessWx86Information",null,null,null,false],[0,0,0,"ProcessHandleCount",null,null,null,false],[0,0,0,"ProcessAffinityMask",null,null,null,false],[0,0,0,"ProcessPriorityBoost",null,null,null,false],[0,0,0,"ProcessDeviceMap",null,null,null,false],[0,0,0,"ProcessSessionInformation",null,null,null,false],[0,0,0,"ProcessForegroundInformation",null,null,null,false],[0,0,0,"ProcessWow64Information",null,null,null,false],[0,0,0,"ProcessImageFileName",null,null,null,false],[0,0,0,"ProcessLUIDDeviceMapsEnabled",null,null,null,false],[0,0,0,"ProcessBreakOnTermination",null,null,null,false],[0,0,0,"ProcessDebugObjectHandle",null,null,null,false],[0,0,0,"ProcessDebugFlags",null,null,null,false],[0,0,0,"ProcessHandleTracing",null,null,null,false],[0,0,0,"ProcessIoPriority",null,null,null,false],[0,0,0,"ProcessExecuteFlags",null,null,null,false],[0,0,0,"ProcessTlsInformation",null,null,null,false],[0,0,0,"ProcessCookie",null,null,null,false],[0,0,0,"ProcessImageInformation",null,null,null,false],[0,0,0,"ProcessCycleTime",null,null,null,false],[0,0,0,"ProcessPagePriority",null,null,null,false],[0,0,0,"ProcessInstrumentationCallback",null,null,null,false],[0,0,0,"ProcessThreadStackAllocation",null,null,null,false],[0,0,0,"ProcessWorkingSetWatchEx",null,null,null,false],[0,0,0,"ProcessImageFileNameWin32",null,null,null,false],[0,0,0,"ProcessImageFileMapping",null,null,null,false],[0,0,0,"ProcessAffinityUpdateMode",null,null,null,false],[0,0,0,"ProcessMemoryAllocationMode",null,null,null,false],[0,0,0,"ProcessGroupInformation",null,null,null,false],[0,0,0,"ProcessTokenVirtualizationEnabled",null,null,null,false],[0,0,0,"ProcessConsoleHostProcess",null,null,null,false],[0,0,0,"ProcessWindowInformation",null,null,null,false],[0,0,0,"MaxProcessInfoClass",null,null,null,false],[401,5169,0,null,null,null,[58085,58087,58089,58091,58093,58095],false],[401,5169,0,null,null,null,null,false],[0,0,0,"ExitStatus",null,null,null,false],[401,5169,0,null,null,null,null,false],[0,0,0,"PebBaseAddress",null,null,null,false],[401,5169,0,null,null,null,null,false],[0,0,0,"AffinityMask",null,null,null,false],[401,5169,0,null,null,null,null,false],[0,0,0,"BasePriority",null,null,null,false],[401,5169,0,null,null,null,null,false],[0,0,0,"UniqueProcessId",null,null,null,false],[401,5169,0,null,null,null,null,false],[0,0,0,"InheritedFromUniqueProcessId",null,null,null,false],[401,5178,0,null,null,null,null,false],[401,5182,0,null,null,null,[58098,58099,58100],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[401,5197,0,null,null,null,null,false],[401,5201,0,null,null,null,[58103,58104,58105],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[401,5216,0,null,null,null,null,false],[401,5219,0,null,null," Returns the base address of the process loaded into memory.",[58108],false],[0,0,0,"handle",null,"",null,false],[401,2373,0,"getNamespacePrefix","test getNamespacePrefix {\n    try std.testing.expectEqual(NamespacePrefix.none, getNamespacePrefix(u8, \"\"));\n    try std.testing.expectEqual(NamespacePrefix.nt, getNamespacePrefix(u8, \"\\\\??\\\\\"));\n    try std.testing.expectEqual(NamespacePrefix.none, getNamespacePrefix(u8, \"/??/\"));\n    try std.testing.expectEqual(NamespacePrefix.none, getNamespacePrefix(u8, \"/??\\\\\"));\n    try std.testing.expectEqual(NamespacePrefix.none, getNamespacePrefix(u8, \"\\\\?\\\\\\\\\"));\n    try std.testing.expectEqual(NamespacePrefix.local_device, getNamespacePrefix(u8, \"\\\\\\\\.\\\\\"));\n    try std.testing.expectEqual(NamespacePrefix.local_device, getNamespacePrefix(u8, \"\\\\\\\\./\"));\n    try std.testing.expectEqual(NamespacePrefix.local_device, getNamespacePrefix(u8, \"/\\\\./\"));\n    try std.testing.expectEqual(NamespacePrefix.local_device, getNamespacePrefix(u8, \"//./\"));\n    try std.testing.expectEqual(NamespacePrefix.none, getNamespacePrefix(u8, \"/.//\"));\n    try std.testing.expectEqual(NamespacePrefix.verbatim, getNamespacePrefix(u8, \"\\\\\\\\?\\\\\"));\n    try std.testing.expectEqual(NamespacePrefix.fake_verbatim, getNamespacePrefix(u8, \"\\\\/?\\\\\"));\n    try std.testing.expectEqual(NamespacePrefix.fake_verbatim, getNamespacePrefix(u8, \"\\\\/?/\"));\n    try std.testing.expectEqual(NamespacePrefix.fake_verbatim, getNamespacePrefix(u8, \"//?/\"));\n}",null,null,false],[401,2427,0,"getUnprefixedPathType","test getUnprefixedPathType {\n    try std.testing.expectEqual(UnprefixedPathType.relative, getUnprefixedPathType(u8, \"\"));\n    try std.testing.expectEqual(UnprefixedPathType.relative, getUnprefixedPathType(u8, \"x\"));\n    try std.testing.expectEqual(UnprefixedPathType.relative, getUnprefixedPathType(u8, \"x\\\\\"));\n    try std.testing.expectEqual(UnprefixedPathType.root_local_device, getUnprefixedPathType(u8, \"//.\"));\n    try std.testing.expectEqual(UnprefixedPathType.root_local_device, getUnprefixedPathType(u8, \"/\\\\?\"));\n    try std.testing.expectEqual(UnprefixedPathType.root_local_device, getUnprefixedPathType(u8, \"\\\\\\\\?\"));\n    try std.testing.expectEqual(UnprefixedPathType.unc_absolute, getUnprefixedPathType(u8, \"\\\\\\\\x\"));\n    try std.testing.expectEqual(UnprefixedPathType.unc_absolute, getUnprefixedPathType(u8, \"//x\"));\n    try std.testing.expectEqual(UnprefixedPathType.rooted, getUnprefixedPathType(u8, \"\\\\x\"));\n    try std.testing.expectEqual(UnprefixedPathType.rooted, getUnprefixedPathType(u8, \"/\"));\n    try std.testing.expectEqual(UnprefixedPathType.drive_relative, getUnprefixedPathType(u8, \"x:\"));\n    try std.testing.expectEqual(UnprefixedPathType.drive_relative, getUnprefixedPathType(u8, \"x:abc\"));\n    try std.testing.expectEqual(UnprefixedPathType.drive_relative, getUnprefixedPathType(u8, \"x:a/b/c\"));\n    try std.testing.expectEqual(UnprefixedPathType.drive_absolute, getUnprefixedPathType(u8, \"x:\\\\\"));\n    try std.testing.expectEqual(UnprefixedPathType.drive_absolute, getUnprefixedPathType(u8, \"x:\\\\abc\"));\n    try std.testing.expectEqual(UnprefixedPathType.drive_absolute, getUnprefixedPathType(u8, \"x:/a/b/c\"));\n}",null,null,false],[350,60,0,null,null," Applications can override the `system` API layer in their root source file.\n Otherwise, when linking libc, this is the C API.\n When not linking libc, it is the OS-specific system interface.",null,false],[350,72,0,null,null,null,null,false],[350,73,0,null,null,null,null,false],[350,74,0,null,null,null,null,false],[350,75,0,null,null,null,null,false],[350,76,0,null,null,null,null,false],[350,77,0,null,null,null,null,false],[350,78,0,null,null,null,null,false],[350,79,0,null,null,null,null,false],[350,80,0,null,null,null,null,false],[350,81,0,null,null,null,null,false],[350,82,0,null,null,null,null,false],[350,83,0,null,null,null,null,false],[350,84,0,null,null,null,null,false],[350,85,0,null,null,null,null,false],[350,86,0,null,null,null,null,false],[350,87,0,null,null,null,null,false],[350,91,0,null,null,null,null,false],[350,92,0,null,null,null,null,false],[350,93,0,null,null,null,null,false],[350,94,0,null,null,null,null,false],[350,95,0,null,null,null,null,false],[350,96,0,null,null,null,null,false],[350,97,0,null,null,null,null,false],[350,98,0,null,null,null,null,false],[350,99,0,null,null,null,null,false],[350,100,0,null,null,null,null,false],[350,101,0,null,null,null,null,false],[350,102,0,null,null,null,null,false],[350,103,0,null,null,null,null,false],[350,104,0,null,null,null,null,false],[350,105,0,null,null,null,null,false],[350,111,0,null,null,null,null,false],[350,112,0,null,null,null,null,false],[350,113,0,null,null,null,null,false],[350,114,0,null,null,null,null,false],[350,115,0,null,null,null,null,false],[350,116,0,null,null,null,null,false],[350,117,0,null,null,null,null,false],[350,118,0,null,null,null,null,false],[350,119,0,null,null,null,null,false],[350,120,0,null,null,null,null,false],[350,121,0,null,null,null,null,false],[350,122,0,null,null,null,null,false],[350,123,0,null,null,null,null,false],[350,124,0,null,null,null,null,false],[350,125,0,null,null,null,null,false],[350,126,0,null,null,null,null,false],[350,127,0,null,null,null,null,false],[350,128,0,null,null,null,null,false],[350,129,0,null,null,null,null,false],[350,130,0,null,null,null,null,false],[350,131,0,null,null,null,null,false],[350,132,0,null,null,null,null,false],[350,133,0,null,null,null,null,false],[350,134,0,null,null,null,null,false],[350,135,0,null,null,null,null,false],[350,136,0,null,null,null,null,false],[350,137,0,null,null,null,null,false],[350,138,0,null,null,null,null,false],[350,139,0,null,null,null,null,false],[350,140,0,null,null,null,null,false],[350,141,0,null,null,null,null,false],[350,142,0,null,null,null,null,false],[350,143,0,null,null,null,null,false],[350,144,0,null,null,null,null,false],[350,145,0,null,null,null,null,false],[350,146,0,null,null,null,null,false],[350,147,0,null,null,null,null,false],[350,148,0,null,null,null,null,false],[350,149,0,null,null,null,null,false],[350,150,0,null,null,null,null,false],[350,151,0,null,null,null,null,false],[350,152,0,null,null,null,null,false],[350,153,0,null,null,null,null,false],[350,154,0,null,null,null,null,false],[350,155,0,null,null,null,null,false],[350,156,0,null,null,null,null,false],[350,157,0,null,null,null,null,false],[350,158,0,null,null,null,null,false],[350,159,0,null,null,null,null,false],[350,160,0,null,null,null,null,false],[350,161,0,null,null,null,null,false],[350,162,0,null,null,null,null,false],[350,163,0,null,null,null,null,false],[350,164,0,null,null,null,null,false],[350,165,0,null,null,null,null,false],[350,166,0,null,null,null,null,false],[350,167,0,null,null,null,null,false],[350,168,0,null,null,null,null,false],[350,169,0,null,null,null,null,false],[350,170,0,null,null,null,null,false],[350,171,0,null,null,null,null,false],[350,172,0,null,null,null,null,false],[350,173,0,null,null,null,null,false],[350,174,0,null,null,null,null,false],[350,175,0,null,null,null,null,false],[350,176,0,null,null,null,null,false],[350,177,0,null,null,null,null,false],[350,178,0,null,null,null,null,false],[350,179,0,null,null,null,null,false],[350,180,0,null,null,null,null,false],[350,181,0,null,null,null,null,false],[350,182,0,null,null,null,null,false],[350,183,0,null,null,null,null,false],[350,184,0,null,null,null,null,false],[350,185,0,null,null,null,null,false],[350,186,0,null,null,null,null,false],[350,187,0,null,null,null,null,false],[350,188,0,null,null,null,null,false],[350,189,0,null,null,null,null,false],[350,190,0,null,null,null,null,false],[350,191,0,null,null,null,null,false],[350,193,0,null,null,null,null,false],[350,194,0,null,null,null,null,false],[350,195,0,null,null,null,null,false],[350,196,0,null,null,null,null,false],[350,198,0,null,null,null,[58230,58231],false],[350,198,0,null,null,null,null,false],[0,0,0,"iov_base",null,null,null,false],[0,0,0,"iov_len",null,null,null,false],[350,203,0,null,null,null,[58234,58235],false],[350,203,0,null,null,null,null,false],[0,0,0,"iov_base",null,null,null,false],[0,0,0,"iov_len",null,null,null,false],[350,208,0,null,null,null,[],false],[350,210,0,null,null," system is unusable",null,false],[350,212,0,null,null," action must be taken immediately",null,false],[350,214,0,null,null," critical conditions",null,false],[350,216,0,null,null," error conditions",null,false],[350,218,0,null,null," warning conditions",null,false],[350,220,0,null,null," normal but significant condition",null,false],[350,222,0,null,null," informational",null,false],[350,224,0,null,null," debug-level messages",null,false],[350,231,0,null,null," An fd-relative file path\n\n This is currently only used for WASI-specific functionality, but the concept\n is the same as the dirfd/pathname pairs in the `*at(...)` POSIX functions.",[58247,58249],false],[350,231,0,null,null,null,null,false],[0,0,0,"dir_fd",null," Handle to directory",null,false],[350,231,0,null,null,null,null,false],[0,0,0,"relative_path",null," Path to resource within `dir_fd`.",null,false],[350,238,0,null,null,null,null,false],[350,243,0,null,null," See also `getenv`. Populated by startup code before main().\n TODO this is a footgun because the value will be undefined when using `zig build-lib`.\n https://github.com/ziglang/zig/issues/4524",null,false],[350,248,0,null,null," Populated by startup code before main().\n Not available on WASI or Windows without libc. See `std.process.argsAlloc`\n or `std.process.argsWithAllocator` for a cross-platform alternative.",null,false],[350,254,0,null,null,null,null,false],[350,256,0,null,null,null,[58255],false],[0,0,0,"",null,"",null,false],[350,259,0,null,null," On default executed by posix startup code before main(), if SIGPIPE is supported.",[],false],[350,279,0,null,null," To obtain errno, call this function with the return value of the\n system function call. For some systems this will obtain the value directly\n from the return code; for others it will use a thread-local errno variable.\n Therefore, this function only returns a well-defined value when it is called\n directly after the system function call which one wants to learn the errno\n value of.",null,false],[350,286,0,null,null," Closes the file descriptor.\n This function is not capable of returning any indication of failure. An\n application which wants to ensure writes have succeeded before closing\n must call `fsync` before `close`.\n Note: The Zig standard library does not support POSIX thread cancellation.",[58259],false],[0,0,0,"fd",null,"",null,false],[350,308,0,null,null,null,null,false],[350,321,0,null,null," Changes the mode of the file referred to by the file descriptor.\n The process must have the correct privileges in order to do this\n successfully, or must have the effective user ID matching the owner\n of the file.",[58262,58263],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,346,0,null,null,null,null,false],[350,350,0,null,null,null,[58266,58267,58268,58269],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,377,0,null,null,null,null,false],[350,391,0,null,null," Changes the owner and group of the file referred to by the file descriptor.\n The process must have the correct privileges in order to do this\n successfully. The group may be changed by the owner of the directory to\n any group of which the owner is a member. If the owner or group is\n specified as `null`, the ID is not changed.",[58272,58273,58274],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"owner",null,"",null,false],[0,0,0,"group",null,"",null,false],[350,418,0,null,null,null,null,false],[350,422,0,null,null,null,null,false],[350,436,0,null,null,null,[58278],false],[0,0,0,"cmd",null,"",null,false],[350,468,0,null,null,null,null,false],[350,475,0,null,null," Obtain a series of random bytes. These bytes can be used to seed user-space\n random number generators or for cryptographic purposes.\n When linking against libc, this calls the\n appropriate OS-specific library call. Otherwise it uses the zig standard\n library implementation.",[58281],false],[0,0,0,"buffer",null,"",null,false],[350,523,0,null,null,null,[58283],false],[0,0,0,"buf",null,"",null,false],[350,545,0,null,null," Causes abnormal process termination.\n If linking against libc, this calls the abort() libc function. Otherwise\n it raises SIGABRT followed by SIGKILL and finally lo\n Invokes the current signal handler for SIGABRT, if any.",[],false],[350,601,0,null,null,null,null,false],[350,603,0,null,null,null,[58287],false],[0,0,0,"sig",null,"",null,false],[350,631,0,null,null,null,null,false],[350,633,0,null,null,null,[58290,58291],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"sig",null,"",null,false],[350,644,0,null,null," Exits the program cleanly with the specified status code.",[58293],false],[0,0,0,"status",null,"",null,false],[350,669,0,null,null,null,null,false],[350,701,0,null,null," Returns the number of bytes that were read, which can be less than\n buf.len. If 0 bytes were read, that means EOF.\n If `fd` is opened in non blocking mode, the function will return error.WouldBlock\n when EAGAIN is received.\n\n Linux has a limit on how many bytes may be transferred in one `read` call, which is `0x7ffff000`\n on both 64-bit and 32-bit systems. This is due to using a signed C int as the return value, as\n well as stuffing the errno codes into the last `4096` values. This is noted on the `read` man page.\n The limit on Darwin is `0x7fffffff`, trying to read more than that returns EINVAL.\n The corresponding POSIX limit is `math.maxInt(isize)`.",[58296,58297],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[350,772,0,null,null," Number of bytes read is returned. Upon reading end-of-file, zero is returned.\n\n For POSIX systems, if `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n On Windows, if the application has a global event loop enabled, I/O Completion Ports are\n used to perform the I/O. `error.WouldBlock` is not possible on Windows.\n\n This operation is non-atomic on the following systems:\n * Windows\n On these systems, the read races with concurrent writes to the same file descriptor.\n\n This function assumes that all vectors, including zero-length vectors, have\n a pointer within the address space of the application.",[58299,58300],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[350,817,0,null,null,null,null,false],[350,833,0,null,null," Number of bytes read is returned. Upon reading end-of-file, zero is returned.\n\n Retries when interrupted by a signal.\n\n For POSIX systems, if `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n On Windows, if the application has a global event loop enabled, I/O Completion Ports are\n used to perform the I/O. `error.WouldBlock` is not possible on Windows.\n\n Linux has a limit on how many bytes may be transferred in one `pread` call, which is `0x7ffff000`\n on both 64-bit and 32-bit systems. This is due to using a signed C int as the return value, as\n well as stuffing the errno codes into the last `4096` values. This is noted on the `read` man page.\n The limit on Darwin is `0x7fffffff`, trying to read more than that returns EINVAL.\n The corresponding POSIX limit is `math.maxInt(isize)`.",[58303,58304,58305],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,898,0,null,null,null,null,false],[350,908,0,null,null,null,[58308,58309],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"length",null,"",null,false],[350,976,0,null,null," Number of bytes read is returned. Upon reading end-of-file, zero is returned.\n\n Retries when interrupted by a signal.\n\n For POSIX systems, if `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n On Windows, if the application has a global event loop enabled, I/O Completion Ports are\n used to perform the I/O. `error.WouldBlock` is not possible on Windows.\n\n This operation is non-atomic on the following systems:\n * Darwin\n * Windows\n On these systems, the read races with concurrent writes to the same file descriptor.",[58311,58312,58313],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,1035,0,null,null,null,null,false],[350,1085,0,null,null," Write to a file descriptor.\n Retries when interrupted by a signal.\n Returns the number of bytes written. If nonzero bytes were supplied, this will be nonzero.\n\n Note that a successful write() may transfer fewer than count bytes.  Such partial  writes  can\n occur  for  various reasons; for example, because there was insufficient space on the disk\n device to write all of the requested bytes, or because a blocked write() to a socket,  pipe,  or\n similar  was  interrupted by a signal handler after it had transferred some, but before it had\n transferred all of the requested bytes.  In the event of a partial write, the caller can  make\n another  write() call to transfer the remaining bytes.  The subsequent call will either\n transfer further bytes or may result in an error (e.g., if the disk is now full).\n\n For POSIX systems, if `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n On Windows, if the application has a global event loop enabled, I/O Completion Ports are\n used to perform the I/O. `error.WouldBlock` is not possible on Windows.\n\n Linux has a limit on how many bytes may be transferred in one `write` call, which is `0x7ffff000`\n on both 64-bit and 32-bit systems. This is due to using a signed C int as the return value, as\n well as stuffing the errno codes into the last `4096` values. This is noted on the `write` man page.\n The limit on Darwin is `0x7fffffff`, trying to read more than that returns EINVAL.\n The corresponding POSIX limit is `math.maxInt(isize)`.",[58316,58317],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[350,1167,0,null,null," Write multiple buffers to a file descriptor.\n Retries when interrupted by a signal.\n Returns the number of bytes written. If nonzero bytes were supplied, this will be nonzero.\n\n Note that a successful write() may transfer fewer bytes than supplied.  Such partial  writes  can\n occur  for  various reasons; for example, because there was insufficient space on the disk\n device to write all of the requested bytes, or because a blocked write() to a socket,  pipe,  or\n similar  was  interrupted by a signal handler after it had transferred some, but before it had\n transferred all of the requested bytes.  In the event of a partial write, the caller can  make\n another  write() call to transfer the remaining bytes.  The subsequent call will either\n transfer further bytes or may result in an error (e.g., if the disk is now full).\n\n For POSIX systems, if `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n On Windows, if the application has a global event loop enabled, I/O Completion Ports are\n used to perform the I/O. `error.WouldBlock` is not possible on Windows.\n\n If `iov.len` is larger than `IOV_MAX`, a partial write will occur.\n\n This function assumes that all vectors, including zero-length vectors, have\n a pointer within the address space of the application.",[58319,58320],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[350,1219,0,null,null,null,null,false],[350,1243,0,null,null," Write to a file descriptor, with a position offset.\n Retries when interrupted by a signal.\n Returns the number of bytes written. If nonzero bytes were supplied, this will be nonzero.\n\n Note that a successful write() may transfer fewer bytes than supplied.  Such partial  writes  can\n occur  for  various reasons; for example, because there was insufficient space on the disk\n device to write all of the requested bytes, or because a blocked write() to a socket,  pipe,  or\n similar  was  interrupted by a signal handler after it had transferred some, but before it had\n transferred all of the requested bytes.  In the event of a partial write, the caller can  make\n another  write() call to transfer the remaining bytes.  The subsequent call will either\n transfer further bytes or may result in an error (e.g., if the disk is now full).\n\n For POSIX systems, if `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n On Windows, if the application has a global event loop enabled, I/O Completion Ports are\n used to perform the I/O. `error.WouldBlock` is not possible on Windows.\n\n Linux has a limit on how many bytes may be transferred in one `pwrite` call, which is `0x7ffff000`\n on both 64-bit and 32-bit systems. This is due to using a signed C int as the return value, as\n well as stuffing the errno codes into the last `4096` values. This is noted on the `write` man page.\n The limit on Darwin is `0x7fffffff`, trying to write more than that returns EINVAL.\n The corresponding POSIX limit is `math.maxInt(isize)`.",[58323,58324,58325],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,1334,0,null,null," Write multiple buffers to a file descriptor, with a position offset.\n Retries when interrupted by a signal.\n Returns the number of bytes written. If nonzero bytes were supplied, this will be nonzero.\n\n Note that a successful write() may transfer fewer than count bytes.  Such partial  writes  can\n occur  for  various reasons; for example, because there was insufficient space on the disk\n device to write all of the requested bytes, or because a blocked write() to a socket,  pipe,  or\n similar  was  interrupted by a signal handler after it had transferred some, but before it had\n transferred all of the requested bytes.  In the event of a partial write, the caller can  make\n another  write() call to transfer the remaining bytes.  The subsequent call will either\n transfer further bytes or may result in an error (e.g., if the disk is now full).\n\n If `fd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.\n\n The following systems do not have this syscall, and will return partial writes if more than one\n vector is provided:\n * Darwin\n * Windows\n\n If `iov.len` is larger than `IOV_MAX`, a partial write will occur.",[58327,58328,58329],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"iov",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,1400,0,null,null,null,null,false],[350,1464,0,null,null," Open and possibly create a file. Keeps trying if it gets interrupted.\n See also `openZ`.",[58332,58333,58334],false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"perm",null,"",null,false],[350,1477,0,null,null," Open and possibly create a file. Keeps trying if it gets interrupted.\n See also `open`.",[58336,58337,58338],false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"perm",null,"",null,false],[350,1516,0,null,null,null,[58340],false],[0,0,0,"flags",null,"",null,false],[350,1554,0,null,null," Windows-only. The path parameter is\n [WTF-16](https://simonsapin.github.io/wtf-8/#potentially-ill-formed-utf-16) encoded.\n Translates the POSIX open API call to a Windows API call.\n TODO currently, this function does not handle all flag combinations\n or makes use of perm argument.",[58342,58343,58344],false],[0,0,0,"file_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"perm",null,"",null,false],[350,1568,0,null,null," Open and possibly create a file. Keeps trying if it gets interrupted.\n `file_path` is relative to the open directory handle `dir_fd`.\n See also `openatZ`.",[58346,58347,58348,58349],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,1599,0,null,null," A struct to contain all lookup/rights flags accepted by `wasi.path_open`",[58352,58354,58356,58358,58360],false],[350,1599,0,null,null,null,null,false],[0,0,0,"oflags",null,null,null,false],[350,1599,0,null,null,null,null,false],[0,0,0,"lookup_flags",null,null,null,false],[350,1599,0,null,null,null,null,false],[0,0,0,"fs_rights_base",null,null,null,false],[350,1599,0,null,null,null,null,false],[0,0,0,"fs_rights_inheriting",null,null,null,false],[350,1599,0,null,null,null,null,false],[0,0,0,"fs_flags",null,null,null,false],[350,1608,0,null,null," Compute rights + flags corresponding to the provided POSIX access mode.",[58362,58363],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"oflag",null,"",null,false],[350,1648,0,null,null," Open and possibly create a file in WASI.",[58365,58366,58367,58368,58369,58370,58371],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"lookup_flags",null,"",null,false],[0,0,0,"oflags",null,"",null,false],[0,0,0,"fdflags",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"inheriting",null,"",null,false],[350,1690,0,null,null," Open and possibly create a file. Keeps trying if it gets interrupted.\n `file_path` is relative to the open directory handle `dir_fd`.\n See also `openat`.",[58373,58374,58375,58376],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,1737,0,null,null," Windows-only. Similar to `openat` but with pathname argument null-terminated\n WTF16 encoded.\n TODO currently, this function does not handle all flag combinations\n or makes use of perm argument.",[58378,58379,58380,58381],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"file_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,1748,0,null,null,null,[58383],false],[0,0,0,"old_fd",null,"",null,false],[350,1758,0,null,null,null,[58385,58386],false],[0,0,0,"old_fd",null,"",null,false],[0,0,0,"new_fd",null,"",null,false],[350,1771,0,null,null,null,null,false],[350,1786,0,null,null," This function ignores PATH environment variable. See `execvpeZ` for that.",[58389,58390,58391],false],[0,0,0,"path",null,"",null,false],[0,0,0,"child_argv",null,"",null,false],[0,0,0,"envp",null,"",null,false],[350,1824,0,null,null,null,[58393,58394],false],[0,0,0,"expand",null,null,null,false],[0,0,0,"no_expand",null,null,null,false],[350,1832,0,null,null," Like `execvpeZ` except if `arg0_expand` is `.expand`, then `argv` is mutable,\n and `argv[0]` is expanded to be the same absolute path that is passed to the execve syscall.\n If this function returns with an error, `argv[0]` will be restored to the value it was when it was passed in.",[58396,58397,58398,58399],false],[0,0,0,"arg0_expand",null,"",null,true],[0,0,0,"file",null,"",null,false],[0,0,0,"child_argv",null,"",null,false],[0,0,0,"envp",null,"",null,false],[350,1884,0,null,null," This function also uses the PATH environment variable to get the full path to the executable.\n If `file` is an absolute path, this is the same as `execveZ`.",[58401,58402,58403],false],[0,0,0,"file",null,"",null,false],[0,0,0,"argv_ptr",null,"",null,false],[0,0,0,"envp",null,"",null,false],[350,1894,0,null,null," Get an environment variable.\n See also `getenvZ`.",[58405],false],[0,0,0,"key",null,"",null,false],[350,1930,0,null,null," Get an environment variable with a null-terminated name.\n See also `getenv`.",[58407],false],[0,0,0,"key",null,"",null,false],[350,1944,0,null,null," Windows-only. Get an environment variable with a null-terminated, WTF-16 encoded name.\n See also `getenv`.\n This function performs a Unicode-aware case-insensitive lookup using RtlEqualUnicodeString.",[58409],false],[0,0,0,"key",null,"",null,false],[350,1978,0,null,null,null,null,false],[350,1984,0,null,null," The result is a slice of out_buffer, indexed from 0.",[58412],false],[0,0,0,"out_buffer",null,"",null,false],[350,2011,0,null,null,null,null,false],[350,2034,0,null,null," Creates a symbolic link named `sym_link_path` which contains the string `target_path`.\n A symbolic link (also known as a soft link) may point to an existing file or to a nonexistent\n one; the latter case is known as a dangling link.\n If `sym_link_path` exists, it will not be overwritten.\n See also `symlinkZ.",[58415,58416],false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[350,2047,0,null,null," This is the same as `symlink` except the parameters are null-terminated pointers.\n See also `symlink`.",[58418,58419],false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[350,2079,0,null,null," Similar to `symlink`, however, creates a symbolic link named `sym_link_path` which contains the string\n `target_path` **relative** to `newdirfd` directory handle.\n A symbolic link (also known as a soft link) may point to an existing file or to a nonexistent\n one; the latter case is known as a dangling link.\n If `sym_link_path` exists, it will not be overwritten.\n See also `symlinkatWasi`, `symlinkatZ` and `symlinkatW`.",[58421,58422,58423],false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"newdirfd",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[350,2092,0,null,null," WASI-only. The same as `symlinkat` but targeting WASI.\n See also `symlinkat`.",[58425,58426,58427],false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"newdirfd",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[350,2117,0,null,null," The same as `symlinkat` except the parameters are null-terminated pointers.\n See also `symlinkat`.",[58429,58430,58431],false],[0,0,0,"target_path",null,"",null,false],[0,0,0,"newdirfd",null,"",null,false],[0,0,0,"sym_link_path",null,"",null,false],[350,2143,0,null,null,null,null,false],[350,2158,0,null,null,null,[58434,58435,58436],false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2183,0,null,null,null,[58438,58439,58440],false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2195,0,null,null,null,null,false],[350,2197,0,null,null,null,[58443,58444,58445,58446,58447],false],[0,0,0,"olddir",null,"",null,false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newdir",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2229,0,null,null,null,[58449,58450,58451,58452,58453],false],[0,0,0,"olddir",null,"",null,false],[0,0,0,"oldpath",null,"",null,false],[0,0,0,"newdir",null,"",null,false],[0,0,0,"newpath",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2248,0,null,null," WASI-only. The same as `linkat` but targeting WASI.\n See also `linkat`.",[58455,58456,58457],false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2275,0,null,null,null,null,false],[350,2303,0,null,null," Delete a name and possibly the file it refers to.\n See also `unlinkZ`.",[58460],false],[0,0,0,"file_path",null,"",null,false],[350,2319,0,null,null," Same as `unlink` except the parameter is a null terminated UTF8-encoded string.",[58462],false],[0,0,0,"file_path",null,"",null,false],[350,2346,0,null,null," Windows-only. Same as `unlink` except the parameter is null-terminated, WTF16 encoded.",[58464],false],[0,0,0,"file_path_w",null,"",null,false],[350,2350,0,null,null,null,null,false],[350,2357,0,null,null," Delete a file name and possibly the file it refers to, based on an open directory handle.\n Asserts that the path parameter has no null bytes.",[58467,58468,58469],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2371,0,null,null," WASI-only. Same as `unlinkat` but targeting WASI.\n See also `unlinkat`.",[58471,58472,58473],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2402,0,null,null," Same as `unlinkat` but `file_path` is a null-terminated string.",[58475,58476,58477],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path_c",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2434,0,null,null," Same as `unlinkat` but `sub_path_w` is UTF16LE, NT prefixed. Windows only.",[58479,58480,58481],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,2439,0,null,null,null,null,false],[350,2469,0,null,null," Change the name or location of a file.",[58484,58485],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[350,2484,0,null,null," Same as `rename` except the parameters are null-terminated byte arrays.",[58487,58488],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[350,2518,0,null,null," Same as `rename` except the parameters are null-terminated UTF16LE encoded byte arrays.\n Assumes target is Windows.",[58490,58491],false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[350,2524,0,null,null," Change the name or location of a file based on an open directory handle.",[58493,58494,58495,58496],false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[350,2547,0,null,null," WASI-only. Same as `renameat` expect targeting WASI.\n See also `renameat`.",[58498,58499],false],[0,0,0,"old",null,"",null,false],[0,0,0,"new",null,"",null,false],[350,2574,0,null,null," Same as `renameat` except the parameters are null-terminated byte arrays.",[58501,58502,58503,58504],false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path",null,"",null,false],[350,2614,0,null,null," Same as `renameat` but Windows-only and the path parameters are\n [WTF-16](https://simonsapin.github.io/wtf-8/#potentially-ill-formed-utf-16) encoded.",[58506,58507,58508,58509,58510],false],[0,0,0,"old_dir_fd",null,"",null,false],[0,0,0,"old_path_w",null,"",null,false],[0,0,0,"new_dir_fd",null,"",null,false],[0,0,0,"new_path_w",null,"",null,false],[0,0,0,"ReplaceIfExists",null,"",null,false],[350,2720,0,null,null,null,[58512,58513,58514],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"sub_dir_path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2732,0,null,null,null,[58516,58517,58518],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"sub_dir_path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2755,0,null,null,null,[58520,58521,58522],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"sub_dir_path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2784,0,null,null,null,[58524,58525,58526],false],[0,0,0,"dir_fd",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2801,0,null,null,null,null,false],[350,2824,0,null,null," Create a directory.\n `mode` is ignored on Windows and WASI.",[58529,58530],false],[0,0,0,"dir_path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2837,0,null,null," Same as `mkdir` but the parameter is a null-terminated UTF8-encoded string.",[58532,58533],false],[0,0,0,"dir_path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2864,0,null,null," Windows-only. Same as `mkdir` but the parameters is  WTF16 encoded.",[58535,58536],false],[0,0,0,"dir_path_w",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,2881,0,null,null,null,null,false],[350,2898,0,null,null," Deletes an empty directory.",[58539],false],[0,0,0,"dir_path",null,"",null,false],[350,2915,0,null,null," Same as `rmdir` except the parameter is null-terminated.",[58541],false],[0,0,0,"dir_path",null,"",null,false],[350,2942,0,null,null," Windows-only. Same as `rmdir` except the parameter is WTF16 encoded.",[58543],false],[0,0,0,"dir_path_w",null,"",null,false],[350,2949,0,null,null,null,null,false],[350,2965,0,null,null," Changes the current working directory of the calling process.\n `dir_path` is recommended to be a UTF-8 encoded string.",[58546],false],[0,0,0,"dir_path",null,"",null,false],[350,2980,0,null,null," Same as `chdir` except the parameter is null-terminated.",[58548],false],[0,0,0,"dir_path",null,"",null,false],[350,3004,0,null,null," Windows-only. Same as `chdir` except the parameter is WTF16 encoded.",[58550],false],[0,0,0,"dir_path",null,"",null,false],[350,3011,0,null,null,null,null,false],[350,3017,0,null,null,null,[58553],false],[0,0,0,"dirfd",null,"",null,false],[350,3031,0,null,null,null,null,false],[350,3053,0,null,null," Read value of a symbolic link.\n The return value is a slice of `out_buffer` from index 0.",[58556,58557],false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3067,0,null,null," Windows-only. Same as `readlink` except `file_path` is WTF16 encoded.\n See also `readlinkZ`.",[58559,58560],false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3072,0,null,null," Same as `readlink` except `file_path` is null-terminated.",[58562,58563],false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3098,0,null,null," Similar to `readlink` except reads value of a symbolink link **relative** to `dirfd` directory handle.\n The return value is a slice of `out_buffer` from index 0.\n See also `readlinkatWasi`, `realinkatZ` and `realinkatW`.",[58565,58566,58567],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3112,0,null,null," WASI-only. Same as `readlinkat` but targets WASI.\n See also `readlinkat`.",[58569,58570,58571],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3132,0,null,null," Windows-only. Same as `readlinkat` except `file_path` is null-terminated, WTF16 encoded.\n See also `readlinkat`.",[58573,58574,58575],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3138,0,null,null," Same as `readlinkat` except `file_path` is null-terminated.\n See also `readlinkat`.",[58577,58578,58579],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"file_path",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,3161,0,null,null,null,null,false],[350,3166,0,null,null,null,null,false],[350,3168,0,null,null,null,[58583],false],[0,0,0,"uid",null,"",null,false],[350,3178,0,null,null,null,[58585],false],[0,0,0,"uid",null,"",null,false],[350,3187,0,null,null,null,[58587,58588],false],[0,0,0,"ruid",null,"",null,false],[0,0,0,"euid",null,"",null,false],[350,3197,0,null,null,null,[58590],false],[0,0,0,"gid",null,"",null,false],[350,3207,0,null,null,null,[58592],false],[0,0,0,"uid",null,"",null,false],[350,3216,0,null,null,null,[58594,58595],false],[0,0,0,"rgid",null,"",null,false],[0,0,0,"egid",null,"",null,false],[350,3227,0,null,null," Test whether a file descriptor refers to a terminal.",[58597],false],[0,0,0,"handle",null,"",null,false],[350,3271,0,null,null,null,[58599],false],[0,0,0,"handle",null,"",null,false],[350,3319,0,null,null,null,null,false],[350,3347,0,null,null,null,[58602,58603,58604],false],[0,0,0,"domain",null,"",null,false],[0,0,0,"socket_type",null,"",null,false],[0,0,0,"protocol",null,"",null,false],[350,3404,0,null,null,null,null,false],[350,3419,0,null,null,null,[58607,58608,58609],false],[0,0,0,"recv",null,null,null,false],[0,0,0,"send",null,null,null,false],[0,0,0,"both",null,null,null,false],[350,3422,0,null,null," Shutdown socket send/receive operations",[58611,58612],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"how",null,"",null,false],[350,3458,0,null,null,null,[58614],false],[0,0,0,"sock",null,"",null,false],[350,3466,0,null,null,null,null,false],[350,3512,0,null,null," addr is `*const T` where T is one of the sockaddr",[58617,58618,58619],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[350,3555,0,null,null,null,null,false],[350,3583,0,null,null,null,[58622,58623],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"backlog",null,"",null,false],[350,3614,0,null,null,null,null,false],[350,3656,0,null,null," Accept a connection on a socket.\n If `sockfd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.",[58626,58627,58628,58629],false],[0,0,0,"sock",null," This argument is a socket that has been created with `socket`, bound to a local address\n with `bind`, and is listening for connections after a `listen`.",null,false],[0,0,0,"addr",null," This argument is a pointer to a sockaddr structure.  This structure is filled in with  the\n address  of  the  peer  socket, as known to the communications layer.  The exact format of the\n address returned addr is determined by the socket's address  family  (see  `socket`  and  the\n respective  protocol  man  pages).",null,false],[0,0,0,"addr_size",null," This argument is a value-result argument: the caller must initialize it to contain  the\n size (in bytes) of the structure pointed to by addr; on return it will contain the actual size\n of the peer address.\n\n The returned address is truncated if the buffer provided is too small; in this  case,  `addr_size`\n will return a value greater than was supplied to the call.",null,false],[0,0,0,"flags",null," The following values can be bitwise ORed in flags to obtain different behavior:\n * `SOCK.NONBLOCK` - Set the `O.NONBLOCK` file status flag on the open file description (see `open`)\n   referred  to by the new file descriptor.  Using this flag saves extra calls to `fcntl` to achieve\n   the same result.\n * `SOCK.CLOEXEC`  - Set the close-on-exec (`FD_CLOEXEC`) flag on the new file descriptor.   See  the\n   description  of the `O.CLOEXEC` flag in `open` for reasons why this may be useful.",null,false],[350,3738,0,null,null,null,null,false],[350,3752,0,null,null,null,[58632],false],[0,0,0,"flags",null,"",null,false],[350,3765,0,null,null,null,null,false],[350,3791,0,null,null,null,[58635,58636,58637,58638],false],[0,0,0,"epfd",null,"",null,false],[0,0,0,"op",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"event",null,"",null,false],[350,3811,0,null,null," Waits for an I/O event on an epoll file descriptor.\n Returns the number of file descriptors ready for the requested I/O,\n or zero if no file descriptor became ready during the requested timeout milliseconds.",[58640,58641,58642],false],[0,0,0,"epfd",null,"",null,false],[0,0,0,"events",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[350,3826,0,null,null,null,null,false],[350,3832,0,null,null,null,[58645,58646],false],[0,0,0,"initval",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,3846,0,null,null,null,null,false],[350,3859,0,null,null,null,[58649,58650,58651],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[350,3888,0,null,null,null,[58653,58654,58655],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[350,3917,0,null,null,null,null,false],[350,3967,0,null,null," Initiate a connection on a socket.\n If `sockfd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN or EINPROGRESS is received.",[58658,58659,58660],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"sock_addr",null,"",null,false],[0,0,0,"len",null,"",null,false],[350,4021,0,null,null,null,[58662],false],[0,0,0,"sockfd",null,"",null,false],[350,4057,0,null,null,null,[58665,58666],false],[350,4057,0,null,null,null,null,false],[0,0,0,"pid",null,null,null,false],[0,0,0,"status",null,null,null,false],[350,4064,0,null,null," Use this version of the `waitpid` wrapper if you spawned your child process using explicit\n `fork` and `execve` method.",[58668,58669],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4083,0,null,null,null,[58671,58672,58673],false],[0,0,0,"pid",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"ru",null,"",null,false],[350,4102,0,null,null,null,null,false],[350,4111,0,null,null," Return information about a file descriptor.",[58676],false],[0,0,0,"fd",null,"",null,false],[350,4141,0,null,null,null,null,false],[350,4146,0,null,null," Similar to `fstat`, but returns stat of a resource pointed to by `pathname`\n which is relative to `dirfd` handle.\n See also `fstatatZ` and `fstatatWasi`.",[58679,58680,58681],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4160,0,null,null," WASI-only. Same as `fstatat` but targeting WASI.\n See also `fstatat`.",[58683,58684,58685],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4179,0,null,null," Same as `fstatat` but `pathname` is null-terminated.\n See also `fstatat`.",[58687,58688,58689],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4203,0,null,null,null,null,false],[350,4211,0,null,null,null,[],false],[350,4221,0,null,null,null,null,false],[350,4239,0,null,null,null,[58694,58695,58696,58697],false],[0,0,0,"kq",null,"",null,false],[0,0,0,"changelist",null,"",null,false],[0,0,0,"eventlist",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[350,4269,0,null,null,null,null,false],[350,4276,0,null,null," initialize an inotify instance",[58700],false],[0,0,0,"flags",null,"",null,false],[350,4288,0,null,null,null,null,false],[350,4299,0,null,null," add a watch to an initialized inotify instance",[58703,58704,58705],false],[0,0,0,"inotify_fd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"mask",null,"",null,false],[350,4305,0,null,null," Same as `inotify_add_watch` except pathname is null-terminated.",[58707,58708,58709],false],[0,0,0,"inotify_fd",null,"",null,false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"mask",null,"",null,false],[350,4324,0,null,null," remove an existing watch from an inotify instance",[58711,58712],false],[0,0,0,"inotify_fd",null,"",null,false],[0,0,0,"wd",null,"",null,false],[350,4333,0,null,null,null,null,false],[350,4348,0,null,null," `memory.len` must be page-aligned.",[58715,58716],false],[0,0,0,"memory",null,"",null,false],[0,0,0,"protection",null,"",null,false],[350,4377,0,null,null,null,null,false],[350,4379,0,null,null,null,[],false],[350,4389,0,null,null,null,null,false],[350,4413,0,null,null," Map files or devices into memory.\n `length` does not need to be aligned.\n Use of a mapped region can result in these signals:\n * SIGSEGV - Attempted write into a region mapped as read-only.\n * SIGBUS - Attempted  access to a portion of the buffer that does not correspond to the file",[58721,58722,58723,58724,58725,58726],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"prot",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,4456,0,null,null," Deletes the mappings for the specified address range, causing\n further references to addresses within the range to generate invalid memory references.\n Note that while POSIX allows unmapping a region in the middle of an existing mapping,\n Zig's munmap function does not, for two reasons:\n * It violates the Zig principle that resource deallocation must succeed.\n * The Windows function, VirtualFree, has this restriction.",[58728],false],[0,0,0,"memory",null,"",null,false],[350,4465,0,null,null,null,null,false],[350,4469,0,null,null,null,[58731,58732],false],[0,0,0,"memory",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4478,0,null,null,null,null,false],[350,4495,0,null,null," check user's permissions for a file\n TODO currently this assumes `mode` is `F.OK` on Windows.",[58735,58736],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,4511,0,null,null," Same as `access` except `path` is null-terminated.",[58738,58739],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,4542,0,null,null," Call from Windows-specific code if you already have a UTF-16LE encoded, null terminated string.\n Otherwise use `access` or `accessC`.\n TODO currently this ignores `mode`.",[58741,58742],false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[350,4558,0,null,null," Check user's permissions for a file, based on an open directory handle.\n TODO currently this ignores `mode` and `flags` on Windows.",[58744,58745,58746,58747],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4601,0,null,null," Same as `faccessat` except the path parameter is null-terminated.",[58749,58750,58751,58752],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"path",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4628,0,null,null," Same as `faccessat` except asserts the target is Windows and the path parameter\n is NtDll-prefixed, null-terminated, WTF-16 encoded.\n TODO currently this ignores `mode` and `flags`",[58754,58755,58756,58757],false],[0,0,0,"dirfd",null,"",null,false],[0,0,0,"sub_path_w",null,"",null,false],[0,0,0,"mode",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,4665,0,null,null,null,null,false],[350,4671,0,null,null," Creates a unidirectional data channel that can be used for interprocess communication.",[],false],[350,4683,0,null,null,null,[58761],false],[0,0,0,"flags",null,"",null,false],[350,4734,0,null,null,null,null,false],[350,4741,0,null,null,null,[58764,58765,58766,58767,58768],false],[0,0,0,"name",null,"",null,false],[0,0,0,"oldp",null,"",null,false],[0,0,0,"oldlenp",null,"",null,false],[0,0,0,"newp",null,"",null,false],[0,0,0,"newlen",null,"",null,false],[350,4766,0,null,null,null,[58770,58771,58772,58773,58774],false],[0,0,0,"name",null,"",null,false],[0,0,0,"oldp",null,"",null,false],[0,0,0,"oldlenp",null,"",null,false],[0,0,0,"newp",null,"",null,false],[0,0,0,"newlen",null,"",null,false],[350,4790,0,null,null,null,[58776,58777],false],[0,0,0,"tv",null,"",null,false],[0,0,0,"tz",null,"",null,false],[350,4798,0,null,null,null,null,false],[350,4807,0,null,null," Repositions read/write file offset relative to the beginning.",[58780,58781],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,4852,0,null,null," Repositions read/write file offset relative to the current offset.",[58783,58784],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,4896,0,null,null," Repositions read/write file offset relative to the end.",[58786,58787],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"offset",null,"",null,false],[350,4940,0,null,null," Returns the read/write file offset relative to the beginning.",[58789],false],[0,0,0,"fd",null,"",null,false],[350,4983,0,null,null,null,null,false],[350,4992,0,null,null,null,[58792,58793,58794],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"cmd",null,"",null,false],[0,0,0,"arg",null,"",null,false],[350,5012,0,null,null,null,[58796,58797],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,5070,0,null,null,null,null,false],[350,5082,0,null,null," Depending on the operating system `flock` may or may not interact with\n `fcntl` locks made by other processes.",[58800,58801],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"operation",null,"",null,false],[350,5098,0,null,null,null,null,false],[350,5137,0,null,null," Return the canonicalized absolute pathname.\n Expands all symbolic links and resolves references to `.`, `..`, and\n extra `/` characters in `pathname`.\n The return value is a slice of `out_buffer`, but not necessarily from the beginning.\n See also `realpathZ` and `realpathW`.",[58804,58805],false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,5149,0,null,null," Same as `realpath` except `pathname` is null-terminated.",[58807,58808],false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,5187,0,null,null," Same as `realpath` except `pathname` is UTF16LE-encoded.",[58810,58811],false],[0,0,0,"pathname",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,5213,0,null,null,null,[58813],false],[0,0,0,"os",null,"",null,false],[350,5233,0,null,null," Return canonical path of handle `fd`.\n This function is very host-specific and is not universally supported by all hosts.\n For example, while it generally works on Linux, macOS, FreeBSD or Windows, it is\n unsupported on WASI.",[58815,58816],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"out_buffer",null,"",null,false],[350,5368,0,null,null," Spurious wakeups are possible and no precision of timing is guaranteed.",[58818,58819],false],[0,0,0,"seconds",null,"",null,false],[0,0,0,"nanoseconds",null,"",null,false],[350,5392,0,null,null,null,[58821,58822,58823],false],[0,0,0,"context",null,"",null,false],[0,0,0,"Error",null,"",null,true],[0,0,0,"callback",null,"",[58824,58825,58826],true],[0,0,0,"info",null,"",null,false],[0,0,0,"size",null,"",null,false],[0,0,0,"context",null,"",null,false],[350,5476,0,null,null,null,null,false],[350,5480,0,null,null," TODO: change this to return the timespec as a return value\n TODO: look into making clk_id an enum",[58829,58830],false],[0,0,0,"clk_id",null,"",null,false],[0,0,0,"tp",null,"",null,false],[350,5521,0,null,null,null,[58832,58833],false],[0,0,0,"clk_id",null,"",null,false],[0,0,0,"res",null,"",null,false],[350,5543,0,null,null,null,null,false],[350,5545,0,null,null,null,[58836],false],[0,0,0,"pid",null,"",null,false],[350,5559,0,null,null," Used to convert a slice to a null terminated slice on the stack.\n TODO https://github.com/ziglang/zig/issues/287",[58838],false],[0,0,0,"file_path",null,"",null,false],[350,5573,0,null,null," Whether or not error.Unexpected will print its value and a stack trace.\n if this happens the fix is to add the error code to the corresponding\n switch expression, possibly introduce a new error in the error set, and\n send a patch to Zig.",null,false],[350,5575,0,null,null,null,null,false],[350,5584,0,null,null," Call this when you made a syscall or something that sets errno\n and you get an unexpected error.",[58842],false],[0,0,0,"err",null,"",null,false],[350,5592,0,null,null,null,null,false],[350,5600,0,null,null,null,[58845,58846],false],[0,0,0,"ss",null,"",null,false],[0,0,0,"old_ss",null,"",null,false],[350,5612,0,null,null," Examine and change a signal action.",[58848,58849,58850],false],[0,0,0,"sig",null,"",null,false],[0,0,0,"act",null,"",null,false],[0,0,0,"oact",null,"",null,false],[350,5621,0,null,null," Sets the thread signal mask.",[58852,58853,58854],false],[0,0,0,"flags",null,"",null,false],[0,0,0,"set",null,"",null,false],[0,0,0,"oldset",null,"",null,false],[350,5630,0,null,null,null,null,false],[350,5654,0,null,null,null,[58857,58858],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"times",null,"",null,false],[350,5685,0,null,null,null,null,false],[350,5687,0,null,null,null,[58861],false],[0,0,0,"name_buffer",null,"",null,false],[350,5708,0,null,null,null,[],false],[350,5717,0,null,null,null,[58864,58865,58866,58867,58868,58869,58870],false],[0,0,0,"op",null,"",null,false],[0,0,0,"dname",null,"",null,false],[0,0,0,"class",null,"",null,false],[0,0,0,"ty",null,"",null,false],[0,0,0,"data",null,"",null,false],[0,0,0,"newrr",null,"",null,false],[0,0,0,"buf",null,"",null,false],[350,5767,0,null,null,null,null,false],[350,5814,0,null,null,null,null,false],[350,5833,0,null,null,null,[58874,58875,58876],false],[0,0,0,"sockfd",null," The file descriptor of the sending socket.",null,false],[0,0,0,"msg",null," Message header and iovecs",null,false],[0,0,0,"flags",null,"",null,false],[350,5904,0,null,null,null,null,false],[350,5934,0,null,null," Transmit a message to another socket.\n\n The `sendto` call may be used only when the socket is in a connected state (so that the intended\n recipient  is  known). The  following call\n\n     send(sockfd, buf, len, flags);\n\n is equivalent to\n\n     sendto(sockfd, buf, len, flags, NULL, 0);\n\n If  sendto()  is used on a connection-mode (`SOCK.STREAM`, `SOCK.SEQPACKET`) socket, the arguments\n `dest_addr` and `addrlen` are asserted to be `null` and `0` respectively, and asserted\n that the socket was actually connected.\n Otherwise, the address of the target is given by `dest_addr` with `addrlen` specifying  its  size.\n\n If the message is too long to pass atomically through the underlying protocol,\n `SendError.MessageTooBig` is returned, and the message is not transmitted.\n\n There is no  indication  of  failure  to  deliver.\n\n When the message does not fit into the send buffer of  the  socket,  `sendto`  normally  blocks,\n unless  the socket has been placed in nonblocking I/O mode.  In nonblocking mode it would fail\n with `SendError.WouldBlock`.  The `select` call may be used  to  determine when it is\n possible to send more data.",[58879,58880,58881,58882,58883],false],[0,0,0,"sockfd",null," The file descriptor of the sending socket.",null,false],[0,0,0,"buf",null," Message to send.",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"dest_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[350,6024,0,null,null," Transmit a message to another socket.\n\n The `send` call may be used only when the socket is in a connected state (so that the intended\n recipient  is  known).   The  only  difference  between `send` and `write` is the presence of\n flags.  With a zero flags argument, `send` is equivalent to  `write`.   Also,  the  following\n call\n\n     send(sockfd, buf, len, flags);\n\n is equivalent to\n\n     sendto(sockfd, buf, len, flags, NULL, 0);\n\n There is no  indication  of  failure  to  deliver.\n\n When the message does not fit into the send buffer of  the  socket,  `send`  normally  blocks,\n unless  the socket has been placed in nonblocking I/O mode.  In nonblocking mode it would fail\n with `SendError.WouldBlock`.  The `select` call may be used  to  determine when it is\n possible to send more data.",[58885,58886,58887],false],[0,0,0,"sockfd",null," The file descriptor of the sending socket.",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6044,0,null,null,null,null,false],[350,6046,0,null,null,null,[58890],false],[0,0,0,"iovs",null,"",null,false],[350,6088,0,null,null," Transfer data between file descriptors, with optional headers and trailers.\n Returns the number of bytes written, which can be zero.\n\n The `sendfile` call copies `in_len` bytes from one file descriptor to another. When possible,\n this is done within the operating system kernel, which can provide better performance\n characteristics than transferring data from kernel to user space and back, such as with\n `read` and `write` calls. When `in_len` is `0`, it means to copy until the end of the input file has been\n reached. Note, however, that partial writes are still possible in this case.\n\n `in_fd` must be a file descriptor opened for reading, and `out_fd` must be a file descriptor\n opened for writing. They may be any kind of file descriptor; however, if `in_fd` is not a regular\n file system file, it may cause this function to fall back to calling `read` and `write`, in which case\n atomicity guarantees no longer apply.\n\n Copying begins reading at `in_offset`. The input file descriptor seek position is ignored and not updated.\n If the output file descriptor has a seek position, it is updated as bytes are written. When\n `in_offset` is past the end of the input file, it successfully reads 0 bytes.\n\n `flags` has different meanings per operating system; refer to the respective man pages.\n\n These systems support atomically sending everything, including headers and trailers:\n * macOS\n * FreeBSD\n\n These systems support in-kernel data copying, but headers and trailers are not sent atomically:\n * Linux\n\n Other systems fall back to calling `read` / `write`.\n\n Linux has a limit on how many bytes may be transferred in one `sendfile` call, which is `0x7ffff000`\n on both 64-bit and 32-bit systems. This is due to using a signed C int as the return value, as\n well as stuffing the errno codes into the last `4096` values. This is noted on the `sendfile` man page.\n The limit on Darwin is `0x7fffffff`, trying to write more than that returns EINVAL.\n The corresponding POSIX limit on this is `math.maxInt(isize)`.",[58892,58893,58894,58895,58896,58897,58898],false],[0,0,0,"out_fd",null,"",null,false],[0,0,0,"in_fd",null,"",null,false],[0,0,0,"in_offset",null,"",null,false],[0,0,0,"in_len",null,"",null,false],[0,0,0,"headers",null,"",null,false],[0,0,0,"trailers",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6366,0,null,null,null,null,false],[350,6381,0,null,null,null,null,false],[350,6409,0,null,null," Transfer data between file descriptors at specified offsets.\n Returns the number of bytes written, which can less than requested.\n\n The `copy_file_range` call copies `len` bytes from one file descriptor to another. When possible,\n this is done within the operating system kernel, which can provide better performance\n characteristics than transferring data from kernel to user space and back, such as with\n `pread` and `pwrite` calls.\n\n `fd_in` must be a file descriptor opened for reading, and `fd_out` must be a file descriptor\n opened for writing. They may be any kind of file descriptor; however, if `fd_in` is not a regular\n file system file, it may cause this function to fall back to calling `pread` and `pwrite`, in which case\n atomicity guarantees no longer apply.\n\n If `fd_in` and `fd_out` are the same, source and target ranges must not overlap.\n The file descriptor seek positions are ignored and not updated.\n When `off_in` is past the end of the input file, it successfully reads 0 bytes.\n\n `flags` has different meanings per operating system; refer to the respective man pages.\n\n These systems support in-kernel data copying:\n * Linux 4.5 (cross-filesystem 5.3)\n * FreeBSD 13.0\n\n Other systems fall back to calling `pread` / `pwrite`.\n\n Maximum offsets on Linux and FreeBSD are `math.maxInt(i64)`.",[58902,58903,58904,58905,58906,58907],false],[0,0,0,"fd_in",null,"",null,false],[0,0,0,"off_in",null,"",null,false],[0,0,0,"fd_out",null,"",null,false],[0,0,0,"off_out",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6466,0,null,null,null,null,false],[350,6474,0,null,null,null,[58910,58911],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[350,6504,0,null,null,null,null,false],[350,6512,0,null,null,null,[58914,58915,58916],false],[0,0,0,"fds",null,"",null,false],[0,0,0,"timeout",null,"",null,false],[0,0,0,"mask",null,"",null,false],[350,6531,0,null,null,null,null,false],[350,6558,0,null,null,null,[58919,58920,58921],false],[0,0,0,"sock",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6564,0,null,null," If `sockfd` is opened in non blocking mode, the function will\n return error.WouldBlock when EAGAIN is received.",[58923,58924,58925,58926,58927],false],[0,0,0,"sockfd",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"src_addr",null,"",null,false],[0,0,0,"addrlen",null,"",null,false],[350,6608,0,null,null,null,null,false],[350,6610,0,null,null,null,[58930,58931,58932],false],[0,0,0,"msg",null,"",null,false],[0,0,0,"comp_dn",null,"",null,false],[0,0,0,"exp_dn",null,"",null,false],[350,6658,0,null,null,null,null,false],[350,6681,0,null,null," Set a socket's options.",[58935,58936,58937,58938],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"level",null,"",null,false],[0,0,0,"optname",null,"",null,false],[0,0,0,"opt",null,"",null,false],[350,6714,0,null,null,null,null,false],[350,6724,0,null,null,null,[58941,58942],false],[0,0,0,"name",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6761,0,null,null,null,null,false],[350,6762,0,null,null,null,null,false],[350,6763,0,null,null,null,[58946],false],[0,0,0,"name",null,"",null,false],[350,6772,0,null,null,null,[58948,58949],false],[0,0,0,"name",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6777,0,null,null,null,[58951],false],[0,0,0,"who",null,"",null,false],[350,6788,0,null,null,null,null,false],[350,6790,0,null,null,null,null,false],[350,6792,0,null,null,null,[58955],false],[0,0,0,"handle",null,"",null,false],[350,6805,0,null,null,null,null,false],[350,6807,0,null,null,null,[58958,58959,58960],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"optional_action",null,"",null,false],[0,0,0,"termios_p",null,"",null,false],[350,6821,0,null,null,null,null,false],[350,6824,0,null,null," Returns the process group ID for the TTY associated with the given handle.",[58963],false],[0,0,0,"handle",null,"",null,false],[350,6838,0,null,null,null,null,false],[350,6844,0,null,null," Sets the controlling process group ID for given TTY.\n handle must be valid fd_t to a TTY associated with calling process.\n pgrp must be a valid process group, and the calling process must be a member\n of that group.",[58966,58967],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"pgrp",null,"",null,false],[350,6858,0,null,null,null,null,false],[350,6863,0,null,null,null,[58970,58971],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"ifr",null,"",null,false],[350,6880,0,null,null,null,[58973,58974,58975],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"mask",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,6894,0,null,null,null,null,false],[350,6902,0,null,null," Write all pending file contents and metadata modifications to all filesystems.",[],false],[350,6907,0,null,null," Write all pending file contents and metadata modifications to the filesystem which contains the specified file.",[58979],false],[0,0,0,"fd",null,"",null,false],[350,6920,0,null,null," Write all pending file contents and metadata modifications for the specified file descriptor to the underlying filesystem.",[58981],false],[0,0,0,"fd",null,"",null,false],[350,6944,0,null,null," Write all pending file contents for the specified file descriptor to the underlying filesystem, but not necessarily the metadata.",[58983],false],[0,0,0,"fd",null,"",null,false],[350,6962,0,null,null,null,null,false],[350,6977,0,null,null,null,[58986,58987],false],[0,0,0,"option",null,"",null,false],[0,0,0,"args",null,"",null,false],[350,7004,0,null,null,null,null,false],[350,7006,0,null,null,null,[58990],false],[0,0,0,"resource",null,"",null,false],[350,7018,0,null,null,null,null,false],[350,7020,0,null,null,null,[58993,58994],false],[0,0,0,"resource",null,"",null,false],[0,0,0,"limits",null,"",null,false],[350,7032,0,null,null,null,null,false],[350,7049,0,null,null," Determine whether pages are resident in memory.",[58997,58998,58999],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"vec",null,"",null,false],[350,7061,0,null,null,null,null,false],[350,7095,0,null,null," Give advice about use of memory.\n This syscall is optional and is sometimes configured to be disabled.",[59002,59003,59004],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"length",null,"",null,false],[0,0,0,"advice",null,"",null,false],[350,7109,0,null,null,null,null,false],[350,7163,0,null,null,null,[59007,59008,59009,59010,59011],false],[0,0,0,"attr",null,"",null,false],[0,0,0,"pid",null,"",null,false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"group_fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,7193,0,null,null,null,null,false],[350,7201,0,null,null,null,null,false],[350,7202,0,null,null,null,null,false],[350,7204,0,null,null,null,[59016,59017],false],[0,0,0,"clokid",null,"",null,false],[0,0,0,"flags",null,"",null,false],[350,7218,0,null,null,null,[59019,59020,59021,59022],false],[0,0,0,"fd",null,"",null,false],[0,0,0,"flags",null,"",null,false],[0,0,0,"new_value",null,"",null,false],[0,0,0,"old_value",null,"",null,false],[350,7230,0,null,null,null,[59024],false],[0,0,0,"fd",null,"",null,false],[350,7242,0,null,null,null,null,false],[350,7250,0,null,null,null,[59027,59028,59029,59030],false],[0,0,0,"request",null,"",null,false],[0,0,0,"pid",null,"",null,false],[0,0,0,"addr",null,"",null,false],[0,0,0,"signal",null,"",null,false],[350,7291,0,null,null,null,null,false],[1,148,0,null,null,null,null,false],[0,0,0,"once.zig",null,"",[],false],[418,0,0,null,null,null,null,false],[418,1,0,null,null,null,null,false],[418,2,0,null,null,null,null,false],[418,4,0,null,null,null,[59038],false],[0,0,0,"f",null,"",[],true],[418,9,0,null,null," An object that executes the function `f` just once.",[59040],false],[0,0,0,"f",null,"",[59045,59047],true],[418,18,0,null,null," Call the function `f`.\n If `call` is invoked multiple times `f` will be executed only the\n first time.\n The invocations are thread-safe.",[59042],false],[0,0,0,"self",null,"",null,false],[418,25,0,null,null,null,[59044],false],[0,0,0,"self",null,"",null,false],[0,0,0,"done",null,null,null,false],[418,10,0,null,null,null,null,false],[0,0,0,"mutex",null,null,null,false],[418,40,0,null,null,null,null,false],[418,41,0,null,null,null,null,false],[418,43,0,null,null,null,[],false],[1,151,0,null,null," A set of array and slice types that bit-pack integer elements.",null,false],[1,154,0,null,null," PDB file format.",null,false],[0,0,0,"pdb.zig",null,"",[],false],[419,0,0,null,null,null,null,false],[419,1,0,null,null,null,null,false],[419,2,0,null,null,null,null,false],[419,3,0,null,null,null,null,false],[419,4,0,null,null,null,null,false],[419,5,0,null,null,null,null,false],[419,6,0,null,null,null,null,false],[419,7,0,null,null,null,null,false],[419,8,0,null,null,null,null,false],[419,10,0,null,null,null,null,false],[419,16,0,null,null,null,[59065,59066,59067,59068,59069,59070,59071,59072,59073,59074,59075,59076,59077,59078,59079,59080,59081,59082,59083,59084],false],[0,0,0,"VersionSignature",null,null,null,false],[0,0,0,"VersionHeader",null,null,null,false],[0,0,0,"Age",null,null,null,false],[0,0,0,"GlobalStreamIndex",null,null,null,false],[0,0,0,"BuildNumber",null,null,null,false],[0,0,0,"PublicStreamIndex",null,null,null,false],[0,0,0,"PdbDllVersion",null,null,null,false],[0,0,0,"SymRecordStream",null,null,null,false],[0,0,0,"PdbDllRbld",null,null,null,false],[0,0,0,"ModInfoSize",null,null,null,false],[0,0,0,"SectionContributionSize",null,null,null,false],[0,0,0,"SectionMapSize",null,null,null,false],[0,0,0,"SourceInfoSize",null,null,null,false],[0,0,0,"TypeServerSize",null,null,null,false],[0,0,0,"MFCTypeServerIndex",null,null,null,false],[0,0,0,"OptionalDbgHeaderSize",null,null,null,false],[0,0,0,"ECSubstreamSize",null,null,null,false],[0,0,0,"Flags",null,null,null,false],[0,0,0,"Machine",null,null,null,false],[0,0,0,"Padding",null,null,null,false],[419,39,0,null,null,null,[59086,59088,59089,59090,59091,59092,59094,59095,59096],false],[0,0,0,"Section",null," COFF Section index, 1-based",null,false],[419,39,0,null,null,null,null,false],[0,0,0,"Padding1",null,null,null,false],[0,0,0,"Offset",null,null,null,false],[0,0,0,"Size",null,null,null,false],[0,0,0,"Characteristics",null,null,null,false],[0,0,0,"ModuleIndex",null,null,null,false],[419,39,0,null,null,null,null,false],[0,0,0,"Padding2",null,null,null,false],[0,0,0,"DataCrc",null,null,null,false],[0,0,0,"RelocCrc",null,null,null,false],[419,52,0,null,null,null,[59098,59100,59101,59102,59103,59104,59105,59106,59108,59109,59110,59111],false],[0,0,0,"Unused1",null,null,null,false],[419,52,0,null,null,null,null,false],[0,0,0,"SectionContr",null,null,null,false],[0,0,0,"Flags",null,null,null,false],[0,0,0,"ModuleSymStream",null,null,null,false],[0,0,0,"SymByteSize",null,null,null,false],[0,0,0,"C11ByteSize",null,null,null,false],[0,0,0,"C13ByteSize",null,null,null,false],[0,0,0,"SourceFileCount",null,null,null,false],[419,52,0,null,null,null,null,false],[0,0,0,"Padding",null,null,null,false],[0,0,0,"Unused2",null,null,null,false],[0,0,0,"SourceFileNameIndex",null,null,null,false],[0,0,0,"PdbFilePathNameIndex",null,null,null,false],[419,70,0,null,null,null,[59113,59114],false],[0,0,0,"Count",null," Number of segment descriptors",null,false],[0,0,0,"LogCount",null," Number of logical segment descriptors",null,false],[419,78,0,null,null,null,[59116,59117,59118,59119,59120,59121,59122,59123],false],[0,0,0,"Flags",null," See the SectionMapEntryFlags enum below.",null,false],[0,0,0,"Ovl",null," Logical overlay number",null,false],[0,0,0,"Group",null," Group index into descriptor array.",null,false],[0,0,0,"Frame",null,null,null,false],[0,0,0,"SectionName",null," Byte index of segment / group name in string table, or 0xFFFF.",null,false],[0,0,0,"ClassName",null," Byte index of class in string table, or 0xFFFF.",null,false],[0,0,0,"Offset",null," Byte offset of the logical segment within physical segment.  If group is set in flags, this is the offset of the group.",null,false],[0,0,0,"SectionLength",null," Byte count of the segment or group.",null,false],[419,102,0,null,null,null,[59125,59126,59127,59128],false],[0,0,0,"Pdb",null,null,null,false],[0,0,0,"Tpi",null,null,null,false],[0,0,0,"Dbi",null,null,null,false],[0,0,0,"Ipi",null,null,null,false],[419,111,0,null,null," Duplicate copy of SymbolRecordKind, but using the official CV names. Useful\n for reference purposes and when dealing with unknown record types.",[59130,59131,59132,59133,59134,59135,59136,59137,59138,59139,59140,59141,59142,59143,59144,59145,59146,59147,59148,59149,59150,59151,59152,59153,59154,59155,59156,59157,59158,59159,59160,59161,59162,59163,59164,59165,59166,59167,59168,59169,59170,59171,59172,59173,59174,59175,59176,59177,59178,59179,59180,59181,59182,59183,59184,59185,59186,59187,59188,59189,59190,59191,59192,59193,59194,59195,59196,59197,59198,59199,59200,59201,59202,59203,59204,59205,59206,59207,59208,59209,59210,59211,59212,59213,59214,59215,59216,59217,59218,59219,59220,59221,59222,59223,59224,59225,59226,59227,59228,59229,59230,59231,59232,59233,59234,59235,59236,59237,59238,59239,59240,59241,59242,59243,59244,59245,59246,59247,59248,59249,59250,59251,59252,59253,59254,59255,59256,59257,59258,59259,59260,59261,59262,59263,59264,59265,59266,59267,59268,59269,59270,59271,59272,59273,59274,59275,59276,59277,59278,59279,59280,59281,59282,59283,59284,59285,59286,59287,59288,59289,59290,59291,59292,59293,59294,59295,59296,59297,59298,59299,59300,59301,59302,59303,59304,59305,59306,59307,59308,59309,59310,59311,59312,59313,59314,59315,59316,59317,59318,59319,59320,59321,59322,59323,59324,59325],false],[0,0,0,"S_COMPILE",null,null,null,false],[0,0,0,"S_REGISTER_16t",null,null,null,false],[0,0,0,"S_CONSTANT_16t",null,null,null,false],[0,0,0,"S_UDT_16t",null,null,null,false],[0,0,0,"S_SSEARCH",null,null,null,false],[0,0,0,"S_SKIP",null,null,null,false],[0,0,0,"S_CVRESERVE",null,null,null,false],[0,0,0,"S_OBJNAME_ST",null,null,null,false],[0,0,0,"S_ENDARG",null,null,null,false],[0,0,0,"S_COBOLUDT_16t",null,null,null,false],[0,0,0,"S_MANYREG_16t",null,null,null,false],[0,0,0,"S_RETURN",null,null,null,false],[0,0,0,"S_ENTRYTHIS",null,null,null,false],[0,0,0,"S_BPREL16",null,null,null,false],[0,0,0,"S_LDATA16",null,null,null,false],[0,0,0,"S_GDATA16",null,null,null,false],[0,0,0,"S_PUB16",null,null,null,false],[0,0,0,"S_LPROC16",null,null,null,false],[0,0,0,"S_GPROC16",null,null,null,false],[0,0,0,"S_THUNK16",null,null,null,false],[0,0,0,"S_BLOCK16",null,null,null,false],[0,0,0,"S_WITH16",null,null,null,false],[0,0,0,"S_LABEL16",null,null,null,false],[0,0,0,"S_CEXMODEL16",null,null,null,false],[0,0,0,"S_VFTABLE16",null,null,null,false],[0,0,0,"S_REGREL16",null,null,null,false],[0,0,0,"S_BPREL32_16t",null,null,null,false],[0,0,0,"S_LDATA32_16t",null,null,null,false],[0,0,0,"S_GDATA32_16t",null,null,null,false],[0,0,0,"S_PUB32_16t",null,null,null,false],[0,0,0,"S_LPROC32_16t",null,null,null,false],[0,0,0,"S_GPROC32_16t",null,null,null,false],[0,0,0,"S_THUNK32_ST",null,null,null,false],[0,0,0,"S_BLOCK32_ST",null,null,null,false],[0,0,0,"S_WITH32_ST",null,null,null,false],[0,0,0,"S_LABEL32_ST",null,null,null,false],[0,0,0,"S_CEXMODEL32",null,null,null,false],[0,0,0,"S_VFTABLE32_16t",null,null,null,false],[0,0,0,"S_REGREL32_16t",null,null,null,false],[0,0,0,"S_LTHREAD32_16t",null,null,null,false],[0,0,0,"S_GTHREAD32_16t",null,null,null,false],[0,0,0,"S_SLINK32",null,null,null,false],[0,0,0,"S_LPROCMIPS_16t",null,null,null,false],[0,0,0,"S_GPROCMIPS_16t",null,null,null,false],[0,0,0,"S_PROCREF_ST",null,null,null,false],[0,0,0,"S_DATAREF_ST",null,null,null,false],[0,0,0,"S_ALIGN",null,null,null,false],[0,0,0,"S_LPROCREF_ST",null,null,null,false],[0,0,0,"S_OEM",null,null,null,false],[0,0,0,"S_TI16_MAX",null,null,null,false],[0,0,0,"S_REGISTER_ST",null,null,null,false],[0,0,0,"S_CONSTANT_ST",null,null,null,false],[0,0,0,"S_UDT_ST",null,null,null,false],[0,0,0,"S_COBOLUDT_ST",null,null,null,false],[0,0,0,"S_MANYREG_ST",null,null,null,false],[0,0,0,"S_BPREL32_ST",null,null,null,false],[0,0,0,"S_LDATA32_ST",null,null,null,false],[0,0,0,"S_GDATA32_ST",null,null,null,false],[0,0,0,"S_PUB32_ST",null,null,null,false],[0,0,0,"S_LPROC32_ST",null,null,null,false],[0,0,0,"S_GPROC32_ST",null,null,null,false],[0,0,0,"S_VFTABLE32",null,null,null,false],[0,0,0,"S_REGREL32_ST",null,null,null,false],[0,0,0,"S_LTHREAD32_ST",null,null,null,false],[0,0,0,"S_GTHREAD32_ST",null,null,null,false],[0,0,0,"S_LPROCMIPS_ST",null,null,null,false],[0,0,0,"S_GPROCMIPS_ST",null,null,null,false],[0,0,0,"S_COMPILE2_ST",null,null,null,false],[0,0,0,"S_MANYREG2_ST",null,null,null,false],[0,0,0,"S_LPROCIA64_ST",null,null,null,false],[0,0,0,"S_GPROCIA64_ST",null,null,null,false],[0,0,0,"S_LOCALSLOT_ST",null,null,null,false],[0,0,0,"S_PARAMSLOT_ST",null,null,null,false],[0,0,0,"S_ANNOTATION",null,null,null,false],[0,0,0,"S_GMANPROC_ST",null,null,null,false],[0,0,0,"S_LMANPROC_ST",null,null,null,false],[0,0,0,"S_RESERVED1",null,null,null,false],[0,0,0,"S_RESERVED2",null,null,null,false],[0,0,0,"S_RESERVED3",null,null,null,false],[0,0,0,"S_RESERVED4",null,null,null,false],[0,0,0,"S_LMANDATA_ST",null,null,null,false],[0,0,0,"S_GMANDATA_ST",null,null,null,false],[0,0,0,"S_MANFRAMEREL_ST",null,null,null,false],[0,0,0,"S_MANREGISTER_ST",null,null,null,false],[0,0,0,"S_MANSLOT_ST",null,null,null,false],[0,0,0,"S_MANMANYREG_ST",null,null,null,false],[0,0,0,"S_MANREGREL_ST",null,null,null,false],[0,0,0,"S_MANMANYREG2_ST",null,null,null,false],[0,0,0,"S_MANTYPREF",null,null,null,false],[0,0,0,"S_UNAMESPACE_ST",null,null,null,false],[0,0,0,"S_ST_MAX",null,null,null,false],[0,0,0,"S_WITH32",null,null,null,false],[0,0,0,"S_MANYREG",null,null,null,false],[0,0,0,"S_LPROCMIPS",null,null,null,false],[0,0,0,"S_GPROCMIPS",null,null,null,false],[0,0,0,"S_MANYREG2",null,null,null,false],[0,0,0,"S_LPROCIA64",null,null,null,false],[0,0,0,"S_GPROCIA64",null,null,null,false],[0,0,0,"S_LOCALSLOT",null,null,null,false],[0,0,0,"S_PARAMSLOT",null,null,null,false],[0,0,0,"S_MANFRAMEREL",null,null,null,false],[0,0,0,"S_MANREGISTER",null,null,null,false],[0,0,0,"S_MANSLOT",null,null,null,false],[0,0,0,"S_MANMANYREG",null,null,null,false],[0,0,0,"S_MANREGREL",null,null,null,false],[0,0,0,"S_MANMANYREG2",null,null,null,false],[0,0,0,"S_UNAMESPACE",null,null,null,false],[0,0,0,"S_DATAREF",null,null,null,false],[0,0,0,"S_ANNOTATIONREF",null,null,null,false],[0,0,0,"S_TOKENREF",null,null,null,false],[0,0,0,"S_GMANPROC",null,null,null,false],[0,0,0,"S_LMANPROC",null,null,null,false],[0,0,0,"S_ATTR_FRAMEREL",null,null,null,false],[0,0,0,"S_ATTR_REGISTER",null,null,null,false],[0,0,0,"S_ATTR_REGREL",null,null,null,false],[0,0,0,"S_ATTR_MANYREG",null,null,null,false],[0,0,0,"S_SEPCODE",null,null,null,false],[0,0,0,"S_LOCAL_2005",null,null,null,false],[0,0,0,"S_DEFRANGE_2005",null,null,null,false],[0,0,0,"S_DEFRANGE2_2005",null,null,null,false],[0,0,0,"S_DISCARDED",null,null,null,false],[0,0,0,"S_LPROCMIPS_ID",null,null,null,false],[0,0,0,"S_GPROCMIPS_ID",null,null,null,false],[0,0,0,"S_LPROCIA64_ID",null,null,null,false],[0,0,0,"S_GPROCIA64_ID",null,null,null,false],[0,0,0,"S_DEFRANGE_HLSL",null,null,null,false],[0,0,0,"S_GDATA_HLSL",null,null,null,false],[0,0,0,"S_LDATA_HLSL",null,null,null,false],[0,0,0,"S_LOCAL_DPC_GROUPSHARED",null,null,null,false],[0,0,0,"S_DEFRANGE_DPC_PTR_TAG",null,null,null,false],[0,0,0,"S_DPC_SYM_TAG_MAP",null,null,null,false],[0,0,0,"S_ARMSWITCHTABLE",null,null,null,false],[0,0,0,"S_POGODATA",null,null,null,false],[0,0,0,"S_INLINESITE2",null,null,null,false],[0,0,0,"S_MOD_TYPEREF",null,null,null,false],[0,0,0,"S_REF_MINIPDB",null,null,null,false],[0,0,0,"S_PDBMAP",null,null,null,false],[0,0,0,"S_GDATA_HLSL32",null,null,null,false],[0,0,0,"S_LDATA_HLSL32",null,null,null,false],[0,0,0,"S_GDATA_HLSL32_EX",null,null,null,false],[0,0,0,"S_LDATA_HLSL32_EX",null,null,null,false],[0,0,0,"S_FASTLINK",null,null,null,false],[0,0,0,"S_INLINEES",null,null,null,false],[0,0,0,"S_END",null,null,null,false],[0,0,0,"S_INLINESITE_END",null,null,null,false],[0,0,0,"S_PROC_ID_END",null,null,null,false],[0,0,0,"S_THUNK32",null,null,null,false],[0,0,0,"S_TRAMPOLINE",null,null,null,false],[0,0,0,"S_SECTION",null,null,null,false],[0,0,0,"S_COFFGROUP",null,null,null,false],[0,0,0,"S_EXPORT",null,null,null,false],[0,0,0,"S_LPROC32",null,null,null,false],[0,0,0,"S_GPROC32",null,null,null,false],[0,0,0,"S_LPROC32_ID",null,null,null,false],[0,0,0,"S_GPROC32_ID",null,null,null,false],[0,0,0,"S_LPROC32_DPC",null,null,null,false],[0,0,0,"S_LPROC32_DPC_ID",null,null,null,false],[0,0,0,"S_REGISTER",null,null,null,false],[0,0,0,"S_PUB32",null,null,null,false],[0,0,0,"S_PROCREF",null,null,null,false],[0,0,0,"S_LPROCREF",null,null,null,false],[0,0,0,"S_ENVBLOCK",null,null,null,false],[0,0,0,"S_INLINESITE",null,null,null,false],[0,0,0,"S_LOCAL",null,null,null,false],[0,0,0,"S_DEFRANGE",null,null,null,false],[0,0,0,"S_DEFRANGE_SUBFIELD",null,null,null,false],[0,0,0,"S_DEFRANGE_REGISTER",null,null,null,false],[0,0,0,"S_DEFRANGE_FRAMEPOINTER_REL",null,null,null,false],[0,0,0,"S_DEFRANGE_SUBFIELD_REGISTER",null,null,null,false],[0,0,0,"S_DEFRANGE_FRAMEPOINTER_REL_FULL_SCOPE",null,null,null,false],[0,0,0,"S_DEFRANGE_REGISTER_REL",null,null,null,false],[0,0,0,"S_BLOCK32",null,null,null,false],[0,0,0,"S_LABEL32",null,null,null,false],[0,0,0,"S_OBJNAME",null,null,null,false],[0,0,0,"S_COMPILE2",null,null,null,false],[0,0,0,"S_COMPILE3",null,null,null,false],[0,0,0,"S_FRAMEPROC",null,null,null,false],[0,0,0,"S_CALLSITEINFO",null,null,null,false],[0,0,0,"S_FILESTATIC",null,null,null,false],[0,0,0,"S_HEAPALLOCSITE",null,null,null,false],[0,0,0,"S_FRAMECOOKIE",null,null,null,false],[0,0,0,"S_CALLEES",null,null,null,false],[0,0,0,"S_CALLERS",null,null,null,false],[0,0,0,"S_UDT",null,null,null,false],[0,0,0,"S_COBOLUDT",null,null,null,false],[0,0,0,"S_BUILDINFO",null,null,null,false],[0,0,0,"S_BPREL32",null,null,null,false],[0,0,0,"S_REGREL32",null,null,null,false],[0,0,0,"S_CONSTANT",null,null,null,false],[0,0,0,"S_MANCONSTANT",null,null,null,false],[0,0,0,"S_LDATA32",null,null,null,false],[0,0,0,"S_GDATA32",null,null,null,false],[0,0,0,"S_LMANDATA",null,null,null,false],[0,0,0,"S_GMANDATA",null,null,null,false],[0,0,0,"S_LTHREAD32",null,null,null,false],[0,0,0,"S_GTHREAD32",null,null,null,false],[419,310,0,null,null,null,null,false],[419,316,0,null,null,null,[59328,59329,59330,59331,59332,59333,59335,59336,59337,59339,59341],false],[0,0,0,"Parent",null,null,null,false],[0,0,0,"End",null,null,null,false],[0,0,0,"Next",null,null,null,false],[0,0,0,"CodeSize",null,null,null,false],[0,0,0,"DbgStart",null,null,null,false],[0,0,0,"DbgEnd",null,null,null,false],[419,316,0,null,null,null,null,false],[0,0,0,"FunctionType",null,null,null,false],[0,0,0,"CodeOffset",null,null,null,false],[0,0,0,"Segment",null,null,null,false],[419,316,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[419,316,0,null,null,null,null,false],[0,0,0,"Name",null,null,null,false],[419,330,0,null,null,null,[59343,59344,59345,59346,59347,59348,59349,59350],false],[0,0,0,"HasFP",null,null,null,false],[0,0,0,"HasIRET",null,null,null,false],[0,0,0,"HasFRET",null,null,null,false],[0,0,0,"IsNoReturn",null,null,null,false],[0,0,0,"IsUnreachable",null,null,null,false],[0,0,0,"HasCustomCallingConv",null,null,null,false],[0,0,0,"IsNoInline",null,null,null,false],[0,0,0,"HasOptimizedDebugInfo",null,null,null,false],[419,341,0,null,null,null,[59352,59353],false],[0,0,0,"Ver60",null,null,null,false],[0,0,0,"V2",null,null,null,false],[419,347,0,null,null,null,[59355,59357],false],[0,0,0,"RecordLen",null," Record length, starting from &RecordKind.",null,false],[419,347,0,null,null,null,null,false],[0,0,0,"RecordKind",null," Record kind enum (SymRecordKind or TypeRecordKind)",null,false],[419,359,0,null,null," The following variable length array appears immediately after the header.\n The structure definition follows.\n LineBlockFragmentHeader Blocks[]\n Each `LineBlockFragmentHeader` as specified below.",[59359,59360,59362,59363],false],[0,0,0,"RelocOffset",null," Code offset of line contribution.",null,false],[0,0,0,"RelocSegment",null," Code segment of line contribution.",null,false],[419,359,0,null,null,null,null,false],[0,0,0,"Flags",null,null,null,false],[0,0,0,"CodeSize",null," Code size of this line contribution.",null,false],[419,371,0,null,null,null,[59365,59367],false],[0,0,0,"LF_HaveColumns",null," CV_LINES_HAVE_COLUMNS",null,false],[419,371,0,null,null,null,null,false],[0,0,0,"unused",null,null,null,false],[419,381,0,null,null," The following two variable length arrays appear immediately after the\n header.  The structure definitions follow.\n LineNumberEntry   Lines[NumLines];\n ColumnNumberEntry Columns[NumLines];",[59369,59370,59371],false],[0,0,0,"NameIndex",null," Offset of FileChecksum entry in File\n checksums buffer.  The checksum entry then\n contains another offset into the string\n table of the actual name.",null,false],[0,0,0,"NumLines",null,null,null,false],[0,0,0,"BlockSize",null," code size of block, in bytes",null,false],[419,393,0,null,null,null,[59379,59380],false],[419,399,0,null,null," TODO runtime crash when I make the actual type of Flags this",[59375,59377,59378],false],[419,399,0,null,null,null,null,false],[0,0,0,"Start",null," Start line number",null,false],[419,399,0,null,null,null,null,false],[0,0,0,"End",null," Delta of lines to the end of the expression. Still unclear.",null,false],[0,0,0,"IsStatement",null,null,null,false],[0,0,0,"Offset",null," Offset to start of code bytes for line number",null,false],[0,0,0,"Flags",null,null,null,false],[419,409,0,null,null,null,[59382,59383],false],[0,0,0,"StartColumn",null,null,null,false],[0,0,0,"EndColumn",null,null,null,false],[419,415,0,null,null," Checksum bytes follow.",[59385,59386,59387],false],[0,0,0,"FileNameOffset",null," Byte offset of filename in global string table.",null,false],[0,0,0,"ChecksumSize",null," Number of bytes of checksum.",null,false],[0,0,0,"ChecksumKind",null," FileChecksumKind",null,false],[419,426,0,null,null,null,[59389,59390,59391,59392,59393,59394,59395,59396,59397,59398,59399,59400,59401,59402],false],[0,0,0,"None",null,null,null,false],[0,0,0,"Symbols",null,null,null,false],[0,0,0,"Lines",null,null,null,false],[0,0,0,"StringTable",null,null,null,false],[0,0,0,"FileChecksums",null,null,null,false],[0,0,0,"FrameData",null,null,null,false],[0,0,0,"InlineeLines",null,null,null,false],[0,0,0,"CrossScopeImports",null,null,null,false],[0,0,0,"CrossScopeExports",null,null,null,false],[0,0,0,"ILLines",null,null,null,false],[0,0,0,"FuncMDTokenMap",null,null,null,false],[0,0,0,"TypeMDTokenMap",null,null,null,false],[0,0,0,"MergedAssemblyInput",null,null,null,false],[0,0,0,"CoffSymbolRVA",null,null,null,false],[419,446,0,null,null,null,[59405,59406],false],[419,446,0,null,null,null,null,false],[0,0,0,"Kind",null," codeview::DebugSubsectionKind enum",null,false],[0,0,0,"Length",null," number of bytes occupied by this record.",null,false],[419,454,0,null,null,null,[59408,59409,59410],false],[0,0,0,"Signature",null," PDBStringTableSignature",null,false],[0,0,0,"HashVersion",null," 1 or 2",null,false],[0,0,0,"ByteSize",null," Number of bytes of names buffer.",null,false],[419,465,0,null,null,null,[59412,59413],false],[0,0,0,"stream",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[419,483,0,null,null,null,[59459,59461,59463,59465,59467,59469,59471,59473,59474],false],[419,494,0,null,null,null,[59420,59422,59424,59425,59427,59429,59431],false],[419,504,0,null,null,null,[59417,59418],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[419,494,0,null,null,null,null,false],[0,0,0,"mod_info",null,null,null,false],[419,494,0,null,null,null,null,false],[0,0,0,"module_name",null,null,null,false],[419,494,0,null,null,null,null,false],[0,0,0,"obj_file_name",null,null,null,false],[0,0,0,"populated",null,null,null,false],[419,494,0,null,null,null,null,false],[0,0,0,"symbols",null,null,null,false],[419,494,0,null,null,null,null,false],[0,0,0,"subsect_info",null,null,null,false],[419,494,0,null,null,null,null,false],[0,0,0,"checksum_offset",null,null,null,false],[419,514,0,null,null,null,[59433,59434],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"path",null,"",null,false],[419,531,0,null,null,null,[59436],false],[0,0,0,"self",null,"",null,false],[419,541,0,null,null,null,[59438],false],[0,0,0,"self",null,"",null,false],[419,621,0,null,null,null,[59440],false],[0,0,0,"self",null,"",null,false],[419,685,0,null,null,null,[59442,59443,59444],false],[0,0,0,"self",null,"",null,false],[0,0,0,"module",null,"",null,false],[0,0,0,"address",null,"",null,false],[419,709,0,null,null,null,[59446,59447,59448],false],[0,0,0,"self",null,"",null,false],[0,0,0,"module",null,"",null,false],[0,0,0,"address",null,"",null,false],[419,805,0,null,null,null,[59450,59451],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,"",null,false],[419,858,0,null,null,null,[59453,59454],false],[0,0,0,"self",null,"",null,false],[0,0,0,"id",null,"",null,false],[419,864,0,null,null,null,[59456,59457],false],[0,0,0,"self",null,"",null,false],[0,0,0,"stream",null,"",null,false],[419,483,0,null,null,null,null,false],[0,0,0,"in_file",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"msf",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"string_table",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"dbi",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"modules",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"sect_contribs",null,null,null,false],[419,483,0,null,null,null,null,false],[0,0,0,"guid",null,null,null,false],[0,0,0,"age",null,null,null,false],[419,871,0,null,null,null,[59483,59485],false],[419,875,0,null,null,null,[59477,59478],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"file",null,"",null,false],[419,960,0,null,null,null,[59480,59481],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[419,871,0,null,null,null,null,false],[0,0,0,"directory",null,null,null,false],[419,871,0,null,null,null,null,false],[0,0,0,"streams",null,null,null,false],[419,969,0,null,null,null,[59487,59488],false],[0,0,0,"size",null,"",null,false],[0,0,0,"block_size",null,"",null,false],[419,974,0,null,null,null,[59492,59493,59494,59495,59496,59497,59498],false],[419,976,0,null,null," The LLVM docs list a space between C / C++ but empirically this is not the case.",null,false],[419,974,0,null,null,null,null,false],[0,0,0,"FileMagic",null,null,null,false],[0,0,0,"BlockSize",null," The block size of the internal file system. Valid values are 512, 1024,\n 2048, and 4096 bytes. Certain aspects of the MSF file layout vary depending\n on the block sizes. For the purposes of LLVM, we handle only block sizes of\n 4KiB, and all further discussion assumes a block size of 4KiB.",null,false],[0,0,0,"FreeBlockMapBlock",null," The index of a block within the file, at which begins a bitfield representing\n the set of all blocks within the file which are “free” (i.e. the data within\n that block is not used). See The Free Block Map for more information. Important:\n FreeBlockMapBlock can only be 1 or 2!",null,false],[0,0,0,"NumBlocks",null," The total number of blocks in the file. NumBlocks * BlockSize should equal the\n size of the file on disk.",null,false],[0,0,0,"NumDirectoryBytes",null," The size of the stream directory, in bytes. The stream directory contains\n information about each stream’s size and the set of blocks that it occupies.\n It will be described in more detail later.",null,false],[0,0,0,"Unknown",null,null,null,false],[0,0,0,"BlockMapAddr",null," The index of a block within the MSF file. At this block is an array of\n ulittle32_t’s listing the blocks that the stream directory resides on.\n For large MSF files, the stream directory (which describes the block\n layout of each stream) may not fit entirely on a single block. As a\n result, this extra layer of indirection is introduced, whereby this\n block contains the list of blocks that the stream directory occupies,\n and the stream directory itself can be stitched together accordingly.\n The number of ulittle32_t’s in this array is given by\n ceil(NumDirectoryBytes / BlockSize).",null,false],[419,1020,0,null,null,null,[59521,59522,59524,59525],false],[419,1026,0,null,null,null,null,false],[419,1028,0,null,null,null,[59502,59503,59504],false],[0,0,0,"block_size",null,"",null,false],[0,0,0,"file",null,"",null,false],[0,0,0,"blocks",null,"",null,false],[419,1039,0,null,null,null,[59506,59507],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[419,1070,0,null,null,null,[59509,59510],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,"",null,false],[419,1076,0,null,null,null,[59512,59513],false],[0,0,0,"self",null,"",null,false],[0,0,0,"len",null,"",null,false],[419,1082,0,null,null,null,[59515],false],[0,0,0,"self",null,"",null,false],[419,1086,0,null,null,null,[59517],false],[0,0,0,"self",null,"",null,false],[419,1094,0,null,null,null,[59519],false],[0,0,0,"self",null,"",null,false],[419,1020,0,null,null,null,null,false],[0,0,0,"in_file",null,null,null,false],[0,0,0,"pos",null,null,null,false],[419,1020,0,null,null,null,null,false],[0,0,0,"blocks",null,null,null,false],[0,0,0,"block_size",null,null,null,false],[1,158,0,null,null," Accessors for process-related info (e.g. command line arguments)\n and spawning of child processes.",null,false],[0,0,0,"process.zig",null,"",[],false],[420,0,0,null,null,null,null,false],[420,1,0,null,null,null,null,false],[420,2,0,null,null,null,null,false],[420,3,0,null,null,null,null,false],[420,4,0,null,null,null,null,false],[420,5,0,null,null,null,null,false],[420,6,0,null,null,null,null,false],[420,7,0,null,null,null,null,false],[420,8,0,null,null,null,null,false],[420,9,0,null,null,null,null,false],[420,11,0,null,null,null,null,false],[420,12,0,null,null,null,null,false],[420,13,0,null,null,null,null,false],[420,14,0,null,null,null,null,false],[420,15,0,null,null,null,null,false],[420,18,0,null,null," The result is a slice of `out_buffer`, from index `0`.",[59544],false],[0,0,0,"out_buffer",null,"",null,false],[420,23,0,null,null," Caller must free the returned memory.",[59546],false],[0,0,0,"allocator",null,"",null,false],[420,55,0,null,null,null,[59592],false],[420,58,0,null,null,null,null,false],[420,65,0,null,null,null,null,false],[420,67,0,null,null,null,[],false],[420,68,0,null,null,null,[59552],false],[0,0,0,"c",null,"",null,false],[420,74,0,null,null,null,[59554,59555],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[420,92,0,null,null,null,[59557,59558,59559],false],[0,0,0,"self",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[420,112,0,null,null," Create a EnvMap backed by a specific allocator.\n That allocator will be used for both backing allocations\n and string deduplication.",[59561],false],[0,0,0,"allocator",null,"",null,false],[420,118,0,null,null," Free the backing storage of the map, as well as all\n of the stored keys and values.",[59563],false],[0,0,0,"self",null,"",null,false],[420,132,0,null,null," Same as `put` but the key and value become owned by the EnvMap rather\n than being copied.\n If `putMove` fails, the ownership of key and value does not transfer.\n On Windows `key` must be a valid UTF-8 string.",[59565,59566,59567],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[420,144,0,null,null," `key` and `value` are copied into the EnvMap.\n On Windows `key` must be a valid UTF-8 string.",[59569,59570,59571],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[420,162,0,null,null," Find the address of the value associated with a key.\n The returned pointer is invalidated if the map resizes.\n On Windows `key` must be a valid UTF-8 string.",[59573,59574],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[420,170,0,null,null," Return the map's copy of the value associated with\n a key.  The returned string is invalidated if this\n key is removed from the map.\n On Windows `key` must be a valid UTF-8 string.",[59576,59577],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[420,177,0,null,null," Removes the item from the map and frees its value.\n This invalidates the value returned by get() for this key.\n On Windows `key` must be a valid UTF-8 string.",[59579,59580],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[420,184,0,null,null," Returns the number of KV pairs stored in the map.",[59582],false],[0,0,0,"self",null,"",null,false],[420,189,0,null,null," Returns an iterator over entries in the map.",[59584],false],[0,0,0,"self",null,"",null,false],[420,193,0,null,null,null,[59586,59587],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[420,197,0,null,null,null,[59589,59590],false],[0,0,0,"self",null,"",null,false],[0,0,0,"value",null,"",null,false],[420,55,0,null,null,null,null,false],[0,0,0,"hash_map",null,null,null,false],[420,252,0,null,null," Returns a snapshot of the environment variables of the current process.\n Any modifications to the resulting EnvMap will not be not reflected in the environment, and\n likewise, any future modifications to the environment will not be reflected in the EnvMap.\n Caller owns resulting `EnvMap` and should call its `deinit` fn when done.",[59594],false],[0,0,0,"allocator",null,"",null,false],[420,353,0,null,null,null,null,false],[420,362,0,null,null," Caller must free returned memory.",[59597,59598],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[420,387,0,null,null,null,[59600],false],[0,0,0,"key",null,"",null,true],[420,398,0,null,null,null,[59602,59603],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"key",null,"",null,false],[420,418,0,null,null,null,[59611,59612],false],[420,422,0,null,null,null,null,false],[420,424,0,null,null,null,[],false],[420,431,0,null,null,null,[59608],false],[0,0,0,"self",null,"",null,false],[420,439,0,null,null,null,[59610],false],[0,0,0,"self",null,"",null,false],[0,0,0,"index",null,null,null,false],[0,0,0,"count",null,null,null,false],[420,447,0,null,null,null,[59626,59627,59629],false],[420,452,0,null,null,null,null,false],[420,456,0,null,null," You must call deinit to free the internal buffer of the\n iterator after you are done.",[59616],false],[0,0,0,"allocator",null,"",null,false],[420,465,0,null,null,null,[59618],false],[0,0,0,"allocator",null,"",null,false],[420,498,0,null,null,null,[59620],false],[0,0,0,"self",null,"",null,false],[420,506,0,null,null,null,[59622],false],[0,0,0,"self",null,"",null,false],[420,514,0,null,null," Call to free the internal buffer of the iterator.",[59624],false],[0,0,0,"self",null,"",null,false],[420,447,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[0,0,0,"index",null,null,null,false],[420,447,0,null,null,null,null,false],[0,0,0,"args",null,null,null,false],[420,525,0,null,null," Optional parameters for `ArgIteratorGeneral`",[59631,59632],false],[0,0,0,"comments",null,null,null,false],[0,0,0,"single_quotes",null,null,null,false],[420,531,0,null,null," A general Iterator to parse a string into a set of arguments",[59634],false],[0,0,0,"options",null,"",[59662,59663,59665,59666,59668,59669,59670],true],[420,546,0,null,null,null,null,false],[420,548,0,null,null,null,null,false],[420,549,0,null,null,null,null,false],[420,552,0,null,null," cmd_line_utf8 MUST remain valid and constant while using this instance",[59639,59640],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"cmd_line_utf8",null,"",null,false],[420,565,0,null,null," cmd_line_utf8 will be free'd (with the allocator) on deinit()",[59642,59643],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"cmd_line_utf8",null,"",null,false],[420,578,0,null,null," cmd_line_utf16le MUST be encoded UTF16-LE, and is converted to UTF-8 in an internal buffer",[59645,59646],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"cmd_line_utf16le",null,"",null,false],[420,604,0,null,null,null,[59648],false],[0,0,0,"self",null,"",null,false],[420,630,0,null,null,null,[59650],false],[0,0,0,"self",null,"",null,false],[420,670,0,null,null," Returns a slice of the internal buffer that contains the next argument.\n Returns null when it reaches the end.",[59652],false],[0,0,0,"self",null,"",null,false],[420,730,0,null,null,null,[59654,59655],false],[0,0,0,"self",null,"",null,false],[0,0,0,"emit_count",null,"",null,false],[420,737,0,null,null,null,[59657,59658],false],[0,0,0,"self",null,"",null,false],[0,0,0,"char",null,"",null,false],[420,743,0,null,null," Call to free the internal buffer of the iterator.",[59660],false],[0,0,0,"self",null,"",null,false],[420,532,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[0,0,0,"index",null,null,null,false],[420,532,0,null,null,null,null,false],[0,0,0,"cmd_line",null,null,null,false],[0,0,0,"free_cmd_line_on_deinit",null," Should the cmd_line field be free'd (using the allocator) on deinit()?",null,false],[420,532,0,null,null,null,null,false],[0,0,0,"buffer",null," buffer MUST be long enough to hold the cmd_line plus a null terminator.\n buffer will we free'd (using the allocator) on deinit()",null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[420,754,0,null,null," Cross-platform command line argument iterator.",[59684],false],[420,755,0,null,null,null,null,false],[420,765,0,null,null," Initialize the args iterator. Consider using initWithAllocator() instead\n for cross-platform compatibility.",[],false],[420,776,0,null,null,null,null,false],[420,782,0,null,null," You must deinitialize iterator's internal buffers by calling `deinit` when done.",[59676],false],[0,0,0,"allocator",null,"",null,false],[420,796,0,null,null," Get the next argument. Returns 'null' if we are at the end.\n Returned slice is pointing to the iterator's internal buffer.",[59678],false],[0,0,0,"self",null,"",null,false],[420,802,0,null,null," Parse past 1 argument without capturing it.\n Returns `true` if skipped an arg, `false` if we are at the end.",[59680],false],[0,0,0,"self",null,"",null,false],[420,808,0,null,null," Call this to free the iterator's internal buffer if the iterator\n was created with `initWithAllocator` function.",[59682],false],[0,0,0,"self",null,"",null,false],[420,754,0,null,null,null,null,false],[0,0,0,"inner",null,null,null,false],[420,822,0,null,null," Holds the command-line arguments, with the program name as the first entry.\n Use argsWithAllocator() for cross-platform code.",[],false],[420,827,0,null,null," You must deinitialize iterator's internal buffers by calling `deinit` when done.",[59687],false],[0,0,0,"allocator",null,"",null,false],[420,832,0,null,null," Caller must call argsFree on result.",[59689],false],[0,0,0,"allocator",null,"",null,false],[420,869,0,null,null,null,[59691,59692],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"args_alloc",null,"",null,false],[420,902,0,null,null,null,[59694,59695],false],[0,0,0,"input_cmd_line",null,"",null,false],[0,0,0,"expected_args",null,"",null,false],[420,942,0,null,null,null,[59697,59698],false],[0,0,0,"input_cmd_line",null,"",null,false],[0,0,0,"expected_args",null,"",null,false],[420,953,0,null,null,null,[59701,59703],false],[420,953,0,null,null,null,null,false],[0,0,0,"uid",null,null,null,false],[420,953,0,null,null,null,null,false],[0,0,0,"gid",null,null,null,false],[420,959,0,null,null," POSIX function which gets a uid from username.",[59705],false],[0,0,0,"name",null,"",null,false],[420,968,0,null,null," TODO this reads /etc/passwd. But sometimes the user/id mapping is in something else\n like NIS, AD, etc. See `man nss` or look at an strace for `id myuser`.",[59707],false],[0,0,0,"name",null,"",null,false],[420,1070,0,null,null,null,[],false],[420,1089,0,null,null," Tells whether calling the `execv` or `execve` functions will be a compile error.",null,false],[420,1095,0,null,null," Tells whether spawning child processes is supported (e.g. via ChildProcess)",null,false],[420,1100,0,null,null,null,null,false],[420,1110,0,null,null," Replaces the current process image with the executed process.\n This function must allocate memory to add a null terminating bytes on path and each arg.\n It must also convert to KEY=VALUE\\0 format for environment variables, and include null\n pointers after the args and after the environment variables.\n `argv[0]` is the executable path.\n This function also uses the PATH environment variable to get the full path to the executable.\n Due to the heap-allocation, it is illegal to call this function in a fork() child.\n For that use case, use the `std.os` functions directly.",[59713,59714],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"argv",null,"",null,false],[420,1122,0,null,null," Replaces the current process image with the executed process.\n This function must allocate memory to add a null terminating bytes on path and each arg.\n It must also convert to KEY=VALUE\\0 format for environment variables, and include null\n pointers after the args and after the environment variables.\n `argv[0]` is the executable path.\n This function also uses the PATH environment variable to get the full path to the executable.\n Due to the heap-allocation, it is illegal to call this function in a fork() child.\n For that use case, use the `std.os` functions directly.",[59716,59717,59718],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"env_map",null,"",null,false],[420,1155,0,null,null,null,null,false],[420,1160,0,null,null," Returns the total system memory, in bytes.",[],false],[420,1208,0,null,null,null,[],false],[420,1229,0,null,null," Indicate that we are now terminating with a successful exit code.\n In debug builds, this is a no-op, so that the calling code's\n cleanup mechanisms are tested and so that external tools that\n check for resource leaks can be accurate. In release builds, this\n calls exit(0), and does not return.",[],false],[1,161,0,null,null," Fast pseudo-random number generators (i.e. not cryptographically secure).",null,false],[0,0,0,"rand.zig",null," The engines provided here should be initialized from an external source.\n For a thread-local cryptographically secure pseudo random number generator,\n use `std.crypto.random`.\n Be sure to use a CSPRNG when required, otherwise using a normal PRNG will\n be faster and use substantially less stack space.\n\n TODO(tiehuis): Benchmark these against other reference implementations.\n",[],false],[421,8,0,null,null,null,null,false],[421,9,0,null,null,null,null,false],[421,10,0,null,null,null,null,false],[421,11,0,null,null,null,null,false],[421,12,0,null,null,null,null,false],[421,13,0,null,null,null,null,false],[421,16,0,null,null," Fast unbiased random numbers.",null,false],[421,19,0,null,null," Cryptographically secure random numbers.",null,false],[421,21,0,null,null,null,null,false],[0,0,0,"rand/Ascon.zig",null," CSPRNG based on the Reverie construction, a permutation-based PRNG\n with forward security, instantiated with the Ascon(128,12,8) permutation.\n\n Compared to ChaCha, this PRNG has a much smaller state, and can be\n a better choice for constrained environments.\n\n References:\n - A Robust and Sponge-Like PRNG with Improved Efficiency https://eprint.iacr.org/2016/886.pdf\n - Ascon https://ascon.iaik.tugraz.at/files/asconv12-nist.pdf\n",[59753],false],[422,10,0,null,null,null,null,false],[422,11,0,null,null,null,null,false],[422,12,0,null,null,null,null,false],[422,13,0,null,null,null,null,false],[422,15,0,null,null,null,null,false],[422,19,0,null,null,null,null,false],[422,20,0,null,null,null,null,false],[422,23,0,null,null," The seed must be uniform, secret and `secret_seed_length` bytes long.",[59743],false],[0,0,0,"secret_seed",null,"",null,false],[422,30,0,null,null," Inserts entropy to refresh the internal state.",[59745,59746],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[422,42,0,null,null," Returns a `std.rand.Random` structure backed by the current RNG.",[59748],false],[0,0,0,"self",null,"",null,false],[422,47,0,null,null," Fills the buffer with random bytes.",[59750,59751],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[422,0,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[421,22,0,null,null,null,null,false],[0,0,0,"rand/ChaCha.zig",null," CSPRNG based on the ChaCha8 stream cipher, with forward security.\n\n References:\n - Fast-key-erasure random-number generators https://blog.cr.yp.to/20170723-random.html\n",[59777,59778],false],[423,5,0,null,null,null,null,false],[423,6,0,null,null,null,null,false],[423,7,0,null,null,null,null,false],[423,8,0,null,null,null,null,false],[423,10,0,null,null,null,null,false],[423,12,0,null,null,null,null,false],[423,17,0,null,null,null,null,false],[423,19,0,null,null,null,null,false],[423,22,0,null,null," The seed must be uniform, secret and `secret_seed_length` bytes long.",[59765],false],[0,0,0,"secret_seed",null,"",null,false],[423,29,0,null,null," Inserts entropy to refresh the internal state.",[59767,59768],false],[0,0,0,"self",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[423,56,0,null,null," Returns a `std.rand.Random` structure backed by the current RNG.",[59770],false],[0,0,0,"self",null,"",null,false],[423,61,0,null,null,null,[59772],false],[0,0,0,"self",null,"",null,false],[423,67,0,null,null," Fills the buffer with random bytes.",[59774,59775],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf_",null,"",null,false],[423,0,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[0,0,0,"offset",null,null,null,false],[421,24,0,null,null,null,null,false],[0,0,0,"rand/Isaac64.zig",null," ISAAC64 - http://www.burtleburtle.net/bob/rand/isaacafa.html\n\n Follows the general idea of the implementation from here with a few shortcuts.\n https://doc.rust-lang.org/rand/src/rand/prng/isaac64.rs.html\n",[59807,59809,59810,59811,59812,59813],false],[424,5,0,null,null,null,null,false],[424,6,0,null,null,null,null,false],[424,7,0,null,null,null,null,false],[424,8,0,null,null,null,null,false],[424,17,0,null,null,null,[59786],false],[0,0,0,"init_s",null,"",null,false],[424,32,0,null,null,null,[59788],false],[0,0,0,"self",null,"",null,false],[424,36,0,null,null,null,[59790,59791,59792,59793,59794],false],[0,0,0,"self",null,"",null,false],[0,0,0,"mix",null,"",null,false],[0,0,0,"base",null,"",null,false],[0,0,0,"m1",null,"",null,true],[0,0,0,"m2",null,"",null,true],[424,47,0,null,null,null,[59796],false],[0,0,0,"self",null,"",null,false],[424,76,0,null,null,null,[59798],false],[0,0,0,"self",null,"",null,false],[424,86,0,null,null,null,[59800,59801,59802],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[0,0,0,"rounds",null,"",null,true],[424,152,0,null,null,null,[59804,59805],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[424,0,0,null,null,null,null,false],[0,0,0,"r",null,null,null,false],[424,0,0,null,null,null,null,false],[0,0,0,"m",null,null,null,false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"i",null,null,null,false],[421,25,0,null,null,null,null,false],[0,0,0,"rand/Pcg.zig",null," PCG32 - http://www.pcg-random.org/\n\n PRNG\n",[59836,59837],false],[425,4,0,null,null,null,null,false],[425,5,0,null,null,null,null,false],[425,6,0,null,null,null,null,false],[425,8,0,null,null,null,null,false],[425,13,0,null,null,null,[59821],false],[0,0,0,"init_s",null,"",null,false],[425,23,0,null,null,null,[59823],false],[0,0,0,"self",null,"",null,false],[425,27,0,null,null,null,[59825],false],[0,0,0,"self",null,"",null,false],[425,37,0,null,null,null,[59827,59828],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[425,43,0,null,null,null,[59830,59831,59832],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[0,0,0,"init_i",null,"",null,false],[425,51,0,null,null,null,[59834,59835],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"s",null,null,null,false],[0,0,0,"i",null,null,null,false],[421,26,0,null,null,null,null,false],[0,0,0,"rand/Xoroshiro128.zig",null," Xoroshiro128+ - http://xoroshiro.di.unimi.it/\n\n PRNG\n",[59859],false],[426,4,0,null,null,null,null,false],[426,5,0,null,null,null,null,false],[426,6,0,null,null,null,null,false],[426,7,0,null,null,null,null,false],[426,11,0,null,null,null,[59845],false],[0,0,0,"init_s",null,"",null,false],[426,18,0,null,null,null,[59847],false],[0,0,0,"self",null,"",null,false],[426,22,0,null,null,null,[59849],false],[0,0,0,"self",null,"",null,false],[426,35,0,null,null,null,[59851],false],[0,0,0,"self",null,"",null,false],[426,59,0,null,null,null,[59853,59854],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[426,67,0,null,null,null,[59856,59857],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[426,0,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[421,27,0,null,null,null,null,false],[0,0,0,"rand/Xoshiro256.zig",null," Xoshiro256++ - http://xoroshiro.di.unimi.it/\n\n PRNG\n",[59881],false],[427,4,0,null,null,null,null,false],[427,5,0,null,null,null,null,false],[427,6,0,null,null,null,null,false],[427,7,0,null,null,null,null,false],[427,11,0,null,null,null,[59867],false],[0,0,0,"init_s",null,"",null,false],[427,20,0,null,null,null,[59869],false],[0,0,0,"self",null,"",null,false],[427,24,0,null,null,null,[59871],false],[0,0,0,"self",null,"",null,false],[427,42,0,null,null,null,[59873],false],[0,0,0,"self",null,"",null,false],[427,57,0,null,null,null,[59875,59876],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[427,67,0,null,null,null,[59878,59879],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[427,0,0,null,null,null,null,false],[0,0,0,"s",null,null,null,false],[421,28,0,null,null,null,null,false],[0,0,0,"rand/Sfc64.zig",null," Sfc64 pseudo-random number generator from Practically Random.\n Fastest engine of pracrand and smallest footprint.\n See http://pracrand.sourceforge.net/\n",[59903,59904,59905,59906],false],[428,4,0,null,null,null,null,false],[428,5,0,null,null,null,null,false],[428,6,0,null,null,null,null,false],[428,7,0,null,null,null,null,false],[428,14,0,null,null,null,null,false],[428,15,0,null,null,null,null,false],[428,16,0,null,null,null,null,false],[428,18,0,null,null,null,[59892],false],[0,0,0,"init_s",null,"",null,false],[428,25,0,null,null,null,[59894],false],[0,0,0,"self",null,"",null,false],[428,29,0,null,null,null,[59896],false],[0,0,0,"self",null,"",null,false],[428,38,0,null,null,null,[59898,59899],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[428,49,0,null,null,null,[59901,59902],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"a",null,null,null,false],[0,0,0,"b",null,null,null,false],[0,0,0,"c",null,null,null,false],[0,0,0,"counter",null,null,null,false],[421,29,0,null,null,null,null,false],[0,0,0,"rand/RomuTrio.zig",null,"",[59928,59929,59930],false],[429,4,0,null,null,null,null,false],[429,5,0,null,null,null,null,false],[429,6,0,null,null,null,null,false],[429,7,0,null,null,null,null,false],[429,13,0,null,null,null,[59914],false],[0,0,0,"init_s",null,"",null,false],[429,19,0,null,null,null,[59916],false],[0,0,0,"self",null,"",null,false],[429,23,0,null,null,null,[59918],false],[0,0,0,"self",null,"",null,false],[429,35,0,null,null,null,[59920,59921],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[429,42,0,null,null,null,[59923,59924],false],[0,0,0,"self",null,"",null,false],[0,0,0,"init_s",null,"",null,false],[429,51,0,null,null,null,[59926,59927],false],[0,0,0,"self",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"x_state",null,null,null,false],[0,0,0,"y_state",null,null,null,false],[0,0,0,"z_state",null,null,null,false],[421,30,0,null,null,null,null,false],[0,0,0,"rand/ziggurat.zig",null," Implements ZIGNOR [1].\n\n [1]: Jurgen A. Doornik (2005). [*An Improved Ziggurat Method to Generate Normal Random Samples*]\n (https://www.doornik.com/research/ziggurat.pdf). Nuffield College, Oxford.\n\n rust/rand used as a reference;\n\n NOTE: This seems interesting but reference code is a bit hard to grok:\n https://sbarral.github.io/etf.\n",[],false],[430,10,0,null,null,null,null,false],[430,11,0,null,null,null,null,false],[430,12,0,null,null,null,null,false],[430,13,0,null,null,null,null,false],[430,15,0,null,null,null,[59938,59939],false],[0,0,0,"random",null,"",null,false],[0,0,0,"tables",null,"",null,true],[430,53,0,null,null,null,[59941,59943,59945,59948,59949,59953],false],[0,0,0,"r",null,null,null,false],[430,53,0,null,null,null,null,false],[0,0,0,"x",null,null,null,false],[430,53,0,null,null,null,null,false],[0,0,0,"f",null,null,null,false],[430,53,0,null,null,null,[59947],false],[0,0,0,"",null,"",null,false],[0,0,0,"pdf",null,null,null,false],[0,0,0,"is_symmetric",null,null,null,false],[430,53,0,null,null,null,[59951,59952],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"zero_case",null,null,null,false],[430,67,0,null,null,null,[59955,59956,59957,59958,59960,59962],false],[0,0,0,"is_symmetric",null,"",null,true],[0,0,0,"r",null,"",null,true],[0,0,0,"v",null,"",null,true],[0,0,0,"f",null,"",[59959],true],[0,0,0,"",null,"",null,false],[0,0,0,"f_inv",null,"",[59961],true],[0,0,0,"",null,"",null,false],[0,0,0,"zero_case",null,"",[59963,59964],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[430,99,0,null,null,null,null,false],[430,104,0,null,null,null,null,false],[430,105,0,null,null,null,null,false],[430,107,0,null,null,null,[59969],false],[0,0,0,"x",null,"",null,false],[430,110,0,null,null,null,[59971],false],[0,0,0,"y",null,"",null,false],[430,113,0,null,null,null,[59973,59974],false],[0,0,0,"random",null,"",null,false],[0,0,0,"u",null,"",null,false],[430,140,0,null,null,null,null,false],[430,145,0,null,null,null,null,false],[430,146,0,null,null,null,null,false],[430,148,0,null,null,null,[59979],false],[0,0,0,"x",null,"",null,false],[430,151,0,null,null,null,[59981],false],[0,0,0,"y",null,"",null,false],[430,154,0,null,null,null,[59983,59984],false],[0,0,0,"random",null,"",null,false],[0,0,0,"",null,"",null,false],[421,32,0,null,null,null,[60067,60071],false],[421,36,0,null,null,null,[59987,59988],false],[0,0,0,"pointer",null,"",null,false],[0,0,0,"fillFn",null,"",[59989,59990],true],[0,0,0,"ptr",null,"",null,false],[0,0,0,"buf",null,"",null,false],[421,55,0,null,null," Read random bytes into the specified buffer until full.",[59992,59993],false],[0,0,0,"r",null,"",null,false],[0,0,0,"buf",null,"",null,false],[421,59,0,null,null,null,[59995],false],[0,0,0,"r",null,"",null,false],[421,68,0,null,null," Returns a random value from an enum, evenly distributed.\n\n Note that this will not yield consistent results across all targets\n due to dependence on the representation of `usize` as an index.\n See `enumValueWithIndex` for further commentary.",[59997,59998],false],[0,0,0,"r",null,"",null,false],[0,0,0,"EnumType",null,"",null,true],[421,82,0,null,null," Returns a random value from an enum, evenly distributed.\n\n An index into an array of all named values is generated using the\n specified `Index` type to determine the return value.\n This allows for results to be independent of `usize` representation.\n\n Prefer `enumValue` if this isn't important.\n\n See `uintLessThan`, which this function uses in most cases,\n for commentary on the runtime of this function.",[60000,60001,60002],false],[0,0,0,"r",null,"",null,false],[0,0,0,"EnumType",null,"",null,true],[0,0,0,"Index",null,"",null,true],[421,103,0,null,null," Returns a random int `i` such that `minInt(T) <= i <= maxInt(T)`.\n `i` is evenly distributed.",[60004,60005],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[421,121,0,null,null," Constant-time implementation off `uintLessThan`.\n The results of this function may be biased.",[60007,60008,60009],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"less_than",null,"",null,false],[421,141,0,null,null," Returns an evenly distributed random unsigned integer `0 <= i < less_than`.\n This function assumes that the underlying `fillFn` produces evenly distributed values.\n Within this assumption, the runtime of this function is exponentially distributed.\n If `fillFn` were backed by a true random generator,\n the runtime of this function would technically be unbounded.\n However, if `fillFn` is backed by any evenly distributed pseudo random number generator,\n this function is guaranteed to return.\n If you need deterministic runtime bounds, use `uintLessThanBiased`.",[60011,60012,60013],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"less_than",null,"",null,false],[421,178,0,null,null," Constant-time implementation off `uintAtMost`.\n The results of this function may be biased.",[60015,60016,60017],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"at_most",null,"",null,false],[421,190,0,null,null," Returns an evenly distributed random unsigned integer `0 <= i <= at_most`.\n See `uintLessThan`, which this function uses in most cases,\n for commentary on the runtime of this function.",[60019,60020,60021],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"at_most",null,"",null,false],[421,201,0,null,null," Constant-time implementation off `intRangeLessThan`.\n The results of this function may be biased.",[60023,60024,60025,60026],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"at_least",null,"",null,false],[0,0,0,"less_than",null,"",null,false],[421,220,0,null,null," Returns an evenly distributed random integer `at_least <= i < less_than`.\n See `uintLessThan`, which this function uses in most cases,\n for commentary on the runtime of this function.",[60028,60029,60030,60031],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"at_least",null,"",null,false],[0,0,0,"less_than",null,"",null,false],[421,238,0,null,null," Constant-time implementation off `intRangeAtMostBiased`.\n The results of this function may be biased.",[60033,60034,60035,60036],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"at_least",null,"",null,false],[0,0,0,"at_most",null,"",null,false],[421,257,0,null,null," Returns an evenly distributed random integer `at_least <= i <= at_most`.\n See `uintLessThan`, which this function uses in most cases,\n for commentary on the runtime of this function.",[60038,60039,60040,60041],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"at_least",null,"",null,false],[0,0,0,"at_most",null,"",null,false],[421,274,0,null,null," Return a floating point value evenly distributed in the range [0, 1).",[60043,60044],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[421,331,0,null,null," Return a floating point value normally distributed with mean = 0, stddev = 1.\n\n To use different parameters, use: floatNorm(...) * desiredStddev + desiredMean.",[60046,60047],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[421,343,0,null,null," Return an exponentially distributed float with a rate parameter of 1.\n\n To use a different rate parameter, use: floatExp(...) / desiredRate.",[60049,60050],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[421,357,0,null,null," Shuffle a slice into a random order.\n\n Note that this will not yield consistent results across all targets\n due to dependence on the representation of `usize` as an index.\n See `shuffleWithIndex` for further commentary.",[60052,60053,60054],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[421,373,0,null,null," Shuffle a slice into a random order, using an index of a\n specified type to maintain distribution across targets.\n Asserts the index type can represent `buf.len`.\n\n Indexes into the slice are generated using the specified `Index`\n type, which determines distribution properties. This allows for\n results to be independent of `usize` representation.\n\n Prefer `shuffle` if this isn't important.\n\n See `intRangeLessThan`, which this function uses,\n for commentary on the runtime of this function.",[60056,60057,60058,60059],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"buf",null,"",null,false],[0,0,0,"Index",null,"",null,true],[421,395,0,null,null," Randomly selects an index into `proportions`, where the likelihood of each\n index is weighted by that proportion.\n It is more likely for the index of the last proportion to be returned\n than the index of the first proportion in the slice, and vice versa.\n\n This is useful for selecting an item from a slice where weights are not equal.\n `T` must be a numeric type capable of holding the sum of `proportions`.",[60061,60062,60063],false],[0,0,0,"r",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"proportions",null,"",null,false],[421,427,0,null,null," Returns the smallest of `Index` and `usize`.",[60065],false],[0,0,0,"Index",null,"",null,true],[421,32,0,null,null,null,null,false],[0,0,0,"ptr",null,null,null,false],[421,32,0,null,null,null,[60069,60070],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"fillFn",null,null,null,false],[421,437,0,null,null," Convert a random integer 0 <= random_int <= maxValue(T),\n into an integer 0 <= result < less_than.\n This function introduces a minor bias.",[60073,60074,60075],false],[0,0,0,"T",null,"",null,true],[0,0,0,"random_int",null,"",null,false],[0,0,0,"less_than",null,"",null,false],[421,453,0,null,null,null,[60081],false],[421,456,0,null,null,null,[60078],false],[0,0,0,"seed",null,"",null,false],[421,460,0,null,null,null,[60080],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,null,null,false],[1,164,0,null,null," Sorting.",null,false],[0,0,0,"sort.zig",null,"",[],false],[431,0,0,null,null,null,null,false],[431,1,0,null,null,null,null,false],[431,2,0,null,null,null,null,false],[431,3,0,null,null,null,null,false],[431,4,0,null,null,null,null,false],[431,6,0,null,null,null,null,false],[0,0,0,"sort/block.zig",null,"",[],false],[432,0,0,null,null,null,null,false],[432,1,0,null,null,null,null,false],[432,2,0,null,null,null,null,false],[432,3,0,null,null,null,null,false],[432,4,0,null,null,null,null,false],[432,6,0,null,null,null,[60102,60103],false],[432,10,0,null,null,null,[60098,60099],false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[432,17,0,null,null,null,[60101],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[432,22,0,null,null,null,[60118,60119,60120,60121,60122,60123,60124],false],[432,31,0,null,null,null,[60106,60107],false],[0,0,0,"size2",null,"",null,false],[0,0,0,"min_level",null,"",null,false],[432,45,0,null,null,null,[60109],false],[0,0,0,"self",null,"",null,false],[432,50,0,null,null,null,[60111],false],[0,0,0,"self",null,"",null,false],[432,66,0,null,null,null,[60113],false],[0,0,0,"self",null,"",null,false],[432,70,0,null,null,null,[60115],false],[0,0,0,"self",null,"",null,false],[432,81,0,null,null,null,[60117],false],[0,0,0,"self",null,"",null,false],[0,0,0,"size",null,null,null,false],[0,0,0,"power_of_two",null,null,null,false],[0,0,0,"numerator",null,null,null,false],[0,0,0,"decimal",null,null,null,false],[0,0,0,"denominator",null,null,null,false],[0,0,0,"decimal_step",null,null,null,false],[0,0,0,"numerator_step",null,null,null,false],[432,86,0,null,null,null,[60126,60127,60128,60130],false],[0,0,0,"from",null,null,null,false],[0,0,0,"to",null,null,null,false],[0,0,0,"count",null,null,null,false],[432,86,0,null,null,null,null,false],[0,0,0,"range",null,null,null,false],[432,99,0,null,null," Stable in-place sort. O(n) best case, O(n*log(n)) worst case and average case.\n O(1) memory (no allocator required).\n Sorts in ascending order with respect to the given `lessThan` function.\n\n NOTE: the algorithm only work when the comparison is less-than or greater-than\n       (See https://github.com/ziglang/zig/issues/8289)",[60132,60133,60134,60135],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThanFn",null,"",[60136,60137,60138],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,757,0,null,null,null,[60140,60141,60142,60143,60144,60145],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"A_arg",null,"",null,false],[0,0,0,"B_arg",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60146,60147,60148],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,806,0,null,null,null,[60150,60151,60152,60153,60154,60155,60156],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"A",null,"",null,false],[0,0,0,"B",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60157,60158,60159],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,841,0,null,null,null,[60161,60162,60163,60164,60165],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"start1",null,"",null,false],[0,0,0,"start2",null,"",null,false],[0,0,0,"block_size",null,"",null,false],[432,850,0,null,null,null,[60167,60168,60169,60170,60171,60172,60173],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"unique",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60174,60175,60176],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,872,0,null,null,null,[60178,60179,60180,60181,60182,60183,60184],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"unique",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60185,60186,60187],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,894,0,null,null,null,[60189,60190,60191,60192,60193,60194,60195],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"unique",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60196,60197,60198],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,916,0,null,null,null,[60200,60201,60202,60203,60204,60205,60206],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"unique",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60207,60208,60209],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,938,0,null,null,null,[60211,60212,60213,60214,60215,60216],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60217,60218,60219],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,961,0,null,null,null,[60221,60222,60223,60224,60225,60226],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"value",null,"",null,false],[0,0,0,"range",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60227,60228,60229],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,984,0,null,null,null,[60231,60232,60233,60234,60235,60236,60237],false],[0,0,0,"T",null,"",null,true],[0,0,0,"from",null,"",null,false],[0,0,0,"A",null,"",null,false],[0,0,0,"B",null,"",null,false],[0,0,0,"into",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60238,60239,60240],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,1024,0,null,null,null,[60242,60243,60244,60245,60246,60247,60248],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"A",null,"",null,false],[0,0,0,"B",null,"",null,false],[0,0,0,"cache",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60249,60250,60251],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[432,1061,0,null,null,null,[60253,60254,60255,60256,60257,60258,60259],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"order",null,"",null,false],[0,0,0,"x",null,"",null,false],[0,0,0,"y",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60260,60261,60262],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,7,0,null,null,null,null,false],[0,0,0,"sort/pdq.zig",null,"",[],false],[433,0,0,null,null,null,null,false],[433,1,0,null,null,null,null,false],[433,2,0,null,null,null,null,false],[433,3,0,null,null,null,null,false],[433,4,0,null,null,null,null,false],[433,10,0,null,null," Unstable in-place sort. n best case, n*log(n) worst case and average case.\n log(n) memory (no allocator required).\n\n Sorts in ascending order with respect to the given `lessThan` function.",[60271,60272,60273,60274],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThanFn",null,"",[60275,60276,60277],true],[0,0,0,"context",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[433,31,0,null,null,null,[60279,60280,60281],false],[0,0,0,"increasing",null,null,null,false],[0,0,0,"decreasing",null,null,null,false],[0,0,0,"unknown",null,null,null,false],[433,42,0,null,null," Unstable in-place sort. O(n) best case, O(n*log(n)) worst case and average case.\n O(log(n)) memory (no allocator required).\n `context` must have methods `swap` and `lessThan`,\n which each take 2 `usize` parameters indicating the index of an item.\n Sorts in ascending order with respect to `lessThan`.",[60283,60284,60285],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,138,0,null,null," partitions `items[a..b]` into elements smaller than `items[pivot]`,\n followed by elements greater than or equal to `items[pivot]`.\n\n sets the new pivot.\n returns `true` if already partitioned.",[60287,60288,60289,60290],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"pivot",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,181,0,null,null," partitions items into elements equal to `items[pivot]`\n followed by elements greater than `items[pivot]`.\n\n it assumed that `items[a..b]` does not contain elements smaller than the `items[pivot]`.",[60292,60293,60294,60295],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"pivot",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,204,0,null,null," partially sorts a slice by shifting several out-of-order elements around.\n\n returns `true` if the slice is sorted at the end. This function is `O(n)` worst-case.",[60297,60298,60299],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,248,0,null,null,null,[60301,60302,60303],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,272,0,null,null," choses a pivot in `items[a..b]`.\n swaps likely_sorted when `items[a..b]` seems to be already sorted.",[60305,60306,60307,60308],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"pivot",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,304,0,null,null,null,[60310,60311,60312,60313,60314],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"c",null,"",null,false],[0,0,0,"swaps",null,"",null,false],[0,0,0,"context",null,"",null,false],[433,321,0,null,null,null,[60316,60317,60318],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[431,8,0,null,null,null,null,false],[431,13,0,null,null," Stable in-place sort. O(n) best case, O(pow(n, 2)) worst case.\n O(1) memory (no allocator required).\n Sorts in ascending order with respect to the given `lessThan` function.",[60321,60322,60323,60324],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThanFn",null,"",[60325,60326,60327],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,39,0,null,null," Stable in-place sort. O(n) best case, O(pow(n, 2)) worst case.\n O(1) memory (no allocator required).\n `context` must have methods `swap` and `lessThan`,\n which each take 2 `usize` parameters indicating the index of an item.\n Sorts in ascending order with respect to `lessThan`.",[60329,60330,60331],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[431,54,0,null,null," Unstable in-place sort. O(n*log(n)) best case, worst case and average case.\n O(1) memory (no allocator required).\n Sorts in ascending order with respect to the given `lessThan` function.",[60333,60334,60335,60336],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThanFn",null,"",[60337,60338,60339],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,80,0,null,null," Unstable in-place sort. O(n*log(n)) best case, worst case and average case.\n O(1) memory (no allocator required).\n `context` must have methods `swap` and `lessThan`,\n which each take 2 `usize` parameters indicating the index of an item.\n Sorts in ascending order with respect to `lessThan`.",[60341,60342,60343],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[431,98,0,null,null,null,[60345,60346,60347,60348],false],[0,0,0,"a",null,"",null,false],[0,0,0,"target",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"context",null,"",null,false],[431,129,0,null,null," Use to generate a comparator function for a given type. e.g. `sort(u8, slice, {}, asc(u8))`.",[60350],false],[0,0,0,"T",null,"",[60351,60352,60353],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[431,138,0,null,null," Use to generate a comparator function for a given type. e.g. `sort(u8, slice, {}, desc(u8))`.",[60355],false],[0,0,0,"T",null,"",[60356,60357,60358],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[431,146,0,null,null,null,null,false],[431,147,0,null,null,null,null,false],[431,148,0,null,null,null,null,false],[431,149,0,null,null,null,null,false],[431,151,0,null,null,null,[60364,60365,60366,60367],false],[0,0,0,"",null,"",null,true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,true],[431,158,0,null,null,null,[60369,60370,60371],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[431,165,0,null,null,null,[60377,60378],false],[431,169,0,null,null,null,[60374,60375,60376],false],[0,0,0,"context",null,"",null,false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"id",null,null,null,false],[0,0,0,"value",null,null,null,false],[431,399,0,null,null,null,[60380,60381,60382,60383,60384],false],[0,0,0,"T",null,"",null,true],[0,0,0,"key",null,"",null,false],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"compareFn",null,"",[60385,60386,60387],true],[0,0,0,"context",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"mid_item",null,"",null,false],[431,502,0,null,null,null,[60389,60390,60391,60392],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60393,60394,60395],true],[0,0,0,"",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,534,0,null,null,null,[60397,60398,60399,60400],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60401,60402,60403],true],[0,0,0,"context",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,554,0,null,null,null,[60405,60406,60407,60408],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60409,60410,60411],true],[0,0,0,"context",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,586,0,null,null,null,[60413,60414,60415,60416],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60417,60418,60419],true],[0,0,0,"context",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[431,606,0,null,null,null,[60421,60422,60423,60424],false],[0,0,0,"T",null,"",null,true],[0,0,0,"items",null,"",null,false],[0,0,0,"context",null,"",null,false],[0,0,0,"lessThan",null,"",[60425,60426,60427],true],[0,0,0,"context",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[1,167,0,null,null," Single Instruction Multiple Data (SIMD) helpers.",null,false],[0,0,0,"simd.zig",null," This module provides functions for working conveniently with SIMD (Single Instruction; Multiple Data),\n which may offer a potential boost in performance on some targets by performing the same operations on\n multiple elements at once.\n Please be aware that some functions are known to not work on MIPS.\n",[],false],[434,5,0,null,null,null,null,false],[434,6,0,null,null,null,null,false],[434,8,0,null,null,null,[60433,60434],false],[0,0,0,"T",null,"",null,true],[0,0,0,"cpu",null,"",null,true],[434,57,0,null,null," Suggests a target-dependant vector size for a given type, or null if scalars are recommended.\n Not yet implemented for every CPU architecture.",[60436],false],[0,0,0,"T",null,"",null,true],[434,70,0,null,null,null,[60438],false],[0,0,0,"VectorType",null,"",null,true],[434,79,0,null,null," Returns the smallest type of unsigned ints capable of indexing any element within the given vector type.",[60440],false],[0,0,0,"VectorType",null,"",null,true],[434,84,0,null,null," Returns the smallest type of unsigned ints capable of holding the length of the given vector type.",[60442],false],[0,0,0,"VectorType",null,"",null,true],[434,90,0,null,null," Returns a vector containing the first `len` integers in order from 0 to `len`-1.\n For example, `iota(i32, 8)` will return a vector containing `.{0, 1, 2, 3, 4, 5, 6, 7}`.",[60444,60445],false],[0,0,0,"T",null,"",null,true],[0,0,0,"len",null,"",null,true],[434,106,0,null,null," Returns a vector containing the same elements as the input, but repeated until the desired length is reached.\n For example, `repeat(8, [_]u32{1, 2, 3})` will return a vector containing `.{1, 2, 3, 1, 2, 3, 1, 2}`.",[60447,60448],false],[0,0,0,"len",null,"",null,true],[0,0,0,"vec",null,"",null,false],[434,114,0,null,null," Returns a vector containing all elements of the first vector at the lower indices followed by all elements of the second vector\n at the higher indices.",[60450,60451],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[434,124,0,null,null," Returns a vector whose elements alternates between those of each input vector.\n For example, `interlace(.{[4]u32{11, 12, 13, 14}, [4]u32{21, 22, 23, 24}})` returns a vector containing `.{11, 21, 12, 22, 13, 23, 14, 24}`.",[60453],false],[0,0,0,"vecs",null,"",null,false],[434,163,0,null,null," The contents of `interlaced` is evenly split between vec_count vectors that are returned as an array. They \"take turns\",\n receiving one element from `interlaced` at a time.",[60455,60456],false],[0,0,0,"vec_count",null,"",null,true],[0,0,0,"interlaced",null,"",null,false],[434,184,0,null,null,null,[60458,60459,60460],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"first",null,"",null,true],[0,0,0,"count",null,"",null,true],[434,227,0,null,null," Joins two vectors, shifts them leftwards (towards lower indices) and extracts the leftmost elements into a vector the size of a and b.",[60462,60463,60464],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"shift",null,"",null,true],[434,235,0,null,null," Elements are shifted rightwards (towards higher indices). New elements are added to the left, and the rightmost elements are cut off\n so that the size of the vector stays the same.",[60466,60467,60468],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"amount",null,"",null,true],[0,0,0,"shift_in",null,"",null,false],[434,247,0,null,null," Elements are shifted leftwards (towards lower indices). New elements are added to the right, and the leftmost elements are cut off\n so that no elements with indices below 0 remain.",[60470,60471,60472],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"amount",null,"",null,true],[0,0,0,"shift_in",null,"",null,false],[434,254,0,null,null," Elements are shifted leftwards (towards lower indices). Elements that leave to the left will reappear to the right in the same order.",[60474,60475],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"amount",null,"",null,true],[434,259,0,null,null," Elements are shifted rightwards (towards higher indices). Elements that leave to the right will reappear to the left in the same order.",[60477,60478],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"amount",null,"",null,true],[434,263,0,null,null,null,[60480],false],[0,0,0,"vec",null,"",null,false],[434,280,0,null,null,null,[60482],false],[0,0,0,"vec",null,"",null,false],[434,292,0,null,null,null,[60484],false],[0,0,0,"vec",null,"",null,false],[434,305,0,null,null,null,[60486],false],[0,0,0,"vec",null,"",null,false],[434,316,0,null,null,null,[60488,60489],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"value",null,"",null,false],[434,322,0,null,null,null,[60491,60492],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"value",null,"",null,false],[434,328,0,null,null,null,[60494,60495],false],[0,0,0,"vec",null,"",null,false],[0,0,0,"value",null,"",null,false],[434,344,0,null,null," Same as prefixScan, but with a user-provided, mathematically associative function.",[60497,60498,60499,60500,60503],false],[0,0,0,"hop",null,"",null,true],[0,0,0,"vec",null,"",null,false],[0,0,0,"ErrorType",null," The error type that `func` might return. Set this to `void` if `func` doesn't return an error union.\n",null,true],[0,0,0,"func",null,"",[60501,60502],true],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"identity",null," When one operand of the operation performed by `func` is this value, the result must equal the other operand.\n For example, this should be 0 for addition or 1 for multiplication.\n",null,true],[434,377,0,null,null," Returns a vector whose elements are the result of performing the specified operation on the corresponding\n element of the input vector and every hop'th element that came before it (or after, if hop is negative).\n Supports the same operations as the @reduce() builtin. Takes O(logN) to compute.\n The scan is not linear, which may affect floating point errors. This may affect the determinism of\n algorithms that use this function.",[60505,60506,60507],false],[0,0,0,"op",null,"",null,true],[0,0,0,"hop",null,"",null,true],[0,0,0,"vec",null,"",null,false],[1,170,0,null,null," ASCII text processing.",null,false],[0,0,0,"ascii.zig",null," The 7-bit [ASCII](https://en.wikipedia.org/wiki/ASCII) character encoding standard.\n\n This is not to be confused with the 8-bit [extended ASCII](https://en.wikipedia.org/wiki/Extended_ASCII) character encoding.\n\n Even though this module concerns itself with 7-bit ASCII,\n functions use `u8` as the type instead of `u7` for convenience and compatibility.\n Characters outside of the 7-bit range are gracefully handled (e.g. by returning `false`).\n\n See also: https://en.wikipedia.org/wiki/ASCII#Character_set\n",[],false],[435,10,0,null,null,null,null,false],[435,15,0,null,null," The C0 control codes of the ASCII encoding.\n\n See also: https://en.wikipedia.org/wiki/C0_and_C1_control_codes and `isControl`",[],false],[435,17,0,null,null," Null.",null,false],[435,19,0,null,null," Start of Heading.",null,false],[435,21,0,null,null," Start of Text.",null,false],[435,23,0,null,null," End of Text.",null,false],[435,25,0,null,null," End of Transmission.",null,false],[435,27,0,null,null," Enquiry.",null,false],[435,29,0,null,null," Acknowledge.",null,false],[435,31,0,null,null," Bell, Alert.",null,false],[435,33,0,null,null," Backspace.",null,false],[435,35,0,null,null," Horizontal Tab, Tab ('\\t').",null,false],[435,37,0,null,null," Line Feed, Newline ('\\n').",null,false],[435,39,0,null,null," Vertical Tab.",null,false],[435,41,0,null,null," Form Feed.",null,false],[435,43,0,null,null," Carriage Return ('\\r').",null,false],[435,45,0,null,null," Shift Out.",null,false],[435,47,0,null,null," Shift In.",null,false],[435,49,0,null,null," Data Link Escape.",null,false],[435,51,0,null,null," Device Control One (XON).",null,false],[435,53,0,null,null," Device Control Two.",null,false],[435,55,0,null,null," Device Control Three (XOFF).",null,false],[435,57,0,null,null," Device Control Four.",null,false],[435,59,0,null,null," Negative Acknowledge.",null,false],[435,61,0,null,null," Synchronous Idle.",null,false],[435,63,0,null,null," End of Transmission Block",null,false],[435,65,0,null,null," Cancel.",null,false],[435,67,0,null,null," End of Medium.",null,false],[435,69,0,null,null," Substitute.",null,false],[435,71,0,null,null," Escape.",null,false],[435,73,0,null,null," File Separator.",null,false],[435,75,0,null,null," Group Separator.",null,false],[435,77,0,null,null," Record Separator.",null,false],[435,79,0,null,null," Unit Separator.",null,false],[435,82,0,null,null," Delete.",null,false],[435,85,0,null,null," An alias to `dc1`.",null,false],[435,87,0,null,null," An alias to `dc3`.",null,false],[435,91,0,null,null," Returns whether the character is alphanumeric: A-Z, a-z, or 0-9.",[60548],false],[0,0,0,"c",null,"",null,false],[435,99,0,null,null," Returns whether the character is alphabetic: A-Z or a-z.",[60550],false],[0,0,0,"c",null,"",null,false],[435,109,0,null,null," Returns whether the character is a control character.\n\n See also: `control_code`",[60552],false],[0,0,0,"c",null,"",null,false],[435,114,0,null,null," Returns whether the character is a digit.",[60554],false],[0,0,0,"c",null,"",null,false],[435,122,0,null,null," Returns whether the character is a lowercase letter.",[60556],false],[0,0,0,"c",null,"",null,false],[435,131,0,null,null," Returns whether the character is printable and has some graphical representation,\n including the space character.",[60558],false],[0,0,0,"c",null,"",null,false],[435,136,0,null,null," Returns whether this character is included in `whitespace`.",[60560],false],[0,0,0,"c",null,"",null,false],[435,147,0,null,null," Whitespace for general use.\n This may be used with e.g. `std.mem.trim` to trim whitespace.\n\n See also: `isWhitespace`",null,false],[435,159,0,null,null," Returns whether the character is an uppercase letter.",[60563],false],[0,0,0,"c",null,"",null,false],[435,167,0,null,null," Returns whether the character is a hexadecimal digit: A-F, a-f, or 0-9.",[60565],false],[0,0,0,"c",null,"",null,false],[435,175,0,null,null," Returns whether the character is a 7-bit ASCII character.",[60567],false],[0,0,0,"c",null,"",null,false],[435,180,0,null,null," Uppercases the character and returns it as-is if already uppercase or not a letter.",[60569],false],[0,0,0,"c",null,"",null,false],[435,189,0,null,null," Lowercases the character and returns it as-is if already lowercase or not a letter.",[60571],false],[0,0,0,"c",null,"",null,false],[435,272,0,null,null," Writes a lower case copy of `ascii_string` to `output`.\n Asserts `output.len >= ascii_string.len`.",[60573,60574],false],[0,0,0,"output",null,"",null,false],[0,0,0,"ascii_string",null,"",null,false],[435,288,0,null,null," Allocates a lower case copy of `ascii_string`.\n Caller owns returned string and must free with `allocator`.",[60576,60577],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ascii_string",null,"",null,false],[435,301,0,null,null," Writes an upper case copy of `ascii_string` to `output`.\n Asserts `output.len >= ascii_string.len`.",[60579,60580],false],[0,0,0,"output",null,"",null,false],[0,0,0,"ascii_string",null,"",null,false],[435,317,0,null,null," Allocates an upper case copy of `ascii_string`.\n Caller owns returned string and must free with `allocator`.",[60582,60583],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"ascii_string",null,"",null,false],[435,329,0,null,null," Compares strings `a` and `b` case-insensitively and returns whether they are equal.",[60585,60586],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[435,343,0,null,null,null,[60588,60589],false],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[435,352,0,null,null,null,[60591,60592],false],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[435,362,0,null,null," Finds `needle` in `haystack`, ignoring case, starting at index 0.",[60594,60595],false],[0,0,0,"haystack",null,"",null,false],[0,0,0,"needle",null,"",null,false],[435,368,0,null,null," Finds `needle` in `haystack`, ignoring case, starting at `start_index`.\n Uses Boyer-Moore-Horspool algorithm on large inputs; `indexOfIgnoreCasePosLinear` on small inputs.",[60597,60598,60599],false],[0,0,0,"haystack",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"needle",null,"",null,false],[435,389,0,null,null," Consider using `indexOfIgnoreCasePos` instead of this, which will automatically use a\n more sophisticated algorithm on larger inputs.",[60601,60602,60603],false],[0,0,0,"haystack",null,"",null,false],[0,0,0,"start_index",null,"",null,false],[0,0,0,"needle",null,"",null,false],[435,398,0,null,null,null,[60605,60606],false],[0,0,0,"pattern",null,"",null,false],[0,0,0,"table",null,"",null,false],[435,423,0,null,null," Returns the lexicographical order of two slices. O(n).",[60608,60609],false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[435,437,0,null,null," Returns whether the lexicographical order of `lhs` is lower than `rhs`.",[60611,60612],false],[0,0,0,"lhs",null,"",null,false],[0,0,0,"rhs",null,"",null,false],[1,173,0,null,null," Tar archive format compression/decompression.",null,false],[0,0,0,"tar.zig",null,"",[],false],[436,0,0,null,null,null,[60619,60621],false],[436,6,0,null,null,null,[60617,60618],false],[0,0,0,"ignore",null," The mode from the tar file is completely ignored. Files are created\n with the default mode when creating files.",null,false],[0,0,0,"executable_bit_only",null," The mode from the tar file is inspected for the owner executable bit\n only. This bit is copied to the group and other executable bits.\n Other bits of the mode are left as the default when creating files.",null,false],[0,0,0,"strip_components",null," Number of directory levels to skip when extracting files.",null,false],[436,0,0,null,null,null,null,false],[0,0,0,"mode_mode",null," How to handle the \"mode\" property of files from within the tar file.",null,false],[436,17,0,null,null,null,[60652],false],[436,20,0,null,null,null,[60624,60625,60626,60627,60628,60629,60630,60631,60632,60633],false],[0,0,0,"normal",null,null,null,false],[0,0,0,"hard_link",null,null,null,false],[0,0,0,"symbolic_link",null,null,null,false],[0,0,0,"character_special",null,null,null,false],[0,0,0,"block_special",null,null,null,false],[0,0,0,"directory",null,null,null,false],[0,0,0,"fifo",null,null,null,false],[0,0,0,"contiguous",null,null,null,false],[0,0,0,"global_extended_header",null,null,null,false],[0,0,0,"extended_header",null,null,null,false],[436,34,0,null,null,null,[60635],false],[0,0,0,"header",null,"",null,false],[436,42,0,null,null,null,[60637],false],[0,0,0,"header",null,"",null,false],[436,50,0,null,null," Includes prefix concatenated, if any.\n Return value may point into Header buffer, or might point into the\n argument buffer.\n TODO: check against \"../\" and other nefarious things",[60639,60640],false],[0,0,0,"header",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[436,63,0,null,null,null,[60642],false],[0,0,0,"header",null,"",null,false],[436,67,0,null,null,null,[60644],false],[0,0,0,"header",null,"",null,false],[436,71,0,null,null,null,[60646],false],[0,0,0,"header",null,"",null,false],[436,76,0,null,null,null,[60648,60649,60650],false],[0,0,0,"header",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[436,17,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[436,85,0,null,null,null,[60669,60670,60671],false],[436,90,0,null,null,null,[60655,60656,60657],false],[0,0,0,"b",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"count",null,"",null,false],[436,99,0,null,null,null,[60659,60660],false],[0,0,0,"b",null,"",null,false],[0,0,0,"count",null,"",null,false],[436,104,0,null,null,null,[60662,60663,60664],false],[0,0,0,"b",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"count",null,"",null,false],[436,113,0,null,null,null,[60666,60667],false],[0,0,0,"b",null,"",null,false],[0,0,0,"count",null,"",null,false],[436,85,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[436,123,0,null,null,null,[60673,60674,60675],false],[0,0,0,"dir",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"options",null,"",null,false],[436,236,0,null,null,null,[60677,60678],false],[0,0,0,"path",null,"",null,false],[0,0,0,"count",null,"",null,false],[436,256,0,null,null,null,[60680,60682,60683,60684],false],[0,0,0,"size",null,null,null,false],[436,256,0,null,null,null,null,false],[0,0,0,"key",null,null,null,false],[0,0,0,"value_off",null,null,null,false],[0,0,0,"value_len",null,null,null,false],[436,263,0,null,null,null,[60686,60687],false],[0,0,0,"data",null,"",null,false],[0,0,0,"max_size",null,"",null,false],[436,295,0,null,null,null,null,false],[436,296,0,null,null,null,null,false],[436,249,0,"stripComponents","test stripComponents {\n    const expectEqualStrings = std.testing.expectEqualStrings;\n    try expectEqualStrings(\"a/b/c\", try stripComponents(\"a/b/c\", 0));\n    try expectEqualStrings(\"b/c\", try stripComponents(\"a/b/c\", 1));\n    try expectEqualStrings(\"c\", try stripComponents(\"a/b/c\", 2));\n}",null,null,false],[436,278,0,"parsePaxAttribute","test parsePaxAttribute {\n    const expectEqual = std.testing.expectEqual;\n    const expectEqualStrings = std.testing.expectEqualStrings;\n    const expectError = std.testing.expectError;\n    const prefix = \"1011 path=\";\n    const file_name = \"0123456789\" ** 100;\n    const header = prefix ++ file_name ++ \"\\n\";\n    const attr_info = try parsePaxAttribute(header, 1011);\n    try expectEqual(@as(usize, 1011), attr_info.size);\n    try expectEqualStrings(\"path\", attr_info.key);\n    try expectEqual(prefix.len, attr_info.value_off);\n    try expectEqual(file_name.len, attr_info.value_len);\n    try expectEqual(attr_info, try parsePaxAttribute(header, 1012));\n    try expectError(error.InvalidPaxAttribute, parsePaxAttribute(header, 1010));\n    try expectError(error.InvalidPaxAttribute, parsePaxAttribute(\"\", 0));\n}",null,null,false],[1,176,0,null,null," Testing allocator, testing assertions, and other helpers for testing code.",null,false],[0,0,0,"testing.zig",null,"",[],false],[437,0,0,null,null,null,null,false],[437,1,0,null,null,null,null,false],[437,3,0,null,null,null,null,false],[437,5,0,null,null,null,null,false],[0,0,0,"testing/failing_allocator.zig",null,"",[],false],[438,0,0,null,null,null,null,false],[438,1,0,null,null,null,null,false],[438,3,0,null,null,null,[60702,60703],false],[0,0,0,"fail_index",null," The number of successful allocations you can expect from this allocator.\n The next allocation will fail. For example, with `fail_index` equal to\n 2, the following test will pass:\n\n var a = try failing_alloc.create(i32);\n var b = try failing_alloc.create(i32);\n testing.expectError(error.OutOfMemory, failing_alloc.create(i32));",null,false],[0,0,0,"resize_fail_index",null," Number of successful resizes to expect from this allocator. The next resize will fail.",null,false],[438,27,0,null,null," Allocator that fails after N allocations, useful for making sure out of\n memory conditions are handled correctly.\n\n To use this, first initialize it and get an allocator with\n\n `const failing_allocator = &FailingAllocator.init(<allocator>,\n                                                   <config>).allocator;`\n\n Then use `failing_allocator` anywhere you would have used a\n different allocator.",[60729,60730,60732,60733,60734,60735,60736,60738,60739,60740,60741],false],[438,40,0,null,null,null,null,false],[438,42,0,null,null,null,[60707,60708],false],[0,0,0,"internal_allocator",null,"",null,false],[0,0,0,"config",null,"",null,false],[438,58,0,null,null,null,[60710],false],[0,0,0,"self",null,"",null,false],[438,69,0,null,null,null,[60712,60713,60714,60715],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"log2_ptr_align",null,"",null,false],[0,0,0,"return_address",null,"",null,false],[438,96,0,null,null,null,[60717,60718,60719,60720,60721],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"log2_old_align",null,"",null,false],[0,0,0,"new_len",null,"",null,false],[0,0,0,"ra",null,"",null,false],[438,117,0,null,null,null,[60723,60724,60725,60726],false],[0,0,0,"ctx",null,"",null,false],[0,0,0,"old_mem",null,"",null,false],[0,0,0,"log2_old_align",null,"",null,false],[0,0,0,"ra",null,"",null,false],[438,130,0,null,null," Only valid once `has_induced_failure == true`",[60728],false],[0,0,0,"self",null,"",null,false],[0,0,0,"alloc_index",null,null,null,false],[0,0,0,"resize_index",null,null,null,false],[438,27,0,null,null,null,null,false],[0,0,0,"internal_allocator",null,null,null,false],[0,0,0,"allocated_bytes",null,null,null,false],[0,0,0,"freed_bytes",null,null,null,false],[0,0,0,"allocations",null,null,null,false],[0,0,0,"deallocations",null,null,null,false],[438,27,0,null,null,null,null,false],[0,0,0,"stack_addresses",null,null,null,false],[0,0,0,"has_induced_failure",null,null,null,false],[0,0,0,"fail_index",null,null,null,false],[0,0,0,"resize_fail_index",null,null,null,false],[437,8,0,null,null," This should only be used in temporary test programs.",null,false],[437,9,0,null,null,null,null,false],[437,15,0,null,null,null,null,false],[437,16,0,null,null,null,null,false],[437,18,0,null,null,null,null,false],[437,21,0,null,null," TODO https://github.com/ziglang/zig/issues/5738",null,false],[437,23,0,null,null,null,[60749,60750],false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[437,32,0,null,null," This function is intended to be used only in tests. It prints diagnostics to stderr\n and then returns a test failure error when actual_error_union is not expected_error.",[60752,60753],false],[0,0,0,"expected_error",null,"",null,false],[0,0,0,"actual_error_union",null,"",null,false],[437,51,0,null,null," This function is intended to be used only in tests. When the two values are not\n equal, prints diagnostics to stderr to show exactly how they are not equal,\n then returns a test failure error.\n `actual` is casted to the type of `expected`.",[60755,60756],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[437,204,0,null,null," This function is intended to be used only in tests. When the formatted result of the template\n and its arguments does not equal the expected text, it prints diagnostics to stderr to show how\n they are not equal, then returns an error.",[60758,60759,60760],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"template",null,"",null,true],[0,0,0,"args",null,"",null,false],[437,222,0,null,null," This function is intended to be used only in tests. When the actual value is\n not approximately equal to the expected value, prints diagnostics to stderr\n to show exactly how they are not equal, then returns a test failure error.\n See `math.approxEqAbs` for more information on the tolerance parameter.\n The types must be floating-point.",[60762,60763,60764],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[0,0,0,"tolerance",null,"",null,false],[437,254,0,null,null," This function is intended to be used only in tests. When the actual value is\n not approximately equal to the expected value, prints diagnostics to stderr\n to show exactly how they are not equal, then returns a test failure error.\n See `math.approxEqRel` for more information on the tolerance parameter.\n The types must be floating-point.",[60766,60767,60768],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[0,0,0,"tolerance",null,"",null,false],[437,289,0,null,null," This function is intended to be used only in tests. When the two slices are not\n equal, prints diagnostics to stderr to show exactly how they are not equal (with\n the differences highlighted in red), then returns a test failure error.\n The colorized output is optional and controlled by the return of `std.io.tty.detectConfig()`.\n If your inputs are UTF-8 encoded strings, consider calling `expectEqualStrings` instead.",[60770,60771,60772],false],[0,0,0,"T",null,"",null,true],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[437,382,0,null,null,null,[60774],false],[0,0,0,"T",null,"",[60779,60781,60783,60785],true],[437,389,0,null,null,null,null,false],[437,391,0,null,null,null,[60777,60778],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"start_index",null,null,null,false],[437,383,0,null,null,null,null,false],[0,0,0,"expected",null,null,null,false],[437,383,0,null,null,null,null,false],[0,0,0,"actual",null,null,null,false],[437,383,0,null,null,null,null,false],[0,0,0,"ttyconf",null,null,null,false],[437,407,0,null,null,null,[60803,60805,60807],false],[437,412,0,null,null,null,[60788,60789],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[437,438,0,null,null,null,[60791,60792,60793,60794,60795],false],[0,0,0,"self",null,"",null,false],[0,0,0,"writer",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"byte",null,"",null,false],[0,0,0,"diff",null,"",null,false],[437,444,0,null,null,null,[60800,60801],false],[437,448,0,null,null,null,[60798],false],[0,0,0,"self",null,"",null,false],[437,444,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"index",null,null,null,false],[437,407,0,null,null,null,null,false],[0,0,0,"expected",null,null,null,false],[437,407,0,null,null,null,null,false],[0,0,0,"actual",null,null,null,false],[437,407,0,null,null,null,null,false],[0,0,0,"ttyconf",null,null,null,false],[437,475,0,null,null," This function is intended to be used only in tests. Checks that two slices or two arrays are equal,\n including that their sentinel (if any) are the same. Will error if given another type.",[60809,60810,60811,60812],false],[0,0,0,"T",null,"",null,true],[0,0,0,"sentinel",null,"",null,true],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[437,517,0,null,null," This function is intended to be used only in tests.\n When `ok` is false, returns a test failure error.",[60814],false],[0,0,0,"ok",null,"",null,false],[437,521,0,null,null,null,[60821,60823,60825],false],[437,526,0,null,null,null,null,false],[437,527,0,null,null,null,null,false],[437,529,0,null,null,null,[60819],false],[0,0,0,"self",null,"",null,false],[437,521,0,null,null,null,null,false],[0,0,0,"dir",null,null,null,false],[437,521,0,null,null,null,null,false],[0,0,0,"parent_dir",null,null,null,false],[437,521,0,null,null,null,null,false],[0,0,0,"sub_path",null,null,null,false],[437,537,0,null,null,null,[60832,60834,60836],false],[437,542,0,null,null,null,null,false],[437,543,0,null,null,null,null,false],[437,545,0,null,null,null,[60830],false],[0,0,0,"self",null,"",null,false],[437,537,0,null,null,null,null,false],[0,0,0,"iterable_dir",null,null,null,false],[437,537,0,null,null,null,null,false],[0,0,0,"parent_dir",null,null,null,false],[437,537,0,null,null,null,null,false],[0,0,0,"sub_path",null,null,null,false],[437,553,0,null,null,null,[60838],false],[0,0,0,"opts",null,"",null,false],[437,575,0,null,null,null,[60840],false],[0,0,0,"opts",null,"",null,false],[437,618,0,null,null,null,[60842,60843],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[437,642,0,null,null,null,[60845,60846],false],[0,0,0,"actual",null,"",null,false],[0,0,0,"expected_starts_with",null,"",null,false],[437,662,0,null,null,null,[60848,60849],false],[0,0,0,"actual",null,"",null,false],[0,0,0,"expected_ends_with",null,"",null,false],[437,694,0,null,null," This function is intended to be used only in tests. When the two values are not\n deeply equal, prints diagnostics to stderr to show exactly how they are not equal,\n then returns a test failure error.\n `actual` is casted to the type of `expected`.\n\n Deeply equal is defined as follows:\n Primitive types are deeply equal if they are equal using  `==` operator.\n Struct values are deeply equal if their corresponding fields are deeply equal.\n Container types(like Array/Slice/Vector) deeply equal when their corresponding elements are deeply equal.\n Pointer values are deeply equal if values they point to are deeply equal.\n\n Note: Self-referential structs are not supported (e.g. things like std.SinglyLinkedList)",[60851,60852],false],[0,0,0,"expected",null,"",null,false],[0,0,0,"actual",null,"",null,false],[437,928,0,null,null,null,[60854,60855],false],[0,0,0,"source",null,"",null,false],[0,0,0,"indicator_index",null,"",null,false],[437,950,0,null,null,null,[60857],false],[0,0,0,"source",null,"",null,false],[437,958,0,null,null,null,[60859],false],[0,0,0,"line",null,"",null,false],[437,1045,0,null,null," Exhaustively check that allocation failures within `test_fn` are handled without\n introducing memory leaks. If used with the `testing.allocator` as the `backing_allocator`,\n it will also be able to detect double frees, etc (when runtime safety is enabled).\n\n The provided `test_fn` must have a `std.mem.Allocator` as its first argument,\n and must have a return type of `!void`. Any extra arguments of `test_fn` can\n be provided via the `extra_args` tuple.\n\n Any relevant state shared between runs of `test_fn` *must* be reset within `test_fn`.\n\n The strategy employed is to:\n - Run the test function once to get the total number of allocations.\n - Then, iterate and run the function X more times, incrementing\n   the failing index each iteration (where X is the total number of\n   allocations determined previously)\n\n Expects that `test_fn` has a deterministic number of memory allocations:\n - If an allocation was made to fail during a run of `test_fn`, but `test_fn`\n   didn't return `error.OutOfMemory`, then `error.SwallowedOutOfMemoryError`\n   is returned from `checkAllAllocationFailures`. You may want to ignore this\n   depending on whether or not the code you're testing includes some strategies\n   for recovering from `error.OutOfMemory`.\n - If a run of `test_fn` with an expected allocation failure executes without\n   an allocation failure being induced, then `error.NondeterministicMemoryUsage`\n   is returned. This error means that there are allocation points that won't be\n   tested by the strategy this function employs (that is, there are sometimes more\n   points of allocation than the initial run of `test_fn` detects).\n\n ---\n\n Here's an example using a simple test case that will cause a leak when the\n allocation of `bar` fails (but will pass normally):\n\n ```zig\n test {\n     const length: usize = 10;\n     const allocator = std.testing.allocator;\n     var foo = try allocator.alloc(u8, length);\n     var bar = try allocator.alloc(u8, length);\n\n     allocator.free(foo);\n     allocator.free(bar);\n }\n ```\n\n The test case can be converted to something that this function can use by\n doing:\n\n ```zig\n fn testImpl(allocator: std.mem.Allocator, length: usize) !void {\n     var foo = try allocator.alloc(u8, length);\n     var bar = try allocator.alloc(u8, length);\n\n     allocator.free(foo);\n     allocator.free(bar);\n }\n\n test {\n     const length: usize = 10;\n     const allocator = std.testing.allocator;\n     try std.testing.checkAllAllocationFailures(allocator, testImpl, .{length});\n }\n ```\n\n Running this test will show that `foo` is leaked when the allocation of\n `bar` fails. The simplest fix, in this case, would be to use defer like so:\n\n ```zig\n fn testImpl(allocator: std.mem.Allocator, length: usize) !void {\n     var foo = try allocator.alloc(u8, length);\n     defer allocator.free(foo);\n     var bar = try allocator.alloc(u8, length);\n     defer allocator.free(bar);\n }\n ```",[60861,60862,60863],false],[0,0,0,"backing_allocator",null,"",null,false],[0,0,0,"test_fn",null,"",null,true],[0,0,0,"extra_args",null,"",null,false],[437,1125,0,null,null," Given a type, references all the declarations inside, so that the semantic analyzer sees them.",[60865],false],[0,0,0,"T",null,"",null,true],[437,1134,0,null,null," Given a type, recursively references all the declarations inside, so that the semantic analyzer sees them.\n For deep types, you may use `@setEvalBranchQuota`.",[60867],false],[0,0,0,"T",null,"",null,true],[1,179,0,null,null," Sleep, obtaining the current time, conversion constants, and more.",null,false],[0,0,0,"time.zig",null,"",[],false],[439,0,0,null,null,null,null,false],[439,1,0,null,null,null,null,false],[439,2,0,null,null,null,null,false],[439,3,0,null,null,null,null,false],[439,4,0,null,null,null,null,false],[439,5,0,null,null,null,null,false],[439,7,0,null,null,null,null,false],[0,0,0,"time/epoch.zig",null," Epoch reference times in terms of their difference from\n UTC 1970-01-01 in seconds.\n",[],false],[440,2,0,null,null,null,null,false],[440,3,0,null,null,null,null,false],[440,4,0,null,null,null,null,false],[440,7,0,null,null," Jan 01, 1970 AD",null,false],[440,9,0,null,null," Jan 01, 1980 AD",null,false],[440,11,0,null,null," Jan 01, 2001 AD",null,false],[440,13,0,null,null," Nov 17, 1858 AD",null,false],[440,15,0,null,null," Jan 01, 1900 AD",null,false],[440,17,0,null,null," Jan 01, 1601 AD",null,false],[440,19,0,null,null," Jan 01, 1978 AD",null,false],[440,21,0,null,null," Dec 31, 1967 AD",null,false],[440,23,0,null,null," Jan 06, 1980 AD",null,false],[440,25,0,null,null," Jan 01, 0001 AD",null,false],[440,27,0,null,null,null,null,false],[440,28,0,null,null,null,null,false],[440,29,0,null,null,null,null,false],[440,30,0,null,null,null,null,false],[440,31,0,null,null,null,null,false],[440,32,0,null,null,null,null,false],[440,33,0,null,null,null,null,false],[440,34,0,null,null,null,null,false],[440,35,0,null,null,null,null,false],[440,36,0,null,null,null,null,false],[440,37,0,null,null,null,null,false],[440,38,0,null,null,null,null,false],[440,39,0,null,null,null,null,false],[440,42,0,null,null," The type that holds the current year, i.e. 2016",null,false],[440,44,0,null,null,null,null,false],[440,45,0,null,null,null,null,false],[440,47,0,null,null,null,[60908],false],[0,0,0,"year",null,"",null,false],[440,62,0,null,null,null,[60910],false],[0,0,0,"year",null,"",null,false],[440,66,0,null,null,null,[60912,60913],false],[0,0,0,"not_leap",null,null,null,false],[0,0,0,"leap",null,null,null,false],[440,68,0,null,null,null,[60917,60918,60919,60920,60921,60922,60923,60924,60925,60926,60927,60928],false],[440,84,0,null,null," return the numeric calendar value for the given month\n i.e. jan=1, feb=2, etc",[60916],false],[0,0,0,"self",null,"",null,false],[0,0,0,"jan",null,null,null,false],[0,0,0,"feb",null,null,null,false],[0,0,0,"mar",null,null,null,false],[0,0,0,"apr",null,null,null,false],[0,0,0,"may",null,null,null,false],[0,0,0,"jun",null,null,null,false],[0,0,0,"jul",null,null,null,false],[0,0,0,"aug",null,null,null,false],[0,0,0,"sep",null,null,null,false],[0,0,0,"oct",null,null,null,false],[0,0,0,"nov",null,null,null,false],[0,0,0,"dec",null,null,null,false],[440,90,0,null,null," Get the number of days in the given month",[60930,60931],false],[0,0,0,"leap_year",null,"",null,false],[0,0,0,"month",null,"",null,false],[440,110,0,null,null,null,[60936,60938],false],[440,115,0,null,null,null,[60934],false],[0,0,0,"self",null,"",null,false],[440,110,0,null,null,null,null,false],[0,0,0,"year",null,null,null,false],[440,110,0,null,null,null,null,false],[0,0,0,"day",null," The number of days into the year (0 to 365)",null,false],[440,130,0,null,null,null,[60941,60943],false],[440,130,0,null,null,null,null,false],[0,0,0,"month",null,null,null,false],[440,130,0,null,null,null,null,false],[0,0,0,"day_index",null,null,null,false],[440,136,0,null,null,null,[60948],false],[440,138,0,null,null,null,[60946],false],[0,0,0,"self",null,"",null,false],[440,136,0,null,null,null,null,false],[0,0,0,"day",null,null,null,false],[440,153,0,null,null," seconds since start of day",[60957],false],[440,157,0,null,null," the number of hours past the start of the day (0 to 23)",[60951],false],[0,0,0,"self",null,"",null,false],[440,161,0,null,null," the number of minutes past the hour (0 to 59)",[60953],false],[0,0,0,"self",null,"",null,false],[440,165,0,null,null," the number of seconds past the start of the minute (0 to 59)",[60955],false],[0,0,0,"self",null,"",null,false],[440,153,0,null,null,null,null,false],[0,0,0,"secs",null,null,null,false],[440,171,0,null,null," seconds since epoch Oct 1, 1970 at 12:00 AM",[60963],false],[440,176,0,null,null," Returns the number of days since the epoch as an EpochDay.\n Use EpochDay to get information about the day of this time.",[60960],false],[0,0,0,"self",null,"",null,false],[440,182,0,null,null," Returns the number of seconds into the day as DaySeconds.\n Use DaySeconds to get information about the time.",[60962],false],[0,0,0,"self",null,"",null,false],[0,0,0,"secs",null,null,null,false],[440,187,0,null,null,null,[60965,60966,60967,60968],false],[0,0,0,"secs",null,"",null,false],[0,0,0,"expected_year_day",null,"",null,false],[0,0,0,"expected_month_day",null,"",null,false],[0,0,0,"expected_day_seconds",null,"",[60970,60972,60974],false],[440,187,0,null,null,null,null,false],[0,0,0,"hours_into_day",null," 0 to 23",null,false],[440,187,0,null,null,null,null,false],[0,0,0,"minutes_into_hour",null," 0 to 59",null,false],[440,187,0,null,null,null,null,false],[0,0,0,"seconds_into_minute",null," 0 to 59",null,false],[439,10,0,null,null," Spurious wakeups are possible and no precision of timing is guaranteed.",[60976],false],[0,0,0,"nanoseconds",null,"",null,false],[439,70,0,null,null," Get a calendar timestamp, in seconds, relative to UTC 1970-01-01.\n Precision of timing depends on the hardware and operating system.\n The return value is signed because it is possible to have a date that is\n before the epoch.\n See `std.os.clock_gettime` for a POSIX timestamp.",[],false],[439,79,0,null,null," Get a calendar timestamp, in milliseconds, relative to UTC 1970-01-01.\n Precision of timing depends on the hardware and operating system.\n The return value is signed because it is possible to have a date that is\n before the epoch.\n See `std.os.clock_gettime` for a POSIX timestamp.",[],false],[439,88,0,null,null," Get a calendar timestamp, in microseconds, relative to UTC 1970-01-01.\n Precision of timing depends on the hardware and operating system.\n The return value is signed because it is possible to have a date that is\n before the epoch.\n See `std.os.clock_gettime` for a POSIX timestamp.",[],false],[439,98,0,null,null," Get a calendar timestamp, in nanoseconds, relative to UTC 1970-01-01.\n Precision of timing depends on the hardware and operating system.\n On Windows this has a maximum granularity of 100 nanoseconds.\n The return value is signed because it is possible to have a date that is\n before the epoch.\n See `std.os.clock_gettime` for a POSIX timestamp.",[],false],[439,136,0,null,null,null,null,false],[439,137,0,null,null,null,null,false],[439,138,0,null,null,null,null,false],[439,139,0,null,null,null,null,false],[439,140,0,null,null,null,null,false],[439,141,0,null,null,null,null,false],[439,142,0,null,null,null,null,false],[439,145,0,null,null,null,null,false],[439,146,0,null,null,null,null,false],[439,147,0,null,null,null,null,false],[439,148,0,null,null,null,null,false],[439,149,0,null,null,null,null,false],[439,150,0,null,null,null,null,false],[439,153,0,null,null,null,null,false],[439,154,0,null,null,null,null,false],[439,155,0,null,null,null,null,false],[439,156,0,null,null,null,null,false],[439,157,0,null,null,null,null,false],[439,160,0,null,null,null,null,false],[439,161,0,null,null,null,null,false],[439,162,0,null,null,null,null,false],[439,163,0,null,null,null,null,false],[439,172,0,null,null," An Instant represents a timestamp with respect to the currently\n executing program that ticks during suspend and can be used to\n record elapsed time unlike `nanoTimestamp`.\n\n It tries to sample the system's fastest and most precise timer available.\n It also tries to be monotonic, but this is not a guarantee due to OS/hardware bugs.\n If you need monotonic readings for elapsed time, consider `Timer` instead.",[61013],false],[439,176,0,null,null,null,null,false],[439,185,0,null,null," Queries the system for the current moment of time as an Instant.\n This is not guaranteed to be monotonic or steadily increasing, but for most implementations it is.\n Returns `error.Unsupported` when a suitable clock is not detected.",[],false],[439,216,0,null,null," Quickly compares two instances between each other.",[61007,61008],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[439,232,0,null,null," Returns elapsed time in nanoseconds since the `earlier` Instant.\n This assumes that the `earlier` Instant represents a moment in time before or equal to `self`.\n This also assumes that the time that has passed between both Instants fits inside a u64 (~585 yrs).",[61010,61011],false],[0,0,0,"self",null,"",null,false],[0,0,0,"earlier",null,"",null,false],[439,172,0,null,null,null,null,false],[0,0,0,"timestamp",null,null,null,false],[439,276,0,null,null," A monotonic, high performance timer.\n\n Timer.start() is used to initialize the timer\n and gives the caller an opportunity to check for the existence of a supported clock.\n Once a supported clock is discovered,\n it is assumed that it will be available for the duration of the Timer's use.\n\n Monotonicity is ensured by saturating on the most previous sample.\n This means that while timings reported are monotonic,\n they're not guaranteed to tick at a steady rate as this is up to the underlying system.",[61026,61028],false],[439,280,0,null,null,null,null,false],[439,285,0,null,null," Initialize the timer by querying for a supported clock.\n Returns `error.TimerUnsupported` when such a clock is unavailable.\n This should only fail in hostile environments such as linux seccomp misuse.",[],false],[439,291,0,null,null," Reads the timer value since start or the last reset in nanoseconds.",[61018],false],[0,0,0,"self",null,"",null,false],[439,297,0,null,null," Resets the timer value to 0/now.",[61020],false],[0,0,0,"self",null,"",null,false],[439,303,0,null,null," Returns the current value of the timer in nanoseconds, then resets it.",[61022],false],[0,0,0,"self",null,"",null,false],[439,311,0,null,null," Returns an Instant sampled at the callsite that is\n guaranteed to be monotonic with respect to the timer's starting point.",[61024],false],[0,0,0,"self",null,"",null,false],[439,276,0,null,null,null,null,false],[0,0,0,"started",null,null,null,false],[439,276,0,null,null,null,null,false],[0,0,0,"previous",null,null,null,false],[1,182,0,null,null," Time zones.",null,false],[0,0,0,"tz.zig",null,"",[],false],[441,0,0,null,null,null,null,false],[441,1,0,null,null,null,null,false],[441,3,0,null,null,null,[61034,61036],false],[0,0,0,"ts",null,null,null,false],[441,3,0,null,null,null,null,false],[0,0,0,"timetype",null,null,null,false],[441,8,0,null,null,null,[61046,61047,61049],false],[441,13,0,null,null,null,[61039],false],[0,0,0,"self",null,"",null,false],[441,17,0,null,null,null,[61041],false],[0,0,0,"self",null,"",null,false],[441,21,0,null,null,null,[61043],false],[0,0,0,"self",null,"",null,false],[441,25,0,null,null,null,[61045],false],[0,0,0,"self",null,"",null,false],[0,0,0,"offset",null,null,null,false],[0,0,0,"flags",null,null,null,false],[441,8,0,null,null,null,null,false],[0,0,0,"name_data",null,null,null,false],[441,30,0,null,null,null,[61052,61053],false],[441,30,0,null,null,null,null,false],[0,0,0,"occurrence",null,null,null,false],[0,0,0,"correction",null,null,null,false],[441,35,0,null,null,null,[61080,61082,61084,61086,61088],false],[441,42,0,null,null,null,[61057,61058,61060,61068],false],[441,42,0,null,null,null,null,false],[0,0,0,"magic",null,null,null,false],[0,0,0,"version",null,null,null,false],[441,42,0,null,null,null,null,false],[0,0,0,"reserved",null,null,null,false],[441,42,0,null,null,null,[61062,61063,61064,61065,61066,61067],false],[0,0,0,"isutcnt",null,null,null,false],[0,0,0,"isstdcnt",null,null,null,false],[0,0,0,"leapcnt",null,null,null,false],[0,0,0,"timecnt",null,null,null,false],[0,0,0,"typecnt",null,null,null,false],[0,0,0,"charcnt",null,null,null,false],[0,0,0,"counts",null,null,null,false],[441,56,0,null,null,null,[61070,61071],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[441,83,0,null,null,null,[61073,61074,61075,61076],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"reader",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"legacy",null,"",null,false],[441,205,0,null,null,null,[61078],false],[0,0,0,"self",null,"",null,false],[441,35,0,null,null,null,null,false],[0,0,0,"allocator",null,null,null,false],[441,35,0,null,null,null,null,false],[0,0,0,"transitions",null,null,null,false],[441,35,0,null,null,null,null,false],[0,0,0,"timetypes",null,null,null,false],[441,35,0,null,null,null,null,false],[0,0,0,"leapseconds",null,null,null,false],[441,35,0,null,null,null,null,false],[0,0,0,"footer",null,null,null,false],[1,185,0,null,null," UTF-8 and UTF-16LE encoding/decoding.",null,false],[0,0,0,"unicode.zig",null,"",[],false],[442,0,0,null,null,null,null,false],[442,1,0,null,null,null,null,false],[442,2,0,null,null,null,null,false],[442,3,0,null,null,null,null,false],[442,8,0,null,null," Use this to replace an unknown, unrecognized, or unrepresentable character.\n\n See also: https://en.wikipedia.org/wiki/Specials_(Unicode_block)#Replacement_character",null,false],[442,12,0,null,null," Returns how many bytes the UTF-8 representation would require\n for the given codepoint.",[61097],false],[0,0,0,"c",null,"",null,false],[442,23,0,null,null," Given the first byte of a UTF-8 codepoint,\n returns a number 1-4 indicating the total length of the codepoint in bytes.\n If this byte does not match the form of a UTF-8 start byte, returns Utf8InvalidStartByte.",[61099],false],[0,0,0,"first_byte",null,"",null,false],[442,39,0,null,null," Encodes the given codepoint into a UTF-8 byte sequence.\n c: the codepoint.\n out: the out buffer to write to. Must have a len >= utf8CodepointSequenceLength(c).\n Errors: if c cannot be encoded in UTF-8.\n Returns: the number of bytes written to out.",[61101,61102],false],[0,0,0,"c",null,"",null,false],[0,0,0,"out",null,"",null,false],[442,69,0,null,null,null,null,false],[442,75,0,null,null," Decodes the UTF-8 codepoint encoded in the given slice of bytes.\n bytes.len must be equal to utf8ByteSequenceLength(bytes[0]) catch unreachable.\n If you already know the length at comptime, you can call one of\n utf8Decode2,utf8Decode3,utf8Decode4 directly instead of this function.",[61105],false],[0,0,0,"bytes",null,"",null,false],[442,85,0,null,null,null,null,false],[442,89,0,null,null,null,[61108],false],[0,0,0,"bytes",null,"",null,false],[442,103,0,null,null,null,null,false],[442,108,0,null,null,null,[61111],false],[0,0,0,"bytes",null,"",null,false],[442,127,0,null,null,null,null,false],[442,132,0,null,null,null,[61114],false],[0,0,0,"bytes",null,"",null,false],[442,156,0,null,null," Returns true if the given unicode codepoint can be encoded in UTF-8.",[61116],false],[0,0,0,"value",null,"",null,false],[442,166,0,null,null," Returns the length of a supplied UTF-8 string literal in terms of unicode\n codepoints.",[61118],false],[0,0,0,"s",null,"",null,false],[442,198,0,null,null,null,[61120],false],[0,0,0,"s",null,"",null,false],[442,225,0,null,null," Utf8View iterates the code points of a utf-8 encoded string.\n\n ```\n var utf8 = (try std.unicode.Utf8View.init(\"hi there\")).iterator();\n while (utf8.nextCodepointSlice()) |codepoint| {\n   std.debug.print(\"got codepoint {}\\n\", .{codepoint});\n }\n ```",[61131],false],[442,228,0,null,null,null,[61123],false],[0,0,0,"s",null,"",null,false],[442,236,0,null,null,null,[61125],false],[0,0,0,"s",null,"",null,false],[442,241,0,null,null," TODO: https://github.com/ziglang/zig/issues/425",[61127],false],[0,0,0,"s",null,"",null,true],[442,251,0,null,null,null,[61129],false],[0,0,0,"s",null,"",null,false],[442,225,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[442,259,0,null,null,null,[61141,61142],false],[442,263,0,null,null,null,[61134],false],[0,0,0,"it",null,"",null,false],[442,273,0,null,null,null,[61136],false],[0,0,0,"it",null,"",null,false],[442,280,0,null,null," Look ahead at the next n codepoints without advancing the iterator.\n If fewer than n codepoints are available, then return the remainder of the string.",[61138,61139],false],[0,0,0,"it",null,"",null,false],[0,0,0,"n",null,"",null,false],[442,259,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"i",null,null,null,false],[442,295,0,null,null,null,[61144],false],[0,0,0,"c",null,"",null,false],[442,299,0,null,null,null,[61146],false],[0,0,0,"c",null,"",null,false],[442,305,0,null,null," Returns how many code units the UTF-16 representation would require\n for the given codepoint.",[61148],false],[0,0,0,"c",null,"",null,false],[442,322,0,null,null," Given the first code unit of a UTF-16 codepoint, returns a number 1-2\n indicating the total length of the codepoint in UTF-16 code units.\n If this code unit does not match the form of a UTF-16 start code unit, returns Utf16InvalidStartCodeUnit.",[61150],false],[0,0,0,"first_code_unit",null,"",null,false],[442,338,0,null,null," Decodes the codepoint encoded in the given pair of UTF-16 code units.\n Asserts that `surrogate_pair.len >= 2` and that the first code unit is a high surrogate.\n If the second code unit is not a low surrogate, error.ExpectedSecondSurrogateHalf is returned.",[61152],false],[0,0,0,"surrogate_pair",null,"",null,false],[442,347,0,null,null,null,[61159,61160],false],[442,351,0,null,null,null,[61155],false],[0,0,0,"s",null,"",null,false],[442,358,0,null,null,null,[61157],false],[0,0,0,"it",null,"",null,false],[442,347,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"i",null,null,null,false],[442,381,0,null,null," Returns the length of a supplied UTF-16 string literal in terms of unicode\n codepoints.",[61162],false],[0,0,0,"utf16le",null,"",null,false],[442,388,0,null,null,null,[],false],[442,416,0,null,null,null,[],false],[442,442,0,null,null,null,[],false],[442,450,0,null,null,null,[61167,61168,61169],false],[0,0,0,"codePoint",null,"",null,false],[0,0,0,"array",null,"",null,false],[0,0,0,"expectedErr",null,"",null,false],[442,458,0,null,null,null,[],false],[442,478,0,null,null,null,[],false],[442,488,0,null,null,null,[],false],[442,508,0,null,null,null,[],false],[442,519,0,null,null,null,[],false],[442,538,0,null,null,null,[],false],[442,570,0,null,null,null,[],false],[442,583,0,null,null,null,[],false],[442,599,0,null,null,null,[],false],[442,619,0,null,null,null,[61180,61181],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"expected_err",null,"",null,false],[442,623,0,null,null,null,[61183,61184],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"expected_codepoint",null,"",null,false],[442,627,0,null,null,null,[61186],false],[0,0,0,"bytes",null,"",null,false],[442,635,0,null,null," Caller must free returned memory.",[61188,61189],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"utf16le",null,"",null,false],[442,652,0,null,null," Caller must free returned memory.",[61191,61192],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"utf16le",null,"",null,false],[442,669,0,null,null," Asserts that the output buffer is big enough.\n Returns end byte index into utf8.",[61194,61195],false],[0,0,0,"utf8",null,"",null,false],[0,0,0,"utf16le",null,"",null,false],[442,741,0,null,null,null,[61197,61198],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"utf8",null,"",null,false],[442,767,0,null,null," Returns index of next character. If exact fit, returned index equals output slice length.\n Assumes there is enough space for the output.",[61200,61201],false],[0,0,0,"utf16le",null,"",null,false],[0,0,0,"utf8",null,"",null,false],[442,828,0,null,null," Converts a UTF-8 string literal into a UTF-16LE string literal.",[61203],false],[0,0,0,"utf8",null,"",null,true],[442,838,0,null,null,null,null,false],[442,842,0,null,null," Returns length in UTF-16 of UTF-8 slice as length of []u16.\n Length in []u8 is 2*len16.",[61206],false],[0,0,0,"utf8",null,"",null,false],[442,859,0,null,null,null,[],false],[442,872,0,null,null," Print the given `utf16le` string",[61209,61210,61211,61212],false],[0,0,0,"utf16le",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[442,895,0,null,null," Return a Formatter for a Utf16le string",[61214],false],[0,0,0,"utf16le",null,"",null,false],[442,965,0,null,null,null,[],false],[442,977,0,null,null,null,[],false],[442,311,0,"utf16CodepointSequenceLength","test utf16CodepointSequenceLength {\n    try testing.expectEqual(@as(u2, 1), try utf16CodepointSequenceLength('a'));\n    try testing.expectEqual(@as(u2, 1), try utf16CodepointSequenceLength(0xFFFF));\n    try testing.expectEqual(@as(u2, 2), try utf16CodepointSequenceLength(0x10000));\n    try testing.expectEqual(@as(u2, 2), try utf16CodepointSequenceLength(0x10FFFF));\n    try testing.expectError(error.CodepointTooLarge, utf16CodepointSequenceLength(0x110000));\n}",null,null,false],[442,328,0,"utf16CodeUnitSequenceLength","test utf16CodeUnitSequenceLength {\n    try testing.expectEqual(@as(u2, 1), try utf16CodeUnitSequenceLength('a'));\n    try testing.expectEqual(@as(u2, 1), try utf16CodeUnitSequenceLength(0xFFFF));\n    try testing.expectEqual(@as(u2, 2), try utf16CodeUnitSequenceLength(0xDBFF));\n    try testing.expectError(error.Utf16InvalidStartCodeUnit, utf16CodeUnitSequenceLength(0xDFFF));\n}",null,null,false],[1,188,0,null,null," Helpers for integrating with Valgrind.",null,false],[0,0,0,"valgrind.zig",null,"",[],false],[443,0,0,null,null,null,null,false],[443,1,0,null,null,null,null,false],[443,2,0,null,null,null,null,false],[443,4,0,null,null,null,[61225,61226,61227,61228,61229,61230,61231],false],[0,0,0,"default",null,"",null,false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[443,55,0,null,null,null,[61233,61234,61235,61236,61237,61238,61239,61240,61241,61242,61243,61244,61245,61246,61247,61248,61249,61250,61251,61252,61253,61254,61255,61256,61257,61258,61259,61260,61261,61262,61263],false],[0,0,0,"RunningOnValgrind",null,null,null,false],[0,0,0,"DiscardTranslations",null,null,null,false],[0,0,0,"ClientCall0",null,null,null,false],[0,0,0,"ClientCall1",null,null,null,false],[0,0,0,"ClientCall2",null,null,null,false],[0,0,0,"ClientCall3",null,null,null,false],[0,0,0,"CountErrors",null,null,null,false],[0,0,0,"GdbMonitorCommand",null,null,null,false],[0,0,0,"MalloclikeBlock",null,null,null,false],[0,0,0,"ResizeinplaceBlock",null,null,null,false],[0,0,0,"FreelikeBlock",null,null,null,false],[0,0,0,"CreateMempool",null,null,null,false],[0,0,0,"DestroyMempool",null,null,null,false],[0,0,0,"MempoolAlloc",null,null,null,false],[0,0,0,"MempoolFree",null,null,null,false],[0,0,0,"MempoolTrim",null,null,null,false],[0,0,0,"MoveMempool",null,null,null,false],[0,0,0,"MempoolChange",null,null,null,false],[0,0,0,"MempoolExists",null,null,null,false],[0,0,0,"Printf",null,null,null,false],[0,0,0,"PrintfBacktrace",null,null,null,false],[0,0,0,"PrintfValistByRef",null,null,null,false],[0,0,0,"PrintfBacktraceValistByRef",null,null,null,false],[0,0,0,"StackRegister",null,null,null,false],[0,0,0,"StackDeregister",null,null,null,false],[0,0,0,"StackChange",null,null,null,false],[0,0,0,"LoadPdbDebuginfo",null,null,null,false],[0,0,0,"MapIpToSrcloc",null,null,null,false],[0,0,0,"ChangeErrDisablement",null,null,null,false],[0,0,0,"VexInitForIri",null,null,null,false],[0,0,0,"InnerThreads",null,null,null,false],[443,88,0,null,null,null,[61265],false],[0,0,0,"base",null,"",null,false],[443,91,0,null,null,null,[61267,61268],false],[0,0,0,"base",null,"",null,false],[0,0,0,"code",null,"",null,false],[443,95,0,null,null,null,[61270,61271,61272,61273,61274,61275,61276],false],[0,0,0,"default",null,"",null,false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[443,99,0,null,null,null,[61278,61279,61280,61281,61282,61283],false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[443,107,0,null,null," Returns the number of Valgrinds this code is running under.  That\n is, 0 if running natively, 1 if running under Valgrind, 2 if\n running under Valgrind which is running under another Valgrind,\n etc.",[],false],[443,118,0,null,null," Discard translation of code in the slice qzz.  Useful if you are debugging\n a JITter or some such, since it provides a way to make sure valgrind will\n retranslate the invalidated area.  Returns no value.",[61286],false],[0,0,0,"qzz",null,"",null,false],[443,122,0,null,null,null,[61288],false],[0,0,0,"qzz",null,"",null,false],[443,126,0,null,null,null,[61290],false],[0,0,0,"func",null,"",[61291],false],[0,0,0,"",null,"",null,false],[443,130,0,null,null,null,[61293,61296],false],[0,0,0,"func",null,"",[61294,61295],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"a1",null,"",null,false],[443,134,0,null,null,null,[61298,61302,61303],false],[0,0,0,"func",null,"",[61299,61300,61301],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[443,138,0,null,null,null,[61305,61310,61311,61312],false],[0,0,0,"func",null,"",[61306,61307,61308,61309],false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[443,145,0,null,null," Counts the number of errors that have been recorded by a tool.  Nb:\n the tool must record the errors with VG_(maybe_record_error)() or\n VG_(unique_error)() for them to be counted.",[],false],[443,150,0,null,null,null,[61315,61316,61317],false],[0,0,0,"mem",null,"",null,false],[0,0,0,"rzB",null,"",null,false],[0,0,0,"is_zeroed",null,"",null,false],[443,154,0,null,null,null,[61319,61320,61321],false],[0,0,0,"oldmem",null,"",null,false],[0,0,0,"newsize",null,"",null,false],[0,0,0,"rzB",null,"",null,false],[443,158,0,null,null,null,[61323,61324],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"rzB",null,"",null,false],[443,163,0,null,null," Create a memory pool.",[],false],[443,164,0,null,null,null,null,false],[443,165,0,null,null,null,null,false],[443,167,0,null,null,null,[61329,61330,61331,61332],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"rzB",null,"",null,false],[0,0,0,"is_zeroed",null,"",null,false],[0,0,0,"flags",null,"",null,false],[443,172,0,null,null," Destroy a memory pool.",[61334],false],[0,0,0,"pool",null,"",null,false],[443,177,0,null,null," Associate a piece of memory with a memory pool.",[61336,61337],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"mem",null,"",null,false],[443,182,0,null,null," Disassociate a piece of memory from a memory pool.",[61339,61340],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"addr",null,"",null,false],[443,187,0,null,null," Disassociate any pieces outside a particular range.",[61342,61343],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"mem",null,"",null,false],[443,192,0,null,null," Resize and/or move a piece associated with a memory pool.",[61345,61346],false],[0,0,0,"poolA",null,"",null,false],[0,0,0,"poolB",null,"",null,false],[443,197,0,null,null," Resize and/or move a piece associated with a memory pool.",[61348,61349,61350],false],[0,0,0,"pool",null,"",null,false],[0,0,0,"addrA",null,"",null,false],[0,0,0,"mem",null,"",null,false],[443,202,0,null,null," Return if a mempool exists.",[61352],false],[0,0,0,"pool",null,"",null,false],[443,209,0,null,null," Mark a piece of memory as being a stack. Returns a stack id.\n start is the lowest addressable stack byte, end is the highest\n addressable stack byte.",[61354],false],[0,0,0,"stack",null,"",null,false],[443,214,0,null,null," Unmark the piece of memory associated with a stack id as being a stack.",[61356],false],[0,0,0,"id",null,"",null,false],[443,221,0,null,null," Change the start and end address of the stack id.\n start is the new lowest addressable stack byte, end is the new highest\n addressable stack byte.",[61358,61359],false],[0,0,0,"id",null,"",null,false],[0,0,0,"newstack",null,"",null,false],[443,236,0,null,null," Map a code address to a source file name and line number.  buf64\n must point to a 64-byte buffer in the caller's address space. The\n result will be dumped in there and is guaranteed to be zero\n terminated.  If no info is found, the first byte is set to zero.",[61361,61362],false],[0,0,0,"addr",null,"",null,false],[0,0,0,"buf64",null,"",null,false],[443,248,0,null,null," Disable error reporting for this thread.  Behaves in a stack like\n way, so you can safely call this multiple times provided that\n enableErrorReporting() is called the same number of times\n to re-enable reporting.  The first call of this macro disables\n reporting.  Subsequent calls have no effect except to increase the\n number of enableErrorReporting() calls needed to re-enable\n reporting.  Child threads do not inherit this setting from their\n parents -- they are always created with reporting enabled.",[],false],[443,253,0,null,null," Re-enable error reporting, (see disableErrorReporting())",[],false],[443,262,0,null,null," Execute a monitor command from the client program.\n If a connection is opened with GDB, the output will be sent\n according to the output mode set for vgdb.\n If no connection is opened, output will go to the log output.\n Returns 1 if command not recognised, 0 otherwise.",[61366],false],[0,0,0,"command",null,"",null,false],[443,266,0,null,null,null,null,false],[0,0,0,"valgrind/memcheck.zig",null,"",[],false],[444,0,0,null,null,null,null,false],[444,1,0,null,null,null,null,false],[444,2,0,null,null,null,null,false],[444,4,0,null,null,null,[61373,61374,61375,61376,61377,61378,61379,61380,61381,61382,61383,61384,61385,61386,61387],false],[0,0,0,"MakeMemNoAccess",null,null,null,false],[0,0,0,"MakeMemUndefined",null,null,null,false],[0,0,0,"MakeMemDefined",null,null,null,false],[0,0,0,"Discard",null,null,null,false],[0,0,0,"CheckMemIsAddressable",null,null,null,false],[0,0,0,"CheckMemIsDefined",null,null,null,false],[0,0,0,"DoLeakCheck",null,null,null,false],[0,0,0,"CountLeaks",null,null,null,false],[0,0,0,"GetVbits",null,null,null,false],[0,0,0,"SetVbits",null,null,null,false],[0,0,0,"CreateBlock",null,null,null,false],[0,0,0,"MakeMemDefinedIfAddressable",null,null,null,false],[0,0,0,"CountLeakBlocks",null,null,null,false],[0,0,0,"EnableAddrErrorReportingInRange",null,null,null,false],[0,0,0,"DisableAddrErrorReportingInRange",null,null,null,false],[444,22,0,null,null,null,[61389,61390,61391,61392,61393,61394,61395],false],[0,0,0,"default",null,"",null,false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[444,26,0,null,null,null,[61397,61398,61399,61400,61401,61402],false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[444,32,0,null,null," Mark memory at qzz.ptr as unaddressable for qzz.len bytes.\n This returns -1 when run on Valgrind and 0 otherwise.",[61404],false],[0,0,0,"qzz",null,"",null,false],[444,40,0,null,null," Similarly, mark memory at qzz.ptr as addressable but undefined\n for qzz.len bytes.\n This returns -1 when run on Valgrind and 0 otherwise.",[61406],false],[0,0,0,"qzz",null,"",null,false],[444,47,0,null,null," Similarly, mark memory at qzz.ptr as addressable and defined\n for qzz.len bytes.",[61408],false],[0,0,0,"qzz",null,"",null,false],[444,57,0,null,null," Similar to makeMemDefined except that addressability is\n not altered: bytes which are addressable are marked as defined,\n but those which are not addressable are left unchanged.\n This returns -1 when run on Valgrind and 0 otherwise.",[61410],false],[0,0,0,"qzz",null,"",null,false],[444,66,0,null,null," Create a block-description handle.  The description is an ascii\n string which is included in any messages pertaining to addresses\n within the specified memory range.  Has no other effect on the\n properties of the memory range.",[61412,61413],false],[0,0,0,"qzz",null,"",null,false],[0,0,0,"desc",null,"",null,false],[444,73,0,null,null," Discard a block-description-handle. Returns 1 for an\n invalid handle, 0 for a valid handle.",[61415],false],[0,0,0,"blkindex",null,"",null,false],[444,82,0,null,null," Check that memory at qzz.ptr is addressable for qzz.len bytes.\n If suitable addressability is not established, Valgrind prints an\n error message and returns the address of the first offending byte.\n Otherwise it returns zero.",[61417],false],[0,0,0,"qzz",null,"",null,false],[444,90,0,null,null," Check that memory at qzz.ptr is addressable and defined for\n qzz.len bytes.  If suitable addressability and definedness are not\n established, Valgrind prints an error message and returns the\n address of the first offending byte.  Otherwise it returns zero.",[61419],false],[0,0,0,"qzz",null,"",null,false],[444,95,0,null,null," Do a full memory leak check (like --leak-check=full) mid-execution.",[],false],[444,102,0,null,null," Same as doLeakCheck() but only showing the entries for\n which there was an increase in leaked bytes or leaked nr of blocks\n since the previous leak search.",[],false],[444,109,0,null,null," Same as doAddedLeakCheck() but showing entries with\n increased or decreased leaked bytes/blocks since previous leak\n search.",[],false],[444,114,0,null,null," Do a summary memory leak check (like --leak-check=summary) mid-execution.",[],false],[444,120,0,null,null," Return number of leaked, dubious, reachable and suppressed bytes found by\n all previous leak checks.",[61425,61426,61427,61428],false],[0,0,0,"leaked",null,null,null,false],[0,0,0,"dubious",null,null,null,false],[0,0,0,"reachable",null,null,null,false],[0,0,0,"suppressed",null,null,null,false],[444,127,0,null,null,null,[],false],[444,157,0,null,null,null,[],false],[444,195,0,null,null," Get the validity data for addresses zza and copy it\n into the provided zzvbits array.  Return values:\n    0   if not running on valgrind\n    1   success\n    2   [previously indicated unaligned arrays;  these are now allowed]\n    3   if any parts of zzsrc/zzvbits are not addressable.\n The metadata is not copied in cases 0, 2 or 3 so it should be\n impossible to segfault your system by using this call.",[61432,61433],false],[0,0,0,"zza",null,"",null,false],[0,0,0,"zzvbits",null,"",null,false],[444,208,0,null,null," Set the validity data for addresses zza, copying it\n from the provided zzvbits array.  Return values:\n    0   if not running on valgrind\n    1   success\n    2   [previously indicated unaligned arrays;  these are now allowed]\n    3   if any parts of zza/zzvbits are not addressable.\n The metadata is not copied in cases 0, 2 or 3 so it should be\n impossible to segfault your system by using this call.",[61435,61436],false],[0,0,0,"zzvbits",null,"",null,false],[0,0,0,"zza",null,"",null,false],[444,215,0,null,null," Disable and re-enable reporting of addressing errors in the\n specified address range.",[61438],false],[0,0,0,"qzz",null,"",null,false],[444,220,0,null,null,null,[61440],false],[0,0,0,"qzz",null,"",null,false],[443,267,0,null,null,null,null,false],[0,0,0,"valgrind/callgrind.zig",null,"",[],false],[445,0,0,null,null,null,null,false],[445,1,0,null,null,null,null,false],[445,3,0,null,null,null,[61446,61447,61448,61449,61450,61451],false],[0,0,0,"DumpStats",null,null,null,false],[0,0,0,"ZeroStats",null,null,null,false],[0,0,0,"ToggleCollect",null,null,null,false],[0,0,0,"DumpStatsAt",null,null,null,false],[0,0,0,"StartInstrumentation",null,null,null,false],[0,0,0,"StopInstrumentation",null,null,null,false],[445,12,0,null,null,null,[61453,61454,61455,61456,61457,61458,61459],false],[0,0,0,"default",null,"",null,false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[445,16,0,null,null,null,[61461,61462,61463,61464,61465,61466],false],[0,0,0,"request",null,"",null,false],[0,0,0,"a1",null,"",null,false],[0,0,0,"a2",null,"",null,false],[0,0,0,"a3",null,"",null,false],[0,0,0,"a4",null,"",null,false],[0,0,0,"a5",null,"",null,false],[445,21,0,null,null," Dump current state of cost centers, and zero them afterwards",[],false],[445,29,0,null,null," Dump current state of cost centers, and zero them afterwards.\n The argument is appended to a string stating the reason which triggered\n the dump. This string is written as a description field into the\n profile data dump.",[61469],false],[0,0,0,"pos_str",null,"",null,false],[445,34,0,null,null," Zero cost centers",[],false],[445,42,0,null,null," Toggles collection state.\n The collection state specifies whether the happening of events\n should be noted or if they are to be ignored. Events are noted\n by increment of counters in a cost center",[],false],[445,50,0,null,null," Start full callgrind instrumentation if not already switched on.\n When cache simulation is done, it will flush the simulated cache;\n this will lead to an artificial cache warmup phase afterwards with\n cache misses which would not have happened in reality.",[],false],[445,61,0,null,null," Stop full callgrind instrumentation if not already switched off.\n This flushes Valgrinds translation cache, and does no additional\n instrumentation afterwards, which effectivly will run at the same\n speed as the \"none\" tool (ie. at minimal slowdown).\n Use this to bypass Callgrind aggregation for uninteresting code parts.\n To start Callgrind in this mode to ignore the setup phase, use\n the option \"--instr-atstart=no\".",[],false],[1,191,0,null,null," Constants and types representing the Wasm binary format.",null,false],[0,0,0,"wasm.zig",null,"",[],false],[446,3,0,null,null,"! Contains all constants and types representing the wasm\n! binary format, as specified by:\n! https://webassembly.github.io/spec/core/",null,false],[446,4,0,null,null,null,null,false],[446,12,0,null,null," Wasm instruction opcodes\n\n All instructions are defined as per spec:\n https://webassembly.github.io/spec/core/appendix/index-instructions.html",[61479,61480,61481,61482,61483,61484,61485,61486,61487,61488,61489,61490,61491,61492,61493,61494,61495,61496,61497,61498,61499,61500,61501,61502,61503,61504,61505,61506,61507,61508,61509,61510,61511,61512,61513,61514,61515,61516,61517,61518,61519,61520,61521,61522,61523,61524,61525,61526,61527,61528,61529,61530,61531,61532,61533,61534,61535,61536,61537,61538,61539,61540,61541,61542,61543,61544,61545,61546,61547,61548,61549,61550,61551,61552,61553,61554,61555,61556,61557,61558,61559,61560,61561,61562,61563,61564,61565,61566,61567,61568,61569,61570,61571,61572,61573,61574,61575,61576,61577,61578,61579,61580,61581,61582,61583,61584,61585,61586,61587,61588,61589,61590,61591,61592,61593,61594,61595,61596,61597,61598,61599,61600,61601,61602,61603,61604,61605,61606,61607,61608,61609,61610,61611,61612,61613,61614,61615,61616,61617,61618,61619,61620,61621,61622,61623,61624,61625,61626,61627,61628,61629,61630,61631,61632,61633,61634,61635,61636,61637,61638,61639,61640,61641,61642,61643,61644,61645,61646,61647,61648,61649,61650,61651,61652,61653,61654,61655,61656,61657,61658],false],[0,0,0,"unreachable",null,null,null,false],[0,0,0,"nop",null,null,null,false],[0,0,0,"block",null,null,null,false],[0,0,0,"loop",null,null,null,false],[0,0,0,"if",null,null,null,false],[0,0,0,"else",null,null,null,false],[0,0,0,"end",null,null,null,false],[0,0,0,"br",null,null,null,false],[0,0,0,"br_if",null,null,null,false],[0,0,0,"br_table",null,null,null,false],[0,0,0,"return",null,null,null,false],[0,0,0,"call",null,null,null,false],[0,0,0,"call_indirect",null,null,null,false],[0,0,0,"drop",null,null,null,false],[0,0,0,"select",null,null,null,false],[0,0,0,"local_get",null,null,null,false],[0,0,0,"local_set",null,null,null,false],[0,0,0,"local_tee",null,null,null,false],[0,0,0,"global_get",null,null,null,false],[0,0,0,"global_set",null,null,null,false],[0,0,0,"i32_load",null,null,null,false],[0,0,0,"i64_load",null,null,null,false],[0,0,0,"f32_load",null,null,null,false],[0,0,0,"f64_load",null,null,null,false],[0,0,0,"i32_load8_s",null,null,null,false],[0,0,0,"i32_load8_u",null,null,null,false],[0,0,0,"i32_load16_s",null,null,null,false],[0,0,0,"i32_load16_u",null,null,null,false],[0,0,0,"i64_load8_s",null,null,null,false],[0,0,0,"i64_load8_u",null,null,null,false],[0,0,0,"i64_load16_s",null,null,null,false],[0,0,0,"i64_load16_u",null,null,null,false],[0,0,0,"i64_load32_s",null,null,null,false],[0,0,0,"i64_load32_u",null,null,null,false],[0,0,0,"i32_store",null,null,null,false],[0,0,0,"i64_store",null,null,null,false],[0,0,0,"f32_store",null,null,null,false],[0,0,0,"f64_store",null,null,null,false],[0,0,0,"i32_store8",null,null,null,false],[0,0,0,"i32_store16",null,null,null,false],[0,0,0,"i64_store8",null,null,null,false],[0,0,0,"i64_store16",null,null,null,false],[0,0,0,"i64_store32",null,null,null,false],[0,0,0,"memory_size",null,null,null,false],[0,0,0,"memory_grow",null,null,null,false],[0,0,0,"i32_const",null,null,null,false],[0,0,0,"i64_const",null,null,null,false],[0,0,0,"f32_const",null,null,null,false],[0,0,0,"f64_const",null,null,null,false],[0,0,0,"i32_eqz",null,null,null,false],[0,0,0,"i32_eq",null,null,null,false],[0,0,0,"i32_ne",null,null,null,false],[0,0,0,"i32_lt_s",null,null,null,false],[0,0,0,"i32_lt_u",null,null,null,false],[0,0,0,"i32_gt_s",null,null,null,false],[0,0,0,"i32_gt_u",null,null,null,false],[0,0,0,"i32_le_s",null,null,null,false],[0,0,0,"i32_le_u",null,null,null,false],[0,0,0,"i32_ge_s",null,null,null,false],[0,0,0,"i32_ge_u",null,null,null,false],[0,0,0,"i64_eqz",null,null,null,false],[0,0,0,"i64_eq",null,null,null,false],[0,0,0,"i64_ne",null,null,null,false],[0,0,0,"i64_lt_s",null,null,null,false],[0,0,0,"i64_lt_u",null,null,null,false],[0,0,0,"i64_gt_s",null,null,null,false],[0,0,0,"i64_gt_u",null,null,null,false],[0,0,0,"i64_le_s",null,null,null,false],[0,0,0,"i64_le_u",null,null,null,false],[0,0,0,"i64_ge_s",null,null,null,false],[0,0,0,"i64_ge_u",null,null,null,false],[0,0,0,"f32_eq",null,null,null,false],[0,0,0,"f32_ne",null,null,null,false],[0,0,0,"f32_lt",null,null,null,false],[0,0,0,"f32_gt",null,null,null,false],[0,0,0,"f32_le",null,null,null,false],[0,0,0,"f32_ge",null,null,null,false],[0,0,0,"f64_eq",null,null,null,false],[0,0,0,"f64_ne",null,null,null,false],[0,0,0,"f64_lt",null,null,null,false],[0,0,0,"f64_gt",null,null,null,false],[0,0,0,"f64_le",null,null,null,false],[0,0,0,"f64_ge",null,null,null,false],[0,0,0,"i32_clz",null,null,null,false],[0,0,0,"i32_ctz",null,null,null,false],[0,0,0,"i32_popcnt",null,null,null,false],[0,0,0,"i32_add",null,null,null,false],[0,0,0,"i32_sub",null,null,null,false],[0,0,0,"i32_mul",null,null,null,false],[0,0,0,"i32_div_s",null,null,null,false],[0,0,0,"i32_div_u",null,null,null,false],[0,0,0,"i32_rem_s",null,null,null,false],[0,0,0,"i32_rem_u",null,null,null,false],[0,0,0,"i32_and",null,null,null,false],[0,0,0,"i32_or",null,null,null,false],[0,0,0,"i32_xor",null,null,null,false],[0,0,0,"i32_shl",null,null,null,false],[0,0,0,"i32_shr_s",null,null,null,false],[0,0,0,"i32_shr_u",null,null,null,false],[0,0,0,"i32_rotl",null,null,null,false],[0,0,0,"i32_rotr",null,null,null,false],[0,0,0,"i64_clz",null,null,null,false],[0,0,0,"i64_ctz",null,null,null,false],[0,0,0,"i64_popcnt",null,null,null,false],[0,0,0,"i64_add",null,null,null,false],[0,0,0,"i64_sub",null,null,null,false],[0,0,0,"i64_mul",null,null,null,false],[0,0,0,"i64_div_s",null,null,null,false],[0,0,0,"i64_div_u",null,null,null,false],[0,0,0,"i64_rem_s",null,null,null,false],[0,0,0,"i64_rem_u",null,null,null,false],[0,0,0,"i64_and",null,null,null,false],[0,0,0,"i64_or",null,null,null,false],[0,0,0,"i64_xor",null,null,null,false],[0,0,0,"i64_shl",null,null,null,false],[0,0,0,"i64_shr_s",null,null,null,false],[0,0,0,"i64_shr_u",null,null,null,false],[0,0,0,"i64_rotl",null,null,null,false],[0,0,0,"i64_rotr",null,null,null,false],[0,0,0,"f32_abs",null,null,null,false],[0,0,0,"f32_neg",null,null,null,false],[0,0,0,"f32_ceil",null,null,null,false],[0,0,0,"f32_floor",null,null,null,false],[0,0,0,"f32_trunc",null,null,null,false],[0,0,0,"f32_nearest",null,null,null,false],[0,0,0,"f32_sqrt",null,null,null,false],[0,0,0,"f32_add",null,null,null,false],[0,0,0,"f32_sub",null,null,null,false],[0,0,0,"f32_mul",null,null,null,false],[0,0,0,"f32_div",null,null,null,false],[0,0,0,"f32_min",null,null,null,false],[0,0,0,"f32_max",null,null,null,false],[0,0,0,"f32_copysign",null,null,null,false],[0,0,0,"f64_abs",null,null,null,false],[0,0,0,"f64_neg",null,null,null,false],[0,0,0,"f64_ceil",null,null,null,false],[0,0,0,"f64_floor",null,null,null,false],[0,0,0,"f64_trunc",null,null,null,false],[0,0,0,"f64_nearest",null,null,null,false],[0,0,0,"f64_sqrt",null,null,null,false],[0,0,0,"f64_add",null,null,null,false],[0,0,0,"f64_sub",null,null,null,false],[0,0,0,"f64_mul",null,null,null,false],[0,0,0,"f64_div",null,null,null,false],[0,0,0,"f64_min",null,null,null,false],[0,0,0,"f64_max",null,null,null,false],[0,0,0,"f64_copysign",null,null,null,false],[0,0,0,"i32_wrap_i64",null,null,null,false],[0,0,0,"i32_trunc_f32_s",null,null,null,false],[0,0,0,"i32_trunc_f32_u",null,null,null,false],[0,0,0,"i32_trunc_f64_s",null,null,null,false],[0,0,0,"i32_trunc_f64_u",null,null,null,false],[0,0,0,"i64_extend_i32_s",null,null,null,false],[0,0,0,"i64_extend_i32_u",null,null,null,false],[0,0,0,"i64_trunc_f32_s",null,null,null,false],[0,0,0,"i64_trunc_f32_u",null,null,null,false],[0,0,0,"i64_trunc_f64_s",null,null,null,false],[0,0,0,"i64_trunc_f64_u",null,null,null,false],[0,0,0,"f32_convert_i32_s",null,null,null,false],[0,0,0,"f32_convert_i32_u",null,null,null,false],[0,0,0,"f32_convert_i64_s",null,null,null,false],[0,0,0,"f32_convert_i64_u",null,null,null,false],[0,0,0,"f32_demote_f64",null,null,null,false],[0,0,0,"f64_convert_i32_s",null,null,null,false],[0,0,0,"f64_convert_i32_u",null,null,null,false],[0,0,0,"f64_convert_i64_s",null,null,null,false],[0,0,0,"f64_convert_i64_u",null,null,null,false],[0,0,0,"f64_promote_f32",null,null,null,false],[0,0,0,"i32_reinterpret_f32",null,null,null,false],[0,0,0,"i64_reinterpret_f64",null,null,null,false],[0,0,0,"f32_reinterpret_i32",null,null,null,false],[0,0,0,"f64_reinterpret_i64",null,null,null,false],[0,0,0,"i32_extend8_s",null,null,null,false],[0,0,0,"i32_extend16_s",null,null,null,false],[0,0,0,"i64_extend8_s",null,null,null,false],[0,0,0,"i64_extend16_s",null,null,null,false],[0,0,0,"i64_extend32_s",null,null,null,false],[0,0,0,"misc_prefix",null,null,null,false],[0,0,0,"simd_prefix",null,null,null,false],[0,0,0,"atomics_prefix",null,null,null,false],[446,199,0,null,null," Returns the integer value of an `Opcode`. Used by the Zig compiler\n to write instructions to the wasm binary file",[61660],false],[0,0,0,"op",null,"",null,false],[446,221,0,null,null," Opcodes that require a prefix `0xFC`\n Each opcode represents a varuint32, meaning\n they are encoded as leb128 in binary.",[61662,61663,61664,61665,61666,61667,61668,61669,61670,61671,61672,61673,61674,61675,61676,61677,61678,61679],false],[0,0,0,"i32_trunc_sat_f32_s",null,null,null,false],[0,0,0,"i32_trunc_sat_f32_u",null,null,null,false],[0,0,0,"i32_trunc_sat_f64_s",null,null,null,false],[0,0,0,"i32_trunc_sat_f64_u",null,null,null,false],[0,0,0,"i64_trunc_sat_f32_s",null,null,null,false],[0,0,0,"i64_trunc_sat_f32_u",null,null,null,false],[0,0,0,"i64_trunc_sat_f64_s",null,null,null,false],[0,0,0,"i64_trunc_sat_f64_u",null,null,null,false],[0,0,0,"memory_init",null,null,null,false],[0,0,0,"data_drop",null,null,null,false],[0,0,0,"memory_copy",null,null,null,false],[0,0,0,"memory_fill",null,null,null,false],[0,0,0,"table_init",null,null,null,false],[0,0,0,"elem_drop",null,null,null,false],[0,0,0,"table_copy",null,null,null,false],[0,0,0,"table_grow",null,null,null,false],[0,0,0,"table_size",null,null,null,false],[0,0,0,"table_fill",null,null,null,false],[446,245,0,null,null," Returns the integer value of an `MiscOpcode`. Used by the Zig compiler\n to write instructions to the wasm binary file",[61681],false],[0,0,0,"op",null,"",null,false],[446,252,0,null,null," Simd opcodes that require a prefix `0xFD`.\n Each opcode represents a varuint32, meaning\n they are encoded as leb128 in binary.",[61683,61684,61685,61686,61687,61688,61689,61690,61691,61692,61693,61694,61695,61696,61697,61698,61699,61700,61701,61702,61703,61704,61705,61706,61707,61708,61709,61710,61711,61712,61713,61714,61715,61716,61717,61718,61719,61720,61721,61722,61723,61724,61725,61726,61727,61728,61729,61730,61731,61732,61733,61734,61735,61736,61737,61738,61739,61740,61741,61742,61743,61744,61745,61746,61747,61748,61749,61750,61751,61752,61753,61754,61755,61756,61757,61758,61759,61760,61761,61762,61763,61764,61765,61766,61767,61768,61769,61770,61771,61772,61773,61774,61775,61776,61777,61778,61779,61780,61781,61782,61783,61784,61785,61786,61787,61788,61789,61790,61791,61792,61793,61794,61795,61796,61797,61798,61799,61800,61801,61802,61803,61804,61805,61806,61807,61808,61809,61810,61811,61812,61813,61814,61815,61816,61817,61818,61819,61820,61821,61822,61823,61824,61825,61826,61827,61828,61829,61830,61831,61832,61833,61834,61835,61836,61837,61838,61839,61840,61841,61842,61843,61844,61845,61846,61847,61848,61849,61850,61851,61852,61853,61854,61855,61856,61857,61858,61859,61860,61861,61862,61863,61864,61865,61866,61867,61868,61869,61870,61871,61872,61873,61874,61875,61876,61877,61878,61879,61880,61881,61882,61883,61884,61885,61886,61887,61888,61889,61890,61891,61892,61893,61894,61895,61896,61897,61898,61899,61900,61901,61902,61903,61904,61905,61906,61907,61908,61909,61910,61911,61912,61913,61914,61915,61916,61917,61918,61919,61920,61921,61922,61923,61924,61925,61926,61927,61928,61929,61930,61931,61932,61933,61934,61935,61936,61937,61938,61939],false],[0,0,0,"v128_load",null,null,null,false],[0,0,0,"v128_load8x8_s",null,null,null,false],[0,0,0,"v128_load8x8_u",null,null,null,false],[0,0,0,"v128_load16x4_s",null,null,null,false],[0,0,0,"v128_load16x4_u",null,null,null,false],[0,0,0,"v128_load32x2_s",null,null,null,false],[0,0,0,"v128_load32x2_u",null,null,null,false],[0,0,0,"v128_load8_splat",null,null,null,false],[0,0,0,"v128_load16_splat",null,null,null,false],[0,0,0,"v128_load32_splat",null,null,null,false],[0,0,0,"v128_load64_splat",null,null,null,false],[0,0,0,"v128_store",null,null,null,false],[0,0,0,"v128_const",null,null,null,false],[0,0,0,"i8x16_shuffle",null,null,null,false],[0,0,0,"i8x16_swizzle",null,null,null,false],[0,0,0,"i8x16_splat",null,null,null,false],[0,0,0,"i16x8_splat",null,null,null,false],[0,0,0,"i32x4_splat",null,null,null,false],[0,0,0,"i64x2_splat",null,null,null,false],[0,0,0,"f32x4_splat",null,null,null,false],[0,0,0,"f64x2_splat",null,null,null,false],[0,0,0,"i8x16_extract_lane_s",null,null,null,false],[0,0,0,"i8x16_extract_lane_u",null,null,null,false],[0,0,0,"i8x16_replace_lane",null,null,null,false],[0,0,0,"i16x8_extract_lane_s",null,null,null,false],[0,0,0,"i16x8_extract_lane_u",null,null,null,false],[0,0,0,"i16x8_replace_lane",null,null,null,false],[0,0,0,"i32x4_extract_lane",null,null,null,false],[0,0,0,"i32x4_replace_lane",null,null,null,false],[0,0,0,"i64x2_extract_lane",null,null,null,false],[0,0,0,"i64x2_replace_lane",null,null,null,false],[0,0,0,"f32x4_extract_lane",null,null,null,false],[0,0,0,"f32x4_replace_lane",null,null,null,false],[0,0,0,"f64x2_extract_lane",null,null,null,false],[0,0,0,"f64x2_replace_lane",null,null,null,false],[0,0,0,"i8x16_eq",null,null,null,false],[0,0,0,"i16x8_eq",null,null,null,false],[0,0,0,"i32x4_eq",null,null,null,false],[0,0,0,"i8x16_ne",null,null,null,false],[0,0,0,"i16x8_ne",null,null,null,false],[0,0,0,"i32x4_ne",null,null,null,false],[0,0,0,"i8x16_lt_s",null,null,null,false],[0,0,0,"i16x8_lt_s",null,null,null,false],[0,0,0,"i32x4_lt_s",null,null,null,false],[0,0,0,"i8x16_lt_u",null,null,null,false],[0,0,0,"i16x8_lt_u",null,null,null,false],[0,0,0,"i32x4_lt_u",null,null,null,false],[0,0,0,"i8x16_gt_s",null,null,null,false],[0,0,0,"i16x8_gt_s",null,null,null,false],[0,0,0,"i32x4_gt_s",null,null,null,false],[0,0,0,"i8x16_gt_u",null,null,null,false],[0,0,0,"i16x8_gt_u",null,null,null,false],[0,0,0,"i32x4_gt_u",null,null,null,false],[0,0,0,"i8x16_le_s",null,null,null,false],[0,0,0,"i16x8_le_s",null,null,null,false],[0,0,0,"i32x4_le_s",null,null,null,false],[0,0,0,"i8x16_le_u",null,null,null,false],[0,0,0,"i16x8_le_u",null,null,null,false],[0,0,0,"i32x4_le_u",null,null,null,false],[0,0,0,"i8x16_ge_s",null,null,null,false],[0,0,0,"i16x8_ge_s",null,null,null,false],[0,0,0,"i32x4_ge_s",null,null,null,false],[0,0,0,"i8x16_ge_u",null,null,null,false],[0,0,0,"i16x8_ge_u",null,null,null,false],[0,0,0,"i32x4_ge_u",null,null,null,false],[0,0,0,"f32x4_eq",null,null,null,false],[0,0,0,"f64x2_eq",null,null,null,false],[0,0,0,"f32x4_ne",null,null,null,false],[0,0,0,"f64x2_ne",null,null,null,false],[0,0,0,"f32x4_lt",null,null,null,false],[0,0,0,"f64x2_lt",null,null,null,false],[0,0,0,"f32x4_gt",null,null,null,false],[0,0,0,"f64x2_gt",null,null,null,false],[0,0,0,"f32x4_le",null,null,null,false],[0,0,0,"f64x2_le",null,null,null,false],[0,0,0,"f32x4_ge",null,null,null,false],[0,0,0,"f64x2_ge",null,null,null,false],[0,0,0,"v128_not",null,null,null,false],[0,0,0,"v128_and",null,null,null,false],[0,0,0,"v128_andnot",null,null,null,false],[0,0,0,"v128_or",null,null,null,false],[0,0,0,"v128_xor",null,null,null,false],[0,0,0,"v128_bitselect",null,null,null,false],[0,0,0,"v128_any_true",null,null,null,false],[0,0,0,"v128_load8_lane",null,null,null,false],[0,0,0,"v128_load16_lane",null,null,null,false],[0,0,0,"v128_load32_lane",null,null,null,false],[0,0,0,"v128_load64_lane",null,null,null,false],[0,0,0,"v128_store8_lane",null,null,null,false],[0,0,0,"v128_store16_lane",null,null,null,false],[0,0,0,"v128_store32_lane",null,null,null,false],[0,0,0,"v128_store64_lane",null,null,null,false],[0,0,0,"v128_load32_zero",null,null,null,false],[0,0,0,"v128_load64_zero",null,null,null,false],[0,0,0,"f32x4_demote_f64x2_zero",null,null,null,false],[0,0,0,"f64x2_promote_low_f32x4",null,null,null,false],[0,0,0,"i8x16_abs",null,null,null,false],[0,0,0,"i16x8_abs",null,null,null,false],[0,0,0,"i32x4_abs",null,null,null,false],[0,0,0,"i64x2_abs",null,null,null,false],[0,0,0,"i8x16_neg",null,null,null,false],[0,0,0,"i16x8_neg",null,null,null,false],[0,0,0,"i32x4_neg",null,null,null,false],[0,0,0,"i64x2_neg",null,null,null,false],[0,0,0,"i8x16_popcnt",null,null,null,false],[0,0,0,"i16x8_q15mulr_sat_s",null,null,null,false],[0,0,0,"i8x16_all_true",null,null,null,false],[0,0,0,"i16x8_all_true",null,null,null,false],[0,0,0,"i32x4_all_true",null,null,null,false],[0,0,0,"i64x2_all_true",null,null,null,false],[0,0,0,"i8x16_bitmask",null,null,null,false],[0,0,0,"i16x8_bitmask",null,null,null,false],[0,0,0,"i32x4_bitmask",null,null,null,false],[0,0,0,"i64x2_bitmask",null,null,null,false],[0,0,0,"i8x16_narrow_i16x8_s",null,null,null,false],[0,0,0,"i16x8_narrow_i32x4_s",null,null,null,false],[0,0,0,"i8x16_narrow_i16x8_u",null,null,null,false],[0,0,0,"i16x8_narrow_i32x4_u",null,null,null,false],[0,0,0,"f32x4_ceil",null,null,null,false],[0,0,0,"i16x8_extend_low_i8x16_s",null,null,null,false],[0,0,0,"i32x4_extend_low_i16x8_s",null,null,null,false],[0,0,0,"i64x2_extend_low_i32x4_s",null,null,null,false],[0,0,0,"f32x4_floor",null,null,null,false],[0,0,0,"i16x8_extend_high_i8x16_s",null,null,null,false],[0,0,0,"i32x4_extend_high_i16x8_s",null,null,null,false],[0,0,0,"i64x2_extend_high_i32x4_s",null,null,null,false],[0,0,0,"f32x4_trunc",null,null,null,false],[0,0,0,"i16x8_extend_low_i8x16_u",null,null,null,false],[0,0,0,"i32x4_extend_low_i16x8_u",null,null,null,false],[0,0,0,"i64x2_extend_low_i32x4_u",null,null,null,false],[0,0,0,"f32x4_nearest",null,null,null,false],[0,0,0,"i16x8_extend_high_i8x16_u",null,null,null,false],[0,0,0,"i32x4_extend_high_i16x8_u",null,null,null,false],[0,0,0,"i64x2_extend_high_i32x4_u",null,null,null,false],[0,0,0,"i8x16_shl",null,null,null,false],[0,0,0,"i16x8_shl",null,null,null,false],[0,0,0,"i32x4_shl",null,null,null,false],[0,0,0,"i64x2_shl",null,null,null,false],[0,0,0,"i8x16_shr_s",null,null,null,false],[0,0,0,"i16x8_shr_s",null,null,null,false],[0,0,0,"i32x4_shr_s",null,null,null,false],[0,0,0,"i64x2_shr_s",null,null,null,false],[0,0,0,"i8x16_shr_u",null,null,null,false],[0,0,0,"i16x8_shr_u",null,null,null,false],[0,0,0,"i32x4_shr_u",null,null,null,false],[0,0,0,"i64x2_shr_u",null,null,null,false],[0,0,0,"i8x16_add",null,null,null,false],[0,0,0,"i16x8_add",null,null,null,false],[0,0,0,"i32x4_add",null,null,null,false],[0,0,0,"i64x2_add",null,null,null,false],[0,0,0,"i8x16_add_sat_s",null,null,null,false],[0,0,0,"i16x8_add_sat_s",null,null,null,false],[0,0,0,"i8x16_add_sat_u",null,null,null,false],[0,0,0,"i16x8_add_sat_u",null,null,null,false],[0,0,0,"i8x16_sub",null,null,null,false],[0,0,0,"i16x8_sub",null,null,null,false],[0,0,0,"i32x4_sub",null,null,null,false],[0,0,0,"i64x2_sub",null,null,null,false],[0,0,0,"i8x16_sub_sat_s",null,null,null,false],[0,0,0,"i16x8_sub_sat_s",null,null,null,false],[0,0,0,"i8x16_sub_sat_u",null,null,null,false],[0,0,0,"i16x8_sub_sat_u",null,null,null,false],[0,0,0,"f64x2_ceil",null,null,null,false],[0,0,0,"f64x2_nearest",null,null,null,false],[0,0,0,"f64x2_floor",null,null,null,false],[0,0,0,"i16x8_mul",null,null,null,false],[0,0,0,"i32x4_mul",null,null,null,false],[0,0,0,"i64x2_mul",null,null,null,false],[0,0,0,"i8x16_min_s",null,null,null,false],[0,0,0,"i16x8_min_s",null,null,null,false],[0,0,0,"i32x4_min_s",null,null,null,false],[0,0,0,"i64x2_eq",null,null,null,false],[0,0,0,"i8x16_min_u",null,null,null,false],[0,0,0,"i16x8_min_u",null,null,null,false],[0,0,0,"i32x4_min_u",null,null,null,false],[0,0,0,"i64x2_ne",null,null,null,false],[0,0,0,"i8x16_max_s",null,null,null,false],[0,0,0,"i16x8_max_s",null,null,null,false],[0,0,0,"i32x4_max_s",null,null,null,false],[0,0,0,"i64x2_lt_s",null,null,null,false],[0,0,0,"i8x16_max_u",null,null,null,false],[0,0,0,"i16x8_max_u",null,null,null,false],[0,0,0,"i32x4_max_u",null,null,null,false],[0,0,0,"i64x2_gt_s",null,null,null,false],[0,0,0,"f64x2_trunc",null,null,null,false],[0,0,0,"i32x4_dot_i16x8_s",null,null,null,false],[0,0,0,"i64x2_le_s",null,null,null,false],[0,0,0,"i8x16_avgr_u",null,null,null,false],[0,0,0,"i16x8_avgr_u",null,null,null,false],[0,0,0,"i64x2_ge_s",null,null,null,false],[0,0,0,"i16x8_extadd_pairwise_i8x16_s",null,null,null,false],[0,0,0,"i16x8_extmul_low_i8x16_s",null,null,null,false],[0,0,0,"i32x4_extmul_low_i16x8_s",null,null,null,false],[0,0,0,"i64x2_extmul_low_i32x4_s",null,null,null,false],[0,0,0,"i16x8_extadd_pairwise_i8x16_u",null,null,null,false],[0,0,0,"i16x8_extmul_high_i8x16_s",null,null,null,false],[0,0,0,"i32x4_extmul_high_i16x8_s",null,null,null,false],[0,0,0,"i64x2_extmul_high_i32x4_s",null,null,null,false],[0,0,0,"i32x4_extadd_pairwise_i16x8_s",null,null,null,false],[0,0,0,"i16x8_extmul_low_i8x16_u",null,null,null,false],[0,0,0,"i32x4_extmul_low_i16x8_u",null,null,null,false],[0,0,0,"i64x2_extmul_low_i32x4_u",null,null,null,false],[0,0,0,"i32x4_extadd_pairwise_i16x8_u",null,null,null,false],[0,0,0,"i16x8_extmul_high_i8x16_u",null,null,null,false],[0,0,0,"i32x4_extmul_high_i16x8_u",null,null,null,false],[0,0,0,"i64x2_extmul_high_i32x4_u",null,null,null,false],[0,0,0,"f32x4_abs",null,null,null,false],[0,0,0,"f64x2_abs",null,null,null,false],[0,0,0,"f32x4_neg",null,null,null,false],[0,0,0,"f64x2_neg",null,null,null,false],[0,0,0,"f32x4_sqrt",null,null,null,false],[0,0,0,"f64x2_sqrt",null,null,null,false],[0,0,0,"f32x4_add",null,null,null,false],[0,0,0,"f64x2_add",null,null,null,false],[0,0,0,"f32x4_sub",null,null,null,false],[0,0,0,"f64x2_sub",null,null,null,false],[0,0,0,"f32x4_mul",null,null,null,false],[0,0,0,"f64x2_mul",null,null,null,false],[0,0,0,"f32x4_div",null,null,null,false],[0,0,0,"f64x2_div",null,null,null,false],[0,0,0,"f32x4_min",null,null,null,false],[0,0,0,"f64x2_min",null,null,null,false],[0,0,0,"f32x4_max",null,null,null,false],[0,0,0,"f64x2_max",null,null,null,false],[0,0,0,"f32x4_pmin",null,null,null,false],[0,0,0,"f64x2_pmin",null,null,null,false],[0,0,0,"f32x4_pmax",null,null,null,false],[0,0,0,"f64x2_pmax",null,null,null,false],[0,0,0,"i32x4_trunc_sat_f32x4_s",null,null,null,false],[0,0,0,"i32x4_trunc_sat_f32x4_u",null,null,null,false],[0,0,0,"f32x4_convert_i32x4_s",null,null,null,false],[0,0,0,"f32x4_convert_i32x4_u",null,null,null,false],[0,0,0,"i32x4_trunc_sat_f64x2_s_zero",null,null,null,false],[0,0,0,"i32x4_trunc_sat_f64x2_u_zero",null,null,null,false],[0,0,0,"f64x2_convert_low_i32x4_s",null,null,null,false],[0,0,0,"f64x2_convert_low_i32x4_u",null,null,null,false],[0,0,0,"i8x16_relaxed_swizzle",null,null,null,false],[0,0,0,"i32x4_relaxed_trunc_f32x4_s",null,null,null,false],[0,0,0,"i32x4_relaxed_trunc_f32x4_u",null,null,null,false],[0,0,0,"i32x4_relaxed_trunc_f64x2_s_zero",null,null,null,false],[0,0,0,"i32x4_relaxed_trunc_f64x2_u_zero",null,null,null,false],[0,0,0,"f32x4_relaxed_madd",null,null,null,false],[0,0,0,"f32x4_relaxed_nmadd",null,null,null,false],[0,0,0,"f64x2_relaxed_madd",null,null,null,false],[0,0,0,"f64x2_relaxed_nmadd",null,null,null,false],[0,0,0,"i8x16_relaxed_laneselect",null,null,null,false],[0,0,0,"i16x8_relaxed_laneselect",null,null,null,false],[0,0,0,"i32x4_relaxed_laneselect",null,null,null,false],[0,0,0,"i64x2_relaxed_laneselect",null,null,null,false],[0,0,0,"f32x4_relaxed_min",null,null,null,false],[0,0,0,"f32x4_relaxed_max",null,null,null,false],[0,0,0,"f64x2_relaxed_min",null,null,null,false],[0,0,0,"f64x2_relaxed_max",null,null,null,false],[0,0,0,"i16x8_relaxed_q15mulr_s",null,null,null,false],[0,0,0,"i16x8_relaxed_dot_i8x16_i7x16_s",null,null,null,false],[0,0,0,"i32x4_relaxed_dot_i8x16_i7x16_add_s",null,null,null,false],[0,0,0,"f32x4_relaxed_dot_bf16x8_add_f32x4",null,null,null,false],[446,516,0,null,null," Returns the integer value of an `SimdOpcode`. Used by the Zig compiler\n to write instructions to the wasm binary file",[61941],false],[0,0,0,"op",null,"",null,false],[446,523,0,null,null," Simd opcodes that require a prefix `0xFE`.\n Each opcode represents a varuint32, meaning\n they are encoded as leb128 in binary.",[61943,61944,61945,61946,61947,61948,61949,61950,61951,61952,61953,61954,61955,61956,61957,61958,61959,61960,61961,61962,61963,61964,61965,61966,61967,61968,61969,61970,61971,61972,61973,61974,61975,61976,61977,61978,61979,61980,61981,61982,61983,61984,61985,61986,61987,61988,61989,61990,61991,61992,61993,61994,61995,61996,61997,61998,61999,62000,62001,62002,62003,62004,62005,62006,62007,62008,62009],false],[0,0,0,"memory_atomic_notify",null,null,null,false],[0,0,0,"memory_atomic_wait32",null,null,null,false],[0,0,0,"memory_atomic_wait64",null,null,null,false],[0,0,0,"atomic_fence",null,null,null,false],[0,0,0,"i32_atomic_load",null,null,null,false],[0,0,0,"i64_atomic_load",null,null,null,false],[0,0,0,"i32_atomic_load8_u",null,null,null,false],[0,0,0,"i32_atomic_load16_u",null,null,null,false],[0,0,0,"i64_atomic_load8_u",null,null,null,false],[0,0,0,"i64_atomic_load16_u",null,null,null,false],[0,0,0,"i64_atomic_load32_u",null,null,null,false],[0,0,0,"i32_atomic_store",null,null,null,false],[0,0,0,"i64_atomic_store",null,null,null,false],[0,0,0,"i32_atomic_store8",null,null,null,false],[0,0,0,"i32_atomic_store16",null,null,null,false],[0,0,0,"i64_atomic_store8",null,null,null,false],[0,0,0,"i64_atomic_store16",null,null,null,false],[0,0,0,"i64_atomic_store32",null,null,null,false],[0,0,0,"i32_atomic_rmw_add",null,null,null,false],[0,0,0,"i64_atomic_rmw_add",null,null,null,false],[0,0,0,"i32_atomic_rmw8_add_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_add_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_add_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_add_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_add_u",null,null,null,false],[0,0,0,"i32_atomic_rmw_sub",null,null,null,false],[0,0,0,"i64_atomic_rmw_sub",null,null,null,false],[0,0,0,"i32_atomic_rmw8_sub_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_sub_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_sub_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_sub_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_sub_u",null,null,null,false],[0,0,0,"i32_atomic_rmw_and",null,null,null,false],[0,0,0,"i64_atomic_rmw_and",null,null,null,false],[0,0,0,"i32_atomic_rmw8_and_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_and_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_and_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_and_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_and_u",null,null,null,false],[0,0,0,"i32_atomic_rmw_or",null,null,null,false],[0,0,0,"i64_atomic_rmw_or",null,null,null,false],[0,0,0,"i32_atomic_rmw8_or_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_or_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_or_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_or_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_or_u",null,null,null,false],[0,0,0,"i32_atomic_rmw_xor",null,null,null,false],[0,0,0,"i64_atomic_rmw_xor",null,null,null,false],[0,0,0,"i32_atomic_rmw8_xor_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_xor_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_xor_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_xor_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_xor_u",null,null,null,false],[0,0,0,"i32_atomic_rmw_xchg",null,null,null,false],[0,0,0,"i64_atomic_rmw_xchg",null,null,null,false],[0,0,0,"i32_atomic_rmw8_xchg_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_xchg_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_xchg_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_xchg_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_xchg_u",null,null,null,false],[0,0,0,"i32_atomic_rmw_cmpxchg",null,null,null,false],[0,0,0,"i64_atomic_rmw_cmpxchg",null,null,null,false],[0,0,0,"i32_atomic_rmw8_cmpxchg_u",null,null,null,false],[0,0,0,"i32_atomic_rmw16_cmpxchg_u",null,null,null,false],[0,0,0,"i64_atomic_rmw8_cmpxchg_u",null,null,null,false],[0,0,0,"i64_atomic_rmw16_cmpxchg_u",null,null,null,false],[0,0,0,"i64_atomic_rmw32_cmpxchg_u",null,null,null,false],[446,596,0,null,null," Returns the integer value of an `AtomicsOpcode`. Used by the Zig compiler\n to write instructions to the wasm binary file",[62011],false],[0,0,0,"op",null,"",null,false],[446,602,0,null,null," Enum representing all Wasm value types as per spec:\n https://webassembly.github.io/spec/core/binary/types.html",[62013,62014,62015,62016,62017],false],[0,0,0,"i32",null,null,null,false],[0,0,0,"i64",null,null,null,false],[0,0,0,"f32",null,null,null,false],[0,0,0,"f64",null,null,null,false],[0,0,0,"v128",null,null,null,false],[446,611,0,null,null," Returns the integer value of a `Valtype`",[62019],false],[0,0,0,"value",null,"",null,false],[446,617,0,null,null," Reference types, where the funcref references to a function regardless of its type\n and ref references an object from the embedder.",[62021,62022],false],[0,0,0,"funcref",null,null,null,false],[0,0,0,"externref",null,null,null,false],[446,623,0,null,null," Returns the integer value of a `Reftype`",[62024],false],[0,0,0,"value",null,"",null,false],[446,640,0,null,null," Limits classify the size range of resizeable storage associated with memory types and table types.",[62035,62036,62037],false],[446,645,0,null,null,null,[62027,62028],false],[0,0,0,"WASM_LIMITS_FLAG_HAS_MAX",null,null,null,false],[0,0,0,"WASM_LIMITS_FLAG_IS_SHARED",null,null,null,false],[446,650,0,null,null,null,[62030,62031],false],[0,0,0,"limits",null,"",null,false],[0,0,0,"flag",null,"",null,false],[446,654,0,null,null,null,[62033,62034],false],[0,0,0,"limits",null,"",null,false],[0,0,0,"flag",null,"",null,false],[0,0,0,"flags",null,null,null,false],[0,0,0,"min",null,null,null,false],[0,0,0,"max",null,null,null,false],[446,661,0,null,null," Initialization expressions are used to set the initial value on an object\n when a wasm module is being loaded.",[62039,62040,62041,62042,62043],false],[0,0,0,"i32_const",null,null,null,false],[0,0,0,"i64_const",null,null,null,false],[0,0,0,"f32_const",null,null,null,false],[0,0,0,"f64_const",null,null,null,false],[0,0,0,"global_get",null,null,null,false],[446,670,0,null,null," Represents a function entry, holding the index to its type",[62045],false],[0,0,0,"type_index",null,null,null,false],[446,676,0,null,null," Tables are used to hold pointers to opaque objects.\n This can either by any function, or an object from the host.",[62048,62050],false],[446,676,0,null,null,null,null,false],[0,0,0,"limits",null,null,null,false],[446,676,0,null,null,null,null,false],[0,0,0,"reftype",null,null,null,false],[446,685,0,null,null," Describes the layout of the memory where `min` represents\n the minimal amount of pages, and the optional `max` represents\n the max pages. When `null` will allow the host to determine the\n amount of pages.",[62053],false],[446,685,0,null,null,null,null,false],[0,0,0,"limits",null,null,null,false],[446,690,0,null,null," Represents the type of a `Global` or an imported global.",[62056,62057],false],[446,690,0,null,null,null,null,false],[0,0,0,"valtype",null,null,null,false],[0,0,0,"mutable",null,null,null,false],[446,695,0,null,null,null,[62060,62062],false],[446,695,0,null,null,null,null,false],[0,0,0,"global_type",null,null,null,false],[446,695,0,null,null,null,null,false],[0,0,0,"init",null,null,null,false],[446,702,0,null,null," Notates an object to be exported from wasm\n to the host.",[62065,62067,62068],false],[446,702,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[446,702,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[0,0,0,"index",null,null,null,false],[446,710,0,null,null," Element describes the layout of the table that can\n be found at `table_index`",[62070,62072,62074],false],[0,0,0,"table_index",null,null,null,false],[446,710,0,null,null,null,null,false],[0,0,0,"offset",null,null,null,false],[446,710,0,null,null,null,null,false],[0,0,0,"func_indexes",null,null,null,false],[446,717,0,null,null," Imports are used to import objects from the host",[62082,62084,62086],false],[446,722,0,null,null,null,[62077,62078,62079,62080],false],[0,0,0,"function",null,null,null,false],[0,0,0,"table",null,null,null,false],[0,0,0,"memory",null,null,null,false],[0,0,0,"global",null,null,null,false],[446,717,0,null,null,null,null,false],[0,0,0,"module_name",null,null,null,false],[446,717,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[446,717,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[446,732,0,null,null," `Type` represents a function signature type containing both\n a slice of parameters as well as a slice of return values.",[62100,62102],false],[446,736,0,null,null,null,[62089,62090,62091,62092],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"opt",null,"",null,false],[0,0,0,"writer",null,"",null,false],[446,759,0,null,null,null,[62094,62095],false],[0,0,0,"self",null,"",null,false],[0,0,0,"other",null,"",null,false],[446,764,0,null,null,null,[62097,62098],false],[0,0,0,"self",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[446,732,0,null,null,null,null,false],[0,0,0,"params",null,null,null,false],[446,732,0,null,null,null,null,false],[0,0,0,"returns",null,null,null,false],[446,773,0,null,null," Wasm module sections as per spec:\n https://webassembly.github.io/spec/core/binary/modules.html",[62104,62105,62106,62107,62108,62109,62110,62111,62112,62113,62114,62115,62116],false],[0,0,0,"custom",null,null,null,false],[0,0,0,"type",null,null,null,false],[0,0,0,"import",null,null,null,false],[0,0,0,"function",null,null,null,false],[0,0,0,"table",null,null,null,false],[0,0,0,"memory",null,null,null,false],[0,0,0,"global",null,null,null,false],[0,0,0,"export",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"element",null,null,null,false],[0,0,0,"code",null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"data_count",null,null,null,false],[446,791,0,null,null," Returns the integer value of a given `Section`",[62118],false],[0,0,0,"val",null,"",null,false],[446,797,0,null,null," The kind of the type when importing or exporting to/from the host environment\n https://webassembly.github.io/spec/core/syntax/modules.html",[62120,62121,62122,62123],false],[0,0,0,"function",null,null,null,false],[0,0,0,"table",null,null,null,false],[0,0,0,"memory",null,null,null,false],[0,0,0,"global",null,null,null,false],[446,805,0,null,null," Returns the integer value of a given `ExternalKind`",[62125],false],[0,0,0,"val",null,"",null,false],[446,812,0,null,null," Defines the enum values for each subsection id for the \"Names\" custom section\n as described by:\n https://webassembly.github.io/spec/core/appendix/custom.html?highlight=name#name-section",[62127,62128,62129,62130,62131,62132,62133,62134,62135,62136],false],[0,0,0,"module",null,null,null,false],[0,0,0,"function",null,null,null,false],[0,0,0,"local",null,null,null,false],[0,0,0,"label",null,null,null,false],[0,0,0,"type",null,null,null,false],[0,0,0,"table",null,null,null,false],[0,0,0,"memory",null,null,null,false],[0,0,0,"global",null,null,null,false],[0,0,0,"elem_segment",null,null,null,false],[0,0,0,"data_segment",null,null,null,false],[446,826,0,null,null,null,null,false],[446,827,0,null,null,null,null,false],[446,828,0,null,null,null,null,false],[446,831,0,null,null," Represents a block which will not return a value",null,false],[446,834,0,null,null,null,null,false],[446,835,0,null,null,null,null,false],[446,838,0,null,null,null,null,false],[1,194,0,null,null," Tokenizing and parsing of Zig code and other Zig-specific language tooling.",null,false],[0,0,0,"zig.zig",null,"",[],false],[447,0,0,null,null,null,null,false],[447,1,0,null,null,null,null,false],[0,0,0,"zig/tokenizer.zig",null,"",[],false],[448,0,0,null,null,null,null,false],[448,2,0,null,null,null,[62285,62287],false],[448,6,0,null,null,null,[62152,62153],false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[448,11,0,null,null,null,null,false],[448,63,0,null,null,null,[62156],false],[0,0,0,"bytes",null,"",null,false],[448,67,0,null,null,null,[62162,62163,62164,62165,62166,62167,62168,62169,62170,62171,62172,62173,62174,62175,62176,62177,62178,62179,62180,62181,62182,62183,62184,62185,62186,62187,62188,62189,62190,62191,62192,62193,62194,62195,62196,62197,62198,62199,62200,62201,62202,62203,62204,62205,62206,62207,62208,62209,62210,62211,62212,62213,62214,62215,62216,62217,62218,62219,62220,62221,62222,62223,62224,62225,62226,62227,62228,62229,62230,62231,62232,62233,62234,62235,62236,62237,62238,62239,62240,62241,62242,62243,62244,62245,62246,62247,62248,62249,62250,62251,62252,62253,62254,62255,62256,62257,62258,62259,62260,62261,62262,62263,62264,62265,62266,62267,62268,62269,62270,62271,62272,62273,62274,62275,62276,62277,62278,62279,62280,62281,62282,62283],false],[448,191,0,null,null,null,[62159],false],[0,0,0,"tag",null,"",null,false],[448,320,0,null,null,null,[62161],false],[0,0,0,"tag",null,"",null,false],[0,0,0,"invalid",null,null,null,false],[0,0,0,"invalid_periodasterisks",null,null,null,false],[0,0,0,"identifier",null,null,null,false],[0,0,0,"string_literal",null,null,null,false],[0,0,0,"multiline_string_literal_line",null,null,null,false],[0,0,0,"char_literal",null,null,null,false],[0,0,0,"eof",null,null,null,false],[0,0,0,"builtin",null,null,null,false],[0,0,0,"bang",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"pipe_pipe",null,null,null,false],[0,0,0,"pipe_equal",null,null,null,false],[0,0,0,"equal",null,null,null,false],[0,0,0,"equal_equal",null,null,null,false],[0,0,0,"equal_angle_bracket_right",null,null,null,false],[0,0,0,"bang_equal",null,null,null,false],[0,0,0,"l_paren",null,null,null,false],[0,0,0,"r_paren",null,null,null,false],[0,0,0,"semicolon",null,null,null,false],[0,0,0,"percent",null,null,null,false],[0,0,0,"percent_equal",null,null,null,false],[0,0,0,"l_brace",null,null,null,false],[0,0,0,"r_brace",null,null,null,false],[0,0,0,"l_bracket",null,null,null,false],[0,0,0,"r_bracket",null,null,null,false],[0,0,0,"period",null,null,null,false],[0,0,0,"period_asterisk",null,null,null,false],[0,0,0,"ellipsis2",null,null,null,false],[0,0,0,"ellipsis3",null,null,null,false],[0,0,0,"caret",null,null,null,false],[0,0,0,"caret_equal",null,null,null,false],[0,0,0,"plus",null,null,null,false],[0,0,0,"plus_plus",null,null,null,false],[0,0,0,"plus_equal",null,null,null,false],[0,0,0,"plus_percent",null,null,null,false],[0,0,0,"plus_percent_equal",null,null,null,false],[0,0,0,"plus_pipe",null,null,null,false],[0,0,0,"plus_pipe_equal",null,null,null,false],[0,0,0,"minus",null,null,null,false],[0,0,0,"minus_equal",null,null,null,false],[0,0,0,"minus_percent",null,null,null,false],[0,0,0,"minus_percent_equal",null,null,null,false],[0,0,0,"minus_pipe",null,null,null,false],[0,0,0,"minus_pipe_equal",null,null,null,false],[0,0,0,"asterisk",null,null,null,false],[0,0,0,"asterisk_equal",null,null,null,false],[0,0,0,"asterisk_asterisk",null,null,null,false],[0,0,0,"asterisk_percent",null,null,null,false],[0,0,0,"asterisk_percent_equal",null,null,null,false],[0,0,0,"asterisk_pipe",null,null,null,false],[0,0,0,"asterisk_pipe_equal",null,null,null,false],[0,0,0,"arrow",null,null,null,false],[0,0,0,"colon",null,null,null,false],[0,0,0,"slash",null,null,null,false],[0,0,0,"slash_equal",null,null,null,false],[0,0,0,"comma",null,null,null,false],[0,0,0,"ampersand",null,null,null,false],[0,0,0,"ampersand_equal",null,null,null,false],[0,0,0,"question_mark",null,null,null,false],[0,0,0,"angle_bracket_left",null,null,null,false],[0,0,0,"angle_bracket_left_equal",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_left",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_left_equal",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_left_pipe",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_left_pipe_equal",null,null,null,false],[0,0,0,"angle_bracket_right",null,null,null,false],[0,0,0,"angle_bracket_right_equal",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_right",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_right_equal",null,null,null,false],[0,0,0,"tilde",null,null,null,false],[0,0,0,"number_literal",null,null,null,false],[0,0,0,"doc_comment",null,null,null,false],[0,0,0,"container_doc_comment",null,null,null,false],[0,0,0,"keyword_addrspace",null,null,null,false],[0,0,0,"keyword_align",null,null,null,false],[0,0,0,"keyword_allowzero",null,null,null,false],[0,0,0,"keyword_and",null,null,null,false],[0,0,0,"keyword_anyframe",null,null,null,false],[0,0,0,"keyword_anytype",null,null,null,false],[0,0,0,"keyword_asm",null,null,null,false],[0,0,0,"keyword_async",null,null,null,false],[0,0,0,"keyword_await",null,null,null,false],[0,0,0,"keyword_break",null,null,null,false],[0,0,0,"keyword_callconv",null,null,null,false],[0,0,0,"keyword_catch",null,null,null,false],[0,0,0,"keyword_comptime",null,null,null,false],[0,0,0,"keyword_const",null,null,null,false],[0,0,0,"keyword_continue",null,null,null,false],[0,0,0,"keyword_defer",null,null,null,false],[0,0,0,"keyword_else",null,null,null,false],[0,0,0,"keyword_enum",null,null,null,false],[0,0,0,"keyword_errdefer",null,null,null,false],[0,0,0,"keyword_error",null,null,null,false],[0,0,0,"keyword_export",null,null,null,false],[0,0,0,"keyword_extern",null,null,null,false],[0,0,0,"keyword_fn",null,null,null,false],[0,0,0,"keyword_for",null,null,null,false],[0,0,0,"keyword_if",null,null,null,false],[0,0,0,"keyword_inline",null,null,null,false],[0,0,0,"keyword_noalias",null,null,null,false],[0,0,0,"keyword_noinline",null,null,null,false],[0,0,0,"keyword_nosuspend",null,null,null,false],[0,0,0,"keyword_opaque",null,null,null,false],[0,0,0,"keyword_or",null,null,null,false],[0,0,0,"keyword_orelse",null,null,null,false],[0,0,0,"keyword_packed",null,null,null,false],[0,0,0,"keyword_pub",null,null,null,false],[0,0,0,"keyword_resume",null,null,null,false],[0,0,0,"keyword_return",null,null,null,false],[0,0,0,"keyword_linksection",null,null,null,false],[0,0,0,"keyword_struct",null,null,null,false],[0,0,0,"keyword_suspend",null,null,null,false],[0,0,0,"keyword_switch",null,null,null,false],[0,0,0,"keyword_test",null,null,null,false],[0,0,0,"keyword_threadlocal",null,null,null,false],[0,0,0,"keyword_try",null,null,null,false],[0,0,0,"keyword_union",null,null,null,false],[0,0,0,"keyword_unreachable",null,null,null,false],[0,0,0,"keyword_usingnamespace",null,null,null,false],[0,0,0,"keyword_var",null,null,null,false],[0,0,0,"keyword_volatile",null,null,null,false],[0,0,0,"keyword_while",null,null,null,false],[448,2,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[448,2,0,null,null,null,null,false],[0,0,0,"loc",null,null,null,false],[448,336,0,null,null,null,[62354,62355,62357],false],[448,342,0,null,null," For debugging purposes",[62290,62291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"token",null,"",null,false],[448,346,0,null,null,null,[62293],false],[0,0,0,"buffer",null,"",null,false],[448,356,0,null,null,null,[62295,62296,62297,62298,62299,62300,62301,62302,62303,62304,62305,62306,62307,62308,62309,62310,62311,62312,62313,62314,62315,62316,62317,62318,62319,62320,62321,62322,62323,62324,62325,62326,62327,62328,62329,62330,62331,62332,62333,62334,62335,62336,62337,62338,62339,62340,62341,62342,62343],false],[0,0,0,"start",null,null,null,false],[0,0,0,"identifier",null,null,null,false],[0,0,0,"builtin",null,null,null,false],[0,0,0,"string_literal",null,null,null,false],[0,0,0,"string_literal_backslash",null,null,null,false],[0,0,0,"multiline_string_literal_line",null,null,null,false],[0,0,0,"char_literal",null,null,null,false],[0,0,0,"char_literal_backslash",null,null,null,false],[0,0,0,"char_literal_hex_escape",null,null,null,false],[0,0,0,"char_literal_unicode_escape_saw_u",null,null,null,false],[0,0,0,"char_literal_unicode_escape",null,null,null,false],[0,0,0,"char_literal_unicode_invalid",null,null,null,false],[0,0,0,"char_literal_unicode",null,null,null,false],[0,0,0,"char_literal_end",null,null,null,false],[0,0,0,"backslash",null,null,null,false],[0,0,0,"equal",null,null,null,false],[0,0,0,"bang",null,null,null,false],[0,0,0,"pipe",null,null,null,false],[0,0,0,"minus",null,null,null,false],[0,0,0,"minus_percent",null,null,null,false],[0,0,0,"minus_pipe",null,null,null,false],[0,0,0,"asterisk",null,null,null,false],[0,0,0,"asterisk_percent",null,null,null,false],[0,0,0,"asterisk_pipe",null,null,null,false],[0,0,0,"slash",null,null,null,false],[0,0,0,"line_comment_start",null,null,null,false],[0,0,0,"line_comment",null,null,null,false],[0,0,0,"doc_comment_start",null,null,null,false],[0,0,0,"doc_comment",null,null,null,false],[0,0,0,"int",null,null,null,false],[0,0,0,"int_exponent",null,null,null,false],[0,0,0,"int_period",null,null,null,false],[0,0,0,"float",null,null,null,false],[0,0,0,"float_exponent",null,null,null,false],[0,0,0,"ampersand",null,null,null,false],[0,0,0,"caret",null,null,null,false],[0,0,0,"percent",null,null,null,false],[0,0,0,"plus",null,null,null,false],[0,0,0,"plus_percent",null,null,null,false],[0,0,0,"plus_pipe",null,null,null,false],[0,0,0,"angle_bracket_left",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_left",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_left_pipe",null,null,null,false],[0,0,0,"angle_bracket_right",null,null,null,false],[0,0,0,"angle_bracket_angle_bracket_right",null,null,null,false],[0,0,0,"period",null,null,null,false],[0,0,0,"period_2",null,null,null,false],[0,0,0,"period_asterisk",null,null,null,false],[0,0,0,"saw_at_sign",null,null,null,false],[448,416,0,null,null," This is a workaround to the fact that the tokenizer can queue up\n 'pending_invalid_token's when parsing literals, which means that we need\n to scan from the start of the current line to find a matching tag - just\n in case it was an invalid character generated during literal\n tokenization. Ideally this processing of this would be pushed to the AST\n parser or another later stage, both to give more useful error messages\n with that extra context and in order to be able to remove this\n workaround.",[62345,62346],false],[0,0,0,"self",null,"",null,false],[0,0,0,"tag",null,"",null,false],[448,440,0,null,null,null,[62348],false],[0,0,0,"self",null,"",null,false],[448,1257,0,null,null,null,[62350],false],[0,0,0,"self",null,"",null,false],[448,1270,0,null,null,null,[62352],false],[0,0,0,"self",null,"",null,false],[448,336,0,null,null,null,null,false],[0,0,0,"buffer",null,null,null,false],[0,0,0,"index",null,null,null,false],[448,336,0,null,null,null,null,false],[0,0,0,"pending_invalid_token",null,null,null,false],[448,1919,0,null,null,null,[62359,62360],false],[0,0,0,"source",null,"",null,false],[0,0,0,"expected_token_tags",null,"",null,false],[447,2,0,null,null,null,null,false],[0,0,0,"zig/fmt.zig",null,"",[],false],[449,0,0,null,null,null,null,false],[449,1,0,null,null,null,null,false],[449,4,0,null,null," Print the string as a Zig identifier escaping it with @\"\" syntax if needed.",[62366,62367,62368,62369],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[449,20,0,null,null," Return a Formatter for a Zig identifier",[62371],false],[0,0,0,"bytes",null,"",null,false],[449,24,0,null,null,null,[62373],false],[0,0,0,"bytes",null,"",null,false],[449,49,0,null,null," Print the string as escaped contents of a double quoted or single-quoted string.\n Format `{}` treats contents as a double-quoted string.\n Format `{'}` treats contents as a single-quoted string.",[62375,62376,62377,62378],false],[0,0,0,"bytes",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[449,92,0,null,null," Return a Formatter for Zig Escapes of a double quoted string.\n The format specifier must be one of:\n  * `{}` treats contents as a double-quoted string.\n  * `{'}` treats contents as a single-quoted string.",[62380],false],[0,0,0,"bytes",null,"",null,false],[447,3,0,null,null,null,null,false],[447,5,0,null,null,null,null,false],[0,0,0,"zig/ErrorBundle.zig",null," To support incremental compilation, errors are stored in various places\n so that they can be created and destroyed appropriately. This structure\n is used to collect all the errors from the various places into one\n convenient place for API users to consume.\n\n There is one special encoding for this data structure. If both arrays are\n empty, it means there are no errors. This special encoding exists so that\n heap allocation is not needed in the common case of no errors.\n",[62537,62539],false],[450,14,0,null,null," Special encoding when there are no errors.",null,false],[450,20,0,null,null,null,[],false],[450,25,0,null,null,null,[62387],false],[0,0,0,"none",null,null,null,false],[450,31,0,null,null," There will be a MessageIndex for each len at start.",[62389,62390,62391],false],[0,0,0,"len",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"compile_log_text",null," null-terminated string index. 0 means no compile log text.",null,false],[450,40,0,null,null," Trailing:\n * ReferenceTrace for each reference_trace_len",[62393,62394,62395,62396,62397,62398,62399,62400],false],[0,0,0,"src_path",null," null terminated string index",null,false],[0,0,0,"line",null,null,null,false],[0,0,0,"column",null,null,null,false],[0,0,0,"span_start",null," byte offset of starting token",null,false],[0,0,0,"span_main",null," byte offset of main error location",null,false],[0,0,0,"span_end",null," byte offset of end of last token",null,false],[0,0,0,"source_line",null," null terminated string index, possibly null.\n Does not include the trailing newline.",null,false],[0,0,0,"reference_trace_len",null,null,null,false],[450,59,0,null,null," Trailing:\n * MessageIndex for each notes_len.",[62402,62403,62405,62406],false],[0,0,0,"msg",null," null terminated string index",null,false],[0,0,0,"count",null," Usually one, but incremented for redundant messages.",null,false],[450,59,0,null,null,null,null,false],[0,0,0,"src_loc",null,null,null,false],[0,0,0,"notes_len",null,null,null,false],[450,68,0,null,null,null,[62408,62410],false],[0,0,0,"decl_name",null," null terminated string index\n Except for the sentinel ReferenceTrace element, in which case:\n * 0 means remaining references hidden\n * >0 means N references hidden",null,false],[450,68,0,null,null,null,null,false],[0,0,0,"src_loc",null," Index into extra of a SourceLocation\n If this is 0, this is the sentinel ReferenceTrace element.",null,false],[450,79,0,null,null,null,[62412,62413],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[450,85,0,null,null,null,[62415],false],[0,0,0,"eb",null,"",null,false],[450,90,0,null,null,null,[62417],false],[0,0,0,"eb",null,"",null,false],[450,94,0,null,null,null,[62419],false],[0,0,0,"eb",null,"",null,false],[450,99,0,null,null,null,[62421,62422],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"index",null,"",null,false],[450,103,0,null,null,null,[62424,62425],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"index",null,"",null,false],[450,108,0,null,null,null,[62427,62428],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"index",null,"",null,false],[450,114,0,null,null,null,[62430],false],[0,0,0,"eb",null,"",null,false],[450,120,0,null,null," Returns the requested data, as well as the new index which is at the start of the\n trailers for the object.",[62432,62433,62434],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"T",null,"",null,true],[0,0,0,"index",null,"",[62436,62437],false],[450,120,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[0,0,0,"end",null,null,null,false],[450,140,0,null,null," Given an index into `string_bytes` returns the null-terminated string found there.",[62439,62440],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"index",null,"",null,false],[450,149,0,null,null,null,[62443,62444,62445,62446],false],[450,149,0,null,null,null,null,false],[0,0,0,"ttyconf",null,null,null,false],[0,0,0,"include_reference_trace",null,null,null,false],[0,0,0,"include_source_line",null,null,null,false],[0,0,0,"include_log_text",null,null,null,false],[450,156,0,null,null,null,[62448,62449],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"options",null,"",null,false],[450,163,0,null,null,null,[62451,62452,62453],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"writer",null,"",null,false],[450,177,0,null,null,null,[62455,62456,62457,62458,62459,62460,62461],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"options",null,"",null,false],[0,0,0,"err_msg_index",null,"",null,false],[0,0,0,"stderr",null,"",null,false],[0,0,0,"kind",null,"",null,false],[0,0,0,"color",null,"",null,false],[0,0,0,"indent",null,"",null,false],[450,294,0,null,null," Splits the error message up into lines to properly indent them\n to allow for long, good-looking error messages.\n\n This is used to split the message in `@compileError(\"hello\\nworld\")` for example.",[62463,62464,62465,62466],false],[0,0,0,"eb",null,"",null,false],[0,0,0,"err_msg",null,"",null,false],[0,0,0,"stderr",null,"",null,false],[0,0,0,"indent",null,"",null,false],[450,304,0,null,null,null,null,false],[450,305,0,null,null,null,null,false],[450,306,0,null,null,null,null,false],[450,307,0,null,null,null,null,false],[450,309,0,null,null,null,[62529,62531,62533,62535],false],[450,316,0,null,null,null,[62473,62474],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[450,334,0,null,null,null,[62476],false],[0,0,0,"wip",null,"",null,false],[450,342,0,null,null,null,[62478,62479],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"compile_log_text",null,"",null,false],[450,378,0,null,null,null,[62481],false],[0,0,0,"wip",null,"",null,false],[450,385,0,null,null,null,[62483,62484],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"s",null,"",null,false],[450,394,0,null,null,null,[62486,62487,62488],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[450,402,0,null,null,null,[62490,62491],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"em",null,"",null,false],[450,407,0,null,null,null,[62493,62494],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"em",null,"",null,false],[450,411,0,null,null,null,[62496,62497],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"em",null,"",null,false],[450,415,0,null,null,null,[62499,62500],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"sl",null,"",null,false],[450,419,0,null,null,null,[62502,62503],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"rt",null,"",null,false],[450,423,0,null,null,null,[62505,62506],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"other",null,"",null,false],[450,438,0,null,null,null,[62508,62509],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"notes_len",null,"",null,false],[450,445,0,null,null,null,[62511,62512,62513],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"other",null,"",null,false],[0,0,0,"msg_index",null,"",null,false],[450,461,0,null,null,null,[62515,62516,62517],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"other",null,"",null,false],[0,0,0,"index",null,"",null,false],[450,485,0,null,null,null,[62519,62520],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"extra",null,"",null,false],[450,492,0,null,null,null,[62522,62523],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"extra",null,"",null,false],[450,500,0,null,null,null,[62525,62526,62527],false],[0,0,0,"wip",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"extra",null,"",null,false],[450,309,0,null,null,null,null,false],[0,0,0,"gpa",null,null,null,false],[450,309,0,null,null,null,null,false],[0,0,0,"string_bytes",null,null,null,false],[450,309,0,null,null,null,null,false],[0,0,0,"extra",null," The first thing in this array is a ErrorMessageList.",null,false],[450,309,0,null,null,null,null,false],[0,0,0,"root_list",null,null,null,false],[450,0,0,null,null,null,null,false],[0,0,0,"string_bytes",null,null,null,false],[450,0,0,null,null,null,null,false],[0,0,0,"extra",null," The first thing in this array is an `ErrorMessageList`.",null,false],[447,6,0,null,null,null,null,false],[0,0,0,"zig/Server.zig",null,"",[62641,62643,62645],false],[451,4,0,null,null,null,[],false],[451,5,0,null,null,null,[62545,62546],false],[451,5,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[0,0,0,"bytes_len",null," Size of the body only; does not include this Header.",null,false],[451,11,0,null,null,null,[62548,62549,62550,62551,62552,62553],false],[0,0,0,"zig_version",null," Body is a UTF-8 string.",null,false],[0,0,0,"error_bundle",null," Body is an ErrorBundle.",null,false],[0,0,0,"progress",null," Body is a UTF-8 string.",null,false],[0,0,0,"emit_bin_path",null," Body is a EmitBinPath.",null,false],[0,0,0,"test_metadata",null," Body is a TestMetadata",null,false],[0,0,0,"test_results",null," Body is a TestResults",null,false],[451,32,0,null,null," Trailing:\n * extra: [extra_len]u32,\n * string_bytes: [string_bytes_len]u8,\n See `std.zig.ErrorBundle`.",[62555,62556],false],[0,0,0,"extra_len",null,null,null,false],[0,0,0,"string_bytes_len",null,null,null,false],[451,46,0,null,null," Trailing:\n * name: [tests_len]u32\n   - null-terminated string_bytes index\n * async_frame_len: [tests_len]u32,\n   - 0 means not async\n * expected_panic_msg: [tests_len]u32,\n   - null-terminated string_bytes index\n   - 0 means does not expect pani\n * string_bytes: [string_bytes_len]u8,",[62558,62559],false],[0,0,0,"string_bytes_len",null,null,null,false],[0,0,0,"tests_len",null,null,null,false],[451,51,0,null,null,null,[62566,62568],false],[451,55,0,null,null,null,[62562,62563,62564,62565],false],[0,0,0,"fail",null,null,null,false],[0,0,0,"skip",null,null,null,false],[0,0,0,"leak",null,null,null,false],[0,0,0,"log_err_count",null,null,null,false],[0,0,0,"index",null,null,null,false],[451,51,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[451,65,0,null,null," Trailing:\n * the file system path the emitted binary can be found",[62575],false],[451,68,0,null,null,null,[62571,62573],false],[0,0,0,"cache_hit",null,null,null,false],[451,68,0,null,null,null,null,false],[0,0,0,"reserved",null,null,null,false],[451,65,0,null,null,null,null,false],[0,0,0,"flags",null,null,null,false],[451,75,0,null,null,null,[62578,62580,62582,62584],false],[451,75,0,null,null,null,null,false],[0,0,0,"gpa",null,null,null,false],[451,75,0,null,null,null,null,false],[0,0,0,"in",null,null,null,false],[451,75,0,null,null,null,null,false],[0,0,0,"out",null,null,null,false],[451,75,0,null,null,null,null,false],[0,0,0,"zig_version",null,null,null,false],[451,82,0,null,null,null,[62586],false],[0,0,0,"options",null,"",null,false],[451,92,0,null,null,null,[62588],false],[0,0,0,"s",null,"",null,false],[451,97,0,null,null,null,[62590],false],[0,0,0,"s",null,"",null,false],[451,130,0,null,null,null,[62592],false],[0,0,0,"s",null,"",null,false],[451,138,0,null,null,null,[62594,62595,62596],false],[0,0,0,"s",null,"",null,false],[0,0,0,"tag",null,"",null,false],[0,0,0,"msg",null,"",null,false],[451,145,0,null,null,null,[62598,62599,62600],false],[0,0,0,"s",null,"",null,false],[0,0,0,"header",null,"",null,false],[0,0,0,"bufs",null,"",null,false],[451,165,0,null,null,null,[62602,62603,62604],false],[0,0,0,"s",null,"",null,false],[0,0,0,"fs_path",null,"",null,false],[0,0,0,"header",null,"",null,false],[451,179,0,null,null,null,[62606,62607],false],[0,0,0,"s",null,"",null,false],[0,0,0,"msg",null,"",null,false],[451,192,0,null,null,null,[62609,62610],false],[0,0,0,"s",null,"",null,false],[0,0,0,"error_bundle",null,"",null,false],[451,210,0,null,null,null,[62613,62615,62617,62619],false],[451,210,0,null,null,null,null,false],[0,0,0,"names",null,null,null,false],[451,210,0,null,null,null,null,false],[0,0,0,"async_frame_sizes",null,null,null,false],[451,210,0,null,null,null,null,false],[0,0,0,"expected_panic_msgs",null,null,null,false],[451,210,0,null,null,null,null,false],[0,0,0,"string_bytes",null,null,null,false],[451,217,0,null,null,null,[62621,62622],false],[0,0,0,"s",null,"",null,false],[0,0,0,"test_metadata",null,"",null,false],[451,249,0,null,null,null,[62624],false],[0,0,0,"x",null,"",null,false],[451,274,0,null,null,null,[62626],false],[0,0,0,"slice",null,"",null,false],[451,280,0,null,null," workaround for https://github.com/ziglang/zig/issues/14904",[62628],false],[0,0,0,"bytes_ptr",null,"",null,false],[451,285,0,null,null," workaround for https://github.com/ziglang/zig/issues/14904",[62630],false],[0,0,0,"bytes_ptr",null,"",null,false],[451,290,0,null,null,null,null,false],[451,291,0,null,null,null,null,false],[451,293,0,null,null,null,null,false],[451,294,0,null,null,null,null,false],[451,295,0,null,null,null,null,false],[451,296,0,null,null,null,null,false],[451,297,0,null,null,null,null,false],[451,298,0,null,null,null,null,false],[451,299,0,null,null,null,null,false],[451,0,0,null,null,null,null,false],[0,0,0,"in",null,null,null,false],[451,0,0,null,null,null,null,false],[0,0,0,"out",null,null,null,false],[451,0,0,null,null,null,null,false],[0,0,0,"receive_fifo",null,null,null,false],[447,7,0,null,null,null,null,false],[0,0,0,"zig/Client.zig",null,"",[],false],[452,0,0,null,null,null,[],false],[452,1,0,null,null,null,[62651,62652],false],[452,1,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[0,0,0,"bytes_len",null," Size of the body only; does not include this Header.",null,false],[452,7,0,null,null,null,[62654,62655,62656,62657,62658,62659],false],[0,0,0,"exit",null," Tells the compiler to shut down cleanly.\n No body.",null,false],[0,0,0,"update",null," Tells the compiler to detect changes in source files and update the\n affected output compilation artifacts.\n If one of the compilation artifacts is an executable that is\n running as a child process, the compiler will wait for it to exit\n before performing the update.\n No body.",null,false],[0,0,0,"run",null," Tells the compiler to execute the executable as a child process.\n No body.",null,false],[0,0,0,"hot_update",null," Tells the compiler to detect changes in source files and update the\n affected output compilation artifacts.\n If one of the compilation artifacts is an executable that is\n running as a child process, the compiler will perform a hot code\n swap.\n No body.",null,false],[0,0,0,"query_test_metadata",null," Ask the test runner for metadata about all the unit tests that can\n be run. Server will respond with a `test_metadata` message.\n No body.",null,false],[0,0,0,"run_test",null," Ask the test runner to run a particular test.\n The message body is a u32 test index.",null,false],[447,8,0,null,null,null,null,false],[447,9,0,null,null,null,null,false],[447,10,0,null,null,null,null,false],[447,11,0,null,null,null,null,false],[447,12,0,null,null,null,null,false],[447,13,0,null,null,null,null,false],[0,0,0,"zig/string_literal.zig",null,"",[],false],[453,0,0,null,null,null,null,false],[453,1,0,null,null,null,null,false],[453,2,0,null,null,null,null,false],[453,3,0,null,null,null,null,false],[453,5,0,null,null,null,null,false],[453,10,0,null,null,null,[62673,62674],false],[0,0,0,"success",null,null,null,false],[0,0,0,"failure",null,null,null,false],[453,15,0,null,null,null,[62676,62677],false],[0,0,0,"success",null,null,null,false],[0,0,0,"failure",null,null,null,false],[453,20,0,null,null,null,[62679,62680,62681,62682,62683,62684,62685,62686,62687],false],[0,0,0,"invalid_escape_character",null," The character after backslash is missing or not recognized.",null,false],[0,0,0,"expected_hex_digit",null," Expected hex digit at this index.",null,false],[0,0,0,"empty_unicode_escape_sequence",null," Unicode escape sequence had no digits with rbrace at this index.",null,false],[0,0,0,"expected_hex_digit_or_rbrace",null," Expected hex digit or '}' at this index.",null,false],[0,0,0,"invalid_unicode_codepoint",null," Invalid unicode codepoint at this index.",null,false],[0,0,0,"expected_lbrace",null," Expected '{' at this index.",null,false],[0,0,0,"expected_rbrace",null," Expected '}' at this index.",null,false],[0,0,0,"expected_single_quote",null," Expected '\\'' at this index.",null,false],[0,0,0,"invalid_character",null," The character at this index cannot be represented without an escape sequence.",null,false],[453,43,0,null,null," Only validates escape sequence characters.\n Slice must be valid utf8 starting and ending with \"'\" and exactly one codepoint in between.",[62689],false],[0,0,0,"slice",null,"",null,false],[453,65,0,null,null," Parse an escape sequence from `slice[offset..]`. If parsing is successful,\n offset is updated to reflect the characters consumed.",[62691,62692],false],[0,0,0,"slice",null,"",null,false],[0,0,0,"offset",null,"",null,false],[453,235,0,null,null," Parses `bytes` as a Zig string literal and writes the result to the std.io.Writer type.\n Asserts `bytes` has '\"' at beginning and end.",[62694,62695],false],[0,0,0,"writer",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[453,273,0,null,null," Higher level API. Does not return extra info about parse errors.\n Caller owns returned memory.",[62697,62698],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"bytes",null,"",null,false],[447,14,0,null,null,null,null,false],[0,0,0,"zig/number_literal.zig",null,"",[],false],[454,0,0,null,null,null,null,false],[454,1,0,null,null,null,null,false],[454,2,0,null,null,null,null,false],[454,3,0,null,null,null,null,false],[454,5,0,null,null,null,null,false],[454,10,0,null,null,null,[62707,62708,62709,62710],false],[0,0,0,"decimal",null,null,null,false],[0,0,0,"hex",null,null,null,false],[0,0,0,"binary",null,null,null,false],[0,0,0,"octal",null,null,null,false],[454,11,0,null,null,null,[62712,62713],false],[0,0,0,"decimal",null,null,null,false],[0,0,0,"hex",null,null,null,false],[454,13,0,null,null,null,[62715,62716,62717,62718],false],[0,0,0,"int",null," Result fits if it fits in u64",null,false],[0,0,0,"big_int",null," Result is an int that doesn't fit in u64. Payload is the base, if it is\n not `.decimal` then the slice has a two character prefix.",null,false],[0,0,0,"float",null," Result is a float. Payload is the base, if it is not `.decimal` then\n the slice has a two character prefix.",null,false],[0,0,0,"failure",null,null,null,false],[454,25,0,null,null,null,[62720,62721,62722,62723,62724,62725,62729,62730,62731,62732,62733,62734,62735,62736,62737,62738],false],[0,0,0,"leading_zero",null," The number has leading zeroes.",null,false],[0,0,0,"digit_after_base",null," Expected a digit after base prefix.",null,false],[0,0,0,"upper_case_base",null," The base prefix is in uppercase.",null,false],[0,0,0,"invalid_float_base",null," Float literal has an invalid base prefix.",null,false],[0,0,0,"repeated_underscore",null," Repeated '_' digit separator.",null,false],[0,0,0,"invalid_underscore_after_special",null," '_' digit separator after special character (+-.)",[62726,62728],false],[0,0,0,"i",null,null,null,false],[454,39,0,null,null,null,null,false],[0,0,0,"base",null,null,null,false],[0,0,0,"invalid_digit",null," Invalid digit for the specified base.",null,false],[0,0,0,"invalid_digit_exponent",null," Invalid digit for an exponent.",null,false],[0,0,0,"duplicate_period",null," Float literal has multiple periods.",null,false],[0,0,0,"duplicate_exponent",null," Float literal has multiple exponents.",null,false],[0,0,0,"exponent_after_underscore",null," Exponent comes directly after '_' digit separator.",null,false],[0,0,0,"special_after_underscore",null," Special character (+-.) comes directly after exponent.",null,false],[0,0,0,"trailing_special",null," Number ends in special character (+-.)",null,false],[0,0,0,"trailing_underscore",null," Number ends in '_' digit separator.",null,false],[0,0,0,"invalid_character",null," Character not in [0-9a-zA-Z.+-_]",null,false],[0,0,0,"invalid_exponent_sign",null," [+-] not immediately after [pPeE]",null,false],[454,62,0,null,null," Parse Zig number literal accepted by fmt.parseInt, fmt.parseFloat and big_int.setString.\n Valid for any input.",[62740],false],[0,0,0,"bytes",null,"",null,false],[447,15,0,null,null,null,null,false],[0,0,0,"zig/primitives.zig",null,"",[],false],[455,0,0,null,null,null,null,false],[455,4,0,null,null," Set of primitive type and value names.\n Does not include `_` or integer type names.",null,false],[455,41,0,null,null," Returns true if a name matches a primitive type or value, excluding `_`.\n Integer type names like `u8` or `i32` are only matched for syntax,\n so this will still return true when they have an oversized bit count\n or leading zeroes.",[62746],false],[0,0,0,"name",null,"",null,false],[447,16,0,null,null,null,null,false],[0,0,0,"zig/Ast.zig",null," Abstract Syntax Tree for Zig source code.\n For Zig syntax, the root node is at nodes[0] and contains the list of\n sub-nodes.\n For Zon syntax, the root node is at nodes[0] and contains lhs as the node\n index of the main expression.\n",[64020,64022,64024,64026,64028],false],[456,17,0,null,null,null,null,false],[456,18,0,null,null,null,null,false],[456,20,0,null,null,null,null,false],[456,24,0,null,null,null,null,false],[456,26,0,null,null,null,[62754,62755,62756,62757],false],[0,0,0,"line",null,null,null,false],[0,0,0,"column",null,null,null,false],[0,0,0,"line_start",null,null,null,false],[0,0,0,"line_end",null,null,null,false],[456,33,0,null,null,null,[62759,62760],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[456,41,0,null,null,null,null,false],[456,47,0,null,null,null,[62763,62764],false],[0,0,0,"zig",null,null,null,false],[0,0,0,"zon",null,null,null,false],[456,51,0,null,null," Result should be freed with tree.deinit() when there are\n no more references to any of the tokens or nodes.",[62766,62767,62768],false],[0,0,0,"gpa",null,"",null,false],[0,0,0,"source",null,"",null,false],[0,0,0,"mode",null,"",null,false],[456,109,0,null,null," `gpa` is used for allocating the resulting formatted source code, as well as\n for allocating extra stack memory if needed, because this function utilizes recursion.\n Note: that's not actually true yet, see https://github.com/ziglang/zig/issues/1006.\n Caller owns the returned slice of bytes, allocated with `gpa`.",[62770,62771],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"gpa",null,"",null,false],[456,117,0,null,null,null,[62773,62774],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[456,123,0,null,null," Returns an extra offset for column and byte offset of errors that\n should point after the token in the error message.",[62776,62777],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"parse_error",null,"",null,false],[456,130,0,null,null,null,[62779,62780,62781],false],[0,0,0,"self",null,"",null,false],[0,0,0,"start_offset",null,"",null,false],[0,0,0,"token_index",null,"",null,false],[456,157,0,null,null,null,[62783,62784],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"token_index",null,"",null,false],[456,178,0,null,null,null,[62786,62787,62788],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"index",null,"",null,false],[0,0,0,"T",null,"",null,true],[456,188,0,null,null,null,[62790],false],[0,0,0,"tree",null,"",null,false],[456,194,0,null,null,null,[62792,62793,62794],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"parse_error",null,"",null,false],[0,0,0,"stream",null,"",null,false],[456,455,0,null,null,null,[62796,62797],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,777,0,null,null,null,[62799,62800],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1320,0,null,null,null,[62802,62803,62804],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"token1",null,"",null,false],[0,0,0,"token2",null,"",null,false],[456,1326,0,null,null,null,[62806,62807],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1335,0,null,null,null,[62809,62810],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1349,0,null,null,null,[62812,62813],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1363,0,null,null,null,[62815,62816],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1376,0,null,null,null,[62818,62819],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1389,0,null,null,null,[62821,62822],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1400,0,null,null,null,[62824,62825],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1412,0,null,null,null,[62827,62828],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1427,0,null,null,null,[62830,62831],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1441,0,null,null,null,[62833,62834],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1455,0,null,null,null,[62836,62837,62838],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1472,0,null,null,null,[62840,62841],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1489,0,null,null,null,[62843,62844,62845],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1507,0,null,null,null,[62847,62848],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1524,0,null,null,null,[62850,62851,62852],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1539,0,null,null,null,[62854,62855,62856],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1559,0,null,null,null,[62858,62859],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1572,0,null,null,null,[62861,62862],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1586,0,null,null,null,[62864,62865,62866],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1601,0,null,null,null,[62868,62869,62870],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1621,0,null,null,null,[62872,62873],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1634,0,null,null,null,[62875,62876],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1648,0,null,null,null,[62878,62879],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1661,0,null,null,null,[62881,62882],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1676,0,null,null,null,[62884,62885],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1690,0,null,null,null,[62887,62888],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1704,0,null,null,null,[62890,62891],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1719,0,null,null,null,[62893,62894],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1734,0,null,null,null,[62896,62897],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1748,0,null,null,null,[62899,62900],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1763,0,null,null,null,[62902,62903],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1778,0,null,null,null,[62905,62906,62907],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1797,0,null,null,null,[62909,62910],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1809,0,null,null,null,[62912,62913],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1822,0,null,null,null,[62915],false],[0,0,0,"tree",null,"",null,false],[456,1834,0,null,null,null,[62917,62918,62919],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1854,0,null,null,null,[62921,62922],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1867,0,null,null,null,[62924,62925],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1881,0,null,null,null,[62927,62928],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1891,0,null,null,null,[62930,62931],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1901,0,null,null,null,[62933,62934],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1911,0,null,null,null,[62936,62937],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1922,0,null,null,null,[62939,62940],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1933,0,null,null,null,[62942,62943],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1945,0,null,null,null,[62945,62946],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1957,0,null,null,null,[62948,62949],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1968,0,null,null,null,[62951,62952],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1982,0,null,null,null,[62954,62955,62956],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,1993,0,null,null,null,[62958,62959],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2003,0,null,null,null,[62961,62962],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2028,0,null,null,null,[62964,62965],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2053,0,null,null,null,[62967,62968],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2071,0,null,null,null,[62970,62971],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2107,0,null,null,null,[62973,62974],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2154,0,null,null,null,[62976,62977],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2170,0,null,null,null,[62979,62980,62981],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2188,0,null,null,null,[62983,62984],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2251,0,null,null,null,[62986,62987],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2286,0,null,null,null,[62989,62990],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2313,0,null,null,null,[62992,62993],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"info",null,"",null,false],[456,2326,0,null,null,null,[62995,62996],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2336,0,null,null,null,[62998,62999],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2344,0,null,null,null,[63001,63002],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2353,0,null,null,null,[63004,63005],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2361,0,null,null,null,[63007,63008],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2370,0,null,null,null,[63010,63011,63012],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2381,0,null,null,null,[63014,63015,63016],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2391,0,null,null,null,[63018,63019,63020],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2401,0,null,null,null,[63022,63023],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2409,0,null,null,null,[63025,63026],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2419,0,null,null,null,[63028,63029],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2428,0,null,null,null,[63031,63032,63033],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2441,0,null,null,null,[63035,63036],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2449,0,null,null,null,[63038,63039],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2457,0,null,null,null,[63041,63042,63043],false],[0,0,0,"tree",null,"",null,false],[0,0,0,"buffer",null,"",null,false],[0,0,0,"node",null,"",null,false],[456,2466,0,null,null," Fully assembled AST node information.",[],false],[456,2467,0,null,null,null,[63062,63064,63066,63068,63070,63072],false],[456,2475,0,null,null,null,[63048,63050,63052,63054,63056,63058],false],[456,2475,0,null,null,null,null,false],[0,0,0,"mut_token",null,null,null,false],[456,2475,0,null,null,null,null,false],[0,0,0,"type_node",null,null,null,false],[456,2475,0,null,null,null,null,false],[0,0,0,"align_node",null,null,null,false],[456,2475,0,null,null,null,null,false],[0,0,0,"addrspace_node",null,null,null,false],[456,2475,0,null,null,null,null,false],[0,0,0,"section_node",null,null,null,false],[456,2475,0,null,null,null,null,false],[0,0,0,"init_node",null,null,null,false],[456,2484,0,null,null,null,[63060],false],[0,0,0,"var_decl",null,"",null,false],[456,2467,0,null,null,null,null,false],[0,0,0,"visib_token",null,null,null,false],[456,2467,0,null,null,null,null,false],[0,0,0,"extern_export_token",null,null,null,false],[456,2467,0,null,null,null,null,false],[0,0,0,"lib_name",null,null,null,false],[456,2467,0,null,null,null,null,false],[0,0,0,"threadlocal_token",null,null,null,false],[456,2467,0,null,null,null,null,false],[0,0,0,"comptime_token",null,null,null,false],[456,2467,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2493,0,null,null,null,[63084,63086,63088,63090],false],[456,2503,0,null,null,null,[63076,63078,63080,63082],false],[456,2503,0,null,null,null,null,false],[0,0,0,"if_token",null,null,null,false],[456,2503,0,null,null,null,null,false],[0,0,0,"cond_expr",null,null,null,false],[456,2503,0,null,null,null,null,false],[0,0,0,"then_expr",null,null,null,false],[456,2503,0,null,null,null,null,false],[0,0,0,"else_expr",null,null,null,false],[456,2493,0,null,null,null,null,false],[0,0,0,"payload_token",null," Points to the first token after the `|`. Will either be an identifier or\n a `*` (with an identifier immediately after it).",null,false],[456,2493,0,null,null,null,null,false],[0,0,0,"error_token",null," Points to the identifier after the `|`.",null,false],[456,2493,0,null,null,null,null,false],[0,0,0,"else_token",null," Populated only if else_expr != 0.",null,false],[456,2493,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2511,0,null,null,null,[63104,63106,63108,63110,63112,63114],false],[456,2520,0,null,null,null,[63094,63096,63098,63100,63102],false],[456,2520,0,null,null,null,null,false],[0,0,0,"while_token",null,null,null,false],[456,2520,0,null,null,null,null,false],[0,0,0,"cond_expr",null,null,null,false],[456,2520,0,null,null,null,null,false],[0,0,0,"cont_expr",null,null,null,false],[456,2520,0,null,null,null,null,false],[0,0,0,"then_expr",null,null,null,false],[456,2520,0,null,null,null,null,false],[0,0,0,"else_expr",null,null,null,false],[456,2511,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2511,0,null,null,null,null,false],[0,0,0,"inline_token",null,null,null,false],[456,2511,0,null,null,null,null,false],[0,0,0,"label_token",null,null,null,false],[456,2511,0,null,null,null,null,false],[0,0,0,"payload_token",null,null,null,false],[456,2511,0,null,null,null,null,false],[0,0,0,"error_token",null,null,null,false],[456,2511,0,null,null,null,null,false],[0,0,0,"else_token",null," Populated only if else_expr != 0.",null,false],[456,2529,0,null,null,null,[63129,63131,63133,63135,63137],false],[456,2537,0,null,null,null,[63118,63120,63122,63124],false],[456,2537,0,null,null,null,null,false],[0,0,0,"for_token",null,null,null,false],[456,2537,0,null,null,null,null,false],[0,0,0,"inputs",null,null,null,false],[456,2537,0,null,null,null,null,false],[0,0,0,"then_expr",null,null,null,false],[456,2537,0,null,null,null,null,false],[0,0,0,"else_expr",null,null,null,false],[456,2545,0,null,null," TODO: remove this after zig 0.11.0 is tagged.",[63126,63127],false],[0,0,0,"f",null,"",null,false],[0,0,0,"token_tags",null,"",null,false],[456,2529,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2529,0,null,null,null,null,false],[0,0,0,"inline_token",null,null,null,false],[456,2529,0,null,null,null,null,false],[0,0,0,"label_token",null,null,null,false],[456,2529,0,null,null,null,null,false],[0,0,0,"payload_token",null,null,null,false],[456,2529,0,null,null,null,null,false],[0,0,0,"else_token",null," Populated only if else_expr != 0.",null,false],[456,2557,0,null,null,null,[63155,63157],false],[456,2561,0,null,null,null,[63141,63143,63145,63147,63148],false],[456,2561,0,null,null,null,null,false],[0,0,0,"main_token",null,null,null,false],[456,2561,0,null,null,null,null,false],[0,0,0,"type_expr",null,null,null,false],[456,2561,0,null,null,null,null,false],[0,0,0,"value_expr",null,null,null,false],[456,2561,0,null,null,null,null,false],[0,0,0,"align_expr",null,null,null,false],[0,0,0,"tuple_like",null,null,null,false],[456,2569,0,null,null,null,[63150],false],[0,0,0,"cf",null,"",null,false],[456,2573,0,null,null,null,[63152,63153],false],[0,0,0,"cf",null,"",null,false],[0,0,0,"nodes",null,"",null,false],[456,2557,0,null,null,null,null,false],[0,0,0,"comptime_token",null,null,null,false],[456,2557,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2585,0,null,null,null,[63204,63206,63208,63210,63212,63214],false],[456,2593,0,null,null,null,[63161,63163,63165,63167,63169,63171,63173,63175],false],[456,2593,0,null,null,null,null,false],[0,0,0,"proto_node",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"fn_token",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"return_type",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"params",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"align_expr",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"addrspace_expr",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"section_expr",null,null,null,false],[456,2593,0,null,null,null,null,false],[0,0,0,"callconv_expr",null,null,null,false],[456,2604,0,null,null,null,[63178,63180,63182,63184,63186],false],[456,2604,0,null,null,null,null,false],[0,0,0,"first_doc_comment",null,null,null,false],[456,2604,0,null,null,null,null,false],[0,0,0,"name_token",null,null,null,false],[456,2604,0,null,null,null,null,false],[0,0,0,"comptime_noalias",null,null,null,false],[456,2604,0,null,null,null,null,false],[0,0,0,"anytype_ellipsis3",null,null,null,false],[456,2604,0,null,null,null,null,false],[0,0,0,"type_expr",null,null,null,false],[456,2612,0,null,null,null,[63188],false],[0,0,0,"fn_proto",null,"",null,false],[456,2621,0,null,null," Abstracts over the fact that anytype and ... are not included\n in the params slice, since they are simple identifiers and\n not sub-expressions.",[63193,63195,63196,63198,63199],false],[456,2628,0,null,null,null,[63191],false],[0,0,0,"it",null,"",null,false],[456,2621,0,null,null,null,null,false],[0,0,0,"tree",null,null,null,false],[456,2621,0,null,null,null,null,false],[0,0,0,"fn_proto",null,null,null,false],[0,0,0,"param_i",null,null,null,false],[456,2621,0,null,null,null,null,false],[0,0,0,"tok_i",null,null,null,false],[0,0,0,"tok_flag",null,null,null,false],[456,2712,0,null,null,null,[63201,63202],false],[0,0,0,"fn_proto",null,"",null,false],[0,0,0,"tree",null,"",null,false],[456,2585,0,null,null,null,null,false],[0,0,0,"visib_token",null,null,null,false],[456,2585,0,null,null,null,null,false],[0,0,0,"extern_export_inline_token",null,null,null,false],[456,2585,0,null,null,null,null,false],[0,0,0,"lib_name",null,null,null,false],[456,2585,0,null,null,null,null,false],[0,0,0,"name_token",null,null,null,false],[456,2585,0,null,null,null,null,false],[0,0,0,"lparen",null,null,null,false],[456,2585,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2723,0,null,null,null,[63224],false],[456,2726,0,null,null,null,[63218,63220,63222],false],[456,2726,0,null,null,null,null,false],[0,0,0,"lbrace",null,null,null,false],[456,2726,0,null,null,null,null,false],[0,0,0,"fields",null,null,null,false],[456,2726,0,null,null,null,null,false],[0,0,0,"type_expr",null,null,null,false],[456,2723,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2733,0,null,null,null,[63234],false],[456,2736,0,null,null,null,[63228,63230,63232],false],[456,2736,0,null,null,null,null,false],[0,0,0,"lbrace",null,null,null,false],[456,2736,0,null,null,null,null,false],[0,0,0,"elements",null,null,null,false],[456,2736,0,null,null,null,null,false],[0,0,0,"type_expr",null,null,null,false],[456,2733,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2743,0,null,null,null,[63246],false],[456,2746,0,null,null,null,[63238,63240,63242,63244],false],[456,2746,0,null,null,null,null,false],[0,0,0,"lbracket",null,null,null,false],[456,2746,0,null,null,null,null,false],[0,0,0,"elem_count",null,null,null,false],[456,2746,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,2746,0,null,null,null,null,false],[0,0,0,"elem_type",null,null,null,false],[456,2743,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2754,0,null,null,null,[63264,63266,63268,63270,63272],false],[456,2761,0,null,null,null,[63250,63252,63254,63256,63258,63260,63262],false],[456,2761,0,null,null,null,null,false],[0,0,0,"main_token",null,null,null,false],[456,2761,0,null,null,null,null,false],[0,0,0,"align_node",null,null,null,false],[456,2761,0,null,null,null,null,false],[0,0,0,"addrspace_node",null,null,null,false],[456,2761,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,2761,0,null,null,null,null,false],[0,0,0,"bit_range_start",null,null,null,false],[456,2761,0,null,null,null,null,false],[0,0,0,"bit_range_end",null,null,null,false],[456,2761,0,null,null,null,null,false],[0,0,0,"child_type",null,null,null,false],[456,2754,0,null,null,null,null,false],[0,0,0,"size",null,null,null,false],[456,2754,0,null,null,null,null,false],[0,0,0,"allowzero_token",null,null,null,false],[456,2754,0,null,null,null,null,false],[0,0,0,"const_token",null,null,null,false],[456,2754,0,null,null,null,null,false],[0,0,0,"volatile_token",null,null,null,false],[456,2754,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2772,0,null,null,null,[63286],false],[456,2775,0,null,null,null,[63276,63278,63280,63282,63284],false],[456,2775,0,null,null,null,null,false],[0,0,0,"sliced",null,null,null,false],[456,2775,0,null,null,null,null,false],[0,0,0,"lbracket",null,null,null,false],[456,2775,0,null,null,null,null,false],[0,0,0,"start",null,null,null,false],[456,2775,0,null,null,null,null,false],[0,0,0,"end",null,null,null,false],[456,2775,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,2772,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2784,0,null,null,null,[63298,63300],false],[456,2788,0,null,null,null,[63290,63292,63294,63296],false],[456,2788,0,null,null,null,null,false],[0,0,0,"main_token",null,null,null,false],[456,2788,0,null,null,null,null,false],[0,0,0,"enum_token",null," Populated when main_token is Keyword_union.",null,false],[456,2788,0,null,null,null,null,false],[0,0,0,"members",null,null,null,false],[456,2788,0,null,null,null,null,false],[0,0,0,"arg",null,null,null,false],[456,2784,0,null,null,null,null,false],[0,0,0,"layout_token",null,null,null,false],[456,2784,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2797,0,null,null,null,[63310,63312,63314],false],[456,2804,0,null,null,null,[63304,63306,63308],false],[456,2804,0,null,null,null,null,false],[0,0,0,"values",null," If empty, this is an else case",null,false],[456,2804,0,null,null,null,null,false],[0,0,0,"arrow_token",null,null,null,false],[456,2804,0,null,null,null,null,false],[0,0,0,"target_expr",null,null,null,false],[456,2797,0,null,null,null,null,false],[0,0,0,"inline_token",null,null,null,false],[456,2797,0,null,null,null,null,false],[0,0,0,"payload_token",null," Points to the first token after the `|`. Will either be an identifier or\n a `*` (with an identifier immediately after it).",null,false],[456,2797,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2812,0,null,null,null,[63326,63328,63330,63332,63334],false],[456,2819,0,null,null,null,[63318,63320,63322,63324],false],[456,2819,0,null,null,null,null,false],[0,0,0,"asm_token",null,null,null,false],[456,2819,0,null,null,null,null,false],[0,0,0,"template",null,null,null,false],[456,2819,0,null,null,null,null,false],[0,0,0,"items",null,null,null,false],[456,2819,0,null,null,null,null,false],[0,0,0,"rparen",null,null,null,false],[456,2812,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2812,0,null,null,null,null,false],[0,0,0,"volatile_token",null,null,null,false],[456,2812,0,null,null,null,null,false],[0,0,0,"first_clobber",null,null,null,false],[456,2812,0,null,null,null,null,false],[0,0,0,"outputs",null,null,null,false],[456,2812,0,null,null,null,null,false],[0,0,0,"inputs",null,null,null,false],[456,2827,0,null,null,null,[63344,63346],false],[456,2831,0,null,null,null,[63338,63340,63342],false],[456,2831,0,null,null,null,null,false],[0,0,0,"lparen",null,null,null,false],[456,2831,0,null,null,null,null,false],[0,0,0,"fn_expr",null,null,null,false],[456,2831,0,null,null,null,null,false],[0,0,0,"params",null,null,null,false],[456,2827,0,null,null,null,null,false],[0,0,0,"ast",null,null,null,false],[456,2827,0,null,null,null,null,false],[0,0,0,"async_token",null,null,null,false],[456,2839,0,null,null,null,[63414,63415,63416,63418,63422],false],[456,2850,0,null,null,null,[63349,63350,63351,63352,63353,63354,63355,63356,63357,63358,63359,63360,63361,63362,63363,63364,63365,63366,63367,63368,63369,63370,63371,63372,63373,63374,63375,63376,63377,63378,63379,63380,63381,63382,63383,63384,63385,63386,63387,63388,63389,63390,63391,63392,63393,63394,63395,63396,63397,63398,63399,63400,63401,63402,63403,63404,63405,63406,63407,63408,63409,63410,63411,63412],false],[0,0,0,"asterisk_after_ptr_deref",null,null,null,false],[0,0,0,"chained_comparison_operators",null,null,null,false],[0,0,0,"decl_between_fields",null,null,null,false],[0,0,0,"expected_block",null,null,null,false],[0,0,0,"expected_block_or_assignment",null,null,null,false],[0,0,0,"expected_block_or_expr",null,null,null,false],[0,0,0,"expected_block_or_field",null,null,null,false],[0,0,0,"expected_container_members",null,null,null,false],[0,0,0,"expected_expr",null,null,null,false],[0,0,0,"expected_expr_or_assignment",null,null,null,false],[0,0,0,"expected_expr_or_var_decl",null,null,null,false],[0,0,0,"expected_fn",null,null,null,false],[0,0,0,"expected_inlinable",null,null,null,false],[0,0,0,"expected_labelable",null,null,null,false],[0,0,0,"expected_param_list",null,null,null,false],[0,0,0,"expected_prefix_expr",null,null,null,false],[0,0,0,"expected_primary_type_expr",null,null,null,false],[0,0,0,"expected_pub_item",null,null,null,false],[0,0,0,"expected_return_type",null,null,null,false],[0,0,0,"expected_semi_or_else",null,null,null,false],[0,0,0,"expected_semi_or_lbrace",null,null,null,false],[0,0,0,"expected_statement",null,null,null,false],[0,0,0,"expected_suffix_op",null,null,null,false],[0,0,0,"expected_type_expr",null,null,null,false],[0,0,0,"expected_var_decl",null,null,null,false],[0,0,0,"expected_var_decl_or_fn",null,null,null,false],[0,0,0,"expected_loop_payload",null,null,null,false],[0,0,0,"expected_container",null,null,null,false],[0,0,0,"extern_fn_body",null,null,null,false],[0,0,0,"extra_addrspace_qualifier",null,null,null,false],[0,0,0,"extra_align_qualifier",null,null,null,false],[0,0,0,"extra_allowzero_qualifier",null,null,null,false],[0,0,0,"extra_const_qualifier",null,null,null,false],[0,0,0,"extra_volatile_qualifier",null,null,null,false],[0,0,0,"ptr_mod_on_array_child_type",null,null,null,false],[0,0,0,"invalid_bit_range",null,null,null,false],[0,0,0,"same_line_doc_comment",null,null,null,false],[0,0,0,"unattached_doc_comment",null,null,null,false],[0,0,0,"test_doc_comment",null,null,null,false],[0,0,0,"comptime_doc_comment",null,null,null,false],[0,0,0,"varargs_nonfinal",null,null,null,false],[0,0,0,"expected_continue_expr",null,null,null,false],[0,0,0,"expected_semi_after_decl",null,null,null,false],[0,0,0,"expected_semi_after_stmt",null,null,null,false],[0,0,0,"expected_comma_after_field",null,null,null,false],[0,0,0,"expected_comma_after_arg",null,null,null,false],[0,0,0,"expected_comma_after_param",null,null,null,false],[0,0,0,"expected_comma_after_initializer",null,null,null,false],[0,0,0,"expected_comma_after_switch_prong",null,null,null,false],[0,0,0,"expected_comma_after_for_operand",null,null,null,false],[0,0,0,"expected_comma_after_capture",null,null,null,false],[0,0,0,"expected_initializer",null,null,null,false],[0,0,0,"mismatched_binary_op_whitespace",null,null,null,false],[0,0,0,"invalid_ampersand_ampersand",null,null,null,false],[0,0,0,"c_style_container",null,null,null,false],[0,0,0,"expected_var_const",null,null,null,false],[0,0,0,"wrong_equal_var_decl",null,null,null,false],[0,0,0,"var_const_decl",null,null,null,false],[0,0,0,"extra_for_capture",null,null,null,false],[0,0,0,"for_input_not_captured",null,null,null,false],[0,0,0,"zig_style_container",null,null,null,false],[0,0,0,"previous_field",null,null,null,false],[0,0,0,"next_field",null,null,null,false],[0,0,0,"expected_token",null," `expected_tag` is populated.",null,false],[456,2839,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[0,0,0,"is_note",null,null,null,false],[0,0,0,"token_is_prev",null," True if `token` points to the token before the token causing an issue.",null,false],[456,2839,0,null,null,null,null,false],[0,0,0,"token",null,null,null,false],[456,2839,0,null,null,null,[63420,63421],false],[0,0,0,"none",null,null,null,false],[0,0,0,"expected_tag",null,null,null,false],[0,0,0,"extra",null,null,null,false],[456,2921,0,null,null,null,[63715,63717,63719],false],[456,2926,0,null,null,null,null,false],[456,2935,0,null,null," Note: The FooComma/FooSemicolon variants exist to ease the implementation of\n Ast.lastToken()",[63428,63429,63430,63431,63432,63433,63434,63435,63436,63437,63438,63439,63440,63441,63442,63443,63444,63445,63446,63447,63448,63449,63450,63451,63452,63453,63454,63455,63456,63457,63458,63459,63460,63461,63462,63463,63464,63465,63466,63467,63468,63469,63470,63471,63472,63473,63474,63475,63476,63477,63478,63479,63480,63481,63482,63483,63484,63485,63486,63487,63488,63489,63490,63491,63492,63493,63494,63495,63496,63497,63498,63499,63500,63501,63502,63503,63504,63505,63506,63507,63508,63509,63510,63511,63512,63513,63514,63515,63516,63517,63518,63519,63520,63521,63522,63523,63524,63525,63526,63527,63528,63529,63530,63531,63532,63533,63534,63535,63536,63537,63538,63539,63540,63541,63542,63543,63544,63545,63546,63547,63548,63549,63550,63551,63552,63553,63554,63555,63556,63557,63558,63559,63560,63561,63562,63563,63564,63565,63566,63567,63568,63569,63570,63571,63572,63573,63574,63575,63576,63577,63578,63579,63580,63581,63582,63583,63584,63585,63586,63587,63588,63589,63590,63591,63592,63593,63594,63595,63596,63597],false],[456,3402,0,null,null,null,[63427],false],[0,0,0,"tag",null,"",null,false],[0,0,0,"root",null," sub_list[lhs...rhs]",null,false],[0,0,0,"usingnamespace",null," `usingnamespace lhs;`. rhs unused. main_token is `usingnamespace`.",null,false],[0,0,0,"test_decl",null," lhs is test name token (must be string literal or identifier), if any.\n rhs is the body node.",null,false],[0,0,0,"global_var_decl",null," lhs is the index into extra_data.\n rhs is the initialization expression, if any.\n main_token is `var` or `const`.",null,false],[0,0,0,"local_var_decl",null," `var a: x align(y) = rhs`\n lhs is the index into extra_data.\n main_token is `var` or `const`.",null,false],[0,0,0,"simple_var_decl",null," `var a: lhs = rhs`. lhs and rhs may be unused.\n Can be local or global.\n main_token is `var` or `const`.",null,false],[0,0,0,"aligned_var_decl",null," `var a align(lhs) = rhs`. lhs and rhs may be unused.\n Can be local or global.\n main_token is `var` or `const`.",null,false],[0,0,0,"errdefer",null," lhs is the identifier token payload if any,\n rhs is the deferred expression.",null,false],[0,0,0,"defer",null," lhs is unused.\n rhs is the deferred expression.",null,false],[0,0,0,"catch",null," lhs catch rhs\n lhs catch |err| rhs\n main_token is the `catch` keyword.\n payload is determined by looking at the next token after the `catch` keyword.",null,false],[0,0,0,"field_access",null," `lhs.a`. main_token is the dot. rhs is the identifier token index.",null,false],[0,0,0,"unwrap_optional",null," `lhs.?`. main_token is the dot. rhs is the `?` token index.",null,false],[0,0,0,"equal_equal",null," `lhs == rhs`. main_token is op.",null,false],[0,0,0,"bang_equal",null," `lhs != rhs`. main_token is op.",null,false],[0,0,0,"less_than",null," `lhs < rhs`. main_token is op.",null,false],[0,0,0,"greater_than",null," `lhs > rhs`. main_token is op.",null,false],[0,0,0,"less_or_equal",null," `lhs <= rhs`. main_token is op.",null,false],[0,0,0,"greater_or_equal",null," `lhs >= rhs`. main_token is op.",null,false],[0,0,0,"assign_mul",null," `lhs *= rhs`. main_token is op.",null,false],[0,0,0,"assign_div",null," `lhs /= rhs`. main_token is op.",null,false],[0,0,0,"assign_mod",null," `lhs *= rhs`. main_token is op.",null,false],[0,0,0,"assign_add",null," `lhs += rhs`. main_token is op.",null,false],[0,0,0,"assign_sub",null," `lhs -= rhs`. main_token is op.",null,false],[0,0,0,"assign_shl",null," `lhs <<= rhs`. main_token is op.",null,false],[0,0,0,"assign_shl_sat",null," `lhs <<|= rhs`. main_token is op.",null,false],[0,0,0,"assign_shr",null," `lhs >>= rhs`. main_token is op.",null,false],[0,0,0,"assign_bit_and",null," `lhs &= rhs`. main_token is op.",null,false],[0,0,0,"assign_bit_xor",null," `lhs ^= rhs`. main_token is op.",null,false],[0,0,0,"assign_bit_or",null," `lhs |= rhs`. main_token is op.",null,false],[0,0,0,"assign_mul_wrap",null," `lhs *%= rhs`. main_token is op.",null,false],[0,0,0,"assign_add_wrap",null," `lhs +%= rhs`. main_token is op.",null,false],[0,0,0,"assign_sub_wrap",null," `lhs -%= rhs`. main_token is op.",null,false],[0,0,0,"assign_mul_sat",null," `lhs *|= rhs`. main_token is op.",null,false],[0,0,0,"assign_add_sat",null," `lhs +|= rhs`. main_token is op.",null,false],[0,0,0,"assign_sub_sat",null," `lhs -|= rhs`. main_token is op.",null,false],[0,0,0,"assign",null," `lhs = rhs`. main_token is op.",null,false],[0,0,0,"assign_destructure",null," `a, b, ... = rhs`. main_token is op. lhs is index into `extra_data`\n of an lhs elem count followed by an array of that many `Node.Index`,\n with each node having one of the following types:\n * `global_var_decl`\n * `local_var_decl`\n * `simple_var_decl`\n * `aligned_var_decl`\n * Any expression node\n The first 3 types correspond to a `var` or `const` lhs node (note\n that their `rhs` is always 0). An expression node corresponds to a\n standard assignment LHS (which must be evaluated as an lvalue).\n There may be a preceding `comptime` token, which does not create a\n corresponding `comptime` node so must be manually detected.",null,false],[0,0,0,"merge_error_sets",null," `lhs || rhs`. main_token is the `||`.",null,false],[0,0,0,"mul",null," `lhs * rhs`. main_token is the `*`.",null,false],[0,0,0,"div",null," `lhs / rhs`. main_token is the `/`.",null,false],[0,0,0,"mod",null," `lhs % rhs`. main_token is the `%`.",null,false],[0,0,0,"array_mult",null," `lhs ** rhs`. main_token is the `**`.",null,false],[0,0,0,"mul_wrap",null," `lhs *% rhs`. main_token is the `*%`.",null,false],[0,0,0,"mul_sat",null," `lhs *| rhs`. main_token is the `*|`.",null,false],[0,0,0,"add",null," `lhs + rhs`. main_token is the `+`.",null,false],[0,0,0,"sub",null," `lhs - rhs`. main_token is the `-`.",null,false],[0,0,0,"array_cat",null," `lhs ++ rhs`. main_token is the `++`.",null,false],[0,0,0,"add_wrap",null," `lhs +% rhs`. main_token is the `+%`.",null,false],[0,0,0,"sub_wrap",null," `lhs -% rhs`. main_token is the `-%`.",null,false],[0,0,0,"add_sat",null," `lhs +| rhs`. main_token is the `+|`.",null,false],[0,0,0,"sub_sat",null," `lhs -| rhs`. main_token is the `-|`.",null,false],[0,0,0,"shl",null," `lhs << rhs`. main_token is the `<<`.",null,false],[0,0,0,"shl_sat",null," `lhs <<| rhs`. main_token is the `<<|`.",null,false],[0,0,0,"shr",null," `lhs >> rhs`. main_token is the `>>`.",null,false],[0,0,0,"bit_and",null," `lhs & rhs`. main_token is the `&`.",null,false],[0,0,0,"bit_xor",null," `lhs ^ rhs`. main_token is the `^`.",null,false],[0,0,0,"bit_or",null," `lhs | rhs`. main_token is the `|`.",null,false],[0,0,0,"orelse",null," `lhs orelse rhs`. main_token is the `orelse`.",null,false],[0,0,0,"bool_and",null," `lhs and rhs`. main_token is the `and`.",null,false],[0,0,0,"bool_or",null," `lhs or rhs`. main_token is the `or`.",null,false],[0,0,0,"bool_not",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"negation",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"bit_not",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"negation_wrap",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"address_of",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"try",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"await",null," `op lhs`. rhs unused. main_token is op.",null,false],[0,0,0,"optional_type",null," `?lhs`. rhs unused. main_token is the `?`.",null,false],[0,0,0,"array_type",null," `[lhs]rhs`.",null,false],[0,0,0,"array_type_sentinel",null," `[lhs:a]b`. `ArrayTypeSentinel[rhs]`.",null,false],[0,0,0,"ptr_type_aligned",null," `[*]align(lhs) rhs`. lhs can be omitted.\n `*align(lhs) rhs`. lhs can be omitted.\n `[]rhs`.\n main_token is the asterisk if a pointer or the lbracket if a slice\n main_token might be a ** token, which is shared with a parent/child\n pointer type and may require special handling.",null,false],[0,0,0,"ptr_type_sentinel",null," `[*:lhs]rhs`. lhs can be omitted.\n `*rhs`.\n `[:lhs]rhs`.\n main_token is the asterisk if a pointer or the lbracket if a slice\n main_token might be a ** token, which is shared with a parent/child\n pointer type and may require special handling.",null,false],[0,0,0,"ptr_type",null," lhs is index into ptr_type. rhs is the element type expression.\n main_token is the asterisk if a pointer or the lbracket if a slice\n main_token might be a ** token, which is shared with a parent/child\n pointer type and may require special handling.",null,false],[0,0,0,"ptr_type_bit_range",null," lhs is index into ptr_type_bit_range. rhs is the element type expression.\n main_token is the asterisk if a pointer or the lbracket if a slice\n main_token might be a ** token, which is shared with a parent/child\n pointer type and may require special handling.",null,false],[0,0,0,"slice_open",null," `lhs[rhs..]`\n main_token is the lbracket.",null,false],[0,0,0,"slice",null," `lhs[b..c]`. rhs is index into Slice\n main_token is the lbracket.",null,false],[0,0,0,"slice_sentinel",null," `lhs[b..c :d]`. rhs is index into SliceSentinel\n main_token is the lbracket.",null,false],[0,0,0,"deref",null," `lhs.*`. rhs is unused.",null,false],[0,0,0,"array_access",null," `lhs[rhs]`.",null,false],[0,0,0,"array_init_one",null," `lhs{rhs}`. rhs can be omitted.",null,false],[0,0,0,"array_init_one_comma",null," `lhs{rhs,}`. rhs can *not* be omitted",null,false],[0,0,0,"array_init_dot_two",null," `.{lhs, rhs}`. lhs and rhs can be omitted.",null,false],[0,0,0,"array_init_dot_two_comma",null," Same as `array_init_dot_two` except there is known to be a trailing comma\n before the final rbrace.",null,false],[0,0,0,"array_init_dot",null," `.{a, b}`. `sub_list[lhs..rhs]`.",null,false],[0,0,0,"array_init_dot_comma",null," Same as `array_init_dot` except there is known to be a trailing comma\n before the final rbrace.",null,false],[0,0,0,"array_init",null," `lhs{a, b}`. `sub_range_list[rhs]`. lhs can be omitted which means `.{a, b}`.",null,false],[0,0,0,"array_init_comma",null," Same as `array_init` except there is known to be a trailing comma\n before the final rbrace.",null,false],[0,0,0,"struct_init_one",null," `lhs{.a = rhs}`. rhs can be omitted making it empty.\n main_token is the lbrace.",null,false],[0,0,0,"struct_init_one_comma",null," `lhs{.a = rhs,}`. rhs can *not* be omitted.\n main_token is the lbrace.",null,false],[0,0,0,"struct_init_dot_two",null," `.{.a = lhs, .b = rhs}`. lhs and rhs can be omitted.\n main_token is the lbrace.\n No trailing comma before the rbrace.",null,false],[0,0,0,"struct_init_dot_two_comma",null," Same as `struct_init_dot_two` except there is known to be a trailing comma\n before the final rbrace.",null,false],[0,0,0,"struct_init_dot",null," `.{.a = b, .c = d}`. `sub_list[lhs..rhs]`.\n main_token is the lbrace.",null,false],[0,0,0,"struct_init_dot_comma",null," Same as `struct_init_dot` except there is known to be a trailing comma\n before the final rbrace.",null,false],[0,0,0,"struct_init",null," `lhs{.a = b, .c = d}`. `sub_range_list[rhs]`.\n lhs can be omitted which means `.{.a = b, .c = d}`.\n main_token is the lbrace.",null,false],[0,0,0,"struct_init_comma",null," Same as `struct_init` except there is known to be a trailing comma\n before the final rbrace.",null,false],[0,0,0,"call_one",null," `lhs(rhs)`. rhs can be omitted.\n main_token is the lparen.",null,false],[0,0,0,"call_one_comma",null," `lhs(rhs,)`. rhs can be omitted.\n main_token is the lparen.",null,false],[0,0,0,"async_call_one",null," `async lhs(rhs)`. rhs can be omitted.",null,false],[0,0,0,"async_call_one_comma",null," `async lhs(rhs,)`.",null,false],[0,0,0,"call",null," `lhs(a, b, c)`. `SubRange[rhs]`.\n main_token is the `(`.",null,false],[0,0,0,"call_comma",null," `lhs(a, b, c,)`. `SubRange[rhs]`.\n main_token is the `(`.",null,false],[0,0,0,"async_call",null," `async lhs(a, b, c)`. `SubRange[rhs]`.\n main_token is the `(`.",null,false],[0,0,0,"async_call_comma",null," `async lhs(a, b, c,)`. `SubRange[rhs]`.\n main_token is the `(`.",null,false],[0,0,0,"switch",null," `switch(lhs) {}`. `SubRange[rhs]`.",null,false],[0,0,0,"switch_comma",null," Same as switch except there is known to be a trailing comma\n before the final rbrace",null,false],[0,0,0,"switch_case_one",null," `lhs => rhs`. If lhs is omitted it means `else`.\n main_token is the `=>`",null,false],[0,0,0,"switch_case_inline_one",null," Same ast `switch_case_one` but the case is inline",null,false],[0,0,0,"switch_case",null," `a, b, c => rhs`. `SubRange[lhs]`.\n main_token is the `=>`",null,false],[0,0,0,"switch_case_inline",null," Same ast `switch_case` but the case is inline",null,false],[0,0,0,"switch_range",null," `lhs...rhs`.",null,false],[0,0,0,"while_simple",null," `while (lhs) rhs`.\n `while (lhs) |x| rhs`.",null,false],[0,0,0,"while_cont",null," `while (lhs) : (a) b`. `WhileCont[rhs]`.\n `while (lhs) : (a) b`. `WhileCont[rhs]`.",null,false],[0,0,0,"while",null," `while (lhs) : (a) b else c`. `While[rhs]`.\n `while (lhs) |x| : (a) b else c`. `While[rhs]`.\n `while (lhs) |x| : (a) b else |y| c`. `While[rhs]`.",null,false],[0,0,0,"for_simple",null," `for (lhs) rhs`.",null,false],[0,0,0,"for",null," `for (lhs[0..inputs]) lhs[inputs + 1] else lhs[inputs + 2]`. `For[rhs]`.",null,false],[0,0,0,"for_range",null," `lhs..rhs`.",null,false],[0,0,0,"if_simple",null," `if (lhs) rhs`.\n `if (lhs) |a| rhs`.",null,false],[0,0,0,"if",null," `if (lhs) a else b`. `If[rhs]`.\n `if (lhs) |x| a else b`. `If[rhs]`.\n `if (lhs) |x| a else |y| b`. `If[rhs]`.",null,false],[0,0,0,"suspend",null," `suspend lhs`. lhs can be omitted. rhs is unused.",null,false],[0,0,0,"resume",null," `resume lhs`. rhs is unused.",null,false],[0,0,0,"continue",null," `continue`. lhs is token index of label if any. rhs is unused.",null,false],[0,0,0,"break",null," `break :lhs rhs`\n both lhs and rhs may be omitted.",null,false],[0,0,0,"return",null," `return lhs`. lhs can be omitted. rhs is unused.",null,false],[0,0,0,"fn_proto_simple",null," `fn(a: lhs) rhs`. lhs can be omitted.\n anytype and ... parameters are omitted from the AST tree.\n main_token is the `fn` keyword.\n extern function declarations use this tag.",null,false],[0,0,0,"fn_proto_multi",null," `fn(a: b, c: d) rhs`. `sub_range_list[lhs]`.\n anytype and ... parameters are omitted from the AST tree.\n main_token is the `fn` keyword.\n extern function declarations use this tag.",null,false],[0,0,0,"fn_proto_one",null," `fn(a: b) rhs addrspace(e) linksection(f) callconv(g)`. `FnProtoOne[lhs]`.\n zero or one parameters.\n anytype and ... parameters are omitted from the AST tree.\n main_token is the `fn` keyword.\n extern function declarations use this tag.",null,false],[0,0,0,"fn_proto",null," `fn(a: b, c: d) rhs addrspace(e) linksection(f) callconv(g)`. `FnProto[lhs]`.\n anytype and ... parameters are omitted from the AST tree.\n main_token is the `fn` keyword.\n extern function declarations use this tag.",null,false],[0,0,0,"fn_decl",null," lhs is the fn_proto.\n rhs is the function body block.\n Note that extern function declarations use the fn_proto tags rather\n than this one.",null,false],[0,0,0,"anyframe_type",null," `anyframe->rhs`. main_token is `anyframe`. `lhs` is arrow token index.",null,false],[0,0,0,"anyframe_literal",null," Both lhs and rhs unused.",null,false],[0,0,0,"char_literal",null," Both lhs and rhs unused.",null,false],[0,0,0,"number_literal",null," Both lhs and rhs unused.",null,false],[0,0,0,"unreachable_literal",null," Both lhs and rhs unused.",null,false],[0,0,0,"identifier",null," Both lhs and rhs unused.\n Most identifiers will not have explicit AST nodes, however for expressions\n which could be one of many different kinds of AST nodes, there will be an\n identifier AST node for it.",null,false],[0,0,0,"enum_literal",null," lhs is the dot token index, rhs unused, main_token is the identifier.",null,false],[0,0,0,"string_literal",null," main_token is the string literal token\n Both lhs and rhs unused.",null,false],[0,0,0,"multiline_string_literal",null," main_token is the first token index (redundant with lhs)\n lhs is the first token index; rhs is the last token index.\n Could be a series of multiline_string_literal_line tokens, or a single\n string_literal token.",null,false],[0,0,0,"grouped_expression",null," `(lhs)`. main_token is the `(`; rhs is the token index of the `)`.",null,false],[0,0,0,"builtin_call_two",null," `@a(lhs, rhs)`. lhs and rhs may be omitted.\n main_token is the builtin token.",null,false],[0,0,0,"builtin_call_two_comma",null," Same as builtin_call_two but there is known to be a trailing comma before the rparen.",null,false],[0,0,0,"builtin_call",null," `@a(b, c)`. `sub_list[lhs..rhs]`.\n main_token is the builtin token.",null,false],[0,0,0,"builtin_call_comma",null," Same as builtin_call but there is known to be a trailing comma before the rparen.",null,false],[0,0,0,"error_set_decl",null," `error{a, b}`.\n rhs is the rbrace, lhs is unused.",null,false],[0,0,0,"container_decl",null," `struct {}`, `union {}`, `opaque {}`, `enum {}`. `extra_data[lhs..rhs]`.\n main_token is `struct`, `union`, `opaque`, `enum` keyword.",null,false],[0,0,0,"container_decl_trailing",null," Same as ContainerDecl but there is known to be a trailing comma\n or semicolon before the rbrace.",null,false],[0,0,0,"container_decl_two",null," `struct {lhs, rhs}`, `union {lhs, rhs}`, `opaque {lhs, rhs}`, `enum {lhs, rhs}`.\n lhs or rhs can be omitted.\n main_token is `struct`, `union`, `opaque`, `enum` keyword.",null,false],[0,0,0,"container_decl_two_trailing",null," Same as ContainerDeclTwo except there is known to be a trailing comma\n or semicolon before the rbrace.",null,false],[0,0,0,"container_decl_arg",null," `struct(lhs)` / `union(lhs)` / `enum(lhs)`. `SubRange[rhs]`.",null,false],[0,0,0,"container_decl_arg_trailing",null," Same as container_decl_arg but there is known to be a trailing\n comma or semicolon before the rbrace.",null,false],[0,0,0,"tagged_union",null," `union(enum) {}`. `sub_list[lhs..rhs]`.\n Note that tagged unions with explicitly provided enums are represented\n by `container_decl_arg`.",null,false],[0,0,0,"tagged_union_trailing",null," Same as tagged_union but there is known to be a trailing comma\n or semicolon before the rbrace.",null,false],[0,0,0,"tagged_union_two",null," `union(enum) {lhs, rhs}`. lhs or rhs may be omitted.\n Note that tagged unions with explicitly provided enums are represented\n by `container_decl_arg`.",null,false],[0,0,0,"tagged_union_two_trailing",null," Same as tagged_union_two but there is known to be a trailing comma\n or semicolon before the rbrace.",null,false],[0,0,0,"tagged_union_enum_tag",null," `union(enum(lhs)) {}`. `SubRange[rhs]`.",null,false],[0,0,0,"tagged_union_enum_tag_trailing",null," Same as tagged_union_enum_tag but there is known to be a trailing comma\n or semicolon before the rbrace.",null,false],[0,0,0,"container_field_init",null," `a: lhs = rhs,`. lhs and rhs can be omitted.\n main_token is the field name identifier.\n lastToken() does not include the possible trailing comma.",null,false],[0,0,0,"container_field_align",null," `a: lhs align(rhs),`. rhs can be omitted.\n main_token is the field name identifier.\n lastToken() does not include the possible trailing comma.",null,false],[0,0,0,"container_field",null," `a: lhs align(c) = d,`. `container_field_list[rhs]`.\n main_token is the field name identifier.\n lastToken() does not include the possible trailing comma.",null,false],[0,0,0,"comptime",null," `comptime lhs`. rhs unused.",null,false],[0,0,0,"nosuspend",null," `nosuspend lhs`. rhs unused.",null,false],[0,0,0,"block_two",null," `{lhs rhs}`. rhs or lhs can be omitted.\n main_token points at the lbrace.",null,false],[0,0,0,"block_two_semicolon",null," Same as block_two but there is known to be a semicolon before the rbrace.",null,false],[0,0,0,"block",null," `{}`. `sub_list[lhs..rhs]`.\n main_token points at the lbrace.",null,false],[0,0,0,"block_semicolon",null," Same as block but there is known to be a semicolon before the rbrace.",null,false],[0,0,0,"asm_simple",null," `asm(lhs)`. rhs is the token index of the rparen.",null,false],[0,0,0,"asm",null," `asm(lhs, a)`. `Asm[rhs]`.",null,false],[0,0,0,"asm_output",null," `[a] \"b\" (c)`. lhs is 0, rhs is token index of the rparen.\n `[a] \"b\" (-> lhs)`. rhs is token index of the rparen.\n main_token is `a`.",null,false],[0,0,0,"asm_input",null," `[a] \"b\" (lhs)`. rhs is token index of the rparen.\n main_token is `a`.",null,false],[0,0,0,"error_value",null," `error.a`. lhs is token index of `.`. rhs is token index of `a`.",null,false],[0,0,0,"error_union",null," `lhs!rhs`. main_token is the `!`.",null,false],[456,3414,0,null,null,null,[63600,63602],false],[456,3414,0,null,null,null,null,false],[0,0,0,"lhs",null,null,null,false],[456,3414,0,null,null,null,null,false],[0,0,0,"rhs",null,null,null,false],[456,3419,0,null,null,null,[63605,63607],false],[456,3419,0,null,null,null,null,false],[0,0,0,"type_node",null,null,null,false],[456,3419,0,null,null,null,null,false],[0,0,0,"align_node",null,null,null,false],[456,3424,0,null,null,null,[63610,63612],false],[456,3424,0,null,null,null,null,false],[0,0,0,"elem_type",null,null,null,false],[456,3424,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,3429,0,null,null,null,[63615,63617,63619],false],[456,3429,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,3429,0,null,null,null,null,false],[0,0,0,"align_node",null,null,null,false],[456,3429,0,null,null,null,null,false],[0,0,0,"addrspace_node",null,null,null,false],[456,3435,0,null,null,null,[63622,63624,63626,63628,63630],false],[456,3435,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,3435,0,null,null,null,null,false],[0,0,0,"align_node",null,null,null,false],[456,3435,0,null,null,null,null,false],[0,0,0,"addrspace_node",null,null,null,false],[456,3435,0,null,null,null,null,false],[0,0,0,"bit_range_start",null,null,null,false],[456,3435,0,null,null,null,null,false],[0,0,0,"bit_range_end",null,null,null,false],[456,3443,0,null,null,null,[63633,63635],false],[456,3443,0,null,null,null,null,false],[0,0,0,"start",null," Index into sub_list.",null,false],[456,3443,0,null,null,null,null,false],[0,0,0,"end",null," Index into sub_list.",null,false],[456,3450,0,null,null,null,[63638,63640],false],[456,3450,0,null,null,null,null,false],[0,0,0,"then_expr",null,null,null,false],[456,3450,0,null,null,null,null,false],[0,0,0,"else_expr",null,null,null,false],[456,3455,0,null,null,null,[63643,63645],false],[456,3455,0,null,null,null,null,false],[0,0,0,"value_expr",null,null,null,false],[456,3455,0,null,null,null,null,false],[0,0,0,"align_expr",null,null,null,false],[456,3460,0,null,null,null,[63648,63650,63652,63654],false],[456,3460,0,null,null,null,null,false],[0,0,0,"type_node",null," Populated if there is an explicit type ascription.",null,false],[456,3460,0,null,null,null,null,false],[0,0,0,"align_node",null," Populated if align(A) is present.",null,false],[456,3460,0,null,null,null,null,false],[0,0,0,"addrspace_node",null," Populated if addrspace(A) is present.",null,false],[456,3460,0,null,null,null,null,false],[0,0,0,"section_node",null," Populated if linksection(A) is present.",null,false],[456,3471,0,null,null,null,[63657,63659],false],[456,3471,0,null,null,null,null,false],[0,0,0,"start",null,null,null,false],[456,3471,0,null,null,null,null,false],[0,0,0,"end",null,null,null,false],[456,3476,0,null,null,null,[63662,63664,63666],false],[456,3476,0,null,null,null,null,false],[0,0,0,"start",null,null,null,false],[456,3476,0,null,null,null,null,false],[0,0,0,"end",null," May be 0 if the slice is \"open\"",null,false],[456,3476,0,null,null,null,null,false],[0,0,0,"sentinel",null,null,null,false],[456,3483,0,null,null,null,[63669,63671,63673],false],[456,3483,0,null,null,null,null,false],[0,0,0,"cont_expr",null,null,null,false],[456,3483,0,null,null,null,null,false],[0,0,0,"then_expr",null,null,null,false],[456,3483,0,null,null,null,null,false],[0,0,0,"else_expr",null,null,null,false],[456,3489,0,null,null,null,[63676,63678],false],[456,3489,0,null,null,null,null,false],[0,0,0,"cont_expr",null,null,null,false],[456,3489,0,null,null,null,null,false],[0,0,0,"then_expr",null,null,null,false],[456,3494,0,null,null,null,[63681,63682],false],[456,3494,0,null,null,null,null,false],[0,0,0,"inputs",null,null,null,false],[0,0,0,"has_else",null,null,null,false],[456,3499,0,null,null,null,[63685,63687,63689,63691,63693],false],[456,3499,0,null,null,null,null,false],[0,0,0,"param",null," Populated if there is exactly 1 parameter. Otherwise there are 0 parameters.",null,false],[456,3499,0,null,null,null,null,false],[0,0,0,"align_expr",null," Populated if align(A) is present.",null,false],[456,3499,0,null,null,null,null,false],[0,0,0,"addrspace_expr",null," Populated if addrspace(A) is present.",null,false],[456,3499,0,null,null,null,null,false],[0,0,0,"section_expr",null," Populated if linksection(A) is present.",null,false],[456,3499,0,null,null,null,null,false],[0,0,0,"callconv_expr",null," Populated if callconv(A) is present.",null,false],[456,3512,0,null,null,null,[63696,63698,63700,63702,63704,63706],false],[456,3512,0,null,null,null,null,false],[0,0,0,"params_start",null,null,null,false],[456,3512,0,null,null,null,null,false],[0,0,0,"params_end",null,null,null,false],[456,3512,0,null,null,null,null,false],[0,0,0,"align_expr",null," Populated if align(A) is present.",null,false],[456,3512,0,null,null,null,null,false],[0,0,0,"addrspace_expr",null," Populated if addrspace(A) is present.",null,false],[456,3512,0,null,null,null,null,false],[0,0,0,"section_expr",null," Populated if linksection(A) is present.",null,false],[456,3512,0,null,null,null,null,false],[0,0,0,"callconv_expr",null," Populated if callconv(A) is present.",null,false],[456,3525,0,null,null,null,[63709,63711,63713],false],[456,3525,0,null,null,null,null,false],[0,0,0,"items_start",null,null,null,false],[456,3525,0,null,null,null,null,false],[0,0,0,"items_end",null,null,null,false],[456,3525,0,null,null,null,null,false],[0,0,0,"rparen",null," Needed to make lastToken() work.",null,false],[456,2921,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[456,2921,0,null,null,null,null,false],[0,0,0,"main_token",null,null,null,false],[456,2921,0,null,null,null,null,false],[0,0,0,"data",null,null,null,false],[456,3533,0,null,null,null,null,false],[456,3534,0,null,null,null,null,false],[456,3535,0,null,null,null,null,false],[456,3536,0,null,null,null,null,false],[456,3537,0,null,null,null,null,false],[456,3538,0,null,null,null,null,false],[456,3539,0,null,null,null,null,false],[456,3540,0,null,null,null,null,false],[0,0,0,"Parse.zig",null," Represents in-progress parsing, will be converted to an Ast after completion.\n",[64002,64004,64006,64008,64010,64012,64014,64016,64018],false],[457,2,0,null,null,null,null,false],[457,14,0,null,null,null,[63731,63732],false],[0,0,0,"zero_or_one",null,null,null,false],[0,0,0,"multi",null,null,null,false],[457,19,0,null,null,null,[63737,63739,63741,63742],false],[457,25,0,null,null,null,[63735,63736],false],[0,0,0,"self",null,"",null,false],[0,0,0,"p",null,"",null,false],[0,0,0,"len",null,null,null,false],[457,19,0,null,null,null,null,false],[0,0,0,"lhs",null,null,null,false],[457,19,0,null,null,null,null,false],[0,0,0,"rhs",null,null,null,false],[0,0,0,"trailing",null,null,null,false],[457,35,0,null,null,null,[63744,63745],false],[0,0,0,"p",null,"",null,false],[0,0,0,"list",null,"",null,false],[457,43,0,null,null,null,[63747,63748],false],[0,0,0,"p",null,"",null,false],[0,0,0,"elem",null,"",null,false],[457,49,0,null,null,null,[63750,63751,63752],false],[0,0,0,"p",null,"",null,false],[0,0,0,"i",null,"",null,false],[0,0,0,"elem",null,"",null,false],[457,54,0,null,null,null,[63754,63755],false],[0,0,0,"p",null,"",null,false],[0,0,0,"tag",null,"",null,false],[457,60,0,null,null,null,[63757,63758],false],[0,0,0,"p",null,"",null,false],[0,0,0,"node_index",null,"",null,false],[457,71,0,null,null,null,[63760,63761],false],[0,0,0,"p",null,"",null,false],[0,0,0,"extra",null,"",null,false],[457,82,0,null,null,null,[63763,63764],false],[0,0,0,"p",null,"",null,false],[0,0,0,"expected_token",null,"",null,false],[457,91,0,null,null,null,[63766,63767],false],[0,0,0,"p",null,"",null,false],[0,0,0,"error_tag",null,"",null,false],[457,96,0,null,null,null,[63769,63770],false],[0,0,0,"p",null,"",null,false],[0,0,0,"msg",null,"",null,false],[457,142,0,null,null,null,[63772,63773],false],[0,0,0,"p",null,"",null,false],[0,0,0,"tag",null,"",null,false],[457,147,0,null,null,null,[63775,63776],false],[0,0,0,"p",null,"",null,false],[0,0,0,"expected_token",null,"",null,false],[457,156,0,null,null,null,[63778,63779],false],[0,0,0,"p",null,"",null,false],[0,0,0,"msg",null,"",null,false],[457,163,0,null,null," Root <- skip container_doc_comment? ContainerMembers eof",[63781],false],[0,0,0,"p",null,"",null,false],[457,184,0,null,null," Parse in ZON mode. Subset of the language.\n TODO: set a flag in Parse struct, and honor that flag\n by emitting compilation errors when non-zon nodes are encountered.",[63783],false],[0,0,0,"p",null,"",null,false],[457,216,0,null,null," ContainerMembers <- ContainerDeclarations (ContainerField COMMA)* (ContainerField / ContainerDeclarations)\n\n ContainerDeclarations\n     <- TestDecl ContainerDeclarations\n      / ComptimeDecl ContainerDeclarations\n      / doc_comment? KEYWORD_pub? Decl ContainerDeclarations\n      /\n\n ComptimeDecl <- KEYWORD_comptime Block",[63785],false],[0,0,0,"p",null,"",null,false],[457,483,0,null,null," Attempts to find next container member by searching for certain tokens",[63787],false],[0,0,0,"p",null,"",null,false],[457,541,0,null,null," Attempts to find the next statement by searching for a semicolon",[63789],false],[0,0,0,"p",null,"",null,false],[457,569,0,null,null," TestDecl <- KEYWORD_test (STRINGLITERALSINGLE / IDENTIFIER)? Block",[63791],false],[0,0,0,"p",null,"",null,false],[457,590,0,null,null,null,[63793],false],[0,0,0,"p",null,"",null,false],[457,604,0,null,null," Decl\n     <- (KEYWORD_export / KEYWORD_extern STRINGLITERALSINGLE? / (KEYWORD_inline / KEYWORD_noinline))? FnProto (SEMICOLON / Block)\n      / (KEYWORD_export / KEYWORD_extern STRINGLITERALSINGLE?)? KEYWORD_threadlocal? VarDecl\n      / KEYWORD_usingnamespace Expr SEMICOLON",[63795],false],[0,0,0,"p",null,"",null,false],[457,676,0,null,null,null,[63797],false],[0,0,0,"p",null,"",null,false],[457,686,0,null,null,null,[63799],false],[0,0,0,"p",null,"",null,false],[457,700,0,null,null,null,[63801],false],[0,0,0,"p",null,"",null,false],[457,711,0,null,null," FnProto <- KEYWORD_fn IDENTIFIER? LPAREN ParamDeclList RPAREN ByteAlign? AddrSpace? LinkSection? CallConv? EXCLAMATIONMARK? TypeExpr",[63803],false],[0,0,0,"p",null,"",null,false],[457,795,0,null,null," VarDeclProto <- (KEYWORD_const / KEYWORD_var) IDENTIFIER (COLON TypeExpr)? ByteAlign? AddrSpace? LinkSection?\n Returns a `*_var_decl` node with its rhs (init expression) initialized to 0.",[63805],false],[0,0,0,"p",null,"",null,false],[457,858,0,null,null," GlobalVarDecl <- VarDeclProto (EQUAL Expr?) SEMICOLON",[63807],false],[0,0,0,"p",null,"",null,false],[457,886,0,null,null," ContainerField\n     <- doc_comment? KEYWORD_comptime? IDENTIFIER (COLON TypeExpr)? ByteAlign? (EQUAL Expr)?\n      / doc_comment? KEYWORD_comptime? (IDENTIFIER COLON)? !KEYWORD_fn TypeExpr ByteAlign? (EQUAL Expr)?",[63809],false],[0,0,0,"p",null,"",null,false],[457,946,0,null,null," Statement\n     <- KEYWORD_comptime ComptimeStatement\n      / KEYWORD_nosuspend BlockExprStatement\n      / KEYWORD_suspend BlockExprStatement\n      / KEYWORD_defer BlockExprStatement\n      / KEYWORD_errdefer Payload? BlockExprStatement\n      / IfStatement\n      / LabeledStatement\n      / SwitchExpr\n      / VarDeclExprStatement",[63811,63812],false],[0,0,0,"p",null,"",null,false],[0,0,0,"allow_defer_var",null,"",null,false],[457,1042,0,null,null," ComptimeStatement\n     <- BlockExpr\n      / VarDeclExprStatement",[63814,63815],false],[0,0,0,"p",null,"",null,false],[0,0,0,"comptime_token",null,"",null,false],[457,1057,0,null,null," VarDeclExprStatement\n    <- VarDeclProto (COMMA (VarDeclProto / Expr))* EQUAL Expr SEMICOLON\n     / Expr (AssignOp Expr / (COMMA (VarDeclProto / Expr))+ EQUAL Expr)? SEMICOLON",[63817,63818],false],[0,0,0,"p",null,"",null,false],[0,0,0,"comptime_token",null,"",null,false],[457,1174,0,null,null," If a parse error occurs, reports an error, but then finds the next statement\n and returns that one instead. If a parse error occurs but there is no following\n statement, returns 0.",[63820],false],[0,0,0,"p",null,"",null,false],[457,1193,0,null,null," IfStatement\n     <- IfPrefix BlockExpr ( KEYWORD_else Payload? Statement )?\n      / IfPrefix AssignExpr ( SEMICOLON / KEYWORD_else Payload? Statement )",[63822],false],[0,0,0,"p",null,"",null,false],[457,1252,0,null,null," LabeledStatement <- BlockLabel? (Block / LoopStatement)",[63824],false],[0,0,0,"p",null,"",null,false],[457,1279,0,null,null," LoopStatement <- KEYWORD_inline? (ForStatement / WhileStatement)",[63826],false],[0,0,0,"p",null,"",null,false],[457,1297,0,null,null," ForStatement\n     <- ForPrefix BlockExpr ( KEYWORD_else Statement )?\n      / ForPrefix AssignExpr ( SEMICOLON / KEYWORD_else Statement )",[63828],false],[0,0,0,"p",null,"",null,false],[457,1358,0,null,null," WhilePrefix <- KEYWORD_while LPAREN Expr RPAREN PtrPayload? WhileContinueExpr?\n\n WhileStatement\n     <- WhilePrefix BlockExpr ( KEYWORD_else Payload? Statement )?\n      / WhilePrefix AssignExpr ( SEMICOLON / KEYWORD_else Payload? Statement )",[63830],false],[0,0,0,"p",null,"",null,false],[457,1449,0,null,null," BlockExprStatement\n     <- BlockExpr\n      / AssignExpr SEMICOLON",[63832],false],[0,0,0,"p",null,"",null,false],[457,1462,0,null,null,null,[63834],false],[0,0,0,"p",null,"",null,false],[457,1471,0,null,null," BlockExpr <- BlockLabel? Block",[63836],false],[0,0,0,"p",null,"",null,false],[457,1509,0,null,null," AssignExpr <- Expr (AssignOp Expr / (COMMA Expr)+ EQUAL Expr)?\n\n AssignOp\n     <- ASTERISKEQUAL\n      / ASTERISKPIPEEQUAL\n      / SLASHEQUAL\n      / PERCENTEQUAL\n      / PLUSEQUAL\n      / PLUSPIPEEQUAL\n      / MINUSEQUAL\n      / MINUSPIPEEQUAL\n      / LARROW2EQUAL\n      / LARROW2PIPEEQUAL\n      / RARROW2EQUAL\n      / AMPERSANDEQUAL\n      / CARETEQUAL\n      / PIPEEQUAL\n      / ASTERISKPERCENTEQUAL\n      / PLUSPERCENTEQUAL\n      / MINUSPERCENTEQUAL\n      / EQUAL",[63838],false],[0,0,0,"p",null,"",null,false],[457,1516,0,null,null," SingleAssignExpr <- Expr (AssignOp Expr)?",[63840],false],[0,0,0,"p",null,"",null,false],[457,1530,0,null,null,null,[63842,63843],false],[0,0,0,"p",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[457,1544,0,null,null,null,[63845],false],[0,0,0,"tok",null,"",null,false],[457,1568,0,null,null,null,[63847,63848],false],[0,0,0,"p",null,"",null,false],[0,0,0,"first_lhs",null,"",null,false],[457,1601,0,null,null,null,[63850],false],[0,0,0,"p",null,"",null,false],[457,1609,0,null,null,null,[63852],false],[0,0,0,"p",null,"",null,false],[457,1617,0,null,null,null,[63854],false],[0,0,0,"p",null,"",null,false],[457,1621,0,null,null,null,[63856],false],[0,0,0,"p",null,"",null,false],[457,1630,0,null,null,null,[63858,63859],false],[0,0,0,"left",null,null,null,false],[0,0,0,"none",null,null,null,false],[457,1635,0,null,null,null,[63861,63863,63865],false],[0,0,0,"prec",null,null,null,false],[457,1635,0,null,null,null,null,false],[0,0,0,"tag",null,null,null,false],[457,1635,0,null,null,null,null,false],[0,0,0,"assoc",null,null,null,false],[457,1644,0,null,null,null,null,false],[457,1683,0,null,null,null,[63868,63869],false],[0,0,0,"p",null,"",null,false],[0,0,0,"min_prec",null,"",null,false],[457,1753,0,null,null," PrefixExpr <- PrefixOp* PrimaryExpr\n\n PrefixOp\n     <- EXCLAMATIONMARK\n      / MINUS\n      / TILDE\n      / MINUSPERCENT\n      / AMPERSAND\n      / KEYWORD_try\n      / KEYWORD_await",[63871],false],[0,0,0,"p",null,"",null,false],[457,1774,0,null,null,null,[63873],false],[0,0,0,"p",null,"",null,false],[457,1799,0,null,null," TypeExpr <- PrefixTypeOp* ErrorUnionExpr\n\n PrefixTypeOp\n     <- QUESTIONMARK\n      / KEYWORD_anyframe MINUSRARROW\n      / SliceTypeStart (ByteAlign / AddrSpace / KEYWORD_const / KEYWORD_volatile / KEYWORD_allowzero)*\n      / PtrTypeStart (AddrSpace / KEYWORD_align LPAREN Expr (COLON Expr COLON Expr)? RPAREN / KEYWORD_const / KEYWORD_volatile / KEYWORD_allowzero)*\n      / ArrayTypeStart\n\n SliceTypeStart <- LBRACKET (COLON Expr)? RBRACKET\n\n PtrTypeStart\n     <- ASTERISK\n      / ASTERISK2\n      / LBRACKET ASTERISK (LETTERC / COLON Expr)? RBRACKET\n\n ArrayTypeStart <- LBRACKET Expr (COLON Expr)? RBRACKET",[63875],false],[0,0,0,"p",null,"",null,false],[457,2071,0,null,null,null,[63877],false],[0,0,0,"p",null,"",null,false],[457,2091,0,null,null," PrimaryExpr\n     <- AsmExpr\n      / IfExpr\n      / KEYWORD_break BreakLabel? Expr?\n      / KEYWORD_comptime Expr\n      / KEYWORD_nosuspend Expr\n      / KEYWORD_continue BreakLabel?\n      / KEYWORD_resume Expr\n      / KEYWORD_return Expr?\n      / BlockLabel? LoopExpr\n      / Block\n      / CurlySuffixExpr",[63879],false],[0,0,0,"p",null,"",null,false],[457,2206,0,null,null," IfExpr <- IfPrefix Expr (KEYWORD_else Payload? Expr)?",[63881],false],[0,0,0,"p",null,"",null,false],[457,2211,0,null,null," Block <- LBRACE Statement* RBRACE",[63883],false],[0,0,0,"p",null,"",null,false],[457,2264,0,null,null," ForExpr <- ForPrefix Expr (KEYWORD_else Expr)?",[63885],false],[0,0,0,"p",null,"",null,false],[457,2308,0,null,null," ForPrefix <- KEYWORD_for LPAREN ForInput (COMMA ForInput)* COMMA? RPAREN ForPayload\n\n ForInput <- Expr (DOT2 Expr?)?\n\n ForPayload <- PIPE ASTERISK? IDENTIFIER (COMMA ASTERISK? IDENTIFIER)* PIPE",[63887],false],[0,0,0,"p",null,"",null,false],[457,2381,0,null,null," WhilePrefix <- KEYWORD_while LPAREN Expr RPAREN PtrPayload? WhileContinueExpr?\n\n WhileExpr <- WhilePrefix Expr (KEYWORD_else Payload? Expr)?",[63889],false],[0,0,0,"p",null,"",null,false],[457,2436,0,null,null," CurlySuffixExpr <- TypeExpr InitList?\n\n InitList\n     <- LBRACE FieldInit (COMMA FieldInit)* COMMA? RBRACE\n      / LBRACE Expr (COMMA Expr)* COMMA? RBRACE\n      / LBRACE RBRACE",[63891],false],[0,0,0,"p",null,"",null,false],[457,2533,0,null,null," ErrorUnionExpr <- SuffixExpr (EXCLAMATIONMARK TypeExpr)?",[63893],false],[0,0,0,"p",null,"",null,false],[457,2554,0,null,null," SuffixExpr\n     <- KEYWORD_async PrimaryTypeExpr SuffixOp* FnCallArguments\n      / PrimaryTypeExpr (SuffixOp / FnCallArguments)*\n\n FnCallArguments <- LPAREN ExprList RPAREN\n\n ExprList <- (Expr COMMA)* Expr?",[63895],false],[0,0,0,"p",null,"",null,false],[457,2711,0,null,null," PrimaryTypeExpr\n     <- BUILTINIDENTIFIER FnCallArguments\n      / CHAR_LITERAL\n      / ContainerDecl\n      / DOT IDENTIFIER\n      / DOT InitList\n      / ErrorSetDecl\n      / FLOAT\n      / FnProto\n      / GroupedExpr\n      / LabeledTypeExpr\n      / IDENTIFIER\n      / IfTypeExpr\n      / INTEGER\n      / KEYWORD_comptime TypeExpr\n      / KEYWORD_error DOT IDENTIFIER\n      / KEYWORD_anyframe\n      / KEYWORD_unreachable\n      / STRINGLITERAL\n      / SwitchExpr\n\n ContainerDecl <- (KEYWORD_extern / KEYWORD_packed)? ContainerDeclAuto\n\n ContainerDeclAuto <- ContainerDeclType LBRACE container_doc_comment? ContainerMembers RBRACE\n\n InitList\n     <- LBRACE FieldInit (COMMA FieldInit)* COMMA? RBRACE\n      / LBRACE Expr (COMMA Expr)* COMMA? RBRACE\n      / LBRACE RBRACE\n\n ErrorSetDecl <- KEYWORD_error LBRACE IdentifierList RBRACE\n\n GroupedExpr <- LPAREN Expr RPAREN\n\n IfTypeExpr <- IfPrefix TypeExpr (KEYWORD_else Payload? TypeExpr)?\n\n LabeledTypeExpr\n     <- BlockLabel Block\n      / BlockLabel? LoopTypeExpr\n\n LoopTypeExpr <- KEYWORD_inline? (ForTypeExpr / WhileTypeExpr)",[63897],false],[0,0,0,"p",null,"",null,false],[457,3030,0,null,null,null,[63899],false],[0,0,0,"p",null,"",null,false],[457,3039,0,null,null," ForTypeExpr <- ForPrefix TypeExpr (KEYWORD_else TypeExpr)?",[63901],false],[0,0,0,"p",null,"",null,false],[457,3081,0,null,null," WhilePrefix <- KEYWORD_while LPAREN Expr RPAREN PtrPayload? WhileContinueExpr?\n\n WhileTypeExpr <- WhilePrefix TypeExpr (KEYWORD_else Payload? TypeExpr)?",[63903],false],[0,0,0,"p",null,"",null,false],[457,3131,0,null,null," SwitchExpr <- KEYWORD_switch LPAREN Expr RPAREN LBRACE SwitchProngList RBRACE",[63905],false],[0,0,0,"p",null,"",null,false],[457,3167,0,null,null," AsmExpr <- KEYWORD_asm KEYWORD_volatile? LPAREN Expr AsmOutput? RPAREN\n\n AsmOutput <- COLON AsmOutputList AsmInput?\n\n AsmInput <- COLON AsmInputList AsmClobbers?\n\n AsmClobbers <- COLON StringList\n\n StringList <- (STRINGLITERAL COMMA)* STRINGLITERAL?\n\n AsmOutputList <- (AsmOutputItem COMMA)* AsmOutputItem?\n\n AsmInputList <- (AsmInputItem COMMA)* AsmInputItem?",[63907],false],[0,0,0,"p",null,"",null,false],[457,3242,0,null,null," AsmOutputItem <- LBRACKET IDENTIFIER RBRACKET STRINGLITERAL LPAREN (MINUSRARROW TypeExpr / IDENTIFIER) RPAREN",[63909],false],[0,0,0,"p",null,"",null,false],[457,3268,0,null,null," AsmInputItem <- LBRACKET IDENTIFIER RBRACKET STRINGLITERAL LPAREN Expr RPAREN",[63911],false],[0,0,0,"p",null,"",null,false],[457,3287,0,null,null," BreakLabel <- COLON IDENTIFIER",[63913],false],[0,0,0,"p",null,"",null,false],[457,3293,0,null,null," BlockLabel <- IDENTIFIER COLON",[63915],false],[0,0,0,"p",null,"",null,false],[457,3305,0,null,null," FieldInit <- DOT IDENTIFIER EQUAL Expr",[63917],false],[0,0,0,"p",null,"",null,false],[457,3317,0,null,null,null,[63919],false],[0,0,0,"p",null,"",null,false],[457,3328,0,null,null," WhileContinueExpr <- COLON LPAREN AssignExpr RPAREN",[63921],false],[0,0,0,"p",null,"",null,false],[457,3343,0,null,null," LinkSection <- KEYWORD_linksection LPAREN Expr RPAREN",[63923],false],[0,0,0,"p",null,"",null,false],[457,3352,0,null,null," CallConv <- KEYWORD_callconv LPAREN Expr RPAREN",[63925],false],[0,0,0,"p",null,"",null,false],[457,3361,0,null,null," AddrSpace <- KEYWORD_addrspace LPAREN Expr RPAREN",[63927],false],[0,0,0,"p",null,"",null,false],[457,3380,0,null,null," This function can return null nodes and then still return nodes afterwards,\n such as in the case of anytype and `...`. Caller must look for rparen to find\n out when there are no more param decls left.\n\n ParamDecl\n     <- doc_comment? (KEYWORD_noalias / KEYWORD_comptime)? (IDENTIFIER COLON)? ParamType\n      / DOT3\n\n ParamType\n     <- KEYWORD_anytype\n      / TypeExpr",[63929],false],[0,0,0,"p",null,"",null,false],[457,3405,0,null,null," Payload <- PIPE IDENTIFIER PIPE",[63931],false],[0,0,0,"p",null,"",null,false],[457,3413,0,null,null," PtrPayload <- PIPE ASTERISK? IDENTIFIER PIPE",[63933],false],[0,0,0,"p",null,"",null,false],[457,3424,0,null,null," Returns the first identifier token, if any.\n\n PtrIndexPayload <- PIPE ASTERISK? IDENTIFIER (COMMA IDENTIFIER)? PIPE",[63935],false],[0,0,0,"p",null,"",null,false],[457,3440,0,null,null," SwitchProng <- KEYWORD_inline? SwitchCase EQUALRARROW PtrIndexPayload? AssignExpr\n\n SwitchCase\n     <- SwitchItem (COMMA SwitchItem)* COMMA?\n      / KEYWORD_else",[63937],false],[0,0,0,"p",null,"",null,false],[457,3491,0,null,null," SwitchItem <- Expr (DOT3 Expr)?",[63939],false],[0,0,0,"p",null,"",null,false],[457,3508,0,null,null,null,[63942,63944,63946,63948],false],[457,3508,0,null,null,null,null,false],[0,0,0,"align_node",null,null,null,false],[457,3508,0,null,null,null,null,false],[0,0,0,"addrspace_node",null,null,null,false],[457,3508,0,null,null,null,null,false],[0,0,0,"bit_range_start",null,null,null,false],[457,3508,0,null,null,null,null,false],[0,0,0,"bit_range_end",null,null,null,false],[457,3515,0,null,null,null,[63950],false],[0,0,0,"p",null,"",null,false],[457,3581,0,null,null," SuffixOp\n     <- LBRACKET Expr (DOT2 (Expr? (COLON Expr)?)?)? RBRACKET\n      / DOT IDENTIFIER\n      / DOTASTERISK\n      / DOTQUESTIONMARK",[63952,63953],false],[0,0,0,"p",null,"",null,false],[0,0,0,"lhs",null,"",null,false],[457,3697,0,null,null," Caller must have already verified the first token.\n\n ContainerDeclAuto <- ContainerDeclType LBRACE container_doc_comment? ContainerMembers RBRACE\n\n ContainerDeclType\n     <- KEYWORD_struct (LPAREN Expr RPAREN)?\n      / KEYWORD_opaque\n      / KEYWORD_enum (LPAREN Expr RPAREN)?\n      / KEYWORD_union (LPAREN (KEYWORD_enum (LPAREN Expr RPAREN)? / Expr) RPAREN)?",[63955],false],[0,0,0,"p",null,"",null,false],[457,3831,0,null,null," Give a helpful error message for those transitioning from\n C's 'struct Foo {};' to Zig's 'const Foo = struct {};'.",[63957],false],[0,0,0,"p",null,"",null,false],[457,3863,0,null,null," Holds temporary data until we are ready to construct the full ContainerDecl AST node.\n\n ByteAlign <- KEYWORD_align LPAREN Expr RPAREN",[63959],false],[0,0,0,"p",null,"",null,false],[457,3872,0,null,null," SwitchProngList <- (SwitchProng COMMA)* SwitchProng?",[63961],false],[0,0,0,"p",null,"",null,false],[457,3894,0,null,null," ParamDeclList <- (ParamDecl COMMA)* ParamDecl?",[63963],false],[0,0,0,"p",null,"",null,false],[457,3933,0,null,null," FnCallArguments <- LPAREN ExprList RPAREN\n\n ExprList <- (Expr COMMA)* Expr?",[63965],false],[0,0,0,"p",null,"",null,false],[457,4006,0,null,null," IfPrefix <- KEYWORD_if LPAREN Expr RPAREN PtrPayload?",[63967,63968],false],[0,0,0,"p",null,"",null,false],[0,0,0,"bodyParseFn",null,"",[63969],true],[0,0,0,"p",null,"",null,false],[457,4042,0,null,null," Skips over doc comment tokens. Returns the first one, if any.",[63971],false],[0,0,0,"p",null,"",null,false],[457,4058,0,null,null,null,[63973,63974,63975],false],[0,0,0,"p",null,"",null,false],[0,0,0,"token1",null,"",null,false],[0,0,0,"token2",null,"",null,false],[457,4062,0,null,null,null,[63977,63978],false],[0,0,0,"p",null,"",null,false],[0,0,0,"tag",null,"",null,false],[457,4066,0,null,null,null,[63980,63981],false],[0,0,0,"p",null,"",null,false],[0,0,0,"tag",null,"",null,false],[457,4072,0,null,null,null,[63983,63984],false],[0,0,0,"p",null,"",null,false],[0,0,0,"tag",null,"",null,false],[457,4083,0,null,null,null,[63986,63987,63988],false],[0,0,0,"p",null,"",null,false],[0,0,0,"error_tag",null,"",null,false],[0,0,0,"recoverable",null,"",null,false],[457,4092,0,null,null,null,[63990],false],[0,0,0,"p",null,"",null,false],[457,4098,0,null,null,null,null,false],[457,4100,0,null,null,null,null,false],[457,4101,0,null,null,null,null,false],[457,4102,0,null,null,null,null,false],[457,4103,0,null,null,null,null,false],[457,4104,0,null,null,null,null,false],[457,4105,0,null,null,null,null,false],[457,4106,0,null,null,null,null,false],[457,4107,0,null,null,null,null,false],[457,4108,0,null,null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"gpa",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"source",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"token_tags",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"token_starts",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"tok_i",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"errors",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"nodes",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"extra_data",null,null,null,false],[457,0,0,null,null,null,null,false],[0,0,0,"scratch",null,null,null,false],[456,0,0,null,null,null,null,false],[0,0,0,"source",null," Reference to externally-owned data.",null,false],[456,0,0,null,null,null,null,false],[0,0,0,"tokens",null,null,null,false],[456,0,0,null,null,null,null,false],[0,0,0,"nodes",null," The root AST node is assumed to be index 0. Since there can be no\n references to the root node, this means 0 is available to indicate null.",null,false],[456,0,0,null,null,null,null,false],[0,0,0,"extra_data",null,null,null,false],[456,0,0,null,null,null,null,false],[0,0,0,"errors",null,null,null,false],[447,17,0,null,null,null,null,false],[0,0,0,"zig/system.zig",null,"",[],false],[458,0,0,null,null,null,null,false],[0,0,0,"system/NativePaths.zig",null,"",[64075,64077,64079,64081,64083,64085],false],[459,0,0,null,null,null,null,false],[459,1,0,null,null,null,null,false],[459,2,0,null,null,null,null,false],[459,3,0,null,null,null,null,false],[459,4,0,null,null,null,null,false],[459,6,0,null,null,null,null,false],[459,7,0,null,null,null,null,false],[459,16,0,null,null,null,[64041,64042],false],[0,0,0,"arena",null,"",null,false],[0,0,0,"native_info",null,"",null,false],[459,159,0,null,null,null,[64044,64045],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[459,163,0,null,null,null,[64047,64048,64049],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[459,168,0,null,null,null,[64051,64052],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[459,172,0,null,null,null,[64054,64055,64056],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[459,177,0,null,null,null,[64058,64059],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[459,181,0,null,null,null,[64061,64062],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[459,185,0,null,null,null,[64064,64065,64066],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[459,190,0,null,null,null,[64068,64069,64070],false],[0,0,0,"self",null,"",null,false],[0,0,0,"fmt",null,"",null,true],[0,0,0,"args",null,"",null,false],[459,195,0,null,null,null,[64072,64073],false],[0,0,0,"self",null,"",null,false],[0,0,0,"s",null,"",null,false],[459,0,0,null,null,null,null,false],[0,0,0,"arena",null,null,null,false],[459,0,0,null,null,null,null,false],[0,0,0,"include_dirs",null,null,null,false],[459,0,0,null,null,null,null,false],[0,0,0,"lib_dirs",null,null,null,false],[459,0,0,null,null,null,null,false],[0,0,0,"framework_dirs",null,null,null,false],[459,0,0,null,null,null,null,false],[0,0,0,"rpaths",null,null,null,false],[459,0,0,null,null,null,null,false],[0,0,0,"warnings",null,null,null,false],[458,1,0,null,null,null,null,false],[0,0,0,"system/NativeTargetInfo.zig",null,"",[64169,64171],false],[460,0,0,null,null,null,null,false],[460,1,0,null,null,null,null,false],[460,2,0,null,null,null,null,false],[460,3,0,null,null,null,null,false],[460,4,0,null,null,null,null,false],[460,5,0,null,null,null,null,false],[460,6,0,null,null,null,null,false],[460,8,0,null,null,null,null,false],[460,9,0,null,null,null,null,false],[460,10,0,null,null,null,null,false],[460,11,0,null,null,null,null,false],[460,12,0,null,null,null,null,false],[460,13,0,null,null,null,null,false],[460,14,0,null,null,null,null,false],[460,19,0,null,null,null,null,false],[460,21,0,null,null,null,null,false],[460,36,0,null,null," Given a `CrossTarget`, which specifies in detail which parts of the target should be detected\n natively, which should be standard or default, and which are provided explicitly, this function\n resolves the native components by detecting the native system, and then resolves standard/default parts\n relative to that.",[64105],false],[0,0,0,"cross_target",null,"",null,false],[460,252,0,null,null," In the past, this function attempted to use the executable's own binary if it was dynamically\n linked to answer both the C ABI question and the dynamic linker question. However, this\n could be problematic on a system that uses a RUNPATH for the compiler binary, locking\n it to an older glibc version, while system binaries such as /usr/bin/env use a newer glibc\n version. The problem is that libc.so.6 glibc version will match that of the system while\n the dynamic linker will match that of the compiler binary. Executables with these versions\n mismatching will fail to run.\n\n Therefore, this function works the same regardless of whether the compiler binary is\n dynamically or statically linked. It inspects `/usr/bin/env` as an ELF file to find the\n answer to these questions, or if there is a shebang line, then it chases the referenced\n file recursively. If that does not provide the answer, then the function falls back to\n defaults.",[64107,64108,64109],false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"os",null,"",null,false],[0,0,0,"cross_target",null,"",null,false],[460,398,0,null,null,null,[64111],false],[0,0,0,"rpath",null,"",null,false],[460,481,0,null,null,null,[64113],false],[0,0,0,"file",null,"",null,false],[460,578,0,null,null,null,[64115,64116],false],[0,0,0,"link_name",null,"",null,false],[0,0,0,"prefix",null,"",null,false],[460,594,0,null,null,null,null,false],[460,611,0,null,null,null,[64119,64120,64121,64122,64123],false],[0,0,0,"file",null,"",null,false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"os",null,"",null,false],[0,0,0,"ld_info_list",null,"",null,false],[0,0,0,"cross_target",null,"",null,false],[460,893,0,null,null,null,[64125,64126,64127,64128],false],[0,0,0,"file",null,"",null,false],[0,0,0,"buf",null,"",null,false],[0,0,0,"offset",null,"",null,false],[0,0,0,"min_read_len",null,"",null,false],[460,917,0,null,null,null,[64130,64131,64132],false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"os",null,"",null,false],[0,0,0,"cross_target",null,"",null,false],[460,933,0,null,null,null,[64135,64137],false],[460,933,0,null,null,null,null,false],[0,0,0,"ld",null,null,null,false],[460,933,0,null,null,null,null,false],[0,0,0,"abi",null,null,null,false],[460,938,0,null,null,null,[64139,64140,64141,64142],false],[0,0,0,"is_64",null,"",null,false],[0,0,0,"need_bswap",null,"",null,false],[0,0,0,"int_32",null,"",null,false],[0,0,0,"int_64",null,"",null,false],[460,954,0,null,null,null,[64144,64145,64146],false],[0,0,0,"cpu_arch",null,"",null,false],[0,0,0,"os",null,"",null,false],[0,0,0,"cross_target",null,"",null,false],[460,977,0,null,null,null,[64148,64149,64150,64151,64152,64153,64154,64155],false],[0,0,0,"native",null,null,null,false],[0,0,0,"rosetta",null,null,null,false],[0,0,0,"qemu",null,null,null,false],[0,0,0,"wine",null,null,null,false],[0,0,0,"wasmtime",null,null,null,false],[0,0,0,"darling",null,null,null,false],[0,0,0,"bad_dl",null,null,null,false],[0,0,0,"bad_os_or_cpu",null,null,null,false],[460,988,0,null,null,null,[64157,64158,64159,64160,64161,64162,64163],false],[0,0,0,"allow_darling",null,null,null,false],[0,0,0,"allow_qemu",null,null,null,false],[0,0,0,"allow_rosetta",null,null,null,false],[0,0,0,"allow_wasmtime",null,null,null,false],[0,0,0,"allow_wine",null,null,null,false],[0,0,0,"qemu_fixes_dl",null,null,null,false],[0,0,0,"link_libc",null,null,null,false],[460,1000,0,null,null," Return whether or not the given host target is capable of executing natively executables\n of the other target.",[64165,64166,64167],false],[0,0,0,"host",null,"",null,false],[0,0,0,"candidate",null,"",null,false],[0,0,0,"options",null,"",null,false],[460,0,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[460,0,0,null,null,null,null,false],[0,0,0,"dynamic_linker",null,null,null,false],[458,3,0,null,null,null,null,false],[0,0,0,"system/windows.zig",null,"",[],false],[461,0,0,null,null,null,null,false],[461,1,0,null,null,null,null,false],[461,2,0,null,null,null,null,false],[461,3,0,null,null,null,null,false],[461,4,0,null,null,null,null,false],[461,6,0,null,null,null,null,false],[461,7,0,null,null,null,null,false],[461,8,0,null,null,null,null,false],[461,9,0,null,null,null,null,false],[461,13,0,null,null," Returns the highest known WindowsVersion deduced from reported runtime information.\n Discards information about in-between versions we don't differentiate.",[],false],[461,52,0,null,null,null,null,false],[461,54,0,null,null,null,[64186,64187],false],[0,0,0,"core",null,"",null,false],[0,0,0,"args",null,"",null,false],[461,189,0,null,null,null,[64189,64190,64191,64192],false],[0,0,0,"Feature",null,"",null,true],[0,0,0,"cpu",null,"",null,false],[0,0,0,"feature",null,"",null,false],[0,0,0,"enabled",null,"",null,false],[461,195,0,null,null,null,[],false],[461,203,0,null,null," If the fine-grained detection of CPU features via Win registry fails,\n we fallback to a generic CPU model but we override the feature set\n using `SharedUserData` contents.\n This is effectively what LLVM does for all ARM chips on Windows.",[64195],false],[0,0,0,"arch",null,"",null,false],[461,228,0,null,null,null,[],false],[458,4,0,null,null,null,null,false],[0,0,0,"system/darwin.zig",null,"",[],false],[462,0,0,null,null,null,null,false],[462,1,0,null,null,null,null,false],[462,2,0,null,null,null,null,false],[462,3,0,null,null,null,null,false],[462,4,0,null,null,null,null,false],[462,6,0,null,null,null,null,false],[0,0,0,"darwin/macos.zig",null,"",[],false],[463,0,0,null,null,null,null,false],[463,1,0,null,null,null,null,false],[463,2,0,null,null,null,null,false],[463,3,0,null,null,null,null,false],[463,4,0,null,null,null,null,false],[463,5,0,null,null,null,null,false],[463,7,0,null,null,null,null,false],[463,11,0,null,null," Detect macOS version.\n `target_os` is not modified in case of error.",[64214],false],[0,0,0,"target_os",null,"",null,false],[463,76,0,null,null,null,[64216],false],[0,0,0,"buf",null,"",null,false],[463,111,0,null,null,null,[64248,64249,64251],false],[463,116,0,null,null,null,[64219],false],[0,0,0,"self",null,"",null,false],[463,251,0,null,null,null,[64221],false],[0,0,0,"self",null,"",null,false],[463,263,0,null,null,null,[64223,64224,64225],false],[0,0,0,"self",null,"",null,false],[0,0,0,"kind",null,"",null,false],[0,0,0,"name",null,"",null,false],[463,275,0,null,null,null,[64227,64228,64229,64230,64231,64232,64233],false],[0,0,0,"begin",null,null,null,false],[0,0,0,"tag0",null,null,null,false],[0,0,0,"tag0_end_or_empty",null,null,null,false],[0,0,0,"tagN",null,null,null,false],[0,0,0,"tagN_end",null,null,null,false],[0,0,0,"tag_string",null,null,null,false],[0,0,0,"content",null,null,null,false],[463,285,0,null,null,null,[64235,64236],false],[0,0,0,"tag",null,null,null,false],[0,0,0,"content",null,null,null,false],[463,290,0,null,null,null,[64244,64246],false],[463,294,0,null,null,null,[64239,64240,64241,64242],false],[0,0,0,"unknown",null,null,null,false],[0,0,0,"start",null,null,null,false],[0,0,0,"end",null,null,null,false],[0,0,0,"empty",null,null,null,false],[463,290,0,null,null,null,null,false],[0,0,0,"kind",null,null,null,false],[463,290,0,null,null,null,null,false],[0,0,0,"name",null,null,null,false],[463,111,0,null,null,null,null,false],[0,0,0,"bytes",null,null,null,false],[0,0,0,"index",null,null,null,false],[463,111,0,null,null,null,null,false],[0,0,0,"state",null,null,null,false],[463,415,0,null,null,null,[],false],[462,14,0,null,null," Check if SDK is installed on Darwin without triggering CLT installation popup window.\n Note: simply invoking `xcrun` will inevitably trigger the CLT installation popup.\n Therefore, we resort to invoking `xcode-select --print-path` and checking\n if the status is nonzero.\n stderr from xcode-select is ignored.\n If error.OutOfMemory occurs in Allocator, this function returns null.",[64254],false],[0,0,0,"allocator",null,"",null,false],[462,36,0,null,null," Detect SDK on Darwin.\n Calls `xcrun --sdk <target_sdk> --show-sdk-path` which fetches the path to the SDK.\n Caller owns the memory.\n stderr from xcrun is ignored.\n If error.OutOfMemory occurs in Allocator, this function returns null.",[64256,64257],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"target",null,"",null,false],[458,5,0,null,null,null,null,false],[0,0,0,"system/linux.zig",null,"",[],false],[464,0,0,null,null,null,null,false],[464,1,0,null,null,null,null,false],[464,2,0,null,null,null,null,false],[464,3,0,null,null,null,null,false],[464,4,0,null,null,null,null,false],[464,5,0,null,null,null,null,false],[464,6,0,null,null,null,null,false],[464,8,0,null,null,null,null,false],[464,9,0,null,null,null,null,false],[464,11,0,null,null,null,null,false],[464,13,0,null,null,null,[64280,64281],false],[464,17,0,null,null,null,null,false],[464,37,0,null,null,null,[64273,64274,64275],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[464,52,0,null,null,null,[64277,64278],false],[0,0,0,"self",null,"",null,false],[0,0,0,"arch",null,"",null,false],[464,13,0,null,null,null,null,false],[0,0,0,"model",null,null,null,false],[0,0,0,"is_64bit",null,null,null,false],[464,65,0,null,null,null,null,false],[464,76,0,null,null,null,[64293],false],[464,79,0,null,null,null,null,false],[464,102,0,null,null,null,[64286,64287,64288],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[464,121,0,null,null,null,[64290,64291],false],[0,0,0,"self",null,"",null,false],[0,0,0,"arch",null,"",null,false],[464,76,0,null,null,null,null,false],[0,0,0,"model",null,null,null,false],[464,131,0,null,null,null,null,false],[464,148,0,null,null,null,[64363,64364,64365],false],[464,149,0,null,null,null,null,false],[464,155,0,null,null,null,[64298,64299,64300,64301,64302],false],[0,0,0,"architecture",null,null,null,false],[0,0,0,"implementer",null,null,null,false],[0,0,0,"variant",null,null,null,false],[0,0,0,"part",null,null,null,false],[0,0,0,"is_really_v6",null,null,null,false],[464,163,0,null,null,null,null,false],[0,0,0,"arm.zig",null,"",[],false],[465,0,0,null,null,null,null,false],[465,1,0,null,null,null,null,false],[465,3,0,null,null,null,[64308,64309,64310,64311],false],[0,0,0,"architecture",null,null,null,false],[0,0,0,"implementer",null,null,null,false],[0,0,0,"variant",null,null,null,false],[0,0,0,"part",null,null,null,false],[465,10,0,null,null,null,[],false],[465,12,0,null,null,null,null,false],[465,13,0,null,null,null,null,false],[465,15,0,null,null,null,[64316,64318,64320,64322],false],[0,0,0,"part",null,null,null,false],[465,15,0,null,null,null,null,false],[0,0,0,"variant",null,null,null,false],[465,15,0,null,null,null,null,false],[0,0,0,"m32",null,null,null,false],[465,15,0,null,null,null,null,false],[0,0,0,"m64",null,null,null,false],[465,23,0,null,null,null,null,false],[465,69,0,null,null,null,null,false],[465,73,0,null,null,null,null,false],[465,81,0,null,null,null,null,false],[465,85,0,null,null,null,null,false],[465,89,0,null,null,null,null,false],[465,93,0,null,null,null,null,false],[465,98,0,null,null,null,null,false],[465,113,0,null,null,null,[64332,64333],false],[0,0,0,"core",null,"",null,false],[0,0,0,"is_64bit",null,"",null,false],[465,135,0,null,null,null,[],false],[465,136,0,null,null,null,[64336,64337,64338],false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"feature",null,"",null,false],[0,0,0,"enabled",null,"",null,false],[465,142,0,null,null,null,[64340,64341],false],[0,0,0,"input",null,"",null,false],[0,0,0,"offset",null,"",null,false],[465,159,0,null,null," Input array should consist of readouts from 12 system registers such that:\n 0  -> MIDR_EL1\n 1  -> ID_AA64PFR0_EL1\n 2  -> ID_AA64PFR1_EL1\n 3  -> ID_AA64DFR0_EL1\n 4  -> ID_AA64DFR1_EL1\n 5  -> ID_AA64AFR0_EL1\n 6  -> ID_AA64AFR1_EL1\n 7  -> ID_AA64ISAR0_EL1\n 8  -> ID_AA64ISAR1_EL1\n 9  -> ID_AA64MMFR0_EL1\n 10 -> ID_AA64MMFR1_EL1\n 11 -> ID_AA64MMFR2_EL1",[64343,64344],false],[0,0,0,"arch",null,"",null,false],[0,0,0,"registers",null,"",null,false],[465,176,0,null,null," Takes readout of MIDR_EL1 register as input.",[64346],false],[0,0,0,"midr",null,"",null,false],[465,212,0,null,null," Input array should consist of readouts from 11 system registers such that:\n 0  -> ID_AA64PFR0_EL1\n 1  -> ID_AA64PFR1_EL1\n 2  -> ID_AA64DFR0_EL1\n 3  -> ID_AA64DFR1_EL1\n 4  -> ID_AA64AFR0_EL1\n 5  -> ID_AA64AFR1_EL1\n 6  -> ID_AA64ISAR0_EL1\n 7  -> ID_AA64ISAR1_EL1\n 8  -> ID_AA64MMFR0_EL1\n 9  -> ID_AA64MMFR1_EL1\n 10 -> ID_AA64MMFR2_EL1",[64348,64349],false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"registers",null,"",null,false],[465,291,0,null,null,null,[64351,64352],false],[0,0,0,"cpu",null,"",null,false],[0,0,0,"info",null,"",null,false],[464,165,0,null,null,null,[64354],false],[0,0,0,"self",null,"",null,false],[464,178,0,null,null,null,[64356,64357,64358],false],[0,0,0,"self",null,"",null,false],[0,0,0,"key",null,"",null,false],[0,0,0,"value",null,"",null,false],[464,218,0,null,null,null,[64360,64361],false],[0,0,0,"self",null,"",null,false],[0,0,0,"arch",null,"",null,false],[464,148,0,null,null,null,null,false],[0,0,0,"cores",null,null,null,false],[0,0,0,"core_no",null,null,null,false],[0,0,0,"have_fields",null,null,null,false],[464,247,0,null,null,null,null,false],[464,294,0,null,null,null,[64368,64369,64370,64371],false],[0,0,0,"parser",null,"",null,false],[0,0,0,"arch",null,"",null,false],[0,0,0,"expected_model",null,"",null,false],[0,0,0,"input",null,"",null,false],[464,311,0,null,null,null,[64373],false],[0,0,0,"impl",null,"",[],true],[464,313,0,null,null,null,[64375,64376],false],[0,0,0,"arch",null,"",null,false],[0,0,0,"reader",null,"",null,false],[464,332,0,null,null,null,[],false],[447,18,0,null,null,null,null,false],[0,0,0,"zig/CrossTarget.zig",null," Contains all the same data as `Target`, additionally introducing the concept of \"the native target\".\n The purpose of this abstraction is to provide meaningful and unsurprising defaults.\n This struct does reference any resources and it is copyable.\n",[64520,64522,64524,64526,64528,64530,64532,64534,64536,64538,64540],false],[466,4,0,null,null,null,null,false],[466,5,0,null,null,null,null,false],[466,6,0,null,null,null,null,false],[466,7,0,null,null,null,null,false],[466,8,0,null,null,null,null,false],[466,9,0,null,null,null,null,false],[466,47,0,null,null,null,[64387,64388,64389,64390],false],[0,0,0,"native",null," Always native",null,false],[0,0,0,"baseline",null," Always baseline",null,false],[0,0,0,"determined_by_cpu_arch",null," If CPU Architecture is native, then the CPU model will be native. Otherwise,\n it will be baseline.",null,false],[0,0,0,"explicit",null,null,null,false],[466,61,0,null,null,null,[64392,64393,64394],false],[0,0,0,"none",null,null,null,false],[0,0,0,"semver",null,null,null,false],[0,0,0,"windows",null,null,null,false],[466,67,0,null,null,null,null,false],[466,69,0,null,null,null,null,false],[466,71,0,null,null,null,[64398],false],[0,0,0,"target",null,"",null,false],[466,104,0,null,null,null,[64400,64401],false],[0,0,0,"self",null,"",null,false],[0,0,0,"os",null,"",null,false],[466,171,0,null,null," TODO deprecated, use `std.zig.system.NativeTargetInfo.detect`.",[64403],false],[0,0,0,"self",null,"",null,false],[466,180,0,null,null,null,[64419,64421,64423,64425,64427],false],[466,212,0,null,null,null,[64407,64409,64411,64413,64415,64417],false],[466,212,0,null,null,null,null,false],[0,0,0,"arch",null," If the architecture was determined, this will be populated.",null,false],[466,212,0,null,null,null,null,false],[0,0,0,"os_name",null," If the OS name was determined, this will be populated.",null,false],[466,212,0,null,null,null,null,false],[0,0,0,"os_tag",null," If the OS tag was determined, this will be populated.",null,false],[466,212,0,null,null,null,null,false],[0,0,0,"abi",null," If the ABI was determined, this will be populated.",null,false],[466,212,0,null,null,null,null,false],[0,0,0,"cpu_name",null," If the CPU name was determined, this will be populated.",null,false],[466,212,0,null,null,null,null,false],[0,0,0,"unknown_feature_name",null," If error.UnknownCpuFeature is returned, this will be populated.",null,false],[466,180,0,null,null,null,null,false],[0,0,0,"arch_os_abi",null," This is sometimes called a \"triple\". It looks roughly like this:\n     riscv64-linux-musl\n The fields are, respectively:\n * CPU Architecture\n * Operating System (and optional version range)\n * C ABI (optional, with optional glibc version)\n The string \"native\" can be used for CPU architecture as well as Operating System.\n If the CPU Architecture is specified as \"native\", then the Operating System and C ABI may be omitted.",null,false],[466,180,0,null,null,null,null,false],[0,0,0,"cpu_features",null," Looks like \"name+a+b-c-d+e\", where \"name\" is a CPU Model name, \"a\", \"b\", and \"e\"\n are examples of CPU features to add to the set, and \"c\" and \"d\" are examples of CPU features\n to remove from the set.\n The following special strings are recognized for CPU Model name:\n * \"baseline\" - The \"default\" set of CPU features for cross-compiling. A conservative set\n                of features that is expected to be supported on most available hardware.\n * \"native\"   - The native CPU model is to be detected when compiling.\n If this field is not provided (`null`), then the value will depend on the\n parsed CPU Architecture. If native, then this will be \"native\". Otherwise, it will be \"baseline\".",null,false],[466,180,0,null,null,null,null,false],[0,0,0,"dynamic_linker",null," Absolute path to dynamic linker, to override the default, which is either a natively\n detected path, or a standard path.",null,false],[466,180,0,null,null,null,null,false],[0,0,0,"object_format",null,null,null,false],[466,180,0,null,null,null,null,false],[0,0,0,"diagnostics",null," If this is provided, the function will populate some information about parsing failures,\n so that user-friendly error messages can be delivered.",null,false],[466,233,0,null,null,null,[64429],false],[0,0,0,"args",null,"",null,false],[466,343,0,null,null," Similar to `parse` except instead of fully parsing, it only determines the CPU\n architecture and returns it if it can be determined, and returns `null` otherwise.\n This is intended to be used if the API user of CrossTarget needs to learn the\n target CPU architecture in order to fully populate `ParseOptions`.",[64431],false],[0,0,0,"args",null,"",null,false],[466,356,0,null,null," Parses a version with an omitted patch component, such as \"1.0\",\n which SemanticVersion.parse is not capable of.",[64433],false],[0,0,0,"ver",null,"",null,false],[466,380,0,null,null," TODO deprecated, use `std.zig.system.NativeTargetInfo.detect`.",[64435],false],[0,0,0,"self",null,"",null,false],[466,411,0,null,null,null,[64437],false],[0,0,0,"self",null,"",null,false],[466,415,0,null,null,null,[64439],false],[0,0,0,"self",null,"",null,false],[466,422,0,null,null,null,[64441],false],[0,0,0,"self",null,"",null,false],[466,427,0,null,null," TODO deprecated, use `std.zig.system.NativeTargetInfo.detect`.",[64443],false],[0,0,0,"self",null,"",null,false],[466,459,0,null,null,null,[64445],false],[0,0,0,"self",null,"",null,false],[466,464,0,null,null," TODO deprecated, use `std.zig.system.NativeTargetInfo.detect`.",[64447],false],[0,0,0,"self",null,"",null,false],[466,472,0,null,null," TODO deprecated, use `std.zig.system.NativeTargetInfo.detect`.",[64449],false],[0,0,0,"self",null,"",null,false],[466,480,0,null,null," TODO deprecated, use `std.zig.system.NativeTargetInfo.detect`.",[64451],false],[0,0,0,"self",null,"",null,false],[466,493,0,null,null,null,[64453],false],[0,0,0,"self",null,"",null,false],[466,497,0,null,null,null,[64455],false],[0,0,0,"self",null,"",null,false],[466,501,0,null,null,null,[64457],false],[0,0,0,"self",null,"",null,false],[466,505,0,null,null,null,[64459],false],[0,0,0,"self",null,"",null,false],[466,509,0,null,null,null,[64461],false],[0,0,0,"self",null,"",null,false],[466,513,0,null,null,null,[64463],false],[0,0,0,"self",null,"",null,false],[466,517,0,null,null,null,[64465],false],[0,0,0,"self",null,"",null,false],[466,521,0,null,null,null,[64467],false],[0,0,0,"self",null,"",null,false],[466,525,0,null,null,null,[64469],false],[0,0,0,"self",null,"",null,false],[466,529,0,null,null,null,[64471],false],[0,0,0,"self",null,"",null,false],[466,533,0,null,null,null,[64473],false],[0,0,0,"self",null,"",null,false],[466,537,0,null,null,null,[64475],false],[0,0,0,"self",null,"",null,false],[466,541,0,null,null,null,[64477],false],[0,0,0,"self",null,"",null,false],[466,547,0,null,null,null,[64479],false],[0,0,0,"self",null,"",null,false],[466,552,0,null,null,null,[64481],false],[0,0,0,"self",null,"",null,false],[466,556,0,null,null,null,[64483],false],[0,0,0,"self",null,"",null,false],[466,562,0,null,null," Formats a version with the patch component omitted if it is zero,\n unlike SemanticVersion.format which formats all its version components regardless.",[64485,64486],false],[0,0,0,"version",null,"",null,false],[0,0,0,"writer",null,"",null,false],[466,570,0,null,null,null,[64488,64489],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[466,616,0,null,null,null,[64491,64492],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[466,622,0,null,null,null,[64494,64495],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[466,626,0,null,null,null,[64497],false],[0,0,0,"self",null,"",null,false],[466,630,0,null,null,null,null,false],[466,633,0,null,null," Returned slice must be freed by the caller.",[64500,64501,64502],false],[0,0,0,"self",null,"",null,false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"linkage",null,"",null,false],[466,667,0,null,null,null,[64504],false],[0,0,0,"self",null,"",null,false],[466,671,0,null,null,null,[64506,64507,64508,64509],false],[0,0,0,"self",null,"",null,false],[0,0,0,"major",null,"",null,false],[0,0,0,"minor",null,"",null,false],[0,0,0,"patch",null,"",null,false],[466,676,0,null,null,null,[64511],false],[0,0,0,"self",null,"",null,false],[466,680,0,null,null,null,[64513,64514],false],[0,0,0,"self",null,"",null,false],[0,0,0,"set",null,"",null,false],[466,687,0,null,null,null,[64516,64517,64518],false],[0,0,0,"result",null,"",null,false],[0,0,0,"diags",null,"",null,false],[0,0,0,"text",null,"",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"cpu_arch",null," `null` means native.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"cpu_model",null,null,null,false],[466,0,0,null,null,null,null,false],[0,0,0,"cpu_features_add",null," Sparse set of CPU features to add to the set from `cpu_model`.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"cpu_features_sub",null," Sparse set of CPU features to remove from the set from `cpu_model`.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"os_tag",null," `null` means native.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"os_version_min",null," `null` means the default version range for `os_tag`. If `os_tag` is `null` (native)\n then `null` for this field means native.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"os_version_max",null," When cross compiling, `null` means default (latest known OS version).\n When `os_tag` is native, `null` means equal to the native OS version.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"glibc_version",null," `null` means default when cross compiling, or native when os_tag is native.\n If `isGnuLibC()` is `false`, this must be `null` and is ignored.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"abi",null," `null` means the native C ABI, if `os_tag` is native, otherwise it means the default C ABI.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"dynamic_linker",null," When `os_tag` is `null`, then `null` means native. Otherwise it means the standard path\n based on the `os_tag`.",null,false],[466,0,0,null,null,null,null,false],[0,0,0,"ofmt",null," `null` means default for the cpu/arch/os combo.",null,false],[447,21,0,null,null,null,null,false],[447,22,0,null,null,null,null,false],[447,23,0,null,null,null,null,false],[447,26,0,null,null,null,null,false],[0,0,0,"zig/c_builtins.zig",null,"",[],false],[467,0,0,null,null,null,null,false],[467,2,0,null,null,null,[64548],false],[0,0,0,"val",null,"",null,false],[467,5,0,null,null,null,[64550],false],[0,0,0,"val",null,"",null,false],[467,8,0,null,null,null,[64552],false],[0,0,0,"val",null,"",null,false],[467,12,0,null,null,null,[64554],false],[0,0,0,"val",null,"",null,false],[467,15,0,null,null,null,[64556],false],[0,0,0,"val",null,"",null,false],[467,19,0,null,null,null,[64558],false],[0,0,0,"val",null,"",null,false],[467,24,0,null,null,null,[64560],false],[0,0,0,"val",null,"",null,false],[467,30,0,null,null,null,[64562],false],[0,0,0,"val",null,"",null,false],[467,37,0,null,null,null,[64564],false],[0,0,0,"val",null,"",null,false],[467,40,0,null,null,null,[64566],false],[0,0,0,"val",null,"",null,false],[467,44,0,null,null,null,[64568],false],[0,0,0,"val",null,"",null,false],[467,47,0,null,null,null,[64570],false],[0,0,0,"val",null,"",null,false],[467,50,0,null,null,null,[64572],false],[0,0,0,"val",null,"",null,false],[467,53,0,null,null,null,[64574],false],[0,0,0,"val",null,"",null,false],[467,57,0,null,null,null,[64576],false],[0,0,0,"val",null,"",null,false],[467,60,0,null,null,null,[64578],false],[0,0,0,"val",null,"",null,false],[467,63,0,null,null,null,[64580],false],[0,0,0,"val",null,"",null,false],[467,66,0,null,null,null,[64582],false],[0,0,0,"val",null,"",null,false],[467,69,0,null,null,null,[64584],false],[0,0,0,"val",null,"",null,false],[467,72,0,null,null,null,[64586],false],[0,0,0,"val",null,"",null,false],[467,75,0,null,null,null,[64588],false],[0,0,0,"val",null,"",null,false],[467,78,0,null,null,null,[64590],false],[0,0,0,"val",null,"",null,false],[467,81,0,null,null,null,[64592],false],[0,0,0,"val",null,"",null,false],[467,84,0,null,null,null,[64594],false],[0,0,0,"val",null,"",null,false],[467,89,0,null,null,null,[64596],false],[0,0,0,"val",null,"",null,false],[467,92,0,null,null,null,[64598],false],[0,0,0,"val",null,"",null,false],[467,95,0,null,null,null,[64600],false],[0,0,0,"val",null,"",null,false],[467,99,0,null,null,null,[64602],false],[0,0,0,"val",null,"",null,false],[467,102,0,null,null,null,[64604],false],[0,0,0,"val",null,"",null,false],[467,105,0,null,null,null,[64606],false],[0,0,0,"val",null,"",null,false],[467,108,0,null,null,null,[64608],false],[0,0,0,"val",null,"",null,false],[467,111,0,null,null,null,[64610],false],[0,0,0,"val",null,"",null,false],[467,114,0,null,null,null,[64612],false],[0,0,0,"val",null,"",null,false],[467,117,0,null,null,null,[64614],false],[0,0,0,"val",null,"",null,false],[467,120,0,null,null,null,[64616],false],[0,0,0,"val",null,"",null,false],[467,124,0,null,null,null,[64618],false],[0,0,0,"s",null,"",null,false],[467,127,0,null,null,null,[64620,64621],false],[0,0,0,"s1",null,"",null,false],[0,0,0,"s2",null,"",null,false],[467,135,0,null,null,null,[64623,64624],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"ty",null,"",null,false],[467,146,0,null,null,null,[64626,64627,64628,64629],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"val",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"remaining",null,"",null,false],[467,156,0,null,null,null,[64631,64632,64633],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"val",null,"",null,false],[0,0,0,"len",null,"",null,false],[467,162,0,null,null,null,[64635,64636,64637,64638],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"len",null,"",null,false],[0,0,0,"remaining",null,"",null,false],[467,172,0,null,null,null,[64640,64641,64642],false],[0,0,0,"dst",null,"",null,false],[0,0,0,"src",null,"",null,false],[0,0,0,"len",null,"",null,false],[467,186,0,null,null," The return value of __builtin_expect is `expr`. `c` is the expected value\n of `expr` and is used as a hint to the compiler in C. Here it is unused.",[64644,64645],false],[0,0,0,"expr",null,"",null,false],[0,0,0,"c",null,"",null,false],[467,206,0,null,null," returns a quiet NaN. Quiet NaNs have many representations; tagp is used to select one in an\n implementation-defined way.\n This implementation is based on the description for __builtin_nan provided in the GCC docs at\n https://gcc.gnu.org/onlinedocs/gcc/Other-Builtins.html#index-_005f_005fbuiltin_005fnan\n Comment is reproduced below:\n Since ISO C99 defines this function in terms of strtod, which we do not implement, a description\n of the parsing is in order.\n The string is parsed as by strtol; that is, the base is recognized by leading ‘0’ or ‘0x’ prefixes.\n The number parsed is placed in the significand such that the least significant bit of the number is\n    at the least significant bit of the significand.\n The number is truncated to fit the significand field provided.\n The significand is forced to be a quiet NaN.\n\n If tagp contains any non-numeric characters, the function returns a NaN whose significand is zero.\n If tagp is empty, the function returns a NaN whose significand is zero.",[64647],false],[0,0,0,"tagp",null,"",null,false],[467,212,0,null,null,null,[],false],[467,216,0,null,null,null,[],false],[467,220,0,null,null,null,[64651],false],[0,0,0,"x",null,"",null,false],[467,224,0,null,null,null,[64653],false],[0,0,0,"x",null,"",null,false],[467,229,0,null,null," Similar to isinf, except the return value is -1 for an argument of -Inf and 1 for an argument of +Inf.",[64655],false],[0,0,0,"x",null,"",null,false],[467,234,0,null,null,null,[64657],false],[0,0,0,"func",null,"",null,false],[467,239,0,null,null,null,[64659],false],[0,0,0,"cond",null,"",null,false],[467,243,0,null,null,null,[],false],[467,247,0,null,null,null,[64662],false],[0,0,0,"expr",null,"",null,false],[467,251,0,null,null,null,[64664,64665,64666],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"result",null,"",null,false],[447,27,0,null,null,null,null,false],[0,0,0,"zig/c_translation.zig",null,"",[],false],[468,0,0,null,null,null,null,false],[468,1,0,null,null,null,null,false],[468,2,0,null,null,null,null,false],[468,3,0,null,null,null,null,false],[468,4,0,null,null,null,null,false],[468,7,0,null,null," Given a type and value, cast the value to the type as c would.",[64675,64676],false],[0,0,0,"DestType",null,"",null,true],[0,0,0,"target",null,"",null,false],[468,62,0,null,null,null,[64678,64679],false],[0,0,0,"DestType",null,"",null,true],[0,0,0,"target",null,"",null,false],[468,72,0,null,null,null,[64681,64682],false],[0,0,0,"DestType",null,"",null,true],[0,0,0,"target",null,"",null,false],[468,76,0,null,null,null,[64684,64685,64686],false],[0,0,0,"DestType",null,"",null,true],[0,0,0,"SourceType",null,"",null,true],[0,0,0,"target",null,"",null,false],[468,100,0,null,null,null,[64688],false],[0,0,0,"PtrType",null,"",null,true],[468,142,0,null,null," Given a value returns its size as C's sizeof operator would.",[64690],false],[0,0,0,"target",null,"",null,false],[468,253,0,null,null,null,[64692,64693,64694],false],[0,0,0,"decimal",null,null,null,false],[0,0,0,"octal",null,null,null,false],[0,0,0,"hexadecimal",null,null,null,false],[468,256,0,null,null," Deprecated: use `CIntLiteralBase`",null,false],[468,258,0,null,null,null,[64697,64698,64699],false],[0,0,0,"SuffixType",null,"",null,true],[0,0,0,"number",null,"",null,true],[0,0,0,"base",null,"",null,true],[468,281,0,null,null," Promote the type of an integer literal until it fits as C would.",[64701,64702,64703],false],[0,0,0,"SuffixType",null,"",null,true],[0,0,0,"number",null,"",null,true],[0,0,0,"base",null,"",null,true],[468,313,0,null,null," Convert from clang __builtin_shufflevector index to Zig @shuffle index\n clang requires __builtin_shufflevector index arguments to be integer constants.\n negative values for `this_index` indicate \"don't care\" so we arbitrarily choose 0\n clang enforces that `this_index` is less than the total number of vector elements\n See https://ziglang.org/documentation/master/#shuffle\n See https://clang.llvm.org/docs/LanguageExtensions.html#langext-builtin-shufflevector",[64705,64706],false],[0,0,0,"this_index",null,"",null,true],[0,0,0,"source_vector_len",null,"",null,true],[468,340,0,null,null," Constructs a [*c] pointer with the const and volatile annotations\n from SelfType for pointing to a C flexible array of ElementType.",[64708,64709],false],[0,0,0,"SelfType",null,"",null,true],[0,0,0,"ElementType",null,"",null,true],[468,374,0,null,null," C `%` operator for signed integers\n C standard states: \"If the quotient a/b is representable, the expression (a/b)*b + a%b shall equal a\"\n The quotient is not representable if denominator is zero, or if numerator is the minimum integer for\n the type and denominator is -1. C has undefined behavior for those two cases; this function has safety\n checked undefined behavior",[64711,64712],false],[0,0,0,"numerator",null,"",null,false],[0,0,0,"denominator",null,"",null,false],[468,380,0,null,null,null,[],false],[468,381,0,null,null,null,[64715],false],[0,0,0,"n",null,"",null,true],[468,385,0,null,null,null,[64717],false],[0,0,0,"number",null,"",null,true],[468,392,0,null,null,null,[64719],false],[0,0,0,"number",null,"",null,true],[468,400,0,null,null,null,[64721],false],[0,0,0,"n",null,"",null,true],[468,404,0,null,null,null,[64723],false],[0,0,0,"n",null,"",null,true],[468,408,0,null,null,null,[64725],false],[0,0,0,"n",null,"",null,true],[468,412,0,null,null,null,[64727],false],[0,0,0,"f",null,"",null,true],[468,416,0,null,null,null,[64729,64730,64731],false],[0,0,0,"ptr",null,"",null,false],[0,0,0,"sample",null,"",null,false],[0,0,0,"member",null,"",null,true],[468,422,0,null,null," A 2-argument function-like macro defined as #define FOO(A, B) (A)(B)\n could be either: cast B to A, or call A with the value B.",[64733,64734],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[468,434,0,null,null,null,[64736],false],[0,0,0,"x",null,"",null,false],[468,440,0,null,null," Integer promotion described in C11 6.3.1.1.2",[64738],false],[0,0,0,"T",null,"",null,true],[468,456,0,null,null," C11 6.3.1.1.1",[64740],false],[0,0,0,"T",null,"",null,true],[468,468,0,null,null,null,[64742],false],[0,0,0,"T",null,"",null,true],[468,478,0,null,null," \"Usual arithmetic conversions\" from C11 standard 6.3.1.8",[64744,64745],false],[0,0,0,"A",null,"",null,true],[0,0,0,"B",null,"",null,true],[468,541,0,null,null,null,[],false],[468,542,0,null,null,null,[64748,64749],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[468,553,0,null,null,null,[64751,64752],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[447,29,0,null,null,null,null,false],[447,31,0,null,null,null,[64755],false],[0,0,0,"src",null,"",null,false],[447,37,0,null,null,null,[64757,64758],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[447,41,0,null,null,null,[64760,64761,64762],false],[0,0,0,"parent_hash",null,"",null,false],[0,0,0,"sep",null,"",null,false],[0,0,0,"name",null,"",null,false],[447,51,0,null,null,null,[64767,64768,64770],false],[447,57,0,null,null,null,[64765,64766],false],[0,0,0,"a",null,"",null,false],[0,0,0,"b",null,"",null,false],[0,0,0,"line",null,null,null,false],[0,0,0,"column",null,null,null,false],[447,51,0,null,null,null,null,false],[0,0,0,"source_line",null," Does not include the trailing newline.",null,false],[447,62,0,null,null,null,[64772,64773],false],[0,0,0,"source",null,"",null,false],[0,0,0,"byte_offset",null,"",null,false],[447,89,0,null,null,null,[64775,64776,64777],false],[0,0,0,"source",null,"",null,false],[0,0,0,"start",null,"",null,false],[0,0,0,"end",null,"",null,false],[447,105,0,null,null,null,[64780,64782,64784,64786,64788],false],[447,105,0,null,null,null,null,false],[0,0,0,"root_name",null,null,null,false],[447,105,0,null,null,null,null,false],[0,0,0,"target",null,null,null,false],[447,105,0,null,null,null,null,false],[0,0,0,"output_mode",null,null,null,false],[447,105,0,null,null,null,null,false],[0,0,0,"link_mode",null,null,null,false],[447,105,0,null,null,null,null,false],[0,0,0,"version",null,null,null,false],[447,114,0,null,null," Returns the standard file system basename of a binary generated by the Zig compiler.",[64790,64791],false],[0,0,0,"allocator",null,"",null,false],[0,0,0,"options",null,"",null,false],[1,196,0,null,null,null,null,false],[0,0,0,"start.zig",null,"",[],false],[469,2,0,null,null,null,null,false],[469,3,0,null,null,null,null,false],[469,4,0,null,null,null,null,false],[469,5,0,null,null,null,null,false],[469,6,0,null,null,null,null,false],[469,7,0,null,null,null,null,false],[469,8,0,null,null,null,null,false],[469,9,0,null,null,null,null,false],[469,11,0,null,null,null,null,false],[469,13,0,null,null,null,null,false],[469,18,0,null,null,null,null,false],[469,98,0,null,null,null,[],false],[469,103,0,null,null,null,[],false],[469,107,0,null,null,null,[],false],[469,113,0,null,null,null,[],false],[469,117,0,null,null,null,[],false],[469,122,0,null,null,null,[64811],false],[0,0,0,"code",null,"",null,false],[469,177,0,null,null,null,[64813],false],[0,0,0,"exit_code",null,"",null,false],[469,181,0,null,null,null,[64815,64816,64817],false],[0,0,0,"hinstDLL",null,"",null,false],[0,0,0,"fdwReason",null,"",null,false],[0,0,0,"lpReserved",null,"",null,false],[469,197,0,null,null,null,[],false],[469,203,0,null,null,null,[],false],[469,212,0,null,null,null,[64821,64822],false],[0,0,0,"handle",null,"",null,false],[0,0,0,"system_table",null,"",null,false],[469,234,0,null,null,null,[],false],[469,330,0,null,null,null,[],false],[469,341,0,null,null,null,[],false],[469,353,0,null,null,null,[],false],[469,416,0,null,null,null,[64828],false],[0,0,0,"phdrs",null,"",null,false],[469,450,0,null,null,null,[64830,64831,64832],false],[0,0,0,"argc",null,"",null,false],[0,0,0,"argv",null,"",null,false],[0,0,0,"envp",null,"",null,false],[469,460,0,null,null,null,[64834,64835,64836],false],[0,0,0,"c_argc",null,"",null,false],[0,0,0,"c_argv",null,"",null,false],[0,0,0,"c_envp",null,"",null,false],[469,475,0,null,null,null,[64838,64839],false],[0,0,0,"c_argc",null,"",null,false],[0,0,0,"c_argv",null,"",null,false],[469,481,0,null,null,null,null,false],[469,485,0,null,null,null,[],false],[469,514,0,null,null,null,[],false],[469,539,0,null,null,null,[64844],false],[0,0,0,"loop",null,"",null,false],[469,547,0,null,null,null,[64846],false],[0,0,0,"loop",null,"",null,false],[469,557,0,null,null,null,[],false],[469,595,0,null,null,null,[],false],[1,199,0,null,null," deprecated: use `Build`.",null,false],[1,201,0,null,null,null,null,false],[1,202,0,null,null,null,null,false],[1,205,0,null,null," Stdlib-wide options that can be overridden by the root file.",[],false],[1,206,0,null,null,null,null,false],[1,212,0,null,null," Function used to implement `std.fs.cwd` for WASI.",null,false],[1,218,0,null,null," The application's chosen I/O mode.",null,false],[1,225,0,null,null,null,null,false],[1,230,0,null,null,null,null,false],[1,236,0,null,null," The current log level.",null,false],[1,241,0,null,null,null,null,false],[1,246,0,null,null,null,null,false],[1,256,0,null,null,null,null,false],[1,261,0,null,null,null,null,false],[1,266,0,null,null,null,null,false],[1,282,0,null,null," By default Zig disables SIGPIPE by setting a \"no-op\" handler for it.  Set this option\n to `true` to prevent that.\n\n Note that we use a \"no-op\" handler instead of SIG_IGN because it will not be inherited by\n any child process.\n\n SIGPIPE is triggered when a process attempts to write to a broken pipe. By default, SIGPIPE\n will terminate the process instead of exiting.  It doesn't trigger the panic handler so in many\n cases it's unclear why the process was terminated.  By capturing SIGPIPE instead, functions that\n write to broken pipes will return the EPIPE error (error.BrokenPipe) and the program can handle\n it like any other error.",null,false],[1,287,0,null,null,null,null,false],[1,292,0,null,null,null,null,false],[0,1,0,null,null,null,null,false],[0,6,0,null,null,null,[64869],false],[0,0,0,"a",null,"",null,false],[0,14,0,null,null,null,[],false],[0,28,0,null,null,null,null,false],[0,34,0,null,null,null,null,false],[0,35,0,null,null,null,null,false],[0,36,0,null,null,null,null,false],[0,37,0,null,null,null,null,false],[0,38,0,null,null,null,null,false],[0,39,0,null,null,null,null,false],[0,40,0,null,null,null,null,false],[0,41,0,null,null,null,null,false],[0,42,0,null,null,null,null,false],[0,44,0,null,null,null,[64882,64883],false],[0,0,0,"self",null,"",null,false],[0,0,0,"args",null,"",null,false],[0,51,0,null,null,null,null,false],[0,66,0,null,null,null,null,false],[0,86,0,null,null,null,[],false]];